<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">adaptive.h</div>  </div>
</div>
<div class="contents">
<a href="adaptive_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adaptive.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __adaptive_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __adaptive_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="linear_8h.php">linear.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="kelly__error__estimator_8h.php">kelly_error_estimator.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__refinement_8h.php">mesh_refinement.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh_8h.php">mesh.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// Adaptive class definition</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T = Linear&lt;&gt; &gt;
<a name="l00050"></a><a class="code" href="classlibMesh_1_1Adaptive.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Adaptive.php">Adaptive</a> : <span class="keyword">public</span> T
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053   
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1Adaptive.php#af11d2f585dc654506465605329084dd6">Adaptive</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1Adaptive.php#af11d2f585dc654506465605329084dd6">Adaptive</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00063"></a>00063             <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00064"></a>00064             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1Adaptive.php#a834a3f90015a1dddeaf2c79c893adce7">~Adaptive</a> ();
<a name="l00070"></a>00070 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Adaptive.php#a248d2e83f2b9cf5c16c5f6fb5480cd6f">solve</a> ();
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1Adaptive.php#a179fa75e66b5974c1328b4d55a6d2be6">00080</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Adaptive.php#a179fa75e66b5974c1328b4d55a6d2be6">refinement_step</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Adaptive.php#acbc61e65c49a8ca94d095c183d5f1995">_refinement_step</a>; }
<a name="l00081"></a>00081 
<a name="l00085"></a><a class="code" href="classlibMesh_1_1Adaptive.php#a74da296eb4de995546c3ada39a1bb49b">00085</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Adaptive.php#a74da296eb4de995546c3ada39a1bb49b">n_refinement_steps</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Adaptive.php#acc7973ece486f3bffbbf895b10cc9c63">_n_refinement_steps</a>; }
<a name="l00086"></a>00086 
<a name="l00090"></a><a class="code" href="classlibMesh_1_1Adaptive.php#a106252aa58c2599bed3bc295f720785a">00090</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1Adaptive.php#a106252aa58c2599bed3bc295f720785a">n_refinement_steps</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Adaptive.php#acc7973ece486f3bffbbf895b10cc9c63">_n_refinement_steps</a>; }  
<a name="l00091"></a>00091 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1Adaptive.php#a0af6868156447928b09749fea5992338">00095</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Adaptive.php#a0af6868156447928b09749fea5992338">max_refinement_level</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Adaptive.php#a8cdf5e66b19355ad157c0e3956e29176">_max_refinement_level</a>; }
<a name="l00096"></a>00096 
<a name="l00100"></a><a class="code" href="classlibMesh_1_1Adaptive.php#a33f9826f5400cb5c05314046fd22882f">00100</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1Adaptive.php#a33f9826f5400cb5c05314046fd22882f">max_refinement_level</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Adaptive.php#a8cdf5e66b19355ad157c0e3956e29176">_max_refinement_level</a>; }
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   
<a name="l00103"></a>00103 <span class="keyword">protected</span>:
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   
<a name="l00109"></a><a class="code" href="classlibMesh_1_1Adaptive.php#aaa34c1c6e92ac8d9cc0a077d4b8c99f5">00109</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1Adaptive.php#aaa34c1c6e92ac8d9cc0a077d4b8c99f5">refinement_step</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Adaptive.php#acbc61e65c49a8ca94d095c183d5f1995">_refinement_step</a>; }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   
<a name="l00112"></a>00112 <span class="keyword">private</span>:
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1Adaptive.php#acbc61e65c49a8ca94d095c183d5f1995">00118</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Adaptive.php#acbc61e65c49a8ca94d095c183d5f1995">_refinement_step</a>;
<a name="l00119"></a>00119   
<a name="l00123"></a><a class="code" href="classlibMesh_1_1Adaptive.php#acc7973ece486f3bffbbf895b10cc9c63">00123</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Adaptive.php#acc7973ece486f3bffbbf895b10cc9c63">_n_refinement_steps</a>;
<a name="l00124"></a>00124 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1Adaptive.php#a8cdf5e66b19355ad157c0e3956e29176">00128</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Adaptive.php#a8cdf5e66b19355ad157c0e3956e29176">_max_refinement_level</a>;
<a name="l00129"></a>00129 };
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00134"></a>00134 <span class="comment">// Adaptive inline members</span>
<a name="l00135"></a>00135 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00136"></a><a class="code" href="classlibMesh_1_1Adaptive.php#af11d2f585dc654506465605329084dd6">00136</a> <a class="code" href="classlibMesh_1_1Adaptive.php#af11d2f585dc654506465605329084dd6">Adaptive&lt;T&gt;::Adaptive</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es) :
<a name="l00137"></a>00137   T                    (es), <span class="comment">// Call the base class constructor</span>
<a name="l00138"></a>00138   _refinement_step     (0),  <span class="comment">// Solver parameters</span>
<a name="l00139"></a>00139   _n_refinement_steps  (1),
<a name="l00140"></a>00140   _max_refinement_level(100)
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142 libmesh_deprecated();
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00148"></a><a class="code" href="classlibMesh_1_1Adaptive.php#af0d5a19640800756ebbcabb4a36f4754">00148</a> <a class="code" href="classlibMesh_1_1Adaptive.php#af11d2f585dc654506465605329084dd6">Adaptive&lt;T&gt;::Adaptive</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00149"></a>00149                        <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00150"></a>00150                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00151"></a>00151   <a class="code" href="classlibMesh_1_1Adaptive.php">Adaptive</a> (es),
<a name="l00152"></a>00152   T        (es, name, number)
<a name="l00153"></a>00153 {
<a name="l00154"></a>00154 libmesh_deprecated();
<a name="l00155"></a>00155 }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00160"></a><a class="code" href="classlibMesh_1_1Adaptive.php#a834a3f90015a1dddeaf2c79c893adce7">00160</a> <a class="code" href="classlibMesh_1_1Adaptive.php#a834a3f90015a1dddeaf2c79c893adce7">Adaptive&lt;T&gt;::~Adaptive</a> ()
<a name="l00161"></a>00161 {
<a name="l00162"></a>00162 }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00167"></a><a class="code" href="classlibMesh_1_1Adaptive.php#a248d2e83f2b9cf5c16c5f6fb5480cd6f">00167</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Adaptive.php#a248d2e83f2b9cf5c16c5f6fb5480cd6f">Adaptive&lt;T&gt;::solve</a> ()
<a name="l00168"></a>00168 {
<a name="l00169"></a>00169   <span class="comment">// First solve the base system</span>
<a name="l00170"></a>00170   T::solve ();
<a name="l00171"></a>00171       
<a name="l00172"></a>00172   <span class="keywordflow">for</span> (this-&gt;refinement_step()=0;
<a name="l00173"></a>00173        this-&gt;refinement_step() &lt; this-&gt;n_refinement_steps();
<a name="l00174"></a>00174        this-&gt;refinement_step()++)
<a name="l00175"></a>00175     {  
<a name="l00176"></a>00176       <span class="comment">// Then estimate the error in the base system</span>
<a name="l00177"></a>00177       <span class="comment">// and refine the mesh</span>
<a name="l00178"></a>00178       {
<a name="l00179"></a>00179         <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> error;
<a name="l00180"></a>00180         
<a name="l00181"></a>00181         <a class="code" href="classlibMesh_1_1KellyErrorEstimator.php">KellyErrorEstimator</a> error_estimator;
<a name="l00182"></a>00182         
<a name="l00183"></a>00183         error_estimator.<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#abafa2609660d4de159fb16d0a8d3c509">estimate_error</a> (this-&gt;system(), <span class="stringliteral">&quot;incomp_ns&quot;</span>, error);
<a name="l00184"></a>00184         
<a name="l00185"></a>00185         <a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a> mesh_refinement (this-&gt;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>());
<a name="l00186"></a>00186         
<a name="l00187"></a>00187         mesh_refinement.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6ef885bd531649c9d0738f2e9c65b53b">flag_elements_by_error_fraction</a> (error,
<a name="l00188"></a>00188                                                          0.40,
<a name="l00189"></a>00189                                                          0.40,
<a name="l00190"></a>00190                                                          this-&gt;max_refinement_level());
<a name="l00191"></a>00191         
<a name="l00192"></a>00192         mesh_refinement.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a0fbfad1ea615122c73e2202c7dc1cc9e">refine_and_coarsen_elements</a> ();
<a name="l00193"></a>00193 
<a name="l00194"></a>00194         this-&gt;system().reinit ();
<a name="l00195"></a>00195       }
<a name="l00196"></a>00196   
<a name="l00197"></a>00197       <span class="comment">// Then re-solve the base system</span>
<a name="l00198"></a>00198       T::solve ();
<a name="l00199"></a>00199     }
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 } <span class="comment">// namespace libMesh</span>
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="preprocessor">#endif // #define __adaptive_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
