<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">adaptive_time_solver.C</div>  </div>
</div>
<div class="contents">
<a href="adaptive__time__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adaptive_time_solver.C 4015 2010-10-01 21:03:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="adaptive__time__solver_8h.php">adaptive_time_solver.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">namespace </span>libMesh
<a name="l00025"></a>00025 {
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ac9d39e0aca9faaa22f2afc948645b93a">00029</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ac9d39e0aca9faaa22f2afc948645b93a">AdaptiveTimeSolver::AdaptiveTimeSolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00030"></a>00030  : <a class="code" href="classlibMesh_1_1UnsteadySolver.php">UnsteadySolver</a>(s),
<a name="l00031"></a>00031    core_time_solver(NULL),
<a name="l00032"></a>00032    target_tolerance(1.e-3), upper_tolerance(0.0),
<a name="l00033"></a>00033    max_deltat(0.),
<a name="l00034"></a>00034    min_deltat(0.),
<a name="l00035"></a>00035    max_growth(0.),
<a name="l00036"></a>00036    global_tolerance(true)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   <span class="comment">// the child class must populate core_time_solver</span>
<a name="l00039"></a>00039   <span class="comment">// with whatever actual time solver is to be used</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="comment">// As an UnsteadySolver, we have an old_local_nonlinear_solution, but we&#39;re</span>
<a name="l00042"></a>00042   <span class="comment">// going to drop it and use our core time solver&#39;s instead.</span>
<a name="l00043"></a>00043   <a class="code" href="classlibMesh_1_1UnsteadySolver.php#afd7b9f33d66c64b664e054f32e7d3471">old_local_nonlinear_solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>();
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a8c1c823f34455546af9f6cecaec91245">00048</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a8c1c823f34455546af9f6cecaec91245">AdaptiveTimeSolver::~AdaptiveTimeSolver</a> ()
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="comment">// As an UnsteadySolver, we have an old_local_nonlinear_solution, but it</span>
<a name="l00051"></a>00051   <span class="comment">// is being managed by our core_time_solver.  Make sure we don&#39;t delete</span>
<a name="l00052"></a>00052   <span class="comment">// it out from under them, in case the user wants to keep using the core</span>
<a name="l00053"></a>00053   <span class="comment">// solver after they&#39;re done with us.</span>
<a name="l00054"></a>00054   <a class="code" href="classlibMesh_1_1UnsteadySolver.php#afd7b9f33d66c64b664e054f32e7d3471">old_local_nonlinear_solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a89bff9a08bc4353ea1ca0dc0e4d2e758">00059</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a89bff9a08bc4353ea1ca0dc0e4d2e758">AdaptiveTimeSolver::init</a>()
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   libmesh_assert(<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// We override this because our core_time_solver is the one that</span>
<a name="l00064"></a>00064   <span class="comment">// needs to handle new vectors, diff_solver-&gt;init(), etc</span>
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;init();
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="comment">// As an UnsteadySolver, we have an old_local_nonlinear_solution, but it</span>
<a name="l00068"></a>00068   <span class="comment">// isn&#39;t pointing to the right place - fix it</span>
<a name="l00069"></a>00069   <span class="comment">//</span>
<a name="l00070"></a>00070   <span class="comment">// This leaves us with two AutoPtrs holding the same pointer - dangerous</span>
<a name="l00071"></a>00071   <span class="comment">// for future use.  Replace with shared_ptr?</span>
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1UnsteadySolver.php#afd7b9f33d66c64b664e054f32e7d3471">old_local_nonlinear_solution</a> = 
<a name="l00073"></a>00073     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;(<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;old_local_nonlinear_solution.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00074"></a>00074 }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ae9023449f04ae49518498875b1d3f55f">00078</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ae9023449f04ae49518498875b1d3f55f">AdaptiveTimeSolver::reinit</a>()
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080   libmesh_assert(<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// We override this because our core_time_solver is the one that</span>
<a name="l00083"></a>00083   <span class="comment">// needs to handle new vectors, diff_solver-&gt;reinit(), etc</span>
<a name="l00084"></a>00084   <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;reinit();
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#af4889d2b0319244d6830af445ad8c986">00088</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#af4889d2b0319244d6830af445ad8c986">AdaptiveTimeSolver::advance_timestep</a> ()
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;<a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a> =
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;_old_nonlinear_solution&quot;</span>);
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;nonlinear_solution =
<a name="l00093"></a>00093     *(<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00094"></a>00094 <span class="comment">//    _system.get_vector(&quot;_nonlinear_solution&quot;);</span>
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   old_nonlinear_solution = nonlinear_solution;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad5be0a1a2852028cc39b995b0d07bef6">first_solve</a>)
<a name="l00099"></a>00099     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a90b0537fa503134bfa91865a6995742e">time</a> += <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aafc55e61a042582de96032b721d46b55">last_deltat</a>;
<a name="l00100"></a>00100 }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ac70faae9fcda34d6d3bfaa303b9e0bb1">00104</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ac70faae9fcda34d6d3bfaa303b9e0bb1">AdaptiveTimeSolver::error_order</a> ()<span class="keyword"> const</span>
<a name="l00105"></a>00105 <span class="keyword"></span>{
<a name="l00106"></a>00106   libmesh_assert(<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;error_order();
<a name="l00109"></a>00109 }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a3eb85d97e93bc297ca7d360fe28e297b">00113</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a3eb85d97e93bc297ca7d360fe28e297b">AdaptiveTimeSolver::element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00114"></a>00114                                            <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;context)
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116   libmesh_assert(<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;element_residual(request_jacobian, context);
<a name="l00119"></a>00119 }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a2de458a49d588de0e37163acac575fa7">00123</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a2de458a49d588de0e37163acac575fa7">AdaptiveTimeSolver::side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00124"></a>00124                                         <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;context)
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126   libmesh_assert(<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;side_residual(request_jacobian, context);
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aebd8e278bbd7aabe7708f209349f2166">00133</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> &amp; <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aebd8e278bbd7aabe7708f209349f2166">AdaptiveTimeSolver::diff_solver</a>()
<a name="l00134"></a>00134 {
<a name="l00135"></a>00135   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>-&gt;diff_solver();
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a24cf02c068643d8cd3e4c25d96895a8a">00140</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a24cf02c068643d8cd3e4c25d96895a8a">AdaptiveTimeSolver::calculate_norm</a>(<a class="code" href="classlibMesh_1_1System.php">System</a> &amp;s,
<a name="l00141"></a>00141                                         <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;v)
<a name="l00142"></a>00142 {
<a name="l00143"></a>00143   <span class="keywordflow">return</span> s.<a class="code" href="classlibMesh_1_1System.php#a3153155431e918a782fabedcaf58e4e6">calculate_norm</a>(v, <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a59a933b429ce060d4c14002db6245136">component_norm</a>);
<a name="l00144"></a>00144 }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
