<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">adaptive_time_solver.h</div>  </div>
</div>
<div class="contents">
<a href="adaptive__time__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adaptive_time_solver.h 3933 2010-08-24 23:16:20Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __adaptive_time_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __adaptive_time_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="system__norm_8h.php">system_norm.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="unsteady__solver_8h.php">unsteady_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>System;
<a name="l00036"></a>00036 
<a name="l00051"></a>00051 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00052"></a>00052 <span class="comment">// Solver class definition</span>
<a name="l00053"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php">00053</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php">AdaptiveTimeSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php">UnsteadySolver</a>
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00059"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a1796233ea700c408f9027a3d1276fc31">00059</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php">UnsteadySolver</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a1796233ea700c408f9027a3d1276fc31">Parent</a>;
<a name="l00060"></a>00060   
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ac9d39e0aca9faaa22f2afc948645b93a">AdaptiveTimeSolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00066"></a>00066   
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a8c1c823f34455546af9f6cecaec91245">~AdaptiveTimeSolver</a> ();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a89bff9a08bc4353ea1ca0dc0e4d2e758">init</a>();
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ae9023449f04ae49518498875b1d3f55f">reinit</a>();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a1d1466ff5ebbd0e646578753303481e4">solve</a>() = 0;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#af4889d2b0319244d6830af445ad8c986">advance_timestep</a>();
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ac70faae9fcda34d6d3bfaa303b9e0bb1">error_order</a> () <span class="keyword">const</span>;
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a3eb85d97e93bc297ca7d360fe28e297b">element_residual</a> (<span class="keywordtype">bool</span> get_jacobian,
<a name="l00089"></a>00089                                  <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;);
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a2de458a49d588de0e37163acac575fa7">side_residual</a> (<span class="keywordtype">bool</span> get_jacobian,
<a name="l00095"></a>00095                               <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;);
<a name="l00096"></a>00096 
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> &amp;<a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aebd8e278bbd7aabe7708f209349f2166">diff_solver</a>();
<a name="l00101"></a>00101 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">00105</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;UnsteadySolver&gt;</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca2e2273ff2ac4a6d0e448c49a165ac3">core_time_solver</a>;
<a name="l00106"></a>00106 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a59a933b429ce060d4c14002db6245136">00110</a>   <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a59a933b429ce060d4c14002db6245136">component_norm</a>;
<a name="l00111"></a>00111 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ad3e331379cc4db63ccc8f2cc59551dde">00118</a>   std::vector&lt;float&gt; <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ad3e331379cc4db63ccc8f2cc59551dde">component_scale</a>;
<a name="l00119"></a>00119 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca9e4ce98150b7452299c990c6d13741">00129</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aca9e4ce98150b7452299c990c6d13741">target_tolerance</a>;
<a name="l00130"></a>00130 
<a name="l00138"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a4d15b5d216cbb6657055125da543c388">00138</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a4d15b5d216cbb6657055125da543c388">upper_tolerance</a>;
<a name="l00139"></a>00139 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a93b378583a8e5d6da9d1408a49b8a0a9">00144</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a93b378583a8e5d6da9d1408a49b8a0a9">max_deltat</a>;
<a name="l00145"></a>00145 
<a name="l00150"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a3ef4f9c102adce5c8ef9cacab1b8cd7c">00150</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a3ef4f9c102adce5c8ef9cacab1b8cd7c">min_deltat</a>;
<a name="l00151"></a>00151   
<a name="l00158"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ada68f2f70960a70215aa8978105d9df2">00158</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#ada68f2f70960a70215aa8978105d9df2">max_growth</a>;
<a name="l00159"></a>00159 
<a name="l00174"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#accf5c408d7a99cb7d27a819404b85ea3">00174</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#accf5c408d7a99cb7d27a819404b85ea3">global_tolerance</a>;
<a name="l00175"></a>00175   
<a name="l00176"></a>00176 <span class="keyword">protected</span>:
<a name="l00177"></a>00177 
<a name="l00183"></a><a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aafc55e61a042582de96032b721d46b55">00183</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#aafc55e61a042582de96032b721d46b55">last_deltat</a>;
<a name="l00184"></a>00184 
<a name="l00188"></a>00188   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1AdaptiveTimeSolver.php#a24cf02c068643d8cd3e4c25d96895a8a">calculate_norm</a>(<a class="code" href="classlibMesh_1_1System.php">System</a> &amp;, <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;);
<a name="l00189"></a>00189 };
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 } <span class="comment">// namespace libMesh</span>
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="preprocessor">#endif // #define __adaptive_time_solver_</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
