<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">adjoint_refinement_estimator.C</div>  </div>
</div>
<div class="contents">
<a href="adjoint__refinement__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adjoint_refinement_estimator.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#if 0</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span>
<a name="l00022"></a>00022 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="keyword">namespace </span>libMesh
<a name="l00025"></a>00025 {
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;cmath&gt;</span>    <span class="comment">// for sqrt</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local Includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="mesh__refinement_8h.php">mesh_refinement.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#include &quot;<a class="code" href="adjoint__refinement__estimator_8h.php">adjoint_refinement_estimator.h</a>&quot;</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// ErrorEstimator implementations</span>
<a name="l00049"></a><a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a88133f5a181d748fd67d537e37fb944c">00049</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a88133f5a181d748fd67d537e37fb944c">AdjointRefinementEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; _system,
<a name="l00050"></a>00050                                                  <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00051"></a>00051                                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00052"></a>00052                                                  <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   <span class="comment">// Make sure the user doesn&#39;t misunderstand what we&#39;re returning:</span>
<a name="l00055"></a>00055   libmesh_assert(<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a165995a1ed79f4b8c98e8824a54a2e27">INVALID_NORM</a>);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">// We have to break the rules here, because we can&#39;t refine a const System</span>
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1System.php">System</a> *system = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1System.php">System</a> *<span class="keyword">&gt;</span>(_system);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="comment">// An EquationSystems reference will be convenient.</span>
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = system-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>());
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// The current mesh</span>
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>();
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">// The dimensionality of the mesh</span>
<a name="l00067"></a>00067   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00068"></a>00068   
<a name="l00069"></a>00069   <span class="comment">// Resize the error_per_cell vector to be</span>
<a name="l00070"></a>00070   <span class="comment">// the number of elements, initialized to 0.</span>
<a name="l00071"></a>00071   error_per_cell.clear();
<a name="l00072"></a>00072   error_per_cell-&gt;resize (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>(), 0.);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="comment">// We&#39;ll want to back up all coarse grid vectors</span>
<a name="l00075"></a>00075   std::map&lt;std::string, NumericVector&lt;Number&gt; *&gt;
<a name="l00076"></a>00076     coarse_vectors();
<a name="l00077"></a>00077   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">System::vectors_iterator</a> vec = system.<a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a>(); vec !=
<a name="l00078"></a>00078        system.<a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a>(); ++vec)
<a name="l00079"></a>00079     {
<a name="l00080"></a>00080       <span class="comment">// The (string) name of this vector</span>
<a name="l00081"></a>00081       <span class="keyword">const</span> std::string&amp; var_name = vec-&gt;first;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083       coarse_vectors[var_name] = vec-&gt;second-&gt;clone().release();
<a name="l00084"></a>00084     }
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * coarse_solution =
<a name="l00086"></a>00086     system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;clone().<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00087"></a>00087   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * coarse_local_solution =
<a name="l00088"></a>00088     system.<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>-&gt;clone().<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00089"></a>00089   <span class="comment">// And make copies of projected solutions</span>
<a name="l00090"></a>00090   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * projected_solution;
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">// And we&#39;ll need to temporarily change solution projection settings</span>
<a name="l00093"></a>00093   <span class="keywordtype">bool</span> old_projection_setting;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// And it&#39;ll be best to avoid any repartitioning</span>
<a name="l00096"></a>00096   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> old_partitioner = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa07a00e86d68f366d8fe7e4d01140ffc">partitioner</a>();
<a name="l00097"></a>00097   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa07a00e86d68f366d8fe7e4d01140ffc">partitioner</a>().<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(NULL);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// Use a non-standard solution vector if necessary</span>
<a name="l00100"></a>00100   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00103"></a>00103         <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span> (solution_vector);
<a name="l00104"></a>00104       newsol-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">swap</a>(*system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00105"></a>00105       system.<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00106"></a>00106     }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">// Make sure the solution is projected when we refine the mesh</span>
<a name="l00109"></a>00109   old_projection_setting = system.<a class="code" href="classlibMesh_1_1System.php#a04a93003e559fb4b266738e81fa52585">project_solution_on_reinit</a>();
<a name="l00110"></a>00110   system.<a class="code" href="classlibMesh_1_1System.php#a04a93003e559fb4b266738e81fa52585">project_solution_on_reinit</a>() = <span class="keyword">true</span>;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="comment">// Find the number of coarse mesh elements, to make it possible</span>
<a name="l00113"></a>00113   <span class="comment">// to find correct coarse elem ids later</span>
<a name="l00114"></a>00114   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_coarse_elem_id = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>();
<a name="l00115"></a>00115 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>  <span class="comment">// n_coarse_elem is only used in an assertion later so</span>
<a name="l00117"></a>00117   <span class="comment">// avoid declaring it unless asserts are active.</span>
<a name="l00118"></a>00118   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_coarse_elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>  
<a name="l00121"></a>00121   <span class="comment">// Uniformly refine the mesh</span>
<a name="l00122"></a>00122   <a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a> mesh_refinement(mesh);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   libmesh_assert (<a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a4437c7888b7459952e06a9157bf61ffe">number_h_refinements</a> &gt; 0 || <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#abff7ac97985f693cd3cc7a8311a24558">number_p_refinements</a> &gt; 0);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// FIXME: this may break if there is more than one System</span>
<a name="l00127"></a>00127   <span class="comment">// on this mesh but estimate_error was still called instead of</span>
<a name="l00128"></a>00128   <span class="comment">// estimate_errors</span>
<a name="l00129"></a>00129   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a4437c7888b7459952e06a9157bf61ffe">number_h_refinements</a>; ++i)
<a name="l00130"></a>00130     {
<a name="l00131"></a>00131       mesh_refinement.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a406e53c22bd8c9e2cefa862ef02f226f">uniformly_refine</a>(1);
<a name="l00132"></a>00132       es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a1634fa5937c4d915d83c35d591ed7c05">reinit</a>();
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134       
<a name="l00135"></a>00135   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#abff7ac97985f693cd3cc7a8311a24558">number_p_refinements</a>; ++i)
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137       mesh_refinement.<a class="code" href="classlibMesh_1_1MeshRefinement.php#ac8b117eccc68c96f20c0c0b4045303e8">uniformly_p_refine</a>(1);
<a name="l00138"></a>00138       es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a1634fa5937c4d915d83c35d591ed7c05">reinit</a>();
<a name="l00139"></a>00139     }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00142"></a>00142     {
<a name="l00143"></a>00143       <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system = *system_list[i];
<a name="l00144"></a>00144       
<a name="l00145"></a>00145       <span class="comment">// Copy the projected coarse grid solutions, which will be</span>
<a name="l00146"></a>00146       <span class="comment">// overwritten by solve()</span>
<a name="l00147"></a>00147 <span class="comment">//      projected_solutions[i] = system.solution-&gt;clone().release();</span>
<a name="l00148"></a>00148       projected_solutions[i] = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>().release();
<a name="l00149"></a>00149       projected_solutions[i]-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a>(system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;size(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00150"></a>00150       system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;localize(*projected_solutions[i],
<a name="l00151"></a>00151                                 system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a4e0a6909796bc3c19ca543a182ffe224">get_send_list</a>());
<a name="l00152"></a>00152     }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// Get the uniformly refined solution.</span>
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keywordflow">if</span> (_es)
<a name="l00157"></a>00157     {
<a name="l00158"></a>00158       <span class="comment">// No specified vectors == forward solve</span>
<a name="l00159"></a>00159       <span class="keywordflow">if</span> (!solution_vectors)
<a name="l00160"></a>00160         es.<a class="code" href="classlibMesh_1_1EquationSystems.php#ae63435d018c0c5cd6d0b72547afc0032">solve</a>();
<a name="l00161"></a>00161       <span class="keywordflow">else</span>
<a name="l00162"></a>00162         {
<a name="l00163"></a>00163           libmesh_assert(solution_vectors-&gt;size() == es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00164"></a>00164           libmesh_assert(solution_vectors-&gt;find(system_list[0]) !=
<a name="l00165"></a>00165                          solution_vectors-&gt;end());
<a name="l00166"></a>00166           <span class="keyword">const</span> <span class="keywordtype">bool</span> solve_adjoint = 
<a name="l00167"></a>00167             (system_list[0]-&gt;have_vector(<span class="stringliteral">&quot;adjoint_solution0&quot;</span>) &amp;&amp;
<a name="l00168"></a>00168              (solution_vectors-&gt;find(system_list[0])-&gt;second ==
<a name="l00169"></a>00169               &amp;system_list[0]-&gt;get_adjoint_solution()));
<a name="l00170"></a>00170           libmesh_assert(solve_adjoint ||
<a name="l00171"></a>00171             (solution_vectors-&gt;find(system_list[0])-&gt;second ==
<a name="l00172"></a>00172              system_list[0]-&gt;solution.get()) ||
<a name="l00173"></a>00173              !solution_vectors-&gt;find(system_list[0])-&gt;second);
<a name="l00174"></a>00174                          
<a name="l00175"></a>00175 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>          <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00177"></a>00177             {
<a name="l00178"></a>00178               libmesh_assert(solution_vectors-&gt;find(system_list[i]) !=
<a name="l00179"></a>00179                              solution_vectors-&gt;end());
<a name="l00180"></a>00180               libmesh_assert(!solve_adjoint ||
<a name="l00181"></a>00181                              solution_vectors-&gt;find(system_list[i])-&gt;second ==
<a name="l00182"></a>00182                              &amp;system_list[i]-&gt;get_adjoint_solution());
<a name="l00183"></a>00183               libmesh_assert(solve_adjoint ||
<a name="l00184"></a>00184                              solution_vectors-&gt;find(system_list[i])-&gt;second ==
<a name="l00185"></a>00185                              system_list[i]-&gt;solution.get() ||
<a name="l00186"></a>00186                              !solution_vectors-&gt;find(system_list[i])-&gt;second);
<a name="l00187"></a>00187             }
<a name="l00188"></a>00188 <span class="preprocessor">#endif</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>
<a name="l00190"></a>00190           <span class="keywordflow">if</span> (solve_adjoint)
<a name="l00191"></a>00191             {
<a name="l00192"></a>00192               <span class="comment">// Set up proper initial guesses</span>
<a name="l00193"></a>00193               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00194"></a>00194                 system_list[i]-&gt;get_adjoint_solution() = *system_list[i]-&gt;solution;
<a name="l00195"></a>00195               es.<a class="code" href="classlibMesh_1_1EquationSystems.php#abf595c7f10f4234ab6027e6aea712935">adjoint_solve</a>();
<a name="l00196"></a>00196               <span class="comment">// Put the adjoint_solution into solution for</span>
<a name="l00197"></a>00197               <span class="comment">// comparisons</span>
<a name="l00198"></a>00198               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00199"></a>00199                 {
<a name="l00200"></a>00200                   system_list[i]-&gt;get_adjoint_solution().swap(*system_list[i]-&gt;solution);
<a name="l00201"></a>00201                   system_list[i]-&gt;update();
<a name="l00202"></a>00202                 }
<a name="l00203"></a>00203             }
<a name="l00204"></a>00204           <span class="keywordflow">else</span>
<a name="l00205"></a>00205             es.<a class="code" href="classlibMesh_1_1EquationSystems.php#ae63435d018c0c5cd6d0b72547afc0032">solve</a>();
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207     }
<a name="l00208"></a>00208   <span class="keywordflow">else</span>
<a name="l00209"></a>00209     {
<a name="l00210"></a>00210       <span class="comment">// No specified vectors == forward solve</span>
<a name="l00211"></a>00211       <span class="keywordflow">if</span> (!solution_vectors)
<a name="l00212"></a>00212         system_list[0]-&gt;solve();
<a name="l00213"></a>00213       <span class="keywordflow">else</span>
<a name="l00214"></a>00214         {
<a name="l00215"></a>00215           libmesh_assert(solution_vectors-&gt;find(system_list[0]) !=
<a name="l00216"></a>00216                          solution_vectors-&gt;end());
<a name="l00217"></a>00217 
<a name="l00218"></a>00218           <span class="keyword">const</span> <span class="keywordtype">bool</span> solve_adjoint = 
<a name="l00219"></a>00219             (system_list[0]-&gt;have_vector(<span class="stringliteral">&quot;adjoint_solution0&quot;</span>) &amp;&amp;
<a name="l00220"></a>00220              (solution_vectors-&gt;find(system_list[0])-&gt;second ==
<a name="l00221"></a>00221               &amp;system_list[0]-&gt;get_adjoint_solution()));
<a name="l00222"></a>00222           libmesh_assert(solve_adjoint ||
<a name="l00223"></a>00223             (solution_vectors-&gt;find(system_list[0])-&gt;second ==
<a name="l00224"></a>00224              system_list[0]-&gt;solution.get()) ||
<a name="l00225"></a>00225             !solution_vectors-&gt;find(system_list[0])-&gt;second);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227           <span class="keywordflow">if</span> (solve_adjoint)
<a name="l00228"></a>00228             {
<a name="l00229"></a>00229               <span class="comment">// Set up proper initial guesses</span>
<a name="l00230"></a>00230               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00231"></a>00231                 system_list[0]-&gt;get_adjoint_solution() = *system_list[0]-&gt;solution;
<a name="l00232"></a>00232               system_list[0]-&gt;adjoint_solve();
<a name="l00233"></a>00233               <span class="comment">// Put the adjoint_solution into solution for</span>
<a name="l00234"></a>00234               <span class="comment">// comparisons</span>
<a name="l00235"></a>00235               system_list[0]-&gt;get_adjoint_solution().swap(*system_list[0]-&gt;solution);
<a name="l00236"></a>00236               system_list[0]-&gt;update();
<a name="l00237"></a>00237             }
<a name="l00238"></a>00238           <span class="keywordflow">else</span>
<a name="l00239"></a>00239             system_list[0]-&gt;solve();
<a name="l00240"></a>00240         }
<a name="l00241"></a>00241     }
<a name="l00242"></a>00242   
<a name="l00243"></a>00243   <span class="comment">// Get the error in the uniformly refined solution(s).</span>
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00246"></a>00246     {
<a name="l00247"></a>00247       <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system = *system_list[i];
<a name="l00248"></a>00248 
<a name="l00249"></a>00249       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00250"></a>00250 
<a name="l00251"></a>00251       <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map = system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00252"></a>00252 
<a name="l00253"></a>00253       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> &amp;system_i_norm =
<a name="l00254"></a>00254         _error_norms-&gt;find(&amp;system)-&gt;second;
<a name="l00255"></a>00255 
<a name="l00256"></a>00256       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *projected_solution = projected_solutions[i];
<a name="l00257"></a>00257 
<a name="l00258"></a>00258       <span class="comment">// Loop over all the variables in the system</span>
<a name="l00259"></a>00259       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00260"></a>00260         {
<a name="l00261"></a>00261           <span class="comment">// Get the error vector to fill for this system and variable</span>
<a name="l00262"></a>00262           <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> *err_vec = error_per_cell;
<a name="l00263"></a>00263           <span class="keywordflow">if</span> (!err_vec)
<a name="l00264"></a>00264             {
<a name="l00265"></a>00265               libmesh_assert(errors_per_cell);
<a name="l00266"></a>00266               err_vec =
<a name="l00267"></a>00267                 (*errors_per_cell)[std::make_pair(&amp;system,var)];
<a name="l00268"></a>00268             }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270           <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00271"></a>00271           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a> (var);
<a name="l00272"></a>00272       
<a name="l00273"></a>00273           <span class="comment">// Finite element object for each fine element</span>
<a name="l00274"></a>00274           <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a> (dim, fe_type));
<a name="l00275"></a>00275 
<a name="l00276"></a>00276           <span class="comment">// Build and attach an appropriate quadrature rule</span>
<a name="l00277"></a>00277           <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> qrule = fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a>(dim);
<a name="l00278"></a>00278           fe-&gt;attach_quadrature_rule (qrule.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00279"></a>00279       
<a name="l00280"></a>00280           <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;  JxW = fe-&gt;get_JxW();
<a name="l00281"></a>00281           <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; phi = fe-&gt;get_phi();
<a name="l00282"></a>00282           <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; dphi =
<a name="l00283"></a>00283             fe-&gt;get_dphi();
<a name="l00284"></a>00284 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00285"></a>00285 <span class="preprocessor"></span>          <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp; d2phi =
<a name="l00286"></a>00286             fe-&gt;get_d2phi();
<a name="l00287"></a>00287 <span class="preprocessor">#endif</span>
<a name="l00288"></a>00288 <span class="preprocessor"></span>
<a name="l00289"></a>00289           <span class="comment">// The global DOF indices for the fine element</span>
<a name="l00290"></a>00290           std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00291"></a>00291       
<a name="l00292"></a>00292           <span class="comment">// Iterate over all the active elements in the fine mesh</span>
<a name="l00293"></a>00293           <span class="comment">// that live on this processor.</span>
<a name="l00294"></a>00294           <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00295"></a>00295           <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297           <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00298"></a>00298             {
<a name="l00299"></a>00299               <span class="comment">// e is necessarily an active element on the local processor</span>
<a name="l00300"></a>00300               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00301"></a>00301 
<a name="l00302"></a>00302               <span class="comment">// Find the element id for the corresponding coarse grid element</span>
<a name="l00303"></a>00303               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* coarse = elem;
<a name="l00304"></a>00304               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e_id = coarse-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00305"></a>00305               <span class="keywordflow">while</span> (e_id &gt;= max_coarse_elem_id)
<a name="l00306"></a>00306                 {
<a name="l00307"></a>00307                   libmesh_assert (coarse-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>());
<a name="l00308"></a>00308                   coarse = coarse-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00309"></a>00309                   e_id = coarse-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00310"></a>00310                 }
<a name="l00311"></a>00311           
<a name="l00312"></a>00312               <span class="keywordtype">double</span> L2normsq = 0., H1seminormsq = 0., H2seminormsq = 0.;
<a name="l00313"></a>00313 
<a name="l00314"></a>00314               <span class="comment">// reinitialize the element-specific data</span>
<a name="l00315"></a>00315               <span class="comment">// for the current element</span>
<a name="l00316"></a>00316               fe-&gt;reinit (elem);
<a name="l00317"></a>00317 
<a name="l00318"></a>00318               <span class="comment">// Get the local to global degree of freedom maps</span>
<a name="l00319"></a>00319               dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices, var);
<a name="l00320"></a>00320 
<a name="l00321"></a>00321               <span class="comment">// The number of quadrature points</span>
<a name="l00322"></a>00322               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qrule-&gt;n_points();
<a name="l00323"></a>00323 
<a name="l00324"></a>00324               <span class="comment">// The number of shape functions</span>
<a name="l00325"></a>00325               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = dof_indices.size();
<a name="l00326"></a>00326 
<a name="l00327"></a>00327               <span class="comment">//</span>
<a name="l00328"></a>00328               <span class="comment">// Begin the loop over the Quadrature points.</span>
<a name="l00329"></a>00329               <span class="comment">//</span>
<a name="l00330"></a>00330               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00331"></a>00331                 {
<a name="l00332"></a>00332                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_fine = 0., u_coarse = 0.;
<a name="l00333"></a>00333 
<a name="l00334"></a>00334                   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_fine, grad_u_coarse;
<a name="l00335"></a>00335 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00336"></a>00336 <span class="preprocessor"></span>                  <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> grad2_u_fine, grad2_u_coarse;
<a name="l00337"></a>00337 <span class="preprocessor">#endif</span>
<a name="l00338"></a>00338 <span class="preprocessor"></span>
<a name="l00339"></a>00339                   <span class="comment">// Compute solution values at the current</span>
<a name="l00340"></a>00340                   <span class="comment">// quadrature point.  This reqiures a sum</span>
<a name="l00341"></a>00341                   <span class="comment">// over all the shape functions evaluated</span>
<a name="l00342"></a>00342                   <span class="comment">// at the quadrature point.</span>
<a name="l00343"></a>00343                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00344"></a>00344                     {
<a name="l00345"></a>00345                       u_fine            += phi[i][qp]*system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[i]);
<a name="l00346"></a>00346                       u_coarse          += phi[i][qp]*(*projected_solution) (dof_indices[i]);
<a name="l00347"></a>00347                       grad_u_fine       += dphi[i][qp]*system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[i]);
<a name="l00348"></a>00348                       grad_u_coarse     += dphi[i][qp]*(*projected_solution) (dof_indices[i]);
<a name="l00349"></a>00349 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00350"></a>00350 <span class="preprocessor"></span>                      grad2_u_fine      += d2phi[i][qp]*system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[i]);
<a name="l00351"></a>00351                       grad2_u_coarse    += d2phi[i][qp]*(*projected_solution) (dof_indices[i]);
<a name="l00352"></a>00352 <span class="preprocessor">#endif</span>
<a name="l00353"></a>00353 <span class="preprocessor"></span>                    }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355                   <span class="comment">// Compute the value of the error at this quadrature point</span>
<a name="l00356"></a>00356                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> val_error = u_fine - u_coarse;
<a name="l00357"></a>00357 
<a name="l00358"></a>00358                   <span class="comment">// Add the squares of the error to each contribution</span>
<a name="l00359"></a>00359                   <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00360"></a>00360                       system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00361"></a>00361                       system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>)
<a name="l00362"></a>00362                     {
<a name="l00363"></a>00363                       L2normsq += JxW[qp] * system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">weight_sq</a>(var) *
<a name="l00364"></a>00364                                   <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(val_error);
<a name="l00365"></a>00365                       libmesh_assert (L2normsq     &gt;= 0.);
<a name="l00366"></a>00366                     }
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369                   <span class="comment">// Compute the value of the error in the gradient at this</span>
<a name="l00370"></a>00370                   <span class="comment">// quadrature point</span>
<a name="l00371"></a>00371                   <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00372"></a>00372                       system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00373"></a>00373                       system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l00374"></a>00374                     {
<a name="l00375"></a>00375                       <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_error = grad_u_fine - grad_u_coarse;
<a name="l00376"></a>00376 
<a name="l00377"></a>00377                       H1seminormsq += JxW[qp] * system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">weight_sq</a>(var) *
<a name="l00378"></a>00378                         grad_error.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>();
<a name="l00379"></a>00379                       libmesh_assert (H1seminormsq &gt;= 0.);
<a name="l00380"></a>00380                     }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00383"></a>00383 <span class="preprocessor"></span>                  <span class="comment">// Compute the value of the error in the hessian at this</span>
<a name="l00384"></a>00384                   <span class="comment">// quadrature point</span>
<a name="l00385"></a>00385                   <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00386"></a>00386                       system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00387"></a>00387                     {
<a name="l00388"></a>00388                       <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> grad2_error = grad2_u_fine - grad2_u_coarse;
<a name="l00389"></a>00389 
<a name="l00390"></a>00390                       H2seminormsq += JxW[qp] * system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">weight_sq</a>(var) *
<a name="l00391"></a>00391                         grad2_error.<a class="code" href="classlibMesh_1_1TypeTensor.php#a3f195e163a89444e26e49398cbad1155">size_sq</a>();
<a name="l00392"></a>00392                       libmesh_assert (H2seminormsq &gt;= 0.);
<a name="l00393"></a>00393                     }
<a name="l00394"></a>00394 <span class="preprocessor">#endif</span>
<a name="l00395"></a>00395 <span class="preprocessor"></span>                } <span class="comment">// end qp loop</span>
<a name="l00396"></a>00396 
<a name="l00397"></a>00397               <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00398"></a>00398                   system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00399"></a>00399                   system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>)
<a name="l00400"></a>00400                 (*err_vec)[e_id] += L2normsq;
<a name="l00401"></a>00401               <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00402"></a>00402                   system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00403"></a>00403                   system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l00404"></a>00404                 (*err_vec)[e_id] += H1seminormsq;
<a name="l00405"></a>00405               
<a name="l00406"></a>00406               <span class="keywordflow">if</span> (system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a> ||
<a name="l00407"></a>00407                   system_i_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00408"></a>00408                 (*err_vec)[e_id] += H2seminormsq;
<a name="l00409"></a>00409             } <span class="comment">// End loop over active local elements</span>
<a name="l00410"></a>00410         } <span class="comment">// End loop over variables</span>
<a name="l00411"></a>00411 
<a name="l00412"></a>00412       <span class="comment">// Don&#39;t bother projecting the solution; we&#39;ll restore from backup</span>
<a name="l00413"></a>00413       <span class="comment">// after coarsening</span>
<a name="l00414"></a>00414       system.<a class="code" href="classlibMesh_1_1System.php#a04a93003e559fb4b266738e81fa52585">project_solution_on_reinit</a>() = <span class="keyword">false</span>;
<a name="l00415"></a>00415     }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="comment">// Uniformly coarsen the mesh, without projecting the solution</span>
<a name="l00419"></a>00419   libmesh_assert (<a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a4437c7888b7459952e06a9157bf61ffe">number_h_refinements</a> &gt; 0 || <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#abff7ac97985f693cd3cc7a8311a24558">number_p_refinements</a> &gt; 0);
<a name="l00420"></a>00420 
<a name="l00421"></a>00421   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a4437c7888b7459952e06a9157bf61ffe">number_h_refinements</a>; ++i)
<a name="l00422"></a>00422     {
<a name="l00423"></a>00423       mesh_refinement.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a0c090a5a22834d33fa0d436fbccab795">uniformly_coarsen</a>(1);
<a name="l00424"></a>00424       <span class="comment">// FIXME - should the reinits here be necessary? - RHS</span>
<a name="l00425"></a>00425       es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a1634fa5937c4d915d83c35d591ed7c05">reinit</a>();
<a name="l00426"></a>00426     }
<a name="l00427"></a>00427       
<a name="l00428"></a>00428   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#abff7ac97985f693cd3cc7a8311a24558">number_p_refinements</a>; ++i)
<a name="l00429"></a>00429     {
<a name="l00430"></a>00430       mesh_refinement.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a19810e55f1ba17b88aa665e8c31cb5a2">uniformly_p_coarsen</a>(1);
<a name="l00431"></a>00431       es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a1634fa5937c4d915d83c35d591ed7c05">reinit</a>();
<a name="l00432"></a>00432     }
<a name="l00433"></a>00433 
<a name="l00434"></a>00434   <span class="comment">// We should be back where we started</span>
<a name="l00435"></a>00435   libmesh_assert(n_coarse_elem == mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>());
<a name="l00436"></a>00436 
<a name="l00437"></a>00437   <span class="comment">// Each processor has now computed the error contribuions</span>
<a name="l00438"></a>00438   <span class="comment">// for its local elements.  We need to sum the vector</span>
<a name="l00439"></a>00439   <span class="comment">// and then take the square-root of each component.  Note</span>
<a name="l00440"></a>00440   <span class="comment">// that we only need to sum if we are running on multiple</span>
<a name="l00441"></a>00441   <span class="comment">// processors, and we only need to take the square-root</span>
<a name="l00442"></a>00442   <span class="comment">// if the value is nonzero.  There will in general be many</span>
<a name="l00443"></a>00443   <span class="comment">// zeros for the inactive elements.</span>
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="keywordflow">if</span> (error_per_cell)
<a name="l00446"></a>00446     {
<a name="l00447"></a>00447       <span class="comment">// First sum the vector of estimated error values</span>
<a name="l00448"></a>00448       this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9b57650afd8a3a0a88cb62bf74dd95e3">reduce_error</a>(*error_per_cell);
<a name="l00449"></a>00449 
<a name="l00450"></a>00450       <span class="comment">// Compute the square-root of each component.</span>
<a name="l00451"></a>00451       START_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;AdjointRefinementEstimator&quot;</span>);
<a name="l00452"></a>00452       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;error_per_cell-&gt;size(); i++)
<a name="l00453"></a>00453         <span class="keywordflow">if</span> ((*error_per_cell)[i] != 0.)
<a name="l00454"></a>00454           (*error_per_cell)[i] = std::sqrt((*error_per_cell)[i]);
<a name="l00455"></a>00455       STOP_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;AdjointRefinementEstimator&quot;</span>);
<a name="l00456"></a>00456     }
<a name="l00457"></a>00457   <span class="keywordflow">else</span>
<a name="l00458"></a>00458     {
<a name="l00459"></a>00459       <span class="keywordflow">for</span> (ErrorMap::iterator i = errors_per_cell-&gt;begin();
<a name="l00460"></a>00460            i != errors_per_cell-&gt;end(); ++i)
<a name="l00461"></a>00461         {
<a name="l00462"></a>00462           <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> *e = i-&gt;second;
<a name="l00463"></a>00463           <span class="comment">// First sum the vector of estimated error values</span>
<a name="l00464"></a>00464           this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9b57650afd8a3a0a88cb62bf74dd95e3">reduce_error</a>(*e);
<a name="l00465"></a>00465 
<a name="l00466"></a>00466           <span class="comment">// Compute the square-root of each component.</span>
<a name="l00467"></a>00467           START_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;AdjointRefinementEstimator&quot;</span>);
<a name="l00468"></a>00468           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;e-&gt;size(); i++)
<a name="l00469"></a>00469             <span class="keywordflow">if</span> ((*e)[i] != 0.)
<a name="l00470"></a>00470               (*e)[i] = std::sqrt((*e)[i]);
<a name="l00471"></a>00471           STOP_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;AdjointRefinementEstimator&quot;</span>);
<a name="l00472"></a>00472         }
<a name="l00473"></a>00473     }
<a name="l00474"></a>00474 
<a name="l00475"></a>00475   <span class="comment">// Restore old solutions and clean up the heap</span>
<a name="l00476"></a>00476   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != system_list.size(); ++i)
<a name="l00477"></a>00477     {
<a name="l00478"></a>00478       <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system = *system_list[i];
<a name="l00479"></a>00479 
<a name="l00480"></a>00480       system.<a class="code" href="classlibMesh_1_1System.php#a04a93003e559fb4b266738e81fa52585">project_solution_on_reinit</a>() = old_projection_settings[i];
<a name="l00481"></a>00481   
<a name="l00482"></a>00482       <span class="comment">// Restore the coarse solution vectors and delete their copies</span>
<a name="l00483"></a>00483       *system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a> = *coarse_solutions[i];
<a name="l00484"></a>00484       <span class="keyword">delete</span> coarse_solutions[i];
<a name="l00485"></a>00485       *system.<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a> = *coarse_local_solutions[i];
<a name="l00486"></a>00486       <span class="keyword">delete</span> coarse_local_solutions[i];
<a name="l00487"></a>00487       <span class="keyword">delete</span> projected_solutions[i];
<a name="l00488"></a>00488 
<a name="l00489"></a>00489       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1System.php#a6a75b971c5614203f50d5a922df9253c">System::vectors_iterator</a> vec = system.<a class="code" href="classlibMesh_1_1System.php#a293a39e0a532954f5c643b5d3650c048">vectors_begin</a>(); vec !=
<a name="l00490"></a>00490            system.<a class="code" href="classlibMesh_1_1System.php#a8bad75f37fdc2e047d73830d182e1314">vectors_end</a>(); ++vec)
<a name="l00491"></a>00491         {
<a name="l00492"></a>00492           <span class="comment">// The (string) name of this vector</span>
<a name="l00493"></a>00493           <span class="keyword">const</span> std::string&amp; var_name = vec-&gt;first;
<a name="l00494"></a>00494 
<a name="l00495"></a>00495           system.<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(var_name) = *coarse_vectors[i][var_name];
<a name="l00496"></a>00496 
<a name="l00497"></a>00497           coarse_vectors[i][var_name]-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a1d68d128b5e80a75fea7c24b7f3bcb5b">clear</a>();
<a name="l00498"></a>00498           <span class="keyword">delete</span> coarse_vectors[i][var_name];
<a name="l00499"></a>00499         }
<a name="l00500"></a>00500     }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   <span class="comment">// Restore old partitioner settings</span>
<a name="l00503"></a>00503   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa07a00e86d68f366d8fe7e4d01140ffc">partitioner</a>() = old_partitioner;
<a name="l00504"></a>00504 }
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 } <span class="comment">// namespace libMesh</span>
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00509"></a>00509 <span class="preprocessor"></span>
<a name="l00510"></a>00510 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
