<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3734f8fafd73a2969ee8ed4a34620869.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">adjoint_refinement_estimator.h</div>  </div>
</div>
<div class="contents">
<a href="adjoint__refinement__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adjoint_refinement_estimator.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __adjoint_refinement_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __adjoint_refinement_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="qoi__set_8h.php">qoi_set.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php">AdjointRefinementEstimator</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php">ErrorEstimator</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#afcdf4f028e2e69d7457d052cb8b27540">00054</a>   <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#afcdf4f028e2e69d7457d052cb8b27540">AdjointRefinementEstimator</a>() : <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a4437c7888b7459952e06a9157bf61ffe">number_h_refinements</a>(1),
<a name="l00055"></a>00055                                  <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#abff7ac97985f693cd3cc7a8311a24558">number_p_refinements</a>(0),
<a name="l00056"></a>00056                                  <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#ad51061a9299eba61c328edca03b0cd20">_qoi_set</a>(<a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>())
<a name="l00057"></a>00057   {
<a name="l00058"></a>00058     <span class="comment">// We&#39;re not actually going to use error_norm; our norms are</span>
<a name="l00059"></a>00059     <span class="comment">// absolute values of QoI error.</span>
<a name="l00060"></a>00060     <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a165995a1ed79f4b8c98e8824a54a2e27">INVALID_NORM</a>;
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062   
<a name="l00066"></a><a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#acfe91c49a0c78d780403574eeaee5b3a">00066</a>   <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#acfe91c49a0c78d780403574eeaee5b3a">~AdjointRefinementEstimator</a>() {}
<a name="l00067"></a>00067 
<a name="l00072"></a><a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a0aca6ed2c5e83a66cbea3fb745d42bb6">00072</a>   <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;<a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a0aca6ed2c5e83a66cbea3fb745d42bb6">qoi_set</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#ad51061a9299eba61c328edca03b0cd20">_qoi_set</a>; }
<a name="l00073"></a>00073 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a88133f5a181d748fd67d537e37fb944c">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00091"></a>00091                                <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00092"></a>00092                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00093"></a>00093                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00094"></a>00094 
<a name="l00098"></a><a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a4437c7888b7459952e06a9157bf61ffe">00098</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a4437c7888b7459952e06a9157bf61ffe">number_h_refinements</a>;
<a name="l00099"></a>00099   
<a name="l00103"></a><a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#abff7ac97985f693cd3cc7a8311a24558">00103</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#abff7ac97985f693cd3cc7a8311a24558">number_p_refinements</a>;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="keyword">protected</span>:
<a name="l00110"></a>00110   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#a0015d8973ae08db7fe44c853853c98b1">_estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> *equation_systems,
<a name="l00111"></a>00111                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>* system,
<a name="l00112"></a>00112                                 <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>* error_per_cell,
<a name="l00113"></a>00113                                 std::map&lt;std::pair&lt;const System*, unsigned int&gt;, <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>*&gt;* errors_per_cell,
<a name="l00114"></a>00114                                 <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors = NULL,
<a name="l00115"></a>00115                                 <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#ad51061a9299eba61c328edca03b0cd20">00120</a>   <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> <a class="code" href="classlibMesh_1_1AdjointRefinementEstimator.php#ad51061a9299eba61c328edca03b0cd20">_qoi_set</a>;
<a name="l00121"></a>00121 };
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span>
<a name="l00125"></a>00125 } <span class="comment">// namespace libMesh</span>
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="preprocessor">#endif</span>
<a name="l00128"></a>00128 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
