<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">adjoint_residual_error_estimator.C</div>  </div>
</div>
<div class="contents">
<a href="adjoint__residual__error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adjoint_residual_error_estimator.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="adjoint__residual__error__estimator_8h.php">adjoint_residual_error_estimator.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="patch__recovery__error__estimator_8h.php">patch_recovery_error_estimator.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="system__norm_8h.php">system_norm.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="qoi__set_8h.php">qoi_set.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// AdjointResidualErrorEstimator implementations</span>
<a name="l00040"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a6a0f8337eae9e8c156680441d2840c24">00040</a> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a6a0f8337eae9e8c156680441d2840c24">AdjointResidualErrorEstimator::AdjointResidualErrorEstimator</a> () :
<a name="l00041"></a>00041   adjoint_already_solved(false),
<a name="l00042"></a>00042   error_plot_suffix(),
<a name="l00043"></a>00043   _primal_error_estimator(new <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a>()),
<a name="l00044"></a>00044   _dual_error_estimator(new <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a>()),
<a name="l00045"></a>00045   _qoi_set(<a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>())
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a3be60bea58f364ffa0aed5351ce23361">00051</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a3be60bea58f364ffa0aed5351ce23361">AdjointResidualErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; _system,
<a name="l00052"></a>00052                                                     <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00053"></a>00053                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00054"></a>00054                                                     <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   START_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;AdjointResidualErrorEstimator&quot;</span>);
<a name="l00057"></a>00057  
<a name="l00058"></a>00058   <span class="comment">// The current mesh</span>
<a name="l00059"></a>00059   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = _system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">// Resize the error_per_cell vector to be</span>
<a name="l00062"></a>00062   <span class="comment">// the number of elements, initialize it to 0.</span>
<a name="l00063"></a>00063   error_per_cell.resize (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>());
<a name="l00064"></a>00064   std::fill (error_per_cell.begin(), error_per_cell.end(), 0.);
<a name="l00065"></a>00065     
<a name="l00066"></a>00066   <span class="comment">// Get the number of variables in the system</span>
<a name="l00067"></a>00067   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = _system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">// We need to make a map of the pointer to the solution vector    </span>
<a name="l00070"></a>00070   std::map&lt;const System*, const NumericVector&lt;Number&gt;*&gt;solutionvecs;
<a name="l00071"></a>00071   solutionvecs[&amp;_system] = _system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00072"></a>00072   
<a name="l00073"></a>00073   <span class="comment">// Solve the dual problem if we have to</span>
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a6c0a22af027cd007714750c7c4216791">adjoint_already_solved</a>)
<a name="l00075"></a>00075     {
<a name="l00076"></a>00076       <span class="comment">// FIXME - we&#39;ll need to change a lot of APIs to make this trick</span>
<a name="l00077"></a>00077       <span class="comment">// work with a const System...     </span>
<a name="l00078"></a>00078       <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;  system = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1System.php">System</a>&amp;<span class="keyword">&gt;</span>(_system);
<a name="l00079"></a>00079       system.<a class="code" href="classlibMesh_1_1System.php#a6e5b90b9bd6cf63a40cc77f02671a92d">adjoint_solve</a>(<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4d04cafa87de4f7aa6ad7bac316a7a39">_qoi_set</a>);
<a name="l00080"></a>00080     }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// Flag to check whether we have not been asked to weight the variable error contributions in any specific manner</span>
<a name="l00083"></a>00083   <span class="keywordtype">bool</span> error_norm_is_identity = <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#ae6cce0dd5b1659cd55e4f8430ea1bb39">is_identity</a>();
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// Create an ErrorMap/ErrorVector to store the primal, dual and total_dual variable errors</span>
<a name="l00086"></a>00086   <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a838c11d53f37d85b33a827a355819c94">ErrorMap</a> primal_errors_per_cell; 
<a name="l00087"></a>00087   <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a838c11d53f37d85b33a827a355819c94">ErrorMap</a> dual_errors_per_cell; 
<a name="l00088"></a>00088   <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a838c11d53f37d85b33a827a355819c94">ErrorMap</a> total_dual_errors_per_cell;
<a name="l00089"></a>00089   <span class="comment">// Allocate ErrorVectors to this map if we&#39;re going to use it</span>
<a name="l00090"></a>00090   <span class="keywordflow">if</span> (!error_norm_is_identity)
<a name="l00091"></a>00091     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v = 0; v &lt; <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; v++)
<a name="l00092"></a>00092       {            
<a name="l00093"></a>00093         primal_errors_per_cell[std::make_pair(&amp;_system, v)] = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>;
<a name="l00094"></a>00094         dual_errors_per_cell[std::make_pair(&amp;_system, v)] = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>;
<a name="l00095"></a>00095         total_dual_errors_per_cell[std::make_pair(&amp;_system, v)] = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>;
<a name="l00096"></a>00096       }
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> primal_error_per_cell;
<a name="l00098"></a>00098   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> dual_error_per_cell;
<a name="l00099"></a>00099   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> total_dual_error_per_cell;
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">// Get the error estimator object&#39;s SystemNorm object to compute the weighted error estimate u^T M z</span>
<a name="l00102"></a>00102   <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> = this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>;
<a name="l00103"></a>00103   
<a name="l00104"></a>00104   <span class="comment">// Have we been asked to weight the variable error contributions in any specific manner</span>
<a name="l00105"></a>00105   <span class="keywordflow">if</span>(!error_norm_is_identity) <span class="comment">// If we do</span>
<a name="l00106"></a>00106     {           
<a name="l00107"></a>00107       <span class="comment">// Estimate the primal problem error for each variable      </span>
<a name="l00108"></a>00108       <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a0dc159e5896539cdfbab4448ef2c6de6">_primal_error_estimator</a>-&gt;estimate_errors
<a name="l00109"></a>00109         (_system.<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>(), primal_errors_per_cell, &amp;solutionvecs, estimate_parent_error);                         
<a name="l00110"></a>00110     }
<a name="l00111"></a>00111   <span class="keywordflow">else</span> <span class="comment">// If not</span>
<a name="l00112"></a>00112     {
<a name="l00113"></a>00113       <span class="comment">// Just get the combined error estimate</span>
<a name="l00114"></a>00114       <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a0dc159e5896539cdfbab4448ef2c6de6">_primal_error_estimator</a>-&gt;estimate_error
<a name="l00115"></a>00115         (_system, primal_error_per_cell, solution_vector, estimate_parent_error);
<a name="l00116"></a>00116     }
<a name="l00117"></a>00117                   
<a name="l00118"></a>00118   <span class="comment">// Sum and weight the dual error estimate based on our QoISet</span>
<a name="l00119"></a>00119   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != _system.<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00120"></a>00120     {
<a name="l00121"></a>00121       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4d04cafa87de4f7aa6ad7bac316a7a39">_qoi_set</a>.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00122"></a>00122         {
<a name="l00123"></a>00123           <span class="comment">// Get the weight for the current QoI</span>
<a name="l00124"></a>00124           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_weight = <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4d04cafa87de4f7aa6ad7bac316a7a39">_qoi_set</a>.<a class="code" href="classlibMesh_1_1QoISet.php#abfcf1c89b78ec1ff01f3b6064b910401">weight</a>(i);
<a name="l00125"></a>00125           
<a name="l00126"></a>00126            <span class="comment">// We need to make a map of the pointer to the adjoint solution vector</span>
<a name="l00127"></a>00127           std::map&lt;const System*, const NumericVector&lt;Number&gt;*&gt;adjointsolutionvecs;
<a name="l00128"></a>00128           adjointsolutionvecs[&amp;_system] = &amp;_system.<a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(i);
<a name="l00129"></a>00129                   
<a name="l00130"></a>00130           <span class="comment">// Have we been asked to weight the variable error contributions in any specific manner</span>
<a name="l00131"></a>00131           <span class="keywordflow">if</span>(!error_norm_is_identity) <span class="comment">// If we have</span>
<a name="l00132"></a>00132             {                 
<a name="l00133"></a>00133               <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ad8e104593004e8243489c129ea12afd0">_dual_error_estimator</a>-&gt;estimate_errors
<a name="l00134"></a>00134                 (_system.<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>(), dual_errors_per_cell, &amp;adjointsolutionvecs,
<a name="l00135"></a>00135                  estimate_parent_error);              
<a name="l00136"></a>00136             }
<a name="l00137"></a>00137           <span class="keywordflow">else</span> <span class="comment">// If not</span>
<a name="l00138"></a>00138             {
<a name="l00139"></a>00139             <span class="comment">// Just get the combined error estimate</span>
<a name="l00140"></a>00140               <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ad8e104593004e8243489c129ea12afd0">_dual_error_estimator</a>-&gt;estimate_error
<a name="l00141"></a>00141                 (_system, dual_error_per_cell, &amp;(_system.<a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(i)), estimate_parent_error);
<a name="l00142"></a>00142             }
<a name="l00143"></a>00143           
<a name="l00144"></a>00144           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> error_size;
<a name="l00145"></a>00145           
<a name="l00146"></a>00146           <span class="comment">// Get the size of the first ErrorMap vector; this will give us the number of elements</span>
<a name="l00147"></a>00147           <span class="keywordflow">if</span>(!error_norm_is_identity) <span class="comment">// If in non default weights case</span>
<a name="l00148"></a>00148             {       
<a name="l00149"></a>00149               error_size = dual_errors_per_cell[std::make_pair(&amp;_system, 0)]-&gt;size();
<a name="l00150"></a>00150             }
<a name="l00151"></a>00151           <span class="keywordflow">else</span> <span class="comment">// If in the standard default weights case</span>
<a name="l00152"></a>00152             {
<a name="l00153"></a>00153               error_size = dual_error_per_cell.size();
<a name="l00154"></a>00154             }
<a name="l00155"></a>00155           
<a name="l00156"></a>00156           <span class="comment">// Resize the ErrorVector(s)</span>
<a name="l00157"></a>00157           <span class="keywordflow">if</span>(!error_norm_is_identity)
<a name="l00158"></a>00158             {
<a name="l00159"></a>00159               <span class="comment">// Loop over variables</span>
<a name="l00160"></a>00160               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v = 0; v &lt; <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; v++)
<a name="l00161"></a>00161                 {                 
<a name="l00162"></a>00162                   libmesh_assert(!total_dual_errors_per_cell[std::make_pair(&amp;_system, v)]-&gt;size() ||
<a name="l00163"></a>00163                                  total_dual_errors_per_cell[std::make_pair(&amp;_system, v)]-&gt;size() == error_size) ;
<a name="l00164"></a>00164                   total_dual_errors_per_cell[std::make_pair(&amp;_system, v)]-&gt;resize(error_size);
<a name="l00165"></a>00165                 }
<a name="l00166"></a>00166             }
<a name="l00167"></a>00167           <span class="keywordflow">else</span>
<a name="l00168"></a>00168             {
<a name="l00169"></a>00169               libmesh_assert(!total_dual_error_per_cell.size() ||
<a name="l00170"></a>00170                              total_dual_error_per_cell.size() == error_size);
<a name="l00171"></a>00171               total_dual_error_per_cell.resize(error_size);
<a name="l00172"></a>00172             }
<a name="l00173"></a>00173           
<a name="l00174"></a>00174           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e = 0; e != error_size; ++e)
<a name="l00175"></a>00175             {     
<a name="l00176"></a>00176               <span class="comment">// Have we been asked to weight the variable error contributions in any specific manner</span>
<a name="l00177"></a>00177               <span class="keywordflow">if</span>(!error_norm_is_identity) <span class="comment">// If we have</span>
<a name="l00178"></a>00178                 {
<a name="l00179"></a>00179                   <span class="comment">// Loop over variables</span>
<a name="l00180"></a>00180                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v = 0; v &lt; <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; v++)
<a name="l00181"></a>00181                     {                 
<a name="l00182"></a>00182                       <span class="comment">// Now fill in total_dual_error ErrorMap with the weight</span>
<a name="l00183"></a>00183                       (*total_dual_errors_per_cell[std::make_pair(&amp;_system, v)])[e] += 
<a name="l00184"></a>00184                         error_weight * (*dual_errors_per_cell[std::make_pair(&amp;_system, v)])[e];
<a name="l00185"></a>00185                     }     
<a name="l00186"></a>00186                 }
<a name="l00187"></a>00187               <span class="keywordflow">else</span> <span class="comment">// If not</span>
<a name="l00188"></a>00188               {
<a name="l00189"></a>00189                 total_dual_error_per_cell[e] += 
<a name="l00190"></a>00190                   error_weight * dual_error_per_cell[e];
<a name="l00191"></a>00191               }
<a name="l00192"></a>00192             }
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194     }
<a name="l00195"></a>00195   
<a name="l00196"></a>00196   <span class="comment">// Do some debugging plots if requested</span>
<a name="l00197"></a>00197   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a40755ebde43be4598a02b45e4f1196d4">error_plot_suffix</a>.empty())
<a name="l00198"></a>00198     {                  
<a name="l00199"></a>00199       <span class="keywordflow">if</span>(!error_norm_is_identity) <span class="comment">// If we have</span>
<a name="l00200"></a>00200         {
<a name="l00201"></a>00201           <span class="comment">// Loop over variables</span>
<a name="l00202"></a>00202           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v = 0; v &lt; <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; v++)
<a name="l00203"></a>00203             {
<a name="l00204"></a>00204               <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> primal_out;
<a name="l00205"></a>00205               <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> dual_out;
<a name="l00206"></a>00206               primal_out &lt;&lt; <span class="stringliteral">&quot;primal_&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a40755ebde43be4598a02b45e4f1196d4">error_plot_suffix</a> &lt;&lt; <span class="stringliteral">&quot;.&quot;</span>;
<a name="l00207"></a>00207               dual_out &lt;&lt; <span class="stringliteral">&quot;dual_&quot;</span> &lt;&lt; error_plot_suffix &lt;&lt; <span class="stringliteral">&quot;.&quot;</span>;
<a name="l00208"></a>00208               
<a name="l00209"></a>00209               OSSRealzeroright(primal_out, 1,0,v);            
<a name="l00210"></a>00210               OSSRealzeroright(dual_out, 1,0,v);              
<a name="l00211"></a>00211               (*primal_errors_per_cell[std::make_pair(&amp;_system, v)]).plot_error(primal_out.str(), _system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>());        
<a name="l00212"></a>00212               (*total_dual_errors_per_cell[std::make_pair(&amp;_system, v)]).plot_error(dual_out.str(), _system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>());           
<a name="l00213"></a>00213 
<a name="l00214"></a>00214               primal_out.clear();
<a name="l00215"></a>00215               dual_out.clear();
<a name="l00216"></a>00216             }
<a name="l00217"></a>00217         }
<a name="l00218"></a>00218       <span class="keywordflow">else</span> <span class="comment">// If not</span>
<a name="l00219"></a>00219         {
<a name="l00220"></a>00220           <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> primal_out;
<a name="l00221"></a>00221           <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> dual_out;
<a name="l00222"></a>00222           primal_out &lt;&lt; <span class="stringliteral">&quot;primal_&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a40755ebde43be4598a02b45e4f1196d4">error_plot_suffix</a> ;
<a name="l00223"></a>00223           dual_out &lt;&lt; <span class="stringliteral">&quot;dual_&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a40755ebde43be4598a02b45e4f1196d4">error_plot_suffix</a> ;
<a name="l00224"></a>00224 
<a name="l00225"></a>00225           primal_error_per_cell.<a class="code" href="classlibMesh_1_1ErrorVector.php#af42a70293b724817dd9c282642eb354c">plot_error</a>(primal_out.str(), _system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>());
<a name="l00226"></a>00226           total_dual_error_per_cell.<a class="code" href="classlibMesh_1_1ErrorVector.php#af42a70293b724817dd9c282642eb354c">plot_error</a>(dual_out.str(), _system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>());
<a name="l00227"></a>00227 
<a name="l00228"></a>00228           primal_out.clear();
<a name="l00229"></a>00229           dual_out.clear();
<a name="l00230"></a>00230         }
<a name="l00231"></a>00231     }
<a name="l00232"></a>00232     
<a name="l00233"></a>00233   <span class="comment">// Weight the primal error by the dual error using the system norm object</span>
<a name="l00234"></a>00234   <span class="comment">// FIXME: we ought to thread this</span>
<a name="l00235"></a>00235   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != error_per_cell.size(); ++i)
<a name="l00236"></a>00236     {
<a name="l00237"></a>00237       <span class="comment">// Have we been asked to weight the variable error contributions in any specific manner</span>
<a name="l00238"></a>00238       <span class="keywordflow">if</span>(!error_norm_is_identity) <span class="comment">// If we do</span>
<a name="l00239"></a>00239         {
<a name="l00240"></a>00240           <span class="comment">// Create Error Vectors to pass to calculate_norm</span>
<a name="l00241"></a>00241           std::vector&lt;Real&gt; cell_primal_error;
<a name="l00242"></a>00242           std::vector&lt;Real&gt; cell_dual_error;
<a name="l00243"></a>00243 
<a name="l00244"></a>00244           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v = 0; v &lt; <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; v++)
<a name="l00245"></a>00245             {                      
<a name="l00246"></a>00246               cell_primal_error.push_back((*primal_errors_per_cell[std::make_pair(&amp;_system, v)])[i]);
<a name="l00247"></a>00247               cell_dual_error.push_back((*total_dual_errors_per_cell[std::make_pair(&amp;_system, v)])[i]);             
<a name="l00248"></a>00248             }     
<a name="l00249"></a>00249                 
<a name="l00250"></a>00250           error_per_cell[i] = <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8afa822767f85f32acc11abba82ece3">calculate_norm</a>(cell_primal_error, cell_dual_error);
<a name="l00251"></a>00251         }
<a name="l00252"></a>00252       <span class="keywordflow">else</span> <span class="comment">// If not</span>
<a name="l00253"></a>00253         {
<a name="l00254"></a>00254           error_per_cell[i] = primal_error_per_cell[i]*total_dual_error_per_cell[i];
<a name="l00255"></a>00255         }
<a name="l00256"></a>00256     }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="comment">// Deallocate the ErrorMap contents if we allocated them earlier</span>
<a name="l00259"></a>00259   <span class="keywordflow">if</span> (!error_norm_is_identity)
<a name="l00260"></a>00260     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v = 0; v &lt; <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; v++)
<a name="l00261"></a>00261       {
<a name="l00262"></a>00262         <span class="keyword">delete</span> primal_errors_per_cell[std::make_pair(&amp;_system, v)];
<a name="l00263"></a>00263         <span class="keyword">delete</span> dual_errors_per_cell[std::make_pair(&amp;_system, v)];
<a name="l00264"></a>00264         <span class="keyword">delete</span> total_dual_errors_per_cell[std::make_pair(&amp;_system, v)];
<a name="l00265"></a>00265       }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   STOP_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;AdjointResidualErrorEstimator&quot;</span>);
<a name="l00268"></a>00268 }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
