<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3734f8fafd73a2969ee8ed4a34620869.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">adjoint_residual_error_estimator.h</div>  </div>
</div>
<div class="contents">
<a href="adjoint__residual__error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: adjoint_residual_error_estimator.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __adjoint_residual_error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __adjoint_residual_error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="qoi__set_8h.php">qoi_set.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>libMesh
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php">00055</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php">AdjointResidualErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php">ErrorEstimator</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a6a0f8337eae9e8c156680441d2840c24">AdjointResidualErrorEstimator</a>();
<a name="l00063"></a>00063   
<a name="l00067"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ace30bc17e231716cc337b408e2741a70">00067</a>   <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ace30bc17e231716cc337b408e2741a70">~AdjointResidualErrorEstimator</a>() {}
<a name="l00068"></a>00068 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ade92ddfd4436754820fac65c55487099">00073</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;ErrorEstimator&gt;</a> &amp;<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ade92ddfd4436754820fac65c55487099">primal_error_estimator</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a0dc159e5896539cdfbab4448ef2c6de6">_primal_error_estimator</a>; }
<a name="l00074"></a>00074   
<a name="l00079"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a8f0770e9e23feaef8cd3b5836d53e46b">00079</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;ErrorEstimator&gt;</a> &amp;<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a8f0770e9e23feaef8cd3b5836d53e46b">dual_error_estimator</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ad8e104593004e8243489c129ea12afd0">_dual_error_estimator</a>; }
<a name="l00080"></a>00080   
<a name="l00085"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4b1d0230d7ba9bfc8850ffa76c01e4a1">00085</a>   <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;<a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4b1d0230d7ba9bfc8850ffa76c01e4a1">qoi_set</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4d04cafa87de4f7aa6ad7bac316a7a39">_qoi_set</a>; }
<a name="l00086"></a>00086   
<a name="l00092"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a6c0a22af027cd007714750c7c4216791">00092</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a6c0a22af027cd007714750c7c4216791">adjoint_already_solved</a>;
<a name="l00093"></a>00093 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a40755ebde43be4598a02b45e4f1196d4">00101</a>   std::string <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a40755ebde43be4598a02b45e4f1196d4">error_plot_suffix</a>;
<a name="l00102"></a>00102 
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a3be60bea58f364ffa0aed5351ce23361">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00112"></a>00112                        <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00113"></a>00113                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00114"></a>00114                        <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00115"></a>00115   
<a name="l00116"></a>00116 <span class="keyword">protected</span>:
<a name="l00117"></a>00117 
<a name="l00121"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a0dc159e5896539cdfbab4448ef2c6de6">00121</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;ErrorEstimator&gt;</a> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a0dc159e5896539cdfbab4448ef2c6de6">_primal_error_estimator</a>;
<a name="l00122"></a>00122 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ad8e104593004e8243489c129ea12afd0">00126</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;ErrorEstimator&gt;</a> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#ad8e104593004e8243489c129ea12afd0">_dual_error_estimator</a>;
<a name="l00127"></a>00127 
<a name="l00131"></a><a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4d04cafa87de4f7aa6ad7bac316a7a39">00131</a>   <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> <a class="code" href="classlibMesh_1_1AdjointResidualErrorEstimator.php#a4d04cafa87de4f7aa6ad7bac316a7a39">_qoi_set</a>;
<a name="l00132"></a>00132 };
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 } <span class="comment">// namespace libMesh</span>
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="preprocessor">#endif //__adjoint_residual_error_estimator_h__</span>
<a name="l00138"></a>00138 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
