<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">analytic_function.C</div>  </div>
</div>
<div class="contents">
<a href="analytic__function_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: analytic_function.C 4123 2010-12-01 15:55:07Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="analytic__function_8h.php">analytic_function.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">namespace </span>libMesh
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// AnalyticFunction methods</span>
<a name="l00035"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php#a515d8028c70f165872c535fa9d64af03">00035</a> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a515d8028c70f165872c535fa9d64af03">AnalyticFunction::AnalyticFunction</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00036"></a>00036                                                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time)) :
<a name="l00037"></a>00037   <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a> (),
<a name="l00038"></a>00038   _number_fptr (fptr)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   libmesh_assert (fptr != NULL);
<a name="l00041"></a>00041   this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">_initialized</a> = <span class="keyword">true</span>;
<a name="l00042"></a>00042 }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php#adc7f45fd274975595a13693b0848defb">00047</a> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a515d8028c70f165872c535fa9d64af03">AnalyticFunction::AnalyticFunction</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output,
<a name="l00048"></a>00048                                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00049"></a>00049                                               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time)) :
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a> (),
<a name="l00051"></a>00051   _vector_fptr (fptr)
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   libmesh_assert (fptr != NULL);
<a name="l00054"></a>00054   this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">_initialized</a> = <span class="keyword">true</span>;
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php#ad69466447f882eee9865f24d0e0c1397">00060</a> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#ad69466447f882eee9865f24d0e0c1397">AnalyticFunction::~AnalyticFunction</a> ()
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php#a46168a4cdb302a266e65c1dab55054f7">00068</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a46168a4cdb302a266e65c1dab55054f7">AnalyticFunction::init</a> ()
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   <span class="comment">// dumb double-test</span>
<a name="l00071"></a>00071   libmesh_assert ((<a class="code" href="classlibMesh_1_1AnalyticFunction.php#aa431b45a74b9f5e1612c233fb1d047df">_number_fptr</a> != NULL) || (<a class="code" href="classlibMesh_1_1AnalyticFunction.php#a42b9e94730ef46e38539287abe3116f0">_vector_fptr</a> != NULL));
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// definitely ready</span>
<a name="l00074"></a>00074   this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">_initialized</a> = <span class="keyword">true</span>;
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php#aa5a80c940936cbc7e2064ee77015f8ec">00079</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#aa5a80c940936cbc7e2064ee77015f8ec">AnalyticFunction::clear</a> ()
<a name="l00080"></a>00080 {
<a name="l00081"></a>00081   <span class="comment">// We probably need a method to reset these later...</span>
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1AnalyticFunction.php#aa431b45a74b9f5e1612c233fb1d047df">_number_fptr</a> = NULL;
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a42b9e94730ef46e38539287abe3116f0">_vector_fptr</a> = NULL;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// definitely not ready</span>
<a name="l00086"></a>00086   this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">_initialized</a> = <span class="keyword">false</span>;
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
