<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">analytic_function.h</div>  </div>
</div>
<div class="contents">
<a href="analytic__function_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: analytic_function.h 4123 2010-12-01 15:55:07Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __analytic_function_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __analytic_function_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="function__base_8h.php">function_base.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00038"></a>00038 <span class="keyword">class </span>DenseVector;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// AnalyticFunction class definition</span>
<a name="l00051"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php">00051</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1AnalyticFunction.php">AnalyticFunction</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00054"></a>00054 
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a515d8028c70f165872c535fa9d64af03">AnalyticFunction</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00060"></a>00060                                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time));
<a name="l00061"></a>00061 
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a515d8028c70f165872c535fa9d64af03">AnalyticFunction</a> (<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output,
<a name="l00067"></a>00067                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00068"></a>00068                               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time));
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1AnalyticFunction.php#ad69466447f882eee9865f24d0e0c1397">~AnalyticFunction</a> ();
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php#aa431b45a74b9f5e1612c233fb1d047df">00080</a>   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> (* <a class="code" href="classlibMesh_1_1AnalyticFunction.php#aa431b45a74b9f5e1612c233fb1d047df">_number_fptr</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00081"></a>00081                            <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time);
<a name="l00082"></a>00082 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php#a42b9e94730ef46e38539287abe3116f0">00086</a>   void (* <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a42b9e94730ef46e38539287abe3116f0">_vector_fptr</a>) (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output,
<a name="l00087"></a>00087                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00088"></a>00088                          <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time);
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a46168a4cdb302a266e65c1dab55054f7">init</a> ();
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#aa5a80c940936cbc7e2064ee77015f8ec">clear</a> ();
<a name="l00099"></a>00099 
<a name="l00104"></a>00104   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a1b418476d88ece7a352a56867e37f380">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, 
<a name="l00105"></a>00105                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time=0.);
<a name="l00106"></a>00106 
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a1b418476d88ece7a352a56867e37f380">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00112"></a>00112                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time,
<a name="l00113"></a>00113                    <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 };
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00120"></a>00120 <span class="comment">// AnalyticFunction inline methods</span>
<a name="l00121"></a>00121 <span class="keyword">inline</span>
<a name="l00122"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php#a1b418476d88ece7a352a56867e37f380">00122</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a1b418476d88ece7a352a56867e37f380">AnalyticFunction::operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, 
<a name="l00123"></a>00123                                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time)
<a name="l00124"></a>00124 {
<a name="l00125"></a>00125   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00126"></a>00126   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classlibMesh_1_1AnalyticFunction.php#aa431b45a74b9f5e1612c233fb1d047df">_number_fptr</a>(p, time));
<a name="l00127"></a>00127 }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="keyword">inline</span>
<a name="l00132"></a><a class="code" href="classlibMesh_1_1AnalyticFunction.php#a9a937175a25043c0c305c419bca846ea">00132</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1AnalyticFunction.php#a1b418476d88ece7a352a56867e37f380">AnalyticFunction::operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00133"></a>00133                                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time,
<a name="l00134"></a>00134                                    <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output)
<a name="l00135"></a>00135 {
<a name="l00136"></a>00136   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00137"></a>00137   this-&gt;<a class="code" href="classlibMesh_1_1AnalyticFunction.php#a42b9e94730ef46e38539287abe3116f0">_vector_fptr</a>(output, p, time);
<a name="l00138"></a>00138   <span class="keywordflow">return</span>;
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 } <span class="comment">// namespace libMesh</span>
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="preprocessor">#endif</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
