<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">auto_ptr.h</div>  </div>
</div>
<div class="contents">
<a href="auto__ptr_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: auto_ptr.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// Copyright (C) 2001, 2002 Free Software Foundation, Inc.</span>
<a name="l00004"></a>00004 <span class="comment">//</span>
<a name="l00005"></a>00005 <span class="comment">// This file is part of the GNU ISO C++ Library.  This library is free</span>
<a name="l00006"></a>00006 <span class="comment">// software; you can redistribute it and/or modify it under the</span>
<a name="l00007"></a>00007 <span class="comment">// terms of the GNU General Public License as published by the</span>
<a name="l00008"></a>00008 <span class="comment">// Free Software Foundation; either version 2, or (at your option)</span>
<a name="l00009"></a>00009 <span class="comment">// any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the</span>
<a name="l00014"></a>00014 <span class="comment">// GNU General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU General Public License along</span>
<a name="l00017"></a>00017 <span class="comment">// with this library; see the file COPYING.  If not, write to the Free</span>
<a name="l00018"></a>00018 <span class="comment">// Software Foundation, 59 Temple Place - Suite 330, Boston, MA 02111-1307,</span>
<a name="l00019"></a>00019 <span class="comment">// USA.</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// As a special exception, you may use this file as part of a free software</span>
<a name="l00022"></a>00022 <span class="comment">// library without restriction.  Specifically, if other files instantiate</span>
<a name="l00023"></a>00023 <span class="comment">// templates or use macros or inline functions from this file, or you compile</span>
<a name="l00024"></a>00024 <span class="comment">// this file and link it with other files to produce an executable, this</span>
<a name="l00025"></a>00025 <span class="comment">// file does not by itself cause the resulting executable to be covered by</span>
<a name="l00026"></a>00026 <span class="comment">// the GNU General Public License.  This exception does not however</span>
<a name="l00027"></a>00027 <span class="comment">// invalidate any other reasons why the executable file might be covered by</span>
<a name="l00028"></a>00028 <span class="comment">// the GNU General Public License.</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">/*</span>
<a name="l00031"></a>00031 <span class="comment"> * Copyright (c) 1997-1999</span>
<a name="l00032"></a>00032 <span class="comment"> * Silicon Graphics Computer Systems, Inc.</span>
<a name="l00033"></a>00033 <span class="comment"> *</span>
<a name="l00034"></a>00034 <span class="comment"> * Permission to use, copy, modify, distribute and sell this software</span>
<a name="l00035"></a>00035 <span class="comment"> * and its documentation for any purpose is hereby granted without fee,</span>
<a name="l00036"></a>00036 <span class="comment"> * provided that the above copyright notice appear in all copies and</span>
<a name="l00037"></a>00037 <span class="comment"> * that both that copyright notice and this permission notice appear</span>
<a name="l00038"></a>00038 <span class="comment"> * in supporting documentation.  Silicon Graphics makes no</span>
<a name="l00039"></a>00039 <span class="comment"> * representations about the suitability of this software for any</span>
<a name="l00040"></a>00040 <span class="comment"> * purpose.  It is provided &quot;as is&quot; without express or implied warranty.</span>
<a name="l00041"></a>00041 <span class="comment"> *</span>
<a name="l00042"></a>00042 <span class="comment"> */</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="preprocessor">#ifndef __auto_ptr_h__</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span><span class="preprocessor">#define __auto_ptr_h__</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00049"></a>00049 <span class="keyword">namespace </span>libMesh
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00059"></a>00059 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00060"></a><a class="code" href="structlibMesh_1_1AutoPtrRef.php">00060</a> <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1AutoPtrRef.php">AutoPtrRef</a>
<a name="l00061"></a>00061 {
<a name="l00065"></a><a class="code" href="structlibMesh_1_1AutoPtrRef.php#a2dd0d6ddfa16ed4e62ed8bd21c1ac087">00065</a>   Tp1* <a class="code" href="structlibMesh_1_1AutoPtrRef.php#a2dd0d6ddfa16ed4e62ed8bd21c1ac087">_ptr</a>;
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <span class="keyword">explicit</span>
<a name="l00071"></a><a class="code" href="structlibMesh_1_1AutoPtrRef.php#af555453b59550ffb772fabeb7aeb8d11">00071</a>   <a class="code" href="structlibMesh_1_1AutoPtrRef.php#af555453b59550ffb772fabeb7aeb8d11">AutoPtrRef</a>(Tp1* p)
<a name="l00072"></a>00072     : <a class="code" href="structlibMesh_1_1AutoPtrRef.php#a2dd0d6ddfa16ed4e62ed8bd21c1ac087">_ptr</a>(p) {}
<a name="l00073"></a>00073 };
<a name="l00074"></a>00074   
<a name="l00075"></a>00075   
<a name="l00103"></a>00103 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp&gt;
<a name="l00104"></a><a class="code" href="classlibMesh_1_1AutoPtr.php">00104</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106 <span class="keyword">private</span>:
<a name="l00107"></a>00107 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">00111</a>   Tp* <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>;
<a name="l00112"></a>00112     
<a name="l00113"></a>00113 <span class="keyword">public</span>:
<a name="l00117"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#af7d6809e6bdb84d790ad2ef11afe3fa6">00117</a>   <span class="keyword">typedef</span> Tp <a class="code" href="classlibMesh_1_1AutoPtr.php#af7d6809e6bdb84d790ad2ef11afe3fa6">element_type</a>;
<a name="l00118"></a>00118     
<a name="l00125"></a>00125   <span class="keyword">explicit</span>
<a name="l00126"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a6e5b3ce1fc0f9d76bb6b55e79342910c">00126</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#a6e5b3ce1fc0f9d76bb6b55e79342910c" title="An AutoPtr is usually constructed from a raw pointer.">AutoPtr</a>(<a class="code" href="classlibMesh_1_1LinearSolver.php">element_type</a>* p = 0) 
<a name="l00127"></a>00127     : <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>(p) {}
<a name="l00128"></a>00128 
<a name="l00136"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a29ea7c5bc4f7cd137cf52a14ea88de52">00136</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#a6e5b3ce1fc0f9d76bb6b55e79342910c" title="An AutoPtr is usually constructed from a raw pointer.">AutoPtr</a>(<a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp; a) 
<a name="l00137"></a>00137     : <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>(a.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>()) {}
<a name="l00138"></a>00138 
<a name="l00148"></a>00148   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00149"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a52e57ccdf65c08397b90f2041b8494b4">00149</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#a6e5b3ce1fc0f9d76bb6b55e79342910c" title="An AutoPtr is usually constructed from a raw pointer.">AutoPtr</a>(<a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Tp1&gt;</a>&amp; a) 
<a name="l00150"></a>00150     : <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>(a.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>()) {}
<a name="l00151"></a>00151 
<a name="l00160"></a>00160   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp;
<a name="l00161"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#ae1b5eb5ed5b453121b0a6db973ff9d72">00161</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#ae1b5eb5ed5b453121b0a6db973ff9d72" title="AutoPtr assignment operator.">operator=</a>(<a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp; a) 
<a name="l00162"></a>00162   {
<a name="l00163"></a>00163     <a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(a.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>());
<a name="l00164"></a>00164     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00165"></a>00165   }
<a name="l00166"></a>00166     
<a name="l00177"></a>00177   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00178"></a>00178   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp;
<a name="l00179"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#adb982f58581bc97b2c9a925771201023">00179</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#ae1b5eb5ed5b453121b0a6db973ff9d72" title="AutoPtr assignment operator.">operator=</a>(<a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Tp1&gt;</a>&amp; a) 
<a name="l00180"></a>00180   {
<a name="l00181"></a>00181     <a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(a.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>());
<a name="l00182"></a>00182     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00183"></a>00183   }
<a name="l00184"></a>00184 
<a name="l00197"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a6c0e9fbbfdd93f5dd0b1a2c580d36202">00197</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#a6c0e9fbbfdd93f5dd0b1a2c580d36202">~AutoPtr</a>() { <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>; }
<a name="l00198"></a>00198     
<a name="l00207"></a>00207   <a class="code" href="classlibMesh_1_1AutoPtr.php#af7d6809e6bdb84d790ad2ef11afe3fa6">element_type</a>&amp;
<a name="l00208"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a280cc923315c8202a9d1b5613157a58e">00208</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#a280cc923315c8202a9d1b5613157a58e" title="Smart pointer dereferencing.">operator*</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>; }
<a name="l00209"></a>00209     
<a name="l00216"></a>00216   <a class="code" href="classlibMesh_1_1AutoPtr.php#af7d6809e6bdb84d790ad2ef11afe3fa6">element_type</a>*
<a name="l00217"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a05a072981e5044e4d87143a5b5841c5a">00217</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#a05a072981e5044e4d87143a5b5841c5a" title="Smart pointer dereferencing.">operator-&gt;</a>()<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>; }
<a name="l00218"></a>00218     
<a name="l00229"></a>00229   <a class="code" href="classlibMesh_1_1AutoPtr.php#af7d6809e6bdb84d790ad2ef11afe3fa6">element_type</a>*
<a name="l00230"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd">00230</a>   <span class="keyword">get</span>() <span class="keyword">const</span>  { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>; }
<a name="l00231"></a>00231     
<a name="l00243"></a>00243   <a class="code" href="classlibMesh_1_1AutoPtr.php#af7d6809e6bdb84d790ad2ef11afe3fa6">element_type</a>*
<a name="l00244"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526">00244</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>() 
<a name="l00245"></a>00245   {
<a name="l00246"></a>00246     <a class="code" href="classlibMesh_1_1LinearSolver.php">element_type</a>* tmp = <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>;
<a name="l00247"></a>00247     <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a> = 0;
<a name="l00248"></a>00248     <span class="keywordflow">return</span> tmp;
<a name="l00249"></a>00249   }
<a name="l00250"></a>00250     
<a name="l00258"></a>00258   <span class="keywordtype">void</span>
<a name="l00259"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c">00259</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(<a class="code" href="classlibMesh_1_1LinearSolver.php">element_type</a>* p = 0) 
<a name="l00260"></a>00260   {
<a name="l00261"></a>00261     <span class="keywordflow">if</span> (p != <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>)
<a name="l00262"></a>00262       {
<a name="l00263"></a>00263         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>;
<a name="l00264"></a>00264         <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a> = p;
<a name="l00265"></a>00265       }
<a name="l00266"></a>00266   }
<a name="l00267"></a>00267     
<a name="l00279"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#ac87f7a29cee79240f59b9fe132212640">00279</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#a6e5b3ce1fc0f9d76bb6b55e79342910c" title="An AutoPtr is usually constructed from a raw pointer.">AutoPtr</a>(<a class="code" href="structlibMesh_1_1AutoPtrRef.php">AutoPtrRef&lt;element_type&gt;</a> ref) 
<a name="l00280"></a>00280     : <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>(ref.<a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>) {}
<a name="l00281"></a>00281 
<a name="l00288"></a>00288   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr</a>&amp;
<a name="l00289"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#abc2d725cb78d2dafc1e80d847d62c487">00289</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#ae1b5eb5ed5b453121b0a6db973ff9d72" title="AutoPtr assignment operator.">operator=</a>(<a class="code" href="structlibMesh_1_1AutoPtrRef.php">AutoPtrRef&lt;element_type&gt;</a> ref) 
<a name="l00290"></a>00290   {
<a name="l00291"></a>00291     <span class="keywordflow">if</span> (ref.<a class="code" href="structlibMesh_1_1AutoPtrRef.php#a2dd0d6ddfa16ed4e62ed8bd21c1ac087">_ptr</a> != this-&gt;get())
<a name="l00292"></a>00292       {
<a name="l00293"></a>00293         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a>;
<a name="l00294"></a>00294         <a class="code" href="classlibMesh_1_1AutoPtr.php#a7e8340fb4f4326ce8496a49f52980374">_ptr</a> = ref.<a class="code" href="structlibMesh_1_1AutoPtrRef.php#a2dd0d6ddfa16ed4e62ed8bd21c1ac087">_ptr</a>;
<a name="l00295"></a>00295       }
<a name="l00296"></a>00296     <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00297"></a>00297   }
<a name="l00298"></a>00298 
<a name="l00302"></a>00302   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00303"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#ae6a23f73fc4f9ec7754b9d8d43989fb1">00303</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#ae6a23f73fc4f9ec7754b9d8d43989fb1">operator AutoPtrRef&lt;Tp1&gt;</a>() 
<a name="l00304"></a>00304   { <span class="keywordflow">return</span> <a class="code" href="structlibMesh_1_1AutoPtrRef.php">AutoPtrRef&lt;Tp1&gt;</a>(this-&gt;<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>()); }
<a name="l00305"></a>00305     
<a name="l00309"></a>00309   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> Tp1&gt;
<a name="l00310"></a><a class="code" href="classlibMesh_1_1AutoPtr.php#a6c1439aaec8f295f529f73da595b5718">00310</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php#a6c1439aaec8f295f529f73da595b5718">operator AutoPtr&lt;Tp1&gt;</a>() 
<a name="l00311"></a>00311   { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Tp1&gt;</a>(this-&gt;<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>()); }
<a name="l00312"></a>00312 };
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 } <span class="comment">// namespace libMesh</span>
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="preprocessor">#endif </span><span class="comment">/* __auto_ptr_h__ */</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
