<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">boundary_info.C</div>  </div>
</div>
<div class="contents">
<a href="boundary__info_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: boundary_info.C 4356 2011-04-15 15:28:29Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="boundary__mesh_8h.php">boundary_mesh.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__data_8h.php">mesh_data.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="partitioner_8h.php">partitioner.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// BoundaryInfo static member initializations</span>
<a name="l00041"></a>00041 <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">BoundaryInfo::invalid_id</a> = -1234;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">//------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// BoundaryInfo functions</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a976732d8ddbc295d7afd3edd689d6023">00047</a> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a976732d8ddbc295d7afd3edd689d6023">BoundaryInfo::BoundaryInfo</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m) :
<a name="l00048"></a>00048   _mesh (m)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#ac88f924025e8370238570582982dfbad">00052</a> <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>&amp; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ac88f924025e8370238570582982dfbad">BoundaryInfo::operator=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>&amp; other_boundary_info)
<a name="l00053"></a>00053 {
<a name="l00060"></a>00060   {
<a name="l00061"></a>00061     std::multimap&lt;const Node*, short int&gt;::const_iterator it = other_boundary_info.<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.begin();
<a name="l00062"></a>00062     <span class="keyword">const</span> std::multimap&lt;const Node*, short int&gt;::const_iterator end = other_boundary_info.<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.end();
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keywordflow">for</span>(; it != end; ++it)
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a> * other_node = it-&gt;first;
<a name="l00067"></a>00067       <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.insert( std::pair&lt;const Node*, short int&gt;(<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(other_node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()), it-&gt;second) );
<a name="l00068"></a>00068     }
<a name="l00069"></a>00069   }
<a name="l00070"></a>00070   
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   {
<a name="l00073"></a>00073     std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator it = other_boundary_info.<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.begin();
<a name="l00074"></a>00074     <span class="keyword">const</span> std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator end = other_boundary_info.<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.end();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keywordflow">for</span>(; it != end; ++it)
<a name="l00077"></a>00077     {
<a name="l00078"></a>00078       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * other_elem = it-&gt;first;
<a name="l00079"></a>00079       <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.insert( std::pair&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*, std::pair&lt;unsigned short int, short int&gt; &gt;(<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(other_elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()), it-&gt;second) );
<a name="l00080"></a>00080     }
<a name="l00081"></a>00081   }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a> = other_boundary_info.<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a94131726fa74bd596d6e6d1bb3fcfacc">00089</a> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a94131726fa74bd596d6e6d1bb3fcfacc">BoundaryInfo::~BoundaryInfo</a>()
<a name="l00090"></a>00090 {
<a name="l00091"></a>00091   this-&gt;<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a824b4cd550177ac7d30db57e545699ea">clear</a>();
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a824b4cd550177ac7d30db57e545699ea">00096</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a824b4cd550177ac7d30db57e545699ea">BoundaryInfo::clear</a>()
<a name="l00097"></a>00097 {
<a name="l00098"></a>00098   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.clear();
<a name="l00099"></a>00099   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.clear();
<a name="l00100"></a>00100   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>.clear();
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a2b56eacc15f8e6172a0589eabde6e1ff">00105</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a2b56eacc15f8e6172a0589eabde6e1ff">BoundaryInfo::sync</a> (<a class="code" href="classlibMesh_1_1BoundaryMesh.php">BoundaryMesh</a>&amp; boundary_mesh,
<a name="l00106"></a>00106                          <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>*     boundary_mesh_data,
<a name="l00107"></a>00107                          <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>*     this_mesh_data)
<a name="l00108"></a>00108 {
<a name="l00109"></a>00109   boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">clear</a>();
<a name="l00110"></a>00110 
<a name="l00115"></a>00115   <span class="comment">// Map boundary ids to side subdomain/partition ids</span>
<a name="l00116"></a>00116   std::map&lt;short int, unsigned int&gt; id_map;
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">// Original Code</span>
<a name="l00119"></a>00119   <span class="comment">//     unsigned int cnt = 0;</span>
<a name="l00120"></a>00120   <span class="comment">//     for (std::set&lt;short int&gt;::iterator pos = boundary_ids.begin();</span>
<a name="l00121"></a>00121   <span class="comment">//     pos != boundary_ids.end(); ++pos)</span>
<a name="l00122"></a>00122   <span class="comment">//       id_map[*pos] = cnt++;</span>
<a name="l00123"></a>00123   
<a name="l00124"></a>00124   <span class="comment">//     id_map[invalid_id] = cnt;</span>
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     
<a name="l00127"></a>00127   <span class="comment">// New code</span>
<a name="l00128"></a>00128   <span class="comment">// Here we need to use iota() once it is in the</span>
<a name="l00129"></a>00129   <span class="comment">// Utility namespace.</span>
<a name="l00130"></a>00130   std::for_each(<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>.begin(),
<a name="l00131"></a>00131                 <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>.end(),
<a name="l00132"></a>00132                 <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php">Fill</a>(id_map));
<a name="l00133"></a>00133     
<a name="l00134"></a>00134   boundary_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa1d4be6015417d17b41780fbcf5472a2">set_n_partitions</a>() = id_map.size();
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// Make individual copies of all the nodes in the current mesh</span>
<a name="l00138"></a>00138   <span class="comment">// and add them to the boundary mesh.  Yes, this is overkill because</span>
<a name="l00139"></a>00139   <span class="comment">// all of the current mesh nodes will not end up in the the boundary</span>
<a name="l00140"></a>00140   <span class="comment">// mesh.  These nodes can be trimmed later via a call to prepare_for_use().</span>
<a name="l00141"></a>00141   {
<a name="l00142"></a>00142     libmesh_assert (boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == 0);
<a name="l00143"></a>00143     boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a3bc142900cfe869d278d58ca69def123">reserve_nodes</a>(<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00144"></a>00144     
<a name="l00145"></a>00145     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> it  = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00146"></a>00146     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00147"></a>00147     
<a name="l00148"></a>00148     <span class="keywordflow">for</span>(; it != end; ++it)
<a name="l00149"></a>00149       {
<a name="l00150"></a>00150         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = *it;
<a name="l00151"></a>00151         boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">add_point</a>(*node); <span class="comment">// calls Node::build(Point, id)</span>
<a name="l00152"></a>00152       }
<a name="l00153"></a>00153   }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="comment">// Add additional sides that aren&#39;t flagged with boundary conditions</span>
<a name="l00156"></a>00156   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00157"></a>00157   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00160"></a>00160     {
<a name="l00161"></a>00161       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00162"></a>00162       
<a name="l00163"></a>00163       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00164"></a>00164         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL) <span class="comment">// on the boundary</span>
<a name="l00165"></a>00165           {
<a name="l00166"></a>00166 
<a name="l00167"></a>00167             <span class="comment">// Build the side - do not use a &quot;proxy&quot; element here:</span>
<a name="l00168"></a>00168             <span class="comment">// This will be going into the BoundaryMesh and needs to</span>
<a name="l00169"></a>00169             <span class="comment">// stand on its own.</span>
<a name="l00170"></a>00170             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s, <span class="keyword">false</span>));
<a name="l00171"></a>00171             
<a name="l00172"></a>00172             <span class="comment">// Get the top-level parent for this element</span>
<a name="l00173"></a>00173             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* top_parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">top_parent</a>();
<a name="l00174"></a>00174 
<a name="l00175"></a>00175             <span class="comment">// A convenient typedef</span>
<a name="l00176"></a>00176             <span class="keyword">typedef</span>
<a name="l00177"></a>00177               std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator
<a name="l00178"></a>00178               Iter;
<a name="l00179"></a>00179               
<a name="l00180"></a>00180             <span class="comment">// Find the right id number for that side</span>
<a name="l00181"></a>00181             std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(top_parent);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183             <span class="keywordflow">while</span> (pos.first != pos.second)
<a name="l00184"></a>00184               {
<a name="l00185"></a>00185                 <span class="keywordflow">if</span> (pos.first-&gt;second.first == s) <span class="comment">// already flagged with a boundary condition</span>
<a name="l00186"></a>00186                   {
<a name="l00187"></a>00187                     <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;subdomain_id() =
<a name="l00188"></a>00188                       id_map[pos.first-&gt;second.second];
<a name="l00189"></a>00189                     <span class="keywordflow">break</span>;
<a name="l00190"></a>00190                   }
<a name="l00191"></a>00191                 
<a name="l00192"></a>00192                 ++pos.first;
<a name="l00193"></a>00193               }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195             <span class="comment">// either the element wasn&#39;t found or side s</span>
<a name="l00196"></a>00196             <span class="comment">// doesn&#39;t have a boundary condition</span>
<a name="l00197"></a>00197             <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l00198"></a>00198               {
<a name="l00199"></a>00199                 <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;subdomain_id() = id_map[<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a>];
<a name="l00200"></a>00200               }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202             <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;processor_id() = <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;subdomain_id(); <span class="comment">//elem-&gt;processor_id();</span>
<a name="l00203"></a>00203             
<a name="l00204"></a>00204             <span class="comment">// Add the side</span>
<a name="l00205"></a>00205             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* new_elem = boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ad230cc153170488ad92ab4f6ee2146c7">add_elem</a>(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>.release());
<a name="l00206"></a>00206 
<a name="l00207"></a>00207             <span class="comment">// This side&#39;s Node pointers still point to the nodes of the  original mesh.</span>
<a name="l00208"></a>00208             <span class="comment">// We need to re-point them to the boundary mesh&#39;s nodes!  Since we copied *ALL* of</span>
<a name="l00209"></a>00209             <span class="comment">// the original mesh&#39;s nodes over, we should be guaranteed to have the same ordering.</span>
<a name="l00210"></a>00210             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn=0; nn&lt;new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++nn)
<a name="l00211"></a>00211               {
<a name="l00212"></a>00212                 <span class="comment">// Get the correct node pointer, based on the id()</span>
<a name="l00213"></a>00213                 <a class="code" href="classlibMesh_1_1Node.php">Node</a>* new_node = boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a>(new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(nn));
<a name="l00214"></a>00214                 
<a name="l00215"></a>00215                 <span class="comment">// sanity check: be sure that the new Nodes global id really matches</span>
<a name="l00216"></a>00216                 libmesh_assert (new_node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(nn));
<a name="l00217"></a>00217 
<a name="l00218"></a>00218                 <span class="comment">// Assign the new node pointer</span>
<a name="l00219"></a>00219                 new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(nn) = new_node;
<a name="l00220"></a>00220               }
<a name="l00221"></a>00221           }
<a name="l00222"></a>00222     } <span class="comment">// end loop over active elements</span>
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   <span class="comment">// When desired, copy the MeshData</span>
<a name="l00227"></a>00227   <span class="comment">// to the boundary_mesh</span>
<a name="l00228"></a>00228   <span class="keywordflow">if</span> ((boundary_mesh_data != NULL) &amp;&amp; (this_mesh_data != NULL))
<a name="l00229"></a>00229     boundary_mesh_data-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a3cfeb42a2a552b7ccca99766bdc95f91">assign</a>(*this_mesh_data);
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <span class="comment">// Don&#39;t repartition this mesh; we&#39;re using the processor_id values</span>
<a name="l00232"></a>00232   <span class="comment">// as a hack to display bcids for now.</span>
<a name="l00233"></a>00233   boundary_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa07a00e86d68f366d8fe7e4d01140ffc">partitioner</a>().<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(NULL);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="comment">// Trim any un-used nodes from the Mesh</span>
<a name="l00236"></a>00236   boundary_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a>(<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);
<a name="l00237"></a>00237 }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240                          
<a name="l00241"></a>00241 
<a name="l00242"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad12fbdbaa21f85c72cc2899baf3a6278">00242</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a2b56eacc15f8e6172a0589eabde6e1ff">BoundaryInfo::sync</a> (<span class="keyword">const</span> std::set&lt;short int&gt; &amp;requested_boundary_ids,
<a name="l00243"></a>00243                          <a class="code" href="classlibMesh_1_1BoundaryMesh.php">BoundaryMesh</a>&amp; boundary_mesh)
<a name="l00244"></a>00244 {
<a name="l00245"></a>00245   <span class="comment">// Re-create the boundary mesh.</span>
<a name="l00246"></a>00246   boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">clear</a>();
<a name="l00247"></a>00247     
<a name="l00248"></a>00248   boundary_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa1d4be6015417d17b41780fbcf5472a2">set_n_partitions</a>() = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a716b4df3429a6b2a1d5386691dabe2ae">n_partitions</a>();
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">// Make individual copies of all the nodes in the current mesh</span>
<a name="l00251"></a>00251   <span class="comment">// and add them to the boundary mesh.  Yes, this is overkill because</span>
<a name="l00252"></a>00252   <span class="comment">// all of the current mesh nodes will not end up in the the boundary</span>
<a name="l00253"></a>00253   <span class="comment">// mesh.  These nodes can be trimmed later via a call to prepare_for_use().</span>
<a name="l00254"></a>00254   {
<a name="l00255"></a>00255     libmesh_assert (boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == 0);
<a name="l00256"></a>00256     boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a3bc142900cfe869d278d58ca69def123">reserve_nodes</a>(<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00257"></a>00257     
<a name="l00258"></a>00258     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> it  = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00259"></a>00259     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> end = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00260"></a>00260     
<a name="l00261"></a>00261     <span class="keywordflow">for</span>(; it != end; ++it)
<a name="l00262"></a>00262       {
<a name="l00263"></a>00263         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = *it;
<a name="l00264"></a>00264         boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">add_point</a>(*node); <span class="comment">// calls Node::build(Point, id)</span>
<a name="l00265"></a>00265       }
<a name="l00266"></a>00266   }
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <span class="comment">// Add additional sides that aren&#39;t flagged with boundary conditions</span>
<a name="l00269"></a>00269   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00270"></a>00270   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00273"></a>00273     {
<a name="l00274"></a>00274       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00275"></a>00275       
<a name="l00276"></a>00276       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00277"></a>00277         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL) <span class="comment">// on the boundary</span>
<a name="l00278"></a>00278           {
<a name="l00279"></a>00279             <span class="comment">// Get the top-level parent for this element</span>
<a name="l00280"></a>00280             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* top_parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">top_parent</a>();
<a name="l00281"></a>00281 
<a name="l00282"></a>00282             <span class="comment">// A convenient typedef</span>
<a name="l00283"></a>00283             <span class="keyword">typedef</span>
<a name="l00284"></a>00284               std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator
<a name="l00285"></a>00285               Iter;
<a name="l00286"></a>00286               
<a name="l00287"></a>00287             <span class="comment">// Find all the bcs asociated with top_parent</span>
<a name="l00288"></a>00288             std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(top_parent);
<a name="l00289"></a>00289 
<a name="l00290"></a>00290             <span class="comment">// look for a bcid which is (i) in the user-requested set, and</span>
<a name="l00291"></a>00291             <span class="comment">// (ii) matches the current side #s</span>
<a name="l00292"></a>00292             <span class="keywordflow">while</span> (pos.first != pos.second)
<a name="l00293"></a>00293               {
<a name="l00294"></a>00294                 <span class="comment">// if this side is flagged with a boundary condition</span>
<a name="l00295"></a>00295                 <span class="comment">// and the user wants this id</span>
<a name="l00296"></a>00296                 <span class="keywordflow">if</span> ((pos.first-&gt;second.first == s) &amp;&amp;
<a name="l00297"></a>00297                     (requested_boundary_ids.count(pos.first-&gt;second.second)))
<a name="l00298"></a>00298                   {
<a name="l00299"></a>00299                     <span class="comment">// Build the side - do not use a &quot;proxy&quot; element here:</span>
<a name="l00300"></a>00300                     <span class="comment">// This will be going into the BoundaryMesh and needs to</span>
<a name="l00301"></a>00301                     <span class="comment">// stand on its own.</span>
<a name="l00302"></a>00302                     <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s, <span class="keyword">false</span>));
<a name="l00303"></a>00303                     
<a name="l00304"></a>00304                     <span class="comment">// inherit processor_id and subdomain_id from parent</span>
<a name="l00305"></a>00305                     <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;subdomain_id() = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l00306"></a>00306                     <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;processor_id() = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00307"></a>00307 
<a name="l00308"></a>00308                     <span class="comment">// Add the side</span>
<a name="l00309"></a>00309                     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* new_elem = boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ad230cc153170488ad92ab4f6ee2146c7">add_elem</a>(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>.release());
<a name="l00310"></a>00310 
<a name="l00311"></a>00311                     <span class="comment">// and set the parent</span>
<a name="l00312"></a>00312                     new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa4496b9addd808d8c1fa2074e1a8cc4f">set_parent</a> (const_cast&lt;Elem*&gt;(elem));
<a name="l00313"></a>00313 
<a name="l00314"></a>00314                     <span class="comment">// This side&#39;s Node pointers still point to the nodes of the  original mesh.</span>
<a name="l00315"></a>00315                     <span class="comment">// We need to re-point them to the boundary mesh&#39;s nodes!  Since we copied *ALL* of</span>
<a name="l00316"></a>00316                     <span class="comment">// the original mesh&#39;s nodes over, we should be guaranteed to have the same ordering.</span>
<a name="l00317"></a>00317                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn=0; nn&lt;new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++nn)
<a name="l00318"></a>00318                       {
<a name="l00319"></a>00319                         <span class="comment">// Get the correct node pointer, based on the id()</span>
<a name="l00320"></a>00320                         <a class="code" href="classlibMesh_1_1Node.php">Node</a>* new_node = boundary_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a>(new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(nn));
<a name="l00321"></a>00321                         
<a name="l00322"></a>00322                         <span class="comment">// sanity check: be sure that the new Nodes global id really matches</span>
<a name="l00323"></a>00323                         libmesh_assert (new_node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(nn));
<a name="l00324"></a>00324 
<a name="l00325"></a>00325                         <span class="comment">// Assign the new node pointer</span>
<a name="l00326"></a>00326                         new_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(nn) = new_node;
<a name="l00327"></a>00327                       }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329                     <span class="comment">// go on to the next side</span>
<a name="l00330"></a>00330                     <span class="keywordflow">break</span>;
<a name="l00331"></a>00331                   }
<a name="l00332"></a>00332                 
<a name="l00333"></a>00333                 ++pos.first;
<a name="l00334"></a>00334               } <span class="comment">// end loop over bcs matching top_parent</span>
<a name="l00335"></a>00335             
<a name="l00336"></a>00336           } <span class="comment">// end if neighbor is NULL</span>
<a name="l00337"></a>00337     } <span class="comment">// end loop over active elements</span>
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="comment">// Don&#39;t repartition this mesh; but rather inherit the partitioning</span>
<a name="l00340"></a>00340   boundary_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa07a00e86d68f366d8fe7e4d01140ffc">partitioner</a>().<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(NULL);
<a name="l00341"></a>00341   
<a name="l00342"></a>00342   <span class="comment">// Trim any un-used nodes from the Mesh</span>
<a name="l00343"></a>00343   boundary_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a>(<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="comment">// and finally distribute element partitioning to the nodes</span>
<a name="l00346"></a>00346   <a class="code" href="classlibMesh_1_1Partitioner.php#accc819bc421fd8e50323b46f9762c714">Partitioner::set_node_processor_ids</a>(boundary_mesh);
<a name="l00347"></a>00347 }
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#af692299a03ebad7307d277fe96029795">00352</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ab1ac1017f2822b21287befe935cf7891">BoundaryInfo::add_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node,
<a name="l00353"></a>00353                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   this-&gt;<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ab1ac1017f2822b21287befe935cf7891">add_node</a> (<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(node), id);
<a name="l00356"></a>00356 }
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#ab1ac1017f2822b21287befe935cf7891">00360</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ab1ac1017f2822b21287befe935cf7891">BoundaryInfo::add_node</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node,
<a name="l00361"></a>00361                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00362"></a>00362 {
<a name="l00363"></a>00363   <span class="keywordflow">if</span> (<span class="keywordtype">id</span> == <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a>)
<a name="l00364"></a>00364     {
<a name="l00365"></a>00365       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: You may not set a boundary ID of &quot;</span>
<a name="l00366"></a>00366                     &lt;&lt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a> &lt;&lt; std::endl
<a name="l00367"></a>00367                     &lt;&lt; <span class="stringliteral">&quot; That is reserved for internal use.\n&quot;</span>
<a name="l00368"></a>00368                     &lt;&lt; std::endl;
<a name="l00369"></a>00369 
<a name="l00370"></a>00370       libmesh_error();
<a name="l00371"></a>00371     }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373   <span class="comment">// A convenient typedef</span>
<a name="l00374"></a>00374   <span class="keyword">typedef</span> std::multimap&lt;const Node*, short int&gt;::const_iterator Iter;
<a name="l00375"></a>00375               
<a name="l00376"></a>00376   <span class="comment">// Don&#39;t add the same ID twice</span>
<a name="l00377"></a>00377   std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.equal_range(node);
<a name="l00378"></a>00378 
<a name="l00379"></a>00379   <span class="keywordflow">for</span> (;pos.first != pos.second; ++pos.first)
<a name="l00380"></a>00380     <span class="keywordflow">if</span> (pos.first-&gt;second == <span class="keywordtype">id</span>)
<a name="l00381"></a>00381       <span class="keywordflow">return</span>;
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   std::pair&lt;const Node*, short int&gt; kv (node, <span class="keywordtype">id</span>);
<a name="l00384"></a>00384   
<a name="l00385"></a>00385   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.insert(kv);
<a name="l00386"></a>00386   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>.insert(<span class="keywordtype">id</span>);
<a name="l00387"></a>00387 }
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#acc2b9c83daca4dc956faf3a2bda9b37f">00391</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#acc2b9c83daca4dc956faf3a2bda9b37f">BoundaryInfo::add_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00392"></a>00392                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00393"></a>00393                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00394"></a>00394 {
<a name="l00395"></a>00395   this-&gt;<a class="code" href="classlibMesh_1_1BoundaryInfo.php#acc2b9c83daca4dc956faf3a2bda9b37f">add_side</a> (<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e), <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>, id);
<a name="l00396"></a>00396 }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4dcf1af7344f24f32063e3bd3941ed96">00400</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#acc2b9c83daca4dc956faf3a2bda9b37f">BoundaryInfo::add_side</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00401"></a>00401                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00402"></a>00402                             <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00403"></a>00403 {
<a name="l00404"></a>00404   libmesh_assert (elem != NULL);
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="comment">// Only add BCs for level-0 elements.</span>
<a name="l00407"></a>00407   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == 0);
<a name="l00408"></a>00408   
<a name="l00409"></a>00409   <span class="keywordflow">if</span> (<span class="keywordtype">id</span> == <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a>)
<a name="l00410"></a>00410     {
<a name="l00411"></a>00411       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: You may not set a boundary ID of &quot;</span>
<a name="l00412"></a>00412                     &lt;&lt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a> &lt;&lt; std::endl
<a name="l00413"></a>00413                     &lt;&lt; <span class="stringliteral">&quot; That is reserved for internal use.\n&quot;</span>
<a name="l00414"></a>00414                     &lt;&lt; std::endl;
<a name="l00415"></a>00415 
<a name="l00416"></a>00416       libmesh_error();
<a name="l00417"></a>00417     }
<a name="l00418"></a>00418   
<a name="l00419"></a>00419   <span class="comment">// A convenient typedef</span>
<a name="l00420"></a>00420   <span class="keyword">typedef</span> std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator Iter;
<a name="l00421"></a>00421               
<a name="l00422"></a>00422   <span class="comment">// Don&#39;t add the same ID twice</span>
<a name="l00423"></a>00423   std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(elem);
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="keywordflow">for</span> (;pos.first != pos.second; ++pos.first)
<a name="l00426"></a>00426     <span class="keywordflow">if</span> (pos.first-&gt;second.first == side &amp;&amp;
<a name="l00427"></a>00427         pos.first-&gt;second.second == <span class="keywordtype">id</span>)
<a name="l00428"></a>00428       <span class="keywordflow">return</span>;
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   std::pair&lt;unsigned short int, short int&gt; p(side,<span class="keywordtype">id</span>);
<a name="l00431"></a>00431   std::pair&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;
<a name="l00432"></a>00432     kv (elem, p);
<a name="l00433"></a>00433   
<a name="l00434"></a>00434   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.insert(kv);
<a name="l00435"></a>00435   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>.insert(<span class="keywordtype">id</span>);
<a name="l00436"></a>00436 }
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a08f26a1e4e3f1b9677fcfdc23c4086b4">00440</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#acc2b9c83daca4dc956faf3a2bda9b37f">BoundaryInfo::add_side</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00441"></a>00441                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00442"></a>00442                             <span class="keyword">const</span> std::vector&lt;short int&gt;&amp; ids)
<a name="l00443"></a>00443 {
<a name="l00444"></a>00444   <span class="keywordflow">if</span> (ids.empty())
<a name="l00445"></a>00445     <span class="keywordflow">return</span>;
<a name="l00446"></a>00446 
<a name="l00447"></a>00447   libmesh_assert (elem != NULL);
<a name="l00448"></a>00448 
<a name="l00449"></a>00449   <span class="comment">// Only add BCs for level-0 elements.</span>
<a name="l00450"></a>00450   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == 0);
<a name="l00451"></a>00451   
<a name="l00452"></a>00452   <span class="comment">// A convenient typedef</span>
<a name="l00453"></a>00453   <span class="keyword">typedef</span> std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator Iter;
<a name="l00454"></a>00454               
<a name="l00455"></a>00455   <span class="comment">// Don&#39;t add the same ID twice</span>
<a name="l00456"></a>00456   std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(elem);
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!= ids.size(); ++i)
<a name="l00459"></a>00459     {
<a name="l00460"></a>00460       <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>=ids[i];
<a name="l00461"></a>00461 
<a name="l00462"></a>00462       <span class="keywordflow">if</span> (<span class="keywordtype">id</span> == <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a>)
<a name="l00463"></a>00463         {
<a name="l00464"></a>00464           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: You may not set a boundary ID of &quot;</span>
<a name="l00465"></a>00465                         &lt;&lt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a> &lt;&lt; std::endl
<a name="l00466"></a>00466                         &lt;&lt; <span class="stringliteral">&quot; That is reserved for internal use.\n&quot;</span>
<a name="l00467"></a>00467                         &lt;&lt; std::endl;
<a name="l00468"></a>00468 
<a name="l00469"></a>00469           libmesh_error();
<a name="l00470"></a>00470         }
<a name="l00471"></a>00471   
<a name="l00472"></a>00472       <span class="keywordflow">for</span> (Iter p = pos.first;p != pos.second; ++p)
<a name="l00473"></a>00473         <span class="keywordflow">if</span> (p-&gt;second.first == side &amp;&amp;
<a name="l00474"></a>00474             p-&gt;second.second == <span class="keywordtype">id</span>)
<a name="l00475"></a>00475           <span class="keywordflow">continue</span>;
<a name="l00476"></a>00476 
<a name="l00477"></a>00477       std::pair&lt;unsigned short int, short int&gt; p(side,<span class="keywordtype">id</span>);
<a name="l00478"></a>00478       std::pair&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;
<a name="l00479"></a>00479         kv (elem, p);
<a name="l00480"></a>00480   
<a name="l00481"></a>00481       <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.insert(kv);
<a name="l00482"></a>00482       <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>.insert(<span class="keywordtype">id</span>);
<a name="l00483"></a>00483     }
<a name="l00484"></a>00484 }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#abd852b41b83c277a7c7e0b224ad85574">00488</a> std::vector&lt;short int&gt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#abd852b41b83c277a7c7e0b224ad85574">BoundaryInfo::boundary_ids</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node)<span class="keyword"> const</span>
<a name="l00489"></a>00489 <span class="keyword"></span>{
<a name="l00490"></a>00490   std::vector&lt;short int&gt; ids;
<a name="l00491"></a>00491   
<a name="l00492"></a>00492   <span class="comment">// A convenient typedef</span>
<a name="l00493"></a>00493   <span class="keyword">typedef</span> std::multimap&lt;const Node*, short int&gt;::const_iterator Iter;
<a name="l00494"></a>00494               
<a name="l00495"></a>00495   <span class="comment">// Don&#39;t add the same ID twice</span>
<a name="l00496"></a>00496   std::pair&lt;Iter, Iter&gt; pos = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.equal_range(node);
<a name="l00497"></a>00497 
<a name="l00498"></a>00498   <span class="keywordflow">for</span> (;pos.first != pos.second; ++pos.first)
<a name="l00499"></a>00499     ids.push_back(pos.first-&gt;second);
<a name="l00500"></a>00500 
<a name="l00501"></a>00501   <span class="keywordflow">return</span> ids;
<a name="l00502"></a>00502 }
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 
<a name="l00505"></a>00505 
<a name="l00506"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3becf69c281c3b2a7a711f48fe0ac76b">00506</a> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3becf69c281c3b2a7a711f48fe0ac76b">BoundaryInfo::boundary_id</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00507"></a>00507                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>)<span class="keyword"> const</span>
<a name="l00508"></a>00508 <span class="keyword"></span>{
<a name="l00509"></a>00509   libmesh_assert (elem != NULL);
<a name="l00510"></a>00510 
<a name="l00511"></a>00511   <span class="comment">// Only level-0 elements store BCs.  If this is not a level-0</span>
<a name="l00512"></a>00512   <span class="comment">// element, one of its parent elements may have either internal</span>
<a name="l00513"></a>00513   <span class="comment">// or external boundary IDs.  We find that parent now.</span>
<a name="l00514"></a>00514   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*  searched_elem = elem;
<a name="l00515"></a>00515   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() != 0)
<a name="l00516"></a>00516   {
<a name="l00517"></a>00517     <span class="comment">// Child element on external side: the top_parent will have the BCs</span>
<a name="l00518"></a>00518     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(side) == NULL)
<a name="l00519"></a>00519       searched_elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">top_parent</a> ();
<a name="l00520"></a>00520     
<a name="l00521"></a>00521 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00522"></a>00522 <span class="preprocessor"></span>    <span class="comment">// Child element is not on external side, but it may have internal</span>
<a name="l00523"></a>00523     <span class="comment">// &quot;boundary&quot; IDs.  We will walk up the tree, at each level checking that </span>
<a name="l00524"></a>00524     <span class="comment">// the current child is actually on the same side of the parent that is</span>
<a name="l00525"></a>00525     <span class="comment">// currently being searched for (i.e. that was passed in as &quot;side&quot;).</span>
<a name="l00526"></a>00526     <span class="keywordflow">else</span>
<a name="l00527"></a>00527       <span class="keywordflow">while</span> (searched_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() != NULL) 
<a name="l00528"></a>00528         {
<a name="l00529"></a>00529           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * parent = searched_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00530"></a>00530           <span class="keywordflow">if</span> (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a166a97989977b40b52351665d4c4028f">is_child_on_side</a>(parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(searched_elem), <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>) == <span class="keyword">false</span>)
<a name="l00531"></a>00531             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a>;
<a name="l00532"></a>00532           searched_elem = parent;
<a name="l00533"></a>00533         }
<a name="l00534"></a>00534 <span class="preprocessor">#endif</span>
<a name="l00535"></a>00535 <span class="preprocessor"></span>  }
<a name="l00536"></a>00536   
<a name="l00537"></a>00537   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00538"></a>00538                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator,
<a name="l00539"></a>00539             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00540"></a>00540                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator &gt; 
<a name="l00541"></a>00541     e = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(searched_elem);
<a name="l00542"></a>00542 
<a name="l00543"></a>00543   <span class="comment">// elem not in the data structure</span>
<a name="l00544"></a>00544   <span class="keywordflow">if</span> (e.first == e.second)
<a name="l00545"></a>00545     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a>;
<a name="l00546"></a>00546 
<a name="l00547"></a>00547   <span class="comment">// elem is there, maybe multiple occurances</span>
<a name="l00548"></a>00548   <span class="keywordflow">while</span> (e.first != e.second)
<a name="l00549"></a>00549     {
<a name="l00550"></a>00550       <span class="comment">// if this is true we found the requested side</span>
<a name="l00551"></a>00551       <span class="comment">// of the element and want to return the id</span>
<a name="l00552"></a>00552       <span class="keywordflow">if</span> (e.first-&gt;second.first == side)
<a name="l00553"></a>00553         <span class="keywordflow">return</span> e.first-&gt;second.second;
<a name="l00554"></a>00554 
<a name="l00555"></a>00555       ++e.first;
<a name="l00556"></a>00556     }
<a name="l00557"></a>00557 
<a name="l00558"></a>00558   <span class="comment">// if we get here, we found elem in the data structure but not</span>
<a name="l00559"></a>00559   <span class="comment">// the requested side, so return the default value</span>
<a name="l00560"></a>00560   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a>;  
<a name="l00561"></a>00561 }
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 
<a name="l00564"></a>00564 
<a name="l00565"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a88769e26678d54c67eb9d73bfd7cac01">00565</a> std::vector&lt;short int&gt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#abd852b41b83c277a7c7e0b224ad85574">BoundaryInfo::boundary_ids</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00566"></a>00566                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>)<span class="keyword"> const</span>
<a name="l00567"></a>00567 <span class="keyword"></span>{
<a name="l00568"></a>00568   libmesh_assert (elem != NULL);
<a name="l00569"></a>00569 
<a name="l00570"></a>00570   std::vector&lt;short int&gt; ids;
<a name="l00571"></a>00571 
<a name="l00572"></a>00572   <span class="comment">// Only level-0 elements store BCs.  If this is not a level-0</span>
<a name="l00573"></a>00573   <span class="comment">// element get its level-0 parent and infer the BCs.</span>
<a name="l00574"></a>00574   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*  searched_elem = elem;
<a name="l00575"></a>00575   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() != 0)
<a name="l00576"></a>00576   {
<a name="l00577"></a>00577     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(side) == NULL)
<a name="l00578"></a>00578       searched_elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">top_parent</a> ();
<a name="l00579"></a>00579 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00580"></a>00580 <span class="preprocessor"></span>    <span class="keywordflow">else</span>
<a name="l00581"></a>00581       <span class="keywordflow">while</span> (searched_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() != NULL) 
<a name="l00582"></a>00582         {
<a name="l00583"></a>00583           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> * parent = searched_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00584"></a>00584           <span class="keywordflow">if</span> (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a166a97989977b40b52351665d4c4028f">is_child_on_side</a>(parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(searched_elem), <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>) == <span class="keyword">false</span>)
<a name="l00585"></a>00585             <span class="keywordflow">return</span> ids;
<a name="l00586"></a>00586           searched_elem = parent;
<a name="l00587"></a>00587         }
<a name="l00588"></a>00588 <span class="preprocessor">#endif</span>
<a name="l00589"></a>00589 <span class="preprocessor"></span>  }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00592"></a>00592                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator,
<a name="l00593"></a>00593             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00594"></a>00594                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator &gt;
<a name="l00595"></a>00595     e = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(searched_elem);
<a name="l00596"></a>00596 
<a name="l00597"></a>00597   <span class="comment">// elem not in the data structure</span>
<a name="l00598"></a>00598   <span class="keywordflow">if</span> (e.first == e.second)
<a name="l00599"></a>00599     <span class="keywordflow">return</span> ids;
<a name="l00600"></a>00600 
<a name="l00601"></a>00601   <span class="comment">// elem is there, maybe multiple occurances</span>
<a name="l00602"></a>00602   <span class="keywordflow">while</span> (e.first != e.second)
<a name="l00603"></a>00603     {
<a name="l00604"></a>00604       <span class="comment">// if this is true we found the requested side of the element</span>
<a name="l00605"></a>00605       <span class="keywordflow">if</span> (e.first-&gt;second.first == side)
<a name="l00606"></a>00606         ids.push_back(e.first-&gt;second.second);
<a name="l00607"></a>00607 
<a name="l00608"></a>00608       ++e.first;
<a name="l00609"></a>00609     }
<a name="l00610"></a>00610 
<a name="l00611"></a>00611   <span class="comment">// Whether or not we found anything, return &quot;ids&quot;.  If it&#39;s empty, it</span>
<a name="l00612"></a>00612   <span class="comment">// means no valid bounary IDs were found for &quot;side&quot;</span>
<a name="l00613"></a>00613   <span class="keywordflow">return</span> ids;
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 }
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 
<a name="l00618"></a>00618 
<a name="l00619"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a34d0d081caf1bcca0e15b724dab04b64">00619</a> std::vector&lt;short int&gt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a34d0d081caf1bcca0e15b724dab04b64">BoundaryInfo::raw_boundary_ids</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00620"></a>00620                                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>)<span class="keyword"> const</span>
<a name="l00621"></a>00621 <span class="keyword"></span>{
<a name="l00622"></a>00622   libmesh_assert (elem != NULL);
<a name="l00623"></a>00623 
<a name="l00624"></a>00624   std::vector&lt;short int&gt; ids;
<a name="l00625"></a>00625 
<a name="l00626"></a>00626   <span class="comment">// Only level-0 elements store BCs.</span>
<a name="l00627"></a>00627   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>())
<a name="l00628"></a>00628     <span class="keywordflow">return</span> ids;
<a name="l00629"></a>00629 
<a name="l00630"></a>00630   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00631"></a>00631                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator,
<a name="l00632"></a>00632             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00633"></a>00633                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator &gt;
<a name="l00634"></a>00634     e = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(elem);
<a name="l00635"></a>00635 
<a name="l00636"></a>00636   <span class="comment">// Check any occurances</span>
<a name="l00637"></a>00637   <span class="keywordflow">while</span> (e.first != e.second)
<a name="l00638"></a>00638     {
<a name="l00639"></a>00639       <span class="comment">// if this is true we found the requested side of the element</span>
<a name="l00640"></a>00640       <span class="keywordflow">if</span> (e.first-&gt;second.first == side)
<a name="l00641"></a>00641         ids.push_back(e.first-&gt;second.second);
<a name="l00642"></a>00642 
<a name="l00643"></a>00643       ++e.first;
<a name="l00644"></a>00644     }
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <span class="comment">// if nothing got pushed back, we didn&#39;t find elem in the data</span>
<a name="l00647"></a>00647   <span class="comment">// structure with the requested side, so return the default empty</span>
<a name="l00648"></a>00648   <span class="comment">// vector </span>
<a name="l00649"></a>00649   <span class="keywordflow">return</span> ids;
<a name="l00650"></a>00650 }
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00654"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#ac953dd930604001078b7ce122ef89032">00654</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ac953dd930604001078b7ce122ef89032">BoundaryInfo::remove_side</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00655"></a>00655                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>)
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   libmesh_assert (elem != NULL);
<a name="l00658"></a>00658 
<a name="l00659"></a>00659   <span class="comment">// The user shouldn&#39;t be trying to remove only one child&#39;s boundary</span>
<a name="l00660"></a>00660   <span class="comment">// id</span>
<a name="l00661"></a>00661   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == 0);
<a name="l00662"></a>00662   
<a name="l00663"></a>00663   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00664"></a>00664                           std::pair&lt;unsigned short int, short int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>,
<a name="l00665"></a>00665             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00666"></a>00666                           std::pair&lt;unsigned short int, short int&gt; &gt;::iterator &gt; 
<a name="l00667"></a>00667     e = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(elem);
<a name="l00668"></a>00668 
<a name="l00669"></a>00669   <span class="comment">// elem may be there, maybe multiple occurances</span>
<a name="l00670"></a>00670   <span class="keywordflow">while</span> (e.first != e.second)
<a name="l00671"></a>00671     {
<a name="l00672"></a>00672       <span class="comment">// if this is true we found the requested side</span>
<a name="l00673"></a>00673       <span class="comment">// of the element and want to erase the id</span>
<a name="l00674"></a>00674       <span class="keywordflow">if</span> (e.first-&gt;second.first == side)
<a name="l00675"></a>00675         {
<a name="l00676"></a>00676           <span class="comment">// (postfix++ - increment the iterator before it&#39;s invalid)</span>
<a name="l00677"></a>00677           <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.erase(e.first++);
<a name="l00678"></a>00678         }
<a name="l00679"></a>00679       <span class="keywordflow">else</span>
<a name="l00680"></a>00680         ++e.first;
<a name="l00681"></a>00681     }
<a name="l00682"></a>00682 }
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 
<a name="l00685"></a>00685 
<a name="l00686"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#af6bbebeb121c6941355d3d2139b63623">00686</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ac953dd930604001078b7ce122ef89032">BoundaryInfo::remove_side</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00687"></a>00687                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00688"></a>00688                                 <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00689"></a>00689 {
<a name="l00690"></a>00690   libmesh_assert (elem != NULL);
<a name="l00691"></a>00691 
<a name="l00692"></a>00692   <span class="comment">// The user shouldn&#39;t be trying to remove only one child&#39;s boundary</span>
<a name="l00693"></a>00693   <span class="comment">// id</span>
<a name="l00694"></a>00694   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == 0);
<a name="l00695"></a>00695   
<a name="l00696"></a>00696   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00697"></a>00697                           std::pair&lt;unsigned short int, short int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>,
<a name="l00698"></a>00698             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00699"></a>00699                           std::pair&lt;unsigned short int, short int&gt; &gt;::iterator &gt; 
<a name="l00700"></a>00700     e = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(elem);
<a name="l00701"></a>00701 
<a name="l00702"></a>00702   <span class="comment">// elem may be there, maybe multiple occurances</span>
<a name="l00703"></a>00703   <span class="keywordflow">while</span> (e.first != e.second)
<a name="l00704"></a>00704     {
<a name="l00705"></a>00705       <span class="comment">// if this is true we found the requested side</span>
<a name="l00706"></a>00706       <span class="comment">// of the element and want to erase the requested id</span>
<a name="l00707"></a>00707       <span class="keywordflow">if</span> (e.first-&gt;second.first == side &amp;&amp;
<a name="l00708"></a>00708           e.first-&gt;second.second == <span class="keywordtype">id</span>)
<a name="l00709"></a>00709         {
<a name="l00710"></a>00710           <span class="comment">// (postfix++ - increment the iterator before it&#39;s invalid)</span>
<a name="l00711"></a>00711           <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.erase(e.first++);
<a name="l00712"></a>00712         }
<a name="l00713"></a>00713       <span class="keywordflow">else</span>
<a name="l00714"></a>00714         ++e.first;
<a name="l00715"></a>00715     }
<a name="l00716"></a>00716 }
<a name="l00717"></a>00717 
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0515bf086e3fef621b0d9d7a261eccb9">00720</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0515bf086e3fef621b0d9d7a261eccb9">BoundaryInfo::side_with_boundary_id</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00721"></a>00721                                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> boundary_id)<span class="keyword"> const</span>
<a name="l00722"></a>00722 <span class="keyword"></span>{
<a name="l00723"></a>00723   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* searched_elem = elem;
<a name="l00724"></a>00724   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() != 0)
<a name="l00725"></a>00725     searched_elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1f984d3d93fbef517316356f80fa2c1d">top_parent</a>();
<a name="l00726"></a>00726 
<a name="l00727"></a>00727   std::pair&lt;std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00728"></a>00728                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator,
<a name="l00729"></a>00729             std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00730"></a>00730                           std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator &gt; 
<a name="l00731"></a>00731     e = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.equal_range(searched_elem);
<a name="l00732"></a>00732 
<a name="l00733"></a>00733   <span class="comment">// elem may have zero or multiple occurances</span>
<a name="l00734"></a>00734   <span class="keywordflow">for</span> (; e.first != e.second; ++e.first)
<a name="l00735"></a>00735     {
<a name="l00736"></a>00736       <span class="comment">// if this is true we found the requested boundary_id</span>
<a name="l00737"></a>00737       <span class="comment">// of the element and want to return the side</span>
<a name="l00738"></a>00738       <span class="keywordflow">if</span> (e.first-&gt;second.second == boundary_id)
<a name="l00739"></a>00739         {
<a name="l00740"></a>00740          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> = e.first-&gt;second.first;
<a name="l00741"></a>00741 
<a name="l00742"></a>00742          <span class="comment">// If we&#39;re on this external boundary then we share this</span>
<a name="l00743"></a>00743          <span class="comment">// external boundary id</span>
<a name="l00744"></a>00744          <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(side) == NULL)
<a name="l00745"></a>00745            <span class="keywordflow">return</span> side;
<a name="l00746"></a>00746 
<a name="l00747"></a>00747          <span class="comment">// If we&#39;re on an internal boundary then we need to be sure</span>
<a name="l00748"></a>00748          <span class="comment">// it&#39;s the same internal boundary as our top_parent</span>
<a name="l00749"></a>00749          <span class="keyword">const</span> Elem *p = elem;
<a name="l00750"></a>00750 
<a name="l00751"></a>00751 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00752"></a>00752 <span class="preprocessor"></span>
<a name="l00753"></a>00753          <span class="keywordflow">while</span> (p != NULL)
<a name="l00754"></a>00754            {
<a name="l00755"></a>00755              <span class="keyword">const</span> Elem *parent = p-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00756"></a>00756              <span class="keywordflow">if</span> (!parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a166a97989977b40b52351665d4c4028f">is_child_on_side</a>(parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(p), <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>))
<a name="l00757"></a>00757                <span class="keywordflow">break</span>;
<a name="l00758"></a>00758              p = parent;
<a name="l00759"></a>00759            }
<a name="l00760"></a>00760 <span class="preprocessor">#endif</span>
<a name="l00761"></a>00761 <span class="preprocessor"></span>         <span class="comment">// We&#39;re on that side of our top_parent; return it</span>
<a name="l00762"></a>00762          <span class="keywordflow">if</span> (!p)
<a name="l00763"></a>00763            <span class="keywordflow">return</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>;
<a name="l00764"></a>00764        }
<a name="l00765"></a>00765     }
<a name="l00766"></a>00766 
<a name="l00767"></a>00767   <span class="comment">// if we get here, we found elem in the data structure but not</span>
<a name="l00768"></a>00768   <span class="comment">// the requested boundary id, so return the default value</span>
<a name="l00769"></a>00769   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;  
<a name="l00770"></a>00770 }
<a name="l00771"></a>00771 
<a name="l00772"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0b467afe1b44905f68d60aad3516021d">00772</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0b467afe1b44905f68d60aad3516021d">BoundaryInfo::build_node_boundary_ids</a>(std::vector&lt;short int&gt; &amp;b_ids)
<a name="l00773"></a>00773 {
<a name="l00774"></a>00774   b_ids.clear();
<a name="l00775"></a>00775 
<a name="l00776"></a>00776   std::multimap&lt;const Node*, short int&gt;::const_iterator pos
<a name="l00777"></a>00777     = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.begin();
<a name="l00778"></a>00778 
<a name="l00779"></a>00779   <span class="keywordflow">for</span> (; pos != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.end(); ++pos)
<a name="l00780"></a>00780     {
<a name="l00781"></a>00781       <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = pos-&gt;second;
<a name="l00782"></a>00782       
<a name="l00783"></a>00783       <span class="keywordflow">if</span>(std::find(b_ids.begin(),b_ids.end(),id) == b_ids.end())
<a name="l00784"></a>00784         b_ids.push_back(<span class="keywordtype">id</span>);
<a name="l00785"></a>00785     }
<a name="l00786"></a>00786 }
<a name="l00787"></a>00787 
<a name="l00788"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a71fa95e73dcf44048cc98e82540c6647">00788</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a71fa95e73dcf44048cc98e82540c6647">BoundaryInfo::build_side_boundary_ids</a>(std::vector&lt;short int&gt; &amp;b_ids)
<a name="l00789"></a>00789 {
<a name="l00790"></a>00790   b_ids.clear();
<a name="l00791"></a>00791 
<a name="l00792"></a>00792   std::multimap&lt;const Elem*, std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator pos
<a name="l00793"></a>00793     = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.begin();
<a name="l00794"></a>00794 
<a name="l00795"></a>00795   <span class="keywordflow">for</span> (; pos != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.end(); ++pos)
<a name="l00796"></a>00796     {
<a name="l00797"></a>00797       <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = pos-&gt;second.second;
<a name="l00798"></a>00798       
<a name="l00799"></a>00799       <span class="keywordflow">if</span>(std::find(b_ids.begin(),b_ids.end(),id) == b_ids.end())
<a name="l00800"></a>00800         b_ids.push_back(<span class="keywordtype">id</span>);
<a name="l00801"></a>00801     }
<a name="l00802"></a>00802 }
<a name="l00803"></a>00803 
<a name="l00804"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a5e76cd11f6c4acbaf33cd858b8acaea3">00804</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a5e76cd11f6c4acbaf33cd858b8acaea3">BoundaryInfo::n_boundary_conds</a> ()<span class="keyword"> const</span>
<a name="l00805"></a>00805 <span class="keyword"></span>{
<a name="l00806"></a>00806   <span class="comment">// in serial we know the number of bcs from the</span>
<a name="l00807"></a>00807   <span class="comment">// size of the container</span>
<a name="l00808"></a>00808   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00809"></a>00809     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.size();
<a name="l00810"></a>00810 
<a name="l00811"></a>00811   <span class="comment">// in parallel we need to sum the number of local bcs</span>
<a name="l00812"></a>00812   parallel_only();
<a name="l00813"></a>00813   
<a name="l00814"></a>00814   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nbcs=0;
<a name="l00815"></a>00815 
<a name="l00816"></a>00816   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00817"></a>00817                 std::pair&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> int,
<a name="l00818"></a>00818                           <span class="keywordtype">short</span> <span class="keywordtype">int</span>&gt; &gt;::const_iterator pos;
<a name="l00819"></a>00819 
<a name="l00820"></a>00820   <span class="keywordflow">for</span> (pos=<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.begin(); pos != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.end(); ++pos)
<a name="l00821"></a>00821     <span class="keywordflow">if</span> (pos-&gt;first-&gt;processor_id() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00822"></a>00822       nbcs++;
<a name="l00823"></a>00823   
<a name="l00824"></a>00824   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a> (nbcs);
<a name="l00825"></a>00825   
<a name="l00826"></a>00826   <span class="keywordflow">return</span> nbcs;
<a name="l00827"></a>00827 }
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 
<a name="l00830"></a>00830 
<a name="l00831"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#aeda547d39f317fb87411ecff5822e6b1">00831</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#aeda547d39f317fb87411ecff5822e6b1">BoundaryInfo::build_node_list</a> (std::vector&lt;unsigned int&gt;&amp; nl,
<a name="l00832"></a>00832                                     std::vector&lt;short int&gt;&amp;    il)<span class="keyword"> const</span>
<a name="l00833"></a>00833 <span class="keyword"></span>{
<a name="l00834"></a>00834   <span class="comment">// Reserve the size, then use push_back</span>
<a name="l00835"></a>00835   nl.reserve (<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.size());
<a name="l00836"></a>00836   il.reserve (<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.size());
<a name="l00837"></a>00837   
<a name="l00838"></a>00838   std::multimap&lt;const Node*, short int&gt;::const_iterator pos
<a name="l00839"></a>00839     = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.begin();
<a name="l00840"></a>00840 
<a name="l00841"></a>00841   <span class="keywordflow">for</span> (; pos != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.end(); ++pos)
<a name="l00842"></a>00842     {
<a name="l00843"></a>00843       nl.push_back (pos-&gt;first-&gt;id());
<a name="l00844"></a>00844       il.push_back (pos-&gt;second);
<a name="l00845"></a>00845     }
<a name="l00846"></a>00846 }
<a name="l00847"></a>00847 
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 <span class="keywordtype">void</span>
<a name="l00850"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a9396d00a28005c703b354c4f834a2cd1">00850</a> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a9396d00a28005c703b354c4f834a2cd1">BoundaryInfo::build_node_list_from_side_list</a>()
<a name="l00851"></a>00851 {
<a name="l00852"></a>00852   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00853"></a>00853                 std::pair&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> int,
<a name="l00854"></a>00854                           <span class="keywordtype">short</span> <span class="keywordtype">int</span>&gt; &gt;::const_iterator pos;
<a name="l00855"></a>00855   
<a name="l00856"></a>00856   <span class="comment">//Loop over the side list</span>
<a name="l00857"></a>00857   <span class="keywordflow">for</span> (pos=<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.begin(); pos != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.end(); ++pos)
<a name="l00858"></a>00858   {
<a name="l00859"></a>00859     <span class="comment">// Don&#39;t add remote sides</span>
<a name="l00860"></a>00860     <span class="keywordflow">if</span>(pos-&gt;first-&gt;is_remote())
<a name="l00861"></a>00861       <span class="keywordflow">continue</span>;
<a name="l00862"></a>00862     
<a name="l00863"></a>00863     <span class="comment">//Need to loop over the sides of any possible children</span>
<a name="l00864"></a>00864     std::vector&lt; const Elem * &gt; family;
<a name="l00865"></a>00865 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00866"></a>00866 <span class="preprocessor"></span>    pos-&gt;first-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a45301bbc272e10e4cfafc0bb38ada072">active_family_tree_by_side</a> (family, pos-&gt;second.first);
<a name="l00867"></a>00867 <span class="preprocessor">#else</span>
<a name="l00868"></a>00868 <span class="preprocessor"></span>    family.push_back(pos-&gt;first);
<a name="l00869"></a>00869 <span class="preprocessor">#endif</span>
<a name="l00870"></a>00870 <span class="preprocessor"></span>
<a name="l00871"></a>00871     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_it=0; elem_it &lt; family.size(); elem_it++)
<a name="l00872"></a>00872     {
<a name="l00873"></a>00873       <span class="keyword">const</span> Elem * cur_elem = family[elem_it];
<a name="l00874"></a>00874       
<a name="l00875"></a>00875       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> = cur_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(pos-&gt;second.first);
<a name="l00876"></a>00876 
<a name="l00877"></a>00877       <span class="comment">//Add each node node on the side with the side&#39;s boundary id</span>
<a name="l00878"></a>00878       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;side-&gt;n_nodes(); i++)
<a name="l00879"></a>00879       {
<a name="l00880"></a>00880         <a class="code" href="classlibMesh_1_1Node.php">Node</a> * node = side-&gt;get_node(i);
<a name="l00881"></a>00881         
<a name="l00882"></a>00882         this-&gt;<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ab1ac1017f2822b21287befe935cf7891">add_node</a>(node, pos-&gt;second.second);
<a name="l00883"></a>00883       }
<a name="l00884"></a>00884     }
<a name="l00885"></a>00885   }
<a name="l00886"></a>00886 }
<a name="l00887"></a>00887 
<a name="l00888"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0cec45d5fbaafa35f5eb84348ed429c6">00888</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0cec45d5fbaafa35f5eb84348ed429c6">BoundaryInfo::build_side_list</a> (std::vector&lt;unsigned int&gt;&amp;       el,
<a name="l00889"></a>00889                                     std::vector&lt;unsigned short int&gt;&amp; sl,
<a name="l00890"></a>00890                                     std::vector&lt;short int&gt;&amp;          il)<span class="keyword"> const</span>
<a name="l00891"></a>00891 <span class="keyword"></span>{
<a name="l00892"></a>00892   <span class="comment">// Reserve the size, then use push_back</span>
<a name="l00893"></a>00893   el.reserve (<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.size());
<a name="l00894"></a>00894   sl.reserve (<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.size());
<a name="l00895"></a>00895   il.reserve (<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.size());
<a name="l00896"></a>00896 
<a name="l00897"></a>00897   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00898"></a>00898                 std::pair&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> int,
<a name="l00899"></a>00899                           <span class="keywordtype">short</span> <span class="keywordtype">int</span>&gt; &gt;::const_iterator pos;
<a name="l00900"></a>00900 
<a name="l00901"></a>00901   <span class="keywordflow">for</span> (pos=<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.begin(); pos != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.end();
<a name="l00902"></a>00902        ++pos)
<a name="l00903"></a>00903     {
<a name="l00904"></a>00904       el.push_back (pos-&gt;first-&gt;id());
<a name="l00905"></a>00905       sl.push_back (pos-&gt;second.first);
<a name="l00906"></a>00906       il.push_back (pos-&gt;second.second);
<a name="l00907"></a>00907     }
<a name="l00908"></a>00908 }
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 
<a name="l00911"></a>00911 
<a name="l00912"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#aecddaf823709389fe4e842af25c89376">00912</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#aecddaf823709389fe4e842af25c89376">BoundaryInfo::print_info</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)<span class="keyword"> const</span>
<a name="l00913"></a>00913 <span class="keyword"></span>{
<a name="l00914"></a>00914   <span class="comment">// Print out the nodal BCs</span>
<a name="l00915"></a>00915   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.empty())
<a name="l00916"></a>00916     {
<a name="l00917"></a>00917       out &lt;&lt; <span class="stringliteral">&quot;Nodal Boundary conditions:&quot;</span> &lt;&lt; std::endl
<a name="l00918"></a>00918           &lt;&lt; <span class="stringliteral">&quot;--------------------------&quot;</span> &lt;&lt; std::endl
<a name="l00919"></a>00919           &lt;&lt; <span class="stringliteral">&quot;  (Node No., ID)               &quot;</span> &lt;&lt; std::endl;
<a name="l00920"></a>00920 
<a name="l00921"></a>00921 <span class="comment">//       std::for_each(_boundary_node_id.begin(),</span>
<a name="l00922"></a>00922 <span class="comment">//                  _boundary_node_id.end(),</span>
<a name="l00923"></a>00923 <span class="comment">//                  PrintNodeInfo());</span>
<a name="l00924"></a>00924 
<a name="l00925"></a>00925       std::multimap&lt;const Node*, short int&gt;::const_iterator it        = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.begin();
<a name="l00926"></a>00926       <span class="keyword">const</span> std::multimap&lt;const Node*, short int&gt;::const_iterator end = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.end();
<a name="l00927"></a>00927 
<a name="l00928"></a>00928       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00929"></a>00929         out &lt;&lt; <span class="stringliteral">&quot;  (&quot;</span> &lt;&lt; (*it).first-&gt;id()
<a name="l00930"></a>00930             &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>  &lt;&lt; (*it).second
<a name="l00931"></a>00931             &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>  &lt;&lt; std::endl;
<a name="l00932"></a>00932     }
<a name="l00933"></a>00933   
<a name="l00934"></a>00934   <span class="comment">// Print out the element BCs</span>
<a name="l00935"></a>00935   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.empty())
<a name="l00936"></a>00936     {
<a name="l00937"></a>00937       out &lt;&lt; std::endl
<a name="l00938"></a>00938           &lt;&lt; <span class="stringliteral">&quot;Side Boundary conditions:&quot;</span> &lt;&lt; std::endl
<a name="l00939"></a>00939           &lt;&lt; <span class="stringliteral">&quot;-------------------------&quot;</span> &lt;&lt; std::endl
<a name="l00940"></a>00940           &lt;&lt; <span class="stringliteral">&quot;  (Elem No., Side No., ID)      &quot;</span> &lt;&lt; std::endl;
<a name="l00941"></a>00941 
<a name="l00942"></a>00942 <span class="comment">//       std::for_each(_boundary_side_id.begin(),</span>
<a name="l00943"></a>00943 <span class="comment">//                  _boundary_side_id.end(),</span>
<a name="l00944"></a>00944 <span class="comment">//                  PrintSideInfo());</span>
<a name="l00945"></a>00945 
<a name="l00946"></a>00946       std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00947"></a>00947         std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator it = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.begin();
<a name="l00948"></a>00948       <span class="keyword">const</span> std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l00949"></a>00949         std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator end = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.end();
<a name="l00950"></a>00950 
<a name="l00951"></a>00951       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00952"></a>00952         out &lt;&lt; <span class="stringliteral">&quot;  (&quot;</span> &lt;&lt; (*it).first-&gt;id()
<a name="l00953"></a>00953             &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>  &lt;&lt; (*it).second.first
<a name="l00954"></a>00954             &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>  &lt;&lt; (*it).second.second 
<a name="l00955"></a>00955             &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>   &lt;&lt; std::endl;
<a name="l00956"></a>00956     }
<a name="l00957"></a>00957 }
<a name="l00958"></a>00958 
<a name="l00959"></a>00959 
<a name="l00960"></a>00960 
<a name="l00961"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0019ae472bdecdca68ed14cd58656454">00961</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0019ae472bdecdca68ed14cd58656454">BoundaryInfo::print_summary</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)<span class="keyword"> const</span>
<a name="l00962"></a>00962 <span class="keyword"></span>{
<a name="l00963"></a>00963   <span class="comment">// Print out the nodal BCs</span>
<a name="l00964"></a>00964   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.empty())
<a name="l00965"></a>00965     {
<a name="l00966"></a>00966       out &lt;&lt; <span class="stringliteral">&quot;Nodal Boundary conditions:&quot;</span> &lt;&lt; std::endl
<a name="l00967"></a>00967           &lt;&lt; <span class="stringliteral">&quot;--------------------------&quot;</span> &lt;&lt; std::endl
<a name="l00968"></a>00968           &lt;&lt; <span class="stringliteral">&quot;  (ID, number of nodes)   &quot;</span> &lt;&lt; std::endl;
<a name="l00969"></a>00969 
<a name="l00970"></a>00970       std::map&lt;short int, unsigned int&gt; ID_counts;
<a name="l00971"></a>00971 
<a name="l00972"></a>00972       std::multimap&lt;const Node*, short int&gt;::const_iterator it        = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.begin();
<a name="l00973"></a>00973       <span class="keyword">const</span> std::multimap&lt;const Node*, short int&gt;::const_iterator end = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.end();
<a name="l00974"></a>00974 
<a name="l00975"></a>00975       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00976"></a>00976         ID_counts[(*it).second]++;
<a name="l00977"></a>00977 
<a name="l00978"></a>00978       std::map&lt;short int, unsigned int&gt;::const_iterator ID_it        = ID_counts.begin();
<a name="l00979"></a>00979       <span class="keyword">const</span> std::map&lt;short int, unsigned int&gt;::const_iterator ID_end = ID_counts.end();
<a name="l00980"></a>00980 
<a name="l00981"></a>00981       <span class="keywordflow">for</span> (; ID_it != ID_end; ++ID_it)
<a name="l00982"></a>00982         out &lt;&lt; <span class="stringliteral">&quot;  (&quot;</span> &lt;&lt; (*ID_it).first
<a name="l00983"></a>00983             &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>  &lt;&lt; (*ID_it).second
<a name="l00984"></a>00984             &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>  &lt;&lt; std::endl;
<a name="l00985"></a>00985     }
<a name="l00986"></a>00986   
<a name="l00987"></a>00987   <span class="comment">// Print out the element BCs</span>
<a name="l00988"></a>00988   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.empty())
<a name="l00989"></a>00989     {
<a name="l00990"></a>00990       out &lt;&lt; std::endl
<a name="l00991"></a>00991           &lt;&lt; <span class="stringliteral">&quot;Side Boundary conditions:&quot;</span> &lt;&lt; std::endl
<a name="l00992"></a>00992           &lt;&lt; <span class="stringliteral">&quot;-------------------------&quot;</span> &lt;&lt; std::endl
<a name="l00993"></a>00993           &lt;&lt; <span class="stringliteral">&quot;  (ID, number of sides)   &quot;</span> &lt;&lt; std::endl;
<a name="l00994"></a>00994 
<a name="l00995"></a>00995       std::map&lt;short int, unsigned int&gt; ID_counts;
<a name="l00996"></a>00996 
<a name="l00997"></a>00997       std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00998"></a>00998         std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator it = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.begin();
<a name="l00999"></a>00999       <span class="keyword">const</span> std::multimap&lt;<span class="keyword">const</span> Elem*,
<a name="l01000"></a>01000         std::pair&lt;unsigned short int, short int&gt; &gt;::const_iterator end = <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.end();
<a name="l01001"></a>01001 
<a name="l01002"></a>01002       <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01003"></a>01003         ID_counts[(*it).second.second]++;
<a name="l01004"></a>01004 
<a name="l01005"></a>01005       std::map&lt;short int, unsigned int&gt;::const_iterator ID_it        = ID_counts.begin();
<a name="l01006"></a>01006       <span class="keyword">const</span> std::map&lt;short int, unsigned int&gt;::const_iterator ID_end = ID_counts.end();
<a name="l01007"></a>01007 
<a name="l01008"></a>01008       <span class="keywordflow">for</span> (; ID_it != ID_end; ++ID_it)
<a name="l01009"></a>01009         out &lt;&lt; <span class="stringliteral">&quot;  (&quot;</span> &lt;&lt; (*ID_it).first
<a name="l01010"></a>01010             &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>  &lt;&lt; (*ID_it).second
<a name="l01011"></a>01011             &lt;&lt; <span class="stringliteral">&quot;)&quot;</span>  &lt;&lt; std::endl;
<a name="l01012"></a>01012     }
<a name="l01013"></a>01013 }
<a name="l01014"></a>01014 
<a name="l01015"></a>01015 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
