<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">boundary_info.h</div>  </div>
</div>
<div class="contents">
<a href="boundary__info_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: boundary_info.h 4047 2010-10-13 18:53:55Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __boundary_info_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __boundary_info_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>Elem;
<a name="l00039"></a>00039 <span class="keyword">class </span>Node;
<a name="l00040"></a>00040 <span class="keyword">class </span>MeshBase;
<a name="l00041"></a>00041 <span class="keyword">class </span>BoundaryMesh;
<a name="l00042"></a>00042 <span class="keyword">class </span>MeshData;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00056"></a>00056 <span class="comment">//------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// BoundaryInfo class definition</span>
<a name="l00058"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php">00058</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">protected</span>:
<a name="l00061"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad3a3c9ef9c9ca3ff5642ac40daaedd99">00061</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>;
<a name="l00062"></a>00062   
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a976732d8ddbc295d7afd3edd689d6023">BoundaryInfo</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="keyword">public</span>:
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>&amp; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ac88f924025e8370238570582982dfbad">operator=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>&amp; other_boundary_info);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a94131726fa74bd596d6e6d1bb3fcfacc">~BoundaryInfo</a> ();
<a name="l00084"></a>00084 
<a name="l00090"></a>00090   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a824b4cd550177ac7d30db57e545699ea">clear</a> ();
<a name="l00091"></a>00091   
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a2b56eacc15f8e6172a0589eabde6e1ff">sync</a> (<a class="code" href="classlibMesh_1_1BoundaryMesh.php">BoundaryMesh</a>&amp; boundary_mesh,
<a name="l00105"></a>00105              <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* boundary_mesh_data=NULL,
<a name="l00106"></a>00106              <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* this_mesh_data=NULL);
<a name="l00107"></a>00107   
<a name="l00121"></a>00121   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a2b56eacc15f8e6172a0589eabde6e1ff">sync</a> (<span class="keyword">const</span> std::set&lt;short int&gt; &amp;requested_boundary_ids,
<a name="l00122"></a>00122              <a class="code" href="classlibMesh_1_1BoundaryMesh.php">BoundaryMesh</a>&amp; boundary_mesh);
<a name="l00123"></a>00123   
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ab1ac1017f2822b21287befe935cf7891">add_node</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node,
<a name="l00129"></a>00129                  <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00130"></a>00130 
<a name="l00135"></a>00135   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ab1ac1017f2822b21287befe935cf7891">add_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node,
<a name="l00136"></a>00136                  <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00137"></a>00137 
<a name="l00142"></a>00142   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#acc2b9c83daca4dc956faf3a2bda9b37f">add_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem,
<a name="l00143"></a>00143                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00144"></a>00144                  <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00145"></a>00145 
<a name="l00150"></a>00150   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#acc2b9c83daca4dc956faf3a2bda9b37f">add_side</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00151"></a>00151                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00152"></a>00152                  <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00153"></a>00153 
<a name="l00158"></a>00158   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#acc2b9c83daca4dc956faf3a2bda9b37f">add_side</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00159"></a>00159                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00160"></a>00160                  <span class="keyword">const</span> std::vector&lt;short int&gt;&amp; ids);
<a name="l00161"></a>00161 
<a name="l00166"></a>00166   <span class="keywordtype">void</span> <span class="keyword">remove</span> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node);
<a name="l00167"></a>00167 
<a name="l00172"></a>00172   <span class="keywordtype">void</span> <span class="keyword">remove</span> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00173"></a>00173 
<a name="l00178"></a>00178   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ac953dd930604001078b7ce122ef89032">remove_side</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00179"></a>00179                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>);
<a name="l00180"></a>00180 
<a name="l00185"></a>00185   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ac953dd930604001078b7ce122ef89032">remove_side</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00186"></a>00186                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00187"></a>00187                     <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00188"></a>00188 
<a name="l00192"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3bf998aaa380308f5a1b543e911039dc">00192</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3bf998aaa380308f5a1b543e911039dc">n_boundary_ids</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>.size(); }
<a name="l00193"></a>00193 
<a name="l00197"></a>00197   std::vector&lt;short int&gt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#abd852b41b83c277a7c7e0b224ad85574">boundary_ids</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node) <span class="keyword">const</span>;
<a name="l00198"></a>00198 
<a name="l00206"></a>00206   <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3becf69c281c3b2a7a711f48fe0ac76b">boundary_id</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00207"></a>00207                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>) <span class="keyword">const</span>;
<a name="l00208"></a>00208 
<a name="l00213"></a>00213   std::vector&lt;short int&gt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#abd852b41b83c277a7c7e0b224ad85574">boundary_ids</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00214"></a>00214        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>) <span class="keyword">const</span>;
<a name="l00215"></a>00215 
<a name="l00222"></a>00222   std::vector&lt;short int&gt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a34d0d081caf1bcca0e15b724dab04b64">raw_boundary_ids</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00223"></a>00223        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>) <span class="keyword">const</span>;
<a name="l00224"></a>00224 
<a name="l00233"></a>00233   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0515bf086e3fef621b0d9d7a261eccb9">side_with_boundary_id</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00234"></a>00234                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3becf69c281c3b2a7a711f48fe0ac76b">boundary_id</a>) <span class="keyword">const</span>;
<a name="l00235"></a>00235 
<a name="l00239"></a>00239   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0b467afe1b44905f68d60aad3516021d">build_node_boundary_ids</a>(std::vector&lt;short int&gt; &amp;b_ids);
<a name="l00240"></a>00240 
<a name="l00244"></a>00244   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a71fa95e73dcf44048cc98e82540c6647">build_side_boundary_ids</a>(std::vector&lt;short int&gt; &amp;b_ids);
<a name="l00245"></a>00245 
<a name="l00249"></a>00249   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a5e76cd11f6c4acbaf33cd858b8acaea3">n_boundary_conds</a> () <span class="keyword">const</span>;
<a name="l00250"></a>00250   
<a name="l00254"></a>00254   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#aeda547d39f317fb87411ecff5822e6b1">build_node_list</a> (std::vector&lt;unsigned int&gt;&amp; nl,
<a name="l00255"></a>00255                         std::vector&lt;short int&gt;&amp;    il) <span class="keyword">const</span>;
<a name="l00256"></a>00256 
<a name="l00261"></a>00261   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a9396d00a28005c703b354c4f834a2cd1">build_node_list_from_side_list</a>();
<a name="l00262"></a>00262 
<a name="l00266"></a>00266   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0cec45d5fbaafa35f5eb84348ed429c6">build_side_list</a> (std::vector&lt;unsigned int&gt;&amp;       el,
<a name="l00267"></a>00267                         std::vector&lt;unsigned short int&gt;&amp; sl,
<a name="l00268"></a>00268                         std::vector&lt;short int&gt;&amp;          il) <span class="keyword">const</span>;
<a name="l00269"></a>00269 
<a name="l00273"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a122dfc798b2bf63738c317c4024799b5">00273</a>   <span class="keyword">const</span> std::set&lt;short int&gt;&amp; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a122dfc798b2bf63738c317c4024799b5">get_boundary_ids</a> ()<span class="keyword"> const</span>
<a name="l00274"></a>00274 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>; }
<a name="l00275"></a>00275 
<a name="l00279"></a>00279   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#aecddaf823709389fe4e842af25c89376">print_info</a> (std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00280"></a>00280   
<a name="l00284"></a>00284   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a0019ae472bdecdca68ed14cd58656454">print_summary</a> (std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00285"></a>00285   
<a name="l00290"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">00290</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a>;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293  <span class="keyword">private</span>:
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00299"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">00299</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a4cb5b8317f56ba08d075970408e98cde">_mesh</a>;
<a name="l00300"></a>00300 
<a name="l00305"></a>00305   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*,
<a name="l00306"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">00306</a>                 <span class="keywordtype">short</span> <span class="keywordtype">int</span>&gt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>;
<a name="l00307"></a>00307 
<a name="l00312"></a>00312   std::multimap&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00313"></a>00313                 std::pair&lt;unsigned short int, short int&gt; &gt;
<a name="l00314"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">00314</a>                                              <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>;
<a name="l00315"></a>00315 
<a name="l00319"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">00319</a>   std::set&lt;short int&gt; <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3966ad8d35352da7bc5d18ad02215af1">_boundary_ids</a>;
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 <span class="comment">//   /**</span>
<a name="l00324"></a>00324 <span class="comment">//    * Functor class for printing a single node&#39;s info</span>
<a name="l00325"></a>00325 <span class="comment">//    * To be used with &quot;for_each&quot;.</span>
<a name="l00326"></a>00326 <span class="comment">//    */</span>
<a name="l00327"></a>00327 <span class="comment">//   class PrintNodeInfo </span>
<a name="l00328"></a>00328 <span class="comment">//   {</span>
<a name="l00329"></a>00329 <span class="comment">//   public:</span>
<a name="l00330"></a>00330 <span class="comment">//     inline</span>
<a name="l00331"></a>00331 <span class="comment">//     void operator() (const std::pair&lt;const Node*, short int&gt;&amp; np) const</span>
<a name="l00332"></a>00332 <span class="comment">//     {</span>
<a name="l00333"></a>00333 <span class="comment">//       libMesh::out &lt;&lt; &quot;  (&quot; &lt;&lt; np.first-&gt;id()</span>
<a name="l00334"></a>00334 <span class="comment">//                    &lt;&lt; &quot;, &quot;  &lt;&lt; np.second</span>
<a name="l00335"></a>00335 <span class="comment">//                    &lt;&lt; &quot;)&quot;  &lt;&lt; std::endl;</span>
<a name="l00336"></a>00336 <span class="comment">//     }</span>
<a name="l00337"></a>00337 <span class="comment">//   };</span>
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 <span class="comment">//   /**</span>
<a name="l00341"></a>00341 <span class="comment">//    * Functor class for printing a single side&#39;s info.</span>
<a name="l00342"></a>00342 <span class="comment">//    * To be used with &quot;for_each&quot;.</span>
<a name="l00343"></a>00343 <span class="comment">//    */</span>
<a name="l00344"></a>00344 <span class="comment">//   class PrintSideInfo</span>
<a name="l00345"></a>00345 <span class="comment">//   {</span>
<a name="l00346"></a>00346 <span class="comment">//   public:</span>
<a name="l00347"></a>00347 <span class="comment">//     PrintSideInfo() {}</span>
<a name="l00348"></a>00348 <span class="comment">//     inline</span>
<a name="l00349"></a>00349 <span class="comment">//     void operator() (const std::pair&lt;const Elem*, std::pair&lt;unsigned short int,short int&gt; &gt;&amp; sp) const</span>
<a name="l00350"></a>00350 <span class="comment">//     {</span>
<a name="l00351"></a>00351 <span class="comment">//       libMesh::out &lt;&lt; &quot;  (&quot; &lt;&lt; sp.first-&gt;id()</span>
<a name="l00352"></a>00352 <span class="comment">//                    &lt;&lt; &quot;, &quot;  &lt;&lt; sp.second.first</span>
<a name="l00353"></a>00353 <span class="comment">//                    &lt;&lt; &quot;, &quot;  &lt;&lt; sp.second.second </span>
<a name="l00354"></a>00354 <span class="comment">//                    &lt;&lt; &quot;)&quot;   &lt;&lt; std::endl;</span>
<a name="l00355"></a>00355 <span class="comment">//     }</span>
<a name="l00356"></a>00356 <span class="comment">//   };</span>
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   
<a name="l00367"></a><a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php">00367</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php">Fill</a>
<a name="l00368"></a>00368   {
<a name="l00369"></a>00369   <span class="keyword">public</span>:
<a name="l00370"></a><a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#aa8d5dba160f22af35fd2dfed385fcc65">00370</a>     <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#aa8d5dba160f22af35fd2dfed385fcc65">Fill</a>(std::map&lt;short int, unsigned int&gt;&amp; im) : <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#ae7ee102ee8b2ecbac18ba5733debd0d4">id_map</a>(im), <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#a6cdbe2f675dcc3948ceade1033b668f9">cnt</a>(0) {}
<a name="l00371"></a>00371 
<a name="l00372"></a><a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#a6b8a8567ce4b0e5e27686d2351ebd54c">00372</a>     <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#a6b8a8567ce4b0e5e27686d2351ebd54c">~Fill</a>()
<a name="l00373"></a>00373     {
<a name="l00374"></a>00374       <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#ae7ee102ee8b2ecbac18ba5733debd0d4">id_map</a>[<a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">invalid_id</a>] = <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#a6cdbe2f675dcc3948ceade1033b668f9">cnt</a>;
<a name="l00375"></a>00375     }
<a name="l00376"></a>00376     
<a name="l00377"></a>00377     <span class="keyword">inline</span>
<a name="l00378"></a><a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#a7e5efee50d7f2a3f80702c72ab64e3ee">00378</a>     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#a7e5efee50d7f2a3f80702c72ab64e3ee">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> &amp; pos)
<a name="l00379"></a>00379     {
<a name="l00380"></a>00380       <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#ae7ee102ee8b2ecbac18ba5733debd0d4">id_map</a>[pos] = <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#a6cdbe2f675dcc3948ceade1033b668f9">cnt</a>++;
<a name="l00381"></a>00381     }
<a name="l00382"></a>00382     
<a name="l00383"></a>00383   <span class="keyword">private</span>:
<a name="l00384"></a><a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#ae7ee102ee8b2ecbac18ba5733debd0d4">00384</a>     std::map&lt;short int, unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#ae7ee102ee8b2ecbac18ba5733debd0d4">id_map</a>;
<a name="l00385"></a><a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#a6cdbe2f675dcc3948ceade1033b668f9">00385</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1BoundaryInfo_1_1Fill.php#a6cdbe2f675dcc3948ceade1033b668f9">cnt</a>;
<a name="l00386"></a>00386   };
<a name="l00387"></a>00387   
<a name="l00388"></a>00388 };
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00396"></a>00396 <span class="comment">// BoundaryInfo inline methods</span>
<a name="l00397"></a>00397 <span class="keyword">inline</span>
<a name="l00398"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad0689912289a62de894c8ccecdf9c4bf">00398</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad0689912289a62de894c8ccecdf9c4bf">BoundaryInfo::remove</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node)
<a name="l00399"></a>00399 {
<a name="l00400"></a>00400   libmesh_assert (node != NULL);
<a name="l00401"></a>00401   
<a name="l00402"></a>00402   <span class="comment">// Erase everything associated with node</span>
<a name="l00403"></a>00403   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3dac465cf3563eb4446e25428eeea7ec">_boundary_node_id</a>.erase (node);
<a name="l00404"></a>00404 }
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 <span class="keyword">inline</span>
<a name="l00409"></a><a class="code" href="classlibMesh_1_1BoundaryInfo.php#ae300174c088f12a9e3f690ac9affb1d2">00409</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad0689912289a62de894c8ccecdf9c4bf">BoundaryInfo::remove</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00410"></a>00410 {
<a name="l00411"></a>00411   libmesh_assert (elem != NULL);
<a name="l00412"></a>00412   
<a name="l00413"></a>00413   <span class="comment">// Erase everything associated with elem</span>
<a name="l00414"></a>00414   <a class="code" href="classlibMesh_1_1BoundaryInfo.php#ad16a767f31a0abbe2ca0d3644ef35bb7">_boundary_side_id</a>.erase (elem);
<a name="l00415"></a>00415 }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 } <span class="comment">// namespace libMesh</span>
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
