<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_hex.C</div>  </div>
</div>
<div class="contents">
<a href="cell__hex_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_hex.C 4356 2011-04-15 15:28:29Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::min, std::max</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex_8h.php">cell_hex.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="cell__hex8_8h.php">cell_hex8.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="face__quad4_8h.php">face_quad4.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// Hex class member functions</span>
<a name="l00037"></a><a class="code" href="classlibMesh_1_1Hex.php#ac2dd6b8e38c64266acda8aad158377a3">00037</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#ac2dd6b8e38c64266acda8aad158377a3">Hex::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00038"></a>00038 <span class="keyword"></span>{
<a name="l00039"></a>00039   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Hex.php#a3fae4b2b56a9ebc908dffc0a87bdb8fd">n_sides</a>());
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="comment">// Think of a unit cube: (-1,1) x (-1,1)x (-1,1)</span>
<a name="l00042"></a>00042   <span class="keywordflow">switch</span> (s)
<a name="l00043"></a>00043     {
<a name="l00044"></a>00044     <span class="keywordflow">case</span> 0:  <span class="comment">// the face at z = -1</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046       <span class="keywordflow">return</span>
<a name="l00047"></a>00047         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00048"></a>00048                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3),
<a name="l00049"></a>00049                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00050"></a>00050                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1));
<a name="l00051"></a>00051       
<a name="l00052"></a>00052     <span class="keywordflow">case</span> 1:  <span class="comment">// the face at y = -1</span>
<a name="l00053"></a>00053 
<a name="l00054"></a>00054       <span class="keywordflow">return</span>
<a name="l00055"></a>00055         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00056"></a>00056                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00057"></a>00057                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5),
<a name="l00058"></a>00058                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4));
<a name="l00059"></a>00059       
<a name="l00060"></a>00060     <span class="keywordflow">case</span> 2:  <span class="comment">// the face at x = 1</span>
<a name="l00061"></a>00061 
<a name="l00062"></a>00062       <span class="keywordflow">return</span>
<a name="l00063"></a>00063         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00064"></a>00064                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00065"></a>00065                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6),
<a name="l00066"></a>00066                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5));
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keywordflow">case</span> 3: <span class="comment">// the face at y = 1</span>
<a name="l00069"></a>00069 
<a name="l00070"></a>00070       <span class="keywordflow">return</span>
<a name="l00071"></a>00071         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00072"></a>00072                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3),
<a name="l00073"></a>00073                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7),
<a name="l00074"></a>00074                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6));
<a name="l00075"></a>00075       
<a name="l00076"></a>00076     <span class="keywordflow">case</span> 4: <span class="comment">// the face at x = -1</span>
<a name="l00077"></a>00077       
<a name="l00078"></a>00078       <span class="keywordflow">return</span>
<a name="l00079"></a>00079         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3),
<a name="l00080"></a>00080                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00081"></a>00081                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4),
<a name="l00082"></a>00082                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7));
<a name="l00083"></a>00083 
<a name="l00084"></a>00084     <span class="keywordflow">case</span> 5: <span class="comment">// the face at z = 1</span>
<a name="l00085"></a>00085 
<a name="l00086"></a>00086       <span class="keywordflow">return</span>
<a name="l00087"></a>00087         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4),
<a name="l00088"></a>00088                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5),
<a name="l00089"></a>00089                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6),
<a name="l00090"></a>00090                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7));      
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00094"></a>00094   libmesh_error();
<a name="l00095"></a>00095   <span class="keywordflow">return</span> 0;
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="classlibMesh_1_1Hex.php#a37ceb0d8ddb7a17e0711e23bad85900e">00100</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Hex.php#a37ceb0d8ddb7a17e0711e23bad85900e">Hex::side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00101"></a>00101 <span class="keyword"></span>{
<a name="l00102"></a>00102   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Hex.php#a3fae4b2b56a9ebc908dffc0a87bdb8fd">n_sides</a>());
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   
<a name="l00106"></a>00106   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* face = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>;
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">// Think of a unit cube: (-1,1) x (-1,1)x (-1,1)</span>
<a name="l00109"></a>00109   <span class="keywordflow">switch</span> (i)
<a name="l00110"></a>00110     {
<a name="l00111"></a>00111     <span class="keywordflow">case</span> 0:  <span class="comment">// the face at z = -1</span>
<a name="l00112"></a>00112       {
<a name="l00113"></a>00113         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00114"></a>00114         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00115"></a>00115         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00116"></a>00116         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00117"></a>00117 
<a name="l00118"></a>00118         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(face);
<a name="l00119"></a>00119         <span class="keywordflow">return</span> ap;
<a name="l00120"></a>00120       }
<a name="l00121"></a>00121     <span class="keywordflow">case</span> 1:  <span class="comment">// the face at y = -1</span>
<a name="l00122"></a>00122       {
<a name="l00123"></a>00123         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00124"></a>00124         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00125"></a>00125         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00126"></a>00126         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00127"></a>00127         
<a name="l00128"></a>00128         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(face);
<a name="l00129"></a>00129         <span class="keywordflow">return</span> ap;
<a name="l00130"></a>00130       }
<a name="l00131"></a>00131     <span class="keywordflow">case</span> 2:  <span class="comment">// the face at x = 1</span>
<a name="l00132"></a>00132       {
<a name="l00133"></a>00133         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00134"></a>00134         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00135"></a>00135         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00136"></a>00136         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(face);
<a name="l00139"></a>00139         <span class="keywordflow">return</span> ap;
<a name="l00140"></a>00140       }
<a name="l00141"></a>00141     <span class="keywordflow">case</span> 3: <span class="comment">// the face at y = 1</span>
<a name="l00142"></a>00142       {
<a name="l00143"></a>00143         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00144"></a>00144         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00145"></a>00145         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00146"></a>00146         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00147"></a>00147         
<a name="l00148"></a>00148         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(face);
<a name="l00149"></a>00149         <span class="keywordflow">return</span> ap;
<a name="l00150"></a>00150       }
<a name="l00151"></a>00151     <span class="keywordflow">case</span> 4: <span class="comment">// the face at x = -1</span>
<a name="l00152"></a>00152       {
<a name="l00153"></a>00153         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00154"></a>00154         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00155"></a>00155         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00156"></a>00156         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(face);
<a name="l00159"></a>00159         <span class="keywordflow">return</span> ap;
<a name="l00160"></a>00160       }
<a name="l00161"></a>00161     <span class="keywordflow">case</span> 5: <span class="comment">// the face at z = 1</span>
<a name="l00162"></a>00162       {
<a name="l00163"></a>00163         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00164"></a>00164         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00165"></a>00165         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00166"></a>00166         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00167"></a>00167         
<a name="l00168"></a>00168         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(face);
<a name="l00169"></a>00169         <span class="keywordflow">return</span> ap;
<a name="l00170"></a>00170       }
<a name="l00171"></a>00171     <span class="keywordflow">default</span>:
<a name="l00172"></a>00172       {
<a name="l00173"></a>00173         libmesh_error();
<a name="l00174"></a>00174         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(face);
<a name="l00175"></a>00175         <span class="keywordflow">return</span> ap;
<a name="l00176"></a>00176       }
<a name="l00177"></a>00177     }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00180"></a>00180   libmesh_error();
<a name="l00181"></a>00181   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(face);
<a name="l00182"></a>00182   <span class="keywordflow">return</span> ap;
<a name="l00183"></a>00183 }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a><a class="code" href="classlibMesh_1_1Hex.php#ab80d94e7bcea248b694f6fe7b55bd1b1">00187</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Hex.php#ab80d94e7bcea248b694f6fe7b55bd1b1">Hex::is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00188"></a>00188                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00189"></a>00189 <span class="keyword"></span>{
<a name="l00190"></a>00190   libmesh_assert (c &lt; this-&gt;<a class="code" href="classlibMesh_1_1Hex.php#a384c60bbf615c0f80cbf5cfa580826b9">n_children</a>());
<a name="l00191"></a>00191   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Hex.php#a3fae4b2b56a9ebc908dffc0a87bdb8fd">n_sides</a>());
<a name="l00192"></a>00192   
<a name="l00193"></a>00193 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR  </span>
<a name="l00194"></a>00194 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 4; ++i)
<a name="l00195"></a>00195     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Hex8.php#a151d1322384be3349bf8993f03e6fdf8">Hex8::node_child_map</a>[<a class="code" href="classlibMesh_1_1Hex8.php#a84b21fba36e8bd586aad2501c7e69e9c">Hex8::side_nodes_map</a>[s][i]] == c)
<a name="l00196"></a>00196       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00197"></a>00197 <span class="preprocessor">#endif</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>  
<a name="l00199"></a>00199   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="classlibMesh_1_1Hex.php#ab8beba7f14257e0de3eb1cfa82c2860d">00204</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Hex.php#ab8beba7f14257e0de3eb1cfa82c2860d">Hex::quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00205"></a>00205 <span class="keyword"></span>{
<a name="l00206"></a>00206   <span class="keywordflow">switch</span> (q)
<a name="l00207"></a>00207     {
<a name="l00208"></a>00208       
<a name="l00213"></a>00213     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00214"></a>00214       {
<a name="l00215"></a>00215         <span class="comment">// Diagonal between node 0 and node 6</span>
<a name="l00216"></a>00216         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d06 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,6);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218         <span class="comment">// Diagonal between node 3 and node 5</span>
<a name="l00219"></a>00219         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d35 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(3,5);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221         <span class="comment">// Diagonal between node 1 and node 7</span>
<a name="l00222"></a>00222         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d17 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,7);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224         <span class="comment">// Diagonal between node 2 and node 4 </span>
<a name="l00225"></a>00225         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d24 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(2,4);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227         <span class="comment">// Find the biggest and smallest diagonals</span>
<a name="l00228"></a>00228         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d06, <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d35, <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d17, d24)));
<a name="l00229"></a>00229         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d06, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d35, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d17, d24)));
<a name="l00230"></a>00230 
<a name="l00231"></a>00231         libmesh_assert (max != 0.0);
<a name="l00232"></a>00232         
<a name="l00233"></a>00233         <span class="keywordflow">return</span> min / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>;
<a name="l00234"></a>00234 
<a name="l00235"></a>00235         <span class="keywordflow">break</span>;
<a name="l00236"></a>00236       }
<a name="l00237"></a>00237 
<a name="l00242"></a>00242     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00243"></a>00243       {
<a name="l00244"></a>00244 
<a name="l00248"></a>00248         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d01 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,1);
<a name="l00249"></a>00249         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d12 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,2);
<a name="l00250"></a>00250         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d23 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(2,3);
<a name="l00251"></a>00251         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d03 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,3);
<a name="l00252"></a>00252         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d45 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(4,5);
<a name="l00253"></a>00253         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d56 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(5,6);
<a name="l00254"></a>00254         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d67 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(6,7);
<a name="l00255"></a>00255         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d47 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(4,7);
<a name="l00256"></a>00256         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d04 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,4);
<a name="l00257"></a>00257         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d15 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,5);
<a name="l00258"></a>00258         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d37 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(3,7);
<a name="l00259"></a>00259         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d26 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(2,6);
<a name="l00260"></a>00260 
<a name="l00261"></a>00261         std::vector&lt;Real&gt; edge_ratios(12);
<a name="l00262"></a>00262         <span class="comment">// Front</span>
<a name="l00263"></a>00263         edge_ratios[0] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d01, d45) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d01, d45);
<a name="l00264"></a>00264         edge_ratios[1] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d04, d15) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d04, d15);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266         <span class="comment">// Right</span>
<a name="l00267"></a>00267         edge_ratios[2] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d15, d26) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d15, d26);
<a name="l00268"></a>00268         edge_ratios[3] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d12, d56) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d12, d56);
<a name="l00269"></a>00269 
<a name="l00270"></a>00270         <span class="comment">// Back</span>
<a name="l00271"></a>00271         edge_ratios[4] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d67, d23) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d67, d23);
<a name="l00272"></a>00272         edge_ratios[5] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d26, d37) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d26, d37);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274         <span class="comment">// Left</span>
<a name="l00275"></a>00275         edge_ratios[6] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d04, d37) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d04, d37);
<a name="l00276"></a>00276         edge_ratios[7] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d03, d47) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d03, d47);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278         <span class="comment">// Bottom</span>
<a name="l00279"></a>00279         edge_ratios[8] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d01, d23) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d01, d23);
<a name="l00280"></a>00280         edge_ratios[9] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d03, d12) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d03, d12);
<a name="l00281"></a>00281 
<a name="l00282"></a>00282         <span class="comment">// Top</span>
<a name="l00283"></a>00283         edge_ratios[10] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d45, d67) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d45, d67);
<a name="l00284"></a>00284         edge_ratios[11] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d56, d47) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d56, d47);
<a name="l00285"></a>00285         
<a name="l00286"></a>00286         <span class="keywordflow">return</span> *(std::min_element(edge_ratios.begin(), edge_ratios.end())) ;
<a name="l00287"></a>00287 
<a name="l00288"></a>00288         <span class="keywordflow">break</span>;
<a name="l00289"></a>00289       }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00296"></a>00296     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00297"></a>00297       {
<a name="l00298"></a>00298         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sqrt3 = 1.73205080756888;
<a name="l00299"></a>00299 
<a name="l00303"></a>00303         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d06 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,6);
<a name="l00304"></a>00304         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d17 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,7);
<a name="l00305"></a>00305         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d35 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(3,5);
<a name="l00306"></a>00306         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d24 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(2,4);
<a name="l00307"></a>00307         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> max_diag = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d06, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d17, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d35, d24)));
<a name="l00308"></a>00308 
<a name="l00309"></a>00309         libmesh_assert ( max_diag != 0.0 );
<a name="l00310"></a>00310 
<a name="l00314"></a>00314         std::vector&lt;Real&gt; edges(12);
<a name="l00315"></a>00315         edges[0]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,1);
<a name="l00316"></a>00316         edges[1]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,2);
<a name="l00317"></a>00317         edges[2]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(2,3);
<a name="l00318"></a>00318         edges[3]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,3);
<a name="l00319"></a>00319         edges[4]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(4,5);
<a name="l00320"></a>00320         edges[5]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(5,6);
<a name="l00321"></a>00321         edges[6]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(6,7);
<a name="l00322"></a>00322         edges[7]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(4,7);
<a name="l00323"></a>00323         edges[8]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,4);
<a name="l00324"></a>00324         edges[9]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,5);
<a name="l00325"></a>00325         edges[10] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(2,6);
<a name="l00326"></a>00326         edges[11] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(3,7);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> min_edge = *(std::min_element(edges.begin(), edges.end()));
<a name="l00329"></a>00329         <span class="keywordflow">return</span> sqrt3 * min_edge / max_diag ;
<a name="l00330"></a>00330         <span class="keywordflow">break</span>;
<a name="l00331"></a>00331       }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333       
<a name="l00338"></a>00338     <span class="keywordflow">default</span>:
<a name="l00339"></a>00339       {
<a name="l00340"></a>00340         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Hex.php#ab8beba7f14257e0de3eb1cfa82c2860d">Elem::quality</a>(q);
<a name="l00341"></a>00341       }
<a name="l00342"></a>00342     }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344     
<a name="l00345"></a>00345     <span class="comment">// Will never get here...</span>
<a name="l00346"></a>00346     libmesh_error();
<a name="l00347"></a>00347     <span class="keywordflow">return</span> 0.;
<a name="l00348"></a>00348 }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a><a class="code" href="classlibMesh_1_1Hex.php#a28c75ec0ac2871174bf11d066cfb9ec0">00352</a> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1Hex.php#a28c75ec0ac2871174bf11d066cfb9ec0">Hex::qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00353"></a>00353 <span class="keyword"></span>{
<a name="l00354"></a>00354   std::pair&lt;Real, Real&gt; bounds;
<a name="l00355"></a>00355   
<a name="l00356"></a>00356   <span class="keywordflow">switch</span> (q)
<a name="l00357"></a>00357     {
<a name="l00358"></a>00358 
<a name="l00359"></a>00359     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>:
<a name="l00360"></a>00360       bounds.first  = 1.;
<a name="l00361"></a>00361       bounds.second = 4.;
<a name="l00362"></a>00362       <span class="keywordflow">break</span>;
<a name="l00363"></a>00363       
<a name="l00364"></a>00364     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>:
<a name="l00365"></a>00365       bounds.first  = 0.;
<a name="l00366"></a>00366       bounds.second = 0.5;
<a name="l00367"></a>00367       <span class="keywordflow">break</span>;
<a name="l00368"></a>00368 
<a name="l00369"></a>00369     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>:
<a name="l00370"></a>00370     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>:
<a name="l00371"></a>00371       bounds.first  = 0.3;
<a name="l00372"></a>00372       bounds.second = 1.;
<a name="l00373"></a>00373       <span class="keywordflow">break</span>;
<a name="l00374"></a>00374 
<a name="l00375"></a>00375     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>:
<a name="l00376"></a>00376       bounds.first  = 1.;
<a name="l00377"></a>00377       bounds.second = 8.;
<a name="l00378"></a>00378       <span class="keywordflow">break</span>;
<a name="l00379"></a>00379 
<a name="l00380"></a>00380     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>:
<a name="l00381"></a>00381       bounds.first  = 0.5;
<a name="l00382"></a>00382       bounds.second = 1.;
<a name="l00383"></a>00383       <span class="keywordflow">break</span>;  
<a name="l00384"></a>00384       
<a name="l00385"></a>00385     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00386"></a>00386       bounds.first  = 0.6;
<a name="l00387"></a>00387       bounds.second = 1.;
<a name="l00388"></a>00388       <span class="keywordflow">break</span>;  
<a name="l00389"></a>00389 
<a name="l00390"></a>00390     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00391"></a>00391       bounds.first  = 0.;
<a name="l00392"></a>00392       bounds.second = 0.4;
<a name="l00393"></a>00393       <span class="keywordflow">break</span>;
<a name="l00394"></a>00394       
<a name="l00395"></a>00395     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00396"></a>00396       bounds.first  = 0.25;
<a name="l00397"></a>00397       bounds.second = 1.;
<a name="l00398"></a>00398       <span class="keywordflow">break</span>;
<a name="l00399"></a>00399       
<a name="l00400"></a>00400     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00401"></a>00401       bounds.first  = 0.65;
<a name="l00402"></a>00402       bounds.second = 1.;
<a name="l00403"></a>00403       <span class="keywordflow">break</span>;
<a name="l00404"></a>00404 
<a name="l00405"></a>00405     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>:
<a name="l00406"></a>00406       bounds.first  = 0.5;
<a name="l00407"></a>00407       bounds.second = 1.;
<a name="l00408"></a>00408       <span class="keywordflow">break</span>;
<a name="l00409"></a>00409       
<a name="l00410"></a>00410     <span class="keywordflow">default</span>:
<a name="l00411"></a>00411       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Invalid quality measure chosen.&quot;</span> &lt;&lt; std::endl;
<a name="l00412"></a>00412       bounds.first  = -1;
<a name="l00413"></a>00413       bounds.second = -1;
<a name="l00414"></a>00414     }
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   <span class="keywordflow">return</span> bounds;
<a name="l00417"></a>00417 }
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#a6e9d6de3ae30d3d6bc0a6e1448cd5eab">Hex::_second_order_vertex_child_number</a>[27] =
<a name="l00422"></a>00422 {
<a name="l00423"></a>00423   99,99,99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00424"></a>00424   0,1,2,0,0,1,2,3,4,5,6,5, <span class="comment">// Edges</span>
<a name="l00425"></a>00425   0,0,1,2,0,4,             <span class="comment">// Faces</span>
<a name="l00426"></a>00426   0                        <span class="comment">// Interior</span>
<a name="l00427"></a>00427 };
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#a4ae3ce3c4029164cb3500a2b4fd5244f">Hex::_second_order_vertex_child_index</a>[27] =
<a name="l00432"></a>00432 {
<a name="l00433"></a>00433   99,99,99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00434"></a>00434   1,2,3,3,4,5,6,7,5,6,7,7, <span class="comment">// Edges</span>
<a name="l00435"></a>00435   2,5,6,7,7,6,             <span class="comment">// Faces</span>
<a name="l00436"></a>00436   6                        <span class="comment">// Interior</span>
<a name="l00437"></a>00437 };
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#acedfa74acdbc8f3d86e480f13a0eaf8d">Hex::_second_order_adjacent_vertices</a>[12][2] = 
<a name="l00441"></a>00441 {
<a name="l00442"></a>00442   { 0,  1}, <span class="comment">// vertices adjacent to node 8 </span>
<a name="l00443"></a>00443   { 1,  2}, <span class="comment">// vertices adjacent to node 9 </span>
<a name="l00444"></a>00444   { 2,  3}, <span class="comment">// vertices adjacent to node 10 </span>
<a name="l00445"></a>00445   { 0,  3}, <span class="comment">// vertices adjacent to node 11</span>
<a name="l00446"></a>00446 
<a name="l00447"></a>00447   { 0,  4}, <span class="comment">// vertices adjacent to node 12</span>
<a name="l00448"></a>00448   { 1,  5}, <span class="comment">// vertices adjacent to node 13</span>
<a name="l00449"></a>00449   { 2,  6}, <span class="comment">// vertices adjacent to node 14</span>
<a name="l00450"></a>00450   { 3,  7}, <span class="comment">// vertices adjacent to node 15</span>
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   { 4,  5}, <span class="comment">// vertices adjacent to node 16</span>
<a name="l00453"></a>00453   { 5,  6}, <span class="comment">// vertices adjacent to node 17</span>
<a name="l00454"></a>00454   { 6,  7}, <span class="comment">// vertices adjacent to node 18</span>
<a name="l00455"></a>00455   { 4,  7}  <span class="comment">// vertices adjacent to node 19</span>
<a name="l00456"></a>00456 };
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
