<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_hex.h</div>  </div>
</div>
<div class="contents">
<a href="cell__hex_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_hex.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_hex_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_hex_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell_8h.php">cell.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// Hex class definition</span>
<a name="l00042"></a><a class="code" href="classlibMesh_1_1Hex.php">00042</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Hex.php">Hex</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Cell.php">Cell</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1Hex.php#a24b8e2e9704b99527c2fb6526dc4bb49">Hex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p);
<a name="l00051"></a>00051 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1Hex.php#a3fae4b2b56a9ebc908dffc0a87bdb8fd">00055</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#a3fae4b2b56a9ebc908dffc0a87bdb8fd">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00056"></a>00056 
<a name="l00060"></a><a class="code" href="classlibMesh_1_1Hex.php#ac923a2143a480679022864637b7a9150">00060</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#ac923a2143a480679022864637b7a9150">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00061"></a>00061 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1Hex.php#a524345ba28b93faa7be1ea1dec818aae">00065</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#a524345ba28b93faa7be1ea1dec818aae">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 12; }
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1Hex.php#a9e7512b1a5b98a52c7c6595d447f5f75">00070</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#a9e7512b1a5b98a52c7c6595d447f5f75">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00071"></a>00071   
<a name="l00075"></a><a class="code" href="classlibMesh_1_1Hex.php#a384c60bbf615c0f80cbf5cfa580826b9">00075</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#a384c60bbf615c0f80cbf5cfa580826b9">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <span class="comment">/*</span>
<a name="l00078"></a>00078 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00079"></a>00079 <span class="comment">   * specified side</span>
<a name="l00080"></a>00080 <span class="comment">   */</span>
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Hex.php#ab80d94e7bcea248b694f6fe7b55bd1b1">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00082"></a>00082                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00083"></a>00083   
<a name="l00089"></a>00089   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#ac2dd6b8e38c64266acda8aad158377a3">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00090"></a>00090 
<a name="l00095"></a>00095   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Hex.php#a37ceb0d8ddb7a17e0711e23bad85900e">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00096"></a>00096 
<a name="l00101"></a>00101   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Hex.php#ab8beba7f14257e0de3eb1cfa82c2860d">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00102"></a>00102 
<a name="l00108"></a>00108   std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1Hex.php#a28c75ec0ac2871174bf11d066cfb9ec0">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   
<a name="l00112"></a>00112 <span class="keyword">protected</span>:
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   
<a name="l00123"></a><a class="code" href="classlibMesh_1_1Hex.php#acedfa74acdbc8f3d86e480f13a0eaf8d">00123</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#acedfa74acdbc8f3d86e480f13a0eaf8d">_second_order_adjacent_vertices</a>[12][2];
<a name="l00124"></a>00124 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1Hex.php#a6e9d6de3ae30d3d6bc0a6e1448cd5eab">00128</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#a6e9d6de3ae30d3d6bc0a6e1448cd5eab">_second_order_vertex_child_number</a>[27];
<a name="l00129"></a>00129 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1Hex.php#a4ae3ce3c4029164cb3500a2b4fd5244f">00133</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Hex.php#a4ae3ce3c4029164cb3500a2b4fd5244f">_second_order_vertex_child_index</a>[27];
<a name="l00134"></a>00134 };
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00139"></a>00139 <span class="comment">// Hex class member functions</span>
<a name="l00140"></a>00140 <span class="keyword">inline</span>
<a name="l00141"></a><a class="code" href="classlibMesh_1_1Hex.php#a24b8e2e9704b99527c2fb6526dc4bb49">00141</a> <a class="code" href="classlibMesh_1_1Hex.php#a24b8e2e9704b99527c2fb6526dc4bb49">Hex::Hex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00142"></a>00142   <a class="code" href="classlibMesh_1_1Cell.php">Cell</a>(nn, <a class="code" href="classlibMesh_1_1Hex.php">Hex</a>::n_sides(), p) 
<a name="l00143"></a>00143 {
<a name="l00144"></a>00144 }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 } <span class="comment">// namespace libMesh</span>
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
