<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_hex16.C</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex16_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex16.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes cont&#39;d</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex16_8h.php">cell_inf_hex16.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="edge__inf__edge2_8h.php">edge_inf_edge2.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__quad8_8h.php">face_quad8.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad6_8h.php">face_inf_quad6.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// InfHex16 class static member initializations</span>
<a name="l00041"></a>00041 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex16.php#a142118f40764aa04546403d38be8bf88">InfHex16::side_nodes_map</a>[5][8] =
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   { 0, 1, 2, 3, 8, 9, 10, 11},   <span class="comment">// Side 0</span>
<a name="l00044"></a>00044   { 0, 1, 4, 5, 8, 12, 99, 99},  <span class="comment">// Side 1</span>
<a name="l00045"></a>00045   { 1, 2, 5, 6, 9, 13, 99, 99},  <span class="comment">// Side 2</span>
<a name="l00046"></a>00046   { 2, 3, 6, 7, 10, 14, 99, 99}, <span class="comment">// Side 3</span>
<a name="l00047"></a>00047   { 3, 0, 7, 4, 11, 15, 99, 99}  <span class="comment">// Side 4</span>
<a name="l00048"></a>00048 };
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex16.php#aeaf439f872fcd37e3ea171bcfe43151b">InfHex16::edge_nodes_map</a>[8][3] =
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   { 0, 1, 8},  <span class="comment">// Side 0</span>
<a name="l00053"></a>00053   { 1, 2, 9},  <span class="comment">// Side 1</span>
<a name="l00054"></a>00054   { 2, 3, 10}, <span class="comment">// Side 2</span>
<a name="l00055"></a>00055   { 0, 3, 11}, <span class="comment">// Side 3</span>
<a name="l00056"></a>00056   { 0, 4, 99}, <span class="comment">// Side 4</span>
<a name="l00057"></a>00057   { 1, 5, 99}, <span class="comment">// Side 5</span>
<a name="l00058"></a>00058   { 2, 6, 99}, <span class="comment">// Side 6</span>
<a name="l00059"></a>00059   { 3, 7, 99}  <span class="comment">// Side 7</span>
<a name="l00060"></a>00060 };
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00064"></a>00064 <span class="comment">// InfHex16 class member functions</span>
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1InfHex16.php#a0b7ff4091b2537e01eb8afadeefe3321">00066</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex16.php#a0b7ff4091b2537e01eb8afadeefe3321">InfHex16::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00067"></a>00067 <span class="keyword"></span>{
<a name="l00068"></a>00068   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00069"></a>00069     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00070"></a>00070   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1InfHex16.php#a8b595997a018ff1f6b00eacc1bfffc52">00073</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex16.php#a8b595997a018ff1f6b00eacc1bfffc52">InfHex16::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00074"></a>00074 <span class="keyword"></span>{
<a name="l00075"></a>00075   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00076"></a>00076     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00077"></a>00077   <span class="keywordflow">if</span> (i &gt; 11)
<a name="l00078"></a>00078     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00079"></a>00079   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1InfHex16.php#ac303f9c4145fdeaa4feca5a232586b7a">00082</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex16.php#ac303f9c4145fdeaa4feca5a232586b7a">InfHex16::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00083"></a>00083 <span class="keyword"></span>{
<a name="l00084"></a>00084   <span class="keywordflow">if</span> (i &gt; 11)
<a name="l00085"></a>00085     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00086"></a>00086   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1InfHex16.php#ac48c9a100f81f6b27497d7171251c883">00089</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex16.php#ac48c9a100f81f6b27497d7171251c883">InfHex16::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00090"></a>00090                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00091"></a>00091 <span class="keyword"></span>{
<a name="l00092"></a>00092   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00093"></a>00093   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 8; ++i)
<a name="l00094"></a>00094     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfHex16.php#a142118f40764aa04546403d38be8bf88">side_nodes_map</a>[s][i] == n)
<a name="l00095"></a>00095       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00096"></a>00096   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00097"></a>00097 }
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1InfHex16.php#a915bf7244639e326d75c9a1eca91eaef">00099</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex16.php#a915bf7244639e326d75c9a1eca91eaef">InfHex16::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00100"></a>00100                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00101"></a>00101 <span class="keyword"></span>{
<a name="l00102"></a>00102   libmesh_assert(e &lt; <a class="code" href="classlibMesh_1_1InfHex.php#add6f00e7fee9ea06dfabb98d5c465f62">n_edges</a>());
<a name="l00103"></a>00103   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00104"></a>00104     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfHex16.php#aeaf439f872fcd37e3ea171bcfe43151b">edge_nodes_map</a>[e][i] == n)
<a name="l00105"></a>00105       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00106"></a>00106   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1InfHex16.php#a5c614d15bf376a0d5f9092902b4bfdce">00109</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex16.php#a5c614d15bf376a0d5f9092902b4bfdce">InfHex16::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00110"></a>00110                                     <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00111"></a>00111 <span class="keyword"></span>{
<a name="l00112"></a>00112   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="keywordflow">if</span> (proxy)
<a name="l00115"></a>00115     {
<a name="l00116"></a>00116       <span class="keywordflow">switch</span> (i)
<a name="l00117"></a>00117         {
<a name="l00118"></a>00118           <span class="comment">// base</span>
<a name="l00119"></a>00119         <span class="keywordflow">case</span> 0:
<a name="l00120"></a>00120           {
<a name="l00121"></a>00121             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Quad8,InfHex16&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00122"></a>00122             <span class="keywordflow">return</span> ap;
<a name="l00123"></a>00123           }
<a name="l00124"></a>00124           <span class="comment">// ifem sides</span>
<a name="l00125"></a>00125         <span class="keywordflow">case</span> 1:
<a name="l00126"></a>00126         <span class="keywordflow">case</span> 2:
<a name="l00127"></a>00127         <span class="keywordflow">case</span> 3:
<a name="l00128"></a>00128         <span class="keywordflow">case</span> 4:
<a name="l00129"></a>00129           {
<a name="l00130"></a>00130             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;InfQuad6,InfHex16&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00131"></a>00131             <span class="keywordflow">return</span> ap;
<a name="l00132"></a>00132           }
<a name="l00133"></a>00133         <span class="keywordflow">default</span>:
<a name="l00134"></a>00134           libmesh_error();
<a name="l00135"></a>00135         }
<a name="l00136"></a>00136     }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keywordflow">else</span>
<a name="l00139"></a>00139     {
<a name="l00140"></a>00140       <span class="comment">// Think of a unit cube: (-1,1) x (-1,1)x (1,1)</span>
<a name="l00141"></a>00141       <span class="keywordflow">switch</span> (i)
<a name="l00142"></a>00142         {
<a name="l00143"></a>00143         <span class="keywordflow">case</span> 0: <span class="comment">// the base face</span>
<a name="l00144"></a>00144           {
<a name="l00145"></a>00145             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad8.php">Quad8</a>);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147             <span class="comment">// Only here, the face element&#39;s normal points inward</span>
<a name="l00148"></a>00148             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00149"></a>00149             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00150"></a>00150             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00151"></a>00151             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00152"></a>00152             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00153"></a>00153             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00154"></a>00154             face-&gt;set_node(6) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(10);
<a name="l00155"></a>00155             face-&gt;set_node(7) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(11);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157             <span class="keywordflow">return</span> face;
<a name="l00158"></a>00158           }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160         <span class="keywordflow">case</span> 1:  <span class="comment">// connecting to another infinite element</span>
<a name="l00161"></a>00161           {
<a name="l00162"></a>00162             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00165"></a>00165             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00166"></a>00166             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00167"></a>00167             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00168"></a>00168             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00169"></a>00169             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(12);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171             <span class="keywordflow">return</span> face;
<a name="l00172"></a>00172           }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174         <span class="keywordflow">case</span> 2:  <span class="comment">// connecting to another infinite element</span>
<a name="l00175"></a>00175           {
<a name="l00176"></a>00176             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00179"></a>00179             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00180"></a>00180             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00181"></a>00181             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00182"></a>00182             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00183"></a>00183             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(13);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185             <span class="keywordflow">return</span> face;
<a name="l00186"></a>00186           }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188         <span class="keywordflow">case</span> 3:  <span class="comment">// connecting to another infinite element</span>
<a name="l00189"></a>00189           {
<a name="l00190"></a>00190             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00191"></a>00191         
<a name="l00192"></a>00192             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00193"></a>00193             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00194"></a>00194             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00195"></a>00195             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00196"></a>00196             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(10);
<a name="l00197"></a>00197             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(14);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199             <span class="keywordflow">return</span> face;
<a name="l00200"></a>00200           }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202         <span class="keywordflow">case</span> 4:  <span class="comment">// connecting to another infinite element</span>
<a name="l00203"></a>00203           {
<a name="l00204"></a>00204             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00205"></a>00205 
<a name="l00206"></a>00206             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00207"></a>00207             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00208"></a>00208             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00209"></a>00209             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00210"></a>00210             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(11);
<a name="l00211"></a>00211             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(15);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213             <span class="keywordflow">return</span> face;
<a name="l00214"></a>00214           }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216         <span class="keywordflow">default</span>:
<a name="l00217"></a>00217           {
<a name="l00218"></a>00218             libmesh_error();
<a name="l00219"></a>00219             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00220"></a>00220           }
<a name="l00221"></a>00221         }
<a name="l00222"></a>00222     }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   
<a name="l00225"></a>00225   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00226"></a>00226   libmesh_error();
<a name="l00227"></a>00227   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00228"></a>00228 }
<a name="l00229"></a>00229 
<a name="l00230"></a><a class="code" href="classlibMesh_1_1InfHex16.php#ac2a06690b542c6c7a561962ac2a34fd4">00230</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex16.php#ac2a06690b542c6c7a561962ac2a34fd4">InfHex16::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00231"></a>00231 <span class="keyword"></span>{
<a name="l00232"></a>00232   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#add6f00e7fee9ea06dfabb98d5c465f62">n_edges</a>());
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   <span class="keywordflow">if</span> (i &lt; 4) <span class="comment">// base edges</span>
<a name="l00235"></a>00235     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;Edge3,InfHex16&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00236"></a>00236   <span class="comment">// infinite edges</span>
<a name="l00237"></a>00237   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;InfEdge2,InfHex16&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a><a class="code" href="classlibMesh_1_1InfHex16.php#a50f1069c6cb170bc56abab0e4b47dcdc">00241</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfHex16.php#a50f1069c6cb170bc56abab0e4b47dcdc">InfHex16::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00242"></a>00242                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00243"></a>00243                             std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00244"></a>00244 <span class="keyword"></span>{
<a name="l00245"></a>00245   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL);
<a name="l00246"></a>00246   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex16.php#abea90cd9b9abde98f84e54e375af2936">n_sub_elem</a>());
<a name="l00247"></a>00247   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   <span class="keywordflow">switch</span> (iop)
<a name="l00250"></a>00250     {
<a name="l00251"></a>00251     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00252"></a>00252       {
<a name="l00253"></a>00253         <span class="keywordflow">switch</span> (sc)
<a name="l00254"></a>00254           {
<a name="l00255"></a>00255           <span class="keywordflow">case</span> 0:
<a name="l00256"></a>00256 
<a name="l00257"></a>00257             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00258"></a>00258             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00259"></a>00259             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00260"></a>00260             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00261"></a>00261             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00262"></a>00262             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00263"></a>00263             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00264"></a>00264             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00265"></a>00265             <span class="keywordflow">return</span>;
<a name="l00266"></a>00266       
<a name="l00267"></a>00267           <span class="keywordflow">default</span>:
<a name="l00268"></a>00268             libmesh_error();
<a name="l00269"></a>00269       
<a name="l00270"></a>00270           }
<a name="l00271"></a>00271       }
<a name="l00272"></a>00272 
<a name="l00273"></a>00273     <span class="keywordflow">default</span>:
<a name="l00274"></a>00274       libmesh_error();
<a name="l00275"></a>00275     }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   libmesh_error();
<a name="l00278"></a>00278 }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a><a class="code" href="classlibMesh_1_1InfHex16.php#af77ade93f0c9e45e43c1869f9e0bd449">00283</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex16.php#af77ade93f0c9e45e43c1869f9e0bd449">InfHex16::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00284"></a>00284                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00285"></a>00285 <span class="keyword"></span>{ 
<a name="l00286"></a>00286   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#a6f7d6506e7030ef1c04e8060cf7718d4">n_vertices</a>());
<a name="l00287"></a>00287   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classlibMesh_1_1InfHex16.php#a976ec7d2a848bd9442d922a1eaa285cd">n_nodes</a>());
<a name="l00288"></a>00288   libmesh_assert (v &lt;  2);
<a name="l00289"></a>00289   <span class="comment">// note that the _second_order_adjacent_vertices matrix is</span>
<a name="l00290"></a>00290   <span class="comment">// stored in \p InfHex</span>
<a name="l00291"></a>00291   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfHex.php#a1ffa1361509b318958f7da6eb8daa5cd">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#a6f7d6506e7030ef1c04e8060cf7718d4">n_vertices</a>()][v]; 
<a name="l00292"></a>00292 }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00297"></a><a class="code" href="classlibMesh_1_1InfHex16.php#ac993258d77baa221d48f516a58f4a447">00297</a> <a class="code" href="classlibMesh_1_1InfHex16.php#ac993258d77baa221d48f516a58f4a447">InfHex16::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00298"></a>00298 <span class="keyword"></span>{
<a name="l00299"></a>00299   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#a6f7d6506e7030ef1c04e8060cf7718d4">n_vertices</a>());
<a name="l00300"></a>00300   libmesh_assert (n &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex16.php#a976ec7d2a848bd9442d922a1eaa285cd">n_nodes</a>());
<a name="l00301"></a>00301   <span class="comment">/*</span>
<a name="l00302"></a>00302 <span class="comment">   * the _second_order_vertex_child_* vectors are</span>
<a name="l00303"></a>00303 <span class="comment">   * stored in cell_inf_hex.C, since they are identical</span>
<a name="l00304"></a>00304 <span class="comment">   * for InfHex16 and InfHex18</span>
<a name="l00305"></a>00305 <span class="comment">   */</span>
<a name="l00306"></a>00306   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00307"></a>00307     (<a class="code" href="classlibMesh_1_1InfHex.php#ad0088faa57a16eaef4f4cfa32ea0b013">_second_order_vertex_child_number</a>[n],
<a name="l00308"></a>00308      <a class="code" href="classlibMesh_1_1InfHex.php#a312673bd7501104d9abdf02ab6ab4869">_second_order_vertex_child_index</a>[n]);
<a name="l00309"></a>00309 }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>
<a name="l00317"></a>00317 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfHex16.php#aaaddad1b4fcfd5eba8898f65854b7075">InfHex16::_embedding_matrix</a>[4][16][16] =
<a name="l00318"></a>00318 {
<a name="l00319"></a>00319   <span class="comment">// embedding matrix for child 0</span>
<a name="l00320"></a>00320   {
<a name="l00321"></a>00321     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15 th parent Node</span>
<a name="l00322"></a>00322     {         1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00323"></a>00323     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00324"></a>00324     {       -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00325"></a>00325     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00326"></a>00326     {         0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 4</span>
<a name="l00327"></a>00327     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00328"></a>00328     {         0.0,        0.0,        0.0,        0.0,      -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5}, <span class="comment">// 6</span>
<a name="l00329"></a>00329     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 7</span>
<a name="l00330"></a>00330     {       0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00331"></a>00331     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.75,      0.375,       0.25,      0.375,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00332"></a>00332     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.25,      0.375,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00333"></a>00333     {       0.375,        0.0,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00334"></a>00334     {         0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0}, <span class="comment">// 12</span>
<a name="l00335"></a>00335     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.75,      0.375,       0.25,      0.375}, <span class="comment">// 13</span>
<a name="l00336"></a>00336     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.25,      0.375,       0.75}, <span class="comment">// 14</span>
<a name="l00337"></a>00337     {         0.0,        0.0,        0.0,        0.0,      0.375,        0.0,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75}  <span class="comment">// 15</span>
<a name="l00338"></a>00338   },
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <span class="comment">// embedding matrix for child 1</span>
<a name="l00341"></a>00341   {
<a name="l00342"></a>00342     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15 th parent Node</span>
<a name="l00343"></a>00343     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00344"></a>00344     {         0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00345"></a>00345     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00346"></a>00346     {       -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00347"></a>00347     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0}, <span class="comment">// 4</span>
<a name="l00348"></a>00348     {         0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00349"></a>00349     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00350"></a>00350     {         0.0,        0.0,        0.0,        0.0,      -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5}, <span class="comment">// 7</span>
<a name="l00351"></a>00351     {      -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00352"></a>00352     {         0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00353"></a>00353     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.75,      0.375,       0.25,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00354"></a>00354     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.75,      0.375,       0.25,      0.375,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00355"></a>00355     {         0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0}, <span class="comment">// 12</span>
<a name="l00356"></a>00356     {         0.0,        0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0}, <span class="comment">// 13</span>
<a name="l00357"></a>00357     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.75,      0.375,       0.25}, <span class="comment">// 14</span>
<a name="l00358"></a>00358     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.75,      0.375,       0.25,      0.375}  <span class="comment">// 15</span>
<a name="l00359"></a>00359   },
<a name="l00360"></a>00360 
<a name="l00361"></a>00361   <span class="comment">// embedding matrix for child 2</span>
<a name="l00362"></a>00362   {
<a name="l00363"></a>00363     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15 th parent Node</span>
<a name="l00364"></a>00364     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00365"></a>00365     {       -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00366"></a>00366     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00367"></a>00367     {         0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00368"></a>00368     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 4</span>
<a name="l00369"></a>00369     {         0.0,        0.0,        0.0,        0.0,      -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5}, <span class="comment">// 5</span>
<a name="l00370"></a>00370     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 6</span>
<a name="l00371"></a>00371     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 7</span>
<a name="l00372"></a>00372     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.25,      0.375,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00373"></a>00373     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.25,      0.375,       0.75,      0.375,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00374"></a>00374     {         0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00375"></a>00375     {      -0.125,        0.0,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00376"></a>00376     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.25,      0.375,       0.75}, <span class="comment">// 12</span>
<a name="l00377"></a>00377     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.25,      0.375,       0.75,      0.375}, <span class="comment">// 13</span>
<a name="l00378"></a>00378     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 14</span>
<a name="l00379"></a>00379     {         0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75}  <span class="comment">// 15</span>
<a name="l00380"></a>00380   },
<a name="l00381"></a>00381 
<a name="l00382"></a>00382   <span class="comment">// embedding matrix for child 3</span>
<a name="l00383"></a>00383   {
<a name="l00384"></a>00384     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15 th parent Node</span>
<a name="l00385"></a>00385     {       -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00386"></a>00386     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00387"></a>00387     {         0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00388"></a>00388     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00389"></a>00389     {         0.0,        0.0,        0.0,        0.0,      -0.25,      -0.25,      -0.25,      -0.25,        0.0,        0.0,        0.0,        0.0,        0.5,        0.5,        0.5,        0.5}, <span class="comment">// 4</span>
<a name="l00390"></a>00390     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00391"></a>00391     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00392"></a>00392     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 7</span>
<a name="l00393"></a>00393     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.75,      0.375,       0.25,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00394"></a>00394     {         0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00395"></a>00395     {         0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00396"></a>00396     {     -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.25,      0.375,       0.75,      0.375,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00397"></a>00397     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,      0.375,       0.75,      0.375,       0.25}, <span class="comment">// 12</span>
<a name="l00398"></a>00398     {         0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0}, <span class="comment">// 13</span>
<a name="l00399"></a>00399     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 14</span>
<a name="l00400"></a>00400     {         0.0,        0.0,        0.0,        0.0,    -0.1875,    -0.1875,    -0.1875,    -0.1875,        0.0,        0.0,        0.0,        0.0,       0.25,      0.375,       0.75,      0.375}  <span class="comment">// 15</span>
<a name="l00401"></a>00401   }
<a name="l00402"></a>00402 };
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 <span class="preprocessor">#endif</span>
<a name="l00407"></a>00407 <span class="preprocessor"></span>
<a name="l00408"></a>00408 } <span class="comment">// namespace libMesh</span>
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 <span class="preprocessor">#endif  // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
