<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_hex18.C</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex18_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex18.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes cont&#39;d</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex18_8h.php">cell_inf_hex18.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="edge__inf__edge2_8h.php">edge_inf_edge2.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__quad9_8h.php">face_quad9.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad6_8h.php">face_inf_quad6.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// InfHex18 class static member initializations</span>
<a name="l00041"></a>00041 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#abe894dcea6c59ce698addd2f3616db41">InfHex18::side_nodes_map</a>[5][9] =
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   { 0, 1, 2, 3, 8, 9, 10, 11, 16},   <span class="comment">// Side 0</span>
<a name="l00044"></a>00044   { 0, 1, 4, 5, 8, 12, 99, 99, 99},  <span class="comment">// Side 1</span>
<a name="l00045"></a>00045   { 1, 2, 5, 6, 9, 13, 99, 99, 99},  <span class="comment">// Side 2</span>
<a name="l00046"></a>00046   { 2, 3, 6, 7, 10, 14, 99, 99, 99}, <span class="comment">// Side 3</span>
<a name="l00047"></a>00047   { 3, 0, 7, 4, 11, 15, 99, 99, 99}  <span class="comment">// Side 4</span>
<a name="l00048"></a>00048 };
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a4d8f6cb8905f2177d46934e92c5fa187">InfHex18::edge_nodes_map</a>[8][3] =
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   { 0, 1, 8},  <span class="comment">// Side 0</span>
<a name="l00053"></a>00053   { 1, 2, 9},  <span class="comment">// Side 1</span>
<a name="l00054"></a>00054   { 2, 3, 10}, <span class="comment">// Side 2</span>
<a name="l00055"></a>00055   { 0, 3, 11}, <span class="comment">// Side 3</span>
<a name="l00056"></a>00056   { 0, 4, 99}, <span class="comment">// Side 4</span>
<a name="l00057"></a>00057   { 1, 5, 99}, <span class="comment">// Side 5</span>
<a name="l00058"></a>00058   { 2, 6, 99}, <span class="comment">// Side 6</span>
<a name="l00059"></a>00059   { 3, 7, 99}  <span class="comment">// Side 7</span>
<a name="l00060"></a>00060 };
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00063"></a>00063 <span class="comment">// InfHex18 class member functions</span>
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a2eb526fb3551b636668db72ff532d222">00065</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a2eb526fb3551b636668db72ff532d222">InfHex18::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00066"></a>00066 <span class="keyword"></span>{
<a name="l00067"></a>00067   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00068"></a>00068     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00069"></a>00069   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00070"></a>00070 }
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a6abdc04d35415210c17fea4e5430a124">00072</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a6abdc04d35415210c17fea4e5430a124">InfHex18::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00073"></a>00073 <span class="keyword"></span>{
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00075"></a>00075     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00076"></a>00076   <span class="keywordflow">if</span> (i &gt; 11)
<a name="l00077"></a>00077     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00078"></a>00078   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1InfHex18.php#ae23ab10590550f20b7b0b55bdf29d109">00081</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#ae23ab10590550f20b7b0b55bdf29d109">InfHex18::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00082"></a>00082 <span class="keyword"></span>{
<a name="l00083"></a>00083   <span class="keywordflow">if</span> (i &gt; 11)
<a name="l00084"></a>00084     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00085"></a>00085   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a49087b9b03d2d5606782941ed81a0656">00088</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a49087b9b03d2d5606782941ed81a0656">InfHex18::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00089"></a>00089                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00090"></a>00090 <span class="keyword"></span>{
<a name="l00091"></a>00091   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00092"></a>00092   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 9; ++i)
<a name="l00093"></a>00093     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfHex18.php#abe894dcea6c59ce698addd2f3616db41">side_nodes_map</a>[s][i] == n)
<a name="l00094"></a>00094       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00095"></a>00095   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a3a765de726c9eee725b22f7b05727b19">00098</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a3a765de726c9eee725b22f7b05727b19">InfHex18::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00099"></a>00099                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00100"></a>00100 <span class="keyword"></span>{
<a name="l00101"></a>00101   libmesh_assert(e &lt; <a class="code" href="classlibMesh_1_1InfHex.php#add6f00e7fee9ea06dfabb98d5c465f62">n_edges</a>());
<a name="l00102"></a>00102   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00103"></a>00103     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfHex18.php#a4d8f6cb8905f2177d46934e92c5fa187">edge_nodes_map</a>[e][i] == n)
<a name="l00104"></a>00104       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00105"></a>00105   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00106"></a>00106 }
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1InfHex18.php#ac613f40883fa608723b9290201703c2f">00108</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#ac613f40883fa608723b9290201703c2f">InfHex18::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00109"></a>00109 <span class="keyword"></span>{
<a name="l00110"></a>00110   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="comment">// Think of a unit cube: (-1,1) x (-1,1) x (1,1)</span>
<a name="l00113"></a>00113   <span class="keywordflow">switch</span> (s)
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115     <span class="keywordflow">case</span> 0: <span class="comment">// the base face</span>
<a name="l00116"></a>00116 
<a name="l00117"></a>00117       <span class="keywordflow">return</span>
<a name="l00118"></a>00118         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16));
<a name="l00119"></a>00119 
<a name="l00120"></a>00120           
<a name="l00121"></a>00121     <span class="keywordflow">case</span> 1:  <span class="comment">// the face at y = -1</span>
<a name="l00122"></a>00122 
<a name="l00123"></a>00123       <span class="keywordflow">return</span>
<a name="l00124"></a>00124         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00125"></a>00125                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00126"></a>00126                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5),
<a name="l00127"></a>00127                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4));
<a name="l00128"></a>00128       
<a name="l00129"></a>00129     <span class="keywordflow">case</span> 2:  <span class="comment">// the face at x = 1</span>
<a name="l00130"></a>00130 
<a name="l00131"></a>00131       <span class="keywordflow">return</span>
<a name="l00132"></a>00132         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00133"></a>00133                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00134"></a>00134                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6),
<a name="l00135"></a>00135                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5));
<a name="l00136"></a>00136 
<a name="l00137"></a>00137     <span class="keywordflow">case</span> 3: <span class="comment">// the face at y = 1</span>
<a name="l00138"></a>00138 
<a name="l00139"></a>00139       <span class="keywordflow">return</span>
<a name="l00140"></a>00140         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00141"></a>00141                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3),
<a name="l00142"></a>00142                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7),
<a name="l00143"></a>00143                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6));
<a name="l00144"></a>00144       
<a name="l00145"></a>00145     <span class="keywordflow">case</span> 4: <span class="comment">// the face at x = -1</span>
<a name="l00146"></a>00146       
<a name="l00147"></a>00147       <span class="keywordflow">return</span>
<a name="l00148"></a>00148         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3),
<a name="l00149"></a>00149                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00150"></a>00150                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4),
<a name="l00151"></a>00151                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7));
<a name="l00152"></a>00152     }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00155"></a>00155   libmesh_error();
<a name="l00156"></a>00156   <span class="keywordflow">return</span> 0;
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a382a612d5538deda8c19c8e663060484">00161</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex18.php#a382a612d5538deda8c19c8e663060484">InfHex18::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00162"></a>00162                                     <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00163"></a>00163 <span class="keyword"></span>{
<a name="l00164"></a>00164   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   <span class="keywordflow">if</span> (proxy)
<a name="l00167"></a>00167     {
<a name="l00168"></a>00168       <span class="keywordflow">switch</span> (i)
<a name="l00169"></a>00169         {
<a name="l00170"></a>00170           <span class="comment">// base</span>
<a name="l00171"></a>00171         <span class="keywordflow">case</span> 0:
<a name="l00172"></a>00172           {
<a name="l00173"></a>00173             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Quad9,InfHex18&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00174"></a>00174             <span class="keywordflow">return</span> ap;
<a name="l00175"></a>00175           }
<a name="l00176"></a>00176           <span class="comment">// ifem sides</span>
<a name="l00177"></a>00177         <span class="keywordflow">case</span> 1:
<a name="l00178"></a>00178         <span class="keywordflow">case</span> 2:
<a name="l00179"></a>00179         <span class="keywordflow">case</span> 3:
<a name="l00180"></a>00180         <span class="keywordflow">case</span> 4:
<a name="l00181"></a>00181           {
<a name="l00182"></a>00182             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;InfQuad6,InfHex18&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00183"></a>00183             <span class="keywordflow">return</span> ap;
<a name="l00184"></a>00184           }
<a name="l00185"></a>00185         <span class="keywordflow">default</span>:
<a name="l00186"></a>00186           libmesh_error();
<a name="l00187"></a>00187         }
<a name="l00188"></a>00188     }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="keywordflow">else</span>
<a name="l00191"></a>00191     {
<a name="l00192"></a>00192       <span class="comment">// Think of a unit cube: (-1,1) x (-1,1) x (1,1)</span>
<a name="l00193"></a>00193       <span class="keywordflow">switch</span> (i)
<a name="l00194"></a>00194         {
<a name="l00195"></a>00195         <span class="keywordflow">case</span> 0: <span class="comment">// the base face</span>
<a name="l00196"></a>00196           {
<a name="l00197"></a>00197             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad9.php">Quad9</a>);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199             <span class="comment">// This is the exception: all other face elements&#39; normals</span>
<a name="l00200"></a>00200             <span class="comment">// point outwards; but the base element&#39;s normal points inward</span>
<a name="l00201"></a>00201             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00202"></a>00202             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00203"></a>00203             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00204"></a>00204             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00205"></a>00205             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00206"></a>00206             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00207"></a>00207             face-&gt;set_node(6) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(10);
<a name="l00208"></a>00208             face-&gt;set_node(7) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(11);
<a name="l00209"></a>00209             face-&gt;set_node(8) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(16);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211             <span class="keywordflow">return</span> face;
<a name="l00212"></a>00212           }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214         <span class="keywordflow">case</span> 1:  <span class="comment">// connecting to another infinite element</span>
<a name="l00215"></a>00215           {
<a name="l00216"></a>00216             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00217"></a>00217         
<a name="l00218"></a>00218             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00219"></a>00219             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00220"></a>00220             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00221"></a>00221             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00222"></a>00222             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00223"></a>00223             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(12);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225             <span class="keywordflow">return</span> face;
<a name="l00226"></a>00226           }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228         <span class="keywordflow">case</span> 2:  <span class="comment">// connecting to another infinite element</span>
<a name="l00229"></a>00229           {
<a name="l00230"></a>00230             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00233"></a>00233             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00234"></a>00234             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00235"></a>00235             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00236"></a>00236             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00237"></a>00237             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(13);
<a name="l00238"></a>00238 
<a name="l00239"></a>00239             <span class="keywordflow">return</span> face;
<a name="l00240"></a>00240           }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242         <span class="keywordflow">case</span> 3:  <span class="comment">// connecting to another infinite element</span>
<a name="l00243"></a>00243           {
<a name="l00244"></a>00244             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00245"></a>00245         
<a name="l00246"></a>00246             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00247"></a>00247             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00248"></a>00248             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00249"></a>00249             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00250"></a>00250             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(10);
<a name="l00251"></a>00251             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(14);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253             <span class="keywordflow">return</span> face;
<a name="l00254"></a>00254           }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256         <span class="keywordflow">case</span> 4:  <span class="comment">// connecting to another infinite element</span>
<a name="l00257"></a>00257           {
<a name="l00258"></a>00258             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00261"></a>00261             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00262"></a>00262             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00263"></a>00263             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00264"></a>00264             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(11);
<a name="l00265"></a>00265             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(15);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267             <span class="keywordflow">return</span> face;
<a name="l00268"></a>00268           }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270         <span class="keywordflow">default</span>:
<a name="l00271"></a>00271           {
<a name="l00272"></a>00272             libmesh_error();
<a name="l00273"></a>00273             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00274"></a>00274           }
<a name="l00275"></a>00275         }
<a name="l00276"></a>00276     }
<a name="l00277"></a>00277   
<a name="l00278"></a>00278   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00279"></a>00279   libmesh_error();
<a name="l00280"></a>00280   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00281"></a>00281 }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a086e1416d18ec3d65257be76c2686fa8">00285</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex18.php#a086e1416d18ec3d65257be76c2686fa8">InfHex18::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00286"></a>00286 <span class="keyword"></span>{
<a name="l00287"></a>00287   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#add6f00e7fee9ea06dfabb98d5c465f62">n_edges</a>());
<a name="l00288"></a>00288 
<a name="l00289"></a>00289   <span class="keywordflow">if</span> (i &lt; 4) <span class="comment">// base edges</span>
<a name="l00290"></a>00290     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;Edge3,InfHex18&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00291"></a>00291   <span class="comment">// infinite edges</span>
<a name="l00292"></a>00292   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;InfEdge2,InfHex18&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00293"></a>00293 }
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a4e222598d9e050d6fdac7357df197f50">00297</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a4e222598d9e050d6fdac7357df197f50">InfHex18::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00298"></a>00298                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00299"></a>00299                             std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00300"></a>00300 <span class="keyword"></span>{
<a name="l00301"></a>00301   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL);
<a name="l00302"></a>00302   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex18.php#af1f626782df1929bdb2e202508cefc56">n_sub_elem</a>());
<a name="l00303"></a>00303   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="keywordflow">switch</span> (iop)
<a name="l00306"></a>00306     {
<a name="l00307"></a>00307     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00308"></a>00308       {
<a name="l00309"></a>00309         <span class="keywordflow">switch</span> (sc)
<a name="l00310"></a>00310           {
<a name="l00311"></a>00311           <span class="keywordflow">case</span> 0:
<a name="l00312"></a>00312 
<a name="l00313"></a>00313             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00314"></a>00314             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00315"></a>00315             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00316"></a>00316             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00317"></a>00317             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00318"></a>00318             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(12)+1;
<a name="l00319"></a>00319             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00320"></a>00320             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15)+1;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322             <span class="keywordflow">return</span>;
<a name="l00323"></a>00323       
<a name="l00324"></a>00324           <span class="keywordflow">case</span> 1:
<a name="l00325"></a>00325 
<a name="l00326"></a>00326             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00327"></a>00327             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00328"></a>00328             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00329"></a>00329             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00330"></a>00330             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(12)+1;
<a name="l00331"></a>00331             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00332"></a>00332             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(13)+1;
<a name="l00333"></a>00333             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00334"></a>00334 
<a name="l00335"></a>00335             <span class="keywordflow">return</span>;
<a name="l00336"></a>00336       
<a name="l00337"></a>00337           <span class="keywordflow">case</span> 2:
<a name="l00338"></a>00338 
<a name="l00339"></a>00339             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00340"></a>00340             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00341"></a>00341             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10)+1;
<a name="l00342"></a>00342             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1; 
<a name="l00343"></a>00343             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15)+1;
<a name="l00344"></a>00344             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00345"></a>00345             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14)+1;
<a name="l00346"></a>00346             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348             <span class="keywordflow">return</span>;
<a name="l00349"></a>00349       
<a name="l00350"></a>00350           <span class="keywordflow">case</span> 3:
<a name="l00351"></a>00351 
<a name="l00352"></a>00352             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00353"></a>00353             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00354"></a>00354             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00355"></a>00355             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10)+1;
<a name="l00356"></a>00356             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00357"></a>00357             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(13)+1;
<a name="l00358"></a>00358             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00359"></a>00359             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14)+1;
<a name="l00360"></a>00360 
<a name="l00361"></a>00361             <span class="keywordflow">return</span>;
<a name="l00362"></a>00362       
<a name="l00363"></a>00363           <span class="keywordflow">default</span>:
<a name="l00364"></a>00364             libmesh_error();
<a name="l00365"></a>00365           }
<a name="l00366"></a>00366       }
<a name="l00367"></a>00367 
<a name="l00368"></a>00368     <span class="keywordflow">default</span>:
<a name="l00369"></a>00369       libmesh_error();
<a name="l00370"></a>00370     }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   libmesh_error();
<a name="l00373"></a>00373 }
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a><a class="code" href="classlibMesh_1_1InfHex18.php#aed80f3cf5af9441dc8c8c618d38e057b">00378</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#aed80f3cf5af9441dc8c8c618d38e057b">InfHex18::n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00379"></a>00379 <span class="keyword"></span>{
<a name="l00380"></a>00380   <span class="keywordflow">switch</span> (n)
<a name="l00381"></a>00381     {
<a name="l00382"></a>00382       <span class="keywordflow">case</span> 8:
<a name="l00383"></a>00383       <span class="keywordflow">case</span> 9:
<a name="l00384"></a>00384       <span class="keywordflow">case</span> 10:
<a name="l00385"></a>00385       <span class="keywordflow">case</span> 11:
<a name="l00386"></a>00386       <span class="keywordflow">case</span> 12:
<a name="l00387"></a>00387       <span class="keywordflow">case</span> 13:
<a name="l00388"></a>00388       <span class="keywordflow">case</span> 14:
<a name="l00389"></a>00389       <span class="keywordflow">case</span> 15:
<a name="l00390"></a>00390         <span class="keywordflow">return</span> 2;
<a name="l00391"></a>00391 
<a name="l00392"></a>00392       <span class="keywordflow">case</span> 16:
<a name="l00393"></a>00393       <span class="keywordflow">case</span> 17:
<a name="l00394"></a>00394         <span class="keywordflow">return</span> 4;
<a name="l00395"></a>00395 
<a name="l00396"></a>00396       <span class="keywordflow">default</span>:
<a name="l00397"></a>00397         libmesh_error();
<a name="l00398"></a>00398     }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   libmesh_error();
<a name="l00401"></a>00401   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00402"></a>00402 }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a1c0e614b09eaa53b79671f85a2f7fc12">00406</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a1c0e614b09eaa53b79671f85a2f7fc12">InfHex18::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00407"></a>00407                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00408"></a>00408 <span class="keyword"></span>{ 
<a name="l00409"></a>00409   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#a6f7d6506e7030ef1c04e8060cf7718d4">n_vertices</a>());
<a name="l00410"></a>00410   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classlibMesh_1_1InfHex18.php#a353de7cb275eb9a8ecdd2a7dd4b0d834">n_nodes</a>());
<a name="l00411"></a>00411   libmesh_assert (v &lt;  this-&gt;<a class="code" href="classlibMesh_1_1InfHex18.php#aed80f3cf5af9441dc8c8c618d38e057b">n_second_order_adjacent_vertices</a>(n));
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="keywordflow">if</span> (n == 16)
<a name="l00414"></a>00414       <span class="comment">/*</span>
<a name="l00415"></a>00415 <span class="comment">       * for the bubble node in the base the return value is </span>
<a name="l00416"></a>00416 <span class="comment">       * simply v.  Why? -- the user asks for the v-th </span>
<a name="l00417"></a>00417 <span class="comment">       * adjacent vertex, from \p n_second_order_adjacent_vertices() </span>
<a name="l00418"></a>00418 <span class="comment">       * there are 4 adjacent vertices, and these happen to be</span>
<a name="l00419"></a>00419 <span class="comment">       * 0..3</span>
<a name="l00420"></a>00420 <span class="comment">       */</span>
<a name="l00421"></a>00421       <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(v);
<a name="l00422"></a>00422   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (n == 17)
<a name="l00423"></a>00423       <span class="comment">/*</span>
<a name="l00424"></a>00424 <span class="comment">       * for the bubble node further out similar reasoning works,</span>
<a name="l00425"></a>00425 <span class="comment">       * but v must be shifted to the further-out nodes: </span>
<a name="l00426"></a>00426 <span class="comment">       * simply add 4</span>
<a name="l00427"></a>00427 <span class="comment">       */</span>
<a name="l00428"></a>00428       <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(v+4);
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   <span class="keywordflow">else</span>
<a name="l00431"></a>00431       <span class="comment">/*</span>
<a name="l00432"></a>00432 <span class="comment">       * all others are stored in the vertices matrix -- note</span>
<a name="l00433"></a>00433 <span class="comment">       * that this matrix is kept in \p InfHex to foster</span>
<a name="l00434"></a>00434 <span class="comment">       * code-reuse</span>
<a name="l00435"></a>00435 <span class="comment">       */</span>
<a name="l00436"></a>00436       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfHex.php#a1ffa1361509b318958f7da6eb8daa5cd">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#a6f7d6506e7030ef1c04e8060cf7718d4">n_vertices</a>()][v]; 
<a name="l00437"></a>00437 }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00442"></a><a class="code" href="classlibMesh_1_1InfHex18.php#aa47a98dc598999c49648cf9bb1201036">00442</a> <a class="code" href="classlibMesh_1_1InfHex18.php#aa47a98dc598999c49648cf9bb1201036">InfHex18::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00443"></a>00443 <span class="keyword"></span>{
<a name="l00444"></a>00444   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#a6f7d6506e7030ef1c04e8060cf7718d4">n_vertices</a>());
<a name="l00445"></a>00445   libmesh_assert (n &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex18.php#a353de7cb275eb9a8ecdd2a7dd4b0d834">n_nodes</a>());
<a name="l00446"></a>00446   <span class="comment">/*</span>
<a name="l00447"></a>00447 <span class="comment">   * the _second_order_vertex_child_* vectors are</span>
<a name="l00448"></a>00448 <span class="comment">   * stored in cell_inf_hex.C, since they are identical</span>
<a name="l00449"></a>00449 <span class="comment">   * for InfHex16 and InfHex18</span>
<a name="l00450"></a>00450 <span class="comment">   */</span>
<a name="l00451"></a>00451   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00452"></a>00452     (<a class="code" href="classlibMesh_1_1InfHex.php#ad0088faa57a16eaef4f4cfa32ea0b013">_second_order_vertex_child_number</a>[n],
<a name="l00453"></a>00453      <a class="code" href="classlibMesh_1_1InfHex.php#a312673bd7501104d9abdf02ab6ab4869">_second_order_vertex_child_index</a>[n]);
<a name="l00454"></a>00454 }
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00463"></a>00463 <span class="preprocessor"></span>
<a name="l00464"></a>00464 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a364b04c3ccd3f9e5dc8e92abe3ef1109">InfHex18::_embedding_matrix</a>[4][18][18] =
<a name="l00465"></a>00465 {
<a name="l00466"></a>00466   <span class="comment">// embedding matrix for child 0</span>
<a name="l00467"></a>00467   {
<a name="l00468"></a>00468     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15          16          17 th parent Node</span>
<a name="l00469"></a>00469     {         1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00470"></a>00470     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00471"></a>00471     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 2</span>
<a name="l00472"></a>00472     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00473"></a>00473     {         0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 4</span>
<a name="l00474"></a>00474     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00475"></a>00475     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 6</span>
<a name="l00476"></a>00476     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0}, <span class="comment">// 7</span>
<a name="l00477"></a>00477     {       0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00478"></a>00478     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 9</span>
<a name="l00479"></a>00479     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 10</span>
<a name="l00480"></a>00480     {       0.375,        0.0,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00481"></a>00481     {         0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 12</span>
<a name="l00482"></a>00482     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,        0.0,     -0.125,        0.0,        0.0,       0.75}, <span class="comment">// 13</span>
<a name="l00483"></a>00483     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,      0.375,        0.0,       0.75}, <span class="comment">// 14</span>
<a name="l00484"></a>00484     {         0.0,        0.0,        0.0,        0.0,      0.375,        0.0,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0}, <span class="comment">// 15</span>
<a name="l00485"></a>00485     {    0.140625,  -0.046875,   0.015625,  -0.046875,        0.0,        0.0,        0.0,        0.0,    0.28125,   -0.09375,   -0.09375,    0.28125,        0.0,        0.0,        0.0,        0.0,     0.5625,        0.0}, <span class="comment">// 16</span>
<a name="l00486"></a>00486     {         0.0,        0.0,        0.0,        0.0,   0.140625,  -0.046875,   0.015625,  -0.046875,        0.0,        0.0,        0.0,        0.0,    0.28125,   -0.09375,   -0.09375,    0.28125,        0.0,     0.5625}  <span class="comment">// 17</span>
<a name="l00487"></a>00487   },
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   <span class="comment">// embedding matrix for child 1</span>
<a name="l00490"></a>00490   {
<a name="l00491"></a>00491     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15          16          17 th parent Node</span>
<a name="l00492"></a>00492     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00493"></a>00493     {         0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00494"></a>00494     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00495"></a>00495     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 3</span>
<a name="l00496"></a>00496     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 4</span>
<a name="l00497"></a>00497     {         0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00498"></a>00498     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00499"></a>00499     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 7</span>
<a name="l00500"></a>00500     {      -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00501"></a>00501     {         0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00502"></a>00502     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 10</span>
<a name="l00503"></a>00503     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 11</span>
<a name="l00504"></a>00504     {         0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 12</span>
<a name="l00505"></a>00505     {         0.0,        0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 13</span>
<a name="l00506"></a>00506     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,        0.0,     -0.125,        0.0,       0.75}, <span class="comment">// 14</span>
<a name="l00507"></a>00507     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,        0.0,     -0.125,        0.0,        0.0,       0.75}, <span class="comment">// 15</span>
<a name="l00508"></a>00508     {   -0.046875,   0.140625,  -0.046875,   0.015625,        0.0,        0.0,        0.0,        0.0,    0.28125,    0.28125,   -0.09375,   -0.09375,        0.0,        0.0,        0.0,        0.0,     0.5625,        0.0}, <span class="comment">// 16</span>
<a name="l00509"></a>00509     {         0.0,        0.0,        0.0,        0.0,  -0.046875,   0.140625,  -0.046875,   0.015625,        0.0,        0.0,        0.0,        0.0,    0.28125,    0.28125,   -0.09375,   -0.09375,        0.0,     0.5625}  <span class="comment">// 17</span>
<a name="l00510"></a>00510   },
<a name="l00511"></a>00511 
<a name="l00512"></a>00512   <span class="comment">// embedding matrix for child 2</span>
<a name="l00513"></a>00513   {
<a name="l00514"></a>00514     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15          16          17 th parent Node</span>
<a name="l00515"></a>00515     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00516"></a>00516     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 1</span>
<a name="l00517"></a>00517     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00518"></a>00518     {         0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00519"></a>00519     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0}, <span class="comment">// 4</span>
<a name="l00520"></a>00520     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 5</span>
<a name="l00521"></a>00521     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00522"></a>00522     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 7</span>
<a name="l00523"></a>00523     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 8</span>
<a name="l00524"></a>00524     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 9</span>
<a name="l00525"></a>00525     {         0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00526"></a>00526     {      -0.125,        0.0,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 11</span>
<a name="l00527"></a>00527     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,      0.375,        0.0,       0.75}, <span class="comment">// 12</span>
<a name="l00528"></a>00528     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,      0.375,        0.0,        0.0,       0.75}, <span class="comment">// 13</span>
<a name="l00529"></a>00529     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0}, <span class="comment">// 14</span>
<a name="l00530"></a>00530     {         0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0}, <span class="comment">// 15</span>
<a name="l00531"></a>00531     {   -0.046875,   0.015625,  -0.046875,   0.140625,        0.0,        0.0,        0.0,        0.0,   -0.09375,   -0.09375,    0.28125,    0.28125,        0.0,        0.0,        0.0,        0.0,     0.5625,        0.0}, <span class="comment">// 16</span>
<a name="l00532"></a>00532     {         0.0,        0.0,        0.0,        0.0,  -0.046875,   0.015625,  -0.046875,   0.140625,        0.0,        0.0,        0.0,        0.0,   -0.09375,   -0.09375,    0.28125,    0.28125,        0.0,     0.5625}  <span class="comment">// 17</span>
<a name="l00533"></a>00533   },
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <span class="comment">// embedding matrix for child 3</span>
<a name="l00536"></a>00536   {
<a name="l00537"></a>00537     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11          12          13          14          15          16          17 th parent Node</span>
<a name="l00538"></a>00538     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00539"></a>00539     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00540"></a>00540     {         0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00541"></a>00541     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00542"></a>00542     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 4</span>
<a name="l00543"></a>00543     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00544"></a>00544     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00545"></a>00545     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0}, <span class="comment">// 7</span>
<a name="l00546"></a>00546     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 8</span>
<a name="l00547"></a>00547     {         0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00548"></a>00548     {         0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 10</span>
<a name="l00549"></a>00549     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 11</span>
<a name="l00550"></a>00550     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,        0.0,     -0.125,        0.0,       0.75}, <span class="comment">// 12</span>
<a name="l00551"></a>00551     {         0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 13</span>
<a name="l00552"></a>00552     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0}, <span class="comment">// 14</span>
<a name="l00553"></a>00553     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,     -0.125,        0.0,      0.375,        0.0,        0.0,       0.75}, <span class="comment">// 15</span>
<a name="l00554"></a>00554     {    0.015625,  -0.046875,   0.140625,  -0.046875,        0.0,        0.0,        0.0,        0.0,   -0.09375,    0.28125,    0.28125,   -0.09375,        0.0,        0.0,        0.0,        0.0,     0.5625,        0.0}, <span class="comment">// 16</span>
<a name="l00555"></a>00555     {         0.0,        0.0,        0.0,        0.0,   0.015625,  -0.046875,   0.140625,  -0.046875,        0.0,        0.0,        0.0,        0.0,   -0.09375,    0.28125,    0.28125,   -0.09375,        0.0,     0.5625}  <span class="comment">// 17</span>
<a name="l00556"></a>00556   }
<a name="l00557"></a>00557 };
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 <span class="preprocessor">#endif</span>
<a name="l00563"></a>00563 <span class="preprocessor"></span>
<a name="l00564"></a>00564 } <span class="comment">// namespace libMesh</span>
<a name="l00565"></a>00565 
<a name="l00566"></a>00566 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00567"></a>00567 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
