<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_hex18.h</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex18_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex18.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_hex18_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_hex18_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex_8h.php">cell_inf_hex.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00073"></a>00073 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00074"></a>00074 <span class="comment">// InfHex18 class definition</span>
<a name="l00075"></a><a class="code" href="classlibMesh_1_1InfHex18.php">00075</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfHex18.php">InfHex18</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1InfHex.php">InfHex</a>
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077 <span class="keyword">public</span>:
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1InfHex18.php#a23843892d3a9a76d3dd3499005854131">InfHex18</a>  (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL);
<a name="l00083"></a>00083     
<a name="l00087"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a353de7cb275eb9a8ecdd2a7dd4b0d834">00087</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a353de7cb275eb9a8ecdd2a7dd4b0d834">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 18; }
<a name="l00088"></a>00088   
<a name="l00092"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a5cab4491f749295666fb8254a14adbc0">00092</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>     <a class="code" href="classlibMesh_1_1InfHex18.php#a5cab4491f749295666fb8254a14adbc0">type</a> ()<span class="keyword">   const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>; }
<a name="l00093"></a>00093   
<a name="l00097"></a><a class="code" href="classlibMesh_1_1InfHex18.php#af1f626782df1929bdb2e202508cefc56">00097</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#af1f626782df1929bdb2e202508cefc56">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00098"></a>00098   
<a name="l00102"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a53ac5d818357a236c3a68d6dcb5041bf">00102</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1InfHex18.php#a53ac5d818357a236c3a68d6dcb5041bf">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00103"></a>00103 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a2eb526fb3551b636668db72ff532d222">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a6abdc04d35415210c17fea4e5430a124">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#ae23ab10590550f20b7b0b55bdf29d109">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00118"></a>00118   
<a name="l00119"></a>00119   <span class="comment">/*</span>
<a name="l00120"></a>00120 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00121"></a>00121 <span class="comment">   * specified side</span>
<a name="l00122"></a>00122 <span class="comment">   */</span>
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a49087b9b03d2d5606782941ed81a0656">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00124"></a>00124                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="comment">/*</span>
<a name="l00127"></a>00127 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00128"></a>00128 <span class="comment">   * specified edge</span>
<a name="l00129"></a>00129 <span class="comment">   */</span>
<a name="l00130"></a>00130   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a3a765de726c9eee725b22f7b05727b19">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00131"></a>00131                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00132"></a>00132   
<a name="l00138"></a>00138   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex18.php#a382a612d5538deda8c19c8e663060484">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00139"></a>00139                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00140"></a>00140 
<a name="l00146"></a>00146   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex18.php#a086e1416d18ec3d65257be76c2686fa8">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00147"></a>00147 
<a name="l00157"></a>00157   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#ac613f40883fa608723b9290201703c2f">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a4e222598d9e050d6fdac7357df197f50">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00160"></a>00160                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00161"></a>00161                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="comment">//   void tecplot_connectivity(const unsigned int sc,</span>
<a name="l00164"></a>00164 <span class="comment">//                          std::vector&lt;unsigned int&gt;&amp; conn) const;</span>
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="comment">//   void vtk_connectivity(const unsigned int,</span>
<a name="l00167"></a>00167 <span class="comment">//                      std::vector&lt;unsigned int&gt;*) const</span>
<a name="l00168"></a>00168 <span class="comment">//   { libmesh_error(); }</span>
<a name="l00169"></a>00169   
<a name="l00170"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a136178618bf51dab2f60bd2928aed6cd">00170</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a136178618bf51dab2f60bd2928aed6cd">vtk_element_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00171"></a>00171 <span class="keyword">  </span>{ <span class="keywordflow">return</span> 12; }
<a name="l00172"></a>00172 
<a name="l00176"></a>00176   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#aed80f3cf5af9441dc8c8c618d38e057b">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) <span class="keyword">const</span>;
<a name="l00177"></a>00177 
<a name="l00183"></a>00183   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a1c0e614b09eaa53b79671f85a2f7fc12">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00184"></a>00184                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00185"></a>00185 
<a name="l00195"></a>00195   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00196"></a>00196           <a class="code" href="classlibMesh_1_1InfHex18.php#aa47a98dc598999c49648cf9bb1201036">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00197"></a>00197 
<a name="l00202"></a><a class="code" href="classlibMesh_1_1InfHex18.php#abe894dcea6c59ce698addd2f3616db41">00202</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#abe894dcea6c59ce698addd2f3616db41">side_nodes_map</a>[5][9];
<a name="l00203"></a>00203 
<a name="l00208"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a4d8f6cb8905f2177d46934e92c5fa187">00208</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a4d8f6cb8905f2177d46934e92c5fa187">edge_nodes_map</a>[8][3];
<a name="l00209"></a>00209    
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="keyword">protected</span>:
<a name="l00212"></a>00212   
<a name="l00213"></a>00213   
<a name="l00214"></a>00214 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00215"></a>00215 <span class="preprocessor"></span>
<a name="l00219"></a><a class="code" href="classlibMesh_1_1InfHex18.php#ae1c6473b7979a99a70fcea46a6992b99">00219</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfHex18.php#ae1c6473b7979a99a70fcea46a6992b99">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00220"></a>00220                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00221"></a>00221                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00222"></a>00222 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a364b04c3ccd3f9e5dc8e92abe3ef1109">_embedding_matrix</a>[i][j][k]; }
<a name="l00223"></a>00223 
<a name="l00228"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a364b04c3ccd3f9e5dc8e92abe3ef1109">00228</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfHex18.php#a364b04c3ccd3f9e5dc8e92abe3ef1109">_embedding_matrix</a>[4][18][18];
<a name="l00229"></a>00229   
<a name="l00230"></a>00230   
<a name="l00231"></a>00231 <span class="preprocessor">#endif</span>
<a name="l00232"></a>00232 <span class="preprocessor"></span>
<a name="l00233"></a>00233 };
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00238"></a>00238 <span class="comment">// InfHex18 class member functions</span>
<a name="l00239"></a>00239 <span class="keyword">inline</span>
<a name="l00240"></a><a class="code" href="classlibMesh_1_1InfHex18.php#a23843892d3a9a76d3dd3499005854131">00240</a> <a class="code" href="classlibMesh_1_1InfHex18.php#a23843892d3a9a76d3dd3499005854131">InfHex18::InfHex18</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00241"></a>00241   <a class="code" href="classlibMesh_1_1InfHex.php">InfHex</a>(<a class="code" href="classlibMesh_1_1InfHex18.php">InfHex18</a>::<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>(), p) 
<a name="l00242"></a>00242 {
<a name="l00243"></a>00243 }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 } <span class="comment">// namespace libMesh</span>
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="preprocessor">#endif  // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00249"></a>00249 <span class="preprocessor"></span>
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
