<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_hex8.C</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex8_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex8.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes cont&#39;d</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex8_8h.php">cell_inf_hex8.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge2_8h.php">edge_edge2.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="edge__inf__edge2_8h.php">edge_inf_edge2.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__quad4_8h.php">face_quad4.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad4_8h.php">face_inf_quad4.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// InfHex8 class member functions</span>
<a name="l00043"></a>00043 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex8.php#aada41d14f4549022ace8b7a0ef60d73d">InfHex8::side_nodes_map</a>[5][4] =
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   { 0, 1, 2, 3}, <span class="comment">// Side 0</span>
<a name="l00046"></a>00046   { 0, 1, 4, 5}, <span class="comment">// Side 1</span>
<a name="l00047"></a>00047   { 1, 2, 5, 6}, <span class="comment">// Side 2</span>
<a name="l00048"></a>00048   { 2, 3, 6, 7}, <span class="comment">// Side 3</span>
<a name="l00049"></a>00049   { 3, 0, 7, 4}  <span class="comment">// Side 4</span>
<a name="l00050"></a>00050 };
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a109ae76106c920f7268b01c0e10aab62">InfHex8::edge_nodes_map</a>[8][2] =
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   { 0, 1}, <span class="comment">// Side 0</span>
<a name="l00055"></a>00055   { 1, 2}, <span class="comment">// Side 1</span>
<a name="l00056"></a>00056   { 2, 3}, <span class="comment">// Side 2</span>
<a name="l00057"></a>00057   { 0, 3}, <span class="comment">// Side 3</span>
<a name="l00058"></a>00058   { 0, 4}, <span class="comment">// Side 4</span>
<a name="l00059"></a>00059   { 1, 5}, <span class="comment">// Side 5</span>
<a name="l00060"></a>00060   { 2, 6}, <span class="comment">// Side 6</span>
<a name="l00061"></a>00061   { 3, 7}  <span class="comment">// Side 7</span>
<a name="l00062"></a>00062 };
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00066"></a>00066 <span class="comment">// InfHex8 class member functions</span>
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a39da6b6e720d108e41a48a59921bdd9b">00068</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a39da6b6e720d108e41a48a59921bdd9b">InfHex8::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00069"></a>00069 <span class="keyword"></span>{
<a name="l00070"></a>00070   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00071"></a>00071     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00072"></a>00072   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a5f2b7e54152c8f1cbac20f4bb8968319">00075</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a5f2b7e54152c8f1cbac20f4bb8968319">InfHex8::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00076"></a>00076 <span class="keyword"></span>{
<a name="l00077"></a>00077   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00078"></a>00078     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00079"></a>00079   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a58f08886d8607c0c5792e9a453560798">00082</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a58f08886d8607c0c5792e9a453560798">InfHex8::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00083"></a>00083 <span class="keyword"></span>{
<a name="l00084"></a>00084   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a8bb2c5e780a8c06e87b9672630d9d359">00087</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a8bb2c5e780a8c06e87b9672630d9d359">InfHex8::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00088"></a>00088                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00089"></a>00089 <span class="keyword"></span>{
<a name="l00090"></a>00090   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00091"></a>00091   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 4; ++i)
<a name="l00092"></a>00092     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfHex8.php#aada41d14f4549022ace8b7a0ef60d73d">side_nodes_map</a>[s][i] == n)
<a name="l00093"></a>00093       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00094"></a>00094   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a00c7610664ab6b308d9854a561177238">00097</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a00c7610664ab6b308d9854a561177238">InfHex8::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00098"></a>00098                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00099"></a>00099 <span class="keyword"></span>{
<a name="l00100"></a>00100   libmesh_assert(e &lt; <a class="code" href="classlibMesh_1_1InfHex.php#add6f00e7fee9ea06dfabb98d5c465f62">n_edges</a>());
<a name="l00101"></a>00101   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 2; ++i)
<a name="l00102"></a>00102     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfHex8.php#a109ae76106c920f7268b01c0e10aab62">edge_nodes_map</a>[e][i] == n)
<a name="l00103"></a>00103       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00104"></a>00104   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00105"></a>00105 }
<a name="l00106"></a>00106 
<a name="l00107"></a><a class="code" href="classlibMesh_1_1InfHex8.php#af8783c4fae43ef97826aa5147215a6a9">00107</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex8.php#af8783c4fae43ef97826aa5147215a6a9">InfHex8::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00108"></a>00108                                    <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00109"></a>00109 <span class="keyword"></span>{
<a name="l00110"></a>00110   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (proxy)
<a name="l00113"></a>00113     {
<a name="l00114"></a>00114       <span class="keywordflow">switch</span> (i)
<a name="l00115"></a>00115         {
<a name="l00116"></a>00116           <span class="comment">// base</span>
<a name="l00117"></a>00117         <span class="keywordflow">case</span> 0:
<a name="l00118"></a>00118           {
<a name="l00119"></a>00119             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Quad4,InfHex8&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00120"></a>00120             <span class="keywordflow">return</span> ap;
<a name="l00121"></a>00121           }
<a name="l00122"></a>00122           <span class="comment">// ifem sides</span>
<a name="l00123"></a>00123         <span class="keywordflow">case</span> 1:
<a name="l00124"></a>00124         <span class="keywordflow">case</span> 2:
<a name="l00125"></a>00125         <span class="keywordflow">case</span> 3:
<a name="l00126"></a>00126         <span class="keywordflow">case</span> 4:
<a name="l00127"></a>00127           {
<a name="l00128"></a>00128             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;InfQuad4,InfHex8&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00129"></a>00129             <span class="keywordflow">return</span> ap;
<a name="l00130"></a>00130           }
<a name="l00131"></a>00131         <span class="keywordflow">default</span>:
<a name="l00132"></a>00132           libmesh_error();
<a name="l00133"></a>00133         }
<a name="l00134"></a>00134     }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">else</span>
<a name="l00137"></a>00137     {
<a name="l00138"></a>00138       <span class="comment">// FIXME: Find out how to return non-proxy side</span>
<a name="l00139"></a>00139       libmesh_error();
<a name="l00140"></a>00140     }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   
<a name="l00143"></a>00143   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00144"></a>00144   libmesh_error();
<a name="l00145"></a>00145   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a><a class="code" href="classlibMesh_1_1InfHex8.php#aadf74634122d5650653b7d9bf8a89b1f">00149</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex8.php#aadf74634122d5650653b7d9bf8a89b1f">InfHex8::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00150"></a>00150 <span class="keyword"></span>{
<a name="l00151"></a>00151   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#add6f00e7fee9ea06dfabb98d5c465f62">n_edges</a>());
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="keywordflow">if</span> (i &lt; 4) <span class="comment">// base edges</span>
<a name="l00154"></a>00154     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;Edge2,InfHex8&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00155"></a>00155   <span class="comment">// infinite edges</span>
<a name="l00156"></a>00156   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;InfEdge2,InfHex8&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a7ed4d9e95dcdd2e3bb90ad9b8df9175f">00159</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a7ed4d9e95dcdd2e3bb90ad9b8df9175f">InfHex8::contains_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol)<span class="keyword"> const</span>
<a name="l00160"></a>00160 <span class="keyword"></span>{
<a name="l00161"></a>00161   <span class="comment">/*</span>
<a name="l00162"></a>00162 <span class="comment">   * For infinite elements with linear base interpolation:</span>
<a name="l00163"></a>00163 <span class="comment">   *</span>
<a name="l00164"></a>00164 <span class="comment">   * make use of the fact that infinite elements do not</span>
<a name="l00165"></a>00165 <span class="comment">   * live inside the envelope.  Use a fast scheme to</span>
<a name="l00166"></a>00166 <span class="comment">   * check whether point \p p is inside or outside</span>
<a name="l00167"></a>00167 <span class="comment">   * our relevant part of the envelope.  Note that</span>
<a name="l00168"></a>00168 <span class="comment">   * this is not exclusive: only when the distance is less,</span>
<a name="l00169"></a>00169 <span class="comment">   * we are safe.  Otherwise, we cannot say anything. The </span>
<a name="l00170"></a>00170 <span class="comment">   * envelope may be non-spherical, the physical point may lie</span>
<a name="l00171"></a>00171 <span class="comment">   * inside the envelope, outside the envelope, or even inside </span>
<a name="l00172"></a>00172 <span class="comment">   * this infinite element.  Therefore if this fails,</span>
<a name="l00173"></a>00173 <span class="comment">   * fall back to the FEInterface::inverse_map()</span>
<a name="l00174"></a>00174 <span class="comment">   */</span>
<a name="l00175"></a>00175   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfCell.php#a84a99f73771ebbdb6b8f11268e3db4e6">origin</a> (this-&gt;<a class="code" href="classlibMesh_1_1InfCell.php#a84a99f73771ebbdb6b8f11268e3db4e6">origin</a>());
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">/*</span>
<a name="l00178"></a>00178 <span class="comment">   * determine the minimal distance of the base from the origin</span>
<a name="l00179"></a>00179 <span class="comment">   * Use size_sq() instead of size(), it is faster</span>
<a name="l00180"></a>00180 <span class="comment">   */</span>
<a name="l00181"></a>00181   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> min_distance_sq = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((<a class="code" href="classlibMesh_1_1Point.php">Point</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)-origin)).size_sq(),
<a name="l00182"></a>00182                                         <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((<a class="code" href="classlibMesh_1_1Point.php">Point</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)-origin)).size_sq(),
<a name="l00183"></a>00183                                                  <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((<a class="code" href="classlibMesh_1_1Point.php">Point</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)-origin)).size_sq(),
<a name="l00184"></a>00184                                                           (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)-origin)).size_sq())));
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">/*</span>
<a name="l00187"></a>00187 <span class="comment">   * work with 1% allowable deviation.  We can still fall</span>
<a name="l00188"></a>00188 <span class="comment">   * back to the InfFE::inverse_map()</span>
<a name="l00189"></a>00189 <span class="comment">   */</span>
<a name="l00190"></a>00190   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> conservative_p_dist_sq = 1.01 * (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(p-origin).<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>());
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="keywordflow">if</span> (conservative_p_dist_sq &lt; min_distance_sq)
<a name="l00195"></a>00195     {
<a name="l00196"></a>00196       <span class="comment">/*</span>
<a name="l00197"></a>00197 <span class="comment">       * the physical point is definitely not contained in the element</span>
<a name="l00198"></a>00198 <span class="comment">       */</span>
<a name="l00199"></a>00199       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00200"></a>00200     }
<a name="l00201"></a>00201   <span class="keywordflow">else</span>
<a name="l00202"></a>00202     {
<a name="l00203"></a>00203       <span class="comment">/*</span>
<a name="l00204"></a>00204 <span class="comment">       * Declare a basic FEType.  Will use default in the base,</span>
<a name="l00205"></a>00205 <span class="comment">       * and something else (not important) in radial direction.</span>
<a name="l00206"></a>00206 <span class="comment">       */</span>
<a name="l00207"></a>00207       <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type(<a class="code" href="classlibMesh_1_1InfHex8.php#a71a0c655ac48a9d4442508204ea4ae9a">default_order</a>());
<a name="l00208"></a>00208   
<a name="l00209"></a>00209       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> mapped_point = <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(<a class="code" href="classlibMesh_1_1InfCell.php#aa1497aebf8fbae7c35a2fa4d78562fa9">dim</a>(),
<a name="l00210"></a>00210                                                           fe_type,
<a name="l00211"></a>00211                                                           <span class="keyword">this</span>,
<a name="l00212"></a>00212                                                           p,
<a name="l00213"></a>00213                                                           tol,
<a name="l00214"></a>00214                                                           <span class="keyword">false</span>);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a5ed1b078cb472a00bf1b4cdb5cf28be7">FEInterface::on_reference_element</a>(mapped_point, this-&gt;<a class="code" href="classlibMesh_1_1InfHex8.php#af2442cb01fd6c16985e5312a60c0a73b">type</a>(), tol);
<a name="l00217"></a>00217     }
<a name="l00218"></a>00218 }
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1InfHex8.php#aa9b2d55c0bab257346626f963fc12473">00221</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfHex8.php#aa9b2d55c0bab257346626f963fc12473">InfHex8::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00222"></a>00222                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00223"></a>00223                            std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00224"></a>00224 <span class="keyword"></span>{
<a name="l00225"></a>00225   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL);
<a name="l00226"></a>00226   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex8.php#ac9a2f618c830497f27b7658b8f589c78">n_sub_elem</a>());
<a name="l00227"></a>00227   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="keywordflow">switch</span> (iop)
<a name="l00230"></a>00230     {
<a name="l00231"></a>00231     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00232"></a>00232       {
<a name="l00233"></a>00233         conn.resize(8);
<a name="l00234"></a>00234         conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00235"></a>00235         conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00236"></a>00236         conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00237"></a>00237         conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00238"></a>00238         conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00239"></a>00239         conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00240"></a>00240         conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00241"></a>00241         conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00242"></a>00242         <span class="keywordflow">return</span>;
<a name="l00243"></a>00243       }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245       
<a name="l00246"></a>00246     <span class="keywordflow">default</span>:
<a name="l00247"></a>00247       libmesh_error();
<a name="l00248"></a>00248     }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   libmesh_error();
<a name="l00251"></a>00251 }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>
<a name="l00257"></a>00257 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a8cb84551013cc1bc8ada1ca036ce7119">InfHex8::_embedding_matrix</a>[4][8][8] =
<a name="l00258"></a>00258 {
<a name="l00259"></a>00259   <span class="comment">// embedding matrix for child 0</span>
<a name="l00260"></a>00260   {
<a name="l00261"></a>00261     <span class="comment">//     0      1      2      3      4      5      6      7 th parent N.(ode)</span>
<a name="l00262"></a>00262     {    1.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 0th child N.</span>
<a name="l00263"></a>00263     {    0.5,   0.5,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 1</span>
<a name="l00264"></a>00264     {   0.25,  0.25,  0.25,  0.25,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 2</span>
<a name="l00265"></a>00265     {    0.5,   0.0,   0.0,   0.5,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 3</span>
<a name="l00266"></a>00266     {    0.0,   0.0,   0.0,   0.0,   1.0,   0.0,   0.0,   0.0}, <span class="comment">// 4</span>
<a name="l00267"></a>00267     {    0.0,   0.0,   0.0,   0.0,   0.5,   0.5,   0.0,   0.0}, <span class="comment">// 5</span>
<a name="l00268"></a>00268     {    0.0,   0.0,   0.0,   0.0,  0.25,  0.25,  0.25,  0.25}, <span class="comment">// 6</span>
<a name="l00269"></a>00269     {    0.0,   0.0,   0.0,   0.0,   0.5,   0.0,   0.0,   0.5}  <span class="comment">// 7</span>
<a name="l00270"></a>00270   },
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="comment">// embedding matrix for child 1</span>
<a name="l00273"></a>00273   {
<a name="l00274"></a>00274     <span class="comment">//     0      1      2      3      4      5      6      7 th parent N.(ode)</span>
<a name="l00275"></a>00275     {    0.5,   0.5,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 0th child N.</span>
<a name="l00276"></a>00276     {    0.0,   1.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 1</span>
<a name="l00277"></a>00277     {    0.0,   0.5,   0.5,   0.0,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 2</span>
<a name="l00278"></a>00278     {   0.25,  0.25,  0.25,  0.25,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 3</span>
<a name="l00279"></a>00279     {    0.0,   0.0,   0.0,   0.0,   0.5,   0.5,   0.0,   0.0}, <span class="comment">// 4</span>
<a name="l00280"></a>00280     {    0.0,   0.0,   0.0,   0.0,   0.0,   1.0,   0.0,   0.0}, <span class="comment">// 5</span>
<a name="l00281"></a>00281     {    0.0,   0.0,   0.0,   0.0,   0.0,   0.5,   0.5,   0.0}, <span class="comment">// 6</span>
<a name="l00282"></a>00282     {    0.0,   0.0,   0.0,   0.0,  0.25,  0.25,  0.25,  0.25}  <span class="comment">// 7</span>
<a name="l00283"></a>00283   },
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="comment">// embedding matrix for child 2</span>
<a name="l00286"></a>00286   {
<a name="l00287"></a>00287     <span class="comment">//     0      1      2      3      4      5      6      7 th parent N.(ode)</span>
<a name="l00288"></a>00288     {    0.5,   0.0,   0.0,   0.5,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 0th child N.</span>
<a name="l00289"></a>00289     {   0.25,  0.25,  0.25,  0.25,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 1</span>
<a name="l00290"></a>00290     {    0.0,   0.0,   0.5,   0.5,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 2</span>
<a name="l00291"></a>00291     {    0.0,   0.0,   0.0,   1.0,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 3</span>
<a name="l00292"></a>00292     {    0.0,   0.0,   0.0,   0.0,   0.5,   0.0,   0.0,   0.5}, <span class="comment">// 4</span>
<a name="l00293"></a>00293     {    0.0,   0.0,   0.0,   0.0,  0.25,  0.25,  0.25,  0.25}, <span class="comment">// 5</span>
<a name="l00294"></a>00294     {    0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.5,   0.5}, <span class="comment">// 6</span>
<a name="l00295"></a>00295     {    0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   1.0}  <span class="comment">// 7</span>
<a name="l00296"></a>00296   },
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   <span class="comment">// embedding matrix for child 3</span>
<a name="l00299"></a>00299   {
<a name="l00300"></a>00300     <span class="comment">//     0      1      2      3      4      5      6      7 th parent N.(ode)</span>
<a name="l00301"></a>00301     {   0.25,  0.25,  0.25,  0.25,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 0th child N.</span>
<a name="l00302"></a>00302     {    0.0,   0.5,   0.5,   0.0,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 1</span>
<a name="l00303"></a>00303     {    0.0,   0.0,   1.0,   0.0,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 2</span>
<a name="l00304"></a>00304     {    0.0,   0.0,   0.5,   0.5,   0.0,   0.0,   0.0,   0.0}, <span class="comment">// 3</span>
<a name="l00305"></a>00305     {    0.0,   0.0,   0.0,   0.0,  0.25,  0.25,  0.25,  0.25}, <span class="comment">// 4</span>
<a name="l00306"></a>00306     {    0.0,   0.0,   0.0,   0.0,   0.0,   0.5,   0.5,   0.0}, <span class="comment">// 5</span>
<a name="l00307"></a>00307     {    0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   1.0,   0.0}, <span class="comment">// 6</span>
<a name="l00308"></a>00308     {    0.0,   0.0,   0.0,   0.0,   0.0,   0.0,   0.5,   0.5}  <span class="comment">// 7</span>
<a name="l00309"></a>00309   }
<a name="l00310"></a>00310 };
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 <span class="preprocessor">#endif</span>
<a name="l00315"></a>00315 <span class="preprocessor"></span>
<a name="l00316"></a>00316 } <span class="comment">// namespace libMesh</span>
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
