<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_hex8.h</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex8_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex8.h 4246 2011-03-11 22:24:59Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_hex8_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_hex8_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex_8h.php">cell_inf_hex.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00059"></a>00059 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00060"></a>00060 <span class="comment">// InfHex8 class definition</span>
<a name="l00061"></a><a class="code" href="classlibMesh_1_1InfHex8.php">00061</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfHex8.php">InfHex8</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1InfHex.php">InfHex</a>
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063 <span class="keyword">public</span>:
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1InfHex8.php#ae6eeeb101ec8c0e4b15888f46a4bcbe5">InfHex8</a>  (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL);
<a name="l00069"></a>00069     
<a name="l00073"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a6a594bdc4ad56f49a06f2b85e575e293">00073</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a6a594bdc4ad56f49a06f2b85e575e293">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00074"></a>00074 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1InfHex8.php#af2442cb01fd6c16985e5312a60c0a73b">00078</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>     <a class="code" href="classlibMesh_1_1InfHex8.php#af2442cb01fd6c16985e5312a60c0a73b">type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>; }
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1InfHex8.php#ac9a2f618c830497f27b7658b8f589c78">00083</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex8.php#ac9a2f618c830497f27b7658b8f589c78">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00084"></a>00084   
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a39da6b6e720d108e41a48a59921bdd9b">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a5f2b7e54152c8f1cbac20f4bb8968319">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a58f08886d8607c0c5792e9a453560798">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00099"></a>00099   
<a name="l00100"></a>00100   <span class="comment">/*</span>
<a name="l00101"></a>00101 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00102"></a>00102 <span class="comment">   * specified side</span>
<a name="l00103"></a>00103 <span class="comment">   */</span>
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a8bb2c5e780a8c06e87b9672630d9d359">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00105"></a>00105                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   <span class="comment">/*</span>
<a name="l00108"></a>00108 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00109"></a>00109 <span class="comment">   * specified edge</span>
<a name="l00110"></a>00110 <span class="comment">   */</span>
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a00c7610664ab6b308d9854a561177238">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00112"></a>00112                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00113"></a>00113   
<a name="l00117"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a71a0c655ac48a9d4442508204ea4ae9a">00117</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        <a class="code" href="classlibMesh_1_1InfHex8.php#a71a0c655ac48a9d4442508204ea4ae9a">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00118"></a>00118   
<a name="l00124"></a>00124   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex8.php#af8783c4fae43ef97826aa5147215a6a9">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00125"></a>00125                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00126"></a>00126 <span class="comment">/*   {  */</span>
<a name="l00127"></a>00127 <span class="comment">/*     // side() returns an AutoPtr to a DofObject, hence need to cast to Elem* */</span>
<a name="l00128"></a>00128 <span class="comment">/*     AutoPtr&lt;DofObject&gt; ap_dof_object(this-&gt;side(i)); */</span>
<a name="l00129"></a>00129 <span class="comment">/*     Elem* side = libmesh_cast_ptr&lt;Elem*&gt;(ap_dof_object.release()); */</span>
<a name="l00130"></a>00130 <span class="comment">/*     libmesh_assert(side); // libmesh_assert that the cast was successful */</span>
<a name="l00131"></a>00131     
<a name="l00132"></a>00132 <span class="comment">/*     AutoPtr&lt;Elem&gt; ap(side); */</span>
<a name="l00133"></a>00133 <span class="comment">/*     return ap; */</span>
<a name="l00134"></a>00134 <span class="comment">/*   } */</span>
<a name="l00135"></a>00135 
<a name="l00141"></a>00141   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex8.php#aadf74634122d5650653b7d9bf8a89b1f">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfHex8.php#aa9b2d55c0bab257346626f963fc12473">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00144"></a>00144                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00145"></a>00145                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="comment">//   void tecplot_connectivity(const unsigned int sc,</span>
<a name="l00148"></a>00148 <span class="comment">//                          std::vector&lt;unsigned int&gt;&amp; conn) const;</span>
<a name="l00149"></a>00149   
<a name="l00150"></a>00150 <span class="comment">//   void vtk_connectivity(const unsigned int,</span>
<a name="l00151"></a>00151 <span class="comment">//                      std::vector&lt;unsigned int&gt;*) const</span>
<a name="l00152"></a>00152 <span class="comment">//   { libmesh_error(); }</span>
<a name="l00153"></a>00153   
<a name="l00154"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a5632c0033f5de09b7f590d968c559b27">00154</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a5632c0033f5de09b7f590d968c559b27">vtk_element_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00155"></a>00155 <span class="keyword">  </span>{ <span class="keywordflow">return</span> 12; }
<a name="l00156"></a>00156   
<a name="l00162"></a>00162   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a7ed4d9e95dcdd2e3bb90ad9b8df9175f">contains_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol=TOLERANCE) <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00168"></a><a class="code" href="classlibMesh_1_1InfHex8.php#aada41d14f4549022ace8b7a0ef60d73d">00168</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex8.php#aada41d14f4549022ace8b7a0ef60d73d">side_nodes_map</a>[5][4];
<a name="l00169"></a>00169 
<a name="l00174"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a109ae76106c920f7268b01c0e10aab62">00174</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a109ae76106c920f7268b01c0e10aab62">edge_nodes_map</a>[8][2];
<a name="l00175"></a>00175   
<a name="l00176"></a>00176   
<a name="l00177"></a>00177 <span class="keyword">protected</span>:
<a name="l00178"></a>00178   
<a name="l00179"></a>00179   
<a name="l00180"></a>00180 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00181"></a>00181 <span class="preprocessor"></span>
<a name="l00185"></a><a class="code" href="classlibMesh_1_1InfHex8.php#aac8ba4c74f6521bb33b1c535490f143f">00185</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfHex8.php#aac8ba4c74f6521bb33b1c535490f143f">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00186"></a>00186                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00187"></a>00187                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00188"></a>00188 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a8cb84551013cc1bc8ada1ca036ce7119">_embedding_matrix</a>[i][j][k]; }
<a name="l00189"></a>00189 
<a name="l00194"></a><a class="code" href="classlibMesh_1_1InfHex8.php#a8cb84551013cc1bc8ada1ca036ce7119">00194</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfHex8.php#a8cb84551013cc1bc8ada1ca036ce7119">_embedding_matrix</a>[4][8][8];
<a name="l00195"></a>00195     
<a name="l00196"></a>00196 <span class="preprocessor">#endif</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>
<a name="l00198"></a>00198 };
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00203"></a>00203 <span class="comment">// InfHex8 class member functions</span>
<a name="l00204"></a>00204 <span class="keyword">inline</span>
<a name="l00205"></a><a class="code" href="classlibMesh_1_1InfHex8.php#ae6eeeb101ec8c0e4b15888f46a4bcbe5">00205</a> <a class="code" href="classlibMesh_1_1InfHex8.php#ae6eeeb101ec8c0e4b15888f46a4bcbe5">InfHex8::InfHex8</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00206"></a>00206   <a class="code" href="classlibMesh_1_1InfHex.php">InfHex</a>(<a class="code" href="classlibMesh_1_1InfHex8.php">InfHex8</a>::<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>(), p) 
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208 }
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 } <span class="comment">// namespace libMesh</span>
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="preprocessor">#endif  // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span>
<a name="l00215"></a>00215 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
