<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_hex.C</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex.C 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::min, std::max</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes cont&#39;d</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex_8h.php">cell_inf_hex.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__quad4_8h.php">face_quad4.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad4_8h.php">face_inf_quad4.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// InfHex class member functions</span>
<a name="l00042"></a><a class="code" href="classlibMesh_1_1InfHex.php#a9028fabc1e7b4da4e7940e28af28d8f5">00042</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#a9028fabc1e7b4da4e7940e28af28d8f5">InfHex::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00043"></a>00043 <span class="keyword"></span>{
<a name="l00044"></a>00044   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keywordflow">switch</span> (s)
<a name="l00047"></a>00047     {
<a name="l00048"></a>00048     <span class="keywordflow">case</span> 0:  <span class="comment">// the face at z = -1</span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050       <span class="keywordflow">return</span>
<a name="l00051"></a>00051         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00052"></a>00052                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00053"></a>00053                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00054"></a>00054                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3));
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keywordflow">case</span> 1:  <span class="comment">// the face at y = -1</span>
<a name="l00057"></a>00057 
<a name="l00058"></a>00058       <span class="keywordflow">return</span>
<a name="l00059"></a>00059         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00060"></a>00060                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00061"></a>00061                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5),
<a name="l00062"></a>00062                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4));
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keywordflow">case</span> 2:  <span class="comment">// the face at x = 1</span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066       <span class="keywordflow">return</span>
<a name="l00067"></a>00067         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00068"></a>00068                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00069"></a>00069                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6),
<a name="l00070"></a>00070                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5));
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     <span class="keywordflow">case</span> 3: <span class="comment">// the face at y = 1</span>
<a name="l00073"></a>00073 
<a name="l00074"></a>00074       <span class="keywordflow">return</span>
<a name="l00075"></a>00075         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00076"></a>00076                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3),
<a name="l00077"></a>00077                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7),
<a name="l00078"></a>00078                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6));
<a name="l00079"></a>00079       
<a name="l00080"></a>00080         
<a name="l00081"></a>00081     <span class="keywordflow">case</span> 4: <span class="comment">// the face at x = -1</span>
<a name="l00082"></a>00082 
<a name="l00083"></a>00083       <span class="keywordflow">return</span>
<a name="l00084"></a>00084         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3),
<a name="l00085"></a>00085                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00086"></a>00086                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4),
<a name="l00087"></a>00087                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7));
<a name="l00088"></a>00088     }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00091"></a>00091   libmesh_error();
<a name="l00092"></a>00092  <span class="keywordflow">return</span> 0;
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1InfHex.php#ad396fa26daee8bd1672f3df32695e6be">00097</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex.php#ad396fa26daee8bd1672f3df32695e6be">InfHex::side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword"></span>{
<a name="l00099"></a>00099   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="comment">/*</span>
<a name="l00102"></a>00102 <span class="comment">   *Think of a unit cube: (-1,1) x (-1,1)x (-1,1),</span>
<a name="l00103"></a>00103 <span class="comment">   * with (in general) the normals pointing outwards</span>
<a name="l00104"></a>00104 <span class="comment">   */</span>
<a name="l00105"></a>00105   <span class="keywordflow">switch</span> (i)
<a name="l00106"></a>00106     {
<a name="l00107"></a>00107     <span class="keywordflow">case</span> 0:  <span class="comment">// the face at z = -1</span>
<a name="l00108"></a>00108       <span class="comment">// the base, where the infinite element couples to conventional</span>
<a name="l00109"></a>00109       <span class="comment">// elements</span>
<a name="l00110"></a>00110       {  
<a name="l00111"></a>00111         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* face = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a>;
<a name="l00112"></a>00112         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00113"></a>00113 
<a name="l00114"></a>00114         <span class="comment">/*</span>
<a name="l00115"></a>00115 <span class="comment">         * Oops, here we are, claiming the normal of the face</span>
<a name="l00116"></a>00116 <span class="comment">         * elements point outwards -- and this is the exception:</span>
<a name="l00117"></a>00117 <span class="comment">         * For the side built from the base face, </span>
<a name="l00118"></a>00118 <span class="comment">         * the normal is pointing _into_ the element!</span>
<a name="l00119"></a>00119 <span class="comment">         * Why is that? - In agreement with build_side(),</span>
<a name="l00120"></a>00120 <span class="comment">         * which in turn _has_ to build the face in this</span>
<a name="l00121"></a>00121 <span class="comment">         * way as to enable the cool way \p InfFE re-uses \p FE.</span>
<a name="l00122"></a>00122 <span class="comment">         */</span>
<a name="l00123"></a>00123         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00124"></a>00124         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00125"></a>00125         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00126"></a>00126         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128         <span class="keywordflow">return</span> ap_face;
<a name="l00129"></a>00129       }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     <span class="keywordflow">case</span> 1:  <span class="comment">// the face at y = -1</span>
<a name="l00132"></a>00132       <span class="comment">// this face connects to another infinite element</span>
<a name="l00133"></a>00133       {
<a name="l00134"></a>00134         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* face = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad4.php">InfQuad4</a>;
<a name="l00135"></a>00135         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00136"></a>00136 
<a name="l00137"></a>00137         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00138"></a>00138         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00139"></a>00139         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00140"></a>00140         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00141"></a>00141         
<a name="l00142"></a>00142         <span class="keywordflow">return</span> ap_face;
<a name="l00143"></a>00143       }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145     <span class="keywordflow">case</span> 2:  <span class="comment">// the face at x = 1</span>
<a name="l00146"></a>00146       <span class="comment">// this face connects to another infinite element</span>
<a name="l00147"></a>00147       {
<a name="l00148"></a>00148         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* face = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad4.php">InfQuad4</a>;
<a name="l00149"></a>00149         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00150"></a>00150         <span class="comment">//AutoPtr&lt;Elem&gt; face(new InfQuad4);</span>
<a name="l00151"></a>00151 
<a name="l00152"></a>00152         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00153"></a>00153         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00154"></a>00154         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00155"></a>00155         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157         <span class="keywordflow">return</span> ap_face;
<a name="l00158"></a>00158       }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160     <span class="keywordflow">case</span> 3: <span class="comment">// the face at y = 1</span>
<a name="l00161"></a>00161       <span class="comment">// this face connects to another infinite element</span>
<a name="l00162"></a>00162       {
<a name="l00163"></a>00163         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* face = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad4.php">InfQuad4</a>;
<a name="l00164"></a>00164         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00165"></a>00165         <span class="comment">//AutoPtr&lt;Elem&gt; face(new InfQuad4);</span>
<a name="l00166"></a>00166 
<a name="l00167"></a>00167         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00168"></a>00168         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00169"></a>00169         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00170"></a>00170         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00171"></a>00171         
<a name="l00172"></a>00172         <span class="keywordflow">return</span> ap_face;
<a name="l00173"></a>00173       }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175     <span class="keywordflow">case</span> 4: <span class="comment">// the face at x = -1</span>
<a name="l00176"></a>00176       <span class="comment">// this face connects to another infinite element</span>
<a name="l00177"></a>00177       {  
<a name="l00178"></a>00178         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* face = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad4.php">InfQuad4</a>;
<a name="l00179"></a>00179         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00180"></a>00180         <span class="comment">//AutoPtr&lt;Elem&gt; face(new InfQuad4);</span>
<a name="l00181"></a>00181 
<a name="l00182"></a>00182         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00183"></a>00183         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00184"></a>00184         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00185"></a>00185         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187         <span class="keywordflow">return</span> ap_face;
<a name="l00188"></a>00188       }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190     <span class="keywordflow">default</span>:
<a name="l00191"></a>00191       {
<a name="l00192"></a>00192         libmesh_error();
<a name="l00193"></a>00193         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00194"></a>00194       }
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00198"></a>00198   libmesh_error();
<a name="l00199"></a>00199   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="classlibMesh_1_1InfHex.php#ab56bdb0def99d3c88adf0109e2f86531">00204</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex.php#ab56bdb0def99d3c88adf0109e2f86531">InfHex::is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00205"></a>00205                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00206"></a>00206 <span class="keyword"></span>{
<a name="l00207"></a>00207   libmesh_assert (c &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#a67b4314bc949e2f1af9423f7b154553a">n_children</a>());
<a name="l00208"></a>00208   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>());
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="keywordflow">return</span> (s == 0 || c+1 == s || c == s%4);
<a name="l00211"></a>00211 }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a><a class="code" href="classlibMesh_1_1InfHex.php#a4509c331956ca576cdbbd1e532e047f5">00215</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfHex.php#a4509c331956ca576cdbbd1e532e047f5">InfHex::quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00216"></a>00216 <span class="keyword"></span>{
<a name="l00217"></a>00217   <span class="keywordflow">switch</span> (q)
<a name="l00218"></a>00218     {
<a name="l00219"></a>00219       
<a name="l00229"></a>00229     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00230"></a>00230       {
<a name="l00231"></a>00231         <span class="comment">// Diagonal between node 0 and node 2</span>
<a name="l00232"></a>00232         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d02 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,2);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234         <span class="comment">// Diagonal between node 1 and node 3</span>
<a name="l00235"></a>00235         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d13 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,3);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237         <span class="comment">// Find the biggest and smallest diagonals</span>
<a name="l00238"></a>00238         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d02, d13);
<a name="l00239"></a>00239         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d02, d13);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241         libmesh_assert (max != 0.0);
<a name="l00242"></a>00242         
<a name="l00243"></a>00243         <span class="keywordflow">return</span> min / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>;
<a name="l00244"></a>00244 
<a name="l00245"></a>00245         <span class="keywordflow">break</span>;
<a name="l00246"></a>00246       }
<a name="l00247"></a>00247 
<a name="l00255"></a>00255     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00256"></a>00256       {
<a name="l00257"></a>00257 
<a name="l00261"></a>00261         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d01 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,1);
<a name="l00262"></a>00262         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d12 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,2);
<a name="l00263"></a>00263         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d23 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(2,3);
<a name="l00264"></a>00264         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d03 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,3);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266         std::vector&lt;Real&gt; edge_ratios(2);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268         <span class="comment">// Bottom</span>
<a name="l00269"></a>00269         edge_ratios[8] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d01, d23) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d01, d23);
<a name="l00270"></a>00270         edge_ratios[9] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(d03, d12) / <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d03, d12);
<a name="l00271"></a>00271         
<a name="l00272"></a>00272         <span class="keywordflow">return</span> *(std::min_element(edge_ratios.begin(), edge_ratios.end())) ;
<a name="l00273"></a>00273 
<a name="l00274"></a>00274         <span class="keywordflow">break</span>;
<a name="l00275"></a>00275       }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00285"></a>00285     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00286"></a>00286       {
<a name="l00290"></a>00290         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sqrt3 = 1.73205080756888;
<a name="l00291"></a>00291 
<a name="l00295"></a>00295         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d02 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,2);
<a name="l00296"></a>00296         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d13 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,3);
<a name="l00297"></a>00297         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> max_diag = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(d02, d13);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299         libmesh_assert ( max_diag != 0.0 );
<a name="l00300"></a>00300 
<a name="l00304"></a>00304         std::vector&lt;Real&gt; edges(4);
<a name="l00305"></a>00305         edges[0]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,1);
<a name="l00306"></a>00306         edges[1]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,2);
<a name="l00307"></a>00307         edges[2]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(2,3);
<a name="l00308"></a>00308         edges[3]  = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,3);
<a name="l00309"></a>00309 
<a name="l00310"></a>00310         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> min_edge = *(std::min_element(edges.begin(), edges.end()));
<a name="l00311"></a>00311         <span class="keywordflow">return</span> sqrt3 * min_edge / max_diag ;
<a name="l00312"></a>00312         <span class="keywordflow">break</span>;
<a name="l00313"></a>00313       }
<a name="l00314"></a>00314 
<a name="l00315"></a>00315       
<a name="l00320"></a>00320     <span class="keywordflow">default</span>:
<a name="l00321"></a>00321       {
<a name="l00322"></a>00322         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfHex.php#a4509c331956ca576cdbbd1e532e047f5">Elem::quality</a>(q);
<a name="l00323"></a>00323       }
<a name="l00324"></a>00324     }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326     
<a name="l00327"></a>00327     <span class="comment">// Will never get here...</span>
<a name="l00328"></a>00328     libmesh_error();
<a name="l00329"></a>00329     <span class="keywordflow">return</span> 0.;
<a name="l00330"></a>00330 }
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 
<a name="l00334"></a><a class="code" href="classlibMesh_1_1InfHex.php#ae564a25370ffd1aa94d4445eca2ebb10">00334</a> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1InfHex.php#ae564a25370ffd1aa94d4445eca2ebb10">InfHex::qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a>)<span class="keyword"> const</span>
<a name="l00335"></a>00335 <span class="keyword"></span>{
<a name="l00336"></a>00336   libmesh_not_implemented();
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   std::pair&lt;Real, Real&gt; bounds;
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 <span class="comment">/*</span>
<a name="l00341"></a>00341 <span class="comment">  switch (q)</span>
<a name="l00342"></a>00342 <span class="comment">    {</span>
<a name="l00343"></a>00343 <span class="comment"></span>
<a name="l00344"></a>00344 <span class="comment">    case ASPECT_RATIO:</span>
<a name="l00345"></a>00345 <span class="comment">      bounds.first  = 1.;</span>
<a name="l00346"></a>00346 <span class="comment">      bounds.second = 4.;</span>
<a name="l00347"></a>00347 <span class="comment">      break;</span>
<a name="l00348"></a>00348 <span class="comment">      </span>
<a name="l00349"></a>00349 <span class="comment">    case SKEW:</span>
<a name="l00350"></a>00350 <span class="comment">      bounds.first  = 0.;</span>
<a name="l00351"></a>00351 <span class="comment">      bounds.second = 0.5;</span>
<a name="l00352"></a>00352 <span class="comment">      break;</span>
<a name="l00353"></a>00353 <span class="comment"></span>
<a name="l00354"></a>00354 <span class="comment">    case SHEAR:</span>
<a name="l00355"></a>00355 <span class="comment">    case SHAPE:</span>
<a name="l00356"></a>00356 <span class="comment">      bounds.first  = 0.3;</span>
<a name="l00357"></a>00357 <span class="comment">      bounds.second = 1.;</span>
<a name="l00358"></a>00358 <span class="comment">      break;</span>
<a name="l00359"></a>00359 <span class="comment"></span>
<a name="l00360"></a>00360 <span class="comment">    case CONDITION:</span>
<a name="l00361"></a>00361 <span class="comment">      bounds.first  = 1.;</span>
<a name="l00362"></a>00362 <span class="comment">      bounds.second = 8.;</span>
<a name="l00363"></a>00363 <span class="comment">      break;</span>
<a name="l00364"></a>00364 <span class="comment"></span>
<a name="l00365"></a>00365 <span class="comment">    case JACOBIAN:</span>
<a name="l00366"></a>00366 <span class="comment">      bounds.first  = 0.5;</span>
<a name="l00367"></a>00367 <span class="comment">      bounds.second = 1.;</span>
<a name="l00368"></a>00368 <span class="comment">      break;  </span>
<a name="l00369"></a>00369 <span class="comment">      </span>
<a name="l00370"></a>00370 <span class="comment">    case DISTORTION:</span>
<a name="l00371"></a>00371 <span class="comment">      bounds.first  = 0.6;</span>
<a name="l00372"></a>00372 <span class="comment">      bounds.second = 1.;</span>
<a name="l00373"></a>00373 <span class="comment">      break;  </span>
<a name="l00374"></a>00374 <span class="comment"></span>
<a name="l00375"></a>00375 <span class="comment">    case TAPER:</span>
<a name="l00376"></a>00376 <span class="comment">      bounds.first  = 0.;</span>
<a name="l00377"></a>00377 <span class="comment">      bounds.second = 0.4;</span>
<a name="l00378"></a>00378 <span class="comment">      break;</span>
<a name="l00379"></a>00379 <span class="comment">      </span>
<a name="l00380"></a>00380 <span class="comment">    case STRETCH:</span>
<a name="l00381"></a>00381 <span class="comment">      bounds.first  = 0.25;</span>
<a name="l00382"></a>00382 <span class="comment">      bounds.second = 1.;</span>
<a name="l00383"></a>00383 <span class="comment">      break;</span>
<a name="l00384"></a>00384 <span class="comment">      </span>
<a name="l00385"></a>00385 <span class="comment">    case DIAGONAL:</span>
<a name="l00386"></a>00386 <span class="comment">      bounds.first  = 0.65;</span>
<a name="l00387"></a>00387 <span class="comment">      bounds.second = 1.;</span>
<a name="l00388"></a>00388 <span class="comment">      break;</span>
<a name="l00389"></a>00389 <span class="comment"></span>
<a name="l00390"></a>00390 <span class="comment">    case SIZE:</span>
<a name="l00391"></a>00391 <span class="comment">      bounds.first  = 0.5;</span>
<a name="l00392"></a>00392 <span class="comment">      bounds.second = 1.;</span>
<a name="l00393"></a>00393 <span class="comment">      break;</span>
<a name="l00394"></a>00394 <span class="comment">      </span>
<a name="l00395"></a>00395 <span class="comment">    default:</span>
<a name="l00396"></a>00396 <span class="comment">      libMesh::out &lt;&lt; &quot;Warning: Invalid quality measure chosen.&quot; &lt;&lt; std::endl;</span>
<a name="l00397"></a>00397 <span class="comment">      bounds.first  = -1;</span>
<a name="l00398"></a>00398 <span class="comment">      bounds.second = -1;</span>
<a name="l00399"></a>00399 <span class="comment">    }</span>
<a name="l00400"></a>00400 <span class="comment">*/</span>
<a name="l00401"></a>00401 
<a name="l00402"></a>00402   <span class="keywordflow">return</span> bounds;
<a name="l00403"></a>00403 }
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#a1ffa1361509b318958f7da6eb8daa5cd">InfHex::_second_order_adjacent_vertices</a>[8][2] = 
<a name="l00410"></a>00410 {
<a name="l00411"></a>00411   { 0,  1}, <span class="comment">// vertices adjacent to node 8 </span>
<a name="l00412"></a>00412   { 1,  2}, <span class="comment">// vertices adjacent to node 9 </span>
<a name="l00413"></a>00413   { 2,  3}, <span class="comment">// vertices adjacent to node 10 </span>
<a name="l00414"></a>00414   { 0,  3}, <span class="comment">// vertices adjacent to node 11</span>
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   { 4,  5}, <span class="comment">// vertices adjacent to node 12</span>
<a name="l00417"></a>00417   { 5,  6}, <span class="comment">// vertices adjacent to node 13</span>
<a name="l00418"></a>00418   { 6,  7}, <span class="comment">// vertices adjacent to node 14</span>
<a name="l00419"></a>00419   { 4,  7}  <span class="comment">// vertices adjacent to node 15</span>
<a name="l00420"></a>00420 };
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#ad0088faa57a16eaef4f4cfa32ea0b013">InfHex::_second_order_vertex_child_number</a>[18] =
<a name="l00425"></a>00425 {
<a name="l00426"></a>00426   99,99,99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00427"></a>00427   0,1,2,0,                 <span class="comment">// Edges</span>
<a name="l00428"></a>00428   0,1,2,0,0,               <span class="comment">// Faces</span>
<a name="l00429"></a>00429   0                        <span class="comment">// Interior</span>
<a name="l00430"></a>00430 };
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#a312673bd7501104d9abdf02ab6ab4869">InfHex::_second_order_vertex_child_index</a>[18] =
<a name="l00435"></a>00435 {
<a name="l00436"></a>00436   99,99,99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00437"></a>00437   1,2,3,3,                 <span class="comment">// Edges</span>
<a name="l00438"></a>00438   5,6,7,7,2,               <span class="comment">// Faces</span>
<a name="l00439"></a>00439   6                        <span class="comment">// Interior</span>
<a name="l00440"></a>00440 };
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 } <span class="comment">// namespace libMesh</span>
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
