<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_hex.h</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__hex_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_hex.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_hex_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_hex_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="cell__inf_8h.php">cell_inf.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00048"></a>00048 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// InfHex class definition</span>
<a name="l00050"></a><a class="code" href="classlibMesh_1_1InfHex.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfHex.php">InfHex</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1InfCell.php">InfCell</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1InfHex.php#a7a4c3d9444318deac5c81a64c214dbec">InfHex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="comment">//   /**</span>
<a name="l00061"></a>00061 <span class="comment">//    * @returns 4 for the base \p s=0 and 2 for side faces. </span>
<a name="l00062"></a>00062 <span class="comment">//    */</span>
<a name="l00063"></a>00063 <span class="comment">//   unsigned int n_children_per_side(const unsigned int s) const;</span>
<a name="l00064"></a>00064 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">00070</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#aa058c676698cc9c5ee4ab90a3433e3b9">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00071"></a>00071 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1InfHex.php#a6f7d6506e7030ef1c04e8060cf7718d4">00076</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#a6f7d6506e7030ef1c04e8060cf7718d4">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00077"></a>00077 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1InfHex.php#add6f00e7fee9ea06dfabb98d5c465f62">00082</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#add6f00e7fee9ea06dfabb98d5c465f62">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1InfHex.php#a99506f9dbe48b827a2ba27080b23f499">00087</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#a99506f9dbe48b827a2ba27080b23f499">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00088"></a>00088   
<a name="l00092"></a><a class="code" href="classlibMesh_1_1InfHex.php#a67b4314bc949e2f1af9423f7b154553a">00092</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#a67b4314bc949e2f1af9423f7b154553a">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="comment">/*</span>
<a name="l00095"></a>00095 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00096"></a>00096 <span class="comment">   * specified side</span>
<a name="l00097"></a>00097 <span class="comment">   */</span>
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfHex.php#ab56bdb0def99d3c88adf0109e2f86531">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00099"></a>00099                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00100"></a>00100   
<a name="l00106"></a>00106   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#a9028fabc1e7b4da4e7940e28af28d8f5">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfHex.php#ad396fa26daee8bd1672f3df32695e6be">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00113"></a>00113 
<a name="l00118"></a>00118   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfHex.php#a4509c331956ca576cdbbd1e532e047f5">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00119"></a>00119 
<a name="l00125"></a>00125   std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1InfHex.php#ae564a25370ffd1aa94d4445eca2ebb10">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   
<a name="l00129"></a>00129 <span class="keyword">protected</span>:
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   
<a name="l00142"></a><a class="code" href="classlibMesh_1_1InfHex.php#a1ffa1361509b318958f7da6eb8daa5cd">00142</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#a1ffa1361509b318958f7da6eb8daa5cd">_second_order_adjacent_vertices</a>[8][2];
<a name="l00143"></a>00143 
<a name="l00147"></a><a class="code" href="classlibMesh_1_1InfHex.php#ad0088faa57a16eaef4f4cfa32ea0b013">00147</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#ad0088faa57a16eaef4f4cfa32ea0b013">_second_order_vertex_child_number</a>[18];
<a name="l00148"></a>00148 
<a name="l00152"></a><a class="code" href="classlibMesh_1_1InfHex.php#a312673bd7501104d9abdf02ab6ab4869">00152</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfHex.php#a312673bd7501104d9abdf02ab6ab4869">_second_order_vertex_child_index</a>[18];
<a name="l00153"></a>00153 };
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00158"></a>00158 <span class="comment">// InfHex class member functions</span>
<a name="l00159"></a>00159 <span class="keyword">inline</span>
<a name="l00160"></a><a class="code" href="classlibMesh_1_1InfHex.php#a7a4c3d9444318deac5c81a64c214dbec">00160</a> <a class="code" href="classlibMesh_1_1InfHex.php#a7a4c3d9444318deac5c81a64c214dbec">InfHex::InfHex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00161"></a>00161   <a class="code" href="classlibMesh_1_1InfCell.php">InfCell</a>(nn, <a class="code" href="classlibMesh_1_1InfHex.php">InfHex</a>::n_sides(), p) 
<a name="l00162"></a>00162 {
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 <span class="comment">// inline</span>
<a name="l00167"></a>00167 <span class="comment">// unsigned int InfHex::n_children_per_side(const unsigned int s) const</span>
<a name="l00168"></a>00168 <span class="comment">// {</span>
<a name="l00169"></a>00169 <span class="comment">//   libmesh_assert (s &lt; this-&gt;n_sides());</span>
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="comment">//   switch (s)</span>
<a name="l00172"></a>00172 <span class="comment">//   {</span>
<a name="l00173"></a>00173 <span class="comment">//     case 0:</span>
<a name="l00174"></a>00174 <span class="comment">//       // every infinite element has 4 children in the base side</span>
<a name="l00175"></a>00175 <span class="comment">//       return 4;</span>
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 <span class="comment">//     default:</span>
<a name="l00178"></a>00178 <span class="comment">//       // on infinite faces (sides), only 2 children exist</span>
<a name="l00179"></a>00179 <span class="comment">//       //</span>
<a name="l00180"></a>00180 <span class="comment">//       // note that the face at infinity is already caught by the libmesh_assertion</span>
<a name="l00181"></a>00181 <span class="comment">//       return 2;</span>
<a name="l00182"></a>00182 <span class="comment">//   }</span>
<a name="l00183"></a>00183 <span class="comment">// }</span>
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 } <span class="comment">// namespace libMesh</span>
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>
<a name="l00190"></a>00190 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
