<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_prism12.C</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__prism12_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_prism12.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// Local includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes cont&#39;d</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__prism12_8h.php">cell_inf_prism12.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="edge__inf__edge2_8h.php">edge_inf_edge2.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__tri6_8h.php">face_tri6.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad6_8h.php">face_inf_quad6.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// InfPrism12 class static member initializations</span>
<a name="l00041"></a>00041 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#a70f3ce00e5bf17004aa9dc37bfd0d6b2">InfPrism12::side_nodes_map</a>[4][6] =
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   { 0, 1, 2, 6, 7, 8},  <span class="comment">// Side 0</span>
<a name="l00044"></a>00044   { 0, 1, 3, 4, 6, 9},  <span class="comment">// Side 1</span>
<a name="l00045"></a>00045   { 1, 2, 4, 5, 7, 10}, <span class="comment">// Side 2</span>
<a name="l00046"></a>00046   { 2, 0, 5, 3, 8, 11}  <span class="comment">// Side 3</span>
<a name="l00047"></a>00047 };
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#a1b27aead2fcc39753528ab205c79e5ef">InfPrism12::edge_nodes_map</a>[6][3] =
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051   { 0, 1, 6},  <span class="comment">// Side 0</span>
<a name="l00052"></a>00052   { 1, 2, 7},  <span class="comment">// Side 1</span>
<a name="l00053"></a>00053   { 0, 2, 8},  <span class="comment">// Side 2</span>
<a name="l00054"></a>00054   { 0, 3, 99}, <span class="comment">// Side 3</span>
<a name="l00055"></a>00055   { 1, 4, 99}, <span class="comment">// Side 4</span>
<a name="l00056"></a>00056   { 2, 5, 99}  <span class="comment">// Side 5</span>
<a name="l00057"></a>00057 };
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00061"></a>00061 <span class="comment">// InfPrism12 class member functions</span>
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#ad45ee7f9b78769f3f657c024c05e10c2">00063</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#ad45ee7f9b78769f3f657c024c05e10c2">InfPrism12::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   <span class="keywordflow">if</span> (i &lt; 3)
<a name="l00066"></a>00066     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#aef9f3d95618b1cfc9f56497dada39703">00070</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#aef9f3d95618b1cfc9f56497dada39703">InfPrism12::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00071"></a>00071 <span class="keyword"></span>{
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (i &lt; 3)
<a name="l00073"></a>00073     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (i &gt; 8)
<a name="l00075"></a>00075     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00076"></a>00076   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#ab4e30ef61b447d1d1fcc9d53c1380d8e">00079</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#ab4e30ef61b447d1d1fcc9d53c1380d8e">InfPrism12::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword"></span>{
<a name="l00081"></a>00081   <span class="keywordflow">if</span> (i &gt; 8)
<a name="l00082"></a>00082     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00083"></a>00083   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#ac39dbf83050557cd896afcdf1e5ea0e8">00086</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#ac39dbf83050557cd896afcdf1e5ea0e8">InfPrism12::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00087"></a>00087                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword"></span>{
<a name="l00089"></a>00089   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1InfPrism.php#a77fb5e24f82732159115989354fd8cb3">n_sides</a>());
<a name="l00090"></a>00090   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 6; ++i)
<a name="l00091"></a>00091     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfPrism12.php#a70f3ce00e5bf17004aa9dc37bfd0d6b2">side_nodes_map</a>[s][i] == n)
<a name="l00092"></a>00092       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00093"></a>00093   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#a3bd8fe1933db789f7f3e7f3db138ba4f">00096</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#a3bd8fe1933db789f7f3e7f3db138ba4f">InfPrism12::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00097"></a>00097                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword"></span>{
<a name="l00099"></a>00099   libmesh_assert(e &lt; <a class="code" href="classlibMesh_1_1InfPrism.php#a22f8902d3eadcc75b0406c00e3e39dbc">n_edges</a>());
<a name="l00100"></a>00100   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00101"></a>00101     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfPrism12.php#a1b27aead2fcc39753528ab205c79e5ef">edge_nodes_map</a>[e][i] == n)
<a name="l00102"></a>00102       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00103"></a>00103   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#a6104dcfe4e2ef46f201301ff0fba5fc3">00106</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfPrism12.php#a6104dcfe4e2ef46f201301ff0fba5fc3">InfPrism12::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00107"></a>00107                                       <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00108"></a>00108 <span class="keyword"></span>{
<a name="l00109"></a>00109   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfPrism.php#a77fb5e24f82732159115989354fd8cb3">n_sides</a>());
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="keywordflow">if</span> (proxy)
<a name="l00112"></a>00112     {
<a name="l00113"></a>00113       <span class="keywordflow">switch</span> (i)
<a name="l00114"></a>00114         {
<a name="l00115"></a>00115           <span class="comment">// base</span>
<a name="l00116"></a>00116         <span class="keywordflow">case</span> 0:
<a name="l00117"></a>00117           {
<a name="l00118"></a>00118             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Tri6,InfPrism12&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00119"></a>00119             <span class="keywordflow">return</span> ap;
<a name="l00120"></a>00120           }
<a name="l00121"></a>00121           <span class="comment">// ifem sides</span>
<a name="l00122"></a>00122         <span class="keywordflow">case</span> 1:
<a name="l00123"></a>00123         <span class="keywordflow">case</span> 2:
<a name="l00124"></a>00124         <span class="keywordflow">case</span> 3:
<a name="l00125"></a>00125           {
<a name="l00126"></a>00126             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;InfQuad6,InfPrism12&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00127"></a>00127             <span class="keywordflow">return</span> ap;
<a name="l00128"></a>00128           }
<a name="l00129"></a>00129         <span class="keywordflow">default</span>:
<a name="l00130"></a>00130           libmesh_error();
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132     }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="keywordflow">else</span>
<a name="l00135"></a>00135     {
<a name="l00136"></a>00136       <span class="keywordflow">switch</span> (i)
<a name="l00137"></a>00137         {
<a name="l00138"></a>00138         <span class="keywordflow">case</span> 0:  <span class="comment">// the triangular face at z=-1, base face</span>
<a name="l00139"></a>00139           {
<a name="l00140"></a>00140             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142             <span class="comment">// Note that for this face element, the normal points inward</span>
<a name="l00143"></a>00143             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00144"></a>00144             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00145"></a>00145             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00146"></a>00146             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00147"></a>00147             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00148"></a>00148             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150             <span class="keywordflow">return</span> face;
<a name="l00151"></a>00151           }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153         <span class="keywordflow">case</span> 1:  <span class="comment">// the quad face at y=0</span>
<a name="l00154"></a>00154           {
<a name="l00155"></a>00155             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00156"></a>00156         
<a name="l00157"></a>00157             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00158"></a>00158             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00159"></a>00159             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00160"></a>00160             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00161"></a>00161             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00162"></a>00162             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00163"></a>00163         
<a name="l00164"></a>00164             <span class="keywordflow">return</span> face;
<a name="l00165"></a>00165           }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167         <span class="keywordflow">case</span> 2:  <span class="comment">// the other quad face</span>
<a name="l00168"></a>00168           {
<a name="l00169"></a>00169             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00172"></a>00172             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00173"></a>00173             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00174"></a>00174             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00175"></a>00175             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00176"></a>00176             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(10);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178             <span class="keywordflow">return</span> face;
<a name="l00179"></a>00179           }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181         <span class="keywordflow">case</span> 3: <span class="comment">// the quad face at x=0</span>
<a name="l00182"></a>00182           {
<a name="l00183"></a>00183             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00186"></a>00186             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00187"></a>00187             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00188"></a>00188             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00189"></a>00189             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00190"></a>00190             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(11);
<a name="l00191"></a>00191         
<a name="l00192"></a>00192             <span class="keywordflow">return</span> face;
<a name="l00193"></a>00193           }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195         <span class="keywordflow">default</span>:
<a name="l00196"></a>00196           {
<a name="l00197"></a>00197             libmesh_error();
<a name="l00198"></a>00198             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00199"></a>00199           }
<a name="l00200"></a>00200         }
<a name="l00201"></a>00201     }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   
<a name="l00204"></a>00204   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00205"></a>00205   libmesh_error();
<a name="l00206"></a>00206   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00207"></a>00207 }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#a00828ebb80392a3cdfae09892d611f46">00210</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfPrism12.php#a00828ebb80392a3cdfae09892d611f46">InfPrism12::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00211"></a>00211 <span class="keyword"></span>{
<a name="l00212"></a>00212   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfPrism.php#a22f8902d3eadcc75b0406c00e3e39dbc">n_edges</a>());
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="keywordflow">if</span> (i &lt; 3) <span class="comment">// base edges</span>
<a name="l00215"></a>00215     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;Edge3,InfPrism12&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00216"></a>00216   <span class="comment">// infinite edges</span>
<a name="l00217"></a>00217   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;InfEdge2,InfPrism12&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00218"></a>00218 }
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#a42d150d75ce02fe1dc37ec45b8a815bc">00221</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#a42d150d75ce02fe1dc37ec45b8a815bc">InfPrism12::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00222"></a>00222                               <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00223"></a>00223                               std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00224"></a>00224 <span class="keyword"></span>{
<a name="l00225"></a>00225   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL);
<a name="l00226"></a>00226   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfPrism12.php#aa28bf60002eaa6be21f41b516240fb1d">n_sub_elem</a>());
<a name="l00227"></a>00227   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="keywordflow">switch</span> (iop)
<a name="l00230"></a>00230     {
<a name="l00231"></a>00231     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00232"></a>00232       {
<a name="l00233"></a>00233         conn.resize(8);
<a name="l00234"></a>00234         <span class="keywordflow">switch</span> (sc)
<a name="l00235"></a>00235           {
<a name="l00236"></a>00236           <span class="keywordflow">case</span> 0:
<a name="l00237"></a>00237 
<a name="l00238"></a>00238             <span class="comment">// guess this is a collapsed hex8</span>
<a name="l00239"></a>00239             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00240"></a>00240             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00241"></a>00241             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00242"></a>00242             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00243"></a>00243             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00244"></a>00244             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00245"></a>00245             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00246"></a>00246             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00247"></a>00247 
<a name="l00248"></a>00248             <span class="keywordflow">return</span>;
<a name="l00249"></a>00249 
<a name="l00250"></a>00250           <span class="keywordflow">case</span> 1:
<a name="l00251"></a>00251 
<a name="l00252"></a>00252             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00253"></a>00253             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00254"></a>00254             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00255"></a>00255             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00256"></a>00256             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00257"></a>00257             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10)+1;
<a name="l00258"></a>00258             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00259"></a>00259             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261             <span class="keywordflow">return</span>;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263           <span class="keywordflow">case</span> 2:
<a name="l00264"></a>00264 
<a name="l00265"></a>00265             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00266"></a>00266             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00267"></a>00267             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00268"></a>00268             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00269"></a>00269             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00270"></a>00270             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00271"></a>00271             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10)+1;
<a name="l00272"></a>00272             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10)+1;
<a name="l00273"></a>00273 
<a name="l00274"></a>00274             <span class="keywordflow">return</span>;
<a name="l00275"></a>00275 
<a name="l00276"></a>00276           <span class="keywordflow">case</span> 3:
<a name="l00277"></a>00277 
<a name="l00278"></a>00278             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00279"></a>00279             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00280"></a>00280             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00281"></a>00281             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00282"></a>00282             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00283"></a>00283             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10)+1;
<a name="l00284"></a>00284             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00285"></a>00285             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00286"></a>00286 
<a name="l00287"></a>00287             <span class="keywordflow">return</span>;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289           <span class="keywordflow">default</span>:
<a name="l00290"></a>00290             libmesh_error();
<a name="l00291"></a>00291       
<a name="l00292"></a>00292           }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294       }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296     <span class="keywordflow">default</span>:
<a name="l00297"></a>00297       libmesh_error();
<a name="l00298"></a>00298     }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   libmesh_error();
<a name="l00301"></a>00301 }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#acee20fd89f9deadaad0af66b4be87366">00307</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#acee20fd89f9deadaad0af66b4be87366">InfPrism12::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00308"></a>00308                                                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00309"></a>00309 <span class="keyword"></span>{ 
<a name="l00310"></a>00310   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1InfPrism.php#a5f088f4d331939daddf2d418047e98ea">n_vertices</a>());
<a name="l00311"></a>00311   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classlibMesh_1_1InfPrism12.php#a67c84e088262e00cf1316cf1039fb2e5">n_nodes</a>());
<a name="l00312"></a>00312   libmesh_assert (v &lt;  2);
<a name="l00313"></a>00313   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#aa4bda581487a8f4ce8dc214be88af494">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classlibMesh_1_1InfPrism.php#a5f088f4d331939daddf2d418047e98ea">n_vertices</a>()][v]; 
<a name="l00314"></a>00314 }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#aa4bda581487a8f4ce8dc214be88af494">InfPrism12::_second_order_adjacent_vertices</a>[6][2] = 
<a name="l00319"></a>00319 {
<a name="l00320"></a>00320   { 0,  1}, <span class="comment">// vertices adjacent to node 6 </span>
<a name="l00321"></a>00321   { 1,  2}, <span class="comment">// vertices adjacent to node 7 </span>
<a name="l00322"></a>00322   { 0,  2}, <span class="comment">// vertices adjacent to node 8 </span>
<a name="l00323"></a>00323 
<a name="l00324"></a>00324   { 3,  4}, <span class="comment">// vertices adjacent to node 9 </span>
<a name="l00325"></a>00325   { 4,  5}, <span class="comment">// vertices adjacent to node 10 </span>
<a name="l00326"></a>00326   { 3,  5}  <span class="comment">// vertices adjacent to node 11</span>
<a name="l00327"></a>00327 };
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00332"></a><a class="code" href="classlibMesh_1_1InfPrism12.php#ab64601a0cd4cfc9818d91ddb1a93898a">00332</a> <a class="code" href="classlibMesh_1_1InfPrism12.php#ab64601a0cd4cfc9818d91ddb1a93898a">InfPrism12::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00333"></a>00333 <span class="keyword"></span>{
<a name="l00334"></a>00334   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1InfPrism.php#a5f088f4d331939daddf2d418047e98ea">n_vertices</a>());
<a name="l00335"></a>00335   libmesh_assert (n &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfPrism12.php#a67c84e088262e00cf1316cf1039fb2e5">n_nodes</a>());
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00338"></a>00338     (<a class="code" href="classlibMesh_1_1InfPrism12.php#aeeb235dfaf8a917352e6db011796ba9d">_second_order_vertex_child_number</a>[n],
<a name="l00339"></a>00339      <a class="code" href="classlibMesh_1_1InfPrism12.php#a132fb1bc36481346c2e9538a6141ccd7">_second_order_vertex_child_index</a>[n]);
<a name="l00340"></a>00340 }
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#aeeb235dfaf8a917352e6db011796ba9d">InfPrism12::_second_order_vertex_child_number</a>[12] =
<a name="l00345"></a>00345 {
<a name="l00346"></a>00346   99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00347"></a>00347   0,1,0,             <span class="comment">// Edges</span>
<a name="l00348"></a>00348   0,1,0              <span class="comment">// Faces</span>
<a name="l00349"></a>00349 };
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#a132fb1bc36481346c2e9538a6141ccd7">InfPrism12::_second_order_vertex_child_index</a>[12] =
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   99,99,99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00356"></a>00356   1,2,2,             <span class="comment">// Edges</span>
<a name="l00357"></a>00357   4,5,5              <span class="comment">// Faces</span>
<a name="l00358"></a>00358 };
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00363"></a>00363 <span class="preprocessor"></span>
<a name="l00364"></a>00364 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfPrism12.php#ab15bb4100066d0f83599c183c7f478e5">InfPrism12::_embedding_matrix</a>[4][12][12] =
<a name="l00365"></a>00365 {
<a name="l00366"></a>00366   <span class="comment">// embedding matrix for child 0</span>
<a name="l00367"></a>00367   {
<a name="l00368"></a>00368     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11 th parent Node</span>
<a name="l00369"></a>00369     {         1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00370"></a>00370     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00371"></a>00371     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00372"></a>00372     {         0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00373"></a>00373     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0}, <span class="comment">// 4</span>
<a name="l00374"></a>00374     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 5</span>
<a name="l00375"></a>00375     {       0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00376"></a>00376     {         0.0,     -0.125,     -0.125,        0.0,        0.0,        0.0,        0.5,       0.25,        0.5,        0.0,        0.0,        0.0}, <span class="comment">// 7</span>
<a name="l00377"></a>00377     {       0.375,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00378"></a>00378     {         0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00379"></a>00379     {         0.0,        0.0,        0.0,        0.0,     -0.125,     -0.125,        0.0,        0.0,        0.0,        0.5,       0.25,        0.5}, <span class="comment">// 10</span>
<a name="l00380"></a>00380     {         0.0,        0.0,        0.0,      0.375,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75}  <span class="comment">// 11</span>
<a name="l00381"></a>00381   },
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   <span class="comment">// embedding matrix for child 1</span>
<a name="l00384"></a>00384   {
<a name="l00385"></a>00385     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11 th parent Node</span>
<a name="l00386"></a>00386     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00387"></a>00387     {         0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00388"></a>00388     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00389"></a>00389     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00390"></a>00390     {         0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 4</span>
<a name="l00391"></a>00391     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 5</span>
<a name="l00392"></a>00392     {      -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00393"></a>00393     {         0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 7</span>
<a name="l00394"></a>00394     {      -0.125,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.5,        0.5,       0.25,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00395"></a>00395     {         0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0}, <span class="comment">// 9</span>
<a name="l00396"></a>00396     {         0.0,        0.0,        0.0,        0.0,      0.375,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 10</span>
<a name="l00397"></a>00397     {         0.0,        0.0,        0.0,     -0.125,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.5,        0.5,       0.25}  <span class="comment">// 11</span>
<a name="l00398"></a>00398   },
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   <span class="comment">// embedding matrix for child 2</span>
<a name="l00401"></a>00401   {
<a name="l00402"></a>00402     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11 th parent Node</span>
<a name="l00403"></a>00403     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00404"></a>00404     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00405"></a>00405     {         0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00406"></a>00406     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 3</span>
<a name="l00407"></a>00407     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 4</span>
<a name="l00408"></a>00408     {         0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 5</span>
<a name="l00409"></a>00409     {      -0.125,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.25,        0.5,        0.5,        0.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00410"></a>00410     {         0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 7</span>
<a name="l00411"></a>00411     {      -0.125,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00412"></a>00412     {         0.0,        0.0,        0.0,     -0.125,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.25,        0.5,        0.5}, <span class="comment">// 9</span>
<a name="l00413"></a>00413     {         0.0,        0.0,        0.0,        0.0,     -0.125,      0.375,        0.0,        0.0,        0.0,        0.0,       0.75,        0.0}, <span class="comment">// 10</span>
<a name="l00414"></a>00414     {         0.0,        0.0,        0.0,     -0.125,        0.0,      0.375,        0.0,        0.0,        0.0,        0.0,        0.0,       0.75}  <span class="comment">// 11</span>
<a name="l00415"></a>00415   },
<a name="l00416"></a>00416 
<a name="l00417"></a>00417   <span class="comment">// embedding matrix for child 3</span>
<a name="l00418"></a>00418   {
<a name="l00419"></a>00419     <span class="comment">//          0           1           2           3           4           5           6           7           8           9          10          11 th parent Node</span>
<a name="l00420"></a>00420     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 0th child N.</span>
<a name="l00421"></a>00421     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0,        0.0}, <span class="comment">// 1</span>
<a name="l00422"></a>00422     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0,        0.0}, <span class="comment">// 2</span>
<a name="l00423"></a>00423     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0,        0.0}, <span class="comment">// 3</span>
<a name="l00424"></a>00424     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0,        0.0}, <span class="comment">// 4</span>
<a name="l00425"></a>00425     {         0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        0.0,        1.0}, <span class="comment">// 5</span>
<a name="l00426"></a>00426     {      -0.125,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.5,        0.5,       0.25,        0.0,        0.0,        0.0}, <span class="comment">// 6</span>
<a name="l00427"></a>00427     {      -0.125,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.25,        0.5,        0.5,        0.0,        0.0,        0.0}, <span class="comment">// 7</span>
<a name="l00428"></a>00428     {         0.0,     -0.125,     -0.125,        0.0,        0.0,        0.0,        0.5,       0.25,        0.5,        0.0,        0.0,        0.0}, <span class="comment">// 8</span>
<a name="l00429"></a>00429     {         0.0,        0.0,        0.0,     -0.125,        0.0,     -0.125,        0.0,        0.0,        0.0,        0.5,        0.5,       0.25}, <span class="comment">// 9</span>
<a name="l00430"></a>00430     {         0.0,        0.0,        0.0,     -0.125,     -0.125,        0.0,        0.0,        0.0,        0.0,       0.25,        0.5,        0.5}, <span class="comment">// 10</span>
<a name="l00431"></a>00431     {         0.0,        0.0,        0.0,        0.0,     -0.125,     -0.125,        0.0,        0.0,        0.0,        0.5,       0.25,        0.5}  <span class="comment">// 11</span>
<a name="l00432"></a>00432   }
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 };
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 <span class="preprocessor">#endif</span>
<a name="l00440"></a>00440 <span class="preprocessor"></span>
<a name="l00441"></a>00441 } <span class="comment">// namespace libMesh</span>
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
