<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_prism6.h</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__prism6_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_prism6.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_prism6_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_prism6_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__prism_8h.php">cell_inf_prism.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00060"></a>00060 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00061"></a>00061 <span class="comment">// InfPrism6 class definition</span>
<a name="l00062"></a><a class="code" href="classlibMesh_1_1InfPrism6.php">00062</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfPrism6.php">InfPrism6</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1InfPrism.php">InfPrism</a>
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064 <span class="keyword">public</span>:
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1InfPrism6.php#a0281c1f8cde2c928c1cb0381281a6dab">InfPrism6</a>  (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL);
<a name="l00070"></a>00070     
<a name="l00074"></a><a class="code" href="classlibMesh_1_1InfPrism6.php#a3ba03e49fb128c9ac945cdb8d846ed68">00074</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a3ba03e49fb128c9ac945cdb8d846ed68">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00075"></a>00075   
<a name="l00079"></a><a class="code" href="classlibMesh_1_1InfPrism6.php#abcbde9724ce64df4f503dc7576dff480">00079</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>     <a class="code" href="classlibMesh_1_1InfPrism6.php#abcbde9724ce64df4f503dc7576dff480">type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>; }
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1InfPrism6.php#a39be01b744982375d56855424c654aac">00084</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a39be01b744982375d56855424c654aac">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00085"></a>00085   
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a759bf14076cb0842255831496324ea31">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a0cce919c3b9b071ec99a7c444f233de7">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a114ead4d1a4f5ad2dc9111343feae924">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">/*</span>
<a name="l00102"></a>00102 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00103"></a>00103 <span class="comment">   * specified side</span>
<a name="l00104"></a>00104 <span class="comment">   */</span>
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a2d839c5f4bd875ac835de76b8ab0a9b7">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00106"></a>00106                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   <span class="comment">/*</span>
<a name="l00109"></a>00109 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00110"></a>00110 <span class="comment">   * specified edge</span>
<a name="l00111"></a>00111 <span class="comment">   */</span>
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a509a34844969cf1cc9078aa4ed7367b5">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00113"></a>00113                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00114"></a>00114   
<a name="l00118"></a><a class="code" href="classlibMesh_1_1InfPrism6.php#aa09bbc4dd3f7a18eb41e9baea2c75857">00118</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        <a class="code" href="classlibMesh_1_1InfPrism6.php#aa09bbc4dd3f7a18eb41e9baea2c75857">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00119"></a>00119   
<a name="l00125"></a>00125   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfPrism6.php#a563e77260d17e41297e7c693c2386a46">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00126"></a>00126                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00127"></a>00127   
<a name="l00133"></a>00133   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfPrism6.php#a3c00f9dce86392e6d17673531bd336c0">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a6bef421bee325d681e9e5255eb98960a">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00136"></a>00136                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00137"></a>00137                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="comment">//   void tecplot_connectivity(const unsigned int sc,</span>
<a name="l00140"></a>00140 <span class="comment">//                          std::vector&lt;unsigned int&gt;&amp; conn) const;</span>
<a name="l00141"></a>00141   
<a name="l00142"></a>00142 <span class="comment">//   void vtk_connectivity(const unsigned int,</span>
<a name="l00143"></a>00143 <span class="comment">//                      std::vector&lt;unsigned int&gt;*) const</span>
<a name="l00144"></a>00144 <span class="comment">//   { libmesh_error(); }</span>
<a name="l00145"></a>00145   
<a name="l00146"></a>00146 <span class="comment">//   unsigned int vtk_element_type (const unsigned int) const</span>
<a name="l00147"></a>00147 <span class="comment">//   { return 13; }</span>
<a name="l00148"></a>00148 
<a name="l00154"></a>00154   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a5cbb97ab72795ce77b60c8a50622b488">contains_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol=TOLERANCE) <span class="keyword">const</span>;
<a name="l00155"></a>00155 
<a name="l00160"></a><a class="code" href="classlibMesh_1_1InfPrism6.php#a5d3c6a8ca19266988cd9b20624f9b637">00160</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a5d3c6a8ca19266988cd9b20624f9b637">side_nodes_map</a>[4][4];
<a name="l00161"></a>00161 
<a name="l00166"></a><a class="code" href="classlibMesh_1_1InfPrism6.php#a81908edade3b2b65ff6c1e43de23d742">00166</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a81908edade3b2b65ff6c1e43de23d742">edge_nodes_map</a>[6][2];
<a name="l00167"></a>00167   
<a name="l00168"></a>00168   
<a name="l00169"></a>00169 <span class="keyword">protected</span>:
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   
<a name="l00172"></a>00172 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>  
<a name="l00177"></a><a class="code" href="classlibMesh_1_1InfPrism6.php#a9cb6dd04e24ebfcff8f9981c7d858e2d">00177</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#a9cb6dd04e24ebfcff8f9981c7d858e2d">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00178"></a>00178                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00179"></a>00179                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00180"></a>00180 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#ab8015ee5d8cff9ce02ec5986a9cd1545">_embedding_matrix</a>[i][j][k]; }
<a name="l00181"></a>00181 
<a name="l00186"></a><a class="code" href="classlibMesh_1_1InfPrism6.php#ab8015ee5d8cff9ce02ec5986a9cd1545">00186</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfPrism6.php#ab8015ee5d8cff9ce02ec5986a9cd1545">_embedding_matrix</a>[4][6][6];
<a name="l00187"></a>00187   
<a name="l00188"></a>00188 <span class="preprocessor">#endif</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>  
<a name="l00190"></a>00190 };
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00195"></a>00195 <span class="comment">// InfPrism6 class member functions</span>
<a name="l00196"></a>00196 <span class="keyword">inline</span>
<a name="l00197"></a><a class="code" href="classlibMesh_1_1InfPrism6.php#a0281c1f8cde2c928c1cb0381281a6dab">00197</a> <a class="code" href="classlibMesh_1_1InfPrism6.php#a0281c1f8cde2c928c1cb0381281a6dab">InfPrism6::InfPrism6</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00198"></a>00198   <a class="code" href="classlibMesh_1_1InfPrism.php">InfPrism</a>(<a class="code" href="classlibMesh_1_1InfPrism6.php">InfPrism6</a>::<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>(), p) 
<a name="l00199"></a>00199 {
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 } <span class="comment">// namespace libMesh</span>
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 <span class="preprocessor">#endif  // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span>
<a name="l00207"></a>00207 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
