<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_inf_prism.h</div>  </div>
</div>
<div class="contents">
<a href="cell__inf__prism_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_inf_prism.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_inf_prism_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_inf_prism_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf_8h.php">cell_inf.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// InfPrism class definition</span>
<a name="l00051"></a><a class="code" href="classlibMesh_1_1InfPrism.php">00051</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfPrism.php">InfPrism</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1InfCell.php">InfCell</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00054"></a>00054 
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1InfPrism.php#a3f9dfe37372113cb3c284093ae5bd87e">InfPrism</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="comment">//   /**</span>
<a name="l00062"></a>00062 <span class="comment">//    * @returns 4 for the base \p s=0 and 2 for side faces. </span>
<a name="l00063"></a>00063 <span class="comment">//    */</span>
<a name="l00064"></a>00064 <span class="comment">//   unsigned int n_children_per_side(const unsigned int s) const;</span>
<a name="l00065"></a>00065 
<a name="l00071"></a><a class="code" href="classlibMesh_1_1InfPrism.php#a77fb5e24f82732159115989354fd8cb3">00071</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism.php#a77fb5e24f82732159115989354fd8cb3">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00072"></a>00072 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1InfPrism.php#a5f088f4d331939daddf2d418047e98ea">00077</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism.php#a5f088f4d331939daddf2d418047e98ea">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00078"></a>00078 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1InfPrism.php#a22f8902d3eadcc75b0406c00e3e39dbc">00083</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism.php#a22f8902d3eadcc75b0406c00e3e39dbc">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00084"></a>00084 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1InfPrism.php#a19844ce6dfc5c2bca720fcace88bf8dd">00088</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism.php#a19844ce6dfc5c2bca720fcace88bf8dd">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00089"></a>00089   
<a name="l00093"></a><a class="code" href="classlibMesh_1_1InfPrism.php#a75b7ec1596489aa0d01c3a2fdc4011a9">00093</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism.php#a75b7ec1596489aa0d01c3a2fdc4011a9">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   <span class="comment">/*</span>
<a name="l00096"></a>00096 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00097"></a>00097 <span class="comment">   * specified side</span>
<a name="l00098"></a>00098 <span class="comment">   */</span>
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfPrism.php#aa4517fcb5729088134f6c1eea23c75a7">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00100"></a>00100                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00101"></a>00101   
<a name="l00107"></a>00107   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfPrism.php#abdc95895aca570aa42e58770be12c97d">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00108"></a>00108 
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfPrism.php#ae919d033fc92cb962f25dc6d68d6fa09">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 };
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00120"></a>00120 <span class="comment">// InfPrism class member functions</span>
<a name="l00121"></a>00121 <span class="keyword">inline</span>
<a name="l00122"></a><a class="code" href="classlibMesh_1_1InfPrism.php#a3f9dfe37372113cb3c284093ae5bd87e">00122</a> <a class="code" href="classlibMesh_1_1InfPrism.php#a3f9dfe37372113cb3c284093ae5bd87e">InfPrism::InfPrism</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00123"></a>00123   <a class="code" href="classlibMesh_1_1InfCell.php">InfCell</a>(nn, <a class="code" href="classlibMesh_1_1InfPrism.php">InfPrism</a>::n_sides(), p) 
<a name="l00124"></a>00124 {
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="comment">// inline</span>
<a name="l00129"></a>00129 <span class="comment">// unsigned int InfPrism::n_children_per_side(const unsigned int s) const</span>
<a name="l00130"></a>00130 <span class="comment">// {</span>
<a name="l00131"></a>00131 <span class="comment">//   libmesh_assert (s &lt; this-&gt;n_sides());</span>
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="comment">//   switch (s)</span>
<a name="l00134"></a>00134 <span class="comment">//   {</span>
<a name="l00135"></a>00135 <span class="comment">//     case 0:</span>
<a name="l00136"></a>00136 <span class="comment">//       // every infinite prism has 4 children in the base side</span>
<a name="l00137"></a>00137 <span class="comment">//       return 4;</span>
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="comment">//     default:</span>
<a name="l00140"></a>00140 <span class="comment">//       // on infinite faces (sides), only 2 children exist</span>
<a name="l00141"></a>00141 <span class="comment">//       //</span>
<a name="l00142"></a>00142 <span class="comment">//       // note that the face at infinity is already caught by the libmesh_assertion</span>
<a name="l00143"></a>00143 <span class="comment">//       return 2;</span>
<a name="l00144"></a>00144 <span class="comment">//   }</span>
<a name="l00145"></a>00145 <span class="comment">// }</span>
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 } <span class="comment">// namespace libMesh</span>
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>
<a name="l00152"></a>00152 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
