<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_prism15.C</div>  </div>
</div>
<div class="contents">
<a href="cell__prism15_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_prism15.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism15_8h.php">cell_prism15.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="face__quad8_8h.php">face_quad8.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="face__tri6_8h.php">face_tri6.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// Prism15 class static member initializations</span>
<a name="l00037"></a>00037 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism15.php#a5264c1a5c00878305773a571a9870106">Prism15::side_nodes_map</a>[5][8] =
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   {0, 2, 1,  8,  7,  6, 99, 99}, <span class="comment">// Side 0</span>
<a name="l00040"></a>00040   {0, 1, 4,  3,  6, 10, 12,  9}, <span class="comment">// Side 1</span>
<a name="l00041"></a>00041   {1, 2, 5,  4,  7, 11, 13, 10}, <span class="comment">// Side 2</span>
<a name="l00042"></a>00042   {2, 0, 3,  5,  8,  9, 14, 11}, <span class="comment">// Side 3</span>
<a name="l00043"></a>00043   {3, 4, 5, 12, 13, 14, 99, 99}  <span class="comment">// Side 4</span>
<a name="l00044"></a>00044 };
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism15.php#a75b91b530df4710c285ac24af3685a20">Prism15::edge_nodes_map</a>[9][3] =
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   {0, 1, 6},  <span class="comment">// Side 0</span>
<a name="l00049"></a>00049   {1, 2, 7},  <span class="comment">// Side 1</span>
<a name="l00050"></a>00050   {0, 2, 8},  <span class="comment">// Side 2</span>
<a name="l00051"></a>00051   {0, 3, 9},  <span class="comment">// Side 3</span>
<a name="l00052"></a>00052   {1, 4, 10}, <span class="comment">// Side 4</span>
<a name="l00053"></a>00053   {2, 5, 11}, <span class="comment">// Side 5</span>
<a name="l00054"></a>00054   {3, 4, 12}, <span class="comment">// Side 6</span>
<a name="l00055"></a>00055   {4, 5, 13}, <span class="comment">// Side 7</span>
<a name="l00056"></a>00056   {3, 5, 14}  <span class="comment">// Side 8</span>
<a name="l00057"></a>00057 };
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00061"></a>00061 <span class="comment">// Prism15 class member functions</span>
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1Prism15.php#aa7aa7756ce7979c1311bccb0f2cf4e9d">00063</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism15.php#aa7aa7756ce7979c1311bccb0f2cf4e9d">Prism15::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   <span class="keywordflow">if</span> (i &lt; 6)
<a name="l00066"></a>00066     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1Prism15.php#a0409bd3c81a24eafec99a8a831e7d2df">00070</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism15.php#a0409bd3c81a24eafec99a8a831e7d2df">Prism15::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00071"></a>00071 <span class="keyword"></span>{
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (i &lt; 6)
<a name="l00073"></a>00073     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00074"></a>00074   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1Prism15.php#a5f53bdbfbe593a79db0cfe012cb7e3b6">00077</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism15.php#a5f53bdbfbe593a79db0cfe012cb7e3b6">Prism15::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00078"></a>00078 <span class="keyword"></span>{
<a name="l00079"></a>00079   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1Prism15.php#a52b47cd4c97a14df89e77d84b6c7d642">00082</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism15.php#a52b47cd4c97a14df89e77d84b6c7d642">Prism15::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00083"></a>00083                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00084"></a>00084 <span class="keyword"></span>{
<a name="l00085"></a>00085   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1Prism.php#a075e71558bb7cd912a02ecd12c16d0dc">n_sides</a>());
<a name="l00086"></a>00086   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 8; ++i)
<a name="l00087"></a>00087     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Prism15.php#a5264c1a5c00878305773a571a9870106">side_nodes_map</a>[s][i] == n)
<a name="l00088"></a>00088       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00089"></a>00089   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="classlibMesh_1_1Prism15.php#a71ea934f7dee172bf87200132b72f92f">00092</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism15.php#a71ea934f7dee172bf87200132b72f92f">Prism15::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00093"></a>00093                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00094"></a>00094 <span class="keyword"></span>{
<a name="l00095"></a>00095   libmesh_assert(e &lt; <a class="code" href="classlibMesh_1_1Prism.php#a065c69f09f7b609c7110f00e80ba9651">n_edges</a>());
<a name="l00096"></a>00096   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00097"></a>00097     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Prism15.php#a75b91b530df4710c285ac24af3685a20">edge_nodes_map</a>[e][i] == n)
<a name="l00098"></a>00098       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00099"></a>00099   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00100"></a>00100 }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1Prism15.php#a09749e064b6e3350ceb78db164491f5d">00104</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism15.php#a09749e064b6e3350ceb78db164491f5d">Prism15::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00105"></a>00105 <span class="keyword"></span>{
<a name="l00106"></a>00106   <span class="comment">// Make sure z edges are affine</span>
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1Point.php">Point</a> v = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0);
<a name="l00108"></a>00108   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(4) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)) ||
<a name="l00109"></a>00109       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(5) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00110"></a>00110     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00111"></a>00111   <span class="comment">// Make sure edges are straight</span>
<a name="l00112"></a>00112   v /= 2;
<a name="l00113"></a>00113   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(9) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)) ||
<a name="l00114"></a>00114       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(10) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)) ||
<a name="l00115"></a>00115       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(11) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00116"></a>00116     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00117"></a>00117   v = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))/2;
<a name="l00118"></a>00118   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(6) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)) ||
<a name="l00119"></a>00119       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(12) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00120"></a>00120     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00121"></a>00121   v = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))/2;
<a name="l00122"></a>00122   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(8) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)) ||
<a name="l00123"></a>00123       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(14) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00124"></a>00124     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00125"></a>00125   v = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1))/2;
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(7) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)) ||
<a name="l00127"></a>00127       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(13) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l00128"></a>00128     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00129"></a>00129   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="classlibMesh_1_1Prism15.php#a600f16e38d634bba5a3b4147033a6e54">00134</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Prism15.php#a600f16e38d634bba5a3b4147033a6e54">Prism15::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00135"></a>00135                                    <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00136"></a>00136 <span class="keyword"></span>{
<a name="l00137"></a>00137   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a075e71558bb7cd912a02ecd12c16d0dc">n_sides</a>());
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="keywordflow">if</span> (proxy)
<a name="l00140"></a>00140     {
<a name="l00141"></a>00141       <span class="keywordflow">switch</span> (i)
<a name="l00142"></a>00142         {
<a name="l00143"></a>00143         <span class="keywordflow">case</span> 0:  <span class="comment">// the triangular face at z=-1</span>
<a name="l00144"></a>00144         <span class="keywordflow">case</span> 4:
<a name="l00145"></a>00145           {
<a name="l00146"></a>00146             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Tri6,Prism15&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00147"></a>00147             <span class="keywordflow">return</span> face;
<a name="l00148"></a>00148           }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150         <span class="keywordflow">case</span> 1:
<a name="l00151"></a>00151         <span class="keywordflow">case</span> 2:
<a name="l00152"></a>00152         <span class="keywordflow">case</span> 3:
<a name="l00153"></a>00153           {
<a name="l00154"></a>00154             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Quad8,Prism15&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00155"></a>00155             <span class="keywordflow">return</span> face;
<a name="l00156"></a>00156           }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158         <span class="keywordflow">default</span>:
<a name="l00159"></a>00159           {
<a name="l00160"></a>00160             libmesh_error();
<a name="l00161"></a>00161           }
<a name="l00162"></a>00162         }
<a name="l00163"></a>00163     }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="keywordflow">else</span>
<a name="l00166"></a>00166     {
<a name="l00167"></a>00167       <span class="keywordflow">switch</span> (i)
<a name="l00168"></a>00168         {
<a name="l00169"></a>00169         <span class="keywordflow">case</span> 0:  <span class="comment">// the triangular face at z=-1</span>
<a name="l00170"></a>00170           {
<a name="l00171"></a>00171             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>);
<a name="l00172"></a>00172 
<a name="l00173"></a>00173             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00174"></a>00174             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00175"></a>00175             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00176"></a>00176             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00177"></a>00177             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00178"></a>00178             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180             <span class="keywordflow">return</span> face;
<a name="l00181"></a>00181           }
<a name="l00182"></a>00182         <span class="keywordflow">case</span> 1:  <span class="comment">// the quad face at y=0</span>
<a name="l00183"></a>00183           {
<a name="l00184"></a>00184             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad8.php">Quad8</a>);
<a name="l00185"></a>00185         
<a name="l00186"></a>00186             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00187"></a>00187             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00188"></a>00188             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00189"></a>00189             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00190"></a>00190             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00191"></a>00191             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(10);
<a name="l00192"></a>00192             face-&gt;set_node(6) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(12);
<a name="l00193"></a>00193             face-&gt;set_node(7) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00194"></a>00194         
<a name="l00195"></a>00195             <span class="keywordflow">return</span> face;
<a name="l00196"></a>00196           }
<a name="l00197"></a>00197         <span class="keywordflow">case</span> 2:  <span class="comment">// the other quad face</span>
<a name="l00198"></a>00198           {
<a name="l00199"></a>00199             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad8.php">Quad8</a>);
<a name="l00200"></a>00200 
<a name="l00201"></a>00201             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00202"></a>00202             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00203"></a>00203             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00204"></a>00204             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00205"></a>00205             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00206"></a>00206             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(11);
<a name="l00207"></a>00207             face-&gt;set_node(6) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(13);
<a name="l00208"></a>00208             face-&gt;set_node(7) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(10);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210             <span class="keywordflow">return</span> face;
<a name="l00211"></a>00211           }
<a name="l00212"></a>00212         <span class="keywordflow">case</span> 3: <span class="comment">// the quad face at x=0</span>
<a name="l00213"></a>00213           {
<a name="l00214"></a>00214             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad8.php">Quad8</a>);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00217"></a>00217             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00218"></a>00218             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00219"></a>00219             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00220"></a>00220             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00221"></a>00221             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00222"></a>00222             face-&gt;set_node(6) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(14);
<a name="l00223"></a>00223             face-&gt;set_node(7) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(11);
<a name="l00224"></a>00224         
<a name="l00225"></a>00225             <span class="keywordflow">return</span> face;
<a name="l00226"></a>00226           }
<a name="l00227"></a>00227         <span class="keywordflow">case</span> 4: <span class="comment">// the triangular face at z=1</span>
<a name="l00228"></a>00228           {
<a name="l00229"></a>00229             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>);
<a name="l00230"></a>00230 
<a name="l00231"></a>00231             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00232"></a>00232             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00233"></a>00233             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00234"></a>00234             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(12);
<a name="l00235"></a>00235             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(13);
<a name="l00236"></a>00236             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(14);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238             <span class="keywordflow">return</span> face;
<a name="l00239"></a>00239           }
<a name="l00240"></a>00240         <span class="keywordflow">default</span>:
<a name="l00241"></a>00241           {
<a name="l00242"></a>00242             libmesh_error();
<a name="l00243"></a>00243           }
<a name="l00244"></a>00244         }
<a name="l00245"></a>00245     }
<a name="l00246"></a>00246   
<a name="l00247"></a>00247   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00248"></a>00248   libmesh_error();
<a name="l00249"></a>00249   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00250"></a>00250 }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a><a class="code" href="classlibMesh_1_1Prism15.php#aa481c73b176abffdd05101c791106ca8">00253</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Prism15.php#aa481c73b176abffdd05101c791106ca8">Prism15::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00254"></a>00254 <span class="keyword"></span>{
<a name="l00255"></a>00255   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a065c69f09f7b609c7110f00e80ba9651">n_edges</a>());
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;Edge3,Prism15&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00258"></a>00258 }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a><a class="code" href="classlibMesh_1_1Prism15.php#ae11a26c4d03b103a764605ea256fe11f">00261</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Prism15.php#ae11a26c4d03b103a764605ea256fe11f">Prism15::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00262"></a>00262                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00263"></a>00263                            std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00264"></a>00264 <span class="keyword"></span>{
<a name="l00265"></a>00265   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL);
<a name="l00266"></a>00266   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classlibMesh_1_1Prism15.php#a849e4d918f5ede7d4c54054fb1dcd9eb">n_sub_elem</a>());
<a name="l00267"></a>00267   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="keywordflow">switch</span> (iop)
<a name="l00270"></a>00270     {
<a name="l00271"></a>00271     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00272"></a>00272       {
<a name="l00273"></a>00273         conn.resize(8);
<a name="l00274"></a>00274         conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00275"></a>00275         conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00276"></a>00276         conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00277"></a>00277         conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00278"></a>00278         conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00279"></a>00279         conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00280"></a>00280         conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00281"></a>00281         conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00282"></a>00282         <span class="keywordflow">return</span>;
<a name="l00283"></a>00283       }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00286"></a>00286       {
<a name="l00287"></a>00287         conn.resize(6);
<a name="l00288"></a>00288         conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0);
<a name="l00289"></a>00289         conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2);
<a name="l00290"></a>00290         conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1);
<a name="l00291"></a>00291         conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3);
<a name="l00292"></a>00292         conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5);
<a name="l00293"></a>00293         conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4);
<a name="l00294"></a>00294         <span class="keywordflow">return</span>;
<a name="l00295"></a>00295       }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297     <span class="keywordflow">default</span>:
<a name="l00298"></a>00298       libmesh_error();
<a name="l00299"></a>00299     }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   libmesh_error();
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a><a class="code" href="classlibMesh_1_1Prism15.php#ad5943b36a69d98d3fb69e4049a8f9b76">00308</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism15.php#ad5943b36a69d98d3fb69e4049a8f9b76">Prism15::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00309"></a>00309                                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00310"></a>00310 <span class="keyword"></span>{ 
<a name="l00311"></a>00311   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a5a8ea1fa1b486aae23effc0d5ec052ca">n_vertices</a>());
<a name="l00312"></a>00312   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classlibMesh_1_1Prism15.php#ab4005c9791b0e0bc731e649673b4ca09">n_nodes</a>());
<a name="l00313"></a>00313   libmesh_assert (v &lt; 2);
<a name="l00314"></a>00314   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Prism.php#aebf9f0ec1379218836e7cecd28cc0e1c">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a5a8ea1fa1b486aae23effc0d5ec052ca">n_vertices</a>()][v]; 
<a name="l00315"></a>00315 }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00320"></a><a class="code" href="classlibMesh_1_1Prism15.php#ab2c07ee15f729e9f41e2dcb92ee344b5">00320</a> <a class="code" href="classlibMesh_1_1Prism15.php#ab2c07ee15f729e9f41e2dcb92ee344b5">Prism15::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00321"></a>00321 <span class="keyword"></span>{
<a name="l00322"></a>00322   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a5a8ea1fa1b486aae23effc0d5ec052ca">n_vertices</a>());
<a name="l00323"></a>00323   libmesh_assert (n &lt; this-&gt;<a class="code" href="classlibMesh_1_1Prism15.php#ab4005c9791b0e0bc731e649673b4ca09">n_nodes</a>());
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00326"></a>00326     (<a class="code" href="classlibMesh_1_1Prism.php#a7268c3d4d75a8356ce4bd69831e2a050">_second_order_vertex_child_number</a>[n],
<a name="l00327"></a>00327      <a class="code" href="classlibMesh_1_1Prism.php#af24e406976c619cce58d82c589a0357e">_second_order_vertex_child_index</a>[n]);
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 } <span class="comment">// namespace libMesh</span>
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
