<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_prism18.C</div>  </div>
</div>
<div class="contents">
<a href="cell__prism18_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_prism18.C 4242 2011-03-10 19:36:28Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="cell__prism18_8h.php">cell_prism18.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="face__quad9_8h.php">face_quad9.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="face__tri6_8h.php">face_tri6.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// Prism18 class static member initializations</span>
<a name="l00037"></a>00037 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism18.php#a224c3f0c4365aefea74ccf17e9c49604">Prism18::side_nodes_map</a>[5][9] =
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039   {0, 2, 1,  8,  7,  6, 99, 99, 99}, <span class="comment">// Side 0</span>
<a name="l00040"></a>00040   {0, 1, 4,  3,  6, 10, 12,  9, 15}, <span class="comment">// Side 1</span>
<a name="l00041"></a>00041   {1, 2, 5,  4,  7, 11, 13, 10, 16}, <span class="comment">// Side 2</span>
<a name="l00042"></a>00042   {2, 0, 3,  5,  8,  9, 14, 11, 17}, <span class="comment">// Side 3</span>
<a name="l00043"></a>00043   {3, 4, 5, 12, 13, 14, 99, 99, 99}  <span class="comment">// Side 4</span>
<a name="l00044"></a>00044 };
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism18.php#a7f056c14fd31013f88091071816f7b7e">Prism18::edge_nodes_map</a>[9][3] =
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   {0, 1, 6},  <span class="comment">// Side 0</span>
<a name="l00049"></a>00049   {1, 2, 7},  <span class="comment">// Side 1</span>
<a name="l00050"></a>00050   {0, 2, 8},  <span class="comment">// Side 2</span>
<a name="l00051"></a>00051   {0, 3, 9},  <span class="comment">// Side 3</span>
<a name="l00052"></a>00052   {1, 4, 10}, <span class="comment">// Side 4</span>
<a name="l00053"></a>00053   {2, 5, 11}, <span class="comment">// Side 5</span>
<a name="l00054"></a>00054   {3, 4, 12}, <span class="comment">// Side 6</span>
<a name="l00055"></a>00055   {4, 5, 13}, <span class="comment">// Side 7</span>
<a name="l00056"></a>00056   {3, 5, 14}  <span class="comment">// Side 8</span>
<a name="l00057"></a>00057 };
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00061"></a>00061 <span class="comment">// Prism18 class member functions</span>
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1Prism18.php#a45ed2a00edcfcf03173755c92b950141">00063</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism18.php#a45ed2a00edcfcf03173755c92b950141">Prism18::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   <span class="keywordflow">if</span> (i &lt; 6)
<a name="l00066"></a>00066     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1Prism18.php#a5c19c3675356a9f60c894b9552e7f2d1">00070</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism18.php#a5c19c3675356a9f60c894b9552e7f2d1">Prism18::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00071"></a>00071 <span class="keyword"></span>{
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (i &lt; 6)
<a name="l00073"></a>00073     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (i &gt; 14)
<a name="l00075"></a>00075     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00076"></a>00076   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1Prism18.php#ac0f0e13f52dcc1172c1d44d95d502c54">00079</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism18.php#ac0f0e13f52dcc1172c1d44d95d502c54">Prism18::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword"></span>{
<a name="l00081"></a>00081   <span class="keywordflow">if</span> (i &gt; 14)
<a name="l00082"></a>00082     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00083"></a>00083   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1Prism18.php#a07396575f032857706d449fe035a96c3">00086</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism18.php#a07396575f032857706d449fe035a96c3">Prism18::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00087"></a>00087                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword"></span>{
<a name="l00089"></a>00089   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1Prism.php#a075e71558bb7cd912a02ecd12c16d0dc">n_sides</a>());
<a name="l00090"></a>00090   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 9; ++i)
<a name="l00091"></a>00091     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Prism18.php#a224c3f0c4365aefea74ccf17e9c49604">side_nodes_map</a>[s][i] == n)
<a name="l00092"></a>00092       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00093"></a>00093   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classlibMesh_1_1Prism18.php#a066b342eb7622ff470b1a3183bc85b1d">00096</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism18.php#a066b342eb7622ff470b1a3183bc85b1d">Prism18::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00097"></a>00097                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword"></span>{
<a name="l00099"></a>00099   libmesh_assert(e &lt; <a class="code" href="classlibMesh_1_1Prism.php#a065c69f09f7b609c7110f00e80ba9651">n_edges</a>());
<a name="l00100"></a>00100   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00101"></a>00101     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Prism18.php#a7f056c14fd31013f88091071816f7b7e">edge_nodes_map</a>[e][i] == n)
<a name="l00102"></a>00102       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00103"></a>00103   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1Prism18.php#a78c4ea138c3f0c01fff53a74f574da1d">00108</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism18.php#a78c4ea138c3f0c01fff53a74f574da1d">Prism18::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00109"></a>00109 <span class="keyword"></span>{
<a name="l00110"></a>00110   <span class="comment">// Make sure z edges are affine</span>
<a name="l00111"></a>00111   <a class="code" href="classlibMesh_1_1Point.php">Point</a> v = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0);
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(4) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)) ||
<a name="l00113"></a>00113       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(5) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)))
<a name="l00114"></a>00114     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00115"></a>00115   <span class="comment">// Make sure edges are straight</span>
<a name="l00116"></a>00116   v /= 2;
<a name="l00117"></a>00117   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(9) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)) ||
<a name="l00118"></a>00118       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(10) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)) ||
<a name="l00119"></a>00119       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(11) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)) ||
<a name="l00120"></a>00120       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(15) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6)) ||
<a name="l00121"></a>00121       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(16) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7)) ||
<a name="l00122"></a>00122       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(17) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(8)))
<a name="l00123"></a>00123     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00124"></a>00124   v = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))/2;
<a name="l00125"></a>00125   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(6) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)) ||
<a name="l00126"></a>00126       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(12) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00127"></a>00127     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00128"></a>00128   v = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))/2;
<a name="l00129"></a>00129   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(8) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)) ||
<a name="l00130"></a>00130       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(14) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00131"></a>00131     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00132"></a>00132   v = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1))/2;
<a name="l00133"></a>00133   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(7) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)) ||
<a name="l00134"></a>00134       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(13) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l00135"></a>00135     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00136"></a>00136   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00137"></a>00137 }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a><a class="code" href="classlibMesh_1_1Prism18.php#a4b78ee731b2a3d322c5175fc750253ea">00141</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism18.php#a4b78ee731b2a3d322c5175fc750253ea">Prism18::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00142"></a>00142 <span class="keyword"></span>{
<a name="l00143"></a>00143   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a075e71558bb7cd912a02ecd12c16d0dc">n_sides</a>());
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="keywordflow">switch</span> (s)
<a name="l00146"></a>00146     {
<a name="l00147"></a>00147     <span class="keywordflow">case</span> 0:  <span class="comment">// the triangular face at z=0</span>
<a name="l00148"></a>00148       {
<a name="l00149"></a>00149         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Prism18.php#a4b78ee731b2a3d322c5175fc750253ea">Prism::key</a>(0);
<a name="l00150"></a>00150       }
<a name="l00151"></a>00151     <span class="keywordflow">case</span> 1:  <span class="comment">// the quad face at y=0</span>
<a name="l00152"></a>00152       {
<a name="l00153"></a>00153         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">Elem::compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15));
<a name="l00154"></a>00154       }
<a name="l00155"></a>00155     <span class="keywordflow">case</span> 2:  <span class="comment">// the other quad face</span>
<a name="l00156"></a>00156       {
<a name="l00157"></a>00157         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">Elem::compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16));
<a name="l00158"></a>00158       }
<a name="l00159"></a>00159     <span class="keywordflow">case</span> 3: <span class="comment">// the quad face at x=0</span>
<a name="l00160"></a>00160       {
<a name="l00161"></a>00161         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">Elem::compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17));
<a name="l00162"></a>00162       }
<a name="l00163"></a>00163     <span class="keywordflow">case</span> 4: <span class="comment">// the triangular face at z=1</span>
<a name="l00164"></a>00164       {
<a name="l00165"></a>00165         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Prism18.php#a4b78ee731b2a3d322c5175fc750253ea">Prism::key</a>(4);
<a name="l00166"></a>00166       }
<a name="l00167"></a>00167     }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00170"></a>00170   libmesh_error();
<a name="l00171"></a>00171   <span class="keywordflow">return</span> 0;
<a name="l00172"></a>00172 }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1Prism18.php#ac6c7bc0bc28cec1494778658dbf481cb">00178</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Prism18.php#ac6c7bc0bc28cec1494778658dbf481cb">Prism18::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00179"></a>00179                                    <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00180"></a>00180 <span class="keyword"></span>{
<a name="l00181"></a>00181   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a075e71558bb7cd912a02ecd12c16d0dc">n_sides</a>());
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="keywordflow">if</span> (proxy)
<a name="l00184"></a>00184     {
<a name="l00185"></a>00185       <span class="keywordflow">switch</span>(i)
<a name="l00186"></a>00186         {
<a name="l00187"></a>00187         <span class="keywordflow">case</span> 0:
<a name="l00188"></a>00188         <span class="keywordflow">case</span> 4:
<a name="l00189"></a>00189           {
<a name="l00190"></a>00190             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Tri6,Prism18&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00191"></a>00191             <span class="keywordflow">return</span> face;
<a name="l00192"></a>00192           }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194         <span class="keywordflow">case</span> 1:
<a name="l00195"></a>00195         <span class="keywordflow">case</span> 2:
<a name="l00196"></a>00196         <span class="keywordflow">case</span> 3:
<a name="l00197"></a>00197           {
<a name="l00198"></a>00198             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Quad9,Prism18&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00199"></a>00199             <span class="keywordflow">return</span> face;
<a name="l00200"></a>00200           }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202         <span class="keywordflow">default</span>:
<a name="l00203"></a>00203           {
<a name="l00204"></a>00204             libmesh_error();
<a name="l00205"></a>00205           }
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207     }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   <span class="keywordflow">else</span>
<a name="l00210"></a>00210     {
<a name="l00211"></a>00211       <span class="keywordflow">switch</span> (i)
<a name="l00212"></a>00212         {
<a name="l00213"></a>00213         <span class="keywordflow">case</span> 0:  <span class="comment">// the triangular face at z=-1</span>
<a name="l00214"></a>00214           {
<a name="l00215"></a>00215             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00218"></a>00218             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00219"></a>00219             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00220"></a>00220             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00221"></a>00221             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00222"></a>00222             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224             <span class="keywordflow">return</span> face;
<a name="l00225"></a>00225           }
<a name="l00226"></a>00226         <span class="keywordflow">case</span> 1:  <span class="comment">// the quad face at y=0</span>
<a name="l00227"></a>00227           {
<a name="l00228"></a>00228             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad9.php">Quad9</a>);
<a name="l00229"></a>00229         
<a name="l00230"></a>00230             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00231"></a>00231             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00232"></a>00232             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00233"></a>00233             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00234"></a>00234             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00235"></a>00235             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(10);
<a name="l00236"></a>00236             face-&gt;set_node(6) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(12);
<a name="l00237"></a>00237             face-&gt;set_node(7) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00238"></a>00238             face-&gt;set_node(8) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(15);
<a name="l00239"></a>00239         
<a name="l00240"></a>00240             <span class="keywordflow">return</span> face;
<a name="l00241"></a>00241           }
<a name="l00242"></a>00242         <span class="keywordflow">case</span> 2:  <span class="comment">// the other quad face</span>
<a name="l00243"></a>00243           {
<a name="l00244"></a>00244             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad9.php">Quad9</a>);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00247"></a>00247             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00248"></a>00248             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00249"></a>00249             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00250"></a>00250             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00251"></a>00251             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(11);
<a name="l00252"></a>00252             face-&gt;set_node(6) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(13);
<a name="l00253"></a>00253             face-&gt;set_node(7) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(10);
<a name="l00254"></a>00254             face-&gt;set_node(8) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(16);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256             <span class="keywordflow">return</span> face;
<a name="l00257"></a>00257           }
<a name="l00258"></a>00258         <span class="keywordflow">case</span> 3: <span class="comment">// the quad face at x=0</span>
<a name="l00259"></a>00259           {
<a name="l00260"></a>00260             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Quad9.php">Quad9</a>);
<a name="l00261"></a>00261 
<a name="l00262"></a>00262             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00263"></a>00263             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00264"></a>00264             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00265"></a>00265             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00266"></a>00266             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00267"></a>00267             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00268"></a>00268             face-&gt;set_node(6) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(14);
<a name="l00269"></a>00269             face-&gt;set_node(7) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(11);
<a name="l00270"></a>00270             face-&gt;set_node(8) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(17);
<a name="l00271"></a>00271         
<a name="l00272"></a>00272             <span class="keywordflow">return</span> face;
<a name="l00273"></a>00273           }
<a name="l00274"></a>00274         <span class="keywordflow">case</span> 4: <span class="comment">// the triangular face at z=1</span>
<a name="l00275"></a>00275           {
<a name="l00276"></a>00276             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00279"></a>00279             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00280"></a>00280             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00281"></a>00281             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(12);
<a name="l00282"></a>00282             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(13);
<a name="l00283"></a>00283             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(14);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285             <span class="keywordflow">return</span> face;
<a name="l00286"></a>00286           }
<a name="l00287"></a>00287         <span class="keywordflow">default</span>:
<a name="l00288"></a>00288           {
<a name="l00289"></a>00289             libmesh_error();
<a name="l00290"></a>00290           }
<a name="l00291"></a>00291         }
<a name="l00292"></a>00292     }
<a name="l00293"></a>00293   
<a name="l00294"></a>00294   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00295"></a>00295   libmesh_error();
<a name="l00296"></a>00296   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00297"></a>00297 }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 
<a name="l00301"></a><a class="code" href="classlibMesh_1_1Prism18.php#ad769d33029590001d79e14a8852c80b5">00301</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Prism18.php#ad769d33029590001d79e14a8852c80b5">Prism18::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00302"></a>00302 <span class="keyword"></span>{
<a name="l00303"></a>00303   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a065c69f09f7b609c7110f00e80ba9651">n_edges</a>());
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;Edge3,Prism18&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00306"></a>00306 }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a><a class="code" href="classlibMesh_1_1Prism18.php#ab42ed67279abe33258261d64fe907ad7">00310</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Prism18.php#ab42ed67279abe33258261d64fe907ad7">Prism18::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00311"></a>00311                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00312"></a>00312                            std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00313"></a>00313 <span class="keyword"></span>{
<a name="l00314"></a>00314   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL);
<a name="l00315"></a>00315   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classlibMesh_1_1Prism18.php#ac4f6b6d8227b91c1d0308090df91f2e5">n_sub_elem</a>());
<a name="l00316"></a>00316   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00317"></a>00317 
<a name="l00318"></a>00318     <span class="keywordflow">switch</span> (iop)
<a name="l00319"></a>00319     {
<a name="l00320"></a>00320     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00321"></a>00321       {
<a name="l00322"></a>00322         conn.resize(8);
<a name="l00323"></a>00323         <span class="keywordflow">switch</span> (sc)
<a name="l00324"></a>00324           {
<a name="l00325"></a>00325       
<a name="l00326"></a>00326           <span class="keywordflow">case</span> 0:
<a name="l00327"></a>00327             {
<a name="l00328"></a>00328               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00329"></a>00329               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00330"></a>00330               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00331"></a>00331               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00332"></a>00332               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00333"></a>00333               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15)+1;
<a name="l00334"></a>00334               conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00335"></a>00335               conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00336"></a>00336         
<a name="l00337"></a>00337               <span class="keywordflow">return</span>;
<a name="l00338"></a>00338             }
<a name="l00339"></a>00339 
<a name="l00340"></a>00340           <span class="keywordflow">case</span> 1:
<a name="l00341"></a>00341             {
<a name="l00342"></a>00342               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00343"></a>00343               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00344"></a>00344               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00345"></a>00345               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00346"></a>00346               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15)+1;
<a name="l00347"></a>00347               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10)+1;
<a name="l00348"></a>00348               conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00349"></a>00349               conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00350"></a>00350         
<a name="l00351"></a>00351               <span class="keywordflow">return</span>;
<a name="l00352"></a>00352             }
<a name="l00353"></a>00353       
<a name="l00354"></a>00354           <span class="keywordflow">case</span> 2:
<a name="l00355"></a>00355             {
<a name="l00356"></a>00356               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00357"></a>00357               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00358"></a>00358               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00359"></a>00359               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00360"></a>00360               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00361"></a>00361               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00362"></a>00362               conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00363"></a>00363               conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00364"></a>00364         
<a name="l00365"></a>00365               <span class="keywordflow">return</span>;
<a name="l00366"></a>00366             }
<a name="l00367"></a>00367       
<a name="l00368"></a>00368           <span class="keywordflow">case</span> 3:
<a name="l00369"></a>00369             {
<a name="l00370"></a>00370               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00371"></a>00371               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00372"></a>00372               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00373"></a>00373               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00374"></a>00374               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15)+1;
<a name="l00375"></a>00375               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00376"></a>00376               conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00377"></a>00377               conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00378"></a>00378         
<a name="l00379"></a>00379               <span class="keywordflow">return</span>;
<a name="l00380"></a>00380             }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382           <span class="keywordflow">case</span> 4:
<a name="l00383"></a>00383             {
<a name="l00384"></a>00384               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00385"></a>00385               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15)+1;
<a name="l00386"></a>00386               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00387"></a>00387               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00388"></a>00388               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00389"></a>00389               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(12)+1;
<a name="l00390"></a>00390               conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14)+1;
<a name="l00391"></a>00391               conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14)+1;
<a name="l00392"></a>00392         
<a name="l00393"></a>00393               <span class="keywordflow">return</span>;
<a name="l00394"></a>00394             }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396           <span class="keywordflow">case</span> 5:
<a name="l00397"></a>00397             {
<a name="l00398"></a>00398               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15)+1;
<a name="l00399"></a>00399               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10)+1;
<a name="l00400"></a>00400               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00401"></a>00401               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00402"></a>00402               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(12)+1;
<a name="l00403"></a>00403               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00404"></a>00404               conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(13)+1;
<a name="l00405"></a>00405               conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(13)+1;
<a name="l00406"></a>00406         
<a name="l00407"></a>00407               <span class="keywordflow">return</span>;
<a name="l00408"></a>00408             }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410           <span class="keywordflow">case</span> 6:
<a name="l00411"></a>00411             {
<a name="l00412"></a>00412               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00413"></a>00413               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00414"></a>00414               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00415"></a>00415               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11)+1;
<a name="l00416"></a>00416               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14)+1;
<a name="l00417"></a>00417               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(13)+1;
<a name="l00418"></a>00418               conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00419"></a>00419               conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00420"></a>00420         
<a name="l00421"></a>00421               <span class="keywordflow">return</span>;
<a name="l00422"></a>00422             }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424           <span class="keywordflow">case</span> 7:
<a name="l00425"></a>00425             {
<a name="l00426"></a>00426               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15)+1;
<a name="l00427"></a>00427               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16)+1;
<a name="l00428"></a>00428               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00429"></a>00429               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17)+1;
<a name="l00430"></a>00430               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(12)+1;
<a name="l00431"></a>00431               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(13)+1;
<a name="l00432"></a>00432               conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14)+1;
<a name="l00433"></a>00433               conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14)+1;
<a name="l00434"></a>00434         
<a name="l00435"></a>00435               <span class="keywordflow">return</span>;
<a name="l00436"></a>00436             }
<a name="l00437"></a>00437 
<a name="l00438"></a>00438           <span class="keywordflow">default</span>:
<a name="l00439"></a>00439             libmesh_error();
<a name="l00440"></a>00440           }
<a name="l00441"></a>00441 
<a name="l00442"></a>00442       }
<a name="l00443"></a>00443 
<a name="l00444"></a>00444     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00445"></a>00445       {
<a name="l00446"></a>00446         conn.resize(6);
<a name="l00447"></a>00447         <span class="keywordflow">switch</span> (sc)
<a name="l00448"></a>00448           {
<a name="l00449"></a>00449       
<a name="l00450"></a>00450           <span class="keywordflow">case</span> 0:
<a name="l00451"></a>00451             {
<a name="l00452"></a>00452               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0);
<a name="l00453"></a>00453               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6);
<a name="l00454"></a>00454               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8);
<a name="l00455"></a>00455               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9);
<a name="l00456"></a>00456               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15);
<a name="l00457"></a>00457               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17);
<a name="l00458"></a>00458         
<a name="l00459"></a>00459               <span class="keywordflow">return</span>;
<a name="l00460"></a>00460             }
<a name="l00461"></a>00461 
<a name="l00462"></a>00462           <span class="keywordflow">case</span> 1:
<a name="l00463"></a>00463             {
<a name="l00464"></a>00464               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6);
<a name="l00465"></a>00465               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1);
<a name="l00466"></a>00466               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7);
<a name="l00467"></a>00467               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15);
<a name="l00468"></a>00468               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10);
<a name="l00469"></a>00469               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16);
<a name="l00470"></a>00470         
<a name="l00471"></a>00471               <span class="keywordflow">return</span>;
<a name="l00472"></a>00472             }
<a name="l00473"></a>00473       
<a name="l00474"></a>00474           <span class="keywordflow">case</span> 2:
<a name="l00475"></a>00475             {
<a name="l00476"></a>00476               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8);
<a name="l00477"></a>00477               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7);
<a name="l00478"></a>00478               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2);
<a name="l00479"></a>00479               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17);
<a name="l00480"></a>00480               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16);
<a name="l00481"></a>00481               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11);
<a name="l00482"></a>00482         
<a name="l00483"></a>00483               <span class="keywordflow">return</span>;
<a name="l00484"></a>00484             }
<a name="l00485"></a>00485       
<a name="l00486"></a>00486           <span class="keywordflow">case</span> 3:
<a name="l00487"></a>00487             {
<a name="l00488"></a>00488               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6);
<a name="l00489"></a>00489               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7);
<a name="l00490"></a>00490               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8);
<a name="l00491"></a>00491               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15);
<a name="l00492"></a>00492               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16);
<a name="l00493"></a>00493               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17);
<a name="l00494"></a>00494         
<a name="l00495"></a>00495               <span class="keywordflow">return</span>;
<a name="l00496"></a>00496             }
<a name="l00497"></a>00497 
<a name="l00498"></a>00498           <span class="keywordflow">case</span> 4:
<a name="l00499"></a>00499             {
<a name="l00500"></a>00500               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9);
<a name="l00501"></a>00501               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15);
<a name="l00502"></a>00502               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17);
<a name="l00503"></a>00503               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3);
<a name="l00504"></a>00504               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(12);
<a name="l00505"></a>00505               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14);
<a name="l00506"></a>00506         
<a name="l00507"></a>00507               <span class="keywordflow">return</span>;
<a name="l00508"></a>00508             }
<a name="l00509"></a>00509 
<a name="l00510"></a>00510           <span class="keywordflow">case</span> 5:
<a name="l00511"></a>00511             {
<a name="l00512"></a>00512               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15);
<a name="l00513"></a>00513               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(10);
<a name="l00514"></a>00514               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16);
<a name="l00515"></a>00515               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(12);
<a name="l00516"></a>00516               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4);
<a name="l00517"></a>00517               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(13);
<a name="l00518"></a>00518         
<a name="l00519"></a>00519               <span class="keywordflow">return</span>;
<a name="l00520"></a>00520             }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522           <span class="keywordflow">case</span> 6:
<a name="l00523"></a>00523             {
<a name="l00524"></a>00524               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17);
<a name="l00525"></a>00525               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16);
<a name="l00526"></a>00526               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(11);
<a name="l00527"></a>00527               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14);
<a name="l00528"></a>00528               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(13);
<a name="l00529"></a>00529               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5);
<a name="l00530"></a>00530         
<a name="l00531"></a>00531               <span class="keywordflow">return</span>;
<a name="l00532"></a>00532             }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534           <span class="keywordflow">case</span> 7:
<a name="l00535"></a>00535             {
<a name="l00536"></a>00536               conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(15);
<a name="l00537"></a>00537               conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(16);
<a name="l00538"></a>00538               conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(17);
<a name="l00539"></a>00539               conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(12);
<a name="l00540"></a>00540               conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(13);
<a name="l00541"></a>00541               conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(14);
<a name="l00542"></a>00542         
<a name="l00543"></a>00543               <span class="keywordflow">return</span>;
<a name="l00544"></a>00544             }
<a name="l00545"></a>00545 
<a name="l00546"></a>00546           <span class="keywordflow">default</span>:
<a name="l00547"></a>00547             libmesh_error();
<a name="l00548"></a>00548           }
<a name="l00549"></a>00549 
<a name="l00550"></a>00550       }
<a name="l00551"></a>00551 
<a name="l00552"></a>00552     <span class="keywordflow">default</span>:
<a name="l00553"></a>00553       libmesh_error();
<a name="l00554"></a>00554     }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556   libmesh_error();
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 }
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 
<a name="l00563"></a><a class="code" href="classlibMesh_1_1Prism18.php#a4db9732e57335fadd94b53e005ef416b">00563</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism18.php#a4db9732e57335fadd94b53e005ef416b">Prism18::n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00564"></a>00564 <span class="keyword"></span>{
<a name="l00565"></a>00565   <span class="keywordflow">switch</span> (n)
<a name="l00566"></a>00566     {
<a name="l00567"></a>00567       <span class="keywordflow">case</span> 6:
<a name="l00568"></a>00568       <span class="keywordflow">case</span> 7:
<a name="l00569"></a>00569       <span class="keywordflow">case</span> 8:
<a name="l00570"></a>00570       <span class="keywordflow">case</span> 9:
<a name="l00571"></a>00571       <span class="keywordflow">case</span> 10:
<a name="l00572"></a>00572       <span class="keywordflow">case</span> 11:
<a name="l00573"></a>00573       <span class="keywordflow">case</span> 12:
<a name="l00574"></a>00574       <span class="keywordflow">case</span> 13:
<a name="l00575"></a>00575       <span class="keywordflow">case</span> 14:
<a name="l00576"></a>00576         <span class="keywordflow">return</span> 2;
<a name="l00577"></a>00577 
<a name="l00578"></a>00578       <span class="keywordflow">case</span> 15:
<a name="l00579"></a>00579       <span class="keywordflow">case</span> 16:
<a name="l00580"></a>00580       <span class="keywordflow">case</span> 17:
<a name="l00581"></a>00581         <span class="keywordflow">return</span> 4;
<a name="l00582"></a>00582 
<a name="l00583"></a>00583       <span class="keywordflow">default</span>:
<a name="l00584"></a>00584         libmesh_error();
<a name="l00585"></a>00585     }
<a name="l00586"></a>00586   libmesh_error();
<a name="l00587"></a>00587   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(-1);
<a name="l00588"></a>00588 }
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 
<a name="l00594"></a><a class="code" href="classlibMesh_1_1Prism18.php#a610030db06fd22502800a9dcfcbc97cf">00594</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism18.php#a610030db06fd22502800a9dcfcbc97cf">Prism18::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00595"></a>00595                                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00596"></a>00596 <span class="keyword"></span>{ 
<a name="l00597"></a>00597   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a5a8ea1fa1b486aae23effc0d5ec052ca">n_vertices</a>());
<a name="l00598"></a>00598   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classlibMesh_1_1Prism18.php#aa0a1fd2d9fce48b20b51cc75387f10e4">n_nodes</a>());
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   <span class="keywordflow">switch</span> (n)
<a name="l00601"></a>00601     {
<a name="l00602"></a>00602       <span class="comment">/*</span>
<a name="l00603"></a>00603 <span class="comment">       * These nodes are unique to \p Prism18,</span>
<a name="l00604"></a>00604 <span class="comment">       * let our _remaining_... matrix handle</span>
<a name="l00605"></a>00605 <span class="comment">       * this.</span>
<a name="l00606"></a>00606 <span class="comment">       */</span>
<a name="l00607"></a>00607       <span class="keywordflow">case</span> 15:
<a name="l00608"></a>00608       <span class="keywordflow">case</span> 16:
<a name="l00609"></a>00609       <span class="keywordflow">case</span> 17:
<a name="l00610"></a>00610       {
<a name="l00611"></a>00611         libmesh_assert (v &lt; 4);
<a name="l00612"></a>00612         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Prism18.php#a04dc0bb98a27b00d5a1cd26467b168d9">_remaining_second_order_adjacent_vertices</a>[n-15][v]; 
<a name="l00613"></a>00613       }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615       <span class="comment">/*</span>
<a name="l00616"></a>00616 <span class="comment">       * All other second-order nodes (6,...,14) are</span>
<a name="l00617"></a>00617 <span class="comment">       * identical with Prism15 and are therefore</span>
<a name="l00618"></a>00618 <span class="comment">       * delegated to the _second_order matrix of</span>
<a name="l00619"></a>00619 <span class="comment">       * \p Prism</span>
<a name="l00620"></a>00620 <span class="comment">       */</span>
<a name="l00621"></a>00621       <span class="keywordflow">default</span>:
<a name="l00622"></a>00622       {
<a name="l00623"></a>00623         libmesh_assert (v &lt; 2);
<a name="l00624"></a>00624         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Prism.php#aebf9f0ec1379218836e7cecd28cc0e1c">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a5a8ea1fa1b486aae23effc0d5ec052ca">n_vertices</a>()][v]; 
<a name="l00625"></a>00625       }
<a name="l00626"></a>00626 
<a name="l00627"></a>00627     }
<a name="l00628"></a>00628 
<a name="l00629"></a>00629   libmesh_error();
<a name="l00630"></a>00630   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(-1);
<a name="l00631"></a>00631 }
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism18.php#a04dc0bb98a27b00d5a1cd26467b168d9">Prism18::_remaining_second_order_adjacent_vertices</a>[3][4] = 
<a name="l00636"></a>00636 {
<a name="l00637"></a>00637   { 0,  1,  3,  4}, <span class="comment">// vertices adjacent to node 15</span>
<a name="l00638"></a>00638   { 1,  2,  4,  5}, <span class="comment">// vertices adjacent to node 16</span>
<a name="l00639"></a>00639   { 0,  2,  3,  5}  <span class="comment">// vertices adjacent to node 17</span>
<a name="l00640"></a>00640 };
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00645"></a><a class="code" href="classlibMesh_1_1Prism18.php#a7326188aa5abec67e7668c0f300f8169">00645</a> <a class="code" href="classlibMesh_1_1Prism18.php#a7326188aa5abec67e7668c0f300f8169">Prism18::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00646"></a>00646 <span class="keyword"></span>{
<a name="l00647"></a>00647   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Prism.php#a5a8ea1fa1b486aae23effc0d5ec052ca">n_vertices</a>());
<a name="l00648"></a>00648   libmesh_assert (n &lt; this-&gt;<a class="code" href="classlibMesh_1_1Prism18.php#aa0a1fd2d9fce48b20b51cc75387f10e4">n_nodes</a>());
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00651"></a>00651     (<a class="code" href="classlibMesh_1_1Prism.php#a7268c3d4d75a8356ce4bd69831e2a050">_second_order_vertex_child_number</a>[n],
<a name="l00652"></a>00652      <a class="code" href="classlibMesh_1_1Prism.php#af24e406976c619cce58d82c589a0357e">_second_order_vertex_child_index</a>[n]);
<a name="l00653"></a>00653 }
<a name="l00654"></a>00654 
<a name="l00655"></a>00655 
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00662"></a>00662 <span class="preprocessor"></span>
<a name="l00663"></a>00663 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Prism18.php#aeec72a63f0afc27de9371f4f9a323f98">Prism18::_embedding_matrix</a>[8][18][18] =
<a name="l00664"></a>00664 {
<a name="l00665"></a>00665   <span class="comment">// embedding matrix for child 0</span>
<a name="l00666"></a>00666   {
<a name="l00667"></a>00667     <span class="comment">//       0         1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17</span>
<a name="l00668"></a>00668     {       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 0</span>
<a name="l00669"></a>00669     {       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 1</span>
<a name="l00670"></a>00670     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 2</span>
<a name="l00671"></a>00671     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 3</span>
<a name="l00672"></a>00672     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.}, <span class="comment">// 4</span>
<a name="l00673"></a>00673     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.}, <span class="comment">// 5</span>
<a name="l00674"></a>00674     {    0.375,   -0.125,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 6</span>
<a name="l00675"></a>00675     {       0.,   -0.125,   -0.125,       0.,       0.,       0.,      0.5,     0.25,      0.5,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 7</span>
<a name="l00676"></a>00676     {    0.375,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 8</span>
<a name="l00677"></a>00677     {    0.375,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 9</span>
<a name="l00678"></a>00678     {       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 10</span>
<a name="l00679"></a>00679     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,     0.75}, <span class="comment">// 11</span>
<a name="l00680"></a>00680     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,   -0.125,       0.,       0.,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 12</span>
<a name="l00681"></a>00681     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,      0.5,     0.25,      0.5}, <span class="comment">// 13</span>
<a name="l00682"></a>00682     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,     0.75}, <span class="comment">// 14</span>
<a name="l00683"></a>00683     { 0.140625,-0.046875,       0.,-0.046875, 0.015625,       0.,  0.28125,       0.,       0.,  0.28125, -0.09375,       0., -0.09375,       0.,       0.,   0.5625,       0.,       0.}, <span class="comment">// 15</span>
<a name="l00684"></a>00684     {       0.,-0.046875,-0.046875,       0., 0.015625, 0.015625,   0.1875,  0.09375,   0.1875,       0., -0.09375, -0.09375,  -0.0625, -0.03125,  -0.0625,    0.375,   0.1875,    0.375}, <span class="comment">// 16</span>
<a name="l00685"></a>00685     { 0.140625,       0.,-0.046875,-0.046875,       0., 0.015625,       0.,       0.,  0.28125,  0.28125,       0., -0.09375,       0.,       0., -0.09375,       0.,       0.,   0.5625}  <span class="comment">// 17</span>
<a name="l00686"></a>00686   },
<a name="l00687"></a>00687 
<a name="l00688"></a>00688   <span class="comment">// embedding matrix for child 1</span>
<a name="l00689"></a>00689   {
<a name="l00690"></a>00690     <span class="comment">//       0         1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17</span>
<a name="l00691"></a>00691     {       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 0</span>
<a name="l00692"></a>00692     {       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 1</span>
<a name="l00693"></a>00693     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 2</span>
<a name="l00694"></a>00694     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.}, <span class="comment">// 3</span>
<a name="l00695"></a>00695     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 4</span>
<a name="l00696"></a>00696     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.}, <span class="comment">// 5</span>
<a name="l00697"></a>00697     {   -0.125,    0.375,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 6</span>
<a name="l00698"></a>00698     {       0.,    0.375,   -0.125,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 7</span>
<a name="l00699"></a>00699     {   -0.125,       0.,   -0.125,       0.,       0.,       0.,      0.5,      0.5,     0.25,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 8</span>
<a name="l00700"></a>00700     {       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 9</span>
<a name="l00701"></a>00701     {       0.,    0.375,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 10</span>
<a name="l00702"></a>00702     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,     0.75,       0.}, <span class="comment">// 11</span>
<a name="l00703"></a>00703     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,    0.375,       0.,       0.,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 12</span>
<a name="l00704"></a>00704     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,   -0.125,       0.,       0.,       0.,       0.,     0.75,       0.}, <span class="comment">// 13</span>
<a name="l00705"></a>00705     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,   -0.125,       0.,       0.,       0.,      0.5,      0.5,     0.25}, <span class="comment">// 14</span>
<a name="l00706"></a>00706     {-0.046875, 0.140625,       0., 0.015625,-0.046875,       0.,  0.28125,       0.,       0., -0.09375,  0.28125,       0., -0.09375,       0.,       0.,   0.5625,       0.,       0.}, <span class="comment">// 15</span>
<a name="l00707"></a>00707     {       0., 0.140625,-0.046875,       0.,-0.046875, 0.015625,       0.,  0.28125,       0.,       0.,  0.28125, -0.09375,       0., -0.09375,       0.,       0.,   0.5625,       0.}, <span class="comment">// 16</span>
<a name="l00708"></a>00708     {-0.046875,       0.,-0.046875, 0.015625,       0., 0.015625,   0.1875,   0.1875,  0.09375, -0.09375,       0., -0.09375,  -0.0625,  -0.0625, -0.03125,    0.375,    0.375,   0.1875}  <span class="comment">// 17</span>
<a name="l00709"></a>00709   },
<a name="l00710"></a>00710 
<a name="l00711"></a>00711   <span class="comment">// embedding matrix for child 2</span>
<a name="l00712"></a>00712   {
<a name="l00713"></a>00713     <span class="comment">//       0         1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17</span>
<a name="l00714"></a>00714     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 0</span>
<a name="l00715"></a>00715     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 1</span>
<a name="l00716"></a>00716     {       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 2</span>
<a name="l00717"></a>00717     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.}, <span class="comment">// 3</span>
<a name="l00718"></a>00718     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.}, <span class="comment">// 4</span>
<a name="l00719"></a>00719     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 5</span>
<a name="l00720"></a>00720     {   -0.125,   -0.125,       0.,       0.,       0.,       0.,     0.25,      0.5,      0.5,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 6</span>
<a name="l00721"></a>00721     {       0.,   -0.125,    0.375,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 7</span>
<a name="l00722"></a>00722     {   -0.125,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 8</span>
<a name="l00723"></a>00723     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,     0.75}, <span class="comment">// 9</span>
<a name="l00724"></a>00724     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,     0.75,       0.}, <span class="comment">// 10</span>
<a name="l00725"></a>00725     {       0.,       0.,    0.375,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 11</span>
<a name="l00726"></a>00726     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,       0.,     0.25,      0.5,      0.5}, <span class="comment">// 12</span>
<a name="l00727"></a>00727     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,    0.375,       0.,       0.,       0.,       0.,     0.75,       0.}, <span class="comment">// 13</span>
<a name="l00728"></a>00728     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,     0.75}, <span class="comment">// 14</span>
<a name="l00729"></a>00729     {-0.046875,-0.046875,       0., 0.015625, 0.015625,       0.,  0.09375,   0.1875,   0.1875, -0.09375, -0.09375,       0., -0.03125,  -0.0625,  -0.0625,   0.1875,    0.375,    0.375}, <span class="comment">// 15</span>
<a name="l00730"></a>00730     {       0.,-0.046875, 0.140625,       0., 0.015625,-0.046875,       0.,  0.28125,       0.,       0., -0.09375,  0.28125,       0., -0.09375,       0.,       0.,   0.5625,       0.}, <span class="comment">// 16</span>
<a name="l00731"></a>00731     {-0.046875,       0., 0.140625, 0.015625,       0.,-0.046875,       0.,       0.,  0.28125, -0.09375,       0.,  0.28125,       0.,       0., -0.09375,       0.,       0.,   0.5625}  <span class="comment">// 17</span>
<a name="l00732"></a>00732   },
<a name="l00733"></a>00733 
<a name="l00734"></a>00734   <span class="comment">// embedding matrix for child 3</span>
<a name="l00735"></a>00735   {
<a name="l00736"></a>00736     <span class="comment">//       0         1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17</span>
<a name="l00737"></a>00737     {       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 0</span>
<a name="l00738"></a>00738     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 1</span>
<a name="l00739"></a>00739     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 2</span>
<a name="l00740"></a>00740     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.}, <span class="comment">// 3</span>
<a name="l00741"></a>00741     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.}, <span class="comment">// 4</span>
<a name="l00742"></a>00742     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.}, <span class="comment">// 5</span>
<a name="l00743"></a>00743     {   -0.125,       0.,   -0.125,       0.,       0.,       0.,      0.5,      0.5,     0.25,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 6</span>
<a name="l00744"></a>00744     {   -0.125,   -0.125,       0.,       0.,       0.,       0.,     0.25,      0.5,      0.5,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 7</span>
<a name="l00745"></a>00745     {       0.,   -0.125,   -0.125,       0.,       0.,       0.,      0.5,     0.25,      0.5,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 8</span>
<a name="l00746"></a>00746     {       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 9</span>
<a name="l00747"></a>00747     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,     0.75,       0.}, <span class="comment">// 10</span>
<a name="l00748"></a>00748     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,     0.75}, <span class="comment">// 11</span>
<a name="l00749"></a>00749     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,   -0.125,       0.,       0.,       0.,      0.5,      0.5,     0.25}, <span class="comment">// 12</span>
<a name="l00750"></a>00750     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,       0.,     0.25,      0.5,      0.5}, <span class="comment">// 13</span>
<a name="l00751"></a>00751     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,      0.5,     0.25,      0.5}, <span class="comment">// 14</span>
<a name="l00752"></a>00752     {-0.046875,       0.,-0.046875, 0.015625,       0., 0.015625,   0.1875,   0.1875,  0.09375, -0.09375,       0., -0.09375,  -0.0625,  -0.0625, -0.03125,    0.375,    0.375,   0.1875}, <span class="comment">// 15</span>
<a name="l00753"></a>00753     {-0.046875,-0.046875,       0., 0.015625, 0.015625,       0.,  0.09375,   0.1875,   0.1875, -0.09375, -0.09375,       0., -0.03125,  -0.0625,  -0.0625,   0.1875,    0.375,    0.375}, <span class="comment">// 16</span>
<a name="l00754"></a>00754     {       0.,-0.046875,-0.046875,       0., 0.015625, 0.015625,   0.1875,  0.09375,   0.1875,       0., -0.09375, -0.09375,  -0.0625, -0.03125,  -0.0625,    0.375,   0.1875,    0.375}  <span class="comment">// 17</span>
<a name="l00755"></a>00755   },
<a name="l00756"></a>00756 
<a name="l00757"></a>00757   <span class="comment">// embedding matrix for child 4</span>
<a name="l00758"></a>00758   {
<a name="l00759"></a>00759     <span class="comment">//       0         1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17</span>
<a name="l00760"></a>00760     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 0</span>
<a name="l00761"></a>00761     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.}, <span class="comment">// 1</span>
<a name="l00762"></a>00762     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.}, <span class="comment">// 2</span>
<a name="l00763"></a>00763     {       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 3</span>
<a name="l00764"></a>00764     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 4</span>
<a name="l00765"></a>00765     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.}, <span class="comment">// 5</span>
<a name="l00766"></a>00766     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,   -0.125,       0.,       0.,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 6</span>
<a name="l00767"></a>00767     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,      0.5,     0.25,      0.5}, <span class="comment">// 7</span>
<a name="l00768"></a>00768     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,     0.75}, <span class="comment">// 8</span>
<a name="l00769"></a>00769     {   -0.125,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 9</span>
<a name="l00770"></a>00770     {       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 10</span>
<a name="l00771"></a>00771     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,     0.75}, <span class="comment">// 11</span>
<a name="l00772"></a>00772     {       0.,       0.,       0.,    0.375,   -0.125,       0.,       0.,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 12</span>
<a name="l00773"></a>00773     {       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,       0.,       0.,       0.,      0.5,     0.25,      0.5,       0.,       0.,       0.}, <span class="comment">// 13</span>
<a name="l00774"></a>00774     {       0.,       0.,       0.,    0.375,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.}, <span class="comment">// 14</span>
<a name="l00775"></a>00775     {-0.046875, 0.015625,       0., 0.140625,-0.046875,       0., -0.09375,       0.,       0.,  0.28125, -0.09375,       0.,  0.28125,       0.,       0.,   0.5625,       0.,       0.}, <span class="comment">// 15</span>
<a name="l00776"></a>00776     {       0., 0.015625, 0.015625,       0.,-0.046875,-0.046875,  -0.0625, -0.03125,  -0.0625,       0., -0.09375, -0.09375,   0.1875,  0.09375,   0.1875,    0.375,   0.1875,    0.375}, <span class="comment">// 16</span>
<a name="l00777"></a>00777     {-0.046875,       0., 0.015625, 0.140625,       0.,-0.046875,       0.,       0., -0.09375,  0.28125,       0., -0.09375,       0.,       0.,  0.28125,       0.,       0.,   0.5625}  <span class="comment">// 17</span>
<a name="l00778"></a>00778   },
<a name="l00779"></a>00779 
<a name="l00780"></a>00780   <span class="comment">// embedding matrix for child 5</span>
<a name="l00781"></a>00781   {
<a name="l00782"></a>00782     <span class="comment">//       0         1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17</span>
<a name="l00783"></a>00783     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.}, <span class="comment">// 0</span>
<a name="l00784"></a>00784     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 1</span>
<a name="l00785"></a>00785     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.}, <span class="comment">// 2</span>
<a name="l00786"></a>00786     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 3</span>
<a name="l00787"></a>00787     {       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 4</span>
<a name="l00788"></a>00788     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.}, <span class="comment">// 5</span>
<a name="l00789"></a>00789     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,    0.375,       0.,       0.,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 6</span>
<a name="l00790"></a>00790     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,    0.375,   -0.125,       0.,       0.,       0.,       0.,     0.75,       0.}, <span class="comment">// 7</span>
<a name="l00791"></a>00791     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,   -0.125,       0.,       0.,       0.,      0.5,      0.5,     0.25}, <span class="comment">// 8</span>
<a name="l00792"></a>00792     {       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 9</span>
<a name="l00793"></a>00793     {       0.,   -0.125,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 10</span>
<a name="l00794"></a>00794     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,     0.75,       0.}, <span class="comment">// 11</span>
<a name="l00795"></a>00795     {       0.,       0.,       0.,   -0.125,    0.375,       0.,       0.,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 12</span>
<a name="l00796"></a>00796     {       0.,       0.,       0.,       0.,    0.375,   -0.125,       0.,       0.,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.}, <span class="comment">// 13</span>
<a name="l00797"></a>00797     {       0.,       0.,       0.,   -0.125,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,       0.,      0.5,      0.5,     0.25,       0.,       0.,       0.}, <span class="comment">// 14</span>
<a name="l00798"></a>00798     { 0.015625,-0.046875,       0.,-0.046875, 0.140625,       0., -0.09375,       0.,       0., -0.09375,  0.28125,       0.,  0.28125,       0.,       0.,   0.5625,       0.,       0.}, <span class="comment">// 15</span>
<a name="l00799"></a>00799     {       0.,-0.046875, 0.015625,       0., 0.140625,-0.046875,       0., -0.09375,       0.,       0.,  0.28125, -0.09375,       0.,  0.28125,       0.,       0.,   0.5625,       0.}, <span class="comment">// 16</span>
<a name="l00800"></a>00800     { 0.015625,       0., 0.015625,-0.046875,       0.,-0.046875,  -0.0625,  -0.0625, -0.03125, -0.09375,       0., -0.09375,   0.1875,   0.1875,  0.09375,    0.375,    0.375,   0.1875}  <span class="comment">// 17</span>
<a name="l00801"></a>00801   },
<a name="l00802"></a>00802 
<a name="l00803"></a>00803   <span class="comment">// embedding matrix for child 6</span>
<a name="l00804"></a>00804   {
<a name="l00805"></a>00805     <span class="comment">//       0         1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17</span>
<a name="l00806"></a>00806     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.}, <span class="comment">// 0</span>
<a name="l00807"></a>00807     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.}, <span class="comment">// 1</span>
<a name="l00808"></a>00808     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 2</span>
<a name="l00809"></a>00809     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.}, <span class="comment">// 3</span>
<a name="l00810"></a>00810     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.}, <span class="comment">// 4</span>
<a name="l00811"></a>00811     {       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 5</span>
<a name="l00812"></a>00812     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,       0.,     0.25,      0.5,      0.5}, <span class="comment">// 6</span>
<a name="l00813"></a>00813     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,    0.375,       0.,       0.,       0.,       0.,     0.75,       0.}, <span class="comment">// 7</span>
<a name="l00814"></a>00814     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,     0.75}, <span class="comment">// 8</span>
<a name="l00815"></a>00815     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,     0.75}, <span class="comment">// 9</span>
<a name="l00816"></a>00816     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,     0.75,       0.}, <span class="comment">// 10</span>
<a name="l00817"></a>00817     {       0.,       0.,   -0.125,       0.,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 11</span>
<a name="l00818"></a>00818     {       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,       0.,       0.,       0.,       0.,     0.25,      0.5,      0.5,       0.,       0.,       0.}, <span class="comment">// 12</span>
<a name="l00819"></a>00819     {       0.,       0.,       0.,       0.,   -0.125,    0.375,       0.,       0.,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.,       0.}, <span class="comment">// 13</span>
<a name="l00820"></a>00820     {       0.,       0.,       0.,   -0.125,       0.,    0.375,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,     0.75,       0.,       0.,       0.}, <span class="comment">// 14</span>
<a name="l00821"></a>00821     { 0.015625, 0.015625,       0.,-0.046875,-0.046875,       0., -0.03125,  -0.0625,  -0.0625, -0.09375, -0.09375,       0.,  0.09375,   0.1875,   0.1875,   0.1875,    0.375,    0.375}, <span class="comment">// 15</span>
<a name="l00822"></a>00822     {       0., 0.015625,-0.046875,       0.,-0.046875, 0.140625,       0., -0.09375,       0.,       0., -0.09375,  0.28125,       0.,  0.28125,       0.,       0.,   0.5625,       0.}, <span class="comment">// 16</span>
<a name="l00823"></a>00823     { 0.015625,       0.,-0.046875,-0.046875,       0., 0.140625,       0.,       0., -0.09375, -0.09375,       0.,  0.28125,       0.,       0.,  0.28125,       0.,       0.,   0.5625}  <span class="comment">// 17</span>
<a name="l00824"></a>00824   },
<a name="l00825"></a>00825 
<a name="l00826"></a>00826   <span class="comment">// embedding matrix for child 7</span>
<a name="l00827"></a>00827   {
<a name="l00828"></a>00828     <span class="comment">//       0         1         2         3         4         5         6         7         8         9        10        11        12        13        14        15        16        17</span>
<a name="l00829"></a>00829     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.}, <span class="comment">// 0</span>
<a name="l00830"></a>00830     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.}, <span class="comment">// 1</span>
<a name="l00831"></a>00831     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.}, <span class="comment">// 2</span>
<a name="l00832"></a>00832     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.,       0.}, <span class="comment">// 3</span>
<a name="l00833"></a>00833     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.,       0.}, <span class="comment">// 4</span>
<a name="l00834"></a>00834     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       1.,       0.,       0.,       0.}, <span class="comment">// 5</span>
<a name="l00835"></a>00835     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,   -0.125,       0.,       0.,       0.,      0.5,      0.5,     0.25}, <span class="comment">// 6</span>
<a name="l00836"></a>00836     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,       0.,     0.25,      0.5,      0.5}, <span class="comment">// 7</span>
<a name="l00837"></a>00837     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,      0.5,     0.25,      0.5}, <span class="comment">// 8</span>
<a name="l00838"></a>00838     {       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,     0.75,       0.,       0.}, <span class="comment">// 9</span>
<a name="l00839"></a>00839     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,     0.75,       0.}, <span class="comment">// 10</span>
<a name="l00840"></a>00840     {       0.,       0.,       0.,       0.,       0.,       0.,       0.,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,    0.375,       0.,       0.,     0.75}, <span class="comment">// 11</span>
<a name="l00841"></a>00841     {       0.,       0.,       0.,   -0.125,       0.,   -0.125,       0.,       0.,       0.,       0.,       0.,       0.,      0.5,      0.5,     0.25,       0.,       0.,       0.}, <span class="comment">// 12</span>
<a name="l00842"></a>00842     {       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,       0.,       0.,       0.,       0.,     0.25,      0.5,      0.5,       0.,       0.,       0.}, <span class="comment">// 13</span>
<a name="l00843"></a>00843     {       0.,       0.,       0.,       0.,   -0.125,   -0.125,       0.,       0.,       0.,       0.,       0.,       0.,      0.5,     0.25,      0.5,       0.,       0.,       0.}, <span class="comment">// 14</span>
<a name="l00844"></a>00844     { 0.015625,       0., 0.015625,-0.046875,       0.,-0.046875,  -0.0625,  -0.0625, -0.03125, -0.09375,       0., -0.09375,   0.1875,   0.1875,  0.09375,    0.375,    0.375,   0.1875}, <span class="comment">// 15</span>
<a name="l00845"></a>00845     { 0.015625, 0.015625,       0.,-0.046875,-0.046875,       0., -0.03125,  -0.0625,  -0.0625, -0.09375, -0.09375,       0.,  0.09375,   0.1875,   0.1875,   0.1875,    0.375,    0.375}, <span class="comment">// 16</span>
<a name="l00846"></a>00846     {       0., 0.015625, 0.015625,       0.,-0.046875,-0.046875,  -0.0625, -0.03125,  -0.0625,       0., -0.09375, -0.09375,   0.1875,  0.09375,   0.1875,    0.375,   0.1875,    0.375}  <span class="comment">// 17</span>
<a name="l00847"></a>00847   }
<a name="l00848"></a>00848 };
<a name="l00849"></a>00849 
<a name="l00850"></a>00850 <span class="preprocessor">#endif</span>
<a name="l00851"></a>00851 <span class="preprocessor"></span>
<a name="l00852"></a>00852 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
