<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_prism.h</div>  </div>
</div>
<div class="contents">
<a href="cell__prism_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_prism.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __cell_prism_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __cell_prism_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="cell_8h.php">cell.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// Prism class definition</span>
<a name="l00042"></a><a class="code" href="classlibMesh_1_1Prism.php">00042</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Prism.php">Prism</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Cell.php">Cell</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045 
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1Prism.php#ac161407603bad0f8bf99ec33c9a168f6">Prism</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p);
<a name="l00051"></a>00051   
<a name="l00056"></a><a class="code" href="classlibMesh_1_1Prism.php#aa3534e2be74f344bce328ebd93f0cff4">00056</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#aa3534e2be74f344bce328ebd93f0cff4">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00057"></a>00057 
<a name="l00061"></a><a class="code" href="classlibMesh_1_1Prism.php#a075e71558bb7cd912a02ecd12c16d0dc">00061</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#a075e71558bb7cd912a02ecd12c16d0dc">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00062"></a>00062 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1Prism.php#a5a8ea1fa1b486aae23effc0d5ec052ca">00066</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#a5a8ea1fa1b486aae23effc0d5ec052ca">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00067"></a>00067 
<a name="l00071"></a><a class="code" href="classlibMesh_1_1Prism.php#a065c69f09f7b609c7110f00e80ba9651">00071</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#a065c69f09f7b609c7110f00e80ba9651">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 9; }
<a name="l00072"></a>00072 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1Prism.php#af3789237bf55b02772e434d321d73cbf">00076</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#af3789237bf55b02772e434d321d73cbf">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00077"></a>00077   
<a name="l00081"></a><a class="code" href="classlibMesh_1_1Prism.php#a5bc2f400e1c8e02484c0c222ffc31527">00081</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#a5bc2f400e1c8e02484c0c222ffc31527">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00082"></a>00082   
<a name="l00083"></a>00083   <span class="comment">/*</span>
<a name="l00084"></a>00084 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00085"></a>00085 <span class="comment">   * specified side</span>
<a name="l00086"></a>00086 <span class="comment">   */</span>
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Prism.php#ad5aa2877f90083b92856b2fd7d7373ca">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00088"></a>00088                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00089"></a>00089   
<a name="l00095"></a>00095   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#a2521df5b7a7ed39ff2cb0e670fc9fc2d">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00096"></a>00096 
<a name="l00101"></a>00101   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Prism.php#a31554dcaed0c36f8a139bee81a597a0b">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="keyword">protected</span>:
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   
<a name="l00115"></a><a class="code" href="classlibMesh_1_1Prism.php#aebf9f0ec1379218836e7cecd28cc0e1c">00115</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#aebf9f0ec1379218836e7cecd28cc0e1c">_second_order_adjacent_vertices</a>[9][2];
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1Prism.php#a7268c3d4d75a8356ce4bd69831e2a050">00120</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#a7268c3d4d75a8356ce4bd69831e2a050">_second_order_vertex_child_number</a>[18];
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1Prism.php#af24e406976c619cce58d82c589a0357e">00125</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Prism.php#af24e406976c619cce58d82c589a0357e">_second_order_vertex_child_index</a>[18];
<a name="l00126"></a>00126 };
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00131"></a>00131 <span class="comment">// Prism class member functions</span>
<a name="l00132"></a>00132 <span class="keyword">inline</span>
<a name="l00133"></a><a class="code" href="classlibMesh_1_1Prism.php#ac161407603bad0f8bf99ec33c9a168f6">00133</a> <a class="code" href="classlibMesh_1_1Prism.php#ac161407603bad0f8bf99ec33c9a168f6">Prism::Prism</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1Cell.php">Cell</a>(nn, <a class="code" href="classlibMesh_1_1Prism.php">Prism</a>::n_sides(), p) 
<a name="l00135"></a>00135 {
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 } <span class="comment">// namespace libMesh</span>
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
