<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_tet10.C</div>  </div>
</div>
<div class="contents">
<a href="cell__tet10_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_tet10.C 4209 2011-02-28 21:25:22Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet10_8h.php">cell_tet10.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="face__tri6_8h.php">face_tri6.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// Tet10 class static member initializations</span>
<a name="l00036"></a>00036 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tet10.php#a1854cc5ccfc3999d6daa05cb049bb100">Tet10::side_nodes_map</a>[4][6] =
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   {0, 2, 1, 6, 5, 4}, <span class="comment">// Side 0</span>
<a name="l00039"></a>00039   {0, 1, 3, 4, 8, 7}, <span class="comment">// Side 1</span>
<a name="l00040"></a>00040   {1, 2, 3, 5, 9, 8}, <span class="comment">// Side 2</span>
<a name="l00041"></a>00041   {2, 0, 3, 6, 7, 9}  <span class="comment">// Side 3</span>
<a name="l00042"></a>00042 };
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tet10.php#a3c9a37cc3c20483f7649a92f3e0bdc37">Tet10::edge_nodes_map</a>[6][3] =
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   {0, 1, 4}, <span class="comment">// Side 0</span>
<a name="l00047"></a>00047   {1, 2, 5}, <span class="comment">// Side 1</span>
<a name="l00048"></a>00048   {0, 2, 6}, <span class="comment">// Side 2</span>
<a name="l00049"></a>00049   {0, 3, 7}, <span class="comment">// Side 3</span>
<a name="l00050"></a>00050   {1, 3, 8}, <span class="comment">// Side 4</span>
<a name="l00051"></a>00051   {2, 3, 9}  <span class="comment">// Side 5</span>
<a name="l00052"></a>00052 };
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// Tet10 class member functions</span>
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1Tet10.php#a46b01a2af3500be2c0b3135eab00c118">00059</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet10.php#a46b01a2af3500be2c0b3135eab00c118">Tet10::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00060"></a>00060 <span class="keyword"></span>{
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00062"></a>00062     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00063"></a>00063   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1Tet10.php#a5adb492c59eabbc664f1239a2f114ba3">00066</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet10.php#a5adb492c59eabbc664f1239a2f114ba3">Tet10::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00067"></a>00067 <span class="keyword"></span>{
<a name="l00068"></a>00068   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00069"></a>00069     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00070"></a>00070   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1Tet10.php#a98ab5c284fc89c571333d29498f67b30">00073</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet10.php#a98ab5c284fc89c571333d29498f67b30">Tet10::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00074"></a>00074 <span class="keyword"></span>{
<a name="l00075"></a>00075   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1Tet10.php#af7726dd2b96b2c131752607ea2674a6d">00078</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet10.php#af7726dd2b96b2c131752607ea2674a6d">Tet10::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00079"></a>00079                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword"></span>{
<a name="l00081"></a>00081   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1Tet.php#a273874aa6b467759119e2a1cd5d7436b">n_sides</a>());
<a name="l00082"></a>00082   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 6; ++i)
<a name="l00083"></a>00083     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Tet10.php#a1854cc5ccfc3999d6daa05cb049bb100">side_nodes_map</a>[s][i] == n)
<a name="l00084"></a>00084       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00085"></a>00085   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00086"></a>00086 }
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1Tet10.php#a74dbdfb607dcb651e6aa3387ecb63120">00088</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet10.php#a74dbdfb607dcb651e6aa3387ecb63120">Tet10::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00089"></a>00089                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00090"></a>00090 <span class="keyword"></span>{
<a name="l00091"></a>00091   libmesh_assert(e &lt; <a class="code" href="classlibMesh_1_1Tet.php#a4fdc7c7435603240aaa5fab783759eb0">n_edges</a>());
<a name="l00092"></a>00092   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00093"></a>00093     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Tet10.php#a3c9a37cc3c20483f7649a92f3e0bdc37">edge_nodes_map</a>[e][i] == n)
<a name="l00094"></a>00094       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00095"></a>00095   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="classlibMesh_1_1Tet10.php#a4c5fab3ad6c580e977d35c55dc8d84bb">00100</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet10.php#a4c5fab3ad6c580e977d35c55dc8d84bb">Tet10::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00101"></a>00101 <span class="keyword"></span>{
<a name="l00102"></a>00102   <span class="comment">// Make sure edges are straight</span>
<a name="l00103"></a>00103   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4).relative_fuzzy_equals
<a name="l00104"></a>00104       ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1))/2))
<a name="l00105"></a>00105     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5).relative_fuzzy_equals
<a name="l00107"></a>00107       ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2))/2))
<a name="l00108"></a>00108     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00109"></a>00109   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(6).relative_fuzzy_equals
<a name="l00110"></a>00110       ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))/2))
<a name="l00111"></a>00111     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(7).relative_fuzzy_equals
<a name="l00113"></a>00113       ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))/2))
<a name="l00114"></a>00114     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00115"></a>00115   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(8).relative_fuzzy_equals
<a name="l00116"></a>00116       ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1))/2))
<a name="l00117"></a>00117     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00118"></a>00118   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(9).relative_fuzzy_equals
<a name="l00119"></a>00119       ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2))/2))
<a name="l00120"></a>00120     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00121"></a>00121   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1Tet10.php#a6f8141775632e0a55ca7550f26ca3214">00126</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Tet10.php#a6f8141775632e0a55ca7550f26ca3214">Tet10::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00127"></a>00127                                  <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00128"></a>00128 <span class="keyword"></span>{
<a name="l00129"></a>00129   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a273874aa6b467759119e2a1cd5d7436b">n_sides</a>());
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="keywordflow">if</span> (proxy)
<a name="l00132"></a>00132     {
<a name="l00133"></a>00133       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Tri6,Tet10&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00134"></a>00134       <span class="keywordflow">return</span> ap;
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="keywordflow">else</span>
<a name="l00138"></a>00138     {
<a name="l00139"></a>00139       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>);
<a name="l00140"></a>00140   
<a name="l00141"></a>00141       <span class="keywordflow">switch</span> (i)
<a name="l00142"></a>00142         {
<a name="l00143"></a>00143         <span class="keywordflow">case</span> 0:
<a name="l00144"></a>00144           {
<a name="l00145"></a>00145             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00146"></a>00146             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00147"></a>00147             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00148"></a>00148             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00149"></a>00149             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00150"></a>00150             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152             <span class="keywordflow">return</span> face;
<a name="l00153"></a>00153           }
<a name="l00154"></a>00154         <span class="keywordflow">case</span> 1:
<a name="l00155"></a>00155           {
<a name="l00156"></a>00156             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00157"></a>00157             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00158"></a>00158             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00159"></a>00159             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00160"></a>00160             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00161"></a>00161             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163             <span class="keywordflow">return</span> face;
<a name="l00164"></a>00164           }
<a name="l00165"></a>00165         <span class="keywordflow">case</span> 2:
<a name="l00166"></a>00166           {
<a name="l00167"></a>00167             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00168"></a>00168             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00169"></a>00169             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00170"></a>00170             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00171"></a>00171             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00172"></a>00172             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(8);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174             <span class="keywordflow">return</span> face;
<a name="l00175"></a>00175           }
<a name="l00176"></a>00176         <span class="keywordflow">case</span> 3:
<a name="l00177"></a>00177           {
<a name="l00178"></a>00178             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00179"></a>00179             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00180"></a>00180             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00181"></a>00181             face-&gt;set_node(3) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00182"></a>00182             face-&gt;set_node(4) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00183"></a>00183             face-&gt;set_node(5) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(9);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185             <span class="keywordflow">return</span> face;
<a name="l00186"></a>00186           }
<a name="l00187"></a>00187         <span class="keywordflow">default</span>:
<a name="l00188"></a>00188           {
<a name="l00189"></a>00189             libmesh_error();
<a name="l00190"></a>00190           }
<a name="l00191"></a>00191         }
<a name="l00192"></a>00192     }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   
<a name="l00195"></a>00195   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00196"></a>00196   libmesh_error();
<a name="l00197"></a>00197   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a><a class="code" href="classlibMesh_1_1Tet10.php#a5a5712d65c23dec75a801e9e785afac9">00202</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Tet10.php#a5a5712d65c23dec75a801e9e785afac9">Tet10::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00203"></a>00203 <span class="keyword"></span>{
<a name="l00204"></a>00204   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a4fdc7c7435603240aaa5fab783759eb0">n_edges</a>());
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;Edge3,Tet10&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00207"></a>00207 }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a><a class="code" href="classlibMesh_1_1Tet10.php#a9871d677c8db079449272056d2db4fc4">00211</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tet10.php#a9871d677c8db079449272056d2db4fc4">Tet10::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00212"></a>00212                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00213"></a>00213                          std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00214"></a>00214 <span class="keyword"></span>{
<a name="l00215"></a>00215   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL);
<a name="l00216"></a>00216   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a77dec30ac2bec70adb19a0ecf4321c9d">n_sub_elem</a>());
<a name="l00217"></a>00217   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="keywordflow">switch</span> (iop)
<a name="l00220"></a>00220     {
<a name="l00221"></a>00221     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00222"></a>00222       {
<a name="l00223"></a>00223         conn.resize(8);
<a name="l00224"></a>00224         <span class="keywordflow">switch</span> (sc)
<a name="l00225"></a>00225           {
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228             <span class="comment">// Linear sub-tet 0</span>
<a name="l00229"></a>00229           <span class="keywordflow">case</span> 0:
<a name="l00230"></a>00230 
<a name="l00231"></a>00231             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00232"></a>00232             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00233"></a>00233             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00234"></a>00234             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00235"></a>00235             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00236"></a>00236             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00237"></a>00237             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00238"></a>00238             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00239"></a>00239  
<a name="l00240"></a>00240             <span class="keywordflow">return</span>;
<a name="l00241"></a>00241   
<a name="l00242"></a>00242             <span class="comment">// Linear sub-tet 1</span>
<a name="l00243"></a>00243           <span class="keywordflow">case</span> 1:
<a name="l00244"></a>00244 
<a name="l00245"></a>00245             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00246"></a>00246             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00247"></a>00247             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00248"></a>00248             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00249"></a>00249             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00250"></a>00250             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00251"></a>00251             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00252"></a>00252             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254             <span class="keywordflow">return</span>;
<a name="l00255"></a>00255 
<a name="l00256"></a>00256             <span class="comment">// Linear sub-tet 2</span>
<a name="l00257"></a>00257           <span class="keywordflow">case</span> 2:
<a name="l00258"></a>00258 
<a name="l00259"></a>00259             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00260"></a>00260             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00261"></a>00261             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00262"></a>00262             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00263"></a>00263             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00264"></a>00264             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00265"></a>00265             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00266"></a>00266             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268             <span class="keywordflow">return</span>;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270             <span class="comment">// Linear sub-tet 3</span>
<a name="l00271"></a>00271           <span class="keywordflow">case</span> 3:
<a name="l00272"></a>00272 
<a name="l00273"></a>00273             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00274"></a>00274             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00275"></a>00275             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00276"></a>00276             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00277"></a>00277             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00278"></a>00278             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00279"></a>00279             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00280"></a>00280             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282             <span class="keywordflow">return</span>;
<a name="l00283"></a>00283 
<a name="l00284"></a>00284             <span class="comment">// Linear sub-tet 4</span>
<a name="l00285"></a>00285           <span class="keywordflow">case</span> 4:
<a name="l00286"></a>00286 
<a name="l00287"></a>00287             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00288"></a>00288             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00289"></a>00289             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00290"></a>00290             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00291"></a>00291             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00292"></a>00292             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00293"></a>00293             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00294"></a>00294             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00295"></a>00295 
<a name="l00296"></a>00296             <span class="keywordflow">return</span>;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298             <span class="comment">// Linear sub-tet 5</span>
<a name="l00299"></a>00299           <span class="keywordflow">case</span> 5:
<a name="l00300"></a>00300 
<a name="l00301"></a>00301             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00302"></a>00302             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00303"></a>00303             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00304"></a>00304             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00305"></a>00305             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00306"></a>00306             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00307"></a>00307             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00308"></a>00308             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310             <span class="keywordflow">return</span>;
<a name="l00311"></a>00311 
<a name="l00312"></a>00312             <span class="comment">// Linear sub-tet 6</span>
<a name="l00313"></a>00313           <span class="keywordflow">case</span> 6:
<a name="l00314"></a>00314 
<a name="l00315"></a>00315             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00316"></a>00316             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00317"></a>00317             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00318"></a>00318             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00319"></a>00319             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00320"></a>00320             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00321"></a>00321             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00322"></a>00322             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00323"></a>00323 
<a name="l00324"></a>00324             <span class="keywordflow">return</span>;
<a name="l00325"></a>00325 
<a name="l00326"></a>00326             <span class="comment">// Linear sub-tet 7</span>
<a name="l00327"></a>00327           <span class="keywordflow">case</span> 7:
<a name="l00328"></a>00328 
<a name="l00329"></a>00329             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00330"></a>00330             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00331"></a>00331             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00332"></a>00332             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1;
<a name="l00333"></a>00333             conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00334"></a>00334             conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00335"></a>00335             conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00336"></a>00336             conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00337"></a>00337 
<a name="l00338"></a>00338             <span class="keywordflow">return</span>;
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341           <span class="keywordflow">default</span>:
<a name="l00342"></a>00342 
<a name="l00343"></a>00343             libmesh_error();
<a name="l00344"></a>00344         }
<a name="l00345"></a>00345       }
<a name="l00346"></a>00346 
<a name="l00347"></a>00347     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00348"></a>00348       {
<a name="l00349"></a>00349         conn.resize(10);
<a name="l00350"></a>00350         conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0);
<a name="l00351"></a>00351         conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1);
<a name="l00352"></a>00352         conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2);
<a name="l00353"></a>00353         conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3);
<a name="l00354"></a>00354         conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4);
<a name="l00355"></a>00355         conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5);
<a name="l00356"></a>00356         conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6);
<a name="l00357"></a>00357         conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7);
<a name="l00358"></a>00358         conn[8] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8);
<a name="l00359"></a>00359         conn[9] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9);
<a name="l00360"></a>00360         <span class="keywordflow">return</span>;
<a name="l00361"></a>00361         <span class="comment">/*</span>
<a name="l00362"></a>00362 <span class="comment">           conn.resize(4);</span>
<a name="l00363"></a>00363 <span class="comment">           switch (sc)</span>
<a name="l00364"></a>00364 <span class="comment">           {            </span>
<a name="l00365"></a>00365 <span class="comment">        // Linear sub-tet 0</span>
<a name="l00366"></a>00366 <span class="comment">        case 0:</span>
<a name="l00367"></a>00367 <span class="comment"></span>
<a name="l00368"></a>00368 <span class="comment">        conn[0] = this-&gt;node(0);</span>
<a name="l00369"></a>00369 <span class="comment">        conn[1] = this-&gt;node(4);</span>
<a name="l00370"></a>00370 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00371"></a>00371 <span class="comment">        conn[3] = this-&gt;node(7);</span>
<a name="l00372"></a>00372 <span class="comment"></span>
<a name="l00373"></a>00373 <span class="comment">        return;</span>
<a name="l00374"></a>00374 <span class="comment"></span>
<a name="l00375"></a>00375 <span class="comment">        // Linear sub-tet 1</span>
<a name="l00376"></a>00376 <span class="comment">        case 1:</span>
<a name="l00377"></a>00377 <span class="comment"></span>
<a name="l00378"></a>00378 <span class="comment">        conn[0] = this-&gt;node(4);</span>
<a name="l00379"></a>00379 <span class="comment">        conn[1] = this-&gt;node(1);</span>
<a name="l00380"></a>00380 <span class="comment">        conn[2] = this-&gt;node(5);</span>
<a name="l00381"></a>00381 <span class="comment">        conn[3] = this-&gt;node(8);</span>
<a name="l00382"></a>00382 <span class="comment"></span>
<a name="l00383"></a>00383 <span class="comment">        return;</span>
<a name="l00384"></a>00384 <span class="comment"></span>
<a name="l00385"></a>00385 <span class="comment">        // Linear sub-tet 2</span>
<a name="l00386"></a>00386 <span class="comment">        case 2:</span>
<a name="l00387"></a>00387 <span class="comment"></span>
<a name="l00388"></a>00388 <span class="comment">        conn[0] = this-&gt;node(5);</span>
<a name="l00389"></a>00389 <span class="comment">        conn[1] = this-&gt;node(2);</span>
<a name="l00390"></a>00390 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00391"></a>00391 <span class="comment">        conn[3] = this-&gt;node(9);</span>
<a name="l00392"></a>00392 <span class="comment"></span>
<a name="l00393"></a>00393 <span class="comment">        return;</span>
<a name="l00394"></a>00394 <span class="comment"></span>
<a name="l00395"></a>00395 <span class="comment">        // Linear sub-tet 3</span>
<a name="l00396"></a>00396 <span class="comment">        case 3:</span>
<a name="l00397"></a>00397 <span class="comment"></span>
<a name="l00398"></a>00398 <span class="comment">        conn[0] = this-&gt;node(7);</span>
<a name="l00399"></a>00399 <span class="comment">        conn[1] = this-&gt;node(8);</span>
<a name="l00400"></a>00400 <span class="comment">        conn[2] = this-&gt;node(9);</span>
<a name="l00401"></a>00401 <span class="comment">        conn[3] = this-&gt;node(3);</span>
<a name="l00402"></a>00402 <span class="comment"></span>
<a name="l00403"></a>00403 <span class="comment">        return;</span>
<a name="l00404"></a>00404 <span class="comment"></span>
<a name="l00405"></a>00405 <span class="comment">        // Linear sub-tet 4</span>
<a name="l00406"></a>00406 <span class="comment">        case 4:</span>
<a name="l00407"></a>00407 <span class="comment"></span>
<a name="l00408"></a>00408 <span class="comment">        conn[0] = this-&gt;node(4);</span>
<a name="l00409"></a>00409 <span class="comment">        conn[1] = this-&gt;node(8);</span>
<a name="l00410"></a>00410 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00411"></a>00411 <span class="comment">        conn[3] = this-&gt;node(7);</span>
<a name="l00412"></a>00412 <span class="comment"></span>
<a name="l00413"></a>00413 <span class="comment">        return;</span>
<a name="l00414"></a>00414 <span class="comment"></span>
<a name="l00415"></a>00415 <span class="comment">        // Linear sub-tet 5</span>
<a name="l00416"></a>00416 <span class="comment">        case 5:</span>
<a name="l00417"></a>00417 <span class="comment"></span>
<a name="l00418"></a>00418 <span class="comment">        conn[0] = this-&gt;node(4);</span>
<a name="l00419"></a>00419 <span class="comment">        conn[1] = this-&gt;node(5);</span>
<a name="l00420"></a>00420 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00421"></a>00421 <span class="comment">        conn[3] = this-&gt;node(8);</span>
<a name="l00422"></a>00422 <span class="comment"></span>
<a name="l00423"></a>00423 <span class="comment">        return;</span>
<a name="l00424"></a>00424 <span class="comment"></span>
<a name="l00425"></a>00425 <span class="comment">        // Linear sub-tet 6</span>
<a name="l00426"></a>00426 <span class="comment">        case 6:</span>
<a name="l00427"></a>00427 <span class="comment"></span>
<a name="l00428"></a>00428 <span class="comment">        conn[0] = this-&gt;node(5);</span>
<a name="l00429"></a>00429 <span class="comment">        conn[1] = this-&gt;node(9);</span>
<a name="l00430"></a>00430 <span class="comment">        conn[2] = this-&gt;node(6);</span>
<a name="l00431"></a>00431 <span class="comment">        conn[3] = this-&gt;node(8);</span>
<a name="l00432"></a>00432 <span class="comment"></span>
<a name="l00433"></a>00433 <span class="comment">        return;</span>
<a name="l00434"></a>00434 <span class="comment"></span>
<a name="l00435"></a>00435 <span class="comment">        // Linear sub-tet 7</span>
<a name="l00436"></a>00436 <span class="comment">        case 7:</span>
<a name="l00437"></a>00437 <span class="comment"></span>
<a name="l00438"></a>00438 <span class="comment">        conn[0] = this-&gt;node(7);</span>
<a name="l00439"></a>00439 <span class="comment">        conn[1] = this-&gt;node(6);</span>
<a name="l00440"></a>00440 <span class="comment">        conn[2] = this-&gt;node(9);</span>
<a name="l00441"></a>00441 <span class="comment">        conn[3] = this-&gt;node(8);</span>
<a name="l00442"></a>00442 <span class="comment"></span>
<a name="l00443"></a>00443 <span class="comment">        return;</span>
<a name="l00444"></a>00444 <span class="comment"></span>
<a name="l00445"></a>00445 <span class="comment"></span>
<a name="l00446"></a>00446 <span class="comment">        default:</span>
<a name="l00447"></a>00447 <span class="comment"></span>
<a name="l00448"></a>00448 <span class="comment">        libmesh_error();</span>
<a name="l00449"></a>00449 <span class="comment">      }</span>
<a name="l00450"></a>00450 <span class="comment">      */</span>
<a name="l00451"></a>00451       }
<a name="l00452"></a>00452 
<a name="l00453"></a>00453     <span class="keywordflow">default</span>:
<a name="l00454"></a>00454       libmesh_error();
<a name="l00455"></a>00455   }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   libmesh_error();
<a name="l00458"></a>00458 }
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tet10.php#ab170ae59edc19adc17497b6f1a9dfefe">Tet10::_second_order_vertex_child_number</a>[10] =
<a name="l00463"></a>00463 {
<a name="l00464"></a>00464   99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00465"></a>00465   0,1,0,0,1,2  <span class="comment">// Edges</span>
<a name="l00466"></a>00466 };
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tet10.php#a665a827ace0a6596d4ae794eb39580e1">Tet10::_second_order_vertex_child_index</a>[10] =
<a name="l00471"></a>00471 {
<a name="l00472"></a>00472   99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00473"></a>00473   1,2,2,3,3,3  <span class="comment">// Edges</span>
<a name="l00474"></a>00474 };
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00479"></a><a class="code" href="classlibMesh_1_1Tet10.php#ad2ade47eac03d6a37c61ba35d4ea4603">00479</a> <a class="code" href="classlibMesh_1_1Tet10.php#ad2ade47eac03d6a37c61ba35d4ea4603">Tet10::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00480"></a>00480 <span class="keyword"></span>{
<a name="l00481"></a>00481   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a3988ad52509d6addfe5496772e8bd6ca">n_vertices</a>());
<a name="l00482"></a>00482   libmesh_assert (n &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#af82c65de4724c7d97847b675483f3822">n_nodes</a>());
<a name="l00483"></a>00483   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00484"></a>00484     (<a class="code" href="classlibMesh_1_1Tet10.php#ab170ae59edc19adc17497b6f1a9dfefe">_second_order_vertex_child_number</a>[n],
<a name="l00485"></a>00485      <a class="code" href="classlibMesh_1_1Tet10.php#a665a827ace0a6596d4ae794eb39580e1">_second_order_vertex_child_index</a>[n]);
<a name="l00486"></a>00486 }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a><a class="code" href="classlibMesh_1_1Tet10.php#a162d65d7fd1dfefc9d897584f25fe790">00490</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tet10.php#a162d65d7fd1dfefc9d897584f25fe790">Tet10::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00491"></a>00491                                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00492"></a>00492 <span class="keyword"></span>{ 
<a name="l00493"></a>00493   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a3988ad52509d6addfe5496772e8bd6ca">n_vertices</a>());
<a name="l00494"></a>00494   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#af82c65de4724c7d97847b675483f3822">n_nodes</a>());
<a name="l00495"></a>00495   libmesh_assert (v &lt; 2);
<a name="l00496"></a>00496   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Tet10.php#adad1d79bc54bd81d1c73414c3a034bdc">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a3988ad52509d6addfe5496772e8bd6ca">n_vertices</a>()][v]; 
<a name="l00497"></a>00497 }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a>00501 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tet10.php#adad1d79bc54bd81d1c73414c3a034bdc">Tet10::_second_order_adjacent_vertices</a>[6][2] = 
<a name="l00502"></a>00502 {
<a name="l00503"></a>00503   {0, 1}, <span class="comment">// vertices adjacent to node 4 </span>
<a name="l00504"></a>00504   {1, 2}, <span class="comment">// vertices adjacent to node 5 </span>
<a name="l00505"></a>00505   {0, 2}, <span class="comment">// vertices adjacent to node 6 </span>
<a name="l00506"></a>00506   {0, 3}, <span class="comment">// vertices adjacent to node 7 </span>
<a name="l00507"></a>00507   {1, 3}, <span class="comment">// vertices adjacent to node 8 </span>
<a name="l00508"></a>00508   {2, 3}  <span class="comment">// vertices adjacent to node 9 </span>
<a name="l00509"></a>00509 };
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00516"></a>00516 <span class="preprocessor"></span>
<a name="l00517"></a>00517 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Tet10.php#a8a35c91cde6fddc1e1dbe531d47607dc">Tet10::_embedding_matrix</a>[8][10][10] =
<a name="l00518"></a>00518 {
<a name="l00519"></a>00519   <span class="comment">// embedding matrix for child 0</span>
<a name="l00520"></a>00520   {
<a name="l00521"></a>00521     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00522"></a>00522     {    1.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00523"></a>00523     {    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00524"></a>00524     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00525"></a>00525     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.}, <span class="comment">// 3</span>
<a name="l00526"></a>00526     { 0.375,-0.125,    0.,    0.,  0.75,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00527"></a>00527     {    0.,-0.125,-0.125,    0.,   0.5,  0.25,   0.5,    0.,    0.,    0.}, <span class="comment">// 5</span>
<a name="l00528"></a>00528     { 0.375,    0.,-0.125,    0.,    0.,    0.,  0.75,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00529"></a>00529     { 0.375,    0.,    0.,-0.125,    0.,    0.,    0.,  0.75,    0.,    0.}, <span class="comment">// 7</span>
<a name="l00530"></a>00530     {    0.,-0.125,    0.,-0.125,   0.5,    0.,    0.,   0.5,  0.25,    0.}, <span class="comment">// 8</span>
<a name="l00531"></a>00531     {    0.,    0.,-0.125,-0.125,    0.,    0.,   0.5,   0.5,    0.,  0.25}  <span class="comment">// 9</span>
<a name="l00532"></a>00532   },
<a name="l00533"></a>00533 
<a name="l00534"></a>00534   <span class="comment">// embedding matrix for child 1</span>
<a name="l00535"></a>00535   {
<a name="l00536"></a>00536     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00537"></a>00537     {    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00538"></a>00538     {    0.,    1.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00539"></a>00539     {    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00540"></a>00540     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 3</span>
<a name="l00541"></a>00541     {-0.125, 0.375,    0.,    0.,  0.75,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00542"></a>00542     {    0., 0.375,-0.125,    0.,    0.,  0.75,    0.,    0.,    0.,    0.}, <span class="comment">// 5</span>
<a name="l00543"></a>00543     {-0.125,    0.,-0.125,    0.,   0.5,   0.5,  0.25,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00544"></a>00544     {-0.125,    0.,    0.,-0.125,   0.5,    0.,    0.,  0.25,   0.5,    0.}, <span class="comment">// 7</span>
<a name="l00545"></a>00545     {    0., 0.375,    0.,-0.125,    0.,    0.,    0.,    0.,  0.75,    0.}, <span class="comment">// 8</span>
<a name="l00546"></a>00546     {    0.,    0.,-0.125,-0.125,    0.,   0.5,    0.,    0.,   0.5,  0.25}  <span class="comment">// 9</span>
<a name="l00547"></a>00547   },
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="comment">// embedding matrix for child 2</span>
<a name="l00550"></a>00550   {
<a name="l00551"></a>00551     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00552"></a>00552     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00553"></a>00553     {    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00554"></a>00554     {    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00555"></a>00555     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.}, <span class="comment">// 3</span>
<a name="l00556"></a>00556     {-0.125,-0.125,    0.,    0.,  0.25,   0.5,   0.5,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00557"></a>00557     {    0.,-0.125, 0.375,    0.,    0.,  0.75,    0.,    0.,    0.,    0.}, <span class="comment">// 5</span>
<a name="l00558"></a>00558     {-0.125,    0., 0.375,    0.,    0.,    0.,  0.75,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00559"></a>00559     {-0.125,    0.,    0.,-0.125,    0.,    0.,   0.5,  0.25,    0.,   0.5}, <span class="comment">// 7</span>
<a name="l00560"></a>00560     {    0.,-0.125,    0.,-0.125,    0.,   0.5,    0.,    0.,  0.25,   0.5}, <span class="comment">// 8</span>
<a name="l00561"></a>00561     {    0.,    0., 0.375,-0.125,    0.,    0.,    0.,    0.,    0.,  0.75}  <span class="comment">// 9</span>
<a name="l00562"></a>00562   },
<a name="l00563"></a>00563 
<a name="l00564"></a>00564   <span class="comment">// embedding matrix for child 3</span>
<a name="l00565"></a>00565   {
<a name="l00566"></a>00566     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00567"></a>00567     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00568"></a>00568     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 1</span>
<a name="l00569"></a>00569     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.}, <span class="comment">// 2</span>
<a name="l00570"></a>00570     {    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 3</span>
<a name="l00571"></a>00571     {-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5,    0.}, <span class="comment">// 4</span>
<a name="l00572"></a>00572     {    0.,-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5}, <span class="comment">// 5</span>
<a name="l00573"></a>00573     {-0.125,    0.,-0.125,    0.,    0.,    0.,  0.25,   0.5,    0.,   0.5}, <span class="comment">// 6</span>
<a name="l00574"></a>00574     {-0.125,    0.,    0., 0.375,    0.,    0.,    0.,  0.75,    0.,    0.}, <span class="comment">// 7</span>
<a name="l00575"></a>00575     {    0.,-0.125,    0., 0.375,    0.,    0.,    0.,    0.,  0.75,    0.}, <span class="comment">// 8</span>
<a name="l00576"></a>00576     {    0.,    0.,-0.125, 0.375,    0.,    0.,    0.,    0.,    0.,  0.75}  <span class="comment">// 9</span>
<a name="l00577"></a>00577   },
<a name="l00578"></a>00578 
<a name="l00579"></a>00579   <span class="comment">// embedding matrix for child 4</span>
<a name="l00580"></a>00580   {
<a name="l00581"></a>00581     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00582"></a>00582     {    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00583"></a>00583     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 1</span>
<a name="l00584"></a>00584     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00585"></a>00585     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.}, <span class="comment">// 3</span>
<a name="l00586"></a>00586     {-0.125,    0.,    0.,-0.125,   0.5,    0.,    0.,  0.25,   0.5,    0.}, <span class="comment">// 4</span>
<a name="l00587"></a>00587     {-0.125,-0.125,-0.125,-0.125,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25}, <span class="comment">// 5</span>
<a name="l00588"></a>00588     {    0.,-0.125,-0.125,    0.,   0.5,  0.25,   0.5,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00589"></a>00589     {    0.,-0.125,    0.,-0.125,   0.5,    0.,    0.,   0.5,  0.25,    0.}, <span class="comment">// 7</span>
<a name="l00590"></a>00590     {-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5,    0.}, <span class="comment">// 8</span>
<a name="l00591"></a>00591     {    0.,    0.,-0.125,-0.125,    0.,    0.,   0.5,   0.5,    0.,  0.25}  <span class="comment">// 9</span>
<a name="l00592"></a>00592   },
<a name="l00593"></a>00593 
<a name="l00594"></a>00594   <span class="comment">// embedding matrix for child 5</span>
<a name="l00595"></a>00595   {
<a name="l00596"></a>00596     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00597"></a>00597     {    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00598"></a>00598     {    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00599"></a>00599     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 2</span>
<a name="l00600"></a>00600     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 3</span>
<a name="l00601"></a>00601     {-0.125,    0.,-0.125,    0.,   0.5,   0.5,  0.25,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00602"></a>00602     {-0.125,-0.125,    0.,    0.,  0.25,   0.5,   0.5,    0.,    0.,    0.}, <span class="comment">// 5</span>
<a name="l00603"></a>00603     {    0.,-0.125,-0.125,    0.,   0.5,  0.25,   0.5,    0.,    0.,    0.}, <span class="comment">// 6</span>
<a name="l00604"></a>00604     {-0.125,    0.,    0.,-0.125,   0.5,    0.,    0.,  0.25,   0.5,    0.}, <span class="comment">// 7</span>
<a name="l00605"></a>00605     {    0.,    0.,-0.125,-0.125,    0.,   0.5,    0.,    0.,   0.5,  0.25}, <span class="comment">// 8</span>
<a name="l00606"></a>00606     {-0.125,-0.125,-0.125,-0.125,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25}  <span class="comment">// 9</span>
<a name="l00607"></a>00607   },
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   <span class="comment">// embedding matrix for child 6</span>
<a name="l00610"></a>00610   {
<a name="l00611"></a>00611     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00612"></a>00612     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00613"></a>00613     {    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.,    0.}, <span class="comment">// 1</span>
<a name="l00614"></a>00614     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.}, <span class="comment">// 2</span>
<a name="l00615"></a>00615     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 3</span>
<a name="l00616"></a>00616     {-0.125,-0.125,    0.,    0.,  0.25,   0.5,   0.5,    0.,    0.,    0.}, <span class="comment">// 4</span>
<a name="l00617"></a>00617     {    0.,-0.125,    0.,-0.125,    0.,   0.5,    0.,    0.,  0.25,   0.5}, <span class="comment">// 5</span>
<a name="l00618"></a>00618     {-0.125,    0.,    0.,-0.125,    0.,    0.,   0.5,  0.25,    0.,   0.5}, <span class="comment">// 6</span>
<a name="l00619"></a>00619     {-0.125,-0.125,-0.125,-0.125,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25}, <span class="comment">// 7</span>
<a name="l00620"></a>00620     {    0.,    0.,-0.125,-0.125,    0.,   0.5,    0.,    0.,   0.5,  0.25}, <span class="comment">// 8</span>
<a name="l00621"></a>00621     {    0.,-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5}  <span class="comment">// 9</span>
<a name="l00622"></a>00622   },
<a name="l00623"></a>00623 
<a name="l00624"></a>00624   <span class="comment">// embedding matrix for child 7</span>
<a name="l00625"></a>00625   {
<a name="l00626"></a>00626     <span class="comment">//    0      1      2      3      4      5      6      7      8      9</span>
<a name="l00627"></a>00627     {    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.,    0.}, <span class="comment">// 0</span>
<a name="l00628"></a>00628     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.}, <span class="comment">// 1</span>
<a name="l00629"></a>00629     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.}, <span class="comment">// 2</span>
<a name="l00630"></a>00630     {    0.,    0.,    0.,    0.,    0.,    0.,    0.,    1.,    0.,    0.}, <span class="comment">// 3</span>
<a name="l00631"></a>00631     {-0.125,-0.125,-0.125,-0.125,  0.25,  0.25,  0.25,  0.25,  0.25,  0.25}, <span class="comment">// 4</span>
<a name="l00632"></a>00632     {    0.,-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5}, <span class="comment">// 5</span>
<a name="l00633"></a>00633     {-0.125,    0.,    0.,-0.125,    0.,    0.,   0.5,  0.25,    0.,   0.5}, <span class="comment">// 6</span>
<a name="l00634"></a>00634     {    0.,    0.,-0.125,-0.125,    0.,    0.,   0.5,   0.5,    0.,  0.25}, <span class="comment">// 7</span>
<a name="l00635"></a>00635     {-0.125,-0.125,    0.,    0.,  0.25,    0.,    0.,   0.5,   0.5,    0.}, <span class="comment">// 8</span>
<a name="l00636"></a>00636     {-0.125,    0.,-0.125,    0.,    0.,    0.,  0.25,   0.5,    0.,   0.5}  <span class="comment">// 9</span>
<a name="l00637"></a>00637   }
<a name="l00638"></a>00638 };
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 
<a name="l00645"></a><a class="code" href="classlibMesh_1_1Tet10.php#a6aa0564792464e9a5a2e6c65dd4cf8ad">00645</a> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Tet10.php#a6aa0564792464e9a5a2e6c65dd4cf8ad">Tet10::embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00646"></a>00646                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00647"></a>00647                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00648"></a>00648 <span class="keyword"></span>{
<a name="l00649"></a>00649   <span class="comment">// Check for uninitialized diagonal selection</span>
<a name="l00650"></a>00650   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a85e066d153f92af2bbd6385f18c04c3d">_diagonal_selection</a>==<a class="code" href="classlibMesh_1_1Tet10.php#a75f9b4a891f41cfa2afa08d2345b00e3af43d616d5f9468552a40c6fb593ad8a0">INVALID_DIAG</a>)
<a name="l00651"></a>00651     {
<a name="l00652"></a>00652       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> diag_01_23 = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)+this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)).size_sq();
<a name="l00653"></a>00653       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> diag_02_13 = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)+this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)).size_sq();
<a name="l00654"></a>00654       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> diag_03_12 = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)+this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)).size_sq();
<a name="l00655"></a>00655 
<a name="l00656"></a>00656       this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a85e066d153f92af2bbd6385f18c04c3d">_diagonal_selection</a>=<a class="code" href="classlibMesh_1_1Tet10.php#a75f9b4a891f41cfa2afa08d2345b00e3afbc635c297e3aa6eff614f21afac615f">DIAG_02_13</a>;
<a name="l00657"></a>00657 
<a name="l00658"></a>00658       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_02_13 || diag_03_12 &lt; diag_02_13)
<a name="l00659"></a>00659       {
<a name="l00660"></a>00660         <span class="keywordflow">if</span> (diag_01_23 &lt; diag_03_12)
<a name="l00661"></a>00661           this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a85e066d153f92af2bbd6385f18c04c3d">_diagonal_selection</a>=<a class="code" href="classlibMesh_1_1Tet10.php#a75f9b4a891f41cfa2afa08d2345b00e3a941182a40a840ad04d2998ebaf77c72d">DIAG_01_23</a>;
<a name="l00662"></a>00662 
<a name="l00663"></a>00663         <span class="keywordflow">else</span>
<a name="l00664"></a>00664           this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a85e066d153f92af2bbd6385f18c04c3d">_diagonal_selection</a>=<a class="code" href="classlibMesh_1_1Tet10.php#a75f9b4a891f41cfa2afa08d2345b00e3a3755e8a8462d3a946943760fd46e36c1">DIAG_03_12</a>;
<a name="l00665"></a>00665       }
<a name="l00666"></a>00666     }
<a name="l00667"></a>00667 
<a name="l00668"></a>00668   <span class="comment">// Permuted j and k indices</span>
<a name="l00669"></a>00669   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00670"></a>00670     jp=j,
<a name="l00671"></a>00671     kp=k;
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="keywordflow">if</span> ((i&gt;3) &amp;&amp; (this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a85e066d153f92af2bbd6385f18c04c3d">_diagonal_selection</a>!=<a class="code" href="classlibMesh_1_1Tet10.php#a75f9b4a891f41cfa2afa08d2345b00e3afbc635c297e3aa6eff614f21afac615f">DIAG_02_13</a>))
<a name="l00674"></a>00674     {
<a name="l00675"></a>00675       <span class="comment">// Permute j, k</span>
<a name="l00676"></a>00676       <span class="keywordflow">if</span> (jp&lt;3) jp=(jp+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a85e066d153f92af2bbd6385f18c04c3d">_diagonal_selection</a>))%3;
<a name="l00677"></a>00677       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (jp&gt;3) jp=(jp-1+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a85e066d153f92af2bbd6385f18c04c3d">_diagonal_selection</a>))%3+1+3*((jp-1)/3);
<a name="l00678"></a>00678       <span class="keywordflow">if</span> (kp&lt;3) kp=(kp+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a85e066d153f92af2bbd6385f18c04c3d">_diagonal_selection</a>))%3;
<a name="l00679"></a>00679       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (kp&gt;3) kp=(kp-1+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a85e066d153f92af2bbd6385f18c04c3d">_diagonal_selection</a>))%3+1+3*((kp-1)/3);
<a name="l00680"></a>00680     }
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   <span class="comment">// Call embedding matrx with permuted indices</span>
<a name="l00683"></a>00683   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Tet10.php#a8a35c91cde6fddc1e1dbe531d47607dc">_embedding_matrix</a>[i][jp][kp];
<a name="l00684"></a>00684 }
<a name="l00685"></a>00685 
<a name="l00686"></a>00686 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00687"></a>00687 <span class="preprocessor"></span>
<a name="l00688"></a>00688 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
