<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_tet4.C</div>  </div>
</div>
<div class="contents">
<a href="cell__tet4_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_tet4.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet4_8h.php">cell_tet4.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge2_8h.php">edge_edge2.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="face__tri3_8h.php">face_tri3.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// Tet4 class static member initializations</span>
<a name="l00036"></a>00036 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tet4.php#a901b2cbe553f000445fa49db486d737a">Tet4::side_nodes_map</a>[4][3] =
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   {0, 2, 1}, <span class="comment">// Side 0</span>
<a name="l00039"></a>00039   {0, 1, 3}, <span class="comment">// Side 1</span>
<a name="l00040"></a>00040   {1, 2, 3}, <span class="comment">// Side 2</span>
<a name="l00041"></a>00041   {2, 0, 3}  <span class="comment">// Side 3</span>
<a name="l00042"></a>00042 };
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tet4.php#adb4b6e1b0cc9b7d78729bdfb23c901c3">Tet4::edge_nodes_map</a>[6][2] =
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   {0, 1}, <span class="comment">// Side 0</span>
<a name="l00047"></a>00047   {1, 2}, <span class="comment">// Side 1</span>
<a name="l00048"></a>00048   {0, 2}, <span class="comment">// Side 2</span>
<a name="l00049"></a>00049   {0, 3}, <span class="comment">// Side 3</span>
<a name="l00050"></a>00050   {1, 3}, <span class="comment">// Side 4</span>
<a name="l00051"></a>00051   {2, 3}  <span class="comment">// Side 5</span>
<a name="l00052"></a>00052 };
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// Tet4 class member functions</span>
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1Tet4.php#abe038adad327c6d31522831154f72fa6">00058</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet4.php#abe038adad327c6d31522831154f72fa6">Tet4::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00059"></a>00059 <span class="keyword"></span>{
<a name="l00060"></a>00060   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1Tet4.php#aa2a9a574735e852c5d07af22520a8b4a">00063</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet4.php#aa2a9a574735e852c5d07af22520a8b4a">Tet4::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1Tet4.php#a129a26a42323f4f33867791da4d9e094">00068</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet4.php#a129a26a42323f4f33867791da4d9e094">Tet4::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00069"></a>00069 <span class="keyword"></span>{
<a name="l00070"></a>00070   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1Tet4.php#a8afa05417404454dce39f2da69bf8ad2">00073</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet4.php#a8afa05417404454dce39f2da69bf8ad2">Tet4::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00074"></a>00074                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00075"></a>00075 <span class="keyword"></span>{
<a name="l00076"></a>00076   libmesh_assert(e &lt; <a class="code" href="classlibMesh_1_1Tet.php#a4fdc7c7435603240aaa5fab783759eb0">n_edges</a>());
<a name="l00077"></a>00077   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 2; ++i)
<a name="l00078"></a>00078     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Tet4.php#adb4b6e1b0cc9b7d78729bdfb23c901c3">edge_nodes_map</a>[e][i] == n)
<a name="l00079"></a>00079       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00080"></a>00080   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1Tet4.php#a2398ce2a07345d13cf212bb5fd276b08">00083</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet4.php#a2398ce2a07345d13cf212bb5fd276b08">Tet4::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00084"></a>00084                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00085"></a>00085 <span class="keyword"></span>{
<a name="l00086"></a>00086   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1Tet.php#a273874aa6b467759119e2a1cd5d7436b">n_sides</a>());
<a name="l00087"></a>00087   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00088"></a>00088     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Tet4.php#a901b2cbe553f000445fa49db486d737a">side_nodes_map</a>[s][i] == n)
<a name="l00089"></a>00089       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00090"></a>00090   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00091"></a>00091 }
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1Tet4.php#a9a0ea84e3a0cf6bc6afe59d26748b3cf">00093</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Tet4.php#a9a0ea84e3a0cf6bc6afe59d26748b3cf">Tet4::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00094"></a>00094                                 <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00095"></a>00095 <span class="keyword"></span>{
<a name="l00096"></a>00096   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a273874aa6b467759119e2a1cd5d7436b">n_sides</a>());
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">if</span> (proxy)
<a name="l00099"></a>00099     {
<a name="l00100"></a>00100       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Tri3,Tet4&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00101"></a>00101       <span class="keywordflow">return</span> ap;
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordflow">else</span>
<a name="l00105"></a>00105     {
<a name="l00106"></a>00106       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108       <span class="keywordflow">switch</span> (i)
<a name="l00109"></a>00109         {
<a name="l00110"></a>00110         <span class="keywordflow">case</span> 0:
<a name="l00111"></a>00111           {
<a name="l00112"></a>00112             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00113"></a>00113             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00114"></a>00114             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116             <span class="keywordflow">return</span> face;
<a name="l00117"></a>00117           }
<a name="l00118"></a>00118         <span class="keywordflow">case</span> 1:
<a name="l00119"></a>00119           {
<a name="l00120"></a>00120             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00121"></a>00121             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00122"></a>00122             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124             <span class="keywordflow">return</span> face;
<a name="l00125"></a>00125           }
<a name="l00126"></a>00126         <span class="keywordflow">case</span> 2:
<a name="l00127"></a>00127           {
<a name="l00128"></a>00128             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00129"></a>00129             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00130"></a>00130             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132             <span class="keywordflow">return</span> face;
<a name="l00133"></a>00133           }
<a name="l00134"></a>00134         <span class="keywordflow">case</span> 3:
<a name="l00135"></a>00135           {
<a name="l00136"></a>00136             face-&gt;set_node(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00137"></a>00137             face-&gt;set_node(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00138"></a>00138             face-&gt;set_node(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00139"></a>00139         
<a name="l00140"></a>00140             <span class="keywordflow">return</span> face;
<a name="l00141"></a>00141           }
<a name="l00142"></a>00142         <span class="keywordflow">default</span>:
<a name="l00143"></a>00143           {
<a name="l00144"></a>00144             libmesh_error();
<a name="l00145"></a>00145           }
<a name="l00146"></a>00146         }
<a name="l00147"></a>00147     }
<a name="l00148"></a>00148   
<a name="l00149"></a>00149   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00150"></a>00150   libmesh_error();  
<a name="l00151"></a>00151   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a><a class="code" href="classlibMesh_1_1Tet4.php#a8d5a61d3327a9819cfd192e8368c3ef6">00155</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Tet4.php#a8d5a61d3327a9819cfd192e8368c3ef6">Tet4::build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00156"></a>00156 <span class="keyword"></span>{
<a name="l00157"></a>00157   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a4fdc7c7435603240aaa5fab783759eb0">n_edges</a>());
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SideEdge.php">SideEdge&lt;Edge2,Tet4&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="classlibMesh_1_1Tet4.php#af1bc7b5f0dab3531630e875688a8d0f2">00163</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tet4.php#af1bc7b5f0dab3531630e875688a8d0f2">Tet4::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00164"></a>00164                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00165"></a>00165                         std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00166"></a>00166 <span class="keyword"></span>{
<a name="l00167"></a>00167   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#a66f802040c258daed713a2c6e079de49">_nodes</a> != NULL);
<a name="l00168"></a>00168   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#abf020224798d87c48c992fe59db0f8ad">n_sub_elem</a>());
<a name="l00169"></a>00169   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="keywordflow">switch</span> (iop)
<a name="l00173"></a>00173     {
<a name="l00174"></a>00174     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00175"></a>00175       {
<a name="l00176"></a>00176         conn.resize(8);
<a name="l00177"></a>00177         conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00178"></a>00178         conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00179"></a>00179         conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00180"></a>00180         conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00181"></a>00181         conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00182"></a>00182         conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00183"></a>00183         conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00184"></a>00184         conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00185"></a>00185         <span class="keywordflow">return</span>;
<a name="l00186"></a>00186       }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00189"></a>00189       {
<a name="l00190"></a>00190         conn.resize(4);
<a name="l00191"></a>00191         conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0);
<a name="l00192"></a>00192         conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1);
<a name="l00193"></a>00193         conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2);
<a name="l00194"></a>00194         conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3);
<a name="l00195"></a>00195         <span class="keywordflow">return</span>;
<a name="l00196"></a>00196       }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198     <span class="keywordflow">default</span>:
<a name="l00199"></a>00199       libmesh_error();
<a name="l00200"></a>00200     }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   libmesh_error();
<a name="l00203"></a>00203 }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00208"></a>00208 <span class="preprocessor"></span>
<a name="l00209"></a>00209 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Tet4.php#a6d4c66410574ad13b8a982082eb1eff6">Tet4::_embedding_matrix</a>[8][4][4] =
<a name="l00210"></a>00210   {
<a name="l00211"></a>00211     <span class="comment">// embedding matrix for child 0</span>
<a name="l00212"></a>00212     {
<a name="l00213"></a>00213       <span class="comment">// 0    1    2    3  </span>
<a name="l00214"></a>00214       {1.0, 0.0, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00215"></a>00215       {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00216"></a>00216       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 2</span>
<a name="l00217"></a>00217       {0.5, 0.0, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00218"></a>00218     },
<a name="l00219"></a>00219   
<a name="l00220"></a>00220     <span class="comment">// embedding matrix for child 1</span>
<a name="l00221"></a>00221     {
<a name="l00222"></a>00222       <span class="comment">// 0    1    2    3  </span>
<a name="l00223"></a>00223       {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00224"></a>00224       {0.0, 1.0, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00225"></a>00225       {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 2</span>
<a name="l00226"></a>00226       {0.0, 0.5, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00227"></a>00227     },
<a name="l00228"></a>00228   
<a name="l00229"></a>00229     <span class="comment">// embedding matrix for child 2</span>
<a name="l00230"></a>00230     {
<a name="l00231"></a>00231       <span class="comment">// 0    1    2    3  </span>
<a name="l00232"></a>00232       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 0</span>
<a name="l00233"></a>00233       {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 1</span>
<a name="l00234"></a>00234       {0.0, 0.0, 1.0, 0.0}, <span class="comment">// 2</span>
<a name="l00235"></a>00235       {0.0, 0.0, 0.5, 0.5}  <span class="comment">// 3</span>
<a name="l00236"></a>00236     },
<a name="l00237"></a>00237   
<a name="l00238"></a>00238     <span class="comment">// embedding matrix for child 3</span>
<a name="l00239"></a>00239     {
<a name="l00240"></a>00240       <span class="comment">// 0    1    2    3  </span>
<a name="l00241"></a>00241       {0.5, 0.0, 0.0, 0.5}, <span class="comment">// 0</span>
<a name="l00242"></a>00242       {0.0, 0.5, 0.0, 0.5}, <span class="comment">// 1</span>
<a name="l00243"></a>00243       {0.0, 0.0, 0.5, 0.5}, <span class="comment">// 2</span>
<a name="l00244"></a>00244       {0.0, 0.0, 0.0, 1.0}  <span class="comment">// 3</span>
<a name="l00245"></a>00245     },
<a name="l00246"></a>00246   
<a name="l00247"></a>00247     <span class="comment">// embedding matrix for child 4</span>
<a name="l00248"></a>00248     {
<a name="l00249"></a>00249       <span class="comment">// 0    1    2    3  </span>
<a name="l00250"></a>00250       {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00251"></a>00251       {0.0, 0.5, 0.0, 0.5}, <span class="comment">// 1</span>
<a name="l00252"></a>00252       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 2</span>
<a name="l00253"></a>00253       {0.5, 0.0, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00254"></a>00254     },
<a name="l00255"></a>00255   
<a name="l00256"></a>00256     <span class="comment">// embedding matrix for child 5</span>
<a name="l00257"></a>00257     {
<a name="l00258"></a>00258       <span class="comment">// 0    1    2    3  </span>
<a name="l00259"></a>00259       {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00260"></a>00260       {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 1</span>
<a name="l00261"></a>00261       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 2</span>
<a name="l00262"></a>00262       {0.0, 0.5, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00263"></a>00263     },
<a name="l00264"></a>00264   
<a name="l00265"></a>00265     <span class="comment">// embedding matrix for child 6</span>
<a name="l00266"></a>00266     {
<a name="l00267"></a>00267       <span class="comment">// 0    1    2    3  </span>
<a name="l00268"></a>00268       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 0</span>
<a name="l00269"></a>00269       {0.0, 0.5, 0.5, 0.0}, <span class="comment">// 1</span>
<a name="l00270"></a>00270       {0.0, 0.0, 0.5, 0.5}, <span class="comment">// 2</span>
<a name="l00271"></a>00271       {0.0, 0.5, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00272"></a>00272     },
<a name="l00273"></a>00273   
<a name="l00274"></a>00274     <span class="comment">// embedding matrix for child 7</span>
<a name="l00275"></a>00275     {
<a name="l00276"></a>00276       <span class="comment">// 0    1    2    3  </span>
<a name="l00277"></a>00277       {0.5, 0.0, 0.5, 0.0}, <span class="comment">// 0</span>
<a name="l00278"></a>00278       {0.0, 0.5, 0.0, 0.5}, <span class="comment">// 1</span>
<a name="l00279"></a>00279       {0.0, 0.0, 0.5, 0.5}, <span class="comment">// 2</span>
<a name="l00280"></a>00280       {0.5, 0.0, 0.0, 0.5}  <span class="comment">// 3</span>
<a name="l00281"></a>00281     }
<a name="l00282"></a>00282   };
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00285"></a>00285 <span class="preprocessor"></span>
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a><a class="code" href="classlibMesh_1_1Tet4.php#a11f47559c504ce1a0407408464720ebc">00290</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Tet4.php#a11f47559c504ce1a0407408464720ebc">Tet4::volume</a> ()<span class="keyword"> const</span>
<a name="l00291"></a>00291 <span class="keyword"></span>{
<a name="l00292"></a>00292   <span class="comment">// The volume of a tetrahedron is 1/6 the box product formed</span>
<a name="l00293"></a>00293   <span class="comment">// by its base and apex vectors</span>
<a name="l00294"></a>00294   <a class="code" href="classlibMesh_1_1Point.php">Point</a> a ( *this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3) - *this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0) );
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="comment">// b is the vector pointing from 0 to 1</span>
<a name="l00297"></a>00297   <a class="code" href="classlibMesh_1_1Point.php">Point</a> b ( *this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1) - *this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0) );
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="comment">// c is the vector pointing from 0 to 2</span>
<a name="l00300"></a>00300   <a class="code" href="classlibMesh_1_1Point.php">Point</a> c ( *this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2) - *this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0) );
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="keywordflow">return</span> (1.0 / 6.0) * (a * (b.<a class="code" href="classlibMesh_1_1TypeVector.php#a2aec9a10f796ec4cd55c5d2a62885305">cross</a>(c)));
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a><a class="code" href="classlibMesh_1_1Tet4.php#a6b51bd6f4b717f56cbbdb91c67ea4687">00308</a> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1Tet4.php#a6b51bd6f4b717f56cbbdb91c67ea4687">Tet4::min_and_max_angle</a>()<span class="keyword"> const</span>
<a name="l00309"></a>00309 <span class="keyword"></span>{
<a name="l00310"></a>00310   <a class="code" href="classlibMesh_1_1Point.php">Point</a> n[4];
<a name="l00311"></a>00311   
<a name="l00312"></a>00312   <span class="comment">// Compute the outward normal vectors on each face</span>
<a name="l00313"></a>00313   n[0] = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)).cross(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0));
<a name="l00314"></a>00314   n[1] = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)).cross(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0));
<a name="l00315"></a>00315   n[2] = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)).cross(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1));
<a name="l00316"></a>00316   n[3] = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)).cross(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2));
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dihedral_angles[6]; <span class="comment">// 01, 02, 03, 12, 13, 23</span>
<a name="l00319"></a>00319 
<a name="l00320"></a>00320   <span class="comment">// Compute dihedral angles</span>
<a name="l00321"></a>00321   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0,i=0; i&lt;4; ++i)
<a name="l00322"></a>00322     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;4; ++j,k+=1)
<a name="l00323"></a>00323       dihedral_angles[k] = std::acos(n[i]*n[j] / n[i].size() / n[j].<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>()); <span class="comment">// return value is between 0 and PI</span>
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="comment">// Return max/min dihedral angles</span>
<a name="l00326"></a>00326   <span class="keywordflow">return</span> std::make_pair(*std::min_element(dihedral_angles, dihedral_angles+6),
<a name="l00327"></a>00327                         *std::max_element(dihedral_angles, dihedral_angles+6));
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00334"></a><a class="code" href="classlibMesh_1_1Tet4.php#a49bcb607a8aad1af9c1d5d79d5ff516f">00334</a> <span class="preprocessor"></span><span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Tet4.php#a49bcb607a8aad1af9c1d5d79d5ff516f">Tet4::embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00335"></a>00335                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00336"></a>00336                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00337"></a>00337 <span class="keyword"></span>{
<a name="l00338"></a>00338   <span class="comment">// Check for uninitialized diagonal selection</span>
<a name="l00339"></a>00339   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a>==<a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a68fecbef6a62da615b4f20206b6f3f68">INVALID_DIAG</a>)
<a name="l00340"></a>00340     {
<a name="l00341"></a>00341       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> diag_01_23 = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)+this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)).size_sq();
<a name="l00342"></a>00342       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> diag_02_13 = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)+this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)).size_sq();
<a name="l00343"></a>00343       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> diag_03_12 = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)+this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)).size_sq();
<a name="l00344"></a>00344 
<a name="l00345"></a>00345       this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a>=<a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a089d959cb1f500bc2b5d91f91c0c4ffa">DIAG_02_13</a>;
<a name="l00346"></a>00346       
<a name="l00347"></a>00347       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_02_13 || diag_03_12 &lt; diag_02_13)
<a name="l00348"></a>00348         {
<a name="l00349"></a>00349           <span class="keywordflow">if</span> (diag_01_23 &lt; diag_03_12)
<a name="l00350"></a>00350             this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a>=<a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60af160f58ce391da30b08bea9767a81308">DIAG_01_23</a>;
<a name="l00351"></a>00351 
<a name="l00352"></a>00352           <span class="keywordflow">else</span>
<a name="l00353"></a>00353             this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a>=<a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a7142da6831b498b27f6f20c313cb1213">DIAG_03_12</a>;
<a name="l00354"></a>00354         }
<a name="l00355"></a>00355     }
<a name="l00356"></a>00356 
<a name="l00357"></a>00357   <span class="comment">// Permuted j and k indices</span>
<a name="l00358"></a>00358   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00359"></a>00359     jp=j,
<a name="l00360"></a>00360     kp=k;
<a name="l00361"></a>00361 
<a name="l00362"></a>00362   <span class="keywordflow">if</span> ((i&gt;3) &amp;&amp; (this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a>!=<a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a089d959cb1f500bc2b5d91f91c0c4ffa">DIAG_02_13</a>))
<a name="l00363"></a>00363     {
<a name="l00364"></a>00364       <span class="comment">// Permute j, k</span>
<a name="l00365"></a>00365       <span class="keywordflow">if</span> (jp!=3) jp=(jp+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a>))%3;
<a name="l00366"></a>00366       <span class="keywordflow">if</span> (kp!=3) kp=(kp+<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a>))%3;
<a name="l00367"></a>00367     }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="comment">// Call embedding matrx with permuted indices</span>
<a name="l00370"></a>00370   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#a6d4c66410574ad13b8a982082eb1eff6">_embedding_matrix</a>[i][jp][kp]; 
<a name="l00371"></a>00371 }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a><a class="code" href="classlibMesh_1_1Tet4.php#aa708ed89631371f332b28985d6911c3c">00375</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tet4.php#aa708ed89631371f332b28985d6911c3c">Tet4::select_diagonal</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60">Diagonal</a> diag)<span class="keyword"> const</span>
<a name="l00376"></a>00376 <span class="keyword"></span>{
<a name="l00377"></a>00377   libmesh_assert (<a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a>==<a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a68fecbef6a62da615b4f20206b6f3f68">INVALID_DIAG</a>);
<a name="l00378"></a>00378   <a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a> = diag;
<a name="l00379"></a>00379 }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00383"></a><a class="code" href="classlibMesh_1_1Tet4.php#af8c428992350dd73ec03e9c7b90a6106">00383</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tet4.php#af8c428992350dd73ec03e9c7b90a6106">Tet4::reselect_diagonal</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60">Diagonal</a> diag)
<a name="l00384"></a>00384 {
<a name="l00385"></a>00385   <span class="comment">/* Make sure that the element has just been refined.  */</span>
<a name="l00386"></a>00386   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>!=NULL);
<a name="l00387"></a>00387   libmesh_assert (<a class="code" href="classlibMesh_1_1Tet.php#ac8cc3fd8290d58ea4517eff51eea3ddb">n_children</a>()==8);
<a name="l00388"></a>00388   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[0]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()==<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">JUST_REFINED</a>);
<a name="l00389"></a>00389   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[1]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()==<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">JUST_REFINED</a>);
<a name="l00390"></a>00390   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[2]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()==<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">JUST_REFINED</a>);
<a name="l00391"></a>00391   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[3]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()==<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">JUST_REFINED</a>);
<a name="l00392"></a>00392   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[4]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()==<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">JUST_REFINED</a>);
<a name="l00393"></a>00393   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[5]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()==<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">JUST_REFINED</a>);
<a name="l00394"></a>00394   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[6]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()==<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">JUST_REFINED</a>);
<a name="l00395"></a>00395   libmesh_assert (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[7]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()==<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">JUST_REFINED</a>);
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="comment">/* Check whether anything has to be changed.  */</span>
<a name="l00398"></a>00398   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a>!=diag)
<a name="l00399"></a>00399     {
<a name="l00400"></a>00400       <span class="comment">/* Set new diagonal selection.  */</span>
<a name="l00401"></a>00401       <a class="code" href="classlibMesh_1_1Tet4.php#a1e78cbeb3e2640bee1529323801bd097">_diagonal_selection</a> = diag;
<a name="l00402"></a>00402 
<a name="l00403"></a>00403       <span class="comment">/* The first four children do not have to be changed.  For the</span>
<a name="l00404"></a>00404 <span class="comment">         others, only the nodes have to be changed.  Note that we have</span>
<a name="l00405"></a>00405 <span class="comment">         to keep track of the nodes ourselves since there is no \p</span>
<a name="l00406"></a>00406 <span class="comment">         MeshRefinement object with a valid \p _new_nodes_map</span>
<a name="l00407"></a>00407 <span class="comment">         available.  */</span>
<a name="l00408"></a>00408       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=4; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#ac8cc3fd8290d58ea4517eff51eea3ddb">n_children</a>(); c++)
<a name="l00409"></a>00409         {
<a name="l00410"></a>00410           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l00411"></a>00411           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); nc++)
<a name="l00412"></a>00412             {
<a name="l00413"></a>00413               <span class="comment">/* Unassign the current node.  */</span>
<a name="l00414"></a>00414               child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(nc) = NULL;
<a name="l00415"></a>00415 
<a name="l00416"></a>00416               <span class="comment">/* We have to find the correct new node now.  We know</span>
<a name="l00417"></a>00417 <span class="comment">                 that it exists somewhere.  We make use of the fact</span>
<a name="l00418"></a>00418 <span class="comment">                 that the embedding matrix for these children consists</span>
<a name="l00419"></a>00419 <span class="comment">                 of entries 0.0 and 0.5 only.  Also, we make use of</span>
<a name="l00420"></a>00420 <span class="comment">                 the properties of the embedding matrix for the first</span>
<a name="l00421"></a>00421 <span class="comment">                 (unchanged) four children, which allow us to use a</span>
<a name="l00422"></a>00422 <span class="comment">                 simple mechanism to find the required node.  */</span>
<a name="l00423"></a>00423               
<a name="l00424"></a>00424               
<a name="l00425"></a>00425               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_05_in_embedding_matrix = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00426"></a>00426               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#ad0848dff77d2e89d87b5f047015a99f5">n_nodes</a>(); n++)
<a name="l00427"></a>00427                 {
<a name="l00428"></a>00428                   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Tet4.php#a49bcb607a8aad1af9c1d5d79d5ff516f">embedding_matrix</a>(c,nc,n) != 0.0)
<a name="l00429"></a>00429                     {
<a name="l00430"></a>00430                       <span class="comment">/* It must be 0.5 then.  Check whether it&#39;s the</span>
<a name="l00431"></a>00431 <span class="comment">                         first or second time that we get a 0.5</span>
<a name="l00432"></a>00432 <span class="comment">                         value.  */</span>
<a name="l00433"></a>00433                       <span class="keywordflow">if</span> (first_05_in_embedding_matrix==<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00434"></a>00434                         {
<a name="l00435"></a>00435                           <span class="comment">/* First time, so just remeber this position.  */</span>
<a name="l00436"></a>00436                           first_05_in_embedding_matrix = n;
<a name="l00437"></a>00437                         }
<a name="l00438"></a>00438                       <span class="keywordflow">else</span>
<a name="l00439"></a>00439                         {
<a name="l00440"></a>00440                           <span class="comment">/* Second time, so we know now which node to</span>
<a name="l00441"></a>00441 <span class="comment">                             use.  */</span>
<a name="l00442"></a>00442                           child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(nc) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(n)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(first_05_in_embedding_matrix);
<a name="l00443"></a>00443                         }
<a name="l00444"></a>00444 
<a name="l00445"></a>00445                     }
<a name="l00446"></a>00446                 }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448               <span class="comment">/* Make sure that a node has been found.  */</span>
<a name="l00449"></a>00449               libmesh_assert (child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(nc)!=NULL);
<a name="l00450"></a>00450             }
<a name="l00451"></a>00451         }
<a name="l00452"></a>00452     }
<a name="l00453"></a>00453 }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 
<a name="l00457"></a><a class="code" href="classlibMesh_1_1Tet4.php#ab5758aefcceb3ce24e6077e954ce2d51">00457</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tet4.php#ab5758aefcceb3ce24e6077e954ce2d51">Tet4::reselect_optimal_diagonal</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60">Diagonal</a> exclude_this)
<a name="l00458"></a>00458 {
<a name="l00459"></a>00459   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> diag_01_23 = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)+this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)).size_sq();
<a name="l00460"></a>00460   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> diag_02_13 = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)+this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)).size_sq();
<a name="l00461"></a>00461   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> diag_03_12 = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)-this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2)+this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)).size_sq();
<a name="l00462"></a>00462   
<a name="l00463"></a>00463   <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60">Diagonal</a> use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a68fecbef6a62da615b4f20206b6f3f68">INVALID_DIAG</a>;
<a name="l00464"></a>00464   <span class="keywordflow">switch</span> (exclude_this)
<a name="l00465"></a>00465     {
<a name="l00466"></a>00466     <span class="keywordflow">case</span> <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60af160f58ce391da30b08bea9767a81308">DIAG_01_23</a>:
<a name="l00467"></a>00467       use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a089d959cb1f500bc2b5d91f91c0c4ffa">DIAG_02_13</a>;
<a name="l00468"></a>00468       <span class="keywordflow">if</span> (diag_03_12 &lt; diag_02_13)
<a name="l00469"></a>00469         {
<a name="l00470"></a>00470           use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a7142da6831b498b27f6f20c313cb1213">DIAG_03_12</a>;
<a name="l00471"></a>00471         }
<a name="l00472"></a>00472       <span class="keywordflow">break</span>;
<a name="l00473"></a>00473 
<a name="l00474"></a>00474     <span class="keywordflow">case</span> <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a089d959cb1f500bc2b5d91f91c0c4ffa">DIAG_02_13</a>:
<a name="l00475"></a>00475       use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a7142da6831b498b27f6f20c313cb1213">DIAG_03_12</a>;
<a name="l00476"></a>00476       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_03_12)
<a name="l00477"></a>00477         {
<a name="l00478"></a>00478           use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60af160f58ce391da30b08bea9767a81308">DIAG_01_23</a>;
<a name="l00479"></a>00479         }
<a name="l00480"></a>00480       <span class="keywordflow">break</span>;
<a name="l00481"></a>00481 
<a name="l00482"></a>00482     <span class="keywordflow">case</span> <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a7142da6831b498b27f6f20c313cb1213">DIAG_03_12</a>:
<a name="l00483"></a>00483       use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a089d959cb1f500bc2b5d91f91c0c4ffa">DIAG_02_13</a>;
<a name="l00484"></a>00484       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_02_13)
<a name="l00485"></a>00485         {
<a name="l00486"></a>00486           use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60af160f58ce391da30b08bea9767a81308">DIAG_01_23</a>;
<a name="l00487"></a>00487         }
<a name="l00488"></a>00488       <span class="keywordflow">break</span>;
<a name="l00489"></a>00489 
<a name="l00490"></a>00490     <span class="keywordflow">default</span>:
<a name="l00491"></a>00491       use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a089d959cb1f500bc2b5d91f91c0c4ffa">DIAG_02_13</a>;
<a name="l00492"></a>00492       <span class="keywordflow">if</span> (diag_01_23 &lt; diag_02_13 || diag_03_12 &lt; diag_02_13)
<a name="l00493"></a>00493         {
<a name="l00494"></a>00494           <span class="keywordflow">if</span> (diag_01_23 &lt; diag_03_12)
<a name="l00495"></a>00495             {
<a name="l00496"></a>00496               use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60af160f58ce391da30b08bea9767a81308">DIAG_01_23</a>;
<a name="l00497"></a>00497             }
<a name="l00498"></a>00498           <span class="keywordflow">else</span>
<a name="l00499"></a>00499             {
<a name="l00500"></a>00500               use_this = <a class="code" href="classlibMesh_1_1Tet4.php#ae108f3cfe223b98b42044b1a43f35c60a7142da6831b498b27f6f20c313cb1213">DIAG_03_12</a>;
<a name="l00501"></a>00501             }
<a name="l00502"></a>00502         }
<a name="l00503"></a>00503       <span class="keywordflow">break</span>;
<a name="l00504"></a>00504     }
<a name="l00505"></a>00505 
<a name="l00506"></a>00506   <a class="code" href="classlibMesh_1_1Tet4.php#af8c428992350dd73ec03e9c7b90a6106">reselect_diagonal</a> (use_this);  
<a name="l00507"></a>00507 } 
<a name="l00508"></a>00508 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00509"></a>00509 <span class="preprocessor"></span>
<a name="l00510"></a>00510 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
