<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">cell_tet.C</div>  </div>
</div>
<div class="contents">
<a href="cell__tet_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: cell_tet.C 4356 2011-04-15 15:28:29Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet_8h.php">cell_tet.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet4_8h.php">cell_tet4.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="face__tri3_8h.php">face_tri3.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">namespace </span>libMesh
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// Tet class member functions</span>
<a name="l00035"></a><a class="code" href="classlibMesh_1_1Tet.php#a892f1b65bfbad8375c387036ebf65d51">00035</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tet.php#a892f1b65bfbad8375c387036ebf65d51">Tet::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00036"></a>00036 <span class="keyword"></span>{
<a name="l00037"></a>00037   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a273874aa6b467759119e2a1cd5d7436b">n_sides</a>());
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="keywordflow">switch</span> (s)
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041     <span class="keywordflow">case</span> 0:
<a name="l00042"></a>00042       <span class="keywordflow">return</span>
<a name="l00043"></a>00043         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00044"></a>00044                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00045"></a>00045                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1));
<a name="l00046"></a>00046       
<a name="l00047"></a>00047     <span class="keywordflow">case</span> 1:
<a name="l00048"></a>00048       <span class="keywordflow">return</span>
<a name="l00049"></a>00049         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00050"></a>00050                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00051"></a>00051                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3));
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="keywordflow">case</span> 2:
<a name="l00054"></a>00054       <span class="keywordflow">return</span>
<a name="l00055"></a>00055         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00056"></a>00056                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00057"></a>00057                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3));
<a name="l00058"></a>00058 
<a name="l00059"></a>00059     <span class="keywordflow">case</span> 3:
<a name="l00060"></a>00060       <span class="keywordflow">return</span>
<a name="l00061"></a>00061         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00062"></a>00062                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00063"></a>00063                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3));      
<a name="l00064"></a>00064     }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00067"></a>00067   libmesh_error();
<a name="l00068"></a>00068   <span class="keywordflow">return</span> 0;
<a name="l00069"></a>00069 }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1Tet.php#ae21df7218ca40ea197ebae771b1cf0ba">00073</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Tet.php#ae21df7218ca40ea197ebae771b1cf0ba">Tet::side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00074"></a>00074 <span class="keyword"></span>{
<a name="l00075"></a>00075   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a273874aa6b467759119e2a1cd5d7436b">n_sides</a>());
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* face = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>;
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="keywordflow">switch</span> (i)
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083     <span class="keywordflow">case</span> 0:
<a name="l00084"></a>00084       {
<a name="l00085"></a>00085         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00086"></a>00086         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00087"></a>00087         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00090"></a>00090         <span class="keywordflow">return</span> ap_face;
<a name="l00091"></a>00091       }
<a name="l00092"></a>00092     <span class="keywordflow">case</span> 1:
<a name="l00093"></a>00093       {
<a name="l00094"></a>00094         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00095"></a>00095         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00096"></a>00096         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00099"></a>00099         <span class="keywordflow">return</span> ap_face;
<a name="l00100"></a>00100       }
<a name="l00101"></a>00101     <span class="keywordflow">case</span> 2:
<a name="l00102"></a>00102       {
<a name="l00103"></a>00103         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00104"></a>00104         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00105"></a>00105         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00108"></a>00108         <span class="keywordflow">return</span> ap_face;
<a name="l00109"></a>00109       }
<a name="l00110"></a>00110     <span class="keywordflow">case</span> 3:
<a name="l00111"></a>00111       {
<a name="l00112"></a>00112         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00113"></a>00113         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00114"></a>00114         face-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00115"></a>00115         
<a name="l00116"></a>00116         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00117"></a>00117         <span class="keywordflow">return</span> ap_face;
<a name="l00118"></a>00118       }
<a name="l00119"></a>00119     <span class="keywordflow">default</span>:
<a name="l00120"></a>00120       {
<a name="l00121"></a>00121         libmesh_error();
<a name="l00122"></a>00122       }
<a name="l00123"></a>00123     }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   <span class="comment">// We&#39;ll never get here.</span>
<a name="l00126"></a>00126   libmesh_error();
<a name="l00127"></a>00127   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_face(face);
<a name="l00128"></a>00128   <span class="keywordflow">return</span> ap_face;
<a name="l00129"></a>00129 }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1Tet.php#a26ce6b272b94e93b2d9a6db63c2a87c1">00133</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tet.php#a26ce6b272b94e93b2d9a6db63c2a87c1">Tet::is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00134"></a>00134                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00135"></a>00135 <span class="keyword"></span>{
<a name="l00136"></a>00136   libmesh_assert (c &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#ac8cc3fd8290d58ea4517eff51eea3ddb">n_children</a>());
<a name="l00137"></a>00137   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tet.php#a273874aa6b467759119e2a1cd5d7436b">n_sides</a>());
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// For the 4 vertices, child c touches vertex c, so we can return</span>
<a name="l00140"></a>00140   <span class="comment">// true if that vertex is on side s</span>
<a name="l00141"></a>00141   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00142"></a>00142     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Tet4.php#a901b2cbe553f000445fa49db486d737a">Tet4::side_nodes_map</a>[s][i] == c)
<a name="l00143"></a>00143       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="comment">// For the 4 non-vertex children, the child ordering depends on the</span>
<a name="l00146"></a>00146   <span class="comment">// diagonal selection.  We&#39;ll let the embedding matrix figure that</span>
<a name="l00147"></a>00147   <span class="comment">// out: if this child has three nodes that don&#39;t depend on the</span>
<a name="l00148"></a>00148   <span class="comment">// position of the node_facing_side[s], then we&#39;re on side s.</span>
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_facing_side[4] = {3, 2, 0, 1};
<a name="l00151"></a>00151   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = node_facing_side[s];
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> independent_nodes = 0;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc = 0; nc != 3; ++nc)
<a name="l00156"></a>00156     {
<a name="l00157"></a>00157       independent_nodes++;  <span class="comment">// Hey, we&#39;re independent so far!</span>
<a name="l00158"></a>00158       
<a name="l00159"></a>00159 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a20e8a3350fb24fd249209e0089b2ca33">embedding_matrix</a>(c,nc,n) != 0.)
<a name="l00161"></a>00161         {
<a name="l00162"></a>00162           independent_nodes--;  <span class="comment">// No, wait, we&#39;re not</span>
<a name="l00163"></a>00163           <span class="keywordflow">continue</span>;
<a name="l00164"></a>00164         }
<a name="l00165"></a>00165 <span class="preprocessor">#endif //LIBMESH_ENABLE_AMR</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>    }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="comment">// No subtet of an octahedron touches a side at all nodes</span>
<a name="l00169"></a>00169   libmesh_assert(independent_nodes != 4);
<a name="l00170"></a>00170   <span class="comment">// Every subtet of an octahedron touches each side at at least one</span>
<a name="l00171"></a>00171   <span class="comment">// node</span>
<a name="l00172"></a>00172   libmesh_assert(independent_nodes != 0);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="keywordflow">return</span> (independent_nodes == 3);
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classlibMesh_1_1Tet.php#abec887b9760066bf4985591c7e4cf7f3">00179</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Tet.php#abec887b9760066bf4985591c7e4cf7f3">Tet::quality</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00180"></a>00180 <span class="keyword"></span>{
<a name="l00181"></a>00181   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Tet.php#abec887b9760066bf4985591c7e4cf7f3">Elem::quality</a>(q); <span class="comment">// Not implemented</span>
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a><a class="code" href="classlibMesh_1_1Tet.php#a078790359eafdd309eddb9ac8496c62c">00187</a> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1Tet.php#a078790359eafdd309eddb9ac8496c62c">Tet::qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00188"></a>00188 <span class="keyword"></span>{
<a name="l00189"></a>00189   std::pair&lt;Real, Real&gt; bounds;
<a name="l00190"></a>00190   
<a name="l00191"></a>00191   <span class="keywordflow">switch</span> (q)
<a name="l00192"></a>00192     {
<a name="l00193"></a>00193 
<a name="l00194"></a>00194     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a77ceaa502eaeff5313a279f08699e9d5">ASPECT_RATIO_BETA</a>:
<a name="l00195"></a>00195     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad1cac69d1c38539e42934ab8dd2cb5a8">ASPECT_RATIO_GAMMA</a>:
<a name="l00196"></a>00196       bounds.first  = 1.;
<a name="l00197"></a>00197       bounds.second = 3.;
<a name="l00198"></a>00198       <span class="keywordflow">break</span>;
<a name="l00199"></a>00199       
<a name="l00200"></a>00200     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>:
<a name="l00201"></a>00201     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>:
<a name="l00202"></a>00202       bounds.first  = 0.2;
<a name="l00203"></a>00203       bounds.second = 1.;
<a name="l00204"></a>00204       <span class="keywordflow">break</span>;
<a name="l00205"></a>00205 
<a name="l00206"></a>00206     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>:
<a name="l00207"></a>00207       bounds.first  = 1.;
<a name="l00208"></a>00208       bounds.second = 3.;
<a name="l00209"></a>00209       <span class="keywordflow">break</span>;
<a name="l00210"></a>00210       
<a name="l00211"></a>00211     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00212"></a>00212       bounds.first  = 0.6;
<a name="l00213"></a>00213       bounds.second = 1.;
<a name="l00214"></a>00214       <span class="keywordflow">break</span>;  
<a name="l00215"></a>00215 
<a name="l00216"></a>00216     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>:
<a name="l00217"></a>00217       bounds.first  = 0.5;
<a name="l00218"></a>00218       bounds.second = 1.414;
<a name="l00219"></a>00219       <span class="keywordflow">break</span>;
<a name="l00220"></a>00220       
<a name="l00221"></a>00221     <span class="keywordflow">default</span>:
<a name="l00222"></a>00222       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Invalid quality measure chosen.&quot;</span> &lt;&lt; std::endl;
<a name="l00223"></a>00223       bounds.first  = -1;
<a name="l00224"></a>00224       bounds.second = -1;
<a name="l00225"></a>00225     }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="keywordflow">return</span> bounds;
<a name="l00228"></a>00228 }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
