<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_80224e50d3aebdc14135f96bcab47e92.php">partitioning</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">centroid_partitioner.h</div>  </div>
</div>
<div class="contents">
<a href="centroid__partitioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: centroid_partitioner.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __centroid_partitioner_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __centroid_partitioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;utility&gt;</span> <span class="comment">// pair</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="partitioner_8h.php">partitioner.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span>Elem;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00053"></a>00053 <span class="comment">// CentroidPartitioner class definition</span>
<a name="l00054"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php">00054</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1CentroidPartitioner.php">CentroidPartitioner</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Partitioner.php">Partitioner</a>
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   
<a name="l00064"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058a2974b0c24da5bad4ce3005d613241703">00064</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058">CentroidSortMethod</a> {<a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058a2974b0c24da5bad4ce3005d613241703">X</a>=0,
<a name="l00065"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058ab6b4c549db03998c47dee0dcf7d265c9">00065</a>                            <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058ab6b4c549db03998c47dee0dcf7d265c9">Y</a>,
<a name="l00066"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058a0971daa69c11bc98c44f6beb126d0659">00066</a>                            <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058a0971daa69c11bc98c44f6beb126d0659">Z</a>,
<a name="l00067"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058a090e064a31b5a835ed844c1d1b270b07">00067</a>                            <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058a090e064a31b5a835ed844c1d1b270b07">RADIAL</a>,
<a name="l00068"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058aae4f138a102738703595228555c39f01">00068</a>                            <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058aae4f138a102738703595228555c39f01">INVALID_METHOD</a>};
<a name="l00069"></a>00069 
<a name="l00074"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a22690b637a359a79e1ae9762eeb24adb">00074</a>   <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a22690b637a359a79e1ae9762eeb24adb">CentroidPartitioner</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058">CentroidSortMethod</a> sm=<a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058a2974b0c24da5bad4ce3005d613241703">X</a>) : <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a568f67583bf293252906691336aad3b0">_sort_method</a>(sm) {}
<a name="l00075"></a>00075 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#af2f34c96c4e1104aedff3a85d0bdadb4">00080</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#af2f34c96c4e1104aedff3a85d0bdadb4">clone</a> ()<span class="keyword"> const </span>{
<a name="l00081"></a>00081     <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> cloned_partitioner
<a name="l00082"></a>00082       (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a22690b637a359a79e1ae9762eeb24adb">CentroidPartitioner</a>(<a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a0658d96b2c33c755b8901e383c7232a1">sort_method</a>()));
<a name="l00083"></a>00083     <span class="keywordflow">return</span> cloned_partitioner;
<a name="l00084"></a>00084   }
<a name="l00085"></a>00085 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a0658d96b2c33c755b8901e383c7232a1">00089</a>   <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058">CentroidSortMethod</a> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a0658d96b2c33c755b8901e383c7232a1">sort_method</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a568f67583bf293252906691336aad3b0">_sort_method</a>; }
<a name="l00090"></a>00090 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a615f1b51e4fddf283361a58da92f4043">00094</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a615f1b51e4fddf283361a58da92f4043">set_sort_method</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058">CentroidSortMethod</a> sm) {<a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a568f67583bf293252906691336aad3b0">_sort_method</a> = sm; }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   
<a name="l00097"></a>00097 <span class="keyword">protected</span>:
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#ad39d375e441770cfac65ea184305f7bb">_do_partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00103"></a>00103                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="keyword">private</span>:
<a name="l00106"></a>00106 
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a182834547bbed91db4d1f249be404bff">compute_centroids</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00113"></a>00113 
<a name="l00120"></a>00120   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#afdd26d4284b7c3404489b6e416d70027">sort_x</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00121"></a>00121                       <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs);
<a name="l00122"></a>00122 
<a name="l00129"></a>00129   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#ae15841056facb11ec946a75ea374cf14">sort_y</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00130"></a>00130                       <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs);
<a name="l00131"></a>00131 
<a name="l00138"></a>00138   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#ac4e1874832759e6598e57264c9a71bbf">sort_z</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00139"></a>00139                       <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   
<a name="l00148"></a>00148   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a388844941f6ec99037b4823cdefb1aa3">sort_radial</a> (<span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; lhs,
<a name="l00149"></a>00149                            <span class="keyword">const</span> std::pair&lt;Point, Elem*&gt;&amp; rhs);
<a name="l00150"></a>00150 
<a name="l00155"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a568f67583bf293252906691336aad3b0">00155</a>   <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a36bd22adadcd807098ecb2e0363ad058">CentroidSortMethod</a> <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#a568f67583bf293252906691336aad3b0">_sort_method</a>;
<a name="l00156"></a>00156 
<a name="l00161"></a><a class="code" href="classlibMesh_1_1CentroidPartitioner.php#abadb14eb90085034a68a5a3fbad30fe8">00161</a>   std::vector&lt;std::pair&lt;Point, Elem*&gt; &gt; <a class="code" href="classlibMesh_1_1CentroidPartitioner.php#abadb14eb90085034a68a5a3fbad30fe8">_elem_centroids</a>;
<a name="l00162"></a>00162 };
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 } <span class="comment">// namespace libMesh</span>
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
