<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">condensed_eigen_system.C</div>  </div>
</div>
<div class="contents">
<a href="condensed__eigen__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: condensed_eigen_system.C 4253 2011-03-12 04:44:04Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Currently, the EigenSystem should only be available</span>
<a name="l00023"></a>00023 <span class="comment">// if SLEPc support is enabled. </span>
<a name="l00024"></a>00024 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="condensed__eigen__system_8h.php">condensed_eigen_system.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a7745c9b530285f16e9f747d35ab80b5c">00036</a> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a7745c9b530285f16e9f747d35ab80b5c">CondensedEigenSystem::CondensedEigenSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00037"></a>00037                                             <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00038"></a>00038                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00039"></a>00039   : <a class="code" href="classlibMesh_1_1EigenSystem.php">Parent</a>(es, name, number),
<a name="l00040"></a>00040     condensed_matrix_A(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00041"></a>00041     condensed_matrix_B(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00042"></a>00042     condensed_dofs_initialized(false)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#aa888b1f9f7cda8a67f82ee581cdd7b1c">00046</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#aa888b1f9f7cda8a67f82ee581cdd7b1c">CondensedEigenSystem::initialize_condensed_dofs</a>(std::set&lt;unsigned int&gt;&amp; global_dirichlet_dofs_set)
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="comment">// First, put all local dofs into non_dirichlet_dofs_set and</span>
<a name="l00049"></a>00049   std::set&lt;unsigned int&gt; local_non_condensed_dofs_set;
<a name="l00050"></a>00050   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().first_dof(); i&lt;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>(); i++)
<a name="l00051"></a>00051     local_non_condensed_dofs_set.insert(i);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="comment">// Now erase the condensed dofs</span>
<a name="l00054"></a>00054   std::set&lt;unsigned int&gt;::iterator iter     = global_dirichlet_dofs_set.begin();
<a name="l00055"></a>00055   std::set&lt;unsigned int&gt;::iterator iter_end = global_dirichlet_dofs_set.end();
<a name="l00056"></a>00056   
<a name="l00057"></a>00057   <span class="keywordflow">for</span> ( ; iter != iter_end ; iter++)
<a name="l00058"></a>00058   {
<a name="l00059"></a>00059     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> condensed_dof_index = *iter;
<a name="l00060"></a>00060     <span class="keywordflow">if</span> ( (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().first_dof() &lt;= condensed_dof_index) &amp;&amp;
<a name="l00061"></a>00061          (condensed_dof_index &lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().end_dof()) )
<a name="l00062"></a>00062     {
<a name="l00063"></a>00063       local_non_condensed_dofs_set.erase(condensed_dof_index);
<a name="l00064"></a>00064     }
<a name="l00065"></a>00065   }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="comment">// Finally, move local_non_condensed_dofs_set over to a vector for convenience in solve()</span>
<a name="l00068"></a>00068   iter     = local_non_condensed_dofs_set.begin();
<a name="l00069"></a>00069   iter_end = local_non_condensed_dofs_set.end();
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   this-&gt;<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>.clear();
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="keywordflow">for</span> ( ; iter != iter_end; ++iter)
<a name="l00074"></a>00074     {
<a name="l00075"></a>00075       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> non_condensed_dof_index = *iter;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077       this-&gt;<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>.push_back(non_condensed_dof_index);
<a name="l00078"></a>00078     }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a2a9f1cee6432003bbee649cb24790d70">condensed_dofs_initialized</a> = <span class="keyword">true</span>;
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#aa594512fed05ab237e23cd224825158a">00083</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#aa594512fed05ab237e23cd224825158a">CondensedEigenSystem::n_global_non_condensed_dofs</a>()<span class="keyword"> const</span>
<a name="l00084"></a>00084 <span class="keyword"></span>{
<a name="l00085"></a>00085   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a2a9f1cee6432003bbee649cb24790d70">condensed_dofs_initialized</a>)
<a name="l00086"></a>00086   {
<a name="l00087"></a>00087     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>();
<a name="l00088"></a>00088   }
<a name="l00089"></a>00089   <span class="keywordflow">else</span>
<a name="l00090"></a>00090   {
<a name="l00091"></a>00091     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#aa594512fed05ab237e23cd224825158a">n_global_non_condensed_dofs</a> = <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>.size();
<a name="l00092"></a>00092     <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(n_global_non_condensed_dofs);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#aa594512fed05ab237e23cd224825158a">n_global_non_condensed_dofs</a>;
<a name="l00095"></a>00095   }
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a87f6a730f828acbba4b4b375a94ee914">00099</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a87f6a730f828acbba4b4b375a94ee914">CondensedEigenSystem::solve</a>()
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;CondensedEigenSystem&quot;</span>);
<a name="l00102"></a>00102   
<a name="l00103"></a>00103   <span class="comment">// If we haven&#39;t initialized any condensed dofs,</span>
<a name="l00104"></a>00104   <span class="comment">// just use the default eigen_system</span>
<a name="l00105"></a>00105   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a2a9f1cee6432003bbee649cb24790d70">condensed_dofs_initialized</a>)
<a name="l00106"></a>00106   {
<a name="l00107"></a>00107     STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;CondensedEigenSystem&quot;</span>);
<a name="l00108"></a>00108     <a class="code" href="classlibMesh_1_1EigenSystem.php#a454664a042652e1e501b3718a82d84eb">Parent::solve</a>();
<a name="l00109"></a>00109     <span class="keywordflow">return</span>;
<a name="l00110"></a>00110   }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="comment">// A reference to the EquationSystems</span>
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// check that necessary parameters have been set</span>
<a name="l00116"></a>00116   libmesh_assert (es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;eigenpairs&quot;</span>));
<a name="l00117"></a>00117   libmesh_assert (es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;basis vectors&quot;</span>));
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a>)
<a name="l00120"></a>00120     <span class="comment">// Assemble the linear system</span>
<a name="l00121"></a>00121     this-&gt;<a class="code" href="classlibMesh_1_1EigenSystem.php#a2b4572555305c92ed24feea4d5b4d522">assemble</a> ();
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">// If we reach here, then there should be some non-condensed dofs</span>
<a name="l00124"></a>00124   libmesh_assert(!<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>.empty());
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// Need to get a global copy of local_non_condensed_dofs_vector on all processors</span>
<a name="l00127"></a>00127   std::vector&lt;unsigned int&gt; global_non_condensed_dofs_vector = <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>;
<a name="l00128"></a>00128   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(global_non_condensed_dofs_vector);
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="comment">// Now condense the matrices</span>
<a name="l00131"></a>00131   <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#ae7069ca3b5265f87438c1ffcce9470f5">create_submatrix</a>(*<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#af49398f259562d805ec8645eba8df46f">condensed_matrix_A</a>,
<a name="l00132"></a>00132                              <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>,
<a name="l00133"></a>00133                              global_non_condensed_dofs_vector);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#ae7069ca3b5265f87438c1ffcce9470f5">create_submatrix</a>(*<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#ab4ff55cf1b403f032f1384397b7e0392">condensed_matrix_B</a>,
<a name="l00136"></a>00136                              <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>,
<a name="l00137"></a>00137                              global_non_condensed_dofs_vector);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="comment">// Get the tolerance for the solver and the maximum</span>
<a name="l00141"></a>00141   <span class="comment">// number of iterations. Here, we simply adopt the linear solver</span>
<a name="l00142"></a>00142   <span class="comment">// specific parameters.</span>
<a name="l00143"></a>00143   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol            =
<a name="l00144"></a>00144     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxits =
<a name="l00147"></a>00147     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nev    =
<a name="l00150"></a>00150     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;eigenpairs&quot;</span>);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ncv    =
<a name="l00153"></a>00153     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;basis vectors&quot;</span>);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   std::pair&lt;unsigned int, unsigned int&gt; solve_data;
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="comment">// call the solver depending on the type of eigenproblem</span>
<a name="l00158"></a>00158   <span class="keywordflow">if</span> ( <a class="code" href="classlibMesh_1_1EigenSystem.php#aff9b2776cd721fc84ee71bb66b5d6f5b">generalized</a>() )
<a name="l00159"></a>00159     {
<a name="l00160"></a>00160       <span class="comment">//in case of a generalized eigenproblem</span>
<a name="l00161"></a>00161       solve_data = <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;solve_generalized
<a name="l00162"></a>00162         (*<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#af49398f259562d805ec8645eba8df46f">condensed_matrix_A</a>,*<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#ab4ff55cf1b403f032f1384397b7e0392">condensed_matrix_B</a>, nev, ncv, tol, maxits);
<a name="l00163"></a>00163     }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="keywordflow">else</span>
<a name="l00166"></a>00166     {
<a name="l00167"></a>00167       libmesh_assert (<a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a> == NULL);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169       <span class="comment">//in case of a standard eigenproblem</span>
<a name="l00170"></a>00170       solve_data = <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;solve_standard (*<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#af49398f259562d805ec8645eba8df46f">condensed_matrix_A</a>, nev, ncv, tol, maxits);
<a name="l00171"></a>00171     }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <a class="code" href="classlibMesh_1_1EigenSystem.php#a4b87a747126b87053026efe939ebc18b">set_n_converged</a>(solve_data.first);
<a name="l00174"></a>00174   <a class="code" href="classlibMesh_1_1EigenSystem.php#ae85415626f2d9b82b03788228be72edc">set_n_iterations</a>(solve_data.second);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;CondensedEigenSystem&quot;</span>);
<a name="l00177"></a>00177 }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a61074dcbb447fd31e18a3706fc4b48ec">00181</a> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a61074dcbb447fd31e18a3706fc4b48ec">CondensedEigenSystem::get_eigenpair</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00182"></a>00182 {
<a name="l00183"></a>00183   START_LOG(<span class="stringliteral">&quot;get_eigenpair()&quot;</span>, <span class="stringliteral">&quot;CondensedEigenSystem&quot;</span>);
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="comment">// If we haven&#39;t initialized any condensed dofs,</span>
<a name="l00186"></a>00186   <span class="comment">// just use the default eigen_system</span>
<a name="l00187"></a>00187   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a2a9f1cee6432003bbee649cb24790d70">condensed_dofs_initialized</a>)
<a name="l00188"></a>00188   {
<a name="l00189"></a>00189     STOP_LOG(<span class="stringliteral">&quot;get_eigenpair()&quot;</span>, <span class="stringliteral">&quot;CondensedEigenSystem&quot;</span>);
<a name="l00190"></a>00190     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a4cb401cd6e4bd406b68cb408caa06721">Parent::get_eigenpair</a>(i);
<a name="l00191"></a>00191   }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="comment">// If we reach here, then there should be some non-condensed dofs</span>
<a name="l00194"></a>00194   libmesh_assert(!<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>.empty());
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="comment">// This function assumes that condensed_solve has just been called.</span>
<a name="l00197"></a>00197   <span class="comment">// If this is not the case, then we will trip an asset in get_eigenpair</span>
<a name="l00198"></a>00198   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; NumericVector&lt;Number&gt;</a> &gt; temp = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00199"></a>00199   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local = <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>.size();
<a name="l00200"></a>00200   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n       = n_local;
<a name="l00201"></a>00201   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(n);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   temp-&gt;init (n, n_local, <span class="keyword">false</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">libMeshEnums::PARALLEL</a>);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   std::pair&lt;Real, Real&gt; eval = <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;get_eigenpair (i, *temp);
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="comment">// Now map temp to solution. Loop over local entries of local_non_condensed_dofs_vector</span>
<a name="l00208"></a>00208   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;zero();
<a name="l00209"></a>00209   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>.size(); i++)
<a name="l00210"></a>00210   {
<a name="l00211"></a>00211     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>[i];
<a name="l00212"></a>00212     <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;set(index,(*temp)(temp-&gt;first_local_index()+i));
<a name="l00213"></a>00213   }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00216"></a>00216   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   STOP_LOG(<span class="stringliteral">&quot;get_eigenpair()&quot;</span>, <span class="stringliteral">&quot;CondensedEigenSystem&quot;</span>);
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="keywordflow">return</span> eval;
<a name="l00221"></a>00221 }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 } <span class="comment">// namespace libMesh</span>
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
