<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">condensed_eigen_system.h</div>  </div>
</div>
<div class="contents">
<a href="condensed__eigen__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: condensed_eigen_system.h 4253 2011-03-12 04:44:04Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributd in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __condensed_eigen_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __condensed_eigen_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Currently, the EigenSystem should only be available</span>
<a name="l00027"></a>00027 <span class="comment">// if SLEPc support is enabled. </span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="comment">// C++ includes</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local Includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="eigen__system_8h.php">eigen_system.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// CondensedEigenSystem class definition</span>
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php">CondensedEigenSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1EigenSystem.php">EigenSystem</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a7745c9b530285f16e9f747d35ab80b5c">CondensedEigenSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00059"></a>00059                         <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00060"></a>00060                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00061"></a>00061  
<a name="l00065"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#ace3b97b74f03adaa3a2000a873f4ed21">00065</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php">CondensedEigenSystem</a> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#ace3b97b74f03adaa3a2000a873f4ed21">sys_type</a>;
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a477d97f9cf65566b778dd3694f6d82df">00070</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1EigenSystem.php">EigenSystem</a> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a477d97f9cf65566b778dd3694f6d82df">Parent</a>;
<a name="l00071"></a>00071   
<a name="l00075"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#af74d076ec7647da165f9f85330298930">00075</a>   <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#af74d076ec7647da165f9f85330298930">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00076"></a>00076 
<a name="l00082"></a>00082   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#aa888b1f9f7cda8a67f82ee581cdd7b1c">initialize_condensed_dofs</a>(std::set&lt;unsigned int&gt;&amp; global_dirichlet_dofs_set);
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#aa594512fed05ab237e23cd224825158a">n_global_non_condensed_dofs</a>() <span class="keyword">const</span>;
<a name="l00088"></a>00088 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a87f6a730f828acbba4b4b375a94ee914">solve</a>();
<a name="l00095"></a>00095 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a61074dcbb447fd31e18a3706fc4b48ec">get_eigenpair</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00103"></a>00103   
<a name="l00108"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a8ca2ca560026871195f034847f6e2c89">00108</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a8ca2ca560026871195f034847f6e2c89">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;CondensedEigen&quot;</span>; }
<a name="l00109"></a>00109   
<a name="l00113"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#af49398f259562d805ec8645eba8df46f">00113</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; SparseMatrix&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#af49398f259562d805ec8645eba8df46f">condensed_matrix_A</a>;
<a name="l00114"></a>00114 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#ab4ff55cf1b403f032f1384397b7e0392">00118</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt; SparseMatrix&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#ab4ff55cf1b403f032f1384397b7e0392">condensed_matrix_B</a>;
<a name="l00119"></a>00119 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">00125</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a4ffc4c116e84da128caa56b573ef613e">local_non_condensed_dofs_vector</a>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="keyword">private</span>:
<a name="l00128"></a>00128 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a2a9f1cee6432003bbee649cb24790d70">00133</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1CondensedEigenSystem.php#a2a9f1cee6432003bbee649cb24790d70">condensed_dofs_initialized</a>;
<a name="l00134"></a>00134   
<a name="l00135"></a>00135 };
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 } <span class="comment">// namespace libMesh</span>
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
<a name="l00142"></a>00142 <span class="preprocessor"></span>
<a name="l00143"></a>00143 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
