<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">continuation_system.h</div>  </div>
</div>
<div class="contents">
<a href="continuation__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: continuation_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __continuation_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __continuation_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fem__system_8h.php">fem_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>LinearSolver;
<a name="l00035"></a>00035 <span class="keyword">class </span>NewtonSolver;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php">00059</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ContinuationSystem.php">ContinuationSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FEMSystem.php">FEMSystem</a>
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6ec7c334543edd9117ce97e3eb491292">ContinuationSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00067"></a>00067                       <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00068"></a>00068                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3a438c87dd95393e480a98d239146450">~ContinuationSystem</a> ();
<a name="l00074"></a>00074 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1e16e54312b5099b71e42f6593926536">00078</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php">ContinuationSystem</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1e16e54312b5099b71e42f6593926536">sys_type</a>;
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#aa590e2a8c5a75d6b3d1a1c5cfc8f08e6">00083</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FEMSystem.php">FEMSystem</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aa590e2a8c5a75d6b3d1a1c5cfc8f08e6">Parent</a>;
<a name="l00084"></a>00084   
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aca9bc20581a6aaa68ed6cc1f2b30c431">clear</a> ();
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac64404dcb7d22aa6f73a5c8208e41217">solve</a>();
<a name="l00095"></a>00095   
<a name="l00102"></a>00102   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8706b919a3b01da570359d8bb71338dd">continuation_solve</a>();
<a name="l00103"></a>00103 
<a name="l00108"></a>00108   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a652388ee34fa6ffefe9d67e8655e5d1e">advance_arcstep</a>();
<a name="l00109"></a>00109   
<a name="l00119"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">00119</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>* <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a95e4e1ac0b0db34b8ca3011ae221ed80">continuation_parameter</a>;
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">00125</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a202486b5f0a3740de27e707d01ee892c">quiet</a>;
<a name="l00126"></a>00126 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2ebd4210e22590e9f23a18e20c7d71cf">00132</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2ebd4210e22590e9f23a18e20c7d71cf">set_max_arclength_stepsize</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> maxds) { <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a113feb65e8fc969228ce08e71971aae6">ds</a>=maxds; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>=maxds; }
<a name="l00133"></a>00133   
<a name="l00138"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#acaa3c4e3ee838ed8c53c0636e83b3846">00138</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#acaa3c4e3ee838ed8c53c0636e83b3846">continuation_parameter_tolerance</a>;
<a name="l00139"></a>00139 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab7bd605b573521a7a98cf44627bd7e4e">00144</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab7bd605b573521a7a98cf44627bd7e4e">solution_tolerance</a>;
<a name="l00145"></a>00145 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a23b9ced011dfbbf49fcac0d00b58d5c5">00151</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a23b9ced011dfbbf49fcac0d00b58d5c5">initial_newton_tolerance</a>;
<a name="l00152"></a>00152   
<a name="l00160"></a>00160   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ab1f92beb3279c4ed3267e63c7a9eb9">save_current_solution</a>();
<a name="l00161"></a>00161 
<a name="l00165"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab77f90619bd7bc91484458fea937a7cd">00165</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ab77f90619bd7bc91484458fea937a7cd">old_continuation_parameter</a>;
<a name="l00166"></a>00166 
<a name="l00171"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3c926e951ebf781dd05157295532a833">00171</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3c926e951ebf781dd05157295532a833">min_continuation_parameter</a>;
<a name="l00172"></a>00172 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a69d569bd9b652d24df1fbc9bd2c9c54a">00178</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a69d569bd9b652d24df1fbc9bd2c9c54a">max_continuation_parameter</a>;
<a name="l00179"></a>00179 
<a name="l00185"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">00185</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a570c39c32a5de85421fcbd7ef8684ad5">Theta</a>;
<a name="l00186"></a>00186   
<a name="l00192"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">00192</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecef946a682013aafd03a1d853a182d3">Theta_LOCA</a>;
<a name="l00193"></a>00193 
<a name="l00199"></a>00199   <span class="comment">//Real tau;</span>
<a name="l00200"></a>00200 
<a name="l00206"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecb2c9bf8e35299c02a1fb768082f8cb">00206</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aecb2c9bf8e35299c02a1fb768082f8cb">n_backtrack_steps</a>;
<a name="l00207"></a>00207 
<a name="l00213"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a460a40fa157a8a02291bf801855da11a">00213</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a460a40fa157a8a02291bf801855da11a">n_arclength_reductions</a>;
<a name="l00214"></a>00214 
<a name="l00218"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7cc77804ea5ef5dde638fe522aeed6a3">00218</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7cc77804ea5ef5dde638fe522aeed6a3">ds_min</a>;
<a name="l00219"></a>00219 
<a name="l00225"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600">00225</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600">Predictor</a> {
<a name="l00229"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600a9c5dbe46dad699af1f4278be53012c76">00229</a>     <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600a9c5dbe46dad699af1f4278be53012c76">Euler</a>,
<a name="l00230"></a>00230 
<a name="l00234"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600a64dba0386d970145477a4d001db5e549">00234</a>     <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600a64dba0386d970145477a4d001db5e549">AB2</a>,
<a name="l00235"></a>00235 
<a name="l00239"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600a5d9fffba94c555b0116ce03320b86b70">00239</a>     <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600a5d9fffba94c555b0116ce03320b86b70">Invalid_Predictor</a>
<a name="l00240"></a>00240   };
<a name="l00241"></a>00241 
<a name="l00242"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a172cfb334a843f73419f20ab5cde57a5">00242</a>   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac6985654cb1d70608920d8c77409c600">Predictor</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a172cfb334a843f73419f20ab5cde57a5">predictor</a>;
<a name="l00243"></a>00243 
<a name="l00251"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad499324a7a490ad9a4777fd48bfca048">00251</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad499324a7a490ad9a4777fd48bfca048">newton_stepgrowth_aggressiveness</a>;
<a name="l00252"></a>00252 
<a name="l00260"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8723254d749f107d589deffb4eae4f5f">00260</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8723254d749f107d589deffb4eae4f5f">newton_progress_check</a>;
<a name="l00261"></a>00261   
<a name="l00262"></a>00262 <span class="keyword">protected</span>:
<a name="l00267"></a>00267   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aac004fb67b83674c9d8d122a7912f646">init_data</a> ();
<a name="l00268"></a>00268 
<a name="l00290"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006e">00290</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006e">RHS_Mode</a> {<a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea24777dbaa6ef5bfd9980dc81ebfdba81">Residual</a>,
<a name="l00291"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea4bcf4ab6f979f5e38505fc32720307f1">00291</a>                  <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006ea4bcf4ab6f979f5e38505fc32720307f1">G_Lambda</a>};
<a name="l00292"></a>00292   
<a name="l00293"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a34d429e11a79273738c658c10bfa07c5">00293</a>   <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a7aa2e6f267de7c463bb3e1e706c5006e">RHS_Mode</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a34d429e11a79273738c658c10bfa07c5">rhs_mode</a>;
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 <span class="keyword">private</span>:
<a name="l00304"></a>00304   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ac5130a85829d1f6e7bb63373a3efe0a7">initialize_tangent</a>();
<a name="l00305"></a>00305 
<a name="l00309"></a>00309   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a686615e1d0b0559da3c1f0b620211bec">solve_tangent</a>();
<a name="l00310"></a>00310 
<a name="l00316"></a>00316   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6869735ca949bbd219ffdac8c2f08296">update_solution</a>();
<a name="l00317"></a>00317 
<a name="l00321"></a>00321   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#aec7faf1468f632e64415540f6c9897a2">set_Theta</a>();
<a name="l00322"></a>00322 
<a name="l00327"></a>00327   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ff4d70ffecd54e4c2f35a341cddf3bd">set_Theta_LOCA</a>();
<a name="l00328"></a>00328 
<a name="l00333"></a>00333   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a619cd33885c0d1568fa26970fea8f5cd">apply_predictor</a>();
<a name="l00334"></a>00334   
<a name="l00342"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">00342</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a542ed3d4e4dbd55f3d4c840c625f9307">du_ds</a>;
<a name="l00343"></a>00343 
<a name="l00347"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ae0f4570622a491f4879271fb6fb6ad08">00347</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ae0f4570622a491f4879271fb6fb6ad08">previous_du_ds</a>;
<a name="l00348"></a>00348 
<a name="l00352"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad90a5b948d2eb5a79853e6644a0b8b00">00352</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1ContinuationSystem.php#ad90a5b948d2eb5a79853e6644a0b8b00">previous_u</a>;
<a name="l00353"></a>00353 
<a name="l00357"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">00357</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1ContinuationSystem.php#af820547d41ab966362c384649416490b">y</a>;
<a name="l00358"></a>00358 
<a name="l00363"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#afde572b48fb8abf26c11e45df3de13c8">00363</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1ContinuationSystem.php#afde572b48fb8abf26c11e45df3de13c8">y_old</a>;
<a name="l00364"></a>00364 
<a name="l00368"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">00368</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1ae8e474c3fe8098e43cf492bd5e02b9">z</a>;
<a name="l00369"></a>00369 
<a name="l00374"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">00374</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a3126c8160b55c63afcd4181ae6fdcec6">delta_u</a>;
<a name="l00375"></a>00375 
<a name="l00381"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a13d62743d8c1ad7f52869d151208ac08">00381</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a13d62743d8c1ad7f52869d151208ac08">linear_solver</a>;
<a name="l00382"></a>00382   
<a name="l00386"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8baeade7451f926deb575dffeac428cb">00386</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a8baeade7451f926deb575dffeac428cb">tangent_initialized</a>;
<a name="l00387"></a>00387 
<a name="l00393"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">00393</a>   <a class="code" href="classlibMesh_1_1NewtonSolver.php">NewtonSolver</a>* <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a2bfbfa047bde7727566f009858c44936">newton_solver</a>;
<a name="l00394"></a>00394   
<a name="l00400"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">00400</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a9550dbf729cf9a1aac8f46f8bd02e413">dlambda_ds</a>;
<a name="l00401"></a>00401 
<a name="l00407"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a113feb65e8fc969228ce08e71971aae6">00407</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a113feb65e8fc969228ce08e71971aae6">ds</a>;
<a name="l00408"></a>00408   
<a name="l00413"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">00413</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a1a9615c4935bde72cc723c4ad9356d17">ds_current</a>;
<a name="l00414"></a>00414 
<a name="l00418"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a0cf5468ad5b4aef78f63c4f30395c7b5">00418</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a0cf5468ad5b4aef78f63c4f30395c7b5">previous_dlambda_ds</a>;
<a name="l00419"></a>00419 
<a name="l00423"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6fb1f05891c1986f8b3294ae7de8038e">00423</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#a6fb1f05891c1986f8b3294ae7de8038e">previous_ds</a>;
<a name="l00424"></a>00424 
<a name="l00428"></a><a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">00428</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ContinuationSystem.php#abb52b3e342e9ce329a7e4bfeab1487bf">newton_step</a>;
<a name="l00429"></a>00429 };
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 } <span class="comment">// namespace libMesh</span>
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
