<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">coupling_matrix.h</div>  </div>
</div>
<div class="contents">
<a href="coupling__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: coupling_matrix.h 4153 2011-01-11 16:36:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __coupling_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __coupling_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00044"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php">00044</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1CouplingMatrix.php">CouplingMatrix</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 <span class="keyword">public</span>:
<a name="l00047"></a>00047   
<a name="l00051"></a>00051   <a class="code" href="classlibMesh_1_1CouplingMatrix.php#ab7c694b0052cc103484d504f77e0b840">CouplingMatrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0);
<a name="l00052"></a>00052 
<a name="l00056"></a>00056   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a57fe58802e9559d948b42d0770c91194">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00057"></a>00057                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00058"></a>00058   
<a name="l00063"></a>00063   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> &amp; <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a57fe58802e9559d948b42d0770c91194">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00064"></a>00064                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00065"></a>00065   
<a name="l00070"></a>00070   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#ae185f5ff037a9a838aa18d7f9537ff6d">size</a>() <span class="keyword">const</span>;
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a2b45a9ae0680364a6dab1e9945786ead">resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00077"></a>00077 
<a name="l00081"></a>00081   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#aebd53152c48194ed96e71f176153762b">clear</a>();
<a name="l00082"></a>00082 
<a name="l00086"></a>00086   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#aa4e4b91867c63a57cf985147205d82cd">empty</a>() <span class="keyword">const</span>;
<a name="l00087"></a>00087   
<a name="l00088"></a>00088 <span class="keyword">private</span>:
<a name="l00089"></a>00089   
<a name="l00096"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php#a639e3cbf47653b0946d5f505c5919793">00096</a>   std::vector&lt;unsigned char&gt; <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a639e3cbf47653b0946d5f505c5919793">_values</a>;  
<a name="l00097"></a>00097 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">00101</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a>;
<a name="l00102"></a>00102 };
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="comment">//--------------------------------------------------</span>
<a name="l00110"></a>00110 <span class="comment">// CouplingMatrix inline methods</span>
<a name="l00111"></a>00111 <span class="keyword">inline</span>
<a name="l00112"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php#ab7c694b0052cc103484d504f77e0b840">00112</a> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#ab7c694b0052cc103484d504f77e0b840">CouplingMatrix::CouplingMatrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) :
<a name="l00113"></a>00113   _values(), _size(n)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115   this-&gt;<a class="code" href="classlibMesh_1_1CouplingMatrix.php#a2b45a9ae0680364a6dab1e9945786ead">resize</a>(n);
<a name="l00116"></a>00116 }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">inline</span>
<a name="l00121"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php#a57fe58802e9559d948b42d0770c91194">00121</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a57fe58802e9559d948b42d0770c91194">CouplingMatrix::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00122"></a>00122                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00123"></a>00123 <span class="keyword"></span>{
<a name="l00124"></a>00124   libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a>);
<a name="l00125"></a>00125   libmesh_assert (j &lt; <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a>);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a639e3cbf47653b0946d5f505c5919793">_values</a>[i*<a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a> + j];
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="keyword">inline</span>
<a name="l00133"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php#a8c4182149cdd77f26c473ea43b1679ee">00133</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> &amp; <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a57fe58802e9559d948b42d0770c91194">CouplingMatrix::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00134"></a>00134                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00135"></a>00135 {
<a name="l00136"></a>00136   libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a>);
<a name="l00137"></a>00137   libmesh_assert (j &lt; <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a>);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a639e3cbf47653b0946d5f505c5919793">_values</a>[i*<a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a> + j];
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="keyword">inline</span>
<a name="l00145"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php#ae185f5ff037a9a838aa18d7f9537ff6d">00145</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#ae185f5ff037a9a838aa18d7f9537ff6d">CouplingMatrix::size</a>()<span class="keyword"> const</span>
<a name="l00146"></a>00146 <span class="keyword"></span>{
<a name="l00147"></a>00147   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a>;
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">inline</span>
<a name="l00153"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php#a2b45a9ae0680364a6dab1e9945786ead">00153</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a2b45a9ae0680364a6dab1e9945786ead">CouplingMatrix::resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00154"></a>00154 {
<a name="l00155"></a>00155   <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a> = n;
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a639e3cbf47653b0946d5f505c5919793">_values</a>.resize(<a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a>*<a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a>);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1CouplingMatrix.php#a639e3cbf47653b0946d5f505c5919793">_values</a>.size(); i++)
<a name="l00160"></a>00160     <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a639e3cbf47653b0946d5f505c5919793">_values</a>[i] = 0;
<a name="l00161"></a>00161 }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="keyword">inline</span>
<a name="l00166"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php#aebd53152c48194ed96e71f176153762b">00166</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#aebd53152c48194ed96e71f176153762b">CouplingMatrix::clear</a>()
<a name="l00167"></a>00167 {
<a name="l00168"></a>00168   <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a> = 0;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1CouplingMatrix.php#a639e3cbf47653b0946d5f505c5919793">_values</a>.clear();
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="keyword">inline</span>
<a name="l00176"></a><a class="code" href="classlibMesh_1_1CouplingMatrix.php#aa4e4b91867c63a57cf985147205d82cd">00176</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1CouplingMatrix.php#aa4e4b91867c63a57cf985147205d82cd">CouplingMatrix::empty</a>()<span class="keyword"> const</span>
<a name="l00177"></a>00177 <span class="keyword"></span>{
<a name="l00178"></a>00178   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1CouplingMatrix.php#a0e63cd0badc321431e234c1f43e76f62">_size</a> == 0);
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 } <span class="comment">// namespace libMesh</span>
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
