<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dense_matrix.C</div>  </div>
</div>
<div class="contents">
<a href="dense__matrix_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_matrix.C 4329 2011-04-07 17:57:59Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ Includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for sqrt</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// Dense Matrix member functions</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00038"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f189109a2760176e9541bce50cd216d">00038</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f189109a2760176e9541bce50cd216d">DenseMatrix&lt;T&gt;::left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00041"></a>00041     this-&gt;_multiply_blas(M2, LEFT_MULTIPLY);
<a name="l00042"></a>00042   <span class="keywordflow">else</span>
<a name="l00043"></a>00043     {
<a name="l00044"></a>00044       <span class="comment">// (*this) &lt;- M2 * (*this)</span>
<a name="l00045"></a>00045       <span class="comment">// Where:</span>
<a name="l00046"></a>00046       <span class="comment">// (*this) = (m x n),</span>
<a name="l00047"></a>00047       <span class="comment">// M2      = (m x p),</span>
<a name="l00048"></a>00048       <span class="comment">// M3      = (p x n)</span>
<a name="l00049"></a>00049   
<a name="l00050"></a>00050       <span class="comment">// M3 is a copy of *this before it gets resize()d</span>
<a name="l00051"></a>00051       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> M3(*<span class="keyword">this</span>);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053       <span class="comment">// Resize *this so that the result can fit</span>
<a name="l00054"></a>00054       this-&gt;resize (M2.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(), M3.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00055"></a>00055 
<a name="l00056"></a>00056       <span class="comment">// Call the multiply function in the base class</span>
<a name="l00057"></a>00057       this-&gt;multiply(*<span class="keyword">this</span>, M2, M3);
<a name="l00058"></a>00058     }
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00065"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">00065</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">DenseMatrix&lt;T&gt;::left_multiply_transpose</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A)
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00068"></a>00068     this-&gt;_multiply_blas(A, LEFT_MULTIPLY_TRANSPOSE);
<a name="l00069"></a>00069   <span class="keywordflow">else</span>
<a name="l00070"></a>00070     {
<a name="l00071"></a>00071       <span class="comment">//Check to see if we are doing (A^T)*A</span>
<a name="l00072"></a>00072       <span class="keywordflow">if</span> (<span class="keyword">this</span> == &amp;A)
<a name="l00073"></a>00073         {
<a name="l00074"></a>00074           <span class="comment">//libmesh_here();</span>
<a name="l00075"></a>00075           <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> B(*<span class="keyword">this</span>);
<a name="l00076"></a>00076       
<a name="l00077"></a>00077           <span class="comment">// Simple but inefficient way</span>
<a name="l00078"></a>00078           <span class="comment">// return this-&gt;left_multiply_transpose(B);</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080           <span class="comment">// More efficient, but more code way</span>
<a name="l00081"></a>00081           <span class="comment">// If A is mxn, the result will be a square matrix of Size n x n.</span>
<a name="l00082"></a>00082           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m = A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>();
<a name="l00083"></a>00083           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>();
<a name="l00084"></a>00084 
<a name="l00085"></a>00085           <span class="comment">// resize() *this and also zero out all entries.</span>
<a name="l00086"></a>00086           this-&gt;resize(n,n);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088           <span class="comment">// Compute the lower-triangular part</span>
<a name="l00089"></a>00089           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00090"></a>00090             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; ++j)
<a name="l00091"></a>00091               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;m; ++k) <span class="comment">// inner products are over m</span>
<a name="l00092"></a>00092                 (*<span class="keyword">this</span>)(i,j) += B(k,i)*B(k,j);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094           <span class="comment">// Copy lower-triangular part into upper-triangular part</span>
<a name="l00095"></a>00095           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00096"></a>00096             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;n; ++j)
<a name="l00097"></a>00097               (*<span class="keyword">this</span>)(i,j) = (*<span class="keyword">this</span>)(j,i);
<a name="l00098"></a>00098         }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100       <span class="keywordflow">else</span>
<a name="l00101"></a>00101         {
<a name="l00102"></a>00102           <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> B(*<span class="keyword">this</span>);
<a name="l00103"></a>00103   
<a name="l00104"></a>00104           this-&gt;resize (A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(), B.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00105"></a>00105       
<a name="l00106"></a>00106           libmesh_assert (A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == B.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00107"></a>00107           libmesh_assert (this-&gt;m() == A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00108"></a>00108           libmesh_assert (this-&gt;n() == B.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00109"></a>00109       
<a name="l00110"></a>00110           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_s = A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>();
<a name="l00111"></a>00111           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_s = A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(); 
<a name="l00112"></a>00112           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_s = this-&gt;n();
<a name="l00113"></a>00113   
<a name="l00114"></a>00114           <span class="comment">// Do it this way because there is a</span>
<a name="l00115"></a>00115           <span class="comment">// decent chance (at least for constraint matrices)</span>
<a name="l00116"></a>00116           <span class="comment">// that A.transpose(i,k) = 0.</span>
<a name="l00117"></a>00117           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m_s; i++)
<a name="l00118"></a>00118             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;p_s; k++)
<a name="l00119"></a>00119               <span class="keywordflow">if</span> (A.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,k) != 0.)
<a name="l00120"></a>00120                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_s; j++)
<a name="l00121"></a>00121                   (*<span class="keyword">this</span>)(i,j) += A.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,k)*B(k,j);
<a name="l00122"></a>00122         }
<a name="l00123"></a>00123     }
<a name="l00124"></a>00124   
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00133"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">00133</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">DenseMatrix&lt;T&gt;::right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3)
<a name="l00134"></a>00134 {
<a name="l00135"></a>00135   <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00136"></a>00136     this-&gt;_multiply_blas(M3, RIGHT_MULTIPLY);
<a name="l00137"></a>00137   <span class="keywordflow">else</span>
<a name="l00138"></a>00138     {
<a name="l00139"></a>00139       <span class="comment">// (*this) &lt;- M3 * (*this)</span>
<a name="l00140"></a>00140       <span class="comment">// Where:</span>
<a name="l00141"></a>00141       <span class="comment">// (*this) = (m x n),</span>
<a name="l00142"></a>00142       <span class="comment">// M2      = (m x p),</span>
<a name="l00143"></a>00143       <span class="comment">// M3      = (p x n)</span>
<a name="l00144"></a>00144 
<a name="l00145"></a>00145       <span class="comment">// M2 is a copy of *this before it gets resize()d</span>
<a name="l00146"></a>00146       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> M2(*<span class="keyword">this</span>);
<a name="l00147"></a>00147 
<a name="l00148"></a>00148       <span class="comment">// Resize *this so that the result can fit</span>
<a name="l00149"></a>00149       this-&gt;resize (M2.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(), M3.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00150"></a>00150   
<a name="l00151"></a>00151       this-&gt;multiply(*<span class="keyword">this</span>, M2, M3);
<a name="l00152"></a>00152     }
<a name="l00153"></a>00153 }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00159"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a2936a147980a3643fdb637ab78c251c9">00159</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a2936a147980a3643fdb637ab78c251c9">DenseMatrix&lt;T&gt;::right_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; B)
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161   <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00162"></a>00162     this-&gt;_multiply_blas(B, RIGHT_MULTIPLY_TRANSPOSE);
<a name="l00163"></a>00163   <span class="keywordflow">else</span>
<a name="l00164"></a>00164     {
<a name="l00165"></a>00165       <span class="comment">//Check to see if we are doing B*(B^T)</span>
<a name="l00166"></a>00166       <span class="keywordflow">if</span> (<span class="keyword">this</span> == &amp;B)
<a name="l00167"></a>00167         {
<a name="l00168"></a>00168           <span class="comment">//libmesh_here();</span>
<a name="l00169"></a>00169           <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> A(*<span class="keyword">this</span>);
<a name="l00170"></a>00170       
<a name="l00171"></a>00171           <span class="comment">// Simple but inefficient way</span>
<a name="l00172"></a>00172           <span class="comment">// return this-&gt;right_multiply_transpose(A);</span>
<a name="l00173"></a>00173 
<a name="l00174"></a>00174           <span class="comment">// More efficient, more code</span>
<a name="l00175"></a>00175           <span class="comment">// If B is mxn, the result will be a square matrix of Size m x m.</span>
<a name="l00176"></a>00176           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m = B.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>();
<a name="l00177"></a>00177           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = B.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>();
<a name="l00178"></a>00178 
<a name="l00179"></a>00179           <span class="comment">// resize() *this and also zero out all entries.</span>
<a name="l00180"></a>00180           this-&gt;resize(m,m);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182           <span class="comment">// Compute the lower-triangular part</span>
<a name="l00183"></a>00183           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00184"></a>00184             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;=i; ++j)
<a name="l00185"></a>00185               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;n; ++k) <span class="comment">// inner products are over n</span>
<a name="l00186"></a>00186                 (*<span class="keyword">this</span>)(i,j) += A(i,k)*A(j,k);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188           <span class="comment">// Copy lower-triangular part into upper-triangular part</span>
<a name="l00189"></a>00189           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00190"></a>00190             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;m; ++j)
<a name="l00191"></a>00191               (*<span class="keyword">this</span>)(i,j) = (*<span class="keyword">this</span>)(j,i);
<a name="l00192"></a>00192         }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194       <span class="keywordflow">else</span>
<a name="l00195"></a>00195         {
<a name="l00196"></a>00196           <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> A(*<span class="keyword">this</span>);
<a name="l00197"></a>00197   
<a name="l00198"></a>00198           this-&gt;resize (A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(), B.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00199"></a>00199       
<a name="l00200"></a>00200           libmesh_assert (A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == B.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00201"></a>00201           libmesh_assert (this-&gt;m() == A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00202"></a>00202           libmesh_assert (this-&gt;n() == B.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00203"></a>00203       
<a name="l00204"></a>00204           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_s = A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>();
<a name="l00205"></a>00205           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_s = A.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); 
<a name="l00206"></a>00206           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_s = this-&gt;n();
<a name="l00207"></a>00207 
<a name="l00208"></a>00208           <span class="comment">// Do it this way because there is a</span>
<a name="l00209"></a>00209           <span class="comment">// decent chance (at least for constraint matrices)</span>
<a name="l00210"></a>00210           <span class="comment">// that B.transpose(k,j) = 0.</span>
<a name="l00211"></a>00211           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_s; j++)
<a name="l00212"></a>00212             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;p_s; k++)
<a name="l00213"></a>00213               <span class="keywordflow">if</span> (B.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(k,j) != 0.)
<a name="l00214"></a>00214                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m_s; i++)
<a name="l00215"></a>00215                   (*<span class="keyword">this</span>)(i,j) += A(i,k)*B.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(k,j);
<a name="l00216"></a>00216         }
<a name="l00217"></a>00217     }
<a name="l00218"></a>00218 }
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00223"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">00223</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">DenseMatrix&lt;T&gt;::vector_mult</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, 
<a name="l00224"></a>00224                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00225"></a>00225 <span class="keyword"></span>{
<a name="l00226"></a>00226   <span class="comment">// Make sure the input sizes are compatible</span>
<a name="l00227"></a>00227   libmesh_assert(this-&gt;n() == arg.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="comment">// Resize and clear dest.</span>
<a name="l00230"></a>00230   <span class="comment">// Note: DenseVector::resize() also zeros the vector.</span>
<a name="l00231"></a>00231   dest.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(this-&gt;m());
<a name="l00232"></a>00232   
<a name="l00233"></a>00233   <span class="comment">// Short-circuit if the matrix is empty</span>
<a name="l00234"></a>00234   <span class="keywordflow">if</span>(this-&gt;m() == 0)
<a name="l00235"></a>00235     <span class="keywordflow">return</span>;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00238"></a>00238     this-&gt;_matvec_blas(1., 0., dest, arg);
<a name="l00239"></a>00239   <span class="keywordflow">else</span>
<a name="l00240"></a>00240     {
<a name="l00241"></a>00241       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = this-&gt;m();
<a name="l00242"></a>00242       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cols = this-&gt;n();
<a name="l00243"></a>00243 
<a name="l00244"></a>00244       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_rows; i++)
<a name="l00245"></a>00245         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_cols; j++)
<a name="l00246"></a>00246           dest(i) += (*this)(i,j)*arg(j);
<a name="l00247"></a>00247     }
<a name="l00248"></a>00248 }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00254"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ace7e590c10044121b6b348c3301e545a">00254</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ace7e590c10044121b6b348c3301e545a">DenseMatrix&lt;T&gt;::vector_mult_transpose</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, 
<a name="l00255"></a>00255                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00256"></a>00256 <span class="keyword"></span>{
<a name="l00257"></a>00257   <span class="comment">// Make sure the input sizes are compatible</span>
<a name="l00258"></a>00258   libmesh_assert(this-&gt;m() == arg.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="comment">// Resize and clear dest.</span>
<a name="l00261"></a>00261   <span class="comment">// Note: DenseVector::resize() also zeros the vector.</span>
<a name="l00262"></a>00262   dest.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(this-&gt;n());
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="comment">// Short-circuit if the matrix is empty</span>
<a name="l00265"></a>00265   <span class="keywordflow">if</span>(this-&gt;m() == 0)
<a name="l00266"></a>00266     <span class="keywordflow">return</span>;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00269"></a>00269     {
<a name="l00270"></a>00270       this-&gt;_matvec_blas(1., 0., dest, arg, <span class="comment">/*trans=*/</span><span class="keyword">true</span>); 
<a name="l00271"></a>00271     }
<a name="l00272"></a>00272   <span class="keywordflow">else</span>
<a name="l00273"></a>00273     {
<a name="l00274"></a>00274       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = this-&gt;m();
<a name="l00275"></a>00275       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cols = this-&gt;n();
<a name="l00276"></a>00276 
<a name="l00277"></a>00277       <span class="comment">// WORKS</span>
<a name="l00278"></a>00278       <span class="comment">// for(unsigned int j=0; j&lt;n_cols; j++)</span>
<a name="l00279"></a>00279       <span class="comment">//   for(unsigned int i=0; i&lt;n_rows; i++)</span>
<a name="l00280"></a>00280       <span class="comment">//     dest(j) += (*this)(i,j)*arg(i);</span>
<a name="l00281"></a>00281 
<a name="l00282"></a>00282       <span class="comment">// ALSO WORKS, (i,j) just swapped</span>
<a name="l00283"></a>00283       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_cols; i++)
<a name="l00284"></a>00284         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_rows; j++)
<a name="l00285"></a>00285           dest(i) += (*this)(j,i)*arg(j);
<a name="l00286"></a>00286     }
<a name="l00287"></a>00287 }
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00292"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#aa524e3051fffc87a03e16791d917284a">00292</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa524e3051fffc87a03e16791d917284a">DenseMatrix&lt;T&gt;::vector_mult_add</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, 
<a name="l00293"></a>00293                                       <span class="keyword">const</span> T factor,
<a name="l00294"></a>00294                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg)<span class="keyword"> const</span>
<a name="l00295"></a>00295 <span class="keyword"></span>{
<a name="l00296"></a>00296   <span class="comment">// Short-circuit if the matrix is empty</span>
<a name="l00297"></a>00297   <span class="keywordflow">if</span>(this-&gt;m() == 0)
<a name="l00298"></a>00298   {
<a name="l00299"></a>00299     dest.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(0);
<a name="l00300"></a>00300     <span class="keywordflow">return</span>;
<a name="l00301"></a>00301   }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00304"></a>00304     this-&gt;_matvec_blas(factor, 1., dest, arg);
<a name="l00305"></a>00305   <span class="keywordflow">else</span>
<a name="l00306"></a>00306     {
<a name="l00307"></a>00307       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a> temp(arg.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00308"></a>00308       this-&gt;vector_mult(temp, arg);
<a name="l00309"></a>00309       dest.<a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">add</a>(factor, temp);
<a name="l00310"></a>00310     }
<a name="l00311"></a>00311 }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00316"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">00316</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">DenseMatrix&lt;T&gt;::get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m,
<a name="l00317"></a>00317                                               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_n,
<a name="l00318"></a>00318                                               <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00319"></a>00319 <span class="keyword"></span>{
<a name="l00320"></a>00320   libmesh_assert( (sub_m &lt;= this-&gt;m()) &amp;&amp; (sub_n &lt;= this-&gt;n()) );
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   dest.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(sub_m, sub_n);
<a name="l00323"></a>00323   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;sub_m; i++)
<a name="l00324"></a>00324     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;sub_n; j++)
<a name="l00325"></a>00325       dest(i,j) = (*this)(i,j);
<a name="l00326"></a>00326 }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00331"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a0d77a3261b71d9fe94bec7c4ada662f3">00331</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">DenseMatrix&lt;T&gt;::get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00332"></a>00332 <span class="keyword"></span>{
<a name="l00333"></a>00333   get_principal_submatrix(sub_m, sub_m, dest);
<a name="l00334"></a>00334 }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00339"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a66347c890f7fd45143f6d0b8898713d1">00339</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a66347c890f7fd45143f6d0b8898713d1">DenseMatrix&lt;T&gt;::get_transpose</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00340"></a>00340 <span class="keyword"></span>{
<a name="l00341"></a>00341   dest.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(this-&gt;n(), this-&gt;m());
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dest.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(); i++)
<a name="l00344"></a>00344     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;dest.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00345"></a>00345       dest(i,j) = (*this)(j,i);
<a name="l00346"></a>00346 }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00352"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">00352</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">DenseMatrix&lt;T&gt;::lu_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00353"></a>00353                                <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x)
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   <span class="comment">// Check to be sure that the matrix is square before attempting</span>
<a name="l00356"></a>00356   <span class="comment">// an LU-solve.  In general, one can compute the LU factorization of</span>
<a name="l00357"></a>00357   <span class="comment">// a non-square matrix, but:</span>
<a name="l00358"></a>00358   <span class="comment">//</span>
<a name="l00359"></a>00359   <span class="comment">// Overdetermined systems (m&gt;n) have a solution only if enough of</span>
<a name="l00360"></a>00360   <span class="comment">// the equations are linearly-dependent.</span>
<a name="l00361"></a>00361   <span class="comment">//</span>
<a name="l00362"></a>00362   <span class="comment">// Underdetermined systems (m&lt;n) typically have infinitely many</span>
<a name="l00363"></a>00363   <span class="comment">// solutions.</span>
<a name="l00364"></a>00364   <span class="comment">// </span>
<a name="l00365"></a>00365   <span class="comment">// We don&#39;t want to deal with either of these ambiguous cases here...</span>
<a name="l00366"></a>00366   libmesh_assert (this-&gt;m() == this-&gt;n());
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="keywordflow">switch</span>(this-&gt;_decomposition_type)
<a name="l00369"></a>00369     {
<a name="l00370"></a>00370     <span class="keywordflow">case</span> NONE:
<a name="l00371"></a>00371       {
<a name="l00372"></a>00372         <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00373"></a>00373           this-&gt;_lu_decompose_lapack();   
<a name="l00374"></a>00374         <span class="keywordflow">else</span>
<a name="l00375"></a>00375           this-&gt;_lu_decompose ();
<a name="l00376"></a>00376         <span class="keywordflow">break</span>;
<a name="l00377"></a>00377       }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379     <span class="keywordflow">case</span> LU_BLAS_LAPACK:
<a name="l00380"></a>00380       {
<a name="l00381"></a>00381         <span class="comment">// Already factored, just need to call back_substitute.</span>
<a name="l00382"></a>00382         <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00383"></a>00383           <span class="keywordflow">break</span>;
<a name="l00384"></a>00384       }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386     <span class="keywordflow">case</span> LU:
<a name="l00387"></a>00387       {
<a name="l00388"></a>00388         <span class="comment">// Already factored, just need to call back_substitute.</span>
<a name="l00389"></a>00389         <span class="keywordflow">if</span> ( !(this-&gt;use_blas_lapack) )
<a name="l00390"></a>00390           <span class="keywordflow">break</span>;
<a name="l00391"></a>00391       }
<a name="l00392"></a>00392 
<a name="l00393"></a>00393     <span class="keywordflow">default</span>:
<a name="l00394"></a>00394       {
<a name="l00395"></a>00395         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error! This matrix already has a &quot;</span>
<a name="l00396"></a>00396                       &lt;&lt; <span class="stringliteral">&quot;different decomposition...&quot;</span>
<a name="l00397"></a>00397                       &lt;&lt; std::endl;
<a name="l00398"></a>00398         libmesh_error();
<a name="l00399"></a>00399       }
<a name="l00400"></a>00400     }
<a name="l00401"></a>00401 
<a name="l00402"></a>00402   <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00403"></a>00403      this-&gt;_lu_back_substitute_lapack (b, x);
<a name="l00404"></a>00404   <span class="keywordflow">else</span>
<a name="l00405"></a>00405     this-&gt;_lu_back_substitute (b, x);
<a name="l00406"></a>00406 }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00414"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a89a35b300c65ec74fe85b3d2504508ba">00414</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a89a35b300c65ec74fe85b3d2504508ba">DenseMatrix&lt;T&gt;::_lu_back_substitute</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00415"></a>00415                                           <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x )<span class="keyword"> const</span>
<a name="l00416"></a>00416 <span class="keyword"></span>{
<a name="l00417"></a>00417   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00418"></a>00418     n = this-&gt;n();
<a name="l00419"></a>00419 
<a name="l00420"></a>00420   libmesh_assert (this-&gt;m() == n);
<a name="l00421"></a>00421   libmesh_assert (this-&gt;m() == b.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00422"></a>00422   
<a name="l00423"></a>00423   x.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a> (n);
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="comment">// A convenient reference to *this</span>
<a name="l00426"></a>00426   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   <span class="comment">// Temporary vector storage.  We use this instead of</span>
<a name="l00429"></a>00429   <span class="comment">// modifying the RHS.  </span>
<a name="l00430"></a>00430   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a> z = b;
<a name="l00431"></a>00431   
<a name="l00432"></a>00432   <span class="comment">// Lower-triangular &quot;top to bottom&quot; solve step, taking into account pivots</span>
<a name="l00433"></a>00433   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00434"></a>00434     {
<a name="l00435"></a>00435       <span class="comment">// Swap</span>
<a name="l00436"></a>00436       <span class="keywordflow">if</span> (_pivots[i] != static_cast&lt;int&gt;(i))
<a name="l00437"></a>00437         std::swap( z(i), z(_pivots[i]) );
<a name="l00438"></a>00438 
<a name="l00439"></a>00439       x(i) = z(i);
<a name="l00440"></a>00440           
<a name="l00441"></a>00441       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;i; ++j)
<a name="l00442"></a>00442         x(i) -= A(i,j)*x(j);
<a name="l00443"></a>00443           
<a name="l00444"></a>00444       x(i) /= A(i,i);
<a name="l00445"></a>00445     }
<a name="l00446"></a>00446 
<a name="l00447"></a>00447   <span class="comment">// Upper-triangular &quot;bottom to top&quot; solve step</span>
<a name="l00448"></a>00448   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_row = n-1;
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=last_row; i&gt;=0; --i)
<a name="l00451"></a>00451     {
<a name="l00452"></a>00452       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=i+1; j&lt;static_cast&lt;int&gt;(n); ++j)
<a name="l00453"></a>00453         x(i) -= A(i,j)*x(j);
<a name="l00454"></a>00454     }
<a name="l00455"></a>00455 }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00465"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a1455b27da806fa1dbc733eab6d1cbe94">00465</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1455b27da806fa1dbc733eab6d1cbe94">DenseMatrix&lt;T&gt;::_lu_decompose</a> ()
<a name="l00466"></a>00466 {
<a name="l00467"></a>00467   <span class="comment">// If this function was called, there better not be any</span>
<a name="l00468"></a>00468   <span class="comment">// previous decomposition of the matrix.</span>
<a name="l00469"></a>00469   libmesh_assert(this-&gt;_decomposition_type == NONE);
<a name="l00470"></a>00470   
<a name="l00471"></a>00471   <span class="comment">// Get the matrix size and make sure it is square</span>
<a name="l00472"></a>00472   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00473"></a>00473     m = this-&gt;m();
<a name="l00474"></a>00474 
<a name="l00475"></a>00475   <span class="comment">// A convenient reference to *this</span>
<a name="l00476"></a>00476   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00477"></a>00477   
<a name="l00478"></a>00478   _pivots.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(m);
<a name="l00479"></a>00479       
<a name="l00480"></a>00480   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00481"></a>00481     {
<a name="l00482"></a>00482       <span class="comment">// Find the pivot row by searching down the i&#39;th column</span>
<a name="l00483"></a>00483       _pivots[i] = i;
<a name="l00484"></a>00484 
<a name="l00485"></a>00485       <span class="comment">// std::abs(complex) must return a Real!</span>
<a name="l00486"></a>00486       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = std::abs( A(i,i) );
<a name="l00487"></a>00487       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;m; ++j)
<a name="l00488"></a>00488         {
<a name="l00489"></a>00489           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> candidate_max = std::abs( A(j,i) );
<a name="l00490"></a>00490           <span class="keywordflow">if</span> (max &lt; candidate_max)
<a name="l00491"></a>00491             {
<a name="l00492"></a>00492               max = candidate_max;
<a name="l00493"></a>00493               _pivots[i] = j;
<a name="l00494"></a>00494             }
<a name="l00495"></a>00495         }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497       <span class="comment">// libMesh::out &lt;&lt; &quot;max=&quot; &lt;&lt; max &lt;&lt; &quot; found at row &quot; &lt;&lt; _pivots[i] &lt;&lt; std::endl;</span>
<a name="l00498"></a>00498 
<a name="l00499"></a>00499       <span class="comment">// If the max was found in a different row, interchange rows.</span>
<a name="l00500"></a>00500       <span class="comment">// Here we interchange the *entire* row, in Gaussian elimination</span>
<a name="l00501"></a>00501       <span class="comment">// you would only interchange the subrows A(i,j) and A(p(i),j), for j&gt;i</span>
<a name="l00502"></a>00502       <span class="keywordflow">if</span> (_pivots[i] != static_cast&lt;int&gt;(i))
<a name="l00503"></a>00503         {
<a name="l00504"></a>00504           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;m; ++j)
<a name="l00505"></a>00505             std::swap( A(i,j), A(_pivots[i], j) );
<a name="l00506"></a>00506         }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508           
<a name="l00509"></a>00509       <span class="comment">// If the max abs entry found is zero, the matrix is singular</span>
<a name="l00510"></a>00510       <span class="keywordflow">if</span> (A(i,i) == <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>)
<a name="l00511"></a>00511         {
<a name="l00512"></a>00512           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Matrix A is singular!&quot;</span> &lt;&lt; std::endl;
<a name="l00513"></a>00513           libmesh_error();
<a name="l00514"></a>00514         }
<a name="l00515"></a>00515 
<a name="l00516"></a>00516       <span class="comment">// Scale upper triangle entries of row i by the diagonal entry</span>
<a name="l00517"></a>00517       <span class="comment">// Note: don&#39;t scale the diagonal entry itself! </span>
<a name="l00518"></a>00518       <span class="keyword">const</span> T diag_inv = 1. / A(i,i);
<a name="l00519"></a>00519       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i+1; j&lt;m; ++j)
<a name="l00520"></a>00520         A(i,j) *= diag_inv;
<a name="l00521"></a>00521 
<a name="l00522"></a>00522       <span class="comment">// Update the remaining sub-matrix A[i+1:m][i+1:m]</span>
<a name="l00523"></a>00523       <span class="comment">// by subtracting off (the diagonal-scaled)</span>
<a name="l00524"></a>00524       <span class="comment">// upper-triangular part of row i, scaled by the</span>
<a name="l00525"></a>00525       <span class="comment">// i&#39;th column entry of each row.  In terms of</span>
<a name="l00526"></a>00526       <span class="comment">// row operations, this is:</span>
<a name="l00527"></a>00527       <span class="comment">// for each r &gt; i</span>
<a name="l00528"></a>00528       <span class="comment">//   SubRow(r) = SubRow(r) - A(r,i)*SubRow(i)</span>
<a name="l00529"></a>00529       <span class="comment">//</span>
<a name="l00530"></a>00530       <span class="comment">// If we were scaling the i&#39;th column as well, like</span>
<a name="l00531"></a>00531       <span class="comment">// in Gaussian elimination, this would &#39;zero&#39; the</span>
<a name="l00532"></a>00532       <span class="comment">// entry in the i&#39;th column.</span>
<a name="l00533"></a>00533       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row=i+1; row&lt;m; ++row)
<a name="l00534"></a>00534         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> col=i+1; col&lt;m; ++col)
<a name="l00535"></a>00535           A(row,col) -= A(row,i) * A(i,col);
<a name="l00536"></a>00536               
<a name="l00537"></a>00537     } <span class="comment">// end i loop</span>
<a name="l00538"></a>00538   
<a name="l00539"></a>00539   <span class="comment">// Set the flag for LU decomposition</span>
<a name="l00540"></a>00540   this-&gt;_decomposition_type = LU;
<a name="l00541"></a>00541 }
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00546"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a5f3041ad291a970fb632481e01aae17f">00546</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a5f3041ad291a970fb632481e01aae17f">DenseMatrix&lt;T&gt;::svd</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; sigma)
<a name="l00547"></a>00547 {
<a name="l00548"></a>00548   <span class="comment">// We use the LAPACK svd implementation</span>
<a name="l00549"></a>00549   _svd_lapack(sigma);
<a name="l00550"></a>00550 }
<a name="l00551"></a>00551 
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00554"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4c6f60b5e54a4d53e20558ea834b1a4">00554</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a5f3041ad291a970fb632481e01aae17f">DenseMatrix&lt;T&gt;::svd</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; sigma, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; U, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; VT)
<a name="l00555"></a>00555 {
<a name="l00556"></a>00556   <span class="comment">// We use the LAPACK svd implementation</span>
<a name="l00557"></a>00557   _svd_lapack(sigma, U, VT);
<a name="l00558"></a>00558 }
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00563"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ab4b217cc39f4135073b5dc30b3d157e2">00563</a> T <a class="code" href="classlibMesh_1_1DenseMatrix.php#ab4b217cc39f4135073b5dc30b3d157e2">DenseMatrix&lt;T&gt;::det</a> ()
<a name="l00564"></a>00564 {
<a name="l00565"></a>00565   <span class="keywordflow">switch</span>(this-&gt;_decomposition_type)
<a name="l00566"></a>00566     {
<a name="l00567"></a>00567     <span class="keywordflow">case</span> NONE:
<a name="l00568"></a>00568       {
<a name="l00569"></a>00569         <span class="comment">// First LU decompose the matrix.</span>
<a name="l00570"></a>00570         <span class="comment">// Note that the lu_decompose routine will check to see if the</span>
<a name="l00571"></a>00571         <span class="comment">// matrix is square so we don&#39;t worry about it.</span>
<a name="l00572"></a>00572         <span class="keywordflow">if</span> (this-&gt;use_blas_lapack)
<a name="l00573"></a>00573           this-&gt;_lu_decompose_lapack();   
<a name="l00574"></a>00574         <span class="keywordflow">else</span>
<a name="l00575"></a>00575           this-&gt;_lu_decompose ();
<a name="l00576"></a>00576       }
<a name="l00577"></a>00577     <span class="keywordflow">case</span> LU:
<a name="l00578"></a>00578     <span class="keywordflow">case</span> LU_BLAS_LAPACK:
<a name="l00579"></a>00579       {
<a name="l00580"></a>00580         <span class="comment">// Already decomposed, don&#39;t do anything</span>
<a name="l00581"></a>00581         <span class="keywordflow">break</span>;
<a name="l00582"></a>00582       }
<a name="l00583"></a>00583     <span class="keywordflow">default</span>:
<a name="l00584"></a>00584       {
<a name="l00585"></a>00585       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error! Can&#39;t compute the determinant under &quot;</span>
<a name="l00586"></a>00586                     &lt;&lt; <span class="stringliteral">&quot;the current decomposition.&quot;</span>
<a name="l00587"></a>00587                     &lt;&lt; std::endl;
<a name="l00588"></a>00588       libmesh_error();
<a name="l00589"></a>00589       }
<a name="l00590"></a>00590     }
<a name="l00591"></a>00591   
<a name="l00592"></a>00592   <span class="comment">// A variable to keep track of the running product of diagonal terms.</span>
<a name="l00593"></a>00593   T determinant = 1.;
<a name="l00594"></a>00594   
<a name="l00595"></a>00595   <span class="comment">// Loop over diagonal terms, computing the product.  In practice,</span>
<a name="l00596"></a>00596   <span class="comment">// be careful because this value could easily become too large to</span>
<a name="l00597"></a>00597   <span class="comment">// fit in a double or float.  To be safe, one should keep track of</span>
<a name="l00598"></a>00598   <span class="comment">// the power (of 10) of the determinant in a separate variable</span>
<a name="l00599"></a>00599   <span class="comment">// and maintain an order 1 value for the determinant itself.</span>
<a name="l00600"></a>00600   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_interchanges = 0;
<a name="l00601"></a>00601   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00602"></a>00602     {
<a name="l00603"></a>00603       <span class="keywordflow">if</span> (this-&gt;_decomposition_type==LU)      
<a name="l00604"></a>00604         <span class="keywordflow">if</span> (_pivots[i] != static_cast&lt;int&gt;(i))
<a name="l00605"></a>00605           n_interchanges++;
<a name="l00606"></a>00606       
<a name="l00607"></a>00607       <span class="comment">// Lapack pivots are 1-based!</span>
<a name="l00608"></a>00608       <span class="keywordflow">if</span> (this-&gt;_decomposition_type==LU_BLAS_LAPACK)      
<a name="l00609"></a>00609         <span class="keywordflow">if</span> (_pivots[i] != static_cast&lt;int&gt;(i+1))
<a name="l00610"></a>00610           n_interchanges++;
<a name="l00611"></a>00611       
<a name="l00612"></a>00612       determinant *= (*this)(i,i);
<a name="l00613"></a>00613     }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615   <span class="comment">// Compute sign of determinant, depends on number of row interchanges!</span>
<a name="l00616"></a>00616   <span class="comment">// The sign should be (-1)^{n}, where n is the number of interchanges.  </span>
<a name="l00617"></a>00617   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sign = n_interchanges % 2 == 0 ? 1. : -1.;
<a name="l00618"></a>00618   
<a name="l00619"></a>00619   <span class="keywordflow">return</span> sign*determinant;
<a name="l00620"></a>00620 }
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 <span class="comment">// The cholesky solve function first decomposes the matrix</span>
<a name="l00625"></a>00625 <span class="comment">// with cholesky_decompose and then uses the cholesky_back_substitute</span>
<a name="l00626"></a>00626 <span class="comment">// routine to find the solution x.</span>
<a name="l00627"></a>00627 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00628"></a>00628 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00629"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">00629</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">DenseMatrix&lt;T&gt;::cholesky_solve</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00630"></a>00630                                      <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x)
<a name="l00631"></a>00631 {
<a name="l00632"></a>00632   <span class="comment">// Check for a previous decomposition</span>
<a name="l00633"></a>00633   <span class="keywordflow">switch</span>(this-&gt;_decomposition_type)
<a name="l00634"></a>00634     {
<a name="l00635"></a>00635     <span class="keywordflow">case</span> NONE:
<a name="l00636"></a>00636       {
<a name="l00637"></a>00637         this-&gt;_cholesky_decompose ();
<a name="l00638"></a>00638         <span class="keywordflow">break</span>;
<a name="l00639"></a>00639       }
<a name="l00640"></a>00640 
<a name="l00641"></a>00641     <span class="keywordflow">case</span> CHOLESKY:
<a name="l00642"></a>00642       {
<a name="l00643"></a>00643         <span class="comment">// Already factored, just need to call back_substitute.</span>
<a name="l00644"></a>00644         <span class="keywordflow">break</span>;
<a name="l00645"></a>00645       }
<a name="l00646"></a>00646       
<a name="l00647"></a>00647     <span class="keywordflow">default</span>:
<a name="l00648"></a>00648       {
<a name="l00649"></a>00649         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error! This matrix already has a &quot;</span>
<a name="l00650"></a>00650                       &lt;&lt; <span class="stringliteral">&quot;different decomposition...&quot;</span>
<a name="l00651"></a>00651                       &lt;&lt; std::endl;
<a name="l00652"></a>00652         libmesh_error();
<a name="l00653"></a>00653       }
<a name="l00654"></a>00654     }
<a name="l00655"></a>00655 
<a name="l00656"></a>00656   <span class="comment">// Perform back substitution</span>
<a name="l00657"></a>00657   this-&gt;_cholesky_back_substitute (b, x);
<a name="l00658"></a>00658 }
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 <span class="comment">// This algorithm is based on the Cholesky decomposition in</span>
<a name="l00664"></a>00664 <span class="comment">// the Numerical Recipes in C book.</span>
<a name="l00665"></a>00665 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00666"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a0d41126a4cadcf798ea3009e8dd663b2">00666</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a0d41126a4cadcf798ea3009e8dd663b2">DenseMatrix&lt;T&gt;::_cholesky_decompose</a> ()
<a name="l00667"></a>00667 {
<a name="l00668"></a>00668   <span class="comment">// If we called this function, there better not be any</span>
<a name="l00669"></a>00669   <span class="comment">// previous decomposition of the matrix.</span>
<a name="l00670"></a>00670   libmesh_assert(this-&gt;_decomposition_type == NONE);
<a name="l00671"></a>00671   
<a name="l00672"></a>00672   <span class="comment">// Shorthand notation for number of rows and columns.</span>
<a name="l00673"></a>00673   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00674"></a>00674     m = this-&gt;m(),
<a name="l00675"></a>00675     n = this-&gt;n();
<a name="l00676"></a>00676 
<a name="l00677"></a>00677   <span class="comment">// Just to be really sure...</span>
<a name="l00678"></a>00678   libmesh_assert(m==n);
<a name="l00679"></a>00679 
<a name="l00680"></a>00680   <span class="comment">// A convenient reference to *this</span>
<a name="l00681"></a>00681   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00682"></a>00682   
<a name="l00683"></a>00683   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m; ++i)
<a name="l00684"></a>00684     {
<a name="l00685"></a>00685       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=i; j&lt;n; ++j)
<a name="l00686"></a>00686         {
<a name="l00687"></a>00687           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;i; ++k)
<a name="l00688"></a>00688             A(i,j) -= A(i,k) * A(j,k);
<a name="l00689"></a>00689 
<a name="l00690"></a>00690           <span class="keywordflow">if</span> (i == j)
<a name="l00691"></a>00691             {
<a name="l00692"></a>00692 <span class="preprocessor">#ifndef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00693"></a>00693 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (A(i,j) &lt;= 0.0)
<a name="l00694"></a>00694                 {
<a name="l00695"></a>00695                   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error! Can only use Cholesky decomposition &quot;</span>
<a name="l00696"></a>00696                                 &lt;&lt; <span class="stringliteral">&quot;with symmetric positive definite matrices.&quot;</span>
<a name="l00697"></a>00697                                 &lt;&lt; std::endl;
<a name="l00698"></a>00698                   libmesh_error();
<a name="l00699"></a>00699                 }
<a name="l00700"></a>00700 <span class="preprocessor">#endif</span>
<a name="l00701"></a>00701 <span class="preprocessor"></span>
<a name="l00702"></a>00702               A(i,i) = std::sqrt(A(i,j));
<a name="l00703"></a>00703             }
<a name="l00704"></a>00704           <span class="keywordflow">else</span>
<a name="l00705"></a>00705             A(j,i) = A(i,j) / A(i,i);
<a name="l00706"></a>00706         }
<a name="l00707"></a>00707     }
<a name="l00708"></a>00708   
<a name="l00709"></a>00709   <span class="comment">// Set the flag for CHOLESKY decomposition</span>
<a name="l00710"></a>00710   this-&gt;_decomposition_type = CHOLESKY;
<a name="l00711"></a>00711 }
<a name="l00712"></a>00712 
<a name="l00713"></a>00713 
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00716"></a>00716 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00717"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ae96215c54161e7f671a42737fc0ff873">00717</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae96215c54161e7f671a42737fc0ff873">DenseMatrix&lt;T&gt;::_cholesky_back_substitute</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00718"></a>00718                                                 <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x)<span class="keyword"> const</span>
<a name="l00719"></a>00719 <span class="keyword"></span>{
<a name="l00720"></a>00720   <span class="comment">// Shorthand notation for number of rows and columns.</span>
<a name="l00721"></a>00721   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00722"></a>00722     m = this-&gt;m(),
<a name="l00723"></a>00723     n = this-&gt;n();
<a name="l00724"></a>00724 
<a name="l00725"></a>00725   <span class="comment">// Just to be really sure...</span>
<a name="l00726"></a>00726   libmesh_assert(m==n);
<a name="l00727"></a>00727 
<a name="l00728"></a>00728   <span class="comment">// A convenient reference to *this</span>
<a name="l00729"></a>00729   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A = *<span class="keyword">this</span>;
<a name="l00730"></a>00730    
<a name="l00731"></a>00731   <span class="comment">// Now compute the solution to Ax =b using the factorization.</span>
<a name="l00732"></a>00732   x.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(m);
<a name="l00733"></a>00733   
<a name="l00734"></a>00734   <span class="comment">// Solve for Ly=b</span>
<a name="l00735"></a>00735   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00736"></a>00736     {
<a name="l00737"></a>00737       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;i; ++k)
<a name="l00738"></a>00738         b(i) -= A(i,k)*x(k);
<a name="l00739"></a>00739       
<a name="l00740"></a>00740       x(i) = b(i) / A(i,i);
<a name="l00741"></a>00741     }
<a name="l00742"></a>00742   
<a name="l00743"></a>00743   <span class="comment">// Solve for L^T x = y</span>
<a name="l00744"></a>00744   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00745"></a>00745     {
<a name="l00746"></a>00746       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ib = (n-1)-i;
<a name="l00747"></a>00747 
<a name="l00748"></a>00748       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=(ib+1); k&lt;n; ++k)
<a name="l00749"></a>00749         x(ib) -= A(k,ib) * x(k);
<a name="l00750"></a>00750       
<a name="l00751"></a>00751       x(ib) /= A(ib,ib);
<a name="l00752"></a>00752     }
<a name="l00753"></a>00753 }
<a name="l00754"></a>00754 
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 
<a name="l00757"></a>00757 
<a name="l00758"></a>00758 
<a name="l00759"></a>00759 
<a name="l00760"></a>00760 
<a name="l00761"></a>00761 
<a name="l00762"></a>00762 <span class="comment">// This routine is commented out since it is not really a memory</span>
<a name="l00763"></a>00763 <span class="comment">// efficient implementation.  Also, you don&#39;t *need* the inverse</span>
<a name="l00764"></a>00764 <span class="comment">// for anything, instead just use lu_solve to solve Ax=b.</span>
<a name="l00765"></a>00765 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00766"></a>00766 <span class="comment">// void DenseMatrix&lt;T&gt;::inverse ()</span>
<a name="l00767"></a>00767 <span class="comment">// {</span>
<a name="l00768"></a>00768 <span class="comment">//   // First LU decompose the matrix</span>
<a name="l00769"></a>00769 <span class="comment">//   // Note that the lu_decompose routine will check to see if the</span>
<a name="l00770"></a>00770 <span class="comment">//   // matrix is square so we don&#39;t worry about it.</span>
<a name="l00771"></a>00771 <span class="comment">//   if (!this-&gt;_lu_decomposed)</span>
<a name="l00772"></a>00772 <span class="comment">//     this-&gt;_lu_decompose();</span>
<a name="l00773"></a>00773 
<a name="l00774"></a>00774 <span class="comment">//   // A unit vector which will be used as a rhs</span>
<a name="l00775"></a>00775 <span class="comment">//   // to pick off a single value each time.</span>
<a name="l00776"></a>00776 <span class="comment">//   DenseVector&lt;T&gt; e;</span>
<a name="l00777"></a>00777 <span class="comment">//   e.resize(this-&gt;m());</span>
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 <span class="comment">//   // An empty vector which will be used to hold the solution</span>
<a name="l00780"></a>00780 <span class="comment">//   // to the back substitutions.</span>
<a name="l00781"></a>00781 <span class="comment">//   DenseVector&lt;T&gt; x;</span>
<a name="l00782"></a>00782 <span class="comment">//   x.resize(this-&gt;m());</span>
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 <span class="comment">//   // An empty dense matrix to store the resulting inverse</span>
<a name="l00785"></a>00785 <span class="comment">//   // temporarily until we can overwrite A.</span>
<a name="l00786"></a>00786 <span class="comment">//   DenseMatrix&lt;T&gt; inv;</span>
<a name="l00787"></a>00787 <span class="comment">//   inv.resize(this-&gt;m(), this-&gt;n());</span>
<a name="l00788"></a>00788   
<a name="l00789"></a>00789 <span class="comment">//   // Resize the passed in matrix to hold the inverse</span>
<a name="l00790"></a>00790 <span class="comment">//   inv.resize(this-&gt;m(), this-&gt;n());</span>
<a name="l00791"></a>00791   
<a name="l00792"></a>00792 <span class="comment">//   for (unsigned int j=0; j&lt;this-&gt;n(); ++j)</span>
<a name="l00793"></a>00793 <span class="comment">//     {</span>
<a name="l00794"></a>00794 <span class="comment">//       e.zero();</span>
<a name="l00795"></a>00795 <span class="comment">//       e(j) = 1.;</span>
<a name="l00796"></a>00796 <span class="comment">//       this-&gt;_lu_back_substitute(e, x, false);</span>
<a name="l00797"></a>00797 <span class="comment">//       for (unsigned int i=0; i&lt;this-&gt;n(); ++i)</span>
<a name="l00798"></a>00798 <span class="comment">//      inv(i,j) = x(i);</span>
<a name="l00799"></a>00799 <span class="comment">//     }</span>
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 <span class="comment">//   // Now overwrite all the entries</span>
<a name="l00802"></a>00802 <span class="comment">//   *this = inv;</span>
<a name="l00803"></a>00803 <span class="comment">// }</span>
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 
<a name="l00806"></a>00806 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00807"></a>00807 <span class="comment">// Explicit instantiations</span>
<a name="l00808"></a>00808 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Real&gt;</a>;
<a name="l00809"></a>00809 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">DenseMatrix&lt;Real&gt;::cholesky_solve</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Real&gt;</a>&amp;, <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Real&gt;</a>&amp;);
<a name="l00810"></a>00810 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae96215c54161e7f671a42737fc0ff873">DenseMatrix&lt;Real&gt;::_cholesky_back_substitute</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Real&gt;</a>&amp;, <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Real&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00811"></a>00811 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">DenseMatrix&lt;Real&gt;::cholesky_solve</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;, <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;);
<a name="l00812"></a>00812 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae96215c54161e7f671a42737fc0ff873">DenseMatrix&lt;Real&gt;::_cholesky_back_substitute</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;, <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00815"></a>00815 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Complex&gt;</a>;
<a name="l00816"></a>00816 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">DenseMatrix&lt;Complex&gt;::cholesky_solve</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;,<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;);
<a name="l00817"></a>00817 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae96215c54161e7f671a42737fc0ff873">DenseMatrix&lt;Complex&gt;::_cholesky_back_substitute</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;, <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Complex&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00818"></a>00818 <span class="preprocessor">#endif</span>
<a name="l00819"></a>00819 <span class="preprocessor"></span>
<a name="l00820"></a>00820 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
