<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dense_matrix.h</div>  </div>
</div>
<div class="contents">
<a href="dense__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_matrix.h 4233 2011-03-07 23:50:33Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix__base_8h.php">dense_matrix_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseVector;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// Dense Matrix class definition</span>
<a name="l00051"></a>00051 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00052"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055   
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1DenseMatrix.php#a63066c751f8498dbbcb8ca4a00a0cf14">DenseMatrix</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>=0,
<a name="l00060"></a>00060               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>=0);
<a name="l00061"></a>00061   
<a name="l00065"></a>00065   <span class="comment">//DenseMatrix (const DenseMatrix&lt;T&gt;&amp; other_matrix);</span>
<a name="l00066"></a>00066   
<a name="l00070"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a5f192c355cfed7ae7eb0df1144b8c120">00070</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a5f192c355cfed7ae7eb0df1144b8c120">~DenseMatrix</a>() {}
<a name="l00071"></a>00071   
<a name="l00072"></a>00072 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00077"></a>00077 
<a name="l00081"></a>00081   T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00082"></a>00082                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   T &amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00088"></a>00088                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00089"></a>00089 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f93c5b1066687b30850e97c03ef44fb">00093</a>   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f93c5b1066687b30850e97c03ef44fb">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00094"></a>00094                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); }
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a0bbdaffed797db2696e2b67a861d0484">00099</a>   <span class="keyword">virtual</span> T &amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f93c5b1066687b30850e97c03ef44fb">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00100"></a>00100                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)     { <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); } 
<a name="l00101"></a>00101 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6f189109a2760176e9541bce50cd216d">left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2);
<a name="l00106"></a>00106   
<a name="l00110"></a>00110   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3);
<a name="l00111"></a>00111 
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a493649f63f70ca2adeaee645e26a4677">vector_mult</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ace7e590c10044121b6b348c3301e545a">vector_mult_transpose</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00123"></a>00123   
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa524e3051fffc87a03e16791d917284a">vector_mult_add</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest, 
<a name="l00129"></a>00129                         <span class="keyword">const</span> T factor,
<a name="l00130"></a>00130                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg) <span class="keyword">const</span>;
<a name="l00131"></a>00131 
<a name="l00135"></a>00135   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_n, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00140"></a>00140   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#abf62d6b34b155876279d8db1564a6e14">get_principal_submatrix</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_m, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00141"></a>00141 
<a name="l00145"></a>00145   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac00a4740e8613e80c7e99b361ae014ac">operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00146"></a>00146   
<a name="l00150"></a>00150   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">swap</a>(<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00151"></a>00151   
<a name="l00156"></a>00156   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>,
<a name="l00157"></a>00157               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>);
<a name="l00158"></a>00158   
<a name="l00162"></a>00162   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#acbb89f0334849faeb3be9094d547e655">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00163"></a>00163 
<a name="l00167"></a>00167   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#aeff58723e7b264b82e893abc9759cb8c">operator *= </a>(<span class="keyword">const</span> T factor);
<a name="l00168"></a>00168 
<a name="l00172"></a>00172   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a> (<span class="keyword">const</span> T factor,
<a name="l00173"></a>00173             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; mat);
<a name="l00174"></a>00174 
<a name="l00178"></a>00178   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a2a338baa0d16e9b5babe83769d89af90">operator== </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat) <span class="keyword">const</span>;
<a name="l00179"></a>00179 
<a name="l00183"></a>00183   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a4d683965c1325f535b5228b49b07c465">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat) <span class="keyword">const</span>;
<a name="l00184"></a>00184 
<a name="l00188"></a>00188   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#af17218eca4586b0891314c75741a744b">operator+= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat);
<a name="l00189"></a>00189 
<a name="l00193"></a>00193   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa933e5b87272195342626e6045b401f4">operator-= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat);
<a name="l00194"></a>00194 
<a name="l00200"></a>00200   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#afabf81db3e54bb0fe6c82c01dc8a9e69">min</a> () <span class="keyword">const</span>;
<a name="l00201"></a>00201 
<a name="l00207"></a>00207   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a76f0e840cc379a27672616bf7193b5e3">max</a> () <span class="keyword">const</span>;
<a name="l00208"></a>00208 
<a name="l00219"></a>00219   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00220"></a>00220 
<a name="l00232"></a>00232   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#add745b39468415cd9d99e0acebb5237a">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00233"></a>00233 
<a name="l00237"></a>00237   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">left_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A);
<a name="l00238"></a>00238   
<a name="l00239"></a>00239 
<a name="l00243"></a>00243   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a2936a147980a3643fdb637ab78c251c9">right_multiply_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; A);
<a name="l00244"></a>00244   
<a name="l00248"></a>00248   T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00249"></a>00249                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00250"></a>00250 
<a name="l00254"></a>00254   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a66347c890f7fd45143f6d0b8898713d1">get_transpose</a>(<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00255"></a>00255  
<a name="l00261"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a676d389b9cb9410e418026ec2c1a54c1">00261</a>   std::vector&lt;T&gt;&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a676d389b9cb9410e418026ec2c1a54c1">get_values</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>; }
<a name="l00262"></a>00262 
<a name="l00266"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#af75d60ad7d9581a015ddcd85b52209e3">00266</a>   <span class="keyword">const</span> std::vector&lt;T&gt;&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#af75d60ad7d9581a015ddcd85b52209e3">get_values</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>; }
<a name="l00267"></a>00267 
<a name="l00274"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ae2a11c928f4640150f9df555b07ac35e">00274</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae2a11c928f4640150f9df555b07ac35e">condense</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00275"></a>00275                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00276"></a>00276                 <span class="keyword">const</span> T val,
<a name="l00277"></a>00277                 <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; rhs)
<a name="l00278"></a>00278   { <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae2a11c928f4640150f9df555b07ac35e">DenseMatrixBase&lt;T&gt;::condense</a> (i, j, val, rhs); }
<a name="l00279"></a>00279 
<a name="l00285"></a>00285   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00286"></a>00286                  <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00299"></a>00299   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00300"></a>00300   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">cholesky_solve</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00301"></a>00301                       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x);
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00312"></a>00312   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a5f3041ad291a970fb632481e01aae17f">svd</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; sigma);
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00326"></a>00326   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a5f3041ad291a970fb632481e01aae17f">svd</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; sigma, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; U, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; VT);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   
<a name="l00334"></a>00334   T <a class="code" href="classlibMesh_1_1DenseMatrix.php#ab4b217cc39f4135073b5dc30b3d157e2">det</a>();
<a name="l00335"></a>00335 
<a name="l00344"></a>00344   <span class="comment">// void inverse();</span>
<a name="l00345"></a>00345 
<a name="l00351"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a847c530f0b4909b248aff4e6258d5b8d">00351</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a847c530f0b4909b248aff4e6258d5b8d">use_blas_lapack</a>;
<a name="l00352"></a>00352   
<a name="l00353"></a>00353 <span class="keyword">private</span>:
<a name="l00354"></a>00354 
<a name="l00358"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">00358</a>   std::vector&lt;T&gt; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>;
<a name="l00359"></a>00359 
<a name="l00365"></a>00365   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1455b27da806fa1dbc733eab6d1cbe94">_lu_decompose</a> ();
<a name="l00366"></a>00366   
<a name="l00372"></a>00372   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a89a35b300c65ec74fe85b3d2504508ba">_lu_back_substitute</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00373"></a>00373                             <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x) <span class="keyword">const</span>;
<a name="l00374"></a>00374   
<a name="l00381"></a>00381   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a0d41126a4cadcf798ea3009e8dd663b2">_cholesky_decompose</a>();
<a name="l00382"></a>00382 
<a name="l00389"></a>00389   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00390"></a>00390   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ae96215c54161e7f671a42737fc0ff873">_cholesky_back_substitute</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; b,
<a name="l00391"></a>00391                                  <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; x) <span class="keyword">const</span>;
<a name="l00392"></a>00392 
<a name="l00400"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9ade1cc985e6ce6f751e958231d7f3ed3e">00400</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9">DecompositionType</a> {<a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9a7686133778a883fd072c35d75d2c0cd7">LU</a>=0, <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9ae678cf68eb00a1043eda7421ba358539">CHOLESKY</a>=1, <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9a8760f5d6eac01ddcc3d2a10424114aaf">LU_BLAS_LAPACK</a>, <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9ade1cc985e6ce6f751e958231d7f3ed3e">NONE</a>};
<a name="l00401"></a>00401 
<a name="l00406"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">00406</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9">DecompositionType</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">_decomposition_type</a>;
<a name="l00407"></a>00407 
<a name="l00412"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653">00412</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653">_BLAS_Multiply_Flag</a> {
<a name="l00413"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653afe4ed4f088f6c5dac60def9c025116e0">00413</a>     <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653afe4ed4f088f6c5dac60def9c025116e0">LEFT_MULTIPLY</a> = 0,
<a name="l00414"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653a02fea2659e88a03205dd1dd9d87a026c">00414</a>     <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653a02fea2659e88a03205dd1dd9d87a026c">RIGHT_MULTIPLY</a>,
<a name="l00415"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653a827aed689cf5dbe31c97974f3d7af975">00415</a>     <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653a827aed689cf5dbe31c97974f3d7af975">LEFT_MULTIPLY_TRANSPOSE</a>,
<a name="l00416"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653af63423255b4fff1e762ddb06067438d1">00416</a>     <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653af63423255b4fff1e762ddb06067438d1">RIGHT_MULTIPLY_TRANSPOSE</a>
<a name="l00417"></a>00417   };
<a name="l00418"></a>00418   
<a name="l00426"></a>00426   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#af78dfd54eedcd8cb107a913b724395c2">_multiply_blas</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; other,
<a name="l00427"></a>00427                       <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653">_BLAS_Multiply_Flag</a> flag);
<a name="l00428"></a>00428 
<a name="l00438"></a>00438   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a752c27f2644b00a8c6b779aecd644222">_lu_decompose_lapack</a>();
<a name="l00439"></a>00439 
<a name="l00445"></a>00445   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4ca6a9580863cac27f5beb767b6dc69">_svd_lapack</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; sigma);
<a name="l00446"></a>00446   
<a name="l00452"></a>00452   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4ca6a9580863cac27f5beb767b6dc69">_svd_lapack</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; sigma,
<a name="l00453"></a>00453                    <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; U,
<a name="l00454"></a>00454                    <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; VT);
<a name="l00455"></a>00455 
<a name="l00460"></a>00460   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a9499f275e74feefde23ea3a116918c95">_svd_helper</a> (<span class="keywordtype">char</span> JOBU,
<a name="l00461"></a>00461                     <span class="keywordtype">char</span> JOBVT,
<a name="l00462"></a>00462                     std::vector&lt;T&gt;&amp; sigma_val,
<a name="l00463"></a>00463                     std::vector&lt;T&gt;&amp; U_val,
<a name="l00464"></a>00464                     std::vector&lt;T&gt;&amp; VT_val);
<a name="l00465"></a>00465 
<a name="l00471"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#af53ee84c9674f37b8ad1d885ca5f291c">00471</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1DenseMatrix.php#af53ee84c9674f37b8ad1d885ca5f291c">_pivots</a>;
<a name="l00472"></a>00472 
<a name="l00482"></a>00482   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac70a007254352725bae26a2cf41c5ef5">_lu_back_substitute_lapack</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00483"></a>00483                                    <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x);
<a name="l00484"></a>00484 
<a name="l00497"></a>00497   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a7d06e96c79a3d579cd03bd8836ad1090">_matvec_blas</a>(T alpha, T beta,
<a name="l00498"></a>00498                     <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest,
<a name="l00499"></a>00499                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg,
<a name="l00500"></a>00500                     <span class="keywordtype">bool</span> trans=<span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00501"></a>00501 };
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00511"></a><a class="code" href="namespacelibMesh_1_1DenseMatrices.php">00511</a> <span class="comment"></span><span class="keyword">namespace </span>DenseMatrices
<a name="l00512"></a>00512 {
<a name="l00513"></a>00513 
<a name="l00518"></a><a class="code" href="namespacelibMesh_1_1DenseMatrices.php#aada1321106662747e018481072603e2d">00518</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Real&gt;</a> <a class="code" href="namespacelibMesh_1_1DenseMatrices.php#aada1321106662747e018481072603e2d">RealDenseMatrix</a>;
<a name="l00519"></a>00519 
<a name="l00529"></a><a class="code" href="namespacelibMesh_1_1DenseMatrices.php#a3515ea9802d906d8a42251845e8f7239">00529</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Complex&gt;</a> <a class="code" href="namespacelibMesh_1_1DenseMatrices.php#a3515ea9802d906d8a42251845e8f7239">ComplexDenseMatrix</a>;  
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 }
<a name="l00532"></a>00532 
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 <span class="keyword">using namespace </span>DenseMatrices;
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540 
<a name="l00541"></a>00541 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00542"></a>00542 <span class="comment">// Dense Matrix member functions</span>
<a name="l00543"></a>00543 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00544"></a>00544 <span class="keyword">inline</span>
<a name="l00545"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a63066c751f8498dbbcb8ca4a00a0cf14">00545</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;::DenseMatrix</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00546"></a>00546                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00547"></a>00547   : <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;(m,n),
<a name="l00548"></a>00548 #if defined(LIBMESH_HAVE_PETSC) &amp;&amp; defined(LIBMESH_USE_REAL_NUMBERS)
<a name="l00549"></a>00549     use_blas_lapack(true),
<a name="l00550"></a>00550 #else
<a name="l00551"></a>00551     use_blas_lapack(false),
<a name="l00552"></a>00552 #endif
<a name="l00553"></a>00553     _val(),
<a name="l00554"></a>00554     _decomposition_type(NONE),
<a name="l00555"></a>00555     _pivots()
<a name="l00556"></a>00556 {
<a name="l00557"></a>00557   this-&gt;<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(m,n);
<a name="l00558"></a>00558 }
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 <span class="comment">// FIXME[JWP]: This copy ctor has not been maintained along with</span>
<a name="l00563"></a>00563 <span class="comment">// the rest of the class...</span>
<a name="l00564"></a>00564 <span class="comment">// Can we just use the compiler-generated copy ctor here?</span>
<a name="l00565"></a>00565 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00566"></a>00566 <span class="comment">// inline</span>
<a name="l00567"></a>00567 <span class="comment">// DenseMatrix&lt;T&gt;::DenseMatrix (const DenseMatrix&lt;T&gt;&amp; other_matrix)</span>
<a name="l00568"></a>00568 <span class="comment">//   : DenseMatrixBase&lt;T&gt;(other_matrix._m, other_matrix._n)</span>
<a name="l00569"></a>00569 <span class="comment">// {</span>
<a name="l00570"></a>00570 <span class="comment">//   _val = other_matrix._val;</span>
<a name="l00571"></a>00571 <span class="comment">// }</span>
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00576"></a>00576 <span class="keyword">inline</span>
<a name="l00577"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">00577</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">DenseMatrix&lt;T&gt;::swap</a>(<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00578"></a>00578 {
<a name="l00579"></a>00579   std::swap(this-&gt;_m, other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#aa7400426b259d1c630a4b26221205e76">_m</a>);
<a name="l00580"></a>00580   std::swap(this-&gt;_n, other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a65ad8af64975eb0ecfc621a75743a869">_n</a>);
<a name="l00581"></a>00581   _val.swap(other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>);
<a name="l00582"></a>00582   <a class="code" href="classlibMesh_1_1DenseMatrix.php#af13624c3650ea77e588478fb683bf8d9">DecompositionType</a> _temp = _decomposition_type;
<a name="l00583"></a>00583   _decomposition_type = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">_decomposition_type</a>;
<a name="l00584"></a>00584   other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">_decomposition_type</a> = _temp;
<a name="l00585"></a>00585 }
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 
<a name="l00588"></a>00588   
<a name="l00589"></a>00589 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00590"></a>00590 <span class="keyword">inline</span>
<a name="l00591"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">00591</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">DenseMatrix&lt;T&gt;::resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00592"></a>00592                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00593"></a>00593 {
<a name="l00594"></a>00594   _val.resize(m*n);
<a name="l00595"></a>00595 
<a name="l00596"></a>00596   this-&gt;_m = m;
<a name="l00597"></a>00597   this-&gt;_n = n;
<a name="l00598"></a>00598 
<a name="l00599"></a>00599   _decomposition_type = NONE;
<a name="l00600"></a>00600   this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>();
<a name="l00601"></a>00601 }
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 
<a name="l00605"></a>00605 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00606"></a>00606 <span class="keyword">inline</span>
<a name="l00607"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">00607</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">DenseMatrix&lt;T&gt;::zero</a>()
<a name="l00608"></a>00608 {
<a name="l00609"></a>00609   _decomposition_type = NONE;
<a name="l00610"></a>00610 
<a name="l00611"></a>00611   std::fill (_val.begin(), _val.end(), 0.);
<a name="l00612"></a>00612 }
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00617"></a>00617 <span class="keyword">inline</span>
<a name="l00618"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ac00a4740e8613e80c7e99b361ae014ac">00618</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac00a4740e8613e80c7e99b361ae014ac">DenseMatrix&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; other_matrix)
<a name="l00619"></a>00619 {
<a name="l00620"></a>00620   this-&gt;_m = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#aa7400426b259d1c630a4b26221205e76">_m</a>;
<a name="l00621"></a>00621   this-&gt;_n = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a65ad8af64975eb0ecfc621a75743a869">_n</a>;
<a name="l00622"></a>00622 
<a name="l00623"></a>00623   _val                = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>;
<a name="l00624"></a>00624   _decomposition_type = other_matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac1da39d620cd6248899c1bf19f421083">_decomposition_type</a>;
<a name="l00625"></a>00625 
<a name="l00626"></a>00626   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00627"></a>00627 }
<a name="l00628"></a>00628 
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 
<a name="l00631"></a>00631 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00632"></a>00632 <span class="keyword">inline</span>
<a name="l00633"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">00633</a> T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">DenseMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00634"></a>00634                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00635"></a>00635 <span class="keyword"></span>{
<a name="l00636"></a>00636   libmesh_assert (i*j&lt;_val.size());
<a name="l00637"></a>00637   libmesh_assert (i &lt; this-&gt;_m);
<a name="l00638"></a>00638   libmesh_assert (j &lt; this-&gt;_n);
<a name="l00639"></a>00639   
<a name="l00640"></a>00640   
<a name="l00641"></a>00641   <span class="comment">//  return _val[(i) + (this-&gt;_m)*(j)]; // col-major</span>
<a name="l00642"></a>00642   <span class="keywordflow">return</span> _val[(i)*(this-&gt;_n) + (j)]; <span class="comment">// row-major</span>
<a name="l00643"></a>00643 }
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 
<a name="l00647"></a>00647 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00648"></a>00648 <span class="keyword">inline</span>
<a name="l00649"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a1d171121a9643f970396d55f9f883e6e">00649</a> T &amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#a1b6afa5e746003ebf9b2b6c5ad82230c">DenseMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00650"></a>00650                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00651"></a>00651 {
<a name="l00652"></a>00652   libmesh_assert (i*j&lt;_val.size());
<a name="l00653"></a>00653   libmesh_assert (i &lt; this-&gt;_m);
<a name="l00654"></a>00654   libmesh_assert (j &lt; this-&gt;_n);
<a name="l00655"></a>00655   
<a name="l00656"></a>00656   <span class="comment">//return _val[(i) + (this-&gt;_m)*(j)]; // col-major</span>
<a name="l00657"></a>00657   <span class="keywordflow">return</span> _val[(i)*(this-&gt;_n) + (j)]; <span class="comment">// row-major</span>
<a name="l00658"></a>00658 }
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661      
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00665"></a>00665 <span class="keyword">inline</span>
<a name="l00666"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#acbb89f0334849faeb3be9094d547e655">00666</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#acbb89f0334849faeb3be9094d547e655">DenseMatrix&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00667"></a>00667 {
<a name="l00668"></a>00668   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00669"></a>00669     _val[i] *= factor;
<a name="l00670"></a>00670 }
<a name="l00671"></a>00671 
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00675"></a>00675 <span class="keyword">inline</span>
<a name="l00676"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#aeff58723e7b264b82e893abc9759cb8c">00676</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#aeff58723e7b264b82e893abc9759cb8c">DenseMatrix&lt;T&gt;::operator *= </a>(<span class="keyword">const</span> T factor)
<a name="l00677"></a>00677 {
<a name="l00678"></a>00678   this-&gt;<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a48c03ebd8ce97c6c8aef8e2a05a94a16">scale</a>(factor);
<a name="l00679"></a>00679   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00680"></a>00680 }
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00685"></a>00685 <span class="keyword">inline</span>
<a name="l00686"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">00686</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">DenseMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T factor, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; mat)
<a name="l00687"></a>00687 {
<a name="l00688"></a>00688   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00689"></a>00689     _val[i] += factor * mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i];
<a name="l00690"></a>00690 }
<a name="l00691"></a>00691 
<a name="l00692"></a>00692 
<a name="l00693"></a>00693 
<a name="l00694"></a>00694 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00695"></a>00695 <span class="keyword">inline</span>
<a name="l00696"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a2a338baa0d16e9b5babe83769d89af90">00696</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a2a338baa0d16e9b5babe83769d89af90">DenseMatrix&lt;T&gt;::operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)<span class="keyword"> const</span>
<a name="l00697"></a>00697 <span class="keyword"></span>{
<a name="l00698"></a>00698   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00699"></a>00699     <span class="keywordflow">if</span> (_val[i] != mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i])
<a name="l00700"></a>00700       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00701"></a>00701 
<a name="l00702"></a>00702   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00703"></a>00703 }
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00708"></a>00708 <span class="keyword">inline</span>
<a name="l00709"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a4d683965c1325f535b5228b49b07c465">00709</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a4d683965c1325f535b5228b49b07c465">DenseMatrix&lt;T&gt;::operator != </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)<span class="keyword"> const</span>
<a name="l00710"></a>00710 <span class="keyword"></span>{
<a name="l00711"></a>00711   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00712"></a>00712     <span class="keywordflow">if</span> (_val[i] != mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i])
<a name="l00713"></a>00713       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00716"></a>00716 }
<a name="l00717"></a>00717 
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00721"></a>00721 <span class="keyword">inline</span>
<a name="l00722"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#af17218eca4586b0891314c75741a744b">00722</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#af17218eca4586b0891314c75741a744b">DenseMatrix&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)
<a name="l00723"></a>00723 {
<a name="l00724"></a>00724   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00725"></a>00725     _val[i] += mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i];
<a name="l00726"></a>00726 
<a name="l00727"></a>00727   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00728"></a>00728 }
<a name="l00729"></a>00729 
<a name="l00730"></a>00730 
<a name="l00731"></a>00731 
<a name="l00732"></a>00732 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00733"></a>00733 <span class="keyword">inline</span>
<a name="l00734"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#aa933e5b87272195342626e6045b401f4">00734</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseMatrix.php#aa933e5b87272195342626e6045b401f4">DenseMatrix&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;mat)
<a name="l00735"></a>00735 {
<a name="l00736"></a>00736   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00737"></a>00737     _val[i] -= mat.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[i];
<a name="l00738"></a>00738 
<a name="l00739"></a>00739   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00740"></a>00740 }
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00745"></a>00745 <span class="keyword">inline</span>
<a name="l00746"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#afabf81db3e54bb0fe6c82c01dc8a9e69">00746</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#afabf81db3e54bb0fe6c82c01dc8a9e69">DenseMatrix&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00747"></a>00747 <span class="keyword"></span>{
<a name="l00748"></a>00748   libmesh_assert (this-&gt;_m);
<a name="l00749"></a>00749   libmesh_assert (this-&gt;_n);
<a name="l00750"></a>00750   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_min = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(0,0));
<a name="l00751"></a>00751 
<a name="l00752"></a>00752   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00753"></a>00753     {
<a name="l00754"></a>00754       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00755"></a>00755         {
<a name="l00756"></a>00756           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(i,j));
<a name="l00757"></a>00757           my_min = (my_min &lt; current? my_min : current);
<a name="l00758"></a>00758         }
<a name="l00759"></a>00759     }
<a name="l00760"></a>00760   <span class="keywordflow">return</span> my_min;
<a name="l00761"></a>00761 }
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 
<a name="l00765"></a>00765 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00766"></a>00766 <span class="keyword">inline</span>
<a name="l00767"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a76f0e840cc379a27672616bf7193b5e3">00767</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a76f0e840cc379a27672616bf7193b5e3">DenseMatrix&lt;T&gt;::max</a> ()<span class="keyword"> const</span>
<a name="l00768"></a>00768 <span class="keyword"></span>{
<a name="l00769"></a>00769   libmesh_assert (this-&gt;_m);
<a name="l00770"></a>00770   libmesh_assert (this-&gt;_n);
<a name="l00771"></a>00771   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(0,0));
<a name="l00772"></a>00772 
<a name="l00773"></a>00773   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00774"></a>00774     {
<a name="l00775"></a>00775       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00776"></a>00776         {
<a name="l00777"></a>00777           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(i,j));
<a name="l00778"></a>00778           my_max = (my_max &gt; current? my_max : current);
<a name="l00779"></a>00779         }
<a name="l00780"></a>00780     }
<a name="l00781"></a>00781   <span class="keywordflow">return</span> my_max;
<a name="l00782"></a>00782 }
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 
<a name="l00785"></a>00785 
<a name="l00786"></a>00786 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00787"></a>00787 <span class="keyword">inline</span>
<a name="l00788"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">00788</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">DenseMatrix&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00789"></a>00789 <span class="keyword"></span>{
<a name="l00790"></a>00790   libmesh_assert (this-&gt;_m);
<a name="l00791"></a>00791   libmesh_assert (this-&gt;_n);
<a name="l00792"></a>00792 
<a name="l00793"></a>00793   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> columnsum = 0.;
<a name="l00794"></a>00794   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00795"></a>00795     {
<a name="l00796"></a>00796       columnsum += std::abs((*<span class="keyword">this</span>)(i,0));
<a name="l00797"></a>00797     }
<a name="l00798"></a>00798   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max = columnsum;
<a name="l00799"></a>00799   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j!=this-&gt;_n; j++)
<a name="l00800"></a>00800     {
<a name="l00801"></a>00801       columnsum = 0.;
<a name="l00802"></a>00802       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;_m; i++)
<a name="l00803"></a>00803         {
<a name="l00804"></a>00804           columnsum += std::abs((*<span class="keyword">this</span>)(i,j));
<a name="l00805"></a>00805         }
<a name="l00806"></a>00806       my_max = (my_max &gt; columnsum? my_max : columnsum);
<a name="l00807"></a>00807     }
<a name="l00808"></a>00808   <span class="keywordflow">return</span> my_max;
<a name="l00809"></a>00809 }
<a name="l00810"></a>00810 
<a name="l00811"></a>00811 
<a name="l00812"></a>00812 
<a name="l00813"></a>00813 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00814"></a>00814 <span class="keyword">inline</span>
<a name="l00815"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#add745b39468415cd9d99e0acebb5237a">00815</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseMatrix.php#add745b39468415cd9d99e0acebb5237a">DenseMatrix&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00816"></a>00816 <span class="keyword"></span>{
<a name="l00817"></a>00817   libmesh_assert (this-&gt;_m);
<a name="l00818"></a>00818   libmesh_assert (this-&gt;_n);
<a name="l00819"></a>00819 
<a name="l00820"></a>00820   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rowsum = 0.;
<a name="l00821"></a>00821   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00822"></a>00822     {
<a name="l00823"></a>00823       rowsum += std::abs((*<span class="keyword">this</span>)(0,j));
<a name="l00824"></a>00824     }
<a name="l00825"></a>00825   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max = rowsum;
<a name="l00826"></a>00826   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;_m; i++)
<a name="l00827"></a>00827     {
<a name="l00828"></a>00828       rowsum = 0.;
<a name="l00829"></a>00829       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=this-&gt;_n; j++)
<a name="l00830"></a>00830         {
<a name="l00831"></a>00831           rowsum += std::abs((*<span class="keyword">this</span>)(i,j));
<a name="l00832"></a>00832         }
<a name="l00833"></a>00833       my_max = (my_max &gt; rowsum? my_max : rowsum);
<a name="l00834"></a>00834     }
<a name="l00835"></a>00835   <span class="keywordflow">return</span> my_max;
<a name="l00836"></a>00836 }
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 
<a name="l00839"></a>00839 
<a name="l00840"></a>00840 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00841"></a>00841 <span class="keyword">inline</span>
<a name="l00842"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">00842</a> T <a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">DenseMatrix&lt;T&gt;::transpose</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00843"></a>00843                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00844"></a>00844 <span class="keyword"></span>{
<a name="l00845"></a>00845   <span class="comment">// Implement in terms of operator()</span>
<a name="l00846"></a>00846   <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(j,i);
<a name="l00847"></a>00847 }
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 
<a name="l00850"></a>00850 
<a name="l00851"></a>00851 
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 <span class="comment">// template&lt;typename T&gt;</span>
<a name="l00854"></a>00854 <span class="comment">// inline</span>
<a name="l00855"></a>00855 <span class="comment">// void DenseMatrix&lt;T&gt;::condense(const unsigned int iv,</span>
<a name="l00856"></a>00856 <span class="comment">//                            const unsigned int jv,</span>
<a name="l00857"></a>00857 <span class="comment">//                            const T val,</span>
<a name="l00858"></a>00858 <span class="comment">//                            DenseVector&lt;T&gt;&amp; rhs)</span>
<a name="l00859"></a>00859 <span class="comment">// {</span>
<a name="l00860"></a>00860 <span class="comment">//   libmesh_assert (this-&gt;_m == rhs.size());</span>
<a name="l00861"></a>00861 <span class="comment">//   libmesh_assert (iv == jv);</span>
<a name="l00862"></a>00862 
<a name="l00863"></a>00863 
<a name="l00864"></a>00864 <span class="comment">//   // move the known value into the RHS</span>
<a name="l00865"></a>00865 <span class="comment">//   // and zero the column</span>
<a name="l00866"></a>00866 <span class="comment">//   for (unsigned int i=0; i&lt;this-&gt;m(); i++)</span>
<a name="l00867"></a>00867 <span class="comment">//     {</span>
<a name="l00868"></a>00868 <span class="comment">//       rhs(i) -= ((*this)(i,jv))*val;</span>
<a name="l00869"></a>00869 <span class="comment">//       (*this)(i,jv) = 0.;</span>
<a name="l00870"></a>00870 <span class="comment">//     }</span>
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 <span class="comment">//   // zero the row</span>
<a name="l00873"></a>00873 <span class="comment">//   for (unsigned int j=0; j&lt;this-&gt;n(); j++)</span>
<a name="l00874"></a>00874 <span class="comment">//     (*this)(iv,j) = 0.;</span>
<a name="l00875"></a>00875 
<a name="l00876"></a>00876 <span class="comment">//   (*this)(iv,jv) = 1.;</span>
<a name="l00877"></a>00877 <span class="comment">//   rhs(iv) = val;</span>
<a name="l00878"></a>00878   
<a name="l00879"></a>00879 <span class="comment">// }</span>
<a name="l00880"></a>00880 
<a name="l00881"></a>00881 
<a name="l00882"></a>00882 
<a name="l00883"></a>00883 
<a name="l00884"></a>00884 } <span class="comment">// namespace libMesh</span>
<a name="l00885"></a>00885 
<a name="l00886"></a>00886 
<a name="l00887"></a>00887 
<a name="l00888"></a>00888 
<a name="l00889"></a>00889 <span class="preprocessor">#endif // #ifndef __dense_matrix_h__</span>
<a name="l00890"></a>00890 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
