<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dense_matrix_base.C</div>  </div>
</div>
<div class="contents">
<a href="dense__matrix__base_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_matrix_base.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;iomanip&gt;</span> <span class="comment">// for std::setw()</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local Includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix__base_8h.php">dense_matrix_base.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector__base_8h.php">dense_vector_base.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00033"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a97a0f61a31b72851e000af4f7b78a889">00033</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a97a0f61a31b72851e000af4f7b78a889">DenseMatrixBase&lt;T&gt;::multiply</a> (<a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M1,
<a name="l00034"></a>00034                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2,
<a name="l00035"></a>00035                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   <span class="comment">// Assertions to make sure we have been</span>
<a name="l00038"></a>00038   <span class="comment">// passed matrices of the correct dimension.</span>
<a name="l00039"></a>00039   libmesh_assert (M1.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == M2.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00040"></a>00040   libmesh_assert (M1.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == M3.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00041"></a>00041   libmesh_assert (M2.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == M3.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00042"></a>00042           
<a name="l00043"></a>00043   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_s = M2.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>();
<a name="l00044"></a>00044   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_s = M2.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); 
<a name="l00045"></a>00045   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_s = M1.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>();
<a name="l00046"></a>00046   
<a name="l00047"></a>00047   <span class="comment">// Do it this way because there is a</span>
<a name="l00048"></a>00048   <span class="comment">// decent chance (at least for constraint matrices)</span>
<a name="l00049"></a>00049   <span class="comment">// that M3(k,j) = 0. when right-multiplying.</span>
<a name="l00050"></a>00050   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;p_s; k++)
<a name="l00051"></a>00051     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;n_s; j++)
<a name="l00052"></a>00052       <span class="keywordflow">if</span> (M3.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a18b1c581e3f4badd001432e7ca67e31c">el</a>(k,j) != 0.)
<a name="l00053"></a>00053         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;m_s; i++)
<a name="l00054"></a>00054           M1.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a18b1c581e3f4badd001432e7ca67e31c">el</a>(i,j) += M2.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a18b1c581e3f4badd001432e7ca67e31c">el</a>(i,k) * M3.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a18b1c581e3f4badd001432e7ca67e31c">el</a>(k,j);                  
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00060"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a0472bd2ec76bfa88657299b9d39ab399">00060</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a0472bd2ec76bfa88657299b9d39ab399">DenseMatrixBase&lt;T&gt;::condense</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> iv,
<a name="l00061"></a>00061                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> jv,
<a name="l00062"></a>00062                                   <span class="keyword">const</span> T val,
<a name="l00063"></a>00063                                   <a class="code" href="classlibMesh_1_1DenseVectorBase.php">DenseVectorBase&lt;T&gt;</a>&amp; rhs)
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065   libmesh_assert (this-&gt;_m == rhs.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>());
<a name="l00066"></a>00066   libmesh_assert (iv == jv);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">// move the known value into the RHS</span>
<a name="l00070"></a>00070   <span class="comment">// and zero the column</span>
<a name="l00071"></a>00071   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073       rhs.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a35567e09039c62b9914def1fd063a73c">el</a>(i) -= this-&gt;el(i,jv)*val;
<a name="l00074"></a>00074       this-&gt;el(i,jv) = 0.;
<a name="l00075"></a>00075     }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="comment">// zero the row</span>
<a name="l00078"></a>00078   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00079"></a>00079     this-&gt;el(iv,j) = 0.;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   this-&gt;el(iv,jv) = 1.;
<a name="l00082"></a>00082   rhs.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a35567e09039c62b9914def1fd063a73c">el</a>(iv) = val;
<a name="l00083"></a>00083   
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00088"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a16d875257ce79de592b34c3ede8683db">00088</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a16d875257ce79de592b34c3ede8683db">DenseMatrixBase&lt;T&gt;::print_scientific</a> (std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00089"></a>00089 <span class="keyword"></span>{
<a name="l00090"></a>00090 <span class="preprocessor">#ifndef LIBMESH_BROKEN_IOSTREAM</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>  
<a name="l00092"></a>00092   <span class="comment">// save the initial format flags</span>
<a name="l00093"></a>00093   std::ios_base::fmtflags os_flags = os.flags();
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   <span class="comment">// Print the matrix entries.</span>
<a name="l00096"></a>00096   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00097"></a>00097     {
<a name="l00098"></a>00098       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00099"></a>00099         os &lt;&lt; std::setw(15)
<a name="l00100"></a>00100            &lt;&lt; std::scientific
<a name="l00101"></a>00101            &lt;&lt; std::setprecision(8)
<a name="l00102"></a>00102            &lt;&lt; this-&gt;el(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00103"></a>00103 
<a name="l00104"></a>00104       os &lt;&lt; std::endl;
<a name="l00105"></a>00105     }
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   <span class="comment">// reset the original format flags</span>
<a name="l00108"></a>00108   os.flags(os_flags);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="preprocessor">#else</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span>  
<a name="l00112"></a>00112   <span class="comment">// Print the matrix entries.</span>
<a name="l00113"></a>00113   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)  
<a name="l00116"></a>00116         os &lt;&lt; std::setprecision(8)
<a name="l00117"></a>00117            &lt;&lt; this-&gt;el(i,j)
<a name="l00118"></a>00118            &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00119"></a>00119       
<a name="l00120"></a>00120       os &lt;&lt; std::endl;
<a name="l00121"></a>00121     }
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   
<a name="l00124"></a>00124 <span class="preprocessor">#endif</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span>}
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00130"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a041c10a32db1f43eccfb86bdc9f63e60">00130</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a041c10a32db1f43eccfb86bdc9f63e60">DenseMatrixBase&lt;T&gt;::print</a> (std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00131"></a>00131 <span class="keyword"></span>{  
<a name="l00132"></a>00132   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00133"></a>00133     {
<a name="l00134"></a>00134       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00135"></a>00135         os &lt;&lt; std::setw(8)
<a name="l00136"></a>00136            &lt;&lt; this-&gt;el(i,j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138       os &lt;&lt; std::endl;
<a name="l00139"></a>00139     }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="keywordflow">return</span>;
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00153"></a>00153 <span class="comment">// Explicit instantiations</span>
<a name="l00154"></a>00154 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;Real&gt;</a>;
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;Complex&gt;</a>;
<a name="l00158"></a>00158 <span class="preprocessor">#endif</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>
<a name="l00160"></a>00160 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
