<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dense_matrix_base.h</div>  </div>
</div>
<div class="contents">
<a href="dense__matrix__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_matrix_base.h 4044 2010-10-12 23:33:03Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_matrix_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_matrix_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="compare__types_8h.php">compare_types.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Delcarations</span>
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseVectorBase;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00047"></a>00047 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00048"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php">00048</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   
<a name="l00051"></a>00051 <span class="keyword">protected</span>:
<a name="l00056"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a8a3e8ee705d502d06f9c48176fe3176d">00056</a>   <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a8a3e8ee705d502d06f9c48176fe3176d">DenseMatrixBase</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>=0,
<a name="l00057"></a>00057                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>=0) : <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#aa7400426b259d1c630a4b26221205e76">_m</a>(<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>), <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a65ad8af64975eb0ecfc621a75743a869">_n</a>(<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>) {};
<a name="l00058"></a>00058   
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00063"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4ab9bbc55a7580faf95030d0d89e3c56">00063</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4ab9bbc55a7580faf95030d0d89e3c56">~DenseMatrixBase</a>() {};
<a name="l00064"></a>00064 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a9b2447c7f9169d1d1c01f9b453f48df9">zero</a>() = 0;
<a name="l00071"></a>00071 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a18b1c581e3f4badd001432e7ca67e31c">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00078"></a>00078                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span> = 0;
<a name="l00079"></a>00079   
<a name="l00085"></a>00085   <span class="keyword">virtual</span> T &amp; <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a18b1c581e3f4badd001432e7ca67e31c">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00086"></a>00086                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) = 0;
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#afcb264450d957c4bc7ca54ad487ea8df">left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2) = 0;
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a1a8f1cc874504144e65f4ba01747c286">right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3) = 0;
<a name="l00097"></a>00097   
<a name="l00101"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">00101</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#aa7400426b259d1c630a4b26221205e76">_m</a>; }
<a name="l00102"></a>00102   
<a name="l00106"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">00106</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a65ad8af64975eb0ecfc621a75743a869">_n</a>; }
<a name="l00107"></a>00107   
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a041c10a32db1f43eccfb86bdc9f63e60">print</a>(std::ostream&amp; os = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00112"></a>00112 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#ae69bcf4703696e88fb14522c77f46567">00118</a>   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const DenseMatrixBase&lt;T&gt;&amp; <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>)
<a name="l00119"></a>00119   {
<a name="l00120"></a>00120     <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>.print(os);
<a name="l00121"></a>00121     <span class="keywordflow">return</span> os;
<a name="l00122"></a>00122   }
<a name="l00123"></a>00123   
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a16d875257ce79de592b34c3ede8683db">print_scientific</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00129"></a>00129   
<a name="l00135"></a>00135   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3&gt;
<a name="l00136"></a>00136   <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00137"></a>00137     <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;T2&gt;::value</a>, <span class="keywordtype">void</span> &gt;::type
<a name="l00138"></a>00138   <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a56936749882014c838eaee9f69cd7dd0">add</a> (<span class="keyword">const</span> T2 factor,
<a name="l00139"></a>00139        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T3&gt;</a>&amp; mat);
<a name="l00140"></a>00140    
<a name="l00141"></a>00141 <span class="keyword">protected</span>:
<a name="l00142"></a>00142   
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a97a0f61a31b72851e000af4f7b78a889">multiply</a> (<a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M1,
<a name="l00150"></a>00150                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2,
<a name="l00151"></a>00151                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3);
<a name="l00152"></a>00152 
<a name="l00159"></a>00159   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a0472bd2ec76bfa88657299b9d39ab399">condense</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00160"></a>00160                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00161"></a>00161                 <span class="keyword">const</span> T val,
<a name="l00162"></a>00162                 <a class="code" href="classlibMesh_1_1DenseVectorBase.php">DenseVectorBase&lt;T&gt;</a>&amp; rhs);
<a name="l00163"></a>00163 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#aa7400426b259d1c630a4b26221205e76">00167</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#aa7400426b259d1c630a4b26221205e76">_m</a>;
<a name="l00168"></a>00168 
<a name="l00172"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a65ad8af64975eb0ecfc621a75743a869">00172</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a65ad8af64975eb0ecfc621a75743a869">_n</a>;
<a name="l00173"></a>00173 };
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00182"></a>00182 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3&gt;
<a name="l00183"></a>00183 <span class="keyword">inline</span>
<a name="l00184"></a>00184 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00185"></a>00185   <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;T2&gt;::value</a>, <span class="keywordtype">void</span> &gt;::type
<a name="l00186"></a><a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a56936749882014c838eaee9f69cd7dd0">00186</a> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a56936749882014c838eaee9f69cd7dd0">DenseMatrixBase&lt;T&gt;::add</a> (<span class="keyword">const</span> T2 factor,
<a name="l00187"></a>00187                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T3&gt;</a>&amp; mat)
<a name="l00188"></a>00188 {
<a name="l00189"></a>00189   libmesh_assert (this-&gt;m() == mat.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00190"></a>00190   libmesh_assert (this-&gt;n() == mat.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00193"></a>00193     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00194"></a>00194       this-&gt;el(i,j) += factor*mat.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a18b1c581e3f4badd001432e7ca67e31c">el</a>(i,j);
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 } <span class="comment">// namespace libMesh</span>
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="preprocessor">#endif // #ifndef __dense_matrix_base_h__</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
