<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dense_matrix_blas_lapack.C</div>  </div>
</div>
<div class="contents">
<a href="dense__matrix__blas__lapack_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_matrix_blas_lapack.C 4246 2011-03-11 22:24:59Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local Includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#if (LIBMESH_HAVE_PETSC &amp;&amp; LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;petscblaslapack.h&gt;</span>
<a name="l00031"></a>00031 EXTERN_C_FOR_PETSC_END
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#if (LIBMESH_HAVE_PETSC &amp;&amp; LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00041"></a>00041 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00042"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#af78dfd54eedcd8cb107a913b724395c2">00042</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#af78dfd54eedcd8cb107a913b724395c2">DenseMatrix&lt;T&gt;::_multiply_blas</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; other,
<a name="l00043"></a>00043                                     <a class="code" href="classlibMesh_1_1DenseMatrix.php#afa268fd78e9c7110ccb20872bd987653">_BLAS_Multiply_Flag</a> flag)
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   <span class="keywordtype">int</span> result_size = 0;
<a name="l00046"></a>00046   
<a name="l00047"></a>00047   <span class="comment">// For each case, determine the size of the final result make sure</span>
<a name="l00048"></a>00048   <span class="comment">// that the inner dimensions match</span>
<a name="l00049"></a>00049   <span class="keywordflow">switch</span> (flag)
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keywordflow">case</span> LEFT_MULTIPLY:
<a name="l00052"></a>00052       {
<a name="l00053"></a>00053         result_size = other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() * this-&gt;n();
<a name="l00054"></a>00054         <span class="keywordflow">if</span> (other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == this-&gt;m())
<a name="l00055"></a>00055           <span class="keywordflow">break</span>;
<a name="l00056"></a>00056       }
<a name="l00057"></a>00057     <span class="keywordflow">case</span> RIGHT_MULTIPLY:
<a name="l00058"></a>00058       {
<a name="l00059"></a>00059         result_size = other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() * this-&gt;m();
<a name="l00060"></a>00060         <span class="keywordflow">if</span> (other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == this-&gt;n())
<a name="l00061"></a>00061           <span class="keywordflow">break</span>;
<a name="l00062"></a>00062       }
<a name="l00063"></a>00063     <span class="keywordflow">case</span> LEFT_MULTIPLY_TRANSPOSE:
<a name="l00064"></a>00064       {
<a name="l00065"></a>00065         result_size = other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() * this-&gt;n();
<a name="l00066"></a>00066         <span class="keywordflow">if</span> (other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == this-&gt;m())
<a name="l00067"></a>00067           <span class="keywordflow">break</span>;
<a name="l00068"></a>00068       }
<a name="l00069"></a>00069     <span class="keywordflow">case</span> RIGHT_MULTIPLY_TRANSPOSE:
<a name="l00070"></a>00070       {
<a name="l00071"></a>00071         result_size = other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() * this-&gt;m();
<a name="l00072"></a>00072         <span class="keywordflow">if</span> (other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == this-&gt;n())
<a name="l00073"></a>00073           <span class="keywordflow">break</span>;
<a name="l00074"></a>00074       }
<a name="l00075"></a>00075     <span class="keywordflow">default</span>:
<a name="l00076"></a>00076       {
<a name="l00077"></a>00077         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Unknown flag selected or matrices are &quot;</span>;
<a name="l00078"></a>00078         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;incompatible for multiplication.&quot;</span> &lt;&lt; std::endl;
<a name="l00079"></a>00079         libmesh_error();
<a name="l00080"></a>00080       }
<a name="l00081"></a>00081     }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">// For this to work, the passed arg. must actually be a DenseMatrix&lt;T&gt;</span>
<a name="l00084"></a>00084   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>* const_that = libmesh_cast_ptr&lt; const DenseMatrix&lt;T&gt;* &gt;(&amp;other);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">// Also, although &#39;that&#39; is logically const in this BLAS routine,</span>
<a name="l00087"></a>00087   <span class="comment">// the PETSc BLAS interface does not specify that any of the inputs are</span>
<a name="l00088"></a>00088   <span class="comment">// const.  To use it, I must cast away const-ness.</span>
<a name="l00089"></a>00089   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>* that = <span class="keyword">const_cast&lt;</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>* <span class="keyword">&gt;</span> (const_that);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">// Initialize A, B pointers for LEFT_MULTIPLY* cases</span>
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>
<a name="l00093"></a>00093     *A = <span class="keyword">this</span>,
<a name="l00094"></a>00094     *B = that;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">// For RIGHT_MULTIPLY* cases, swap the meaning of A and B.</span>
<a name="l00097"></a>00097   <span class="comment">// Here is a full table of combinations we can pass to BLASgemm, and what the answer is when finished:</span>
<a name="l00098"></a>00098   <span class="comment">// pass A B   -&gt; (Fortran) -&gt; A^T B^T -&gt; (C++) -&gt; (A^T B^T)^T -&gt; (identity) -&gt; B A   &quot;lt multiply&quot;</span>
<a name="l00099"></a>00099   <span class="comment">// pass B A   -&gt; (Fortran) -&gt; B^T A^T -&gt; (C++) -&gt; (B^T A^T)^T -&gt; (identity) -&gt; A B   &quot;rt multiply&quot;</span>
<a name="l00100"></a>00100   <span class="comment">// pass A B^T -&gt; (Fortran) -&gt; A^T B   -&gt; (C++) -&gt; (A^T B)^T   -&gt; (identity) -&gt; B^T A &quot;lt multiply t&quot;</span>
<a name="l00101"></a>00101   <span class="comment">// pass B^T A -&gt; (Fortran) -&gt; B A^T   -&gt; (C++) -&gt; (B A^T)^T   -&gt; (identity) -&gt; A B^T &quot;rt multiply t&quot;</span>
<a name="l00102"></a>00102   <span class="keywordflow">if</span> (flag==RIGHT_MULTIPLY || flag==RIGHT_MULTIPLY_TRANSPOSE)
<a name="l00103"></a>00103     std::swap(A,B);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">// transa, transb values to pass to blas</span>
<a name="l00106"></a>00106   <span class="keywordtype">char</span>
<a name="l00107"></a>00107     transa[] = <span class="stringliteral">&quot;n&quot;</span>,
<a name="l00108"></a>00108     transb[] = <span class="stringliteral">&quot;n&quot;</span>;
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">// Integer values to pass to BLAS:</span>
<a name="l00111"></a>00111   <span class="comment">//</span>
<a name="l00112"></a>00112   <span class="comment">// M  </span>
<a name="l00113"></a>00113   <span class="comment">// In Fortran, the number of rows of op(A),</span>
<a name="l00114"></a>00114   <span class="comment">// In the BLAS documentation, typically known as &#39;M&#39;.</span>
<a name="l00115"></a>00115   <span class="comment">//</span>
<a name="l00116"></a>00116   <span class="comment">// In C/C++, we set:</span>
<a name="l00117"></a>00117   <span class="comment">// M = n_cols(A) if (transa=&#39;n&#39;)</span>
<a name="l00118"></a>00118   <span class="comment">//     n_rows(A) if (transa=&#39;t&#39;)</span>
<a name="l00119"></a>00119   <span class="keywordtype">int</span> M = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( A-&gt;<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() );
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// N</span>
<a name="l00122"></a>00122   <span class="comment">// In Fortran, the number of cols of op(B), and also the number of cols of C.</span>
<a name="l00123"></a>00123   <span class="comment">// In the BLAS documentation, typically known as &#39;N&#39;.</span>
<a name="l00124"></a>00124   <span class="comment">//        </span>
<a name="l00125"></a>00125   <span class="comment">// In C/C++, we set:</span>
<a name="l00126"></a>00126   <span class="comment">// N = n_rows(B) if (transb=&#39;n&#39;)</span>
<a name="l00127"></a>00127   <span class="comment">//     n_cols(B) if (transb=&#39;t&#39;)</span>
<a name="l00128"></a>00128   <span class="keywordtype">int</span> N = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( B-&gt;m() );
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="comment">// K</span>
<a name="l00131"></a>00131   <span class="comment">// In Fortran, the number of cols of op(A), and also</span>
<a name="l00132"></a>00132   <span class="comment">// the number of rows of op(B). In the BLAS documentation,</span>
<a name="l00133"></a>00133   <span class="comment">// typically known as &#39;K&#39;.</span>
<a name="l00134"></a>00134   <span class="comment">//</span>
<a name="l00135"></a>00135   <span class="comment">// In C/C++, we set:</span>
<a name="l00136"></a>00136   <span class="comment">// K = n_rows(A) if (transa=&#39;n&#39;)</span>
<a name="l00137"></a>00137   <span class="comment">//     n_cols(A) if (transa=&#39;t&#39;)</span>
<a name="l00138"></a>00138   <span class="keywordtype">int</span> K = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( A-&gt;<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() );
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="comment">// LDA (leading dimension of A). In our cases,</span>
<a name="l00141"></a>00141   <span class="comment">// LDA is always the number of columns of A.</span>
<a name="l00142"></a>00142   <span class="keywordtype">int</span> LDA = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( A-&gt;<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() );
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <span class="comment">// LDB (leading dimension of B).  In our cases,</span>
<a name="l00145"></a>00145   <span class="comment">// LDB is always the number of columns of B.</span>
<a name="l00146"></a>00146   <span class="keywordtype">int</span> LDB = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( B-&gt;n() );
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="keywordflow">if</span> (flag == LEFT_MULTIPLY_TRANSPOSE)
<a name="l00149"></a>00149     {
<a name="l00150"></a>00150       transb[0] = <span class="charliteral">&#39;t&#39;</span>;
<a name="l00151"></a>00151       N = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>( B-&gt;n() );
<a name="l00152"></a>00152     }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (flag == RIGHT_MULTIPLY_TRANSPOSE)
<a name="l00155"></a>00155     {
<a name="l00156"></a>00156       transa[0] = <span class="charliteral">&#39;t&#39;</span>;
<a name="l00157"></a>00157       std::swap(M,K);
<a name="l00158"></a>00158     }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">// LDC (leading dimension of C).  LDC is the</span>
<a name="l00161"></a>00161   <span class="comment">// number of columns in the solution matrix.</span>
<a name="l00162"></a>00162   <span class="keywordtype">int</span> LDC = M;
<a name="l00163"></a>00163   
<a name="l00164"></a>00164   <span class="comment">// Scalar values to pass to BLAS</span>
<a name="l00165"></a>00165   <span class="comment">//</span>
<a name="l00166"></a>00166   <span class="comment">// scalar multiplying the whole product AB </span>
<a name="l00167"></a>00167   T alpha = 1.;
<a name="l00168"></a>00168   
<a name="l00169"></a>00169   <span class="comment">// scalar multiplying C, which is the original matrix.</span>
<a name="l00170"></a>00170   T beta  = 0.;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="comment">// Storage for the result</span>
<a name="l00173"></a>00173   std::vector&lt;T&gt; result (result_size);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="comment">// Finally ready to call the BLAS</span>
<a name="l00176"></a>00176   BLASgemm_(transa, transb, &amp;M, &amp;N, &amp;K, &amp;alpha, &amp;(A-&gt;<a class="code" href="classlibMesh_1_1DenseMatrix.php#a850c40fcb0f9d1f4994bd9ac1d094284">_val</a>[0]), &amp;LDA, &amp;(B-&gt;_val[0]), &amp;LDB, &amp;beta, &amp;result[0], &amp;LDC);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="comment">// Update the relevant dimension for this matrix.</span>
<a name="l00179"></a>00179   <span class="keywordflow">switch</span> (flag)
<a name="l00180"></a>00180     {
<a name="l00181"></a>00181     <span class="keywordflow">case</span> LEFT_MULTIPLY:            { this-&gt;_m = other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(); <span class="keywordflow">break</span>; }
<a name="l00182"></a>00182     <span class="keywordflow">case</span> RIGHT_MULTIPLY:           { this-&gt;_n = other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); <span class="keywordflow">break</span>; }
<a name="l00183"></a>00183     <span class="keywordflow">case</span> LEFT_MULTIPLY_TRANSPOSE:  { this-&gt;_m = other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); <span class="keywordflow">break</span>; }
<a name="l00184"></a>00184     <span class="keywordflow">case</span> RIGHT_MULTIPLY_TRANSPOSE: { this-&gt;_n = other.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(); <span class="keywordflow">break</span>; }
<a name="l00185"></a>00185     <span class="keywordflow">default</span>:
<a name="l00186"></a>00186       {
<a name="l00187"></a>00187         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Unknown flag selected.&quot;</span> &lt;&lt; std::endl;
<a name="l00188"></a>00188         libmesh_error();
<a name="l00189"></a>00189       }
<a name="l00190"></a>00190     }
<a name="l00191"></a>00191   
<a name="l00192"></a>00192   <span class="comment">// Swap my data vector with the result</span>
<a name="l00193"></a>00193   this-&gt;_val.swap(result);
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="preprocessor">#else</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>
<a name="l00198"></a>00198 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00199"></a>00199 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#af78dfd54eedcd8cb107a913b724395c2">DenseMatrix&lt;T&gt;::_multiply_blas</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; ,
<a name="l00200"></a>00200                                     _BLAS_Multiply_Flag )
<a name="l00201"></a>00201 {
<a name="l00202"></a>00202   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;No PETSc-provided BLAS/LAPACK available!&quot;</span> &lt;&lt; std::endl;
<a name="l00203"></a>00203   libmesh_error();
<a name="l00204"></a>00204 }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="preprocessor">#endif</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="preprocessor">#if (LIBMESH_HAVE_PETSC &amp;&amp; LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00215"></a>00215 <span class="preprocessor"></span>
<a name="l00216"></a>00216 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00217"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a752c27f2644b00a8c6b779aecd644222">00217</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a752c27f2644b00a8c6b779aecd644222">DenseMatrix&lt;T&gt;::_lu_decompose_lapack</a> ()
<a name="l00218"></a>00218 {
<a name="l00219"></a>00219   <span class="comment">// If this function was called, there better not be any</span>
<a name="l00220"></a>00220   <span class="comment">// previous decomposition of the matrix.</span>
<a name="l00221"></a>00221   libmesh_assert(this-&gt;_decomposition_type == NONE);
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="comment">// The calling sequence for dgetrf is:</span>
<a name="l00224"></a>00224   <span class="comment">// dgetrf(M, N, A, lda, ipiv, info)</span>
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   <span class="comment">//    M       (input) int*</span>
<a name="l00227"></a>00227   <span class="comment">//            The number of rows of the matrix A.  M &gt;= 0.</span>
<a name="l00228"></a>00228   <span class="comment">// In C/C++, pass the number of *cols* of A</span>
<a name="l00229"></a>00229   <span class="keywordtype">int</span> M = this-&gt;n();
<a name="l00230"></a>00230     
<a name="l00231"></a>00231   <span class="comment">//    N       (input) int*</span>
<a name="l00232"></a>00232   <span class="comment">//            The number of columns of the matrix A.  N &gt;= 0.</span>
<a name="l00233"></a>00233   <span class="comment">// In C/C++, pass the number of *rows* of A</span>
<a name="l00234"></a>00234   <span class="keywordtype">int</span> N = this-&gt;m();
<a name="l00235"></a>00235   
<a name="l00236"></a>00236   <span class="comment">//    A (input/output) double precision array, dimension (LDA,N)</span>
<a name="l00237"></a>00237   <span class="comment">//      On entry, the M-by-N matrix to be factored.</span>
<a name="l00238"></a>00238   <span class="comment">//      On exit, the factors L and U from the factorization</span>
<a name="l00239"></a>00239   <span class="comment">//      A = P*L*U; the unit diagonal elements of L are not stored.</span>
<a name="l00240"></a>00240   <span class="comment">// Here, we pass &amp;(_val[0]).</span>
<a name="l00241"></a>00241   
<a name="l00242"></a>00242   <span class="comment">//    LDA     (input) int*</span>
<a name="l00243"></a>00243   <span class="comment">//            The leading dimension of the array A.  LDA &gt;= max(1,M).</span>
<a name="l00244"></a>00244   <span class="keywordtype">int</span> LDA = M;
<a name="l00245"></a>00245   
<a name="l00246"></a>00246   <span class="comment">//    ipiv    (output) integer array, dimension (min(m,n))</span>
<a name="l00247"></a>00247   <span class="comment">//            The pivot indices; for 1 &lt;= i &lt;= min(m,n), row i of the</span>
<a name="l00248"></a>00248   <span class="comment">//            matrix was interchanged with row IPIV(i).</span>
<a name="l00249"></a>00249   <span class="comment">// Here, we pass &amp;(_pivots[0]), a private class member used to store pivots</span>
<a name="l00250"></a>00250   this-&gt;_pivots.resize( <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(M,N) );
<a name="l00251"></a>00251   
<a name="l00252"></a>00252   <span class="comment">//    info    (output) int*</span>
<a name="l00253"></a>00253   <span class="comment">//            = 0:  successful exit</span>
<a name="l00254"></a>00254   <span class="comment">//            &lt; 0:  if INFO = -i, the i-th argument had an illegal value</span>
<a name="l00255"></a>00255   <span class="comment">//            &gt; 0:  if INFO = i, U(i,i) is exactly zero. The factorization</span>
<a name="l00256"></a>00256   <span class="comment">//                  has been completed, but the factor U is exactly</span>
<a name="l00257"></a>00257   <span class="comment">//                  singular, and division by zero will occur if it is used</span>
<a name="l00258"></a>00258   <span class="comment">//                  to solve a system of equations.</span>
<a name="l00259"></a>00259   <span class="keywordtype">int</span> INFO = 0;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="comment">// Ready to call the actual factorization routine through PETSc&#39;s interface</span>
<a name="l00262"></a>00262   LAPACKgetrf_(&amp;M, &amp;N, &amp;(this-&gt;_val[0]), &amp;LDA, &amp;(_pivots[0]), &amp;INFO);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="comment">// Check return value for errors</span>
<a name="l00265"></a>00265   <span class="keywordflow">if</span> (INFO != 0)
<a name="l00266"></a>00266     {
<a name="l00267"></a>00267       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;INFO=&quot;</span>
<a name="l00268"></a>00268                     &lt;&lt; INFO
<a name="l00269"></a>00269                     &lt;&lt; <span class="stringliteral">&quot;, Error during Lapack LU factorization!&quot;</span> &lt;&lt; std::endl;
<a name="l00270"></a>00270       libmesh_error();
<a name="l00271"></a>00271     }
<a name="l00272"></a>00272   
<a name="l00273"></a>00273   <span class="comment">// Set the flag for LU decomposition</span>
<a name="l00274"></a>00274   this-&gt;_decomposition_type = LU_BLAS_LAPACK;
<a name="l00275"></a>00275 }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 <span class="preprocessor">#else</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>
<a name="l00279"></a>00279 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00280"></a>00280 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a752c27f2644b00a8c6b779aecd644222">DenseMatrix&lt;T&gt;::_lu_decompose_lapack</a> ()
<a name="l00281"></a>00281 {
<a name="l00282"></a>00282   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;No PETSc-provided BLAS/LAPACK available!&quot;</span> &lt;&lt; std::endl;
<a name="l00283"></a>00283   libmesh_error();
<a name="l00284"></a>00284 }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="preprocessor">#endif</span>
<a name="l00287"></a>00287 <span class="preprocessor"></span>
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00291"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4ca6a9580863cac27f5beb767b6dc69">00291</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4ca6a9580863cac27f5beb767b6dc69">DenseMatrix&lt;T&gt;::_svd_lapack</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; sigma)
<a name="l00292"></a>00292 {
<a name="l00293"></a>00293   <span class="comment">// The calling sequence for dgetrf is:</span>
<a name="l00294"></a>00294   <span class="comment">// DGESVD( JOBU, JOBVT, M, N, A, LDA, S, U, LDU, VT, LDVT, WORK, LWORK, INFO )</span>
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   
<a name="l00297"></a>00297   <span class="comment">//  JOBU    (input) CHARACTER*1</span>
<a name="l00298"></a>00298   <span class="comment">//          Specifies options for computing all or part of the matrix U:</span>
<a name="l00299"></a>00299   <span class="comment">//          = &#39;A&#39;:  all M columns of U are returned in array U:</span>
<a name="l00300"></a>00300   <span class="comment">//          = &#39;S&#39;:  the first min(m,n) columns of U (the left singular</span>
<a name="l00301"></a>00301   <span class="comment">//                  vectors) are returned in the array U;</span>
<a name="l00302"></a>00302   <span class="comment">//          = &#39;O&#39;:  the first min(m,n) columns of U (the left singular</span>
<a name="l00303"></a>00303   <span class="comment">//                  vectors) are overwritten on the array A;</span>
<a name="l00304"></a>00304   <span class="comment">//          = &#39;N&#39;:  no columns of U (no left singular vectors) are</span>
<a name="l00305"></a>00305   <span class="comment">//                  computed.</span>
<a name="l00306"></a>00306   <span class="keywordtype">char</span> JOBU = <span class="charliteral">&#39;N&#39;</span>;
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <span class="comment">//  JOBVT   (input) CHARACTER*1</span>
<a name="l00309"></a>00309   <span class="comment">//          Specifies options for computing all or part of the matrix</span>
<a name="l00310"></a>00310   <span class="comment">//          V**T:</span>
<a name="l00311"></a>00311   <span class="comment">//          = &#39;A&#39;:  all N rows of V**T are returned in the array VT;</span>
<a name="l00312"></a>00312   <span class="comment">//          = &#39;S&#39;:  the first min(m,n) rows of V**T (the right singular</span>
<a name="l00313"></a>00313   <span class="comment">//                  vectors) are returned in the array VT;</span>
<a name="l00314"></a>00314   <span class="comment">//          = &#39;O&#39;:  the first min(m,n) rows of V**T (the right singular</span>
<a name="l00315"></a>00315   <span class="comment">//                  vectors) are overwritten on the array A;</span>
<a name="l00316"></a>00316   <span class="comment">//          = &#39;N&#39;:  no rows of V**T (no right singular vectors) are</span>
<a name="l00317"></a>00317   <span class="comment">//                  computed.</span>
<a name="l00318"></a>00318   <span class="keywordtype">char</span> JOBVT = <span class="charliteral">&#39;N&#39;</span>;
<a name="l00319"></a>00319   
<a name="l00320"></a>00320   std::vector&lt;T&gt; sigma_val;
<a name="l00321"></a>00321   std::vector&lt;T&gt; U_val;
<a name="l00322"></a>00322   std::vector&lt;T&gt; VT_val;
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   _svd_helper(JOBU, JOBVT, sigma_val, U_val, VT_val);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   <span class="comment">// Load the singular values into sigma, ignore U_val and VT_val</span>
<a name="l00327"></a>00327   sigma.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(sigma_val.size());
<a name="l00328"></a>00328   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;sigma_val.size(); i++)
<a name="l00329"></a>00329     sigma(i) = sigma_val[i];
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00334"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a2626eb1f746de31bd14542df48b5c3ac">00334</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4ca6a9580863cac27f5beb767b6dc69">DenseMatrix&lt;T&gt;::_svd_lapack</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; sigma, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; U, <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; VT)
<a name="l00335"></a>00335 {
<a name="l00336"></a>00336   <span class="comment">// The calling sequence for dgetrf is:</span>
<a name="l00337"></a>00337   <span class="comment">// DGESVD( JOBU, JOBVT, M, N, A, LDA, S, U, LDU, VT, LDVT, WORK, LWORK, INFO )</span>
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   
<a name="l00340"></a>00340   <span class="comment">//  JOBU    (input) CHARACTER*1</span>
<a name="l00341"></a>00341   <span class="comment">//          Specifies options for computing all or part of the matrix U:</span>
<a name="l00342"></a>00342   <span class="comment">//          = &#39;A&#39;:  all M columns of U are returned in array U:</span>
<a name="l00343"></a>00343   <span class="comment">//          = &#39;S&#39;:  the first min(m,n) columns of U (the left singular</span>
<a name="l00344"></a>00344   <span class="comment">//                  vectors) are returned in the array U;</span>
<a name="l00345"></a>00345   <span class="comment">//          = &#39;O&#39;:  the first min(m,n) columns of U (the left singular</span>
<a name="l00346"></a>00346   <span class="comment">//                  vectors) are overwritten on the array A;</span>
<a name="l00347"></a>00347   <span class="comment">//          = &#39;N&#39;:  no columns of U (no left singular vectors) are</span>
<a name="l00348"></a>00348   <span class="comment">//                  computed.</span>
<a name="l00349"></a>00349   <span class="keywordtype">char</span> JOBU = <span class="charliteral">&#39;S&#39;</span>;
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="comment">//  JOBVT   (input) CHARACTER*1</span>
<a name="l00352"></a>00352   <span class="comment">//          Specifies options for computing all or part of the matrix</span>
<a name="l00353"></a>00353   <span class="comment">//          V**T:</span>
<a name="l00354"></a>00354   <span class="comment">//          = &#39;A&#39;:  all N rows of V**T are returned in the array VT;</span>
<a name="l00355"></a>00355   <span class="comment">//          = &#39;S&#39;:  the first min(m,n) rows of V**T (the right singular</span>
<a name="l00356"></a>00356   <span class="comment">//                  vectors) are returned in the array VT;</span>
<a name="l00357"></a>00357   <span class="comment">//          = &#39;O&#39;:  the first min(m,n) rows of V**T (the right singular</span>
<a name="l00358"></a>00358   <span class="comment">//                  vectors) are overwritten on the array A;</span>
<a name="l00359"></a>00359   <span class="comment">//          = &#39;N&#39;:  no rows of V**T (no right singular vectors) are</span>
<a name="l00360"></a>00360   <span class="comment">//                  computed.</span>
<a name="l00361"></a>00361   <span class="keywordtype">char</span> JOBVT = <span class="charliteral">&#39;S&#39;</span>;
<a name="l00362"></a>00362   
<a name="l00363"></a>00363   std::vector&lt;T&gt; sigma_val;
<a name="l00364"></a>00364   std::vector&lt;T&gt; U_val;
<a name="l00365"></a>00365   std::vector&lt;T&gt; VT_val;
<a name="l00366"></a>00366   
<a name="l00367"></a>00367   _svd_helper(JOBU, JOBVT, sigma_val, U_val, VT_val);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="comment">// Load the singular values into sigma, ignore U_val and VT_val</span>
<a name="l00370"></a>00370   sigma.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(sigma_val.size());
<a name="l00371"></a>00371   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;sigma_val.size(); i++)
<a name="l00372"></a>00372     sigma(i) = sigma_val[i];
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="keywordtype">int</span> M = this-&gt;n();
<a name="l00375"></a>00375   <span class="keywordtype">int</span> N = this-&gt;m();
<a name="l00376"></a>00376   <span class="keywordtype">int</span> min_MN = (M &lt; N) ? M : N;
<a name="l00377"></a>00377   U.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(M,min_MN);
<a name="l00378"></a>00378   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;U.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(); i++)
<a name="l00379"></a>00379     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;U.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00380"></a>00380     {
<a name="l00381"></a>00381       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = i + j*U.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>();  <span class="comment">// Column major storage</span>
<a name="l00382"></a>00382       U(i,j) = U_val[index];
<a name="l00383"></a>00383     }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385   VT.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(min_MN,N);
<a name="l00386"></a>00386   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;VT.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(); i++)
<a name="l00387"></a>00387     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;VT.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00388"></a>00388     {
<a name="l00389"></a>00389       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index = i + j*U.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); <span class="comment">// Column major storage</span>
<a name="l00390"></a>00390       VT(i,j) = VT_val[index];
<a name="l00391"></a>00391     }
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 <span class="preprocessor">#if (LIBMESH_HAVE_PETSC &amp;&amp; LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00396"></a>00396 <span class="preprocessor"></span>
<a name="l00397"></a>00397 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00398"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a9499f275e74feefde23ea3a116918c95">00398</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a9499f275e74feefde23ea3a116918c95">DenseMatrix&lt;T&gt;::_svd_helper</a> (<span class="keywordtype">char</span> JOBU,
<a name="l00399"></a>00399                                   <span class="keywordtype">char</span> JOBVT,
<a name="l00400"></a>00400                                   std::vector&lt;T&gt;&amp; sigma_val,
<a name="l00401"></a>00401                                   std::vector&lt;T&gt;&amp; U_val,
<a name="l00402"></a>00402                                   std::vector&lt;T&gt;&amp; VT_val)
<a name="l00403"></a>00403 {
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="comment">//    M       (input) int*</span>
<a name="l00406"></a>00406   <span class="comment">//            The number of rows of the matrix A.  M &gt;= 0.</span>
<a name="l00407"></a>00407   <span class="comment">// In C/C++, pass the number of *cols* of A</span>
<a name="l00408"></a>00408   <span class="keywordtype">int</span> M = this-&gt;n();
<a name="l00409"></a>00409     
<a name="l00410"></a>00410   <span class="comment">//    N       (input) int*</span>
<a name="l00411"></a>00411   <span class="comment">//            The number of columns of the matrix A.  N &gt;= 0.</span>
<a name="l00412"></a>00412   <span class="comment">// In C/C++, pass the number of *rows* of A</span>
<a name="l00413"></a>00413   <span class="keywordtype">int</span> N = this-&gt;m();
<a name="l00414"></a>00414   
<a name="l00415"></a>00415   <span class="keywordtype">int</span> min_MN = (M &lt; N) ? M : N;
<a name="l00416"></a>00416   <span class="keywordtype">int</span> max_MN = (M &gt; N) ? M : N;
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="comment">//  A       (input/output) DOUBLE PRECISION array, dimension (LDA,N)</span>
<a name="l00419"></a>00419   <span class="comment">//          On entry, the M-by-N matrix A.</span>
<a name="l00420"></a>00420   <span class="comment">//          On exit,</span>
<a name="l00421"></a>00421   <span class="comment">//          if JOBU = &#39;O&#39;,  A is overwritten with the first min(m,n)</span>
<a name="l00422"></a>00422   <span class="comment">//                          columns of U (the left singular vectors,</span>
<a name="l00423"></a>00423   <span class="comment">//                          stored columnwise);</span>
<a name="l00424"></a>00424   <span class="comment">//          if JOBVT = &#39;O&#39;, A is overwritten with the first min(m,n)</span>
<a name="l00425"></a>00425   <span class="comment">//                          rows of V**T (the right singular vectors,</span>
<a name="l00426"></a>00426   <span class="comment">//                          stored rowwise);</span>
<a name="l00427"></a>00427   <span class="comment">//          if JOBU .ne. &#39;O&#39; and JOBVT .ne. &#39;O&#39;, the contents of A</span>
<a name="l00428"></a>00428   <span class="comment">//                          are destroyed.</span>
<a name="l00429"></a>00429   <span class="comment">// Here, we pass &amp;(_val[0]).</span>
<a name="l00430"></a>00430   
<a name="l00431"></a>00431   <span class="comment">//    LDA     (input) int*</span>
<a name="l00432"></a>00432   <span class="comment">//            The leading dimension of the array A.  LDA &gt;= max(1,M).</span>
<a name="l00433"></a>00433   <span class="keywordtype">int</span> LDA = M;
<a name="l00434"></a>00434 
<a name="l00435"></a>00435   <span class="comment">//  S       (output) DOUBLE PRECISION array, dimension (min(M,N))</span>
<a name="l00436"></a>00436   <span class="comment">//          The singular values of A, sorted so that S(i) &gt;= S(i+1).</span>
<a name="l00437"></a>00437   sigma_val.resize( min_MN );
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   <span class="comment">//  LDU     (input) INTEGER</span>
<a name="l00440"></a>00440   <span class="comment">//          The leading dimension of the array U.  LDU &gt;= 1; if</span>
<a name="l00441"></a>00441   <span class="comment">//          JOBU = &#39;S&#39; or &#39;A&#39;, LDU &gt;= M.</span>
<a name="l00442"></a>00442   <span class="keywordtype">int</span> LDU = M;
<a name="l00443"></a>00443 
<a name="l00444"></a>00444   <span class="comment">//  U       (output) DOUBLE PRECISION array, dimension (LDU,UCOL)</span>
<a name="l00445"></a>00445   <span class="comment">//          (LDU,M) if JOBU = &#39;A&#39; or (LDU,min(M,N)) if JOBU = &#39;S&#39;.</span>
<a name="l00446"></a>00446   <span class="comment">//          If JOBU = &#39;A&#39;, U contains the M-by-M orthogonal matrix U;</span>
<a name="l00447"></a>00447   <span class="comment">//          if JOBU = &#39;S&#39;, U contains the first min(m,n) columns of U</span>
<a name="l00448"></a>00448   <span class="comment">//          (the left singular vectors, stored columnwise);</span>
<a name="l00449"></a>00449   <span class="comment">//          if JOBU = &#39;N&#39; or &#39;O&#39;, U is not referenced.</span>
<a name="l00450"></a>00450   U_val.resize( LDU*M );
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   <span class="comment">//  LDVT    (input) INTEGER</span>
<a name="l00453"></a>00453   <span class="comment">//          The leading dimension of the array VT.  LDVT &gt;= 1; if</span>
<a name="l00454"></a>00454   <span class="comment">//          JOBVT = &#39;A&#39;, LDVT &gt;= N; if JOBVT = &#39;S&#39;, LDVT &gt;= min(M,N).</span>
<a name="l00455"></a>00455   <span class="keywordtype">int</span> LDVT = N;
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   <span class="comment">//  VT      (output) DOUBLE PRECISION array, dimension (LDVT,N)</span>
<a name="l00458"></a>00458   <span class="comment">//          If JOBVT = &#39;A&#39;, VT contains the N-by-N orthogonal matrix</span>
<a name="l00459"></a>00459   <span class="comment">//          V**T;</span>
<a name="l00460"></a>00460   <span class="comment">//          if JOBVT = &#39;S&#39;, VT contains the first min(m,n) rows of</span>
<a name="l00461"></a>00461   <span class="comment">//          V**T (the right singular vectors, stored rowwise);</span>
<a name="l00462"></a>00462   <span class="comment">//          if JOBVT = &#39;N&#39; or &#39;O&#39;, VT is not referenced.</span>
<a name="l00463"></a>00463   VT_val.resize( LDVT*N );
<a name="l00464"></a>00464 
<a name="l00465"></a>00465   <span class="comment">//  LWORK   (input) INTEGER</span>
<a name="l00466"></a>00466   <span class="comment">//          The dimension of the array WORK.</span>
<a name="l00467"></a>00467   <span class="comment">//          LWORK &gt;= MAX(1,3*MIN(M,N)+MAX(M,N),5*MIN(M,N)).</span>
<a name="l00468"></a>00468   <span class="comment">//          For good performance, LWORK should generally be larger.</span>
<a name="l00469"></a>00469   <span class="comment">//</span>
<a name="l00470"></a>00470   <span class="comment">//          If LWORK = -1, then a workspace query is assumed; the routine</span>
<a name="l00471"></a>00471   <span class="comment">//          only calculates the optimal size of the WORK array, returns</span>
<a name="l00472"></a>00472   <span class="comment">//          this value as the first entry of the WORK array, and no error</span>
<a name="l00473"></a>00473   <span class="comment">//          message related to LWORK is issued by XERBLA.</span>
<a name="l00474"></a>00474   <span class="keywordtype">int</span> larger = (3*min_MN+max_MN &gt; 5*min_MN) ? 3*min_MN+max_MN : 5*min_MN;
<a name="l00475"></a>00475   <span class="keywordtype">int</span> LWORK  = (larger &gt; 1) ? larger : 1;
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478   <span class="comment">//  WORK    (workspace/output) DOUBLE PRECISION array, dimension (MAX(1,LWORK))</span>
<a name="l00479"></a>00479   <span class="comment">//          On exit, if INFO = 0, WORK(1) returns the optimal LWORK;</span>
<a name="l00480"></a>00480   <span class="comment">//          if INFO &gt; 0, WORK(2:MIN(M,N)) contains the unconverged</span>
<a name="l00481"></a>00481   <span class="comment">//          superdiagonal elements of an upper bidiagonal matrix B</span>
<a name="l00482"></a>00482   <span class="comment">//          whose diagonal is in S (not necessarily sorted). B</span>
<a name="l00483"></a>00483   <span class="comment">//          satisfies A = U * B * VT, so it has the same singular values</span>
<a name="l00484"></a>00484   <span class="comment">//          as A, and singular vectors related by U and VT.</span>
<a name="l00485"></a>00485   std::vector&lt;T&gt; WORK( LWORK );
<a name="l00486"></a>00486 
<a name="l00487"></a>00487   <span class="comment">//  INFO    (output) INTEGER</span>
<a name="l00488"></a>00488   <span class="comment">//          = 0:  successful exit.</span>
<a name="l00489"></a>00489   <span class="comment">//          &lt; 0:  if INFO = -i, the i-th argument had an illegal value.</span>
<a name="l00490"></a>00490   <span class="comment">//          &gt; 0:  if DBDSQR did not converge, INFO specifies how many</span>
<a name="l00491"></a>00491   <span class="comment">//                superdiagonals of an intermediate bidiagonal form B</span>
<a name="l00492"></a>00492   <span class="comment">//                did not converge to zero. See the description of WORK</span>
<a name="l00493"></a>00493   <span class="comment">//                above for details.</span>
<a name="l00494"></a>00494   <span class="keywordtype">int</span> INFO = 0;
<a name="l00495"></a>00495 
<a name="l00496"></a>00496   <span class="comment">// Ready to call the actual factorization routine through PETSc&#39;s interface</span>
<a name="l00497"></a>00497   LAPACKgesvd_(&amp;JOBU, &amp;JOBVT, &amp;M, &amp;N, &amp;(_val[0]), &amp;LDA, &amp;(sigma_val[0]), &amp;(U_val[0]),
<a name="l00498"></a>00498                &amp;LDU, &amp;(VT_val[0]), &amp;LDVT, &amp;(WORK[0]), &amp;LWORK, &amp;INFO);
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   <span class="comment">// Check return value for errors</span>
<a name="l00501"></a>00501   <span class="keywordflow">if</span> (INFO != 0)
<a name="l00502"></a>00502     {
<a name="l00503"></a>00503       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;INFO=&quot;</span>
<a name="l00504"></a>00504                     &lt;&lt; INFO
<a name="l00505"></a>00505                     &lt;&lt; <span class="stringliteral">&quot;, Error during Lapack SVD calculation!&quot;</span> &lt;&lt; std::endl;
<a name="l00506"></a>00506       libmesh_error();
<a name="l00507"></a>00507     }
<a name="l00508"></a>00508 }
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 <span class="preprocessor">#else</span>
<a name="l00512"></a>00512 <span class="preprocessor"></span>
<a name="l00513"></a>00513 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00514"></a>00514 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a9499f275e74feefde23ea3a116918c95">DenseMatrix&lt;T&gt;::_svd_helper</a> (<span class="keywordtype">char</span>,
<a name="l00515"></a>00515                                   <span class="keywordtype">char</span>,
<a name="l00516"></a>00516                                   std::vector&lt;T&gt;&amp;,
<a name="l00517"></a>00517                                   std::vector&lt;T&gt;&amp;,
<a name="l00518"></a>00518                                   std::vector&lt;T&gt;&amp;)
<a name="l00519"></a>00519 {
<a name="l00520"></a>00520   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;No PETSc-provided BLAS/LAPACK available!&quot;</span> &lt;&lt; std::endl;
<a name="l00521"></a>00521   libmesh_error();
<a name="l00522"></a>00522 }
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 <span class="preprocessor">#endif</span>
<a name="l00525"></a>00525 <span class="preprocessor"></span>
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 <span class="preprocessor">#if (LIBMESH_HAVE_PETSC &amp;&amp; LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00531"></a>00531 <span class="preprocessor"></span>
<a name="l00532"></a>00532 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00533"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#ac70a007254352725bae26a2cf41c5ef5">00533</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac70a007254352725bae26a2cf41c5ef5">DenseMatrix&lt;T&gt;::_lu_back_substitute_lapack</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; b,
<a name="l00534"></a>00534                                                  <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x) 
<a name="l00535"></a>00535 {
<a name="l00536"></a>00536   <span class="comment">// The calling sequence for getrs is:</span>
<a name="l00537"></a>00537   <span class="comment">// dgetrs(TRANS, N, NRHS, A, LDA, IPIV, B, LDB, INFO)</span>
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="comment">//    trans   (input) char*</span>
<a name="l00540"></a>00540   <span class="comment">//            &#39;n&#39; for no tranpose, &#39;t&#39; for transpose</span>
<a name="l00541"></a>00541   <span class="keywordtype">char</span> TRANS[] = <span class="stringliteral">&quot;t&quot;</span>;
<a name="l00542"></a>00542   
<a name="l00543"></a>00543   <span class="comment">//    N       (input) int*</span>
<a name="l00544"></a>00544   <span class="comment">//            The order of the matrix A.  N &gt;= 0.</span>
<a name="l00545"></a>00545   <span class="keywordtype">int</span> N = this-&gt;m();
<a name="l00546"></a>00546   
<a name="l00547"></a>00547  
<a name="l00548"></a>00548   <span class="comment">//    NRHS    (input) int*</span>
<a name="l00549"></a>00549   <span class="comment">//            The number of right hand sides, i.e., the number of columns</span>
<a name="l00550"></a>00550   <span class="comment">//            of the matrix B.  NRHS &gt;= 0.</span>
<a name="l00551"></a>00551   <span class="keywordtype">int</span> NRHS = 1;
<a name="l00552"></a>00552  
<a name="l00553"></a>00553   <span class="comment">//    A       (input) DOUBLE PRECISION array, dimension (LDA,N)</span>
<a name="l00554"></a>00554   <span class="comment">//            The factors L and U from the factorization A = P*L*U</span>
<a name="l00555"></a>00555   <span class="comment">//            as computed by dgetrf.</span>
<a name="l00556"></a>00556   <span class="comment">// Here, we pass &amp;(_val[0])</span>
<a name="l00557"></a>00557   
<a name="l00558"></a>00558   <span class="comment">//    LDA     (input) int*</span>
<a name="l00559"></a>00559   <span class="comment">//            The leading dimension of the array A.  LDA &gt;= max(1,N).</span>
<a name="l00560"></a>00560   <span class="keywordtype">int</span> LDA = N;
<a name="l00561"></a>00561     
<a name="l00562"></a>00562   <span class="comment">//    ipiv    (input) int array, dimension (N)</span>
<a name="l00563"></a>00563   <span class="comment">//            The pivot indices from DGETRF; for 1&lt;=i&lt;=N, row i of the</span>
<a name="l00564"></a>00564   <span class="comment">//            matrix was interchanged with row IPIV(i).</span>
<a name="l00565"></a>00565   <span class="comment">// Here, we pass &amp;(_pivots[0]) which was computed in _lu_decompose_lapack</span>
<a name="l00566"></a>00566  
<a name="l00567"></a>00567   <span class="comment">//    B       (input/output) DOUBLE PRECISION array, dimension (LDB,NRHS)</span>
<a name="l00568"></a>00568   <span class="comment">//            On entry, the right hand side matrix B.</span>
<a name="l00569"></a>00569   <span class="comment">//            On exit, the solution matrix X.</span>
<a name="l00570"></a>00570   <span class="comment">// Here, we pass a copy of the rhs vector&#39;s data array in x, so that the</span>
<a name="l00571"></a>00571   <span class="comment">// passed right-hand side b is unmodified.  I don&#39;t see a way around this</span>
<a name="l00572"></a>00572   <span class="comment">// copy if we want to maintain an unmodified rhs in LibMesh.</span>
<a name="l00573"></a>00573   x = b;
<a name="l00574"></a>00574   std::vector&lt;T&gt;&amp; x_vec = x.<a class="code" href="classlibMesh_1_1DenseVector.php#a09f9e592bb23ee55d1c02bbe8fe3fca6">get_values</a>();
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   <span class="comment">// We can avoid the copy if we don&#39;t care about overwriting the RHS: just</span>
<a name="l00577"></a>00577   <span class="comment">// pass b to the Lapack routine and then swap with x before exiting</span>
<a name="l00578"></a>00578   <span class="comment">// std::vector&lt;T&gt;&amp; x_vec = b.get_values();</span>
<a name="l00579"></a>00579  
<a name="l00580"></a>00580   <span class="comment">//    LDB     (input) int*</span>
<a name="l00581"></a>00581   <span class="comment">//            The leading dimension of the array B.  LDB &gt;= max(1,N).</span>
<a name="l00582"></a>00582   <span class="keywordtype">int</span> LDB = N;
<a name="l00583"></a>00583  
<a name="l00584"></a>00584   <span class="comment">//    INFO    (output) int*</span>
<a name="l00585"></a>00585   <span class="comment">//            = 0:  successful exit</span>
<a name="l00586"></a>00586   <span class="comment">//            &lt; 0:  if INFO = -i, the i-th argument had an illegal value</span>
<a name="l00587"></a>00587   <span class="keywordtype">int</span> INFO = 0;
<a name="l00588"></a>00588   
<a name="l00589"></a>00589   <span class="comment">// Finally, ready to call the Lapack getrs function</span>
<a name="l00590"></a>00590   LAPACKgetrs_(TRANS, &amp;N, &amp;NRHS, &amp;(_val[0]), &amp;LDA, &amp;(_pivots[0]), &amp;(x_vec[0]), &amp;LDB, &amp;INFO);
<a name="l00591"></a>00591 
<a name="l00592"></a>00592   <span class="comment">// Check return value for errors</span>
<a name="l00593"></a>00593   <span class="keywordflow">if</span> (INFO != 0)
<a name="l00594"></a>00594     {
<a name="l00595"></a>00595       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;INFO=&quot;</span>
<a name="l00596"></a>00596                     &lt;&lt; INFO
<a name="l00597"></a>00597                     &lt;&lt; <span class="stringliteral">&quot;, Error during Lapack LU solve!&quot;</span> &lt;&lt; std::endl;
<a name="l00598"></a>00598       libmesh_error();
<a name="l00599"></a>00599     }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601   <span class="comment">// Don&#39;t do this if you already made a copy of b above</span>
<a name="l00602"></a>00602   <span class="comment">// Swap b and x.  The solution will then be in x, and whatever was originally</span>
<a name="l00603"></a>00603   <span class="comment">// in x, maybe garbage, maybe nothing, will be in b.</span>
<a name="l00604"></a>00604   <span class="comment">// FIXME: Rewrite the LU and Cholesky solves to just take one input, and overwrite</span>
<a name="l00605"></a>00605   <span class="comment">// the input.  This *should* make user code simpler, as they don&#39;t have to create</span>
<a name="l00606"></a>00606   <span class="comment">// an extra vector just to pass it in to the solve function!</span>
<a name="l00607"></a>00607   <span class="comment">// b.swap(x);</span>
<a name="l00608"></a>00608 }
<a name="l00609"></a>00609 
<a name="l00610"></a>00610 <span class="preprocessor">#else</span>
<a name="l00611"></a>00611 <span class="preprocessor"></span>
<a name="l00612"></a>00612 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00613"></a>00613 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac70a007254352725bae26a2cf41c5ef5">DenseMatrix&lt;T&gt;::_lu_back_substitute_lapack</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; ,
<a name="l00614"></a>00614                                                  <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; )
<a name="l00615"></a>00615 {
<a name="l00616"></a>00616   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;No PETSc-provided BLAS/LAPACK available!&quot;</span> &lt;&lt; std::endl;
<a name="l00617"></a>00617   libmesh_error();
<a name="l00618"></a>00618 }
<a name="l00619"></a>00619 
<a name="l00620"></a>00620 <span class="preprocessor">#endif</span>
<a name="l00621"></a>00621 <span class="preprocessor"></span>
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 <span class="preprocessor">#if (LIBMESH_HAVE_PETSC &amp;&amp; LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00627"></a>00627 <span class="preprocessor"></span>
<a name="l00628"></a>00628 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00629"></a><a class="code" href="classlibMesh_1_1DenseMatrix.php#a7d06e96c79a3d579cd03bd8836ad1090">00629</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a7d06e96c79a3d579cd03bd8836ad1090">DenseMatrix&lt;T&gt;::_matvec_blas</a>(T alpha, T beta,
<a name="l00630"></a>00630                                   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest,
<a name="l00631"></a>00631                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; arg,
<a name="l00632"></a>00632                                   <span class="keywordtype">bool</span> trans)<span class="keyword"> const</span>
<a name="l00633"></a>00633 <span class="keyword"></span>{
<a name="l00634"></a>00634   <span class="comment">// Ensure that dest and arg sizes are compatible</span>
<a name="l00635"></a>00635   <span class="keywordflow">if</span> (!trans)
<a name="l00636"></a>00636     {
<a name="l00637"></a>00637       <span class="comment">// dest  ~ A     * arg</span>
<a name="l00638"></a>00638       <span class="comment">// (mx1)   (mxn) * (nx1)</span>
<a name="l00639"></a>00639       <span class="keywordflow">if</span> ((dest.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() != this-&gt;m()) || (arg.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() != this-&gt;n()))
<a name="l00640"></a>00640         {
<a name="l00641"></a>00641           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Improper input argument sizes!&quot;</span> &lt;&lt; std::endl;
<a name="l00642"></a>00642           libmesh_error();
<a name="l00643"></a>00643         }
<a name="l00644"></a>00644     }
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <span class="keywordflow">else</span> <span class="comment">// trans == true</span>
<a name="l00647"></a>00647     {
<a name="l00648"></a>00648       <span class="comment">// Ensure that dest and arg are proper size</span>
<a name="l00649"></a>00649       <span class="comment">// dest  ~ A^T   * arg</span>
<a name="l00650"></a>00650       <span class="comment">// (nx1)   (nxm) * (mx1)</span>
<a name="l00651"></a>00651       <span class="keywordflow">if</span> ((dest.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() != this-&gt;n()) || (arg.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() != this-&gt;m()))
<a name="l00652"></a>00652         {
<a name="l00653"></a>00653           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Improper input argument sizes!&quot;</span> &lt;&lt; std::endl;
<a name="l00654"></a>00654           libmesh_error();
<a name="l00655"></a>00655         }
<a name="l00656"></a>00656     }
<a name="l00657"></a>00657   
<a name="l00658"></a>00658   <span class="comment">// Calling sequence for dgemv:</span>
<a name="l00659"></a>00659   <span class="comment">//</span>
<a name="l00660"></a>00660   <span class="comment">// dgemv(TRANS,M,N,ALPHA,A,LDA,X,INCX,BETA,Y,INCY)</span>
<a name="l00661"></a>00661   
<a name="l00662"></a>00662   <span class="comment">//   TRANS  - CHARACTER*1, &#39;t&#39; for transpose, &#39;n&#39; for non-transpose multiply</span>
<a name="l00663"></a>00663   <span class="comment">// We store everything in row-major order, so pass the transpose flag for</span>
<a name="l00664"></a>00664   <span class="comment">// non-transposed matvecs and the &#39;n&#39; flag for transposed matvecs</span>
<a name="l00665"></a>00665   <span class="keywordtype">char</span> TRANS[] = <span class="stringliteral">&quot;t&quot;</span>;
<a name="l00666"></a>00666   <span class="keywordflow">if</span> (trans)
<a name="l00667"></a>00667     TRANS[0] = <span class="charliteral">&#39;n&#39;</span>;
<a name="l00668"></a>00668   
<a name="l00669"></a>00669   <span class="comment">//   M      - INTEGER.</span>
<a name="l00670"></a>00670   <span class="comment">//            On entry, M specifies the number of rows of the matrix A.</span>
<a name="l00671"></a>00671   <span class="comment">// In C/C++, pass the number of *cols* of A</span>
<a name="l00672"></a>00672   <span class="keywordtype">int</span> M = this-&gt;n();
<a name="l00673"></a>00673     
<a name="l00674"></a>00674   <span class="comment">//   N      - INTEGER.</span>
<a name="l00675"></a>00675   <span class="comment">//            On entry, N specifies the number of columns of the matrix A.</span>
<a name="l00676"></a>00676   <span class="comment">// In C/C++, pass the number of *rows* of A</span>
<a name="l00677"></a>00677   <span class="keywordtype">int</span> N = this-&gt;m();
<a name="l00678"></a>00678   
<a name="l00679"></a>00679   <span class="comment">//   ALPHA  - DOUBLE PRECISION.</span>
<a name="l00680"></a>00680   <span class="comment">// The scalar constant passed to this function</span>
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   <span class="comment">//   A      - DOUBLE PRECISION array of DIMENSION ( LDA, n ).</span>
<a name="l00683"></a>00683   <span class="comment">//            Before entry, the leading m by n part of the array A must</span>
<a name="l00684"></a>00684   <span class="comment">//            contain the matrix of coefficients.</span>
<a name="l00685"></a>00685   <span class="comment">// The matrix, *this.  Note that _matvec_blas is called from</span>
<a name="l00686"></a>00686   <span class="comment">// a const function, vector_mult(), and so we have made this function const</span>
<a name="l00687"></a>00687   <span class="comment">// as well.  Since BLAS knows nothing about const, we have to cast it away</span>
<a name="l00688"></a>00688   <span class="comment">// now.</span>
<a name="l00689"></a>00689   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; a_ref = <span class="keyword">const_cast&lt;</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; <span class="keyword">&gt;</span> ( *this );
<a name="l00690"></a>00690   std::vector&lt;T&gt;&amp; a = a_ref.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a676d389b9cb9410e418026ec2c1a54c1">get_values</a>();
<a name="l00691"></a>00691 
<a name="l00692"></a>00692   <span class="comment">//   LDA    - INTEGER.</span>
<a name="l00693"></a>00693   <span class="comment">//            On entry, LDA specifies the first dimension of A as declared</span>
<a name="l00694"></a>00694   <span class="comment">//            in the calling (sub) program. LDA must be at least</span>
<a name="l00695"></a>00695   <span class="comment">//            max( 1, m ).</span>
<a name="l00696"></a>00696   <span class="keywordtype">int</span> LDA = M;
<a name="l00697"></a>00697   
<a name="l00698"></a>00698   <span class="comment">//   X      - DOUBLE PRECISION array of DIMENSION at least</span>
<a name="l00699"></a>00699   <span class="comment">//            ( 1 + ( n - 1 )*abs( INCX ) ) when TRANS = &#39;N&#39; or &#39;n&#39;</span>
<a name="l00700"></a>00700   <span class="comment">//            and at least</span>
<a name="l00701"></a>00701   <span class="comment">//            ( 1 + ( m - 1 )*abs( INCX ) ) otherwise.</span>
<a name="l00702"></a>00702   <span class="comment">//            Before entry, the incremented array X must contain the</span>
<a name="l00703"></a>00703   <span class="comment">//            vector x.</span>
<a name="l00704"></a>00704   <span class="comment">// Here, we must cast away the const-ness of &quot;arg&quot; since BLAS knows</span>
<a name="l00705"></a>00705   <span class="comment">// nothing about const</span>
<a name="l00706"></a>00706   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; x_ref = <span class="keyword">const_cast&lt;</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; <span class="keyword">&gt;</span> ( arg );
<a name="l00707"></a>00707   std::vector&lt;T&gt;&amp; x = x_ref.<a class="code" href="classlibMesh_1_1DenseVector.php#a09f9e592bb23ee55d1c02bbe8fe3fca6">get_values</a>();
<a name="l00708"></a>00708   
<a name="l00709"></a>00709   <span class="comment">//   INCX   - INTEGER.</span>
<a name="l00710"></a>00710   <span class="comment">//            On entry, INCX specifies the increment for the elements of</span>
<a name="l00711"></a>00711   <span class="comment">//            X. INCX must not be zero.</span>
<a name="l00712"></a>00712   <span class="keywordtype">int</span> INCX = 1;
<a name="l00713"></a>00713   
<a name="l00714"></a>00714   <span class="comment">//   BETA   - DOUBLE PRECISION.</span>
<a name="l00715"></a>00715   <span class="comment">//            On entry, BETA specifies the scalar beta. When BETA is</span>
<a name="l00716"></a>00716   <span class="comment">//            supplied as zero then Y need not be set on input.</span>
<a name="l00717"></a>00717   <span class="comment">// The second scalar constant passed to this function</span>
<a name="l00718"></a>00718 
<a name="l00719"></a>00719   <span class="comment">//   Y      - DOUBLE PRECISION array of DIMENSION at least</span>
<a name="l00720"></a>00720   <span class="comment">//            ( 1 + ( m - 1 )*abs( INCY ) ) when TRANS = &#39;N&#39; or &#39;n&#39;</span>
<a name="l00721"></a>00721   <span class="comment">//            and at least</span>
<a name="l00722"></a>00722   <span class="comment">//            ( 1 + ( n - 1 )*abs( INCY ) ) otherwise.</span>
<a name="l00723"></a>00723   <span class="comment">//            Before entry with BETA non-zero, the incremented array Y</span>
<a name="l00724"></a>00724   <span class="comment">//            must contain the vector y. On exit, Y is overwritten by the</span>
<a name="l00725"></a>00725   <span class="comment">//            updated vector y.</span>
<a name="l00726"></a>00726   <span class="comment">// The input vector &quot;dest&quot;</span>
<a name="l00727"></a>00727   std::vector&lt;T&gt;&amp; y = dest.<a class="code" href="classlibMesh_1_1DenseVector.php#a09f9e592bb23ee55d1c02bbe8fe3fca6">get_values</a>();
<a name="l00728"></a>00728 
<a name="l00729"></a>00729   <span class="comment">//   INCY   - INTEGER.</span>
<a name="l00730"></a>00730   <span class="comment">//            On entry, INCY specifies the increment for the elements of</span>
<a name="l00731"></a>00731   <span class="comment">//            Y. INCY must not be zero.</span>
<a name="l00732"></a>00732   <span class="keywordtype">int</span> INCY = 1;
<a name="l00733"></a>00733   
<a name="l00734"></a>00734   <span class="comment">// Finally, ready to call the BLAS function</span>
<a name="l00735"></a>00735   BLASgemv_(TRANS, &amp;M, &amp;N, &amp;alpha, &amp;(a[0]), &amp;LDA, &amp;(x[0]), &amp;INCX, &amp;beta, &amp;(y[0]), &amp;INCY);
<a name="l00736"></a>00736 }
<a name="l00737"></a>00737 
<a name="l00738"></a>00738 
<a name="l00739"></a>00739 <span class="preprocessor">#else</span>
<a name="l00740"></a>00740 <span class="preprocessor"></span>
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00743"></a>00743 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a7d06e96c79a3d579cd03bd8836ad1090">DenseMatrix&lt;T&gt;::_matvec_blas</a>(T , T,
<a name="l00744"></a>00744                                   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; ,
<a name="l00745"></a>00745                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp;,
<a name="l00746"></a>00746                                   <span class="keywordtype">bool</span> )<span class="keyword"> const</span>
<a name="l00747"></a>00747 <span class="keyword"></span>{
<a name="l00748"></a>00748   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;No PETSc-provided BLAS/LAPACK available!&quot;</span> &lt;&lt; std::endl;
<a name="l00749"></a>00749   libmesh_error();
<a name="l00750"></a>00750 }
<a name="l00751"></a>00751 
<a name="l00752"></a>00752 
<a name="l00753"></a>00753 <span class="preprocessor">#endif</span>
<a name="l00754"></a>00754 <span class="preprocessor"></span>
<a name="l00755"></a>00755 
<a name="l00756"></a>00756 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00757"></a>00757 <span class="comment">// Explicit instantiations</span>
<a name="l00758"></a>00758 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#af78dfd54eedcd8cb107a913b724395c2">DenseMatrix&lt;Real&gt;::_multiply_blas</a>(<span class="keyword">const</span> DenseMatrixBase&lt;Real&gt;&amp;, _BLAS_Multiply_Flag);
<a name="l00759"></a>00759 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a752c27f2644b00a8c6b779aecd644222">DenseMatrix&lt;Real&gt;::_lu_decompose_lapack</a>();
<a name="l00760"></a>00760 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac70a007254352725bae26a2cf41c5ef5">DenseMatrix&lt;Real&gt;::_lu_back_substitute_lapack</a>(<span class="keyword">const</span> DenseVector&lt;Real&gt;&amp; ,
<a name="l00761"></a>00761                                                             DenseVector&lt;Real&gt;&amp;);
<a name="l00762"></a>00762 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a7d06e96c79a3d579cd03bd8836ad1090">DenseMatrix&lt;Real&gt;::_matvec_blas</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,
<a name="l00763"></a>00763                                               DenseVector&lt;Real&gt;&amp; ,
<a name="l00764"></a>00764                                               <span class="keyword">const</span> DenseVector&lt;Real&gt;&amp;,
<a name="l00765"></a>00765                                               <span class="keywordtype">bool</span> ) <span class="keyword">const</span>;
<a name="l00766"></a>00766 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4ca6a9580863cac27f5beb767b6dc69">DenseMatrix&lt;Real&gt;::_svd_lapack</a>(DenseVector&lt;Real&gt;&amp;);
<a name="l00767"></a>00767 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4ca6a9580863cac27f5beb767b6dc69">DenseMatrix&lt;Real&gt;::_svd_lapack</a>(DenseVector&lt;Real&gt;&amp;, DenseMatrix&lt;Real&gt;&amp;, DenseMatrix&lt;Real&gt;&amp;);
<a name="l00768"></a>00768 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a9499f275e74feefde23ea3a116918c95">DenseMatrix&lt;Real&gt;::_svd_helper</a> (<span class="keywordtype">char</span>, <span class="keywordtype">char</span>, std::vector&lt;Real&gt;&amp;,
<a name="l00769"></a>00769                                               std::vector&lt;Real&gt;&amp;,
<a name="l00770"></a>00770                                               std::vector&lt;Real&gt;&amp; );
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 <span class="preprocessor">#if !(LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00773"></a>00773 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#af78dfd54eedcd8cb107a913b724395c2">DenseMatrix&lt;Number&gt;::_multiply_blas</a>(<span class="keyword">const</span> DenseMatrixBase&lt;Number&gt;&amp;, _BLAS_Multiply_Flag);
<a name="l00774"></a>00774 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a752c27f2644b00a8c6b779aecd644222">DenseMatrix&lt;Number&gt;::_lu_decompose_lapack</a>();
<a name="l00775"></a>00775 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ac70a007254352725bae26a2cf41c5ef5">DenseMatrix&lt;Number&gt;::_lu_back_substitute_lapack</a>(<span class="keyword">const</span> DenseVector&lt;Number&gt;&amp; ,
<a name="l00776"></a>00776                                                               DenseVector&lt;Number&gt;&amp;);
<a name="l00777"></a>00777 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a7d06e96c79a3d579cd03bd8836ad1090">DenseMatrix&lt;Number&gt;::_matvec_blas</a>(<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>, <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>,
<a name="l00778"></a>00778                                                 DenseVector&lt;Number&gt;&amp; ,
<a name="l00779"></a>00779                                                 <span class="keyword">const</span> DenseVector&lt;Number&gt;&amp;,
<a name="l00780"></a>00780                                                 <span class="keywordtype">bool</span> ) <span class="keyword">const</span>;
<a name="l00781"></a>00781 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4ca6a9580863cac27f5beb767b6dc69">DenseMatrix&lt;Number&gt;::_svd_lapack</a>(DenseVector&lt;Number&gt;&amp;);
<a name="l00782"></a>00782 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#ad4ca6a9580863cac27f5beb767b6dc69">DenseMatrix&lt;Number&gt;::_svd_lapack</a>(DenseVector&lt;Number&gt;&amp;, DenseMatrix&lt;Number&gt;&amp;, DenseMatrix&lt;Number&gt;&amp;);
<a name="l00783"></a>00783 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php#a9499f275e74feefde23ea3a116918c95">DenseMatrix&lt;Number&gt;::_svd_helper</a> (<span class="keywordtype">char</span>, <span class="keywordtype">char</span>, std::vector&lt;Number&gt;&amp;,
<a name="l00784"></a>00784                                                 std::vector&lt;Number&gt;&amp;,
<a name="l00785"></a>00785                                                 std::vector&lt;Number&gt;&amp; );
<a name="l00786"></a>00786 <span class="preprocessor">#endif</span>
<a name="l00787"></a>00787 <span class="preprocessor"></span>
<a name="l00788"></a>00788 } <span class="comment">// namespace libMesh</span>
<a name="l00789"></a>00789 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
