<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dense_submatrix.h</div>  </div>
</div>
<div class="contents">
<a href="dense__submatrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_submatrix.h 3930 2010-08-24 23:04:08Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_submatrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_submatrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__subvector_8h.php">dense_subvector.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// DenseSubMatrix class definition</span>
<a name="l00047"></a>00047 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00048"></a><a class="code" href="classlibMesh_1_1DenseSubMatrix.php">00048</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix</a>(<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; parent,
<a name="l00059"></a>00059                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff=0,
<a name="l00060"></a>00060                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> joff=0,
<a name="l00061"></a>00061                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>=0,
<a name="l00062"></a>00062                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>=0);
<a name="l00063"></a>00063 
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix&lt;T&gt;</a>&amp; other_matrix);
<a name="l00068"></a>00068   
<a name="l00072"></a>00072   <span class="keyword">virtual</span> ~<a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix</a>() {};
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; parent () { <span class="keywordflow">return</span> _parent_matrix; }
<a name="l00079"></a>00079   
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a9b2447c7f9169d1d1c01f9b453f48df9">zero</a>();
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   T operator() (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00089"></a>00089                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   T &amp; operator() (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00095"></a>00095                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j);
<a name="l00096"></a>00096   
<a name="l00100"></a>00100   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a18b1c581e3f4badd001432e7ca67e31c">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00101"></a>00101                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); }
<a name="l00102"></a>00102 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> T &amp; <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a18b1c581e3f4badd001432e7ca67e31c">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00107"></a>00107                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)     { <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i,j); } 
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#afcb264450d957c4bc7ca54ad487ea8df">left_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M2);
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a1a8f1cc874504144e65f4ba01747c286">right_multiply</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase&lt;T&gt;</a>&amp; M3);
<a name="l00118"></a>00118   
<a name="l00122"></a>00122   <span class="keywordtype">void</span> reposition(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff,
<a name="l00123"></a>00123                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> joff,
<a name="l00124"></a>00124                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>,
<a name="l00125"></a>00125                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>);
<a name="l00126"></a>00126 
<a name="l00130"></a>00130   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_off()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> _i_off; }
<a name="l00131"></a>00131 
<a name="l00135"></a>00135   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j_off()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> _j_off; }
<a name="l00136"></a>00136 
<a name="l00143"></a>00143   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a0472bd2ec76bfa88657299b9d39ab399">condense</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00144"></a>00144                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00145"></a>00145                 <span class="keyword">const</span> T val,
<a name="l00146"></a>00146                 <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; rhs)
<a name="l00147"></a>00147   {
<a name="l00148"></a>00148     this-&gt;parent().<a class="code" href="classlibMesh_1_1DenseMatrix.php#ae2a11c928f4640150f9df555b07ac35e">condense</a>(this-&gt;i_off()+i,
<a name="l00149"></a>00149                             this-&gt;j_off()+j,
<a name="l00150"></a>00150                             val, rhs.parent());
<a name="l00151"></a>00151   }
<a name="l00152"></a>00152   
<a name="l00153"></a>00153 <span class="keyword">private</span>:
<a name="l00154"></a>00154   
<a name="l00158"></a>00158   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; _parent_matrix;
<a name="l00159"></a>00159   
<a name="l00163"></a>00163   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _i_off;
<a name="l00164"></a>00164 
<a name="l00168"></a>00168   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _j_off;
<a name="l00169"></a>00169 };
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="comment">// -------------------------------------------------- </span>
<a name="l00173"></a>00173 <span class="comment">// Constructor</span>
<a name="l00174"></a>00174 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00175"></a>00175 <span class="keyword">inline</span>
<a name="l00176"></a>00176 <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix&lt;T&gt;::DenseSubMatrix</a>(<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; parent,
<a name="l00177"></a>00177                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff,
<a name="l00178"></a>00178                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> joff,
<a name="l00179"></a>00179                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00180"></a>00180                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) 
<a name="l00181"></a>00181   : <a class="code" href="classlibMesh_1_1DenseMatrixBase.php">DenseMatrixBase</a>&lt;T&gt;(m,n),
<a name="l00182"></a>00182     _parent_matrix(parent)
<a name="l00183"></a>00183 {
<a name="l00184"></a>00184   this-&gt;reposition (ioff, joff, m, n);
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="comment">// Copy Constructor</span>
<a name="l00189"></a>00189 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00190"></a>00190 <span class="keyword">inline</span>
<a name="l00191"></a>00191 DenseSubMatrix&lt;T&gt;::DenseSubMatrix(<span class="keyword">const</span> DenseSubMatrix&lt;T&gt;&amp; other_matrix)
<a name="l00192"></a>00192   : DenseMatrixBase&lt;T&gt;(other_matrix._m, other_matrix._n),
<a name="l00193"></a>00193     _parent_matrix(other_matrix._parent_matrix)
<a name="l00194"></a>00194 {
<a name="l00195"></a>00195   _i_off = other_matrix._i_off; 
<a name="l00196"></a>00196   _j_off = other_matrix._j_off; 
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00201"></a>00201 <span class="keyword">inline</span>
<a name="l00202"></a>00202 <span class="keywordtype">void</span> DenseSubMatrix&lt;T&gt;::reposition(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff,
<a name="l00203"></a>00203                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> joff,
<a name="l00204"></a>00204                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00205"></a>00205                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00206"></a>00206 {                                  
<a name="l00207"></a>00207   _i_off = ioff;
<a name="l00208"></a>00208   _j_off = joff;
<a name="l00209"></a>00209   this-&gt;_m = m;
<a name="l00210"></a>00210   this-&gt;_n = n;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="comment">// Make sure we still fit in the parent matrix.</span>
<a name="l00213"></a>00213   libmesh_assert ((this-&gt;i_off() + this-&gt;m()) &lt;= _parent_matrix.m());
<a name="l00214"></a>00214   libmesh_assert ((this-&gt;j_off() + this-&gt;n()) &lt;= _parent_matrix.n());
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00220"></a>00220 <span class="keyword">inline</span>
<a name="l00221"></a>00221 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a9b2447c7f9169d1d1c01f9b453f48df9">DenseSubMatrix&lt;T&gt;::zero</a>()
<a name="l00222"></a>00222 {
<a name="l00223"></a>00223   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;m(); i++)
<a name="l00224"></a>00224     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;this-&gt;n(); j++)
<a name="l00225"></a>00225       _parent_matrix(i + this-&gt;i_off(),
<a name="l00226"></a>00226                      j + this-&gt;j_off()) = 0.;
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00232"></a>00232 <span class="keyword">inline</span>
<a name="l00233"></a>00233 T DenseSubMatrix&lt;T&gt;::operator () (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00234"></a>00234                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00235"></a>00235 <span class="keyword"></span>{
<a name="l00236"></a>00236   libmesh_assert (i &lt; this-&gt;m());
<a name="l00237"></a>00237   libmesh_assert (j &lt; this-&gt;n());
<a name="l00238"></a>00238   libmesh_assert (i + this-&gt;i_off() &lt; _parent_matrix.m());
<a name="l00239"></a>00239   libmesh_assert (j + this-&gt;j_off() &lt; _parent_matrix.n());
<a name="l00240"></a>00240   
<a name="l00241"></a>00241   <span class="keywordflow">return</span> _parent_matrix (i + this-&gt;i_off(),
<a name="l00242"></a>00242                          j + this-&gt;j_off());
<a name="l00243"></a>00243 }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00247"></a>00247 <span class="keyword">inline</span>
<a name="l00248"></a>00248 T &amp; DenseSubMatrix&lt;T&gt;::operator () (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00249"></a>00249                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)
<a name="l00250"></a>00250 {
<a name="l00251"></a>00251   libmesh_assert (i &lt; this-&gt;m());
<a name="l00252"></a>00252   libmesh_assert (j &lt; this-&gt;n());
<a name="l00253"></a>00253   libmesh_assert (i + this-&gt;i_off() &lt; _parent_matrix.m());
<a name="l00254"></a>00254   libmesh_assert (j + this-&gt;j_off() &lt; _parent_matrix.n());
<a name="l00255"></a>00255   
<a name="l00256"></a>00256   <span class="keywordflow">return</span> _parent_matrix (i + this-&gt;i_off(),
<a name="l00257"></a>00257                          j + this-&gt;j_off());
<a name="l00258"></a>00258 }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 } <span class="comment">// namespace libMesh</span>
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 <span class="preprocessor">#endif // #ifndef __dense_matrix_h__</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
