<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dense_vector.h</div>  </div>
</div>
<div class="contents">
<a href="dense__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dense_vector.h 3912 2010-08-23 22:25:28Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dense_vector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dense_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="compare__types_8h.php">compare_types.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector__base_8h.php">dense_vector_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// DenseVector class definition</span>
<a name="l00051"></a>00051 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00052"></a><a class="code" href="classlibMesh_1_1DenseVector.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1DenseVectorBase.php">DenseVectorBase</a>&lt;T&gt;
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <span class="keyword">explicit</span>
<a name="l00060"></a>00060   <a class="code" href="classlibMesh_1_1DenseVector.php#aad9a32a48f641676cf5bc5cb215d7bf0">DenseVector</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0);
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1DenseVector.php#aad9a32a48f641676cf5bc5cb215d7bf0">DenseVector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; other_vector);
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1DenseVector.php#aad9a32a48f641676cf5bc5cb215d7bf0">DenseVector</a> (<span class="keyword">const</span> std::vector&lt;T2&gt;&amp; other_vector);
<a name="l00073"></a>00073   
<a name="l00077"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a4b0b8ffe74d451a8dc9b09901b127a2b">00077</a>   <a class="code" href="classlibMesh_1_1DenseVector.php#a4b0b8ffe74d451a8dc9b09901b127a2b">~DenseVector</a>() {}
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">00082</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DenseVector.php#a76dbc878af763c7ab4b1edb996fc6e65">_val</a>.size(); }
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00088"></a>00088   
<a name="l00092"></a>00092   T <a class="code" href="classlibMesh_1_1DenseVector.php#acae92b1523e4cec37fab173eb59a2b5c">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00093"></a>00093 
<a name="l00097"></a>00097   T &amp; <a class="code" href="classlibMesh_1_1DenseVector.php#acae92b1523e4cec37fab173eb59a2b5c">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="classlibMesh_1_1DenseVector.php#adfcd41dac4906a4c9334e42d801badf9">00102</a>   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1DenseVector.php#adfcd41dac4906a4c9334e42d801badf9">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i); }
<a name="l00103"></a>00103 
<a name="l00107"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a3f54082db214f04005fbefa19273ad54">00107</a>   <span class="keyword">virtual</span> T &amp; <a class="code" href="classlibMesh_1_1DenseVector.php#a3f54082db214f04005fbefa19273ad54">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)     { <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i); }
<a name="l00108"></a>00108   
<a name="l00112"></a>00112   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#a536bbb46dacb84d88493ff6547110976">operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; other_vector);
<a name="l00114"></a>00114   
<a name="l00118"></a>00118   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; other_vector);
<a name="l00119"></a>00119   
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00124"></a>00124 
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#af9c240ca08d420f6c949e6d1295e1fbe">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00129"></a>00129   
<a name="l00133"></a>00133   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#a3ac21aa470056b6a9f1dcb6f87b790da">operator*= </a>(<span class="keyword">const</span> T factor);
<a name="l00134"></a>00134   
<a name="l00140"></a>00140   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3&gt;
<a name="l00141"></a>00141   <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00142"></a>00142     <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;T2&gt;::value</a>, <span class="keywordtype">void</span> &gt;::type
<a name="l00143"></a>00143   <a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">add</a> (<span class="keyword">const</span> T2 factor,
<a name="l00144"></a>00144        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T3&gt;</a>&amp; vec);
<a name="l00145"></a>00145 
<a name="l00149"></a>00149   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00150"></a>00150   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">dot</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l00151"></a>00151 
<a name="l00155"></a>00155   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00156"></a>00156   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseVector.php#a90fe310b5d5cab6543c2658beec2052a">operator== </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l00157"></a>00157   
<a name="l00161"></a>00161   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00162"></a>00162   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseVector.php#ac2c7d5761d6d548dc3992474e88b139c">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec) <span class="keyword">const</span>;
<a name="l00163"></a>00163   
<a name="l00167"></a>00167   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00168"></a>00168   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#ae4e74296494017e58af57e7ff71b8897">operator+= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec);
<a name="l00169"></a>00169   
<a name="l00173"></a>00173   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T2&gt;
<a name="l00174"></a>00174   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#abbfbf457b9a77059574762d71ad71548">operator-= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a> &amp;vec);
<a name="l00175"></a>00175   
<a name="l00181"></a>00181   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#a90fbc1967e6f64bacee885ce12ac7a92">min</a> () <span class="keyword">const</span>;
<a name="l00182"></a>00182 
<a name="l00188"></a>00188   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#ac16cae5fbf3e4edaba3ceb0d0fcb8890">max</a> () <span class="keyword">const</span>;
<a name="l00189"></a>00189 
<a name="l00194"></a>00194   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#a765bfe54381b809720db3841b1a1d3a8">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00195"></a>00195 
<a name="l00201"></a>00201   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#aba21b1716e029687d91f20e44ac7ae93">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00202"></a>00202 
<a name="l00208"></a>00208   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#aaac31c8483b433b37983a78a99b7762b">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00209"></a>00209 
<a name="l00214"></a>00214   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#aacfb5c2e5aee056320aaae4c9dd22a55">get_principal_subvector</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_n, <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00215"></a>00215 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a09f9e592bb23ee55d1c02bbe8fe3fca6">00221</a>   std::vector&lt;T&gt;&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#a09f9e592bb23ee55d1c02bbe8fe3fca6">get_values</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DenseVector.php#a76dbc878af763c7ab4b1edb996fc6e65">_val</a>; }
<a name="l00222"></a>00222 
<a name="l00228"></a><a class="code" href="classlibMesh_1_1DenseVector.php#ae7d05a414f8f36f13e7fc2045b5892c4">00228</a>   <span class="keyword">const</span> std::vector&lt;T&gt;&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#ae7d05a414f8f36f13e7fc2045b5892c4">get_values</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DenseVector.php#a76dbc878af763c7ab4b1edb996fc6e65">_val</a>; }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="keyword">private</span>:
<a name="l00231"></a>00231 
<a name="l00235"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a76dbc878af763c7ab4b1edb996fc6e65">00235</a>   std::vector&lt;T&gt; <a class="code" href="classlibMesh_1_1DenseVector.php#a76dbc878af763c7ab4b1edb996fc6e65">_val</a>;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 };
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00242"></a>00242 <span class="comment">// DenseVector member functions</span>
<a name="l00243"></a>00243 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00244"></a>00244 <span class="keyword">inline</span>
<a name="l00245"></a><a class="code" href="classlibMesh_1_1DenseVector.php#aad9a32a48f641676cf5bc5cb215d7bf0">00245</a> <a class="code" href="classlibMesh_1_1DenseVector.php#aad9a32a48f641676cf5bc5cb215d7bf0">DenseVector&lt;T&gt;::DenseVector</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) :
<a name="l00246"></a>00246   _val (n, 0.)
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248 }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00253"></a>00253 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00254"></a>00254 <span class="keyword">inline</span>
<a name="l00255"></a><a class="code" href="classlibMesh_1_1DenseVector.php#ad38f7560b83db0f096eb8b05f8f9b96d">00255</a> <a class="code" href="classlibMesh_1_1DenseVector.php#aad9a32a48f641676cf5bc5cb215d7bf0">DenseVector&lt;T&gt;::DenseVector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; other_vector) :
<a name="l00256"></a>00256   <a class="code" href="classlibMesh_1_1DenseVectorBase.php">DenseVectorBase</a>&lt;T&gt;()
<a name="l00257"></a>00257 {
<a name="l00258"></a>00258   <span class="keyword">const</span> std::vector&lt;T2&gt; &amp;other_vals = other_vector.<a class="code" href="classlibMesh_1_1DenseVector.php#a09f9e592bb23ee55d1c02bbe8fe3fca6">get_values</a>();
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <a class="code" href="classlibMesh_1_1DenseVector.php#a76dbc878af763c7ab4b1edb996fc6e65">_val</a>.clear();
<a name="l00261"></a>00261   <a class="code" href="classlibMesh_1_1DenseVector.php#a76dbc878af763c7ab4b1edb996fc6e65">_val</a>.reserve(other_vals.size());
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;other_vals.size(); i++)
<a name="l00264"></a>00264     <a class="code" href="classlibMesh_1_1DenseVector.php#a76dbc878af763c7ab4b1edb996fc6e65">_val</a>.push_back(other_vals[i]);
<a name="l00265"></a>00265 }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00270"></a>00270 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00271"></a>00271 <span class="keyword">inline</span>
<a name="l00272"></a><a class="code" href="classlibMesh_1_1DenseVector.php#aca9e4dde8259a0ce339595a861ab8c02">00272</a> <a class="code" href="classlibMesh_1_1DenseVector.php#aad9a32a48f641676cf5bc5cb215d7bf0">DenseVector&lt;T&gt;::DenseVector</a> (<span class="keyword">const</span> std::vector&lt;T2&gt;&amp; other_vector) :
<a name="l00273"></a>00273   _val(other_vector)
<a name="l00274"></a>00274 {  
<a name="l00275"></a>00275 }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00282"></a>00282 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00283"></a>00283 <span class="keyword">inline</span>
<a name="l00284"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a536bbb46dacb84d88493ff6547110976">00284</a> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#a536bbb46dacb84d88493ff6547110976">DenseVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; other_vector)
<a name="l00285"></a>00285 {
<a name="l00286"></a>00286   <span class="comment">//  _val = other_vector._val;</span>
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   <span class="keyword">const</span> std::vector&lt;T2&gt; &amp;other_vals = other_vector.<a class="code" href="classlibMesh_1_1DenseVector.php#a09f9e592bb23ee55d1c02bbe8fe3fca6">get_values</a>();
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   _val.clear();
<a name="l00291"></a>00291   _val.reserve(other_vals.size());
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;other_vals.size(); i++)
<a name="l00294"></a>00294     _val.push_back(other_vals[i]);
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00297"></a>00297 }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00302"></a>00302 <span class="keyword">inline</span>
<a name="l00303"></a><a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">00303</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">DenseVector&lt;T&gt;::swap</a>(<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; other_vector)
<a name="l00304"></a>00304 {
<a name="l00305"></a>00305   _val.swap(other_vector.<a class="code" href="classlibMesh_1_1DenseVector.php#a76dbc878af763c7ab4b1edb996fc6e65">_val</a>);
<a name="l00306"></a>00306 }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00311"></a>00311 <span class="keyword">inline</span>
<a name="l00312"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">00312</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">DenseVector&lt;T&gt;::resize</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00313"></a>00313 {
<a name="l00314"></a>00314   _val.resize(n);
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>();
<a name="l00317"></a>00317 }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00322"></a>00322 <span class="keyword">inline</span>
<a name="l00323"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">00323</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">DenseVector&lt;T&gt;::zero</a>()
<a name="l00324"></a>00324 {
<a name="l00325"></a>00325   std::fill (_val.begin(),
<a name="l00326"></a>00326              _val.end(),
<a name="l00327"></a>00327              0.);
<a name="l00328"></a>00328 }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00333"></a>00333 <span class="keyword">inline</span>
<a name="l00334"></a><a class="code" href="classlibMesh_1_1DenseVector.php#acae92b1523e4cec37fab173eb59a2b5c">00334</a> T <a class="code" href="classlibMesh_1_1DenseVector.php#acae92b1523e4cec37fab173eb59a2b5c">DenseVector&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00335"></a>00335 <span class="keyword"></span>{
<a name="l00336"></a>00336   libmesh_assert (i &lt; _val.size());
<a name="l00337"></a>00337   
<a name="l00338"></a>00338   <span class="keywordflow">return</span> _val[i]; 
<a name="l00339"></a>00339 }
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00344"></a>00344 <span class="keyword">inline</span>
<a name="l00345"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a32b58de3ad3d4ae8639aa7232f48bf6f">00345</a> T &amp; <a class="code" href="classlibMesh_1_1DenseVector.php#acae92b1523e4cec37fab173eb59a2b5c">DenseVector&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00346"></a>00346 {
<a name="l00347"></a>00347   libmesh_assert (i &lt; _val.size());
<a name="l00348"></a>00348   
<a name="l00349"></a>00349   <span class="keywordflow">return</span> _val[i]; 
<a name="l00350"></a>00350 }
<a name="l00351"></a>00351       
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00355"></a>00355 <span class="keyword">inline</span>
<a name="l00356"></a><a class="code" href="classlibMesh_1_1DenseVector.php#af9c240ca08d420f6c949e6d1295e1fbe">00356</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#af9c240ca08d420f6c949e6d1295e1fbe">DenseVector&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00357"></a>00357 {
<a name="l00358"></a>00358   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_val.size(); i++)
<a name="l00359"></a>00359     _val[i] *= factor;
<a name="l00360"></a>00360 }
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00365"></a>00365 <span class="keyword">inline</span>
<a name="l00366"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a3ac21aa470056b6a9f1dcb6f87b790da">00366</a> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#a3ac21aa470056b6a9f1dcb6f87b790da">DenseVector&lt;T&gt;::operator*= </a>(<span class="keyword">const</span> T factor)
<a name="l00367"></a>00367 {
<a name="l00368"></a>00368   this-&gt;<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a48c03ebd8ce97c6c8aef8e2a05a94a16">scale</a>(factor);
<a name="l00369"></a>00369   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00370"></a>00370 }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00375"></a>00375 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2, <span class="keyword">typename</span> T3&gt;
<a name="l00376"></a>00376 <span class="keyword">inline</span>
<a name="l00377"></a>00377 <span class="keyword">typename</span> <a class="code" href="structlibMesh_1_1boostcopy_1_1enable__if__c.php">boostcopy::enable_if_c</a>&lt;
<a name="l00378"></a>00378   <a class="code" href="structlibMesh_1_1ScalarTraits.php">ScalarTraits&lt;T2&gt;::value</a>, <span class="keywordtype">void</span> &gt;::type
<a name="l00379"></a><a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">00379</a> <a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">DenseVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T2 factor,
<a name="l00380"></a>00380                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T3&gt;</a>&amp; vec)
<a name="l00381"></a>00381 {
<a name="l00382"></a>00382   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00383"></a>00383 
<a name="l00384"></a>00384   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00385"></a>00385     (*<span class="keyword">this</span>)(i) += factor*vec(i);
<a name="l00386"></a>00386 }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00389"></a>00389 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00390"></a>00390 <span class="keyword">inline</span>
<a name="l00391"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">00391</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1DenseVector.php#a740926ab2815bb507a1e33b659414be1">DenseVector&lt;T&gt;::dot</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00392"></a>00392 <span class="keyword"></span>{
<a name="l00393"></a>00393   libmesh_assert(this-&gt;size() == vec.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> val = 0.;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00398"></a>00398     val += (*<span class="keyword">this</span>)(i)*<a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(vec(i));
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   <span class="keywordflow">return</span> val;
<a name="l00401"></a>00401 }
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00404"></a>00404 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00405"></a>00405 <span class="keyword">inline</span>
<a name="l00406"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a90fe310b5d5cab6543c2658beec2052a">00406</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseVector.php#a90fe310b5d5cab6543c2658beec2052a">DenseVector&lt;T&gt;::operator== </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00407"></a>00407 <span class="keyword"></span>{
<a name="l00408"></a>00408   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00411"></a>00411     <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i) != vec(i))
<a name="l00412"></a>00412       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00415"></a>00415 }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00420"></a>00420 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00421"></a>00421 <span class="keyword">inline</span>
<a name="l00422"></a><a class="code" href="classlibMesh_1_1DenseVector.php#ac2c7d5761d6d548dc3992474e88b139c">00422</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DenseVector.php#ac2c7d5761d6d548dc3992474e88b139c">DenseVector&lt;T&gt;::operator!= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)<span class="keyword"> const</span>
<a name="l00423"></a>00423 <span class="keyword"></span>{
<a name="l00424"></a>00424   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00427"></a>00427     <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)(i) != vec(i))
<a name="l00428"></a>00428       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00431"></a>00431 }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00436"></a>00436 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00437"></a>00437 <span class="keyword">inline</span>
<a name="l00438"></a><a class="code" href="classlibMesh_1_1DenseVector.php#ae4e74296494017e58af57e7ff71b8897">00438</a> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#ae4e74296494017e58af57e7ff71b8897">DenseVector&lt;T&gt;::operator+= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)
<a name="l00439"></a>00439 {
<a name="l00440"></a>00440   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00443"></a>00443     (*<span class="keyword">this</span>)(i) += vec(i);
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00446"></a>00446 }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00451"></a>00451 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T2&gt;
<a name="l00452"></a>00452 <span class="keyword">inline</span>
<a name="l00453"></a><a class="code" href="classlibMesh_1_1DenseVector.php#abbfbf457b9a77059574762d71ad71548">00453</a> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DenseVector.php#abbfbf457b9a77059574762d71ad71548">DenseVector&lt;T&gt;::operator-= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T2&gt;</a>&amp; vec)
<a name="l00454"></a>00454 {
<a name="l00455"></a>00455   libmesh_assert (this-&gt;size() == vec.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;size(); i++)
<a name="l00458"></a>00458     (*<span class="keyword">this</span>)(i) -= vec(i);
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00461"></a>00461 }
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00466"></a>00466 <span class="keyword">inline</span>
<a name="l00467"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a90fbc1967e6f64bacee885ce12ac7a92">00467</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#a90fbc1967e6f64bacee885ce12ac7a92">DenseVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00468"></a>00468 <span class="keyword"></span>{
<a name="l00469"></a>00469   libmesh_assert (this-&gt;size());
<a name="l00470"></a>00470   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_min = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(0));
<a name="l00471"></a>00471 
<a name="l00472"></a>00472   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;size(); i++)
<a name="l00473"></a>00473     {
<a name="l00474"></a>00474       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(i));
<a name="l00475"></a>00475       my_min = (my_min &lt; current? my_min : current);
<a name="l00476"></a>00476     }
<a name="l00477"></a>00477   <span class="keywordflow">return</span> my_min;
<a name="l00478"></a>00478 }
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00483"></a>00483 <span class="keyword">inline</span>
<a name="l00484"></a><a class="code" href="classlibMesh_1_1DenseVector.php#ac16cae5fbf3e4edaba3ceb0d0fcb8890">00484</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#ac16cae5fbf3e4edaba3ceb0d0fcb8890">DenseVector&lt;T&gt;::max</a> ()<span class="keyword"> const</span>
<a name="l00485"></a>00485 <span class="keyword"></span>{
<a name="l00486"></a>00486   libmesh_assert (this-&gt;size());
<a name="l00487"></a>00487   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(0));
<a name="l00488"></a>00488 
<a name="l00489"></a>00489   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;size(); i++)
<a name="l00490"></a>00490     {
<a name="l00491"></a>00491       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(i));
<a name="l00492"></a>00492       my_max = (my_max &gt; current? my_max : current);
<a name="l00493"></a>00493     }
<a name="l00494"></a>00494   <span class="keywordflow">return</span> my_max;
<a name="l00495"></a>00495 }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00500"></a>00500 <span class="keyword">inline</span>
<a name="l00501"></a><a class="code" href="classlibMesh_1_1DenseVector.php#a765bfe54381b809720db3841b1a1d3a8">00501</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#a765bfe54381b809720db3841b1a1d3a8">DenseVector&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00502"></a>00502 <span class="keyword"></span>{
<a name="l00503"></a>00503   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_norm = 0.;
<a name="l00504"></a>00504   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;size(); i++)
<a name="l00505"></a>00505     {
<a name="l00506"></a>00506       my_norm += std::abs((*<span class="keyword">this</span>)(i));
<a name="l00507"></a>00507     }
<a name="l00508"></a>00508   <span class="keywordflow">return</span> my_norm;
<a name="l00509"></a>00509 }
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00514"></a>00514 <span class="keyword">inline</span>
<a name="l00515"></a><a class="code" href="classlibMesh_1_1DenseVector.php#aba21b1716e029687d91f20e44ac7ae93">00515</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#aba21b1716e029687d91f20e44ac7ae93">DenseVector&lt;T&gt;::l2_norm</a> ()<span class="keyword"> const</span>
<a name="l00516"></a>00516 <span class="keyword"></span>{
<a name="l00517"></a>00517   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_norm = 0.;
<a name="l00518"></a>00518   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=this-&gt;size(); i++)
<a name="l00519"></a>00519     {
<a name="l00520"></a>00520       my_norm += <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>((*<span class="keyword">this</span>)(i));
<a name="l00521"></a>00521     }
<a name="l00522"></a>00522   <span class="keywordflow">return</span> sqrt(my_norm);
<a name="l00523"></a>00523 }
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00528"></a>00528 <span class="keyword">inline</span>
<a name="l00529"></a><a class="code" href="classlibMesh_1_1DenseVector.php#aaac31c8483b433b37983a78a99b7762b">00529</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DenseVector.php#aaac31c8483b433b37983a78a99b7762b">DenseVector&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00530"></a>00530 <span class="keyword"></span>{
<a name="l00531"></a>00531   <span class="keywordflow">if</span> (!this-&gt;size())
<a name="l00532"></a>00532     <span class="keywordflow">return</span> 0.;
<a name="l00533"></a>00533   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_norm = <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>((*<span class="keyword">this</span>)(0));
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i!=this-&gt;size(); i++)
<a name="l00536"></a>00536     {
<a name="l00537"></a>00537       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current = <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>((*<span class="keyword">this</span>)(i));
<a name="l00538"></a>00538       my_norm = (my_norm &gt; current? my_norm : current);
<a name="l00539"></a>00539     }
<a name="l00540"></a>00540   <span class="keywordflow">return</span> sqrt(my_norm);
<a name="l00541"></a>00541 }
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00544"></a>00544 <span class="keyword">inline</span>
<a name="l00545"></a><a class="code" href="classlibMesh_1_1DenseVector.php#aacfb5c2e5aee056320aaae4c9dd22a55">00545</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DenseVector.php#aacfb5c2e5aee056320aaae4c9dd22a55">DenseVector&lt;T&gt;::get_principal_subvector</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_n,
<a name="l00546"></a>00546                                               <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; dest)<span class="keyword"> const</span>
<a name="l00547"></a>00547 <span class="keyword"></span>{
<a name="l00548"></a>00548   libmesh_assert( sub_n &lt;= this-&gt;size() );
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   dest.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(sub_n);
<a name="l00551"></a>00551   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;sub_n; i++)
<a name="l00552"></a>00552     dest(i) = (*this)(i);
<a name="l00553"></a>00553 }
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 } <span class="comment">// namespace libMesh</span>
<a name="l00556"></a>00556 
<a name="l00557"></a>00557 <span class="preprocessor">#endif // #ifndef __dense_vector_h__</span>
<a name="l00558"></a>00558 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
