<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">derived_rb_evaluation.C</div>  </div>
</div>
<div class="contents">
<a href="derived__rb__evaluation_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="derived__rb__evaluation_8h.php">derived_rb_evaluation.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="rb__system_8h.php">rb_system.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;sys/stat.h&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00029"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a19d5d161344a52783dc0109b8ed381be">00029</a> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a19d5d161344a52783dc0109b8ed381be">DerivedRBEvaluation&lt;Base&gt;::DerivedRBEvaluation</a>(<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; rb_sys)
<a name="l00030"></a>00030   :
<a name="l00031"></a>00031   Base(rb_sys),
<a name="l00032"></a>00032   residual_type_flag(RESIDUAL_WRT_UBER)
<a name="l00033"></a>00033 {}
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00036"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a5ed0a30b4b1fe9831a1a93226138e16f">00036</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a5ed0a30b4b1fe9831a1a93226138e16f">DerivedRBEvaluation&lt;Base&gt;::clear</a>()
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   Base::clear();
<a name="l00039"></a>00039   
<a name="l00040"></a>00040   <span class="comment">// Reset the residual type</span>
<a name="l00041"></a>00041   residual_type_flag = RESIDUAL_WRT_UBER;
<a name="l00042"></a>00042 }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00045"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#ab6772de297cf395c1bf8e363608f472b">00045</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#ab6772de297cf395c1bf8e363608f472b">DerivedRBEvaluation&lt;Base&gt;::get_n_basis_functions</a>()<span class="keyword"> const</span>
<a name="l00046"></a>00046 <span class="keyword"></span>{
<a name="l00047"></a>00047   <span class="keywordflow">return</span> derived_basis_functions.size();
<a name="l00048"></a>00048 }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00051"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#ad53bbec41b0e078256cbab8dcfb588ad">00051</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#ad53bbec41b0e078256cbab8dcfb588ad">DerivedRBEvaluation&lt;Base&gt;::set_n_basis_functions</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs)
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   derived_basis_functions.resize(n_bfs);
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a00155c803729d8b092bca89ef874c9fc">00057</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a00155c803729d8b092bca89ef874c9fc">DerivedRBEvaluation&lt;Base&gt;::write_out_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name,
<a name="l00058"></a>00058                                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   <span class="keywordflow">if</span>( Base::rb_sys.store_basis_functions &amp;&amp; (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0) ) <span class="comment">// Only write out on proc 0</span>
<a name="l00061"></a>00061   {
<a name="l00062"></a>00062     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Writing out the basis functions...&quot;</span> &lt;&lt; std::endl;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     std::ostringstream file_name;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;derived_basis_functions.size(); i++)
<a name="l00067"></a>00067     {
<a name="l00068"></a>00068       file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset the string</span>
<a name="l00069"></a>00069       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/derived_bf&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00070"></a>00070       std::ofstream derived_bf_out(file_name.str().c_str());
<a name="l00071"></a>00071       
<a name="l00072"></a>00072       <span class="keywordflow">if</span> ( !derived_bf_out.good() )
<a name="l00073"></a>00073       {
<a name="l00074"></a>00074         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening derived_bf&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00075"></a>00075         libmesh_error();
<a name="l00076"></a>00076       }
<a name="l00077"></a>00077       
<a name="l00078"></a>00078       derived_bf_out.precision(precision_level);
<a name="l00079"></a>00079       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;derived_basis_functions[i].size(); j++)
<a name="l00080"></a>00080       {
<a name="l00081"></a>00081         derived_bf_out &lt;&lt; std::scientific &lt;&lt; derived_basis_functions[i](j) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00082"></a>00082       }
<a name="l00083"></a>00083       derived_bf_out.close();
<a name="l00084"></a>00084     }
<a name="l00085"></a>00085     
<a name="l00086"></a>00086     <span class="comment">// Also, need to write out the size of the derived basis functions</span>
<a name="l00087"></a>00087     {
<a name="l00088"></a>00088       std::ofstream derived_bf_size_out;
<a name="l00089"></a>00089       {
<a name="l00090"></a>00090         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00091"></a>00091         file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/derived_bf_size.dat&quot;</span>;
<a name="l00092"></a>00092         derived_bf_size_out.open(file_name.str().c_str());
<a name="l00093"></a>00093       }
<a name="l00094"></a>00094       <span class="keywordflow">if</span> ( !derived_bf_size_out.good() )
<a name="l00095"></a>00095       {
<a name="l00096"></a>00096         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening derived_bf_size.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00097"></a>00097         libmesh_error();
<a name="l00098"></a>00098       }
<a name="l00099"></a>00099       derived_bf_size_out &lt;&lt; derived_basis_functions[0].size();
<a name="l00100"></a>00100       derived_bf_size_out.close();
<a name="l00101"></a>00101     }
<a name="l00102"></a>00102   }
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00106"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a4b90c2cd0aa5d523b427f0b9e6e973ad">00106</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a4b90c2cd0aa5d523b427f0b9e6e973ad">DerivedRBEvaluation&lt;Base&gt;::read_in_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name)
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108   <span class="keywordflow">if</span>(Base::rb_sys.store_basis_functions)
<a name="l00109"></a>00109   {
<a name="l00110"></a>00110     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading in the basis functions...&quot;</span> &lt;&lt; std::endl;
<a name="l00111"></a>00111     
<a name="l00112"></a>00112     <span class="comment">// First, get the number of size of the derived basis functions</span>
<a name="l00113"></a>00113     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> derived_bf_size;
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file_name;
<a name="l00116"></a>00116       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/derived_bf_size.dat&quot;</span>;
<a name="l00117"></a>00117       std::ifstream derived_bf_size_in(file_name.str().c_str());
<a name="l00118"></a>00118 
<a name="l00119"></a>00119       <span class="keywordflow">if</span> ( !derived_bf_size_in.good() )
<a name="l00120"></a>00120       {
<a name="l00121"></a>00121         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error opening derived_bf_size.dat&quot;</span> &lt;&lt; std::endl;
<a name="l00122"></a>00122         libmesh_error();
<a name="l00123"></a>00123       }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125       derived_bf_size_in &gt;&gt; derived_bf_size;
<a name="l00126"></a>00126       derived_bf_size_in.close();
<a name="l00127"></a>00127     }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129     std::ostringstream file_name;
<a name="l00130"></a>00130     <span class="keyword">struct </span>stat stat_info;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;derived_basis_functions.size(); i++)
<a name="l00133"></a>00133     {
<a name="l00134"></a>00134       file_name.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset the string</span>
<a name="l00135"></a>00135       file_name &lt;&lt; directory_name &lt;&lt; <span class="stringliteral">&quot;/derived_bf&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;.dat&quot;</span>;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137       <span class="comment">// On processor zero check to be sure the file exists</span>
<a name="l00138"></a>00138       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00139"></a>00139         {
<a name="l00140"></a>00140           <span class="keywordtype">int</span> stat_result = stat(file_name.str().c_str(), &amp;stat_info);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142           <span class="keywordflow">if</span> (stat_result != 0)
<a name="l00143"></a>00143             {
<a name="l00144"></a>00144               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;File does not exist: &quot;</span> &lt;&lt; file_name.str() &lt;&lt; std::endl;
<a name="l00145"></a>00145               libmesh_error();
<a name="l00146"></a>00146             }
<a name="l00147"></a>00147         }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149       derived_basis_functions[i].resize(derived_bf_size);
<a name="l00150"></a>00150 
<a name="l00151"></a>00151       std::ifstream derived_bf_size_in(file_name.str().c_str());
<a name="l00152"></a>00152       
<a name="l00153"></a>00153       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;derived_bf_size; j++)
<a name="l00154"></a>00154       {
<a name="l00155"></a>00155         <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>  value;
<a name="l00156"></a>00156         derived_bf_size_in &gt;&gt; value;
<a name="l00157"></a>00157         derived_basis_functions[i](j) = value;
<a name="l00158"></a>00158       }
<a name="l00159"></a>00159       derived_bf_size_in.close();
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     }
<a name="l00162"></a>00162   }
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php">DerivedRBEvaluation&lt;RBEvaluation&gt;</a>;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
