<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">derived_rb_evaluation.h</div>  </div>
</div>
<div class="contents">
<a href="derived__rb__evaluation_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __derived_rb_evaluation_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __derived_rb_evaluation_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="rb__evaluation_8h.php">rb_evaluation.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">class </span>RBSystem;
<a name="l00030"></a>00030 <span class="keyword">class </span>string;
<a name="l00031"></a>00031 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// DerivedRBEvaluation class definition</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Base&gt;
<a name="l00045"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php">00045</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php">DerivedRBEvaluation</a> : <span class="keyword">public</span> Base
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a19d5d161344a52783dc0109b8ed381be">DerivedRBEvaluation</a> (<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; rb_sys_in);
<a name="l00053"></a>00053   
<a name="l00057"></a>00057   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a5ed0a30b4b1fe9831a1a93226138e16f">clear</a>();
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#ab6772de297cf395c1bf8e363608f472b">get_n_basis_functions</a>() <span class="keyword">const</span>;
<a name="l00063"></a>00063 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#ad53bbec41b0e078256cbab8dcfb588ad">set_n_basis_functions</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_bfs);
<a name="l00069"></a>00069 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a00155c803729d8b092bca89ef874c9fc">write_out_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name,
<a name="l00075"></a>00075                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> precision_level);
<a name="l00076"></a>00076   
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a4b90c2cd0aa5d523b427f0b9e6e973ad">read_in_basis_functions</a>(<span class="keyword">const</span> std::string&amp; directory_name);
<a name="l00081"></a>00081   
<a name="l00082"></a>00082   <span class="comment">//----------- PUBLIC DATA MEMBERS -----------//</span>
<a name="l00083"></a>00083 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a242e118501d73327f2e4d7a168c8a433">00088</a>    std::vector&lt; DenseVector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a242e118501d73327f2e4d7a168c8a433">derived_basis_functions</a>;
<a name="l00089"></a>00089 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a526e661929fb20230c2881c2495d309ba5d2a574c311c6b89162f5719f6107310">00094</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a526e661929fb20230c2881c2495d309b">DERIVED_RESIDUAL_TYPE</a> { <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a526e661929fb20230c2881c2495d309ba5d2a574c311c6b89162f5719f6107310">RESIDUAL_WRT_UBER</a>, <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a526e661929fb20230c2881c2495d309ba7bd6639a42bf27390e95d60951e0d7eb">RESIDUAL_WRT_TRUTH</a> };
<a name="l00095"></a>00095 
<a name="l00102"></a><a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a067c4443b5b856dc0069c3729911929f">00102</a>   <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a526e661929fb20230c2881c2495d309b">DERIVED_RESIDUAL_TYPE</a> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php#a067c4443b5b856dc0069c3729911929f">residual_type_flag</a>;
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 };
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="comment">// And introduce convenient typedefs</span>
<a name="l00107"></a><a class="code" href="namespacelibMesh.php#a995410b97cd841a5aebad69092f07942">00107</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DerivedRBEvaluation.php">DerivedRBEvaluation&lt;RBEvaluation&gt;</a> <a class="code" href="namespacelibMesh.php#a995410b97cd841a5aebad69092f07942">SteadyDerivedRBEvaluation</a>;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
