<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">derived_rb_system.C</div>  </div>
</div>
<div class="contents">
<a href="derived__rb__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// rbOOmit: An implementation of the Certified Reduced Basis method.</span>
<a name="l00002"></a>00002 <span class="comment">// Copyright (C) 2009, 2010 David J. Knezevic</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// This file is part of rbOOmit.</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// rbOOmit is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// rbOOmit is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="derived__rb__system_8h.php">derived_rb_system.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="derived__rb__evaluation_8h.php">derived_rb_evaluation.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00029"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#afb18eceb7e74123ba16fb3834a8fd989">00029</a> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#afb18eceb7e74123ba16fb3834a8fd989">DerivedRBSystem&lt;Base&gt;::DerivedRBSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00030"></a>00030                     <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00031"></a>00031                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00032"></a>00032   : Base(es, name, number)
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034   <span class="comment">// We do not want to compute the output dual norms in</span>
<a name="l00035"></a>00035   <span class="comment">// a derived system, we just copy them over from the</span>
<a name="l00036"></a>00036   <span class="comment">// primary system</span>
<a name="l00037"></a>00037   Base::output_dual_norms_computed = <span class="keyword">true</span>;
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00041"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a144c151da98bb7ff1577ad67add81cbf">00041</a> std::string <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a144c151da98bb7ff1577ad67add81cbf">DerivedRBSystem&lt;Base&gt;::system_type</a> ()<span class="keyword"> const</span>
<a name="l00042"></a>00042 <span class="keyword"></span>{
<a name="l00043"></a>00043   <span class="keywordflow">return</span> <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>;
<a name="l00044"></a>00044 }
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="keyword">template</span>&lt;<span class="keyword">class</span> Base&gt;
<a name="l00048"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#afbb5eb10ed674dfef24626f4abb7b882">00048</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#afbb5eb10ed674dfef24626f4abb7b882">DerivedRBSystem&lt;Base&gt;::set_uber_current_parameters</a>()
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;get_equation_systems();
<a name="l00051"></a>00051   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; uber_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&gt;(uber_system_name);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   uber_system.<a class="code" href="classlibMesh_1_1RBBase.php#a04037fe5c23e9d9e5652936888cb8f0f">set_current_parameters</a>( Base::get_current_parameters() );
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a88bddab0eb5fdbd49779babb6e33d377">00057</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a88bddab0eb5fdbd49779babb6e33d377">DerivedRBSystem&lt;Base&gt;::load_basis_function</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   START_LOG(<span class="stringliteral">&quot;load_basis_function()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="keywordflow">if</span>(!Base::initialize_mesh_dependent_data)
<a name="l00062"></a>00062   {
<a name="l00063"></a>00063     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: We must initialize the mesh dependent &quot;</span>
<a name="l00064"></a>00064                  &lt;&lt; <span class="stringliteral">&quot;data structures in order to load basis function.&quot;</span>
<a name="l00065"></a>00065                  &lt;&lt; std::endl;
<a name="l00066"></a>00066     libmesh_error();
<a name="l00067"></a>00067   }
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   libmesh_assert(i &lt; Base::get_n_basis_functions());
<a name="l00070"></a>00070   
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = Base::get_equation_systems();
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&amp; uber_system = es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>&lt;<a class="code" href="classlibMesh_1_1RBSystem.php">RBSystem</a>&gt;(uber_system_name);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> bf = get_derived_basis_function(i);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#a74c2f35cb7ee77e6f9ebb3b4d5222bab">get_n_basis_functions</a>(); j++)
<a name="l00077"></a>00077   {
<a name="l00078"></a>00078     Base::solution-&gt;add(bf(j), uber_system.<a class="code" href="classlibMesh_1_1RBSystem.php#af1991710315abf6a971f6020e051b46c">get_basis_function</a>(j));
<a name="l00079"></a>00079   }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   STOP_LOG(<span class="stringliteral">&quot;load_basis_function()&quot;</span>, <span class="stringliteral">&quot;DerivedRBSystem&quot;</span>);
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00085"></a><a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a768c7a0125c6334198ff5d89ea6cf404">00085</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DerivedRBSystem.php#a768c7a0125c6334198ff5d89ea6cf404">DerivedRBSystem&lt;Base&gt;::write_offline_data_to_files</a>(<span class="keyword">const</span> std::string&amp; directory_name,
<a name="l00086"></a>00086                                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1RBSystem.php#afb4483edcd1830982b5a07083918ef83">RBSystem::RBDataIO</a> io_flag)
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   generate_residual_terms_wrt_truth();
<a name="l00089"></a>00089   
<a name="l00090"></a>00090   Base::write_offline_data_to_files(directory_name, io_flag);
<a name="l00091"></a>00091 }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="comment">// explicit instantiations</span>
<a name="l00094"></a>00094 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DerivedRBSystem.php">DerivedRBSystem&lt;RBSystem&gt;</a>;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 }
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
