<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">diff_context.C</div>  </div>
</div>
<div class="contents">
<a href="diff__context_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diff_context.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__context_8h.php">diff_context.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">namespace </span>libMesh
<a name="l00025"></a>00025 {
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a1f4725e99eac36666e8189b4db9f44ba">00029</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a1f4725e99eac36666e8189b4db9f44ba">DiffContext::DiffContext</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys) :
<a name="l00030"></a>00030   time(sys.time),
<a name="l00031"></a>00031   system_time(sys.time),
<a name="l00032"></a>00032   elem_solution_derivative(1.),
<a name="l00033"></a>00033   fixed_solution_derivative(0.),
<a name="l00034"></a>00034   dof_indices_var(sys.<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>()),
<a name="l00035"></a>00035   _deltat(NULL)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   <span class="comment">// Finally initialize solution/residual/jacobian data structures</span>
<a name="l00038"></a>00038   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = sys.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   <a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.reserve(n_vars);
<a name="l00041"></a>00041   <a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>.reserve(n_vars);
<a name="l00042"></a>00042   <a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>.resize(n_vars);
<a name="l00043"></a>00043   <span class="keywordflow">if</span> (sys.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00044"></a>00044     <a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.reserve(n_vars);
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="comment">// If the user resizes sys.qoi, it will invalidate us</span>
<a name="l00047"></a>00047   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qoi = sys.<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size();
<a name="l00048"></a>00048   <a class="code" href="classlibMesh_1_1DiffContext.php#ad01aaa7bb57398e3b583ce483dac141f">elem_qoi</a>.resize(n_qoi);
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1DiffContext.php#a5fad6a1ca3ce18dd2f11c22b2ad5923a">elem_qoi_derivative</a>.resize(n_qoi);
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1DiffContext.php#a45d1d8941d44174dcb83ba881519d922">elem_qoi_subderivatives</a>.resize(n_qoi);
<a name="l00051"></a>00051   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q != n_qoi; ++q)
<a name="l00052"></a>00052     <a class="code" href="classlibMesh_1_1DiffContext.php#a45d1d8941d44174dcb83ba881519d922">elem_qoi_subderivatives</a>[q].reserve(n_vars);
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; ++i)
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056       <a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.push_back(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a>(<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>));
<a name="l00057"></a>00057       <a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>.push_back(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a>(<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>));
<a name="l00058"></a>00058       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q != n_qoi; ++q)
<a name="l00059"></a>00059         <a class="code" href="classlibMesh_1_1DiffContext.php#a45d1d8941d44174dcb83ba881519d922">elem_qoi_subderivatives</a>[q].push_back(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a>(<a class="code" href="classlibMesh_1_1DiffContext.php#a5fad6a1ca3ce18dd2f11c22b2ad5923a">elem_qoi_derivative</a>[q]));
<a name="l00060"></a>00060       <a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[i].reserve(n_vars);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062       <span class="keywordflow">if</span> (sys.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00063"></a>00063         <a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.push_back
<a name="l00064"></a>00064           (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a>(<a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">elem_fixed_solution</a>));
<a name="l00065"></a>00065 
<a name="l00066"></a>00066       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; ++j)
<a name="l00067"></a>00067         <a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[i].push_back
<a name="l00068"></a>00068           (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a>(<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>));
<a name="l00069"></a>00069     }
<a name="l00070"></a>00070 }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a9d2011bca13091ab7d9d9dc14388665d">00074</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a9d2011bca13091ab7d9d9dc14388665d">DiffContext::~DiffContext</a> ()
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.size(); ++i)
<a name="l00077"></a>00077     {
<a name="l00078"></a>00078       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[i];
<a name="l00079"></a>00079       <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>[i];
<a name="l00080"></a>00080       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q != <a class="code" href="classlibMesh_1_1DiffContext.php#a45d1d8941d44174dcb83ba881519d922">elem_qoi_subderivatives</a>.size(); ++q)
<a name="l00081"></a>00081         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1DiffContext.php#a45d1d8941d44174dcb83ba881519d922">elem_qoi_subderivatives</a>[q][i];
<a name="l00082"></a>00082       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.empty())
<a name="l00083"></a>00083         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[i];
<a name="l00084"></a>00084 
<a name="l00085"></a>00085       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != <a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[i].size(); ++j)
<a name="l00086"></a>00086         <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[i][j];
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classlibMesh_1_1DiffContext.php#aa4ede669bc502925b1022a6d8a106cdc">00091</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiffContext.php#aa4ede669bc502925b1022a6d8a106cdc">DiffContext::set_deltat_pointer</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>* dt)
<a name="l00092"></a>00092   {
<a name="l00093"></a>00093     <span class="comment">// We may actually want to be able to set this pointer to NULL, so</span>
<a name="l00094"></a>00094     <span class="comment">// don&#39;t report an error for that.</span>
<a name="l00095"></a>00095     <a class="code" href="classlibMesh_1_1DiffContext.php#a4aa3e29907b246aa0659161320a6ff71">_deltat</a> = dt;
<a name="l00096"></a>00096   }
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a79812d270f452cf404caa7285025aac4">00098</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a79812d270f452cf404caa7285025aac4">DiffContext::get_deltat_value</a>()
<a name="l00099"></a>00099   {
<a name="l00100"></a>00100     libmesh_assert(<a class="code" href="classlibMesh_1_1DiffContext.php#a4aa3e29907b246aa0659161320a6ff71">_deltat</a> != NULL);
<a name="l00101"></a>00101     
<a name="l00102"></a>00102     <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1DiffContext.php#a4aa3e29907b246aa0659161320a6ff71">_deltat</a>;
<a name="l00103"></a>00103   }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 } <span class="comment">// namespace libMesh</span>
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
