<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">diff_context.h</div>  </div>
</div>
<div class="contents">
<a href="diff__context_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: diff_context.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __diff_context_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __diff_context_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__submatrix_8h.php">dense_submatrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__subvector_8h.php">dense_subvector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>System;
<a name="l00039"></a>00039 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// DifferentiableSystem class definition</span>
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1DiffContext.php">00055</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1DiffContext.php#a1f4725e99eac36666e8189b4db9f44ba">DiffContext</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;);
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1DiffContext.php#a9d2011bca13091ab7d9d9dc14388665d">~DiffContext</a> ();
<a name="l00069"></a>00069 
<a name="l00074"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a1c5a183a0f3e282437a429b1a4878fa7">00074</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DiffContext.php#a1c5a183a0f3e282437a429b1a4878fa7">postprocess_sides</a>;
<a name="l00075"></a>00075 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a45af196d72b6798323b0af96ca68cb2b">00081</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiffContext.php#a45af196d72b6798323b0af96ca68cb2b">elem_reinit</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>) {}
<a name="l00082"></a>00082 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a4a9862bec36617be5fd2f6c0290d0c52">00087</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiffContext.php#a4a9862bec36617be5fd2f6c0290d0c52">elem_side_reinit</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>) {}
<a name="l00088"></a>00088 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a0fc3fa18d4c4c3ffdda4cc77402a2c75">00094</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a0fc3fa18d4c4c3ffdda4cc77402a2c75">time</a>;
<a name="l00095"></a>00095 
<a name="l00103"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a2ca16f4474c6c1ff8bd2abe4c170ebfe">00103</a>   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a2ca16f4474c6c1ff8bd2abe4c170ebfe">system_time</a>;
<a name="l00104"></a>00104 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">00109</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>;
<a name="l00110"></a><a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">00110</a>   std::vector&lt;DenseSubVector&lt;Number&gt; *&gt; <a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>;
<a name="l00111"></a>00111 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">00117</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">elem_fixed_solution</a>;
<a name="l00118"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">00118</a>   std::vector&lt;DenseSubVector&lt;Number&gt; *&gt; <a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>;
<a name="l00119"></a>00119 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">00125</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a>;
<a name="l00126"></a>00126 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">00132</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">fixed_solution_derivative</a>;
<a name="l00133"></a>00133 
<a name="l00137"></a><a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">00137</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00138"></a>00138 
<a name="l00143"></a><a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">00143</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1DiffContext.php#ad01aaa7bb57398e3b583ce483dac141f">00148</a>   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1DiffContext.php#ad01aaa7bb57398e3b583ce483dac141f">elem_qoi</a>;
<a name="l00149"></a>00149 
<a name="l00153"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a5fad6a1ca3ce18dd2f11c22b2ad5923a">00153</a>   std::vector&lt;DenseVector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1DiffContext.php#a5fad6a1ca3ce18dd2f11c22b2ad5923a">elem_qoi_derivative</a>;
<a name="l00154"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a45d1d8941d44174dcb83ba881519d922">00154</a>   std::vector&lt;std::vector&lt;DenseSubVector&lt;Number&gt; *&gt; &gt; <a class="code" href="classlibMesh_1_1DiffContext.php#a45d1d8941d44174dcb83ba881519d922">elem_qoi_subderivatives</a>;
<a name="l00155"></a>00155 
<a name="l00159"></a><a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">00159</a>   std::vector&lt;DenseSubVector&lt;Number&gt; *&gt; <a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>;
<a name="l00160"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">00160</a>   std::vector&lt;std::vector&lt;DenseSubMatrix&lt;Number&gt; *&gt; &gt; <a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>;
<a name="l00161"></a>00161 
<a name="l00165"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">00165</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>;
<a name="l00166"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">00166</a>   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>;
<a name="l00167"></a>00167 
<a name="l00172"></a>00172   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiffContext.php#aa4ede669bc502925b1022a6d8a106cdc">set_deltat_pointer</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>* dt);
<a name="l00173"></a>00173 
<a name="l00178"></a>00178   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffContext.php#a79812d270f452cf404caa7285025aac4">get_deltat_value</a>();
<a name="l00179"></a>00179   
<a name="l00180"></a>00180 <span class="keyword">private</span>:
<a name="l00192"></a><a class="code" href="classlibMesh_1_1DiffContext.php#a4aa3e29907b246aa0659161320a6ff71">00192</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>* <a class="code" href="classlibMesh_1_1DiffContext.php#a4aa3e29907b246aa0659161320a6ff71">_deltat</a>;
<a name="l00193"></a>00193 };
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 } <span class="comment">// namespace libMesh</span>
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
