<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">diff_solver.C</div>  </div>
</div>
<div class="contents">
<a href="diff__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diff_solver.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__solver_8h.php">diff_solver.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="newton__solver_8h.php">newton_solver.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">namespace </span>libMesh
<a name="l00025"></a>00025 {
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ad7b57492a02c50ba1e7263bb8ca31af6">00029</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#ad7b57492a02c50ba1e7263bb8ca31af6">DiffSolver::DiffSolver</a> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a>&amp; s)
<a name="l00030"></a>00030     : max_linear_iterations(1000),
<a name="l00031"></a>00031       max_nonlinear_iterations(100),
<a name="l00032"></a>00032       quiet(true),
<a name="l00033"></a>00033       continue_after_max_iterations(true),
<a name="l00034"></a>00034       continue_after_backtrack_failure(false),
<a name="l00035"></a>00035       absolute_residual_tolerance(0.),
<a name="l00036"></a>00036       relative_residual_tolerance(0.),
<a name="l00037"></a>00037       absolute_step_tolerance(0.),
<a name="l00038"></a>00038       relative_step_tolerance(0.),
<a name="l00039"></a>00039       initial_linear_tolerance(1e-12),
<a name="l00040"></a>00040       minimum_linear_tolerance(TOLERANCE*TOLERANCE),
<a name="l00041"></a>00041       max_solution_norm(0.),
<a name="l00042"></a>00042       max_residual_norm(0.),
<a name="l00043"></a>00043       _system (s),
<a name="l00044"></a>00044       _solve_result(INVALID_SOLVE_RESULT)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046 }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a0577e99d7a903ad3d732489cf9dbbd95">00050</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#a0577e99d7a903ad3d732489cf9dbbd95">DiffSolver::build</a> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a>&amp; s)
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php">NewtonSolver</a>(s));
<a name="l00053"></a>00053 }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ac7f6532da1a45d35dee39e82ae383d17">00057</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#ac7f6532da1a45d35dee39e82ae383d17">DiffSolver::reinit</a> ()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <span class="comment">// Reset the max_step_size and max_residual_norm for a new mesh</span>
<a name="l00060"></a>00060   <a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a> = 0.;
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">max_residual_norm</a> = 0.;
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a7bd8581a3550252487bc90a76733747c">00066</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a7bd8581a3550252487bc90a76733747c">DiffSolver::init</a> ()
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068   <span class="comment">// Reset the max_step_size and max_residual_norm for a new problem</span>
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a> = 0.;
<a name="l00070"></a>00070   <a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">max_residual_norm</a> = 0.;
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
