<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">diff_solver.h</div>  </div>
</div>
<div class="contents">
<a href="diff__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diff_solver.h 4369 2011-04-19 22:30:47Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __diff_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __diff_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span>DiffSolver;
<a name="l00038"></a>00038 <span class="keyword">class </span>ImplicitSystem;
<a name="l00039"></a>00039 <span class="keyword">class </span>ParameterVector;
<a name="l00040"></a>00040 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// Solver class definition</span>
<a name="l00056"></a><a class="code" href="classlibMesh_1_1DiffSolver.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DiffSolver.php">DiffSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;DiffSolver&gt;
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00062"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ae2321337e832473964b21dc019a62354">00062</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#ae2321337e832473964b21dc019a62354">sys_type</a>;
<a name="l00063"></a>00063   
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1DiffSolver.php#ad7b57492a02c50ba1e7263bb8ca31af6">DiffSolver</a> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a>&amp; s);
<a name="l00069"></a>00069 
<a name="l00074"></a>00074   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#a0577e99d7a903ad3d732489cf9dbbd95">build</a>(<a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a>&amp; s);
<a name="l00075"></a>00075   
<a name="l00079"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#afc7c54bfd9827bc0534535783d065e5a">00079</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#afc7c54bfd9827bc0534535783d065e5a">~DiffSolver</a> () {}
<a name="l00080"></a>00080 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a7bd8581a3550252487bc90a76733747c">init</a> ();
<a name="l00086"></a>00086 
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#ac7f6532da1a45d35dee39e82ae383d17">reinit</a> ();
<a name="l00092"></a>00092 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a780db1db2c12dd55fb86c7e72bb7d644">solve</a> () = 0;
<a name="l00099"></a>00099 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ae11c932161bb6e9bf8c786c380df4511">00104</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#ae11c932161bb6e9bf8c786c380df4511">total_outer_iterations</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>; }
<a name="l00105"></a>00105 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a45b6ff1a482e0a893297f837024c678c">00110</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a45b6ff1a482e0a893297f837024c678c">total_inner_iterations</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a1427e8cbf65b72d18ba567c8cd35d3c0">_inner_iterations</a>; }
<a name="l00111"></a>00111 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a896dcdb0abf4bb32cbbc6e0078248b69">00115</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a896dcdb0abf4bb32cbbc6e0078248b69">solve_result</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a>; }
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a5409063e9676de368c09c023df7a92f8">00120</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1DiffSolver.php#a5409063e9676de368c09c023df7a92f8">system</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>; }
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ae9852528fe99a3153f7bc6360624f03e">00125</a>   <a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1DiffSolver.php#ae9852528fe99a3153f7bc6360624f03e">system</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>; }
<a name="l00126"></a>00126   
<a name="l00131"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a2e1f21d4bbb429bbc643930238166327">00131</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a2e1f21d4bbb429bbc643930238166327">max_linear_iterations</a>;
<a name="l00132"></a>00132 
<a name="l00139"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ae2d85fde243f9037ca23cc5f58483d21">00139</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#ae2d85fde243f9037ca23cc5f58483d21">max_nonlinear_iterations</a>;
<a name="l00140"></a>00140 
<a name="l00145"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ae8809909d1442365d6f7385b28625793">00145</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#ae8809909d1442365d6f7385b28625793">quiet</a>;
<a name="l00146"></a>00146 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">00151</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>;
<a name="l00152"></a>00152 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a9b10e04643a5998e6bca41e54d53c0ce">00157</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a9b10e04643a5998e6bca41e54d53c0ce">continue_after_max_iterations</a>;
<a name="l00158"></a>00158 
<a name="l00163"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a438b337eddd22eb22750d047cbb09db5">00163</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a438b337eddd22eb22750d047cbb09db5">continue_after_backtrack_failure</a>;
<a name="l00164"></a>00164 
<a name="l00174"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a1926cd67dedca636fc38ab09075b0c49">00174</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#a1926cd67dedca636fc38ab09075b0c49">absolute_residual_tolerance</a>;
<a name="l00175"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ac277e840781dace340939660d459f266">00175</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#ac277e840781dace340939660d459f266">relative_residual_tolerance</a>;
<a name="l00176"></a>00176 
<a name="l00186"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a197637747531db57ef98538814252999">00186</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#a197637747531db57ef98538814252999">absolute_step_tolerance</a>;
<a name="l00187"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ac546f5e08f900ca8d1e90bd460da5b4f">00187</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#ac546f5e08f900ca8d1e90bd460da5b4f">relative_step_tolerance</a>;
<a name="l00188"></a>00188 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#afed86ff95698a52eecb3824ab5b6028d">00193</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#afed86ff95698a52eecb3824ab5b6028d">initial_linear_tolerance</a>;
<a name="l00194"></a>00194 
<a name="l00198"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a3456056572858cb5a215d45db1514c38">00198</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#a3456056572858cb5a215d45db1514c38">minimum_linear_tolerance</a>;
<a name="l00199"></a>00199   
<a name="l00205"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450">00205</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450">SolveResult</a> {
<a name="l00210"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450ae632866d841ee9a65aa1c9225aeb909c">00210</a>     <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450ae632866d841ee9a65aa1c9225aeb909c">INVALID_SOLVE_RESULT</a> = 0,
<a name="l00211"></a>00211     
<a name="l00216"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450ae3f189af1cb3df09215f3f615072393c">00216</a>     <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450ae3f189af1cb3df09215f3f615072393c">CONVERGED_NO_REASON</a> = 1,
<a name="l00217"></a>00217 
<a name="l00222"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450aada72a67598570cfbe5bc23381893a0e">00222</a>     <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450aada72a67598570cfbe5bc23381893a0e">CONVERGED_ABSOLUTE_RESIDUAL</a> = 2,
<a name="l00223"></a>00223 
<a name="l00228"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450af59076b835010125f7a7aba2501f38f7">00228</a>     <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450af59076b835010125f7a7aba2501f38f7">CONVERGED_RELATIVE_RESIDUAL</a> = 4,
<a name="l00229"></a>00229 
<a name="l00234"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450af6c19e0bb6182623a463bb7d0f24927d">00234</a>     <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450af6c19e0bb6182623a463bb7d0f24927d">CONVERGED_ABSOLUTE_STEP</a> = 8,
<a name="l00235"></a>00235 
<a name="l00240"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a95ac9d89a4ed442ba9a643ba6c181afa">00240</a>     <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a95ac9d89a4ed442ba9a643ba6c181afa">CONVERGED_RELATIVE_STEP</a> = 16,
<a name="l00241"></a>00241 
<a name="l00246"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450ad30a1feeb5ca1d799e4b292d466ef3af">00246</a>     <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450ad30a1feeb5ca1d799e4b292d466ef3af">DIVERGED_NO_REASON</a> = 32,
<a name="l00247"></a>00247 
<a name="l00253"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a7161b703163120b21894f1dec0ab6799">00253</a>     <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a7161b703163120b21894f1dec0ab6799">DIVERGED_MAX_NONLINEAR_ITERATIONS</a> = 64,
<a name="l00254"></a>00254 
<a name="l00259"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a5a9f6f2aa16e982c8ab85b4394140755">00259</a>     <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a5a9f6f2aa16e982c8ab85b4394140755">DIVERGED_BACKTRACKING_FAILURE</a> = 128
<a name="l00260"></a>00260   };
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 <span class="keyword">protected</span>:
<a name="l00263"></a>00263 
<a name="l00268"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">00268</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a>;
<a name="l00269"></a>00269 
<a name="l00275"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">00275</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">max_residual_norm</a>;
<a name="l00276"></a>00276 
<a name="l00280"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">00280</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>;
<a name="l00281"></a>00281 
<a name="l00285"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a1427e8cbf65b72d18ba567c8cd35d3c0">00285</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#a1427e8cbf65b72d18ba567c8cd35d3c0">_inner_iterations</a>;
<a name="l00286"></a>00286 
<a name="l00290"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">00290</a>   <a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a>&amp; <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>;
<a name="l00291"></a>00291 
<a name="l00298"></a><a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">00298</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a>;
<a name="l00299"></a>00299 };
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 } <span class="comment">// namespace libMesh</span>
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 <span class="preprocessor">#endif // #define __diff_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
