<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">diff_system.C</div>  </div>
</div>
<div class="contents">
<a href="diff__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diff_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__solver_8h.php">diff_solver.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a3b603ce263db67c50b46b5ee23741a37">DifferentiableSystem::DifferentiableSystem</a>
<a name="l00031"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a3b603ce263db67c50b46b5ee23741a37">00031</a>                       (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00032"></a>00032                        <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00033"></a>00033                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00034"></a>00034   <a class="code" href="classlibMesh_1_1ImplicitSystem.php">Parent</a>      (es, name, number),
<a name="l00035"></a>00035   compute_internal_sides(<span class="keyword">false</span>),
<a name="l00036"></a>00036   postprocess_sides(<span class="keyword">false</span>),
<a name="l00037"></a>00037   assemble_qoi_sides(<span class="keyword">false</span>),
<a name="l00038"></a>00038   time_solver (NULL),
<a name="l00039"></a>00039   deltat(1.),
<a name="l00040"></a>00040   print_solution_norms(<span class="keyword">false</span>),
<a name="l00041"></a>00041   print_solutions(<span class="keyword">false</span>),
<a name="l00042"></a>00042   print_residual_norms(<span class="keyword">false</span>),
<a name="l00043"></a>00043   print_residuals(<span class="keyword">false</span>),
<a name="l00044"></a>00044   print_jacobian_norms(<span class="keyword">false</span>),
<a name="l00045"></a>00045   print_jacobians(<span class="keyword">false</span>),
<a name="l00046"></a>00046   print_element_jacobians(<span class="keyword">false</span>)
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 }
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a5020219bdd6b2e5a444bebe81499a3ee">00052</a> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a5020219bdd6b2e5a444bebe81499a3ee">DifferentiableSystem::~DifferentiableSystem</a> ()
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab4ab534276ae950c906b238e38c7b3d9">clear</a>();
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab4ab534276ae950c906b238e38c7b3d9">00059</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab4ab534276ae950c906b238e38c7b3d9">DifferentiableSystem::clear</a> ()
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a50a4fef55dc7025624a81fcbb8db3fca">_time_evolving</a>.resize(0);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a> = <span class="keyword">false</span>;
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ad1fe416c0c60cec691ce13d61d59af04">00068</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ad1fe416c0c60cec691ce13d61d59af04">DifferentiableSystem::reinit</a> ()
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a766e6bac5c51ef16b7ddc4f62933b309">Parent::reinit</a>();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;reinit();
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab95f6ccd3684f3ad3423ae466bf4e8cd">00077</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab95f6ccd3684f3ad3423ae466bf4e8cd">DifferentiableSystem::init_data</a> ()
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   <span class="comment">// give us flags for every variable that might be time evolving</span>
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a50a4fef55dc7025624a81fcbb8db3fca">_time_evolving</a>.resize(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(), <span class="keyword">false</span>);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// Do any initialization our solvers need</span>
<a name="l00083"></a>00083   libmesh_assert (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL);
<a name="l00084"></a>00084   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;init();
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">// Next initialize ImplicitSystem data</span>
<a name="l00087"></a>00087   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ada6846f6432bb259d4cd0a83abdc567a">Parent::init_data</a>();
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a4a54fe7fd1361b929023c4728ec5ac07">00092</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a4a54fe7fd1361b929023c4728ec5ac07">DifferentiableSystem::build_context</a> ()
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>(*<span class="keyword">this</span>));
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   ap-&gt;set_deltat_pointer( &amp;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> );
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="keywordflow">return</span> ap;
<a name="l00099"></a>00099 }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a99518b55ed2edbcc6fec6191e1c370be">00103</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a99518b55ed2edbcc6fec6191e1c370be">DifferentiableSystem::assemble</a> ()
<a name="l00104"></a>00104 {
<a name="l00105"></a>00105   this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#af715c0eb1cf04586a6db5e4eb85daf39">assembly</a>(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00106"></a>00106 }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#acd2e68265ffb835434e783190c452b42">00110</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#acd2e68265ffb835434e783190c452b42">DifferentiableSystem::solve</a> ()
<a name="l00111"></a>00111 {
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;solve();
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a13198b1d24756e22e458b253c46d61ba">00117</a> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a13198b1d24756e22e458b253c46d61ba">DifferentiableSystem::get_linear_solver</a>()<span class="keyword"> const</span>
<a name="l00118"></a>00118 <span class="keyword"></span>{
<a name="l00119"></a>00119   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;linear_solver().<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ac600b1e68eab7fa10df86168daeaa579">00124</a> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ac600b1e68eab7fa10df86168daeaa579">DifferentiableSystem::get_linear_solve_parameters</a>()<span class="keyword"> const</span>
<a name="l00125"></a>00125 <span class="keyword"></span>{
<a name="l00126"></a>00126   <span class="keywordflow">return</span> std::make_pair(this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;diff_solver()-&gt;max_linear_iterations,
<a name="l00127"></a>00127                         this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;diff_solver()-&gt;relative_residual_tolerance);
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a25da0ee4fc2d4c938cba347029e2621a">00132</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a25da0ee4fc2d4c938cba347029e2621a">DifferentiableSystem::release_linear_solver</a>(<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a>*)<span class="keyword"> const</span>
<a name="l00133"></a>00133 <span class="keyword"></span>{
<a name="l00134"></a>00134 }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
