<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">diff_system.h</div>  </div>
</div>
<div class="contents">
<a href="diff__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: diff_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __diff_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __diff_system_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="diff__context_8h.php">diff_context.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="implicit__system_8h.php">implicit_system.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span>TimeSolver;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00039"></a>00039 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// DifferentiableSystem class definition</span>
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php">00055</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DifferentiableSystem.php">DifferentiableSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a3b603ce263db67c50b46b5ee23741a37">DifferentiableSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00064"></a>00064                  <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00065"></a>00065                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a5020219bdd6b2e5a444bebe81499a3ee">~DifferentiableSystem</a> ();
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aadee51558ad3de169ec114ad310fc919">00075</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aadee51558ad3de169ec114ad310fc919">sys_type</a>;
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a20cb6b0e480799b86a2000e0033299f9">00080</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a20cb6b0e480799b86a2000e0033299f9">Parent</a>;
<a name="l00081"></a>00081   
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab4ab534276ae950c906b238e38c7b3d9">clear</a> ();
<a name="l00087"></a>00087 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ad1fe416c0c60cec691ce13d61d59af04">reinit</a> ();
<a name="l00093"></a>00093    
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a99518b55ed2edbcc6fec6191e1c370be">assemble</a> ();
<a name="l00099"></a>00099 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a13198b1d24756e22e458b253c46d61ba">get_linear_solver</a>() <span class="keyword">const</span>;
<a name="l00105"></a>00105 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00112"></a>00112     <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ac600b1e68eab7fa10df86168daeaa579">get_linear_solve_parameters</a>() <span class="keyword">const</span>;
<a name="l00113"></a>00113 
<a name="l00118"></a>00118   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a25da0ee4fc2d4c938cba347029e2621a">release_linear_solver</a>(<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *) <span class="keyword">const</span>;
<a name="l00119"></a>00119 
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#af715c0eb1cf04586a6db5e4eb85daf39">assembly</a> (<span class="keywordtype">bool</span> get_residual, <span class="keywordtype">bool</span> get_jacobian) = 0;
<a name="l00125"></a>00125 
<a name="l00138"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0e74f65c812202ed8109767105c7321b">00138</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0e74f65c812202ed8109767105c7321b">element_time_derivative</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00139"></a>00139                                         <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {
<a name="l00140"></a>00140     <span class="keywordflow">return</span> request_jacobian;
<a name="l00141"></a>00141   }
<a name="l00142"></a>00142 
<a name="l00155"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#acf8f44832ec07639d55b1688787c80d0">00155</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#acf8f44832ec07639d55b1688787c80d0">element_constraint</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00156"></a>00156                                    <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {
<a name="l00157"></a>00157     <span class="keywordflow">return</span> request_jacobian;
<a name="l00158"></a>00158   }
<a name="l00159"></a>00159 
<a name="l00166"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a979327b7dd46ad979e6145076fd8e176">00166</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a979327b7dd46ad979e6145076fd8e176">compute_internal_sides</a>;
<a name="l00167"></a>00167 
<a name="l00179"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a47fff9592eebfc5014c9d83405dc42a6">00179</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a47fff9592eebfc5014c9d83405dc42a6">side_time_derivative</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00180"></a>00180                                      <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {
<a name="l00181"></a>00181     <span class="keywordflow">return</span> request_jacobian;
<a name="l00182"></a>00182   }
<a name="l00183"></a>00183 
<a name="l00195"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aa70056a38d864596769ef8382ba1e9d8">00195</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aa70056a38d864596769ef8382ba1e9d8">side_constraint</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00196"></a>00196                                 <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {
<a name="l00197"></a>00197     <span class="keywordflow">return</span> request_jacobian;
<a name="l00198"></a>00198   }
<a name="l00199"></a>00199 
<a name="l00204"></a>00204   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a91b4997da9271393df5b21ad1b49feef">postprocess</a> () = 0;
<a name="l00205"></a>00205 
<a name="l00211"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a191ca6371747268974a5f108e7576873">00211</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a191ca6371747268974a5f108e7576873">postprocess_sides</a>;
<a name="l00212"></a>00212 
<a name="l00218"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0d959109f732e1f0729950973098536f">00218</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0d959109f732e1f0729950973098536f">assemble_qoi_sides</a>;
<a name="l00219"></a>00219 
<a name="l00223"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a7309f211d6ac11ac750e4a90858e7a0f">00223</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a7309f211d6ac11ac750e4a90858e7a0f">element_postprocess</a> (<a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {}
<a name="l00224"></a>00224  
<a name="l00229"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#afdc7a29f5bc94098ddf54cc1584622d4">00229</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#afdc7a29f5bc94098ddf54cc1584622d4">side_postprocess</a> (<a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {}
<a name="l00230"></a>00230  
<a name="l00238"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a5417ddd53b7946914ef038a53860b9e4">00238</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a5417ddd53b7946914ef038a53860b9e4">element_qoi</a> (<a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;, 
<a name="l00239"></a>00239                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;)
<a name="l00240"></a>00240     {}
<a name="l00241"></a>00241  
<a name="l00250"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ac24440d25028b40fbd23c6ee71abebea">00250</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ac24440d25028b40fbd23c6ee71abebea">element_qoi_derivative</a> (<a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;,
<a name="l00251"></a>00251                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;)
<a name="l00252"></a>00252     {}
<a name="l00253"></a>00253  
<a name="l00261"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a04c95b4a690e123981e960d9888377e7">00261</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a04c95b4a690e123981e960d9888377e7">side_qoi</a> (<a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;,
<a name="l00262"></a>00262                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;)
<a name="l00263"></a>00263     {}
<a name="l00264"></a>00264  
<a name="l00273"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab66879581243bee3aa9f1c3793173b88">00273</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab66879581243bee3aa9f1c3793173b88">side_qoi_derivative</a> (<a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;,
<a name="l00274"></a>00274                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;)
<a name="l00275"></a>00275     {}
<a name="l00276"></a>00276  
<a name="l00288"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a6ede04c93654df99643da828390b477c">00288</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a6ede04c93654df99643da828390b477c">time_evolving</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) {
<a name="l00289"></a>00289     libmesh_assert(<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a50a4fef55dc7025624a81fcbb8db3fca">_time_evolving</a>.size() &gt; var);
<a name="l00290"></a>00290     <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a50a4fef55dc7025624a81fcbb8db3fca">_time_evolving</a>[var] = <span class="keyword">true</span>;
<a name="l00291"></a>00291   }
<a name="l00292"></a>00292 
<a name="l00301"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a3fd9c4341b2bd346bdd89c0e04b570ac">00301</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a3fd9c4341b2bd346bdd89c0e04b570ac">eulerian_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00302"></a>00302                                   <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {
<a name="l00303"></a>00303     <span class="keywordflow">return</span> request_jacobian;
<a name="l00304"></a>00304   }
<a name="l00305"></a>00305 
<a name="l00317"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a742491345d88358ef03a9fddbdb18920">00317</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a742491345d88358ef03a9fddbdb18920">mass_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00318"></a>00318                               <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {
<a name="l00319"></a>00319     <span class="keywordflow">return</span> request_jacobian;
<a name="l00320"></a>00320   }
<a name="l00321"></a>00321 
<a name="l00334"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a805cab2a7e7feb6226a04029d882e9e8">00334</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a805cab2a7e7feb6226a04029d882e9e8">side_mass_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00335"></a>00335                                    <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {
<a name="l00336"></a>00336     <span class="keywordflow">return</span> request_jacobian;
<a name="l00337"></a>00337   }
<a name="l00338"></a>00338 
<a name="l00347"></a>00347   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a4a54fe7fd1361b929023c4728ec5ac07">build_context</a>();
<a name="l00348"></a>00348 
<a name="l00349"></a>00349   <span class="comment">/*</span>
<a name="l00350"></a>00350 <span class="comment">   * Prepares the result of a build_context() call for use.</span>
<a name="l00351"></a>00351 <span class="comment">   * </span>
<a name="l00352"></a>00352 <span class="comment">   * Most FEMSystem-based problems will need to reimplement this in order to</span>
<a name="l00353"></a>00353 <span class="comment">   * call FE::get_*() as their particular physics requires.</span>
<a name="l00354"></a>00354 <span class="comment">   */</span>
<a name="l00355"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a70230747554985556b79e02949c31c06">00355</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a70230747554985556b79e02949c31c06">init_context</a>(<a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;) {}
<a name="l00356"></a>00356  
<a name="l00362"></a>00362   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#acd2e68265ffb835434e783190c452b42">solve</a> ();
<a name="l00363"></a>00363  
<a name="l00368"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">00368</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;TimeSolver&gt;</a> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>;
<a name="l00369"></a>00369 
<a name="l00374"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">00374</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>;
<a name="l00375"></a>00375 
<a name="l00380"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a724e8442b2bc0b3a07e5e82051ce7f9e">00380</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a724e8442b2bc0b3a07e5e82051ce7f9e">print_solution_norms</a>;
<a name="l00381"></a>00381 
<a name="l00386"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a94c17d5708132f067a3224019af8ce58">00386</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a94c17d5708132f067a3224019af8ce58">print_solutions</a>;
<a name="l00387"></a>00387 
<a name="l00391"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aa4fc23a36102eb56598d5bb528cacf0b">00391</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aa4fc23a36102eb56598d5bb528cacf0b">print_residual_norms</a>;
<a name="l00392"></a>00392 
<a name="l00396"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a1be85415f6f38f15a4e36a201abbfe1c">00396</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a1be85415f6f38f15a4e36a201abbfe1c">print_residuals</a>;
<a name="l00397"></a>00397 
<a name="l00401"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aeaa7d80ca74e2494265f70a618989b6a">00401</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aeaa7d80ca74e2494265f70a618989b6a">print_jacobian_norms</a>;
<a name="l00402"></a>00402 
<a name="l00406"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0b0878d8d6d40ef8cb6daad9e9915daf">00406</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0b0878d8d6d40ef8cb6daad9e9915daf">print_jacobians</a>;
<a name="l00407"></a>00407 
<a name="l00411"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a72254eda9b022410c946f7ca2008e83a">00411</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a72254eda9b022410c946f7ca2008e83a">print_element_jacobians</a>;
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 <span class="keyword">protected</span>:
<a name="l00418"></a>00418   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab95f6ccd3684f3ad3423ae466bf4e8cd">init_data</a> ();
<a name="l00419"></a>00419 
<a name="l00424"></a><a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a50a4fef55dc7025624a81fcbb8db3fca">00424</a>   std::vector&lt;bool&gt; <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a50a4fef55dc7025624a81fcbb8db3fca">_time_evolving</a>;
<a name="l00425"></a>00425 };
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 } <span class="comment">// namespace libMesh</span>
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
