<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3734f8fafd73a2969ee8ed4a34620869.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">discontinuity_measure.h</div>  </div>
</div>
<div class="contents">
<a href="discontinuity__measure_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: discontinuity_measure.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __discontinuity_measure_h___</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __discontinuity_measure_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="jump__error__estimator_8h.php">jump_error_estimator.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span>Point;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00049"></a><a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php">00049</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php">DiscontinuityMeasure</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php">JumpErrorEstimator</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#afce341055712ce5587b524e77a4d1265">00058</a>   <a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#afce341055712ce5587b524e77a4d1265">DiscontinuityMeasure</a>() : <a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#ae25735cd54c0767a0e03c7f611b0ee17">_bc_function</a>(NULL) { <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>; }
<a name="l00059"></a>00059   
<a name="l00063"></a><a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#a0a3137522873549c5575a79c31a0015b">00063</a>   <a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#a0a3137522873549c5575a79c31a0015b">~DiscontinuityMeasure</a>() {}
<a name="l00064"></a>00064 
<a name="l00069"></a>00069   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#a3aafdec861b5dde7ef332895de4b7440">attach_essential_bc_function</a> (std::pair&lt;bool,Real&gt; fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00070"></a>00070                                                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00071"></a>00071                                                                <span class="keyword">const</span> std::string&amp; var_name));
<a name="l00072"></a>00072   
<a name="l00073"></a>00073 <span class="keyword">protected</span>:
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#adfef30e9de6ef96cdecc24269ff0e4d1">initialize</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00080"></a>00080                           <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00081"></a>00081                           <span class="keywordtype">bool</span> estimate_parent_error);
<a name="l00082"></a>00082 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#ab5f408eac1d9e866dbf6d09f81df3103">internal_side_integration</a>();
<a name="l00088"></a>00088 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#a866c66f12e3036dc0c25b052be9ada26">boundary_side_integration</a>();
<a name="l00095"></a>00095 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#ab7a1f103931a4b596ca05c490a1d02a9">00099</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> *<a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#ab7a1f103931a4b596ca05c490a1d02a9">my_system</a>;
<a name="l00100"></a>00100 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1DiscontinuityMeasure.php#ae25735cd54c0767a0e03c7f611b0ee17">00104</a>   std::pair&lt;bool,Real&gt; (* _bc_function) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00105"></a>00105                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00106"></a>00106                                          <span class="keyword">const</span> std::string&amp; var_name);
<a name="l00107"></a>00107 };
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 } <span class="comment">// namespace libMesh</span>
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="preprocessor">#endif</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
