<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">distributed_vector.C</div>  </div>
</div>
<div class="contents">
<a href="distributed__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: distributed_vector.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::abs</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="distributed__vector_8h.php">distributed_vector.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__subvector_8h.php">dense_subvector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// DistributedVector methods</span>
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00041"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a02629f78bacadf0fe874d6504b4f9a4c">00041</a> T <a class="code" href="classlibMesh_1_1DistributedVector.php#a02629f78bacadf0fe874d6504b4f9a4c">DistributedVector&lt;T&gt;::sum</a> ()<span class="keyword"> const</span>
<a name="l00042"></a>00042 <span class="keyword"></span>{
<a name="l00043"></a>00043   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00044"></a>00044   parallel_only();
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00047"></a>00047   libmesh_assert (_values.size() == _local_size);
<a name="l00048"></a>00048   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   T local_sum = 0.;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00053"></a>00053     local_sum += _values[i];
<a name="l00054"></a>00054   
<a name="l00055"></a>00055   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(local_sum);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="keywordflow">return</span> local_sum;
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00063"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#aa86d6548e8d9962d45aeebab03a8ab22">00063</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#aa86d6548e8d9962d45aeebab03a8ab22">DistributedVector&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00064"></a>00064 <span class="keyword"></span>{
<a name="l00065"></a>00065   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00066"></a>00066   parallel_only();
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00069"></a>00069   libmesh_assert (_values.size() == _local_size);
<a name="l00070"></a>00070   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="keywordtype">double</span> local_l1 = 0.;
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00075"></a>00075     local_l1 += std::abs(_values[i]);
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(local_l1);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="keywordflow">return</span> local_l1;
<a name="l00080"></a>00080 }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00085"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ab3cd2d852c327bfb51629a546840d326">00085</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#ab3cd2d852c327bfb51629a546840d326">DistributedVector&lt;T&gt;::l2_norm</a> ()<span class="keyword"> const</span>
<a name="l00086"></a>00086 <span class="keyword"></span>{
<a name="l00087"></a>00087   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00088"></a>00088   parallel_only();
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00091"></a>00091   libmesh_assert (_values.size() == _local_size);
<a name="l00092"></a>00092   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="keywordtype">double</span> local_l2 = 0.;
<a name="l00095"></a>00095   
<a name="l00096"></a>00096   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00097"></a>00097     local_l2 += <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(_values[i]);
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(local_l2);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="keywordflow">return</span> std::sqrt(local_l2);
<a name="l00102"></a>00102 }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00107"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ac65f58552c3172ebaac4026a94ad2fb1">00107</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#ac65f58552c3172ebaac4026a94ad2fb1">DistributedVector&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00108"></a>00108 <span class="keyword"></span>{
<a name="l00109"></a>00109   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00110"></a>00110   parallel_only();
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00113"></a>00113   libmesh_assert (_values.size() == _local_size);
<a name="l00114"></a>00114   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> local_linfty = 0.;
<a name="l00117"></a>00117   
<a name="l00118"></a>00118   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00119"></a>00119     local_linfty  = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(local_linfty,
<a name="l00120"></a>00120                              static_cast&lt;Real&gt;(std::abs(_values[i]))
<a name="l00121"></a>00121                              ); <span class="comment">// Note we static_cast so that both</span>
<a name="l00122"></a>00122                                 <span class="comment">// types are the same, as required</span>
<a name="l00123"></a>00123                                 <span class="comment">// by std::max</span>
<a name="l00124"></a>00124   
<a name="l00125"></a>00125   <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">Parallel::max</a>(local_linfty);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="keywordflow">return</span> local_linfty;
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00133"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ac6529c1cd60df12aac5d0d33112a52ee">00133</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DistributedVector.php#ac6529c1cd60df12aac5d0d33112a52ee">DistributedVector&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00134"></a>00134 {
<a name="l00135"></a>00135   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00136"></a>00136   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00137"></a>00137   libmesh_assert (_values.size() == _local_size);
<a name="l00138"></a>00138   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00139"></a>00139   
<a name="l00140"></a>00140   add(1., v);
<a name="l00141"></a>00141   
<a name="l00142"></a>00142   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00148"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ae0d16989873a71362ec96fa9185a2fa0">00148</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1DistributedVector.php#ae0d16989873a71362ec96fa9185a2fa0">DistributedVector&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00151"></a>00151   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00152"></a>00152   libmesh_assert (_values.size() == _local_size);
<a name="l00153"></a>00153   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00154"></a>00154   
<a name="l00155"></a>00155   add(-1., v);
<a name="l00156"></a>00156   
<a name="l00157"></a>00157   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00158"></a>00158 }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00163"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a224bb6169bf4db781004bb128da4853a">00163</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a224bb6169bf4db781004bb128da4853a">DistributedVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00164"></a>00164                                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00165"></a>00165 {
<a name="l00166"></a>00166   libmesh_assert (!v.empty());
<a name="l00167"></a>00167   libmesh_assert (v.size() == dof_indices.size());
<a name="l00168"></a>00168   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00169"></a>00169   libmesh_assert (_values.size() == _local_size);
<a name="l00170"></a>00170   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00171"></a>00171   
<a name="l00172"></a>00172   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00173"></a>00173     add (dof_indices[i], v[i]);
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00179"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a23f74e9175bb8a992b656246832689c7">00179</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a224bb6169bf4db781004bb128da4853a">DistributedVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00180"></a>00180                                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00181"></a>00181 {
<a name="l00182"></a>00182   libmesh_assert (V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>() == dof_indices.size());
<a name="l00183"></a>00183   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00184"></a>00184   libmesh_assert (_values.size() == _local_size);
<a name="l00185"></a>00185   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(); i++)
<a name="l00188"></a>00188     add (dof_indices[i], V(i));
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00194"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a18e211325d8051a272dab4e77efb979c">00194</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a224bb6169bf4db781004bb128da4853a">DistributedVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00195"></a>00195                                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00196"></a>00196 {
<a name="l00197"></a>00197   libmesh_assert (V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == dof_indices.size());
<a name="l00198"></a>00198   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00199"></a>00199   libmesh_assert (_values.size() == _local_size);
<a name="l00200"></a>00200   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l00203"></a>00203     add (dof_indices[i], V(i));
<a name="l00204"></a>00204 }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00209"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#af36137374c98370102f053757b4cf7fc">00209</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a8df626ab96f55b89b87f623f20ce728f">DistributedVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T v)
<a name="l00210"></a>00210 {
<a name="l00211"></a>00211   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00212"></a>00212   libmesh_assert (_values.size() == _local_size);
<a name="l00213"></a>00213   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00216"></a>00216     _values[i] += v;
<a name="l00217"></a>00217 }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00222"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a8d5f05d1914bf84a87d995ff3cf7f5e2">00222</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a8df626ab96f55b89b87f623f20ce728f">DistributedVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00223"></a>00223 {
<a name="l00224"></a>00224   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00225"></a>00225   libmesh_assert (_values.size() == _local_size);
<a name="l00226"></a>00226   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00227"></a>00227 
<a name="l00228"></a>00228   add (1., v);
<a name="l00229"></a>00229 }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00234"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#abb83885d5e9916e35d756d4c4d6f989f">00234</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a8df626ab96f55b89b87f623f20ce728f">DistributedVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00235"></a>00235 {
<a name="l00236"></a>00236   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00237"></a>00237   libmesh_assert (_values.size() == _local_size);
<a name="l00238"></a>00238   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   add(a, v);
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00246"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#aea66cf017b7c532bbf9211f175d22826">00246</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aea66cf017b7c532bbf9211f175d22826">DistributedVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00247"></a>00247                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00248"></a>00248 {
<a name="l00249"></a>00249   libmesh_assert (!v.empty());
<a name="l00250"></a>00250   libmesh_assert (v.size() == dof_indices.size());
<a name="l00251"></a>00251   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00252"></a>00252   libmesh_assert (_values.size() == _local_size);
<a name="l00253"></a>00253   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00254"></a>00254   
<a name="l00255"></a>00255   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00256"></a>00256     this-&gt;<span class="keyword">set</span> (dof_indices[i], v[i]);
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00262"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a297022a0ed9e458b812a13b821afd0cc">00262</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aea66cf017b7c532bbf9211f175d22826">DistributedVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00263"></a>00263                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00264"></a>00264 {
<a name="l00265"></a>00265   libmesh_assert (V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>() == dof_indices.size());
<a name="l00266"></a>00266   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00267"></a>00267   libmesh_assert (_values.size() == _local_size);
<a name="l00268"></a>00268   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(); i++)
<a name="l00271"></a>00271     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00277"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a12c574d7f9331cc08aa6a39bfd3795f5">00277</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aea66cf017b7c532bbf9211f175d22826">DistributedVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00278"></a>00278                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00279"></a>00279 {
<a name="l00280"></a>00280   libmesh_assert (V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == dof_indices.size());
<a name="l00281"></a>00281   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00282"></a>00282   libmesh_assert (_values.size() == _local_size);
<a name="l00283"></a>00283   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l00286"></a>00286     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00287"></a>00287 }
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00292"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a59488267c2dcc37ac8c422b17fe40bea">00292</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aea66cf017b7c532bbf9211f175d22826">DistributedVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00293"></a>00293                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00294"></a>00294 {
<a name="l00295"></a>00295   libmesh_assert (V.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>() == dof_indices.size());
<a name="l00296"></a>00296   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00297"></a>00297   libmesh_assert (_values.size() == _local_size);
<a name="l00298"></a>00298   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>(); i++)
<a name="l00301"></a>00301     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00302"></a>00302 }
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00307"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a62fffd6bad70e3551e4b672910f8ba12">00307</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a62fffd6bad70e3551e4b672910f8ba12">DistributedVector&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00308"></a>00308 {
<a name="l00309"></a>00309   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00310"></a>00310   libmesh_assert (_values.size() == _local_size);
<a name="l00311"></a>00311   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00314"></a>00314     _values[i] *= factor;  
<a name="l00315"></a>00315 }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00318"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ab04306c8bb98d9ad97975a73f7ff0fea">00318</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ab04306c8bb98d9ad97975a73f7ff0fea">DistributedVector&lt;T&gt;::abs</a>()
<a name="l00319"></a>00319 {
<a name="l00320"></a>00320   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00321"></a>00321   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00322"></a>00322 
<a name="l00323"></a>00323   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00324"></a>00324     this-&gt;<span class="keyword">set</span>(i,std::abs(_values[i]));
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00332"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a0c80b44d2b010cf2edb09030b781c903">00332</a> T <a class="code" href="classlibMesh_1_1DistributedVector.php#a0c80b44d2b010cf2edb09030b781c903">DistributedVector&lt;T&gt;::dot</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V)<span class="keyword"> const</span>
<a name="l00333"></a>00333 <span class="keyword"></span>{
<a name="l00334"></a>00334   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00335"></a>00335   parallel_only();
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="comment">// Make sure the NumericVector passed in is really a DistributedVector</span>
<a name="l00338"></a>00338   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const DistributedVector&lt;T&gt;*&gt;(&amp;V);
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <span class="comment">// Make sure that the two vectors are distributed in the same way.</span>
<a name="l00341"></a>00341   libmesh_assert ( this-&gt;first_local_index() == v-&gt;<a class="code" href="classlibMesh_1_1DistributedVector.php#a991c9c658658d1347f688986f02f69c5">first_local_index</a>() );
<a name="l00342"></a>00342   libmesh_assert ( this-&gt;last_local_index()  == v-&gt;<a class="code" href="classlibMesh_1_1DistributedVector.php#a0404a54df7e0b9362f02bd9215761555">last_local_index</a>()  );
<a name="l00343"></a>00343   
<a name="l00344"></a>00344   <span class="comment">// The result of dotting together the local parts of the vector.</span>
<a name="l00345"></a>00345   T local_dot = 0;
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;local_size(); i++)
<a name="l00348"></a>00348     local_dot += this-&gt;_values[i] * v-&gt;<a class="code" href="classlibMesh_1_1DistributedVector.php#a1074892adb5701b7c13614058356fc0a">_values</a>[i];
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   <span class="comment">// The local dot products are now summed via MPI</span>
<a name="l00351"></a>00351   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(local_dot);
<a name="l00352"></a>00352 
<a name="l00353"></a>00353   <span class="keywordflow">return</span> local_dot;
<a name="l00354"></a>00354 } 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00359"></a>00359 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; 
<a name="l00360"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ae600b46efe3ace199c186f6b29f4b8e3">00360</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae600b46efe3ace199c186f6b29f4b8e3">DistributedVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> T s)
<a name="l00361"></a>00361 {
<a name="l00362"></a>00362   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00363"></a>00363   libmesh_assert (_values.size() == _local_size);
<a name="l00364"></a>00364   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;local_size(); i++)
<a name="l00367"></a>00367     _values[i] = s;
<a name="l00368"></a>00368   
<a name="l00369"></a>00369   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00370"></a>00370 }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00375"></a>00375 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00376"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a6616af50fa81c6982dc49e122c3bd953">00376</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae600b46efe3ace199c186f6b29f4b8e3">DistributedVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00377"></a>00377 {
<a name="l00378"></a>00378   <span class="comment">// Make sure the NumericVector passed in is really a DistributedVector</span>
<a name="l00379"></a>00379   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const DistributedVector&lt;T&gt;*&gt;(&amp;v_in);
<a name="l00380"></a>00380   
<a name="l00381"></a>00381   *<span class="keyword">this</span> = *v;
<a name="l00382"></a>00382   
<a name="l00383"></a>00383   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00384"></a>00384 }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00389"></a>00389 <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a>&amp;
<a name="l00390"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a10de210f9aa6764abeeeb403d09a0d35">00390</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae600b46efe3ace199c186f6b29f4b8e3">DistributedVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a>&amp; v)
<a name="l00391"></a>00391 {
<a name="l00392"></a>00392   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>    = v.<a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a>;
<a name="l00393"></a>00393   this-&gt;_is_closed         = v.<a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a>;
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   _global_size       = v.<a class="code" href="classlibMesh_1_1DistributedVector.php#a858c895cef9b6db82715e2ae2a25bd0b">_global_size</a>;
<a name="l00396"></a>00396   _local_size        = v.<a class="code" href="classlibMesh_1_1DistributedVector.php#ab41d83fa37a202ce344894b4af6c98c8">_local_size</a>;
<a name="l00397"></a>00397   _first_local_index = v.<a class="code" href="classlibMesh_1_1DistributedVector.php#a394cccb8c5982fc003427b68b36ce68a">_first_local_index</a>;
<a name="l00398"></a>00398   _last_local_index  = v.<a class="code" href="classlibMesh_1_1DistributedVector.php#ae3bef136197973a856b46aa9d414bd1a">_last_local_index</a>;
<a name="l00399"></a>00399   
<a name="l00400"></a>00400   <span class="keywordflow">if</span> (v.<a class="code" href="classlibMesh_1_1DistributedVector.php#a235df94e403a3d36886f47dd6c03a8e7">local_size</a>() == this-&gt;local_size())
<a name="l00401"></a>00401     {
<a name="l00402"></a>00402       _values = v.<a class="code" href="classlibMesh_1_1DistributedVector.php#a1074892adb5701b7c13614058356fc0a">_values</a>;
<a name="l00403"></a>00403     }
<a name="l00404"></a>00404   <span class="keywordflow">else</span>
<a name="l00405"></a>00405     {
<a name="l00406"></a>00406       libmesh_error();
<a name="l00407"></a>00407     }
<a name="l00408"></a>00408   
<a name="l00409"></a>00409   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00415"></a>00415 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00416"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a57dc9702ac4fe615e477bc25dfc8d57e">00416</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae600b46efe3ace199c186f6b29f4b8e3">DistributedVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v)
<a name="l00417"></a>00417 {
<a name="l00418"></a>00418   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00419"></a>00419   libmesh_assert (_values.size() == _local_size);
<a name="l00420"></a>00420   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   <span class="keywordflow">if</span> (v.size() == local_size())
<a name="l00423"></a>00423     _values = v;
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (v.size() == size())
<a name="l00426"></a>00426     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=first_local_index(); i&lt;last_local_index(); i++)
<a name="l00427"></a>00427       _values[i-first_local_index()] = v[i];
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   <span class="keywordflow">else</span>
<a name="l00430"></a>00430     {
<a name="l00431"></a>00431       libmesh_error();
<a name="l00432"></a>00432     }
<a name="l00433"></a>00433 
<a name="l00434"></a>00434   
<a name="l00435"></a>00435   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00436"></a>00436 }
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00441"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#afdb918026fbc527893c771223718b35b">00441</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">DistributedVector&lt;T&gt;::localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in)<span class="keyword"> const</span>
<a name="l00442"></a>00442 <span class="keyword"></span>
<a name="l00443"></a>00443 <span class="keyword"></span>{
<a name="l00444"></a>00444   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00445"></a>00445   libmesh_assert (_values.size() == _local_size);
<a name="l00446"></a>00446   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a>* v_local = libmesh_cast_ptr&lt;DistributedVector&lt;T&gt;*&gt;(&amp;v_local_in);
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   v_local-&gt;<a class="code" href="classlibMesh_1_1DistributedVector.php#a394cccb8c5982fc003427b68b36ce68a">_first_local_index</a> = 0;
<a name="l00451"></a>00451   
<a name="l00452"></a>00452   v_local-&gt;<a class="code" href="classlibMesh_1_1DistributedVector.php#a858c895cef9b6db82715e2ae2a25bd0b">_global_size</a> =
<a name="l00453"></a>00453     v_local-&gt;<a class="code" href="classlibMesh_1_1DistributedVector.php#ab41d83fa37a202ce344894b4af6c98c8">_local_size</a> =
<a name="l00454"></a>00454     v_local-&gt;<a class="code" href="classlibMesh_1_1DistributedVector.php#ae3bef136197973a856b46aa9d414bd1a">_last_local_index</a> = size();
<a name="l00455"></a>00455 
<a name="l00456"></a>00456   v_local-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a> =
<a name="l00457"></a>00457     v_local-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a> = <span class="keyword">true</span>;
<a name="l00458"></a>00458   
<a name="l00459"></a>00459   <span class="comment">// Call localize on the vector&#39;s values.  This will help</span>
<a name="l00460"></a>00460   <span class="comment">// prevent code duplication</span>
<a name="l00461"></a>00461   localize (v_local-&gt;<a class="code" href="classlibMesh_1_1DistributedVector.php#a1074892adb5701b7c13614058356fc0a">_values</a>);    
<a name="l00462"></a>00462   
<a name="l00463"></a>00463 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00464"></a>00464 <span class="preprocessor"></span>
<a name="l00465"></a>00465   libmesh_assert (local_size() == size());
<a name="l00466"></a>00466   
<a name="l00467"></a>00467 <span class="preprocessor">#endif</span>
<a name="l00468"></a>00468 <span class="preprocessor"></span>}
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00473"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a48d965d0129a33d271af987edea66dd4">00473</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">DistributedVector&lt;T&gt;::localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in,
<a name="l00474"></a>00474                                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp;)<span class="keyword"> const</span>
<a name="l00475"></a>00475 <span class="keyword"></span>{
<a name="l00476"></a>00476   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00477"></a>00477   libmesh_assert (_values.size() == _local_size);
<a name="l00478"></a>00478   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00479"></a>00479 
<a name="l00480"></a>00480   <span class="comment">// TODO: We don&#39;t yet support the send list; this is inefficient:</span>
<a name="l00481"></a>00481   localize (v_local_in);
<a name="l00482"></a>00482 }
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00487"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a7a70b36749df08057f514d97d0ce6ef2">00487</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">DistributedVector&lt;T&gt;::localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00488"></a>00488                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00489"></a>00489                                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list)
<a name="l00490"></a>00490 {
<a name="l00491"></a>00491   <span class="comment">// Only good for serial vectors</span>
<a name="l00492"></a>00492   libmesh_assert (this-&gt;size() == this-&gt;local_size());
<a name="l00493"></a>00493   libmesh_assert (last_local_idx &gt; first_local_idx);
<a name="l00494"></a>00494   libmesh_assert (send_list.size() &lt;= this-&gt;size());
<a name="l00495"></a>00495   libmesh_assert (last_local_idx &lt; this-&gt;size());
<a name="l00496"></a>00496   
<a name="l00497"></a>00497   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size       = this-&gt;size();
<a name="l00498"></a>00498   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_size = (last_local_idx - first_local_idx + 1);
<a name="l00499"></a>00499 
<a name="l00500"></a>00500     <span class="comment">// Don&#39;t bother for serial cases</span>
<a name="l00501"></a>00501   <span class="keywordflow">if</span> ((first_local_idx == 0) &amp;&amp;
<a name="l00502"></a>00502       (local_size == size))
<a name="l00503"></a>00503     <span class="keywordflow">return</span>;
<a name="l00504"></a>00504   
<a name="l00505"></a>00505           
<a name="l00506"></a>00506   <span class="comment">// Build a parallel vector, initialize it with the local</span>
<a name="l00507"></a>00507   <span class="comment">// parts of (*this)</span>
<a name="l00508"></a>00508   <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a> parallel_vec;
<a name="l00509"></a>00509 
<a name="l00510"></a>00510   parallel_vec.<a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">init</a> (size, local_size, <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00511"></a>00511 
<a name="l00512"></a>00512   <span class="comment">// Copy part of *this into the parallel_vec</span>
<a name="l00513"></a>00513   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=first_local_idx; i&lt;=last_local_idx; i++)
<a name="l00514"></a>00514     parallel_vec.<a class="code" href="classlibMesh_1_1DistributedVector.php#a1074892adb5701b7c13614058356fc0a">_values</a>[i-first_local_idx] = _values[i];
<a name="l00515"></a>00515 
<a name="l00516"></a>00516   <span class="comment">// localize like normal</span>
<a name="l00517"></a>00517   parallel_vec.<a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">localize</a> (*<span class="keyword">this</span>, send_list);    
<a name="l00518"></a>00518 }
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00523"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">00523</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">DistributedVector&lt;T&gt;::localize</a> (std::vector&lt;T&gt;&amp; v_local)<span class="keyword"> const</span>
<a name="l00524"></a>00524 <span class="keyword"></span>{
<a name="l00525"></a>00525   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00526"></a>00526   parallel_only();
<a name="l00527"></a>00527 
<a name="l00528"></a>00528   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00529"></a>00529   libmesh_assert (_values.size() == _local_size);
<a name="l00530"></a>00530   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00531"></a>00531 
<a name="l00532"></a>00532   v_local = this-&gt;_values;
<a name="l00533"></a>00533 
<a name="l00534"></a>00534   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a> (v_local);
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00537"></a>00537 <span class="preprocessor"></span>  libmesh_assert (local_size() == size());
<a name="l00538"></a>00538 <span class="preprocessor">#endif  </span>
<a name="l00539"></a>00539 <span class="preprocessor"></span>}
<a name="l00540"></a>00540 
<a name="l00541"></a>00541 
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00544"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#acb10ecbde6e5535cd05b8943006ad040">00544</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#acb10ecbde6e5535cd05b8943006ad040">DistributedVector&lt;T&gt;::localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00545"></a>00545                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)<span class="keyword"> const</span>
<a name="l00546"></a>00546 <span class="keyword"></span>{
<a name="l00547"></a>00547   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00548"></a>00548   parallel_only();
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00551"></a>00551   libmesh_assert (_values.size() == _local_size);
<a name="l00552"></a>00552   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   v_local = this-&gt;_values;
<a name="l00555"></a>00555 
<a name="l00556"></a>00556   <a class="code" href="namespacelibMesh_1_1Parallel.php#af1249b450004d53c5e2acd6f4668f19d">Parallel::gather</a> (pid, v_local);
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00559"></a>00559 <span class="preprocessor"></span>  libmesh_assert (local_size() == size());
<a name="l00560"></a>00560 <span class="preprocessor">#endif  </span>
<a name="l00561"></a>00561 <span class="preprocessor"></span>}
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 
<a name="l00564"></a>00564 
<a name="l00565"></a>00565 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00566"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#aecb56ab987b87dbd97e71b23c04c5a15">00566</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aecb56ab987b87dbd97e71b23c04c5a15">DistributedVector&lt;T&gt;::pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00567"></a>00567                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;)
<a name="l00568"></a>00568 <span class="comment">//void DistributedVector&lt;T&gt;::pointwise_mult (const NumericVector&lt;T&gt;&amp; vec1,</span>
<a name="l00569"></a>00569 <span class="comment">//                                         const NumericVector&lt;T&gt;&amp; vec2)</span>
<a name="l00570"></a>00570 {
<a name="l00571"></a>00571   libmesh_not_implemented();
<a name="l00572"></a>00572 }
<a name="l00573"></a>00573 
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00577"></a>00577 <span class="comment">// Explicit instantiations</span>
<a name="l00578"></a>00578 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;Number&gt;</a>;
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
