<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">distributed_vector.h</div>  </div>
</div>
<div class="contents">
<a href="distributed__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: distributed_vector.h 4286 2011-03-24 03:55:50Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#ifndef __distributed_vector_h__</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span><span class="preprocessor">#define __distributed_vector_h__</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// C++ includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Local includes</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1DistributedVector.php">00057</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>&lt;T&gt;
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060 
<a name="l00064"></a>00064   <span class="keyword">explicit</span>
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1DistributedVector.php#a076e1147a20dea75817289f7bfd8bc54">DistributedVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00066"></a>00066   
<a name="l00070"></a>00070   <span class="keyword">explicit</span>
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1DistributedVector.php#a076e1147a20dea75817289f7bfd8bc54">DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00072"></a>00072                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00073"></a>00073     
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1DistributedVector.php#a076e1147a20dea75817289f7bfd8bc54">DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00079"></a>00079                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00080"></a>00080                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00081"></a>00081     
<a name="l00087"></a>00087   <a class="code" href="classlibMesh_1_1DistributedVector.php#a076e1147a20dea75817289f7bfd8bc54">DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00088"></a>00088                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00089"></a>00089                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00090"></a>00090                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00091"></a>00091     
<a name="l00096"></a>00096   <a class="code" href="classlibMesh_1_1DistributedVector.php#af27e8248c1106353f590de646ead6fef">~DistributedVector</a> ();
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ab0fda9fd10355cf22ba60ebfbca37f62">close</a> (); 
<a name="l00102"></a>00102 
<a name="l00106"></a>00106   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#afd65d8a3e889184fe520324eb14e4bc8">clear</a> ();
<a name="l00107"></a>00107   
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a131693bc4f8862305f86e612de79e6a1">zero</a> ();    
<a name="l00113"></a>00113 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1DistributedVector.php#a185618e2fd09e9b5d5608679b5e8234f">zero_clone</a> () <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00124"></a>00124   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1DistributedVector.php#afa2f56b0f31973e7a749e57485ad945d">clone</a> () <span class="keyword">const</span>;
<a name="l00125"></a>00125 
<a name="l00138"></a>00138   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00139"></a>00139              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00140"></a>00140              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00141"></a>00141              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00142"></a>00142     
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00147"></a>00147              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00148"></a>00148              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00149"></a>00149     
<a name="l00154"></a>00154   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00155"></a>00155                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00156"></a>00156                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00157"></a>00157                      <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00158"></a>00158                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00159"></a>00159     
<a name="l00164"></a>00164   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00165"></a>00165                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>);
<a name="l00166"></a>00166 
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1DistributedVector.php#ae600b46efe3ace199c186f6b29f4b8e3">operator= </a>(<span class="keyword">const</span> T s);
<a name="l00171"></a>00171     
<a name="l00175"></a>00175   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1DistributedVector.php#ae600b46efe3ace199c186f6b29f4b8e3">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00176"></a>00176 
<a name="l00180"></a>00180   <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1DistributedVector.php#ae600b46efe3ace199c186f6b29f4b8e3">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a> &amp;V);
<a name="l00181"></a>00181 
<a name="l00185"></a>00185   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1DistributedVector.php#ae600b46efe3ace199c186f6b29f4b8e3">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v);
<a name="l00186"></a>00186   
<a name="l00192"></a>00192   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#a9d32d3b7d49b3114d6045775e99afef8">min</a> () <span class="keyword">const</span>;
<a name="l00193"></a>00193   
<a name="l00199"></a>00199   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#a37176fd9b426e7737f4a52685f9d41a2">max</a> () <span class="keyword">const</span>;
<a name="l00200"></a>00200   
<a name="l00204"></a>00204   T <a class="code" href="classlibMesh_1_1DistributedVector.php#a02629f78bacadf0fe874d6504b4f9a4c">sum</a>() <span class="keyword">const</span>;
<a name="l00205"></a>00205 
<a name="l00210"></a>00210   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#aa86d6548e8d9962d45aeebab03a8ab22">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00211"></a>00211 
<a name="l00217"></a>00217   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#ab3cd2d852c327bfb51629a546840d326">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00218"></a>00218 
<a name="l00224"></a>00224   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#ac65f58552c3172ebaac4026a94ad2fb1">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00225"></a>00225 
<a name="l00233"></a>00233   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#acc8b3a66af8684890f1607b3403f9910">size</a> () <span class="keyword">const</span>;
<a name="l00234"></a>00234 
<a name="l00239"></a>00239   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a235df94e403a3d36886f47dd6c03a8e7">local_size</a>() <span class="keyword">const</span>;
<a name="l00240"></a>00240 
<a name="l00245"></a>00245   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a991c9c658658d1347f688986f02f69c5">first_local_index</a>() <span class="keyword">const</span>;
<a name="l00246"></a>00246 
<a name="l00251"></a>00251   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a0404a54df7e0b9362f02bd9215761555">last_local_index</a>() <span class="keyword">const</span>;
<a name="l00252"></a>00252     
<a name="l00256"></a>00256   T <a class="code" href="classlibMesh_1_1DistributedVector.php#acdbc2ce26bda305876214f8a73caf00d">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00257"></a>00257     
<a name="l00262"></a>00262   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1DistributedVector.php#ac6529c1cd60df12aac5d0d33112a52ee">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00263"></a>00263 
<a name="l00268"></a>00268   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1DistributedVector.php#ae0d16989873a71362ec96fa9185a2fa0">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00269"></a>00269     
<a name="l00273"></a>00273   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00274"></a>00274     
<a name="l00278"></a>00278   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a8df626ab96f55b89b87f623f20ce728f">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00279"></a>00279     
<a name="l00285"></a>00285   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a8df626ab96f55b89b87f623f20ce728f">add</a> (<span class="keyword">const</span> T s);
<a name="l00286"></a>00286     
<a name="l00292"></a>00292   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a8df626ab96f55b89b87f623f20ce728f">add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V);
<a name="l00293"></a>00293 
<a name="l00299"></a>00299   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a8df626ab96f55b89b87f623f20ce728f">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v);
<a name="l00300"></a>00300   
<a name="l00306"></a>00306   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a224bb6169bf4db781004bb128da4853a">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00307"></a>00307                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00308"></a>00308 
<a name="l00315"></a>00315   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a224bb6169bf4db781004bb128da4853a">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00316"></a>00316                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00317"></a>00317   
<a name="l00324"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a7c67a75229b9262ef0a4ed2236e99b08">00324</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a224bb6169bf4db781004bb128da4853a">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00325"></a>00325                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;)
<a name="l00326"></a>00326   { libmesh_error(); }
<a name="l00327"></a>00327   
<a name="l00334"></a>00334   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a224bb6169bf4db781004bb128da4853a">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00335"></a>00335                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00336"></a>00336 
<a name="l00343"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ad2f3a1bb023031d567981dd809036751">00343</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ad2f3a1bb023031d567981dd809036751">add_vector_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00344"></a>00344                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;)
<a name="l00345"></a>00345   { libmesh_error(); }
<a name="l00346"></a>00346   
<a name="l00351"></a>00351   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aea66cf017b7c532bbf9211f175d22826">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00352"></a>00352                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00353"></a>00353 
<a name="l00360"></a>00360   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aea66cf017b7c532bbf9211f175d22826">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00361"></a>00361                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00362"></a>00362       
<a name="l00368"></a>00368   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aea66cf017b7c532bbf9211f175d22826">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00369"></a>00369                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00370"></a>00370     
<a name="l00376"></a>00376   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aea66cf017b7c532bbf9211f175d22826">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00377"></a>00377                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00378"></a>00378     
<a name="l00383"></a>00383   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a62fffd6bad70e3551e4b672910f8ba12">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00384"></a>00384 
<a name="l00389"></a>00389   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ab04306c8bb98d9ad97975a73f7ff0fea">abs</a>();
<a name="l00390"></a>00390   
<a name="l00394"></a>00394   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1DistributedVector.php#a0c80b44d2b010cf2edb09030b781c903">dot</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) <span class="keyword">const</span>;
<a name="l00395"></a>00395   
<a name="l00400"></a>00400   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span>;
<a name="l00401"></a>00401 
<a name="l00406"></a>00406   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span>;
<a name="l00407"></a>00407 
<a name="l00413"></a>00413   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00414"></a>00414                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span>;
<a name="l00415"></a>00415   
<a name="l00420"></a>00420   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ad50a5273e5fd20aa917e4f7bf4b03e8a">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00421"></a>00421                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00422"></a>00422                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list);
<a name="l00423"></a>00423 
<a name="l00430"></a>00430   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#acb10ecbde6e5535cd05b8943006ad040">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00431"></a>00431                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span>;
<a name="l00432"></a>00432     
<a name="l00437"></a>00437   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#aecb56ab987b87dbd97e71b23c04c5a15">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00438"></a>00438                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2);
<a name="l00439"></a>00439 
<a name="l00443"></a>00443   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#abfc45c65fc2df98cbe73508ddf213a32">swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 <span class="keyword">private</span>:
<a name="l00446"></a>00446 
<a name="l00451"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a1074892adb5701b7c13614058356fc0a">00451</a>   std::vector&lt;T&gt; <a class="code" href="classlibMesh_1_1DistributedVector.php#a1074892adb5701b7c13614058356fc0a">_values</a>;
<a name="l00452"></a>00452 
<a name="l00456"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a858c895cef9b6db82715e2ae2a25bd0b">00456</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a858c895cef9b6db82715e2ae2a25bd0b">_global_size</a>;
<a name="l00457"></a>00457 
<a name="l00461"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ab41d83fa37a202ce344894b4af6c98c8">00461</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ab41d83fa37a202ce344894b4af6c98c8">_local_size</a>;
<a name="l00462"></a>00462 
<a name="l00466"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a394cccb8c5982fc003427b68b36ce68a">00466</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a394cccb8c5982fc003427b68b36ce68a">_first_local_index</a>;
<a name="l00467"></a>00467 
<a name="l00471"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ae3bef136197973a856b46aa9d414bd1a">00471</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae3bef136197973a856b46aa9d414bd1a">_last_local_index</a>;
<a name="l00472"></a>00472 };
<a name="l00473"></a>00473 
<a name="l00474"></a>00474 
<a name="l00475"></a>00475 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00476"></a>00476 <span class="comment">// DistributedVector inline methods</span>
<a name="l00477"></a>00477 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00478"></a>00478 <span class="keyword">inline</span>
<a name="l00479"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a076e1147a20dea75817289f7bfd8bc54">00479</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#a076e1147a20dea75817289f7bfd8bc54">DistributedVector&lt;T&gt;::DistributedVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00480"></a>00480   _global_size      (0),
<a name="l00481"></a>00481   _local_size       (0),
<a name="l00482"></a>00482   _first_local_index(0),
<a name="l00483"></a>00483   _last_local_index (0)
<a name="l00484"></a>00484 {
<a name="l00485"></a>00485   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a> = <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>;
<a name="l00486"></a>00486 }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00491"></a>00491 <span class="keyword">inline</span>
<a name="l00492"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a494ec1a9574ca901fd9fdfd0fc70be02">00492</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#a076e1147a20dea75817289f7bfd8bc54">DistributedVector&lt;T&gt;::DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00493"></a>00493                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00494"></a>00494 {
<a name="l00495"></a>00495   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n, <span class="keyword">false</span>, type);
<a name="l00496"></a>00496 }
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00501"></a>00501 <span class="keyword">inline</span>
<a name="l00502"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a37b0737430077e1fdbc292efb738c802">00502</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#a076e1147a20dea75817289f7bfd8bc54">DistributedVector&lt;T&gt;::DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00503"></a>00503                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00504"></a>00504                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00505"></a>00505 {
<a name="l00506"></a>00506   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, <span class="keyword">false</span>, type);
<a name="l00507"></a>00507 }
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00512"></a>00512 <span class="keyword">inline</span>
<a name="l00513"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#add23e9a0d17c6e069d8363eb5a8699e1">00513</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#a076e1147a20dea75817289f7bfd8bc54">DistributedVector&lt;T&gt;::DistributedVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00514"></a>00514                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00515"></a>00515                                          <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00516"></a>00516                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00517"></a>00517 {
<a name="l00518"></a>00518   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, ghost, <span class="keyword">false</span>, type);
<a name="l00519"></a>00519 }
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00524"></a>00524 <span class="keyword">inline</span>
<a name="l00525"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#af27e8248c1106353f590de646ead6fef">00525</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#af27e8248c1106353f590de646ead6fef">DistributedVector&lt;T&gt;::~DistributedVector</a> ()
<a name="l00526"></a>00526 {
<a name="l00527"></a>00527   this-&gt;clear ();
<a name="l00528"></a>00528 }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00533"></a>00533 <span class="keyword">inline</span>
<a name="l00534"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">00534</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">DistributedVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00535"></a>00535                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00536"></a>00536                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00537"></a>00537                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00538"></a>00538 {
<a name="l00539"></a>00539   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00540"></a>00540   parallel_only();
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   libmesh_assert (n_local &lt;= n);
<a name="l00543"></a>00543 
<a name="l00544"></a>00544   <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>)
<a name="l00545"></a>00545     {
<a name="l00546"></a>00546       <span class="keywordflow">if</span> (n == n_local)
<a name="l00547"></a>00547         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00548"></a>00548       <span class="keywordflow">else</span>
<a name="l00549"></a>00549         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00550"></a>00550     }
<a name="l00551"></a>00551   <span class="keywordflow">else</span>
<a name="l00552"></a>00552     this-&gt;_type = type;
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   libmesh_assert ((this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a> &amp;&amp; n==n_local) || 
<a name="l00555"></a>00555                   this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   <span class="comment">// Clear the data structures if already initialized</span>
<a name="l00558"></a>00558   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00559"></a>00559     this-&gt;clear();
<a name="l00560"></a>00560     
<a name="l00561"></a>00561   <span class="comment">// Initialize data structures</span>
<a name="l00562"></a>00562   _values.resize(n_local);
<a name="l00563"></a>00563   _local_size  = n_local;
<a name="l00564"></a>00564   _global_size = n;
<a name="l00565"></a>00565 
<a name="l00566"></a>00566   _first_local_index = 0;
<a name="l00567"></a>00567   
<a name="l00568"></a>00568 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00569"></a>00569 <span class="preprocessor"></span>
<a name="l00570"></a>00570   std::vector&lt;int&gt; local_sizes (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00571"></a>00571   
<a name="l00572"></a>00572   local_sizes[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] = n_local;
<a name="l00573"></a>00573 
<a name="l00574"></a>00574   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(local_sizes);
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   <span class="comment">// _first_local_index is the sum of _local_size</span>
<a name="l00577"></a>00577   <span class="comment">// for all processor ids less than ours</span>
<a name="l00578"></a>00578   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p!=<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); p++)
<a name="l00579"></a>00579     _first_local_index += local_sizes[p];
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 
<a name="l00582"></a>00582 <span class="preprocessor">#  ifdef DEBUG</span>
<a name="l00583"></a>00583 <span class="preprocessor"></span>  <span class="comment">// Make sure all the local sizes sum up to the global</span>
<a name="l00584"></a>00584   <span class="comment">// size, otherwise there is big trouble!</span>
<a name="l00585"></a>00585   <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">sum</a>=0;
<a name="l00586"></a>00586 
<a name="l00587"></a>00587   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p!=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); p++)
<a name="l00588"></a>00588     sum += local_sizes[p];
<a name="l00589"></a>00589 
<a name="l00590"></a>00590   libmesh_assert (sum == static_cast&lt;int&gt;(n));
<a name="l00591"></a>00591   
<a name="l00592"></a>00592 <span class="preprocessor">#  endif</span>
<a name="l00593"></a>00593 <span class="preprocessor"></span>  
<a name="l00594"></a>00594 <span class="preprocessor">#else</span>
<a name="l00595"></a>00595 <span class="preprocessor"></span>  
<a name="l00596"></a>00596   <span class="comment">// No other options without MPI!</span>
<a name="l00597"></a>00597   <span class="keywordflow">if</span> (n != n_local)
<a name="l00598"></a>00598     {
<a name="l00599"></a>00599       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  MPI is required for n != n_local!&quot;</span>
<a name="l00600"></a>00600                     &lt;&lt; std::endl;
<a name="l00601"></a>00601       libmesh_error();
<a name="l00602"></a>00602     }
<a name="l00603"></a>00603   
<a name="l00604"></a>00604 <span class="preprocessor">#endif</span>
<a name="l00605"></a>00605 <span class="preprocessor"></span>
<a name="l00606"></a>00606   _last_local_index = _first_local_index + n_local;
<a name="l00607"></a>00607   
<a name="l00608"></a>00608   <span class="comment">// Set the initialized flag</span>
<a name="l00609"></a>00609   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00610"></a>00610 
<a name="l00611"></a>00611   <span class="comment">// Zero the components unless directed otherwise</span>
<a name="l00612"></a>00612   <span class="keywordflow">if</span> (!fast)
<a name="l00613"></a>00613     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a>();
<a name="l00614"></a>00614 }
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00618"></a>00618 <span class="keyword">inline</span>
<a name="l00619"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a487a755143df60a87142cb236a3b2035">00619</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">DistributedVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00620"></a>00620                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00621"></a>00621                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00622"></a>00622                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00623"></a>00623                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00624"></a>00624 {
<a name="l00625"></a>00625   <span class="comment">// TODO: we shouldn&#39;t ignore the ghost sparsity pattern</span>
<a name="l00626"></a>00626   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n, n_local, fast, type);
<a name="l00627"></a>00627 }
<a name="l00628"></a>00628 
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 
<a name="l00631"></a>00631 <span class="comment">/* Default implementation for solver packages for which ghosted</span>
<a name="l00632"></a>00632 <span class="comment">   vectors are not yet implemented.  */</span>
<a name="l00633"></a>00633 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00634"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a459dc6a7554a6e733f93b46961b7fab6">00634</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">DistributedVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00635"></a>00635                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> fast)
<a name="l00636"></a>00636 {
<a name="l00637"></a>00637   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(other.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(),other.<a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>(),fast,other.<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>());
<a name="l00638"></a>00638 }
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00643"></a>00643 <span class="keyword">inline</span>
<a name="l00644"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#abd690cb22df9aa6c2206b9eae604507a">00644</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ae4f4bc64c68e47d4417ddcc728f5eb69">DistributedVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00645"></a>00645                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00646"></a>00646                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00647"></a>00647 {
<a name="l00648"></a>00648   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n,fast,type);
<a name="l00649"></a>00649 }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00654"></a>00654 <span class="keyword">inline</span>
<a name="l00655"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#ab0fda9fd10355cf22ba60ebfbca37f62">00655</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#ab0fda9fd10355cf22ba60ebfbca37f62">DistributedVector&lt;T&gt;::close</a> ()
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00658"></a>00658   
<a name="l00659"></a>00659   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00660"></a>00660 }
<a name="l00661"></a>00661 
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00665"></a>00665 <span class="keyword">inline</span>
<a name="l00666"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#afd65d8a3e889184fe520324eb14e4bc8">00666</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#afd65d8a3e889184fe520324eb14e4bc8">DistributedVector&lt;T&gt;::clear</a> ()
<a name="l00667"></a>00667 {
<a name="l00668"></a>00668   _values.clear();
<a name="l00669"></a>00669   
<a name="l00670"></a>00670   _global_size =
<a name="l00671"></a>00671     _local_size =
<a name="l00672"></a>00672     _first_local_index =
<a name="l00673"></a>00673     _last_local_index = 0;
<a name="l00674"></a>00674   
<a name="l00675"></a>00675   
<a name="l00676"></a>00676   this-&gt;_is_closed = this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00677"></a>00677 }
<a name="l00678"></a>00678 
<a name="l00679"></a>00679 
<a name="l00680"></a>00680 
<a name="l00681"></a>00681 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00682"></a>00682 <span class="keyword">inline</span>
<a name="l00683"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a131693bc4f8862305f86e612de79e6a1">00683</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a131693bc4f8862305f86e612de79e6a1">DistributedVector&lt;T&gt;::zero</a> ()
<a name="l00684"></a>00684 {
<a name="l00685"></a>00685   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00686"></a>00686   libmesh_assert (_values.size() == _local_size);
<a name="l00687"></a>00687   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00688"></a>00688   
<a name="l00689"></a>00689   std::fill (_values.begin(),
<a name="l00690"></a>00690              _values.end(),
<a name="l00691"></a>00691              0.);
<a name="l00692"></a>00692 }
<a name="l00693"></a>00693 
<a name="l00694"></a>00694 
<a name="l00695"></a>00695 
<a name="l00696"></a>00696 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00697"></a>00697 <span class="keyword">inline</span>
<a name="l00698"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a185618e2fd09e9b5d5608679b5e8234f">00698</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1DistributedVector.php#a185618e2fd09e9b5d5608679b5e8234f">DistributedVector&lt;T&gt;::zero_clone</a> ()<span class="keyword"> const</span>
<a name="l00699"></a>00699 <span class="keyword"></span>{
<a name="l00700"></a>00700   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a>);
<a name="l00701"></a>00701 
<a name="l00702"></a>00702   cloned_vector-&gt;init(*<span class="keyword">this</span>);
<a name="l00703"></a>00703 
<a name="l00704"></a>00704   <span class="keywordflow">return</span> cloned_vector;
<a name="l00705"></a>00705 }
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00710"></a>00710 <span class="keyword">inline</span>
<a name="l00711"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#afa2f56b0f31973e7a749e57485ad945d">00711</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1DistributedVector.php#afa2f56b0f31973e7a749e57485ad945d">DistributedVector&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00712"></a>00712 <span class="keyword"></span>{
<a name="l00713"></a>00713   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a>);
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   cloned_vector-&gt;init(*<span class="keyword">this</span>, <span class="keyword">true</span>);
<a name="l00716"></a>00716 
<a name="l00717"></a>00717   *cloned_vector = *<span class="keyword">this</span>;
<a name="l00718"></a>00718 
<a name="l00719"></a>00719   <span class="keywordflow">return</span> cloned_vector;
<a name="l00720"></a>00720 }
<a name="l00721"></a>00721 
<a name="l00722"></a>00722 
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00725"></a>00725 <span class="keyword">inline</span>
<a name="l00726"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#acc8b3a66af8684890f1607b3403f9910">00726</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#acc8b3a66af8684890f1607b3403f9910">DistributedVector&lt;T&gt;::size</a> ()<span class="keyword"> const</span>
<a name="l00727"></a>00727 <span class="keyword"></span>{
<a name="l00728"></a>00728   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00729"></a>00729   libmesh_assert (_values.size() == _local_size);
<a name="l00730"></a>00730   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00731"></a>00731 
<a name="l00732"></a>00732   <span class="keywordflow">return</span> _global_size;
<a name="l00733"></a>00733 }
<a name="l00734"></a>00734 
<a name="l00735"></a>00735 
<a name="l00736"></a>00736 
<a name="l00737"></a>00737 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00738"></a>00738 <span class="keyword">inline</span>
<a name="l00739"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a235df94e403a3d36886f47dd6c03a8e7">00739</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a235df94e403a3d36886f47dd6c03a8e7">DistributedVector&lt;T&gt;::local_size</a> ()<span class="keyword"> const</span>
<a name="l00740"></a>00740 <span class="keyword"></span>{
<a name="l00741"></a>00741   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00742"></a>00742   libmesh_assert (_values.size() == _local_size);
<a name="l00743"></a>00743   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00744"></a>00744 
<a name="l00745"></a>00745   <span class="keywordflow">return</span> _local_size;
<a name="l00746"></a>00746 }
<a name="l00747"></a>00747 
<a name="l00748"></a>00748 
<a name="l00749"></a>00749 
<a name="l00750"></a>00750 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00751"></a>00751 <span class="keyword">inline</span>
<a name="l00752"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a991c9c658658d1347f688986f02f69c5">00752</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a991c9c658658d1347f688986f02f69c5">DistributedVector&lt;T&gt;::first_local_index</a> ()<span class="keyword"> const</span>
<a name="l00753"></a>00753 <span class="keyword"></span>{
<a name="l00754"></a>00754   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00755"></a>00755   libmesh_assert (_values.size() == _local_size);
<a name="l00756"></a>00756   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00757"></a>00757 
<a name="l00758"></a>00758   <span class="keywordflow">return</span> _first_local_index;
<a name="l00759"></a>00759 }
<a name="l00760"></a>00760 
<a name="l00761"></a>00761 
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00764"></a>00764 <span class="keyword">inline</span>
<a name="l00765"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a0404a54df7e0b9362f02bd9215761555">00765</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a0404a54df7e0b9362f02bd9215761555">DistributedVector&lt;T&gt;::last_local_index</a> ()<span class="keyword"> const</span>
<a name="l00766"></a>00766 <span class="keyword"></span>{
<a name="l00767"></a>00767   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00768"></a>00768   libmesh_assert (_values.size() == _local_size);
<a name="l00769"></a>00769   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00770"></a>00770 
<a name="l00771"></a>00771   <span class="keywordflow">return</span> _last_local_index;
<a name="l00772"></a>00772 }
<a name="l00773"></a>00773 
<a name="l00774"></a>00774 
<a name="l00775"></a>00775 
<a name="l00776"></a>00776 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00777"></a>00777 <span class="keyword">inline</span>
<a name="l00778"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#acdbc2ce26bda305876214f8a73caf00d">00778</a> T <a class="code" href="classlibMesh_1_1DistributedVector.php#acdbc2ce26bda305876214f8a73caf00d">DistributedVector&lt;T&gt;::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00779"></a>00779 <span class="keyword"></span>{
<a name="l00780"></a>00780   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00781"></a>00781   libmesh_assert (_values.size() == _local_size);
<a name="l00782"></a>00782   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00783"></a>00783   libmesh_assert ( ((i &gt;= first_local_index()) &amp;&amp;
<a name="l00784"></a>00784             (i &lt;  last_local_index())) );
<a name="l00785"></a>00785 
<a name="l00786"></a>00786   <span class="keywordflow">return</span> _values[i - _first_local_index];
<a name="l00787"></a>00787 }
<a name="l00788"></a>00788 
<a name="l00789"></a>00789 
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00792"></a>00792 <span class="keyword">inline</span>
<a name="l00793"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#abfe6143e58616d9b1a35b52f87ae071b">00793</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#abfe6143e58616d9b1a35b52f87ae071b">DistributedVector&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00794"></a>00794 {
<a name="l00795"></a>00795   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00796"></a>00796   libmesh_assert (_values.size() == _local_size);
<a name="l00797"></a>00797   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00798"></a>00798   libmesh_assert (i&lt;size());
<a name="l00799"></a>00799   libmesh_assert (i-first_local_index() &lt; local_size());
<a name="l00800"></a>00800   
<a name="l00801"></a>00801   _values[i - _first_local_index] = value;
<a name="l00802"></a>00802 }
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 
<a name="l00806"></a>00806 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00807"></a>00807 <span class="keyword">inline</span>
<a name="l00808"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a8df626ab96f55b89b87f623f20ce728f">00808</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#a8df626ab96f55b89b87f623f20ce728f">DistributedVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00809"></a>00809 {
<a name="l00810"></a>00810   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00811"></a>00811   libmesh_assert (_values.size() == _local_size);
<a name="l00812"></a>00812   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00813"></a>00813   libmesh_assert (i&lt;size());
<a name="l00814"></a>00814   libmesh_assert (i-first_local_index() &lt; local_size());
<a name="l00815"></a>00815   
<a name="l00816"></a>00816   _values[i - _first_local_index] += value;
<a name="l00817"></a>00817 }
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 
<a name="l00821"></a>00821 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00822"></a>00822 <span class="keyword">inline</span>
<a name="l00823"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a9d32d3b7d49b3114d6045775e99afef8">00823</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#a9d32d3b7d49b3114d6045775e99afef8">DistributedVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00824"></a>00824 <span class="keyword"></span>{
<a name="l00825"></a>00825   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00826"></a>00826   parallel_only();
<a name="l00827"></a>00827 
<a name="l00828"></a>00828   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00829"></a>00829   libmesh_assert (_values.size() == _local_size);
<a name="l00830"></a>00830   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00831"></a>00831 
<a name="l00832"></a>00832   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> local_min = _values.size() ? 
<a name="l00833"></a>00833     <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(_values[0]) : <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>();
<a name="l00834"></a>00834   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 1; i &lt; _values.size(); ++i)
<a name="l00835"></a>00835     local_min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(_values[i]), local_min);
<a name="l00836"></a>00836   
<a name="l00837"></a>00837   <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(local_min);
<a name="l00838"></a>00838 
<a name="l00839"></a>00839   <span class="keywordflow">return</span> local_min;
<a name="l00840"></a>00840 }
<a name="l00841"></a>00841 
<a name="l00842"></a>00842 
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00845"></a>00845 <span class="keyword">inline</span>
<a name="l00846"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#a37176fd9b426e7737f4a52685f9d41a2">00846</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1DistributedVector.php#a37176fd9b426e7737f4a52685f9d41a2">DistributedVector&lt;T&gt;::max</a>()<span class="keyword"> const</span>
<a name="l00847"></a>00847 <span class="keyword"></span>{
<a name="l00848"></a>00848   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00849"></a>00849   parallel_only();
<a name="l00850"></a>00850 
<a name="l00851"></a>00851   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00852"></a>00852   libmesh_assert (_values.size() == _local_size);
<a name="l00853"></a>00853   libmesh_assert ((_last_local_index - _first_local_index) == _local_size);
<a name="l00854"></a>00854 
<a name="l00855"></a>00855   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> local_max = _values.size() ? 
<a name="l00856"></a>00856     <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(_values[0]) : -<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>();
<a name="l00857"></a>00857   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 1; i &lt; _values.size(); ++i)
<a name="l00858"></a>00858     local_max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(_values[i]), local_max);
<a name="l00859"></a>00859   
<a name="l00860"></a>00860   <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">Parallel::max</a>(local_max);
<a name="l00861"></a>00861 
<a name="l00862"></a>00862   <span class="keywordflow">return</span> local_max;
<a name="l00863"></a>00863 }
<a name="l00864"></a>00864 
<a name="l00865"></a>00865 
<a name="l00866"></a>00866 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00867"></a>00867 <span class="keyword">inline</span>
<a name="l00868"></a><a class="code" href="classlibMesh_1_1DistributedVector.php#abfc45c65fc2df98cbe73508ddf213a32">00868</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DistributedVector.php#abfc45c65fc2df98cbe73508ddf213a32">DistributedVector&lt;T&gt;::swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other)
<a name="l00869"></a>00869 {
<a name="l00870"></a>00870   <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;DistributedVector&lt;T&gt;&amp;&gt;(other);
<a name="l00871"></a>00871 
<a name="l00872"></a>00872   std::swap(_global_size, v.<a class="code" href="classlibMesh_1_1DistributedVector.php#a858c895cef9b6db82715e2ae2a25bd0b">_global_size</a>);
<a name="l00873"></a>00873   std::swap(_local_size, v.<a class="code" href="classlibMesh_1_1DistributedVector.php#ab41d83fa37a202ce344894b4af6c98c8">_local_size</a>);
<a name="l00874"></a>00874   std::swap(_first_local_index, v.<a class="code" href="classlibMesh_1_1DistributedVector.php#a394cccb8c5982fc003427b68b36ce68a">_first_local_index</a>);
<a name="l00875"></a>00875   std::swap(_last_local_index, v.<a class="code" href="classlibMesh_1_1DistributedVector.php#ae3bef136197973a856b46aa9d414bd1a">_last_local_index</a>);
<a name="l00876"></a>00876 
<a name="l00877"></a>00877   <span class="comment">// This should be O(1) with any reasonable STL implementation</span>
<a name="l00878"></a>00878   std::swap(_values, v.<a class="code" href="classlibMesh_1_1DistributedVector.php#a1074892adb5701b7c13614058356fc0a">_values</a>);
<a name="l00879"></a>00879 }
<a name="l00880"></a>00880 
<a name="l00881"></a>00881 } <span class="comment">// namespace libMesh</span>
<a name="l00882"></a>00882 
<a name="l00883"></a>00883 
<a name="l00884"></a>00884 <span class="preprocessor">#endif  // #ifdef __distributed_vector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
