<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">diva_io.C</div>  </div>
</div>
<div class="contents">
<a href="diva__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: diva_io.C 4313 2011-03-31 21:06:34Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="diva__io_8h.php">diva_io.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="boundary__mesh_8h.php">boundary_mesh.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// DivaIO class members</span>
<a name="l00036"></a><a class="code" href="classlibMesh_1_1DivaIO.php#ab0e952761220f84cd4acb8e67a2320fa">00036</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DivaIO.php#ab0e952761220f84cd4acb8e67a2320fa">DivaIO::write</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   <span class="comment">// We may need to gather a ParallelMesh to output it, making that</span>
<a name="l00039"></a>00039   <span class="comment">// const qualifier in our constructor a dirty lie</span>
<a name="l00040"></a>00040   MeshOutputSerializer serialize(const_cast&lt;MeshBase&amp;&gt;(this-&gt;<a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a>()), !<a class="code" href="classlibMesh_1_1MeshOutput.php#a0b28b0e8e7d99921d181c7c122384d0d">_is_parallel_format</a>);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">// Open the output file stream</span>
<a name="l00043"></a>00043   std::ofstream <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>(fname.c_str());
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="comment">// Make sure it opened correctly</span>
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>.good())
<a name="l00047"></a>00047     libmesh_file_error(fname.c_str());
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   this-&gt;<a class="code" href="classlibMesh_1_1DivaIO.php#a119914a0adb97110125f55fa1694441c">write_stream</a> (<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>);
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1DivaIO.php#a119914a0adb97110125f55fa1694441c">00055</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DivaIO.php#a119914a0adb97110125f55fa1694441c">DivaIO::write_stream</a> (std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <span class="comment">/*</span>
<a name="l00058"></a>00058 <span class="comment">    From Kelly: (kelly@tacc.utexas.edu)</span>
<a name="l00059"></a>00059 <span class="comment"></span>
<a name="l00060"></a>00060 <span class="comment">    Ok, the following is the format:</span>
<a name="l00061"></a>00061 <span class="comment"></span>
<a name="l00062"></a>00062 <span class="comment">    #points #triangles #quads #tets #prisms #pyramids #hexs</span>
<a name="l00063"></a>00063 <span class="comment">    loop over all points (written out x y z x y z ...)</span>
<a name="l00064"></a>00064 <span class="comment">    loop over all triangles (written out i1 i2 i3) (These are indices into</span>
<a name="l00065"></a>00065 <span class="comment">    the points going from</span>
<a name="l00066"></a>00066 <span class="comment">    1 to #points) </span>
<a name="l00067"></a>00067 <span class="comment">    loop over all quads (written out i1 i2 i3 i4) (Same numbering scheme)</span>
<a name="l00068"></a>00068 <span class="comment">    loop over all triangles and quads (write out b1) (This is a boundary</span>
<a name="l00069"></a>00069 <span class="comment">    condition for each</span>
<a name="l00070"></a>00070 <span class="comment">    triangle and each</span>
<a name="l00071"></a>00071 <span class="comment">    hex. You can put</span>
<a name="l00072"></a>00072 <span class="comment">    anything you want</span>
<a name="l00073"></a>00073 <span class="comment">    here)</span>
<a name="l00074"></a>00074 <span class="comment">    loop over all tets (written out i1 i2 i3 i4) (Same)</span>
<a name="l00075"></a>00075 <span class="comment">    loop over all pyramids (written out i1 i2 i3 i4 i5) (Same)</span>
<a name="l00076"></a>00076 <span class="comment">    loop over all prisms (written out i1 i2 i3 i4 i5 i6) (Same)</span>
<a name="l00077"></a>00077 <span class="comment">    loop over all hexs (written out i1 i2 i3 i4 i5 i6 i7 i8) (Same)</span>
<a name="l00078"></a>00078 <span class="comment">    </span>
<a name="l00079"></a>00079 <span class="comment">  */</span>
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// Be sure the stream has been created successfully.</span>
<a name="l00082"></a>00082   libmesh_assert (out.good());
<a name="l00083"></a>00083   
<a name="l00084"></a>00084   <span class="comment">// Can&#39;t use a constant mesh reference since we have to</span>
<a name="l00085"></a>00085   <span class="comment">// sync the boundary info.</span>
<a name="l00086"></a>00086   libmesh_here();
<a name="l00087"></a>00087   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING...  Sure you want to do this?&quot;</span>
<a name="l00088"></a>00088                 &lt;&lt; std::endl;
<a name="l00089"></a>00089   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a> = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;<span class="keyword">&gt;</span>
<a name="l00090"></a>00090     (<a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">MeshOutput&lt;MeshBase&gt;::mesh</a>());
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() &lt; 3)
<a name="l00093"></a>00093     {
<a name="l00094"></a>00094       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: DIVA only supports 3D meshes.\n\n&quot;</span>
<a name="l00095"></a>00095                     &lt;&lt; <span class="stringliteral">&quot;Exiting without producing output.\n&quot;</span>;
<a name="l00096"></a>00096       <span class="keywordflow">return</span>;
<a name="l00097"></a>00097     }
<a name="l00098"></a>00098   
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <a class="code" href="classlibMesh_1_1BoundaryMesh.php">BoundaryMesh</a> boundary_mesh (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>()-1);
<a name="l00102"></a>00102   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;sync(boundary_mesh);
<a name="l00103"></a>00103   
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00109"></a>00109     
<a name="l00110"></a>00110       &lt;&lt; (<a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(boundary_mesh,<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>) +
<a name="l00111"></a>00111           <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(boundary_mesh,<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>)*4) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00112"></a>00112     
<a name="l00113"></a>00113       &lt;&lt; (<a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(boundary_mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>) +
<a name="l00114"></a>00114           <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(boundary_mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>) +
<a name="l00115"></a>00115           <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(boundary_mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>)*4) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00116"></a>00116     
<a name="l00117"></a>00117       &lt;&lt; (<a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>) +
<a name="l00118"></a>00118           <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>)*8) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00119"></a>00119     
<a name="l00120"></a>00120       &lt;&lt; <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00121"></a>00121     
<a name="l00122"></a>00122       &lt;&lt; (<a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>) +
<a name="l00123"></a>00123           <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>)*8) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00124"></a>00124 
<a name="l00125"></a>00125       &lt;&lt; (<a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>)   +
<a name="l00126"></a>00126           <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>) +
<a name="l00127"></a>00127           <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a>(mesh, <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>)*8) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00128"></a>00128     
<a name="l00129"></a>00129       &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00130"></a>00130   
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   boundary_mesh.clear();
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   
<a name="l00138"></a>00138   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); v++)
<a name="l00139"></a>00139     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(v).<a class="code" href="classlibMesh_1_1TypeVector.php#ab06b207d152da2cdc8dbf147f01b97cf">write_unformatted</a>(out);
<a name="l00140"></a>00140   
<a name="l00141"></a>00141   
<a name="l00145"></a>00145   {
<a name="l00149"></a>00149     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(); e++)
<a name="l00150"></a>00150       <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00151"></a>00151         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00152"></a>00152           <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l00153"></a>00153             {
<a name="l00154"></a>00154               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00155"></a>00155 
<a name="l00156"></a>00156               <span class="keywordflow">if</span> (<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>)
<a name="l00157"></a>00157                 {
<a name="l00158"></a>00158                   out &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(0)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00159"></a>00159                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(1)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00160"></a>00160                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(2)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00161"></a>00161                 }
<a name="l00162"></a>00162               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>)
<a name="l00163"></a>00163                 {
<a name="l00164"></a>00164                   out &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(0)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00165"></a>00165                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(3)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00166"></a>00166                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(5)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00167"></a>00167 
<a name="l00168"></a>00168                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(3)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00169"></a>00169                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(1)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00170"></a>00170                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(4)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00171"></a>00171 
<a name="l00172"></a>00172                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(5)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00173"></a>00173                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(4)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00174"></a>00174                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(2)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00175"></a>00175 
<a name="l00176"></a>00176                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(3)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00177"></a>00177                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(4)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00178"></a>00178                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(5)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00179"></a>00179                 }
<a name="l00180"></a>00180             }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     
<a name="l00186"></a>00186     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(); e++)
<a name="l00187"></a>00187       <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00188"></a>00188         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00189"></a>00189           <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l00190"></a>00190             {
<a name="l00191"></a>00191               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00192"></a>00192 
<a name="l00193"></a>00193               <span class="keywordflow">if</span> ((<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>) ||
<a name="l00194"></a>00194                   (<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>)  )            
<a name="l00195"></a>00195                 {
<a name="l00196"></a>00196                   out &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(0)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00197"></a>00197                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(1)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00198"></a>00198                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(2)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00199"></a>00199                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(3)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00200"></a>00200                 }
<a name="l00201"></a>00201               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>)
<a name="l00202"></a>00202                 {
<a name="l00203"></a>00203                   out &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(0)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00204"></a>00204                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(4)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00205"></a>00205                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(8)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00206"></a>00206                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(7)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00207"></a>00207 
<a name="l00208"></a>00208                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(4)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00209"></a>00209                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(1)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00210"></a>00210                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(5)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00211"></a>00211                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(8)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00212"></a>00212 
<a name="l00213"></a>00213                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(7)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00214"></a>00214                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(8)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00215"></a>00215                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(6)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00216"></a>00216                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(3)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00217"></a>00217 
<a name="l00218"></a>00218                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(8)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00219"></a>00219                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(5)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00220"></a>00220                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(2)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00221"></a>00221                       &lt;&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(6)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00222"></a>00222                 }
<a name="l00223"></a>00223             }
<a name="l00224"></a>00224   }
<a name="l00225"></a>00225   
<a name="l00226"></a>00226           
<a name="l00227"></a>00227 
<a name="l00231"></a>00231   {
<a name="l00235"></a>00235     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(); e++)
<a name="l00236"></a>00236       <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00237"></a>00237         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00238"></a>00238           <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l00239"></a>00239             {
<a name="l00240"></a>00240               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00241"></a>00241               
<a name="l00242"></a>00242               <span class="keywordflow">if</span> ((<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>) ||
<a name="l00243"></a>00243                   (<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>)  )
<a name="l00244"></a>00244 
<a name="l00245"></a>00245                 out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_id(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e), s)
<a name="l00246"></a>00246                     &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00247"></a>00247             }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249     
<a name="l00253"></a>00253     <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(); e++)
<a name="l00254"></a>00254       <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00255"></a>00255         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00256"></a>00256           <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l00257"></a>00257             {
<a name="l00258"></a>00258               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00259"></a>00259               
<a name="l00260"></a>00260               <span class="keywordflow">if</span> ((<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>)  ||
<a name="l00261"></a>00261                   (<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>) ||
<a name="l00262"></a>00262                   (<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>)  )
<a name="l00263"></a>00263                 
<a name="l00264"></a>00264                 out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_id(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e), s);
<a name="l00265"></a>00265             }
<a name="l00266"></a>00266   }
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   
<a name="l00273"></a>00273   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(); e++)
<a name="l00274"></a>00274     <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00275"></a>00275       {
<a name="l00276"></a>00276         <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>)
<a name="l00277"></a>00277           {
<a name="l00278"></a>00278             out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00279"></a>00279                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00280"></a>00280                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00281"></a>00281                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00282"></a>00282           }
<a name="l00283"></a>00283         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>)
<a name="l00284"></a>00284           {
<a name="l00285"></a>00285             out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00286"></a>00286                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00287"></a>00287                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00288"></a>00288                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00289"></a>00289             
<a name="l00290"></a>00290             out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00291"></a>00291                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00292"></a>00292                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00293"></a>00293                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;     
<a name="l00294"></a>00294             
<a name="l00295"></a>00295           out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00296"></a>00296               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00297"></a>00297               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00298"></a>00298               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;       
<a name="l00299"></a>00299             
<a name="l00300"></a>00300           out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00301"></a>00301               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00302"></a>00302               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00303"></a>00303               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;       
<a name="l00304"></a>00304             
<a name="l00305"></a>00305           out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00306"></a>00306               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00307"></a>00307               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00308"></a>00308               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;       
<a name="l00309"></a>00309             
<a name="l00310"></a>00310           out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00311"></a>00311               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00312"></a>00312               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00313"></a>00313               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;       
<a name="l00314"></a>00314             
<a name="l00315"></a>00315           out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00316"></a>00316               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00317"></a>00317               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00318"></a>00318               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;       
<a name="l00319"></a>00319           
<a name="l00320"></a>00320           out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00321"></a>00321               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00322"></a>00322               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(9)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00323"></a>00323               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;       
<a name="l00324"></a>00324         }
<a name="l00325"></a>00325       }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00331"></a>00331   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(); e++)
<a name="l00332"></a>00332     <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00333"></a>00333       <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>)
<a name="l00334"></a>00334         {
<a name="l00335"></a>00335           out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00336"></a>00336               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00337"></a>00337               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00338"></a>00338               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00339"></a>00339               &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00340"></a>00340         }
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00347"></a>00347   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(); e++)
<a name="l00348"></a>00348     <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00349"></a>00349       {
<a name="l00350"></a>00350         <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>)
<a name="l00351"></a>00351           {
<a name="l00352"></a>00352             out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00353"></a>00353                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00354"></a>00354                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00355"></a>00355                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00356"></a>00356                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00357"></a>00357                 &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1 &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00358"></a>00358           }
<a name="l00359"></a>00359         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>)
<a name="l00360"></a>00360           {
<a name="l00361"></a>00361             libmesh_error();
<a name="l00362"></a>00362           }
<a name="l00363"></a>00363       }
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 
<a name="l00369"></a>00369   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(); e++)
<a name="l00370"></a>00370     <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00371"></a>00371       <span class="keywordflow">if</span> ((mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>)   ||
<a name="l00372"></a>00372           (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>) ||
<a name="l00373"></a>00373           (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>)   )
<a name="l00374"></a>00374         {
<a name="l00375"></a>00375           std::vector&lt;unsigned int&gt; conn;
<a name="l00376"></a>00376           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> se=0; se&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a958eb1740332cf7a0ca291dc335f9a47">n_sub_elem</a>(); se++)
<a name="l00377"></a>00377             {
<a name="l00378"></a>00378               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#abbf1e39b13aa0ee2e41169274d5ec717">connectivity</a>(se, <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>, conn);
<a name="l00379"></a>00379 
<a name="l00380"></a>00380               out &lt;&lt; conn[0] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00381"></a>00381                   &lt;&lt; conn[1] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00382"></a>00382                   &lt;&lt; conn[2] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00383"></a>00383                   &lt;&lt; conn[3] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00384"></a>00384                   &lt;&lt; conn[4] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00385"></a>00385                   &lt;&lt; conn[5] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00386"></a>00386                   &lt;&lt; conn[6] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00387"></a>00387                   &lt;&lt; conn[7] &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00388"></a>00388             }
<a name="l00389"></a>00389         }
<a name="l00390"></a>00390 }
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
