<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dof_map.h</div>  </div>
</div>
<div class="contents">
<a href="dof__map_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dof_map.h 4360 2011-04-19 07:23:18Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dof_map_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dof_map_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;iterator&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="enum__order_8h.php">enum_order.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span> <span class="comment">// libMesh::invalid_uint</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="variable_8h.php">variable.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="threads__allocators_8h.php">threads_allocators.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="elem__range_8h.php">elem_range.h</a>&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>libMesh
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// Forward Declarations</span>
<a name="l00046"></a>00046 <span class="keyword">class </span>CouplingMatrix;
<a name="l00047"></a>00047 <span class="keyword">class </span>DofMap;
<a name="l00048"></a>00048 <span class="keyword">class </span>DofObject;
<a name="l00049"></a>00049 <span class="keyword">class </span>Elem;
<a name="l00050"></a>00050 <span class="keyword">class </span>FEType;
<a name="l00051"></a>00051 <span class="keyword">class </span>MeshBase;
<a name="l00052"></a>00052 <span class="keyword">class </span>Mesh;
<a name="l00053"></a>00053 <span class="keyword">class </span>PeriodicBoundary;
<a name="l00054"></a>00054 <span class="keyword">class </span>PeriodicBoundaries;
<a name="l00055"></a><a class="code" href="namespacelibMesh_1_1SparsityPattern.php">00055</a> <span class="keyword">namespace </span>SparsityPattern { <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">Build</a>; }
<a name="l00056"></a>00056 <span class="keyword">class </span><a class="code" href="classlibMesh_1_1System.php">System</a>;
<a name="l00057"></a>00057 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseVectorBase.php">DenseVectorBase</a>;
<a name="l00058"></a>00058 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector</a>;
<a name="l00059"></a>00059 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix</a>;
<a name="l00060"></a>00060 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>;
<a name="l00061"></a><a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">00061</a> <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>;
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00066"></a>00066 <span class="comment">// AMR constraint matrix types</span>
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>
<a name="l00072"></a>00072 <span class="keyword">typedef</span> std::map&lt;<span class="keywordtype">unsigned</span> int, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>, 
<a name="l00073"></a>00073                  std::less&lt;unsigned int&gt;, 
<a name="l00074"></a>00074                  <a class="code" href="classlibMesh_1_1Threads_1_1scalable__allocator.php">Threads::scalable_allocator&lt;std::pair&lt;const unsigned int, Real&gt;</a> &gt; &gt; <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>;
<a name="l00075"></a>00075 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1DofConstraints.php">00082</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1map.php">map</a>&lt;unsigned int, 
<a name="l00083"></a>00083                                        DofConstraintRow, 
<a name="l00084"></a>00084                                        std::less&lt;unsigned int&gt;, 
<a name="l00085"></a>00085                                        Threads::scalable_allocator&lt;std::pair&lt;const unsigned int, DofConstraintRow&gt; &gt; &gt;
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087 };
<a name="l00088"></a>00088 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   
<a name="l00092"></a>00092 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00093"></a>00093 <span class="comment">// DofMap class definition</span>
<a name="l00094"></a>00094 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1DofMap.php">00104</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;DofMap&gt;
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106 <span class="keyword">public</span>:
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1DofMap.php#a6fe401e7df6dfc21a89c528cd52515ac">DofMap</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>);
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <a class="code" href="classlibMesh_1_1DofMap.php#addb6136725455c3a28e17193d3edf7ee">~DofMap</a>();
<a name="l00118"></a>00118 
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp; matrix);
<a name="l00125"></a>00125 
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ab986eb7bbf9bbb5119a49a145306a980">distribute_dofs</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;);
<a name="l00132"></a>00132 
<a name="l00138"></a>00138   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a49379ce3a542eab41a8f8e44d0f154c2">compute_sparsity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;);
<a name="l00139"></a>00139 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1DofMap.php#ae6d755f3a2b326ac76dc3a740396217d">00144</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae6d755f3a2b326ac76dc3a740396217d">attach_extra_send_list_function</a>(<span class="keywordtype">void</span> (*func)(std::vector&lt;unsigned int&gt; &amp;, <span class="keywordtype">void</span> *), <span class="keywordtype">void</span> * context = NULL)
<a name="l00145"></a>00145     { <a class="code" href="classlibMesh_1_1DofMap.php#ac9a00835345e2150e6699fe2073b2068">_extra_send_list_function</a> = func; <a class="code" href="classlibMesh_1_1DofMap.php#a6c450ba54bc8caffac28eed88a98a17d">_extra_send_list_context</a> = context; }
<a name="l00146"></a>00146 
<a name="l00152"></a>00152   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a47865aeb6379c68169e926dd0ecc2b71">prepare_send_list</a> ();
<a name="l00153"></a>00153   
<a name="l00161"></a><a class="code" href="classlibMesh_1_1DofMap.php#a4e0a6909796bc3c19ca543a182ffe224">00161</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a4e0a6909796bc3c19ca543a182ffe224">get_send_list</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>; }
<a name="l00162"></a>00162   
<a name="l00169"></a><a class="code" href="classlibMesh_1_1DofMap.php#aa29946f60cd67530a744a022478ec19f">00169</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#aa29946f60cd67530a744a022478ec19f">get_n_nz</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2f1f1ad0386f846409d903d5df18f114">_n_nz</a>; }
<a name="l00170"></a>00170   
<a name="l00177"></a><a class="code" href="classlibMesh_1_1DofMap.php#a0a809b27a371bf3dbae5241b485ef530">00177</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a0a809b27a371bf3dbae5241b485ef530">get_n_oz</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a0b3879c0bf8ae122f12710bc32f17810">_n_oz</a>; }
<a name="l00178"></a>00178 
<a name="l00183"></a>00183   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a99bd5717524ac8156554650eac8d2c60">add_variable</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp;var);
<a name="l00184"></a>00184   
<a name="l00188"></a>00188   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a>&amp; <a class="code" href="classlibMesh_1_1DofMap.php#ab36a0dc3c2c457fa8c01c1b0ba37facc">variable</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00189"></a>00189 
<a name="l00193"></a>00193   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1DofMap.php#a43aa131ac08b4b6aff6d865e672638da">variable_order</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00194"></a>00194   
<a name="l00198"></a>00198   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c) <span class="keyword">const</span>;
<a name="l00199"></a>00199   
<a name="l00205"></a><a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">00205</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#aee89c467613b296c215421d60d5ae961">n_variables</a>()<span class="keyword"> const</span>
<a name="l00206"></a>00206 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>.size(); }
<a name="l00207"></a>00207   
<a name="l00212"></a><a class="code" href="classlibMesh_1_1DofMap.php#ae014405975490bab74a4a7596c379990">00212</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae014405975490bab74a4a7596c379990">n_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a339dde44caf1af4d425d3830a20c7f54">_n_dfs</a>; }
<a name="l00216"></a><a class="code" href="classlibMesh_1_1DofMap.php#a2bb9dd194dc4de300fd315bd9edc92bd">00216</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2bb9dd194dc4de300fd315bd9edc92bd">n_SCALAR_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a>; }
<a name="l00217"></a>00217 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1DofMap.php#a0066097865af69c00a98148791480d5b">00221</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a0066097865af69c00a98148791480d5b">n_local_dofs</a> ()<span class="keyword"> const</span>
<a name="l00222"></a>00222 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1DofMap.php#a93892a922e17e271f635262a9c8acf98">n_dofs_on_processor</a> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); }
<a name="l00223"></a>00223 
<a name="l00227"></a><a class="code" href="classlibMesh_1_1DofMap.php#a93892a922e17e271f635262a9c8acf98">00227</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a93892a922e17e271f635262a9c8acf98">n_dofs_on_processor</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc)<span class="keyword"> const</span>
<a name="l00228"></a>00228 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>.size()); <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[proc] - <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>[proc]); }
<a name="l00229"></a>00229 
<a name="l00233"></a><a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">00233</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad2b15648e708f656a798bd642c3ca8e3">first_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00234"></a>00234 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>[proc]; }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>
<a name="l00240"></a><a class="code" href="classlibMesh_1_1DofMap.php#a57c76483c978870339e943a5973e254e">00240</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a57c76483c978870339e943a5973e254e">first_old_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00241"></a>00241 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">_first_old_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">_first_old_df</a>[proc]; }
<a name="l00242"></a>00242 <span class="preprocessor">#endif //LIBMESH_ENABLE_AMR</span>
<a name="l00243"></a>00243 <span class="preprocessor"></span>  
<a name="l00249"></a><a class="code" href="classlibMesh_1_1DofMap.php#a725dd59194b6a36156219e5357104bf5">00249</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a725dd59194b6a36156219e5357104bf5">last_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00250"></a>00250 <span class="keyword">  </span>{ libmesh_deprecated(); libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>.size()); <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[proc] - 1); }  
<a name="l00251"></a>00251 
<a name="l00256"></a><a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">00256</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#abf250ac3decfedbe00ddaeef85ed4de4">end_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00257"></a>00257 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>[proc]; }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span>
<a name="l00264"></a><a class="code" href="classlibMesh_1_1DofMap.php#af914825b77ed3620fc1e5b632d228400">00264</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#af914825b77ed3620fc1e5b632d228400">end_old_dof</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())<span class="keyword"> const</span>
<a name="l00265"></a>00265 <span class="keyword">  </span>{ libmesh_assert(proc &lt; <a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">_end_old_df</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">_end_old_df</a>[proc]; }
<a name="l00266"></a>00266 <span class="preprocessor">#endif //LIBMESH_ENABLE_AMR</span>
<a name="l00267"></a>00267 <span class="preprocessor"></span>  
<a name="l00271"></a><a class="code" href="classlibMesh_1_1DofMap.php#a1dc795b4576e48661fd850c8ed1b33f2">00271</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a1dc795b4576e48661fd850c8ed1b33f2">variable_first_local_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00272"></a>00272 <span class="keyword">  </span>{ 
<a name="l00273"></a>00273     libmesh_assert ((var+1) &lt; <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.size());
<a name="l00274"></a>00274     libmesh_assert (<a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>[var] != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00275"></a>00275     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>[var];
<a name="l00276"></a>00276   }
<a name="l00277"></a>00277 
<a name="l00282"></a><a class="code" href="classlibMesh_1_1DofMap.php#a27a81a53cc462042ab5fb7d355bc9427">00282</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a27a81a53cc462042ab5fb7d355bc9427">variable_last_local_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00283"></a>00283 <span class="keyword">  </span>{ 
<a name="l00284"></a>00284     libmesh_assert ((var+1) &lt; <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>.size());
<a name="l00285"></a>00285     libmesh_assert (<a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>[var+1] != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>);
<a name="l00286"></a>00286     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>[var+1];
<a name="l00287"></a>00287   }
<a name="l00288"></a>00288 
<a name="l00294"></a>00294   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00295"></a>00295                     std::vector&lt;unsigned int&gt;&amp; di,
<a name="l00296"></a>00296                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00297"></a>00297 
<a name="l00304"></a>00304   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#af9103a52e6edce2c9f4a3d8499b9aaa3">SCALAR_dof_indices</a> (std::vector&lt;unsigned int&gt;&amp; di,
<a name="l00305"></a>00305                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn,
<a name="l00306"></a>00306                            <span class="keyword">const</span> <span class="keywordtype">bool</span> old_dofs=<span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00307"></a>00307 
<a name="l00314"></a>00314   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#a6a93245255b86501e09ef377b73bf089">all_semilocal_indices</a> (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a>) <span class="keyword">const</span>;
<a name="l00315"></a>00315 
<a name="l00322"></a>00322   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2489e7c067abb05feba00459ac70a1ba">use_coupled_neighbor_dofs</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) <span class="keyword">const</span>;
<a name="l00323"></a>00323 
<a name="l00334"></a>00334   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aa026159e90f65d37c08345a86072994f">extract_local_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; Ug,
<a name="l00335"></a>00335                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a>,
<a name="l00336"></a>00336                              <a class="code" href="classlibMesh_1_1DenseVectorBase.php">DenseVectorBase&lt;Number&gt;</a>&amp; Ue) <span class="keyword">const</span>;
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00340"></a>00340 <span class="preprocessor"></span>
<a name="l00341"></a>00341   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00342"></a>00342   <span class="comment">// Constraint-specific methods</span>
<a name="l00347"></a><a class="code" href="classlibMesh_1_1DofMap.php#a89d713b396dfc8dd883078c278a5b6d1">00347</a> <span class="comment"></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a89d713b396dfc8dd883078c278a5b6d1">n_constrained_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.size(); }
<a name="l00348"></a>00348 
<a name="l00352"></a>00352   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a4dc67be5bbecf0e4947d790f6653e2d5">create_dof_constraints</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00353"></a>00353 
<a name="l00357"></a>00357   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2a73dfbc22045908ef2acf9045c7790f">allgather_recursive_constraints</a> ();
<a name="l00358"></a>00358 
<a name="l00366"></a>00366   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad48c72b8add66781d21ad77a3febe59d">process_constraints</a> ();
<a name="l00367"></a>00367 
<a name="l00372"></a>00372   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ab49ad674c1ea5fd71d968d84db954739">add_constraint_row</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_number,
<a name="l00373"></a>00373                            <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row,
<a name="l00374"></a>00374                            <span class="keyword">const</span> <span class="keywordtype">bool</span> forbid_constraint_overwrite = <span class="keyword">true</span>);
<a name="l00375"></a>00375 
<a name="l00379"></a><a class="code" href="classlibMesh_1_1DofMap.php#ac72b84326e15a8e0b57c739f3b7c5a30">00379</a>   DofConstraints::const_iterator <a class="code" href="classlibMesh_1_1DofMap.php#ac72b84326e15a8e0b57c739f3b7c5a30">constraint_rows_begin</a>()<span class="keyword"> const</span>
<a name="l00380"></a>00380 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.begin(); }
<a name="l00381"></a>00381   
<a name="l00385"></a><a class="code" href="classlibMesh_1_1DofMap.php#a5d8722d80a7bbdc6e4c3873c03d0e237">00385</a>   DofConstraints::const_iterator <a class="code" href="classlibMesh_1_1DofMap.php#a5d8722d80a7bbdc6e4c3873c03d0e237">constraint_rows_end</a>()<span class="keyword"> const</span>
<a name="l00386"></a>00386 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.end(); }
<a name="l00387"></a>00387   
<a name="l00392"></a>00392   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">is_constrained_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof) <span class="keyword">const</span>;
<a name="l00393"></a>00393   
<a name="l00397"></a>00397   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a9c8aef879917dfdd8a9309b7e29ed9d3">print_dof_constraints</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00398"></a>00398 
<a name="l00407"></a>00407   std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a8d3c9a10b0a20e889cb9c781219ef29d">max_constraint_error</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system,
<a name="l00408"></a>00408                                              <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v = NULL) <span class="keyword">const</span>;
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l00411"></a>00411 <span class="preprocessor"></span>
<a name="l00412"></a>00412   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00413"></a>00413   <span class="comment">// Constraint-specific methods</span>
<a name="l00414"></a>00414   <span class="comment">// Some of these methods are enabled (but inlined away to nothing)</span>
<a name="l00415"></a>00415   <span class="comment">// when constraints are disabled at configure-time.  This is to</span>
<a name="l00416"></a>00416   <span class="comment">// increase API compatibility of user code with different library</span>
<a name="l00417"></a>00417   <span class="comment">// builds.</span>
<a name="l00418"></a>00418 
<a name="l00432"></a>00432   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">constrain_element_matrix</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00433"></a>00433                                  std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00434"></a>00434                                  <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00435"></a>00435   
<a name="l00442"></a>00442   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">constrain_element_matrix</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00443"></a>00443                                  std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00444"></a>00444                                  std::vector&lt;unsigned int&gt;&amp; col_dofs,
<a name="l00445"></a>00445                                  <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00446"></a>00446   
<a name="l00450"></a>00450   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">constrain_element_vector</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp;       rhs,
<a name="l00451"></a>00451                                  std::vector&lt;unsigned int&gt;&amp; dofs,
<a name="l00452"></a>00452                                  <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00453"></a>00453   
<a name="l00462"></a>00462   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00463"></a>00463                                             <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; rhs,
<a name="l00464"></a>00464                                             std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00465"></a>00465                                             <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00466"></a>00466 
<a name="l00475"></a>00475   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae5ccc5717b8c3a94629a306ebd4e1f17">constrain_element_dyad_matrix</a> (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; v,
<a name="l00476"></a>00476                                       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; w,
<a name="l00477"></a>00477                                       std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00478"></a>00478                                       <span class="keywordtype">bool</span> asymmetric_constraint_rows = <span class="keyword">true</span>) <span class="keyword">const</span>;
<a name="l00479"></a>00479 
<a name="l00486"></a>00486   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a435e93c5a2f7bc911a62886eaddab082">constrain_nothing</a> (std::vector&lt;unsigned int&gt;&amp; dofs) <span class="keyword">const</span>;
<a name="l00487"></a>00487   
<a name="l00496"></a>00496   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system,
<a name="l00497"></a>00497                                     <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v = NULL) <span class="keyword">const</span>;
<a name="l00498"></a>00498   
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00501"></a>00501 <span class="preprocessor"></span>
<a name="l00502"></a>00502   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00503"></a>00503   <span class="comment">// PeriodicBoundary-specific methods</span>
<a name="l00504"></a>00504 
<a name="l00508"></a>00508   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2f0a90f17fba3db87f78f8813e111ac2">add_periodic_boundary</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a>&amp; periodic_boundary);
<a name="l00509"></a>00509 
<a name="l00516"></a>00516   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a2f0a90f17fba3db87f78f8813e111ac2">add_periodic_boundary</a> (<a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> * boundary, <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> * inverse_boundary);
<a name="l00517"></a>00517 
<a name="l00522"></a>00522   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#a342c83f2e41c2ea88ff60644aa7f90f2">is_periodic_boundary</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundaryid) <span class="keyword">const</span>;
<a name="l00523"></a>00523 
<a name="l00524"></a><a class="code" href="classlibMesh_1_1DofMap.php#ad8fbe12a80566efce1259ea93601dc2a">00524</a>   <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> * <a class="code" href="classlibMesh_1_1DofMap.php#ad8fbe12a80566efce1259ea93601dc2a">get_periodic_boundaries</a>()
<a name="l00525"></a>00525     {
<a name="l00526"></a>00526       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#aa6cb04933a25a9b2a296e333a7ce3554">_periodic_boundaries</a>;
<a name="l00527"></a>00527     }
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l00530"></a>00530 <span class="preprocessor"></span>
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00533"></a>00533 <span class="preprocessor"></span>
<a name="l00534"></a>00534   <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00535"></a>00535   <span class="comment">// AMR-specific methods</span>
<a name="l00536"></a>00536 
<a name="l00545"></a>00545   <span class="comment">// void augment_send_list_for_projection(const MeshBase &amp;);</span>
<a name="l00546"></a>00546 
<a name="l00553"></a>00553   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae260ebddbb3c10a932ab9e16baa5bbb3">old_dof_indices</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00554"></a>00554                         std::vector&lt;unsigned int&gt;&amp; di,
<a name="l00555"></a>00555                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00560"></a><a class="code" href="classlibMesh_1_1DofMap.php#aff4c82b145509c7cd1b60606fa10af1d">00560</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#aff4c82b145509c7cd1b60606fa10af1d">n_old_dofs</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5e406923a04ca8cce5a0a73ebedaaa36">_n_old_dfs</a>; }
<a name="l00561"></a>00561 
<a name="l00567"></a>00567   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a1c8e17a57f38de4ae0060311b5497989">constrain_p_dofs</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00568"></a>00568                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem,
<a name="l00569"></a>00569                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00570"></a>00570                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00571"></a>00571   
<a name="l00572"></a>00572 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00573"></a>00573 <span class="preprocessor"></span>
<a name="l00577"></a>00577   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#abf4ed8e608b51a7a4e95935bf42ebbb1">reinit</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00578"></a>00578   
<a name="l00582"></a>00582   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a480f80bc9234a5586711833b87a89784">clear</a> ();
<a name="l00583"></a>00583   
<a name="l00587"></a>00587   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a0b01b32e3e5a146cbda0a64e9e39f451">print_info</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00588"></a>00588 
<a name="l00592"></a>00592   std::string <a class="code" href="classlibMesh_1_1DofMap.php#a4e4f1eeb9c6c7a7196d96d969bfb0e32">get_info</a>() <span class="keyword">const</span>;
<a name="l00593"></a>00593 
<a name="l00607"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab276e172c5488ab3b387b235e28556cf">00607</a>   <a class="code" href="classlibMesh_1_1CouplingMatrix.php">CouplingMatrix</a>* <a class="code" href="classlibMesh_1_1DofMap.php#ab276e172c5488ab3b387b235e28556cf">_dof_coupling</a>;
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   
<a name="l00610"></a>00610 <span class="keyword">private</span>:
<a name="l00611"></a>00611   
<a name="l00615"></a>00615   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">sys_number</a>() <span class="keyword">const</span>;
<a name="l00616"></a>00616 
<a name="l00620"></a>00620   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a9cbe9d7dc9f93f266817f997562bfa7c">invalidate_dofs</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) <span class="keyword">const</span>;
<a name="l00621"></a>00621 
<a name="l00625"></a>00625   <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>* <a class="code" href="classlibMesh_1_1DofMap.php#ab67f7b5505959af29c3aac5bbbb9e9d2">node_ptr</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00626"></a>00626 
<a name="l00630"></a>00630   <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>* <a class="code" href="classlibMesh_1_1DofMap.php#ab6e5067ba73e4228bbd01956805af660">elem_ptr</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00631"></a>00631 
<a name="l00635"></a>00635   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>* (<a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>::*<a class="code" href="classlibMesh_1_1DofMap.php#aaca0bd6cd27307340542eb58fe3de279">dofobject_accessor</a>)
<a name="l00636"></a><a class="code" href="classlibMesh_1_1DofMap.php#aaca0bd6cd27307340542eb58fe3de279">00636</a>     (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00637"></a>00637   
<a name="l00641"></a>00641   <span class="keyword">template</span>&lt;<span class="keyword">typename</span> iterator_type&gt;
<a name="l00642"></a>00642   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aafa42683c20195adafb582225eefd91c">set_nonlocal_dof_objects</a>(iterator_type objects_begin,
<a name="l00643"></a>00643                                 iterator_type objects_end,
<a name="l00644"></a>00644                                 <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00645"></a>00645                                 <a class="code" href="classlibMesh_1_1DofMap.php#aaca0bd6cd27307340542eb58fe3de279">dofobject_accessor</a> objects);
<a name="l00646"></a>00646 
<a name="l00655"></a>00655   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a55f4e20c43c4d9b726702ece1c6b9cdc">distribute_local_dofs_var_major</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; next_free_dof,
<a name="l00656"></a>00656                                         <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00657"></a>00657   
<a name="l00670"></a>00670   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ad4cb3d7c654bb942da7a99c5fc645a66">distribute_local_dofs_node_major</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; next_free_dof,
<a name="l00671"></a>00671                                          <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00672"></a>00672     
<a name="l00677"></a>00677   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aed8eba054300e64164af4a8257bae8d8">add_neighbors_to_send_list</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00678"></a>00678 
<a name="l00679"></a>00679 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00680"></a>00680 <span class="preprocessor"></span>
<a name="l00691"></a>00691   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ab205c45f9397a3864d915a4bc558acbf">build_constraint_matrix</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; C,
<a name="l00692"></a>00692                                 std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00693"></a>00693                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> called_recursively=<span class="keyword">false</span>) <span class="keyword">const</span>;
<a name="l00694"></a>00694 
<a name="l00699"></a>00699   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#aeb1398dca8edb951fbd22762fedd0500">find_connected_dofs</a> (std::vector&lt;unsigned int&gt; &amp;elem_dofs) <span class="keyword">const</span>;
<a name="l00700"></a>00700   
<a name="l00706"></a>00706   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a0783b9a05a297be8f1c3e630301e0604">add_constraints_to_send_list</a>();
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 <span class="preprocessor">#endif</span>
<a name="l00709"></a>00709 <span class="preprocessor"></span>
<a name="l00710"></a>00710 
<a name="l00714"></a><a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">00714</a>   std::vector&lt;Variable&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a5232a8054e580a408f394ba1574c63df">_variables</a>;
<a name="l00715"></a>00715 
<a name="l00719"></a><a class="code" href="classlibMesh_1_1DofMap.php#a32b9faf7127f48555386705a952460d6">00719</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a32b9faf7127f48555386705a952460d6">_sys_number</a>;
<a name="l00720"></a>00720   
<a name="l00726"></a><a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">00726</a>   std::vector&lt;SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1DofMap.php#a29ff2098ced1859cd5296af428435d73">_matrices</a>;
<a name="l00727"></a>00727   
<a name="l00731"></a><a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">00731</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a6a2cc4429bc1f9ec22b85dedbee55d96">_first_df</a>;
<a name="l00732"></a>00732 
<a name="l00736"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">00736</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#ab03f023f66c9d64feddada936ae18750">_end_df</a>;
<a name="l00737"></a>00737 
<a name="l00741"></a><a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">00741</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#ac2cd47f78f1cf8bbdba640f56ef96afa">_var_first_local_df</a>;
<a name="l00742"></a>00742   
<a name="l00747"></a><a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">00747</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a66d63042b6f4dce2ef98a1573ff6b2ad">_send_list</a>;
<a name="l00748"></a>00748 
<a name="l00752"></a><a class="code" href="classlibMesh_1_1DofMap.php#ac9a00835345e2150e6699fe2073b2068">00752</a>   void (*<a class="code" href="classlibMesh_1_1DofMap.php#ac9a00835345e2150e6699fe2073b2068">_extra_send_list_function</a>)(std::vector&lt;unsigned int&gt; &amp;, <span class="keywordtype">void</span> *);
<a name="l00753"></a>00753 
<a name="l00757"></a><a class="code" href="classlibMesh_1_1DofMap.php#a6c450ba54bc8caffac28eed88a98a17d">00757</a>   <span class="keywordtype">void</span> * <a class="code" href="classlibMesh_1_1DofMap.php#a6c450ba54bc8caffac28eed88a98a17d">_extra_send_list_context</a>;
<a name="l00758"></a>00758 
<a name="l00763"></a><a class="code" href="classlibMesh_1_1DofMap.php#a2f1f1ad0386f846409d903d5df18f114">00763</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a2f1f1ad0386f846409d903d5df18f114">_n_nz</a>;
<a name="l00764"></a>00764   
<a name="l00769"></a><a class="code" href="classlibMesh_1_1DofMap.php#a0b3879c0bf8ae122f12710bc32f17810">00769</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a0b3879c0bf8ae122f12710bc32f17810">_n_oz</a>;
<a name="l00770"></a>00770 
<a name="l00774"></a><a class="code" href="classlibMesh_1_1DofMap.php#a339dde44caf1af4d425d3830a20c7f54">00774</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a339dde44caf1af4d425d3830a20c7f54">_n_dfs</a>;
<a name="l00775"></a>00775 
<a name="l00780"></a><a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">00780</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae4795cf1e08ba233dec67fe06b36873b">_n_SCALAR_dofs</a>;
<a name="l00781"></a>00781 
<a name="l00782"></a>00782 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00783"></a>00783 <span class="preprocessor"></span>
<a name="l00787"></a><a class="code" href="classlibMesh_1_1DofMap.php#a5e406923a04ca8cce5a0a73ebedaaa36">00787</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a5e406923a04ca8cce5a0a73ebedaaa36">_n_old_dfs</a>;
<a name="l00788"></a>00788 
<a name="l00792"></a><a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">00792</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#abe4f7d1a32937bce6c6d8fc8b32ce0a2">_first_old_df</a>;
<a name="l00793"></a>00793 
<a name="l00797"></a><a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">00797</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1DofMap.php#a5c01318c85ebe04282bdaf8dff4e3528">_end_old_df</a>;
<a name="l00798"></a>00798 
<a name="l00799"></a>00799 <span class="preprocessor">#endif</span>
<a name="l00800"></a>00800 <span class="preprocessor"></span>
<a name="l00801"></a>00801 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00802"></a>00802 <span class="preprocessor"></span>
<a name="l00807"></a><a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">00807</a>   <a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> <a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>;
<a name="l00808"></a>00808 
<a name="l00809"></a>00809 <span class="preprocessor">#endif</span>
<a name="l00810"></a>00810 <span class="preprocessor"></span>
<a name="l00811"></a>00811 
<a name="l00812"></a>00812 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00813"></a>00813 <span class="preprocessor"></span>
<a name="l00817"></a><a class="code" href="classlibMesh_1_1DofMap.php#aa6cb04933a25a9b2a296e333a7ce3554">00817</a>   <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> *<a class="code" href="classlibMesh_1_1DofMap.php#aa6cb04933a25a9b2a296e333a7ce3554">_periodic_boundaries</a>;
<a name="l00818"></a>00818 <span class="preprocessor">#endif</span>
<a name="l00819"></a>00819 <span class="preprocessor"></span>
<a name="l00820"></a><a class="code" href="classlibMesh_1_1DofMap.php#a298e05b1935249e7045795d918f46d70">00820</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1SparsityPattern_1_1Build.php">SparsityPattern::Build</a>;
<a name="l00821"></a>00821 };
<a name="l00822"></a>00822 
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00825"></a>00825 <span class="comment">// Dof Map inline member functions</span>
<a name="l00826"></a>00826 
<a name="l00827"></a>00827 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00828"></a>00828 <span class="preprocessor"></span>
<a name="l00829"></a>00829 <span class="keyword">inline</span>
<a name="l00830"></a><a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">00830</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofMap.php#af59487b50683e231676f836f94cde1ab">DofMap::is_constrained_dof</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof)<span class="keyword"> const</span>
<a name="l00831"></a>00831 <span class="keyword"></span>{
<a name="l00832"></a>00832   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DofMap.php#af7fe4d0cf13618e6dd04ff22fdaca0ba">_dof_constraints</a>.count(dof) != 0)
<a name="l00833"></a>00833     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00834"></a>00834 
<a name="l00835"></a>00835   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00836"></a>00836 }
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 <span class="preprocessor">#endif</span>
<a name="l00839"></a>00839 <span class="preprocessor"></span>
<a name="l00840"></a>00840 
<a name="l00841"></a>00841 <span class="keyword">inline</span>
<a name="l00842"></a><a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">00842</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofMap.php#a244e7a1cd82d5e6ae8780c93205ec1fa">DofMap::sys_number</a>()<span class="keyword"> const</span>
<a name="l00843"></a>00843 <span class="keyword"></span>{
<a name="l00844"></a>00844   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofMap.php#a32b9faf7127f48555386705a952460d6">_sys_number</a>;
<a name="l00845"></a>00845 }
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 
<a name="l00848"></a>00848 <span class="preprocessor">#if !defined(LIBMESH_ENABLE_AMR) &amp;&amp; !defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00849"></a>00849 <span class="preprocessor"></span>  <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00850"></a>00850   <span class="comment">// Constraint-specific methods get inlined into nothing if</span>
<a name="l00851"></a>00851   <span class="comment">// constraints are disabled, so there&#39;s no reason for users not to </span>
<a name="l00852"></a>00852   <span class="comment">// use them.</span>
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">DofMap::constrain_element_matrix</a> (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp;,
<a name="l00855"></a>00855                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l00856"></a>00856                                               <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00857"></a>00857   
<a name="l00858"></a>00858 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">DofMap::constrain_element_matrix</a> (DenseMatrix&lt;Number&gt;&amp;,
<a name="l00859"></a>00859                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l00860"></a>00860                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l00861"></a>00861                                               <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00862"></a>00862   
<a name="l00863"></a>00863 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">DofMap::constrain_element_vector</a> (DenseVector&lt;Number&gt;&amp;,
<a name="l00864"></a>00864                                               std::vector&lt;unsigned int&gt;&amp;,
<a name="l00865"></a>00865                                               <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00866"></a>00866   
<a name="l00867"></a>00867 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">DofMap::constrain_element_matrix_and_vector</a> (DenseMatrix&lt;Number&gt;&amp;,
<a name="l00868"></a>00868                                                          DenseVector&lt;Number&gt;&amp;,
<a name="l00869"></a>00869                                                          std::vector&lt;unsigned int&gt;&amp;,
<a name="l00870"></a>00870                                                          <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#ae5ccc5717b8c3a94629a306ebd4e1f17">DofMap::constrain_element_dyad_matrix</a> (DenseVector&lt;Number&gt;&amp;,
<a name="l00873"></a>00873                                                    DenseVector&lt;Number&gt;&amp;,
<a name="l00874"></a>00874                                                    std::vector&lt;unsigned int&gt;&amp;,
<a name="l00875"></a>00875                                                    <span class="keywordtype">bool</span>)<span class="keyword"> const </span>{}
<a name="l00876"></a>00876 
<a name="l00877"></a>00877 <span class="keyword">inline</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">DofMap::enforce_constraints_exactly</a> (<span class="keyword">const</span> System &amp;,
<a name="l00878"></a>00878                                                  NumericVector&lt;Number&gt; *)<span class="keyword"> const </span>{}
<a name="l00879"></a>00879 
<a name="l00880"></a>00880 <span class="preprocessor">#endif // !defined(LIBMESH_ENABLE_AMR) &amp;&amp; !defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00881"></a>00881 <span class="preprocessor"></span>
<a name="l00882"></a>00882 } <span class="comment">// namespace libMesh</span>
<a name="l00883"></a>00883 
<a name="l00884"></a>00884 <span class="preprocessor">#endif // __dof_map_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
