<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5459648d2d7c2fd1db7d167825a0dd64.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dof_map_constraints.C</div>  </div>
</div>
<div class="contents">
<a href="dof__map__constraints_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dof_map_constraints.C 4402 2011-04-22 23:10:19Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ Includes -------------------------------------</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::count, std::fill</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span> <span class="comment">// needed by enforce_constraints_exactly()</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span> <span class="comment">// likewise</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="periodic__boundaries_8h.php">periodic_boundaries.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__base_8h.php">point_locator_base.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="elem__range_8h.php">elem_range.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// Anonymous namespace to hold helper classes</span>
<a name="l00044"></a>00044 <span class="keyword">namespace </span>{
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">using namespace </span>libMesh;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keyword">class </span>ComputeConstraints
<a name="l00049"></a>00049   {
<a name="l00050"></a>00050   <span class="keyword">public</span>:
<a name="l00051"></a>00051     ComputeConstraints (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00052"></a>00052                         <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00053"></a>00053 #ifdef LIBMESH_ENABLE_PERIODIC
<a name="l00054"></a>00054                         <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> &amp;periodic_boundaries,
<a name="l00055"></a>00055 #endif
<a name="l00056"></a>00056                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00057"></a>00057                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number) :
<a name="l00058"></a>00058       _constraints(constraints),
<a name="l00059"></a>00059       _dof_map(dof_map),
<a name="l00060"></a>00060 #ifdef LIBMESH_ENABLE_PERIODIC
<a name="l00061"></a>00061       _periodic_boundaries(periodic_boundaries),
<a name="l00062"></a>00062 #endif
<a name="l00063"></a>00063       _mesh(mesh),
<a name="l00064"></a>00064       _variable_number(variable_number)
<a name="l00065"></a>00065     {}
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <span class="keywordtype">void</span> operator()(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range)<span class="keyword"> const</span>
<a name="l00068"></a>00068 <span class="keyword">    </span>{
<a name="l00069"></a>00069       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp;var_description = _dof_map.variable(_variable_number);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> point_locator;
<a name="l00073"></a>00073       <span class="keywordtype">bool</span> have_periodic_boundaries = !_periodic_boundaries.empty();
<a name="l00074"></a>00074       <span class="keywordflow">if</span> (have_periodic_boundaries)
<a name="l00075"></a>00075         point_locator = _mesh.sub_point_locator();
<a name="l00076"></a>00076 <span class="preprocessor">#endif</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> it = range.<a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a>(); it!=range.<a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a>(); ++it)
<a name="l00079"></a>00079         <span class="keywordflow">if</span> (var_description.<a class="code" href="classlibMesh_1_1Variable.php#a94ff035823801db20635514405af60be">active_on_subdomain</a>((*it)-&gt;subdomain_id()))
<a name="l00080"></a>00080           {
<a name="l00081"></a>00081 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>            FEInterface::compute_constraints (_constraints,
<a name="l00083"></a>00083                                               _dof_map,
<a name="l00084"></a>00084                                               _variable_number,
<a name="l00085"></a>00085                                               *it);
<a name="l00086"></a>00086 <span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span><span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>            <span class="comment">// FIXME: periodic constraints won&#39;t work on a non-serial</span>
<a name="l00089"></a>00089             <span class="comment">// mesh unless it&#39;s kept ghost elements from opposing</span>
<a name="l00090"></a>00090             <span class="comment">// boundaries!</span>
<a name="l00091"></a>00091             <span class="keywordflow">if</span> (have_periodic_boundaries)
<a name="l00092"></a>00092               FEInterface::compute_periodic_constraints (_constraints,
<a name="l00093"></a>00093                                                          _dof_map,
<a name="l00094"></a>00094                                                          _periodic_boundaries,
<a name="l00095"></a>00095                                                          _mesh,
<a name="l00096"></a>00096                                                          point_locator.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>(),
<a name="l00097"></a>00097                                                          _variable_number,
<a name="l00098"></a>00098                                                          *it);
<a name="l00099"></a>00099 <span class="preprocessor">#endif</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>          }
<a name="l00101"></a>00101     }
<a name="l00102"></a>00102     
<a name="l00103"></a>00103   <span class="keyword">private</span>:
<a name="l00104"></a>00104     <a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;_constraints;
<a name="l00105"></a>00105     <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;_dof_map;
<a name="l00106"></a>00106 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span>    <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> &amp;_periodic_boundaries;
<a name="l00108"></a>00108 <span class="preprocessor">#endif</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span>    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;_mesh;
<a name="l00110"></a>00110     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _variable_number;    
<a name="l00111"></a>00111   };
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">namespace </span>libMesh
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00120"></a>00120 <span class="comment">// DofMap member functions</span>
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="preprocessor">#if defined(LIBMESH_ENABLE_AMR) || defined(LIBMESH_ENABLE_PERIODIC)</span>
<a name="l00123"></a>00123 <span class="preprocessor"></span>
<a name="l00124"></a><a class="code" href="classlibMesh_1_1DofMap.php#a4dc67be5bbecf0e4947d790f6653e2d5">00124</a> <span class="keywordtype">void</span> DofMap::create_dof_constraints(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126   START_LOG(<span class="stringliteral">&quot;create_dof_constraints()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aef78858f228f672f3587b19c2bbd5fce">is_prepared</a>());
<a name="l00129"></a>00129   
<a name="l00130"></a>00130   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// Constraints are not necessary in 1D</span>
<a name="l00133"></a>00133   <span class="keywordflow">if</span> (dim == 1)
<a name="l00134"></a>00134   {
<a name="l00135"></a>00135     <span class="comment">// make sure we stop logging though</span>
<a name="l00136"></a>00136     STOP_LOG(<span class="stringliteral">&quot;create_dof_constraints()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00137"></a>00137     <span class="keywordflow">return</span>;
<a name="l00138"></a>00138   }
<a name="l00139"></a>00139   
<a name="l00140"></a>00140   <span class="comment">// Here we build the hanging node constraints.  This is done</span>
<a name="l00141"></a>00141   <span class="comment">// by enforcing the condition u_a = u_b along hanging sides.</span>
<a name="l00142"></a>00142   <span class="comment">// u_a = u_b is collocated at the nodes of side a, which gives</span>
<a name="l00143"></a>00143   <span class="comment">// one row of the constraint matrix.</span>
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   <span class="comment">// clear any existing constraints.</span>
<a name="l00146"></a>00146   _dof_constraints.clear();
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="comment">// define the range of elements of interest</span>
<a name="l00149"></a>00149   <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> range;
<a name="l00150"></a>00150   {
<a name="l00151"></a>00151     <span class="comment">// With SerialMesh or a serial ParallelMesh, every processor</span>
<a name="l00152"></a>00152     <span class="comment">// computes every constraint</span>
<a name="l00153"></a>00153     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l00154"></a>00154       elem_begin = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(),
<a name="l00155"></a>00155       elem_end   = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00156"></a>00156     
<a name="l00157"></a>00157     <span class="comment">// With a parallel ParallelMesh, processors compute only</span>
<a name="l00158"></a>00158     <span class="comment">// their local constraints</span>
<a name="l00159"></a>00159     <span class="keywordflow">if</span> (!mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00160"></a>00160       {
<a name="l00161"></a>00161         elem_begin = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5b67c2aa94e76310a6db3470cce8ef11">local_elements_begin</a>();
<a name="l00162"></a>00162         elem_end   = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab8bd839216a1ef9c0912d523b68ae136">local_elements_end</a>(); 
<a name="l00163"></a>00163       }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165     <span class="comment">// set the range to contain the specified elements</span>
<a name="l00166"></a>00166     range.<a class="code" href="classlibMesh_1_1StoredRange.php#a6769bcd5b501cb9a10cdbc85c64a2e72">reset</a> (elem_begin, elem_end);
<a name="l00167"></a>00167   }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="comment">// compute_periodic_constraints requires a point_locator() from our</span>
<a name="l00170"></a>00170   <span class="comment">// Mesh, that point_locator() construction is threaded.  Rather than</span>
<a name="l00171"></a>00171   <span class="comment">// nest threads within threads we&#39;ll make sure it&#39;s preconstructed.</span>
<a name="l00172"></a>00172 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!_periodic_boundaries-&gt;empty())
<a name="l00174"></a>00174     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a122877d5316f9035967c6ed10d86a520">point_locator</a>();
<a name="l00175"></a>00175 <span class="preprocessor">#endif</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>  
<a name="l00177"></a>00177   <span class="comment">// Look at all the variables in the system.  Reset the element</span>
<a name="l00178"></a>00178   <span class="comment">// range at each iteration -- there is no need to reconstruct it.</span>
<a name="l00179"></a>00179   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number=0; variable_number&lt;this-&gt;n_variables();
<a name="l00180"></a>00180        ++variable_number, range.<a class="code" href="classlibMesh_1_1StoredRange.php#a6769bcd5b501cb9a10cdbc85c64a2e72">reset</a>())
<a name="l00181"></a>00181     <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">Threads::parallel_for</a> (range,
<a name="l00182"></a>00182                            ComputeConstraints (_dof_constraints,
<a name="l00183"></a>00183                                                *<span class="keyword">this</span>,
<a name="l00184"></a>00184 #ifdef LIBMESH_ENABLE_PERIODIC
<a name="l00185"></a>00185                                                *_periodic_boundaries,
<a name="l00186"></a>00186 #endif
<a name="l00187"></a>00187                                                mesh,
<a name="l00188"></a>00188                                                variable_number));
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">// With a parallelized Mesh, we&#39;ve computed our local constraints,</span>
<a name="l00191"></a>00191   <span class="comment">// but they may depend on non-local constraints that we&#39;ll need to</span>
<a name="l00192"></a>00192   <span class="comment">// take into account.</span>
<a name="l00193"></a>00193   <span class="keywordflow">if</span> (!mesh.is_serial())
<a name="l00194"></a>00194     this-&gt;allgather_recursive_constraints();
<a name="l00195"></a>00195   
<a name="l00196"></a>00196   STOP_LOG(<span class="stringliteral">&quot;create_dof_constraints()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab49ad674c1ea5fd71d968d84db954739">00201</a> <span class="keywordtype">void</span> DofMap::add_constraint_row (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_number,
<a name="l00202"></a>00202                                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row,
<a name="l00203"></a>00203                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> forbid_constraint_overwrite)
<a name="l00204"></a>00204 {
<a name="l00205"></a>00205   <span class="comment">// Optionally allow the user to overwrite constraints.  Defaults to false.</span>
<a name="l00206"></a>00206   <span class="keywordflow">if</span> (forbid_constraint_overwrite)
<a name="l00207"></a>00207     <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(dof_number))
<a name="l00208"></a>00208       {
<a name="l00209"></a>00209         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: DOF &quot;</span> &lt;&lt; dof_number &lt;&lt; <span class="stringliteral">&quot; was already constrained!&quot;</span>
<a name="l00210"></a>00210                       &lt;&lt; std::endl;
<a name="l00211"></a>00211         libmesh_error();
<a name="l00212"></a>00212       }
<a name="l00213"></a>00213   
<a name="l00214"></a>00214   std::pair&lt;unsigned int, DofConstraintRow&gt; kv(dof_number, constraint_row);
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   _dof_constraints.insert(kv);
<a name="l00217"></a>00217 }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1DofMap.php#a9c8aef879917dfdd8a9309b7e29ed9d3">00221</a> <span class="keywordtype">void</span> DofMap::print_dof_constraints(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00222"></a>00222 <span class="keyword"></span>{
<a name="l00223"></a>00223   os &lt;&lt; <span class="stringliteral">&quot;DOF CONSTRAINTS OUTPUT:&quot;</span>
<a name="l00224"></a>00224      &lt;&lt; std::endl;
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   <span class="keywordflow">for</span> (DofConstraints::const_iterator it=_dof_constraints.begin();
<a name="l00227"></a>00227        it != _dof_constraints.end(); ++it)
<a name="l00228"></a>00228     {
<a name="l00229"></a>00229       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = it-&gt;first;
<a name="l00230"></a>00230       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; row = it-&gt;second;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232       os &lt;&lt; <span class="stringliteral">&quot;Constraints for DOF &quot;</span> &lt;&lt; i
<a name="l00233"></a>00233          &lt;&lt; <span class="stringliteral">&quot;: \t&quot;</span>;
<a name="l00234"></a>00234 
<a name="l00235"></a>00235       <span class="keywordflow">for</span> (DofConstraintRow::const_iterator pos=row.begin();
<a name="l00236"></a>00236            pos != row.end(); ++pos)
<a name="l00237"></a>00237         os &lt;&lt; <span class="stringliteral">&quot; (&quot;</span> &lt;&lt; pos-&gt;first &lt;&lt; <span class="stringliteral">&quot;,&quot;</span>
<a name="l00238"></a>00238            &lt;&lt; pos-&gt;second &lt;&lt; <span class="stringliteral">&quot;)\t&quot;</span>;
<a name="l00239"></a>00239 
<a name="l00240"></a>00240       os &lt;&lt; std::endl;
<a name="l00241"></a>00241     }
<a name="l00242"></a>00242 }
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a><a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">00246</a> <span class="keywordtype">void</span> DofMap::constrain_element_matrix (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00247"></a>00247                                        std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00248"></a>00248                                        <span class="keywordtype">bool</span> asymmetric_constraint_rows)<span class="keyword"> const</span>
<a name="l00249"></a>00249 <span class="keyword"></span>{
<a name="l00250"></a>00250   libmesh_assert (elem_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00251"></a>00251   libmesh_assert (elem_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">// check for easy return</span>
<a name="l00254"></a>00254   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00255"></a>00255     <span class="keywordflow">return</span>;
<a name="l00256"></a>00256     
<a name="l00257"></a>00257   <span class="comment">// The constrained matrix is built up as C^T K C.    </span>
<a name="l00258"></a>00258   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   
<a name="l00261"></a>00261   this-&gt;build_constraint_matrix (C, elem_dofs);
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   START_LOG(<span class="stringliteral">&quot;constrain_elem_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00264"></a>00264   
<a name="l00265"></a>00265   <span class="comment">// It is possible that the matrix is not constrained at all.</span>
<a name="l00266"></a>00266   <span class="keywordflow">if</span> ((C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>()) &amp;&amp;
<a name="l00267"></a>00267       (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size())) <span class="comment">// It the matrix is constrained</span>
<a name="l00268"></a>00268     {
<a name="l00269"></a>00269       <span class="comment">// Compute the matrix-matrix-matrix product C^T K C</span>
<a name="l00270"></a>00270       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">left_multiply_transpose</a>  (C);
<a name="l00271"></a>00271       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a> (C);
<a name="l00272"></a>00272       
<a name="l00273"></a>00273       
<a name="l00274"></a>00274       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00275"></a>00275       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == elem_dofs.size());
<a name="l00276"></a>00276       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size());
<a name="l00277"></a>00277       
<a name="l00278"></a>00278       
<a name="l00279"></a>00279       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00280"></a>00280         <span class="comment">// If the DOF is constrained</span>
<a name="l00281"></a>00281         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00282"></a>00282           {
<a name="l00283"></a>00283             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00284"></a>00284               matrix(i,j) = 0.;
<a name="l00285"></a>00285             
<a name="l00286"></a>00286             matrix(i,i) = 1.;
<a name="l00287"></a>00287             
<a name="l00288"></a>00288             <span class="keywordflow">if</span> (asymmetric_constraint_rows)
<a name="l00289"></a>00289               {
<a name="l00290"></a>00290                 DofConstraints::const_iterator
<a name="l00291"></a>00291                   pos = _dof_constraints.find(elem_dofs[i]);
<a name="l00292"></a>00292             
<a name="l00293"></a>00293                 libmesh_assert (pos != _dof_constraints.end());
<a name="l00294"></a>00294             
<a name="l00295"></a>00295                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00296"></a>00296             
<a name="l00297"></a>00297                 libmesh_assert (!constraint_row.empty());
<a name="l00298"></a>00298             
<a name="l00299"></a>00299                 <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00300"></a>00300                        it=constraint_row.begin(); it != constraint_row.end();
<a name="l00301"></a>00301                      ++it)
<a name="l00302"></a>00302                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem_dofs.size(); j++)
<a name="l00303"></a>00303                     <span class="keywordflow">if</span> (elem_dofs[j] == it-&gt;first)
<a name="l00304"></a>00304                       matrix(i,j) = -it-&gt;second;        
<a name="l00305"></a>00305               }
<a name="l00306"></a>00306           }
<a name="l00307"></a>00307     } <span class="comment">// end if is constrained...</span>
<a name="l00308"></a>00308   
<a name="l00309"></a>00309   STOP_LOG(<span class="stringliteral">&quot;constrain_elem_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00310"></a>00310 }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a><a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">00314</a> <span class="keywordtype">void</span> DofMap::constrain_element_matrix_and_vector (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00315"></a>00315                                                   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; rhs,
<a name="l00316"></a>00316                                                   std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00317"></a>00317                                                   <span class="keywordtype">bool</span> asymmetric_constraint_rows)<span class="keyword"> const</span>
<a name="l00318"></a>00318 <span class="keyword"></span>{
<a name="l00319"></a>00319   libmesh_assert (elem_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00320"></a>00320   libmesh_assert (elem_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00321"></a>00321   libmesh_assert (elem_dofs.size() == rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00322"></a>00322 
<a name="l00323"></a>00323   <span class="comment">// check for easy return</span>
<a name="l00324"></a>00324   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00325"></a>00325     <span class="keywordflow">return</span>;
<a name="l00326"></a>00326   
<a name="l00327"></a>00327   <span class="comment">// The constrained matrix is built up as C^T K C.</span>
<a name="l00328"></a>00328   <span class="comment">// The constrained RHS is built up as C^T F</span>
<a name="l00329"></a>00329   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l00330"></a>00330   
<a name="l00331"></a>00331   this-&gt;build_constraint_matrix (C, elem_dofs);
<a name="l00332"></a>00332   
<a name="l00333"></a>00333   START_LOG(<span class="stringliteral">&quot;cnstrn_elem_mat_vec()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00334"></a>00334   
<a name="l00335"></a>00335   <span class="comment">// It is possible that the matrix is not constrained at all.</span>
<a name="l00336"></a>00336   <span class="keywordflow">if</span> ((C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>()) &amp;&amp;
<a name="l00337"></a>00337       (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size())) <span class="comment">// It the matrix is constrained</span>
<a name="l00338"></a>00338     {
<a name="l00339"></a>00339       <span class="comment">// Compute the matrix-matrix-matrix product C^T K C</span>
<a name="l00340"></a>00340       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">left_multiply_transpose</a>  (C);
<a name="l00341"></a>00341       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a> (C);
<a name="l00342"></a>00342       
<a name="l00343"></a>00343       
<a name="l00344"></a>00344       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00345"></a>00345       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == elem_dofs.size());
<a name="l00346"></a>00346       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size());
<a name="l00347"></a>00347       
<a name="l00348"></a>00348 
<a name="l00349"></a>00349       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00350"></a>00350         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00351"></a>00351           {
<a name="l00352"></a>00352             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00353"></a>00353               matrix(i,j) = 0.;
<a name="l00354"></a>00354             
<a name="l00355"></a>00355             <span class="comment">// If the DOF is constrained</span>
<a name="l00356"></a>00356             matrix(i,i) = 1.;
<a name="l00357"></a>00357             
<a name="l00358"></a>00358             <span class="comment">// This will put a nonsymmetric entry in the constraint</span>
<a name="l00359"></a>00359             <span class="comment">// row to ensure that the linear system produces the</span>
<a name="l00360"></a>00360             <span class="comment">// correct value for the constrained DOF.</span>
<a name="l00361"></a>00361             <span class="keywordflow">if</span> (asymmetric_constraint_rows)
<a name="l00362"></a>00362               {
<a name="l00363"></a>00363                 DofConstraints::const_iterator
<a name="l00364"></a>00364                   pos = _dof_constraints.find(elem_dofs[i]);
<a name="l00365"></a>00365             
<a name="l00366"></a>00366                 libmesh_assert (pos != _dof_constraints.end());
<a name="l00367"></a>00367             
<a name="l00368"></a>00368                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00369"></a>00369             
<a name="l00370"></a>00370 <span class="comment">// p refinement creates empty constraint rows</span>
<a name="l00371"></a>00371 <span class="comment">//          libmesh_assert (!constraint_row.empty());</span>
<a name="l00372"></a>00372             
<a name="l00373"></a>00373                 <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00374"></a>00374                        it=constraint_row.begin(); it != constraint_row.end();
<a name="l00375"></a>00375                      ++it)
<a name="l00376"></a>00376                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem_dofs.size(); j++)
<a name="l00377"></a>00377                     <span class="keywordflow">if</span> (elem_dofs[j] == it-&gt;first)
<a name="l00378"></a>00378                       matrix(i,j) = -it-&gt;second;        
<a name="l00379"></a>00379               }
<a name="l00380"></a>00380           }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382       
<a name="l00383"></a>00383       <span class="comment">// Compute the matrix-vector product C^T F</span>
<a name="l00384"></a>00384       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_rhs(rhs);
<a name="l00385"></a>00385 
<a name="l00386"></a>00386       <span class="comment">// resize the RHS vector &amp; 0 before summation</span>
<a name="l00387"></a>00387       rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(elem_dofs.size());
<a name="l00388"></a>00388       rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00389"></a>00389       
<a name="l00390"></a>00390       <span class="comment">// compute matrix/vector product</span>
<a name="l00391"></a>00391       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00392"></a>00392         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;old_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); j++)
<a name="l00393"></a>00393           rhs(i) += C.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,j)*old_rhs(j);
<a name="l00394"></a>00394         
<a name="l00395"></a>00395 
<a name="l00396"></a>00396       libmesh_assert (elem_dofs.size() == rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00397"></a>00397 
<a name="l00398"></a>00398       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00399"></a>00399         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00400"></a>00400           {     
<a name="l00401"></a>00401             <span class="comment">// If the DOF is constrained</span>
<a name="l00402"></a>00402             rhs(i) = 0.;
<a name="l00403"></a>00403           }
<a name="l00404"></a>00404     } <span class="comment">// end if is constrained...</span>
<a name="l00405"></a>00405   
<a name="l00406"></a>00406   STOP_LOG(<span class="stringliteral">&quot;cnstrn_elem_mat_vec()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a><a class="code" href="classlibMesh_1_1DofMap.php#adeaa5c51453a3de59f146452771c4e19">00411</a> <span class="keywordtype">void</span> DofMap::constrain_element_matrix (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; matrix,
<a name="l00412"></a>00412                                        std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00413"></a>00413                                        std::vector&lt;unsigned int&gt;&amp; col_dofs,
<a name="l00414"></a>00414                                        <span class="keywordtype">bool</span> asymmetric_constraint_rows)<span class="keyword"> const</span>
<a name="l00415"></a>00415 <span class="keyword"></span>{
<a name="l00416"></a>00416   libmesh_assert (row_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>());
<a name="l00417"></a>00417   libmesh_assert (col_dofs.size() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>());
<a name="l00418"></a>00418 
<a name="l00419"></a>00419   <span class="comment">// check for easy return</span>
<a name="l00420"></a>00420   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00421"></a>00421     <span class="keywordflow">return</span>;
<a name="l00422"></a>00422   
<a name="l00423"></a>00423   <span class="comment">// The constrained matrix is built up as R^T K C.</span>
<a name="l00424"></a>00424   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> R;
<a name="l00425"></a>00425   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l00426"></a>00426 
<a name="l00427"></a>00427   <span class="comment">// Safeguard against the user passing us the same</span>
<a name="l00428"></a>00428   <span class="comment">// object for row_dofs and col_dofs.  If that is done</span>
<a name="l00429"></a>00429   <span class="comment">// the calls to build_matrix would fail</span>
<a name="l00430"></a>00430   std::vector&lt;unsigned int&gt; orig_row_dofs(row_dofs);
<a name="l00431"></a>00431   std::vector&lt;unsigned int&gt; orig_col_dofs(col_dofs);
<a name="l00432"></a>00432   
<a name="l00433"></a>00433   this-&gt;build_constraint_matrix (R, orig_row_dofs);
<a name="l00434"></a>00434   this-&gt;build_constraint_matrix (C, orig_col_dofs);
<a name="l00435"></a>00435 
<a name="l00436"></a>00436   START_LOG(<span class="stringliteral">&quot;constrain_elem_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00437"></a>00437   
<a name="l00438"></a>00438   row_dofs = orig_row_dofs;
<a name="l00439"></a>00439   col_dofs = orig_col_dofs;
<a name="l00440"></a>00440   
<a name="l00441"></a>00441     
<a name="l00442"></a>00442   <span class="comment">// It is possible that the matrix is not constrained at all.</span>
<a name="l00443"></a>00443   <span class="keywordflow">if</span> ((R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>()) &amp;&amp;
<a name="l00444"></a>00444       (R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == row_dofs.size()) &amp;&amp;
<a name="l00445"></a>00445       (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>()) &amp;&amp;
<a name="l00446"></a>00446       (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == col_dofs.size())) <span class="comment">// If the matrix is constrained</span>
<a name="l00447"></a>00447     {
<a name="l00448"></a>00448       <span class="comment">// K_constrained = R^T K C</span>
<a name="l00449"></a>00449       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aea84b08f2ffc1a36a5a87969287ac865">left_multiply_transpose</a>  (R);
<a name="l00450"></a>00450       matrix.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a> (C);
<a name="l00451"></a>00451       
<a name="l00452"></a>00452       
<a name="l00453"></a>00453       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == row_dofs.size());
<a name="l00454"></a>00454       libmesh_assert (matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == col_dofs.size());
<a name="l00455"></a>00455       
<a name="l00456"></a>00456       
<a name="l00457"></a>00457       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00458"></a>00458         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(row_dofs[i]))
<a name="l00459"></a>00459           {
<a name="l00460"></a>00460             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;matrix.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00461"></a>00461               matrix(i,j) = 0.;
<a name="l00462"></a>00462           
<a name="l00463"></a>00463             <span class="comment">// If the DOF is constrained</span>
<a name="l00464"></a>00464             matrix(i,i) = 1.;
<a name="l00465"></a>00465             
<a name="l00466"></a>00466             <span class="keywordflow">if</span> (asymmetric_constraint_rows)
<a name="l00467"></a>00467               {
<a name="l00468"></a>00468                 DofConstraints::const_iterator
<a name="l00469"></a>00469                   pos = _dof_constraints.find(row_dofs[i]);
<a name="l00470"></a>00470             
<a name="l00471"></a>00471                 libmesh_assert (pos != _dof_constraints.end());
<a name="l00472"></a>00472             
<a name="l00473"></a>00473                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00474"></a>00474             
<a name="l00475"></a>00475                 libmesh_assert (!constraint_row.empty());
<a name="l00476"></a>00476             
<a name="l00477"></a>00477                 <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00478"></a>00478                        it=constraint_row.begin(); it != constraint_row.end();
<a name="l00479"></a>00479                      ++it)
<a name="l00480"></a>00480                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;col_dofs.size(); j++)
<a name="l00481"></a>00481                     <span class="keywordflow">if</span> (col_dofs[j] == it-&gt;first)
<a name="l00482"></a>00482                       matrix(i,j) = -it-&gt;second;        
<a name="l00483"></a>00483               }
<a name="l00484"></a>00484           }
<a name="l00485"></a>00485     } <span class="comment">// end if is constrained...</span>
<a name="l00486"></a>00486   
<a name="l00487"></a>00487   STOP_LOG(<span class="stringliteral">&quot;constrain_elem_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00488"></a>00488 }
<a name="l00489"></a>00489 
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a><a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">00492</a> <span class="keywordtype">void</span> DofMap::constrain_element_vector (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp;       rhs,
<a name="l00493"></a>00493                                        std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00494"></a>00494                                        <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00495"></a>00495 <span class="keyword"></span>{
<a name="l00496"></a>00496   libmesh_assert (rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == row_dofs.size());
<a name="l00497"></a>00497 
<a name="l00498"></a>00498   <span class="comment">// check for easy return</span>
<a name="l00499"></a>00499   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00500"></a>00500     <span class="keywordflow">return</span>;
<a name="l00501"></a>00501   
<a name="l00502"></a>00502   <span class="comment">// The constrained RHS is built up as R^T F.  </span>
<a name="l00503"></a>00503   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> R;
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   this-&gt;build_constraint_matrix (R, row_dofs);
<a name="l00506"></a>00506 
<a name="l00507"></a>00507   START_LOG(<span class="stringliteral">&quot;constrain_elem_vector()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00508"></a>00508     
<a name="l00509"></a>00509   <span class="comment">// It is possible that the vector is not constrained at all.</span>
<a name="l00510"></a>00510   <span class="keywordflow">if</span> ((R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>()) &amp;&amp;
<a name="l00511"></a>00511       (R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == row_dofs.size())) <span class="comment">// if the RHS is constrained</span>
<a name="l00512"></a>00512     {
<a name="l00513"></a>00513       <span class="comment">// Compute the matrix-vector product</span>
<a name="l00514"></a>00514       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_rhs(rhs);
<a name="l00515"></a>00515 
<a name="l00516"></a>00516       <span class="comment">// resize RHS &amp; zero before summation</span>
<a name="l00517"></a>00517       rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(row_dofs.size());
<a name="l00518"></a>00518       rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00519"></a>00519 
<a name="l00520"></a>00520       <span class="comment">// compute matrix/vector product</span>
<a name="l00521"></a>00521       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00522"></a>00522         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;old_rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); j++)
<a name="l00523"></a>00523           rhs(i) += R.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,j)*old_rhs(j);
<a name="l00524"></a>00524       
<a name="l00525"></a>00525       libmesh_assert (row_dofs.size() == rhs.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00526"></a>00526 
<a name="l00527"></a>00527       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00528"></a>00528         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(row_dofs[i]))
<a name="l00529"></a>00529           {     
<a name="l00530"></a>00530             <span class="comment">// If the DOF is constrained</span>
<a name="l00531"></a>00531             rhs(i) = 0.;
<a name="l00532"></a>00532           }
<a name="l00533"></a>00533     } <span class="comment">// end if the RHS is constrained.</span>
<a name="l00534"></a>00534   
<a name="l00535"></a>00535   STOP_LOG(<span class="stringliteral">&quot;constrain_elem_vector()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00536"></a>00536 }
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a><a class="code" href="classlibMesh_1_1DofMap.php#ae5ccc5717b8c3a94629a306ebd4e1f17">00540</a> <span class="keywordtype">void</span> DofMap::constrain_element_dyad_matrix (<a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; v,
<a name="l00541"></a>00541                                             <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; w,
<a name="l00542"></a>00542                                             std::vector&lt;unsigned int&gt;&amp; row_dofs,
<a name="l00543"></a>00543                                             <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00544"></a>00544 <span class="keyword"></span>{
<a name="l00545"></a>00545   libmesh_assert (v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == row_dofs.size());
<a name="l00546"></a>00546   libmesh_assert (w.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == row_dofs.size());
<a name="l00547"></a>00547 
<a name="l00548"></a>00548   <span class="comment">// check for easy return</span>
<a name="l00549"></a>00549   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00550"></a>00550     <span class="keywordflow">return</span>;
<a name="l00551"></a>00551   
<a name="l00552"></a>00552   <span class="comment">// The constrained RHS is built up as R^T F.  </span>
<a name="l00553"></a>00553   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> R;
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   this-&gt;build_constraint_matrix (R, row_dofs);
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   START_LOG(<span class="stringliteral">&quot;cnstrn_elem_dyad_mat()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00558"></a>00558     
<a name="l00559"></a>00559   <span class="comment">// It is possible that the vector is not constrained at all.</span>
<a name="l00560"></a>00560   <span class="keywordflow">if</span> ((R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>()) &amp;&amp;
<a name="l00561"></a>00561       (R.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == row_dofs.size())) <span class="comment">// if the RHS is constrained</span>
<a name="l00562"></a>00562     {
<a name="l00563"></a>00563       <span class="comment">// Compute the matrix-vector products</span>
<a name="l00564"></a>00564       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_v(v);
<a name="l00565"></a>00565       <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_w(w);
<a name="l00566"></a>00566 
<a name="l00567"></a>00567       <span class="comment">// resize RHS &amp; zero before summation</span>
<a name="l00568"></a>00568       v.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(row_dofs.size());
<a name="l00569"></a>00569       w.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(row_dofs.size());
<a name="l00570"></a>00570 
<a name="l00571"></a>00571       <span class="comment">// compute matrix/vector product</span>
<a name="l00572"></a>00572       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00573"></a>00573         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;old_v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); j++)
<a name="l00574"></a>00574           {
<a name="l00575"></a>00575             v(i) += R.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,j)*old_v(j);
<a name="l00576"></a>00576             w(i) += R.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a8f1a04ca0780c6327443862cae23f1d3">transpose</a>(i,j)*old_w(j);
<a name="l00577"></a>00577           }
<a name="l00578"></a>00578       
<a name="l00579"></a>00579       libmesh_assert (row_dofs.size() == v.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00580"></a>00580       libmesh_assert (row_dofs.size() == w.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>());
<a name="l00581"></a>00581 
<a name="l00582"></a>00582       <span class="comment">/* Constrain only v, not w.  */</span>
<a name="l00583"></a>00583 
<a name="l00584"></a>00584       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;row_dofs.size(); i++)
<a name="l00585"></a>00585         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(row_dofs[i]))
<a name="l00586"></a>00586           {     
<a name="l00587"></a>00587             <span class="comment">// If the DOF is constrained</span>
<a name="l00588"></a>00588             v(i) = 0.;
<a name="l00589"></a>00589           }
<a name="l00590"></a>00590     } <span class="comment">// end if the RHS is constrained.</span>
<a name="l00591"></a>00591   
<a name="l00592"></a>00592   STOP_LOG(<span class="stringliteral">&quot;cnstrn_elem_dyad_mat()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00593"></a>00593 }
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 
<a name="l00597"></a><a class="code" href="classlibMesh_1_1DofMap.php#a435e93c5a2f7bc911a62886eaddab082">00597</a> <span class="keywordtype">void</span> DofMap::constrain_nothing (std::vector&lt;unsigned int&gt;&amp; dofs)<span class="keyword"> const</span>
<a name="l00598"></a>00598 <span class="keyword"></span>{
<a name="l00599"></a>00599   <span class="comment">// check for easy return</span>
<a name="l00600"></a>00600   <span class="keywordflow">if</span> (this-&gt;n_constrained_dofs() == 0)
<a name="l00601"></a>00601     <span class="keywordflow">return</span>;
<a name="l00602"></a>00602 
<a name="l00603"></a>00603   <span class="comment">// All the work is done by \p build_constraint_matrix.  We just need</span>
<a name="l00604"></a>00604   <span class="comment">// a dummy matrix.</span>
<a name="l00605"></a>00605   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> R;
<a name="l00606"></a>00606   this-&gt;build_constraint_matrix (R, dofs);
<a name="l00607"></a>00607 }
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 
<a name="l00610"></a>00610 
<a name="l00611"></a><a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">00611</a> <span class="keywordtype">void</span> DofMap::enforce_constraints_exactly (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system,
<a name="l00612"></a>00612                                           <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v)<span class="keyword"> const</span>
<a name="l00613"></a>00613 <span class="keyword"></span>{
<a name="l00614"></a>00614   parallel_only();
<a name="l00615"></a>00615 
<a name="l00616"></a>00616   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_constraints = this-&gt;n_constrained_dofs();
<a name="l00617"></a>00617   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(local_constraints);
<a name="l00618"></a>00618   <span class="keywordflow">if</span> (!local_constraints)
<a name="l00619"></a>00619     <span class="keywordflow">return</span>;
<a name="l00620"></a>00620   
<a name="l00621"></a>00621   START_LOG(<span class="stringliteral">&quot;enforce_constraints_exactly()&quot;</span>,<span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00622"></a>00622 
<a name="l00623"></a>00623   <span class="keywordflow">if</span> (!v)
<a name="l00624"></a>00624     v = system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00625"></a>00625 
<a name="l00626"></a>00626   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v_local  = NULL; <span class="comment">// will be initialized below</span>
<a name="l00627"></a>00627   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v_global = NULL; <span class="comment">// will be initialized below</span>
<a name="l00628"></a>00628   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; v_built;
<a name="l00629"></a>00629   <span class="keywordflow">if</span> (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>)
<a name="l00630"></a>00630     {
<a name="l00631"></a>00631       v_built = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00632"></a>00632       v_built-&gt;init(this-&gt;n_dofs(), this-&gt;n_local_dofs(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00633"></a>00633       v_built-&gt;close();
<a name="l00634"></a>00634 
<a name="l00635"></a>00635       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=v_built-&gt;first_local_index();
<a name="l00636"></a>00636            i&lt;v_built-&gt;last_local_index(); i++)
<a name="l00637"></a>00637         v_built-&gt;set(i, (*v)(i));
<a name="l00638"></a>00638       v_built-&gt;close();
<a name="l00639"></a>00639       v_global = v_built.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00640"></a>00640 
<a name="l00641"></a>00641       v_local = v;
<a name="l00642"></a>00642       libmesh_assert (v_local-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#afa69111a678b5552c7fe586c91a6585f">closed</a>());
<a name="l00643"></a>00643     }
<a name="l00644"></a>00644   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>)
<a name="l00645"></a>00645     {
<a name="l00646"></a>00646       v_built = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00647"></a>00647       v_built-&gt;init (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(), v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00648"></a>00648       v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a>(*v_built);
<a name="l00649"></a>00649       v_built-&gt;close();
<a name="l00650"></a>00650       v_local = v_built.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00651"></a>00651 
<a name="l00652"></a>00652       v_global = v;
<a name="l00653"></a>00653     }
<a name="l00654"></a>00654   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00655"></a>00655     {
<a name="l00656"></a>00656       v_local = v;
<a name="l00657"></a>00657       v_global = v;
<a name="l00658"></a>00658     }
<a name="l00659"></a>00659   <span class="keywordflow">else</span> <span class="comment">// unknown v-&gt;type()</span>
<a name="l00660"></a>00660     {
<a name="l00661"></a>00661       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unknown v-&gt;type() == &quot;</span> &lt;&lt; v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() 
<a name="l00662"></a>00662                     &lt;&lt; std::endl;
<a name="l00663"></a>00663       libmesh_error();
<a name="l00664"></a>00664     }
<a name="l00665"></a>00665 
<a name="l00666"></a>00666   <span class="comment">// We should never hit these asserts because we should error-out in</span>
<a name="l00667"></a>00667   <span class="comment">// else clause above.  Just to be sure we don&#39;t try to use v_local</span>
<a name="l00668"></a>00668   <span class="comment">// and v_global uninitialized...</span>
<a name="l00669"></a>00669   libmesh_assert(v_local);
<a name="l00670"></a>00670   libmesh_assert(v_global);
<a name="l00671"></a>00671   libmesh_assert (<span class="keyword">this</span> == &amp;(system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>()));
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   DofConstraints::const_iterator c_it = _dof_constraints.begin();
<a name="l00674"></a>00674   <span class="keyword">const</span> DofConstraints::const_iterator c_end = _dof_constraints.end();
<a name="l00675"></a>00675 
<a name="l00676"></a>00676   <span class="keywordflow">for</span> ( ; c_it != c_end; ++c_it)
<a name="l00677"></a>00677     {
<a name="l00678"></a>00678       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained_dof = c_it-&gt;first;
<a name="l00679"></a>00679       <span class="keywordflow">if</span> (constrained_dof &lt; this-&gt;first_dof() ||
<a name="l00680"></a>00680           constrained_dof &gt;= this-&gt;end_dof())
<a name="l00681"></a>00681         <span class="keywordflow">continue</span>;
<a name="l00682"></a>00682 
<a name="l00683"></a>00683       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> constraint_row = c_it-&gt;second;
<a name="l00684"></a>00684 
<a name="l00685"></a>00685       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> exact_value = 0;
<a name="l00686"></a>00686       <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00687"></a>00687            j=constraint_row.begin(); j != constraint_row.end();
<a name="l00688"></a>00688            ++j)
<a name="l00689"></a>00689         exact_value += j-&gt;second * (*v_local)(j-&gt;first);
<a name="l00690"></a>00690 
<a name="l00691"></a>00691       v_global-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a51bd7e4c6afb223573ec051777133c9b">set</a>(constrained_dof, exact_value);
<a name="l00692"></a>00692     }
<a name="l00693"></a>00693 
<a name="l00694"></a>00694   <span class="comment">// If the old vector was serial, we probably need to send our values</span>
<a name="l00695"></a>00695   <span class="comment">// to other processors</span>
<a name="l00696"></a>00696   <span class="keywordflow">if</span> (v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>)
<a name="l00697"></a>00697     {
<a name="l00698"></a>00698       v_global-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a> (*v);
<a name="l00699"></a>00699     }
<a name="l00700"></a>00700   v-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00701"></a>00701 
<a name="l00702"></a>00702   STOP_LOG(<span class="stringliteral">&quot;enforce_constraints_exactly()&quot;</span>,<span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00703"></a>00703 }
<a name="l00704"></a>00704 
<a name="l00705"></a>00705 
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 std::pair&lt;Real, Real&gt;
<a name="l00708"></a><a class="code" href="classlibMesh_1_1DofMap.php#a8d3c9a10b0a20e889cb9c781219ef29d">00708</a> DofMap::max_constraint_error (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system,
<a name="l00709"></a>00709                               <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> *v)<span class="keyword"> const</span>
<a name="l00710"></a>00710 <span class="keyword"></span>{
<a name="l00711"></a>00711   <span class="keywordflow">if</span> (!v)
<a name="l00712"></a>00712     v = system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00713"></a>00713   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;vec = *v;
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   <span class="comment">// We&#39;ll assume the vector is closed</span>
<a name="l00716"></a>00716   libmesh_assert (vec.<a class="code" href="classlibMesh_1_1NumericVector.php#afa69111a678b5552c7fe586c91a6585f">closed</a>());
<a name="l00717"></a>00717 
<a name="l00718"></a>00718   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> max_absolute_error = 0., max_relative_error = 0.;
<a name="l00719"></a>00719 
<a name="l00720"></a>00720   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00721"></a>00721 
<a name="l00722"></a>00722   libmesh_assert (<span class="keyword">this</span> == &amp;(system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>()));
<a name="l00723"></a>00723 
<a name="l00724"></a>00724   <span class="comment">// indices on each element</span>
<a name="l00725"></a>00725   std::vector&lt;unsigned int&gt; local_dof_indices;
<a name="l00726"></a>00726 
<a name="l00727"></a>00727   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  =
<a name="l00728"></a>00728     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00729"></a>00729   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end =
<a name="l00730"></a>00730     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00731"></a>00731       
<a name="l00732"></a>00732   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00733"></a>00733     {
<a name="l00734"></a>00734       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00735"></a>00735 
<a name="l00736"></a>00736       this-&gt;dof_indices(elem, local_dof_indices);
<a name="l00737"></a>00737       std::vector&lt;unsigned int&gt; raw_dof_indices = local_dof_indices;
<a name="l00738"></a>00738 
<a name="l00739"></a>00739       <span class="comment">// Constraint matrix for each element</span>
<a name="l00740"></a>00740       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> C;
<a name="l00741"></a>00741 
<a name="l00742"></a>00742       this-&gt;build_constraint_matrix (C, local_dof_indices);
<a name="l00743"></a>00743 
<a name="l00744"></a>00744       <span class="comment">// Continue if the element is unconstrained</span>
<a name="l00745"></a>00745       <span class="keywordflow">if</span> (!C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>())
<a name="l00746"></a>00746         <span class="keywordflow">continue</span>;
<a name="l00747"></a>00747 
<a name="l00748"></a>00748       libmesh_assert(C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>() == raw_dof_indices.size());
<a name="l00749"></a>00749       libmesh_assert(C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == local_dof_indices.size());
<a name="l00750"></a>00750 
<a name="l00751"></a>00751       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(); ++i)
<a name="l00752"></a>00752         {
<a name="l00753"></a>00753           <span class="comment">// Recalculate any constrained dof owned by this processor</span>
<a name="l00754"></a>00754           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_dof = raw_dof_indices[i];
<a name="l00755"></a>00755           <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(global_dof) &amp;&amp;
<a name="l00756"></a>00756               global_dof &gt;= vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>() &amp;&amp;
<a name="l00757"></a>00757               global_dof &lt; vec.<a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>())
<a name="l00758"></a>00758           {
<a name="l00759"></a>00759             <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> exact_value = 0;
<a name="l00760"></a>00760             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j!=C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); ++j)
<a name="l00761"></a>00761               {
<a name="l00762"></a>00762                 <span class="keywordflow">if</span> (local_dof_indices[j] != global_dof)
<a name="l00763"></a>00763                   exact_value += C(i,j) * 
<a name="l00764"></a>00764                     vec(local_dof_indices[j]);
<a name="l00765"></a>00765               }
<a name="l00766"></a>00766 
<a name="l00767"></a>00767             max_absolute_error = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_absolute_error,
<a name="l00768"></a>00768               std::abs(vec(global_dof) - exact_value));
<a name="l00769"></a>00769             max_relative_error = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_relative_error,
<a name="l00770"></a>00770               std::abs(vec(global_dof) - exact_value)
<a name="l00771"></a>00771               / std::abs(exact_value));
<a name="l00772"></a>00772           }
<a name="l00773"></a>00773         }
<a name="l00774"></a>00774     }
<a name="l00775"></a>00775 
<a name="l00776"></a>00776   <span class="keywordflow">return</span> std::pair&lt;Real, Real&gt;(max_absolute_error, max_relative_error);
<a name="l00777"></a>00777 }
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 
<a name="l00780"></a>00780 
<a name="l00781"></a><a class="code" href="classlibMesh_1_1DofMap.php#ab205c45f9397a3864d915a4bc558acbf">00781</a> <span class="keywordtype">void</span> DofMap::build_constraint_matrix (<a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a>&amp; C,
<a name="l00782"></a>00782                                       std::vector&lt;unsigned int&gt;&amp; elem_dofs,
<a name="l00783"></a>00783                                       <span class="keyword">const</span> <span class="keywordtype">bool</span> called_recursively)<span class="keyword"> const</span>
<a name="l00784"></a>00784 <span class="keyword"></span>{
<a name="l00785"></a>00785   <span class="keywordflow">if</span> (!called_recursively) START_LOG(<span class="stringliteral">&quot;build_constraint_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00786"></a>00786 
<a name="l00787"></a>00787   <span class="comment">// Create a set containing the DOFs we already depend on</span>
<a name="l00788"></a>00788   <span class="keyword">typedef</span> std::set&lt;unsigned int&gt; RCSet;
<a name="l00789"></a>00789   RCSet dof_set;
<a name="l00790"></a>00790 
<a name="l00791"></a>00791   <span class="keywordtype">bool</span> we_have_constraints = <span class="keyword">false</span>;
<a name="l00792"></a>00792 
<a name="l00793"></a>00793   <span class="comment">// Next insert any other dofs the current dofs might be constrained</span>
<a name="l00794"></a>00794   <span class="comment">// in terms of.  Note that in this case we may not be done: Those</span>
<a name="l00795"></a>00795   <span class="comment">// may in turn depend on others.  So, we need to repeat this process</span>
<a name="l00796"></a>00796   <span class="comment">// in that case until the system depends only on unconstrained</span>
<a name="l00797"></a>00797   <span class="comment">// degrees of freedom.</span>
<a name="l00798"></a>00798   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00799"></a>00799     <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00800"></a>00800       {
<a name="l00801"></a>00801         we_have_constraints = <span class="keyword">true</span>;
<a name="l00802"></a>00802 
<a name="l00803"></a>00803         <span class="comment">// If the DOF is constrained</span>
<a name="l00804"></a>00804         DofConstraints::const_iterator
<a name="l00805"></a>00805           pos = _dof_constraints.find(elem_dofs[i]);
<a name="l00806"></a>00806         
<a name="l00807"></a>00807         libmesh_assert (pos != _dof_constraints.end());
<a name="l00808"></a>00808         
<a name="l00809"></a>00809         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00810"></a>00810         
<a name="l00811"></a>00811 <span class="comment">// Constraint rows in p refinement may be empty</span>
<a name="l00812"></a>00812 <span class="comment">//      libmesh_assert (!constraint_row.empty());</span>
<a name="l00813"></a>00813         
<a name="l00814"></a>00814         <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00815"></a>00815                it=constraint_row.begin(); it != constraint_row.end();
<a name="l00816"></a>00816              ++it)
<a name="l00817"></a>00817           dof_set.insert (it-&gt;first);
<a name="l00818"></a>00818       }
<a name="l00819"></a>00819 
<a name="l00820"></a>00820   <span class="comment">// May be safe to return at this point</span>
<a name="l00821"></a>00821   <span class="comment">// (but remember to stop the perflog)</span>
<a name="l00822"></a>00822   <span class="keywordflow">if</span> (!we_have_constraints)
<a name="l00823"></a>00823     {
<a name="l00824"></a>00824       STOP_LOG(<span class="stringliteral">&quot;build_constraint_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);
<a name="l00825"></a>00825       <span class="keywordflow">return</span>;
<a name="l00826"></a>00826     }
<a name="l00827"></a>00827 
<a name="l00828"></a>00828   <span class="comment">// delay inserting elem_dofs for efficiency in the case of</span>
<a name="l00829"></a>00829   <span class="comment">// no constraints.  In that case we don&#39;t get here!</span>
<a name="l00830"></a>00830   dof_set.insert (elem_dofs.begin(),
<a name="l00831"></a>00831                   elem_dofs.end());
<a name="l00832"></a>00832 
<a name="l00833"></a>00833   <span class="comment">// If we added any DOFS then we need to do this recursively.</span>
<a name="l00834"></a>00834   <span class="comment">// It is possible that we just added a DOF that is also</span>
<a name="l00835"></a>00835   <span class="comment">// constrained!</span>
<a name="l00836"></a>00836   <span class="comment">//</span>
<a name="l00837"></a>00837   <span class="comment">// Also, we need to handle the special case of an element having DOFs</span>
<a name="l00838"></a>00838   <span class="comment">// constrained in terms of other, local DOFs</span>
<a name="l00839"></a>00839   <span class="keywordflow">if</span> ((dof_set.size() != elem_dofs.size()) || <span class="comment">// case 1: constrained in terms of other DOFs</span>
<a name="l00840"></a>00840       !called_recursively)                    <span class="comment">// case 2: constrained in terms of our own DOFs</span>
<a name="l00841"></a>00841     {
<a name="l00842"></a>00842       <span class="comment">// Create a new list of element DOFs containing the</span>
<a name="l00843"></a>00843       <span class="comment">// contents of the current dof_set.</span>
<a name="l00844"></a>00844       std::vector&lt;unsigned int&gt; new_elem_dofs (dof_set.begin(),
<a name="l00845"></a>00845                                                dof_set.end());
<a name="l00846"></a>00846       
<a name="l00847"></a>00847       <span class="comment">// Now we can build the constraint matrix.</span>
<a name="l00848"></a>00848       <span class="comment">// Note that resize also zeros for a DenseMatrix&lt;Number&gt;.</span>
<a name="l00849"></a>00849       C.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a> (elem_dofs.size(), new_elem_dofs.size());
<a name="l00850"></a>00850       
<a name="l00851"></a>00851       <span class="comment">// Create the C constraint matrix.</span>
<a name="l00852"></a>00852       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem_dofs.size(); i++)
<a name="l00853"></a>00853         <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(elem_dofs[i]))
<a name="l00854"></a>00854           {
<a name="l00855"></a>00855             <span class="comment">// If the DOF is constrained</span>
<a name="l00856"></a>00856             DofConstraints::const_iterator
<a name="l00857"></a>00857               pos = _dof_constraints.find(elem_dofs[i]);
<a name="l00858"></a>00858             
<a name="l00859"></a>00859             libmesh_assert (pos != _dof_constraints.end());
<a name="l00860"></a>00860             
<a name="l00861"></a>00861             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l00862"></a>00862             
<a name="l00863"></a>00863 <span class="comment">// p refinement creates empty constraint rows</span>
<a name="l00864"></a>00864 <span class="comment">//          libmesh_assert (!constraint_row.empty());</span>
<a name="l00865"></a>00865             
<a name="l00866"></a>00866             <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l00867"></a>00867                    it=constraint_row.begin(); it != constraint_row.end();
<a name="l00868"></a>00868                  ++it)
<a name="l00869"></a>00869               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;new_elem_dofs.size(); j++)
<a name="l00870"></a>00870                 <span class="keywordflow">if</span> (new_elem_dofs[j] == it-&gt;first)
<a name="l00871"></a>00871                   C(i,j) = it-&gt;second;
<a name="l00872"></a>00872           }
<a name="l00873"></a>00873         <span class="keywordflow">else</span>
<a name="l00874"></a>00874           {
<a name="l00875"></a>00875             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;new_elem_dofs.size(); j++)
<a name="l00876"></a>00876               <span class="keywordflow">if</span> (new_elem_dofs[j] == elem_dofs[i])
<a name="l00877"></a>00877                 C(i,j) =  1.;
<a name="l00878"></a>00878           }     
<a name="l00879"></a>00879 
<a name="l00880"></a>00880       <span class="comment">// May need to do this recursively.  It is possible</span>
<a name="l00881"></a>00881       <span class="comment">// that we just replaced a constrained DOF with another</span>
<a name="l00882"></a>00882       <span class="comment">// constrained DOF.</span>
<a name="l00883"></a>00883       elem_dofs = new_elem_dofs;
<a name="l00884"></a>00884       
<a name="l00885"></a>00885       <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> Cnew;
<a name="l00886"></a>00886       
<a name="l00887"></a>00887       this-&gt;build_constraint_matrix (Cnew, elem_dofs, <span class="keyword">true</span>);
<a name="l00888"></a>00888 
<a name="l00889"></a>00889       <span class="keywordflow">if</span> ((C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == Cnew.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>()) &amp;&amp;
<a name="l00890"></a>00890           (Cnew.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size())) <span class="comment">// If the constraint matrix                                    </span>
<a name="l00891"></a>00891         C.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a9cb161155585b412f27e6bf8103d6d48">right_multiply</a>(Cnew);           <span class="comment">// is constrained...</span>
<a name="l00892"></a>00892       
<a name="l00893"></a>00893       libmesh_assert (C.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>() == elem_dofs.size());
<a name="l00894"></a>00894     }
<a name="l00895"></a>00895   
<a name="l00896"></a>00896   <span class="keywordflow">if</span> (!called_recursively) STOP_LOG(<span class="stringliteral">&quot;build_constraint_matrix()&quot;</span>, <span class="stringliteral">&quot;DofMap&quot;</span>);  
<a name="l00897"></a>00897 }
<a name="l00898"></a>00898 
<a name="l00899"></a>00899 
<a name="l00900"></a>00900 
<a name="l00901"></a><a class="code" href="classlibMesh_1_1DofMap.php#a2a73dfbc22045908ef2acf9045c7790f">00901</a> <span class="keywordtype">void</span> DofMap::allgather_recursive_constraints()
<a name="l00902"></a>00902 {
<a name="l00903"></a>00903   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00904"></a>00904   parallel_only();
<a name="l00905"></a>00905 
<a name="l00906"></a>00906   <span class="comment">// Return immediately if there&#39;s nothing to gather</span>
<a name="l00907"></a>00907   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00908"></a>00908     <span class="keywordflow">return</span>;
<a name="l00909"></a>00909 
<a name="l00910"></a>00910   <span class="comment">// We might get to return immediately if none of the processors</span>
<a name="l00911"></a>00911   <span class="comment">// found any constraints</span>
<a name="l00912"></a>00912   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> has_constraints = !_dof_constraints.empty();
<a name="l00913"></a>00913   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(has_constraints);
<a name="l00914"></a>00914   <span class="keywordflow">if</span> (!has_constraints)
<a name="l00915"></a>00915     <span class="keywordflow">return</span>;
<a name="l00916"></a>00916 
<a name="l00917"></a>00917   <span class="comment">// We might have calculated constraints for constrained dofs</span>
<a name="l00918"></a>00918   <span class="comment">// which live on other processors.</span>
<a name="l00919"></a>00919   <span class="comment">// Push these out first.</span>
<a name="l00920"></a>00920   {
<a name="l00921"></a>00921   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; pushed_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00922"></a>00922   std::vector&lt;unsigned int&gt; pushed_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00923"></a>00923 
<a name="l00924"></a>00924   <span class="comment">// Count the constraints to push to each processor</span>
<a name="l00925"></a>00925   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> push_proc_id = 0;
<a name="l00926"></a>00926   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l00927"></a>00927          i != _dof_constraints.end(); ++i)
<a name="l00928"></a>00928     {
<a name="l00929"></a>00929       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = i-&gt;first;
<a name="l00930"></a>00930       <span class="keywordflow">while</span> (constrained &gt;= _end_df[push_proc_id])
<a name="l00931"></a>00931         push_proc_id++;
<a name="l00932"></a>00932       pushed_on_proc[push_proc_id]++;
<a name="l00933"></a>00933     }
<a name="l00934"></a>00934   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p = 0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00935"></a>00935     pushed_ids[p].reserve(pushed_on_proc[p]);
<a name="l00936"></a>00936 
<a name="l00937"></a>00937   <span class="comment">// Collect the constraints to push to each processor</span>
<a name="l00938"></a>00938   push_proc_id = 0;
<a name="l00939"></a>00939   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l00940"></a>00940          i != _dof_constraints.end(); ++i)
<a name="l00941"></a>00941     {
<a name="l00942"></a>00942       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = i-&gt;first;
<a name="l00943"></a>00943       <span class="keywordflow">while</span> (constrained &gt;= _end_df[push_proc_id])
<a name="l00944"></a>00944         push_proc_id++;
<a name="l00945"></a>00945       pushed_ids[push_proc_id].push_back(constrained);
<a name="l00946"></a>00946     }
<a name="l00947"></a>00947 
<a name="l00948"></a>00948   <span class="comment">// Now trade constraint rows</span>
<a name="l00949"></a>00949   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p = 0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00950"></a>00950     {
<a name="l00951"></a>00951       <span class="comment">// Push to processor procup while receiving from procdown</span>
<a name="l00952"></a>00952       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00953"></a>00953                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00954"></a>00954       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00955"></a>00955                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00956"></a>00956                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00957"></a>00957 
<a name="l00958"></a>00958       <span class="comment">// Pack the constraint rows to push to procup</span>
<a name="l00959"></a>00959       std::vector&lt;std::vector&lt;unsigned int&gt; &gt; pushed_keys(pushed_ids[procup].size());
<a name="l00960"></a>00960       std::vector&lt;std::vector&lt;Real&gt; &gt; pushed_vals(pushed_ids[procup].size());
<a name="l00961"></a>00961       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != pushed_ids[procup].size(); ++i) 
<a name="l00962"></a>00962         {
<a name="l00963"></a>00963           <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[pushed_ids[procup][i]];
<a name="l00964"></a>00964           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row_size = row.size();
<a name="l00965"></a>00965           pushed_keys[i].reserve(row_size);
<a name="l00966"></a>00966           pushed_vals[i].reserve(row_size);
<a name="l00967"></a>00967           <span class="keywordflow">for</span> (DofConstraintRow::iterator j = row.begin();
<a name="l00968"></a>00968                j != row.end(); ++j)
<a name="l00969"></a>00969             {
<a name="l00970"></a>00970               pushed_keys[i].push_back(j-&gt;first);
<a name="l00971"></a>00971               pushed_vals[i].push_back(j-&gt;second);
<a name="l00972"></a>00972             }
<a name="l00973"></a>00973         }
<a name="l00974"></a>00974 
<a name="l00975"></a>00975       <span class="comment">// Trade pushed constraint rows</span>
<a name="l00976"></a>00976       std::vector&lt;unsigned int&gt; pushed_ids_to_me;
<a name="l00977"></a>00977       std::vector&lt;std::vector&lt;unsigned int&gt; &gt; pushed_keys_to_me;
<a name="l00978"></a>00978       std::vector&lt;std::vector&lt;Real&gt; &gt; pushed_vals_to_me;
<a name="l00979"></a>00979       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, pushed_ids[procup],
<a name="l00980"></a>00980                              procdown, pushed_ids_to_me);
<a name="l00981"></a>00981       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, pushed_keys,
<a name="l00982"></a>00982                              procdown, pushed_keys_to_me);
<a name="l00983"></a>00983       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, pushed_vals,
<a name="l00984"></a>00984                              procdown, pushed_vals_to_me);
<a name="l00985"></a>00985       libmesh_assert (pushed_ids_to_me.size() == pushed_keys_to_me.size());
<a name="l00986"></a>00986       libmesh_assert (pushed_ids_to_me.size() == pushed_vals_to_me.size());
<a name="l00987"></a>00987 
<a name="l00988"></a>00988       <span class="comment">// Add the constraints that I&#39;ve been sent</span>
<a name="l00989"></a>00989       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != pushed_ids_to_me.size(); ++i)
<a name="l00990"></a>00990         {
<a name="l00991"></a>00991           libmesh_assert (pushed_keys_to_me[i].size() == pushed_vals_to_me[i].size());
<a name="l00992"></a>00992 
<a name="l00993"></a>00993           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = pushed_ids_to_me[i];
<a name="l00994"></a>00994 
<a name="l00995"></a>00995           <span class="comment">// If we don&#39;t already have a constraint for this dof,</span>
<a name="l00996"></a>00996           <span class="comment">// add the one we were sent</span>
<a name="l00997"></a>00997           <span class="keywordflow">if</span> (!this-&gt;is_constrained_dof(constrained))
<a name="l00998"></a>00998             {
<a name="l00999"></a>00999               <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[constrained];
<a name="l01000"></a>01000               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != pushed_keys_to_me[i].size(); ++j)
<a name="l01001"></a>01001                 {
<a name="l01002"></a>01002                   row[pushed_keys_to_me[i][j]] = pushed_vals_to_me[i][j];
<a name="l01003"></a>01003                 }
<a name="l01004"></a>01004             }
<a name="l01005"></a>01005         }
<a name="l01006"></a>01006     }
<a name="l01007"></a>01007   }
<a name="l01008"></a>01008 
<a name="l01009"></a>01009   <span class="comment">// Now start checking for any other constraints we need</span>
<a name="l01010"></a>01010   <span class="comment">// to know about, requesting them recursively.</span>
<a name="l01011"></a>01011 
<a name="l01012"></a>01012   <span class="comment">// Create a set containing the DOFs we already depend on</span>
<a name="l01013"></a>01013   <span class="keyword">typedef</span> std::set&lt;unsigned int&gt; RCSet;
<a name="l01014"></a>01014   RCSet unexpanded_set;
<a name="l01015"></a>01015 
<a name="l01016"></a>01016   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l01017"></a>01017          i != _dof_constraints.end(); ++i)
<a name="l01018"></a>01018     {
<a name="l01019"></a>01019       unexpanded_set.insert(i-&gt;first);
<a name="l01020"></a>01020     }
<a name="l01021"></a>01021 
<a name="l01022"></a>01022   <span class="comment">// We have to keep recursing while the unexpanded set is</span>
<a name="l01023"></a>01023   <span class="comment">// nonempty on *any* processor</span>
<a name="l01024"></a>01024   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> unexpanded_set_nonempty = !unexpanded_set.empty();
<a name="l01025"></a>01025   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(unexpanded_set_nonempty);
<a name="l01026"></a>01026 
<a name="l01027"></a>01027   <span class="keywordflow">while</span> (unexpanded_set_nonempty)
<a name="l01028"></a>01028     {
<a name="l01029"></a>01029       <span class="comment">// Request set</span>
<a name="l01030"></a>01030       RCSet request_set;
<a name="l01031"></a>01031 
<a name="l01032"></a>01032       <span class="comment">// Request sets to send to each processor</span>
<a name="l01033"></a>01033       std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l01034"></a>01034         requested_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l01035"></a>01035 
<a name="l01036"></a>01036       <span class="comment">// And the sizes of each</span>
<a name="l01037"></a>01037       std::vector&lt;unsigned int&gt; ids_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l01038"></a>01038 
<a name="l01039"></a>01039       <span class="comment">// Fill (and thereby sort and uniq!) the main request set</span>
<a name="l01040"></a>01040       <span class="keywordflow">for</span> (RCSet::iterator i = unexpanded_set.begin();
<a name="l01041"></a>01041            i != unexpanded_set.end(); ++i)
<a name="l01042"></a>01042         {
<a name="l01043"></a>01043           <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[*i];
<a name="l01044"></a>01044           <span class="keywordflow">for</span> (DofConstraintRow::iterator j = row.begin();
<a name="l01045"></a>01045                j != row.end(); ++j)
<a name="l01046"></a>01046             request_set.insert(j-&gt;first);
<a name="l01047"></a>01047         }
<a name="l01048"></a>01048 
<a name="l01049"></a>01049       <span class="comment">// Clear the unexpanded constraint set; we&#39;re about to expand it</span>
<a name="l01050"></a>01050       unexpanded_set.clear();
<a name="l01051"></a>01051 
<a name="l01052"></a>01052       <span class="comment">// Count requests by processor</span>
<a name="l01053"></a>01053       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = 0;
<a name="l01054"></a>01054       <span class="keywordflow">for</span> (RCSet::iterator i = request_set.begin();
<a name="l01055"></a>01055            i != request_set.end(); ++i)
<a name="l01056"></a>01056         {
<a name="l01057"></a>01057           <span class="keywordflow">while</span> (*i &gt;= _end_df[proc_id])
<a name="l01058"></a>01058             proc_id++;
<a name="l01059"></a>01059           ids_on_proc[proc_id]++;
<a name="l01060"></a>01060         }
<a name="l01061"></a>01061       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p = 0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l01062"></a>01062         requested_ids[p].reserve(ids_on_proc[p]);
<a name="l01063"></a>01063 
<a name="l01064"></a>01064       <span class="comment">// Prepare each processor&#39;s request set</span>
<a name="l01065"></a>01065       proc_id = 0;
<a name="l01066"></a>01066       <span class="keywordflow">for</span> (RCSet::iterator i = request_set.begin();
<a name="l01067"></a>01067            i != request_set.end(); ++i)
<a name="l01068"></a>01068         {
<a name="l01069"></a>01069           <span class="keywordflow">while</span> (*i &gt;= _end_df[proc_id])
<a name="l01070"></a>01070             proc_id++;
<a name="l01071"></a>01071           requested_ids[proc_id].push_back(*i);
<a name="l01072"></a>01072         }
<a name="l01073"></a>01073 
<a name="l01074"></a>01074       <span class="comment">// Now request constraint rows from other processors</span>
<a name="l01075"></a>01075       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l01076"></a>01076         {
<a name="l01077"></a>01077           <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l01078"></a>01078           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l01079"></a>01079                                  <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l01080"></a>01080           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l01081"></a>01081                                    <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l01082"></a>01082                                    <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l01083"></a>01083           std::vector&lt;unsigned int&gt; request_to_fill;
<a name="l01084"></a>01084           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_ids[procup],
<a name="l01085"></a>01085                                  procdown, request_to_fill);
<a name="l01086"></a>01086 
<a name="l01087"></a>01087           <span class="comment">// Fill those requests</span>
<a name="l01088"></a>01088           std::vector&lt;std::vector&lt;unsigned int&gt; &gt; row_keys(request_to_fill.size());
<a name="l01089"></a>01089           std::vector&lt;std::vector&lt;Real&gt; &gt; row_vals(request_to_fill.size());
<a name="l01090"></a>01090           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill.size(); ++i)
<a name="l01091"></a>01091             {
<a name="l01092"></a>01092               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = request_to_fill[i];
<a name="l01093"></a>01093               <span class="keywordflow">if</span> (_dof_constraints.count(constrained))
<a name="l01094"></a>01094                 {
<a name="l01095"></a>01095                   <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[constrained];
<a name="l01096"></a>01096                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row_size = row.size();
<a name="l01097"></a>01097                   row_keys[i].reserve(row_size);
<a name="l01098"></a>01098                   row_vals[i].reserve(row_size);
<a name="l01099"></a>01099                   <span class="keywordflow">for</span> (DofConstraintRow::iterator j = row.begin();
<a name="l01100"></a>01100                        j != row.end(); ++j)
<a name="l01101"></a>01101                     {
<a name="l01102"></a>01102                       row_keys[i].push_back(j-&gt;first);
<a name="l01103"></a>01103                       row_vals[i].push_back(j-&gt;second);
<a name="l01104"></a>01104                     }
<a name="l01105"></a>01105                 }
<a name="l01106"></a>01106             }
<a name="l01107"></a>01107 
<a name="l01108"></a>01108           <span class="comment">// Trade back the results</span>
<a name="l01109"></a>01109           std::vector&lt;std::vector&lt;unsigned int&gt; &gt; filled_keys;
<a name="l01110"></a>01110           std::vector&lt;std::vector&lt;Real&gt; &gt; filled_vals;
<a name="l01111"></a>01111           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, row_keys,
<a name="l01112"></a>01112                                  procup, filled_keys);
<a name="l01113"></a>01113           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, row_vals,
<a name="l01114"></a>01114                                  procup, filled_vals);
<a name="l01115"></a>01115           libmesh_assert (filled_keys.size() == requested_ids[procup].size());
<a name="l01116"></a>01116           libmesh_assert (filled_vals.size() == requested_ids[procup].size());
<a name="l01117"></a>01117 
<a name="l01118"></a>01118           <span class="comment">// Add any new constraint rows we&#39;ve found</span>
<a name="l01119"></a>01119           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != requested_ids[procup].size(); ++i)
<a name="l01120"></a>01120             {
<a name="l01121"></a>01121               libmesh_assert (filled_keys[i].size() == filled_vals[i].size());
<a name="l01122"></a>01122               <span class="keywordflow">if</span> (!filled_keys[i].empty())
<a name="l01123"></a>01123                 {
<a name="l01124"></a>01124                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained = requested_ids[procup][i];
<a name="l01125"></a>01125                   <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a> &amp;row = _dof_constraints[constrained];
<a name="l01126"></a>01126                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != filled_keys[i].size(); ++j)
<a name="l01127"></a>01127                     row[filled_keys[i][j]] = filled_vals[i][j];
<a name="l01128"></a>01128 
<a name="l01129"></a>01129                   <span class="comment">// And prepare to check for more recursive constraints</span>
<a name="l01130"></a>01130                   unexpanded_set.insert(constrained);
<a name="l01131"></a>01131                 }
<a name="l01132"></a>01132             }
<a name="l01133"></a>01133         }
<a name="l01134"></a>01134 
<a name="l01135"></a>01135       <span class="comment">// We have to keep recursing while the unexpanded set is</span>
<a name="l01136"></a>01136       <span class="comment">// nonempty on *any* processor</span>
<a name="l01137"></a>01137       unexpanded_set_nonempty = !unexpanded_set.empty();
<a name="l01138"></a>01138       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(unexpanded_set_nonempty);
<a name="l01139"></a>01139     }
<a name="l01140"></a>01140 }
<a name="l01141"></a>01141 
<a name="l01142"></a>01142 
<a name="l01143"></a>01143 
<a name="l01144"></a><a class="code" href="classlibMesh_1_1DofMap.php#ad48c72b8add66781d21ad77a3febe59d">01144</a> <span class="keywordtype">void</span> DofMap::process_constraints ()
<a name="l01145"></a>01145 {
<a name="l01146"></a>01146   <span class="comment">// Create a set containing the DOFs we already depend on</span>
<a name="l01147"></a>01147   <span class="keyword">typedef</span> std::set&lt;unsigned int&gt; RCSet;
<a name="l01148"></a>01148   RCSet unexpanded_set;
<a name="l01149"></a>01149 
<a name="l01150"></a>01150   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l01151"></a>01151          i != _dof_constraints.end(); ++i)
<a name="l01152"></a>01152     unexpanded_set.insert(i-&gt;first);
<a name="l01153"></a>01153 
<a name="l01154"></a>01154   <span class="keywordflow">while</span> (!unexpanded_set.empty())
<a name="l01155"></a>01155     <span class="keywordflow">for</span> (RCSet::iterator i = unexpanded_set.begin();
<a name="l01156"></a>01156          i != unexpanded_set.end(); <span class="comment">/* nothing */</span>)
<a name="l01157"></a>01157       {
<a name="l01158"></a>01158         <span class="comment">// If the DOF is constrained</span>
<a name="l01159"></a>01159         DofConstraints::iterator
<a name="l01160"></a>01160           pos = _dof_constraints.find(*i);
<a name="l01161"></a>01161         
<a name="l01162"></a>01162         libmesh_assert (pos != _dof_constraints.end());
<a name="l01163"></a>01163         
<a name="l01164"></a>01164         <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = pos-&gt;second;
<a name="l01165"></a>01165 
<a name="l01166"></a>01166         std::vector&lt;unsigned int&gt; constraints_to_expand;
<a name="l01167"></a>01167 
<a name="l01168"></a>01168         <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l01169"></a>01169                it=constraint_row.begin(); it != constraint_row.end();
<a name="l01170"></a>01170              ++it)
<a name="l01171"></a>01171           <span class="keywordflow">if</span> (this-&gt;is_constrained_dof(it-&gt;first))
<a name="l01172"></a>01172             {
<a name="l01173"></a>01173               unexpanded_set.insert(it-&gt;first);
<a name="l01174"></a>01174               constraints_to_expand.push_back(it-&gt;first);
<a name="l01175"></a>01175             }
<a name="l01176"></a>01176 
<a name="l01177"></a>01177         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != constraints_to_expand.size();
<a name="l01178"></a>01178              ++j)
<a name="l01179"></a>01179           {
<a name="l01180"></a>01180             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> expandable = constraints_to_expand[j];
<a name="l01181"></a>01181 
<a name="l01182"></a>01182             DofConstraints::const_iterator
<a name="l01183"></a>01183               subpos = _dof_constraints.find(expandable);
<a name="l01184"></a>01184         
<a name="l01185"></a>01185             libmesh_assert (subpos != _dof_constraints.end());
<a name="l01186"></a>01186         
<a name="l01187"></a>01187             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; subconstraint_row = subpos-&gt;second;
<a name="l01188"></a>01188             
<a name="l01189"></a>01189             <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l01190"></a>01190                    it=subconstraint_row.begin();
<a name="l01191"></a>01191                    it != subconstraint_row.end(); ++it)
<a name="l01192"></a>01192               {
<a name="l01193"></a>01193                 constraint_row[it-&gt;first] += it-&gt;second *
<a name="l01194"></a>01194                                 constraint_row[expandable];
<a name="l01195"></a>01195               }
<a name="l01196"></a>01196             constraint_row.erase(expandable);
<a name="l01197"></a>01197           }
<a name="l01198"></a>01198 
<a name="l01199"></a>01199         <span class="keywordflow">if</span> (constraints_to_expand.empty())
<a name="l01200"></a>01200           unexpanded_set.erase(i++);
<a name="l01201"></a>01201         <span class="keywordflow">else</span>
<a name="l01202"></a>01202           i++;
<a name="l01203"></a>01203       }
<a name="l01204"></a>01204 
<a name="l01205"></a>01205   <span class="comment">// Now that we have our root constraint dependencies sorted out, add</span>
<a name="l01206"></a>01206   <span class="comment">// them to the send_list</span>
<a name="l01207"></a>01207   this-&gt;add_constraints_to_send_list();
<a name="l01208"></a>01208 }
<a name="l01209"></a>01209 
<a name="l01210"></a>01210 
<a name="l01211"></a>01211 
<a name="l01212"></a><a class="code" href="classlibMesh_1_1DofMap.php#a0783b9a05a297be8f1c3e630301e0604">01212</a> <span class="keywordtype">void</span> DofMap::add_constraints_to_send_list()
<a name="l01213"></a>01213 {
<a name="l01214"></a>01214   <span class="comment">// This function must be run on all processors at once</span>
<a name="l01215"></a>01215   parallel_only();
<a name="l01216"></a>01216 
<a name="l01217"></a>01217   <span class="comment">// Return immediately if there&#39;s nothing to gather</span>
<a name="l01218"></a>01218   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01219"></a>01219     <span class="keywordflow">return</span>;
<a name="l01220"></a>01220 
<a name="l01221"></a>01221   <span class="comment">// We might get to return immediately if none of the processors</span>
<a name="l01222"></a>01222   <span class="comment">// found any constraints</span>
<a name="l01223"></a>01223   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> has_constraints = !_dof_constraints.empty();
<a name="l01224"></a>01224   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(has_constraints);
<a name="l01225"></a>01225   <span class="keywordflow">if</span> (!has_constraints)
<a name="l01226"></a>01226     <span class="keywordflow">return</span>;
<a name="l01227"></a>01227 
<a name="l01228"></a>01228   <span class="keywordflow">for</span> (DofConstraints::iterator i = _dof_constraints.begin();
<a name="l01229"></a>01229          i != _dof_constraints.end(); ++i)
<a name="l01230"></a>01230     {
<a name="l01231"></a>01231       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constrained_dof = i-&gt;first;
<a name="l01232"></a>01232 
<a name="l01233"></a>01233       <span class="comment">// We only need the dependencies of our own constrained dofs</span>
<a name="l01234"></a>01234       <span class="keywordflow">if</span> (constrained_dof &lt; this-&gt;first_dof() || 
<a name="l01235"></a>01235           constrained_dof &gt;= this-&gt;end_dof())
<a name="l01236"></a>01236         <span class="keywordflow">continue</span>;
<a name="l01237"></a>01237 
<a name="l01238"></a>01238       <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = i-&gt;second;
<a name="l01239"></a>01239       <span class="keywordflow">for</span> (DofConstraintRow::const_iterator
<a name="l01240"></a>01240            j=constraint_row.begin(); j != constraint_row.end();
<a name="l01241"></a>01241            ++j)
<a name="l01242"></a>01242         {
<a name="l01243"></a>01243           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> constraint_dependency = j-&gt;first;
<a name="l01244"></a>01244 
<a name="l01245"></a>01245           <span class="comment">// No point in adding one of our own dofs to the send_list</span>
<a name="l01246"></a>01246           <span class="keywordflow">if</span> (constraint_dependency &gt;= this-&gt;first_dof() &amp;&amp; 
<a name="l01247"></a>01247               constraint_dependency &lt; this-&gt;end_dof())
<a name="l01248"></a>01248             <span class="keywordflow">continue</span>;
<a name="l01249"></a>01249 
<a name="l01250"></a>01250           _send_list.push_back(constraint_dependency);
<a name="l01251"></a>01251         }
<a name="l01252"></a>01252     }
<a name="l01253"></a>01253 }
<a name="l01254"></a>01254 
<a name="l01255"></a>01255 
<a name="l01256"></a>01256 
<a name="l01257"></a>01257 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR || LIBMESH_ENABLE_PERIODIC</span>
<a name="l01258"></a>01258 <span class="preprocessor"></span>
<a name="l01259"></a>01259 
<a name="l01260"></a>01260 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01261"></a>01261 <span class="preprocessor"></span>
<a name="l01262"></a><a class="code" href="classlibMesh_1_1DofMap.php#a1c8e17a57f38de4ae0060311b5497989">01262</a> <span class="keywordtype">void</span> DofMap::constrain_p_dofs (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l01263"></a>01263                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem,
<a name="l01264"></a>01264                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l01265"></a>01265                                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l01266"></a>01266 {
<a name="l01267"></a>01267   <span class="comment">// We&#39;re constraining dofs on elem which correspond to p refinement</span>
<a name="l01268"></a>01268   <span class="comment">// levels above p - this only makes sense if elem&#39;s p refinement</span>
<a name="l01269"></a>01269   <span class="comment">// level is above p.</span>
<a name="l01270"></a>01270   libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; p);
<a name="l01271"></a>01271   libmesh_assert(s &lt; elem-&gt;n_sides());
<a name="l01272"></a>01272 
<a name="l01273"></a>01273   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = this-&gt;sys_number();
<a name="l01274"></a>01274   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l01275"></a>01275   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l01276"></a>01276   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> low_p_fe_type = this-&gt;variable_type(var);
<a name="l01277"></a>01277   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> high_p_fe_type = this-&gt;variable_type(var);
<a name="l01278"></a>01278   low_p_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(low_p_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> + p);
<a name="l01279"></a>01279   high_p_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(high_p_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> + 
<a name="l01280"></a>01280                                             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l01281"></a>01281 
<a name="l01282"></a>01282   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l01283"></a>01283   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++n)
<a name="l01284"></a>01284     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a095386c4644b0478229289f281f2f8e4">is_node_on_side</a>(n, s))
<a name="l01285"></a>01285       {
<a name="l01286"></a>01286         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a> * <span class="keyword">const</span> node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l01287"></a>01287         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> low_nc =
<a name="l01288"></a>01288           FEInterface::n_dofs_at_node (dim, low_p_fe_type, type, n);
<a name="l01289"></a>01289         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> high_nc =
<a name="l01290"></a>01290           FEInterface::n_dofs_at_node (dim, high_p_fe_type, type, n);
<a name="l01291"></a>01291         
<a name="l01292"></a>01292         <span class="comment">// since we may be running this method concurretly </span>
<a name="l01293"></a>01293         <span class="comment">// on multiple threads we need to acquire a lock </span>
<a name="l01294"></a>01294         <span class="comment">// before modifying the _dof_constraints object.</span>
<a name="l01295"></a>01295         Threads::spin_mutex::scoped_lock lock(<a class="code" href="namespacelibMesh_1_1Threads.php#aba1ae5c24686d2cd2fc7ccdc9537c4f5">Threads::spin_mtx</a>);
<a name="l01296"></a>01296         
<a name="l01297"></a>01297         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac56e382d9871ff243a781940ee13ed87">is_vertex</a>(n))
<a name="l01298"></a>01298           {
<a name="l01299"></a>01299             <span class="comment">// Add &quot;this is zero&quot; constraint rows for high p vertex</span>
<a name="l01300"></a>01300             <span class="comment">// dofs</span>
<a name="l01301"></a>01301             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = low_nc; i != high_nc; ++i)
<a name="l01302"></a>01302               _dof_constraints[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var,i)].clear();
<a name="l01303"></a>01303           }
<a name="l01304"></a>01304         <span class="keywordflow">else</span>
<a name="l01305"></a>01305           {
<a name="l01306"></a>01306             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> total_dofs = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num, var);
<a name="l01307"></a>01307             libmesh_assert(total_dofs &gt;= high_nc);
<a name="l01308"></a>01308             <span class="comment">// Add &quot;this is zero&quot; constraint rows for high p</span>
<a name="l01309"></a>01309             <span class="comment">// non-vertex dofs, which are numbered in reverse</span>
<a name="l01310"></a>01310             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = low_nc; j != high_nc; ++j)
<a name="l01311"></a>01311               {
<a name="l01312"></a>01312                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = total_dofs - j - 1;
<a name="l01313"></a>01313                 _dof_constraints[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var,i)].clear();
<a name="l01314"></a>01314               }
<a name="l01315"></a>01315           }
<a name="l01316"></a>01316       }
<a name="l01317"></a>01317 }
<a name="l01318"></a>01318 
<a name="l01319"></a>01319 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l01320"></a>01320 <span class="preprocessor"></span>
<a name="l01321"></a>01321 
<a name="l01322"></a>01322 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l01323"></a>01323 <span class="preprocessor"></span>
<a name="l01324"></a><a class="code" href="classlibMesh_1_1DofMap.php#a2f0a90f17fba3db87f78f8813e111ac2">01324</a> <span class="keywordtype">void</span> DofMap::add_periodic_boundary (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a>&amp; periodic_boundary)
<a name="l01325"></a>01325 {
<a name="l01326"></a>01326   <span class="keywordflow">if</span> (_periodic_boundaries-&gt;boundary(periodic_boundary.<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>) == NULL)
<a name="l01327"></a>01327   {
<a name="l01328"></a>01328     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *boundary = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a>(periodic_boundary);
<a name="l01329"></a>01329     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *inverse_boundary = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a>(periodic_boundary, <span class="keyword">true</span>);
<a name="l01330"></a>01330 
<a name="l01331"></a>01331     std::pair&lt;unsigned int, PeriodicBoundary *&gt; bp
<a name="l01332"></a>01332       (boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>, boundary);
<a name="l01333"></a>01333     std::pair&lt;unsigned int, PeriodicBoundary *&gt; ibp
<a name="l01334"></a>01334       (boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>, inverse_boundary);
<a name="l01335"></a>01335 
<a name="l01336"></a>01336     _periodic_boundaries-&gt;insert(bp);
<a name="l01337"></a>01337     _periodic_boundaries-&gt;insert(ibp);
<a name="l01338"></a>01338   }
<a name="l01339"></a>01339   <span class="keywordflow">else</span>
<a name="l01340"></a>01340   {
<a name="l01341"></a>01341     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *boundary = _periodic_boundaries-&gt;boundary(periodic_boundary.<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>);
<a name="l01342"></a>01342     boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a94ca1680f846a5cc8537d39a7420eb8c">merge</a>(periodic_boundary);
<a name="l01343"></a>01343     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *inverse_boundary = _periodic_boundaries-&gt;boundary(periodic_boundary.<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>);
<a name="l01344"></a>01344     inverse_boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a94ca1680f846a5cc8537d39a7420eb8c">merge</a>(periodic_boundary);
<a name="l01345"></a>01345   }
<a name="l01346"></a>01346 }
<a name="l01347"></a>01347 
<a name="l01348"></a><a class="code" href="classlibMesh_1_1DofMap.php#ad683850a2762d9bbd2f4c8f4a12e749a">01348</a> <span class="keywordtype">void</span> DofMap::add_periodic_boundary (<a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> * boundary, <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> * inverse_boundary)
<a name="l01349"></a>01349 {
<a name="l01350"></a>01350   libmesh_assert(boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a> == inverse_boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>);
<a name="l01351"></a>01351   libmesh_assert(boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a> == inverse_boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>);
<a name="l01352"></a>01352 
<a name="l01353"></a>01353   std::pair&lt;unsigned int, PeriodicBoundary *&gt; bp(boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>, boundary);
<a name="l01354"></a>01354   std::pair&lt;unsigned int, PeriodicBoundary *&gt; ibp(inverse_boundary-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>, inverse_boundary);
<a name="l01355"></a>01355 
<a name="l01356"></a>01356   _periodic_boundaries-&gt;insert(bp);
<a name="l01357"></a>01357   _periodic_boundaries-&gt;insert(ibp);
<a name="l01358"></a>01358 }
<a name="l01359"></a>01359 
<a name="l01360"></a>01360 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01361"></a>01361 <span class="comment">// PeriodicBoundaries member functions</span>
<a name="l01362"></a>01362 
<a name="l01363"></a><a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#aa7921d23950abb00801648c34f389786">01363</a> PeriodicBoundaries::~PeriodicBoundaries()
<a name="l01364"></a>01364 {
<a name="l01365"></a>01365   <span class="keywordflow">for</span> (std::map&lt;unsigned, PeriodicBoundary *&gt;::iterator it = begin(); it != end(); ++it)
<a name="l01366"></a>01366     <span class="keyword">delete</span> it-&gt;second;
<a name="l01367"></a>01367 }
<a name="l01368"></a>01368 
<a name="l01369"></a><a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a06b6e333d6a0ffaee9252b703dfefede">01369</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *PeriodicBoundaries::neighbor(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundary_id,
<a name="l01370"></a>01370                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> &amp;point_locator,
<a name="l01371"></a>01371                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e,
<a name="l01372"></a>01372                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>)<span class="keyword"> const</span>
<a name="l01373"></a>01373 <span class="keyword"></span>{
<a name="l01374"></a>01374   <span class="comment">// Find a point on that side (and only that side)</span>
<a name="l01375"></a>01375 
<a name="l01376"></a>01376   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p = e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(side)-&gt;centroid();
<a name="l01377"></a>01377 
<a name="l01378"></a>01378   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *b = this-&gt;boundary(boundary_id);
<a name="l01379"></a>01379   libmesh_assert (b);
<a name="l01380"></a>01380   p = b-&gt;<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a27be85e1730579d906bad0d1703acfe2">get_corresponding_pos</a>(p);
<a name="l01381"></a>01381 
<a name="l01382"></a>01382   <span class="keywordflow">return</span> point_locator.operator()(p);
<a name="l01383"></a>01383 }
<a name="l01384"></a>01384 
<a name="l01385"></a>01385 <span class="preprocessor">#endif</span>
<a name="l01386"></a>01386 <span class="preprocessor"></span>
<a name="l01387"></a>01387 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
