<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">dof_object.h</div>  </div>
</div>
<div class="contents">
<a href="dof__object_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: dof_object.h 4356 2011-04-15 15:28:29Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __dof_object_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __dof_object_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span> <span class="comment">// libMesh::invalid_uint</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span>DofObject;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00056"></a><a class="code" href="classlibMesh_1_1DofObject.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;DofObject&gt;
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   
<a name="l00059"></a>00059 <span class="keyword">protected</span>:
<a name="l00060"></a>00060   
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1DofObject.php#a4685ab6cf8f8611b48c30b0485c45fc5">DofObject</a> ();
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="keyword">public</span>:
<a name="l00067"></a>00067   
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1DofObject.php#a4685ab6cf8f8611b48c30b0485c45fc5">DofObject</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>&amp;);
<a name="l00072"></a>00072 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1DofObject.php#aaff32e00c07a47bfe5eeb48b689d0db6">~DofObject</a> ();
<a name="l00077"></a>00077   
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>&amp; <a class="code" href="classlibMesh_1_1DofObject.php#a8b2eccbd4ec6516713c48e44388500e1">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>&amp; dof_obj);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>
<a name="l00089"></a><a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">00089</a>   <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>* <a class="code" href="classlibMesh_1_1DofObject.php#a8e674de36aaf3c03e7128dc04bac63a7">old_dof_object</a>;
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#adfd4147a2c6fe3213dde2bc8695c73a3">clear_old_dof_object</a> ();
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a085279db05ac736c3d82b8e7f76613df">set_old_dof_object</a> ();
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 <span class="preprocessor">#endif</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span>  
<a name="l00107"></a>00107   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#ad4dc74518a56da9b4b502a434ae0285c">clear_dofs</a> ();
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a5ef73de3da8ba46f8df5a793a49644a9">invalidate_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a56b4005a2da17ccc37cd71dd452081e7">invalidate_id</a> ();
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a080a5295fc4a41c1ab776a1a38c4be8d">invalidate_processor_id</a> ();
<a name="l00123"></a>00123 
<a name="l00127"></a>00127   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#aa3a334b9b9014db2bc40eb8a16a5c595">invalidate</a> ();
<a name="l00128"></a>00128   
<a name="l00134"></a>00134   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#aea91b1b15fa8dd5d12b900ecd38711da">n_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s, 
<a name="l00135"></a>00135                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var =
<a name="l00136"></a>00136                        <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00137"></a>00137   
<a name="l00141"></a>00141   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a> () <span class="keyword">const</span>;
<a name="l00142"></a>00142 
<a name="l00146"></a>00146   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a> ();
<a name="l00147"></a>00147 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1DofObject.php#a1f5bb18de17b38a292ee46e63a7d43be">00151</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00152"></a>00152   { this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a1f5bb18de17b38a292ee46e63a7d43be">set_id</a>() = <a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>; }
<a name="l00153"></a>00153 
<a name="l00158"></a>00158   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">valid_id</a> () <span class="keyword">const</span>;
<a name="l00159"></a>00159   
<a name="l00164"></a>00164   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a> () <span class="keyword">const</span>;
<a name="l00165"></a>00165   
<a name="l00170"></a>00170   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a> ();
<a name="l00171"></a>00171 
<a name="l00175"></a>00175   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00176"></a>00176 
<a name="l00181"></a>00181   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofObject.php#a9c11dc5a53d4840957e273764935c20f">valid_processor_id</a> () <span class="keyword">const</span>;
<a name="l00182"></a>00182   
<a name="l00187"></a>00187   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>() <span class="keyword">const</span>;
<a name="l00188"></a>00188 
<a name="l00192"></a>00192   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#aeb992cecba98cbbf1b682d25f4043b71">set_n_systems</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s);
<a name="l00193"></a>00193 
<a name="l00197"></a>00197   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a6b91c602ca66c3826c1c915aba225957">add_system</a> ();
<a name="l00198"></a>00198   
<a name="l00203"></a>00203   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00204"></a>00204   
<a name="l00209"></a>00209   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a9d7f627cb9f563b0a4341c17d550cd06">set_n_vars</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00210"></a>00210                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nvars);
<a name="l00211"></a>00211   
<a name="l00221"></a>00221   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00222"></a>00222                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var) <span class="keyword">const</span>;
<a name="l00223"></a>00223   
<a name="l00228"></a>00228   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a25df5d5f6f2436cf566954d7b97283db">set_n_comp</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00229"></a>00229                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00230"></a>00230                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ncomp);
<a name="l00231"></a>00231   
<a name="l00236"></a>00236   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00237"></a>00237                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00238"></a>00238                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp) <span class="keyword">const</span>;
<a name="l00239"></a>00239   
<a name="l00244"></a>00244   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00245"></a>00245                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00246"></a>00246                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp,
<a name="l00247"></a>00247                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dn);
<a name="l00248"></a>00248 
<a name="l00253"></a>00253   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofObject.php#a82a14ff8b37b674b380b9235c92d1ea3">has_dofs</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) <span class="keyword">const</span>;
<a name="l00254"></a>00254   
<a name="l00258"></a>00258 <span class="comment">//  virtual bool operator==(const DofObject&amp; ) const</span>
<a name="l00259"></a>00259 <span class="comment">//  { libmesh_error(); return false; }</span>
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   
<a name="l00265"></a><a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">00265</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">invalid_id</a> = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00266"></a>00266 
<a name="l00271"></a><a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">00271</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">invalid_processor_id</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(-1);
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   
<a name="l00274"></a>00274 <span class="keyword">private</span>:
<a name="l00275"></a>00275 
<a name="l00276"></a>00276   
<a name="l00280"></a><a class="code" href="classlibMesh_1_1DofObject.php#aeec11d5d3dc1f6c0a6e2469f112e1914">00280</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#aeec11d5d3dc1f6c0a6e2469f112e1914">_id</a>;
<a name="l00281"></a>00281 
<a name="l00291"></a><a class="code" href="classlibMesh_1_1DofObject.php#a333d76cb86bcef3dd66ca455de72fea4">00291</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a333d76cb86bcef3dd66ca455de72fea4">_processor_id</a>;
<a name="l00292"></a>00292 
<a name="l00296"></a><a class="code" href="classlibMesh_1_1DofObject.php#adbd711ffffe00d9a8f256d672c52cc69">00296</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1DofObject.php#adbd711ffffe00d9a8f256d672c52cc69">_n_systems</a>;
<a name="l00297"></a>00297 
<a name="l00306"></a><a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">00306</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> **<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a>;
<a name="l00307"></a>00307 
<a name="l00312"></a><a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">00312</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> **<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>;
<a name="l00313"></a>00313 };
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 <span class="comment">//------------------------------------------------------</span>
<a name="l00318"></a>00318 <span class="comment">// Inline functions</span>
<a name="l00319"></a>00319 <span class="keyword">inline</span>
<a name="l00320"></a><a class="code" href="classlibMesh_1_1DofObject.php#a4685ab6cf8f8611b48c30b0485c45fc5">00320</a> <a class="code" href="classlibMesh_1_1DofObject.php#a4685ab6cf8f8611b48c30b0485c45fc5">DofObject::DofObject</a> () :
<a name="l00321"></a>00321 #ifdef LIBMESH_ENABLE_AMR
<a name="l00322"></a>00322   old_dof_object(NULL),
<a name="l00323"></a>00323 #endif
<a name="l00324"></a>00324   _id (invalid_id),
<a name="l00325"></a>00325   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#a6a7e7a746767771468fcc0c6e165edfc">_processor_id</a> (invalid_processor_id),
<a name="l00326"></a>00326   _n_systems  (0),
<a name="l00327"></a>00327   _n_v_comp (NULL),
<a name="l00328"></a>00328   _dof_ids (NULL)
<a name="l00329"></a>00329 {
<a name="l00330"></a>00330   this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aa3a334b9b9014db2bc40eb8a16a5c595">invalidate</a>();
<a name="l00331"></a>00331 }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 <span class="keyword">inline</span>
<a name="l00338"></a><a class="code" href="classlibMesh_1_1DofObject.php#aaff32e00c07a47bfe5eeb48b689d0db6">00338</a> <a class="code" href="classlibMesh_1_1DofObject.php#aaff32e00c07a47bfe5eeb48b689d0db6">DofObject::~DofObject</a> ()
<a name="l00339"></a>00339 {
<a name="l00340"></a>00340   <span class="comment">// Free all memory.</span>
<a name="l00341"></a>00341 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00342"></a>00342 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#adfd4147a2c6fe3213dde2bc8695c73a3">clear_old_dof_object</a> ();
<a name="l00343"></a>00343 <span class="preprocessor">#endif</span>
<a name="l00344"></a>00344 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ad4dc74518a56da9b4b502a434ae0285c">clear_dofs</a> ();
<a name="l00345"></a>00345 }
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 <span class="keyword">inline</span>
<a name="l00350"></a><a class="code" href="classlibMesh_1_1DofObject.php#a5ef73de3da8ba46f8df5a793a49644a9">00350</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a5ef73de3da8ba46f8df5a793a49644a9">DofObject::invalidate_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num)
<a name="l00351"></a>00351 {
<a name="l00352"></a>00352   <span class="comment">// If the user does not specify the system number...</span>
<a name="l00353"></a>00353   <span class="keywordflow">if</span> (sys_num &gt;= this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>()) 
<a name="l00354"></a>00354     {
<a name="l00355"></a>00355       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>(); s++)
<a name="l00356"></a>00356         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(s); v++)
<a name="l00357"></a>00357           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(s,v))
<a name="l00358"></a>00358             this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(s,v,0,<a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">invalid_id</a>);
<a name="l00359"></a>00359     }
<a name="l00360"></a>00360   <span class="comment">// ...otherwise invalidate the dofs for all systems</span>
<a name="l00361"></a>00361   <span class="keywordflow">else</span>
<a name="l00362"></a>00362     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(sys_num); v++)
<a name="l00363"></a>00363       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(sys_num,v))
<a name="l00364"></a>00364         this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#ae48fb571482cb01744308449089ca6ee">set_dof_number</a>(sys_num,v,0,<a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">invalid_id</a>);
<a name="l00365"></a>00365 }
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 <span class="keyword">inline</span>
<a name="l00370"></a><a class="code" href="classlibMesh_1_1DofObject.php#a56b4005a2da17ccc37cd71dd452081e7">00370</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a56b4005a2da17ccc37cd71dd452081e7">DofObject::invalidate_id</a> ()
<a name="l00371"></a>00371 {
<a name="l00372"></a>00372   this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a> (<a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">invalid_id</a>);
<a name="l00373"></a>00373 }
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 <span class="keyword">inline</span>
<a name="l00378"></a><a class="code" href="classlibMesh_1_1DofObject.php#a080a5295fc4a41c1ab776a1a38c4be8d">00378</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#a080a5295fc4a41c1ab776a1a38c4be8d">DofObject::invalidate_processor_id</a> ()
<a name="l00379"></a>00379 {
<a name="l00380"></a>00380   this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a> (<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">invalid_processor_id</a>);
<a name="l00381"></a>00381 }
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="keyword">inline</span>
<a name="l00386"></a><a class="code" href="classlibMesh_1_1DofObject.php#aa3a334b9b9014db2bc40eb8a16a5c595">00386</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#aa3a334b9b9014db2bc40eb8a16a5c595">DofObject::invalidate</a> ()
<a name="l00387"></a>00387 {
<a name="l00388"></a>00388   this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a5ef73de3da8ba46f8df5a793a49644a9">invalidate_dofs</a> ();
<a name="l00389"></a>00389   this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a56b4005a2da17ccc37cd71dd452081e7">invalidate_id</a> ();
<a name="l00390"></a>00390   this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a080a5295fc4a41c1ab776a1a38c4be8d">invalidate_processor_id</a> ();
<a name="l00391"></a>00391 }
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 <span class="keyword">inline</span>
<a name="l00396"></a><a class="code" href="classlibMesh_1_1DofObject.php#ad4dc74518a56da9b4b502a434ae0285c">00396</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#ad4dc74518a56da9b4b502a434ae0285c">DofObject::clear_dofs</a> ()
<a name="l00397"></a>00397 {
<a name="l00398"></a>00398   <span class="comment">// Only clear if there is data</span>
<a name="l00399"></a>00399   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>() != 0)
<a name="l00400"></a>00400     {
<a name="l00401"></a>00401       libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a> != NULL);
<a name="l00402"></a>00402       libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>  != NULL);
<a name="l00403"></a>00403       
<a name="l00404"></a>00404       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>(); s++)
<a name="l00405"></a>00405         {
<a name="l00406"></a>00406           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>[s] != NULL) <span class="comment">// This has only been allocated if </span>
<a name="l00407"></a>00407             {                      <span class="comment">// variables were declared</span>
<a name="l00408"></a>00408               <span class="keyword">delete</span> [] <a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>[s]; <a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>[s] = NULL;
<a name="l00409"></a>00409             }
<a name="l00410"></a>00410           
<a name="l00411"></a>00411           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a>[s] != NULL) <span class="comment">// it is possible the number of variables is 0,</span>
<a name="l00412"></a>00412             {                       <span class="comment">// but this was allocated (_n_v_comp[s][0] == 0)</span>
<a name="l00413"></a>00413               <span class="keyword">delete</span> [] <a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a>[s]; <a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a>[s] = NULL;
<a name="l00414"></a>00414             }
<a name="l00415"></a>00415         }
<a name="l00416"></a>00416       
<a name="l00417"></a>00417       <span class="keyword">delete</span> [] <a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a>; <a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a> = NULL;
<a name="l00418"></a>00418       <span class="keyword">delete</span> [] <a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>;  <a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>  = NULL;
<a name="l00419"></a>00419     }
<a name="l00420"></a>00420   
<a name="l00421"></a>00421   <span class="comment">// Make sure we cleaned up</span>
<a name="l00422"></a>00422   <span class="comment">// (or there was nothing there)</span>
<a name="l00423"></a>00423   libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a> == NULL);
<a name="l00424"></a>00424   libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>  == NULL);
<a name="l00425"></a>00425   
<a name="l00426"></a>00426   <span class="comment">// No systems now.</span>
<a name="l00427"></a>00427   <a class="code" href="classlibMesh_1_1DofObject.php#adbd711ffffe00d9a8f256d672c52cc69">_n_systems</a> = 0;
<a name="l00428"></a>00428 }
<a name="l00429"></a>00429   
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 <span class="keyword">inline</span>
<a name="l00433"></a><a class="code" href="classlibMesh_1_1DofObject.php#aea91b1b15fa8dd5d12b900ecd38711da">00433</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#aea91b1b15fa8dd5d12b900ecd38711da">DofObject::n_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00434"></a>00434                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00435"></a>00435 <span class="keyword"></span>{
<a name="l00436"></a>00436   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>());
<a name="l00437"></a>00437   
<a name="l00438"></a>00438   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = 0;
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   <span class="comment">// Count all variables</span>
<a name="l00441"></a>00441   <span class="keywordflow">if</span> (var == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00442"></a>00442     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(s); v++)
<a name="l00443"></a>00443       num += this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(s,v);
<a name="l00444"></a>00444   
<a name="l00445"></a>00445   <span class="comment">// Only count specified variable</span>
<a name="l00446"></a>00446   <span class="keywordflow">else</span>
<a name="l00447"></a>00447     {
<a name="l00448"></a>00448       num = this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(s,var);
<a name="l00449"></a>00449     }
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   <span class="keywordflow">return</span> num;
<a name="l00452"></a>00452 }
<a name="l00453"></a>00453 
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 <span class="keyword">inline</span>
<a name="l00457"></a><a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">00457</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">DofObject::id</a> ()<span class="keyword"> const</span>
<a name="l00458"></a>00458 <span class="keyword"></span>{
<a name="l00459"></a>00459   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">valid_id</a>());
<a name="l00460"></a>00460   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofObject.php#aeec11d5d3dc1f6c0a6e2469f112e1914">_id</a>;
<a name="l00461"></a>00461 }
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 <span class="keyword">inline</span>
<a name="l00466"></a><a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">00466</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">DofObject::set_id</a> ()
<a name="l00467"></a>00467 {
<a name="l00468"></a>00468   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofObject.php#aeec11d5d3dc1f6c0a6e2469f112e1914">_id</a>;
<a name="l00469"></a>00469 }
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 
<a name="l00472"></a>00472 
<a name="l00473"></a>00473 <span class="keyword">inline</span>
<a name="l00474"></a><a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">00474</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">DofObject::valid_id</a> ()<span class="keyword"> const</span>
<a name="l00475"></a>00475 <span class="keyword"></span>{
<a name="l00476"></a>00476   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a> != <a class="code" href="classlibMesh_1_1DofObject.php#aeec11d5d3dc1f6c0a6e2469f112e1914">_id</a>);
<a name="l00477"></a>00477 }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 <span class="keyword">inline</span>
<a name="l00481"></a><a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">00481</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">DofObject::processor_id</a> ()<span class="keyword"> const</span>
<a name="l00482"></a>00482 <span class="keyword"></span>{
<a name="l00483"></a>00483   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofObject.php#a333d76cb86bcef3dd66ca455de72fea4">_processor_id</a>;
<a name="l00484"></a>00484 }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 <span class="keyword">inline</span>
<a name="l00489"></a><a class="code" href="classlibMesh_1_1DofObject.php#a898023f7298400e051325057bf6d4375">00489</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">DofObject::processor_id</a> ()
<a name="l00490"></a>00490 {
<a name="l00491"></a>00491   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofObject.php#a333d76cb86bcef3dd66ca455de72fea4">_processor_id</a>;
<a name="l00492"></a>00492 }
<a name="l00493"></a>00493 
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 <span class="keyword">inline</span>
<a name="l00497"></a><a class="code" href="classlibMesh_1_1DofObject.php#a669da7bb0b6db8c474ec23ab0485bf77">00497</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">DofObject::processor_id</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00498"></a>00498 {
<a name="l00499"></a>00499 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00500"></a>00500 <span class="preprocessor"></span>  
<a name="l00501"></a>00501   <span class="keywordflow">if</span> (<span class="keywordtype">id</span> != static_cast&lt;unsigned int&gt;(static_cast&lt;unsigned short int&gt;(<span class="keywordtype">id</span>)))
<a name="l00502"></a>00502     {
<a name="l00503"></a>00503       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: id too large for unsigned short int!&quot;</span> &lt;&lt; std::endl
<a name="l00504"></a>00504                     &lt;&lt; <span class="stringliteral">&quot;Recompile with DofObject::_processor_id larger!&quot;</span> &lt;&lt; std::endl;
<a name="l00505"></a>00505       
<a name="l00506"></a>00506       libmesh_error();
<a name="l00507"></a>00507     }
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 <span class="preprocessor">#endif</span>
<a name="l00510"></a>00510 <span class="preprocessor"></span>  
<a name="l00511"></a>00511   this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = <a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>;
<a name="l00512"></a>00512 }
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 <span class="keyword">inline</span>
<a name="l00517"></a><a class="code" href="classlibMesh_1_1DofObject.php#a9c11dc5a53d4840957e273764935c20f">00517</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofObject.php#a9c11dc5a53d4840957e273764935c20f">DofObject::valid_processor_id</a> ()<span class="keyword"> const</span>
<a name="l00518"></a>00518 <span class="keyword"></span>{
<a name="l00519"></a>00519   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a> != <a class="code" href="classlibMesh_1_1DofObject.php#a333d76cb86bcef3dd66ca455de72fea4">_processor_id</a>);
<a name="l00520"></a>00520 }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 <span class="keyword">inline</span>
<a name="l00525"></a><a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">00525</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">DofObject::n_systems</a> ()<span class="keyword"> const</span>
<a name="l00526"></a>00526 <span class="keyword"></span>{
<a name="l00527"></a>00527   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1DofObject.php#adbd711ffffe00d9a8f256d672c52cc69">_n_systems</a>);
<a name="l00528"></a>00528 }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 <span class="keyword">inline</span>
<a name="l00533"></a><a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">00533</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">DofObject::n_vars</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00534"></a>00534 <span class="keyword"></span>{
<a name="l00535"></a>00535   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>());
<a name="l00536"></a>00536   libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a> != NULL);
<a name="l00537"></a>00537   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a>[s] == NULL)
<a name="l00538"></a>00538     <span class="keywordflow">return</span> 0;
<a name="l00539"></a>00539   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a>[s][0]);
<a name="l00540"></a>00540 }
<a name="l00541"></a>00541 
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 <span class="keyword">inline</span>
<a name="l00546"></a><a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">00546</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">DofObject::n_comp</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00547"></a>00547                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)<span class="keyword"> const</span>
<a name="l00548"></a>00548 <span class="keyword"></span>{
<a name="l00549"></a>00549   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>());
<a name="l00550"></a>00550   libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a> != NULL);
<a name="l00551"></a>00551   libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>[s] != NULL);
<a name="l00552"></a>00552   libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a> != NULL);
<a name="l00553"></a>00553   libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a>[s] != NULL);
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 <span class="preprocessor"># ifdef DEBUG</span>
<a name="l00556"></a>00556 <span class="preprocessor"></span>  <span class="comment">// Does this ever happen?  I doubt it... 3/7/2003 (BSK)</span>
<a name="l00557"></a>00557   <span class="keywordflow">if</span> (var &gt;= this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(s))
<a name="l00558"></a>00558     {
<a name="l00559"></a>00559       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;s=&quot;</span> &lt;&lt; s &lt;&lt; <span class="stringliteral">&quot;, var=&quot;</span> &lt;&lt; var &lt;&lt; std::endl
<a name="l00560"></a>00560                     &lt;&lt; <span class="stringliteral">&quot;this-&gt;n_vars(s)=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(s) &lt;&lt; std::endl
<a name="l00561"></a>00561                     &lt;&lt; <span class="stringliteral">&quot;this-&gt;n_systems()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>() &lt;&lt; std::endl;
<a name="l00562"></a>00562       libmesh_error();
<a name="l00563"></a>00563     }
<a name="l00564"></a>00564 <span class="preprocessor"># endif</span>
<a name="l00565"></a>00565 <span class="preprocessor"></span>  
<a name="l00566"></a>00566   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1DofObject.php#ad01d76b2a540ae96322ec22c1c3bee8f">_n_v_comp</a>[s][var+1]);
<a name="l00567"></a>00567 }
<a name="l00568"></a>00568 
<a name="l00569"></a>00569 
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 <span class="keyword">inline</span>
<a name="l00572"></a><a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">00572</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">DofObject::dof_number</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00573"></a>00573                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00574"></a>00574                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comp)<span class="keyword"> const</span>
<a name="l00575"></a>00575 <span class="keyword"></span>{
<a name="l00576"></a>00576   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>());
<a name="l00577"></a>00577   libmesh_assert (var  &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(s));
<a name="l00578"></a>00578   libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a> != NULL);
<a name="l00579"></a>00579   libmesh_assert (<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>[s] != NULL);  
<a name="l00580"></a>00580   libmesh_assert (comp &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6710a2bb047a60ef54bfe702432114f8">n_comp</a>(s,var));
<a name="l00581"></a>00581   
<a name="l00582"></a>00582   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>[s][var] == <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">invalid_id</a>)
<a name="l00583"></a>00583     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">invalid_id</a>;
<a name="l00584"></a>00584   <span class="keywordflow">else</span>
<a name="l00585"></a>00585     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1DofObject.php#a30089ef24ebd6995751d7508554cde2d">_dof_ids</a>[s][var] + comp);
<a name="l00586"></a>00586 }
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 <span class="keyword">inline</span>
<a name="l00591"></a><a class="code" href="classlibMesh_1_1DofObject.php#a82a14ff8b37b674b380b9235c92d1ea3">00591</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1DofObject.php#a82a14ff8b37b674b380b9235c92d1ea3">DofObject::has_dofs</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys)<span class="keyword"> const</span>
<a name="l00592"></a>00592 <span class="keyword"></span>{
<a name="l00593"></a>00593   <span class="keywordflow">if</span> (sys == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00594"></a>00594     {
<a name="l00595"></a>00595       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>(); s++)
<a name="l00596"></a>00596         <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(s))
<a name="l00597"></a>00597           <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00598"></a>00598     }
<a name="l00599"></a>00599   
<a name="l00600"></a>00600   <span class="keywordflow">else</span>
<a name="l00601"></a>00601     {
<a name="l00602"></a>00602       libmesh_assert (sys &lt; this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>());
<a name="l00603"></a>00603 
<a name="l00604"></a>00604       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7c666bde4f1a0a23a8661afc52621a44">n_vars</a>(sys))
<a name="l00605"></a>00605         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00606"></a>00606     }
<a name="l00607"></a>00607   
<a name="l00608"></a>00608   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00609"></a>00609 }
<a name="l00610"></a>00610   
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 } <span class="comment">// namespace libMesh</span>
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 <span class="preprocessor">#endif // #ifndef __dof_object_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
