<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">edge.h</div>  </div>
</div>
<div class="contents">
<a href="edge_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __edge_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __edge_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>Mesh;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// Edge class definition</span>
<a name="l00046"></a><a class="code" href="classlibMesh_1_1Edge.php">00046</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Edge.php">Edge</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048  <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1Edge.php#ac78088ee6ccca4948423824196eaa0ae">00054</a>   <a class="code" href="classlibMesh_1_1Edge.php#ac78088ee6ccca4948423824196eaa0ae">Edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00055"></a>00055         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00056"></a>00056     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>(nn, <a class="code" href="classlibMesh_1_1Edge.php">Edge</a>::<a class="code" href="classlibMesh_1_1Edge.php#ae7003fb0aeecc59d63291b8daefce85e">n_sides</a>(), p) {}
<a name="l00057"></a>00057    
<a name="l00062"></a><a class="code" href="classlibMesh_1_1Edge.php#a3777f86681f6b40700994a8d3603e106">00062</a>   <a class="code" href="classlibMesh_1_1Edge.php#ac78088ee6ccca4948423824196eaa0ae">Edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00063"></a>00063         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00064"></a>00064         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00065"></a>00065     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>(nn, ns, p) {}
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1Edge.php#acf6538dc7598d97e7ea9fe6516c07b31">00070</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge.php#acf6538dc7598d97e7ea9fe6516c07b31">dim</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00071"></a>00071   
<a name="l00075"></a><a class="code" href="classlibMesh_1_1Edge.php#a34bfea679ccd34cc5fb103cd5cebac74">00075</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge.php#a34bfea679ccd34cc5fb103cd5cebac74">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1Edge.php#ae7003fb0aeecc59d63291b8daefce85e">00080</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge.php#ae7003fb0aeecc59d63291b8daefce85e">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00081"></a>00081 
<a name="l00085"></a><a class="code" href="classlibMesh_1_1Edge.php#a79e827f09e107c26c7515e7c5c45c9f7">00085</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge.php#a79e827f09e107c26c7515e7c5c45c9f7">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00086"></a>00086   
<a name="l00090"></a><a class="code" href="classlibMesh_1_1Edge.php#a8812e222e5410e9ed87128c8883cbc60">00090</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge.php#a8812e222e5410e9ed87128c8883cbc60">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00091"></a>00091   
<a name="l00095"></a><a class="code" href="classlibMesh_1_1Edge.php#add8a7894827d3883258a0cbd1cd6b1db">00095</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge.php#add8a7894827d3883258a0cbd1cd6b1db">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00096"></a>00096   
<a name="l00100"></a><a class="code" href="classlibMesh_1_1Edge.php#a22aeaa91c95baf95d0c7a90cd32d0024">00100</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge.php#a22aeaa91c95baf95d0c7a90cd32d0024">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">/*</span>
<a name="l00103"></a>00103 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00104"></a>00104 <span class="comment">   * specified side</span>
<a name="l00105"></a>00105 <span class="comment">   */</span>
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge.php#a74c206366376dadafb023d3c1c6913ab">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00107"></a>00107                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00108"></a>00108   
<a name="l00109"></a>00109 <span class="comment">//   /**</span>
<a name="l00110"></a>00110 <span class="comment">//    * @returns 1</span>
<a name="l00111"></a>00111 <span class="comment">//    */</span>
<a name="l00112"></a>00112 <span class="comment">//   unsigned int n_children_per_side(const unsigned int) const { return 1; }</span>
<a name="l00113"></a>00113   
<a name="l00119"></a><a class="code" href="classlibMesh_1_1Edge.php#a2a1bb53c398f8e16bf06ccc11cbc1d25">00119</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge.php#a2a1bb53c398f8e16bf06ccc11cbc1d25">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00120"></a>00120 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(s)); }
<a name="l00121"></a>00121   
<a name="l00126"></a>00126   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Edge.php#abbd4dc5d3b30ead01e0828b147d7f64d">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00127"></a>00127 
<a name="l00132"></a>00132   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Edge.php#a50d7c03372795905b58d6bee74b705ea">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00133"></a>00133                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00134"></a>00134 
<a name="l00138"></a><a class="code" href="classlibMesh_1_1Edge.php#ab536b0cf00d06d6989229230ab1037c1">00138</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Edge.php#ab536b0cf00d06d6989229230ab1037c1">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) <span class="keyword">const</span>
<a name="l00139"></a>00139   <span class="comment">//{ libmesh_assert(i &lt; n_nodes()); AutoPtr&lt;DofObject&gt; ap(new Node(*get_node(i))); return ap; }</span>
<a name="l00140"></a>00140   { libmesh_error(); <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL); <span class="keywordflow">return</span> ap; }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   
<a name="l00143"></a>00143  <span class="keyword">protected</span>:
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span>  
<a name="l00151"></a><a class="code" href="classlibMesh_1_1Edge.php#a5c1a7d331336a931f2afd7c7a6981616">00151</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge.php#a5c1a7d331336a931f2afd7c7a6981616">side_children_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, 
<a name="l00152"></a>00152                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00153"></a>00153 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>  
<a name="l00157"></a>00157 };
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00164"></a>00164 <span class="comment">// Edge class member functions</span>
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 } <span class="comment">// namespace libMesh</span>
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
