<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">edge_edge2.h</div>  </div>
</div>
<div class="contents">
<a href="edge__edge2_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge_edge2.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __edge2_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __edge2_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="edge_8h.php">edge.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// Edge class definition</span>
<a name="l00048"></a><a class="code" href="classlibMesh_1_1Edge2.php">00048</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Edge2.php">Edge2</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Edge.php">Edge</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050  <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1Edge2.php#abb434acbd30f6d8de767fea5c9a662e7">00055</a>   <a class="code" href="classlibMesh_1_1Edge2.php#abb434acbd30f6d8de767fea5c9a662e7">Edge2</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL) :
<a name="l00056"></a>00056     <a class="code" href="classlibMesh_1_1Edge.php">Edge</a>(<a class="code" href="classlibMesh_1_1Edge2.php">Edge2</a>::<a class="code" href="classlibMesh_1_1Edge.php#a34bfea679ccd34cc5fb103cd5cebac74">n_nodes</a>(), p) {} 
<a name="l00057"></a>00057 
<a name="l00062"></a><a class="code" href="classlibMesh_1_1Edge2.php#a7826a22b92350805d57f6cd0ec5fcffe">00062</a>   <a class="code" href="classlibMesh_1_1Edge2.php#abb434acbd30f6d8de767fea5c9a662e7">Edge2</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00063"></a>00063          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00064"></a>00064          <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00065"></a>00065     <a class="code" href="classlibMesh_1_1Edge.php">Edge</a>(nn, p) { libmesh_assert (ns == 0); }
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1Edge2.php#a6f856848c9d384401f1ea832a0101296">00070</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Edge2.php#a6f856848c9d384401f1ea832a0101296">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00071"></a>00071   
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge2.php#a7cd97ed0684bc8a949b816c91a6d0983">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00076"></a>00076 
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge2.php#a6960cfb766cf7d893ade066b86deef14">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00081"></a>00081 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge2.php#aec9901f386f00f9ec6ec66c44bd21360">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   <span class="comment">/*</span>
<a name="l00088"></a>00088 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00089"></a>00089 <span class="comment">   * specified side</span>
<a name="l00090"></a>00090 <span class="comment">   */</span>
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge2.php#a99ce56ef4289d985fd172a2abb3f934d">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00092"></a>00092                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="comment">/*</span>
<a name="l00095"></a>00095 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00096"></a>00096 <span class="comment">   * specified edge (i.e. &quot;returns true&quot; in 1D)</span>
<a name="l00097"></a>00097 <span class="comment">   */</span>
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge2.php#afa5453aa99298cbb6afabd8e6bc948d5">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00099"></a>00099                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">/*</span>
<a name="l00102"></a>00102 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00103"></a>00103 <span class="comment">   * numerical tolerances</span>
<a name="l00104"></a>00104 <span class="comment">   */</span>
<a name="l00105"></a><a class="code" href="classlibMesh_1_1Edge2.php#a74f79ff7232d7440ffb50ca7089f4af1">00105</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge2.php#a74f79ff7232d7440ffb50ca7089f4af1">has_affine_map</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00106"></a>00106 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1Edge2.php#a40a897ce75548071dd8fcad96999f894">00110</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Edge2.php#a40a897ce75548071dd8fcad96999f894">type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>; }
<a name="l00111"></a>00111   
<a name="l00115"></a><a class="code" href="classlibMesh_1_1Edge2.php#a97e1db1bd5b872699918b2a9d3331fb9">00115</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1Edge2.php#a97e1db1bd5b872699918b2a9d3331fb9">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Edge2.php#a4ce73cc672a38f69f9529a93c4b0739f">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00118"></a>00118                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00119"></a>00119                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Edge2.php#a184495697b347868540c1619395dcf17">volume</a> () <span class="keyword">const</span>;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span>
<a name="l00131"></a><a class="code" href="classlibMesh_1_1Edge2.php#a3be02fa275d70466e45b7f8952b0e4bc">00131</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge2.php#a3be02fa275d70466e45b7f8952b0e4bc">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="preprocessor">#endif</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>
<a name="l00135"></a>00135   
<a name="l00136"></a>00136 <span class="keyword">protected</span>:
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   
<a name="l00139"></a>00139 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00140"></a>00140 <span class="preprocessor"></span>
<a name="l00144"></a><a class="code" href="classlibMesh_1_1Edge2.php#a59411ef6cda2d88d912870aef3a7e9a3">00144</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Edge2.php#a59411ef6cda2d88d912870aef3a7e9a3">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00145"></a>00145                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00146"></a>00146                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00147"></a>00147 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Edge2.php#a7796f45b768f9cd6c1da88a75cd7c319">_embedding_matrix</a>[i][j][k]; }
<a name="l00148"></a>00148   
<a name="l00153"></a><a class="code" href="classlibMesh_1_1Edge2.php#a7796f45b768f9cd6c1da88a75cd7c319">00153</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Edge2.php#a7796f45b768f9cd6c1da88a75cd7c319">_embedding_matrix</a>[2][2][2];
<a name="l00154"></a>00154   
<a name="l00155"></a>00155 <span class="preprocessor">#endif</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>};
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 } <span class="comment">// namespace libMesh</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
