<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">edge_edge3.C</div>  </div>
</div>
<div class="contents">
<a href="edge__edge3_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge_edge3.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Edge3.php#a294f46a3f24fad96ff8e4fbdff2802d4">Edge3::_embedding_matrix</a>[2][3][3] =
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032   <span class="comment">// embedding matrix for child 0</span>
<a name="l00033"></a>00033   {
<a name="l00034"></a>00034     <span class="comment">// 0    1    2  </span>
<a name="l00035"></a>00035     {1.0, 0.0, 0.0}, <span class="comment">// left</span>
<a name="l00036"></a>00036     {0.0, 0.0, 1.0}, <span class="comment">// right</span>
<a name="l00037"></a>00037     {3./8.,-1./8.,0.75} <span class="comment">// middle</span>
<a name="l00038"></a>00038   },
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   <span class="comment">// embedding matrix for child 1</span>
<a name="l00041"></a>00041   {
<a name="l00042"></a>00042     <span class="comment">// 0    1    2  </span>
<a name="l00043"></a>00043     {0.0, 0.0, 1.0}, <span class="comment">// left</span>
<a name="l00044"></a>00044     {0.0, 1.0, 0.0},  <span class="comment">// right</span>
<a name="l00045"></a>00045     {-1./8.,3./8.,0.75} <span class="comment">// middle</span>
<a name="l00046"></a>00046   }
<a name="l00047"></a>00047 };
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a><a class="code" href="classlibMesh_1_1Edge3.php#a9962591f5fb9ae6634e17ae08198d3c8">00051</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge3.php#a9962591f5fb9ae6634e17ae08198d3c8">Edge3::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00052"></a>00052 <span class="keyword"></span>{
<a name="l00053"></a>00053   <span class="keywordflow">if</span> (i &lt; 2)
<a name="l00054"></a>00054     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00055"></a>00055   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00056"></a>00056 }
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1Edge3.php#a410125c0e7213a670005541ae036cccc">00058</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge3.php#a410125c0e7213a670005541ae036cccc">Edge3::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00059"></a>00059 <span class="keyword"></span>{
<a name="l00060"></a>00060   <span class="keywordflow">if</span> (i &lt; 2)
<a name="l00061"></a>00061    <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00062"></a>00062   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1Edge3.php#ac9dc49b98efd7e4e1195f9e477b37b03">00065</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge3.php#ac9dc49b98efd7e4e1195f9e477b37b03">Edge3::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> )<span class="keyword"> const</span>
<a name="l00066"></a>00066 <span class="keyword"></span>{
<a name="l00067"></a>00067   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1Edge3.php#a0a37631ed4fb56c8b9cb312e8d8390bb">00070</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge3.php#a0a37631ed4fb56c8b9cb312e8d8390bb">Edge3::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00071"></a>00071                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00072"></a>00072 <span class="keyword"></span>{
<a name="l00073"></a>00073   libmesh_assert(s &lt; 2);
<a name="l00074"></a>00074   libmesh_assert(n &lt; 3);
<a name="l00075"></a>00075   <span class="keywordflow">return</span> (s == n);
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1Edge3.php#a17425a53a972c1d0f48474995b4c0306">00078</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge3.php#a17425a53a972c1d0f48474995b4c0306">Edge3::is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00079"></a>00079                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00080"></a>00080 <span class="keyword"></span>{
<a name="l00081"></a>00081   libmesh_assert(e == 0);
<a name="l00082"></a>00082   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1Edge3.php#a9362d451ba022f4d9b4b85f5696cc1fc">00087</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Edge3.php#a9362d451ba022f4d9b4b85f5696cc1fc">Edge3::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword"></span>{
<a name="l00089"></a>00089   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2).relative_fuzzy_equals
<a name="l00090"></a>00090           ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1))/2));
<a name="l00091"></a>00091 }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1Edge3.php#a15314b0174f91e6e533d6a1ff4a30747">00095</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Edge3.php#a15314b0174f91e6e533d6a1ff4a30747">Edge3::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00096"></a>00096                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00097"></a>00097                          std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00098"></a>00098 <span class="keyword"></span>{
<a name="l00099"></a>00099   libmesh_assert (sc &lt;= 1);
<a name="l00100"></a>00100   libmesh_assert (sc &lt; this-&gt;<a class="code" href="classlibMesh_1_1Edge3.php#a31b87b9817f07e42816310b077871c54">n_sub_elem</a>());
<a name="l00101"></a>00101   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">// Create storage</span>
<a name="l00104"></a>00104   conn.resize(2);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keywordflow">switch</span> (iop)
<a name="l00107"></a>00107     {
<a name="l00108"></a>00108     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00109"></a>00109       {
<a name="l00110"></a>00110         <span class="keywordflow">switch</span> (sc)
<a name="l00111"></a>00111           {
<a name="l00112"></a>00112           <span class="keywordflow">case</span> 0: 
<a name="l00113"></a>00113             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00114"></a>00114             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00115"></a>00115             <span class="keywordflow">return</span>;
<a name="l00116"></a>00116       
<a name="l00117"></a>00117           <span class="keywordflow">case</span> 1: 
<a name="l00118"></a>00118             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00119"></a>00119             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00120"></a>00120             <span class="keywordflow">return</span>;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122           <span class="keywordflow">default</span>:
<a name="l00123"></a>00123             libmesh_error();
<a name="l00124"></a>00124           }
<a name="l00125"></a>00125       }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127       
<a name="l00128"></a>00128     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00129"></a>00129       {
<a name="l00130"></a>00130         <span class="keywordflow">switch</span> (sc)
<a name="l00131"></a>00131           {
<a name="l00132"></a>00132           <span class="keywordflow">case</span> 0: 
<a name="l00133"></a>00133             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0);
<a name="l00134"></a>00134             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2);
<a name="l00135"></a>00135       
<a name="l00136"></a>00136             <span class="keywordflow">return</span>;
<a name="l00137"></a>00137       
<a name="l00138"></a>00138           <span class="keywordflow">case</span> 1: 
<a name="l00139"></a>00139             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2);
<a name="l00140"></a>00140             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1);
<a name="l00141"></a>00141       
<a name="l00142"></a>00142             <span class="keywordflow">return</span>;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144           <span class="keywordflow">default</span>:
<a name="l00145"></a>00145             libmesh_error();
<a name="l00146"></a>00146           }
<a name="l00147"></a>00147       }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     <span class="keywordflow">default</span>:
<a name="l00150"></a>00150       {
<a name="l00151"></a>00151         libmesh_error();
<a name="l00152"></a>00152       }
<a name="l00153"></a>00153     }
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00159"></a><a class="code" href="classlibMesh_1_1Edge3.php#ae502992c686c26828f74611c6bcfcd93">00159</a> <a class="code" href="classlibMesh_1_1Edge3.php#ae502992c686c26828f74611c6bcfcd93">Edge3::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00160"></a>00160 <span class="keyword"></span>{
<a name="l00161"></a>00161   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;(0,0);
<a name="l00162"></a>00162 }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="classlibMesh_1_1Edge3.php#a11ff9d7cd2ad346be26b6156e733e070">00166</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Edge3.php#a11ff9d7cd2ad346be26b6156e733e070">Edge3::volume</a> ()<span class="keyword"> const</span>
<a name="l00167"></a>00167 <span class="keyword"></span>{
<a name="l00168"></a>00168   <span class="comment">// Finding the (exact) length of a general quadratic element</span>
<a name="l00169"></a>00169   <span class="comment">// is a surprisingly complicated formula.</span>
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1Point.php">Point</a> A = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) - 2*this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2);
<a name="l00171"></a>00171   <a class="code" href="classlibMesh_1_1Point.php">Point</a> B = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))/2;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a = A.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>(); 
<a name="l00174"></a>00174   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b = 2.*(A*B);    
<a name="l00175"></a>00175   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> c = B.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>(); 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// Degenerate straight line case</span>
<a name="l00178"></a>00178   <span class="keywordflow">if</span> (a &lt; TOLERANCE*TOLERANCE*TOLERANCE)
<a name="l00179"></a>00179     <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)).size();
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ba=b/a; 
<a name="l00182"></a>00182   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ca=c/a; 
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   libmesh_assert (1.-ba+ca&gt;0.);
<a name="l00185"></a>00185   
<a name="l00186"></a>00186   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> s1 = std::sqrt(1. - ba + ca);
<a name="l00187"></a>00187   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> s2 = std::sqrt(1. + ba + ca);
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="keywordflow">return</span> 0.5*std::sqrt(a)*((1.-0.5*ba)*s1 +
<a name="l00190"></a>00190                            (1.+0.5*ba)*s2 +
<a name="l00191"></a>00191                            (ca - 0.25*ba*ba)*std::log( (1.-0.5*ba+s1)/(-1.-0.5*ba+s2) )
<a name="l00192"></a>00192                            );
<a name="l00193"></a>00193 }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
