<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">edge_inf_edge2.h</div>  </div>
</div>
<div class="contents">
<a href="edge__inf__edge2_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: edge_inf_edge2.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __edge_inf_edge2_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __edge_inf_edge2_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="edge_8h.php">edge.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// InfEdge2 class definition</span>
<a name="l00055"></a><a class="code" href="classlibMesh_1_1InfEdge2.php">00055</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfEdge2.php">InfEdge2</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Edge.php">Edge</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057  <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00062"></a><a class="code" href="classlibMesh_1_1InfEdge2.php#a76579e8c2cd7a4d78bba8802bb3642d3">00062</a>   <a class="code" href="classlibMesh_1_1InfEdge2.php#a76579e8c2cd7a4d78bba8802bb3642d3">InfEdge2</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL) :
<a name="l00063"></a>00063     <a class="code" href="classlibMesh_1_1Edge.php">Edge</a>(<a class="code" href="classlibMesh_1_1InfEdge2.php">InfEdge2</a>::<a class="code" href="classlibMesh_1_1Edge.php#a34bfea679ccd34cc5fb103cd5cebac74">n_nodes</a>(), p) {}
<a name="l00064"></a>00064 
<a name="l00069"></a><a class="code" href="classlibMesh_1_1InfEdge2.php#aa2bea8e1d75c21879bb730ec12ccbf0f">00069</a>   <a class="code" href="classlibMesh_1_1InfEdge2.php#a76579e8c2cd7a4d78bba8802bb3642d3">InfEdge2</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00070"></a>00070            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00071"></a>00071            <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00072"></a>00072     <a class="code" href="classlibMesh_1_1Edge.php">Edge</a>(nn, ns, p) {}
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1InfEdge2.php#a7c4c2867f36a06f1b3f45dbaf94cda58">00077</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfEdge2.php#a7c4c2867f36a06f1b3f45dbaf94cda58">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00078"></a>00078   
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfEdge2.php#aafd51d6ffe8adad879a30b368cbab7a1">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfEdge2.php#a7370de1c6c83aa3d0ae0a0bec1e1e7ee">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00088"></a>00088 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfEdge2.php#ab11b4b427dd786c73cb606740ef6c6bf">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00093"></a>00093   
<a name="l00094"></a>00094   <span class="comment">/*</span>
<a name="l00095"></a>00095 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00096"></a>00096 <span class="comment">   * specified side</span>
<a name="l00097"></a>00097 <span class="comment">   */</span>
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfEdge2.php#ac4bb862e3fc4171b22cd673d92ddd339">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00099"></a>00099                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">/*</span>
<a name="l00102"></a>00102 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00103"></a>00103 <span class="comment">   * specified edge (i.e. &quot;returns true&quot; in 1D)</span>
<a name="l00104"></a>00104 <span class="comment">   */</span>
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfEdge2.php#a75aa164f5c92efc071ea5bf1dea7ced0">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00106"></a>00106                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e) <span class="keyword">const</span>;
<a name="l00107"></a>00107   
<a name="l00111"></a><a class="code" href="classlibMesh_1_1InfEdge2.php#aeca0bac950ea4ad236bce6ad46cbe5be">00111</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1InfEdge2.php#aeca0bac950ea4ad236bce6ad46cbe5be">type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>; }
<a name="l00112"></a>00112   
<a name="l00116"></a><a class="code" href="classlibMesh_1_1InfEdge2.php#a36cd30500734bbf4c4542e99b08c5eb5">00116</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1InfEdge2.php#a36cd30500734bbf4c4542e99b08c5eb5">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfEdge2.php#a5dc26b8f3e976cba7f42d0b8fedacbb7">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> se,
<a name="l00119"></a>00119                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00120"></a>00120                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="comment">//   const std::vector&lt;unsigned int&gt; tecplot_connectivity(const unsigned int se=0) const;</span>
<a name="l00123"></a>00123   
<a name="l00124"></a>00124 <span class="comment">//   void vtk_connectivity(const unsigned int se,</span>
<a name="l00125"></a>00125 <span class="comment">//                      std::vector&lt;unsigned int&gt;*conn = NULL) const;</span>
<a name="l00126"></a>00126   
<a name="l00127"></a>00127 <span class="comment">//   unsigned int vtk_element_type (const unsigned int) const</span>
<a name="l00128"></a>00128 <span class="comment">//   { return 3; }</span>
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span>
<a name="l00136"></a><a class="code" href="classlibMesh_1_1InfEdge2.php#a02ac21935488f92a227e884960cc8a4d">00136</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfEdge2.php#a02ac21935488f92a227e884960cc8a4d">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00137"></a>00137 
<a name="l00141"></a>00141   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfEdge2.php#a5d205e5bd0c97e4e9262042a2d9f625d">origin</a> () <span class="keyword">const</span>;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="preprocessor">#endif</span>
<a name="l00144"></a>00144 <span class="preprocessor"></span>
<a name="l00145"></a>00145   
<a name="l00146"></a>00146 <span class="keyword">protected</span>:
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   
<a name="l00149"></a>00149 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span>
<a name="l00154"></a><a class="code" href="classlibMesh_1_1InfEdge2.php#ad66bc09124075ea835063e6be572670f">00154</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfEdge2.php#ad66bc09124075ea835063e6be572670f">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00155"></a>00155                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00156"></a>00156                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00157"></a>00157 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0.; }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="preprocessor">#endif</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>};
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00166"></a>00166 <span class="comment">// InfEdge2 class member functions</span>
<a name="l00167"></a>00167 <span class="keyword">inline</span>
<a name="l00168"></a><a class="code" href="classlibMesh_1_1InfEdge2.php#a5d205e5bd0c97e4e9262042a2d9f625d">00168</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfEdge2.php#a5d205e5bd0c97e4e9262042a2d9f625d">InfEdge2::origin</a> ()<span class="keyword"> const</span>
<a name="l00169"></a>00169 <span class="keyword"></span>{
<a name="l00170"></a>00170   <span class="keywordflow">return</span> ( this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)*2 - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) );
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 } <span class="comment">// namespace libMesh</span>
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 <span class="preprocessor">#endif</span>
<a name="l00177"></a>00177 <span class="preprocessor"></span>
<a name="l00178"></a>00178 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
