<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">eigen_solver.C</div>  </div>
</div>
<div class="contents">
<a href="eigen__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_solver.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="eigen__solver_8h.php">eigen_solver.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="slepc__eigen__solver_8h.php">slepc_eigen_solver.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// EigenSolver members</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00038"></a>00038 AutoPtr&lt;EigenSolver&lt;T&gt; &gt;
<a name="l00039"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#a0105d9e9f20cf5e5a24b48a2aa1641d3">00039</a> <a class="code" href="classlibMesh_1_1EigenSolver.php#a0105d9e9f20cf5e5a24b48a2aa1641d3">EigenSolver&lt;T&gt;::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <span class="comment">// Build the appropriate solver</span>
<a name="l00042"></a>00042   <span class="keywordflow">switch</span> (solver_package)
<a name="l00043"></a>00043     {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="preprocessor">#ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>        <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8acd9cb691eeae568b29133157cab34ef4">SLEPC_SOLVERS</a>:
<a name="l00049"></a>00049       {
<a name="l00050"></a>00050         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;EigenSolver&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1SlepcEigenSolver.php">SlepcEigenSolver&lt;T&gt;</a>);
<a name="l00051"></a>00051         <span class="keywordflow">return</span> ap;
<a name="l00052"></a>00052       }
<a name="l00053"></a>00053 <span class="preprocessor">#endif</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keywordflow">default</span>:
<a name="l00057"></a>00057       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unrecognized eigen solver package: &quot;</span>
<a name="l00058"></a>00058                     &lt;&lt; solver_package
<a name="l00059"></a>00059                     &lt;&lt; std::endl;
<a name="l00060"></a>00060       libmesh_error();
<a name="l00061"></a>00061     }
<a name="l00062"></a>00062     
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;EigenSolver&lt;T&gt;</a> &gt; ap(NULL);
<a name="l00064"></a>00064   <span class="keywordflow">return</span> ap;    
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00070"></a>00070 <span class="comment">// Explicit instantiations</span>
<a name="l00071"></a>00071 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EigenSolver.php">EigenSolver&lt;Number&gt;</a>;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 } <span class="comment">// namespace libMesh</span>
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
