<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">eigen_solver.h</div>  </div>
</div>
<div class="contents">
<a href="eigen__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_solver.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributd in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __eigen_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __eigen_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="enum__solver__package_8h.php">enum_solver_package.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="enum__eigen__solver__type_8h.php">enum_eigen_solver_type.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>libMesh
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// forward declarations</span>
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>AutoPtr;
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>ShellMatrix;
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00054"></a><a class="code" href="classlibMesh_1_1EigenSolver.php">00054</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EigenSolver.php">EigenSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;EigenSolver&lt;T&gt; &gt;
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00057"></a>00057   
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1EigenSolver.php#a27c926fec4ed0d317927bd85f2280547">EigenSolver</a> ();
<a name="l00062"></a>00062     
<a name="l00066"></a>00066   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#a522a5cd9b43fbb1f48ef624d4a6461f7">~EigenSolver</a> ();
<a name="l00067"></a>00067   
<a name="l00072"></a>00072   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;EigenSolver&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1EigenSolver.php#a0105d9e9f20cf5e5a24b48a2aa1641d3">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package =
<a name="l00073"></a>00073                                         <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8acd9cb691eeae568b29133157cab34ef4">SLEPC_SOLVERS</a>);
<a name="l00074"></a>00074   
<a name="l00079"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#aac9fe5618164f7dddb83ab22ae3eef45">00079</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#aac9fe5618164f7dddb83ab22ae3eef45">initialized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#ac8f327356f8f61c2a945d49219031af2">_is_initialized</a>; }
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   
<a name="l00085"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#aa5e950bf4018b725cd6e4354176edf32">00085</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#aa5e950bf4018b725cd6e4354176edf32">clear</a> () {}
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#ade0b41d9b6c3a88a8941f86adf8c01cb">init</a> () = 0;
<a name="l00091"></a>00091 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#afd9dca985146b3cb40e3b4cf027faf00">00095</a>   <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802">EigenSolverType</a> <a class="code" href="classlibMesh_1_1EigenSolver.php#afd9dca985146b3cb40e3b4cf027faf00">eigen_solver_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#a612af7d1ea26e4396473074140652c02">_eigen_solver_type</a>; }
<a name="l00096"></a>00096 
<a name="l00100"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#afd21b66c7fc29d94cd17285f93f8706d">00100</a>   <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> <a class="code" href="classlibMesh_1_1EigenSolver.php#afd21b66c7fc29d94cd17285f93f8706d">eigen_problem_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#abe5081b823f7c8b50c981aff1368e3f4">_eigen_problem_type</a>;}
<a name="l00101"></a>00101 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#a9f2071b3a8a8144a6c51e7fafcd2985b">00105</a>   <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84">PositionOfSpectrum</a> <a class="code" href="classlibMesh_1_1EigenSolver.php#a9f2071b3a8a8144a6c51e7fafcd2985b">position_of_spectrum</a> ()<span class="keyword"> const</span>
<a name="l00106"></a>00106 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#a99b8426642a772b165ffd26f8fdaf876">_position_of_spectrum</a>;}
<a name="l00107"></a>00107 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#a4917efdd3f144809de1e696c490915f7">00111</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#a4917efdd3f144809de1e696c490915f7">set_eigensolver_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802">EigenSolverType</a> est)
<a name="l00112"></a>00112     { <a class="code" href="classlibMesh_1_1EigenSolver.php#a612af7d1ea26e4396473074140652c02">_eigen_solver_type</a> = est; }
<a name="l00113"></a>00113 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#a21d61dfb8a0ba191bd3e87fdc21d94a8">00117</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#a21d61dfb8a0ba191bd3e87fdc21d94a8">set_eigenproblem_type</a> ( <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> ept) 
<a name="l00118"></a>00118     {<a class="code" href="classlibMesh_1_1EigenSolver.php#abe5081b823f7c8b50c981aff1368e3f4">_eigen_problem_type</a> = ept;}
<a name="l00119"></a>00119 
<a name="l00123"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#a24f66d82dd5cac041b8a64cc89a38e34">00123</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#a24f66d82dd5cac041b8a64cc89a38e34">set_position_of_spectrum</a> (<a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84">PositionOfSpectrum</a> pos)
<a name="l00124"></a>00124     {<a class="code" href="classlibMesh_1_1EigenSolver.php#a99b8426642a772b165ffd26f8fdaf876">_position_of_spectrum</a>= pos;}
<a name="l00125"></a>00125 
<a name="l00131"></a>00131   <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1EigenSolver.php#afdc3f23028c0a92d13772bc3f7867f67">solve_standard</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A,  
<a name="l00132"></a>00132                                                                 <span class="keywordtype">int</span> nev,
<a name="l00133"></a>00133                                                                 <span class="keywordtype">int</span> ncv,
<a name="l00134"></a>00134                                                                 <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00135"></a>00135                                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00136"></a>00136 
<a name="l00142"></a>00142   <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1EigenSolver.php#afdc3f23028c0a92d13772bc3f7867f67">solve_standard</a> (<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A,  
<a name="l00143"></a>00143                                                                 <span class="keywordtype">int</span> nev,
<a name="l00144"></a>00144                                                                 <span class="keywordtype">int</span> ncv,
<a name="l00145"></a>00145                                                                 <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00146"></a>00146                                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   
<a name="l00155"></a>00155   <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1EigenSolver.php#a30c402b2a47db6a245b906aa38b9df11">solve_generalized</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A, 
<a name="l00156"></a>00156                                                                    <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,  
<a name="l00157"></a>00157                                                                    <span class="keywordtype">int</span> nev,
<a name="l00158"></a>00158                                                                    <span class="keywordtype">int</span> ncv,
<a name="l00159"></a>00159                                                                    <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00160"></a>00160                                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00161"></a>00161 
<a name="l00166"></a>00166    <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1EigenSolver.php#a30c402b2a47db6a245b906aa38b9df11">solve_generalized</a> (<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A, 
<a name="l00167"></a>00167                                                                    <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_B,  
<a name="l00168"></a>00168                                                                    <span class="keywordtype">int</span> nev,
<a name="l00169"></a>00169                                                                    <span class="keywordtype">int</span> ncv,
<a name="l00170"></a>00170                                                                    <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00171"></a>00171                                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00172"></a>00172 
<a name="l00177"></a>00177    <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1EigenSolver.php#a30c402b2a47db6a245b906aa38b9df11">solve_generalized</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_A, 
<a name="l00178"></a>00178                                                                    <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,  
<a name="l00179"></a>00179                                                                    <span class="keywordtype">int</span> nev,
<a name="l00180"></a>00180                                                                    <span class="keywordtype">int</span> ncv,
<a name="l00181"></a>00181                                                                    <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00182"></a>00182                                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00183"></a>00183 
<a name="l00188"></a>00188    <span class="keyword">virtual</span> std::pair&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1EigenSolver.php#a30c402b2a47db6a245b906aa38b9df11">solve_generalized</a> (<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_A, 
<a name="l00189"></a>00189                                                                    <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a> &amp;matrix_B,  
<a name="l00190"></a>00190                                                                    <span class="keywordtype">int</span> nev,
<a name="l00191"></a>00191                                                                    <span class="keywordtype">int</span> ncv,
<a name="l00192"></a>00192                                                                    <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00193"></a>00193                                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its) = 0;
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00200"></a>00200   <span class="keyword">virtual</span> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1EigenSolver.php#a7a7e29a72c0e7f5f05fcb2aeacf6221e">get_eigenpair</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00201"></a>00201                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution) = 0;
<a name="l00202"></a>00202 
<a name="l00206"></a>00206   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#affe0d3abae60b3a685fe66cdd9a4b145">attach_deflation_space</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;deflation_vector) = 0;
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 <span class="keyword">protected</span>:
<a name="l00209"></a>00209 
<a name="l00213"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#a612af7d1ea26e4396473074140652c02">00213</a>   <a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802">EigenSolverType</a> <a class="code" href="classlibMesh_1_1EigenSolver.php#a612af7d1ea26e4396473074140652c02">_eigen_solver_type</a>;
<a name="l00214"></a>00214 
<a name="l00218"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#abe5081b823f7c8b50c981aff1368e3f4">00218</a>   <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> <a class="code" href="classlibMesh_1_1EigenSolver.php#abe5081b823f7c8b50c981aff1368e3f4">_eigen_problem_type</a>;
<a name="l00219"></a>00219 
<a name="l00223"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#a99b8426642a772b165ffd26f8fdaf876">00223</a>   <a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84">PositionOfSpectrum</a> <a class="code" href="classlibMesh_1_1EigenSolver.php#a99b8426642a772b165ffd26f8fdaf876">_position_of_spectrum</a>;     
<a name="l00224"></a>00224 
<a name="l00228"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#ac8f327356f8f61c2a945d49219031af2">00228</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EigenSolver.php#ac8f327356f8f61c2a945d49219031af2">_is_initialized</a>;
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 };
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00236"></a>00236 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00237"></a>00237 <span class="keyword">inline</span>
<a name="l00238"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#a27c926fec4ed0d317927bd85f2280547">00238</a> <a class="code" href="classlibMesh_1_1EigenSolver.php#a27c926fec4ed0d317927bd85f2280547">EigenSolver&lt;T&gt;::EigenSolver</a> () :
<a name="l00239"></a>00239   
<a name="l00240"></a>00240   _eigen_solver_type    (<a class="code" href="namespacelibMeshEnums.php#a4b230c3a7c3d5488c3c46bd9d03ce802a12dfe2dfbb1204d9ac57ca8efc947146">ARNOLDI</a>),
<a name="l00241"></a>00241   _eigen_problem_type   (<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2b61471cb234c46e5f054bc73c2221de">NHEP</a>),
<a name="l00242"></a>00242   _position_of_spectrum (<a class="code" href="namespacelibMeshEnums.php#a0630b52d8fe07f56702ddb7c6ff14d84aa33e7e94f5eba77558dbdb57a640e964">LARGEST_MAGNITUDE</a>),
<a name="l00243"></a>00243   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>       (false)
<a name="l00244"></a>00244 {
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00250"></a>00250 <span class="keyword">inline</span>
<a name="l00251"></a><a class="code" href="classlibMesh_1_1EigenSolver.php#a522a5cd9b43fbb1f48ef624d4a6461f7">00251</a> <a class="code" href="classlibMesh_1_1EigenSolver.php#a522a5cd9b43fbb1f48ef624d4a6461f7">EigenSolver&lt;T&gt;::~EigenSolver</a> ()
<a name="l00252"></a>00252 {
<a name="l00253"></a>00253   this-&gt;clear ();
<a name="l00254"></a>00254 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 } <span class="comment">// namespace libMesh</span>
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span>
<a name="l00260"></a>00260 <span class="preprocessor">#endif // #ifdef __eigen_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
