<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">eigen_system.C</div>  </div>
</div>
<div class="contents">
<a href="eigen__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Currently, the EigenSystem should only be available</span>
<a name="l00024"></a>00024 <span class="comment">// if SLEPc support is enabled. </span>
<a name="l00025"></a>00025 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="eigen__system_8h.php">eigen_system.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="eigen__solver_8h.php">eigen_solver.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// EigenSystem implementation</span>
<a name="l00043"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a4e48c05f560a35ce7f281d5ea83add16">00043</a> <a class="code" href="classlibMesh_1_1EigenSystem.php#a4e48c05f560a35ce7f281d5ea83add16">EigenSystem::EigenSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00044"></a>00044                           <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00045"></a>00045                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number
<a name="l00046"></a>00046                           ) :
<a name="l00047"></a>00047   <a class="code" href="classlibMesh_1_1System.php">Parent</a>           (es, name, number),
<a name="l00048"></a>00048   matrix_A         (NULL),
<a name="l00049"></a>00049   matrix_B         (NULL),
<a name="l00050"></a>00050   eigen_solver     (<a class="code" href="classlibMesh_1_1EigenSolver.php">EigenSolver</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00051"></a>00051   _n_converged_eigenpairs (0),
<a name="l00052"></a>00052   _n_iterations           (0),
<a name="l00053"></a>00053   _is_generalized_eigenproblem (false),
<a name="l00054"></a>00054   _eigen_problem_type (<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2b61471cb234c46e5f054bc73c2221de">NHEP</a>)
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#ae3a45c2f12c1550c21de6619a6ec4a29">00060</a> <a class="code" href="classlibMesh_1_1EigenSystem.php#ae3a45c2f12c1550c21de6619a6ec4a29">EigenSystem::~EigenSystem</a> ()
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062   <span class="comment">// clear data</span>
<a name="l00063"></a>00063   this-&gt;<a class="code" href="classlibMesh_1_1EigenSystem.php#a7fda3fe21f9991625097a93b16ea4208">clear</a>();
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a7fda3fe21f9991625097a93b16ea4208">00068</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a7fda3fe21f9991625097a93b16ea4208">EigenSystem::clear</a> ()
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   <span class="comment">// Clear the parent data</span>
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1System.php#a8b6f936ce782fbd86cb4f3922def4cf0">Parent::clear</a>();
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// delete the matricies</span>
<a name="l00074"></a>00074   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>;
<a name="l00075"></a>00075   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a>;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="comment">// NULL-out the matricies.</span>
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a> = NULL;
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a> = NULL;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// clear the solver</span>
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;clear();
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a0e58b2fd0efeb1fa491ff16df6403098">00087</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a0e58b2fd0efeb1fa491ff16df6403098">EigenSystem::set_eigenproblem_type</a> (<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> ept)
<a name="l00088"></a>00088 {
<a name="l00089"></a>00089   <a class="code" href="classlibMesh_1_1EigenSystem.php#a133520e379693b5c933283c1507fed32">_eigen_problem_type</a> = ept;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;set_eigenproblem_type(ept);
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">// libMesh::out&lt;&lt; &quot;The Problem type is set to be: &quot;&lt;&lt;std::endl;</span>
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1EigenSystem.php#a133520e379693b5c933283c1507fed32">_eigen_problem_type</a>)
<a name="l00096"></a>00096     {
<a name="l00097"></a>00097     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a0fbfb4356e45e29380946d58569abdff">HEP</a>: <span class="comment">// libMesh::out&lt;&lt;&quot;Hermitian&quot;&lt;&lt;std::endl;</span>
<a name="l00098"></a>00098       <span class="keywordflow">break</span>;
<a name="l00099"></a>00099       
<a name="l00100"></a>00100     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2b61471cb234c46e5f054bc73c2221de">NHEP</a>: <span class="comment">// libMesh::out&lt;&lt;&quot;Non-Hermitian&quot;&lt;&lt;std::endl;</span>
<a name="l00101"></a>00101       <span class="keywordflow">break</span>;
<a name="l00102"></a>00102       
<a name="l00103"></a>00103     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2249b7b4acec69dfdd4212b7a0333c22">GHEP</a>: <span class="comment">// libMesh::out&lt;&lt;&quot;Gerneralized Hermitian&quot;&lt;&lt;std::endl;</span>
<a name="l00104"></a>00104       <span class="keywordflow">break</span>;
<a name="l00105"></a>00105       
<a name="l00106"></a>00106     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a456841f5f527e93817e4bcea61b6cdfb">GNHEP</a>: <span class="comment">// libMesh::out&lt;&lt;&quot;Generalized Non-Hermitian&quot;&lt;&lt;std::endl;</span>
<a name="l00107"></a>00107       <span class="keywordflow">break</span>;
<a name="l00108"></a>00108       
<a name="l00109"></a>00109     <span class="keywordflow">default</span>: <span class="comment">// libMesh::out&lt;&lt;&quot;not properly specified&quot;&lt;&lt;std::endl;</span>
<a name="l00110"></a>00110       libmesh_error();
<a name="l00111"></a>00111       <span class="keywordflow">break</span>;
<a name="l00112"></a>00112       
<a name="l00113"></a>00113     } 
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a34d67246c21d8bc72dc474a3e5c8618d">00119</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a34d67246c21d8bc72dc474a3e5c8618d">EigenSystem::init_data</a> ()
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121  
<a name="l00122"></a>00122   <span class="comment">// initialize parent data</span>
<a name="l00123"></a>00123   <a class="code" href="classlibMesh_1_1System.php#aa82956a48e464a20f18426601ad511d4">Parent::init_data</a>();
<a name="l00124"></a>00124   
<a name="l00125"></a>00125   <span class="comment">// define the type of eigenproblem</span>
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EigenSystem.php#a133520e379693b5c933283c1507fed32">_eigen_problem_type</a> == <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a456841f5f527e93817e4bcea61b6cdfb">GNHEP</a> || <a class="code" href="classlibMesh_1_1EigenSystem.php#a133520e379693b5c933283c1507fed32">_eigen_problem_type</a> == <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301a2249b7b4acec69dfdd4212b7a0333c22">GHEP</a>) 
<a name="l00127"></a>00127     <a class="code" href="classlibMesh_1_1EigenSystem.php#aac6ed67e24ccc4f013c19c0785b3a344">_is_generalized_eigenproblem</a> = <span class="keyword">true</span>;
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   <span class="comment">// build the system matrix</span>
<a name="l00130"></a>00130   <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a> = <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// add matrix to the _dof_map</span>
<a name="l00133"></a>00133   <span class="comment">// and compute the sparsity</span>
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>);
<a name="l00137"></a>00137   
<a name="l00138"></a>00138   <span class="comment">// build matrix_B only in case of a</span>
<a name="l00139"></a>00139   <span class="comment">// generalized problem</span>
<a name="l00140"></a>00140   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EigenSystem.php#aac6ed67e24ccc4f013c19c0785b3a344">_is_generalized_eigenproblem</a>)
<a name="l00141"></a>00141     {
<a name="l00142"></a>00142       <a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a> = <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00143"></a>00143       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a>(*<a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a>);
<a name="l00144"></a>00144     }
<a name="l00145"></a>00145   
<a name="l00146"></a>00146   dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a49379ce3a542eab41a8f8e44d0f154c2">compute_sparsity</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>());
<a name="l00147"></a>00147   
<a name="l00148"></a>00148   <span class="comment">// initialize and zero system matrix</span>
<a name="l00149"></a>00149   <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a250c79a97a6765b3e8f8395df930fd81">init</a>();
<a name="l00150"></a>00150   <a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00151"></a>00151   
<a name="l00152"></a>00152   <span class="comment">// eventually initialize and zero system matrix_B  </span>
<a name="l00153"></a>00153   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EigenSystem.php#aac6ed67e24ccc4f013c19c0785b3a344">_is_generalized_eigenproblem</a>)
<a name="l00154"></a>00154     {
<a name="l00155"></a>00155       <a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a250c79a97a6765b3e8f8395df930fd81">init</a>();
<a name="l00156"></a>00156       <a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00157"></a>00157     }   
<a name="l00158"></a>00158   
<a name="l00159"></a>00159 }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#af30e166ab058ea992133b262c739a6b3">00163</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#af30e166ab058ea992133b262c739a6b3">EigenSystem::reinit</a> ()
<a name="l00164"></a>00164 {
<a name="l00165"></a>00165   <span class="comment">// initialize parent data</span>
<a name="l00166"></a>00166   <a class="code" href="classlibMesh_1_1System.php#a1cb3b5ae4fdd2f72d8fbddcadf3d3256">Parent::reinit</a>();  
<a name="l00167"></a>00167   
<a name="l00168"></a>00168 }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a454664a042652e1e501b3718a82d84eb">00172</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a454664a042652e1e501b3718a82d84eb">EigenSystem::solve</a> ()
<a name="l00173"></a>00173 {
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="comment">// A reference to the EquationSystems</span>
<a name="l00176"></a>00176   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es = this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="comment">// check that necessary parameters have been set</span>
<a name="l00179"></a>00179   libmesh_assert (es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;eigenpairs&quot;</span>));
<a name="l00180"></a>00180   libmesh_assert (es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;basis vectors&quot;</span>));
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a>)
<a name="l00183"></a>00183     <span class="comment">// Assemble the linear system</span>
<a name="l00184"></a>00184     this-&gt;<a class="code" href="classlibMesh_1_1EigenSystem.php#a2b4572555305c92ed24feea4d5b4d522">assemble</a> ();
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// Get the tolerance for the solver and the maximum</span>
<a name="l00187"></a>00187   <span class="comment">// number of iterations. Here, we simply adopt the linear solver</span>
<a name="l00188"></a>00188   <span class="comment">// specific parameters.</span>
<a name="l00189"></a>00189   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol            =
<a name="l00190"></a>00190     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>);
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxits =
<a name="l00193"></a>00193     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nev    =
<a name="l00196"></a>00196     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;eigenpairs&quot;</span>);
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ncv    =
<a name="l00199"></a>00199     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;basis vectors&quot;</span>);
<a name="l00200"></a>00200     
<a name="l00201"></a>00201   std::pair&lt;unsigned int, unsigned int&gt; solve_data;
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   <span class="comment">// call the solver depending on the type of eigenproblem</span>
<a name="l00204"></a>00204   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EigenSystem.php#aac6ed67e24ccc4f013c19c0785b3a344">_is_generalized_eigenproblem</a>)
<a name="l00205"></a>00205     { 
<a name="l00206"></a>00206       <span class="comment">//in case of a generalized eigenproblem</span>
<a name="l00207"></a>00207       solve_data = <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;solve_generalized (*<a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>,*<a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a>, nev, ncv, tol, maxits);
<a name="l00208"></a>00208       
<a name="l00209"></a>00209     }
<a name="l00210"></a>00210   
<a name="l00211"></a>00211   <span class="keywordflow">else</span>
<a name="l00212"></a>00212     {
<a name="l00213"></a>00213       libmesh_assert (<a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a> == NULL);
<a name="l00214"></a>00214       
<a name="l00215"></a>00215       <span class="comment">//in case of a standard eigenproblem</span>
<a name="l00216"></a>00216       solve_data = <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;solve_standard (*<a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>, nev, ncv, tol, maxits);
<a name="l00217"></a>00217       
<a name="l00218"></a>00218     }
<a name="l00219"></a>00219   
<a name="l00220"></a>00220   this-&gt;<a class="code" href="classlibMesh_1_1EigenSystem.php#a1039a53237198f12d499d915fbbee461">_n_converged_eigenpairs</a> = solve_data.first;
<a name="l00221"></a>00221   this-&gt;<a class="code" href="classlibMesh_1_1EigenSystem.php#a421e2df19a534ae1bf640b2dd11dbc4c">_n_iterations</a>           = solve_data.second;
<a name="l00222"></a>00222   
<a name="l00223"></a>00223 }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a2b4572555305c92ed24feea4d5b4d522">00226</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a2b4572555305c92ed24feea4d5b4d522">EigenSystem::assemble</a> ()
<a name="l00227"></a>00227 {
<a name="l00228"></a>00228 
<a name="l00229"></a>00229   <span class="comment">// Assemble the linear system</span>
<a name="l00230"></a>00230   <a class="code" href="classlibMesh_1_1System.php#a79e4227a9e627031fac487cbd7c17250">Parent::assemble</a> (); 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a4cb401cd6e4bd406b68cb408caa06721">00235</a> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1EigenSystem.php#a4cb401cd6e4bd406b68cb408caa06721">EigenSystem::get_eigenpair</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00236"></a>00236 {
<a name="l00237"></a>00237   <span class="comment">// call the eigen_solver get_eigenpair method</span>
<a name="l00238"></a>00238   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>-&gt;get_eigenpair (i, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00239"></a>00239 }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 } <span class="comment">// namespace libMesh</span>
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
