<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">eigen_system.h</div>  </div>
</div>
<div class="contents">
<a href="eigen__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributd in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __eigen_system_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __eigen_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Currently, the EigenSystem should only be available</span>
<a name="l00027"></a>00027 <span class="comment">// if SLEPc support is enabled. </span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_HAVE_SLEPC)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="comment">// C++ includes</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local Includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="eigen__solver_8h.php">eigen_solver.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// Forward Declarations</span>
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// EigenSystem class definition</span>
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1EigenSystem.php">00055</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EigenSystem.php">EigenSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1System.php">System</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1EigenSystem.php#a4e48c05f560a35ce7f281d5ea83add16">EigenSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00064"></a>00064                <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00065"></a>00065                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#ae3a45c2f12c1550c21de6619a6ec4a29">~EigenSystem</a> ();
<a name="l00071"></a>00071  
<a name="l00075"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#ace706850a85a1d9f2f16ad30441c35a5">00075</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1EigenSystem.php">EigenSystem</a> <a class="code" href="classlibMesh_1_1EigenSystem.php#ace706850a85a1d9f2f16ad30441c35a5">sys_type</a>;
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#ac9935d3e4da94909a02f6baa2f9eb33b">00080</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1System.php">System</a> <a class="code" href="classlibMesh_1_1EigenSystem.php#ac9935d3e4da94909a02f6baa2f9eb33b">Parent</a>;
<a name="l00081"></a>00081   
<a name="l00085"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a3b82b1af728dfd206dc3c998632f5020">00085</a>   <a class="code" href="classlibMesh_1_1EigenSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1EigenSystem.php#a3b82b1af728dfd206dc3c998632f5020">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00086"></a>00086   
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a7fda3fe21f9991625097a93b16ea4208">clear</a> ();
<a name="l00092"></a>00092 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#af30e166ab058ea992133b262c739a6b3">reinit</a> ();
<a name="l00098"></a>00098   
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a454664a042652e1e501b3718a82d84eb">solve</a> ();
<a name="l00103"></a>00103 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a2b4572555305c92ed24feea4d5b4d522">assemble</a> ();
<a name="l00108"></a>00108 
<a name="l00113"></a>00113   <span class="keyword">virtual</span> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1EigenSystem.php#a4cb401cd6e4bd406b68cb408caa06721">get_eigenpair</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00114"></a>00114   
<a name="l00119"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a21f0e29bf231a5d6d71e90d9194e3bde">00119</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1EigenSystem.php#a21f0e29bf231a5d6d71e90d9194e3bde">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;Eigen&quot;</span>; }
<a name="l00120"></a>00120 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#ab4c0a9337a8e0243e81fbafa043cb29f">00124</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#ab4c0a9337a8e0243e81fbafa043cb29f">get_n_converged</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a1039a53237198f12d499d915fbbee461">_n_converged_eigenpairs</a>;}
<a name="l00125"></a>00125 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a30651749e2beae7f85f03c7af876121f">00129</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a30651749e2beae7f85f03c7af876121f">get_n_iterations</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a421e2df19a534ae1bf640b2dd11dbc4c">_n_iterations</a>;}
<a name="l00130"></a>00130   
<a name="l00134"></a>00134   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a0e58b2fd0efeb1fa491ff16df6403098">set_eigenproblem_type</a> (<a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> ept);
<a name="l00135"></a>00135   
<a name="l00139"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a0e009dde1a2a36034ee5a473c25c2608">00139</a>   <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> <a class="code" href="classlibMesh_1_1EigenSystem.php#a0e009dde1a2a36034ee5a473c25c2608">get_eigenproblem_type</a> ()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a133520e379693b5c933283c1507fed32">_eigen_problem_type</a>;}
<a name="l00140"></a>00140   
<a name="l00145"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#aff9b2776cd721fc84ee71bb66b5d6f5b">00145</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#aff9b2776cd721fc84ee71bb66b5d6f5b">generalized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#aac6ed67e24ccc4f013c19c0785b3a344">_is_generalized_eigenproblem</a>; }
<a name="l00146"></a>00146   
<a name="l00150"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">00150</a>   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> *<a class="code" href="classlibMesh_1_1EigenSystem.php#a01a29a78830ad7813cdf0f64997b586f">matrix_A</a>;
<a name="l00151"></a>00151 
<a name="l00155"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">00155</a>   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> *<a class="code" href="classlibMesh_1_1EigenSystem.php#a16b1c6094998ba06a32f5c965d0aee0b">matrix_B</a>;
<a name="l00156"></a>00156 
<a name="l00161"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">00161</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;EigenSolver&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1EigenSystem.php#aaee4d84c67c46084f350edd4d35d4887">eigen_solver</a>;
<a name="l00162"></a>00162  
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="keyword">protected</span>:
<a name="l00165"></a>00165 
<a name="l00166"></a>00166   
<a name="l00171"></a>00171   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a34d67246c21d8bc72dc474a3e5c8618d">init_data</a> ();
<a name="l00172"></a>00172 
<a name="l00177"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a4b87a747126b87053026efe939ebc18b">00177</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a4b87a747126b87053026efe939ebc18b">set_n_converged</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nconv)
<a name="l00178"></a>00178     { <a class="code" href="classlibMesh_1_1EigenSystem.php#a1039a53237198f12d499d915fbbee461">_n_converged_eigenpairs</a> = nconv; }
<a name="l00179"></a>00179 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#ae85415626f2d9b82b03788228be72edc">00184</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#ae85415626f2d9b82b03788228be72edc">set_n_iterations</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> its) 
<a name="l00185"></a>00185     { <a class="code" href="classlibMesh_1_1EigenSystem.php#a421e2df19a534ae1bf640b2dd11dbc4c">_n_iterations</a> = its;}
<a name="l00186"></a>00186 
<a name="l00187"></a>00187  
<a name="l00188"></a>00188 <span class="keyword">private</span>:
<a name="l00189"></a>00189 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a1039a53237198f12d499d915fbbee461">00193</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a1039a53237198f12d499d915fbbee461">_n_converged_eigenpairs</a>;
<a name="l00194"></a>00194 
<a name="l00198"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a421e2df19a534ae1bf640b2dd11dbc4c">00198</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#a421e2df19a534ae1bf640b2dd11dbc4c">_n_iterations</a>;
<a name="l00199"></a>00199   
<a name="l00204"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#aac6ed67e24ccc4f013c19c0785b3a344">00204</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EigenSystem.php#aac6ed67e24ccc4f013c19c0785b3a344">_is_generalized_eigenproblem</a>;
<a name="l00205"></a>00205   
<a name="l00209"></a><a class="code" href="classlibMesh_1_1EigenSystem.php#a133520e379693b5c933283c1507fed32">00209</a>   <a class="code" href="namespacelibMeshEnums.php#a834a7caabd0c61943731bb38bfc67301">EigenProblemType</a> <a class="code" href="classlibMesh_1_1EigenSystem.php#a133520e379693b5c933283c1507fed32">_eigen_problem_type</a>;
<a name="l00210"></a>00210   
<a name="l00211"></a>00211   
<a name="l00212"></a>00212 };
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00217"></a>00217 <span class="comment">// EigenSystem inline methods</span>
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 } <span class="comment">// namespace libMesh</span>
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span>
<a name="l00224"></a>00224 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
