<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">eigen_time_solver.h</div>  </div>
</div>
<div class="contents">
<a href="eigen__time__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: eigen_time_solver.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __eigen_time_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __eigen_time_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_HAVE_SLEPC</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="comment">// C++ includes</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>EigenSolver;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00069"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php">00069</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EigenTimeSolver.php">EigenTimeSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TimeSolver.php">TimeSolver</a>
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071 <span class="keyword">public</span>:
<a name="l00075"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a07ff84934bd7a5a7d9f94a1837947358">00075</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a07ff84934bd7a5a7d9f94a1837947358">sys_type</a>;
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a37117458124770bb3ee1e053dfbae896">00080</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TimeSolver.php">TimeSolver</a> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a37117458124770bb3ee1e053dfbae896">Parent</a>;
<a name="l00081"></a>00081   
<a name="l00086"></a>00086   <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#aa2ec46b307b3d9640d4dfb0095a653d7">EigenTimeSolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00087"></a>00087   
<a name="l00091"></a>00091   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#ade921601d3cf167db27054dfded3786d">~EigenTimeSolver</a> ();
<a name="l00092"></a>00092 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#adf67fe7249c27f68130b3fe73f7cc2dd">init</a> ();
<a name="l00098"></a>00098 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#adea13963b58616ad26f249a2b78874a7">reinit</a> ();
<a name="l00104"></a>00104 
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#aa4e1388ab7385397c29b22802cbe6c2d">solve</a> ();
<a name="l00110"></a>00110 
<a name="l00114"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a1ca140619082901958ccfa59f7773d90">00114</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a1ca140619082901958ccfa59f7773d90">advance_timestep</a> () { }
<a name="l00115"></a>00115 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a891ca6d55f32d609128a735d9f7476d2">00120</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a891ca6d55f32d609128a735d9f7476d2">error_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.; }
<a name="l00121"></a>00121 
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a4db26f165e22204225a67e8662866f99">element_residual</a> (<span class="keywordtype">bool</span> get_jacobian,
<a name="l00127"></a>00127                                  <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;);
<a name="l00128"></a>00128 
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a6f1ef4d40807031e2590c2dc6e2cdda8">side_residual</a> (<span class="keywordtype">bool</span> get_jacobian,
<a name="l00133"></a>00133                               <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;);
<a name="l00134"></a>00134 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a58c0f60e1d1583739cdb64cbfed3edf5">00140</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a58c0f60e1d1583739cdb64cbfed3edf5">du</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a>&amp;)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0.; }
<a name="l00141"></a>00141 
<a name="l00145"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#ac4c26bba97c09d96753fa36f1c3e5ad9">00145</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#ac4c26bba97c09d96753fa36f1c3e5ad9">is_steady</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00146"></a>00146 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#ab28b5841f64cdefc7fbb35c90d6b2d66">00151</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;EigenSolver&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#ab28b5841f64cdefc7fbb35c90d6b2d66">eigen_solver</a>;
<a name="l00152"></a>00152 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#af5f16f80f7139b4ec8019732d8e1cb89">00157</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#af5f16f80f7139b4ec8019732d8e1cb89">tol</a>;
<a name="l00158"></a>00158 
<a name="l00162"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a158fd57d83a1816fa3514703bd15a7c3">00162</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a158fd57d83a1816fa3514703bd15a7c3">maxits</a>;
<a name="l00163"></a>00163 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#ae59854c481d35a3aedad2c5a32ce1614">00167</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#ae59854c481d35a3aedad2c5a32ce1614">n_eigenpairs_to_compute</a>;    
<a name="l00168"></a>00168 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a71659dea1d48c57888b5086e8d9122ed">00178</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a71659dea1d48c57888b5086e8d9122ed">n_basis_vectors_to_use</a>;
<a name="l00179"></a>00179 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a1c94ac26c1dec52b039d731abf03475d">00184</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a1c94ac26c1dec52b039d731abf03475d">n_converged_eigenpairs</a>;
<a name="l00185"></a>00185 
<a name="l00190"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#ab61298b057785a0355c567c758f0504d">00190</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#ab61298b057785a0355c567c758f0504d">n_iterations_reqd</a>;
<a name="l00191"></a>00191   
<a name="l00192"></a>00192 <span class="keyword">private</span>:
<a name="l00193"></a>00193   
<a name="l00194"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a7ab6c5d69320a815c67e2a9eabd2add5">00194</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a7ab6c5d69320a815c67e2a9eabd2add5">NowAssembling</a> {
<a name="l00198"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a7ab6c5d69320a815c67e2a9eabd2add5adca2de5fa8ba042168bbf4a08aff11fc">00198</a>     <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a7ab6c5d69320a815c67e2a9eabd2add5adca2de5fa8ba042168bbf4a08aff11fc">Matrix_A</a>,
<a name="l00199"></a>00199 
<a name="l00203"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a7ab6c5d69320a815c67e2a9eabd2add5a15f16c705e3475454ee185d2d41857d4">00203</a>     <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a7ab6c5d69320a815c67e2a9eabd2add5a15f16c705e3475454ee185d2d41857d4">Matrix_B</a>,
<a name="l00204"></a>00204 
<a name="l00208"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a7ab6c5d69320a815c67e2a9eabd2add5aafa35d02eb805d7d0f0c8ab14becc66f">00208</a>     <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a7ab6c5d69320a815c67e2a9eabd2add5aafa35d02eb805d7d0f0c8ab14becc66f">Invalid_Matrix</a>
<a name="l00209"></a>00209   };
<a name="l00210"></a>00210 
<a name="l00214"></a><a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a482d3812eeeef09fe2b2699cb4b25787">00214</a>   <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a7ab6c5d69320a815c67e2a9eabd2add5">NowAssembling</a> <a class="code" href="classlibMesh_1_1EigenTimeSolver.php#a482d3812eeeef09fe2b2699cb4b25787">now_assembling</a>;
<a name="l00215"></a>00215   
<a name="l00216"></a>00216 };
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 } <span class="comment">// namespace libMesh</span>
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 <span class="preprocessor">#endif // LIBMESH_HAVE_SLEPC</span>
<a name="l00222"></a>00222 <span class="preprocessor"></span><span class="preprocessor">#endif // #define __eigen_time_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
