<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">elem_quality.C</div>  </div>
</div>
<div class="contents">
<a href="elem__quality_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: elem_quality.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;sstream&gt;</span> 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="elem__quality_8h.php">elem_quality.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">namespace </span>libMesh
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// Quality function definitions</span>
<a name="l00033"></a>00033 
<a name="l00041"></a><a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">00041</a> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">Quality::name</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) 
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   std::string its_name;
<a name="l00044"></a>00044   
<a name="l00045"></a>00045   <span class="keywordflow">switch</span> (q)
<a name="l00046"></a>00046     {
<a name="l00047"></a>00047       
<a name="l00048"></a>00048     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>:
<a name="l00049"></a>00049       its_name = <span class="stringliteral">&quot;Aspect Ratio&quot;</span>;
<a name="l00050"></a>00050       <span class="keywordflow">break</span>;
<a name="l00051"></a>00051       
<a name="l00052"></a>00052     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>:
<a name="l00053"></a>00053       its_name = <span class="stringliteral">&quot;Skew&quot;</span>;
<a name="l00054"></a>00054       <span class="keywordflow">break</span>;
<a name="l00055"></a>00055       
<a name="l00056"></a>00056     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>:
<a name="l00057"></a>00057       its_name = <span class="stringliteral">&quot;Shear&quot;</span>;
<a name="l00058"></a>00058       <span class="keywordflow">break</span>;
<a name="l00059"></a>00059       
<a name="l00060"></a>00060     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>:
<a name="l00061"></a>00061       its_name = <span class="stringliteral">&quot;Shape&quot;</span>;
<a name="l00062"></a>00062       <span class="keywordflow">break</span>;
<a name="l00063"></a>00063       
<a name="l00064"></a>00064     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a2c906ab7c9aca6cca231949a86b430a0">MAX_ANGLE</a>:
<a name="l00065"></a>00065       its_name = <span class="stringliteral">&quot;Maximum Angle&quot;</span>;
<a name="l00066"></a>00066       <span class="keywordflow">break</span>;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012aa567a4d684ebdd698e26a3e10456126b">MIN_ANGLE</a>:
<a name="l00069"></a>00069       its_name = <span class="stringliteral">&quot;Minimum Angle&quot;</span>;
<a name="l00070"></a>00070       <span class="keywordflow">break</span>;
<a name="l00071"></a>00071       
<a name="l00072"></a>00072     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>:
<a name="l00073"></a>00073       its_name = <span class="stringliteral">&quot;Condition Number&quot;</span>;
<a name="l00074"></a>00074       <span class="keywordflow">break</span>;
<a name="l00075"></a>00075       
<a name="l00076"></a>00076     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00077"></a>00077       its_name = <span class="stringliteral">&quot;Distortion&quot;</span>;
<a name="l00078"></a>00078       <span class="keywordflow">break</span>;
<a name="l00079"></a>00079       
<a name="l00080"></a>00080     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00081"></a>00081       its_name = <span class="stringliteral">&quot;Taper&quot;</span>;
<a name="l00082"></a>00082       <span class="keywordflow">break</span>;
<a name="l00083"></a>00083       
<a name="l00084"></a>00084     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a4ac2c62ea7ca226c3586825a77dd64a8">WARP</a>:
<a name="l00085"></a>00085       its_name = <span class="stringliteral">&quot;Warp&quot;</span>;
<a name="l00086"></a>00086       <span class="keywordflow">break</span>;
<a name="l00087"></a>00087       
<a name="l00088"></a>00088     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00089"></a>00089       its_name = <span class="stringliteral">&quot;Stretch&quot;</span>;
<a name="l00090"></a>00090       <span class="keywordflow">break</span>;
<a name="l00091"></a>00091       
<a name="l00092"></a>00092     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00093"></a>00093       its_name = <span class="stringliteral">&quot;Diagonal&quot;</span>;
<a name="l00094"></a>00094       <span class="keywordflow">break</span>;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a77ceaa502eaeff5313a279f08699e9d5">ASPECT_RATIO_BETA</a>:
<a name="l00097"></a>00097       its_name = <span class="stringliteral">&quot;AR Beta&quot;</span>;
<a name="l00098"></a>00098       <span class="keywordflow">break</span>;
<a name="l00099"></a>00099       
<a name="l00100"></a>00100     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad1cac69d1c38539e42934ab8dd2cb5a8">ASPECT_RATIO_GAMMA</a>:
<a name="l00101"></a>00101       its_name = <span class="stringliteral">&quot;AR Gamma&quot;</span>;
<a name="l00102"></a>00102       <span class="keywordflow">break</span>;
<a name="l00103"></a>00103 
<a name="l00104"></a>00104     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>:
<a name="l00105"></a>00105       its_name = <span class="stringliteral">&quot;Size&quot;</span>;
<a name="l00106"></a>00106       <span class="keywordflow">break</span>;
<a name="l00107"></a>00107       
<a name="l00108"></a>00108     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>:
<a name="l00109"></a>00109       its_name = <span class="stringliteral">&quot;Jacobian&quot;</span>;
<a name="l00110"></a>00110       <span class="keywordflow">break</span>;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     <span class="keywordflow">default</span>:
<a name="l00113"></a>00113       its_name = <span class="stringliteral">&quot;Unknown&quot;</span>;
<a name="l00114"></a>00114       <span class="keywordflow">break</span>;
<a name="l00115"></a>00115     }
<a name="l00116"></a>00116   
<a name="l00117"></a>00117   <span class="keywordflow">return</span> its_name;
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00129"></a><a class="code" href="namespacelibMesh_1_1Quality.php#acb524e1826e939a09c19c8d69115c286">00129</a> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#acb524e1826e939a09c19c8d69115c286">Quality::describe</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) 
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   
<a name="l00132"></a>00132   std::ostringstream desc; 
<a name="l00133"></a>00133   
<a name="l00134"></a>00134   <span class="keywordflow">switch</span> (q)
<a name="l00135"></a>00135     {
<a name="l00136"></a>00136       
<a name="l00137"></a>00137     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>:
<a name="l00138"></a>00138       desc &lt;&lt; <span class="stringliteral">&quot;Max edge length ratio\n&quot;</span>
<a name="l00139"></a>00139            &lt;&lt; <span class="stringliteral">&quot;at element center.\n&quot;</span>
<a name="l00140"></a>00140            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00141"></a>00141            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00142"></a>00142            &lt;&lt; <span class="stringliteral">&quot;Hexes: (1 -&gt; 4)\n&quot;</span>
<a name="l00143"></a>00143            &lt;&lt; <span class="stringliteral">&quot;Quads: (1 -&gt; 4)&quot;</span>;
<a name="l00144"></a>00144       <span class="keywordflow">break</span>;
<a name="l00145"></a>00145       
<a name="l00146"></a>00146     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>:
<a name="l00147"></a>00147       desc &lt;&lt; <span class="stringliteral">&quot;Maximum |cos A|, where A\n&quot;</span>
<a name="l00148"></a>00148            &lt;&lt; <span class="stringliteral">&quot;is the angle between edges\n&quot;</span>
<a name="l00149"></a>00149            &lt;&lt; <span class="stringliteral">&quot;at element center.\n&quot;</span>
<a name="l00150"></a>00150            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00151"></a>00151            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00152"></a>00152            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0 -&gt; 0.5)\n&quot;</span>
<a name="l00153"></a>00153            &lt;&lt; <span class="stringliteral">&quot;Quads: (0 -&gt; 0.5)&quot;</span>;
<a name="l00154"></a>00154       <span class="keywordflow">break</span>;
<a name="l00155"></a>00155       
<a name="l00156"></a>00156     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>:
<a name="l00157"></a>00157       desc &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM / K(Js)\n&quot;</span>
<a name="l00158"></a>00158            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00159"></a>00159            &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM   = element dimension.\n&quot;</span>
<a name="l00160"></a>00160            &lt;&lt; <span class="stringliteral">&quot;K(Js) = Condition number of \n&quot;</span>
<a name="l00161"></a>00161            &lt;&lt; <span class="stringliteral">&quot;        Jacobian skew matrix.\n&quot;</span>
<a name="l00162"></a>00162            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00163"></a>00163            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00164"></a>00164            &lt;&lt; <span class="stringliteral">&quot;Hexes(LIBMESH_DIM=3): (0.3 -&gt; 1)\n&quot;</span>
<a name="l00165"></a>00165            &lt;&lt; <span class="stringliteral">&quot;Quads(LIBMESH_DIM=2): (0.3 -&gt; 1)&quot;</span>;
<a name="l00166"></a>00166       <span class="keywordflow">break</span>;
<a name="l00167"></a>00167       
<a name="l00168"></a>00168     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>:
<a name="l00169"></a>00169       desc &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM / K(Jw)\n&quot;</span>
<a name="l00170"></a>00170            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00171"></a>00171            &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM   = element dimension.\n&quot;</span>
<a name="l00172"></a>00172            &lt;&lt; <span class="stringliteral">&quot;K(Jw) = Condition number of \n&quot;</span>
<a name="l00173"></a>00173            &lt;&lt; <span class="stringliteral">&quot;        weighted Jacobian\n&quot;</span>
<a name="l00174"></a>00174            &lt;&lt; <span class="stringliteral">&quot;        matrix.\n&quot;</span>
<a name="l00175"></a>00175            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00176"></a>00176            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00177"></a>00177            &lt;&lt; <span class="stringliteral">&quot;Hexes(LIBMESH_DIM=3): (0.3 -&gt; 1)\n&quot;</span>
<a name="l00178"></a>00178            &lt;&lt; <span class="stringliteral">&quot;Tets(LIBMESH_DIM=3): (0.2 -&gt; 1)\n&quot;</span>
<a name="l00179"></a>00179            &lt;&lt; <span class="stringliteral">&quot;Quads(LIBMESH_DIM=2): (0.3 -&gt; 1).&quot;</span>;
<a name="l00180"></a>00180       <span class="keywordflow">break</span>;
<a name="l00181"></a>00181       
<a name="l00182"></a>00182     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a2c906ab7c9aca6cca231949a86b430a0">MAX_ANGLE</a>:
<a name="l00183"></a>00183       desc &lt;&lt; <span class="stringliteral">&quot;Largest included angle.\n&quot;</span>
<a name="l00184"></a>00184            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00185"></a>00185            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00186"></a>00186            &lt;&lt; <span class="stringliteral">&quot;Quads: (90 -&gt; 135)\n&quot;</span>
<a name="l00187"></a>00187            &lt;&lt; <span class="stringliteral">&quot;Triangles: (60 -&gt; 90)&quot;</span>;
<a name="l00188"></a>00188       <span class="keywordflow">break</span>;
<a name="l00189"></a>00189 
<a name="l00190"></a>00190     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012aa567a4d684ebdd698e26a3e10456126b">MIN_ANGLE</a>:
<a name="l00191"></a>00191       desc &lt;&lt; <span class="stringliteral">&quot;Smallest included angle.\n&quot;</span>
<a name="l00192"></a>00192            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00193"></a>00193            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00194"></a>00194            &lt;&lt; <span class="stringliteral">&quot;Quads: (45 -&gt; 90)\n&quot;</span>
<a name="l00195"></a>00195            &lt;&lt; <span class="stringliteral">&quot;Triangles: (30 -&gt; 60)&quot;</span>;
<a name="l00196"></a>00196       <span class="keywordflow">break</span>;
<a name="l00197"></a>00197       
<a name="l00198"></a>00198     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>:
<a name="l00199"></a>00199       desc &lt;&lt; <span class="stringliteral">&quot;Condition number of the\n&quot;</span>
<a name="l00200"></a>00200            &lt;&lt; <span class="stringliteral">&quot;Jacobian matrix.\n&quot;</span>
<a name="l00201"></a>00201            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00202"></a>00202            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00203"></a>00203            &lt;&lt; <span class="stringliteral">&quot;Quads: (1 -&gt; 4)\n&quot;</span> 
<a name="l00204"></a>00204            &lt;&lt; <span class="stringliteral">&quot;Hexes: (1 -&gt; 8)\n&quot;</span>
<a name="l00205"></a>00205            &lt;&lt; <span class="stringliteral">&quot;Tris: (1 -&gt; 1.3)\n&quot;</span>
<a name="l00206"></a>00206            &lt;&lt; <span class="stringliteral">&quot;Tets: (1 -&gt; 3)&quot;</span>;
<a name="l00207"></a>00207       <span class="keywordflow">break</span>;
<a name="l00208"></a>00208       
<a name="l00209"></a>00209     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00210"></a>00210       desc &lt;&lt; <span class="stringliteral">&quot;min |J| * A / &lt;A&gt;\n&quot;</span>
<a name="l00211"></a>00211            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00212"></a>00212            &lt;&lt; <span class="stringliteral">&quot;|J| = norm of Jacobian matrix\n&quot;</span>
<a name="l00213"></a>00213            &lt;&lt; <span class="stringliteral">&quot; A  = actual area\n&quot;</span>
<a name="l00214"></a>00214            &lt;&lt; <span class="stringliteral">&quot;&lt;A&gt; = reference area\n&quot;</span>
<a name="l00215"></a>00215            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00216"></a>00216            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00217"></a>00217            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.6 -&gt; 1), &lt;A&gt;=4\n&quot;</span> 
<a name="l00218"></a>00218            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.6 -&gt; 1), &lt;A&gt;=8\n&quot;</span>
<a name="l00219"></a>00219            &lt;&lt; <span class="stringliteral">&quot;Tris: (0.6 -&gt; 1), &lt;A&gt;=1/2\n&quot;</span>
<a name="l00220"></a>00220            &lt;&lt; <span class="stringliteral">&quot;Tets: (0.6 -&gt; 1), &lt;A&gt;=1/6&quot;</span>;
<a name="l00221"></a>00221       <span class="keywordflow">break</span>;
<a name="l00222"></a>00222       
<a name="l00223"></a>00223     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00224"></a>00224       desc &lt;&lt; <span class="stringliteral">&quot;Maximum ratio of lengths\n&quot;</span>
<a name="l00225"></a>00225            &lt;&lt; <span class="stringliteral">&quot;derived from opposited edges.\n&quot;</span>
<a name="l00226"></a>00226            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00227"></a>00227            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00228"></a>00228            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.7 -&gt; 1)\n&quot;</span>
<a name="l00229"></a>00229            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.4 -&gt; 1)&quot;</span>;
<a name="l00230"></a>00230       <span class="keywordflow">break</span>;
<a name="l00231"></a>00231       
<a name="l00232"></a>00232     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a4ac2c62ea7ca226c3586825a77dd64a8">WARP</a>:
<a name="l00233"></a>00233       desc &lt;&lt; <span class="stringliteral">&quot;cos D\n&quot;</span>
<a name="l00234"></a>00234            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00235"></a>00235            &lt;&lt; <span class="stringliteral">&quot;D = minimum dihedral angle\n&quot;</span>
<a name="l00236"></a>00236            &lt;&lt; <span class="stringliteral">&quot;    formed by diagonals.\n&quot;</span>
<a name="l00237"></a>00237            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00238"></a>00238            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00239"></a>00239            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.9 -&gt; 1)&quot;</span>;
<a name="l00240"></a>00240       <span class="keywordflow">break</span>;
<a name="l00241"></a>00241       
<a name="l00242"></a>00242     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00243"></a>00243       desc &lt;&lt; <span class="stringliteral">&quot;Sqrt(3) * L_min / L_max\n&quot;</span>
<a name="l00244"></a>00244            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00245"></a>00245            &lt;&lt; <span class="stringliteral">&quot;L_min = minimum edge length.\n&quot;</span>
<a name="l00246"></a>00246            &lt;&lt; <span class="stringliteral">&quot;L_max = maximum edge length.\n&quot;</span>
<a name="l00247"></a>00247            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00248"></a>00248            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00249"></a>00249            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.25 -&gt; 1)\n&quot;</span>
<a name="l00250"></a>00250            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.25 -&gt; 1)&quot;</span>;
<a name="l00251"></a>00251       <span class="keywordflow">break</span>;
<a name="l00252"></a>00252       
<a name="l00253"></a>00253     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00254"></a>00254       desc &lt;&lt; <span class="stringliteral">&quot;D_min / D_max\n&quot;</span>
<a name="l00255"></a>00255            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00256"></a>00256            &lt;&lt; <span class="stringliteral">&quot;D_min = minimum diagonal.\n&quot;</span>
<a name="l00257"></a>00257            &lt;&lt; <span class="stringliteral">&quot;D_max = maximum diagonal.\n&quot;</span>
<a name="l00258"></a>00258            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00259"></a>00259            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00260"></a>00260            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.65 -&gt; 1)&quot;</span>;
<a name="l00261"></a>00261       <span class="keywordflow">break</span>;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a77ceaa502eaeff5313a279f08699e9d5">ASPECT_RATIO_BETA</a>:
<a name="l00264"></a>00264       desc &lt;&lt; <span class="stringliteral">&quot;CR / (3 * IR)\n&quot;</span>
<a name="l00265"></a>00265            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00266"></a>00266            &lt;&lt; <span class="stringliteral">&quot;CR = circumsphere radius\n&quot;</span>
<a name="l00267"></a>00267            &lt;&lt; <span class="stringliteral">&quot;IR = inscribed sphere radius\n&quot;</span>
<a name="l00268"></a>00268            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00269"></a>00269            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00270"></a>00270            &lt;&lt; <span class="stringliteral">&quot;Tets: (1 -&gt; 3)&quot;</span>;
<a name="l00271"></a>00271       <span class="keywordflow">break</span>;
<a name="l00272"></a>00272       
<a name="l00273"></a>00273     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad1cac69d1c38539e42934ab8dd2cb5a8">ASPECT_RATIO_GAMMA</a>:
<a name="l00274"></a>00274       desc &lt;&lt; <span class="stringliteral">&quot;S^(3/2) / 8.479670 * V\n&quot;</span>
<a name="l00275"></a>00275            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00276"></a>00276            &lt;&lt; <span class="stringliteral">&quot;S = sum(si*si/6)\n&quot;</span>
<a name="l00277"></a>00277            &lt;&lt; <span class="stringliteral">&quot;si = edge length\n&quot;</span>
<a name="l00278"></a>00278            &lt;&lt; <span class="stringliteral">&quot;V = volume\n&quot;</span>
<a name="l00279"></a>00279            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00280"></a>00280            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00281"></a>00281            &lt;&lt; <span class="stringliteral">&quot;Tets: (1 -&gt; 3)&quot;</span>;
<a name="l00282"></a>00282       <span class="keywordflow">break</span>;
<a name="l00283"></a>00283 
<a name="l00284"></a>00284     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>:
<a name="l00285"></a>00285       desc &lt;&lt; <span class="stringliteral">&quot;min (|J|, |1/J|)\n&quot;</span>
<a name="l00286"></a>00286            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00287"></a>00287            &lt;&lt; <span class="stringliteral">&quot;|J| = norm of Jacobian matrix.\n&quot;</span>
<a name="l00288"></a>00288            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00289"></a>00289            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00290"></a>00290            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.3 -&gt; 1)\n&quot;</span> 
<a name="l00291"></a>00291            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.5 -&gt; 1)\n&quot;</span>
<a name="l00292"></a>00292            &lt;&lt; <span class="stringliteral">&quot;Tris: (0.25 -&gt; 1)\n&quot;</span>
<a name="l00293"></a>00293            &lt;&lt; <span class="stringliteral">&quot;Tets: (0.2 -&gt; 1)&quot;</span>;
<a name="l00294"></a>00294       <span class="keywordflow">break</span>;
<a name="l00295"></a>00295       
<a name="l00296"></a>00296     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>:
<a name="l00297"></a>00297       desc &lt;&lt; <span class="stringliteral">&quot;Minimum Jacobian divided by\n&quot;</span>
<a name="l00298"></a>00298            &lt;&lt; <span class="stringliteral">&quot;the lengths of the LIBMESH_DIM\n&quot;</span>
<a name="l00299"></a>00299            &lt;&lt; <span class="stringliteral">&quot;largest edge vectors.\n&quot;</span>
<a name="l00300"></a>00300            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00301"></a>00301            &lt;&lt; <span class="stringliteral">&quot;LIBMESH_DIM = element dimension.\n&quot;</span>
<a name="l00302"></a>00302            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00303"></a>00303            &lt;&lt; <span class="stringliteral">&quot;Suggested ranges:\n&quot;</span>
<a name="l00304"></a>00304            &lt;&lt; <span class="stringliteral">&quot;Quads: (0.5 -&gt; 1)\n&quot;</span> 
<a name="l00305"></a>00305            &lt;&lt; <span class="stringliteral">&quot;Hexes: (0.5 -&gt; 1)\n&quot;</span>
<a name="l00306"></a>00306            &lt;&lt; <span class="stringliteral">&quot;Tris: (0.5 -&gt; 1.155)\n&quot;</span>
<a name="l00307"></a>00307            &lt;&lt; <span class="stringliteral">&quot;Tets: (0.5 -&gt; 1.414)&quot;</span>;
<a name="l00308"></a>00308       <span class="keywordflow">break</span>;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310     <span class="keywordflow">default</span>:
<a name="l00311"></a>00311       desc &lt;&lt; <span class="stringliteral">&quot;Unknown&quot;</span>;
<a name="l00312"></a>00312       <span class="keywordflow">break</span>;
<a name="l00313"></a>00313     }
<a name="l00314"></a>00314   
<a name="l00315"></a>00315   <span class="keywordflow">return</span> desc.str();
<a name="l00316"></a>00316 }
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00323"></a><a class="code" href="namespacelibMesh_1_1Quality.php#ac0d621e813e680024e89e202d5ba4901">00323</a> std::vector&lt;ElemQuality&gt; <a class="code" href="namespacelibMesh_1_1Quality.php#ac0d621e813e680024e89e202d5ba4901">Quality::valid</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00324"></a>00324 {
<a name="l00325"></a>00325   std::vector&lt;ElemQuality&gt; v;
<a name="l00326"></a>00326   
<a name="l00327"></a>00327   <span class="keywordflow">switch</span> (t)
<a name="l00328"></a>00328     {
<a name="l00329"></a>00329     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00330"></a>00330     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00331"></a>00331     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00332"></a>00332       {
<a name="l00333"></a>00333         <span class="comment">// None yet</span>
<a name="l00334"></a>00334         <span class="keywordflow">break</span>;
<a name="l00335"></a>00335       }
<a name="l00336"></a>00336 
<a name="l00337"></a>00337     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00338"></a>00338     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00339"></a>00339       {
<a name="l00340"></a>00340         v.resize(7);
<a name="l00341"></a>00341         v[0] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a2c906ab7c9aca6cca231949a86b430a0">MAX_ANGLE</a>;
<a name="l00342"></a>00342         v[1] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012aa567a4d684ebdd698e26a3e10456126b">MIN_ANGLE</a>;
<a name="l00343"></a>00343         v[2] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>;
<a name="l00344"></a>00344         v[3] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>;
<a name="l00345"></a>00345         v[4] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>;
<a name="l00346"></a>00346         v[5] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>;
<a name="l00347"></a>00347         v[6] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>;
<a name="l00348"></a>00348         <span class="keywordflow">break</span>;
<a name="l00349"></a>00349       }
<a name="l00350"></a>00350 
<a name="l00351"></a>00351     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00352"></a>00352     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00353"></a>00353     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00354"></a>00354       {
<a name="l00355"></a>00355         v.resize(13);
<a name="l00356"></a>00356         v[0]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>;
<a name="l00357"></a>00357         v[1]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>;
<a name="l00358"></a>00358         v[2]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>;
<a name="l00359"></a>00359         v[3]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a4ac2c62ea7ca226c3586825a77dd64a8">WARP</a>;
<a name="l00360"></a>00360         v[4]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>;
<a name="l00361"></a>00361         v[5]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012aa567a4d684ebdd698e26a3e10456126b">MIN_ANGLE</a>;
<a name="l00362"></a>00362         v[6]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a2c906ab7c9aca6cca231949a86b430a0">MAX_ANGLE</a>;
<a name="l00363"></a>00363         v[7]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>;
<a name="l00364"></a>00364         v[8]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>;
<a name="l00365"></a>00365         v[9]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>;
<a name="l00366"></a>00366         v[10] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>;
<a name="l00367"></a>00367         v[11] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>;
<a name="l00368"></a>00368         v[12] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>;
<a name="l00369"></a>00369         <span class="keywordflow">break</span>;
<a name="l00370"></a>00370       }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00373"></a>00373     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00374"></a>00374       {
<a name="l00375"></a>00375         v.resize(7);
<a name="l00376"></a>00376         v[0]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a77ceaa502eaeff5313a279f08699e9d5">ASPECT_RATIO_BETA</a>;
<a name="l00377"></a>00377         v[1]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad1cac69d1c38539e42934ab8dd2cb5a8">ASPECT_RATIO_GAMMA</a>;
<a name="l00378"></a>00378         v[2]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>;
<a name="l00379"></a>00379         v[3]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>;
<a name="l00380"></a>00380         v[4]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>;
<a name="l00381"></a>00381         v[5]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>;
<a name="l00382"></a>00382         v[6]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>;
<a name="l00383"></a>00383         <span class="keywordflow">break</span>;
<a name="l00384"></a>00384       }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00387"></a>00387     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00388"></a>00388     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00389"></a>00389       {
<a name="l00390"></a>00390         v.resize(11);
<a name="l00391"></a>00391         v[0]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>;
<a name="l00392"></a>00392         v[1]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>;
<a name="l00393"></a>00393         v[2]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>;
<a name="l00394"></a>00394         v[3] = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>;
<a name="l00395"></a>00395         v[4]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>;
<a name="l00396"></a>00396         v[5]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>;
<a name="l00397"></a>00397         v[6]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>;
<a name="l00398"></a>00398         v[7]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>;
<a name="l00399"></a>00399         v[8]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>;
<a name="l00400"></a>00400         v[9]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>;
<a name="l00401"></a>00401         v[10]  = <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>;
<a name="l00402"></a>00402         <span class="keywordflow">break</span>;
<a name="l00403"></a>00403       }
<a name="l00404"></a>00404 
<a name="l00405"></a>00405     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00406"></a>00406     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00407"></a>00407       {
<a name="l00408"></a>00408         <span class="comment">// None yet</span>
<a name="l00409"></a>00409         <span class="keywordflow">break</span>;
<a name="l00410"></a>00410       }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00413"></a>00413       {
<a name="l00414"></a>00414         <span class="comment">// None yet</span>
<a name="l00415"></a>00415         <span class="keywordflow">break</span>;
<a name="l00416"></a>00416       }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00421"></a>00421 <span class="preprocessor"></span>
<a name="l00422"></a>00422     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00423"></a>00423       {
<a name="l00424"></a>00424         <span class="comment">// None yet</span>
<a name="l00425"></a>00425         <span class="keywordflow">break</span>;
<a name="l00426"></a>00426       }
<a name="l00427"></a>00427 
<a name="l00428"></a>00428     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00429"></a>00429     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00430"></a>00430       {
<a name="l00431"></a>00431         <span class="comment">// None yet</span>
<a name="l00432"></a>00432         <span class="keywordflow">break</span>;
<a name="l00433"></a>00433       }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00436"></a>00436     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00437"></a>00437     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00438"></a>00438       {
<a name="l00439"></a>00439         <span class="comment">// None yet</span>
<a name="l00440"></a>00440         <span class="keywordflow">break</span>;
<a name="l00441"></a>00441       }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00444"></a>00444     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00445"></a>00445       {
<a name="l00446"></a>00446         <span class="comment">// None yet</span>
<a name="l00447"></a>00447         <span class="keywordflow">break</span>;
<a name="l00448"></a>00448       }
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 <span class="preprocessor">#endif</span>
<a name="l00451"></a>00451 <span class="preprocessor"></span>
<a name="l00452"></a>00452       
<a name="l00453"></a>00453     <span class="keywordflow">default</span>:
<a name="l00454"></a>00454       {
<a name="l00455"></a>00455         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Undefined element type!.&quot;</span> &lt;&lt; std::endl;
<a name="l00456"></a>00456         libmesh_error();
<a name="l00457"></a>00457       }
<a name="l00458"></a>00458     }
<a name="l00459"></a>00459   
<a name="l00460"></a>00460   <span class="keywordflow">return</span> v;
<a name="l00461"></a>00461 }
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
