<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">elem_refinement.C</div>  </div>
</div>
<div class="contents">
<a href="elem__refinement_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: elem_refinement.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__refinement_8h.php">mesh_refinement.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="remote__elem_8h.php">remote_elem.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// Elem methods</span>
<a name="l00035"></a>00035 
<a name="l00041"></a>00041 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a><a class="code" href="classlibMesh_1_1Elem.php#a162331e5fa77118d63acfe93c1fece82">00043</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a162331e5fa77118d63acfe93c1fece82">Elem::refine</a> (<a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a>&amp; mesh_refinement)
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00046"></a>00046   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00047"></a>00047   
<a name="l00048"></a>00048   <span class="comment">// Create my children if necessary</span>
<a name="l00049"></a>00049   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>)
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051       <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*[this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>()];
<a name="l00052"></a>00052 
<a name="l00053"></a>00053       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_p_level = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00054"></a>00054       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00055"></a>00055         {
<a name="l00056"></a>00056           <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c] = <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), <span class="keyword">this</span>).<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00057"></a>00057           <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>);
<a name="l00058"></a>00058           <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(parent_p_level);
<a name="l00059"></a>00059           <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>[c]-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>());
<a name="l00060"></a>00060         }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062       <span class="comment">// Compute new nodal locations</span>
<a name="l00063"></a>00063       <span class="comment">// and asssign nodes to children</span>
<a name="l00064"></a>00064       <span class="comment">// Make these static.  It is unlikely the</span>
<a name="l00065"></a>00065       <span class="comment">// sizes will change from call to call, so having these</span>
<a name="l00066"></a>00066       <span class="comment">// static should save on reallocations</span>
<a name="l00067"></a>00067       std::vector&lt;std::vector&lt;Point&gt; &gt;        p    (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>());
<a name="l00068"></a>00068       std::vector&lt;std::vector&lt;Node*&gt; &gt;        nodes(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>());
<a name="l00069"></a>00069     
<a name="l00070"></a>00070 
<a name="l00071"></a>00071       <span class="comment">// compute new nodal locations</span>
<a name="l00072"></a>00072       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00073"></a>00073         {       
<a name="l00074"></a>00074           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l00075"></a>00075           p[c].resize    (child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00076"></a>00076           nodes[c].resize(child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00077"></a>00077 
<a name="l00078"></a>00078           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); nc++)
<a name="l00079"></a>00079             {
<a name="l00080"></a>00080               <span class="comment">// zero entries</span>
<a name="l00081"></a>00081               p[c][nc].zero();
<a name="l00082"></a>00082               nodes[c][nc] = NULL;
<a name="l00083"></a>00083           
<a name="l00084"></a>00084               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00085"></a>00085                 {
<a name="l00086"></a>00086                   <span class="comment">// The value from the embedding matrix</span>
<a name="l00087"></a>00087                   <span class="keyword">const</span> <span class="keywordtype">float</span> em_val = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a20e8a3350fb24fd249209e0089b2ca33">embedding_matrix</a>(c,nc,n);
<a name="l00088"></a>00088               
<a name="l00089"></a>00089                   <span class="keywordflow">if</span> (em_val != 0.)
<a name="l00090"></a>00090                     {
<a name="l00091"></a>00091                       p[c][nc].add_scaled (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n), em_val);
<a name="l00092"></a>00092                   
<a name="l00093"></a>00093                       <span class="comment">// We may have found the node, in which case we</span>
<a name="l00094"></a>00094                       <span class="comment">// won&#39;t need to look it up later.</span>
<a name="l00095"></a>00095                       <span class="keywordflow">if</span> (em_val == 1.)
<a name="l00096"></a>00096                         nodes[c][nc] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l00097"></a>00097                     }
<a name="l00098"></a>00098                 }
<a name="l00099"></a>00099             }
<a name="l00100"></a>00100       
<a name="l00101"></a>00101         <span class="comment">// assign nodes to children &amp; add them to the mesh</span>
<a name="l00102"></a>00102           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> pointtol = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af7712d01779f053ea14d49b017c54828">hmin</a>() * TOLERANCE;
<a name="l00103"></a>00103           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); nc++)
<a name="l00104"></a>00104             {
<a name="l00105"></a>00105               <span class="keywordflow">if</span> (nodes[c][nc] != NULL)
<a name="l00106"></a>00106                 {
<a name="l00107"></a>00107                   child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(nc) = nodes[c][nc];
<a name="l00108"></a>00108                 }
<a name="l00109"></a>00109               <span class="keywordflow">else</span>
<a name="l00110"></a>00110                 {
<a name="l00111"></a>00111                   child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(nc) =
<a name="l00112"></a>00112                     mesh_refinement.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a1dae39fb0b5070dc1f343f0c99ca2971">add_point</a>(p[c][nc],
<a name="l00113"></a>00113                                               child-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>(),
<a name="l00114"></a>00114                                               pointtol);
<a name="l00115"></a>00115                   child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(nc)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aeb992cecba98cbbf1b682d25f4043b71">set_n_systems</a>
<a name="l00116"></a>00116                     (this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>());
<a name="l00117"></a>00117                 }
<a name="l00118"></a>00118             }
<a name="l00119"></a>00119       
<a name="l00120"></a>00120           mesh_refinement.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a052c0307f8d231199f9a5d20b9d698ca">add_elem</a> (child);
<a name="l00121"></a>00121           child-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aeb992cecba98cbbf1b682d25f4043b71">set_n_systems</a>(this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a6c321216edb625922b895e2f4b102fc5">n_systems</a>());
<a name="l00122"></a>00122         }
<a name="l00123"></a>00123     }
<a name="l00124"></a>00124   <span class="keywordflow">else</span>
<a name="l00125"></a>00125     {
<a name="l00126"></a>00126       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_p_level = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00127"></a>00127       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00128"></a>00128         {       
<a name="l00129"></a>00129           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a> = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l00130"></a>00130           libmesh_assert(child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l00131"></a>00131           child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a6fb8f2a3f8b6cc1a569263dbc1f1c5cf">Elem::JUST_REFINED</a>);
<a name="l00132"></a>00132           child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(parent_p_level);
<a name="l00133"></a>00133           child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>());
<a name="l00134"></a>00134         }
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// Un-set my refinement flag now</span>
<a name="l00138"></a>00138   this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00139"></a>00139   this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00142"></a>00142     {   
<a name="l00143"></a>00143       libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() == <span class="keyword">this</span>);
<a name="l00144"></a>00144       libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00145"></a>00145     }
<a name="l00146"></a>00146   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a>());
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1Elem.php#ab55ff0440bfc0a90025349270738df4d">00151</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Elem.php#ab55ff0440bfc0a90025349270738df4d">Elem::_cast_node_address_to_unsigned_int</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00152"></a>00152 {
<a name="l00153"></a>00153   <span class="comment">// An unsigned int associated with the</span>
<a name="l00154"></a>00154   <span class="comment">// address of the node n.  We can&#39;t use the</span>
<a name="l00155"></a>00155   <span class="comment">// node number since they can change, so we use the</span>
<a name="l00156"></a>00156   <span class="comment">// Node&#39;s address.  (We also can&#39;t use the x,y,z</span>
<a name="l00157"></a>00157   <span class="comment">// location of the node since that can change too!)</span>
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="preprocessor">#if LIBMESH_SIZEOF_INT == LIBMESH_SIZEOF_VOID_P</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>
<a name="l00161"></a>00161   <span class="comment">// 32-bit machines</span>
<a name="l00162"></a>00162   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_id =
<a name="l00163"></a>00163     <span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n));
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="preprocessor">#elif LIBMESH_SIZEOF_LONG_INT == LIBMESH_SIZEOF_VOID_P</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>
<a name="l00167"></a>00167   <span class="comment">// 64-bit machines </span>
<a name="l00168"></a>00168   <span class="comment">// Another big prime number less than max_unsigned_int</span>
<a name="l00169"></a>00169   <span class="comment">// for key creation on 64-bit machines</span>
<a name="l00170"></a>00170   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp3 = 4294967291;
<a name="l00171"></a>00171   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_id =                     
<a name="l00172"></a>00172     <span class="keyword">reinterpret_cast&lt;</span><span class="keywordtype">long</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n))%bp3;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="preprocessor">#else</span>
<a name="l00175"></a>00175 <span class="preprocessor"></span>  <span class="comment">// Huh?</span>
<a name="l00176"></a>00176 <span class="preprocessor">#error                  WHAT KIND OF CRAZY MACHINE IS THIS? CANNOT COMPILE</span>
<a name="l00177"></a>00177 <span class="preprocessor"></span>
<a name="l00178"></a>00178 <span class="preprocessor">#endif</span>
<a name="l00179"></a>00179 <span class="preprocessor"></span>
<a name="l00180"></a>00180   <span class="keywordflow">return</span> n_id;
<a name="l00181"></a>00181 }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a><a class="code" href="classlibMesh_1_1Elem.php#ac54b6c6495592ce7774d01167b71dfbd">00187</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#ac54b6c6495592ce7774d01167b71dfbd">Elem::coarsen</a>()
<a name="l00188"></a>00188 {
<a name="l00189"></a>00189   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">Elem::COARSEN_INACTIVE</a>);
<a name="l00190"></a>00190   libmesh_assert (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="comment">// We no longer delete children until MeshRefinement::contract()</span>
<a name="l00193"></a>00193   <span class="comment">// delete [] _children;</span>
<a name="l00194"></a>00194   <span class="comment">// _children = NULL;</span>
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_p_level = 0;
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// re-compute hanging node nodal locations</span>
<a name="l00199"></a>00199   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00200"></a>00200   {     
<a name="l00201"></a>00201     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *mychild = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l00202"></a>00202     <span class="keywordflow">if</span> (mychild == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00203"></a>00203       <span class="keywordflow">continue</span>;
<a name="l00204"></a>00204     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;mychild-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); nc++)
<a name="l00205"></a>00205     {
<a name="l00206"></a>00206       <a class="code" href="classlibMesh_1_1Point.php">Point</a> new_pos;
<a name="l00207"></a>00207       <span class="keywordtype">bool</span> calculated_new_pos = <span class="keyword">false</span>;
<a name="l00208"></a>00208 
<a name="l00209"></a>00209       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00210"></a>00210       {
<a name="l00211"></a>00211         <span class="comment">// The value from the embedding matrix</span>
<a name="l00212"></a>00212         <span class="keyword">const</span> <span class="keywordtype">float</span> em_val = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a20e8a3350fb24fd249209e0089b2ca33">embedding_matrix</a>(c,nc,n);
<a name="l00213"></a>00213          
<a name="l00214"></a>00214         <span class="comment">// The node location is somewhere between existing vertices</span>
<a name="l00215"></a>00215         <span class="keywordflow">if</span> ((em_val != 0.) &amp;&amp; (em_val != 1.)) 
<a name="l00216"></a>00216         {
<a name="l00217"></a>00217           new_pos.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n), em_val);
<a name="l00218"></a>00218           calculated_new_pos = <span class="keyword">true</span>;
<a name="l00219"></a>00219         }
<a name="l00220"></a>00220       }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222       <span class="keywordflow">if</span>(calculated_new_pos)
<a name="l00223"></a>00223       { 
<a name="l00224"></a>00224         <span class="comment">//Move the existing node back into it&#39;s original location</span>
<a name="l00225"></a>00225         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00226"></a>00226         {
<a name="l00227"></a>00227           <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; child_node = *(mychild-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(nc));
<a name="l00228"></a>00228           child_node(i)=new_pos(i);
<a name="l00229"></a>00229         }
<a name="l00230"></a>00230       }
<a name="l00231"></a>00231     }
<a name="l00232"></a>00232   }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00235"></a>00235     {   
<a name="l00236"></a>00236       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *mychild = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l00237"></a>00237       <span class="keywordflow">if</span> (mychild == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00238"></a>00238         <span class="keywordflow">continue</span>;
<a name="l00239"></a>00239       libmesh_assert (mychild-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00240"></a>00240       mychild-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00241"></a>00241       <span class="keywordflow">if</span> (mychild-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; parent_p_level)
<a name="l00242"></a>00242         parent_p_level = mychild-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00243"></a>00243     }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>);
<a name="l00246"></a>00246   this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(parent_p_level);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00249"></a>00249 }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a><a class="code" href="classlibMesh_1_1Elem.php#a190384cbf87edfe3d41219615f3b6d27">00253</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Elem.php#a190384cbf87edfe3d41219615f3b6d27">Elem::contract</a>()
<a name="l00254"></a>00254 {
<a name="l00255"></a>00255   <span class="comment">// Subactive elements get deleted entirely, not contracted</span>
<a name="l00256"></a>00256   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="comment">// Active contracted elements no longer can have children</span>
<a name="l00259"></a>00259   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>)
<a name="l00260"></a>00260     {
<a name="l00261"></a>00261       <span class="keyword">delete</span> [] <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a>;
<a name="l00262"></a>00262       <a class="code" href="classlibMesh_1_1Elem.php#ab946553573f56cea901654619264101e">_children</a> = NULL;
<a name="l00263"></a>00263     }
<a name="l00264"></a>00264   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54adec28448bd3f7297806b7d58e9625240">Elem::JUST_COARSENED</a>)
<a name="l00265"></a>00265     this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00266"></a>00266 }
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00269"></a>00269 <span class="preprocessor"></span>
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 } <span class="comment">// namespace libMesh</span>
<a name="l00272"></a>00272 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
