<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">elem_type.C</div>  </div>
</div>
<div class="contents">
<a href="elem__type_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: elem_type.C 4044 2010-10-12 23:33:03Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="elem__type_8h.php">elem_type.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// Element type definitions</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="namespacelibMesh_1_1ElementTypes.php#a87f4110fa4d3b21cb5543fa9bc33e090">00033</a> std::string <a class="code" href="namespacelibMesh_1_1ElementTypes.php#a87f4110fa4d3b21cb5543fa9bc33e090">ElementTypes::basic_name</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   std::string its_name;
<a name="l00036"></a>00036   <span class="keywordflow">switch</span> (t)
<a name="l00037"></a>00037     {
<a name="l00038"></a>00038     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00039"></a>00039     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00040"></a>00040     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00041"></a>00041       {
<a name="l00042"></a>00042         its_name = <span class="stringliteral">&quot;Edge&quot;</span>;
<a name="l00043"></a>00043         <span class="keywordflow">break</span>;
<a name="l00044"></a>00044       }
<a name="l00045"></a>00045 
<a name="l00046"></a>00046     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00047"></a>00047     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00048"></a>00048       {
<a name="l00049"></a>00049         its_name = <span class="stringliteral">&quot;Triangle&quot;</span>;
<a name="l00050"></a>00050         <span class="keywordflow">break</span>;
<a name="l00051"></a>00051       }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00054"></a>00054     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00055"></a>00055     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00056"></a>00056       {
<a name="l00057"></a>00057         its_name = <span class="stringliteral">&quot;Quadrilateral&quot;</span>;
<a name="l00058"></a>00058         <span class="keywordflow">break</span>;
<a name="l00059"></a>00059       }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00062"></a>00062     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00063"></a>00063       {
<a name="l00064"></a>00064         its_name = <span class="stringliteral">&quot;Tetrahedron&quot;</span>;
<a name="l00065"></a>00065         <span class="keywordflow">break</span>;
<a name="l00066"></a>00066       }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00069"></a>00069     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00070"></a>00070     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00071"></a>00071       {
<a name="l00072"></a>00072         its_name = <span class="stringliteral">&quot;Hexahedron&quot;</span>;
<a name="l00073"></a>00073         <span class="keywordflow">break</span>;
<a name="l00074"></a>00074       }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00077"></a>00077     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00078"></a>00078       {
<a name="l00079"></a>00079         its_name = <span class="stringliteral">&quot;Prism&quot;</span>;
<a name="l00080"></a>00080         <span class="keywordflow">break</span>;
<a name="l00081"></a>00081       }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00084"></a>00084       {
<a name="l00085"></a>00085         its_name = <span class="stringliteral">&quot;Pyramid&quot;</span>;
<a name="l00086"></a>00086         <span class="keywordflow">break</span>;
<a name="l00087"></a>00087       }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>
<a name="l00093"></a>00093     <span class="comment">// infinite elements</span>
<a name="l00094"></a>00094     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00095"></a>00095       {
<a name="l00096"></a>00096         its_name = <span class="stringliteral">&quot;Infinite Edge&quot;</span>;
<a name="l00097"></a>00097         <span class="keywordflow">break</span>;
<a name="l00098"></a>00098       }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00101"></a>00101     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00102"></a>00102       {
<a name="l00103"></a>00103         its_name = <span class="stringliteral">&quot;Infinite Quadrilateral&quot;</span>;
<a name="l00104"></a>00104         <span class="keywordflow">break</span>;
<a name="l00105"></a>00105       }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00108"></a>00108     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00109"></a>00109     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00110"></a>00110       {
<a name="l00111"></a>00111         its_name = <span class="stringliteral">&quot;Infinite Hexahedron&quot;</span>;
<a name="l00112"></a>00112         <span class="keywordflow">break</span>;
<a name="l00113"></a>00113       }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00116"></a>00116     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00117"></a>00117       {
<a name="l00118"></a>00118         its_name = <span class="stringliteral">&quot;Infinite Prism&quot;</span>;
<a name="l00119"></a>00119         <span class="keywordflow">break</span>;
<a name="l00120"></a>00120       }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="preprocessor">#endif</span>
<a name="l00123"></a>00123 <span class="preprocessor"></span>
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     <span class="keywordflow">default</span>:
<a name="l00126"></a>00126       {
<a name="l00127"></a>00127         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Undefined element type!.&quot;</span> &lt;&lt; std::endl;
<a name="l00128"></a>00128         libmesh_error();
<a name="l00129"></a>00129       }
<a name="l00130"></a>00130     }
<a name="l00131"></a>00131   <span class="keywordflow">return</span> its_name;
<a name="l00132"></a>00132 }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a><a class="code" href="namespacelibMesh_1_1ElementTypes.php#acfc82a5c84a72bfae526be628ca2ce54">00135</a> std::string <a class="code" href="namespacelibMesh_1_1ElementTypes.php#acfc82a5c84a72bfae526be628ca2ce54">ElementTypes::name</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00136"></a>00136 {
<a name="l00137"></a>00137   std::string its_name;
<a name="l00138"></a>00138   <span class="keywordflow">switch</span> (t)
<a name="l00139"></a>00139     {
<a name="l00140"></a>00140     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00141"></a>00141       {
<a name="l00142"></a>00142         its_name = <span class="stringliteral">&quot;Edge 2&quot;</span>;
<a name="l00143"></a>00143         <span class="keywordflow">break</span>;
<a name="l00144"></a>00144       }
<a name="l00145"></a>00145       
<a name="l00146"></a>00146     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00147"></a>00147       {
<a name="l00148"></a>00148         its_name = <span class="stringliteral">&quot;Edge 3&quot;</span>;
<a name="l00149"></a>00149         <span class="keywordflow">break</span>;
<a name="l00150"></a>00150       }
<a name="l00151"></a>00151       
<a name="l00152"></a>00152     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00153"></a>00153       {
<a name="l00154"></a>00154         its_name = <span class="stringliteral">&quot;Edge 4&quot;</span>;
<a name="l00155"></a>00155         <span class="keywordflow">break</span>;
<a name="l00156"></a>00156       }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00159"></a>00159       {
<a name="l00160"></a>00160         its_name = <span class="stringliteral">&quot;Tri 3&quot;</span>;
<a name="l00161"></a>00161         <span class="keywordflow">break</span>;
<a name="l00162"></a>00162       }
<a name="l00163"></a>00163       
<a name="l00164"></a>00164     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00165"></a>00165       {
<a name="l00166"></a>00166         its_name = <span class="stringliteral">&quot;Tri 6&quot;</span>;
<a name="l00167"></a>00167         <span class="keywordflow">break</span>;
<a name="l00168"></a>00168       }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00171"></a>00171       {
<a name="l00172"></a>00172         its_name = <span class="stringliteral">&quot;Quad 4&quot;</span>;
<a name="l00173"></a>00173         <span class="keywordflow">break</span>;
<a name="l00174"></a>00174       }
<a name="l00175"></a>00175       
<a name="l00176"></a>00176     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00177"></a>00177       {
<a name="l00178"></a>00178         its_name = <span class="stringliteral">&quot;Quad 8&quot;</span>;
<a name="l00179"></a>00179         <span class="keywordflow">break</span>;
<a name="l00180"></a>00180       }
<a name="l00181"></a>00181       
<a name="l00182"></a>00182     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00183"></a>00183       {
<a name="l00184"></a>00184         its_name = <span class="stringliteral">&quot;Quad 9&quot;</span>;
<a name="l00185"></a>00185         <span class="keywordflow">break</span>;
<a name="l00186"></a>00186       }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00189"></a>00189       {
<a name="l00190"></a>00190         its_name = <span class="stringliteral">&quot;Tet 4&quot;</span>;
<a name="l00191"></a>00191         <span class="keywordflow">break</span>;
<a name="l00192"></a>00192       }
<a name="l00193"></a>00193       
<a name="l00194"></a>00194     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00195"></a>00195       {
<a name="l00196"></a>00196         its_name = <span class="stringliteral">&quot;Tet 10&quot;</span>;
<a name="l00197"></a>00197         <span class="keywordflow">break</span>;
<a name="l00198"></a>00198       }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00201"></a>00201       {
<a name="l00202"></a>00202         its_name = <span class="stringliteral">&quot;Hex 8&quot;</span>;
<a name="l00203"></a>00203         <span class="keywordflow">break</span>;
<a name="l00204"></a>00204       }
<a name="l00205"></a>00205       
<a name="l00206"></a>00206     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00207"></a>00207       {
<a name="l00208"></a>00208         its_name = <span class="stringliteral">&quot;Hex 20&quot;</span>;
<a name="l00209"></a>00209         <span class="keywordflow">break</span>;
<a name="l00210"></a>00210       }
<a name="l00211"></a>00211       
<a name="l00212"></a>00212     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00213"></a>00213       {
<a name="l00214"></a>00214         its_name = <span class="stringliteral">&quot;Hex 27&quot;</span>;
<a name="l00215"></a>00215         <span class="keywordflow">break</span>;
<a name="l00216"></a>00216       }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00219"></a>00219       {
<a name="l00220"></a>00220         its_name = <span class="stringliteral">&quot;Prism 6&quot;</span>;
<a name="l00221"></a>00221         <span class="keywordflow">break</span>;
<a name="l00222"></a>00222       }
<a name="l00223"></a>00223       
<a name="l00224"></a>00224     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00225"></a>00225       {
<a name="l00226"></a>00226         its_name = <span class="stringliteral">&quot;Prism 8&quot;</span>;
<a name="l00227"></a>00227         <span class="keywordflow">break</span>;
<a name="l00228"></a>00228       }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00231"></a>00231       {
<a name="l00232"></a>00232         its_name = <span class="stringliteral">&quot;Pyramid 5&quot;</span>;
<a name="l00233"></a>00233         <span class="keywordflow">break</span>;
<a name="l00234"></a>00234       }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span>
<a name="l00240"></a>00240     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00241"></a>00241       {
<a name="l00242"></a>00242         its_name = <span class="stringliteral">&quot;Infinite Edge 2&quot;</span>;
<a name="l00243"></a>00243         <span class="keywordflow">break</span>;
<a name="l00244"></a>00244       }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00247"></a>00247       {
<a name="l00248"></a>00248         its_name = <span class="stringliteral">&quot;Infinite Quad 4&quot;</span>;
<a name="l00249"></a>00249         <span class="keywordflow">break</span>;
<a name="l00250"></a>00250       }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00253"></a>00253       {
<a name="l00254"></a>00254         its_name = <span class="stringliteral">&quot;Infinite Quad 6&quot;</span>;
<a name="l00255"></a>00255         <span class="keywordflow">break</span>;
<a name="l00256"></a>00256       }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00259"></a>00259       {
<a name="l00260"></a>00260         its_name = <span class="stringliteral">&quot;Infinite Hex 8&quot;</span>;
<a name="l00261"></a>00261         <span class="keywordflow">break</span>;
<a name="l00262"></a>00262       }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00265"></a>00265       {
<a name="l00266"></a>00266         its_name = <span class="stringliteral">&quot;Infinite Hex 16&quot;</span>;
<a name="l00267"></a>00267         <span class="keywordflow">break</span>;
<a name="l00268"></a>00268       }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00271"></a>00271       {
<a name="l00272"></a>00272         its_name = <span class="stringliteral">&quot;Infinite Hex 18&quot;</span>;
<a name="l00273"></a>00273         <span class="keywordflow">break</span>;
<a name="l00274"></a>00274       }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00277"></a>00277       {
<a name="l00278"></a>00278         its_name = <span class="stringliteral">&quot;Infinite Prism 6&quot;</span>;
<a name="l00279"></a>00279         <span class="keywordflow">break</span>;
<a name="l00280"></a>00280       }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00283"></a>00283       {
<a name="l00284"></a>00284         its_name = <span class="stringliteral">&quot;Infinite Prism 12&quot;</span>;
<a name="l00285"></a>00285         <span class="keywordflow">break</span>;
<a name="l00286"></a>00286       }
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 <span class="preprocessor">#endif</span>
<a name="l00289"></a>00289 <span class="preprocessor"></span>
<a name="l00290"></a>00290 
<a name="l00291"></a>00291       
<a name="l00292"></a>00292     <span class="keywordflow">default</span>:
<a name="l00293"></a>00293       {
<a name="l00294"></a>00294         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Undefined element type!.&quot;</span> &lt;&lt; std::endl;
<a name="l00295"></a>00295         libmesh_error();
<a name="l00296"></a>00296       }
<a name="l00297"></a>00297     }
<a name="l00298"></a>00298   <span class="keywordflow">return</span> its_name;
<a name="l00299"></a>00299 }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
