<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">ensight_io.C</div>  </div>
</div>
<div class="contents">
<a href="ensight__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: ensight_io.C 4313 2011-03-31 21:06:34Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;cstring&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;stdio.h&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="ensight__io_8h.php">ensight_io.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a0e8ce6e193def21e5c140cb41c274d61">00041</a> <a class="code" href="classlibMesh_1_1EnsightIO.php#a0e8ce6e193def21e5c140cb41c274d61">EnsightIO::EnsightIO</a> (<span class="keyword">const</span> std::string &amp;filename, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> &amp;eq) :
<a name="l00042"></a>00042   <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt; (eq.get_mesh()),
<a name="l00043"></a>00043   _equation_systems(eq)
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   
<a name="l00046"></a>00046   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00047"></a>00047     <a class="code" href="classlibMesh_1_1EnsightIO.php#ab876905d68b01a9899faf90cbe6e9dc0">_ensight_file_name</a> = filename;
<a name="l00048"></a>00048   <span class="keywordflow">else</span>
<a name="l00049"></a>00049     {
<a name="l00050"></a>00050       std::stringstream tmp_file;
<a name="l00051"></a>00051       tmp_file &lt;&lt; filename &lt;&lt; <span class="stringliteral">&quot;_rank&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00052"></a>00052       <a class="code" href="classlibMesh_1_1EnsightIO.php#ab876905d68b01a9899faf90cbe6e9dc0">_ensight_file_name</a> = tmp_file.str();      
<a name="l00053"></a>00053     }
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a0a74130067939f48215c1335f94fdf5d">00058</a> <a class="code" href="classlibMesh_1_1EnsightIO.php#a0a74130067939f48215c1335f94fdf5d">EnsightIO::~EnsightIO</a> ()
<a name="l00059"></a>00059 {}
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#aa1a1d4165f6a43342b7cc58aa7f7fe0d">00063</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aa1a1d4165f6a43342b7cc58aa7f7fe0d">EnsightIO::add_vector</a> (<span class="keyword">const</span> std::string &amp;system_name, <span class="keyword">const</span> std::string &amp;vec_description, 
<a name="l00064"></a>00064                             <span class="keyword">const</span> std::string &amp;u, <span class="keyword">const</span> std::string &amp;v)
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   libmesh_assert (<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5119f662bf0ea98b1df8f3f94ac5cf11">has_system</a>(system_name));
<a name="l00067"></a>00067   libmesh_assert (<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(system_name).has_variable(u));
<a name="l00068"></a>00068   libmesh_assert (<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(system_name).has_variable(v));
<a name="l00069"></a>00069   
<a name="l00070"></a>00070   <a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php">Vectors</a> vec; 
<a name="l00071"></a>00071   vec.<a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php#a5123bff6944dc58c8f6e8803cde1680b">description</a> = vec_description;
<a name="l00072"></a>00072   vec.components.push_back(u);
<a name="l00073"></a>00073   vec.components.push_back(v);  
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1EnsightIO.php#a2051344bd682980403fce51344cd2430">_systems_vars_map</a>[system_name].EnsightVectors.push_back(vec);
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079                 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#aa578696efd360e00da7ac060c6e39d0c">00080</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aa1a1d4165f6a43342b7cc58aa7f7fe0d">EnsightIO::add_vector</a> (<span class="keyword">const</span> std::string &amp;system_name, <span class="keyword">const</span> std::string &amp;vec_name, 
<a name="l00081"></a>00081                             <span class="keyword">const</span> std::string &amp;u, <span class="keyword">const</span> std::string &amp;v, <span class="keyword">const</span> std::string &amp;w)
<a name="l00082"></a>00082 {
<a name="l00083"></a>00083   libmesh_assert(<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5119f662bf0ea98b1df8f3f94ac5cf11">has_system</a>(system_name));
<a name="l00084"></a>00084   libmesh_assert(<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(system_name).has_variable(u));
<a name="l00085"></a>00085   libmesh_assert(<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(system_name).has_variable(v));
<a name="l00086"></a>00086   libmesh_assert(<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(system_name).has_variable(w));
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php">Vectors</a> vec; 
<a name="l00089"></a>00089   vec.<a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php#a5123bff6944dc58c8f6e8803cde1680b">description</a> = vec_name;
<a name="l00090"></a>00090   vec.components.push_back(u);
<a name="l00091"></a>00091   vec.components.push_back(v);  
<a name="l00092"></a>00092   vec.components.push_back(w);  
<a name="l00093"></a>00093   <a class="code" href="classlibMesh_1_1EnsightIO.php#a2051344bd682980403fce51344cd2430">_systems_vars_map</a>[system_name].EnsightVectors.push_back(vec);
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097                 
<a name="l00098"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a068ca884fe7e2d1bfc219db0fb7ca1d4">00098</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#a068ca884fe7e2d1bfc219db0fb7ca1d4">EnsightIO::add_scalar</a>(<span class="keyword">const</span> std::string &amp;system_name, <span class="keyword">const</span> std::string &amp;scl_description, 
<a name="l00099"></a>00099                            <span class="keyword">const</span> std::string &amp;s)
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   libmesh_assert(<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5119f662bf0ea98b1df8f3f94ac5cf11">has_system</a>(system_name));
<a name="l00102"></a>00102   libmesh_assert(<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(system_name).has_variable(s));
<a name="l00103"></a>00103   
<a name="l00104"></a>00104   <a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php">Scalars</a> scl;
<a name="l00105"></a>00105   scl.<a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php#ad7aace074cb7b3b0597c224d91a4a44a">description</a> = scl_description;
<a name="l00106"></a>00106   scl.scalar_name = s;
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   <a class="code" href="classlibMesh_1_1EnsightIO.php#a2051344bd682980403fce51344cd2430">_systems_vars_map</a>[system_name].EnsightScalars.push_back(scl);
<a name="l00109"></a>00109 }
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 <span class="comment">// This method must be implemented as it is pure virtual in</span>
<a name="l00114"></a>00114 <span class="comment">// the MeshOutput base class.</span>
<a name="l00115"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a352e34228c269ffcb694e688c7ee45f5">00115</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#a352e34228c269ffcb694e688c7ee45f5">EnsightIO::write</a> (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   <span class="comment">// We may need to gather a ParallelMesh to output it, making that</span>
<a name="l00118"></a>00118   <span class="comment">// const qualifier in our constructor a dirty lie</span>
<a name="l00119"></a>00119   MeshOutputSerializer serialize(const_cast&lt;MeshBase&amp;&gt;(this-&gt;<a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a>()), !<a class="code" href="classlibMesh_1_1MeshOutput.php#a0b28b0e8e7d99921d181c7c122384d0d">_is_parallel_format</a>);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <a class="code" href="classlibMesh_1_1EnsightIO.php#ab876905d68b01a9899faf90cbe6e9dc0">_ensight_file_name</a> = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00122"></a>00122   this-&gt;<a class="code" href="classlibMesh_1_1EnsightIO.php#a352e34228c269ffcb694e688c7ee45f5">write</a>();
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a8885510c3f6394ccb9cbbf8e15018db0">00127</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#a352e34228c269ffcb694e688c7ee45f5">EnsightIO::write</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> time)
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   this-&gt;<a class="code" href="classlibMesh_1_1EnsightIO.php#ab10ac1d08bc00cdd9e96abc603c23318">write_ascii</a>(time);
<a name="l00130"></a>00130   this-&gt;<a class="code" href="classlibMesh_1_1EnsightIO.php#aba312f1ba1cbd2cf3433681fc4871bff">write_case</a>();
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#ab10ac1d08bc00cdd9e96abc603c23318">00135</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#ab10ac1d08bc00cdd9e96abc603c23318">EnsightIO::write_ascii</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> time)
<a name="l00136"></a>00136 {
<a name="l00137"></a>00137   <a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">_time_steps</a>.push_back(time);
<a name="l00138"></a>00138   
<a name="l00139"></a>00139   this-&gt;<a class="code" href="classlibMesh_1_1EnsightIO.php#aab90c2a77c22b5b85252dae66b4ad789">write_geometry_ascii</a>();
<a name="l00140"></a>00140   this-&gt;<a class="code" href="classlibMesh_1_1EnsightIO.php#aadf3ecc4a9d2b77e63c7ea5fcb5d9f16">write_solution_ascii</a>();
<a name="l00141"></a>00141 }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144         
<a name="l00145"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#aab90c2a77c22b5b85252dae66b4ad789">00145</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aab90c2a77c22b5b85252dae66b4ad789">EnsightIO::write_geometry_ascii</a>()
<a name="l00146"></a>00146 {
<a name="l00147"></a>00147   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> file;
<a name="l00148"></a>00148   file &lt;&lt; <a class="code" href="classlibMesh_1_1EnsightIO.php#ab876905d68b01a9899faf90cbe6e9dc0">_ensight_file_name</a> &lt;&lt; <span class="stringliteral">&quot;.geo&quot;</span>;
<a name="l00149"></a>00149   
<a name="l00150"></a>00150   OSSRealzeroright(file,3,0,<a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">_time_steps</a>.size()-1);
<a name="l00151"></a>00151   
<a name="l00152"></a>00152   FILE* fout = fopen(file.str().c_str(),<span class="stringliteral">&quot;w&quot;</span>);
<a name="l00153"></a>00153   
<a name="l00154"></a>00154   <span class="keywordtype">char</span> buffer[80];
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   fprintf(fout,<span class="stringliteral">&quot;EnSight Gold Geometry File Format\n&quot;</span>);
<a name="l00157"></a>00157   fprintf(fout,<span class="stringliteral">&quot;Generated by \n&quot;</span>);
<a name="l00158"></a>00158   fprintf(fout,<span class="stringliteral">&quot;node id off\n&quot;</span>);
<a name="l00159"></a>00159   fprintf(fout,<span class="stringliteral">&quot;element id given\n&quot;</span>);
<a name="l00160"></a>00160   fprintf(fout,<span class="stringliteral">&quot;part\n&quot;</span>);
<a name="l00161"></a>00161   fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,1);
<a name="l00162"></a>00162   fprintf(fout,<span class="stringliteral">&quot;uns-elements\n&quot;</span>);
<a name="l00163"></a>00163   fprintf(fout,<span class="stringliteral">&quot;coordinates\n&quot;</span>);
<a name="l00164"></a>00164   
<a name="l00165"></a>00165   <span class="comment">// mapping between nodal index and your coordinates</span>
<a name="l00166"></a>00166   std::map&lt;int, Point&gt;                     mesh_nodes_map;
<a name="l00167"></a>00167   <span class="keyword">typedef</span> std::map &lt;int, Point&gt;::iterator  mesh_nodes_iterator;
<a name="l00168"></a>00168   <span class="keyword">typedef</span> std::pair&lt;int, Point&gt;            mesh_node_value;
<a name="l00169"></a>00169   
<a name="l00170"></a>00170   <span class="comment">// Mapping between global and local indices</span>
<a name="l00171"></a>00171   std::map &lt;int, int&gt;       ensight_node_index;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="comment">// Grouping elements of the same type</span>
<a name="l00174"></a>00174   std::map&lt;ElemType, std::vector&lt;const Elem*&gt; &gt;                    ensight_parts_map;
<a name="l00175"></a>00175   <span class="keyword">typedef</span> std::map&lt;ElemType, std::vector&lt;const Elem*&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>  ensight_parts_iterator; 
<a name="l00176"></a>00176   <span class="keyword">typedef</span> std::pair&lt;ElemType, std::vector&lt;const Elem*&gt; &gt;           ensight_parts_value;   
<a name="l00177"></a>00177         
<a name="l00178"></a>00178   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a> = <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00181"></a>00181   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="keywordflow">for</span> ( ; el != end_el ; ++el) 
<a name="l00184"></a>00184     {
<a name="l00185"></a>00185       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00186"></a>00186       ensight_parts_map[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>()].push_back(elem);
<a name="l00187"></a>00187     
<a name="l00188"></a>00188       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); i++)
<a name="l00189"></a>00189         mesh_nodes_map[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(i)] = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i);    
<a name="l00190"></a>00190     }
<a name="l00191"></a>00191       
<a name="l00192"></a>00192   <span class="comment">// Write number of local points</span>
<a name="l00193"></a>00193   fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,static_cast&lt;int&gt;(mesh_nodes_map.size()));
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   mesh_nodes_iterator           no_it = mesh_nodes_map.begin();
<a name="l00196"></a>00196   <span class="keyword">const</span> mesh_nodes_iterator no_end_it = mesh_nodes_map.end();
<a name="l00197"></a>00197         
<a name="l00198"></a>00198   <span class="comment">// write x</span>
<a name="l00199"></a>00199   <span class="keywordflow">for</span>(<span class="keywordtype">int</span> i = 1; no_it != no_end_it; ++no_it, i++)
<a name="l00200"></a>00200     {
<a name="l00201"></a>00201       <span class="keyword">const</span> mesh_node_value pn = *no_it;
<a name="l00202"></a>00202       fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,pn.second(0));
<a name="l00203"></a>00203       ensight_node_index[pn.first] = i;
<a name="l00204"></a>00204     }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <span class="comment">// write y</span>
<a name="l00207"></a>00207   no_it = mesh_nodes_map.begin();
<a name="l00208"></a>00208   <span class="keywordflow">for</span>(; no_it != no_end_it; ++no_it)
<a name="l00209"></a>00209     {
<a name="l00210"></a>00210       <span class="keyword">const</span> mesh_node_value pn = *no_it;
<a name="l00211"></a>00211       fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,pn.second(1));
<a name="l00212"></a>00212     }
<a name="l00213"></a>00213   
<a name="l00214"></a>00214   <span class="comment">// write z</span>
<a name="l00215"></a>00215   no_it = mesh_nodes_map.begin();
<a name="l00216"></a>00216   <span class="keywordflow">for</span>(; no_it != no_end_it; ++no_it)
<a name="l00217"></a>00217     {
<a name="l00218"></a>00218       <span class="keyword">const</span> mesh_node_value pn = *no_it;
<a name="l00219"></a>00219       fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,pn.second(2));
<a name="l00220"></a>00220     }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   ensight_parts_iterator            parts_it  =  ensight_parts_map.begin();
<a name="l00223"></a>00223   <span class="keyword">const</span> ensight_parts_iterator  end_parts_it  =  ensight_parts_map.end();
<a name="l00224"></a>00224   
<a name="l00225"></a>00225   <span class="comment">// Write parts</span>
<a name="l00226"></a>00226   <span class="keywordflow">for</span> (; parts_it != end_parts_it; ++parts_it)
<a name="l00227"></a>00227     {
<a name="l00228"></a>00228       ensight_parts_value kvp = *parts_it;
<a name="l00229"></a>00229       
<a name="l00230"></a>00230       <span class="comment">// Write element type</span>
<a name="l00231"></a>00231       <a class="code" href="classlibMesh_1_1EnsightIO.php#a965d85e21c0ab6d97786abcf2be687f7">elem_type_to_string</a>(kvp.first,buffer);
<a name="l00232"></a>00232       fprintf(fout,<span class="stringliteral">&quot;\n%s\n&quot;</span>, buffer);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234       std::vector&lt;const Elem*&gt; elem_ref  = kvp.second;
<a name="l00235"></a>00235       
<a name="l00236"></a>00236       <span class="comment">// Write number of element</span>
<a name="l00237"></a>00237       fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,static_cast&lt;int&gt;(elem_ref.size()));
<a name="l00238"></a>00238       
<a name="l00239"></a>00239       <span class="comment">// Write element id</span>
<a name="l00240"></a>00240       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; elem_ref.size(); i++)
<a name="l00241"></a>00241         fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,elem_ref[i]-&gt;<span class="keywordtype">id</span>());
<a name="l00242"></a>00242       
<a name="l00243"></a>00243       <span class="comment">// Write connectivity</span>
<a name="l00244"></a>00244       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; elem_ref.size(); i++)
<a name="l00245"></a>00245         {
<a name="l00246"></a>00246           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j &lt; elem_ref[i]-&gt;n_nodes(); j++) {
<a name="l00247"></a>00247             <span class="comment">// tests!</span>
<a name="l00248"></a>00248             <span class="keywordflow">if</span>(kvp.first == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a> &amp;&amp; i==4)
<a name="l00249"></a>00249               <span class="keywordflow">continue</span>;
<a name="l00250"></a>00250             <span class="comment">// tests!</span>
<a name="l00251"></a>00251             <span class="keywordflow">if</span>(kvp.first == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a> &amp;&amp; (i==4    || i ==10 || i == 12 ||
<a name="l00252"></a>00252                                       i == 13 || i ==14 || i == 16 || i == 22))
<a name="l00253"></a>00253               <span class="keywordflow">continue</span>;
<a name="l00254"></a>00254             
<a name="l00255"></a>00255             fprintf(fout,<span class="stringliteral">&quot;%10d&quot;</span>,ensight_node_index[elem_ref[i]-&gt;node(j)]);
<a name="l00256"></a>00256           }
<a name="l00257"></a>00257           fprintf(fout,<span class="stringliteral">&quot;\n&quot;</span>);
<a name="l00258"></a>00258         }      
<a name="l00259"></a>00259     }
<a name="l00260"></a>00260   fclose(fout);
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#aba312f1ba1cbd2cf3433681fc4871bff">00267</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aba312f1ba1cbd2cf3433681fc4871bff">EnsightIO::write_case</a>()
<a name="l00268"></a>00268 {
<a name="l00269"></a>00269   std::stringstream case_file, geo_file, scl_file;
<a name="l00270"></a>00270   case_file &lt;&lt; <a class="code" href="classlibMesh_1_1EnsightIO.php#ab876905d68b01a9899faf90cbe6e9dc0">_ensight_file_name</a> &lt;&lt; <span class="stringliteral">&quot;.case&quot;</span>;
<a name="l00271"></a>00271   
<a name="l00272"></a>00272   FILE* fout = fopen(case_file.str().c_str(),<span class="stringliteral">&quot;w&quot;</span>);
<a name="l00273"></a>00273   fprintf(fout,<span class="stringliteral">&quot;FORMAT\n&quot;</span>);
<a name="l00274"></a>00274   fprintf(fout,<span class="stringliteral">&quot;type:  ensight gold\n\n&quot;</span>);
<a name="l00275"></a>00275   fprintf(fout,<span class="stringliteral">&quot;GEOMETRY\n&quot;</span>);
<a name="l00276"></a>00276   
<a name="l00277"></a>00277   geo_file &lt;&lt; _ensight_file_name &lt;&lt; <span class="stringliteral">&quot;.geo&quot;</span>;
<a name="l00278"></a>00278   
<a name="l00279"></a>00279   
<a name="l00280"></a>00280   fprintf(fout,<span class="stringliteral">&quot;model:            1     %s***\n&quot;</span>,geo_file.str().c_str());
<a name="l00281"></a>00281       
<a name="l00282"></a>00282   <a class="code" href="classlibMesh_1_1EnsightIO.php#ad3c1424dc0157f609bddc6057c7b2ddb">SystemsVarsMapIterator</a>       sys      = <a class="code" href="classlibMesh_1_1EnsightIO.php#a2051344bd682980403fce51344cd2430">_systems_vars_map</a>.begin();
<a name="l00283"></a>00283   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#ad3c1424dc0157f609bddc6057c7b2ddb">SystemsVarsMapIterator</a> sys_end  = <a class="code" href="classlibMesh_1_1EnsightIO.php#a2051344bd682980403fce51344cd2430">_systems_vars_map</a>.end();
<a name="l00284"></a>00284   
<a name="l00285"></a>00285   <span class="comment">// Write Variable per node section</span>
<a name="l00286"></a>00286   <span class="keywordflow">if</span> ( sys != sys_end )
<a name="l00287"></a>00287     fprintf(fout,<span class="stringliteral">&quot;\n\nVARIABLE\n&quot;</span>);
<a name="l00288"></a>00288   
<a name="l00289"></a>00289   <span class="keywordflow">for</span> (; sys != sys_end; ++sys)
<a name="l00290"></a>00290     {
<a name="l00291"></a>00291       <a class="code" href="classlibMesh_1_1EnsightIO.php#a87b8f1006c6c63897452b2e88e999e7c">SystemsVarsValue</a> value = *sys;
<a name="l00292"></a>00292       
<a name="l00293"></a>00293       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; value.second.EnsightScalars.size(); i++)
<a name="l00294"></a>00294         {
<a name="l00295"></a>00295           std::stringstream scl_file;
<a name="l00296"></a>00296           <a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php">Scalars</a> scalar = value.second.EnsightScalars[i];
<a name="l00297"></a>00297           scl_file &lt;&lt; _ensight_file_name
<a name="l00298"></a>00298                    &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; scalar.<a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php#a01a4d4c97d5b77fecd441de068355765">scalar_name</a>
<a name="l00299"></a>00299                    &lt;&lt; <span class="stringliteral">&quot;.scl&quot;</span>;
<a name="l00300"></a>00300           
<a name="l00301"></a>00301           fprintf(fout,<span class="stringliteral">&quot;scalar per node:   1  %s %s***\n&quot;</span>,scalar.<a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php#ad7aace074cb7b3b0597c224d91a4a44a">description</a>.c_str(), scl_file.str().c_str());    
<a name="l00302"></a>00302         }
<a name="l00303"></a>00303       
<a name="l00304"></a>00304       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; value.second.EnsightVectors.size(); i++) 
<a name="l00305"></a>00305         {
<a name="l00306"></a>00306           std::stringstream vec_file;
<a name="l00307"></a>00307           <a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php">Vectors</a> vec = value.second.EnsightVectors[i];
<a name="l00308"></a>00308           vec_file&lt;&lt;_ensight_file_name&lt;&lt;<span class="stringliteral">&quot;_&quot;</span>&lt;&lt;vec.<a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php#a5123bff6944dc58c8f6e8803cde1680b">description</a>&lt;&lt;<span class="stringliteral">&quot;.vec&quot;</span>;
<a name="l00309"></a>00309         
<a name="l00310"></a>00310           fprintf(fout,<span class="stringliteral">&quot;vector per node:      1    %s %s***\n&quot;</span>,vec.<a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php#a5123bff6944dc58c8f6e8803cde1680b">description</a>.c_str(), vec_file.str().c_str());          
<a name="l00311"></a>00311         }
<a name="l00312"></a>00312       
<a name="l00313"></a>00313       <span class="comment">// Write time step section</span>
<a name="l00314"></a>00314       <span class="keywordflow">if</span>( <a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">_time_steps</a>.size() != 0) 
<a name="l00315"></a>00315         {
<a name="l00316"></a>00316           fprintf(fout,<span class="stringliteral">&quot;\n\nTIME\n&quot;</span>);
<a name="l00317"></a>00317           fprintf(fout,<span class="stringliteral">&quot;time set:             1\n&quot;</span>);
<a name="l00318"></a>00318           fprintf(fout,<span class="stringliteral">&quot;number of steps:   %10d\n&quot;</span>, static_cast&lt;int&gt;(<a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">_time_steps</a>.size()));
<a name="l00319"></a>00319           fprintf(fout,<span class="stringliteral">&quot;filename start number:   %10d\n&quot;</span>, 0);
<a name="l00320"></a>00320           fprintf(fout,<span class="stringliteral">&quot;filename increment:  %10d\n&quot;</span>, 1);
<a name="l00321"></a>00321           fprintf(fout,<span class="stringliteral">&quot;time values:\n&quot;</span>);
<a name="l00322"></a>00322           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; <a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">_time_steps</a>.size(); i++)
<a name="l00323"></a>00323             fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>, <a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">_time_steps</a>[i]);     
<a name="l00324"></a>00324         }
<a name="l00325"></a>00325     }
<a name="l00326"></a>00326   fclose(fout);
<a name="l00327"></a>00327 }
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="comment">// Write scalar and vector solution</span>
<a name="l00331"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#aadf3ecc4a9d2b77e63c7ea5fcb5d9f16">00331</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aadf3ecc4a9d2b77e63c7ea5fcb5d9f16">EnsightIO::write_solution_ascii</a>()
<a name="l00332"></a>00332 {
<a name="l00333"></a>00333   
<a name="l00334"></a>00334   <a class="code" href="classlibMesh_1_1EnsightIO.php#ad3c1424dc0157f609bddc6057c7b2ddb">SystemsVarsMapIterator</a>       sys     = <a class="code" href="classlibMesh_1_1EnsightIO.php#a2051344bd682980403fce51344cd2430">_systems_vars_map</a>.begin();
<a name="l00335"></a>00335   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#ad3c1424dc0157f609bddc6057c7b2ddb">SystemsVarsMapIterator</a> sys_end = <a class="code" href="classlibMesh_1_1EnsightIO.php#a2051344bd682980403fce51344cd2430">_systems_vars_map</a>.end();
<a name="l00336"></a>00336   
<a name="l00337"></a>00337   <span class="keywordflow">for</span> (; sys != sys_end; ++sys)
<a name="l00338"></a>00338     {
<a name="l00339"></a>00339       <a class="code" href="classlibMesh_1_1EnsightIO.php#a87b8f1006c6c63897452b2e88e999e7c">SystemsVarsValue</a> value = *sys;
<a name="l00340"></a>00340       
<a name="l00341"></a>00341       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; value.second.EnsightScalars.size(); i++) 
<a name="l00342"></a>00342         this-&gt;<a class="code" href="classlibMesh_1_1EnsightIO.php#abd870bb7cadb42848cdb795bc8ff1726">write_scalar_ascii</a>(value.first,
<a name="l00343"></a>00343                                  value.second.EnsightScalars[i].scalar_name);   
<a name="l00344"></a>00344       
<a name="l00345"></a>00345       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; value.second.EnsightVectors.size(); i++)
<a name="l00346"></a>00346         this-&gt;<a class="code" href="classlibMesh_1_1EnsightIO.php#ab7f5bbbc02f1d16ea7705948a843b2c8">write_vector_ascii</a>(value.first, 
<a name="l00347"></a>00347                                  value.second.EnsightVectors[i].components,
<a name="l00348"></a>00348                                  value.second.EnsightVectors[i].description);
<a name="l00349"></a>00349     }
<a name="l00350"></a>00350 }
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#abd870bb7cadb42848cdb795bc8ff1726">00353</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#abd870bb7cadb42848cdb795bc8ff1726">EnsightIO::write_scalar_ascii</a>(<span class="keyword">const</span> std::string &amp;sys, <span class="keyword">const</span> std::string &amp;var_name)
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> scl_file;
<a name="l00356"></a>00356   scl_file &lt;&lt; <a class="code" href="classlibMesh_1_1EnsightIO.php#ab876905d68b01a9899faf90cbe6e9dc0">_ensight_file_name</a> &lt;&lt; <span class="stringliteral">&quot;_&quot;</span> &lt;&lt; var_name &lt;&lt; <span class="stringliteral">&quot;.scl&quot;</span>;
<a name="l00357"></a>00357   OSSRealzeroright(scl_file,3,0,<a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">_time_steps</a>.size()-1);
<a name="l00358"></a>00358   
<a name="l00359"></a>00359   FILE * fout = fopen(scl_file.str().c_str(),<span class="stringliteral">&quot;w&quot;</span>);
<a name="l00360"></a>00360   
<a name="l00361"></a>00361   fprintf(fout,<span class="stringliteral">&quot;Per node scalar value\n&quot;</span>);
<a name="l00362"></a>00362   fprintf(fout,<span class="stringliteral">&quot;part\n&quot;</span>);
<a name="l00363"></a>00363   fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,1);
<a name="l00364"></a>00364   fprintf(fout,<span class="stringliteral">&quot;coordinates\n&quot;</span>);
<a name="l00365"></a>00365   
<a name="l00366"></a>00366   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a> = <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00369"></a>00369 
<a name="l00370"></a>00370   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system = <a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(sys);
<a name="l00371"></a>00371                 
<a name="l00372"></a>00372   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00373"></a>00373   
<a name="l00374"></a>00374         
<a name="l00375"></a>00375   <span class="keywordtype">int</span> var = system.<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(var_name);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00379"></a>00379   std::vector&lt;unsigned int&gt; dof_indices_scl;
<a name="l00380"></a>00380 
<a name="l00381"></a>00381   <span class="comment">// Now we will loop over all the elements in the mesh.</span>
<a name="l00382"></a>00382 
<a name="l00383"></a>00383   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00384"></a>00384   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00385"></a>00385                 
<a name="l00386"></a>00386   <span class="keyword">typedef</span> std::map&lt;int,Real&gt; map_local_soln;
<a name="l00387"></a>00387   <span class="keyword">typedef</span> map_local_soln::iterator local_soln_iterator;
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   map_local_soln local_soln;
<a name="l00390"></a>00390     
<a name="l00391"></a>00391   std::vector&lt;Number&gt;       elem_soln;
<a name="l00392"></a>00392   std::vector&lt;Number&gt;       nodal_soln;
<a name="l00393"></a>00393         
<a name="l00394"></a>00394   <span class="keywordflow">for</span> ( ; el != end_el ; ++el){
<a name="l00395"></a>00395   
<a name="l00396"></a>00396     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00397"></a>00397 
<a name="l00398"></a>00398     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type    = system.<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(var);
<a name="l00399"></a>00399 
<a name="l00400"></a>00400     dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices);
<a name="l00401"></a>00401     dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices_scl, var);
<a name="l00402"></a>00402 
<a name="l00403"></a>00403     elem_soln.resize(dof_indices_scl.size());
<a name="l00404"></a>00404                                 
<a name="l00405"></a>00405     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; dof_indices_scl.size(); i++)
<a name="l00406"></a>00406       elem_soln[i] = system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices_scl[i]);
<a name="l00407"></a>00407                         
<a name="l00408"></a>00408     <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">FEInterface::nodal_soln</a> (dim,fe_type, elem, elem_soln, nodal_soln);
<a name="l00409"></a>00409                                                 
<a name="l00410"></a>00410     libmesh_assert (nodal_soln.size() == elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00411"></a>00411                    
<a name="l00412"></a>00412 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00413"></a>00413 <span class="preprocessor"></span>    <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Complex-valued Ensight output not yet supported&quot;</span> &lt;&lt; std::endl;
<a name="l00414"></a>00414     libmesh_not_implemented();
<a name="l00415"></a>00415 <span class="preprocessor">#endif</span>
<a name="l00416"></a>00416 <span class="preprocessor"></span>                   
<a name="l00417"></a>00417     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00418"></a>00418       local_soln[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(nodal_soln[n]);
<a name="l00419"></a>00419  
<a name="l00420"></a>00420   }
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   local_soln_iterator sol = local_soln.begin();
<a name="l00423"></a>00423   <span class="keyword">const</span> local_soln_iterator sol_end = local_soln.end();
<a name="l00424"></a>00424   <span class="keywordflow">for</span>(; sol != sol_end; ++sol)
<a name="l00425"></a>00425     fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,(*sol).second);
<a name="l00426"></a>00426         
<a name="l00427"></a>00427   fclose(fout);
<a name="l00428"></a>00428                 
<a name="l00429"></a>00429 }
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#ab7f5bbbc02f1d16ea7705948a843b2c8">00432</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#ab7f5bbbc02f1d16ea7705948a843b2c8">EnsightIO::write_vector_ascii</a>(<span class="keyword">const</span> std::string &amp;sys, <span class="keyword">const</span> std::vector&lt;std::string&gt; &amp;vec, <span class="keyword">const</span> std::string &amp;var_name)
<a name="l00433"></a>00433 {
<a name="l00434"></a>00434   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> vec_file;
<a name="l00435"></a>00435   vec_file&lt;&lt;<a class="code" href="classlibMesh_1_1EnsightIO.php#ab876905d68b01a9899faf90cbe6e9dc0">_ensight_file_name</a>&lt;&lt;<span class="stringliteral">&quot;_&quot;</span>&lt;&lt;var_name&lt;&lt;<span class="stringliteral">&quot;.vec&quot;</span>;
<a name="l00436"></a>00436   OSSRealzeroright(vec_file,3,0,<a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">_time_steps</a>.size()-1);
<a name="l00437"></a>00437                         
<a name="l00438"></a>00438   FILE * fout = fopen(vec_file.str().c_str(),<span class="stringliteral">&quot;w&quot;</span>);
<a name="l00439"></a>00439   fprintf(fout,<span class="stringliteral">&quot;Per vector per value\n&quot;</span>);
<a name="l00440"></a>00440   fprintf(fout,<span class="stringliteral">&quot;part\n&quot;</span>);
<a name="l00441"></a>00441   fprintf(fout,<span class="stringliteral">&quot;%10d\n&quot;</span>,1);
<a name="l00442"></a>00442   fprintf(fout,<span class="stringliteral">&quot;coordinates\n&quot;</span>);
<a name="l00443"></a>00443   
<a name="l00444"></a>00444   <span class="comment">// Get a constant reference to the mesh object.</span>
<a name="l00445"></a>00445   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a> = <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00446"></a>00446 
<a name="l00447"></a>00447   <span class="comment">// The dimension that we are running</span>
<a name="l00448"></a>00448   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system = <a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(sys);
<a name="l00451"></a>00451                 
<a name="l00452"></a>00452   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00453"></a>00453         
<a name="l00454"></a>00454   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> u_var = system.<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(vec[0]);
<a name="l00455"></a>00455   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v_var = system.<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(vec[1]);
<a name="l00456"></a>00456   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> w_var = (dim==3) ? system.<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(vec[2]) : 0;
<a name="l00457"></a>00457         
<a name="l00458"></a>00458   std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00459"></a>00459   std::vector&lt;unsigned int&gt; dof_indices_u;
<a name="l00460"></a>00460   std::vector&lt;unsigned int&gt; dof_indices_v;
<a name="l00461"></a>00461   std::vector&lt;unsigned int&gt; dof_indices_w;
<a name="l00462"></a>00462                 
<a name="l00463"></a>00463   <span class="comment">// Now we will loop over all the elements in the mesh.</span>
<a name="l00464"></a>00464   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00465"></a>00465   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00466"></a>00466                
<a name="l00467"></a>00467   <span class="keyword">typedef</span> std::map&lt;int,std::vector&lt;Real&gt; &gt; map_local_soln;
<a name="l00468"></a>00468   <span class="keyword">typedef</span> map_local_soln::iterator  local_soln_iterator;
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   map_local_soln local_soln;
<a name="l00471"></a>00471         
<a name="l00472"></a>00472   <span class="keywordflow">for</span> ( ; el != end_el ; ++el){
<a name="l00473"></a>00473                 
<a name="l00474"></a>00474     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00475"></a>00475                                 
<a name="l00476"></a>00476     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type    = system.<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(u_var);
<a name="l00477"></a>00477               
<a name="l00478"></a>00478     dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices);
<a name="l00479"></a>00479     dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices_u,u_var);
<a name="l00480"></a>00480     dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices_v,v_var);
<a name="l00481"></a>00481     <span class="keywordflow">if</span>(dim==3)  dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices,w_var);
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 
<a name="l00484"></a>00484     std::vector&lt;Number&gt;       elem_soln_u;
<a name="l00485"></a>00485     std::vector&lt;Number&gt;       elem_soln_v;
<a name="l00486"></a>00486     std::vector&lt;Number&gt;       elem_soln_w;
<a name="l00487"></a>00487 
<a name="l00488"></a>00488     std::vector&lt;Number&gt;       nodal_soln_u;
<a name="l00489"></a>00489     std::vector&lt;Number&gt;       nodal_soln_v;
<a name="l00490"></a>00490     std::vector&lt;Number&gt;       nodal_soln_w;
<a name="l00491"></a>00491                 
<a name="l00492"></a>00492     elem_soln_u.resize(dof_indices_u.size());
<a name="l00493"></a>00493     elem_soln_v.resize(dof_indices_v.size());
<a name="l00494"></a>00494     <span class="keywordflow">if</span>(dim == 3) elem_soln_w.resize(dof_indices_w.size());
<a name="l00495"></a>00495 
<a name="l00496"></a>00496     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i &lt; dof_indices_u.size(); i++)
<a name="l00497"></a>00497       {
<a name="l00498"></a>00498         elem_soln_u[i] = system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices_u[i]);
<a name="l00499"></a>00499         elem_soln_v[i] = system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices_v[i]);
<a name="l00500"></a>00500         <span class="keywordflow">if</span>(dim==3) elem_soln_w[i] = system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices_w[i]);
<a name="l00501"></a>00501       }                
<a name="l00502"></a>00502 
<a name="l00503"></a>00503     <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">FEInterface::nodal_soln</a> (dim,fe_type,elem,elem_soln_u,nodal_soln_u);
<a name="l00504"></a>00504     <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">FEInterface::nodal_soln</a> (dim,fe_type,elem,elem_soln_v,nodal_soln_v);
<a name="l00505"></a>00505     <span class="keywordflow">if</span>(dim == 3) <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">FEInterface::nodal_soln</a> (dim,fe_type,elem,elem_soln_w,nodal_soln_w);
<a name="l00506"></a>00506     
<a name="l00507"></a>00507                  
<a name="l00508"></a>00508     libmesh_assert (nodal_soln_u.size() == elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00509"></a>00509     libmesh_assert (nodal_soln_v.size() == elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00510"></a>00510                   
<a name="l00511"></a>00511 <span class="preprocessor">#ifdef LIBMESH_ENABLE_COMPLEX</span>
<a name="l00512"></a>00512 <span class="preprocessor"></span>    <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Complex-valued Ensight output not yet supported&quot;</span> &lt;&lt; std::endl;
<a name="l00513"></a>00513     libmesh_not_implemented()
<a name="l00514"></a>00514 <span class="preprocessor">#endif</span>
<a name="l00515"></a>00515 <span class="preprocessor"></span>                   
<a name="l00516"></a>00516     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00517"></a>00517       {
<a name="l00518"></a>00518         std::vector&lt;Real&gt; vec(3);
<a name="l00519"></a>00519         vec[0]= <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(nodal_soln_u[n]);
<a name="l00520"></a>00520         vec[1]= <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(nodal_soln_v[n]);
<a name="l00521"></a>00521         vec[2]=0.0;
<a name="l00522"></a>00522         <span class="keywordflow">if</span>(dim==3) vec[2]= <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(nodal_soln_w[n]);
<a name="l00523"></a>00523         local_soln[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)] = vec;        
<a name="l00524"></a>00524       }
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   }
<a name="l00527"></a>00527         
<a name="l00528"></a>00528   local_soln_iterator sol = local_soln.begin();
<a name="l00529"></a>00529   <span class="keyword">const</span> local_soln_iterator sol_end = local_soln.end();
<a name="l00530"></a>00530         
<a name="l00531"></a>00531   <span class="keywordflow">for</span>(; sol != sol_end; ++sol)
<a name="l00532"></a>00532     fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,(*sol).second[0]);
<a name="l00533"></a>00533   sol = local_soln.begin();
<a name="l00534"></a>00534   <span class="keywordflow">for</span>(; sol != sol_end; ++sol)
<a name="l00535"></a>00535     fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,(*sol).second[1]);
<a name="l00536"></a>00536   sol = local_soln.begin();
<a name="l00537"></a>00537   <span class="keywordflow">for</span>(; sol != sol_end; ++sol)
<a name="l00538"></a>00538     fprintf(fout,<span class="stringliteral">&quot;%12.5e\n&quot;</span>,(*sol).second[2]);
<a name="l00539"></a>00539                 
<a name="l00540"></a>00540   fclose(fout);
<a name="l00541"></a>00541         
<a name="l00542"></a>00542 }
<a name="l00543"></a>00543 
<a name="l00544"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a965d85e21c0ab6d97786abcf2be687f7">00544</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#a965d85e21c0ab6d97786abcf2be687f7">EnsightIO::elem_type_to_string</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type, <span class="keywordtype">char</span>* buffer)
<a name="l00545"></a>00545 {
<a name="l00546"></a>00546   <span class="keywordflow">switch</span>(type){
<a name="l00547"></a>00547   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00548"></a>00548     std::strcpy(buffer,<span class="stringliteral">&quot;bar2&quot;</span>);
<a name="l00549"></a>00549     <span class="keywordflow">break</span>;
<a name="l00550"></a>00550   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00551"></a>00551     std::strcpy(buffer,<span class="stringliteral">&quot;bar3&quot;</span>);
<a name="l00552"></a>00552     <span class="keywordflow">break</span>;
<a name="l00553"></a>00553   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00554"></a>00554     std::strcpy(buffer,<span class="stringliteral">&quot;quad4&quot;</span>);
<a name="l00555"></a>00555     <span class="keywordflow">break</span>;
<a name="l00556"></a>00556   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00557"></a>00557     std::strcpy(buffer,<span class="stringliteral">&quot;quad8&quot;</span>);
<a name="l00558"></a>00558     <span class="keywordflow">break</span>;
<a name="l00559"></a>00559   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00560"></a>00560     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt;<span class="stringliteral">&quot;QUAD9: element not supported!&quot;</span>&lt;&lt;std::endl;
<a name="l00561"></a>00561     libmesh_error();
<a name="l00562"></a>00562     <span class="keywordflow">break</span>;
<a name="l00563"></a>00563                 
<a name="l00564"></a>00564   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00565"></a>00565     std::strcpy(buffer,<span class="stringliteral">&quot;tria3&quot;</span>);
<a name="l00566"></a>00566     <span class="keywordflow">break</span>;
<a name="l00567"></a>00567   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00568"></a>00568     std::strcpy(buffer,<span class="stringliteral">&quot;tria6&quot;</span>);
<a name="l00569"></a>00569     <span class="keywordflow">break</span>;
<a name="l00570"></a>00570   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00571"></a>00571     std::strcpy(buffer,<span class="stringliteral">&quot;tetra4&quot;</span>);
<a name="l00572"></a>00572     <span class="keywordflow">break</span>;
<a name="l00573"></a>00573   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00574"></a>00574     std::strcpy(buffer,<span class="stringliteral">&quot;tetra10&quot;</span>);
<a name="l00575"></a>00575     <span class="keywordflow">break</span>;
<a name="l00576"></a>00576   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00577"></a>00577     std::strcpy(buffer,<span class="stringliteral">&quot;hexa8&quot;</span>);
<a name="l00578"></a>00578     <span class="keywordflow">break</span>;
<a name="l00579"></a>00579   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00580"></a>00580     std::strcpy(buffer,<span class="stringliteral">&quot;hexa20&quot;</span>);
<a name="l00581"></a>00581     <span class="keywordflow">break</span>;
<a name="l00582"></a>00582   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00583"></a>00583     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>&lt;&lt;<span class="stringliteral">&quot;HEX27: element not supported!&quot;</span>&lt;&lt;std::endl;
<a name="l00584"></a>00584     libmesh_error();
<a name="l00585"></a>00585     <span class="keywordflow">break</span>;
<a name="l00586"></a>00586   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00587"></a>00587     std::strcpy(buffer,<span class="stringliteral">&quot;pyramid5&quot;</span>);
<a name="l00588"></a>00588     <span class="keywordflow">break</span>;
<a name="l00589"></a>00589   <span class="keywordflow">default</span>:
<a name="l00590"></a>00590     <span class="keywordflow">break</span>;
<a name="l00591"></a>00591   }
<a name="l00592"></a>00592 }
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
