<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">ensight_io.h</div>  </div>
</div>
<div class="contents">
<a href="ensight__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: ensight_io.h 3924 2010-08-24 22:10:57Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __ensight_io_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __ensight_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// The c++ include </span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// libMesh includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span>EquationSystems;
<a name="l00040"></a>00040 
<a name="l00045"></a><a class="code" href="classlibMesh_1_1EnsightIO.php">00045</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EnsightIO.php">EnsightIO</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047  <span class="keyword">public</span>:
<a name="l00048"></a>00048   
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1EnsightIO.php#a0e8ce6e193def21e5c140cb41c274d61">EnsightIO</a> (<span class="keyword">const</span> std::string &amp;filename, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> &amp;eq);
<a name="l00053"></a>00053   
<a name="l00054"></a>00054   <a class="code" href="classlibMesh_1_1EnsightIO.php#a0a74130067939f48215c1335f94fdf5d">~EnsightIO</a> ();
<a name="l00055"></a>00055 
<a name="l00060"></a>00060   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aa1a1d4165f6a43342b7cc58aa7f7fe0d">add_vector</a> (<span class="keyword">const</span> std::string &amp;system, <span class="keyword">const</span> std::string &amp;vec_description, 
<a name="l00061"></a>00061                    <span class="keyword">const</span> std::string &amp;u, <span class="keyword">const</span> std::string &amp;v);
<a name="l00062"></a>00062   
<a name="l00066"></a>00066   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aa1a1d4165f6a43342b7cc58aa7f7fe0d">add_vector</a> (<span class="keyword">const</span> std::string &amp;system, <span class="keyword">const</span> std::string &amp;vec_description, 
<a name="l00067"></a>00067                    <span class="keyword">const</span> std::string &amp;u, <span class="keyword">const</span> std::string &amp;v, <span class="keyword">const</span> std::string &amp;w);
<a name="l00068"></a>00068   
<a name="l00072"></a>00072   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#a068ca884fe7e2d1bfc219db0fb7ca1d4">add_scalar</a> (<span class="keyword">const</span> std::string &amp;system, <span class="keyword">const</span> std::string &amp;scalar_description, 
<a name="l00073"></a>00073                    <span class="keyword">const</span> std::string &amp;s);               
<a name="l00074"></a>00074                 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#a352e34228c269ffcb694e688c7ee45f5">write</a> (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#a352e34228c269ffcb694e688c7ee45f5">write</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> time = 0);
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   <span class="keywordtype">bool</span>&amp; <a class="code" href="classlibMesh_1_1EnsightIO.php#a37cf63436904918edd2c18641dd538e2">has_mesh_refinement</a>();
<a name="l00086"></a>00086                         
<a name="l00087"></a>00087 <span class="keyword">private</span>:
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// Define aux. structures</span>
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   <span class="comment">// Represents the vectors that are used by the EnsightIO</span>
<a name="l00092"></a><a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php">00092</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php">Vectors</a>
<a name="l00093"></a>00093   {
<a name="l00094"></a><a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php#a5123bff6944dc58c8f6e8803cde1680b">00094</a>     std::string <a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php#a5123bff6944dc58c8f6e8803cde1680b">description</a>;          
<a name="l00095"></a><a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php#aa43c414e28f258d06bf97954a4a2553d">00095</a>     std::vector&lt;std::string&gt; <a class="code" href="structlibMesh_1_1EnsightIO_1_1Vectors.php#aa43c414e28f258d06bf97954a4a2553d">components</a>;
<a name="l00096"></a>00096   };
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="comment">// Represents the scalars </span>
<a name="l00099"></a><a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php">00099</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php">Scalars</a> 
<a name="l00100"></a>00100   {
<a name="l00101"></a><a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php#a01a4d4c97d5b77fecd441de068355765">00101</a>     std::string <a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php#a01a4d4c97d5b77fecd441de068355765">scalar_name</a>;
<a name="l00102"></a><a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php#ad7aace074cb7b3b0597c224d91a4a44a">00102</a>     std::string <a class="code" href="structlibMesh_1_1EnsightIO_1_1Scalars.php#ad7aace074cb7b3b0597c224d91a4a44a">description</a>;
<a name="l00103"></a>00103   };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">// Store the variables of system</span>
<a name="l00106"></a><a class="code" href="structlibMesh_1_1EnsightIO_1_1SystemVars.php">00106</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1EnsightIO_1_1SystemVars.php">SystemVars</a> 
<a name="l00107"></a>00107   {
<a name="l00108"></a><a class="code" href="structlibMesh_1_1EnsightIO_1_1SystemVars.php#afc14e7ef96bcb5b5d72b54c3ca8c54c4">00108</a>     std::vector&lt;Vectors&gt; <a class="code" href="structlibMesh_1_1EnsightIO_1_1SystemVars.php#afc14e7ef96bcb5b5d72b54c3ca8c54c4">EnsightVectors</a>;
<a name="l00109"></a><a class="code" href="structlibMesh_1_1EnsightIO_1_1SystemVars.php#ae7354bc386a88674e320b2114be85764">00109</a>     std::vector&lt;Scalars&gt; <a class="code" href="structlibMesh_1_1EnsightIO_1_1SystemVars.php#ae7354bc386a88674e320b2114be85764">EnsightScalars</a>;
<a name="l00110"></a>00110   };
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#ad2ea9f8f428a326673ec3ed2496faca5">00113</a>   <span class="keyword">typedef</span> std::map &lt;std::string, SystemVars&gt;           <a class="code" href="classlibMesh_1_1EnsightIO.php#ad2ea9f8f428a326673ec3ed2496faca5">SystemsVarsMap</a>;
<a name="l00114"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#ad3c1424dc0157f609bddc6057c7b2ddb">00114</a>   <span class="keyword">typedef</span> std::map &lt;std::string, SystemVars&gt;::iterator <a class="code" href="classlibMesh_1_1EnsightIO.php#ad3c1424dc0157f609bddc6057c7b2ddb">SystemsVarsMapIterator</a>;
<a name="l00115"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a87b8f1006c6c63897452b2e88e999e7c">00115</a>   <span class="keyword">typedef</span> std::pair&lt;std::string, SystemVars&gt;           <a class="code" href="classlibMesh_1_1EnsightIO.php#a87b8f1006c6c63897452b2e88e999e7c">SystemsVarsValue</a>;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="comment">// private methods</span>
<a name="l00118"></a>00118   <span class="comment">// write solution in ascii format file</span>
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#ab10ac1d08bc00cdd9e96abc603c23318">write_ascii</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> time = 0);
<a name="l00120"></a>00120   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#abd870bb7cadb42848cdb795bc8ff1726">write_scalar_ascii</a> (<span class="keyword">const</span> std::string &amp;sys, <span class="keyword">const</span> std::string &amp;var);
<a name="l00121"></a>00121   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#ab7f5bbbc02f1d16ea7705948a843b2c8">write_vector_ascii</a> (<span class="keyword">const</span> std::string &amp;sys, <span class="keyword">const</span> std::vector&lt;std::string&gt; &amp;vec, <span class="keyword">const</span> std::string &amp;var_name);
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aadf3ecc4a9d2b77e63c7ea5fcb5d9f16">write_solution_ascii</a> ();
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aab90c2a77c22b5b85252dae66b4ad789">write_geometry_ascii</a> ();
<a name="l00124"></a>00124   
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#aba312f1ba1cbd2cf3433681fc4871bff">write_case</a>();
<a name="l00127"></a>00127   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EnsightIO.php#a965d85e21c0ab6d97786abcf2be687f7">elem_type_to_string</a> (<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>, <span class="keywordtype">char</span>*);
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   <span class="comment">// private Attributes</span>
<a name="l00130"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#ab876905d68b01a9899faf90cbe6e9dc0">00130</a>   std::string     <a class="code" href="classlibMesh_1_1EnsightIO.php#ab876905d68b01a9899faf90cbe6e9dc0">_ensight_file_name</a>;
<a name="l00131"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">00131</a>   std::vector&lt;double&gt;   <a class="code" href="classlibMesh_1_1EnsightIO.php#a867305e196249c68ce14a965a03963e6">_time_steps</a>;
<a name="l00132"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a2051344bd682980403fce51344cd2430">00132</a>   <a class="code" href="classlibMesh_1_1EnsightIO.php#ad2ea9f8f428a326673ec3ed2496faca5">SystemsVarsMap</a>   <a class="code" href="classlibMesh_1_1EnsightIO.php#a2051344bd682980403fce51344cd2430">_systems_vars_map</a>;
<a name="l00133"></a><a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">00133</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> &amp;<a class="code" href="classlibMesh_1_1EnsightIO.php#a73fcaa700d2f29055cbd5da1992873d8">_equation_systems</a>;             
<a name="l00134"></a>00134 };
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 } <span class="comment">// namespace libMesh</span>
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#endif // #define __ensight_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
