<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">equation_systems.C</div>  </div>
</div>
<div class="contents">
<a href="equation__systems_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: equation_systems.C 4356 2011-04-15 15:28:29Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// System includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="explicit__system_8h.php">explicit_system.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="frequency__system_8h.php">frequency_system.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__refinement_8h.php">mesh_refinement.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="newmark__system_8h.php">newmark_system.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="nonlinear__implicit__system_8h.php">nonlinear_implicit_system.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="transient__system_8h.php">transient_system.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Include the systems before this one to avoid</span>
<a name="l00040"></a>00040 <span class="comment">// overlapping forward declarations.</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>libMesh
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="comment">// Forward Declarations</span>
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00052"></a>00052 <span class="comment">// EquationSystems class implementation</span>
<a name="l00053"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a49489a225ff814ce0e2df83f153a6c06">00053</a> <a class="code" href="classlibMesh_1_1EquationSystems.php#a49489a225ff814ce0e2df83f153a6c06">EquationSystems::EquationSystems</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m, <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* mesh_data) :
<a name="l00054"></a>00054   _mesh      (m),
<a name="l00055"></a>00055   _mesh_data (mesh_data)
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <span class="comment">// Set default parameters</span>
<a name="l00058"></a>00058   this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;        (<span class="stringliteral">&quot;linear solver tolerance&quot;</span>) = TOLERANCE * TOLERANCE;
<a name="l00059"></a>00059   this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>) = 5000;  
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a329b3f85c7dafc3df8ffd9d052584fa7">00064</a> <a class="code" href="classlibMesh_1_1EquationSystems.php#a329b3f85c7dafc3df8ffd9d052584fa7">EquationSystems::~EquationSystems</a> ()
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#ac2353c8c83f2b9d2aafb05acfda445be">clear</a> ();
<a name="l00067"></a>00067 }
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#ac2353c8c83f2b9d2aafb05acfda445be">00071</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ac2353c8c83f2b9d2aafb05acfda445be">EquationSystems::clear</a> ()
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <span class="comment">// Clear any additional parameters</span>
<a name="l00074"></a>00074   <a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a64b2d5b2367f03a30e7c37780b8c5047">clear</a> ();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// clear the systems.  We must delete them</span>
<a name="l00077"></a>00077   <span class="comment">// since we newed them!</span>
<a name="l00078"></a>00078   <span class="keywordflow">while</span> (!<a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.empty())
<a name="l00079"></a>00079     {
<a name="l00080"></a>00080       <a class="code" href="classlibMesh_1_1EquationSystems.php#a4a4e902556e150e04ae72eb8f2ddd661">system_iterator</a> pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00081"></a>00081       
<a name="l00082"></a>00082       <a class="code" href="classlibMesh_1_1System.php">System</a> *sys = pos-&gt;second;
<a name="l00083"></a>00083       <span class="keyword">delete</span> sys;
<a name="l00084"></a>00084       sys = NULL;
<a name="l00085"></a>00085       
<a name="l00086"></a>00086       <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.erase (pos);
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#aa79320b68e236ece82d5b358721ebd13">00092</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#aa79320b68e236ece82d5b358721ebd13">EquationSystems::init</a> ()
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sys = this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>();
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   libmesh_assert (n_sys != 0);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">// Distribute the mesh if possible</span>
<a name="l00099"></a>00099   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00100"></a>00100     <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a8d57ce79036999648936424bfbab715e">delete_remote_elements</a>();
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   <span class="comment">// Tell all the \p DofObject entities how many systems</span>
<a name="l00103"></a>00103   <span class="comment">// there are.</span>
<a name="l00104"></a>00104   {
<a name="l00105"></a>00105     <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00106"></a>00106     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00107"></a>00107 
<a name="l00108"></a>00108     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00109"></a>00109       (*node_it)-&gt;set_n_systems(n_sys);
<a name="l00110"></a>00110     
<a name="l00111"></a>00111     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00112"></a>00112     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00113"></a>00113     
<a name="l00114"></a>00114     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00115"></a>00115       (*elem_it)-&gt;set_n_systems(n_sys);
<a name="l00116"></a>00116   }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00119"></a>00119     this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i).init();
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a> mesh_refine(<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>);
<a name="l00123"></a>00123   mesh_refine.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6930cd279030a81ff6d36a40809b1fd8">clean_refinement_flags</a>();
<a name="l00124"></a>00124 <span class="preprocessor">#endif</span>
<a name="l00125"></a>00125 <span class="preprocessor"></span>}
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a1634fa5937c4d915d83c35d591ed7c05">00129</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a1634fa5937c4d915d83c35d591ed7c05">EquationSystems::reinit</a> ()
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>() != 0);
<a name="l00132"></a>00132   
<a name="l00133"></a>00133 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>  <span class="comment">// Make sure all the \p DofObject entities know how many systems</span>
<a name="l00135"></a>00135   <span class="comment">// there are.</span>
<a name="l00136"></a>00136   {
<a name="l00137"></a>00137     <span class="comment">// All the nodes</span>
<a name="l00138"></a>00138     <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00139"></a>00139     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00142"></a>00142       libmesh_assert((*node_it)-&gt;n_systems() == this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00143"></a>00143     
<a name="l00144"></a>00144     <span class="comment">// All the elements</span>
<a name="l00145"></a>00145     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00146"></a>00146     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00147"></a>00147     
<a name="l00148"></a>00148     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00149"></a>00149       libmesh_assert((*elem_it)-&gt;n_systems() == this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00150"></a>00150   }
<a name="l00151"></a>00151 <span class="preprocessor">#endif</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>
<a name="l00153"></a>00153   <span class="comment">// Localize each system&#39;s vectors</span>
<a name="l00154"></a>00154   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00155"></a>00155     this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i).re_update();
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00158"></a>00158 <span class="preprocessor"></span>
<a name="l00159"></a>00159   <span class="keywordtype">bool</span> dof_constraints_created = <span class="keyword">false</span>;
<a name="l00160"></a>00160   <span class="keywordtype">bool</span> mesh_changed = <span class="keyword">false</span>;
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="comment">// FIXME: For backwards compatibility, assume</span>
<a name="l00163"></a>00163   <span class="comment">// refine_and_coarsen_elements or refine_uniformly have already</span>
<a name="l00164"></a>00164   <span class="comment">// been called</span>
<a name="l00165"></a>00165   {
<a name="l00166"></a>00166     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00167"></a>00167       {
<a name="l00168"></a>00168         <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170         <span class="comment">// Don&#39;t do anything if the system doesn&#39;t have any variables in it</span>
<a name="l00171"></a>00171         <span class="keywordflow">if</span>(!sys.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>())
<a name="l00172"></a>00172           <span class="keywordflow">continue</span>;
<a name="l00173"></a>00173         
<a name="l00174"></a>00174         sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#ab986eb7bbf9bbb5119a49a145306a980">distribute_dofs</a>(<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176         <span class="comment">// Recreate any hanging node constraints</span>
<a name="l00177"></a>00177         sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a4dc67be5bbecf0e4947d790f6653e2d5">create_dof_constraints</a>(<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179         <span class="comment">// Apply any user-defined constraints</span>
<a name="l00180"></a>00180         sys.<a class="code" href="classlibMesh_1_1System.php#a8e857fcc4af2756cdd0d16563dfbbe83">user_constrain</a>();
<a name="l00181"></a>00181 
<a name="l00182"></a>00182         <span class="comment">// Expand any recursive constraints</span>
<a name="l00183"></a>00183         sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#ad48c72b8add66781d21ad77a3febe59d">process_constraints</a>();
<a name="l00184"></a>00184 
<a name="l00185"></a>00185         <span class="comment">// And clean up the send_list before we use it again</span>
<a name="l00186"></a>00186         sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a47865aeb6379c68169e926dd0ecc2b71">prepare_send_list</a>();
<a name="l00187"></a>00187 
<a name="l00188"></a>00188         sys.<a class="code" href="classlibMesh_1_1System.php#a55667d016781687feed399872671c963">prolong_vectors</a>();
<a name="l00189"></a>00189       }
<a name="l00190"></a>00190     mesh_changed = <span class="keyword">true</span>;
<a name="l00191"></a>00191     dof_constraints_created = <span class="keyword">true</span>;
<a name="l00192"></a>00192   }
<a name="l00193"></a>00193   
<a name="l00194"></a>00194   <span class="comment">// FIXME: Where should the user set maintain_level_one now??</span>
<a name="l00195"></a>00195   <span class="comment">// Don&#39;t override previous settings, for now</span>
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a> mesh_refine(<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   mesh_refine.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a81fa55fe9538fded1391a56952aa1376">face_level_mismatch_limit</a>() = <span class="keyword">false</span>;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="comment">// Try to coarsen the mesh, then restrict each system&#39;s vectors</span>
<a name="l00202"></a>00202   <span class="comment">// if necessary</span>
<a name="l00203"></a>00203   <span class="keywordflow">if</span> (mesh_refine.<a class="code" href="classlibMesh_1_1MeshRefinement.php#aca713a738c5308507a7fe9ed02147100">coarsen_elements</a>())
<a name="l00204"></a>00204     {
<a name="l00205"></a>00205       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00206"></a>00206         {
<a name="l00207"></a>00207           <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i);
<a name="l00208"></a>00208           <span class="keywordflow">if</span> (!dof_constraints_created)
<a name="l00209"></a>00209             {
<a name="l00210"></a>00210               sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#ab986eb7bbf9bbb5119a49a145306a980">distribute_dofs</a>(<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>);
<a name="l00211"></a>00211               sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a4dc67be5bbecf0e4947d790f6653e2d5">create_dof_constraints</a>(<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>);
<a name="l00212"></a>00212               sys.<a class="code" href="classlibMesh_1_1System.php#a8e857fcc4af2756cdd0d16563dfbbe83">user_constrain</a>();
<a name="l00213"></a>00213               sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#ad48c72b8add66781d21ad77a3febe59d">process_constraints</a>();
<a name="l00214"></a>00214               sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a47865aeb6379c68169e926dd0ecc2b71">prepare_send_list</a>();
<a name="l00215"></a>00215 
<a name="l00216"></a>00216             }
<a name="l00217"></a>00217           sys.<a class="code" href="classlibMesh_1_1System.php#a78af7f915ad5c678e3629ddced200967">restrict_vectors</a>();
<a name="l00218"></a>00218         }
<a name="l00219"></a>00219       mesh_changed = <span class="keyword">true</span>;
<a name="l00220"></a>00220       dof_constraints_created = <span class="keyword">true</span>;
<a name="l00221"></a>00221     }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="comment">// Once vectors are all restricted, we can delete</span>
<a name="l00224"></a>00224   <span class="comment">// children of coarsened elements</span>
<a name="l00225"></a>00225   <span class="keywordflow">if</span> (mesh_changed)
<a name="l00226"></a>00226     this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a0a109c00dfc85ad16576fde8a0cb2215">contract</a>();
<a name="l00227"></a>00227   
<a name="l00228"></a>00228   <span class="comment">// Try to refine the mesh, then prolong each system&#39;s vectors</span>
<a name="l00229"></a>00229   <span class="comment">// if necessary</span>
<a name="l00230"></a>00230   <span class="keywordflow">if</span> (mesh_refine.<a class="code" href="classlibMesh_1_1MeshRefinement.php#a68f01ed0485284d19a9c153572a35da9">refine_elements</a>())
<a name="l00231"></a>00231     {
<a name="l00232"></a>00232       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00233"></a>00233         {
<a name="l00234"></a>00234           <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i);
<a name="l00235"></a>00235           <span class="keywordflow">if</span> (!dof_constraints_created)
<a name="l00236"></a>00236             {
<a name="l00237"></a>00237               sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#ab986eb7bbf9bbb5119a49a145306a980">distribute_dofs</a>(<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>);
<a name="l00238"></a>00238               sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a4dc67be5bbecf0e4947d790f6653e2d5">create_dof_constraints</a>(<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>);
<a name="l00239"></a>00239               sys.<a class="code" href="classlibMesh_1_1System.php#a8e857fcc4af2756cdd0d16563dfbbe83">user_constrain</a>();
<a name="l00240"></a>00240               sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#ad48c72b8add66781d21ad77a3febe59d">process_constraints</a>();
<a name="l00241"></a>00241               sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a47865aeb6379c68169e926dd0ecc2b71">prepare_send_list</a>();
<a name="l00242"></a>00242 
<a name="l00243"></a>00243             }
<a name="l00244"></a>00244           sys.<a class="code" href="classlibMesh_1_1System.php#a55667d016781687feed399872671c963">prolong_vectors</a>();
<a name="l00245"></a>00245         }
<a name="l00246"></a>00246       mesh_changed = <span class="keyword">true</span>;
<a name="l00247"></a>00247       dof_constraints_created = <span class="keyword">true</span>;
<a name="l00248"></a>00248     }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">// If the mesh has changed, systems will need to create new dof</span>
<a name="l00251"></a>00251   <span class="comment">// constraints and update their global solution vectors</span>
<a name="l00252"></a>00252   <span class="keywordflow">if</span> (mesh_changed)
<a name="l00253"></a>00253     {
<a name="l00254"></a>00254       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00255"></a>00255         this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i).reinit();
<a name="l00256"></a>00256     }
<a name="l00257"></a>00257 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span>}
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#af9e14bd8d215858c0c7046d6fdb7881b">00262</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#af9e14bd8d215858c0c7046d6fdb7881b">EquationSystems::allgather</a> ()
<a name="l00263"></a>00263 {
<a name="l00264"></a>00264   <span class="comment">// A serial mesh means nothing needs to be done</span>
<a name="l00265"></a>00265   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00266"></a>00266     <span class="keywordflow">return</span>;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sys = this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>();
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   libmesh_assert (n_sys != 0);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="comment">// Gather the mesh</span>
<a name="l00273"></a>00273   <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a880cd0ce25794e2b0b200b1d6f6086be">allgather</a>();
<a name="l00274"></a>00274   
<a name="l00275"></a>00275   <span class="comment">// Tell all the \p DofObject entities how many systems</span>
<a name="l00276"></a>00276   <span class="comment">// there are.</span>
<a name="l00277"></a>00277   {
<a name="l00278"></a>00278     <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00279"></a>00279     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00280"></a>00280 
<a name="l00281"></a>00281     <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00282"></a>00282       (*node_it)-&gt;set_n_systems(n_sys);
<a name="l00283"></a>00283     
<a name="l00284"></a>00284     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00285"></a>00285     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00286"></a>00286     
<a name="l00287"></a>00287     <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00288"></a>00288       (*elem_it)-&gt;set_n_systems(n_sys);
<a name="l00289"></a>00289   }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <span class="comment">// And distribute each system&#39;s dofs</span>
<a name="l00292"></a>00292   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00293"></a>00293     this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i).get_dof_map().distribute_dofs(<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>);
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00299"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a3f4875f0168a7c02cd09e006b7edcddf">00299</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a3f4875f0168a7c02cd09e006b7edcddf">EquationSystems::update</a> ()
<a name="l00300"></a>00300 {
<a name="l00301"></a>00301   START_LOG(<span class="stringliteral">&quot;update()&quot;</span>,<span class="stringliteral">&quot;EquationSystems&quot;</span>);
<a name="l00302"></a>00302   
<a name="l00303"></a>00303   <span class="comment">// Localize each system&#39;s vectors</span>
<a name="l00304"></a>00304   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00305"></a>00305     this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i).update();
<a name="l00306"></a>00306   
<a name="l00307"></a>00307   STOP_LOG(<span class="stringliteral">&quot;update()&quot;</span>,<span class="stringliteral">&quot;EquationSystems&quot;</span>);
<a name="l00308"></a>00308 }
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a09450d5e4547d8b2e5690043da03dbd3">00312</a> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp; <a class="code" href="classlibMesh_1_1EquationSystems.php#a09450d5e4547d8b2e5690043da03dbd3">EquationSystems::add_system</a> (<span class="keyword">const</span> std::string&amp; sys_type,
<a name="l00313"></a>00313                                       <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00314"></a>00314 {
<a name="l00315"></a>00315   <span class="comment">// If the user already built a system with this name, we&#39;ll</span>
<a name="l00316"></a>00316   <span class="comment">// trust them and we&#39;ll use it.  That way they can pre-add</span>
<a name="l00317"></a>00317   <span class="comment">// non-standard derived system classes, and if their restart file</span>
<a name="l00318"></a>00318   <span class="comment">// has some non-standard sys_type we won&#39;t throw an error.</span>
<a name="l00319"></a>00319   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.count(name))
<a name="l00320"></a>00320     {
<a name="l00321"></a>00321       <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(name);
<a name="l00322"></a>00322     }
<a name="l00323"></a>00323   <span class="comment">// Build a Newmark system</span>
<a name="l00324"></a>00324   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;Newmark&quot;</span>)
<a name="l00325"></a>00325     this-&gt;add_system&lt;NewmarkSystem&gt; (<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00326"></a>00326 
<a name="l00327"></a>00327   <span class="comment">// Build an Explicit system</span>
<a name="l00328"></a>00328   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((sys_type == <span class="stringliteral">&quot;Explicit&quot;</span>))
<a name="l00329"></a>00329     this-&gt;add_system&lt;ExplicitSystem&gt; (name);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <span class="comment">// Build an Implicit system</span>
<a name="l00332"></a>00332   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((sys_type == <span class="stringliteral">&quot;Implicit&quot;</span>) ||
<a name="l00333"></a>00333            (sys_type == <span class="stringliteral">&quot;Steady&quot;</span>  ))
<a name="l00334"></a>00334     this-&gt;add_system&lt;ImplicitSystem&gt; (<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// build a transient implicit linear system</span>
<a name="l00337"></a>00337   <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((sys_type == <span class="stringliteral">&quot;Transient&quot;</span>) ||
<a name="l00338"></a>00338            (sys_type == <span class="stringliteral">&quot;TransientImplicit&quot;</span>) ||
<a name="l00339"></a>00339            (sys_type == <span class="stringliteral">&quot;TransientLinearImplicit&quot;</span>))
<a name="l00340"></a>00340     this-&gt;add_system&lt;TransientLinearImplicitSystem&gt; (name);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342   <span class="comment">// build a transient implicit nonlinear system</span>
<a name="l00343"></a>00343   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;TransientNonlinearImplicit&quot;</span>)
<a name="l00344"></a>00344     this-&gt;add_system&lt;TransientNonlinearImplicitSystem&gt; (<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   <span class="comment">// build a transient explicit system</span>
<a name="l00347"></a>00347   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;TransientExplicit&quot;</span>)
<a name="l00348"></a>00348     this-&gt;add_system&lt;TransientExplicitSystem&gt; (<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   <span class="comment">// build a linear implicit system</span>
<a name="l00351"></a>00351   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;LinearImplicit&quot;</span>)
<a name="l00352"></a>00352     this-&gt;add_system&lt;LinearImplicitSystem&gt; (<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00353"></a>00353 
<a name="l00354"></a>00354   <span class="comment">// build a nonlinear implicit system</span>
<a name="l00355"></a>00355   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;NonlinearImplicit&quot;</span>)
<a name="l00356"></a>00356     this-&gt;add_system&lt;NonlinearImplicitSystem&gt; (<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="preprocessor">#if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00359"></a>00359 <span class="preprocessor"></span>  <span class="comment">// build a frequency system</span>
<a name="l00360"></a>00360   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (sys_type == <span class="stringliteral">&quot;Frequency&quot;</span>)
<a name="l00361"></a>00361     this-&gt;add_system&lt;FrequencySystem&gt; (<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00362"></a>00362 <span class="preprocessor">#endif</span>
<a name="l00363"></a>00363 <span class="preprocessor"></span>
<a name="l00364"></a>00364   <span class="keywordflow">else</span>
<a name="l00365"></a>00365     {
<a name="l00366"></a>00366       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unknown system type: &quot;</span>
<a name="l00367"></a>00367                     &lt;&lt; sys_type
<a name="l00368"></a>00368                     &lt;&lt; std::endl;
<a name="l00369"></a>00369       libmesh_error();
<a name="l00370"></a>00370     }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   <span class="comment">// Return a reference to the new system</span>
<a name="l00373"></a>00373   <span class="comment">//return (*this)(name);</span>
<a name="l00374"></a>00374   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(name);
<a name="l00375"></a>00375 }
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#ace47cf459c29a740bd88c5a2d7f8b5fa">00382</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ace47cf459c29a740bd88c5a2d7f8b5fa">EquationSystems::delete_system</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00383"></a>00383 {
<a name="l00384"></a>00384   libmesh_deprecated();
<a name="l00385"></a>00385 
<a name="l00386"></a>00386   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.count(name))
<a name="l00387"></a>00387     {
<a name="l00388"></a>00388       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: no system named &quot;</span>
<a name="l00389"></a>00389                     &lt;&lt; name  &lt;&lt; std::endl;
<a name="l00390"></a>00390 
<a name="l00391"></a>00391       libmesh_error();
<a name="l00392"></a>00392     }
<a name="l00393"></a>00393   
<a name="l00394"></a>00394   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>[<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>];
<a name="l00395"></a>00395   
<a name="l00396"></a>00396   <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.erase (name);
<a name="l00397"></a>00397 }
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#ae63435d018c0c5cd6d0b72547afc0032">00401</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae63435d018c0c5cd6d0b72547afc0032">EquationSystems::solve</a> ()
<a name="l00402"></a>00402 {
<a name="l00403"></a>00403   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00406"></a>00406     this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i).solve();
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410  
<a name="l00411"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a365876dded3fa6105838e633d0f33ee4">00411</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a365876dded3fa6105838e633d0f33ee4">EquationSystems::sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters)
<a name="l00412"></a>00412 {
<a name="l00413"></a>00413   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00414"></a>00414 
<a name="l00415"></a>00415   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++i)
<a name="l00416"></a>00416     this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i).sensitivity_solve(parameters);
<a name="l00417"></a>00417 }
<a name="l00418"></a>00418  
<a name="l00419"></a>00419 
<a name="l00420"></a>00420  
<a name="l00421"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#abf595c7f10f4234ab6027e6aea712935">00421</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#abf595c7f10f4234ab6027e6aea712935">EquationSystems::adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l00422"></a>00422 {
<a name="l00423"></a>00423   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); i != 0; --i)
<a name="l00426"></a>00426     this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(i-1).adjoint_solve(qoi_indices);
<a name="l00427"></a>00427 }
<a name="l00428"></a>00428  
<a name="l00429"></a>00429 
<a name="l00430"></a>00430  
<a name="l00431"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#aa050d0013c82f8a646d0ec583e142341">00431</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#aa050d0013c82f8a646d0ec583e142341">EquationSystems::build_variable_names</a> (std::vector&lt;std::string&gt;&amp; var_names)<span class="keyword"> const</span>
<a name="l00432"></a>00432 <span class="keyword"></span>{
<a name="l00433"></a>00433   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00434"></a>00434   
<a name="l00435"></a>00435   var_names.resize (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a110251f64665b11b6c93ed293313b8e7">n_vars</a>());
<a name="l00436"></a>00436 
<a name="l00437"></a>00437   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num=0;
<a name="l00438"></a>00438   
<a name="l00439"></a>00439   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00440"></a>00440   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00443"></a>00443     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> vn=0; vn&lt;pos-&gt;second-&gt;n_vars(); vn++)
<a name="l00444"></a>00444       var_names[var_num++] = pos-&gt;second-&gt;variable_name(vn);       
<a name="l00445"></a>00445 }
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a2c7a089f06d24e9f42330d849ab18503">00449</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a2c7a089f06d24e9f42330d849ab18503">EquationSystems::build_solution_vector</a> (std::vector&lt;Number&gt;&amp;,
<a name="l00450"></a>00450                                              <span class="keyword">const</span> std::string&amp;,
<a name="l00451"></a>00451                                              <span class="keyword">const</span> std::string&amp;)<span class="keyword"> const</span>
<a name="l00452"></a>00452 <span class="keyword"></span>{
<a name="l00453"></a>00453   <span class="comment">//TODO:[BSK] re-implement this from the method below</span>
<a name="l00454"></a>00454   libmesh_error();
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 <span class="comment">//   // Get a reference to the named system</span>
<a name="l00457"></a>00457 <span class="comment">//   const System&amp; system = this-&gt;get_system(system_name);</span>
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 <span class="comment">//   // Get the number associated with the variable_name we are passed</span>
<a name="l00460"></a>00460 <span class="comment">//   const unsigned short int variable_num = system.variable_number(variable_name);</span>
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 <span class="comment">//   // Get the dimension of the current mesh</span>
<a name="l00463"></a>00463 <span class="comment">//   const unsigned int dim = _mesh.mesh_dimension();</span>
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 <span class="comment">//   // If we&#39;re on processor 0, allocate enough memory to hold the solution.</span>
<a name="l00466"></a>00466 <span class="comment">//   // Since we&#39;re only looking at one variable, there will be one solution value</span>
<a name="l00467"></a>00467 <span class="comment">//   // for each node in the mesh.</span>
<a name="l00468"></a>00468 <span class="comment">//   if (_mesh.processor_id() == 0)</span>
<a name="l00469"></a>00469 <span class="comment">//     soln.resize(_mesh.n_nodes());</span>
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 <span class="comment">//   // Vector to hold the global solution from all processors</span>
<a name="l00472"></a>00472 <span class="comment">//   std::vector&lt;Number&gt; sys_soln;</span>
<a name="l00473"></a>00473   
<a name="l00474"></a>00474 <span class="comment">//   // Update the global solution from all processors</span>
<a name="l00475"></a>00475 <span class="comment">//   system.update_global_solution (sys_soln, 0);</span>
<a name="l00476"></a>00476   
<a name="l00477"></a>00477 <span class="comment">//   // Temporary vector to store the solution on an individual element.</span>
<a name="l00478"></a>00478 <span class="comment">//   std::vector&lt;Number&gt;       elem_soln;   </span>
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 <span class="comment">//   // The FE solution interpolated to the nodes</span>
<a name="l00481"></a>00481 <span class="comment">//   std::vector&lt;Number&gt;       nodal_soln;  </span>
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 <span class="comment">//   // The DOF indices for the element</span>
<a name="l00484"></a>00484 <span class="comment">//   std::vector&lt;unsigned int&gt; dof_indices; </span>
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 <span class="comment">//   // Determine the finite/infinite element type used in this system </span>
<a name="l00487"></a>00487 <span class="comment">//   const FEType&amp; fe_type    = system.variable_type(variable_num);</span>
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 <span class="comment">//   // Define iterators to iterate over all the elements of the mesh</span>
<a name="l00490"></a>00490 <span class="comment">//   const_active_elem_iterator       it (_mesh.elements_begin());</span>
<a name="l00491"></a>00491 <span class="comment">//   const const_active_elem_iterator end(_mesh.elements_end());</span>
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 <span class="comment">//   // Loop over elements</span>
<a name="l00494"></a>00494 <span class="comment">//   for ( ; it != end; ++it)</span>
<a name="l00495"></a>00495 <span class="comment">//     {</span>
<a name="l00496"></a>00496 <span class="comment">//       // Convenient shortcut to the element pointer</span>
<a name="l00497"></a>00497 <span class="comment">//       const Elem* elem = *it;</span>
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 <span class="comment">//       // Fill the dof_indices vector for this variable</span>
<a name="l00500"></a>00500 <span class="comment">//       system.get_dof_map().dof_indices(elem,</span>
<a name="l00501"></a>00501 <span class="comment">//                                     dof_indices,</span>
<a name="l00502"></a>00502 <span class="comment">//                                     variable_num);</span>
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 <span class="comment">//       // Resize the element solution vector to fit the</span>
<a name="l00505"></a>00505 <span class="comment">//       // dof_indices for this element.</span>
<a name="l00506"></a>00506 <span class="comment">//       elem_soln.resize(dof_indices.size());</span>
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 <span class="comment">//       // Transfer the system solution to the element</span>
<a name="l00509"></a>00509 <span class="comment">//       // solution by mapping it through the dof_indices vector.</span>
<a name="l00510"></a>00510 <span class="comment">//       for (unsigned int i=0; i&lt;dof_indices.size(); i++)</span>
<a name="l00511"></a>00511 <span class="comment">//      elem_soln[i] = sys_soln[dof_indices[i]];</span>
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 <span class="comment">//       // Using the FE interface, compute the nodal_soln</span>
<a name="l00514"></a>00514 <span class="comment">//       // for the current elemnt type given the elem_soln</span>
<a name="l00515"></a>00515 <span class="comment">//       FEInterface::nodal_soln (dim,</span>
<a name="l00516"></a>00516 <span class="comment">//                             fe_type,</span>
<a name="l00517"></a>00517 <span class="comment">//                             elem,</span>
<a name="l00518"></a>00518 <span class="comment">//                             elem_soln,</span>
<a name="l00519"></a>00519 <span class="comment">//                             nodal_soln);</span>
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 <span class="comment">//       // Sanity check -- make sure that there are the same number</span>
<a name="l00522"></a>00522 <span class="comment">//       // of entries in the nodal_soln as there are nodes in the</span>
<a name="l00523"></a>00523 <span class="comment">//       // element!</span>
<a name="l00524"></a>00524 <span class="comment">//       libmesh_assert (nodal_soln.size() == elem-&gt;n_nodes());</span>
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 <span class="comment">//       // Copy the nodal solution over into the correct place in</span>
<a name="l00527"></a>00527 <span class="comment">//       // the global soln vector which will be returned to the user.</span>
<a name="l00528"></a>00528 <span class="comment">//       for (unsigned int n=0; n&lt;elem-&gt;n_nodes(); n++)</span>
<a name="l00529"></a>00529 <span class="comment">//      soln[elem-&gt;node(n)] = nodal_soln[n];</span>
<a name="l00530"></a>00530 <span class="comment">//     }</span>
<a name="l00531"></a>00531 }
<a name="l00532"></a>00532 
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a8af6f584c724be0eca934956899c8eb5">00536</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a2c7a089f06d24e9f42330d849ab18503">EquationSystems::build_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln)<span class="keyword"> const</span>
<a name="l00537"></a>00537 <span class="keyword"></span>{
<a name="l00538"></a>00538   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00539"></a>00539   parallel_only();
<a name="l00540"></a>00540 
<a name="l00541"></a>00541   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00542"></a>00542 
<a name="l00543"></a>00543   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00544"></a>00544   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>();
<a name="l00545"></a>00545   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv  = this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a110251f64665b11b6c93ed293313b8e7">n_vars</a>();
<a name="l00546"></a>00546   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> one = 1;
<a name="l00547"></a>00547 
<a name="l00548"></a>00548   <span class="comment">// We&#39;d better have a contiguous node numbering</span>
<a name="l00549"></a>00549   libmesh_assert (nn == <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9778fcd4d5fc7687babdf9a5ea56d882">max_node_id</a>());
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   <span class="comment">// allocate storage to hold</span>
<a name="l00552"></a>00552   <span class="comment">// (number_of_nodes)*(number_of_variables) entries.</span>
<a name="l00553"></a>00553   soln.resize(nn*nv);
<a name="l00554"></a>00554   
<a name="l00555"></a>00555   <span class="comment">// Zero out the soln vector</span>
<a name="l00556"></a>00556   std::fill (soln.begin(), soln.end(), <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>);
<a name="l00557"></a>00557 
<a name="l00558"></a>00558   std::vector&lt;Number&gt;  sys_soln;
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   <span class="comment">// (Note that we use an unsigned short int here even though an</span>
<a name="l00561"></a>00561   <span class="comment">// unsigned char would be more that sufficient.  The MPI 1.1</span>
<a name="l00562"></a>00562   <span class="comment">// standard does not require that MPI_SUM, MPI_PROD etc... be</span>
<a name="l00563"></a>00563   <span class="comment">// implemented for char data types. 12/23/2003 - BSK)  </span>
<a name="l00564"></a>00564   std::vector&lt;unsigned short int&gt; node_conn(nn), repeat_count(nn);
<a name="l00565"></a>00565 
<a name="l00566"></a>00566   <span class="comment">// Get the number of elements that share each node.  We will</span>
<a name="l00567"></a>00567   <span class="comment">// compute the average value at each node.  This is particularly</span>
<a name="l00568"></a>00568   <span class="comment">// useful for plotting discontinuous data.</span>
<a name="l00569"></a>00569   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       e_it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00570"></a>00570   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> e_end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00571"></a>00571 
<a name="l00572"></a>00572   <span class="keywordflow">for</span> ( ; e_it != e_end; ++e_it)
<a name="l00573"></a>00573     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*e_it)-&gt;n_nodes(); n++)
<a name="l00574"></a>00574       node_conn[(*e_it)-&gt;node(n)]++;
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   <span class="comment">// Gather the distributed node_conn arrays in the case of</span>
<a name="l00577"></a>00577   <span class="comment">// multiple processors.</span>
<a name="l00578"></a>00578   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(node_conn);
<a name="l00579"></a>00579 
<a name="l00580"></a>00580   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num=0;
<a name="l00581"></a>00581 
<a name="l00582"></a>00582   <span class="comment">// For each system in this EquationSystems object,</span>
<a name="l00583"></a>00583   <span class="comment">// update the global solution and if we are on processor 0,</span>
<a name="l00584"></a>00584   <span class="comment">// loop over the elements and build the nodal solution</span>
<a name="l00585"></a>00585   <span class="comment">// from the element solution.  Then insert this nodal solution</span>
<a name="l00586"></a>00586   <span class="comment">// into the vector passed to build_solution_vector.</span>
<a name="l00587"></a>00587   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00588"></a>00588   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00589"></a>00589   
<a name="l00590"></a>00590   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00591"></a>00591     {  
<a name="l00592"></a>00592       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system  = *(pos-&gt;second);
<a name="l00593"></a>00593       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv_sys = system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00594"></a>00594       
<a name="l00595"></a>00595       system.<a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">update_global_solution</a> (sys_soln);
<a name="l00596"></a>00596       
<a name="l00597"></a>00597       std::vector&lt;Number&gt;       elem_soln;   <span class="comment">// The finite element solution</span>
<a name="l00598"></a>00598       std::vector&lt;Number&gt;       nodal_soln;  <span class="comment">// The FE solution interpolated to the nodes</span>
<a name="l00599"></a>00599       std::vector&lt;unsigned int&gt; dof_indices; <span class="comment">// The DOF indices for the finite element </span>
<a name="l00600"></a>00600       
<a name="l00601"></a>00601       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;nv_sys; var++)
<a name="l00602"></a>00602         {
<a name="l00603"></a>00603           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type           = system.<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(var);
<a name="l00604"></a>00604           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp;var_description = system.<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var);
<a name="l00605"></a>00605           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map           = system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00606"></a>00606 
<a name="l00607"></a>00607           std::fill (repeat_count.begin(), repeat_count.end(), 0);
<a name="l00608"></a>00608 
<a name="l00609"></a>00609           <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00610"></a>00610           <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00611"></a>00611 
<a name="l00612"></a>00612           <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00613"></a>00613             <span class="keywordflow">if</span> (var_description.<a class="code" href="classlibMesh_1_1Variable.php#a94ff035823801db20635514405af60be">active_on_subdomain</a>((*it)-&gt;subdomain_id()))
<a name="l00614"></a>00614               {
<a name="l00615"></a>00615                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;      
<a name="l00616"></a>00616 
<a name="l00617"></a>00617                 dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices, var);
<a name="l00618"></a>00618               
<a name="l00619"></a>00619                 elem_soln.resize(dof_indices.size());
<a name="l00620"></a>00620               
<a name="l00621"></a>00621                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00622"></a>00622                   elem_soln[i] = sys_soln[dof_indices[i]];
<a name="l00623"></a>00623                   
<a name="l00624"></a>00624                 <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">FEInterface::nodal_soln</a> (dim,
<a name="l00625"></a>00625                                          fe_type,
<a name="l00626"></a>00626                                          elem,
<a name="l00627"></a>00627                                          elem_soln,
<a name="l00628"></a>00628                                          nodal_soln);
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00631"></a>00631 <span class="preprocessor"></span>                <span class="comment">// infinite elements should be skipped...</span>
<a name="l00632"></a>00632                 <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af5eecb2e1afee8bc7ebf8632da91e4ff">infinite</a>())
<a name="l00633"></a>00633 #endif
<a name="l00634"></a>00634                   { 
<a name="l00635"></a>00635                     libmesh_assert (nodal_soln.size() == elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00636"></a>00636                   
<a name="l00637"></a>00637                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00638"></a>00638                       {
<a name="l00639"></a>00639                         repeat_count[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)]++;
<a name="l00640"></a>00640                         soln[nv*(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n)) + (var + var_num)] += nodal_soln[n];
<a name="l00641"></a>00641                       }
<a name="l00642"></a>00642                   }
<a name="l00643"></a>00643               } <span class="comment">// end loop over elements        </span>
<a name="l00644"></a>00644 
<a name="l00645"></a>00645           <span class="comment">// when a variable is active everywhere the repeat_count</span>
<a name="l00646"></a>00646           <span class="comment">// and node_conn arrays should be identical, so let&#39;s</span>
<a name="l00647"></a>00647           <span class="comment">// use that information to avoid unnecessary communication</span>
<a name="l00648"></a>00648           <span class="keywordflow">if</span> (var_description.<a class="code" href="classlibMesh_1_1Variable.php#ad6a1439e083b51801997da06fb663443">implicitly_active</a>())
<a name="l00649"></a>00649             repeat_count = node_conn;
<a name="l00650"></a>00650             
<a name="l00651"></a>00651           <span class="keywordflow">else</span>
<a name="l00652"></a>00652             <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a> (repeat_count);
<a name="l00653"></a>00653 
<a name="l00654"></a>00654           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;nn; n++)
<a name="l00655"></a>00655             soln[nv*n + (var + var_num)] /= 
<a name="l00656"></a>00656               <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (repeat_count[n], one));
<a name="l00657"></a>00657           
<a name="l00658"></a>00658       
<a name="l00659"></a>00659         } <span class="comment">// end loop on variables in this system</span>
<a name="l00660"></a>00660   
<a name="l00661"></a>00661       var_num += nv_sys;
<a name="l00662"></a>00662     } <span class="comment">// end loop over systems</span>
<a name="l00663"></a>00663 
<a name="l00664"></a>00664   <span class="comment">// Now each processor has computed contriburions to the</span>
<a name="l00665"></a>00665   <span class="comment">// soln vector.  Gather them all up.</span>
<a name="l00666"></a>00666   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(soln);
<a name="l00667"></a>00667 }
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 
<a name="l00670"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a86138a573a3ad702b4ffab460aaf3938">00670</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a86138a573a3ad702b4ffab460aaf3938">EquationSystems::get_solution</a> (std::vector&lt;Number&gt;&amp; soln,
<a name="l00671"></a>00671                                     std::vector&lt;std::string&gt; &amp; names )<span class="keyword"> const</span>
<a name="l00672"></a>00672 <span class="keyword"></span>{
<a name="l00673"></a>00673   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00674"></a>00674   parallel_only();
<a name="l00675"></a>00675 
<a name="l00676"></a>00676   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00677"></a>00677 
<a name="l00678"></a>00678   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ne  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00679"></a>00679 
<a name="l00680"></a>00680   libmesh_assert (ne == <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>());
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   soln.clear();
<a name="l00683"></a>00683   names.clear();
<a name="l00684"></a>00684 
<a name="l00685"></a>00685   std::vector&lt;Number&gt;  sys_soln;
<a name="l00686"></a>00686 
<a name="l00687"></a>00687   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> type(<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>);
<a name="l00688"></a>00688 
<a name="l00689"></a>00689   <span class="comment">// For each system in this EquationSystems object,</span>
<a name="l00690"></a>00690   <span class="comment">// update the global solution and collect the</span>
<a name="l00691"></a>00691   <span class="comment">// CONSTANT MONOMIALs.  The entries are in variable-major</span>
<a name="l00692"></a>00692   <span class="comment">// format.</span>
<a name="l00693"></a>00693   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00694"></a>00694   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00695"></a>00695 
<a name="l00696"></a>00696   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00697"></a>00697     {
<a name="l00698"></a>00698       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system  = *(pos-&gt;second);
<a name="l00699"></a>00699       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv_sys = system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00700"></a>00700 
<a name="l00701"></a>00701       system.<a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">update_global_solution</a> (sys_soln);
<a name="l00702"></a>00702 
<a name="l00703"></a>00703       std::vector&lt;unsigned int&gt; dof_indices; <span class="comment">// The DOF indices for the finite element</span>
<a name="l00704"></a>00704 
<a name="l00705"></a>00705       <span class="comment">// Loop over the variable names and load them in order</span>
<a name="l00706"></a>00706       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var &lt; nv_sys; ++var)
<a name="l00707"></a>00707       {
<a name="l00708"></a>00708         <span class="keywordflow">if</span> ( system.<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>( var ) != type )
<a name="l00709"></a>00709         {
<a name="l00710"></a>00710           <span class="keywordflow">continue</span>;
<a name="l00711"></a>00711         }
<a name="l00712"></a>00712 
<a name="l00713"></a>00713         names.push_back( system.<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>( var ) );
<a name="l00714"></a>00714 
<a name="l00715"></a>00715         <span class="comment">// Record the offset for the first element for this variable.</span>
<a name="l00716"></a>00716         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset( soln.size() );
<a name="l00717"></a>00717         <span class="comment">// Increase size of soln for this variable.</span>
<a name="l00718"></a>00718         soln.resize( offset + ne );
<a name="l00719"></a>00719 
<a name="l00720"></a>00720         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Variable.php">Variable</a> &amp; variable = system.<a class="code" href="classlibMesh_1_1System.php#a56d89ed534ffce5eda02dc0137583b56">variable</a>(var);
<a name="l00721"></a>00721         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp; dof_map = system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00722"></a>00722 
<a name="l00723"></a>00723         <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00724"></a>00724         <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00725"></a>00725 
<a name="l00726"></a>00726         <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00727"></a>00727         {
<a name="l00728"></a>00728           <span class="keywordflow">if</span> (variable.<a class="code" href="classlibMesh_1_1Variable.php#a94ff035823801db20635514405af60be">active_on_subdomain</a>((*it)-&gt;subdomain_id()))
<a name="l00729"></a>00729           {
<a name="l00730"></a>00730             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00731"></a>00731 
<a name="l00732"></a>00732             dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices, var);
<a name="l00733"></a>00733 
<a name="l00734"></a>00734             libmesh_assert( 1 == dof_indices.size() );
<a name="l00735"></a>00735 
<a name="l00736"></a>00736             soln[offset+elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = sys_soln[dof_indices[0]];
<a name="l00737"></a>00737           }
<a name="l00738"></a>00738         }
<a name="l00739"></a>00739 
<a name="l00740"></a>00740       } <span class="comment">// end loop on variables in this system</span>
<a name="l00741"></a>00741 
<a name="l00742"></a>00742     } <span class="comment">// end loop over systems</span>
<a name="l00743"></a>00743 
<a name="l00744"></a>00744   <span class="comment">// Now each processor has computed contributions to the</span>
<a name="l00745"></a>00745   <span class="comment">// soln vector.  Gather them all up.</span>
<a name="l00746"></a>00746   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(soln);
<a name="l00747"></a>00747 }
<a name="l00748"></a>00748 
<a name="l00749"></a>00749 
<a name="l00750"></a>00750 
<a name="l00751"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a6916bc3c57d591cccb2e485e663df8d3">00751</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a6916bc3c57d591cccb2e485e663df8d3">EquationSystems::build_discontinuous_solution_vector</a> (std::vector&lt;Number&gt;&amp; soln)<span class="keyword"> const</span>
<a name="l00752"></a>00752 <span class="keyword"></span>{
<a name="l00753"></a>00753   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>());
<a name="l00754"></a>00754 
<a name="l00755"></a>00755   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00756"></a>00756   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv  = this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a110251f64665b11b6c93ed293313b8e7">n_vars</a>();
<a name="l00757"></a>00757   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tw=0;
<a name="l00758"></a>00758 
<a name="l00759"></a>00759   <span class="comment">// get the total weight</span>
<a name="l00760"></a>00760   {
<a name="l00761"></a>00761     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00762"></a>00762     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00763"></a>00763 
<a name="l00764"></a>00764     <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00765"></a>00765       tw += (*it)-&gt;n_nodes();
<a name="l00766"></a>00766   }
<a name="l00767"></a>00767   
<a name="l00768"></a>00768 
<a name="l00769"></a>00769   <span class="comment">// Only if we are on processor zero, allocate the storage</span>
<a name="l00770"></a>00770   <span class="comment">// to hold (number_of_nodes)*(number_of_variables) entries.</span>
<a name="l00771"></a>00771   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>() == 0)
<a name="l00772"></a>00772     soln.resize(tw*nv);
<a name="l00773"></a>00773 
<a name="l00774"></a>00774   std::vector&lt;Number&gt; sys_soln; 
<a name="l00775"></a>00775 
<a name="l00776"></a>00776   
<a name="l00777"></a>00777   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num=0;
<a name="l00778"></a>00778 
<a name="l00779"></a>00779   <span class="comment">// For each system in this EquationSystems object,</span>
<a name="l00780"></a>00780   <span class="comment">// update the global solution and if we are on processor 0,</span>
<a name="l00781"></a>00781   <span class="comment">// loop over the elements and build the nodal solution</span>
<a name="l00782"></a>00782   <span class="comment">// from the element solution.  Then insert this nodal solution</span>
<a name="l00783"></a>00783   <span class="comment">// into the vector passed to build_solution_vector.</span>
<a name="l00784"></a>00784   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00785"></a>00785   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00786"></a>00786 
<a name="l00787"></a>00787   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00788"></a>00788     {  
<a name="l00789"></a>00789       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system  = *(pos-&gt;second);
<a name="l00790"></a>00790       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nv_sys = system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00791"></a>00791       
<a name="l00792"></a>00792       system.<a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">update_global_solution</a> (sys_soln, 0);
<a name="l00793"></a>00793       
<a name="l00794"></a>00794       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>() == 0)
<a name="l00795"></a>00795         {
<a name="l00796"></a>00796           std::vector&lt;Number&gt;       elem_soln;   <span class="comment">// The finite element solution</span>
<a name="l00797"></a>00797           std::vector&lt;Number&gt;       nodal_soln;  <span class="comment">// The FE solution interpolated to the nodes</span>
<a name="l00798"></a>00798           std::vector&lt;unsigned int&gt; dof_indices; <span class="comment">// The DOF indices for the finite element </span>
<a name="l00799"></a>00799               
<a name="l00800"></a>00800           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;nv_sys; var++)
<a name="l00801"></a>00801             {
<a name="l00802"></a>00802               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type    = system.<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(var);
<a name="l00803"></a>00803 
<a name="l00804"></a>00804               <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00805"></a>00805               <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00806"></a>00806 
<a name="l00807"></a>00807               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn=0;
<a name="l00808"></a>00808               
<a name="l00809"></a>00809               <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00810"></a>00810                 {
<a name="l00811"></a>00811                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00812"></a>00812                   system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices, var);
<a name="l00813"></a>00813                   
<a name="l00814"></a>00814                   elem_soln.resize(dof_indices.size());
<a name="l00815"></a>00815                   
<a name="l00816"></a>00816                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00817"></a>00817                     elem_soln[i] = sys_soln[dof_indices[i]];
<a name="l00818"></a>00818                   
<a name="l00819"></a>00819                   <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">FEInterface::nodal_soln</a> (dim,
<a name="l00820"></a>00820                                            fe_type,
<a name="l00821"></a>00821                                            elem,
<a name="l00822"></a>00822                                            elem_soln,
<a name="l00823"></a>00823                                            nodal_soln);
<a name="l00824"></a>00824 
<a name="l00825"></a>00825 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00826"></a>00826 <span class="preprocessor"></span>                  <span class="comment">// infinite elements should be skipped...</span>
<a name="l00827"></a>00827                   <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af5eecb2e1afee8bc7ebf8632da91e4ff">infinite</a>())
<a name="l00828"></a>00828 #endif
<a name="l00829"></a>00829                     { 
<a name="l00830"></a>00830                       libmesh_assert (nodal_soln.size() == elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00831"></a>00831                   
<a name="l00832"></a>00832                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00833"></a>00833                         {
<a name="l00834"></a>00834                           soln[nv*(nn++) + (var + var_num)] +=
<a name="l00835"></a>00835                             nodal_soln[n];
<a name="l00836"></a>00836                         }
<a name="l00837"></a>00837                     }
<a name="l00838"></a>00838                 }
<a name="l00839"></a>00839             }    
<a name="l00840"></a>00840         }
<a name="l00841"></a>00841 
<a name="l00842"></a>00842       var_num += nv_sys;
<a name="l00843"></a>00843     }
<a name="l00844"></a>00844 }
<a name="l00845"></a>00845 
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 
<a name="l00848"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a83e3cf47dde2b71b8340fdaabd46b6b9">00848</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a83e3cf47dde2b71b8340fdaabd46b6b9">EquationSystems::compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; other_es, 
<a name="l00849"></a>00849                                <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold,
<a name="l00850"></a>00850                                <span class="keyword">const</span> <span class="keywordtype">bool</span> verbose)<span class="keyword"> const</span>
<a name="l00851"></a>00851 <span class="keyword"></span>{
<a name="l00852"></a>00852   <span class="comment">// safety check, whether we handle at least the same number</span>
<a name="l00853"></a>00853   <span class="comment">// of systems</span>
<a name="l00854"></a>00854   std::vector&lt;bool&gt; os_result;
<a name="l00855"></a>00855 
<a name="l00856"></a>00856   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>() != other_es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>())
<a name="l00857"></a>00857     {
<a name="l00858"></a>00858       <span class="keywordflow">if</span> (verbose)
<a name="l00859"></a>00859         {
<a name="l00860"></a>00860           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Fatal difference. This system handles &quot;</span> 
<a name="l00861"></a>00861                         &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>() &lt;&lt; <span class="stringliteral">&quot; systems,&quot;</span> &lt;&lt; std::endl
<a name="l00862"></a>00862                         &lt;&lt; <span class="stringliteral">&quot;  while the other system handles &quot;</span>
<a name="l00863"></a>00863                         &lt;&lt; other_es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>() 
<a name="l00864"></a>00864                         &lt;&lt; <span class="stringliteral">&quot; systems.&quot;</span> &lt;&lt; std::endl
<a name="l00865"></a>00865                         &lt;&lt; <span class="stringliteral">&quot;  Aborting comparison.&quot;</span> &lt;&lt; std::endl;
<a name="l00866"></a>00866         }
<a name="l00867"></a>00867       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00868"></a>00868     }
<a name="l00869"></a>00869   <span class="keywordflow">else</span>
<a name="l00870"></a>00870     {
<a name="l00871"></a>00871       <span class="comment">// start comparing each system      </span>
<a name="l00872"></a>00872       <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00873"></a>00873       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00874"></a>00874 
<a name="l00875"></a>00875       <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00876"></a>00876         {
<a name="l00877"></a>00877           <span class="keyword">const</span> std::string&amp; sys_name = pos-&gt;first;
<a name="l00878"></a>00878           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;  system        = *(pos-&gt;second);
<a name="l00879"></a>00879       
<a name="l00880"></a>00880           <span class="comment">// get the other system</span>
<a name="l00881"></a>00881           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; other_system   = other_es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (sys_name);
<a name="l00882"></a>00882 
<a name="l00883"></a>00883           os_result.push_back (system.<a class="code" href="classlibMesh_1_1System.php#a8a3e5f73bb8c49d5d69ed59849e9b20e">compare</a> (other_system, threshold, verbose));
<a name="l00884"></a>00884 
<a name="l00885"></a>00885         }
<a name="l00886"></a>00886 
<a name="l00887"></a>00887     }
<a name="l00888"></a>00888   
<a name="l00889"></a>00889 
<a name="l00890"></a>00890   <span class="comment">// sum up the results</span>
<a name="l00891"></a>00891   <span class="keywordflow">if</span> (os_result.size()==0)
<a name="l00892"></a>00892     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00893"></a>00893   <span class="keywordflow">else</span>
<a name="l00894"></a>00894     {
<a name="l00895"></a>00895       <span class="keywordtype">bool</span> os_identical;
<a name="l00896"></a>00896       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0;
<a name="l00897"></a>00897           <span class="keywordflow">do</span>
<a name="l00898"></a>00898             {
<a name="l00899"></a>00899               os_identical = os_result[n];
<a name="l00900"></a>00900               n++;
<a name="l00901"></a>00901             }
<a name="l00902"></a>00902           <span class="keywordflow">while</span> (os_identical &amp;&amp; n&lt;os_result.size());
<a name="l00903"></a>00903           <span class="keywordflow">return</span> os_identical;
<a name="l00904"></a>00904         }
<a name="l00905"></a>00905 }
<a name="l00906"></a>00906 
<a name="l00907"></a>00907 
<a name="l00908"></a>00908 
<a name="l00909"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a117c5dcec33e211dd0810ac7da8e2ecf">00909</a> std::string <a class="code" href="classlibMesh_1_1EquationSystems.php#a117c5dcec33e211dd0810ac7da8e2ecf">EquationSystems::get_info</a> ()<span class="keyword"> const</span>
<a name="l00910"></a>00910 <span class="keyword"></span>{
<a name="l00911"></a>00911   std::ostringstream <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l00912"></a>00912   
<a name="l00913"></a>00913   out &lt;&lt; <span class="stringliteral">&quot; EquationSystems\n&quot;</span>
<a name="l00914"></a>00914       &lt;&lt; <span class="stringliteral">&quot;  n_systems()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00915"></a>00915 
<a name="l00916"></a>00916   <span class="comment">// Print the info for the individual systems</span>
<a name="l00917"></a>00917   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00918"></a>00918   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00919"></a>00919 
<a name="l00920"></a>00920   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00921"></a>00921     out &lt;&lt; pos-&gt;second-&gt;get_info();
<a name="l00922"></a>00922 
<a name="l00923"></a>00923   
<a name="l00924"></a>00924 <span class="comment">//   // Possibly print the parameters  </span>
<a name="l00925"></a>00925 <span class="comment">//   if (!this-&gt;parameters.empty())</span>
<a name="l00926"></a>00926 <span class="comment">//     {  </span>
<a name="l00927"></a>00927 <span class="comment">//       out &lt;&lt; &quot;  n_parameters()=&quot; &lt;&lt; this-&gt;n_parameters() &lt;&lt; &#39;\n&#39;;</span>
<a name="l00928"></a>00928 <span class="comment">//       out &lt;&lt; &quot;   Parameters:\n&quot;;</span>
<a name="l00929"></a>00929       
<a name="l00930"></a>00930 <span class="comment">//       for (std::map&lt;std::string, Real&gt;::const_iterator</span>
<a name="l00931"></a>00931 <span class="comment">//           param = _parameters.begin(); param != _parameters.end();</span>
<a name="l00932"></a>00932 <span class="comment">//         ++param)</span>
<a name="l00933"></a>00933 <span class="comment">//      out &lt;&lt; &quot;    &quot;</span>
<a name="l00934"></a>00934 <span class="comment">//          &lt;&lt; &quot;\&quot;&quot;</span>
<a name="l00935"></a>00935 <span class="comment">//          &lt;&lt; param-&gt;first</span>
<a name="l00936"></a>00936 <span class="comment">//          &lt;&lt; &quot;\&quot;&quot;</span>
<a name="l00937"></a>00937 <span class="comment">//          &lt;&lt; &quot;=&quot;</span>
<a name="l00938"></a>00938 <span class="comment">//          &lt;&lt; param-&gt;second</span>
<a name="l00939"></a>00939 <span class="comment">//          &lt;&lt; &#39;\n&#39;;</span>
<a name="l00940"></a>00940 <span class="comment">//     }</span>
<a name="l00941"></a>00941   
<a name="l00942"></a>00942   <span class="keywordflow">return</span> out.str();
<a name="l00943"></a>00943 }
<a name="l00944"></a>00944 
<a name="l00945"></a>00945 
<a name="l00946"></a>00946 
<a name="l00947"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a06361551bf19f5f651270276703f1fcd">00947</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a06361551bf19f5f651270276703f1fcd">EquationSystems::print_info</a> (std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00948"></a>00948 <span class="keyword"></span>{
<a name="l00949"></a>00949   os &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a117c5dcec33e211dd0810ac7da8e2ecf">get_info</a>()
<a name="l00950"></a>00950      &lt;&lt; std::endl;
<a name="l00951"></a>00951 }
<a name="l00952"></a>00952 
<a name="l00953"></a>00953 
<a name="l00954"></a>00954 
<a name="l00955"></a><a class="code" href="namespacelibMesh.php#a83b8ecd9a011756b110ba693a1591118">00955</a> std::ostream&amp; <a class="code" href="namespacelibMesh.php#a546a7b5eb3d073add8e1f19af6bcaf82">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es)
<a name="l00956"></a>00956 {
<a name="l00957"></a>00957   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a06361551bf19f5f651270276703f1fcd">print_info</a>(os);
<a name="l00958"></a>00958   <span class="keywordflow">return</span> os;
<a name="l00959"></a>00959 }
<a name="l00960"></a>00960 
<a name="l00961"></a>00961 
<a name="l00962"></a>00962 
<a name="l00963"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a110251f64665b11b6c93ed293313b8e7">00963</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a110251f64665b11b6c93ed293313b8e7">EquationSystems::n_vars</a> ()<span class="keyword"> const</span>
<a name="l00964"></a>00964 <span class="keyword"></span>{
<a name="l00965"></a>00965   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot=0;
<a name="l00966"></a>00966   
<a name="l00967"></a>00967   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00968"></a>00968   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00969"></a>00969 
<a name="l00970"></a>00970   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00971"></a>00971     tot += pos-&gt;second-&gt;n_vars();
<a name="l00972"></a>00972 
<a name="l00973"></a>00973   <span class="keywordflow">return</span> tot;
<a name="l00974"></a>00974 }
<a name="l00975"></a>00975 
<a name="l00976"></a>00976 
<a name="l00977"></a>00977 
<a name="l00978"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#af378a53904cbe83a0dfacfa3d9f9f1a5">00978</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#af378a53904cbe83a0dfacfa3d9f9f1a5">EquationSystems::n_dofs</a> ()<span class="keyword"> const</span>
<a name="l00979"></a>00979 <span class="keyword"></span>{
<a name="l00980"></a>00980   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot=0;
<a name="l00981"></a>00981 
<a name="l00982"></a>00982   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00983"></a>00983   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l00984"></a>00984 
<a name="l00985"></a>00985   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l00986"></a>00986     tot += pos-&gt;second-&gt;n_dofs();
<a name="l00987"></a>00987 
<a name="l00988"></a>00988   <span class="keywordflow">return</span> tot;      
<a name="l00989"></a>00989 }
<a name="l00990"></a>00990 
<a name="l00991"></a>00991 
<a name="l00992"></a>00992 
<a name="l00993"></a>00993 
<a name="l00994"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#a9b15b626660071b21314ed9018b4fc85">00994</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#a9b15b626660071b21314ed9018b4fc85">EquationSystems::n_active_dofs</a> ()<span class="keyword"> const</span>
<a name="l00995"></a>00995 <span class="keyword"></span>{
<a name="l00996"></a>00996   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot=0;
<a name="l00997"></a>00997 
<a name="l00998"></a>00998   <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a>       pos = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.begin();
<a name="l00999"></a>00999   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ae02976e2d06f5ed10029f0f597bc4f15">const_system_iterator</a> end = <a class="code" href="classlibMesh_1_1EquationSystems.php#a7a35e87841d9f17fb7e2588ff059ec8e">_systems</a>.end();
<a name="l01000"></a>01000 
<a name="l01001"></a>01001   <span class="keywordflow">for</span> (; pos != end; ++pos)
<a name="l01002"></a>01002     tot += pos-&gt;second-&gt;n_active_dofs();
<a name="l01003"></a>01003 
<a name="l01004"></a>01004   <span class="keywordflow">return</span> tot;      
<a name="l01005"></a>01005 }
<a name="l01006"></a>01006 
<a name="l01007"></a>01007 
<a name="l01008"></a><a class="code" href="classlibMesh_1_1EquationSystems.php#ac5060830e5affa44351759890c3415ac">01008</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1EquationSystems.php#ac5060830e5affa44351759890c3415ac">EquationSystems::_add_system_to_nodes_and_elems</a>()
<a name="l01009"></a>01009 {
<a name="l01010"></a>01010   <span class="comment">// All the nodes</span>
<a name="l01011"></a>01011   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l01012"></a>01012   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l01013"></a>01013  
<a name="l01014"></a>01014   <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l01015"></a>01015     (*node_it)-&gt;add_system();
<a name="l01016"></a>01016  
<a name="l01017"></a>01017   <span class="comment">// All the elements</span>
<a name="l01018"></a>01018   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l01019"></a>01019   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1EquationSystems.php#aa40db714c766361cd70548df3d06c57d">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l01020"></a>01020  
<a name="l01021"></a>01021   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l01022"></a>01022     (*elem_it)-&gt;add_system();
<a name="l01023"></a>01023 }
<a name="l01024"></a>01024 
<a name="l01025"></a>01025 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
