<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">error_estimator.C</div>  </div>
</div>
<div class="contents">
<a href="error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: error_estimator.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local include files</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ErrorEstimator functions</span>
<a name="l00035"></a><a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9b57650afd8a3a0a88cb62bf74dd95e3">00035</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9b57650afd8a3a0a88cb62bf74dd95e3">ErrorEstimator::reduce_error</a> (std::vector&lt;ErrorVectorReal&gt;&amp; error_per_cell)<span class="keyword"> const</span>
<a name="l00036"></a>00036 <span class="keyword"></span>{
<a name="l00037"></a>00037   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00038"></a>00038   parallel_only();
<a name="l00039"></a>00039 
<a name="l00040"></a>00040   <span class="comment">// Each processor has now computed the error contribuions</span>
<a name="l00041"></a>00041   <span class="comment">// for its local elements.  We may need to sum the vector to</span>
<a name="l00042"></a>00042   <span class="comment">// recover the error for each element.</span>
<a name="l00043"></a>00043   
<a name="l00044"></a>00044   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(error_per_cell);
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a><a class="code" href="classlibMesh_1_1ErrorEstimator.php#a8d34dfeddc8a1991cd9d01e401b6d779">00049</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a8d34dfeddc8a1991cd9d01e401b6d779">ErrorEstimator::estimate_errors</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00050"></a>00050                                      <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00051"></a>00051                                      <span class="keyword">const</span> std::map&lt;const System*, SystemNorm&gt;&amp; error_norms,
<a name="l00052"></a>00052                                      <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors,
<a name="l00053"></a>00053                                      <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> old_error_norm = this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">// Sum the error values from each system</span>
<a name="l00058"></a>00058   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s = 0; s != equation_systems.<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++s)
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060       <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> system_error_per_cell;
<a name="l00061"></a>00061       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = equation_systems.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(s);
<a name="l00062"></a>00062       <span class="keywordflow">if</span> (error_norms.find(&amp;sys) == error_norms.end())
<a name="l00063"></a>00063         this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> = old_error_norm;
<a name="l00064"></a>00064       <span class="keywordflow">else</span>
<a name="l00065"></a>00065         this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> = error_norms.find(&amp;sys)-&gt;second;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL;
<a name="l00068"></a>00068       <span class="keywordflow">if</span> (solution_vectors &amp;&amp;
<a name="l00069"></a>00069           solution_vectors-&gt;find(&amp;sys) != solution_vectors-&gt;end())
<a name="l00070"></a>00070         solution_vector = solution_vectors-&gt;find(&amp;sys)-&gt;second;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072       this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a4e8751ba26dfeb9e692d92e10f1cbd28">estimate_error</a>(sys, system_error_per_cell,
<a name="l00073"></a>00073                            solution_vector, estimate_parent_error);
<a name="l00074"></a>00074 
<a name="l00075"></a>00075       <span class="keywordflow">if</span> (s)
<a name="l00076"></a>00076         {
<a name="l00077"></a>00077           libmesh_assert(error_per_cell.size() == system_error_per_cell.size());
<a name="l00078"></a>00078           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != error_per_cell.size(); ++i)
<a name="l00079"></a>00079             error_per_cell[i] += system_error_per_cell[i];
<a name="l00080"></a>00080         }
<a name="l00081"></a>00081       <span class="keywordflow">else</span>
<a name="l00082"></a>00082         error_per_cell = system_error_per_cell;
<a name="l00083"></a>00083     }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// Restore our old state before returning</span>
<a name="l00086"></a>00086   this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> = old_error_norm;
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1ErrorEstimator.php#a6154704639951f51a2749af773c7ea6d">00095</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a8d34dfeddc8a1991cd9d01e401b6d779">ErrorEstimator::estimate_errors</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00096"></a>00096                                      <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a838c11d53f37d85b33a827a355819c94">ErrorMap</a>&amp; errors_per_cell,
<a name="l00097"></a>00097                                      <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors,
<a name="l00098"></a>00098                                      <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100   <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> old_error_norm = this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">// Find the requested error values from each system</span>
<a name="l00103"></a>00103   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s = 0; s != equation_systems.<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++s)
<a name="l00104"></a>00104     {
<a name="l00105"></a>00105       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = equation_systems.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(s);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = sys.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00108"></a>00108 
<a name="l00109"></a>00109       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v = 0; v != <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; ++v)
<a name="l00110"></a>00110         {
<a name="l00111"></a>00111           <span class="comment">// Only fill in ErrorVectors the user asks for</span>
<a name="l00112"></a>00112           <span class="keywordflow">if</span> (errors_per_cell.find(std::make_pair(&amp;sys, v)) ==
<a name="l00113"></a>00113               errors_per_cell.end())
<a name="l00114"></a>00114             <span class="keywordflow">continue</span>;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116           <span class="comment">// Calculate error in only one variable</span>
<a name="l00117"></a>00117           std::vector&lt;Real&gt; weights(n_vars, 0.0);
<a name="l00118"></a>00118           weights[v] = 1.0;
<a name="l00119"></a>00119           this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> =
<a name="l00120"></a>00120             <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a>(std::vector&lt;FEMNormType&gt;(n_vars, old_error_norm.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(0)),
<a name="l00121"></a>00121                        weights);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL;
<a name="l00124"></a>00124           <span class="keywordflow">if</span> (solution_vectors &amp;&amp;
<a name="l00125"></a>00125               solution_vectors-&gt;find(&amp;sys) != solution_vectors-&gt;end())
<a name="l00126"></a>00126             solution_vector = solution_vectors-&gt;find(&amp;sys)-&gt;second;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128           this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a4e8751ba26dfeb9e692d92e10f1cbd28">estimate_error</a>
<a name="l00129"></a>00129             (sys, *errors_per_cell[std::make_pair(&amp;sys, v)],
<a name="l00130"></a>00130              solution_vector, estimate_parent_error);
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132     }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">// Restore our old state before returning</span>
<a name="l00135"></a>00135   this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> = old_error_norm;
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
