<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3734f8fafd73a2969ee8ed4a34620869.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">error_estimator.h</div>  </div>
</div>
<div class="contents">
<a href="error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: error_estimator.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="system__norm_8h.php">system_norm.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>ErrorVector;
<a name="l00039"></a>00039 <span class="keyword">class </span>EquationSystems;
<a name="l00040"></a>00040 <span class="keyword">class </span>System;
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00042"></a>00042 
<a name="l00053"></a><a class="code" href="classlibMesh_1_1ErrorEstimator.php">00053</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ErrorEstimator.php">ErrorEstimator</a>
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055 <span class="keyword">public</span>:
<a name="l00056"></a>00056 
<a name="l00061"></a><a class="code" href="classlibMesh_1_1ErrorEstimator.php#ac4e2a7f658fb05f57ca690a42c2765fb">00061</a>   <a class="code" href="classlibMesh_1_1ErrorEstimator.php#ac4e2a7f658fb05f57ca690a42c2765fb">ErrorEstimator</a>() : <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>() {}
<a name="l00062"></a>00062   
<a name="l00066"></a><a class="code" href="classlibMesh_1_1ErrorEstimator.php#a3fbcb4ecfe8cbd225d6414a10cccf26d">00066</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a3fbcb4ecfe8cbd225d6414a10cccf26d">~ErrorEstimator</a>() {}
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a4e8751ba26dfeb9e692d92e10f1cbd28">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00083"></a>00083                                <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00084"></a>00084                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00085"></a>00085                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>) = 0;
<a name="l00086"></a>00086 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a8d34dfeddc8a1991cd9d01e401b6d779">estimate_errors</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00099"></a>00099                                 <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00100"></a>00100                                 <span class="keyword">const</span> std::map&lt;const System*, SystemNorm&gt;&amp; error_norms,
<a name="l00101"></a>00101                                 <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors = NULL,
<a name="l00102"></a>00102                                 <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00103"></a>00103 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1ErrorEstimator.php#a838c11d53f37d85b33a827a355819c94">00108</a>   <span class="keyword">typedef</span> std::map&lt;std::pair&lt;const System*, unsigned int&gt;, <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>*&gt; <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a838c11d53f37d85b33a827a355819c94">ErrorMap</a>;
<a name="l00109"></a>00109 
<a name="l00122"></a>00122   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a8d34dfeddc8a1991cd9d01e401b6d779">estimate_errors</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; equation_systems,
<a name="l00123"></a>00123                                 <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a838c11d53f37d85b33a827a355819c94">ErrorMap</a>&amp; errors_per_cell,
<a name="l00124"></a>00124                                 <span class="keyword">const</span> std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>*, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* &gt;* solution_vectors = NULL,
<a name="l00125"></a>00125                                 <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00126"></a>00126 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">00140</a>   <a class="code" href="classlibMesh_1_1SystemNorm.php">SystemNorm</a> <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="keyword">protected</span>:
<a name="l00143"></a>00143 
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9b57650afd8a3a0a88cb62bf74dd95e3">reduce_error</a> (std::vector&lt;float&gt;&amp; error_per_cell) <span class="keyword">const</span>;
<a name="l00150"></a>00150 };
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 } <span class="comment">// namespace libMesh</span>
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif</span>
<a name="l00156"></a>00156 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
