<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">error_vector.C</div>  </div>
</div>
<div class="contents">
<a href="error__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: error_vector.C 4015 2010-10-01 21:03:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="explicit__system_8h.php">explicit_system.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="gmv__io_8h.php">gmv_io.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="tecplot__io_8h.php">tecplot_io.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// ErrorVector class member functions</span>
<a name="l00044"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#ae53298fa11ee8858e287ee25f065b46b">00044</a> <a class="code" href="namespacelibMesh.php#a26acf05f075521cbfb223db57e63d6d0">ErrorVectorReal</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#ae53298fa11ee8858e287ee25f065b46b">ErrorVector::minimum</a>()<span class="keyword"> const</span>
<a name="l00045"></a>00045 <span class="keyword"></span>{
<a name="l00046"></a>00046   START_LOG (<span class="stringliteral">&quot;minimum()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00049"></a>00049   <a class="code" href="namespacelibMesh.php#a26acf05f075521cbfb223db57e63d6d0">ErrorVectorReal</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;ErrorVectorReal&gt;::max</a>();
<a name="l00050"></a>00050   
<a name="l00051"></a>00051   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053       <span class="comment">// Only positive (or zero) values in the error vector</span>
<a name="l00054"></a>00054       libmesh_assert((*<span class="keyword">this</span>)[i] &gt;= 0.);
<a name="l00055"></a>00055       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1ErrorVector.php#a4680ee362a30f5df3c83ff6cb669a0fe">is_active_elem</a>(i))
<a name="l00056"></a>00056         min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (min, (*<span class="keyword">this</span>)[i]);
<a name="l00057"></a>00057     }
<a name="l00058"></a>00058   STOP_LOG (<span class="stringliteral">&quot;minimum()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="comment">// ErrorVectors are for positive values</span>
<a name="l00061"></a>00061   libmesh_assert (min &gt;= 0.);
<a name="l00062"></a>00062   
<a name="l00063"></a>00063   <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>;
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#ada7e2f1c0df0e837d6e6f18cf5f56077">00068</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#ada7e2f1c0df0e837d6e6f18cf5f56077">ErrorVector::mean</a>()<span class="keyword"> const</span>
<a name="l00069"></a>00069 <span class="keyword"></span>{
<a name="l00070"></a>00070   START_LOG (<span class="stringliteral">&quot;mean()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00071"></a>00071   
<a name="l00072"></a>00072   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#ada7e2f1c0df0e837d6e6f18cf5f56077">mean</a>  = 0;
<a name="l00075"></a>00075   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz = 0;
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00078"></a>00078     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1ErrorVector.php#a4680ee362a30f5df3c83ff6cb669a0fe">is_active_elem</a>(i))
<a name="l00079"></a>00079       {
<a name="l00080"></a>00080         mean += ( <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>((*this)[i]) - mean ) / (nnz + 1);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082         nnz++;
<a name="l00083"></a>00083       }
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   STOP_LOG (<span class="stringliteral">&quot;mean()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ErrorVector.php#ada7e2f1c0df0e837d6e6f18cf5f56077">mean</a>;
<a name="l00088"></a>00088 }
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#aab627b905d6c7f2dfe23b37ff72b4df3">00093</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#aab627b905d6c7f2dfe23b37ff72b4df3">ErrorVector::median</a>() 
<a name="l00094"></a>00094 {
<a name="l00095"></a>00095   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = this-&gt;size();
<a name="l00096"></a>00096   
<a name="l00097"></a>00097   <span class="keywordflow">if</span> (n == 0)
<a name="l00098"></a>00098     <span class="keywordflow">return</span> 0.;
<a name="l00099"></a>00099   
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="comment">// Build a StatisticsVector&lt;ErrorVectorReal&gt; containing</span>
<a name="l00102"></a>00102   <span class="comment">// only our active entries and take its mean</span>
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector&lt;ErrorVectorReal&gt;</a> sv;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   sv.reserve (n);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00108"></a>00108     <span class="keywordflow">if</span>(this-&gt;<a class="code" href="classlibMesh_1_1ErrorVector.php#a4680ee362a30f5df3c83ff6cb669a0fe">is_active_elem</a>(i))
<a name="l00109"></a>00109       sv.push_back((*<span class="keyword">this</span>)[i]);
<a name="l00110"></a>00110   
<a name="l00111"></a>00111   <span class="keywordflow">return</span> sv.<a class="code" href="classlibMesh_1_1StatisticsVector.php#a2099e0d9fd85062c3757354b0acf9670">median</a>();
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#a6a0dbbcf3a59a7137d4688cf92d20fd2">00117</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#aab627b905d6c7f2dfe23b37ff72b4df3">ErrorVector::median</a>()<span class="keyword"> const</span>
<a name="l00118"></a>00118 <span class="keyword"></span>{
<a name="l00119"></a>00119   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> ev = (*this);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="keywordflow">return</span> ev.<a class="code" href="classlibMesh_1_1ErrorVector.php#aab627b905d6c7f2dfe23b37ff72b4df3">median</a>();
<a name="l00122"></a>00122 }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#a3a17dd84f9405a8eb27027ef3ac3f807">00127</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#a961787a0534b54e9debd9a110d315f50">ErrorVector::variance</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> mean)<span class="keyword"> const</span>
<a name="l00128"></a>00128 <span class="keyword"></span>{
<a name="l00129"></a>00129   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = this-&gt;size();
<a name="l00130"></a>00130   
<a name="l00131"></a>00131   START_LOG (<span class="stringliteral">&quot;variance()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#a961787a0534b54e9debd9a110d315f50">variance</a> = 0;
<a name="l00134"></a>00134   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz = 0;
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00137"></a>00137     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1ErrorVector.php#a4680ee362a30f5df3c83ff6cb669a0fe">is_active_elem</a>(i))
<a name="l00138"></a>00138       {
<a name="l00139"></a>00139         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta = ( <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>((*this)[i]) - mean );
<a name="l00140"></a>00140         variance += (delta * delta - <a class="code" href="classlibMesh_1_1ErrorVector.php#a961787a0534b54e9debd9a110d315f50">variance</a>) / (nnz + 1);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142         nnz++;
<a name="l00143"></a>00143       }
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   STOP_LOG (<span class="stringliteral">&quot;variance()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00146"></a>00146   
<a name="l00147"></a>00147   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ErrorVector.php#a961787a0534b54e9debd9a110d315f50">variance</a>;
<a name="l00148"></a>00148 }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#aef82ea17852e473e9e4df80783019d89">00153</a> std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1ErrorVector.php#aef82ea17852e473e9e4df80783019d89">ErrorVector::cut_below</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cut)<span class="keyword"> const</span>
<a name="l00154"></a>00154 <span class="keyword"></span>{
<a name="l00155"></a>00155   START_LOG (<span class="stringliteral">&quot;cut_below()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00156"></a>00156   
<a name="l00157"></a>00157   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00158"></a>00158   
<a name="l00159"></a>00159   std::vector&lt;unsigned int&gt; cut_indices;
<a name="l00160"></a>00160   cut_indices.reserve(n/2);  <span class="comment">// Arbitrary </span>
<a name="l00161"></a>00161   
<a name="l00162"></a>00162   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00163"></a>00163     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1ErrorVector.php#a4680ee362a30f5df3c83ff6cb669a0fe">is_active_elem</a>(i))
<a name="l00164"></a>00164       {
<a name="l00165"></a>00165         <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)[i] &lt; cut)
<a name="l00166"></a>00166           {
<a name="l00167"></a>00167             cut_indices.push_back(i);
<a name="l00168"></a>00168           }
<a name="l00169"></a>00169       }
<a name="l00170"></a>00170   
<a name="l00171"></a>00171   STOP_LOG (<span class="stringliteral">&quot;cut_below()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00172"></a>00172   
<a name="l00173"></a>00173   <span class="keywordflow">return</span> cut_indices;
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#a16077569ce6da661f2df0859c5539a73">00179</a> std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1ErrorVector.php#a16077569ce6da661f2df0859c5539a73">ErrorVector::cut_above</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cut)<span class="keyword"> const</span>
<a name="l00180"></a>00180 <span class="keyword"></span>{
<a name="l00181"></a>00181   START_LOG (<span class="stringliteral">&quot;cut_above()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n   = this-&gt;size();
<a name="l00184"></a>00184   
<a name="l00185"></a>00185   std::vector&lt;unsigned int&gt; cut_indices;
<a name="l00186"></a>00186   cut_indices.reserve(n/2);  <span class="comment">// Arbitrary </span>
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00189"></a>00189     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1ErrorVector.php#a4680ee362a30f5df3c83ff6cb669a0fe">is_active_elem</a>(i))
<a name="l00190"></a>00190       {
<a name="l00191"></a>00191         <span class="keywordflow">if</span> ((*<span class="keyword">this</span>)[i] &gt; cut)
<a name="l00192"></a>00192           {
<a name="l00193"></a>00193             cut_indices.push_back(i);
<a name="l00194"></a>00194           }
<a name="l00195"></a>00195       }
<a name="l00196"></a>00196   
<a name="l00197"></a>00197   STOP_LOG (<span class="stringliteral">&quot;cut_above()&quot;</span>, <span class="stringliteral">&quot;ErrorVector&quot;</span>);
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   <span class="keywordflow">return</span> cut_indices;
<a name="l00200"></a>00200 }
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#a4680ee362a30f5df3c83ff6cb669a0fe">00204</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ErrorVector.php#a4680ee362a30f5df3c83ff6cb669a0fe">ErrorVector::is_active_elem</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00205"></a>00205 <span class="keyword"></span>{
<a name="l00206"></a>00206   libmesh_assert (i &lt; this-&gt;size());
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ErrorVector.php#a7471cc33c975107bda15c785bfc9c701">_mesh</a>)
<a name="l00209"></a>00209     {
<a name="l00210"></a>00210       libmesh_assert(<a class="code" href="classlibMesh_1_1ErrorVector.php#a7471cc33c975107bda15c785bfc9c701">_mesh</a>-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(i));
<a name="l00211"></a>00211       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ErrorVector.php#a7471cc33c975107bda15c785bfc9c701">_mesh</a>-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(i)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>();
<a name="l00212"></a>00212     }
<a name="l00213"></a>00213   <span class="keywordflow">else</span>
<a name="l00214"></a>00214     <span class="keywordflow">return</span> ((*<span class="keyword">this</span>)[i] != 0.);
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#af42a70293b724817dd9c282642eb354c">00218</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ErrorVector.php#af42a70293b724817dd9c282642eb354c">ErrorVector::plot_error</a>(<span class="keyword">const</span> std::string&amp; filename,
<a name="l00219"></a>00219                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; oldmesh)<span class="keyword"> const</span>
<a name="l00220"></a>00220 <span class="keyword"></span>{
<a name="l00221"></a>00221   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a> meshptr = oldmesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a98a7a45b2176811b60664acfe21acc7a">clone</a>();
<a name="l00222"></a>00222   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = *meshptr;
<a name="l00223"></a>00223   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1a467cd415f8c2377734d97f5afe53af">all_first_order</a>();
<a name="l00224"></a>00224   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a> temp_es (mesh);
<a name="l00225"></a>00225   <a class="code" href="classlibMesh_1_1ExplicitSystem.php">ExplicitSystem</a>&amp; error_system
<a name="l00226"></a>00226     = temp_es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a09450d5e4547d8b2e5690043da03dbd3">add_system</a>&lt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php">ExplicitSystem</a>&gt; (<span class="stringliteral">&quot;Error&quot;</span>);
<a name="l00227"></a>00227   error_system.<a class="code" href="classlibMesh_1_1System.php#a9455625733b8137030b388772b094817">add_variable</a>(<span class="stringliteral">&quot;e&quot;</span>, <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>, <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>);
<a name="l00228"></a>00228   temp_es.<a class="code" href="classlibMesh_1_1EquationSystems.php#aa79320b68e236ece82d5b358721ebd13">init</a>();
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; error_dof_map = error_system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     =
<a name="l00233"></a>00233     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00234"></a>00234   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00235"></a>00235     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00236"></a>00236   std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00239"></a>00239   {
<a name="l00240"></a>00240     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00241"></a>00241 
<a name="l00242"></a>00242     error_dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a>(elem, dof_indices);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#ab69c0b5b064ef16daf3f46102d138efa">elem_id</a> = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00245"></a>00245 
<a name="l00246"></a>00246     <span class="comment">//0 for the monomial basis</span>
<a name="l00247"></a>00247     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> solution_index = dof_indices[0];
<a name="l00248"></a>00248     <span class="comment">// libMesh::out &lt;&lt; &quot;elem_number=&quot; &lt;&lt; elem_number &lt;&lt; std::endl;</span>
<a name="l00249"></a>00249     libmesh_assert (elem_id &lt; (*this).size());
<a name="l00250"></a>00250 <span class="comment">//  We may have zero error values in special circumstances</span>
<a name="l00251"></a>00251 <span class="comment">//    libmesh_assert ((*this)[elem_id] &gt; 0.);</span>
<a name="l00252"></a>00252     error_system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;set(solution_index, (*<span class="keyword">this</span>)[elem_id]);
<a name="l00253"></a>00253   }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="keywordflow">if</span> (filename.rfind(<span class="stringliteral">&quot;.gmv&quot;</span>) &lt; filename.size())
<a name="l00256"></a>00256     {
<a name="l00257"></a>00257 <span class="comment">//      GMVIO(mesh).write_equation_systems(filename,</span>
<a name="l00258"></a>00258 <span class="comment">//                                         temp_es);</span>
<a name="l00259"></a>00259 <span class="comment">// write_discontinuous_gmv doesn&#39;t work on second order meshes??</span>
<a name="l00260"></a>00260 <span class="comment">// [RHS]</span>
<a name="l00261"></a>00261       <a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a>(mesh).<a class="code" href="classlibMesh_1_1GMVIO.php#a2b09c1b2f977d1a259fc4f56a5754484">write_discontinuous_gmv</a>(filename,
<a name="l00262"></a>00262                                           temp_es, <span class="keyword">false</span>);
<a name="l00263"></a>00263     }
<a name="l00264"></a>00264   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (filename.rfind(<span class="stringliteral">&quot;.plt&quot;</span>) &lt; filename.size())
<a name="l00265"></a>00265     {
<a name="l00266"></a>00266       <a class="code" href="classlibMesh_1_1TecplotIO.php">TecplotIO</a> (mesh).<a class="code" href="classlibMesh_1_1MeshOutput.php#a935598198649f4b831cd341ce91b3ccb">write_equation_systems</a>
<a name="l00267"></a>00267         (filename, temp_es);
<a name="l00268"></a>00268     }
<a name="l00269"></a>00269   <span class="keywordflow">else</span>
<a name="l00270"></a>00270     {
<a name="l00271"></a>00271       libmesh_here();
<a name="l00272"></a>00272       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Warning: ErrorVector::plot_error currently only&quot;</span>
<a name="l00273"></a>00273                     &lt;&lt; <span class="stringliteral">&quot; supports .gmv and .plt output;&quot;</span> &lt;&lt; std::endl;
<a name="l00274"></a>00274       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Could not recognize filename: &quot;</span> &lt;&lt; filename
<a name="l00275"></a>00275                     &lt;&lt; std::endl;
<a name="l00276"></a>00276     }
<a name="l00277"></a>00277 }
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 } <span class="comment">// namespace libMesh</span>
<a name="l00280"></a>00280 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
