<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">error_vector.h</div>  </div>
</div>
<div class="contents">
<a href="error__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: error_vector.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __error_vector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __error_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="statistics_8h.php">statistics.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Now defined in libmesh_common.h:</span>
<a name="l00034"></a>00034 <span class="comment">// typedef float ErrorVectorReal;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span>MeshBase;
<a name="l00038"></a>00038 <span class="keyword">class </span>Mesh;
<a name="l00039"></a>00039 
<a name="l00053"></a><a class="code" href="classlibMesh_1_1ErrorVector.php">00053</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector</a>&lt;ErrorVectorReal&gt;
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   
<a name="l00056"></a>00056 <span class="keyword">public</span>:
<a name="l00057"></a>00057   
<a name="l00066"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#a484c3ee5eeb6ae0bf67c28fd0b199602">00066</a>   <a class="code" href="classlibMesh_1_1ErrorVector.php#a484c3ee5eeb6ae0bf67c28fd0b199602">ErrorVector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> *<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = NULL) : <a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector</a>&lt;<a class="code" href="namespacelibMesh.php#a26acf05f075521cbfb223db57e63d6d0">ErrorVectorReal</a>&gt; (i), <a class="code" href="classlibMesh_1_1ErrorVector.php#a7471cc33c975107bda15c785bfc9c701">_mesh</a>(<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) {}
<a name="l00067"></a>00067   
<a name="l00076"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#aa91986a6027a7364b65aa1d5fdab1435">00076</a>   <a class="code" href="classlibMesh_1_1ErrorVector.php#a484c3ee5eeb6ae0bf67c28fd0b199602">ErrorVector</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <a class="code" href="namespacelibMesh.php#a26acf05f075521cbfb223db57e63d6d0">ErrorVectorReal</a> val) :
<a name="l00077"></a>00077       <a class="code" href="classlibMesh_1_1StatisticsVector.php">StatisticsVector</a>&lt;<a class="code" href="namespacelibMesh.php#a26acf05f075521cbfb223db57e63d6d0">ErrorVectorReal</a>&gt; (i,val) {}
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#a26acf05f075521cbfb223db57e63d6d0">ErrorVectorReal</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#ae53298fa11ee8858e287ee25f065b46b">minimum</a>() <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#ada7e2f1c0df0e837d6e6f18cf5f56077">mean</a>() <span class="keyword">const</span>;
<a name="l00089"></a>00089   
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#aab627b905d6c7f2dfe23b37ff72b4df3">median</a>();
<a name="l00099"></a>00099 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#aab627b905d6c7f2dfe23b37ff72b4df3">median</a>() <span class="keyword">const</span>;
<a name="l00106"></a>00106 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#a961787a0534b54e9debd9a110d315f50">00117</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#a961787a0534b54e9debd9a110d315f50">variance</a>()<span class="keyword"> const</span>
<a name="l00118"></a>00118 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1ErrorVector.php#a961787a0534b54e9debd9a110d315f50">variance</a>(this-&gt;<a class="code" href="classlibMesh_1_1ErrorVector.php#ada7e2f1c0df0e837d6e6f18cf5f56077">mean</a>()); }
<a name="l00119"></a>00119 
<a name="l00131"></a>00131   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#a961787a0534b54e9debd9a110d315f50">variance</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ErrorVector.php#ada7e2f1c0df0e837d6e6f18cf5f56077">mean</a>) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00138"></a>00138   <span class="keyword">virtual</span> std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1ErrorVector.php#aef82ea17852e473e9e4df80783019d89">cut_below</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cut) <span class="keyword">const</span>;
<a name="l00139"></a>00139 
<a name="l00145"></a>00145   <span class="keyword">virtual</span> std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1ErrorVector.php#a16077569ce6da661f2df0859c5539a73">cut_above</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cut) <span class="keyword">const</span>;
<a name="l00146"></a>00146 
<a name="l00152"></a>00152   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ErrorVector.php#af42a70293b724817dd9c282642eb354c">plot_error</a>(<span class="keyword">const</span> std::string &amp;filename,
<a name="l00153"></a>00153                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) <span class="keyword">const</span>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="keyword">protected</span>:
<a name="l00159"></a>00159   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ErrorVector.php#a4680ee362a30f5df3c83ff6cb669a0fe">is_active_elem</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00160"></a>00160 
<a name="l00165"></a><a class="code" href="classlibMesh_1_1ErrorVector.php#a7471cc33c975107bda15c785bfc9c701">00165</a>   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> *<a class="code" href="classlibMesh_1_1ErrorVector.php#a7471cc33c975107bda15c785bfc9c701">_mesh</a>;
<a name="l00166"></a>00166 };
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 } <span class="comment">// namespace libMesh</span>
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#endif</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
