<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">euler2_solver.C</div>  </div>
</div>
<div class="contents">
<a href="euler2__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: euler2_solver.C 4015 2010-10-01 21:03:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="euler2__solver_8h.php">euler2_solver.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">namespace </span>libMesh
<a name="l00025"></a>00025 {
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="classlibMesh_1_1Euler2Solver.php#a2542c776f774adaba9a5a2259a01589e">00029</a> <a class="code" href="classlibMesh_1_1Euler2Solver.php#a2542c776f774adaba9a5a2259a01589e">Euler2Solver::Euler2Solver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00030"></a>00030  : <a class="code" href="classlibMesh_1_1UnsteadySolver.php">UnsteadySolver</a>(s), theta(1.)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 }
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a><a class="code" href="classlibMesh_1_1Euler2Solver.php#a207bf59a179fd9f3d51df95755acc03f">00036</a> <a class="code" href="classlibMesh_1_1Euler2Solver.php#a207bf59a179fd9f3d51df95755acc03f">Euler2Solver::~Euler2Solver</a> ()
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classlibMesh_1_1Euler2Solver.php#a0e78267568ceed90d11f5e2e62a75669">00042</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Euler2Solver.php#a0e78267568ceed90d11f5e2e62a75669">Euler2Solver::error_order</a>()<span class="keyword"> const</span>
<a name="l00043"></a>00043 <span class="keyword"></span>{
<a name="l00044"></a>00044   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a> == 0.5)
<a name="l00045"></a>00045     <span class="keywordflow">return</span> 2.;
<a name="l00046"></a>00046   <span class="keywordflow">return</span> 1.;
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1Euler2Solver.php#abcfe33a084a5a0f538c73dcd16f9f877">00052</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Euler2Solver.php#abcfe33a084a5a0f538c73dcd16f9f877">Euler2Solver::element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00053"></a>00053                                      <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;context)
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>();
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">// Local nonlinear solution at old timestep</span>
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_elem_solution(n_dofs);
<a name="l00059"></a>00059   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00060"></a>00060     old_elem_solution(i) =
<a name="l00061"></a>00061       <a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[i]);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// We evaluate mass_residual with the change in solution</span>
<a name="l00064"></a>00064   <span class="comment">// to get the mass matrix, reusing old_elem_solution to hold that</span>
<a name="l00065"></a>00065   <span class="comment">// delta_solution.</span>
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> delta_elem_solution(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>);
<a name="l00067"></a>00067   delta_elem_solution -= old_elem_solution;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">// Our first evaluations are at the true elem_solution</span>
<a name="l00070"></a>00070   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a> = 1.0;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">// If a fixed solution is requested, we&#39;ll use the elem_solution</span>
<a name="l00073"></a>00073   <span class="comment">// at the new timestep</span>
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00075"></a>00075     context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">elem_fixed_solution</a> = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">fixed_solution_derivative</a> = 1.0;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="comment">// We&#39;re going to compute just the change in elem_residual</span>
<a name="l00080"></a>00080   <span class="comment">// (and possibly elem_jacobian), then add back the old values</span>
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> total_elem_residual(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>);
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_elem_jacobian, total_elem_jacobian;
<a name="l00083"></a>00083   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00084"></a>00084     {
<a name="l00085"></a>00085       old_elem_jacobian = context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00086"></a>00086       total_elem_jacobian = context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00087"></a>00087       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00088"></a>00088     }
<a name="l00089"></a>00089   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">// First, evaluate time derivative at the new timestep.</span>
<a name="l00092"></a>00092   <span class="comment">// The element should already be in the proper place</span>
<a name="l00093"></a>00093   <span class="comment">// even for a moving mesh problem.</span>
<a name="l00094"></a>00094   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00095"></a>00095     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0e74f65c812202ed8109767105c7321b">element_time_derivative</a>(request_jacobian, context);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="comment">// For a moving mesh problem we may need the pseudoconvection term too</span>
<a name="l00098"></a>00098   jacobian_computed =
<a name="l00099"></a>00099     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a3fd9c4341b2bd346bdd89c0e04b570ac">eulerian_residual</a>(jacobian_computed, context) &amp;&amp; jacobian_computed;
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="comment">// Scale the new time-dependent residual and jacobian correctly</span>
<a name="l00102"></a>00102   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= (<a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a> * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00103"></a>00103   total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00104"></a>00104   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00107"></a>00107     {
<a name="l00108"></a>00108       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= (<a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a> * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00109"></a>00109       total_elem_jacobian += context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00110"></a>00110       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00111"></a>00111     }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="comment">// Next, evaluate the mass residual at the new timestep,</span>
<a name="l00114"></a>00114   <span class="comment">// with the delta_solution.</span>
<a name="l00115"></a>00115   <span class="comment">// Evaluating the mass residual at both old and new timesteps will be</span>
<a name="l00116"></a>00116   <span class="comment">// redundant in most problems but may be necessary for time accuracy</span>
<a name="l00117"></a>00117   <span class="comment">// or stability in moving mesh problems or problems with user-overridden</span>
<a name="l00118"></a>00118   <span class="comment">// mass_residual functions</span>
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">// Move elem_-&gt;delta_, delta_-&gt;elem_</span>
<a name="l00121"></a>00121   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(delta_elem_solution);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   jacobian_computed = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a742491345d88358ef03a9fddbdb18920">mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00124"></a>00124     jacobian_computed;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= -<a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>;
<a name="l00127"></a>00127   total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00128"></a>00128   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00131"></a>00131     {
<a name="l00132"></a>00132       <span class="comment">// The minus sign trick here is to avoid using a non-1</span>
<a name="l00133"></a>00133       <span class="comment">// elem_solution_derivative:</span>
<a name="l00134"></a>00134       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= -<a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>;
<a name="l00135"></a>00135       total_elem_jacobian += context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00136"></a>00136       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00137"></a>00137     }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// Add the time-dependent term for the old solution</span>
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">// Make sure elem_solution is set up for elem_reinit to use</span>
<a name="l00142"></a>00142   <span class="comment">// Move delta_-&gt;old_, old_-&gt;elem_</span>
<a name="l00143"></a>00143   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(old_elem_solution);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="comment">// Move the mesh into place first if necessary</span>
<a name="l00146"></a>00146   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a45af196d72b6798323b0af96ca68cb2b">elem_reinit</a>(0.);
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00149"></a>00149     {
<a name="l00150"></a>00150       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a> = 0.0;
<a name="l00151"></a>00151       jacobian_computed =
<a name="l00152"></a>00152         <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0e74f65c812202ed8109767105c7321b">element_time_derivative</a>(jacobian_computed, context) &amp;&amp;
<a name="l00153"></a>00153         jacobian_computed;
<a name="l00154"></a>00154       jacobian_computed = 
<a name="l00155"></a>00155         <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a3fd9c4341b2bd346bdd89c0e04b570ac">eulerian_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00156"></a>00156         jacobian_computed;
<a name="l00157"></a>00157       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a> = 1.0;
<a name="l00158"></a>00158       context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= ((1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>) * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00159"></a>00159       total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00160"></a>00160       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00161"></a>00161         {
<a name="l00162"></a>00162           context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= ((1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>) * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00163"></a>00163           total_elem_jacobian += context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00164"></a>00164           context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00165"></a>00165         }
<a name="l00166"></a>00166     }
<a name="l00167"></a>00167   <span class="keywordflow">else</span>
<a name="l00168"></a>00168     {
<a name="l00169"></a>00169       <span class="comment">// FIXME - we should detect if element_time_derivative() edits</span>
<a name="l00170"></a>00170       <span class="comment">// elem_jacobian and lies about it!</span>
<a name="l00171"></a>00171       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0e74f65c812202ed8109767105c7321b">element_time_derivative</a>(<span class="keyword">false</span>, context);
<a name="l00172"></a>00172       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a3fd9c4341b2bd346bdd89c0e04b570ac">eulerian_residual</a>(<span class="keyword">false</span>, context);
<a name="l00173"></a>00173       context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= ((1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>) * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00174"></a>00174       total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00175"></a>00175     }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">// Add the mass residual term for the old solution</span>
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   <span class="comment">// Move old_-&gt;old_, delta_-&gt;elem_</span>
<a name="l00182"></a>00182   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(old_elem_solution);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   jacobian_computed = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a742491345d88358ef03a9fddbdb18920">mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00185"></a>00185     jacobian_computed;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= -(1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>);
<a name="l00188"></a>00188   total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00189"></a>00189   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00192"></a>00192     {
<a name="l00193"></a>00193       <span class="comment">// The minus sign trick here is to avoid using a non-1</span>
<a name="l00194"></a>00194       <span class="comment">// *_solution_derivative:</span>
<a name="l00195"></a>00195       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= -(1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>);
<a name="l00196"></a>00196       total_elem_jacobian += context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00197"></a>00197       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00198"></a>00198     }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="comment">// Restore the elem_solution</span>
<a name="l00201"></a>00201   <span class="comment">// Move elem_-&gt;elem_, delta_-&gt;delta_</span>
<a name="l00202"></a>00202   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(delta_elem_solution);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <span class="comment">// Restore the elem position if necessary</span>
<a name="l00205"></a>00205   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a45af196d72b6798323b0af96ca68cb2b">elem_reinit</a>(1.);
<a name="l00206"></a>00206 
<a name="l00207"></a>00207   <span class="comment">// Add the constraint term</span>
<a name="l00208"></a>00208   jacobian_computed = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#acf8f44832ec07639d55b1688787c80d0">element_constraint</a>(jacobian_computed, context) &amp;&amp;
<a name="l00209"></a>00209     jacobian_computed;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="comment">// Add back the previously accumulated residual and jacobian</span>
<a name="l00212"></a>00212   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> += total_elem_residual;
<a name="l00213"></a>00213   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00214"></a>00214     {
<a name="l00215"></a>00215       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00216"></a>00216         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> += total_elem_jacobian;
<a name="l00217"></a>00217       <span class="keywordflow">else</span>
<a name="l00218"></a>00218         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">swap</a>(old_elem_jacobian);
<a name="l00219"></a>00219     }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   <span class="keywordflow">return</span> jacobian_computed;
<a name="l00222"></a>00222 }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a><a class="code" href="classlibMesh_1_1Euler2Solver.php#ad5be6675d22bf35ed58b6c86645221c7">00226</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Euler2Solver.php#ad5be6675d22bf35ed58b6c86645221c7">Euler2Solver::side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00227"></a>00227                                   <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;context)
<a name="l00228"></a>00228 {
<a name="l00229"></a>00229   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>();
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <span class="comment">// Local nonlinear solution at old timestep</span>
<a name="l00232"></a>00232   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_elem_solution(n_dofs);
<a name="l00233"></a>00233   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00234"></a>00234     old_elem_solution(i) =
<a name="l00235"></a>00235       <a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[i]);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   <span class="comment">// We evaluate mass_residual with the change in solution</span>
<a name="l00238"></a>00238   <span class="comment">// to get the mass matrix, reusing old_elem_solution to hold that</span>
<a name="l00239"></a>00239   <span class="comment">// delta_solution.</span>
<a name="l00240"></a>00240   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> delta_elem_solution(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>);
<a name="l00241"></a>00241   delta_elem_solution -= old_elem_solution;
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   <span class="comment">// Our first evaluations are at the true elem_solution</span>
<a name="l00244"></a>00244   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a> = 1.0;
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <span class="comment">// If a fixed solution is requested, we&#39;ll use the elem_solution</span>
<a name="l00247"></a>00247   <span class="comment">// at the new timestep</span>
<a name="l00248"></a>00248   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00249"></a>00249     context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">elem_fixed_solution</a> = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>;
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">fixed_solution_derivative</a> = 1.0;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">// We&#39;re going to compute just the change in elem_residual</span>
<a name="l00254"></a>00254   <span class="comment">// (and possibly elem_jacobian), then add back the old values</span>
<a name="l00255"></a>00255   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> total_elem_residual(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>);
<a name="l00256"></a>00256   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_elem_jacobian, total_elem_jacobian;
<a name="l00257"></a>00257   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00258"></a>00258     {
<a name="l00259"></a>00259       old_elem_jacobian = context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00260"></a>00260       total_elem_jacobian = context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00261"></a>00261       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00262"></a>00262     }
<a name="l00263"></a>00263   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <span class="comment">// First, evaluate time derivative at the new timestep.</span>
<a name="l00266"></a>00266   <span class="comment">// The element should already be in the proper place</span>
<a name="l00267"></a>00267   <span class="comment">// even for a moving mesh problem.</span>
<a name="l00268"></a>00268   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00269"></a>00269     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a47fff9592eebfc5014c9d83405dc42a6">side_time_derivative</a>(request_jacobian, context);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">// Scale the time-dependent residual and jacobian correctly</span>
<a name="l00272"></a>00272   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= (<a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a> * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00273"></a>00273   total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00274"></a>00274   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00275"></a>00275 
<a name="l00276"></a>00276   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00277"></a>00277     {
<a name="l00278"></a>00278       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= (<a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a> * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00279"></a>00279       total_elem_jacobian += context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00280"></a>00280       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00281"></a>00281     }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   <span class="comment">// Next, evaluate the mass residual at the new timestep,</span>
<a name="l00284"></a>00284   <span class="comment">// with the delta_solution.</span>
<a name="l00285"></a>00285   <span class="comment">// Evaluating the mass residual at both old and new timesteps will be</span>
<a name="l00286"></a>00286   <span class="comment">// redundant in most problems but may be necessary for time accuracy</span>
<a name="l00287"></a>00287   <span class="comment">// or stability in moving mesh problems or problems with user-overridden</span>
<a name="l00288"></a>00288   <span class="comment">// mass_residual functions</span>
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="comment">// Move elem_-&gt;delta_, delta_-&gt;elem_</span>
<a name="l00291"></a>00291   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(delta_elem_solution);
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   jacobian_computed = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a805cab2a7e7feb6226a04029d882e9e8">side_mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00294"></a>00294     jacobian_computed;
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= -<a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>;
<a name="l00297"></a>00297   total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00298"></a>00298   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00301"></a>00301     {
<a name="l00302"></a>00302       <span class="comment">// The minus sign trick here is to avoid using a non-1</span>
<a name="l00303"></a>00303       <span class="comment">// elem_solution_derivative:</span>
<a name="l00304"></a>00304       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= -<a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>;
<a name="l00305"></a>00305       total_elem_jacobian += context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00306"></a>00306       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00307"></a>00307     }
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <span class="comment">// Add the time-dependent term for the old solution</span>
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <span class="comment">// Make sure elem_solution is set up for elem_reinit to use</span>
<a name="l00312"></a>00312   <span class="comment">// Move delta_-&gt;old_, old_-&gt;elem_</span>
<a name="l00313"></a>00313   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(old_elem_solution);
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="comment">// Move the mesh into place first if necessary</span>
<a name="l00316"></a>00316   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a4a9862bec36617be5fd2f6c0290d0c52">elem_side_reinit</a>(0.);
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00319"></a>00319     {
<a name="l00320"></a>00320       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a> = 0.0;
<a name="l00321"></a>00321       jacobian_computed = 
<a name="l00322"></a>00322         <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a47fff9592eebfc5014c9d83405dc42a6">side_time_derivative</a>(jacobian_computed, context) &amp;&amp;
<a name="l00323"></a>00323           jacobian_computed;
<a name="l00324"></a>00324       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a> = 1.0;
<a name="l00325"></a>00325       context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= ((1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>) * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00326"></a>00326       total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00327"></a>00327       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00328"></a>00328         {
<a name="l00329"></a>00329           context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= ((1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>) * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00330"></a>00330           total_elem_jacobian += context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00331"></a>00331           context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00332"></a>00332         }
<a name="l00333"></a>00333     }
<a name="l00334"></a>00334   <span class="keywordflow">else</span>
<a name="l00335"></a>00335     {
<a name="l00336"></a>00336       <span class="comment">// FIXME - we should detect if side_time_derivative() edits</span>
<a name="l00337"></a>00337       <span class="comment">// elem_jacobian and lies about it!</span>
<a name="l00338"></a>00338       <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a47fff9592eebfc5014c9d83405dc42a6">side_time_derivative</a>(<span class="keyword">false</span>, context);
<a name="l00339"></a>00339       context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= ((1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>) * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00340"></a>00340       total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00341"></a>00341     }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="comment">// Add the mass residual term for the old solution</span>
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   <span class="comment">// Move old_-&gt;old_, delta_-&gt;elem_</span>
<a name="l00348"></a>00348   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(old_elem_solution);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   jacobian_computed = 
<a name="l00351"></a>00351     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a805cab2a7e7feb6226a04029d882e9e8">side_mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00352"></a>00352       jacobian_computed;
<a name="l00353"></a>00353 
<a name="l00354"></a>00354   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= -(1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>);
<a name="l00355"></a>00355   total_elem_residual += context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00356"></a>00356   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00357"></a>00357 
<a name="l00358"></a>00358   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00359"></a>00359     {
<a name="l00360"></a>00360       <span class="comment">// The minus sign trick here is to avoid using a non-1</span>
<a name="l00361"></a>00361       <span class="comment">// *_solution_derivative:</span>
<a name="l00362"></a>00362       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= -(1. - <a class="code" href="classlibMesh_1_1Euler2Solver.php#a3cfbca143c3020eaed8cfb8dd4eaddfd">theta</a>);
<a name="l00363"></a>00363       total_elem_jacobian += context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00364"></a>00364       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00365"></a>00365     }
<a name="l00366"></a>00366 
<a name="l00367"></a>00367   <span class="comment">// Restore the elem_solution</span>
<a name="l00368"></a>00368   <span class="comment">// Move elem_-&gt;elem_, delta_-&gt;delta_</span>
<a name="l00369"></a>00369   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(delta_elem_solution);
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <span class="comment">// Restore the elem position if necessary</span>
<a name="l00372"></a>00372   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a4a9862bec36617be5fd2f6c0290d0c52">elem_side_reinit</a>(1.);
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="comment">// Add the constraint term</span>
<a name="l00375"></a>00375   jacobian_computed = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aa70056a38d864596769ef8382ba1e9d8">side_constraint</a>(jacobian_computed, context) &amp;&amp;
<a name="l00376"></a>00376     jacobian_computed;
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   <span class="comment">// Add back the previously accumulated residual and jacobian</span>
<a name="l00379"></a>00379   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> += total_elem_residual;
<a name="l00380"></a>00380   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00381"></a>00381     {
<a name="l00382"></a>00382       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00383"></a>00383         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> += total_elem_jacobian;
<a name="l00384"></a>00384       <span class="keywordflow">else</span>
<a name="l00385"></a>00385         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">swap</a>(old_elem_jacobian);
<a name="l00386"></a>00386     }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="keywordflow">return</span> jacobian_computed;
<a name="l00389"></a>00389 }
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
