<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">euler_solver.C</div>  </div>
</div>
<div class="contents">
<a href="euler__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: euler_solver.C 4015 2010-10-01 21:03:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="euler__solver_8h.php">euler_solver.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="keyword">namespace </span>libMesh
<a name="l00025"></a>00025 {
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a><a class="code" href="classlibMesh_1_1EulerSolver.php#ab7e12b4fc56fd7082bb602cd6fbfe963">00029</a> <a class="code" href="classlibMesh_1_1EulerSolver.php#ab7e12b4fc56fd7082bb602cd6fbfe963">EulerSolver::EulerSolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s)
<a name="l00030"></a>00030  : <a class="code" href="classlibMesh_1_1UnsteadySolver.php">UnsteadySolver</a>(s), theta(1.)
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 }
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a><a class="code" href="classlibMesh_1_1EulerSolver.php#a08d2a14b4e50e73e86116672d2c22a34">00036</a> <a class="code" href="classlibMesh_1_1EulerSolver.php#a08d2a14b4e50e73e86116672d2c22a34">EulerSolver::~EulerSolver</a> ()
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classlibMesh_1_1EulerSolver.php#a1ba0f901fa78b251bb3198f70324557d">00042</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EulerSolver.php#a1ba0f901fa78b251bb3198f70324557d">EulerSolver::error_order</a>()<span class="keyword"> const</span>
<a name="l00043"></a>00043 <span class="keyword"></span>{
<a name="l00044"></a>00044   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a> == 0.5)
<a name="l00045"></a>00045     <span class="keywordflow">return</span> 2.;
<a name="l00046"></a>00046   <span class="keywordflow">return</span> 1.;
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1EulerSolver.php#a23da82d364c7983b7d021326f2777647">00052</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EulerSolver.php#a23da82d364c7983b7d021326f2777647">EulerSolver::element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00053"></a>00053                                     <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;context)
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>();
<a name="l00056"></a>00056 
<a name="l00057"></a>00057   <span class="comment">// Local nonlinear solution at old timestep</span>
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_elem_solution(n_dofs);
<a name="l00059"></a>00059   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00060"></a>00060     old_elem_solution(i) =
<a name="l00061"></a>00061       <a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[i]);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// Local nonlinear solution at time t_theta</span>
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> theta_solution(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>);
<a name="l00065"></a>00065   theta_solution *= <a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a>;
<a name="l00066"></a>00066   theta_solution.<a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">add</a>(1. - <a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a>, old_elem_solution);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">// Technically the elem_solution_derivative is either theta</span>
<a name="l00069"></a>00069   <span class="comment">// or -1.0 in this implementation, but we scale the former part</span>
<a name="l00070"></a>00070   <span class="comment">// ourselves</span>
<a name="l00071"></a>00071   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a> = 1.0;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 <span class="comment">// Technically the fixed_solution_derivative is always theta,</span>
<a name="l00074"></a>00074 <span class="comment">// but we&#39;re scaling a whole jacobian by theta after these first</span>
<a name="l00075"></a>00075 <span class="comment">// evaluations</span>
<a name="l00076"></a>00076   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">fixed_solution_derivative</a> = 1.0;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// If a fixed solution is requested, we&#39;ll use theta_solution</span>
<a name="l00079"></a>00079   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00080"></a>00080     context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">elem_fixed_solution</a> = theta_solution;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// Move theta_-&gt;elem_, elem_-&gt;theta_</span>
<a name="l00083"></a>00083   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(theta_solution);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// Move the mesh into place first if necessary</span>
<a name="l00086"></a>00086   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a45af196d72b6798323b0af96ca68cb2b">elem_reinit</a>(<a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a>);
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="comment">// We&#39;re going to compute just the change in elem_residual</span>
<a name="l00089"></a>00089   <span class="comment">// (and possibly elem_jacobian), then add back the old values</span>
<a name="l00090"></a>00090   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_elem_residual(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>);
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_elem_jacobian;
<a name="l00092"></a>00092   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00093"></a>00093     {
<a name="l00094"></a>00094       old_elem_jacobian = context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00095"></a>00095       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00096"></a>00096     }
<a name="l00097"></a>00097   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="comment">// Get the time derivative at t_theta</span>
<a name="l00100"></a>00100   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00101"></a>00101     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0e74f65c812202ed8109767105c7321b">element_time_derivative</a>(request_jacobian, context);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="comment">// For a moving mesh problem we may need the pseudoconvection term too</span>
<a name="l00104"></a>00104   jacobian_computed =
<a name="l00105"></a>00105     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a3fd9c4341b2bd346bdd89c0e04b570ac">eulerian_residual</a>(jacobian_computed, context) &amp;&amp; jacobian_computed;
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="comment">// Scale the time-dependent residual and jacobian correctly</span>
<a name="l00108"></a>00108   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>;
<a name="l00109"></a>00109   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00110"></a>00110     context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= (<a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a> * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="comment">// The fixed_solution_derivative is always theta,</span>
<a name="l00113"></a>00113   <span class="comment">// and now we&#39;re done scaling jacobians</span>
<a name="l00114"></a>00114   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">fixed_solution_derivative</a> = <a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a>;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="comment">// We evaluate mass_residual with the change in solution</span>
<a name="l00117"></a>00117   <span class="comment">// to get the mass matrix, reusing old_elem_solution to hold that</span>
<a name="l00118"></a>00118   <span class="comment">// delta_solution.  We&#39;re solving dt*F(u) - du = 0, so our</span>
<a name="l00119"></a>00119   <span class="comment">// delta_solution is old_solution - new_solution.</span>
<a name="l00120"></a>00120   <span class="comment">// We&#39;re still keeping elem_solution in theta_solution for now</span>
<a name="l00121"></a>00121   old_elem_solution -= theta_solution;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">// Move old_-&gt;elem_, theta_-&gt;old_</span>
<a name="l00124"></a>00124   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(old_elem_solution);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// We do a trick here to avoid using a non-1</span>
<a name="l00127"></a>00127   <span class="comment">// elem_solution_derivative:</span>
<a name="l00128"></a>00128   context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= -1.0;
<a name="l00129"></a>00129   jacobian_computed = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a742491345d88358ef03a9fddbdb18920">mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00130"></a>00130     jacobian_computed;
<a name="l00131"></a>00131   context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= -1.0;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="comment">// Move elem_-&gt;elem_, old_-&gt;theta_</span>
<a name="l00134"></a>00134   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(theta_solution);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="comment">// Restore the elem position if necessary</span>
<a name="l00137"></a>00137   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a45af196d72b6798323b0af96ca68cb2b">elem_reinit</a>(1.);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="comment">// Add the constraint term</span>
<a name="l00140"></a>00140   jacobian_computed = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#acf8f44832ec07639d55b1688787c80d0">element_constraint</a>(jacobian_computed, context) &amp;&amp;
<a name="l00141"></a>00141     jacobian_computed;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="comment">// Add back the old residual and jacobian</span>
<a name="l00144"></a>00144   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> += old_elem_residual;
<a name="l00145"></a>00145   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00146"></a>00146     {
<a name="l00147"></a>00147       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00148"></a>00148         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> += old_elem_jacobian;
<a name="l00149"></a>00149       <span class="keywordflow">else</span>
<a name="l00150"></a>00150         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">swap</a>(old_elem_jacobian);
<a name="l00151"></a>00151     }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="keywordflow">return</span> jacobian_computed;
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a><a class="code" href="classlibMesh_1_1EulerSolver.php#ab0117d2de81ee54d3c8dd15045ea394a">00158</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EulerSolver.php#ab0117d2de81ee54d3c8dd15045ea394a">EulerSolver::side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00159"></a>00159                                  <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;context)
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>();
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="comment">// Local nonlinear solution at old timestep</span>
<a name="l00164"></a>00164   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_elem_solution(n_dofs);
<a name="l00165"></a>00165   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00166"></a>00166     old_elem_solution(i) =
<a name="l00167"></a>00167       <a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[i]);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="comment">// Local nonlinear solution at time t_theta</span>
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> theta_solution(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>);
<a name="l00171"></a>00171   theta_solution *= <a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a>;
<a name="l00172"></a>00172   theta_solution.<a class="code" href="classlibMesh_1_1DenseVector.php#ac131f04240149a0548e56a17adb7fb3f">add</a>(1. - <a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a>, old_elem_solution);
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="comment">// Technically the elem_solution_derivative is either theta</span>
<a name="l00175"></a>00175   <span class="comment">// or 1.0 in this implementation, but we scale the former part</span>
<a name="l00176"></a>00176   <span class="comment">// ourselves</span>
<a name="l00177"></a>00177   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a> = 1.0;
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="comment">// Technically the fixed_solution_derivative is always theta,</span>
<a name="l00180"></a>00180 <span class="comment">// but we&#39;re scaling a whole jacobian by theta after these first</span>
<a name="l00181"></a>00181 <span class="comment">// evaluations</span>
<a name="l00182"></a>00182   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">fixed_solution_derivative</a> = 1.0;
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">// If a fixed solution is requested, we&#39;ll use theta_solution</span>
<a name="l00185"></a>00185   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00186"></a>00186     context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">elem_fixed_solution</a> = theta_solution;
<a name="l00187"></a>00187 
<a name="l00188"></a>00188   <span class="comment">// Move theta_-&gt;elem_, elem_-&gt;theta_</span>
<a name="l00189"></a>00189   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(theta_solution);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <span class="comment">// Move the mesh into place first if necessary</span>
<a name="l00192"></a>00192   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a4a9862bec36617be5fd2f6c0290d0c52">elem_side_reinit</a>(<a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a>);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="comment">// We&#39;re going to compute just the change in elem_residual</span>
<a name="l00195"></a>00195   <span class="comment">// (and possibly elem_jacobian), then add back the old values</span>
<a name="l00196"></a>00196   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> old_elem_residual(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>);
<a name="l00197"></a>00197   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_elem_jacobian;
<a name="l00198"></a>00198   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00199"></a>00199     {
<a name="l00200"></a>00200       old_elem_jacobian = context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00201"></a>00201       context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00202"></a>00202     }
<a name="l00203"></a>00203   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="comment">// Get the time derivative at t_theta</span>
<a name="l00206"></a>00206   <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00207"></a>00207     <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a47fff9592eebfc5014c9d83405dc42a6">side_time_derivative</a>(request_jacobian, context);
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   <span class="comment">// Scale the time-dependent residual and jacobian correctly</span>
<a name="l00210"></a>00210   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> *= <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>;
<a name="l00211"></a>00211   <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00212"></a>00212     context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= (<a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a> * <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="comment">// The fixed_solution_derivative is always theta,</span>
<a name="l00215"></a>00215   <span class="comment">// and now we&#39;re done scaling jacobians</span>
<a name="l00216"></a>00216   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a9907d3920b7dc358aecb2ea8cc04eae9">fixed_solution_derivative</a> = <a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a>;
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   <span class="comment">// We evaluate side_mass_residual with the change in solution</span>
<a name="l00219"></a>00219   <span class="comment">// to get the mass matrix, reusing old_elem_solution to hold that</span>
<a name="l00220"></a>00220   <span class="comment">// delta_solution.  We&#39;re solving dt*F(u) - du = 0, so our</span>
<a name="l00221"></a>00221   <span class="comment">// delta_solution is old_solution - new_solution.</span>
<a name="l00222"></a>00222   <span class="comment">// We&#39;re still keeping elem_solution in theta_solution for now</span>
<a name="l00223"></a>00223   old_elem_solution -= theta_solution;
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="comment">// Move old_-&gt;elem_, theta_-&gt;old_</span>
<a name="l00226"></a>00226   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(old_elem_solution);
<a name="l00227"></a>00227 
<a name="l00228"></a>00228   <span class="comment">// We do a trick here to avoid using a non-1</span>
<a name="l00229"></a>00229   <span class="comment">// elem_solution_derivative:</span>
<a name="l00230"></a>00230   context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= -1.0;
<a name="l00231"></a>00231   jacobian_computed = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a805cab2a7e7feb6226a04029d882e9e8">side_mass_residual</a>(jacobian_computed, context) &amp;&amp;
<a name="l00232"></a>00232     jacobian_computed;
<a name="l00233"></a>00233   context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> *= -1.0;
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="comment">// Move elem_-&gt;elem_, old_-&gt;theta_</span>
<a name="l00236"></a>00236   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ada20ee66c59885ba336012f2cc38a85c">swap</a>(theta_solution);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="comment">// Restore the elem position if necessary</span>
<a name="l00239"></a>00239   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a4a9862bec36617be5fd2f6c0290d0c52">elem_side_reinit</a>(1.);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="comment">// Add the constraint term</span>
<a name="l00242"></a>00242   jacobian_computed = <a class="code" href="classlibMesh_1_1TimeSolver.php#a0cf14c8b81127d014c49c45d88dfaf46">_system</a>.<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aa70056a38d864596769ef8382ba1e9d8">side_constraint</a>(jacobian_computed, context) &amp;&amp;
<a name="l00243"></a>00243     jacobian_computed;
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <span class="comment">// Add back the old residual and jacobian</span>
<a name="l00246"></a>00246   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> += old_elem_residual;
<a name="l00247"></a>00247   <span class="keywordflow">if</span> (request_jacobian)
<a name="l00248"></a>00248     {
<a name="l00249"></a>00249       <span class="keywordflow">if</span> (jacobian_computed)
<a name="l00250"></a>00250         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> += old_elem_jacobian;
<a name="l00251"></a>00251       <span class="keywordflow">else</span>
<a name="l00252"></a>00252         context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">swap</a>(old_elem_jacobian);
<a name="l00253"></a>00253     }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="keywordflow">return</span> jacobian_computed;
<a name="l00256"></a>00256 }
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
