<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">euler_solver.h</div>  </div>
</div>
<div class="contents">
<a href="euler__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: euler_solver.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __euler_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __euler_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="unsteady__solver_8h.php">unsteady_solver.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// Solver class definition</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1EulerSolver.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1EulerSolver.php">EulerSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php">UnsteadySolver</a>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00053"></a><a class="code" href="classlibMesh_1_1EulerSolver.php#a32a99bafd0cbbb1cf2a132136f15022a">00053</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1UnsteadySolver.php">UnsteadySolver</a> <a class="code" href="classlibMesh_1_1EulerSolver.php#a32a99bafd0cbbb1cf2a132136f15022a">Parent</a>;
<a name="l00054"></a>00054   
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1EulerSolver.php#ab7e12b4fc56fd7082bb602cd6fbfe963">EulerSolver</a> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php">sys_type</a>&amp; s);
<a name="l00060"></a>00060   
<a name="l00064"></a>00064   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1EulerSolver.php#a08d2a14b4e50e73e86116672d2c22a34">~EulerSolver</a> ();
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EulerSolver.php#a1ba0f901fa78b251bb3198f70324557d">error_order</a>() <span class="keyword">const</span>;
<a name="l00070"></a>00070 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EulerSolver.php#a23da82d364c7983b7d021326f2777647">element_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00078"></a>00078                                  <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;);
<a name="l00079"></a>00079 
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1EulerSolver.php#ab0117d2de81ee54d3c8dd15045ea394a">side_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00087"></a>00087                               <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;);
<a name="l00088"></a>00088 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">00094</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1EulerSolver.php#ae29905251507f07320e41a9874bd09a5">theta</a>;
<a name="l00095"></a>00095 };
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 } <span class="comment">// namespace libMesh</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 <span class="preprocessor">#endif // #define __euler_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
