<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">exact_error_estimator.C</div>  </div>
</div>
<div class="contents">
<a href="exact__error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exact_error_estimator.C 4396 2011-04-22 17:01:44Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span>    <span class="comment">// for sqrt</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="exact__error__estimator_8h.php">exact_error_estimator.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="mesh__function_8h.php">mesh_function.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// ErrorEstimator implementations</span>
<a name="l00046"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a1da33abf36693e50e54f399a5d9402a2">00046</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#ac3be67d8a418f4e01db002d040b060c8">ExactErrorEstimator::attach_exact_value</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00047"></a>00047                                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00048"></a>00048                                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00049"></a>00049                                                           <span class="keyword">const</span> std::string&amp; unknown_name))
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051   libmesh_assert (fptr != NULL);
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a6fff092587d8f74f723f6a7e4870b176">_exact_value</a> = fptr;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="comment">// If we&#39;re not using a fine grid solution</span>
<a name="l00055"></a>00055   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a> = NULL;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a1370b2a09dc24d20650b2ec39cf6f76e">00060</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a1370b2a09dc24d20650b2ec39cf6f76e">ExactErrorEstimator::attach_exact_deriv</a> (<a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00061"></a>00061                                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00062"></a>00062                                                             <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00063"></a>00063                                                             <span class="keyword">const</span> std::string&amp; unknown_name))
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065   libmesh_assert (fptr != NULL);
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a4d746c50eb074e8320bfee64952e3720">_exact_deriv</a> = fptr;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">// If we&#39;re not using a fine grid solution</span>
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a> = NULL;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#af6d7d385e51667b24fad0fa9d3458d6b">00074</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#af6d7d385e51667b24fad0fa9d3458d6b">ExactErrorEstimator::attach_exact_hessian</a> (<a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00075"></a>00075                                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00076"></a>00076                                                             <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00077"></a>00077                                                             <span class="keyword">const</span> std::string&amp; unknown_name))
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   libmesh_assert (fptr != NULL);
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a11fdcee79b0c706b721c81a6b34af27b">_exact_hessian</a> = fptr;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// If we&#39;re not using a fine grid solution</span>
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a> = NULL;
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a82f73ce3ffbc338bd8197c2beee974a7">00086</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a82f73ce3ffbc338bd8197c2beee974a7">ExactErrorEstimator::attach_reference_solution</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>* es_fine)
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   libmesh_assert (es_fine != NULL);
<a name="l00089"></a>00089   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a> = es_fine;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091   <span class="comment">// If we&#39;re using a fine grid solution, we&#39;re not using exact values</span>
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a6fff092587d8f74f723f6a7e4870b176">_exact_value</a> = NULL;
<a name="l00093"></a>00093   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a4d746c50eb074e8320bfee64952e3720">_exact_deriv</a> = NULL;
<a name="l00094"></a>00094   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a11fdcee79b0c706b721c81a6b34af27b">_exact_hessian</a> = NULL;
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00098"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#aa7f6a8059086481cd6cf862e81ab9af0">00098</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#aa7f6a8059086481cd6cf862e81ab9af0">ExactErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00099"></a>00099                                           <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00100"></a>00100                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00101"></a>00101                                           <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00102"></a>00102 <span class="preprocessor">#else</span>
<a name="l00103"></a>00103 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#aa7f6a8059086481cd6cf862e81ab9af0">ExactErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00104"></a>00104                                           <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00105"></a>00105                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00106"></a>00106                                           <span class="keywordtype">bool</span> <span class="comment">/* estimate_parent_error */</span> )
<a name="l00107"></a>00107 <span class="preprocessor">#endif</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>{
<a name="l00109"></a>00109   <span class="comment">// The current mesh</span>
<a name="l00110"></a>00110   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="comment">// The dimensionality of the mesh</span>
<a name="l00113"></a>00113   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00114"></a>00114   
<a name="l00115"></a>00115   <span class="comment">// The number of variables in the system</span>
<a name="l00116"></a>00116   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00117"></a>00117   
<a name="l00118"></a>00118   <span class="comment">// The DofMap for this system</span>
<a name="l00119"></a>00119   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// Resize the error_per_cell vector to be</span>
<a name="l00122"></a>00122   <span class="comment">// the number of elements, initialize it to 0.</span>
<a name="l00123"></a>00123   error_per_cell.resize (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>());
<a name="l00124"></a>00124   std::fill (error_per_cell.begin(), error_per_cell.end(), 0.);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// Prepare current_local_solution to localize a non-standard</span>
<a name="l00127"></a>00127   <span class="comment">// solution vector if necessary</span>
<a name="l00128"></a>00128   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00131"></a>00131         <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00132"></a>00132       <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1System.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00133"></a>00133       newsol-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">swap</a>(*sys.solution);
<a name="l00134"></a>00134       sys.update();
<a name="l00135"></a>00135     }
<a name="l00136"></a>00136   
<a name="l00137"></a>00137   <span class="comment">// Loop over all the variables in the system</span>
<a name="l00138"></a>00138   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00139"></a>00139     {
<a name="l00140"></a>00140       <span class="comment">// Possibly skip this variable</span>
<a name="l00141"></a>00141       <span class="keywordflow">if</span> (error_norm.weight(var) == 0.0) <span class="keywordflow">continue</span>;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143       <span class="comment">// The (string) name of this variable</span>
<a name="l00144"></a>00144       <span class="keyword">const</span> std::string&amp; var_name = system.<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(var);
<a name="l00145"></a>00145       
<a name="l00146"></a>00146       <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00147"></a>00147       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a> (var);
<a name="l00148"></a>00148       
<a name="l00149"></a>00149       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a> (dim, fe_type));
<a name="l00150"></a>00150 
<a name="l00151"></a>00151       <span class="comment">// Build an appropriate Gaussian quadrature rule</span>
<a name="l00152"></a>00152       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> qrule =
<a name="l00153"></a>00153         fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a> (dim,
<a name="l00154"></a>00154                                          _extra_order);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156       fe-&gt;attach_quadrature_rule (qrule.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00157"></a>00157 
<a name="l00158"></a>00158       <span class="comment">// Prepare a global solution and a MeshFunction of the fine system if we need one</span>
<a name="l00159"></a>00159       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshFunction&gt;</a> fine_values;
<a name="l00160"></a>00160       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; fine_soln = <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;Number&gt;::build</a>();
<a name="l00161"></a>00161       <span class="keywordflow">if</span> (_equation_systems_fine)
<a name="l00162"></a>00162       {
<a name="l00163"></a>00163         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; fine_system = _equation_systems_fine-&gt;get_system(system.<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>());
<a name="l00164"></a>00164 
<a name="l00165"></a>00165         std::vector&lt;Number&gt; global_soln;
<a name="l00166"></a>00166         <span class="comment">// FIXME - we&#39;re assuming that the fine system solution gets</span>
<a name="l00167"></a>00167         <span class="comment">// used even when a different vector is used for the coarse</span>
<a name="l00168"></a>00168         <span class="comment">// system</span>
<a name="l00169"></a>00169         fine_system.<a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">update_global_solution</a>(global_soln);
<a name="l00170"></a>00170         fine_soln-&gt;init (global_soln.size(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00171"></a>00171         (*fine_soln) = global_soln;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173         fine_values = <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshFunction&gt;</a>
<a name="l00174"></a>00174           (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>(*_equation_systems_fine,
<a name="l00175"></a>00175                             *fine_soln,
<a name="l00176"></a>00176                             fine_system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>(),
<a name="l00177"></a>00177                             fine_system.<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(var_name)));
<a name="l00178"></a>00178         fine_values-&gt;init();
<a name="l00179"></a>00179       }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181       <span class="comment">// Request the data we&#39;ll need to compute with</span>
<a name="l00182"></a>00182       fe-&gt;get_JxW();
<a name="l00183"></a>00183       fe-&gt;get_phi();
<a name="l00184"></a>00184       fe-&gt;get_dphi();
<a name="l00185"></a>00185 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>      fe-&gt;get_d2phi();
<a name="l00187"></a>00187 <span class="preprocessor">#endif</span>
<a name="l00188"></a>00188 <span class="preprocessor"></span>      fe-&gt;get_xyz();
<a name="l00189"></a>00189 
<a name="l00190"></a>00190       <span class="comment">// If we compute on parent elements, we&#39;ll want to do so only</span>
<a name="l00191"></a>00191       <span class="comment">// once on each, so we need to keep track of which we&#39;ve done.</span>
<a name="l00192"></a>00192       std::vector&lt;bool&gt; computed_var_on_parent;
<a name="l00193"></a>00193       
<a name="l00194"></a>00194 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (estimate_parent_error)
<a name="l00196"></a>00196         computed_var_on_parent.resize(error_per_cell.size(), <span class="keyword">false</span>);
<a name="l00197"></a>00197 <span class="preprocessor">#endif</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>
<a name="l00199"></a>00199       <span class="comment">// TODO: this ought to be threaded (and using subordinate</span>
<a name="l00200"></a>00200       <span class="comment">// MeshFunction objects in each thread rather than a single</span>
<a name="l00201"></a>00201       <span class="comment">// master)</span>
<a name="l00202"></a>00202 
<a name="l00203"></a>00203       <span class="comment">// Iterate over all the active elements in the mesh</span>
<a name="l00204"></a>00204       <span class="comment">// that live on this processor.</span>
<a name="l00205"></a>00205       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l00206"></a>00206         elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00207"></a>00207       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l00208"></a>00208         elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210       <span class="keywordflow">for</span> (;elem_it != elem_end; ++elem_it)
<a name="l00211"></a>00211         {
<a name="l00212"></a>00212           <span class="comment">// e is necessarily an active element on the local processor</span>
<a name="l00213"></a>00213           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00214"></a>00214           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00217"></a>00217 <span class="preprocessor"></span>          <span class="comment">// See if the parent of element e has been examined yet;</span>
<a name="l00218"></a>00218           <span class="comment">// if not, we may want to compute the estimator on it</span>
<a name="l00219"></a>00219           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00220"></a>00220 
<a name="l00221"></a>00221           <span class="comment">// We only can compute and only need to compute on</span>
<a name="l00222"></a>00222           <span class="comment">// parents with all active children</span>
<a name="l00223"></a>00223           <span class="keywordtype">bool</span> compute_on_parent = <span class="keyword">true</span>;
<a name="l00224"></a>00224           <span class="keywordflow">if</span> (!parent || !estimate_parent_error)
<a name="l00225"></a>00225             compute_on_parent = <span class="keyword">false</span>;
<a name="l00226"></a>00226           <span class="keywordflow">else</span>
<a name="l00227"></a>00227             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l00228"></a>00228               <span class="keywordflow">if</span> (!parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00229"></a>00229                 compute_on_parent = <span class="keyword">false</span>;
<a name="l00230"></a>00230 
<a name="l00231"></a>00231           <span class="keywordflow">if</span> (compute_on_parent &amp;&amp;
<a name="l00232"></a>00232               !computed_var_on_parent[parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()])
<a name="l00233"></a>00233             {
<a name="l00234"></a>00234               computed_var_on_parent[parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = <span class="keyword">true</span>;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236               <span class="comment">// Compute a projection onto the parent</span>
<a name="l00237"></a>00237               <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> Uparent;
<a name="l00238"></a>00238               <a class="code" href="classlibMesh_1_1FEBase.php#a9e8a34c7c7dada421bcf88d5c9bc9a9e">FEBase::coarsened_dof_values</a>(*(system.<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>),
<a name="l00239"></a>00239                                            dof_map, parent, Uparent,
<a name="l00240"></a>00240                                            var, <span class="keyword">false</span>);
<a name="l00241"></a>00241 
<a name="l00242"></a>00242               error_per_cell[parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] +=
<a name="l00243"></a>00243                 find_squared_element_error(system, var_name, parent, Uparent,
<a name="l00244"></a>00244                                            fe.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>(), fine_values.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00245"></a>00245             }
<a name="l00246"></a>00246 <span class="preprocessor">#endif</span>
<a name="l00247"></a>00247 <span class="preprocessor"></span>
<a name="l00248"></a>00248           <span class="comment">// Get the local to global degree of freedom maps</span>
<a name="l00249"></a>00249           std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00250"></a>00250           dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices, var);
<a name="l00251"></a>00251           <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> Uelem(dof_indices.size());
<a name="l00252"></a>00252           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != dof_indices.size(); ++i)
<a name="l00253"></a>00253             Uelem(i) = system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255           error_per_cell[e_id] +=
<a name="l00256"></a>00256             find_squared_element_error(system, var_name, elem, Uelem,
<a name="l00257"></a>00257                                        fe.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>(), fine_values.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00258"></a>00258 
<a name="l00259"></a>00259         } <span class="comment">// End loop over active local elements</span>
<a name="l00260"></a>00260     } <span class="comment">// End loop over variables</span>
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   
<a name="l00264"></a>00264   <span class="comment">// Each processor has now computed the error contribuions</span>
<a name="l00265"></a>00265   <span class="comment">// for its local elements.  We need to sum the vector</span>
<a name="l00266"></a>00266   <span class="comment">// and then take the square-root of each component.  Note</span>
<a name="l00267"></a>00267   <span class="comment">// that we only need to sum if we are running on multiple</span>
<a name="l00268"></a>00268   <span class="comment">// processors, and we only need to take the square-root</span>
<a name="l00269"></a>00269   <span class="comment">// if the value is nonzero.  There will in general be many</span>
<a name="l00270"></a>00270   <span class="comment">// zeros for the inactive elements.</span>
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="comment">// First sum the vector of estimated error values</span>
<a name="l00273"></a>00273   this-&gt;reduce_error(error_per_cell);
<a name="l00274"></a>00274 
<a name="l00275"></a>00275   <span class="comment">// Compute the square-root of each component.</span>
<a name="l00276"></a>00276   START_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;ExactErrorEstimator&quot;</span>);
<a name="l00277"></a>00277   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;error_per_cell.size(); i++)
<a name="l00278"></a>00278     {
<a name="l00279"></a>00279       
<a name="l00280"></a>00280       <span class="keywordflow">if</span> (error_per_cell[i] != 0.)
<a name="l00281"></a>00281         {
<a name="l00282"></a>00282           libmesh_assert (error_per_cell[i] &gt; 0.);
<a name="l00283"></a>00283           error_per_cell[i] = std::sqrt(error_per_cell[i]);
<a name="l00284"></a>00284         }
<a name="l00285"></a>00285       
<a name="l00286"></a>00286       
<a name="l00287"></a>00287     }
<a name="l00288"></a>00288   STOP_LOG(<span class="stringliteral">&quot;std::sqrt()&quot;</span>, <span class="stringliteral">&quot;ExactErrorEstimator&quot;</span>);
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="comment">// If we used a non-standard solution before, now is the time to fix</span>
<a name="l00291"></a>00291   <span class="comment">// the current_local_solution</span>
<a name="l00292"></a>00292   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00293"></a>00293     {
<a name="l00294"></a>00294       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00295"></a>00295         <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00296"></a>00296       <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1System.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00297"></a>00297       newsol-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">swap</a>(*sys.solution);
<a name="l00298"></a>00298       sys.update();
<a name="l00299"></a>00299     }
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a85d4c8fb67cd7b3310cb888070fe3139">00304</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a85d4c8fb67cd7b3310cb888070fe3139">ExactErrorEstimator::find_squared_element_error</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00305"></a>00305                                                      <span class="keyword">const</span> std::string&amp; var_name,
<a name="l00306"></a>00306                                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem,
<a name="l00307"></a>00307                                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> &amp;Uelem,
<a name="l00308"></a>00308                                                      <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a> *fe,
<a name="l00309"></a>00309                                                      <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a> *fine_values)<span class="keyword"> const</span>
<a name="l00310"></a>00310 <span class="keyword"></span>{
<a name="l00311"></a>00311   <span class="comment">// The (string) name of this system</span>
<a name="l00312"></a>00312   <span class="keyword">const</span> std::string&amp; sys_name = system.<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = system.<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(var_name);
<a name="l00315"></a>00315   
<a name="l00316"></a>00316   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters = system.<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>;
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   <span class="comment">// reinitialize the element-specific data</span>
<a name="l00319"></a>00319   <span class="comment">// for the current element</span>
<a name="l00320"></a>00320   fe-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#a79b7a69e06d538c334842e1db2bc1223">reinit</a> (elem);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="comment">// Get the data we need to compute with</span>
<a name="l00323"></a>00323   <span class="keyword">const</span> std::vector&lt;Real&gt; &amp;                      JxW          = fe-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#a68fbad4cea951df70482739ef41354d0">get_JxW</a>();
<a name="l00324"></a>00324   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp;         phi_values   = fe-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#aa4ade299922b8d04d73ee5f902526557">get_phi</a>();
<a name="l00325"></a>00325   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; dphi_values  = fe-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#a00032001d3a0fda4f6281952b68fa400">get_dphi</a>();
<a name="l00326"></a>00326   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp;                      q_point      = fe-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#a916212d29016e696eb914481e3e0b3fc">get_xyz</a>();
<a name="l00327"></a>00327 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00328"></a>00328 <span class="preprocessor"></span>  <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp;   d2phi_values = fe-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#aa844b64d6daf6512b760b9a528fc7848">get_d2phi</a>();
<a name="l00329"></a>00329 <span class="preprocessor">#endif</span>
<a name="l00330"></a>00330 <span class="preprocessor"></span>
<a name="l00331"></a>00331   <span class="comment">// The number of shape functions</span>
<a name="l00332"></a>00332   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = Uelem.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>();
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="comment">// The number of quadrature points</span>
<a name="l00335"></a>00335   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = JxW.size();
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_val = 0;
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="comment">// Begin the loop over the Quadrature points.</span>
<a name="l00340"></a>00340   <span class="comment">//</span>
<a name="l00341"></a>00341   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00342"></a>00342     {
<a name="l00343"></a>00343       <span class="comment">// Real u_h = 0.;</span>
<a name="l00344"></a>00344       <span class="comment">// RealGradient grad_u_h;</span>
<a name="l00345"></a>00345 
<a name="l00346"></a>00346       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_h = 0.;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348       <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00349"></a>00349 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00350"></a>00350 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> grad2_u_h;
<a name="l00351"></a>00351 <span class="preprocessor">#endif</span>
<a name="l00352"></a>00352 <span class="preprocessor"></span>
<a name="l00353"></a>00353       <span class="comment">// Compute solution values at the current</span>
<a name="l00354"></a>00354       <span class="comment">// quadrature point.  This reqiures a sum</span>
<a name="l00355"></a>00355       <span class="comment">// over all the shape functions evaluated</span>
<a name="l00356"></a>00356       <span class="comment">// at the quadrature point.</span>
<a name="l00357"></a>00357       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00358"></a>00358         {
<a name="l00359"></a>00359           <span class="comment">// Values from current solution.</span>
<a name="l00360"></a>00360           u_h      += phi_values[i][qp]*Uelem(i);
<a name="l00361"></a>00361           grad_u_h += dphi_values[i][qp]*Uelem(i);
<a name="l00362"></a>00362 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00363"></a>00363 <span class="preprocessor"></span>          grad2_u_h += d2phi_values[i][qp]*Uelem(i);
<a name="l00364"></a>00364 <span class="preprocessor">#endif</span>
<a name="l00365"></a>00365 <span class="preprocessor"></span>        }
<a name="l00366"></a>00366 
<a name="l00367"></a>00367       <span class="comment">// Compute the value of the error at this quadrature point</span>
<a name="l00368"></a>00368       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00369"></a>00369           <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00370"></a>00370           <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>)
<a name="l00371"></a>00371         {
<a name="l00372"></a>00372           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> val_error = 0;
<a name="l00373"></a>00373           <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a6fff092587d8f74f723f6a7e4870b176">_exact_value</a>)
<a name="l00374"></a>00374             val_error = u_h - <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a6fff092587d8f74f723f6a7e4870b176">_exact_value</a>(q_point[qp],parameters,sys_name,var_name);
<a name="l00375"></a>00375           <span class="keywordflow">else</span> <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a>)
<a name="l00376"></a>00376             val_error = u_h - (*fine_values)(q_point[qp]);
<a name="l00377"></a>00377 
<a name="l00378"></a>00378           <span class="comment">// Add the squares of the error to each contribution</span>
<a name="l00379"></a>00379           error_val += JxW[qp]*<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(val_error);
<a name="l00380"></a>00380         }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382       <span class="comment">// Compute the value of the error in the gradient at this</span>
<a name="l00383"></a>00383       <span class="comment">// quadrature point</span>
<a name="l00384"></a>00384       <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a4d746c50eb074e8320bfee64952e3720">_exact_deriv</a> || <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a>) &amp;&amp; 
<a name="l00385"></a>00385           (<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a> ||
<a name="l00386"></a>00386            <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00387"></a>00387            <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>))
<a name="l00388"></a>00388         {
<a name="l00389"></a>00389           <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_error;
<a name="l00390"></a>00390           <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a4d746c50eb074e8320bfee64952e3720">_exact_deriv</a>)
<a name="l00391"></a>00391             grad_error = grad_u_h - <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a4d746c50eb074e8320bfee64952e3720">_exact_deriv</a>(q_point[qp],parameters,sys_name,var_name);
<a name="l00392"></a>00392           <span class="keywordflow">else</span> <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a>)
<a name="l00393"></a>00393             grad_error = grad_u_h - fine_values-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a9b23c856cd235dbc24b6d0ce9315fc67">gradient</a>(q_point[qp]);
<a name="l00394"></a>00394 
<a name="l00395"></a>00395           error_val += JxW[qp]*grad_error.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>();
<a name="l00396"></a>00396         }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00400"></a>00400 <span class="preprocessor"></span>      <span class="comment">// Compute the value of the error in the hessian at this</span>
<a name="l00401"></a>00401       <span class="comment">// quadrature point</span>
<a name="l00402"></a>00402       <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a11fdcee79b0c706b721c81a6b34af27b">_exact_hessian</a> || <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a>) &amp;&amp; 
<a name="l00403"></a>00403           (<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00404"></a>00404            <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>))
<a name="l00405"></a>00405         {
<a name="l00406"></a>00406           <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> grad2_error;
<a name="l00407"></a>00407           <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a11fdcee79b0c706b721c81a6b34af27b">_exact_hessian</a>)
<a name="l00408"></a>00408             grad2_error = grad2_u_h - <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a11fdcee79b0c706b721c81a6b34af27b">_exact_hessian</a>(q_point[qp],parameters,sys_name,var_name);
<a name="l00409"></a>00409           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a>)
<a name="l00410"></a>00410             grad2_error = grad2_u_h - fine_values-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a127a20e79669e4cbedece9532bf6dc20">hessian</a>(q_point[qp]);
<a name="l00411"></a>00411 
<a name="l00412"></a>00412           error_val += JxW[qp]*grad2_error.<a class="code" href="classlibMesh_1_1TypeTensor.php#a3f195e163a89444e26e49398cbad1155">size_sq</a>();
<a name="l00413"></a>00413         }
<a name="l00414"></a>00414 <span class="preprocessor">#endif</span>
<a name="l00415"></a>00415 <span class="preprocessor"></span>
<a name="l00416"></a>00416     } <span class="comment">// end qp loop</span>
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   libmesh_assert (error_val &gt;= 0.);
<a name="l00419"></a>00419           
<a name="l00420"></a>00420   <span class="keywordflow">return</span> error_val;
<a name="l00421"></a>00421 }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
