<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3734f8fafd73a2969ee8ed4a34620869.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">exact_error_estimator.h</div>  </div>
</div>
<div class="contents">
<a href="exact__error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exact_error_estimator.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __exact_error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __exact_error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward Declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span>Elem;
<a name="l00037"></a>00037 <span class="keyword">class </span>FEBase;
<a name="l00038"></a>00038 <span class="keyword">class </span>MeshFunction;
<a name="l00039"></a>00039 <span class="keyword">class </span>Point;
<a name="l00040"></a>00040 <span class="keyword">class </span>Parameters;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseVector;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// Is there any way to simplify this?</span>
<a name="l00045"></a>00045 <span class="comment">// All we need are Tensor and Gradient. - RHS</span>
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>TensorValue;
<a name="l00047"></a><a class="code" href="namespacelibMesh.php#a080d44bce9955f29c426e896dfd01c4e">00047</a> <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1VectorValue.php">VectorValue</a>;
<a name="l00048"></a>00048 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;Number&gt;</a> <a class="code" href="namespacelibMesh.php#a080d44bce9955f29c426e896dfd01c4e">NumberTensorValue</a>;
<a name="l00049"></a><a class="code" href="namespacelibMesh.php#a5f437145a24acdee8c954a449f6389af">00049</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TensorValue.php">NumberTensorValue</a>   <a class="code" href="namespacelibMesh.php#a5f437145a24acdee8c954a449f6389af">Tensor</a>;
<a name="l00050"></a><a class="code" href="namespacelibMesh.php#af884edb27feca745082c13277a077832">00050</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1VectorValue.php">VectorValue&lt;Number&gt;</a> <a class="code" href="namespacelibMesh.php#af884edb27feca745082c13277a077832">NumberVectorValue</a>;
<a name="l00051"></a><a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">00051</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1VectorValue.php">NumberVectorValue</a>   <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a>;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php">00065</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php">ExactErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php">ErrorEstimator</a>
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067 <span class="keyword">public</span>:
<a name="l00068"></a>00068 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#ad61cd427c6fbfc6fd9d69ece15860455">00073</a>   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#ad61cd427c6fbfc6fd9d69ece15860455">ExactErrorEstimator</a>() : <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a6fff092587d8f74f723f6a7e4870b176">_exact_value</a>(NULL), 
<a name="l00074"></a>00074                           <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a4d746c50eb074e8320bfee64952e3720">_exact_deriv</a>(NULL),
<a name="l00075"></a>00075                           <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a11fdcee79b0c706b721c81a6b34af27b">_exact_hessian</a>(NULL),
<a name="l00076"></a>00076                           <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#adf75f8ec3845c364767681cc1cae723c">_extra_order</a>(0)
<a name="l00077"></a>00077   { <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a>; }
<a name="l00078"></a>00078   
<a name="l00082"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a952d06aaad18c67ec59b8aee12440623">00082</a>   <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a952d06aaad18c67ec59b8aee12440623">~ExactErrorEstimator</a>() {}
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00091"></a>00091   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#ac3be67d8a418f4e01db002d040b060c8">attach_exact_value</a> ( <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00092"></a>00092                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>,
<a name="l00093"></a>00093                                         <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00094"></a>00094                                         <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00095"></a>00095 
<a name="l00102"></a>00102   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a1370b2a09dc24d20650b2ec39cf6f76e">attach_exact_deriv</a> ( <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00103"></a>00103                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00104"></a>00104                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00105"></a>00105                                           <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00106"></a>00106 
<a name="l00113"></a>00113   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#af6d7d385e51667b24fad0fa9d3458d6b">attach_exact_hessian</a> ( <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00114"></a>00114                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00115"></a>00115                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00116"></a>00116                                           <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00117"></a>00117 
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a82f73ce3ffbc338bd8197c2beee974a7">attach_reference_solution</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>* es_fine);
<a name="l00124"></a>00124   
<a name="l00125"></a>00125 
<a name="l00130"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a29f6f21e533a0fd015a9f2652ee41009">00130</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a29f6f21e533a0fd015a9f2652ee41009">extra_quadrature_order</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> extraorder)
<a name="l00131"></a>00131     { <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#adf75f8ec3845c364767681cc1cae723c">_extra_order</a> = extraorder; }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">// Bring the base class functionality into the name lookup</span>
<a name="l00135"></a>00135   <span class="comment">// procedure.  This allows for alternative calling formats</span>
<a name="l00136"></a>00136   <span class="comment">// defined in the base class.  Thanks Wolfgang.</span>
<a name="l00137"></a>00137   <span class="comment">// GCC 2.95.3 cannot compile such code.  Since it was not really</span>
<a name="l00138"></a>00138   <span class="comment">// essential to the functioning of this class, it&#39;s been removed.</span>
<a name="l00139"></a>00139   <span class="comment">// using ErrorEstimator::estimate_error;</span>
<a name="l00140"></a>00140 
<a name="l00147"></a>00147   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#aa7f6a8059086481cd6cf862e81ab9af0">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00148"></a>00148                                <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00149"></a>00149                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00150"></a>00150                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="keyword">private</span>:
<a name="l00153"></a>00153 
<a name="l00158"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a6fff092587d8f74f723f6a7e4870b176">00158</a>   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> (* <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a6fff092587d8f74f723f6a7e4870b176">_exact_value</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00159"></a>00159                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00160"></a>00160                            <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00161"></a>00161                            <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00162"></a>00162 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a4d746c50eb074e8320bfee64952e3720">00167</a>   <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> (* <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a4d746c50eb074e8320bfee64952e3720">_exact_deriv</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00168"></a>00168                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00169"></a>00169                              <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00170"></a>00170                              <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00171"></a>00171 
<a name="l00176"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a11fdcee79b0c706b721c81a6b34af27b">00176</a>   <a class="code" href="namespacelibMesh.php#a5f437145a24acdee8c954a449f6389af">Tensor</a> (* <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a11fdcee79b0c706b721c81a6b34af27b">_exact_hessian</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00177"></a>00177                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00178"></a>00178                              <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00179"></a>00179                              <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00180"></a>00180 
<a name="l00185"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">00185</a>   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>* <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a54e7c745613a580151e5e2746af039e4">_equation_systems_fine</a>;
<a name="l00186"></a>00186 
<a name="l00190"></a>00190   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#a85d4c8fb67cd7b3310cb888070fe3139">find_squared_element_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00191"></a>00191                                    <span class="keyword">const</span> std::string&amp; var_name,
<a name="l00192"></a>00192                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem,
<a name="l00193"></a>00193                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> &amp;Uelem,
<a name="l00194"></a>00194                                    <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a> *fe,
<a name="l00195"></a>00195                                    <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a> *fine_values) <span class="keyword">const</span>;
<a name="l00196"></a>00196 
<a name="l00200"></a><a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#adf75f8ec3845c364767681cc1cae723c">00200</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExactErrorEstimator.php#adf75f8ec3845c364767681cc1cae723c">_extra_order</a>;
<a name="l00201"></a>00201 };
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 } <span class="comment">// namespace libMesh</span>
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="preprocessor">#endif</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
