<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">exact_solution.C</div>  </div>
</div>
<div class="contents">
<a href="exact__solution_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exact_solution.C 4396 2011-04-22 17:01:44Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="exact__solution_8h.php">exact_solution.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__function_8h.php">mesh_function.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="vector__value_8h.php">vector_value.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#acd57f37bbdeef18a8ab9a12cd618da31">00040</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#acd57f37bbdeef18a8ab9a12cd618da31">ExactSolution::ExactSolution</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es) :
<a name="l00041"></a>00041   _exact_value (NULL),
<a name="l00042"></a>00042   _exact_deriv (NULL),
<a name="l00043"></a>00043   _exact_hessian (NULL),
<a name="l00044"></a>00044   _equation_systems(es),
<a name="l00045"></a>00045   _equation_systems_fine(NULL),
<a name="l00046"></a>00046   _extra_order(0)
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="comment">// Initialize the _errors data structure which holds all</span>
<a name="l00049"></a>00049   <span class="comment">// the eventual values of the error.</span>
<a name="l00050"></a>00050   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys=0; sys&lt;<a class="code" href="classlibMesh_1_1ExactSolution.php#a8d2e3624020019551b16bef849c5bdb4">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a93238b71a514e6d24f284e5f92947fbe">n_systems</a>(); ++sys)
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052       <span class="comment">// Reference to the system</span>
<a name="l00053"></a>00053       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system = <a class="code" href="classlibMesh_1_1ExactSolution.php#a8d2e3624020019551b16bef849c5bdb4">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(sys);
<a name="l00054"></a>00054       
<a name="l00055"></a>00055       <span class="comment">// The name of the system</span>
<a name="l00056"></a>00056       <span class="keyword">const</span> std::string&amp; sys_name = system.<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>();
<a name="l00057"></a>00057 
<a name="l00058"></a>00058       <span class="comment">// The SystemErrorMap to be inserted</span>
<a name="l00059"></a>00059       <a class="code" href="classlibMesh_1_1ExactSolution.php#a382b8ab39227bf7808d0f81928c7a59f">ExactSolution::SystemErrorMap</a> sem;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); ++var)
<a name="l00062"></a>00062         {
<a name="l00063"></a>00063           <span class="comment">// The name of this variable</span>
<a name="l00064"></a>00064           <span class="keyword">const</span> std::string&amp; var_name = system.<a class="code" href="classlibMesh_1_1System.php#a9cddad5dd8b68389373567fddfbdb257">variable_name</a>(var);
<a name="l00065"></a>00065           sem[var_name] = std::vector&lt;Real&gt;(5, 0.);
<a name="l00066"></a>00066         }
<a name="l00067"></a>00067       
<a name="l00068"></a>00068       <a class="code" href="classlibMesh_1_1ExactSolution.php#a8019a8e67b9ff616bbc1c621032b9b0b">_errors</a>[sys_name] = sem;
<a name="l00069"></a>00069     }
<a name="l00070"></a>00070 }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a8aaee778ee07a4c872cdba1e4e538329">00073</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#a8aaee778ee07a4c872cdba1e4e538329">ExactSolution::attach_reference_solution</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>* es_fine)
<a name="l00074"></a>00074 {
<a name="l00075"></a>00075   libmesh_assert (es_fine != NULL);
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a> = es_fine;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// If we&#39;re using a fine grid solution, we&#39;re not using exact values</span>
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1ExactSolution.php#ada61fd866652aa16164a1e8c02148d84">_exact_value</a> = NULL;
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1ExactSolution.php#a79319c48cfb07b80f022ce8577222477">_exact_deriv</a> = NULL;
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1ExactSolution.php#a332031ca3a913d222870fba9a8fc5c79">_exact_hessian</a> = NULL;
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#a1da33abf36693e50e54f399a5d9402a2">ExactSolution::attach_exact_value</a> (<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00086"></a>00086                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00087"></a>00087                                                     <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00088"></a>00088                                                     <span class="keyword">const</span> std::string&amp; unknown_name))
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   libmesh_assert (fptr != NULL);
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1ExactSolution.php#ada61fd866652aa16164a1e8c02148d84">_exact_value</a> = fptr;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">// If we&#39;re using exact values, we&#39;re not using a fine grid solution</span>
<a name="l00094"></a>00094   <a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a> = NULL;
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a52ed3c0ce23deff43dc9e429426a79e0">00098</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#a52ed3c0ce23deff43dc9e429426a79e0">ExactSolution::attach_exact_deriv</a> (<a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00099"></a>00099                                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00100"></a>00100                                                       <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00101"></a>00101                                                       <span class="keyword">const</span> std::string&amp; unknown_name))
<a name="l00102"></a>00102 {
<a name="l00103"></a>00103   libmesh_assert (fptr != NULL);
<a name="l00104"></a>00104   <a class="code" href="classlibMesh_1_1ExactSolution.php#a79319c48cfb07b80f022ce8577222477">_exact_deriv</a> = fptr;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">// If we&#39;re using exact values, we&#39;re not using a fine grid solution</span>
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a> = NULL;
<a name="l00108"></a>00108 }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#afbdd781d671af7186a42acab63fe64fe">00111</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#afbdd781d671af7186a42acab63fe64fe">ExactSolution::attach_exact_hessian</a> (<a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00112"></a>00112                                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00113"></a>00113                                                       <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00114"></a>00114                                                       <span class="keyword">const</span> std::string&amp; unknown_name))
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116   libmesh_assert (fptr != NULL);
<a name="l00117"></a>00117   <a class="code" href="classlibMesh_1_1ExactSolution.php#a332031ca3a913d222870fba9a8fc5c79">_exact_hessian</a> = fptr;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">// If we&#39;re using exact values, we&#39;re not using a fine grid solution</span>
<a name="l00120"></a>00120   <a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a> = NULL;
<a name="l00121"></a>00121 }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">00126</a> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">ExactSolution::_check_inputs</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00127"></a>00127                                                 <span class="keyword">const</span> std::string&amp; unknown_name)
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   <span class="comment">// If no exact solution function or fine grid solution has been</span>
<a name="l00130"></a>00130   <span class="comment">// attached, we now just compute the solution norm (i.e. the</span>
<a name="l00131"></a>00131   <span class="comment">// difference from an &quot;exact solution&quot; of zero</span>
<a name="l00132"></a>00132 <span class="comment">/*</span>
<a name="l00133"></a>00133 <span class="comment">  if (_exact_value == NULL)</span>
<a name="l00134"></a>00134 <span class="comment">    {</span>
<a name="l00135"></a>00135 <span class="comment">      libMesh::err &lt;&lt; &quot;Cannot compute error, you must provide a &quot;</span>
<a name="l00136"></a>00136 <span class="comment">                    &lt;&lt; &quot;function which computes the exact solution.&quot;</span>
<a name="l00137"></a>00137 <span class="comment">                    &lt;&lt; std::endl;</span>
<a name="l00138"></a>00138 <span class="comment">      libmesh_error();</span>
<a name="l00139"></a>00139 <span class="comment">    }</span>
<a name="l00140"></a>00140 <span class="comment">*/</span>
<a name="l00141"></a>00141   
<a name="l00142"></a>00142   <span class="comment">// Make sure the requested sys_name exists.</span>
<a name="l00143"></a>00143   std::map&lt;std::string, SystemErrorMap&gt;::iterator sys_iter =
<a name="l00144"></a>00144     <a class="code" href="classlibMesh_1_1ExactSolution.php#a8019a8e67b9ff616bbc1c621032b9b0b">_errors</a>.find(sys_name);
<a name="l00145"></a>00145   
<a name="l00146"></a>00146   <span class="keywordflow">if</span> (sys_iter == <a class="code" href="classlibMesh_1_1ExactSolution.php#a8019a8e67b9ff616bbc1c621032b9b0b">_errors</a>.end())
<a name="l00147"></a>00147     {
<a name="l00148"></a>00148       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Sorry, couldn&#39;t find the requested system &#39;&quot;</span>
<a name="l00149"></a>00149                     &lt;&lt; sys_name &lt;&lt; <span class="stringliteral">&quot;&#39;.&quot;</span>
<a name="l00150"></a>00150                     &lt;&lt; std::endl;
<a name="l00151"></a>00151       libmesh_error();
<a name="l00152"></a>00152     }
<a name="l00153"></a>00153   
<a name="l00154"></a>00154   <span class="comment">// Make sure the requested unknown_name exists.</span>
<a name="l00155"></a>00155   SystemErrorMap::iterator var_iter = (*sys_iter).second.find(unknown_name);
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="keywordflow">if</span> (var_iter == (*sys_iter).second.end())
<a name="l00158"></a>00158     {
<a name="l00159"></a>00159       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Sorry, couldn&#39;t find the requested variable &#39;&quot;</span>
<a name="l00160"></a>00160                     &lt;&lt; unknown_name &lt;&lt; <span class="stringliteral">&quot;&#39;.&quot;</span>
<a name="l00161"></a>00161                     &lt;&lt; std::endl;
<a name="l00162"></a>00162       libmesh_error();
<a name="l00163"></a>00163     }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="comment">// Return a reference to the proper error entry</span>
<a name="l00166"></a>00166   <span class="keywordflow">return</span> (*var_iter).second;
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a356467bb362ddb6818b68f6faa7a5dc1">00174</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#a356467bb362ddb6818b68f6faa7a5dc1">ExactSolution::compute_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00175"></a>00175                                   <span class="keyword">const</span> std::string&amp; unknown_name)
<a name="l00176"></a>00176 {
<a name="l00177"></a>00177   <span class="comment">// Check the inputs for validity, and get a reference</span>
<a name="l00178"></a>00178   <span class="comment">// to the proper location to store the error</span>
<a name="l00179"></a>00179   std::vector&lt;Real&gt;&amp; error_vals = this-&gt;<a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">_check_inputs</a>(sys_name,
<a name="l00180"></a>00180                                                       unknown_name);
<a name="l00181"></a>00181   this-&gt;<a class="code" href="classlibMesh_1_1ExactSolution.php#ae9d299b730a99dcc31d93d48ad615f17">_compute_error</a>(sys_name,
<a name="l00182"></a>00182                        unknown_name,
<a name="l00183"></a>00183                        error_vals);
<a name="l00184"></a>00184 }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a582b933aa67cb72bba3b052899e6ef37">00190</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#a582b933aa67cb72bba3b052899e6ef37">ExactSolution::error_norm</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00191"></a>00191                                <span class="keyword">const</span> std::string&amp; unknown_name,
<a name="l00192"></a>00192                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a>&amp; norm)
<a name="l00193"></a>00193 {
<a name="l00194"></a>00194   <span class="comment">// Check the inputs for validity, and get a reference</span>
<a name="l00195"></a>00195   <span class="comment">// to the proper location to store the error</span>
<a name="l00196"></a>00196   std::vector&lt;Real&gt;&amp; error_vals = this-&gt;<a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">_check_inputs</a>(sys_name,
<a name="l00197"></a>00197                                                       unknown_name);
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   <span class="keywordflow">switch</span> (norm)
<a name="l00200"></a>00200     {
<a name="l00201"></a>00201     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>:
<a name="l00202"></a>00202       <span class="keywordflow">return</span> std::sqrt(error_vals[0]);
<a name="l00203"></a>00203     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a7a46908fc35e8855517abd137413214c">H1</a>:
<a name="l00204"></a>00204       <span class="keywordflow">return</span> std::sqrt(error_vals[0] + error_vals[1]);
<a name="l00205"></a>00205     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ac7e590eaaaaf934b5c10d0497329a53b">H2</a>:
<a name="l00206"></a>00206       <span class="keywordflow">return</span> std::sqrt(error_vals[0] + error_vals[1] + error_vals[2]);
<a name="l00207"></a>00207     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>:
<a name="l00208"></a>00208       <span class="keywordflow">return</span> std::sqrt(error_vals[1]);
<a name="l00209"></a>00209     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>:
<a name="l00210"></a>00210       <span class="keywordflow">return</span> std::sqrt(error_vals[2]);
<a name="l00211"></a>00211     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a51d6d223e50a3f1870c1c2182970543a">L1</a>:
<a name="l00212"></a>00212       <span class="keywordflow">return</span> error_vals[3];
<a name="l00213"></a>00213     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>:
<a name="l00214"></a>00214       <span class="keywordflow">return</span> error_vals[4];
<a name="l00215"></a>00215     <span class="comment">// Currently only Sobolev norms/seminorms are supported</span>
<a name="l00216"></a>00216     <span class="keywordflow">default</span>:
<a name="l00217"></a>00217       libmesh_error();
<a name="l00218"></a>00218     }
<a name="l00219"></a>00219 }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#afad5fc4fb02ca56c244d3d6642e7d5d5">00227</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#afad5fc4fb02ca56c244d3d6642e7d5d5">ExactSolution::l2_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00228"></a>00228                              <span class="keyword">const</span> std::string&amp; unknown_name)
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230   
<a name="l00231"></a>00231   <span class="comment">// Check the inputs for validity, and get a reference</span>
<a name="l00232"></a>00232   <span class="comment">// to the proper location to store the error</span>
<a name="l00233"></a>00233   std::vector&lt;Real&gt;&amp; error_vals = this-&gt;<a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">_check_inputs</a>(sys_name,
<a name="l00234"></a>00234                                                       unknown_name);
<a name="l00235"></a>00235   
<a name="l00236"></a>00236   <span class="comment">// Return the square root of the first component of the</span>
<a name="l00237"></a>00237   <span class="comment">// computed error.</span>
<a name="l00238"></a>00238   <span class="keywordflow">return</span> std::sqrt(error_vals[0]);
<a name="l00239"></a>00239 }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a14b0a08a34e171c085bb141f6de99423">00247</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#a14b0a08a34e171c085bb141f6de99423">ExactSolution::l1_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00248"></a>00248                              <span class="keyword">const</span> std::string&amp; unknown_name)
<a name="l00249"></a>00249 {
<a name="l00250"></a>00250   
<a name="l00251"></a>00251   <span class="comment">// Check the inputs for validity, and get a reference</span>
<a name="l00252"></a>00252   <span class="comment">// to the proper location to store the error</span>
<a name="l00253"></a>00253   std::vector&lt;Real&gt;&amp; error_vals = this-&gt;<a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">_check_inputs</a>(sys_name,
<a name="l00254"></a>00254                                                       unknown_name);
<a name="l00255"></a>00255   
<a name="l00256"></a>00256   <span class="comment">// Return the square root of the first component of the</span>
<a name="l00257"></a>00257   <span class="comment">// computed error.</span>
<a name="l00258"></a>00258   <span class="keywordflow">return</span> error_vals[3];
<a name="l00259"></a>00259 }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a7fa7ffe83e4847d9d316e7c629c98265">00267</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#a7fa7ffe83e4847d9d316e7c629c98265">ExactSolution::l_inf_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00268"></a>00268                                 <span class="keyword">const</span> std::string&amp; unknown_name)
<a name="l00269"></a>00269 {
<a name="l00270"></a>00270   
<a name="l00271"></a>00271   <span class="comment">// Check the inputs for validity, and get a reference</span>
<a name="l00272"></a>00272   <span class="comment">// to the proper location to store the error</span>
<a name="l00273"></a>00273   std::vector&lt;Real&gt;&amp; error_vals = this-&gt;<a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">_check_inputs</a>(sys_name,
<a name="l00274"></a>00274                                                       unknown_name);
<a name="l00275"></a>00275   
<a name="l00276"></a>00276   <span class="comment">// Return the square root of the first component of the</span>
<a name="l00277"></a>00277   <span class="comment">// computed error.</span>
<a name="l00278"></a>00278   <span class="keywordflow">return</span> error_vals[4];
<a name="l00279"></a>00279 }
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a94e4ffc3d8f360ed8ce8de5df9b14116">00287</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#a94e4ffc3d8f360ed8ce8de5df9b14116">ExactSolution::h1_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00288"></a>00288                              <span class="keyword">const</span> std::string&amp; unknown_name)
<a name="l00289"></a>00289 {
<a name="l00290"></a>00290   <span class="comment">// If the user has supplied no exact derivative function, we</span>
<a name="l00291"></a>00291   <span class="comment">// just integrate the H1 norm of the solution; i.e. its</span>
<a name="l00292"></a>00292   <span class="comment">// difference from an &quot;exact solution&quot; of zero.</span>
<a name="l00293"></a>00293 <span class="comment">/*</span>
<a name="l00294"></a>00294 <span class="comment">  if (_exact_deriv == NULL)</span>
<a name="l00295"></a>00295 <span class="comment">    {</span>
<a name="l00296"></a>00296 <span class="comment">      libMesh::err &lt;&lt; &quot;Cannot compute H1 error, you must provide a &quot;</span>
<a name="l00297"></a>00297 <span class="comment">                    &lt;&lt; &quot;function which computes the gradient of the exact solution.&quot;</span>
<a name="l00298"></a>00298 <span class="comment">                    &lt;&lt; std::endl;</span>
<a name="l00299"></a>00299 <span class="comment">      libmesh_error();</span>
<a name="l00300"></a>00300 <span class="comment">    }</span>
<a name="l00301"></a>00301 <span class="comment">*/</span>
<a name="l00302"></a>00302   
<a name="l00303"></a>00303   <span class="comment">// Check the inputs for validity, and get a reference</span>
<a name="l00304"></a>00304   <span class="comment">// to the proper location to store the error</span>
<a name="l00305"></a>00305   std::vector&lt;Real&gt;&amp; error_vals = this-&gt;<a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">_check_inputs</a>(sys_name,
<a name="l00306"></a>00306                                                       unknown_name);
<a name="l00307"></a>00307   
<a name="l00308"></a>00308   <span class="comment">// Return the square root of the sum of the computed errors.</span>
<a name="l00309"></a>00309   <span class="keywordflow">return</span> std::sqrt(error_vals[0] + error_vals[1]);
<a name="l00310"></a>00310 }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#abea1b6ee373cf81cea34df2f42888899">00318</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#abea1b6ee373cf81cea34df2f42888899">ExactSolution::h2_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00319"></a>00319                              <span class="keyword">const</span> std::string&amp; unknown_name)
<a name="l00320"></a>00320 {
<a name="l00321"></a>00321   <span class="comment">// If the user has supplied no exact derivative functions, we</span>
<a name="l00322"></a>00322   <span class="comment">// just integrate the H1 norm of the solution; i.e. its</span>
<a name="l00323"></a>00323   <span class="comment">// difference from an &quot;exact solution&quot; of zero.</span>
<a name="l00324"></a>00324 <span class="comment">/*</span>
<a name="l00325"></a>00325 <span class="comment">  if (_exact_deriv == NULL || _exact_hessian == NULL)</span>
<a name="l00326"></a>00326 <span class="comment">    {</span>
<a name="l00327"></a>00327 <span class="comment">      libMesh::err &lt;&lt; &quot;Cannot compute H2 error, you must provide functions &quot;</span>
<a name="l00328"></a>00328 <span class="comment">                    &lt;&lt; &quot;which computes the gradient and hessian of the &quot;</span>
<a name="l00329"></a>00329 <span class="comment">                    &lt;&lt; &quot;exact solution.&quot;</span>
<a name="l00330"></a>00330 <span class="comment">                    &lt;&lt; std::endl;</span>
<a name="l00331"></a>00331 <span class="comment">      libmesh_error();</span>
<a name="l00332"></a>00332 <span class="comment">    }</span>
<a name="l00333"></a>00333 <span class="comment">*/</span>
<a name="l00334"></a>00334   
<a name="l00335"></a>00335   <span class="comment">// Check the inputs for validity, and get a reference</span>
<a name="l00336"></a>00336   <span class="comment">// to the proper location to store the error</span>
<a name="l00337"></a>00337   std::vector&lt;Real&gt;&amp; error_vals = this-&gt;<a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">_check_inputs</a>(sys_name,
<a name="l00338"></a>00338                                                       unknown_name);
<a name="l00339"></a>00339   
<a name="l00340"></a>00340   <span class="comment">// Return the square root of the sum of the computed errors.</span>
<a name="l00341"></a>00341   <span class="keywordflow">return</span> std::sqrt(error_vals[0] + error_vals[1] + error_vals[2]);
<a name="l00342"></a>00342 }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#ae9d299b730a99dcc31d93d48ad615f17">00351</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#ae9d299b730a99dcc31d93d48ad615f17">ExactSolution::_compute_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00352"></a>00352                                    <span class="keyword">const</span> std::string&amp; unknown_name,
<a name="l00353"></a>00353                                    std::vector&lt;Real&gt;&amp; error_vals)
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00356"></a>00356   parallel_only();
<a name="l00357"></a>00357 
<a name="l00358"></a>00358   <span class="comment">// Make sure we aren&#39;t &quot;overconfigured&quot;</span>
<a name="l00359"></a>00359   libmesh_assert (!(<a class="code" href="classlibMesh_1_1ExactSolution.php#ada61fd866652aa16164a1e8c02148d84">_exact_value</a> &amp;&amp; <a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a>));
<a name="l00360"></a>00360 
<a name="l00361"></a>00361   <span class="comment">// Get a reference to the system whose error is being computed.</span>
<a name="l00362"></a>00362   <span class="comment">// If we have a fine grid, however, we&#39;ll integrate on that instead</span>
<a name="l00363"></a>00363   <span class="comment">// for more accuracy.</span>
<a name="l00364"></a>00364   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; computed_system = <a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a> ?
<a name="l00365"></a>00365     <a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a>-&gt;<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(sys_name) :
<a name="l00366"></a>00366     <a class="code" href="classlibMesh_1_1ExactSolution.php#a8d2e3624020019551b16bef849c5bdb4">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a> (sys_name);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="comment">// Prepare a global solution and a MeshFunction of the coarse system if we need one</span>
<a name="l00369"></a>00369   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshFunction&gt;</a> coarse_values;
<a name="l00370"></a>00370   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; comparison_soln = <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;::build</a>();
<a name="l00371"></a>00371   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a>)
<a name="l00372"></a>00372     {
<a name="l00373"></a>00373       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; comparison_system
<a name="l00374"></a>00374         = <a class="code" href="classlibMesh_1_1ExactSolution.php#a8d2e3624020019551b16bef849c5bdb4">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a5dac23f839af25ce7dbf1fe9a6d4b67a">get_system</a>(sys_name);
<a name="l00375"></a>00375 
<a name="l00376"></a>00376       std::vector&lt;Number&gt; global_soln;
<a name="l00377"></a>00377       comparison_system.<a class="code" href="classlibMesh_1_1System.php#ad4975cc3fa5f1e70fd9a6073a25abc78">update_global_solution</a>(global_soln);
<a name="l00378"></a>00378       comparison_soln-&gt;init(comparison_system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;size(), <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>);
<a name="l00379"></a>00379       (*comparison_soln) = global_soln;
<a name="l00380"></a>00380 
<a name="l00381"></a>00381       coarse_values = <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshFunction&gt;</a>
<a name="l00382"></a>00382         (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>(<a class="code" href="classlibMesh_1_1ExactSolution.php#a8d2e3624020019551b16bef849c5bdb4">_equation_systems</a>,
<a name="l00383"></a>00383                           *comparison_soln,
<a name="l00384"></a>00384                           comparison_system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>(),
<a name="l00385"></a>00385                           comparison_system.<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(unknown_name)));
<a name="l00386"></a>00386       coarse_values-&gt;init();
<a name="l00387"></a>00387     }
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   <span class="comment">// Get a reference to the dofmap and mesh for that system</span>
<a name="l00390"></a>00390   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; computed_dof_map = computed_system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; _mesh = computed_system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00393"></a>00393 
<a name="l00394"></a>00394   <span class="comment">// Zero the error before summation</span>
<a name="l00395"></a>00395   error_vals = std::vector&lt;Real&gt;(5, 0.);
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="comment">// get the EquationSystems parameters for use with _exact_value</span>
<a name="l00398"></a>00398   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters = this-&gt;<a class="code" href="classlibMesh_1_1ExactSolution.php#a8d2e3624020019551b16bef849c5bdb4">_equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>;
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   <span class="comment">// Get the current time, in case the exact solution depends on it.</span>
<a name="l00401"></a>00401   <span class="comment">// Steady systems of equations do not have a time parameter, so this</span>
<a name="l00402"></a>00402   <span class="comment">// routine needs to take that into account.</span>
<a name="l00403"></a>00403   <span class="comment">// FIXME!!!</span>
<a name="l00404"></a>00404   <span class="comment">// const Real time = 0.;//_equation_systems.parameter(&quot;time&quot;);  </span>
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="comment">// Construct Quadrature rule based on default quadrature order</span>
<a name="l00407"></a>00407   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = computed_system.<a class="code" href="classlibMesh_1_1System.php#aeda27e9696b02cf965e2340fc9e64857">variable_number</a>(unknown_name);
<a name="l00408"></a>00408   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type  = computed_dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(var);
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> qrule =
<a name="l00411"></a>00411     fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a> (_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>(),
<a name="l00412"></a>00412                                      <a class="code" href="classlibMesh_1_1ExactSolution.php#af74b8db7aee182d2683ba030de52d865">_extra_order</a>);
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   <span class="comment">// Construct finite element object</span>
<a name="l00415"></a>00415   
<a name="l00416"></a>00416   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe(<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>(), fe_type));
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   <span class="comment">// Attach quadrature rule to FE object</span>
<a name="l00419"></a>00419   fe-&gt;attach_quadrature_rule (qrule.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00420"></a>00420   
<a name="l00421"></a>00421   <span class="comment">// The Jacobian*weight at the quadrature points.</span>
<a name="l00422"></a>00422   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; JxW                               = fe-&gt;get_JxW();
<a name="l00423"></a>00423   
<a name="l00424"></a>00424   <span class="comment">// The value of the shape functions at the quadrature points</span>
<a name="l00425"></a>00425   <span class="comment">// i.e. phi(i) = phi_values[i][qp] </span>
<a name="l00426"></a>00426   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp;  phi_values         = fe-&gt;get_phi();
<a name="l00427"></a>00427   
<a name="l00428"></a>00428   <span class="comment">// The value of the shape function gradients at the quadrature points</span>
<a name="l00429"></a>00429   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; dphi_values = fe-&gt;get_dphi();
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00432"></a>00432 <span class="preprocessor"></span>  <span class="comment">// The value of the shape function second derivatives at the quadrature points</span>
<a name="l00433"></a>00433   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp; d2phi_values = fe-&gt;get_d2phi();
<a name="l00434"></a>00434 <span class="preprocessor">#endif</span>
<a name="l00435"></a>00435 <span class="preprocessor"></span>  
<a name="l00436"></a>00436   <span class="comment">// The XYZ locations (in physical space) of the quadrature points</span>
<a name="l00437"></a>00437   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; q_point                          = fe-&gt;get_xyz();
<a name="l00438"></a>00438             
<a name="l00439"></a>00439   <span class="comment">// The global degree of freedom indices associated</span>
<a name="l00440"></a>00440   <span class="comment">// with the local degrees of freedom.</span>
<a name="l00441"></a>00441   std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444   <span class="comment">//</span>
<a name="l00445"></a>00445   <span class="comment">// Begin the loop over the elements</span>
<a name="l00446"></a>00446   <span class="comment">//</span>
<a name="l00447"></a>00447   <span class="comment">// TODO: this ought to be threaded (and using subordinate</span>
<a name="l00448"></a>00448   <span class="comment">// MeshFunction objects in each thread rather than a single</span>
<a name="l00449"></a>00449   <span class="comment">// master)</span>
<a name="l00450"></a>00450   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el     = _mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00451"></a>00451   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = _mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00454"></a>00454     {
<a name="l00455"></a>00455       <span class="comment">// Store a pointer to the element we are currently</span>
<a name="l00456"></a>00456       <span class="comment">// working on.  This allows for nicer syntax later.</span>
<a name="l00457"></a>00457       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00458"></a>00458 
<a name="l00459"></a>00459       <span class="comment">// reinitialize the element-specific data</span>
<a name="l00460"></a>00460       <span class="comment">// for the current element</span>
<a name="l00461"></a>00461       fe-&gt;reinit (elem);
<a name="l00462"></a>00462 
<a name="l00463"></a>00463       <span class="comment">// Get the local to global degree of freedom maps</span>
<a name="l00464"></a>00464       computed_dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a>    (elem, dof_indices, var);
<a name="l00465"></a>00465       
<a name="l00466"></a>00466       <span class="comment">// The number of quadrature points</span>
<a name="l00467"></a>00467       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qrule-&gt;n_points();
<a name="l00468"></a>00468 
<a name="l00469"></a>00469       <span class="comment">// The number of shape functions</span>
<a name="l00470"></a>00470       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = dof_indices.size();
<a name="l00471"></a>00471 
<a name="l00472"></a>00472       <span class="comment">//</span>
<a name="l00473"></a>00473       <span class="comment">// Begin the loop over the Quadrature points.</span>
<a name="l00474"></a>00474       <span class="comment">//</span>
<a name="l00475"></a>00475       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00476"></a>00476         {
<a name="l00477"></a>00477           <span class="comment">// Real u_h = 0.;</span>
<a name="l00478"></a>00478           <span class="comment">// RealGradient grad_u_h;</span>
<a name="l00479"></a>00479 
<a name="l00480"></a>00480           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_h = 0.;
<a name="l00481"></a>00481 
<a name="l00482"></a>00482           <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00483"></a>00483 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00484"></a>00484 <span class="preprocessor"></span>          <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> grad2_u_h;
<a name="l00485"></a>00485 <span class="preprocessor">#endif</span>
<a name="l00486"></a>00486 <span class="preprocessor"></span>  
<a name="l00487"></a>00487 
<a name="l00488"></a>00488           <span class="comment">// Compute solution values at the current</span>
<a name="l00489"></a>00489           <span class="comment">// quadrature point.  This reqiures a sum</span>
<a name="l00490"></a>00490           <span class="comment">// over all the shape functions evaluated</span>
<a name="l00491"></a>00491           <span class="comment">// at the quadrature point.</span>
<a name="l00492"></a>00492           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00493"></a>00493             {
<a name="l00494"></a>00494               <span class="comment">// Values from current solution.</span>
<a name="l00495"></a>00495               u_h      += phi_values[i][qp]*computed_system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>  (dof_indices[i]);
<a name="l00496"></a>00496               grad_u_h += dphi_values[i][qp]*computed_system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[i]);
<a name="l00497"></a>00497 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00498"></a>00498 <span class="preprocessor"></span>              grad2_u_h += d2phi_values[i][qp]*computed_system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[i]);
<a name="l00499"></a>00499 <span class="preprocessor">#endif</span>
<a name="l00500"></a>00500 <span class="preprocessor"></span>            }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502           <span class="comment">// Compute the value of the error at this quadrature point</span>
<a name="l00503"></a>00503           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> exact_val = 0.0;
<a name="l00504"></a>00504           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExactSolution.php#ada61fd866652aa16164a1e8c02148d84">_exact_value</a>)
<a name="l00505"></a>00505             exact_val = <a class="code" href="classlibMesh_1_1ExactSolution.php#ada61fd866652aa16164a1e8c02148d84">_exact_value</a>(q_point[qp], parameters,
<a name="l00506"></a>00506                                      sys_name, unknown_name);
<a name="l00507"></a>00507           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a>)
<a name="l00508"></a>00508             exact_val = (*coarse_values)(q_point[qp]);
<a name="l00509"></a>00509 
<a name="l00510"></a>00510           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> val_error = u_h - exact_val;
<a name="l00511"></a>00511 
<a name="l00512"></a>00512           <span class="comment">// Add the squares of the error to each contribution</span>
<a name="l00513"></a>00513           error_vals[0] += JxW[qp]*<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(val_error);
<a name="l00514"></a>00514           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm = sqrt(<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(val_error));
<a name="l00515"></a>00515           error_vals[3] += JxW[qp]*norm;
<a name="l00516"></a>00516           <span class="keywordflow">if</span>(error_vals[4]&lt;norm) { error_vals[4] = norm; }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518           <span class="comment">// Compute the value of the error in the gradient at this</span>
<a name="l00519"></a>00519           <span class="comment">// quadrature point</span>
<a name="l00520"></a>00520           <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> exact_grad;
<a name="l00521"></a>00521           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExactSolution.php#a79319c48cfb07b80f022ce8577222477">_exact_deriv</a>)
<a name="l00522"></a>00522             exact_grad = <a class="code" href="classlibMesh_1_1ExactSolution.php#a79319c48cfb07b80f022ce8577222477">_exact_deriv</a>(q_point[qp], parameters,
<a name="l00523"></a>00523                                       sys_name, unknown_name);
<a name="l00524"></a>00524           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a>)
<a name="l00525"></a>00525             exact_grad = coarse_values-&gt;gradient(q_point[qp]);
<a name="l00526"></a>00526 
<a name="l00527"></a>00527           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_error = grad_u_h - exact_grad;
<a name="l00528"></a>00528 
<a name="l00529"></a>00529           error_vals[1] += JxW[qp]*grad_error.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>();
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00533"></a>00533 <span class="preprocessor"></span>          <span class="comment">// Compute the value of the error in the hessian at this</span>
<a name="l00534"></a>00534           <span class="comment">// quadrature point</span>
<a name="l00535"></a>00535           <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> exact_hess;
<a name="l00536"></a>00536           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExactSolution.php#a332031ca3a913d222870fba9a8fc5c79">_exact_hessian</a>)
<a name="l00537"></a>00537             exact_hess = <a class="code" href="classlibMesh_1_1ExactSolution.php#a332031ca3a913d222870fba9a8fc5c79">_exact_hessian</a>(q_point[qp], parameters,
<a name="l00538"></a>00538                                         sys_name, unknown_name);
<a name="l00539"></a>00539           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a>)
<a name="l00540"></a>00540             exact_hess = coarse_values-&gt;hessian(q_point[qp]);
<a name="l00541"></a>00541 
<a name="l00542"></a>00542           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> grad2_error = grad2_u_h - exact_hess;
<a name="l00543"></a>00543 
<a name="l00544"></a>00544           error_vals[2] += JxW[qp]*grad2_error.<a class="code" href="classlibMesh_1_1TypeTensor.php#a3f195e163a89444e26e49398cbad1155">size_sq</a>();
<a name="l00545"></a>00545 <span class="preprocessor">#endif</span>
<a name="l00546"></a>00546 <span class="preprocessor"></span>          
<a name="l00547"></a>00547         } <span class="comment">// end qp loop</span>
<a name="l00548"></a>00548     } <span class="comment">// end element loop</span>
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="comment">// Add up the error values on all processors, except for the L-infty</span>
<a name="l00551"></a>00551   <span class="comment">// norm, for which the maximum is computed.</span>
<a name="l00552"></a>00552   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> l_infty_norm = error_vals[4];
<a name="l00553"></a>00553   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(l_infty_norm);
<a name="l00554"></a>00554   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(error_vals);
<a name="l00555"></a>00555   error_vals[4] = l_infty_norm;
<a name="l00556"></a>00556 }
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
