<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3734f8fafd73a2969ee8ed4a34620869.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">exact_solution.h</div>  </div>
</div>
<div class="contents">
<a href="exact__solution_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exact_solution.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __exact_solution_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __exact_solution_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span> <span class="comment">// for Number</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="enum__norm__type_8h.php">enum_norm_type.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward Declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span>Point;
<a name="l00038"></a>00038 <span class="keyword">class </span>EquationSystems;
<a name="l00039"></a>00039 <span class="keyword">class </span>Parameters;
<a name="l00040"></a>00040 <span class="keyword">class </span>Mesh;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// Is there any way to simplify this?</span>
<a name="l00043"></a>00043 <span class="comment">// All we need are Tensor and Gradient. - RHS</span>
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>TensorValue;
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>VectorValue;
<a name="l00046"></a>00046 <span class="keyword">typedef</span> TensorValue&lt;Number&gt; <a class="code" href="namespacelibMesh.php#a080d44bce9955f29c426e896dfd01c4e">NumberTensorValue</a>;
<a name="l00047"></a>00047 <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#a080d44bce9955f29c426e896dfd01c4e">NumberTensorValue</a>   <a class="code" href="namespacelibMesh.php#a5f437145a24acdee8c954a449f6389af">Tensor</a>;
<a name="l00048"></a>00048 <span class="keyword">typedef</span> VectorValue&lt;Number&gt; <a class="code" href="namespacelibMesh.php#af884edb27feca745082c13277a077832">NumberVectorValue</a>;
<a name="l00049"></a>00049 <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#af884edb27feca745082c13277a077832">NumberVectorValue</a>   <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a>;
<a name="l00050"></a>00050 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1ExactSolution.php">00065</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ExactSolution.php">ExactSolution</a>
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   
<a name="l00068"></a>00068 <span class="keyword">public</span>:
<a name="l00074"></a>00074   <a class="code" href="classlibMesh_1_1ExactSolution.php#acd57f37bbdeef18a8ab9a12cd618da31">ExactSolution</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a8c22379729cdc0c2b08653c514ca6e01">00079</a>   <a class="code" href="classlibMesh_1_1ExactSolution.php#a8c22379729cdc0c2b08653c514ca6e01">~ExactSolution</a>() {}
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   
<a name="l00087"></a>00087   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#a8aaee778ee07a4c872cdba1e4e538329">attach_reference_solution</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>* es_fine);
<a name="l00088"></a>00088 
<a name="l00095"></a>00095   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#a1da33abf36693e50e54f399a5d9402a2">attach_exact_value</a> ( <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00096"></a>00096                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>,
<a name="l00097"></a>00097                                         <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00098"></a>00098                                         <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00099"></a>00099 
<a name="l00106"></a>00106   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#a52ed3c0ce23deff43dc9e429426a79e0">attach_exact_deriv</a> ( <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00107"></a>00107                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00108"></a>00108                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00109"></a>00109                                           <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00110"></a>00110 
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#afbdd781d671af7186a42acab63fe64fe">attach_exact_hessian</a> ( <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> fptr(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00118"></a>00118                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00119"></a>00119                                           <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00120"></a>00120                                           <span class="keyword">const</span> std::string&amp; unknown_name));
<a name="l00121"></a>00121 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#aca8a23c206500a1dbc4d91335d7641c0">00126</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#aca8a23c206500a1dbc4d91335d7641c0">extra_quadrature_order</a> (<span class="keyword">const</span> <span class="keywordtype">int</span> extraorder)
<a name="l00127"></a>00127     { <a class="code" href="classlibMesh_1_1ExactSolution.php#af74b8db7aee182d2683ba030de52d865">_extra_order</a> = extraorder; }
<a name="l00128"></a>00128 
<a name="l00136"></a>00136   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#a356467bb362ddb6818b68f6faa7a5dc1">compute_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00137"></a>00137                      <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00138"></a>00138   
<a name="l00144"></a>00144   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#afad5fc4fb02ca56c244d3d6642e7d5d5">l2_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00145"></a>00145                 <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00146"></a>00146   
<a name="l00152"></a>00152   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#a14b0a08a34e171c085bb141f6de99423">l1_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00153"></a>00153                 <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00154"></a>00154   
<a name="l00164"></a>00164   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#a7fa7ffe83e4847d9d316e7c629c98265">l_inf_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00165"></a>00165                    <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00166"></a>00166   
<a name="l00172"></a>00172   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#a94e4ffc3d8f360ed8ce8de5df9b14116">h1_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00173"></a>00173                 <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00174"></a>00174   
<a name="l00180"></a>00180   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#abea1b6ee373cf81cea34df2f42888899">h2_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00181"></a>00181                 <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00182"></a>00182   
<a name="l00190"></a>00190   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1ExactSolution.php#a582b933aa67cb72bba3b052899e6ef37">error_norm</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00191"></a>00191                   <span class="keyword">const</span> std::string&amp; unknown_name,
<a name="l00192"></a>00192                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098">FEMNormType</a>&amp; norm);
<a name="l00193"></a>00193 <span class="keyword">private</span>:
<a name="l00194"></a>00194   
<a name="l00201"></a>00201   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#ae9d299b730a99dcc31d93d48ad615f17">_compute_error</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00202"></a>00202                       <span class="keyword">const</span> std::string&amp; unknown_name,
<a name="l00203"></a>00203                       std::vector&lt;Real&gt;&amp; error_vals);
<a name="l00204"></a>00204 
<a name="l00210"></a>00210   std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1ExactSolution.php#aa0739c9e5851b39a48a4fe02bf0b502c">_check_inputs</a>(<span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00211"></a>00211                                    <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00212"></a>00212   
<a name="l00217"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#ada61fd866652aa16164a1e8c02148d84">00217</a>   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> (* <a class="code" href="classlibMesh_1_1ExactSolution.php#ada61fd866652aa16164a1e8c02148d84">_exact_value</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00218"></a>00218                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00219"></a>00219                            <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00220"></a>00220                            <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00221"></a>00221 
<a name="l00226"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a79319c48cfb07b80f022ce8577222477">00226</a>   <a class="code" href="namespacelibMesh.php#a4b46bf2d57c1815051b6684921702ef2">Gradient</a> (* <a class="code" href="classlibMesh_1_1ExactSolution.php#a79319c48cfb07b80f022ce8577222477">_exact_deriv</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00227"></a>00227                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00228"></a>00228                              <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00229"></a>00229                              <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00230"></a>00230 
<a name="l00235"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a332031ca3a913d222870fba9a8fc5c79">00235</a>   <a class="code" href="namespacelibMesh.php#a5f437145a24acdee8c954a449f6389af">Tensor</a> (* <a class="code" href="classlibMesh_1_1ExactSolution.php#a332031ca3a913d222870fba9a8fc5c79">_exact_hessian</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00236"></a>00236                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parameters.php">Parameters</a>&amp; parameters,
<a name="l00237"></a>00237                              <span class="keyword">const</span> std::string&amp; sys_name,
<a name="l00238"></a>00238                              <span class="keyword">const</span> std::string&amp; unknown_name);
<a name="l00239"></a>00239 
<a name="l00248"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a382b8ab39227bf7808d0f81928c7a59f">00248</a>   <span class="keyword">typedef</span> std::map&lt;std::string, std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1ExactSolution.php#a382b8ab39227bf7808d0f81928c7a59f">SystemErrorMap</a>;
<a name="l00249"></a>00249 
<a name="l00256"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a8019a8e67b9ff616bbc1c621032b9b0b">00256</a>   std::map&lt;std::string, SystemErrorMap&gt; <a class="code" href="classlibMesh_1_1ExactSolution.php#a8019a8e67b9ff616bbc1c621032b9b0b">_errors</a>;
<a name="l00257"></a>00257   
<a name="l00262"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#a8d2e3624020019551b16bef849c5bdb4">00262</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; <a class="code" href="classlibMesh_1_1ExactSolution.php#a8d2e3624020019551b16bef849c5bdb4">_equation_systems</a>;
<a name="l00263"></a>00263 
<a name="l00268"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">00268</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>* <a class="code" href="classlibMesh_1_1ExactSolution.php#afa3c8f81528b1a2a52182ae3bdc3e65e">_equation_systems_fine</a>;
<a name="l00269"></a>00269 
<a name="l00273"></a><a class="code" href="classlibMesh_1_1ExactSolution.php#af74b8db7aee182d2683ba030de52d865">00273</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExactSolution.php#af74b8db7aee182d2683ba030de52d865">_extra_order</a>;
<a name="l00274"></a>00274 };
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 } <span class="comment">// namespace libMesh</span>
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
