<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">exodusII_io.h</div>  </div>
</div>
<div class="contents">
<a href="exodusII__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: exodusII_io.h 4335 2011-04-11 19:52:03Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __exodusII_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __exodusII_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span>EquationSystems;
<a name="l00038"></a>00038 <span class="keyword">class </span>ExodusII_IO_Helper;
<a name="l00039"></a>00039 <span class="keyword">class </span>MeshBase;
<a name="l00040"></a>00040 <span class="keyword">class </span>System;
<a name="l00041"></a>00041 
<a name="l00051"></a>00051 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00052"></a>00052 <span class="comment">// ExodusII_IO class definition</span>
<a name="l00053"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php">00053</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ExodusII__IO.php">ExodusII_IO</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00054"></a>00054                     <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056 
<a name="l00057"></a>00057  <span class="keyword">public</span>:
<a name="l00058"></a>00058   
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a37202ae96a19aac1b48ec207dea0b37f">ExodusII_IO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a>);
<a name="l00064"></a>00064   
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a704f17fe5f371dfbe4b472d01bafa595">~ExodusII_IO</a> ();
<a name="l00069"></a>00069   
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a5c8740e7197ba48ac0cd7d91d753f0f1">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a4d5d6b01bd1cc3ebcbd3f80814b8b35c">write</a> (<span class="keyword">const</span> std::string&amp; fname);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a3c93dad68213877369e9a5a336d005fc">verbose</a> (<span class="keywordtype">bool</span> set_verbosity);
<a name="l00089"></a>00089 
<a name="l00094"></a>00094   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a1a4d61cb9e4ceda55ab11d07917df84b">copy_nodal_solution</a>(<a class="code" href="classlibMesh_1_1System.php">System</a>&amp; es, std::string nodal_var_name, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> timestep=1);
<a name="l00095"></a>00095   
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a0dbacd8c0f06c6077b00a2514d539bbe">write_discontinuous_exodusII</a> (<span class="keyword">const</span> std::string&amp; name, 
<a name="l00100"></a>00100                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00101"></a>00101   
<a name="l00102"></a>00102 
<a name="l00106"></a>00106   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#ad0f02d07528a7f142689bcdd0ffa4191">write_element_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00107"></a>00107 
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a7c71e054980db6100b3ebc91d4f4d13b">write_nodal_data</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00112"></a>00112                          <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00113"></a>00113                          <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00114"></a>00114 
<a name="l00118"></a>00118   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#aea1df4307625c07f7a64c03a3d998346">write_nodal_data_discontinuous</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00119"></a>00119                          <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00120"></a>00120                          <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00121"></a>00121 
<a name="l00125"></a>00125   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#ab9bcb53927e2716e95c04d75035062b2">write_global_data</a> (<span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00126"></a>00126                           <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00127"></a>00127 
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a84b4b7293a703e499a196720eeb1d787">write_information_records</a> (<span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00132"></a>00132 
<a name="l00137"></a>00137   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a6ae397f170c8aaebde99b273cbaeb1db">write_timestep</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00138"></a>00138                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00139"></a>00139                        <span class="keyword">const</span> <span class="keywordtype">int</span> timestep,
<a name="l00140"></a>00140                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time);
<a name="l00141"></a>00141   
<a name="l00142"></a>00142  <span class="keyword">private</span>:
<a name="l00148"></a>00148 <span class="preprocessor">#ifdef LIBMESH_HAVE_EXODUS_API</span>
<a name="l00149"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">00149</a> <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php">ExodusII_IO_Helper</a> *<a class="code" href="classlibMesh_1_1ExodusII__IO.php#af4c35286542c22438da363ed7e8bc591">exio_helper</a>;
<a name="l00150"></a>00150 <span class="preprocessor">#endif</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>
<a name="l00155"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a2b9dab351d4149b6ac7c0df25f7f9208">00155</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a2b9dab351d4149b6ac7c0df25f7f9208">_timestep</a>;
<a name="l00156"></a>00156 
<a name="l00160"></a><a class="code" href="classlibMesh_1_1ExodusII__IO.php#a33ee8571dc3cbfb11ca8c3f0b13009f5">00160</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ExodusII__IO.php#a33ee8571dc3cbfb11ca8c3f0b13009f5">_verbose</a>;
<a name="l00161"></a>00161 };
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 } <span class="comment">// namespace libMesh</span>
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="preprocessor">#endif // #define __exodusII_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
