<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">explicit_system.C</div>  </div>
</div>
<div class="contents">
<a href="explicit__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: explicit_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="explicit__system_8h.php">explicit_system.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">namespace </span>libMesh
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00033"></a>00033 <span class="comment">// ExplicitSystem implementation</span>
<a name="l00034"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#ab7cc2aa1ea16ecf191afe4be3f9da61e">00034</a> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#ab7cc2aa1ea16ecf191afe4be3f9da61e">ExplicitSystem::ExplicitSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00035"></a>00035                                 <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00036"></a>00036                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00037"></a>00037   <a class="code" href="classlibMesh_1_1System.php">Parent</a> (es, name, number),
<a name="l00038"></a>00038   rhs(NULL)
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <span class="comment">//rhs = &amp;(this-&gt;add_vector (&quot;RHS Vector&quot;));</span>
<a name="l00042"></a>00042 }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#a202f36eff5389cf4a7373d8cd1bb9256">00046</a> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a202f36eff5389cf4a7373d8cd1bb9256">ExplicitSystem::~ExplicitSystem</a> ()
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="comment">// clear data</span>
<a name="l00049"></a>00049   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#ab6f8aaf1e1ba4bdabda4f5f045816f1f">clear</a>();
<a name="l00050"></a>00050 }
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#ab6f8aaf1e1ba4bdabda4f5f045816f1f">00054</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#ab6f8aaf1e1ba4bdabda4f5f045816f1f">ExplicitSystem::clear</a> ()
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   <span class="comment">// Clear the parent data</span>
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1System.php#a8b6f936ce782fbd86cb4f3922def4cf0">Parent::clear</a>();
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">// NULL-out the vector.  Note that</span>
<a name="l00060"></a>00060   <span class="comment">// System::clear() actually deleted it.</span>
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a> = NULL;
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#a47a97723cedc8a3e7ce0d9ebfd57f1ad">00066</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a47a97723cedc8a3e7ce0d9ebfd57f1ad">ExplicitSystem::init_data</a> ()
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068   <span class="comment">// Add the system RHS.</span>
<a name="l00069"></a>00069   <span class="comment">// (We must do this before initializing the System data,</span>
<a name="l00070"></a>00070   <span class="comment">//  then we lose the opportunity to add vectors).</span>
<a name="l00071"></a>00071   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#ada18af0e0b5d40b758ca271d99fbdd37">add_system_rhs</a> ();
<a name="l00072"></a>00072   
<a name="l00073"></a>00073   <span class="comment">// initialize parent data</span>
<a name="l00074"></a>00074   <a class="code" href="classlibMesh_1_1System.php#aa82956a48e464a20f18426601ad511d4">Parent::init_data</a>();
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#a86206bdaf4b5e192ac33812cbf3937e1">00079</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a86206bdaf4b5e192ac33812cbf3937e1">ExplicitSystem::reinit</a> ()
<a name="l00080"></a>00080 {
<a name="l00081"></a>00081   <span class="comment">// initialize parent data</span>
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1System.php#a1cb3b5ae4fdd2f72d8fbddcadf3d3256">Parent::reinit</a>();  
<a name="l00083"></a>00083   
<a name="l00084"></a>00084   <span class="comment">// not necessary, handled by the parent!</span>
<a name="l00085"></a>00085   <span class="comment">// Resize the RHS conformal to the current mesh</span>
<a name="l00086"></a>00086   <span class="comment">//rhs-&gt;init (this-&gt;n_dofs(), this-&gt;n_local_dofs());</span>
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#a5569d95f40c4255f1f9db1948b626462">00091</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a5569d95f40c4255f1f9db1948b626462">ExplicitSystem::assemble_qoi</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093   <span class="comment">// The user quantity of interest assembly gets to expect to</span>
<a name="l00094"></a>00094   <span class="comment">// accumulate on initially zero values</span>
<a name="l00095"></a>00095   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00096"></a>00096     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00097"></a>00097       <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>[i] = 0;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <a class="code" href="classlibMesh_1_1System.php#ab57cde3f61d1816856e1100f068a25fa">Parent::assemble_qoi</a> (qoi_indices);
<a name="l00100"></a>00100 }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#a494403f8651bf2db7a930e02245e5429">00104</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a494403f8651bf2db7a930e02245e5429">ExplicitSystem::assemble_qoi_derivative</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   <span class="comment">// The user quantity of interest derivative assembly gets to expect</span>
<a name="l00107"></a>00107   <span class="comment">// to accumulate on initially zero vectors</span>
<a name="l00108"></a>00108   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00109"></a>00109     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00110"></a>00110       this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab21c031f38c12ff111865623561b6687">add_adjoint_rhs</a>(i).<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1System.php#a7d69df3b46fdd7073cfaaaf0fa71fbbc">Parent::assemble_qoi_derivative</a> (qoi_indices);
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#a2a1d41330ff24046c55e07a08a716cbb">00117</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a2a1d41330ff24046c55e07a08a716cbb">ExplicitSystem::solve</a> ()
<a name="l00118"></a>00118 {
<a name="l00119"></a>00119   <span class="comment">// Assemble the linear system</span>
<a name="l00120"></a>00120   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a79e4227a9e627031fac487cbd7c17250">assemble</a> (); 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">// Update the system after the solve</span>
<a name="l00123"></a>00123   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();  
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#ada18af0e0b5d40b758ca271d99fbdd37">00128</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#ada18af0e0b5d40b758ca271d99fbdd37">ExplicitSystem::add_system_rhs</a> ()
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <span class="comment">// Possible that we cleared the _vectors but</span>
<a name="l00131"></a>00131   <span class="comment">// forgot to NULL-out the rhs?</span>
<a name="l00132"></a>00132   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a46bd8cfb070bab2dc814c33749c8c21b">n_vectors</a>() == 0) <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a> = NULL;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">// Only need to add the rhs if it isn&#39;t there</span>
<a name="l00136"></a>00136   <span class="comment">// already!</span>
<a name="l00137"></a>00137   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a> == NULL)
<a name="l00138"></a>00138     <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a> = &amp;(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="stringliteral">&quot;RHS Vector&quot;</span>, <span class="keyword">false</span>));
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   libmesh_assert (<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a> != NULL);
<a name="l00141"></a>00141 }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
