<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">explicit_system.h</div>  </div>
</div>
<div class="contents">
<a href="explicit__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: explicit_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __explicit_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __explicit_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// ExplicitSystem class definition</span>
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php">00048</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ExplicitSystem.php">ExplicitSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1System.php">System</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00056"></a>00056   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#ab7cc2aa1ea16ecf191afe4be3f9da61e">ExplicitSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00057"></a>00057                   <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00058"></a>00058                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a202f36eff5389cf4a7373d8cd1bb9256">~ExplicitSystem</a> ();
<a name="l00064"></a>00064  
<a name="l00068"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#a2d14ddc51b94a3fdd78ee3ac9f602118">00068</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php">ExplicitSystem</a> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a2d14ddc51b94a3fdd78ee3ac9f602118">sys_type</a>;
<a name="l00069"></a>00069 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#af782ac54aa781d4cedff91e72c411a1b">00073</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1System.php">System</a> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#af782ac54aa781d4cedff91e72c411a1b">Parent</a>;
<a name="l00074"></a>00074   
<a name="l00078"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#aa0e154bb08451f15d8a0269799bc1522">00078</a>   <a class="code" href="classlibMesh_1_1ExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1ExplicitSystem.php#aa0e154bb08451f15d8a0269799bc1522">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00079"></a>00079   
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#ab6f8aaf1e1ba4bdabda4f5f045816f1f">clear</a> ();
<a name="l00085"></a>00085 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a86206bdaf4b5e192ac33812cbf3937e1">reinit</a> ();
<a name="l00091"></a>00091   
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a5569d95f40c4255f1f9db1948b626462">assemble_qoi</a>
<a name="l00098"></a>00098     (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00099"></a>00099 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a494403f8651bf2db7a930e02245e5429">assemble_qoi_derivative</a>
<a name="l00106"></a>00106     (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00107"></a>00107  
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a2a1d41330ff24046c55e07a08a716cbb">solve</a> ();
<a name="l00112"></a>00112  
<a name="l00117"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#a1ff5db3a294b998df8785b7a54d1c195">00117</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a1ff5db3a294b998df8785b7a54d1c195">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;Explicit&quot;</span>; }
<a name="l00118"></a>00118 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">00124</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>;
<a name="l00125"></a>00125   
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="keyword">protected</span>:
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a47a97723cedc8a3e7ce0d9ebfd57f1ad">init_data</a> ();
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   
<a name="l00137"></a>00137 <span class="keyword">private</span>:
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   
<a name="l00144"></a>00144   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php#ada18af0e0b5d40b758ca271d99fbdd37">add_system_rhs</a> ();
<a name="l00145"></a>00145 };
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00150"></a>00150 <span class="comment">// ExplicitSystem inline methods</span>
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 } <span class="comment">// namespace libMesh</span>
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
