<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_inf_quad4.C</div>  </div>
</div>
<div class="contents">
<a href="face__inf__quad4_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_inf_quad4.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes cont&#39;d</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad4_8h.php">face_inf_quad4.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge2_8h.php">edge_edge2.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="edge__inf__edge2_8h.php">edge_inf_edge2.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// InfQuad4 class static member initializations</span>
<a name="l00042"></a>00042 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#adb98747649d9373f21e701261f961c02">InfQuad4::side_nodes_map</a>[3][2] =
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   {0, 1}, <span class="comment">// Side 0</span>
<a name="l00045"></a>00045   {1, 3}, <span class="comment">// Side 1</span>
<a name="l00046"></a>00046   {0, 2}  <span class="comment">// Side 2</span>
<a name="l00047"></a>00047 };
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>
<a name="l00053"></a>00053 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a48b7be18b04200ca1c713200cfecb3e4">InfQuad4::_embedding_matrix</a>[2][4][4] =
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <span class="comment">// embedding matrix for child 0</span>
<a name="l00056"></a>00056   {
<a name="l00057"></a>00057     <span class="comment">// 0    1    2    3rd parent node</span>
<a name="l00058"></a>00058     {1.0, 0.0, 0.0, 0.0}, <span class="comment">// 0th child node</span>
<a name="l00059"></a>00059     {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00060"></a>00060     {0.0, 0.0, 1.0, 0.0}, <span class="comment">// 2</span>
<a name="l00061"></a>00061     {0.0, 0.0, 0.5, 0.5}  <span class="comment">// 3</span>
<a name="l00062"></a>00062   },
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">// embedding matrix for child 1</span>
<a name="l00065"></a>00065   {
<a name="l00066"></a>00066     <span class="comment">// 0    1    2    3</span>
<a name="l00067"></a>00067     {0.5, 0.5, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00068"></a>00068     {0.0, 1.0, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00069"></a>00069     {0.0, 0.0, 0.5, 0.5}, <span class="comment">// 2</span>
<a name="l00070"></a>00070     {0.0, 0.0, 0.0, 1.0}  <span class="comment">// 3</span>
<a name="l00071"></a>00071   }
<a name="l00072"></a>00072 };
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="preprocessor">#endif</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00078"></a>00078 <span class="comment">// InfQuad4 class member functions</span>
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a401f39611cc6882d68113f82f177ed62">00080</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a401f39611cc6882d68113f82f177ed62">InfQuad4::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00081"></a>00081 <span class="keyword"></span>{
<a name="l00082"></a>00082   <span class="keywordflow">if</span> (i &lt; 2)
<a name="l00083"></a>00083     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00084"></a>00084   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#ac87dc576bf52ead8088763eedf759b48">00087</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#ac87dc576bf52ead8088763eedf759b48">InfQuad4::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword"></span>{
<a name="l00089"></a>00089   <span class="keywordflow">if</span> (i &lt; 2)
<a name="l00090"></a>00090     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00091"></a>00091   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a4e5cdf57370e6b4af31edab4639d7a98">00094</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a4e5cdf57370e6b4af31edab4639d7a98">InfQuad4::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00095"></a>00095 <span class="keyword"></span>{
<a name="l00096"></a>00096   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00097"></a>00097 }
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#ac8ff9bcafcb9bf3ed03b997efedbe9f8">00099</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#ac8ff9bcafcb9bf3ed03b997efedbe9f8">InfQuad4::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00100"></a>00100                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00101"></a>00101 <span class="keyword"></span>{
<a name="l00102"></a>00102   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1InfQuad.php#aa19a88f350e78b60e92e8a43a9509286">n_sides</a>());
<a name="l00103"></a>00103   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 2; ++i)
<a name="l00104"></a>00104     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfQuad4.php#adb98747649d9373f21e701261f961c02">side_nodes_map</a>[s][i] == n)
<a name="l00105"></a>00105       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00106"></a>00106   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a26ab1160efa931461e2f8ed3ed119407">00109</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a26ab1160efa931461e2f8ed3ed119407">InfQuad4::contains_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol)<span class="keyword"> const</span>
<a name="l00110"></a>00110 <span class="keyword"></span>{
<a name="l00111"></a>00111   <span class="comment">/*</span>
<a name="l00112"></a>00112 <span class="comment">   * make use of the fact that infinite elements do not</span>
<a name="l00113"></a>00113 <span class="comment">   * live inside the envelope.  Use a fast scheme to</span>
<a name="l00114"></a>00114 <span class="comment">   * check whether point \p p is inside or outside</span>
<a name="l00115"></a>00115 <span class="comment">   * our relevant part of the envelope.  Note that</span>
<a name="l00116"></a>00116 <span class="comment">   * this is not exclusive: the point may be outside</span>
<a name="l00117"></a>00117 <span class="comment">   * the envelope, but contained in another infinite element.</span>
<a name="l00118"></a>00118 <span class="comment">   * Therefore, if the distance is greater, do fall back</span>
<a name="l00119"></a>00119 <span class="comment">   * to the scheme of using FEInterface::inverse_map().</span>
<a name="l00120"></a>00120 <span class="comment">   */</span>
<a name="l00121"></a>00121   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfQuad.php#a2b5206551eb5cccfd6aa6e916ade746a">origin</a> (this-&gt;<a class="code" href="classlibMesh_1_1InfQuad.php#a2b5206551eb5cccfd6aa6e916ade746a">origin</a>());
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">/*</span>
<a name="l00124"></a>00124 <span class="comment">   * determine the minimal distance of the base from the origin</span>
<a name="l00125"></a>00125 <span class="comment">   * use size_sq() instead of size(), it is slightly faster</span>
<a name="l00126"></a>00126 <span class="comment">   */</span>
<a name="l00127"></a>00127   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> min_distance_sq = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((<a class="code" href="classlibMesh_1_1Point.php">Point</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)-origin)).size_sq(),
<a name="l00128"></a>00128                                         (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)-origin)).size_sq());
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="comment">/*</span>
<a name="l00131"></a>00131 <span class="comment">   * work with 1% allowable deviation.  Can still fall</span>
<a name="l00132"></a>00132 <span class="comment">   * back to the InfFE::inverse_map()</span>
<a name="l00133"></a>00133 <span class="comment">   */</span>
<a name="l00134"></a>00134   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> conservative_p_dist_sq = 1.01 * (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(p-origin).<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>());
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">if</span> (conservative_p_dist_sq &lt; min_distance_sq)
<a name="l00137"></a>00137     {
<a name="l00138"></a>00138       <span class="comment">/*</span>
<a name="l00139"></a>00139 <span class="comment">       * the physical point is definitely not contained</span>
<a name="l00140"></a>00140 <span class="comment">       * in the element, return false.</span>
<a name="l00141"></a>00141 <span class="comment">       */</span>
<a name="l00142"></a>00142       <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00143"></a>00143     }
<a name="l00144"></a>00144   <span class="keywordflow">else</span>
<a name="l00145"></a>00145     {
<a name="l00146"></a>00146       <span class="comment">/*</span>
<a name="l00147"></a>00147 <span class="comment">       * cannot say anything, fall back to the FEInterface::inverse_map()</span>
<a name="l00148"></a>00148 <span class="comment">       *</span>
<a name="l00149"></a>00149 <span class="comment">       * Declare a basic FEType.  Will use default in the base,</span>
<a name="l00150"></a>00150 <span class="comment">       * and something else (not important) in radial direction.</span>
<a name="l00151"></a>00151 <span class="comment">       */</span>
<a name="l00152"></a>00152       <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type(<a class="code" href="classlibMesh_1_1InfQuad4.php#a843e6a72abbc9a776ca589088b18dba1">default_order</a>());
<a name="l00153"></a>00153   
<a name="l00154"></a>00154       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> mapped_point = <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(<a class="code" href="classlibMesh_1_1InfQuad.php#a5edf2c42ea8fa08edb4eda2052769526">dim</a>(),
<a name="l00155"></a>00155                                                           fe_type,
<a name="l00156"></a>00156                                                           <span class="keyword">this</span>,
<a name="l00157"></a>00157                                                           p,
<a name="l00158"></a>00158                                                           tol,
<a name="l00159"></a>00159                                                           <span class="keyword">false</span>);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a5ed1b078cb472a00bf1b4cdb5cf28be7">FEInterface::on_reference_element</a>(mapped_point, this-&gt;<a class="code" href="classlibMesh_1_1InfQuad4.php#a56a48a55f400baad71dffaaba76de98b">type</a>(), tol);
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#af494bc2dcbb95502bbf1282bbc9ff7df">00168</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfQuad4.php#af494bc2dcbb95502bbf1282bbc9ff7df">InfQuad4::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00169"></a>00169                                     <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00170"></a>00170 <span class="keyword"></span>{
<a name="l00171"></a>00171   <span class="comment">// libmesh_assert (i &lt; this-&gt;n_sides());</span>
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keywordflow">if</span> (proxy)
<a name="l00174"></a>00174     {
<a name="l00175"></a>00175       <span class="keywordflow">switch</span> (i)
<a name="l00176"></a>00176         {
<a name="l00177"></a>00177           <span class="comment">// base</span>
<a name="l00178"></a>00178         <span class="keywordflow">case</span> 0:
<a name="l00179"></a>00179           {
<a name="l00180"></a>00180             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Edge2,InfQuad4&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00181"></a>00181             <span class="keywordflow">return</span> ap;
<a name="l00182"></a>00182           }
<a name="l00183"></a>00183           <span class="comment">// ifem edges</span>
<a name="l00184"></a>00184         <span class="keywordflow">case</span> 1:
<a name="l00185"></a>00185         <span class="keywordflow">case</span> 2:
<a name="l00186"></a>00186           {
<a name="l00187"></a>00187             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;InfEdge2,InfQuad4&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00188"></a>00188             <span class="keywordflow">return</span> ap;
<a name="l00189"></a>00189           }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191         <span class="keywordflow">default</span>:
<a name="l00192"></a>00192           libmesh_error();
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194     }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="keywordflow">else</span>
<a name="l00197"></a>00197     {
<a name="l00198"></a>00198       <span class="comment">// FIXME: Find out how to return non-proxy side</span>
<a name="l00199"></a>00199       libmesh_error();
<a name="l00200"></a>00200     }
<a name="l00201"></a>00201     
<a name="l00202"></a>00202   <span class="comment">// How did we get here</span>
<a name="l00203"></a>00203   libmesh_error();
<a name="l00204"></a>00204   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00205"></a>00205 }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a1da1e72e7ba37df2d25c653fadf9bcbb">00208</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a1da1e72e7ba37df2d25c653fadf9bcbb">InfQuad4::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00209"></a>00209                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00210"></a>00210                             std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00211"></a>00211 <span class="keyword"></span>{
<a name="l00212"></a>00212   libmesh_assert (sf &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfQuad4.php#a9ec08ec42aa44745c48666f0257a1225">n_sub_elem</a>());
<a name="l00213"></a>00213   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   conn.resize(4);
<a name="l00216"></a>00216   
<a name="l00217"></a>00217   <span class="keywordflow">switch</span> (iop)
<a name="l00218"></a>00218     {
<a name="l00219"></a>00219     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00220"></a>00220       {
<a name="l00221"></a>00221         conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00222"></a>00222         conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00223"></a>00223         conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00224"></a>00224         conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00225"></a>00225         <span class="keywordflow">return</span>;
<a name="l00226"></a>00226       }
<a name="l00227"></a>00227     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00228"></a>00228       {
<a name="l00229"></a>00229         conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0);
<a name="l00230"></a>00230         conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1);
<a name="l00231"></a>00231         conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3);
<a name="l00232"></a>00232         conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2);
<a name="l00233"></a>00233       }
<a name="l00234"></a>00234     <span class="keywordflow">default</span>:
<a name="l00235"></a>00235       libmesh_error();
<a name="l00236"></a>00236     }
<a name="l00237"></a>00237   
<a name="l00238"></a>00238   libmesh_error();
<a name="l00239"></a>00239 }
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 } <span class="comment">// namespace libMesh</span>
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00245"></a>00245 <span class="preprocessor"></span>
<a name="l00246"></a>00246 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
