<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_inf_quad4.h</div>  </div>
</div>
<div class="contents">
<a href="face__inf__quad4_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_inf_quad4.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __inf_quad4_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __inf_quad4_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="comment">// C++ includes</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad_8h.php">face_inf_quad.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// InfQuad4 class definition</span>
<a name="l00056"></a><a class="code" href="classlibMesh_1_1InfQuad4.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfQuad4.php">InfQuad4</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1InfQuad.php">InfQuad</a>
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00059"></a>00059 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a0561a697c429463d02ec4eeda8086f89">00063</a>   <a class="code" href="classlibMesh_1_1InfQuad4.php#a0561a697c429463d02ec4eeda8086f89">InfQuad4</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL) :
<a name="l00064"></a>00064     <a class="code" href="classlibMesh_1_1InfQuad.php">InfQuad</a>(<a class="code" href="classlibMesh_1_1InfQuad4.php">InfQuad4</a>::<a class="code" href="classlibMesh_1_1InfQuad4.php#a6b2dbcee94bd6903366ff7f4a86b3f86">n_nodes</a>(), p) {}
<a name="l00065"></a>00065 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#ace7bb5b9975aa8cb9ba6123d09145aa6">00070</a>   <a class="code" href="classlibMesh_1_1InfQuad4.php#a0561a697c429463d02ec4eeda8086f89">InfQuad4</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00071"></a>00071             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00072"></a>00072             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00073"></a>00073     <a class="code" href="classlibMesh_1_1InfQuad.php">InfQuad</a>(nn, ns, p) {}
<a name="l00074"></a>00074   
<a name="l00078"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a6b2dbcee94bd6903366ff7f4a86b3f86">00078</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a6b2dbcee94bd6903366ff7f4a86b3f86">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a56a48a55f400baad71dffaaba76de98b">00083</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1InfQuad4.php#a56a48a55f400baad71dffaaba76de98b">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>; }
<a name="l00084"></a>00084   
<a name="l00088"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a9ec08ec42aa44745c48666f0257a1225">00088</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a9ec08ec42aa44745c48666f0257a1225">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00089"></a>00089   
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a401f39611cc6882d68113f82f177ed62">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#ac87dc576bf52ead8088763eedf759b48">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00099"></a>00099 
<a name="l00103"></a>00103   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a4e5cdf57370e6b4af31edab4639d7a98">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="comment">/*</span>
<a name="l00106"></a>00106 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00107"></a>00107 <span class="comment">   * specified side</span>
<a name="l00108"></a>00108 <span class="comment">   */</span>
<a name="l00109"></a>00109   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#ac8ff9bcafcb9bf3ed03b997efedbe9f8">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00110"></a>00110                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00111"></a>00111   
<a name="l00112"></a>00112   <span class="comment">/*</span>
<a name="l00113"></a>00113 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00114"></a>00114 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00115"></a>00115 <span class="comment">   */</span>
<a name="l00116"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#aaab27a8daacf5274dee8f6bb5f4cf6d3">00116</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#aaab27a8daacf5274dee8f6bb5f4cf6d3">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00117"></a>00117                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00118"></a>00118 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1InfQuad4.php#ac8ff9bcafcb9bf3ed03b997efedbe9f8">is_node_on_side</a>(n,e); }
<a name="l00119"></a>00119   
<a name="l00123"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a843e6a72abbc9a776ca589088b18dba1">00123</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1InfQuad4.php#a843e6a72abbc9a776ca589088b18dba1">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00124"></a>00124   
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfQuad4.php#af494bc2dcbb95502bbf1282bbc9ff7df">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00130"></a>00130                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a1da1e72e7ba37df2d25c653fadf9bcbb">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00133"></a>00133                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00134"></a>00134                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="comment">//   void tecplot_connectivity(const unsigned int sf,</span>
<a name="l00137"></a>00137 <span class="comment">//                          std::vector&lt;unsigned int&gt;&amp; conn) const;</span>
<a name="l00138"></a>00138   
<a name="l00139"></a>00139 <span class="comment">//   void vtk_connectivity(const unsigned int sc,</span>
<a name="l00140"></a>00140 <span class="comment">//                      std::vector&lt;unsigned int&gt;*conn = NULL) const;</span>
<a name="l00141"></a>00141   
<a name="l00142"></a>00142 <span class="comment">//   unsigned int vtk_element_type (const unsigned int) const</span>
<a name="l00143"></a>00143 <span class="comment">//   { return 9; }</span>
<a name="l00144"></a>00144   
<a name="l00151"></a>00151   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a26ab1160efa931461e2f8ed3ed119407">contains_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol=TOLERANCE) <span class="keyword">const</span>;
<a name="l00152"></a>00152 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#adb98747649d9373f21e701261f961c02">00157</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#adb98747649d9373f21e701261f961c02">side_nodes_map</a>[3][2];
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   
<a name="l00160"></a>00160 <span class="keyword">protected</span>:
<a name="l00161"></a>00161   
<a name="l00162"></a>00162   
<a name="l00163"></a>00163 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>  
<a name="l00168"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#aca40602d0c9f19dd93bed30d8adbdc7f">00168</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#aca40602d0c9f19dd93bed30d8adbdc7f">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00169"></a>00169                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00170"></a>00170                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00171"></a>00171 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a48b7be18b04200ca1c713200cfecb3e4">_embedding_matrix</a>[i][j][k]; }
<a name="l00172"></a>00172 
<a name="l00177"></a><a class="code" href="classlibMesh_1_1InfQuad4.php#a48b7be18b04200ca1c713200cfecb3e4">00177</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfQuad4.php#a48b7be18b04200ca1c713200cfecb3e4">_embedding_matrix</a>[2][4][4];
<a name="l00178"></a>00178   
<a name="l00179"></a>00179 <span class="preprocessor">#endif</span>
<a name="l00180"></a>00180 <span class="preprocessor"></span>    
<a name="l00181"></a>00181 };
<a name="l00182"></a>00182   
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 } <span class="comment">// namespace libMesh</span>
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00187"></a>00187 <span class="preprocessor"></span>
<a name="l00188"></a>00188 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
