<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_inf_quad6.C</div>  </div>
</div>
<div class="contents">
<a href="face__inf__quad6_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_inf_quad6.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes cont&#39;d</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad6_8h.php">face_inf_quad6.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="edge__inf__edge2_8h.php">edge_inf_edge2.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// InfQuad6 class static member initializations</span>
<a name="l00041"></a>00041 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#ad640d8e81299baf8e247a829d4363350">InfQuad6::side_nodes_map</a>[3][3] =
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   {0, 1, 4}, <span class="comment">// Side 0</span>
<a name="l00044"></a>00044   {1, 3},    <span class="comment">// Side 1</span>
<a name="l00045"></a>00045   {0, 2}     <span class="comment">// Side 2</span>
<a name="l00046"></a>00046 };
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// InfQuad6 class member functions</span>
<a name="l00051"></a>00051 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1InfQuad6.php#a429c5a4543e7de6e787e444359599726">00052</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#a429c5a4543e7de6e787e444359599726">InfQuad6::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00053"></a>00053 <span class="keyword"></span>{
<a name="l00054"></a>00054   <span class="keywordflow">if</span> (i &lt; 2)
<a name="l00055"></a>00055     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00056"></a>00056   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1InfQuad6.php#a571ed54275bdc3a90112353c6fefee71">00059</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#a571ed54275bdc3a90112353c6fefee71">InfQuad6::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00060"></a>00060 <span class="keyword"></span>{
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (i &lt; 2)
<a name="l00062"></a>00062     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00063"></a>00063   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1InfQuad6.php#aa495f58924adb8157a6f829af6df5dd7">00066</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#aa495f58924adb8157a6f829af6df5dd7">InfQuad6::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00067"></a>00067 <span class="keyword"></span>{
<a name="l00068"></a>00068   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00069"></a>00069 }
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classlibMesh_1_1InfQuad6.php#ad25b5703609e8d95fe3229820e184a20">00071</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#ad25b5703609e8d95fe3229820e184a20">InfQuad6::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00072"></a>00072                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00073"></a>00073 <span class="keyword"></span>{
<a name="l00074"></a>00074   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1InfQuad.php#aa19a88f350e78b60e92e8a43a9509286">n_sides</a>());
<a name="l00075"></a>00075   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00076"></a>00076     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfQuad6.php#ad640d8e81299baf8e247a829d4363350">side_nodes_map</a>[s][i] == n)
<a name="l00077"></a>00077       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00078"></a>00078   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>
<a name="l00083"></a>00083 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#a0e10d47f30441e5bb6f57dc44be02cbe">InfQuad6::_embedding_matrix</a>[2][6][6] =
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085   <span class="comment">// embedding matrix for child 0</span>
<a name="l00086"></a>00086   {
<a name="l00087"></a>00087     <span class="comment">//     0       1       2       3       4       5th parent node</span>
<a name="l00088"></a>00088     {    1.0,    0.0,    0.0,    0.0,    0.0,    0.0 }, <span class="comment">// 0th child node</span>
<a name="l00089"></a>00089     {    0.0,    0.0,    0.0,    0.0,    1.0,    0.0 }, <span class="comment">// 1</span>
<a name="l00090"></a>00090     {    0.0,    0.0,    1.0,    0.0,    0.0,    0.0 }, <span class="comment">// 2</span>
<a name="l00091"></a>00091     {    0.0,    0.0,    0.0,    0.0,    0.0,    1.0 }, <span class="comment">// 3</span>
<a name="l00092"></a>00092     {  0.375, -0.125,    0.0,    0.0,   0.75,    0.0 }, <span class="comment">// 4</span>
<a name="l00093"></a>00093     {    0.0,    0.0,  0.375, -0.125,    0.0,   0.75 }  <span class="comment">// 5</span>
<a name="l00094"></a>00094   },
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">// embedding matrix for child 1</span>
<a name="l00097"></a>00097   {
<a name="l00098"></a>00098     <span class="comment">//     0       1       2       3       4       5th parent node</span>
<a name="l00099"></a>00099     {    0.0,    0.0,    0.0,    0.0,    1.0,    0.0 }, <span class="comment">// 0th child node</span>
<a name="l00100"></a>00100     {    0.0,    1.0,    0.0,    0.0,    0.0,    0.0 }, <span class="comment">// 1</span>
<a name="l00101"></a>00101     {    0.0,    0.0,    0.0,    0.0,    0.0,    1.0 }, <span class="comment">// 2</span>
<a name="l00102"></a>00102     {    0.0,    0.0,    0.0,    1.0,    0.0,    0.0 }, <span class="comment">// 3</span>
<a name="l00103"></a>00103     { -0.125,  0.375,    0.0,    0.0,   0.75,    0.0 }, <span class="comment">// 4</span>
<a name="l00104"></a>00104     {    0.0,    0.0, -0.125,  0.375,    0.0,   0.75 }  <span class="comment">// 5</span>
<a name="l00105"></a>00105   }
<a name="l00106"></a>00106 };
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="preprocessor">#endif</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span>
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1InfQuad6.php#a934ec07f8886f646d50353a5bb9c0a09">00113</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfQuad6.php#a934ec07f8886f646d50353a5bb9c0a09">InfQuad6::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00114"></a>00114                                     <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00115"></a>00115 <span class="keyword"></span>{
<a name="l00116"></a>00116   <span class="comment">// libmesh_assert (i &lt; this-&gt;n_sides());</span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="keywordflow">if</span> (proxy)
<a name="l00119"></a>00119     {
<a name="l00120"></a>00120       <span class="keywordflow">switch</span> (i)
<a name="l00121"></a>00121         {
<a name="l00122"></a>00122         <span class="keywordflow">case</span> 0:
<a name="l00123"></a>00123           {
<a name="l00124"></a>00124             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Edge3,InfQuad6&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00125"></a>00125             <span class="keywordflow">return</span> ap;
<a name="l00126"></a>00126           }
<a name="l00127"></a>00127         <span class="keywordflow">case</span> 1:
<a name="l00128"></a>00128         <span class="keywordflow">case</span> 2:
<a name="l00129"></a>00129           {
<a name="l00130"></a>00130             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;InfEdge2,InfQuad6&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00131"></a>00131             <span class="keywordflow">return</span> ap;
<a name="l00132"></a>00132           }
<a name="l00133"></a>00133         <span class="keywordflow">default</span>:
<a name="l00134"></a>00134           libmesh_error();
<a name="l00135"></a>00135         }
<a name="l00136"></a>00136     }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keywordflow">else</span>
<a name="l00139"></a>00139     {
<a name="l00140"></a>00140       <span class="keywordflow">switch</span> (i)
<a name="l00141"></a>00141         {
<a name="l00142"></a>00142         <span class="keywordflow">case</span> 0:
<a name="l00143"></a>00143           {
<a name="l00144"></a>00144             <a class="code" href="classlibMesh_1_1Edge3.php">Edge3</a>* edge = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge3.php">Edge3</a>;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00147"></a>00147             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00148"></a>00148             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00149"></a>00149         
<a name="l00150"></a>00150             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00151"></a>00151           }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153         <span class="keywordflow">case</span> 1:
<a name="l00154"></a>00154           {
<a name="l00155"></a>00155             <span class="comment">// adjacent to another infinite element     </span>
<a name="l00156"></a>00156             <a class="code" href="classlibMesh_1_1InfEdge2.php">InfEdge2</a>* edge = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfEdge2.php">InfEdge2</a>;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00159"></a>00159             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00162"></a>00162           }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164         <span class="keywordflow">case</span> 2:
<a name="l00165"></a>00165           {
<a name="l00166"></a>00166             <span class="comment">// adjacent to another infinite element     </span>
<a name="l00167"></a>00167             <a class="code" href="classlibMesh_1_1InfEdge2.php">InfEdge2</a>* edge = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfEdge2.php">InfEdge2</a>;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0); <span class="comment">// be aware of swapped nodes,</span>
<a name="l00170"></a>00170             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2); <span class="comment">// compared to conventional side numbering</span>
<a name="l00171"></a>00171 
<a name="l00172"></a>00172             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00173"></a>00173           }
<a name="l00174"></a>00174         <span class="keywordflow">default</span>:
<a name="l00175"></a>00175           {
<a name="l00176"></a>00176             libmesh_error();
<a name="l00177"></a>00177             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00178"></a>00178           }
<a name="l00179"></a>00179         }
<a name="l00180"></a>00180     }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">// We will never get here...  </span>
<a name="l00183"></a>00183   libmesh_error();
<a name="l00184"></a>00184   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a><a class="code" href="classlibMesh_1_1InfQuad6.php#ad1c549ad9f0cc78dd488d68d087f8c7a">00190</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#ad1c549ad9f0cc78dd488d68d087f8c7a">InfQuad6::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00191"></a>00191                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00192"></a>00192                             std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00193"></a>00193 <span class="keyword"></span>{
<a name="l00194"></a>00194   libmesh_assert (sf &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfQuad6.php#a56c088dffd199442391bc22eca1c66a4">n_sub_elem</a>());
<a name="l00195"></a>00195   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   conn.resize(4);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199   <span class="keywordflow">switch</span> (iop)
<a name="l00200"></a>00200     {
<a name="l00201"></a>00201     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00202"></a>00202       {
<a name="l00203"></a>00203         <span class="keywordflow">switch</span>(sf)
<a name="l00204"></a>00204           {
<a name="l00205"></a>00205           <span class="keywordflow">case</span> 0:
<a name="l00206"></a>00206             <span class="comment">// linear sub-quad 0</span>
<a name="l00207"></a>00207             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00208"></a>00208             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00209"></a>00209             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00210"></a>00210             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00211"></a>00211 
<a name="l00212"></a>00212             <span class="keywordflow">return</span>;
<a name="l00213"></a>00213 
<a name="l00214"></a>00214           <span class="keywordflow">case</span> 1:
<a name="l00215"></a>00215             <span class="comment">// linear sub-quad 1</span>
<a name="l00216"></a>00216             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00217"></a>00217             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00218"></a>00218             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00219"></a>00219             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00220"></a>00220 
<a name="l00221"></a>00221             <span class="keywordflow">return</span>;
<a name="l00222"></a>00222             
<a name="l00223"></a>00223           <span class="keywordflow">default</span>:
<a name="l00224"></a>00224             libmesh_error();
<a name="l00225"></a>00225           }
<a name="l00226"></a>00226       }
<a name="l00227"></a>00227       
<a name="l00228"></a>00228     <span class="keywordflow">default</span>:
<a name="l00229"></a>00229       libmesh_error();
<a name="l00230"></a>00230     }
<a name="l00231"></a>00231   
<a name="l00232"></a>00232   libmesh_error();
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a><a class="code" href="classlibMesh_1_1InfQuad6.php#a8261f8bc986da4176001434555c47032">00238</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#a8261f8bc986da4176001434555c47032">InfQuad6::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00239"></a>00239                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00240"></a>00240 <span class="keyword"></span>{ 
<a name="l00241"></a>00241   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1InfQuad.php#a910b1c5d4dd1e68f6aee7c3daa3cec44">n_vertices</a>());
<a name="l00242"></a>00242   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classlibMesh_1_1InfQuad6.php#af13f1519524d8c0a9a199d9483338371">n_nodes</a>());
<a name="l00243"></a>00243   libmesh_assert (v &lt; 2);
<a name="l00244"></a>00244   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#af2137cdb5ee0ce0e3b3970ece1606b3d">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classlibMesh_1_1InfQuad.php#a910b1c5d4dd1e68f6aee7c3daa3cec44">n_vertices</a>()][v]; 
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad6.php#af2137cdb5ee0ce0e3b3970ece1606b3d">InfQuad6::_second_order_adjacent_vertices</a>[2][2] = 
<a name="l00250"></a>00250 {
<a name="l00251"></a>00251   {0, 1}, <span class="comment">// vertices adjacent to node 4</span>
<a name="l00252"></a>00252   {2, 3}  <span class="comment">// vertices adjacent to node 5  </span>
<a name="l00253"></a>00253 };
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00258"></a><a class="code" href="classlibMesh_1_1InfQuad6.php#ae76dff4a096b044701fd5ed97b39c7dc">00258</a> <a class="code" href="classlibMesh_1_1InfQuad6.php#ae76dff4a096b044701fd5ed97b39c7dc">InfQuad6::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00259"></a>00259 <span class="keyword"></span>{
<a name="l00260"></a>00260   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1InfQuad.php#a910b1c5d4dd1e68f6aee7c3daa3cec44">n_vertices</a>());
<a name="l00261"></a>00261   libmesh_assert (n &lt; this-&gt;<a class="code" href="classlibMesh_1_1InfQuad6.php#af13f1519524d8c0a9a199d9483338371">n_nodes</a>());
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00264"></a>00264     (0, 2*n-7);
<a name="l00265"></a>00265 }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 } <span class="comment">// namespace libMesh</span>
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
