<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_inf_quad.h</div>  </div>
</div>
<div class="contents">
<a href="face__inf__quad_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_inf_quad.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __face_inf_quad_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __face_inf_quad_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00061"></a>00061 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00062"></a>00062 <span class="comment">// InfQuad class definition</span>
<a name="l00063"></a><a class="code" href="classlibMesh_1_1InfQuad.php">00063</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfQuad.php">InfQuad</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065 <span class="keyword">public</span>:
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1InfQuad.php#aaa7583fdd82690bf96eb79104e3500bb">00070</a>   <a class="code" href="classlibMesh_1_1InfQuad.php#aaa7583fdd82690bf96eb79104e3500bb">InfQuad</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00071"></a>00071            <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00072"></a>00072     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>(nn, <a class="code" href="classlibMesh_1_1InfQuad.php">InfQuad</a>::<a class="code" href="classlibMesh_1_1InfQuad.php#aa19a88f350e78b60e92e8a43a9509286">n_sides</a>(), p) {}
<a name="l00073"></a>00073 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1InfQuad.php#a17ecf7ff6645662171e447d703ca37c6">00078</a>   <a class="code" href="classlibMesh_1_1InfQuad.php#aaa7583fdd82690bf96eb79104e3500bb">InfQuad</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00079"></a>00079            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00080"></a>00080            <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00081"></a>00081     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>(nn, ns, p) {}
<a name="l00082"></a>00082  
<a name="l00086"></a><a class="code" href="classlibMesh_1_1InfQuad.php#a5edf2c42ea8fa08edb4eda2052769526">00086</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad.php#a5edf2c42ea8fa08edb4eda2052769526">dim</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="comment">//   /**</span>
<a name="l00089"></a>00089 <span class="comment">//    * @returns 2 for the base, 1 otherwise</span>
<a name="l00090"></a>00090 <span class="comment">//    */</span>
<a name="l00091"></a>00091 <span class="comment">//   unsigned int n_children_per_side(const unsigned int s) const;</span>
<a name="l00092"></a>00092 
<a name="l00098"></a><a class="code" href="classlibMesh_1_1InfQuad.php#aa19a88f350e78b60e92e8a43a9509286">00098</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad.php#aa19a88f350e78b60e92e8a43a9509286">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classlibMesh_1_1InfQuad.php#a910b1c5d4dd1e68f6aee7c3daa3cec44">00103</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad.php#a910b1c5d4dd1e68f6aee7c3daa3cec44">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00104"></a>00104 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1InfQuad.php#a3046f65e29ad8f796a70dfe2d2c0273d">00109</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad.php#a3046f65e29ad8f796a70dfe2d2c0273d">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00110"></a>00110 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1InfQuad.php#a5cdddc53bb116b23c969e8bd6efa173d">00115</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad.php#a5cdddc53bb116b23c969e8bd6efa173d">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00116"></a>00116   
<a name="l00120"></a><a class="code" href="classlibMesh_1_1InfQuad.php#abc58de8d55e45b3fa2c0722b2e2d521e">00120</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad.php#abc58de8d55e45b3fa2c0722b2e2d521e">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00121"></a>00121   
<a name="l00122"></a>00122   <span class="comment">/*</span>
<a name="l00123"></a>00123 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00124"></a>00124 <span class="comment">   * specified side</span>
<a name="l00125"></a>00125 <span class="comment">   */</span>
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad.php#a29a5d429de0929a514002f3929dbc3ae">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00127"></a>00127                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00128"></a>00128   
<a name="l00134"></a>00134   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfQuad.php#a87367cb951ed6f45cc53067a4d318256">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00135"></a>00135 
<a name="l00140"></a>00140   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfQuad.php#a88da816de7b2e433a49a3bebac29da08">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00141"></a>00141   
<a name="l00145"></a><a class="code" href="classlibMesh_1_1InfQuad.php#a9ed413557011f4a82e4f01756a7ff1fa">00145</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1InfQuad.php#a9ed413557011f4a82e4f01756a7ff1fa">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00146"></a>00146 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(i); }
<a name="l00147"></a>00147 
<a name="l00152"></a>00152   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfQuad.php#a5eb014db8665a389348264819d7d14e9">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00153"></a>00153 
<a name="l00159"></a>00159   std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1InfQuad.php#a7d68c7f9b3edd505277b28366ecf2c6b">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00160"></a>00160 
<a name="l00165"></a><a class="code" href="classlibMesh_1_1InfQuad.php#a4a663fbcfc2b9374dec052130140315d">00165</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfQuad.php#a4a663fbcfc2b9374dec052130140315d">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00166"></a>00166 
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfQuad.php#a2b5206551eb5cccfd6aa6e916ade746a">origin</a> () <span class="keyword">const</span>;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 };
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00177"></a>00177 <span class="comment">// InfQuad class member functions</span>
<a name="l00178"></a>00178 <span class="comment">// inline</span>
<a name="l00179"></a>00179 <span class="comment">// unsigned int InfQuad::n_children_per_side(const unsigned int s) const</span>
<a name="l00180"></a>00180 <span class="comment">// {</span>
<a name="l00181"></a>00181 <span class="comment">//   libmesh_assert (s &lt; this-&gt;n_sides());</span>
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="comment">//   switch (s)</span>
<a name="l00184"></a>00184 <span class="comment">//   {</span>
<a name="l00185"></a>00185 <span class="comment">//     case 0:</span>
<a name="l00186"></a>00186 <span class="comment">//       // every infinite face has 2 children in the base edge</span>
<a name="l00187"></a>00187 <span class="comment">//       return 2;</span>
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="comment">//     default:</span>
<a name="l00190"></a>00190 <span class="comment">//       // on infinite edges only 1 child</span>
<a name="l00191"></a>00191 <span class="comment">//       return 1;</span>
<a name="l00192"></a>00192 <span class="comment">//   }</span>
<a name="l00193"></a>00193 <span class="comment">// }</span>
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="keyword">inline</span>
<a name="l00198"></a><a class="code" href="classlibMesh_1_1InfQuad.php#a2b5206551eb5cccfd6aa6e916ade746a">00198</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfQuad.php#a2b5206551eb5cccfd6aa6e916ade746a">InfQuad::origin</a> ()<span class="keyword"> const</span>
<a name="l00199"></a>00199 <span class="keyword"></span>{
<a name="l00200"></a>00200   <span class="keywordflow">return</span> ( this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)*2 - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(this-&gt;<a class="code" href="classlibMesh_1_1InfQuad.php#a910b1c5d4dd1e68f6aee7c3daa3cec44">n_vertices</a>()/2) );
<a name="l00201"></a>00201 }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 } <span class="comment">// namespace libMesh</span>
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00208"></a>00208 <span class="preprocessor"></span>
<a name="l00209"></a>00209 <span class="preprocessor">#endif</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span>
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
