<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_quad4.h</div>  </div>
</div>
<div class="contents">
<a href="face__quad4_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad4.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quad4_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quad4_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__quad_8h.php">face_quad.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward declarations</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00058"></a>00058 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00059"></a>00059 <span class="comment">// Quad4 class definition</span>
<a name="l00060"></a><a class="code" href="classlibMesh_1_1Quad4.php">00060</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Quad4.php">Quad4</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062 <span class="keyword">public</span>:
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1Quad4.php#a861535cb817502fc970e47c08a6aa138">00067</a>   <a class="code" href="classlibMesh_1_1Quad4.php#a861535cb817502fc970e47c08a6aa138">Quad4</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL) :
<a name="l00068"></a>00068     <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>(<a class="code" href="classlibMesh_1_1Quad.php">Quad</a>::<a class="code" href="classlibMesh_1_1Quad.php#a476faee1f5146b9fba768c9641bc175a">n_nodes</a>(), p) {}
<a name="l00069"></a>00069 
<a name="l00074"></a><a class="code" href="classlibMesh_1_1Quad4.php#a94ec820677c7bf2a23b9cb5ff60a5e4e">00074</a>   <a class="code" href="classlibMesh_1_1Quad4.php#a861535cb817502fc970e47c08a6aa138">Quad4</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00075"></a>00075          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00076"></a>00076          <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00077"></a>00077     <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>(nn, ns, p) {}
<a name="l00078"></a>00078   
<a name="l00082"></a><a class="code" href="classlibMesh_1_1Quad4.php#af7c1efbccfec9dd1a21e831ab3ead9d9">00082</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Quad4.php#af7c1efbccfec9dd1a21e831ab3ead9d9">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>; }
<a name="l00083"></a>00083   
<a name="l00087"></a><a class="code" href="classlibMesh_1_1Quad4.php#a85cee9dd95e099ac357580f0b2568e27">00087</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad4.php#a85cee9dd95e099ac357580f0b2568e27">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00088"></a>00088   
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad4.php#a2b27cc0f4494b929181e2a43d3dd3ef6">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00093"></a>00093 
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad4.php#ab21c762d39b1d09def3ad13d071bbb9c">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00098"></a>00098 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad4.php#a4bb1638eafc528eda79657c4e454a0bb">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00103"></a>00103   
<a name="l00104"></a>00104   <span class="comment">/*</span>
<a name="l00105"></a>00105 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00106"></a>00106 <span class="comment">   * specified side</span>
<a name="l00107"></a>00107 <span class="comment">   */</span>
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad4.php#a938599c3e03c759a4d7c5b471e9a8d5a">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00109"></a>00109                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00110"></a>00110   
<a name="l00111"></a>00111   <span class="comment">/*</span>
<a name="l00112"></a>00112 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00113"></a>00113 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00114"></a>00114 <span class="comment">   */</span>
<a name="l00115"></a><a class="code" href="classlibMesh_1_1Quad4.php#afebba24f1aa4dfd2d5c187a35bc282b1">00115</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad4.php#afebba24f1aa4dfd2d5c187a35bc282b1">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00116"></a>00116                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00117"></a>00117 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Quad4.php#a938599c3e03c759a4d7c5b471e9a8d5a">is_node_on_side</a>(n,e); }
<a name="l00118"></a>00118   
<a name="l00119"></a>00119   <span class="comment">/*</span>
<a name="l00120"></a>00120 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00121"></a>00121 <span class="comment">   * numerical tolerances</span>
<a name="l00122"></a>00122 <span class="comment">   */</span>
<a name="l00123"></a>00123   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad4.php#a218c98eb69b0b47268ce7449f8e34e44">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00124"></a>00124 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1Quad4.php#a5b7f66cd755844d39f35fd1c4086961f">00128</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1Quad4.php#a5b7f66cd755844d39f35fd1c4086961f">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00129"></a>00129   
<a name="l00130"></a>00130   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Quad4.php#a96207f007e16e5255e068f227aeded09">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00131"></a>00131                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Quad4.php#a26a0f8ef50db530f47e66c60b6cbbbaa">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00134"></a>00134                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00135"></a>00135                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00136"></a>00136 
<a name="l00141"></a><a class="code" href="classlibMesh_1_1Quad4.php#a5a80c5ee579b48bb615c0605c7dc5a0e">00141</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad4.php#a5a80c5ee579b48bb615c0605c7dc5a0e">side_nodes_map</a>[4][2];
<a name="l00142"></a>00142 
<a name="l00148"></a>00148   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Quad4.php#a71a1f6a23fa645af5e5814f12fcce00c">volume</a> () <span class="keyword">const</span>;
<a name="l00149"></a>00149   
<a name="l00150"></a>00150 <span class="keyword">protected</span>:
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   
<a name="l00153"></a>00153 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span>  
<a name="l00158"></a><a class="code" href="classlibMesh_1_1Quad4.php#a02596b0e607e94a590267a15005517cc">00158</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Quad4.php#a02596b0e607e94a590267a15005517cc">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00159"></a>00159                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00160"></a>00160                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00161"></a>00161 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Quad4.php#a4bae65a0ab6a907ef177fc60986711d9">_embedding_matrix</a>[i][j][k]; }
<a name="l00162"></a>00162 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1Quad4.php#a4bae65a0ab6a907ef177fc60986711d9">00167</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Quad4.php#a4bae65a0ab6a907ef177fc60986711d9">_embedding_matrix</a>[4][4][4];
<a name="l00168"></a>00168   
<a name="l00169"></a>00169 <span class="preprocessor">#endif</span>
<a name="l00170"></a>00170 <span class="preprocessor"></span>    
<a name="l00171"></a>00171 };
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 } <span class="comment">// namespace libMesh</span>
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
