<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_quad8.h</div>  </div>
</div>
<div class="contents">
<a href="face__quad8_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad8.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quad8_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quad8_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__quad_8h.php">face_quad.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span>Mesh;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00059"></a>00059 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00060"></a>00060 <span class="comment">// Quad8 class definition</span>
<a name="l00061"></a><a class="code" href="classlibMesh_1_1Quad8.php">00061</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Quad8.php">Quad8</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063 <span class="keyword">public</span>:
<a name="l00064"></a>00064 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1Quad8.php#a5c66ac6d1d7e0776f9915b13427b277c">00068</a>   <a class="code" href="classlibMesh_1_1Quad8.php#a5c66ac6d1d7e0776f9915b13427b277c">Quad8</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL) :
<a name="l00069"></a>00069     <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>(<a class="code" href="classlibMesh_1_1Quad8.php">Quad8</a>::<a class="code" href="classlibMesh_1_1Quad8.php#aa71c251ad77ab4428ab7ddb53d05fae9">n_nodes</a>(), p) {}
<a name="l00070"></a>00070  
<a name="l00075"></a><a class="code" href="classlibMesh_1_1Quad8.php#a78731d31ee761c363b801dcff71c88a9">00075</a>   <a class="code" href="classlibMesh_1_1Quad8.php#a5c66ac6d1d7e0776f9915b13427b277c">Quad8</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00076"></a>00076          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00077"></a>00077          <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00078"></a>00078     <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>(nn, ns, p) {}
<a name="l00079"></a>00079   
<a name="l00083"></a><a class="code" href="classlibMesh_1_1Quad8.php#a5437f013facfe2d8d0bde486782edddb">00083</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Quad8.php#a5437f013facfe2d8d0bde486782edddb">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>; }
<a name="l00084"></a>00084 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1Quad8.php#aa71c251ad77ab4428ab7ddb53d05fae9">00088</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad8.php#aa71c251ad77ab4428ab7ddb53d05fae9">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 8; }
<a name="l00089"></a>00089   
<a name="l00093"></a><a class="code" href="classlibMesh_1_1Quad8.php#a379ce49249ea352b0807f1a9e89072d7">00093</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad8.php#a379ce49249ea352b0807f1a9e89072d7">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00094"></a>00094   
<a name="l00098"></a><a class="code" href="classlibMesh_1_1Quad8.php#a7bd27145ba22fbb49233ceffa12f0ebf">00098</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad8.php#a7bd27145ba22fbb49233ceffa12f0ebf">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00099"></a>00099   
<a name="l00103"></a><a class="code" href="classlibMesh_1_1Quad8.php#a3cb5afdf1bcd3e5f76d8e3563b024d4a">00103</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad8.php#a3cb5afdf1bcd3e5f76d8e3563b024d4a">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 5; }
<a name="l00104"></a>00104   
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad8.php#a4daf13bf0d53d82249c5567e8ce0c6bd">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00109"></a>00109 
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad8.php#a36d044245e576dada834f31d80bb0265">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00114"></a>00114 
<a name="l00118"></a>00118   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad8.php#ad7c6c76a6d377bd93db84c4ed0f4bd7d">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00119"></a>00119   
<a name="l00120"></a>00120   <span class="comment">/*</span>
<a name="l00121"></a>00121 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00122"></a>00122 <span class="comment">   * specified side</span>
<a name="l00123"></a>00123 <span class="comment">   */</span>
<a name="l00124"></a>00124   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad8.php#ab40d2ff1ef819978396d8d6cc88a0f59">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00125"></a>00125                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00126"></a>00126   
<a name="l00127"></a>00127   <span class="comment">/*</span>
<a name="l00128"></a>00128 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00129"></a>00129 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00130"></a>00130 <span class="comment">   */</span>
<a name="l00131"></a><a class="code" href="classlibMesh_1_1Quad8.php#aa0f837902ac36f44e784b26212a8ead2">00131</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad8.php#aa0f837902ac36f44e784b26212a8ead2">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00132"></a>00132                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00133"></a>00133 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Quad8.php#ab40d2ff1ef819978396d8d6cc88a0f59">is_node_on_side</a>(n,e); }
<a name="l00134"></a>00134   
<a name="l00135"></a>00135   <span class="comment">/*</span>
<a name="l00136"></a>00136 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00137"></a>00137 <span class="comment">   * numerical tolerances</span>
<a name="l00138"></a>00138 <span class="comment">   */</span>
<a name="l00139"></a>00139   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad8.php#acfead1493f4503cf4a987d4438986e5b">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1Quad8.php#ab9d2cd312b44d62eaff589f6be0015ea">00144</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1Quad8.php#ab9d2cd312b44d62eaff589f6be0015ea">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00145"></a>00145 
<a name="l00155"></a>00155   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad8.php#aaf753aba1af2b5c2250bad9b99a1e0f4">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00156"></a>00156   
<a name="l00157"></a>00157   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Quad8.php#a7a8707ed628c69f17c47803325d6ccd9">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00158"></a>00158                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Quad8.php#a4454a7f0e88185e7b1472084c353cc5c">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00161"></a>00161                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00162"></a>00162                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1Quad8.php#ae0e8f58b3e6e45a3ea5e5e3c06b218a4">00167</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad8.php#ae0e8f58b3e6e45a3ea5e5e3c06b218a4">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00168"></a>00168 <span class="keyword">  </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00169"></a>00169 
<a name="l00175"></a>00175   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad8.php#adeefbb921c052d94f0f1f6a3b8f94621">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00176"></a>00176                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00177"></a>00177 
<a name="l00187"></a>00187   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00188"></a>00188           <a class="code" href="classlibMesh_1_1Quad8.php#a3f7ac56ca3192f8c1f50db0215c787ef">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00189"></a>00189 
<a name="l00194"></a><a class="code" href="classlibMesh_1_1Quad8.php#a04f7eea33c0833cd802ebcd25fcb8ce0">00194</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad8.php#a04f7eea33c0833cd802ebcd25fcb8ce0">side_nodes_map</a>[4][3];
<a name="l00195"></a>00195   
<a name="l00196"></a>00196   
<a name="l00197"></a>00197 <span class="keyword">protected</span>:
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   
<a name="l00200"></a>00200 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>  
<a name="l00205"></a><a class="code" href="classlibMesh_1_1Quad8.php#afd973830bc6b2163578ebec304972fa6">00205</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Quad8.php#afd973830bc6b2163578ebec304972fa6">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00206"></a>00206                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00207"></a>00207                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00208"></a>00208 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Quad8.php#abc1755beeb29506a54d33896920bcc98">_embedding_matrix</a>[i][j][k]; }
<a name="l00209"></a>00209 
<a name="l00214"></a><a class="code" href="classlibMesh_1_1Quad8.php#abc1755beeb29506a54d33896920bcc98">00214</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Quad8.php#abc1755beeb29506a54d33896920bcc98">_embedding_matrix</a>[4][8][8];
<a name="l00215"></a>00215   
<a name="l00216"></a>00216 <span class="preprocessor">#endif</span>
<a name="l00217"></a>00217 <span class="preprocessor"></span> 
<a name="l00218"></a>00218 };
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 } <span class="comment">// namespace libMesh</span>
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
