<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_quad9.C</div>  </div>
</div>
<div class="contents">
<a href="face__quad9_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad9.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="face__quad9_8h.php">face_quad9.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// Quad9 class static member initializations</span>
<a name="l00035"></a>00035 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a3270707f6bf15072ef478f9a59f5a292">Quad9::side_nodes_map</a>[4][3] =
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   {0, 1, 4}, <span class="comment">// Side 0</span>
<a name="l00038"></a>00038   {1, 2, 5}, <span class="comment">// Side 1</span>
<a name="l00039"></a>00039   {2, 3, 6}, <span class="comment">// Side 2</span>
<a name="l00040"></a>00040   {3, 0, 7}  <span class="comment">// Side 3</span>
<a name="l00041"></a>00041 };
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>
<a name="l00046"></a>00046 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Quad9.php#a0ed31135438aa916a3b8475ffc3ab6c9">Quad9::_embedding_matrix</a>[4][9][9] =
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="comment">// embedding matrix for child 0</span>
<a name="l00049"></a>00049   {
<a name="l00050"></a>00050     <span class="comment">//         0           1           2           3           4           5           6           7           8</span>
<a name="l00051"></a>00051     {    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 0</span>
<a name="l00052"></a>00052     {    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00053"></a>00053     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000 }, <span class="comment">// 2</span>
<a name="l00054"></a>00054     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000 }, <span class="comment">// 3</span>
<a name="l00055"></a>00055     {   0.375000,  -0.125000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 4</span>
<a name="l00056"></a>00056     {    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,  -0.125000,    0.00000,   0.750000 }, <span class="comment">// 5</span>
<a name="l00057"></a>00057     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,   0.375000,   0.750000 }, <span class="comment">// 6</span>
<a name="l00058"></a>00058     {   0.375000,    0.00000,    0.00000,  -0.125000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000 }, <span class="comment">// 7</span>
<a name="l00059"></a>00059     {   0.140625, -0.0468750,  0.0156250, -0.0468750,   0.281250, -0.0937500, -0.0937500,   0.281250,   0.562500 }  <span class="comment">// 8</span>
<a name="l00060"></a>00060   },
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="comment">// embedding matrix for child 1</span>
<a name="l00063"></a>00063   {
<a name="l00064"></a>00064     <span class="comment">//         0           1           2           3           4           5           6           7           8</span>
<a name="l00065"></a>00065     {    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 0</span>
<a name="l00066"></a>00066     {    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00067"></a>00067     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00068"></a>00068     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000 }, <span class="comment">// 3</span>
<a name="l00069"></a>00069     {  -0.125000,   0.375000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 4</span>
<a name="l00070"></a>00070     {    0.00000,   0.375000,  -0.125000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 5</span>
<a name="l00071"></a>00071     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,  -0.125000,   0.750000 }, <span class="comment">// 6</span>
<a name="l00072"></a>00072     {    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,  -0.125000,    0.00000,   0.750000 }, <span class="comment">// 7</span>
<a name="l00073"></a>00073     { -0.0468750,   0.140625, -0.0468750,  0.0156250,   0.281250,   0.281250, -0.0937500, -0.0937500,   0.562500 }  <span class="comment">// 8</span>
<a name="l00074"></a>00074   },
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// embedding matrix for child 2</span>
<a name="l00077"></a>00077   {
<a name="l00078"></a>00078     <span class="comment">//         0           1           2           3           4           5           6           7           8</span>
<a name="l00079"></a>00079     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000 }, <span class="comment">// 0</span>
<a name="l00080"></a>00080     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000 }, <span class="comment">// 1</span>
<a name="l00081"></a>00081     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00082"></a>00082     {    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 3</span>
<a name="l00083"></a>00083     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,   0.375000,   0.750000 }, <span class="comment">// 4</span>
<a name="l00084"></a>00084     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,   0.375000,    0.00000,   0.750000 }, <span class="comment">// 5</span>
<a name="l00085"></a>00085     {    0.00000,    0.00000,  -0.125000,   0.375000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000 }, <span class="comment">// 6</span>
<a name="l00086"></a>00086     {  -0.125000,    0.00000,    0.00000,   0.375000,    0.00000,    0.00000,    0.00000,   0.750000,    0.00000 }, <span class="comment">// 7</span>
<a name="l00087"></a>00087     { -0.0468750,  0.0156250, -0.0468750,   0.140625, -0.0937500, -0.0937500,   0.281250,   0.281250,   0.562500 }  <span class="comment">// 8</span>
<a name="l00088"></a>00088   },
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <span class="comment">// embedding matrix for child 3</span>
<a name="l00091"></a>00091   {
<a name="l00092"></a>00092     <span class="comment">//         0           1           2           3           4           5           6           7           8</span>
<a name="l00093"></a>00093     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000 }, <span class="comment">// 0</span>
<a name="l00094"></a>00094     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 1</span>
<a name="l00095"></a>00095     {    0.00000,    0.00000,    1.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 2</span>
<a name="l00096"></a>00096     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,    1.00000,    0.00000,    0.00000 }, <span class="comment">// 3</span>
<a name="l00097"></a>00097     {    0.00000,    0.00000,    0.00000,    0.00000,    0.00000,   0.375000,    0.00000,  -0.125000,   0.750000 }, <span class="comment">// 4</span>
<a name="l00098"></a>00098     {    0.00000,  -0.125000,   0.375000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000,    0.00000 }, <span class="comment">// 5</span>
<a name="l00099"></a>00099     {    0.00000,    0.00000,   0.375000,  -0.125000,    0.00000,    0.00000,   0.750000,    0.00000,    0.00000 }, <span class="comment">// 6</span>
<a name="l00100"></a>00100     {    0.00000,    0.00000,    0.00000,    0.00000,  -0.125000,    0.00000,   0.375000,    0.00000,   0.750000 }, <span class="comment">// 7</span>
<a name="l00101"></a>00101     {  0.0156250, -0.0468750,   0.140625, -0.0468750, -0.0937500,   0.281250,   0.281250, -0.0937500,   0.562500 }  <span class="comment">// 8</span>
<a name="l00102"></a>00102   }
<a name="l00103"></a>00103 };
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#endif</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00110"></a>00110 <span class="comment">// Quad9 class member functions</span>
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classlibMesh_1_1Quad9.php#aeaacba34e7089be1bcb0af452508c760">00112</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#aeaacba34e7089be1bcb0af452508c760">Quad9::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00113"></a>00113 <span class="keyword"></span>{
<a name="l00114"></a>00114   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00115"></a>00115     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00116"></a>00116   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classlibMesh_1_1Quad9.php#ab98f874c0379e3c5428df172712e4f0c">00119</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#ab98f874c0379e3c5428df172712e4f0c">Quad9::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00120"></a>00120 <span class="keyword"></span>{
<a name="l00121"></a>00121   <span class="keywordflow">if</span> (i &lt; 4)
<a name="l00122"></a>00122     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00123"></a>00123   <span class="keywordflow">if</span> (i &gt; 7)
<a name="l00124"></a>00124     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00125"></a>00125   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1Quad9.php#a538968adcee45fc91e05f1ba61f77b1c">00128</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#a538968adcee45fc91e05f1ba61f77b1c">Quad9::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00129"></a>00129 <span class="keyword"></span>{
<a name="l00130"></a>00130   <span class="keywordflow">if</span> (i &gt; 7)
<a name="l00131"></a>00131     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00132"></a>00132   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a><a class="code" href="classlibMesh_1_1Quad9.php#ac70211d9adfc51f042c784515be9ef5b">00135</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#ac70211d9adfc51f042c784515be9ef5b">Quad9::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00136"></a>00136                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00137"></a>00137 <span class="keyword"></span>{
<a name="l00138"></a>00138   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1Quad.php#a88bb8e50e5221b8a6b1d9f5ee0c76619">n_sides</a>());
<a name="l00139"></a>00139   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00140"></a>00140     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Quad9.php#a3270707f6bf15072ef478f9a59f5a292">side_nodes_map</a>[s][i] == n)
<a name="l00141"></a>00141       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00142"></a>00142   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a><a class="code" href="classlibMesh_1_1Quad9.php#a02f4ffad33405e8c470e56d77b92bc15">00147</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#a02f4ffad33405e8c470e56d77b92bc15">Quad9::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00148"></a>00148 <span class="keyword"></span>{
<a name="l00149"></a>00149   <span class="comment">// make sure corners form a parallelogram</span>
<a name="l00150"></a>00150   <a class="code" href="classlibMesh_1_1Point.php">Point</a> v = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0);
<a name="l00151"></a>00151   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(2) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00152"></a>00152     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00153"></a>00153   <span class="comment">// make sure &quot;horizontal&quot; sides are straight</span>
<a name="l00154"></a>00154   v /= 2;
<a name="l00155"></a>00155   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(4) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)) ||
<a name="l00156"></a>00156       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(6) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3)))
<a name="l00157"></a>00157     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00158"></a>00158   <span class="comment">// make sure &quot;vertical&quot; sides are straight</span>
<a name="l00159"></a>00159   <span class="comment">// and the center node is centered</span>
<a name="l00160"></a>00160   v = (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))/2;
<a name="l00161"></a>00161   <span class="keywordflow">if</span> (!v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(7) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)) ||
<a name="l00162"></a>00162       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(5) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)) ||
<a name="l00163"></a>00163       !v.<a class="code" href="classlibMesh_1_1TypeVector.php#a510b7f78c908b4d0f2a1250bace34d88">relative_fuzzy_equals</a>(this-&gt;point(8) - this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4)))
<a name="l00164"></a>00164     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00165"></a>00165   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169  
<a name="l00170"></a><a class="code" href="classlibMesh_1_1Quad9.php#a91d186d6e9e719ab51f215fa8cd36d54">00170</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a91d186d6e9e719ab51f215fa8cd36d54">Quad9::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00171"></a>00171 <span class="keyword"></span>{
<a name="l00172"></a>00172   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Quad.php#a88bb8e50e5221b8a6b1d9f5ee0c76619">n_sides</a>());
<a name="l00173"></a>00173   
<a name="l00174"></a>00174   <span class="keywordflow">switch</span> (s)
<a name="l00175"></a>00175     {
<a name="l00176"></a>00176     <span class="keywordflow">case</span> 0:
<a name="l00177"></a>00177 
<a name="l00178"></a>00178       <span class="keywordflow">return</span>
<a name="l00179"></a>00179         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4));
<a name="l00180"></a>00180               
<a name="l00181"></a>00181     <span class="keywordflow">case</span> 1:
<a name="l00182"></a>00182 
<a name="l00183"></a>00183       <span class="keywordflow">return</span>
<a name="l00184"></a>00184         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5));
<a name="l00185"></a>00185         
<a name="l00186"></a>00186     <span class="keywordflow">case</span> 2:
<a name="l00187"></a>00187 
<a name="l00188"></a>00188       <span class="keywordflow">return</span>
<a name="l00189"></a>00189         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6));
<a name="l00190"></a>00190         
<a name="l00191"></a>00191     <span class="keywordflow">case</span> 3:
<a name="l00192"></a>00192 
<a name="l00193"></a>00193       <span class="keywordflow">return</span>
<a name="l00194"></a>00194         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7));
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="comment">// We will never get here...  Look at the code above.</span>
<a name="l00199"></a>00199   libmesh_error();
<a name="l00200"></a>00200   <span class="keywordflow">return</span> 0;
<a name="l00201"></a>00201 }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 
<a name="l00205"></a><a class="code" href="classlibMesh_1_1Quad9.php#a0dca87b100eb4e30143f2ebca0efb5e9">00205</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Quad9.php#a0dca87b100eb4e30143f2ebca0efb5e9">Quad9::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00206"></a>00206                                  <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00207"></a>00207 <span class="keyword"></span>{
<a name="l00208"></a>00208   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Quad.php#a88bb8e50e5221b8a6b1d9f5ee0c76619">n_sides</a>());
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="keywordflow">if</span> (proxy)
<a name="l00211"></a>00211     {
<a name="l00212"></a>00212       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Edge3,Quad9&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00213"></a>00213       <span class="keywordflow">return</span> ap;
<a name="l00214"></a>00214     }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   <span class="keywordflow">else</span>
<a name="l00217"></a>00217     {
<a name="l00218"></a>00218       <a class="code" href="classlibMesh_1_1Edge3.php">Edge3</a>* edge = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge3.php">Edge3</a>;
<a name="l00219"></a>00219 
<a name="l00220"></a>00220       <span class="keywordflow">switch</span> (i)
<a name="l00221"></a>00221         {
<a name="l00222"></a>00222         <span class="keywordflow">case</span> 0:
<a name="l00223"></a>00223           {
<a name="l00224"></a>00224             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00225"></a>00225             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00226"></a>00226             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00227"></a>00227         
<a name="l00228"></a>00228             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00229"></a>00229           }
<a name="l00230"></a>00230         <span class="keywordflow">case</span> 1:
<a name="l00231"></a>00231           {
<a name="l00232"></a>00232             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00233"></a>00233             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00234"></a>00234             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00235"></a>00235         
<a name="l00236"></a>00236             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00237"></a>00237           }
<a name="l00238"></a>00238         <span class="keywordflow">case</span> 2:
<a name="l00239"></a>00239           {
<a name="l00240"></a>00240             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00241"></a>00241             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00242"></a>00242             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(6);
<a name="l00243"></a>00243         
<a name="l00244"></a>00244             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00245"></a>00245           }
<a name="l00246"></a>00246         <span class="keywordflow">case</span> 3:
<a name="l00247"></a>00247           {
<a name="l00248"></a>00248             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00249"></a>00249             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00250"></a>00250             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(7);
<a name="l00251"></a>00251         
<a name="l00252"></a>00252             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00253"></a>00253           }
<a name="l00254"></a>00254         <span class="keywordflow">default</span>:
<a name="l00255"></a>00255           {
<a name="l00256"></a>00256             libmesh_error();
<a name="l00257"></a>00257           }
<a name="l00258"></a>00258         }
<a name="l00259"></a>00259     }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="comment">// We will never get here...</span>
<a name="l00262"></a>00262   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a><a class="code" href="classlibMesh_1_1Quad9.php#a349e39986fa10dddedaa6f0e1088e1cf">00271</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Quad9.php#a349e39986fa10dddedaa6f0e1088e1cf">Quad9::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00272"></a>00272                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00273"></a>00273                          std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00274"></a>00274 <span class="keyword"></span>{
<a name="l00275"></a>00275   libmesh_assert (sf &lt; this-&gt;<a class="code" href="classlibMesh_1_1Quad9.php#a3f6a44ff2d301680aa95e0a990ee084b">n_sub_elem</a>());
<a name="l00276"></a>00276   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   conn.resize(4);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="keywordflow">switch</span> (iop)
<a name="l00281"></a>00281     {
<a name="l00282"></a>00282     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00283"></a>00283       {
<a name="l00284"></a>00284         <span class="keywordflow">switch</span>(sf)
<a name="l00285"></a>00285           {
<a name="l00286"></a>00286           <span class="keywordflow">case</span> 0:
<a name="l00287"></a>00287             <span class="comment">// linear sub-quad 0</span>
<a name="l00288"></a>00288             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00289"></a>00289             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00290"></a>00290             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00291"></a>00291             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00292"></a>00292             <span class="keywordflow">return</span>;
<a name="l00293"></a>00293 
<a name="l00294"></a>00294           <span class="keywordflow">case</span> 1:
<a name="l00295"></a>00295             <span class="comment">// linear sub-quad 1</span>
<a name="l00296"></a>00296             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00297"></a>00297             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00298"></a>00298             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00299"></a>00299             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00300"></a>00300             <span class="keywordflow">return</span>;
<a name="l00301"></a>00301 
<a name="l00302"></a>00302           <span class="keywordflow">case</span> 2:
<a name="l00303"></a>00303             <span class="comment">// linear sub-quad 2</span>
<a name="l00304"></a>00304             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7)+1;
<a name="l00305"></a>00305             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00306"></a>00306             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00307"></a>00307             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00308"></a>00308             <span class="keywordflow">return</span>;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310           <span class="keywordflow">case</span> 3:
<a name="l00311"></a>00311             <span class="comment">// linear sub-quad 3</span>
<a name="l00312"></a>00312             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8)+1;
<a name="l00313"></a>00313             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00314"></a>00314             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00315"></a>00315             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6)+1;
<a name="l00316"></a>00316             <span class="keywordflow">return</span>;
<a name="l00317"></a>00317 
<a name="l00318"></a>00318           <span class="keywordflow">default</span>:
<a name="l00319"></a>00319             libmesh_error();
<a name="l00320"></a>00320           }
<a name="l00321"></a>00321       }
<a name="l00322"></a>00322 
<a name="l00323"></a>00323     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00324"></a>00324       {
<a name="l00325"></a>00325         conn.resize(9);
<a name="l00326"></a>00326         conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0);
<a name="l00327"></a>00327         conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1);
<a name="l00328"></a>00328         conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2);
<a name="l00329"></a>00329         conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3);
<a name="l00330"></a>00330         conn[4] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4);
<a name="l00331"></a>00331         conn[5] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5);
<a name="l00332"></a>00332         conn[6] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(6);
<a name="l00333"></a>00333         conn[7] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(7);
<a name="l00334"></a>00334         conn[8] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(8);
<a name="l00335"></a>00335         <span class="keywordflow">return</span>;
<a name="l00336"></a>00336 
<a name="l00337"></a>00337           <span class="comment">/*</span>
<a name="l00338"></a>00338 <span class="comment">        switch(sf)</span>
<a name="l00339"></a>00339 <span class="comment">          {</span>
<a name="l00340"></a>00340 <span class="comment">          case 0:</span>
<a name="l00341"></a>00341 <span class="comment">            // linear sub-quad 0</span>
<a name="l00342"></a>00342 <span class="comment">            conn[0] = this-&gt;node(0);</span>
<a name="l00343"></a>00343 <span class="comment">            conn[1] = this-&gt;node(4);</span>
<a name="l00344"></a>00344 <span class="comment">            conn[2] = this-&gt;node(8);</span>
<a name="l00345"></a>00345 <span class="comment">            conn[3] = this-&gt;node(7);</span>
<a name="l00346"></a>00346 <span class="comment"></span>
<a name="l00347"></a>00347 <span class="comment">            return;</span>
<a name="l00348"></a>00348 <span class="comment"></span>
<a name="l00349"></a>00349 <span class="comment">          case 1:</span>
<a name="l00350"></a>00350 <span class="comment">            // linear sub-quad 1</span>
<a name="l00351"></a>00351 <span class="comment">            conn[0] = this-&gt;node(4);</span>
<a name="l00352"></a>00352 <span class="comment">            conn[1] = this-&gt;node(1);</span>
<a name="l00353"></a>00353 <span class="comment">            conn[2] = this-&gt;node(5);</span>
<a name="l00354"></a>00354 <span class="comment">            conn[3] = this-&gt;node(8);</span>
<a name="l00355"></a>00355 <span class="comment"></span>
<a name="l00356"></a>00356 <span class="comment">            return;</span>
<a name="l00357"></a>00357 <span class="comment"></span>
<a name="l00358"></a>00358 <span class="comment">          case 2:</span>
<a name="l00359"></a>00359 <span class="comment">            // linear sub-quad 2</span>
<a name="l00360"></a>00360 <span class="comment">            conn[0] = this-&gt;node(7);</span>
<a name="l00361"></a>00361 <span class="comment">            conn[1] = this-&gt;node(8);</span>
<a name="l00362"></a>00362 <span class="comment">            conn[2] = this-&gt;node(6);</span>
<a name="l00363"></a>00363 <span class="comment">            conn[3] = this-&gt;node(3);</span>
<a name="l00364"></a>00364 <span class="comment"></span>
<a name="l00365"></a>00365 <span class="comment">            return;</span>
<a name="l00366"></a>00366 <span class="comment"></span>
<a name="l00367"></a>00367 <span class="comment">          case 3:</span>
<a name="l00368"></a>00368 <span class="comment">            // linear sub-quad 3</span>
<a name="l00369"></a>00369 <span class="comment">            conn[0] = this-&gt;node(8);</span>
<a name="l00370"></a>00370 <span class="comment">            conn[1] = this-&gt;node(5);</span>
<a name="l00371"></a>00371 <span class="comment">            conn[2] = this-&gt;node(2);</span>
<a name="l00372"></a>00372 <span class="comment">            conn[3] = this-&gt;node(6);</span>
<a name="l00373"></a>00373 <span class="comment"></span>
<a name="l00374"></a>00374 <span class="comment">            return;</span>
<a name="l00375"></a>00375 <span class="comment"></span>
<a name="l00376"></a>00376 <span class="comment">          default:</span>
<a name="l00377"></a>00377 <span class="comment">            libmesh_error();</span>
<a name="l00378"></a>00378 <span class="comment">          }*/</span>
<a name="l00379"></a>00379       }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381     <span class="keywordflow">default</span>:
<a name="l00382"></a>00382       {
<a name="l00383"></a>00383         libmesh_error();
<a name="l00384"></a>00384       }
<a name="l00385"></a>00385     }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387   libmesh_error();
<a name="l00388"></a>00388 }
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00393"></a><a class="code" href="classlibMesh_1_1Quad9.php#a6292bca7f54ad2e15ae1e2818e5e09ba">00393</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a6292bca7f54ad2e15ae1e2818e5e09ba">Quad9::n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00394"></a>00394 <span class="keyword"></span>{
<a name="l00395"></a>00395   <span class="keywordflow">switch</span> (n)
<a name="l00396"></a>00396     {
<a name="l00397"></a>00397       <span class="keywordflow">case</span> 4:
<a name="l00398"></a>00398       <span class="keywordflow">case</span> 5:
<a name="l00399"></a>00399       <span class="keywordflow">case</span> 6:
<a name="l00400"></a>00400       <span class="keywordflow">case</span> 7:
<a name="l00401"></a>00401         <span class="keywordflow">return</span> 2;
<a name="l00402"></a>00402 
<a name="l00403"></a>00403       <span class="keywordflow">case</span> 8:
<a name="l00404"></a>00404         <span class="keywordflow">return</span> 4;
<a name="l00405"></a>00405 
<a name="l00406"></a>00406       <span class="keywordflow">default</span>:
<a name="l00407"></a>00407         libmesh_error();
<a name="l00408"></a>00408     }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   libmesh_error();
<a name="l00411"></a>00411   <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00412"></a>00412 }
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a><a class="code" href="classlibMesh_1_1Quad9.php#a0c40a5b805778fbd6487baf8f18c4b9c">00416</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a0c40a5b805778fbd6487baf8f18c4b9c">Quad9::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00417"></a>00417                                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00418"></a>00418 <span class="keyword"></span>{ 
<a name="l00419"></a>00419   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Quad.php#ac809b0db845bc629c084af935048a5f7">n_vertices</a>());
<a name="l00420"></a>00420   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classlibMesh_1_1Quad9.php#a20f85e052968ebfbbb6f6d853985f3b5">n_nodes</a>());
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   <span class="keywordflow">switch</span> (n)
<a name="l00423"></a>00423     {
<a name="l00424"></a>00424       <span class="keywordflow">case</span> 8:
<a name="l00425"></a>00425       {
<a name="l00426"></a>00426         libmesh_assert (v &lt; 4);
<a name="l00427"></a>00427         <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(v);
<a name="l00428"></a>00428       }
<a name="l00429"></a>00429 
<a name="l00430"></a>00430       <span class="keywordflow">default</span>:
<a name="l00431"></a>00431       {
<a name="l00432"></a>00432         libmesh_assert (v &lt; 2);
<a name="l00433"></a>00433         <span class="comment">// use the matrix that we inherited from \p Quad</span>
<a name="l00434"></a>00434         <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Quad.php#accbea2bdf844d9f7f40b341a9829cae0">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classlibMesh_1_1Quad.php#ac809b0db845bc629c084af935048a5f7">n_vertices</a>()][v]; 
<a name="l00435"></a>00435       }
<a name="l00436"></a>00436     }
<a name="l00437"></a>00437 }
<a name="l00438"></a>00438 
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00442"></a><a class="code" href="classlibMesh_1_1Quad9.php#a49b4b6b6129ad6b459ebe0c37f1388a5">00442</a> <a class="code" href="classlibMesh_1_1Quad9.php#a49b4b6b6129ad6b459ebe0c37f1388a5">Quad9::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00443"></a>00443 <span class="keyword"></span>{
<a name="l00444"></a>00444   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Quad.php#ac809b0db845bc629c084af935048a5f7">n_vertices</a>());
<a name="l00445"></a>00445   libmesh_assert (n &lt; this-&gt;<a class="code" href="classlibMesh_1_1Quad9.php#a20f85e052968ebfbbb6f6d853985f3b5">n_nodes</a>());
<a name="l00446"></a>00446   <span class="comment">/*</span>
<a name="l00447"></a>00447 <span class="comment">   * the _second_order_vertex_child_* vectors are</span>
<a name="l00448"></a>00448 <span class="comment">   * stored in face_quad.C, since they are identical</span>
<a name="l00449"></a>00449 <span class="comment">   * for Quad8 and Quad9 (for the first 4 higher-order nodes)</span>
<a name="l00450"></a>00450 <span class="comment">   */</span>
<a name="l00451"></a>00451   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00452"></a>00452     (<a class="code" href="classlibMesh_1_1Quad.php#add80df7cb52d641e6b3f843bf16cd5a0">_second_order_vertex_child_number</a>[n],
<a name="l00453"></a>00453      <a class="code" href="classlibMesh_1_1Quad.php#aec9cd4af30c2a0cb74e8f77e11490319">_second_order_vertex_child_index</a>[n]);
<a name="l00454"></a>00454 }
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 } <span class="comment">// namespace libMesh</span>
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
