<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_quad9.h</div>  </div>
</div>
<div class="contents">
<a href="face__quad9_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad9.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quad9_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quad9_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="face__quad_8h.php">face_quad.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00057"></a>00057 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00058"></a>00058 <span class="comment">// Quad9 class definition</span>
<a name="l00059"></a><a class="code" href="classlibMesh_1_1Quad9.php">00059</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Quad9.php">Quad9</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00062"></a>00062 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1Quad9.php#a29002ab0d86e0b53a4d4af5e3ac2ce5f">00066</a>   <a class="code" href="classlibMesh_1_1Quad9.php#a29002ab0d86e0b53a4d4af5e3ac2ce5f">Quad9</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL) :
<a name="l00067"></a>00067     <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>(<a class="code" href="classlibMesh_1_1Quad9.php">Quad9</a>::<a class="code" href="classlibMesh_1_1Quad9.php#a20f85e052968ebfbbb6f6d853985f3b5">n_nodes</a>(), p) {}
<a name="l00068"></a>00068 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1Quad9.php#a9a7afaa9d0d60b1d4978b3c485f2df54">00073</a>   <a class="code" href="classlibMesh_1_1Quad9.php#a29002ab0d86e0b53a4d4af5e3ac2ce5f">Quad9</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00074"></a>00074          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00075"></a>00075          <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00076"></a>00076     <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>(nn, ns, p) {}
<a name="l00077"></a>00077 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1Quad9.php#a6e1765ccc6466d60e222210164c01c6a">00081</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Quad9.php#a6e1765ccc6466d60e222210164c01c6a">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>; }
<a name="l00082"></a>00082 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1Quad9.php#a20f85e052968ebfbbb6f6d853985f3b5">00086</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a20f85e052968ebfbbb6f6d853985f3b5">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 9; }
<a name="l00087"></a>00087   
<a name="l00091"></a><a class="code" href="classlibMesh_1_1Quad9.php#a3f6a44ff2d301680aa95e0a990ee084b">00091</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a3f6a44ff2d301680aa95e0a990ee084b">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00092"></a>00092   
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#aeaacba34e7089be1bcb0af452508c760">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#ab98f874c0379e3c5428df172712e4f0c">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00102"></a>00102 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#a538968adcee45fc91e05f1ba61f77b1c">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   <span class="comment">/*</span>
<a name="l00109"></a>00109 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00110"></a>00110 <span class="comment">   * specified side</span>
<a name="l00111"></a>00111 <span class="comment">   */</span>
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#ac70211d9adfc51f042c784515be9ef5b">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00113"></a>00113                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00114"></a>00114   
<a name="l00115"></a>00115   <span class="comment">/*</span>
<a name="l00116"></a>00116 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00117"></a>00117 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00118"></a>00118 <span class="comment">   */</span>
<a name="l00119"></a><a class="code" href="classlibMesh_1_1Quad9.php#ab0d9fed937c06c4f43498f33eccc8501">00119</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#ab0d9fed937c06c4f43498f33eccc8501">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00120"></a>00120                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00121"></a>00121 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Quad9.php#ac70211d9adfc51f042c784515be9ef5b">is_node_on_side</a>(n,e); }
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <span class="comment">/*</span>
<a name="l00124"></a>00124 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00125"></a>00125 <span class="comment">   * numerical tolerances</span>
<a name="l00126"></a>00126 <span class="comment">   */</span>
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad9.php#a02f4ffad33405e8c470e56d77b92bc15">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1Quad9.php#acab3506384d79399a3c08e9c7162d813">00132</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1Quad9.php#acab3506384d79399a3c08e9c7162d813">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00133"></a>00133 
<a name="l00143"></a>00143   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a91d186d6e9e719ab51f215fa8cd36d54">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Quad9.php#a0dca87b100eb4e30143f2ebca0efb5e9">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00146"></a>00146                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Quad9.php#a349e39986fa10dddedaa6f0e1088e1cf">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00149"></a>00149                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00150"></a>00150                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00151"></a>00151   
<a name="l00155"></a>00155   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a6292bca7f54ad2e15ae1e2818e5e09ba">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00156"></a>00156 
<a name="l00162"></a>00162   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a0c40a5b805778fbd6487baf8f18c4b9c">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00163"></a>00163                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00164"></a>00164   
<a name="l00174"></a>00174   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00175"></a>00175           <a class="code" href="classlibMesh_1_1Quad9.php#a49b4b6b6129ad6b459ebe0c37f1388a5">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00181"></a><a class="code" href="classlibMesh_1_1Quad9.php#a3270707f6bf15072ef478f9a59f5a292">00181</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad9.php#a3270707f6bf15072ef478f9a59f5a292">side_nodes_map</a>[4][3];
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   
<a name="l00184"></a>00184 <span class="keyword">protected</span>:
<a name="l00185"></a>00185   
<a name="l00186"></a>00186   
<a name="l00187"></a>00187 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00188"></a>00188 <span class="preprocessor"></span>  
<a name="l00192"></a><a class="code" href="classlibMesh_1_1Quad9.php#a94a55ede03587505b039e23610996895">00192</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Quad9.php#a94a55ede03587505b039e23610996895">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00193"></a>00193                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00194"></a>00194                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00195"></a>00195 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Quad9.php#a0ed31135438aa916a3b8475ffc3ab6c9">_embedding_matrix</a>[i][j][k]; }
<a name="l00196"></a>00196 
<a name="l00201"></a><a class="code" href="classlibMesh_1_1Quad9.php#a0ed31135438aa916a3b8475ffc3ab6c9">00201</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Quad9.php#a0ed31135438aa916a3b8475ffc3ab6c9">_embedding_matrix</a>[4][9][9];
<a name="l00202"></a>00202   
<a name="l00203"></a>00203 <span class="preprocessor">#endif</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span>
<a name="l00205"></a>00205     
<a name="l00206"></a>00206 };
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 } <span class="comment">// namespace libMesh</span>
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
