<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_quad.C</div>  </div>
</div>
<div class="contents">
<a href="face__quad_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad.C 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="face__quad_8h.php">face_quad.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge2_8h.php">edge_edge2.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// Quad class member functions</span>
<a name="l00032"></a><a class="code" href="classlibMesh_1_1Quad.php#af10282896104dc7639d6daa5fcf6e756">00032</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#af10282896104dc7639d6daa5fcf6e756">Quad::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00033"></a>00033 <span class="keyword"></span>{
<a name="l00034"></a>00034   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Quad.php#a88bb8e50e5221b8a6b1d9f5ee0c76619">n_sides</a>());
<a name="l00035"></a>00035   
<a name="l00036"></a>00036   <span class="keywordflow">switch</span> (s)
<a name="l00037"></a>00037     {
<a name="l00038"></a>00038     <span class="keywordflow">case</span> 0:
<a name="l00039"></a>00039       <span class="keywordflow">return</span>
<a name="l00040"></a>00040         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0),
<a name="l00041"></a>00041                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1));
<a name="l00042"></a>00042       
<a name="l00043"></a>00043     <span class="keywordflow">case</span> 1:
<a name="l00044"></a>00044       <span class="keywordflow">return</span>
<a name="l00045"></a>00045         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1),
<a name="l00046"></a>00046                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2));
<a name="l00047"></a>00047         
<a name="l00048"></a>00048     <span class="keywordflow">case</span> 2:
<a name="l00049"></a>00049       <span class="keywordflow">return</span>
<a name="l00050"></a>00050         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2),
<a name="l00051"></a>00051                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3));
<a name="l00052"></a>00052         
<a name="l00053"></a>00053     <span class="keywordflow">case</span> 3:
<a name="l00054"></a>00054       <span class="keywordflow">return</span>
<a name="l00055"></a>00055         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3),
<a name="l00056"></a>00056                            this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0));      
<a name="l00057"></a>00057     }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="comment">// We will never get here...  Look at the code above.</span>
<a name="l00061"></a>00061   libmesh_error();  
<a name="l00062"></a>00062   <span class="keywordflow">return</span> 0;
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1Quad.php#ad6fd4f4e32f6ce484af6c63d8f026e1b">00067</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Quad.php#ad6fd4f4e32f6ce484af6c63d8f026e1b">Quad::side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00068"></a>00068 <span class="keyword"></span>{
<a name="l00069"></a>00069   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Quad.php#a88bb8e50e5221b8a6b1d9f5ee0c76619">n_sides</a>());
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* edge = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge2.php">Edge2</a>;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="keywordflow">switch</span> (i)
<a name="l00074"></a>00074     {
<a name="l00075"></a>00075     <span class="keywordflow">case</span> 0:
<a name="l00076"></a>00076       {
<a name="l00077"></a>00077         edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00078"></a>00078         edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00079"></a>00079         
<a name="l00080"></a>00080         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_edge(edge);
<a name="l00081"></a>00081         <span class="keywordflow">return</span> ap_edge;
<a name="l00082"></a>00082       }
<a name="l00083"></a>00083     <span class="keywordflow">case</span> 1:
<a name="l00084"></a>00084       {
<a name="l00085"></a>00085         edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00086"></a>00086         edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00087"></a>00087         
<a name="l00088"></a>00088         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_edge(edge);
<a name="l00089"></a>00089         <span class="keywordflow">return</span> ap_edge;
<a name="l00090"></a>00090       }
<a name="l00091"></a>00091     <span class="keywordflow">case</span> 2:
<a name="l00092"></a>00092       {
<a name="l00093"></a>00093         edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00094"></a>00094         edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00095"></a>00095         
<a name="l00096"></a>00096         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_edge(edge);
<a name="l00097"></a>00097         <span class="keywordflow">return</span> ap_edge;
<a name="l00098"></a>00098       }
<a name="l00099"></a>00099     <span class="keywordflow">case</span> 3:
<a name="l00100"></a>00100       {
<a name="l00101"></a>00101         edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00102"></a>00102         edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00103"></a>00103         
<a name="l00104"></a>00104         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_edge(edge);
<a name="l00105"></a>00105         <span class="keywordflow">return</span> ap_edge;
<a name="l00106"></a>00106       }
<a name="l00107"></a>00107     <span class="keywordflow">default</span>:
<a name="l00108"></a>00108       {
<a name="l00109"></a>00109         libmesh_error();
<a name="l00110"></a>00110       }
<a name="l00111"></a>00111     }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114   <span class="comment">// We will never get here...  Look at the code above.</span>
<a name="l00115"></a>00115   libmesh_error();  
<a name="l00116"></a>00116   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap_edge(edge);
<a name="l00117"></a>00117   <span class="keywordflow">return</span> ap_edge;
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1Quad.php#a5a707ff34872e3ef23edf198640b6112">00122</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad.php#a5a707ff34872e3ef23edf198640b6112">Quad::is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00123"></a>00123                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00124"></a>00124 <span class="keyword"></span>{
<a name="l00125"></a>00125   libmesh_assert (c &lt; this-&gt;<a class="code" href="classlibMesh_1_1Quad.php#a9191ae487da4d13c0ab43950521bb5e7">n_children</a>());
<a name="l00126"></a>00126   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Quad.php#a88bb8e50e5221b8a6b1d9f5ee0c76619">n_sides</a>());
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="comment">// A quad&#39;s children and nodes don&#39;t share the same ordering:</span>
<a name="l00129"></a>00129   <span class="comment">// child 2 and 3 are swapped;</span>
<a name="l00130"></a>00130   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = (c &lt; 2) ? c : 5-c;
<a name="l00131"></a>00131   <span class="keywordflow">return</span> (n == s || n == (s+1)%4);
<a name="l00132"></a>00132 }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a><a class="code" href="classlibMesh_1_1Quad.php#a1d375d2e977585d2a3bd7957b5b66443">00136</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Quad.php#a1d375d2e977585d2a3bd7957b5b66443">Quad::quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00137"></a>00137 <span class="keyword"></span>{
<a name="l00138"></a>00138   <span class="keywordflow">switch</span> (q)
<a name="l00139"></a>00139     {
<a name="l00140"></a>00140       
<a name="l00145"></a>00145     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00146"></a>00146     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a89d0f252b1485d9b6012ffde9431e227">DIAGONAL</a>:
<a name="l00147"></a>00147     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00148"></a>00148       {
<a name="l00149"></a>00149         <span class="comment">// Diagonal between node 0 and node 2</span>
<a name="l00150"></a>00150         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d02 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(0,2);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152         <span class="comment">// Diagonal between node 1 and node 3</span>
<a name="l00153"></a>00153         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d13 = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aef6515911a6bab7eaf91004a9bb60ea3">length</a>(1,3);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155         <span class="comment">// Find the biggest and smallest diagonals</span>
<a name="l00156"></a>00156         <span class="keywordflow">if</span> ( (d02 &gt; 0.) &amp;&amp; (d13 &gt;0.) )
<a name="l00157"></a>00157           <span class="keywordflow">if</span> (d02 &lt; d13) <span class="keywordflow">return</span> d02 / d13;
<a name="l00158"></a>00158           <span class="keywordflow">else</span> <span class="keywordflow">return</span> d13 / d02;
<a name="l00159"></a>00159         <span class="keywordflow">else</span>
<a name="l00160"></a>00160           <span class="keywordflow">return</span> 0.;
<a name="l00161"></a>00161         <span class="keywordflow">break</span>;
<a name="l00162"></a>00162       }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     <span class="keywordflow">default</span>:
<a name="l00165"></a>00165       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Quad.php#a1d375d2e977585d2a3bd7957b5b66443">Elem::quality</a>(q);
<a name="l00166"></a>00166     }
<a name="l00167"></a>00167       
<a name="l00173"></a>00173   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Quad.php#a1d375d2e977585d2a3bd7957b5b66443">Elem::quality</a>(q);
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a><a class="code" href="classlibMesh_1_1Quad.php#a2590b73c53903ad456e9152a9954abde">00181</a> std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1Quad.php#a2590b73c53903ad456e9152a9954abde">Quad::qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q)<span class="keyword"> const</span>
<a name="l00182"></a>00182 <span class="keyword"></span>{
<a name="l00183"></a>00183   std::pair&lt;Real, Real&gt; bounds;
<a name="l00184"></a>00184   
<a name="l00185"></a>00185   <span class="keywordflow">switch</span> (q)
<a name="l00186"></a>00186     {
<a name="l00187"></a>00187 
<a name="l00188"></a>00188     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad84ce9cc13267ffa231163dc658d5e23">ASPECT_RATIO</a>:
<a name="l00189"></a>00189       bounds.first  = 1.;
<a name="l00190"></a>00190       bounds.second = 4.;
<a name="l00191"></a>00191       <span class="keywordflow">break</span>;
<a name="l00192"></a>00192       
<a name="l00193"></a>00193     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a221d6d85c3c750560623002387ab06b2">SKEW</a>:
<a name="l00194"></a>00194       bounds.first  = 0.;
<a name="l00195"></a>00195       bounds.second = 0.5;
<a name="l00196"></a>00196       <span class="keywordflow">break</span>;
<a name="l00197"></a>00197 
<a name="l00198"></a>00198     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a74f44b3ae7234b35337fbd0c71b112af">TAPER</a>:
<a name="l00199"></a>00199       bounds.first  = 0.;
<a name="l00200"></a>00200       bounds.second = 0.7;
<a name="l00201"></a>00201       <span class="keywordflow">break</span>;
<a name="l00202"></a>00202 
<a name="l00203"></a>00203     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a4ac2c62ea7ca226c3586825a77dd64a8">WARP</a>:
<a name="l00204"></a>00204       bounds.first  = 0.9;
<a name="l00205"></a>00205       bounds.second = 1.;
<a name="l00206"></a>00206       <span class="keywordflow">break</span>;
<a name="l00207"></a>00207      
<a name="l00208"></a>00208     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012ad7b656d7a4cdf057a09a9a9c328c5b3a">STRETCH</a>:
<a name="l00209"></a>00209       bounds.first  = 0.25;
<a name="l00210"></a>00210       bounds.second = 1.;
<a name="l00211"></a>00211       <span class="keywordflow">break</span>;
<a name="l00212"></a>00212 
<a name="l00213"></a>00213     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012aa567a4d684ebdd698e26a3e10456126b">MIN_ANGLE</a>:
<a name="l00214"></a>00214       bounds.first  = 45.;
<a name="l00215"></a>00215       bounds.second = 90.;
<a name="l00216"></a>00216       <span class="keywordflow">break</span>;
<a name="l00217"></a>00217       
<a name="l00218"></a>00218     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a2c906ab7c9aca6cca231949a86b430a0">MAX_ANGLE</a>:
<a name="l00219"></a>00219       bounds.first  = 90.;
<a name="l00220"></a>00220       bounds.second = 135.;
<a name="l00221"></a>00221       <span class="keywordflow">break</span>;
<a name="l00222"></a>00222       
<a name="l00223"></a>00223     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a29e1db5c60b32bcee224ac441c04274b">CONDITION</a>:
<a name="l00224"></a>00224       bounds.first  = 1.;
<a name="l00225"></a>00225       bounds.second = 4.;
<a name="l00226"></a>00226       <span class="keywordflow">break</span>;
<a name="l00227"></a>00227 
<a name="l00228"></a>00228     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012adce510f6954c2ac2cd6b1c6bf91210cc">JACOBIAN</a>:
<a name="l00229"></a>00229       bounds.first  = 0.5;
<a name="l00230"></a>00230       bounds.second = 1.;
<a name="l00231"></a>00231       <span class="keywordflow">break</span>;
<a name="l00232"></a>00232       
<a name="l00233"></a>00233     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a41601385ca9d2f055200e85cfe782e5b">SHEAR</a>:
<a name="l00234"></a>00234     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a44883df285a1b32254467277e46343df">SHAPE</a>:
<a name="l00235"></a>00235     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012afe883232d33e91404f7669f2aab854a6">SIZE</a>:
<a name="l00236"></a>00236       bounds.first  = 0.3;
<a name="l00237"></a>00237       bounds.second = 1.;
<a name="l00238"></a>00238       <span class="keywordflow">break</span>;
<a name="l00239"></a>00239       
<a name="l00240"></a>00240     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012a3fe96cbcdc284192e960220fc49fa942">DISTORTION</a>:
<a name="l00241"></a>00241       bounds.first  = 0.6;
<a name="l00242"></a>00242       bounds.second = 1.;
<a name="l00243"></a>00243       <span class="keywordflow">break</span>;
<a name="l00244"></a>00244       
<a name="l00245"></a>00245     <span class="keywordflow">default</span>:
<a name="l00246"></a>00246       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning: Invalid quality measure chosen.&quot;</span> &lt;&lt; std::endl;
<a name="l00247"></a>00247       bounds.first  = -1;
<a name="l00248"></a>00248       bounds.second = -1;
<a name="l00249"></a>00249     }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   <span class="keywordflow">return</span> bounds;
<a name="l00252"></a>00252 }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#accbea2bdf844d9f7f40b341a9829cae0">Quad::_second_order_adjacent_vertices</a>[4][2] = 
<a name="l00258"></a>00258 {
<a name="l00259"></a>00259   {0, 1}, <span class="comment">// vertices adjacent to node 4 </span>
<a name="l00260"></a>00260   {1, 2}, <span class="comment">// vertices adjacent to node 5 </span>
<a name="l00261"></a>00261   {2, 3}, <span class="comment">// vertices adjacent to node 6 </span>
<a name="l00262"></a>00262   {0, 3}  <span class="comment">// vertices adjacent to node 7 </span>
<a name="l00263"></a>00263 };
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#add80df7cb52d641e6b3f843bf16cd5a0">Quad::_second_order_vertex_child_number</a>[9] =
<a name="l00268"></a>00268 {
<a name="l00269"></a>00269   99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00270"></a>00270   0,1,2,0,     <span class="comment">// Edges</span>
<a name="l00271"></a>00271   0            <span class="comment">// Interior</span>
<a name="l00272"></a>00272 };
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#aec9cd4af30c2a0cb74e8f77e11490319">Quad::_second_order_vertex_child_index</a>[9] =
<a name="l00277"></a>00277 {
<a name="l00278"></a>00278   99,99,99,99, <span class="comment">// Vertices</span>
<a name="l00279"></a>00279   1,2,3,3,     <span class="comment">// Edges</span>
<a name="l00280"></a>00280   2            <span class="comment">// Interior</span>
<a name="l00281"></a>00281 };
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
