<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_quad.h</div>  </div>
</div>
<div class="contents">
<a href="face__quad_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_quad.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quad_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quad_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face_8h.php">face.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00056"></a>00056 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// Quad class definition</span>
<a name="l00058"></a><a class="code" href="classlibMesh_1_1Quad.php">00058</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Quad.php">Quad</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Face.php">Face</a>
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1Quad.php#a832d49bb85299078891f88be9236428b">00066</a>   <a class="code" href="classlibMesh_1_1Quad.php#a832d49bb85299078891f88be9236428b">Quad</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00067"></a>00067     <a class="code" href="classlibMesh_1_1Face.php">Face</a>(nn, <a class="code" href="classlibMesh_1_1Quad.php">Quad</a>::<a class="code" href="classlibMesh_1_1Quad.php#a88bb8e50e5221b8a6b1d9f5ee0c76619">n_sides</a>(), p) {}
<a name="l00068"></a>00068  
<a name="l00073"></a><a class="code" href="classlibMesh_1_1Quad.php#a1f9aef0a16bcb58e30acfe9531e7112f">00073</a>   <a class="code" href="classlibMesh_1_1Quad.php#a832d49bb85299078891f88be9236428b">Quad</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00074"></a>00074         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00075"></a>00075         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00076"></a>00076     <a class="code" href="classlibMesh_1_1Face.php">Face</a>(nn, ns, p) {}
<a name="l00077"></a>00077 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1Quad.php#a476faee1f5146b9fba768c9641bc175a">00082</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#a476faee1f5146b9fba768c9641bc175a">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1Quad.php#a88bb8e50e5221b8a6b1d9f5ee0c76619">00087</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#a88bb8e50e5221b8a6b1d9f5ee0c76619">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }  
<a name="l00088"></a>00088 
<a name="l00092"></a><a class="code" href="classlibMesh_1_1Quad.php#ac809b0db845bc629c084af935048a5f7">00092</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#ac809b0db845bc629c084af935048a5f7">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00093"></a>00093 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1Quad.php#a0a7efa9d4aad341e7a6f8bb3a6ef43fa">00097</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#a0a7efa9d4aad341e7a6f8bb3a6ef43fa">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00098"></a>00098 
<a name="l00102"></a><a class="code" href="classlibMesh_1_1Quad.php#a9191ae487da4d13c0ab43950521bb5e7">00102</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#a9191ae487da4d13c0ab43950521bb5e7">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00103"></a>00103   
<a name="l00104"></a>00104   <span class="comment">/*</span>
<a name="l00105"></a>00105 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00106"></a>00106 <span class="comment">   * specified side</span>
<a name="l00107"></a>00107 <span class="comment">   */</span>
<a name="l00108"></a>00108   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Quad.php#a5a707ff34872e3ef23edf198640b6112">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00109"></a>00109                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00110"></a>00110   
<a name="l00116"></a>00116   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#af10282896104dc7639d6daa5fcf6e756">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00117"></a>00117 
<a name="l00122"></a>00122   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Quad.php#ad6fd4f4e32f6ce484af6c63d8f026e1b">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00123"></a>00123   
<a name="l00128"></a>00128   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Quad.php#a1d375d2e977585d2a3bd7957b5b66443">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00135"></a>00135   std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1Quad.php#a2590b73c53903ad456e9152a9954abde">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00136"></a>00136   
<a name="l00143"></a><a class="code" href="classlibMesh_1_1Quad.php#accbea2bdf844d9f7f40b341a9829cae0">00143</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#accbea2bdf844d9f7f40b341a9829cae0">_second_order_adjacent_vertices</a>[4][2];
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1Quad.php#add80df7cb52d641e6b3f843bf16cd5a0">00148</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#add80df7cb52d641e6b3f843bf16cd5a0">_second_order_vertex_child_number</a>[9];
<a name="l00149"></a>00149 
<a name="l00153"></a><a class="code" href="classlibMesh_1_1Quad.php#aec9cd4af30c2a0cb74e8f77e11490319">00153</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Quad.php#aec9cd4af30c2a0cb74e8f77e11490319">_second_order_vertex_child_index</a>[9];
<a name="l00154"></a>00154 };
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00158"></a>00158 <span class="comment">// Quad class member functions</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 } <span class="comment">// namespace libMesh</span>
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
