<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_tri3.h</div>  </div>
</div>
<div class="contents">
<a href="face__tri3_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_tri3.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tri3_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tri3_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__tri_8h.php">face_tri.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 
<a name="l00055"></a>00055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// Tri3 class definition</span>
<a name="l00057"></a><a class="code" href="classlibMesh_1_1Tri3.php">00057</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Tri.php">Tri</a>
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1Tri3.php#ae87fa890bc16a0ba370821fb2b658b4e">00064</a>   <a class="code" href="classlibMesh_1_1Tri3.php#ae87fa890bc16a0ba370821fb2b658b4e">Tri3</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL) :
<a name="l00065"></a>00065     <a class="code" href="classlibMesh_1_1Tri.php">Tri</a>(<a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>::<a class="code" href="classlibMesh_1_1Tri.php#ab3a6aa7576b90f506ab00637de922a22">n_nodes</a>(), p) {}
<a name="l00066"></a>00066 
<a name="l00071"></a><a class="code" href="classlibMesh_1_1Tri3.php#aa093a9e683135a9fbdf82d26a2b11625">00071</a>   <a class="code" href="classlibMesh_1_1Tri3.php#ae87fa890bc16a0ba370821fb2b658b4e">Tri3</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00072"></a>00072         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00073"></a>00073         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00074"></a>00074     <a class="code" href="classlibMesh_1_1Tri.php">Tri</a>(nn, ns, p) {}
<a name="l00075"></a>00075 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1Tri3.php#a25aff65405216c0a8123704edd1f151a">00079</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Tri3.php#a25aff65405216c0a8123704edd1f151a">type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>; }
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1Tri3.php#ac5447c697430acccefbf84ab7910e3fa">00084</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri3.php#ac5447c697430acccefbf84ab7910e3fa">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00085"></a>00085   
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri3.php#a27f5123a4029de1af6859e5a13772186">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri3.php#ae414b449dd2e49f8a44df8bfa0695cdf">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri3.php#a396789a5f017cc8ef69cafc2ccea7bb0">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">/*</span>
<a name="l00102"></a>00102 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00103"></a>00103 <span class="comment">   * specified side</span>
<a name="l00104"></a>00104 <span class="comment">   */</span>
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri3.php#aad9b915f57d9ca7cc5bc1a303257f021">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00106"></a>00106                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00107"></a>00107   
<a name="l00108"></a>00108   <span class="comment">/*</span>
<a name="l00109"></a>00109 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00110"></a>00110 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00111"></a>00111 <span class="comment">   */</span>
<a name="l00112"></a><a class="code" href="classlibMesh_1_1Tri3.php#aa465d63c43f1ba693bcd1070cb3b3201">00112</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri3.php#aa465d63c43f1ba693bcd1070cb3b3201">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00113"></a>00113                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00114"></a>00114 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Tri3.php#aad9b915f57d9ca7cc5bc1a303257f021">is_node_on_side</a>(n,e); }
<a name="l00115"></a>00115   
<a name="l00116"></a>00116   <span class="comment">/*</span>
<a name="l00117"></a>00117 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00118"></a>00118 <span class="comment">   * numerical tolerances</span>
<a name="l00119"></a>00119 <span class="comment">   */</span>
<a name="l00120"></a><a class="code" href="classlibMesh_1_1Tri3.php#a9451e9ab8956db4544ef036229ec7e47">00120</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri3.php#a9451e9ab8956db4544ef036229ec7e47">has_affine_map</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1Tri3.php#a2ee1832fa6b67b24f87ae9b881ef4aa7">00125</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1Tri3.php#a2ee1832fa6b67b24f87ae9b881ef4aa7">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Tri3.php#a8a009b5efc09fc3d24ac3ba37c3aa67b">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00128"></a>00128                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tri3.php#aa473131ac9d3848e675ccd80f5d574e3">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00131"></a>00131                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00132"></a>00132                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00133"></a>00133 
<a name="l00138"></a><a class="code" href="classlibMesh_1_1Tri3.php#ae96a6bfe1b39fbcff4b260733cb3448b">00138</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri3.php#ae96a6bfe1b39fbcff4b260733cb3448b">side_nodes_map</a>[3][2];
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00144"></a>00144   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Tri3.php#a816c4bfaf7a4d0ee7a6255906a5f7115">volume</a> () <span class="keyword">const</span>;
<a name="l00145"></a>00145 
<a name="l00151"></a>00151   std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1Tri3.php#ad0494c29263b47b44731097a2ff829df">min_and_max_angle</a>() <span class="keyword">const</span>;
<a name="l00152"></a>00152   
<a name="l00153"></a>00153 <span class="keyword">protected</span>:
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   
<a name="l00156"></a>00156 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span>  
<a name="l00161"></a><a class="code" href="classlibMesh_1_1Tri3.php#a6cc39d5ab19d686acc11fd2572183dbc">00161</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Tri3.php#a6cc39d5ab19d686acc11fd2572183dbc">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00162"></a>00162                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00163"></a>00163                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00164"></a>00164 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Tri3.php#ab18e7d1dce4a47b31e55c6eafe88e08b">_embedding_matrix</a>[i][j][k]; }
<a name="l00165"></a>00165 
<a name="l00170"></a><a class="code" href="classlibMesh_1_1Tri3.php#ab18e7d1dce4a47b31e55c6eafe88e08b">00170</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Tri3.php#ab18e7d1dce4a47b31e55c6eafe88e08b">_embedding_matrix</a>[4][3][3];
<a name="l00171"></a>00171   
<a name="l00172"></a>00172 <span class="preprocessor">#endif</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>    
<a name="l00174"></a>00174 };
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 } <span class="comment">// namespace libMesh</span>
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
