<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_tri6.C</div>  </div>
</div>
<div class="contents">
<a href="face__tri6_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_tri6.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="side_8h.php">side.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="edge__edge3_8h.php">edge_edge3.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="face__tri6_8h.php">face_tri6.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// Tri6 class static member initializations</span>
<a name="l00035"></a>00035 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#a7ff9f42178ced5b4c48bdff7badcd641">Tri6::side_nodes_map</a>[3][3] =
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   {0, 1, 3}, <span class="comment">// Side 0</span>
<a name="l00038"></a>00038   {1, 2, 4}, <span class="comment">// Side 1</span>
<a name="l00039"></a>00039   {2, 0, 5}  <span class="comment">// Side 2</span>
<a name="l00040"></a>00040 };
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Tri6.php#a79b50cb50ce1052a37d88c89935808eb">Tri6::_embedding_matrix</a>[4][6][6] =
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   <span class="comment">// embedding matrix for child 0</span>
<a name="l00048"></a>00048   {
<a name="l00049"></a>00049     <span class="comment">//  0      1      2    3    4    5</span>
<a name="l00050"></a>00050     { 1.0,   0.0,   0.0, 0.0, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00051"></a>00051     { 0.0,   0.0,   0.0, 1.0, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00052"></a>00052     { 0.0,   0.0,   0.0, 0.0, 0.0, 1.0}, <span class="comment">// 2</span>
<a name="l00053"></a>00053     {.375, -.125,   0.0, .75, 0.0, 0.0}, <span class="comment">// 3</span>
<a name="l00054"></a>00054     { 0.0, -.125, -.125, 0.5, .25, 0.5}, <span class="comment">// 4</span>
<a name="l00055"></a>00055     {.375,   0.0, -.125, 0.0, 0.0, .75}  <span class="comment">// 5</span>
<a name="l00056"></a>00056   },
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// embedding matrix for child 1</span>
<a name="l00059"></a>00059   {
<a name="l00060"></a>00060     <span class="comment">//  0      1      2    3    4    5</span>
<a name="l00061"></a>00061     {  0.0,  0.0,   0.0, 1.0, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00062"></a>00062     {  0.0,  1.0,   0.0, 0.0, 0.0, 0.0}, <span class="comment">// 1</span>
<a name="l00063"></a>00063     {  0.0,  0.0,   0.0, 0.0, 1.0, 0.0}, <span class="comment">// 2</span>
<a name="l00064"></a>00064     {-.125, .375,   0.0, .75, 0.0, 0.0}, <span class="comment">// 3</span>
<a name="l00065"></a>00065     {  0.0, .375, -.125, 0.0, .75, 0.0}, <span class="comment">// 4</span>
<a name="l00066"></a>00066     {-.125,  0.0, -.125, 0.5, 0.5, .25}  <span class="comment">// 5</span>
<a name="l00067"></a>00067   },
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">// embedding matrix for child 2</span>
<a name="l00070"></a>00070   {
<a name="l00071"></a>00071     <span class="comment">//  0       1     2    3    4    5</span>
<a name="l00072"></a>00072     {  0.0,   0.0,  0.0, 0.0, 0.0, 1.0}, <span class="comment">// 0</span>
<a name="l00073"></a>00073     {  0.0,   0.0,  0.0, 0.0, 1.0, 0.0}, <span class="comment">// 1</span>
<a name="l00074"></a>00074     {  0.0,   0.0,  1.0, 0.0, 0.0, 0.0}, <span class="comment">// 2</span>
<a name="l00075"></a>00075     {-.125, -.125,  0.0, .25, 0.5, 0.5}, <span class="comment">// 3</span>
<a name="l00076"></a>00076     {  0.0, -.125, .375, 0.0, .75, 0.0}, <span class="comment">// 4</span>
<a name="l00077"></a>00077     {-.125,   0.0, .375, 0.0, 0.0, .75}  <span class="comment">// 5</span>
<a name="l00078"></a>00078   },
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="comment">// embedding matrix for child 3</span>
<a name="l00081"></a>00081   {
<a name="l00082"></a>00082     <span class="comment">//  0       1      2    3    4    5</span>
<a name="l00083"></a>00083     {  0.0,   0.0,   0.0, 1.0, 0.0, 0.0}, <span class="comment">// 0</span>
<a name="l00084"></a>00084     {  0.0,   0.0,   0.0, 0.0, 1.0, 0.0}, <span class="comment">// 1</span>
<a name="l00085"></a>00085     {  0.0,   0.0,   0.0, 0.0, 0.0, 1.0}, <span class="comment">// 2</span>
<a name="l00086"></a>00086     {-.125,   0.0, -.125, 0.5, 0.5, .25}, <span class="comment">// 3</span>
<a name="l00087"></a>00087     {-.125, -.125,   0.0, .25, 0.5, 0.5}, <span class="comment">// 4</span>
<a name="l00088"></a>00088     {  0.0, -.125, -.125, 0.5, .25, 0.5}  <span class="comment">// 5</span>
<a name="l00089"></a>00089   }
<a name="l00090"></a>00090 };
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 <span class="preprocessor">#endif</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00097"></a>00097 <span class="comment">// Tri6 class member functions</span>
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1Tri6.php#a1814823052ca94fcfa7fc162fe5298e6">00099</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a1814823052ca94fcfa7fc162fe5298e6">Tri6::is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00100"></a>00100 <span class="keyword"></span>{
<a name="l00101"></a>00101   <span class="keywordflow">if</span> (i &lt; 3)
<a name="l00102"></a>00102     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00103"></a>00103   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1Tri6.php#a78b9c7757a2d8c5a6fab89faee192427">00106</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a78b9c7757a2d8c5a6fab89faee192427">Tri6::is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00107"></a>00107 <span class="keyword"></span>{
<a name="l00108"></a>00108   <span class="keywordflow">if</span> (i &lt; 3)
<a name="l00109"></a>00109     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00110"></a>00110   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1Tri6.php#a6bf7ebf305637b7a5bd464fcfd07b524">00113</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a6bf7ebf305637b7a5bd464fcfd07b524">Tri6::is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00114"></a>00114 <span class="keyword"></span>{
<a name="l00115"></a>00115   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00116"></a>00116 }
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1Tri6.php#a7921f0420d6452b48fd35bdf423c1351">00118</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a7921f0420d6452b48fd35bdf423c1351">Tri6::is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00119"></a>00119                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00120"></a>00120 <span class="keyword"></span>{
<a name="l00121"></a>00121   libmesh_assert(s &lt; <a class="code" href="classlibMesh_1_1Tri.php#ada6c80c30362855decab6fd0566da648">n_sides</a>());
<a name="l00122"></a>00122   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != 3; ++i)
<a name="l00123"></a>00123     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Tri6.php#a7ff9f42178ced5b4c48bdff7badcd641">side_nodes_map</a>[s][i] == n)
<a name="l00124"></a>00124       <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00125"></a>00125   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="classlibMesh_1_1Tri6.php#a00985e69348e315fe11591845f32d01d">00130</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a00985e69348e315fe11591845f32d01d">Tri6::has_affine_map</a>()<span class="keyword"> const</span>
<a name="l00131"></a>00131 <span class="keyword"></span>{
<a name="l00132"></a>00132   <span class="comment">// Make sure edges are straight</span>
<a name="l00133"></a>00133   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(3).relative_fuzzy_equals
<a name="l00134"></a>00134       ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1))/2.))
<a name="l00135"></a>00135     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00136"></a>00136   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(4).relative_fuzzy_equals
<a name="l00137"></a>00137       ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2))/2.))
<a name="l00138"></a>00138     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00139"></a>00139   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(5).relative_fuzzy_equals
<a name="l00140"></a>00140       ((this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(2) + this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0))/2.))
<a name="l00141"></a>00141     <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00144"></a>00144 }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1Tri6.php#accb0b601beee03f13778c7d0b38feefd">00148</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#accb0b601beee03f13778c7d0b38feefd">Tri6::key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s)<span class="keyword"> const</span>
<a name="l00149"></a>00149 <span class="keyword"></span>{
<a name="l00150"></a>00150   libmesh_assert (s &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tri.php#ada6c80c30362855decab6fd0566da648">n_sides</a>());
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="keywordflow">switch</span> (s)
<a name="l00153"></a>00153     {
<a name="l00154"></a>00154     <span class="keywordflow">case</span> 0:
<a name="l00155"></a>00155 
<a name="l00156"></a>00156       <span class="keywordflow">return</span>
<a name="l00157"></a>00157         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3));
<a name="l00158"></a>00158         
<a name="l00159"></a>00159     <span class="keywordflow">case</span> 1:
<a name="l00160"></a>00160 
<a name="l00161"></a>00161       <span class="keywordflow">return</span>
<a name="l00162"></a>00162         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4));
<a name="l00163"></a>00163         
<a name="l00164"></a>00164     <span class="keywordflow">case</span> 2:
<a name="l00165"></a>00165 
<a name="l00166"></a>00166       <span class="keywordflow">return</span>
<a name="l00167"></a>00167         this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0a7312317e69017905bbee8cf5bbd60d">compute_key</a> (this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5));
<a name="l00168"></a>00168     }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   
<a name="l00171"></a>00171   <span class="comment">// We will never get here...  Look at the code above.</span>
<a name="l00172"></a>00172   libmesh_error();
<a name="l00173"></a>00173   <span class="keywordflow">return</span> 0;
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1Tri6.php#ab9cdabfa2863dcae6c44b1f72a4db5f0">00178</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Tri6.php#ab9cdabfa2863dcae6c44b1f72a4db5f0">Tri6::build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00179"></a>00179                                 <span class="keywordtype">bool</span> proxy)<span class="keyword"> const</span>
<a name="l00180"></a>00180 <span class="keyword"></span>{
<a name="l00181"></a>00181   libmesh_assert (i &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tri.php#ada6c80c30362855decab6fd0566da648">n_sides</a>());
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="keywordflow">if</span> (proxy)
<a name="l00184"></a>00184     {
<a name="l00185"></a>00185       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Side.php">Side&lt;Edge3,Tri6&gt;</a>(<span class="keyword">this</span>,i));
<a name="l00186"></a>00186       <span class="keywordflow">return</span> ap;
<a name="l00187"></a>00187     }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="keywordflow">else</span>
<a name="l00190"></a>00190     {
<a name="l00191"></a>00191       <a class="code" href="classlibMesh_1_1Edge3.php">Edge3</a>* edge = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Edge3.php">Edge3</a>;
<a name="l00192"></a>00192 
<a name="l00193"></a>00193       <span class="keywordflow">switch</span> (i)
<a name="l00194"></a>00194         {
<a name="l00195"></a>00195         <span class="keywordflow">case</span> 0:
<a name="l00196"></a>00196           {
<a name="l00197"></a>00197             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00198"></a>00198             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00199"></a>00199             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(3);
<a name="l00200"></a>00200         
<a name="l00201"></a>00201             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00202"></a>00202           }
<a name="l00203"></a>00203         <span class="keywordflow">case</span> 1:
<a name="l00204"></a>00204           {
<a name="l00205"></a>00205             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(1);
<a name="l00206"></a>00206             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00207"></a>00207             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(4);
<a name="l00208"></a>00208         
<a name="l00209"></a>00209             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00210"></a>00210           }
<a name="l00211"></a>00211         <span class="keywordflow">case</span> 2:
<a name="l00212"></a>00212           {
<a name="l00213"></a>00213             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(2);
<a name="l00214"></a>00214             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(0);
<a name="l00215"></a>00215             edge-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(5);
<a name="l00216"></a>00216         
<a name="l00217"></a>00217             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(edge);  <span class="keywordflow">return</span> ap;
<a name="l00218"></a>00218           }
<a name="l00219"></a>00219         <span class="keywordflow">default</span>:
<a name="l00220"></a>00220           {
<a name="l00221"></a>00221             libmesh_error();
<a name="l00222"></a>00222           }
<a name="l00223"></a>00223         }
<a name="l00224"></a>00224     }
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   <span class="comment">// We will never get here...  Look at the code above.</span>
<a name="l00227"></a>00227   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL);  <span class="keywordflow">return</span> ap;
<a name="l00228"></a>00228 }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a><a class="code" href="classlibMesh_1_1Tri6.php#a7fb7b0f0c2401a822c3e4c29ad90593c">00231</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tri6.php#a7fb7b0f0c2401a822c3e4c29ad90593c">Tri6::connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00232"></a>00232                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00233"></a>00233                         std::vector&lt;unsigned int&gt;&amp; conn)<span class="keyword"> const</span>
<a name="l00234"></a>00234 <span class="keyword"></span>{
<a name="l00235"></a>00235   libmesh_assert (sf &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tri6.php#a77ca3f16464f77ed00267744be71cdc9">n_sub_elem</a>());
<a name="l00236"></a>00236   libmesh_assert (iop != <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aaa651d0dcb9fb1600a26126dcc0aeb777">INVALID_IO_PACKAGE</a>);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="keywordflow">switch</span> (iop)
<a name="l00239"></a>00239     {
<a name="l00240"></a>00240     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa3388de76cef7a6b68099e56f38798147">TECPLOT</a>:
<a name="l00241"></a>00241       {
<a name="l00242"></a>00242         conn.resize(4);
<a name="l00243"></a>00243         <span class="keywordflow">switch</span>(sf)
<a name="l00244"></a>00244           {
<a name="l00245"></a>00245           <span class="keywordflow">case</span> 0:
<a name="l00246"></a>00246             <span class="comment">// linear sub-triangle 0</span>
<a name="l00247"></a>00247             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0)+1;
<a name="l00248"></a>00248             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00249"></a>00249             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00250"></a>00250             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00251"></a>00251 
<a name="l00252"></a>00252             <span class="keywordflow">return</span>;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254           <span class="keywordflow">case</span> 1:
<a name="l00255"></a>00255             <span class="comment">// linear sub-triangle 1</span>
<a name="l00256"></a>00256             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00257"></a>00257             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1)+1;
<a name="l00258"></a>00258             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00259"></a>00259             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261             <span class="keywordflow">return</span>;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263           <span class="keywordflow">case</span> 2:
<a name="l00264"></a>00264             <span class="comment">// linear sub-triangle 2</span>
<a name="l00265"></a>00265             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00266"></a>00266             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00267"></a>00267             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00268"></a>00268             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2)+1;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270             <span class="keywordflow">return</span>;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272           <span class="keywordflow">case</span> 3:
<a name="l00273"></a>00273             <span class="comment">// linear sub-triangle 3</span>
<a name="l00274"></a>00274             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3)+1;
<a name="l00275"></a>00275             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4)+1;
<a name="l00276"></a>00276             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00277"></a>00277             conn[3] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5)+1;
<a name="l00278"></a>00278 
<a name="l00279"></a>00279             <span class="keywordflow">return</span>;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281           <span class="keywordflow">default</span>:
<a name="l00282"></a>00282             libmesh_error();
<a name="l00283"></a>00283           }
<a name="l00284"></a>00284       }
<a name="l00285"></a>00285 
<a name="l00286"></a>00286     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953aa1affb8987f83b5e4acb22d9401dd44ef">VTK</a>:
<a name="l00287"></a>00287       {
<a name="l00288"></a>00288         conn.resize(3);
<a name="l00289"></a>00289         <span class="keywordflow">switch</span>(sf)
<a name="l00290"></a>00290           {
<a name="l00291"></a>00291           <span class="keywordflow">case</span> 0:
<a name="l00292"></a>00292             <span class="comment">// linear sub-triangle 0</span>
<a name="l00293"></a>00293             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(0);
<a name="l00294"></a>00294             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3);
<a name="l00295"></a>00295             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5);
<a name="l00296"></a>00296 
<a name="l00297"></a>00297             <span class="keywordflow">return</span>;
<a name="l00298"></a>00298 
<a name="l00299"></a>00299           <span class="keywordflow">case</span> 1:
<a name="l00300"></a>00300             <span class="comment">// linear sub-triangle 1</span>
<a name="l00301"></a>00301             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3);
<a name="l00302"></a>00302             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(1);
<a name="l00303"></a>00303             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305             <span class="keywordflow">return</span>;
<a name="l00306"></a>00306 
<a name="l00307"></a>00307           <span class="keywordflow">case</span> 2:
<a name="l00308"></a>00308             <span class="comment">// linear sub-triangle 2</span>
<a name="l00309"></a>00309             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5);
<a name="l00310"></a>00310             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4);
<a name="l00311"></a>00311             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(2);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313             <span class="keywordflow">return</span>;
<a name="l00314"></a>00314 
<a name="l00315"></a>00315           <span class="keywordflow">case</span> 3:
<a name="l00316"></a>00316             <span class="comment">// linear sub-triangle 3</span>
<a name="l00317"></a>00317             conn[0] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(3);
<a name="l00318"></a>00318             conn[1] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(4);
<a name="l00319"></a>00319             conn[2] = this-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(5);
<a name="l00320"></a>00320 
<a name="l00321"></a>00321             <span class="keywordflow">return</span>;
<a name="l00322"></a>00322 
<a name="l00323"></a>00323           <span class="keywordflow">default</span>:
<a name="l00324"></a>00324             libmesh_error();
<a name="l00325"></a>00325           }
<a name="l00326"></a>00326       }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328     <span class="keywordflow">default</span>:
<a name="l00329"></a>00329       libmesh_error();
<a name="l00330"></a>00330     }
<a name="l00331"></a>00331   
<a name="l00332"></a>00332   libmesh_error();
<a name="l00333"></a>00333 }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a><a class="code" href="classlibMesh_1_1Tri6.php#a11aaf8df8022bef3f607186c7410f926">00339</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#a11aaf8df8022bef3f607186c7410f926">Tri6::second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00340"></a>00340                                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v)<span class="keyword"> const</span>
<a name="l00341"></a>00341 <span class="keyword"></span>{ 
<a name="l00342"></a>00342   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Tri.php#a0e286bffa79b0e2258b0f688ed0acd02">n_vertices</a>());
<a name="l00343"></a>00343   libmesh_assert (n &lt;  this-&gt;<a class="code" href="classlibMesh_1_1Tri6.php#aaeae27ab06dccc8db09dbfe3ae53e060">n_nodes</a>());
<a name="l00344"></a>00344   libmesh_assert (v &lt; 2);
<a name="l00345"></a>00345   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Tri6.php#a3a5b50ab56d55c6f239952964d568f8e">_second_order_adjacent_vertices</a>[n-this-&gt;<a class="code" href="classlibMesh_1_1Tri.php#a0e286bffa79b0e2258b0f688ed0acd02">n_vertices</a>()][v]; 
<a name="l00346"></a>00346 }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#a3a5b50ab56d55c6f239952964d568f8e">Tri6::_second_order_adjacent_vertices</a>[3][2] = 
<a name="l00351"></a>00351 {
<a name="l00352"></a>00352   {0, 1}, <span class="comment">// vertices adjacent to node 3 </span>
<a name="l00353"></a>00353   {1, 2}, <span class="comment">// vertices adjacent to node 4 </span>
<a name="l00354"></a>00354   {0, 2}  <span class="comment">// vertices adjacent to node 5  </span>
<a name="l00355"></a>00355 };
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00360"></a><a class="code" href="classlibMesh_1_1Tri6.php#a731edd181ef5d839cacd29cb88d0b52a">00360</a> <a class="code" href="classlibMesh_1_1Tri6.php#a731edd181ef5d839cacd29cb88d0b52a">Tri6::second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00361"></a>00361 <span class="keyword"></span>{
<a name="l00362"></a>00362   libmesh_assert (n &gt;= this-&gt;<a class="code" href="classlibMesh_1_1Tri.php#a0e286bffa79b0e2258b0f688ed0acd02">n_vertices</a>());
<a name="l00363"></a>00363   libmesh_assert (n &lt; this-&gt;<a class="code" href="classlibMesh_1_1Tri6.php#aaeae27ab06dccc8db09dbfe3ae53e060">n_nodes</a>());
<a name="l00364"></a>00364   <span class="keywordflow">return</span> std::pair&lt;unsigned short int, unsigned short int&gt;
<a name="l00365"></a>00365     (<a class="code" href="classlibMesh_1_1Tri6.php#ad63a8ee0d1d7e4b335939e0464d03622">_second_order_vertex_child_number</a>[n],
<a name="l00366"></a>00366      <a class="code" href="classlibMesh_1_1Tri6.php#ac13d96dd14bda52a08e71d38a8799210">_second_order_vertex_child_index</a>[n]);
<a name="l00367"></a>00367 }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#ad63a8ee0d1d7e4b335939e0464d03622">Tri6::_second_order_vertex_child_number</a>[6] =
<a name="l00372"></a>00372 {
<a name="l00373"></a>00373   99,99,99, <span class="comment">// Vertices</span>
<a name="l00374"></a>00374   0,1,0     <span class="comment">// Edges</span>
<a name="l00375"></a>00375 };
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#ac13d96dd14bda52a08e71d38a8799210">Tri6::_second_order_vertex_child_index</a>[6] =
<a name="l00380"></a>00380 {
<a name="l00381"></a>00381   99,99,99, <span class="comment">// Vertices</span>
<a name="l00382"></a>00382   1,2,2     <span class="comment">// Edges</span>
<a name="l00383"></a>00383 };
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
