<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_tri6.h</div>  </div>
</div>
<div class="contents">
<a href="face__tri6_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_tri6.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tri6_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tri6_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="face__tri_8h.php">face_tri.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00058"></a>00058 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00059"></a>00059 <span class="comment">// Tri6 class definition</span>
<a name="l00060"></a><a class="code" href="classlibMesh_1_1Tri6.php">00060</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Tri.php">Tri</a>
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062 <span class="keyword">public</span>:
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1Tri6.php#afc63072eb3df1d8194364567d0e7bc8f">00067</a>   <a class="code" href="classlibMesh_1_1Tri6.php#afc63072eb3df1d8194364567d0e7bc8f">Tri6</a>  (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL) :
<a name="l00068"></a>00068     <a class="code" href="classlibMesh_1_1Tri.php">Tri</a>(<a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>::<a class="code" href="classlibMesh_1_1Tri6.php#aaeae27ab06dccc8db09dbfe3ae53e060">n_nodes</a>(), p) {}
<a name="l00069"></a>00069 
<a name="l00074"></a><a class="code" href="classlibMesh_1_1Tri6.php#acf96f48e1714b04e4aaa5107f5ab2ab1">00074</a>   <a class="code" href="classlibMesh_1_1Tri6.php#afc63072eb3df1d8194364567d0e7bc8f">Tri6</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00075"></a>00075         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00076"></a>00076         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00077"></a>00077     <a class="code" href="classlibMesh_1_1Tri.php">Tri</a>(nn, ns, p) {}
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1Tri6.php#a63d6af11377964c30dffe16708d4fc85">00082</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1Tri6.php#a63d6af11377964c30dffe16708d4fc85">type</a> ()<span class="keyword">   const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>; }
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1Tri6.php#aaeae27ab06dccc8db09dbfe3ae53e060">00087</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#aaeae27ab06dccc8db09dbfe3ae53e060">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 6; }
<a name="l00088"></a>00088   
<a name="l00092"></a><a class="code" href="classlibMesh_1_1Tri6.php#a77ca3f16464f77ed00267744be71cdc9">00092</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#a77ca3f16464f77ed00267744be71cdc9">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00093"></a>00093   
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a1814823052ca94fcfa7fc162fe5298e6">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00098"></a>00098 
<a name="l00102"></a>00102   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a78b9c7757a2d8c5a6fab89faee192427">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00103"></a>00103 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a6bf7ebf305637b7a5bd464fcfd07b524">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00108"></a>00108   
<a name="l00109"></a>00109   <span class="comment">/*</span>
<a name="l00110"></a>00110 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00111"></a>00111 <span class="comment">   * specified side</span>
<a name="l00112"></a>00112 <span class="comment">   */</span>
<a name="l00113"></a>00113   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a7921f0420d6452b48fd35bdf423c1351">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00114"></a>00114                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00115"></a>00115   
<a name="l00116"></a>00116   <span class="comment">/*</span>
<a name="l00117"></a>00117 <span class="comment">   * @returns true iff the specified (local) node number is on the</span>
<a name="l00118"></a>00118 <span class="comment">   * specified edge (== is_node_on_side in 2D)</span>
<a name="l00119"></a>00119 <span class="comment">   */</span>
<a name="l00120"></a><a class="code" href="classlibMesh_1_1Tri6.php#ae85ce8b1a70ea94d5c4e216e80894b2d">00120</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#ae85ce8b1a70ea94d5c4e216e80894b2d">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00121"></a>00121                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e)<span class="keyword"> const</span>
<a name="l00122"></a>00122 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1Tri6.php#a7921f0420d6452b48fd35bdf423c1351">is_node_on_side</a>(n,e); }
<a name="l00123"></a>00123   
<a name="l00124"></a>00124   <span class="comment">/*</span>
<a name="l00125"></a>00125 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00126"></a>00126 <span class="comment">   * numerical tolerances</span>
<a name="l00127"></a>00127 <span class="comment">   */</span>
<a name="l00128"></a>00128   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri6.php#a00985e69348e315fe11591845f32d01d">has_affine_map</a> () <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1Tri6.php#af778ee2842756fd16268291bdebd681a">00133</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1Tri6.php#af778ee2842756fd16268291bdebd681a">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>; }
<a name="l00134"></a>00134 
<a name="l00144"></a>00144   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#accb0b601beee03f13778c7d0b38feefd">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00145"></a>00145   
<a name="l00146"></a>00146   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Tri6.php#ab9cdabfa2863dcae6c44b1f72a4db5f0">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00147"></a>00147                             <span class="keywordtype">bool</span> proxy) <span class="keyword">const</span>;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Tri6.php#a7fb7b0f0c2401a822c3e4c29ad90593c">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sf,
<a name="l00150"></a>00150                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00151"></a>00151                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00152"></a>00152 
<a name="l00156"></a><a class="code" href="classlibMesh_1_1Tri6.php#ae70a92ac0eb4957aef2223c7e70f36e2">00156</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#ae70a92ac0eb4957aef2223c7e70f36e2">n_second_order_adjacent_vertices</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00157"></a>00157 <span class="keyword">      </span>{ <span class="keywordflow">return</span> 2; }
<a name="l00158"></a>00158 
<a name="l00164"></a>00164   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#a11aaf8df8022bef3f607186c7410f926">second_order_adjacent_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00165"></a>00165                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v) <span class="keyword">const</span>;
<a name="l00166"></a>00166 
<a name="l00176"></a>00176   <span class="keyword">virtual</span> std::pair&lt;unsigned short int, unsigned short int&gt; 
<a name="l00177"></a>00177           <a class="code" href="classlibMesh_1_1Tri6.php#a731edd181ef5d839cacd29cb88d0b52a">second_order_child_vertex</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00178"></a>00178 
<a name="l00183"></a><a class="code" href="classlibMesh_1_1Tri6.php#a7ff9f42178ced5b4c48bdff7badcd641">00183</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#a7ff9f42178ced5b4c48bdff7badcd641">side_nodes_map</a>[3][3];
<a name="l00184"></a>00184  
<a name="l00185"></a>00185   
<a name="l00186"></a>00186 <span class="keyword">private</span>:
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   
<a name="l00189"></a>00189 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00190"></a>00190 <span class="preprocessor"></span>  
<a name="l00194"></a><a class="code" href="classlibMesh_1_1Tri6.php#a38f106b107ad465a3468d01801ff73cf">00194</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Tri6.php#a38f106b107ad465a3468d01801ff73cf">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00195"></a>00195                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00196"></a>00196                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00197"></a>00197 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Tri6.php#a79b50cb50ce1052a37d88c89935808eb">_embedding_matrix</a>[i][j][k]; }
<a name="l00198"></a>00198 
<a name="l00203"></a><a class="code" href="classlibMesh_1_1Tri6.php#a79b50cb50ce1052a37d88c89935808eb">00203</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1Tri6.php#a79b50cb50ce1052a37d88c89935808eb">_embedding_matrix</a>[4][6][6];
<a name="l00204"></a>00204   
<a name="l00205"></a>00205 <span class="preprocessor">#endif</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span>
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 <span class="keyword">private</span>:
<a name="l00209"></a>00209   
<a name="l00214"></a><a class="code" href="classlibMesh_1_1Tri6.php#a3a5b50ab56d55c6f239952964d568f8e">00214</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#a3a5b50ab56d55c6f239952964d568f8e">_second_order_adjacent_vertices</a>[3][2];
<a name="l00215"></a>00215     
<a name="l00219"></a><a class="code" href="classlibMesh_1_1Tri6.php#ad63a8ee0d1d7e4b335939e0464d03622">00219</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#ad63a8ee0d1d7e4b335939e0464d03622">_second_order_vertex_child_number</a>[6];
<a name="l00220"></a>00220 
<a name="l00224"></a><a class="code" href="classlibMesh_1_1Tri6.php#ac13d96dd14bda52a08e71d38a8799210">00224</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri6.php#ac13d96dd14bda52a08e71d38a8799210">_second_order_vertex_child_index</a>[6];
<a name="l00225"></a>00225 };
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 } <span class="comment">// namespace libMesh</span>
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
