<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">face_tri.h</div>  </div>
</div>
<div class="contents">
<a href="face__tri_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: face_tri.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __tri_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __tri_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face_8h.php">face.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00058"></a>00058 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00059"></a>00059 <span class="comment">// Tri class definition</span>
<a name="l00060"></a><a class="code" href="classlibMesh_1_1Tri.php">00060</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Tri.php">Tri</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Face.php">Face</a>
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062 <span class="keyword">public</span>:
<a name="l00063"></a>00063 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1Tri.php#a4d164d507d5674010414cc5be85186e7">00068</a>   <a class="code" href="classlibMesh_1_1Tri.php#a4d164d507d5674010414cc5be85186e7">Tri</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00069"></a>00069        <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00070"></a>00070     <a class="code" href="classlibMesh_1_1Face.php">Face</a>(nn, <a class="code" href="classlibMesh_1_1Tri.php">Tri</a>::<a class="code" href="classlibMesh_1_1Tri.php#ada6c80c30362855decab6fd0566da648">n_sides</a>(), p) {}
<a name="l00071"></a>00071  
<a name="l00076"></a><a class="code" href="classlibMesh_1_1Tri.php#a5939b518cf126d4778a10339a6bbf090">00076</a>   <a class="code" href="classlibMesh_1_1Tri.php#a4d164d507d5674010414cc5be85186e7">Tri</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00077"></a>00077        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00078"></a>00078        <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00079"></a>00079     <a class="code" href="classlibMesh_1_1Face.php">Face</a>(nn, ns, p) {}
<a name="l00080"></a>00080     
<a name="l00085"></a><a class="code" href="classlibMesh_1_1Tri.php#ab3a6aa7576b90f506ab00637de922a22">00085</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri.php#ab3a6aa7576b90f506ab00637de922a22">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00086"></a>00086 
<a name="l00090"></a><a class="code" href="classlibMesh_1_1Tri.php#ada6c80c30362855decab6fd0566da648">00090</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri.php#ada6c80c30362855decab6fd0566da648">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00091"></a>00091 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1Tri.php#a0e286bffa79b0e2258b0f688ed0acd02">00095</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri.php#a0e286bffa79b0e2258b0f688ed0acd02">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00096"></a>00096 
<a name="l00100"></a><a class="code" href="classlibMesh_1_1Tri.php#aad8748d71f19a51a09a0f18744547cc0">00100</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri.php#aad8748d71f19a51a09a0f18744547cc0">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 3; }
<a name="l00101"></a>00101 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1Tri.php#af717380b3fc001a4fb6c3415e5106e02">00105</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri.php#af717380b3fc001a4fb6c3415e5106e02">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 4; }
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   <span class="comment">/*</span>
<a name="l00108"></a>00108 <span class="comment">   * @returns true iff the specified child is on the</span>
<a name="l00109"></a>00109 <span class="comment">   * specified side</span>
<a name="l00110"></a>00110 <span class="comment">   */</span>
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Tri.php#a747f3b3add681f5831fa2ef0aeeb2f68">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00112"></a>00112                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00113"></a>00113   
<a name="l00119"></a>00119   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Tri.php#ae2f4f5da85ed19b0f3bdf9e6b939d1d1">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00125"></a>00125   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1Tri.php#aad34546e05494c2743c757028ad22e2c">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00131"></a>00131   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Tri.php#a21ccf49ffddbe87fbb9453062437a7bd">quality</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00138"></a>00138   std::pair&lt;Real, Real&gt; <a class="code" href="classlibMesh_1_1Tri.php#adc700d4f52c8178961617bb01544f73a">qual_bounds</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2f6f0ae0fe5fa9991fbc994d0fa39012">ElemQuality</a> q) <span class="keyword">const</span>;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 };
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00143"></a>00143 <span class="comment">// Tri class member functions</span>
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 } <span class="comment">// namespace libMesh</span>
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>
<a name="l00149"></a>00149 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
