<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">factory.h</div>  </div>
</div>
<div class="contents">
<a href="factory_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: factory.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __factory_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __factory_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// System &amp; C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00043"></a><a class="code" href="classlibMesh_1_1Factory.php">00043</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Factory.php">Factory</a>
<a name="l00044"></a>00044 {  
<a name="l00045"></a>00045 <span class="keyword">protected</span>:
<a name="l00046"></a>00046 
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1Factory.php#a6752211fb66b8908b8c22d8d11442e5a">Factory</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1Factory.php#aeee4391283d3bb962c1d0074064bceec">00057</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Factory.php#aeee4391283d3bb962c1d0074064bceec">~Factory</a> () {}
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classlibMesh_1_1Factory.php#a8a61b1ae0df3d37e1507d25288175537">build</a> (<span class="keyword">const</span> std::string&amp; name);
<a name="l00063"></a>00063 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classlibMesh_1_1Factory.php#aa1886ae924d5733c3f3afcafb9a0ef04">create</a> () = 0;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   
<a name="l00071"></a>00071 <span class="keyword">protected</span>:
<a name="l00072"></a>00072 
<a name="l00076"></a>00076   <span class="keyword">static</span> std::map&lt;std::string, Factory&lt;Base&gt;*&gt;&amp; <a class="code" href="classlibMesh_1_1Factory.php#adfce9c38966725c8cc10ca3960db8efe">factory_map</a>();
<a name="l00077"></a>00077 };
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00084"></a>00084 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Derived, <span class="keyword">class</span> Base&gt;
<a name="l00085"></a><a class="code" href="classlibMesh_1_1FactoryImp.php">00085</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FactoryImp.php">FactoryImp</a>: <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Factory.php">Factory</a>&lt;Base&gt;
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087 <span class="keyword">public</span>:
<a name="l00088"></a>00088 
<a name="l00092"></a><a class="code" href="classlibMesh_1_1FactoryImp.php#a6ffa91e4409ece0e10ed9b8bb0491391">00092</a>   <a class="code" href="classlibMesh_1_1FactoryImp.php#a6ffa91e4409ece0e10ed9b8bb0491391">FactoryImp</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>) : <a class="code" href="classlibMesh_1_1Factory.php">Factory</a>&lt;Base&gt;(name) { }
<a name="l00093"></a>00093 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1FactoryImp.php#a55b2ba6c9d61d56f7b10fa2d9735a648">00097</a>   <a class="code" href="classlibMesh_1_1FactoryImp.php#a55b2ba6c9d61d56f7b10fa2d9735a648">~FactoryImp</a> () {}
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="keyword">private</span>:
<a name="l00100"></a>00100 
<a name="l00104"></a>00104   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classlibMesh_1_1FactoryImp.php#ae31d311aa0c670ef89dca53c9b02f0c4">create</a> ();
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 };
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="comment">// -----------------------------------------------------</span>
<a name="l00111"></a>00111 <span class="comment">// Factory members</span>
<a name="l00112"></a>00112 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00113"></a>00113 <span class="keyword">inline</span>
<a name="l00114"></a><a class="code" href="classlibMesh_1_1Factory.php#a6752211fb66b8908b8c22d8d11442e5a">00114</a> <a class="code" href="classlibMesh_1_1Factory.php#a6752211fb66b8908b8c22d8d11442e5a">Factory&lt;Base&gt;::Factory</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116   <span class="comment">// Make sure we haven&#39;t already added this name</span>
<a name="l00117"></a>00117   <span class="comment">// to the map</span>
<a name="l00118"></a>00118   libmesh_assert (!factory_map().count(name));
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   factory_map()[<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>] = <span class="keyword">this</span>;
<a name="l00121"></a>00121 }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Base&gt;
<a name="l00126"></a>00126 <span class="keyword">inline</span>
<a name="l00127"></a><a class="code" href="classlibMesh_1_1Factory.php#a8a61b1ae0df3d37e1507d25288175537">00127</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classlibMesh_1_1Factory.php#a8a61b1ae0df3d37e1507d25288175537">Factory&lt;Base&gt;::build</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129   <span class="comment">// name not found in the map</span>
<a name="l00130"></a>00130   <span class="keywordflow">if</span> (!factory_map().count(name))
<a name="l00131"></a>00131     {
<a name="l00132"></a>00132       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Tried to build an unknown type: &quot;</span> &lt;&lt; name &lt;&lt; std::endl;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;valid options are:&quot;</span> &lt;&lt; std::endl;
<a name="l00135"></a>00135       
<a name="l00136"></a>00136       <span class="keywordflow">for</span> (<span class="keyword">typename</span> std::map&lt;std::string,<a class="code" href="classlibMesh_1_1Factory.php">Factory&lt;Base&gt;</a>*&gt;::const_iterator
<a name="l00137"></a>00137              it = factory_map().begin(); it != factory_map().end(); ++it)
<a name="l00138"></a>00138         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;  &quot;</span> &lt;&lt; it-&gt;first &lt;&lt; std::endl;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140       libmesh_error();
<a name="l00141"></a>00141       
<a name="l00142"></a>00142       <span class="comment">// Do this the stoopid way for IBM xlC</span>
<a name="l00143"></a>00143       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> ret_val (NULL);
<a name="l00144"></a>00144       
<a name="l00145"></a>00145       <span class="keywordflow">return</span> ret_val;
<a name="l00146"></a>00146     }
<a name="l00147"></a>00147   
<a name="l00148"></a>00148   <span class="comment">// Do this the stoopid way for IBM xlC</span>
<a name="l00149"></a>00149   <a class="code" href="classlibMesh_1_1Factory.php">Factory&lt;Base&gt;</a> *f = factory_map()[<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>];
<a name="l00150"></a>00150   
<a name="l00151"></a>00151   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> ret_val (f-&gt;<a class="code" href="classlibMesh_1_1Factory.php#aa1886ae924d5733c3f3afcafb9a0ef04">create</a>());
<a name="l00152"></a>00152   
<a name="l00153"></a>00153   <span class="keywordflow">return</span> ret_val;
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="comment">// Note - this cannot be inlined!</span>
<a name="l00159"></a>00159 <span class="comment">// template &lt;class Base&gt;</span>
<a name="l00160"></a>00160 <span class="comment">// std::map&lt;std::string, Factory&lt;Base&gt;*&gt;&amp; Factory&lt;Base&gt;::factory_map()</span>
<a name="l00161"></a>00161 <span class="comment">// {</span>
<a name="l00162"></a>00162 <span class="comment">//   static std::map&lt;std::string, Factory&lt;Base&gt;*&gt; _factory_map;</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="comment">//   return _factory_map;</span>
<a name="l00165"></a>00165 <span class="comment">// }</span>
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 <span class="keyword">template</span> &lt;<span class="keyword">class</span> Derived, <span class="keyword">class</span> Base&gt;
<a name="l00170"></a>00170 <span class="keyword">inline</span>
<a name="l00171"></a><a class="code" href="classlibMesh_1_1FactoryImp.php#ae31d311aa0c670ef89dca53c9b02f0c4">00171</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> <a class="code" href="classlibMesh_1_1FactoryImp.php#ae31d311aa0c670ef89dca53c9b02f0c4">FactoryImp&lt;Derived,Base&gt;::create</a> ()
<a name="l00172"></a>00172 {  
<a name="l00173"></a>00173   <span class="comment">// Do this the stoopid way for IBM xlC</span>
<a name="l00174"></a>00174   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Base&gt;</a> ret_val (<span class="keyword">new</span> Derived);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keywordflow">return</span> ret_val;
<a name="l00177"></a>00177 }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 } <span class="comment">// namespace libMesh</span>
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
