<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe.C</div>  </div>
</div>
<div class="contents">
<a href="fe_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe.C 4106 2010-11-16 16:35:07Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="fe__macro_8h.php">fe_macro.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// FE class members</span>
<a name="l00036"></a>00036 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00037"></a><a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">00037</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;Dim,T&gt;::n_shape_functions</a> ()<span class="keyword"> const</span>
<a name="l00038"></a>00038 <span class="keyword"></span>{
<a name="l00039"></a>00039   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#a401b5a255c73cd4fd202aadee954ba37">FE&lt;Dim,T&gt;::n_dofs</a> (elem_type,
<a name="l00040"></a>00040            static_cast&lt;Order&gt;(fe_type.order + _p_level));
<a name="l00041"></a>00041 }
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00045"></a><a class="code" href="classlibMesh_1_1FE.php#a4cac6e5c629fe59f44178dc62ca15abf">00045</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a4cac6e5c629fe59f44178dc62ca15abf">FE&lt;Dim,T&gt;::attach_quadrature_rule</a> (<a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* q)
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   libmesh_assert (q != NULL); 
<a name="l00048"></a>00048   qrule = q;
<a name="l00049"></a>00049   <span class="comment">// make sure we don&#39;t cache results from a previous quadrature rule</span>
<a name="l00050"></a>00050   elem_type = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l00051"></a>00051   <span class="keywordflow">return</span>;
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00056"></a><a class="code" href="classlibMesh_1_1FE.php#a05d14d05d8b8b4f87bbff084dd5def74">00056</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a05d14d05d8b8b4f87bbff084dd5def74">FE&lt;Dim,T&gt;::n_quadrature_points</a> ()<span class="keyword"> const</span>
<a name="l00057"></a>00057 <span class="keyword"></span>{ 
<a name="l00058"></a>00058   libmesh_assert (qrule != NULL);  
<a name="l00059"></a>00059   <span class="keywordflow">return</span> qrule-&gt;n_points(); 
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00064"></a><a class="code" href="classlibMesh_1_1FE.php#a07513a5d2c88338980f63ae7959bed50">00064</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a07513a5d2c88338980f63ae7959bed50">FE&lt;Dim,T&gt;::dofs_on_side</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00065"></a>00065                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00066"></a>00066                              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00067"></a>00067                              std::vector&lt;unsigned int&gt;&amp; di)
<a name="l00068"></a>00068 {
<a name="l00069"></a>00069   libmesh_assert(elem != NULL);
<a name="l00070"></a>00070   libmesh_assert(s &lt; elem-&gt;n_sides());
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   di.clear();
<a name="l00073"></a>00073   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodenum = 0;
<a name="l00074"></a>00074   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00075"></a>00075   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++n)
<a name="l00076"></a>00076     {
<a name="l00077"></a>00077       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = n_dofs_at_node(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(),
<a name="l00078"></a>00078                                                  <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(o + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), n);
<a name="l00079"></a>00079       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a095386c4644b0478229289f281f2f8e4">is_node_on_side</a>(n, s))
<a name="l00080"></a>00080         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_dofs; ++i)
<a name="l00081"></a>00081           di.push_back(nodenum++);
<a name="l00082"></a>00082       <span class="keywordflow">else</span>
<a name="l00083"></a>00083         nodenum += n_dofs;
<a name="l00084"></a>00084     }
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00090"></a><a class="code" href="classlibMesh_1_1FE.php#ac5e1e9342d9545a78d3a8e370dfe8117">00090</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#ac5e1e9342d9545a78d3a8e370dfe8117">FE&lt;Dim,T&gt;::dofs_on_edge</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00091"></a>00091                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00092"></a>00092                              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00093"></a>00093                              std::vector&lt;unsigned int&gt;&amp; di)
<a name="l00094"></a>00094 {
<a name="l00095"></a>00095   libmesh_assert(elem != NULL);
<a name="l00096"></a>00096   libmesh_assert(e &lt; elem-&gt;n_edges());
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   di.clear();
<a name="l00099"></a>00099   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodenum = 0;
<a name="l00100"></a>00100   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00101"></a>00101   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++n)
<a name="l00102"></a>00102     {
<a name="l00103"></a>00103       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = n_dofs_at_node(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(),
<a name="l00104"></a>00104                                                  <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(o + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), n);
<a name="l00105"></a>00105       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad60e38f39743e85b379795b1b9958ec5">is_node_on_edge</a>(n, e))
<a name="l00106"></a>00106         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_dofs; ++i)
<a name="l00107"></a>00107           di.push_back(nodenum++);
<a name="l00108"></a>00108       <span class="keywordflow">else</span>
<a name="l00109"></a>00109         nodenum += n_dofs;
<a name="l00110"></a>00110     }
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00116"></a><a class="code" href="classlibMesh_1_1FE.php#a2f701accaa0865b120c5e19a654b9c0d">00116</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a2f701accaa0865b120c5e19a654b9c0d">FE&lt;Dim,T&gt;::reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00117"></a>00117                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts)
<a name="l00118"></a>00118 {
<a name="l00119"></a>00119   libmesh_assert (elem != NULL);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// Try to avoid calling init_shape_functions</span>
<a name="l00122"></a>00122   <span class="comment">// even when shapes_need_reinit</span>
<a name="l00123"></a>00123   <span class="keywordtype">bool</span> cached_nodes_still_fit = <span class="keyword">false</span>;
<a name="l00124"></a>00124   
<a name="l00125"></a>00125   <span class="comment">// Initialize the shape functions at the user-specified</span>
<a name="l00126"></a>00126   <span class="comment">// points</span>
<a name="l00127"></a>00127   <span class="keywordflow">if</span> (pts != NULL)
<a name="l00128"></a>00128     {
<a name="l00129"></a>00129       <span class="comment">// Set the type and p level for this element</span>
<a name="l00130"></a>00130       elem_type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00131"></a>00131       _p_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00132"></a>00132 
<a name="l00133"></a>00133       <span class="comment">// Initialize the shape functions</span>
<a name="l00134"></a>00134       this-&gt;init_shape_functions (*pts, elem);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136       <span class="comment">// The shape functions do not correspond to the qrule</span>
<a name="l00137"></a>00137       shapes_on_quadrature = <span class="keyword">false</span>;
<a name="l00138"></a>00138     }
<a name="l00139"></a>00139   
<a name="l00140"></a>00140   <span class="comment">// If there are no user specified points, we use the</span>
<a name="l00141"></a>00141   <span class="comment">// quadrature rule</span>
<a name="l00142"></a>00142   
<a name="l00143"></a>00143   <span class="comment">// update the type in accordance to the current cell</span>
<a name="l00144"></a>00144   <span class="comment">// and reinit if the cell type has changed or (as in</span>
<a name="l00145"></a>00145   <span class="comment">// the case of the hierarchics) the shape functions need</span>
<a name="l00146"></a>00146   <span class="comment">// reinit, since they depend on the particular element shape</span>
<a name="l00147"></a>00147   <span class="keywordflow">else</span> 
<a name="l00148"></a>00148     {      
<a name="l00149"></a>00149       libmesh_assert (qrule   != NULL);
<a name="l00150"></a>00150       qrule-&gt;init(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00151"></a>00151       
<a name="l00152"></a>00152       <span class="keywordflow">if</span>(qrule-&gt;shapes_need_reinit())
<a name="l00153"></a>00153         shapes_on_quadrature = <span class="keyword">false</span>;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155       <span class="keywordflow">if</span> (elem_type != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() ||
<a name="l00156"></a>00156           _p_level != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() ||
<a name="l00157"></a>00157           !shapes_on_quadrature)
<a name="l00158"></a>00158         {
<a name="l00159"></a>00159           <span class="comment">// Set the type and p level for this element</span>
<a name="l00160"></a>00160           elem_type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00161"></a>00161           _p_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00162"></a>00162           <span class="comment">// Initialize the shape functions</span>
<a name="l00163"></a>00163           this-&gt;init_shape_functions (qrule-&gt;get_points(), elem);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165           <span class="keywordflow">if</span> (this-&gt;shapes_need_reinit())
<a name="l00166"></a>00166             {
<a name="l00167"></a>00167               cached_nodes.resize(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00168"></a>00168               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00169"></a>00169                 {
<a name="l00170"></a>00170                   cached_nodes[n] = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n);
<a name="l00171"></a>00171                 }
<a name="l00172"></a>00172             }
<a name="l00173"></a>00173         }
<a name="l00174"></a>00174       <span class="keywordflow">else</span>
<a name="l00175"></a>00175         {
<a name="l00176"></a>00176           <span class="comment">// libmesh_assert(elem-&gt;n_nodes() &gt; 1);</span>
<a name="l00177"></a>00177 
<a name="l00178"></a>00178           cached_nodes_still_fit = <span class="keyword">true</span>;
<a name="l00179"></a>00179           <span class="keywordflow">if</span> (cached_nodes.size() != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>())
<a name="l00180"></a>00180             cached_nodes_still_fit = <span class="keyword">false</span>;
<a name="l00181"></a>00181           <span class="keywordflow">else</span>
<a name="l00182"></a>00182             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 1; n &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00183"></a>00183               {
<a name="l00184"></a>00184                 <span class="keywordflow">if</span> (!(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n) - elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0)).relative_fuzzy_equals(
<a name="l00185"></a>00185                       (cached_nodes[n] - cached_nodes[0]), 1e-13))
<a name="l00186"></a>00186                   {
<a name="l00187"></a>00187                     cached_nodes_still_fit = <span class="keyword">false</span>;
<a name="l00188"></a>00188                     <span class="keywordflow">break</span>;
<a name="l00189"></a>00189                   }
<a name="l00190"></a>00190               }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192           <span class="keywordflow">if</span> (this-&gt;shapes_need_reinit() &amp;&amp; !cached_nodes_still_fit)
<a name="l00193"></a>00193             {
<a name="l00194"></a>00194               this-&gt;init_shape_functions (qrule-&gt;get_points(), elem);
<a name="l00195"></a>00195               cached_nodes.resize(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00196"></a>00196               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00197"></a>00197                 cached_nodes[n] = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n);
<a name="l00198"></a>00198             }
<a name="l00199"></a>00199         }
<a name="l00200"></a>00200       
<a name="l00201"></a>00201       <span class="comment">// The shape functions correspond to the qrule</span>
<a name="l00202"></a>00202       shapes_on_quadrature = <span class="keyword">true</span>;
<a name="l00203"></a>00203     }
<a name="l00204"></a>00204   
<a name="l00205"></a>00205   <span class="comment">// Compute the map for this element.  In the future we can specify</span>
<a name="l00206"></a>00206   <span class="comment">// different types of maps</span>
<a name="l00207"></a>00207   <span class="keywordflow">if</span> (pts != NULL)
<a name="l00208"></a>00208     {
<a name="l00209"></a>00209       std::vector&lt;Real&gt; dummy_weights (pts-&gt;size(), 1.);
<a name="l00210"></a>00210       
<a name="l00211"></a>00211       this-&gt;compute_map (dummy_weights, elem);
<a name="l00212"></a>00212     }
<a name="l00213"></a>00213   <span class="keywordflow">else</span>
<a name="l00214"></a>00214     {
<a name="l00215"></a>00215       this-&gt;compute_map (qrule-&gt;get_weights(), elem);
<a name="l00216"></a>00216     }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218   <span class="comment">// Compute the shape functions and the derivatives at all of the</span>
<a name="l00219"></a>00219   <span class="comment">// quadrature points.</span>
<a name="l00220"></a>00220   <span class="keywordflow">if</span> (!cached_nodes_still_fit)
<a name="l00221"></a>00221     this-&gt;compute_shape_functions (elem);
<a name="l00222"></a>00222 }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00227"></a><a class="code" href="classlibMesh_1_1FE.php#a23842e856a2968a150cb459ffab1cdd3">00227</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a23842e856a2968a150cb459ffab1cdd3">FE&lt;Dim,T&gt;::init_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00228"></a>00228                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00229"></a>00229 {
<a name="l00230"></a>00230   libmesh_assert (elem  != NULL);
<a name="l00231"></a>00231   calculations_started = <span class="keyword">true</span>;
<a name="l00232"></a>00232 
<a name="l00233"></a>00233   <span class="comment">// If the user forgot to request anything, we&#39;ll be safe and</span>
<a name="l00234"></a>00234   <span class="comment">// calculate everything:</span>
<a name="l00235"></a>00235 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00236"></a>00236 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!calculate_phi &amp;&amp; !calculate_dphi &amp;&amp; !calculate_d2phi)
<a name="l00237"></a>00237     calculate_phi = calculate_dphi = calculate_d2phi = <span class="keyword">true</span>;
<a name="l00238"></a>00238 <span class="preprocessor">#else</span>
<a name="l00239"></a>00239 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!calculate_phi &amp;&amp; !calculate_dphi)
<a name="l00240"></a>00240     calculate_phi = calculate_dphi = <span class="keyword">true</span>;
<a name="l00241"></a>00241 <span class="preprocessor">#endif // LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>  
<a name="l00243"></a>00243   <span class="comment">// Start logging the shape function initialization</span>
<a name="l00244"></a>00244   START_LOG(<span class="stringliteral">&quot;init_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   
<a name="l00247"></a>00247   <span class="comment">// The number of quadrature points.</span>
<a name="l00248"></a>00248   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qp.size();
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="comment">// The element type and order to use in</span>
<a name="l00251"></a>00251   <span class="comment">// the map</span>
<a name="l00252"></a>00252   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    mapping_order     (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>());
<a name="l00253"></a>00253   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> mapping_elem_type (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00254"></a>00254     
<a name="l00255"></a>00255   <span class="comment">// Number of shape functions in the finite element approximation</span>
<a name="l00256"></a>00256   <span class="comment">// space.</span>
<a name="l00257"></a>00257   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_approx_shape_functions =
<a name="l00258"></a>00258     this-&gt;n_shape_functions(this-&gt;get_type(),
<a name="l00259"></a>00259                             this-&gt;get_order());
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="comment">// Number of shape functions used to construt the map</span>
<a name="l00262"></a>00262   <span class="comment">// (Lagrange shape functions are used for mapping)</span>
<a name="l00263"></a>00263   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_mapping_shape_functions =
<a name="l00264"></a>00264     <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;Dim,LAGRANGE&gt;::n_shape_functions</a> (mapping_elem_type,
<a name="l00265"></a>00265                                          mapping_order);
<a name="l00266"></a>00266   
<a name="l00267"></a>00267   <span class="comment">// resize the vectors to hold current data</span>
<a name="l00268"></a>00268   <span class="comment">// Phi are the shape functions used for the FE approximation</span>
<a name="l00269"></a>00269   <span class="comment">// Phi_map are the shape functions used for the FE mapping</span>
<a name="l00270"></a>00270   <span class="keywordflow">if</span> (calculate_phi)
<a name="l00271"></a>00271     phi.resize     (n_approx_shape_functions);
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00274"></a>00274     {
<a name="l00275"></a>00275       dphi.resize    (n_approx_shape_functions);
<a name="l00276"></a>00276       dphidx.resize  (n_approx_shape_functions);
<a name="l00277"></a>00277       dphidy.resize  (n_approx_shape_functions);
<a name="l00278"></a>00278       dphidz.resize  (n_approx_shape_functions);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280       <span class="keywordflow">if</span> (Dim &gt; 0)
<a name="l00281"></a>00281         dphidxi.resize (n_approx_shape_functions);
<a name="l00282"></a>00282 
<a name="l00283"></a>00283       <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00284"></a>00284         dphideta.resize      (n_approx_shape_functions);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286       <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00287"></a>00287         dphidzeta.resize     (n_approx_shape_functions);
<a name="l00288"></a>00288     }
<a name="l00289"></a>00289 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00290"></a>00290 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00291"></a>00291     {
<a name="l00292"></a>00292       d2phi.resize     (n_approx_shape_functions);
<a name="l00293"></a>00293       d2phidx2.resize  (n_approx_shape_functions);
<a name="l00294"></a>00294       d2phidxdy.resize (n_approx_shape_functions);
<a name="l00295"></a>00295       d2phidxdz.resize (n_approx_shape_functions);
<a name="l00296"></a>00296       d2phidy2.resize  (n_approx_shape_functions);
<a name="l00297"></a>00297       d2phidydz.resize (n_approx_shape_functions);
<a name="l00298"></a>00298       d2phidz2.resize  (n_approx_shape_functions);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300       <span class="keywordflow">if</span> (Dim &gt; 0)
<a name="l00301"></a>00301         d2phidxi2.resize (n_approx_shape_functions);
<a name="l00302"></a>00302 
<a name="l00303"></a>00303       <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00304"></a>00304         {
<a name="l00305"></a>00305           d2phidxideta.resize (n_approx_shape_functions);
<a name="l00306"></a>00306           d2phideta2.resize   (n_approx_shape_functions);
<a name="l00307"></a>00307         }
<a name="l00308"></a>00308       <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00309"></a>00309         {
<a name="l00310"></a>00310           d2phidxidzeta.resize  (n_approx_shape_functions);
<a name="l00311"></a>00311           d2phidetadzeta.resize (n_approx_shape_functions);
<a name="l00312"></a>00312           d2phidzeta2.resize    (n_approx_shape_functions);
<a name="l00313"></a>00313         }
<a name="l00314"></a>00314     }
<a name="l00315"></a>00315 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>    
<a name="l00317"></a>00317   phi_map.resize         (n_mapping_shape_functions);
<a name="l00318"></a>00318   <span class="keywordflow">if</span> (Dim &gt; 0)
<a name="l00319"></a>00319     {
<a name="l00320"></a>00320       dphidxi_map.resize     (n_mapping_shape_functions);
<a name="l00321"></a>00321 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00322"></a>00322 <span class="preprocessor"></span>      d2phidxi2_map.resize   (n_mapping_shape_functions);
<a name="l00323"></a>00323 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00324"></a>00324 <span class="preprocessor"></span>    }
<a name="l00325"></a>00325     
<a name="l00326"></a>00326   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00327"></a>00327     {
<a name="l00328"></a>00328       dphideta_map.resize  (n_mapping_shape_functions);
<a name="l00329"></a>00329 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00330"></a>00330 <span class="preprocessor"></span>      d2phidxideta_map.resize   (n_mapping_shape_functions);
<a name="l00331"></a>00331       d2phideta2_map.resize     (n_mapping_shape_functions);
<a name="l00332"></a>00332 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>    }
<a name="l00334"></a>00334     
<a name="l00335"></a>00335   <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00336"></a>00336     {
<a name="l00337"></a>00337       dphidzeta_map.resize (n_mapping_shape_functions);
<a name="l00338"></a>00338 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00339"></a>00339 <span class="preprocessor"></span>      d2phidxidzeta_map.resize  (n_mapping_shape_functions);
<a name="l00340"></a>00340       d2phidetadzeta_map.resize (n_mapping_shape_functions);
<a name="l00341"></a>00341       d2phidzeta2_map.resize    (n_mapping_shape_functions);
<a name="l00342"></a>00342 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00343"></a>00343 <span class="preprocessor"></span>    }
<a name="l00344"></a>00344     
<a name="l00345"></a>00345   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00346"></a>00346     {
<a name="l00347"></a>00347       <span class="keywordflow">if</span> (calculate_phi)
<a name="l00348"></a>00348         phi[i].resize         (n_qp);
<a name="l00349"></a>00349       <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00350"></a>00350         {
<a name="l00351"></a>00351           dphi[i].resize        (n_qp);
<a name="l00352"></a>00352           dphidx[i].resize      (n_qp);
<a name="l00353"></a>00353           dphidy[i].resize      (n_qp);
<a name="l00354"></a>00354           dphidz[i].resize      (n_qp);
<a name="l00355"></a>00355           <span class="keywordflow">if</span> (Dim &gt; 0)
<a name="l00356"></a>00356           dphidxi[i].resize     (n_qp);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358           <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00359"></a>00359             dphideta[i].resize  (n_qp);
<a name="l00360"></a>00360    
<a name="l00361"></a>00361           <span class="keywordflow">if</span> (Dim &gt; 2)       
<a name="l00362"></a>00362             dphidzeta[i].resize (n_qp);
<a name="l00363"></a>00363         }
<a name="l00364"></a>00364 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00365"></a>00365 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00366"></a>00366         {
<a name="l00367"></a>00367           d2phi[i].resize     (n_qp);
<a name="l00368"></a>00368           d2phidx2[i].resize  (n_qp);
<a name="l00369"></a>00369           d2phidxdy[i].resize (n_qp);
<a name="l00370"></a>00370           d2phidxdz[i].resize (n_qp);
<a name="l00371"></a>00371           d2phidy2[i].resize  (n_qp);
<a name="l00372"></a>00372           d2phidydz[i].resize (n_qp);
<a name="l00373"></a>00373           d2phidz2[i].resize  (n_qp);
<a name="l00374"></a>00374           <span class="keywordflow">if</span> (Dim &gt; 0)
<a name="l00375"></a>00375             d2phidxi2[i].resize (n_qp);
<a name="l00376"></a>00376           <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00377"></a>00377             {
<a name="l00378"></a>00378               d2phidxideta[i].resize (n_qp);
<a name="l00379"></a>00379               d2phideta2[i].resize   (n_qp);
<a name="l00380"></a>00380             }
<a name="l00381"></a>00381           <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00382"></a>00382             {
<a name="l00383"></a>00383               d2phidxidzeta[i].resize  (n_qp);
<a name="l00384"></a>00384               d2phidetadzeta[i].resize (n_qp);
<a name="l00385"></a>00385               d2phidzeta2[i].resize    (n_qp);
<a name="l00386"></a>00386             }
<a name="l00387"></a>00387         }
<a name="l00388"></a>00388 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00389"></a>00389 <span class="preprocessor"></span>    }
<a name="l00390"></a>00390        
<a name="l00391"></a>00391   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00392"></a>00392     {
<a name="l00393"></a>00393       phi_map[i].resize         (n_qp);
<a name="l00394"></a>00394       <span class="keywordflow">if</span> (Dim &gt; 0)
<a name="l00395"></a>00395         {
<a name="l00396"></a>00396           dphidxi_map[i].resize     (n_qp);
<a name="l00397"></a>00397 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00398"></a>00398 <span class="preprocessor"></span>          d2phidxi2_map[i].resize     (n_qp);
<a name="l00399"></a>00399           <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00400"></a>00400             {
<a name="l00401"></a>00401               d2phidxideta_map[i].resize (n_qp);
<a name="l00402"></a>00402               d2phideta2_map[i].resize (n_qp);
<a name="l00403"></a>00403             }
<a name="l00404"></a>00404           <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00405"></a>00405             {
<a name="l00406"></a>00406               d2phidxidzeta_map[i].resize  (n_qp);
<a name="l00407"></a>00407               d2phidetadzeta_map[i].resize (n_qp);
<a name="l00408"></a>00408               d2phidzeta2_map[i].resize    (n_qp);
<a name="l00409"></a>00409             }
<a name="l00410"></a>00410 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00411"></a>00411 <span class="preprocessor"></span>           
<a name="l00412"></a>00412           <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00413"></a>00413             dphideta_map[i].resize  (n_qp);
<a name="l00414"></a>00414            
<a name="l00415"></a>00415           <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00416"></a>00416             dphidzeta_map[i].resize (n_qp);
<a name="l00417"></a>00417         }
<a name="l00418"></a>00418     }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 
<a name="l00421"></a>00421       
<a name="l00422"></a>00422 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00423"></a>00423 <span class="preprocessor"></span>  <span class="comment">//------------------------------------------------------------</span>
<a name="l00424"></a>00424   <span class="comment">// Initialize the data fields, which should only be used for infinite </span>
<a name="l00425"></a>00425   <span class="comment">// elements, to some sensible values, so that using a FE with the</span>
<a name="l00426"></a>00426   <span class="comment">// variational formulation of an InfFE, correct element matrices are</span>
<a name="l00427"></a>00427   <span class="comment">// returned</span>
<a name="l00428"></a>00428 
<a name="l00429"></a>00429  {
<a name="l00430"></a>00430     <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">weight</a>.resize  (n_qp);
<a name="l00431"></a>00431     dweight.resize (n_qp);
<a name="l00432"></a>00432     dphase.resize  (n_qp);
<a name="l00433"></a>00433     
<a name="l00434"></a>00434     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00435"></a>00435       {
<a name="l00436"></a>00436         <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">weight</a>[p] = 1.;
<a name="l00437"></a>00437         dweight[p].zero();
<a name="l00438"></a>00438         dphase[p].zero();
<a name="l00439"></a>00439       }
<a name="l00440"></a>00440 
<a name="l00441"></a>00441  }
<a name="l00442"></a>00442 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00443"></a>00443 <span class="preprocessor"></span>
<a name="l00444"></a>00444   <span class="comment">// Optimize for the affine elements case:</span>
<a name="l00445"></a>00445   <span class="keywordtype">bool</span> has_affine_map = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad0155a2e8e15da7dc9c7a820265fd143">has_affine_map</a>();
<a name="l00446"></a>00446   
<a name="l00447"></a>00447   <span class="keywordflow">switch</span> (Dim)
<a name="l00448"></a>00448     {
<a name="l00449"></a>00449 
<a name="l00450"></a>00450       <span class="comment">//------------------------------------------------------------</span>
<a name="l00451"></a>00451       <span class="comment">// 0D</span>
<a name="l00452"></a>00452     <span class="keywordflow">case</span> 0:
<a name="l00453"></a>00453       {
<a name="l00454"></a>00454         <span class="comment">// Compute the value of the approximation shape function i at quadrature point p</span>
<a name="l00455"></a>00455         <span class="keywordflow">if</span> (calculate_phi)
<a name="l00456"></a>00456           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00457"></a>00457             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00458"></a>00458               phi[i][p]      = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,T&gt;::shape</a>       (elem, fe_type.order, i,    qp[p]);
<a name="l00459"></a>00459         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00460"></a>00460           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00461"></a>00461             phi_map[i][p]      = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,LAGRANGE&gt;::shape</a> (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00462"></a>00462 
<a name="l00463"></a>00463         <span class="keywordflow">break</span>;
<a name="l00464"></a>00464       }
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 
<a name="l00468"></a>00468       <span class="comment">//------------------------------------------------------------</span>
<a name="l00469"></a>00469       <span class="comment">// 1D</span>
<a name="l00470"></a>00470     <span class="keywordflow">case</span> 1:
<a name="l00471"></a>00471       {
<a name="l00472"></a>00472         <span class="comment">// Compute the value of the approximation shape function i at quadrature point p</span>
<a name="l00473"></a>00473         <span class="keywordflow">if</span> (calculate_phi)
<a name="l00474"></a>00474           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00475"></a>00475             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00476"></a>00476               phi[i][p]      = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,T&gt;::shape</a>       (elem, fe_type.order, i,    qp[p]);
<a name="l00477"></a>00477         <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00478"></a>00478           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00479"></a>00479             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00480"></a>00480               dphidxi[i][p]  = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00481"></a>00481 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00482"></a>00482 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00483"></a>00483           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00484"></a>00484             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00485"></a>00485               d2phidxi2[i][p] = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00486"></a>00486 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00487"></a>00487 <span class="preprocessor"></span>        
<a name="l00488"></a>00488         <span class="comment">// Compute the value of the mapping shape function i at quadrature point p</span>
<a name="l00489"></a>00489         <span class="comment">// (Lagrange shape functions are used for mapping)</span>
<a name="l00490"></a>00490         <span class="keywordflow">if</span> (has_affine_map)
<a name="l00491"></a>00491           {
<a name="l00492"></a>00492             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00493"></a>00493               {
<a name="l00494"></a>00494                 phi_map[i][0]      = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[0]);
<a name="l00495"></a>00495                 dphidxi_map[i][0]  = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00496"></a>00496 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00497"></a>00497 <span class="preprocessor"></span>                d2phidxi2_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00498"></a>00498 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00499"></a>00499 <span class="preprocessor"></span>                <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;n_qp; p++)
<a name="l00500"></a>00500                   {
<a name="l00501"></a>00501                     phi_map[i][p]      = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a> (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00502"></a>00502                     dphidxi_map[i][p]  = dphidxi_map[i][0];
<a name="l00503"></a>00503 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00504"></a>00504 <span class="preprocessor"></span>                    d2phidxi2_map[i][p] = d2phidxi2_map[i][0];
<a name="l00505"></a>00505 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00506"></a>00506 <span class="preprocessor"></span>                  }
<a name="l00507"></a>00507               }
<a name="l00508"></a>00508           }
<a name="l00509"></a>00509         <span class="keywordflow">else</span>
<a name="l00510"></a>00510           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00511"></a>00511             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00512"></a>00512               {
<a name="l00513"></a>00513                 phi_map[i][p]      = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00514"></a>00514                 dphidxi_map[i][p]  = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00515"></a>00515 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00516"></a>00516 <span class="preprocessor"></span>                d2phidxi2_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00517"></a>00517 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00518"></a>00518 <span class="preprocessor"></span>              }
<a name="l00519"></a>00519                 
<a name="l00520"></a>00520         <span class="keywordflow">break</span>;
<a name="l00521"></a>00521       }
<a name="l00522"></a>00522 
<a name="l00523"></a>00523 
<a name="l00524"></a>00524       
<a name="l00525"></a>00525       <span class="comment">//------------------------------------------------------------</span>
<a name="l00526"></a>00526       <span class="comment">// 2D</span>
<a name="l00527"></a>00527     <span class="keywordflow">case</span> 2:
<a name="l00528"></a>00528       {
<a name="l00529"></a>00529         <span class="comment">// Compute the value of the approximation shape function i at quadrature point p</span>
<a name="l00530"></a>00530         <span class="keywordflow">if</span> (calculate_phi)
<a name="l00531"></a>00531           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00532"></a>00532             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00533"></a>00533               phi[i][p]      = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,T&gt;::shape</a>       (elem, fe_type.order, i,    qp[p]);
<a name="l00534"></a>00534         <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00535"></a>00535           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00536"></a>00536             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00537"></a>00537               {
<a name="l00538"></a>00538                 dphidxi[i][p]  = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00539"></a>00539                 dphideta[i][p] = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 1, qp[p]);
<a name="l00540"></a>00540               }
<a name="l00541"></a>00541 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00542"></a>00542 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00543"></a>00543           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00544"></a>00544             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00545"></a>00545               {
<a name="l00546"></a>00546                 d2phidxi2[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00547"></a>00547                 d2phidxideta[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 1, qp[p]);
<a name="l00548"></a>00548                 d2phideta2[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 2, qp[p]);
<a name="l00549"></a>00549               }
<a name="l00550"></a>00550 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00551"></a>00551 <span class="preprocessor"></span>        
<a name="l00552"></a>00552         <span class="comment">// Compute the value of the mapping shape function i at quadrature point p</span>
<a name="l00553"></a>00553         <span class="comment">// (Lagrange shape functions are used for mapping)</span>
<a name="l00554"></a>00554         <span class="keywordflow">if</span> (has_affine_map)
<a name="l00555"></a>00555           {
<a name="l00556"></a>00556             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00557"></a>00557               {
<a name="l00558"></a>00558                 phi_map[i][0]      = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[0]);
<a name="l00559"></a>00559                 dphidxi_map[i][0]  = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00560"></a>00560                 dphideta_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[0]);
<a name="l00561"></a>00561 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00562"></a>00562 <span class="preprocessor"></span>                d2phidxi2_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00563"></a>00563                 d2phidxideta_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[0]);
<a name="l00564"></a>00564                 d2phideta2_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[0]);
<a name="l00565"></a>00565 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00566"></a>00566 <span class="preprocessor"></span>                <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;n_qp; p++)
<a name="l00567"></a>00567                   {
<a name="l00568"></a>00568                     phi_map[i][p]      = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a> (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00569"></a>00569                     dphidxi_map[i][p]  = dphidxi_map[i][0];
<a name="l00570"></a>00570                     dphideta_map[i][p] = dphideta_map[i][0];
<a name="l00571"></a>00571 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00572"></a>00572 <span class="preprocessor"></span>                    d2phidxi2_map[i][p] = d2phidxi2_map[i][0];
<a name="l00573"></a>00573                     d2phidxideta_map[i][p] = d2phidxideta_map[i][0];
<a name="l00574"></a>00574                     d2phideta2_map[i][p] = d2phideta2_map[i][0];
<a name="l00575"></a>00575 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00576"></a>00576 <span class="preprocessor"></span>                  }
<a name="l00577"></a>00577               }
<a name="l00578"></a>00578           }
<a name="l00579"></a>00579         <span class="keywordflow">else</span>
<a name="l00580"></a>00580           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00581"></a>00581             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00582"></a>00582               {
<a name="l00583"></a>00583                 phi_map[i][p]      = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00584"></a>00584                 dphidxi_map[i][p]  = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00585"></a>00585                 dphideta_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[p]);
<a name="l00586"></a>00586 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00587"></a>00587 <span class="preprocessor"></span>                d2phidxi2_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00588"></a>00588                 d2phidxideta_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[p]);
<a name="l00589"></a>00589                 d2phideta2_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[p]);
<a name="l00590"></a>00590 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00591"></a>00591 <span class="preprocessor"></span>              }
<a name="l00592"></a>00592                         
<a name="l00593"></a>00593         <span class="keywordflow">break</span>;
<a name="l00594"></a>00594       }
<a name="l00595"></a>00595 
<a name="l00596"></a>00596 
<a name="l00597"></a>00597       
<a name="l00598"></a>00598       <span class="comment">//------------------------------------------------------------</span>
<a name="l00599"></a>00599       <span class="comment">// 3D</span>
<a name="l00600"></a>00600     <span class="keywordflow">case</span> 3:
<a name="l00601"></a>00601       {
<a name="l00602"></a>00602         <span class="comment">// Compute the value of the approximation shape function i at quadrature point p</span>
<a name="l00603"></a>00603         <span class="keywordflow">if</span> (calculate_phi)
<a name="l00604"></a>00604           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00605"></a>00605             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00606"></a>00606               phi[i][p]       = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,T&gt;::shape</a>       (elem, fe_type.order, i,    qp[p]);
<a name="l00607"></a>00607         <span class="keywordflow">if</span> (calculate_dphi)
<a name="l00608"></a>00608           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00609"></a>00609             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00610"></a>00610               {
<a name="l00611"></a>00611                 dphidxi[i][p]   = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00612"></a>00612                 dphideta[i][p]  = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 1, qp[p]);
<a name="l00613"></a>00613                 dphidzeta[i][p] = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,T&gt;::shape_deriv</a> (elem, fe_type.order, i, 2, qp[p]);
<a name="l00614"></a>00614               }
<a name="l00615"></a>00615 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00616"></a>00616 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (calculate_d2phi)
<a name="l00617"></a>00617           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00618"></a>00618             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00619"></a>00619               {
<a name="l00620"></a>00620                 d2phidxi2[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 0, qp[p]);
<a name="l00621"></a>00621                 d2phidxideta[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 1, qp[p]);
<a name="l00622"></a>00622                 d2phideta2[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 2, qp[p]);
<a name="l00623"></a>00623                 d2phidxidzeta[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 3, qp[p]);
<a name="l00624"></a>00624                 d2phidetadzeta[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 4, qp[p]);
<a name="l00625"></a>00625                 d2phidzeta2[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,T&gt;::shape_second_deriv</a> (elem, fe_type.order, i, 5, qp[p]);
<a name="l00626"></a>00626               }
<a name="l00627"></a>00627 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00628"></a>00628 <span class="preprocessor"></span>        
<a name="l00629"></a>00629         <span class="comment">// Compute the value of the mapping shape function i at quadrature point p</span>
<a name="l00630"></a>00630         <span class="comment">// (Lagrange shape functions are used for mapping)</span>
<a name="l00631"></a>00631         <span class="keywordflow">if</span> (has_affine_map)
<a name="l00632"></a>00632           {
<a name="l00633"></a>00633             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00634"></a>00634               {
<a name="l00635"></a>00635                 phi_map[i][0]      = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[0]);
<a name="l00636"></a>00636                 dphidxi_map[i][0]  = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00637"></a>00637                 dphideta_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[0]);
<a name="l00638"></a>00638                 dphidzeta_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[0]);
<a name="l00639"></a>00639 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00640"></a>00640 <span class="preprocessor"></span>                d2phidxi2_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[0]);
<a name="l00641"></a>00641                 d2phidxideta_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[0]);
<a name="l00642"></a>00642                 d2phideta2_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[0]);
<a name="l00643"></a>00643                 d2phidxideta_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 3, qp[0]);
<a name="l00644"></a>00644                 d2phidetadzeta_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 4, qp[0]);
<a name="l00645"></a>00645                 d2phidzeta2_map[i][0] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 5, qp[0]);
<a name="l00646"></a>00646 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00647"></a>00647 <span class="preprocessor"></span>                <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;n_qp; p++)
<a name="l00648"></a>00648                   {
<a name="l00649"></a>00649                     phi_map[i][p]      = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a> (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00650"></a>00650                     dphidxi_map[i][p]  = dphidxi_map[i][0];
<a name="l00651"></a>00651                     dphideta_map[i][p] = dphideta_map[i][0];
<a name="l00652"></a>00652                     dphidzeta_map[i][p] = dphidzeta_map[i][0];
<a name="l00653"></a>00653 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00654"></a>00654 <span class="preprocessor"></span>                    d2phidxi2_map[i][p] = d2phidxi2_map[i][0];
<a name="l00655"></a>00655                     d2phidxideta_map[i][p] = d2phidxideta_map[i][0];
<a name="l00656"></a>00656                     d2phideta2_map[i][p] = d2phideta2_map[i][0];
<a name="l00657"></a>00657                     d2phidxideta_map[i][p] = d2phidxideta_map[i][0];
<a name="l00658"></a>00658                     d2phidetadzeta_map[i][p] = d2phidetadzeta_map[i][0];
<a name="l00659"></a>00659                     d2phidzeta2_map[i][p] = d2phidzeta2_map[i][0];
<a name="l00660"></a>00660 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00661"></a>00661 <span class="preprocessor"></span>                  }
<a name="l00662"></a>00662               }
<a name="l00663"></a>00663           }
<a name="l00664"></a>00664         <span class="keywordflow">else</span>
<a name="l00665"></a>00665           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_mapping_shape_functions; i++)
<a name="l00666"></a>00666             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00667"></a>00667               {
<a name="l00668"></a>00668                 phi_map[i][p]       = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a>       (mapping_elem_type, mapping_order, i,    qp[p]);
<a name="l00669"></a>00669                 dphidxi_map[i][p]   = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00670"></a>00670                 dphideta_map[i][p]  = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[p]);
<a name="l00671"></a>00671                 dphidzeta_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[p]);
<a name="l00672"></a>00672 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00673"></a>00673 <span class="preprocessor"></span>                d2phidxi2_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 0, qp[p]);
<a name="l00674"></a>00674                 d2phidxideta_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 1, qp[p]);
<a name="l00675"></a>00675                 d2phideta2_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 2, qp[p]);
<a name="l00676"></a>00676                 d2phidxideta_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 3, qp[p]);
<a name="l00677"></a>00677                 d2phidetadzeta_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 4, qp[p]);
<a name="l00678"></a>00678                 d2phidzeta2_map[i][p] = <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;Dim,LAGRANGE&gt;::shape_second_deriv</a> (mapping_elem_type, mapping_order, i, 5, qp[p]);
<a name="l00679"></a>00679 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00680"></a>00680 <span class="preprocessor"></span>              }
<a name="l00681"></a>00681                         
<a name="l00682"></a>00682         <span class="keywordflow">break</span>;
<a name="l00683"></a>00683       }
<a name="l00684"></a>00684 
<a name="l00685"></a>00685 
<a name="l00686"></a>00686     <span class="keywordflow">default</span>:
<a name="l00687"></a>00687       libmesh_error();
<a name="l00688"></a>00688     }
<a name="l00689"></a>00689   
<a name="l00690"></a>00690   <span class="comment">// Stop logging the shape function initialization</span>
<a name="l00691"></a>00691   STOP_LOG(<span class="stringliteral">&quot;init_shape_functions()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00692"></a>00692 }
<a name="l00693"></a>00693 
<a name="l00694"></a>00694 
<a name="l00695"></a>00695 
<a name="l00696"></a>00696     
<a name="l00697"></a>00697 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00698"></a>00698 <span class="preprocessor"></span>
<a name="l00699"></a>00699 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00700"></a><a class="code" href="classlibMesh_1_1FE.php#ac8154be71f2d2b558b2b89cff25d002f">00700</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#ac8154be71f2d2b558b2b89cff25d002f">FE&lt;Dim,T&gt;::init_base_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00701"></a>00701                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e)
<a name="l00702"></a>00702 { 
<a name="l00703"></a>00703   <span class="comment">// I don&#39;t understand infinite elements well enough to risk</span>
<a name="l00704"></a>00704   <span class="comment">// calculating too little.  :-(  RHS</span>
<a name="l00705"></a>00705   calculate_phi = calculate_dphi = calculate_d2phi = <span class="keyword">true</span>;
<a name="l00706"></a>00706 
<a name="l00707"></a>00707   elem_type = e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(); 
<a name="l00708"></a>00708   init_shape_functions(qp, e); 
<a name="l00709"></a>00709 }
<a name="l00710"></a>00710 
<a name="l00711"></a>00711 <span class="preprocessor">#endif // LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00712"></a>00712 <span class="preprocessor"></span>    
<a name="l00713"></a>00713 
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00716"></a>00716 <span class="comment">// Explicit instantiations using macro from fe_macro.h</span>
<a name="l00717"></a>00717 
<a name="l00718"></a>00718 <a class="code" href="namespacelibMesh.php#a0bcd751f4ddb5960369839e9383b3027">INSTANTIATE_FE</a>(0);
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 <a class="code" href="namespacelibMesh.php#a0bcd751f4ddb5960369839e9383b3027">INSTANTIATE_FE</a>(1);
<a name="l00721"></a>00721 
<a name="l00722"></a>00722 <a class="code" href="namespacelibMesh.php#a0bcd751f4ddb5960369839e9383b3027">INSTANTIATE_FE</a>(2);
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 <a class="code" href="namespacelibMesh.php#a0bcd751f4ddb5960369839e9383b3027">INSTANTIATE_FE</a>(3);
<a name="l00725"></a>00725 
<a name="l00726"></a>00726 
<a name="l00727"></a>00727 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
