<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fbfd1e4ea7786050feab5206011c3dac.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe.h</div>  </div>
</div>
<div class="contents">
<a href="fe_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fe_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fe_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>DofConstraints;
<a name="l00036"></a>00036 <span class="keyword">class </span>DofMap;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> friend_Dim, FEFamily friend_T_radial, InfMapType friend_T_map&gt;
<a name="l00041"></a>00041 <span class="keyword">class </span>InfFE;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="preprocessor">#endif</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00065"></a>00065 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00066"></a>00066 <span class="comment">// FE class definition</span>
<a name="l00067"></a>00067 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00068"></a><a class="code" href="classlibMesh_1_1FE.php">00068</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FE.php">FE</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a>
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070 <span class="keyword">public</span>:
<a name="l00071"></a>00071   
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1FE.php#a3886b7dd4aa24a762d2bc78ded60db99">FE</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00076"></a>00076   
<a name="l00085"></a>00085   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00086"></a>00086                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00087"></a>00087                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00088"></a>00088                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00089"></a>00089 
<a name="l00098"></a>00098   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00099"></a>00099                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00100"></a>00100                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00101"></a>00101                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00102"></a>00102   
<a name="l00110"></a>00110   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00111"></a>00111                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00112"></a>00112                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00113"></a>00113                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00114"></a>00114                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00115"></a>00115 
<a name="l00122"></a>00122   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00123"></a>00123                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00124"></a>00124                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00125"></a>00125                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00126"></a>00126                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00127"></a>00127 
<a name="l00146"></a>00146   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00147"></a>00147                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00148"></a>00148                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00149"></a>00149                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00150"></a>00150                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00151"></a>00151 
<a name="l00170"></a>00170   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00171"></a>00171                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00172"></a>00172                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00173"></a>00173                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00174"></a>00174                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00175"></a>00175   
<a name="l00182"></a>00182   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#aeddb953b5b64abc7ab1efa1e5ffc68e9">nodal_soln</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00183"></a>00183                          <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00184"></a>00184                          std::vector&lt;Number&gt;&amp; <a class="code" href="classlibMesh_1_1FE.php#aeddb953b5b64abc7ab1efa1e5ffc68e9">nodal_soln</a>);
<a name="l00185"></a>00185 
<a name="l00190"></a>00190   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">n_shape_functions</a> () <span class="keyword">const</span>;
<a name="l00191"></a>00191 
<a name="l00198"></a><a class="code" href="classlibMesh_1_1FE.php#ada9eac5e8e9bb3d70c406565d9460ba2">00198</a>   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">n_shape_functions</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00199"></a>00199                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o)
<a name="l00200"></a>00200   { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#a401b5a255c73cd4fd202aadee954ba37">FE&lt;Dim,T&gt;::n_dofs</a> (t,o); }
<a name="l00201"></a>00201 
<a name="l00208"></a>00208   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a401b5a255c73cd4fd202aadee954ba37">n_dofs</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00209"></a>00209                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o);
<a name="l00210"></a>00210 
<a name="l00217"></a>00217   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a00239d73fd53a032ab838a5d0a7dc7ce">n_dofs_at_node</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00218"></a>00218                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00219"></a>00219                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00220"></a>00220 
<a name="l00227"></a>00227   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a6790b3764960ddd6e6faaa40bb0b4a65">n_dofs_per_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00228"></a>00228                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o);
<a name="l00229"></a>00229 
<a name="l00233"></a>00233   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classlibMesh_1_1FE.php#a26671578bbeec8d12a76e6d3de92c422">get_continuity</a>() <span class="keyword">const</span>;
<a name="l00234"></a>00234                                        
<a name="l00239"></a>00239   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FE.php#a6e3c6ecf80a5f9a057cd98710650b379">is_hierarchic</a>() <span class="keyword">const</span>;
<a name="l00240"></a>00240                                        
<a name="l00247"></a>00247   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a07513a5d2c88338980f63ae7959bed50">dofs_on_side</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00248"></a>00248                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00249"></a>00249                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00250"></a>00250                            std::vector&lt;unsigned int&gt;&amp; di);
<a name="l00257"></a>00257   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#ac5e1e9342d9545a78d3a8e370dfe8117">dofs_on_edge</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00258"></a>00258                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00259"></a>00259                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00260"></a>00260                            std::vector&lt;unsigned int&gt;&amp; di);
<a name="l00261"></a>00261 
<a name="l00271"></a>00271   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#ac17b5ee3f4e5b0bc2c66a1380582e324">inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00272"></a>00272                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00273"></a>00273                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE,
<a name="l00274"></a>00274                             <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00275"></a>00275 
<a name="l00286"></a>00286   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#ac17b5ee3f4e5b0bc2c66a1380582e324">inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00287"></a>00287                            <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00288"></a>00288                            std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00289"></a>00289                            <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE,
<a name="l00290"></a>00290                            <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00291"></a>00291   
<a name="l00302"></a>00302   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a2f701accaa0865b120c5e19a654b9c0d">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00303"></a>00303                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts = NULL);
<a name="l00304"></a>00304     
<a name="l00310"></a>00310   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a2f701accaa0865b120c5e19a654b9c0d">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00311"></a>00311                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00312"></a>00312                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE);
<a name="l00313"></a>00313 
<a name="l00319"></a>00319   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a30687339a476d74e1ba6b348a335175c">edge_reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00320"></a>00320                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> edge,
<a name="l00321"></a>00321                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE);
<a name="l00322"></a>00322 
<a name="l00328"></a>00328   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a4cac6e5c629fe59f44178dc62ca15abf">attach_quadrature_rule</a> (<a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* q);
<a name="l00329"></a>00329   
<a name="l00335"></a>00335   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a05d14d05d8b8b4f87bbff084dd5def74">n_quadrature_points</a> () <span class="keyword">const</span>;
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00338"></a>00338 <span class="preprocessor"></span>
<a name="l00344"></a>00344   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a7ecb48abba2b40eef1c7c2d8d998cdf8">compute_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00345"></a>00345                                    <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00346"></a>00346                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00347"></a>00347                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00348"></a>00348 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00349"></a>00349 <span class="preprocessor"></span>  
<a name="l00350"></a>00350 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00351"></a>00351 <span class="preprocessor"></span>
<a name="l00356"></a>00356   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#ac8154be71f2d2b558b2b89cff25d002f">init_base_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00357"></a>00357                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e);
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 <span class="preprocessor">#endif</span>
<a name="l00360"></a>00360 <span class="preprocessor"></span>
<a name="l00367"></a>00367   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FE.php#ae8089f56b5648f5657b5d85cd630b622">shapes_need_reinit</a>() <span class="keyword">const</span>;
<a name="l00368"></a>00368   
<a name="l00376"></a>00376   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a23842e856a2968a150cb459ffab1cdd3">init_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00377"></a>00377                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e);
<a name="l00378"></a>00378 
<a name="l00383"></a>00383   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a3ce28a593bb38d9706664411a929563a">init_face_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00384"></a>00384                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>);
<a name="l00385"></a>00385 
<a name="l00390"></a>00390   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a86d0b2372a2514fe50ce904c1ee89ae1">init_edge_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00391"></a>00391                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* edge);
<a name="l00392"></a>00392 
<a name="l00397"></a>00397   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#a26520529cc913b1046bda1018b1441dc">map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00398"></a>00398                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; reference_point);
<a name="l00399"></a>00399   
<a name="l00404"></a>00404   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#a205ebdc6a3fc1a1eabcff5bfd8e724a4">map_xi</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00405"></a>00405                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; reference_point);
<a name="l00406"></a>00406   
<a name="l00411"></a>00411   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#a88e0ee4b0e9721c3086629daf07fd1ca">map_eta</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00412"></a>00412                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; reference_point);
<a name="l00413"></a>00413 
<a name="l00418"></a>00418   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#a74c1b626c81f8b7cba3443d57a3f44ae">map_zeta</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00419"></a>00419                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; reference_point);
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00422"></a>00422 <span class="preprocessor"></span>
<a name="l00426"></a>00426   <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> friend_Dim, FEFamily friend_T_radial, InfMapType friend_T_map&gt;
<a name="l00427"></a><a class="code" href="classlibMesh_1_1FE.php#a30966325e9cd5ef7b41e45148b6919ed">00427</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfFE.php">InfFE</a>;
<a name="l00428"></a>00428 <span class="preprocessor">#endif</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span>
<a name="l00430"></a>00430 <span class="keyword">protected</span>:
<a name="l00435"></a><a class="code" href="classlibMesh_1_1FE.php#acda36d9e38cb4396cc8b6b9333ab1338">00435</a>   std::vector&lt;Point&gt; <a class="code" href="classlibMesh_1_1FE.php#acda36d9e38cb4396cc8b6b9333ab1338">cached_nodes</a>;
<a name="l00436"></a>00436 
<a name="l00440"></a><a class="code" href="classlibMesh_1_1FE.php#a0aae366ba2ee5d293e8df3554ba54a42">00440</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a0aae366ba2ee5d293e8df3554ba54a42">last_side</a>, <a class="code" href="classlibMesh_1_1FE.php#ab2db901a1129961249c840fd9cf867f2">last_edge</a>;
<a name="l00441"></a>00441 };
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00454"></a>00454 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00455"></a>00455 <span class="comment">// FEHierarchic class definition</span>
<a name="l00456"></a>00456 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00457"></a><a class="code" href="classlibMesh_1_1FEClough.php">00457</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEClough.php">FEClough</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,CLOUGH&gt;
<a name="l00458"></a>00458 {
<a name="l00459"></a>00459 <span class="keyword">public</span>:
<a name="l00460"></a>00460 
<a name="l00465"></a>00465   <a class="code" href="classlibMesh_1_1FEClough.php#a0db03e9d31884b79b69053207bccb50a">FEClough</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00466"></a>00466 };
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00479"></a>00479 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00480"></a>00480 <span class="comment">// FEHierarchic class definition</span>
<a name="l00481"></a>00481 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00482"></a><a class="code" href="classlibMesh_1_1FEHermite.php">00482</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,HERMITE&gt;
<a name="l00483"></a>00483 {
<a name="l00484"></a>00484 <span class="keyword">public</span>:
<a name="l00485"></a>00485 
<a name="l00490"></a>00490   <a class="code" href="classlibMesh_1_1FEHermite.php#aa3c2d877063f8184849e12257a4618c2">FEHermite</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00491"></a>00491 
<a name="l00495"></a>00495   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEHermite.php#a8512f4698232e6fde9262b0ad1b272a2">hermite_raw_shape_second_deriv</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00496"></a>00496                                              <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi);
<a name="l00497"></a>00497   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEHermite.php#a7ee5b665d389361ec7673a1cb622fa68">hermite_raw_shape_deriv</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00498"></a>00498                                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi);
<a name="l00499"></a>00499   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEHermite.php#a6f0abdeeaa596a55f6e2fd75c2f28793">hermite_raw_shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00500"></a>00500                                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi);
<a name="l00501"></a>00501 };
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 
<a name="l00504"></a>00504 
<a name="l00514"></a>00514 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00515"></a>00515 <span class="comment">// FEHierarchic class definition</span>
<a name="l00516"></a>00516 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00517"></a><a class="code" href="classlibMesh_1_1FEHierarchic.php">00517</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEHierarchic.php">FEHierarchic</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,HIERARCHIC&gt;
<a name="l00518"></a>00518 {
<a name="l00519"></a>00519 <span class="keyword">public</span>:
<a name="l00520"></a>00520 
<a name="l00525"></a>00525   <a class="code" href="classlibMesh_1_1FEHierarchic.php#a2dc64ee5e4b0d9a74d31a22b7397c7a4">FEHierarchic</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00526"></a>00526 };
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00539"></a>00539 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00540"></a>00540 <span class="comment">// FELagrange class definition</span>
<a name="l00541"></a>00541 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00542"></a><a class="code" href="classlibMesh_1_1FELagrange.php">00542</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FELagrange.php">FELagrange</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,LAGRANGE&gt;
<a name="l00543"></a>00543 {
<a name="l00544"></a>00544 <span class="keyword">public</span>:
<a name="l00545"></a>00545 
<a name="l00550"></a>00550   <a class="code" href="classlibMesh_1_1FELagrange.php#a217345dbf1634e5c8bdf7bda99288bf3">FELagrange</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00551"></a>00551 };
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 
<a name="l00564"></a>00564 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00565"></a>00565 <span class="comment">// FEMonomial class definition</span>
<a name="l00566"></a>00566 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00567"></a><a class="code" href="classlibMesh_1_1FEMonomial.php">00567</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEMonomial.php">FEMonomial</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,MONOMIAL&gt;
<a name="l00568"></a>00568 {
<a name="l00569"></a>00569 <span class="keyword">public</span>:
<a name="l00570"></a>00570 
<a name="l00575"></a>00575   <a class="code" href="classlibMesh_1_1FEMonomial.php#ac06df8782db245410e377552e32bd433">FEMonomial</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00576"></a>00576 };
<a name="l00577"></a>00577 
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00580"></a>00580 <span class="comment">// FEScalar class definition</span>
<a name="l00581"></a>00581 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00582"></a><a class="code" href="classlibMesh_1_1FEScalar.php">00582</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEScalar.php">FEScalar</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,SCALAR&gt;
<a name="l00583"></a>00583 {
<a name="l00584"></a>00584 <span class="keyword">public</span>:
<a name="l00585"></a>00585 
<a name="l00592"></a>00592   <a class="code" href="classlibMesh_1_1FEScalar.php#a69cce2117dfb103c76a3c51007bc3b1c">FEScalar</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00593"></a>00593 };
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 
<a name="l00606"></a>00606 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00607"></a>00607 <span class="comment">// FEXYZ class definition</span>
<a name="l00608"></a>00608 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00609"></a><a class="code" href="classlibMesh_1_1FEXYZ.php">00609</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEXYZ.php">FEXYZ</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,XYZ&gt;
<a name="l00610"></a>00610 {
<a name="l00611"></a>00611 <span class="keyword">public</span>:
<a name="l00612"></a>00612   
<a name="l00617"></a>00617   <a class="code" href="classlibMesh_1_1FEXYZ.php#ab7284e1552282ecf8006a4ab7a73f03b">FEXYZ</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00618"></a>00618     
<a name="l00623"></a><a class="code" href="classlibMesh_1_1FEXYZ.php#ac3483021c8d5daca7ddcace0333015a2">00623</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEXYZ.php#ac3483021c8d5daca7ddcace0333015a2">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00624"></a>00624                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts = NULL)
<a name="l00625"></a>00625   { <a class="code" href="classlibMesh_1_1FEXYZ.php#ac3483021c8d5daca7ddcace0333015a2">FE&lt;Dim,XYZ&gt;::reinit</a> (elem, pts); }
<a name="l00626"></a>00626 
<a name="l00631"></a>00631   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEXYZ.php#ac3483021c8d5daca7ddcace0333015a2">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00632"></a>00632                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00633"></a>00633                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE);
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 
<a name="l00636"></a>00636 <span class="keyword">protected</span>:
<a name="l00637"></a>00637 
<a name="l00645"></a>00645   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEXYZ.php#a93bf11d4d6f7f1862cf5d210a45d5eef">init_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00646"></a>00646                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e);
<a name="l00647"></a>00647 
<a name="l00658"></a>00658   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEXYZ.php#a7b61cf9360ce742e584a36cb79513978">compute_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*);
<a name="l00659"></a>00659 
<a name="l00663"></a>00663   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEXYZ.php#a8115dbb29d93d72172219ab59669b801">compute_face_values</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00664"></a>00664                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>);
<a name="l00665"></a>00665 };
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 
<a name="l00673"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php">00673</a> <span class="keyword">namespace </span>FiniteElements
<a name="l00674"></a>00674 {
<a name="l00679"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#a0dc22346562cc5ad80e3d8315f321db2">00679</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FEClough.php">FEClough&lt;2&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#a0dc22346562cc5ad80e3d8315f321db2">FEClough2D</a>;
<a name="l00680"></a>00680   
<a name="l00685"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#a81b45fa67185daddd792ff6abb9c48bc">00685</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,HIERARCHIC&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#a81b45fa67185daddd792ff6abb9c48bc">FEHierarchic1D</a>;
<a name="l00686"></a>00686   
<a name="l00691"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#addfe5156f3a9863e98582da473276c84">00691</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,HIERARCHIC&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#addfe5156f3a9863e98582da473276c84">FEHierarchic2D</a>;
<a name="l00692"></a>00692   
<a name="l00697"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#a6dda647d858a260ad9e7782fdc0147e5">00697</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HIERARCHIC&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#a6dda647d858a260ad9e7782fdc0147e5">FEHierarchic3D</a>;
<a name="l00698"></a>00698   
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 
<a name="l00705"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#ae7e7bf1717c63fae1483ac80cc721387">00705</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,LAGRANGE&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#ae7e7bf1717c63fae1483ac80cc721387">FELagrange1D</a>;
<a name="l00706"></a>00706 
<a name="l00711"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#aabb5343153c729e1e4271f9bf2c388da">00711</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,LAGRANGE&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#aabb5343153c729e1e4271f9bf2c388da">FELagrange2D</a>;
<a name="l00712"></a>00712 
<a name="l00717"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#a1605e5771c7810c7cb0487a9953b4df5">00717</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,LAGRANGE&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#a1605e5771c7810c7cb0487a9953b4df5">FELagrange3D</a>;
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720   
<a name="l00725"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#a04233d5d1dd48aa682ffbba8cb3f5a35">00725</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,MONOMIAL&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#a04233d5d1dd48aa682ffbba8cb3f5a35">FEMonomial1D</a>;
<a name="l00726"></a>00726   
<a name="l00731"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#a5035e75f92583c38ed67b4f3609cd3ca">00731</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;2,MONOMIAL&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#a5035e75f92583c38ed67b4f3609cd3ca">FEMonomial2D</a>;
<a name="l00732"></a>00732 
<a name="l00737"></a><a class="code" href="namespacelibMesh_1_1FiniteElements.php#ae011741709514a34df20a519e5f5f318">00737</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,MONOMIAL&gt;</a> <a class="code" href="namespacelibMesh_1_1FiniteElements.php#ae011741709514a34df20a519e5f5f318">FEMonomial3D</a>;
<a name="l00738"></a>00738 
<a name="l00739"></a>00739 }
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00745"></a>00745 <span class="comment">// FE class inline members</span>
<a name="l00746"></a>00746 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00747"></a>00747 <span class="keyword">inline</span>
<a name="l00748"></a><a class="code" href="classlibMesh_1_1FE.php#a3886b7dd4aa24a762d2bc78ded60db99">00748</a> <a class="code" href="classlibMesh_1_1FE.php#a3886b7dd4aa24a762d2bc78ded60db99">FE&lt;Dim,T&gt;::FE</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l00749"></a>00749   <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a> (Dim,fet),
<a name="l00750"></a>00750   last_side(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00751"></a>00751   last_edge(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>)
<a name="l00752"></a>00752 {
<a name="l00753"></a>00753   <span class="comment">// Sanity check.  Make sure the</span>
<a name="l00754"></a>00754   <span class="comment">// Family specified in the template instantiation</span>
<a name="l00755"></a>00755   <span class="comment">// matches the one in the FEType object</span>
<a name="l00756"></a>00756   libmesh_assert (T == <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>);
<a name="l00757"></a>00757 }
<a name="l00758"></a>00758 
<a name="l00759"></a>00759 
<a name="l00760"></a>00760 
<a name="l00761"></a>00761 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00762"></a>00762 <span class="comment">// FEClough class inline members</span>
<a name="l00763"></a>00763 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00764"></a>00764 <span class="keyword">inline</span>
<a name="l00765"></a><a class="code" href="classlibMesh_1_1FEClough.php#a0db03e9d31884b79b69053207bccb50a">00765</a> <a class="code" href="classlibMesh_1_1FEClough.php#a0db03e9d31884b79b69053207bccb50a">FEClough&lt;Dim&gt;::FEClough</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l00766"></a>00766   <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>&gt; (fet)
<a name="l00767"></a>00767 {
<a name="l00768"></a>00768 }
<a name="l00769"></a>00769 
<a name="l00770"></a>00770 
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00773"></a>00773 <span class="comment">// FEHermite class inline members</span>
<a name="l00774"></a>00774 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00775"></a>00775 <span class="keyword">inline</span>
<a name="l00776"></a><a class="code" href="classlibMesh_1_1FEHermite.php#aa3c2d877063f8184849e12257a4618c2">00776</a> <a class="code" href="classlibMesh_1_1FEHermite.php#aa3c2d877063f8184849e12257a4618c2">FEHermite&lt;Dim&gt;::FEHermite</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l00777"></a>00777   <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a7264ca68bed0b3e4a43378489afae355">HERMITE</a>&gt; (fet)
<a name="l00778"></a>00778 {
<a name="l00779"></a>00779 }
<a name="l00780"></a>00780 
<a name="l00781"></a>00781 
<a name="l00782"></a>00782 
<a name="l00783"></a>00783 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00784"></a>00784 <span class="comment">// FEHierarchic class inline members</span>
<a name="l00785"></a>00785 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00786"></a>00786 <span class="keyword">inline</span>
<a name="l00787"></a><a class="code" href="classlibMesh_1_1FEHierarchic.php#a2dc64ee5e4b0d9a74d31a22b7397c7a4">00787</a> <a class="code" href="classlibMesh_1_1FEHierarchic.php#a2dc64ee5e4b0d9a74d31a22b7397c7a4">FEHierarchic&lt;Dim&gt;::FEHierarchic</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l00788"></a>00788   <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac5d5bbcbcfbcbe575cfd2219348132c4">HIERARCHIC</a>&gt; (fet)
<a name="l00789"></a>00789 {
<a name="l00790"></a>00790 }
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00795"></a>00795 <span class="comment">// FELagrange class inline members</span>
<a name="l00796"></a>00796 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00797"></a>00797 <span class="keyword">inline</span>
<a name="l00798"></a><a class="code" href="classlibMesh_1_1FELagrange.php#a217345dbf1634e5c8bdf7bda99288bf3">00798</a> <a class="code" href="classlibMesh_1_1FELagrange.php#a217345dbf1634e5c8bdf7bda99288bf3">FELagrange&lt;Dim&gt;::FELagrange</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l00799"></a>00799   <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>&gt; (fet)
<a name="l00800"></a>00800 {
<a name="l00801"></a>00801 }
<a name="l00802"></a>00802 
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00806"></a>00806 <span class="comment">// FEMonomial class inline members</span>
<a name="l00807"></a>00807 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00808"></a>00808 <span class="keyword">inline</span>
<a name="l00809"></a><a class="code" href="classlibMesh_1_1FEMonomial.php#ac06df8782db245410e377552e32bd433">00809</a> <a class="code" href="classlibMesh_1_1FEMonomial.php#ac06df8782db245410e377552e32bd433">FEMonomial&lt;Dim&gt;::FEMonomial</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l00810"></a>00810   <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ae91a24a1ce57904c9f97c767bada32b4">MONOMIAL</a>&gt; (fet)
<a name="l00811"></a>00811 {
<a name="l00812"></a>00812 }
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00818"></a>00818 <span class="comment">// FEXYZ class inline members</span>
<a name="l00819"></a>00819 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00820"></a>00820 <span class="keyword">inline</span>
<a name="l00821"></a><a class="code" href="classlibMesh_1_1FEXYZ.php#ab7284e1552282ecf8006a4ab7a73f03b">00821</a> <a class="code" href="classlibMesh_1_1FEXYZ.php#ab7284e1552282ecf8006a4ab7a73f03b">FEXYZ&lt;Dim&gt;::FEXYZ</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l00822"></a>00822   <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a776f5d12735c7a2d27835d3868ca5221">XYZ</a>&gt; (fet)
<a name="l00823"></a>00823 {
<a name="l00824"></a>00824 }
<a name="l00825"></a>00825 
<a name="l00826"></a>00826 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00827"></a>00827 <span class="comment">// FEScalar class inline members</span>
<a name="l00828"></a>00828 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00829"></a>00829 <span class="keyword">inline</span>
<a name="l00830"></a><a class="code" href="classlibMesh_1_1FEScalar.php#a69cce2117dfb103c76a3c51007bc3b1c">00830</a> <a class="code" href="classlibMesh_1_1FEScalar.php#a69cce2117dfb103c76a3c51007bc3b1c">FEScalar&lt;Dim&gt;::FEScalar</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l00831"></a>00831   <a class="code" href="classlibMesh_1_1FE.php">FE</a>&lt;Dim,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a2ab36d7da9f38141601fd010d729e893">SCALAR</a>&gt; (fet)
<a name="l00832"></a>00832 {
<a name="l00833"></a>00833 }
<a name="l00834"></a>00834 
<a name="l00835"></a>00835 } <span class="comment">// namespace libMesh</span>
<a name="l00836"></a>00836 
<a name="l00837"></a>00837 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
