<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fbfd1e4ea7786050feab5206011c3dac.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_base.h</div>  </div>
</div>
<div class="contents">
<a href="fe__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_base.h 4399 2011-04-22 18:32:39Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fe_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fe_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="vector__value_8h.php">vector_value.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// forward declarations</span>
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseMatrix;
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseVector;
<a name="l00047"></a>00047 <span class="keyword">class </span>BoundaryInfo;
<a name="l00048"></a>00048 <span class="keyword">class </span>DofConstraints;
<a name="l00049"></a>00049 <span class="keyword">class </span>DofMap;
<a name="l00050"></a>00050 <span class="keyword">class </span>Elem;
<a name="l00051"></a>00051 <span class="keyword">class </span>MeshBase;
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00053"></a>00053 <span class="keyword">class </span>QBase;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span><span class="keyword">class </span>PeriodicBoundaries;
<a name="l00057"></a>00057 <span class="keyword">class </span>PointLocatorBase;
<a name="l00058"></a>00058 <span class="preprocessor">#endif</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>
<a name="l00060"></a>00060 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00062"></a>00062 <span class="keyword">class </span>InfFE;
<a name="l00063"></a>00063 <span class="preprocessor">#endif</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00091"></a>00091 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00092"></a>00092 <span class="comment">// FEBase class definition</span>
<a name="l00093"></a><a class="code" href="classlibMesh_1_1FEBase.php">00093</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;FEBase&gt;
<a name="l00094"></a>00094 {
<a name="l00095"></a>00095 <span class="keyword">protected</span>:
<a name="l00096"></a>00096 
<a name="l00102"></a>00102   <a class="code" href="classlibMesh_1_1FEBase.php#a192af2af77761e6f1a4b4d078fee62be">FEBase</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a>,
<a name="l00103"></a>00103           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00104"></a>00104   
<a name="l00105"></a>00105 <span class="keyword">public</span>:
<a name="l00106"></a>00106   
<a name="l00110"></a>00110   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1FEBase.php#a577a559c45a3f0c88bb0a9e555a90c6c">~FEBase</a>();
<a name="l00111"></a>00111 
<a name="l00117"></a>00117   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">build</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00118"></a>00118                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; type); 
<a name="l00119"></a>00119   
<a name="l00120"></a>00120 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span>
<a name="l00127"></a>00127   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classlibMesh_1_1FEBase.php#a42df651089ddc60e9baea1a73633ed90">build_InfFE</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00128"></a>00128                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; type); 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="preprocessor">#endif</span>
<a name="l00131"></a>00131 <span class="preprocessor"></span>
<a name="l00146"></a>00146   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a79b7a69e06d538c334842e1db2bc1223">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00147"></a>00147                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts = NULL) = 0;
<a name="l00148"></a>00148     
<a name="l00154"></a>00154   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a79b7a69e06d538c334842e1db2bc1223">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00155"></a>00155                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00156"></a>00156                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE) = 0;
<a name="l00157"></a>00157   
<a name="l00163"></a>00163   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa42ccc1ab793f7a1a84b808eacd536e6">edge_reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00164"></a>00164                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> edge,
<a name="l00165"></a>00165                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE) = 0;
<a name="l00166"></a>00166   
<a name="l00174"></a>00174   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#afde8f8b71cba1d61a14c63194c8ca68a">on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00175"></a>00175                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00176"></a>00176                                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps = TOLERANCE);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00179"></a>00179 <span class="preprocessor"></span>
<a name="l00186"></a>00186   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a3c6b19b079eaa80d062c0c6e3908bed1">compute_proj_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00187"></a>00187                                         <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00188"></a>00188                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00189"></a>00189                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00190"></a>00190 
<a name="l00196"></a>00196   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9e8a34c7c7dada421bcf88d5c9bc9a9e">coarsened_dof_values</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;global_vector,
<a name="l00197"></a>00197                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00198"></a>00198                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *coarse_elem,
<a name="l00199"></a>00199                                    <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> &amp;coarse_dofs,
<a name="l00200"></a>00200                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00201"></a>00201                                    <span class="keyword">const</span> <span class="keywordtype">bool</span> use_old_dof_indices = <span class="keyword">false</span>);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span>
<a name="l00205"></a>00205 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span>
<a name="l00212"></a>00212   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a6a9baff4a0f58c4c62d50d00a77fbb40">compute_periodic_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00213"></a>00213                                             <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00214"></a>00214                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> &amp;boundaries,
<a name="l00215"></a>00215                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00216"></a>00216                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* point_locator,
<a name="l00217"></a>00217                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00218"></a>00218                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l00221"></a>00221 <span class="preprocessor"></span>
<a name="l00226"></a><a class="code" href="classlibMesh_1_1FEBase.php#a916212d29016e696eb914481e3e0b3fc">00226</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a916212d29016e696eb914481e3e0b3fc">get_xyz</a>()<span class="keyword"> const</span>
<a name="l00227"></a>00227 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>; }
<a name="l00228"></a>00228   
<a name="l00233"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa4ade299922b8d04d73ee5f902526557">00233</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#aa4ade299922b8d04d73ee5f902526557">get_phi</a>()<span class="keyword"> const</span>
<a name="l00234"></a>00234 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a>);
<a name="l00235"></a>00235     <a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">phi</a>; }
<a name="l00236"></a>00236   
<a name="l00241"></a><a class="code" href="classlibMesh_1_1FEBase.php#a68fbad4cea951df70482739ef41354d0">00241</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a68fbad4cea951df70482739ef41354d0">get_JxW</a>()<span class="keyword"> const</span>
<a name="l00242"></a>00242 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>; }
<a name="l00243"></a>00243 
<a name="l00248"></a><a class="code" href="classlibMesh_1_1FEBase.php#a00032001d3a0fda4f6281952b68fa400">00248</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a00032001d3a0fda4f6281952b68fa400">get_dphi</a>()<span class="keyword"> const</span>
<a name="l00249"></a>00249 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00250"></a>00250     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>; }
<a name="l00251"></a>00251   
<a name="l00256"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7f717fa3f44eec495f18a604c4e05873">00256</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a7f717fa3f44eec495f18a604c4e05873">get_dphidx</a>()<span class="keyword"> const</span>
<a name="l00257"></a>00257 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00258"></a>00258     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af788235b8ba5e45b88a1faab71023511">dphidx</a>; }
<a name="l00259"></a>00259   
<a name="l00264"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae0d97502f4715d24e2420541f2d66cc1">00264</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae0d97502f4715d24e2420541f2d66cc1">get_dphidy</a>()<span class="keyword"> const</span>
<a name="l00265"></a>00265 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00266"></a>00266     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">dphidy</a>; }
<a name="l00267"></a>00267   
<a name="l00272"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa56a41bf6ea9f3eb785c6b8ac907c8b6">00272</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#aa56a41bf6ea9f3eb785c6b8ac907c8b6">get_dphidz</a>()<span class="keyword"> const</span>
<a name="l00273"></a>00273 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>);
<a name="l00274"></a>00274     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">dphidz</a>; }
<a name="l00275"></a>00275 
<a name="l00280"></a><a class="code" href="classlibMesh_1_1FEBase.php#a00de91670d2e80ae28efd5f9d5f1e730">00280</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a00de91670d2e80ae28efd5f9d5f1e730">get_dphidxi</a>()<span class="keyword"> const</span>
<a name="l00281"></a>00281 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00282"></a>00282     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>; }
<a name="l00283"></a>00283   
<a name="l00288"></a><a class="code" href="classlibMesh_1_1FEBase.php#a3b482a95bb38c889b7b159959514eaa2">00288</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a3b482a95bb38c889b7b159959514eaa2">get_dphideta</a>()<span class="keyword"> const</span>
<a name="l00289"></a>00289 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>); 
<a name="l00290"></a>00290     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>; }
<a name="l00291"></a>00291   
<a name="l00296"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae7e3da68b2431109084c0b9365cfa697">00296</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae7e3da68b2431109084c0b9365cfa697">get_dphidzeta</a>()<span class="keyword"> const</span>
<a name="l00297"></a>00297 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>);
<a name="l00298"></a>00298     <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a41ed461b364fb98c1c25ed6414ffc8db">dphidzeta</a>; }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00301"></a>00301 <span class="preprocessor"></span>
<a name="l00306"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa844b64d6daf6512b760b9a528fc7848">00306</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#aa844b64d6daf6512b760b9a528fc7848">get_d2phi</a>()<span class="keyword"> const</span>
<a name="l00307"></a>00307 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>); 
<a name="l00308"></a>00308     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>; }
<a name="l00309"></a>00309   
<a name="l00314"></a><a class="code" href="classlibMesh_1_1FEBase.php#adb19cd4b3a848682de61216562d46258">00314</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#adb19cd4b3a848682de61216562d46258">get_d2phidx2</a>()<span class="keyword"> const</span>
<a name="l00315"></a>00315 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00316"></a>00316     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">d2phidx2</a>; }
<a name="l00317"></a>00317   
<a name="l00322"></a><a class="code" href="classlibMesh_1_1FEBase.php#a225b0c138d9619ee1365fe883f961640">00322</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a225b0c138d9619ee1365fe883f961640">get_d2phidxdy</a>()<span class="keyword"> const</span>
<a name="l00323"></a>00323 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00324"></a>00324     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">d2phidxdy</a>; }
<a name="l00325"></a>00325   
<a name="l00330"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4475014e8d36378416784b975b272e9c">00330</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a4475014e8d36378416784b975b272e9c">get_d2phidxdz</a>()<span class="keyword"> const</span>
<a name="l00331"></a>00331 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00332"></a>00332     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">d2phidxdz</a>; }
<a name="l00333"></a>00333   
<a name="l00338"></a><a class="code" href="classlibMesh_1_1FEBase.php#a963c366d16f4e5c5a221ed3665c475f5">00338</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a963c366d16f4e5c5a221ed3665c475f5">get_d2phidy2</a>()<span class="keyword"> const</span>
<a name="l00339"></a>00339 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00340"></a>00340     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">d2phidy2</a>; }
<a name="l00341"></a>00341   
<a name="l00346"></a><a class="code" href="classlibMesh_1_1FEBase.php#afd48c473b3c4b46a60744244aaac6bab">00346</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#afd48c473b3c4b46a60744244aaac6bab">get_d2phidydz</a>()<span class="keyword"> const</span>
<a name="l00347"></a>00347 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00348"></a>00348     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">d2phidydz</a>; }
<a name="l00349"></a>00349   
<a name="l00354"></a><a class="code" href="classlibMesh_1_1FEBase.php#a0552134ae661a20780a0ffe9136f16eb">00354</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a0552134ae661a20780a0ffe9136f16eb">get_d2phidz2</a>()<span class="keyword"> const</span>
<a name="l00355"></a>00355 <span class="keyword">  </span>{ libmesh_assert(!<a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a> || <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>);
<a name="l00356"></a>00356     <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a> = <span class="keyword">true</span>; <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">d2phidz2</a>; }
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="preprocessor">#endif</span>
<a name="l00359"></a>00359 <span class="preprocessor"></span>  
<a name="l00364"></a><a class="code" href="classlibMesh_1_1FEBase.php#a873da67ebc4a818d23dc068daa37186d">00364</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a873da67ebc4a818d23dc068daa37186d">get_dxyzdxi</a>()<span class="keyword"> const</span>
<a name="l00365"></a>00365 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>; }
<a name="l00366"></a>00366 
<a name="l00371"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4356aafa6fcbdf7854aceaffe1950f0f">00371</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a4356aafa6fcbdf7854aceaffe1950f0f">get_dxyzdeta</a>()<span class="keyword"> const</span>
<a name="l00372"></a>00372 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>; }
<a name="l00373"></a>00373 
<a name="l00378"></a><a class="code" href="classlibMesh_1_1FEBase.php#abbedad421faadc2ff3559e9ea7dc7957">00378</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#abbedad421faadc2ff3559e9ea7dc7957">get_dxyzdzeta</a>()<span class="keyword"> const</span>
<a name="l00379"></a>00379 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>; }
<a name="l00380"></a>00380   
<a name="l00384"></a><a class="code" href="classlibMesh_1_1FEBase.php#a8613b53a9a0f75b005ca4efe80fbf5e6">00384</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a8613b53a9a0f75b005ca4efe80fbf5e6">get_d2xyzdxi2</a>()<span class="keyword"> const</span>
<a name="l00385"></a>00385 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>; }
<a name="l00386"></a>00386 
<a name="l00390"></a><a class="code" href="classlibMesh_1_1FEBase.php#a300472022bacaecb2a5e251fc9e145f2">00390</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a300472022bacaecb2a5e251fc9e145f2">get_d2xyzdeta2</a>()<span class="keyword"> const</span>
<a name="l00391"></a>00391 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>; }
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00394"></a>00394 <span class="preprocessor"></span>  
<a name="l00398"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae2b689466cc98a44196ef5a1c19dbe02">00398</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae2b689466cc98a44196ef5a1c19dbe02">get_d2xyzdzeta2</a>()<span class="keyword"> const</span>
<a name="l00399"></a>00399 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">d2xyzdzeta2_map</a>; }
<a name="l00400"></a>00400   
<a name="l00401"></a>00401 <span class="preprocessor">#endif</span>
<a name="l00402"></a>00402 <span class="preprocessor"></span>  
<a name="l00406"></a><a class="code" href="classlibMesh_1_1FEBase.php#a03f30ee2c26be3e8bf07d21d54c82863">00406</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a03f30ee2c26be3e8bf07d21d54c82863">get_d2xyzdxideta</a>()<span class="keyword"> const</span>
<a name="l00407"></a>00407 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>; }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00410"></a>00410 <span class="preprocessor"></span>  
<a name="l00414"></a><a class="code" href="classlibMesh_1_1FEBase.php#a8e346653c82e56c85d57f2a64a5789db">00414</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a8e346653c82e56c85d57f2a64a5789db">get_d2xyzdxidzeta</a>()<span class="keyword"> const</span>
<a name="l00415"></a>00415 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">d2xyzdxidzeta_map</a>; }
<a name="l00416"></a>00416 
<a name="l00420"></a><a class="code" href="classlibMesh_1_1FEBase.php#a33943b6e4da045659c80694e66e042ee">00420</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a33943b6e4da045659c80694e66e042ee">get_d2xyzdetadzeta</a>()<span class="keyword"> const</span>
<a name="l00421"></a>00421 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">d2xyzdetadzeta_map</a>; }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 <span class="preprocessor">#endif</span>
<a name="l00424"></a>00424 <span class="preprocessor"></span>  
<a name="l00429"></a><a class="code" href="classlibMesh_1_1FEBase.php#adacdb7abfb45f93075503c491b7ea859">00429</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#adacdb7abfb45f93075503c491b7ea859">get_dxidx</a>()<span class="keyword"> const</span>
<a name="l00430"></a>00430 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>; }
<a name="l00431"></a>00431 
<a name="l00436"></a><a class="code" href="classlibMesh_1_1FEBase.php#a04d49de7fd7bdda94d3b15affb1d5efa">00436</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a04d49de7fd7bdda94d3b15affb1d5efa">get_dxidy</a>()<span class="keyword"> const</span>
<a name="l00437"></a>00437 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>; }
<a name="l00438"></a>00438 
<a name="l00443"></a><a class="code" href="classlibMesh_1_1FEBase.php#acdca7bdfc4364365320287eadc4833b3">00443</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#acdca7bdfc4364365320287eadc4833b3">get_dxidz</a>()<span class="keyword"> const</span>
<a name="l00444"></a>00444 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>; }
<a name="l00445"></a>00445 
<a name="l00450"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac688428b9142e2d6ca27a0420b627533">00450</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ac688428b9142e2d6ca27a0420b627533">get_detadx</a>()<span class="keyword"> const</span>
<a name="l00451"></a>00451 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>; }
<a name="l00452"></a>00452 
<a name="l00457"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5d14d85c8eca1e4cb647acbbd44daf36">00457</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a5d14d85c8eca1e4cb647acbbd44daf36">get_detady</a>()<span class="keyword"> const</span>
<a name="l00458"></a>00458 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>; }
<a name="l00459"></a>00459 
<a name="l00464"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae1ab8299847ae6027494cb41ae758444">00464</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae1ab8299847ae6027494cb41ae758444">get_detadz</a>()<span class="keyword"> const</span>
<a name="l00465"></a>00465 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>; }
<a name="l00466"></a>00466 
<a name="l00471"></a><a class="code" href="classlibMesh_1_1FEBase.php#a0070553b81441483d0dae640a290e6c2">00471</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a0070553b81441483d0dae640a290e6c2">get_dzetadx</a>()<span class="keyword"> const</span>
<a name="l00472"></a>00472 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>; }
<a name="l00473"></a>00473 
<a name="l00478"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4b686928dad06ccae30080b74f12df4d">00478</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a4b686928dad06ccae30080b74f12df4d">get_dzetady</a>()<span class="keyword"> const</span>
<a name="l00479"></a>00479 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>; }
<a name="l00480"></a>00480 
<a name="l00485"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab4c52a0d85ded34b09b3dccf9674819b">00485</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ab4c52a0d85ded34b09b3dccf9674819b">get_dzetadz</a>()<span class="keyword"> const</span>
<a name="l00486"></a>00486 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>; }
<a name="l00487"></a>00487   
<a name="l00488"></a>00488 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00489"></a>00489 <span class="preprocessor"></span>
<a name="l00500"></a><a class="code" href="classlibMesh_1_1FEBase.php#a60b68907bb757385086daeaeb5583840">00500</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a60b68907bb757385086daeaeb5583840">get_dphase</a>()<span class="keyword"> const</span>
<a name="l00501"></a>00501 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a736b3086ae27dfdb25eea45a32d8be46">dphase</a>; }
<a name="l00502"></a>00502 
<a name="l00503"></a>00503 
<a name="l00516"></a><a class="code" href="classlibMesh_1_1FEBase.php#af2206d26dcf0a8daeb77ccede092e446">00516</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#af2206d26dcf0a8daeb77ccede092e446">get_Sobolev_weight</a>()<span class="keyword"> const</span>
<a name="l00517"></a>00517 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a68e24d92c979f86161c991c5d9679efd">weight</a>; }
<a name="l00518"></a>00518 
<a name="l00524"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac101983243b18de5be27f901c228f7d7">00524</a>   <span class="keyword">const</span> std::vector&lt;RealGradient&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ac101983243b18de5be27f901c228f7d7">get_Sobolev_dweight</a>()<span class="keyword"> const</span>
<a name="l00525"></a>00525 <span class="keyword">      </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5e1ad40ece4ef6feb855628dd30217fa">dweight</a>; }
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 <span class="preprocessor">#endif</span>
<a name="l00528"></a>00528 <span class="preprocessor"></span>
<a name="l00529"></a>00529   
<a name="l00533"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae9881db3ec685b4abc05774f921b5c23">00533</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Point&gt; &gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#ae9881db3ec685b4abc05774f921b5c23">get_tangents</a>()<span class="keyword"> const</span>
<a name="l00534"></a>00534 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a75af7795f42767464ccf13ff1d461211">tangents</a>; }
<a name="l00535"></a>00535   
<a name="l00539"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9078ec05cdd69415d6eda9a1a0d7a61f">00539</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a9078ec05cdd69415d6eda9a1a0d7a61f">get_normals</a>()<span class="keyword"> const</span>
<a name="l00540"></a>00540 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a7e59b6e942afe70db77d4270a2f22a92">normals</a>; }
<a name="l00541"></a>00541 
<a name="l00545"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9b077a144e6a56f6e4ff481ffd3899bb">00545</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1FEBase.php#a9b077a144e6a56f6e4ff481ffd3899bb">get_curvatures</a>()<span class="keyword"> const</span>
<a name="l00546"></a>00546 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aac9919c0f087c1439e39de79469c3620">curvatures</a>;}
<a name="l00547"></a>00547   
<a name="l00552"></a>00552   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#aee369a488ea99b9dbbd48b8a288e242d">attach_quadrature_rule</a> (<a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* q) = 0;
<a name="l00553"></a>00553 
<a name="l00559"></a>00559   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9b62c96b04ef966bc60698668fc50ae2">n_shape_functions</a> () <span class="keyword">const</span> = 0;
<a name="l00560"></a>00560 
<a name="l00565"></a>00565   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#a4654366f3c40cf9798130ae40a3f237d">n_quadrature_points</a> () <span class="keyword">const</span> = 0;
<a name="l00566"></a>00566   
<a name="l00572"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac0fc89014c1461482964913acbf3c473">00572</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1FEBase.php#ac0fc89014c1461482964913acbf3c473">get_type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a99ba1265271c4c3a26b8c71c1c35c7e6">elem_type</a>; }
<a name="l00573"></a>00573 
<a name="l00578"></a><a class="code" href="classlibMesh_1_1FEBase.php#ad3d200ccc45670a850c9d6c3ef9cd1c5">00578</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad3d200ccc45670a850c9d6c3ef9cd1c5">get_p_level</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#af53860e35032db7fd392c199e8d8389a">_p_level</a>; }
<a name="l00579"></a>00579 
<a name="l00583"></a><a class="code" href="classlibMesh_1_1FEBase.php#a92b2eaa1dc1b54e5dbbecce45ed732ef">00583</a>   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> <a class="code" href="classlibMesh_1_1FEBase.php#a92b2eaa1dc1b54e5dbbecce45ed732ef">get_fe_type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>; }
<a name="l00584"></a>00584 
<a name="l00588"></a><a class="code" href="classlibMesh_1_1FEBase.php#a1b8cca9e17655605147b013f9f2f6421">00588</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1FEBase.php#a1b8cca9e17655605147b013f9f2f6421">get_order</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> + <a class="code" href="classlibMesh_1_1FEBase.php#af53860e35032db7fd392c199e8d8389a">_p_level</a>); }
<a name="l00589"></a>00589 
<a name="l00593"></a>00593   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classlibMesh_1_1FEBase.php#a8ef41afc2e271d2a4c06c62fbc6964a5">get_continuity</a>() <span class="keyword">const</span> = 0;
<a name="l00594"></a>00594 
<a name="l00599"></a>00599   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#af709cad010aac366e7441fed797ebc35">is_hierarchic</a>() <span class="keyword">const</span> = 0;
<a name="l00600"></a>00600 
<a name="l00604"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa5fa89a3197c8b3b10fb2abb3ddc8220">00604</a>   <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="classlibMesh_1_1FEBase.php#aa5fa89a3197c8b3b10fb2abb3ddc8220">get_family</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>; }
<a name="l00605"></a>00605 
<a name="l00609"></a>00609   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a756e10b9e7a9c4f92531e6f8fe278795">print_JxW</a>(std::ostream&amp; os) <span class="keyword">const</span>; 
<a name="l00610"></a>00610   
<a name="l00614"></a>00614   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a9d95ed9fed8a96c18ff68be25d988b8f">print_phi</a>(std::ostream&amp; os) <span class="keyword">const</span>; 
<a name="l00615"></a>00615   
<a name="l00620"></a>00620   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a2b5d94c3ceb3f6b9a5eb589238f532b9">print_dphi</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00623"></a>00623 <span class="preprocessor"></span>
<a name="l00628"></a>00628   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac335f09834d705416b119e0a7c6d83a3">print_d2phi</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 <span class="preprocessor">#endif</span>
<a name="l00631"></a>00631 <span class="preprocessor"></span>  
<a name="l00636"></a>00636   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ade57dae87a9086c7c30741368a47b8e5">print_xyz</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00637"></a>00637 
<a name="l00641"></a>00641   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#af737e6b5daf21df5f3b8a850c20db32a">print_info</a>(std::ostream&amp; os) <span class="keyword">const</span>;
<a name="l00642"></a>00642 
<a name="l00646"></a>00646   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classlibMesh_1_1FEBase.php#af707d8f04488db8220405623626a146a">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a>&amp; fe);
<a name="l00647"></a>00647   
<a name="l00648"></a>00648   
<a name="l00649"></a>00649 <span class="keyword">protected</span>:
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652     
<a name="l00653"></a>00653 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00654"></a>00654 <span class="preprocessor"></span>
<a name="l00660"></a>00660   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a3395d0d9c15aa2ad5e246efdbffa4a45">init_base_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00661"></a>00661                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) = 0;
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 <span class="preprocessor">#endif</span>
<a name="l00664"></a>00664 <span class="preprocessor"></span>
<a name="l00670"></a>00670   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#abd044b0b177027f910216e798e4436a1">compute_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00671"></a>00671                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e);
<a name="l00672"></a>00672   
<a name="l00679"></a>00679   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab2a635bf29b6bc9d23590c1b4152b1df">compute_affine_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00680"></a>00680                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e);
<a name="l00681"></a>00681 
<a name="l00686"></a>00686   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#adba0bb8c55b1c53ac0cba7b1884180b0">compute_single_point_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00687"></a>00687                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e,
<a name="l00688"></a>00688                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p);
<a name="l00689"></a>00689   
<a name="l00693"></a>00693   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac2f2ae3020f2bd820e84221b723fcb12">resize_map_vectors</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp);
<a name="l00694"></a>00694 
<a name="l00698"></a>00698   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab7942827e4a09c31d046859ca822c948">compute_face_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00699"></a>00699                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* side);
<a name="l00700"></a>00700 
<a name="l00704"></a>00704   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5382d1dbc9cac70126980415cafda726">compute_edge_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00705"></a>00705                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* side);
<a name="l00706"></a>00706 
<a name="l00717"></a>00717   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#aec0d64ab86b8d4ffcfc90588ace98524">compute_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*);
<a name="l00718"></a>00718   
<a name="l00719"></a>00719 
<a name="l00725"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa173e314ea4d6da0e051aba7357393b3">00725</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#aa173e314ea4d6da0e051aba7357393b3">dxdxi_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p](0); }
<a name="l00726"></a>00726 
<a name="l00732"></a><a class="code" href="classlibMesh_1_1FEBase.php#a70c807295d3ee32f02e8db8c064c2a69">00732</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#a70c807295d3ee32f02e8db8c064c2a69">dydxi_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p](1); }
<a name="l00733"></a>00733 
<a name="l00739"></a><a class="code" href="classlibMesh_1_1FEBase.php#add885fcfc231cb5f1bae5fa79e26b5ed">00739</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#add885fcfc231cb5f1bae5fa79e26b5ed">dzdxi_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const   </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p](2); }
<a name="l00740"></a>00740 
<a name="l00746"></a><a class="code" href="classlibMesh_1_1FEBase.php#adbe405374738b13bcc4237c470691994">00746</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#adbe405374738b13bcc4237c470691994">dxdeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p](0); }
<a name="l00747"></a>00747 
<a name="l00753"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa2b58e35c68f2799aa973f54ae6bf1df">00753</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#aa2b58e35c68f2799aa973f54ae6bf1df">dydeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p](1); } 
<a name="l00754"></a>00754 
<a name="l00760"></a><a class="code" href="classlibMesh_1_1FEBase.php#a0afe7058842193201f4754362f3e40df">00760</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#a0afe7058842193201f4754362f3e40df">dzdeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p](2); }
<a name="l00761"></a>00761 
<a name="l00767"></a><a class="code" href="classlibMesh_1_1FEBase.php#a1702b8d10f490aff3a311cf68237cf58">00767</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#a1702b8d10f490aff3a311cf68237cf58">dxdzeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[p](0); }
<a name="l00768"></a>00768 
<a name="l00774"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae1d648a326b54e268be20fd640a40eb3">00774</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#ae1d648a326b54e268be20fd640a40eb3">dydzeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[p](1); }
<a name="l00775"></a>00775 
<a name="l00781"></a><a class="code" href="classlibMesh_1_1FEBase.php#a10703c0c0035098e9a6e0aca97beb57c">00781</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEBase.php#a10703c0c0035098e9a6e0aca97beb57c">dzdzeta_map</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[p](2); }
<a name="l00782"></a>00782 
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 
<a name="l00785"></a>00785 
<a name="l00786"></a>00786   
<a name="l00790"></a><a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">00790</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a>;
<a name="l00791"></a>00791 
<a name="l00795"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">00795</a>   std::vector&lt;Point&gt; <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>;
<a name="l00796"></a>00796 
<a name="l00797"></a>00797 
<a name="l00798"></a>00798   
<a name="l00803"></a><a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">00803</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>;
<a name="l00804"></a>00804 
<a name="l00809"></a><a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">00809</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>;
<a name="l00810"></a>00810 
<a name="l00815"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">00815</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>;
<a name="l00816"></a>00816   
<a name="l00821"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">00821</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>;
<a name="l00822"></a>00822 
<a name="l00827"></a><a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">00827</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>;
<a name="l00828"></a>00828 
<a name="l00833"></a><a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">00833</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>;
<a name="l00834"></a>00834 
<a name="l00835"></a>00835 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00836"></a>00836 <span class="preprocessor"></span>
<a name="l00841"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">00841</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">d2xyzdxidzeta_map</a>;
<a name="l00842"></a>00842 
<a name="l00847"></a><a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">00847</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">d2xyzdetadzeta_map</a>;
<a name="l00848"></a>00848 
<a name="l00853"></a><a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">00853</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">d2xyzdzeta2_map</a>;
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 <span class="preprocessor">#endif</span>
<a name="l00856"></a>00856 <span class="preprocessor"></span>  
<a name="l00861"></a><a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">00861</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>;
<a name="l00862"></a>00862 
<a name="l00867"></a><a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">00867</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>;
<a name="l00868"></a>00868 
<a name="l00873"></a><a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">00873</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>;
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 
<a name="l00876"></a>00876 
<a name="l00877"></a>00877   
<a name="l00882"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">00882</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>;
<a name="l00883"></a>00883 
<a name="l00888"></a><a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">00888</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>;
<a name="l00889"></a>00889 
<a name="l00894"></a><a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">00894</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>;
<a name="l00895"></a>00895 
<a name="l00896"></a>00896 
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 
<a name="l00899"></a>00899   
<a name="l00904"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">00904</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>;
<a name="l00905"></a>00905 
<a name="l00910"></a><a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">00910</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>;
<a name="l00911"></a>00911 
<a name="l00916"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">00916</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>;
<a name="l00917"></a>00917 
<a name="l00922"></a><a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">00922</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a21086169151d3274ecfefa03039162fc">calculations_started</a>;
<a name="l00923"></a>00923 
<a name="l00927"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">00927</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a5347b5c1604abaf2bf6a387eeb55f572">calculate_phi</a>;
<a name="l00928"></a>00928 
<a name="l00932"></a><a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">00932</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a3aee3c1c80c3e2934f1375247d9bb431">calculate_dphi</a>;
<a name="l00933"></a>00933 
<a name="l00937"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">00937</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>;
<a name="l00938"></a>00938 
<a name="l00942"></a><a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">00942</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a17a8b5dc3944c7848af1541f07ff9963">phi</a>;
<a name="l00943"></a>00943 
<a name="l00947"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">00947</a>   std::vector&lt;std::vector&lt;RealGradient&gt; &gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a5d3c004bf1a96cf936cc3c5db5ab8170">dphi</a>;
<a name="l00948"></a>00948 
<a name="l00952"></a><a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">00952</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a55924631f827328b44a9f34b36ac80df">dphidxi</a>;
<a name="l00953"></a>00953 
<a name="l00957"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">00957</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a5418c7b62ef30ce968b09f22f9240db7">dphideta</a>;
<a name="l00958"></a>00958   
<a name="l00962"></a><a class="code" href="classlibMesh_1_1FEBase.php#a41ed461b364fb98c1c25ed6414ffc8db">00962</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a41ed461b364fb98c1c25ed6414ffc8db">dphidzeta</a>;
<a name="l00963"></a>00963 
<a name="l00967"></a><a class="code" href="classlibMesh_1_1FEBase.php#af788235b8ba5e45b88a1faab71023511">00967</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#af788235b8ba5e45b88a1faab71023511">dphidx</a>;
<a name="l00968"></a>00968 
<a name="l00972"></a><a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">00972</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#af9dc49053521282a4b176a74df91dc0b">dphidy</a>;
<a name="l00973"></a>00973 
<a name="l00977"></a><a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">00977</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#aabdefc6f2e13fa5880273c269b21b362">dphidz</a>;
<a name="l00978"></a>00978 
<a name="l00979"></a>00979 
<a name="l00980"></a>00980 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00981"></a>00981 <span class="preprocessor"></span>  
<a name="l00985"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">00985</a>   std::vector&lt;std::vector&lt;RealTensor&gt; &gt;  <a class="code" href="classlibMesh_1_1FEBase.php#ac30dc4874a7bf7f81ba1774e80dfc10c">d2phi</a>;
<a name="l00986"></a>00986 
<a name="l00990"></a><a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">00990</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a8015bef034bd5509122b437fc1c82100">d2phidxi2</a>;
<a name="l00991"></a>00991 
<a name="l00995"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">00995</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a7c5f099795f3a0a1ce4ca105ecad930a">d2phidxideta</a>;
<a name="l00996"></a>00996   
<a name="l01000"></a><a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">01000</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a30eceed833b0d3bc5aaff3259f1f6f32">d2phidxidzeta</a>;
<a name="l01001"></a>01001 
<a name="l01005"></a><a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">01005</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#af6aac6f2d35dfdc781f73a1007cfb7cb">d2phideta2</a>;
<a name="l01006"></a>01006 
<a name="l01010"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">01010</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a4aa2fe65c1c10165df3b20d2b98ed8f5">d2phidetadzeta</a>;
<a name="l01011"></a>01011   
<a name="l01015"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">01015</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ae2c0e416e3a48d0264958a32cf120d20">d2phidzeta2</a>;
<a name="l01016"></a>01016 
<a name="l01020"></a><a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">01020</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ae714718de014536d22cae1025152c1bc">d2phidx2</a>;
<a name="l01021"></a>01021 
<a name="l01025"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">01025</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#aa6a1dbdf1d2b43775f970a2935c856eb">d2phidxdy</a>;
<a name="l01026"></a>01026 
<a name="l01030"></a><a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">01030</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a9d886719c19dd168b673a8e4c2e0e22c">d2phidxdz</a>;
<a name="l01031"></a>01031 
<a name="l01035"></a><a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">01035</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a2dd94fa0428de261dccfdb1c56bbe6ff">d2phidy2</a>;
<a name="l01036"></a>01036 
<a name="l01040"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">01040</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a4062e05a6ae4409130a3e8170a6416b6">d2phidydz</a>;
<a name="l01041"></a>01041 
<a name="l01045"></a><a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">01045</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a1f0b11a1d8784fd8eb4604a9605aa421">d2phidz2</a>;
<a name="l01046"></a>01046   
<a name="l01047"></a>01047 <span class="preprocessor">#endif</span>
<a name="l01048"></a>01048 <span class="preprocessor"></span>
<a name="l01049"></a>01049 
<a name="l01050"></a>01050 
<a name="l01051"></a>01051   
<a name="l01055"></a><a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">01055</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>;
<a name="l01056"></a>01056 
<a name="l01060"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4ce4aa7d641ab7d3a38bb5be8db1fa62">01060</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a4ce4aa7d641ab7d3a38bb5be8db1fa62">dphidxi_map</a>;
<a name="l01061"></a>01061 
<a name="l01065"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7cd2ca921c422d405ac9518c91d1eebf">01065</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a7cd2ca921c422d405ac9518c91d1eebf">dphideta_map</a>;
<a name="l01066"></a>01066 
<a name="l01070"></a><a class="code" href="classlibMesh_1_1FEBase.php#a4ee95ba576c7a780f489e80a623b59b3">01070</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a4ee95ba576c7a780f489e80a623b59b3">dphidzeta_map</a>;
<a name="l01071"></a>01071 
<a name="l01072"></a>01072 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l01073"></a>01073 <span class="preprocessor"></span>
<a name="l01077"></a><a class="code" href="classlibMesh_1_1FEBase.php#ada94b1f5b37ea3deab82c4146cb2d0aa">01077</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ada94b1f5b37ea3deab82c4146cb2d0aa">d2phidxi2_map</a>;
<a name="l01078"></a>01078 
<a name="l01082"></a><a class="code" href="classlibMesh_1_1FEBase.php#a568b109f25df018387061568627d03e0">01082</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a568b109f25df018387061568627d03e0">d2phidxideta_map</a>;
<a name="l01083"></a>01083 
<a name="l01087"></a><a class="code" href="classlibMesh_1_1FEBase.php#af478144998beaa1c7465ac3434b27b4a">01087</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#af478144998beaa1c7465ac3434b27b4a">d2phidxidzeta_map</a>;
<a name="l01088"></a>01088 
<a name="l01092"></a><a class="code" href="classlibMesh_1_1FEBase.php#a0d690cfc9d95b964392128e8c3e5c9af">01092</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a0d690cfc9d95b964392128e8c3e5c9af">d2phideta2_map</a>;
<a name="l01093"></a>01093 
<a name="l01097"></a><a class="code" href="classlibMesh_1_1FEBase.php#ad27265d343c92a7f614f44b59350a4e6">01097</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ad27265d343c92a7f614f44b59350a4e6">d2phidetadzeta_map</a>;
<a name="l01098"></a>01098 
<a name="l01102"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab705352c53f9bf0a0a48f1411448d674">01102</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#ab705352c53f9bf0a0a48f1411448d674">d2phidzeta2_map</a>;
<a name="l01103"></a>01103 
<a name="l01104"></a>01104 <span class="preprocessor">#endif</span>
<a name="l01105"></a>01105 <span class="preprocessor"></span>  
<a name="l01106"></a>01106 
<a name="l01107"></a>01107 
<a name="l01108"></a>01108 
<a name="l01109"></a>01109   
<a name="l01113"></a><a class="code" href="classlibMesh_1_1FEBase.php#aa0f7b14cfaee75c87cfdcbb82a9e11fb">01113</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#aa0f7b14cfaee75c87cfdcbb82a9e11fb">psi_map</a>;
<a name="l01114"></a>01114 
<a name="l01119"></a><a class="code" href="classlibMesh_1_1FEBase.php#abc94029585d2dfa72eb2cca7416511f4">01119</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#abc94029585d2dfa72eb2cca7416511f4">dpsidxi_map</a>;
<a name="l01120"></a>01120 
<a name="l01125"></a><a class="code" href="classlibMesh_1_1FEBase.php#a20c465fb766b38e8444823e542901952">01125</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1FEBase.php#a20c465fb766b38e8444823e542901952">dpsideta_map</a>;
<a name="l01126"></a>01126 
<a name="l01132"></a><a class="code" href="classlibMesh_1_1FEBase.php#a20b0364af51f086b305f1054f88a904d">01132</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1FEBase.php#a20b0364af51f086b305f1054f88a904d">d2psidxi2_map</a>;
<a name="l01133"></a>01133 
<a name="l01139"></a><a class="code" href="classlibMesh_1_1FEBase.php#a099296b4316f3597d1cebab9b727b274">01139</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1FEBase.php#a099296b4316f3597d1cebab9b727b274">d2psidxideta_map</a>;
<a name="l01140"></a>01140 
<a name="l01146"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7040dce3d91c517ec4f9ccd127021c02">01146</a>   std::vector&lt;std::vector&lt;Real&gt; &gt; <a class="code" href="classlibMesh_1_1FEBase.php#a7040dce3d91c517ec4f9ccd127021c02">d2psideta2_map</a>;
<a name="l01147"></a>01147 
<a name="l01148"></a>01148   
<a name="l01149"></a>01149 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01150"></a>01150 <span class="preprocessor"></span>
<a name="l01151"></a>01151   <span class="comment">//--------------------------------------------------------------</span>
<a name="l01152"></a>01152   <span class="comment">/* protected members for infinite elements, which are accessed </span>
<a name="l01153"></a>01153 <span class="comment">   * from the outside through some inline functions</span>
<a name="l01154"></a>01154 <span class="comment">   */</span>
<a name="l01155"></a>01155 
<a name="l01156"></a>01156 
<a name="l01162"></a><a class="code" href="classlibMesh_1_1FEBase.php#a736b3086ae27dfdb25eea45a32d8be46">01162</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a736b3086ae27dfdb25eea45a32d8be46">dphase</a>;
<a name="l01163"></a>01163 
<a name="l01169"></a><a class="code" href="classlibMesh_1_1FEBase.php#a5e1ad40ece4ef6feb855628dd30217fa">01169</a>   std::vector&lt;RealGradient&gt; <a class="code" href="classlibMesh_1_1FEBase.php#a5e1ad40ece4ef6feb855628dd30217fa">dweight</a>;
<a name="l01170"></a>01170 
<a name="l01176"></a><a class="code" href="classlibMesh_1_1FEBase.php#a68e24d92c979f86161c991c5d9679efd">01176</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a68e24d92c979f86161c991c5d9679efd">weight</a>;
<a name="l01177"></a>01177 
<a name="l01178"></a>01178 <span class="preprocessor">#endif</span>
<a name="l01179"></a>01179 <span class="preprocessor"></span>
<a name="l01180"></a>01180 
<a name="l01181"></a>01181 
<a name="l01182"></a>01182   
<a name="l01186"></a><a class="code" href="classlibMesh_1_1FEBase.php#a75af7795f42767464ccf13ff1d461211">01186</a>   std::vector&lt;std::vector&lt;Point&gt; &gt;  <a class="code" href="classlibMesh_1_1FEBase.php#a75af7795f42767464ccf13ff1d461211">tangents</a>;
<a name="l01187"></a>01187 
<a name="l01191"></a><a class="code" href="classlibMesh_1_1FEBase.php#a7e59b6e942afe70db77d4270a2f22a92">01191</a>   std::vector&lt;Point&gt;                <a class="code" href="classlibMesh_1_1FEBase.php#a7e59b6e942afe70db77d4270a2f22a92">normals</a>;
<a name="l01192"></a>01192 
<a name="l01198"></a><a class="code" href="classlibMesh_1_1FEBase.php#aac9919c0f087c1439e39de79469c3620">01198</a>   std::vector&lt;Real&gt;                 <a class="code" href="classlibMesh_1_1FEBase.php#aac9919c0f087c1439e39de79469c3620">curvatures</a>;
<a name="l01199"></a>01199   
<a name="l01203"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">01203</a>   std::vector&lt;Real&gt;                 <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>;
<a name="l01204"></a>01204 
<a name="l01209"></a><a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">01209</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>;
<a name="l01210"></a>01210   
<a name="l01215"></a><a class="code" href="classlibMesh_1_1FEBase.php#a99ba1265271c4c3a26b8c71c1c35c7e6">01215</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1FEBase.php#a99ba1265271c4c3a26b8c71c1c35c7e6">elem_type</a>;
<a name="l01216"></a>01216 
<a name="l01221"></a><a class="code" href="classlibMesh_1_1FEBase.php#af53860e35032db7fd392c199e8d8389a">01221</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEBase.php#af53860e35032db7fd392c199e8d8389a">_p_level</a>;
<a name="l01222"></a>01222 
<a name="l01226"></a><a class="code" href="classlibMesh_1_1FEBase.php#abcabec825c0abb699a454176b12b1b41">01226</a>   <a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* <a class="code" href="classlibMesh_1_1FEBase.php#abcabec825c0abb699a454176b12b1b41">qrule</a>;
<a name="l01227"></a>01227 
<a name="l01232"></a><a class="code" href="classlibMesh_1_1FEBase.php#a02e6dd164380fe7c60cb69ed624e1220">01232</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#a02e6dd164380fe7c60cb69ed624e1220">shapes_on_quadrature</a>;
<a name="l01233"></a>01233 
<a name="l01234"></a>01234 
<a name="l01235"></a>01235 <span class="keyword">private</span>:
<a name="l01236"></a>01236 
<a name="l01243"></a>01243   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEBase.php#aaa07e229d5bc30aa5d7e303f89c269cd">shapes_need_reinit</a>() <span class="keyword">const</span> = 0;
<a name="l01244"></a>01244 
<a name="l01245"></a>01245 
<a name="l01246"></a>01246 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01247"></a>01247 <span class="preprocessor"></span>
<a name="l01253"></a>01253   <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> friend_Dim, FEFamily friend_T_radial, InfMapType friend_T_map&gt;
<a name="l01254"></a><a class="code" href="classlibMesh_1_1FEBase.php#a30966325e9cd5ef7b41e45148b6919ed">01254</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfFE.php">InfFE</a>;
<a name="l01255"></a>01255 
<a name="l01256"></a>01256 <span class="preprocessor">#endif</span>
<a name="l01257"></a>01257 <span class="preprocessor"></span>
<a name="l01258"></a>01258 
<a name="l01259"></a>01259 };
<a name="l01260"></a>01260 
<a name="l01261"></a>01261 
<a name="l01262"></a>01262 
<a name="l01263"></a>01263 
<a name="l01264"></a>01264 <span class="comment">// ------------------------------------------------------------</span>
<a name="l01265"></a>01265 <span class="comment">// FEBase class inline members</span>
<a name="l01266"></a>01266 <span class="keyword">inline</span>
<a name="l01267"></a><a class="code" href="classlibMesh_1_1FEBase.php#a192af2af77761e6f1a4b4d078fee62be">01267</a> <a class="code" href="classlibMesh_1_1FEBase.php#a192af2af77761e6f1a4b4d078fee62be">FEBase::FEBase</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d,
<a name="l01268"></a>01268                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l01269"></a>01269   dim(d),
<a name="l01270"></a>01270   xyz(),
<a name="l01271"></a>01271   dxyzdxi_map(),
<a name="l01272"></a>01272   dxyzdeta_map(),
<a name="l01273"></a>01273   dxyzdzeta_map(),
<a name="l01274"></a>01274   d2xyzdxi2_map(),
<a name="l01275"></a>01275   d2xyzdxideta_map(),
<a name="l01276"></a>01276   d2xyzdeta2_map(),
<a name="l01277"></a>01277 #ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES
<a name="l01278"></a>01278   d2xyzdxidzeta_map(),
<a name="l01279"></a>01279   d2xyzdetadzeta_map(),
<a name="l01280"></a>01280   d2xyzdzeta2_map(),
<a name="l01281"></a>01281 #endif
<a name="l01282"></a>01282   dxidx_map(),
<a name="l01283"></a>01283   dxidy_map(),
<a name="l01284"></a>01284   dxidz_map(),
<a name="l01285"></a>01285   detadx_map(),
<a name="l01286"></a>01286   detady_map(),
<a name="l01287"></a>01287   detadz_map(),
<a name="l01288"></a>01288   dzetadx_map(),
<a name="l01289"></a>01289   dzetady_map(),
<a name="l01290"></a>01290   dzetadz_map(),
<a name="l01291"></a>01291   calculations_started(false),
<a name="l01292"></a>01292   calculate_phi(false),
<a name="l01293"></a>01293   calculate_dphi(false),
<a name="l01294"></a>01294   calculate_d2phi(false),
<a name="l01295"></a>01295   phi(),
<a name="l01296"></a>01296   dphi(),
<a name="l01297"></a>01297   dphidxi(),
<a name="l01298"></a>01298   dphideta(),
<a name="l01299"></a>01299   dphidzeta(),
<a name="l01300"></a>01300   dphidx(),
<a name="l01301"></a>01301   dphidy(),
<a name="l01302"></a>01302   dphidz(),
<a name="l01303"></a>01303 #ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES
<a name="l01304"></a>01304   d2phi(),
<a name="l01305"></a>01305   d2phidxi2(),
<a name="l01306"></a>01306   d2phidxideta(),
<a name="l01307"></a>01307   d2phidxidzeta(),
<a name="l01308"></a>01308   d2phideta2(),
<a name="l01309"></a>01309   d2phidetadzeta(),
<a name="l01310"></a>01310   d2phidzeta2(),
<a name="l01311"></a>01311   d2phidx2(),
<a name="l01312"></a>01312   d2phidxdy(),
<a name="l01313"></a>01313   d2phidxdz(),
<a name="l01314"></a>01314   d2phidy2(),
<a name="l01315"></a>01315   d2phidydz(),
<a name="l01316"></a>01316   d2phidz2(),
<a name="l01317"></a>01317 #endif
<a name="l01318"></a>01318   phi_map(),
<a name="l01319"></a>01319   dphidxi_map(),
<a name="l01320"></a>01320   dphideta_map(),
<a name="l01321"></a>01321   dphidzeta_map(),
<a name="l01322"></a>01322 #ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES
<a name="l01323"></a>01323   d2phidxi2_map(),
<a name="l01324"></a>01324   d2phidxideta_map(),
<a name="l01325"></a>01325   d2phidxidzeta_map(),
<a name="l01326"></a>01326   d2phideta2_map(),
<a name="l01327"></a>01327   d2phidetadzeta_map(),
<a name="l01328"></a>01328   d2phidzeta2_map(),
<a name="l01329"></a>01329 #endif
<a name="l01330"></a>01330   psi_map(),
<a name="l01331"></a>01331   dpsidxi_map(),
<a name="l01332"></a>01332   dpsideta_map(),
<a name="l01333"></a>01333   d2psidxi2_map(),
<a name="l01334"></a>01334   d2psidxideta_map(),
<a name="l01335"></a>01335   d2psideta2_map(),
<a name="l01336"></a>01336 #ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS
<a name="l01337"></a>01337   dphase(),
<a name="l01338"></a>01338   dweight(),
<a name="l01339"></a>01339   <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">weight</a>(),
<a name="l01340"></a>01340 #endif
<a name="l01341"></a>01341   tangents(),
<a name="l01342"></a>01342   normals(),
<a name="l01343"></a>01343   curvatures(),
<a name="l01344"></a>01344   JxW(),
<a name="l01345"></a>01345   fe_type(fet),
<a name="l01346"></a>01346   elem_type(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>),
<a name="l01347"></a>01347   _p_level(0),
<a name="l01348"></a>01348   qrule(NULL),
<a name="l01349"></a>01349   shapes_on_quadrature(false)
<a name="l01350"></a>01350 {
<a name="l01351"></a>01351 }
<a name="l01352"></a>01352 
<a name="l01353"></a>01353 
<a name="l01354"></a>01354 
<a name="l01355"></a>01355 <span class="keyword">inline</span>
<a name="l01356"></a><a class="code" href="classlibMesh_1_1FEBase.php#a577a559c45a3f0c88bb0a9e555a90c6c">01356</a> <a class="code" href="classlibMesh_1_1FEBase.php#a577a559c45a3f0c88bb0a9e555a90c6c">FEBase::~FEBase</a>()
<a name="l01357"></a>01357 {
<a name="l01358"></a>01358 }
<a name="l01359"></a>01359 
<a name="l01360"></a>01360 } <span class="comment">// namespace libMesh</span>
<a name="l01361"></a>01361 
<a name="l01362"></a>01362 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
