<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_bernstein_shape_1D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__bernstein__shape__1D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_bernstein_shape_1D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The Next Great Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;&gt;
<a name="l00036"></a><a class="code" href="classlibMesh_1_1FE.php#a1f58e7dbcfde672b30fce3cf4fa8c1e5">00036</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,BERNSTEIN&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00037"></a>00037                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00038"></a>00038                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00039"></a>00039                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0);
<a name="l00042"></a>00042   <span class="keyword">using</span> <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">Utility::pow</a>;
<a name="l00043"></a>00043   
<a name="l00044"></a>00044   <span class="keywordflow">switch</span> (order)
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00047"></a>00047       
<a name="l00048"></a>00048       <span class="keywordflow">switch</span>(i)
<a name="l00049"></a>00049         {
<a name="l00050"></a>00050         <span class="keywordflow">case</span> 0:
<a name="l00051"></a>00051           <span class="keywordflow">return</span> (1.-xi)/2.;
<a name="l00052"></a>00052         <span class="keywordflow">case</span> 1:
<a name="l00053"></a>00053           <span class="keywordflow">return</span> (1.+xi)/2.;
<a name="l00054"></a>00054         <span class="keywordflow">default</span>:
<a name="l00055"></a>00055           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00056"></a>00056           libmesh_error();          
<a name="l00057"></a>00057         }
<a name="l00058"></a>00058       
<a name="l00059"></a>00059     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00060"></a>00060       
<a name="l00061"></a>00061       <span class="keywordflow">switch</span>(i)
<a name="l00062"></a>00062         {
<a name="l00063"></a>00063         <span class="keywordflow">case</span> 0:
<a name="l00064"></a>00064           <span class="keywordflow">return</span> (1./4.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.-xi);
<a name="l00065"></a>00065         <span class="keywordflow">case</span> 1:
<a name="l00066"></a>00066           <span class="keywordflow">return</span> (1./4.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.+xi);
<a name="l00067"></a>00067         <span class="keywordflow">case</span> 2:
<a name="l00068"></a>00068           <span class="keywordflow">return</span> (1./2.)*(1.-xi)*(1.+xi);
<a name="l00069"></a>00069         <span class="keywordflow">default</span>:
<a name="l00070"></a>00070           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00071"></a>00071           libmesh_error();          
<a name="l00072"></a>00072         }   
<a name="l00073"></a>00073       
<a name="l00074"></a>00074     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00075"></a>00075       
<a name="l00076"></a>00076       <span class="keywordflow">switch</span>(i)
<a name="l00077"></a>00077         {
<a name="l00078"></a>00078         <span class="keywordflow">case</span> 0:
<a name="l00079"></a>00079           <span class="keywordflow">return</span> (1./8.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.-xi);
<a name="l00080"></a>00080         <span class="keywordflow">case</span> 1:
<a name="l00081"></a>00081           <span class="keywordflow">return</span> (1./8.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.+xi);
<a name="l00082"></a>00082         <span class="keywordflow">case</span> 2:
<a name="l00083"></a>00083           <span class="keywordflow">return</span> (3./8.)*(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.-xi);
<a name="l00084"></a>00084         <span class="keywordflow">case</span> 3:
<a name="l00085"></a>00085           <span class="keywordflow">return</span> (3./8.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.+xi)*(1.-xi);                 
<a name="l00086"></a>00086         <span class="keywordflow">default</span>:
<a name="l00087"></a>00087           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00088"></a>00088           libmesh_error();          
<a name="l00089"></a>00089         }   
<a name="l00090"></a>00090       
<a name="l00091"></a>00091     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00092"></a>00092       
<a name="l00093"></a>00093       <span class="keywordflow">switch</span>(i)
<a name="l00094"></a>00094         {
<a name="l00095"></a>00095         <span class="keywordflow">case</span> 0:
<a name="l00096"></a>00096           <span class="keywordflow">return</span> (1./16.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.-xi);
<a name="l00097"></a>00097         <span class="keywordflow">case</span> 1:
<a name="l00098"></a>00098           <span class="keywordflow">return</span> (1./16.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.+xi);
<a name="l00099"></a>00099         <span class="keywordflow">case</span> 2:
<a name="l00100"></a>00100           <span class="keywordflow">return</span> (1./ 4.)*(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.-xi);
<a name="l00101"></a>00101         <span class="keywordflow">case</span> 3:
<a name="l00102"></a>00102           <span class="keywordflow">return</span> (3./ 8.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.-xi);
<a name="l00103"></a>00103         <span class="keywordflow">case</span> 4:
<a name="l00104"></a>00104           <span class="keywordflow">return</span> (1./ 4.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.+xi)*(1.-xi);
<a name="l00105"></a>00105         <span class="keywordflow">default</span>:
<a name="l00106"></a>00106           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00107"></a>00107           libmesh_error();          
<a name="l00108"></a>00108         }   
<a name="l00109"></a>00109       
<a name="l00110"></a>00110       
<a name="l00111"></a>00111     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00112"></a>00112       
<a name="l00113"></a>00113       <span class="keywordflow">switch</span>(i)
<a name="l00114"></a>00114         {
<a name="l00115"></a>00115         <span class="keywordflow">case</span> 0:
<a name="l00116"></a>00116           <span class="keywordflow">return</span> (1./32.)*pow&lt;5&gt;(1.-xi);
<a name="l00117"></a>00117         <span class="keywordflow">case</span> 1:
<a name="l00118"></a>00118           <span class="keywordflow">return</span> (1./32.)*pow&lt;5&gt;(1.+xi);
<a name="l00119"></a>00119         <span class="keywordflow">case</span> 2:
<a name="l00120"></a>00120           <span class="keywordflow">return</span> (5./32.)*(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.-xi);    
<a name="l00121"></a>00121         <span class="keywordflow">case</span> 3:
<a name="l00122"></a>00122           <span class="keywordflow">return</span> (5./16.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.-xi);
<a name="l00123"></a>00123         <span class="keywordflow">case</span> 4:
<a name="l00124"></a>00124           <span class="keywordflow">return</span> (5./16.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.-xi);
<a name="l00125"></a>00125         <span class="keywordflow">case</span> 5:
<a name="l00126"></a>00126           <span class="keywordflow">return</span> (5./32.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.+xi)*(1.-xi);
<a name="l00127"></a>00127         <span class="keywordflow">default</span>:
<a name="l00128"></a>00128           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00129"></a>00129           libmesh_error();          
<a name="l00130"></a>00130         }   
<a name="l00131"></a>00131       
<a name="l00132"></a>00132       
<a name="l00133"></a>00133     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00134"></a>00134       
<a name="l00135"></a>00135       <span class="keywordflow">switch</span> (i)
<a name="l00136"></a>00136         {
<a name="l00137"></a>00137         <span class="keywordflow">case</span> 0:
<a name="l00138"></a>00138           <span class="keywordflow">return</span> ( 1./64.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a2d46d0773532b1585515720757cbab90">pow&lt;6&gt;</a>(1.-xi);
<a name="l00139"></a>00139         <span class="keywordflow">case</span> 1:
<a name="l00140"></a>00140           <span class="keywordflow">return</span> ( 1./64.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a2d46d0773532b1585515720757cbab90">pow&lt;6&gt;</a>(1.+xi);
<a name="l00141"></a>00141         <span class="keywordflow">case</span> 2:
<a name="l00142"></a>00142           <span class="keywordflow">return</span> ( 3./32.)*(1.+xi)*pow&lt;5&gt;(1.-xi);
<a name="l00143"></a>00143         <span class="keywordflow">case</span> 3:
<a name="l00144"></a>00144           <span class="keywordflow">return</span> (15./64.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.-xi);
<a name="l00145"></a>00145         <span class="keywordflow">case</span> 4:
<a name="l00146"></a>00146           <span class="keywordflow">return</span> ( 5./16.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.-xi);
<a name="l00147"></a>00147         <span class="keywordflow">case</span> 5:                              
<a name="l00148"></a>00148           <span class="keywordflow">return</span> (15./64.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.-xi);
<a name="l00149"></a>00149         <span class="keywordflow">case</span> 6:
<a name="l00150"></a>00150           <span class="keywordflow">return</span> ( 3./32.)*pow&lt;5&gt;(1.+xi)*(1.-xi);    
<a name="l00151"></a>00151         <span class="keywordflow">default</span>:
<a name="l00152"></a>00152           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00153"></a>00153           libmesh_error();          
<a name="l00154"></a>00154         }         
<a name="l00155"></a>00155       
<a name="l00156"></a>00156     <span class="keywordflow">default</span>:
<a name="l00157"></a>00157       {
<a name="l00158"></a>00158         libmesh_assert (order&gt;6);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160         <span class="comment">// Use this for arbitrary orders.</span>
<a name="l00161"></a>00161         <span class="comment">// Note that this implementation is less efficient.</span>
<a name="l00162"></a>00162         <span class="keyword">const</span> <span class="keywordtype">int</span> p_order = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(order);
<a name="l00163"></a>00163         <span class="keyword">const</span> <span class="keywordtype">int</span> m       = p_order-i+1;
<a name="l00164"></a>00164         <span class="keyword">const</span> <span class="keywordtype">int</span> n       = (i-1);
<a name="l00165"></a>00165         
<a name="l00166"></a>00166         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> binomial_p_i = 1;
<a name="l00167"></a>00167         
<a name="l00168"></a>00168         <span class="comment">// the binomial coefficient (p choose n)</span>
<a name="l00169"></a>00169         <span class="keywordflow">if</span> (i&gt;1)
<a name="l00170"></a>00170           binomial_p_i = <a class="code" href="namespacelibMesh_1_1Utility.php#a448493f3f6e7c8827127c19049a0273c">Utility::factorial</a>(p_order)
<a name="l00171"></a>00171             / (<a class="code" href="namespacelibMesh_1_1Utility.php#a448493f3f6e7c8827127c19049a0273c">Utility::factorial</a>(n)*<a class="code" href="namespacelibMesh_1_1Utility.php#a448493f3f6e7c8827127c19049a0273c">Utility::factorial</a>(p_order-n));
<a name="l00172"></a>00172         
<a name="l00173"></a>00173         
<a name="l00174"></a>00174         <span class="keywordflow">switch</span>(i)
<a name="l00175"></a>00175           {
<a name="l00176"></a>00176           <span class="keywordflow">case</span> 0:
<a name="l00177"></a>00177             <span class="keywordflow">return</span> binomial_p_i * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1-xi)/2,static_cast&lt;int&gt;(p_order));
<a name="l00178"></a>00178           <span class="keywordflow">case</span> 1:
<a name="l00179"></a>00179             <span class="keywordflow">return</span> binomial_p_i * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1+xi)/2,static_cast&lt;int&gt;(p_order));
<a name="l00180"></a>00180           <span class="keywordflow">default</span>:
<a name="l00181"></a>00181             {
<a name="l00182"></a>00182               <span class="keywordflow">return</span> binomial_p_i * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1+xi)/2,n)
<a name="l00183"></a>00183                                   * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1-xi)/2,m);
<a name="l00184"></a>00184             }
<a name="l00185"></a>00185           }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187         <span class="comment">// we should never get here</span>
<a name="l00188"></a>00188         libmesh_error();
<a name="l00189"></a>00189       }
<a name="l00190"></a>00190     }
<a name="l00191"></a>00191   
<a name="l00192"></a>00192   libmesh_error();
<a name="l00193"></a>00193   <span class="keywordflow">return</span> 0.;
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="keyword">template</span> &lt;&gt;
<a name="l00199"></a><a class="code" href="classlibMesh_1_1FE.php#ad54ae1c9b4cc230d36b43eab3a2acf20">00199</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,BERNSTEIN&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00200"></a>00200                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00201"></a>00201                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00202"></a>00202                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00203"></a>00203 {
<a name="l00204"></a>00204   libmesh_assert (elem != NULL);
<a name="l00205"></a>00205   
<a name="l00206"></a>00206   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,BERNSTEIN&gt;::shape</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, p);
<a name="l00207"></a>00207 }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="keyword">template</span> &lt;&gt;
<a name="l00212"></a><a class="code" href="classlibMesh_1_1FE.php#afca91eb1c97b23b183f06240b1a9d3c8">00212</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00213"></a>00213                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00214"></a>00214                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00215"></a>00215                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00216"></a>00216                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00217"></a>00217 {
<a name="l00218"></a>00218   <span class="comment">// only d()/dxi in 1D!</span>
<a name="l00219"></a>00219   
<a name="l00220"></a>00220   libmesh_assert (j == 0);
<a name="l00221"></a>00221   
<a name="l00222"></a>00222   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0);
<a name="l00223"></a>00223   
<a name="l00224"></a>00224   <span class="keyword">using</span> <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">Utility::pow</a>;      
<a name="l00225"></a>00225   
<a name="l00226"></a>00226   <span class="keywordflow">switch</span> (order)
<a name="l00227"></a>00227     {      
<a name="l00228"></a>00228     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00229"></a>00229         
<a name="l00230"></a>00230       <span class="keywordflow">switch</span>(i)
<a name="l00231"></a>00231         {
<a name="l00232"></a>00232         <span class="keywordflow">case</span> 0:
<a name="l00233"></a>00233           <span class="keywordflow">return</span> -.5;
<a name="l00234"></a>00234         <span class="keywordflow">case</span> 1:
<a name="l00235"></a>00235           <span class="keywordflow">return</span> .5;        
<a name="l00236"></a>00236         <span class="keywordflow">default</span>:
<a name="l00237"></a>00237           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00238"></a>00238           libmesh_error();
<a name="l00239"></a>00239         }
<a name="l00240"></a>00240       
<a name="l00241"></a>00241     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00242"></a>00242       
<a name="l00243"></a>00243       <span class="keywordflow">switch</span>(i)
<a name="l00244"></a>00244         {
<a name="l00245"></a>00245         <span class="keywordflow">case</span> 0:
<a name="l00246"></a>00246           <span class="keywordflow">return</span> (xi-1.)*.5;
<a name="l00247"></a>00247         <span class="keywordflow">case</span> 1:
<a name="l00248"></a>00248           <span class="keywordflow">return</span> (xi+1.)*.5;
<a name="l00249"></a>00249         <span class="keywordflow">case</span> 2:
<a name="l00250"></a>00250           <span class="keywordflow">return</span> -xi;           
<a name="l00251"></a>00251         <span class="keywordflow">default</span>:
<a name="l00252"></a>00252           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00253"></a>00253           libmesh_error();
<a name="l00254"></a>00254         }
<a name="l00255"></a>00255       
<a name="l00256"></a>00256     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00257"></a>00257 
<a name="l00258"></a>00258       <span class="keywordflow">switch</span>(i)
<a name="l00259"></a>00259         {
<a name="l00260"></a>00260         <span class="keywordflow">case</span> 0:
<a name="l00261"></a>00261           <span class="keywordflow">return</span> -0.375*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.-xi);
<a name="l00262"></a>00262         <span class="keywordflow">case</span> 1:
<a name="l00263"></a>00263           <span class="keywordflow">return</span>  0.375*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.+xi);
<a name="l00264"></a>00264         <span class="keywordflow">case</span> 2:
<a name="l00265"></a>00265           <span class="keywordflow">return</span> -0.375 -.75*xi +1.125*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(xi);
<a name="l00266"></a>00266         <span class="keywordflow">case</span> 3:
<a name="l00267"></a>00267           <span class="keywordflow">return</span>  0.375 -.75*xi -1.125*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(xi);
<a name="l00268"></a>00268         <span class="keywordflow">default</span>:
<a name="l00269"></a>00269           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00270"></a>00270           libmesh_error();
<a name="l00271"></a>00271         }
<a name="l00272"></a>00272       
<a name="l00273"></a>00273     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00274"></a>00274       
<a name="l00275"></a>00275       <span class="keywordflow">switch</span>(i)
<a name="l00276"></a>00276         {
<a name="l00277"></a>00277         <span class="keywordflow">case</span> 0:
<a name="l00278"></a>00278           <span class="keywordflow">return</span> -0.25*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.-xi);
<a name="l00279"></a>00279         <span class="keywordflow">case</span> 1:
<a name="l00280"></a>00280           <span class="keywordflow">return</span>  0.25*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.+xi);
<a name="l00281"></a>00281         <span class="keywordflow">case</span> 2:
<a name="l00282"></a>00282           <span class="keywordflow">return</span> -0.5 +1.5*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(xi)-<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(xi); 
<a name="l00283"></a>00283         <span class="keywordflow">case</span> 3:
<a name="l00284"></a>00284           <span class="keywordflow">return</span>  1.5*(<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(xi)-xi);
<a name="l00285"></a>00285         <span class="keywordflow">case</span> 4:
<a name="l00286"></a>00286           <span class="keywordflow">return</span>  0.5 -1.5*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(xi)-<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(xi);  
<a name="l00287"></a>00287         <span class="keywordflow">default</span>:
<a name="l00288"></a>00288           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00289"></a>00289           libmesh_error();
<a name="l00290"></a>00290         }
<a name="l00291"></a>00291       
<a name="l00292"></a>00292     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00293"></a>00293       
<a name="l00294"></a>00294       <span class="keywordflow">switch</span>(i)
<a name="l00295"></a>00295         {
<a name="l00296"></a>00296         <span class="keywordflow">case</span> 0:
<a name="l00297"></a>00297           <span class="keywordflow">return</span> -(5./32.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(xi-1.);
<a name="l00298"></a>00298         <span class="keywordflow">case</span> 1:
<a name="l00299"></a>00299           <span class="keywordflow">return</span>  (5./32.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(xi+1.);
<a name="l00300"></a>00300         <span class="keywordflow">case</span> 2:
<a name="l00301"></a>00301           <span class="keywordflow">return</span>  (5./32.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.-xi)         -(5./8.)*(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.-xi);
<a name="l00302"></a>00302         <span class="keywordflow">case</span> 3:
<a name="l00303"></a>00303           <span class="keywordflow">return</span>  (5./ 8.)*(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.-xi) -(15./16.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.-xi);
<a name="l00304"></a>00304         <span class="keywordflow">case</span> 4: 
<a name="l00305"></a>00305           <span class="keywordflow">return</span> -(5./ 8.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.+xi)*(1.-xi) +(15./16.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.-xi); 
<a name="l00306"></a>00306         <span class="keywordflow">case</span> 5:
<a name="l00307"></a>00307           <span class="keywordflow">return</span>  (5./ 8.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.+xi)*(1.-xi) -(5./32.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.+xi);          
<a name="l00308"></a>00308         <span class="keywordflow">default</span>:
<a name="l00309"></a>00309           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00310"></a>00310           libmesh_error();
<a name="l00311"></a>00311         }
<a name="l00312"></a>00312       
<a name="l00313"></a>00313     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:         
<a name="l00314"></a>00314       
<a name="l00315"></a>00315       <span class="keywordflow">switch</span>(i)
<a name="l00316"></a>00316         {
<a name="l00317"></a>00317         <span class="keywordflow">case</span> 0:
<a name="l00318"></a>00318           <span class="keywordflow">return</span> -( 3./32.)*pow&lt;5&gt;(1.-xi);
<a name="l00319"></a>00319         <span class="keywordflow">case</span> 1:
<a name="l00320"></a>00320           <span class="keywordflow">return</span>  ( 3./32.)*pow&lt;5&gt;(1.+xi);
<a name="l00321"></a>00321         <span class="keywordflow">case</span> 2:
<a name="l00322"></a>00322           <span class="keywordflow">return</span>  ( 3./32.)*pow&lt;5&gt;(1.-xi)-(15./32.)*(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.-xi);
<a name="l00323"></a>00323         <span class="keywordflow">case</span> 3:
<a name="l00324"></a>00324           <span class="keywordflow">return</span>  (15./32.)*(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.-xi)-(15./16.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.+xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.-xi); 
<a name="l00325"></a>00325         <span class="keywordflow">case</span> 4:
<a name="l00326"></a>00326           <span class="keywordflow">return</span> -(15./ 8.)*xi +(15./4.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(xi)-(15./8.)*pow&lt;5&gt;(xi);
<a name="l00327"></a>00327         <span class="keywordflow">case</span> 5:
<a name="l00328"></a>00328           <span class="keywordflow">return</span> -(15./32.)*(1.-xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.+xi)+(15./16.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(1.-xi)*<a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(1.+xi);                        
<a name="l00329"></a>00329         <span class="keywordflow">case</span> 6:
<a name="l00330"></a>00330           <span class="keywordflow">return</span>  (15./32.)*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(1.+xi)*(1.-xi)-(3./32.)*pow&lt;5&gt;(1.+xi);
<a name="l00331"></a>00331         <span class="keywordflow">default</span>:
<a name="l00332"></a>00332           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00333"></a>00333           libmesh_error();
<a name="l00334"></a>00334         }
<a name="l00335"></a>00335       
<a name="l00336"></a>00336       
<a name="l00337"></a>00337     <span class="keywordflow">default</span>:
<a name="l00338"></a>00338       {
<a name="l00339"></a>00339         libmesh_assert (order&gt;6);
<a name="l00340"></a>00340 
<a name="l00341"></a>00341         <span class="comment">// Use this for arbitrary orders</span>
<a name="l00342"></a>00342         <span class="keyword">const</span> <span class="keywordtype">int</span> p_order = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(order);
<a name="l00343"></a>00343         <span class="keyword">const</span> <span class="keywordtype">int</span> m       = p_order-(i-1);
<a name="l00344"></a>00344         <span class="keyword">const</span> <span class="keywordtype">int</span> n       = (i-1);
<a name="l00345"></a>00345         
<a name="l00346"></a>00346         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> binomial_p_i = 1;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348         <span class="comment">// the binomial coefficient (p choose n)        </span>
<a name="l00349"></a>00349         <span class="keywordflow">if</span> (i&gt;1)
<a name="l00350"></a>00350           binomial_p_i = <a class="code" href="namespacelibMesh_1_1Utility.php#a448493f3f6e7c8827127c19049a0273c">Utility::factorial</a>(p_order)
<a name="l00351"></a>00351             / (<a class="code" href="namespacelibMesh_1_1Utility.php#a448493f3f6e7c8827127c19049a0273c">Utility::factorial</a>(n)*<a class="code" href="namespacelibMesh_1_1Utility.php#a448493f3f6e7c8827127c19049a0273c">Utility::factorial</a>(p_order-n));
<a name="l00352"></a>00352         
<a name="l00353"></a>00353         
<a name="l00354"></a>00354         
<a name="l00355"></a>00355         <span class="keywordflow">switch</span>(i)
<a name="l00356"></a>00356           {
<a name="l00357"></a>00357           <span class="keywordflow">case</span> 0:
<a name="l00358"></a>00358             <span class="keywordflow">return</span> binomial_p_i * (-1./2.) * p_order * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1-xi)/2,static_cast&lt;int&gt;(p_order-1));
<a name="l00359"></a>00359           <span class="keywordflow">case</span> 1:
<a name="l00360"></a>00360             <span class="keywordflow">return</span> binomial_p_i * ( 1./2.) * p_order * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1+xi)/2,static_cast&lt;int&gt;(p_order-1));
<a name="l00361"></a>00361             
<a name="l00362"></a>00362           <span class="keywordflow">default</span>:
<a name="l00363"></a>00363             {
<a name="l00364"></a>00364               <span class="keywordflow">return</span> binomial_p_i * (1./2. * n * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1+xi)/2,n-1) * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1-xi)/2,m)
<a name="l00365"></a>00365                                    - 1./2. * m * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1+xi)/2,n)   * <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>((1-xi)/2,m-1));
<a name="l00366"></a>00366             }
<a name="l00367"></a>00367           }
<a name="l00368"></a>00368         
<a name="l00369"></a>00369         <span class="comment">// we should never get here</span>
<a name="l00370"></a>00370         libmesh_error();
<a name="l00371"></a>00371       }      
<a name="l00372"></a>00372 
<a name="l00373"></a>00373     }
<a name="l00374"></a>00374   
<a name="l00375"></a>00375   libmesh_error();
<a name="l00376"></a>00376   <span class="keywordflow">return</span> 0.;
<a name="l00377"></a>00377 }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 <span class="keyword">template</span> &lt;&gt;
<a name="l00382"></a><a class="code" href="classlibMesh_1_1FE.php#a248b475de2e917da1409e2833c75d1ab">00382</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00383"></a>00383                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00384"></a>00384                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00385"></a>00385                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00386"></a>00386                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00387"></a>00387 {
<a name="l00388"></a>00388   libmesh_assert (elem != NULL);
<a name="l00389"></a>00389   
<a name="l00390"></a>00390   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,BERNSTEIN&gt;::shape_deriv</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(),
<a name="l00391"></a>00391                                       <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, j, p);
<a name="l00392"></a>00392 }
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 <span class="keyword">template</span> &lt;&gt;
<a name="l00397"></a><a class="code" href="classlibMesh_1_1FE.php#a208640c8a95c14652cb5f1491c6bd0f2">00397</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;1,BERNSTEIN&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00398"></a>00398                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00399"></a>00399                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00400"></a>00400                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00401"></a>00401                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00402"></a>00402 {
<a name="l00403"></a>00403   <span class="keyword">static</span> <span class="keywordtype">bool</span> warning_given = <span class="keyword">false</span>;
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="keywordflow">if</span> (!warning_given)
<a name="l00406"></a>00406   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Second derivatives for Bernstein elements &quot;</span>
<a name="l00407"></a>00407                 &lt;&lt; <span class="stringliteral">&quot;are not yet implemented!&quot;</span>
<a name="l00408"></a>00408                 &lt;&lt; std::endl;
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   warning_given = <span class="keyword">true</span>;
<a name="l00411"></a>00411   <span class="keywordflow">return</span> 0.;
<a name="l00412"></a>00412 }
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="keyword">template</span> &lt;&gt;
<a name="l00418"></a><a class="code" href="classlibMesh_1_1FE.php#a968c41529a0cebf420e0b6cfe091ba9b">00418</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;1,BERNSTEIN&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00419"></a>00419                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00420"></a>00420                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00421"></a>00421                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00422"></a>00422                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00423"></a>00423 {
<a name="l00424"></a>00424   <span class="keyword">static</span> <span class="keywordtype">bool</span> warning_given = <span class="keyword">false</span>;
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="keywordflow">if</span> (!warning_given)
<a name="l00427"></a>00427   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Second derivatives for Bernstein elements &quot;</span>
<a name="l00428"></a>00428                 &lt;&lt; <span class="stringliteral">&quot;are not yet implemented!&quot;</span>
<a name="l00429"></a>00429                 &lt;&lt; std::endl;
<a name="l00430"></a>00430 
<a name="l00431"></a>00431   warning_given = <span class="keyword">true</span>;
<a name="l00432"></a>00432   <span class="keywordflow">return</span> 0.;
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 } <span class="comment">// namespace libMesh</span>
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 <span class="preprocessor">#endif //LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
