<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_clough.C</div>  </div>
</div>
<div class="contents">
<a href="fe__clough_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_clough.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="fe__macro_8h.php">fe_macro.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// Hierarchic-specific implementations</span>
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00036"></a>00036 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#aeddb953b5b64abc7ab1efa1e5ffc68e9">FE&lt;Dim,T&gt;::nodal_soln</a>(<span class="keyword">const</span> Elem* elem,
<a name="l00037"></a>00037                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00038"></a>00038                            <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00039"></a>00039                            std::vector&lt;Number&gt;&amp;       nodal_soln)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;n_nodes();
<a name="l00042"></a>00042   
<a name="l00043"></a>00043   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;type();
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   nodal_soln.resize(n_nodes);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;p_level());
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   
<a name="l00050"></a>00050   <span class="keywordflow">switch</span> (totalorder)
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052       <span class="comment">// Piecewise cubic shape functions with linear flux edges</span>
<a name="l00053"></a>00053     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00054"></a>00054       <span class="comment">// Piecewise cubic shape functions</span>
<a name="l00055"></a>00055     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00056"></a>00056       {
<a name="l00057"></a>00057 
<a name="l00058"></a>00058         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf =
<a name="l00059"></a>00059           <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;Dim,T&gt;::n_shape_functions</a>(type, totalorder);
<a name="l00060"></a>00060         
<a name="l00061"></a>00061         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; n++)
<a name="l00062"></a>00062           {
<a name="l00063"></a>00063             <span class="keyword">const</span> Point mapped_point = <a class="code" href="classlibMesh_1_1FE.php#ac17b5ee3f4e5b0bc2c66a1380582e324">FE&lt;Dim,T&gt;::inverse_map</a>(elem,
<a name="l00064"></a>00064                                                               elem-&gt;point(n));
<a name="l00065"></a>00065 
<a name="l00066"></a>00066             libmesh_assert (elem_soln.size() == n_sf);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068             <span class="comment">// Zero before summation</span>
<a name="l00069"></a>00069             nodal_soln[n] = 0;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071             <span class="comment">// u_i = Sum (alpha_i phi_i)</span>
<a name="l00072"></a>00072             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00073"></a>00073               nodal_soln[n] += elem_soln[i]*FE&lt;Dim,T&gt;::shape(elem,
<a name="l00074"></a>00074                                                              order,
<a name="l00075"></a>00075                                                              i,
<a name="l00076"></a>00076                                                              mapped_point);         
<a name="l00077"></a>00077           }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079         <span class="keywordflow">return</span>;
<a name="l00080"></a>00080       }
<a name="l00081"></a>00081       
<a name="l00082"></a>00082     <span class="keywordflow">default</span>:
<a name="l00083"></a>00083       {
<a name="l00084"></a>00084         libmesh_error();
<a name="l00085"></a>00085       }
<a name="l00086"></a>00086     }
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00092"></a>00092 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a401b5a255c73cd4fd202aadee954ba37">FE&lt;Dim,T&gt;::n_dofs</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o)
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094   <span class="keywordflow">switch</span> (o)
<a name="l00095"></a>00095     {
<a name="l00096"></a>00096       <span class="comment">// Piecewise cubic shape functions with linear flux edges</span>
<a name="l00097"></a>00097     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00098"></a>00098       {
<a name="l00099"></a>00099         <span class="keywordflow">switch</span> (t)
<a name="l00100"></a>00100           {
<a name="l00101"></a>00101           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00102"></a>00102             <span class="keywordflow">return</span> 9;
<a name="l00103"></a>00103             
<a name="l00104"></a>00104           <span class="keywordflow">default</span>:
<a name="l00105"></a>00105             {
<a name="l00106"></a>00106 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00108"></a>00108                             &lt;&lt; <span class="stringliteral">&quot; for &quot;</span> &lt;&lt; o &lt;&lt; <span class="stringliteral">&quot;th order approximation!&quot;</span> 
<a name="l00109"></a>00109                             &lt;&lt; std::endl;
<a name="l00110"></a>00110 <span class="preprocessor">#endif</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00112"></a>00112             }
<a name="l00113"></a>00113           }
<a name="l00114"></a>00114       }
<a name="l00115"></a>00115       <span class="comment">// Piecewise cubic Clough-Tocher element</span>
<a name="l00116"></a>00116     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00117"></a>00117       {
<a name="l00118"></a>00118         <span class="keywordflow">switch</span> (t)
<a name="l00119"></a>00119           {
<a name="l00120"></a>00120           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00121"></a>00121             <span class="keywordflow">return</span> 12;
<a name="l00122"></a>00122             
<a name="l00123"></a>00123           <span class="keywordflow">default</span>:
<a name="l00124"></a>00124             {
<a name="l00125"></a>00125 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00127"></a>00127                             &lt;&lt; <span class="stringliteral">&quot; for &quot;</span> &lt;&lt; o &lt;&lt; <span class="stringliteral">&quot;th order approximation!&quot;</span> 
<a name="l00128"></a>00128                             &lt;&lt; std::endl;
<a name="l00129"></a>00129 <span class="preprocessor">#endif</span>
<a name="l00130"></a>00130 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00131"></a>00131             }
<a name="l00132"></a>00132           }
<a name="l00133"></a>00133       }
<a name="l00134"></a>00134       
<a name="l00135"></a>00135     <span class="keywordflow">default</span>:
<a name="l00136"></a>00136       {
<a name="l00137"></a>00137         libmesh_error();
<a name="l00138"></a>00138       }
<a name="l00139"></a>00139     }
<a name="l00140"></a>00140   
<a name="l00141"></a>00141   libmesh_error();  
<a name="l00142"></a>00142   <span class="keywordflow">return</span> 0;
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00148"></a>00148 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a00239d73fd53a032ab838a5d0a7dc7ce">FE&lt;Dim,T&gt;::n_dofs_at_node</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00149"></a>00149                                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00150"></a>00150                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00151"></a>00151 {
<a name="l00152"></a>00152   <span class="keywordflow">switch</span> (o)
<a name="l00153"></a>00153     {
<a name="l00154"></a>00154       <span class="comment">// Piecewise cubic shape functions with linear flux edges</span>
<a name="l00155"></a>00155     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00156"></a>00156       {
<a name="l00157"></a>00157         <span class="keywordflow">switch</span> (t)
<a name="l00158"></a>00158           {
<a name="l00159"></a>00159             <span class="comment">// The 2D Clough-Tocher defined on a 6-noded triangle</span>
<a name="l00160"></a>00160           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00161"></a>00161             {
<a name="l00162"></a>00162               <span class="keywordflow">switch</span> (n)
<a name="l00163"></a>00163                 {
<a name="l00164"></a>00164                 <span class="keywordflow">case</span> 0:
<a name="l00165"></a>00165                 <span class="keywordflow">case</span> 1:
<a name="l00166"></a>00166                 <span class="keywordflow">case</span> 2:
<a name="l00167"></a>00167                   <span class="keywordflow">return</span> 3;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169                 <span class="keywordflow">case</span> 3:
<a name="l00170"></a>00170                 <span class="keywordflow">case</span> 4:
<a name="l00171"></a>00171                 <span class="keywordflow">case</span> 5:
<a name="l00172"></a>00172                   <span class="keywordflow">return</span> 0;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174                 <span class="keywordflow">default</span>:
<a name="l00175"></a>00175                   libmesh_error();
<a name="l00176"></a>00176                 }
<a name="l00177"></a>00177             }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179           <span class="keywordflow">default</span>:
<a name="l00180"></a>00180             {
<a name="l00181"></a>00181 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00182"></a>00182 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00183"></a>00183                             &lt;&lt; <span class="stringliteral">&quot; for &quot;</span> &lt;&lt; o &lt;&lt; <span class="stringliteral">&quot;th order approximation!&quot;</span> 
<a name="l00184"></a>00184                             &lt;&lt; std::endl;
<a name="l00185"></a>00185 <span class="preprocessor">#endif</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00187"></a>00187             }
<a name="l00188"></a>00188             
<a name="l00189"></a>00189           }
<a name="l00190"></a>00190       }
<a name="l00191"></a>00191       <span class="comment">// The third-order hierarchic shape functions</span>
<a name="l00192"></a>00192     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00193"></a>00193       {
<a name="l00194"></a>00194         <span class="keywordflow">switch</span> (t)
<a name="l00195"></a>00195           {
<a name="l00196"></a>00196             <span class="comment">// The 2D Clough-Tocher defined on a 6-noded triangle</span>
<a name="l00197"></a>00197           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00198"></a>00198             {
<a name="l00199"></a>00199               <span class="keywordflow">switch</span> (n)
<a name="l00200"></a>00200                 {
<a name="l00201"></a>00201                 <span class="keywordflow">case</span> 0:
<a name="l00202"></a>00202                 <span class="keywordflow">case</span> 1:
<a name="l00203"></a>00203                 <span class="keywordflow">case</span> 2:
<a name="l00204"></a>00204                   <span class="keywordflow">return</span> 3;
<a name="l00205"></a>00205 
<a name="l00206"></a>00206                 <span class="keywordflow">case</span> 3:
<a name="l00207"></a>00207                 <span class="keywordflow">case</span> 4:
<a name="l00208"></a>00208                 <span class="keywordflow">case</span> 5:
<a name="l00209"></a>00209                   <span class="keywordflow">return</span> 1;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211                 <span class="keywordflow">default</span>:
<a name="l00212"></a>00212                   libmesh_error();
<a name="l00213"></a>00213                 }
<a name="l00214"></a>00214             }
<a name="l00215"></a>00215 
<a name="l00216"></a>00216           <span class="keywordflow">default</span>:
<a name="l00217"></a>00217             {
<a name="l00218"></a>00218 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00220"></a>00220                             &lt;&lt; <span class="stringliteral">&quot; for &quot;</span> &lt;&lt; o &lt;&lt; <span class="stringliteral">&quot;th order approximation!&quot;</span> 
<a name="l00221"></a>00221                             &lt;&lt; std::endl;
<a name="l00222"></a>00222 <span class="preprocessor">#endif</span>
<a name="l00223"></a>00223 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00224"></a>00224             }
<a name="l00225"></a>00225             
<a name="l00226"></a>00226           }
<a name="l00227"></a>00227       }
<a name="l00228"></a>00228     <span class="keywordflow">default</span>:
<a name="l00229"></a>00229       {
<a name="l00230"></a>00230         libmesh_error();
<a name="l00231"></a>00231       }
<a name="l00232"></a>00232     }
<a name="l00233"></a>00233   
<a name="l00234"></a>00234   libmesh_error();
<a name="l00235"></a>00235   
<a name="l00236"></a>00236   <span class="keywordflow">return</span> 0;
<a name="l00237"></a>00237 }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00242"></a>00242 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a6790b3764960ddd6e6faaa40bb0b4a65">FE&lt;Dim,T&gt;::n_dofs_per_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00243"></a>00243                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o)
<a name="l00244"></a>00244 {
<a name="l00245"></a>00245   <span class="keywordflow">switch</span> (o)
<a name="l00246"></a>00246     {
<a name="l00247"></a>00247       <span class="comment">// Piecewise cubic shape functions with linear flux edges</span>
<a name="l00248"></a>00248     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00249"></a>00249       <span class="comment">// The third-order Clough-Tocher shape functions</span>
<a name="l00250"></a>00250     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00251"></a>00251       {
<a name="l00252"></a>00252         <span class="keywordflow">switch</span> (t)
<a name="l00253"></a>00253           {
<a name="l00254"></a>00254             <span class="comment">// The 2D hierarchic defined on a 6-noded triangle</span>
<a name="l00255"></a>00255           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00256"></a>00256             <span class="keywordflow">return</span> 0;
<a name="l00257"></a>00257 
<a name="l00258"></a>00258           <span class="keywordflow">default</span>:
<a name="l00259"></a>00259             {
<a name="l00260"></a>00260 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00261"></a>00261 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00262"></a>00262                             &lt;&lt; <span class="stringliteral">&quot; for &quot;</span> &lt;&lt; o &lt;&lt; <span class="stringliteral">&quot;th order approximation!&quot;</span> 
<a name="l00263"></a>00263                             &lt;&lt; std::endl;
<a name="l00264"></a>00264 <span class="preprocessor">#endif</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00266"></a>00266             }
<a name="l00267"></a>00267             
<a name="l00268"></a>00268           }
<a name="l00269"></a>00269       }
<a name="l00270"></a>00270       <span class="comment">// Otherwise no DOFS per element</span>
<a name="l00271"></a>00271     <span class="keywordflow">default</span>:
<a name="l00272"></a>00272       libmesh_error();      
<a name="l00273"></a>00273       <span class="keywordflow">return</span> 0;
<a name="l00274"></a>00274     }
<a name="l00275"></a>00275 }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00280"></a>00280 <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classlibMesh_1_1FE.php#a26671578bbeec8d12a76e6d3de92c422">FE&lt;Dim,T&gt;::get_continuity</a>()<span class="keyword"> const</span>
<a name="l00281"></a>00281 <span class="keyword"></span>{
<a name="l00282"></a>00282   <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>;
<a name="l00283"></a>00283 }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00288"></a>00288 <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FE.php#a6e3c6ecf80a5f9a057cd98710650b379">FE&lt;Dim,T&gt;::is_hierarchic</a>()<span class="keyword"> const</span>
<a name="l00289"></a>00289 <span class="keyword"></span>{
<a name="l00290"></a>00290   <span class="keywordflow">return</span> <span class="keyword">false</span>;  <span class="comment">// FIXME - this will be changed</span>
<a name="l00291"></a>00291 }
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00296"></a>00296 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00297"></a><a class="code" href="classlibMesh_1_1FE.php#a7ecb48abba2b40eef1c7c2d8d998cdf8">00297</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a7ecb48abba2b40eef1c7c2d8d998cdf8">FE&lt;Dim,T&gt;::compute_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00298"></a>00298                                      <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00299"></a>00299                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00300"></a>00300                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00301"></a>00301 {
<a name="l00302"></a>00302   compute_proj_constraints(constraints, dof_map, variable_number, elem);
<a name="l00303"></a>00303 }
<a name="l00304"></a>00304 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00305"></a>00305 <span class="preprocessor"></span>
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00309"></a>00309 <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FE.php#ae8089f56b5648f5657b5d85cd630b622">FE&lt;Dim,T&gt;::shapes_need_reinit</a>()<span class="keyword"> const</span>
<a name="l00310"></a>00310 <span class="keyword"></span>{
<a name="l00311"></a>00311   <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00312"></a>00312 }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00316"></a>00316 <span class="comment">// Explicit instantiation of member functions</span>
<a name="l00317"></a>00317 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(0,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>);
<a name="l00318"></a>00318 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>);
<a name="l00319"></a>00319 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>);
<a name="l00320"></a>00320 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00323"></a>00323 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a7ecb48abba2b40eef1c7c2d8d998cdf8">FE&lt;2,CLOUGH&gt;::compute_constraints</a>(DofConstraints&amp;, DofMap&amp;,
<a name="l00324"></a>00324                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00325"></a>00325                                                 <span class="keyword">const</span> Elem*);
<a name="l00326"></a>00326 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a7ecb48abba2b40eef1c7c2d8d998cdf8">FE&lt;3,CLOUGH&gt;::compute_constraints</a>(DofConstraints&amp;, DofMap&amp;,
<a name="l00327"></a>00327                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00328"></a>00328                                                 <span class="keyword">const</span> Elem*);
<a name="l00329"></a>00329 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00330"></a>00330 <span class="preprocessor"></span>
<a name="l00331"></a>00331 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
