<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_clough_shape_1D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__clough__shape__1D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_clough_shape_1D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ inlcludes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Anonymous namespace for persistant variables.</span>
<a name="l00029"></a>00029 <span class="comment">// This allows us to cache the global-to-local mapping transformation</span>
<a name="l00030"></a>00030 <span class="comment">// This should also screw up multithreading royally</span>
<a name="l00031"></a>00031 <span class="keyword">namespace</span>
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033   <span class="keyword">using namespace </span>libMesh;
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_elem_id = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00036"></a>00036   <span class="comment">// Coefficient naming: d(1)d(2n) is the coefficient of the</span>
<a name="l00037"></a>00037   <span class="comment">// global shape function corresponding to value 1 in terms of the</span>
<a name="l00038"></a>00038   <span class="comment">// local shape function corresponding to normal derivative 2</span>
<a name="l00039"></a>00039   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d1xd1x, d2xd2x;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape_second_deriv(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00042"></a>00042                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> deriv_type,
<a name="l00043"></a>00043                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00044"></a>00044 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape_deriv(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00045"></a>00045                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> deriv_type,
<a name="l00046"></a>00046                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00047"></a>00047 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00048"></a>00048                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="comment">// Compute the static coefficients for an element</span>
<a name="l00052"></a>00052 <span class="keywordtype">void</span> clough_compute_coefs(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   <span class="comment">// Using static globals for old_elem_id, etc. will fail</span>
<a name="l00055"></a>00055   <span class="comment">// horribly with more than one thread.</span>
<a name="l00056"></a>00056   libmesh_assert(<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() == 1);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// Coefficients are cached from old elements</span>
<a name="l00059"></a>00059   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == old_elem_id)
<a name="l00060"></a>00060     <span class="keywordflow">return</span>;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   old_elem_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> mapping_order        (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>());
<a name="l00065"></a>00065   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> mapping_elem_type (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00066"></a>00066   <span class="keyword">const</span> <span class="keywordtype">int</span> n_mapping_shape_functions =
<a name="l00067"></a>00067     <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;1,LAGRANGE&gt;::n_shape_functions</a>(mapping_elem_type,
<a name="l00068"></a>00068                                       mapping_order);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// Degrees of freedom are at vertices and edge midpoints</span>
<a name="l00071"></a>00071   std::vector&lt;Point&gt; dofpt;
<a name="l00072"></a>00072   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(0));
<a name="l00073"></a>00073   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(1));
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="comment">// Mapping functions - first derivatives at each dofpt</span>
<a name="l00076"></a>00076   std::vector&lt;Real&gt; dxdxi(2);
<a name="l00077"></a>00077   std::vector&lt;Real&gt; dxidx(2);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> p = 0; p != 2; ++p)
<a name="l00080"></a>00080     {
<a name="l00081"></a>00081       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i != n_mapping_shape_functions; ++i)
<a name="l00082"></a>00082         {
<a name="l00083"></a>00083           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ddxi = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,LAGRANGE&gt;::shape_deriv</a> 
<a name="l00084"></a>00084             (mapping_elem_type, mapping_order, i, 0, dofpt[p]);
<a name="l00085"></a>00085           dxdxi[p] += dofpt[p](0) * ddxi;
<a name="l00086"></a>00086         }
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// Calculate derivative scaling factors</span>
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   d1xd1x = dxdxi[0];
<a name="l00092"></a>00092   d2xd2x = dxdxi[1];
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="comment">// Return shape function second derivatives on the unit interval</span>
<a name="l00097"></a>00097 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape_second_deriv(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00098"></a>00098                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> deriv_type,
<a name="l00099"></a>00099                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0);
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="keywordflow">switch</span> (deriv_type)
<a name="l00104"></a>00104   {
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">// second derivative in xi-xi direction</span>
<a name="l00107"></a>00107   <span class="keywordflow">case</span> 0:
<a name="l00108"></a>00108   <span class="keywordflow">switch</span> (basis_num)
<a name="l00109"></a>00109     {
<a name="l00110"></a>00110       <span class="keywordflow">case</span> 0:
<a name="l00111"></a>00111         <span class="keywordflow">return</span> -6 + 12*xi;
<a name="l00112"></a>00112       <span class="keywordflow">case</span> 1:
<a name="l00113"></a>00113         <span class="keywordflow">return</span> 6 - 12*xi;
<a name="l00114"></a>00114       <span class="keywordflow">case</span> 2:
<a name="l00115"></a>00115         <span class="keywordflow">return</span> -4 + 6*xi;
<a name="l00116"></a>00116       <span class="keywordflow">case</span> 3:
<a name="l00117"></a>00117         <span class="keywordflow">return</span> -2 + 6*xi;
<a name="l00118"></a>00118     }
<a name="l00119"></a>00119   }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   libmesh_error();
<a name="l00122"></a>00122   <span class="keywordflow">return</span> 0.;
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape_deriv(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00128"></a>00128                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> deriv_type,
<a name="l00129"></a>00129                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="keywordflow">switch</span> (deriv_type)
<a name="l00134"></a>00134   {
<a name="l00135"></a>00135   <span class="keywordflow">case</span> 0:
<a name="l00136"></a>00136   <span class="keywordflow">switch</span> (basis_num)
<a name="l00137"></a>00137     {
<a name="l00138"></a>00138       <span class="keywordflow">case</span> 0:
<a name="l00139"></a>00139         <span class="keywordflow">return</span> -6*xi + 6*xi*xi;
<a name="l00140"></a>00140       <span class="keywordflow">case</span> 1:
<a name="l00141"></a>00141         <span class="keywordflow">return</span> 6*xi - 6*xi*xi;
<a name="l00142"></a>00142       <span class="keywordflow">case</span> 2:
<a name="l00143"></a>00143         <span class="keywordflow">return</span> 1 - 4*xi + 3*xi*xi;
<a name="l00144"></a>00144       <span class="keywordflow">case</span> 3:
<a name="l00145"></a>00145         <span class="keywordflow">return</span> -2*xi + 3*xi*xi;
<a name="l00146"></a>00146     }
<a name="l00147"></a>00147   }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   libmesh_error();
<a name="l00150"></a>00150   <span class="keywordflow">return</span> 0.;
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> clough_raw_shape(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basis_num,
<a name="l00154"></a>00154                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00155"></a>00155 {
<a name="l00156"></a>00156   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   <span class="keywordflow">switch</span> (basis_num)
<a name="l00159"></a>00159     {
<a name="l00160"></a>00160       <span class="keywordflow">case</span> 0:
<a name="l00161"></a>00161         <span class="keywordflow">return</span> 1 - 3*xi*xi + 2*xi*xi*xi;
<a name="l00162"></a>00162       <span class="keywordflow">case</span> 1:
<a name="l00163"></a>00163         <span class="keywordflow">return</span> 3*xi*xi - 2*xi*xi*xi;
<a name="l00164"></a>00164       <span class="keywordflow">case</span> 2:
<a name="l00165"></a>00165         <span class="keywordflow">return</span> xi - 2*xi*xi + xi*xi*xi;
<a name="l00166"></a>00166       <span class="keywordflow">case</span> 3:
<a name="l00167"></a>00167         <span class="keywordflow">return</span> -xi*xi + xi*xi*xi;
<a name="l00168"></a>00168     }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   libmesh_error();
<a name="l00171"></a>00171   <span class="keywordflow">return</span> 0.;
<a name="l00172"></a>00172 }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   
<a name="l00175"></a>00175 } <span class="comment">// end anonymous namespace</span>
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="keyword">namespace </span>libMesh
<a name="l00179"></a>00179 {
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="keyword">template</span> &lt;&gt;
<a name="l00183"></a><a class="code" href="classlibMesh_1_1FE.php#a05bfc2c54bb7f5c9a730dae41712a942">00183</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,CLOUGH&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00184"></a>00184                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00185"></a>00185                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00186"></a>00186                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Clough-Tocher elements require the real element\n&quot;</span>
<a name="l00189"></a>00189                 &lt;&lt; <span class="stringliteral">&quot;to construct gradient-based degrees of freedom.&quot;</span>
<a name="l00190"></a>00190                 &lt;&lt; std::endl;
<a name="l00191"></a>00191   
<a name="l00192"></a>00192   libmesh_error();
<a name="l00193"></a>00193   <span class="keywordflow">return</span> 0.;
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="keyword">template</span> &lt;&gt;
<a name="l00199"></a><a class="code" href="classlibMesh_1_1FE.php#a72783b7be946e7075fae8ef8b8ede5b2">00199</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,CLOUGH&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00200"></a>00200                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00201"></a>00201                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00202"></a>00202                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00203"></a>00203 {
<a name="l00204"></a>00204   libmesh_assert (elem != NULL);
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   clough_compute_coefs(elem);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00211"></a>00211   
<a name="l00212"></a>00212   <span class="keywordflow">switch</span> (totalorder)
<a name="l00213"></a>00213     {      
<a name="l00214"></a>00214       <span class="comment">// 3rd-order C1 cubic element</span>
<a name="l00215"></a>00215     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00216"></a>00216       {
<a name="l00217"></a>00217         <span class="keywordflow">switch</span> (type)
<a name="l00218"></a>00218           {
<a name="l00219"></a>00219             <span class="comment">// C1 functions on the C1 cubic edge</span>
<a name="l00220"></a>00220           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00221"></a>00221           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00222"></a>00222             {
<a name="l00223"></a>00223               libmesh_assert (i&lt;4);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225               <span class="keywordflow">switch</span> (i)
<a name="l00226"></a>00226                 {
<a name="l00227"></a>00227                 <span class="keywordflow">case</span> 0:
<a name="l00228"></a>00228                   <span class="keywordflow">return</span> clough_raw_shape(0, p);
<a name="l00229"></a>00229                 <span class="keywordflow">case</span> 1:
<a name="l00230"></a>00230                   <span class="keywordflow">return</span> clough_raw_shape(1, p);
<a name="l00231"></a>00231                 <span class="keywordflow">case</span> 2:
<a name="l00232"></a>00232                   <span class="keywordflow">return</span> d1xd1x * clough_raw_shape(2, p);
<a name="l00233"></a>00233                 <span class="keywordflow">case</span> 3:
<a name="l00234"></a>00234                   <span class="keywordflow">return</span> d2xd2x * clough_raw_shape(3, p);
<a name="l00235"></a>00235                 <span class="keywordflow">default</span>:
<a name="l00236"></a>00236                   libmesh_error();
<a name="l00237"></a>00237                 }
<a name="l00238"></a>00238             }
<a name="l00239"></a>00239           <span class="keywordflow">default</span>:
<a name="l00240"></a>00240             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l00241"></a>00241             libmesh_error();
<a name="l00242"></a>00242           }
<a name="l00243"></a>00243       }
<a name="l00244"></a>00244       <span class="comment">// by default throw an error</span>
<a name="l00245"></a>00245     <span class="keywordflow">default</span>:
<a name="l00246"></a>00246       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported polynomial order!&quot;</span> &lt;&lt; std::endl;
<a name="l00247"></a>00247       libmesh_error();
<a name="l00248"></a>00248     }
<a name="l00249"></a>00249   
<a name="l00250"></a>00250   libmesh_error();
<a name="l00251"></a>00251   <span class="keywordflow">return</span> 0.;
<a name="l00252"></a>00252 }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 <span class="keyword">template</span> &lt;&gt;
<a name="l00257"></a><a class="code" href="classlibMesh_1_1FE.php#ae869399e9d23c50b205fa5fe2cbd0024">00257</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,CLOUGH&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00258"></a>00258                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,                     
<a name="l00259"></a>00259                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00260"></a>00260                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00261"></a>00261                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00262"></a>00262 {
<a name="l00263"></a>00263   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Clough-Tocher elements require the real element\n&quot;</span>
<a name="l00264"></a>00264                 &lt;&lt; <span class="stringliteral">&quot;to construct gradient-based degrees of freedom.&quot;</span>
<a name="l00265"></a>00265                 &lt;&lt; std::endl;
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   libmesh_error();
<a name="l00268"></a>00268   <span class="keywordflow">return</span> 0.;
<a name="l00269"></a>00269 }
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 <span class="keyword">template</span> &lt;&gt;
<a name="l00274"></a><a class="code" href="classlibMesh_1_1FE.php#a9ca606fdbf868f31a6e175ba080f2ce7">00274</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,CLOUGH&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00275"></a>00275                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00276"></a>00276                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00277"></a>00277                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00278"></a>00278                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00279"></a>00279 {
<a name="l00280"></a>00280   libmesh_assert (elem != NULL);
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   clough_compute_coefs(elem);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00287"></a>00287   
<a name="l00288"></a>00288   <span class="keywordflow">switch</span> (totalorder)
<a name="l00289"></a>00289     {      
<a name="l00290"></a>00290       <span class="comment">// 3rd-order C1 cubic element</span>
<a name="l00291"></a>00291     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00292"></a>00292       {
<a name="l00293"></a>00293         <span class="keywordflow">switch</span> (type)
<a name="l00294"></a>00294           {
<a name="l00295"></a>00295             <span class="comment">// C1 functions on the C1 cubic edge</span>
<a name="l00296"></a>00296           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00297"></a>00297           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00298"></a>00298             {
<a name="l00299"></a>00299               <span class="keywordflow">switch</span> (i)
<a name="l00300"></a>00300                 {
<a name="l00301"></a>00301                 <span class="keywordflow">case</span> 0:
<a name="l00302"></a>00302                   <span class="keywordflow">return</span> clough_raw_shape_deriv(0, j, p);
<a name="l00303"></a>00303                 <span class="keywordflow">case</span> 1:
<a name="l00304"></a>00304                   <span class="keywordflow">return</span> clough_raw_shape_deriv(1, j, p);
<a name="l00305"></a>00305                 <span class="keywordflow">case</span> 2:
<a name="l00306"></a>00306                   <span class="keywordflow">return</span> d1xd1x * clough_raw_shape_deriv(2, j, p);
<a name="l00307"></a>00307                 <span class="keywordflow">case</span> 3:
<a name="l00308"></a>00308                   <span class="keywordflow">return</span> d2xd2x * clough_raw_shape_deriv(3, j, p);
<a name="l00309"></a>00309                 <span class="keywordflow">default</span>:
<a name="l00310"></a>00310                   libmesh_error();
<a name="l00311"></a>00311                 }
<a name="l00312"></a>00312             }
<a name="l00313"></a>00313           <span class="keywordflow">default</span>:
<a name="l00314"></a>00314             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l00315"></a>00315             libmesh_error();
<a name="l00316"></a>00316           }
<a name="l00317"></a>00317       }
<a name="l00318"></a>00318       <span class="comment">// by default throw an error</span>
<a name="l00319"></a>00319     <span class="keywordflow">default</span>:
<a name="l00320"></a>00320       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported polynomial order!&quot;</span> &lt;&lt; std::endl;
<a name="l00321"></a>00321       libmesh_error();
<a name="l00322"></a>00322     }
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   libmesh_error();
<a name="l00325"></a>00325   <span class="keywordflow">return</span> 0.;
<a name="l00326"></a>00326 }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 <span class="keyword">template</span> &lt;&gt;
<a name="l00331"></a><a class="code" href="classlibMesh_1_1FE.php#adc7982474f7b0f6829bec5bd4c771a07">00331</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;1,CLOUGH&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00332"></a>00332                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00333"></a>00333                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00334"></a>00334                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00335"></a>00335                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00336"></a>00336 {
<a name="l00337"></a>00337   libmesh_assert (elem != NULL);
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   clough_compute_coefs(elem);
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00342"></a>00342 
<a name="l00343"></a>00343   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00344"></a>00344   
<a name="l00345"></a>00345   <span class="keywordflow">switch</span> (totalorder)
<a name="l00346"></a>00346     {      
<a name="l00347"></a>00347       <span class="comment">// 3rd-order C1 cubic element</span>
<a name="l00348"></a>00348     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00349"></a>00349       {
<a name="l00350"></a>00350         <span class="keywordflow">switch</span> (type)
<a name="l00351"></a>00351           {
<a name="l00352"></a>00352             <span class="comment">// C1 functions on the C1 cubic edge</span>
<a name="l00353"></a>00353           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00354"></a>00354           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00355"></a>00355             {
<a name="l00356"></a>00356               <span class="keywordflow">switch</span> (i)
<a name="l00357"></a>00357                 {
<a name="l00358"></a>00358                 <span class="keywordflow">case</span> 0:
<a name="l00359"></a>00359                   <span class="keywordflow">return</span> clough_raw_shape_second_deriv(0, j, p);
<a name="l00360"></a>00360                 <span class="keywordflow">case</span> 1:
<a name="l00361"></a>00361                   <span class="keywordflow">return</span> clough_raw_shape_second_deriv(1, j, p);
<a name="l00362"></a>00362                 <span class="keywordflow">case</span> 2:
<a name="l00363"></a>00363                   <span class="keywordflow">return</span> d1xd1x * clough_raw_shape_second_deriv(2, j, p);
<a name="l00364"></a>00364                 <span class="keywordflow">case</span> 3:
<a name="l00365"></a>00365                   <span class="keywordflow">return</span> d2xd2x * clough_raw_shape_second_deriv(3, j, p);
<a name="l00366"></a>00366                 <span class="keywordflow">default</span>:
<a name="l00367"></a>00367                   libmesh_error();
<a name="l00368"></a>00368                 }
<a name="l00369"></a>00369             }
<a name="l00370"></a>00370           <span class="keywordflow">default</span>:
<a name="l00371"></a>00371             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l00372"></a>00372             libmesh_error();
<a name="l00373"></a>00373           }
<a name="l00374"></a>00374       }
<a name="l00375"></a>00375       <span class="comment">// by default throw an error</span>
<a name="l00376"></a>00376     <span class="keywordflow">default</span>:
<a name="l00377"></a>00377       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported polynomial order!&quot;</span> &lt;&lt; std::endl;
<a name="l00378"></a>00378       libmesh_error();
<a name="l00379"></a>00379     }
<a name="l00380"></a>00380   
<a name="l00381"></a>00381   libmesh_error();
<a name="l00382"></a>00382   <span class="keywordflow">return</span> 0.;
<a name="l00383"></a>00383 }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
