<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_compute_data.C</div>  </div>
</div>
<div class="contents">
<a href="fe__compute__data_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_compute_data.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="fe__compute__data_8h.php">fe_compute_data.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="keyword">namespace </span>libMesh
<a name="l00024"></a>00024 {
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a><a class="code" href="classlibMesh_1_1FEComputeData.php#ab22eac574d179abf36017c8b2237c917">00028</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEComputeData.php#ab22eac574d179abf36017c8b2237c917">FEComputeData::clear</a> () 
<a name="l00029"></a>00029 { 
<a name="l00030"></a>00030   this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>.clear();
<a name="l00031"></a>00031 <span class="preprocessor">#if defined(LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; !defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#ad1bbba20949444c9a995733d2f599770">phase</a> = 0.;
<a name="l00033"></a>00033   this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#ad9aef672ac8a346ce0d1c8ec0873ae0b">speed</a> = 0.;
<a name="l00034"></a>00034 <span class="preprocessor">#endif</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00036"></a>00036 <span class="preprocessor">#if defined (LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#ad9aef672ac8a346ce0d1c8ec0873ae0b">speed</a> = 0.;
<a name="l00038"></a>00038   this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#a7311109aecee478a1ce9e4dd62b975db">frequency</a> = 0.;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#endif</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>}
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classlibMesh_1_1FEComputeData.php#acd3497f2d3a00fd1ac670f0faaba9f2e">00045</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEComputeData.php#acd3497f2d3a00fd1ac670f0faaba9f2e">FEComputeData::init</a> () 
<a name="l00046"></a>00046 { 
<a name="l00047"></a>00047   <span class="keywordflow">if</span> (!(this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>.empty()))
<a name="l00048"></a>00048     std::fill (this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>.begin(),   this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>.end(),   0.);
<a name="l00049"></a>00049   
<a name="l00050"></a>00050 <span class="preprocessor">#if defined(LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; !defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#ad1bbba20949444c9a995733d2f599770">phase</a> = 0.;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEComputeData.php#a0e4f158b965e866d8162f300bfc29af7">equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;speed&quot;</span>))
<a name="l00054"></a>00054     this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#ad9aef672ac8a346ce0d1c8ec0873ae0b">speed</a> = this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#a0e4f158b965e866d8162f300bfc29af7">equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;speed&quot;</span>);
<a name="l00055"></a>00055 <span class="preprocessor">#endif</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>
<a name="l00057"></a>00057 <span class="preprocessor">#if defined (LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEComputeData.php#a0e4f158b965e866d8162f300bfc29af7">equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;speed&quot;</span>))
<a name="l00059"></a>00059     this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#ad9aef672ac8a346ce0d1c8ec0873ae0b">speed</a> = this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#a0e4f158b965e866d8162f300bfc29af7">equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;speed&quot;</span>);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEComputeData.php#a0e4f158b965e866d8162f300bfc29af7">equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;current frequency&quot;</span>))  
<a name="l00062"></a>00062     this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#a7311109aecee478a1ce9e4dd62b975db">frequency</a> = this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#a0e4f158b965e866d8162f300bfc29af7">equation_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;current frequency&quot;</span>);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="preprocessor">#endif</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>}
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
