<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fbfd1e4ea7786050feab5206011c3dac.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_compute_data.h</div>  </div>
</div>
<div class="contents">
<a href="fe__compute__data_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_compute_data.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __fe_compute_data_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __fe_compute_data_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>EquationSystems;
<a name="l00036"></a>00036 <span class="keyword">class </span>Point;
<a name="l00037"></a>00037 
<a name="l00049"></a><a class="code" href="classlibMesh_1_1FEComputeData.php">00049</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">//------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// Conventional FEComputeData</span>
<a name="l00060"></a><a class="code" href="classlibMesh_1_1FEComputeData.php#a6fe86be2b5be76eb8cf0c3829fcba197">00060</a> <span class="comment"></span>  <a class="code" href="classlibMesh_1_1FEComputeData.php#a6fe86be2b5be76eb8cf0c3829fcba197">FEComputeData</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00061"></a>00061                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; pin) :
<a name="l00062"></a>00062     <a class="code" href="classlibMesh_1_1FEComputeData.php#a0e4f158b965e866d8162f300bfc29af7">equation_systems</a>(es),
<a name="l00063"></a>00063     <a class="code" href="classlibMesh_1_1FEComputeData.php#a23e7e761ccb626914ba41de94cfa9465">p</a>(pin)
<a name="l00064"></a>00064   { 
<a name="l00065"></a>00065     this-&gt;<a class="code" href="classlibMesh_1_1FEComputeData.php#ab22eac574d179abf36017c8b2237c917">clear</a>(); 
<a name="l00066"></a>00066   }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">//----------------------------------------------------</span>
<a name="l00070"></a>00070   <span class="comment">// Input data</span>
<a name="l00075"></a><a class="code" href="classlibMesh_1_1FEComputeData.php#a0e4f158b965e866d8162f300bfc29af7">00075</a> <span class="comment"></span>  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; <a class="code" href="classlibMesh_1_1FEComputeData.php#a0e4f158b965e866d8162f300bfc29af7">equation_systems</a>;
<a name="l00079"></a><a class="code" href="classlibMesh_1_1FEComputeData.php#a23e7e761ccb626914ba41de94cfa9465">00079</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1FEComputeData.php#a23e7e761ccb626914ba41de94cfa9465">p</a>;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">//----------------------------------------------------</span>
<a name="l00084"></a>00084   <span class="comment">// Output data</span>
<a name="l00088"></a><a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">00088</a> <span class="comment"></span>  std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="preprocessor">#if defined(LIBMESH_ENABLE_INFINITE_ELEMENTS) &amp;&amp; !defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>
<a name="l00095"></a><a class="code" href="classlibMesh_1_1FEComputeData.php#ad1bbba20949444c9a995733d2f599770">00095</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEComputeData.php#ad1bbba20949444c9a995733d2f599770">phase</a>;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 <span class="preprocessor">#endif</span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>
<a name="l00099"></a>00099 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>
<a name="l00103"></a><a class="code" href="classlibMesh_1_1FEComputeData.php#ad9aef672ac8a346ce0d1c8ec0873ae0b">00103</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEComputeData.php#ad9aef672ac8a346ce0d1c8ec0873ae0b">speed</a>;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#endif</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>
<a name="l00107"></a>00107 <span class="preprocessor">#if defined LIBMESH_ENABLE_INFINITE_ELEMENTS &amp;&amp; defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
<a name="l00112"></a><a class="code" href="classlibMesh_1_1FEComputeData.php#a7311109aecee478a1ce9e4dd62b975db">00112</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEComputeData.php#a7311109aecee478a1ce9e4dd62b975db">frequency</a>;
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 <span class="preprocessor">#endif</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span>
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEComputeData.php#ab22eac574d179abf36017c8b2237c917">clear</a> () ;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00126"></a>00126   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEComputeData.php#acd3497f2d3a00fd1ac670f0faaba9f2e">init</a> () ;
<a name="l00127"></a>00127 };
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 } <span class="comment">// namespace libMesh</span>
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="preprocessor">#endif // #ifndef __fe_compute_data_h__</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
