<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_hermite_shape_3D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__hermite__shape__3D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_hermite_shape_3D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ inlcludes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="number__lookups_8h.php">number_lookups.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Anonymous namespace for persistant variables.</span>
<a name="l00030"></a>00030 <span class="comment">// This allows us to cache the global-to-local mapping transformation</span>
<a name="l00031"></a>00031 <span class="comment">// This caching is turned off when TBB is enabled...</span>
<a name="l00032"></a>00032 <span class="keyword">namespace</span>
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034   <span class="keyword">using namespace </span>libMesh;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#ifndef LIBMESH_HAVE_TBB_API</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>  <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_elem_id = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00038"></a>00038   <span class="keyword">static</span> std::vector&lt;std::vector&lt;Real&gt; &gt; dxdxi(3, std::vector&lt;Real&gt;(2, 0));
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>  <span class="keyword">static</span> std::vector&lt;Real&gt; dydxi(2), dzdeta(2), dxdzeta(2);
<a name="l00041"></a>00041   <span class="keyword">static</span> std::vector&lt;Real&gt; dzdxi(2), dxdeta(2), dydzeta(2);
<a name="l00042"></a>00042 <span class="preprocessor">#endif</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a>00044 <span class="preprocessor">#endif //LIBMESH_HAVE_TBB_API</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span>
<a name="l00046"></a>00046 <span class="preprocessor">#ifndef LIBMESH_HAVE_TBB_API</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>  <span class="comment">// Compute the static coefficients for an element</span>
<a name="l00048"></a>00048   <span class="keywordtype">void</span> hermite_compute_coefs(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00049"></a>00049   {
<a name="l00050"></a>00050     <span class="comment">// Coefficients are cached from old elements</span>
<a name="l00051"></a>00051     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == old_elem_id)
<a name="l00052"></a>00052       <span class="keywordflow">return</span>;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054     old_elem_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00055"></a>00055 <span class="preprocessor">#else</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>  <span class="keywordtype">void</span> hermite_compute_coefs(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, std::vector&lt;std::vector&lt;Real&gt; &gt; &amp; dxdxi
<a name="l00057"></a>00057 #ifdef DEBUG
<a name="l00058"></a>00058                              ,
<a name="l00059"></a>00059                              std::vector&lt;Real&gt; &amp; dydxi,
<a name="l00060"></a>00060                              std::vector&lt;Real&gt; &amp; dzdeta,
<a name="l00061"></a>00061                              std::vector&lt;Real&gt; &amp; dxdzeta,
<a name="l00062"></a>00062                              std::vector&lt;Real&gt; &amp; dzdxi,
<a name="l00063"></a>00063                              std::vector&lt;Real&gt; &amp; dxdeta,
<a name="l00064"></a>00064                              std::vector&lt;Real&gt; &amp; dydzeta
<a name="l00065"></a>00065 #endif <span class="comment">//DEBUG</span>
<a name="l00066"></a>00066     )
<a name="l00067"></a>00067   {
<a name="l00068"></a>00068 <span class="preprocessor">#endif //LIBMESH_HAVE_TBB_API</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>    
<a name="l00070"></a>00070   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> mapping_order        (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>());
<a name="l00071"></a>00071   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> mapping_elem_type (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00072"></a>00072   <span class="keyword">const</span> <span class="keywordtype">int</span> n_mapping_shape_functions =
<a name="l00073"></a>00073     <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;3,LAGRANGE&gt;::n_shape_functions</a>(mapping_elem_type,
<a name="l00074"></a>00074                                       mapping_order);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   std::vector&lt;Point&gt; dofpt;
<a name="l00077"></a>00077   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(-1,-1,-1));
<a name="l00078"></a>00078   dofpt.push_back(<a class="code" href="classlibMesh_1_1Point.php">Point</a>(1,1,1));
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> p = 0; p != 2; ++p)
<a name="l00081"></a>00081     {
<a name="l00082"></a>00082       dxdxi[0][p] = 0;
<a name="l00083"></a>00083       dxdxi[1][p] = 0;
<a name="l00084"></a>00084       dxdxi[2][p] = 0;
<a name="l00085"></a>00085 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>      dydxi[p] = 0;
<a name="l00087"></a>00087       dzdeta[p] = 0;
<a name="l00088"></a>00088       dxdzeta[p] = 0;
<a name="l00089"></a>00089       dzdxi[p] = 0;
<a name="l00090"></a>00090       dxdeta[p] = 0;
<a name="l00091"></a>00091       dydzeta[p] = 0;
<a name="l00092"></a>00092 <span class="preprocessor">#endif</span>
<a name="l00093"></a>00093 <span class="preprocessor"></span>      <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i = 0; i != n_mapping_shape_functions; ++i)
<a name="l00094"></a>00094         {
<a name="l00095"></a>00095           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ddxi = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;3,LAGRANGE&gt;::shape_deriv</a> 
<a name="l00096"></a>00096             (mapping_elem_type, mapping_order, i, 0, dofpt[p]);
<a name="l00097"></a>00097           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ddeta = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;3,LAGRANGE&gt;::shape_deriv</a> 
<a name="l00098"></a>00098             (mapping_elem_type, mapping_order, i, 1, dofpt[p]);
<a name="l00099"></a>00099           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ddzeta = <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;3,LAGRANGE&gt;::shape_deriv</a> 
<a name="l00100"></a>00100             (mapping_elem_type, mapping_order, i, 2, dofpt[p]);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102           <span class="comment">// dxdeta, dxdzeta, dydxi, dydzeta, dzdxi, dzdeta should all</span>
<a name="l00103"></a>00103           <span class="comment">// be 0!</span>
<a name="l00104"></a>00104           dxdxi[0][p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(0) * ddxi;
<a name="l00105"></a>00105           dxdxi[1][p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(1) * ddeta;
<a name="l00106"></a>00106           dxdxi[2][p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(2) * ddzeta;
<a name="l00107"></a>00107 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>          dydxi[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(1) * ddxi;
<a name="l00109"></a>00109           dzdeta[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(2) * ddeta;
<a name="l00110"></a>00110           dxdzeta[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(0) * ddzeta;
<a name="l00111"></a>00111           dzdxi[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(2) * ddxi;
<a name="l00112"></a>00112           dxdeta[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(0) * ddeta;
<a name="l00113"></a>00113           dydzeta[p] += elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(1) * ddzeta;
<a name="l00114"></a>00114 <span class="preprocessor">#endif</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span>        }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117       <span class="comment">// No singular elements!</span>
<a name="l00118"></a>00118       libmesh_assert(dxdxi[0][p]);
<a name="l00119"></a>00119       libmesh_assert(dxdxi[1][p]);
<a name="l00120"></a>00120       libmesh_assert(dxdxi[2][p]);
<a name="l00121"></a>00121       <span class="comment">// No non-rectilinear or non-axis-aligned elements!</span>
<a name="l00122"></a>00122 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00123"></a>00123 <span class="preprocessor"></span>      libmesh_assert(std::abs(dydxi[p]) &lt; TOLERANCE);
<a name="l00124"></a>00124       libmesh_assert(std::abs(dzdeta[p]) &lt; TOLERANCE);
<a name="l00125"></a>00125       libmesh_assert(std::abs(dxdzeta[p]) &lt; TOLERANCE);
<a name="l00126"></a>00126       libmesh_assert(std::abs(dzdxi[p]) &lt; TOLERANCE);
<a name="l00127"></a>00127       libmesh_assert(std::abs(dxdeta[p]) &lt; TOLERANCE);
<a name="l00128"></a>00128       libmesh_assert(std::abs(dydzeta[p]) &lt; TOLERANCE);
<a name="l00129"></a>00129 <span class="preprocessor">#endif</span>
<a name="l00130"></a>00130 <span class="preprocessor"></span>    }
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> hermite_bases_3D
<a name="l00136"></a>00136  (std::vector&lt;unsigned int&gt; &amp;bases1D,
<a name="l00137"></a>00137   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;dxdxi,
<a name="l00138"></a>00138   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> &amp;o,
<a name="l00139"></a>00139   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00140"></a>00140 {
<a name="l00141"></a>00141   bases1D.clear();
<a name="l00142"></a>00142   bases1D.resize(3,0);
<a name="l00143"></a>00143   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> coef = 1.0;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e = o-2;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="comment">// Nodes</span>
<a name="l00148"></a>00148   <span class="keywordflow">if</span> (i &lt; 64)
<a name="l00149"></a>00149     {
<a name="l00150"></a>00150       <span class="keywordflow">switch</span> (i / 8)
<a name="l00151"></a>00151         {
<a name="l00152"></a>00152         <span class="keywordflow">case</span> 0:
<a name="l00153"></a>00153           <span class="keywordflow">break</span>;
<a name="l00154"></a>00154         <span class="keywordflow">case</span> 1:
<a name="l00155"></a>00155           bases1D[0] = 1;
<a name="l00156"></a>00156           <span class="keywordflow">break</span>;
<a name="l00157"></a>00157         <span class="keywordflow">case</span> 2:
<a name="l00158"></a>00158           bases1D[0] = 1;
<a name="l00159"></a>00159           bases1D[1] = 1;
<a name="l00160"></a>00160           <span class="keywordflow">break</span>;
<a name="l00161"></a>00161         <span class="keywordflow">case</span> 3:
<a name="l00162"></a>00162           bases1D[1] = 1;
<a name="l00163"></a>00163           <span class="keywordflow">break</span>;
<a name="l00164"></a>00164         <span class="keywordflow">case</span> 4:
<a name="l00165"></a>00165           bases1D[2] = 1;
<a name="l00166"></a>00166           <span class="keywordflow">break</span>;
<a name="l00167"></a>00167         <span class="keywordflow">case</span> 5:
<a name="l00168"></a>00168           bases1D[0] = 1;
<a name="l00169"></a>00169           bases1D[2] = 1;
<a name="l00170"></a>00170           <span class="keywordflow">break</span>;
<a name="l00171"></a>00171         <span class="keywordflow">case</span> 6:
<a name="l00172"></a>00172           bases1D[0] = 1;
<a name="l00173"></a>00173           bases1D[1] = 1;
<a name="l00174"></a>00174           bases1D[2] = 1;
<a name="l00175"></a>00175           <span class="keywordflow">break</span>;
<a name="l00176"></a>00176         <span class="keywordflow">case</span> 7:
<a name="l00177"></a>00177           bases1D[1] = 1;
<a name="l00178"></a>00178           bases1D[2] = 1;
<a name="l00179"></a>00179           <span class="keywordflow">break</span>;
<a name="l00180"></a>00180         }
<a name="l00181"></a>00181 
<a name="l00182"></a>00182       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i%8;
<a name="l00183"></a>00183       <span class="keywordflow">switch</span> (basisnum) <span class="comment">// DoF type</span>
<a name="l00184"></a>00184         {
<a name="l00185"></a>00185         <span class="keywordflow">case</span> 0: <span class="comment">// DoF = value at node</span>
<a name="l00186"></a>00186           coef = 1.0;
<a name="l00187"></a>00187           <span class="keywordflow">break</span>;
<a name="l00188"></a>00188         <span class="keywordflow">case</span> 1: <span class="comment">// DoF = x derivative at node</span>
<a name="l00189"></a>00189           coef = dxdxi[0][bases1D[0]];
<a name="l00190"></a>00190           bases1D[0] += 2; <span class="keywordflow">break</span>;
<a name="l00191"></a>00191         <span class="keywordflow">case</span> 2: <span class="comment">// DoF = y derivative at node</span>
<a name="l00192"></a>00192           coef = dxdxi[1][bases1D[1]];
<a name="l00193"></a>00193           bases1D[1] += 2; <span class="keywordflow">break</span>;
<a name="l00194"></a>00194         <span class="keywordflow">case</span> 3: <span class="comment">// DoF = xy derivative at node</span>
<a name="l00195"></a>00195           coef = dxdxi[0][bases1D[0]] * dxdxi[1][bases1D[1]];
<a name="l00196"></a>00196           bases1D[0] += 2; bases1D[1] += 2; <span class="keywordflow">break</span>;
<a name="l00197"></a>00197         <span class="keywordflow">case</span> 4: <span class="comment">// DoF = z derivative at node</span>
<a name="l00198"></a>00198           coef = dxdxi[2][bases1D[2]];
<a name="l00199"></a>00199           bases1D[2] += 2; <span class="keywordflow">break</span>;
<a name="l00200"></a>00200         <span class="keywordflow">case</span> 5: <span class="comment">// DoF = xz derivative at node</span>
<a name="l00201"></a>00201           coef = dxdxi[0][bases1D[0]] * dxdxi[2][bases1D[2]];
<a name="l00202"></a>00202           bases1D[0] += 2; bases1D[2] += 2; <span class="keywordflow">break</span>;
<a name="l00203"></a>00203         <span class="keywordflow">case</span> 6: <span class="comment">// DoF = yz derivative at node</span>
<a name="l00204"></a>00204           coef = dxdxi[1][bases1D[1]] * dxdxi[2][bases1D[2]];
<a name="l00205"></a>00205           bases1D[1] += 2; bases1D[2] += 2; <span class="keywordflow">break</span>;
<a name="l00206"></a>00206         <span class="keywordflow">case</span> 7: <span class="comment">// DoF = xyz derivative at node</span>
<a name="l00207"></a>00207           coef = dxdxi[0][bases1D[0]] * dxdxi[1][bases1D[1]] * dxdxi[2][bases1D[2]];
<a name="l00208"></a>00208           bases1D[0] += 2; bases1D[1] += 2; bases1D[2] += 2; <span class="keywordflow">break</span>;
<a name="l00209"></a>00209         }
<a name="l00210"></a>00210     }
<a name="l00211"></a>00211   <span class="comment">// Edges</span>
<a name="l00212"></a>00212   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 64 + 12*4*e)
<a name="l00213"></a>00213     {
<a name="l00214"></a>00214       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = (i - 64) % (4*e);
<a name="l00215"></a>00215       <span class="keywordflow">switch</span> ((i - 64) / (4*e))
<a name="l00216"></a>00216         {
<a name="l00217"></a>00217         <span class="keywordflow">case</span> 0:
<a name="l00218"></a>00218           bases1D[0] = basisnum / 4 + 4;
<a name="l00219"></a>00219           bases1D[1] = basisnum % 4 / 2 * 2;
<a name="l00220"></a>00220           bases1D[2] = basisnum % 2 * 2;
<a name="l00221"></a>00221           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00222"></a>00222             coef *= dxdxi[1][0];
<a name="l00223"></a>00223           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00224"></a>00224             coef *= dxdxi[2][0];
<a name="l00225"></a>00225           <span class="keywordflow">break</span>;
<a name="l00226"></a>00226         <span class="keywordflow">case</span> 1:
<a name="l00227"></a>00227           bases1D[0] = basisnum % 4 / 2 * 2 + 1;
<a name="l00228"></a>00228           bases1D[1] = basisnum / 4 + 4;
<a name="l00229"></a>00229           bases1D[2] = basisnum % 2 * 2;
<a name="l00230"></a>00230           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00231"></a>00231             coef *= dxdxi[0][1];
<a name="l00232"></a>00232           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00233"></a>00233             coef *= dxdxi[2][0];
<a name="l00234"></a>00234           <span class="keywordflow">break</span>;
<a name="l00235"></a>00235         <span class="keywordflow">case</span> 2:
<a name="l00236"></a>00236           bases1D[0] = basisnum / 4 + 4;
<a name="l00237"></a>00237           bases1D[1] = basisnum % 4 / 2 * 2 + 1;
<a name="l00238"></a>00238           bases1D[2] = basisnum % 2 * 2;
<a name="l00239"></a>00239           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00240"></a>00240             coef *= dxdxi[1][1];
<a name="l00241"></a>00241           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00242"></a>00242             coef *= dxdxi[2][0];
<a name="l00243"></a>00243           <span class="keywordflow">break</span>;
<a name="l00244"></a>00244         <span class="keywordflow">case</span> 3:
<a name="l00245"></a>00245           bases1D[0] = basisnum % 4 / 2 * 2;
<a name="l00246"></a>00246           bases1D[1] = basisnum / 4 + 4;
<a name="l00247"></a>00247           bases1D[2] = basisnum % 2 * 2;
<a name="l00248"></a>00248           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00249"></a>00249             coef *= dxdxi[0][0];
<a name="l00250"></a>00250           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00251"></a>00251             coef *= dxdxi[2][0];
<a name="l00252"></a>00252           <span class="keywordflow">break</span>;
<a name="l00253"></a>00253         <span class="keywordflow">case</span> 4:
<a name="l00254"></a>00254           bases1D[0] = basisnum % 4 / 2 * 2;
<a name="l00255"></a>00255           bases1D[1] = basisnum % 2 * 2;
<a name="l00256"></a>00256           bases1D[2] = basisnum / 4 + 4;
<a name="l00257"></a>00257           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00258"></a>00258             coef *= dxdxi[0][0];
<a name="l00259"></a>00259           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00260"></a>00260             coef *= dxdxi[1][0];
<a name="l00261"></a>00261           <span class="keywordflow">break</span>;
<a name="l00262"></a>00262         <span class="keywordflow">case</span> 5:
<a name="l00263"></a>00263           bases1D[0] = basisnum % 4 / 2 * 2 + 1;
<a name="l00264"></a>00264           bases1D[1] = basisnum % 2 * 2;
<a name="l00265"></a>00265           bases1D[2] = basisnum / 4 + 4;
<a name="l00266"></a>00266           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00267"></a>00267             coef *= dxdxi[0][1];
<a name="l00268"></a>00268           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00269"></a>00269             coef *= dxdxi[1][0];
<a name="l00270"></a>00270           <span class="keywordflow">break</span>;
<a name="l00271"></a>00271         <span class="keywordflow">case</span> 6:
<a name="l00272"></a>00272           bases1D[0] = basisnum % 4 / 2 * 2 + 1;
<a name="l00273"></a>00273           bases1D[1] = basisnum % 2 * 2 + 1;
<a name="l00274"></a>00274           bases1D[2] = basisnum / 4 + 4;
<a name="l00275"></a>00275           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00276"></a>00276             coef *= dxdxi[0][1];
<a name="l00277"></a>00277           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00278"></a>00278             coef *= dxdxi[1][1];
<a name="l00279"></a>00279           <span class="keywordflow">break</span>;
<a name="l00280"></a>00280         <span class="keywordflow">case</span> 7:
<a name="l00281"></a>00281           bases1D[0] = basisnum % 4 / 2 * 2;
<a name="l00282"></a>00282           bases1D[1] = basisnum % 2 * 2 + 1;
<a name="l00283"></a>00283           bases1D[2] = basisnum / 4 + 4;
<a name="l00284"></a>00284           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00285"></a>00285             coef *= dxdxi[0][0];
<a name="l00286"></a>00286           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00287"></a>00287             coef *= dxdxi[1][1];
<a name="l00288"></a>00288           <span class="keywordflow">break</span>;
<a name="l00289"></a>00289         <span class="keywordflow">case</span> 8:
<a name="l00290"></a>00290           bases1D[0] = basisnum / 4 + 4;
<a name="l00291"></a>00291           bases1D[1] = basisnum % 4 / 2 * 2;
<a name="l00292"></a>00292           bases1D[2] = basisnum % 2 * 2 + 1;
<a name="l00293"></a>00293           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00294"></a>00294             coef *= dxdxi[1][0];
<a name="l00295"></a>00295           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00296"></a>00296             coef *= dxdxi[2][1];
<a name="l00297"></a>00297           <span class="keywordflow">break</span>;
<a name="l00298"></a>00298         <span class="keywordflow">case</span> 9:
<a name="l00299"></a>00299           bases1D[0] = basisnum % 4 / 2 * 2 + 1;
<a name="l00300"></a>00300           bases1D[1] = basisnum / 4 + 4;
<a name="l00301"></a>00301           bases1D[2] = basisnum % 2 * 2;
<a name="l00302"></a>00302           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00303"></a>00303             coef *= dxdxi[0][1];
<a name="l00304"></a>00304           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00305"></a>00305             coef *= dxdxi[2][1];
<a name="l00306"></a>00306           <span class="keywordflow">break</span>;
<a name="l00307"></a>00307         <span class="keywordflow">case</span> 10:
<a name="l00308"></a>00308           bases1D[0] = basisnum / 4 + 4;
<a name="l00309"></a>00309           bases1D[1] = basisnum % 4 / 2 * 2 + 1;
<a name="l00310"></a>00310           bases1D[2] = basisnum % 2 * 2 + 1;
<a name="l00311"></a>00311           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00312"></a>00312             coef *= dxdxi[1][1];
<a name="l00313"></a>00313           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00314"></a>00314             coef *= dxdxi[2][1];
<a name="l00315"></a>00315           <span class="keywordflow">break</span>;
<a name="l00316"></a>00316         <span class="keywordflow">case</span> 11:
<a name="l00317"></a>00317           bases1D[0] = basisnum % 4 / 2 * 2;
<a name="l00318"></a>00318           bases1D[1] = basisnum / 4 + 4;
<a name="l00319"></a>00319           bases1D[2] = basisnum % 2 * 2 + 1;
<a name="l00320"></a>00320           <span class="keywordflow">if</span> (basisnum % 4 / 2)
<a name="l00321"></a>00321             coef *= dxdxi[0][0];
<a name="l00322"></a>00322           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00323"></a>00323             coef *= dxdxi[2][1];
<a name="l00324"></a>00324           <span class="keywordflow">break</span>;
<a name="l00325"></a>00325         }
<a name="l00326"></a>00326     }
<a name="l00327"></a>00327   <span class="comment">// Faces</span>
<a name="l00328"></a>00328   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 64 + 12*4*e + 6*2*e*e)
<a name="l00329"></a>00329     {
<a name="l00330"></a>00330       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = (i - 64 - 12*4*e) % (2*e*e);
<a name="l00331"></a>00331       <span class="keywordflow">switch</span> ((i - 64 - 12*4*e) / (2*e*e))
<a name="l00332"></a>00332         {
<a name="l00333"></a>00333         <span class="keywordflow">case</span> 0:
<a name="l00334"></a>00334           bases1D[0] = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum / 2];
<a name="l00335"></a>00335           bases1D[1] = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum / 2];
<a name="l00336"></a>00336           bases1D[2] = basisnum % 2 * 2;
<a name="l00337"></a>00337           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00338"></a>00338             coef *= dxdxi[2][0];
<a name="l00339"></a>00339           <span class="keywordflow">break</span>;
<a name="l00340"></a>00340         <span class="keywordflow">case</span> 1:
<a name="l00341"></a>00341           bases1D[0] = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum / 2];
<a name="l00342"></a>00342           bases1D[1] = basisnum % 2 * 2;
<a name="l00343"></a>00343           bases1D[2] = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum / 2];
<a name="l00344"></a>00344           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00345"></a>00345             coef *= dxdxi[1][0];
<a name="l00346"></a>00346           <span class="keywordflow">break</span>;
<a name="l00347"></a>00347         <span class="keywordflow">case</span> 2:
<a name="l00348"></a>00348           bases1D[0] = basisnum % 2 * 2 + 1;
<a name="l00349"></a>00349           bases1D[1] = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum / 2];
<a name="l00350"></a>00350           bases1D[2] = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum / 2];
<a name="l00351"></a>00351           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00352"></a>00352             coef *= dxdxi[0][1];
<a name="l00353"></a>00353           <span class="keywordflow">break</span>;
<a name="l00354"></a>00354         <span class="keywordflow">case</span> 3:
<a name="l00355"></a>00355           bases1D[0] = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum / 2];
<a name="l00356"></a>00356           bases1D[1] = basisnum % 2 * 2 + 1;
<a name="l00357"></a>00357           bases1D[2] = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum / 2];
<a name="l00358"></a>00358           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00359"></a>00359             coef *= dxdxi[1][1];
<a name="l00360"></a>00360           <span class="keywordflow">break</span>;
<a name="l00361"></a>00361         <span class="keywordflow">case</span> 4:
<a name="l00362"></a>00362           bases1D[0] = basisnum % 2 * 2;
<a name="l00363"></a>00363           bases1D[1] = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum / 2];
<a name="l00364"></a>00364           bases1D[2] = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum / 2];
<a name="l00365"></a>00365           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00366"></a>00366             coef *= dxdxi[0][0];
<a name="l00367"></a>00367           <span class="keywordflow">break</span>;
<a name="l00368"></a>00368         <span class="keywordflow">case</span> 5:
<a name="l00369"></a>00369           bases1D[0] = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum / 2];
<a name="l00370"></a>00370           bases1D[1] = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum / 2];
<a name="l00371"></a>00371           bases1D[2] = basisnum % 2 * 2 + 1;
<a name="l00372"></a>00372           <span class="keywordflow">if</span> (basisnum % 2)
<a name="l00373"></a>00373             coef *= dxdxi[2][1];
<a name="l00374"></a>00374           <span class="keywordflow">break</span>;
<a name="l00375"></a>00375         }
<a name="l00376"></a>00376     }
<a name="l00377"></a>00377   <span class="comment">// Interior</span>
<a name="l00378"></a>00378   <span class="keywordflow">else</span>
<a name="l00379"></a>00379     {
<a name="l00380"></a>00380       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 64 - 12*4*e;
<a name="l00381"></a>00381       bases1D[0] = <a class="code" href="namespacelibMesh.php#a89b107ed0e100e4616f74b44b57d791d">cube_number_column</a>[basisnum] + 4;
<a name="l00382"></a>00382       bases1D[1] = <a class="code" href="namespacelibMesh.php#a6a98ddb5341c1a8eb7c5517d89db62d8">cube_number_row</a>[basisnum] + 4;
<a name="l00383"></a>00383       bases1D[2] = <a class="code" href="namespacelibMesh.php#a6c2acecfb9abd9fd0cff680913ba1447">cube_number_page</a>[basisnum] + 4;
<a name="l00384"></a>00384     }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386   <span class="comment">// No singular elements</span>
<a name="l00387"></a>00387   libmesh_assert(coef);
<a name="l00388"></a>00388   <span class="keywordflow">return</span> coef;
<a name="l00389"></a>00389 }
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 } <span class="comment">// end anonymous namespace</span>
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 <span class="keyword">namespace </span>libMesh
<a name="l00396"></a>00396 {
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 <span class="keyword">template</span> &lt;&gt;
<a name="l00400"></a>00400 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HERMITE&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00401"></a>00401                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00402"></a>00402                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00403"></a>00403                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00404"></a>00404 {
<a name="l00405"></a>00405   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Hermite elements require the real element\n&quot;</span>
<a name="l00406"></a>00406                 &lt;&lt; <span class="stringliteral">&quot;to construct gradient-based degrees of freedom.&quot;</span>
<a name="l00407"></a>00407                 &lt;&lt; std::endl;
<a name="l00408"></a>00408   
<a name="l00409"></a>00409   libmesh_error();
<a name="l00410"></a>00410   <span class="keywordflow">return</span> 0.;
<a name="l00411"></a>00411 }
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 <span class="keyword">template</span> &lt;&gt;
<a name="l00416"></a>00416 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HERMITE&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00417"></a>00417                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00418"></a>00418                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00419"></a>00419                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00420"></a>00420 {
<a name="l00421"></a>00421   libmesh_assert (elem != NULL);
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 <span class="preprocessor">#ifndef LIBMESH_HAVE_TBB_API</span>
<a name="l00424"></a>00424 <span class="preprocessor"></span>  hermite_compute_coefs(elem);
<a name="l00425"></a>00425 <span class="preprocessor">#else</span>
<a name="l00426"></a>00426 <span class="preprocessor"></span>  std::vector&lt;std::vector&lt;Real&gt; &gt; dxdxi(3, std::vector&lt;Real&gt;(2, 0));
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span>  std::vector&lt;Real&gt; dydxi(2), dzdeta(2), dxdzeta(2);   
<a name="l00430"></a>00430   std::vector&lt;Real&gt; dzdxi(2), dxdeta(2), dydzeta(2);
<a name="l00431"></a>00431   
<a name="l00432"></a>00432   hermite_compute_coefs(elem, dxdxi, dydxi, dzdeta, dxdzeta, dzdxi, dxdeta, dydzeta);
<a name="l00433"></a>00433 <span class="preprocessor">#else //DEBUG</span>
<a name="l00434"></a>00434 <span class="preprocessor"></span>  hermite_compute_coefs(elem, dxdxi);
<a name="l00435"></a>00435 <span class="preprocessor">#endif //DEBUG</span>
<a name="l00436"></a>00436 <span class="preprocessor"></span>
<a name="l00437"></a>00437 <span class="preprocessor">#endif</span>
<a name="l00438"></a>00438 <span class="preprocessor"></span>
<a name="l00439"></a>00439   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00440"></a>00440   
<a name="l00441"></a>00441   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00442"></a>00442   
<a name="l00443"></a>00443   <span class="keywordflow">switch</span> (totalorder)
<a name="l00444"></a>00444     {      
<a name="l00445"></a>00445       <span class="comment">// 3rd-order tricubic Hermite functions</span>
<a name="l00446"></a>00446     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00447"></a>00447       {
<a name="l00448"></a>00448         <span class="keywordflow">switch</span> (type)
<a name="l00449"></a>00449           {
<a name="l00450"></a>00450           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00451"></a>00451           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00452"></a>00452           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00453"></a>00453             {
<a name="l00454"></a>00454               libmesh_assert (i&lt;64);
<a name="l00455"></a>00455 
<a name="l00456"></a>00456               std::vector&lt;unsigned int&gt; bases1D;
<a name="l00457"></a>00457 
<a name="l00458"></a>00458               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> coef = hermite_bases_3D(bases1D, dxdxi, totalorder, i);
<a name="l00459"></a>00459 
<a name="l00460"></a>00460               <span class="keywordflow">return</span> coef *
<a name="l00461"></a>00461                      <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[0],p(0)) *
<a name="l00462"></a>00462                      <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[1],p(1)) *
<a name="l00463"></a>00463                      <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[2],p(2));
<a name="l00464"></a>00464             }
<a name="l00465"></a>00465           <span class="keywordflow">default</span>:
<a name="l00466"></a>00466             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l00467"></a>00467             libmesh_error();
<a name="l00468"></a>00468           }
<a name="l00469"></a>00469       }
<a name="l00470"></a>00470       <span class="comment">// by default throw an error</span>
<a name="l00471"></a>00471     <span class="keywordflow">default</span>:
<a name="l00472"></a>00472       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported polynomial order!&quot;</span> &lt;&lt; std::endl;
<a name="l00473"></a>00473       libmesh_error();
<a name="l00474"></a>00474     }
<a name="l00475"></a>00475   
<a name="l00476"></a>00476   libmesh_error();
<a name="l00477"></a>00477   <span class="keywordflow">return</span> 0.;
<a name="l00478"></a>00478 }
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 <span class="keyword">template</span> &lt;&gt;
<a name="l00483"></a>00483 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HERMITE&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00484"></a>00484                                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,                        
<a name="l00485"></a>00485                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00486"></a>00486                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00487"></a>00487                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00488"></a>00488 {
<a name="l00489"></a>00489   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Hermite elements require the real element\n&quot;</span>
<a name="l00490"></a>00490                 &lt;&lt; <span class="stringliteral">&quot;to construct gradient-based degrees of freedom.&quot;</span>
<a name="l00491"></a>00491                 &lt;&lt; std::endl;
<a name="l00492"></a>00492 
<a name="l00493"></a>00493   libmesh_error();
<a name="l00494"></a>00494   <span class="keywordflow">return</span> 0.;
<a name="l00495"></a>00495 }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 <span class="keyword">template</span> &lt;&gt;
<a name="l00500"></a>00500 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HERMITE&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00501"></a>00501                                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00502"></a>00502                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00503"></a>00503                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00504"></a>00504                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00505"></a>00505 {
<a name="l00506"></a>00506   libmesh_assert (elem != NULL);
<a name="l00507"></a>00507   libmesh_assert (j == 0 || j == 1 || j == 2);
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 <span class="preprocessor">#ifndef LIBMESH_HAVE_TBB_API</span>
<a name="l00510"></a>00510 <span class="preprocessor"></span>  hermite_compute_coefs(elem);
<a name="l00511"></a>00511 <span class="preprocessor">#else</span>
<a name="l00512"></a>00512 <span class="preprocessor"></span>  std::vector&lt;std::vector&lt;Real&gt; &gt; dxdxi(3, std::vector&lt;Real&gt;(2, 0));
<a name="l00513"></a>00513 
<a name="l00514"></a>00514 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00515"></a>00515 <span class="preprocessor"></span>  std::vector&lt;Real&gt; dydxi(2), dzdeta(2), dxdzeta(2);   
<a name="l00516"></a>00516   std::vector&lt;Real&gt; dzdxi(2), dxdeta(2), dydzeta(2);
<a name="l00517"></a>00517   
<a name="l00518"></a>00518   hermite_compute_coefs(elem, dxdxi, dydxi, dzdeta, dxdzeta, dzdxi, dxdeta, dydzeta);
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 <span class="preprocessor">#else //DEBUG</span>
<a name="l00521"></a>00521 <span class="preprocessor"></span>  hermite_compute_coefs(elem, dxdxi);
<a name="l00522"></a>00522 <span class="preprocessor">#endif //DEBUG</span>
<a name="l00523"></a>00523 <span class="preprocessor"></span>
<a name="l00524"></a>00524 <span class="preprocessor">#endif</span>
<a name="l00525"></a>00525 <span class="preprocessor"></span>
<a name="l00526"></a>00526   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00527"></a>00527   
<a name="l00528"></a>00528   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00529"></a>00529   
<a name="l00530"></a>00530   <span class="keywordflow">switch</span> (totalorder)
<a name="l00531"></a>00531     {      
<a name="l00532"></a>00532       <span class="comment">// 3rd-order tricubic Hermite functions</span>
<a name="l00533"></a>00533     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00534"></a>00534       {
<a name="l00535"></a>00535         <span class="keywordflow">switch</span> (type)
<a name="l00536"></a>00536           {
<a name="l00537"></a>00537           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00538"></a>00538           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00539"></a>00539           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00540"></a>00540             {
<a name="l00541"></a>00541               libmesh_assert (i&lt;64);
<a name="l00542"></a>00542 
<a name="l00543"></a>00543               std::vector&lt;unsigned int&gt; bases1D;
<a name="l00544"></a>00544 
<a name="l00545"></a>00545               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> coef = hermite_bases_3D(bases1D, dxdxi, totalorder, i);
<a name="l00546"></a>00546 
<a name="l00547"></a>00547               <span class="keywordflow">switch</span> (j) <span class="comment">// Derivative type</span>
<a name="l00548"></a>00548                 {
<a name="l00549"></a>00549                 <span class="keywordflow">case</span> 0:
<a name="l00550"></a>00550                   <span class="keywordflow">return</span> coef *
<a name="l00551"></a>00551                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_deriv</a>(bases1D[0],p(0)) * 
<a name="l00552"></a>00552                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[1],p(1)) * 
<a name="l00553"></a>00553                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[2],p(2));
<a name="l00554"></a>00554                   <span class="keywordflow">break</span>;
<a name="l00555"></a>00555                 <span class="keywordflow">case</span> 1:
<a name="l00556"></a>00556                   <span class="keywordflow">return</span> coef *
<a name="l00557"></a>00557                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[0],p(0)) * 
<a name="l00558"></a>00558                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_deriv</a>(bases1D[1],p(1)) * 
<a name="l00559"></a>00559                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[2],p(2));
<a name="l00560"></a>00560                   <span class="keywordflow">break</span>;
<a name="l00561"></a>00561                 <span class="keywordflow">case</span> 2:
<a name="l00562"></a>00562                   <span class="keywordflow">return</span> coef *
<a name="l00563"></a>00563                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[0],p(0)) * 
<a name="l00564"></a>00564                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[1],p(1)) * 
<a name="l00565"></a>00565                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_deriv</a>(bases1D[2],p(2));
<a name="l00566"></a>00566                   <span class="keywordflow">break</span>;
<a name="l00567"></a>00567                 }
<a name="l00568"></a>00568                   
<a name="l00569"></a>00569             }
<a name="l00570"></a>00570           <span class="keywordflow">default</span>:
<a name="l00571"></a>00571             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l00572"></a>00572             libmesh_error();
<a name="l00573"></a>00573           }
<a name="l00574"></a>00574       }
<a name="l00575"></a>00575       <span class="comment">// by default throw an error</span>
<a name="l00576"></a>00576     <span class="keywordflow">default</span>:
<a name="l00577"></a>00577       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported polynomial order!&quot;</span> &lt;&lt; std::endl;
<a name="l00578"></a>00578       libmesh_error();
<a name="l00579"></a>00579     }
<a name="l00580"></a>00580   
<a name="l00581"></a>00581   libmesh_error();
<a name="l00582"></a>00582   <span class="keywordflow">return</span> 0.;
<a name="l00583"></a>00583 }
<a name="l00584"></a>00584 
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 <span class="keyword">template</span> &lt;&gt;
<a name="l00588"></a>00588 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HERMITE&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00589"></a>00589                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00590"></a>00590                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00591"></a>00591                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00592"></a>00592                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00593"></a>00593 {
<a name="l00594"></a>00594   libmesh_assert (elem != NULL);
<a name="l00595"></a>00595   
<a name="l00596"></a>00596 <span class="preprocessor">#ifndef LIBMESH_HAVE_TBB_API</span>
<a name="l00597"></a>00597 <span class="preprocessor"></span>  hermite_compute_coefs(elem);
<a name="l00598"></a>00598 <span class="preprocessor">#else</span>
<a name="l00599"></a>00599 <span class="preprocessor"></span>  std::vector&lt;std::vector&lt;Real&gt; &gt; dxdxi(3, std::vector&lt;Real&gt;(2, 0));
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00602"></a>00602 <span class="preprocessor"></span>  std::vector&lt;Real&gt; dydxi(2), dzdeta(2), dxdzeta(2);   
<a name="l00603"></a>00603   std::vector&lt;Real&gt; dzdxi(2), dxdeta(2), dydzeta(2);
<a name="l00604"></a>00604   
<a name="l00605"></a>00605   hermite_compute_coefs(elem, dxdxi, dydxi, dzdeta, dxdzeta, dzdxi, dxdeta, dydzeta);
<a name="l00606"></a>00606 
<a name="l00607"></a>00607 <span class="preprocessor">#else //DEBUG</span>
<a name="l00608"></a>00608 <span class="preprocessor"></span>  hermite_compute_coefs(elem, dxdxi);
<a name="l00609"></a>00609 <span class="preprocessor">#endif //DEBUG</span>
<a name="l00610"></a>00610 <span class="preprocessor"></span>
<a name="l00611"></a>00611 <span class="preprocessor">#endif</span>
<a name="l00612"></a>00612 <span class="preprocessor"></span>
<a name="l00613"></a>00613   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00614"></a>00614   
<a name="l00615"></a>00615   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00616"></a>00616   
<a name="l00617"></a>00617   <span class="keywordflow">switch</span> (totalorder)
<a name="l00618"></a>00618     {      
<a name="l00619"></a>00619       <span class="comment">// 3rd-order tricubic Hermite functions</span>
<a name="l00620"></a>00620     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00621"></a>00621       {
<a name="l00622"></a>00622         <span class="keywordflow">switch</span> (type)
<a name="l00623"></a>00623           {
<a name="l00624"></a>00624           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00625"></a>00625           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00626"></a>00626           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00627"></a>00627             {
<a name="l00628"></a>00628               libmesh_assert (i&lt;64);
<a name="l00629"></a>00629 
<a name="l00630"></a>00630               std::vector&lt;unsigned int&gt; bases1D;
<a name="l00631"></a>00631 
<a name="l00632"></a>00632               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> coef = hermite_bases_3D(bases1D, dxdxi, totalorder, i);
<a name="l00633"></a>00633 
<a name="l00634"></a>00634               <span class="keywordflow">switch</span> (j) <span class="comment">// Derivative type</span>
<a name="l00635"></a>00635                 {
<a name="l00636"></a>00636                 <span class="keywordflow">case</span> 0:
<a name="l00637"></a>00637                   <span class="keywordflow">return</span> coef *
<a name="l00638"></a>00638                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_second_deriv</a>(bases1D[0],p(0)) * 
<a name="l00639"></a>00639                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[1],p(1)) * 
<a name="l00640"></a>00640                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[2],p(2));
<a name="l00641"></a>00641                   <span class="keywordflow">break</span>;
<a name="l00642"></a>00642                 <span class="keywordflow">case</span> 1:
<a name="l00643"></a>00643                   <span class="keywordflow">return</span> coef *
<a name="l00644"></a>00644                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_deriv</a>(bases1D[0],p(0)) * 
<a name="l00645"></a>00645                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_deriv</a>(bases1D[1],p(1)) * 
<a name="l00646"></a>00646                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[2],p(2));
<a name="l00647"></a>00647                   <span class="keywordflow">break</span>;
<a name="l00648"></a>00648                 <span class="keywordflow">case</span> 2:
<a name="l00649"></a>00649                   <span class="keywordflow">return</span> coef *
<a name="l00650"></a>00650                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[0],p(0)) * 
<a name="l00651"></a>00651                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_second_deriv</a>(bases1D[1],p(1)) * 
<a name="l00652"></a>00652                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[2],p(2));
<a name="l00653"></a>00653                   <span class="keywordflow">break</span>;
<a name="l00654"></a>00654                 <span class="keywordflow">case</span> 3:
<a name="l00655"></a>00655                   <span class="keywordflow">return</span> coef *
<a name="l00656"></a>00656                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_deriv</a>(bases1D[0],p(0)) * 
<a name="l00657"></a>00657                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[1],p(1)) * 
<a name="l00658"></a>00658                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_deriv</a>(bases1D[2],p(2));
<a name="l00659"></a>00659                   <span class="keywordflow">break</span>;
<a name="l00660"></a>00660                 <span class="keywordflow">case</span> 4:
<a name="l00661"></a>00661                   <span class="keywordflow">return</span> coef *
<a name="l00662"></a>00662                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[0],p(0)) * 
<a name="l00663"></a>00663                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_deriv</a>(bases1D[1],p(1)) * 
<a name="l00664"></a>00664                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_deriv</a>(bases1D[2],p(2));
<a name="l00665"></a>00665                   <span class="keywordflow">break</span>;
<a name="l00666"></a>00666                 <span class="keywordflow">case</span> 5:
<a name="l00667"></a>00667                   <span class="keywordflow">return</span> coef *
<a name="l00668"></a>00668                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[0],p(0)) * 
<a name="l00669"></a>00669                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape</a>(bases1D[1],p(1)) * 
<a name="l00670"></a>00670                     <a class="code" href="classlibMesh_1_1FEHermite.php">FEHermite&lt;1&gt;::hermite_raw_shape_second_deriv</a>(bases1D[2],p(2));
<a name="l00671"></a>00671                   <span class="keywordflow">break</span>;
<a name="l00672"></a>00672                 }
<a name="l00673"></a>00673                   
<a name="l00674"></a>00674             }
<a name="l00675"></a>00675           <span class="keywordflow">default</span>:
<a name="l00676"></a>00676             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!&quot;</span> &lt;&lt; std::endl;
<a name="l00677"></a>00677             libmesh_error();
<a name="l00678"></a>00678           }
<a name="l00679"></a>00679       }
<a name="l00680"></a>00680       <span class="comment">// by default throw an error</span>
<a name="l00681"></a>00681     <span class="keywordflow">default</span>:
<a name="l00682"></a>00682       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported polynomial order!&quot;</span> &lt;&lt; std::endl;
<a name="l00683"></a>00683       libmesh_error();
<a name="l00684"></a>00684     }
<a name="l00685"></a>00685   
<a name="l00686"></a>00686   libmesh_error();
<a name="l00687"></a>00687   <span class="keywordflow">return</span> 0.;
<a name="l00688"></a>00688 }
<a name="l00689"></a>00689 
<a name="l00690"></a>00690 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
