<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_hierarchic_shape_1D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__hierarchic__shape__1D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_hierarchic_shape_1D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ inlcludes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">template</span> &lt;&gt;
<a name="l00035"></a><a class="code" href="classlibMesh_1_1FE.php#aea835579e127bfde37703178f5667d9b">00035</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,HIERARCHIC&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00036"></a>00036                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00037"></a>00037                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00038"></a>00038                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   libmesh_assert(i &lt; order+1u);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">// Declare that we are using our own special power function</span>
<a name="l00043"></a>00043   <span class="comment">// from the Utility namespace.  This saves typing later.</span>
<a name="l00044"></a>00044   <span class="keyword">using</span> <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">Utility::pow</a>;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0);
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> returnval = 1.;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keywordflow">switch</span> (i)
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052     <span class="keywordflow">case</span> 0:
<a name="l00053"></a>00053       returnval = .5*(1. - xi);
<a name="l00054"></a>00054       <span class="keywordflow">break</span>;
<a name="l00055"></a>00055     <span class="keywordflow">case</span> 1:
<a name="l00056"></a>00056       returnval = .5*(1.  + xi);
<a name="l00057"></a>00057       <span class="keywordflow">break</span>;
<a name="l00058"></a>00058       <span class="comment">// All even-terms have the same form.</span>
<a name="l00059"></a>00059       <span class="comment">// (xi^p - 1.)/p!</span>
<a name="l00060"></a>00060     <span class="keywordflow">case</span> 2:
<a name="l00061"></a>00061       returnval = (xi*xi - 1.)/2.;
<a name="l00062"></a>00062       <span class="keywordflow">break</span>;
<a name="l00063"></a>00063     <span class="keywordflow">case</span> 4:
<a name="l00064"></a>00064       returnval = (<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(xi) - 1.)/24.;
<a name="l00065"></a>00065       <span class="keywordflow">break</span>;
<a name="l00066"></a>00066     <span class="keywordflow">case</span> 6:
<a name="l00067"></a>00067       returnval = (<a class="code" href="namespacelibMesh_1_1Utility.php#a2d46d0773532b1585515720757cbab90">pow&lt;6&gt;</a>(xi) - 1.)/720.;
<a name="l00068"></a>00068       <span class="keywordflow">break</span>;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070       <span class="comment">// All odd-terms have the same form.</span>
<a name="l00071"></a>00071       <span class="comment">// (xi^p - xi)/p!</span>
<a name="l00072"></a>00072     <span class="keywordflow">case</span> 3:
<a name="l00073"></a>00073       returnval = (xi*xi*xi - xi)/6.;
<a name="l00074"></a>00074       <span class="keywordflow">break</span>;
<a name="l00075"></a>00075     <span class="keywordflow">case</span> 5:
<a name="l00076"></a>00076       returnval = (pow&lt;5&gt;(xi) - xi)/120.;
<a name="l00077"></a>00077       <span class="keywordflow">break</span>;
<a name="l00078"></a>00078     <span class="keywordflow">case</span> 7:
<a name="l00079"></a>00079       returnval = (pow&lt;7&gt;(xi) - xi)/5040.;          
<a name="l00080"></a>00080       <span class="keywordflow">break</span>;
<a name="l00081"></a>00081     <span class="keywordflow">default</span>:
<a name="l00082"></a>00082       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> denominator = 1.;
<a name="l00083"></a>00083       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1; n &lt;= i; ++n)
<a name="l00084"></a>00084         {
<a name="l00085"></a>00085           returnval *= xi;
<a name="l00086"></a>00086           denominator *= n;
<a name="l00087"></a>00087         }
<a name="l00088"></a>00088       <span class="comment">// Odd:</span>
<a name="l00089"></a>00089       <span class="keywordflow">if</span> (i % 2)
<a name="l00090"></a>00090         returnval = (returnval - xi)/denominator;
<a name="l00091"></a>00091       <span class="comment">// Even:</span>
<a name="l00092"></a>00092       <span class="keywordflow">else</span>
<a name="l00093"></a>00093         returnval = (returnval - 1.)/denominator;
<a name="l00094"></a>00094       <span class="keywordflow">break</span>;
<a name="l00095"></a>00095     }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="keywordflow">return</span> returnval;
<a name="l00098"></a>00098 }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="keyword">template</span> &lt;&gt;
<a name="l00103"></a><a class="code" href="classlibMesh_1_1FE.php#afecc638880d09933abef2504ff721b7f">00103</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,HIERARCHIC&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00104"></a>00104                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00105"></a>00105                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00106"></a>00106                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00107"></a>00107 {
<a name="l00108"></a>00108   libmesh_assert (elem != NULL);
<a name="l00109"></a>00109   
<a name="l00110"></a>00110   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,HIERARCHIC&gt;::shape</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, p);
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="keyword">template</span> &lt;&gt;
<a name="l00116"></a><a class="code" href="classlibMesh_1_1FE.php#ad50da28a9c3c28f7ef59bc8a25dc2af9">00116</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,HIERARCHIC&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00117"></a>00117                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00118"></a>00118                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00119"></a>00119                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00120"></a>00120                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00121"></a>00121 {
<a name="l00122"></a>00122   <span class="comment">// only d()/dxi in 1D!</span>
<a name="l00123"></a>00123   
<a name="l00124"></a>00124   libmesh_assert (j == 0);
<a name="l00125"></a>00125   libmesh_assert(i &lt; order+1u);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="comment">// Declare that we are using our own special power function</span>
<a name="l00128"></a>00128   <span class="comment">// from the Utility namespace.  This saves typing later.</span>
<a name="l00129"></a>00129   <span class="keyword">using</span> <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">Utility::pow</a>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> returnval = 1.;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordflow">switch</span> (i)
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137     <span class="keywordflow">case</span> 0:
<a name="l00138"></a>00138       returnval = -.5;
<a name="l00139"></a>00139       <span class="keywordflow">break</span>;
<a name="l00140"></a>00140     <span class="keywordflow">case</span> 1:
<a name="l00141"></a>00141       returnval =  .5;
<a name="l00142"></a>00142       <span class="keywordflow">break</span>;
<a name="l00143"></a>00143       <span class="comment">// All even-terms have the same form.</span>
<a name="l00144"></a>00144       <span class="comment">// xi^(p-1)/(p-1)!</span>
<a name="l00145"></a>00145     <span class="keywordflow">case</span> 2:
<a name="l00146"></a>00146       returnval = xi;
<a name="l00147"></a>00147       <span class="keywordflow">break</span>;
<a name="l00148"></a>00148     <span class="keywordflow">case</span> 4:
<a name="l00149"></a>00149       returnval = <a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(xi)/6.;
<a name="l00150"></a>00150       <span class="keywordflow">break</span>;
<a name="l00151"></a>00151     <span class="keywordflow">case</span> 6:
<a name="l00152"></a>00152       returnval = pow&lt;5&gt;(xi)/120.;
<a name="l00153"></a>00153       <span class="keywordflow">break</span>;
<a name="l00154"></a>00154       <span class="comment">// All odd-terms have the same form.</span>
<a name="l00155"></a>00155       <span class="comment">// (p*xi^(p-1) - 1.)/p!</span>
<a name="l00156"></a>00156     <span class="keywordflow">case</span> 3:
<a name="l00157"></a>00157       returnval = (3*xi*xi - 1.)/6.;
<a name="l00158"></a>00158       <span class="keywordflow">break</span>;
<a name="l00159"></a>00159     <span class="keywordflow">case</span> 5:
<a name="l00160"></a>00160       returnval = (5.*<a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(xi) - 1.)/120.;
<a name="l00161"></a>00161       <span class="keywordflow">break</span>;
<a name="l00162"></a>00162     <span class="keywordflow">case</span> 7:
<a name="l00163"></a>00163       returnval = (7.*<a class="code" href="namespacelibMesh_1_1Utility.php#a2d46d0773532b1585515720757cbab90">pow&lt;6&gt;</a>(xi) - 1.)/5040.;       
<a name="l00164"></a>00164       <span class="keywordflow">break</span>;
<a name="l00165"></a>00165     <span class="keywordflow">default</span>:
<a name="l00166"></a>00166       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> denominator = 1.;
<a name="l00167"></a>00167       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1; n != i; ++n)
<a name="l00168"></a>00168         {
<a name="l00169"></a>00169           returnval *= xi;
<a name="l00170"></a>00170           denominator *= n;
<a name="l00171"></a>00171         }
<a name="l00172"></a>00172       <span class="comment">// Odd:</span>
<a name="l00173"></a>00173       <span class="keywordflow">if</span> (i % 2)
<a name="l00174"></a>00174         returnval = (i * returnval - 1.)/denominator/i;
<a name="l00175"></a>00175       <span class="comment">// Even:</span>
<a name="l00176"></a>00176       <span class="keywordflow">else</span>
<a name="l00177"></a>00177         returnval = returnval/denominator;
<a name="l00178"></a>00178       <span class="keywordflow">break</span>;
<a name="l00179"></a>00179     }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   <span class="keywordflow">return</span> returnval;
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="keyword">template</span> &lt;&gt;
<a name="l00187"></a><a class="code" href="classlibMesh_1_1FE.php#a183a1cf37f1c14d3edaed8cad39adafd">00187</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,HIERARCHIC&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00188"></a>00188                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00189"></a>00189                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00190"></a>00190                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00191"></a>00191                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00192"></a>00192 {
<a name="l00193"></a>00193   libmesh_assert (elem != NULL);
<a name="l00194"></a>00194   
<a name="l00195"></a>00195   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,HIERARCHIC&gt;::shape_deriv</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(),
<a name="l00196"></a>00196                                        <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, j, p);
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 <span class="keyword">template</span> &lt;&gt;
<a name="l00202"></a><a class="code" href="classlibMesh_1_1FE.php#aa1e1fa6adde2b11e772b4ef2bb6bdbcd">00202</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;1,HIERARCHIC&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00203"></a>00203                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00204"></a>00204                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00205"></a>00205                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00206"></a>00206                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208   <span class="comment">// only d2()/d2xi in 1D!</span>
<a name="l00209"></a>00209   
<a name="l00210"></a>00210   libmesh_assert (j == 0);
<a name="l00211"></a>00211   libmesh_assert (i &lt; order+1u);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">// Declare that we are using our own special power function</span>
<a name="l00214"></a>00214   <span class="comment">// from the Utility namespace.  This saves typing later.</span>
<a name="l00215"></a>00215   <span class="keyword">using</span> <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">Utility::pow</a>;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi = p(0);
<a name="l00218"></a>00218         
<a name="l00219"></a>00219   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> returnval = 1.;
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   <span class="keywordflow">switch</span> (i)
<a name="l00222"></a>00222     {
<a name="l00223"></a>00223     <span class="keywordflow">case</span> 0:
<a name="l00224"></a>00224     <span class="keywordflow">case</span> 1:
<a name="l00225"></a>00225       returnval = 0;
<a name="l00226"></a>00226       <span class="keywordflow">break</span>;
<a name="l00227"></a>00227       <span class="comment">// All terms have the same form.</span>
<a name="l00228"></a>00228       <span class="comment">// xi^(p-2)/(p-2)!</span>
<a name="l00229"></a>00229     <span class="keywordflow">case</span> 2:
<a name="l00230"></a>00230       returnval = 1;
<a name="l00231"></a>00231       <span class="keywordflow">break</span>;
<a name="l00232"></a>00232     <span class="keywordflow">case</span> 3:
<a name="l00233"></a>00233       returnval = xi;
<a name="l00234"></a>00234       <span class="keywordflow">break</span>;
<a name="l00235"></a>00235     <span class="keywordflow">case</span> 4:
<a name="l00236"></a>00236       returnval = <a class="code" href="namespacelibMesh_1_1Utility.php#a226fc6d9c55b865a32c76fd1297ca728">pow&lt;2&gt;</a>(xi)/2.;
<a name="l00237"></a>00237       <span class="keywordflow">break</span>;
<a name="l00238"></a>00238     <span class="keywordflow">case</span> 5:
<a name="l00239"></a>00239       returnval = <a class="code" href="namespacelibMesh_1_1Utility.php#a476c80f75cba5bc8400df2144aceb588">pow&lt;3&gt;</a>(xi)/6.;
<a name="l00240"></a>00240       <span class="keywordflow">break</span>;
<a name="l00241"></a>00241     <span class="keywordflow">case</span> 6:
<a name="l00242"></a>00242       returnval = <a class="code" href="namespacelibMesh_1_1Utility.php#a8e12d159b2339f6e22be376adafaf37e">pow&lt;4&gt;</a>(xi)/24.;
<a name="l00243"></a>00243       <span class="keywordflow">break</span>;
<a name="l00244"></a>00244     <span class="keywordflow">case</span> 7:
<a name="l00245"></a>00245       returnval = pow&lt;5&gt;(xi)/120.;          
<a name="l00246"></a>00246       <span class="keywordflow">break</span>;
<a name="l00247"></a>00247     
<a name="l00248"></a>00248     <span class="keywordflow">default</span>:
<a name="l00249"></a>00249       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> denominator = 1.;
<a name="l00250"></a>00250       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1; n != i; ++n)
<a name="l00251"></a>00251         {
<a name="l00252"></a>00252           returnval *= xi;
<a name="l00253"></a>00253           denominator *= n;
<a name="l00254"></a>00254         }
<a name="l00255"></a>00255       <span class="comment">// Odd:</span>
<a name="l00256"></a>00256       <span class="keywordflow">if</span> (i % 2)
<a name="l00257"></a>00257         returnval = (i * returnval - 1.)/denominator/i;
<a name="l00258"></a>00258       <span class="comment">// Even:</span>
<a name="l00259"></a>00259       <span class="keywordflow">else</span>
<a name="l00260"></a>00260         returnval = returnval/denominator;
<a name="l00261"></a>00261       <span class="keywordflow">break</span>;
<a name="l00262"></a>00262     }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="keywordflow">return</span> returnval;
<a name="l00265"></a>00265 }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 <span class="keyword">template</span> &lt;&gt;
<a name="l00270"></a><a class="code" href="classlibMesh_1_1FE.php#a147f90723d74d3312c1994c3af5b5447">00270</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;1,HIERARCHIC&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00271"></a>00271                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00272"></a>00272                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00273"></a>00273                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00274"></a>00274                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00275"></a>00275 {
<a name="l00276"></a>00276   libmesh_assert (elem != NULL);
<a name="l00277"></a>00277   
<a name="l00278"></a>00278   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;1,HIERARCHIC&gt;::shape_second_deriv</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(),
<a name="l00279"></a>00279                                               <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, j, p);
<a name="l00280"></a>00280 }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
