<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_hierarchic_shape_3D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__hierarchic__shape__3D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_hierarchic_shape_3D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="number__lookups_8h.php">number_lookups.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">namespace </span>libMesh
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// anonymous namespace for local helper functions</span>
<a name="l00032"></a>00032 <span class="keyword">namespace</span>
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035   Point get_min_point(<span class="keyword">const</span> Elem *elem,
<a name="l00036"></a>00036                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> a,
<a name="l00037"></a>00037                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b,
<a name="l00038"></a>00038                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c,
<a name="l00039"></a>00039                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d)
<a name="l00040"></a>00040   {
<a name="l00041"></a>00041     <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(a),elem-&gt;point(b)),
<a name="l00042"></a>00042                     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(c),elem-&gt;point(d)));
<a name="l00043"></a>00043   }
<a name="l00044"></a>00044   
<a name="l00045"></a>00045   <span class="keywordtype">void</span> cube_indices(<span class="keyword">const</span> Elem *elem,
<a name="l00046"></a>00046                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> totalorder,
<a name="l00047"></a>00047                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00048"></a>00048                     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp;xi, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp;eta, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp;zeta,
<a name="l00049"></a>00049                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;i0,
<a name="l00050"></a>00050                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;i1,
<a name="l00051"></a>00051                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;i2)
<a name="l00052"></a>00052   {
<a name="l00053"></a>00053     <span class="comment">// The only way to make any sense of this</span>
<a name="l00054"></a>00054     <span class="comment">// is to look at the mgflo/mg2/mgf documentation</span>
<a name="l00055"></a>00055     <span class="comment">// and make the cut-out cube!</span>
<a name="l00056"></a>00056     <span class="comment">// Example i0 and i1 values for totalorder = 3:</span>
<a name="l00057"></a>00057     <span class="comment">// FIXME - these examples are incorrect now that we&#39;ve got truly</span>
<a name="l00058"></a>00058     <span class="comment">// hierarchic basis functions</span>
<a name="l00059"></a>00059     <span class="comment">//     Nodes                         0  1  2  3  4  5  6  7  8  8  9  9 10 10 11 11 12 12 13 13 14 14 15 15 16 16 17 17 18 18 19 19 20 20 20 20 21 21 21 21 22 22 22 22 23 23 23 23 24 24 24 24 25 25 25 25 26 26 26 26 26 26 26 26 </span>
<a name="l00060"></a>00060     <span class="comment">//     DOFS                          0  1  2  3  4  5  6  7  8  9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 18 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 60 62 63</span>
<a name="l00061"></a>00061     <span class="comment">// static const unsigned int i0[] = {0, 1, 1, 0, 0, 1, 1, 0, 2, 3, 1, 1, 2, 3, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 1, 1, 1, 1, 2, 3, 2, 3, 0, 0, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 2, 3, 2, 3};</span>
<a name="l00062"></a>00062     <span class="comment">// static const unsigned int i1[] = {0, 0, 1, 1, 0, 0, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 2, 3, 1, 1, 2, 3, 2, 2, 3, 3, 0, 0, 0, 0, 2, 3, 2, 3, 1, 1, 1, 1, 2, 3, 2, 3, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3};</span>
<a name="l00063"></a>00063     <span class="comment">// static const unsigned int i2[] = {0, 0, 0, 0, 1, 1, 1, 1, 0, 0, 0, 0, 0, 0, 0, 0, 2, 3, 2, 3, 2, 3, 2, 3, 1, 1, 1, 1, 1, 1, 1, 1, 0, 0, 0, 0, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3, 2, 2, 3, 3, 1, 1, 1, 1, 2, 2, 2, 2, 3, 3, 3, 3};</span>
<a name="l00064"></a>00064 
<a name="l00065"></a>00065     <span class="comment">// the number of DoFs per edge appears everywhere:</span>
<a name="l00066"></a>00066     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e = totalorder - 1u;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     libmesh_assert (i&lt;(totalorder+1u)*(totalorder+1u)*(totalorder+1u));
<a name="l00069"></a>00069 
<a name="l00070"></a>00070     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi_saved = xi, eta_saved = eta, zeta_saved = zeta;
<a name="l00071"></a>00071 
<a name="l00072"></a>00072     <span class="comment">// Vertices:</span>
<a name="l00073"></a>00073     <span class="keywordflow">if</span> (i == 0)
<a name="l00074"></a>00074       {
<a name="l00075"></a>00075         i0 = 0;
<a name="l00076"></a>00076         i1 = 0;
<a name="l00077"></a>00077         i2 = 0;
<a name="l00078"></a>00078       }
<a name="l00079"></a>00079     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 1)
<a name="l00080"></a>00080       {
<a name="l00081"></a>00081         i0 = 1;
<a name="l00082"></a>00082         i1 = 0;
<a name="l00083"></a>00083         i2 = 0;
<a name="l00084"></a>00084       }
<a name="l00085"></a>00085     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 2)
<a name="l00086"></a>00086       {
<a name="l00087"></a>00087         i0 = 1;
<a name="l00088"></a>00088         i1 = 1;
<a name="l00089"></a>00089         i2 = 0;
<a name="l00090"></a>00090       }
<a name="l00091"></a>00091     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 3)
<a name="l00092"></a>00092       {
<a name="l00093"></a>00093         i0 = 0;
<a name="l00094"></a>00094         i1 = 1;
<a name="l00095"></a>00095         i2 = 0;
<a name="l00096"></a>00096       }
<a name="l00097"></a>00097     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 4)
<a name="l00098"></a>00098       {
<a name="l00099"></a>00099         i0 = 0;
<a name="l00100"></a>00100         i1 = 0;
<a name="l00101"></a>00101         i2 = 1;
<a name="l00102"></a>00102       }
<a name="l00103"></a>00103     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 5)
<a name="l00104"></a>00104       {
<a name="l00105"></a>00105         i0 = 1;
<a name="l00106"></a>00106         i1 = 0;
<a name="l00107"></a>00107         i2 = 1;
<a name="l00108"></a>00108       }
<a name="l00109"></a>00109     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 6)
<a name="l00110"></a>00110       {
<a name="l00111"></a>00111         i0 = 1;
<a name="l00112"></a>00112         i1 = 1;
<a name="l00113"></a>00113         i2 = 1;
<a name="l00114"></a>00114       }
<a name="l00115"></a>00115     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i == 7)
<a name="l00116"></a>00116       {
<a name="l00117"></a>00117         i0 = 0;
<a name="l00118"></a>00118         i1 = 1;
<a name="l00119"></a>00119         i2 = 1;
<a name="l00120"></a>00120       }
<a name="l00121"></a>00121     <span class="comment">// Edge 0</span>
<a name="l00122"></a>00122     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + e)
<a name="l00123"></a>00123       {
<a name="l00124"></a>00124         i0 = i - 6;
<a name="l00125"></a>00125         i1 = 0;
<a name="l00126"></a>00126         i2 = 0;
<a name="l00127"></a>00127         <span class="keywordflow">if</span> (elem-&gt;point(0) &gt; elem-&gt;point(1))
<a name="l00128"></a>00128           xi = -xi_saved;
<a name="l00129"></a>00129       }
<a name="l00130"></a>00130     <span class="comment">// Edge 1</span>
<a name="l00131"></a>00131     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 2*e)
<a name="l00132"></a>00132       {
<a name="l00133"></a>00133         i0 = 1;
<a name="l00134"></a>00134         i1 = i - e - 6;
<a name="l00135"></a>00135         i2 = 0;
<a name="l00136"></a>00136         <span class="keywordflow">if</span> (elem-&gt;point(1) &gt; elem-&gt;point(2))
<a name="l00137"></a>00137           eta = -eta_saved;
<a name="l00138"></a>00138       }
<a name="l00139"></a>00139     <span class="comment">// Edge 2</span>
<a name="l00140"></a>00140     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 3*e)
<a name="l00141"></a>00141       {
<a name="l00142"></a>00142         i0 = i - 2*e - 6;
<a name="l00143"></a>00143         i1 = 1;
<a name="l00144"></a>00144         i2 = 0;
<a name="l00145"></a>00145         <span class="keywordflow">if</span> (elem-&gt;point(3) &gt; elem-&gt;point(2))
<a name="l00146"></a>00146           xi = -xi_saved;
<a name="l00147"></a>00147       }
<a name="l00148"></a>00148     <span class="comment">// Edge 3</span>
<a name="l00149"></a>00149     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 4*e)
<a name="l00150"></a>00150       {
<a name="l00151"></a>00151         i0 = 0;
<a name="l00152"></a>00152         i1 = i - 3*e - 6;
<a name="l00153"></a>00153         i2 = 0;
<a name="l00154"></a>00154         <span class="keywordflow">if</span> (elem-&gt;point(0) &gt; elem-&gt;point(3))
<a name="l00155"></a>00155           eta = -eta_saved;
<a name="l00156"></a>00156       }
<a name="l00157"></a>00157     <span class="comment">// Edge 4</span>
<a name="l00158"></a>00158     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 5*e)
<a name="l00159"></a>00159       {
<a name="l00160"></a>00160         i0 = 0;
<a name="l00161"></a>00161         i1 = 0;
<a name="l00162"></a>00162         i2 = i - 4*e - 6;
<a name="l00163"></a>00163         <span class="keywordflow">if</span> (elem-&gt;point(0) &gt; elem-&gt;point(4))
<a name="l00164"></a>00164           zeta = -zeta_saved;
<a name="l00165"></a>00165       }                
<a name="l00166"></a>00166     <span class="comment">// Edge 5</span>
<a name="l00167"></a>00167     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 6*e)
<a name="l00168"></a>00168       {
<a name="l00169"></a>00169         i0 = 1;
<a name="l00170"></a>00170         i1 = 0;
<a name="l00171"></a>00171         i2 = i - 5*e - 6;
<a name="l00172"></a>00172         <span class="keywordflow">if</span> (elem-&gt;point(1) &gt; elem-&gt;point(5))
<a name="l00173"></a>00173           zeta = -zeta_saved;
<a name="l00174"></a>00174       }                
<a name="l00175"></a>00175     <span class="comment">// Edge 6</span>
<a name="l00176"></a>00176     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 7*e)
<a name="l00177"></a>00177       {
<a name="l00178"></a>00178         i0 = 1;
<a name="l00179"></a>00179         i1 = 1;
<a name="l00180"></a>00180         i2 = i - 6*e - 6;
<a name="l00181"></a>00181         <span class="keywordflow">if</span> (elem-&gt;point(2) &gt; elem-&gt;point(6))
<a name="l00182"></a>00182           zeta = -zeta_saved;
<a name="l00183"></a>00183       }
<a name="l00184"></a>00184     <span class="comment">// Edge 7</span>
<a name="l00185"></a>00185     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 8*e)
<a name="l00186"></a>00186       {
<a name="l00187"></a>00187         i0 = 0;
<a name="l00188"></a>00188         i1 = 1;
<a name="l00189"></a>00189         i2 = i - 7*e - 6;
<a name="l00190"></a>00190         <span class="keywordflow">if</span> (elem-&gt;point(3) &gt; elem-&gt;point(7))
<a name="l00191"></a>00191           zeta = -zeta_saved;
<a name="l00192"></a>00192       }                
<a name="l00193"></a>00193     <span class="comment">// Edge 8</span>
<a name="l00194"></a>00194     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 9*e)
<a name="l00195"></a>00195       {
<a name="l00196"></a>00196         i0 = i - 8*e - 6;
<a name="l00197"></a>00197         i1 = 0;
<a name="l00198"></a>00198         i2 = 1;
<a name="l00199"></a>00199         <span class="keywordflow">if</span> (elem-&gt;point(4) &gt; elem-&gt;point(5))
<a name="l00200"></a>00200           xi = -xi_saved;
<a name="l00201"></a>00201       }
<a name="l00202"></a>00202     <span class="comment">// Edge 9</span>
<a name="l00203"></a>00203     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 10*e)
<a name="l00204"></a>00204       {
<a name="l00205"></a>00205         i0 = 1;
<a name="l00206"></a>00206         i1 = i - 9*e - 6;
<a name="l00207"></a>00207         i2 = 1;
<a name="l00208"></a>00208         <span class="keywordflow">if</span> (elem-&gt;point(5) &gt; elem-&gt;point(6))
<a name="l00209"></a>00209           eta = -eta_saved;
<a name="l00210"></a>00210       }                
<a name="l00211"></a>00211     <span class="comment">// Edge 10</span>
<a name="l00212"></a>00212     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 11*e)
<a name="l00213"></a>00213       {
<a name="l00214"></a>00214         i0 = i - 10*e - 6;
<a name="l00215"></a>00215         i1 = 1;
<a name="l00216"></a>00216         i2 = 1;
<a name="l00217"></a>00217         <span class="keywordflow">if</span> (elem-&gt;point(7) &gt; elem-&gt;point(6))
<a name="l00218"></a>00218           xi = -xi_saved;
<a name="l00219"></a>00219       }
<a name="l00220"></a>00220     <span class="comment">// Edge 11</span>
<a name="l00221"></a>00221     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e)
<a name="l00222"></a>00222       {
<a name="l00223"></a>00223         i0 = 0;
<a name="l00224"></a>00224         i1 = i - 11*e - 6;
<a name="l00225"></a>00225         i2 = 1;
<a name="l00226"></a>00226         <span class="keywordflow">if</span> (elem-&gt;point(4) &gt; elem-&gt;point(7))
<a name="l00227"></a>00227           eta = -eta_saved;
<a name="l00228"></a>00228       }
<a name="l00229"></a>00229     <span class="comment">// Face 0</span>
<a name="l00230"></a>00230     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + e*e)
<a name="l00231"></a>00231       {
<a name="l00232"></a>00232         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e;
<a name="l00233"></a>00233         i0 = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum] + 2;
<a name="l00234"></a>00234         i1 = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum] + 2;
<a name="l00235"></a>00235         i2 = 0;
<a name="l00236"></a>00236         <span class="keyword">const</span> Point min_point = get_min_point(elem, 1, 2, 0, 3);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238         <span class="keywordflow">if</span> (elem-&gt;point(0) == min_point)
<a name="l00239"></a>00239           <span class="keywordflow">if</span> (elem-&gt;point(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(1), elem-&gt;point(3)))
<a name="l00240"></a>00240             {
<a name="l00241"></a>00241               <span class="comment">// Case 1</span>
<a name="l00242"></a>00242               xi  = xi_saved;
<a name="l00243"></a>00243               eta = eta_saved;
<a name="l00244"></a>00244             }
<a name="l00245"></a>00245           <span class="keywordflow">else</span>
<a name="l00246"></a>00246             {
<a name="l00247"></a>00247               <span class="comment">// Case 2</span>
<a name="l00248"></a>00248               xi  = eta_saved;
<a name="l00249"></a>00249               eta = xi_saved;
<a name="l00250"></a>00250             }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(3) == min_point)
<a name="l00253"></a>00253           <span class="keywordflow">if</span> (elem-&gt;point(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(0), elem-&gt;point(2)))
<a name="l00254"></a>00254             {
<a name="l00255"></a>00255               <span class="comment">// Case 3</span>
<a name="l00256"></a>00256               xi  = -eta_saved;
<a name="l00257"></a>00257               eta = xi_saved;
<a name="l00258"></a>00258             }
<a name="l00259"></a>00259           <span class="keywordflow">else</span>
<a name="l00260"></a>00260             {
<a name="l00261"></a>00261               <span class="comment">// Case 4</span>
<a name="l00262"></a>00262               xi  = xi_saved;
<a name="l00263"></a>00263               eta = -eta_saved;
<a name="l00264"></a>00264             }
<a name="l00265"></a>00265 
<a name="l00266"></a>00266         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(2) == min_point)
<a name="l00267"></a>00267           <span class="keywordflow">if</span> (elem-&gt;point(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(3), elem-&gt;point(1)))
<a name="l00268"></a>00268             {
<a name="l00269"></a>00269               <span class="comment">// Case 5</span>
<a name="l00270"></a>00270               xi  = -xi_saved;
<a name="l00271"></a>00271               eta = -eta_saved;
<a name="l00272"></a>00272             }
<a name="l00273"></a>00273           <span class="keywordflow">else</span>
<a name="l00274"></a>00274             {
<a name="l00275"></a>00275               <span class="comment">// Case 6</span>
<a name="l00276"></a>00276               xi  = -eta_saved;
<a name="l00277"></a>00277               eta = -xi_saved;
<a name="l00278"></a>00278             }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(1) == min_point)
<a name="l00281"></a>00281           {
<a name="l00282"></a>00282             <span class="keywordflow">if</span> (elem-&gt;point(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(2), elem-&gt;point(0)))
<a name="l00283"></a>00283               {
<a name="l00284"></a>00284                 <span class="comment">// Case 7</span>
<a name="l00285"></a>00285                 xi  = eta_saved;
<a name="l00286"></a>00286                 eta = -xi_saved;
<a name="l00287"></a>00287               }
<a name="l00288"></a>00288             <span class="keywordflow">else</span>
<a name="l00289"></a>00289               {
<a name="l00290"></a>00290                 <span class="comment">// Case 8</span>
<a name="l00291"></a>00291                 xi  = -xi_saved;
<a name="l00292"></a>00292                 eta = eta_saved;
<a name="l00293"></a>00293               }
<a name="l00294"></a>00294           }
<a name="l00295"></a>00295       }
<a name="l00296"></a>00296     <span class="comment">// Face 1</span>
<a name="l00297"></a>00297     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 2*e*e)
<a name="l00298"></a>00298       {
<a name="l00299"></a>00299         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - e*e;
<a name="l00300"></a>00300         i0 = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum] + 2;
<a name="l00301"></a>00301         i1 = 0;
<a name="l00302"></a>00302         i2 = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum] + 2;
<a name="l00303"></a>00303         <span class="keyword">const</span> Point min_point = get_min_point(elem, 0, 1, 5, 4);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305         <span class="keywordflow">if</span> (elem-&gt;point(0) == min_point)
<a name="l00306"></a>00306           <span class="keywordflow">if</span> (elem-&gt;point(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(1), elem-&gt;point(4)))
<a name="l00307"></a>00307             {
<a name="l00308"></a>00308               <span class="comment">// Case 1</span>
<a name="l00309"></a>00309               xi   = xi_saved;
<a name="l00310"></a>00310               zeta = zeta_saved;
<a name="l00311"></a>00311             }
<a name="l00312"></a>00312           <span class="keywordflow">else</span>
<a name="l00313"></a>00313             {
<a name="l00314"></a>00314               <span class="comment">// Case 2</span>
<a name="l00315"></a>00315               xi   = zeta_saved;
<a name="l00316"></a>00316               zeta = xi_saved;
<a name="l00317"></a>00317             }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(1) == min_point)
<a name="l00320"></a>00320           <span class="keywordflow">if</span> (elem-&gt;point(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(5), elem-&gt;point(0)))
<a name="l00321"></a>00321             {
<a name="l00322"></a>00322               <span class="comment">// Case 3</span>
<a name="l00323"></a>00323               xi   = zeta_saved;
<a name="l00324"></a>00324               zeta = -xi_saved;
<a name="l00325"></a>00325             }
<a name="l00326"></a>00326           <span class="keywordflow">else</span>
<a name="l00327"></a>00327             {
<a name="l00328"></a>00328               <span class="comment">// Case 4</span>
<a name="l00329"></a>00329               xi   = -xi_saved;
<a name="l00330"></a>00330               zeta = zeta_saved;
<a name="l00331"></a>00331             }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(5) == min_point)
<a name="l00334"></a>00334           <span class="keywordflow">if</span> (elem-&gt;point(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(4), elem-&gt;point(1)))
<a name="l00335"></a>00335             {
<a name="l00336"></a>00336               <span class="comment">// Case 5</span>
<a name="l00337"></a>00337               xi   = -xi_saved;
<a name="l00338"></a>00338               zeta = -zeta_saved;
<a name="l00339"></a>00339             }
<a name="l00340"></a>00340           <span class="keywordflow">else</span>
<a name="l00341"></a>00341             {
<a name="l00342"></a>00342               <span class="comment">// Case 6</span>
<a name="l00343"></a>00343               xi   = -zeta_saved;
<a name="l00344"></a>00344               zeta = -xi_saved;
<a name="l00345"></a>00345             }
<a name="l00346"></a>00346 
<a name="l00347"></a>00347         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(4) == min_point)
<a name="l00348"></a>00348           {
<a name="l00349"></a>00349             <span class="keywordflow">if</span> (elem-&gt;point(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(0), elem-&gt;point(5)))
<a name="l00350"></a>00350               {
<a name="l00351"></a>00351                 <span class="comment">// Case 7</span>
<a name="l00352"></a>00352                 xi   = -xi_saved;
<a name="l00353"></a>00353                 zeta = zeta_saved;
<a name="l00354"></a>00354               }
<a name="l00355"></a>00355             <span class="keywordflow">else</span>
<a name="l00356"></a>00356               {
<a name="l00357"></a>00357                 <span class="comment">// Case 8</span>
<a name="l00358"></a>00358                 xi   = xi_saved;
<a name="l00359"></a>00359                 zeta = -zeta_saved;
<a name="l00360"></a>00360               }
<a name="l00361"></a>00361           }
<a name="l00362"></a>00362       }
<a name="l00363"></a>00363     <span class="comment">// Face 2</span>
<a name="l00364"></a>00364     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 3*e*e)
<a name="l00365"></a>00365       {
<a name="l00366"></a>00366         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 2*e*e;
<a name="l00367"></a>00367         i0 = 1;
<a name="l00368"></a>00368         i1 = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum] + 2;
<a name="l00369"></a>00369         i2 = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum] + 2;
<a name="l00370"></a>00370         <span class="keyword">const</span> Point min_point = get_min_point(elem, 1, 2, 6, 5);
<a name="l00371"></a>00371 
<a name="l00372"></a>00372         <span class="keywordflow">if</span> (elem-&gt;point(1) == min_point)
<a name="l00373"></a>00373           <span class="keywordflow">if</span> (elem-&gt;point(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(2), elem-&gt;point(5)))
<a name="l00374"></a>00374             {
<a name="l00375"></a>00375               <span class="comment">// Case 1</span>
<a name="l00376"></a>00376               eta  = eta_saved;
<a name="l00377"></a>00377               zeta = zeta_saved;
<a name="l00378"></a>00378             }
<a name="l00379"></a>00379           <span class="keywordflow">else</span>
<a name="l00380"></a>00380             {
<a name="l00381"></a>00381               <span class="comment">// Case 2</span>
<a name="l00382"></a>00382               eta  = zeta_saved;
<a name="l00383"></a>00383               zeta = eta_saved;
<a name="l00384"></a>00384             }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(2) == min_point)
<a name="l00387"></a>00387           <span class="keywordflow">if</span> (elem-&gt;point(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(6), elem-&gt;point(1)))
<a name="l00388"></a>00388             {
<a name="l00389"></a>00389               <span class="comment">// Case 3</span>
<a name="l00390"></a>00390               eta  = zeta_saved;
<a name="l00391"></a>00391               zeta = -eta_saved;
<a name="l00392"></a>00392             }
<a name="l00393"></a>00393           <span class="keywordflow">else</span>
<a name="l00394"></a>00394             {
<a name="l00395"></a>00395               <span class="comment">// Case 4</span>
<a name="l00396"></a>00396               eta  = -eta_saved;
<a name="l00397"></a>00397               zeta = zeta_saved;
<a name="l00398"></a>00398             }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(6) == min_point)
<a name="l00401"></a>00401           <span class="keywordflow">if</span> (elem-&gt;point(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(5), elem-&gt;point(2)))
<a name="l00402"></a>00402             {
<a name="l00403"></a>00403               <span class="comment">// Case 5</span>
<a name="l00404"></a>00404               eta  = -eta_saved;
<a name="l00405"></a>00405               zeta = -zeta_saved;
<a name="l00406"></a>00406             }
<a name="l00407"></a>00407           <span class="keywordflow">else</span>
<a name="l00408"></a>00408             {
<a name="l00409"></a>00409               <span class="comment">// Case 6</span>
<a name="l00410"></a>00410               eta  = -zeta_saved;
<a name="l00411"></a>00411               zeta = -eta_saved;
<a name="l00412"></a>00412             }
<a name="l00413"></a>00413 
<a name="l00414"></a>00414         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(5) == min_point)
<a name="l00415"></a>00415           {
<a name="l00416"></a>00416             <span class="keywordflow">if</span> (elem-&gt;point(1) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(1), elem-&gt;point(6)))
<a name="l00417"></a>00417               {
<a name="l00418"></a>00418                 <span class="comment">// Case 7</span>
<a name="l00419"></a>00419                 eta  = -zeta_saved;
<a name="l00420"></a>00420                 zeta = eta_saved;
<a name="l00421"></a>00421               }
<a name="l00422"></a>00422             <span class="keywordflow">else</span>
<a name="l00423"></a>00423               {
<a name="l00424"></a>00424                 <span class="comment">// Case 8</span>
<a name="l00425"></a>00425                 eta   = eta_saved;
<a name="l00426"></a>00426                 zeta = -zeta_saved;
<a name="l00427"></a>00427               }
<a name="l00428"></a>00428           }
<a name="l00429"></a>00429       }
<a name="l00430"></a>00430     <span class="comment">// Face 3</span>
<a name="l00431"></a>00431     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 4*e*e)
<a name="l00432"></a>00432       {
<a name="l00433"></a>00433         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 3*e*e;
<a name="l00434"></a>00434         i0 = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum] + 2;
<a name="l00435"></a>00435         i1 = 1;
<a name="l00436"></a>00436         i2 = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum] + 2;
<a name="l00437"></a>00437         <span class="keyword">const</span> Point min_point = get_min_point(elem, 2, 3, 7, 6);
<a name="l00438"></a>00438 
<a name="l00439"></a>00439         <span class="keywordflow">if</span> (elem-&gt;point(3) == min_point)
<a name="l00440"></a>00440           <span class="keywordflow">if</span> (elem-&gt;point(2) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(2), elem-&gt;point(7)))
<a name="l00441"></a>00441             {
<a name="l00442"></a>00442               <span class="comment">// Case 1</span>
<a name="l00443"></a>00443               xi   = xi_saved;
<a name="l00444"></a>00444               zeta = zeta_saved;
<a name="l00445"></a>00445             }
<a name="l00446"></a>00446           <span class="keywordflow">else</span>
<a name="l00447"></a>00447             {
<a name="l00448"></a>00448               <span class="comment">// Case 2</span>
<a name="l00449"></a>00449               xi   = zeta_saved;
<a name="l00450"></a>00450               zeta = xi_saved;
<a name="l00451"></a>00451             }
<a name="l00452"></a>00452 
<a name="l00453"></a>00453         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(7) == min_point)
<a name="l00454"></a>00454           <span class="keywordflow">if</span> (elem-&gt;point(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(3), elem-&gt;point(6)))
<a name="l00455"></a>00455             {
<a name="l00456"></a>00456               <span class="comment">// Case 3</span>
<a name="l00457"></a>00457               xi   = -zeta_saved;
<a name="l00458"></a>00458               zeta = xi_saved;
<a name="l00459"></a>00459             }
<a name="l00460"></a>00460           <span class="keywordflow">else</span>
<a name="l00461"></a>00461             {
<a name="l00462"></a>00462               <span class="comment">// Case 4</span>
<a name="l00463"></a>00463               xi   = xi_saved;
<a name="l00464"></a>00464               zeta = -zeta_saved;
<a name="l00465"></a>00465             }
<a name="l00466"></a>00466 
<a name="l00467"></a>00467         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(6) == min_point)
<a name="l00468"></a>00468           <span class="keywordflow">if</span> (elem-&gt;point(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(7), elem-&gt;point(2)))
<a name="l00469"></a>00469             {
<a name="l00470"></a>00470               <span class="comment">// Case 5</span>
<a name="l00471"></a>00471               xi   = -xi_saved;
<a name="l00472"></a>00472               zeta = -zeta_saved;
<a name="l00473"></a>00473             }
<a name="l00474"></a>00474           <span class="keywordflow">else</span>
<a name="l00475"></a>00475             {
<a name="l00476"></a>00476               <span class="comment">// Case 6</span>
<a name="l00477"></a>00477               xi   = -zeta_saved;
<a name="l00478"></a>00478               zeta = -xi_saved;
<a name="l00479"></a>00479             }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(2) == min_point)
<a name="l00482"></a>00482           {
<a name="l00483"></a>00483             <span class="keywordflow">if</span> (elem-&gt;point(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(3), elem-&gt;point(6)))
<a name="l00484"></a>00484               {
<a name="l00485"></a>00485                 <span class="comment">// Case 7</span>
<a name="l00486"></a>00486                 xi   = zeta_saved;
<a name="l00487"></a>00487                 zeta = -xi_saved;
<a name="l00488"></a>00488               }
<a name="l00489"></a>00489             <span class="keywordflow">else</span>
<a name="l00490"></a>00490               {
<a name="l00491"></a>00491                 <span class="comment">// Case 8</span>
<a name="l00492"></a>00492                 xi   = -xi_saved;
<a name="l00493"></a>00493               zeta = zeta_saved;
<a name="l00494"></a>00494               }
<a name="l00495"></a>00495           }
<a name="l00496"></a>00496       }
<a name="l00497"></a>00497     <span class="comment">// Face 4</span>
<a name="l00498"></a>00498     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 5*e*e)
<a name="l00499"></a>00499       {
<a name="l00500"></a>00500         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 4*e*e;
<a name="l00501"></a>00501         i0 = 0;
<a name="l00502"></a>00502         i1 = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum] + 2;
<a name="l00503"></a>00503         i2 = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum] + 2;
<a name="l00504"></a>00504         <span class="keyword">const</span> Point min_point = get_min_point(elem, 3, 0, 4, 7);
<a name="l00505"></a>00505 
<a name="l00506"></a>00506         <span class="keywordflow">if</span> (elem-&gt;point(0) == min_point)
<a name="l00507"></a>00507           <span class="keywordflow">if</span> (elem-&gt;point(3) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(3), elem-&gt;point(4)))
<a name="l00508"></a>00508             {
<a name="l00509"></a>00509               <span class="comment">// Case 1</span>
<a name="l00510"></a>00510               eta  = eta_saved;
<a name="l00511"></a>00511               zeta = zeta_saved;
<a name="l00512"></a>00512             }
<a name="l00513"></a>00513           <span class="keywordflow">else</span>
<a name="l00514"></a>00514             {
<a name="l00515"></a>00515               <span class="comment">// Case 2</span>
<a name="l00516"></a>00516               eta  = zeta_saved;
<a name="l00517"></a>00517               zeta = eta_saved;
<a name="l00518"></a>00518             }
<a name="l00519"></a>00519 
<a name="l00520"></a>00520         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(4) == min_point)
<a name="l00521"></a>00521           <span class="keywordflow">if</span> (elem-&gt;point(0) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(0), elem-&gt;point(7)))
<a name="l00522"></a>00522             {
<a name="l00523"></a>00523               <span class="comment">// Case 3</span>
<a name="l00524"></a>00524               eta  = -zeta_saved;
<a name="l00525"></a>00525               zeta = eta_saved;
<a name="l00526"></a>00526             }
<a name="l00527"></a>00527           <span class="keywordflow">else</span>
<a name="l00528"></a>00528             {
<a name="l00529"></a>00529               <span class="comment">// Case 4</span>
<a name="l00530"></a>00530               eta  = eta_saved;
<a name="l00531"></a>00531               zeta = -zeta_saved;
<a name="l00532"></a>00532             }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(7) == min_point)
<a name="l00535"></a>00535           <span class="keywordflow">if</span> (elem-&gt;point(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(4), elem-&gt;point(3)))
<a name="l00536"></a>00536             {
<a name="l00537"></a>00537               <span class="comment">// Case 5</span>
<a name="l00538"></a>00538               eta  = -eta_saved;
<a name="l00539"></a>00539               zeta = -zeta_saved;
<a name="l00540"></a>00540             }
<a name="l00541"></a>00541           <span class="keywordflow">else</span>
<a name="l00542"></a>00542             {
<a name="l00543"></a>00543               <span class="comment">// Case 6</span>
<a name="l00544"></a>00544               eta  = -zeta_saved;
<a name="l00545"></a>00545               zeta = -eta_saved;
<a name="l00546"></a>00546             }
<a name="l00547"></a>00547 
<a name="l00548"></a>00548         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(3) == min_point)
<a name="l00549"></a>00549           {
<a name="l00550"></a>00550             <span class="keywordflow">if</span> (elem-&gt;point(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(7), elem-&gt;point(0)))
<a name="l00551"></a>00551               {
<a name="l00552"></a>00552                 <span class="comment">// Case 7</span>
<a name="l00553"></a>00553                 eta   = zeta_saved;
<a name="l00554"></a>00554                 zeta = -eta_saved;
<a name="l00555"></a>00555               }
<a name="l00556"></a>00556             <span class="keywordflow">else</span>
<a name="l00557"></a>00557               {
<a name="l00558"></a>00558                 <span class="comment">// Case 8</span>
<a name="l00559"></a>00559                 eta  = -eta_saved;
<a name="l00560"></a>00560                 zeta = zeta_saved;
<a name="l00561"></a>00561               }
<a name="l00562"></a>00562           }
<a name="l00563"></a>00563       }
<a name="l00564"></a>00564     <span class="comment">// Face 5</span>
<a name="l00565"></a>00565     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; 8 + 12*e + 6*e*e)
<a name="l00566"></a>00566       {
<a name="l00567"></a>00567         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 5*e*e;
<a name="l00568"></a>00568         i0 = <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[basisnum] + 2;
<a name="l00569"></a>00569         i1 = <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[basisnum] + 2;
<a name="l00570"></a>00570         i2 = 1;
<a name="l00571"></a>00571         <span class="keyword">const</span> Point min_point = get_min_point(elem, 4, 5, 6, 7);
<a name="l00572"></a>00572 
<a name="l00573"></a>00573         <span class="keywordflow">if</span> (elem-&gt;point(4) == min_point)
<a name="l00574"></a>00574           <span class="keywordflow">if</span> (elem-&gt;point(5) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(5), elem-&gt;point(7)))
<a name="l00575"></a>00575             {
<a name="l00576"></a>00576               <span class="comment">// Case 1</span>
<a name="l00577"></a>00577               xi  = xi_saved;
<a name="l00578"></a>00578               eta = eta_saved;
<a name="l00579"></a>00579             }
<a name="l00580"></a>00580           <span class="keywordflow">else</span>
<a name="l00581"></a>00581             {
<a name="l00582"></a>00582               <span class="comment">// Case 2</span>
<a name="l00583"></a>00583               xi  = eta_saved;
<a name="l00584"></a>00584               eta = xi_saved;
<a name="l00585"></a>00585             }
<a name="l00586"></a>00586 
<a name="l00587"></a>00587         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(5) == min_point)
<a name="l00588"></a>00588           <span class="keywordflow">if</span> (elem-&gt;point(6) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(6), elem-&gt;point(4)))
<a name="l00589"></a>00589             {
<a name="l00590"></a>00590               <span class="comment">// Case 3</span>
<a name="l00591"></a>00591               xi  = eta_saved;
<a name="l00592"></a>00592               eta = -xi_saved;
<a name="l00593"></a>00593             }
<a name="l00594"></a>00594           <span class="keywordflow">else</span>
<a name="l00595"></a>00595             {
<a name="l00596"></a>00596               <span class="comment">// Case 4</span>
<a name="l00597"></a>00597               xi  = -xi_saved;
<a name="l00598"></a>00598               eta = eta_saved;
<a name="l00599"></a>00599             }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(6) == min_point)
<a name="l00602"></a>00602           <span class="keywordflow">if</span> (elem-&gt;point(7) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(7), elem-&gt;point(5)))
<a name="l00603"></a>00603             {
<a name="l00604"></a>00604               <span class="comment">// Case 5</span>
<a name="l00605"></a>00605               xi  = -xi_saved;
<a name="l00606"></a>00606               eta = -eta_saved;
<a name="l00607"></a>00607             }
<a name="l00608"></a>00608           <span class="keywordflow">else</span>
<a name="l00609"></a>00609             {
<a name="l00610"></a>00610               <span class="comment">// Case 6</span>
<a name="l00611"></a>00611               xi  = -eta_saved;
<a name="l00612"></a>00612               eta = -xi_saved;
<a name="l00613"></a>00613             }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615         <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;point(7) == min_point)
<a name="l00616"></a>00616           {
<a name="l00617"></a>00617             <span class="keywordflow">if</span> (elem-&gt;point(4) == <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;point(4), elem-&gt;point(6)))
<a name="l00618"></a>00618               {
<a name="l00619"></a>00619                 <span class="comment">// Case 7</span>
<a name="l00620"></a>00620                 xi  = -eta_saved;
<a name="l00621"></a>00621                 eta = xi_saved;
<a name="l00622"></a>00622               }
<a name="l00623"></a>00623             <span class="keywordflow">else</span>
<a name="l00624"></a>00624               {
<a name="l00625"></a>00625                 <span class="comment">// Case 8</span>
<a name="l00626"></a>00626                 xi  = xi_saved;
<a name="l00627"></a>00627                 eta = eta_saved;
<a name="l00628"></a>00628               }
<a name="l00629"></a>00629           }
<a name="l00630"></a>00630       }
<a name="l00631"></a>00631 
<a name="l00632"></a>00632     <span class="comment">// Internal DoFs</span>
<a name="l00633"></a>00633     <span class="keywordflow">else</span> 
<a name="l00634"></a>00634       {
<a name="l00635"></a>00635         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> basisnum = i - 8 - 12*e - 6*e*e;
<a name="l00636"></a>00636         i0 = <a class="code" href="namespacelibMesh.php#a89b107ed0e100e4616f74b44b57d791d">cube_number_column</a>[basisnum] + 2;
<a name="l00637"></a>00637         i1 = <a class="code" href="namespacelibMesh.php#a6a98ddb5341c1a8eb7c5517d89db62d8">cube_number_row</a>[basisnum] + 2;
<a name="l00638"></a>00638         i2 = <a class="code" href="namespacelibMesh.php#a6c2acecfb9abd9fd0cff680913ba1447">cube_number_page</a>[basisnum] + 2;
<a name="l00639"></a>00639       }
<a name="l00640"></a>00640   }
<a name="l00641"></a>00641 } <span class="comment">// end anonymous namespace</span>
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 <span class="keyword">template</span> &lt;&gt;
<a name="l00647"></a><a class="code" href="classlibMesh_1_1FE.php#ad108dab7e514d968a9df848d0a4d084f">00647</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;3,HIERARCHIC&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00648"></a>00648                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00649"></a>00649                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00650"></a>00650                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00651"></a>00651 {
<a name="l00652"></a>00652   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Hierarchic polynomials require the element type\n&quot;</span>
<a name="l00653"></a>00653                 &lt;&lt; <span class="stringliteral">&quot;because edge and face orientation is needed.&quot;</span>
<a name="l00654"></a>00654                 &lt;&lt; std::endl;
<a name="l00655"></a>00655   
<a name="l00656"></a>00656   libmesh_error();
<a name="l00657"></a>00657   <span class="keywordflow">return</span> 0.;
<a name="l00658"></a>00658 }
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 
<a name="l00662"></a>00662 <span class="keyword">template</span> &lt;&gt;
<a name="l00663"></a><a class="code" href="classlibMesh_1_1FE.php#a4fc1d186470a06803ca811687202a2ec">00663</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;3,HIERARCHIC&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00664"></a>00664                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00665"></a>00665                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00666"></a>00666                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00667"></a>00667 {
<a name="l00668"></a>00668 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00669"></a>00669 <span class="preprocessor"></span>  
<a name="l00670"></a>00670   libmesh_assert (elem != NULL);
<a name="l00671"></a>00671   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order+elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00674"></a>00674   
<a name="l00675"></a>00675   <span class="keywordflow">switch</span> (type)
<a name="l00676"></a>00676     {
<a name="l00677"></a>00677     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00678"></a>00678     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00679"></a>00679       libmesh_assert(totalorder &lt; 2);
<a name="l00680"></a>00680     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00681"></a>00681       {
<a name="l00682"></a>00682         libmesh_assert (i&lt;(totalorder+1u)*(totalorder+1u)*(totalorder+1u));
<a name="l00683"></a>00683         
<a name="l00684"></a>00684         <span class="comment">// Compute hex shape functions as a tensor-product</span>
<a name="l00685"></a>00685         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi   = p(0);
<a name="l00686"></a>00686         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta  = p(1);
<a name="l00687"></a>00687         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zeta = p(2);
<a name="l00688"></a>00688         
<a name="l00689"></a>00689         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i0, i1, i2;
<a name="l00690"></a>00690         
<a name="l00691"></a>00691         cube_indices(elem, totalorder, i, xi, eta, zeta, i0, i1, i2);
<a name="l00692"></a>00692 
<a name="l00693"></a>00693         <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i0, xi)*
<a name="l00694"></a>00694                 <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i1, eta)*
<a name="l00695"></a>00695                 <a class="code" href="classlibMesh_1_1FE.php">FE&lt;1,HIERARCHIC&gt;::shape</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>, totalorder, i2, zeta));
<a name="l00696"></a>00696       }
<a name="l00697"></a>00697 
<a name="l00698"></a>00698     <span class="keywordflow">default</span>:
<a name="l00699"></a>00699       libmesh_error();
<a name="l00700"></a>00700     }
<a name="l00701"></a>00701   
<a name="l00702"></a>00702 <span class="preprocessor">#endif</span>
<a name="l00703"></a>00703 <span class="preprocessor"></span>      
<a name="l00704"></a>00704   libmesh_error();
<a name="l00705"></a>00705   <span class="keywordflow">return</span> 0.;
<a name="l00706"></a>00706 }
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 
<a name="l00711"></a>00711 <span class="keyword">template</span> &lt;&gt;
<a name="l00712"></a><a class="code" href="classlibMesh_1_1FE.php#a7d091ac1bba8a306cef3ccbfb6f72140">00712</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;3,HIERARCHIC&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00713"></a>00713                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00714"></a>00714                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00715"></a>00715                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00716"></a>00716                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; )
<a name="l00717"></a>00717 {
<a name="l00718"></a>00718   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Hierarchic polynomials require the element type\n&quot;</span>
<a name="l00719"></a>00719                 &lt;&lt; <span class="stringliteral">&quot;because edge and face orientation is needed.&quot;</span>
<a name="l00720"></a>00720                 &lt;&lt; std::endl;
<a name="l00721"></a>00721   libmesh_error();
<a name="l00722"></a>00722   
<a name="l00723"></a>00723   <span class="keywordflow">return</span> 0.;
<a name="l00724"></a>00724 }
<a name="l00725"></a>00725 
<a name="l00726"></a>00726 
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 <span class="keyword">template</span> &lt;&gt;
<a name="l00729"></a><a class="code" href="classlibMesh_1_1FE.php#a0a9eb45f257a2425d94d381fbd0d4a31">00729</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;3,HIERARCHIC&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00730"></a>00730                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00731"></a>00731                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00732"></a>00732                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00733"></a>00733                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00734"></a>00734 {
<a name="l00735"></a>00735 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00736"></a>00736 <span class="preprocessor"></span>  libmesh_assert (elem != NULL);
<a name="l00737"></a>00737 
<a name="l00738"></a>00738   libmesh_assert (j &lt; 3);
<a name="l00739"></a>00739   
<a name="l00740"></a>00740   <span class="comment">// cheat by using finite difference approximations:</span>
<a name="l00741"></a>00741   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps = 1.e-6;
<a name="l00742"></a>00742   <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp, pm;
<a name="l00743"></a>00743         
<a name="l00744"></a>00744   <span class="keywordflow">switch</span> (j)
<a name="l00745"></a>00745   {
<a name="l00746"></a>00746     <span class="comment">// d()/dxi</span>
<a name="l00747"></a>00747   <span class="keywordflow">case</span> 0:
<a name="l00748"></a>00748     {
<a name="l00749"></a>00749       pp = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0)+eps, p(1), p(2));
<a name="l00750"></a>00750       pm = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0)-eps, p(1), p(2));
<a name="l00751"></a>00751       <span class="keywordflow">break</span>;
<a name="l00752"></a>00752     }
<a name="l00753"></a>00753 
<a name="l00754"></a>00754     <span class="comment">// d()/deta</span>
<a name="l00755"></a>00755   <span class="keywordflow">case</span> 1:
<a name="l00756"></a>00756     {
<a name="l00757"></a>00757       pp = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1)+eps, p(2));
<a name="l00758"></a>00758       pm = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1)-eps, p(2));
<a name="l00759"></a>00759       <span class="keywordflow">break</span>;
<a name="l00760"></a>00760     }
<a name="l00761"></a>00761 
<a name="l00762"></a>00762     <span class="comment">// d()/dzeta</span>
<a name="l00763"></a>00763   <span class="keywordflow">case</span> 2:
<a name="l00764"></a>00764     {
<a name="l00765"></a>00765       pp = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1), p(2)+eps);
<a name="l00766"></a>00766       pm = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1), p(2)-eps);
<a name="l00767"></a>00767       <span class="keywordflow">break</span>;
<a name="l00768"></a>00768     }
<a name="l00769"></a>00769 
<a name="l00770"></a>00770   <span class="keywordflow">default</span>:
<a name="l00771"></a>00771     libmesh_error();
<a name="l00772"></a>00772   }
<a name="l00773"></a>00773 
<a name="l00774"></a>00774   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HIERARCHIC&gt;::shape</a>(elem, order, i, pp) -
<a name="l00775"></a>00775           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HIERARCHIC&gt;::shape</a>(elem, order, i, pm))/2./eps;
<a name="l00776"></a>00776 <span class="preprocessor">#endif</span>
<a name="l00777"></a>00777 <span class="preprocessor"></span>  
<a name="l00778"></a>00778   libmesh_error();
<a name="l00779"></a>00779   <span class="keywordflow">return</span> 0.;
<a name="l00780"></a>00780 }
<a name="l00781"></a>00781 
<a name="l00782"></a>00782 
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 <span class="keyword">template</span> &lt;&gt;
<a name="l00785"></a><a class="code" href="classlibMesh_1_1FE.php#ac7ae987fb0b66131478f206efaaf6ec1">00785</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;3,HIERARCHIC&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00786"></a>00786                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00787"></a>00787                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00788"></a>00788                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00789"></a>00789                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; )
<a name="l00790"></a>00790 {
<a name="l00791"></a>00791   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Hierarchic polynomials require the element type\n&quot;</span>
<a name="l00792"></a>00792                 &lt;&lt; <span class="stringliteral">&quot;because edge and face orientation is needed.&quot;</span>
<a name="l00793"></a>00793                 &lt;&lt; std::endl;
<a name="l00794"></a>00794   libmesh_error();
<a name="l00795"></a>00795   
<a name="l00796"></a>00796   <span class="keywordflow">return</span> 0.;
<a name="l00797"></a>00797 }
<a name="l00798"></a>00798 
<a name="l00799"></a>00799 
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 <span class="keyword">template</span> &lt;&gt;
<a name="l00802"></a><a class="code" href="classlibMesh_1_1FE.php#a4da880b6afe4a93327d9bcfdfa926d7d">00802</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;3,HIERARCHIC&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00803"></a>00803                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00804"></a>00804                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00805"></a>00805                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00806"></a>00806                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00807"></a>00807 {
<a name="l00808"></a>00808   libmesh_assert (elem != NULL);
<a name="l00809"></a>00809 
<a name="l00810"></a>00810   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps = 1.e-6;
<a name="l00811"></a>00811   <a class="code" href="classlibMesh_1_1Point.php">Point</a> pp, pm;
<a name="l00812"></a>00812   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> prevj = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00813"></a>00813 
<a name="l00814"></a>00814   <span class="keywordflow">switch</span> (j)
<a name="l00815"></a>00815   {
<a name="l00816"></a>00816     <span class="comment">//  d^2()/dxi^2</span>
<a name="l00817"></a>00817     <span class="keywordflow">case</span> 0:
<a name="l00818"></a>00818       {
<a name="l00819"></a>00819         pp = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0)+eps, p(1), p(2));
<a name="l00820"></a>00820         pm = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0)-eps, p(1), p(2));
<a name="l00821"></a>00821         prevj = 0;
<a name="l00822"></a>00822         <span class="keywordflow">break</span>;
<a name="l00823"></a>00823       }
<a name="l00824"></a>00824 
<a name="l00825"></a>00825     <span class="comment">//  d^2()/dxideta</span>
<a name="l00826"></a>00826     <span class="keywordflow">case</span> 1:
<a name="l00827"></a>00827       {
<a name="l00828"></a>00828         pp = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1)+eps, p(2));
<a name="l00829"></a>00829         pm = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1)-eps, p(2));
<a name="l00830"></a>00830         prevj = 0;
<a name="l00831"></a>00831         <span class="keywordflow">break</span>;
<a name="l00832"></a>00832       }
<a name="l00833"></a>00833 
<a name="l00834"></a>00834     <span class="comment">//  d^2()/deta^2</span>
<a name="l00835"></a>00835     <span class="keywordflow">case</span> 2:
<a name="l00836"></a>00836       {
<a name="l00837"></a>00837         pp = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1)+eps, p(2));
<a name="l00838"></a>00838         pm = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1)-eps, p(2));
<a name="l00839"></a>00839         prevj = 1;
<a name="l00840"></a>00840         <span class="keywordflow">break</span>;
<a name="l00841"></a>00841       }
<a name="l00842"></a>00842 
<a name="l00843"></a>00843     <span class="comment">//  d^2()/dxidzeta</span>
<a name="l00844"></a>00844     <span class="keywordflow">case</span> 3:
<a name="l00845"></a>00845       {
<a name="l00846"></a>00846         pp = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1), p(2)+eps);
<a name="l00847"></a>00847         pm = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1), p(2)-eps);
<a name="l00848"></a>00848         prevj = 0;
<a name="l00849"></a>00849         <span class="keywordflow">break</span>;
<a name="l00850"></a>00850       }
<a name="l00851"></a>00851 
<a name="l00852"></a>00852     <span class="comment">//  d^2()/detadzeta</span>
<a name="l00853"></a>00853     <span class="keywordflow">case</span> 4:
<a name="l00854"></a>00854       {
<a name="l00855"></a>00855         pp = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1), p(2)+eps);
<a name="l00856"></a>00856         pm = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1), p(2)-eps);
<a name="l00857"></a>00857         prevj = 1;
<a name="l00858"></a>00858         <span class="keywordflow">break</span>;
<a name="l00859"></a>00859       }
<a name="l00860"></a>00860 
<a name="l00861"></a>00861     <span class="comment">//  d^2()/dzeta^2</span>
<a name="l00862"></a>00862     <span class="keywordflow">case</span> 5:
<a name="l00863"></a>00863       {
<a name="l00864"></a>00864         pp = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1), p(2)+eps);
<a name="l00865"></a>00865         pm = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p(0), p(1), p(2)-eps);
<a name="l00866"></a>00866         prevj = 2;
<a name="l00867"></a>00867         <span class="keywordflow">break</span>;
<a name="l00868"></a>00868       }
<a name="l00869"></a>00869     <span class="keywordflow">default</span>:
<a name="l00870"></a>00870       libmesh_error();
<a name="l00871"></a>00871   }
<a name="l00872"></a>00872   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HIERARCHIC&gt;::shape_deriv</a>(elem, order, i, prevj, pp) -
<a name="l00873"></a>00873           <a class="code" href="classlibMesh_1_1FE.php">FE&lt;3,HIERARCHIC&gt;::shape_deriv</a>(elem, order, i, prevj, pm))
<a name="l00874"></a>00874           / 2. / eps;
<a name="l00875"></a>00875 }
<a name="l00876"></a>00876 
<a name="l00877"></a>00877 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
