<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fbfd1e4ea7786050feab5206011c3dac.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_interface.h</div>  </div>
</div>
<div class="contents">
<a href="fe__interface_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_interface.h 4399 2011-04-22 18:32:39Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fe_interface_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fe_interface_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// forward declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>BoundaryInfo;
<a name="l00039"></a>00039 <span class="keyword">class </span>DofConstraints;
<a name="l00040"></a>00040 <span class="keyword">class </span>DofMap;
<a name="l00041"></a>00041 <span class="keyword">class </span>Elem;
<a name="l00042"></a>00042 <span class="keyword">class </span>FEType;
<a name="l00043"></a>00043 <span class="keyword">class </span>FEComputeData;
<a name="l00044"></a>00044 <span class="keyword">class </span>Point;
<a name="l00045"></a>00045 <span class="keyword">class </span>MeshBase;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span><span class="keyword">class </span>PeriodicBoundaries;
<a name="l00049"></a>00049 <span class="keyword">class </span>PointLocatorBase;
<a name="l00050"></a>00050 <span class="preprocessor">#endif</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span>
<a name="l00061"></a>00061 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00062"></a>00062 <span class="comment">// FEInterface class definition</span>
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1FEInterface.php">00064</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEInterface.php">FEInterface</a>
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066 <span class="keyword">private</span>:
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1FEInterface.php#a45aa91adf903fc33399c168501fd6660">FEInterface</a>();
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 <span class="keyword">public</span>:
<a name="l00074"></a>00074   
<a name="l00078"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a3fe87b57269ac49f488d7e51bcd09dce">00078</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a3fe87b57269ac49f488d7e51bcd09dce">~FEInterface</a>() {<span class="keywordflow">return</span>;}
<a name="l00079"></a>00079 
<a name="l00087"></a>00087   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aee67c0b169a2cc43fa03724f5a8e92a5">n_shape_functions</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00088"></a>00088                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00089"></a>00089                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00090"></a>00090 
<a name="l00098"></a>00098   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">n_dofs</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00099"></a>00099                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00100"></a>00100                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00101"></a>00101 
<a name="l00109"></a>00109   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">n_dofs_at_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00110"></a>00110                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00111"></a>00111                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00112"></a>00112                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00113"></a>00113 
<a name="l00121"></a>00121   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">n_dofs_per_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00122"></a>00122                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00123"></a>00123                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00124"></a>00124 
<a name="l00132"></a>00132   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a399583054c223ad3ca20949769cd5adb">dofs_on_side</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00133"></a>00133                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00134"></a>00134                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00135"></a>00135                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00136"></a>00136                            std::vector&lt;unsigned int&gt;&amp; di);
<a name="l00137"></a>00137 
<a name="l00145"></a>00145   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a7391d432c820009be1a10837ccda221b">dofs_on_edge</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span> elem,
<a name="l00146"></a>00146                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00147"></a>00147                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00148"></a>00148                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e,
<a name="l00149"></a>00149                            std::vector&lt;unsigned int&gt;&amp; di);
<a name="l00150"></a>00150   
<a name="l00162"></a>00162   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">nodal_soln</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00163"></a>00163                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00164"></a>00164                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00165"></a>00165                          <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00166"></a>00166                          std::vector&lt;Number&gt;&amp; <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">nodal_soln</a>);
<a name="l00167"></a>00167 
<a name="l00177"></a>00177   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00178"></a>00178                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00179"></a>00179                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00180"></a>00180                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00181"></a>00181                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE,
<a name="l00182"></a>00182                             <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00183"></a>00183 
<a name="l00195"></a>00195   <span class="keyword">static</span> <span class="keywordtype">void</span>  <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00196"></a>00196                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00197"></a>00197                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00198"></a>00198                             <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00199"></a>00199                             std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00200"></a>00200                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE,
<a name="l00201"></a>00201                             <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00202"></a>00202 
<a name="l00211"></a>00211   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a5ed1b078cb472a00bf1b4cdb5cf28be7">on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00212"></a>00212                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00213"></a>00213                                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps=TOLERANCE);
<a name="l00222"></a>00222   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00223"></a>00223                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00224"></a>00224                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00225"></a>00225                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00226"></a>00226                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00227"></a>00227 
<a name="l00236"></a>00236   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00237"></a>00237                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00238"></a>00238                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00239"></a>00239                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00240"></a>00240                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00241"></a>00241 
<a name="l00251"></a>00251   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">compute_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00252"></a>00252                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00253"></a>00253                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00254"></a>00254                            <a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a>&amp; data);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00257"></a>00257 <span class="preprocessor"></span>
<a name="l00262"></a>00262   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#ae54818e25f1c0ccaaf672e08d689867e">compute_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00263"></a>00263                                    <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00264"></a>00264                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00265"></a>00265                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00266"></a>00266 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00267"></a>00267 <span class="preprocessor"></span>
<a name="l00268"></a>00268 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00269"></a>00269 <span class="preprocessor"></span>
<a name="l00274"></a>00274   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a8d80ccb6aee150ce73799b3089416886">compute_periodic_constraints</a> (<a class="code" href="classlibMesh_1_1DofConstraints.php">DofConstraints</a> &amp;constraints,
<a name="l00275"></a>00275                                             <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a> &amp;dof_map,
<a name="l00276"></a>00276                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> &amp;boundaries,
<a name="l00277"></a>00277                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00278"></a>00278                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* point_locator,
<a name="l00279"></a>00279                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00280"></a>00280                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00281"></a>00281 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00282"></a>00282 <span class="preprocessor"></span>
<a name="l00287"></a>00287   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aa931485d398b0b9a877e380444ed959c">max_order</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00288"></a>00288                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>&amp; el_t);
<a name="l00289"></a>00289 
<a name="l00294"></a>00294   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEInterface.php#ac0363b6fc2b8355ff0416ac65b522066">extra_hanging_dofs</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t);
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 <span class="keyword">private</span>:
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00305"></a>00305   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a189c3091bc59b7944d789491ca8d64fb">is_InfFE_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et);
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00309"></a>00309 <span class="preprocessor"></span>
<a name="l00310"></a>00310   <span class="comment">// ------------------------------------------------------------</span>
<a name="l00311"></a>00311   <span class="comment">/*</span>
<a name="l00312"></a>00312 <span class="comment">   * All these private members do the same as their public</span>
<a name="l00313"></a>00313 <span class="comment">   * counterparts, but for infinite elements. This dis-entangles</span>
<a name="l00314"></a>00314 <span class="comment">   * the calls to \p FE and \p InfFE.</span>
<a name="l00315"></a>00315 <span class="comment">   */</span>
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a5a8656a8fdeb0ced3e42d1ab13043529">ifem_n_shape_functions</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00318"></a>00318                                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00319"></a>00319                                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00320"></a>00320 
<a name="l00321"></a>00321   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a10e841ebefa45b4f6c17cebc9839ebdb">ifem_n_dofs</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00322"></a>00322                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00323"></a>00323                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a8bdf783b90a606dad2773ab2c83283c7">ifem_n_dofs_at_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00326"></a>00326                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00327"></a>00327                                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00328"></a>00328                                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00329"></a>00329 
<a name="l00330"></a>00330   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a969b836aacf053da9bc5b0820777e97e">ifem_n_dofs_per_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00331"></a>00331                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00332"></a>00332                                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t);
<a name="l00333"></a>00333   
<a name="l00334"></a>00334   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a164f3558672cdca2a7ffbb8fc5dc145e">ifem_nodal_soln</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00335"></a>00335                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00336"></a>00336                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00337"></a>00337                               <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00338"></a>00338                               std::vector&lt;Number&gt;&amp; <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">nodal_soln</a>);
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FEInterface.php#a66a91a235ebe8eddf6850d652b7a5c63">ifem_inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00341"></a>00341                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00342"></a>00342                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00343"></a>00343                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00344"></a>00344                                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE,
<a name="l00345"></a>00345                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00346"></a>00346   
<a name="l00347"></a>00347   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a66a91a235ebe8eddf6850d652b7a5c63">ifem_inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00348"></a>00348                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00349"></a>00349                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00350"></a>00350                                 <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00351"></a>00351                                 std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00352"></a>00352                                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE,
<a name="l00353"></a>00353                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00354"></a>00354     
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a4c1ba77812b306801d7fd20bce43fee1">ifem_on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00357"></a>00357                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00358"></a>00358                                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps);
<a name="l00359"></a>00359 
<a name="l00360"></a>00360   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEInterface.php#a019d71ee53afff815166a3e86d9c77b0">ifem_shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00361"></a>00361                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00362"></a>00362                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00363"></a>00363                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00364"></a>00364                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEInterface.php#a019d71ee53afff815166a3e86d9c77b0">ifem_shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00367"></a>00367                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00368"></a>00368                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00369"></a>00369                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00370"></a>00370                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a5d36b2f7e038db76767b85901b81e700">ifem_compute_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00373"></a>00373                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00374"></a>00374                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00375"></a>00375                                 <a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a>&amp; data);
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 <span class="preprocessor">#endif</span>
<a name="l00378"></a>00378 <span class="preprocessor"></span>
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 };
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00387"></a>00387 <span class="comment">// FEInterface class inline members</span>
<a name="l00388"></a>00388 <span class="preprocessor">#ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS </span>
<a name="l00389"></a>00389 <span class="preprocessor"></span>
<a name="l00390"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a189c3091bc59b7944d789491ca8d64fb">00390</a> <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a189c3091bc59b7944d789491ca8d64fb">FEInterface::is_InfFE_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>)
<a name="l00391"></a>00391 {
<a name="l00392"></a>00392   <span class="keywordflow">return</span> <span class="keyword">false</span>; 
<a name="l00393"></a>00393 }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 <span class="preprocessor">#else</span>
<a name="l00396"></a>00396 <span class="preprocessor"></span>
<a name="l00397"></a>00397 <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a189c3091bc59b7944d789491ca8d64fb">FEInterface::is_InfFE_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> et)
<a name="l00398"></a>00398 {
<a name="l00399"></a>00399 
<a name="l00400"></a>00400   <span class="keywordflow">switch</span> (et)
<a name="l00401"></a>00401     {
<a name="l00402"></a>00402     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00403"></a>00403     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00404"></a>00404     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00405"></a>00405     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00406"></a>00406     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00407"></a>00407     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00408"></a>00408     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00409"></a>00409     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00410"></a>00410       {
<a name="l00411"></a>00411         <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00412"></a>00412       }
<a name="l00413"></a>00413       
<a name="l00414"></a>00414     <span class="keywordflow">default</span>:
<a name="l00415"></a>00415       { 
<a name="l00416"></a>00416         <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00417"></a>00417       }
<a name="l00418"></a>00418     }
<a name="l00419"></a>00419 }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 <span class="preprocessor">#endif //ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS </span>
<a name="l00422"></a>00422 <span class="preprocessor"></span>
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 } <span class="comment">// namespace libMesh</span>
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 <span class="preprocessor">#endif // ifndef __fe_interface_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
