<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_interface_inf_fe.C</div>  </div>
</div>
<div class="contents">
<a href="fe__interface__inf__fe_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_interface_inf_fe.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">//------------------------------------------------------------</span>
<a name="l00037"></a>00037 <span class="comment">//FEInterface class members handling calls to InfFE</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a5a8656a8fdeb0ced3e42d1ab13043529">00041</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a5a8656a8fdeb0ced3e42d1ab13043529">FEInterface::ifem_n_shape_functions</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00042"></a>00042                                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00043"></a>00043                                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00044"></a>00044 { 
<a name="l00045"></a>00045   <span class="keywordflow">switch</span> (dim)
<a name="l00046"></a>00046     {
<a name="l00047"></a>00047       <span class="comment">// 1D</span>
<a name="l00048"></a>00048     <span class="keywordflow">case</span> 1:
<a name="l00049"></a>00049       <span class="comment">/* </span>
<a name="l00050"></a>00050 <span class="comment">       * Since InfFE&lt;Dim,T_radial,T_map&gt;::n_shape_functions(...)</span>
<a name="l00051"></a>00051 <span class="comment">       * is actually independent of T_radial and T_map, we can use</span>
<a name="l00052"></a>00052 <span class="comment">       * just any T_radial and T_map</span>
<a name="l00053"></a>00053 <span class="comment">       */</span>
<a name="l00054"></a>00054       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aee67c0b169a2cc43fa03724f5a8e92a5">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::n_shape_functions</a>(fe_t, t);
<a name="l00055"></a>00055       
<a name="l00056"></a>00056       <span class="comment">// 2D</span>
<a name="l00057"></a>00057     <span class="keywordflow">case</span> 2:
<a name="l00058"></a>00058       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aee67c0b169a2cc43fa03724f5a8e92a5">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::n_shape_functions</a>(fe_t, t);
<a name="l00059"></a>00059       
<a name="l00060"></a>00060       <span class="comment">// 3D</span>
<a name="l00061"></a>00061     <span class="keywordflow">case</span> 3:
<a name="l00062"></a>00062       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aee67c0b169a2cc43fa03724f5a8e92a5">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::n_shape_functions</a>(fe_t, t);
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keywordflow">default</span>:
<a name="l00065"></a>00065       libmesh_error();
<a name="l00066"></a>00066     }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   
<a name="l00069"></a>00069   libmesh_error();
<a name="l00070"></a>00070   <span class="keywordflow">return</span> 0;
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a10e841ebefa45b4f6c17cebc9839ebdb">00077</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a10e841ebefa45b4f6c17cebc9839ebdb">FEInterface::ifem_n_dofs</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00078"></a>00078                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00079"></a>00079                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00080"></a>00080 {
<a name="l00081"></a>00081   <span class="keywordflow">switch</span> (dim)
<a name="l00082"></a>00082     {
<a name="l00083"></a>00083       <span class="comment">// 1D</span>
<a name="l00084"></a>00084     <span class="keywordflow">case</span> 1:
<a name="l00085"></a>00085       <span class="comment">/* </span>
<a name="l00086"></a>00086 <span class="comment">       * Since InfFE&lt;Dim,T_radial,T_map&gt;::n_dofs(...)</span>
<a name="l00087"></a>00087 <span class="comment">       * is actually independent of T_radial and T_map, we can use</span>
<a name="l00088"></a>00088 <span class="comment">       * just any T_radial and T_map</span>
<a name="l00089"></a>00089 <span class="comment">       */</span>
<a name="l00090"></a>00090       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::n_dofs</a>(fe_t, t);
<a name="l00091"></a>00091       
<a name="l00092"></a>00092       <span class="comment">// 2D</span>
<a name="l00093"></a>00093     <span class="keywordflow">case</span> 2:
<a name="l00094"></a>00094       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::n_dofs</a>(fe_t, t);
<a name="l00095"></a>00095       
<a name="l00096"></a>00096       <span class="comment">// 3D</span>
<a name="l00097"></a>00097     <span class="keywordflow">case</span> 3:
<a name="l00098"></a>00098       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::n_dofs</a>(fe_t, t);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100     <span class="keywordflow">default</span>:
<a name="l00101"></a>00101       libmesh_error();
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   libmesh_error();
<a name="l00106"></a>00106   <span class="keywordflow">return</span> 0;
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109                 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 
<a name="l00112"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a8bdf783b90a606dad2773ab2c83283c7">00112</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a8bdf783b90a606dad2773ab2c83283c7">FEInterface::ifem_n_dofs_at_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00113"></a>00113                                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00114"></a>00114                                               <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00115"></a>00115                                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   <span class="keywordflow">switch</span> (dim)
<a name="l00118"></a>00118     {
<a name="l00119"></a>00119       <span class="comment">// 1D</span>
<a name="l00120"></a>00120     <span class="keywordflow">case</span> 1:
<a name="l00121"></a>00121       <span class="comment">/* </span>
<a name="l00122"></a>00122 <span class="comment">       * Since InfFE&lt;Dim,T_radial,T_map&gt;::n_dofs_at_node(...)</span>
<a name="l00123"></a>00123 <span class="comment">       * is actually independent of T_radial and T_map, we can use</span>
<a name="l00124"></a>00124 <span class="comment">       * just any T_radial and T_map</span>
<a name="l00125"></a>00125 <span class="comment">       */</span>
<a name="l00126"></a>00126       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::n_dofs_at_node</a>(fe_t, t, n);
<a name="l00127"></a>00127       
<a name="l00128"></a>00128       <span class="comment">// 2D</span>
<a name="l00129"></a>00129     <span class="keywordflow">case</span> 2:
<a name="l00130"></a>00130       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::n_dofs_at_node</a>(fe_t, t, n);
<a name="l00131"></a>00131       
<a name="l00132"></a>00132       <span class="comment">// 3D</span>
<a name="l00133"></a>00133     <span class="keywordflow">case</span> 3:
<a name="l00134"></a>00134       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::n_dofs_at_node</a>(fe_t, t, n);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136     <span class="keywordflow">default</span>:
<a name="l00137"></a>00137       libmesh_error();
<a name="l00138"></a>00138     }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   
<a name="l00141"></a>00141   libmesh_error();
<a name="l00142"></a>00142   <span class="keywordflow">return</span> 0;
<a name="l00143"></a>00143 }
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a969b836aacf053da9bc5b0820777e97e">00149</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a969b836aacf053da9bc5b0820777e97e">FEInterface::ifem_n_dofs_per_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00150"></a>00150                                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00151"></a>00151                                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00152"></a>00152 {
<a name="l00153"></a>00153   <span class="keywordflow">switch</span> (dim)
<a name="l00154"></a>00154     {
<a name="l00155"></a>00155       <span class="comment">// 1D</span>
<a name="l00156"></a>00156     <span class="keywordflow">case</span> 1:
<a name="l00157"></a>00157       <span class="comment">/* </span>
<a name="l00158"></a>00158 <span class="comment">       * Since InfFE&lt;Dim,T_radial,T_map&gt;::n_dofs(...)</span>
<a name="l00159"></a>00159 <span class="comment">       * is actually independent of T_radial and T_map, we can use</span>
<a name="l00160"></a>00160 <span class="comment">       * just any T_radial and T_map</span>
<a name="l00161"></a>00161 <span class="comment">       */</span>
<a name="l00162"></a>00162       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::n_dofs_per_elem</a>(fe_t, t);
<a name="l00163"></a>00163       
<a name="l00164"></a>00164       <span class="comment">// 2D</span>
<a name="l00165"></a>00165     <span class="keywordflow">case</span> 2:
<a name="l00166"></a>00166       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::n_dofs_per_elem</a>(fe_t, t);
<a name="l00167"></a>00167       
<a name="l00168"></a>00168       <span class="comment">// 3D</span>
<a name="l00169"></a>00169     <span class="keywordflow">case</span> 3:
<a name="l00170"></a>00170       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::n_dofs_per_elem</a>(fe_t, t);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172     <span class="keywordflow">default</span>:
<a name="l00173"></a>00173       libmesh_error();
<a name="l00174"></a>00174     }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   
<a name="l00177"></a>00177   libmesh_error();
<a name="l00178"></a>00178   <span class="keywordflow">return</span> 0;
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a164f3558672cdca2a7ffbb8fc5dc145e">00184</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a164f3558672cdca2a7ffbb8fc5dc145e">FEInterface::ifem_nodal_soln</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00185"></a>00185                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00186"></a>00186                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00187"></a>00187                                   <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00188"></a>00188                                   std::vector&lt;Number&gt;&amp; nodal_soln)
<a name="l00189"></a>00189 {
<a name="l00190"></a>00190   <span class="keywordflow">switch</span> (dim)
<a name="l00191"></a>00191     {
<a name="l00192"></a>00192 
<a name="l00193"></a>00193       <span class="comment">// 1D</span>
<a name="l00194"></a>00194     <span class="keywordflow">case</span> 1:
<a name="l00195"></a>00195       {
<a name="l00196"></a>00196         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00197"></a>00197           {
<a name="l00198"></a>00198           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00199"></a>00199             {
<a name="l00200"></a>00200               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: INFINTE_MAP is not a valid shape family for radial approximation.&quot;</span> &lt;&lt; std::endl;
<a name="l00201"></a>00201               libmesh_error();
<a name="l00202"></a>00202               <span class="keywordflow">break</span>;
<a name="l00203"></a>00203             }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00206"></a>00206             {
<a name="l00207"></a>00207               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00208"></a>00208                 {
<a name="l00209"></a>00209                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00210"></a>00210                     {
<a name="l00211"></a>00211                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00212"></a>00212                       <span class="keywordflow">break</span>;
<a name="l00213"></a>00213                     }
<a name="l00214"></a>00214                   <span class="keywordflow">default</span>:
<a name="l00215"></a>00215                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;
<a name="l00216"></a>00216                     libmesh_error();
<a name="l00217"></a>00217                 }
<a name="l00218"></a>00218               <span class="keywordflow">break</span>;
<a name="l00219"></a>00219             }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00222"></a>00222             {
<a name="l00223"></a>00223               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00224"></a>00224                 {
<a name="l00225"></a>00225                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00226"></a>00226                     {
<a name="l00227"></a>00227                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;1,JACOBI_30_00,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00228"></a>00228                       <span class="keywordflow">break</span>;
<a name="l00229"></a>00229                     }
<a name="l00230"></a>00230                   <span class="keywordflow">default</span>:
<a name="l00231"></a>00231                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;
<a name="l00232"></a>00232                     libmesh_error();
<a name="l00233"></a>00233                 }
<a name="l00234"></a>00234               <span class="keywordflow">break</span>;
<a name="l00235"></a>00235             }
<a name="l00236"></a>00236 
<a name="l00237"></a>00237           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:
<a name="l00238"></a>00238             {
<a name="l00239"></a>00239               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00240"></a>00240                 {
<a name="l00241"></a>00241                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00242"></a>00242                     {
<a name="l00243"></a>00243                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;1,LEGENDRE,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00244"></a>00244                       <span class="keywordflow">break</span>;
<a name="l00245"></a>00245                     }
<a name="l00246"></a>00246                   <span class="keywordflow">default</span>:
<a name="l00247"></a>00247                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;
<a name="l00248"></a>00248                     libmesh_error();
<a name="l00249"></a>00249                 }
<a name="l00250"></a>00250               <span class="keywordflow">break</span>;
<a name="l00251"></a>00251             }
<a name="l00252"></a>00252 
<a name="l00253"></a>00253           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00254"></a>00254             {
<a name="l00255"></a>00255               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00256"></a>00256                 {
<a name="l00257"></a>00257                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00258"></a>00258                     {
<a name="l00259"></a>00259                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;1,LAGRANGE,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00260"></a>00260                       <span class="keywordflow">break</span>;
<a name="l00261"></a>00261                     }
<a name="l00262"></a>00262                   <span class="keywordflow">default</span>:
<a name="l00263"></a>00263                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;
<a name="l00264"></a>00264                     libmesh_error();
<a name="l00265"></a>00265                 }
<a name="l00266"></a>00266               <span class="keywordflow">break</span>;
<a name="l00267"></a>00267             }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270             
<a name="l00271"></a>00271           <span class="keywordflow">default</span>:
<a name="l00272"></a>00272             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.radial_family= &quot;</span> &lt;&lt; fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt;&lt; std::endl;
<a name="l00273"></a>00273             libmesh_error();
<a name="l00274"></a>00274             <span class="keywordflow">break</span>;
<a name="l00275"></a>00275           }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277         <span class="keywordflow">break</span>;
<a name="l00278"></a>00278       }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280       
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283       <span class="comment">// 2D</span>
<a name="l00284"></a>00284     <span class="keywordflow">case</span> 2:
<a name="l00285"></a>00285       {
<a name="l00286"></a>00286         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00287"></a>00287           {
<a name="l00288"></a>00288           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00289"></a>00289             {
<a name="l00290"></a>00290               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: INFINTE_MAP is not a valid shape family for radial approximation.&quot;</span> &lt;&lt; std::endl;
<a name="l00291"></a>00291               libmesh_error();
<a name="l00292"></a>00292               <span class="keywordflow">break</span>;
<a name="l00293"></a>00293             }
<a name="l00294"></a>00294 
<a name="l00295"></a>00295           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00296"></a>00296             {
<a name="l00297"></a>00297               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00298"></a>00298                 {
<a name="l00299"></a>00299                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00300"></a>00300                     {
<a name="l00301"></a>00301                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00302"></a>00302                       <span class="keywordflow">break</span>;
<a name="l00303"></a>00303                     }
<a name="l00304"></a>00304                   <span class="keywordflow">default</span>:
<a name="l00305"></a>00305                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;                             
<a name="l00306"></a>00306                     libmesh_error();
<a name="l00307"></a>00307                 }
<a name="l00308"></a>00308               <span class="keywordflow">break</span>;
<a name="l00309"></a>00309             }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00312"></a>00312             {
<a name="l00313"></a>00313               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00314"></a>00314                 {
<a name="l00315"></a>00315                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00316"></a>00316                     {
<a name="l00317"></a>00317                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;2,JACOBI_30_00,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00318"></a>00318                       <span class="keywordflow">break</span>;
<a name="l00319"></a>00319                     }
<a name="l00320"></a>00320                   <span class="keywordflow">default</span>:
<a name="l00321"></a>00321                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;                             
<a name="l00322"></a>00322                     libmesh_error();
<a name="l00323"></a>00323                 }
<a name="l00324"></a>00324               <span class="keywordflow">break</span>;
<a name="l00325"></a>00325             }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:
<a name="l00328"></a>00328             {
<a name="l00329"></a>00329               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00330"></a>00330                 {
<a name="l00331"></a>00331                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00332"></a>00332                     {
<a name="l00333"></a>00333                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;2,LEGENDRE,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00334"></a>00334                       <span class="keywordflow">break</span>;
<a name="l00335"></a>00335                     }
<a name="l00336"></a>00336                   <span class="keywordflow">default</span>:
<a name="l00337"></a>00337                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;                             
<a name="l00338"></a>00338                     libmesh_error();
<a name="l00339"></a>00339                 }
<a name="l00340"></a>00340               <span class="keywordflow">break</span>;
<a name="l00341"></a>00341             }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00344"></a>00344             {
<a name="l00345"></a>00345               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00346"></a>00346                 {
<a name="l00347"></a>00347                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00348"></a>00348                     {
<a name="l00349"></a>00349                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;2,LAGRANGE,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00350"></a>00350                       <span class="keywordflow">break</span>;
<a name="l00351"></a>00351                     }
<a name="l00352"></a>00352                   <span class="keywordflow">default</span>:
<a name="l00353"></a>00353                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;                             
<a name="l00354"></a>00354                     libmesh_error();
<a name="l00355"></a>00355                 }
<a name="l00356"></a>00356               <span class="keywordflow">break</span>;
<a name="l00357"></a>00357             }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360             
<a name="l00361"></a>00361           <span class="keywordflow">default</span>:
<a name="l00362"></a>00362             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.radial_family= &quot;</span> &lt;&lt; fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt;&lt; std::endl;
<a name="l00363"></a>00363             libmesh_error();
<a name="l00364"></a>00364             <span class="keywordflow">break</span>;
<a name="l00365"></a>00365           }
<a name="l00366"></a>00366 
<a name="l00367"></a>00367         <span class="keywordflow">break</span>;
<a name="l00368"></a>00368       }
<a name="l00369"></a>00369 
<a name="l00370"></a>00370       
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373       <span class="comment">// 3D</span>
<a name="l00374"></a>00374     <span class="keywordflow">case</span> 3:
<a name="l00375"></a>00375       {
<a name="l00376"></a>00376         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00377"></a>00377           {
<a name="l00378"></a>00378           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00379"></a>00379             {
<a name="l00380"></a>00380               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: INFINTE_MAP is not a valid shape family for radial approximation.&quot;</span> &lt;&lt; std::endl;
<a name="l00381"></a>00381               libmesh_error();
<a name="l00382"></a>00382               <span class="keywordflow">break</span>;
<a name="l00383"></a>00383             }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00386"></a>00386             {
<a name="l00387"></a>00387               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00388"></a>00388                 {
<a name="l00389"></a>00389                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00390"></a>00390                     {
<a name="l00391"></a>00391                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00392"></a>00392                       <span class="keywordflow">break</span>;
<a name="l00393"></a>00393                     }
<a name="l00394"></a>00394                   <span class="keywordflow">default</span>:
<a name="l00395"></a>00395                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;                             
<a name="l00396"></a>00396                     libmesh_error();
<a name="l00397"></a>00397                 }
<a name="l00398"></a>00398               <span class="keywordflow">break</span>;
<a name="l00399"></a>00399             }
<a name="l00400"></a>00400 
<a name="l00401"></a>00401           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00402"></a>00402             {
<a name="l00403"></a>00403               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00404"></a>00404                 {
<a name="l00405"></a>00405                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00406"></a>00406                     {
<a name="l00407"></a>00407                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;3,JACOBI_30_00,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00408"></a>00408                       <span class="keywordflow">break</span>;
<a name="l00409"></a>00409                     }
<a name="l00410"></a>00410                   <span class="keywordflow">default</span>:
<a name="l00411"></a>00411                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;                             
<a name="l00412"></a>00412                     libmesh_error();
<a name="l00413"></a>00413                 }
<a name="l00414"></a>00414               <span class="keywordflow">break</span>;
<a name="l00415"></a>00415             }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:
<a name="l00418"></a>00418             {
<a name="l00419"></a>00419               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00420"></a>00420                 {
<a name="l00421"></a>00421                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00422"></a>00422                     {
<a name="l00423"></a>00423                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;3,LEGENDRE,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00424"></a>00424                       <span class="keywordflow">break</span>;
<a name="l00425"></a>00425                     }
<a name="l00426"></a>00426                   <span class="keywordflow">default</span>:
<a name="l00427"></a>00427                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;                     
<a name="l00428"></a>00428                     libmesh_error();
<a name="l00429"></a>00429                 }
<a name="l00430"></a>00430               <span class="keywordflow">break</span>;
<a name="l00431"></a>00431             }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00434"></a>00434             {
<a name="l00435"></a>00435               <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00436"></a>00436                 {
<a name="l00437"></a>00437                   <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00438"></a>00438                     {
<a name="l00439"></a>00439                       <a class="code" href="classlibMesh_1_1FEInterface.php#ade4880e1fdaae814a22e1e1e5aece846">InfFE&lt;3,LAGRANGE,CARTESIAN&gt;::nodal_soln</a>(fe_t, elem, elem_soln, nodal_soln);
<a name="l00440"></a>00440                       <span class="keywordflow">break</span>;
<a name="l00441"></a>00441                     }
<a name="l00442"></a>00442                   <span class="keywordflow">default</span>:
<a name="l00443"></a>00443                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical &amp; Ellipsoidal IFEMs not implemented.&quot;</span> &lt;&lt; std::endl;                             
<a name="l00444"></a>00444                     libmesh_error();
<a name="l00445"></a>00445                 }
<a name="l00446"></a>00446               <span class="keywordflow">break</span>;
<a name="l00447"></a>00447             }
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450             
<a name="l00451"></a>00451           <span class="keywordflow">default</span>:
<a name="l00452"></a>00452             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad FEType.radial_family= &quot;</span> &lt;&lt; fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt;&lt; std::endl;
<a name="l00453"></a>00453             libmesh_error();
<a name="l00454"></a>00454             <span class="keywordflow">break</span>;
<a name="l00455"></a>00455           }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457         <span class="keywordflow">break</span>;
<a name="l00458"></a>00458       }
<a name="l00459"></a>00459 
<a name="l00460"></a>00460     <span class="keywordflow">default</span>:
<a name="l00461"></a>00461       libmesh_error();
<a name="l00462"></a>00462     }
<a name="l00463"></a>00463   <span class="keywordflow">return</span>;
<a name="l00464"></a>00464 }
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 
<a name="l00467"></a>00467 
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 
<a name="l00472"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a66a91a235ebe8eddf6850d652b7a5c63">00472</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FEInterface.php#a66a91a235ebe8eddf6850d652b7a5c63">FEInterface::ifem_inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00473"></a>00473                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00474"></a>00474                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00475"></a>00475                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00476"></a>00476                                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance,
<a name="l00477"></a>00477                                      <span class="keyword">const</span> <span class="keywordtype">bool</span> secure)
<a name="l00478"></a>00478 {
<a name="l00479"></a>00479   <span class="keywordflow">switch</span> (dim)
<a name="l00480"></a>00480     {
<a name="l00481"></a>00481       <span class="comment">// 1D</span>
<a name="l00482"></a>00482     <span class="keywordflow">case</span> 1:
<a name="l00483"></a>00483       {
<a name="l00484"></a>00484         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00485"></a>00485           {
<a name="l00486"></a>00486           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00487"></a>00487             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l00488"></a>00488 
<a name="l00489"></a>00489           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a43327a8402d2f1174b5d029b35ab2848">SPHERICAL</a>:
<a name="l00490"></a>00490           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a7d49a738860410cd543fb5d64202cd3b">ELLIPSOIDAL</a>:
<a name="l00491"></a>00491             {
<a name="l00492"></a>00492               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical and Ellipsoidal IFEMs not (yet) &quot;</span> &lt;&lt; std::endl
<a name="l00493"></a>00493                             &lt;&lt; <span class="stringliteral">&quot;implemented.&quot;</span> &lt;&lt; std::endl;
<a name="l00494"></a>00494               libmesh_error();
<a name="l00495"></a>00495             }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 <span class="comment">/*</span>
<a name="l00498"></a>00498 <span class="comment">          case SPHERICAL:</span>
<a name="l00499"></a>00499 <span class="comment">            return InfFE&lt;1,JACOBI_20_00,SPHERICAL&gt;::inverse_map(elem, p, tolerance);</span>
<a name="l00500"></a>00500 <span class="comment"></span>
<a name="l00501"></a>00501 <span class="comment">          case ELLIPSOIDAL:</span>
<a name="l00502"></a>00502 <span class="comment">            return InfFE&lt;1,JACOBI_20_00,ELLIPSOIDAL&gt;::inverse_map(elem, p, tolerance);</span>
<a name="l00503"></a>00503 <span class="comment">*/</span>
<a name="l00504"></a>00504 
<a name="l00505"></a>00505           <span class="keywordflow">default</span>:
<a name="l00506"></a>00506             libmesh_error();
<a name="l00507"></a>00507           }
<a name="l00508"></a>00508       }
<a name="l00509"></a>00509 
<a name="l00510"></a>00510       
<a name="l00511"></a>00511       <span class="comment">// 2D</span>
<a name="l00512"></a>00512     <span class="keywordflow">case</span> 2:
<a name="l00513"></a>00513       {
<a name="l00514"></a>00514         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00515"></a>00515           {
<a name="l00516"></a>00516           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00517"></a>00517             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l00518"></a>00518 
<a name="l00519"></a>00519           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a43327a8402d2f1174b5d029b35ab2848">SPHERICAL</a>:
<a name="l00520"></a>00520           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a7d49a738860410cd543fb5d64202cd3b">ELLIPSOIDAL</a>:
<a name="l00521"></a>00521             {
<a name="l00522"></a>00522               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical and Ellipsoidal IFEMs not (yet) &quot;</span> &lt;&lt; std::endl
<a name="l00523"></a>00523                             &lt;&lt; <span class="stringliteral">&quot;implemented.&quot;</span> &lt;&lt; std::endl;
<a name="l00524"></a>00524               libmesh_error();
<a name="l00525"></a>00525             }
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 <span class="comment">/*</span>
<a name="l00528"></a>00528 <span class="comment">          case SPHERICAL:</span>
<a name="l00529"></a>00529 <span class="comment">            return InfFE&lt;2,JACOBI_20_00,SPHERICAL&gt;::inverse_map(elem, p, tolerance);</span>
<a name="l00530"></a>00530 <span class="comment"></span>
<a name="l00531"></a>00531 <span class="comment">          case ELLIPSOIDAL:</span>
<a name="l00532"></a>00532 <span class="comment">            return InfFE&lt;2,JACOBI_20_00,ELLIPSOIDAL&gt;::inverse_map(elem, p, tolerance);</span>
<a name="l00533"></a>00533 <span class="comment">*/</span>
<a name="l00534"></a>00534 
<a name="l00535"></a>00535           <span class="keywordflow">default</span>:
<a name="l00536"></a>00536             libmesh_error();
<a name="l00537"></a>00537           }
<a name="l00538"></a>00538 
<a name="l00539"></a>00539       }
<a name="l00540"></a>00540 
<a name="l00541"></a>00541       
<a name="l00542"></a>00542       <span class="comment">// 3D</span>
<a name="l00543"></a>00543     <span class="keywordflow">case</span> 3:
<a name="l00544"></a>00544       {
<a name="l00545"></a>00545         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00546"></a>00546           {
<a name="l00547"></a>00547           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00548"></a>00548             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::inverse_map</a>(elem, p, tolerance, secure);
<a name="l00549"></a>00549 
<a name="l00550"></a>00550           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a43327a8402d2f1174b5d029b35ab2848">SPHERICAL</a>:
<a name="l00551"></a>00551           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a7d49a738860410cd543fb5d64202cd3b">ELLIPSOIDAL</a>:
<a name="l00552"></a>00552             {
<a name="l00553"></a>00553               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Spherical and Ellipsoidal IFEMs not (yet) &quot;</span> &lt;&lt; std::endl
<a name="l00554"></a>00554                             &lt;&lt; <span class="stringliteral">&quot;implemented.&quot;</span> &lt;&lt; std::endl;
<a name="l00555"></a>00555               libmesh_error();
<a name="l00556"></a>00556             }
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 <span class="comment">/*</span>
<a name="l00559"></a>00559 <span class="comment">          case SPHERICAL:</span>
<a name="l00560"></a>00560 <span class="comment">            return InfFE&lt;3,JACOBI_20_00,SPHERICAL&gt;::inverse_map(elem, p, tolerance);</span>
<a name="l00561"></a>00561 <span class="comment"></span>
<a name="l00562"></a>00562 <span class="comment">          case ELLIPSOIDAL:</span>
<a name="l00563"></a>00563 <span class="comment">            return InfFE&lt;3,JACOBI_20_00,ELLIPSOIDAL&gt;::inverse_map(elem, p, tolerance);</span>
<a name="l00564"></a>00564 <span class="comment">*/</span>
<a name="l00565"></a>00565 
<a name="l00566"></a>00566           <span class="keywordflow">default</span>:
<a name="l00567"></a>00567             libmesh_error();
<a name="l00568"></a>00568           }
<a name="l00569"></a>00569 
<a name="l00570"></a>00570       }
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573     <span class="keywordflow">default</span>:
<a name="l00574"></a>00574       libmesh_error();
<a name="l00575"></a>00575     }
<a name="l00576"></a>00576 
<a name="l00577"></a>00577   
<a name="l00578"></a>00578   libmesh_error();
<a name="l00579"></a>00579   <a class="code" href="classlibMesh_1_1Point.php">Point</a> pt;
<a name="l00580"></a>00580   <span class="keywordflow">return</span> pt;
<a name="l00581"></a>00581 }
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 
<a name="l00585"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a6cb87247138cd278af32deda16432784">00585</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a66a91a235ebe8eddf6850d652b7a5c63">FEInterface::ifem_inverse_map</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00586"></a>00586                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00587"></a>00587                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00588"></a>00588                                     <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00589"></a>00589                                     std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00590"></a>00590                                     <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance,
<a name="l00591"></a>00591                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> secure)
<a name="l00592"></a>00592 {
<a name="l00593"></a>00593   <span class="keywordflow">switch</span> (dim)
<a name="l00594"></a>00594     {
<a name="l00595"></a>00595       <span class="comment">// 1D</span>
<a name="l00596"></a>00596     <span class="keywordflow">case</span> 1:
<a name="l00597"></a>00597       {
<a name="l00598"></a>00598         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00599"></a>00599           {
<a name="l00600"></a>00600           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00601"></a>00601             <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l00602"></a>00602             <span class="keywordflow">return</span>;
<a name="l00603"></a>00603 
<a name="l00604"></a>00604           <span class="keywordflow">default</span>:
<a name="l00605"></a>00605             libmesh_error();
<a name="l00606"></a>00606           }
<a name="l00607"></a>00607       }
<a name="l00608"></a>00608 
<a name="l00609"></a>00609       
<a name="l00610"></a>00610       <span class="comment">// 2D</span>
<a name="l00611"></a>00611     <span class="keywordflow">case</span> 2:
<a name="l00612"></a>00612       {
<a name="l00613"></a>00613         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00614"></a>00614           {
<a name="l00615"></a>00615           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00616"></a>00616            <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l00617"></a>00617            <span class="keywordflow">return</span>;
<a name="l00618"></a>00618 
<a name="l00619"></a>00619           <span class="keywordflow">default</span>:
<a name="l00620"></a>00620             libmesh_error();
<a name="l00621"></a>00621           }
<a name="l00622"></a>00622 
<a name="l00623"></a>00623       }
<a name="l00624"></a>00624 
<a name="l00625"></a>00625       
<a name="l00626"></a>00626       <span class="comment">// 3D</span>
<a name="l00627"></a>00627     <span class="keywordflow">case</span> 3:
<a name="l00628"></a>00628       {
<a name="l00629"></a>00629         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00630"></a>00630           {
<a name="l00631"></a>00631           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>:
<a name="l00632"></a>00632            <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::inverse_map</a>(elem, physical_points, reference_points, tolerance, secure);
<a name="l00633"></a>00633            <span class="keywordflow">return</span>;
<a name="l00634"></a>00634 
<a name="l00635"></a>00635           <span class="keywordflow">default</span>:
<a name="l00636"></a>00636             libmesh_error();
<a name="l00637"></a>00637           }
<a name="l00638"></a>00638 
<a name="l00639"></a>00639       }
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642     <span class="keywordflow">default</span>:
<a name="l00643"></a>00643       libmesh_error();
<a name="l00644"></a>00644     }
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   libmesh_error();
<a name="l00647"></a>00647   <span class="keywordflow">return</span>;
<a name="l00648"></a>00648 }
<a name="l00649"></a>00649 
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a4c1ba77812b306801d7fd20bce43fee1">00653</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a4c1ba77812b306801d7fd20bce43fee1">FEInterface::ifem_on_reference_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00654"></a>00654                                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00655"></a>00655                                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eps)
<a name="l00656"></a>00656 {
<a name="l00657"></a>00657   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a5ed1b078cb472a00bf1b4cdb5cf28be7">FEBase::on_reference_element</a>(p,t,eps);
<a name="l00658"></a>00658 }
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 
<a name="l00662"></a>00662 
<a name="l00663"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a019d71ee53afff815166a3e86d9c77b0">00663</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEInterface.php#a019d71ee53afff815166a3e86d9c77b0">FEInterface::ifem_shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00664"></a>00664                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00665"></a>00665                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00666"></a>00666                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00667"></a>00667                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00668"></a>00668 {
<a name="l00669"></a>00669   <span class="keywordflow">switch</span> (dim)
<a name="l00670"></a>00670     {
<a name="l00671"></a>00671       <span class="comment">// 1D</span>
<a name="l00672"></a>00672     <span class="keywordflow">case</span> 1:
<a name="l00673"></a>00673       {
<a name="l00674"></a>00674         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00675"></a>00675           {
<a name="l00676"></a>00676             <span class="comment">/*</span>
<a name="l00677"></a>00677 <span class="comment">             * For no derivatives (and local coordinates, as</span>
<a name="l00678"></a>00678 <span class="comment">             * given in \p p) the infinite element shapes</span>
<a name="l00679"></a>00679 <span class="comment">             * are independent of mapping type</span>
<a name="l00680"></a>00680 <span class="comment">             */</span>
<a name="l00681"></a>00681           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00682"></a>00682             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,INFINITE_MAP,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00683"></a>00683 
<a name="l00684"></a>00684           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00685"></a>00685             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00686"></a>00686 
<a name="l00687"></a>00687           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00688"></a>00688             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,JACOBI_30_00,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00689"></a>00689 
<a name="l00690"></a>00690           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:   
<a name="l00691"></a>00691             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,LEGENDRE,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00692"></a>00692 
<a name="l00693"></a>00693           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00694"></a>00694             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,LAGRANGE,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00695"></a>00695 
<a name="l00696"></a>00696           <span class="keywordflow">default</span>:
<a name="l00697"></a>00697             libmesh_error();
<a name="l00698"></a>00698           }
<a name="l00699"></a>00699       }
<a name="l00700"></a>00700 
<a name="l00701"></a>00701       
<a name="l00702"></a>00702       <span class="comment">// 2D</span>
<a name="l00703"></a>00703     <span class="keywordflow">case</span> 2:
<a name="l00704"></a>00704       {
<a name="l00705"></a>00705         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00706"></a>00706           {
<a name="l00707"></a>00707           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00708"></a>00708             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,INFINITE_MAP,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00709"></a>00709 
<a name="l00710"></a>00710           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00711"></a>00711             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00712"></a>00712 
<a name="l00713"></a>00713           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00714"></a>00714             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,JACOBI_30_00,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00715"></a>00715 
<a name="l00716"></a>00716           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:   
<a name="l00717"></a>00717             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,LEGENDRE,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00718"></a>00718 
<a name="l00719"></a>00719           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00720"></a>00720             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,LAGRANGE,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00721"></a>00721 
<a name="l00722"></a>00722           <span class="keywordflow">default</span>:
<a name="l00723"></a>00723             libmesh_error();
<a name="l00724"></a>00724           }
<a name="l00725"></a>00725 
<a name="l00726"></a>00726       }
<a name="l00727"></a>00727 
<a name="l00728"></a>00728       
<a name="l00729"></a>00729       <span class="comment">// 3D</span>
<a name="l00730"></a>00730     <span class="keywordflow">case</span> 3:
<a name="l00731"></a>00731       {
<a name="l00732"></a>00732         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00733"></a>00733           {
<a name="l00734"></a>00734           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00735"></a>00735             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,INFINITE_MAP,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00736"></a>00736 
<a name="l00737"></a>00737           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00738"></a>00738             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00739"></a>00739 
<a name="l00740"></a>00740           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00741"></a>00741             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,JACOBI_30_00,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00742"></a>00742 
<a name="l00743"></a>00743           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:   
<a name="l00744"></a>00744             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,LEGENDRE,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00745"></a>00745 
<a name="l00746"></a>00746           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00747"></a>00747             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,LAGRANGE,CARTESIAN&gt;::shape</a>(fe_t, t, i, p);
<a name="l00748"></a>00748 
<a name="l00749"></a>00749           <span class="keywordflow">default</span>:
<a name="l00750"></a>00750             libmesh_error();
<a name="l00751"></a>00751           }
<a name="l00752"></a>00752 
<a name="l00753"></a>00753       }
<a name="l00754"></a>00754 
<a name="l00755"></a>00755 
<a name="l00756"></a>00756     <span class="keywordflow">default</span>:
<a name="l00757"></a>00757       libmesh_error();
<a name="l00758"></a>00758     }
<a name="l00759"></a>00759 
<a name="l00760"></a>00760   
<a name="l00761"></a>00761   libmesh_error();
<a name="l00762"></a>00762   <span class="keywordflow">return</span> 0.;
<a name="l00763"></a>00763 }
<a name="l00764"></a>00764 
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 
<a name="l00767"></a>00767 
<a name="l00768"></a><a class="code" href="classlibMesh_1_1FEInterface.php#aad3bcdcc3a86b3dba3014ce67ff1309e">00768</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEInterface.php#a019d71ee53afff815166a3e86d9c77b0">FEInterface::ifem_shape</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00769"></a>00769                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00770"></a>00770                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00771"></a>00771                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00772"></a>00772                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00773"></a>00773 {
<a name="l00774"></a>00774   <span class="keywordflow">switch</span> (dim)
<a name="l00775"></a>00775     {
<a name="l00776"></a>00776       <span class="comment">// 1D</span>
<a name="l00777"></a>00777     <span class="keywordflow">case</span> 1:
<a name="l00778"></a>00778       {
<a name="l00779"></a>00779         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00780"></a>00780           {
<a name="l00781"></a>00781             <span class="comment">/*</span>
<a name="l00782"></a>00782 <span class="comment">             * For no derivatives (and local coordinates, as</span>
<a name="l00783"></a>00783 <span class="comment">             * given in \p p) the infinite element shapes</span>
<a name="l00784"></a>00784 <span class="comment">             * are independent of mapping type</span>
<a name="l00785"></a>00785 <span class="comment">             */</span>
<a name="l00786"></a>00786           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00787"></a>00787             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,INFINITE_MAP,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00788"></a>00788 
<a name="l00789"></a>00789           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00790"></a>00790             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00791"></a>00791 
<a name="l00792"></a>00792           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00793"></a>00793             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,JACOBI_30_00,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00794"></a>00794 
<a name="l00795"></a>00795           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:   
<a name="l00796"></a>00796             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,LEGENDRE,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00797"></a>00797 
<a name="l00798"></a>00798           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00799"></a>00799             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;1,LAGRANGE,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00800"></a>00800 
<a name="l00801"></a>00801           <span class="keywordflow">default</span>:
<a name="l00802"></a>00802             libmesh_error();
<a name="l00803"></a>00803           }
<a name="l00804"></a>00804       }
<a name="l00805"></a>00805 
<a name="l00806"></a>00806 
<a name="l00807"></a>00807       <span class="comment">// 2D</span>
<a name="l00808"></a>00808     <span class="keywordflow">case</span> 2:
<a name="l00809"></a>00809       {
<a name="l00810"></a>00810         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00811"></a>00811           {
<a name="l00812"></a>00812           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00813"></a>00813             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,INFINITE_MAP,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00814"></a>00814 
<a name="l00815"></a>00815           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00816"></a>00816             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00817"></a>00817 
<a name="l00818"></a>00818           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00819"></a>00819             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,JACOBI_30_00,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00820"></a>00820 
<a name="l00821"></a>00821           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:   
<a name="l00822"></a>00822             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,LEGENDRE,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00823"></a>00823 
<a name="l00824"></a>00824           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00825"></a>00825             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;2,LAGRANGE,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00826"></a>00826 
<a name="l00827"></a>00827           <span class="keywordflow">default</span>:
<a name="l00828"></a>00828             libmesh_error();
<a name="l00829"></a>00829           }
<a name="l00830"></a>00830 
<a name="l00831"></a>00831       }
<a name="l00832"></a>00832 
<a name="l00833"></a>00833             
<a name="l00834"></a>00834       <span class="comment">// 3D</span>
<a name="l00835"></a>00835     <span class="keywordflow">case</span> 3:
<a name="l00836"></a>00836       {
<a name="l00837"></a>00837         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00838"></a>00838           {
<a name="l00839"></a>00839           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00840"></a>00840             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,INFINITE_MAP,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00841"></a>00841 
<a name="l00842"></a>00842           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00843"></a>00843             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00844"></a>00844 
<a name="l00845"></a>00845           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00846"></a>00846             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,JACOBI_30_00,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00847"></a>00847 
<a name="l00848"></a>00848           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:   
<a name="l00849"></a>00849             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,LEGENDRE,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00850"></a>00850 
<a name="l00851"></a>00851           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00852"></a>00852             <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">InfFE&lt;3,LAGRANGE,CARTESIAN&gt;::shape</a>(fe_t, elem, i, p);
<a name="l00853"></a>00853 
<a name="l00854"></a>00854           <span class="keywordflow">default</span>:
<a name="l00855"></a>00855             libmesh_error();
<a name="l00856"></a>00856           }
<a name="l00857"></a>00857 
<a name="l00858"></a>00858       }
<a name="l00859"></a>00859 
<a name="l00860"></a>00860 
<a name="l00861"></a>00861     <span class="keywordflow">default</span>:
<a name="l00862"></a>00862       libmesh_error();
<a name="l00863"></a>00863     }
<a name="l00864"></a>00864 
<a name="l00865"></a>00865   
<a name="l00866"></a>00866   libmesh_error();
<a name="l00867"></a>00867   <span class="keywordflow">return</span> 0.;
<a name="l00868"></a>00868 }
<a name="l00869"></a>00869 
<a name="l00870"></a>00870 
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 
<a name="l00873"></a><a class="code" href="classlibMesh_1_1FEInterface.php#a5d36b2f7e038db76767b85901b81e700">00873</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a5d36b2f7e038db76767b85901b81e700">FEInterface::ifem_compute_data</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00874"></a>00874                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00875"></a>00875                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00876"></a>00876                                     <a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a>&amp; data)
<a name="l00877"></a>00877 {
<a name="l00878"></a>00878   <span class="keywordflow">switch</span> (dim)
<a name="l00879"></a>00879     {
<a name="l00880"></a>00880       <span class="comment">// 1D</span>
<a name="l00881"></a>00881     <span class="keywordflow">case</span> 1:
<a name="l00882"></a>00882       {
<a name="l00883"></a>00883         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00884"></a>00884           {
<a name="l00885"></a>00885             <span class="comment">/*</span>
<a name="l00886"></a>00886 <span class="comment">             * For no derivatives (and local coordinates, as</span>
<a name="l00887"></a>00887 <span class="comment">             * given in \p p) the infinite element shapes</span>
<a name="l00888"></a>00888 <span class="comment">             * are independent of mapping type</span>
<a name="l00889"></a>00889 <span class="comment">             */</span>
<a name="l00890"></a>00890           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00891"></a>00891             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;1,INFINITE_MAP,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00892"></a>00892             <span class="keywordflow">break</span>;
<a name="l00893"></a>00893 
<a name="l00894"></a>00894           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00895"></a>00895             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00896"></a>00896             <span class="keywordflow">break</span>;
<a name="l00897"></a>00897 
<a name="l00898"></a>00898           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00899"></a>00899             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;1,JACOBI_30_00,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00900"></a>00900             <span class="keywordflow">break</span>;
<a name="l00901"></a>00901 
<a name="l00902"></a>00902           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:   
<a name="l00903"></a>00903             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;1,LEGENDRE,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00904"></a>00904             <span class="keywordflow">break</span>;
<a name="l00905"></a>00905 
<a name="l00906"></a>00906           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00907"></a>00907             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;1,LAGRANGE,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00908"></a>00908             <span class="keywordflow">break</span>;
<a name="l00909"></a>00909 
<a name="l00910"></a>00910           <span class="keywordflow">default</span>:
<a name="l00911"></a>00911             libmesh_error();
<a name="l00912"></a>00912           }
<a name="l00913"></a>00913 
<a name="l00914"></a>00914         <span class="keywordflow">break</span>;
<a name="l00915"></a>00915       }
<a name="l00916"></a>00916 
<a name="l00917"></a>00917 
<a name="l00918"></a>00918       <span class="comment">// 2D</span>
<a name="l00919"></a>00919     <span class="keywordflow">case</span> 2:
<a name="l00920"></a>00920       {
<a name="l00921"></a>00921         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00922"></a>00922           {
<a name="l00923"></a>00923           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00924"></a>00924             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;2,INFINITE_MAP,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00925"></a>00925             <span class="keywordflow">break</span>;
<a name="l00926"></a>00926 
<a name="l00927"></a>00927           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00928"></a>00928             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00929"></a>00929             <span class="keywordflow">break</span>;
<a name="l00930"></a>00930 
<a name="l00931"></a>00931           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00932"></a>00932             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;2,JACOBI_30_00,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00933"></a>00933             <span class="keywordflow">break</span>;
<a name="l00934"></a>00934 
<a name="l00935"></a>00935           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:   
<a name="l00936"></a>00936             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;2,LEGENDRE,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00937"></a>00937             <span class="keywordflow">break</span>;
<a name="l00938"></a>00938 
<a name="l00939"></a>00939           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00940"></a>00940             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;2,LAGRANGE,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00941"></a>00941             <span class="keywordflow">break</span>;
<a name="l00942"></a>00942 
<a name="l00943"></a>00943           <span class="keywordflow">default</span>:
<a name="l00944"></a>00944             libmesh_error();
<a name="l00945"></a>00945           }
<a name="l00946"></a>00946 
<a name="l00947"></a>00947         <span class="keywordflow">break</span>;
<a name="l00948"></a>00948       }
<a name="l00949"></a>00949 
<a name="l00950"></a>00950             
<a name="l00951"></a>00951       <span class="comment">// 3D</span>
<a name="l00952"></a>00952     <span class="keywordflow">case</span> 3:
<a name="l00953"></a>00953       {
<a name="l00954"></a>00954         <span class="keywordflow">switch</span> (fe_t.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00955"></a>00955           {
<a name="l00956"></a>00956           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>:
<a name="l00957"></a>00957             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;3,INFINITE_MAP,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00958"></a>00958             <span class="keywordflow">break</span>;
<a name="l00959"></a>00959 
<a name="l00960"></a>00960           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>:
<a name="l00961"></a>00961             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00962"></a>00962             <span class="keywordflow">break</span>;
<a name="l00963"></a>00963 
<a name="l00964"></a>00964           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0c05e061ee42e52270205fd2d4fb77bc">JACOBI_30_00</a>:
<a name="l00965"></a>00965             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;3,JACOBI_30_00,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00966"></a>00966             <span class="keywordflow">break</span>;
<a name="l00967"></a>00967 
<a name="l00968"></a>00968           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a592c7a57b998aa47edeb98321e1aa970">LEGENDRE</a>:   
<a name="l00969"></a>00969             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;3,LEGENDRE,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00970"></a>00970             <span class="keywordflow">break</span>;
<a name="l00971"></a>00971 
<a name="l00972"></a>00972           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>:
<a name="l00973"></a>00973             <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">InfFE&lt;3,LAGRANGE,CARTESIAN&gt;::compute_data</a>(fe_t, elem, data);
<a name="l00974"></a>00974             <span class="keywordflow">break</span>;
<a name="l00975"></a>00975 
<a name="l00976"></a>00976           <span class="keywordflow">default</span>:
<a name="l00977"></a>00977             libmesh_error();
<a name="l00978"></a>00978           }
<a name="l00979"></a>00979 
<a name="l00980"></a>00980         <span class="keywordflow">break</span>;
<a name="l00981"></a>00981       }
<a name="l00982"></a>00982 
<a name="l00983"></a>00983 
<a name="l00984"></a>00984     <span class="keywordflow">default</span>:
<a name="l00985"></a>00985       libmesh_error();
<a name="l00986"></a>00986       <span class="keywordflow">break</span>;
<a name="l00987"></a>00987     }
<a name="l00988"></a>00988 
<a name="l00989"></a>00989   <span class="keywordflow">return</span>;
<a name="l00990"></a>00990 }
<a name="l00991"></a>00991 
<a name="l00992"></a>00992 } <span class="comment">// namespace libMesh</span>
<a name="l00993"></a>00993 
<a name="l00994"></a>00994 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00995"></a>00995 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
