<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_lagrange.C</div>  </div>
</div>
<div class="contents">
<a href="fe__lagrange_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_lagrange.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="fe__macro_8h.php">fe_macro.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00037"></a>00037 <span class="comment">// Lagrange-specific implementations</span>
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00039"></a>00039 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#aeddb953b5b64abc7ab1efa1e5ffc68e9">FE&lt;Dim,T&gt;::nodal_soln</a>(<span class="keyword">const</span> Elem* elem,
<a name="l00040"></a>00040                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00041"></a>00041                            <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00042"></a>00042                            std::vector&lt;Number&gt;&amp;       nodal_soln)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;n_nodes();
<a name="l00046"></a>00046   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type        = elem-&gt;type();
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order+elem-&gt;p_level());
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   nodal_soln.resize(n_nodes);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   
<a name="l00054"></a>00054   <span class="keywordflow">switch</span> (totalorder)
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056       <span class="comment">// linear Lagrange shape functions</span>
<a name="l00057"></a>00057     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00058"></a>00058       {
<a name="l00059"></a>00059         <span class="keywordflow">switch</span> (type)
<a name="l00060"></a>00060           {
<a name="l00061"></a>00061           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00062"></a>00062             {
<a name="l00063"></a>00063               libmesh_assert (elem_soln.size()  == 2);
<a name="l00064"></a>00064               libmesh_assert (nodal_soln.size() == 3);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066               nodal_soln[0] = elem_soln[0];
<a name="l00067"></a>00067               nodal_soln[1] = elem_soln[1];
<a name="l00068"></a>00068               nodal_soln[2] = .5*(elem_soln[0] + elem_soln[1]);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070               <span class="keywordflow">return</span>;
<a name="l00071"></a>00071             }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00074"></a>00074             {
<a name="l00075"></a>00075               libmesh_assert(elem_soln.size() == 2);
<a name="l00076"></a>00076               libmesh_assert(nodal_soln.size() == 4);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078               nodal_soln[0] = elem_soln[0];
<a name="l00079"></a>00079               nodal_soln[1] = elem_soln[1];
<a name="l00080"></a>00080               nodal_soln[2] = (2.*elem_soln[0] + elem_soln[1])/3.;
<a name="l00081"></a>00081               nodal_soln[3] = (elem_soln[0] + 2.*elem_soln[1])/3.;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083               <span class="keywordflow">return</span>;
<a name="l00084"></a>00084             }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086             
<a name="l00087"></a>00087           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00088"></a>00088             {
<a name="l00089"></a>00089               libmesh_assert (elem_soln.size()  == 3);
<a name="l00090"></a>00090               libmesh_assert (nodal_soln.size() == 6);
<a name="l00091"></a>00091               
<a name="l00092"></a>00092               nodal_soln[0] = elem_soln[0];
<a name="l00093"></a>00093               nodal_soln[1] = elem_soln[1];
<a name="l00094"></a>00094               nodal_soln[2] = elem_soln[2];
<a name="l00095"></a>00095               nodal_soln[3] = .5*(elem_soln[0] + elem_soln[1]);       
<a name="l00096"></a>00096               nodal_soln[4] = .5*(elem_soln[1] + elem_soln[2]);
<a name="l00097"></a>00097               nodal_soln[5] = .5*(elem_soln[2] + elem_soln[0]);
<a name="l00098"></a>00098 
<a name="l00099"></a>00099               <span class="keywordflow">return</span>;
<a name="l00100"></a>00100             }
<a name="l00101"></a>00101             
<a name="l00102"></a>00102 
<a name="l00103"></a>00103           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00104"></a>00104           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00105"></a>00105             {
<a name="l00106"></a>00106               libmesh_assert (elem_soln.size()  == 4);
<a name="l00107"></a>00107               
<a name="l00108"></a>00108               <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>)
<a name="l00109"></a>00109                 libmesh_assert (nodal_soln.size() == 8);
<a name="l00110"></a>00110               <span class="keywordflow">else</span>
<a name="l00111"></a>00111                 libmesh_assert (nodal_soln.size() == 9);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113               
<a name="l00114"></a>00114               nodal_soln[0] = elem_soln[0];
<a name="l00115"></a>00115               nodal_soln[1] = elem_soln[1];
<a name="l00116"></a>00116               nodal_soln[2] = elem_soln[2];
<a name="l00117"></a>00117               nodal_soln[3] = elem_soln[3];
<a name="l00118"></a>00118               nodal_soln[4] = .5*(elem_soln[0] + elem_soln[1]);
<a name="l00119"></a>00119               nodal_soln[5] = .5*(elem_soln[1] + elem_soln[2]);
<a name="l00120"></a>00120               nodal_soln[6] = .5*(elem_soln[2] + elem_soln[3]);
<a name="l00121"></a>00121               nodal_soln[7] = .5*(elem_soln[3] + elem_soln[0]);
<a name="l00122"></a>00122                                                
<a name="l00123"></a>00123               <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>)
<a name="l00124"></a>00124                 nodal_soln[8] = .25*(elem_soln[0] + elem_soln[1] + elem_soln[2] + elem_soln[3]);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126               <span class="keywordflow">return</span>;
<a name="l00127"></a>00127             }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129             
<a name="l00130"></a>00130           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00131"></a>00131             {
<a name="l00132"></a>00132               libmesh_assert (elem_soln.size()  == 4);
<a name="l00133"></a>00133               libmesh_assert (nodal_soln.size() == 10);
<a name="l00134"></a>00134               
<a name="l00135"></a>00135               nodal_soln[0] = elem_soln[0];
<a name="l00136"></a>00136               nodal_soln[1] = elem_soln[1];
<a name="l00137"></a>00137               nodal_soln[2] = elem_soln[2];
<a name="l00138"></a>00138               nodal_soln[3] = elem_soln[3];
<a name="l00139"></a>00139               nodal_soln[4] = .5*(elem_soln[0] + elem_soln[1]);
<a name="l00140"></a>00140               nodal_soln[5] = .5*(elem_soln[1] + elem_soln[2]);
<a name="l00141"></a>00141               nodal_soln[6] = .5*(elem_soln[2] + elem_soln[0]);
<a name="l00142"></a>00142               nodal_soln[7] = .5*(elem_soln[3] + elem_soln[0]);
<a name="l00143"></a>00143               nodal_soln[8] = .5*(elem_soln[3] + elem_soln[1]);
<a name="l00144"></a>00144               nodal_soln[9] = .5*(elem_soln[3] + elem_soln[2]);
<a name="l00145"></a>00145               
<a name="l00146"></a>00146               <span class="keywordflow">return</span>;
<a name="l00147"></a>00147             }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149             
<a name="l00150"></a>00150           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00151"></a>00151           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00152"></a>00152             {
<a name="l00153"></a>00153               libmesh_assert (elem_soln.size()  == 8);
<a name="l00154"></a>00154               
<a name="l00155"></a>00155               <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>)
<a name="l00156"></a>00156                 libmesh_assert (nodal_soln.size() == 20);
<a name="l00157"></a>00157               <span class="keywordflow">else</span>
<a name="l00158"></a>00158                 libmesh_assert (nodal_soln.size() == 27);
<a name="l00159"></a>00159               
<a name="l00160"></a>00160               nodal_soln[0]  = elem_soln[0];
<a name="l00161"></a>00161               nodal_soln[1]  = elem_soln[1];
<a name="l00162"></a>00162               nodal_soln[2]  = elem_soln[2];
<a name="l00163"></a>00163               nodal_soln[3]  = elem_soln[3];
<a name="l00164"></a>00164               nodal_soln[4]  = elem_soln[4];
<a name="l00165"></a>00165               nodal_soln[5]  = elem_soln[5];
<a name="l00166"></a>00166               nodal_soln[6]  = elem_soln[6];
<a name="l00167"></a>00167               nodal_soln[7]  = elem_soln[7];
<a name="l00168"></a>00168               nodal_soln[8]  = .5*(elem_soln[0] + elem_soln[1]);
<a name="l00169"></a>00169               nodal_soln[9]  = .5*(elem_soln[1] + elem_soln[2]);
<a name="l00170"></a>00170               nodal_soln[10] = .5*(elem_soln[2] + elem_soln[3]);
<a name="l00171"></a>00171               nodal_soln[11] = .5*(elem_soln[3] + elem_soln[0]);
<a name="l00172"></a>00172               nodal_soln[12] = .5*(elem_soln[0] + elem_soln[4]);
<a name="l00173"></a>00173               nodal_soln[13] = .5*(elem_soln[1] + elem_soln[5]);
<a name="l00174"></a>00174               nodal_soln[14] = .5*(elem_soln[2] + elem_soln[6]);
<a name="l00175"></a>00175               nodal_soln[15] = .5*(elem_soln[3] + elem_soln[7]);
<a name="l00176"></a>00176               nodal_soln[16] = .5*(elem_soln[4] + elem_soln[5]);
<a name="l00177"></a>00177               nodal_soln[17] = .5*(elem_soln[5] + elem_soln[6]);
<a name="l00178"></a>00178               nodal_soln[18] = .5*(elem_soln[6] + elem_soln[7]);
<a name="l00179"></a>00179               nodal_soln[19] = .5*(elem_soln[4] + elem_soln[7]);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181               <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>)
<a name="l00182"></a>00182                 {
<a name="l00183"></a>00183                   nodal_soln[20] = .25*(elem_soln[0] + elem_soln[1] + elem_soln[2] + elem_soln[3]);
<a name="l00184"></a>00184                   nodal_soln[21] = .25*(elem_soln[0] + elem_soln[1] + elem_soln[4] + elem_soln[5]);
<a name="l00185"></a>00185                   nodal_soln[22] = .25*(elem_soln[1] + elem_soln[2] + elem_soln[5] + elem_soln[6]);
<a name="l00186"></a>00186                   nodal_soln[23] = .25*(elem_soln[2] + elem_soln[3] + elem_soln[6] + elem_soln[7]);
<a name="l00187"></a>00187                   nodal_soln[24] = .25*(elem_soln[3] + elem_soln[0] + elem_soln[7] + elem_soln[4]);
<a name="l00188"></a>00188                   nodal_soln[25] = .25*(elem_soln[4] + elem_soln[5] + elem_soln[6] + elem_soln[7]);
<a name="l00189"></a>00189 
<a name="l00190"></a>00190                   nodal_soln[26] = .125*(elem_soln[0] + elem_soln[1] + elem_soln[2] + elem_soln[3] +
<a name="l00191"></a>00191                                          elem_soln[4] + elem_soln[5] + elem_soln[6] + elem_soln[7]);
<a name="l00192"></a>00192                 }
<a name="l00193"></a>00193               
<a name="l00194"></a>00194               <span class="keywordflow">return</span>;
<a name="l00195"></a>00195             }
<a name="l00196"></a>00196             
<a name="l00197"></a>00197             
<a name="l00198"></a>00198           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00199"></a>00199           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00200"></a>00200             {
<a name="l00201"></a>00201               libmesh_assert (elem_soln.size()  == 6);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203               <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>)
<a name="l00204"></a>00204                 libmesh_assert (nodal_soln.size() == 15);
<a name="l00205"></a>00205               <span class="keywordflow">else</span>
<a name="l00206"></a>00206                 libmesh_assert (nodal_soln.size() == 18);
<a name="l00207"></a>00207               
<a name="l00208"></a>00208               nodal_soln[0]  = elem_soln[0];
<a name="l00209"></a>00209               nodal_soln[1]  = elem_soln[1];
<a name="l00210"></a>00210               nodal_soln[2]  = elem_soln[2];
<a name="l00211"></a>00211               nodal_soln[3]  = elem_soln[3];
<a name="l00212"></a>00212               nodal_soln[4]  = elem_soln[4];
<a name="l00213"></a>00213               nodal_soln[5]  = elem_soln[5];
<a name="l00214"></a>00214               nodal_soln[6]  = .5*(elem_soln[0] + elem_soln[1]);
<a name="l00215"></a>00215               nodal_soln[7]  = .5*(elem_soln[1] + elem_soln[2]);
<a name="l00216"></a>00216               nodal_soln[8]  = .5*(elem_soln[0] + elem_soln[2]);
<a name="l00217"></a>00217               nodal_soln[9]  = .5*(elem_soln[0] + elem_soln[3]);
<a name="l00218"></a>00218               nodal_soln[10] = .5*(elem_soln[1] + elem_soln[4]);
<a name="l00219"></a>00219               nodal_soln[11] = .5*(elem_soln[2] + elem_soln[5]);
<a name="l00220"></a>00220               nodal_soln[12] = .5*(elem_soln[3] + elem_soln[4]);
<a name="l00221"></a>00221               nodal_soln[13] = .5*(elem_soln[4] + elem_soln[5]);
<a name="l00222"></a>00222               nodal_soln[14] = .5*(elem_soln[3] + elem_soln[5]);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224               <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>)
<a name="l00225"></a>00225                 {
<a name="l00226"></a>00226                   nodal_soln[15] = .25*(elem_soln[0] + elem_soln[1] + elem_soln[4] + elem_soln[3]);
<a name="l00227"></a>00227                   nodal_soln[16] = .25*(elem_soln[1] + elem_soln[2] + elem_soln[5] + elem_soln[4]);
<a name="l00228"></a>00228                   nodal_soln[17] = .25*(elem_soln[2] + elem_soln[0] + elem_soln[3] + elem_soln[5]);
<a name="l00229"></a>00229                 }
<a name="l00230"></a>00230                       
<a name="l00231"></a>00231               <span class="keywordflow">return</span>;
<a name="l00232"></a>00232             }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235             
<a name="l00236"></a>00236           <span class="keywordflow">default</span>:
<a name="l00237"></a>00237             {
<a name="l00238"></a>00238               <span class="comment">// By default the element solution _is_ nodal,</span>
<a name="l00239"></a>00239               <span class="comment">// so just copy it.</span>
<a name="l00240"></a>00240               nodal_soln = elem_soln;
<a name="l00241"></a>00241               
<a name="l00242"></a>00242               <span class="keywordflow">return</span>;
<a name="l00243"></a>00243             }
<a name="l00244"></a>00244           }
<a name="l00245"></a>00245       }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00248"></a>00248       {
<a name="l00249"></a>00249         <span class="keywordflow">switch</span> (type)
<a name="l00250"></a>00250           {
<a name="l00251"></a>00251           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00252"></a>00252             {
<a name="l00253"></a>00253               libmesh_assert(elem_soln.size()  == 3);
<a name="l00254"></a>00254               libmesh_assert(nodal_soln.size() == 4);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256               <span class="comment">// Project quadratic solution onto cubic element nodes</span>
<a name="l00257"></a>00257               nodal_soln[0] = elem_soln[0];
<a name="l00258"></a>00258               nodal_soln[1] = elem_soln[1];
<a name="l00259"></a>00259               nodal_soln[2] = (2.*elem_soln[0] - elem_soln[1] + 
<a name="l00260"></a>00260                                8.*elem_soln[2])/9.;
<a name="l00261"></a>00261               nodal_soln[3] = (-elem_soln[0] + 2.*elem_soln[1] +
<a name="l00262"></a>00262                                8.*elem_soln[2])/9.;
<a name="l00263"></a>00263               <span class="keywordflow">return</span>;
<a name="l00264"></a>00264             }
<a name="l00265"></a>00265 
<a name="l00266"></a>00266           <span class="keywordflow">default</span>:
<a name="l00267"></a>00267             {
<a name="l00268"></a>00268               <span class="comment">// By default the element solution _is_ nodal,</span>
<a name="l00269"></a>00269               <span class="comment">// so just copy it.</span>
<a name="l00270"></a>00270               nodal_soln = elem_soln;
<a name="l00271"></a>00271               
<a name="l00272"></a>00272               <span class="keywordflow">return</span>;
<a name="l00273"></a>00273             }
<a name="l00274"></a>00274           }
<a name="l00275"></a>00275         }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279       
<a name="l00280"></a>00280     <span class="keywordflow">default</span>:
<a name="l00281"></a>00281       {
<a name="l00282"></a>00282         <span class="comment">// By default the element solution _is_ nodal,</span>
<a name="l00283"></a>00283         <span class="comment">// so just copy it.</span>
<a name="l00284"></a>00284         nodal_soln = elem_soln;
<a name="l00285"></a>00285         
<a name="l00286"></a>00286         <span class="keywordflow">return</span>;
<a name="l00287"></a>00287       }      
<a name="l00288"></a>00288     }
<a name="l00289"></a>00289 }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00295"></a>00295 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a401b5a255c73cd4fd202aadee954ba37">FE&lt;Dim,T&gt;::n_dofs</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o)
<a name="l00296"></a>00296 {
<a name="l00297"></a>00297   <span class="keywordflow">switch</span> (o)
<a name="l00298"></a>00298     {
<a name="l00299"></a>00299 
<a name="l00300"></a>00300       <span class="comment">// linear Lagrange shape functions</span>
<a name="l00301"></a>00301     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00302"></a>00302       {
<a name="l00303"></a>00303         <span class="keywordflow">switch</span> (t)
<a name="l00304"></a>00304           {
<a name="l00305"></a>00305           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00306"></a>00306             <span class="keywordflow">return</span> 1;
<a name="l00307"></a>00307 
<a name="l00308"></a>00308           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00309"></a>00309           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00310"></a>00310           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00311"></a>00311             <span class="keywordflow">return</span> 2;
<a name="l00312"></a>00312 
<a name="l00313"></a>00313           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00314"></a>00314           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00315"></a>00315             <span class="keywordflow">return</span> 3;
<a name="l00316"></a>00316 
<a name="l00317"></a>00317           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00318"></a>00318           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00319"></a>00319           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00320"></a>00320             <span class="keywordflow">return</span> 4;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00323"></a>00323           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00324"></a>00324             <span class="keywordflow">return</span> 4;
<a name="l00325"></a>00325 
<a name="l00326"></a>00326           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00327"></a>00327           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00328"></a>00328           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00329"></a>00329             <span class="keywordflow">return</span> 8;
<a name="l00330"></a>00330 
<a name="l00331"></a>00331           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00332"></a>00332           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00333"></a>00333           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00334"></a>00334             <span class="keywordflow">return</span> 6;
<a name="l00335"></a>00335 
<a name="l00336"></a>00336           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00337"></a>00337             <span class="keywordflow">return</span> 5;
<a name="l00338"></a>00338 
<a name="l00339"></a>00339           <span class="keywordflow">default</span>:
<a name="l00340"></a>00340             {
<a name="l00341"></a>00341 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00342"></a>00342 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00343"></a>00343                             &lt;&lt; <span class="stringliteral">&quot; for FIRST order approximation!&quot;</span> 
<a name="l00344"></a>00344                             &lt;&lt; std::endl;
<a name="l00345"></a>00345 <span class="preprocessor">#endif</span>
<a name="l00346"></a>00346 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00347"></a>00347             }
<a name="l00348"></a>00348           }
<a name="l00349"></a>00349       }
<a name="l00350"></a>00350 
<a name="l00351"></a>00351       
<a name="l00352"></a>00352       <span class="comment">// quadratic Lagrange shape functions</span>
<a name="l00353"></a>00353     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00354"></a>00354       {
<a name="l00355"></a>00355         <span class="keywordflow">switch</span> (t)
<a name="l00356"></a>00356           {
<a name="l00357"></a>00357           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00358"></a>00358             <span class="keywordflow">return</span> 1;
<a name="l00359"></a>00359 
<a name="l00360"></a>00360           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00361"></a>00361             <span class="keywordflow">return</span> 3;
<a name="l00362"></a>00362 
<a name="l00363"></a>00363           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00364"></a>00364             <span class="keywordflow">return</span> 6;
<a name="l00365"></a>00365 
<a name="l00366"></a>00366           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00367"></a>00367             <span class="keywordflow">return</span> 8;
<a name="l00368"></a>00368             
<a name="l00369"></a>00369           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00370"></a>00370             <span class="keywordflow">return</span> 9;
<a name="l00371"></a>00371 
<a name="l00372"></a>00372           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00373"></a>00373             <span class="keywordflow">return</span> 10;
<a name="l00374"></a>00374 
<a name="l00375"></a>00375           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00376"></a>00376             <span class="keywordflow">return</span> 20;
<a name="l00377"></a>00377             
<a name="l00378"></a>00378           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00379"></a>00379             <span class="keywordflow">return</span> 27;
<a name="l00380"></a>00380 
<a name="l00381"></a>00381           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00382"></a>00382             <span class="keywordflow">return</span> 15;
<a name="l00383"></a>00383 
<a name="l00384"></a>00384           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00385"></a>00385             <span class="keywordflow">return</span> 18;
<a name="l00386"></a>00386 
<a name="l00387"></a>00387           <span class="keywordflow">default</span>:
<a name="l00388"></a>00388             {
<a name="l00389"></a>00389 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00390"></a>00390 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00391"></a>00391                             &lt;&lt; <span class="stringliteral">&quot; for SECOND order approximation!&quot;</span> 
<a name="l00392"></a>00392                             &lt;&lt; std::endl;
<a name="l00393"></a>00393 <span class="preprocessor">#endif</span>
<a name="l00394"></a>00394 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00395"></a>00395             }
<a name="l00396"></a>00396           }
<a name="l00397"></a>00397       }
<a name="l00398"></a>00398 
<a name="l00399"></a>00399     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00400"></a>00400       {
<a name="l00401"></a>00401         <span class="keywordflow">switch</span> (t)
<a name="l00402"></a>00402         {
<a name="l00403"></a>00403           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00404"></a>00404             <span class="keywordflow">return</span> 1;
<a name="l00405"></a>00405 
<a name="l00406"></a>00406           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00407"></a>00407             <span class="keywordflow">return</span> 4;
<a name="l00408"></a>00408 
<a name="l00409"></a>00409           <span class="keywordflow">default</span>:
<a name="l00410"></a>00410             {
<a name="l00411"></a>00411 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00412"></a>00412 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00413"></a>00413                             &lt;&lt; <span class="stringliteral">&quot; for THIRD order approximation!&quot;</span> 
<a name="l00414"></a>00414                             &lt;&lt; std::endl;
<a name="l00415"></a>00415 <span class="preprocessor">#endif</span>
<a name="l00416"></a>00416 <span class="preprocessor"></span>              libmesh_error();  
<a name="l00417"></a>00417             }
<a name="l00418"></a>00418         }
<a name="l00419"></a>00419       }
<a name="l00420"></a>00420       
<a name="l00421"></a>00421     <span class="keywordflow">default</span>:
<a name="l00422"></a>00422       libmesh_error();
<a name="l00423"></a>00423     }
<a name="l00424"></a>00424   
<a name="l00425"></a>00425   libmesh_error();  
<a name="l00426"></a>00426   <span class="keywordflow">return</span> 0;
<a name="l00427"></a>00427 }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00432"></a>00432 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a00239d73fd53a032ab838a5d0a7dc7ce">FE&lt;Dim,T&gt;::n_dofs_at_node</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00433"></a>00433                                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00434"></a>00434                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00435"></a>00435 {
<a name="l00436"></a>00436   <span class="keywordflow">switch</span> (o)
<a name="l00437"></a>00437     {
<a name="l00438"></a>00438       
<a name="l00439"></a>00439       <span class="comment">// linear Lagrange shape functions</span>
<a name="l00440"></a>00440     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00441"></a>00441       {
<a name="l00442"></a>00442         <span class="keywordflow">switch</span> (t)
<a name="l00443"></a>00443           {
<a name="l00444"></a>00444           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00445"></a>00445             <span class="keywordflow">return</span> 1;
<a name="l00446"></a>00446 
<a name="l00447"></a>00447           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00448"></a>00448           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00449"></a>00449           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00450"></a>00450             {
<a name="l00451"></a>00451               <span class="keywordflow">switch</span> (n)
<a name="l00452"></a>00452                 {
<a name="l00453"></a>00453                 <span class="keywordflow">case</span> 0:
<a name="l00454"></a>00454                 <span class="keywordflow">case</span> 1:
<a name="l00455"></a>00455                   <span class="keywordflow">return</span> 1;
<a name="l00456"></a>00456                   
<a name="l00457"></a>00457                 <span class="keywordflow">default</span>:
<a name="l00458"></a>00458                   <span class="keywordflow">return</span> 0;
<a name="l00459"></a>00459                 }
<a name="l00460"></a>00460             }
<a name="l00461"></a>00461 
<a name="l00462"></a>00462           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00463"></a>00463           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00464"></a>00464             {
<a name="l00465"></a>00465               <span class="keywordflow">switch</span> (n)
<a name="l00466"></a>00466                 {
<a name="l00467"></a>00467                 <span class="keywordflow">case</span> 0:
<a name="l00468"></a>00468                 <span class="keywordflow">case</span> 1:
<a name="l00469"></a>00469                 <span class="keywordflow">case</span> 2:
<a name="l00470"></a>00470                   <span class="keywordflow">return</span> 1;
<a name="l00471"></a>00471                   
<a name="l00472"></a>00472                 <span class="keywordflow">default</span>:
<a name="l00473"></a>00473                   <span class="keywordflow">return</span> 0;
<a name="l00474"></a>00474                 }
<a name="l00475"></a>00475             }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00478"></a>00478           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00479"></a>00479           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00480"></a>00480             {
<a name="l00481"></a>00481               <span class="keywordflow">switch</span> (n)
<a name="l00482"></a>00482                 {
<a name="l00483"></a>00483                 <span class="keywordflow">case</span> 0:
<a name="l00484"></a>00484                 <span class="keywordflow">case</span> 1:
<a name="l00485"></a>00485                 <span class="keywordflow">case</span> 2:
<a name="l00486"></a>00486                 <span class="keywordflow">case</span> 3:
<a name="l00487"></a>00487                   <span class="keywordflow">return</span> 1;
<a name="l00488"></a>00488                   
<a name="l00489"></a>00489                 <span class="keywordflow">default</span>:
<a name="l00490"></a>00490                   <span class="keywordflow">return</span> 0;
<a name="l00491"></a>00491                 }
<a name="l00492"></a>00492             }
<a name="l00493"></a>00493 
<a name="l00494"></a>00494 
<a name="l00495"></a>00495           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00496"></a>00496           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00497"></a>00497             {
<a name="l00498"></a>00498               <span class="keywordflow">switch</span> (n)
<a name="l00499"></a>00499                 {
<a name="l00500"></a>00500                 <span class="keywordflow">case</span> 0:
<a name="l00501"></a>00501                 <span class="keywordflow">case</span> 1:
<a name="l00502"></a>00502                 <span class="keywordflow">case</span> 2:
<a name="l00503"></a>00503                 <span class="keywordflow">case</span> 3:
<a name="l00504"></a>00504                   <span class="keywordflow">return</span> 1;
<a name="l00505"></a>00505                   
<a name="l00506"></a>00506                 <span class="keywordflow">default</span>:
<a name="l00507"></a>00507                   <span class="keywordflow">return</span> 0;
<a name="l00508"></a>00508                 }
<a name="l00509"></a>00509             }
<a name="l00510"></a>00510                     
<a name="l00511"></a>00511           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00512"></a>00512           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00513"></a>00513           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00514"></a>00514             {
<a name="l00515"></a>00515               <span class="keywordflow">switch</span> (n)
<a name="l00516"></a>00516                 {
<a name="l00517"></a>00517                 <span class="keywordflow">case</span> 0:
<a name="l00518"></a>00518                 <span class="keywordflow">case</span> 1:
<a name="l00519"></a>00519                 <span class="keywordflow">case</span> 2:
<a name="l00520"></a>00520                 <span class="keywordflow">case</span> 3:
<a name="l00521"></a>00521                 <span class="keywordflow">case</span> 4:
<a name="l00522"></a>00522                 <span class="keywordflow">case</span> 5:
<a name="l00523"></a>00523                 <span class="keywordflow">case</span> 6:
<a name="l00524"></a>00524                 <span class="keywordflow">case</span> 7:
<a name="l00525"></a>00525                   <span class="keywordflow">return</span> 1;
<a name="l00526"></a>00526                   
<a name="l00527"></a>00527                 <span class="keywordflow">default</span>:
<a name="l00528"></a>00528                   <span class="keywordflow">return</span> 0;
<a name="l00529"></a>00529                 }
<a name="l00530"></a>00530             }
<a name="l00531"></a>00531 
<a name="l00532"></a>00532           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00533"></a>00533           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00534"></a>00534           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00535"></a>00535             {
<a name="l00536"></a>00536               <span class="keywordflow">switch</span> (n)
<a name="l00537"></a>00537                 {
<a name="l00538"></a>00538                 <span class="keywordflow">case</span> 0:
<a name="l00539"></a>00539                 <span class="keywordflow">case</span> 1:
<a name="l00540"></a>00540                 <span class="keywordflow">case</span> 2:
<a name="l00541"></a>00541                 <span class="keywordflow">case</span> 3:
<a name="l00542"></a>00542                 <span class="keywordflow">case</span> 4:
<a name="l00543"></a>00543                 <span class="keywordflow">case</span> 5:
<a name="l00544"></a>00544                   <span class="keywordflow">return</span> 1;
<a name="l00545"></a>00545                   
<a name="l00546"></a>00546                 <span class="keywordflow">default</span>:
<a name="l00547"></a>00547                   <span class="keywordflow">return</span> 0;
<a name="l00548"></a>00548                 }
<a name="l00549"></a>00549             }
<a name="l00550"></a>00550 
<a name="l00551"></a>00551           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00552"></a>00552             {
<a name="l00553"></a>00553               <span class="keywordflow">switch</span> (n)
<a name="l00554"></a>00554                 {
<a name="l00555"></a>00555                 <span class="keywordflow">case</span> 0:
<a name="l00556"></a>00556                 <span class="keywordflow">case</span> 1:
<a name="l00557"></a>00557                 <span class="keywordflow">case</span> 2:
<a name="l00558"></a>00558                 <span class="keywordflow">case</span> 3:
<a name="l00559"></a>00559                 <span class="keywordflow">case</span> 4:
<a name="l00560"></a>00560                   <span class="keywordflow">return</span> 1;
<a name="l00561"></a>00561                   
<a name="l00562"></a>00562                 <span class="keywordflow">default</span>:
<a name="l00563"></a>00563                   <span class="keywordflow">return</span> 0;
<a name="l00564"></a>00564                 }
<a name="l00565"></a>00565             }
<a name="l00566"></a>00566 
<a name="l00567"></a>00567           <span class="keywordflow">default</span>:
<a name="l00568"></a>00568             {
<a name="l00569"></a>00569 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00570"></a>00570 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00571"></a>00571                             &lt;&lt; <span class="stringliteral">&quot; for FIRST order approximation!&quot;</span> 
<a name="l00572"></a>00572                             &lt;&lt; std::endl;
<a name="l00573"></a>00573 <span class="preprocessor">#endif</span>
<a name="l00574"></a>00574 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00575"></a>00575             }
<a name="l00576"></a>00576           }
<a name="l00577"></a>00577       }
<a name="l00578"></a>00578 
<a name="l00579"></a>00579       <span class="comment">// quadratic Lagrange shape functions</span>
<a name="l00580"></a>00580     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00581"></a>00581       {
<a name="l00582"></a>00582         <span class="keywordflow">switch</span> (t)
<a name="l00583"></a>00583           {
<a name="l00584"></a>00584           <span class="comment">// quadratic lagrange has one dof at each node</span>
<a name="l00585"></a>00585           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00586"></a>00586           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00587"></a>00587           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00588"></a>00588           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00589"></a>00589           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00590"></a>00590           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00591"></a>00591           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00592"></a>00592           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00593"></a>00593           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00594"></a>00594           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00595"></a>00595             <span class="keywordflow">return</span> 1;
<a name="l00596"></a>00596 
<a name="l00597"></a>00597           <span class="keywordflow">default</span>:
<a name="l00598"></a>00598             {
<a name="l00599"></a>00599 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00600"></a>00600 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00601"></a>00601                             &lt;&lt; <span class="stringliteral">&quot; for SECOND order approximation!&quot;</span> 
<a name="l00602"></a>00602                             &lt;&lt; std::endl;
<a name="l00603"></a>00603 <span class="preprocessor">#endif</span>
<a name="l00604"></a>00604 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00605"></a>00605             }
<a name="l00606"></a>00606           }
<a name="l00607"></a>00607       }
<a name="l00608"></a>00608 
<a name="l00609"></a>00609     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00610"></a>00610       {
<a name="l00611"></a>00611         <span class="keywordflow">switch</span> (t)
<a name="l00612"></a>00612           {
<a name="l00613"></a>00613             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00614"></a>00614             <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00615"></a>00615               <span class="keywordflow">return</span> 1;
<a name="l00616"></a>00616 
<a name="l00617"></a>00617           <span class="keywordflow">default</span>:
<a name="l00618"></a>00618             {
<a name="l00619"></a>00619 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00620"></a>00620 <span class="preprocessor"></span>              <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad ElemType = &quot;</span> &lt;&lt; t
<a name="l00621"></a>00621                             &lt;&lt; <span class="stringliteral">&quot; for THIRD order approximation!&quot;</span> 
<a name="l00622"></a>00622                             &lt;&lt; std::endl;
<a name="l00623"></a>00623 <span class="preprocessor">#endif</span>
<a name="l00624"></a>00624 <span class="preprocessor"></span>              libmesh_error();      
<a name="l00625"></a>00625             }
<a name="l00626"></a>00626           }
<a name="l00627"></a>00627       }
<a name="l00628"></a>00628 
<a name="l00629"></a>00629 
<a name="l00630"></a>00630       
<a name="l00631"></a>00631     <span class="keywordflow">default</span>:
<a name="l00632"></a>00632       libmesh_error();
<a name="l00633"></a>00633     }
<a name="l00634"></a>00634   
<a name="l00635"></a>00635   libmesh_error();  
<a name="l00636"></a>00636   <span class="keywordflow">return</span> 0;
<a name="l00637"></a>00637 }
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00642"></a>00642 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a6790b3764960ddd6e6faaa40bb0b4a65">FE&lt;Dim,T&gt;::n_dofs_per_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00643"></a>00643                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>)
<a name="l00644"></a>00644 {
<a name="l00645"></a>00645   <span class="comment">// Lagrange elements have no dofs per element</span>
<a name="l00646"></a>00646   <span class="comment">// (just at the nodes)</span>
<a name="l00647"></a>00647   
<a name="l00648"></a>00648   <span class="keywordflow">return</span> 0;
<a name="l00649"></a>00649 }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00654"></a>00654 <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classlibMesh_1_1FE.php#a26671578bbeec8d12a76e6d3de92c422">FE&lt;Dim,T&gt;::get_continuity</a>()<span class="keyword"> const</span>
<a name="l00655"></a>00655 <span class="keyword"></span>{
<a name="l00656"></a>00656   <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>;
<a name="l00657"></a>00657 }
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00662"></a>00662 <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FE.php#a6e3c6ecf80a5f9a057cd98710650b379">FE&lt;Dim,T&gt;::is_hierarchic</a>()<span class="keyword"> const</span>
<a name="l00663"></a>00663 <span class="keyword"></span>{
<a name="l00664"></a>00664   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00665"></a>00665 }
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00670"></a>00670 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00671"></a>00671 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a7ecb48abba2b40eef1c7c2d8d998cdf8">FE&lt;Dim,T&gt;::compute_constraints</a> (DofConstraints &amp;constraints,
<a name="l00672"></a>00672                                      DofMap &amp;dof_map,
<a name="l00673"></a>00673                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> variable_number,
<a name="l00674"></a>00674                                      <span class="keyword">const</span> Elem* elem)
<a name="l00675"></a>00675 {
<a name="l00676"></a>00676   <span class="comment">// Only constrain elements in 2,3D.</span>
<a name="l00677"></a>00677   <span class="keywordflow">if</span> (Dim == 1)
<a name="l00678"></a>00678     <span class="keywordflow">return</span>;
<a name="l00679"></a>00679 
<a name="l00680"></a>00680   libmesh_assert (elem != NULL);
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   <span class="comment">// Only constrain active and ancestor elements</span>
<a name="l00683"></a>00683   <span class="keywordflow">if</span> (elem-&gt;subactive())
<a name="l00684"></a>00684     <span class="keywordflow">return</span>;
<a name="l00685"></a>00685 
<a name="l00686"></a>00686   FEType fe_type = dof_map.variable_type(variable_number);
<a name="l00687"></a>00687   fe_type.order = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.order + elem-&gt;p_level());
<a name="l00688"></a>00688 
<a name="l00689"></a>00689   std::vector&lt;unsigned int&gt; my_dof_indices, parent_dof_indices;
<a name="l00690"></a>00690 
<a name="l00691"></a>00691   <span class="comment">// Look at the element faces.  Check to see if we need to </span>
<a name="l00692"></a>00692   <span class="comment">// build constraints.</span>
<a name="l00693"></a>00693   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;n_sides(); s++)
<a name="l00694"></a>00694     <span class="keywordflow">if</span> (elem-&gt;neighbor(s) != NULL)
<a name="l00695"></a>00695       <span class="keywordflow">if</span> (elem-&gt;neighbor(s)-&gt;level() &lt; elem-&gt;level()) <span class="comment">// constrain dofs shared between</span>
<a name="l00696"></a>00696         {                                                     <span class="comment">// this element and ones coarser</span>
<a name="l00697"></a>00697                                                               <span class="comment">// than this element.</span>
<a name="l00698"></a>00698           <span class="comment">// Get pointers to the elements of interest and its parent.</span>
<a name="l00699"></a>00699           <span class="keyword">const</span> Elem* parent = elem-&gt;parent();
<a name="l00700"></a>00700           
<a name="l00701"></a>00701           <span class="comment">// This can&#39;t happen...  Only level-0 elements have NULL</span>
<a name="l00702"></a>00702           <span class="comment">// parents, and no level-0 elements can be at a higher</span>
<a name="l00703"></a>00703           <span class="comment">// level than their neighbors!</span>
<a name="l00704"></a>00704           libmesh_assert (parent != NULL);
<a name="l00705"></a>00705           
<a name="l00706"></a>00706           <span class="keyword">const</span> AutoPtr&lt;Elem&gt; my_side     (elem-&gt;build_side(s));
<a name="l00707"></a>00707           <span class="keyword">const</span> AutoPtr&lt;Elem&gt; parent_side (parent-&gt;build_side(s));
<a name="l00708"></a>00708 
<a name="l00709"></a>00709           <span class="comment">// This function gets called element-by-element, so there</span>
<a name="l00710"></a>00710           <span class="comment">// will be a lot of memory allocation going on.  We can </span>
<a name="l00711"></a>00711           <span class="comment">// at least minimize this for the case of the dof indices</span>
<a name="l00712"></a>00712           <span class="comment">// by efficiently preallocating the requisite storage.</span>
<a name="l00713"></a>00713           my_dof_indices.reserve (my_side-&gt;n_nodes());
<a name="l00714"></a>00714           parent_dof_indices.reserve (parent_side-&gt;n_nodes());
<a name="l00715"></a>00715 
<a name="l00716"></a>00716           dof_map.dof_indices (my_side.get(), my_dof_indices,
<a name="l00717"></a>00717                                variable_number);
<a name="l00718"></a>00718           dof_map.dof_indices (parent_side.get(), parent_dof_indices,
<a name="l00719"></a>00719                                variable_number);
<a name="l00720"></a>00720   
<a name="l00721"></a>00721           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_dof=0;
<a name="l00722"></a>00722                my_dof&lt;<a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">FEInterface::n_dofs</a>(Dim-1, fe_type, my_side-&gt;type());
<a name="l00723"></a>00723                my_dof++)
<a name="l00724"></a>00724             {
<a name="l00725"></a>00725               libmesh_assert (my_dof &lt; my_side-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());
<a name="l00726"></a>00726               
<a name="l00727"></a>00727               <span class="comment">// My global dof index.</span>
<a name="l00728"></a>00728               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_dof_g = my_dof_indices[my_dof];
<a name="l00729"></a>00729               
<a name="l00730"></a>00730               <span class="comment">// The support point of the DOF</span>
<a name="l00731"></a>00731               <span class="keyword">const</span> Point&amp; support_point = my_side-&gt;point(my_dof);
<a name="l00732"></a>00732               
<a name="l00733"></a>00733               <span class="comment">// Figure out where my node lies on their reference element.</span>
<a name="l00734"></a>00734               <span class="keyword">const</span> Point mapped_point = <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(Dim-1, fe_type,
<a name="l00735"></a>00735                                                                   parent_side.get(),
<a name="l00736"></a>00736                                                                   support_point);
<a name="l00737"></a>00737               
<a name="l00738"></a>00738               <span class="comment">// Compute the parent&#39;s side shape function values.</span>
<a name="l00739"></a>00739               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> their_dof=0;
<a name="l00740"></a>00740                    their_dof&lt;<a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">FEInterface::n_dofs</a>(Dim-1, fe_type, parent_side-&gt;type());
<a name="l00741"></a>00741                    their_dof++)
<a name="l00742"></a>00742                 {
<a name="l00743"></a>00743                   libmesh_assert (their_dof &lt; parent_side-&gt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>());
<a name="l00744"></a>00744                   
<a name="l00745"></a>00745                   <span class="comment">// Their global dof index.</span>
<a name="l00746"></a>00746                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> their_dof_g =
<a name="l00747"></a>00747                                   parent_dof_indices[their_dof];
<a name="l00748"></a>00748                   
<a name="l00749"></a>00749                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> their_dof_value = <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">FEInterface::shape</a>(Dim-1,
<a name="l00750"></a>00750                                                                   fe_type,
<a name="l00751"></a>00751                                                                   parent_side-&gt;type(),
<a name="l00752"></a>00752                                                                   their_dof,
<a name="l00753"></a>00753                                                                   mapped_point);
<a name="l00754"></a>00754                   
<a name="l00755"></a>00755                   <span class="comment">// Only add non-zero and non-identity values</span>
<a name="l00756"></a>00756                   <span class="comment">// for Lagrange basis functions.</span>
<a name="l00757"></a>00757                   <span class="keywordflow">if</span> ((std::abs(their_dof_value) &gt; 1.e-5) &amp;&amp;
<a name="l00758"></a>00758                       (std::abs(their_dof_value) &lt; .999)) 
<a name="l00759"></a>00759                     {
<a name="l00760"></a>00760                       <span class="comment">// since we may be running this method concurretly </span>
<a name="l00761"></a>00761                       <span class="comment">// on multiple threads we need to acquire a lock </span>
<a name="l00762"></a>00762                       <span class="comment">// before modifying the shared constraint_row object.                   </span>
<a name="l00763"></a>00763                       Threads::spin_mutex::scoped_lock lock(<a class="code" href="namespacelibMesh_1_1Threads.php#aba1ae5c24686d2cd2fc7ccdc9537c4f5">Threads::spin_mtx</a>);
<a name="l00764"></a>00764 
<a name="l00765"></a>00765                       <span class="comment">// A reference to the constraint row.</span>
<a name="l00766"></a>00766                       <a class="code" href="namespacelibMesh.php#a919b3727a9707f23ecad00949d1d1c43">DofConstraintRow</a>&amp; constraint_row = constraints[my_dof_g];
<a name="l00767"></a>00767                       
<a name="l00768"></a>00768                       constraint_row.insert(std::make_pair (their_dof_g,
<a name="l00769"></a>00769                                                             their_dof_value));
<a name="l00770"></a>00770                     }
<a name="l00771"></a>00771 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00772"></a>00772 <span class="preprocessor"></span>                  <span class="comment">// Protect for the case u_i = 0.999 u_j,</span>
<a name="l00773"></a>00773                   <span class="comment">// in which case i better equal j.</span>
<a name="l00774"></a>00774                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (their_dof_value &gt;= .999)
<a name="l00775"></a>00775                     libmesh_assert (my_dof_g == their_dof_g);
<a name="l00776"></a>00776 <span class="preprocessor">#endif</span>
<a name="l00777"></a>00777 <span class="preprocessor"></span>                }                     
<a name="l00778"></a>00778             }
<a name="l00779"></a>00779         }
<a name="l00780"></a>00780 }
<a name="l00781"></a>00781 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00782"></a>00782 <span class="preprocessor"></span>
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 
<a name="l00785"></a>00785 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00786"></a>00786 <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FE.php#ae8089f56b5648f5657b5d85cd630b622">FE&lt;Dim,T&gt;::shapes_need_reinit</a>()<span class="keyword"> const</span>
<a name="l00787"></a>00787 <span class="keyword"></span>{
<a name="l00788"></a>00788   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00789"></a>00789 }
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00795"></a>00795 <span class="comment">// Explicit instantiation of member functions</span>
<a name="l00796"></a>00796 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(0,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>);
<a name="l00797"></a>00797 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>);
<a name="l00798"></a>00798 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>);
<a name="l00799"></a>00799 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>);
<a name="l00800"></a>00800 
<a name="l00801"></a>00801 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00802"></a>00802 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a7ecb48abba2b40eef1c7c2d8d998cdf8">FE&lt;2,LAGRANGE&gt;::compute_constraints</a>(DofConstraints&amp;, DofMap&amp;, 
<a name="l00803"></a>00803                                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00804"></a>00804                                                   <span class="keyword">const</span> Elem*);
<a name="l00805"></a>00805 <span class="keyword">template</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#a7ecb48abba2b40eef1c7c2d8d998cdf8">FE&lt;3,LAGRANGE&gt;::compute_constraints</a>(DofConstraints&amp;, DofMap&amp;, 
<a name="l00806"></a>00806                                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00807"></a>00807                                                   <span class="keyword">const</span> Elem*);
<a name="l00808"></a>00808 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00809"></a>00809 <span class="preprocessor"></span>
<a name="l00810"></a>00810 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
