<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fbfd1e4ea7786050feab5206011c3dac.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_macro.h</div>  </div>
</div>
<div class="contents">
<a href="fe__macro_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_macro.h 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __fe_macro_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __fe_macro_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00034"></a>00034 <span class="preprocessor">#ifndef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span>
<a name="l00036"></a>00036 <span class="preprocessor">#define INSTANTIATE_FE(_dim)   template class FE&lt; (_dim), CLOUGH&gt;; \</span>
<a name="l00037"></a>00037 <span class="preprocessor">                               template class FE&lt; (_dim), HERMITE&gt;;    \</span>
<a name="l00038"></a>00038 <span class="preprocessor">                               template class FE&lt; (_dim), HIERARCHIC&gt;;   \</span>
<a name="l00039"></a>00039 <span class="preprocessor">                               template class FE&lt; (_dim), LAGRANGE&gt;;   \</span>
<a name="l00040"></a>00040 <span class="preprocessor">                               template class FE&lt; (_dim), MONOMIAL&gt;;   \</span>
<a name="l00041"></a>00041 <span class="preprocessor">                               template class FE&lt; (_dim), SCALAR&gt;;   \</span>
<a name="l00042"></a>00042 <span class="preprocessor">                               template class FE&lt; (_dim), XYZ&gt;</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a>00044 <span class="preprocessor">#define INSTANTIATE_IMAP(_dim) \</span>
<a name="l00045"></a>00045 <span class="preprocessor">  template void FE&lt;_dim,CLOUGH&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool); \</span>
<a name="l00046"></a>00046 <span class="preprocessor">  template void FE&lt;_dim,HERMITE&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool); \</span>
<a name="l00047"></a>00047 <span class="preprocessor">  template void FE&lt;_dim,HIERARCHIC&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00048"></a>00048 <span class="preprocessor">  template void FE&lt;_dim,LAGRANGE&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00049"></a>00049 <span class="preprocessor">  template void FE&lt;_dim,MONOMIAL&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00050"></a>00050 <span class="preprocessor">  template void FE&lt;_dim,SCALAR&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00051"></a>00051 <span class="preprocessor">  template void FE&lt;_dim,XYZ&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool)</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span> 
<a name="l00053"></a>00053 <span class="preprocessor">#else //LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>
<a name="l00055"></a>00055 <span class="preprocessor">#define INSTANTIATE_FE(_dim)   template class FE&lt; (_dim), CLOUGH&gt;; \</span>
<a name="l00056"></a>00056 <span class="preprocessor">                               template class FE&lt; (_dim), HERMITE&gt;;    \</span>
<a name="l00057"></a>00057 <span class="preprocessor">                               template class FE&lt; (_dim), HIERARCHIC&gt;;   \</span>
<a name="l00058"></a>00058 <span class="preprocessor">                               template class FE&lt; (_dim), LAGRANGE&gt;;   \</span>
<a name="l00059"></a>00059 <span class="preprocessor">                               template class FE&lt; (_dim), MONOMIAL&gt;;   \</span>
<a name="l00060"></a>00060 <span class="preprocessor">                               template class FE&lt; (_dim), SCALAR&gt;;   \</span>
<a name="l00061"></a>00061 <span class="preprocessor">                               template class FE&lt; (_dim), BERNSTEIN&gt;;     \</span>
<a name="l00062"></a>00062 <span class="preprocessor">                               template class FE&lt; (_dim), SZABAB&gt;;     \</span>
<a name="l00063"></a>00063 <span class="preprocessor">                               template class FE&lt; (_dim), XYZ&gt;</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065 <span class="preprocessor">#define INSTANTIATE_IMAP(_dim) \</span>
<a name="l00066"></a>00066 <span class="preprocessor">  template void  FE&lt;_dim,CLOUGH&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool); \</span>
<a name="l00067"></a>00067 <span class="preprocessor">  template void  FE&lt;_dim,HERMITE&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool); \</span>
<a name="l00068"></a>00068 <span class="preprocessor">  template void  FE&lt;_dim,HIERARCHIC&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00069"></a>00069 <span class="preprocessor">  template void  FE&lt;_dim,LAGRANGE&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00070"></a>00070 <span class="preprocessor">  template void  FE&lt;_dim,MONOMIAL&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00071"></a>00071 <span class="preprocessor">  template void  FE&lt;_dim,SCALAR&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00072"></a>00072 <span class="preprocessor">  template void  FE&lt;_dim,BERNSTEIN&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00073"></a>00073 <span class="preprocessor">  template void  FE&lt;_dim,SZABAB&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool);\</span>
<a name="l00074"></a>00074 <span class="preprocessor">  template void  FE&lt;_dim,XYZ&gt;::inverse_map(const Elem*,const std::vector&lt;Point&gt;&amp;,std::vector&lt;Point&gt;&amp;,Real,bool)</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>
<a name="l00076"></a>00076 <span class="preprocessor">#endif //LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078 <span class="preprocessor">#define INSTANTIATE_MBRF(_dim,_t) \</span>
<a name="l00079"></a>00079 <span class="preprocessor">  template unsigned int FE&lt;_dim,_t&gt;::n_dofs_at_node(ElemType,Order,unsigned int); \</span>
<a name="l00080"></a>00080 <span class="preprocessor">  template unsigned int FE&lt;_dim,_t&gt;::n_dofs(ElemType,Order);\</span>
<a name="l00081"></a>00081 <span class="preprocessor">  template bool         FE&lt;_dim,_t&gt;::shapes_need_reinit() const;\</span>
<a name="l00082"></a>00082 <span class="preprocessor">  template FEContinuity FE&lt;_dim,_t&gt;::get_continuity() const;\</span>
<a name="l00083"></a>00083 <span class="preprocessor">  template bool         FE&lt;_dim,_t&gt;::is_hierarchic() const;\</span>
<a name="l00084"></a>00084 <span class="preprocessor">  template unsigned int FE&lt;_dim,_t&gt;::n_dofs_per_elem(ElemType,Order);\</span>
<a name="l00085"></a>00085 <span class="preprocessor">  template void         FE&lt;_dim,_t&gt;::nodal_soln(const Elem*,const Order,const std::vector&lt;Number&gt;&amp;,std::vector&lt;Number&gt;&amp;)</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>
<a name="l00087"></a>00087 <span class="preprocessor">#endif</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>
<a name="l00089"></a>00089 <span class="comment">// The Intel 7.1 compiler out at TACC required these, but they are used</span>
<a name="l00090"></a>00090 <span class="comment">// inside the inverse_map function so it seems like they should be instantiated</span>
<a name="l00091"></a>00091 <span class="comment">// by the INSTANTIATE_IMAP macro above?  Also for some reason it did not</span>
<a name="l00092"></a>00092 <span class="comment">// complain about map_zeta.</span>
<a name="l00093"></a>00093 <span class="preprocessor">#define INSTANTIATE_MAP(_dim) \</span>
<a name="l00094"></a>00094 <span class="preprocessor">  template Point FE&lt;_dim,LAGRANGE&gt;::map(const Elem*,const Point&amp;);\</span>
<a name="l00095"></a>00095 <span class="preprocessor">  template Point FE&lt;_dim,LAGRANGE&gt;::map_xi(const Elem*,const Point&amp;);\</span>
<a name="l00096"></a>00096 <span class="preprocessor">  template Point FE&lt;_dim,LAGRANGE&gt;::map_eta(const Elem*,const Point&amp;)</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
