<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_map.C</div>  </div>
</div>
<div class="contents">
<a href="fe__map_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_map.C 4390 2011-04-21 17:02:25Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::sqrt, std::abs</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="fe__macro_8h.php">fe_macro.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="classlibMesh_1_1FEBase.php#adba0bb8c55b1c53ac0cba7b1884180b0">00038</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#adba0bb8c55b1c53ac0cba7b1884180b0">FEBase::compute_single_point_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00039"></a>00039                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00040"></a>00040                                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   libmesh_assert (elem  != NULL);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="keywordflow">switch</span> (this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a>)
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046       <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00047"></a>00047       <span class="comment">// 0D</span>
<a name="l00048"></a>00048     <span class="keywordflow">case</span> 0:
<a name="l00049"></a>00049       {
<a name="l00050"></a>00050         <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[p] = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0);
<a name="l00051"></a>00051         <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>[p] = qw[p];
<a name="l00052"></a>00052         <span class="keywordflow">break</span>;
<a name="l00053"></a>00053       }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055       <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00056"></a>00056       <span class="comment">// 1D</span>
<a name="l00057"></a>00057     <span class="keywordflow">case</span> 1:
<a name="l00058"></a>00058       {
<a name="l00059"></a>00059         <span class="comment">// Clear the entities that will be summed</span>
<a name="l00060"></a>00060         <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[p].zero();
<a name="l00061"></a>00061         <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p].zero();
<a name="l00062"></a>00062 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>        <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>[p].zero();
<a name="l00064"></a>00064 <span class="preprocessor">#endif</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>        
<a name="l00066"></a>00066         <span class="comment">// compute x, dx, d2x at the quadrature point</span>
<a name="l00067"></a>00067         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>.size(); i++) <span class="comment">// sum over the nodes</span>
<a name="l00068"></a>00068           {
<a name="l00069"></a>00069             <span class="comment">// Reference to the point, helps eliminate</span>
<a name="l00070"></a>00070             <span class="comment">// exessive temporaries in the inner loop</span>
<a name="l00071"></a>00071             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; elem_point = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i);
<a name="l00072"></a>00072             
<a name="l00073"></a>00073             <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[p].add_scaled          (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>[i][p]    );
<a name="l00074"></a>00074             <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p].add_scaled  (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a4ce4aa7d641ab7d3a38bb5be8db1fa62">dphidxi_map</a>[i][p]);
<a name="l00075"></a>00075 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>            <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>[p].add_scaled(elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#ada94b1f5b37ea3deab82c4146cb2d0aa">d2phidxi2_map</a>[i][p]);
<a name="l00077"></a>00077 <span class="preprocessor">#endif</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span>          }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080         <span class="comment">// Compute the jacobian</span>
<a name="l00081"></a>00081         <span class="comment">//</span>
<a name="l00082"></a>00082         <span class="comment">// 1D elements can live in 2D or 3D space.</span>
<a name="l00083"></a>00083         <span class="comment">// The transformation matrix from local-&gt;global</span>
<a name="l00084"></a>00084         <span class="comment">// coordinates is</span>
<a name="l00085"></a>00085         <span class="comment">//</span>
<a name="l00086"></a>00086         <span class="comment">// T = | dx/dxi | </span>
<a name="l00087"></a>00087         <span class="comment">//     | dy/dxi |</span>
<a name="l00088"></a>00088         <span class="comment">//     | dz/dxi |</span>
<a name="l00089"></a>00089         <span class="comment">//</span>
<a name="l00090"></a>00090         <span class="comment">// The generalized determinant of T (from the</span>
<a name="l00091"></a>00091         <span class="comment">// so-called &quot;normal&quot; eqns.) is</span>
<a name="l00092"></a>00092         <span class="comment">// jac = &quot;det(T)&quot; = sqrt(det(T&#39;T))</span>
<a name="l00093"></a>00093         <span class="comment">//</span>
<a name="l00094"></a>00094         <span class="comment">// where T&#39;= transpose of T, so</span>
<a name="l00095"></a>00095         <span class="comment">//</span>
<a name="l00096"></a>00096         <span class="comment">// jac = sqrt( (dx/dxi)^2 + (dy/dxi)^2 + (dz/dxi)^2 )</span>
<a name="l00097"></a>00097         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> jac = <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p].size();
<a name="l00098"></a>00098             
<a name="l00099"></a>00099         <span class="keywordflow">if</span> (jac &lt;= 0.)
<a name="l00100"></a>00100           {
<a name="l00101"></a>00101             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: negative Jacobian: &quot;</span>
<a name="l00102"></a>00102                           &lt;&lt; jac
<a name="l00103"></a>00103                           &lt;&lt; <span class="stringliteral">&quot; in element &quot;</span> 
<a name="l00104"></a>00104                           &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()
<a name="l00105"></a>00105                           &lt;&lt; std::endl;
<a name="l00106"></a>00106             libmesh_error();
<a name="l00107"></a>00107           }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109         <span class="comment">// The inverse Jacobian entries also come from the</span>
<a name="l00110"></a>00110         <span class="comment">// generalized inverse of T (see also the 2D element</span>
<a name="l00111"></a>00111         <span class="comment">// living in 3D code).</span>
<a name="l00112"></a>00112         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> jacm2 = 1./jac/jac;
<a name="l00113"></a>00113         <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p] = jacm2*<a class="code" href="classlibMesh_1_1FEBase.php#aa173e314ea4d6da0e051aba7357393b3">dxdxi_map</a>(p);
<a name="l00114"></a>00114 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00115"></a>00115 <span class="preprocessor"></span>        <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p] = jacm2*<a class="code" href="classlibMesh_1_1FEBase.php#a70c807295d3ee32f02e8db8c064c2a69">dydxi_map</a>(p);
<a name="l00116"></a>00116 <span class="preprocessor">#endif</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>        <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] = jacm2*<a class="code" href="classlibMesh_1_1FEBase.php#add885fcfc231cb5f1bae5fa79e26b5ed">dzdxi_map</a>(p);
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>
<a name="l00121"></a>00121         <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>[p] = jac*qw[p];
<a name="l00122"></a>00122 
<a name="l00123"></a>00123         <span class="comment">// done computing the map</span>
<a name="l00124"></a>00124         <span class="keywordflow">break</span>;
<a name="l00125"></a>00125       }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127       
<a name="l00128"></a>00128       <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00129"></a>00129       <span class="comment">// 2D</span>
<a name="l00130"></a>00130     <span class="keywordflow">case</span> 2:
<a name="l00131"></a>00131       {
<a name="l00132"></a>00132         <span class="comment">//------------------------------------------------------------------</span>
<a name="l00133"></a>00133         <span class="comment">// Compute the (x,y) values at the quadrature points,</span>
<a name="l00134"></a>00134         <span class="comment">// the Jacobian at the quadrature points</span>
<a name="l00135"></a>00135 
<a name="l00136"></a>00136         <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[p].zero();
<a name="l00137"></a>00137 
<a name="l00138"></a>00138         <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p].zero();
<a name="l00139"></a>00139         <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p].zero();
<a name="l00140"></a>00140 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span>        <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>[p].zero();
<a name="l00142"></a>00142         <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>[p].zero();
<a name="l00143"></a>00143         <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>[p].zero();
<a name="l00144"></a>00144 <span class="preprocessor">#endif</span>
<a name="l00145"></a>00145 <span class="preprocessor"></span>        
<a name="l00146"></a>00146         
<a name="l00147"></a>00147         <span class="comment">// compute (x,y) at the quadrature points, derivatives once</span>
<a name="l00148"></a>00148         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>.size(); i++) <span class="comment">// sum over the nodes</span>
<a name="l00149"></a>00149           {
<a name="l00150"></a>00150             <span class="comment">// Reference to the point, helps eliminate</span>
<a name="l00151"></a>00151             <span class="comment">// exessive temporaries in the inner loop</span>
<a name="l00152"></a>00152             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; elem_point = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i);
<a name="l00153"></a>00153             
<a name="l00154"></a>00154             <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[p].add_scaled          (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>[i][p]     );
<a name="l00155"></a>00155 
<a name="l00156"></a>00156             <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p].add_scaled      (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a4ce4aa7d641ab7d3a38bb5be8db1fa62">dphidxi_map</a>[i][p] );
<a name="l00157"></a>00157             <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p].add_scaled     (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a7cd2ca921c422d405ac9518c91d1eebf">dphideta_map</a>[i][p]);
<a name="l00158"></a>00158 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00159"></a>00159 <span class="preprocessor"></span>            <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>[p].add_scaled    (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#ada94b1f5b37ea3deab82c4146cb2d0aa">d2phidxi2_map</a>[i][p]);
<a name="l00160"></a>00160             <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>[p].add_scaled (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a568b109f25df018387061568627d03e0">d2phidxideta_map</a>[i][p]);
<a name="l00161"></a>00161             <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>[p].add_scaled   (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a0d690cfc9d95b964392128e8c3e5c9af">d2phideta2_map</a>[i][p]);
<a name="l00162"></a>00162 <span class="preprocessor">#endif</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>          }
<a name="l00164"></a>00164         
<a name="l00165"></a>00165         <span class="comment">// compute the jacobian once</span>
<a name="l00166"></a>00166         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dx_dxi = <a class="code" href="classlibMesh_1_1FEBase.php#aa173e314ea4d6da0e051aba7357393b3">dxdxi_map</a>(p),
<a name="l00167"></a>00167                    dx_deta = <a class="code" href="classlibMesh_1_1FEBase.php#adbe405374738b13bcc4237c470691994">dxdeta_map</a>(p),
<a name="l00168"></a>00168                    dy_dxi = <a class="code" href="classlibMesh_1_1FEBase.php#a70c807295d3ee32f02e8db8c064c2a69">dydxi_map</a>(p),
<a name="l00169"></a>00169                    dy_deta = <a class="code" href="classlibMesh_1_1FEBase.php#aa2b58e35c68f2799aa973f54ae6bf1df">dydeta_map</a>(p);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#if LIBMESH_DIM == 2</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>        <span class="comment">// Compute the Jacobian.  This assumes the 2D face</span>
<a name="l00173"></a>00173         <span class="comment">// lives in 2D space</span>
<a name="l00174"></a>00174         <span class="comment">//</span>
<a name="l00175"></a>00175         <span class="comment">// Symbolically, the matrix determinant is</span>
<a name="l00176"></a>00176         <span class="comment">//</span>
<a name="l00177"></a>00177         <span class="comment">//         | dx/dxi  dx/deta |</span>
<a name="l00178"></a>00178         <span class="comment">// jac =   | dy/dxi  dy/deta |</span>
<a name="l00179"></a>00179         <span class="comment">//         </span>
<a name="l00180"></a>00180         <span class="comment">// jac = dx/dxi*dy/deta - dx/deta*dy/dxi </span>
<a name="l00181"></a>00181         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> jac = (dx_dxi*dy_deta - dx_deta*dy_dxi);
<a name="l00182"></a>00182             
<a name="l00183"></a>00183         <span class="keywordflow">if</span> (jac &lt;= 0.)
<a name="l00184"></a>00184           {
<a name="l00185"></a>00185             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: negative Jacobian: &quot;</span>
<a name="l00186"></a>00186                           &lt;&lt; jac
<a name="l00187"></a>00187                           &lt;&lt; <span class="stringliteral">&quot; in element &quot;</span> 
<a name="l00188"></a>00188                           &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()
<a name="l00189"></a>00189                           &lt;&lt; std::endl;
<a name="l00190"></a>00190             libmesh_error();
<a name="l00191"></a>00191           }
<a name="l00192"></a>00192             
<a name="l00193"></a>00193         <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>[p] = jac*qw[p];
<a name="l00194"></a>00194             
<a name="l00195"></a>00195         <span class="comment">// Compute the shape function derivatives wrt x,y at the</span>
<a name="l00196"></a>00196         <span class="comment">// quadrature points</span>
<a name="l00197"></a>00197         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> inv_jac = 1./jac;
<a name="l00198"></a>00198             
<a name="l00199"></a>00199         <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]  =  dy_deta*inv_jac; <span class="comment">//dxi/dx  =  (1/J)*dy/deta</span>
<a name="l00200"></a>00200         <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p]  = -dx_deta*inv_jac; <span class="comment">//dxi/dy  = -(1/J)*dx/deta</span>
<a name="l00201"></a>00201         <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p] = -dy_dxi* inv_jac; <span class="comment">//deta/dx = -(1/J)*dy/dxi</span>
<a name="l00202"></a>00202         <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p] =  dx_dxi* inv_jac; <span class="comment">//deta/dy =  (1/J)*dx/dxi</span>
<a name="l00203"></a>00203 
<a name="l00204"></a>00204         <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] = 0.;
<a name="l00205"></a>00205 <span class="preprocessor">#else</span>
<a name="l00206"></a>00206 <span class="preprocessor"></span>
<a name="l00207"></a>00207         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dz_dxi = <a class="code" href="classlibMesh_1_1FEBase.php#add885fcfc231cb5f1bae5fa79e26b5ed">dzdxi_map</a>(p),
<a name="l00208"></a>00208                    dz_deta = <a class="code" href="classlibMesh_1_1FEBase.php#a0afe7058842193201f4754362f3e40df">dzdeta_map</a>(p);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210         <span class="comment">// Compute the Jacobian.  This assumes a 2D face in</span>
<a name="l00211"></a>00211         <span class="comment">// 3D space.</span>
<a name="l00212"></a>00212         <span class="comment">//</span>
<a name="l00213"></a>00213         <span class="comment">// The transformation matrix T from local to global</span>
<a name="l00214"></a>00214         <span class="comment">// coordinates is</span>
<a name="l00215"></a>00215         <span class="comment">//</span>
<a name="l00216"></a>00216         <span class="comment">//         | dx/dxi  dx/deta |</span>
<a name="l00217"></a>00217         <span class="comment">//     T = | dy/dxi  dy/deta |</span>
<a name="l00218"></a>00218         <span class="comment">//         | dz/dxi  dz/deta |</span>
<a name="l00219"></a>00219         <span class="comment">// note det(T&#39; T) = det(T&#39;)det(T) = det(T)det(T)</span>
<a name="l00220"></a>00220         <span class="comment">// so det(T) = std::sqrt(det(T&#39; T))</span>
<a name="l00221"></a>00221         <span class="comment">//</span>
<a name="l00222"></a>00222         <span class="comment">//----------------------------------------------</span>
<a name="l00223"></a>00223         <span class="comment">// Notes:</span>
<a name="l00224"></a>00224         <span class="comment">//</span>
<a name="l00225"></a>00225         <span class="comment">//       dX = R dXi -&gt; R&#39;dX = R&#39;R dXi</span>
<a name="l00226"></a>00226         <span class="comment">// (R^-1)dX =   dXi    [(R&#39;R)^-1 R&#39;]dX = dXi </span>
<a name="l00227"></a>00227         <span class="comment">//</span>
<a name="l00228"></a>00228         <span class="comment">// so R^-1 = (R&#39;R)^-1 R&#39;</span>
<a name="l00229"></a>00229         <span class="comment">//</span>
<a name="l00230"></a>00230         <span class="comment">// and R^-1 R = (R&#39;R)^-1 R&#39;R = I.</span>
<a name="l00231"></a>00231         <span class="comment">//</span>
<a name="l00232"></a>00232         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g11 = (dx_dxi*dx_dxi +
<a name="l00233"></a>00233                           dy_dxi*dy_dxi +
<a name="l00234"></a>00234                           dz_dxi*dz_dxi);
<a name="l00235"></a>00235             
<a name="l00236"></a>00236         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g12 = (dx_dxi*dx_deta +
<a name="l00237"></a>00237                           dy_dxi*dy_deta +
<a name="l00238"></a>00238                           dz_dxi*dz_deta);
<a name="l00239"></a>00239             
<a name="l00240"></a>00240         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g21 = g12;
<a name="l00241"></a>00241             
<a name="l00242"></a>00242         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g22 = (dx_deta*dx_deta +
<a name="l00243"></a>00243                           dy_deta*dy_deta +
<a name="l00244"></a>00244                           dz_deta*dz_deta);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> det = (g11*g22 - g12*g21);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248         <span class="keywordflow">if</span> (det &lt;= 0.)
<a name="l00249"></a>00249           {
<a name="l00250"></a>00250             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: negative Jacobian! &quot;</span>
<a name="l00251"></a>00251                           &lt;&lt; <span class="stringliteral">&quot; in element &quot;</span> 
<a name="l00252"></a>00252                           &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()
<a name="l00253"></a>00253                           &lt;&lt; std::endl;
<a name="l00254"></a>00254             libmesh_error();
<a name="l00255"></a>00255           }
<a name="l00256"></a>00256               
<a name="l00257"></a>00257         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> inv_det = 1./det;
<a name="l00258"></a>00258         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> jac = std::sqrt(det);
<a name="l00259"></a>00259             
<a name="l00260"></a>00260         <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>[p] = jac*qw[p];
<a name="l00261"></a>00261 
<a name="l00262"></a>00262         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g11inv =  g22*inv_det;
<a name="l00263"></a>00263         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g12inv = -g12*inv_det;
<a name="l00264"></a>00264         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g21inv = -g21*inv_det;
<a name="l00265"></a>00265         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g22inv =  g11*inv_det;
<a name="l00266"></a>00266 
<a name="l00267"></a>00267         <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]  = g11inv*dx_dxi + g12inv*dx_deta;
<a name="l00268"></a>00268         <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p]  = g11inv*dy_dxi + g12inv*dy_deta;
<a name="l00269"></a>00269         <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p]  = g11inv*dz_dxi + g12inv*dz_deta;
<a name="l00270"></a>00270             
<a name="l00271"></a>00271         <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p] = g21inv*dx_dxi + g22inv*dx_deta;
<a name="l00272"></a>00272         <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p] = g21inv*dy_dxi + g22inv*dy_deta;
<a name="l00273"></a>00273         <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] = g21inv*dz_dxi + g22inv*dz_deta;
<a name="l00274"></a>00274                             
<a name="l00275"></a>00275 <span class="preprocessor">#endif</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span>        <span class="comment">// done computing the map</span>
<a name="l00277"></a>00277         <span class="keywordflow">break</span>;
<a name="l00278"></a>00278       }
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281       
<a name="l00282"></a>00282       <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00283"></a>00283       <span class="comment">// 3D</span>
<a name="l00284"></a>00284     <span class="keywordflow">case</span> 3:
<a name="l00285"></a>00285       {
<a name="l00286"></a>00286         <span class="comment">//------------------------------------------------------------------</span>
<a name="l00287"></a>00287         <span class="comment">// Compute the (x,y,z) values at the quadrature points,</span>
<a name="l00288"></a>00288         <span class="comment">// the Jacobian at the quadrature point</span>
<a name="l00289"></a>00289 
<a name="l00290"></a>00290         <span class="comment">// Clear the entities that will be summed</span>
<a name="l00291"></a>00291         <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[p].zero           ();
<a name="l00292"></a>00292         <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p].zero   ();
<a name="l00293"></a>00293         <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p].zero  ();
<a name="l00294"></a>00294         <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[p].zero ();
<a name="l00295"></a>00295 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00296"></a>00296 <span class="preprocessor"></span>        <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>[p].zero();
<a name="l00297"></a>00297         <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>[p].zero();
<a name="l00298"></a>00298         <a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">d2xyzdxidzeta_map</a>[p].zero();
<a name="l00299"></a>00299         <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>[p].zero();
<a name="l00300"></a>00300         <a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">d2xyzdetadzeta_map</a>[p].zero();
<a name="l00301"></a>00301         <a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">d2xyzdzeta2_map</a>[p].zero();
<a name="l00302"></a>00302 <span class="preprocessor">#endif</span>
<a name="l00303"></a>00303 <span class="preprocessor"></span>        
<a name="l00304"></a>00304         
<a name="l00305"></a>00305         <span class="comment">// compute (x,y,z) at the quadrature points,</span>
<a name="l00306"></a>00306         <span class="comment">// dxdxi,   dydxi,   dzdxi,</span>
<a name="l00307"></a>00307         <span class="comment">// dxdeta,  dydeta,  dzdeta,</span>
<a name="l00308"></a>00308         <span class="comment">// dxdzeta, dydzeta, dzdzeta  all once</span>
<a name="l00309"></a>00309         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>.size(); i++) <span class="comment">// sum over the nodes</span>
<a name="l00310"></a>00310           {
<a name="l00311"></a>00311             <span class="comment">// Reference to the point, helps eliminate</span>
<a name="l00312"></a>00312             <span class="comment">// exessive temporaries in the inner loop</span>
<a name="l00313"></a>00313             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; elem_point = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i);
<a name="l00314"></a>00314             
<a name="l00315"></a>00315             <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[p].add_scaled           (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>[i][p]      );
<a name="l00316"></a>00316             <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p].add_scaled   (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a4ce4aa7d641ab7d3a38bb5be8db1fa62">dphidxi_map</a>[i][p]  );
<a name="l00317"></a>00317             <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p].add_scaled  (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a7cd2ca921c422d405ac9518c91d1eebf">dphideta_map</a>[i][p] );
<a name="l00318"></a>00318             <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[p].add_scaled (elem_point, <a class="code" href="classlibMesh_1_1FEBase.php#a4ee95ba576c7a780f489e80a623b59b3">dphidzeta_map</a>[i][p]);
<a name="l00319"></a>00319 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span>            <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>[p].add_scaled      (elem_point,
<a name="l00321"></a>00321                                                <a class="code" href="classlibMesh_1_1FEBase.php#ada94b1f5b37ea3deab82c4146cb2d0aa">d2phidxi2_map</a>[i][p]);
<a name="l00322"></a>00322             <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>[p].add_scaled   (elem_point,
<a name="l00323"></a>00323                                                <a class="code" href="classlibMesh_1_1FEBase.php#a568b109f25df018387061568627d03e0">d2phidxideta_map</a>[i][p]);
<a name="l00324"></a>00324             <a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">d2xyzdxidzeta_map</a>[p].add_scaled  (elem_point,
<a name="l00325"></a>00325                                                <a class="code" href="classlibMesh_1_1FEBase.php#af478144998beaa1c7465ac3434b27b4a">d2phidxidzeta_map</a>[i][p]);
<a name="l00326"></a>00326             <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>[p].add_scaled     (elem_point,
<a name="l00327"></a>00327                                                <a class="code" href="classlibMesh_1_1FEBase.php#a0d690cfc9d95b964392128e8c3e5c9af">d2phideta2_map</a>[i][p]);
<a name="l00328"></a>00328             <a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">d2xyzdetadzeta_map</a>[p].add_scaled (elem_point,
<a name="l00329"></a>00329                                                <a class="code" href="classlibMesh_1_1FEBase.php#ad27265d343c92a7f614f44b59350a4e6">d2phidetadzeta_map</a>[i][p]);
<a name="l00330"></a>00330             <a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">d2xyzdzeta2_map</a>[p].add_scaled    (elem_point,
<a name="l00331"></a>00331                                                <a class="code" href="classlibMesh_1_1FEBase.php#ab705352c53f9bf0a0a48f1411448d674">d2phidzeta2_map</a>[i][p]);
<a name="l00332"></a>00332 <span class="preprocessor">#endif</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>          }
<a name="l00334"></a>00334         
<a name="l00335"></a>00335         <span class="comment">// compute the jacobian</span>
<a name="l00336"></a>00336         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l00337"></a>00337           dx_dxi   = <a class="code" href="classlibMesh_1_1FEBase.php#aa173e314ea4d6da0e051aba7357393b3">dxdxi_map</a>(p),   dy_dxi   = <a class="code" href="classlibMesh_1_1FEBase.php#a70c807295d3ee32f02e8db8c064c2a69">dydxi_map</a>(p),   dz_dxi   = <a class="code" href="classlibMesh_1_1FEBase.php#add885fcfc231cb5f1bae5fa79e26b5ed">dzdxi_map</a>(p),
<a name="l00338"></a>00338           dx_deta  = <a class="code" href="classlibMesh_1_1FEBase.php#adbe405374738b13bcc4237c470691994">dxdeta_map</a>(p),  dy_deta  = <a class="code" href="classlibMesh_1_1FEBase.php#aa2b58e35c68f2799aa973f54ae6bf1df">dydeta_map</a>(p),  dz_deta  = <a class="code" href="classlibMesh_1_1FEBase.php#a0afe7058842193201f4754362f3e40df">dzdeta_map</a>(p),
<a name="l00339"></a>00339           dx_dzeta = <a class="code" href="classlibMesh_1_1FEBase.php#a1702b8d10f490aff3a311cf68237cf58">dxdzeta_map</a>(p), dy_dzeta = <a class="code" href="classlibMesh_1_1FEBase.php#ae1d648a326b54e268be20fd640a40eb3">dydzeta_map</a>(p), dz_dzeta = <a class="code" href="classlibMesh_1_1FEBase.php#a10703c0c0035098e9a6e0aca97beb57c">dzdzeta_map</a>(p);
<a name="l00340"></a>00340             
<a name="l00341"></a>00341         <span class="comment">// Symbolically, the matrix determinant is</span>
<a name="l00342"></a>00342         <span class="comment">//</span>
<a name="l00343"></a>00343         <span class="comment">//         | dx/dxi   dy/dxi   dz/dxi   |</span>
<a name="l00344"></a>00344         <span class="comment">// jac =   | dx/deta  dy/deta  dz/deta  |</span>
<a name="l00345"></a>00345         <span class="comment">//         | dx/dzeta dy/dzeta dz/dzeta |</span>
<a name="l00346"></a>00346         <span class="comment">// </span>
<a name="l00347"></a>00347         <span class="comment">// jac = dx/dxi*(dy/deta*dz/dzeta - dz/deta*dy/dzeta) +</span>
<a name="l00348"></a>00348         <span class="comment">//       dy/dxi*(dz/deta*dx/dzeta - dx/deta*dz/dzeta) +</span>
<a name="l00349"></a>00349         <span class="comment">//       dz/dxi*(dx/deta*dy/dzeta - dy/deta*dx/dzeta)</span>
<a name="l00350"></a>00350 
<a name="l00351"></a>00351         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> jac = (dx_dxi*(dy_deta*dz_dzeta - dz_deta*dy_dzeta)  +
<a name="l00352"></a>00352                           dy_dxi*(dz_deta*dx_dzeta - dx_deta*dz_dzeta)  +
<a name="l00353"></a>00353                           dz_dxi*(dx_deta*dy_dzeta - dy_deta*dx_dzeta));
<a name="l00354"></a>00354             
<a name="l00355"></a>00355         <span class="keywordflow">if</span> (jac &lt;= 0.)
<a name="l00356"></a>00356           {
<a name="l00357"></a>00357             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: negative Jacobian: &quot;</span>
<a name="l00358"></a>00358                           &lt;&lt; jac
<a name="l00359"></a>00359                           &lt;&lt; <span class="stringliteral">&quot; in element &quot;</span> 
<a name="l00360"></a>00360                           &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()
<a name="l00361"></a>00361                           &lt;&lt; std::endl;
<a name="l00362"></a>00362             libmesh_error();
<a name="l00363"></a>00363           }
<a name="l00364"></a>00364 
<a name="l00365"></a>00365         <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>[p] = jac*qw[p];
<a name="l00366"></a>00366             
<a name="l00367"></a>00367             <span class="comment">// Compute the shape function derivatives wrt x,y at the</span>
<a name="l00368"></a>00368             <span class="comment">// quadrature points</span>
<a name="l00369"></a>00369         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> inv_jac  = 1./jac;       
<a name="l00370"></a>00370             
<a name="l00371"></a>00371         <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p]   = (dy_deta*dz_dzeta - dz_deta*dy_dzeta)*inv_jac;
<a name="l00372"></a>00372         <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p]   = (dz_deta*dx_dzeta - dx_deta*dz_dzeta)*inv_jac;
<a name="l00373"></a>00373         <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p]   = (dx_deta*dy_dzeta - dy_deta*dx_dzeta)*inv_jac;
<a name="l00374"></a>00374             
<a name="l00375"></a>00375         <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p]  = (dz_dxi*dy_dzeta  - dy_dxi*dz_dzeta )*inv_jac;
<a name="l00376"></a>00376         <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p]  = (dx_dxi*dz_dzeta  - dz_dxi*dx_dzeta )*inv_jac;
<a name="l00377"></a>00377         <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p]  = (dy_dxi*dx_dzeta  - dx_dxi*dy_dzeta )*inv_jac;
<a name="l00378"></a>00378             
<a name="l00379"></a>00379         <a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p] = (dy_dxi*dz_deta   - dz_dxi*dy_deta  )*inv_jac;
<a name="l00380"></a>00380         <a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p] = (dz_dxi*dx_deta   - dx_dxi*dz_deta  )*inv_jac;
<a name="l00381"></a>00381         <a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] = (dx_dxi*dy_deta   - dy_dxi*dx_deta  )*inv_jac;
<a name="l00382"></a>00382         
<a name="l00383"></a>00383         <span class="comment">// done computing the map</span>
<a name="l00384"></a>00384         <span class="keywordflow">break</span>;
<a name="l00385"></a>00385       }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387     <span class="keywordflow">default</span>:
<a name="l00388"></a>00388       libmesh_error();
<a name="l00389"></a>00389     }
<a name="l00390"></a>00390 }
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00393"></a><a class="code" href="classlibMesh_1_1FEBase.php#ac2f2ae3020f2bd820e84221b723fcb12">00393</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ac2f2ae3020f2bd820e84221b723fcb12">FEBase::resize_map_vectors</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp)
<a name="l00394"></a>00394 {
<a name="l00395"></a>00395   <span class="comment">// Resize the vectors to hold data at the quadrature points</span>
<a name="l00396"></a>00396   <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>.resize(n_qp);
<a name="l00397"></a>00397   <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>.resize(n_qp);
<a name="l00398"></a>00398   <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>.resize(n_qp);
<a name="l00399"></a>00399   <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>.resize(n_qp); <span class="comment">// 1D element may live in 2D ...</span>
<a name="l00400"></a>00400   <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>.resize(n_qp); <span class="comment">// ... or 3D</span>
<a name="l00401"></a>00401 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00402"></a>00402 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>.resize(n_qp);
<a name="l00403"></a>00403 <span class="preprocessor">#endif</span>
<a name="l00404"></a>00404 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a> &gt; 1)
<a name="l00405"></a>00405     {
<a name="l00406"></a>00406       <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>.resize(n_qp);
<a name="l00407"></a>00407       <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>.resize(n_qp);
<a name="l00408"></a>00408       <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>.resize(n_qp);
<a name="l00409"></a>00409       <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>.resize(n_qp);
<a name="l00410"></a>00410 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00411"></a>00411 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>.resize(n_qp);
<a name="l00412"></a>00412       <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>.resize(n_qp);
<a name="l00413"></a>00413 <span class="preprocessor">#endif</span>
<a name="l00414"></a>00414 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a> &gt; 2)
<a name="l00415"></a>00415         {
<a name="l00416"></a>00416           <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>.resize (n_qp);
<a name="l00417"></a>00417           <a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>.resize   (n_qp);
<a name="l00418"></a>00418           <a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>.resize   (n_qp);
<a name="l00419"></a>00419           <a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>.resize   (n_qp);
<a name="l00420"></a>00420 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00421"></a>00421 <span class="preprocessor"></span>          <a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">d2xyzdxidzeta_map</a>.resize(n_qp);
<a name="l00422"></a>00422           <a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">d2xyzdetadzeta_map</a>.resize(n_qp);
<a name="l00423"></a>00423           <a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">d2xyzdzeta2_map</a>.resize(n_qp);
<a name="l00424"></a>00424 <span class="preprocessor">#endif</span>
<a name="l00425"></a>00425 <span class="preprocessor"></span>        }
<a name="l00426"></a>00426     }
<a name="l00427"></a>00427     
<a name="l00428"></a>00428   <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>.resize(n_qp);
<a name="l00429"></a>00429 }
<a name="l00430"></a>00430 
<a name="l00431"></a><a class="code" href="classlibMesh_1_1FEBase.php#ab2a635bf29b6bc9d23590c1b4152b1df">00431</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#ab2a635bf29b6bc9d23590c1b4152b1df">FEBase::compute_affine_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00432"></a>00432                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00433"></a>00433 {
<a name="l00434"></a>00434    <span class="comment">// Start logging the map computation.</span>
<a name="l00435"></a>00435   START_LOG(<span class="stringliteral">&quot;compute_affine_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);  
<a name="l00436"></a>00436 
<a name="l00437"></a>00437   libmesh_assert (elem  != NULL);
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>        n_qp = qw.size();
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <span class="comment">// Resize the vectors to hold data at the quadrature points</span>
<a name="l00442"></a>00442   this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#ac2f2ae3020f2bd820e84221b723fcb12">resize_map_vectors</a>(n_qp);
<a name="l00443"></a>00443 
<a name="l00444"></a>00444   <span class="comment">// Compute map at quadrature point 0</span>
<a name="l00445"></a>00445   this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#adba0bb8c55b1c53ac0cba7b1884180b0">compute_single_point_map</a>(qw, elem, 0);
<a name="l00446"></a>00446   
<a name="l00447"></a>00447   <span class="comment">// Compute xyz at all other quadrature points</span>
<a name="l00448"></a>00448   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;n_qp; p++)
<a name="l00449"></a>00449     {
<a name="l00450"></a>00450       <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[p].zero();
<a name="l00451"></a>00451       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>.size(); i++) <span class="comment">// sum over the nodes</span>
<a name="l00452"></a>00452         <a class="code" href="classlibMesh_1_1FEBase.php#ab172fc7fa719be569a8ab67bc33755a1">xyz</a>[p].add_scaled        (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i), <a class="code" href="classlibMesh_1_1FEBase.php#a74a01fb9954c6644dd3e42c2dff29623">phi_map</a>[i][p]    );
<a name="l00453"></a>00453     }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   <span class="comment">// Copy other map data from quadrature point 0</span>
<a name="l00456"></a>00456   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p&lt;n_qp; p++) <span class="comment">// for each extra quadrature point</span>
<a name="l00457"></a>00457     {
<a name="l00458"></a>00458       <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#ad68d0a6127a9c54b3d6800ff91981523">dxyzdxi_map</a>[0];
<a name="l00459"></a>00459       <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#a2bbf05f3a09e39f3580746ee0872d7dd">dxidx_map</a>[0];
<a name="l00460"></a>00460       <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#a33818360df704d7bffa5918c5afc8e51">dxidy_map</a>[0];
<a name="l00461"></a>00461       <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#a52734d3ba88b2602d385908b2170d19e">dxidz_map</a>[0];
<a name="l00462"></a>00462 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00463"></a>00463 <span class="preprocessor"></span>      <span class="comment">// The map should be affine, so second derivatives are zero</span>
<a name="l00464"></a>00464       <a class="code" href="classlibMesh_1_1FEBase.php#a9f0ecbf196b5e9d14edf43c7f1beca1c">d2xyzdxi2_map</a>[p] = 0.;
<a name="l00465"></a>00465 <span class="preprocessor">#endif</span>
<a name="l00466"></a>00466 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a> &gt; 1)
<a name="l00467"></a>00467         {
<a name="l00468"></a>00468           <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#a86d96fe77ae2c9d4887431ae86686697">dxyzdeta_map</a>[0];
<a name="l00469"></a>00469           <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#ab292d4400894e09b1fb0c056b98d5a31">detadx_map</a>[0];
<a name="l00470"></a>00470           <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#af946c6bf8b1dd0e668744b825d3c455e">detady_map</a>[0];
<a name="l00471"></a>00471           <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#af474fdffb0815f291d7cf71563a74755">detadz_map</a>[0];
<a name="l00472"></a>00472 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00473"></a>00473 <span class="preprocessor"></span>          <a class="code" href="classlibMesh_1_1FEBase.php#a09c2e4ca10dce4a7f565593ff527d50c">d2xyzdxideta_map</a>[p] = 0.;
<a name="l00474"></a>00474           <a class="code" href="classlibMesh_1_1FEBase.php#a68f2668617657bb1041fcf25adacb225">d2xyzdeta2_map</a>[p] = 0.;
<a name="l00475"></a>00475 <span class="preprocessor">#endif</span>
<a name="l00476"></a>00476 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#af0fac88fc60ae6a128fd616362680e47">dim</a> &gt; 2)
<a name="l00477"></a>00477             {
<a name="l00478"></a>00478               <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#aa381ea7e9964780eb8cf4bad4b6fe192">dxyzdzeta_map</a>[0];
<a name="l00479"></a>00479               <a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#a9f554c5ccb1da9ca23929d524e38e009">dzetadx_map</a>[0];
<a name="l00480"></a>00480               <a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#a8e6767de7f38742cadf408d467f2e944">dzetady_map</a>[0];
<a name="l00481"></a>00481               <a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#aa6b144384c2b18bd25ee23fff52afa1b">dzetadz_map</a>[0];
<a name="l00482"></a>00482 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00483"></a>00483 <span class="preprocessor"></span>              <a class="code" href="classlibMesh_1_1FEBase.php#ac682c345ba4eff977747c26ef7e9c39d">d2xyzdxidzeta_map</a>[p] = 0.;
<a name="l00484"></a>00484               <a class="code" href="classlibMesh_1_1FEBase.php#a94c958eeca969946c86b1f740a25fd33">d2xyzdetadzeta_map</a>[p] = 0.;
<a name="l00485"></a>00485               <a class="code" href="classlibMesh_1_1FEBase.php#a15bef5c694ec90dff276ec7cce06240d">d2xyzdzeta2_map</a>[p] = 0.;
<a name="l00486"></a>00486 <span class="preprocessor">#endif</span>
<a name="l00487"></a>00487 <span class="preprocessor"></span>            }
<a name="l00488"></a>00488         }
<a name="l00489"></a>00489       <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>[p] = <a class="code" href="classlibMesh_1_1FEBase.php#ab65e73ccb67c08f9a85a67c1ab7bab5e">JxW</a>[0] / qw[0] * qw[p];
<a name="l00490"></a>00490     }
<a name="l00491"></a>00491   
<a name="l00492"></a>00492   STOP_LOG(<span class="stringliteral">&quot;compute_affine_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);  
<a name="l00493"></a>00493 }
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 
<a name="l00497"></a><a class="code" href="classlibMesh_1_1FEBase.php#abd044b0b177027f910216e798e4436a1">00497</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEBase.php#abd044b0b177027f910216e798e4436a1">FEBase::compute_map</a>(<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw,
<a name="l00498"></a>00498                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)
<a name="l00499"></a>00499 {
<a name="l00500"></a>00500   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad0155a2e8e15da7dc9c7a820265fd143">has_affine_map</a>())
<a name="l00501"></a>00501     {
<a name="l00502"></a>00502       <a class="code" href="classlibMesh_1_1FEBase.php#ab2a635bf29b6bc9d23590c1b4152b1df">compute_affine_map</a>(qw, elem);
<a name="l00503"></a>00503       <span class="keywordflow">return</span>;
<a name="l00504"></a>00504     }
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00507"></a>00507 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEBase.php#a4170551fa0860822e21475e3c098bc13">calculate_d2phi</a>)
<a name="l00508"></a>00508     {
<a name="l00509"></a>00509       libmesh_do_once(
<a name="l00510"></a>00510         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Second derivatives are not currently &quot;</span>
<a name="l00511"></a>00511                       &lt;&lt; <span class="stringliteral">&quot;correctly calculated on non-affine elements!&quot;</span>
<a name="l00512"></a>00512                       &lt;&lt; std::endl;);
<a name="l00513"></a>00513     }
<a name="l00514"></a>00514 <span class="preprocessor">#endif</span>
<a name="l00515"></a>00515 <span class="preprocessor"></span>  
<a name="l00516"></a>00516    <span class="comment">// Start logging the map computation.</span>
<a name="l00517"></a>00517   START_LOG(<span class="stringliteral">&quot;compute_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   libmesh_assert (elem  != NULL);
<a name="l00520"></a>00520   
<a name="l00521"></a>00521   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>        n_qp = qw.size();
<a name="l00522"></a>00522 
<a name="l00523"></a>00523   <span class="comment">// Resize the vectors to hold data at the quadrature points</span>
<a name="l00524"></a>00524   this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#ac2f2ae3020f2bd820e84221b723fcb12">resize_map_vectors</a>(n_qp);
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   <span class="comment">// Compute map at all quadrature points</span>
<a name="l00527"></a>00527   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p!=n_qp; p++)
<a name="l00528"></a>00528     this-&gt;<a class="code" href="classlibMesh_1_1FEBase.php#adba0bb8c55b1c53ac0cba7b1884180b0">compute_single_point_map</a>(qw, elem, p);
<a name="l00529"></a>00529   
<a name="l00530"></a>00530   <span class="comment">// Stop logging the map computation.</span>
<a name="l00531"></a>00531   STOP_LOG(<span class="stringliteral">&quot;compute_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);  
<a name="l00532"></a>00532 }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00538"></a><a class="code" href="classlibMesh_1_1FE.php#a26520529cc913b1046bda1018b1441dc">00538</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#a26520529cc913b1046bda1018b1441dc">FE&lt;Dim,T&gt;::map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00539"></a>00539                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; reference_point)
<a name="l00540"></a>00540 {
<a name="l00541"></a>00541   libmesh_assert (elem != NULL);
<a name="l00542"></a>00542     
<a name="l00543"></a>00543   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p;
<a name="l00544"></a>00544 
<a name="l00545"></a>00545   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type     = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00546"></a>00546   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order       = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>();
<a name="l00547"></a>00547   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;Dim,LAGRANGE&gt;::n_shape_functions</a>(type, order);
<a name="l00548"></a>00548 
<a name="l00549"></a>00549   <span class="comment">// Lagrange basis functions are used for mapping</span>
<a name="l00550"></a>00550   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00551"></a>00551     p.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i),
<a name="l00552"></a>00552                   <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,LAGRANGE&gt;::shape</a>(type,
<a name="l00553"></a>00553                                           order,
<a name="l00554"></a>00554                                           i,
<a name="l00555"></a>00555                                           reference_point)
<a name="l00556"></a>00556                   );
<a name="l00557"></a>00557 
<a name="l00558"></a>00558   <span class="keywordflow">return</span> p;
<a name="l00559"></a>00559 }
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 
<a name="l00562"></a>00562 
<a name="l00563"></a>00563 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00564"></a><a class="code" href="classlibMesh_1_1FE.php#a205ebdc6a3fc1a1eabcff5bfd8e724a4">00564</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#a205ebdc6a3fc1a1eabcff5bfd8e724a4">FE&lt;Dim,T&gt;::map_xi</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00565"></a>00565                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; reference_point)
<a name="l00566"></a>00566 {
<a name="l00567"></a>00567   libmesh_assert (elem != NULL);
<a name="l00568"></a>00568     
<a name="l00569"></a>00569   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p;
<a name="l00570"></a>00570 
<a name="l00571"></a>00571   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type     = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00572"></a>00572   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order       = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>();
<a name="l00573"></a>00573   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;Dim,LAGRANGE&gt;::n_shape_functions</a>(type, order);
<a name="l00574"></a>00574 
<a name="l00575"></a>00575   <span class="comment">// Lagrange basis functions are used for mapping    </span>
<a name="l00576"></a>00576   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00577"></a>00577     p.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i),
<a name="l00578"></a>00578                   <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a>(type,
<a name="l00579"></a>00579                                                 order,
<a name="l00580"></a>00580                                                 i,
<a name="l00581"></a>00581                                                 0,
<a name="l00582"></a>00582                                                 reference_point)
<a name="l00583"></a>00583                   );
<a name="l00584"></a>00584     
<a name="l00585"></a>00585   <span class="keywordflow">return</span> p;
<a name="l00586"></a>00586 }
<a name="l00587"></a>00587 
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00591"></a><a class="code" href="classlibMesh_1_1FE.php#a88e0ee4b0e9721c3086629daf07fd1ca">00591</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#a88e0ee4b0e9721c3086629daf07fd1ca">FE&lt;Dim,T&gt;::map_eta</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00592"></a>00592                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; reference_point)
<a name="l00593"></a>00593 {
<a name="l00594"></a>00594   libmesh_assert (elem != NULL);
<a name="l00595"></a>00595     
<a name="l00596"></a>00596   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p;
<a name="l00597"></a>00597 
<a name="l00598"></a>00598   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type     = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00599"></a>00599   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order       = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>();
<a name="l00600"></a>00600   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;Dim,LAGRANGE&gt;::n_shape_functions</a>(type, order);
<a name="l00601"></a>00601   
<a name="l00602"></a>00602   <span class="comment">// Lagrange basis functions are used for mapping</span>
<a name="l00603"></a>00603   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00604"></a>00604     p.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i),
<a name="l00605"></a>00605                   <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a>(type,
<a name="l00606"></a>00606                                                 order,
<a name="l00607"></a>00607                                                 i,
<a name="l00608"></a>00608                                                 1,
<a name="l00609"></a>00609                                                 reference_point)
<a name="l00610"></a>00610                   );
<a name="l00611"></a>00611     
<a name="l00612"></a>00612   <span class="keywordflow">return</span> p;
<a name="l00613"></a>00613 }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00618"></a><a class="code" href="classlibMesh_1_1FE.php#a74c1b626c81f8b7cba3443d57a3f44ae">00618</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#a74c1b626c81f8b7cba3443d57a3f44ae">FE&lt;Dim,T&gt;::map_zeta</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00619"></a>00619                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; reference_point)
<a name="l00620"></a>00620 {
<a name="l00621"></a>00621   libmesh_assert (elem != NULL);
<a name="l00622"></a>00622     
<a name="l00623"></a>00623   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p;
<a name="l00624"></a>00624 
<a name="l00625"></a>00625   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type     = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00626"></a>00626   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order       = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>();
<a name="l00627"></a>00627   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf = <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;Dim,LAGRANGE&gt;::n_shape_functions</a>(type, order);
<a name="l00628"></a>00628 
<a name="l00629"></a>00629   <span class="comment">// Lagrange basis functions are used for mapping</span>
<a name="l00630"></a>00630   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00631"></a>00631     p.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i),
<a name="l00632"></a>00632                   <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;Dim,LAGRANGE&gt;::shape_deriv</a>(type,
<a name="l00633"></a>00633                                                 order,
<a name="l00634"></a>00634                                                 i,
<a name="l00635"></a>00635                                                 2,
<a name="l00636"></a>00636                                                 reference_point)
<a name="l00637"></a>00637                   );
<a name="l00638"></a>00638     
<a name="l00639"></a>00639   <span class="keywordflow">return</span> p;
<a name="l00640"></a>00640 }
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00645"></a><a class="code" href="classlibMesh_1_1FE.php#ac17b5ee3f4e5b0bc2c66a1380582e324">00645</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1FE.php#ac17b5ee3f4e5b0bc2c66a1380582e324">FE&lt;Dim,T&gt;::inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00646"></a>00646                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; physical_point,
<a name="l00647"></a>00647                               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance,
<a name="l00648"></a>00648                               <span class="keyword">const</span> <span class="keywordtype">bool</span> secure)
<a name="l00649"></a>00649 {
<a name="l00650"></a>00650   libmesh_assert (elem != NULL);
<a name="l00651"></a>00651   libmesh_assert (tolerance &gt;= 0.);
<a name="l00652"></a>00652 
<a name="l00653"></a>00653   
<a name="l00654"></a>00654   <span class="comment">// Start logging the map inversion.  </span>
<a name="l00655"></a>00655   START_LOG(<span class="stringliteral">&quot;inverse_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00656"></a>00656   
<a name="l00657"></a>00657   <span class="comment">// How much did the point on the reference</span>
<a name="l00658"></a>00658   <span class="comment">// element change by in this Newton step?</span>
<a name="l00659"></a>00659   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> inverse_map_error = 0.;
<a name="l00660"></a>00660   
<a name="l00661"></a>00661   <span class="comment">//  The point on the reference element.  This is</span>
<a name="l00662"></a>00662   <span class="comment">//  the &quot;initial guess&quot; for Newton&#39;s method.  The</span>
<a name="l00663"></a>00663   <span class="comment">//  centroid seems like a good idea, but computing</span>
<a name="l00664"></a>00664   <span class="comment">//  it is a little more intensive than, say taking</span>
<a name="l00665"></a>00665   <span class="comment">//  the zero point.  </span>
<a name="l00666"></a>00666   <span class="comment">// </span>
<a name="l00667"></a>00667   <span class="comment">//  Convergence should be insensitive of this choice</span>
<a name="l00668"></a>00668   <span class="comment">//  for &quot;good&quot; elements.</span>
<a name="l00669"></a>00669   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p; <span class="comment">// the zero point.  No computation required</span>
<a name="l00670"></a>00670 
<a name="l00671"></a>00671   <span class="comment">//  The number of iterations in the map inversion process.</span>
<a name="l00672"></a>00672   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = 0;
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 
<a name="l00676"></a>00676 
<a name="l00677"></a>00677   <span class="comment">//  Newton iteration loop.</span>
<a name="l00678"></a>00678   <span class="keywordflow">do</span>
<a name="l00679"></a>00679     {
<a name="l00680"></a>00680       <span class="comment">//  Where our current iterate \p p maps to.</span>
<a name="l00681"></a>00681       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> physical_guess = <a class="code" href="classlibMesh_1_1FE.php#a26520529cc913b1046bda1018b1441dc">FE&lt;Dim,T&gt;::map</a> (elem, p);
<a name="l00682"></a>00682 
<a name="l00683"></a>00683       <span class="comment">//  How far our current iterate is from the actual point.</span>
<a name="l00684"></a>00684       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> delta = physical_point - physical_guess;
<a name="l00685"></a>00685 
<a name="l00686"></a>00686       <span class="comment">//  Increment in current iterate \p p, will be computed.</span>
<a name="l00687"></a>00687       <a class="code" href="classlibMesh_1_1Point.php">Point</a> dp;
<a name="l00688"></a>00688 
<a name="l00689"></a>00689 
<a name="l00690"></a>00690       <span class="comment">//  The form of the map and how we invert it depends</span>
<a name="l00691"></a>00691       <span class="comment">//  on the dimension that we are in.</span>
<a name="l00692"></a>00692       <span class="keywordflow">switch</span> (Dim)
<a name="l00693"></a>00693         {
<a name="l00694"></a>00694           
<a name="l00695"></a>00695           <span class="comment">// ------------------------------------------------------------------</span>
<a name="l00696"></a>00696           <span class="comment">//  1D map inversion</span>
<a name="l00697"></a>00697           <span class="comment">// </span>
<a name="l00698"></a>00698           <span class="comment">//  Here we find the point on a 1D reference element that maps to</span>
<a name="l00699"></a>00699           <span class="comment">//  the point \p physical_point in the domain.  This is a bit tricky</span>
<a name="l00700"></a>00700           <span class="comment">//  since we do not want to assume that the point \p physical_point</span>
<a name="l00701"></a>00701           <span class="comment">//  is also in a 1D domain.  In particular, this method might get</span>
<a name="l00702"></a>00702           <span class="comment">//  called on the edge of a 3D element, in which case</span>
<a name="l00703"></a>00703           <span class="comment">//  \p physical_point actually lives in 3D.</span>
<a name="l00704"></a>00704         <span class="keywordflow">case</span> 1:
<a name="l00705"></a>00705           {
<a name="l00706"></a>00706             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> dxi = <a class="code" href="classlibMesh_1_1FE.php#a205ebdc6a3fc1a1eabcff5bfd8e724a4">FE&lt;Dim,T&gt;::map_xi</a> (elem, p);
<a name="l00707"></a>00707             
<a name="l00708"></a>00708             <span class="comment">//  Newton&#39;s method in this case looks like</span>
<a name="l00709"></a>00709             <span class="comment">// </span>
<a name="l00710"></a>00710             <span class="comment">//  {X} - {X_n} = [J]*dp</span>
<a name="l00711"></a>00711             <span class="comment">// </span>
<a name="l00712"></a>00712             <span class="comment">//  Where {X}, {X_n} are 3x1 vectors, [J] is a 3x1 matrix</span>
<a name="l00713"></a>00713             <span class="comment">//  d(x,y,z)/dxi, and we seek dp, a scalar.  Since the above</span>
<a name="l00714"></a>00714             <span class="comment">//  system is either overdetermined or rank-deficient, we will</span>
<a name="l00715"></a>00715             <span class="comment">//  solve the normal equations for this system</span>
<a name="l00716"></a>00716             <span class="comment">// </span>
<a name="l00717"></a>00717             <span class="comment">//  [J]^T ({X} - {X_n}) = [J]^T [J] {dp}</span>
<a name="l00718"></a>00718             <span class="comment">// </span>
<a name="l00719"></a>00719             <span class="comment">//  which involves the trivial inversion of the scalar</span>
<a name="l00720"></a>00720             <span class="comment">//  G = [J]^T [J]</span>
<a name="l00721"></a>00721             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> G = dxi*dxi;
<a name="l00722"></a>00722             
<a name="l00723"></a>00723             <span class="keywordflow">if</span> (secure)
<a name="l00724"></a>00724               libmesh_assert (G &gt; 0.);
<a name="l00725"></a>00725             
<a name="l00726"></a>00726             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> Ginv = 1./G;
<a name="l00727"></a>00727             
<a name="l00728"></a>00728             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  dxidelta = dxi*delta;
<a name="l00729"></a>00729             
<a name="l00730"></a>00730             dp(0) = Ginv*dxidelta;
<a name="l00731"></a>00731 
<a name="l00732"></a>00732             <span class="comment">// Assume that no master elements have radius &gt; 4</span>
<a name="l00733"></a>00733             <span class="keywordflow">if</span> (secure)
<a name="l00734"></a>00734               libmesh_assert (dp.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>() &lt; 4);
<a name="l00735"></a>00735 
<a name="l00736"></a>00736             <span class="keywordflow">break</span>;
<a name="l00737"></a>00737           }
<a name="l00738"></a>00738 
<a name="l00739"></a>00739 
<a name="l00740"></a>00740 
<a name="l00741"></a>00741           <span class="comment">// ------------------------------------------------------------------</span>
<a name="l00742"></a>00742           <span class="comment">//  2D map inversion</span>
<a name="l00743"></a>00743           <span class="comment">// </span>
<a name="l00744"></a>00744           <span class="comment">//  Here we find the point on a 2D reference element that maps to</span>
<a name="l00745"></a>00745           <span class="comment">//  the point \p physical_point in the domain.  This is a bit tricky</span>
<a name="l00746"></a>00746           <span class="comment">//  since we do not want to assume that the point \p physical_point</span>
<a name="l00747"></a>00747           <span class="comment">//  is also in a 2D domain.  In particular, this method might get</span>
<a name="l00748"></a>00748           <span class="comment">//  called on the face of a 3D element, in which case</span>
<a name="l00749"></a>00749           <span class="comment">//  \p physical_point actually lives in 3D.</span>
<a name="l00750"></a>00750         <span class="keywordflow">case</span> 2:
<a name="l00751"></a>00751           {
<a name="l00752"></a>00752             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> dxi  = <a class="code" href="classlibMesh_1_1FE.php#a205ebdc6a3fc1a1eabcff5bfd8e724a4">FE&lt;Dim,T&gt;::map_xi</a>  (elem, p);
<a name="l00753"></a>00753             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> deta = <a class="code" href="classlibMesh_1_1FE.php#a88e0ee4b0e9721c3086629daf07fd1ca">FE&lt;Dim,T&gt;::map_eta</a> (elem, p);
<a name="l00754"></a>00754             
<a name="l00755"></a>00755             <span class="comment">//  Newton&#39;s method in this case looks like</span>
<a name="l00756"></a>00756             <span class="comment">// </span>
<a name="l00757"></a>00757             <span class="comment">//  {X} - {X_n} = [J]*{dp}</span>
<a name="l00758"></a>00758             <span class="comment">// </span>
<a name="l00759"></a>00759             <span class="comment">//  Where {X}, {X_n} are 3x1 vectors, [J] is a 3x2 matrix</span>
<a name="l00760"></a>00760             <span class="comment">//  d(x,y,z)/d(xi,eta), and we seek {dp}, a 2x1 vector.  Since</span>
<a name="l00761"></a>00761             <span class="comment">//  the above system is either overdermined or rank-deficient,</span>
<a name="l00762"></a>00762             <span class="comment">//  we will solve the normal equations for this system</span>
<a name="l00763"></a>00763             <span class="comment">// </span>
<a name="l00764"></a>00764             <span class="comment">//  [J]^T ({X} - {X_n}) = [J]^T [J] {dp}</span>
<a name="l00765"></a>00765             <span class="comment">// </span>
<a name="l00766"></a>00766             <span class="comment">//  which involves the inversion of the 2x2 matrix</span>
<a name="l00767"></a>00767             <span class="comment">//  [G] = [J]^T [J]</span>
<a name="l00768"></a>00768             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l00769"></a>00769               G11 = dxi*dxi,  G12 = dxi*deta,
<a name="l00770"></a>00770               G21 = dxi*deta, G22 = deta*deta;
<a name="l00771"></a>00771             
<a name="l00772"></a>00772             
<a name="l00773"></a>00773             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> det = (G11*G22 - G12*G21);
<a name="l00774"></a>00774             
<a name="l00775"></a>00775             <span class="keywordflow">if</span> (secure)
<a name="l00776"></a>00776               libmesh_assert (det != 0.);
<a name="l00777"></a>00777 
<a name="l00778"></a>00778             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> inv_det = 1./det;
<a name="l00779"></a>00779             
<a name="l00780"></a>00780             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l00781"></a>00781               Ginv11 =  G22*inv_det,
<a name="l00782"></a>00782               Ginv12 = -G12*inv_det,
<a name="l00783"></a>00783               
<a name="l00784"></a>00784               Ginv21 = -G21*inv_det,
<a name="l00785"></a>00785               Ginv22 =  G11*inv_det;
<a name="l00786"></a>00786             
<a name="l00787"></a>00787             
<a name="l00788"></a>00788             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  dxidelta  = dxi*delta;
<a name="l00789"></a>00789             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  detadelta = deta*delta;
<a name="l00790"></a>00790             
<a name="l00791"></a>00791             dp(0) = (Ginv11*dxidelta + Ginv12*detadelta);
<a name="l00792"></a>00792             dp(1) = (Ginv21*dxidelta + Ginv22*detadelta);
<a name="l00793"></a>00793 
<a name="l00794"></a>00794             <span class="comment">// Assume that no master elements have radius &gt; 4</span>
<a name="l00795"></a>00795             <span class="keywordflow">if</span> (secure)
<a name="l00796"></a>00796               libmesh_assert (dp.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>() &lt; 4);
<a name="l00797"></a>00797 
<a name="l00798"></a>00798             <span class="keywordflow">break</span>;
<a name="l00799"></a>00799           }
<a name="l00800"></a>00800           
<a name="l00801"></a>00801 
<a name="l00802"></a>00802           
<a name="l00803"></a>00803           <span class="comment">// ------------------------------------------------------------------</span>
<a name="l00804"></a>00804           <span class="comment">//  3D map inversion</span>
<a name="l00805"></a>00805           <span class="comment">// </span>
<a name="l00806"></a>00806           <span class="comment">//  Here we find the point in a 3D reference element that maps to</span>
<a name="l00807"></a>00807           <span class="comment">//  the point \p physical_point in a 3D domain. Nothing special</span>
<a name="l00808"></a>00808           <span class="comment">//  has to happen here, since (unless the map is singular because</span>
<a name="l00809"></a>00809           <span class="comment">//  you have a BAD element) the map will be invertable and we can</span>
<a name="l00810"></a>00810           <span class="comment">//  apply Newton&#39;s method directly.</span>
<a name="l00811"></a>00811         <span class="keywordflow">case</span> 3:
<a name="l00812"></a>00812           {
<a name="l00813"></a>00813             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> dxi   = <a class="code" href="classlibMesh_1_1FE.php#a205ebdc6a3fc1a1eabcff5bfd8e724a4">FE&lt;Dim,T&gt;::map_xi</a>   (elem, p);
<a name="l00814"></a>00814             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> deta  = <a class="code" href="classlibMesh_1_1FE.php#a88e0ee4b0e9721c3086629daf07fd1ca">FE&lt;Dim,T&gt;::map_eta</a>  (elem, p);
<a name="l00815"></a>00815             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> dzeta = <a class="code" href="classlibMesh_1_1FE.php#a74c1b626c81f8b7cba3443d57a3f44ae">FE&lt;Dim,T&gt;::map_zeta</a> (elem, p);
<a name="l00816"></a>00816             
<a name="l00817"></a>00817             <span class="comment">//  Newton&#39;s method in this case looks like</span>
<a name="l00818"></a>00818             <span class="comment">// </span>
<a name="l00819"></a>00819             <span class="comment">//  {X} = {X_n} + [J]*{dp}</span>
<a name="l00820"></a>00820             <span class="comment">// </span>
<a name="l00821"></a>00821             <span class="comment">//  Where {X}, {X_n} are 3x1 vectors, [J] is a 3x3 matrix</span>
<a name="l00822"></a>00822             <span class="comment">//  d(x,y,z)/d(xi,eta,zeta), and we seek {dp}, a 3x1 vector.</span>
<a name="l00823"></a>00823             <span class="comment">//  Since the above system is nonsingular for invertable maps</span>
<a name="l00824"></a>00824             <span class="comment">//  we will solve </span>
<a name="l00825"></a>00825             <span class="comment">// </span>
<a name="l00826"></a>00826             <span class="comment">//  {dp} = [J]^-1 ({X} - {X_n})</span>
<a name="l00827"></a>00827             <span class="comment">// </span>
<a name="l00828"></a>00828             <span class="comment">//  which involves the inversion of the 3x3 matrix [J]</span>
<a name="l00829"></a>00829             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l00830"></a>00830               J11 = dxi(0), J12 = deta(0), J13 = dzeta(0),
<a name="l00831"></a>00831               J21 = dxi(1), J22 = deta(1), J23 = dzeta(1),
<a name="l00832"></a>00832               J31 = dxi(2), J32 = deta(2), J33 = dzeta(2);
<a name="l00833"></a>00833             
<a name="l00834"></a>00834             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> det = (J11*(J22*J33 - J23*J32) +
<a name="l00835"></a>00835                               J12*(J23*J31 - J21*J33) +
<a name="l00836"></a>00836                               J13*(J21*J32 - J22*J31));
<a name="l00837"></a>00837             
<a name="l00838"></a>00838             <span class="keywordflow">if</span> (secure)
<a name="l00839"></a>00839               libmesh_assert (det != 0.);
<a name="l00840"></a>00840 
<a name="l00841"></a>00841             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> inv_det = 1./det;
<a name="l00842"></a>00842             
<a name="l00843"></a>00843             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l00844"></a>00844               Jinv11 =  (J22*J33 - J23*J32)*inv_det,
<a name="l00845"></a>00845               Jinv12 = -(J12*J33 - J13*J32)*inv_det,
<a name="l00846"></a>00846               Jinv13 =  (J12*J23 - J13*J22)*inv_det,
<a name="l00847"></a>00847               
<a name="l00848"></a>00848               Jinv21 = -(J21*J33 - J23*J31)*inv_det,
<a name="l00849"></a>00849               Jinv22 =  (J11*J33 - J13*J31)*inv_det,
<a name="l00850"></a>00850               Jinv23 = -(J11*J23 - J13*J21)*inv_det,
<a name="l00851"></a>00851               
<a name="l00852"></a>00852               Jinv31 =  (J21*J32 - J22*J31)*inv_det,
<a name="l00853"></a>00853               Jinv32 = -(J11*J32 - J12*J31)*inv_det,
<a name="l00854"></a>00854               Jinv33 =  (J11*J22 - J12*J21)*inv_det;
<a name="l00855"></a>00855             
<a name="l00856"></a>00856             dp(0) = (Jinv11*delta(0) +
<a name="l00857"></a>00857                      Jinv12*delta(1) +
<a name="l00858"></a>00858                      Jinv13*delta(2));
<a name="l00859"></a>00859             
<a name="l00860"></a>00860             dp(1) = (Jinv21*delta(0) +
<a name="l00861"></a>00861                      Jinv22*delta(1) +
<a name="l00862"></a>00862                      Jinv23*delta(2));
<a name="l00863"></a>00863             
<a name="l00864"></a>00864             dp(2) = (Jinv31*delta(0) +
<a name="l00865"></a>00865                      Jinv32*delta(1) +
<a name="l00866"></a>00866                      Jinv33*delta(2));
<a name="l00867"></a>00867 
<a name="l00868"></a>00868             <span class="comment">// Assume that no master elements have radius &gt; 4</span>
<a name="l00869"></a>00869             <span class="keywordflow">if</span> (secure)
<a name="l00870"></a>00870               libmesh_assert (dp.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>() &lt; 4);
<a name="l00871"></a>00871 
<a name="l00872"></a>00872             <span class="keywordflow">break</span>;
<a name="l00873"></a>00873           }
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 
<a name="l00876"></a>00876           <span class="comment">//  Some other dimension?</span>
<a name="l00877"></a>00877         <span class="keywordflow">default</span>:
<a name="l00878"></a>00878           libmesh_error();
<a name="l00879"></a>00879         } <span class="comment">// end switch(Dim), dp now computed</span>
<a name="l00880"></a>00880 
<a name="l00881"></a>00881 
<a name="l00882"></a>00882 
<a name="l00883"></a>00883       <span class="comment">//  ||P_n+1 - P_n||</span>
<a name="l00884"></a>00884       inverse_map_error = dp.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>();
<a name="l00885"></a>00885 
<a name="l00886"></a>00886       <span class="comment">//  P_n+1 = P_n + dp</span>
<a name="l00887"></a>00887       p.<a class="code" href="classlibMesh_1_1TypeVector.php#a670ef717fd81b3b529503ecec7a949da">add</a> (dp);
<a name="l00888"></a>00888       
<a name="l00889"></a>00889       <span class="comment">//  Increment the iteration count.</span>
<a name="l00890"></a>00890       cnt++;
<a name="l00891"></a>00891       
<a name="l00892"></a>00892       <span class="comment">//  Watch for divergence of Newton&#39;s</span>
<a name="l00893"></a>00893       <span class="comment">//  method.  Here&#39;s how it goes:</span>
<a name="l00894"></a>00894       <span class="comment">//  (1) For good elements, we expect convergence in 10 iterations.</span>
<a name="l00895"></a>00895       <span class="comment">//      - If called with (secure == true) and we have not yet converged</span>
<a name="l00896"></a>00896       <span class="comment">//        print out a warning message.</span>
<a name="l00897"></a>00897       <span class="comment">//      - If called with (secure == true) and we have not converged in</span>
<a name="l00898"></a>00898       <span class="comment">//        20 iterations abort</span>
<a name="l00899"></a>00899       <span class="comment">//  (2) This method may be called in cases when the target point is not</span>
<a name="l00900"></a>00900       <span class="comment">//      inside the element and we have no business expecting convergence.</span>
<a name="l00901"></a>00901       <span class="comment">//      For these cases if we have not converged in 10 iterations forget</span>
<a name="l00902"></a>00902       <span class="comment">//      about it.</span>
<a name="l00903"></a>00903       <span class="keywordflow">if</span> (cnt &gt; 10)
<a name="l00904"></a>00904         {
<a name="l00905"></a>00905           <span class="comment">//  Warn about divergence when secure is true - this</span>
<a name="l00906"></a>00906           <span class="comment">//  shouldn&#39;t happen</span>
<a name="l00907"></a>00907           <span class="keywordflow">if</span> (secure)
<a name="l00908"></a>00908             {
<a name="l00909"></a>00909               libmesh_here();
<a name="l00910"></a>00910               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Newton scheme has not converged in &quot;</span>
<a name="l00911"></a>00911                             &lt;&lt; cnt &lt;&lt; <span class="stringliteral">&quot; iterations:&quot;</span> &lt;&lt; std::endl
<a name="l00912"></a>00912                             &lt;&lt; <span class="stringliteral">&quot;   physical_point=&quot;</span>
<a name="l00913"></a>00913                             &lt;&lt; physical_point
<a name="l00914"></a>00914                             &lt;&lt; <span class="stringliteral">&quot;   physical_guess=&quot;</span>
<a name="l00915"></a>00915                             &lt;&lt; physical_guess
<a name="l00916"></a>00916                             &lt;&lt; <span class="stringliteral">&quot;   dp=&quot;</span>
<a name="l00917"></a>00917                             &lt;&lt; dp
<a name="l00918"></a>00918                             &lt;&lt; <span class="stringliteral">&quot;   p=&quot;</span>
<a name="l00919"></a>00919                             &lt;&lt; p
<a name="l00920"></a>00920                             &lt;&lt; <span class="stringliteral">&quot;   error=&quot;</span> &lt;&lt; inverse_map_error
<a name="l00921"></a>00921                             &lt;&lt; <span class="stringliteral">&quot;   in element &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()
<a name="l00922"></a>00922                             &lt;&lt; std::endl;
<a name="l00923"></a>00923 
<a name="l00924"></a>00924               <span class="keywordflow">if</span> (cnt &gt; 20)
<a name="l00925"></a>00925                 {
<a name="l00926"></a>00926                   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Newton scheme FAILED to converge in &quot;</span>
<a name="l00927"></a>00927                                 &lt;&lt; cnt
<a name="l00928"></a>00928                                 &lt;&lt; <span class="stringliteral">&quot; iterations!&quot;</span>
<a name="l00929"></a>00929                                 &lt;&lt; <span class="stringliteral">&quot; in element &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()
<a name="l00930"></a>00930                                 &lt;&lt; std::endl;
<a name="l00931"></a>00931 
<a name="l00932"></a>00932                   libmesh_error();
<a name="l00933"></a>00933                 }
<a name="l00934"></a>00934             }
<a name="l00935"></a>00935           <span class="comment">//  Return a far off point when secure is false - this</span>
<a name="l00936"></a>00936           <span class="comment">//  should only happen when we&#39;re trying to map a point</span>
<a name="l00937"></a>00937           <span class="comment">//  that&#39;s outside the element</span>
<a name="l00938"></a>00938           <span class="keywordflow">else</span>
<a name="l00939"></a>00939             {
<a name="l00940"></a>00940               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Dim; ++i)
<a name="l00941"></a>00941                 p(i) = 1e6;
<a name="l00942"></a>00942               
<a name="l00943"></a>00943               STOP_LOG(<span class="stringliteral">&quot;inverse_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00944"></a>00944               <span class="keywordflow">return</span> p;
<a name="l00945"></a>00945             }
<a name="l00946"></a>00946         }
<a name="l00947"></a>00947     }
<a name="l00948"></a>00948   <span class="keywordflow">while</span> (inverse_map_error &gt; tolerance);
<a name="l00949"></a>00949 
<a name="l00950"></a>00950 
<a name="l00951"></a>00951 
<a name="l00952"></a>00952   <span class="comment">//  If we are in debug mode do a sanity check.  Make sure</span>
<a name="l00953"></a>00953   <span class="comment">//  the point \p p on the reference element actually does</span>
<a name="l00954"></a>00954   <span class="comment">//  map to the point \p physical_point within a tolerance.</span>
<a name="l00955"></a>00955 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00956"></a>00956 <span class="preprocessor"></span>  
<a name="l00957"></a>00957   <span class="keywordflow">if</span> (secure)
<a name="l00958"></a>00958     {  
<a name="l00959"></a>00959       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> check = <a class="code" href="classlibMesh_1_1FE.php#a26520529cc913b1046bda1018b1441dc">FE&lt;Dim,T&gt;::map</a> (elem, p);
<a name="l00960"></a>00960       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> diff  = physical_point - check;
<a name="l00961"></a>00961       
<a name="l00962"></a>00962       <span class="keywordflow">if</span> (diff.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>() &gt; tolerance)
<a name="l00963"></a>00963         {
<a name="l00964"></a>00964           libmesh_here();
<a name="l00965"></a>00965           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING:  diff is &quot;</span>
<a name="l00966"></a>00966                         &lt;&lt; diff.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>()
<a name="l00967"></a>00967                         &lt;&lt; std::endl
<a name="l00968"></a>00968                         &lt;&lt; <span class="stringliteral">&quot; point=&quot;</span>
<a name="l00969"></a>00969                         &lt;&lt; physical_point;
<a name="l00970"></a>00970           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot; local=&quot;</span> &lt;&lt; check;
<a name="l00971"></a>00971           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot; lref= &quot;</span> &lt;&lt; p;
<a name="l00972"></a>00972         }
<a name="l00973"></a>00973     }
<a name="l00974"></a>00974   
<a name="l00975"></a>00975 <span class="preprocessor">#endif</span>
<a name="l00976"></a>00976 <span class="preprocessor"></span>
<a name="l00977"></a>00977 
<a name="l00978"></a>00978   
<a name="l00979"></a>00979   <span class="comment">//  Stop logging the map inversion.</span>
<a name="l00980"></a>00980   STOP_LOG(<span class="stringliteral">&quot;inverse_map()&quot;</span>, <span class="stringliteral">&quot;FE&quot;</span>);
<a name="l00981"></a>00981   
<a name="l00982"></a>00982   <span class="keywordflow">return</span> p;
<a name="l00983"></a>00983 }
<a name="l00984"></a>00984 
<a name="l00985"></a>00985 
<a name="l00986"></a>00986 
<a name="l00987"></a>00987 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00988"></a><a class="code" href="classlibMesh_1_1FE.php#a1a70a32d1ab264ebb8b685e26be1142c">00988</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#ac17b5ee3f4e5b0bc2c66a1380582e324">FE&lt;Dim,T&gt;::inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00989"></a>00989                              <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00990"></a>00990                              std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00991"></a>00991                              <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance,
<a name="l00992"></a>00992                              <span class="keyword">const</span> <span class="keywordtype">bool</span> secure)
<a name="l00993"></a>00993 {
<a name="l00994"></a>00994   <span class="comment">// The number of points to find the</span>
<a name="l00995"></a>00995   <span class="comment">// inverse map of</span>
<a name="l00996"></a>00996   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_points = physical_points.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>();
<a name="l00997"></a>00997 
<a name="l00998"></a>00998   <span class="comment">// Resize the vector to hold the points</span>
<a name="l00999"></a>00999   <span class="comment">// on the reference element</span>
<a name="l01000"></a>01000   reference_points.resize(n_points);
<a name="l01001"></a>01001 
<a name="l01002"></a>01002   <span class="comment">// Find the coordinates on the reference</span>
<a name="l01003"></a>01003   <span class="comment">// element of each point in physical space</span>
<a name="l01004"></a>01004   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_points; p++)
<a name="l01005"></a>01005     reference_points[p] =
<a name="l01006"></a>01006       <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,T&gt;::inverse_map</a> (elem, physical_points[p], tolerance, secure);
<a name="l01007"></a>01007 }
<a name="l01008"></a>01008 
<a name="l01009"></a>01009 
<a name="l01010"></a>01010 
<a name="l01011"></a>01011 <span class="comment">//--------------------------------------------------------------</span>
<a name="l01012"></a>01012 <span class="comment">// Explicit instantiations using the macro from fe_macro.h</span>
<a name="l01013"></a>01013 <a class="code" href="namespacelibMesh.php#a978475afab8bff44f794112cce690b20">INSTANTIATE_IMAP</a>(0);
<a name="l01014"></a>01014 <a class="code" href="namespacelibMesh.php#a978475afab8bff44f794112cce690b20">INSTANTIATE_IMAP</a>(1);
<a name="l01015"></a>01015 <a class="code" href="namespacelibMesh.php#a978475afab8bff44f794112cce690b20">INSTANTIATE_IMAP</a>(2);
<a name="l01016"></a>01016 <a class="code" href="namespacelibMesh.php#a978475afab8bff44f794112cce690b20">INSTANTIATE_IMAP</a>(3);
<a name="l01017"></a>01017 
<a name="l01018"></a>01018 <span class="preprocessor">#if defined(__INTEL_COMPILER)</span>
<a name="l01019"></a>01019 <span class="preprocessor"></span><a class="code" href="namespacelibMesh.php#a7d1bd573f8151744018432f80e3035c6">INSTANTIATE_MAP</a>(0);
<a name="l01020"></a>01020 <a class="code" href="namespacelibMesh.php#a7d1bd573f8151744018432f80e3035c6">INSTANTIATE_MAP</a>(1);
<a name="l01021"></a>01021 <a class="code" href="namespacelibMesh.php#a7d1bd573f8151744018432f80e3035c6">INSTANTIATE_MAP</a>(2);
<a name="l01022"></a>01022 <a class="code" href="namespacelibMesh.php#a7d1bd573f8151744018432f80e3035c6">INSTANTIATE_MAP</a>(3);
<a name="l01023"></a>01023 <span class="preprocessor">#endif</span>
<a name="l01024"></a>01024 <span class="preprocessor"></span>
<a name="l01025"></a>01025 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
