<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_monomial_shape_2D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__monomial__shape__2D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_monomial_shape_2D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ inlcludes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">template</span> &lt;&gt;
<a name="l00034"></a><a class="code" href="classlibMesh_1_1FE.php#a6a740353a111135dab0b2a6123336c41">00034</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;2,MONOMIAL&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00035"></a>00035                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00036"></a>00036                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00037"></a>00037                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>  
<a name="l00041"></a>00041   libmesh_assert (i &lt; (static_cast&lt;unsigned int&gt;(order)+1)*
<a name="l00042"></a>00042                (static_cast&lt;unsigned int&gt;(order)+2)/2);
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi  = p(0);
<a name="l00045"></a>00045   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta = p(1);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="keywordflow">switch</span> (i)
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049       <span class="comment">// constant</span>
<a name="l00050"></a>00050     <span class="keywordflow">case</span> 0:
<a name="l00051"></a>00051       <span class="keywordflow">return</span> 1.;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053       <span class="comment">// linear</span>
<a name="l00054"></a>00054     <span class="keywordflow">case</span> 1:
<a name="l00055"></a>00055       <span class="keywordflow">return</span> xi;
<a name="l00056"></a>00056     
<a name="l00057"></a>00057     <span class="keywordflow">case</span> 2:
<a name="l00058"></a>00058       <span class="keywordflow">return</span> eta;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060       <span class="comment">// quadratics</span>
<a name="l00061"></a>00061     <span class="keywordflow">case</span> 3:
<a name="l00062"></a>00062       <span class="keywordflow">return</span> xi*xi;
<a name="l00063"></a>00063     
<a name="l00064"></a>00064     <span class="keywordflow">case</span> 4:
<a name="l00065"></a>00065       <span class="keywordflow">return</span> xi*eta;
<a name="l00066"></a>00066     
<a name="l00067"></a>00067     <span class="keywordflow">case</span> 5:
<a name="l00068"></a>00068       <span class="keywordflow">return</span> eta*eta;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070       <span class="comment">// cubics</span>
<a name="l00071"></a>00071     <span class="keywordflow">case</span> 6:
<a name="l00072"></a>00072       <span class="keywordflow">return</span> xi*xi*xi;
<a name="l00073"></a>00073 
<a name="l00074"></a>00074     <span class="keywordflow">case</span> 7:
<a name="l00075"></a>00075       <span class="keywordflow">return</span> xi*xi*eta;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     <span class="keywordflow">case</span> 8:
<a name="l00078"></a>00078       <span class="keywordflow">return</span> xi*eta*eta;
<a name="l00079"></a>00079 
<a name="l00080"></a>00080     <span class="keywordflow">case</span> 9:
<a name="l00081"></a>00081       <span class="keywordflow">return</span> eta*eta*eta;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083       <span class="comment">// quartics</span>
<a name="l00084"></a>00084     <span class="keywordflow">case</span> 10:
<a name="l00085"></a>00085       <span class="keywordflow">return</span> xi*xi*xi*xi;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087     <span class="keywordflow">case</span> 11:
<a name="l00088"></a>00088       <span class="keywordflow">return</span> xi*xi*xi*eta;
<a name="l00089"></a>00089 
<a name="l00090"></a>00090     <span class="keywordflow">case</span> 12:
<a name="l00091"></a>00091       <span class="keywordflow">return</span> xi*xi*eta*eta;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     <span class="keywordflow">case</span> 13:
<a name="l00094"></a>00094       <span class="keywordflow">return</span> xi*eta*eta*eta;
<a name="l00095"></a>00095 
<a name="l00096"></a>00096     <span class="keywordflow">case</span> 14:
<a name="l00097"></a>00097       <span class="keywordflow">return</span> eta*eta*eta*eta;
<a name="l00098"></a>00098     
<a name="l00099"></a>00099     <span class="keywordflow">default</span>:
<a name="l00100"></a>00100       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00101"></a>00101       <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00102"></a>00102       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny = i - (o*(o+1)/2);
<a name="l00103"></a>00103       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx = o - ny;
<a name="l00104"></a>00104       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = 1.;
<a name="l00105"></a>00105       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index != nx; index++)
<a name="l00106"></a>00106         val *= xi;
<a name="l00107"></a>00107       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index != ny; index++)
<a name="l00108"></a>00108         val *= eta;
<a name="l00109"></a>00109       <span class="keywordflow">return</span> val;
<a name="l00110"></a>00110     }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   libmesh_error();
<a name="l00113"></a>00113   <span class="keywordflow">return</span> 0.;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="preprocessor">#endif</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>}
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">template</span> &lt;&gt;
<a name="l00121"></a><a class="code" href="classlibMesh_1_1FE.php#a116fbfc53b4065b7b05bf99c361d2cd6">00121</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;2,MONOMIAL&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00122"></a>00122                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00123"></a>00123                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00124"></a>00124                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126   libmesh_assert (elem != NULL);
<a name="l00127"></a>00127   
<a name="l00128"></a>00128   <span class="comment">// by default call the orientation-independent shape functions</span>
<a name="l00129"></a>00129   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;2,MONOMIAL&gt;::shape</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, p);
<a name="l00130"></a>00130 }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="keyword">template</span> &lt;&gt;
<a name="l00135"></a><a class="code" href="classlibMesh_1_1FE.php#a9099287835254f36e5db96e87335b6ca">00135</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;2,MONOMIAL&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00136"></a>00136                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00137"></a>00137                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00138"></a>00138                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00139"></a>00139                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00140"></a>00140 {
<a name="l00141"></a>00141 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00142"></a>00142 <span class="preprocessor"></span>
<a name="l00143"></a>00143   
<a name="l00144"></a>00144   libmesh_assert (j&lt;2);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   libmesh_assert (i &lt; (static_cast&lt;unsigned int&gt;(order)+1)*
<a name="l00147"></a>00147                (static_cast&lt;unsigned int&gt;(order)+2)/2);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi  = p(0);
<a name="l00150"></a>00150   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta = p(1);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">// monomials. since they are hierarchic we only need one case block.</span>
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="keywordflow">switch</span> (j)
<a name="l00155"></a>00155     {
<a name="l00156"></a>00156       <span class="comment">// d()/dxi</span>
<a name="l00157"></a>00157     <span class="keywordflow">case</span> 0:
<a name="l00158"></a>00158       {
<a name="l00159"></a>00159         <span class="keywordflow">switch</span> (i)
<a name="l00160"></a>00160           {
<a name="l00161"></a>00161             <span class="comment">// constants</span>
<a name="l00162"></a>00162           <span class="keywordflow">case</span> 0:
<a name="l00163"></a>00163             <span class="keywordflow">return</span> 0.;
<a name="l00164"></a>00164             
<a name="l00165"></a>00165             <span class="comment">// linears</span>
<a name="l00166"></a>00166           <span class="keywordflow">case</span> 1:
<a name="l00167"></a>00167             <span class="keywordflow">return</span> 1.;
<a name="l00168"></a>00168             
<a name="l00169"></a>00169           <span class="keywordflow">case</span> 2:
<a name="l00170"></a>00170             <span class="keywordflow">return</span> 0.;
<a name="l00171"></a>00171 
<a name="l00172"></a>00172             <span class="comment">// quadratics</span>
<a name="l00173"></a>00173           <span class="keywordflow">case</span> 3:
<a name="l00174"></a>00174             <span class="keywordflow">return</span> 2.*xi;
<a name="l00175"></a>00175             
<a name="l00176"></a>00176           <span class="keywordflow">case</span> 4:
<a name="l00177"></a>00177             <span class="keywordflow">return</span> eta;
<a name="l00178"></a>00178             
<a name="l00179"></a>00179           <span class="keywordflow">case</span> 5:
<a name="l00180"></a>00180             <span class="keywordflow">return</span> 0.;
<a name="l00181"></a>00181 
<a name="l00182"></a>00182             <span class="comment">// cubics</span>
<a name="l00183"></a>00183           <span class="keywordflow">case</span> 6:
<a name="l00184"></a>00184             <span class="keywordflow">return</span> 3.*xi*xi;
<a name="l00185"></a>00185             
<a name="l00186"></a>00186           <span class="keywordflow">case</span> 7:
<a name="l00187"></a>00187             <span class="keywordflow">return</span> 2.*xi*eta;
<a name="l00188"></a>00188             
<a name="l00189"></a>00189           <span class="keywordflow">case</span> 8:
<a name="l00190"></a>00190             <span class="keywordflow">return</span> eta*eta;
<a name="l00191"></a>00191             
<a name="l00192"></a>00192           <span class="keywordflow">case</span> 9:
<a name="l00193"></a>00193             <span class="keywordflow">return</span> 0.;
<a name="l00194"></a>00194             
<a name="l00195"></a>00195             <span class="comment">// quartics</span>
<a name="l00196"></a>00196           <span class="keywordflow">case</span> 10:
<a name="l00197"></a>00197             <span class="keywordflow">return</span> 4.*xi*xi*xi;
<a name="l00198"></a>00198             
<a name="l00199"></a>00199           <span class="keywordflow">case</span> 11:
<a name="l00200"></a>00200             <span class="keywordflow">return</span> 3.*xi*xi*eta;
<a name="l00201"></a>00201             
<a name="l00202"></a>00202           <span class="keywordflow">case</span> 12:
<a name="l00203"></a>00203             <span class="keywordflow">return</span> 2.*xi*eta*eta;
<a name="l00204"></a>00204             
<a name="l00205"></a>00205           <span class="keywordflow">case</span> 13:
<a name="l00206"></a>00206             <span class="keywordflow">return</span> eta*eta*eta;
<a name="l00207"></a>00207             
<a name="l00208"></a>00208           <span class="keywordflow">case</span> 14:
<a name="l00209"></a>00209             <span class="keywordflow">return</span> 0.;
<a name="l00210"></a>00210             
<a name="l00211"></a>00211           <span class="keywordflow">default</span>:
<a name="l00212"></a>00212             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00213"></a>00213             <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00214"></a>00214             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny = i - (o*(o+1)/2);
<a name="l00215"></a>00215             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx = o - ny;
<a name="l00216"></a>00216             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = nx;
<a name="l00217"></a>00217             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=1; index &lt; nx; index++)
<a name="l00218"></a>00218               val *= xi;
<a name="l00219"></a>00219             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index != ny; index++)
<a name="l00220"></a>00220               val *= eta;
<a name="l00221"></a>00221             <span class="keywordflow">return</span> val;
<a name="l00222"></a>00222           }
<a name="l00223"></a>00223       }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225       
<a name="l00226"></a>00226       <span class="comment">// d()/deta</span>
<a name="l00227"></a>00227     <span class="keywordflow">case</span> 1:
<a name="l00228"></a>00228       {
<a name="l00229"></a>00229         <span class="keywordflow">switch</span> (i)
<a name="l00230"></a>00230           {
<a name="l00231"></a>00231             <span class="comment">// constants</span>
<a name="l00232"></a>00232           <span class="keywordflow">case</span> 0:
<a name="l00233"></a>00233             <span class="keywordflow">return</span> 0.;
<a name="l00234"></a>00234     
<a name="l00235"></a>00235             <span class="comment">// linears</span>
<a name="l00236"></a>00236           <span class="keywordflow">case</span> 1:
<a name="l00237"></a>00237             <span class="keywordflow">return</span> 0.;
<a name="l00238"></a>00238             
<a name="l00239"></a>00239           <span class="keywordflow">case</span> 2:
<a name="l00240"></a>00240             <span class="keywordflow">return</span> 1.;
<a name="l00241"></a>00241 
<a name="l00242"></a>00242             <span class="comment">// quadratics</span>
<a name="l00243"></a>00243           <span class="keywordflow">case</span> 3:
<a name="l00244"></a>00244             <span class="keywordflow">return</span> 0.;
<a name="l00245"></a>00245             
<a name="l00246"></a>00246           <span class="keywordflow">case</span> 4:
<a name="l00247"></a>00247             <span class="keywordflow">return</span> xi;
<a name="l00248"></a>00248             
<a name="l00249"></a>00249           <span class="keywordflow">case</span> 5:
<a name="l00250"></a>00250             <span class="keywordflow">return</span> 2.*eta;
<a name="l00251"></a>00251 
<a name="l00252"></a>00252             <span class="comment">// cubics</span>
<a name="l00253"></a>00253           <span class="keywordflow">case</span> 6:
<a name="l00254"></a>00254             <span class="keywordflow">return</span> 0.;
<a name="l00255"></a>00255             
<a name="l00256"></a>00256           <span class="keywordflow">case</span> 7:
<a name="l00257"></a>00257             <span class="keywordflow">return</span> xi*xi;
<a name="l00258"></a>00258             
<a name="l00259"></a>00259           <span class="keywordflow">case</span> 8:
<a name="l00260"></a>00260             <span class="keywordflow">return</span> 2.*xi*eta;
<a name="l00261"></a>00261             
<a name="l00262"></a>00262           <span class="keywordflow">case</span> 9:
<a name="l00263"></a>00263             <span class="keywordflow">return</span> 3.*eta*eta;
<a name="l00264"></a>00264             
<a name="l00265"></a>00265             <span class="comment">// quartics</span>
<a name="l00266"></a>00266           <span class="keywordflow">case</span> 10:
<a name="l00267"></a>00267             <span class="keywordflow">return</span> 0.;
<a name="l00268"></a>00268             
<a name="l00269"></a>00269           <span class="keywordflow">case</span> 11:
<a name="l00270"></a>00270             <span class="keywordflow">return</span> xi*xi*xi;
<a name="l00271"></a>00271             
<a name="l00272"></a>00272           <span class="keywordflow">case</span> 12:
<a name="l00273"></a>00273             <span class="keywordflow">return</span> 2.*xi*xi*eta;
<a name="l00274"></a>00274             
<a name="l00275"></a>00275           <span class="keywordflow">case</span> 13:
<a name="l00276"></a>00276             <span class="keywordflow">return</span> 3.*xi*eta*eta;
<a name="l00277"></a>00277             
<a name="l00278"></a>00278           <span class="keywordflow">case</span> 14:
<a name="l00279"></a>00279             <span class="keywordflow">return</span> 4.*eta*eta*eta;
<a name="l00280"></a>00280             
<a name="l00281"></a>00281           <span class="keywordflow">default</span>:
<a name="l00282"></a>00282             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00283"></a>00283             <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00284"></a>00284             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny = i - (o*(o+1)/2);
<a name="l00285"></a>00285             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx = o - ny;
<a name="l00286"></a>00286             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = ny;
<a name="l00287"></a>00287             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index != nx; index++)
<a name="l00288"></a>00288               val *= xi;
<a name="l00289"></a>00289             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=1; index &lt; ny; index++)
<a name="l00290"></a>00290               val *= eta;
<a name="l00291"></a>00291             <span class="keywordflow">return</span> val;
<a name="l00292"></a>00292           }
<a name="l00293"></a>00293       }
<a name="l00294"></a>00294     }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   libmesh_error();
<a name="l00297"></a>00297   <span class="keywordflow">return</span> 0.;
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 <span class="preprocessor">#endif</span>
<a name="l00300"></a>00300 <span class="preprocessor"></span>}
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 <span class="keyword">template</span> &lt;&gt;
<a name="l00305"></a><a class="code" href="classlibMesh_1_1FE.php#aa12d43ac3f8b2ceac3ae2e7ca1b015ac">00305</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;2,MONOMIAL&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00306"></a>00306                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00307"></a>00307                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00308"></a>00308                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00309"></a>00309                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00310"></a>00310 {
<a name="l00311"></a>00311   libmesh_assert (elem != NULL);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   <span class="comment">// by default call the orientation-independent shape functions</span>
<a name="l00314"></a>00314   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;2,MONOMIAL&gt;::shape_deriv</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, j, p); 
<a name="l00315"></a>00315 }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 <span class="keyword">template</span> &lt;&gt;
<a name="l00320"></a><a class="code" href="classlibMesh_1_1FE.php#a43522a1a1c2fd9ed1cf60447e97fd3c0">00320</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;2,MONOMIAL&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00321"></a>00321                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00322"></a>00322                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00323"></a>00323                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00324"></a>00324                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00325"></a>00325 {
<a name="l00326"></a>00326 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span>
<a name="l00328"></a>00328   
<a name="l00329"></a>00329   libmesh_assert (j&lt;=2);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   libmesh_assert (i &lt; (static_cast&lt;unsigned int&gt;(order)+1)*
<a name="l00332"></a>00332                (static_cast&lt;unsigned int&gt;(order)+2)/2);
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi  = p(0);
<a name="l00335"></a>00335   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta = p(1);
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="comment">// monomials. since they are hierarchic we only need one case block.</span>
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="keywordflow">switch</span> (j)
<a name="l00340"></a>00340     {
<a name="l00341"></a>00341       <span class="comment">// d^2()/dxi^2</span>
<a name="l00342"></a>00342     <span class="keywordflow">case</span> 0:
<a name="l00343"></a>00343       {
<a name="l00344"></a>00344         <span class="keywordflow">switch</span> (i)
<a name="l00345"></a>00345           {
<a name="l00346"></a>00346             <span class="comment">// constants</span>
<a name="l00347"></a>00347           <span class="keywordflow">case</span> 0:
<a name="l00348"></a>00348             <span class="comment">// linears</span>
<a name="l00349"></a>00349           <span class="keywordflow">case</span> 1:
<a name="l00350"></a>00350           <span class="keywordflow">case</span> 2:
<a name="l00351"></a>00351             <span class="keywordflow">return</span> 0.;
<a name="l00352"></a>00352 
<a name="l00353"></a>00353             <span class="comment">// quadratics</span>
<a name="l00354"></a>00354           <span class="keywordflow">case</span> 3:
<a name="l00355"></a>00355             <span class="keywordflow">return</span> 2.;
<a name="l00356"></a>00356             
<a name="l00357"></a>00357           <span class="keywordflow">case</span> 4:
<a name="l00358"></a>00358           <span class="keywordflow">case</span> 5:
<a name="l00359"></a>00359             <span class="keywordflow">return</span> 0.;
<a name="l00360"></a>00360 
<a name="l00361"></a>00361             <span class="comment">// cubics</span>
<a name="l00362"></a>00362           <span class="keywordflow">case</span> 6:
<a name="l00363"></a>00363             <span class="keywordflow">return</span> 6.*xi;
<a name="l00364"></a>00364             
<a name="l00365"></a>00365           <span class="keywordflow">case</span> 7:
<a name="l00366"></a>00366             <span class="keywordflow">return</span> 2.*eta;
<a name="l00367"></a>00367             
<a name="l00368"></a>00368           <span class="keywordflow">case</span> 8:
<a name="l00369"></a>00369           <span class="keywordflow">case</span> 9:
<a name="l00370"></a>00370             <span class="keywordflow">return</span> 0.;
<a name="l00371"></a>00371             
<a name="l00372"></a>00372             <span class="comment">// quartics</span>
<a name="l00373"></a>00373           <span class="keywordflow">case</span> 10:
<a name="l00374"></a>00374             <span class="keywordflow">return</span> 12.*xi*xi;
<a name="l00375"></a>00375             
<a name="l00376"></a>00376           <span class="keywordflow">case</span> 11:
<a name="l00377"></a>00377             <span class="keywordflow">return</span> 6.*xi*eta;
<a name="l00378"></a>00378             
<a name="l00379"></a>00379           <span class="keywordflow">case</span> 12:
<a name="l00380"></a>00380             <span class="keywordflow">return</span> 2.*eta*eta;
<a name="l00381"></a>00381             
<a name="l00382"></a>00382           <span class="keywordflow">case</span> 13:
<a name="l00383"></a>00383           <span class="keywordflow">case</span> 14:
<a name="l00384"></a>00384             <span class="keywordflow">return</span> 0.;
<a name="l00385"></a>00385             
<a name="l00386"></a>00386           <span class="keywordflow">default</span>:
<a name="l00387"></a>00387             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00388"></a>00388             <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00389"></a>00389             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny = i - (o*(o+1)/2);
<a name="l00390"></a>00390             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx = o - ny;
<a name="l00391"></a>00391             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = nx * (nx - 1);
<a name="l00392"></a>00392             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=2; index &lt; nx; index++)
<a name="l00393"></a>00393               val *= xi;
<a name="l00394"></a>00394             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index != ny; index++)
<a name="l00395"></a>00395               val *= eta;
<a name="l00396"></a>00396             <span class="keywordflow">return</span> val;
<a name="l00397"></a>00397           }
<a name="l00398"></a>00398       }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400       <span class="comment">// d^2()/dxideta</span>
<a name="l00401"></a>00401     <span class="keywordflow">case</span> 1:
<a name="l00402"></a>00402       {
<a name="l00403"></a>00403         <span class="keywordflow">switch</span> (i)
<a name="l00404"></a>00404           {
<a name="l00405"></a>00405             <span class="comment">// constants</span>
<a name="l00406"></a>00406           <span class="keywordflow">case</span> 0:
<a name="l00407"></a>00407             
<a name="l00408"></a>00408             <span class="comment">// linears</span>
<a name="l00409"></a>00409           <span class="keywordflow">case</span> 1:
<a name="l00410"></a>00410           <span class="keywordflow">case</span> 2:
<a name="l00411"></a>00411             <span class="keywordflow">return</span> 0.;
<a name="l00412"></a>00412 
<a name="l00413"></a>00413             <span class="comment">// quadratics</span>
<a name="l00414"></a>00414           <span class="keywordflow">case</span> 3:
<a name="l00415"></a>00415             <span class="keywordflow">return</span> 0.;
<a name="l00416"></a>00416             
<a name="l00417"></a>00417           <span class="keywordflow">case</span> 4:
<a name="l00418"></a>00418             <span class="keywordflow">return</span> 1.;
<a name="l00419"></a>00419             
<a name="l00420"></a>00420           <span class="keywordflow">case</span> 5:
<a name="l00421"></a>00421             <span class="keywordflow">return</span> 0.;
<a name="l00422"></a>00422 
<a name="l00423"></a>00423             <span class="comment">// cubics</span>
<a name="l00424"></a>00424           <span class="keywordflow">case</span> 6:
<a name="l00425"></a>00425             <span class="keywordflow">return</span> 0.;
<a name="l00426"></a>00426           <span class="keywordflow">case</span> 7:
<a name="l00427"></a>00427             <span class="keywordflow">return</span> 2.*xi;
<a name="l00428"></a>00428             
<a name="l00429"></a>00429           <span class="keywordflow">case</span> 8:
<a name="l00430"></a>00430             <span class="keywordflow">return</span> 2.*eta;
<a name="l00431"></a>00431             
<a name="l00432"></a>00432           <span class="keywordflow">case</span> 9:
<a name="l00433"></a>00433             <span class="keywordflow">return</span> 0.;
<a name="l00434"></a>00434             
<a name="l00435"></a>00435             <span class="comment">// quartics</span>
<a name="l00436"></a>00436           <span class="keywordflow">case</span> 10:
<a name="l00437"></a>00437             <span class="keywordflow">return</span> 0.;
<a name="l00438"></a>00438 
<a name="l00439"></a>00439           <span class="keywordflow">case</span> 11:
<a name="l00440"></a>00440             <span class="keywordflow">return</span> 3.*xi*xi;
<a name="l00441"></a>00441             
<a name="l00442"></a>00442           <span class="keywordflow">case</span> 12:
<a name="l00443"></a>00443             <span class="keywordflow">return</span> 4.*xi*eta;
<a name="l00444"></a>00444             
<a name="l00445"></a>00445           <span class="keywordflow">case</span> 13:
<a name="l00446"></a>00446             <span class="keywordflow">return</span> 3.*eta*eta;
<a name="l00447"></a>00447             
<a name="l00448"></a>00448           <span class="keywordflow">case</span> 14:
<a name="l00449"></a>00449             <span class="keywordflow">return</span> 0.;
<a name="l00450"></a>00450             
<a name="l00451"></a>00451           <span class="keywordflow">default</span>:
<a name="l00452"></a>00452             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00453"></a>00453             <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00454"></a>00454             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny = i - (o*(o+1)/2);
<a name="l00455"></a>00455             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx = o - ny;
<a name="l00456"></a>00456             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = nx * ny;
<a name="l00457"></a>00457             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=1; index &lt; nx; index++)
<a name="l00458"></a>00458               val *= xi;
<a name="l00459"></a>00459             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=1; index &lt; ny; index++)
<a name="l00460"></a>00460               val *= eta;
<a name="l00461"></a>00461             <span class="keywordflow">return</span> val;
<a name="l00462"></a>00462           }
<a name="l00463"></a>00463       }
<a name="l00464"></a>00464               
<a name="l00465"></a>00465       <span class="comment">// d^2()/deta^2</span>
<a name="l00466"></a>00466     <span class="keywordflow">case</span> 2:
<a name="l00467"></a>00467       {
<a name="l00468"></a>00468         <span class="keywordflow">switch</span> (i)
<a name="l00469"></a>00469           {
<a name="l00470"></a>00470             <span class="comment">// constants</span>
<a name="l00471"></a>00471           <span class="keywordflow">case</span> 0:
<a name="l00472"></a>00472             
<a name="l00473"></a>00473             <span class="comment">// linears</span>
<a name="l00474"></a>00474           <span class="keywordflow">case</span> 1:
<a name="l00475"></a>00475           <span class="keywordflow">case</span> 2:
<a name="l00476"></a>00476             <span class="keywordflow">return</span> 0.;
<a name="l00477"></a>00477 
<a name="l00478"></a>00478             <span class="comment">// quadratics</span>
<a name="l00479"></a>00479           <span class="keywordflow">case</span> 3:
<a name="l00480"></a>00480           <span class="keywordflow">case</span> 4:
<a name="l00481"></a>00481             <span class="keywordflow">return</span> 0.;
<a name="l00482"></a>00482             
<a name="l00483"></a>00483           <span class="keywordflow">case</span> 5:
<a name="l00484"></a>00484             <span class="keywordflow">return</span> 2.;
<a name="l00485"></a>00485 
<a name="l00486"></a>00486             <span class="comment">// cubics</span>
<a name="l00487"></a>00487           <span class="keywordflow">case</span> 6:
<a name="l00488"></a>00488             <span class="keywordflow">return</span> 0.;
<a name="l00489"></a>00489             
<a name="l00490"></a>00490           <span class="keywordflow">case</span> 7:
<a name="l00491"></a>00491             <span class="keywordflow">return</span> 0.;
<a name="l00492"></a>00492             
<a name="l00493"></a>00493           <span class="keywordflow">case</span> 8:
<a name="l00494"></a>00494             <span class="keywordflow">return</span> 2.*xi;
<a name="l00495"></a>00495             
<a name="l00496"></a>00496           <span class="keywordflow">case</span> 9:
<a name="l00497"></a>00497             <span class="keywordflow">return</span> 6.*eta;
<a name="l00498"></a>00498             
<a name="l00499"></a>00499             <span class="comment">// quartics</span>
<a name="l00500"></a>00500           <span class="keywordflow">case</span> 10:
<a name="l00501"></a>00501           <span class="keywordflow">case</span> 11:
<a name="l00502"></a>00502             <span class="keywordflow">return</span> 0.;
<a name="l00503"></a>00503             
<a name="l00504"></a>00504           <span class="keywordflow">case</span> 12:
<a name="l00505"></a>00505             <span class="keywordflow">return</span> 2.*xi*xi;
<a name="l00506"></a>00506             
<a name="l00507"></a>00507           <span class="keywordflow">case</span> 13:
<a name="l00508"></a>00508             <span class="keywordflow">return</span> 6.*xi*eta;
<a name="l00509"></a>00509             
<a name="l00510"></a>00510           <span class="keywordflow">case</span> 14:
<a name="l00511"></a>00511             <span class="keywordflow">return</span> 12.*eta*eta;
<a name="l00512"></a>00512             
<a name="l00513"></a>00513           <span class="keywordflow">default</span>:
<a name="l00514"></a>00514             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00515"></a>00515             <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00516"></a>00516             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny = i - (o*(o+1)/2);
<a name="l00517"></a>00517             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx = o - ny;
<a name="l00518"></a>00518             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = ny * (ny - 1);
<a name="l00519"></a>00519             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index != nx; index++)
<a name="l00520"></a>00520               val *= xi;
<a name="l00521"></a>00521             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=2; index &lt; ny; index++)
<a name="l00522"></a>00522               val *= eta;
<a name="l00523"></a>00523             <span class="keywordflow">return</span> val;
<a name="l00524"></a>00524           }
<a name="l00525"></a>00525       }
<a name="l00526"></a>00526     }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528   libmesh_error();
<a name="l00529"></a>00529   <span class="keywordflow">return</span> 0.;
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 <span class="preprocessor">#endif</span>
<a name="l00532"></a>00532 <span class="preprocessor"></span>}
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 <span class="keyword">template</span> &lt;&gt;
<a name="l00537"></a><a class="code" href="classlibMesh_1_1FE.php#aebc02347362c545bbbb991d367b3cde7">00537</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;2,MONOMIAL&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00538"></a>00538                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00539"></a>00539                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00540"></a>00540                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00541"></a>00541                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00542"></a>00542 {
<a name="l00543"></a>00543   libmesh_assert (elem != NULL);
<a name="l00544"></a>00544 
<a name="l00545"></a>00545   <span class="comment">// by default call the orientation-independent shape functions</span>
<a name="l00546"></a>00546   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;2,MONOMIAL&gt;::shape_second_deriv</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, j, p); 
<a name="l00547"></a>00547 }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
