<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_szabab.C</div>  </div>
</div>
<div class="contents">
<a href="fe__szabab_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_szabab.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="fe__macro_8h.php">fe_macro.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// Szabo-Babuska-specific implementations</span>
<a name="l00037"></a>00037 <span class="comment">// Steffen Petersen 2004</span>
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00039"></a>00039 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FE.php#aeddb953b5b64abc7ab1efa1e5ffc68e9">FE&lt;Dim,T&gt;::nodal_soln</a>(<span class="keyword">const</span> Elem* elem,
<a name="l00040"></a>00040                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00041"></a>00041                            <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00042"></a>00042                            std::vector&lt;Number&gt;&amp;       nodal_soln)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;n_nodes();
<a name="l00045"></a>00045   
<a name="l00046"></a>00046   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type = elem-&gt;type();
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   nodal_soln.resize(n_nodes);
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> totalorder = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order+elem-&gt;p_level());
<a name="l00051"></a>00051   
<a name="l00052"></a>00052   <span class="keywordflow">switch</span> (totalorder)
<a name="l00053"></a>00053     {
<a name="l00054"></a>00054       <span class="comment">// Constant shape functions</span>
<a name="l00055"></a>00055     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>:
<a name="l00056"></a>00056       {
<a name="l00057"></a>00057         libmesh_assert (elem_soln.size() == 1);
<a name="l00058"></a>00058         
<a name="l00059"></a>00059         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> val = elem_soln[0];
<a name="l00060"></a>00060         
<a name="l00061"></a>00061         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; n++)
<a name="l00062"></a>00062           nodal_soln[n] = val;
<a name="l00063"></a>00063         
<a name="l00064"></a>00064         <span class="keywordflow">return</span>;
<a name="l00065"></a>00065       }
<a name="l00066"></a>00066       
<a name="l00067"></a>00067       
<a name="l00068"></a>00068       <span class="comment">// For other bases do interpolation at the nodes</span>
<a name="l00069"></a>00069       <span class="comment">// explicitly.</span>
<a name="l00070"></a>00070     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00071"></a>00071     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00072"></a>00072     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00073"></a>00073     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00074"></a>00074     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00075"></a>00075     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00076"></a>00076     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00077"></a>00077       {
<a name="l00078"></a>00078         
<a name="l00079"></a>00079         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sf =
<a name="l00080"></a>00080           <a class="code" href="classlibMesh_1_1FE.php#a9d1dc6da0f47b44bd128310498bcb4f0">FE&lt;Dim,T&gt;::n_shape_functions</a>(type, totalorder);
<a name="l00081"></a>00081         
<a name="l00082"></a>00082         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; n++)
<a name="l00083"></a>00083           {
<a name="l00084"></a>00084             <span class="keyword">const</span> Point mapped_point = <a class="code" href="classlibMesh_1_1FE.php#ac17b5ee3f4e5b0bc2c66a1380582e324">FE&lt;Dim,T&gt;::inverse_map</a>(elem,
<a name="l00085"></a>00085                                                               elem-&gt;point(n));
<a name="l00086"></a>00086             
<a name="l00087"></a>00087             libmesh_assert (elem_soln.size() == n_sf);
<a name="l00088"></a>00088             
<a name="l00089"></a>00089             <span class="comment">// Zero before summation</span>
<a name="l00090"></a>00090             nodal_soln[n] = 0;
<a name="l00091"></a>00091             
<a name="l00092"></a>00092             <span class="comment">// u_i = Sum (alpha_i phi_i)</span>
<a name="l00093"></a>00093             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sf; i++)
<a name="l00094"></a>00094               nodal_soln[n] += elem_soln[i]*FE&lt;Dim,T&gt;::shape(elem,
<a name="l00095"></a>00095                                                              order,
<a name="l00096"></a>00096                                                              i,
<a name="l00097"></a>00097                                                              mapped_point);         
<a name="l00098"></a>00098           }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <span class="keywordflow">return</span>;
<a name="l00101"></a>00101       }
<a name="l00102"></a>00102       
<a name="l00103"></a>00103     <span class="keywordflow">default</span>:
<a name="l00104"></a>00104       {
<a name="l00105"></a>00105         libmesh_error();
<a name="l00106"></a>00106         <span class="keywordflow">return</span>;
<a name="l00107"></a>00107       }
<a name="l00108"></a>00108     }
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   
<a name="l00111"></a>00111   <span class="comment">// We should never get here?</span>
<a name="l00112"></a>00112   libmesh_error();  
<a name="l00113"></a>00113   <span class="keywordflow">return</span>;
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00119"></a>00119 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a401b5a255c73cd4fd202aadee954ba37">FE&lt;Dim,T&gt;::n_dofs</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o)
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121   <span class="keywordflow">switch</span> (o)
<a name="l00122"></a>00122     {
<a name="l00123"></a>00123       <span class="comment">// Szabo-Babuska 1st-order polynomials.</span>
<a name="l00124"></a>00124     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00125"></a>00125       {
<a name="l00126"></a>00126         <span class="keywordflow">switch</span> (t)
<a name="l00127"></a>00127           {
<a name="l00128"></a>00128           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00129"></a>00129             <span class="keywordflow">return</span> 1;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00132"></a>00132           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00133"></a>00133             <span class="keywordflow">return</span> 2;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00136"></a>00136             <span class="keywordflow">return</span> 3;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00139"></a>00139           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00140"></a>00140             <span class="keywordflow">return</span> 4;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142           <span class="keywordflow">default</span>:
<a name="l00143"></a>00143             libmesh_error();
<a name="l00144"></a>00144           }
<a name="l00145"></a>00145       }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148       <span class="comment">// Szabo-Babuska 2nd-order polynomials.</span>
<a name="l00149"></a>00149     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00150"></a>00150       {
<a name="l00151"></a>00151         <span class="keywordflow">switch</span> (t)
<a name="l00152"></a>00152           {
<a name="l00153"></a>00153           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00154"></a>00154             <span class="keywordflow">return</span> 1;
<a name="l00155"></a>00155 
<a name="l00156"></a>00156           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00157"></a>00157           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00158"></a>00158             <span class="keywordflow">return</span> 3;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00161"></a>00161             <span class="keywordflow">return</span> 6;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00164"></a>00164             <span class="keywordflow">return</span> 8;
<a name="l00165"></a>00165           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00166"></a>00166             <span class="keywordflow">return</span> 9;
<a name="l00167"></a>00167             
<a name="l00168"></a>00168           <span class="keywordflow">default</span>:
<a name="l00169"></a>00169             libmesh_error();
<a name="l00170"></a>00170           }
<a name="l00171"></a>00171       }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174       <span class="comment">// Szabo-Babuska 3rd-order polynomials.</span>
<a name="l00175"></a>00175     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00176"></a>00176       {
<a name="l00177"></a>00177         <span class="keywordflow">switch</span> (t)
<a name="l00178"></a>00178           {
<a name="l00179"></a>00179           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00180"></a>00180             <span class="keywordflow">return</span> 1;
<a name="l00181"></a>00181 
<a name="l00182"></a>00182           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00183"></a>00183           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00184"></a>00184             <span class="keywordflow">return</span> 4;
<a name="l00185"></a>00185 
<a name="l00186"></a>00186           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00187"></a>00187             <span class="keywordflow">return</span> 10;
<a name="l00188"></a>00188             
<a name="l00189"></a>00189           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00190"></a>00190           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00191"></a>00191             <span class="keywordflow">return</span> 16;
<a name="l00192"></a>00192 
<a name="l00193"></a>00193           <span class="keywordflow">default</span>:
<a name="l00194"></a>00194             libmesh_error();
<a name="l00195"></a>00195           }
<a name="l00196"></a>00196       }
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199       <span class="comment">// Szabo-Babuska 4th-order polynomials.</span>
<a name="l00200"></a>00200     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00201"></a>00201       {
<a name="l00202"></a>00202         <span class="keywordflow">switch</span> (t)
<a name="l00203"></a>00203           {
<a name="l00204"></a>00204           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00205"></a>00205             <span class="keywordflow">return</span> 1;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00208"></a>00208           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00209"></a>00209             <span class="keywordflow">return</span> 5;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00212"></a>00212             <span class="keywordflow">return</span> 15;
<a name="l00213"></a>00213             
<a name="l00214"></a>00214           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00215"></a>00215           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00216"></a>00216             <span class="keywordflow">return</span> 25;
<a name="l00217"></a>00217 
<a name="l00218"></a>00218           <span class="keywordflow">default</span>:
<a name="l00219"></a>00219             libmesh_error();
<a name="l00220"></a>00220           }
<a name="l00221"></a>00221       }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224       <span class="comment">// Szabo-Babuska 5th-order polynomials.</span>
<a name="l00225"></a>00225     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00226"></a>00226       {
<a name="l00227"></a>00227         <span class="keywordflow">switch</span> (t)
<a name="l00228"></a>00228           {
<a name="l00229"></a>00229           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00230"></a>00230             <span class="keywordflow">return</span> 1;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00233"></a>00233           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00234"></a>00234             <span class="keywordflow">return</span> 6;
<a name="l00235"></a>00235 
<a name="l00236"></a>00236           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00237"></a>00237             <span class="keywordflow">return</span> 21;
<a name="l00238"></a>00238               
<a name="l00239"></a>00239           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00240"></a>00240           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00241"></a>00241             <span class="keywordflow">return</span> 36;
<a name="l00242"></a>00242 
<a name="l00243"></a>00243           <span class="keywordflow">default</span>:
<a name="l00244"></a>00244             libmesh_error();
<a name="l00245"></a>00245           }
<a name="l00246"></a>00246       }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248       
<a name="l00249"></a>00249       <span class="comment">// Szabo-Babuska 6th-order polynomials.</span>
<a name="l00250"></a>00250     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00251"></a>00251       {
<a name="l00252"></a>00252         <span class="keywordflow">switch</span> (t)
<a name="l00253"></a>00253           {
<a name="l00254"></a>00254           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00255"></a>00255             <span class="keywordflow">return</span> 1;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00258"></a>00258           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00259"></a>00259             <span class="keywordflow">return</span> 7;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00262"></a>00262             <span class="keywordflow">return</span> 28;
<a name="l00263"></a>00263               
<a name="l00264"></a>00264           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00265"></a>00265           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00266"></a>00266             <span class="keywordflow">return</span> 49;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268           <span class="keywordflow">default</span>:
<a name="l00269"></a>00269             libmesh_error();
<a name="l00270"></a>00270           }
<a name="l00271"></a>00271       }
<a name="l00272"></a>00272 
<a name="l00273"></a>00273       <span class="comment">// Szabo-Babuska 7th-order polynomials.</span>
<a name="l00274"></a>00274     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00275"></a>00275       {
<a name="l00276"></a>00276         <span class="keywordflow">switch</span> (t)
<a name="l00277"></a>00277           {
<a name="l00278"></a>00278           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00279"></a>00279             <span class="keywordflow">return</span> 1;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00282"></a>00282           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00283"></a>00283             <span class="keywordflow">return</span> 8;
<a name="l00284"></a>00284 
<a name="l00285"></a>00285           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00286"></a>00286             <span class="keywordflow">return</span> 36;
<a name="l00287"></a>00287               
<a name="l00288"></a>00288           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00289"></a>00289           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00290"></a>00290             <span class="keywordflow">return</span> 64;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292           <span class="keywordflow">default</span>:
<a name="l00293"></a>00293             libmesh_error();
<a name="l00294"></a>00294           }
<a name="l00295"></a>00295       }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297         
<a name="l00298"></a>00298     <span class="keywordflow">default</span>:
<a name="l00299"></a>00299       {
<a name="l00300"></a>00300         libmesh_error();
<a name="l00301"></a>00301       }
<a name="l00302"></a>00302     }
<a name="l00303"></a>00303   
<a name="l00304"></a>00304   libmesh_error();  
<a name="l00305"></a>00305   <span class="keywordflow">return</span> 0;
<a name="l00306"></a>00306 }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00311"></a>00311 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a00239d73fd53a032ab838a5d0a7dc7ce">FE&lt;Dim,T&gt;::n_dofs_at_node</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00312"></a>00312                                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o,
<a name="l00313"></a>00313                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00314"></a>00314 {
<a name="l00315"></a>00315   <span class="keywordflow">switch</span> (o)
<a name="l00316"></a>00316     {
<a name="l00317"></a>00317       <span class="comment">// The first-order Szabo-Babuska shape functions</span>
<a name="l00318"></a>00318     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00319"></a>00319       {
<a name="l00320"></a>00320         <span class="keywordflow">switch</span> (t)
<a name="l00321"></a>00321           {
<a name="l00322"></a>00322           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00323"></a>00323             <span class="keywordflow">return</span> 1;
<a name="l00324"></a>00324 
<a name="l00325"></a>00325             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l00326"></a>00326           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00327"></a>00327           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00328"></a>00328             {
<a name="l00329"></a>00329               <span class="keywordflow">switch</span> (n)
<a name="l00330"></a>00330                 {
<a name="l00331"></a>00331                 <span class="keywordflow">case</span> 0:
<a name="l00332"></a>00332                 <span class="keywordflow">case</span> 1:
<a name="l00333"></a>00333                   <span class="keywordflow">return</span> 1;
<a name="l00334"></a>00334 
<a name="l00335"></a>00335                 <span class="keywordflow">case</span> 2:
<a name="l00336"></a>00336                   <span class="keywordflow">return</span> 0;
<a name="l00337"></a>00337                   
<a name="l00338"></a>00338                 <span class="keywordflow">default</span>:
<a name="l00339"></a>00339                   libmesh_error();                
<a name="l00340"></a>00340                 }
<a name="l00341"></a>00341             }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343             
<a name="l00344"></a>00344             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l00345"></a>00345           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00346"></a>00346             {
<a name="l00347"></a>00347               <span class="keywordflow">switch</span> (n)
<a name="l00348"></a>00348                 {
<a name="l00349"></a>00349                 <span class="keywordflow">case</span> 0:
<a name="l00350"></a>00350                 <span class="keywordflow">case</span> 1:
<a name="l00351"></a>00351                 <span class="keywordflow">case</span> 2:
<a name="l00352"></a>00352                   <span class="keywordflow">return</span> 1;
<a name="l00353"></a>00353 
<a name="l00354"></a>00354                 <span class="keywordflow">case</span> 3:
<a name="l00355"></a>00355                 <span class="keywordflow">case</span> 4:
<a name="l00356"></a>00356                 <span class="keywordflow">case</span> 5:
<a name="l00357"></a>00357                   <span class="keywordflow">return</span> 0;
<a name="l00358"></a>00358 
<a name="l00359"></a>00359                 <span class="keywordflow">default</span>:
<a name="l00360"></a>00360                   libmesh_error();
<a name="l00361"></a>00361                 }
<a name="l00362"></a>00362             }
<a name="l00363"></a>00363             
<a name="l00364"></a>00364 
<a name="l00365"></a>00365             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00366"></a>00366             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00367"></a>00367           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00368"></a>00368           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00369"></a>00369             {
<a name="l00370"></a>00370               <span class="keywordflow">switch</span> (n)
<a name="l00371"></a>00371                 {
<a name="l00372"></a>00372                 <span class="keywordflow">case</span> 0:
<a name="l00373"></a>00373                 <span class="keywordflow">case</span> 1:
<a name="l00374"></a>00374                 <span class="keywordflow">case</span> 2:
<a name="l00375"></a>00375                 <span class="keywordflow">case</span> 3:
<a name="l00376"></a>00376                   <span class="keywordflow">return</span> 1;
<a name="l00377"></a>00377 
<a name="l00378"></a>00378                 <span class="keywordflow">case</span> 4:
<a name="l00379"></a>00379                 <span class="keywordflow">case</span> 5:
<a name="l00380"></a>00380                 <span class="keywordflow">case</span> 6:
<a name="l00381"></a>00381                 <span class="keywordflow">case</span> 7:
<a name="l00382"></a>00382                   <span class="keywordflow">return</span> 0;
<a name="l00383"></a>00383                   
<a name="l00384"></a>00384                 <span class="keywordflow">case</span> 8:
<a name="l00385"></a>00385                   <span class="keywordflow">return</span> 0;
<a name="l00386"></a>00386                   
<a name="l00387"></a>00387                 <span class="keywordflow">default</span>:
<a name="l00388"></a>00388                   libmesh_error();
<a name="l00389"></a>00389                 }
<a name="l00390"></a>00390             }
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00393"></a>00393           <span class="keywordflow">default</span>:
<a name="l00394"></a>00394             libmesh_error();
<a name="l00395"></a>00395             
<a name="l00396"></a>00396           }
<a name="l00397"></a>00397       }
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401       <span class="comment">// The second-order Szabo-Babuska shape functions</span>
<a name="l00402"></a>00402     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00403"></a>00403       {
<a name="l00404"></a>00404         <span class="keywordflow">switch</span> (t)
<a name="l00405"></a>00405           {
<a name="l00406"></a>00406           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00407"></a>00407             <span class="keywordflow">return</span> 1;
<a name="l00408"></a>00408 
<a name="l00409"></a>00409             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l00410"></a>00410           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00411"></a>00411           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00412"></a>00412             {
<a name="l00413"></a>00413               <span class="keywordflow">switch</span> (n)
<a name="l00414"></a>00414                 {
<a name="l00415"></a>00415                 <span class="keywordflow">case</span> 0:
<a name="l00416"></a>00416                 <span class="keywordflow">case</span> 1:
<a name="l00417"></a>00417                   <span class="keywordflow">return</span> 1;
<a name="l00418"></a>00418 
<a name="l00419"></a>00419                 <span class="keywordflow">case</span> 2:
<a name="l00420"></a>00420                   <span class="keywordflow">return</span> 1;
<a name="l00421"></a>00421                   
<a name="l00422"></a>00422                 <span class="keywordflow">default</span>:
<a name="l00423"></a>00423                   libmesh_error();                
<a name="l00424"></a>00424                 }
<a name="l00425"></a>00425             }
<a name="l00426"></a>00426 
<a name="l00427"></a>00427             
<a name="l00428"></a>00428             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l00429"></a>00429           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00430"></a>00430             {
<a name="l00431"></a>00431               <span class="keywordflow">switch</span> (n)
<a name="l00432"></a>00432                 {
<a name="l00433"></a>00433                 <span class="keywordflow">case</span> 0:
<a name="l00434"></a>00434                 <span class="keywordflow">case</span> 1:
<a name="l00435"></a>00435                 <span class="keywordflow">case</span> 2:
<a name="l00436"></a>00436                   <span class="keywordflow">return</span> 1;
<a name="l00437"></a>00437 
<a name="l00438"></a>00438                 <span class="keywordflow">case</span> 3:
<a name="l00439"></a>00439                 <span class="keywordflow">case</span> 4:
<a name="l00440"></a>00440                 <span class="keywordflow">case</span> 5:
<a name="l00441"></a>00441                   <span class="keywordflow">return</span> 1;
<a name="l00442"></a>00442 
<a name="l00443"></a>00443                 <span class="keywordflow">default</span>:
<a name="l00444"></a>00444                   libmesh_error();
<a name="l00445"></a>00445                 }
<a name="l00446"></a>00446             }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00450"></a>00450             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00451"></a>00451           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00452"></a>00452           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00453"></a>00453             {
<a name="l00454"></a>00454               <span class="keywordflow">switch</span> (n)
<a name="l00455"></a>00455                 {
<a name="l00456"></a>00456                 <span class="keywordflow">case</span> 0:
<a name="l00457"></a>00457                 <span class="keywordflow">case</span> 1:
<a name="l00458"></a>00458                 <span class="keywordflow">case</span> 2:
<a name="l00459"></a>00459                 <span class="keywordflow">case</span> 3:
<a name="l00460"></a>00460                   <span class="keywordflow">return</span> 1;
<a name="l00461"></a>00461 
<a name="l00462"></a>00462                 <span class="keywordflow">case</span> 4:
<a name="l00463"></a>00463                 <span class="keywordflow">case</span> 5:
<a name="l00464"></a>00464                 <span class="keywordflow">case</span> 6:
<a name="l00465"></a>00465                 <span class="keywordflow">case</span> 7:
<a name="l00466"></a>00466                   <span class="keywordflow">return</span> 1;
<a name="l00467"></a>00467                   
<a name="l00468"></a>00468                 <span class="keywordflow">case</span> 8:
<a name="l00469"></a>00469                   <span class="keywordflow">return</span> 1;
<a name="l00470"></a>00470                   
<a name="l00471"></a>00471                 <span class="keywordflow">default</span>:
<a name="l00472"></a>00472                   libmesh_error();
<a name="l00473"></a>00473                 }
<a name="l00474"></a>00474             }
<a name="l00475"></a>00475 
<a name="l00476"></a>00476             
<a name="l00477"></a>00477           <span class="keywordflow">default</span>:
<a name="l00478"></a>00478             libmesh_error();
<a name="l00479"></a>00479             
<a name="l00480"></a>00480           }
<a name="l00481"></a>00481       }
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 
<a name="l00485"></a>00485       <span class="comment">// The third-order Szabo-Babuska shape functions</span>
<a name="l00486"></a>00486     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00487"></a>00487       {
<a name="l00488"></a>00488         <span class="keywordflow">switch</span> (t)
<a name="l00489"></a>00489           {
<a name="l00490"></a>00490           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00491"></a>00491             <span class="keywordflow">return</span> 1;
<a name="l00492"></a>00492 
<a name="l00493"></a>00493             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l00494"></a>00494           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00495"></a>00495           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00496"></a>00496             {
<a name="l00497"></a>00497               <span class="keywordflow">switch</span> (n)
<a name="l00498"></a>00498                 {
<a name="l00499"></a>00499                 <span class="keywordflow">case</span> 0:
<a name="l00500"></a>00500                 <span class="keywordflow">case</span> 1:
<a name="l00501"></a>00501                   <span class="keywordflow">return</span> 1;
<a name="l00502"></a>00502 
<a name="l00503"></a>00503                 <span class="keywordflow">case</span> 2:
<a name="l00504"></a>00504                   <span class="keywordflow">return</span> 2;
<a name="l00505"></a>00505                   
<a name="l00506"></a>00506                 <span class="keywordflow">default</span>:
<a name="l00507"></a>00507                   libmesh_error();                
<a name="l00508"></a>00508                 }
<a name="l00509"></a>00509             }
<a name="l00510"></a>00510 
<a name="l00511"></a>00511             
<a name="l00512"></a>00512             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l00513"></a>00513           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00514"></a>00514             {
<a name="l00515"></a>00515               <span class="keywordflow">switch</span> (n)
<a name="l00516"></a>00516                 {
<a name="l00517"></a>00517                 <span class="keywordflow">case</span> 0:
<a name="l00518"></a>00518                 <span class="keywordflow">case</span> 1:
<a name="l00519"></a>00519                 <span class="keywordflow">case</span> 2:
<a name="l00520"></a>00520                   <span class="keywordflow">return</span> 1;
<a name="l00521"></a>00521 
<a name="l00522"></a>00522                 <span class="keywordflow">case</span> 3:
<a name="l00523"></a>00523                 <span class="keywordflow">case</span> 4:
<a name="l00524"></a>00524                 <span class="keywordflow">case</span> 5:
<a name="l00525"></a>00525                   <span class="keywordflow">return</span> 2;
<a name="l00526"></a>00526 
<a name="l00527"></a>00527                 <span class="keywordflow">default</span>:
<a name="l00528"></a>00528                   libmesh_error();
<a name="l00529"></a>00529                 }
<a name="l00530"></a>00530             }
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 
<a name="l00533"></a>00533             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00534"></a>00534             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00535"></a>00535           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00536"></a>00536           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00537"></a>00537             {
<a name="l00538"></a>00538               <span class="keywordflow">switch</span> (n)
<a name="l00539"></a>00539                 {
<a name="l00540"></a>00540                 <span class="keywordflow">case</span> 0:
<a name="l00541"></a>00541                 <span class="keywordflow">case</span> 1:
<a name="l00542"></a>00542                 <span class="keywordflow">case</span> 2:
<a name="l00543"></a>00543                 <span class="keywordflow">case</span> 3:
<a name="l00544"></a>00544                   <span class="keywordflow">return</span> 1;
<a name="l00545"></a>00545 
<a name="l00546"></a>00546                 <span class="keywordflow">case</span> 4:
<a name="l00547"></a>00547                 <span class="keywordflow">case</span> 5:
<a name="l00548"></a>00548                 <span class="keywordflow">case</span> 6:
<a name="l00549"></a>00549                 <span class="keywordflow">case</span> 7:
<a name="l00550"></a>00550                   <span class="keywordflow">return</span> 2;
<a name="l00551"></a>00551                   
<a name="l00552"></a>00552                 <span class="keywordflow">case</span> 8:
<a name="l00553"></a>00553                   <span class="keywordflow">return</span> 4;
<a name="l00554"></a>00554                   
<a name="l00555"></a>00555                 <span class="keywordflow">default</span>:
<a name="l00556"></a>00556                   libmesh_error();
<a name="l00557"></a>00557                 }
<a name="l00558"></a>00558             }
<a name="l00559"></a>00559 
<a name="l00560"></a>00560 
<a name="l00561"></a>00561           <span class="keywordflow">default</span>:
<a name="l00562"></a>00562             libmesh_error();
<a name="l00563"></a>00563             
<a name="l00564"></a>00564           }
<a name="l00565"></a>00565       }
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a>00569       <span class="comment">// The fourth-order Szabo-Babuska shape functions</span>
<a name="l00570"></a>00570     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00571"></a>00571       {
<a name="l00572"></a>00572         <span class="keywordflow">switch</span> (t)
<a name="l00573"></a>00573           {
<a name="l00574"></a>00574           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00575"></a>00575             <span class="keywordflow">return</span> 1;
<a name="l00576"></a>00576 
<a name="l00577"></a>00577             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l00578"></a>00578           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00579"></a>00579           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00580"></a>00580             {
<a name="l00581"></a>00581               <span class="keywordflow">switch</span> (n)
<a name="l00582"></a>00582                 {
<a name="l00583"></a>00583                 <span class="keywordflow">case</span> 0:
<a name="l00584"></a>00584                 <span class="keywordflow">case</span> 1:
<a name="l00585"></a>00585                   <span class="keywordflow">return</span> 1;
<a name="l00586"></a>00586 
<a name="l00587"></a>00587                 <span class="keywordflow">case</span> 2:
<a name="l00588"></a>00588                   <span class="keywordflow">return</span> 3;
<a name="l00589"></a>00589                   
<a name="l00590"></a>00590                 <span class="keywordflow">default</span>:
<a name="l00591"></a>00591                   libmesh_error();                
<a name="l00592"></a>00592                 }
<a name="l00593"></a>00593             }
<a name="l00594"></a>00594 
<a name="l00595"></a>00595             
<a name="l00596"></a>00596             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l00597"></a>00597           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00598"></a>00598             {
<a name="l00599"></a>00599               <span class="keywordflow">switch</span> (n)
<a name="l00600"></a>00600                 {
<a name="l00601"></a>00601                 <span class="keywordflow">case</span> 0:
<a name="l00602"></a>00602                 <span class="keywordflow">case</span> 1:
<a name="l00603"></a>00603                 <span class="keywordflow">case</span> 2:
<a name="l00604"></a>00604                   <span class="keywordflow">return</span> 1;
<a name="l00605"></a>00605 
<a name="l00606"></a>00606                 <span class="keywordflow">case</span> 3:
<a name="l00607"></a>00607                 <span class="keywordflow">case</span> 4:
<a name="l00608"></a>00608                 <span class="keywordflow">case</span> 5:
<a name="l00609"></a>00609                   <span class="keywordflow">return</span> 3;
<a name="l00610"></a>00610 
<a name="l00611"></a>00611                 <span class="keywordflow">default</span>:
<a name="l00612"></a>00612                   libmesh_error();
<a name="l00613"></a>00613                 }
<a name="l00614"></a>00614             }
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00618"></a>00618             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00619"></a>00619           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00620"></a>00620           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00621"></a>00621             {
<a name="l00622"></a>00622               <span class="keywordflow">switch</span> (n)
<a name="l00623"></a>00623                 {
<a name="l00624"></a>00624                 <span class="keywordflow">case</span> 0:
<a name="l00625"></a>00625                 <span class="keywordflow">case</span> 1:
<a name="l00626"></a>00626                 <span class="keywordflow">case</span> 2:
<a name="l00627"></a>00627                 <span class="keywordflow">case</span> 3:
<a name="l00628"></a>00628                   <span class="keywordflow">return</span> 1;
<a name="l00629"></a>00629 
<a name="l00630"></a>00630                 <span class="keywordflow">case</span> 4:
<a name="l00631"></a>00631                 <span class="keywordflow">case</span> 5:
<a name="l00632"></a>00632                 <span class="keywordflow">case</span> 6:
<a name="l00633"></a>00633                 <span class="keywordflow">case</span> 7:
<a name="l00634"></a>00634                   <span class="keywordflow">return</span> 3;
<a name="l00635"></a>00635                   
<a name="l00636"></a>00636                 <span class="keywordflow">case</span> 8:
<a name="l00637"></a>00637                   <span class="keywordflow">return</span> 9;
<a name="l00638"></a>00638                   
<a name="l00639"></a>00639                 <span class="keywordflow">default</span>:
<a name="l00640"></a>00640                   libmesh_error();
<a name="l00641"></a>00641                 }
<a name="l00642"></a>00642             }
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 
<a name="l00645"></a>00645           <span class="keywordflow">default</span>:
<a name="l00646"></a>00646             libmesh_error();
<a name="l00647"></a>00647             
<a name="l00648"></a>00648           }
<a name="l00649"></a>00649       }
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653       <span class="comment">// The fifth-order Szabo-Babuska shape functions</span>
<a name="l00654"></a>00654     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00655"></a>00655       {
<a name="l00656"></a>00656         <span class="keywordflow">switch</span> (t)
<a name="l00657"></a>00657           {
<a name="l00658"></a>00658           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00659"></a>00659             <span class="keywordflow">return</span> 1;
<a name="l00660"></a>00660 
<a name="l00661"></a>00661             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l00662"></a>00662           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00663"></a>00663           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00664"></a>00664             {
<a name="l00665"></a>00665               <span class="keywordflow">switch</span> (n)
<a name="l00666"></a>00666                 {
<a name="l00667"></a>00667                 <span class="keywordflow">case</span> 0:
<a name="l00668"></a>00668                 <span class="keywordflow">case</span> 1:
<a name="l00669"></a>00669                   <span class="keywordflow">return</span> 1;
<a name="l00670"></a>00670 
<a name="l00671"></a>00671                 <span class="keywordflow">case</span> 2:
<a name="l00672"></a>00672                   <span class="keywordflow">return</span> 4;
<a name="l00673"></a>00673                   
<a name="l00674"></a>00674                 <span class="keywordflow">default</span>:
<a name="l00675"></a>00675                   libmesh_error();                
<a name="l00676"></a>00676                 }
<a name="l00677"></a>00677             }
<a name="l00678"></a>00678 
<a name="l00679"></a>00679             
<a name="l00680"></a>00680             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l00681"></a>00681           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00682"></a>00682             {
<a name="l00683"></a>00683               <span class="keywordflow">switch</span> (n)
<a name="l00684"></a>00684                 {
<a name="l00685"></a>00685                 <span class="keywordflow">case</span> 0:
<a name="l00686"></a>00686                 <span class="keywordflow">case</span> 1:
<a name="l00687"></a>00687                 <span class="keywordflow">case</span> 2:
<a name="l00688"></a>00688                   <span class="keywordflow">return</span> 1;
<a name="l00689"></a>00689 
<a name="l00690"></a>00690                 <span class="keywordflow">case</span> 3:
<a name="l00691"></a>00691                 <span class="keywordflow">case</span> 4:
<a name="l00692"></a>00692                 <span class="keywordflow">case</span> 5:
<a name="l00693"></a>00693                   <span class="keywordflow">return</span> 4;
<a name="l00694"></a>00694 
<a name="l00695"></a>00695                 <span class="keywordflow">default</span>:
<a name="l00696"></a>00696                   libmesh_error();
<a name="l00697"></a>00697                 }
<a name="l00698"></a>00698             }
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 
<a name="l00701"></a>00701             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00702"></a>00702             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00703"></a>00703           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00704"></a>00704           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00705"></a>00705             {
<a name="l00706"></a>00706               <span class="keywordflow">switch</span> (n)
<a name="l00707"></a>00707                 {
<a name="l00708"></a>00708                 <span class="keywordflow">case</span> 0:
<a name="l00709"></a>00709                 <span class="keywordflow">case</span> 1:
<a name="l00710"></a>00710                 <span class="keywordflow">case</span> 2:
<a name="l00711"></a>00711                 <span class="keywordflow">case</span> 3:
<a name="l00712"></a>00712                   <span class="keywordflow">return</span> 1;
<a name="l00713"></a>00713 
<a name="l00714"></a>00714                 <span class="keywordflow">case</span> 4:
<a name="l00715"></a>00715                 <span class="keywordflow">case</span> 5:
<a name="l00716"></a>00716                 <span class="keywordflow">case</span> 6:
<a name="l00717"></a>00717                 <span class="keywordflow">case</span> 7:
<a name="l00718"></a>00718                   <span class="keywordflow">return</span> 4;
<a name="l00719"></a>00719                   
<a name="l00720"></a>00720                 <span class="keywordflow">case</span> 8:
<a name="l00721"></a>00721                   <span class="keywordflow">return</span> 16;
<a name="l00722"></a>00722                   
<a name="l00723"></a>00723                 <span class="keywordflow">default</span>:
<a name="l00724"></a>00724                   libmesh_error();
<a name="l00725"></a>00725                 }
<a name="l00726"></a>00726             }
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 
<a name="l00729"></a>00729           <span class="keywordflow">default</span>:
<a name="l00730"></a>00730             libmesh_error();
<a name="l00731"></a>00731             
<a name="l00732"></a>00732           }
<a name="l00733"></a>00733       }
<a name="l00734"></a>00734 
<a name="l00735"></a>00735 
<a name="l00736"></a>00736 
<a name="l00737"></a>00737       <span class="comment">// The sixth-order Szabo-Babuska shape functions</span>
<a name="l00738"></a>00738     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00739"></a>00739       {
<a name="l00740"></a>00740         <span class="keywordflow">switch</span> (t)
<a name="l00741"></a>00741           {
<a name="l00742"></a>00742           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00743"></a>00743             <span class="keywordflow">return</span> 1;
<a name="l00744"></a>00744 
<a name="l00745"></a>00745             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l00746"></a>00746           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00747"></a>00747           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00748"></a>00748             {
<a name="l00749"></a>00749               <span class="keywordflow">switch</span> (n)
<a name="l00750"></a>00750                 {
<a name="l00751"></a>00751                 <span class="keywordflow">case</span> 0:
<a name="l00752"></a>00752                 <span class="keywordflow">case</span> 1:
<a name="l00753"></a>00753                   <span class="keywordflow">return</span> 1;
<a name="l00754"></a>00754 
<a name="l00755"></a>00755                 <span class="keywordflow">case</span> 2:
<a name="l00756"></a>00756                   <span class="keywordflow">return</span> 5;
<a name="l00757"></a>00757                   
<a name="l00758"></a>00758                 <span class="keywordflow">default</span>:
<a name="l00759"></a>00759                   libmesh_error();                
<a name="l00760"></a>00760                 }
<a name="l00761"></a>00761             }
<a name="l00762"></a>00762 
<a name="l00763"></a>00763             
<a name="l00764"></a>00764             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l00765"></a>00765           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00766"></a>00766             {
<a name="l00767"></a>00767               <span class="keywordflow">switch</span> (n)
<a name="l00768"></a>00768                 {
<a name="l00769"></a>00769                 <span class="keywordflow">case</span> 0:
<a name="l00770"></a>00770                 <span class="keywordflow">case</span> 1:
<a name="l00771"></a>00771                 <span class="keywordflow">case</span> 2:
<a name="l00772"></a>00772                   <span class="keywordflow">return</span> 1;
<a name="l00773"></a>00773 
<a name="l00774"></a>00774                 <span class="keywordflow">case</span> 3:
<a name="l00775"></a>00775                 <span class="keywordflow">case</span> 4:
<a name="l00776"></a>00776                 <span class="keywordflow">case</span> 5:
<a name="l00777"></a>00777                   <span class="keywordflow">return</span> 5;
<a name="l00778"></a>00778 
<a name="l00779"></a>00779                 <span class="keywordflow">default</span>:
<a name="l00780"></a>00780                   libmesh_error();
<a name="l00781"></a>00781                 }
<a name="l00782"></a>00782             }
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 
<a name="l00785"></a>00785             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00786"></a>00786             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00787"></a>00787           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00788"></a>00788           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00789"></a>00789             {
<a name="l00790"></a>00790               <span class="keywordflow">switch</span> (n)
<a name="l00791"></a>00791                 {
<a name="l00792"></a>00792                 <span class="keywordflow">case</span> 0:
<a name="l00793"></a>00793                 <span class="keywordflow">case</span> 1:
<a name="l00794"></a>00794                 <span class="keywordflow">case</span> 2:
<a name="l00795"></a>00795                 <span class="keywordflow">case</span> 3:
<a name="l00796"></a>00796                   <span class="keywordflow">return</span> 1;
<a name="l00797"></a>00797 
<a name="l00798"></a>00798                 <span class="keywordflow">case</span> 4:
<a name="l00799"></a>00799                 <span class="keywordflow">case</span> 5:
<a name="l00800"></a>00800                 <span class="keywordflow">case</span> 6:
<a name="l00801"></a>00801                 <span class="keywordflow">case</span> 7:
<a name="l00802"></a>00802                   <span class="keywordflow">return</span> 5;
<a name="l00803"></a>00803                   
<a name="l00804"></a>00804                 <span class="keywordflow">case</span> 8:
<a name="l00805"></a>00805                   <span class="keywordflow">return</span> 25;
<a name="l00806"></a>00806                   
<a name="l00807"></a>00807                 <span class="keywordflow">default</span>:
<a name="l00808"></a>00808                   libmesh_error();
<a name="l00809"></a>00809                 }
<a name="l00810"></a>00810             }
<a name="l00811"></a>00811 
<a name="l00812"></a>00812 
<a name="l00813"></a>00813           <span class="keywordflow">default</span>:
<a name="l00814"></a>00814             libmesh_error();
<a name="l00815"></a>00815             
<a name="l00816"></a>00816           }
<a name="l00817"></a>00817       }
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 
<a name="l00820"></a>00820       <span class="comment">// The seventh-order Szabo-Babuska shape functions</span>
<a name="l00821"></a>00821     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00822"></a>00822       {
<a name="l00823"></a>00823         <span class="keywordflow">switch</span> (t)
<a name="l00824"></a>00824           {
<a name="l00825"></a>00825           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00826"></a>00826             <span class="keywordflow">return</span> 1;
<a name="l00827"></a>00827 
<a name="l00828"></a>00828             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l00829"></a>00829           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00830"></a>00830           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00831"></a>00831             {
<a name="l00832"></a>00832               <span class="keywordflow">switch</span> (n)
<a name="l00833"></a>00833                 {
<a name="l00834"></a>00834                 <span class="keywordflow">case</span> 0:
<a name="l00835"></a>00835                 <span class="keywordflow">case</span> 1:
<a name="l00836"></a>00836                   <span class="keywordflow">return</span> 1;
<a name="l00837"></a>00837 
<a name="l00838"></a>00838                 <span class="keywordflow">case</span> 2:
<a name="l00839"></a>00839                   <span class="keywordflow">return</span> 6;
<a name="l00840"></a>00840                   
<a name="l00841"></a>00841                 <span class="keywordflow">default</span>:
<a name="l00842"></a>00842                   libmesh_error();                
<a name="l00843"></a>00843                 }
<a name="l00844"></a>00844             }
<a name="l00845"></a>00845 
<a name="l00846"></a>00846             
<a name="l00847"></a>00847             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l00848"></a>00848           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00849"></a>00849             {
<a name="l00850"></a>00850               <span class="keywordflow">switch</span> (n)
<a name="l00851"></a>00851                 {
<a name="l00852"></a>00852                 <span class="keywordflow">case</span> 0:
<a name="l00853"></a>00853                 <span class="keywordflow">case</span> 1:
<a name="l00854"></a>00854                 <span class="keywordflow">case</span> 2:
<a name="l00855"></a>00855                   <span class="keywordflow">return</span> 1;
<a name="l00856"></a>00856 
<a name="l00857"></a>00857                 <span class="keywordflow">case</span> 3:
<a name="l00858"></a>00858                 <span class="keywordflow">case</span> 4:
<a name="l00859"></a>00859                 <span class="keywordflow">case</span> 5:
<a name="l00860"></a>00860                   <span class="keywordflow">return</span> 6;
<a name="l00861"></a>00861 
<a name="l00862"></a>00862                 <span class="keywordflow">default</span>:
<a name="l00863"></a>00863                   libmesh_error();
<a name="l00864"></a>00864                 }
<a name="l00865"></a>00865             }
<a name="l00866"></a>00866 
<a name="l00867"></a>00867 
<a name="l00868"></a>00868             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00869"></a>00869             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00870"></a>00870           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00871"></a>00871           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00872"></a>00872             {
<a name="l00873"></a>00873               <span class="keywordflow">switch</span> (n)
<a name="l00874"></a>00874                 {
<a name="l00875"></a>00875                 <span class="keywordflow">case</span> 0:
<a name="l00876"></a>00876                 <span class="keywordflow">case</span> 1:
<a name="l00877"></a>00877                 <span class="keywordflow">case</span> 2:
<a name="l00878"></a>00878                 <span class="keywordflow">case</span> 3:
<a name="l00879"></a>00879                   <span class="keywordflow">return</span> 1;
<a name="l00880"></a>00880 
<a name="l00881"></a>00881                 <span class="keywordflow">case</span> 4:
<a name="l00882"></a>00882                 <span class="keywordflow">case</span> 5:
<a name="l00883"></a>00883                 <span class="keywordflow">case</span> 6:
<a name="l00884"></a>00884                 <span class="keywordflow">case</span> 7:
<a name="l00885"></a>00885                   <span class="keywordflow">return</span> 6;
<a name="l00886"></a>00886                   
<a name="l00887"></a>00887                 <span class="keywordflow">case</span> 8:
<a name="l00888"></a>00888                   <span class="keywordflow">return</span> 36;
<a name="l00889"></a>00889                   
<a name="l00890"></a>00890                 <span class="keywordflow">default</span>:
<a name="l00891"></a>00891                   libmesh_error();
<a name="l00892"></a>00892                 }
<a name="l00893"></a>00893             }
<a name="l00894"></a>00894 
<a name="l00895"></a>00895 
<a name="l00896"></a>00896           <span class="keywordflow">default</span>:
<a name="l00897"></a>00897             libmesh_error();
<a name="l00898"></a>00898             
<a name="l00899"></a>00899           }
<a name="l00900"></a>00900       }
<a name="l00901"></a>00901 
<a name="l00902"></a>00902       
<a name="l00903"></a>00903     <span class="keywordflow">default</span>:
<a name="l00904"></a>00904       {
<a name="l00905"></a>00905         libmesh_error();
<a name="l00906"></a>00906       }
<a name="l00907"></a>00907     }
<a name="l00908"></a>00908   
<a name="l00909"></a>00909   libmesh_error();
<a name="l00910"></a>00910   
<a name="l00911"></a>00911   <span class="keywordflow">return</span> 0;
<a name="l00912"></a>00912 }
<a name="l00913"></a>00913 
<a name="l00914"></a>00914 
<a name="l00915"></a>00915 
<a name="l00916"></a>00916 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l00917"></a>00917 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FE.php#a6790b3764960ddd6e6faaa40bb0b4a65">FE&lt;Dim,T&gt;::n_dofs_per_elem</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00918"></a>00918                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o)
<a name="l00919"></a>00919 {
<a name="l00920"></a>00920   <span class="keywordflow">switch</span> (o)
<a name="l00921"></a>00921     {
<a name="l00922"></a>00922       <span class="comment">// The first-order Szabo-Babuska shape functions</span>
<a name="l00923"></a>00923     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00924"></a>00924       {
<a name="l00925"></a>00925         <span class="keywordflow">switch</span> (t)
<a name="l00926"></a>00926           {
<a name="l00927"></a>00927           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00928"></a>00928             <span class="keywordflow">return</span> 0;
<a name="l00929"></a>00929 
<a name="l00930"></a>00930             <span class="comment">// The 1D Szabo-Babuska defined on a two-noded edge</span>
<a name="l00931"></a>00931           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00932"></a>00932             <span class="keywordflow">return</span> 0;
<a name="l00933"></a>00933             
<a name="l00934"></a>00934             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l00935"></a>00935           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00936"></a>00936             <span class="keywordflow">return</span> 0;
<a name="l00937"></a>00937             
<a name="l00938"></a>00938             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l00939"></a>00939           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00940"></a>00940             <span class="keywordflow">return</span> 0;
<a name="l00941"></a>00941 
<a name="l00942"></a>00942             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00943"></a>00943             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00944"></a>00944           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00945"></a>00945             <span class="keywordflow">return</span> 0;
<a name="l00946"></a>00946             
<a name="l00947"></a>00947             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00948"></a>00948             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00949"></a>00949             
<a name="l00950"></a>00950           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00951"></a>00951             <span class="keywordflow">return</span> 0;
<a name="l00952"></a>00952             
<a name="l00953"></a>00953             
<a name="l00954"></a>00954           <span class="keywordflow">default</span>:
<a name="l00955"></a>00955             libmesh_error();
<a name="l00956"></a>00956             
<a name="l00957"></a>00957           }
<a name="l00958"></a>00958       }
<a name="l00959"></a>00959 
<a name="l00960"></a>00960 
<a name="l00961"></a>00961 
<a name="l00962"></a>00962       <span class="comment">// The second-order Szabo-Babuska shape functions</span>
<a name="l00963"></a>00963     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00964"></a>00964       {
<a name="l00965"></a>00965         <span class="keywordflow">switch</span> (t)
<a name="l00966"></a>00966           {
<a name="l00967"></a>00967           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l00968"></a>00968             <span class="keywordflow">return</span> 0;
<a name="l00969"></a>00969 
<a name="l00970"></a>00970             <span class="comment">// The 1D Szabo-Babuska defined on a two-noded edge</span>
<a name="l00971"></a>00971           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00972"></a>00972             <span class="keywordflow">return</span> 1;
<a name="l00973"></a>00973             
<a name="l00974"></a>00974             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l00975"></a>00975           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00976"></a>00976             <span class="keywordflow">return</span> 0;
<a name="l00977"></a>00977             
<a name="l00978"></a>00978             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l00979"></a>00979           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00980"></a>00980             <span class="keywordflow">return</span> 0;
<a name="l00981"></a>00981 
<a name="l00982"></a>00982             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00983"></a>00983             <span class="comment">// eight-noded quadrilateral.</span>
<a name="l00984"></a>00984           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00985"></a>00985             <span class="keywordflow">return</span> 0;
<a name="l00986"></a>00986 
<a name="l00987"></a>00987             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l00988"></a>00988             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l00989"></a>00989           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00990"></a>00990             <span class="keywordflow">return</span> 0;
<a name="l00991"></a>00991 
<a name="l00992"></a>00992             
<a name="l00993"></a>00993           <span class="keywordflow">default</span>:
<a name="l00994"></a>00994             libmesh_error();
<a name="l00995"></a>00995             
<a name="l00996"></a>00996           }
<a name="l00997"></a>00997       }
<a name="l00998"></a>00998 
<a name="l00999"></a>00999 
<a name="l01000"></a>01000 
<a name="l01001"></a>01001       <span class="comment">// The third-order Szabo-Babuska shape functions</span>
<a name="l01002"></a>01002     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l01003"></a>01003       {
<a name="l01004"></a>01004         <span class="keywordflow">switch</span> (t)
<a name="l01005"></a>01005           {
<a name="l01006"></a>01006           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l01007"></a>01007             <span class="keywordflow">return</span> 0;
<a name="l01008"></a>01008 
<a name="l01009"></a>01009             <span class="comment">// The 1D Szabo-Babuska defined on a two-noded edge</span>
<a name="l01010"></a>01010           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l01011"></a>01011             <span class="keywordflow">return</span> 2;
<a name="l01012"></a>01012             
<a name="l01013"></a>01013             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l01014"></a>01014           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l01015"></a>01015             <span class="keywordflow">return</span> 0;
<a name="l01016"></a>01016             
<a name="l01017"></a>01017             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l01018"></a>01018           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01019"></a>01019             <span class="keywordflow">return</span> 1;
<a name="l01020"></a>01020 
<a name="l01021"></a>01021             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01022"></a>01022             <span class="comment">// eight-noded quadrilateral.</span>
<a name="l01023"></a>01023           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01024"></a>01024             <span class="keywordflow">return</span> 4;
<a name="l01025"></a>01025 
<a name="l01026"></a>01026             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01027"></a>01027             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l01028"></a>01028           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01029"></a>01029             <span class="keywordflow">return</span> 0;
<a name="l01030"></a>01030 
<a name="l01031"></a>01031             
<a name="l01032"></a>01032           <span class="keywordflow">default</span>:
<a name="l01033"></a>01033             libmesh_error();
<a name="l01034"></a>01034             
<a name="l01035"></a>01035           }
<a name="l01036"></a>01036       }
<a name="l01037"></a>01037 
<a name="l01038"></a>01038 
<a name="l01039"></a>01039 
<a name="l01040"></a>01040       <span class="comment">// The fourth-order Szabo-Babuska shape functions</span>
<a name="l01041"></a>01041     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l01042"></a>01042       {
<a name="l01043"></a>01043         <span class="keywordflow">switch</span> (t)
<a name="l01044"></a>01044           {
<a name="l01045"></a>01045           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l01046"></a>01046             <span class="keywordflow">return</span> 0;
<a name="l01047"></a>01047 
<a name="l01048"></a>01048             <span class="comment">// The 1D Szabo-Babuska defined on a two-noded edge</span>
<a name="l01049"></a>01049           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l01050"></a>01050             <span class="keywordflow">return</span> 3;
<a name="l01051"></a>01051             
<a name="l01052"></a>01052             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l01053"></a>01053           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l01054"></a>01054             <span class="keywordflow">return</span> 0;
<a name="l01055"></a>01055             
<a name="l01056"></a>01056             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l01057"></a>01057           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01058"></a>01058             <span class="keywordflow">return</span> 3;
<a name="l01059"></a>01059 
<a name="l01060"></a>01060             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01061"></a>01061             <span class="comment">// eight-noded quadrilateral.</span>
<a name="l01062"></a>01062           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01063"></a>01063             <span class="keywordflow">return</span> 9;
<a name="l01064"></a>01064 
<a name="l01065"></a>01065             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01066"></a>01066             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l01067"></a>01067           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01068"></a>01068             <span class="keywordflow">return</span> 0;
<a name="l01069"></a>01069 
<a name="l01070"></a>01070             
<a name="l01071"></a>01071           <span class="keywordflow">default</span>:
<a name="l01072"></a>01072             libmesh_error();
<a name="l01073"></a>01073             
<a name="l01074"></a>01074           }
<a name="l01075"></a>01075       }
<a name="l01076"></a>01076 
<a name="l01077"></a>01077 
<a name="l01078"></a>01078 
<a name="l01079"></a>01079       <span class="comment">// The fifth-order Szabo-Babuska shape functions</span>
<a name="l01080"></a>01080     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l01081"></a>01081       {
<a name="l01082"></a>01082         <span class="keywordflow">switch</span> (t)
<a name="l01083"></a>01083           {
<a name="l01084"></a>01084           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l01085"></a>01085             <span class="keywordflow">return</span> 0;
<a name="l01086"></a>01086 
<a name="l01087"></a>01087             <span class="comment">// The 1D Szabo-Babuska defined on a two-noded edge</span>
<a name="l01088"></a>01088           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l01089"></a>01089             <span class="keywordflow">return</span> 4;
<a name="l01090"></a>01090             
<a name="l01091"></a>01091             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l01092"></a>01092           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l01093"></a>01093             <span class="keywordflow">return</span> 0;
<a name="l01094"></a>01094             
<a name="l01095"></a>01095             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l01096"></a>01096           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01097"></a>01097             <span class="keywordflow">return</span> 6;
<a name="l01098"></a>01098 
<a name="l01099"></a>01099             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01100"></a>01100             <span class="comment">// eight-noded quadrilateral.</span>
<a name="l01101"></a>01101           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01102"></a>01102             <span class="keywordflow">return</span> 16;
<a name="l01103"></a>01103 
<a name="l01104"></a>01104             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01105"></a>01105             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l01106"></a>01106           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01107"></a>01107             <span class="keywordflow">return</span> 0;
<a name="l01108"></a>01108 
<a name="l01109"></a>01109             
<a name="l01110"></a>01110           <span class="keywordflow">default</span>:
<a name="l01111"></a>01111             libmesh_error();
<a name="l01112"></a>01112             
<a name="l01113"></a>01113           }
<a name="l01114"></a>01114       }
<a name="l01115"></a>01115 
<a name="l01116"></a>01116 
<a name="l01117"></a>01117   <span class="comment">// The sixth-order Szabo-Babuska shape functions</span>
<a name="l01118"></a>01118     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l01119"></a>01119       {
<a name="l01120"></a>01120         <span class="keywordflow">switch</span> (t)
<a name="l01121"></a>01121           {
<a name="l01122"></a>01122           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l01123"></a>01123             <span class="keywordflow">return</span> 0;
<a name="l01124"></a>01124 
<a name="l01125"></a>01125             <span class="comment">// The 1D Szabo-Babuska defined on a two-noded edge</span>
<a name="l01126"></a>01126           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l01127"></a>01127             <span class="keywordflow">return</span> 5;
<a name="l01128"></a>01128             
<a name="l01129"></a>01129             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l01130"></a>01130           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l01131"></a>01131             <span class="keywordflow">return</span> 0;
<a name="l01132"></a>01132             
<a name="l01133"></a>01133             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l01134"></a>01134           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01135"></a>01135             <span class="keywordflow">return</span> 10;
<a name="l01136"></a>01136 
<a name="l01137"></a>01137             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01138"></a>01138             <span class="comment">// eight-noded quadrilateral.</span>
<a name="l01139"></a>01139           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01140"></a>01140             <span class="keywordflow">return</span> 25;
<a name="l01141"></a>01141 
<a name="l01142"></a>01142             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01143"></a>01143             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l01144"></a>01144           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01145"></a>01145             <span class="keywordflow">return</span> 0;
<a name="l01146"></a>01146 
<a name="l01147"></a>01147             
<a name="l01148"></a>01148           <span class="keywordflow">default</span>:
<a name="l01149"></a>01149             libmesh_error();
<a name="l01150"></a>01150             
<a name="l01151"></a>01151           }
<a name="l01152"></a>01152       }
<a name="l01153"></a>01153 
<a name="l01154"></a>01154 
<a name="l01155"></a>01155   <span class="comment">// The seventh-order Szabo-Babuska shape functions</span>
<a name="l01156"></a>01156     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l01157"></a>01157       {
<a name="l01158"></a>01158         <span class="keywordflow">switch</span> (t)
<a name="l01159"></a>01159           {
<a name="l01160"></a>01160           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>:
<a name="l01161"></a>01161             <span class="keywordflow">return</span> 0;
<a name="l01162"></a>01162 
<a name="l01163"></a>01163             <span class="comment">// The 1D Szabo-Babuska defined on a two-noded edge</span>
<a name="l01164"></a>01164           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l01165"></a>01165             <span class="keywordflow">return</span> 6;
<a name="l01166"></a>01166             
<a name="l01167"></a>01167             <span class="comment">// The 1D Szabo-Babuska defined on a three-noded edge</span>
<a name="l01168"></a>01168           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l01169"></a>01169             <span class="keywordflow">return</span> 0;
<a name="l01170"></a>01170             
<a name="l01171"></a>01171             <span class="comment">// The 2D Szabo-Babuska defined on a 6-noded triangle</span>
<a name="l01172"></a>01172           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l01173"></a>01173             <span class="keywordflow">return</span> 15;
<a name="l01174"></a>01174 
<a name="l01175"></a>01175             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01176"></a>01176             <span class="comment">// eight-noded quadrilateral.</span>
<a name="l01177"></a>01177           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l01178"></a>01178             <span class="keywordflow">return</span> 36;
<a name="l01179"></a>01179 
<a name="l01180"></a>01180             <span class="comment">// The 2D tensor-product Szabo-Babuska defined on a</span>
<a name="l01181"></a>01181             <span class="comment">// nine-noded quadrilateral.</span>
<a name="l01182"></a>01182           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l01183"></a>01183             <span class="keywordflow">return</span> 0;
<a name="l01184"></a>01184 
<a name="l01185"></a>01185             
<a name="l01186"></a>01186           <span class="keywordflow">default</span>:
<a name="l01187"></a>01187             libmesh_error();
<a name="l01188"></a>01188             
<a name="l01189"></a>01189           }
<a name="l01190"></a>01190       }
<a name="l01191"></a>01191 
<a name="l01192"></a>01192       
<a name="l01193"></a>01193       <span class="comment">// Otherwise no DOFS per element</span>
<a name="l01194"></a>01194     <span class="keywordflow">default</span>:
<a name="l01195"></a>01195       <span class="keywordflow">return</span> 0;
<a name="l01196"></a>01196     }
<a name="l01197"></a>01197 }
<a name="l01198"></a>01198 
<a name="l01199"></a>01199 
<a name="l01200"></a>01200 
<a name="l01201"></a>01201 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l01202"></a>01202 <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classlibMesh_1_1FE.php#a26671578bbeec8d12a76e6d3de92c422">FE&lt;Dim,T&gt;::get_continuity</a>()<span class="keyword"> const</span>
<a name="l01203"></a>01203 <span class="keyword"></span>{
<a name="l01204"></a>01204   <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>;
<a name="l01205"></a>01205 }
<a name="l01206"></a>01206 
<a name="l01207"></a>01207 
<a name="l01208"></a>01208 
<a name="l01209"></a>01209 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l01210"></a>01210 <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FE.php#a6e3c6ecf80a5f9a057cd98710650b379">FE&lt;Dim,T&gt;::is_hierarchic</a>()<span class="keyword"> const</span>
<a name="l01211"></a>01211 <span class="keyword"></span>{
<a name="l01212"></a>01212   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l01213"></a>01213 }
<a name="l01214"></a>01214 
<a name="l01215"></a>01215 
<a name="l01216"></a>01216 
<a name="l01217"></a>01217 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T&gt;
<a name="l01218"></a>01218 <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FE.php#ae8089f56b5648f5657b5d85cd630b622">FE&lt;Dim,T&gt;::shapes_need_reinit</a>()<span class="keyword"> const</span>
<a name="l01219"></a>01219 <span class="keyword"></span>{
<a name="l01220"></a>01220   <span class="comment">// reinit is only necessary for</span>
<a name="l01221"></a>01221   <span class="comment">// approximation orders &gt;= 3</span>
<a name="l01222"></a>01222   <span class="comment">// FIXME - but with p refinement it may be</span>
<a name="l01223"></a>01223   <span class="comment">// needed with any base order</span>
<a name="l01224"></a>01224   <span class="comment">// if(this-&gt;fe_type.order == FIRST ||</span>
<a name="l01225"></a>01225   <span class="comment">//    this-&gt;fe_type.order == SECOND)</span>
<a name="l01226"></a>01226   <span class="comment">//   return false;</span>
<a name="l01227"></a>01227   <span class="comment">// else</span>
<a name="l01228"></a>01228     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l01229"></a>01229 }
<a name="l01230"></a>01230 
<a name="l01231"></a>01231 
<a name="l01232"></a>01232 
<a name="l01233"></a>01233 <span class="comment">//--------------------------------------------------------------</span>
<a name="l01234"></a>01234 <span class="comment">// Explicit instantiation of member functions</span>
<a name="l01235"></a>01235 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(0,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>);
<a name="l01236"></a>01236 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>);
<a name="l01237"></a>01237 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>);
<a name="l01238"></a>01238 <a class="code" href="namespacelibMesh.php#a893265222bd8c564adbcf8211fafcd6d">INSTANTIATE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a0d13121a541a5391fd4a73c280bd0e5a">SZABAB</a>);
<a name="l01239"></a>01239 
<a name="l01240"></a>01240 } <span class="comment">// namespace libMesh</span>
<a name="l01241"></a>01241 
<a name="l01242"></a>01242 <span class="preprocessor">#endif //LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
