<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_szabab_shape_1D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__szabab__shape__1D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_szabab_shape_1D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">template</span> &lt;&gt;
<a name="l00037"></a><a class="code" href="classlibMesh_1_1FE.php#ac4a6a6d7c2b8dba3348a04f861d8783c">00037</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,SZABAB&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00038"></a>00038                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00039"></a>00039                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00040"></a>00040                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi  = p(0);
<a name="l00043"></a>00043   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi2 = xi*xi;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="comment">// Use this libmesh_assert rather than a switch with a single entry...</span>
<a name="l00047"></a>00047   <span class="comment">// It will go away in optimized mode, essentially has the same effect.</span>
<a name="l00048"></a>00048   libmesh_assert (order &lt;= <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>);
<a name="l00049"></a>00049   
<a name="l00050"></a>00050 <span class="comment">//   switch (order)</span>
<a name="l00051"></a>00051 <span class="comment">//     {</span>
<a name="l00052"></a>00052 <span class="comment">//     case FIRST:</span>
<a name="l00053"></a>00053 <span class="comment">//     case SECOND:</span>
<a name="l00054"></a>00054 <span class="comment">//     case THIRD:</span>
<a name="l00055"></a>00055 <span class="comment">//     case FOURTH:</span>
<a name="l00056"></a>00056 <span class="comment">//     case FIFTH:</span>
<a name="l00057"></a>00057 <span class="comment">//     case SIXTH:</span>
<a name="l00058"></a>00058 <span class="comment">//     case SEVENTH:</span>
<a name="l00059"></a>00059       
<a name="l00060"></a>00060       <span class="keywordflow">switch</span>(i)
<a name="l00061"></a>00061         {                               
<a name="l00062"></a>00062           <span class="comment">//nodal shape functions</span>
<a name="l00063"></a>00063         <span class="keywordflow">case</span> 0: <span class="keywordflow">return</span> 1./2.-1./2.*xi;
<a name="l00064"></a>00064         <span class="keywordflow">case</span> 1: <span class="keywordflow">return</span> 1./2.+1./2.*xi;
<a name="l00065"></a>00065         <span class="keywordflow">case</span> 2: <span class="keywordflow">return</span> 1./4.  *2.4494897427831780982*(xi2-1.);
<a name="l00066"></a>00066         <span class="keywordflow">case</span> 3: <span class="keywordflow">return</span> 1./4.  *3.1622776601683793320*(xi2-1.)*xi;
<a name="l00067"></a>00067         <span class="keywordflow">case</span> 4: <span class="keywordflow">return</span> 1./16. *3.7416573867739413856*((5.*xi2-6.)*xi2+1.);
<a name="l00068"></a>00068         <span class="keywordflow">case</span> 5: <span class="keywordflow">return</span> 3./16. *1.4142135623730950488*(3.+(-10.+7.*xi2)*xi2)*xi;
<a name="l00069"></a>00069         <span class="keywordflow">case</span> 6: <span class="keywordflow">return</span> 1./32. *4.6904157598234295546*(-1.+(15.+(-35.+21.*xi2)*xi2)*xi2);
<a name="l00070"></a>00070         <span class="keywordflow">case</span> 7: <span class="keywordflow">return</span> 1./32. *5.0990195135927848300*(-5.+(35.+(-63.+33.*xi2)*xi2)*xi2)*xi;
<a name="l00071"></a>00071         <span class="keywordflow">case</span> 8: <span class="keywordflow">return</span> 1./256.*5.4772255750516611346*(5.+(-140.+(630.+(-924.+429.*xi2)*xi2)*xi2)*xi2);
<a name="l00072"></a>00072           
<a name="l00073"></a>00073         <span class="keywordflow">default</span>:
<a name="l00074"></a>00074           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00075"></a>00075           libmesh_error();          
<a name="l00076"></a>00076         }
<a name="l00077"></a>00077       
<a name="l00078"></a>00078 <span class="comment">//     default:</span>
<a name="l00079"></a>00079 <span class="comment">//       {</span>
<a name="l00080"></a>00080 <span class="comment">//      libMesh::err &lt;&lt; &quot;ERROR: Unsupported polynomial order!&quot; &lt;&lt; std::endl;</span>
<a name="l00081"></a>00081 <span class="comment">//      libmesh_error();</span>
<a name="l00082"></a>00082 <span class="comment">//       }</span>
<a name="l00083"></a>00083 <span class="comment">//     }</span>
<a name="l00084"></a>00084   
<a name="l00085"></a>00085   libmesh_error();
<a name="l00086"></a>00086   <span class="keywordflow">return</span> 0.;
<a name="l00087"></a>00087 }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="keyword">template</span> &lt;&gt;
<a name="l00092"></a><a class="code" href="classlibMesh_1_1FE.php#a21b343082a0ae901cc6b80d5286d49bd">00092</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,SZABAB&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00093"></a>00093                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00094"></a>00094                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00095"></a>00095                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   libmesh_assert (elem != NULL);
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,SZABAB&gt;::shape</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, p);
<a name="l00100"></a>00100 }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="keyword">template</span> &lt;&gt;
<a name="l00105"></a><a class="code" href="classlibMesh_1_1FE.php#a62f018f102d82b4b7c2535b3e6bbba5c">00105</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,SZABAB&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00106"></a>00106                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00107"></a>00107                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00108"></a>00108                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00109"></a>00109                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00110"></a>00110 {
<a name="l00111"></a>00111   <span class="comment">// only d()/dxi in 1D!  </span>
<a name="l00112"></a>00112   libmesh_assert (j == 0);
<a name="l00113"></a>00113         
<a name="l00114"></a>00114   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi  = p(0);
<a name="l00115"></a>00115   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi2 = xi*xi;
<a name="l00116"></a>00116   
<a name="l00117"></a>00117   <span class="comment">// Use this libmesh_assert rather than a switch with a single entry...</span>
<a name="l00118"></a>00118   <span class="comment">// It will go away in optimized mode, essentially has the same effect.</span>
<a name="l00119"></a>00119   libmesh_assert (order &lt;= <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>);
<a name="l00120"></a>00120   
<a name="l00121"></a>00121 <span class="comment">//   switch (order)</span>
<a name="l00122"></a>00122 <span class="comment">//     {      </span>
<a name="l00123"></a>00123 <span class="comment">//     case FIRST:</span>
<a name="l00124"></a>00124 <span class="comment">//     case SECOND:</span>
<a name="l00125"></a>00125 <span class="comment">//     case THIRD:</span>
<a name="l00126"></a>00126 <span class="comment">//     case FOURTH:</span>
<a name="l00127"></a>00127 <span class="comment">//     case FIFTH:</span>
<a name="l00128"></a>00128 <span class="comment">//     case SIXTH:</span>
<a name="l00129"></a>00129 <span class="comment">//     case SEVENTH:</span>
<a name="l00130"></a>00130       
<a name="l00131"></a>00131       <span class="keywordflow">switch</span>(i)
<a name="l00132"></a>00132         {
<a name="l00133"></a>00133         <span class="keywordflow">case</span> 0: <span class="keywordflow">return</span> -1./2.;
<a name="l00134"></a>00134         <span class="keywordflow">case</span> 1: <span class="keywordflow">return</span> 1./2.;
<a name="l00135"></a>00135         <span class="keywordflow">case</span> 2: <span class="keywordflow">return</span> 1./2.*2.4494897427831780982*xi;
<a name="l00136"></a>00136         <span class="keywordflow">case</span> 3: <span class="keywordflow">return</span> -1./4.*3.1622776601683793320+3./4.*3.1622776601683793320*xi2;
<a name="l00137"></a>00137         <span class="keywordflow">case</span> 4: <span class="keywordflow">return</span> 1./16.*3.7416573867739413856*(-12.+20*xi2)*xi;
<a name="l00138"></a>00138         <span class="keywordflow">case</span> 5: <span class="keywordflow">return</span> 9./16.*1.4142135623730950488+(-45./8.*1.4142135623730950488+105./16.*1.4142135623730950488*xi2)*xi2;
<a name="l00139"></a>00139         <span class="keywordflow">case</span> 6: <span class="keywordflow">return</span> 1./32.*4.6904157598234295546*(30.+(-140.+126.*xi2)*xi2)*xi;
<a name="l00140"></a>00140         <span class="keywordflow">case</span> 7: <span class="keywordflow">return</span> -5./32.*5.0990195135927848300+(105./32.*5.0990195135927848300+(-315./32.*5.0990195135927848300+231./32.*5.0990195135927848300*xi2)*xi2)*xi2;
<a name="l00141"></a>00141         <span class="keywordflow">case</span> 8: <span class="keywordflow">return</span> 1./256.*5.4772255750516611346*(-280.+(2520.+(-5544.+3432.*xi2)*xi2)*xi2)*xi;
<a name="l00142"></a>00142           
<a name="l00143"></a>00143         <span class="keywordflow">default</span>:
<a name="l00144"></a>00144           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Invalid shape function index!&quot;</span> &lt;&lt; std::endl;
<a name="l00145"></a>00145           libmesh_error();
<a name="l00146"></a>00146         }
<a name="l00147"></a>00147  
<a name="l00148"></a>00148 <span class="comment">//     default:</span>
<a name="l00149"></a>00149 <span class="comment">//       {</span>
<a name="l00150"></a>00150 <span class="comment">//      libMesh::err &lt;&lt; &quot;ERROR: Unsupported polynomial order!&quot; &lt;&lt; std::endl;</span>
<a name="l00151"></a>00151 <span class="comment">//      libmesh_error();</span>
<a name="l00152"></a>00152 <span class="comment">//       }</span>
<a name="l00153"></a>00153 <span class="comment">//     }</span>
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   libmesh_error();
<a name="l00156"></a>00156   <span class="keywordflow">return</span> 0.;
<a name="l00157"></a>00157 }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="keyword">template</span> &lt;&gt;
<a name="l00162"></a><a class="code" href="classlibMesh_1_1FE.php#adfe062a2e7179a741676d78e28dbca33">00162</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,SZABAB&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00163"></a>00163                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00164"></a>00164                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00165"></a>00165                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00166"></a>00166                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00167"></a>00167 {
<a name="l00168"></a>00168   libmesh_assert (elem != NULL);
<a name="l00169"></a>00169   
<a name="l00170"></a>00170   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;1,SZABAB&gt;::shape_deriv</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(),
<a name="l00171"></a>00171                                        <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()), i, j, p);
<a name="l00172"></a>00172 }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 <span class="keyword">template</span> &lt;&gt;
<a name="l00177"></a><a class="code" href="classlibMesh_1_1FE.php#a8ab23deed188295c6d6034cb5eb464af">00177</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;1,SZABAB&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00178"></a>00178                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00179"></a>00179                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00180"></a>00180                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00181"></a>00181                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00182"></a>00182 {
<a name="l00183"></a>00183   <span class="keyword">static</span> <span class="keywordtype">bool</span> warning_given = <span class="keyword">false</span>;
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="keywordflow">if</span> (!warning_given)
<a name="l00186"></a>00186   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Second derivatives for Szabab elements &quot;</span>
<a name="l00187"></a>00187             &lt;&lt; <span class="stringliteral">&quot; are not yet implemented!&quot;</span>
<a name="l00188"></a>00188             &lt;&lt; std::endl;
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   warning_given = <span class="keyword">true</span>;
<a name="l00191"></a>00191   <span class="keywordflow">return</span> 0.;
<a name="l00192"></a>00192 }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="keyword">template</span> &lt;&gt;
<a name="l00197"></a><a class="code" href="classlibMesh_1_1FE.php#a32f422cf80581944640f134a916a94b8">00197</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;1,SZABAB&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00198"></a>00198                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00199"></a>00199                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00200"></a>00200                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00201"></a>00201                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00202"></a>00202 {
<a name="l00203"></a>00203   <span class="keyword">static</span> <span class="keywordtype">bool</span> warning_given = <span class="keyword">false</span>;
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="keywordflow">if</span> (!warning_given)
<a name="l00206"></a>00206   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Second derivatives for Szabab elements &quot;</span>
<a name="l00207"></a>00207             &lt;&lt; <span class="stringliteral">&quot; are not yet implemented!&quot;</span>
<a name="l00208"></a>00208             &lt;&lt; std::endl;
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   warning_given = <span class="keyword">true</span>;
<a name="l00211"></a>00211   <span class="keywordflow">return</span> 0.;
<a name="l00212"></a>00212 }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 } <span class="comment">// namespace libMesh</span>
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="preprocessor">#endif //LIBMESH_ENABLE_HIGHER_ORDER_SHAPES</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
