<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_type.C</div>  </div>
</div>
<div class="contents">
<a href="fe__type_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: fe_type.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__clough_8h.php">quadrature_clough.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// ---------------------------------------</span>
<a name="l00030"></a>00030 <span class="comment">// FEType class members</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 AutoPtr&lt;QBase&gt;
<a name="l00033"></a><a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">00033</a> <a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">FEType::default_quadrature_rule</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00034"></a>00034                                  <span class="keyword">const</span> <span class="keywordtype">int</span> extraorder)<span class="keyword"> const</span>
<a name="l00035"></a>00035 <span class="keyword"></span>{
<a name="l00036"></a>00036 
<a name="l00037"></a>00037   <span class="comment">// Clough elements have at least piecewise cubic functions</span>
<a name="l00038"></a>00038   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5afb6682b07aabfbe33ea22eb9dfa09709">CLOUGH</a>)
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040       <span class="comment">// this seems ridiculous but for some reason gcc 3.3.5 wants</span>
<a name="l00041"></a>00041       <span class="comment">// this when using complex numbers (spetersen 04/20/06)</span>
<a name="l00042"></a>00042       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> seven = 7;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a>
<a name="l00045"></a>00045         (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QClough.php">QClough</a>(dim,
<a name="l00046"></a>00046                      static_cast&lt;Order&gt;
<a name="l00047"></a>00047                      (<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(static_cast&lt;unsigned int&gt;
<a name="l00048"></a>00048                                (this-&gt;<a class="code" href="classlibMesh_1_1FEType.php#a54506eab6fd48e0cbd2ff403fca09ed9">default_quadrature_order</a>()), seven + extraorder))));
<a name="l00049"></a>00049     }
<a name="l00050"></a>00050   
<a name="l00051"></a>00051   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a>
<a name="l00052"></a>00052     (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a>(dim, static_cast&lt;Order&gt;(this-&gt;<a class="code" href="classlibMesh_1_1FEType.php#a54506eab6fd48e0cbd2ff403fca09ed9">default_quadrature_order</a>()
<a name="l00053"></a>00053                                         + extraorder)));
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
