<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fbfd1e4ea7786050feab5206011c3dac.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_type.h</div>  </div>
</div>
<div class="contents">
<a href="fe__type_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_type.h 4143 2010-12-06 21:10:56Z jasondhales $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __fe_type_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __fe_type_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="enum__order_8h.php">enum_order.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="enum__fe__family_8h.php">enum_fe_family.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="enum__inf__map__type_8h.php">enum_inf_map_type.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>QBase;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00045"></a><a class="code" href="classlibMesh_1_1FEType.php">00045</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEType.php">FEType</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>:
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>  
<a name="l00055"></a><a class="code" href="classlibMesh_1_1FEType.php#a383b7b21584deb1657ee703b5a2edaba">00055</a>   <a class="code" href="classlibMesh_1_1FEType.php#a383b7b21584deb1657ee703b5a2edaba">FEType</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    o = <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>,
<a name="l00056"></a>00056          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> f = <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>) :
<a name="l00057"></a>00057     <a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>(o),
<a name="l00058"></a>00058     <a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>(f)
<a name="l00059"></a>00059   {}
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="comment">//TODO:[BSK] Could these data types all be const?  </span>
<a name="l00063"></a>00063   <span class="comment">// [RHS] Order can&#39;t in the case of p refinement!</span>
<a name="l00067"></a><a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">00067</a> <span class="comment"></span>  <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>;
<a name="l00068"></a>00068 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">00073</a>   <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>;
<a name="l00074"></a>00074     
<a name="l00075"></a>00075 <span class="preprocessor">#else</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>  
<a name="l00085"></a><a class="code" href="classlibMesh_1_1FEType.php#a1692b589c616e77660b3b9056f116573">00085</a>   <a class="code" href="classlibMesh_1_1FEType.php#a383b7b21584deb1657ee703b5a2edaba">FEType</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>      o  = <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>,
<a name="l00086"></a>00086          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a>   f  = <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a>,
<a name="l00087"></a>00087          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>      ro = <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>,
<a name="l00088"></a>00088          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a>   rf = <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5ac8091b262c367b2c2c8b213ea407c444">JACOBI_20_00</a>,
<a name="l00089"></a>00089          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7">InfMapType</a> im = <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>) :
<a name="l00090"></a>00090     <a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>(o),
<a name="l00091"></a>00091     <a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>(ro),
<a name="l00092"></a>00092     <a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>(f),
<a name="l00093"></a>00093     <a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>(rf),
<a name="l00094"></a>00094     <a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>(im)
<a name="l00095"></a>00095   {}
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>;
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">00106</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>;
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>;
<a name="l00113"></a>00113 
<a name="l00119"></a><a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">00119</a>   <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5">FEFamily</a> <a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>;
<a name="l00120"></a>00120 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">00127</a>   <a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7">InfMapType</a> <a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>;
<a name="l00128"></a>00128   
<a name="l00129"></a>00129 <span class="preprocessor">#endif // ifndef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00130"></a>00130 <span class="preprocessor"></span>
<a name="l00134"></a><a class="code" href="classlibMesh_1_1FEType.php#aa484ce28328826fa12851a70409f98b3">00134</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEType.php#aa484ce28328826fa12851a70409f98b3">operator== </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp;f2)<span class="keyword"> const</span>
<a name="l00135"></a>00135 <span class="keyword">  </span>{
<a name="l00136"></a>00136     <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> == f2.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>
<a name="l00137"></a>00137             &amp;&amp; <a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> == f2.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>
<a name="l00138"></a>00138 #ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS
<a name="l00139"></a>00139             &amp;&amp; <a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a> == f2.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>
<a name="l00140"></a>00140             &amp;&amp; <a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> == f2.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>
<a name="l00141"></a>00141             &amp;&amp; <a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> == f2.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>
<a name="l00142"></a>00142 #endif <span class="comment">// ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00143"></a>00143             );
<a name="l00144"></a>00144   }
<a name="l00145"></a>00145 
<a name="l00149"></a><a class="code" href="classlibMesh_1_1FEType.php#ab6c7254c6ed3db4638c9a4d55260174e">00149</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEType.php#ab6c7254c6ed3db4638c9a4d55260174e">operator!= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp;f2)<span class="keyword"> const</span>
<a name="l00150"></a>00150 <span class="keyword">  </span>{
<a name="l00151"></a>00151     <span class="keywordflow">return</span> !(*<span class="keyword">this</span> == f2);
<a name="l00152"></a>00152   }
<a name="l00153"></a>00153 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1FEType.php#aa18c37ff3df19d9bc834557ad37edf68">00157</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEType.php#aa18c37ff3df19d9bc834557ad37edf68">operator&lt; </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> &amp;f2)<span class="keyword"> const</span>
<a name="l00158"></a>00158 <span class="keyword">  </span>{
<a name="l00159"></a>00159     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> != f2.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>)
<a name="l00160"></a>00160       <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> &lt; f2.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>);
<a name="l00161"></a>00161     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> != f2.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>)
<a name="l00162"></a>00162       <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a> &lt; f2.<a class="code" href="classlibMesh_1_1FEType.php#ac437ba9b0a5253d6bf6f07ad277b9978">family</a>);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00165"></a>00165 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a> != f2.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>)
<a name="l00166"></a>00166       <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a> &lt; f2.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);
<a name="l00167"></a>00167     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> != f2.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>)
<a name="l00168"></a>00168       <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a> &lt; f2.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>);
<a name="l00169"></a>00169     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> != f2.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>)
<a name="l00170"></a>00170       <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a> &lt; f2.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>);
<a name="l00171"></a>00171 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>    <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00173"></a>00173   }
<a name="l00174"></a>00174 
<a name="l00181"></a>00181   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1FEType.php#a54506eab6fd48e0cbd2ff403fca09ed9">default_quadrature_order</a> () <span class="keyword">const</span>;
<a name="l00182"></a>00182 
<a name="l00189"></a>00189   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00190"></a>00190                                           <span class="keyword">const</span> <span class="keywordtype">int</span> extraorder=0) <span class="keyword">const</span>;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   
<a name="l00193"></a>00193 <span class="keyword">private</span>:  
<a name="l00194"></a>00194   
<a name="l00195"></a>00195 };
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00200"></a>00200 <span class="comment">// FEType inline methods</span>
<a name="l00201"></a>00201 <span class="keyword">inline</span>
<a name="l00202"></a><a class="code" href="classlibMesh_1_1FEType.php#a54506eab6fd48e0cbd2ff403fca09ed9">00202</a> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1FEType.php#a54506eab6fd48e0cbd2ff403fca09ed9">FEType::default_quadrature_order</a> ()<span class="keyword"> const</span>
<a name="l00203"></a>00203 <span class="keyword"></span>{
<a name="l00204"></a>00204   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(2*<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>) + 1);
<a name="l00205"></a>00205 }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 } <span class="comment">// namespace libMesh</span>
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="preprocessor">#endif // #ifndef __fe_type_h__</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span>
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
