<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_xyz_boundary.C</div>  </div>
</div>
<div class="contents">
<a href="fe__xyz__boundary_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_xyz_boundary.C 4015 2010-10-01 21:03:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::sqrt</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//-------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// Full specialization for 0D when this is a useless method</span>
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;&gt;
<a name="l00042"></a><a class="code" href="classlibMesh_1_1FEXYZ.php#a9b04325b909537a0ec788e87ad9dfaf0">00042</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEXYZ.php#ac3483021c8d5daca7ddcace0333015a2">FEXYZ&lt;0&gt;::reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00043"></a>00043                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00044"></a>00044                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: This method only makes sense for 2D/3D elements!&quot;</span>
<a name="l00047"></a>00047                 &lt;&lt; std::endl;
<a name="l00048"></a>00048   libmesh_error();
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">//-------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// Full specialization for 1D when this is a useless method</span>
<a name="l00054"></a>00054 <span class="keyword">template</span> &lt;&gt;
<a name="l00055"></a><a class="code" href="classlibMesh_1_1FEXYZ.php#a6f6160a91dcdbc53a3703394c1cbc18c">00055</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEXYZ.php#ac3483021c8d5daca7ddcace0333015a2">FEXYZ&lt;1&gt;::reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00056"></a>00056                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00057"></a>00057                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: This method only makes sense for 2D/3D elements!&quot;</span>
<a name="l00060"></a>00060                 &lt;&lt; std::endl;
<a name="l00061"></a>00061   libmesh_error();
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">//-------------------------------------------------------</span>
<a name="l00066"></a>00066 <span class="comment">// Method for 2D, 3D</span>
<a name="l00067"></a>00067 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00068"></a><a class="code" href="classlibMesh_1_1FEXYZ.php#ae9dc6f5f554fe747fccdf446dbd66ecf">00068</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEXYZ.php#ac3483021c8d5daca7ddcace0333015a2">FEXYZ&lt;Dim&gt;::reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00069"></a>00069                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00070"></a>00070                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072   libmesh_assert (elem  != NULL);
<a name="l00073"></a>00073   libmesh_assert (this-&gt;qrule != NULL);
<a name="l00074"></a>00074   <span class="comment">// We don&#39;t do this for 1D elements!</span>
<a name="l00075"></a>00075   libmesh_assert (Dim != 1);
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="comment">// Build the side of interest </span>
<a name="l00078"></a>00078   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="comment">// initialize quadrature rule</span>
<a name="l00081"></a>00081   this-&gt;qrule-&gt;init(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type(), elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">// We might not need to reinitialize the shape functions.</span>
<a name="l00084"></a>00084   <span class="comment">// Note that the face shape functions are LAGRANGE and only</span>
<a name="l00085"></a>00085   <span class="comment">// depend on the type of face</span>
<a name="l00086"></a>00086   <span class="keywordflow">if</span> (this-&gt;get_type() != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>())
<a name="l00087"></a>00087     {
<a name="l00088"></a>00088       <span class="comment">// Set the element type</span>
<a name="l00089"></a>00089       this-&gt;elem_type = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00090"></a>00090       
<a name="l00091"></a>00091       <span class="comment">// Initialize the face shape functions</span>
<a name="l00092"></a>00092       this-&gt;init_face_shape_functions (this-&gt;qrule-&gt;get_points(),  <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>.get());
<a name="l00093"></a>00093     }
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   <span class="comment">// Compute data on the face for integration</span>
<a name="l00096"></a>00096   this-&gt;compute_face_values (elem, <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>.get());
<a name="l00097"></a>00097 }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim&gt;
<a name="l00102"></a><a class="code" href="classlibMesh_1_1FEXYZ.php#a8115dbb29d93d72172219ab59669b801">00102</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEXYZ.php#a8115dbb29d93d72172219ab59669b801">FEXYZ&lt;Dim&gt;::compute_face_values</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00103"></a>00103                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>)
<a name="l00104"></a>00104 {
<a name="l00105"></a>00105   libmesh_assert (elem != NULL);
<a name="l00106"></a>00106   libmesh_assert (side != NULL);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   START_LOG(<span class="stringliteral">&quot;compute_face_values()&quot;</span>, <span class="stringliteral">&quot;FEXYZ&quot;</span>);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">// The quadrature weights.</span>
<a name="l00111"></a>00111   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; qw = this-&gt;qrule-&gt;get_weights();
<a name="l00112"></a>00112   
<a name="l00113"></a>00113   <span class="comment">// The number of quadrature points.</span>
<a name="l00114"></a>00114   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = qw.size();
<a name="l00115"></a>00115   
<a name="l00116"></a>00116   <span class="comment">// Number of shape functions in the finite element approximation</span>
<a name="l00117"></a>00117   <span class="comment">// space.</span>
<a name="l00118"></a>00118   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_approx_shape_functions =
<a name="l00119"></a>00119     this-&gt;n_shape_functions(this-&gt;get_type(),
<a name="l00120"></a>00120                             this-&gt;get_order());
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">// Resize the shape functions and their gradients</span>
<a name="l00123"></a>00123   this-&gt;phi.resize    (n_approx_shape_functions);
<a name="l00124"></a>00124   this-&gt;dphi.resize   (n_approx_shape_functions);
<a name="l00125"></a>00125   this-&gt;dphidx.resize (n_approx_shape_functions);
<a name="l00126"></a>00126   this-&gt;dphidy.resize (n_approx_shape_functions);
<a name="l00127"></a>00127   this-&gt;dphidz.resize (n_approx_shape_functions);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00130"></a>00130     {
<a name="l00131"></a>00131       this-&gt;phi[i].resize    (n_qp);
<a name="l00132"></a>00132       this-&gt;dphi[i].resize   (n_qp);
<a name="l00133"></a>00133       this-&gt;dphidx[i].resize (n_qp);
<a name="l00134"></a>00134       this-&gt;dphidy[i].resize (n_qp);
<a name="l00135"></a>00135       this-&gt;dphidz[i].resize (n_qp);
<a name="l00136"></a>00136     }
<a name="l00137"></a>00137  
<a name="l00138"></a>00138   <span class="keywordflow">switch</span> (this-&gt;dim)
<a name="l00139"></a>00139     {
<a name="l00140"></a>00140       
<a name="l00141"></a>00141     <span class="keywordflow">case</span> 2:
<a name="l00142"></a>00142       {
<a name="l00143"></a>00143         <span class="comment">// A 2D finite element living in either 2D or 3D space.</span>
<a name="l00144"></a>00144         <span class="comment">// This means the boundary is a 1D finite element, i.e.</span>
<a name="l00145"></a>00145         <span class="comment">// and EDGE2 or EDGE3.</span>
<a name="l00146"></a>00146         <span class="comment">// Resize the vectors to hold data at the quadrature points</span>
<a name="l00147"></a>00147         {  
<a name="l00148"></a>00148           this-&gt;xyz.resize(n_qp);
<a name="l00149"></a>00149           this-&gt;dxyzdxi_map.resize(n_qp);
<a name="l00150"></a>00150           this-&gt;d2xyzdxi2_map.resize(n_qp);
<a name="l00151"></a>00151           this-&gt;tangents.resize(n_qp);
<a name="l00152"></a>00152           this-&gt;normals.resize(n_qp);
<a name="l00153"></a>00153           this-&gt;curvatures.resize(n_qp);
<a name="l00154"></a>00154           
<a name="l00155"></a>00155           this-&gt;JxW.resize(n_qp);
<a name="l00156"></a>00156         }
<a name="l00157"></a>00157         
<a name="l00158"></a>00158         <span class="comment">// Clear the entities that will be summed</span>
<a name="l00159"></a>00159         <span class="comment">// Compute the tangent &amp; normal at the quadrature point</span>
<a name="l00160"></a>00160         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00161"></a>00161           {
<a name="l00162"></a>00162             this-&gt;tangents[p].resize(LIBMESH_DIM-1); <span class="comment">// 1 Tangent in 2D, 2 in 3D</span>
<a name="l00163"></a>00163             this-&gt;xyz[p].zero();
<a name="l00164"></a>00164             this-&gt;dxyzdxi_map[p].zero();
<a name="l00165"></a>00165             this-&gt;d2xyzdxi2_map[p].zero();
<a name="l00166"></a>00166           }
<a name="l00167"></a>00167         
<a name="l00168"></a>00168         <span class="comment">// compute x, dxdxi at the quadrature points    </span>
<a name="l00169"></a>00169         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;psi_map.size(); i++) <span class="comment">// sum over the nodes</span>
<a name="l00170"></a>00170           {
<a name="l00171"></a>00171             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; side_point = side-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i);
<a name="l00172"></a>00172             
<a name="l00173"></a>00173             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++) <span class="comment">// for each quadrature point...</span>
<a name="l00174"></a>00174               {   
<a name="l00175"></a>00175                 this-&gt;xyz[p].<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>          (side_point, this-&gt;psi_map[i][p]);
<a name="l00176"></a>00176                 this-&gt;dxyzdxi_map[p].add_scaled  (side_point, this-&gt;dpsidxi_map[i][p]);
<a name="l00177"></a>00177                 this-&gt;d2xyzdxi2_map[p].add_scaled(side_point, this-&gt;d2psidxi2_map[i][p]);
<a name="l00178"></a>00178               }
<a name="l00179"></a>00179           }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181         <span class="comment">// Compute the tangent &amp; normal at the quadrature point</span>
<a name="l00182"></a>00182         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00183"></a>00183           {
<a name="l00184"></a>00184             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> n(this-&gt;dxyzdxi_map[p](1), -this-&gt;dxyzdxi_map[p](0), 0.);
<a name="l00185"></a>00185             
<a name="l00186"></a>00186             this-&gt;normals[p]     = n.<a class="code" href="classlibMesh_1_1TypeVector.php#af309ac3227a31641f8e8ecbe9bb972a5">unit</a>();
<a name="l00187"></a>00187             this-&gt;tangents[p][0] = this-&gt;dxyzdxi_map[p].<a class="code" href="classlibMesh_1_1TypeVector.php#af309ac3227a31641f8e8ecbe9bb972a5">unit</a>();
<a name="l00188"></a>00188 <span class="preprocessor">#if LIBMESH_DIM == 3  // Only good in 3D space</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>            this-&gt;tangents[p][1] = this-&gt;dxyzdxi_map[p].<a class="code" href="classlibMesh_1_1TypeVector.php#a2aec9a10f796ec4cd55c5d2a62885305">cross</a>(n).unit();
<a name="l00190"></a>00190 <span class="preprocessor">#endif</span>
<a name="l00191"></a>00191 <span class="preprocessor"></span>            <span class="comment">// The curvature is computed via the familiar Frenet formula:</span>
<a name="l00192"></a>00192             <span class="comment">// curvature = [d^2(x) / d (xi)^2] dot [normal]</span>
<a name="l00193"></a>00193             <span class="comment">// For a reference, see:</span>
<a name="l00194"></a>00194             <span class="comment">// F.S. Merritt, Mathematics Manual, 1962, McGraw-Hill, p. 310</span>
<a name="l00195"></a>00195             <span class="comment">//</span>
<a name="l00196"></a>00196             <span class="comment">// Note: The sign convention here is different from the</span>
<a name="l00197"></a>00197             <span class="comment">// 3D case.  Concave-upward curves (smiles) have a positive</span>
<a name="l00198"></a>00198             <span class="comment">// curvature.  Concave-downward curves (frowns) have a</span>
<a name="l00199"></a>00199             <span class="comment">// negative curvature.  Be sure to take that into account!</span>
<a name="l00200"></a>00200             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> numerator   = this-&gt;d2xyzdxi2_map[p] * this-&gt;normals[p];
<a name="l00201"></a>00201             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> denominator = this-&gt;dxyzdxi_map[p].size_sq();
<a name="l00202"></a>00202             libmesh_assert (denominator != 0);
<a name="l00203"></a>00203             this-&gt;curvatures[p] = numerator / denominator;
<a name="l00204"></a>00204           }
<a name="l00205"></a>00205         
<a name="l00206"></a>00206         <span class="comment">// compute the jacobian at the quadrature points</span>
<a name="l00207"></a>00207         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00208"></a>00208           {
<a name="l00209"></a>00209             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> jac = std::sqrt(this-&gt;dxdxi_map(p)*this-&gt;dxdxi_map(p) +
<a name="l00210"></a>00210                                        this-&gt;dydxi_map(p)*this-&gt;dydxi_map(p));
<a name="l00211"></a>00211             
<a name="l00212"></a>00212             libmesh_assert (jac &gt; 0.);
<a name="l00213"></a>00213             
<a name="l00214"></a>00214             this-&gt;JxW[p] = jac*qw[p];
<a name="l00215"></a>00215           }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217         <span class="comment">// compute the shape function values &amp; gradients</span>
<a name="l00218"></a>00218         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00219"></a>00219           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00220"></a>00220             {
<a name="l00221"></a>00221               this-&gt;phi[i][p] = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,XYZ&gt;::shape</a> (elem, this-&gt;fe_type.order, i, this-&gt;xyz[p]);
<a name="l00222"></a>00222 
<a name="l00223"></a>00223               this-&gt;dphi[i][p](0) =
<a name="l00224"></a>00224                 this-&gt;dphidx[i][p] = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,XYZ&gt;::shape_deriv</a> (elem, this-&gt;fe_type.order, i, 0, this-&gt;xyz[p]);
<a name="l00225"></a>00225               
<a name="l00226"></a>00226               this-&gt;dphi[i][p](1) =
<a name="l00227"></a>00227                 this-&gt;dphidy[i][p] = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,XYZ&gt;::shape_deriv</a> (elem, this-&gt;fe_type.order, i, 1, this-&gt;xyz[p]);
<a name="l00228"></a>00228               
<a name="l00229"></a>00229 <span class="preprocessor">#if LIBMESH_DIM == 3  </span>
<a name="l00230"></a>00230 <span class="preprocessor"></span>              this-&gt;dphi[i][p](2) = <span class="comment">// can only assign to the Z component if LIBMESH_DIM==3</span>
<a name="l00231"></a>00231 #endif
<a name="l00232"></a>00232                 this-&gt;dphidz[i][p] = 0.;
<a name="l00233"></a>00233             }
<a name="l00234"></a>00234         
<a name="l00235"></a>00235         <span class="comment">// done computing face values</span>
<a name="l00236"></a>00236         <span class="keywordflow">break</span>;
<a name="l00237"></a>00237       }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240       
<a name="l00241"></a>00241     <span class="keywordflow">case</span> 3:
<a name="l00242"></a>00242       {
<a name="l00243"></a>00243         <span class="comment">// A 3D finite element living in 3D space.</span>
<a name="l00244"></a>00244         <span class="comment">// Resize the vectors to hold data at the quadrature points</span>
<a name="l00245"></a>00245         {  
<a name="l00246"></a>00246           this-&gt;xyz.resize(n_qp);
<a name="l00247"></a>00247           this-&gt;dxyzdxi_map.resize(n_qp);
<a name="l00248"></a>00248           this-&gt;dxyzdeta_map.resize(n_qp);
<a name="l00249"></a>00249           this-&gt;d2xyzdxi2_map.resize(n_qp);
<a name="l00250"></a>00250           this-&gt;d2xyzdxideta_map.resize(n_qp);
<a name="l00251"></a>00251           this-&gt;d2xyzdeta2_map.resize(n_qp);
<a name="l00252"></a>00252           this-&gt;tangents.resize(n_qp);
<a name="l00253"></a>00253           this-&gt;normals.resize(n_qp);
<a name="l00254"></a>00254           this-&gt;curvatures.resize(n_qp);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256           this-&gt;JxW.resize(n_qp);
<a name="l00257"></a>00257         }
<a name="l00258"></a>00258     
<a name="l00259"></a>00259         <span class="comment">// Clear the entities that will be summed</span>
<a name="l00260"></a>00260         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00261"></a>00261           {
<a name="l00262"></a>00262             this-&gt;tangents[p].resize(LIBMESH_DIM-1); <span class="comment">// 1 Tangent in 2D, 2 in 3D</span>
<a name="l00263"></a>00263             this-&gt;xyz[p].zero();
<a name="l00264"></a>00264             this-&gt;dxyzdxi_map[p].zero();
<a name="l00265"></a>00265             this-&gt;dxyzdeta_map[p].zero();
<a name="l00266"></a>00266             this-&gt;d2xyzdxi2_map[p].zero();
<a name="l00267"></a>00267             this-&gt;d2xyzdxideta_map[p].zero();
<a name="l00268"></a>00268             this-&gt;d2xyzdeta2_map[p].zero();
<a name="l00269"></a>00269           }
<a name="l00270"></a>00270         
<a name="l00271"></a>00271         <span class="comment">// compute x, dxdxi at the quadrature points    </span>
<a name="l00272"></a>00272         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;psi_map.size(); i++) <span class="comment">// sum over the nodes</span>
<a name="l00273"></a>00273           {
<a name="l00274"></a>00274             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; side_point = side-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i);
<a name="l00275"></a>00275             
<a name="l00276"></a>00276             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++) <span class="comment">// for each quadrature point...</span>
<a name="l00277"></a>00277               {
<a name="l00278"></a>00278                 this-&gt;xyz[p].<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>             (side_point, this-&gt;psi_map[i][p]);
<a name="l00279"></a>00279                 this-&gt;dxyzdxi_map[p].add_scaled     (side_point, this-&gt;dpsidxi_map[i][p]);
<a name="l00280"></a>00280                 this-&gt;dxyzdeta_map[p].add_scaled    (side_point, this-&gt;dpsideta_map[i][p]);
<a name="l00281"></a>00281                 this-&gt;d2xyzdxi2_map[p].add_scaled   (side_point, this-&gt;d2psidxi2_map[i][p]);
<a name="l00282"></a>00282                 this-&gt;d2xyzdxideta_map[p].add_scaled(side_point, this-&gt;d2psidxideta_map[i][p]);
<a name="l00283"></a>00283                 this-&gt;d2xyzdeta2_map[p].add_scaled  (side_point, this-&gt;d2psideta2_map[i][p]);
<a name="l00284"></a>00284               }
<a name="l00285"></a>00285           }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287         <span class="comment">// Compute the tangents, normal, and curvature at the quadrature point</span>
<a name="l00288"></a>00288         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00289"></a>00289           {         
<a name="l00290"></a>00290             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> n  = this-&gt;dxyzdxi_map[p].<a class="code" href="classlibMesh_1_1TypeVector.php#a2aec9a10f796ec4cd55c5d2a62885305">cross</a>(this-&gt;dxyzdeta_map[p]);
<a name="l00291"></a>00291             this-&gt;normals[p]     = n.<a class="code" href="classlibMesh_1_1TypeVector.php#af309ac3227a31641f8e8ecbe9bb972a5">unit</a>();
<a name="l00292"></a>00292             this-&gt;tangents[p][0] = this-&gt;dxyzdxi_map[p].<a class="code" href="classlibMesh_1_1TypeVector.php#af309ac3227a31641f8e8ecbe9bb972a5">unit</a>();
<a name="l00293"></a>00293             this-&gt;tangents[p][1] = n.<a class="code" href="classlibMesh_1_1TypeVector.php#a2aec9a10f796ec4cd55c5d2a62885305">cross</a>(this-&gt;dxyzdxi_map[p]).unit();
<a name="l00294"></a>00294             
<a name="l00295"></a>00295             <span class="comment">// Compute curvature using the typical nomenclature</span>
<a name="l00296"></a>00296             <span class="comment">// of the first and second fundamental forms.</span>
<a name="l00297"></a>00297             <span class="comment">// For reference, see:</span>
<a name="l00298"></a>00298             <span class="comment">// 1) http://mathworld.wolfram.com/MeanCurvature.html</span>
<a name="l00299"></a>00299             <span class="comment">//    (note -- they are using inward normal)</span>
<a name="l00300"></a>00300             <span class="comment">// 2) F.S. Merritt, Mathematics Manual, 1962, McGraw-Hill</span>
<a name="l00301"></a>00301             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> L  = -this-&gt;d2xyzdxi2_map[p]    * this-&gt;normals[p];
<a name="l00302"></a>00302             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> M  = -this-&gt;d2xyzdxideta_map[p] * this-&gt;normals[p];
<a name="l00303"></a>00303             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> N  = -this-&gt;d2xyzdeta2_map[p]   * this-&gt;normals[p];
<a name="l00304"></a>00304             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> E  =  this-&gt;dxyzdxi_map[p].size_sq();
<a name="l00305"></a>00305             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> F  =  this-&gt;dxyzdxi_map[p]      * this-&gt;dxyzdeta_map[p];
<a name="l00306"></a>00306             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> G  =  this-&gt;dxyzdeta_map[p].size_sq();
<a name="l00307"></a>00307             
<a name="l00308"></a>00308             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> numerator   = E*N -2.*F*M + G*L;
<a name="l00309"></a>00309             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> denominator = E*G - F*F;
<a name="l00310"></a>00310             libmesh_assert (denominator != 0.);
<a name="l00311"></a>00311             this-&gt;curvatures[p] = 0.5*numerator/denominator;
<a name="l00312"></a>00312           }    
<a name="l00313"></a>00313         
<a name="l00314"></a>00314         <span class="comment">// compute the jacobian at the quadrature points, see</span>
<a name="l00315"></a>00315         <span class="comment">// http://sp81.msi.umn.edu:999/fluent/fidap/help/theory/thtoc.htm</span>
<a name="l00316"></a>00316         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00317"></a>00317           {
<a name="l00318"></a>00318             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g11 = (this-&gt;dxdxi_map(p)*this-&gt;dxdxi_map(p) +
<a name="l00319"></a>00319                               this-&gt;dydxi_map(p)*this-&gt;dydxi_map(p) +
<a name="l00320"></a>00320                               this-&gt;dzdxi_map(p)*this-&gt;dzdxi_map(p));
<a name="l00321"></a>00321             
<a name="l00322"></a>00322             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g12 = (this-&gt;dxdxi_map(p)*this-&gt;dxdeta_map(p) +
<a name="l00323"></a>00323                               this-&gt;dydxi_map(p)*this-&gt;dydeta_map(p) +
<a name="l00324"></a>00324                               this-&gt;dzdxi_map(p)*this-&gt;dzdeta_map(p));
<a name="l00325"></a>00325             
<a name="l00326"></a>00326             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g21 = g12;
<a name="l00327"></a>00327             
<a name="l00328"></a>00328             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> g22 = (this-&gt;dxdeta_map(p)*this-&gt;dxdeta_map(p) +
<a name="l00329"></a>00329                               this-&gt;dydeta_map(p)*this-&gt;dydeta_map(p) +
<a name="l00330"></a>00330                               this-&gt;dzdeta_map(p)*this-&gt;dzdeta_map(p));
<a name="l00331"></a>00331             
<a name="l00332"></a>00332             
<a name="l00333"></a>00333             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> jac = std::sqrt(g11*g22 - g12*g21);
<a name="l00334"></a>00334             
<a name="l00335"></a>00335             libmesh_assert (jac &gt; 0.);
<a name="l00336"></a>00336 
<a name="l00337"></a>00337             this-&gt;JxW[p] = jac*qw[p];
<a name="l00338"></a>00338           }
<a name="l00339"></a>00339         
<a name="l00340"></a>00340         <span class="comment">// compute the shape function values &amp; gradients</span>
<a name="l00341"></a>00341         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_approx_shape_functions; i++)
<a name="l00342"></a>00342           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_qp; p++)
<a name="l00343"></a>00343             {
<a name="l00344"></a>00344               this-&gt;phi[i][p] = <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;Dim,XYZ&gt;::shape</a> (elem, this-&gt;fe_type.order, i, this-&gt;xyz[p]);
<a name="l00345"></a>00345                
<a name="l00346"></a>00346               this-&gt;dphi[i][p](0) =
<a name="l00347"></a>00347                 this-&gt;dphidx[i][p] = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,XYZ&gt;::shape_deriv</a> (elem, this-&gt;fe_type.order, i, 0, this-&gt;xyz[p]);
<a name="l00348"></a>00348                 
<a name="l00349"></a>00349               this-&gt;dphi[i][p](1) =
<a name="l00350"></a>00350                 this-&gt;dphidy[i][p] = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,XYZ&gt;::shape_deriv</a> (elem, this-&gt;fe_type.order, i, 1, this-&gt;xyz[p]);
<a name="l00351"></a>00351                 
<a name="l00352"></a>00352               this-&gt;dphi[i][p](2) =
<a name="l00353"></a>00353                 this-&gt;dphidz[i][p] = <a class="code" href="classlibMesh_1_1FE.php">FE&lt;Dim,XYZ&gt;::shape_deriv</a> (elem, this-&gt;fe_type.order, i, 2, this-&gt;xyz[p]);        
<a name="l00354"></a>00354             }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356         <span class="comment">// done computing face values</span>
<a name="l00357"></a>00357         <span class="keywordflow">break</span>;
<a name="l00358"></a>00358       }
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361     <span class="keywordflow">default</span>:
<a name="l00362"></a>00362       libmesh_error();
<a name="l00363"></a>00363       
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365   STOP_LOG(<span class="stringliteral">&quot;compute_face_values()&quot;</span>, <span class="stringliteral">&quot;FEXYZ&quot;</span>);
<a name="l00366"></a>00366 }
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00372"></a>00372 <span class="comment">// Explicit instantiations (doesn&#39;t make sense in 1D!) using fe_macro.h&#39;s macro</span>
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEXYZ.php">FEXYZ&lt;2&gt;</a>;
<a name="l00375"></a>00375 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEXYZ.php">FEXYZ&lt;3&gt;</a>;
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
