<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fe_xyz_shape_2D.C</div>  </div>
</div>
<div class="contents">
<a href="fe__xyz__shape__2D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fe_xyz_shape_2D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ inlcludes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Anonymous namespace for persistant variables.</span>
<a name="l00031"></a>00031 <span class="comment">// This allows us to determine when the centroid needs</span>
<a name="l00032"></a>00032 <span class="comment">// to be recalculated.</span>
<a name="l00033"></a>00033 <span class="keyword">namespace</span>
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_elem_id = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00036"></a>00036   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">libMesh::Point</a> centroid;
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;&gt;
<a name="l00045"></a><a class="code" href="classlibMesh_1_1FE.php#ae5395993091b4537583cfc9c5f09ebed">00045</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;2,XYZ&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00046"></a>00046                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00047"></a>00047                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00048"></a>00048                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;XYZ polynomials require the element\n&quot;</span>
<a name="l00051"></a>00051                 &lt;&lt; <span class="stringliteral">&quot;because the centroid is needed.&quot;</span>
<a name="l00052"></a>00052                 &lt;&lt; std::endl;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   libmesh_error();
<a name="l00055"></a>00055   <span class="keywordflow">return</span> 0.;
<a name="l00056"></a>00056 }
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="keyword">template</span> &lt;&gt;
<a name="l00061"></a><a class="code" href="classlibMesh_1_1FE.php#aafda96ad47b5d5be4ec4997ad8e999c0">00061</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;2,XYZ&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00062"></a>00062                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00063"></a>00063                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00064"></a>00064                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068   libmesh_assert (elem != NULL);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// Only recompute the centroid if the element</span>
<a name="l00071"></a>00071   <span class="comment">// has changed from the last one we computed.</span>
<a name="l00072"></a>00072   <span class="comment">// This avoids repeated centroid calculations</span>
<a name="l00073"></a>00073   <span class="comment">// when called in succession with the same element.</span>
<a name="l00074"></a>00074   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() != old_elem_id)
<a name="l00075"></a>00075     {
<a name="l00076"></a>00076       centroid = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">centroid</a>();
<a name="l00077"></a>00077       old_elem_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00078"></a>00078     }  
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="comment">// Using static globals for old_elem_id, etc. will fail</span>
<a name="l00081"></a>00081   <span class="comment">// horribly with more than one thread.</span>
<a name="l00082"></a>00082   libmesh_assert(<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() == 1);
<a name="l00083"></a>00083   
<a name="l00084"></a>00084   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x  = p(0);
<a name="l00085"></a>00085   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y  = p(1);
<a name="l00086"></a>00086   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xc = centroid(0);
<a name="l00087"></a>00087   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yc = centroid(1);
<a name="l00088"></a>00088   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dx = x - xc;
<a name="l00089"></a>00089   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dy = y - yc;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00092"></a>00092 <span class="preprocessor"></span>  <span class="comment">// totalorder is only used in the assertion below, so</span>
<a name="l00093"></a>00093   <span class="comment">// we avoid declaring it when asserts are not active.</span>
<a name="l00094"></a>00094   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> totalorder = order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00095"></a>00095 <span class="preprocessor">#endif</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span>  libmesh_assert (i &lt; (totalorder+1)*(totalorder+2)/2);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <span class="comment">// monomials. since they are hierarchic we only need one case block.</span>
<a name="l00100"></a>00100   <span class="keywordflow">switch</span> (i)
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <span class="comment">// constant</span>
<a name="l00103"></a>00103     <span class="keywordflow">case</span> 0:
<a name="l00104"></a>00104       <span class="keywordflow">return</span> 1.;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106       <span class="comment">// linear</span>
<a name="l00107"></a>00107     <span class="keywordflow">case</span> 1:
<a name="l00108"></a>00108       <span class="keywordflow">return</span> dx;
<a name="l00109"></a>00109     
<a name="l00110"></a>00110     <span class="keywordflow">case</span> 2:
<a name="l00111"></a>00111       <span class="keywordflow">return</span> dy;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113       <span class="comment">// quadratics</span>
<a name="l00114"></a>00114     <span class="keywordflow">case</span> 3:
<a name="l00115"></a>00115       <span class="keywordflow">return</span> dx*dx;
<a name="l00116"></a>00116     
<a name="l00117"></a>00117     <span class="keywordflow">case</span> 4:
<a name="l00118"></a>00118       <span class="keywordflow">return</span> dx*dy;
<a name="l00119"></a>00119     
<a name="l00120"></a>00120     <span class="keywordflow">case</span> 5:
<a name="l00121"></a>00121       <span class="keywordflow">return</span> dy*dy;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123       <span class="comment">// cubics</span>
<a name="l00124"></a>00124     <span class="keywordflow">case</span> 6:
<a name="l00125"></a>00125       <span class="keywordflow">return</span> dx*dx*dx;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127     <span class="keywordflow">case</span> 7:
<a name="l00128"></a>00128       <span class="keywordflow">return</span> dx*dx*dy;
<a name="l00129"></a>00129 
<a name="l00130"></a>00130     <span class="keywordflow">case</span> 8:
<a name="l00131"></a>00131       <span class="keywordflow">return</span> dx*dy*dy;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133     <span class="keywordflow">case</span> 9:
<a name="l00134"></a>00134       <span class="keywordflow">return</span> dy*dy*dy;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136       <span class="comment">// quartics</span>
<a name="l00137"></a>00137     <span class="keywordflow">case</span> 10:
<a name="l00138"></a>00138       <span class="keywordflow">return</span> dx*dx*dx*dx;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     <span class="keywordflow">case</span> 11:
<a name="l00141"></a>00141       <span class="keywordflow">return</span> dx*dx*dx*dy;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143     <span class="keywordflow">case</span> 12:
<a name="l00144"></a>00144       <span class="keywordflow">return</span> dx*dx*dy*dy;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     <span class="keywordflow">case</span> 13:
<a name="l00147"></a>00147       <span class="keywordflow">return</span> dx*dy*dy*dy;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     <span class="keywordflow">case</span> 14:
<a name="l00150"></a>00150       <span class="keywordflow">return</span> dy*dy*dy*dy;
<a name="l00151"></a>00151     
<a name="l00152"></a>00152     <span class="keywordflow">default</span>:
<a name="l00153"></a>00153       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00154"></a>00154       <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00155"></a>00155       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2 = i - (o*(o+1)/2);
<a name="l00156"></a>00156       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = 1.;
<a name="l00157"></a>00157       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=i2; index != o; index++)
<a name="l00158"></a>00158         val *= dx;
<a name="l00159"></a>00159       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index != i2; index++)
<a name="l00160"></a>00160         val *= dy;
<a name="l00161"></a>00161       <span class="keywordflow">return</span> val;
<a name="l00162"></a>00162     }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   libmesh_error();
<a name="l00165"></a>00165   <span class="keywordflow">return</span> 0.;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="preprocessor">#endif</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>}
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 <span class="keyword">template</span> &lt;&gt;
<a name="l00173"></a><a class="code" href="classlibMesh_1_1FE.php#a22e55568840f6682917247c104af596f">00173</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;2,XYZ&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00174"></a>00174                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00175"></a>00175                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00176"></a>00176                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00177"></a>00177                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00178"></a>00178 {
<a name="l00179"></a>00179   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;XYZ polynomials require the element\n&quot;</span>
<a name="l00180"></a>00180                 &lt;&lt; <span class="stringliteral">&quot;because the centroid is needed.&quot;</span>
<a name="l00181"></a>00181                 &lt;&lt; std::endl;
<a name="l00182"></a>00182   
<a name="l00183"></a>00183   libmesh_error();
<a name="l00184"></a>00184   <span class="keywordflow">return</span> 0.;
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="keyword">template</span> &lt;&gt;
<a name="l00190"></a><a class="code" href="classlibMesh_1_1FE.php#adb3214dc1f0f14b9d0c741b03820a62e">00190</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#aebb6a76e2c509132112e7d093493f501">FE&lt;2,XYZ&gt;::shape_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00191"></a>00191                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00192"></a>00192                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00193"></a>00193                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00194"></a>00194                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00195"></a>00195 {
<a name="l00196"></a>00196 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>
<a name="l00198"></a>00198   
<a name="l00199"></a>00199   libmesh_assert (j&lt;2);
<a name="l00200"></a>00200   libmesh_assert (elem != NULL);
<a name="l00201"></a>00201   
<a name="l00202"></a>00202   <span class="comment">// Only recompute the centroid if the element</span>
<a name="l00203"></a>00203   <span class="comment">// has changed from the last one we computed.</span>
<a name="l00204"></a>00204   <span class="comment">// This avoids repeated centroid calculations</span>
<a name="l00205"></a>00205   <span class="comment">// when called in succession with the same element.</span>
<a name="l00206"></a>00206   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() != old_elem_id)
<a name="l00207"></a>00207     {
<a name="l00208"></a>00208       centroid = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">centroid</a>();
<a name="l00209"></a>00209       old_elem_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00210"></a>00210     }  
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="comment">// Using static globals for old_elem_id, etc. will fail</span>
<a name="l00213"></a>00213   <span class="comment">// horribly with more than one thread.</span>
<a name="l00214"></a>00214   libmesh_assert(<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() == 1);
<a name="l00215"></a>00215   
<a name="l00216"></a>00216   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x  = p(0);
<a name="l00217"></a>00217   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y  = p(1);
<a name="l00218"></a>00218   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xc = centroid(0);
<a name="l00219"></a>00219   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yc = centroid(1);
<a name="l00220"></a>00220   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dx = x - xc;
<a name="l00221"></a>00221   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dy = y - yc;
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00224"></a>00224 <span class="preprocessor"></span>  <span class="comment">// totalorder is only used in the assertion below, so</span>
<a name="l00225"></a>00225   <span class="comment">// we avoid declaring it when asserts are not active.</span>
<a name="l00226"></a>00226   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> totalorder = order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00227"></a>00227 <span class="preprocessor">#endif</span>
<a name="l00228"></a>00228 <span class="preprocessor"></span>  libmesh_assert (i &lt; (totalorder+1)*(totalorder+2)/2);
<a name="l00229"></a>00229   
<a name="l00230"></a>00230   <span class="comment">// monomials. since they are hierarchic we only need one case block.</span>
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="keywordflow">switch</span> (j)
<a name="l00233"></a>00233   {
<a name="l00234"></a>00234     <span class="comment">// d()/dx</span>
<a name="l00235"></a>00235   <span class="keywordflow">case</span> 0:
<a name="l00236"></a>00236     {
<a name="l00237"></a>00237       <span class="keywordflow">switch</span> (i)
<a name="l00238"></a>00238         {
<a name="l00239"></a>00239           <span class="comment">// constants</span>
<a name="l00240"></a>00240         <span class="keywordflow">case</span> 0:
<a name="l00241"></a>00241           <span class="keywordflow">return</span> 0.;
<a name="l00242"></a>00242             
<a name="l00243"></a>00243           <span class="comment">// linears</span>
<a name="l00244"></a>00244         <span class="keywordflow">case</span> 1:
<a name="l00245"></a>00245           <span class="keywordflow">return</span> 1.;
<a name="l00246"></a>00246             
<a name="l00247"></a>00247         <span class="keywordflow">case</span> 2:
<a name="l00248"></a>00248           <span class="keywordflow">return</span> 0.;
<a name="l00249"></a>00249 
<a name="l00250"></a>00250           <span class="comment">// quadratics</span>
<a name="l00251"></a>00251         <span class="keywordflow">case</span> 3:
<a name="l00252"></a>00252           <span class="keywordflow">return</span> 2.*dx;
<a name="l00253"></a>00253             
<a name="l00254"></a>00254         <span class="keywordflow">case</span> 4:
<a name="l00255"></a>00255           <span class="keywordflow">return</span> dy;
<a name="l00256"></a>00256             
<a name="l00257"></a>00257         <span class="keywordflow">case</span> 5:
<a name="l00258"></a>00258           <span class="keywordflow">return</span> 0.;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260           <span class="comment">// cubics</span>
<a name="l00261"></a>00261         <span class="keywordflow">case</span> 6:
<a name="l00262"></a>00262           <span class="keywordflow">return</span> 3.*dx*dx;
<a name="l00263"></a>00263             
<a name="l00264"></a>00264         <span class="keywordflow">case</span> 7:
<a name="l00265"></a>00265           <span class="keywordflow">return</span> 2.*dx*dy;
<a name="l00266"></a>00266             
<a name="l00267"></a>00267         <span class="keywordflow">case</span> 8:
<a name="l00268"></a>00268           <span class="keywordflow">return</span> dy*dy;
<a name="l00269"></a>00269             
<a name="l00270"></a>00270         <span class="keywordflow">case</span> 9:
<a name="l00271"></a>00271           <span class="keywordflow">return</span> 0.;
<a name="l00272"></a>00272             
<a name="l00273"></a>00273           <span class="comment">// quartics</span>
<a name="l00274"></a>00274         <span class="keywordflow">case</span> 10:
<a name="l00275"></a>00275           <span class="keywordflow">return</span> 4.*dx*dx*dx;
<a name="l00276"></a>00276             
<a name="l00277"></a>00277         <span class="keywordflow">case</span> 11:
<a name="l00278"></a>00278           <span class="keywordflow">return</span> 3.*dx*dx*dy;
<a name="l00279"></a>00279             
<a name="l00280"></a>00280         <span class="keywordflow">case</span> 12:
<a name="l00281"></a>00281           <span class="keywordflow">return</span> 2.*dx*dy*dy;
<a name="l00282"></a>00282             
<a name="l00283"></a>00283         <span class="keywordflow">case</span> 13:
<a name="l00284"></a>00284           <span class="keywordflow">return</span> dy*dy*dy;
<a name="l00285"></a>00285             
<a name="l00286"></a>00286         <span class="keywordflow">case</span> 14:
<a name="l00287"></a>00287           <span class="keywordflow">return</span> 0.;
<a name="l00288"></a>00288             
<a name="l00289"></a>00289         <span class="keywordflow">default</span>:
<a name="l00290"></a>00290           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00291"></a>00291           <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00292"></a>00292           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2 = i - (o*(o+1)/2);
<a name="l00293"></a>00293           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = o - i2;
<a name="l00294"></a>00294           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=i2+1; index &lt; o; index++)
<a name="l00295"></a>00295             val *= dx;
<a name="l00296"></a>00296           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index != i2; index++)
<a name="l00297"></a>00297             val *= dy;
<a name="l00298"></a>00298           <span class="keywordflow">return</span> val;
<a name="l00299"></a>00299         }
<a name="l00300"></a>00300     }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302               
<a name="l00303"></a>00303     <span class="comment">// d()/dy</span>
<a name="l00304"></a>00304   <span class="keywordflow">case</span> 1:
<a name="l00305"></a>00305     {
<a name="l00306"></a>00306       <span class="keywordflow">switch</span> (i)
<a name="l00307"></a>00307         {
<a name="l00308"></a>00308           <span class="comment">// constants</span>
<a name="l00309"></a>00309         <span class="keywordflow">case</span> 0:
<a name="l00310"></a>00310           <span class="keywordflow">return</span> 0.;
<a name="l00311"></a>00311             
<a name="l00312"></a>00312           <span class="comment">// linears</span>
<a name="l00313"></a>00313         <span class="keywordflow">case</span> 1:
<a name="l00314"></a>00314           <span class="keywordflow">return</span> 0.;
<a name="l00315"></a>00315             
<a name="l00316"></a>00316         <span class="keywordflow">case</span> 2:
<a name="l00317"></a>00317           <span class="keywordflow">return</span> 1.;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319           <span class="comment">// quadratics</span>
<a name="l00320"></a>00320         <span class="keywordflow">case</span> 3:
<a name="l00321"></a>00321           <span class="keywordflow">return</span> 0.;
<a name="l00322"></a>00322             
<a name="l00323"></a>00323         <span class="keywordflow">case</span> 4:
<a name="l00324"></a>00324           <span class="keywordflow">return</span> dx;
<a name="l00325"></a>00325             
<a name="l00326"></a>00326         <span class="keywordflow">case</span> 5:
<a name="l00327"></a>00327           <span class="keywordflow">return</span> 2.*dy;
<a name="l00328"></a>00328 
<a name="l00329"></a>00329           <span class="comment">// cubics</span>
<a name="l00330"></a>00330         <span class="keywordflow">case</span> 6:
<a name="l00331"></a>00331           <span class="keywordflow">return</span> 0.;
<a name="l00332"></a>00332             
<a name="l00333"></a>00333         <span class="keywordflow">case</span> 7:
<a name="l00334"></a>00334           <span class="keywordflow">return</span> dx*dx;
<a name="l00335"></a>00335             
<a name="l00336"></a>00336         <span class="keywordflow">case</span> 8:
<a name="l00337"></a>00337           <span class="keywordflow">return</span> 2.*dx*dy;
<a name="l00338"></a>00338             
<a name="l00339"></a>00339         <span class="keywordflow">case</span> 9:
<a name="l00340"></a>00340           <span class="keywordflow">return</span> 3.*dy*dy;
<a name="l00341"></a>00341             
<a name="l00342"></a>00342           <span class="comment">// quartics</span>
<a name="l00343"></a>00343         <span class="keywordflow">case</span> 10:
<a name="l00344"></a>00344           <span class="keywordflow">return</span> 0.;
<a name="l00345"></a>00345             
<a name="l00346"></a>00346         <span class="keywordflow">case</span> 11:
<a name="l00347"></a>00347           <span class="keywordflow">return</span> dx*dx*dx;
<a name="l00348"></a>00348             
<a name="l00349"></a>00349         <span class="keywordflow">case</span> 12:
<a name="l00350"></a>00350           <span class="keywordflow">return</span> 2.*dx*dx*dy;
<a name="l00351"></a>00351             
<a name="l00352"></a>00352         <span class="keywordflow">case</span> 13:
<a name="l00353"></a>00353           <span class="keywordflow">return</span> 3.*dx*dy*dy;
<a name="l00354"></a>00354             
<a name="l00355"></a>00355         <span class="keywordflow">case</span> 14:
<a name="l00356"></a>00356           <span class="keywordflow">return</span> 4.*dy*dy*dy;
<a name="l00357"></a>00357             
<a name="l00358"></a>00358         <span class="keywordflow">default</span>:
<a name="l00359"></a>00359           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00360"></a>00360           <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00361"></a>00361           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2 = i - (o*(o+1)/2);
<a name="l00362"></a>00362           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = i2;
<a name="l00363"></a>00363           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=i2; index != o; index++)
<a name="l00364"></a>00364             val *= dx;
<a name="l00365"></a>00365           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=1; index &lt;= i2; index++)
<a name="l00366"></a>00366             val *= dy;
<a name="l00367"></a>00367           <span class="keywordflow">return</span> val;
<a name="l00368"></a>00368         }
<a name="l00369"></a>00369     }
<a name="l00370"></a>00370               
<a name="l00371"></a>00371               
<a name="l00372"></a>00372   <span class="keywordflow">default</span>:
<a name="l00373"></a>00373     libmesh_error();
<a name="l00374"></a>00374   }
<a name="l00375"></a>00375 
<a name="l00376"></a>00376   libmesh_error();
<a name="l00377"></a>00377   <span class="keywordflow">return</span> 0.;
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 <span class="preprocessor">#endif</span>
<a name="l00380"></a>00380 <span class="preprocessor"></span>}
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 <span class="keyword">template</span> &lt;&gt;
<a name="l00385"></a><a class="code" href="classlibMesh_1_1FE.php#a8a1ce73747c730da8aafec265f9771c8">00385</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;2,XYZ&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00386"></a>00386                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,
<a name="l00387"></a>00387                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00388"></a>00388                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00389"></a>00389                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;)
<a name="l00390"></a>00390 {
<a name="l00391"></a>00391   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;XYZ polynomials require the element\n&quot;</span>
<a name="l00392"></a>00392                 &lt;&lt; <span class="stringliteral">&quot;because the centroid is needed.&quot;</span>
<a name="l00393"></a>00393                 &lt;&lt; std::endl;
<a name="l00394"></a>00394   
<a name="l00395"></a>00395   libmesh_error();
<a name="l00396"></a>00396   <span class="keywordflow">return</span> 0.;
<a name="l00397"></a>00397 }
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 <span class="keyword">template</span> &lt;&gt;
<a name="l00402"></a><a class="code" href="classlibMesh_1_1FE.php#aa31d8d22d539ba6bb95e9f9c31902e5c">00402</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FE.php#afbddc57e71fcd5da36224d3d21ddb5ab">FE&lt;2,XYZ&gt;::shape_second_deriv</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00403"></a>00403                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00404"></a>00404                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00405"></a>00405                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00406"></a>00406                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00407"></a>00407 {
<a name="l00408"></a>00408 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00409"></a>00409 <span class="preprocessor"></span>
<a name="l00410"></a>00410   libmesh_assert (j&lt;=2);
<a name="l00411"></a>00411   libmesh_assert (elem != NULL);
<a name="l00412"></a>00412   
<a name="l00413"></a>00413   <span class="comment">// Only recompute the centroid if the element</span>
<a name="l00414"></a>00414   <span class="comment">// has changed from the last one we computed.</span>
<a name="l00415"></a>00415   <span class="comment">// This avoids repeated centroid calculations</span>
<a name="l00416"></a>00416   <span class="comment">// when called in succession with the same element.</span>
<a name="l00417"></a>00417   <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() != old_elem_id)
<a name="l00418"></a>00418     {
<a name="l00419"></a>00419       centroid = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">centroid</a>();
<a name="l00420"></a>00420       old_elem_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00421"></a>00421     }  
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="comment">// Using static globals for old_elem_id, etc. will fail</span>
<a name="l00424"></a>00424   <span class="comment">// horribly with more than one thread.</span>
<a name="l00425"></a>00425   libmesh_assert(<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() == 1);
<a name="l00426"></a>00426   
<a name="l00427"></a>00427   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x  = p(0);
<a name="l00428"></a>00428   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y  = p(1);
<a name="l00429"></a>00429   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xc = centroid(0);
<a name="l00430"></a>00430   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yc = centroid(1);
<a name="l00431"></a>00431   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dx = x - xc;
<a name="l00432"></a>00432   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dy = y - yc;
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00435"></a>00435 <span class="preprocessor"></span>  <span class="comment">// totalorder is only used in the assertion below, so</span>
<a name="l00436"></a>00436   <span class="comment">// we avoid declaring it when asserts are not active.</span>
<a name="l00437"></a>00437   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> totalorder = order + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00438"></a>00438 <span class="preprocessor">#endif</span>
<a name="l00439"></a>00439 <span class="preprocessor"></span>  libmesh_assert (i &lt; (totalorder+1)*(totalorder+2)/2);
<a name="l00440"></a>00440   
<a name="l00441"></a>00441   <span class="comment">// monomials. since they are hierarchic we only need one case block.</span>
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="keywordflow">switch</span> (j)
<a name="l00444"></a>00444     {
<a name="l00445"></a>00445       <span class="comment">// d^2()/dx^2</span>
<a name="l00446"></a>00446     <span class="keywordflow">case</span> 0:
<a name="l00447"></a>00447       {
<a name="l00448"></a>00448         <span class="keywordflow">switch</span> (i)
<a name="l00449"></a>00449           {
<a name="l00450"></a>00450             <span class="comment">// constants</span>
<a name="l00451"></a>00451           <span class="keywordflow">case</span> 0:
<a name="l00452"></a>00452             <span class="comment">// linears</span>
<a name="l00453"></a>00453           <span class="keywordflow">case</span> 1:
<a name="l00454"></a>00454           <span class="keywordflow">case</span> 2:
<a name="l00455"></a>00455             <span class="keywordflow">return</span> 0.;
<a name="l00456"></a>00456 
<a name="l00457"></a>00457             <span class="comment">// quadratics</span>
<a name="l00458"></a>00458           <span class="keywordflow">case</span> 3:
<a name="l00459"></a>00459             <span class="keywordflow">return</span> 2.;
<a name="l00460"></a>00460             
<a name="l00461"></a>00461           <span class="keywordflow">case</span> 4:
<a name="l00462"></a>00462           <span class="keywordflow">case</span> 5:
<a name="l00463"></a>00463             <span class="keywordflow">return</span> 0.;
<a name="l00464"></a>00464 
<a name="l00465"></a>00465             <span class="comment">// cubics</span>
<a name="l00466"></a>00466           <span class="keywordflow">case</span> 6:
<a name="l00467"></a>00467             <span class="keywordflow">return</span> 6.*dx;
<a name="l00468"></a>00468             
<a name="l00469"></a>00469           <span class="keywordflow">case</span> 7:
<a name="l00470"></a>00470             <span class="keywordflow">return</span> 2.*dy;
<a name="l00471"></a>00471             
<a name="l00472"></a>00472           <span class="keywordflow">case</span> 8:
<a name="l00473"></a>00473           <span class="keywordflow">case</span> 9:
<a name="l00474"></a>00474             <span class="keywordflow">return</span> 0.;
<a name="l00475"></a>00475             
<a name="l00476"></a>00476             <span class="comment">// quartics</span>
<a name="l00477"></a>00477           <span class="keywordflow">case</span> 10:
<a name="l00478"></a>00478             <span class="keywordflow">return</span> 12.*dx*dx;
<a name="l00479"></a>00479             
<a name="l00480"></a>00480           <span class="keywordflow">case</span> 11:
<a name="l00481"></a>00481             <span class="keywordflow">return</span> 6.*dx*dy;
<a name="l00482"></a>00482             
<a name="l00483"></a>00483           <span class="keywordflow">case</span> 12:
<a name="l00484"></a>00484             <span class="keywordflow">return</span> 2.*dy*dy;
<a name="l00485"></a>00485             
<a name="l00486"></a>00486           <span class="keywordflow">case</span> 13:
<a name="l00487"></a>00487           <span class="keywordflow">case</span> 14:
<a name="l00488"></a>00488             <span class="keywordflow">return</span> 0.;
<a name="l00489"></a>00489             
<a name="l00490"></a>00490           <span class="keywordflow">default</span>:
<a name="l00491"></a>00491             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00492"></a>00492             <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00493"></a>00493             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2 = i - (o*(o+1)/2);
<a name="l00494"></a>00494             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = (o - i2) * (o - i2 - 1);
<a name="l00495"></a>00495             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=i2+2; index &lt; o; index++)
<a name="l00496"></a>00496               val *= dx;
<a name="l00497"></a>00497             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index != i2; index++)
<a name="l00498"></a>00498               val *= dy;
<a name="l00499"></a>00499             <span class="keywordflow">return</span> val;
<a name="l00500"></a>00500           }
<a name="l00501"></a>00501       }
<a name="l00502"></a>00502 
<a name="l00503"></a>00503       <span class="comment">// d^2()/dxdy</span>
<a name="l00504"></a>00504     <span class="keywordflow">case</span> 1:
<a name="l00505"></a>00505       {
<a name="l00506"></a>00506         <span class="keywordflow">switch</span> (i)
<a name="l00507"></a>00507           {
<a name="l00508"></a>00508             <span class="comment">// constants</span>
<a name="l00509"></a>00509           <span class="keywordflow">case</span> 0:
<a name="l00510"></a>00510             
<a name="l00511"></a>00511             <span class="comment">// linears</span>
<a name="l00512"></a>00512           <span class="keywordflow">case</span> 1:
<a name="l00513"></a>00513           <span class="keywordflow">case</span> 2:
<a name="l00514"></a>00514             <span class="keywordflow">return</span> 0.;
<a name="l00515"></a>00515 
<a name="l00516"></a>00516             <span class="comment">// quadratics</span>
<a name="l00517"></a>00517           <span class="keywordflow">case</span> 3:
<a name="l00518"></a>00518             <span class="keywordflow">return</span> 0.;
<a name="l00519"></a>00519             
<a name="l00520"></a>00520           <span class="keywordflow">case</span> 4:
<a name="l00521"></a>00521             <span class="keywordflow">return</span> 1.;
<a name="l00522"></a>00522             
<a name="l00523"></a>00523           <span class="keywordflow">case</span> 5:
<a name="l00524"></a>00524             <span class="keywordflow">return</span> 0.;
<a name="l00525"></a>00525 
<a name="l00526"></a>00526             <span class="comment">// cubics</span>
<a name="l00527"></a>00527           <span class="keywordflow">case</span> 6:
<a name="l00528"></a>00528             <span class="keywordflow">return</span> 0.;
<a name="l00529"></a>00529           <span class="keywordflow">case</span> 7:
<a name="l00530"></a>00530             <span class="keywordflow">return</span> 2.*dx;
<a name="l00531"></a>00531             
<a name="l00532"></a>00532           <span class="keywordflow">case</span> 8:
<a name="l00533"></a>00533             <span class="keywordflow">return</span> 2.*dy;
<a name="l00534"></a>00534             
<a name="l00535"></a>00535           <span class="keywordflow">case</span> 9:
<a name="l00536"></a>00536             <span class="keywordflow">return</span> 0.;
<a name="l00537"></a>00537             
<a name="l00538"></a>00538             <span class="comment">// quartics</span>
<a name="l00539"></a>00539           <span class="keywordflow">case</span> 10:
<a name="l00540"></a>00540             <span class="keywordflow">return</span> 0.;
<a name="l00541"></a>00541 
<a name="l00542"></a>00542           <span class="keywordflow">case</span> 11:
<a name="l00543"></a>00543             <span class="keywordflow">return</span> 3.*dx*dx;
<a name="l00544"></a>00544             
<a name="l00545"></a>00545           <span class="keywordflow">case</span> 12:
<a name="l00546"></a>00546             <span class="keywordflow">return</span> 4.*dx*dy;
<a name="l00547"></a>00547             
<a name="l00548"></a>00548           <span class="keywordflow">case</span> 13:
<a name="l00549"></a>00549             <span class="keywordflow">return</span> 3.*dy*dy;
<a name="l00550"></a>00550             
<a name="l00551"></a>00551           <span class="keywordflow">case</span> 14:
<a name="l00552"></a>00552             <span class="keywordflow">return</span> 0.;
<a name="l00553"></a>00553             
<a name="l00554"></a>00554           <span class="keywordflow">default</span>:
<a name="l00555"></a>00555             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00556"></a>00556             <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00557"></a>00557             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2 = i - (o*(o+1)/2);
<a name="l00558"></a>00558             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = (o - i2) * i2;
<a name="l00559"></a>00559             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=i2+1; index &lt; o; index++)
<a name="l00560"></a>00560               val *= dx;
<a name="l00561"></a>00561             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=1; index &lt; i2; index++)
<a name="l00562"></a>00562               val *= dy;
<a name="l00563"></a>00563             <span class="keywordflow">return</span> val;
<a name="l00564"></a>00564           }
<a name="l00565"></a>00565       }
<a name="l00566"></a>00566               
<a name="l00567"></a>00567       <span class="comment">// d^2()/dy^2</span>
<a name="l00568"></a>00568     <span class="keywordflow">case</span> 2:
<a name="l00569"></a>00569       {
<a name="l00570"></a>00570         <span class="keywordflow">switch</span> (i)
<a name="l00571"></a>00571           {
<a name="l00572"></a>00572             <span class="comment">// constants</span>
<a name="l00573"></a>00573           <span class="keywordflow">case</span> 0:
<a name="l00574"></a>00574             
<a name="l00575"></a>00575             <span class="comment">// linears</span>
<a name="l00576"></a>00576           <span class="keywordflow">case</span> 1:
<a name="l00577"></a>00577           <span class="keywordflow">case</span> 2:
<a name="l00578"></a>00578             <span class="keywordflow">return</span> 0.;
<a name="l00579"></a>00579 
<a name="l00580"></a>00580             <span class="comment">// quadratics</span>
<a name="l00581"></a>00581           <span class="keywordflow">case</span> 3:
<a name="l00582"></a>00582           <span class="keywordflow">case</span> 4:
<a name="l00583"></a>00583             <span class="keywordflow">return</span> 0.;
<a name="l00584"></a>00584             
<a name="l00585"></a>00585           <span class="keywordflow">case</span> 5:
<a name="l00586"></a>00586             <span class="keywordflow">return</span> 2.;
<a name="l00587"></a>00587 
<a name="l00588"></a>00588             <span class="comment">// cubics</span>
<a name="l00589"></a>00589           <span class="keywordflow">case</span> 6:
<a name="l00590"></a>00590             <span class="keywordflow">return</span> 0.;
<a name="l00591"></a>00591             
<a name="l00592"></a>00592           <span class="keywordflow">case</span> 7:
<a name="l00593"></a>00593             <span class="keywordflow">return</span> 0.;
<a name="l00594"></a>00594             
<a name="l00595"></a>00595           <span class="keywordflow">case</span> 8:
<a name="l00596"></a>00596             <span class="keywordflow">return</span> 2.*dx;
<a name="l00597"></a>00597             
<a name="l00598"></a>00598           <span class="keywordflow">case</span> 9:
<a name="l00599"></a>00599             <span class="keywordflow">return</span> 6.*dy;
<a name="l00600"></a>00600             
<a name="l00601"></a>00601             <span class="comment">// quartics</span>
<a name="l00602"></a>00602           <span class="keywordflow">case</span> 10:
<a name="l00603"></a>00603           <span class="keywordflow">case</span> 11:
<a name="l00604"></a>00604             <span class="keywordflow">return</span> 0.;
<a name="l00605"></a>00605             
<a name="l00606"></a>00606           <span class="keywordflow">case</span> 12:
<a name="l00607"></a>00607             <span class="keywordflow">return</span> 2.*dx*dx;
<a name="l00608"></a>00608             
<a name="l00609"></a>00609           <span class="keywordflow">case</span> 13:
<a name="l00610"></a>00610             <span class="keywordflow">return</span> 6.*dx*dy;
<a name="l00611"></a>00611             
<a name="l00612"></a>00612           <span class="keywordflow">case</span> 14:
<a name="l00613"></a>00613             <span class="keywordflow">return</span> 12.*dy*dy;
<a name="l00614"></a>00614             
<a name="l00615"></a>00615           <span class="keywordflow">default</span>:
<a name="l00616"></a>00616             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o = 0;
<a name="l00617"></a>00617             <span class="keywordflow">for</span> (; i &gt;= (o+1)*(o+2)/2; o++) { }
<a name="l00618"></a>00618             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i2 = i - (o*(o+1)/2);
<a name="l00619"></a>00619             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> val = i2 * (i2 - 1);
<a name="l00620"></a>00620             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=i2; index != o; index++)
<a name="l00621"></a>00621               val *= dx;
<a name="l00622"></a>00622             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=2; index &lt; i2; index++)
<a name="l00623"></a>00623               val *= dy;
<a name="l00624"></a>00624             <span class="keywordflow">return</span> val;
<a name="l00625"></a>00625           }
<a name="l00626"></a>00626       }
<a name="l00627"></a>00627     }
<a name="l00628"></a>00628 
<a name="l00629"></a>00629   libmesh_error();
<a name="l00630"></a>00630   <span class="keywordflow">return</span> 0.;
<a name="l00631"></a>00631 
<a name="l00632"></a>00632 <span class="preprocessor">#endif</span>
<a name="l00633"></a>00633 <span class="preprocessor"></span>}
<a name="l00634"></a>00634 
<a name="l00635"></a>00635 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
