<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fem_context.C</div>  </div>
</div>
<div class="contents">
<a href="fem__context_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fem_context.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="unsteady__solver_8h.php">unsteady_solver.h</a>&quot;</span> <span class="comment">// For euler_residual</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a39161119feee2afc249ae4729820113a">00041</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a39161119feee2afc249ae4729820113a">FEMContext::FEMContext</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys)
<a name="l00042"></a>00042   : <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>(sys),
<a name="l00043"></a>00043     element_qrule(NULL), side_qrule(NULL),
<a name="l00044"></a>00044     _mesh_sys(sys.get_mesh_system()),
<a name="l00045"></a>00045     _mesh_x_var(sys.get_mesh_x_var()),
<a name="l00046"></a>00046     _mesh_y_var(sys.get_mesh_y_var()),
<a name="l00047"></a>00047     _mesh_z_var(sys.get_mesh_z_var()),
<a name="l00048"></a>00048     elem(NULL), <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(0), dim(sys.get_mesh().mesh_dimension())
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="comment">// We need to know which of our variables has the hardest</span>
<a name="l00051"></a>00051   <span class="comment">// shape functions to numerically integrate.</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = sys.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   libmesh_assert (n_vars);
<a name="l00056"></a>00056   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> hardest_fe_type = sys.<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(0);
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; ++i)
<a name="l00059"></a>00059     {
<a name="l00060"></a>00060       <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = sys.<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(i);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062       <span class="comment">// FIXME - we don&#39;t yet handle mixed finite elements from</span>
<a name="l00063"></a>00063       <span class="comment">// different families which require different quadrature rules</span>
<a name="l00064"></a>00064       <span class="comment">// libmesh_assert (fe_type.family == hardest_fe_type.family);</span>
<a name="l00065"></a>00065 
<a name="l00066"></a>00066       <span class="keywordflow">if</span> (fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> &gt; hardest_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a>)
<a name="l00067"></a>00067         hardest_fe_type = fe_type;
<a name="l00068"></a>00068     }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// Create an adequate quadrature rule</span>
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a> = hardest_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a>
<a name="l00072"></a>00072     (<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>, sys.<a class="code" href="classlibMesh_1_1System.php#a078ffa703ae75f9e2505b4177af2e530">extra_quadrature_order</a>).<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1FEMContext.php#aac937c748b14aef867fc6f83f51a9d6d">side_qrule</a> = hardest_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a>
<a name="l00074"></a>00074     (<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>-1, sys.<a class="code" href="classlibMesh_1_1System.php#a078ffa703ae75f9e2505b4177af2e530">extra_quadrature_order</a>).<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// Next, create finite element objects</span>
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>.resize(n_vars);
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>.resize(n_vars);
<a name="l00079"></a>00079   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; ++i)
<a name="l00080"></a>00080     {
<a name="l00081"></a>00081       <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = sys.<a class="code" href="classlibMesh_1_1System.php#ab321ab954fa1284069a647b311ff6d17">variable_type</a>(i);
<a name="l00082"></a>00082       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>[fe_type] == NULL)
<a name="l00083"></a>00083         {
<a name="l00084"></a>00084           <a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>[fe_type] = <a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>, fe_type).<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00085"></a>00085           <a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>[fe_type]-&gt;attach_quadrature_rule(<a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a>);
<a name="l00086"></a>00086           <a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">side_fe</a>[fe_type] = <a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>, fe_type).<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00087"></a>00087           <a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">side_fe</a>[fe_type]-&gt;attach_quadrature_rule(<a class="code" href="classlibMesh_1_1FEMContext.php#aac937c748b14aef867fc6f83f51a9d6d">side_qrule</a>);
<a name="l00088"></a>00088         }
<a name="l00089"></a>00089       <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[i] = <a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>[fe_type];
<a name="l00090"></a>00090       <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>[i] = <a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">side_fe</a>[fe_type];
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ab50fc20fd16cabb45dbce3671543cc83">00095</a> <a class="code" href="classlibMesh_1_1FEMContext.php#ab50fc20fd16cabb45dbce3671543cc83">FEMContext::~FEMContext</a>()
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   <span class="comment">// We don&#39;t want to store AutoPtrs in STL containers, but we don&#39;t</span>
<a name="l00098"></a>00098   <span class="comment">// want to leak memory either</span>
<a name="l00099"></a>00099   <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i = <a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>.begin();
<a name="l00100"></a>00100        i != <a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>.end(); ++i)
<a name="l00101"></a>00101     <span class="keyword">delete</span> i-&gt;second;
<a name="l00102"></a>00102   <a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>.clear();
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i = <a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">side_fe</a>.begin();
<a name="l00105"></a>00105        i != <a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">side_fe</a>.end(); ++i)
<a name="l00106"></a>00106     <span class="keyword">delete</span> i-&gt;second;
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">side_fe</a>.clear();
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a>;
<a name="l00110"></a>00110   <a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a> = NULL;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1FEMContext.php#aac937c748b14aef867fc6f83f51a9d6d">side_qrule</a>;
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1FEMContext.php#aac937c748b14aef867fc6f83f51a9d6d">side_qrule</a> = NULL;
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a15df99c408b61d4d93bc18c5ecbde22c">00118</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a15df99c408b61d4d93bc18c5ecbde22c">FEMContext::interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00119"></a>00119 {
<a name="l00120"></a>00120   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00121"></a>00121   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00122"></a>00122   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// Get current local coefficients</span>
<a name="l00125"></a>00125   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.size() &gt; var);
<a name="l00126"></a>00126   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var] != NULL);
<a name="l00127"></a>00127   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var];
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00130"></a>00130   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00131"></a>00131     <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="comment">// Accumulate solution value</span>
<a name="l00134"></a>00134   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u = 0.;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00137"></a>00137     u += phi[l][qp] * coef(l);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="keywordflow">return</span> u;
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ab600367c74aeef6dc87f5ced048f0035">00144</a> <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1FEMContext.php#ab600367c74aeef6dc87f5ced048f0035">FEMContext::interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00145"></a>00145 {
<a name="l00146"></a>00146   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00147"></a>00147   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00148"></a>00148   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">// Get current local coefficients</span>
<a name="l00151"></a>00151   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.size() &gt; var);
<a name="l00152"></a>00152   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var] != NULL);
<a name="l00153"></a>00153   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var];
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00156"></a>00156   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00157"></a>00157     <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_dphi();
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00160"></a>00160   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> du;
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00163"></a>00163     du.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="keywordflow">return</span> du;
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00171"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a47e13a1412a2a498bd94673ee11987b8">00171</a> <span class="preprocessor"></span><a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a47e13a1412a2a498bd94673ee11987b8">FEMContext::interior_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00172"></a>00172 {
<a name="l00173"></a>00173   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00174"></a>00174   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00175"></a>00175   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// Get current local coefficients</span>
<a name="l00178"></a>00178   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.size() &gt; var);
<a name="l00179"></a>00179   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var] != NULL);
<a name="l00180"></a>00180   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var];
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00183"></a>00183   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; &amp;d2phi =
<a name="l00184"></a>00184     <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_d2phi();
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// Accumulate solution second derivatives</span>
<a name="l00187"></a>00187   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> d2u;
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00190"></a>00190     d2u.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>(d2phi[l][qp], coef(l));
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="keywordflow">return</span> d2u;
<a name="l00193"></a>00193 }
<a name="l00194"></a>00194 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span>
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ad40e91c90a466fd761784b5dfbf6144f">00198</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#ad40e91c90a466fd761784b5dfbf6144f">FEMContext::side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00199"></a>00199 {
<a name="l00200"></a>00200   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00201"></a>00201   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00202"></a>00202   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <span class="comment">// Get current local coefficients</span>
<a name="l00205"></a>00205   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.size() &gt; var);
<a name="l00206"></a>00206   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var] != NULL);
<a name="l00207"></a>00207   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var];
<a name="l00208"></a>00208 
<a name="l00209"></a>00209   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00210"></a>00210   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00211"></a>00211     <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>[var]-&gt;get_phi();
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="comment">// Accumulate solution value</span>
<a name="l00214"></a>00214   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u = 0.;
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00217"></a>00217     u += phi[l][qp] * coef(l);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="keywordflow">return</span> u;
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a7b1b3cd035a2ac97cc6b8ffc8cc91a15">00224</a> <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a7b1b3cd035a2ac97cc6b8ffc8cc91a15">FEMContext::side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00225"></a>00225 {
<a name="l00226"></a>00226   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00227"></a>00227   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00228"></a>00228   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00229"></a>00229 
<a name="l00230"></a>00230   <span class="comment">// Get current local coefficients</span>
<a name="l00231"></a>00231   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.size() &gt; var);
<a name="l00232"></a>00232   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var] != NULL);
<a name="l00233"></a>00233   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var];
<a name="l00234"></a>00234 
<a name="l00235"></a>00235   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00236"></a>00236   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00237"></a>00237     <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>[var]-&gt;get_dphi();
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00240"></a>00240   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> du;
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00243"></a>00243     du.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <span class="keywordflow">return</span> du;
<a name="l00246"></a>00246 }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00251"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a7039d9ce7eac2a6bacf0103c624f6bea">00251</a> <span class="preprocessor"></span><a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a7039d9ce7eac2a6bacf0103c624f6bea">FEMContext::side_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00252"></a>00252 {
<a name="l00253"></a>00253   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00254"></a>00254   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00255"></a>00255   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="comment">// Get current local coefficients</span>
<a name="l00258"></a>00258   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.size() &gt; var);
<a name="l00259"></a>00259   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var] != NULL);
<a name="l00260"></a>00260   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var];
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00263"></a>00263   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; &amp;d2phi =
<a name="l00264"></a>00264     <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>[var]-&gt;get_d2phi();
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <span class="comment">// Accumulate solution second derivatives</span>
<a name="l00267"></a>00267   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> d2u;
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00270"></a>00270     d2u.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>(d2phi[l][qp], coef(l));
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="keywordflow">return</span> d2u;
<a name="l00273"></a>00273 }
<a name="l00274"></a>00274 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00275"></a>00275 <span class="preprocessor"></span>
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a52384036e0dd6401a3a833d9ed7a4922">00278</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a52384036e0dd6401a3a833d9ed7a4922">FEMContext::point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p)
<a name="l00279"></a>00279 {
<a name="l00280"></a>00280   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00281"></a>00281   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00282"></a>00282   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   
<a name="l00285"></a>00285   <span class="comment">// Get current local coefficients</span>
<a name="l00286"></a>00286   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>.size() &gt; var);
<a name="l00287"></a>00287   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var] != NULL);
<a name="l00288"></a>00288   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[var];
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u = 0.;
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_fe_type();
<a name="l00293"></a>00293   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p_master = <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>, fe_type, <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>, p);
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00296"></a>00296     u += <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">FEInterface::shape</a>(<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>, fe_type, <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>, l, p_master)
<a name="l00297"></a>00297          * coef(l);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="keywordflow">return</span> u;
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a081edfb32181200e3718c188188e6798">00304</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a081edfb32181200e3718c188188e6798">FEMContext::fixed_interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00305"></a>00305 {
<a name="l00306"></a>00306   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00307"></a>00307   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00308"></a>00308   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="comment">// Get current local coefficients</span>
<a name="l00311"></a>00311   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00312"></a>00312   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00313"></a>00313   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var];
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00316"></a>00316   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00317"></a>00317     <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <span class="comment">// Accumulate solution value</span>
<a name="l00320"></a>00320   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u = 0.;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00323"></a>00323     u += phi[l][qp] * coef(l);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="keywordflow">return</span> u;
<a name="l00326"></a>00326 }
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a><a class="code" href="classlibMesh_1_1FEMContext.php#af7bc72cd337072ac1d628004c374d013">00330</a> <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1FEMContext.php#af7bc72cd337072ac1d628004c374d013">FEMContext::fixed_interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00331"></a>00331 {
<a name="l00332"></a>00332   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00333"></a>00333   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00334"></a>00334   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// Get current local coefficients</span>
<a name="l00337"></a>00337   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00338"></a>00338   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00339"></a>00339   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var];
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00342"></a>00342   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00343"></a>00343     <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_dphi();
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00346"></a>00346   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> du;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00349"></a>00349     du.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="keywordflow">return</span> du;
<a name="l00352"></a>00352 }
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00357"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a565e3c890acadc344c18df57f0709af2">00357</a> <span class="preprocessor"></span><a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a565e3c890acadc344c18df57f0709af2">FEMContext::fixed_interior_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00358"></a>00358 {
<a name="l00359"></a>00359   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00360"></a>00360   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00361"></a>00361   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="comment">// Get current local coefficients</span>
<a name="l00364"></a>00364   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00365"></a>00365   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00366"></a>00366   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var];
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00369"></a>00369   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; &amp;d2phi =
<a name="l00370"></a>00370     <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_d2phi();
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   <span class="comment">// Accumulate solution second derivatives</span>
<a name="l00373"></a>00373   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> d2u;
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00376"></a>00376     d2u.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>(d2phi[l][qp], coef(l));
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   <span class="keywordflow">return</span> d2u;
<a name="l00379"></a>00379 }
<a name="l00380"></a>00380 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00381"></a>00381 <span class="preprocessor"></span>
<a name="l00382"></a>00382 
<a name="l00383"></a>00383 
<a name="l00384"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ae524a905037fe3253e5af4fda0cb5549">00384</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#ae524a905037fe3253e5af4fda0cb5549">FEMContext::fixed_side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00385"></a>00385 {
<a name="l00386"></a>00386   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00387"></a>00387   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00388"></a>00388   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <span class="comment">// Get current local coefficients</span>
<a name="l00391"></a>00391   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00392"></a>00392   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00393"></a>00393   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var];
<a name="l00394"></a>00394 
<a name="l00395"></a>00395   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00396"></a>00396   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l00397"></a>00397     <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>[var]-&gt;get_phi();
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="comment">// Accumulate solution value</span>
<a name="l00400"></a>00400   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u = 0.;
<a name="l00401"></a>00401 
<a name="l00402"></a>00402   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00403"></a>00403     u += phi[l][qp] * coef(l);
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="keywordflow">return</span> u;
<a name="l00406"></a>00406 }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a6e32b07742cc44b875cdd9207b66825c">00410</a> <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a6e32b07742cc44b875cdd9207b66825c">FEMContext::fixed_side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00411"></a>00411 {
<a name="l00412"></a>00412   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00413"></a>00413   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00414"></a>00414   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   <span class="comment">// Get current local coefficients</span>
<a name="l00417"></a>00417   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00418"></a>00418   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00419"></a>00419   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var];
<a name="l00420"></a>00420 
<a name="l00421"></a>00421   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00422"></a>00422   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00423"></a>00423     <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>[var]-&gt;get_dphi();
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="comment">// Accumulate solution derivatives</span>
<a name="l00426"></a>00426   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> du;
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00429"></a>00429     du.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>(dphi[l][qp], coef(l));
<a name="l00430"></a>00430 
<a name="l00431"></a>00431   <span class="keywordflow">return</span> du;
<a name="l00432"></a>00432 }
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00437"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a3c37d01eac585aeba73a8632196f8282">00437</a> <span class="preprocessor"></span><a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a3c37d01eac585aeba73a8632196f8282">FEMContext::fixed_side_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp)
<a name="l00438"></a>00438 {
<a name="l00439"></a>00439   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00440"></a>00440   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00441"></a>00441   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="comment">// Get current local coefficients</span>
<a name="l00444"></a>00444   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00445"></a>00445   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00446"></a>00446   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var];
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <span class="comment">// Get shape function values at quadrature point</span>
<a name="l00449"></a>00449   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; &amp;d2phi =
<a name="l00450"></a>00450     <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>[var]-&gt;get_d2phi();
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   <span class="comment">// Accumulate solution second derivatives</span>
<a name="l00453"></a>00453   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> d2u;
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00456"></a>00456     d2u.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>(d2phi[l][qp], coef(l));
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   <span class="keywordflow">return</span> d2u;
<a name="l00459"></a>00459 }
<a name="l00460"></a>00460 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00461"></a>00461 <span class="preprocessor"></span>
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a><a class="code" href="classlibMesh_1_1FEMContext.php#afc2a5b1d70569251870069c16298d636">00464</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#afc2a5b1d70569251870069c16298d636">FEMContext::fixed_point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p)
<a name="l00465"></a>00465 {
<a name="l00466"></a>00466   <span class="comment">// Get local-to-global dof index lookup</span>
<a name="l00467"></a>00467   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size() &gt; var);
<a name="l00468"></a>00468   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   
<a name="l00471"></a>00471   <span class="comment">// Get current local coefficients</span>
<a name="l00472"></a>00472   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>.size() &gt; var);
<a name="l00473"></a>00473   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var] != NULL);
<a name="l00474"></a>00474   <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;coef = *<a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[var];
<a name="l00475"></a>00475 
<a name="l00476"></a>00476   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u = 0.;
<a name="l00477"></a>00477 
<a name="l00478"></a>00478   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> fe_type = <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_fe_type();
<a name="l00479"></a>00479   <a class="code" href="classlibMesh_1_1Point.php">Point</a> p_master = <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a>(<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>, fe_type, <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>, p);
<a name="l00480"></a>00480 
<a name="l00481"></a>00481   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != n_dofs; l++)
<a name="l00482"></a>00482     u += <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">FEInterface::shape</a>(<a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>, fe_type, <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>, l, p_master)
<a name="l00483"></a>00483          * coef(l);
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   <span class="keywordflow">return</span> u;
<a name="l00486"></a>00486 }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a>00489 
<a name="l00490"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a454c11f147a3739bc1fdf048d2aefc71">00490</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a454c11f147a3739bc1fdf048d2aefc71">FEMContext::elem_reinit</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta)
<a name="l00491"></a>00491 {
<a name="l00492"></a>00492   <span class="comment">// Update the &quot;time&quot; variable of this context object</span>
<a name="l00493"></a>00493   this-&gt;<a class="code" href="classlibMesh_1_1FEMContext.php#a98b1f1f3810e44df6819d2a09de930b5">_update_time_from_system</a>(theta);
<a name="l00494"></a>00494   
<a name="l00495"></a>00495   <span class="comment">// Handle a moving element if necessary.</span>
<a name="l00496"></a>00496   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#afda7ec3e8d6eb6d63cb663adc5012c3d">_mesh_sys</a>)
<a name="l00497"></a>00497     <span class="comment">// We assume that the ``default&#39;&#39; state</span>
<a name="l00498"></a>00498     <span class="comment">// of the mesh is its final, theta=1.0</span>
<a name="l00499"></a>00499     <span class="comment">// position, so we don&#39;t bother with</span>
<a name="l00500"></a>00500     <span class="comment">// mesh motion in that case.</span>
<a name="l00501"></a>00501     <span class="keywordflow">if</span> (theta != 1.0)
<a name="l00502"></a>00502       {
<a name="l00503"></a>00503         <span class="comment">// FIXME - ALE is not threadsafe yet!</span>
<a name="l00504"></a>00504         libmesh_assert(<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() == 1);
<a name="l00505"></a>00505 
<a name="l00506"></a>00506         <a class="code" href="classlibMesh_1_1FEMContext.php#a8e1184906e1ececc08b33c3530f1a4a0">elem_position_set</a>(theta);
<a name="l00507"></a>00507       }
<a name="l00508"></a>00508   <a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00509"></a>00509 }
<a name="l00510"></a>00510 
<a name="l00511"></a>00511 
<a name="l00512"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a93696ef373f9ef372e31a9208c1587f4">00512</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a93696ef373f9ef372e31a9208c1587f4">FEMContext::elem_side_reinit</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta)
<a name="l00513"></a>00513 {
<a name="l00514"></a>00514   <span class="comment">// Update the &quot;time&quot; variable of this context object</span>
<a name="l00515"></a>00515   this-&gt;<a class="code" href="classlibMesh_1_1FEMContext.php#a98b1f1f3810e44df6819d2a09de930b5">_update_time_from_system</a>(theta);
<a name="l00516"></a>00516   
<a name="l00517"></a>00517   <span class="comment">// Handle a moving element if necessary</span>
<a name="l00518"></a>00518   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#afda7ec3e8d6eb6d63cb663adc5012c3d">_mesh_sys</a>)
<a name="l00519"></a>00519     {
<a name="l00520"></a>00520       <span class="comment">// FIXME - not threadsafe yet!</span>
<a name="l00521"></a>00521       <a class="code" href="classlibMesh_1_1FEMContext.php#a8e1184906e1ececc08b33c3530f1a4a0">elem_position_set</a>(theta);
<a name="l00522"></a>00522       <a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">side_fe_reinit</a>();
<a name="l00523"></a>00523     }
<a name="l00524"></a>00524 }
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">00527</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">FEMContext::elem_fe_reinit</a> ()
<a name="l00528"></a>00528 {
<a name="l00529"></a>00529   <span class="comment">// Initialize all the interior FE objects on elem.</span>
<a name="l00530"></a>00530   <span class="comment">// Logging of FE::reinit is done in the FE functions</span>
<a name="l00531"></a>00531   std::map&lt;FEType, FEBase *&gt;::iterator fe_end = <a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>.end();
<a name="l00532"></a>00532   <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i = <a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>.begin();
<a name="l00533"></a>00533        i != fe_end; ++i)
<a name="l00534"></a>00534     {
<a name="l00535"></a>00535       i-&gt;second-&gt;reinit(<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>);
<a name="l00536"></a>00536     }
<a name="l00537"></a>00537 }
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">00540</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">FEMContext::side_fe_reinit</a> ()
<a name="l00541"></a>00541 {
<a name="l00542"></a>00542   <span class="comment">// Initialize all the interior FE objects on elem/side.</span>
<a name="l00543"></a>00543   <span class="comment">// Logging of FE::reinit is done in the FE functions</span>
<a name="l00544"></a>00544   std::map&lt;FEType, FEBase *&gt;::iterator fe_end = <a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">side_fe</a>.end();
<a name="l00545"></a>00545   <span class="keywordflow">for</span> (std::map&lt;FEType, FEBase *&gt;::iterator i = <a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">side_fe</a>.begin();
<a name="l00546"></a>00546        i != fe_end; ++i)
<a name="l00547"></a>00547     {
<a name="l00548"></a>00548       i-&gt;second-&gt;reinit(<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>, <a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>);
<a name="l00549"></a>00549     }
<a name="l00550"></a>00550 }
<a name="l00551"></a>00551 
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 
<a name="l00554"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a7a6f5aef1fe3a5ac355ae93c9d0d179e">00554</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a7a6f5aef1fe3a5ac355ae93c9d0d179e">FEMContext::elem_position_get</a>()
<a name="l00555"></a>00555 {
<a name="l00556"></a>00556   <span class="comment">// This is too expensive to call unless we&#39;ve been asked to move the mesh</span>
<a name="l00557"></a>00557   libmesh_assert (<a class="code" href="classlibMesh_1_1FEMContext.php#afda7ec3e8d6eb6d63cb663adc5012c3d">_mesh_sys</a>);
<a name="l00558"></a>00558 
<a name="l00559"></a>00559   <span class="comment">// This will probably break with threading when two contexts are</span>
<a name="l00560"></a>00560   <span class="comment">// operating on elements which share a node</span>
<a name="l00561"></a>00561   libmesh_assert(<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() == 1);
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   <span class="comment">// If the coordinate data is in our own system, it&#39;s already</span>
<a name="l00564"></a>00564   <span class="comment">// been set up for us</span>
<a name="l00565"></a>00565 <span class="comment">//  if (_mesh_sys == this-&gt;number())</span>
<a name="l00566"></a>00566 <span class="comment">//    {</span>
<a name="l00567"></a>00567       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00568"></a>00568       <span class="comment">// For simplicity we demand that mesh coordinates be stored</span>
<a name="l00569"></a>00569       <span class="comment">// in a format that allows a direct copy</span>
<a name="l00570"></a>00570       libmesh_assert(<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00571"></a>00571                      (<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a>]-&gt;get_fe_type().family
<a name="l00572"></a>00572                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00573"></a>00573                       <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a>]-&gt;get_fe_type().order
<a name="l00574"></a>00574                       == <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>()));
<a name="l00575"></a>00575       libmesh_assert(<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00576"></a>00576                      (<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a>]-&gt;get_fe_type().family
<a name="l00577"></a>00577                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00578"></a>00578                       <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a>]-&gt;get_fe_type().order
<a name="l00579"></a>00579                       == <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>()));
<a name="l00580"></a>00580       libmesh_assert(<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00581"></a>00581                      (<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a>]-&gt;get_fe_type().family
<a name="l00582"></a>00582                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00583"></a>00583                       <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a>]-&gt;get_fe_type().order
<a name="l00584"></a>00584                       == <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>()));
<a name="l00585"></a>00585 
<a name="l00586"></a>00586       <span class="comment">// Get degree of freedom coefficients from point coordinates</span>
<a name="l00587"></a>00587       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00588"></a>00588         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++i)
<a name="l00589"></a>00589           (*<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a>])(i) = <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(0);
<a name="l00590"></a>00590 
<a name="l00591"></a>00591       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00592"></a>00592         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++i)
<a name="l00593"></a>00593           (*<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a>])(i) = <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(1);
<a name="l00594"></a>00594 
<a name="l00595"></a>00595       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00596"></a>00596         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++i)
<a name="l00597"></a>00597           (*<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a>])(i) = <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(2);
<a name="l00598"></a>00598 <span class="comment">//    }</span>
<a name="l00599"></a>00599   <span class="comment">// FIXME - If the coordinate data is not in our own system, someone</span>
<a name="l00600"></a>00600   <span class="comment">// had better get around to implementing that... - RHS</span>
<a name="l00601"></a>00601 <span class="comment">//  else</span>
<a name="l00602"></a>00602 <span class="comment">//    {</span>
<a name="l00603"></a>00603 <span class="comment">//      libmesh_not_implemented();</span>
<a name="l00604"></a>00604 <span class="comment">//    }</span>
<a name="l00605"></a>00605 }
<a name="l00606"></a>00606 
<a name="l00607"></a>00607 
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 <span class="comment">// We can ignore the theta argument in the current use of this</span>
<a name="l00610"></a>00610 <span class="comment">// function, because elem_subsolutions will already have been set to</span>
<a name="l00611"></a>00611 <span class="comment">// the theta value.</span>
<a name="l00612"></a>00612 <span class="comment">//</span>
<a name="l00613"></a>00613 <span class="comment">// To enable loose mesh movement coupling things will need to change.</span>
<a name="l00614"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a1212faba8b1bd12507ed75bebff4c1d3">00614</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a1212faba8b1bd12507ed75bebff4c1d3">FEMContext::_do_elem_position_set</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)
<a name="l00615"></a>00615 {
<a name="l00616"></a>00616   <span class="comment">// This is too expensive to call unless we&#39;ve been asked to move the mesh</span>
<a name="l00617"></a>00617   libmesh_assert (<a class="code" href="classlibMesh_1_1FEMContext.php#afda7ec3e8d6eb6d63cb663adc5012c3d">_mesh_sys</a>);
<a name="l00618"></a>00618 
<a name="l00619"></a>00619   <span class="comment">// This will probably break with threading when two contexts are</span>
<a name="l00620"></a>00620   <span class="comment">// operating on elements which share a node</span>
<a name="l00621"></a>00621   libmesh_assert(<a class="code" href="namespacelibMesh.php#afde701cff110e1ff2b158298c06a7d1d">libMesh::n_threads</a>() == 1);
<a name="l00622"></a>00622 
<a name="l00623"></a>00623   <span class="comment">// If the coordinate data is in our own system, it&#39;s already</span>
<a name="l00624"></a>00624   <span class="comment">// been set up for us, and we can ignore our input parameter theta</span>
<a name="l00625"></a>00625 <span class="comment">//  if (_mesh_sys == this-&gt;number())</span>
<a name="l00626"></a>00626 <span class="comment">//    {</span>
<a name="l00627"></a>00627       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00628"></a>00628       <span class="comment">// For simplicity we demand that mesh coordinates be stored</span>
<a name="l00629"></a>00629       <span class="comment">// in a format that allows a direct copy</span>
<a name="l00630"></a>00630       libmesh_assert(<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00631"></a>00631                      (<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a>]-&gt;get_fe_type().family
<a name="l00632"></a>00632                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00633"></a>00633                       <a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a>]-&gt;size() == n_nodes));
<a name="l00634"></a>00634       libmesh_assert(<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00635"></a>00635                      (<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a>]-&gt;get_fe_type().family
<a name="l00636"></a>00636                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00637"></a>00637                       <a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a>]-&gt;size() == n_nodes));
<a name="l00638"></a>00638       libmesh_assert(<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a> ||
<a name="l00639"></a>00639                      (<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a>]-&gt;get_fe_type().family
<a name="l00640"></a>00640                       == <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5aee6cdf9773346876504bcbb02d199ab8">LAGRANGE</a> &amp;&amp;
<a name="l00641"></a>00641                       <a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a>]-&gt;size() == n_nodes));
<a name="l00642"></a>00642 
<a name="l00643"></a>00643       <span class="comment">// Set the new point coordinates</span>
<a name="l00644"></a>00644       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00645"></a>00645         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++i)
<a name="l00646"></a>00646           <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(0) =
<a name="l00647"></a>00647             <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a>])(i));
<a name="l00648"></a>00648 
<a name="l00649"></a>00649       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00650"></a>00650         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++i)
<a name="l00651"></a>00651           <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(1) =
<a name="l00652"></a>00652             <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a>])(i));
<a name="l00653"></a>00653 
<a name="l00654"></a>00654       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00655"></a>00655         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++i)
<a name="l00656"></a>00656           <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(i)(2) =
<a name="l00657"></a>00657             <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a>])(i));
<a name="l00658"></a>00658 <span class="comment">//    }</span>
<a name="l00659"></a>00659   <span class="comment">// FIXME - If the coordinate data is not in our own system, someone</span>
<a name="l00660"></a>00660   <span class="comment">// had better get around to implementing that... - RHS</span>
<a name="l00661"></a>00661 <span class="comment">//  else</span>
<a name="l00662"></a>00662 <span class="comment">//    {</span>
<a name="l00663"></a>00663 <span class="comment">//      libmesh_not_implemented();</span>
<a name="l00664"></a>00664 <span class="comment">//    }</span>
<a name="l00665"></a>00665 }
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 <span class="comment">/*</span>
<a name="l00672"></a>00672 <span class="comment">void FEMContext::reinit(const FEMSystem &amp;sys, Elem *e)</span>
<a name="l00673"></a>00673 <span class="comment">{</span>
<a name="l00674"></a>00674 <span class="comment">  // Initialize our elem pointer, algebraic objects</span>
<a name="l00675"></a>00675 <span class="comment">  this-&gt;pre_fe_reinit(e);</span>
<a name="l00676"></a>00676 <span class="comment"></span>
<a name="l00677"></a>00677 <span class="comment">  // Moving the mesh may be necessary</span>
<a name="l00678"></a>00678 <span class="comment">  // Reinitializing the FE objects is definitely necessary</span>
<a name="l00679"></a>00679 <span class="comment">  this-&gt;elem_reinit(1.);</span>
<a name="l00680"></a>00680 <span class="comment">}</span>
<a name="l00681"></a>00681 <span class="comment">*/</span>
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 
<a name="l00684"></a>00684 
<a name="l00685"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">00685</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">FEMContext::pre_fe_reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e)
<a name="l00686"></a>00686 {
<a name="l00687"></a>00687   <a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a> = e;
<a name="l00688"></a>00688 
<a name="l00689"></a>00689   <span class="comment">// Initialize the per-element data for elem.</span>
<a name="l00690"></a>00690   sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>, <a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00691"></a>00691   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size();
<a name="l00692"></a>00692   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qoi = sys.<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size();
<a name="l00693"></a>00693 
<a name="l00694"></a>00694   <a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(n_dofs);
<a name="l00695"></a>00695   <span class="keywordflow">if</span> (sys.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00696"></a>00696     <a class="code" href="classlibMesh_1_1DiffContext.php#a9b453a5aa8e17abb3d23fadc468515e5">elem_fixed_solution</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(n_dofs);
<a name="l00697"></a>00697 
<a name="l00698"></a>00698   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00699"></a>00699     <a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(i) = sys.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[i]);
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   <span class="comment">// These resize calls also zero out the residual and jacobian</span>
<a name="l00702"></a>00702   <a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(n_dofs);
<a name="l00703"></a>00703   <a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(n_dofs, n_dofs);
<a name="l00704"></a>00704 
<a name="l00705"></a>00705   <a class="code" href="classlibMesh_1_1DiffContext.php#a5fad6a1ca3ce18dd2f11c22b2ad5923a">elem_qoi_derivative</a>.resize(n_qoi);
<a name="l00706"></a>00706   <a class="code" href="classlibMesh_1_1DiffContext.php#a45d1d8941d44174dcb83ba881519d922">elem_qoi_subderivatives</a>.resize(n_qoi);
<a name="l00707"></a>00707   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q != n_qoi; ++q)
<a name="l00708"></a>00708     <a class="code" href="classlibMesh_1_1DiffContext.php#a5fad6a1ca3ce18dd2f11c22b2ad5923a">elem_qoi_derivative</a>[q].resize(n_dofs);
<a name="l00709"></a>00709 
<a name="l00710"></a>00710   <span class="comment">// Initialize the per-variable data for elem.</span>
<a name="l00711"></a>00711   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sub_dofs = 0;
<a name="l00712"></a>00712   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != sys.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); ++i)
<a name="l00713"></a>00713     {
<a name="l00714"></a>00714       sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>, <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i], i);
<a name="l00715"></a>00715 
<a name="l00716"></a>00716       <a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[i]-&gt;reposition
<a name="l00717"></a>00717         (sub_dofs, <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size());
<a name="l00718"></a>00718 
<a name="l00719"></a>00719       <span class="keywordflow">if</span> (sys.<a class="code" href="classlibMesh_1_1System.php#a1fd435eb5b5e949702d92f28df85ea6b">use_fixed_solution</a>)
<a name="l00720"></a>00720         <a class="code" href="classlibMesh_1_1DiffContext.php#a5fb544ed643e96aa685ba8b9bef8a429">elem_fixed_subsolutions</a>[i]-&gt;reposition
<a name="l00721"></a>00721           (sub_dofs, <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size());
<a name="l00722"></a>00722 
<a name="l00723"></a>00723       <a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>[i]-&gt;reposition
<a name="l00724"></a>00724         (sub_dofs, <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size());
<a name="l00725"></a>00725 
<a name="l00726"></a>00726       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> q=0; q != n_qoi; ++q)
<a name="l00727"></a>00727         <a class="code" href="classlibMesh_1_1DiffContext.php#a45d1d8941d44174dcb83ba881519d922">elem_qoi_subderivatives</a>[q][i]-&gt;reposition
<a name="l00728"></a>00728           (sub_dofs, <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size());
<a name="l00729"></a>00729 
<a name="l00730"></a>00730       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != i; ++j)
<a name="l00731"></a>00731         {
<a name="l00732"></a>00732           <a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[i][j]-&gt;reposition
<a name="l00733"></a>00733             (sub_dofs, <a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>[j]-&gt;i_off(),
<a name="l00734"></a>00734              <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size(),
<a name="l00735"></a>00735              <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[j].size());
<a name="l00736"></a>00736           <a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[j][i]-&gt;reposition
<a name="l00737"></a>00737             (<a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>[j]-&gt;i_off(), sub_dofs,
<a name="l00738"></a>00738              <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[j].size(),
<a name="l00739"></a>00739              <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size());
<a name="l00740"></a>00740         }
<a name="l00741"></a>00741       <a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[i][i]-&gt;reposition
<a name="l00742"></a>00742         (sub_dofs, sub_dofs,
<a name="l00743"></a>00743          <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size(),
<a name="l00744"></a>00744          <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size());
<a name="l00745"></a>00745       sub_dofs += <a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[i].size();
<a name="l00746"></a>00746     }
<a name="l00747"></a>00747   libmesh_assert(sub_dofs == n_dofs);
<a name="l00748"></a>00748 }
<a name="l00749"></a>00749 
<a name="l00750"></a>00750 
<a name="l00751"></a>00751 
<a name="l00752"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a98b1f1f3810e44df6819d2a09de930b5">00752</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a98b1f1f3810e44df6819d2a09de930b5">FEMContext::_update_time_from_system</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta)
<a name="l00753"></a>00753 {
<a name="l00754"></a>00754   <span class="comment">// Update the &quot;time&quot; variable based on the value of theta.  For this</span>
<a name="l00755"></a>00755   <span class="comment">// to work, we need to know the value of deltat, a pointer to which is now</span>
<a name="l00756"></a>00756   <span class="comment">// stored by our parent DiffContext class.  Note: get_deltat_value() will</span>
<a name="l00757"></a>00757   <span class="comment">// assert in debug mode if the requested pointer is NULL.</span>
<a name="l00758"></a>00758   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> deltat = this-&gt;<a class="code" href="classlibMesh_1_1DiffContext.php#a79812d270f452cf404caa7285025aac4">get_deltat_value</a>();
<a name="l00759"></a>00759 
<a name="l00760"></a>00760   this-&gt;<a class="code" href="classlibMesh_1_1DiffContext.php#a0fc3fa18d4c4c3ffdda4cc77402a2c75">time</a> = theta*(this-&gt;<a class="code" href="classlibMesh_1_1DiffContext.php#a2ca16f4474c6c1ff8bd2abe4c170ebfe">system_time</a> + deltat) + (1.-theta)*this-&gt;<a class="code" href="classlibMesh_1_1DiffContext.php#a2ca16f4474c6c1ff8bd2abe4c170ebfe">system_time</a>;
<a name="l00761"></a>00761 }
<a name="l00762"></a>00762 
<a name="l00763"></a>00763 
<a name="l00764"></a>00764 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
