<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fem_context.h</div>  </div>
</div>
<div class="contents">
<a href="fem__context_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: fem_context.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __fem_context_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __fem_context_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="diff__context_8h.php">diff_context.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="vector__value_8h.php">vector_value.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="fe__type_8h.php">fe_type.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#endif</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span>
<a name="l00038"></a>00038 <span class="keyword">namespace </span>libMesh
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041   <span class="comment">// Forward Declarations</span>
<a name="l00042"></a>00042   <span class="keyword">class </span>Elem;
<a name="l00043"></a>00043   <span class="keyword">class </span>FEBase;
<a name="l00044"></a>00044   <span class="keyword">class </span>QBase;
<a name="l00045"></a>00045   <span class="keyword">class </span>Point;
<a name="l00046"></a>00046   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00047"></a>00047 
<a name="l00060"></a>00060 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00061"></a>00061 <span class="comment">// FEMContext class definition</span>
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1FEMContext.php">00063</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065 <span class="keyword">public</span>:
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <a class="code" href="classlibMesh_1_1FEMContext.php#a39161119feee2afc249ae4729820113a">FEMContext</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys);
<a name="l00071"></a>00071 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1FEMContext.php#ab50fc20fd16cabb45dbce3671543cc83">~FEMContext</a> ();
<a name="l00076"></a>00076 
<a name="l00081"></a>00081   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a15df99c408b61d4d93bc18c5ecbde22c">interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00082"></a>00082 
<a name="l00087"></a>00087   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#ad40e91c90a466fd761784b5dfbf6144f">side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00088"></a>00088 
<a name="l00093"></a>00093   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a52384036e0dd6401a3a833d9ed7a4922">point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p);
<a name="l00094"></a>00094 
<a name="l00099"></a>00099   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1FEMContext.php#ab600367c74aeef6dc87f5ced048f0035">interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00100"></a>00100 
<a name="l00105"></a>00105   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a7b1b3cd035a2ac97cc6b8ffc8cc91a15">side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a47e13a1412a2a498bd94673ee11987b8">interior_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00113"></a>00113 
<a name="l00118"></a>00118   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a7039d9ce7eac2a6bacf0103c624f6bea">side_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="preprocessor">#endif // LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span>
<a name="l00126"></a>00126   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a081edfb32181200e3718c188188e6798">fixed_interior_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00127"></a>00127 
<a name="l00132"></a>00132   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#ae524a905037fe3253e5af4fda0cb5549">fixed_side_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00133"></a>00133 
<a name="l00138"></a>00138   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FEMContext.php#afc2a5b1d70569251870069c16298d636">fixed_point_value</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;p);
<a name="l00139"></a>00139 
<a name="l00144"></a>00144   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1FEMContext.php#af7bc72cd337072ac1d628004c374d013">fixed_interior_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00145"></a>00145 
<a name="l00150"></a>00150   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a6e32b07742cc44b875cdd9207b66825c">fixed_side_gradient</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>
<a name="l00157"></a>00157   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a565e3c890acadc344c18df57f0709af2">fixed_interior_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00158"></a>00158 
<a name="l00163"></a>00163   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1FEMContext.php#a3c37d01eac585aeba73a8632196f8282">fixed_side_hessian</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp);
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="preprocessor">#endif // LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>
<a name="l00171"></a>00171 <span class="comment">//  virtual void reinit(const FEMSystem&amp;, Elem*);</span>
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 <span class="comment">// should be protected:</span>
<a name="l00179"></a>00179 <span class="comment"></span>  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a454c11f147a3739bc1fdf048d2aefc71">elem_reinit</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta);
<a name="l00180"></a>00180 
<a name="l00186"></a>00186   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a93696ef373f9ef372e31a9208c1587f4">elem_side_reinit</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta);
<a name="l00187"></a>00187 
<a name="l00191"></a>00191   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;, <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e);
<a name="l00192"></a>00192 
<a name="l00196"></a>00196   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00197"></a>00197 
<a name="l00201"></a>00201   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">side_fe_reinit</a>();
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 <span class="comment">// should be protected?:</span>
<a name="l00207"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">00207</a> <span class="comment"></span>  std::map&lt;FEType, FEBase *&gt; <a class="code" href="classlibMesh_1_1FEMContext.php#ab5d0d82e886e27bc8fec460b043049f3">element_fe</a>;
<a name="l00208"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">00208</a>   std::map&lt;FEType, FEBase *&gt; <a class="code" href="classlibMesh_1_1FEMContext.php#ab1c0f0565538b0075e19e6253189be72">side_fe</a>;
<a name="l00209"></a>00209 
<a name="l00214"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">00214</a>   std::vector&lt;FEBase *&gt; <a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>;
<a name="l00215"></a><a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">00215</a>   std::vector&lt;FEBase *&gt; <a class="code" href="classlibMesh_1_1FEMContext.php#aa644b54642e805d250857318efddb969">side_fe_var</a>;
<a name="l00216"></a>00216 
<a name="l00222"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">00222</a>   <a class="code" href="classlibMesh_1_1QBase.php">QBase</a> *<a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a>;
<a name="l00223"></a><a class="code" href="classlibMesh_1_1FEMContext.php#aac937c748b14aef867fc6f83f51a9d6d">00223</a>   <a class="code" href="classlibMesh_1_1QBase.php">QBase</a> *<a class="code" href="classlibMesh_1_1FEMContext.php#aac937c748b14aef867fc6f83f51a9d6d">side_qrule</a>;
<a name="l00224"></a>00224 
<a name="l00230"></a>00230   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a8e1184906e1ececc08b33c3530f1a4a0">elem_position_set</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta);
<a name="l00231"></a>00231 
<a name="l00236"></a>00236   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a7a6f5aef1fe3a5ac355ae93c9d0d179e">elem_position_get</a>();
<a name="l00237"></a>00237 
<a name="l00241"></a><a class="code" href="classlibMesh_1_1FEMContext.php#afda7ec3e8d6eb6d63cb663adc5012c3d">00241</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> *<a class="code" href="classlibMesh_1_1FEMContext.php#afda7ec3e8d6eb6d63cb663adc5012c3d">_mesh_sys</a>;
<a name="l00242"></a>00242 
<a name="l00246"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">00246</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a137e9ee1b77162edb9d2d61c69f1adb9">_mesh_x_var</a>, <a class="code" href="classlibMesh_1_1FEMContext.php#a377da4ccade11c0046c527e6fa756892">_mesh_y_var</a>, <a class="code" href="classlibMesh_1_1FEMContext.php#ab19d4c2d25c71ff753612c8e2e8f4587">_mesh_z_var</a>;
<a name="l00247"></a>00247 
<a name="l00251"></a><a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">00251</a>   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>;
<a name="l00252"></a>00252 
<a name="l00256"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">00256</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>;
<a name="l00257"></a>00257 
<a name="l00261"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">00261</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a0f3b4c6fec7a890efe1ceebcec8ad2e9">dim</a>;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 <span class="keyword">private</span>:
<a name="l00272"></a>00272   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a1212faba8b1bd12507ed75bebff4c1d3">_do_elem_position_set</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta);
<a name="l00273"></a>00273   
<a name="l00279"></a>00279   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a98b1f1f3810e44df6819d2a09de930b5">_update_time_from_system</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta);
<a name="l00280"></a>00280 };
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00285"></a>00285 <span class="comment">// FEMContext inline methods</span>
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 <span class="keyword">inline</span>
<a name="l00290"></a><a class="code" href="classlibMesh_1_1FEMContext.php#a8e1184906e1ececc08b33c3530f1a4a0">00290</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMContext.php#a8e1184906e1ececc08b33c3530f1a4a0">FEMContext::elem_position_set</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta)
<a name="l00291"></a>00291 {
<a name="l00292"></a>00292   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMContext.php#afda7ec3e8d6eb6d63cb663adc5012c3d">_mesh_sys</a>)
<a name="l00293"></a>00293     this-&gt;<a class="code" href="classlibMesh_1_1FEMContext.php#a1212faba8b1bd12507ed75bebff4c1d3">_do_elem_position_set</a>(theta);
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 } <span class="comment">// namespace libMesh</span>
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
