<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fem_system.C</div>  </div>
</div>
<div class="contents">
<a href="fem__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fem_system.C 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="fem__context_8h.php">fem_context.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="fem__system_8h.php">fem_system.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="time__solver_8h.php">time_solver.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="unsteady__solver_8h.php">unsteady_solver.h</a>&quot;</span> <span class="comment">// For eulerian_residual</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a6a2ed16b3026fb1719e44d9128d1e9e5">00044</a> <a class="code" href="classlibMesh_1_1FEMSystem.php#a6a2ed16b3026fb1719e44d9128d1e9e5">FEMSystem::FEMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00045"></a>00045                       <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00046"></a>00046                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number)
<a name="l00047"></a>00047   : <a class="code" href="classlibMesh_1_1ImplicitSystem.php">Parent</a>(es, name, number),
<a name="l00048"></a>00048     fe_reinit_during_postprocess(true),
<a name="l00049"></a>00049     numerical_jacobian_h(1.e-6),
<a name="l00050"></a>00050     verify_analytic_jacobians(0.0)
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a754c3896a0b7c7a426bc2b272888de96">00055</a> <a class="code" href="classlibMesh_1_1FEMSystem.php#a754c3896a0b7c7a426bc2b272888de96">FEMSystem::~FEMSystem</a> ()
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a18808e75d1ea6c77321edd13a88c2af8">clear</a>();
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a18808e75d1ea6c77321edd13a88c2af8">00062</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a18808e75d1ea6c77321edd13a88c2af8">FEMSystem::clear</a>()
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab4ab534276ae950c906b238e38c7b3d9">Parent::clear</a>();
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a98c0176dcaa48e80b848e49987b9e6f8">00069</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a98c0176dcaa48e80b848e49987b9e6f8">FEMSystem::init_data</a> ()
<a name="l00070"></a>00070 {
<a name="l00071"></a>00071   <span class="comment">// First initialize LinearImplicitSystem data</span>
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab95f6ccd3684f3ad3423ae466bf4e8cd">Parent::init_data</a>();
<a name="l00073"></a>00073 }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#af3303ea7a8722e00389473f4094660d7">00076</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#af3303ea7a8722e00389473f4094660d7">FEMSystem::assembly</a> (<span class="keywordtype">bool</span> get_residual, <span class="keywordtype">bool</span> get_jacobian)
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   libmesh_assert(get_residual || get_jacobian);
<a name="l00079"></a>00079   std::string log_name;
<a name="l00080"></a>00080   <span class="keywordflow">if</span> (get_residual &amp;&amp; get_jacobian)
<a name="l00081"></a>00081     log_name = <span class="stringliteral">&quot;assembly()&quot;</span>;
<a name="l00082"></a>00082   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (get_residual)
<a name="l00083"></a>00083     log_name = <span class="stringliteral">&quot;assembly(get_residual)&quot;</span>;
<a name="l00084"></a>00084   <span class="keywordflow">else</span>
<a name="l00085"></a>00085     log_name = <span class="stringliteral">&quot;assembly(get_jacobian)&quot;</span>;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   START_LOG(log_name, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="comment">//  this-&gt;get_vector(&quot;_nonlinear_solution&quot;).localize</span>
<a name="l00092"></a>00092 <span class="comment">//    (*current_local_nonlinear_solution,</span>
<a name="l00093"></a>00093 <span class="comment">//     dof_map.get_send_list());</span>
<a name="l00094"></a>00094   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a724e8442b2bc0b3a07e5e82051ce7f9e">print_solution_norms</a>)
<a name="l00097"></a>00097     {
<a name="l00098"></a>00098 <span class="comment">//      this-&gt;get_vector(&quot;_nonlinear_solution&quot;).close();</span>
<a name="l00099"></a>00099       this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00100"></a>00100       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;|U| = &quot;</span>
<a name="l00101"></a>00101 <span class="comment">//                    &lt;&lt; this-&gt;get_vector(&quot;_nonlinear_solution&quot;).l1_norm()</span>
<a name="l00102"></a>00102                     &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;l1_norm()
<a name="l00103"></a>00103                     &lt;&lt; std::endl;
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a94c17d5708132f067a3224019af8ce58">print_solutions</a>)
<a name="l00106"></a>00106     {
<a name="l00107"></a>00107       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>();
<a name="l00108"></a>00108       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(16);
<a name="l00109"></a>00109 <span class="comment">//      libMesh::out &lt;&lt; &quot;U = [&quot; &lt;&lt; this-&gt;get_vector(&quot;_nonlinear_solution&quot;)</span>
<a name="l00110"></a>00110       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;U = [&quot;</span> &lt;&lt; *(this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>)
<a name="l00111"></a>00111                     &lt;&lt; <span class="stringliteral">&quot;];&quot;</span> &lt;&lt; std::endl;
<a name="l00112"></a>00112       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(old_precision);
<a name="l00113"></a>00113     }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// Is this definitely necessary? [RHS]</span>
<a name="l00116"></a>00116   <span class="keywordflow">if</span> (get_jacobian)
<a name="l00117"></a>00117     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00118"></a>00118   <span class="keywordflow">if</span> (get_residual)
<a name="l00119"></a>00119     <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// Stupid C++ lets you set *Real* verify_analytic_jacobians = true!</span>
<a name="l00122"></a>00122   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a> &gt; 0.5)
<a name="l00123"></a>00123     {
<a name="l00124"></a>00124       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING!  verify_analytic_jacobians was set &quot;</span>
<a name="l00125"></a>00125                     &lt;&lt; <span class="stringliteral">&quot;to absurdly large value of &quot;</span>
<a name="l00126"></a>00126                     &lt;&lt; <a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a> &lt;&lt; std::endl;
<a name="l00127"></a>00127       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Resetting to 1e-6!&quot;</span> &lt;&lt; std::endl;
<a name="l00128"></a>00128       <a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a> = 1e-6;
<a name="l00129"></a>00129     }
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">// In time-dependent problems, the nonlinear function we&#39;re trying</span>
<a name="l00132"></a>00132   <span class="comment">// to solve at each timestep may depend on the particular solver</span>
<a name="l00133"></a>00133   <span class="comment">// we&#39;re using</span>
<a name="l00134"></a>00134   libmesh_assert (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() != NULL);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a366c8233acbdcc10ca07bb2a44c7e969">build_context</a>();
<a name="l00137"></a>00137   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00138"></a>00138   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a5f06215dc236c9f59894d7660392e852">init_context</a>(_femcontext);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="comment">// Build the residual and jacobian contributions on every active</span>
<a name="l00141"></a>00141   <span class="comment">// mesh element on this processor</span>
<a name="l00142"></a>00142   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00143"></a>00143     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00144"></a>00144   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00145"></a>00145     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00148"></a>00148     {
<a name="l00149"></a>00149       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00150"></a>00150       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00151"></a>00151 
<a name="l00152"></a>00152       <span class="keywordtype">bool</span> jacobian_computed =
<a name="l00153"></a>00153         <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;element_residual(get_jacobian, _femcontext);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155       <span class="comment">// Compute a numeric jacobian if we have to</span>
<a name="l00156"></a>00156       <span class="keywordflow">if</span> (get_jacobian &amp;&amp; !jacobian_computed)
<a name="l00157"></a>00157         {
<a name="l00158"></a>00158           <span class="comment">// Make sure we didn&#39;t compute a jacobian and lie about it</span>
<a name="l00159"></a>00159           libmesh_assert(_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a>() == 0.0);
<a name="l00160"></a>00160           <span class="comment">// Logging of numerical jacobians is done separately</span>
<a name="l00161"></a>00161           this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a0a68297c6c5be66b9df3921f6c040d91">numerical_elem_jacobian</a>(_femcontext);
<a name="l00162"></a>00162         }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164       <span class="comment">// Compute a numeric jacobian if we&#39;re asked to verify the</span>
<a name="l00165"></a>00165       <span class="comment">// analytic jacobian we got</span>
<a name="l00166"></a>00166       <span class="keywordflow">if</span> (get_jacobian &amp;&amp; jacobian_computed &amp;&amp;
<a name="l00167"></a>00167           <a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a> != 0.0)
<a name="l00168"></a>00168         {
<a name="l00169"></a>00169           <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> analytic_jacobian(_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171           _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00172"></a>00172           <span class="comment">// Logging of numerical jacobians is done separately</span>
<a name="l00173"></a>00173           this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a0a68297c6c5be66b9df3921f6c040d91">numerical_elem_jacobian</a>(_femcontext);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> analytic_norm = analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a>();
<a name="l00176"></a>00176           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> numerical_norm = _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a>();
<a name="l00177"></a>00177 
<a name="l00178"></a>00178           <span class="comment">// If we can continue, we&#39;ll probably prefer the analytic jacobian</span>
<a name="l00179"></a>00179           analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">swap</a>(_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181           <span class="comment">// The matrix &quot;analytic_jacobian&quot; will now hold the error matrix</span>
<a name="l00182"></a>00182           analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(-1.0, _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00183"></a>00183           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_norm = analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a>();
<a name="l00184"></a>00184 
<a name="l00185"></a>00185           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> relative_error = error_norm /
<a name="l00186"></a>00186                                 <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(analytic_norm, numerical_norm);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188           <span class="keywordflow">if</span> (relative_error &gt; <a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a>)
<a name="l00189"></a>00189             {
<a name="l00190"></a>00190               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Relative error &quot;</span> &lt;&lt; relative_error
<a name="l00191"></a>00191                             &lt;&lt; <span class="stringliteral">&quot; detected in analytic jacobian on element &quot;</span>
<a name="l00192"></a>00192                             &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt;&lt; <span class="charliteral">&#39;!&#39;</span> &lt;&lt; std::endl;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>();
<a name="l00195"></a>00195               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(16);
<a name="l00196"></a>00196               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;J_analytic &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00197"></a>00197                         &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> &lt;&lt; std::endl;
<a name="l00198"></a>00198               analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(1.0, _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00199"></a>00199               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;J_numeric &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00200"></a>00200                         &lt;&lt; analytic_jacobian &lt;&lt; std::endl;
<a name="l00201"></a>00201 
<a name="l00202"></a>00202               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(old_precision);
<a name="l00203"></a>00203 
<a name="l00204"></a>00204               libmesh_error();
<a name="l00205"></a>00205             }
<a name="l00206"></a>00206         }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208       <span class="keywordflow">for</span> (_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> = 0;
<a name="l00209"></a>00209            _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> != _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>();
<a name="l00210"></a>00210            ++_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>)
<a name="l00211"></a>00211         {
<a name="l00212"></a>00212           <span class="comment">// Don&#39;t compute on non-boundary sides unless requested</span>
<a name="l00213"></a>00213           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a979327b7dd46ad979e6145076fd8e176">compute_internal_sides</a> &amp;&amp; 
<a name="l00214"></a>00214               _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>) != NULL)
<a name="l00215"></a>00215             <span class="keywordflow">continue</span>;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217           <span class="comment">// Any mesh movement has already been done (and restored,</span>
<a name="l00218"></a>00218           <span class="comment">// if the TimeSolver isn&#39;t broken), but</span>
<a name="l00219"></a>00219           <span class="comment">// reinitializing the side FE objects is still necessary</span>
<a name="l00220"></a>00220           _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">side_fe_reinit</a>();
<a name="l00221"></a>00221 
<a name="l00222"></a>00222           <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_jacobian;
<a name="l00223"></a>00223           <span class="comment">// If we&#39;re in DEBUG mode, we should always verify that the</span>
<a name="l00224"></a>00224           <span class="comment">// user&#39;s side_residual function doesn&#39;t alter our existing</span>
<a name="l00225"></a>00225           <span class="comment">// jacobian and then lie about it</span>
<a name="l00226"></a>00226 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00227"></a>00227 <span class="preprocessor"></span>          <span class="comment">// Even if we&#39;re not in DEBUG mode, when we&#39;re verifying</span>
<a name="l00228"></a>00228           <span class="comment">// analytic jacobians we&#39;ll want to verify each side&#39;s</span>
<a name="l00229"></a>00229           <span class="comment">// jacobian contribution separately</span>
<a name="l00230"></a>00230           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a> != 0.0 &amp;&amp; get_jacobian)
<a name="l00231"></a>00231 <span class="preprocessor">#endif // ifndef DEBUG</span>
<a name="l00232"></a>00232 <span class="preprocessor"></span>            {
<a name="l00233"></a>00233               old_jacobian = _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>;
<a name="l00234"></a>00234               _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00235"></a>00235             }
<a name="l00236"></a>00236           jacobian_computed =
<a name="l00237"></a>00237             <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;side_residual(get_jacobian, _femcontext);
<a name="l00238"></a>00238 
<a name="l00239"></a>00239           <span class="comment">// Compute a numeric jacobian if we have to</span>
<a name="l00240"></a>00240           <span class="keywordflow">if</span> (get_jacobian &amp;&amp; !jacobian_computed)
<a name="l00241"></a>00241             {
<a name="l00242"></a>00242               <span class="comment">// In DEBUG mode, we&#39;ve already set elem_jacobian == 0,</span>
<a name="l00243"></a>00243               <span class="comment">// so we can make sure side_residual didn&#39;t compute a</span>
<a name="l00244"></a>00244               <span class="comment">// jacobian and lie about it</span>
<a name="l00245"></a>00245 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00246"></a>00246 <span class="preprocessor"></span>              libmesh_assert(_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a>() == 0.0);
<a name="l00247"></a>00247 <span class="preprocessor">#endif</span>
<a name="l00248"></a>00248 <span class="preprocessor"></span>              <span class="comment">// Logging of numerical jacobians is done separately</span>
<a name="l00249"></a>00249               this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a7a44c3fd10ff85e68f55d4be3eb61e0e">numerical_side_jacobian</a>(_femcontext);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251               <span class="comment">// If we&#39;re in DEBUG mode or if</span>
<a name="l00252"></a>00252               <span class="comment">// verify_analytic_jacobians is on, we&#39;ve moved</span>
<a name="l00253"></a>00253               <span class="comment">// elem_jacobian&#39;s accumulated values into old_jacobian.</span>
<a name="l00254"></a>00254               <span class="comment">// Now let&#39;s add them back.</span>
<a name="l00255"></a>00255 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>              <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a> != 0.0)
<a name="l00257"></a>00257 <span class="preprocessor">#endif // ifndef DEBUG</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span>                _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> += old_jacobian;
<a name="l00259"></a>00259             }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261           <span class="comment">// Compute a numeric jacobian if we&#39;re asked to verify the</span>
<a name="l00262"></a>00262           <span class="comment">// analytic jacobian we got</span>
<a name="l00263"></a>00263           <span class="keywordflow">if</span> (get_jacobian &amp;&amp; jacobian_computed &amp;&amp;
<a name="l00264"></a>00264               <a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a> != 0.0)
<a name="l00265"></a>00265             {
<a name="l00266"></a>00266               <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> analytic_jacobian(_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268               _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00269"></a>00269               <span class="comment">// Logging of numerical jacobians is done separately</span>
<a name="l00270"></a>00270               this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a7a44c3fd10ff85e68f55d4be3eb61e0e">numerical_side_jacobian</a>(_femcontext);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> analytic_norm = analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a>();
<a name="l00273"></a>00273               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> numerical_norm = _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a>();
<a name="l00274"></a>00274 
<a name="l00275"></a>00275               <span class="comment">// If we can continue, we&#39;ll probably prefer the analytic jacobian</span>
<a name="l00276"></a>00276               analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#aa2526a1599a6b9d9b5373c41af8bce1f">swap</a>(_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278               <span class="comment">// The matrix &quot;analytic_jacobian&quot; will now hold the error matrix</span>
<a name="l00279"></a>00279               analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(-1.0, _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00280"></a>00280               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_norm = analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ac42e257df76ea1522f0e191d21d78e7d">l1_norm</a>();
<a name="l00281"></a>00281 
<a name="l00282"></a>00282               <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> relative_error = error_norm /
<a name="l00283"></a>00283                                     <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(analytic_norm, numerical_norm);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285               <span class="keywordflow">if</span> (relative_error &gt; <a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a>)
<a name="l00286"></a>00286                 {
<a name="l00287"></a>00287                   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Relative error &quot;</span> &lt;&lt; relative_error
<a name="l00288"></a>00288                                 &lt;&lt; <span class="stringliteral">&quot; detected in analytic jacobian on element &quot;</span>
<a name="l00289"></a>00289                                 &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()
<a name="l00290"></a>00290                                 &lt;&lt; <span class="stringliteral">&quot;, side &quot;</span>
<a name="l00291"></a>00291                                 &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> &lt;&lt; <span class="charliteral">&#39;!&#39;</span> &lt;&lt; std::endl;
<a name="l00292"></a>00292 
<a name="l00293"></a>00293                   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>();
<a name="l00294"></a>00294                   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(16);
<a name="l00295"></a>00295                   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;J_analytic &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00296"></a>00296                                 &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> &lt;&lt; std::endl;
<a name="l00297"></a>00297                   analytic_jacobian.<a class="code" href="classlibMesh_1_1DenseMatrix.php#adf1b1e8773da47d9edaed6f12c6ceb9a">add</a>(1.0, _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00298"></a>00298                   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;J_numeric &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00299"></a>00299                                 &lt;&lt; analytic_jacobian &lt;&lt; std::endl;
<a name="l00300"></a>00300                   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(old_precision);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302                   libmesh_error();
<a name="l00303"></a>00303                 }
<a name="l00304"></a>00304               <span class="comment">// Once we&#39;ve verified a side, we&#39;ll want to add back the</span>
<a name="l00305"></a>00305               <span class="comment">// rest of the accumulated jacobian</span>
<a name="l00306"></a>00306               _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> += old_jacobian;
<a name="l00307"></a>00307             }
<a name="l00308"></a>00308           <span class="comment">// In DEBUG mode, we&#39;ve set elem_jacobian == 0, and we</span>
<a name="l00309"></a>00309           <span class="comment">// may still need to add the old jacobian back</span>
<a name="l00310"></a>00310 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (get_jacobian &amp;&amp; jacobian_computed &amp;&amp;
<a name="l00312"></a>00312               <a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a> == 0.0)
<a name="l00313"></a>00313             {
<a name="l00314"></a>00314               _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> += old_jacobian;
<a name="l00315"></a>00315             }
<a name="l00316"></a>00316 <span class="preprocessor">#endif // ifdef DEBUG</span>
<a name="l00317"></a>00317 <span class="preprocessor"></span>        }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span>      <span class="comment">// We turn off the asymmetric constraint application;</span>
<a name="l00321"></a>00321       <span class="comment">// enforce_constraints_exactly() should be called in the solver</span>
<a name="l00322"></a>00322       <span class="keywordflow">if</span> (get_residual &amp;&amp; get_jacobian)
<a name="l00323"></a>00323         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a97906aa49177873ed7ea9029dcb0cd4b">constrain_element_matrix_and_vector</a>
<a name="l00324"></a>00324           (_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>, _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>,
<a name="l00325"></a>00325            _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>, <span class="keyword">false</span>);
<a name="l00326"></a>00326       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (get_residual)
<a name="l00327"></a>00327         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">constrain_element_vector</a>
<a name="l00328"></a>00328           (_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>, _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>, <span class="keyword">false</span>);
<a name="l00329"></a>00329       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (get_jacobian)
<a name="l00330"></a>00330         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a426611c953c70989bc32a792e49c3450">constrain_element_matrix</a>
<a name="l00331"></a>00331           (_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>, _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>, <span class="keyword">false</span>);
<a name="l00332"></a>00332 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>
<a name="l00334"></a>00334       <span class="keywordflow">if</span> (get_jacobian &amp;&amp; <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a72254eda9b022410c946f7ca2008e83a">print_element_jacobians</a>)
<a name="l00335"></a>00335         {
<a name="l00336"></a>00336           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>();
<a name="l00337"></a>00337           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(16);
<a name="l00338"></a>00338           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;J_elem &quot;</span> &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt;&lt; <span class="stringliteral">&quot; = &quot;</span>
<a name="l00339"></a>00339                     &lt;&lt; _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> &lt;&lt; std::endl;
<a name="l00340"></a>00340           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(old_precision);
<a name="l00341"></a>00341         }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343       <span class="keywordflow">if</span> (get_jacobian)
<a name="l00344"></a>00344         this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a63c5ad2e110a1873c4fd8945ad7b7e3f">add_matrix</a> (_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>,
<a name="l00345"></a>00345                                   _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00346"></a>00346       <span class="keywordflow">if</span> (get_residual)
<a name="l00347"></a>00347         this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>,
<a name="l00348"></a>00348                                _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00349"></a>00349     }
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352   <span class="keywordflow">if</span> (get_residual &amp;&amp; <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aa4fc23a36102eb56598d5bb528cacf0b">print_residual_norms</a>)
<a name="l00353"></a>00353     {
<a name="l00354"></a>00354       this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00355"></a>00355       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;|F| = &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a110a36d7800daa4bb8b91e35419d335d">l1_norm</a>() &lt;&lt; std::endl;
<a name="l00356"></a>00356     }
<a name="l00357"></a>00357   <span class="keywordflow">if</span> (get_residual &amp;&amp; <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a1be85415f6f38f15a4e36a201abbfe1c">print_residuals</a>)
<a name="l00358"></a>00358     {
<a name="l00359"></a>00359       this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00360"></a>00360       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>();
<a name="l00361"></a>00361       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(16);
<a name="l00362"></a>00362       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;F = [&quot;</span> &lt;&lt; *(this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>) &lt;&lt; <span class="stringliteral">&quot;];&quot;</span> &lt;&lt; std::endl;
<a name="l00363"></a>00363       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(old_precision);
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365   <span class="keywordflow">if</span> (get_jacobian &amp;&amp; <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#aeaa7d80ca74e2494265f70a618989b6a">print_jacobian_norms</a>)
<a name="l00366"></a>00366     {
<a name="l00367"></a>00367       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00368"></a>00368       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;|J| = &quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a02cd39b31c06bd3d344ac68d282f21cb">l1_norm</a>() &lt;&lt; std::endl;
<a name="l00369"></a>00369     }
<a name="l00370"></a>00370   <span class="keywordflow">if</span> (get_jacobian &amp;&amp; <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0b0878d8d6d40ef8cb6daad9e9915daf">print_jacobians</a>)
<a name="l00371"></a>00371     {
<a name="l00372"></a>00372       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00373"></a>00373       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_precision = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>();
<a name="l00374"></a>00374       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(16);
<a name="l00375"></a>00375       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;J = [&quot;</span> &lt;&lt; *(this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>) &lt;&lt; <span class="stringliteral">&quot;];&quot;</span> &lt;&lt; std::endl;
<a name="l00376"></a>00376       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>.<a class="code" href="classlibMesh_1_1BasicOStreamProxy.php#a1903b4c5f9397c90e2da3fba62e22516">precision</a>(old_precision);
<a name="l00377"></a>00377     }
<a name="l00378"></a>00378   STOP_LOG(log_name, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00379"></a>00379 }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 
<a name="l00383"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a0e3ea4362b5e9fcb60a7caa2f08f11a7">00383</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a0e3ea4362b5e9fcb60a7caa2f08f11a7">FEMSystem::solve</a>()
<a name="l00384"></a>00384 {
<a name="l00385"></a>00385   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#acd2e68265ffb835434e783190c452b42">Parent::solve</a>();
<a name="l00386"></a>00386 
<a name="l00387"></a>00387   <span class="comment">// On a moving mesh we want the mesh to reflect the new solution</span>
<a name="l00388"></a>00388   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a2efde0dcca62566606f1a259d7de53eb">mesh_position_set</a>();
<a name="l00389"></a>00389 }
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00393"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a2efde0dcca62566606f1a259d7de53eb">00393</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a2efde0dcca62566606f1a259d7de53eb">FEMSystem::mesh_position_set</a>()
<a name="l00394"></a>00394 {
<a name="l00395"></a>00395   <span class="comment">// If we don&#39;t need to move the mesh, we&#39;re done</span>
<a name="l00396"></a>00396   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a> != <span class="keyword">this</span>)
<a name="l00397"></a>00397     <span class="keywordflow">return</span>;
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00400"></a>00400 
<a name="l00401"></a>00401   <span class="comment">// This code won&#39;t work on a parallelized mesh yet -</span>
<a name="l00402"></a>00402   <span class="comment">// it won&#39;t get ancestor elements right.</span>
<a name="l00403"></a>00403   libmesh_assert(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>());
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="comment">// In fact it won&#39;t work in parallel at all yet - we don&#39;t have</span>
<a name="l00406"></a>00406   <span class="comment">// current_solution() data for non-ghost elements.  That&#39;s going to</span>
<a name="l00407"></a>00407   <span class="comment">// be put on hold until we&#39;re debugged in serial and until I figure</span>
<a name="l00408"></a>00408   <span class="comment">// out how to better abstract the &quot;ask other procs for their local</span>
<a name="l00409"></a>00409   <span class="comment">// data, respond to others&#39; queries, work on my query&#39;s results&quot;</span>
<a name="l00410"></a>00410   <span class="comment">// pattern that we seem to be using a lot.</span>
<a name="l00411"></a>00411   libmesh_assert(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1);
<a name="l00412"></a>00412   
<a name="l00413"></a>00413   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a366c8233acbdcc10ca07bb2a44c7e969">build_context</a>();
<a name="l00414"></a>00414   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00415"></a>00415   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a5f06215dc236c9f59894d7660392e852">init_context</a>(_femcontext);
<a name="l00416"></a>00416 
<a name="l00417"></a>00417   <span class="comment">// Move every mesh element we can</span>
<a name="l00418"></a>00418   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00419"></a>00419     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00420"></a>00420   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00421"></a>00421     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00424"></a>00424     {
<a name="l00425"></a>00425       <span class="comment">// We need the algebraic data</span>
<a name="l00426"></a>00426       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00427"></a>00427       <span class="comment">// And when asserts are on, we also need the FE so</span>
<a name="l00428"></a>00428       <span class="comment">// we can assert that the mesh data is of the right type.</span>
<a name="l00429"></a>00429 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00430"></a>00430 <span class="preprocessor"></span>      _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00431"></a>00431 <span class="preprocessor">#endif</span>
<a name="l00432"></a>00432 <span class="preprocessor"></span>
<a name="l00433"></a>00433       <span class="comment">// This code won&#39;t handle moving subactive elements</span>
<a name="l00434"></a>00434       libmesh_assert(!_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>());
<a name="l00435"></a>00435 
<a name="l00436"></a>00436       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a8e1184906e1ececc08b33c3530f1a4a0">elem_position_set</a>(1.);
<a name="l00437"></a>00437     }
<a name="l00438"></a>00438 }
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00442"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a3e52060d9238a685914b8b3b5626d587">00442</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a3e52060d9238a685914b8b3b5626d587">FEMSystem::postprocess</a> ()
<a name="l00443"></a>00443 {
<a name="l00444"></a>00444   START_LOG(<span class="stringliteral">&quot;postprocess()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00445"></a>00445 
<a name="l00446"></a>00446   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a366c8233acbdcc10ca07bb2a44c7e969">build_context</a>();
<a name="l00451"></a>00451   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00452"></a>00452   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a5f06215dc236c9f59894d7660392e852">init_context</a>(_femcontext);
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   <span class="comment">// Loop over every active mesh element on this processor</span>
<a name="l00455"></a>00455   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00456"></a>00456     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00457"></a>00457   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00458"></a>00458     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00461"></a>00461     {
<a name="l00462"></a>00462       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00463"></a>00463 
<a name="l00464"></a>00464       <span class="comment">// Optionally initialize all the interior FE objects on elem.</span>
<a name="l00465"></a>00465       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMSystem.php#a267ad32ebc39d8f8a966682615e28dae">fe_reinit_during_postprocess</a>)
<a name="l00466"></a>00466         _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00467"></a>00467       
<a name="l00468"></a>00468       this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a7309f211d6ac11ac750e4a90858e7a0f">element_postprocess</a>(_femcontext);
<a name="l00469"></a>00469 
<a name="l00470"></a>00470       <span class="keywordflow">for</span> (_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> = 0;
<a name="l00471"></a>00471            _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> != _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>();
<a name="l00472"></a>00472            ++_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>)
<a name="l00473"></a>00473         {
<a name="l00474"></a>00474           <span class="comment">// Don&#39;t compute on non-boundary sides unless requested</span>
<a name="l00475"></a>00475           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a191ca6371747268974a5f108e7576873">postprocess_sides</a> ||
<a name="l00476"></a>00476               (!<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a979327b7dd46ad979e6145076fd8e176">compute_internal_sides</a> &amp;&amp;
<a name="l00477"></a>00477                _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>) != NULL))
<a name="l00478"></a>00478             <span class="keywordflow">continue</span>;
<a name="l00479"></a>00479 
<a name="l00480"></a>00480           <span class="comment">// Optionally initialize all the FE objects on this side.</span>
<a name="l00481"></a>00481           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FEMSystem.php#a267ad32ebc39d8f8a966682615e28dae">fe_reinit_during_postprocess</a>)
<a name="l00482"></a>00482             _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">side_fe_reinit</a>();
<a name="l00483"></a>00483 
<a name="l00484"></a>00484           this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#afdc7a29f5bc94098ddf54cc1584622d4">side_postprocess</a>(_femcontext);
<a name="l00485"></a>00485         }
<a name="l00486"></a>00486     }
<a name="l00487"></a>00487 
<a name="l00488"></a>00488   STOP_LOG(<span class="stringliteral">&quot;postprocess()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00489"></a>00489 }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
<a name="l00493"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#af972b63d2caa5f509aace49a801466ad">00493</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#af972b63d2caa5f509aace49a801466ad">FEMSystem::assemble_qoi</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a> &amp;qoi_indices)
<a name="l00494"></a>00494 {
<a name="l00495"></a>00495   START_LOG(<span class="stringliteral">&quot;assemble_qoi()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00496"></a>00496 
<a name="l00497"></a>00497   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00498"></a>00498 
<a name="l00499"></a>00499   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00500"></a>00500 
<a name="l00501"></a>00501   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a366c8233acbdcc10ca07bb2a44c7e969">build_context</a>();
<a name="l00502"></a>00502   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00503"></a>00503   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a5f06215dc236c9f59894d7660392e852">init_context</a>(_femcontext);
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   <span class="comment">// the quantity of interest is assumed to be a sum of element and</span>
<a name="l00506"></a>00506   <span class="comment">// side terms</span>
<a name="l00507"></a>00507   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00508"></a>00508     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00509"></a>00509       <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>[i] = 0;
<a name="l00510"></a>00510 
<a name="l00511"></a>00511   <span class="comment">// Loop over every active mesh element on this processor</span>
<a name="l00512"></a>00512   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00513"></a>00513     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00514"></a>00514   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00515"></a>00515     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00516"></a>00516 
<a name="l00517"></a>00517   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00518"></a>00518     {
<a name="l00519"></a>00519       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00520"></a>00520       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00521"></a>00521 
<a name="l00522"></a>00522       this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a5417ddd53b7946914ef038a53860b9e4">element_qoi</a>(_femcontext, qoi_indices);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524       <span class="keywordflow">for</span> (_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> = 0;
<a name="l00525"></a>00525            _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> != _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>();
<a name="l00526"></a>00526            ++_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>)
<a name="l00527"></a>00527         {
<a name="l00528"></a>00528           <span class="comment">// Don&#39;t compute on non-boundary sides unless requested</span>
<a name="l00529"></a>00529           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0d959109f732e1f0729950973098536f">assemble_qoi_sides</a> ||
<a name="l00530"></a>00530               (!<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a979327b7dd46ad979e6145076fd8e176">compute_internal_sides</a> &amp;&amp;
<a name="l00531"></a>00531                _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>) != NULL))
<a name="l00532"></a>00532             <span class="keywordflow">continue</span>;
<a name="l00533"></a>00533 
<a name="l00534"></a>00534           _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">side_fe_reinit</a>();
<a name="l00535"></a>00535 
<a name="l00536"></a>00536           this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a04c95b4a690e123981e960d9888377e7">side_qoi</a>(_femcontext, qoi_indices);
<a name="l00537"></a>00537         }
<a name="l00538"></a>00538     }
<a name="l00539"></a>00539 
<a name="l00540"></a>00540   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#ad01aaa7bb57398e3b583ce483dac141f">elem_qoi</a>);
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a> = _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#ad01aaa7bb57398e3b583ce483dac141f">elem_qoi</a>;
<a name="l00543"></a>00543 
<a name="l00544"></a>00544   STOP_LOG(<span class="stringliteral">&quot;assemble_qoi()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00545"></a>00545 }
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 
<a name="l00548"></a>00548 
<a name="l00549"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a22025e7b44e9a73834cbd1831d0f9b68">00549</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a22025e7b44e9a73834cbd1831d0f9b68">FEMSystem::assemble_qoi_derivative</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l00550"></a>00550 {
<a name="l00551"></a>00551   START_LOG(<span class="stringliteral">&quot;assemble_qoi_derivative()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00552"></a>00552 
<a name="l00553"></a>00553   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a366c8233acbdcc10ca07bb2a44c7e969">build_context</a>();
<a name="l00558"></a>00558   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00559"></a>00559   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a5f06215dc236c9f59894d7660392e852">init_context</a>(_femcontext);
<a name="l00560"></a>00560 
<a name="l00561"></a>00561   <span class="comment">// The quantity of interest derivative assembly accumulates on</span>
<a name="l00562"></a>00562   <span class="comment">// initially zero vectors</span>
<a name="l00563"></a>00563   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00564"></a>00564     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00565"></a>00565       this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab21c031f38c12ff111865623561b6687">add_adjoint_rhs</a>(i).<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00566"></a>00566 
<a name="l00567"></a>00567   <span class="comment">// Loop over every active mesh element on this processor</span>
<a name="l00568"></a>00568   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00569"></a>00569     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00570"></a>00570   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00571"></a>00571     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00572"></a>00572 
<a name="l00573"></a>00573   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00574"></a>00574     {
<a name="l00575"></a>00575       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00576"></a>00576       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a24f0889875c6cfa85f45e0b1d0986651">elem_fe_reinit</a>();
<a name="l00577"></a>00577 
<a name="l00578"></a>00578       this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ac24440d25028b40fbd23c6ee71abebea">element_qoi_derivative</a>(_femcontext, qoi_indices);
<a name="l00579"></a>00579 
<a name="l00580"></a>00580       <span class="keywordflow">for</span> (_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> = 0;
<a name="l00581"></a>00581            _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a> != _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>();
<a name="l00582"></a>00582            ++_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>)
<a name="l00583"></a>00583         {
<a name="l00584"></a>00584           <span class="comment">// Don&#39;t compute on non-boundary sides unless requested</span>
<a name="l00585"></a>00585           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a0d959109f732e1f0729950973098536f">assemble_qoi_sides</a> ||
<a name="l00586"></a>00586               (!<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a979327b7dd46ad979e6145076fd8e176">compute_internal_sides</a> &amp;&amp;
<a name="l00587"></a>00587                _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(_femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a59d031054af8f000ebe3874b0a944410">side</a>) != NULL))
<a name="l00588"></a>00588             <span class="keywordflow">continue</span>;
<a name="l00589"></a>00589 
<a name="l00590"></a>00590           _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a0f7f6e01f78a5dbf532901b5198878fc">side_fe_reinit</a>();
<a name="l00591"></a>00591 
<a name="l00592"></a>00592           this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#ab66879581243bee3aa9f1c3793173b88">side_qoi_derivative</a>(_femcontext, qoi_indices);
<a name="l00593"></a>00593         }
<a name="l00594"></a>00594 
<a name="l00595"></a>00595       <span class="comment">// We need some unmodified indices to use for constraining</span>
<a name="l00596"></a>00596       <span class="comment">// multiple vector</span>
<a name="l00597"></a>00597       <span class="comment">// FIXME - there should be a DofMap::constrain_element_vectors</span>
<a name="l00598"></a>00598       <span class="comment">// to do this more efficiently</span>
<a name="l00599"></a>00599       std::vector&lt;unsigned int&gt; original_dofs = _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>;
<a name="l00600"></a>00600 
<a name="l00601"></a>00601       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00602"></a>00602         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00603"></a>00603           {
<a name="l00604"></a>00604             _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a> = original_dofs;
<a name="l00605"></a>00605             this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a29aba1bf008a1de4dd81a9a1b6f5ff41">constrain_element_vector</a>
<a name="l00606"></a>00606               (_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a5fad6a1ca3ce18dd2f11c22b2ad5923a">elem_qoi_derivative</a>[i], _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>, <span class="keyword">false</span>);
<a name="l00607"></a>00607 
<a name="l00608"></a>00608             this-&gt;<a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(i).<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>
<a name="l00609"></a>00609               (_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a5fad6a1ca3ce18dd2f11c22b2ad5923a">elem_qoi_derivative</a>[i], _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>);
<a name="l00610"></a>00610           }
<a name="l00611"></a>00611     }
<a name="l00612"></a>00612 
<a name="l00613"></a>00613   STOP_LOG(<span class="stringliteral">&quot;assemble_qoi_derivative()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00614"></a>00614 }
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 
<a name="l00618"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#ac1680f6482fb491cc89e4462846006f4">00618</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#ac1680f6482fb491cc89e4462846006f4">FEMSystem::numerical_jacobian</a> (TimeSolverResPtr res,
<a name="l00619"></a>00619                                     <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context)
<a name="l00620"></a>00620 {
<a name="l00621"></a>00621   <span class="comment">// Logging is done by numerical_elem_jacobian</span>
<a name="l00622"></a>00622   <span class="comment">// or numerical_side_jacobian</span>
<a name="l00623"></a>00623 
<a name="l00624"></a>00624   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> original_residual(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>);
<a name="l00625"></a>00625   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> backwards_residual(context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>);
<a name="l00626"></a>00626   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1FEMSystem.php#ac1680f6482fb491cc89e4462846006f4">numerical_jacobian</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00627"></a>00627 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00628"></a>00628 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> old_jacobian(context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00629"></a>00629 <span class="preprocessor">#endif</span>
<a name="l00630"></a>00630 <span class="preprocessor"></span>
<a name="l00631"></a>00631   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> numerical_point_h = 0.;
<a name="l00632"></a>00632   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a> == <span class="keyword">this</span>)
<a name="l00633"></a>00633     numerical_point_h = <a class="code" href="classlibMesh_1_1FEMSystem.php#a73b4c7f9f81fc10f215caf1f4799664a">numerical_jacobian_h</a> * context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af7712d01779f053ea14d49b017c54828">hmin</a>();
<a name="l00634"></a>00634 
<a name="l00635"></a>00635   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size(); ++j)
<a name="l00636"></a>00636     {
<a name="l00637"></a>00637       <span class="comment">// Take the &quot;minus&quot; side of a central differenced first derivative</span>
<a name="l00638"></a>00638       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> original_solution = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(j);
<a name="l00639"></a>00639       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(j) -= <a class="code" href="classlibMesh_1_1FEMSystem.php#a73b4c7f9f81fc10f215caf1f4799664a">numerical_jacobian_h</a>;
<a name="l00640"></a>00640 
<a name="l00641"></a>00641       <span class="comment">// Make sure to catch any moving mesh terms</span>
<a name="l00642"></a>00642       <span class="comment">// FIXME - this could be less ugly</span>
<a name="l00643"></a>00643       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> *coord = NULL;
<a name="l00644"></a>00644       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a> == <span class="keyword">this</span>)
<a name="l00645"></a>00645         {
<a name="l00646"></a>00646           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00647"></a>00647             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k = 0;
<a name="l00648"></a>00648                  k != context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>].size(); ++k)
<a name="l00649"></a>00649               <span class="keywordflow">if</span> (context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>][k] ==
<a name="l00650"></a>00650                   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[j])
<a name="l00651"></a>00651                 coord = &amp;(context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(k)(0));
<a name="l00652"></a>00652           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00653"></a>00653             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k = 0;
<a name="l00654"></a>00654                  k != context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>].size(); ++k)
<a name="l00655"></a>00655               <span class="keywordflow">if</span> (context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>][k] == 
<a name="l00656"></a>00656                   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[j])
<a name="l00657"></a>00657                 coord = &amp;(context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(k)(1));
<a name="l00658"></a>00658           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00659"></a>00659             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k = 0;
<a name="l00660"></a>00660                  k != context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>].size(); ++k)
<a name="l00661"></a>00661               <span class="keywordflow">if</span> (context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>][k] ==
<a name="l00662"></a>00662                   context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>[j])
<a name="l00663"></a>00663                 coord = &amp;(context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab6f9bf4e40120dd6b18e6da4f12c3cc8">elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(k)(2));
<a name="l00664"></a>00664         }
<a name="l00665"></a>00665       <span class="keywordflow">if</span> (coord)
<a name="l00666"></a>00666         {
<a name="l00667"></a>00667           <span class="comment">// We have enough information to scale the perturbations</span>
<a name="l00668"></a>00668           <span class="comment">// here appropriately</span>
<a name="l00669"></a>00669           context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(j) = original_solution - numerical_point_h;
<a name="l00670"></a>00670           *coord = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(j));
<a name="l00671"></a>00671         }
<a name="l00672"></a>00672 
<a name="l00673"></a>00673       context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00674"></a>00674       ((*time_solver).*(res))(<span class="keyword">false</span>, context);
<a name="l00675"></a>00675 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>      libmesh_assert(old_jacobian == context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00677"></a>00677 <span class="preprocessor">#endif</span>
<a name="l00678"></a>00678 <span class="preprocessor"></span>      backwards_residual = context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>;
<a name="l00679"></a>00679 
<a name="l00680"></a>00680       <span class="comment">// Take the &quot;plus&quot; side of a central differenced first derivative</span>
<a name="l00681"></a>00681       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(j) = original_solution + <a class="code" href="classlibMesh_1_1FEMSystem.php#a73b4c7f9f81fc10f215caf1f4799664a">numerical_jacobian_h</a>;
<a name="l00682"></a>00682       <span class="keywordflow">if</span> (coord)
<a name="l00683"></a>00683         {
<a name="l00684"></a>00684           context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(j) = original_solution + numerical_point_h;
<a name="l00685"></a>00685           *coord = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(j));
<a name="l00686"></a>00686         }
<a name="l00687"></a>00687       context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00688"></a>00688       ((*time_solver).*(res))(<span class="keyword">false</span>, context);
<a name="l00689"></a>00689 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00690"></a>00690 <span class="preprocessor"></span>      libmesh_assert(old_jacobian == context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a>);
<a name="l00691"></a>00691 <span class="preprocessor">#endif</span>
<a name="l00692"></a>00692 <span class="preprocessor"></span>
<a name="l00693"></a>00693       context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(j) = original_solution;
<a name="l00694"></a>00694       <span class="keywordflow">if</span> (coord)
<a name="l00695"></a>00695         {
<a name="l00696"></a>00696           *coord = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(context.<a class="code" href="classlibMesh_1_1DiffContext.php#a37ecd0ccb2abf2abe8f5dbbff52daf4a">elem_solution</a>(j));
<a name="l00697"></a>00697           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size(); ++i)
<a name="l00698"></a>00698             {
<a name="l00699"></a>00699               <a class="code" href="classlibMesh_1_1FEMSystem.php#ac1680f6482fb491cc89e4462846006f4">numerical_jacobian</a>(i,j) =
<a name="l00700"></a>00700                 (context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>(i) - backwards_residual(i)) /
<a name="l00701"></a>00701                 2. / numerical_point_h;
<a name="l00702"></a>00702             }
<a name="l00703"></a>00703         }
<a name="l00704"></a>00704       <span class="keywordflow">else</span>
<a name="l00705"></a>00705         {
<a name="l00706"></a>00706           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != context.<a class="code" href="classlibMesh_1_1DiffContext.php#a66eb0ba364350d256552d872f30c9b34">dof_indices</a>.size(); ++i)
<a name="l00707"></a>00707             {
<a name="l00708"></a>00708               <a class="code" href="classlibMesh_1_1FEMSystem.php#ac1680f6482fb491cc89e4462846006f4">numerical_jacobian</a>(i,j) =
<a name="l00709"></a>00709                 (context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a>(i) - backwards_residual(i)) /
<a name="l00710"></a>00710                 2. / numerical_jacobian_h;
<a name="l00711"></a>00711             }
<a name="l00712"></a>00712         }
<a name="l00713"></a>00713     }
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   context.<a class="code" href="classlibMesh_1_1DiffContext.php#ae8ee506ab5362a9fa6cb5c012d7c72b2">elem_residual</a> = original_residual;
<a name="l00716"></a>00716   context.<a class="code" href="classlibMesh_1_1DiffContext.php#aa2f012df0c5175baaf718dc4c15fb2ff">elem_jacobian</a> = <a class="code" href="classlibMesh_1_1FEMSystem.php#ac1680f6482fb491cc89e4462846006f4">numerical_jacobian</a>;
<a name="l00717"></a>00717 }
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 
<a name="l00721"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a0a68297c6c5be66b9df3921f6c040d91">00721</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a0a68297c6c5be66b9df3921f6c040d91">FEMSystem::numerical_elem_jacobian</a> (<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context)
<a name="l00722"></a>00722 {
<a name="l00723"></a>00723   START_LOG(<span class="stringliteral">&quot;numerical_elem_jacobian()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00724"></a>00724   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#ac1680f6482fb491cc89e4462846006f4">numerical_jacobian</a>(&amp;<a class="code" href="classlibMesh_1_1TimeSolver.php#ae93a1e73cc5e4bea79942c738d038dd5">TimeSolver::element_residual</a>, context);
<a name="l00725"></a>00725   STOP_LOG(<span class="stringliteral">&quot;numerical_elem_jacobian()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00726"></a>00726 }
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 
<a name="l00729"></a>00729 
<a name="l00730"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a7a44c3fd10ff85e68f55d4be3eb61e0e">00730</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a7a44c3fd10ff85e68f55d4be3eb61e0e">FEMSystem::numerical_side_jacobian</a> (<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context)
<a name="l00731"></a>00731 {
<a name="l00732"></a>00732   START_LOG(<span class="stringliteral">&quot;numerical_side_jacobian()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00733"></a>00733   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#ac1680f6482fb491cc89e4462846006f4">numerical_jacobian</a>(&amp;<a class="code" href="classlibMesh_1_1TimeSolver.php#afe6b041195b7c116b534ff31b60b2214">TimeSolver::side_residual</a>, context);
<a name="l00734"></a>00734   STOP_LOG(<span class="stringliteral">&quot;numerical_side_jacobian()&quot;</span>, <span class="stringliteral">&quot;FEMSystem&quot;</span>);
<a name="l00735"></a>00735 }
<a name="l00736"></a>00736 
<a name="l00737"></a>00737 
<a name="l00738"></a>00738 
<a name="l00739"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a366c8233acbdcc10ca07bb2a44c7e969">00739</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> <a class="code" href="classlibMesh_1_1FEMSystem.php#a366c8233acbdcc10ca07bb2a44c7e969">FEMSystem::build_context</a> ()
<a name="l00740"></a>00740 {
<a name="l00741"></a>00741   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a>(*<span class="keyword">this</span>));
<a name="l00742"></a>00742 
<a name="l00743"></a>00743   ap-&gt;set_deltat_pointer( &amp;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> );
<a name="l00744"></a>00744   
<a name="l00745"></a>00745   <span class="keywordflow">return</span> ap;
<a name="l00746"></a>00746 }
<a name="l00747"></a>00747 
<a name="l00748"></a>00748 
<a name="l00749"></a>00749 
<a name="l00750"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a5f06215dc236c9f59894d7660392e852">00750</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a5f06215dc236c9f59894d7660392e852">FEMSystem::init_context</a>(<a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;c)
<a name="l00751"></a>00751 {
<a name="l00752"></a>00752   <span class="comment">// Parent::init_context(c);  // may be a good idea in derived classes</span>
<a name="l00753"></a>00753 
<a name="l00754"></a>00754   <span class="comment">// Although we do this in DiffSystem::build_context() and</span>
<a name="l00755"></a>00755   <span class="comment">// FEMSystem::build_context() as well, we do it here just to be</span>
<a name="l00756"></a>00756   <span class="comment">// extra sure that the deltat pointer gets set.  Since the</span>
<a name="l00757"></a>00757   <span class="comment">// intended behavior is for classes derived from FEMSystem to</span>
<a name="l00758"></a>00758   <span class="comment">// call Parent::init_context() in their own init_context()</span>
<a name="l00759"></a>00759   <span class="comment">// overloads, we can ensure that those classes get the correct</span>
<a name="l00760"></a>00760   <span class="comment">// deltat pointers even if they have different build_context()</span>
<a name="l00761"></a>00761   <span class="comment">// overloads.</span>
<a name="l00762"></a>00762   c.<a class="code" href="classlibMesh_1_1DiffContext.php#aa4ede669bc502925b1022a6d8a106cdc">set_deltat_pointer</a> ( &amp;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a> );
<a name="l00763"></a>00763   
<a name="l00764"></a>00764   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context = libmesh_cast_ref&lt;FEMContext&amp;&gt;(c);
<a name="l00765"></a>00765 
<a name="l00766"></a>00766   <span class="comment">// Make sure we&#39;re prepared to do mass integration</span>
<a name="l00767"></a>00767   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = 0; var != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); ++var)
<a name="l00768"></a>00768     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a50a4fef55dc7025624a81fcbb8db3fca">_time_evolving</a>[var])
<a name="l00769"></a>00769       {
<a name="l00770"></a>00770         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l00771"></a>00771         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00772"></a>00772       }
<a name="l00773"></a>00773 }
<a name="l00774"></a>00774 
<a name="l00775"></a>00775 
<a name="l00776"></a>00776 
<a name="l00777"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a6c08da46138a6cb32ab0d46060700ee1">00777</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a6c08da46138a6cb32ab0d46060700ee1">FEMSystem::time_evolving</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00778"></a>00778 {
<a name="l00779"></a>00779   <span class="comment">// Call the parent function</span>
<a name="l00780"></a>00780   <a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a6ede04c93654df99643da828390b477c">Parent::time_evolving</a>(var);
<a name="l00781"></a>00781 }
<a name="l00782"></a>00782 
<a name="l00783"></a>00783 
<a name="l00784"></a>00784 
<a name="l00785"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a16cba6e08b4e89962bf0175637e62698">00785</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a16cba6e08b4e89962bf0175637e62698">FEMSystem::mesh_position_get</a>()
<a name="l00786"></a>00786 {
<a name="l00787"></a>00787   <span class="comment">// This function makes no sense unless we&#39;ve already picked out some</span>
<a name="l00788"></a>00788   <span class="comment">// variable(s) to reflect mesh position coordinates</span>
<a name="l00789"></a>00789   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a>)
<a name="l00790"></a>00790     libmesh_error();
<a name="l00791"></a>00791 
<a name="l00792"></a>00792   <span class="comment">// We currently assume mesh variables are in our own system</span>
<a name="l00793"></a>00793   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a> != <span class="keyword">this</span>)
<a name="l00794"></a>00794     libmesh_not_implemented();
<a name="l00795"></a>00795 
<a name="l00796"></a>00796   <span class="comment">// Loop over every active mesh element on this processor</span>
<a name="l00797"></a>00797   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00798"></a>00798 
<a name="l00799"></a>00799   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00800"></a>00800     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00801"></a>00801   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00802"></a>00802     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00803"></a>00803 
<a name="l00804"></a>00804   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> con = this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a366c8233acbdcc10ca07bb2a44c7e969">build_context</a>();
<a name="l00805"></a>00805   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;_femcontext = libmesh_cast_ref&lt;FEMContext&amp;&gt;(*con);
<a name="l00806"></a>00806   this-&gt;<a class="code" href="classlibMesh_1_1FEMSystem.php#a5f06215dc236c9f59894d7660392e852">init_context</a>(_femcontext);
<a name="l00807"></a>00807 
<a name="l00808"></a>00808   <span class="comment">// Get the solution&#39;s mesh variables from every element</span>
<a name="l00809"></a>00809   <span class="keywordflow">for</span> ( ; el != end_el; ++el)
<a name="l00810"></a>00810     {
<a name="l00811"></a>00811       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a4f3f3300b191500571bf8e05bc0cf38e">pre_fe_reinit</a>(*<span class="keyword">this</span>, *el);
<a name="l00812"></a>00812 
<a name="l00813"></a>00813       _femcontext.<a class="code" href="classlibMesh_1_1FEMContext.php#a7a6f5aef1fe3a5ac355ae93c9d0d179e">elem_position_get</a>();
<a name="l00814"></a>00814 
<a name="l00815"></a>00815       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00816"></a>00816         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;insert(*_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>],
<a name="l00817"></a>00817                                _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>]);
<a name="l00818"></a>00818       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00819"></a>00819         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;insert(*_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>],
<a name="l00820"></a>00820                                _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>]);
<a name="l00821"></a>00821       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a> != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00822"></a>00822         this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;insert(*_femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#ae0cafd7ed0cc3ed64049dcde2c5def28">elem_subsolutions</a>[<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>],
<a name="l00823"></a>00823                                _femcontext.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>]);
<a name="l00824"></a>00824     }
<a name="l00825"></a>00825 
<a name="l00826"></a>00826   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>-&gt;close();
<a name="l00827"></a>00827 
<a name="l00828"></a>00828   <span class="comment">// And make sure the current_local_solution is up to date too</span>
<a name="l00829"></a>00829   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00830"></a>00830 }
<a name="l00831"></a>00831 
<a name="l00832"></a>00832 
<a name="l00833"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#aa8d1b5b1eb27c3b387b5d4c2d8e9c495">00833</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#aa8d1b5b1eb27c3b387b5d4c2d8e9c495">FEMSystem::eulerian_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00834"></a>00834                                    <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;c)
<a name="l00835"></a>00835 {
<a name="l00836"></a>00836   <span class="comment">// Only calculate a mesh movement residual if it&#39;s necessary</span>
<a name="l00837"></a>00837   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a>)
<a name="l00838"></a>00838     <span class="keywordflow">return</span> request_jacobian;
<a name="l00839"></a>00839 
<a name="l00840"></a>00840   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context = libmesh_cast_ref&lt;FEMContext&amp;&gt;(c);
<a name="l00841"></a>00841 
<a name="l00842"></a>00842   <span class="comment">// This function only supports fully coupled mesh motion for now</span>
<a name="l00843"></a>00843   libmesh_assert(<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a> == <span class="keyword">this</span>);
<a name="l00844"></a>00844 
<a name="l00845"></a>00845   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qpoints = context.<a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a>-&gt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l00846"></a>00846 
<a name="l00847"></a>00847   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_x_dofs = (<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) ?
<a name="l00848"></a>00848                                 0 : context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>].size();
<a name="l00849"></a>00849   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_y_dofs = (<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) ?
<a name="l00850"></a>00850                                 0 : context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>].size();
<a name="l00851"></a>00851   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_z_dofs = (<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a> == <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>) ?
<a name="l00852"></a>00852                                 0 : context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>].size();
<a name="l00853"></a>00853 
<a name="l00854"></a>00854   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> mesh_xyz_var = n_x_dofs ? <a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a> :
<a name="l00855"></a>00855                                    (n_y_dofs ? <a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a> :
<a name="l00856"></a>00856                                    (n_z_dofs ? <a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a> :
<a name="l00857"></a>00857                                     <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>));
<a name="l00858"></a>00858 
<a name="l00859"></a>00859   <span class="comment">// If we&#39;re our own _mesh_sys, we&#39;d better be in charge of</span>
<a name="l00860"></a>00860   <span class="comment">// at least one coordinate, and we&#39;d better have the same</span>
<a name="l00861"></a>00861   <span class="comment">// FE type for all coordinates we are in charge of</span>
<a name="l00862"></a>00862   libmesh_assert(mesh_xyz_var != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00863"></a>00863   libmesh_assert(!n_x_dofs || context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>] ==
<a name="l00864"></a>00864                               context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[mesh_xyz_var]);
<a name="l00865"></a>00865   libmesh_assert(!n_y_dofs || context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>] ==
<a name="l00866"></a>00866                               context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[mesh_xyz_var]);
<a name="l00867"></a>00867   libmesh_assert(!n_z_dofs || context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>] ==
<a name="l00868"></a>00868                               context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[mesh_xyz_var]);
<a name="l00869"></a>00869 
<a name="l00870"></a>00870   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;     &amp;psi =
<a name="l00871"></a>00871     context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[mesh_xyz_var]-&gt;get_phi();
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = 0; var != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); ++var)
<a name="l00874"></a>00874     {
<a name="l00875"></a>00875       <span class="comment">// Mesh motion only affects time-evolving variables</span>
<a name="l00876"></a>00876       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a50a4fef55dc7025624a81fcbb8db3fca">_time_evolving</a>[var])
<a name="l00877"></a>00877         <span class="keywordflow">continue</span>;
<a name="l00878"></a>00878 
<a name="l00879"></a>00879       <span class="comment">// The mesh coordinate variables themselves are Lagrangian,</span>
<a name="l00880"></a>00880       <span class="comment">// not Eulerian, and no convective term is desired.</span>
<a name="l00881"></a>00881       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a> == <span class="keyword">this</span> &amp;&amp;
<a name="l00882"></a>00882           (var == <a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a> ||
<a name="l00883"></a>00883            var == <a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a> ||
<a name="l00884"></a>00884            var == <a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>))
<a name="l00885"></a>00885         <span class="keywordflow">continue</span>;
<a name="l00886"></a>00886 
<a name="l00887"></a>00887       <span class="comment">// Some of this code currently relies on the assumption that</span>
<a name="l00888"></a>00888       <span class="comment">// we can pull mesh coordinate data from our own system</span>
<a name="l00889"></a>00889       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a> != <span class="keyword">this</span>)
<a name="l00890"></a>00890         libmesh_not_implemented();
<a name="l00891"></a>00891 
<a name="l00892"></a>00892       <span class="comment">// This residual should only be called by unsteady solvers:</span>
<a name="l00893"></a>00893       <span class="comment">// if the mesh is steady, there&#39;s no mesh convection term!</span>
<a name="l00894"></a>00894       <a class="code" href="classlibMesh_1_1UnsteadySolver.php">UnsteadySolver</a> *unsteady;
<a name="l00895"></a>00895       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>-&gt;is_steady())
<a name="l00896"></a>00896         <span class="keywordflow">return</span> request_jacobian;
<a name="l00897"></a>00897       <span class="keywordflow">else</span>
<a name="l00898"></a>00898         unsteady = libmesh_cast_ptr&lt;UnsteadySolver*&gt;(this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a482140c2a6e7a15d64faf33412a6a0f3">time_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00899"></a>00899 
<a name="l00900"></a>00900       <span class="keyword">const</span> std::vector&lt;Real&gt; &amp;JxW = 
<a name="l00901"></a>00901         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l00902"></a>00902 
<a name="l00903"></a>00903       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;     &amp;phi =
<a name="l00904"></a>00904         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l00905"></a>00905 
<a name="l00906"></a>00906       <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; &amp;dphi =
<a name="l00907"></a>00907         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_dphi();
<a name="l00908"></a>00908 
<a name="l00909"></a>00909       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_u_dofs = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l00910"></a>00910 
<a name="l00911"></a>00911       <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;Fu = *context.<a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>[var];
<a name="l00912"></a>00912       <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> &amp;Kuu = *context.<a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[var][var];
<a name="l00913"></a>00913 
<a name="l00914"></a>00914       <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> *Kux = n_x_dofs ?
<a name="l00915"></a>00915         context.<a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[var][<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>] : NULL;
<a name="l00916"></a>00916       <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> *Kuy = n_y_dofs ?
<a name="l00917"></a>00917         context.<a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[var][<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>] : NULL;
<a name="l00918"></a>00918       <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> *Kuz = n_z_dofs ?
<a name="l00919"></a>00919         context.<a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[var][<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>] : NULL;
<a name="l00920"></a>00920 
<a name="l00921"></a>00921       std::vector&lt;Real&gt; delta_x(n_x_dofs, 0.);
<a name="l00922"></a>00922       std::vector&lt;Real&gt; delta_y(n_y_dofs, 0.);
<a name="l00923"></a>00923       std::vector&lt;Real&gt; delta_z(n_z_dofs, 0.);
<a name="l00924"></a>00924 
<a name="l00925"></a>00925       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_x_dofs; ++i)
<a name="l00926"></a>00926         {
<a name="l00927"></a>00927           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a>][i];
<a name="l00928"></a>00928           delta_x[i] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(j)) -
<a name="l00929"></a>00929                        <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(unsteady-&gt;<a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a>(j));
<a name="l00930"></a>00930         }
<a name="l00931"></a>00931 
<a name="l00932"></a>00932       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_y_dofs; ++i)
<a name="l00933"></a>00933         {
<a name="l00934"></a>00934           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a>][i];
<a name="l00935"></a>00935           delta_y[i] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(j)) -
<a name="l00936"></a>00936                        <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(unsteady-&gt;<a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a>(j));
<a name="l00937"></a>00937         }
<a name="l00938"></a>00938 
<a name="l00939"></a>00939       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_z_dofs; ++i)
<a name="l00940"></a>00940         {
<a name="l00941"></a>00941           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[<a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a>][i];
<a name="l00942"></a>00942           delta_z[i] = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(j)) -
<a name="l00943"></a>00943                        <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(unsteady-&gt;<a class="code" href="classlibMesh_1_1UnsteadySolver.php#ad7058287f55c038b0b3292031e1c0da6">old_nonlinear_solution</a>(j));
<a name="l00944"></a>00944         }
<a name="l00945"></a>00945 
<a name="l00946"></a>00946       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp = 0; qp != n_qpoints; ++qp)
<a name="l00947"></a>00947         {
<a name="l00948"></a>00948           <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u = context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab600367c74aeef6dc87f5ced048f0035">interior_gradient</a>(var, qp);
<a name="l00949"></a>00949           <a class="code" href="classlibMesh_1_1VectorValue.php">RealGradient</a> convection(0.);
<a name="l00950"></a>00950 
<a name="l00951"></a>00951           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_x_dofs; ++i)
<a name="l00952"></a>00952             convection(0) += delta_x[i] * psi[i][qp];
<a name="l00953"></a>00953           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_y_dofs; ++i)
<a name="l00954"></a>00954             convection(1) += delta_y[i] * psi[i][qp];
<a name="l00955"></a>00955           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_z_dofs; ++i)
<a name="l00956"></a>00956             convection(2) += delta_z[i] * psi[i][qp];
<a name="l00957"></a>00957 
<a name="l00958"></a>00958           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != n_u_dofs; ++i)
<a name="l00959"></a>00959             {
<a name="l00960"></a>00960               <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> JxWxPhiI = JxW[qp] * phi[i][qp];
<a name="l00961"></a>00961               Fu(i) += (convection * grad_u) * JxWxPhiI;
<a name="l00962"></a>00962               <span class="keywordflow">if</span> (request_jacobian)
<a name="l00963"></a>00963                 {
<a name="l00964"></a>00964                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> JxWxPhiI = JxW[qp] * phi[i][qp];
<a name="l00965"></a>00965                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != n_u_dofs; ++j)
<a name="l00966"></a>00966                     Kuu(i,j) += JxWxPhiI * (convection * dphi[j][qp]);
<a name="l00967"></a>00967 
<a name="l00968"></a>00968                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> JxWxPhiIoverDT = JxWxPhiI/this-&gt;<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a2b792f8f71393719e56312995d863b04">deltat</a>;
<a name="l00969"></a>00969 
<a name="l00970"></a>00970                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> JxWxPhiIxDUDXoverDT = JxWxPhiIoverDT * grad_u(0);
<a name="l00971"></a>00971                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != n_x_dofs; ++j)
<a name="l00972"></a>00972                     (*Kux)(i,j) += JxWxPhiIxDUDXoverDT * psi[j][qp];
<a name="l00973"></a>00973 
<a name="l00974"></a>00974                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> JxWxPhiIxDUDYoverDT = JxWxPhiIoverDT * grad_u(1);
<a name="l00975"></a>00975                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != n_y_dofs; ++j)
<a name="l00976"></a>00976                     (*Kuy)(i,j) += JxWxPhiIxDUDYoverDT * psi[j][qp];
<a name="l00977"></a>00977 
<a name="l00978"></a>00978                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> JxWxPhiIxDUDZoverDT = JxWxPhiIoverDT * grad_u(2);
<a name="l00979"></a>00979                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j != n_z_dofs; ++j)
<a name="l00980"></a>00980                     (*Kuz)(i,j) += JxWxPhiIxDUDZoverDT * psi[j][qp];
<a name="l00981"></a>00981                 }
<a name="l00982"></a>00982             }
<a name="l00983"></a>00983         }
<a name="l00984"></a>00984     }
<a name="l00985"></a>00985 
<a name="l00986"></a>00986   <span class="keywordflow">return</span> request_jacobian;
<a name="l00987"></a>00987 }
<a name="l00988"></a>00988 
<a name="l00989"></a>00989       
<a name="l00990"></a>00990 
<a name="l00991"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a04f21d6113781ff306a4d484448ee199">00991</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a04f21d6113781ff306a4d484448ee199">FEMSystem::mass_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00992"></a>00992                                <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;c)
<a name="l00993"></a>00993 {
<a name="l00994"></a>00994   <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context = libmesh_cast_ref&lt;FEMContext&amp;&gt;(c);
<a name="l00995"></a>00995 
<a name="l00996"></a>00996   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qpoints = context.<a class="code" href="classlibMesh_1_1FEMContext.php#ae13cf73442456b127e9a209e26dd163e">element_qrule</a>-&gt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l00997"></a>00997 
<a name="l00998"></a>00998   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = 0; var != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>(); ++var)
<a name="l00999"></a>00999     {
<a name="l01000"></a>01000       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DifferentiableSystem.php#a50a4fef55dc7025624a81fcbb8db3fca">_time_evolving</a>[var])
<a name="l01001"></a>01001         <span class="keywordflow">continue</span>;
<a name="l01002"></a>01002 
<a name="l01003"></a>01003       <span class="keyword">const</span> std::vector&lt;Real&gt; &amp;JxW = 
<a name="l01004"></a>01004         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_JxW();
<a name="l01005"></a>01005 
<a name="l01006"></a>01006       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; &amp;phi =
<a name="l01007"></a>01007         context.<a class="code" href="classlibMesh_1_1FEMContext.php#ab383f19798c04ded72cff9f031c7e626">element_fe_var</a>[var]-&gt;get_phi();
<a name="l01008"></a>01008 
<a name="l01009"></a>01009       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a> = context.<a class="code" href="classlibMesh_1_1DiffContext.php#a7d609caec46d2087753fffc144da7264">dof_indices_var</a>[var].size();
<a name="l01010"></a>01010 
<a name="l01011"></a>01011       <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;Number&gt;</a> &amp;Fu = *context.<a class="code" href="classlibMesh_1_1DiffContext.php#af7c90c20ab2a20247cb4f194a8f92604">elem_subresiduals</a>[var];
<a name="l01012"></a>01012       <a class="code" href="classlibMesh_1_1DenseSubMatrix.php">DenseSubMatrix&lt;Number&gt;</a> &amp;Kuu = *context.<a class="code" href="classlibMesh_1_1DiffContext.php#a02e5af8c7aaaf27567b80a0855697abe">elem_subjacobians</a>[var][var];
<a name="l01013"></a>01013 
<a name="l01014"></a>01014       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp = 0; qp != n_qpoints; ++qp)
<a name="l01015"></a>01015         {
<a name="l01016"></a>01016           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u = context.<a class="code" href="classlibMesh_1_1FEMContext.php#a15df99c408b61d4d93bc18c5ecbde22c">interior_value</a>(var, qp);
<a name="l01017"></a>01017           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> JxWxU = JxW[qp] * u;
<a name="l01018"></a>01018           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; ++i)
<a name="l01019"></a>01019             {
<a name="l01020"></a>01020               Fu(i) += JxWxU * phi[i][qp];
<a name="l01021"></a>01021               <span class="keywordflow">if</span> (request_jacobian &amp;&amp; context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a>)
<a name="l01022"></a>01022                 {
<a name="l01023"></a>01023                   libmesh_assert (context.<a class="code" href="classlibMesh_1_1DiffContext.php#a00397dfaaa0eaaeb17205942bcdae88e">elem_solution_derivative</a> == 1.0);
<a name="l01024"></a>01024 
<a name="l01025"></a>01025                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> JxWxPhiI = JxW[qp] * phi[i][qp];
<a name="l01026"></a>01026                   Kuu(i,i) += JxWxPhiI * phi[i][qp];
<a name="l01027"></a>01027                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = i+1; j &lt; <a class="code" href="classlibMesh_1_1System.php#a90dbb901f00c14ff18399f4afabcebe5">n_dofs</a>; ++j)
<a name="l01028"></a>01028                     {
<a name="l01029"></a>01029                       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> Kij = JxWxPhiI * phi[j][qp];
<a name="l01030"></a>01030                       Kuu(i,j) += Kij;
<a name="l01031"></a>01031                       Kuu(j,i) += Kij;
<a name="l01032"></a>01032                     }
<a name="l01033"></a>01033                 }
<a name="l01034"></a>01034             }
<a name="l01035"></a>01035         }
<a name="l01036"></a>01036     }
<a name="l01037"></a>01037 
<a name="l01038"></a>01038   <span class="keywordflow">return</span> request_jacobian;
<a name="l01039"></a>01039 }
<a name="l01040"></a>01040 
<a name="l01041"></a>01041 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
