<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fem_system.h</div>  </div>
</div>
<div class="contents">
<a href="fem__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: fem_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __fem_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __fem_system_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>DiffContext;
<a name="l00036"></a>00036 <span class="keyword">class </span>FEMContext;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// FEMSystem class definition</span>
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classlibMesh_1_1FEMSystem.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FEMSystem.php">FEMSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php">DifferentiableSystem</a>
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00059"></a>00059 
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1FEMSystem.php#a6a2ed16b3026fb1719e44d9128d1e9e5">FEMSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00065"></a>00065                  <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00066"></a>00066                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a754c3896a0b7c7a426bc2b272888de96">~FEMSystem</a> ();
<a name="l00072"></a>00072 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a436edbcb99b8aac39976871a2f27f5a7">00076</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1FEMSystem.php">FEMSystem</a> <a class="code" href="classlibMesh_1_1FEMSystem.php#a436edbcb99b8aac39976871a2f27f5a7">sys_type</a>;
<a name="l00077"></a>00077 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a374efee236c5aa4095a37c0151798be4">00081</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DifferentiableSystem.php">DifferentiableSystem</a> <a class="code" href="classlibMesh_1_1FEMSystem.php#a374efee236c5aa4095a37c0151798be4">Parent</a>;
<a name="l00082"></a>00082   
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a18808e75d1ea6c77321edd13a88c2af8">clear</a> ();
<a name="l00088"></a>00088 
<a name="l00094"></a>00094   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#af3303ea7a8722e00389473f4094660d7">assembly</a> (<span class="keywordtype">bool</span> get_residual, <span class="keywordtype">bool</span> get_jacobian);
<a name="l00095"></a>00095 
<a name="l00104"></a>00104   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a0e3ea4362b5e9fcb60a7caa2f08f11a7">solve</a> ();
<a name="l00105"></a>00105 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a6c08da46138a6cb32ab0d46060700ee1">time_evolving</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00118"></a>00118 
<a name="l00142"></a>00142   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#af69758992c73431f2ef1023ad20e74c2">set_mesh_system</a>(<a class="code" href="classlibMesh_1_1System.php">System</a>* sys);
<a name="l00143"></a>00143 
<a name="l00158"></a>00158   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#aa47ff766e091aa04e64405a239618c79">set_mesh_x_var</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00159"></a>00159 
<a name="l00164"></a>00164   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#afd7fd729546dd140f2ea2c6490351a9b">set_mesh_y_var</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00165"></a>00165 
<a name="l00170"></a>00170   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a28e0f20f76423e4f021a44a635c89e3c">set_mesh_z_var</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00171"></a>00171 
<a name="l00176"></a>00176   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a16cba6e08b4e89962bf0175637e62698">mesh_position_get</a>();
<a name="l00177"></a>00177 
<a name="l00182"></a>00182   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a2efde0dcca62566606f1a259d7de53eb">mesh_position_set</a>();
<a name="l00183"></a>00183 
<a name="l00198"></a>00198   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#aa8d1b5b1eb27c3b387b5d4c2d8e9c495">eulerian_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00199"></a>00199                                   <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;context);
<a name="l00200"></a>00200 
<a name="l00214"></a>00214   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a04f21d6113781ff306a4d484448ee199">mass_residual</a> (<span class="keywordtype">bool</span> request_jacobian,
<a name="l00215"></a>00215                               <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;context);
<a name="l00216"></a>00216 
<a name="l00225"></a>00225   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;DiffContext&gt;</a> <a class="code" href="classlibMesh_1_1FEMSystem.php#a366c8233acbdcc10ca07bb2a44c7e969">build_context</a>();
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="comment">/*</span>
<a name="l00228"></a>00228 <span class="comment">   * Prepares the result of a build_context() call for use.</span>
<a name="l00229"></a>00229 <span class="comment">   * </span>
<a name="l00230"></a>00230 <span class="comment">   * Most FEMSystem-based problems will need to reimplement this in order to</span>
<a name="l00231"></a>00231 <span class="comment">   * call FE::get_*() as their particular physics requires.</span>
<a name="l00232"></a>00232 <span class="comment">   */</span>
<a name="l00233"></a>00233   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a5f06215dc236c9f59894d7660392e852">init_context</a>(<a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a> &amp;);
<a name="l00234"></a>00234  
<a name="l00239"></a>00239   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a3e52060d9238a685914b8b3b5626d587">postprocess</a> ();
<a name="l00240"></a>00240 
<a name="l00248"></a>00248   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#af972b63d2caa5f509aace49a801466ad">assemble_qoi</a>
<a name="l00249"></a>00249     (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00250"></a>00250 
<a name="l00258"></a>00258   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a22025e7b44e9a73834cbd1831d0f9b68">assemble_qoi_derivative</a>
<a name="l00259"></a>00259     (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00260"></a>00260 
<a name="l00267"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a267ad32ebc39d8f8a966682615e28dae">00267</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a267ad32ebc39d8f8a966682615e28dae">fe_reinit_during_postprocess</a>;
<a name="l00268"></a>00268 
<a name="l00274"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a73b4c7f9f81fc10f215caf1f4799664a">00274</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEMSystem.php#a73b4c7f9f81fc10f215caf1f4799664a">numerical_jacobian_h</a>;
<a name="l00275"></a>00275 
<a name="l00289"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">00289</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1FEMSystem.php#af3b49eeb3527a6aab2cf647fdb71d3e4">verify_analytic_jacobians</a>;
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 <span class="keyword">protected</span>:
<a name="l00296"></a>00296   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a98c0176dcaa48e80b848e49987b9e6f8">init_data</a> ();
<a name="l00297"></a>00297 
<a name="l00301"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a1b0309d81e51a657209482a80e4a9047">00301</a>   <span class="keyword">typedef</span> bool (<a class="code" href="classlibMesh_1_1TimeSolver.php">TimeSolver</a>::*<a class="code" href="classlibMesh_1_1FEMSystem.php#a1b0309d81e51a657209482a80e4a9047">TimeSolverResPtr</a>)(bool, <a class="code" href="classlibMesh_1_1DiffContext.php">DiffContext</a>&amp;);
<a name="l00302"></a>00302 
<a name="l00307"></a>00307   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#ac1680f6482fb491cc89e4462846006f4">numerical_jacobian</a> (<a class="code" href="classlibMesh_1_1FEMSystem.php#a1b0309d81e51a657209482a80e4a9047">TimeSolverResPtr</a> res,
<a name="l00308"></a>00308                            <a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context);
<a name="l00309"></a>00309 
<a name="l00315"></a>00315   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a0a68297c6c5be66b9df3921f6c040d91">numerical_elem_jacobian</a> (<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context);
<a name="l00316"></a>00316 
<a name="l00322"></a>00322   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a7a44c3fd10ff85e68f55d4be3eb61e0e">numerical_side_jacobian</a> (<a class="code" href="classlibMesh_1_1FEMContext.php">FEMContext</a> &amp;context);
<a name="l00323"></a>00323 };
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00328"></a>00328 <span class="comment">// FEMSystem inline methods</span>
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="keyword">inline</span>
<a name="l00333"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#af69758992c73431f2ef1023ad20e74c2">00333</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#af69758992c73431f2ef1023ad20e74c2">FEMSystem::set_mesh_system</a>(<a class="code" href="classlibMesh_1_1System.php">System</a>* sys)
<a name="l00334"></a>00334 {
<a name="l00335"></a>00335   <span class="comment">// For now we assume that we&#39;re doing fully coupled mesh motion</span>
<a name="l00336"></a>00336   <span class="keywordflow">if</span> (sys &amp;&amp; sys != <span class="keyword">this</span>)
<a name="l00337"></a>00337     libmesh_not_implemented();
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="comment">// For the foreseeable future we&#39;ll assume that we keep these</span>
<a name="l00340"></a>00340   <span class="comment">// Systems in the same EquationSystems</span>
<a name="l00341"></a>00341   libmesh_assert(&amp;this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>() ==
<a name="l00342"></a>00342                  &amp;sys-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>());
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="comment">// And for the immediate future this code may not even work</span>
<a name="l00345"></a>00345   libmesh_experimental();
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   <a class="code" href="classlibMesh_1_1System.php#a5c1eb01a3714bd870f38e2493e8e200a">_mesh_sys</a> = sys;
<a name="l00348"></a>00348 }
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 <span class="keyword">inline</span>
<a name="l00353"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#aa47ff766e091aa04e64405a239618c79">00353</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#aa47ff766e091aa04e64405a239618c79">FEMSystem::set_mesh_x_var</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   <a class="code" href="classlibMesh_1_1System.php#a4ba10714ce3d0f2f0ebea5af774c0410">_mesh_x_var</a> = var;
<a name="l00356"></a>00356 }
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 <span class="keyword">inline</span>
<a name="l00361"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#afd7fd729546dd140f2ea2c6490351a9b">00361</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#afd7fd729546dd140f2ea2c6490351a9b">FEMSystem::set_mesh_y_var</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00362"></a>00362 {
<a name="l00363"></a>00363   <a class="code" href="classlibMesh_1_1System.php#a6e5e444236409ae047939d411925029a">_mesh_y_var</a> = var;
<a name="l00364"></a>00364 }
<a name="l00365"></a>00365 
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 <span class="keyword">inline</span>
<a name="l00369"></a><a class="code" href="classlibMesh_1_1FEMSystem.php#a28e0f20f76423e4f021a44a635c89e3c">00369</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FEMSystem.php#a28e0f20f76423e4f021a44a635c89e3c">FEMSystem::set_mesh_z_var</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00370"></a>00370 {
<a name="l00371"></a>00371   <a class="code" href="classlibMesh_1_1System.php#abe79ee716383ee682c44083728292e44">_mesh_z_var</a> = var;
<a name="l00372"></a>00372 }
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 } <span class="comment">// namespace libMesh</span>
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
