<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fourth_error_estimators.C</div>  </div>
</div>
<div class="contents">
<a href="fourth__error__estimators_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fourth_error_estimators.C 4015 2010-10-01 21:03:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;cmath&gt;</span>    <span class="comment">// for sqrt</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="fourth__error__estimators_8h.php">fourth_error_estimators.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>libMesh
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keywordtype">void</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1LaplacianErrorEstimator.php#a2f5afc4c291d0e9e23ef7e73300f3a5e">00047</a> <a class="code" href="classlibMesh_1_1LaplacianErrorEstimator.php#a2f5afc4c291d0e9e23ef7e73300f3a5e">LaplacianErrorEstimator::initialize</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;,
<a name="l00048"></a>00048                                     <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp;,
<a name="l00049"></a>00049                                     <span class="keywordtype">bool</span>)
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051   <span class="comment">// We&#39;ll need second derivatives for Laplacian jump computation</span>
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;get_d2phi();
<a name="l00053"></a>00053   <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a67599bdd08ab287db8b455660542bc19">fe_coarse</a>-&gt;get_d2phi();
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 <span class="keywordtype">void</span>
<a name="l00059"></a><a class="code" href="classlibMesh_1_1LaplacianErrorEstimator.php#aff63af0ef4f7469eded6fac434006820">00059</a> <a class="code" href="classlibMesh_1_1LaplacianErrorEstimator.php#aff63af0ef4f7469eded6fac434006820">LaplacianErrorEstimator::internal_side_integration</a> ()
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error = 1.e-30;
<a name="l00062"></a>00062   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;n_quadrature_points();
<a name="l00063"></a>00063   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_fine_dofs = <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>();
<a name="l00064"></a>00064   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_coarse_dofs = <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6cb5f9a7c33e98c66e60f60332efd772">Ucoarse</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>();
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   std::vector&lt;std::vector&lt;RealTensor&gt; &gt; d2phi_coarse = <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a67599bdd08ab287db8b455660542bc19">fe_coarse</a>-&gt;get_d2phi();
<a name="l00069"></a>00069   std::vector&lt;std::vector&lt;RealTensor&gt; &gt; d2phi_fine = <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;get_d2phi();
<a name="l00070"></a>00070   std::vector&lt;Real&gt; JxW_face = <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;get_JxW();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp != n_qp; ++qp)
<a name="l00073"></a>00073     {
<a name="l00074"></a>00074       <span class="comment">// Calculate solution gradients on fine and coarse elements</span>
<a name="l00075"></a>00075       <span class="comment">// at this quadrature point</span>
<a name="l00076"></a>00076       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> laplacian_fine = 0., laplacian_coarse = 0.;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_coarse_dofs; ++i)
<a name="l00079"></a>00079         {
<a name="l00080"></a>00080           laplacian_coarse += d2phi_coarse[i][qp](0,0) * <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6cb5f9a7c33e98c66e60f60332efd772">Ucoarse</a>(i);
<a name="l00081"></a>00081           <span class="keywordflow">if</span> (dim &gt; 1)
<a name="l00082"></a>00082             laplacian_coarse += d2phi_coarse[i][qp](1,1) * <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6cb5f9a7c33e98c66e60f60332efd772">Ucoarse</a>(i);
<a name="l00083"></a>00083           <span class="keywordflow">if</span> (dim &gt; 2)
<a name="l00084"></a>00084             laplacian_coarse += d2phi_coarse[i][qp](2,2) * <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6cb5f9a7c33e98c66e60f60332efd772">Ucoarse</a>(i);
<a name="l00085"></a>00085         }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_fine_dofs; ++i)
<a name="l00088"></a>00088         {
<a name="l00089"></a>00089           laplacian_fine += d2phi_fine[i][qp](0,0) * <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>(i);
<a name="l00090"></a>00090           <span class="keywordflow">if</span> (dim &gt; 1)
<a name="l00091"></a>00091             laplacian_fine += d2phi_fine[i][qp](1,1) * <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>(i);
<a name="l00092"></a>00092           <span class="keywordflow">if</span> (dim &gt; 2)
<a name="l00093"></a>00093             laplacian_fine += d2phi_fine[i][qp](2,2) * <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>(i);
<a name="l00094"></a>00094         }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096                                 
<a name="l00097"></a>00097       <span class="comment">// Find the jump in the Laplacian</span>
<a name="l00098"></a>00098       <span class="comment">// at this quadrature point</span>
<a name="l00099"></a>00099       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> jump = laplacian_fine - laplacian_coarse;
<a name="l00100"></a>00100       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> jump2 = <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(jump);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102       <span class="comment">// Accumulate the jump integral</span>
<a name="l00103"></a>00103       error += JxW_face[qp] * jump2;
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">// Add the h-weighted jump integral to each error term</span>
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a28cc78a25a550e30504bfef7402398d3">fine_error</a> =
<a name="l00108"></a>00108     error * <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af238e5529e55b1c434b0a6ec923b5f47">hmax</a>() * <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>);
<a name="l00109"></a>00109   <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a5999107dbf9dfc4166e59cdc6e1c24fe">coarse_error</a> =
<a name="l00110"></a>00110     error * <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af238e5529e55b1c434b0a6ec923b5f47">hmax</a>() * <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>);
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 } <span class="comment">// namespace libMesh</span>
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="preprocessor">#else // defined (LIBMESH_ENABLE_SECOND_DERIVATIVES)</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>
<a name="l00117"></a>00117 <span class="preprocessor">#include &quot;<a class="code" href="fourth__error__estimators_8h.php">fourth_error_estimators.h</a>&quot;</span>
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="keyword">namespace </span>libMesh
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="keywordtype">void</span>
<a name="l00123"></a>00123 <a class="code" href="classlibMesh_1_1LaplacianErrorEstimator.php#a2f5afc4c291d0e9e23ef7e73300f3a5e">LaplacianErrorEstimator::initialize</a>(<span class="keyword">const</span> System&amp;,
<a name="l00124"></a>00124                                     ErrorVector&amp;,
<a name="l00125"></a>00125                                     <span class="keywordtype">bool</span>)
<a name="l00126"></a>00126 {
<a name="l00127"></a>00127   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: LaplacianErrorEstimator requires second &quot;</span>
<a name="l00128"></a>00128                 &lt;&lt; <span class="stringliteral">&quot;derivative support; try configuring libmesh with &quot;</span>
<a name="l00129"></a>00129                 &lt;&lt; <span class="stringliteral">&quot;--enable-second&quot;</span> &lt;&lt; std::endl;
<a name="l00130"></a>00130   libmesh_error();
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="keywordtype">void</span>
<a name="l00135"></a>00135 <a class="code" href="classlibMesh_1_1LaplacianErrorEstimator.php#aff63af0ef4f7469eded6fac434006820">LaplacianErrorEstimator::internal_side_integration</a> ()
<a name="l00136"></a>00136 {
<a name="l00137"></a>00137   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: LaplacianErrorEstimator requires second &quot;</span>
<a name="l00138"></a>00138                 &lt;&lt; <span class="stringliteral">&quot;derivative support; try configuring libmesh with &quot;</span>
<a name="l00139"></a>00139                 &lt;&lt; <span class="stringliteral">&quot;--enable-second&quot;</span> &lt;&lt; std::endl;
<a name="l00140"></a>00140   libmesh_error();
<a name="l00141"></a>00141 }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 } <span class="comment">// namespace libMesh</span>
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="preprocessor">#endif // defined (LIBMESH_ENABLE_SECOND_DERIVATIVES)</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>
<a name="l00147"></a>00147 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
