<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">frequency_system.C</div>  </div>
</div>
<div class="contents">
<a href="frequency__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: frequency_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">/*</span>
<a name="l00026"></a>00026 <span class="comment"> * Require complex arithmetic</span>
<a name="l00027"></a>00027 <span class="comment"> */</span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// C++ includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;cstdio&gt;</span>          <span class="comment">// for sprintf</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Local includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="frequency__system_8h.php">frequency_system.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// FrequencySystem implementation</span>
<a name="l00048"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a00030d32408a9a9a3eb91adaa7484e81">00048</a> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a00030d32408a9a9a3eb91adaa7484e81">FrequencySystem::FrequencySystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00049"></a>00049                                   <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00050"></a>00050                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00051"></a>00051   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php">LinearImplicitSystem</a>      (es, name, number),
<a name="l00052"></a>00052   solve_system              (NULL),
<a name="l00053"></a>00053   _finished_set_frequencies (false),
<a name="l00054"></a>00054   _keep_solution_duplicates (true),
<a name="l00055"></a>00055   _finished_init            (false),
<a name="l00056"></a>00056   _finished_assemble        (false)
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   <span class="comment">// default value for wave speed &amp; fluid density</span>
<a name="l00059"></a>00059   <span class="comment">//_equation_systems.parameters.set&lt;Real&gt;(&quot;wave speed&quot;) = 340.;</span>
<a name="l00060"></a>00060   <span class="comment">//_equation_systems.parameters.set&lt;Real&gt;(&quot;rho&quot;)        = 1.225;</span>
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#add8057ad281faad75441fec67d57ffc8">00065</a> <a class="code" href="classlibMesh_1_1FrequencySystem.php#add8057ad281faad75441fec67d57ffc8">FrequencySystem::~FrequencySystem</a> ()
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a94c273a276f9705a182c38e79e67ad66">clear</a> ();
<a name="l00068"></a>00068   
<a name="l00069"></a>00069   <span class="comment">// the additional matrices and vectors are cleared and zero&#39;ed in System</span>
<a name="l00070"></a>00070 }
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a94c273a276f9705a182c38e79e67ad66">00075</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a94c273a276f9705a182c38e79e67ad66">FrequencySystem::clear</a> ()
<a name="l00076"></a>00076 {
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a94c273a276f9705a182c38e79e67ad66">LinearImplicitSystem::clear</a>();
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a> = <span class="keyword">false</span>;
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">_keep_solution_duplicates</a> = <span class="keyword">true</span>;
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a270d4a54360e4460153d9bb2d184398e">_finished_init</a>            = <span class="keyword">false</span>;
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a3d8f524b918cc82ab43c13e2c9ccdc5e">_finished_assemble</a>        = <span class="keyword">false</span>;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">/*</span>
<a name="l00085"></a>00085 <span class="comment">   * We have to distinguish between the</span>
<a name="l00086"></a>00086 <span class="comment">   * simple straightforward &quot;clear()&quot;</span>
<a name="l00087"></a>00087 <span class="comment">   * and the clear that also touches the</span>
<a name="l00088"></a>00088 <span class="comment">   * EquationSystems parameters &quot;current frequency&quot; etc.</span>
<a name="l00089"></a>00089 <span class="comment">   * Namely, when reading from file (through equation_systems_io.C</span>
<a name="l00090"></a>00090 <span class="comment">   * methods), the param&#39;s are read in, then the systems.</span>
<a name="l00091"></a>00091 <span class="comment">   * Prior to reading a system, this system gets cleared...</span>
<a name="l00092"></a>00092 <span class="comment">   * And there, all the previously loaded frequency parameters</span>
<a name="l00093"></a>00093 <span class="comment">   * would get lost...</span>
<a name="l00094"></a>00094 <span class="comment">   */</span>
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a92f7b5f6a6364cbfdda703ecafc37d07">00099</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a92f7b5f6a6364cbfdda703ecafc37d07">FrequencySystem::clear_all</a> ()
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a94c273a276f9705a182c38e79e67ad66">clear</a> ();
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00104"></a>00104     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00105"></a>00105   
<a name="l00106"></a>00106   <span class="comment">// clear frequencies in the parameters section of the </span>
<a name="l00107"></a>00107   <span class="comment">// EquationSystems object</span>
<a name="l00108"></a>00108   <span class="keywordflow">if</span> (es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; (<span class="stringliteral">&quot;n_frequencies&quot;</span>))
<a name="l00109"></a>00109     {
<a name="l00110"></a>00110       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n &lt; es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>); n++)
<a name="l00111"></a>00111         es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a06b2f9d9ec57980583bf9aad3c7e03f6">remove</a>(this-&gt;form_freq_param_name(n));
<a name="l00112"></a>00112       es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a06b2f9d9ec57980583bf9aad3c7e03f6">remove</a>(<span class="stringliteral">&quot;current frequency&quot;</span>);
<a name="l00113"></a>00113     }
<a name="l00114"></a>00114 }
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a5b965b58aec67a9ec284d09569409e73">00119</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a5b965b58aec67a9ec284d09569409e73">FrequencySystem::init_data</a> ()
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121   <span class="comment">// initialize parent data and additional solution vectors</span>
<a name="l00122"></a>00122   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a5b965b58aec67a9ec284d09569409e73">LinearImplicitSystem::init_data</a>();
<a name="l00123"></a>00123   
<a name="l00124"></a>00124   <span class="comment">// Log how long initializing the system takes</span>
<a name="l00125"></a>00125   START_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00128"></a>00128     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00129"></a>00129 
<a name="l00130"></a>00130   <span class="comment">// make sure we have frequencies to solve for</span>
<a name="l00131"></a>00131   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a>)
<a name="l00132"></a>00132     {
<a name="l00133"></a>00133       <span class="comment">/*</span>
<a name="l00134"></a>00134 <span class="comment">       * when this system was read from file, check</span>
<a name="l00135"></a>00135 <span class="comment">       * if this has a &quot;n_frequencies&quot; parameter,</span>
<a name="l00136"></a>00136 <span class="comment">       * and initialize us with these.</span>
<a name="l00137"></a>00137 <span class="comment">       */</span>
<a name="l00138"></a>00138       <span class="keywordflow">if</span> (es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a6ced71ca7796d8109dd9b62bd0e1139b">have_parameter</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; (<span class="stringliteral">&quot;n_frequencies&quot;</span>))
<a name="l00139"></a>00139         {
<a name="l00140"></a>00140           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq = 
<a name="l00141"></a>00141             es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>);
<a name="l00142"></a>00142 
<a name="l00143"></a>00143           libmesh_assert(n_freq &gt; 0);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145           <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a> = <span class="keyword">true</span>;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147           this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a80e407a5411f20d3311f24c67a0926a0">set_current_frequency</a>(0);
<a name="l00148"></a>00148         }
<a name="l00149"></a>00149       <span class="keywordflow">else</span>
<a name="l00150"></a>00150         {
<a name="l00151"></a>00151           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Need to set frequencies before calling init(). &quot;</span> &lt;&lt; std::endl;
<a name="l00152"></a>00152           libmesh_error();
<a name="l00153"></a>00153         }
<a name="l00154"></a>00154     }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a270d4a54360e4460153d9bb2d184398e">_finished_init</a> = <span class="keyword">true</span>;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   <span class="comment">// Stop logging init()</span>
<a name="l00159"></a>00159   STOP_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#aaee3ed97a002df300e11b5b2c6d37d67">00164</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#aaee3ed97a002df300e11b5b2c6d37d67">FrequencySystem::assemble</a> ()
<a name="l00165"></a>00165 {
<a name="l00166"></a>00166   libmesh_assert (<a class="code" href="classlibMesh_1_1FrequencySystem.php#a270d4a54360e4460153d9bb2d184398e">_finished_init</a>);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FrequencySystem.php#a3d8f524b918cc82ab43c13e2c9ccdc5e">_finished_assemble</a>)  
<a name="l00169"></a>00169     {
<a name="l00170"></a>00170       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Matrices already assembled.&quot;</span> &lt;&lt; std::endl;
<a name="l00171"></a>00171       libmesh_error (); 
<a name="l00172"></a>00172     }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="comment">// Log how long assemble() takes</span>
<a name="l00175"></a>00175   START_LOG(<span class="stringliteral">&quot;assemble()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// prepare matrix with the help of the _dof_map, </span>
<a name="l00178"></a>00178   <span class="comment">// fill with sparsity pattern, initialize the</span>
<a name="l00179"></a>00179   <span class="comment">// additional matrices</span>
<a name="l00180"></a>00180   <a class="code" href="classlibMesh_1_1FrequencySystem.php#aaee3ed97a002df300e11b5b2c6d37d67">LinearImplicitSystem::assemble</a>();
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">//matrix.print ();</span>
<a name="l00183"></a>00183   <span class="comment">//rhs.print    ();</span>
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a3d8f524b918cc82ab43c13e2c9ccdc5e">_finished_assemble</a> = <span class="keyword">true</span>;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="comment">// Log how long assemble() takes</span>
<a name="l00188"></a>00188   STOP_LOG(<span class="stringliteral">&quot;assemble()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a57f1cf3d31db4a89aff7956cdfe74a98">00193</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a57f1cf3d31db4a89aff7956cdfe74a98">FrequencySystem::set_frequencies_by_steps</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> base_freq,
<a name="l00194"></a>00194                                                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> freq_step,
<a name="l00195"></a>00195                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq,
<a name="l00196"></a>00196                                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates)
<a name="l00197"></a>00197 {
<a name="l00198"></a>00198   this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">_keep_solution_duplicates</a> = allocate_solution_duplicates;
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="comment">// sanity check</span>
<a name="l00201"></a>00201   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a>)
<a name="l00202"></a>00202     {
<a name="l00203"></a>00203       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: frequencies already initialized.&quot;</span> 
<a name="l00204"></a>00204                     &lt;&lt; std::endl;
<a name="l00205"></a>00205       libmesh_error();
<a name="l00206"></a>00206     }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00209"></a>00209     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="comment">// store number of frequencies as parameter</span>
<a name="l00212"></a>00212   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>) = n_freq;
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_freq; n++)
<a name="l00215"></a>00215     {
<a name="l00216"></a>00216       <span class="comment">// remember frequencies as parameters</span>
<a name="l00217"></a>00217       es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a136920d148cf01fa1a14497b43faba5a">form_freq_param_name</a>(n)) = 
<a name="l00218"></a>00218           base_freq + n * freq_step;
<a name="l00219"></a>00219 
<a name="l00220"></a>00220       <span class="comment">// build storage for solution vector, if wanted</span>
<a name="l00221"></a>00221       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">_keep_solution_duplicates</a>)
<a name="l00222"></a>00222           this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a>(this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#afc99310d64cf696e1a33f9bcef5179d1">form_solu_vec_name</a>(n));
<a name="l00223"></a>00223     }  
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a> = <span class="keyword">true</span>;
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="comment">// set the current frequency</span>
<a name="l00228"></a>00228   this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a80e407a5411f20d3311f24c67a0926a0">set_current_frequency</a>(0);
<a name="l00229"></a>00229 }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#aecf9f2533e427a9cde8c40cb661d78b8">00233</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#aecf9f2533e427a9cde8c40cb661d78b8">FrequencySystem::set_frequencies_by_range</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> min_freq,
<a name="l00234"></a>00234                                                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> max_freq,
<a name="l00235"></a>00235                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq,
<a name="l00236"></a>00236                                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates)
<a name="l00237"></a>00237 {
<a name="l00238"></a>00238   this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">_keep_solution_duplicates</a> = allocate_solution_duplicates;
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="comment">// sanity checks</span>
<a name="l00241"></a>00241   libmesh_assert(max_freq &gt; min_freq);
<a name="l00242"></a>00242   libmesh_assert(n_freq &gt; 0);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a>)
<a name="l00245"></a>00245     {
<a name="l00246"></a>00246       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: frequencies already initialized. &quot;</span> &lt;&lt; std::endl;
<a name="l00247"></a>00247       libmesh_error();
<a name="l00248"></a>00248     }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00251"></a>00251     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">// store number of frequencies as parameter</span>
<a name="l00254"></a>00254   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>) = n_freq;
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="comment">// set frequencies, build solution storage</span>
<a name="l00257"></a>00257   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_freq; n++)
<a name="l00258"></a>00258     {
<a name="l00259"></a>00259       <span class="comment">// remember frequencies as parameters</span>
<a name="l00260"></a>00260       es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a136920d148cf01fa1a14497b43faba5a">form_freq_param_name</a>(n)) = 
<a name="l00261"></a>00261           min_freq + n*(max_freq-min_freq)/(n_freq-1);
<a name="l00262"></a>00262       
<a name="l00263"></a>00263       <span class="comment">// build storage for solution vector, if wanted</span>
<a name="l00264"></a>00264       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">_keep_solution_duplicates</a>)
<a name="l00265"></a>00265           <a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">System::add_vector</a>(this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#afc99310d64cf696e1a33f9bcef5179d1">form_solu_vec_name</a>(n));
<a name="l00266"></a>00266     }  
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a> = <span class="keyword">true</span>;
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="comment">// set the current frequency</span>
<a name="l00271"></a>00271   this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a80e407a5411f20d3311f24c67a0926a0">set_current_frequency</a>(0);
<a name="l00272"></a>00272 }
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#ae7db125bb552d7fa429f561a25600b69">00276</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#ae7db125bb552d7fa429f561a25600b69">FrequencySystem::set_frequencies</a> (<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; frequencies,
<a name="l00277"></a>00277                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates)
<a name="l00278"></a>00278 {
<a name="l00279"></a>00279   this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">_keep_solution_duplicates</a> = allocate_solution_duplicates;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="comment">// sanity checks</span>
<a name="l00282"></a>00282   libmesh_assert(!frequencies.empty());
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a>)
<a name="l00285"></a>00285     {
<a name="l00286"></a>00286       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: frequencies already initialized. &quot;</span> &lt;&lt; std::endl;
<a name="l00287"></a>00287       libmesh_error();
<a name="l00288"></a>00288     }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00291"></a>00291     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="comment">// store number of frequencies as parameter</span>
<a name="l00294"></a>00294   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>) = frequencies.size();
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="comment">// set frequencies, build solution storage</span>
<a name="l00297"></a>00297   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;frequencies.size(); n++)
<a name="l00298"></a>00298     {
<a name="l00299"></a>00299       <span class="comment">// remember frequencies as parameters</span>
<a name="l00300"></a>00300       es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a136920d148cf01fa1a14497b43faba5a">form_freq_param_name</a>(n)) = frequencies[n];
<a name="l00301"></a>00301       
<a name="l00302"></a>00302       <span class="comment">// build storage for solution vector, if wanted</span>
<a name="l00303"></a>00303       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">_keep_solution_duplicates</a>)
<a name="l00304"></a>00304           <a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">System::add_vector</a>(this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#afc99310d64cf696e1a33f9bcef5179d1">form_solu_vec_name</a>(n));
<a name="l00305"></a>00305     }  
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a> = <span class="keyword">true</span>;
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <span class="comment">// set the current frequency</span>
<a name="l00310"></a>00310   this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a80e407a5411f20d3311f24c67a0926a0">set_current_frequency</a>(0);
<a name="l00311"></a>00311 }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a324922259a87c2a919191969195175ca">00316</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a324922259a87c2a919191969195175ca">FrequencySystem::n_frequencies</a> ()<span class="keyword"> const</span>
<a name="l00317"></a>00317 <span class="keyword"></span>{
<a name="l00318"></a>00318   libmesh_assert(<a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a>);
<a name="l00319"></a>00319   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;n_frequencies&quot;</span>);
<a name="l00320"></a>00320 }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 
<a name="l00324"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#ad353661036d8b4dd3582dca2df7130a5">00324</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#ad353661036d8b4dd3582dca2df7130a5">FrequencySystem::solve</a> ()
<a name="l00325"></a>00325 {
<a name="l00326"></a>00326   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a324922259a87c2a919191969195175ca">n_frequencies</a>() &gt; 0);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   <span class="comment">// Solve for all the specified frequencies</span>
<a name="l00329"></a>00329   this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#ad353661036d8b4dd3582dca2df7130a5">solve</a> (0, this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a324922259a87c2a919191969195175ca">n_frequencies</a>()-1);
<a name="l00330"></a>00330 }
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 
<a name="l00334"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a70a3e69c137fda894f50e51d1e042489">00334</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#ad353661036d8b4dd3582dca2df7130a5">FrequencySystem::solve</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_start,
<a name="l00335"></a>00335                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_stop)
<a name="l00336"></a>00336 {
<a name="l00337"></a>00337   <span class="comment">// Assemble the linear system, if not already done</span>
<a name="l00338"></a>00338   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1FrequencySystem.php#a3d8f524b918cc82ab43c13e2c9ccdc5e">_finished_assemble</a>)
<a name="l00339"></a>00339     this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#aaee3ed97a002df300e11b5b2c6d37d67">assemble</a> (); 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="comment">// the user-supplied solve method _has_ to be provided by the user</span>
<a name="l00342"></a>00342   libmesh_assert (<a class="code" href="classlibMesh_1_1FrequencySystem.php#a216e475229f4727d97d3f3e563e550a7">solve_system</a> != NULL);
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="comment">// existence &amp; range checks</span>
<a name="l00345"></a>00345   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a324922259a87c2a919191969195175ca">n_frequencies</a>() &gt; 0);
<a name="l00346"></a>00346   libmesh_assert(n_stop &lt; this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a324922259a87c2a919191969195175ca">n_frequencies</a>());
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00349"></a>00349     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="comment">// Get the user-specified linear solver tolerance,</span>
<a name="l00352"></a>00352   <span class="comment">//     the user-specified maximum # of linear solver iterations,</span>
<a name="l00353"></a>00353   <span class="comment">//     the user-specified wave speed</span>
<a name="l00354"></a>00354   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol            =
<a name="l00355"></a>00355     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>);
<a name="l00356"></a>00356   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxits =
<a name="l00357"></a>00357     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>);
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 <span class="comment">//   // return values</span>
<a name="l00361"></a>00361 <span class="comment">//   std::vector&lt; std::pair&lt;unsigned int, Real&gt; &gt; vec_rval;</span>
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="comment">// start solver loop</span>
<a name="l00364"></a>00364   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=n_start; n&lt;= n_stop; n++)
<a name="l00365"></a>00365     {
<a name="l00366"></a>00366       <span class="comment">// set the current frequency</span>
<a name="l00367"></a>00367       this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a80e407a5411f20d3311f24c67a0926a0">set_current_frequency</a>(n);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369       <span class="comment">// Call the user-supplied pre-solve method</span>
<a name="l00370"></a>00370       START_LOG(<span class="stringliteral">&quot;user_pre_solve()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00371"></a>00371       
<a name="l00372"></a>00372       this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a216e475229f4727d97d3f3e563e550a7">solve_system</a> (es, this-&gt;<a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>());
<a name="l00373"></a>00373       
<a name="l00374"></a>00374       STOP_LOG(<span class="stringliteral">&quot;user_pre_solve()&quot;</span>, <span class="stringliteral">&quot;FrequencySystem&quot;</span>);
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377       <span class="comment">// Solve the linear system for this specific frequency</span>
<a name="l00378"></a>00378       <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval = 
<a name="l00379"></a>00379         <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;solve (*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>, *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, tol, maxits);
<a name="l00380"></a>00380 
<a name="l00381"></a>00381       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a57e48b332f51b09bb0a202c18daa46f6">_n_linear_iterations</a>   = rval.first;
<a name="l00382"></a>00382       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a9a2a816c2a19f12d8d2f34709940f8dc">_final_linear_residual</a> = rval.second;
<a name="l00383"></a>00383 
<a name="l00384"></a>00384        <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8401a19da335589cf723bbbafa3ddd33">vec_rval</a>.push_back(rval);      
<a name="l00385"></a>00385 
<a name="l00389"></a>00389       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">_keep_solution_duplicates</a>)
<a name="l00390"></a>00390         this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(this-&gt;<a class="code" href="classlibMesh_1_1FrequencySystem.php#afc99310d64cf696e1a33f9bcef5179d1">form_solu_vec_name</a>(n)) = *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l00391"></a>00391     }  
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   <span class="comment">// sanity check</span>
<a name="l00394"></a>00394   <span class="comment">//libmesh_assert (vec_rval.size() == (n_stop-n_start+1));</span>
<a name="l00395"></a>00395 
<a name="l00396"></a>00396   <span class="comment">//return vec_rval; </span>
<a name="l00397"></a>00397 }
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#aeecf84ef87989c9edd8b4a68749627d7">00401</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#aeecf84ef87989c9edd8b4a68749627d7">FrequencySystem::attach_solve_function</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00402"></a>00402                                                       <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>))
<a name="l00403"></a>00403 {
<a name="l00404"></a>00404   libmesh_assert (fptr != NULL);
<a name="l00405"></a>00405   
<a name="l00406"></a>00406   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a216e475229f4727d97d3f3e563e550a7">solve_system</a> = fptr;
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a80e407a5411f20d3311f24c67a0926a0">00411</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a80e407a5411f20d3311f24c67a0926a0">FrequencySystem::set_current_frequency</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00412"></a>00412 {
<a name="l00413"></a>00413   libmesh_assert(n &lt; <a class="code" href="classlibMesh_1_1FrequencySystem.php#a324922259a87c2a919191969195175ca">n_frequencies</a>());
<a name="l00414"></a>00414   
<a name="l00415"></a>00415   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00416"></a>00416     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00417"></a>00417 
<a name="l00418"></a>00418   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;current frequency&quot;</span>) = 
<a name="l00419"></a>00419     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(this-&gt;form_freq_param_name(n));
<a name="l00420"></a>00420 }
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a136920d148cf01fa1a14497b43faba5a">00424</a> std::string <a class="code" href="classlibMesh_1_1FrequencySystem.php#a136920d148cf01fa1a14497b43faba5a">FrequencySystem::form_freq_param_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00425"></a>00425 <span class="keyword"></span>{
<a name="l00426"></a>00426   libmesh_assert (n &lt; 9999);
<a name="l00427"></a>00427   <span class="keywordtype">char</span> buf[15];
<a name="l00428"></a>00428   sprintf(buf, <span class="stringliteral">&quot;frequency %04d&quot;</span>, n);
<a name="l00429"></a>00429   <span class="keywordflow">return</span> (buf);
<a name="l00430"></a>00430 }
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#afc99310d64cf696e1a33f9bcef5179d1">00434</a> std::string <a class="code" href="classlibMesh_1_1FrequencySystem.php#afc99310d64cf696e1a33f9bcef5179d1">FrequencySystem::form_solu_vec_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00435"></a>00435 <span class="keyword"></span>{
<a name="l00436"></a>00436   libmesh_assert (n &lt; 9999);
<a name="l00437"></a>00437   <span class="keywordtype">char</span> buf[15];
<a name="l00438"></a>00438   sprintf(buf, <span class="stringliteral">&quot;solution %04d&quot;</span>, n);
<a name="l00439"></a>00439   <span class="keywordflow">return</span> (buf);
<a name="l00440"></a>00440 }
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 } <span class="comment">// namespace libMesh</span>
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445 <span class="preprocessor">#endif // if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
