<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">frequency_system.h</div>  </div>
</div>
<div class="contents">
<a href="frequency__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: frequency_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __frequency_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __frequency_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Frequency domain solutions only possible with complex arithmetic</span>
<a name="l00028"></a>00028 <span class="preprocessor">#if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="comment">// C++ includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Local Includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00068"></a>00068 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00069"></a>00069 <span class="comment">// FrequencySystem class definition</span>
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php">00071</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FrequencySystem.php">FrequencySystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php">LinearImplicitSystem</a>
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073 <span class="keyword">public</span>:
<a name="l00074"></a>00074 
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1FrequencySystem.php#a00030d32408a9a9a3eb91adaa7484e81">FrequencySystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00080"></a>00080                    <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00081"></a>00081                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1FrequencySystem.php#add8057ad281faad75441fec67d57ffc8">~FrequencySystem</a> ();
<a name="l00086"></a>00086   
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a94c273a276f9705a182c38e79e67ad66">clear</a> ();
<a name="l00094"></a>00094   
<a name="l00100"></a>00100   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a92f7b5f6a6364cbfdda703ecafc37d07">clear_all</a> ();
<a name="l00101"></a>00101 
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#aaee3ed97a002df300e11b5b2c6d37d67">assemble</a> ();
<a name="l00107"></a>00107 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#ad353661036d8b4dd3582dca2df7130a5">solve</a> ();
<a name="l00112"></a>00112   
<a name="l00121"></a>00121   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#ad353661036d8b4dd3582dca2df7130a5">solve</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_start,
<a name="l00122"></a>00122               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_stop);
<a name="l00123"></a>00123   
<a name="l00128"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a7bb571179f2f3720dc87c6ccae4283e4">00128</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1FrequencySystem.php#a7bb571179f2f3720dc87c6ccae4283e4">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;Frequency&quot;</span>; }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">//--------------------------------------------------------</span>
<a name="l00132"></a>00132   <span class="comment">// Methods specific to the FrequencySystem</span>
<a name="l00133"></a>00133   <span class="comment">//</span>
<a name="l00134"></a>00134   
<a name="l00147"></a>00147   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a57f1cf3d31db4a89aff7956cdfe74a98">set_frequencies_by_steps</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> base_freq,
<a name="l00148"></a>00148                                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> freq_step=0.,
<a name="l00149"></a>00149                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq=1,
<a name="l00150"></a>00150                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates=<span class="keyword">true</span>);
<a name="l00151"></a>00151 
<a name="l00161"></a>00161   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#aecf9f2533e427a9cde8c40cb661d78b8">set_frequencies_by_range</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> min_freq,
<a name="l00162"></a>00162                                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> max_freq,
<a name="l00163"></a>00163                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_freq,
<a name="l00164"></a>00164                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates=<span class="keyword">true</span>);
<a name="l00165"></a>00165 
<a name="l00173"></a>00173   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#ae7db125bb552d7fa429f561a25600b69">set_frequencies</a> (<span class="keyword">const</span> std::vector&lt;Real&gt;&amp; frequencies,
<a name="l00174"></a>00174                         <span class="keyword">const</span> <span class="keywordtype">bool</span> allocate_solution_duplicates=<span class="keyword">true</span>);
<a name="l00175"></a>00175 
<a name="l00179"></a>00179   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a324922259a87c2a919191969195175ca">n_frequencies</a> () <span class="keyword">const</span>;
<a name="l00180"></a>00180   
<a name="l00187"></a>00187   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#aeecf84ef87989c9edd8b4a68749627d7">attach_solve_function</a>(<span class="keywordtype">void</span> fptr(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00188"></a>00188                                        <span class="keyword">const</span> std::string&amp; name));
<a name="l00189"></a>00189   
<a name="l00193"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a216e475229f4727d97d3f3e563e550a7">00193</a>   void (* <a class="code" href="classlibMesh_1_1FrequencySystem.php#a216e475229f4727d97d3f3e563e550a7">solve_system</a>) (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00194"></a>00194                          <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>);
<a name="l00195"></a>00195 
<a name="l00199"></a>00199   std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1FrequencySystem.php#a1da206b7333cc68a5df7ece863f4c95c">get_rval</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00200"></a>00200 
<a name="l00206"></a>00206   std::string <a class="code" href="classlibMesh_1_1FrequencySystem.php#a136920d148cf01fa1a14497b43faba5a">form_freq_param_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00207"></a>00207 
<a name="l00213"></a>00213   std::string <a class="code" href="classlibMesh_1_1FrequencySystem.php#afc99310d64cf696e1a33f9bcef5179d1">form_solu_vec_name</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span>;
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 <span class="keyword">protected</span>:
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00225"></a>00225   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a5b965b58aec67a9ec284d09569409e73">init_data</a> ();
<a name="l00226"></a>00226   
<a name="l00231"></a>00231   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a80e407a5411f20d3311f24c67a0926a0">set_current_frequency</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00232"></a>00232 
<a name="l00238"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">00238</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8fa1e02a237c454dd00fd575f18d1e34">_finished_set_frequencies</a>;
<a name="l00239"></a>00239 
<a name="l00247"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">00247</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a2f19429a34dcbbf54dd5030c7b27830c">_keep_solution_duplicates</a>;
<a name="l00248"></a>00248 
<a name="l00254"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a270d4a54360e4460153d9bb2d184398e">00254</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a270d4a54360e4460153d9bb2d184398e">_finished_init</a>;
<a name="l00255"></a>00255 
<a name="l00268"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a3d8f524b918cc82ab43c13e2c9ccdc5e">00268</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a3d8f524b918cc82ab43c13e2c9ccdc5e">_finished_assemble</a>;
<a name="l00269"></a>00269 
<a name="l00274"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a8401a19da335589cf723bbbafa3ddd33">00274</a>   std::vector&lt;std::pair&lt;unsigned int, Real&gt; &gt; <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8401a19da335589cf723bbbafa3ddd33">vec_rval</a>;
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 };
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00281"></a>00281 <span class="comment">// FrequencySystem inline methods</span>
<a name="l00282"></a>00282 <span class="keyword">inline</span>
<a name="l00283"></a><a class="code" href="classlibMesh_1_1FrequencySystem.php#a1da206b7333cc68a5df7ece863f4c95c">00283</a> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1FrequencySystem.php#a1da206b7333cc68a5df7ece863f4c95c">FrequencySystem::get_rval</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00284"></a>00284 <span class="keyword"></span>{
<a name="l00285"></a>00285   libmesh_assert (n &lt; <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8401a19da335589cf723bbbafa3ddd33">vec_rval</a>.size());
<a name="l00286"></a>00286 
<a name="l00287"></a>00287   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FrequencySystem.php#a8401a19da335589cf723bbbafa3ddd33">vec_rval</a>[n];
<a name="l00288"></a>00288 }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 } <span class="comment">// namespace libMesh</span>
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 <span class="preprocessor">#endif // if defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00294"></a>00294 <span class="preprocessor"></span>
<a name="l00295"></a>00295 <span class="preprocessor">#endif // ifndef __frequency_system_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
