<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">fro_io.C</div>  </div>
</div>
<div class="contents">
<a href="fro__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: fro_io.C 4313 2011-03-31 21:06:34Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;deque&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="fro__io_8h.php">fro_io.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// FroIO  members</span>
<a name="l00043"></a><a class="code" href="classlibMesh_1_1FroIO.php#a58efbdb0178c55b5ef4aa1512b816650">00043</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FroIO.php#a58efbdb0178c55b5ef4aa1512b816650">FroIO::write</a> (<span class="keyword">const</span> std::string&amp; fname)
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   <span class="comment">// We may need to gather a ParallelMesh to output it, making that</span>
<a name="l00046"></a>00046   <span class="comment">// const qualifier in our constructor a dirty lie</span>
<a name="l00047"></a>00047   MeshOutputSerializer serialize(const_cast&lt;MeshBase&amp;&gt;(this-&gt;<a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a>()), !<a class="code" href="classlibMesh_1_1MeshOutput.php#a0b28b0e8e7d99921d181c7c122384d0d">_is_parallel_format</a>);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051       <span class="comment">// Open the output file stream</span>
<a name="l00052"></a>00052       std::ofstream <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> (fname.c_str());
<a name="l00053"></a>00053       libmesh_assert (<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>.good());
<a name="l00054"></a>00054 
<a name="l00055"></a>00055       <span class="comment">// Make sure it opened correctly</span>
<a name="l00056"></a>00056       <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>.good())
<a name="l00057"></a>00057         libmesh_file_error(fname.c_str());
<a name="l00058"></a>00058 
<a name="l00059"></a>00059       <span class="comment">// Get a reference to the mesh</span>
<a name="l00060"></a>00060       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a> = <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00061"></a>00061 
<a name="l00062"></a>00062       <span class="comment">// Write the header</span>
<a name="l00063"></a>00063       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>()  &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00064"></a>00064           &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>() &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00065"></a>00065           &lt;&lt; <span class="stringliteral">&quot;0 0 &quot;</span>
<a name="l00066"></a>00066           &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;n_boundary_ids()  &lt;&lt; <span class="stringliteral">&quot; 1\n&quot;</span>;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068       <span class="comment">// Write the nodes -- 1-based!</span>
<a name="l00069"></a>00069       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); n++)
<a name="l00070"></a>00070         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; n+1 &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>
<a name="l00071"></a>00071             &lt;&lt; std::scientific
<a name="l00072"></a>00072             &lt;&lt; std::setprecision(12)
<a name="l00073"></a>00073             &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(n)(0) &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>
<a name="l00074"></a>00074             &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(n)(1) &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>
<a name="l00075"></a>00075             &lt;&lt; 0. &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077       <span class="comment">// Write the elements -- 1-based!</span>
<a name="l00078"></a>00078       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00079"></a>00079       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00080"></a>00080       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0;
<a name="l00081"></a>00081       
<a name="l00082"></a>00082       <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00083"></a>00083         {
<a name="l00084"></a>00084           <span class="comment">// .fro likes TRI3&#39;s</span>
<a name="l00085"></a>00085           <span class="keywordflow">if</span> ((*it)-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>)
<a name="l00086"></a>00086             {
<a name="l00087"></a>00087               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  .fro format only valid for triangles!\n&quot;</span>
<a name="l00088"></a>00088                             &lt;&lt; <span class="stringliteral">&quot;  writing of &quot;</span> &lt;&lt; fname &lt;&lt; <span class="stringliteral">&quot; aborted.\n&quot;</span>
<a name="l00089"></a>00089                             &lt;&lt; std::endl;
<a name="l00090"></a>00090               libmesh_error();
<a name="l00091"></a>00091             }
<a name="l00092"></a>00092           
<a name="l00093"></a>00093           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; ++e &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*it)-&gt;n_nodes(); n++)
<a name="l00096"></a>00096             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; (*it)-&gt;node(n)+1 &lt;&lt; <span class="stringliteral">&quot; \t&quot;</span>;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="comment">//        // LHS -&gt; RHS Mapping, for inverted triangles</span>
<a name="l00099"></a>00099 <span class="comment">//        out &lt;&lt; (*it)-&gt;node(0)+1 &lt;&lt; &quot; \t&quot;;</span>
<a name="l00100"></a>00100 <span class="comment">//        out &lt;&lt; (*it)-&gt;node(2)+1 &lt;&lt; &quot; \t&quot;;</span>
<a name="l00101"></a>00101 <span class="comment">//        out &lt;&lt; (*it)-&gt;node(1)+1 &lt;&lt; &quot; \t&quot;;</span>
<a name="l00102"></a>00102 
<a name="l00103"></a>00103           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;1\n&quot;</span>;
<a name="l00104"></a>00104         }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106       <span class="comment">// Write BCs.</span>
<a name="l00107"></a>00107       {
<a name="l00108"></a>00108         <span class="keyword">const</span> std::set&lt;short int&gt;&amp; bc_ids =
<a name="l00109"></a>00109           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;get_boundary_ids();
<a name="l00110"></a>00110 
<a name="l00111"></a>00111         std::vector&lt;unsigned int&gt;       el;
<a name="l00112"></a>00112         std::vector&lt;unsigned short int&gt; sl;
<a name="l00113"></a>00113         std::vector&lt;short int&gt;          il;
<a name="l00114"></a>00114         
<a name="l00115"></a>00115         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;build_side_list (el, sl, il);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118         <span class="comment">// Map the boundary ids into [1,n_bc_ids],</span>
<a name="l00119"></a>00119         <span class="comment">// treat them one at a time.</span>
<a name="l00120"></a>00120         <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a5ecbd368c0b0ad8b7ec4d85877e05af3">bc_id</a>=0;
<a name="l00121"></a>00121         <span class="keywordflow">for</span> (std::set&lt;short int&gt;::const_iterator <span class="keywordtype">id</span> = bc_ids.begin();
<a name="l00122"></a>00122              <span class="keywordtype">id</span> != bc_ids.end(); ++id)
<a name="l00123"></a>00123           {
<a name="l00124"></a>00124             std::deque&lt;unsigned int&gt; node_list;
<a name="l00125"></a>00125             
<a name="l00126"></a>00126             std::map&lt;unsigned int, unsigned int&gt;
<a name="l00127"></a>00127               forward_edges, backward_edges;
<a name="l00128"></a>00128             
<a name="l00129"></a>00129             <span class="comment">// Get all sides on this element with the relevant BC id.</span>
<a name="l00130"></a>00130             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;el.size(); e++)
<a name="l00131"></a>00131               <span class="keywordflow">if</span> (il[e] == *<span class="keywordtype">id</span>)
<a name="l00132"></a>00132                 {
<a name="l00133"></a>00133                   <span class="comment">// need to build up node_list as a sorted array of edge nodes...</span>
<a name="l00134"></a>00134                   <span class="comment">// for the following:</span>
<a name="l00135"></a>00135                   <span class="comment">// a---b---c---d---e</span>
<a name="l00136"></a>00136                   <span class="comment">// node_list [ a b c d e];</span>
<a name="l00137"></a>00137                   <span class="comment">//</span>
<a name="l00138"></a>00138                   <span class="comment">// the issue is just how to get this out of the elem/side based data structure.</span>
<a name="l00139"></a>00139                   <span class="comment">// the approach is to build up &#39;chain links&#39; like this:</span>
<a name="l00140"></a>00140                   <span class="comment">// a---b b---c c---d d---e</span>
<a name="l00141"></a>00141                   <span class="comment">// and piece them together.</span>
<a name="l00142"></a>00142                   <span class="comment">//</span>
<a name="l00143"></a>00143                   <span class="comment">// so, for an arbitray edge n0---n1, we build the</span>
<a name="l00144"></a>00144                   <span class="comment">// &quot;forward_edges&quot;  map n0--&gt;n1</span>
<a name="l00145"></a>00145                   <span class="comment">// &quot;backward_edges&quot; map n1--&gt;n0</span>
<a name="l00146"></a>00146                   <span class="comment">// and then start with one chain link, and add on...</span>
<a name="l00147"></a>00147                   <span class="comment">//</span>
<a name="l00148"></a>00148                   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(el[e])-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(sl[e]);
<a name="l00149"></a>00149 
<a name="l00150"></a>00150                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00151"></a>00151                     n0 = side-&gt;node(0),
<a name="l00152"></a>00152                     n1 = side-&gt;node(1);
<a name="l00153"></a>00153 
<a name="l00154"></a>00154                   <span class="comment">// insert into forward-edge set</span>
<a name="l00155"></a>00155                   forward_edges.insert (std::make_pair(n0, n1));
<a name="l00156"></a>00156 
<a name="l00157"></a>00157                   <span class="comment">// insert into backward-edge set</span>
<a name="l00158"></a>00158                   backward_edges.insert (std::make_pair(n1, n0));
<a name="l00159"></a>00159 
<a name="l00160"></a>00160                   <span class="comment">// go ahead and add one edge to the list -- this will give us the beginning of a</span>
<a name="l00161"></a>00161                   <span class="comment">// chain to work from!</span>
<a name="l00162"></a>00162                   <span class="keywordflow">if</span> (node_list.empty())
<a name="l00163"></a>00163                     {
<a name="l00164"></a>00164                       node_list.push_front(n0);
<a name="l00165"></a>00165                       node_list.push_back (n1);
<a name="l00166"></a>00166                     }
<a name="l00167"></a>00167                 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169             <span class="comment">// we now have the node_list with one edge, the forward_edges, and the backward_edges</span>
<a name="l00170"></a>00170             <span class="comment">// the node_list will be filled when (node_list.size() == (n_edges+1))</span>
<a name="l00171"></a>00171             <span class="comment">// until that is the case simply add on to the beginning and end of the node_list,</span>
<a name="l00172"></a>00172             <span class="comment">// building up a chain of ordered nodes...</span>
<a name="l00173"></a>00173             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_edges = forward_edges.size();
<a name="l00174"></a>00174             
<a name="l00175"></a>00175             <span class="keywordflow">while</span> (node_list.size() != (n_edges+1))
<a name="l00176"></a>00176               {
<a name="l00177"></a>00177                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00178"></a>00178                   front_node = node_list.front(),
<a name="l00179"></a>00179                   back_node  = node_list.back();
<a name="l00180"></a>00180 
<a name="l00181"></a>00181                 <span class="comment">// look for front_pair in the backward_edges list</span>
<a name="l00182"></a>00182                 {
<a name="l00183"></a>00183                   std::map&lt;unsigned int, unsigned int&gt;::iterator
<a name="l00184"></a>00184                     pos = backward_edges.find(front_node);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186                   <span class="keywordflow">if</span> (pos != backward_edges.end())
<a name="l00187"></a>00187                     {
<a name="l00188"></a>00188                       node_list.push_front(pos-&gt;second);
<a name="l00189"></a>00189                        
<a name="l00190"></a>00190                       backward_edges.erase(pos);
<a name="l00191"></a>00191                     }
<a name="l00192"></a>00192                 }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194                 <span class="comment">// look for back_pair in the forward_edges list</span>
<a name="l00195"></a>00195                 {
<a name="l00196"></a>00196                   std::map&lt;unsigned int, unsigned int&gt;::iterator
<a name="l00197"></a>00197                     pos = forward_edges.find(back_node);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199                   <span class="keywordflow">if</span> (pos != forward_edges.end())
<a name="l00200"></a>00200                     {
<a name="l00201"></a>00201                       node_list.push_back(pos-&gt;second);
<a name="l00202"></a>00202                        
<a name="l00203"></a>00203                       forward_edges.erase(pos);
<a name="l00204"></a>00204                     }
<a name="l00205"></a>00205                 }
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="comment">//              libMesh::out &lt;&lt; &quot;node_list.size()=&quot; &lt;&lt; node_list.size()</span>
<a name="l00208"></a>00208 <span class="comment">//                            &lt;&lt; &quot;, n_edges+1=&quot; &lt;&lt; n_edges+1 &lt;&lt; std::endl;                </span>
<a name="l00209"></a>00209               }
<a name="l00210"></a>00210                     
<a name="l00211"></a>00211 
<a name="l00212"></a>00212             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; ++bc_id &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; node_list.size() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00213"></a>00213 
<a name="l00214"></a>00214             std::deque&lt;unsigned int&gt;::iterator pos = node_list.begin();
<a name="l00215"></a>00215             <span class="keywordflow">for</span> ( ; pos != node_list.end(); ++pos)
<a name="l00216"></a>00216                 <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; *pos+1 &lt;&lt; <span class="stringliteral">&quot; \t0\n&quot;</span>;
<a name="l00217"></a>00217           }     
<a name="l00218"></a>00218       }      
<a name="l00219"></a>00219     }
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
