<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">function_base.h</div>  </div>
</div>
<div class="contents">
<a href="function__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: function_base.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __function_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __function_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations</span>
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseVector;
<a name="l00039"></a>00039 <span class="keyword">class </span>FunctionBase;
<a name="l00040"></a>00040 <span class="keyword">class </span>Point;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00059"></a>00059 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00060"></a>00060 <span class="comment">// FunctionBase class definition</span>
<a name="l00061"></a><a class="code" href="classlibMesh_1_1FunctionBase.php">00061</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a> 
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063 <span class="keyword">protected</span>:
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1FunctionBase.php#aae4cd08c3f58d0b37a3adc49090c7d03">FunctionBase</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>* master = NULL);
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 <span class="keyword">public</span>:
<a name="l00071"></a>00071 
<a name="l00075"></a>00075   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1FunctionBase.php#ad7c020ab25afd7968568366184d28372">~FunctionBase</a> ();
<a name="l00076"></a>00076 
<a name="l00080"></a>00080   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FunctionBase.php#a2e3e16a985ab77e658c5de7b649d24e2">init</a> () = 0;
<a name="l00081"></a>00081 
<a name="l00085"></a>00085   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FunctionBase.php#a5349be7e887f28bcc47474df9781848b">clear</a> () = 0;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="comment">// ------------------------------------------------------</span>
<a name="l00089"></a>00089   <span class="comment">// misc</span>
<a name="l00096"></a>00096 <span class="comment"></span>  <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1FunctionBase.php#aef48e82bd9c84b98d41ececf14945d9c">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, 
<a name="l00097"></a>00097                              <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time = 0.) = 0;
<a name="l00098"></a>00098 
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FunctionBase.php#aef48e82bd9c84b98d41ececf14945d9c">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00105"></a>00105                    <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output);
<a name="l00106"></a>00106 
<a name="l00114"></a>00114   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FunctionBase.php#aef48e82bd9c84b98d41ececf14945d9c">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00115"></a>00115                            <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time,
<a name="l00116"></a>00116                            <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output) = 0;
<a name="l00117"></a>00117 
<a name="l00122"></a>00122   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a> () <span class="keyword">const</span>;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="keyword">protected</span>:
<a name="l00126"></a>00126 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">00133</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>* <a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a>;
<a name="l00134"></a>00134 
<a name="l00139"></a><a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">00139</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">_initialized</a>;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 };
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00145"></a>00145 <span class="comment">// FunctionBase inline methods</span>
<a name="l00146"></a>00146 <span class="keyword">inline</span>
<a name="l00147"></a><a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">00147</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">FunctionBase::initialized</a>()<span class="keyword"> const</span>
<a name="l00148"></a>00148 <span class="keyword"></span>{
<a name="l00149"></a>00149   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">_initialized</a>);
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="keyword">inline</span>
<a name="l00155"></a><a class="code" href="classlibMesh_1_1FunctionBase.php#a0574f54ad7b9f2c62d09a28b1fc55e05">00155</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1FunctionBase.php#aef48e82bd9c84b98d41ececf14945d9c">FunctionBase::operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00156"></a>00156                                <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output)
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158   <span class="comment">// Call the time-dependent function with t=0.</span>
<a name="l00159"></a>00159   this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#aef48e82bd9c84b98d41ececf14945d9c">operator()</a>(p, 0., output);
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 } <span class="comment">// namespace libMesh</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
