<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">gmsh_io.C</div>  </div>
</div>
<div class="contents">
<a href="gmsh__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: gmsh_io.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// This file was massively overhauled and extended by Martin Lthi, mluthi@tnoo.net</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;cstring&gt;</span> <span class="comment">// std::memcpy, std::strncmp</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="gmsh__io_8h.php">gmsh_io.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// anonymous namespace to hold local data</span>
<a name="l00036"></a>00036 <span class="keyword">namespace </span>
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   
<a name="l00045"></a>00045   <span class="keyword">struct </span>boundaryElementInfo {
<a name="l00046"></a>00046     std::set&lt;unsigned int&gt; nodes;
<a name="l00047"></a>00047     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> id;
<a name="l00048"></a>00048   };
<a name="l00049"></a>00049 
<a name="l00053"></a>00053   <span class="keyword">struct </span>elementDefinition {
<a name="l00054"></a>00054     std::string label;
<a name="l00055"></a>00055     std::vector&lt;unsigned int&gt; nodes;
<a name="l00056"></a>00056     <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type;
<a name="l00057"></a>00057     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> exptype;
<a name="l00058"></a>00058     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim;
<a name="l00059"></a>00059     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnodes;
<a name="l00060"></a>00060   };
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// maps from a libMesh element type to the proper</span>
<a name="l00064"></a>00064   <span class="comment">// Gmsh elementDefinition.  Placing the data structure</span>
<a name="l00065"></a>00065   <span class="comment">// here in this anonymous namespace gives us the</span>
<a name="l00066"></a>00066   <span class="comment">// benefits of a global variable without the nasty</span>
<a name="l00067"></a>00067   <span class="comment">// side-effects</span>
<a name="l00068"></a>00068   std::map&lt;ElemType, elementDefinition&gt; eletypes_exp;
<a name="l00069"></a>00069   std::map&lt;unsigned int, elementDefinition&gt; eletypes_imp;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// ------------------------------------------------------------</span>
<a name="l00074"></a>00074   <span class="comment">// helper function to initialize the eletypes map</span>
<a name="l00075"></a>00075   <span class="keywordtype">void</span> init_eletypes ()
<a name="l00076"></a>00076   {
<a name="l00077"></a>00077     <span class="keywordflow">if</span> (eletypes_exp.empty() &amp;&amp; eletypes_imp.empty())
<a name="l00078"></a>00078       {
<a name="l00079"></a>00079         <span class="comment">// This should happen only once.  The first time this method</span>
<a name="l00080"></a>00080         <span class="comment">// is called the eletypes data struture will be empty, and</span>
<a name="l00081"></a>00081         <span class="comment">// we will fill it.  Any subsequent calls will find an initialized</span>
<a name="l00082"></a>00082         <span class="comment">// eletypes map and will do nothing.</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084         <span class="comment">//==============================</span>
<a name="l00085"></a>00085         <span class="comment">// setup the element definitions</span>
<a name="l00086"></a>00086         elementDefinition eledef;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088         <span class="comment">// use &quot;swap trick&quot; from Scott Meyer&#39;s &quot;Effective STL&quot; to initialize</span>
<a name="l00089"></a>00089         <span class="comment">// eledef.nodes vector</span>
<a name="l00090"></a>00090         
<a name="l00091"></a>00091         <span class="comment">// POINT (only Gmsh)</span>
<a name="l00092"></a>00092         {
<a name="l00093"></a>00093           eledef.exptype = 15;
<a name="l00094"></a>00094           eledef.dim     = 0;
<a name="l00095"></a>00095           eledef.nnodes  = 1;
<a name="l00096"></a>00096           eledef.nodes.clear();
<a name="l00097"></a>00097         
<a name="l00098"></a>00098           <span class="comment">// import only</span>
<a name="l00099"></a>00099           eletypes_imp[15] = eledef;
<a name="l00100"></a>00100         }
<a name="l00101"></a>00101 
<a name="l00102"></a>00102         <span class="comment">// EDGE2</span>
<a name="l00103"></a>00103         {
<a name="l00104"></a>00104           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>;
<a name="l00105"></a>00105           eledef.dim     = 1;
<a name="l00106"></a>00106           eledef.nnodes  = 2;
<a name="l00107"></a>00107           eledef.exptype = 1;
<a name="l00108"></a>00108           eledef.nodes.clear();
<a name="l00109"></a>00109         
<a name="l00110"></a>00110           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>] = eledef;
<a name="l00111"></a>00111           eletypes_imp[1]     = eledef;
<a name="l00112"></a>00112         }
<a name="l00113"></a>00113   
<a name="l00114"></a>00114         <span class="comment">// EDGE3</span>
<a name="l00115"></a>00115         {
<a name="l00116"></a>00116           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>;
<a name="l00117"></a>00117           eledef.dim     = 1;
<a name="l00118"></a>00118           eledef.nnodes  = 3;
<a name="l00119"></a>00119           eledef.exptype = 8;
<a name="l00120"></a>00120           eledef.nodes.clear();
<a name="l00121"></a>00121           
<a name="l00122"></a>00122           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>] = eledef;
<a name="l00123"></a>00123           eletypes_imp[8]     = eledef;
<a name="l00124"></a>00124         }
<a name="l00125"></a>00125       
<a name="l00126"></a>00126         <span class="comment">// TRI3</span>
<a name="l00127"></a>00127         {
<a name="l00128"></a>00128           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>;
<a name="l00129"></a>00129           eledef.dim     = 2;
<a name="l00130"></a>00130           eledef.nnodes  = 3;
<a name="l00131"></a>00131           eledef.exptype = 2;
<a name="l00132"></a>00132           eledef.nodes.clear();
<a name="l00133"></a>00133           
<a name="l00134"></a>00134           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>] = eledef;
<a name="l00135"></a>00135           eletypes_imp[2] = eledef;
<a name="l00136"></a>00136         }
<a name="l00137"></a>00137       
<a name="l00138"></a>00138         <span class="comment">// TRI6</span>
<a name="l00139"></a>00139         {
<a name="l00140"></a>00140           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>;
<a name="l00141"></a>00141           eledef.dim     = 2;
<a name="l00142"></a>00142           eledef.nnodes  = 6;
<a name="l00143"></a>00143           eledef.exptype = 9;
<a name="l00144"></a>00144           eledef.nodes.clear();
<a name="l00145"></a>00145 
<a name="l00146"></a>00146           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>] = eledef;
<a name="l00147"></a>00147           eletypes_imp[9]    = eledef;
<a name="l00148"></a>00148         }
<a name="l00149"></a>00149       
<a name="l00150"></a>00150         <span class="comment">// QUAD4</span>
<a name="l00151"></a>00151         {
<a name="l00152"></a>00152           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>;
<a name="l00153"></a>00153           eledef.dim     = 2;
<a name="l00154"></a>00154           eledef.nnodes  = 4;
<a name="l00155"></a>00155           eledef.exptype = 3;
<a name="l00156"></a>00156           eledef.nodes.clear();
<a name="l00157"></a>00157 
<a name="l00158"></a>00158           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>] = eledef;
<a name="l00159"></a>00159           eletypes_imp[3]     = eledef;
<a name="l00160"></a>00160         }
<a name="l00161"></a>00161       
<a name="l00162"></a>00162         <span class="comment">// QUAD8</span>
<a name="l00163"></a>00163         <span class="comment">// TODO: what should be done with this on writing?</span>
<a name="l00164"></a>00164         {
<a name="l00165"></a>00165           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>;
<a name="l00166"></a>00166           eledef.dim     = 2;
<a name="l00167"></a>00167           eledef.nnodes  = 8;
<a name="l00168"></a>00168           eledef.exptype = 100;
<a name="l00169"></a>00169           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {1,2,3,4,5,6,7,8};
<a name="l00170"></a>00170           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>] = eledef;
<a name="l00173"></a>00173           eletypes_imp[10]    = eledef;
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175       
<a name="l00176"></a>00176         <span class="comment">// QUAD9</span>
<a name="l00177"></a>00177         {
<a name="l00178"></a>00178           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>;
<a name="l00179"></a>00179           eledef.dim     = 2;
<a name="l00180"></a>00180           eledef.nnodes  = 9;
<a name="l00181"></a>00181           eledef.exptype = 10;
<a name="l00182"></a>00182           eledef.nodes.clear();
<a name="l00183"></a>00183 
<a name="l00184"></a>00184           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>] = eledef;
<a name="l00185"></a>00185           eletypes_imp[10]    = eledef;
<a name="l00186"></a>00186         }
<a name="l00187"></a>00187       
<a name="l00188"></a>00188         <span class="comment">// HEX8</span>
<a name="l00189"></a>00189         {
<a name="l00190"></a>00190           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>;
<a name="l00191"></a>00191           eledef.dim     = 3;
<a name="l00192"></a>00192           eledef.nnodes  = 8;
<a name="l00193"></a>00193           eledef.exptype = 5;
<a name="l00194"></a>00194           eledef.nodes.clear();
<a name="l00195"></a>00195 
<a name="l00196"></a>00196           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>] = eledef;
<a name="l00197"></a>00197           eletypes_imp[5]    = eledef;
<a name="l00198"></a>00198         }
<a name="l00199"></a>00199       
<a name="l00200"></a>00200         <span class="comment">// HEX20</span>
<a name="l00201"></a>00201         <span class="comment">// TODO: what should be done with this on writing?</span>
<a name="l00202"></a>00202         {
<a name="l00203"></a>00203           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>;
<a name="l00204"></a>00204           eledef.dim     = 3;
<a name="l00205"></a>00205           eledef.nnodes  = 20;
<a name="l00206"></a>00206           eledef.exptype = 101;
<a name="l00207"></a>00207           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {1,2,3,4,5,6,7,8,9,10,11,16,17,18,19,12,13,14,15,16};
<a name="l00208"></a>00208           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>] = eledef;
<a name="l00211"></a>00211           eletypes_imp[12]    = eledef;
<a name="l00212"></a>00212         }
<a name="l00213"></a>00213       
<a name="l00214"></a>00214         <span class="comment">// HEX27</span>
<a name="l00215"></a>00215         {
<a name="l00216"></a>00216           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>;
<a name="l00217"></a>00217           eledef.dim     = 3;
<a name="l00218"></a>00218           eledef.nnodes  = 27;
<a name="l00219"></a>00219           eledef.exptype = 12;
<a name="l00220"></a>00220           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {0,1,2,3,4,5,6,7,8,11,12,9,13,10,14,
<a name="l00221"></a>00221                                         15,16,19,17,18,20,21,24,22,23,25,26};
<a name="l00222"></a>00222           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>] = eledef;
<a name="l00225"></a>00225           eletypes_imp[12]    = eledef;
<a name="l00226"></a>00226         }
<a name="l00227"></a>00227       
<a name="l00228"></a>00228         <span class="comment">// TET4</span>
<a name="l00229"></a>00229         {
<a name="l00230"></a>00230           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>;
<a name="l00231"></a>00231           eledef.dim     = 3;
<a name="l00232"></a>00232           eledef.nnodes  = 4;
<a name="l00233"></a>00233           eledef.exptype = 4;
<a name="l00234"></a>00234           eledef.nodes.clear();
<a name="l00235"></a>00235 
<a name="l00236"></a>00236           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>] = eledef;
<a name="l00237"></a>00237           eletypes_imp[4]    = eledef;
<a name="l00238"></a>00238         }
<a name="l00239"></a>00239       
<a name="l00240"></a>00240         <span class="comment">// TET10</span>
<a name="l00241"></a>00241         {
<a name="l00242"></a>00242           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>;
<a name="l00243"></a>00243           eledef.dim     = 3;
<a name="l00244"></a>00244           eledef.nnodes  = 10;
<a name="l00245"></a>00245           eledef.exptype = 11;
<a name="l00246"></a>00246           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {0,1,2,3,4,5,6,7,9,8};
<a name="l00247"></a>00247           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00248"></a>00248           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>] = eledef;
<a name="l00249"></a>00249           eletypes_imp[11]    = eledef;
<a name="l00250"></a>00250         }
<a name="l00251"></a>00251       
<a name="l00252"></a>00252         <span class="comment">// PRISM6</span>
<a name="l00253"></a>00253         {
<a name="l00254"></a>00254           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>;
<a name="l00255"></a>00255           eledef.dim     = 3;
<a name="l00256"></a>00256           eledef.nnodes  = 6;
<a name="l00257"></a>00257           eledef.exptype = 6;
<a name="l00258"></a>00258           eledef.nodes.clear();
<a name="l00259"></a>00259           
<a name="l00260"></a>00260           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>] = eledef;
<a name="l00261"></a>00261           eletypes_imp[6]      = eledef;
<a name="l00262"></a>00262         }
<a name="l00263"></a>00263       
<a name="l00264"></a>00264         <span class="comment">// PRISM15</span>
<a name="l00265"></a>00265         <span class="comment">// TODO: what should be done with this on writing?</span>
<a name="l00266"></a>00266         {
<a name="l00267"></a>00267           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>;
<a name="l00268"></a>00268           eledef.dim     = 3;
<a name="l00269"></a>00269           eledef.nnodes  = 15;
<a name="l00270"></a>00270           eledef.exptype = 103;
<a name="l00271"></a>00271           eledef.nodes.clear();
<a name="l00272"></a>00272           
<a name="l00273"></a>00273           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>] = eledef;
<a name="l00274"></a>00274           eletypes_imp[13] = eledef;
<a name="l00275"></a>00275         }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277         <span class="comment">// PRISM18</span>
<a name="l00278"></a>00278         {
<a name="l00279"></a>00279           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>;
<a name="l00280"></a>00280           eledef.dim     = 3;
<a name="l00281"></a>00281           eledef.nnodes  = 18;
<a name="l00282"></a>00282           eledef.exptype = 13;
<a name="l00283"></a>00283           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodes[] = {0,1,2,3,4,5,6,8,9,7,10,11,
<a name="l00284"></a>00284                                         12,14,13,15,17,16};
<a name="l00285"></a>00285           std::vector&lt;unsigned int&gt;(nodes, nodes+eledef.nnodes).swap(eledef.nodes);
<a name="l00286"></a>00286 
<a name="l00287"></a>00287           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>] = eledef;
<a name="l00288"></a>00288           eletypes_imp[13]      = eledef;
<a name="l00289"></a>00289         }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291         <span class="comment">// PYRAMID5</span>
<a name="l00292"></a>00292         {
<a name="l00293"></a>00293           eledef.type    = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>;
<a name="l00294"></a>00294           eledef.dim     = 3;
<a name="l00295"></a>00295           eledef.nnodes  = 5;
<a name="l00296"></a>00296           eledef.exptype = 7;
<a name="l00297"></a>00297           eledef.nodes.clear();
<a name="l00298"></a>00298           
<a name="l00299"></a>00299           eletypes_exp[<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>] = eledef;
<a name="l00300"></a>00300           eletypes_imp[7]        = eledef;
<a name="l00301"></a>00301         }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303         <span class="comment">//==============================      </span>
<a name="l00304"></a>00304       }
<a name="l00305"></a>00305   }
<a name="l00306"></a>00306   
<a name="l00307"></a>00307 } <span class="comment">// end anonymous namespace</span>
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a>00310 <span class="keyword">namespace </span>libMesh
<a name="l00311"></a>00311 {
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00314"></a>00314 <span class="comment">// GmshIO  members</span>
<a name="l00315"></a><a class="code" href="classlibMesh_1_1GmshIO.php#a9c1ba35a3e456c1d7722bfb0c2d97ae2">00315</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a9c1ba35a3e456c1d7722bfb0c2d97ae2">GmshIO::read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00316"></a>00316 {
<a name="l00317"></a>00317   std::ifstream in (name.c_str());
<a name="l00318"></a>00318   this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a5fa2a5e195b223daa82b17be9378a996">read_mesh</a> (in);
<a name="l00319"></a>00319 }
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a><a class="code" href="classlibMesh_1_1GmshIO.php#a5fa2a5e195b223daa82b17be9378a996">00322</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a5fa2a5e195b223daa82b17be9378a996">GmshIO::read_mesh</a>(std::istream&amp; in)
<a name="l00323"></a>00323 {
<a name="l00324"></a>00324   <span class="comment">// This is a serial-only process for now;</span>
<a name="l00325"></a>00325   <span class="comment">// the Mesh should be read on processor 0 and</span>
<a name="l00326"></a>00326   <span class="comment">// broadcast later</span>
<a name="l00327"></a>00327   libmesh_assert(<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00328"></a>00328 
<a name="l00329"></a>00329   libmesh_assert(in.good());
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <span class="comment">// initialize the map with element types</span>
<a name="l00332"></a>00332   init_eletypes();
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="comment">// clear any data in the mesh</span>
<a name="l00335"></a>00335   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MeshBase&gt;::mesh</a>();
<a name="l00336"></a>00336   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">clear</a>();
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <span class="comment">// some variables</span>
<a name="l00341"></a>00341   <span class="keyword">const</span> <span class="keywordtype">int</span>  bufLen = 256;
<a name="l00342"></a>00342   <span class="keywordtype">char</span>       buf[bufLen+1];
<a name="l00343"></a>00343   <span class="keywordtype">int</span>        format=0, size=0;
<a name="l00344"></a>00344   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>       version = 1.0;
<a name="l00345"></a>00345   
<a name="l00346"></a>00346   <span class="comment">// map to hold the node numbers for translation</span>
<a name="l00347"></a>00347   <span class="comment">// note the the nodes can be non-consecutive</span>
<a name="l00348"></a>00348   std::map&lt;unsigned int, unsigned int&gt; nodetrans;
<a name="l00349"></a>00349   
<a name="l00350"></a>00350   {
<a name="l00351"></a>00351     <span class="keywordflow">while</span> (!in.eof()) {
<a name="l00352"></a>00352       in &gt;&gt; buf;
<a name="l00353"></a>00353 
<a name="l00354"></a>00354       <span class="keywordflow">if</span> (!std::strncmp(buf,<span class="stringliteral">&quot;$MeshFormat&quot;</span>,11))
<a name="l00355"></a>00355         {
<a name="l00356"></a>00356           in &gt;&gt; version &gt;&gt; format &gt;&gt; size;
<a name="l00357"></a>00357           <span class="keywordflow">if</span> ((version != 2.0) &amp;&amp; (version != 2.1)) {
<a name="l00358"></a>00358             <span class="comment">// Some notes on gmsh mesh versions:</span>
<a name="l00359"></a>00359             <span class="comment">//</span>
<a name="l00360"></a>00360             <span class="comment">// Mesh version 2.0 goes back as far as I know.  It&#39;s not explicitly</span>
<a name="l00361"></a>00361             <span class="comment">// mentioned here: http://www.geuz.org/gmsh/doc/VERSIONS.txt</span>
<a name="l00362"></a>00362             <span class="comment">//</span>
<a name="l00363"></a>00363             <span class="comment">// As of gmsh-2.4.0:</span>
<a name="l00364"></a>00364             <span class="comment">// bumped mesh version format to 2.1 (small change in the $PhysicalNames</span>
<a name="l00365"></a>00365             <span class="comment">// section, where the group dimension is now required);</span>
<a name="l00366"></a>00366             <span class="comment">// [Since we don&#39;t even parse the PhysicalNames section at the time</span>
<a name="l00367"></a>00367             <span class="comment">//  of this writing, I don&#39;t think this change affects us.]</span>
<a name="l00368"></a>00368             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Wrong msh file version &quot;</span> &lt;&lt; version &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00369"></a>00369             libmesh_error();
<a name="l00370"></a>00370           }
<a name="l00371"></a>00371           <span class="keywordflow">if</span>(format){
<a name="l00372"></a>00372             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error: Unknown data format for mesh\n&quot;</span>;
<a name="l00373"></a>00373             libmesh_error();
<a name="l00374"></a>00374           }
<a name="l00375"></a>00375         }
<a name="l00376"></a>00376       
<a name="l00377"></a>00377       <span class="comment">// read the node block</span>
<a name="l00378"></a>00378       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!std::strncmp(buf,<span class="stringliteral">&quot;$NOD&quot;</span>,4) ||
<a name="l00379"></a>00379                !std::strncmp(buf,<span class="stringliteral">&quot;$NOE&quot;</span>,4) ||
<a name="l00380"></a>00380                !std::strncmp(buf,<span class="stringliteral">&quot;$Nodes&quot;</span>,6) 
<a name="l00381"></a>00381                )
<a name="l00382"></a>00382         {
<a name="l00383"></a>00383           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> numNodes = 0;
<a name="l00384"></a>00384           in &gt;&gt; numNodes;
<a name="l00385"></a>00385           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a> (numNodes);
<a name="l00386"></a>00386 
<a name="l00387"></a>00387           <span class="comment">// read in the nodal coordinates and form points.</span>
<a name="l00388"></a>00388           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x, y, z;
<a name="l00389"></a>00389           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> id;
<a name="l00390"></a>00390         
<a name="l00391"></a>00391           <span class="comment">// add the nodal coordinates to the mesh</span>
<a name="l00392"></a>00392           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;numNodes; ++i)      
<a name="l00393"></a>00393             {
<a name="l00394"></a>00394               in &gt;&gt; <span class="keywordtype">id</span> &gt;&gt; x &gt;&gt; y &gt;&gt; z;
<a name="l00395"></a>00395               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(x, y, z), i);
<a name="l00396"></a>00396               nodetrans[id] = i;
<a name="l00397"></a>00397             }
<a name="l00398"></a>00398           <span class="comment">// read the $ENDNOD delimiter</span>
<a name="l00399"></a>00399           in &gt;&gt; buf;
<a name="l00400"></a>00400         }
<a name="l00401"></a>00401 
<a name="l00412"></a>00412       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (!std::strncmp(buf,<span class="stringliteral">&quot;$ELM&quot;</span>,4) ||
<a name="l00413"></a>00413                !std::strncmp(buf,<span class="stringliteral">&quot;$Elements&quot;</span>,9)
<a name="l00414"></a>00414                )
<a name="l00415"></a>00415         {
<a name="l00416"></a>00416           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> numElem = 0;
<a name="l00417"></a>00417           std::vector&lt; boundaryElementInfo &gt; boundary_elem;
<a name="l00418"></a>00418 
<a name="l00419"></a>00419           <span class="comment">// read how many elements are there, and reserve space in the mesh</span>
<a name="l00420"></a>00420           in &gt;&gt; numElem;
<a name="l00421"></a>00421           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af5d5be0906f6129f3f3bd9b4878789c4">reserve_elem</a> (numElem);
<a name="l00422"></a>00422 
<a name="l00423"></a>00423           <span class="comment">// read the elements</span>
<a name="l00424"></a>00424           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_id_counter = 0;
<a name="l00425"></a>00425           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> iel=0; iel&lt;numElem; ++iel)      
<a name="l00426"></a>00426             {
<a name="l00427"></a>00427               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> id, type, physical, elementary,
<a name="l00428"></a>00428                 <span class="comment">/* partition = 1,*/</span> nnodes, ntags;
<a name="l00429"></a>00429               <span class="comment">// note - partition was assigned but never used - BSK</span>
<a name="l00430"></a>00430               <span class="keywordflow">if</span>(version &lt;= 1.0)
<a name="l00431"></a>00431                 {
<a name="l00432"></a>00432                   in &gt;&gt; <span class="keywordtype">id</span> &gt;&gt; type &gt;&gt; physical &gt;&gt; elementary &gt;&gt; nnodes;
<a name="l00433"></a>00433                 }
<a name="l00434"></a>00434               <span class="keywordflow">else</span>
<a name="l00435"></a>00435                 {
<a name="l00436"></a>00436                   in &gt;&gt; <span class="keywordtype">id</span> &gt;&gt; type &gt;&gt; ntags;
<a name="l00437"></a>00437                   elementary = physical = <span class="comment">/* partition = */</span> 1;
<a name="l00438"></a>00438                   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = 0; j &lt; ntags; j++)
<a name="l00439"></a>00439                     {
<a name="l00440"></a>00440                       <span class="keywordtype">int</span> tag;
<a name="l00441"></a>00441                       in &gt;&gt; tag;
<a name="l00442"></a>00442                       <span class="keywordflow">if</span>(j == 0)
<a name="l00443"></a>00443                         physical = tag;
<a name="l00444"></a>00444                       <span class="keywordflow">else</span> <span class="keywordflow">if</span>(j == 1)
<a name="l00445"></a>00445                         elementary = tag;
<a name="l00446"></a>00446                       <span class="comment">// else if(j == 2)</span>
<a name="l00447"></a>00447                       <span class="comment">//  partition = tag;</span>
<a name="l00448"></a>00448                       <span class="comment">// ignore any other tags for now</span>
<a name="l00449"></a>00449                     }
<a name="l00450"></a>00450                 }
<a name="l00451"></a>00451 
<a name="l00452"></a>00452               <span class="comment">// consult the import element table which element to build</span>
<a name="l00453"></a>00453               <span class="keyword">const</span> elementDefinition&amp; eletype = eletypes_imp[type];
<a name="l00454"></a>00454               nnodes = eletype.nnodes;
<a name="l00455"></a>00455 
<a name="l00456"></a>00456               <span class="comment">// only elements that match the mesh dimension are added</span>
<a name="l00457"></a>00457               <span class="comment">// if the element dimension is one less than dim, the nodes and</span>
<a name="l00458"></a>00458               <span class="comment">// sides are added to the mesh.boundary_info</span>
<a name="l00459"></a>00459               <span class="keywordflow">if</span> (eletype.dim == dim)
<a name="l00460"></a>00460                 {
<a name="l00461"></a>00461                   <span class="comment">// add the elements to the mesh</span>
<a name="l00462"></a>00462                   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a>(eletype.type).<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00463"></a>00463                   elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>(elem_id_counter);
<a name="l00464"></a>00464                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(elem);
<a name="l00465"></a>00465 
<a name="l00466"></a>00466                   <span class="comment">// different to iel, lower dimensional elems aren&#39;t added</span>
<a name="l00467"></a>00467                   elem_id_counter++;
<a name="l00468"></a>00468 
<a name="l00469"></a>00469                   <span class="comment">// check number of nodes. We cannot do that for version 2.0</span>
<a name="l00470"></a>00470                   <span class="keywordflow">if</span> (version &lt;= 1.0) 
<a name="l00471"></a>00471                     {
<a name="l00472"></a>00472                       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>() != nnodes)
<a name="l00473"></a>00473                         {
<a name="l00474"></a>00474                           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Number of nodes for element &quot;</span> &lt;&lt; <span class="keywordtype">id</span>
<a name="l00475"></a>00475                                         &lt;&lt; <span class="stringliteral">&quot; of type &quot;</span> &lt;&lt; eletypes_imp[type].type
<a name="l00476"></a>00476                                         &lt;&lt; <span class="stringliteral">&quot; (Gmsh type &quot;</span> &lt;&lt; type  
<a name="l00477"></a>00477                                         &lt;&lt; <span class="stringliteral">&quot;) does not match Libmesh definition. &quot;</span>
<a name="l00478"></a>00478                                         &lt;&lt; <span class="stringliteral">&quot;I expected &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>()
<a name="l00479"></a>00479                                         &lt;&lt; <span class="stringliteral">&quot; nodes, but got &quot;</span> &lt;&lt; nnodes &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00480"></a>00480                           libmesh_error();
<a name="l00481"></a>00481                         }
<a name="l00482"></a>00482                     }
<a name="l00483"></a>00483 
<a name="l00484"></a>00484                   <span class="comment">// add node pointers to the elements</span>
<a name="l00485"></a>00485                   <span class="keywordtype">int</span> nod = 0;
<a name="l00486"></a>00486                   <span class="comment">// if there is a node translation table, use it</span>
<a name="l00487"></a>00487                   <span class="keywordflow">if</span> (eletype.nodes.size() &gt; 0)
<a name="l00488"></a>00488                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nnodes; i++)
<a name="l00489"></a>00489                       {
<a name="l00490"></a>00490                         in &gt;&gt; nod;
<a name="l00491"></a>00491                         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(eletype.nodes[i]) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(nodetrans[nod]);
<a name="l00492"></a>00492                       }
<a name="l00493"></a>00493                   <span class="keywordflow">else</span>
<a name="l00494"></a>00494                     {
<a name="l00495"></a>00495                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nnodes; i++)
<a name="l00496"></a>00496                         {
<a name="l00497"></a>00497                           in &gt;&gt; nod;
<a name="l00498"></a>00498                           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(i) = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(nodetrans[nod]);
<a name="l00499"></a>00499                         }
<a name="l00500"></a>00500                     }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502                     <span class="comment">// Finally, set the subdomain ID to physical</span>
<a name="l00503"></a>00503                     elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a><span class="keyword">&gt;</span>(physical);
<a name="l00504"></a>00504                 } <span class="comment">// if element.dim == dim</span>
<a name="l00505"></a>00505               <span class="comment">// if this is a boundary</span>
<a name="l00506"></a>00506               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (eletype.dim == dim-1)
<a name="l00507"></a>00507                 {
<a name="l00512"></a>00512                   boundaryElementInfo binfo;
<a name="l00513"></a>00513                   std::set&lt;unsigned int&gt;::iterator iter = binfo.nodes.begin();
<a name="l00514"></a>00514                   <span class="keywordtype">int</span> nod = 0;
<a name="l00515"></a>00515                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nnodes; i++)
<a name="l00516"></a>00516                     {
<a name="l00517"></a>00517                       in &gt;&gt; nod;
<a name="l00518"></a>00518                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_node(nodetrans[nod], physical);
<a name="l00519"></a>00519                       binfo.nodes.insert(iter, nodetrans[nod]);
<a name="l00520"></a>00520                     }
<a name="l00521"></a>00521                   binfo.id = physical;
<a name="l00522"></a>00522                   boundary_elem.push_back(binfo);
<a name="l00523"></a>00523                 }
<a name="l00528"></a>00528               <span class="keywordflow">else</span>
<a name="l00529"></a>00529                 {
<a name="l00530"></a>00530                   <span class="keyword">static</span> <span class="keywordtype">bool</span> seen_high_dim_element = <span class="keyword">false</span>;
<a name="l00531"></a>00531                   <span class="keywordflow">if</span> (!seen_high_dim_element)
<a name="l00532"></a>00532                     {
<a name="l00533"></a>00533                       std::cerr &lt;&lt; <span class="stringliteral">&quot;Warning: can&#39;t load an element of dimension &quot;</span>
<a name="l00534"></a>00534                                 &lt;&lt; eletype.dim &lt;&lt; <span class="stringliteral">&quot; into a mesh of dimension &quot;</span>
<a name="l00535"></a>00535                                 &lt;&lt; dim &lt;&lt; std::endl;
<a name="l00536"></a>00536                       seen_high_dim_element = <span class="keyword">true</span>;
<a name="l00537"></a>00537                     }
<a name="l00538"></a>00538                   <span class="keywordtype">int</span> nod = 0;
<a name="l00539"></a>00539                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nnodes; i++)
<a name="l00540"></a>00540                     in &gt;&gt; nod;
<a name="l00541"></a>00541                 }
<a name="l00542"></a>00542             }<span class="comment">//element loop</span>
<a name="l00543"></a>00543           <span class="comment">// read the $ENDELM delimiter</span>
<a name="l00544"></a>00544           in &gt;&gt; buf;
<a name="l00545"></a>00545 
<a name="l00551"></a>00551           <span class="keywordflow">if</span> (boundary_elem.size() &gt; 0)
<a name="l00552"></a>00552             {
<a name="l00553"></a>00553               <span class="comment">// create a index of the boundary nodes to easily locate which</span>
<a name="l00554"></a>00554               <span class="comment">// element might have that boundary</span>
<a name="l00555"></a>00555               std::map&lt;unsigned int, std::vector&lt;unsigned int&gt; &gt; node_index;
<a name="l00556"></a>00556               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;boundary_elem.size(); i++)
<a name="l00557"></a>00557                 {
<a name="l00558"></a>00558                   boundaryElementInfo binfo = boundary_elem[i];
<a name="l00559"></a>00559                   std::set&lt;unsigned int&gt;::iterator iter = binfo.nodes.begin();
<a name="l00560"></a>00560                   <span class="keywordflow">for</span> (;iter!= binfo.nodes.end(); iter++)
<a name="l00561"></a>00561                     node_index[*iter].push_back(i);
<a name="l00562"></a>00562                 }
<a name="l00563"></a>00563               
<a name="l00564"></a>00564               <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00565"></a>00565               <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00566"></a>00566               
<a name="l00567"></a>00567               <span class="comment">// iterate over all elements and see which boundary element has</span>
<a name="l00568"></a>00568               <span class="comment">// the same set of nodes as on of the boundary elements previously read</span>
<a name="l00569"></a>00569               <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00570"></a>00570                 {
<a name="l00571"></a>00571                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00572"></a>00572                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00573"></a>00573                     <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l00574"></a>00574                       {
<a name="l00575"></a>00575                         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00576"></a>00576                         std::set&lt;unsigned int&gt; side_nodes;
<a name="l00577"></a>00577                         std::set&lt;unsigned int&gt;::iterator iter = side_nodes.begin();
<a name="l00578"></a>00578 
<a name="l00579"></a>00579                         <span class="comment">// make a set with all nodes from this side</span>
<a name="l00580"></a>00580                         <span class="comment">// this allows for easy comparison                        </span>
<a name="l00581"></a>00581                         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns=0; ns&lt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_nodes(); ns++)
<a name="l00582"></a>00582                           side_nodes.insert(iter, <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(ns)); 
<a name="l00583"></a>00583 
<a name="l00584"></a>00584                         <span class="comment">// See whether one of the side node occurs in the list</span>
<a name="l00585"></a>00585                         <span class="comment">// of tagged nodes. If we would loop over all side</span>
<a name="l00586"></a>00586                         <span class="comment">// nodes, we would just get multiple hits, so taking</span>
<a name="l00587"></a>00587                         <span class="comment">// node 0 is enough to do the job</span>
<a name="l00588"></a>00588                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sn = <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(0);
<a name="l00589"></a>00589                         <span class="keywordflow">if</span> (node_index.count(sn) &gt; 0)
<a name="l00590"></a>00590                           {
<a name="l00591"></a>00591                             <span class="comment">// Loop over all tagged (&quot;physical&quot;) &quot;sides&quot; which</span>
<a name="l00592"></a>00592                             <span class="comment">// contain the node sn (typically just 1 to</span>
<a name="l00593"></a>00593                             <span class="comment">// three). For each of these the set of nodes is</span>
<a name="l00594"></a>00594                             <span class="comment">// compared to the current element&#39;s side nodes</span>
<a name="l00595"></a>00595                             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;node_index[sn].size(); n++)
<a name="l00596"></a>00596                               {
<a name="l00597"></a>00597                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bidx = node_index[sn][n];
<a name="l00598"></a>00598                                 <span class="keywordflow">if</span> (boundary_elem[bidx].nodes == side_nodes)
<a name="l00599"></a>00599                                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, s, boundary_elem[bidx].<span class="keywordtype">id</span>);
<a name="l00600"></a>00600                               }
<a name="l00601"></a>00601                           }
<a name="l00602"></a>00602                       } <span class="comment">// if elem-&gt;neighbor(s) == NULL</span>
<a name="l00603"></a>00603                 } <span class="comment">// element loop</span>
<a name="l00604"></a>00604             } <span class="comment">// if boundary_elem.size() &gt; 0</span>
<a name="l00605"></a>00605         } <span class="comment">// if $ELM</span>
<a name="l00606"></a>00606 
<a name="l00607"></a>00607     } <span class="comment">// while !in.eof()</span>
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   }
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 }
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 
<a name="l00615"></a><a class="code" href="classlibMesh_1_1GmshIO.php#a011fb192816a7c712aa03bf7afef9319">00615</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a011fb192816a7c712aa03bf7afef9319">GmshIO::write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00616"></a>00616 {
<a name="l00617"></a>00617   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00618"></a>00618     {
<a name="l00619"></a>00619       <span class="comment">// Open the output file stream</span>
<a name="l00620"></a>00620       std::ofstream <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> (name.c_str());
<a name="l00621"></a>00621 
<a name="l00622"></a>00622       <span class="comment">// Make sure it opened correctly</span>
<a name="l00623"></a>00623       <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>.good())
<a name="l00624"></a>00624         libmesh_file_error(name.c_str());
<a name="l00625"></a>00625 
<a name="l00626"></a>00626       this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a530c51488c6aa85331cf65af88fb1625">write_mesh</a> (<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>);
<a name="l00627"></a>00627     }
<a name="l00628"></a>00628 }
<a name="l00629"></a>00629 
<a name="l00630"></a>00630 
<a name="l00631"></a><a class="code" href="classlibMesh_1_1GmshIO.php#a1e917b030e1aa7788a7074ab8e36fb28">00631</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a1e917b030e1aa7788a7074ab8e36fb28">GmshIO::write_nodal_data</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00632"></a>00632                                <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; soln,
<a name="l00633"></a>00633                                <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp; names)
<a name="l00634"></a>00634 {
<a name="l00635"></a>00635   <span class="comment">//this-&gt;_binary = true;</span>
<a name="l00636"></a>00636   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00637"></a>00637     this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a1991421b7e76fcf5f9792e2b232f934e">write_post</a>  (fname, &amp;soln, &amp;names);
<a name="l00638"></a>00638 }
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 
<a name="l00641"></a><a class="code" href="classlibMesh_1_1GmshIO.php#a530c51488c6aa85331cf65af88fb1625">00641</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a530c51488c6aa85331cf65af88fb1625">GmshIO::write_mesh</a> (std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)
<a name="l00642"></a>00642 {
<a name="l00643"></a>00643   <span class="comment">// Be sure that the stream is valid.</span>
<a name="l00644"></a>00644   libmesh_assert (out.good());
<a name="l00645"></a>00645   
<a name="l00646"></a>00646   <span class="comment">// initialize the map with element types</span>
<a name="l00647"></a>00647   init_eletypes();
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   <span class="comment">// Get a const reference to the mesh</span>
<a name="l00650"></a>00650   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00651"></a>00651   
<a name="l00652"></a>00652   <span class="comment">// Note: we are using version 2.0 of the gmsh output format.</span>
<a name="l00653"></a>00653   
<a name="l00654"></a>00654   {
<a name="l00655"></a>00655     <span class="comment">// Write the file header.</span>
<a name="l00656"></a>00656     out &lt;&lt; <span class="stringliteral">&quot;$MeshFormat\n&quot;</span>;
<a name="l00657"></a>00657     out &lt;&lt; <span class="stringliteral">&quot;2.0 0 &quot;</span> &lt;&lt; <span class="keyword">sizeof</span>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>) &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00658"></a>00658     out &lt;&lt; <span class="stringliteral">&quot;$EndMeshFormat\n&quot;</span>;
<a name="l00659"></a>00659   }
<a name="l00660"></a>00660 
<a name="l00661"></a>00661   {
<a name="l00662"></a>00662     <span class="comment">// write the nodes in (n x y z) format</span>
<a name="l00663"></a>00663     out &lt;&lt; <span class="stringliteral">&quot;$Nodes\n&quot;</span>;
<a name="l00664"></a>00664     out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00665"></a>00665     
<a name="l00666"></a>00666     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); v++)
<a name="l00667"></a>00667       out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(v).<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00668"></a>00668           &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(v)(0) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00669"></a>00669           &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(v)(1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00670"></a>00670           &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(v)(2) &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00671"></a>00671     out &lt;&lt; <span class="stringliteral">&quot;$EndNodes\n&quot;</span>;
<a name="l00672"></a>00672   }
<a name="l00673"></a>00673   
<a name="l00674"></a>00674   {
<a name="l00675"></a>00675     <span class="comment">// write the connectivity</span>
<a name="l00676"></a>00676     out &lt;&lt; <span class="stringliteral">&quot;$Elements\n&quot;</span>;
<a name="l00677"></a>00677     out &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00678"></a>00678 
<a name="l00679"></a>00679     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00680"></a>00680     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00681"></a>00681     
<a name="l00682"></a>00682     <span class="comment">// loop over the elements</span>
<a name="l00683"></a>00683     <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00684"></a>00684       {
<a name="l00685"></a>00685         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00686"></a>00686 
<a name="l00687"></a>00687         <span class="comment">// Make sure we have a valid entry for</span>
<a name="l00688"></a>00688         <span class="comment">// the current element type.</span>
<a name="l00689"></a>00689         libmesh_assert (eletypes_exp.count(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>()));
<a name="l00690"></a>00690 
<a name="l00691"></a>00691         <span class="comment">// consult the export element table </span>
<a name="l00692"></a>00692         <span class="keyword">const</span> elementDefinition&amp; eletype = eletypes_exp[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>()];
<a name="l00693"></a>00693 
<a name="l00694"></a>00694         <span class="comment">// The element mapper better not require any more nodes</span>
<a name="l00695"></a>00695         <span class="comment">// than are present in the current element!</span>
<a name="l00696"></a>00696         libmesh_assert (eletype.nodes.size() &lt;= elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>());
<a name="l00697"></a>00697         
<a name="l00698"></a>00698         <span class="comment">// elements ids are 1 based in Gmsh</span>
<a name="l00699"></a>00699         out &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00700"></a>00700 
<a name="l00701"></a>00701         <span class="comment">// element type</span>
<a name="l00702"></a>00702         out &lt;&lt; eletype.exptype;
<a name="l00703"></a>00703 
<a name="l00704"></a>00704         <span class="comment">// write the number of tags and</span>
<a name="l00705"></a>00705         <span class="comment">// tag1 (physical entity), tag2 (geometric entity), and tag3 (partition entity)</span>
<a name="l00706"></a>00706         out &lt;&lt; <span class="stringliteral">&quot; 3 &quot;</span>
<a name="l00707"></a>00707             &lt;&lt; <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>())
<a name="l00708"></a>00708             &lt;&lt; <span class="stringliteral">&quot; 1 &quot;</span> 
<a name="l00709"></a>00709             &lt;&lt; (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>()+1) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00710"></a>00710 
<a name="l00711"></a>00711         <span class="comment">// if there is a node translation table, use it</span>
<a name="l00712"></a>00712         <span class="keywordflow">if</span> (eletype.nodes.size() &gt; 0)
<a name="l00713"></a>00713           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); i++)
<a name="l00714"></a>00714             out &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(eletype.nodes[i])+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>; <span class="comment">// gmsh is 1-based </span>
<a name="l00715"></a>00715         <span class="comment">// otherwise keep the same node order</span>
<a name="l00716"></a>00716         <span class="keywordflow">else</span>
<a name="l00717"></a>00717           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); i++)
<a name="l00718"></a>00718             out &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(i)+1 &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;                  <span class="comment">// gmsh is 1-based </span>
<a name="l00719"></a>00719         out &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00720"></a>00720       } <span class="comment">// element loop</span>
<a name="l00721"></a>00721     out &lt;&lt; <span class="stringliteral">&quot;$EndElements\n&quot;</span>;
<a name="l00722"></a>00722   }
<a name="l00723"></a>00723 }
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 
<a name="l00726"></a><a class="code" href="classlibMesh_1_1GmshIO.php#a1991421b7e76fcf5f9792e2b232f934e">00726</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a1991421b7e76fcf5f9792e2b232f934e">GmshIO::write_post</a> (<span class="keyword">const</span> std::string&amp; fname,
<a name="l00727"></a>00727                          <span class="keyword">const</span> std::vector&lt;Number&gt;* v,
<a name="l00728"></a>00728                          <span class="keyword">const</span> std::vector&lt;std::string&gt;* solution_names)
<a name="l00729"></a>00729 {
<a name="l00730"></a>00730 
<a name="l00731"></a>00731   <span class="comment">// Should only do this on processor 0!</span>
<a name="l00732"></a>00732   libmesh_assert (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0);
<a name="l00733"></a>00733   
<a name="l00734"></a>00734   <span class="comment">// Create an output stream</span>
<a name="l00735"></a>00735   std::ofstream <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>(fname.c_str());
<a name="l00736"></a>00736 
<a name="l00737"></a>00737   <span class="comment">// Make sure it opened correctly</span>
<a name="l00738"></a>00738   <span class="keywordflow">if</span> (!<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>.good())
<a name="l00739"></a>00739     libmesh_file_error(fname.c_str());
<a name="l00740"></a>00740 
<a name="l00741"></a>00741   <span class="comment">// initialize the map with element types</span>
<a name="l00742"></a>00742   init_eletypes();
<a name="l00743"></a>00743 
<a name="l00744"></a>00744   <span class="comment">// create a character buffer</span>
<a name="l00745"></a>00745   <span class="keywordtype">char</span> buf[80];
<a name="l00746"></a>00746 
<a name="l00747"></a>00747   <span class="comment">// Get a constant reference to the mesh.</span>
<a name="l00748"></a>00748   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshOutput&lt;MeshBase&gt;::mesh</a>();
<a name="l00749"></a>00749 
<a name="l00750"></a>00750   <span class="comment">//  write the data</span>
<a name="l00751"></a>00751   <span class="keywordflow">if</span> ((solution_names != NULL) &amp;&amp; (v != NULL))
<a name="l00752"></a>00752     {      
<a name="l00753"></a>00753       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = solution_names-&gt;size();
<a name="l00754"></a>00754     
<a name="l00755"></a>00755       <span class="keywordflow">if</span> (!(v-&gt;size() == mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>()*<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>))
<a name="l00756"></a>00756         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: v-&gt;size()=&quot;</span> &lt;&lt; v-&gt;size()
<a name="l00757"></a>00757                       &lt;&lt; <span class="stringliteral">&quot;, mesh.n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>()
<a name="l00758"></a>00758                       &lt;&lt; <span class="stringliteral">&quot;, n_vars=&quot;</span> &lt;&lt; n_vars
<a name="l00759"></a>00759                       &lt;&lt; <span class="stringliteral">&quot;, mesh.n_nodes()*n_vars=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>()*n_vars
<a name="l00760"></a>00760                       &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00761"></a>00761       
<a name="l00762"></a>00762       libmesh_assert (v-&gt;size() == mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>()*<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>);
<a name="l00763"></a>00763 
<a name="l00764"></a>00764       <span class="comment">// write the header</span>
<a name="l00765"></a>00765       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> &lt;&lt; <span class="stringliteral">&quot;$PostFormat\n&quot;</span>;
<a name="l00766"></a>00766       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">binary</a>())
<a name="l00767"></a>00767         out &lt;&lt; <span class="stringliteral">&quot;1.2 1 &quot;</span> &lt;&lt; <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>) &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00768"></a>00768       <span class="keywordflow">else</span>
<a name="l00769"></a>00769         out &lt;&lt; <span class="stringliteral">&quot;1.2 0 &quot;</span> &lt;&lt; <span class="keyword">sizeof</span>(double) &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00770"></a>00770       out &lt;&lt; <span class="stringliteral">&quot;$EndPostFormat\n&quot;</span>;
<a name="l00771"></a>00771 
<a name="l00772"></a>00772       <span class="comment">// Loop over the elements to see how much of each type there are</span>
<a name="l00773"></a>00773       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_points=0, n_lines=0, n_triangles=0, n_quadrangles=0,
<a name="l00774"></a>00774         n_tetrahedra=0, n_hexahedra=0, n_prisms=0, n_pyramids=0;
<a name="l00775"></a>00775       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_scalar=0, n_vector=0, n_tensor=0;
<a name="l00776"></a>00776       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nb_text2d=0, nb_text2d_chars=0, nb_text3d=0, nb_text3d_chars=0;
<a name="l00777"></a>00777 
<a name="l00778"></a>00778       {
<a name="l00779"></a>00779         <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00780"></a>00780         <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00781"></a>00781 
<a name="l00782"></a>00782 
<a name="l00783"></a>00783         <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00784"></a>00784           {
<a name="l00785"></a>00785             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> elemtype = (*it)-&gt;type();
<a name="l00786"></a>00786             
<a name="l00787"></a>00787             <span class="keywordflow">switch</span> (elemtype)
<a name="l00788"></a>00788               {
<a name="l00789"></a>00789               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00790"></a>00790               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00791"></a>00791               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa098d19e7903837c45b907c299376b52">EDGE4</a>:
<a name="l00792"></a>00792                 {
<a name="l00793"></a>00793                   n_lines += 1;
<a name="l00794"></a>00794                   <span class="keywordflow">break</span>;
<a name="l00795"></a>00795                 }
<a name="l00796"></a>00796               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00797"></a>00797               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00798"></a>00798                 {
<a name="l00799"></a>00799                   n_triangles += 1;
<a name="l00800"></a>00800                   <span class="keywordflow">break</span>;
<a name="l00801"></a>00801                 }
<a name="l00802"></a>00802               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00803"></a>00803               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00804"></a>00804               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00805"></a>00805                 {
<a name="l00806"></a>00806                   n_quadrangles += 1;
<a name="l00807"></a>00807                   <span class="keywordflow">break</span>;
<a name="l00808"></a>00808                 }
<a name="l00809"></a>00809               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00810"></a>00810               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00811"></a>00811                 {
<a name="l00812"></a>00812                   n_tetrahedra += 1;
<a name="l00813"></a>00813                   <span class="keywordflow">break</span>;
<a name="l00814"></a>00814                 }
<a name="l00815"></a>00815               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00816"></a>00816               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00817"></a>00817               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00818"></a>00818                 {
<a name="l00819"></a>00819                   n_hexahedra += 1;
<a name="l00820"></a>00820                   <span class="keywordflow">break</span>;
<a name="l00821"></a>00821                 }
<a name="l00822"></a>00822               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00823"></a>00823               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00824"></a>00824               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00825"></a>00825                 {
<a name="l00826"></a>00826                   n_prisms += 1;
<a name="l00827"></a>00827                   <span class="keywordflow">break</span>;
<a name="l00828"></a>00828                 }
<a name="l00829"></a>00829               <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00830"></a>00830                 {
<a name="l00831"></a>00831                   n_pyramids += 1;
<a name="l00832"></a>00832                   <span class="keywordflow">break</span>;
<a name="l00833"></a>00833                 }
<a name="l00834"></a>00834               <span class="keywordflow">default</span>:
<a name="l00835"></a>00835                 {
<a name="l00836"></a>00836                   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Not existant element type &quot;</span>
<a name="l00837"></a>00837                                 &lt;&lt; (*it)-&gt;type() &lt;&lt; std::endl;
<a name="l00838"></a>00838                   libmesh_error();
<a name="l00839"></a>00839                 }
<a name="l00840"></a>00840               }
<a name="l00841"></a>00841           }
<a name="l00842"></a>00842       }
<a name="l00843"></a>00843 
<a name="l00844"></a>00844       <span class="comment">// create a view for each variable</span>
<a name="l00845"></a>00845       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ivar=0; ivar &lt; <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; ivar++)
<a name="l00846"></a>00846         {
<a name="l00847"></a>00847           std::string varname = (*solution_names)[ivar];
<a name="l00848"></a>00848 
<a name="l00849"></a>00849           <span class="comment">// at the moment, we just write out scalar quantities</span>
<a name="l00850"></a>00850           <span class="comment">// later this should be made configurable through</span>
<a name="l00851"></a>00851           <span class="comment">// options to the writer class</span>
<a name="l00852"></a>00852           n_scalar = 1;
<a name="l00853"></a>00853       
<a name="l00854"></a>00854           <span class="comment">// write the variable as a view, and the number of time steps</span>
<a name="l00855"></a>00855           out &lt;&lt; <span class="stringliteral">&quot;$View\n&quot;</span> &lt;&lt; varname &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; 1 &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00856"></a>00856       
<a name="l00857"></a>00857           <span class="comment">// write how many of each geometry type are written</span>
<a name="l00858"></a>00858           out &lt;&lt; n_points * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00859"></a>00859               &lt;&lt; n_points * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00860"></a>00860               &lt;&lt; n_points * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00861"></a>00861               &lt;&lt; n_lines * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00862"></a>00862               &lt;&lt; n_lines * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00863"></a>00863               &lt;&lt; n_lines * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00864"></a>00864               &lt;&lt; n_triangles * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00865"></a>00865               &lt;&lt; n_triangles * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00866"></a>00866               &lt;&lt; n_triangles * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00867"></a>00867               &lt;&lt; n_quadrangles * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00868"></a>00868               &lt;&lt; n_quadrangles * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00869"></a>00869               &lt;&lt; n_quadrangles * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00870"></a>00870               &lt;&lt; n_tetrahedra * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00871"></a>00871               &lt;&lt; n_tetrahedra * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00872"></a>00872               &lt;&lt; n_tetrahedra * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00873"></a>00873               &lt;&lt; n_hexahedra * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00874"></a>00874               &lt;&lt; n_hexahedra * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00875"></a>00875               &lt;&lt; n_hexahedra * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00876"></a>00876               &lt;&lt; n_prisms * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00877"></a>00877               &lt;&lt; n_prisms * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00878"></a>00878               &lt;&lt; n_prisms * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00879"></a>00879               &lt;&lt; n_pyramids * n_scalar &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00880"></a>00880               &lt;&lt; n_pyramids * n_vector &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00881"></a>00881               &lt;&lt; n_pyramids * n_tensor &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00882"></a>00882               &lt;&lt; nb_text2d &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00883"></a>00883               &lt;&lt; nb_text2d_chars &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00884"></a>00884               &lt;&lt; nb_text3d &lt;&lt; <span class="stringliteral">&quot; &quot;</span>
<a name="l00885"></a>00885               &lt;&lt; nb_text3d_chars &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00886"></a>00886       
<a name="l00887"></a>00887           <span class="comment">// if binary, write a marker to identify the endianness of the file</span>
<a name="l00888"></a>00888           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">binary</a>())
<a name="l00889"></a>00889             {
<a name="l00890"></a>00890               <span class="keyword">const</span> <span class="keywordtype">int</span> one = 1;
<a name="l00891"></a>00891               std::memcpy(buf, &amp;one, <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));
<a name="l00892"></a>00892               out.write(buf, <span class="keyword">sizeof</span>(<span class="keywordtype">int</span>));
<a name="l00893"></a>00893             }
<a name="l00894"></a>00894 
<a name="l00895"></a>00895           <span class="comment">// the time steps (there is just 1 at the moment)</span>
<a name="l00896"></a>00896           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">binary</a>())
<a name="l00897"></a>00897             {
<a name="l00898"></a>00898               <span class="keywordtype">double</span> one = 1;
<a name="l00899"></a>00899               std::memcpy(buf, &amp;one, <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00900"></a>00900               out.write(buf, <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00901"></a>00901             }
<a name="l00902"></a>00902           <span class="keywordflow">else</span>
<a name="l00903"></a>00903             out &lt;&lt; <span class="stringliteral">&quot;1\n&quot;</span>;
<a name="l00904"></a>00904 
<a name="l00905"></a>00905           <span class="comment">// Loop over the elements and write out the data</span>
<a name="l00906"></a>00906           <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00907"></a>00907           <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00908"></a>00908     
<a name="l00909"></a>00909           <span class="keywordflow">for</span> ( ; it != end; ++it)
<a name="l00910"></a>00910             {
<a name="l00911"></a>00911               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00912"></a>00912         
<a name="l00913"></a>00913               <span class="comment">// this is quite crappy, but I did not invent that file format!</span>
<a name="l00914"></a>00914               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d=0; d&lt;3; d++)  <span class="comment">// loop over the dimensions </span>
<a name="l00915"></a>00915                 {
<a name="l00916"></a>00916                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); n++)   <span class="comment">// loop over vertices</span>
<a name="l00917"></a>00917                     {
<a name="l00918"></a>00918                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> vertex = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n);
<a name="l00919"></a>00919                       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">binary</a>())
<a name="l00920"></a>00920                         {
<a name="l00921"></a>00921                           <span class="keywordtype">double</span> tmp = vertex(d);
<a name="l00922"></a>00922                           std::memcpy(buf, &amp;tmp, <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00923"></a>00923                           out.write(reinterpret_cast&lt;char *&gt;(buf), <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00924"></a>00924                         }
<a name="l00925"></a>00925                       <span class="keywordflow">else</span>
<a name="l00926"></a>00926                         out &lt;&lt; vertex(d) &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00927"></a>00927                     }
<a name="l00928"></a>00928                   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">binary</a>())
<a name="l00929"></a>00929                     out &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00930"></a>00930                 }
<a name="l00931"></a>00931 
<a name="l00932"></a>00932               <span class="comment">// now finally write out the data</span>
<a name="l00933"></a>00933               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); i++)   <span class="comment">// loop over vertices</span>
<a name="l00934"></a>00934                 <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">binary</a>())
<a name="l00935"></a>00935                   {
<a name="l00936"></a>00936 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00937"></a>00937 <span class="preprocessor"></span>                    <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Gmsh::write_post does not fully support &quot;</span>
<a name="l00938"></a>00938                                   &lt;&lt; <span class="stringliteral">&quot;complex numbers. Will only write the real part of &quot;</span>
<a name="l00939"></a>00939                                   &lt;&lt; <span class="stringliteral">&quot;variable &quot;</span> &lt;&lt; varname &lt;&lt; std::endl;
<a name="l00940"></a>00940 <span class="preprocessor">#endif</span>
<a name="l00941"></a>00941 <span class="preprocessor"></span>                    <span class="keywordtype">double</span> tmp = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*v)[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(i)*n_vars + ivar]);
<a name="l00942"></a>00942                     std::memcpy(buf, &amp;tmp, <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00943"></a>00943                     out.write(reinterpret_cast&lt;char *&gt;(buf), <span class="keyword">sizeof</span>(<span class="keywordtype">double</span>));
<a name="l00944"></a>00944                   }
<a name="l00945"></a>00945                 <span class="keywordflow">else</span>
<a name="l00946"></a>00946                   {
<a name="l00947"></a>00947 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00948"></a>00948 <span class="preprocessor"></span>                    <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Gmsh::write_post does not fully support &quot;</span>
<a name="l00949"></a>00949                                   &lt;&lt; <span class="stringliteral">&quot;complex numbers. Will only write the real part of &quot;</span>
<a name="l00950"></a>00950                                   &lt;&lt; <span class="stringliteral">&quot;variable &quot;</span> &lt;&lt; varname &lt;&lt; std::endl;
<a name="l00951"></a>00951 <span class="preprocessor">#endif</span>
<a name="l00952"></a>00952 <span class="preprocessor"></span>                    out &lt;&lt; <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*v)[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(i)*n_vars + ivar]) &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00953"></a>00953                   }
<a name="l00954"></a>00954             }
<a name="l00955"></a>00955           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">binary</a>())
<a name="l00956"></a>00956             out &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00957"></a>00957           out &lt;&lt; <span class="stringliteral">&quot;$EndView\n&quot;</span>;
<a name="l00958"></a>00958 
<a name="l00959"></a>00959         } <span class="comment">// end variable loop (writing the views)</span>
<a name="l00960"></a>00960     }
<a name="l00961"></a>00961 
<a name="l00962"></a>00962 }
<a name="l00963"></a>00963 
<a name="l00964"></a>00964 } <span class="comment">// namespace libMesh</span>
<a name="l00965"></a>00965 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
