<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">gmsh_io.h</div>  </div>
</div>
<div class="contents">
<a href="gmsh__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: gmsh_io.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __gmsh_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __gmsh_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward declarations</span>
<a name="l00034"></a>00034 <span class="keyword">class </span>MeshBase;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00048"></a>00048 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// GMVIO class definition</span>
<a name="l00050"></a><a class="code" href="classlibMesh_1_1GmshIO.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1GmshIO.php">GmshIO</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00051"></a>00051                <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053  <span class="keyword">public</span>:
<a name="l00054"></a>00054 
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1GmshIO.php#abcf1d83a2bc1a6e77682ed483fe55872">GmshIO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a>);
<a name="l00060"></a>00060   
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1GmshIO.php#abcf1d83a2bc1a6e77682ed483fe55872">GmshIO</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00066"></a>00066 
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a9c1ba35a3e456c1d7722bfb0c2d97ae2">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00072"></a>00072 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a011fb192816a7c712aa03bf7afef9319">write</a> (<span class="keyword">const</span> std::string&amp; name);
<a name="l00078"></a>00078   
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a1e917b030e1aa7788a7074ab8e36fb28">write_nodal_data</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00084"></a>00084                                  <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00085"></a>00085                                  <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00086"></a>00086 
<a name="l00097"></a>00097   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">binary</a> ();
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="keyword">private</span>:
<a name="l00106"></a>00106   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a5fa2a5e195b223daa82b17be9378a996">read_mesh</a> (std::istream&amp; in);
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a530c51488c6aa85331cf65af88fb1625">write_mesh</a> (std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>);
<a name="l00113"></a>00113 
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a1991421b7e76fcf5f9792e2b232f934e">write_post</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00120"></a>00120                    <span class="keyword">const</span> std::vector&lt;Number&gt;* = NULL,
<a name="l00121"></a>00121                    <span class="keyword">const</span> std::vector&lt;std::string&gt;* = NULL);
<a name="l00122"></a>00122 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1GmshIO.php#a6d8863391ce19097f0d358a9c4ce2375">00126</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a6d8863391ce19097f0d358a9c4ce2375">_binary</a>;
<a name="l00127"></a>00127  
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 };
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00135"></a>00135 <span class="comment">// GmshIO inline members</span>
<a name="l00136"></a>00136 <span class="keyword">inline</span>
<a name="l00137"></a><a class="code" href="classlibMesh_1_1GmshIO.php#af7f3f28f41113fe43d155426ddbaadb0">00137</a> <a class="code" href="classlibMesh_1_1GmshIO.php#abcf1d83a2bc1a6e77682ed483fe55872">GmshIO::GmshIO</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) :
<a name="l00138"></a>00138   <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00139"></a>00139   _binary        (false)
<a name="l00140"></a>00140 {
<a name="l00141"></a>00141 }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="keyword">inline</span>
<a name="l00145"></a><a class="code" href="classlibMesh_1_1GmshIO.php#abcf1d83a2bc1a6e77682ed483fe55872">00145</a> <a class="code" href="classlibMesh_1_1GmshIO.php#abcf1d83a2bc1a6e77682ed483fe55872">GmshIO::GmshIO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) :
<a name="l00146"></a>00146   <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt;  (mesh),
<a name="l00147"></a>00147   <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00148"></a>00148   _binary (false)
<a name="l00149"></a>00149 {}
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="keyword">inline</span>
<a name="l00152"></a><a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">00152</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GmshIO.php#a2eb40b9b8b4c293f464e89dada168f63">GmshIO::binary</a> ()
<a name="l00153"></a>00153 {
<a name="l00154"></a>00154   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1GmshIO.php#a6d8863391ce19097f0d358a9c4ce2375">_binary</a>;
<a name="l00155"></a>00155 }
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 } <span class="comment">// namespace libMesh</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 <span class="preprocessor">#endif // #define __gmsh_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
