<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">gmv_io.h</div>  </div>
</div>
<div class="contents">
<a href="gmv__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: gmv_io.h 3924 2010-08-24 22:10:57Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __gmv_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __gmv_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;cstring&gt;</span>  <span class="comment">// for memcpy</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span>MeshBase;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// GMVIO class definition</span>
<a name="l00054"></a><a class="code" href="classlibMesh_1_1GMVIO.php">00054</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1GMVIO.php">GMVIO</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00055"></a>00055               <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057  <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1GMVIO.php#a979584b211e542085cfdaf2a4336f689">GMVIO</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;);
<a name="l00064"></a>00064 
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1GMVIO.php#a979584b211e542085cfdaf2a4336f689">GMVIO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;);
<a name="l00070"></a>00070   
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a0930d00f5b0ca8c5192ea678dd08d265">write</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00075"></a>00075 
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#aafac685af2a642382a3390ec469da03a">read</a> (<span class="keyword">const</span> std::string&amp; mesh_file);
<a name="l00080"></a>00080   
<a name="l00081"></a>00081 <span class="comment">//   /**</span>
<a name="l00082"></a>00082 <span class="comment">//    * This method implements reading a mesh from a specified file.</span>
<a name="l00083"></a>00083 <span class="comment">//    */</span>
<a name="l00084"></a>00084 <span class="comment">//   virtual void read (const std::string&amp; mesh_file)</span>
<a name="l00085"></a>00085 <span class="comment">//   { this-&gt;read_mesh_and_nodal_data(mesh_file, NULL); }</span>
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="comment">//   /**</span>
<a name="l00088"></a>00088 <span class="comment">//    * Extension of the MeshInput::read() routine which</span>
<a name="l00089"></a>00089 <span class="comment">//    * also takes an optional EquationSystems pointer and</span>
<a name="l00090"></a>00090 <span class="comment">//    * tries to read field variables from the GMV file</span>
<a name="l00091"></a>00091 <span class="comment">//    * into the EquationSystems object.</span>
<a name="l00092"></a>00092 <span class="comment">//    */</span>
<a name="l00093"></a>00093 <span class="comment">//   virtual void read_mesh_and_nodal_data (const std::string&amp; ,</span>
<a name="l00094"></a>00094 <span class="comment">//                                       EquationSystems* es=NULL);</span>
<a name="l00095"></a>00095   
<a name="l00100"></a>00100   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a479a7ad380a62cf1979b0c873adb290d">write_nodal_data</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00101"></a>00101                                  <span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,
<a name="l00102"></a>00102                                  <span class="keyword">const</span> std::vector&lt;std::string&gt;&amp;);
<a name="l00103"></a>00103 
<a name="l00114"></a>00114   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a6fa07fc7de8aaf9a75d8852269176f92">binary</a> ();
<a name="l00115"></a>00115    
<a name="l00120"></a>00120   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a401d93c69b05c9d1e714030ab90f6c94">discontinuous</a>();
<a name="l00121"></a>00121   
<a name="l00126"></a>00126   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a07b8521ab252f7063c5d6385cb7da8f6">partitioning</a>();
<a name="l00127"></a>00127 
<a name="l00133"></a>00133   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a215caf1113a37ff475644be19a2b78fe">write_subdomain_id_as_material</a>();
<a name="l00134"></a>00134   
<a name="l00139"></a>00139   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a90e97f78bbc6c9211214b127b2768fe1">subdivide_second_order</a>();
<a name="l00140"></a>00140   
<a name="l00145"></a>00145   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a271520753142a42bf5a4c15165427ca2">p_levels</a>();
<a name="l00146"></a>00146   
<a name="l00150"></a>00150   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a2b09c1b2f977d1a259fc4f56a5754484">write_discontinuous_gmv</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>, 
<a name="l00151"></a>00151                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00152"></a>00152                                 <span class="keyword">const</span> <span class="keywordtype">bool</span> write_partitioning) <span class="keyword">const</span>;
<a name="l00153"></a>00153   
<a name="l00154"></a>00154 
<a name="l00161"></a>00161   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#abd8ce1e2331eaac6b73ad5a47f4f3512">write_ascii_new_impl</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00162"></a>00162                              <span class="keyword">const</span> std::vector&lt;Number&gt;* = NULL,
<a name="l00163"></a>00163                              <span class="keyword">const</span> std::vector&lt;std::string&gt;* = NULL);
<a name="l00164"></a>00164 
<a name="l00176"></a>00176   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#aa11bcdae5b4bf57c49b2d1f7af525855">add_cell_centered_data</a> (<span class="keyword">const</span> std::string&amp;       cell_centered_data_name,
<a name="l00177"></a>00177                                <span class="keyword">const</span> std::vector&lt;Real&gt;* cell_centered_data_vals);
<a name="l00178"></a>00178 
<a name="l00183"></a>00183   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a2b9b2bc4fdf9350a138f6f0e738cf775">copy_nodal_solution</a>(<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00184"></a>00184   
<a name="l00185"></a>00185 <span class="keyword">private</span>:
<a name="l00186"></a>00186 
<a name="l00193"></a>00193   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#ad8040af5e2b834b1aa89f3cc3fea9df1">write_ascii_old_impl</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00194"></a>00194                              <span class="keyword">const</span> std::vector&lt;Number&gt;* = NULL,
<a name="l00195"></a>00195                              <span class="keyword">const</span> std::vector&lt;std::string&gt;* = NULL);
<a name="l00196"></a>00196 
<a name="l00202"></a>00202   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a7490279b00c766cf0db8d08eb431a6d3">write_binary</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00203"></a>00203                      <span class="keyword">const</span> std::vector&lt;Number&gt;* = NULL,
<a name="l00204"></a>00204                      <span class="keyword">const</span> std::vector&lt;std::string&gt;* = NULL);
<a name="l00205"></a>00205   
<a name="l00210"></a>00210   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00211"></a>00211   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a511b590dd8311d67060c9530723544ce">to_binary_stream</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>,
<a name="l00212"></a>00212                         <span class="keyword">const</span> T i);
<a name="l00213"></a>00213   
<a name="l00217"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a4cf46078adf6da377fe063b3bc6936f8">00217</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a4cf46078adf6da377fe063b3bc6936f8">_binary</a>;
<a name="l00218"></a>00218  
<a name="l00222"></a><a class="code" href="classlibMesh_1_1GMVIO.php#ac2ac7959411d8555546af417ddc63e72">00222</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1GMVIO.php#ac2ac7959411d8555546af417ddc63e72">_discontinuous</a>;
<a name="l00223"></a>00223  
<a name="l00227"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a7e42c024bee3e9acde3726eed1d97345">00227</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a7e42c024bee3e9acde3726eed1d97345">_partitioning</a>;
<a name="l00228"></a>00228 
<a name="l00233"></a><a class="code" href="classlibMesh_1_1GMVIO.php#ada7d8bd7b3d2be4fa1ba82d5ce54141e">00233</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1GMVIO.php#ada7d8bd7b3d2be4fa1ba82d5ce54141e">_write_subdomain_id_as_material</a>;
<a name="l00234"></a>00234   
<a name="l00238"></a><a class="code" href="classlibMesh_1_1GMVIO.php#ac734138f99d98f189aebc29136febbd0">00238</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1GMVIO.php#ac734138f99d98f189aebc29136febbd0">_subdivide_second_order</a>;
<a name="l00239"></a>00239  
<a name="l00243"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a56f18d1d2fdb0c3c6d24069df24f6eaf">00243</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a56f18d1d2fdb0c3c6d24069df24f6eaf">_p_levels</a>;
<a name="l00244"></a>00244 
<a name="l00251"></a><a class="code" href="classlibMesh_1_1GMVIO.php#ab1111c521b0089864c26965480023dee">00251</a>   std::map&lt;std::string, const std::vector&lt;Real&gt;* &gt; <a class="code" href="classlibMesh_1_1GMVIO.php#ab1111c521b0089864c26965480023dee">_cell_centered_data</a>;
<a name="l00252"></a>00252 
<a name="l00256"></a>00256   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a678bd21572244b18f7cbcdb7c4ac757c">_read_nodes</a>();
<a name="l00257"></a><a class="code" href="classlibMesh_1_1GMVIO.php#aae6172b47f9277d0e4b558e6ee9b1aab">00257</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1GMVIO.php#aae6172b47f9277d0e4b558e6ee9b1aab">_next_elem_id</a>;
<a name="l00258"></a>00258   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a42852e54482c42d4f948b0a6a790bfd2">_read_one_cell</a>();
<a name="l00259"></a>00259   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1GMVIO.php#a2c96f2e730419fbb2908243c1a2391d9">_gmv_elem_to_libmesh_elem</a>(<span class="keyword">const</span> <span class="keywordtype">char</span>* elemname);
<a name="l00260"></a>00260   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a95b6004fed70a6761c52e79ad86f850a">_read_materials</a>();
<a name="l00261"></a>00261   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a6453d248bfac46f5e403b2c8f6651355">_read_var</a>();
<a name="l00262"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a6deea23cebc78a57d7105294bcee2b7a">00262</a>   std::map&lt;std::string, std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1GMVIO.php#a6deea23cebc78a57d7105294bcee2b7a">_nodal_data</a>;
<a name="l00263"></a>00263 };
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00268"></a>00268 <span class="comment">// GMVIO inline members</span>
<a name="l00269"></a>00269 <span class="keyword">inline</span>
<a name="l00270"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a979584b211e542085cfdaf2a4336f689">00270</a> <a class="code" href="classlibMesh_1_1GMVIO.php#a979584b211e542085cfdaf2a4336f689">GMVIO::GMVIO</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) :
<a name="l00271"></a>00271   <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt;    (mesh),
<a name="l00272"></a>00272   _binary                 (false),
<a name="l00273"></a>00273   _discontinuous          (false),  
<a name="l00274"></a>00274   _partitioning           (true),
<a name="l00275"></a>00275   _write_subdomain_id_as_material (false),
<a name="l00276"></a>00276   _subdivide_second_order (true),
<a name="l00277"></a>00277   _p_levels               (true),
<a name="l00278"></a>00278   _next_elem_id           (0)
<a name="l00279"></a>00279 {
<a name="l00280"></a>00280 }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 <span class="keyword">inline</span>
<a name="l00283"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a3a92fc0ffb87cb476b446f1bee26b519">00283</a> <a class="code" href="classlibMesh_1_1GMVIO.php#a979584b211e542085cfdaf2a4336f689">GMVIO::GMVIO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) :
<a name="l00284"></a>00284   <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt; (mesh),
<a name="l00285"></a>00285   <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&gt;(mesh),
<a name="l00286"></a>00286   _binary (false),
<a name="l00287"></a>00287   _discontinuous          (false),  
<a name="l00288"></a>00288   _partitioning           (true),
<a name="l00289"></a>00289   _write_subdomain_id_as_material (false),
<a name="l00290"></a>00290   _subdivide_second_order (true),
<a name="l00291"></a>00291   _p_levels               (true),
<a name="l00292"></a>00292   _next_elem_id           (0)
<a name="l00293"></a>00293 {
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 <span class="keyword">inline</span>
<a name="l00299"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a6fa07fc7de8aaf9a75d8852269176f92">00299</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a6fa07fc7de8aaf9a75d8852269176f92">GMVIO::binary</a> ()
<a name="l00300"></a>00300 {
<a name="l00301"></a>00301   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a4cf46078adf6da377fe063b3bc6936f8">_binary</a>;
<a name="l00302"></a>00302 }
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 <span class="keyword">inline</span>
<a name="l00307"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a401d93c69b05c9d1e714030ab90f6c94">00307</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a401d93c69b05c9d1e714030ab90f6c94">GMVIO::discontinuous</a> ()
<a name="l00308"></a>00308 {
<a name="l00309"></a>00309   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1GMVIO.php#ac2ac7959411d8555546af417ddc63e72">_discontinuous</a>;
<a name="l00310"></a>00310 }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 <span class="keyword">inline</span>
<a name="l00315"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a07b8521ab252f7063c5d6385cb7da8f6">00315</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a07b8521ab252f7063c5d6385cb7da8f6">GMVIO::partitioning</a> ()
<a name="l00316"></a>00316 {
<a name="l00317"></a>00317   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a7e42c024bee3e9acde3726eed1d97345">_partitioning</a>;
<a name="l00318"></a>00318 }
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 <span class="keyword">inline</span>
<a name="l00322"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a215caf1113a37ff475644be19a2b78fe">00322</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a215caf1113a37ff475644be19a2b78fe">GMVIO::write_subdomain_id_as_material</a> ()
<a name="l00323"></a>00323 {
<a name="l00324"></a>00324   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1GMVIO.php#ada7d8bd7b3d2be4fa1ba82d5ce54141e">_write_subdomain_id_as_material</a>;
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 <span class="keyword">inline</span>
<a name="l00330"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a90e97f78bbc6c9211214b127b2768fe1">00330</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a90e97f78bbc6c9211214b127b2768fe1">GMVIO::subdivide_second_order</a> ()
<a name="l00331"></a>00331 {
<a name="l00332"></a>00332   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1GMVIO.php#ac734138f99d98f189aebc29136febbd0">_subdivide_second_order</a>;
<a name="l00333"></a>00333 }
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 <span class="keyword">inline</span>
<a name="l00338"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a271520753142a42bf5a4c15165427ca2">00338</a> <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1GMVIO.php#a271520753142a42bf5a4c15165427ca2">GMVIO::p_levels</a>()
<a name="l00339"></a>00339 {
<a name="l00340"></a>00340   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a56f18d1d2fdb0c3c6d24069df24f6eaf">_p_levels</a>;
<a name="l00341"></a>00341 }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00346"></a><a class="code" href="classlibMesh_1_1GMVIO.php#a511b590dd8311d67060c9530723544ce">00346</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1GMVIO.php#a511b590dd8311d67060c9530723544ce">GMVIO::to_binary_stream</a>(std::ostream&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>,
<a name="l00347"></a>00347                              <span class="keyword">const</span> T i)
<a name="l00348"></a>00348 {
<a name="l00349"></a>00349   <span class="keyword">static</span> <span class="keywordtype">char</span> buf[<span class="keyword">sizeof</span>(T)];
<a name="l00350"></a>00350   memcpy(buf, &amp;i, <span class="keyword">sizeof</span>(T));
<a name="l00351"></a>00351   out.write(buf, <span class="keyword">sizeof</span>(T));
<a name="l00352"></a>00352 }
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 } <span class="comment">// namespace libMesh</span>
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 <span class="preprocessor">#endif // #define __gmv_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
