<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">hp_coarsentest.C</div>  </div>
</div>
<div class="contents">
<a href="hp__coarsentest_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: hp_coarsentest.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 <span class="preprocessor">#include &lt;limits&gt;</span> <span class="comment">// for std::numeric_limits::max</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;math.h&gt;</span>    <span class="comment">// for sqrt</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="hp__coarsentest_8h.php">hp_coarsentest.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 <span class="keyword">namespace </span>libMesh
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// HPCoarsenTest implementations</span>
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a95120f056b9acc8fe6e4c1684cd37ab9">00048</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a95120f056b9acc8fe6e4c1684cd37ab9">HPCoarsenTest::add_projection</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system,
<a name="l00049"></a>00049                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem,
<a name="l00050"></a>00050                                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   <span class="comment">// If we have children, we need to add their projections instead</span>
<a name="l00053"></a>00053   <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055       libmesh_assert(!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>());
<a name="l00056"></a>00056       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c = 0; c != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l00057"></a>00057         this-&gt;<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a95120f056b9acc8fe6e4c1684cd37ab9">add_projection</a>(system, elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c), var);
<a name="l00058"></a>00058       <span class="keywordflow">return</span>;
<a name="l00059"></a>00059     }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">// The DofMap for this system</span>
<a name="l00062"></a>00062   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00065"></a>00065   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a> (var);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> cont = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;get_continuity();
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;reinit(elem);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a>(elem, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>, var);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>(),
<a name="l00074"></a>00074     fe_type, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>, *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a56cf691ffbae2943f3698c93bb5dbb53">xyz_values</a>, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adb107a991f7744f386ce89b3d53d8b6f">coarse_qpoints</a>);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a9f02d0808b443a977f8981437a558b74">fe_coarse</a>-&gt;reinit(coarse, &amp;<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adb107a991f7744f386ce89b3d53d8b6f">coarse_qpoints</a>);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == 0)
<a name="l00079"></a>00079     {
<a name="l00080"></a>00080       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>-&gt;size(), <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>-&gt;size());
<a name="l00081"></a>00081       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00082"></a>00082       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>-&gt;size());
<a name="l00083"></a>00083       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00084"></a>00084       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>-&gt;size());
<a name="l00085"></a>00085       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00086"></a>00086     }
<a name="l00087"></a>00087   libmesh_assert(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>-&gt;size());
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// Loop over the quadrature points</span>
<a name="l00090"></a>00090   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aff7e97a81ad19f86d69bc1964feee7a6">qrule</a>-&gt;n_points(); qp++)
<a name="l00091"></a>00091     {
<a name="l00092"></a>00092       <span class="comment">// The solution value at the quadrature point</span>
<a name="l00093"></a>00093       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> val = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00094"></a>00094       <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad;
<a name="l00095"></a>00095       <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> hess;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>.size(); i++)
<a name="l00098"></a>00098         {
<a name="l00099"></a>00099           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_num = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>[i];
<a name="l00100"></a>00100           val += (*phi)[i][qp] *
<a name="l00101"></a>00101             system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num);
<a name="l00102"></a>00102           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00103"></a>00103             grad.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adf30d884c212b8afc8511e943901b61a">dphi</a>)[i][qp],system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num));
<a name="l00104"></a>00104            <span class="comment">// grad += (*dphi)[i][qp] *</span>
<a name="l00105"></a>00105             <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00106"></a>00106           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00107"></a>00107             hess.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#acfbf7356e50d606f8f857d7eeebdacd3">d2phi</a>)[i][qp], system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num));
<a name="l00108"></a>00108             <span class="comment">// hess += (*d2phi)[i][qp] *</span>
<a name="l00109"></a>00109             <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112       <span class="comment">// The projection matrix and vector</span>
<a name="l00113"></a>00113       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); ++i)
<a name="l00114"></a>00114         {
<a name="l00115"></a>00115           <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>(i) += (*JxW)[qp] * 
<a name="l00116"></a>00116             (*phi_coarse)[i][qp]*val;
<a name="l00117"></a>00117           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00118"></a>00118             <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>(i) += (*JxW)[qp] *
<a name="l00119"></a>00119               (grad*(*dphi_coarse)[i][qp]);
<a name="l00120"></a>00120           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00121"></a>00121             <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>(i) += (*JxW)[qp] *
<a name="l00122"></a>00122               hess.<a class="code" href="classlibMesh_1_1TypeTensor.php#a91ced4ae7e8d72aee0d21193e2fa7dbc">contract</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a8b8bcb6de38039c4e1af04bb5d92a0c2">d2phi_coarse</a>)[i][qp]);
<a name="l00123"></a>00123             <span class="comment">// Fe(i) += (*JxW)[qp] *</span>
<a name="l00124"></a>00124             <span class="comment">//  (*d2phi_coarse)[i][qp].contract(hess);</span>
<a name="l00125"></a>00125 
<a name="l00126"></a>00126           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); ++j)
<a name="l00127"></a>00127             {
<a name="l00128"></a>00128               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00129"></a>00129                 (*phi_coarse)[i][qp]*(*phi_coarse)[j][qp];
<a name="l00130"></a>00130               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00131"></a>00131                 <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00132"></a>00132                   (*dphi_coarse)[i][qp]*(*dphi_coarse)[j][qp];
<a name="l00133"></a>00133               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00134"></a>00134                 <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00135"></a>00135                   ((*d2phi_coarse)[i][qp].contract((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a8b8bcb6de38039c4e1af04bb5d92a0c2">d2phi_coarse</a>)[j][qp]));
<a name="l00136"></a>00136             }
<a name="l00137"></a>00137         }
<a name="l00138"></a>00138     }
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a89ee714117ceb80e762b03823e675ae5">00141</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a89ee714117ceb80e762b03823e675ae5">HPCoarsenTest::select_refinement</a> (<a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system)
<a name="l00142"></a>00142 {
<a name="l00143"></a>00143   START_LOG(<span class="stringliteral">&quot;select_refinement()&quot;</span>, <span class="stringliteral">&quot;HPCoarsenTest&quot;</span>);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <span class="comment">// The current mesh</span>
<a name="l00146"></a>00146   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="comment">// The dimensionality of the mesh</span>
<a name="l00149"></a>00149   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00150"></a>00150   
<a name="l00151"></a>00151   <span class="comment">// The number of variables in the system</span>
<a name="l00152"></a>00152   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00153"></a>00153   
<a name="l00154"></a>00154   <span class="comment">// The DofMap for this system</span>
<a name="l00155"></a>00155   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00156"></a>00156 
<a name="l00157"></a>00157   <span class="comment">// The system number (for doing bad hackery)</span>
<a name="l00158"></a>00158   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sys_num = system.<a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>();
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">// Check for a valid component_scale</span>
<a name="l00161"></a>00161   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>.empty())
<a name="l00162"></a>00162     {
<a name="l00163"></a>00163       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>.size() != <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>)
<a name="l00164"></a>00164         {
<a name="l00165"></a>00165           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: component_scale is the wrong size:&quot;</span>
<a name="l00166"></a>00166                         &lt;&lt; std::endl
<a name="l00167"></a>00167                         &lt;&lt; <span class="stringliteral">&quot; component_scale.size()=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>.size()
<a name="l00168"></a>00168                         &lt;&lt; std::endl
<a name="l00169"></a>00169                         &lt;&lt; <span class="stringliteral">&quot; n_vars=&quot;</span> &lt;&lt; n_vars
<a name="l00170"></a>00170                         &lt;&lt; std::endl;
<a name="l00171"></a>00171           libmesh_error();
<a name="l00172"></a>00172         }
<a name="l00173"></a>00173     }
<a name="l00174"></a>00174   <span class="keywordflow">else</span>
<a name="l00175"></a>00175     {
<a name="l00176"></a>00176       <span class="comment">// No specified scaling.  Scale all variables by one.</span>
<a name="l00177"></a>00177       <a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>.resize (n_vars, 1.0);
<a name="l00178"></a>00178     }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180   <span class="comment">// Resize the error_per_cell vectors to handle</span>
<a name="l00181"></a>00181   <span class="comment">// the number of elements, initialize them to 0.</span>
<a name="l00182"></a>00182   std::vector&lt;ErrorVectorReal&gt; h_error_per_cell(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(), 0.);
<a name="l00183"></a>00183   std::vector&lt;ErrorVectorReal&gt; p_error_per_cell(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(), 0.);
<a name="l00184"></a>00184   
<a name="l00185"></a>00185   <span class="comment">// Loop over all the variables in the system</span>
<a name="l00186"></a>00186   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00187"></a>00187     {
<a name="l00188"></a>00188       <span class="comment">// Possibly skip this variable</span>
<a name="l00189"></a>00189       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>.empty())
<a name="l00190"></a>00190         <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>[var] == 0.0) <span class="keywordflow">continue</span>;
<a name="l00191"></a>00191       
<a name="l00192"></a>00192       <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00193"></a>00193       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a> (var);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195       <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> low_p_fe_type = fe_type;
<a name="l00196"></a>00196       <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> high_p_fe_type = fe_type;
<a name="l00197"></a>00197 
<a name="l00198"></a>00198       <span class="comment">// Finite element objects for a fine (and probably a coarse)</span>
<a name="l00199"></a>00199       <span class="comment">// element will be needed</span>
<a name="l00200"></a>00200       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a> = <a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a> (dim, fe_type);
<a name="l00201"></a>00201       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a9f02d0808b443a977f8981437a558b74">fe_coarse</a> = <a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a> (dim, fe_type);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203       <span class="comment">// Any cached coarse element results have expired</span>
<a name="l00204"></a>00204       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a> = NULL;
<a name="l00205"></a>00205       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cached_coarse_p_level = 0;
<a name="l00206"></a>00206 
<a name="l00207"></a>00207       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> cont = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;get_continuity();
<a name="l00208"></a>00208       libmesh_assert (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a06624ba73875d1537d4422952c08a782">DISCONTINUOUS</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || 
<a name="l00209"></a>00209               cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211       <span class="comment">// Build an appropriate quadrature rule</span>
<a name="l00212"></a>00212       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aff7e97a81ad19f86d69bc1964feee7a6">qrule</a> = fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a>(dim);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214       <span class="comment">// Tell the refined finite element about the quadrature</span>
<a name="l00215"></a>00215       <span class="comment">// rule.  The coarse finite element need not know about it</span>
<a name="l00216"></a>00216       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;attach_quadrature_rule (<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aff7e97a81ad19f86d69bc1964feee7a6">qrule</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00217"></a>00217 
<a name="l00218"></a>00218       <span class="comment">// We will always do the integration</span>
<a name="l00219"></a>00219       <span class="comment">// on the fine elements.  Get their Jacobian values, etc..</span>
<a name="l00220"></a>00220       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a2d7d6cddaeab26ad28bf055c46e359b9">JxW</a> = &amp;(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;get_JxW());
<a name="l00221"></a>00221       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a56cf691ffbae2943f3698c93bb5dbb53">xyz_values</a> = &amp;(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;get_xyz());
<a name="l00222"></a>00222 
<a name="l00223"></a>00223       <span class="comment">// The shape functions</span>
<a name="l00224"></a>00224       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#ac84415111a75d43d2f47017d4baf38ac">phi</a> = &amp;(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;get_phi());
<a name="l00225"></a>00225       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a> = &amp;(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a9f02d0808b443a977f8981437a558b74">fe_coarse</a>-&gt;get_phi());
<a name="l00226"></a>00226 
<a name="l00227"></a>00227       <span class="comment">// The shape function derivatives</span>
<a name="l00228"></a>00228       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00229"></a>00229         {
<a name="l00230"></a>00230           <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adf30d884c212b8afc8511e943901b61a">dphi</a> = &amp;(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;get_dphi());
<a name="l00231"></a>00231           <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aa344dcdc6b7a83afbc5868de6829b690">dphi_coarse</a> = &amp;(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a9f02d0808b443a977f8981437a558b74">fe_coarse</a>-&gt;get_dphi());
<a name="l00232"></a>00232         }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00235"></a>00235 <span class="preprocessor"></span>      <span class="comment">// The shape function second derivatives</span>
<a name="l00236"></a>00236       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00237"></a>00237         {
<a name="l00238"></a>00238           <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#acfbf7356e50d606f8f857d7eeebdacd3">d2phi</a> = &amp;(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;get_d2phi());
<a name="l00239"></a>00239           <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a8b8bcb6de38039c4e1af04bb5d92a0c2">d2phi_coarse</a> = &amp;(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a9f02d0808b443a977f8981437a558b74">fe_coarse</a>-&gt;get_d2phi());
<a name="l00240"></a>00240         }
<a name="l00241"></a>00241 <span class="preprocessor">#endif // defined (LIBMESH_ENABLE_SECOND_DERIVATIVES)</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>
<a name="l00243"></a>00243       <span class="comment">// Iterate over all the active elements in the mesh</span>
<a name="l00244"></a>00244       <span class="comment">// that live on this processor.</span>
<a name="l00245"></a>00245 
<a name="l00246"></a>00246       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  =
<a name="l00247"></a>00247                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00248"></a>00248       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end =
<a name="l00249"></a>00249                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251       <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00252"></a>00252         {
<a name="l00253"></a>00253           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00254"></a>00254 
<a name="l00255"></a>00255           <span class="comment">// We&#39;re only checking elements that are already flagged for h</span>
<a name="l00256"></a>00256           <span class="comment">// refinement</span>
<a name="l00257"></a>00257           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00258"></a>00258             <span class="keywordflow">continue</span>;
<a name="l00259"></a>00259 
<a name="l00260"></a>00260           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00261"></a>00261 
<a name="l00262"></a>00262           <span class="comment">// Find the projection onto the parent element,</span>
<a name="l00263"></a>00263           <span class="comment">// if necessary</span>
<a name="l00264"></a>00264           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() &amp;&amp;
<a name="l00265"></a>00265               (<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a> != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() ||
<a name="l00266"></a>00266                cached_coarse_p_level != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>()))
<a name="l00267"></a>00267             {
<a name="l00268"></a>00268               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(0);
<a name="l00269"></a>00269 
<a name="l00270"></a>00270               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00271"></a>00271               cached_coarse_p_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00272"></a>00272 
<a name="l00273"></a>00273               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_parent_level = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00274"></a>00274               (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>))-&gt;hack_p_level(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00275"></a>00275               
<a name="l00276"></a>00276               this-&gt;<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a95120f056b9acc8fe6e4c1684cd37ab9">add_projection</a>(system, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>, var);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278               (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>))-&gt;hack_p_level(old_parent_level);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280               <span class="comment">// Solve the h-coarsening projection problem</span>
<a name="l00281"></a>00281               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">cholesky_solve</a>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>);
<a name="l00282"></a>00282             }
<a name="l00283"></a>00283 
<a name="l00284"></a>00284           <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>-&gt;reinit(elem);
<a name="l00285"></a>00285           
<a name="l00286"></a>00286           <span class="comment">// Get the DOF indices for the fine element</span>
<a name="l00287"></a>00287           dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>, var);
<a name="l00288"></a>00288 
<a name="l00289"></a>00289           <span class="comment">// The number of quadrature points</span>
<a name="l00290"></a>00290           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aff7e97a81ad19f86d69bc1964feee7a6">qrule</a>-&gt;n_points();
<a name="l00291"></a>00291 
<a name="l00292"></a>00292           <span class="comment">// The number of DOFS on the fine element</span>
<a name="l00293"></a>00293           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>.size();
<a name="l00294"></a>00294 
<a name="l00295"></a>00295           <span class="comment">// The number of nodes on the fine element</span>
<a name="l00296"></a>00296           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00297"></a>00297 
<a name="l00298"></a>00298           <span class="comment">// The average element value (used as an ugly hack</span>
<a name="l00299"></a>00299           <span class="comment">// when we have nothing p-coarsened to compare to)</span>
<a name="l00300"></a>00300           <span class="comment">// Real average_val = 0.;</span>
<a name="l00301"></a>00301           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> average_val = 0.;
<a name="l00302"></a>00302 
<a name="l00303"></a>00303           <span class="comment">// Calculate this variable&#39;s contribution to the p</span>
<a name="l00304"></a>00304           <span class="comment">// refinement error</span>
<a name="l00305"></a>00305 
<a name="l00306"></a>00306           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() == 0)
<a name="l00307"></a>00307             {
<a name="l00308"></a>00308               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_vertices = 0;
<a name="l00309"></a>00309               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = 0; n != <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; ++n)
<a name="l00310"></a>00310                 <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac56e382d9871ff243a781940ee13ed87">is_vertex</a>(n))
<a name="l00311"></a>00311                   {
<a name="l00312"></a>00312                     n_vertices++;
<a name="l00313"></a>00313                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a> * <span class="keyword">const</span> node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l00314"></a>00314                     average_val += system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>
<a name="l00315"></a>00315                       (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a99664433bae4e638f8befc83cec4eeff">dof_number</a>(sys_num,var,0));
<a name="l00316"></a>00316                   }
<a name="l00317"></a>00317               average_val /= n_vertices;
<a name="l00318"></a>00318             }
<a name="l00319"></a>00319           <span class="keywordflow">else</span>
<a name="l00320"></a>00320             {
<a name="l00321"></a>00321               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_elem_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00322"></a>00322               (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(elem))-&gt;hack_p_level(old_elem_level - 1);
<a name="l00323"></a>00323               
<a name="l00324"></a>00324               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a9f02d0808b443a977f8981437a558b74">fe_coarse</a>-&gt;reinit(elem, &amp;(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aff7e97a81ad19f86d69bc1964feee7a6">qrule</a>-&gt;get_points()));
<a name="l00325"></a>00325 
<a name="l00326"></a>00326               (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(elem))-&gt;hack_p_level(old_elem_level);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ad967ca8d40990ed5cae9944a285a320d">resize</a>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>-&gt;size(), <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>-&gt;size());
<a name="l00329"></a>00329               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#ab3e7a4e199200d0f5875fd4a5082cb7c">zero</a>();
<a name="l00330"></a>00330               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>-&gt;size());
<a name="l00331"></a>00331               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a23868ec54dca234e5893e41a8b510d68">zero</a>();
<a name="l00332"></a>00332 
<a name="l00333"></a>00333               <span class="comment">// Loop over the quadrature points</span>
<a name="l00334"></a>00334               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aff7e97a81ad19f86d69bc1964feee7a6">qrule</a>-&gt;n_points(); qp++)
<a name="l00335"></a>00335                 {
<a name="l00336"></a>00336                   <span class="comment">// The solution value at the quadrature point</span>
<a name="l00337"></a>00337                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> val = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00338"></a>00338                   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad;
<a name="l00339"></a>00339                   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> hess;
<a name="l00340"></a>00340 
<a name="l00341"></a>00341                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>.size(); i++)
<a name="l00342"></a>00342                     {
<a name="l00343"></a>00343                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_num = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>[i];
<a name="l00344"></a>00344                       val += (*phi)[i][qp] *
<a name="l00345"></a>00345                         system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num);
<a name="l00346"></a>00346                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00347"></a>00347                         grad.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adf30d884c212b8afc8511e943901b61a">dphi</a>)[i][qp], system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num));
<a name="l00348"></a>00348                         <span class="comment">// grad += (*dphi)[i][qp] *</span>
<a name="l00349"></a>00349                         <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00350"></a>00350                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00351"></a>00351                         hess.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#acfbf7356e50d606f8f857d7eeebdacd3">d2phi</a>)[i][qp], system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num));
<a name="l00352"></a>00352                         <span class="comment">// hess += (*d2phi)[i][qp] *</span>
<a name="l00353"></a>00353                         <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00354"></a>00354                     }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356                   <span class="comment">// The projection matrix and vector</span>
<a name="l00357"></a>00357                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); ++i)
<a name="l00358"></a>00358                     {
<a name="l00359"></a>00359                       <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>(i) += (*JxW)[qp] *
<a name="l00360"></a>00360                         (*phi_coarse)[i][qp]*val;
<a name="l00361"></a>00361                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00362"></a>00362                         <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>(i) += (*JxW)[qp] *
<a name="l00363"></a>00363                           grad * (*dphi_coarse)[i][qp];
<a name="l00364"></a>00364                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00365"></a>00365                         <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>(i) += (*JxW)[qp] *
<a name="l00366"></a>00366                           hess.<a class="code" href="classlibMesh_1_1TypeTensor.php#a91ced4ae7e8d72aee0d21193e2fa7dbc">contract</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a8b8bcb6de38039c4e1af04bb5d92a0c2">d2phi_coarse</a>)[i][qp]);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); ++j)
<a name="l00369"></a>00369                         {
<a name="l00370"></a>00370                           <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00371"></a>00371                             (*phi_coarse)[i][qp]*(*phi_coarse)[j][qp];
<a name="l00372"></a>00372                           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00373"></a>00373                             <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00374"></a>00374                               (*dphi_coarse)[i][qp]*(*dphi_coarse)[j][qp];
<a name="l00375"></a>00375                           <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00376"></a>00376                             <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>(i,j) += (*JxW)[qp] *
<a name="l00377"></a>00377                               ((*d2phi_coarse)[i][qp].contract((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a8b8bcb6de38039c4e1af04bb5d92a0c2">d2phi_coarse</a>)[j][qp]));
<a name="l00378"></a>00378                         }
<a name="l00379"></a>00379                     }
<a name="l00380"></a>00380                 }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382               <span class="comment">// Solve the p-coarsening projection problem</span>
<a name="l00383"></a>00383               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a6a40309a38c842ca98f3ff48bbbb265c">cholesky_solve</a>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#ab813f703c8f190a2d4dc0acabe6bb54d">Up</a>);
<a name="l00384"></a>00384             }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386           <span class="comment">// loop over the integration points on the fine element</span>
<a name="l00387"></a>00387           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00388"></a>00388             {
<a name="l00389"></a>00389               <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value_error = 0.;
<a name="l00390"></a>00390               <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_error;
<a name="l00391"></a>00391               <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> hessian_error;
<a name="l00392"></a>00392               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00393"></a>00393                 {
<a name="l00394"></a>00394                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_num = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>[i];
<a name="l00395"></a>00395                   value_error += (*phi)[i][qp] *
<a name="l00396"></a>00396                     system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num);
<a name="l00397"></a>00397                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00398"></a>00398                     grad_error.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adf30d884c212b8afc8511e943901b61a">dphi</a>)[i][qp], system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num));
<a name="l00399"></a>00399                     <span class="comment">// grad_error += (*dphi)[i][qp] *</span>
<a name="l00400"></a>00400                     <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00401"></a>00401                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00402"></a>00402                     hessian_error.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#acfbf7356e50d606f8f857d7eeebdacd3">d2phi</a>)[i][qp], system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num));
<a name="l00403"></a>00403                   <span class="comment">// hessian_error += (*d2phi)[i][qp] *</span>
<a name="l00404"></a>00404                   <span class="comment">//    system.current_solution(dof_num);</span>
<a name="l00405"></a>00405                 }
<a name="l00406"></a>00406               <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() == 0)
<a name="l00407"></a>00407                 {
<a name="l00408"></a>00408                   value_error -= average_val;
<a name="l00409"></a>00409                 }
<a name="l00410"></a>00410               <span class="keywordflow">else</span>
<a name="l00411"></a>00411                 {
<a name="l00412"></a>00412                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#ab813f703c8f190a2d4dc0acabe6bb54d">Up</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l00413"></a>00413                     {
<a name="l00414"></a>00414                       value_error -= (*phi_coarse)[i][qp] * <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#ab813f703c8f190a2d4dc0acabe6bb54d">Up</a>(i);
<a name="l00415"></a>00415                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00416"></a>00416                         grad_error.<a class="code" href="classlibMesh_1_1TypeVector.php#a201d687a69ab6befaac50b5c3e72a224">subtract_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aa344dcdc6b7a83afbc5868de6829b690">dphi_coarse</a>)[i][qp], <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#ab813f703c8f190a2d4dc0acabe6bb54d">Up</a>(i));
<a name="l00417"></a>00417                         <span class="comment">// grad_error -= (*dphi_coarse)[i][qp] * Up(i);</span>
<a name="l00418"></a>00418                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00419"></a>00419                         hessian_error.<a class="code" href="classlibMesh_1_1TypeTensor.php#abfe91509bae68904b75b8cedcdff7209">subtract_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a8b8bcb6de38039c4e1af04bb5d92a0c2">d2phi_coarse</a>)[i][qp], <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#ab813f703c8f190a2d4dc0acabe6bb54d">Up</a>(i));
<a name="l00420"></a>00420                         <span class="comment">// hessian_error -= (*d2phi_coarse)[i][qp] * Up(i);</span>
<a name="l00421"></a>00421                     }
<a name="l00422"></a>00422                 }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424               p_error_per_cell[e_id] += <a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>[var] * 
<a name="l00425"></a>00425                 (*JxW)[qp] * <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(value_error);
<a name="l00426"></a>00426               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00427"></a>00427                 p_error_per_cell[e_id] += <a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>[var] *
<a name="l00428"></a>00428                   (*JxW)[qp] * grad_error.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>();
<a name="l00429"></a>00429               <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00430"></a>00430                 p_error_per_cell[e_id] += <a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>[var] *
<a name="l00431"></a>00431                   (*JxW)[qp] * hessian_error.<a class="code" href="classlibMesh_1_1TypeTensor.php#a3f195e163a89444e26e49398cbad1155">size_sq</a>();
<a name="l00432"></a>00432             }
<a name="l00433"></a>00433 
<a name="l00434"></a>00434           <span class="comment">// Calculate this variable&#39;s contribution to the h</span>
<a name="l00435"></a>00435           <span class="comment">// refinement error</span>
<a name="l00436"></a>00436 
<a name="l00437"></a>00437           <span class="keywordflow">if</span> (!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>())
<a name="l00438"></a>00438             {
<a name="l00439"></a>00439               <span class="comment">// For now, we&#39;ll always start with an h refinement</span>
<a name="l00440"></a>00440               h_error_per_cell[e_id] =
<a name="l00441"></a>00441                 <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;ErrorVectorReal&gt;::max</a>() / 2;
<a name="l00442"></a>00442             }
<a name="l00443"></a>00443           <span class="keywordflow">else</span>
<a name="l00444"></a>00444             {
<a name="l00445"></a>00445               <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (dim, fe_type, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>,
<a name="l00446"></a>00446                 *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a56cf691ffbae2943f3698c93bb5dbb53">xyz_values</a>, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adb107a991f7744f386ce89b3d53d8b6f">coarse_qpoints</a>);
<a name="l00447"></a>00447 
<a name="l00448"></a>00448               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_parent_level = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00449"></a>00449               (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>))-&gt;hack_p_level(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00450"></a>00450 
<a name="l00451"></a>00451               <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a9f02d0808b443a977f8981437a558b74">fe_coarse</a>-&gt;reinit(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>, &amp;<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adb107a991f7744f386ce89b3d53d8b6f">coarse_qpoints</a>);
<a name="l00452"></a>00452 
<a name="l00453"></a>00453               (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>))-&gt;hack_p_level(old_parent_level);
<a name="l00454"></a>00454 
<a name="l00455"></a>00455               <span class="comment">// The number of DOFS on the coarse element</span>
<a name="l00456"></a>00456               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_coarse_dofs = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>-&gt;size();
<a name="l00457"></a>00457 
<a name="l00458"></a>00458               <span class="comment">// Loop over the quadrature points</span>
<a name="l00459"></a>00459               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00460"></a>00460                 {
<a name="l00461"></a>00461                   <span class="comment">// The solution difference at the quadrature point</span>
<a name="l00462"></a>00462                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value_error = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00463"></a>00463                   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_error;
<a name="l00464"></a>00464                   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> hessian_error;
<a name="l00465"></a>00465 
<a name="l00466"></a>00466                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_dofs; ++i)
<a name="l00467"></a>00467                     {
<a name="l00468"></a>00468                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dof_num = <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>[i];
<a name="l00469"></a>00469                       value_error += (*phi)[i][qp] *
<a name="l00470"></a>00470                         system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num);
<a name="l00471"></a>00471                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00472"></a>00472                         grad_error.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adf30d884c212b8afc8511e943901b61a">dphi</a>)[i][qp], system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num));
<a name="l00473"></a>00473                         <span class="comment">// grad_error += (*dphi)[i][qp] *</span>
<a name="l00474"></a>00474                         <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00475"></a>00475                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00476"></a>00476                         hessian_error.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#acfbf7356e50d606f8f857d7eeebdacd3">d2phi</a>)[i][qp], system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_num));
<a name="l00477"></a>00477                         <span class="comment">// hessian_error += (*d2phi)[i][qp] *</span>
<a name="l00478"></a>00478                         <span class="comment">//  system.current_solution(dof_num);</span>
<a name="l00479"></a>00479                     }
<a name="l00480"></a>00480 
<a name="l00481"></a>00481                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != n_coarse_dofs; ++i)
<a name="l00482"></a>00482                     {
<a name="l00483"></a>00483                       value_error -= (*phi_coarse)[i][qp] * <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>(i);
<a name="l00484"></a>00484                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00485"></a>00485                         <span class="comment">// grad_error -= (*dphi_coarse)[i][qp] * Uc(i);</span>
<a name="l00486"></a>00486                         grad_error.<a class="code" href="classlibMesh_1_1TypeVector.php#a201d687a69ab6befaac50b5c3e72a224">subtract_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aa344dcdc6b7a83afbc5868de6829b690">dphi_coarse</a>)[i][qp], <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>(i));
<a name="l00487"></a>00487                       <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00488"></a>00488                         hessian_error.<a class="code" href="classlibMesh_1_1TypeTensor.php#abfe91509bae68904b75b8cedcdff7209">subtract_scaled</a>((*<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a8b8bcb6de38039c4e1af04bb5d92a0c2">d2phi_coarse</a>)[i][qp], <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>(i));
<a name="l00489"></a>00489                         <span class="comment">// hessian_error -= (*d2phi_coarse)[i][qp] * Uc(i);</span>
<a name="l00490"></a>00490                     }
<a name="l00491"></a>00491 
<a name="l00492"></a>00492                   h_error_per_cell[e_id] += <a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>[var] * 
<a name="l00493"></a>00493                     (*JxW)[qp] * <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(value_error);
<a name="l00494"></a>00494                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a> || cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00495"></a>00495                     h_error_per_cell[e_id] += <a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>[var] * 
<a name="l00496"></a>00496                       (*JxW)[qp] * grad_error.<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>();
<a name="l00497"></a>00497                   <span class="keywordflow">if</span> (cont == <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a160d9ffe3235371cb72074fc6f3f5166">C_ONE</a>)
<a name="l00498"></a>00498                     h_error_per_cell[e_id] += <a class="code" href="classlibMesh_1_1HPSelector.php#a9bf72419a2df43b5531edd05b5332377">component_scale</a>[var] * 
<a name="l00499"></a>00499                       (*JxW)[qp] * hessian_error.<a class="code" href="classlibMesh_1_1TypeTensor.php#a3f195e163a89444e26e49398cbad1155">size_sq</a>();
<a name="l00500"></a>00500                 }
<a name="l00501"></a>00501 
<a name="l00502"></a>00502             }
<a name="l00503"></a>00503         }
<a name="l00504"></a>00504     }
<a name="l00505"></a>00505 
<a name="l00506"></a>00506   <span class="comment">// Now that we&#39;ve got our approximations for p_error and h_error, let&#39;s see</span>
<a name="l00507"></a>00507   <span class="comment">// if we want to switch any h refinement flags to p refinement</span>
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <span class="comment">// Iterate over all the active elements in the mesh</span>
<a name="l00510"></a>00510   <span class="comment">// that live on this processor.</span>
<a name="l00511"></a>00511 
<a name="l00512"></a>00512   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  =
<a name="l00513"></a>00513                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00514"></a>00514   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end =
<a name="l00515"></a>00515                   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00516"></a>00516 
<a name="l00517"></a>00517   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00518"></a>00518     {
<a name="l00519"></a>00519       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00520"></a>00520 
<a name="l00521"></a>00521       <span class="comment">// We&#39;re only checking elements that are already flagged for h</span>
<a name="l00522"></a>00522       <span class="comment">// refinement</span>
<a name="l00523"></a>00523       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00524"></a>00524         <span class="keywordflow">continue</span>;
<a name="l00525"></a>00525 
<a name="l00526"></a>00526       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00527"></a>00527 
<a name="l00528"></a>00528       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dofs_per_elem = 0, dofs_per_p_elem = 0;
<a name="l00529"></a>00529 
<a name="l00530"></a>00530       <span class="comment">// Loop over all the variables in the system</span>
<a name="l00531"></a>00531       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00532"></a>00532         {
<a name="l00533"></a>00533           <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00534"></a>00534           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a> (var);
<a name="l00535"></a>00535 
<a name="l00536"></a>00536           <span class="comment">// FIXME: we&#39;re overestimating the number of DOFs added by h</span>
<a name="l00537"></a>00537           <span class="comment">// refinement</span>
<a name="l00538"></a>00538           <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> elem_fe_type = fe_type;
<a name="l00539"></a>00539           elem_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> =
<a name="l00540"></a>00540             <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00541"></a>00541           dofs_per_elem += 
<a name="l00542"></a>00542             <a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">FEInterface::n_dofs</a>(dim, elem_fe_type, elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00543"></a>00543 
<a name="l00544"></a>00544           elem_fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> =
<a name="l00545"></a>00545             <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() + 1);
<a name="l00546"></a>00546           dofs_per_p_elem += 
<a name="l00547"></a>00547             <a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">FEInterface::n_dofs</a>(dim, elem_fe_type, elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00548"></a>00548         }
<a name="l00549"></a>00549 
<a name="l00550"></a>00550       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_h_dofs = dofs_per_elem *
<a name="l00551"></a>00551         (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>() - 1);
<a name="l00552"></a>00552 
<a name="l00553"></a>00553       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_p_dofs = dofs_per_p_elem -
<a name="l00554"></a>00554         dofs_per_elem;
<a name="l00555"></a>00555       
<a name="l00556"></a>00556 <span class="comment">/*</span>
<a name="l00557"></a>00557 <span class="comment">libMesh::err &lt;&lt; &quot;Cell &quot; &lt;&lt; e_id &lt;&lt; &quot;: h = &quot; &lt;&lt; elem-&gt;hmax()</span>
<a name="l00558"></a>00558 <span class="comment">              &lt;&lt; &quot;, p = &quot; &lt;&lt; elem-&gt;p_level() + 1 &lt;&lt; &quot;,&quot; &lt;&lt; std::endl </span>
<a name="l00559"></a>00559 <span class="comment">              &lt;&lt; &quot;     h_error = &quot; &lt;&lt; h_error_per_cell[e_id] </span>
<a name="l00560"></a>00560 <span class="comment">              &lt;&lt; &quot;, p_error = &quot; &lt;&lt; p_error_per_cell[e_id] &lt;&lt; std::endl</span>
<a name="l00561"></a>00561 <span class="comment">              &lt;&lt; &quot;     new_h_dofs = &quot; &lt;&lt; new_h_dofs</span>
<a name="l00562"></a>00562 <span class="comment">              &lt;&lt; &quot;, new_p_dofs = &quot; &lt;&lt; new_p_dofs &lt;&lt; std::endl;</span>
<a name="l00563"></a>00563 <span class="comment">*/</span>
<a name="l00564"></a>00564         
<a name="l00565"></a>00565       <span class="keywordflow">if</span> ((std::sqrt(p_error_per_cell[e_id]) * <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adc46860359c12435b6006fe5c6112dd0">p_weight</a> / new_p_dofs) 
<a name="l00566"></a>00566           &gt; (std::sqrt(h_error_per_cell[e_id]) / new_h_dofs))
<a name="l00567"></a>00567 <span class="comment">/*</span>
<a name="l00568"></a>00568 <span class="comment">      if (std::sqrt(p_error_per_cell[e_id]) * p_weight</span>
<a name="l00569"></a>00569 <span class="comment">          &gt; std::sqrt(h_error_per_cell[e_id]))</span>
<a name="l00570"></a>00570 <span class="comment">*/</span>
<a name="l00571"></a>00571         {
<a name="l00572"></a>00572           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00573"></a>00573 <span class="comment">//          elem-&gt;set_refinement_flag(Elem::COARSEN);</span>
<a name="l00574"></a>00574           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00575"></a>00575         }
<a name="l00576"></a>00576     }
<a name="l00577"></a>00577 
<a name="l00578"></a>00578   STOP_LOG(<span class="stringliteral">&quot;select_refinement()&quot;</span>, <span class="stringliteral">&quot;HPCoarsenTest&quot;</span>);
<a name="l00579"></a>00579 }
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 } <span class="comment">// namespace libMesh</span>
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
