<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3734f8fafd73a2969ee8ed4a34620869.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">hp_coarsentest.h</div>  </div>
</div>
<div class="contents">
<a href="hp__coarsentest_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: hp_coarsentest.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __hp_coarsentest_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __hp_coarsentest_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="hp__selector_8h.php">hp_selector.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>         <span class="comment">// MipsPro requires fe.h and quadrature.h in order to</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span> <span class="comment">//  delete AutoPtrs&lt;&gt; upon destruction</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// Forward Declarations</span>
<a name="l00044"></a>00044 <span class="keyword">class </span>Elem;
<a name="l00045"></a>00045 <span class="keyword">class </span>Point;
<a name="l00046"></a>00046 <span class="keyword">class </span>System;
<a name="l00047"></a>00047 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>TensorValue;
<a name="l00048"></a><a class="code" href="namespacelibMesh.php#a7b24a45345db9b61375489cb2d385538">00048</a> <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span><a class="code" href="classlibMesh_1_1VectorValue.php">VectorValue</a>;
<a name="l00049"></a>00049 <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1VectorValue.php">VectorValue&lt;Real&gt;</a> <a class="code" href="namespacelibMesh.php#a7b24a45345db9b61375489cb2d385538">RealVectorValue</a>;
<a name="l00050"></a><a class="code" href="namespacelibMesh.php#a452831d26a60cf3bcf349610a85b52da">00050</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TensorValue.php">TensorValue&lt;Real&gt;</a> <a class="code" href="namespacelibMesh.php#a452831d26a60cf3bcf349610a85b52da">RealTensorValue</a>;
<a name="l00051"></a><a class="code" href="namespacelibMesh.php#adabb700efe8eff368f2a23cb17dce706">00051</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1VectorValue.php">RealVectorValue</a> <a class="code" href="namespacelibMesh.php#adabb700efe8eff368f2a23cb17dce706">RealGradient</a>;
<a name="l00052"></a><a class="code" href="namespacelibMesh.php#a9bd4c05784227753fe29f61700ac5190">00052</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TensorValue.php">RealTensorValue</a> <a class="code" href="namespacelibMesh.php#a9bd4c05784227753fe29f61700ac5190">RealTensor</a>;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php">00068</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1HPCoarsenTest.php">HPCoarsenTest</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1HPSelector.php">HPSelector</a>
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070 <span class="keyword">public</span>:
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a2e659cf80d3ac22323e5bb7e4e331ae3">00075</a>   <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a2e659cf80d3ac22323e5bb7e4e331ae3">HPCoarsenTest</a>() : <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adc46860359c12435b6006fe5c6112dd0">p_weight</a>(1.0) 
<a name="l00076"></a>00076   {
<a name="l00077"></a>00077     libmesh_experimental();
<a name="l00078"></a>00078   }
<a name="l00079"></a>00079   
<a name="l00083"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aa7e31ade394e8a474f5d7ba697d0fe9b">00083</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aa7e31ade394e8a474f5d7ba697d0fe9b">~HPCoarsenTest</a>() {}
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a89ee714117ceb80e762b03823e675ae5">select_refinement</a> (<a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system);
<a name="l00093"></a>00093 
<a name="l00098"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adc46860359c12435b6006fe5c6112dd0">00098</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adc46860359c12435b6006fe5c6112dd0">p_weight</a>;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="keyword">protected</span>:
<a name="l00105"></a>00105   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a95120f056b9acc8fe6e4c1684cd37ab9">add_projection</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var);
<a name="l00106"></a>00106 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">00110</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a0fefe2f15453b639d00634298470e4c9">coarse</a>;
<a name="l00111"></a>00111 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">00115</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a472c1f2ca11dea437b9b475c527adeae">dof_indices</a>;
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a9f02d0808b443a977f8981437a558b74">00120</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#af78d8728eb66496c63e0c8bbbc433d84">fe</a>, <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a9f02d0808b443a977f8981437a558b74">fe_coarse</a>;
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">00125</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt; *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#ac84415111a75d43d2f47017d4baf38ac">phi</a>, *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a917954ede68b3f061e376e8a24f74d88">phi_coarse</a>;
<a name="l00126"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aa344dcdc6b7a83afbc5868de6829b690">00126</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adf30d884c212b8afc8511e943901b61a">dphi</a>, *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aa344dcdc6b7a83afbc5868de6829b690">dphi_coarse</a>;
<a name="l00127"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a8b8bcb6de38039c4e1af04bb5d92a0c2">00127</a>   <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt; *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#acfbf7356e50d606f8f857d7eeebdacd3">d2phi</a>, *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a8b8bcb6de38039c4e1af04bb5d92a0c2">d2phi_coarse</a>;
<a name="l00128"></a>00128 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a2d7d6cddaeab26ad28bf055c46e359b9">00132</a>   <span class="keyword">const</span> std::vector&lt;Real&gt; *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a2d7d6cddaeab26ad28bf055c46e359b9">JxW</a>;
<a name="l00133"></a>00133 
<a name="l00137"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a56cf691ffbae2943f3698c93bb5dbb53">00137</a>   <span class="keyword">const</span> std::vector&lt;Point&gt; *<a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a56cf691ffbae2943f3698c93bb5dbb53">xyz_values</a>;
<a name="l00138"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adb107a991f7744f386ce89b3d53d8b6f">00138</a>   std::vector&lt;Point&gt; <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#adb107a991f7744f386ce89b3d53d8b6f">coarse_qpoints</a>;
<a name="l00139"></a>00139 
<a name="l00143"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aff7e97a81ad19f86d69bc1964feee7a6">00143</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#aff7e97a81ad19f86d69bc1964feee7a6">qrule</a>;
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">00148</a>   <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1c0667135ff4b0a90618d2963ac07371">Ke</a>;
<a name="l00149"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">00149</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a1321a6776e1ab13f2862e20da17d41b2">Fe</a>;
<a name="l00154"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">00154</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#a42b15f44d2312fcb8e02e1cd321b9418">Uc</a>;
<a name="l00155"></a><a class="code" href="classlibMesh_1_1HPCoarsenTest.php#ab813f703c8f190a2d4dc0acabe6bb54d">00155</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1HPCoarsenTest.php#ab813f703c8f190a2d4dc0acabe6bb54d">Up</a>;
<a name="l00156"></a>00156 };
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 } <span class="comment">// namespace libMesh</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>
<a name="l00162"></a>00162 <span class="preprocessor">#endif</span>
<a name="l00163"></a>00163 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
