<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">hp_singular.C</div>  </div>
</div>
<div class="contents">
<a href="hp__singular_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: hp_singular.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="comment">// C++ includes</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local Includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="hp__singular_8h.php">hp_singular.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// HPSingularity implementations</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="classlibMesh_1_1HPSingularity.php#abadc0f2110eed20d807999ce365cc38b">00038</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1HPSingularity.php#abadc0f2110eed20d807999ce365cc38b">HPSingularity::select_refinement</a> (<a class="code" href="classlibMesh_1_1System.php">System</a> &amp;system)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   START_LOG(<span class="stringliteral">&quot;select_refinement()&quot;</span>, <span class="stringliteral">&quot;HPSingularity&quot;</span>);
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">// The current mesh</span>
<a name="l00043"></a>00043   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  =
<a name="l00046"></a>00046     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00047"></a>00047   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end =
<a name="l00048"></a>00048     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00053"></a>00053 
<a name="l00054"></a>00054       <span class="comment">// We&#39;re only checking elements that are already flagged for h</span>
<a name="l00055"></a>00055       <span class="comment">// refinement</span>
<a name="l00056"></a>00056       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00057"></a>00057         <span class="keywordflow">continue</span>;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00060"></a>00060       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062       <span class="keywordflow">for</span> (std::list&lt;Point&gt;::iterator ppoint =
<a name="l00063"></a>00063              <a class="code" href="classlibMesh_1_1HPSingularity.php#aa59cc05b3a968abe809badf130461952">singular_points</a>.begin();
<a name="l00064"></a>00064            ppoint != <a class="code" href="classlibMesh_1_1HPSingularity.php#aa59cc05b3a968abe809badf130461952">singular_points</a>.end(); ++ppoint)
<a name="l00065"></a>00065         {
<a name="l00066"></a>00066           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#afd665f3e6d13b0aaaf4c4620067329bc">contains_point</a>(*ppoint))
<a name="l00067"></a>00067             {
<a name="l00068"></a>00068               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00069"></a>00069               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00070"></a>00070               <span class="keywordflow">break</span>;
<a name="l00071"></a>00071             }
<a name="l00072"></a>00072         }
<a name="l00073"></a>00073     }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   STOP_LOG(<span class="stringliteral">&quot;select_refinement()&quot;</span>, <span class="stringliteral">&quot;HPSingularity&quot;</span>);
<a name="l00076"></a>00076 }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 } <span class="comment">// namespace libMesh</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
