<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">implicit_system.C</div>  </div>
</div>
<div class="contents">
<a href="implicit__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: implicit_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="implicit__system_8h.php">implicit_system.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="parameters_8h.php">parameters.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="parameter__vector_8h.php">parameter_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="qoi__set_8h.php">qoi_set.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="sensitivity__data_8h.php">sensitivity_data.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>libMesh
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// ImplicitSystem implementation</span>
<a name="l00043"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a19ff2b6b4dda0d38247de3ccaf5ba573">00043</a> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a19ff2b6b4dda0d38247de3ccaf5ba573">ImplicitSystem::ImplicitSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00044"></a>00044                                 <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00045"></a>00045                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00046"></a>00046   
<a name="l00047"></a>00047   <a class="code" href="classlibMesh_1_1System.php">Parent</a>            (es, name, number),
<a name="l00048"></a>00048   matrix            (NULL),
<a name="l00049"></a>00049   _can_add_matrices (true)
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa16e13af7c0b247e73837670454fdafb">00055</a> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa16e13af7c0b247e73837670454fdafb">ImplicitSystem::~ImplicitSystem</a> ()
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <span class="comment">// Clear data</span>
<a name="l00058"></a>00058   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a8ec1dbe98f37b3fa50d87292e5b46827">clear</a>();
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a8ec1dbe98f37b3fa50d87292e5b46827">00063</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a8ec1dbe98f37b3fa50d87292e5b46827">ImplicitSystem::clear</a> ()
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065   <span class="comment">// clear the parent data</span>
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#ab6f8aaf1e1ba4bdabda4f5f045816f1f">Parent::clear</a>();
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">// clear any user-added matrices</span>
<a name="l00069"></a>00069   {
<a name="l00070"></a>00070     <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a3150e0ee9d3f20276efea1e3690fe395">matrices_iterator</a> pos = <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.begin();
<a name="l00071"></a>00071          pos != <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.end(); ++pos)
<a name="l00072"></a>00072       {
<a name="l00073"></a>00073         pos-&gt;second-&gt;clear ();
<a name="l00074"></a>00074         <span class="keyword">delete</span> pos-&gt;second;
<a name="l00075"></a>00075         pos-&gt;second = NULL;
<a name="l00076"></a>00076       }
<a name="l00077"></a>00077 
<a name="l00078"></a>00078     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.clear();
<a name="l00079"></a>00079     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#af7129ede5be4b9b84beced9abdfc4e6c">_can_add_matrices</a> = <span class="keyword">true</span>;
<a name="l00080"></a>00080   }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="comment">// NULL the matrix.</span>
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a> = NULL;
<a name="l00084"></a>00084 }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#ada6846f6432bb259d4cd0a83abdc567a">00088</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ada6846f6432bb259d4cd0a83abdc567a">ImplicitSystem::init_data</a> ()
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   <span class="comment">// initialize parent data</span>
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a47a97723cedc8a3e7ce0d9ebfd57f1ad">Parent::init_data</a>();
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   <span class="comment">// Add the system matrix.</span>
<a name="l00094"></a>00094   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0b0463b54037a4500827848d2bb30901">add_system_matrix</a> ();
<a name="l00095"></a>00095   
<a name="l00096"></a>00096   <span class="comment">// Initialize the matrices for the system</span>
<a name="l00097"></a>00097   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#adfdda300feb69430db51a50f3a002c04">init_matrices</a> ();
<a name="l00098"></a>00098 }
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#adfdda300feb69430db51a50f3a002c04">00102</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#adfdda300feb69430db51a50f3a002c04">ImplicitSystem::init_matrices</a> ()
<a name="l00103"></a>00103 {
<a name="l00104"></a>00104   libmesh_assert (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a> != NULL);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">// Check for quick return in case the system matrix</span>
<a name="l00107"></a>00107   <span class="comment">// (and by extension all the matrices) has already</span>
<a name="l00108"></a>00108   <span class="comment">// been initialized</span>
<a name="l00109"></a>00109   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a71ac3668357d2f61480589e2bc9c1b04">initialized</a>())
<a name="l00110"></a>00110     <span class="keywordflow">return</span>;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112   <span class="comment">// Get a reference to the DofMap</span>
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00114"></a>00114   
<a name="l00115"></a>00115   <span class="comment">// no chance to add other matrices</span>
<a name="l00116"></a>00116   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#af7129ede5be4b9b84beced9abdfc4e6c">_can_add_matrices</a> = <span class="keyword">false</span>;
<a name="l00117"></a>00117   
<a name="l00118"></a>00118   <span class="comment">// Tell the matrices about the dof map, and vice versa</span>
<a name="l00119"></a>00119   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a3150e0ee9d3f20276efea1e3690fe395">matrices_iterator</a> pos = <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.begin();
<a name="l00120"></a>00120        pos != <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.end(); ++pos)
<a name="l00121"></a>00121     {
<a name="l00122"></a>00122       libmesh_assert (!pos-&gt;second-&gt;initialized());
<a name="l00123"></a>00123       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#aa10200782a0f8fe0c4d3f7bdf10cedc6">attach_matrix</a> (*(pos-&gt;second));
<a name="l00124"></a>00124     }
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="comment">// Compute the sparsity pattern for the current</span>
<a name="l00127"></a>00127   <span class="comment">// mesh and DOF distribution.  This also updates</span>
<a name="l00128"></a>00128   <span class="comment">// additional matrices, \p DofMap now knows them</span>
<a name="l00129"></a>00129   dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a49379ce3a542eab41a8f8e44d0f154c2">compute_sparsity</a> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>());
<a name="l00130"></a>00130   
<a name="l00131"></a>00131   <span class="comment">// Initialize matrices</span>
<a name="l00132"></a>00132   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a3150e0ee9d3f20276efea1e3690fe395">matrices_iterator</a> pos = <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.begin(); 
<a name="l00133"></a>00133        pos != <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.end(); ++pos)
<a name="l00134"></a>00134     pos-&gt;second-&gt;init ();
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   <span class="comment">// Set the additional matrices to 0.</span>
<a name="l00137"></a>00137   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a3150e0ee9d3f20276efea1e3690fe395">matrices_iterator</a> pos = <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.begin(); 
<a name="l00138"></a>00138        pos != <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.end(); ++pos)
<a name="l00139"></a>00139     pos-&gt;second-&gt;zero ();
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a766e6bac5c51ef16b7ddc4f62933b309">00144</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a766e6bac5c51ef16b7ddc4f62933b309">ImplicitSystem::reinit</a> ()
<a name="l00145"></a>00145 {
<a name="l00146"></a>00146   <span class="comment">// initialize parent data</span>
<a name="l00147"></a>00147   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a86206bdaf4b5e192ac33812cbf3937e1">Parent::reinit</a>();  
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">// Clear the matrices</span>
<a name="l00150"></a>00150   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a3150e0ee9d3f20276efea1e3690fe395">matrices_iterator</a> pos = <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.begin();
<a name="l00151"></a>00151        pos != <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.end(); ++pos)
<a name="l00152"></a>00152     pos-&gt;second-&gt;clear();
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// Re-initialize the matrices</span>
<a name="l00155"></a>00155   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#adfdda300feb69430db51a50f3a002c04">init_matrices</a> ();
<a name="l00156"></a>00156 }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a80ddae9bd83e9ec2f76ee57f5fdfb6e3">00160</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a80ddae9bd83e9ec2f76ee57f5fdfb6e3">ImplicitSystem::assemble</a> ()
<a name="l00161"></a>00161 {
<a name="l00162"></a>00162   libmesh_assert (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a> != NULL);
<a name="l00163"></a>00163   libmesh_assert (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a71ac3668357d2f61480589e2bc9c1b04">initialized</a>());
<a name="l00164"></a>00164   libmesh_assert (<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>    != NULL);
<a name="l00165"></a>00165   libmesh_assert (<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a02791337b6c509228fdf3e72320b56d3">initialized</a>());
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   <span class="comment">// The user assembly gets to expect to accumulate on an initially</span>
<a name="l00168"></a>00168   <span class="comment">// empty system</span>
<a name="l00169"></a>00169   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a> ();
<a name="l00170"></a>00170   <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a> ();
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="comment">// Call the base class assemble function</span>
<a name="l00173"></a>00173   <a class="code" href="classlibMesh_1_1System.php#a79e4227a9e627031fac487cbd7c17250">Parent::assemble</a> ();
<a name="l00174"></a>00174 }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a03484ff4590b6971c650b4cfb2196f85">00178</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a03484ff4590b6971c650b4cfb2196f85">ImplicitSystem::add_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)
<a name="l00179"></a>00179 {
<a name="l00180"></a>00180   <span class="comment">// only add matrices before initializing...</span>
<a name="l00181"></a>00181   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ImplicitSystem.php#af7129ede5be4b9b84beced9abdfc4e6c">_can_add_matrices</a>)
<a name="l00182"></a>00182     {
<a name="l00183"></a>00183       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Too late.  Cannot add matrices to the system after initialization&quot;</span>
<a name="l00184"></a>00184                     &lt;&lt; std::endl
<a name="l00185"></a>00185                     &lt;&lt; <span class="stringliteral">&quot; any more.  You should have done this earlier.&quot;</span>
<a name="l00186"></a>00186                     &lt;&lt; std::endl;
<a name="l00187"></a>00187       libmesh_error();
<a name="l00188"></a>00188     }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190   <span class="comment">// Return the matrix if it is already there.</span>
<a name="l00191"></a>00191   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#ad1f70d2478811263532c49cb9f4a77e2">have_matrix</a>(mat_name))
<a name="l00192"></a>00192     <span class="keywordflow">return</span> *(<a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>[mat_name]);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="comment">// Otherwise build the matrix and return it.</span>
<a name="l00195"></a>00195   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>* buf = <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;::build</a>().release();
<a name="l00196"></a>00196   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.insert (std::make_pair (mat_name, buf));
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="keywordflow">return</span> *buf;
<a name="l00199"></a>00199 }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0f497ae21ddc216ca57b4cbdb7429f67">00203</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0f497ae21ddc216ca57b4cbdb7429f67">ImplicitSystem::request_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)<span class="keyword"> const</span>
<a name="l00204"></a>00204 <span class="keyword"></span>{
<a name="l00205"></a>00205   <span class="comment">// Make sure the matrix exists</span>
<a name="l00206"></a>00206   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a5d3fb82b3496fecd5c502504cf6ed2f0">const_matrices_iterator</a> pos = <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.find (mat_name);
<a name="l00207"></a>00207   
<a name="l00208"></a>00208   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.end())
<a name="l00209"></a>00209     <span class="keywordflow">return</span> NULL;
<a name="l00210"></a>00210   
<a name="l00211"></a>00211   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00212"></a>00212 }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a1023c078753bb38932b34649018f1643">00216</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0f497ae21ddc216ca57b4cbdb7429f67">ImplicitSystem::request_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)
<a name="l00217"></a>00217 {
<a name="l00218"></a>00218   <span class="comment">// Make sure the matrix exists</span>
<a name="l00219"></a>00219   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a3150e0ee9d3f20276efea1e3690fe395">matrices_iterator</a> pos = <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.find (mat_name);
<a name="l00220"></a>00220   
<a name="l00221"></a>00221   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.end())
<a name="l00222"></a>00222     <span class="keywordflow">return</span> NULL;
<a name="l00223"></a>00223   
<a name="l00224"></a>00224   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00225"></a>00225 }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">00229</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">ImplicitSystem::get_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)<span class="keyword"> const</span>
<a name="l00230"></a>00230 <span class="keyword"></span>{
<a name="l00231"></a>00231   <span class="comment">// Make sure the matrix exists</span>
<a name="l00232"></a>00232   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a5d3fb82b3496fecd5c502504cf6ed2f0">const_matrices_iterator</a> pos = <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.find (mat_name);
<a name="l00233"></a>00233   
<a name="l00234"></a>00234   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.end())
<a name="l00235"></a>00235     {
<a name="l00236"></a>00236       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: matrix &quot;</span>
<a name="l00237"></a>00237                     &lt;&lt; mat_name
<a name="l00238"></a>00238                     &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l00239"></a>00239                     &lt;&lt; std::endl;      
<a name="l00240"></a>00240       libmesh_error();
<a name="l00241"></a>00241     }
<a name="l00242"></a>00242   
<a name="l00243"></a>00243   <span class="keywordflow">return</span> *(pos-&gt;second);
<a name="l00244"></a>00244 }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a33fcd73be65b7ad432acdcbb1c5a95c2">00248</a> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">ImplicitSystem::get_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)
<a name="l00249"></a>00249 {
<a name="l00250"></a>00250   <span class="comment">// Make sure the matrix exists</span>
<a name="l00251"></a>00251   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a3150e0ee9d3f20276efea1e3690fe395">matrices_iterator</a> pos = <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.find (mat_name);
<a name="l00252"></a>00252   
<a name="l00253"></a>00253   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.end())
<a name="l00254"></a>00254     {
<a name="l00255"></a>00255       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: matrix &quot;</span>
<a name="l00256"></a>00256                     &lt;&lt; mat_name
<a name="l00257"></a>00257                     &lt;&lt; <span class="stringliteral">&quot; does not exist in this system!&quot;</span>
<a name="l00258"></a>00258                     &lt;&lt; std::endl;      
<a name="l00259"></a>00259       libmesh_error();
<a name="l00260"></a>00260     }
<a name="l00261"></a>00261   
<a name="l00262"></a>00262   <span class="keywordflow">return</span> *(pos-&gt;second);
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0b0463b54037a4500827848d2bb30901">00267</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0b0463b54037a4500827848d2bb30901">ImplicitSystem::add_system_matrix</a> ()
<a name="l00268"></a>00268 {
<a name="l00269"></a>00269   <span class="comment">// Possible that we cleared the _matrices but</span>
<a name="l00270"></a>00270   <span class="comment">// forgot to NULL-out the matrix?</span>
<a name="l00271"></a>00271   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.empty()) <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a> = NULL;
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">// Only need to add the matrix if it isn&#39;t there</span>
<a name="l00275"></a>00275   <span class="comment">// already!</span>
<a name="l00276"></a>00276   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a> == NULL)
<a name="l00277"></a>00277     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a> = &amp;(this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a03484ff4590b6971c650b4cfb2196f85">add_matrix</a> (<span class="stringliteral">&quot;System Matrix&quot;</span>));
<a name="l00278"></a>00278 
<a name="l00279"></a>00279   libmesh_assert (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a> != NULL);
<a name="l00280"></a>00280 }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 std::pair&lt;unsigned int, Real&gt;
<a name="l00285"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#ae22b3e55e993d74a2e8a70091d5cc044">00285</a> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ae22b3e55e993d74a2e8a70091d5cc044">ImplicitSystem::sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters)
<a name="l00286"></a>00286 {
<a name="l00287"></a>00287   <span class="comment">// Log how long the linear solve takes.</span>
<a name="l00288"></a>00288   START_LOG(<span class="stringliteral">&quot;sensitivity_solve()&quot;</span>, <span class="stringliteral">&quot;ImplicitSystem&quot;</span>);
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="comment">// The forward system should now already be solved.</span>
<a name="l00291"></a>00291   <span class="comment">// Now assemble the corresponding sensitivity system.</span>
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a>)
<a name="l00294"></a>00294     {
<a name="l00295"></a>00295       <span class="comment">// Build the Jacobian</span>
<a name="l00296"></a>00296       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00297"></a>00297       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00298"></a>00298 
<a name="l00299"></a>00299       <span class="comment">// Reset and build the RHS from the residual derivatives</span>
<a name="l00300"></a>00300       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a1f8552a617eabf208f2b99768312ec52">assemble_residual_derivatives</a>(parameters);
<a name="l00301"></a>00301     }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <span class="comment">// The sensitivity problem is linear</span>
<a name="l00304"></a>00304   <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *linear_solver = this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a46cae8e0c970cc71f4d3993432d60e5e">get_linear_solver</a>();
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="comment">// Our iteration counts and residuals will be sums of the individual</span>
<a name="l00307"></a>00307   <span class="comment">// results</span>
<a name="l00308"></a>00308   std::pair&lt;unsigned int, Real&gt; solver_params =
<a name="l00309"></a>00309     this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#ab3b6e7ceb320e1cd0f8639780791ba07">get_linear_solve_parameters</a>();
<a name="l00310"></a>00310   std::pair&lt;unsigned int, Real&gt; totalrval = std::make_pair(0,0.0);
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   <span class="comment">// Solve the linear system.</span>
<a name="l00313"></a>00313   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> *pc = this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0f497ae21ddc216ca57b4cbdb7429f67">request_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>);
<a name="l00314"></a>00314   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>(); ++p)
<a name="l00315"></a>00315     {
<a name="l00316"></a>00316       std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00317"></a>00317         linear_solver-&gt;<a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, pc,
<a name="l00318"></a>00318                               this-&gt;<a class="code" href="classlibMesh_1_1System.php#a8af728122cdd5677dc5a78e698bd1b35">add_sensitivity_solution</a>(p),
<a name="l00319"></a>00319                               this-&gt;<a class="code" href="classlibMesh_1_1System.php#aad3023ee4c1d7ff532fab06136eed63c">get_sensitivity_rhs</a>(p),
<a name="l00320"></a>00320                               solver_params.second,
<a name="l00321"></a>00321                               solver_params.first);
<a name="l00322"></a>00322 
<a name="l00323"></a>00323       totalrval.first  += rval.first;
<a name="l00324"></a>00324       totalrval.second += rval.second;
<a name="l00325"></a>00325     }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327   <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00328"></a>00328 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>(); ++p)
<a name="l00330"></a>00330     this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>
<a name="l00331"></a>00331       (*<span class="keyword">this</span>, &amp;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a920173d7f09d6f17b4451f354b7bccac">get_sensitivity_solution</a>(p));
<a name="l00332"></a>00332 <span class="preprocessor">#endif</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>
<a name="l00334"></a>00334   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a43effba7c17eb24695c107560eb65e7d">release_linear_solver</a>(linear_solver);
<a name="l00335"></a>00335 
<a name="l00336"></a>00336   <span class="comment">// Stop logging the nonlinear solve</span>
<a name="l00337"></a>00337   STOP_LOG(<span class="stringliteral">&quot;sensitivity_solve()&quot;</span>, <span class="stringliteral">&quot;ImplicitSystem&quot;</span>);
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="keywordflow">return</span> totalrval;
<a name="l00340"></a>00340 }
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 std::pair&lt;unsigned int, Real&gt;
<a name="l00345"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#abe4a5375e0680ab8c0048b2e3e361808">00345</a> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#abe4a5375e0680ab8c0048b2e3e361808">ImplicitSystem::adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l00346"></a>00346 {
<a name="l00347"></a>00347   <span class="comment">// Log how long the linear solve takes.</span>
<a name="l00348"></a>00348   START_LOG(<span class="stringliteral">&quot;adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;ImplicitSystem&quot;</span>);
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   <span class="comment">// The forward system should now already be solved.</span>
<a name="l00351"></a>00351   <span class="comment">// Now assemble it&#39;s adjoint.</span>
<a name="l00352"></a>00352 
<a name="l00353"></a>00353   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a>)
<a name="l00354"></a>00354     {
<a name="l00355"></a>00355       <span class="comment">// Build the Jacobian</span>
<a name="l00356"></a>00356       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00357"></a>00357       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00358"></a>00358 
<a name="l00359"></a>00359       <span class="comment">// Take the discrete adjoint</span>
<a name="l00360"></a>00360       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#aa85149e85125392a2fdb7671bb50a1e2">get_transpose</a>(*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00361"></a>00361 
<a name="l00362"></a>00362       <span class="comment">// Reset and build the RHS from the QOI derivative</span>
<a name="l00363"></a>00363       this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a494403f8651bf2db7a930e02245e5429">assemble_qoi_derivative</a>(qoi_indices);
<a name="l00364"></a>00364     }
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="comment">// The adjoint problem is linear</span>
<a name="l00367"></a>00367   <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *linear_solver = this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a46cae8e0c970cc71f4d3993432d60e5e">get_linear_solver</a>();
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="comment">// Our iteration counts and residuals will be sums of the individual</span>
<a name="l00370"></a>00370   <span class="comment">// results</span>
<a name="l00371"></a>00371   std::pair&lt;unsigned int, Real&gt; solver_params =
<a name="l00372"></a>00372     this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#ab3b6e7ceb320e1cd0f8639780791ba07">get_linear_solve_parameters</a>();
<a name="l00373"></a>00373   std::pair&lt;unsigned int, Real&gt; totalrval = std::make_pair(0,0.0);
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00376"></a>00376     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00377"></a>00377       {
<a name="l00378"></a>00378         <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00379"></a>00379           linear_solver-&gt;<a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab5777831398d0a7a0d8ef2a231824989">add_adjoint_solution</a>(i),
<a name="l00380"></a>00380                                  this-&gt;<a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(i),
<a name="l00381"></a>00381                                  solver_params.second,
<a name="l00382"></a>00382                                  solver_params.first);
<a name="l00383"></a>00383 
<a name="l00384"></a>00384         totalrval.first  += rval.first;
<a name="l00385"></a>00385         totalrval.second += rval.second;
<a name="l00386"></a>00386       }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a43effba7c17eb24695c107560eb65e7d">release_linear_solver</a>(linear_solver);
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00391"></a>00391 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00392"></a>00392 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00393"></a>00393     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00394"></a>00394       this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>
<a name="l00395"></a>00395         (*<span class="keyword">this</span>, &amp;this-&gt;<a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(i));
<a name="l00396"></a>00396 <span class="preprocessor">#endif</span>
<a name="l00397"></a>00397 <span class="preprocessor"></span>
<a name="l00398"></a>00398   <span class="comment">// Stop logging the nonlinear solve</span>
<a name="l00399"></a>00399   STOP_LOG(<span class="stringliteral">&quot;adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;ImplicitSystem&quot;</span>);
<a name="l00400"></a>00400 
<a name="l00401"></a>00401   <span class="keywordflow">return</span> totalrval;
<a name="l00402"></a>00402 }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 std::pair&lt;unsigned int, Real&gt;
<a name="l00407"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a86af1dcc71b17ddec43f0e9fe67f353f">00407</a> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a86af1dcc71b17ddec43f0e9fe67f353f">ImplicitSystem::weighted_sensitivity_adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00408"></a>00408                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; weights,
<a name="l00409"></a>00409                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices)
<a name="l00410"></a>00410 {
<a name="l00411"></a>00411   <span class="comment">// Log how long the linear solve takes.</span>
<a name="l00412"></a>00412   START_LOG(<span class="stringliteral">&quot;weighted_sensitivity_adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;ImplicitSystem&quot;</span>);
<a name="l00413"></a>00413 
<a name="l00414"></a>00414   <span class="comment">// We currently get partial derivatives via central differencing</span>
<a name="l00415"></a>00415   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta_p = TOLERANCE;
<a name="l00416"></a>00416 
<a name="l00417"></a>00417   <span class="comment">// The forward system should now already be solved.</span>
<a name="l00418"></a>00418   <span class="comment">// The adjoint system should now already be solved.</span>
<a name="l00419"></a>00419   <span class="comment">// Now we&#39;re assembling a weighted sum of adjoint-adjoint systems:</span>
<a name="l00420"></a>00420   <span class="comment">//</span>
<a name="l00421"></a>00421   <span class="comment">// dR/du (u, sum_l(w_l*z^l)) = sum_l(w_l*(Q&#39;&#39;_ul - R&#39;&#39;_ul (u, z)))</span>
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="comment">// We&#39;ll assemble the rhs first, because the R&#39;&#39; term will require</span>
<a name="l00424"></a>00424   <span class="comment">// perturbing the jacobian</span>
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="comment">// We&#39;ll use temporary rhs vectors, because we haven&#39;t (yet) found</span>
<a name="l00427"></a>00427   <span class="comment">// any good reasons why users might want to save these:</span>
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   std::vector&lt;NumericVector&lt;Number&gt; *&gt; temprhs(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size());
<a name="l00430"></a>00430   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00431"></a>00431     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00432"></a>00432       temprhs[i] = this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a6f0bb3315b7252ca3bcc2b3c2e828a31">zero_clone</a>().<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00433"></a>00433 
<a name="l00434"></a>00434   <span class="comment">// We approximate the _l partial derivatives via a central</span>
<a name="l00435"></a>00435   <span class="comment">// differencing perturbation in the w_l direction:</span>
<a name="l00436"></a>00436   <span class="comment">//</span>
<a name="l00437"></a>00437   <span class="comment">// sum_l(w_l*v_l) ~= (v(p + dp*w_l*e_l) - v(p - dp*w_l*e_l))/(2*dp)</span>
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   <span class="comment">// PETSc doesn&#39;t implement SGEMX, so neither does NumericVector,</span>
<a name="l00440"></a>00440   <span class="comment">// so we want to avoid calculating f -= R&#39;*z.  We&#39;ll thus evaluate</span>
<a name="l00441"></a>00441   <span class="comment">// the above equation by first adding -v(p+dp...), then multiplying</span>
<a name="l00442"></a>00442   <span class="comment">// the intermediate result vectors by -1, then adding -v(p-dp...),</span>
<a name="l00443"></a>00443   <span class="comment">// then finally dividing by 2*dp.</span>
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a> oldparameters, parameterperturbation;
<a name="l00446"></a>00446   parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#aacf06a1971b30b2328c9d3013df2af5c">deep_copy</a>(oldparameters);
<a name="l00447"></a>00447   weights.<a class="code" href="classlibMesh_1_1ParameterVector.php#aacf06a1971b30b2328c9d3013df2af5c">deep_copy</a>(parameterperturbation);
<a name="l00448"></a>00448   parameterperturbation *= delta_p;
<a name="l00449"></a>00449   parameters += parameterperturbation;
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00452"></a>00452   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   <span class="comment">// Take the discrete adjoint, so that we can calculate R_u(u,z) with</span>
<a name="l00455"></a>00455   <span class="comment">// a matrix-vector product of R_u and z.</span>
<a name="l00456"></a>00456   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#aa85149e85125392a2fdb7671bb50a1e2">get_transpose</a>(*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a494403f8651bf2db7a930e02245e5429">assemble_qoi_derivative</a>(qoi_indices);
<a name="l00459"></a>00459   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00460"></a>00460     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00461"></a>00461       {
<a name="l00462"></a>00462         this-&gt;<a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(i).<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00463"></a>00463         *(temprhs[i]) -= this-&gt;<a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(i);
<a name="l00464"></a>00464         this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a0a7445955e126e341cd9a2e71b3c3976">vector_mult_add</a>(*(temprhs[i]), this-&gt;<a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(i));
<a name="l00465"></a>00465         *(temprhs[i]) *= -1.0;
<a name="l00466"></a>00466       }
<a name="l00467"></a>00467 
<a name="l00468"></a>00468   oldparameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#ab1728a53e4e47d3d9b9dc2bf470f0dbe">value_copy</a>(parameters);
<a name="l00469"></a>00469   parameterperturbation *= -1.0;
<a name="l00470"></a>00470   parameters += parameterperturbation;
<a name="l00471"></a>00471 
<a name="l00472"></a>00472   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00473"></a>00473   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00474"></a>00474   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#aa85149e85125392a2fdb7671bb50a1e2">get_transpose</a>(*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00475"></a>00475 
<a name="l00476"></a>00476   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a494403f8651bf2db7a930e02245e5429">assemble_qoi_derivative</a>(qoi_indices);
<a name="l00477"></a>00477   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00478"></a>00478     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00479"></a>00479       {
<a name="l00480"></a>00480         this-&gt;<a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(i).<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00481"></a>00481         *(temprhs[i]) -= this-&gt;<a class="code" href="classlibMesh_1_1System.php#afe988921e219358881c49d1fa7303507">get_adjoint_rhs</a>(i);
<a name="l00482"></a>00482         this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a0a7445955e126e341cd9a2e71b3c3976">vector_mult_add</a>(*(temprhs[i]), this-&gt;<a class="code" href="classlibMesh_1_1System.php#aeaf02ff714b2d9b6aca4e8d696856529">get_adjoint_solution</a>(i));
<a name="l00483"></a>00483         *(temprhs[i]) /= (2.0*delta_p);
<a name="l00484"></a>00484       }
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="comment">// Finally, assemble the jacobian at the non-perturbed parameter</span>
<a name="l00487"></a>00487   <span class="comment">// values</span>
<a name="l00488"></a>00488   oldparameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#ab1728a53e4e47d3d9b9dc2bf470f0dbe">value_copy</a>(parameters);
<a name="l00489"></a>00489 
<a name="l00490"></a>00490   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a>)
<a name="l00491"></a>00491     {
<a name="l00492"></a>00492       <span class="comment">// Build the Jacobian</span>
<a name="l00493"></a>00493       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00494"></a>00494       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00495"></a>00495 
<a name="l00496"></a>00496       <span class="comment">// Take the discrete adjoint</span>
<a name="l00497"></a>00497       <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#aa85149e85125392a2fdb7671bb50a1e2">get_transpose</a>(*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00498"></a>00498     }
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   <span class="comment">// The weighted adjoint-adjoint problem is linear</span>
<a name="l00501"></a>00501   <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *linear_solver = this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a46cae8e0c970cc71f4d3993432d60e5e">get_linear_solver</a>();
<a name="l00502"></a>00502 
<a name="l00503"></a>00503   <span class="comment">// Our iteration counts and residuals will be sums of the individual</span>
<a name="l00504"></a>00504   <span class="comment">// results</span>
<a name="l00505"></a>00505   std::pair&lt;unsigned int, Real&gt; solver_params =
<a name="l00506"></a>00506     this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#ab3b6e7ceb320e1cd0f8639780791ba07">get_linear_solve_parameters</a>();
<a name="l00507"></a>00507   std::pair&lt;unsigned int, Real&gt; totalrval = std::make_pair(0,0.0);
<a name="l00508"></a>00508 
<a name="l00509"></a>00509   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00510"></a>00510     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00511"></a>00511       {
<a name="l00512"></a>00512         <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00513"></a>00513           linear_solver-&gt;<a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a16e412144b3c5c1cc59cbb9e52b9ab05">add_weighted_sensitivity_adjoint_solution</a>(i),
<a name="l00514"></a>00514                                  *(temprhs[i]),
<a name="l00515"></a>00515                                  solver_params.second,
<a name="l00516"></a>00516                                  solver_params.first);
<a name="l00517"></a>00517 
<a name="l00518"></a>00518         totalrval.first  += rval.first;
<a name="l00519"></a>00519         totalrval.second += rval.second;
<a name="l00520"></a>00520       }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a43effba7c17eb24695c107560eb65e7d">release_linear_solver</a>(linear_solver);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00525"></a>00525     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00526"></a>00526       <span class="keyword">delete</span> temprhs[i];
<a name="l00527"></a>00527 
<a name="l00528"></a>00528   <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00529"></a>00529 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00530"></a>00530 <span class="preprocessor"></span>  <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != this-&gt;<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00531"></a>00531     <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00532"></a>00532       this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>
<a name="l00533"></a>00533         (*<span class="keyword">this</span>, &amp;this-&gt;<a class="code" href="classlibMesh_1_1System.php#a497665a8b66520f587e5e5102c94420c">get_weighted_sensitivity_adjoint_solution</a>(i));
<a name="l00534"></a>00534 <span class="preprocessor">#endif</span>
<a name="l00535"></a>00535 <span class="preprocessor"></span>
<a name="l00536"></a>00536   <span class="comment">// Stop logging the nonlinear solve</span>
<a name="l00537"></a>00537   STOP_LOG(<span class="stringliteral">&quot;weighted_sensitivity_adjoint_solve()&quot;</span>, <span class="stringliteral">&quot;ImplicitSystem&quot;</span>);
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="keywordflow">return</span> totalrval;
<a name="l00540"></a>00540 }
<a name="l00541"></a>00541 
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 std::pair&lt;unsigned int, Real&gt;
<a name="l00545"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#ae8d212c3ba251d39d4d177e4ef9698cc">00545</a> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ae8d212c3ba251d39d4d177e4ef9698cc">ImplicitSystem::weighted_sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00546"></a>00546                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; weights)
<a name="l00547"></a>00547 {
<a name="l00548"></a>00548   <span class="comment">// Log how long the linear solve takes.</span>
<a name="l00549"></a>00549   START_LOG(<span class="stringliteral">&quot;weighted_sensitivity_solve()&quot;</span>, <span class="stringliteral">&quot;ImplicitSystem&quot;</span>);
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   <span class="comment">// We currently get partial derivatives via central differencing</span>
<a name="l00552"></a>00552   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta_p = TOLERANCE;
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   <span class="comment">// The forward system should now already be solved.</span>
<a name="l00555"></a>00555 
<a name="l00556"></a>00556   <span class="comment">// Now we&#39;re assembling a weighted sum of sensitivity systems:</span>
<a name="l00557"></a>00557   <span class="comment">//</span>
<a name="l00558"></a>00558   <span class="comment">// dR/du (u, v)(sum(w_l*u&#39;_l)) = -sum_l(w_l*R&#39;_l (u, v)) forall v</span>
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   <span class="comment">// We&#39;ll assemble the rhs first, because the R&#39; term will require</span>
<a name="l00561"></a>00561   <span class="comment">// perturbing the system, and some applications may not be able to</span>
<a name="l00562"></a>00562   <span class="comment">// assemble a perturbed residual without simultaneously constructing</span>
<a name="l00563"></a>00563   <span class="comment">// a perturbed jacobian.</span>
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="comment">// We approximate the _l partial derivatives via a central</span>
<a name="l00566"></a>00566   <span class="comment">// differencing perturbation in the w_l direction:</span>
<a name="l00567"></a>00567   <span class="comment">//</span>
<a name="l00568"></a>00568   <span class="comment">// sum_l(w_l*v_l) ~= (v(p + dp*w_l*e_l) - v(p - dp*w_l*e_l))/(2*dp)</span>
<a name="l00569"></a>00569 
<a name="l00570"></a>00570   <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a> oldparameters, parameterperturbation;
<a name="l00571"></a>00571   parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#aacf06a1971b30b2328c9d3013df2af5c">deep_copy</a>(oldparameters);
<a name="l00572"></a>00572   weights.<a class="code" href="classlibMesh_1_1ParameterVector.php#aacf06a1971b30b2328c9d3013df2af5c">deep_copy</a>(parameterperturbation);
<a name="l00573"></a>00573   parameterperturbation *= delta_p;
<a name="l00574"></a>00574   parameters += parameterperturbation;
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00577"></a>00577   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00578"></a>00578 
<a name="l00579"></a>00579   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; temprhs = this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5c4b5cbb3877d0ad466895286fc8bb55">clone</a>();
<a name="l00580"></a>00580 
<a name="l00581"></a>00581   oldparameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#ab1728a53e4e47d3d9b9dc2bf470f0dbe">value_copy</a>(parameters);
<a name="l00582"></a>00582   parameterperturbation *= -1.0;
<a name="l00583"></a>00583   parameters += parameterperturbation;
<a name="l00584"></a>00584 
<a name="l00585"></a>00585   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00586"></a>00586   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00587"></a>00587 
<a name="l00588"></a>00588   *temprhs -= *(this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>);
<a name="l00589"></a>00589   *temprhs /= (2.0*delta_p);
<a name="l00590"></a>00590 
<a name="l00591"></a>00591   <span class="comment">// Finally, assemble the jacobian at the non-perturbed parameter</span>
<a name="l00592"></a>00592   <span class="comment">// values</span>
<a name="l00593"></a>00593   oldparameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#ab1728a53e4e47d3d9b9dc2bf470f0dbe">value_copy</a>(parameters);
<a name="l00594"></a>00594 
<a name="l00595"></a>00595   <span class="comment">// Build the Jacobian</span>
<a name="l00596"></a>00596   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00597"></a>00597   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00598"></a>00598 
<a name="l00599"></a>00599   <span class="comment">// The weighted sensitivity problem is linear</span>
<a name="l00600"></a>00600   <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *linear_solver = this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a46cae8e0c970cc71f4d3993432d60e5e">get_linear_solver</a>();
<a name="l00601"></a>00601 
<a name="l00602"></a>00602   std::pair&lt;unsigned int, Real&gt; solver_params =
<a name="l00603"></a>00603     this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#ab3b6e7ceb320e1cd0f8639780791ba07">get_linear_solve_parameters</a>();
<a name="l00604"></a>00604 
<a name="l00605"></a>00605   <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00606"></a>00606     linear_solver-&gt;<a class="code" href="classlibMesh_1_1LinearSolver.php#a9663fee6659bd9705e72142d5e42a02a">solve</a> (*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1922f73d344e6e1bea9100fec966e54">add_weighted_sensitivity_solution</a>(),
<a name="l00607"></a>00607                           *temprhs,
<a name="l00608"></a>00608                           solver_params.second,
<a name="l00609"></a>00609                           solver_params.first);
<a name="l00610"></a>00610 
<a name="l00611"></a>00611   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a43effba7c17eb24695c107560eb65e7d">release_linear_solver</a>(linear_solver);
<a name="l00612"></a>00612 
<a name="l00613"></a>00613   <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00614"></a>00614 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00615"></a>00615 <span class="preprocessor"></span>  this-&gt;<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>
<a name="l00616"></a>00616     (*<span class="keyword">this</span>, &amp;this-&gt;<a class="code" href="classlibMesh_1_1System.php#ad4168ae004bc141639bb8b2b44de45cc">get_weighted_sensitivity_solution</a>());
<a name="l00617"></a>00617 <span class="preprocessor">#endif</span>
<a name="l00618"></a>00618 <span class="preprocessor"></span>
<a name="l00619"></a>00619   <span class="comment">// Stop logging the nonlinear solve</span>
<a name="l00620"></a>00620   STOP_LOG(<span class="stringliteral">&quot;weighted_sensitivity_solve()&quot;</span>, <span class="stringliteral">&quot;ImplicitSystem&quot;</span>);
<a name="l00621"></a>00621 
<a name="l00622"></a>00622   <span class="keywordflow">return</span> rval;
<a name="l00623"></a>00623 }
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 
<a name="l00627"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a1f8552a617eabf208f2b99768312ec52">00627</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a1f8552a617eabf208f2b99768312ec52">ImplicitSystem::assemble_residual_derivatives</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters)
<a name="l00628"></a>00628 {
<a name="l00629"></a>00629   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Np = parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>();
<a name="l00630"></a>00630   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> deltap = TOLERANCE;
<a name="l00631"></a>00631 
<a name="l00632"></a>00632   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != Np; ++p)
<a name="l00633"></a>00633     {
<a name="l00634"></a>00634       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;sensitivity_rhs = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a65312b9004fc31ba812b7ec32515a2fa">add_sensitivity_rhs</a>(p);
<a name="l00635"></a>00635 
<a name="l00636"></a>00636       <span class="comment">// Approximate -(partial R / partial p) by</span>
<a name="l00637"></a>00637       <span class="comment">// (R(p-dp) - R(p+dp)) / (2*dp)</span>
<a name="l00638"></a>00638 
<a name="l00639"></a>00639       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> old_parameter = *parameters[p];
<a name="l00640"></a>00640       *parameters[p] -= deltap;
<a name="l00641"></a>00641 
<a name="l00642"></a>00642       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00643"></a>00643       this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00644"></a>00644       sensitivity_rhs = *this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>;
<a name="l00645"></a>00645 
<a name="l00646"></a>00646       *parameters[p] = old_parameter + deltap;
<a name="l00647"></a>00647 
<a name="l00648"></a>00648       this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00649"></a>00649       this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00650"></a>00650 
<a name="l00651"></a>00651       sensitivity_rhs -= *this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>;
<a name="l00652"></a>00652       sensitivity_rhs /= (2*deltap);
<a name="l00653"></a>00653       sensitivity_rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00654"></a>00654 
<a name="l00655"></a>00655       *parameters[p] = old_parameter;
<a name="l00656"></a>00656     }
<a name="l00657"></a>00657 }
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a4f8bc3fa7c7f75d914128e0ecd1913ee">ImplicitSystem::adjoint_qoi_parameter_sensitivity</a>
<a name="l00662"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a4f8bc3fa7c7f75d914128e0ecd1913ee">00662</a>   (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;          qoi_indices,
<a name="l00663"></a>00663    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00664"></a>00664    <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;       sensitivities)
<a name="l00665"></a>00665 {
<a name="l00666"></a>00666   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Np = parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>();
<a name="l00667"></a>00667   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nq = qoi.size();
<a name="l00668"></a>00668 
<a name="l00669"></a>00669   <span class="comment">// We currently get partial derivatives via central differencing</span>
<a name="l00670"></a>00670   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta_p = TOLERANCE;
<a name="l00671"></a>00671 
<a name="l00672"></a>00672   <span class="comment">// An introduction to the problem:</span>
<a name="l00673"></a>00673   <span class="comment">//</span>
<a name="l00674"></a>00674   <span class="comment">// Residual R(u(p),p) = 0</span>
<a name="l00675"></a>00675   <span class="comment">// partial R / partial u = J = system matrix</span>
<a name="l00676"></a>00676   <span class="comment">//</span>
<a name="l00677"></a>00677   <span class="comment">// This implies that:</span>
<a name="l00678"></a>00678   <span class="comment">// d/dp(R) = 0</span>
<a name="l00679"></a>00679   <span class="comment">// (partial R / partial p) + </span>
<a name="l00680"></a>00680   <span class="comment">// (partial R / partial u) * (partial u / partial p) = 0</span>
<a name="l00681"></a>00681 
<a name="l00682"></a>00682   <span class="comment">// We first do an adjoint solve:</span>
<a name="l00683"></a>00683   <span class="comment">// J^T * z = (partial q / partial u)</span>
<a name="l00684"></a>00684 
<a name="l00685"></a>00685   this-&gt;adjoint_solve(qoi_indices);
<a name="l00686"></a>00686 
<a name="l00687"></a>00687   <span class="comment">// Get ready to fill in senstivities:</span>
<a name="l00688"></a>00688   sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#a917d97e53b3fbf2b05253917ce3cf8c0">allocate_data</a>(qoi_indices, *<span class="keyword">this</span>, parameters);
<a name="l00689"></a>00689 
<a name="l00690"></a>00690   <span class="comment">// We use the identities:</span>
<a name="l00691"></a>00691   <span class="comment">// dq/dp = (partial q / partial p) + (partial q / partial u) *</span>
<a name="l00692"></a>00692   <span class="comment">//         (partial u / partial p)</span>
<a name="l00693"></a>00693   <span class="comment">// dq/dp = (partial q / partial p) + (J^T * z) *</span>
<a name="l00694"></a>00694   <span class="comment">//         (partial u / partial p)</span>
<a name="l00695"></a>00695   <span class="comment">// dq/dp = (partial q / partial p) + z * J *</span>
<a name="l00696"></a>00696   <span class="comment">//         (partial u / partial p)</span>
<a name="l00697"></a>00697  
<a name="l00698"></a>00698   <span class="comment">// Leading to our final formula:</span>
<a name="l00699"></a>00699   <span class="comment">// dq/dp = (partial q / partial p) - z * (partial R / partial p)</span>
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != Np; ++j)
<a name="l00702"></a>00702     {
<a name="l00703"></a>00703       <span class="comment">// (partial q / partial p) ~= (q(p+dp)-q(p-dp))/(2*dp)</span>
<a name="l00704"></a>00704       <span class="comment">// (partial R / partial p) ~= (rhs(p+dp) - rhs(p-dp))/(2*dp)</span>
<a name="l00705"></a>00705 
<a name="l00706"></a>00706       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> old_parameter = *parameters[j];
<a name="l00707"></a>00707       <span class="comment">// Number old_qoi = this-&gt;qoi;</span>
<a name="l00708"></a>00708 
<a name="l00709"></a>00709       *parameters[j] = old_parameter - delta_p;
<a name="l00710"></a>00710       this-&gt;assemble_qoi(qoi_indices);
<a name="l00711"></a>00711       std::vector&lt;Number&gt; qoi_minus = this-&gt;qoi;
<a name="l00712"></a>00712 
<a name="l00713"></a>00713       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00714"></a>00714       this-&gt;rhs-&gt;close();
<a name="l00715"></a>00715       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; partialR_partialp = this-&gt;rhs-&gt;clone();
<a name="l00716"></a>00716       *partialR_partialp *= -1;
<a name="l00717"></a>00717 
<a name="l00718"></a>00718       *parameters[j] = old_parameter + delta_p;
<a name="l00719"></a>00719       this-&gt;assemble_qoi(qoi_indices);
<a name="l00720"></a>00720       std::vector&lt;Number&gt;&amp; qoi_plus = this-&gt;qoi;
<a name="l00721"></a>00721 
<a name="l00722"></a>00722       std::vector&lt;Number&gt; partialq_partialp(Nq, 0);
<a name="l00723"></a>00723       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00724"></a>00724         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00725"></a>00725           partialq_partialp[i] = (qoi_plus[i] - qoi_minus[i]) / (2.*delta_p);
<a name="l00726"></a>00726 
<a name="l00727"></a>00727       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00728"></a>00728       this-&gt;rhs-&gt;close();
<a name="l00729"></a>00729       *partialR_partialp += *this-&gt;rhs;
<a name="l00730"></a>00730       *partialR_partialp /= (2.*delta_p);
<a name="l00731"></a>00731 
<a name="l00732"></a>00732       <span class="comment">// Don&#39;t leave the parameter changed</span>
<a name="l00733"></a>00733       *parameters[j] = old_parameter;
<a name="l00734"></a>00734 
<a name="l00735"></a>00735       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00736"></a>00736         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00737"></a>00737           sensitivities[i][j] = partialq_partialp[i] -
<a name="l00738"></a>00738             partialR_partialp-&gt;dot(this-&gt;get_adjoint_solution(i));
<a name="l00739"></a>00739     }
<a name="l00740"></a>00740 
<a name="l00741"></a>00741   <span class="comment">// All parameters have been reset.</span>
<a name="l00742"></a>00742   <span class="comment">// We didn&#39;t cache the original rhs or matrix for memory reasons,</span>
<a name="l00743"></a>00743   <span class="comment">// but we can restore them to a state consistent solution -</span>
<a name="l00744"></a>00744   <span class="comment">// principle of least surprise.</span>
<a name="l00745"></a>00745   this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00746"></a>00746   this-&gt;rhs-&gt;close();
<a name="l00747"></a>00747   this-&gt;matrix-&gt;close();
<a name="l00748"></a>00748   this-&gt;assemble_qoi(qoi_indices);
<a name="l00749"></a>00749 }
<a name="l00750"></a>00750 
<a name="l00751"></a>00751 
<a name="l00752"></a>00752 
<a name="l00753"></a>00753 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a49c08585cd11fe4c44ef0471329f1c28">ImplicitSystem::forward_qoi_parameter_sensitivity</a>
<a name="l00754"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a49c08585cd11fe4c44ef0471329f1c28">00754</a>   (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp;          qoi_indices,
<a name="l00755"></a>00755    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00756"></a>00756    <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp;       sensitivities)
<a name="l00757"></a>00757 {
<a name="l00758"></a>00758   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Np = parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>();
<a name="l00759"></a>00759   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nq = qoi.size();
<a name="l00760"></a>00760 
<a name="l00761"></a>00761   <span class="comment">// We currently get partial derivatives via central differencing</span>
<a name="l00762"></a>00762   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta_p = TOLERANCE;
<a name="l00763"></a>00763 
<a name="l00764"></a>00764   <span class="comment">// An introduction to the problem:</span>
<a name="l00765"></a>00765   <span class="comment">//</span>
<a name="l00766"></a>00766   <span class="comment">// Residual R(u(p),p) = 0</span>
<a name="l00767"></a>00767   <span class="comment">// partial R / partial u = J = system matrix</span>
<a name="l00768"></a>00768   <span class="comment">//</span>
<a name="l00769"></a>00769   <span class="comment">// This implies that:</span>
<a name="l00770"></a>00770   <span class="comment">// d/dp(R) = 0</span>
<a name="l00771"></a>00771   <span class="comment">// (partial R / partial p) + </span>
<a name="l00772"></a>00772   <span class="comment">// (partial R / partial u) * (partial u / partial p) = 0</span>
<a name="l00773"></a>00773 
<a name="l00774"></a>00774   <span class="comment">// We first solve for (partial u / partial p) for each parameter:</span>
<a name="l00775"></a>00775   <span class="comment">// J * (partial u / partial p) = - (partial R / partial p)</span>
<a name="l00776"></a>00776 
<a name="l00777"></a>00777   this-&gt;sensitivity_solve(parameters);
<a name="l00778"></a>00778 
<a name="l00779"></a>00779   <span class="comment">// Get ready to fill in senstivities:</span>
<a name="l00780"></a>00780   sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#a917d97e53b3fbf2b05253917ce3cf8c0">allocate_data</a>(qoi_indices, *<span class="keyword">this</span>, parameters);
<a name="l00781"></a>00781 
<a name="l00782"></a>00782   <span class="comment">// We use the identity:</span>
<a name="l00783"></a>00783   <span class="comment">// dq/dp = (partial q / partial p) + (partial q / partial u) *</span>
<a name="l00784"></a>00784   <span class="comment">//         (partial u / partial p)</span>
<a name="l00785"></a>00785  
<a name="l00786"></a>00786   <span class="comment">// We get (partial q / partial u) from the user</span>
<a name="l00787"></a>00787   this-&gt;assemble_qoi_derivative(qoi_indices);
<a name="l00788"></a>00788 
<a name="l00789"></a>00789   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j != Np; ++j)
<a name="l00790"></a>00790     {
<a name="l00791"></a>00791       <span class="comment">// (partial q / partial p) ~= (q(p+dp)-q(p-dp))/(2*dp)</span>
<a name="l00792"></a>00792 
<a name="l00793"></a>00793       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> old_parameter = *parameters[j];
<a name="l00794"></a>00794 
<a name="l00795"></a>00795       *parameters[j] = old_parameter - delta_p;
<a name="l00796"></a>00796       this-&gt;assemble_qoi();
<a name="l00797"></a>00797       std::vector&lt;Number&gt; qoi_minus = this-&gt;qoi;
<a name="l00798"></a>00798 
<a name="l00799"></a>00799       *parameters[j] = old_parameter + delta_p;
<a name="l00800"></a>00800       this-&gt;assemble_qoi();
<a name="l00801"></a>00801       std::vector&lt;Number&gt;&amp; qoi_plus = this-&gt;qoi;
<a name="l00802"></a>00802 
<a name="l00803"></a>00803       std::vector&lt;Number&gt; partialq_partialp(Nq, 0);
<a name="l00804"></a>00804       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00805"></a>00805         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00806"></a>00806           partialq_partialp[i] = (qoi_plus[i] - qoi_minus[i]) / (2.*delta_p);
<a name="l00807"></a>00807 
<a name="l00808"></a>00808       <span class="comment">// Don&#39;t leave the parameter changed</span>
<a name="l00809"></a>00809       *parameters[j] = old_parameter;
<a name="l00810"></a>00810 
<a name="l00811"></a>00811       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00812"></a>00812         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00813"></a>00813           sensitivities[i][j] = partialq_partialp[i] +
<a name="l00814"></a>00814             this-&gt;get_adjoint_rhs(i).dot(this-&gt;get_sensitivity_solution(j));
<a name="l00815"></a>00815     }
<a name="l00816"></a>00816 
<a name="l00817"></a>00817   <span class="comment">// All parameters have been reset.</span>
<a name="l00818"></a>00818   <span class="comment">// We didn&#39;t cache the original rhs or matrix for memory reasons,</span>
<a name="l00819"></a>00819   <span class="comment">// but we can restore them to a state consistent solution -</span>
<a name="l00820"></a>00820   <span class="comment">// principle of least surprise.</span>
<a name="l00821"></a>00821   this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00822"></a>00822   this-&gt;rhs-&gt;close();
<a name="l00823"></a>00823   this-&gt;matrix-&gt;close();
<a name="l00824"></a>00824   this-&gt;assemble_qoi(qoi_indices);
<a name="l00825"></a>00825 }
<a name="l00826"></a>00826 
<a name="l00827"></a>00827 
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aad2b6410e29f55ea4f43d7625603eef4">ImplicitSystem::qoi_parameter_hessian_vector_product</a>
<a name="l00830"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#aad2b6410e29f55ea4f43d7625603eef4">00830</a>   (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00831"></a>00831    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00832"></a>00832    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; <a class="code" href="classstd_1_1vector.php">vector</a>,
<a name="l00833"></a>00833    <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities)
<a name="l00834"></a>00834 {
<a name="l00835"></a>00835   <span class="comment">// We currently get partial derivatives via finite differencing</span>
<a name="l00836"></a>00836   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta_p = TOLERANCE;
<a name="l00837"></a>00837 
<a name="l00838"></a>00838   <span class="comment">// We&#39;ll use a single temporary vector for matrix-vector-vector products</span>
<a name="l00839"></a>00839   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; tempvec = this-&gt;solution-&gt;zero_clone();
<a name="l00840"></a>00840 
<a name="l00841"></a>00841   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Np = parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>();
<a name="l00842"></a>00842   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nq = qoi.size();
<a name="l00843"></a>00843 
<a name="l00844"></a>00844   <span class="comment">// For each quantity of interest q, the parameter sensitivity</span>
<a name="l00845"></a>00845   <span class="comment">// Hessian is defined as q&#39;&#39;_{kl} = {d^2 q}/{d p_k d p_l}.</span>
<a name="l00846"></a>00846   <span class="comment">// Given a vector of parameter perturbation weights w_l, this</span>
<a name="l00847"></a>00847   <span class="comment">// function evaluates the hessian-vector product sum_l(q&#39;&#39;_{kl}*w_l)</span>
<a name="l00848"></a>00848   <span class="comment">//</span>
<a name="l00849"></a>00849   <span class="comment">// We calculate it from values and partial derivatives of the</span>
<a name="l00850"></a>00850   <span class="comment">// quantity of interest function Q, solution u, adjoint solution z,</span>
<a name="l00851"></a>00851   <span class="comment">// parameter sensitivity adjoint solutions z^l, and residual R, as:</span>
<a name="l00852"></a>00852   <span class="comment">//</span>
<a name="l00853"></a>00853   <span class="comment">// sum_l(q&#39;&#39;_{kl}*w_l) =</span>
<a name="l00854"></a>00854   <span class="comment">// sum_l(w_l * Q&#39;&#39;_{kl}) + Q&#39;&#39;_{uk}(u)*(sum_l(w_l u&#39;_l)) -</span>
<a name="l00855"></a>00855   <span class="comment">// R&#39;_k(u, sum_l(w_l*z^l)) - R&#39;_{uk}(u,z)*(sum_l(w_l u&#39;_l) -</span>
<a name="l00856"></a>00856   <span class="comment">// sum_l(w_l*R&#39;&#39;_{kl}(u,z))</span>
<a name="l00857"></a>00857   <span class="comment">//</span>
<a name="l00858"></a>00858   <span class="comment">// See the adjoints model document for more details.</span>
<a name="l00859"></a>00859 
<a name="l00860"></a>00860   <span class="comment">// We first do an adjoint solve to get z for each quantity of</span>
<a name="l00861"></a>00861   <span class="comment">// interest</span>
<a name="l00862"></a>00862 
<a name="l00863"></a>00863   this-&gt;adjoint_solve(qoi_indices);
<a name="l00864"></a>00864 
<a name="l00865"></a>00865   <span class="comment">// Get ready to fill in senstivities:</span>
<a name="l00866"></a>00866   sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#a917d97e53b3fbf2b05253917ce3cf8c0">allocate_data</a>(qoi_indices, *<span class="keyword">this</span>, parameters);
<a name="l00867"></a>00867 
<a name="l00868"></a>00868   <span class="comment">// We can&#39;t solve for all the solution sensitivities u&#39;_l or for all</span>
<a name="l00869"></a>00869   <span class="comment">// of the parameter sensitivity adjoint solutions z^l without</span>
<a name="l00870"></a>00870   <span class="comment">// requiring O(Nq*Np) linear solves.  So we&#39;ll solve directly for their</span>
<a name="l00871"></a>00871   <span class="comment">// weighted sum - this is just O(Nq) solves.</span>
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   <span class="comment">// First solve for sum_l(w_l u&#39;_l).</span>
<a name="l00874"></a>00874   this-&gt;weighted_sensitivity_solve(parameters, vector);
<a name="l00875"></a>00875 
<a name="l00876"></a>00876   <span class="comment">// Then solve for sum_l(w_l z^l).</span>
<a name="l00877"></a>00877   this-&gt;weighted_sensitivity_adjoint_solve(parameters, vector, qoi_indices);
<a name="l00878"></a>00878 
<a name="l00879"></a>00879   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k != Np; ++k)
<a name="l00880"></a>00880     {
<a name="l00881"></a>00881       <span class="comment">// We approximate sum_l(w_l * Q&#39;&#39;_{kl}) with a central</span>
<a name="l00882"></a>00882       <span class="comment">// differencing pertubation:</span>
<a name="l00883"></a>00883       <span class="comment">// sum_l(w_l * Q&#39;&#39;_{kl}) ~= </span>
<a name="l00884"></a>00884       <span class="comment">// (Q(p + dp*w_l*e_l + dp*e_k) - Q(p - dp*w_l*e_l + dp*e_k) -</span>
<a name="l00885"></a>00885       <span class="comment">// Q(p + dp*w_l*e_l - dp*e_k) + Q(p - dp*w_l*e_l - dp*e_k))/(4*dp^2)</span>
<a name="l00886"></a>00886 
<a name="l00887"></a>00887       <span class="comment">// The sum(w_l*R&#39;&#39;_kl) term requires the same sort of pertubation,</span>
<a name="l00888"></a>00888       <span class="comment">// and so we subtract it in at the same time:</span>
<a name="l00889"></a>00889       <span class="comment">// sum_l(w_l * R&#39;&#39;_{kl}) ~= </span>
<a name="l00890"></a>00890       <span class="comment">// (R(p + dp*w_l*e_l + dp*e_k) - R(p - dp*w_l*e_l + dp*e_k) -</span>
<a name="l00891"></a>00891       <span class="comment">// R(p + dp*w_l*e_l - dp*e_k) + R(p - dp*w_l*e_l - dp*e_k))/(4*dp^2)</span>
<a name="l00892"></a>00892 
<a name="l00893"></a>00893       <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a> oldparameters, parameterperturbation;
<a name="l00894"></a>00894       parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#aacf06a1971b30b2328c9d3013df2af5c">deep_copy</a>(oldparameters);
<a name="l00895"></a>00895       vector.<a class="code" href="classlibMesh_1_1ParameterVector.php#aacf06a1971b30b2328c9d3013df2af5c">deep_copy</a>(parameterperturbation);
<a name="l00896"></a>00896       parameterperturbation *= delta_p;
<a name="l00897"></a>00897       parameters += parameterperturbation;
<a name="l00898"></a>00898 
<a name="l00899"></a>00899       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> old_parameter = *parameters[k];
<a name="l00900"></a>00900 
<a name="l00901"></a>00901       *parameters[k] = old_parameter + delta_p;
<a name="l00902"></a>00902       this-&gt;assemble_qoi(qoi_indices);
<a name="l00903"></a>00903       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00904"></a>00904       this-&gt;rhs-&gt;close();
<a name="l00905"></a>00905       std::vector&lt;Number&gt; partial2q_term = this-&gt;qoi;
<a name="l00906"></a>00906       std::vector&lt;Number&gt; partial2R_term(this-&gt;qoi.size());
<a name="l00907"></a>00907       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00908"></a>00908         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00909"></a>00909           partial2R_term[i] = this-&gt;rhs-&gt;dot(this-&gt;get_adjoint_solution(i));
<a name="l00910"></a>00910 
<a name="l00911"></a>00911       *parameters[k] = old_parameter - delta_p;
<a name="l00912"></a>00912       this-&gt;assemble_qoi(qoi_indices);
<a name="l00913"></a>00913       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00914"></a>00914       this-&gt;rhs-&gt;close();
<a name="l00915"></a>00915       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00916"></a>00916         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00917"></a>00917           {
<a name="l00918"></a>00918             partial2q_term[i] -= this-&gt;qoi[i];
<a name="l00919"></a>00919             partial2R_term[i] -= this-&gt;rhs-&gt;dot(this-&gt;get_adjoint_solution(i));
<a name="l00920"></a>00920           }
<a name="l00921"></a>00921 
<a name="l00922"></a>00922       oldparameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#ab1728a53e4e47d3d9b9dc2bf470f0dbe">value_copy</a>(parameters);
<a name="l00923"></a>00923       parameterperturbation *= -1.0;
<a name="l00924"></a>00924       parameters += parameterperturbation;
<a name="l00925"></a>00925 
<a name="l00926"></a>00926       <span class="comment">// Re-center old_parameter, which may be affected by vector</span>
<a name="l00927"></a>00927       old_parameter = *parameters[k];
<a name="l00928"></a>00928 
<a name="l00929"></a>00929       *parameters[k] = old_parameter + delta_p;
<a name="l00930"></a>00930       this-&gt;assemble_qoi(qoi_indices);
<a name="l00931"></a>00931       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00932"></a>00932       this-&gt;rhs-&gt;close();
<a name="l00933"></a>00933       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00934"></a>00934         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00935"></a>00935           {
<a name="l00936"></a>00936             partial2q_term[i] -= this-&gt;qoi[i];
<a name="l00937"></a>00937             partial2R_term[i] -= this-&gt;rhs-&gt;dot(this-&gt;get_adjoint_solution(i));
<a name="l00938"></a>00938           }
<a name="l00939"></a>00939 
<a name="l00940"></a>00940       *parameters[k] = old_parameter - delta_p;
<a name="l00941"></a>00941       this-&gt;assemble_qoi(qoi_indices);
<a name="l00942"></a>00942       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00943"></a>00943       this-&gt;rhs-&gt;close();
<a name="l00944"></a>00944       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00945"></a>00945         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00946"></a>00946           {
<a name="l00947"></a>00947             partial2q_term[i] += this-&gt;qoi[i];
<a name="l00948"></a>00948             partial2R_term[i] += this-&gt;rhs-&gt;dot(this-&gt;get_adjoint_solution(i));
<a name="l00949"></a>00949           }
<a name="l00950"></a>00950 
<a name="l00951"></a>00951       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00952"></a>00952         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00953"></a>00953           {
<a name="l00954"></a>00954             partial2q_term[i] /= (4. * delta_p * delta_p);
<a name="l00955"></a>00955             partial2R_term[i] /= (4. * delta_p * delta_p);
<a name="l00956"></a>00956           }
<a name="l00957"></a>00957 
<a name="l00958"></a>00958       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00959"></a>00959         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00960"></a>00960           sensitivities[i][k] = partial2q_term[i] - partial2R_term[i];
<a name="l00961"></a>00961 
<a name="l00962"></a>00962       <span class="comment">// We get (partial q / partial u), R, and </span>
<a name="l00963"></a>00963       <span class="comment">// (partial R / partial u) from the user, but centrally</span>
<a name="l00964"></a>00964       <span class="comment">// difference to get q_uk, R_k, and R_uk terms:</span>
<a name="l00965"></a>00965       <span class="comment">// (partial R / partial k)</span>
<a name="l00966"></a>00966       <span class="comment">// R_k*sum(w_l*z^l) = (R(p+dp*e_k)*sum(w_l*z^l) - R(p-dp*e_k)*sum(w_l*z^l))/(2*dp)</span>
<a name="l00967"></a>00967       <span class="comment">// (partial^2 q / partial u partial k)</span>
<a name="l00968"></a>00968       <span class="comment">// q_uk = (q_u(p+dp*e_k) - q_u(p-dp*e_k))/(2*dp)</span>
<a name="l00969"></a>00969       <span class="comment">// (partial^2 R / partial u partial k)</span>
<a name="l00970"></a>00970       <span class="comment">// R_uk*z*sum(w_l*u&#39;_l) = (R_u(p+dp*e_k)*z*sum(w_l*u&#39;_l) - R_u(p-dp*e_k)*z*sum(w_l*u&#39;_l))/(2*dp)</span>
<a name="l00971"></a>00971 
<a name="l00972"></a>00972       <span class="comment">// To avoid creating Nq temporary vectors for q_uk or R_uk, we add</span>
<a name="l00973"></a>00973       <span class="comment">// subterms to the sensitivities output one by one.</span>
<a name="l00974"></a>00974       <span class="comment">//</span>
<a name="l00975"></a>00975       <span class="comment">// FIXME: this is probably a bad order of operations for</span>
<a name="l00976"></a>00976       <span class="comment">// controlling floating point error.</span>
<a name="l00977"></a>00977 
<a name="l00978"></a>00978       *parameters[k] = old_parameter + delta_p;
<a name="l00979"></a>00979       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00980"></a>00980       this-&gt;rhs-&gt;close();
<a name="l00981"></a>00981       this-&gt;matrix-&gt;close();
<a name="l00982"></a>00982       this-&gt;assemble_qoi_derivative(qoi_indices);
<a name="l00983"></a>00983 
<a name="l00984"></a>00984       this-&gt;matrix-&gt;vector_mult(*tempvec, this-&gt;get_weighted_sensitivity_solution());
<a name="l00985"></a>00985 
<a name="l00986"></a>00986       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l00987"></a>00987         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00988"></a>00988           {
<a name="l00989"></a>00989             this-&gt;get_adjoint_rhs(i).close();
<a name="l00990"></a>00990             sensitivities[i][k] += (this-&gt;get_adjoint_rhs(i).dot(this-&gt;get_weighted_sensitivity_solution()) -
<a name="l00991"></a>00991                                     this-&gt;rhs-&gt;dot(this-&gt;get_weighted_sensitivity_adjoint_solution(i)) -
<a name="l00992"></a>00992                                     this-&gt;get_adjoint_solution(i).dot(*tempvec)) / (2.*delta_p);
<a name="l00993"></a>00993           }
<a name="l00994"></a>00994  
<a name="l00995"></a>00995       *parameters[k] = old_parameter - delta_p;
<a name="l00996"></a>00996       this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00997"></a>00997       this-&gt;rhs-&gt;close();
<a name="l00998"></a>00998       this-&gt;matrix-&gt;close();
<a name="l00999"></a>00999       this-&gt;assemble_qoi_derivative(qoi_indices);
<a name="l01000"></a>01000 
<a name="l01001"></a>01001       this-&gt;matrix-&gt;vector_mult(*tempvec, this-&gt;get_weighted_sensitivity_solution());
<a name="l01002"></a>01002 
<a name="l01003"></a>01003       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01004"></a>01004         <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01005"></a>01005           {
<a name="l01006"></a>01006             this-&gt;get_adjoint_rhs(i).close();
<a name="l01007"></a>01007             sensitivities[i][k] += (-this-&gt;get_adjoint_rhs(i).dot(this-&gt;get_weighted_sensitivity_solution()) +
<a name="l01008"></a>01008                                     this-&gt;rhs-&gt;dot(this-&gt;get_weighted_sensitivity_adjoint_solution(i)) +
<a name="l01009"></a>01009                                     this-&gt;get_adjoint_solution(i).dot(*tempvec)) / (2.*delta_p);
<a name="l01010"></a>01010           }
<a name="l01011"></a>01011     }
<a name="l01012"></a>01012 
<a name="l01013"></a>01013   <span class="comment">// All parameters have been reset.</span>
<a name="l01014"></a>01014   <span class="comment">// Don&#39;t leave the qoi or system changed - principle of least</span>
<a name="l01015"></a>01015   <span class="comment">// surprise.</span>
<a name="l01016"></a>01016   this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l01017"></a>01017   this-&gt;rhs-&gt;close();
<a name="l01018"></a>01018   this-&gt;matrix-&gt;close();
<a name="l01019"></a>01019   this-&gt;assemble_qoi(qoi_indices);
<a name="l01020"></a>01020 }
<a name="l01021"></a>01021 
<a name="l01022"></a>01022 
<a name="l01023"></a>01023 
<a name="l01024"></a>01024 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aafb0adb90523c2de5d88d5ba221134bc">ImplicitSystem::qoi_parameter_hessian</a>
<a name="l01025"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#aafb0adb90523c2de5d88d5ba221134bc">01025</a>   (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l01026"></a>01026    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l01027"></a>01027    <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities)
<a name="l01028"></a>01028 {
<a name="l01029"></a>01029   <span class="comment">// We currently get partial derivatives via finite differencing</span>
<a name="l01030"></a>01030   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta_p = TOLERANCE;
<a name="l01031"></a>01031 
<a name="l01032"></a>01032   <span class="comment">// We&#39;ll use one temporary vector for matrix-vector-vector products</span>
<a name="l01033"></a>01033   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; tempvec = this-&gt;solution-&gt;zero_clone();
<a name="l01034"></a>01034 
<a name="l01035"></a>01035   <span class="comment">// And another temporary vector to hold a copy of the true solution</span>
<a name="l01036"></a>01036   <span class="comment">// so we can safely perturb this-&gt;solution.</span>
<a name="l01037"></a>01037   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; oldsolution = this-&gt;solution-&gt;clone();
<a name="l01038"></a>01038 
<a name="l01039"></a>01039   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Np = parameters.<a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>();
<a name="l01040"></a>01040   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Nq = qoi.size();
<a name="l01041"></a>01041 
<a name="l01042"></a>01042   <span class="comment">// For each quantity of interest q, the parameter sensitivity</span>
<a name="l01043"></a>01043   <span class="comment">// Hessian is defined as q&#39;&#39;_{kl} = {d^2 q}/{d p_k d p_l}.</span>
<a name="l01044"></a>01044   <span class="comment">//</span>
<a name="l01045"></a>01045   <span class="comment">// We calculate it from values and partial derivatives of the</span>
<a name="l01046"></a>01046   <span class="comment">// quantity of interest function Q, solution u, adjoint solution z,</span>
<a name="l01047"></a>01047   <span class="comment">// and residual R, as:</span>
<a name="l01048"></a>01048   <span class="comment">//</span>
<a name="l01049"></a>01049   <span class="comment">// q&#39;&#39;_{kl} =</span>
<a name="l01050"></a>01050   <span class="comment">// Q&#39;&#39;_{kl} + Q&#39;&#39;_{uk}(u)*u&#39;_l + Q&#39;&#39;_{ul}(u) * u&#39;_k + </span>
<a name="l01051"></a>01051   <span class="comment">// Q&#39;&#39;_{uu}(u)*u&#39;_k*u&#39;_l -</span>
<a name="l01052"></a>01052   <span class="comment">// R&#39;&#39;_{kl}(u,z) -</span>
<a name="l01053"></a>01053   <span class="comment">// R&#39;&#39;_{uk}(u,z)*u&#39;_l - R&#39;&#39;_{ul}(u,z)*u&#39;_k -</span>
<a name="l01054"></a>01054   <span class="comment">// R&#39;&#39;_{uu}(u,z)*u&#39;_k*u&#39;_l</span>
<a name="l01055"></a>01055   <span class="comment">//</span>
<a name="l01056"></a>01056   <span class="comment">// See the adjoints model document for more details.</span>
<a name="l01057"></a>01057 
<a name="l01058"></a>01058   <span class="comment">// We first do an adjoint solve to get z for each quantity of</span>
<a name="l01059"></a>01059   <span class="comment">// interest</span>
<a name="l01060"></a>01060 
<a name="l01061"></a>01061   this-&gt;adjoint_solve(qoi_indices);
<a name="l01062"></a>01062 
<a name="l01063"></a>01063   <span class="comment">// And a sensitivity solve to get u_k for each parameter</span>
<a name="l01064"></a>01064   this-&gt;sensitivity_solve(parameters);
<a name="l01065"></a>01065 
<a name="l01066"></a>01066   <span class="comment">// Get ready to fill in second derivatives:</span>
<a name="l01067"></a>01067   sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#a11e2068254ef4c765d3a0e8c957540b0">allocate_hessian_data</a>(qoi_indices, *<span class="keyword">this</span>, parameters);
<a name="l01068"></a>01068 
<a name="l01069"></a>01069   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k != Np; ++k)
<a name="l01070"></a>01070     {
<a name="l01071"></a>01071       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> old_parameterk = *parameters[k];
<a name="l01072"></a>01072 
<a name="l01073"></a>01073       <span class="comment">// The Hessian is symmetric, so we just calculate the lower</span>
<a name="l01074"></a>01074       <span class="comment">// triangle and the diagonal, and we get the upper triangle from</span>
<a name="l01075"></a>01075       <span class="comment">// the transpose of the lower</span>
<a name="l01076"></a>01076 
<a name="l01077"></a>01077       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != k+1; ++l)
<a name="l01078"></a>01078         {
<a name="l01079"></a>01079           <span class="comment">// The second partial derivatives with respect to parameters</span>
<a name="l01080"></a>01080           <span class="comment">// are all calculated via a central finite difference</span>
<a name="l01081"></a>01081           <span class="comment">// stencil:</span>
<a name="l01082"></a>01082           <span class="comment">// F&#39;&#39;_{kl} ~= (F(p+dp*e_k+dp*e_l) - F(p+dp*e_k-dp*e_l) -</span>
<a name="l01083"></a>01083           <span class="comment">//              F(p-dp*e_k+dp*e_l) + F(p-dp*e_k-dp*e_l))/(4*dp^2)</span>
<a name="l01084"></a>01084           <span class="comment">// We will add Q&#39;&#39;_{kl}(u) and subtract R&#39;&#39;_{kl}(u,z) at the</span>
<a name="l01085"></a>01085           <span class="comment">// same time.</span>
<a name="l01086"></a>01086           <span class="comment">//</span>
<a name="l01087"></a>01087           <span class="comment">// We have to be careful with the perturbations to handle</span>
<a name="l01088"></a>01088           <span class="comment">// the k=l case</span>
<a name="l01089"></a>01089 
<a name="l01090"></a>01090           <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> old_parameterl = *parameters[l];
<a name="l01091"></a>01091 
<a name="l01092"></a>01092           *parameters[k] += delta_p;
<a name="l01093"></a>01093           *parameters[l] += delta_p;
<a name="l01094"></a>01094           this-&gt;assemble_qoi(qoi_indices);
<a name="l01095"></a>01095           this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l01096"></a>01096           this-&gt;rhs-&gt;close();
<a name="l01097"></a>01097           std::vector&lt;Number&gt; partial2q_term = this-&gt;qoi;
<a name="l01098"></a>01098           std::vector&lt;Number&gt; partial2R_term(this-&gt;qoi.size());
<a name="l01099"></a>01099           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01100"></a>01100             <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01101"></a>01101               partial2R_term[i] = this-&gt;rhs-&gt;dot(this-&gt;get_adjoint_solution(i));
<a name="l01102"></a>01102 
<a name="l01103"></a>01103           *parameters[l] -= 2.*delta_p;
<a name="l01104"></a>01104           this-&gt;assemble_qoi(qoi_indices);
<a name="l01105"></a>01105           this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l01106"></a>01106           this-&gt;rhs-&gt;close();
<a name="l01107"></a>01107           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01108"></a>01108             <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01109"></a>01109               {
<a name="l01110"></a>01110                 partial2q_term[i] -= this-&gt;qoi[i];
<a name="l01111"></a>01111                 partial2R_term[i] -= this-&gt;rhs-&gt;dot(this-&gt;get_adjoint_solution(i));
<a name="l01112"></a>01112               }
<a name="l01113"></a>01113 
<a name="l01114"></a>01114           *parameters[k] -= 2.*delta_p;
<a name="l01115"></a>01115           this-&gt;assemble_qoi(qoi_indices);
<a name="l01116"></a>01116           this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l01117"></a>01117           this-&gt;rhs-&gt;close();
<a name="l01118"></a>01118           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01119"></a>01119             <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01120"></a>01120               {
<a name="l01121"></a>01121                 partial2q_term[i] += this-&gt;qoi[i];
<a name="l01122"></a>01122                 partial2R_term[i] += this-&gt;rhs-&gt;dot(this-&gt;get_adjoint_solution(i));
<a name="l01123"></a>01123               }
<a name="l01124"></a>01124 
<a name="l01125"></a>01125           *parameters[l] += 2.*delta_p;
<a name="l01126"></a>01126           this-&gt;assemble_qoi(qoi_indices);
<a name="l01127"></a>01127           this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l01128"></a>01128           this-&gt;rhs-&gt;close();
<a name="l01129"></a>01129           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01130"></a>01130             <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01131"></a>01131               {
<a name="l01132"></a>01132                 partial2q_term[i] -= this-&gt;qoi[i];
<a name="l01133"></a>01133                 partial2R_term[i] -= this-&gt;rhs-&gt;dot(this-&gt;get_adjoint_solution(i));
<a name="l01134"></a>01134                 partial2q_term[i] /= (4. * delta_p * delta_p);
<a name="l01135"></a>01135                 partial2R_term[i] /= (4. * delta_p * delta_p);
<a name="l01136"></a>01136               }
<a name="l01137"></a>01137 
<a name="l01138"></a>01138           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01139"></a>01139             <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01140"></a>01140               {
<a name="l01141"></a>01141                 <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> current_terms = partial2q_term[i] - partial2R_term[i];
<a name="l01142"></a>01142                 sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,k,l) += current_terms;
<a name="l01143"></a>01143                 <span class="keywordflow">if</span> (k != l)
<a name="l01144"></a>01144                   sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,l,k) += current_terms;
<a name="l01145"></a>01145               }
<a name="l01146"></a>01146 
<a name="l01147"></a>01147           <span class="comment">// Don&#39;t leave the parameters perturbed</span>
<a name="l01148"></a>01148           *parameters[l] = old_parameterl;
<a name="l01149"></a>01149           *parameters[k] = old_parameterk;
<a name="l01150"></a>01150         }
<a name="l01151"></a>01151 
<a name="l01152"></a>01152       <span class="comment">// We get (partial q / partial u) and </span>
<a name="l01153"></a>01153       <span class="comment">// (partial R / partial u) from the user, but centrally</span>
<a name="l01154"></a>01154       <span class="comment">// difference to get q_uk and R_uk terms:</span>
<a name="l01155"></a>01155       <span class="comment">// (partial^2 q / partial u partial k)</span>
<a name="l01156"></a>01156       <span class="comment">// q_uk*u&#39;_l = (q_u(p+dp*e_k)*u&#39;_l - q_u(p-dp*e_k)*u&#39;_l)/(2*dp)</span>
<a name="l01157"></a>01157       <span class="comment">// R_uk*z*u&#39;_l = (R_u(p+dp*e_k)*z*u&#39;_l - R_u(p-dp*e_k)*z*u&#39;_l)/(2*dp)</span>
<a name="l01158"></a>01158       <span class="comment">//</span>
<a name="l01159"></a>01159       <span class="comment">// To avoid creating Nq temporary vectors, we add these</span>
<a name="l01160"></a>01160       <span class="comment">// subterms to the sensitivities output one by one.</span>
<a name="l01161"></a>01161       <span class="comment">//</span>
<a name="l01162"></a>01162       <span class="comment">// FIXME: this is probably a bad order of operations for</span>
<a name="l01163"></a>01163       <span class="comment">// controlling floating point error.</span>
<a name="l01164"></a>01164 
<a name="l01165"></a>01165       *parameters[k] = old_parameterk + delta_p;
<a name="l01166"></a>01166       this-&gt;assembly(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l01167"></a>01167       this-&gt;matrix-&gt;close();
<a name="l01168"></a>01168       this-&gt;assemble_qoi_derivative(qoi_indices);
<a name="l01169"></a>01169 
<a name="l01170"></a>01170       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != Np; ++l)
<a name="l01171"></a>01171         {
<a name="l01172"></a>01172           this-&gt;matrix-&gt;vector_mult(*tempvec, this-&gt;get_sensitivity_solution(l));
<a name="l01173"></a>01173           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01174"></a>01174             <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01175"></a>01175               {
<a name="l01176"></a>01176                 this-&gt;get_adjoint_rhs(i).close();
<a name="l01177"></a>01177                 <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> current_terms = 
<a name="l01178"></a>01178                   (this-&gt;get_adjoint_rhs(i).dot(this-&gt;get_sensitivity_solution(l)) -
<a name="l01179"></a>01179                    tempvec-&gt;dot(this-&gt;get_adjoint_solution(i))) / (2.*delta_p);
<a name="l01180"></a>01180                 sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,k,l) += current_terms;
<a name="l01181"></a>01181 
<a name="l01182"></a>01182                 <span class="comment">// We use the _uk terms twice; symmetry lets us reuse</span>
<a name="l01183"></a>01183                 <span class="comment">// these calculations for the _ul terms.</span>
<a name="l01184"></a>01184 
<a name="l01185"></a>01185                 sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,l,k) += current_terms;
<a name="l01186"></a>01186               }
<a name="l01187"></a>01187         }
<a name="l01188"></a>01188  
<a name="l01189"></a>01189       *parameters[k] = old_parameterk - delta_p;
<a name="l01190"></a>01190       this-&gt;assembly(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l01191"></a>01191       this-&gt;matrix-&gt;close();
<a name="l01192"></a>01192       this-&gt;assemble_qoi_derivative(qoi_indices);
<a name="l01193"></a>01193 
<a name="l01194"></a>01194       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != Np; ++l)
<a name="l01195"></a>01195         {
<a name="l01196"></a>01196           this-&gt;matrix-&gt;vector_mult(*tempvec, this-&gt;get_sensitivity_solution(l));
<a name="l01197"></a>01197           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01198"></a>01198             <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01199"></a>01199               {
<a name="l01200"></a>01200                 this-&gt;get_adjoint_rhs(i).close();
<a name="l01201"></a>01201                 <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> current_terms = 
<a name="l01202"></a>01202                   (-this-&gt;get_adjoint_rhs(i).dot(this-&gt;get_sensitivity_solution(l)) +
<a name="l01203"></a>01203                    tempvec-&gt;dot(this-&gt;get_adjoint_solution(i))) / (2.*delta_p);
<a name="l01204"></a>01204                 sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,k,l) += current_terms;
<a name="l01205"></a>01205 
<a name="l01206"></a>01206                 <span class="comment">// We use the _uk terms twice; symmetry lets us reuse</span>
<a name="l01207"></a>01207                 <span class="comment">// these calculations for the _ul terms.</span>
<a name="l01208"></a>01208 
<a name="l01209"></a>01209                 sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,l,k) += current_terms;
<a name="l01210"></a>01210               }
<a name="l01211"></a>01211         }
<a name="l01212"></a>01212 
<a name="l01213"></a>01213       <span class="comment">// Don&#39;t leave the parameter perturbed</span>
<a name="l01214"></a>01214       *parameters[k] = old_parameterk;
<a name="l01215"></a>01215  
<a name="l01216"></a>01216       <span class="comment">// Our last remaining terms are -R_uu(u,z)*u_k*u_l and</span>
<a name="l01217"></a>01217       <span class="comment">// Q_uu(u)*u_k*u_l</span>
<a name="l01218"></a>01218       <span class="comment">//</span>
<a name="l01219"></a>01219       <span class="comment">// We take directional central finite differences of R_u and Q_u</span>
<a name="l01220"></a>01220       <span class="comment">// to approximate these terms, e.g.:</span>
<a name="l01221"></a>01221       <span class="comment">//</span>
<a name="l01222"></a>01222       <span class="comment">// Q_uu(u)*u_k ~= (Q_u(u+dp*u_k) - Q_u(u-dp*u_k))/(2*dp)</span>
<a name="l01223"></a>01223 
<a name="l01224"></a>01224       *this-&gt;solution = this-&gt;get_sensitivity_solution(k);
<a name="l01225"></a>01225       *this-&gt;solution *= delta_p;
<a name="l01226"></a>01226       *this-&gt;solution += *oldsolution;
<a name="l01227"></a>01227       this-&gt;assembly(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l01228"></a>01228       this-&gt;matrix-&gt;close();
<a name="l01229"></a>01229       this-&gt;assemble_qoi_derivative(qoi_indices);
<a name="l01230"></a>01230 
<a name="l01231"></a>01231       <span class="comment">// The Hessian is symmetric, so we just calculate the lower</span>
<a name="l01232"></a>01232       <span class="comment">// triangle and the diagonal, and we get the upper triangle from</span>
<a name="l01233"></a>01233       <span class="comment">// the transpose of the lower</span>
<a name="l01234"></a>01234       <span class="comment">//</span>
<a name="l01235"></a>01235       <span class="comment">// Note that, because we took the directional finite difference</span>
<a name="l01236"></a>01236       <span class="comment">// with respect to k and not l, we&#39;ve added an O(delta_p^2)</span>
<a name="l01237"></a>01237       <span class="comment">// error to any permutational symmetry in the Hessian...</span>
<a name="l01238"></a>01238       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != k+1; ++l)
<a name="l01239"></a>01239         {
<a name="l01240"></a>01240           this-&gt;matrix-&gt;vector_mult(*tempvec, this-&gt;get_sensitivity_solution(l));
<a name="l01241"></a>01241           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01242"></a>01242             <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01243"></a>01243               {
<a name="l01244"></a>01244                 this-&gt;get_adjoint_rhs(i).close();
<a name="l01245"></a>01245                 <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> current_terms =
<a name="l01246"></a>01246                   (this-&gt;get_adjoint_rhs(i).dot(this-&gt;get_sensitivity_solution(l)) -
<a name="l01247"></a>01247                    tempvec-&gt;dot(this-&gt;get_adjoint_solution(i))) / (2.*delta_p);
<a name="l01248"></a>01248                 sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,k,l) += current_terms;
<a name="l01249"></a>01249                 <span class="keywordflow">if</span> (k != l)
<a name="l01250"></a>01250                   sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,l,k) += current_terms;
<a name="l01251"></a>01251               }
<a name="l01252"></a>01252         }
<a name="l01253"></a>01253 
<a name="l01254"></a>01254       *this-&gt;solution = this-&gt;get_sensitivity_solution(k);
<a name="l01255"></a>01255       *this-&gt;solution *= -delta_p;
<a name="l01256"></a>01256       *this-&gt;solution += *oldsolution;
<a name="l01257"></a>01257       this-&gt;assembly(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l01258"></a>01258       this-&gt;matrix-&gt;close();
<a name="l01259"></a>01259       this-&gt;assemble_qoi_derivative(qoi_indices);
<a name="l01260"></a>01260 
<a name="l01261"></a>01261       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l != k+1; ++l)
<a name="l01262"></a>01262         {
<a name="l01263"></a>01263           this-&gt;matrix-&gt;vector_mult(*tempvec, this-&gt;get_sensitivity_solution(l));
<a name="l01264"></a>01264           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != Nq; ++i)
<a name="l01265"></a>01265             <span class="keywordflow">if</span> (qoi_indices.<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l01266"></a>01266               {
<a name="l01267"></a>01267                 this-&gt;get_adjoint_rhs(i).close();
<a name="l01268"></a>01268                 <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> current_terms =
<a name="l01269"></a>01269                   (-this-&gt;get_adjoint_rhs(i).dot(this-&gt;get_sensitivity_solution(l)) +
<a name="l01270"></a>01270                    tempvec-&gt;dot(this-&gt;get_adjoint_solution(i))) / (2.*delta_p);
<a name="l01271"></a>01271                 sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,k,l) += current_terms;
<a name="l01272"></a>01272                 <span class="keywordflow">if</span> (k != l)
<a name="l01273"></a>01273                   sensitivities.<a class="code" href="classlibMesh_1_1SensitivityData.php#ab925e72caace486d14279762d57fb4fe">second_derivative</a>(i,l,k) += current_terms;
<a name="l01274"></a>01274               }
<a name="l01275"></a>01275         }
<a name="l01276"></a>01276 
<a name="l01277"></a>01277       <span class="comment">// Don&#39;t leave the solution perturbed</span>
<a name="l01278"></a>01278       *this-&gt;solution = *oldsolution;
<a name="l01279"></a>01279     }
<a name="l01280"></a>01280 
<a name="l01281"></a>01281   <span class="comment">// All parameters have been reset.</span>
<a name="l01282"></a>01282   <span class="comment">// Don&#39;t leave the qoi or system changed - principle of least</span>
<a name="l01283"></a>01283   <span class="comment">// surprise.</span>
<a name="l01284"></a>01284   this-&gt;assembly(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l01285"></a>01285   this-&gt;rhs-&gt;close();
<a name="l01286"></a>01286   this-&gt;matrix-&gt;close();
<a name="l01287"></a>01287   this-&gt;assemble_qoi(qoi_indices);
<a name="l01288"></a>01288 }
<a name="l01289"></a>01289 
<a name="l01290"></a>01290 
<a name="l01291"></a>01291 
<a name="l01292"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a46cae8e0c970cc71f4d3993432d60e5e">01292</a> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a46cae8e0c970cc71f4d3993432d60e5e">ImplicitSystem::get_linear_solver</a>()<span class="keyword"> const</span>
<a name="l01293"></a>01293 <span class="keyword"></span>{
<a name="l01294"></a>01294   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;::build</a>().release();
<a name="l01295"></a>01295 }
<a name="l01296"></a>01296 
<a name="l01297"></a>01297 
<a name="l01298"></a>01298 
<a name="l01299"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#ab3b6e7ceb320e1cd0f8639780791ba07">01299</a> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ab3b6e7ceb320e1cd0f8639780791ba07">ImplicitSystem::get_linear_solve_parameters</a>()<span class="keyword"> const</span>
<a name="l01300"></a>01300 <span class="keyword"></span>{
<a name="l01301"></a>01301   <span class="keywordflow">return</span> std::make_pair(this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>().parameters.get&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>),
<a name="l01302"></a>01302                         this-&gt;get_equation_systems().parameters.get&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>));
<a name="l01303"></a>01303 }
<a name="l01304"></a>01304 
<a name="l01305"></a>01305 
<a name="l01306"></a>01306 
<a name="l01307"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a43effba7c17eb24695c107560eb65e7d">01307</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a43effba7c17eb24695c107560eb65e7d">ImplicitSystem::release_linear_solver</a>(<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a>* s)<span class="keyword"> const</span>
<a name="l01308"></a>01308 <span class="keyword"></span>{
<a name="l01309"></a>01309   <span class="keyword">delete</span> s;
<a name="l01310"></a>01310 }
<a name="l01311"></a>01311 
<a name="l01312"></a>01312 } <span class="comment">// namespace libMesh</span>
<a name="l01313"></a>01313 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
