<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">implicit_system.h</div>  </div>
</div>
<div class="contents">
<a href="implicit__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: implicit_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __implicit_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __implicit_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="explicit__system_8h.php">explicit_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward declarations</span>
<a name="l00034"></a>00034 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>LinearSolver;
<a name="l00035"></a>00035 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// ImplicitSystem class definition</span>
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php">ExplicitSystem</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a19ff2b6b4dda0d38247de3ccaf5ba573">ImplicitSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00059"></a>00059                   <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00060"></a>00060                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa16e13af7c0b247e73837670454fdafb">~ImplicitSystem</a> ();
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a406212377d5da333147066aa9ae2444f">00070</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a406212377d5da333147066aa9ae2444f">sys_type</a>;
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a4c5fd2988d63965f621c0952304d7ff1">00075</a>   <a class="code" href="classlibMesh_1_1ExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a4c5fd2988d63965f621c0952304d7ff1">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a6521d0c53d25a076eebe302b17520000">00080</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1ExplicitSystem.php">ExplicitSystem</a> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a6521d0c53d25a076eebe302b17520000">Parent</a>;
<a name="l00081"></a>00081   
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a8ec1dbe98f37b3fa50d87292e5b46827">clear</a> ();
<a name="l00087"></a>00087 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a766e6bac5c51ef16b7ddc4f62933b309">reinit</a> ();
<a name="l00093"></a>00093    
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a80ddae9bd83e9ec2f76ee57f5fdfb6e3">assemble</a> ();
<a name="l00100"></a>00100  
<a name="l00101"></a>00101 <span class="comment">//   /**</span>
<a name="l00102"></a>00102 <span class="comment">//    * Assembles &amp; solves the linear system Ax=b. </span>
<a name="l00103"></a>00103 <span class="comment">//    */</span>
<a name="l00104"></a>00104 <span class="comment">//   virtual void solve ();</span>
<a name="l00105"></a>00105  
<a name="l00110"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#ac4f96d2c7ed162eb7d5c4e4bf3653015">00110</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ac4f96d2c7ed162eb7d5c4e4bf3653015">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;Implicit&quot;</span>; }
<a name="l00111"></a>00111 
<a name="l00120"></a>00120   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a46cae8e0c970cc71f4d3993432d60e5e">get_linear_solver</a>() <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00128"></a>00128     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ab3b6e7ceb320e1cd0f8639780791ba07">get_linear_solve_parameters</a>() <span class="keyword">const</span>;
<a name="l00129"></a>00129 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a43effba7c17eb24695c107560eb65e7d">release_linear_solver</a>(<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a> *) <span class="keyword">const</span>;
<a name="l00135"></a>00135 
<a name="l00143"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">00143</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keywordtype">bool</span> <span class="comment">/* get_residual */</span> , <span class="keywordtype">bool</span> <span class="comment">/* get_jacobian */</span>)
<a name="l00144"></a>00144     { libmesh_error(); }
<a name="l00145"></a>00145 
<a name="l00157"></a>00157   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a1f8552a617eabf208f2b99768312ec52">assemble_residual_derivatives</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters);
<a name="l00158"></a>00158 
<a name="l00166"></a>00166   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00167"></a>00167     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ae22b3e55e993d74a2e8a70091d5cc044">sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters);
<a name="l00168"></a>00168  
<a name="l00177"></a>00177   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00178"></a>00178     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ae8d212c3ba251d39d4d177e4ef9698cc">weighted_sensitivity_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00179"></a>00179                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; weights);
<a name="l00180"></a>00180  
<a name="l00190"></a>00190   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00191"></a>00191     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#abe4a5375e0680ab8c0048b2e3e361808">adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00192"></a>00192  
<a name="l00205"></a>00205   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00206"></a>00206     <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a86af1dcc71b17ddec43f0e9fe67f353f">weighted_sensitivity_adjoint_solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00207"></a>00207                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; weights,
<a name="l00208"></a>00208                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices = <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>());
<a name="l00209"></a>00209  
<a name="l00221"></a>00221   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a4f8bc3fa7c7f75d914128e0ecd1913ee">adjoint_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00222"></a>00222                                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00223"></a>00223                                                   <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities);
<a name="l00224"></a>00224 
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a49c08585cd11fe4c44ef0471329f1c28">forward_qoi_parameter_sensitivity</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00237"></a>00237                                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00238"></a>00238                                                   <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; sensitivities);
<a name="l00239"></a>00239   
<a name="l00248"></a>00248   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aafb0adb90523c2de5d88d5ba221134bc">qoi_parameter_hessian</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00249"></a>00249                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00250"></a>00250                                      <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; hessian);
<a name="l00251"></a>00251 
<a name="l00262"></a>00262   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aad2b6410e29f55ea4f43d7625603eef4">qoi_parameter_hessian_vector_product</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>&amp; qoi_indices,
<a name="l00263"></a>00263                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; parameters,
<a name="l00264"></a>00264                                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; <a class="code" href="classstd_1_1vector.php">vector</a>,
<a name="l00265"></a>00265                                                     <a class="code" href="classlibMesh_1_1SensitivityData.php">SensitivityData</a>&amp; product);
<a name="l00266"></a>00266   
<a name="l00270"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a3150e0ee9d3f20276efea1e3690fe395">00270</a>   <span class="keyword">typedef</span> std::map&lt;std::string, SparseMatrix&lt;Number&gt;* &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>        <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a3150e0ee9d3f20276efea1e3690fe395">matrices_iterator</a>;
<a name="l00271"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a5d3fb82b3496fecd5c502504cf6ed2f0">00271</a>   <span class="keyword">typedef</span> std::map&lt;std::string, SparseMatrix&lt;Number&gt;* &gt;::const_iterator  <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a5d3fb82b3496fecd5c502504cf6ed2f0">const_matrices_iterator</a>;
<a name="l00272"></a>00272 
<a name="l00281"></a>00281   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a03484ff4590b6971c650b4cfb2196f85">add_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name);
<a name="l00282"></a>00282 
<a name="l00287"></a>00287   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ad1f70d2478811263532c49cb9f4a77e2">have_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name) <span class="keyword">const</span>;
<a name="l00288"></a>00288 
<a name="l00294"></a>00294   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0f497ae21ddc216ca57b4cbdb7429f67">request_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name) <span class="keyword">const</span>;
<a name="l00295"></a>00295 
<a name="l00301"></a>00301   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0f497ae21ddc216ca57b4cbdb7429f67">request_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name);
<a name="l00302"></a>00302 
<a name="l00309"></a>00309   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name) <span class="keyword">const</span>;
<a name="l00310"></a>00310 
<a name="l00317"></a>00317   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; <a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name);
<a name="l00318"></a>00318 
<a name="l00322"></a>00322   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a317b16eefd799e5cf373d0a47cb073ce">n_matrices</a> () <span class="keyword">const</span>;
<a name="l00323"></a>00323   
<a name="l00329"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">00329</a>   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> * <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>;
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   
<a name="l00333"></a>00333 <span class="keyword">protected</span>:
<a name="l00334"></a>00334   
<a name="l00339"></a>00339   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ada6846f6432bb259d4cd0a83abdc567a">init_data</a> ();
<a name="l00340"></a>00340   
<a name="l00344"></a>00344   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#adfdda300feb69430db51a50f3a002c04">init_matrices</a> ();
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   
<a name="l00348"></a>00348 <span class="keyword">private</span>:
<a name="l00349"></a>00349 
<a name="l00354"></a>00354   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0b0463b54037a4500827848d2bb30901">add_system_matrix</a> ();
<a name="l00355"></a>00355 
<a name="l00359"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">00359</a>   std::map&lt;std::string, SparseMatrix&lt;Number&gt;* &gt; <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>;
<a name="l00360"></a>00360 
<a name="l00364"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#af7129ede5be4b9b84beced9abdfc4e6c">00364</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#af7129ede5be4b9b84beced9abdfc4e6c">_can_add_matrices</a>;
<a name="l00365"></a>00365 };
<a name="l00366"></a>00366 
<a name="l00367"></a>00367 
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00370"></a>00370 <span class="comment">// ImplicitSystem inline methods</span>
<a name="l00371"></a>00371 <span class="keyword">inline</span>
<a name="l00372"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#ad1f70d2478811263532c49cb9f4a77e2">00372</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#ad1f70d2478811263532c49cb9f4a77e2">ImplicitSystem::have_matrix</a> (<span class="keyword">const</span> std::string&amp; mat_name)<span class="keyword"> const</span>
<a name="l00373"></a>00373 <span class="keyword"></span>{
<a name="l00374"></a>00374   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.count(mat_name));
<a name="l00375"></a>00375 }
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 <span class="keyword">inline</span>
<a name="l00379"></a><a class="code" href="classlibMesh_1_1ImplicitSystem.php#a317b16eefd799e5cf373d0a47cb073ce">00379</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a317b16eefd799e5cf373d0a47cb073ce">ImplicitSystem::n_matrices</a> ()<span class="keyword"> const</span>
<a name="l00380"></a>00380 <span class="keyword"></span>{
<a name="l00381"></a>00381  <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php#afa4acc9c1b50b664e45ec16ad1853a45">_matrices</a>.size(); 
<a name="l00382"></a>00382 }
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 } <span class="comment">// namespace libMesh</span>
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
