<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_elem_builder.C</div>  </div>
</div>
<div class="contents">
<a href="inf__elem__builder_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_elem_builder.C 4248 2011-03-11 23:41:21Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="inf__elem__builder_8h.php">inf_elem_builder.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad4_8h.php">face_inf_quad4.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="face__inf__quad6_8h.php">face_inf_quad6.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__prism6_8h.php">cell_inf_prism6.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__prism12_8h.php">cell_inf_prism12.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex8_8h.php">cell_inf_hex8.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex16_8h.php">cell_inf_hex16.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="cell__inf__hex18_8h.php">cell_inf_hex18.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span>
<a name="l00043"></a>00043 <span class="keyword">namespace </span>libMesh
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">00046</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">InfElemBuilder::build_inf_elem</a>(<span class="keywordtype">bool</span> be_verbose)
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="comment">// determine origin automatically,</span>
<a name="l00049"></a>00049   <span class="comment">// works only if the mesh has no symmetry planes.</span>
<a name="l00050"></a>00050   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> b_box = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">MeshTools::bounding_box</a>(<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>);
<a name="l00051"></a>00051   <a class="code" href="classlibMesh_1_1Point.php">Point</a> origin = (b_box.first + b_box.second) / 2;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="keywordflow">if</span> (be_verbose &amp;&amp; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00054"></a>00054     {
<a name="l00055"></a>00055 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>      <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; Determined origin for Infinite Elements:&quot;</span> 
<a name="l00057"></a>00057                     &lt;&lt; std::endl
<a name="l00058"></a>00058                     &lt;&lt; <span class="stringliteral">&quot;  &quot;</span>;
<a name="l00059"></a>00059       origin.<a class="code" href="classlibMesh_1_1TypeVector.php#ab06b207d152da2cdc8dbf147f01b97cf">write_unformatted</a>(<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>);
<a name="l00060"></a>00060       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00061"></a>00061 <span class="preprocessor">#endif</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>    }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">// Call the protected implementation function with the</span>
<a name="l00065"></a>00065   <span class="comment">// automatically determined origin.</span>
<a name="l00066"></a>00066   this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">build_inf_elem</a>(origin, <span class="keyword">false</span>, <span class="keyword">false</span>, <span class="keyword">false</span>, be_verbose);
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   <span class="comment">// when finished with building the Ifems,</span>
<a name="l00069"></a>00069   <span class="comment">// it remains to prepare the mesh for use:</span>
<a name="l00070"></a>00070   <span class="comment">// find neighbors (again), partition (if needed)...</span>
<a name="l00071"></a>00071   this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a> (<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="keywordflow">return</span> origin;
<a name="l00074"></a>00074 }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1InfElemBuilder.php#a5a9710ace8b0c5516816d78060bc403a">00087</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">InfElemBuilder::build_inf_elem</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#acf45bfe5ace01174cb8acfb54328a367">InfElemOriginValue</a>&amp; origin_x,
<a name="l00088"></a>00088                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#acf45bfe5ace01174cb8acfb54328a367">InfElemOriginValue</a>&amp; origin_y,
<a name="l00089"></a>00089                                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#acf45bfe5ace01174cb8acfb54328a367">InfElemOriginValue</a>&amp; origin_z,
<a name="l00090"></a>00090                                             <span class="keyword">const</span> <span class="keywordtype">bool</span> x_sym,
<a name="l00091"></a>00091                                             <span class="keyword">const</span> <span class="keywordtype">bool</span> y_sym,
<a name="l00092"></a>00092                                             <span class="keyword">const</span> <span class="keywordtype">bool</span> z_sym,
<a name="l00093"></a>00093                                             <span class="keyword">const</span> <span class="keywordtype">bool</span> be_verbose,
<a name="l00094"></a>00094                                             std::vector&lt;const Node*&gt;* inner_boundary_nodes)
<a name="l00095"></a>00095 {
<a name="l00096"></a>00096   START_LOG(<span class="stringliteral">&quot;build_inf_elem()&quot;</span>, <span class="stringliteral">&quot;InfElemBuilder&quot;</span>);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="comment">// first determine the origin of the </span>
<a name="l00099"></a>00099   <span class="comment">// infinite elements.  For this, the</span>
<a name="l00100"></a>00100   <span class="comment">// origin defaults to the given values,</span>
<a name="l00101"></a>00101   <span class="comment">// and may be overridden when the user</span>
<a name="l00102"></a>00102   <span class="comment">// provided values</span>
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1Point.php">Point</a> origin(origin_x.second, origin_y.second, origin_z.second);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">// when only _one_ of the origin coordinates is _not_</span>
<a name="l00106"></a>00106   <span class="comment">// given, we have to determine it on our own</span>
<a name="l00107"></a>00107   <span class="keywordflow">if</span> ( !origin_x.first || !origin_y.first || !origin_z.first)
<a name="l00108"></a>00108     {
<a name="l00109"></a>00109       <span class="comment">// determine origin</span>
<a name="l00110"></a>00110       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> b_box = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">MeshTools::bounding_box</a>(<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>);
<a name="l00111"></a>00111       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> auto_origin = (b_box.first+b_box.second)/2;
<a name="l00112"></a>00112 
<a name="l00113"></a>00113       <span class="comment">// override default values, if necessary</span>
<a name="l00114"></a>00114       <span class="keywordflow">if</span> (!origin_x.first)
<a name="l00115"></a>00115           origin(0) = auto_origin(0);
<a name="l00116"></a>00116       <span class="keywordflow">if</span> (!origin_y.first)
<a name="l00117"></a>00117           origin(1) = auto_origin(1);
<a name="l00118"></a>00118       <span class="keywordflow">if</span> (!origin_z.first)
<a name="l00119"></a>00119           origin(2) = auto_origin(2);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121       <span class="keywordflow">if</span> (be_verbose)
<a name="l00122"></a>00122         {
<a name="l00123"></a>00123           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; Origin for Infinite Elements:&quot;</span> &lt;&lt; std::endl;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125           <span class="keywordflow">if</span> (!origin_x.first)
<a name="l00126"></a>00126               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  determined x-coordinate&quot;</span> &lt;&lt; std::endl;
<a name="l00127"></a>00127           <span class="keywordflow">if</span> (!origin_y.first)
<a name="l00128"></a>00128               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  determined y-coordinate&quot;</span> &lt;&lt; std::endl;
<a name="l00129"></a>00129           <span class="keywordflow">if</span> (!origin_z.first)
<a name="l00130"></a>00130               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  determined z-coordinate&quot;</span> &lt;&lt; std::endl;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  coordinates: &quot;</span>;
<a name="l00133"></a>00133           origin.<a class="code" href="classlibMesh_1_1TypeVector.php#ab06b207d152da2cdc8dbf147f01b97cf">write_unformatted</a>(<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>);
<a name="l00134"></a>00134           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00135"></a>00135         }
<a name="l00136"></a>00136     }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (be_verbose)
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     {
<a name="l00141"></a>00141       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; Origin for Infinite Elements:&quot;</span> &lt;&lt; std::endl;
<a name="l00142"></a>00142       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  coordinates: &quot;</span>;
<a name="l00143"></a>00143       origin.<a class="code" href="classlibMesh_1_1TypeVector.php#ab06b207d152da2cdc8dbf147f01b97cf">write_unformatted</a>(<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>);
<a name="l00144"></a>00144       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00145"></a>00145     }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="comment">// Now that we have the origin, check if the user provided an \p</span>
<a name="l00150"></a>00150   <span class="comment">// inner_boundary_nodes.  If so, we pass a std::set to the actual</span>
<a name="l00151"></a>00151   <span class="comment">// implementation of the build_inf_elem(), so that we can convert</span>
<a name="l00152"></a>00152   <span class="comment">// this to the Node* vector</span>
<a name="l00153"></a>00153   <span class="keywordflow">if</span> (inner_boundary_nodes != NULL)
<a name="l00154"></a>00154     {
<a name="l00155"></a>00155       <span class="comment">// note that the std::set that we will get</span>
<a name="l00156"></a>00156       <span class="comment">// from build_inf_elem() uses the index of</span>
<a name="l00157"></a>00157       <span class="comment">// the element in this-&gt;_elements vector,</span>
<a name="l00158"></a>00158       <span class="comment">// and the second entry is the side index</span>
<a name="l00159"></a>00159       <span class="comment">// for this element.  Therefore, we do _not_</span>
<a name="l00160"></a>00160       <span class="comment">// need to renumber nodes and elements</span>
<a name="l00161"></a>00161       <span class="comment">// prior to building the infinite elements.</span>
<a name="l00162"></a>00162       <span class="comment">//</span>
<a name="l00163"></a>00163       <span class="comment">// However, note that this method here uses</span>
<a name="l00164"></a>00164       <span class="comment">// node id&#39;s... Do we need to renumber?</span>
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167       <span class="comment">// Form the list of faces of elements which finally</span>
<a name="l00168"></a>00168       <span class="comment">// will tell us which nodes should receive boundary</span>
<a name="l00169"></a>00169       <span class="comment">// conditions (to form the std::vector&lt;const Node*&gt;)</span>
<a name="l00170"></a>00170       std::set&lt; std::pair&lt;<span class="keywordtype">unsigned</span> int,
<a name="l00171"></a>00171                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; &gt; inner_faces;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174       <span class="comment">// build infinite elements</span>
<a name="l00175"></a>00175       this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">build_inf_elem</a>(origin, 
<a name="l00176"></a>00176                            x_sym, y_sym, z_sym, 
<a name="l00177"></a>00177                            be_verbose,
<a name="l00178"></a>00178                            &amp;inner_faces);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180       <span class="keywordflow">if</span> (be_verbose)
<a name="l00181"></a>00181         {
<a name="l00182"></a>00182           this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a94180309af3081c9da2a0064e66040e6">print_info</a>();
<a name="l00183"></a>00183           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Data pre-processing:&quot;</span> &lt;&lt; std::endl
<a name="l00184"></a>00184                         &lt;&lt; <span class="stringliteral">&quot; convert the &lt;int,int&gt; list to a Node* list...&quot;</span>
<a name="l00185"></a>00185                         &lt;&lt; std::endl;
<a name="l00186"></a>00186         }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188       <span class="comment">// First use a std::vector&lt;unsigned int&gt; that holds</span>
<a name="l00189"></a>00189       <span class="comment">// the global node numbers.  Then sort this vector,</span>
<a name="l00190"></a>00190       <span class="comment">// so that it can be made unique (no multiple occurence</span>
<a name="l00191"></a>00191       <span class="comment">// of a node), and then finally insert the Node* in</span>
<a name="l00192"></a>00192       <span class="comment">// the vector inner_boundary_nodes.</span>
<a name="l00193"></a>00193       <span class="comment">//</span>
<a name="l00194"></a>00194       <span class="comment">// Reserve memory for the vector&lt;unsigned int&gt; with </span>
<a name="l00195"></a>00195       <span class="comment">// 4 times the size of the number of elements in the </span>
<a name="l00196"></a>00196       <span class="comment">// std::set. This is a good bet for Quad4 face elements.  </span>
<a name="l00197"></a>00197       <span class="comment">// For higher-order elements, this probably _has_ to lead</span>
<a name="l00198"></a>00198       <span class="comment">// to additional allocations...</span>
<a name="l00199"></a>00199       <span class="comment">// Practice has to show how this affects performance.</span>
<a name="l00200"></a>00200       std::vector&lt;unsigned int&gt; inner_boundary_node_numbers;
<a name="l00201"></a>00201       inner_boundary_node_numbers.reserve(4*inner_faces.size());
<a name="l00202"></a>00202 
<a name="l00203"></a>00203       <span class="comment">// Now transform the set of pairs to a list of (possibly</span>
<a name="l00204"></a>00204       <span class="comment">// duplicate) global node numbers.</span>
<a name="l00205"></a>00205       std::set&lt; std::pair&lt;unsigned int,unsigned int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> face_it = inner_faces.begin();
<a name="l00206"></a>00206       <span class="keyword">const</span> std::set&lt; std::pair&lt;unsigned int,unsigned int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> face_end = inner_faces.end();
<a name="l00207"></a>00207       <span class="keywordflow">for</span>(; face_it!=face_end; ++face_it)
<a name="l00208"></a>00208         {
<a name="l00209"></a>00209           std::pair&lt;unsigned int,unsigned int&gt; p = *face_it;
<a name="l00210"></a>00210         
<a name="l00211"></a>00211           <span class="comment">// build a full-ordered side element to get _all_ the base nodes</span>
<a name="l00212"></a>00212           <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>( this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(p.first)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(p.second) ); 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214           <span class="comment">// insert all the node numbers in inner_boundary_node_numbers</span>
<a name="l00215"></a>00215           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt; <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_nodes(); n++)
<a name="l00216"></a>00216               inner_boundary_node_numbers.push_back(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(n));
<a name="l00217"></a>00217         }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220       <span class="comment">// inner_boundary_node_numbers now still holds multiple entries of</span>
<a name="l00221"></a>00221       <span class="comment">// node numbers.  So first sort, then unique the vector.</span>
<a name="l00222"></a>00222       <span class="comment">// Note that \p std::unique only puts the new ones in</span>
<a name="l00223"></a>00223       <span class="comment">// front, while to leftovers are @e not deleted.  Instead,</span>
<a name="l00224"></a>00224       <span class="comment">// it returns a pointer to the end of the unique range.</span>
<a name="l00225"></a>00225       <span class="comment">//TODO:[BSK] int_ibn_size_before is not the same type as unique_size!</span>
<a name="l00226"></a>00226       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ibn_size_before = inner_boundary_node_numbers.size();
<a name="l00227"></a>00227       std::sort (inner_boundary_node_numbers.begin(), inner_boundary_node_numbers.end());
<a name="l00228"></a>00228       std::vector&lt;unsigned int&gt;::iterator unique_end = 
<a name="l00229"></a>00229           std::unique (inner_boundary_node_numbers.begin(), inner_boundary_node_numbers.end());
<a name="l00230"></a>00230 
<a name="l00231"></a>00231       <span class="keyword">const</span> <span class="keywordtype">int</span> unique_size = std::distance(inner_boundary_node_numbers.begin(), unique_end);
<a name="l00232"></a>00232       libmesh_assert (unique_size &lt;= static_cast&lt;int&gt;(ibn_size_before));
<a name="l00233"></a>00233 
<a name="l00234"></a>00234       <span class="comment">// Finally, create const Node* in the inner_boundary_nodes</span>
<a name="l00235"></a>00235       <span class="comment">// vector.  Reserve, not resize (otherwise, the push_back</span>
<a name="l00236"></a>00236       <span class="comment">// would append the interesting nodes, while NULL-nodes</span>
<a name="l00237"></a>00237       <span class="comment">// live in the resize&#39;d area...</span>
<a name="l00238"></a>00238       inner_boundary_nodes-&gt;reserve (unique_size);
<a name="l00239"></a>00239       inner_boundary_nodes-&gt;clear();
<a name="l00240"></a>00240 
<a name="l00241"></a>00241 
<a name="l00242"></a>00242       std::vector&lt;unsigned int&gt;::iterator pos_it = inner_boundary_node_numbers.begin();
<a name="l00243"></a>00243       <span class="keywordflow">for</span> (; pos_it != unique_end; ++pos_it)
<a name="l00244"></a>00244         {
<a name="l00245"></a>00245           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; node = this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(*pos_it);
<a name="l00246"></a>00246           inner_boundary_nodes-&gt;push_back(&amp;node);
<a name="l00247"></a>00247         }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249       <span class="keywordflow">if</span> (be_verbose)
<a name="l00250"></a>00250           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  finished identifying &quot;</span> &lt;&lt; unique_size 
<a name="l00251"></a>00251                         &lt;&lt; <span class="stringliteral">&quot; target nodes.&quot;</span> &lt;&lt; std::endl;  
<a name="l00252"></a>00252     }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="keywordflow">else</span>
<a name="l00255"></a>00255 
<a name="l00256"></a>00256     {
<a name="l00257"></a>00257       <span class="comment">// There are no inner boundary nodes, so simply build the infinite elements</span>
<a name="l00258"></a>00258       this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">build_inf_elem</a>(origin, x_sym, y_sym, z_sym, be_verbose);
<a name="l00259"></a>00259     }
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   STOP_LOG(<span class="stringliteral">&quot;build_inf_elem()&quot;</span>, <span class="stringliteral">&quot;InfElemBuilder&quot;</span>);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="comment">// when finished with building the Ifems,</span>
<a name="l00265"></a>00265   <span class="comment">// it remains to prepare the mesh for use:</span>
<a name="l00266"></a>00266   <span class="comment">// find neighbors again, partition (if needed)...</span>
<a name="l00267"></a>00267   this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a> (<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="keywordflow">return</span> origin;
<a name="l00270"></a>00270 }
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="comment">// The actual implementation of building elements.</span>
<a name="l00281"></a><a class="code" href="classlibMesh_1_1InfElemBuilder.php#a703ed74e1de58ff4e9ce02f0ef73baed">00281</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">InfElemBuilder::build_inf_elem</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; origin, 
<a name="l00282"></a>00282                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> x_sym, 
<a name="l00283"></a>00283                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> y_sym, 
<a name="l00284"></a>00284                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> z_sym,
<a name="l00285"></a>00285                                     <span class="keyword">const</span> <span class="keywordtype">bool</span> be_verbose,
<a name="l00286"></a>00286                                     std::set&lt; std::pair&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00287"></a>00287                                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; &gt;* inner_faces)
<a name="l00288"></a>00288 {
<a name="l00289"></a>00289   <span class="keywordflow">if</span> (be_verbose)
<a name="l00290"></a>00290     {
<a name="l00291"></a>00291 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00292"></a>00292 <span class="preprocessor"></span>      <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; Building Infinite Elements:&quot;</span> &lt;&lt; std::endl;
<a name="l00293"></a>00293       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  updating element neighbor tables...&quot;</span> &lt;&lt; std::endl;
<a name="l00294"></a>00294 <span class="preprocessor">#else</span>
<a name="l00295"></a>00295 <span class="preprocessor"></span>      <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; Verbose mode disabled in non-debug mode.&quot;</span> &lt;&lt; std::endl;
<a name="l00296"></a>00296 <span class="preprocessor">#endif</span>
<a name="l00297"></a>00297 <span class="preprocessor"></span>    }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   <span class="comment">// update element neighbors</span>
<a name="l00301"></a>00301   this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a7edb2ad9b032287e750880883cdcf0f3">find_neighbors</a>(); 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   START_LOG(<span class="stringliteral">&quot;build_inf_elem()&quot;</span>, <span class="stringliteral">&quot;InfElemBuilder&quot;</span>);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="comment">// A set for storing element number, side number pairs.</span>
<a name="l00306"></a>00306   <span class="comment">// pair.first == element number, pair.second == side number</span>
<a name="l00307"></a>00307   std::set&lt; std::pair&lt;unsigned int,unsigned int&gt; &gt; faces;
<a name="l00308"></a>00308   std::set&lt; std::pair&lt;unsigned int,unsigned int&gt; &gt; ofaces;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="comment">// A set for storing node numbers on the outer faces.</span>
<a name="l00311"></a>00311   std::set&lt;unsigned int&gt; onodes;
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   <span class="comment">// The distance to the farthest point in the mesh from the origin</span>
<a name="l00314"></a>00314   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> max_r=0.;
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <span class="comment">// The index of the farthest point in the mesh from the origin</span>
<a name="l00317"></a>00317   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_r_node;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00320"></a>00320 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (be_verbose)
<a name="l00321"></a>00321     {
<a name="l00322"></a>00322       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  collecting boundary sides&quot;</span>;
<a name="l00323"></a>00323       <span class="keywordflow">if</span> (x_sym || y_sym || z_sym)
<a name="l00324"></a>00324         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;, skipping sides in symmetry planes...&quot;</span> &lt;&lt; std::endl;
<a name="l00325"></a>00325       <span class="keywordflow">else</span>
<a name="l00326"></a>00326         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;...&quot;</span> &lt;&lt; std::endl;
<a name="l00327"></a>00327     }
<a name="l00328"></a>00328 <span class="preprocessor">#endif</span>
<a name="l00329"></a>00329 <span class="preprocessor"></span>
<a name="l00330"></a>00330   <span class="comment">// Iterate through all elements and sides, collect indices of all active</span>
<a name="l00331"></a>00331   <span class="comment">// boundary sides in the faces set. Skip sides which lie in symmetry planes.</span>
<a name="l00332"></a>00332   <span class="comment">// Later, sides of the inner boundary will be sorted out.</span>
<a name="l00333"></a>00333   {
<a name="l00334"></a>00334     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00335"></a>00335     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00336"></a>00336   
<a name="l00337"></a>00337     <span class="keywordflow">for</span>(; it != end; ++it)
<a name="l00338"></a>00338       {
<a name="l00339"></a>00339         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00340"></a>00340         
<a name="l00341"></a>00341         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); s++)
<a name="l00342"></a>00342           {
<a name="l00343"></a>00343             <span class="comment">// check if elem(e) is on the boundary</span>
<a name="l00344"></a>00344             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l00345"></a>00345               {
<a name="l00346"></a>00346                 <span class="comment">// note that it is safe to use the Elem::side() method, </span>
<a name="l00347"></a>00347                 <span class="comment">// which gives a non-full-ordered element </span>
<a name="l00348"></a>00348                 <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00349"></a>00349 
<a name="l00350"></a>00350                 <span class="comment">// bool flags for symmetry detection</span>
<a name="l00351"></a>00351                 <span class="keywordtype">bool</span> sym_side=<span class="keyword">false</span>;            
<a name="l00352"></a>00352                 <span class="keywordtype">bool</span> on_x_sym=<span class="keyword">true</span>;
<a name="l00353"></a>00353                 <span class="keywordtype">bool</span> on_y_sym=<span class="keyword">true</span>;
<a name="l00354"></a>00354                 <span class="keywordtype">bool</span> on_z_sym=<span class="keyword">true</span>;
<a name="l00355"></a>00355                 
<a name="l00356"></a>00356                 
<a name="l00357"></a>00357                 <span class="comment">// Loop over the nodes to check whether they are on the symmetry planes,</span>
<a name="l00358"></a>00358                 <span class="comment">// and therefore sufficient to use a non-full-ordered side element</span>
<a name="l00359"></a>00359                 <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_nodes(); n++)
<a name="l00360"></a>00360                   {
<a name="l00361"></a>00361                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> dist_from_origin = this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(n)) - origin;
<a name="l00362"></a>00362 
<a name="l00363"></a>00363                     <span class="keywordflow">if</span>(x_sym)
<a name="l00364"></a>00364                       <span class="keywordflow">if</span>( std::abs(dist_from_origin(0)) &gt; 1.e-3 )
<a name="l00365"></a>00365                         on_x_sym=<span class="keyword">false</span>;
<a name="l00366"></a>00366 
<a name="l00367"></a>00367                     <span class="keywordflow">if</span>(y_sym)
<a name="l00368"></a>00368                       <span class="keywordflow">if</span>( std::abs(dist_from_origin(1)) &gt; 1.e-3 )
<a name="l00369"></a>00369                         on_y_sym=<span class="keyword">false</span>;
<a name="l00370"></a>00370 
<a name="l00371"></a>00371                     <span class="keywordflow">if</span>(z_sym)
<a name="l00372"></a>00372                       <span class="keywordflow">if</span>( std::abs(dist_from_origin(2)) &gt; 1.e-3 )
<a name="l00373"></a>00373                         on_z_sym=<span class="keyword">false</span>;
<a name="l00374"></a>00374               
<a name="l00375"></a>00375                     <span class="comment">//        if(x_sym)</span>
<a name="l00376"></a>00376                     <span class="comment">//          if( std::abs(dist_from_origin(0)) &gt; 1.e-6 )</span>
<a name="l00377"></a>00377                     <span class="comment">//            on_x_sym=false;</span>
<a name="l00378"></a>00378 
<a name="l00379"></a>00379                     <span class="comment">//        if(y_sym)</span>
<a name="l00380"></a>00380                     <span class="comment">//          if( std::abs(dist_from_origin(1)) &gt; 1.e-6 )</span>
<a name="l00381"></a>00381                     <span class="comment">//            on_y_sym=false;</span>
<a name="l00382"></a>00382 
<a name="l00383"></a>00383                     <span class="comment">//        if(z_sym)</span>
<a name="l00384"></a>00384                     <span class="comment">//          if( std::abs(dist_from_origin(2)) &gt; 1.e-6 )</span>
<a name="l00385"></a>00385                     <span class="comment">//            on_z_sym=false;</span>
<a name="l00386"></a>00386 
<a name="l00387"></a>00387                     <span class="comment">//find the node most distant from origin</span>
<a name="l00388"></a>00388               
<a name="l00389"></a>00389                     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r = dist_from_origin.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>();
<a name="l00390"></a>00390                     <span class="keywordflow">if</span> (r &gt; max_r)
<a name="l00391"></a>00391                       {
<a name="l00392"></a>00392                         max_r = r;
<a name="l00393"></a>00393                         max_r_node=<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(n);
<a name="l00394"></a>00394                       }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396                   }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398                 sym_side = (x_sym &amp;&amp; on_x_sym) || (y_sym &amp;&amp; on_y_sym) || (z_sym &amp;&amp; on_z_sym);
<a name="l00399"></a>00399                                 
<a name="l00400"></a>00400                 <span class="keywordflow">if</span> (!sym_side)
<a name="l00401"></a>00401                   faces.insert( std::make_pair(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>(), s) );                                        
<a name="l00402"></a>00402                                             
<a name="l00403"></a>00403               } <span class="comment">// neighbor(s) == NULL</span>
<a name="l00404"></a>00404           } <span class="comment">// sides</span>
<a name="l00405"></a>00405       } <span class="comment">// elems</span>
<a name="l00406"></a>00406   }
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   
<a name="l00411"></a>00411                         
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="comment">//  If a boundary side has one node on the outer boundary,</span>
<a name="l00414"></a>00414   <span class="comment">//  all points of this side are on the outer boundary.</span>
<a name="l00415"></a>00415   <span class="comment">//  Start with the node most distant from origin, which has</span>
<a name="l00416"></a>00416   <span class="comment">//  to be on the outer boundary, then recursively find all</span>
<a name="l00417"></a>00417   <span class="comment">//  sides and nodes connected to it. Found sides are moved</span>
<a name="l00418"></a>00418   <span class="comment">//  from faces to ofaces, nodes are collected in onodes.  </span>
<a name="l00419"></a>00419   <span class="comment">//  Here, the search is done iteratively, because, depending on</span>
<a name="l00420"></a>00420   <span class="comment">//  the mesh, a very high level of recursion might be necessary.</span>
<a name="l00421"></a>00421   onodes.insert(max_r_node);    
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a>00424   {
<a name="l00425"></a>00425     std::set&lt; std::pair&lt;unsigned int,unsigned int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> face_it = faces.begin();
<a name="l00426"></a>00426     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> facesfound=0;
<a name="l00427"></a>00427     <span class="keywordflow">do</span> {
<a name="l00428"></a>00428                         
<a name="l00429"></a>00429       std::pair&lt;unsigned int, unsigned int&gt; p;
<a name="l00430"></a>00430       p = *face_it;
<a name="l00431"></a>00431 
<a name="l00432"></a>00432       <span class="comment">// This has to be a full-ordered side element,</span>
<a name="l00433"></a>00433       <span class="comment">// since we need the correct n_nodes,</span>
<a name="l00434"></a>00434       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(p.first)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(p.second));
<a name="l00435"></a>00435                 
<a name="l00436"></a>00436       <span class="keywordtype">bool</span> found=<span class="keyword">false</span>;
<a name="l00437"></a>00437       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sn=0; sn&lt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_nodes(); sn++)
<a name="l00438"></a>00438         <span class="keywordflow">if</span>(onodes.count(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(sn)))
<a name="l00439"></a>00439           {
<a name="l00440"></a>00440             found=<span class="keyword">true</span>;
<a name="l00441"></a>00441             <span class="keywordflow">break</span>;
<a name="l00442"></a>00442           }
<a name="l00443"></a>00443         
<a name="l00444"></a>00444         
<a name="l00445"></a>00445       <span class="comment">// If a new oface is found, include its nodes in onodes</span>
<a name="l00446"></a>00446       <span class="keywordflow">if</span>(found)         
<a name="l00447"></a>00447         {
<a name="l00448"></a>00448           <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sn=0; sn&lt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_nodes(); sn++)
<a name="l00449"></a>00449             onodes.insert(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(sn));
<a name="l00450"></a>00450                                 
<a name="l00451"></a>00451           ofaces.insert(p);
<a name="l00452"></a>00452           face_it++;                    <span class="comment">// iteration is done here</span>
<a name="l00453"></a>00453           faces.erase(p);
<a name="l00454"></a>00454                 
<a name="l00455"></a>00455           facesfound++;
<a name="l00456"></a>00456         }
<a name="l00457"></a>00457     
<a name="l00458"></a>00458       <span class="keywordflow">else</span>
<a name="l00459"></a>00459         face_it++;                      <span class="comment">// iteration is done here</span>
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462       <span class="comment">// If at least one new oface was found in this cycle, </span>
<a name="l00463"></a>00463       <span class="comment">// do another search cycle.</span>
<a name="l00464"></a>00464       <span class="keywordflow">if</span>(facesfound&gt;0 &amp;&amp; face_it == faces.end())
<a name="l00465"></a>00465         {       
<a name="l00466"></a>00466           facesfound = 0;
<a name="l00467"></a>00467           face_it    = faces.begin();
<a name="l00468"></a>00468         }
<a name="l00469"></a>00469     
<a name="l00470"></a>00470     } <span class="keywordflow">while</span>(face_it != faces.end());
<a name="l00471"></a>00471   }
<a name="l00472"></a>00472   
<a name="l00473"></a>00473         
<a name="l00474"></a>00474 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00475"></a>00475 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (be_verbose)
<a name="l00476"></a>00476     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  found &quot;</span> 
<a name="l00477"></a>00477                   &lt;&lt; faces.size() 
<a name="l00478"></a>00478                   &lt;&lt; <span class="stringliteral">&quot; inner and &quot;</span> 
<a name="l00479"></a>00479                   &lt;&lt; ofaces.size() 
<a name="l00480"></a>00480                   &lt;&lt; <span class="stringliteral">&quot; outer boundary faces&quot;</span> 
<a name="l00481"></a>00481                   &lt;&lt; std::endl;
<a name="l00482"></a>00482 <span class="preprocessor">#endif  </span>
<a name="l00483"></a>00483 <span class="preprocessor"></span>        
<a name="l00484"></a>00484   <span class="comment">// When the user provided a non-null pointer to</span>
<a name="l00485"></a>00485   <span class="comment">// inner_faces, that implies he wants to have</span>
<a name="l00486"></a>00486   <span class="comment">// this std::set.  For now, simply copy the data.</span>
<a name="l00487"></a>00487   <span class="keywordflow">if</span> (inner_faces != NULL)
<a name="l00488"></a>00488     *inner_faces = faces;
<a name="l00489"></a>00489 
<a name="l00490"></a>00490   <span class="comment">// free memory, clear our local variable, no need</span>
<a name="l00491"></a>00491   <span class="comment">// for it any more.</span>
<a name="l00492"></a>00492   faces.clear();
<a name="l00493"></a>00493 
<a name="l00494"></a>00494 
<a name="l00495"></a>00495   <span class="comment">// outer_nodes maps onodes to their duplicates</span>
<a name="l00496"></a>00496   std::map&lt;unsigned int, Node *&gt; outer_nodes;
<a name="l00497"></a>00497 
<a name="l00498"></a>00498   <span class="comment">// We may need to pick our own object ids in parallel</span>
<a name="l00499"></a>00499   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_max_node_id = <a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9778fcd4d5fc7687babdf9a5ea56d882">max_node_id</a>();
<a name="l00500"></a>00500   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_max_elem_id = <a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>();
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   <span class="comment">// for each boundary node, add an outer_node with </span>
<a name="l00503"></a>00503   <span class="comment">// double distance from origin.</span>
<a name="l00504"></a>00504   std::set&lt;unsigned int&gt;::iterator on_it = onodes.begin();
<a name="l00505"></a>00505   <span class="keywordflow">for</span>( ; on_it != onodes.end(); ++on_it)
<a name="l00506"></a>00506     {
<a name="l00507"></a>00507       <a class="code" href="classlibMesh_1_1Point.php">Point</a> p = (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(*on_it)) * 2) - origin;
<a name="l00508"></a>00508       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00509"></a>00509         {
<a name="l00510"></a>00510           <span class="comment">// Add with a default id in serial</span>
<a name="l00511"></a>00511           outer_nodes[*on_it]=this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a>(p);
<a name="l00512"></a>00512         }
<a name="l00513"></a>00513       <span class="keywordflow">else</span>
<a name="l00514"></a>00514         {
<a name="l00515"></a>00515           <span class="comment">// Pick a unique id in parallel</span>
<a name="l00516"></a>00516           <a class="code" href="classlibMesh_1_1Node.php">Node</a> &amp;bnode = <a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(*on_it);
<a name="l00517"></a>00517           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id = bnode.<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() + old_max_node_id;
<a name="l00518"></a>00518           outer_nodes[*on_it] = 
<a name="l00519"></a>00519             this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a>(p, new_id,
<a name="l00520"></a>00520                                   bnode.<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>());
<a name="l00521"></a>00521         }
<a name="l00522"></a>00522     }
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00526"></a>00526 <span class="preprocessor"></span>  <span class="comment">// for verbose, remember n_elem</span>
<a name="l00527"></a>00527   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_conventional_elem = this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00528"></a>00528 <span class="preprocessor">#endif</span>
<a name="l00529"></a>00529 <span class="preprocessor"></span>
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   <span class="comment">// build Elems based on boundary side type</span>
<a name="l00532"></a>00532   std::set&lt; std::pair&lt;unsigned int,unsigned int&gt; &gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a> face_it = ofaces.begin();
<a name="l00533"></a>00533   <span class="keywordflow">for</span>( ; face_it != ofaces.end(); ++face_it)
<a name="l00534"></a>00534     {
<a name="l00535"></a>00535       <span class="comment">// Shortcut to the pair being iterated over</span>
<a name="l00536"></a>00536       std::pair&lt;unsigned int,unsigned int&gt; p = *face_it;
<a name="l00537"></a>00537         
<a name="l00538"></a>00538       <span class="comment">// build a full-ordered side element to get the base nodes</span>
<a name="l00539"></a>00539       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(p.first)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(p.second)); 
<a name="l00540"></a>00540 
<a name="l00541"></a>00541       <span class="comment">// create cell depending on side type, assign nodes,</span>
<a name="l00542"></a>00542       <span class="comment">// use braces to force scope.</span>
<a name="l00543"></a>00543       <span class="keywordtype">bool</span> is_higher_order_elem = <span class="keyword">false</span>;
<a name="l00544"></a>00544       {
<a name="l00545"></a>00545         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* el;
<a name="l00546"></a>00546         <span class="keywordflow">switch</span>(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;type())
<a name="l00547"></a>00547         {
<a name="l00548"></a>00548           <span class="comment">// 3D infinite elements</span>
<a name="l00549"></a>00549           <span class="comment">// TRIs                                       </span>
<a name="l00550"></a>00550           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:    
<a name="l00551"></a>00551             el=<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfPrism6.php">InfPrism6</a>;
<a name="l00552"></a>00552             <span class="keywordflow">break</span>;
<a name="l00553"></a>00553                                                         
<a name="l00554"></a>00554           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>: 
<a name="l00555"></a>00555             el=<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfPrism12.php">InfPrism12</a>; 
<a name="l00556"></a>00556             is_higher_order_elem = <span class="keyword">true</span>;
<a name="l00557"></a>00557             <span class="keywordflow">break</span>;
<a name="l00558"></a>00558                                                         
<a name="l00559"></a>00559           <span class="comment">// QUADs                                      </span>
<a name="l00560"></a>00560           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>: 
<a name="l00561"></a>00561             el=<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfHex8.php">InfHex8</a>;
<a name="l00562"></a>00562             <span class="keywordflow">break</span>;
<a name="l00563"></a>00563                                                         
<a name="l00564"></a>00564           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>: 
<a name="l00565"></a>00565             el=<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfHex16.php">InfHex16</a>;
<a name="l00566"></a>00566             is_higher_order_elem = <span class="keyword">true</span>;
<a name="l00567"></a>00567             <span class="keywordflow">break</span>;
<a name="l00568"></a>00568                                                         
<a name="l00569"></a>00569           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>: 
<a name="l00570"></a>00570             el=<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfHex18.php">InfHex18</a>;
<a name="l00571"></a>00571 
<a name="l00572"></a>00572             <span class="comment">// the method of assigning nodes (which follows below)</span>
<a name="l00573"></a>00573             <span class="comment">// omits in the case of QUAD9 the bubble node; therefore</span>
<a name="l00574"></a>00574             <span class="comment">// we assign these first by hand here.</span>
<a name="l00575"></a>00575             el-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(16) = <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;get_node(8);
<a name="l00576"></a>00576             el-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(17) = outer_nodes[<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(8)];
<a name="l00577"></a>00577             is_higher_order_elem=<span class="keyword">true</span>;
<a name="l00578"></a>00578             <span class="keywordflow">break</span>;
<a name="l00579"></a>00579 
<a name="l00580"></a>00580           <span class="comment">// 2D infinite elements                </span>
<a name="l00581"></a>00581           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>:
<a name="l00582"></a>00582             el=<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad4.php">InfQuad4</a>;
<a name="l00583"></a>00583             <span class="keywordflow">break</span>;
<a name="l00584"></a>00584 
<a name="l00585"></a>00585           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>:
<a name="l00586"></a>00586             el=<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1InfQuad6.php">InfQuad6</a>;
<a name="l00587"></a>00587             el-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;get_node(2);
<a name="l00588"></a>00588             <span class="keywordflow">break</span>;
<a name="l00589"></a>00589 
<a name="l00590"></a>00590           <span class="comment">// 1D infinite elements not supported</span>
<a name="l00591"></a>00591           <span class="keywordflow">default</span>: 
<a name="l00592"></a>00592             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;InfElemBuilder::build_inf_elem(Point, bool, bool, bool, bool): &quot;</span>
<a name="l00593"></a>00593                           &lt;&lt; <span class="stringliteral">&quot;invalid face element &quot;</span>
<a name="l00594"></a>00594                           &lt;&lt; std::endl;
<a name="l00595"></a>00595             <span class="keywordflow">continue</span>;
<a name="l00596"></a>00596         }
<a name="l00597"></a>00597 
<a name="l00598"></a>00598         <span class="comment">// In parallel, assign unique ids to the new element</span>
<a name="l00599"></a>00599         <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00600"></a>00600           {
<a name="l00601"></a>00601             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *belem = <a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(p.first);
<a name="l00602"></a>00602             el-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = belem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00603"></a>00603             <span class="comment">// We&#39;d better not have elements with more than 6 sides</span>
<a name="l00604"></a>00604             el-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a> (belem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() * 6 + p.second + old_max_elem_id);
<a name="l00605"></a>00605           }
<a name="l00606"></a>00606 
<a name="l00607"></a>00607         <span class="comment">// assign vertices to the new infinite element</span>
<a name="l00608"></a>00608         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_vertices = <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_vertices();
<a name="l00609"></a>00609         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_base_vertices; i++)
<a name="l00610"></a>00610           {
<a name="l00611"></a>00611             el-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(i                ) = <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;get_node(i);
<a name="l00612"></a>00612             el-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(i+n_base_vertices) = outer_nodes[<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(i)];
<a name="l00613"></a>00613           }
<a name="l00614"></a>00614 
<a name="l00615"></a>00615 
<a name="l00616"></a>00616         <span class="comment">// when this is a higher order element, </span>
<a name="l00617"></a>00617         <span class="comment">// assign also the nodes in between</span>
<a name="l00618"></a>00618         <span class="keywordflow">if</span> (is_higher_order_elem)
<a name="l00619"></a>00619           {
<a name="l00620"></a>00620             <span class="comment">// n_safe_base_nodes is the number of nodes in \p side</span>
<a name="l00621"></a>00621             <span class="comment">// that may be safely assigned using below for loop.</span>
<a name="l00622"></a>00622             <span class="comment">// Actually, n_safe_base_nodes is _identical_ with el-&gt;n_vertices(),</span>
<a name="l00623"></a>00623             <span class="comment">// since for QUAD9, the 9th node was already assigned above</span>
<a name="l00624"></a>00624             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_safe_base_nodes   = el-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>();
<a name="l00625"></a>00625 
<a name="l00626"></a>00626             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=n_base_vertices; i&lt;n_safe_base_nodes; i++)
<a name="l00627"></a>00627               {
<a name="l00628"></a>00628                 el-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(i+n_base_vertices)   = <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;get_node(i);
<a name="l00629"></a>00629                 el-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(i+n_safe_base_nodes) = outer_nodes[<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(i)];
<a name="l00630"></a>00630               }
<a name="l00631"></a>00631           }
<a name="l00632"></a>00632                         
<a name="l00633"></a>00633 
<a name="l00634"></a>00634         <span class="comment">// add infinite element to mesh</span>
<a name="l00635"></a>00635         this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(el);
<a name="l00636"></a>00636       } <span class="comment">// el goes out of scope</span>
<a name="l00637"></a>00637     } <span class="comment">// for</span>
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 
<a name="l00640"></a>00640 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00641"></a>00641 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#adda5cd6af09b7fcc88a890a71a07c1a8">libmesh_assert_valid_parallel_ids</a>();
<a name="l00642"></a>00642 
<a name="l00643"></a>00643   <span class="keywordflow">if</span> (be_verbose)
<a name="l00644"></a>00644     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  added &quot;</span>
<a name="l00645"></a>00645                   &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>() - n_conventional_elem
<a name="l00646"></a>00646                   &lt;&lt; <span class="stringliteral">&quot; infinite elements and &quot;</span>
<a name="l00647"></a>00647                   &lt;&lt; onodes.size() 
<a name="l00648"></a>00648                   &lt;&lt; <span class="stringliteral">&quot; nodes to the mesh&quot;</span>
<a name="l00649"></a>00649                   &lt;&lt; std::endl
<a name="l00650"></a>00650                   &lt;&lt; std::endl;
<a name="l00651"></a>00651 <span class="preprocessor">#endif</span>
<a name="l00652"></a>00652 <span class="preprocessor"></span>
<a name="l00653"></a>00653   STOP_LOG(<span class="stringliteral">&quot;build_inf_elem()&quot;</span>, <span class="stringliteral">&quot;InfElemBuilder&quot;</span>);
<a name="l00654"></a>00654 }
<a name="l00655"></a>00655 
<a name="l00656"></a>00656 } <span class="comment">// namespace libMesh</span>
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 
<a name="l00662"></a>00662 <span class="preprocessor">#endif // LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
