<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_elem_builder.h</div>  </div>
</div>
<div class="contents">
<a href="inf__elem__builder_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_elem_builder.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __inf_elem_builder_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __inf_elem_builder_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;utility&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Local includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>libMesh
<a name="l00038"></a>00038 {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// Forward Declarations</span>
<a name="l00041"></a>00041 <span class="keyword">class </span>MeshBase;
<a name="l00042"></a>00042 <span class="keyword">class </span>Node;
<a name="l00043"></a>00043 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1InfElemBuilder.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfElemBuilder.php">InfElemBuilder</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00058"></a><a class="code" href="classlibMesh_1_1InfElemBuilder.php#a67a807ba18b3d7ab90eac08227e66669">00058</a>   <a class="code" href="classlibMesh_1_1InfElemBuilder.php#a67a807ba18b3d7ab90eac08227e66669">InfElemBuilder</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) : <a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>(mesh) {}
<a name="l00059"></a>00059 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1InfElemBuilder.php#acf45bfe5ace01174cb8acfb54328a367">00063</a>   <span class="keyword">typedef</span> std::pair&lt;bool, double&gt; <a class="code" href="classlibMesh_1_1InfElemBuilder.php#acf45bfe5ace01174cb8acfb54328a367">InfElemOriginValue</a>;
<a name="l00064"></a>00064 
<a name="l00074"></a>00074   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">build_inf_elem</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> be_verbose = <span class="keyword">false</span>);
<a name="l00075"></a>00075 
<a name="l00098"></a>00098   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">build_inf_elem</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#acf45bfe5ace01174cb8acfb54328a367">InfElemOriginValue</a>&amp; origin_x,
<a name="l00099"></a>00099                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#acf45bfe5ace01174cb8acfb54328a367">InfElemOriginValue</a>&amp; origin_y,
<a name="l00100"></a>00100                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#acf45bfe5ace01174cb8acfb54328a367">InfElemOriginValue</a>&amp; origin_z,
<a name="l00101"></a>00101                               <span class="keyword">const</span> <span class="keywordtype">bool</span> x_sym = <span class="keyword">false</span>,
<a name="l00102"></a>00102                               <span class="keyword">const</span> <span class="keywordtype">bool</span> y_sym = <span class="keyword">false</span>,
<a name="l00103"></a>00103                               <span class="keyword">const</span> <span class="keywordtype">bool</span> z_sym = <span class="keyword">false</span>,
<a name="l00104"></a>00104                               <span class="keyword">const</span> <span class="keywordtype">bool</span> be_verbose = <span class="keyword">false</span>,
<a name="l00105"></a>00105                               std::vector&lt;const Node*&gt;* inner_boundary_nodes = NULL);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 <span class="keyword">private</span>:
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfElemBuilder.php#ac6bf21d86621176b3497f089bef8a17a">build_inf_elem</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; origin,
<a name="l00115"></a>00115                        <span class="keyword">const</span> <span class="keywordtype">bool</span> x_sym = <span class="keyword">false</span>,
<a name="l00116"></a>00116                        <span class="keyword">const</span> <span class="keywordtype">bool</span> y_sym = <span class="keyword">false</span>,
<a name="l00117"></a>00117                        <span class="keyword">const</span> <span class="keywordtype">bool</span> z_sym = <span class="keyword">false</span>,
<a name="l00118"></a>00118                        <span class="keyword">const</span> <span class="keywordtype">bool</span> be_verbose = <span class="keyword">false</span>,
<a name="l00119"></a>00119                        std::set&lt;std::pair&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00120"></a>00120                                           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; &gt;* inner_faces = NULL);
<a name="l00125"></a><a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">00125</a>   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1InfElemBuilder.php#afbdff790a0e4a9a08c06e178a4d585f5">_mesh</a>;
<a name="l00126"></a>00126 };
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 } <span class="comment">// namespace libMesh</span>
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#endif // LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
