<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_fe.C</div>  </div>
</div>
<div class="contents">
<a href="inf__fe_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// InfFE class members</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// Constructor</span>
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00042"></a><a class="code" href="classlibMesh_1_1InfFE.php#a3cdd21b19b1705ab3a5c1bc6a7dcbbab">00042</a> <a class="code" href="classlibMesh_1_1InfFE.php#a30966325e9cd5ef7b41e45148b6919ed">InfFE&lt;Dim,T_radial,T_map&gt;::InfFE</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet) :
<a name="l00043"></a>00043   <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a>       (Dim, fet),
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   _n_total_approx_sf (0),
<a name="l00046"></a>00046   _n_total_qp        (0),
<a name="l00047"></a>00047 
<a name="l00048"></a>00048   base_qrule   (NULL),
<a name="l00049"></a>00049   radial_qrule (NULL),
<a name="l00050"></a>00050   base_elem    (NULL),
<a name="l00051"></a>00051   base_fe      (NULL),
<a name="l00052"></a>00052   
<a name="l00053"></a>00053   <span class="comment">// initialize the current_fe_type to all the same</span>
<a name="l00054"></a>00054   <span class="comment">// values as \p fet (since the FE families and coordinate</span>
<a name="l00055"></a>00055   <span class="comment">// map type should @e not change), but use an invalid order</span>
<a name="l00056"></a>00056   <span class="comment">// for the radial part (since this is the only order</span>
<a name="l00057"></a>00057   <span class="comment">// that may change!).</span>
<a name="l00058"></a>00058   <span class="comment">// the data structures like \p phi etc are not initialized </span>
<a name="l00059"></a>00059   <span class="comment">// through the constructor, but throught reinit()</span>
<a name="l00060"></a>00060   current_fe_type ( <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>(fet.order, 
<a name="l00061"></a>00061                            fet.family, 
<a name="l00062"></a>00062                            <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>, 
<a name="l00063"></a>00063                            fet.radial_family,      
<a name="l00064"></a>00064                            fet.inf_map) )
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   <span class="comment">// Sanity checks</span>
<a name="l00068"></a>00068   libmesh_assert (T_radial == <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>.<a class="code" href="classlibMesh_1_1FEType.php#aa977e3f8f993257e1cc81896236ba366">radial_family</a>);
<a name="l00069"></a>00069   libmesh_assert (T_map    == <a class="code" href="classlibMesh_1_1FEBase.php#afee01a0935bb98ce8f670c1a86c3f68a">fe_type</a>.<a class="code" href="classlibMesh_1_1FEType.php#a1fb32083c8ab884440a2beb333b5236e">inf_map</a>);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="comment">// build the base_fe object, handle the AutoPtr</span>
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (Dim != 1)
<a name="l00073"></a>00073     {
<a name="l00074"></a>00074       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap_fb(<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(Dim-1, fet));
<a name="l00075"></a>00075       <a class="code" href="classlibMesh_1_1InfFE.php#a96a2cd7f42aa64975f1edfb613c6ec42">base_fe</a> = ap_fb.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00076"></a>00076     }
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="comment">// Destructor</span>
<a name="l00083"></a>00083 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00084"></a><a class="code" href="classlibMesh_1_1InfFE.php#a30d276887bb6076968b6e42c9906f6af">00084</a> <a class="code" href="classlibMesh_1_1InfFE.php#a30d276887bb6076968b6e42c9906f6af">InfFE&lt;Dim,T_radial,T_map&gt;::~InfFE</a> ()
<a name="l00085"></a>00085 {
<a name="l00086"></a>00086   <span class="comment">// delete pointers, if necessary</span>
<a name="l00087"></a>00087   <span class="keywordflow">if</span> (base_qrule != NULL)
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089       <span class="keyword">delete</span> base_qrule;
<a name="l00090"></a>00090       base_qrule = NULL;
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092   
<a name="l00093"></a>00093   <span class="keywordflow">if</span> (radial_qrule != NULL)
<a name="l00094"></a>00094     {
<a name="l00095"></a>00095       <span class="keyword">delete</span> radial_qrule;
<a name="l00096"></a>00096       radial_qrule = NULL;
<a name="l00097"></a>00097     }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099   <span class="keywordflow">if</span> (base_elem != NULL)
<a name="l00100"></a>00100     {
<a name="l00101"></a>00101       <span class="keyword">delete</span> base_elem;
<a name="l00102"></a>00102       base_elem = NULL;
<a name="l00103"></a>00103     }
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="keywordflow">if</span> (base_fe != NULL)
<a name="l00106"></a>00106     {
<a name="l00107"></a>00107       <span class="keyword">delete</span> base_fe;
<a name="l00108"></a>00108       base_fe = NULL;
<a name="l00109"></a>00109     }
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00117"></a><a class="code" href="classlibMesh_1_1InfFE.php#a03afde0d34a0a9349b8f52c9a84a1cde">00117</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a03afde0d34a0a9349b8f52c9a84a1cde">InfFE&lt;Dim,T_radial,T_map&gt;:: attach_quadrature_rule</a> (<a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* q)
<a name="l00118"></a>00118 {
<a name="l00119"></a>00119   libmesh_assert (q       != NULL);
<a name="l00120"></a>00120   libmesh_assert (base_fe != NULL);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> base_int_order   = q-&gt;<a class="code" href="classlibMesh_1_1QBase.php#a35cb2015566e5ab627e3af64519d4f03">get_order</a>();
<a name="l00123"></a>00123   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> radial_int_order = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(2 * (<span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(fe_type.radial_order) + 1) +2);
<a name="l00124"></a>00124   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qrule_dim = q-&gt;<a class="code" href="classlibMesh_1_1QBase.php#a334ad6c046a65963406402fbdf13e748">get_dim</a>();
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (Dim != 1)
<a name="l00127"></a>00127     {
<a name="l00128"></a>00128       <span class="comment">// build a Dim-1 quadrature rule of the type that we received</span>
<a name="l00129"></a>00129       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> apq( <a class="code" href="classlibMesh_1_1QBase.php#a036daa63de83f2df0333c5e2e6740552">QBase::build</a>(q-&gt;<a class="code" href="classlibMesh_1_1QBase.php#a580d1c4a57b7c9f6f1c8904f3c804373">type</a>(), qrule_dim-1, base_int_order) );
<a name="l00130"></a>00130       base_qrule = apq.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00131"></a>00131       base_fe-&gt;attach_quadrature_rule(base_qrule);
<a name="l00132"></a>00132     }
<a name="l00133"></a>00133   
<a name="l00134"></a>00134   <span class="comment">// in radial direction, always use Gauss quadrature</span>
<a name="l00135"></a>00135   radial_qrule = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a>(1, radial_int_order);
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// currently not used. But maybe helpful to store the QBase*</span>
<a name="l00138"></a>00138   <span class="comment">// with which we initialized our own quadrature rules</span>
<a name="l00139"></a>00139   qrule = q;
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_base&gt;
<a name="l00147"></a><a class="code" href="classlibMesh_1_1InfFE.php#ab446eaf1bea81ca7a9f4676cccd48a6e">00147</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#ab446eaf1bea81ca7a9f4676cccd48a6e">InfFE&lt;Dim,T_radial,T_base&gt;::update_base_elem</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem)
<a name="l00148"></a>00148 {
<a name="l00149"></a>00149   <span class="keywordflow">if</span> (base_elem != NULL)
<a name="l00150"></a>00150     <span class="keyword">delete</span> base_elem;
<a name="l00151"></a>00151   base_elem = Base::build_elem(inf_elem);
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00160"></a><a class="code" href="classlibMesh_1_1InfFE.php#a9ae89fdd879752a80e324fe648a11631">00160</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a9ae89fdd879752a80e324fe648a11631">InfFE&lt;Dim,T_radial,T_map&gt;::reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem,
<a name="l00161"></a>00161                                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts)
<a name="l00162"></a>00162 {
<a name="l00163"></a>00163   libmesh_assert (base_fe        != NULL);
<a name="l00164"></a>00164   libmesh_assert (base_fe-&gt;qrule != NULL);
<a name="l00165"></a>00165   libmesh_assert (base_fe-&gt;qrule == base_qrule);
<a name="l00166"></a>00166   libmesh_assert (radial_qrule   != NULL);
<a name="l00167"></a>00167   libmesh_assert (inf_elem       != NULL);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="keywordflow">if</span> (pts == NULL)
<a name="l00170"></a>00170     {
<a name="l00171"></a>00171       <span class="keywordtype">bool</span> init_shape_functions_required = <span class="keyword">false</span>;
<a name="l00172"></a>00172       
<a name="l00173"></a>00173       <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00174"></a>00174       <span class="comment">// init the radial data fields only when the radial order changes</span>
<a name="l00175"></a>00175       <span class="keywordflow">if</span> (current_fe_type.radial_order != fe_type.radial_order)
<a name="l00176"></a>00176         {
<a name="l00177"></a>00177           current_fe_type.radial_order = fe_type.radial_order;
<a name="l00178"></a>00178           
<a name="l00179"></a>00179           <span class="comment">// Watch out: this call to QBase-&gt;init() only works for </span>
<a name="l00180"></a>00180           <span class="comment">// current_fe_type = const!   To allow variable Order, </span>
<a name="l00181"></a>00181           <span class="comment">// the init() of QBase has to be modified...  </span>
<a name="l00182"></a>00182           radial_qrule-&gt;init(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>);
<a name="l00183"></a>00183           
<a name="l00184"></a>00184           <span class="comment">// initialize the radial shape functions</span>
<a name="l00185"></a>00185           this-&gt;init_radial_shape_functions(inf_elem);
<a name="l00186"></a>00186           
<a name="l00187"></a>00187           init_shape_functions_required=<span class="keyword">true</span>;      
<a name="l00188"></a>00188         }
<a name="l00189"></a>00189       
<a name="l00190"></a>00190       
<a name="l00191"></a>00191       <span class="keywordtype">bool</span> update_base_elem_required=<span class="keyword">true</span>;
<a name="l00192"></a>00192       
<a name="l00193"></a>00193       <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00194"></a>00194       <span class="comment">// update the type in accordance to the current cell</span>
<a name="l00195"></a>00195       <span class="comment">// and reinit if the cell type has changed or (as in</span>
<a name="l00196"></a>00196       <span class="comment">// the case of the hierarchics) the shape functions</span>
<a name="l00197"></a>00197       <span class="comment">// depend on the particular element and need a reinit</span>
<a name="l00198"></a>00198       <span class="keywordflow">if</span> (  ( Dim != 1) &amp;&amp;
<a name="l00199"></a>00199             (  (this-&gt;get_type() != inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>())  ||  
<a name="l00200"></a>00200                (base_fe-&gt;shapes_need_reinit())  )  )
<a name="l00201"></a>00201         {
<a name="l00202"></a>00202           <span class="comment">// store the new element type, update base_elem</span>
<a name="l00203"></a>00203           <span class="comment">// here.  Through \p update_base_elem_required,</span>
<a name="l00204"></a>00204           <span class="comment">// remember whether it has to be updated (see below).</span>
<a name="l00205"></a>00205           elem_type = inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00206"></a>00206           this-&gt;update_base_elem(inf_elem);
<a name="l00207"></a>00207           update_base_elem_required=<span class="keyword">false</span>;
<a name="l00208"></a>00208           
<a name="l00209"></a>00209           <span class="comment">// initialize the base quadrature rule for the new element</span>
<a name="l00210"></a>00210           base_qrule-&gt;init(base_elem-&gt;type());
<a name="l00211"></a>00211           
<a name="l00212"></a>00212           <span class="comment">// initialize the shape functions in the base</span>
<a name="l00213"></a>00213           base_fe-&gt;init_base_shape_functions(base_fe-&gt;qrule-&gt;get_points(),
<a name="l00214"></a>00214                                              base_elem);
<a name="l00215"></a>00215           
<a name="l00216"></a>00216           init_shape_functions_required=<span class="keyword">true</span>;      
<a name="l00217"></a>00217         }
<a name="l00218"></a>00218       
<a name="l00219"></a>00219       
<a name="l00220"></a>00220       <span class="comment">// when either the radial or base part change, </span>
<a name="l00221"></a>00221       <span class="comment">// we have to init the whole fields</span>
<a name="l00222"></a>00222       <span class="keywordflow">if</span> (init_shape_functions_required)
<a name="l00223"></a>00223         this-&gt;init_shape_functions (inf_elem);
<a name="l00224"></a>00224       
<a name="l00225"></a>00225       <span class="comment">// computing the distance only works when we have the current</span>
<a name="l00226"></a>00226       <span class="comment">// base_elem stored.  This happens when fe_type is const,</span>
<a name="l00227"></a>00227       <span class="comment">// the inf_elem-&gt;type remains the same.  Then we have to</span>
<a name="l00228"></a>00228       <span class="comment">// update the base elem _here_.</span>
<a name="l00229"></a>00229       <span class="keywordflow">if</span> (update_base_elem_required)
<a name="l00230"></a>00230         this-&gt;update_base_elem(inf_elem);
<a name="l00231"></a>00231       
<a name="l00232"></a>00232       <span class="comment">// compute dist (depends on geometry, therefore has to be updated for</span>
<a name="l00233"></a>00233       <span class="comment">// each and every new element), throw radial and base part together</span>
<a name="l00234"></a>00234       this-&gt;combine_base_radial (inf_elem);
<a name="l00235"></a>00235       
<a name="l00236"></a>00236       this-&gt;compute_map (_total_qrule_weights, inf_elem);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238       <span class="comment">// Compute the shape functions and the derivatives </span>
<a name="l00239"></a>00239       <span class="comment">// at all quadrature points.</span>
<a name="l00240"></a>00240       this-&gt;compute_shape_functions (inf_elem);
<a name="l00241"></a>00241     }
<a name="l00242"></a>00242   
<a name="l00243"></a>00243   <span class="keywordflow">else</span> <span class="comment">// if pts != NULL</span>
<a name="l00244"></a>00244     {
<a name="l00245"></a>00245       <span class="comment">// update the elem_type</span>
<a name="l00246"></a>00246       elem_type = inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00247"></a>00247 
<a name="l00248"></a>00248       <span class="comment">// init radial shapes</span>
<a name="l00249"></a>00249       this-&gt;init_radial_shape_functions(inf_elem);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251       <span class="comment">// update the base</span>
<a name="l00252"></a>00252       this-&gt;update_base_elem(inf_elem);
<a name="l00253"></a>00253 
<a name="l00254"></a>00254       <span class="comment">// the finite element on the ifem base</span>
<a name="l00255"></a>00255       {
<a name="l00256"></a>00256         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap_fb(<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(Dim-1, this-&gt;fe_type));
<a name="l00257"></a>00257         <span class="keywordflow">if</span> (base_fe != NULL)
<a name="l00258"></a>00258           <span class="keyword">delete</span> base_fe;
<a name="l00259"></a>00259         base_fe = ap_fb.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00260"></a>00260       }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262       <span class="comment">// inite base shapes</span>
<a name="l00263"></a>00263       base_fe-&gt;init_base_shape_functions(*pts,
<a name="l00264"></a>00264                                          base_elem);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266       this-&gt;init_shape_functions (inf_elem);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268       <span class="comment">// combine the base and radial shapes</span>
<a name="l00269"></a>00269       this-&gt;combine_base_radial (inf_elem);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271       <span class="comment">// dummy weights</span>
<a name="l00272"></a>00272       std::vector&lt;Real&gt; dummy_weights (pts-&gt;size(), 1.);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274       this-&gt;compute_map (dummy_weights, inf_elem);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276       <span class="comment">// finally compute the ifem shapes     </span>
<a name="l00277"></a>00277       this-&gt;compute_shape_functions (inf_elem);
<a name="l00278"></a>00278     }
<a name="l00279"></a>00279   
<a name="l00280"></a>00280 }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00287"></a><a class="code" href="classlibMesh_1_1InfFE.php#aef42f87957900f537c9fa2d2e81c3c4c">00287</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#aef42f87957900f537c9fa2d2e81c3c4c">InfFE&lt;Dim,T_radial,T_map&gt;::init_radial_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem)
<a name="l00288"></a>00288 {
<a name="l00289"></a>00289   libmesh_assert (radial_qrule != NULL);
<a name="l00290"></a>00290   libmesh_assert (inf_elem     != NULL);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292  
<a name="l00296"></a>00296   START_LOG(<span class="stringliteral">&quot;init_radial_shape_functions()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00300"></a>00300   <span class="comment">// initialize most of the things related to mapping</span>
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// The order to use in the radial map (currently independent of the element type)</span>
<a name="l00303"></a>00303   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        radial_mapping_order             (Radial::mapping_order());    
<a name="l00304"></a>00304   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_radial_mapping_shape_functions (Radial::n_dofs(radial_mapping_order));
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00309"></a>00309   <span class="comment">// initialize most of the things related to physical approximation</span>
<a name="l00310"></a>00310   
<a name="l00311"></a>00311   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        radial_approx_order             (fe_type.radial_order);
<a name="l00312"></a>00312   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_radial_approx_shape_functions (Radial::n_dofs(radial_approx_order));
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>        n_radial_qp = radial_qrule-&gt;n_points();
<a name="l00315"></a>00315   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp;   radial_qp = radial_qrule-&gt;get_points();
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00320"></a>00320   <span class="comment">// resize the radial data fields</span>
<a name="l00321"></a>00321   
<a name="l00322"></a>00322   mode.resize      (n_radial_approx_shape_functions);       <span class="comment">// the radial polynomials (eval)</span>
<a name="l00323"></a>00323   dmodedv.resize   (n_radial_approx_shape_functions);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   som.resize       (n_radial_qp);                           <span class="comment">// the (1-v)/2 weight</span>
<a name="l00326"></a>00326   dsomdv.resize    (n_radial_qp);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   radial_map.resize    (n_radial_mapping_shape_functions);  <span class="comment">// the radial map</span>
<a name="l00329"></a>00329   dradialdv_map.resize (n_radial_mapping_shape_functions);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   
<a name="l00332"></a>00332   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_radial_mapping_shape_functions; i++)
<a name="l00333"></a>00333     {
<a name="l00334"></a>00334       radial_map[i].resize    (n_radial_qp);
<a name="l00335"></a>00335       dradialdv_map[i].resize (n_radial_qp);
<a name="l00336"></a>00336     }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_radial_approx_shape_functions; i++)
<a name="l00340"></a>00340     {
<a name="l00341"></a>00341       mode[i].resize    (n_radial_qp);
<a name="l00342"></a>00342       dmodedv[i].resize (n_radial_qp);
<a name="l00343"></a>00343     }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 
<a name="l00346"></a>00346   <span class="comment">// compute scalar values at radial quadrature points</span>
<a name="l00347"></a>00347   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_radial_qp; p++)
<a name="l00348"></a>00348     {
<a name="l00349"></a>00349       som[p]       = Radial::decay       (radial_qp[p](0)); 
<a name="l00350"></a>00350       dsomdv[p]    = Radial::decay_deriv (radial_qp[p](0)); 
<a name="l00351"></a>00351     }
<a name="l00352"></a>00352 
<a name="l00353"></a>00353   
<a name="l00354"></a>00354   <span class="comment">// evaluate the mode shapes in radial direction at radial quadrature points</span>
<a name="l00355"></a>00355   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_radial_approx_shape_functions; i++)
<a name="l00356"></a>00356     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_radial_qp; p++)
<a name="l00357"></a>00357       {
<a name="l00358"></a>00358         mode[i][p]    = <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>       (radial_qp[p](0), radial_approx_order, i);
<a name="l00359"></a>00359         dmodedv[i][p] = <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;Dim,T_radial,T_map&gt;::eval_deriv</a> (radial_qp[p](0), radial_approx_order, i);
<a name="l00360"></a>00360       }
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="comment">// evaluate the mapping functions in radial direction at radial quadrature points</span>
<a name="l00364"></a>00364   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_radial_mapping_shape_functions; i++)
<a name="l00365"></a>00365     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_radial_qp; p++)
<a name="l00366"></a>00366       {
<a name="l00367"></a>00367         radial_map[i][p]    = <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval</a>       (radial_qp[p](0), radial_mapping_order, i);
<a name="l00368"></a>00368         dradialdv_map[i][p] = <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval_deriv</a> (radial_qp[p](0), radial_mapping_order, i);
<a name="l00369"></a>00369       }
<a name="l00370"></a>00370 
<a name="l00374"></a>00374   STOP_LOG(<span class="stringliteral">&quot;init_radial_shape_functions()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00383"></a><a class="code" href="classlibMesh_1_1InfFE.php#a310e88546990e4373110b2b340577dd3">00383</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a310e88546990e4373110b2b340577dd3">InfFE&lt;Dim,T_radial,T_map&gt;::init_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem)
<a name="l00384"></a>00384 {
<a name="l00385"></a>00385   libmesh_assert (inf_elem     != NULL);
<a name="l00386"></a>00386  
<a name="l00387"></a>00387   
<a name="l00388"></a>00388   <span class="comment">// Start logging the radial shape function initialization</span>
<a name="l00389"></a>00389   START_LOG(<span class="stringliteral">&quot;init_shape_functions()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00390"></a>00390 
<a name="l00391"></a>00391   
<a name="l00392"></a>00392   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00393"></a>00393   <span class="comment">// fast access to some const int&#39;s for the radial data</span>
<a name="l00394"></a>00394   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_radial_mapping_sf = radial_map.size();
<a name="l00395"></a>00395   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_radial_approx_sf  = mode.size();
<a name="l00396"></a>00396   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_radial_qp         = som.size();
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00400"></a>00400   <span class="comment">// initialize most of the things related to mapping</span>
<a name="l00401"></a>00401   
<a name="l00402"></a>00402   <span class="comment">// The element type and order to use in the base map  </span>
<a name="l00403"></a>00403   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    base_mapping_order     ( base_elem-&gt;default_order() );
<a name="l00404"></a>00404   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_mapping_elem_type ( base_elem-&gt;type()          );
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="comment">// the number of base shape functions used to construct the map</span>
<a name="l00407"></a>00407   <span class="comment">// (Lagrange shape functions are used for mapping in the base)</span>
<a name="l00408"></a>00408   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_mapping_shape_functions = Base::n_base_mapping_sf(base_mapping_elem_type,
<a name="l00409"></a>00409                                                                         base_mapping_order);
<a name="l00410"></a>00410 
<a name="l00411"></a>00411   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_total_mapping_shape_functions = 
<a name="l00412"></a>00412     n_radial_mapping_sf * n_base_mapping_shape_functions;
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00417"></a>00417   <span class="comment">// initialize most of the things related to physical approximation</span>
<a name="l00418"></a>00418   
<a name="l00419"></a>00419   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_approx_shape_functions;
<a name="l00420"></a>00420   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00421"></a>00421     n_base_approx_shape_functions = base_fe-&gt;n_shape_functions();
<a name="l00422"></a>00422   <span class="keywordflow">else</span>
<a name="l00423"></a>00423     n_base_approx_shape_functions = 1;
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_total_approx_shape_functions = 
<a name="l00427"></a>00427       n_radial_approx_sf * n_base_approx_shape_functions;
<a name="l00428"></a>00428 
<a name="l00429"></a>00429   <span class="comment">// update class member field</span>
<a name="l00430"></a>00430   _n_total_approx_sf = n_total_approx_shape_functions;
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a>00433   <span class="comment">// The number of the base quadrature points.</span>
<a name="l00434"></a>00434   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>        n_base_qp =  base_qrule-&gt;n_points();
<a name="l00435"></a>00435 
<a name="l00436"></a>00436   <span class="comment">// The total number of quadrature points.</span>
<a name="l00437"></a>00437   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>        n_total_qp =  n_radial_qp * n_base_qp;
<a name="l00438"></a>00438 
<a name="l00439"></a>00439   
<a name="l00440"></a>00440   <span class="comment">// update class member field</span>
<a name="l00441"></a>00441   _n_total_qp = n_total_qp;
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00446"></a>00446   <span class="comment">// initialize the node and shape numbering maps</span>
<a name="l00447"></a>00447   {
<a name="l00448"></a>00448     <span class="comment">// these vectors work as follows: the i-th entry stores</span>
<a name="l00449"></a>00449     <span class="comment">// the associated base/radial node number</span>
<a name="l00450"></a>00450     _radial_node_index.resize    (n_total_mapping_shape_functions);
<a name="l00451"></a>00451     _base_node_index.resize      (n_total_mapping_shape_functions);
<a name="l00452"></a>00452 
<a name="l00453"></a>00453     <span class="comment">// similar for the shapes: the i-th entry stores</span>
<a name="l00454"></a>00454     <span class="comment">// the associated base/radial shape number</span>
<a name="l00455"></a>00455     _radial_shape_index.resize   (n_total_approx_shape_functions);
<a name="l00456"></a>00456     _base_shape_index.resize     (n_total_approx_shape_functions);
<a name="l00457"></a>00457 
<a name="l00458"></a>00458     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type (inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00459"></a>00459 
<a name="l00460"></a>00460     <span class="comment">// fill the node index map</span>
<a name="l00461"></a>00461     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_total_mapping_shape_functions; n++)
<a name="l00462"></a>00462       {
<a name="l00463"></a>00463         compute_node_indices (inf_elem_type, 
<a name="l00464"></a>00464                               n,
<a name="l00465"></a>00465                               _base_node_index[n], 
<a name="l00466"></a>00466                               _radial_node_index[n]);
<a name="l00467"></a>00467         libmesh_assert (_base_node_index[n]   &lt; n_base_mapping_shape_functions);
<a name="l00468"></a>00468         libmesh_assert (_radial_node_index[n] &lt; n_radial_mapping_sf);
<a name="l00469"></a>00469       }
<a name="l00470"></a>00470 
<a name="l00471"></a>00471     <span class="comment">// fill the shape index map</span>
<a name="l00472"></a>00472     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_total_approx_shape_functions; n++)
<a name="l00473"></a>00473       {
<a name="l00474"></a>00474         compute_shape_indices (this-&gt;fe_type,
<a name="l00475"></a>00475                                inf_elem_type, 
<a name="l00476"></a>00476                                n,
<a name="l00477"></a>00477                                _base_shape_index[n], 
<a name="l00478"></a>00478                                _radial_shape_index[n]);
<a name="l00479"></a>00479         libmesh_assert (_base_shape_index[n]   &lt; n_base_approx_shape_functions);
<a name="l00480"></a>00480         libmesh_assert (_radial_shape_index[n] &lt; n_radial_approx_sf);
<a name="l00481"></a>00481       }
<a name="l00482"></a>00482   }
<a name="l00483"></a>00483  
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00489"></a>00489   <span class="comment">// resize the base data fields</span>
<a name="l00490"></a>00490   dist.resize(n_base_mapping_shape_functions);
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 
<a name="l00494"></a>00494   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00495"></a>00495   <span class="comment">// resize the total data fields</span>
<a name="l00496"></a>00496   
<a name="l00497"></a>00497   <span class="comment">// the phase term varies with xi, eta and zeta(v): store it for _all_ qp</span>
<a name="l00498"></a>00498   <span class="comment">//</span>
<a name="l00499"></a>00499   <span class="comment">// when computing the phase, we need the base approximations</span>
<a name="l00500"></a>00500   <span class="comment">// therefore, initialize the phase here, but evaluate it </span>
<a name="l00501"></a>00501   <span class="comment">// in combine_base_radial().</span>
<a name="l00502"></a>00502   <span class="comment">//</span>
<a name="l00503"></a>00503   <span class="comment">// the weight, though, is only needed at the radial quadrature points, n_radial_qp.</span>
<a name="l00504"></a>00504   <span class="comment">// but for a uniform interface to the protected data fields</span>
<a name="l00505"></a>00505   <span class="comment">// the weight data field (which are accessible from the outside) are expanded to n_total_qp.</span>
<a name="l00506"></a>00506   <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">weight</a>.resize      (n_total_qp);
<a name="l00507"></a>00507   dweightdv.resize   (n_total_qp);
<a name="l00508"></a>00508   dweight.resize     (n_total_qp);
<a name="l00509"></a>00509 
<a name="l00510"></a>00510   dphase.resize      (n_total_qp);
<a name="l00511"></a>00511   dphasedxi.resize   (n_total_qp);
<a name="l00512"></a>00512   dphasedeta.resize  (n_total_qp);
<a name="l00513"></a>00513   dphasedzeta.resize (n_total_qp);
<a name="l00514"></a>00514 
<a name="l00515"></a>00515   <span class="comment">// this vector contains the integration weights for the combined quadrature rule</span>
<a name="l00516"></a>00516   _total_qrule_weights.resize(n_total_qp);
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00520"></a>00520   <span class="comment">// InfFE&#39;s data fields phi, dphi, dphidx, phi_map etc hold the _total_</span>
<a name="l00521"></a>00521   <span class="comment">// shape and mapping functions, respectively</span>
<a name="l00522"></a>00522   {
<a name="l00523"></a>00523     phi.resize     (n_total_approx_shape_functions);
<a name="l00524"></a>00524     dphi.resize    (n_total_approx_shape_functions);
<a name="l00525"></a>00525     dphidx.resize  (n_total_approx_shape_functions);
<a name="l00526"></a>00526     dphidy.resize  (n_total_approx_shape_functions);
<a name="l00527"></a>00527     dphidz.resize  (n_total_approx_shape_functions);
<a name="l00528"></a>00528     dphidxi.resize (n_total_approx_shape_functions);
<a name="l00529"></a>00529 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00530"></a>00530 <span class="preprocessor"></span>    libmesh_do_once(<a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Second derivatives for Infinite elements&quot;</span>
<a name="l00531"></a>00531                                   &lt;&lt; <span class="stringliteral">&quot; are not yet implemented!&quot;</span>
<a name="l00532"></a>00532                                   &lt;&lt; std::endl);
<a name="l00533"></a>00533 
<a name="l00534"></a>00534     d2phi.resize     (n_total_approx_shape_functions);
<a name="l00535"></a>00535     d2phidx2.resize  (n_total_approx_shape_functions);
<a name="l00536"></a>00536     d2phidxdy.resize (n_total_approx_shape_functions);
<a name="l00537"></a>00537     d2phidxdz.resize (n_total_approx_shape_functions);
<a name="l00538"></a>00538     d2phidy2.resize  (n_total_approx_shape_functions);
<a name="l00539"></a>00539     d2phidydz.resize (n_total_approx_shape_functions);
<a name="l00540"></a>00540     d2phidz2.resize  (n_total_approx_shape_functions);
<a name="l00541"></a>00541     d2phidxi2.resize (n_total_approx_shape_functions);
<a name="l00542"></a>00542 
<a name="l00543"></a>00543     <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00544"></a>00544       {
<a name="l00545"></a>00545         d2phidxideta.resize   (n_total_approx_shape_functions);
<a name="l00546"></a>00546         d2phideta2.resize     (n_total_approx_shape_functions);
<a name="l00547"></a>00547       }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549     <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00550"></a>00550       {
<a name="l00551"></a>00551         d2phidetadzeta.resize (n_total_approx_shape_functions);
<a name="l00552"></a>00552         d2phidxidzeta.resize  (n_total_approx_shape_functions);
<a name="l00553"></a>00553         d2phidzeta2.resize    (n_total_approx_shape_functions);
<a name="l00554"></a>00554       }
<a name="l00555"></a>00555 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00556"></a>00556 <span class="preprocessor"></span>    
<a name="l00557"></a>00557     <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00558"></a>00558       dphideta.resize      (n_total_approx_shape_functions);
<a name="l00559"></a>00559     
<a name="l00560"></a>00560     <span class="keywordflow">if</span> (Dim == 3)
<a name="l00561"></a>00561       dphidzeta.resize     (n_total_approx_shape_functions);
<a name="l00562"></a>00562       
<a name="l00563"></a>00563     
<a name="l00564"></a>00564     phi_map.resize         (n_total_mapping_shape_functions);
<a name="l00565"></a>00565     dphidxi_map.resize     (n_total_mapping_shape_functions);
<a name="l00566"></a>00566 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00567"></a>00567 <span class="preprocessor"></span>    d2phidxi2_map.resize   (n_total_mapping_shape_functions);
<a name="l00568"></a>00568 
<a name="l00569"></a>00569     <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00570"></a>00570       {
<a name="l00571"></a>00571         d2phidxideta_map.resize   (n_total_mapping_shape_functions);
<a name="l00572"></a>00572         d2phideta2_map.resize     (n_total_mapping_shape_functions);
<a name="l00573"></a>00573       }
<a name="l00574"></a>00574 
<a name="l00575"></a>00575     <span class="keywordflow">if</span> (Dim == 3)
<a name="l00576"></a>00576       {
<a name="l00577"></a>00577         d2phidxidzeta_map.resize  (n_total_mapping_shape_functions);
<a name="l00578"></a>00578         d2phidetadzeta_map.resize (n_total_mapping_shape_functions);
<a name="l00579"></a>00579         d2phidzeta2_map.resize    (n_total_mapping_shape_functions);
<a name="l00580"></a>00580       }
<a name="l00581"></a>00581 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00582"></a>00582 <span class="preprocessor"></span>    
<a name="l00583"></a>00583     <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00584"></a>00584       dphideta_map.resize  (n_total_mapping_shape_functions);
<a name="l00585"></a>00585     
<a name="l00586"></a>00586     <span class="keywordflow">if</span> (Dim == 3)
<a name="l00587"></a>00587       dphidzeta_map.resize (n_total_mapping_shape_functions);
<a name="l00588"></a>00588   }
<a name="l00589"></a>00589 
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 
<a name="l00592"></a>00592   <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00593"></a>00593   <span class="comment">// collect all the for loops, where inner vectors are </span>
<a name="l00594"></a>00594   <span class="comment">// resized to the appropriate number of quadrature points</span>
<a name="l00595"></a>00595   {    
<a name="l00596"></a>00596     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_total_approx_shape_functions; i++)
<a name="l00597"></a>00597       {
<a name="l00598"></a>00598         phi[i].resize         (n_total_qp);
<a name="l00599"></a>00599         dphi[i].resize        (n_total_qp);
<a name="l00600"></a>00600         dphidx[i].resize      (n_total_qp);
<a name="l00601"></a>00601         dphidy[i].resize      (n_total_qp);
<a name="l00602"></a>00602         dphidz[i].resize      (n_total_qp);
<a name="l00603"></a>00603         dphidxi[i].resize     (n_total_qp);
<a name="l00604"></a>00604 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00605"></a>00605 <span class="preprocessor"></span>        d2phi[i].resize       (n_total_qp);
<a name="l00606"></a>00606         d2phidx2[i].resize    (n_total_qp);
<a name="l00607"></a>00607         d2phidxdy[i].resize   (n_total_qp);
<a name="l00608"></a>00608         d2phidxdz[i].resize   (n_total_qp);
<a name="l00609"></a>00609         d2phidy2[i].resize    (n_total_qp);
<a name="l00610"></a>00610         d2phidydz[i].resize   (n_total_qp);
<a name="l00611"></a>00611         d2phidy2[i].resize    (n_total_qp);
<a name="l00612"></a>00612         d2phidxi2[i].resize   (n_total_qp);
<a name="l00613"></a>00613 
<a name="l00614"></a>00614         <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00615"></a>00615           {
<a name="l00616"></a>00616             d2phidxideta[i].resize   (n_total_qp);
<a name="l00617"></a>00617             d2phideta2[i].resize     (n_total_qp);
<a name="l00618"></a>00618           }
<a name="l00619"></a>00619         <span class="keywordflow">if</span> (Dim &gt; 2)         
<a name="l00620"></a>00620           {
<a name="l00621"></a>00621             d2phidxidzeta[i].resize  (n_total_qp);
<a name="l00622"></a>00622             d2phidetadzeta[i].resize (n_total_qp);
<a name="l00623"></a>00623             d2phidzeta2[i].resize    (n_total_qp);
<a name="l00624"></a>00624           }
<a name="l00625"></a>00625 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00626"></a>00626 <span class="preprocessor"></span>           
<a name="l00627"></a>00627         <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00628"></a>00628           dphideta[i].resize  (n_total_qp);
<a name="l00629"></a>00629            
<a name="l00630"></a>00630         <span class="keywordflow">if</span> (Dim == 3)        
<a name="l00631"></a>00631           dphidzeta[i].resize (n_total_qp);
<a name="l00632"></a>00632              
<a name="l00633"></a>00633       }
<a name="l00634"></a>00634        
<a name="l00635"></a>00635     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_total_mapping_shape_functions; i++)
<a name="l00636"></a>00636       {
<a name="l00637"></a>00637         phi_map[i].resize         (n_total_qp);
<a name="l00638"></a>00638         dphidxi_map[i].resize     (n_total_qp);
<a name="l00639"></a>00639 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00640"></a>00640 <span class="preprocessor"></span>        d2phidxi2_map[i].resize   (n_total_qp);
<a name="l00641"></a>00641         <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00642"></a>00642           {
<a name="l00643"></a>00643             d2phidxideta_map[i].resize   (n_total_qp);
<a name="l00644"></a>00644             d2phideta2_map[i].resize     (n_total_qp);
<a name="l00645"></a>00645           }
<a name="l00646"></a>00646 
<a name="l00647"></a>00647         <span class="keywordflow">if</span> (Dim &gt; 2)
<a name="l00648"></a>00648           {
<a name="l00649"></a>00649             d2phidxidzeta_map[i].resize  (n_total_qp);
<a name="l00650"></a>00650             d2phidetadzeta_map[i].resize (n_total_qp);
<a name="l00651"></a>00651             d2phidzeta2_map[i].resize    (n_total_qp);
<a name="l00652"></a>00652           }
<a name="l00653"></a>00653 <span class="preprocessor">#endif // ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00654"></a>00654 <span class="preprocessor"></span>           
<a name="l00655"></a>00655         <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00656"></a>00656           dphideta_map[i].resize  (n_total_qp);
<a name="l00657"></a>00657            
<a name="l00658"></a>00658         <span class="keywordflow">if</span> (Dim == 3)
<a name="l00659"></a>00659           dphidzeta_map[i].resize (n_total_qp);
<a name="l00660"></a>00660       }
<a name="l00661"></a>00661   }
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   {
<a name="l00666"></a>00666     <span class="comment">// -----------------------------------------------------------------</span>
<a name="l00667"></a>00667     <span class="comment">// (a) compute scalar values at _all_ quadrature points  -- for uniform </span>
<a name="l00668"></a>00668     <span class="comment">//     access from the outside to these fields</span>
<a name="l00669"></a>00669     <span class="comment">// (b) form a std::vector&lt;Real&gt; which contains the appropriate weights</span>
<a name="l00670"></a>00670     <span class="comment">//     of the combined quadrature rule!</span>
<a name="l00671"></a>00671     <span class="keyword">const</span> std::vector&lt;Point&gt;&amp;  radial_qp = radial_qrule-&gt;get_points();
<a name="l00672"></a>00672     libmesh_assert (radial_qp.size() == n_radial_qp);
<a name="l00673"></a>00673 
<a name="l00674"></a>00674     <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;   radial_qw = radial_qrule-&gt;get_weights();
<a name="l00675"></a>00675     <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;   base_qw   = base_qrule-&gt;get_weights();
<a name="l00676"></a>00676     libmesh_assert (radial_qw.size() == n_radial_qp);
<a name="l00677"></a>00677     libmesh_assert (base_qw.size()   == n_base_qp);
<a name="l00678"></a>00678 
<a name="l00679"></a>00679     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rp=0; rp&lt;n_radial_qp; rp++)
<a name="l00680"></a>00680       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp=0; bp&lt;n_base_qp; bp++)
<a name="l00681"></a>00681         {
<a name="l00682"></a>00682           <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">weight</a>   [ bp+rp*n_base_qp ] = Radial::D       (radial_qp[rp](0)); 
<a name="l00683"></a>00683           dweightdv[ bp+rp*n_base_qp ] = Radial::D_deriv (radial_qp[rp](0));
<a name="l00684"></a>00684 
<a name="l00685"></a>00685           _total_qrule_weights[  bp+rp*n_base_qp ] = radial_qw[rp] * base_qw[bp];
<a name="l00686"></a>00686         }
<a name="l00687"></a>00687   }
<a name="l00688"></a>00688 
<a name="l00689"></a>00689  
<a name="l00693"></a>00693   STOP_LOG(<span class="stringliteral">&quot;init_shape_functions()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00694"></a>00694 
<a name="l00695"></a>00695 }
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 
<a name="l00698"></a>00698 
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 
<a name="l00701"></a>00701 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00702"></a><a class="code" href="classlibMesh_1_1InfFE.php#a07964b091022a4b60b205053fe2fc8c0">00702</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a07964b091022a4b60b205053fe2fc8c0">InfFE&lt;Dim,T_radial,T_map&gt;::combine_base_radial</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem)
<a name="l00703"></a>00703 {
<a name="l00704"></a>00704   libmesh_assert (inf_elem != NULL);
<a name="l00705"></a>00705   <span class="comment">// at least check whether the base element type is correct.</span>
<a name="l00706"></a>00706   <span class="comment">// otherwise this version of computing dist would give problems</span>
<a name="l00707"></a>00707   libmesh_assert (base_elem-&gt;type() == Base::get_elem_type(inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>()));
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00713"></a>00713   START_LOG(<span class="stringliteral">&quot;combine_base_radial()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 
<a name="l00716"></a>00716   <span class="comment">// zero  the phase, since it is to be summed up</span>
<a name="l00717"></a>00717   std::fill (dphasedxi.begin(),   dphasedxi.end(),   0.);
<a name="l00718"></a>00718   std::fill (dphasedeta.begin(),  dphasedeta.end(),  0.);
<a name="l00719"></a>00719   std::fill (dphasedzeta.begin(), dphasedzeta.end(), 0.);
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 
<a name="l00722"></a>00722   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_mapping_sf   = dist.size();
<a name="l00723"></a>00723   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> origin                     = inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4da21e127a2f2f1b35168b3cfd458b74">origin</a>();
<a name="l00724"></a>00724 
<a name="l00725"></a>00725   <span class="comment">// for each new infinite element, compute the radial distances</span>
<a name="l00726"></a>00726   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_base_mapping_sf; n++)
<a name="l00727"></a>00727       dist[n] =  <a class="code" href="classlibMesh_1_1Point.php">Point</a>(base_elem-&gt;point(n) - origin).size();
<a name="l00728"></a>00728 
<a name="l00729"></a>00729 
<a name="l00730"></a>00730   <span class="keywordflow">switch</span> (Dim)
<a name="l00731"></a>00731     {
<a name="l00732"></a>00732 
<a name="l00733"></a>00733       <span class="comment">//------------------------------------------------------------</span>
<a name="l00734"></a>00734       <span class="comment">// 1D</span>
<a name="l00735"></a>00735     <span class="keywordflow">case</span> 1:
<a name="l00736"></a>00736       {
<a name="l00737"></a>00737         libmesh_not_implemented();
<a name="l00738"></a>00738         <span class="keywordflow">break</span>;
<a name="l00739"></a>00739       }
<a name="l00740"></a>00740 
<a name="l00741"></a>00741 
<a name="l00742"></a>00742       
<a name="l00743"></a>00743       <span class="comment">//------------------------------------------------------------</span>
<a name="l00744"></a>00744       <span class="comment">// 2D</span>
<a name="l00745"></a>00745     <span class="keywordflow">case</span> 2:
<a name="l00746"></a>00746       {
<a name="l00747"></a>00747         libmesh_not_implemented();
<a name="l00748"></a>00748         <span class="keywordflow">break</span>;
<a name="l00749"></a>00749       }
<a name="l00750"></a>00750 
<a name="l00751"></a>00751 
<a name="l00752"></a>00752       
<a name="l00753"></a>00753       <span class="comment">//------------------------------------------------------------</span>
<a name="l00754"></a>00754       <span class="comment">// 3D</span>
<a name="l00755"></a>00755     <span class="keywordflow">case</span> 3:
<a name="l00756"></a>00756       {
<a name="l00757"></a>00757         <span class="comment">// fast access to the approximation and mapping shapes of base_fe</span>
<a name="l00758"></a>00758         <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; S  = base_fe-&gt;phi;
<a name="l00759"></a>00759         <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; Ss = base_fe-&gt;dphidxi;
<a name="l00760"></a>00760         <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; St = base_fe-&gt;dphideta;
<a name="l00761"></a>00761         <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; S_map  = base_fe-&gt;phi_map;
<a name="l00762"></a>00762         <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; Ss_map = base_fe-&gt;dphidxi_map;
<a name="l00763"></a>00763         <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; St_map = base_fe-&gt;dphideta_map;
<a name="l00764"></a>00764 
<a name="l00765"></a>00765         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_radial_qp         = radial_qrule-&gt;n_points();
<a name="l00766"></a>00766         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_qp           = base_qrule-&gt;  n_points();
<a name="l00767"></a>00767 
<a name="l00768"></a>00768         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_total_mapping_sf  = radial_map.size() * n_base_mapping_sf;
<a name="l00769"></a>00769 
<a name="l00770"></a>00770         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_total_approx_sf   = Radial::n_dofs(fe_type.radial_order) *  base_fe-&gt;n_shape_functions();
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 
<a name="l00773"></a>00773         <span class="comment">// compute the phase term derivatives</span>
<a name="l00774"></a>00774         {
<a name="l00775"></a>00775           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tp=0;
<a name="l00776"></a>00776           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rp=0; rp&lt;n_radial_qp; rp++)  <span class="comment">// over radial qp&#39;s</span>
<a name="l00777"></a>00777             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp=0; bp&lt;n_base_qp; bp++)  <span class="comment">// over base qp&#39;s</span>
<a name="l00778"></a>00778               {
<a name="l00779"></a>00779                 <span class="comment">// sum over all base shapes, to get the average distance</span>
<a name="l00780"></a>00780                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_base_mapping_sf; i++)
<a name="l00781"></a>00781                   {
<a name="l00782"></a>00782                     dphasedxi[tp]   += Ss_map[i][bp] * dist[i] * radial_map   [1][rp];
<a name="l00783"></a>00783                     dphasedeta[tp]  += St_map[i][bp] * dist[i] * radial_map   [1][rp];
<a name="l00784"></a>00784                     dphasedzeta[tp] += S_map [i][bp] * dist[i] * dradialdv_map[1][rp];
<a name="l00785"></a>00785                   }
<a name="l00786"></a>00786 
<a name="l00787"></a>00787                 tp++;
<a name="l00788"></a>00788 
<a name="l00789"></a>00789               } <span class="comment">// loop radial and base qp&#39;s</span>
<a name="l00790"></a>00790 
<a name="l00791"></a>00791         }
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 
<a name="l00796"></a>00796         libmesh_assert (phi.size()       == n_total_approx_sf);
<a name="l00797"></a>00797         libmesh_assert (dphidxi.size()   == n_total_approx_sf);
<a name="l00798"></a>00798         libmesh_assert (dphideta.size()  == n_total_approx_sf);
<a name="l00799"></a>00799         libmesh_assert (dphidzeta.size() == n_total_approx_sf);
<a name="l00800"></a>00800         
<a name="l00801"></a>00801         <span class="comment">// compute the overall approximation shape functions,</span>
<a name="l00802"></a>00802         <span class="comment">// pick the appropriate radial and base shapes through using</span>
<a name="l00803"></a>00803         <span class="comment">// _base_shape_index and _radial_shape_index</span>
<a name="l00804"></a>00804         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rp=0; rp&lt;n_radial_qp; rp++)  <span class="comment">// over radial qp&#39;s</span>
<a name="l00805"></a>00805           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp=0; bp&lt;n_base_qp; bp++)  <span class="comment">// over base qp&#39;s</span>
<a name="l00806"></a>00806             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ti=0; ti&lt;n_total_approx_sf; ti++)  <span class="comment">// over _all_ approx_sf</span>
<a name="l00807"></a>00807               {
<a name="l00808"></a>00808                 <span class="comment">// let the index vectors take care of selecting the appropriate base/radial shape</span>
<a name="l00809"></a>00809                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bi = _base_shape_index  [ti];
<a name="l00810"></a>00810                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ri = _radial_shape_index[ti];
<a name="l00811"></a>00811                 phi      [ti][bp+rp*n_base_qp] = S [bi][bp] * mode[ri][rp] * som[rp];
<a name="l00812"></a>00812                 dphidxi  [ti][bp+rp*n_base_qp] = Ss[bi][bp] * mode[ri][rp] * som[rp];
<a name="l00813"></a>00813                 dphideta [ti][bp+rp*n_base_qp] = St[bi][bp] * mode[ri][rp] * som[rp];
<a name="l00814"></a>00814                 dphidzeta[ti][bp+rp*n_base_qp] = S [bi][bp] 
<a name="l00815"></a>00815                     * (dmodedv[ri][rp] * som[rp] + mode[ri][rp] * dsomdv[rp]);
<a name="l00816"></a>00816               }
<a name="l00817"></a>00817 
<a name="l00818"></a>00818         
<a name="l00819"></a>00819         libmesh_assert (phi_map.size()       == n_total_mapping_sf);
<a name="l00820"></a>00820         libmesh_assert (dphidxi_map.size()   == n_total_mapping_sf);
<a name="l00821"></a>00821         libmesh_assert (dphideta_map.size()  == n_total_mapping_sf);
<a name="l00822"></a>00822         libmesh_assert (dphidzeta_map.size() == n_total_mapping_sf);
<a name="l00823"></a>00823         
<a name="l00824"></a>00824         <span class="comment">// compute the overall mapping functions,</span>
<a name="l00825"></a>00825         <span class="comment">// pick the appropriate radial and base entries through using</span>
<a name="l00826"></a>00826         <span class="comment">// _base_node_index and _radial_node_index</span>
<a name="l00827"></a>00827         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rp=0; rp&lt;n_radial_qp; rp++)  <span class="comment">// over radial qp&#39;s</span>
<a name="l00828"></a>00828           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp=0; bp&lt;n_base_qp; bp++)  <span class="comment">// over base qp&#39;s</span>
<a name="l00829"></a>00829             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ti=0; ti&lt;n_total_mapping_sf; ti++)  <span class="comment">// over all mapping shapes</span>
<a name="l00830"></a>00830               {
<a name="l00831"></a>00831                 <span class="comment">// let the index vectors take care of selecting the appropriate base/radial mapping shape</span>
<a name="l00832"></a>00832                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bi = _base_node_index  [ti];
<a name="l00833"></a>00833                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ri = _radial_node_index[ti];
<a name="l00834"></a>00834                 phi_map      [ti][bp+rp*n_base_qp] = S_map [bi][bp] * radial_map   [ri][rp];
<a name="l00835"></a>00835                 dphidxi_map  [ti][bp+rp*n_base_qp] = Ss_map[bi][bp] * radial_map   [ri][rp];
<a name="l00836"></a>00836                 dphideta_map [ti][bp+rp*n_base_qp] = St_map[bi][bp] * radial_map   [ri][rp];
<a name="l00837"></a>00837                 dphidzeta_map[ti][bp+rp*n_base_qp] = S_map [bi][bp] * dradialdv_map[ri][rp];
<a name="l00838"></a>00838               }
<a name="l00839"></a>00839                         
<a name="l00840"></a>00840 
<a name="l00841"></a>00841         <span class="keywordflow">break</span>;
<a name="l00842"></a>00842       }
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a>00845     <span class="keywordflow">default</span>:
<a name="l00846"></a>00846       libmesh_error();
<a name="l00847"></a>00847     }
<a name="l00848"></a>00848 
<a name="l00849"></a>00849 
<a name="l00853"></a>00853   STOP_LOG(<span class="stringliteral">&quot;combine_base_radial()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 }
<a name="l00856"></a>00856 
<a name="l00857"></a>00857 
<a name="l00858"></a>00858 
<a name="l00859"></a>00859 
<a name="l00860"></a>00860 
<a name="l00861"></a>00861 
<a name="l00862"></a>00862 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00863"></a><a class="code" href="classlibMesh_1_1InfFE.php#a3f39c07a1067bc51cf145ae77f48575c">00863</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a3f39c07a1067bc51cf145ae77f48575c">InfFE&lt;Dim,T_radial,T_map&gt;::compute_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*)
<a name="l00864"></a>00864 {
<a name="l00865"></a>00865   libmesh_assert (radial_qrule != NULL);
<a name="l00866"></a>00866 
<a name="l00867"></a>00867 
<a name="l00868"></a>00868   
<a name="l00869"></a>00869   <span class="comment">// Start logging the overall computation of shape functions</span>
<a name="l00870"></a>00870   START_LOG(<span class="stringliteral">&quot;compute_shape_functions()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 
<a name="l00873"></a>00873   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_total_qp  = _n_total_qp;
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 
<a name="l00876"></a>00876   <span class="comment">//-------------------------------------------------------------------------</span>
<a name="l00877"></a>00877   <span class="comment">// Compute the shape function values (and derivatives)</span>
<a name="l00878"></a>00878   <span class="comment">// at the Quadrature points.  Note that the actual values</span>
<a name="l00879"></a>00879   <span class="comment">// have already been computed via init_shape_functions</span>
<a name="l00880"></a>00880 
<a name="l00881"></a>00881   <span class="comment">// Compute the value of the derivative shape function i at quadrature point p</span>
<a name="l00882"></a>00882   <span class="keywordflow">switch</span> (dim)
<a name="l00883"></a>00883     {
<a name="l00884"></a>00884       
<a name="l00885"></a>00885     <span class="keywordflow">case</span> 1:
<a name="l00886"></a>00886       {
<a name="l00887"></a>00887         libmesh_not_implemented();
<a name="l00888"></a>00888         <span class="keywordflow">break</span>;
<a name="l00889"></a>00889       }
<a name="l00890"></a>00890 
<a name="l00891"></a>00891     <span class="keywordflow">case</span> 2:
<a name="l00892"></a>00892       {
<a name="l00893"></a>00893         libmesh_not_implemented();
<a name="l00894"></a>00894         <span class="keywordflow">break</span>;
<a name="l00895"></a>00895       }
<a name="l00896"></a>00896     
<a name="l00897"></a>00897     <span class="keywordflow">case</span> 3:
<a name="l00898"></a>00898       {
<a name="l00899"></a>00899         <span class="comment">// These are _all_ shape functions of this infinite element</span>
<a name="l00900"></a>00900         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;phi.size(); i++)
<a name="l00901"></a>00901           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_total_qp; p++)
<a name="l00902"></a>00902             {
<a name="l00903"></a>00903               <span class="comment">// dphi/dx    = (dphi/dxi)*(dxi/dx) + (dphi/deta)*(deta/dx) + (dphi/dzeta)*(dzeta/dx);</span>
<a name="l00904"></a>00904               dphi[i][p](0) =
<a name="l00905"></a>00905                 dphidx[i][p] = (dphidxi[i][p]*dxidx_map[p] +
<a name="l00906"></a>00906                                 dphideta[i][p]*detadx_map[p] +
<a name="l00907"></a>00907                                 dphidzeta[i][p]*dzetadx_map[p]);
<a name="l00908"></a>00908                 
<a name="l00909"></a>00909               <span class="comment">// dphi/dy    = (dphi/dxi)*(dxi/dy) + (dphi/deta)*(deta/dy) + (dphi/dzeta)*(dzeta/dy);</span>
<a name="l00910"></a>00910               dphi[i][p](1) =
<a name="l00911"></a>00911                 dphidy[i][p] = (dphidxi[i][p]*dxidy_map[p] +
<a name="l00912"></a>00912                                 dphideta[i][p]*detady_map[p] +
<a name="l00913"></a>00913                                 dphidzeta[i][p]*dzetady_map[p]);
<a name="l00914"></a>00914                 
<a name="l00915"></a>00915               <span class="comment">// dphi/dz    = (dphi/dxi)*(dxi/dz) + (dphi/deta)*(deta/dz) + (dphi/dzeta)*(dzeta/dz);</span>
<a name="l00916"></a>00916               dphi[i][p](2) =
<a name="l00917"></a>00917                 dphidz[i][p] = (dphidxi[i][p]*dxidz_map[p] +
<a name="l00918"></a>00918                                 dphideta[i][p]*detadz_map[p] +
<a name="l00919"></a>00919                                 dphidzeta[i][p]*dzetadz_map[p]);              
<a name="l00920"></a>00920             }
<a name="l00921"></a>00921 
<a name="l00922"></a>00922 
<a name="l00923"></a>00923         <span class="comment">// This is the derivative of the phase term of this infinite element</span>
<a name="l00924"></a>00924         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p&lt;n_total_qp; p++)
<a name="l00925"></a>00925           {
<a name="l00926"></a>00926             <span class="comment">// the derivative of the phase term</span>
<a name="l00927"></a>00927             dphase[p](0) = (dphasedxi[p]   * dxidx_map[p] +
<a name="l00928"></a>00928                             dphasedeta[p]  * detadx_map[p] +
<a name="l00929"></a>00929                             dphasedzeta[p] * dzetadx_map[p]);
<a name="l00930"></a>00930                 
<a name="l00931"></a>00931             dphase[p](1) = (dphasedxi[p]   * dxidy_map[p] +
<a name="l00932"></a>00932                             dphasedeta[p]  * detady_map[p] +
<a name="l00933"></a>00933                             dphasedzeta[p] * dzetady_map[p]);
<a name="l00934"></a>00934                 
<a name="l00935"></a>00935             dphase[p](2) = (dphasedxi[p]   * dxidz_map[p] +
<a name="l00936"></a>00936                             dphasedeta[p]  * detadz_map[p] +
<a name="l00937"></a>00937                             dphasedzeta[p] * dzetadz_map[p]);
<a name="l00938"></a>00938 
<a name="l00939"></a>00939             <span class="comment">// the derivative of the radial weight - varies only in radial direction,</span>
<a name="l00940"></a>00940             <span class="comment">// therefore dweightdxi = dweightdeta = 0.</span>
<a name="l00941"></a>00941             dweight[p](0) = dweightdv[p] * dzetadx_map[p];
<a name="l00942"></a>00942                 
<a name="l00943"></a>00943             dweight[p](1) = dweightdv[p] * dzetady_map[p];
<a name="l00944"></a>00944                 
<a name="l00945"></a>00945             dweight[p](2) = dweightdv[p] * dzetadz_map[p];
<a name="l00946"></a>00946 
<a name="l00947"></a>00947           }
<a name="l00948"></a>00948 
<a name="l00949"></a>00949         <span class="keywordflow">break</span>;
<a name="l00950"></a>00950       }
<a name="l00951"></a>00951 
<a name="l00952"></a>00952 
<a name="l00953"></a>00953 
<a name="l00954"></a>00954     <span class="keywordflow">default</span>:
<a name="l00955"></a>00955       {
<a name="l00956"></a>00956         libmesh_error();
<a name="l00957"></a>00957       }
<a name="l00958"></a>00958     }
<a name="l00959"></a>00959 
<a name="l00960"></a>00960 
<a name="l00961"></a>00961   
<a name="l00962"></a>00962   <span class="comment">// Stop logging the overall computation of shape functions</span>
<a name="l00963"></a>00963   STOP_LOG(<span class="stringliteral">&quot;compute_shape_functions()&quot;</span>, <span class="stringliteral">&quot;InfFE&quot;</span>);
<a name="l00964"></a>00964 
<a name="l00965"></a>00965 }
<a name="l00966"></a>00966 
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 
<a name="l00969"></a>00969 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00970"></a><a class="code" href="classlibMesh_1_1InfFE.php#adbdc8acb4cd4dcb36e73f4e303c13ba3">00970</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfFE.php#adbdc8acb4cd4dcb36e73f4e303c13ba3">InfFE&lt;Dim,T_radial,T_map&gt;::shapes_need_reinit</a>()<span class="keyword"> const </span>
<a name="l00971"></a>00971 <span class="keyword"></span>{ 
<a name="l00972"></a>00972   <span class="keywordflow">return</span> <span class="keyword">false</span>; 
<a name="l00973"></a>00973 }
<a name="l00974"></a>00974 
<a name="l00975"></a>00975 } <span class="comment">// namespace libMesh</span>
<a name="l00976"></a>00976 
<a name="l00977"></a>00977 
<a name="l00978"></a>00978 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00979"></a>00979 <span class="comment">// Explicit instantiations</span>
<a name="l00980"></a>00980 <span class="preprocessor">#include &quot;<a class="code" href="inf__fe__instantiate__1D_8h.php">inf_fe_instantiate_1D.h</a>&quot;</span>
<a name="l00981"></a>00981 <span class="preprocessor">#include &quot;<a class="code" href="inf__fe__instantiate__2D_8h.php">inf_fe_instantiate_2D.h</a>&quot;</span>
<a name="l00982"></a>00982 <span class="preprocessor">#include &quot;<a class="code" href="inf__fe__instantiate__3D_8h.php">inf_fe_instantiate_3D.h</a>&quot;</span>
<a name="l00983"></a>00983 
<a name="l00984"></a>00984 
<a name="l00985"></a>00985 
<a name="l00986"></a>00986 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00987"></a>00987 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
