<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_fbfd1e4ea7786050feab5206011c3dac.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_fe.h</div>  </div>
</div>
<div class="contents">
<a href="inf__fe_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __inf_fe_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __inf_fe_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// forward declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>Elem;
<a name="l00039"></a>00039 <span class="keyword">class </span>FEComputeData;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00075"></a>00075 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00076"></a>00076 <span class="comment">// InfFE class definition</span>
<a name="l00077"></a>00077 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00078"></a><a class="code" href="classlibMesh_1_1InfFE.php">00078</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfFE.php">InfFE</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a>
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="comment">/*</span>
<a name="l00082"></a>00082 <span class="comment"> * Protect the nested class</span>
<a name="l00083"></a>00083 <span class="comment"> */</span>
<a name="l00084"></a>00084 <span class="keyword">protected</span>:
<a name="l00085"></a>00085 
<a name="l00097"></a>00097   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00098"></a>00098   <span class="comment">// InfFE::Radial class definition</span>
<a name="l00099"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php">00099</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php">Radial</a>
<a name="l00100"></a>00100   {
<a name="l00101"></a>00101   <span class="keyword">private</span>:
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a2ea4204db590c1402db3a05ed551a5ca">00106</a>     <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a2ea4204db590c1402db3a05ed551a5ca">Radial</a>() {}
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="keyword">public</span>:
<a name="l00109"></a>00109 
<a name="l00114"></a>00114     <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#aa102427e01a09378006d335620b38959">decay</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v);
<a name="l00115"></a>00115 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a8ccb63afceb173a535fea38d72e2001a">00120</a>     <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a8ccb63afceb173a535fea38d72e2001a">decay_deriv</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>) { <span class="keywordflow">return</span> -.5; }
<a name="l00121"></a>00121 
<a name="l00126"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a55d0d93d80c1ffc8cc042ca70c7b835a">00126</a>     <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a55d0d93d80c1ffc8cc042ca70c7b835a">D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v) { <span class="keywordflow">return</span> (1.-v)*(1.-v)/4.; }
<a name="l00127"></a>00127 
<a name="l00131"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a962b9c073b2281f369d8490fb31fb56b">00131</a>     <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a962b9c073b2281f369d8490fb31fb56b">D_deriv</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v) { <span class="keywordflow">return</span> (v-1.)/2.; }
<a name="l00132"></a>00132 
<a name="l00137"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a00338f14ba1b01b39c6821a04ad492f5">00137</a>     <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a00338f14ba1b01b39c6821a04ad492f5">mapping_order</a>() { <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00138"></a>00138 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a1bf99c1d6fda549041598002570b4a85">00151</a>     <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a1bf99c1d6fda549041598002570b4a85">n_dofs</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial)
<a name="l00152"></a>00152         { <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(o_radial)+1; }
<a name="l00153"></a>00153 
<a name="l00163"></a>00163     <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a3ea0a9dc18f741f952216aedcf4bcf56">n_dofs_at_node</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial,
<a name="l00164"></a>00164                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_onion);
<a name="l00165"></a>00165 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#ac11fb035de4a2945e8fceaca82c138bb">00173</a>     <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#ac11fb035de4a2945e8fceaca82c138bb">n_dofs_per_elem</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial)
<a name="l00174"></a>00174         { <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(o_radial)+1; }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   };
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00189"></a>00189   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00190"></a>00190   <span class="comment">// InfFE::Base class definition</span>
<a name="l00191"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Base.php">00191</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfFE_1_1Base.php">Base</a>
<a name="l00192"></a>00192   {
<a name="l00193"></a>00193   <span class="keyword">private</span>:
<a name="l00194"></a>00194 
<a name="l00198"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#a7a8e785aeb47ef888e8030e91057f503">00198</a>     <a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#a7a8e785aeb47ef888e8030e91057f503">Base</a>() {}
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="keyword">public</span>:
<a name="l00201"></a>00201 
<a name="l00207"></a>00207     <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#ac4e83a84826fc6f474562914835fe1d4">build_elem</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem);
<a name="l00208"></a>00208 
<a name="l00214"></a>00214     <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#a74f3001d8817766a047c06c214a7d0f5">get_elem_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00215"></a>00215 
<a name="l00221"></a>00221     <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#acf8759dd16d8c42964c95aa22f5d7e82">n_base_mapping_sf</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_elem_type,
<a name="l00222"></a>00222                                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> base_mapping_order);
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   };
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="keyword">public</span>:
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00235"></a>00235   <span class="comment">// InfFE continued</span>
<a name="l00236"></a>00236 
<a name="l00250"></a>00250   <a class="code" href="classlibMesh_1_1InfFE.php#a30966325e9cd5ef7b41e45148b6919ed">InfFE</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet);
<a name="l00251"></a>00251 
<a name="l00255"></a>00255   <a class="code" href="classlibMesh_1_1InfFE.php#a30d276887bb6076968b6e42c9906f6af">~InfFE</a>();
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00262"></a>00262   <span class="comment">// The static public members for access from FEInterface etc</span>
<a name="l00274"></a>00274 <span class="comment"></span>  <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#aa8d2683754d22d28af105ff858cbb273">shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00275"></a>00275                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t,
<a name="l00276"></a>00276                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00277"></a>00277                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00278"></a>00278 
<a name="l00290"></a>00290   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#aa8d2683754d22d28af105ff858cbb273">shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00291"></a>00291                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00292"></a>00292                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00293"></a>00293                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00294"></a>00294 
<a name="l00304"></a>00304   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#abeba42623f9312b6d884e974de4751e1">compute_data</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_t,
<a name="l00305"></a>00305                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem,
<a name="l00306"></a>00306                            <a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a>&amp; data);
<a name="l00307"></a>00307   
<a name="l00312"></a><a class="code" href="classlibMesh_1_1InfFE.php#a5a9fd925cd569bd7ec10a44d315cfa29">00312</a>   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#ac401c91cb103fdd546f3226098647637">n_shape_functions</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00313"></a>00313                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> t)
<a name="l00314"></a>00314     { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfFE.php#a3f1303f14c587b80140058f4652ea5c6">n_dofs</a>(fet, t); }
<a name="l00315"></a>00315 
<a name="l00321"></a>00321   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#a3f1303f14c587b80140058f4652ea5c6">n_dofs</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00322"></a>00322                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type);
<a name="l00323"></a>00323 
<a name="l00328"></a>00328   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#a197bf5ebd7b734cb9de463f714ed2293">n_dofs_at_node</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00329"></a>00329                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00330"></a>00330                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00331"></a>00331 
<a name="l00336"></a>00336   <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#ad970acd91b1df49608f75375a594df94">n_dofs_per_elem</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00337"></a>00337                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type);
<a name="l00338"></a>00338 
<a name="l00342"></a><a class="code" href="classlibMesh_1_1InfFE.php#abbd66cc7a6a4ea200bf6341507803e42">00342</a>   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14">FEContinuity</a> <a class="code" href="classlibMesh_1_1InfFE.php#abbd66cc7a6a4ea200bf6341507803e42">get_continuity</a>()<span class="keyword"> const</span>
<a name="l00343"></a>00343 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a5061b5224c9a6d92d69b978b5733cb14a446bca00517e1159cb7602d89b600878">C_ZERO</a>; }  <span class="comment">// FIXME - is this true??</span>
<a name="l00344"></a>00344 
<a name="l00349"></a><a class="code" href="classlibMesh_1_1InfFE.php#a4b4ff316f07d4b3b4a9659893f5ab3ac">00349</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfFE.php#a4b4ff316f07d4b3b4a9659893f5ab3ac">is_hierarchic</a>()<span class="keyword"> const</span>
<a name="l00350"></a>00350 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }  <span class="comment">// FIXME - Inf FEs don&#39;t handle p elevation yet</span>
<a name="l00351"></a>00351 
<a name="l00359"></a>00359   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#af60a6f7d080591594db6e2736f55bcb7">nodal_soln</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00360"></a>00360                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, 
<a name="l00361"></a>00361                          <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; elem_soln,
<a name="l00362"></a>00362                          std::vector&lt;Number&gt;&amp; <a class="code" href="classlibMesh_1_1InfFE.php#af60a6f7d080591594db6e2736f55bcb7">nodal_soln</a>);
<a name="l00363"></a>00363 
<a name="l00379"></a>00379   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfFE.php#a51a38af27d2c722b6b1351e681fcd2e1">inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00380"></a>00380                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00381"></a>00381                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE,
<a name="l00382"></a>00382                             <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>,
<a name="l00383"></a>00383                             <span class="keyword">const</span> <span class="keywordtype">bool</span> interpolated = <span class="keyword">true</span>);
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 
<a name="l00392"></a>00392   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a51a38af27d2c722b6b1351e681fcd2e1">inverse_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00393"></a>00393                            <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; physical_points,
<a name="l00394"></a>00394                            std::vector&lt;Point&gt;&amp;       reference_points,
<a name="l00395"></a>00395                            <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE,
<a name="l00396"></a>00396                            <span class="keyword">const</span> <span class="keywordtype">bool</span> secure = <span class="keyword">true</span>);
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00400"></a>00400   <span class="comment">// The work-horses of InfFE. These are often used during matrix assembly</span>
<a name="l00407"></a>00407 <span class="comment"></span>  <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a9ae89fdd879752a80e324fe648a11631">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00408"></a>00408                        <span class="keyword">const</span> std::vector&lt;Point&gt;* <span class="keyword">const</span> pts);
<a name="l00409"></a>00409     
<a name="l00415"></a>00415   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a9ae89fdd879752a80e324fe648a11631">reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00416"></a>00416                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>,
<a name="l00417"></a>00417                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE);
<a name="l00418"></a>00418 
<a name="l00424"></a>00424   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a21495281a7bab390e35ded72fd5b3f0a">edge_reinit</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00425"></a>00425                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> edge,
<a name="l00426"></a>00426                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance = TOLERANCE);
<a name="l00427"></a>00427 
<a name="l00439"></a>00439   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a03afde0d34a0a9349b8f52c9a84a1cde">attach_quadrature_rule</a> (<a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* q);
<a name="l00440"></a>00440 
<a name="l00445"></a><a class="code" href="classlibMesh_1_1InfFE.php#ac401c91cb103fdd546f3226098647637">00445</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#ac401c91cb103fdd546f3226098647637">n_shape_functions</a> ()<span class="keyword"> const</span>
<a name="l00446"></a>00446 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfFE.php#a7ebb8cd747c04c8fcb911009966a3ef2">_n_total_approx_sf</a>; }
<a name="l00447"></a>00447   
<a name="l00453"></a><a class="code" href="classlibMesh_1_1InfFE.php#acbc70acf0907a6ac0ccafaa0c7b69717">00453</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#acbc70acf0907a6ac0ccafaa0c7b69717">n_quadrature_points</a> ()<span class="keyword"> const</span>
<a name="l00454"></a>00454 <span class="keyword">  </span>{ libmesh_assert (<a class="code" href="classlibMesh_1_1InfFE.php#a82a715d96edc647b78624bc497405c8f">radial_qrule</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfFE.php#aad3d47439098e6e8643ffcb033518e83">_n_total_qp</a>; }
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 
<a name="l00457"></a>00457 <span class="keyword">protected</span>:
<a name="l00458"></a>00458 
<a name="l00459"></a>00459   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00460"></a>00460   <span class="comment">// static members used by the &quot;work-horses&quot;</span>
<a name="l00461"></a>00461 
<a name="l00478"></a>00478   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00479"></a>00479                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial,
<a name="l00480"></a>00480                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00481"></a>00481   
<a name="l00487"></a>00487   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00488"></a>00488                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial,
<a name="l00489"></a>00489                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
<a name="l00493"></a>00493   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00494"></a>00494   <span class="comment">// Non-static members used by the &quot;work-horses&quot;</span>
<a name="l00499"></a>00499 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#ab446eaf1bea81ca7a9f4676cccd48a6e">update_base_elem</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem);
<a name="l00500"></a>00500 
<a name="l00504"></a><a class="code" href="classlibMesh_1_1InfFE.php#a6393a625c256b9dedb8c5a44b07be6e3">00504</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a6393a625c256b9dedb8c5a44b07be6e3">init_base_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;,
<a name="l00505"></a>00505                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*)
<a name="l00506"></a>00506   { libmesh_error(); }
<a name="l00507"></a>00507 
<a name="l00513"></a>00513   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#aef42f87957900f537c9fa2d2e81c3c4c">init_radial_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem);
<a name="l00514"></a>00514 
<a name="l00521"></a>00521   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a310e88546990e4373110b2b340577dd3">init_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem);
<a name="l00522"></a>00522 
<a name="l00527"></a>00527   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a5cb413b147eef6684e601b0ccb6e2983">init_face_shape_functions</a> (<span class="keyword">const</span> std::vector&lt;Point&gt;&amp; qp,
<a name="l00528"></a>00528                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>);
<a name="l00529"></a>00529 
<a name="l00538"></a>00538   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a07964b091022a4b60b205053fe2fc8c0">combine_base_radial</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem);
<a name="l00539"></a>00539 
<a name="l00551"></a>00551   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a3f39c07a1067bc51cf145ae77f48575c">compute_shape_functions</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*);
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00556"></a>00556   <span class="comment">// Miscellaneous static members</span>
<a name="l00557"></a>00557 
<a name="l00562"></a>00562   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1InfFE.php#abc80934ce2d2996472b0ba473e5bc4b4">map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem,
<a name="l00563"></a>00563                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; reference_point);
<a name="l00564"></a>00564 
<a name="l00571"></a>00571   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#ac3df17ad887b002540cc538849448a2e">compute_node_indices</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00572"></a>00572                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> outer_node_index,
<a name="l00573"></a>00573                                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; base_node,
<a name="l00574"></a>00574                                     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; radial_node);
<a name="l00575"></a>00575 
<a name="l00584"></a>00584   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a42dbfc303667197d7cae9362646a031c">compute_node_indices_fast</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00585"></a>00585                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> outer_node_index,
<a name="l00586"></a>00586                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; base_node,
<a name="l00587"></a>00587                                          <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; radial_node);
<a name="l00588"></a>00588 
<a name="l00595"></a>00595   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a8c1c5ab74ec54818d745a7bac3722b18">compute_shape_indices</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00596"></a>00596                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00597"></a>00597                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00598"></a>00598                                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; base_shape,
<a name="l00599"></a>00599                                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; radial_shape);
<a name="l00600"></a>00600 
<a name="l00601"></a>00601   <span class="comment">//--------------------------------------------------------------</span>
<a name="l00602"></a>00602   <span class="comment">// protected members, which are not to be accessed from outside</span>
<a name="l00606"></a><a class="code" href="classlibMesh_1_1InfFE.php#abbfd9d9b4ac914ce185e9e92825ebef5">00606</a> <span class="comment"></span>  std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1InfFE.php#abbfd9d9b4ac914ce185e9e92825ebef5">dist</a>;
<a name="l00607"></a>00607 
<a name="l00614"></a><a class="code" href="classlibMesh_1_1InfFE.php#a36bd84cdf518cb9eb1fa5142757317af">00614</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1InfFE.php#a36bd84cdf518cb9eb1fa5142757317af">dweightdv</a>;
<a name="l00615"></a>00615 
<a name="l00622"></a><a class="code" href="classlibMesh_1_1InfFE.php#ae1141ec873609184caf764d01655235b">00622</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1InfFE.php#ae1141ec873609184caf764d01655235b">som</a>;
<a name="l00627"></a><a class="code" href="classlibMesh_1_1InfFE.php#a198909f2b1ee8580b0627e463b352c32">00627</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1InfFE.php#a198909f2b1ee8580b0627e463b352c32">dsomdv</a>;
<a name="l00628"></a>00628 
<a name="l00633"></a><a class="code" href="classlibMesh_1_1InfFE.php#ad6aed43cc41471805de971932b078d8d">00633</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1InfFE.php#ad6aed43cc41471805de971932b078d8d">mode</a>;
<a name="l00634"></a>00634 
<a name="l00639"></a><a class="code" href="classlibMesh_1_1InfFE.php#a5e441be461b3e096663890ab026a4b4a">00639</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1InfFE.php#a5e441be461b3e096663890ab026a4b4a">dmodedv</a>;
<a name="l00640"></a>00640   
<a name="l00644"></a><a class="code" href="classlibMesh_1_1InfFE.php#a6a313826ba46237203ec90a47510c334">00644</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1InfFE.php#a6a313826ba46237203ec90a47510c334">radial_map</a>;
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 
<a name="l00650"></a><a class="code" href="classlibMesh_1_1InfFE.php#a4c96ac9822dd214470cbbe2fb05ede4d">00650</a>   std::vector&lt;std::vector&lt;Real&gt; &gt;   <a class="code" href="classlibMesh_1_1InfFE.php#a4c96ac9822dd214470cbbe2fb05ede4d">dradialdv_map</a>;
<a name="l00651"></a>00651 
<a name="l00657"></a><a class="code" href="classlibMesh_1_1InfFE.php#a0c349aacab8995fa98617c21dd6af6c9">00657</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1InfFE.php#a0c349aacab8995fa98617c21dd6af6c9">dphasedxi</a>;
<a name="l00658"></a>00658 
<a name="l00664"></a><a class="code" href="classlibMesh_1_1InfFE.php#ae78758ac9cfc70c68d14bb1f9e17307f">00664</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1InfFE.php#ae78758ac9cfc70c68d14bb1f9e17307f">dphasedeta</a>;
<a name="l00665"></a>00665 
<a name="l00671"></a><a class="code" href="classlibMesh_1_1InfFE.php#a5a29fdc6e58fdf8d13f921e08ff05db8">00671</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1InfFE.php#a5a29fdc6e58fdf8d13f921e08ff05db8">dphasedzeta</a>;
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 
<a name="l00676"></a>00676   <span class="comment">//--------------------------------------------------------------</span>
<a name="l00677"></a>00677   <span class="comment">// numbering scheme maps</span>
<a name="l00678"></a>00678 
<a name="l00687"></a><a class="code" href="classlibMesh_1_1InfFE.php#a7611ba3bc8d428d0c5227428fac4594f">00687</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1InfFE.php#a7611ba3bc8d428d0c5227428fac4594f">_radial_node_index</a>;
<a name="l00688"></a>00688 
<a name="l00697"></a><a class="code" href="classlibMesh_1_1InfFE.php#a6e7639861b0deb5cc9e4422e1f55fe2b">00697</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1InfFE.php#a6e7639861b0deb5cc9e4422e1f55fe2b">_base_node_index</a>;
<a name="l00698"></a>00698 
<a name="l00707"></a><a class="code" href="classlibMesh_1_1InfFE.php#ace3a74f1188f2dad1e96f1b20d2b0ad4">00707</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1InfFE.php#ace3a74f1188f2dad1e96f1b20d2b0ad4">_radial_shape_index</a>;
<a name="l00708"></a>00708 
<a name="l00717"></a><a class="code" href="classlibMesh_1_1InfFE.php#ab15eaf1c07cd461af9d9ea674d9a8348">00717</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1InfFE.php#ab15eaf1c07cd461af9d9ea674d9a8348">_base_shape_index</a>;
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 
<a name="l00722"></a>00722   <span class="comment">//--------------------------------------------------------------</span>
<a name="l00723"></a>00723   <span class="comment">// some more protected members</span>
<a name="l00724"></a>00724 
<a name="l00729"></a><a class="code" href="classlibMesh_1_1InfFE.php#a7ebb8cd747c04c8fcb911009966a3ef2">00729</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#a7ebb8cd747c04c8fcb911009966a3ef2">_n_total_approx_sf</a>;
<a name="l00730"></a>00730 
<a name="l00735"></a><a class="code" href="classlibMesh_1_1InfFE.php#aad3d47439098e6e8643ffcb033518e83">00735</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#aad3d47439098e6e8643ffcb033518e83">_n_total_qp</a>;
<a name="l00736"></a>00736 
<a name="l00741"></a><a class="code" href="classlibMesh_1_1InfFE.php#abc165ddba44b56e215a57d76d02e0ed0">00741</a>   std::vector&lt;Real&gt;  <a class="code" href="classlibMesh_1_1InfFE.php#abc165ddba44b56e215a57d76d02e0ed0">_total_qrule_weights</a>;
<a name="l00742"></a>00742 
<a name="l00747"></a><a class="code" href="classlibMesh_1_1InfFE.php#af055fd566b8e6bd39473ec30bf3cf68c">00747</a>   <a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* <a class="code" href="classlibMesh_1_1InfFE.php#af055fd566b8e6bd39473ec30bf3cf68c">base_qrule</a>;
<a name="l00748"></a>00748 
<a name="l00753"></a><a class="code" href="classlibMesh_1_1InfFE.php#a82a715d96edc647b78624bc497405c8f">00753</a>   <a class="code" href="classlibMesh_1_1QBase.php">QBase</a>* <a class="code" href="classlibMesh_1_1InfFE.php#a82a715d96edc647b78624bc497405c8f">radial_qrule</a>;
<a name="l00754"></a>00754 
<a name="l00759"></a><a class="code" href="classlibMesh_1_1InfFE.php#a53eb5ccccfd4f553ea6784c2258da840">00759</a>   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1InfFE.php#a53eb5ccccfd4f553ea6784c2258da840">base_elem</a>;
<a name="l00760"></a>00760 
<a name="l00767"></a><a class="code" href="classlibMesh_1_1InfFE.php#a96a2cd7f42aa64975f1edfb613c6ec42">00767</a>   <a class="code" href="classlibMesh_1_1FEBase.php">FEBase</a>* <a class="code" href="classlibMesh_1_1InfFE.php#a96a2cd7f42aa64975f1edfb613c6ec42">base_fe</a>;
<a name="l00768"></a>00768 
<a name="l00776"></a><a class="code" href="classlibMesh_1_1InfFE.php#a40c2c9e49b57396ac88717b090fa21c9">00776</a>   <a class="code" href="classlibMesh_1_1FEType.php">FEType</a> <a class="code" href="classlibMesh_1_1InfFE.php#a40c2c9e49b57396ac88717b090fa21c9">current_fe_type</a>;
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779 <span class="keyword">private</span>:
<a name="l00780"></a>00780 
<a name="l00784"></a>00784   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfFE.php#adbdc8acb4cd4dcb36e73f4e303c13ba3">shapes_need_reinit</a>() <span class="keyword">const</span>;
<a name="l00785"></a>00785 
<a name="l00793"></a><a class="code" href="classlibMesh_1_1InfFE.php#aea4b92e677d1402c92ca98b5fe4d738f">00793</a>   <span class="keyword">static</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1InfFE.php#aea4b92e677d1402c92ca98b5fe4d738f">_compute_node_indices_fast_current_elem_type</a>;
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 
<a name="l00796"></a>00796 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00797"></a>00797 <span class="preprocessor"></span>
<a name="l00801"></a><a class="code" href="classlibMesh_1_1InfFE.php#a29afcac804ccf23d37feb0d64f80d14d">00801</a>   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfFE.php#a29afcac804ccf23d37feb0d64f80d14d">_warned_for_nodal_soln</a>;
<a name="l00802"></a><a class="code" href="classlibMesh_1_1InfFE.php#a5c2896a59c0f07805b7b23c4d632b276">00802</a>   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1InfFE.php#a5c2896a59c0f07805b7b23c4d632b276">_warned_for_shape</a>;
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 <span class="preprocessor">#endif</span>
<a name="l00805"></a>00805 <span class="preprocessor"></span>
<a name="l00811"></a>00811   <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> friend_Dim, FEFamily friend_T_radial, InfMapType friend_T_map&gt;
<a name="l00812"></a><a class="code" href="classlibMesh_1_1InfFE.php#a30966325e9cd5ef7b41e45148b6919ed">00812</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1InfFE.php">InfFE</a>;
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 };
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 
<a name="l00817"></a>00817 
<a name="l00818"></a>00818 
<a name="l00819"></a>00819 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00820"></a>00820 <span class="comment">// InfFE class inline members</span>
<a name="l00821"></a>00821 
<a name="l00822"></a>00822 
<a name="l00823"></a>00823 
<a name="l00824"></a>00824 
<a name="l00825"></a>00825 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00826"></a>00826 <span class="comment">// InfFE::Radial class inline members</span>
<a name="l00827"></a>00827 
<a name="l00828"></a>00828 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00829"></a>00829 <span class="keyword">inline</span>
<a name="l00830"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#aa102427e01a09378006d335620b38959">00830</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#aa102427e01a09378006d335620b38959">InfFE&lt;Dim,T_radial,T_map&gt;::Radial::decay</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v)
<a name="l00831"></a>00831 {
<a name="l00832"></a>00832   <span class="keywordflow">switch</span> (Dim)
<a name="l00833"></a>00833   <span class="comment">//TODO:[DD] What decay do i have in 2D and 1D?</span>
<a name="l00834"></a>00834   {
<a name="l00835"></a>00835     <span class="keywordflow">case</span> 3:
<a name="l00836"></a>00836       <span class="keywordflow">return</span> (1.-v)/2.;
<a name="l00837"></a>00837 
<a name="l00838"></a>00838     <span class="keywordflow">case</span> 2:
<a name="l00839"></a>00839       <span class="keywordflow">return</span> 0.;
<a name="l00840"></a>00840 
<a name="l00841"></a>00841     <span class="keywordflow">case</span> 1:
<a name="l00842"></a>00842       <span class="keywordflow">return</span> 0.;
<a name="l00843"></a>00843 
<a name="l00844"></a>00844     <span class="keywordflow">default</span>:
<a name="l00845"></a>00845       libmesh_error();
<a name="l00846"></a>00846       <span class="keywordflow">return</span> 0.;
<a name="l00847"></a>00847   }
<a name="l00848"></a>00848 }
<a name="l00849"></a>00849 
<a name="l00850"></a>00850 
<a name="l00851"></a>00851 
<a name="l00852"></a>00852 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00853"></a>00853 <span class="comment">// InfFE::Base class inline members</span>
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 
<a name="l00856"></a>00856 } <span class="comment">// namespace libMesh</span>
<a name="l00857"></a>00857 
<a name="l00858"></a>00858 
<a name="l00859"></a>00859 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00860"></a>00860 <span class="preprocessor"></span>
<a name="l00861"></a>00861 
<a name="l00862"></a>00862 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
