<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_fe_base_radial.C</div>  </div>
</div>
<div class="contents">
<a href="inf__fe__base__radial_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe_base_radial.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="inf__fe__macro_8h.php">inf_fe_macro.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// InfFE::Base class members</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_base&gt;
<a name="l00038"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#ac4e83a84826fc6f474562914835fe1d4">00038</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#ac4e83a84826fc6f474562914835fe1d4">InfFE&lt;Dim,T_radial,T_base&gt;::Base::build_elem</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem)
<a name="l00039"></a>00039 { 
<a name="l00040"></a>00040   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ape(inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(0)); 
<a name="l00041"></a>00041   <span class="keywordflow">return</span> ape.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>(); 
<a name="l00042"></a>00042 }
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_base&gt;
<a name="l00048"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#a74f3001d8817766a047c06c214a7d0f5">00048</a> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;Dim,T_radial,T_base&gt;::Base::get_elem_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="keywordflow">switch</span> (type)
<a name="l00051"></a>00051     {
<a name="l00052"></a>00052       <span class="comment">// 3D infinite elements:</span>
<a name="l00053"></a>00053       <span class="comment">// with Dim=3 -&gt; infinite elements on their own</span>
<a name="l00054"></a>00054       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00055"></a>00055           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a>00057       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00058"></a>00058           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00061"></a>00061           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>;
<a name="l00062"></a>00062                  
<a name="l00063"></a>00063       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00064"></a>00064           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00067"></a>00067           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069       <span class="comment">// 2D infinite elements:</span>
<a name="l00070"></a>00070       <span class="comment">// with Dim=3 -&gt; used as boundary condition,</span>
<a name="l00071"></a>00071       <span class="comment">// with Dim=2 -&gt; infinite elements on their own</span>
<a name="l00072"></a>00072       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00073"></a>00073           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>;
<a name="l00074"></a>00074 
<a name="l00075"></a>00075       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00076"></a>00076           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a220ca478661dc10dd02b8afee8f91653">EDGE3</a>;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078       <span class="comment">// 1D infinite elements:</span>
<a name="l00079"></a>00079       <span class="comment">// with Dim=2 -&gt; used as boundary condition,</span>
<a name="l00080"></a>00080       <span class="comment">// with Dim=1 -&gt; infinite elements on their own,</span>
<a name="l00081"></a>00081       <span class="comment">//               but no base element!</span>
<a name="l00082"></a>00082       <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00083"></a>00083           <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085       <span class="keywordflow">default</span>:
<a name="l00086"></a>00086         {
<a name="l00087"></a>00087           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported element type!: &quot;</span> &lt;&lt; type
<a name="l00088"></a>00088                         &lt;&lt; std::endl;
<a name="l00089"></a>00089           libmesh_error();
<a name="l00090"></a>00090         }
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   libmesh_error();
<a name="l00095"></a>00095   <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_base&gt;
<a name="l00103"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#acf8759dd16d8c42964c95aa22f5d7e82">00103</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;Dim,T_radial,T_base&gt;::Base::n_base_mapping_sf</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_elem_type,
<a name="l00104"></a>00104                                                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> base_mapping_order)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   <span class="keywordflow">if</span> (Dim == 1)
<a name="l00107"></a>00107     <span class="keywordflow">return</span> 1;
<a name="l00108"></a>00108   
<a name="l00109"></a>00109   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (Dim == 2)
<a name="l00110"></a>00110     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfFE.php#ac401c91cb103fdd546f3226098647637">FE&lt;1,LAGRANGE&gt;::n_shape_functions</a> (base_elem_type,
<a name="l00111"></a>00111                                               base_mapping_order);
<a name="l00112"></a>00112   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (Dim == 3)
<a name="l00113"></a>00113     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfFE.php#ac401c91cb103fdd546f3226098647637">FE&lt;2,LAGRANGE&gt;::n_shape_functions</a> (base_elem_type,
<a name="l00114"></a>00114                                               base_mapping_order);
<a name="l00115"></a>00115   <span class="keywordflow">else</span>
<a name="l00116"></a>00116     {
<a name="l00117"></a>00117       <span class="comment">// whoa, cool infinite element!</span>
<a name="l00118"></a>00118       libmesh_error();
<a name="l00119"></a>00119       <span class="keywordflow">return</span> 0;
<a name="l00120"></a>00120     }
<a name="l00121"></a>00121 }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00128"></a>00128 <span class="comment">// InfFE::Radial class members</span>
<a name="l00129"></a>00129 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00130"></a><a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a3ea0a9dc18f741f952216aedcf4bcf56">00130</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#a197bf5ebd7b734cb9de463f714ed2293">InfFE&lt;Dim,T_radial,T_map&gt;::Radial::n_dofs_at_node</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial,
<a name="l00131"></a>00131                                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_onion)
<a name="l00132"></a>00132 {
<a name="l00133"></a>00133   libmesh_assert (n_onion &lt; 2);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordflow">if</span> (n_onion == 0)
<a name="l00136"></a>00136     <span class="comment">/*</span>
<a name="l00137"></a>00137 <span class="comment">     * in the base, no matter what, we have 1 node associated </span>
<a name="l00138"></a>00138 <span class="comment">     * with radial direction</span>
<a name="l00139"></a>00139 <span class="comment">     */</span>
<a name="l00140"></a>00140     <span class="keywordflow">return</span> 1;
<a name="l00141"></a>00141   <span class="keywordflow">else</span>
<a name="l00142"></a>00142     <span class="comment">/*</span>
<a name="l00143"></a>00143 <span class="comment">     * this works, since for Order o_radial=CONST=0, we still</span>
<a name="l00144"></a>00144 <span class="comment">     * have the (1-v)/2 mode, associated to the base</span>
<a name="l00145"></a>00145 <span class="comment">     */</span>
<a name="l00146"></a>00146     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(o_radial);
<a name="l00147"></a>00147 }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00155"></a>00155 <span class="comment">// Explicit instantiations</span>
<a name="l00156"></a>00156 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#ac4e83a84826fc6f474562914835fe1d4">Base::build_elem</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*));
<a name="l00157"></a>00157 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#ac4e83a84826fc6f474562914835fe1d4">Base::build_elem</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*));
<a name="l00158"></a>00158 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#ac4e83a84826fc6f474562914835fe1d4">Base::build_elem</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*));
<a name="l00159"></a>00159 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#a74f3001d8817766a047c06c214a7d0f5">Base::get_elem_type</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type));
<a name="l00160"></a>00160 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#a74f3001d8817766a047c06c214a7d0f5">Base::get_elem_type</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type));
<a name="l00161"></a>00161 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#a74f3001d8817766a047c06c214a7d0f5">Base::get_elem_type</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type));
<a name="l00162"></a>00162 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#acf8759dd16d8c42964c95aa22f5d7e82">Base::n_base_mapping_sf</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>));
<a name="l00163"></a>00163 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#acf8759dd16d8c42964c95aa22f5d7e82">Base::n_base_mapping_sf</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>));
<a name="l00164"></a>00164 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<a class="code" href="classlibMesh_1_1InfFE_1_1Base.php#acf8759dd16d8c42964c95aa22f5d7e82">Base::n_base_mapping_sf</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>));
<a name="l00165"></a>00165 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a3ea0a9dc18f741f952216aedcf4bcf56">Radial::n_dofs_at_node</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>));
<a name="l00166"></a>00166 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a3ea0a9dc18f741f952216aedcf4bcf56">Radial::n_dofs_at_node</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>));
<a name="l00167"></a>00167 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#a3ea0a9dc18f741f952216aedcf4bcf56">Radial::n_dofs_at_node</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>));
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 } <span class="comment">// namespace libMesh</span>
<a name="l00170"></a>00170                                                                 
<a name="l00171"></a>00171 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00172"></a>00172 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
