<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_fe_boundary.C</div>  </div>
</div>
<div class="contents">
<a href="inf__fe__boundary_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe_boundary.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="inf__fe__macro_8h.php">inf_fe_macro.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//-------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// Method for 2D, 3D -- see inf_fe_1D.C for a 1D version of this</span>
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_base&gt;
<a name="l00042"></a><a class="code" href="classlibMesh_1_1InfFE.php#ade3ce0d77164c4e8980418949350c840">00042</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a9ae89fdd879752a80e324fe648a11631">InfFE&lt;Dim,T_radial,T_base&gt;::reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem,
<a name="l00043"></a>00043                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s,
<a name="l00044"></a>00044                                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tolerance)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="comment">// We don&#39;t do this for 1D elements!</span>
<a name="l00047"></a>00047   libmesh_assert (Dim != 1);
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   libmesh_assert (inf_elem  != NULL);
<a name="l00050"></a>00050   libmesh_assert (qrule     != NULL);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052   <span class="comment">// Don&#39;t do this for the base</span>
<a name="l00053"></a>00053   libmesh_assert (s != 0);
<a name="l00054"></a>00054   
<a name="l00055"></a>00055   <span class="comment">// Build the side of interest </span>
<a name="l00056"></a>00056   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// set the element type</span>
<a name="l00059"></a>00059   elem_type = inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>();
<a name="l00060"></a>00060   
<a name="l00061"></a>00061   <span class="comment">// eventually initialize radial quadrature rule</span>
<a name="l00062"></a>00062   <span class="keywordtype">bool</span> radial_qrule_initialized = <span class="keyword">false</span>;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="keywordflow">if</span> (current_fe_type.radial_order != fe_type.radial_order)
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066       current_fe_type.radial_order = fe_type.radial_order;
<a name="l00067"></a>00067       radial_qrule-&gt;init(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>, inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00068"></a>00068       radial_qrule_initialized = <span class="keyword">true</span>;
<a name="l00069"></a>00069     }
<a name="l00070"></a>00070   
<a name="l00071"></a>00071   <span class="comment">// Initialize the face shape functions</span>
<a name="l00072"></a>00072   <span class="keywordflow">if</span> (this-&gt;get_type() != inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() ||  
<a name="l00073"></a>00073       base_fe-&gt;shapes_need_reinit()        ||
<a name="l00074"></a>00074       radial_qrule_initialized)
<a name="l00075"></a>00075     this-&gt;init_face_shape_functions (qrule-&gt;get_points(), <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>.get());
<a name="l00076"></a>00076   
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// compute the face map</span>
<a name="l00079"></a>00079   this-&gt;compute_face_map (_total_qrule_weights, <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>.get());
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// make a copy of the Jacobian for integration</span>
<a name="l00082"></a>00082   <span class="keyword">const</span> std::vector&lt;Real&gt; JxW_int(JxW);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">// Find where the integration points are located on the</span>
<a name="l00085"></a>00085   <span class="comment">// full element.</span>
<a name="l00086"></a>00086   std::vector&lt;Point&gt; qp; this-&gt;inverse_map (inf_elem, xyz, qp, tolerance);
<a name="l00087"></a>00087   
<a name="l00088"></a>00088   <span class="comment">// compute the shape function and derivative values</span>
<a name="l00089"></a>00089   <span class="comment">// at the points qp</span>
<a name="l00090"></a>00090   this-&gt;reinit  (inf_elem, &amp;qp);
<a name="l00091"></a>00091 
<a name="l00092"></a>00092   <span class="comment">// copy back old data</span>
<a name="l00093"></a>00093   JxW = JxW_int;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 <span class="comment">//-------------------------------------------------------</span>
<a name="l00100"></a>00100 <span class="comment">// Method for 2D, 3D -- see inf_fe_1D.C for a 1D version of this</span>
<a name="l00101"></a>00101 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_base&gt;
<a name="l00102"></a><a class="code" href="classlibMesh_1_1InfFE.php#a21495281a7bab390e35ded72fd5b3f0a">00102</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a21495281a7bab390e35ded72fd5b3f0a">InfFE&lt;Dim,T_radial,T_base&gt;::edge_reinit</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00103"></a>00103                                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00104"></a>00104                                              <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   <span class="comment">// We don&#39;t do this for 1D elements!</span>
<a name="l00107"></a>00107   <span class="comment">//libmesh_assert (Dim != 1);</span>
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Edge conditions for infinite elements &quot;</span>
<a name="l00110"></a>00110                 &lt;&lt; <span class="stringliteral">&quot;not implemented!&quot;</span> &lt;&lt; std::endl;
<a name="l00111"></a>00111   libmesh_error();
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_base&gt;
<a name="l00118"></a><a class="code" href="classlibMesh_1_1InfFE.php#a5cb413b147eef6684e601b0ccb6e2983">00118</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a5cb413b147eef6684e601b0ccb6e2983">InfFE&lt;Dim,T_radial,T_base&gt;::init_face_shape_functions</a>(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;,
<a name="l00119"></a>00119                                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_side)
<a name="l00120"></a>00120 {
<a name="l00121"></a>00121   libmesh_assert (inf_side != NULL);
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">// Currently, this makes only sense in 3-D!</span>
<a name="l00124"></a>00124   libmesh_assert (Dim == 3);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// Initialiize the radial shape functions</span>
<a name="l00127"></a>00127   this-&gt;init_radial_shape_functions(inf_side);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// Initialize the base shape functions</span>
<a name="l00130"></a>00130   this-&gt;update_base_elem(inf_side);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// Initialize the base quadratur rule</span>
<a name="l00133"></a>00133   base_qrule-&gt;init(base_elem-&gt;type(), inf_side-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="comment">// base_fe still corresponds to the (dim-1)-dimensional base of the InfFE object,</span>
<a name="l00136"></a>00136   <span class="comment">// so update the fe_base.</span>
<a name="l00137"></a>00137   {
<a name="l00138"></a>00138     libmesh_assert (Dim == 3);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> ap_fb(<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(Dim-2, this-&gt;fe_type));
<a name="l00141"></a>00141     <span class="keywordflow">if</span> (base_fe != NULL)
<a name="l00142"></a>00142       <span class="keyword">delete</span> base_fe;
<a name="l00143"></a>00143     base_fe = ap_fb.<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00144"></a>00144     base_fe-&gt;attach_quadrature_rule(base_qrule);
<a name="l00145"></a>00145   }
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="comment">// initialize the shape functions on the base</span>
<a name="l00148"></a>00148   base_fe-&gt;init_base_shape_functions(base_fe-&gt;qrule-&gt;get_points(),
<a name="l00149"></a>00149                                      base_elem);
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   <span class="comment">// the number of quadratur points</span>
<a name="l00152"></a>00152   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_radial_qp = som.size();
<a name="l00153"></a>00153   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_qp   = base_qrule-&gt;n_points();
<a name="l00154"></a>00154   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_total_qp  = n_radial_qp * n_base_qp;
<a name="l00155"></a>00155   
<a name="l00156"></a>00156   <span class="comment">// the quadratur weigths</span>
<a name="l00157"></a>00157   _total_qrule_weights.resize(n_total_qp);
<a name="l00158"></a>00158   
<a name="l00159"></a>00159   <span class="comment">// now inite the shapes for boundary work</span>
<a name="l00160"></a>00160   {
<a name="l00161"></a>00161     
<a name="l00162"></a>00162     <span class="comment">// The element type and order to use in the base map  </span>
<a name="l00163"></a>00163     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    base_mapping_order     ( base_elem-&gt;default_order() );
<a name="l00164"></a>00164     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_mapping_elem_type ( base_elem-&gt;type()          );
<a name="l00165"></a>00165     
<a name="l00166"></a>00166     <span class="comment">// the number of mapping shape functions</span>
<a name="l00167"></a>00167     <span class="comment">// (Lagrange shape functions are used for mapping in the base)</span>
<a name="l00168"></a>00168     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_radial_mapping_sf = radial_map.size();
<a name="l00169"></a>00169     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_mapping_shape_functions = Base::n_base_mapping_sf(base_mapping_elem_type,
<a name="l00170"></a>00170                                                                                 base_mapping_order);
<a name="l00171"></a>00171     
<a name="l00172"></a>00172     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_total_mapping_shape_functions = 
<a name="l00173"></a>00173       n_radial_mapping_sf * n_base_mapping_shape_functions;
<a name="l00174"></a>00174     
<a name="l00175"></a>00175 
<a name="l00176"></a>00176     <span class="comment">// initialize the node and shape numbering maps</span>
<a name="l00177"></a>00177     {
<a name="l00178"></a>00178       _radial_node_index.resize    (n_total_mapping_shape_functions);
<a name="l00179"></a>00179       _base_node_index.resize      (n_total_mapping_shape_functions);
<a name="l00180"></a>00180       
<a name="l00181"></a>00181       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_face_elem_type (inf_side-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00182"></a>00182     
<a name="l00183"></a>00183       <span class="comment">// fill the node index map</span>
<a name="l00184"></a>00184       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_total_mapping_shape_functions; n++)
<a name="l00185"></a>00185         {
<a name="l00186"></a>00186           compute_node_indices (inf_face_elem_type, 
<a name="l00187"></a>00187                                 n,
<a name="l00188"></a>00188                                 _base_node_index[n], 
<a name="l00189"></a>00189                                 _radial_node_index[n]);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191           libmesh_assert (_base_node_index[n]   &lt; n_base_mapping_shape_functions);
<a name="l00192"></a>00192           libmesh_assert (_radial_node_index[n] &lt; n_radial_mapping_sf);
<a name="l00193"></a>00193         }
<a name="l00194"></a>00194       
<a name="l00195"></a>00195     }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197     <span class="comment">// rezise map data fields</span>
<a name="l00198"></a>00198     {
<a name="l00199"></a>00199       psi_map.resize          (n_total_mapping_shape_functions);
<a name="l00200"></a>00200       dpsidxi_map.resize      (n_total_mapping_shape_functions);
<a name="l00201"></a>00201       d2psidxi2_map.resize    (n_total_mapping_shape_functions);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203       <span class="comment">//  if (Dim == 3)</span>
<a name="l00204"></a>00204       {
<a name="l00205"></a>00205         dpsideta_map.resize     (n_total_mapping_shape_functions);
<a name="l00206"></a>00206         d2psidxideta_map.resize (n_total_mapping_shape_functions);
<a name="l00207"></a>00207         d2psideta2_map.resize   (n_total_mapping_shape_functions);
<a name="l00208"></a>00208       }
<a name="l00209"></a>00209       
<a name="l00210"></a>00210       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_total_mapping_shape_functions; i++)
<a name="l00211"></a>00211         {
<a name="l00212"></a>00212           psi_map[i].resize         (n_total_qp);
<a name="l00213"></a>00213           dpsidxi_map[i].resize     (n_total_qp);
<a name="l00214"></a>00214           d2psidxi2_map[i].resize   (n_total_qp);
<a name="l00215"></a>00215           
<a name="l00216"></a>00216           <span class="comment">// if (Dim == 3)</span>
<a name="l00217"></a>00217           {
<a name="l00218"></a>00218             dpsideta_map[i].resize     (n_total_qp);
<a name="l00219"></a>00219             d2psidxideta_map[i].resize (n_total_qp);
<a name="l00220"></a>00220             d2psideta2_map[i].resize   (n_total_qp);
<a name="l00221"></a>00221           }
<a name="l00222"></a>00222         }    
<a name="l00223"></a>00223     }
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226     <span class="comment">// compute shape maps</span>
<a name="l00227"></a>00227     {
<a name="l00228"></a>00228       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; S_map  = base_fe-&gt;phi_map;
<a name="l00229"></a>00229       <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;&amp; Ss_map = base_fe-&gt;dphidxi_map;
<a name="l00230"></a>00230 
<a name="l00231"></a>00231       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rp=0; rp&lt;n_radial_qp; rp++)  <span class="comment">// over radial qp&#39;s</span>
<a name="l00232"></a>00232         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp=0; bp&lt;n_base_qp; bp++)  <span class="comment">// over base qp&#39;s</span>
<a name="l00233"></a>00233           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ti=0; ti&lt;n_total_mapping_shape_functions; ti++)  <span class="comment">// over all mapping shapes</span>
<a name="l00234"></a>00234             {
<a name="l00235"></a>00235               <span class="comment">// let the index vectors take care of selecting the appropriate base/radial mapping shape</span>
<a name="l00236"></a>00236               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bi = _base_node_index  [ti];
<a name="l00237"></a>00237               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ri = _radial_node_index[ti];
<a name="l00238"></a>00238               psi_map          [ti][bp+rp*n_base_qp] = S_map [bi][bp] * radial_map   [ri][rp];
<a name="l00239"></a>00239               dpsidxi_map      [ti][bp+rp*n_base_qp] = Ss_map[bi][bp] * radial_map   [ri][rp];
<a name="l00240"></a>00240               dpsideta_map     [ti][bp+rp*n_base_qp] = S_map [bi][bp] * dradialdv_map[ri][rp];
<a name="l00241"></a>00241 
<a name="l00242"></a>00242               <span class="comment">// second derivatives are not implemented for infinite elements</span>
<a name="l00243"></a>00243               <span class="comment">// d2psidxi2_map    [ti][bp+rp*n_base_qp] = 0.;</span>
<a name="l00244"></a>00244               <span class="comment">// d2psidxideta_map [ti][bp+rp*n_base_qp] = 0.;</span>
<a name="l00245"></a>00245               <span class="comment">// d2psideta2_map   [ti][bp+rp*n_base_qp] = 0.;</span>
<a name="l00246"></a>00246             }
<a name="l00247"></a>00247       
<a name="l00248"></a>00248     }
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   <span class="comment">// quadrature rule weights</span>
<a name="l00253"></a>00253   {
<a name="l00254"></a>00254     <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;   radial_qw = radial_qrule-&gt;get_weights();
<a name="l00255"></a>00255     <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;   base_qw   = base_qrule-&gt;get_weights();
<a name="l00256"></a>00256 
<a name="l00257"></a>00257     libmesh_assert (radial_qw.size() == n_radial_qp);
<a name="l00258"></a>00258     libmesh_assert (base_qw.size()   == n_base_qp);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rp=0; rp&lt;n_radial_qp; rp++)
<a name="l00261"></a>00261       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bp=0; bp&lt;n_base_qp; bp++)
<a name="l00262"></a>00262         {
<a name="l00263"></a>00263           _total_qrule_weights[  bp+rp*n_base_qp ] = radial_qw[rp] * base_qw[bp];
<a name="l00264"></a>00264         }
<a name="l00265"></a>00265   }
<a name="l00266"></a>00266   
<a name="l00267"></a>00267 }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00273"></a>00273 <span class="comment">// Explicit instantiations - doesn&#39;t make sense in 1D, but as </span>
<a name="l00274"></a>00274 <span class="comment">// long as we only return errors, we are fine... ;-) </span>
<a name="l00275"></a>00275 <span class="comment">//#include &quot;inf_fe_instantiate_1D.h&quot;</span>
<a name="l00276"></a>00276 <span class="comment">//#include &quot;inf_fe_instantiate_2D.h&quot;</span>
<a name="l00277"></a>00277 <span class="comment">//#include &quot;inf_fe_instantiate_3D.h&quot;</span>
<a name="l00278"></a>00278 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,reinit(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>));
<a name="l00279"></a>00279 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,reinit(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>));
<a name="l00280"></a>00280 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,reinit(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>));
<a name="l00281"></a>00281 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,edge_reinit(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>));
<a name="l00282"></a>00282 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,edge_reinit(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>));
<a name="l00283"></a>00283 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,edge_reinit(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>));
<a name="l00284"></a>00284 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,init_face_shape_functions(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*));
<a name="l00285"></a>00285 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,init_face_shape_functions(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*));
<a name="l00286"></a>00286 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,init_face_shape_functions(<span class="keyword">const</span> std::vector&lt;Point&gt;&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*));
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 } <span class="comment">// namespace libMesh</span>
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00291"></a>00291 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
