<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_fe_jacobi_20_00_eval.C</div>  </div>
</div>
<div class="contents">
<a href="inf__fe__jacobi__20__00__eval_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe_jacobi_20_00_eval.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local Includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00032"></a><a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">00032</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00033"></a>00033                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>, <span class="comment">/* not used */</span>
<a name="l00034"></a>00034                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordflow">switch</span> (i)
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040     <span class="keywordflow">case</span> 0:
<a name="l00041"></a>00041       <span class="keywordflow">return</span> 1.;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043     <span class="keywordflow">case</span> 1:
<a name="l00044"></a>00044       <span class="keywordflow">return</span> 2.+2.*v;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046     <span class="keywordflow">case</span> 2:
<a name="l00047"></a>00047       <span class="keywordflow">return</span> -1.25+(2.5+3.75*v)*v;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049     <span class="keywordflow">case</span> 3:
<a name="l00050"></a>00050       <span class="keywordflow">return</span> .25+(-1.5+(5.25+7.*v)*v)*v;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052     <span class="keywordflow">case</span> 4:
<a name="l00053"></a>00053       <span class="keywordflow">return</span> -.875+(-3.5+(-5.25+(10.5+13.125*v)*v)*v)*v;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     <span class="keywordflow">case</span> 5:
<a name="l00056"></a>00056       <span class="keywordflow">return</span> 1.625+(1.25+(-11.25+(-15.+(20.625+24.75*v)*v)*v)*v)*v;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058     <span class="keywordflow">case</span> 6:
<a name="l00059"></a>00059       <span class="keywordflow">return</span> -1.078125+(4.21875+(6.328125+(-30.9375+(-38.671875+(40.21875+46.921875*v)*v)*v)*v)*v)*v;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="keywordflow">case</span> 7:
<a name="l00062"></a>00062       <span class="keywordflow">return</span> .453125+(-1.09375+(18.046875+(24.0625+(-78.203125+(-93.84375+(78.203125+89.375*v)*v)*v)*v)*v)*v)*v;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keywordflow">case</span> 8:
<a name="l00065"></a>00065       <span class="keywordflow">return</span> -.9453125+(-4.8125+(-7.21875+(62.5625+(78.203125+(-187.6875+(-218.96875+(151.9375+170.9296875*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <span class="keywordflow">case</span> 9:
<a name="l00068"></a>00068       <span class="keywordflow">return</span> 1.4921875+(.984375+(-25.59375+(-34.125+(191.953125+(230.34375+(-435.09375+(-497.25+(295.2421875+328.046875*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070     <span class="keywordflow">case</span> 10:
<a name="l00071"></a>00071       <span class="keywordflow">return</span> -1.041015625+(5.33203125+(7.998046875+(-106.640625+(-133.30078125+(543.8671875+(634.51171875+(-984.140625+(-1107.158203125+(574.08203125+631.490234375*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     <span class="keywordflow">case</span> 11:
<a name="l00074"></a>00074       <span class="keywordflow">return</span> .548828125+(-.90234375+(33.837890625+(45.1171875+(-383.49609375+(-460.1953125+(1457.28515625+(1665.46875+(-2185.927734375+(-2428.80859375+(1117.251953125+1218.8203125*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keywordflow">case</span> 12:
<a name="l00077"></a>00077       <span class="keywordflow">return</span> -.9677734375+(-5.80078125+(-8.701171875+(164.35546875+(205.4443359375+(-1249.1015625+(-1457.28515625+(3747.3046875+(4215.7177734375+(-4788.22265625+(-5267.044921875+(2176.46484375+2357.8369140625*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     <span class="keywordflow">case</span> 13:
<a name="l00080"></a>00080       <span class="keywordflow">return</span> 1.418945312499432+(.837890625+(-42.732421875+(-56.9765625+(676.5966796875+(811.9160156249999+(-3788.94140625+(-4330.21875+(9337.0341796875+(10374.482421875+(-10374.482421875+(-11317.6171875+(4244.1064453125+4570.576171875*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     <span class="keywordflow">case</span> 14:
<a name="l00083"></a>00083       <span class="keywordflow">return</span> -1.02618408203125+(6.2318115234375+(9.34771728515625+(-236.808837890625+(-296.0110473632813+(2486.492797851563+(2900.908264160156+(-10893.20654296875+(-12254.85736083984+(22694.18029785156+(24963.59832763672+(-22281.55883789063+(-24138.35540771484+(8284.169311523438+8875.895690917969*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     <span class="keywordflow">case</span> 15:
<a name="l00086"></a>00086       <span class="keywordflow">return</span> .60723876953125+(-.7855224609375+(52.23724365234375+(69.649658203125+(-1096.982116699219+(-1316.378540039063+(8410.196228027344+(9611.65283203125+(-30036.41510009766+(-33373.79455566406+(54065.54718017578+(58980.59692382813+(-47512.14752197266+(-51166.92810058594+(16185.45684814453+17264.4873046875*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088     <span class="keywordflow">case</span> 16:
<a name="l00089"></a>00089       <span class="keywordflow">return</span> -.978179931640625+(-6.63330078125+(-9.949951171875+(325.03173828125+(406.2896728515625+(-4485.43798828125+(-5233.010986328125+(26699.03564453125+(30036.41510009766+(-80097.10693359375+(-88106.81762695313+(126699.0600585938+(137257.3150634766+(-100709.5092773438+(-107903.0456542969+(31651.56005859375+33629.78256225586*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091     <span class="keywordflow">case</span> 17:
<a name="l00092"></a>00092       <span class="keywordflow">return</span> 1.370941162109141+(.74188232421875+(-62.31811523437499+(-83.0908203125+(1672.202758789063+(2006.643310546875+(-16722.02758789063+(-19110.888671875+(80624.06158447266+(89582.29064941406+(-207830.9143066406+(-226724.6337890625+(292852.6519775391+(315379.7790527344+(-212398.6267089844+(-226558.53515625+(61949.5994567871+65593.69354248047*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094     <span class="keywordflow">case</span> 18:
<a name="l00095"></a>00095       <span class="keywordflow">return</span> -1.018547058106322+(7.010787963867187+(10.51618194580078+(-429.9949951171874+(-537.4937438964844+(7524.91241455078+(8779.064483642578+(-58049.32434082031+(-65305.48988342284+(233809.7785949707+(257190.7564544677+(-527134.7735595703+(-571062.6713562012+(669055.6741333008+(716845.3651428223+(-446037.1160888671+(-473914.4358444213+(121348.3330535889+128089.9071121216*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     <span class="keywordflow">default</span>:
<a name="l00099"></a>00099       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00100"></a>00100       libmesh_error();
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// we never end up here.</span>
<a name="l00105"></a>00105   <span class="keywordflow">return</span> 0.;
<a name="l00106"></a>00106 }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00111"></a><a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">00111</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;Dim,T_radial,T_map&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00112"></a>00112                                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>, <span class="comment">/* not used */</span>
<a name="l00113"></a>00113                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="keywordflow">switch</span> (i)
<a name="l00118"></a>00118     {
<a name="l00119"></a>00119     <span class="keywordflow">case</span> 0:
<a name="l00120"></a>00120       <span class="keywordflow">return</span> 0.;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="keywordflow">case</span> 1:
<a name="l00123"></a>00123       <span class="keywordflow">return</span> 2.;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     <span class="keywordflow">case</span> 2:
<a name="l00126"></a>00126       <span class="keywordflow">return</span> 7.5*v+2.5;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     <span class="keywordflow">case</span> 3:
<a name="l00129"></a>00129       <span class="keywordflow">return</span> -1.5+(10.5+21.*v)*v;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     <span class="keywordflow">case</span> 4:
<a name="l00132"></a>00132       <span class="keywordflow">return</span> -3.5+(-10.5+(31.5+52.5*v)*v)*v;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134     <span class="keywordflow">case</span> 5:
<a name="l00135"></a>00135       <span class="keywordflow">return</span> 1.25+(-22.5+(-45.+(82.5+123.75*v)*v)*v)*v;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137     <span class="keywordflow">case</span> 6:
<a name="l00138"></a>00138       <span class="keywordflow">return</span> 4.21875+(12.65625+(-92.8125+(-154.6875+(201.09375+281.53125*v)*v)*v)*v)*v;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     <span class="keywordflow">case</span> 7:
<a name="l00141"></a>00141       <span class="keywordflow">return</span> -1.09375+(36.09375+(72.1875+(-312.8125+(-469.21875+(469.21875+625.625*v)*v)*v)*v)*v)*v;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143     <span class="keywordflow">case</span> 8:
<a name="l00144"></a>00144       <span class="keywordflow">return</span> -4.8125+(-14.4375+(187.6875+(312.8125+(-938.4375+(-1313.8125+(1063.5625+1367.4375*v)*v)*v)*v)*v)*v)*v;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     <span class="keywordflow">case</span> 9:
<a name="l00147"></a>00147       <span class="keywordflow">return</span> .984375+(-51.1875+(-102.375+(767.8125+(1151.71875+(-2610.5625+(-3480.75+(2361.9375+2952.421875*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     <span class="keywordflow">case</span> 10:
<a name="l00150"></a>00150       <span class="keywordflow">return</span> 5.33203125+(15.99609375+(-319.921875+(-533.203125+(2719.3359375+(3807.0703125+(-6888.984375+(-8857.265625+(5166.73828125+6314.90234375*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152     <span class="keywordflow">case</span> 11:
<a name="l00153"></a>00153       <span class="keywordflow">return</span> -.90234375+(67.67578125+(135.3515625+(-1533.984375+(-2300.9765625+(8743.7109375+(11658.28125+(-17487.421875+(-21859.27734375+(11172.51953125+13407.0234375*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155     <span class="keywordflow">case</span> 12:
<a name="l00156"></a>00156       <span class="keywordflow">return</span> -5.80078125+(-17.40234375+(493.06640625+(821.77734375+(-6245.5078125+(-8743.7109375+(26231.1328125+(33725.7421875+(-43094.00390625+(-52670.44921875+(23941.11328125+28294.04296875*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     <span class="keywordflow">case</span> 13:
<a name="l00159"></a>00159       <span class="keywordflow">return</span> .837890625+(-85.46484375+(-170.9296875+(2706.38671875+(4059.580078124999+(-22733.6484375+(-30311.53125+(74696.2734375+(93370.341796875+(-103744.82421875+(-124493.7890625+(50929.27734375+59417.490234375*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     <span class="keywordflow">case</span> 14:
<a name="l00162"></a>00162       <span class="keywordflow">return</span> 6.2318115234375+(18.6954345703125+(-710.426513671875+(-1184.044189453125+(12432.46398925781+(17405.44958496094+(-76252.44580078125+(-98038.85888671875+(204247.6226806641+(249635.9832763672+(-245097.1472167969+(-289660.2648925781+(107694.2010498047+124262.5396728516*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     <span class="keywordflow">case</span> 15:
<a name="l00165"></a>00165       <span class="keywordflow">return</span> -.7855224609375+(104.4744873046875+(208.948974609375+(-4387.928466796875+(-6581.892700195313+(50461.17736816406+(67281.56982421875+(-240291.3208007813+(-300364.1510009766+(540655.4718017578+(648786.5661621094+(-570145.7702636719+(-665170.0653076172+(226596.3958740234+258967.3095703125*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167     <span class="keywordflow">case</span> 16:
<a name="l00168"></a>00168       <span class="keywordflow">return</span> -6.63330078125+(-19.89990234375+(975.09521484375+(1625.15869140625+(-22427.18994140625+(-31398.06591796875+(186893.2495117188+(240291.3208007813+(-720873.9624023438+(-881068.1762695313+(1393689.660644531+(1647087.780761719+(-1309223.620605469+(-1510642.639160156+(474773.4008789063+538076.5209960938*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170     <span class="keywordflow">case</span> 17:
<a name="l00171"></a>00171       <span class="keywordflow">return</span> .74188232421875+(-124.63623046875+(-249.2724609375+(6688.81103515625+(10033.21655273437+(-100332.1655273438+(-133776.220703125+(644992.4926757813+(806240.6158447266+(-2078309.143066406+(-2493970.971679688+(3514231.823730469+(4099937.127685547+(-2973580.773925781+(-3398378.02734375+(991193.5913085936+1115092.790222168*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173     <span class="keywordflow">case</span> 18:
<a name="l00174"></a>00174       <span class="keywordflow">return</span> 7.010787963867187+(21.03236389160156+(-1289.984985351562+(-2149.974975585938+(37624.5620727539+(52674.38690185547+(-406345.2703857421+(-522443.9190673828+(2104288.007354736+(2571907.564544677+(-5798482.509155273+(-6852752.056274414+(8697723.76373291+(10035835.11199951+(-6690556.741333007+(-7582630.973510741+(2062921.66191101+2305618.328018188*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177     <span class="keywordflow">default</span>:
<a name="l00178"></a>00178       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00179"></a>00179       libmesh_error();
<a name="l00180"></a>00180 
<a name="l00181"></a>00181     }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// we never end up here.</span>
<a name="l00184"></a>00184   <span class="keywordflow">return</span> 0.;
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00190"></a>00190 <span class="comment">// Explicit instantiations</span>
<a name="l00191"></a>00191 <span class="comment">// template class InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;;</span>
<a name="l00192"></a>00192 <span class="comment">// template class InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;;</span>
<a name="l00193"></a>00193 <span class="comment">// template class InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;;</span>
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="comment">// template class InfFE&lt;1,JACOBI_20_00,SPHERICAL&gt;;</span>
<a name="l00196"></a>00196 <span class="comment">// template class InfFE&lt;2,JACOBI_20_00,SPHERICAL&gt;;</span>
<a name="l00197"></a>00197 <span class="comment">// template class InfFE&lt;3,JACOBI_20_00,SPHERICAL&gt;;</span>
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="comment">// template class InfFE&lt;1,JACOBI_20_00,ELLIPSOIDAL&gt;;</span>
<a name="l00200"></a>00200 <span class="comment">// template class InfFE&lt;2,JACOBI_20_00,ELLIPSOIDAL&gt;;</span>
<a name="l00201"></a>00201 <span class="comment">// template class InfFE&lt;3,JACOBI_20_00,ELLIPSOIDAL&gt;;</span>
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00204"></a>00204 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;1,JACOBI_20_00,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00205"></a>00205 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00206"></a>00206 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;2,JACOBI_20_00,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00207"></a>00207 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00208"></a>00208 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;3,JACOBI_20_00,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 } <span class="comment">// namespace libMesh</span>
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00213"></a>00213 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
