<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_fe_jacobi_30_00_eval.C</div>  </div>
</div>
<div class="contents">
<a href="inf__fe__jacobi__30__00__eval_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe_jacobi_30_00_eval.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local Includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00032"></a>00032 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00033"></a>00033                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>, <span class="comment">/* not used */</span>
<a name="l00034"></a>00034                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordflow">switch</span> (i)
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040     <span class="keywordflow">case</span> 0:
<a name="l00041"></a>00041       <span class="keywordflow">return</span> 1.;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043     <span class="keywordflow">case</span> 1:
<a name="l00044"></a>00044       <span class="keywordflow">return</span> 2.5+2.5*v;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046     <span class="keywordflow">case</span> 2:
<a name="l00047"></a>00047       <span class="keywordflow">return</span> -.75+(4.5+5.25*v)*v;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049     <span class="keywordflow">case</span> 3:
<a name="l00050"></a>00050       <span class="keywordflow">return</span> (10.5+10.5*v)*v*v;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052     <span class="keywordflow">case</span> 4:
<a name="l00053"></a>00053       <span class="keywordflow">return</span> -1.375+(-5.5+(-2.25+(22.5+20.625*v)*v)*v)*v;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055     <span class="keywordflow">case</span> 5:
<a name="l00056"></a>00056       <span class="keywordflow">return</span> 1.78125+(-1.40625+(-19.6875+(-10.3125+(46.40625+40.21875*v)*v)*v)*v)*v;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058     <span class="keywordflow">case</span> 6:
<a name="l00059"></a>00059       <span class="keywordflow">return</span> -.609375+(6.09375+(-2.578125+(-58.4375+(-33.515625+(93.84375+78.203125*v)*v)*v)*v)*v)*v;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="keywordflow">case</span> 7:
<a name="l00062"></a>00062       <span class="keywordflow">return</span> .34375+(2.40625+(28.875+(-156.40625+(-93.84375+(187.6875+151.9375*v)*v)*v)*v*v)*v)*v;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="keywordflow">case</span> 8:
<a name="l00065"></a>00065       <span class="keywordflow">return</span> -1.3828125+(-6.5625+(8.53125+(108.0625+(21.328125+(-392.4375+(-241.71875+(372.9375+295.2421875*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <span class="keywordflow">case</span> 9:
<a name="l00068"></a>00068       <span class="keywordflow">return</span> 1.57421875+(-3.19921875+(-38.390625+(21.328125+(351.9140625+(108.7734375+(-942.703125+(-590.484375+(738.10546875+574.08203125*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070     <span class="keywordflow">case</span> 10:
<a name="l00071"></a>00071       <span class="keywordflow">return</span> -.6308593750004547+(6.97265625+(-15.380859375+(-172.265625+(34.86328125+(1045.8984375+(397.4414062499999+(-2195.390625+(-1391.044921875+(1457.28515625+1117.251953125*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00072"></a>00072 
<a name="l00073"></a>00073     <span class="keywordflow">case</span> 11:
<a name="l00074"></a>00074       <span class="keywordflow">return</span> .484375+(3.8671875+(48.33984375+(-54.78515625+(-657.421875+(2914.5703125+(1249.1015625+(-4996.40625+(-3192.1484375+(2872.93359375+2176.46484375*v)*v)*v)*v)*v)*v*v)*v)*v)*v)*v;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keywordflow">case</span> 12:
<a name="l00077"></a>00077       <span class="keywordflow">return</span> -1.3544921875+(-7.34765625+(23.009765625+(252.01171875+(-156.1376953125+(-2248.3828125+(-291.45703125+(7744.4296875+(3591.1669921875+(-11172.51953125+(-7182.333984375+(5658.80859375+4244.1064453125*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079     <span class="keywordflow">case</span> 13:
<a name="l00080"></a>00080       <span class="keywordflow">return</span> 1.471313476557931+(-4.4512939453125+(-58.75708007812499+(101.489501953125+(1099.469604492188+(-355.2132568359375+(-7104.265136718749+(-1556.17236328125+(19841.19763183594+(9726.077270507813+(-24639.39575195312+(-15915.39916992187+(11140.77941894531+8284.169311523438*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082     <span class="keywordflow">case</span> 14:
<a name="l00083"></a>00083       <span class="keywordflow">return</span> -.65960693359375+(7.6981201171875+(-31.34234619140625+(-348.248291015625+(365.6607055664063+(4241.664184570313+(-560.6797485351563+(-21145.63623046875+(-6007.283020019531+(49393.21594238281+(25230.58868408203+(-53737.87719726563+(-34842.24151611328+(21928.68347167969+16185.45684814453*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     <span class="keywordflow">case</span> 15:
<a name="l00086"></a>00086       <span class="keywordflow">return</span> .5635986328125+(4.9749755859375+(69.649658203125+(-162.515869140625+(-1706.416625976563+(1121.359497070313+(14951.4599609375+(-60072.83020019531+(-20024.27673339844+(120145.6604003906+(63349.53002929688+(-116140.8050537109+(-75532.13195800781+(43161.21826171875+31651.56005859375*v)*v)*v)*v)*v)*v)*v)*v*v)*v)*v)*v)*v)*v)*v;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088     <span class="keywordflow">case</span> 16:
<a name="l00089"></a>00089       <span class="keywordflow">return</span> -1.327301025390625+(-8.02978515625+(40.323486328125+(461.88720703125+(-688.5540771484375+(-7318.34619140625+(2950.946044921875+(49182.43408203125+(4742.591857910156+(-164409.8510742188+(-61126.73950195313+(286739.9780273438+(155039.6392822266+(-249123.5229492188+(-162422.4792480469+(84959.45068359375+61949.59945678711*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00090"></a>00090 
<a name="l00091"></a>00091     <span class="keywordflow">case</span> 17:
<a name="l00092"></a>00092       <span class="keywordflow">return</span> 1.408035278320313+(-5.452835083007813+(-81.0135498046875+(238.8861083984375+(2508.304138183594+(-2508.304138183594+(-28427.44689941406+(6449.924926757813+(153185.717010498+(25978.86428833008+(-436444.9200439453+(-175711.5911865234+(673561.0995483398+(371697.5967407227+(-530996.5667724609+(-346917.7569580078+(167263.9185333252+121348.3330535889*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00093"></a>00093 
<a name="l00094"></a>00094     <span class="keywordflow">case</span> 18:
<a name="l00095"></a>00095       <span class="keywordflow">return</span> -.6847000124835247+(8.346176147460938+(-49.9101333618164+(-593.8026123046875+(1151.772308349609+(11824.86236572266+(-8062.406158447265+(-102277.3809814453+(10020.4190826416+(456485.7582092285+(103544.3305206299+(-1129574.514770508+(-483206.8757629394+(1561129.906311035+(876144.3351745604+(-1125712.721557617+(-736757.7363967896+(329374.0468597412+237881.2560653686*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     <span class="keywordflow">default</span>:
<a name="l00099"></a>00099       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00100"></a>00100       libmesh_error();
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// we never end up here.</span>
<a name="l00105"></a>00105   <span class="keywordflow">return</span> 0.;
<a name="l00106"></a>00106 }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00111"></a>00111 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;Dim,T_radial,T_map&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00112"></a>00112                                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>, <span class="comment">/* not used */</span>
<a name="l00113"></a>00113                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00114"></a>00114 {
<a name="l00115"></a>00115   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="keywordflow">switch</span> (i)
<a name="l00118"></a>00118     {
<a name="l00119"></a>00119     <span class="keywordflow">case</span> 0:
<a name="l00120"></a>00120       <span class="keywordflow">return</span> 0.;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122     <span class="keywordflow">case</span> 1:
<a name="l00123"></a>00123       <span class="keywordflow">return</span> 2.5;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125     <span class="keywordflow">case</span> 2:
<a name="l00126"></a>00126       <span class="keywordflow">return</span> 10.5*v+4.5;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     <span class="keywordflow">case</span> 3:
<a name="l00129"></a>00129       <span class="keywordflow">return</span> (21.+31.5*v)*v;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131     <span class="keywordflow">case</span> 4:
<a name="l00132"></a>00132       <span class="keywordflow">return</span> -5.5+(-4.5+(67.5+82.5*v)*v)*v;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134     <span class="keywordflow">case</span> 5:
<a name="l00135"></a>00135       <span class="keywordflow">return</span> -1.40625+(-39.375+(-30.9375+(185.625+201.09375*v)*v)*v)*v;
<a name="l00136"></a>00136 
<a name="l00137"></a>00137     <span class="keywordflow">case</span> 6:
<a name="l00138"></a>00138       <span class="keywordflow">return</span> 6.09375+(-5.15625+(-175.3125+(-134.0625+(469.21875+469.21875*v)*v)*v)*v)*v;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140     <span class="keywordflow">case</span> 7:
<a name="l00141"></a>00141       <span class="keywordflow">return</span> 2.40625+(57.75+(-625.625+(-469.21875+(1126.125+1063.5625*v)*v)*v)*v*v)*v;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143     <span class="keywordflow">case</span> 8:
<a name="l00144"></a>00144       <span class="keywordflow">return</span> -6.5625+(17.0625+(324.1875+(85.3125+(-1962.1875+(-1450.3125+(2610.5625+2361.9375*v)*v)*v)*v)*v)*v)*v;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146     <span class="keywordflow">case</span> 9:
<a name="l00147"></a>00147       <span class="keywordflow">return</span> -3.19921875+(-76.78125+(63.984375+(1407.65625+(543.8671875+(-5656.21875+(-4133.390625+(5904.84375+5166.73828125*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149     <span class="keywordflow">case</span> 10:
<a name="l00150"></a>00150       <span class="keywordflow">return</span> 6.97265625+(-30.76171875+(-516.796875+(139.453125+(5229.4921875+(2384.6484375+(-15367.734375+(-11128.359375+(13115.56640625+11172.51953125*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152     <span class="keywordflow">case</span> 11:
<a name="l00153"></a>00153       <span class="keywordflow">return</span> 3.8671875+(96.6796875+(-164.35546875+(-2629.6875+(17487.421875+(8743.7109375+(-39971.25+(-28729.3359375+(28729.3359375+23941.11328125*v)*v)*v)*v)*v)*v*v)*v)*v)*v;
<a name="l00154"></a>00154 
<a name="l00155"></a>00155     <span class="keywordflow">case</span> 12:
<a name="l00156"></a>00156       <span class="keywordflow">return</span> -7.34765625+(46.01953125+(756.03515625+(-624.55078125+(-11241.9140625+(-1748.7421875+(54211.0078125+(28729.3359375+(-100552.67578125+(-71823.33984375+(62246.89453125+50929.27734375*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     <span class="keywordflow">case</span> 13:
<a name="l00159"></a>00159       <span class="keywordflow">return</span> -4.4512939453125+(-117.51416015625+(304.468505859375+(4397.87841796875+(-1776.066284179688+(-42625.59082031249+(-10893.20654296875+(158729.5810546875+(87534.69543457031+(-246393.9575195312+(-175069.3908691406+(133689.3530273438+107694.2010498047*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     <span class="keywordflow">case</span> 14:
<a name="l00162"></a>00162       <span class="keywordflow">return</span> 7.6981201171875+(-62.6846923828125+(-1044.744873046875+(1462.642822265625+(21208.32092285156+(-3364.078491210938+(-148019.4536132813+(-48058.26416015625+(444538.9434814453+(252305.8868408203+(-591116.6491699219+(-418106.8981933594+(285072.8851318359+226596.3958740234*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164     <span class="keywordflow">case</span> 15:
<a name="l00165"></a>00165       <span class="keywordflow">return</span> 4.9749755859375+(139.29931640625+(-487.547607421875+(-6825.66650390625+(5606.797485351563+(89708.759765625+(-480582.6416015625+(-180218.4906005859+(1201456.604003906+(696844.8303222656+(-1393689.660644531+(-981917.7154541016+(604257.0556640625+474773.4008789063*v)*v)*v)*v)*v)*v)*v)*v*v)*v)*v)*v)*v)*v;
<a name="l00166"></a>00166 
<a name="l00167"></a>00167     <span class="keywordflow">case</span> 16:
<a name="l00168"></a>00168       <span class="keywordflow">return</span> -8.02978515625+(80.64697265625+(1385.66162109375+(-2754.21630859375+(-36591.73095703125+(17705.67626953125+(344277.0385742188+(37940.73486328125+(-1479688.659667969+(-611267.3950195313+(3154139.758300781+(1860475.671386719+(-3238605.798339844+(-2273914.709472656+(1274391.760253906+991193.5913085938*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00169"></a>00169 
<a name="l00170"></a>00170     <span class="keywordflow">case</span> 17:
<a name="l00171"></a>00171       <span class="keywordflow">return</span> -5.452835083007813+(-162.027099609375+(716.6583251953125+(10033.21655273438+(-12541.52069091797+(-170564.6813964844+(45149.47448730469+(1225485.736083984+(233809.7785949707+(-4364449.200439453+(-1932827.503051758+(8082733.194580078+(4832068.757629395+(-7433951.934814453+(-5203766.354370117+(2676222.696533203+2062921.661911011*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00172"></a>00172 
<a name="l00173"></a>00173     <span class="keywordflow">case</span> 18:
<a name="l00174"></a>00174       <span class="keywordflow">return</span> 8.346176147460938+(-99.8202667236328+(-1781.407836914063+(4607.089233398438+(59124.31182861328+(-48374.43695068359+(-715941.6668701171+(80163.35266113281+(4108371.823883056+(1035443.305206299+(-12425319.66247559+(-5798482.509155273+(20294688.78204345+(12266020.69244385+(-16885690.82336426+(-11788123.78234863+(5599358.796615601+4281862.609176635*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177     <span class="keywordflow">default</span>:
<a name="l00178"></a>00178       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00179"></a>00179       libmesh_error();
<a name="l00180"></a>00180 
<a name="l00181"></a>00181     }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// we never end up here.</span>
<a name="l00184"></a>00184   <span class="keywordflow">return</span> 0.;
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00190"></a>00190 <span class="comment">// Explicit instantiations</span>
<a name="l00191"></a>00191 <span class="comment">// template class InfFE&lt;1,JACOBI_30_00,CARTESIAN&gt;;</span>
<a name="l00192"></a>00192 <span class="comment">// template class InfFE&lt;2,JACOBI_30_00,CARTESIAN&gt;;</span>
<a name="l00193"></a>00193 <span class="comment">// template class InfFE&lt;3,JACOBI_30_00,CARTESIAN&gt;;</span>
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="comment">// template class InfFE&lt;1,JACOBI_30_00,SPHERICAL&gt;;</span>
<a name="l00196"></a>00196 <span class="comment">// template class InfFE&lt;2,JACOBI_30_00,SPHERICAL&gt;;</span>
<a name="l00197"></a>00197 <span class="comment">// template class InfFE&lt;3,JACOBI_30_00,SPHERICAL&gt;;</span>
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="comment">// template class InfFE&lt;1,JACOBI_30_00,ELLIPSOIDAL&gt;;</span>
<a name="l00200"></a>00200 <span class="comment">// template class InfFE&lt;2,JACOBI_30_00,ELLIPSOIDAL&gt;;</span>
<a name="l00201"></a>00201 <span class="comment">// template class InfFE&lt;3,JACOBI_30_00,ELLIPSOIDAL&gt;;</span>
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;1,JACOBI_30_00,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00204"></a>00204 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;1,JACOBI_30_00,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00205"></a>00205 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;2,JACOBI_30_00,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00206"></a>00206 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;2,JACOBI_30_00,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00207"></a>00207 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;3,JACOBI_30_00,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00208"></a>00208 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;3,JACOBI_30_00,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 } <span class="comment">// namespace libMesh</span>
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00213"></a>00213 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
