<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_fe_lagrange_eval.C</div>  </div>
</div>
<div class="contents">
<a href="inf__fe__lagrange__eval_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe_lagrange_eval.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local Includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00032"></a>00032 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00033"></a>00033                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial,
<a name="l00034"></a>00034                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   <span class="keywordflow">switch</span> (o_radial)
<a name="l00039"></a>00039     {
<a name="l00040"></a>00040     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>:
<a name="l00041"></a>00041       <span class="keywordflow">switch</span> (i)
<a name="l00042"></a>00042         {
<a name="l00043"></a>00043         <span class="keywordflow">case</span> 0:
<a name="l00044"></a>00044           <span class="keywordflow">return</span> 1.;
<a name="l00045"></a>00045 
<a name="l00046"></a>00046         <span class="keywordflow">default</span>:
<a name="l00047"></a>00047           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00048"></a>00048           libmesh_error();
<a name="l00049"></a>00049         }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00053"></a>00053       <span class="keywordflow">switch</span> (i)
<a name="l00054"></a>00054         {
<a name="l00055"></a>00055         <span class="keywordflow">case</span> 0:
<a name="l00056"></a>00056           <span class="keywordflow">return</span> -1.*v;
<a name="l00057"></a>00057 
<a name="l00058"></a>00058         <span class="keywordflow">case</span> 1:
<a name="l00059"></a>00059           <span class="keywordflow">return</span> v+1.;
<a name="l00060"></a>00060 
<a name="l00061"></a>00061         <span class="keywordflow">default</span>:
<a name="l00062"></a>00062           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00063"></a>00063           libmesh_error();
<a name="l00064"></a>00064         }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00068"></a>00068       <span class="keywordflow">switch</span> (i)
<a name="l00069"></a>00069         {
<a name="l00070"></a>00070         <span class="keywordflow">case</span> 0:
<a name="l00071"></a>00071           <span class="keywordflow">return</span> 2.*v*(v+.5);
<a name="l00072"></a>00072 
<a name="l00073"></a>00073         <span class="keywordflow">case</span> 1:
<a name="l00074"></a>00074           <span class="keywordflow">return</span> 2.*(v+1.)*(v+.5);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076         <span class="keywordflow">case</span> 2:
<a name="l00077"></a>00077           <span class="keywordflow">return</span> -4.*(v+1.)*v;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079         <span class="keywordflow">default</span>:
<a name="l00080"></a>00080           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00081"></a>00081           libmesh_error();
<a name="l00082"></a>00082         }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00086"></a>00086       <span class="keywordflow">switch</span> (i)
<a name="l00087"></a>00087         {
<a name="l00088"></a>00088         <span class="keywordflow">case</span> 0:
<a name="l00089"></a>00089           <span class="keywordflow">return</span> -4.5*v*(v+.6666666666666667)*(v+.3333333333333333);
<a name="l00090"></a>00090 
<a name="l00091"></a>00091         <span class="keywordflow">case</span> 1:
<a name="l00092"></a>00092           <span class="keywordflow">return</span> 4.5*(v+1.)*(v+.6666666666666667)*(v+.3333333333333333);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094         <span class="keywordflow">case</span> 2:
<a name="l00095"></a>00095           <span class="keywordflow">return</span> 13.5*(v+1.)*v*(v+.3333333333333333);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097         <span class="keywordflow">case</span> 3:
<a name="l00098"></a>00098           <span class="keywordflow">return</span> -13.5*(v+1.)*v*(v+.6666666666666667);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <span class="keywordflow">default</span>:
<a name="l00101"></a>00101           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00102"></a>00102           libmesh_error();
<a name="l00103"></a>00103         }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00107"></a>00107       <span class="keywordflow">switch</span> (i)
<a name="l00108"></a>00108         {
<a name="l00109"></a>00109         <span class="keywordflow">case</span> 0:
<a name="l00110"></a>00110           <span class="keywordflow">return</span> 10.66666666666667*v*(v+.75)*(v+.5)*(v+.25);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112         <span class="keywordflow">case</span> 1:
<a name="l00113"></a>00113           <span class="keywordflow">return</span> 10.66666666666667*(v+1.)*(v+.75)*(v+.5)*(v+.25);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115         <span class="keywordflow">case</span> 2:
<a name="l00116"></a>00116           <span class="keywordflow">return</span> -42.66666666666667*(v+1.)*v*(v+.5)*(v+.25);
<a name="l00117"></a>00117 
<a name="l00118"></a>00118         <span class="keywordflow">case</span> 3:
<a name="l00119"></a>00119           <span class="keywordflow">return</span> 64.*(v+1.)*v*(v+.75)*(v+.25);
<a name="l00120"></a>00120 
<a name="l00121"></a>00121         <span class="keywordflow">case</span> 4:
<a name="l00122"></a>00122           <span class="keywordflow">return</span> -42.66666666666667*(v+1.)*v*(v+.75)*(v+.5);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124         <span class="keywordflow">default</span>:
<a name="l00125"></a>00125           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00126"></a>00126           libmesh_error();
<a name="l00127"></a>00127         }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00131"></a>00131       <span class="keywordflow">switch</span> (i)
<a name="l00132"></a>00132         {
<a name="l00133"></a>00133         <span class="keywordflow">case</span> 0:
<a name="l00134"></a>00134           <span class="keywordflow">return</span> -26.04166666666667*v*(v+.8)*(v+.6)*(v+.4)*(v+.2);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136         <span class="keywordflow">case</span> 1:
<a name="l00137"></a>00137           <span class="keywordflow">return</span> 26.04166666666667*(v+1.)*(v+.8)*(v+.6)*(v+.4)*(v+.2);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139         <span class="keywordflow">case</span> 2:
<a name="l00140"></a>00140           <span class="keywordflow">return</span> 130.2083333333333*(v+1.)*v*(v+.6)*(v+.4)*(v+.2);
<a name="l00141"></a>00141 
<a name="l00142"></a>00142         <span class="keywordflow">case</span> 3:
<a name="l00143"></a>00143           <span class="keywordflow">return</span> -260.4166666666667*(v+1.)*v*(v+.8)*(v+.4)*(v+.2);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145         <span class="keywordflow">case</span> 4:
<a name="l00146"></a>00146           <span class="keywordflow">return</span> 260.4166666666667*(v+1.)*v*(v+.8)*(v+.6)*(v+.2);
<a name="l00147"></a>00147 
<a name="l00148"></a>00148         <span class="keywordflow">case</span> 5:
<a name="l00149"></a>00149           <span class="keywordflow">return</span> -130.2083333333333*(v+1.)*v*(v+.8)*(v+.6)*(v+.4);
<a name="l00150"></a>00150 
<a name="l00151"></a>00151         <span class="keywordflow">default</span>:
<a name="l00152"></a>00152           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00153"></a>00153           libmesh_error();
<a name="l00154"></a>00154         }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00158"></a>00158       <span class="keywordflow">switch</span> (i)
<a name="l00159"></a>00159         {
<a name="l00160"></a>00160         <span class="keywordflow">case</span> 0:
<a name="l00161"></a>00161           <span class="keywordflow">return</span> 64.8*v*(v+.8333333333333333)*(v+.6666666666666667)*(v+.5)*(v+.3333333333333333)*(v+.1666666666666667);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163         <span class="keywordflow">case</span> 1:
<a name="l00164"></a>00164           <span class="keywordflow">return</span> 64.8*(v+1.)*(v+.8333333333333333)*(v+.6666666666666667)*(v+.5)*(v+.3333333333333333)*(v+.1666666666666667);
<a name="l00165"></a>00165 
<a name="l00166"></a>00166         <span class="keywordflow">case</span> 2:
<a name="l00167"></a>00167           <span class="keywordflow">return</span> -388.8*(v+1.)*v*(v+.6666666666666667)*(v+.5)*(v+.3333333333333333)*(v+.1666666666666667);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169         <span class="keywordflow">case</span> 3:
<a name="l00170"></a>00170           <span class="keywordflow">return</span> 972.*(v+1.)*v*(v+.8333333333333333)*(v+.5)*(v+.3333333333333333)*(v+.1666666666666667);
<a name="l00171"></a>00171 
<a name="l00172"></a>00172         <span class="keywordflow">case</span> 4:
<a name="l00173"></a>00173           <span class="keywordflow">return</span> -1296.*(v+1.)*v*(v+.8333333333333333)*(v+.6666666666666667)*(v+.3333333333333333)*(v+.1666666666666667);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175         <span class="keywordflow">case</span> 5:
<a name="l00176"></a>00176           <span class="keywordflow">return</span> 972.*(v+1.)*v*(v+.8333333333333333)*(v+.6666666666666667)*(v+.5)*(v+.1666666666666667);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178         <span class="keywordflow">case</span> 6:
<a name="l00179"></a>00179           <span class="keywordflow">return</span> -388.8*(v+1.)*v*(v+.8333333333333333)*(v+.6666666666666667)*(v+.5)*(v+.3333333333333333);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181         <span class="keywordflow">default</span>:
<a name="l00182"></a>00182           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00183"></a>00183           libmesh_error();
<a name="l00184"></a>00184         }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00188"></a>00188       <span class="keywordflow">switch</span> (i)
<a name="l00189"></a>00189         {
<a name="l00190"></a>00190         <span class="keywordflow">case</span> 0:
<a name="l00191"></a>00191           <span class="keywordflow">return</span> -163.401388888889*v*(v+.8571428571428571)*(v+.7142857142857143)*(v+.5714285714285714)*(v+.4285714285714286)*(v+.2857142857142857)*(v+.1428571428571429);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193         <span class="keywordflow">case</span> 1:
<a name="l00194"></a>00194           <span class="keywordflow">return</span> 163.4013888888888*(v+1.)*(v+.8571428571428571)*(v+.7142857142857143)*(v+.5714285714285714)*(v+.4285714285714286)*(v+.2857142857142857)*(v+.1428571428571429);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196         <span class="keywordflow">case</span> 2:
<a name="l00197"></a>00197           <span class="keywordflow">return</span> 1143.809722222222*(v+1.)*v*(v+.7142857142857143)*(v+.5714285714285714)*(v+.4285714285714286)*(v+.2857142857142857)*(v+.1428571428571429);
<a name="l00198"></a>00198 
<a name="l00199"></a>00199         <span class="keywordflow">case</span> 3:
<a name="l00200"></a>00200           <span class="keywordflow">return</span> -3431.429166666665*(v+1.)*v*(v+.8571428571428571)*(v+.5714285714285714)*(v+.4285714285714286)*(v+.2857142857142857)*(v+.1428571428571429);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202         <span class="keywordflow">case</span> 4:
<a name="l00203"></a>00203           <span class="keywordflow">return</span> 5719.048611111112*(v+1.)*v*(v+.8571428571428571)*(v+.7142857142857143)*(v+.4285714285714286)*(v+.2857142857142857)*(v+.1428571428571429);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205         <span class="keywordflow">case</span> 5:
<a name="l00206"></a>00206           <span class="keywordflow">return</span> -5719.048611111112*(v+1.)*v*(v+.8571428571428571)*(v+.7142857142857143)*(v+.5714285714285714)*(v+.2857142857142857)*(v+.1428571428571429);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208         <span class="keywordflow">case</span> 6:
<a name="l00209"></a>00209           <span class="keywordflow">return</span> 3431.429166666666*(v+1.)*v*(v+.8571428571428571)*(v+.7142857142857143)*(v+.5714285714285714)*(v+.4285714285714286)*(v+.1428571428571429);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211         <span class="keywordflow">case</span> 7:
<a name="l00212"></a>00212           <span class="keywordflow">return</span> -1143.809722222223*(v+1.)*v*(v+.8571428571428571)*(v+.7142857142857143)*(v+.5714285714285714)*(v+.4285714285714286)*(v+.2857142857142857);
<a name="l00213"></a>00213 
<a name="l00214"></a>00214         <span class="keywordflow">default</span>:
<a name="l00215"></a>00215           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00216"></a>00216           libmesh_error();
<a name="l00217"></a>00217         }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>:
<a name="l00221"></a>00221       <span class="keywordflow">switch</span> (i)
<a name="l00222"></a>00222         {
<a name="l00223"></a>00223         <span class="keywordflow">case</span> 0:
<a name="l00224"></a>00224           <span class="keywordflow">return</span> 416.1015873015873*v*(v+.875)*(v+.75)*(v+.625)*(v+.5)*(v+.375)*(v+.25)*(v+.125);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226         <span class="keywordflow">case</span> 1:
<a name="l00227"></a>00227           <span class="keywordflow">return</span> 416.1015873015873*(v+1.)*(v+.875)*(v+.75)*(v+.625)*(v+.5)*(v+.375)*(v+.25)*(v+.125);
<a name="l00228"></a>00228 
<a name="l00229"></a>00229         <span class="keywordflow">case</span> 2:
<a name="l00230"></a>00230           <span class="keywordflow">return</span> -3328.812698412698*(v+1.)*v*(v+.75)*(v+.625)*(v+.5)*(v+.375)*(v+.25)*(v+.125);
<a name="l00231"></a>00231 
<a name="l00232"></a>00232         <span class="keywordflow">case</span> 3:
<a name="l00233"></a>00233           <span class="keywordflow">return</span> 11650.84444444444*(v+1.)*v*(v+.875)*(v+.625)*(v+.5)*(v+.375)*(v+.25)*(v+.125);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235         <span class="keywordflow">case</span> 4:
<a name="l00236"></a>00236           <span class="keywordflow">return</span> -23301.68888888889*(v+1.)*v*(v+.875)*(v+.75)*(v+.5)*(v+.375)*(v+.25)*(v+.125);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238         <span class="keywordflow">case</span> 5:
<a name="l00239"></a>00239           <span class="keywordflow">return</span> 29127.11111111111*(v+1.)*v*(v+.875)*(v+.75)*(v+.625)*(v+.375)*(v+.25)*(v+.125);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241         <span class="keywordflow">case</span> 6:
<a name="l00242"></a>00242           <span class="keywordflow">return</span> -23301.68888888889*(v+1.)*v*(v+.875)*(v+.75)*(v+.625)*(v+.5)*(v+.25)*(v+.125);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244         <span class="keywordflow">case</span> 7:
<a name="l00245"></a>00245           <span class="keywordflow">return</span> 11650.84444444444*(v+1.)*v*(v+.875)*(v+.75)*(v+.625)*(v+.5)*(v+.375)*(v+.125);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247         <span class="keywordflow">case</span> 8:
<a name="l00248"></a>00248           <span class="keywordflow">return</span> -3328.812698412698*(v+1.)*v*(v+.875)*(v+.75)*(v+.625)*(v+.5)*(v+.375)*(v+.25);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250         <span class="keywordflow">default</span>:
<a name="l00251"></a>00251           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00252"></a>00252           libmesh_error();
<a name="l00253"></a>00253         }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa96e4b793b046031faa991f15f1a80bc6">NINTH</a>:
<a name="l00257"></a>00257       <span class="keywordflow">switch</span> (i)
<a name="l00258"></a>00258         {
<a name="l00259"></a>00259         <span class="keywordflow">case</span> 0:
<a name="l00260"></a>00260           <span class="keywordflow">return</span> -1067.627008928571*v*(v+.8888888888888889)*(v+.7777777777777778)*(v+.6666666666666667)*(v+.5555555555555556)*(v+.4444444444444444)*(v+.3333333333333333)*(v+.2222222222222222)*(v+.1111111111111111);
<a name="l00261"></a>00261 
<a name="l00262"></a>00262         <span class="keywordflow">case</span> 1:
<a name="l00263"></a>00263           <span class="keywordflow">return</span> 1067.627008928571*(v+1.)*(v+.8888888888888889)*(v+.7777777777777778)*(v+.6666666666666667)*(v+.5555555555555556)*(v+.4444444444444444)*(v+.3333333333333333)*(v+.2222222222222222)*(v+.1111111111111111);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265         <span class="keywordflow">case</span> 2:
<a name="l00266"></a>00266           <span class="keywordflow">return</span> 9608.643080357158*(v+1.)*v*(v+.7777777777777778)*(v+.6666666666666667)*(v+.5555555555555556)*(v+.4444444444444444)*(v+.3333333333333333)*(v+.2222222222222222)*(v+.1111111111111111);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268         <span class="keywordflow">case</span> 3:
<a name="l00269"></a>00269           <span class="keywordflow">return</span> -38434.57232142862*(v+1.)*v*(v+.8888888888888889)*(v+.6666666666666667)*(v+.5555555555555556)*(v+.4444444444444444)*(v+.3333333333333333)*(v+.2222222222222222)*(v+.1111111111111111);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271         <span class="keywordflow">case</span> 4:
<a name="l00272"></a>00272           <span class="keywordflow">return</span> 89680.66874999999*(v+1.)*v*(v+.8888888888888889)*(v+.7777777777777778)*(v+.5555555555555556)*(v+.4444444444444444)*(v+.3333333333333333)*(v+.2222222222222222)*(v+.1111111111111111);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274         <span class="keywordflow">case</span> 5:
<a name="l00275"></a>00275           <span class="keywordflow">return</span> -134521.0031249999*(v+1.)*v*(v+.8888888888888889)*(v+.7777777777777778)*(v+.6666666666666667)*(v+.4444444444444444)*(v+.3333333333333333)*(v+.2222222222222222)*(v+.1111111111111111);
<a name="l00276"></a>00276 
<a name="l00277"></a>00277         <span class="keywordflow">case</span> 6:
<a name="l00278"></a>00278           <span class="keywordflow">return</span> 134521.003125*(v+1.)*v*(v+.8888888888888889)*(v+.7777777777777778)*(v+.6666666666666667)*(v+.5555555555555556)*(v+.3333333333333333)*(v+.2222222222222222)*(v+.1111111111111111);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280         <span class="keywordflow">case</span> 7:
<a name="l00281"></a>00281           <span class="keywordflow">return</span> -89680.66875000004*(v+1.)*v*(v+.8888888888888889)*(v+.7777777777777778)*(v+.6666666666666667)*(v+.5555555555555556)*(v+.4444444444444444)*(v+.2222222222222222)*(v+.1111111111111111);
<a name="l00282"></a>00282 
<a name="l00283"></a>00283         <span class="keywordflow">case</span> 8:
<a name="l00284"></a>00284           <span class="keywordflow">return</span> 38434.57232142857*(v+1.)*v*(v+.8888888888888889)*(v+.7777777777777778)*(v+.6666666666666667)*(v+.5555555555555556)*(v+.4444444444444444)*(v+.3333333333333333)*(v+.1111111111111111);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286         <span class="keywordflow">case</span> 9:
<a name="l00287"></a>00287           <span class="keywordflow">return</span> -9608.643080357148*(v+1.)*v*(v+.8888888888888889)*(v+.7777777777777778)*(v+.6666666666666667)*(v+.5555555555555556)*(v+.4444444444444444)*(v+.3333333333333333)*(v+.2222222222222222);
<a name="l00288"></a>00288 
<a name="l00289"></a>00289         <span class="keywordflow">default</span>:
<a name="l00290"></a>00290           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00291"></a>00291           libmesh_error();
<a name="l00292"></a>00292         }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6115f555ee86d242617207bec760f208">TENTH</a>:
<a name="l00296"></a>00296       <span class="keywordflow">switch</span> (i)
<a name="l00297"></a>00297         {
<a name="l00298"></a>00298         <span class="keywordflow">case</span> 0:
<a name="l00299"></a>00299           <span class="keywordflow">return</span> 2755.73192239859*v*(v+.9)*(v+.8)*(v+.7)*(v+.6)*(v+.5)*(v+.4)*(v+.3)*(v+.2)*(v+.1);
<a name="l00300"></a>00300 
<a name="l00301"></a>00301         <span class="keywordflow">case</span> 1:
<a name="l00302"></a>00302           <span class="keywordflow">return</span> 2755.73192239859*(v+1.)*(v+.9)*(v+.8)*(v+.7)*(v+.6)*(v+.5)*(v+.4)*(v+.3)*(v+.2)*(v+.1);
<a name="l00303"></a>00303 
<a name="l00304"></a>00304         <span class="keywordflow">case</span> 2:
<a name="l00305"></a>00305           <span class="keywordflow">return</span> -27557.31922398588*(v+1.)*v*(v+.8)*(v+.7)*(v+.6)*(v+.5)*(v+.4)*(v+.3)*(v+.2)*(v+.1);
<a name="l00306"></a>00306 
<a name="l00307"></a>00307         <span class="keywordflow">case</span> 3:
<a name="l00308"></a>00308           <span class="keywordflow">return</span> 124007.9365079364*(v+1.)*v*(v+.9)*(v+.7)*(v+.6)*(v+.5)*(v+.4)*(v+.3)*(v+.2)*(v+.1);
<a name="l00309"></a>00309 
<a name="l00310"></a>00310         <span class="keywordflow">case</span> 4:
<a name="l00311"></a>00311           <span class="keywordflow">return</span> -330687.8306878306*(v+1.)*v*(v+.9)*(v+.8)*(v+.6)*(v+.5)*(v+.4)*(v+.3)*(v+.2)*(v+.1);
<a name="l00312"></a>00312 
<a name="l00313"></a>00313         <span class="keywordflow">case</span> 5:
<a name="l00314"></a>00314           <span class="keywordflow">return</span> 578703.7037037039*(v+1.)*v*(v+.9)*(v+.8)*(v+.7)*(v+.5)*(v+.4)*(v+.3)*(v+.2)*(v+.1);
<a name="l00315"></a>00315 
<a name="l00316"></a>00316         <span class="keywordflow">case</span> 6:
<a name="l00317"></a>00317           <span class="keywordflow">return</span> -694444.4444444449*(v+1.)*v*(v+.9)*(v+.8)*(v+.7)*(v+.6)*(v+.4)*(v+.3)*(v+.2)*(v+.1);
<a name="l00318"></a>00318 
<a name="l00319"></a>00319         <span class="keywordflow">case</span> 7:
<a name="l00320"></a>00320           <span class="keywordflow">return</span> 578703.7037037039*(v+1.)*v*(v+.9)*(v+.8)*(v+.7)*(v+.6)*(v+.5)*(v+.3)*(v+.2)*(v+.1);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322         <span class="keywordflow">case</span> 8:
<a name="l00323"></a>00323           <span class="keywordflow">return</span> -330687.8306878306*(v+1.)*v*(v+.9)*(v+.8)*(v+.7)*(v+.6)*(v+.5)*(v+.4)*(v+.2)*(v+.1);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325         <span class="keywordflow">case</span> 9:
<a name="l00326"></a>00326           <span class="keywordflow">return</span> 124007.9365079364*(v+1.)*v*(v+.9)*(v+.8)*(v+.7)*(v+.6)*(v+.5)*(v+.4)*(v+.3)*(v+.1);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328         <span class="keywordflow">case</span> 10:
<a name="l00329"></a>00329           <span class="keywordflow">return</span> -27557.31922398588*(v+1.)*v*(v+.9)*(v+.8)*(v+.7)*(v+.6)*(v+.5)*(v+.4)*(v+.3)*(v+.2);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331         <span class="keywordflow">default</span>:
<a name="l00332"></a>00332           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00333"></a>00333           libmesh_error();
<a name="l00334"></a>00334         }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 
<a name="l00337"></a>00337     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa9d8cd1c6f2feb41a556c16d8cb4744cd">ELEVENTH</a>:
<a name="l00338"></a>00338       <span class="keywordflow">switch</span> (i)
<a name="l00339"></a>00339         {
<a name="l00340"></a>00340         <span class="keywordflow">case</span> 0:
<a name="l00341"></a>00341           <span class="keywordflow">return</span> -7147.658895778214*v*(v+.9090909090909091)*(v+.8181818181818182)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00342"></a>00342 
<a name="l00343"></a>00343         <span class="keywordflow">case</span> 1:
<a name="l00344"></a>00344           <span class="keywordflow">return</span> 7147.65889577822*(v+1.)*(v+.9090909090909091)*(v+.8181818181818182)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00345"></a>00345 
<a name="l00346"></a>00346         <span class="keywordflow">case</span> 2:
<a name="l00347"></a>00347           <span class="keywordflow">return</span> 78624.2478535604*(v+1.)*v*(v+.8181818181818182)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00348"></a>00348 
<a name="l00349"></a>00349         <span class="keywordflow">case</span> 3:
<a name="l00350"></a>00350           <span class="keywordflow">return</span> -393121.2392678026*(v+1.)*v*(v+.9090909090909091)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00351"></a>00351 
<a name="l00352"></a>00352         <span class="keywordflow">case</span> 4:
<a name="l00353"></a>00353           <span class="keywordflow">return</span> 1179363.717803407*(v+1.)*v*(v+.9090909090909091)*(v+.8181818181818182)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00354"></a>00354 
<a name="l00355"></a>00355         <span class="keywordflow">case</span> 5:
<a name="l00356"></a>00356           <span class="keywordflow">return</span> -2358727.435606812*(v+1.)*v*(v+.9090909090909091)*(v+.8181818181818182)*(v+.7272727272727273)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358         <span class="keywordflow">case</span> 6:
<a name="l00359"></a>00359           <span class="keywordflow">return</span> 3302218.409849539*(v+1.)*v*(v+.9090909090909091)*(v+.8181818181818182)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00360"></a>00360 
<a name="l00361"></a>00361         <span class="keywordflow">case</span> 7:
<a name="l00362"></a>00362           <span class="keywordflow">return</span> -3302218.40984954*(v+1.)*v*(v+.9090909090909091)*(v+.8181818181818182)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00363"></a>00363 
<a name="l00364"></a>00364         <span class="keywordflow">case</span> 8:
<a name="l00365"></a>00365           <span class="keywordflow">return</span> 2358727.435606811*(v+1.)*v*(v+.9090909090909091)*(v+.8181818181818182)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.2727272727272727)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00366"></a>00366 
<a name="l00367"></a>00367         <span class="keywordflow">case</span> 9:
<a name="l00368"></a>00368           <span class="keywordflow">return</span> -1179363.717803406*(v+1.)*v*(v+.9090909090909091)*(v+.8181818181818182)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.1818181818181818)*(v+.9090909090909091e-1);
<a name="l00369"></a>00369 
<a name="l00370"></a>00370         <span class="keywordflow">case</span> 10:
<a name="l00371"></a>00371           <span class="keywordflow">return</span> 393121.2392678019*(v+1.)*v*(v+.9090909090909091)*(v+.8181818181818182)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.9090909090909091e-1);
<a name="l00372"></a>00372 
<a name="l00373"></a>00373         <span class="keywordflow">case</span> 11:
<a name="l00374"></a>00374           <span class="keywordflow">return</span> -78624.24785356052*(v+1.)*v*(v+.9090909090909091)*(v+.8181818181818182)*(v+.7272727272727273)*(v+.6363636363636364)*(v+.5454545454545455)*(v+.4545454545454545)*(v+.3636363636363636)*(v+.2727272727272727)*(v+.1818181818181818);
<a name="l00375"></a>00375 
<a name="l00376"></a>00376         <span class="keywordflow">default</span>:
<a name="l00377"></a>00377           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00378"></a>00378           libmesh_error();
<a name="l00379"></a>00379         }
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a>00382     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa72ff7b576c902d58a9fc3ad53b247a85">TWELFTH</a>:
<a name="l00383"></a>00383       <span class="keywordflow">switch</span> (i)
<a name="l00384"></a>00384         {
<a name="l00385"></a>00385         <span class="keywordflow">case</span> 0:
<a name="l00386"></a>00386           <span class="keywordflow">return</span> 18613.92623376623*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00387"></a>00387 
<a name="l00388"></a>00388         <span class="keywordflow">case</span> 1:
<a name="l00389"></a>00389           <span class="keywordflow">return</span> 18613.92623376623*(v+1.)*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00390"></a>00390 
<a name="l00391"></a>00391         <span class="keywordflow">case</span> 2:
<a name="l00392"></a>00392           <span class="keywordflow">return</span> -223367.1148051951*(v+1.)*v*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00393"></a>00393 
<a name="l00394"></a>00394         <span class="keywordflow">case</span> 3:
<a name="l00395"></a>00395           <span class="keywordflow">return</span> 1228519.131428571*(v+1.)*v*(v+.9166666666666667)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00396"></a>00396 
<a name="l00397"></a>00397         <span class="keywordflow">case</span> 4:
<a name="l00398"></a>00398           <span class="keywordflow">return</span> -4095063.771428572*(v+1.)*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00399"></a>00399 
<a name="l00400"></a>00400         <span class="keywordflow">case</span> 5:
<a name="l00401"></a>00401           <span class="keywordflow">return</span> 9213893.485714271*(v+1.)*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00402"></a>00402 
<a name="l00403"></a>00403         <span class="keywordflow">case</span> 6:
<a name="l00404"></a>00404           <span class="keywordflow">return</span> -14742229.57714284*(v+1.)*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00405"></a>00405 
<a name="l00406"></a>00406         <span class="keywordflow">case</span> 7:
<a name="l00407"></a>00407           <span class="keywordflow">return</span> 17199267.84*(v+1.)*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00408"></a>00408 
<a name="l00409"></a>00409         <span class="keywordflow">case</span> 8:
<a name="l00410"></a>00410           <span class="keywordflow">return</span> -14742229.57714286*(v+1.)*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00411"></a>00411 
<a name="l00412"></a>00412         <span class="keywordflow">case</span> 9:
<a name="l00413"></a>00413           <span class="keywordflow">return</span> 9213893.485714291*(v+1.)*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.25)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00414"></a>00414 
<a name="l00415"></a>00415         <span class="keywordflow">case</span> 10:
<a name="l00416"></a>00416           <span class="keywordflow">return</span> -4095063.77142857*(v+1.)*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.1666666666666667)*(v+.8333333333333333e-1);
<a name="l00417"></a>00417 
<a name="l00418"></a>00418         <span class="keywordflow">case</span> 11:
<a name="l00419"></a>00419           <span class="keywordflow">return</span> 1228519.131428571*(v+1.)*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.8333333333333333e-1);
<a name="l00420"></a>00420 
<a name="l00421"></a>00421         <span class="keywordflow">case</span> 12:
<a name="l00422"></a>00422           <span class="keywordflow">return</span> -223367.1148051951*(v+1.)*v*(v+.9166666666666667)*(v+.8333333333333333)*(v+.75)*(v+.6666666666666667)*(v+.5833333333333333)*(v+.5)*(v+.4166666666666667)*(v+.3333333333333333)*(v+.25)*(v+.1666666666666667);
<a name="l00423"></a>00423 
<a name="l00424"></a>00424         <span class="keywordflow">default</span>:
<a name="l00425"></a>00425           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00426"></a>00426           libmesh_error();
<a name="l00427"></a>00427         }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 
<a name="l00430"></a>00430     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faeb2a82bbe2a44c6917cedc029423ce75">THIRTEENTH</a>:
<a name="l00431"></a>00431       <span class="keywordflow">switch</span> (i)
<a name="l00432"></a>00432         {
<a name="l00433"></a>00433         <span class="keywordflow">case</span> 0:
<a name="l00434"></a>00434           <span class="keywordflow">return</span> -48638.84613847011*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00435"></a>00435 
<a name="l00436"></a>00436         <span class="keywordflow">case</span> 1:
<a name="l00437"></a>00437           <span class="keywordflow">return</span> 48638.84613847013*(v+1.)*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00438"></a>00438 
<a name="l00439"></a>00439         <span class="keywordflow">case</span> 2:
<a name="l00440"></a>00440           <span class="keywordflow">return</span> 632304.9998001099*(v+1.)*v*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00441"></a>00441 
<a name="l00442"></a>00442         <span class="keywordflow">case</span> 3:
<a name="l00443"></a>00443           <span class="keywordflow">return</span> -3793829.998800662*(v+1.)*v*(v+.9230769230769231)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00444"></a>00444 
<a name="l00445"></a>00445         <span class="keywordflow">case</span> 4:
<a name="l00446"></a>00446           <span class="keywordflow">return</span> 13910709.99560246*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00447"></a>00447 
<a name="l00448"></a>00448         <span class="keywordflow">case</span> 5:
<a name="l00449"></a>00449           <span class="keywordflow">return</span> -34776774.98900616*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00450"></a>00450 
<a name="l00451"></a>00451         <span class="keywordflow">case</span> 6:
<a name="l00452"></a>00452           <span class="keywordflow">return</span> 62598194.98021102*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00453"></a>00453 
<a name="l00454"></a>00454         <span class="keywordflow">case</span> 7:
<a name="l00455"></a>00455           <span class="keywordflow">return</span> -83464259.97361468*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00456"></a>00456 
<a name="l00457"></a>00457         <span class="keywordflow">case</span> 8:
<a name="l00458"></a>00458           <span class="keywordflow">return</span> 83464259.97361466*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00459"></a>00459 
<a name="l00460"></a>00460         <span class="keywordflow">case</span> 9:
<a name="l00461"></a>00461           <span class="keywordflow">return</span> -62598194.98021099*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00462"></a>00462 
<a name="l00463"></a>00463         <span class="keywordflow">case</span> 10:
<a name="l00464"></a>00464           <span class="keywordflow">return</span> 34776774.98900612*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.2307692307692308)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00465"></a>00465 
<a name="l00466"></a>00466         <span class="keywordflow">case</span> 11:
<a name="l00467"></a>00467           <span class="keywordflow">return</span> -13910709.99560244*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.1538461538461538)*(v+.7692307692307692e-1);
<a name="l00468"></a>00468 
<a name="l00469"></a>00469         <span class="keywordflow">case</span> 12:
<a name="l00470"></a>00470           <span class="keywordflow">return</span> 3793829.998800668*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.7692307692307692e-1);
<a name="l00471"></a>00471 
<a name="l00472"></a>00472         <span class="keywordflow">case</span> 13:
<a name="l00473"></a>00473           <span class="keywordflow">return</span> -632304.9998001105*(v+1.)*v*(v+.9230769230769231)*(v+.8461538461538462)*(v+.7692307692307692)*(v+.6923076923076923)*(v+.6153846153846154)*(v+.5384615384615385)*(v+.4615384615384615)*(v+.3846153846153846)*(v+.3076923076923077)*(v+.2307692307692308)*(v+.1538461538461538);
<a name="l00474"></a>00474 
<a name="l00475"></a>00475         <span class="keywordflow">default</span>:
<a name="l00476"></a>00476           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00477"></a>00477           libmesh_error();
<a name="l00478"></a>00478         }
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faab1534905d9792db00394cf617c71749">FOURTEENTH</a>:
<a name="l00482"></a>00482       <span class="keywordflow">switch</span> (i)
<a name="l00483"></a>00483         {
<a name="l00484"></a>00484         <span class="keywordflow">case</span> 0:
<a name="l00485"></a>00485           <span class="keywordflow">return</span> 127463.0033762123*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00486"></a>00486 
<a name="l00487"></a>00487         <span class="keywordflow">case</span> 1:
<a name="l00488"></a>00488           <span class="keywordflow">return</span> 127463.0033762123*(v+1.)*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00489"></a>00489 
<a name="l00490"></a>00490         <span class="keywordflow">case</span> 2:
<a name="l00491"></a>00491           <span class="keywordflow">return</span> -1784482.047266971*(v+1.)*v*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00492"></a>00492 
<a name="l00493"></a>00493         <span class="keywordflow">case</span> 3:
<a name="l00494"></a>00494           <span class="keywordflow">return</span> 11599133.30723529*(v+1.)*v*(v+.9285714285714286)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00495"></a>00495 
<a name="l00496"></a>00496         <span class="keywordflow">case</span> 4:
<a name="l00497"></a>00497           <span class="keywordflow">return</span> -46396533.2289412*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00498"></a>00498 
<a name="l00499"></a>00499         <span class="keywordflow">case</span> 5:
<a name="l00500"></a>00500           <span class="keywordflow">return</span> 127590466.3795883*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00501"></a>00501 
<a name="l00502"></a>00502         <span class="keywordflow">case</span> 6:
<a name="l00503"></a>00503           <span class="keywordflow">return</span> -255180932.7591769*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00504"></a>00504 
<a name="l00505"></a>00505         <span class="keywordflow">case</span> 7:
<a name="l00506"></a>00506           <span class="keywordflow">return</span> 382771399.1387658*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00507"></a>00507 
<a name="l00508"></a>00508         <span class="keywordflow">case</span> 8:
<a name="l00509"></a>00509           <span class="keywordflow">return</span> -437453027.5871608*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00510"></a>00510 
<a name="l00511"></a>00511         <span class="keywordflow">case</span> 9:
<a name="l00512"></a>00512           <span class="keywordflow">return</span> 382771399.1387654*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00513"></a>00513 
<a name="l00514"></a>00514         <span class="keywordflow">case</span> 10:
<a name="l00515"></a>00515           <span class="keywordflow">return</span> -255180932.7591768*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00516"></a>00516 
<a name="l00517"></a>00517         <span class="keywordflow">case</span> 11:
<a name="l00518"></a>00518           <span class="keywordflow">return</span> 127590466.3795886*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2142857142857143)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00519"></a>00519 
<a name="l00520"></a>00520         <span class="keywordflow">case</span> 12:
<a name="l00521"></a>00521           <span class="keywordflow">return</span> -46396533.22894132*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.1428571428571429)*(v+.7142857142857143e-1);
<a name="l00522"></a>00522 
<a name="l00523"></a>00523         <span class="keywordflow">case</span> 13:
<a name="l00524"></a>00524           <span class="keywordflow">return</span> 11599133.30723532*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.7142857142857143e-1);
<a name="l00525"></a>00525 
<a name="l00526"></a>00526         <span class="keywordflow">case</span> 14:
<a name="l00527"></a>00527           <span class="keywordflow">return</span> -1784482.047266969*(v+1.)*v*(v+.9285714285714286)*(v+.8571428571428571)*(v+.7857142857142857)*(v+.7142857142857143)*(v+.6428571428571429)*(v+.5714285714285714)*(v+.5)*(v+.4285714285714286)*(v+.3571428571428571)*(v+.2857142857142857)*(v+.2142857142857143)*(v+.1428571428571429);
<a name="l00528"></a>00528 
<a name="l00529"></a>00529         <span class="keywordflow">default</span>:
<a name="l00530"></a>00530           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00531"></a>00531           libmesh_error();
<a name="l00532"></a>00532         }
<a name="l00533"></a>00533 
<a name="l00534"></a>00534 
<a name="l00535"></a>00535     <span class="comment">// provided the constructor worked fine, we should never end up here.</span>
<a name="l00536"></a>00536     <span class="keywordflow">default</span>:
<a name="l00537"></a>00537       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Lagrange polynomials only defined up to 15. &quot;</span>
<a name="l00538"></a>00538                     &lt;&lt; std::endl;
<a name="l00539"></a>00539       libmesh_error();
<a name="l00540"></a>00540     }
<a name="l00541"></a>00541 
<a name="l00542"></a>00542   <span class="comment">// we never end up here.</span>
<a name="l00543"></a>00543   <span class="keywordflow">return</span> 0.;
<a name="l00544"></a>00544 }
<a name="l00545"></a>00545 
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 
<a name="l00548"></a>00548 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00549"></a>00549 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;Dim,T_radial,T_map&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00550"></a>00550                                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o_radial,
<a name="l00551"></a>00551                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00552"></a>00552 {
<a name="l00553"></a>00553   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   <span class="keywordflow">switch</span> (o_radial)
<a name="l00556"></a>00556     {
<a name="l00557"></a>00557     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>:
<a name="l00558"></a>00558       <span class="keywordflow">switch</span> (i)
<a name="l00559"></a>00559         {
<a name="l00560"></a>00560         <span class="keywordflow">case</span> 0:
<a name="l00561"></a>00561           <span class="keywordflow">return</span> 0.;
<a name="l00562"></a>00562 
<a name="l00563"></a>00563         <span class="keywordflow">default</span>:
<a name="l00564"></a>00564           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00565"></a>00565           libmesh_error();
<a name="l00566"></a>00566         }
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a>00569     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00570"></a>00570       <span class="keywordflow">switch</span> (i)
<a name="l00571"></a>00571         {
<a name="l00572"></a>00572         <span class="keywordflow">case</span> 0:
<a name="l00573"></a>00573           <span class="keywordflow">return</span> -1.;
<a name="l00574"></a>00574 
<a name="l00575"></a>00575         <span class="keywordflow">case</span> 1:
<a name="l00576"></a>00576           <span class="keywordflow">return</span> 1.;
<a name="l00577"></a>00577 
<a name="l00578"></a>00578         <span class="keywordflow">default</span>:
<a name="l00579"></a>00579           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00580"></a>00580           libmesh_error();
<a name="l00581"></a>00581         }
<a name="l00582"></a>00582 
<a name="l00583"></a>00583 
<a name="l00584"></a>00584     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00585"></a>00585       <span class="keywordflow">switch</span> (i)
<a name="l00586"></a>00586         {
<a name="l00587"></a>00587         <span class="keywordflow">case</span> 0:
<a name="l00588"></a>00588           <span class="keywordflow">return</span> 4.*v+1.;
<a name="l00589"></a>00589 
<a name="l00590"></a>00590         <span class="keywordflow">case</span> 1:
<a name="l00591"></a>00591           <span class="keywordflow">return</span> 4.*v+3.;
<a name="l00592"></a>00592 
<a name="l00593"></a>00593         <span class="keywordflow">case</span> 2:
<a name="l00594"></a>00594           <span class="keywordflow">return</span> -8.*v-4.;
<a name="l00595"></a>00595 
<a name="l00596"></a>00596         <span class="keywordflow">default</span>:
<a name="l00597"></a>00597           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00598"></a>00598           libmesh_error();
<a name="l00599"></a>00599         }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 
<a name="l00602"></a>00602     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00603"></a>00603       <span class="keywordflow">switch</span> (i)
<a name="l00604"></a>00604         {
<a name="l00605"></a>00605         <span class="keywordflow">case</span> 0:
<a name="l00606"></a>00606           <span class="keywordflow">return</span> -1.+(-9.-13.5*v)*v;
<a name="l00607"></a>00607 
<a name="l00608"></a>00608         <span class="keywordflow">case</span> 1:
<a name="l00609"></a>00609           <span class="keywordflow">return</span> 5.5+(18.+13.5*v)*v;
<a name="l00610"></a>00610 
<a name="l00611"></a>00611         <span class="keywordflow">case</span> 2:
<a name="l00612"></a>00612           <span class="keywordflow">return</span> 4.5+(36.+40.5*v)*v;
<a name="l00613"></a>00613 
<a name="l00614"></a>00614         <span class="keywordflow">case</span> 3:
<a name="l00615"></a>00615           <span class="keywordflow">return</span> -9.+(-45.-40.5*v)*v;
<a name="l00616"></a>00616 
<a name="l00617"></a>00617         <span class="keywordflow">default</span>:
<a name="l00618"></a>00618           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00619"></a>00619           libmesh_error();
<a name="l00620"></a>00620         }
<a name="l00621"></a>00621 
<a name="l00622"></a>00622 
<a name="l00623"></a>00623     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00624"></a>00624       <span class="keywordflow">switch</span> (i)
<a name="l00625"></a>00625         {
<a name="l00626"></a>00626         <span class="keywordflow">case</span> 0:
<a name="l00627"></a>00627           <span class="keywordflow">return</span> 1.+(14.66666666666667+(48.+42.66666666666667*v)*v)*v;
<a name="l00628"></a>00628 
<a name="l00629"></a>00629         <span class="keywordflow">case</span> 1:
<a name="l00630"></a>00630           <span class="keywordflow">return</span> 8.333333333333333+(46.66666666666667+(80.+42.66666666666667*v)*v)*v;
<a name="l00631"></a>00631 
<a name="l00632"></a>00632         <span class="keywordflow">case</span> 2:
<a name="l00633"></a>00633           <span class="keywordflow">return</span> -5.333333333333333+(-74.66666666666667+(-224.-170.6666666666667*v)*v)*v;
<a name="l00634"></a>00634 
<a name="l00635"></a>00635         <span class="keywordflow">case</span> 3:
<a name="l00636"></a>00636           <span class="keywordflow">return</span> 12.+(152.+(384.+256.*v)*v)*v;
<a name="l00637"></a>00637 
<a name="l00638"></a>00638         <span class="keywordflow">case</span> 4:
<a name="l00639"></a>00639           <span class="keywordflow">return</span> -16.+(-138.6666666666667+(-288.-170.6666666666667*v)*v)*v;
<a name="l00640"></a>00640 
<a name="l00641"></a>00641         <span class="keywordflow">default</span>:
<a name="l00642"></a>00642           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00643"></a>00643           libmesh_error();
<a name="l00644"></a>00644         }
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 
<a name="l00647"></a>00647     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00648"></a>00648       <span class="keywordflow">switch</span> (i)
<a name="l00649"></a>00649         {
<a name="l00650"></a>00650         <span class="keywordflow">case</span> 0:
<a name="l00651"></a>00651           <span class="keywordflow">return</span> -1.+(-20.83333333333333+(-109.375+(-208.3333333333333-130.2083333333333*v)*v)*v)*v;
<a name="l00652"></a>00652 
<a name="l00653"></a>00653         <span class="keywordflow">case</span> 1:
<a name="l00654"></a>00654           <span class="keywordflow">return</span> 11.41666666666667+(93.75+(265.625+(312.5+130.2083333333333*v)*v)*v)*v;
<a name="l00655"></a>00655 
<a name="l00656"></a>00656         <span class="keywordflow">case</span> 2:
<a name="l00657"></a>00657           <span class="keywordflow">return</span> 6.25+(127.0833333333333+(640.625+(1145.833333333333+651.0416666666667*v)*v)*v)*v;
<a name="l00658"></a>00658 
<a name="l00659"></a>00659         <span class="keywordflow">case</span> 3:
<a name="l00660"></a>00660           <span class="keywordflow">return</span> -16.66666666666667+(-325.+(-1531.25+(-2500.-1302.083333333333*v)*v)*v)*v;
<a name="l00661"></a>00661 
<a name="l00662"></a>00662         <span class="keywordflow">case</span> 4:
<a name="l00663"></a>00663           <span class="keywordflow">return</span> 25.+(445.8333333333333+(1843.75+(2708.333333333333+1302.083333333333*v)*v)*v)*v;
<a name="l00664"></a>00664 
<a name="l00665"></a>00665         <span class="keywordflow">case</span> 5:
<a name="l00666"></a>00666           <span class="keywordflow">return</span> -25.+(-320.8333333333333+(-1109.375+(-1458.333333333333-651.0416666666667*v)*v)*v)*v;
<a name="l00667"></a>00667 
<a name="l00668"></a>00668         <span class="keywordflow">default</span>:
<a name="l00669"></a>00669           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00670"></a>00670           libmesh_error();
<a name="l00671"></a>00671         }
<a name="l00672"></a>00672 
<a name="l00673"></a>00673 
<a name="l00674"></a>00674     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00675"></a>00675       <span class="keywordflow">switch</span> (i)
<a name="l00676"></a>00676         {
<a name="l00677"></a>00677         <span class="keywordflow">case</span> 0:
<a name="l00678"></a>00678           <span class="keywordflow">return</span> 1.+(27.4+(202.5+(612.+(810.+388.8*v)*v)*v)*v)*v;
<a name="l00679"></a>00679 
<a name="l00680"></a>00680         <span class="keywordflow">case</span> 1:
<a name="l00681"></a>00681           <span class="keywordflow">return</span> 14.7+(162.4+(661.5+(1260.+(1134.+388.8*v)*v)*v)*v)*v;
<a name="l00682"></a>00682 
<a name="l00683"></a>00683         <span class="keywordflow">case</span> 2:
<a name="l00684"></a>00684           <span class="keywordflow">return</span> -7.2+(-194.4+(-1404.+(-4104.+(-5184.-2332.8*v)*v)*v)*v)*v;
<a name="l00685"></a>00685 
<a name="l00686"></a>00686         <span class="keywordflow">case</span> 3:
<a name="l00687"></a>00687           <span class="keywordflow">return</span> 22.5+(594.+(4144.5+(11556.+(13770.+5832.*v)*v)*v)*v)*v;
<a name="l00688"></a>00688 
<a name="l00689"></a>00689         <span class="keywordflow">case</span> 4:
<a name="l00690"></a>00690           <span class="keywordflow">return</span> -40.+(-1016.+(-6696.+(-17424.+(-19440.-7776.*v)*v)*v)*v)*v;
<a name="l00691"></a>00691 
<a name="l00692"></a>00692         <span class="keywordflow">case</span> 5:
<a name="l00693"></a>00693           <span class="keywordflow">return</span> 45.+(1053.+(6223.5+(14796.+(15390.+5832.*v)*v)*v)*v)*v;
<a name="l00694"></a>00694 
<a name="l00695"></a>00695         <span class="keywordflow">case</span> 6:
<a name="l00696"></a>00696           <span class="keywordflow">return</span> -36.+(-626.4+(-3132.+(-6696.+(-6480.-2332.8*v)*v)*v)*v)*v;
<a name="l00697"></a>00697 
<a name="l00698"></a>00698         <span class="keywordflow">default</span>:
<a name="l00699"></a>00699           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00700"></a>00700           libmesh_error();
<a name="l00701"></a>00701         }
<a name="l00702"></a>00702 
<a name="l00703"></a>00703 
<a name="l00704"></a>00704     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00705"></a>00705       <span class="keywordflow">switch</span> (i)
<a name="l00706"></a>00706         {
<a name="l00707"></a>00707         <span class="keywordflow">case</span> 0:
<a name="l00708"></a>00708           <span class="keywordflow">return</span> -1.000000000000001+(-34.30000000000002+(-331.5666666666668+(-1400.583333333334+(-2917.881944444446+(-2941.225000000002-1143.809722222223*v)*v)*v)*v)*v)*v;
<a name="l00709"></a>00709 
<a name="l00710"></a>00710         <span class="keywordflow">case</span> 1:
<a name="l00711"></a>00711           <span class="keywordflow">return</span> 18.14999999999999+(255.3444444444444+(1382.004166666666+(3734.888888888888+(5368.902777777776+(3921.633333333332+1143.809722222222*v)*v)*v)*v)*v)*v;
<a name="l00712"></a>00712 
<a name="l00713"></a>00713         <span class="keywordflow">case</span> 2:
<a name="l00714"></a>00714           <span class="keywordflow">return</span> 8.166666666666662+(277.3944444444443+(2642.529166666665+(10937.88888888888+(22175.90277777776+(21568.98333333332+8006.668055555551*v)*v)*v)*v)*v)*v;
<a name="l00715"></a>00715 
<a name="l00716"></a>00716         <span class="keywordflow">case</span> 3:
<a name="l00717"></a>00717           <span class="keywordflow">return</span> -29.39999999999998+(-984.8999999999994+(-9192.399999999994+(-37015.41666666664+(-72480.18749999995+(-67648.17499999996-24020.00416666665*v)*v)*v)*v)*v)*v;
<a name="l00718"></a>00718 
<a name="l00719"></a>00719         <span class="keywordflow">case</span> 4:
<a name="l00720"></a>00720           <span class="keywordflow">return</span> 61.25000000000001+(2009.+(18186.14583333333+(70429.33333333334+(131888.2638888889+(117649.+40033.34027777778*v)*v)*v)*v)*v)*v;
<a name="l00721"></a>00721 
<a name="l00722"></a>00722         <span class="keywordflow">case</span> 5:
<a name="l00723"></a>00723           <span class="keywordflow">return</span> -81.66666666666667+(-2583.388888888889+(-22237.83333333334+(-81300.52777777778+(-144143.3680555556+(-122551.0416666667-40033.34027777778*v)*v)*v)*v)*v)*v;
<a name="l00724"></a>00724 
<a name="l00725"></a>00725         <span class="keywordflow">case</span> 6:
<a name="l00726"></a>00726           <span class="keywordflow">return</span> 73.49999999999999+(2153.55+(16845.5875+(56823.66666666666+(94539.37499999999+(76471.84999999999+24020.00416666666*v)*v)*v)*v)*v)*v;
<a name="l00727"></a>00727 
<a name="l00728"></a>00728         <span class="keywordflow">case</span> 7:
<a name="l00729"></a>00729           <span class="keywordflow">return</span> -49.00000000000003+(-1092.700000000001+(-7294.466666666671+(-22209.25000000001+(-34431.00694444447+(-26471.02500000002-8006.66805555556*v)*v)*v)*v)*v)*v;
<a name="l00730"></a>00730 
<a name="l00731"></a>00731         <span class="keywordflow">default</span>:
<a name="l00732"></a>00732           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00733"></a>00733           libmesh_error();
<a name="l00734"></a>00734         }
<a name="l00735"></a>00735 
<a name="l00736"></a>00736 
<a name="l00737"></a>00737     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>:
<a name="l00738"></a>00738       <span class="keywordflow">switch</span> (i)
<a name="l00739"></a>00739         {
<a name="l00740"></a>00740         <span class="keywordflow">case</span> 0:
<a name="l00741"></a>00741           <span class="keywordflow">return</span> 1.+(41.48571428571429+(500.2666666666667+(2750.577777777778+(7964.444444444444+(12561.06666666667+(10194.48888888889+3328.812698412698*v)*v)*v)*v)*v)*v)*v;
<a name="l00742"></a>00742 
<a name="l00743"></a>00743         <span class="keywordflow">case</span> 1:
<a name="l00744"></a>00744           <span class="keywordflow">return</span> 21.74285714285714+(374.9968253968254+(2563.2+(9122.133333333333+(18432.+(21299.2+(13107.2+3328.812698412698*v)*v)*v)*v)*v)*v)*v;
<a name="l00745"></a>00745 
<a name="l00746"></a>00746         <span class="keywordflow">case</span> 2:
<a name="l00747"></a>00747           <span class="keywordflow">return</span> -9.142857142857143+(-376.6857142857143+(-4497.066666666667+(-24393.95555555556+(-69404.44444444444+(-107042.1333333333+(-84468.62222222222-26630.50158730159*v)*v)*v)*v)*v)*v)*v;
<a name="l00748"></a>00748 
<a name="l00749"></a>00749         <span class="keywordflow">case</span> 3:
<a name="l00750"></a>00750           <span class="keywordflow">return</span> 37.33333333333333+(1523.911111111111+(17952.+(95675.73333333333+(266240.+(399769.6+(305834.6666666667+93206.75555555556*v)*v)*v)*v)*v)*v)*v;
<a name="l00751"></a>00751 
<a name="l00752"></a>00752         <span class="keywordflow">case</span> 4:
<a name="l00753"></a>00753           <span class="keywordflow">return</span> -89.6+(-3609.6+(-41736.53333333333+(-217179.0222222222+(-587320.8888888889+(-854152.5333333333+(-632058.3111111111-186413.5111111111*v)*v)*v)*v)*v)*v)*v;
<a name="l00754"></a>00754 
<a name="l00755"></a>00755         <span class="keywordflow">case</span> 5:
<a name="l00756"></a>00756           <span class="keywordflow">return</span> 140.+(5528.+(62165.33333333333+(312689.7777777778+(814648.8888888889+(1141418.666666667+(815559.1111111111+233016.8888888889*v)*v)*v)*v)*v)*v)*v;
<a name="l00757"></a>00757 
<a name="l00758"></a>00758         <span class="keywordflow">case</span> 6:
<a name="l00759"></a>00759           <span class="keywordflow">return</span> -149.3333333333333+(-5697.422222222222+(-61209.6+(-292727.4666666667+(-727040.+(-976486.4+(-672836.2666666667-186413.5111111111*v)*v)*v)*v)*v)*v)*v;
<a name="l00760"></a>00760 
<a name="l00761"></a>00761         <span class="keywordflow">case</span> 7:
<a name="l00762"></a>00762           <span class="keywordflow">return</span> 112.+(3974.4+(39153.06666666667+(173954.8444444444+(407324.4444444444+(522103.4666666667+(346612.6222222222+93206.75555555556*v)*v)*v)*v)*v)*v)*v;
<a name="l00763"></a>00763 
<a name="l00764"></a>00764         <span class="keywordflow">case</span> 8:
<a name="l00765"></a>00765           <span class="keywordflow">return</span> -64.+(-1759.085714285714+(-14890.66666666667+(-59892.62222222222+(-130844.4444444444+(-159470.9333333333+(-101944.8888888889-26630.50158730159*v)*v)*v)*v)*v)*v)*v;
<a name="l00766"></a>00766 
<a name="l00767"></a>00767         <span class="keywordflow">default</span>:
<a name="l00768"></a>00768           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00769"></a>00769           libmesh_error();
<a name="l00770"></a>00770         }
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 
<a name="l00773"></a>00773     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa96e4b793b046031faa991f15f1a80bc6">NINTH</a>:
<a name="l00774"></a>00774       <span class="keywordflow">switch</span> (i)
<a name="l00775"></a>00775         {
<a name="l00776"></a>00776         <span class="keywordflow">case</span> 0:
<a name="l00777"></a>00777           <span class="keywordflow">return</span> -.9999999999999998+(-48.92142857142856+(-711.9080357142856+(-4866.074999999999+(-18264.8671875+(-39858.07499999999+(-50376.17812499999+(-34164.06428571428-9608.643080357141*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00778"></a>00778 
<a name="l00779"></a>00779         <span class="keywordflow">case</span> 1:
<a name="l00780"></a>00780           <span class="keywordflow">return</span> 25.46071428571428+(523.5267857142855+(4361.464285714284+(19477.96874999999+(51479.92968749998+(83037.65624999997+(80269.73437499997+(42705.08035714284+9608.643080357139*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00781"></a>00781 
<a name="l00782"></a>00782         <span class="keywordflow">case</span> 2:
<a name="l00783"></a>00783           <span class="keywordflow">return</span> 10.12500000000002+(492.7982142857151+(7119.466071428583+(48200.56875000008+(178735.9921875003+(384187.5562500006+(476636.1468750008+(316017.5946428576+86477.78772321442*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00784"></a>00784 
<a name="l00785"></a>00785         <span class="keywordflow">case</span> 3:
<a name="l00786"></a>00786           <span class="keywordflow">return</span> -46.28571428571434+(-2237.914285714288+(-32031.73928571432+(-214253.1000000003+(-782604.2812500009+(-1651895.775000002+(-2006189.775000002+(-1298234.442857144-345911.1508928576*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00787"></a>00787 
<a name="l00788"></a>00788         <span class="keywordflow">case</span> 4:
<a name="l00789"></a>00789           <span class="keywordflow">return</span> 126.+(6038.1+(85360.8375+(562004.325+(2014021.96875+(4158525.825+(4929115.275+(3108929.85+807126.01875*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00790"></a>00790 
<a name="l00791"></a>00791         <span class="keywordflow">case</span> 5:
<a name="l00792"></a>00792           <span class="keywordflow">return</span> -226.7999999999999+(-10732.49999999999+(-149126.0624999999+(-961004.2499999995+(-3359744.578124998+(-6753729.374999997+(-7788932.156249996+(-4782968.999999998-1210689.028124999*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00793"></a>00793 
<a name="l00794"></a>00794         <span class="keywordflow">case</span> 6:
<a name="l00795"></a>00795           <span class="keywordflow">return</span> 283.5+(13160.475+(178213.1625+(1113994.0125+(3769397.015624999+(7336100.137499999+(8207441.943749999+(4902543.224999999+1210689.028125*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00796"></a>00796 
<a name="l00797"></a>00797         <span class="keywordflow">case</span> 7:
<a name="l00798"></a>00798           <span class="keywordflow">return</span> -252.0000000000001+(-11320.2+(-146952.2250000001+(-877643.1000000003+(-2844398.531250001+(-5327696.025000002+(-5766134.850000002+(-3348078.300000001-807126.0187500003*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00799"></a>00799 
<a name="l00800"></a>00800         <span class="keywordflow">case</span> 8:
<a name="l00801"></a>00801           <span class="keywordflow">return</span> 162.+(6791.271428571428+(81375.92678571428+(453820.725+(1391547.09375+(2493344.025+(2604060.9+(1469054.764285714+345911.1508928571*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00802"></a>00802 
<a name="l00803"></a>00803         <span class="keywordflow">case</span> 9:
<a name="l00804"></a>00804           <span class="keywordflow">return</span> -81.00000000000004+(-2666.635714285716+(-27608.92232142859+(-139731.0750000001+(-400169.7421875002+(-682015.9500000004+(-685891.0406250004+(-375804.7071428573-86477.78772321433*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00805"></a>00805 
<a name="l00806"></a>00806         <span class="keywordflow">default</span>:
<a name="l00807"></a>00807           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00808"></a>00808           libmesh_error();
<a name="l00809"></a>00809         }
<a name="l00810"></a>00810 
<a name="l00811"></a>00811 
<a name="l00812"></a>00812     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6115f555ee86d242617207bec760f208">TENTH</a>:
<a name="l00813"></a>00813       <span class="keywordflow">switch</span> (i)
<a name="l00814"></a>00814         {
<a name="l00815"></a>00815         <span class="keywordflow">case</span> 0:
<a name="l00816"></a>00816           <span class="keywordflow">return</span> 1.+(56.57936507936509+(969.4940476190478+(7977.072310405645+(37109.37500000001+(104618.0555555556+(182291.6666666667+(191798.9417989418+(111607.1428571429+27557.3192239859*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00817"></a>00817 
<a name="l00818"></a>00818         <span class="keywordflow">case</span> 1:
<a name="l00819"></a>00819           <span class="keywordflow">return</span> 29.28968253968254+(702.9087301587303+(6952.298280423282+(37664.57231040565+(124291.087962963+(260868.0555555556+(350115.7407407408+(291005.2910052911+(136408.7301587302+27557.3192239859*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00820"></a>00820 
<a name="l00821"></a>00821         <span class="keywordflow">case</span> 2:
<a name="l00822"></a>00822           <span class="keywordflow">return</span> -11.11111111111111+(-626.190476190476+(-10671.49470899471+(-87187.38977072308+(-402025.4629629629+(-1121180.555555555+(-1928240.74074074+(-1997354.497354497+(-1140873.015873016-275573.1922398588*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00823"></a>00823 
<a name="l00824"></a>00824         <span class="keywordflow">case</span> 3:
<a name="l00825"></a>00825           <span class="keywordflow">return</span> 56.24999999999993+(3154.464285714282+(53393.30357142851+(432433.5317460312+(1972612.84722222+(5430729.16666666+(9199652.777777767+(9365079.365079354+(5245535.714285708+1240079.365079364*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00826"></a>00826 
<a name="l00827"></a>00827         <span class="keywordflow">case</span> 4:
<a name="l00828"></a>00828           <span class="keywordflow">return</span> -171.4285714285714+(-9552.380952380949+(-160278.5714285714+(-1283804.232804232+(-5778472.22222222+(-15662499.99999999+(-26069444.44444444+(-26031746.03174602+(-14285714.28571428-3306878.306878306*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00829"></a>00829 
<a name="l00830"></a>00830         <span class="keywordflow">case</span> 5:
<a name="l00831"></a>00831           <span class="keywordflow">return</span> 350.0000000000001+(19336.11111111112+(320686.8055555557+(2531768.518518519+(11203732.63888889+(29794791.66666668+(48586805.55555557+(47500000.00000002+(25520833.33333334+5787037.037037039*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00832"></a>00832 
<a name="l00833"></a>00833         <span class="keywordflow">case</span> 6:
<a name="l00834"></a>00834           <span class="keywordflow">return</span> -504.0000000000003+(-27508.00000000002+(-448875.0000000003+(-3474944.444444447+(-15041319.44444445+(-39072083.33333336+(-62222222.22222226+(-59444444.44444448+(-31250000.00000002-6944444.444444449*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00835"></a>00835 
<a name="l00836"></a>00836         <span class="keywordflow">case</span> 7:
<a name="l00837"></a>00837           <span class="keywordflow">return</span> 525.0000000000002+(28129.16666666668+(448056.2500000002+(3373087.962962964+(14176475.69444445+(35773958.33333335+(55440972.22222224+(51666666.66666669+(26562500.00000001+5787037.037037039*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00838"></a>00838 
<a name="l00839"></a>00839         <span class="keywordflow">case</span> 8:
<a name="l00840"></a>00840           <span class="keywordflow">return</span> -399.9999999999999+(-20765.07936507936+(-317919.8412698412+(-2294915.343915343+(-9270138.888888886+(-22579166.66666666+(-33930555.55555554+(-30793650.79365078+(-15476190.47619047-3306878.306878306*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00841"></a>00841 
<a name="l00842"></a>00842         <span class="keywordflow">case</span> 9:
<a name="l00843"></a>00843           <span class="keywordflow">return</span> 224.9999999999997+(10930.35714285713+(155254.0178571427+(1050662.698412697+(4026519.097222217+(9399479.166666656+(13647569.44444443+(12043650.79365078+(5915178.571428564+1240079.365079364*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00844"></a>00844 
<a name="l00845"></a>00845         <span class="keywordflow">case</span> 10:
<a name="l00846"></a>00846           <span class="keywordflow">return</span> -99.99999999999998+(-3857.936507936507+(-47567.26190476189+(-292742.9453262786+(-1048784.722222222+(-2329513.888888888+(-3256944.444444444+(-2791005.29100529+(-1339285.714285714-275573.1922398588*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00847"></a>00847 
<a name="l00848"></a>00848         <span class="keywordflow">default</span>:
<a name="l00849"></a>00849           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00850"></a>00850           libmesh_error();
<a name="l00851"></a>00851         }
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 
<a name="l00854"></a>00854     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa9d8cd1c6f2feb41a556c16d8cb4744cd">ELEVENTH</a>:
<a name="l00855"></a>00855       <span class="keywordflow">switch</span> (i)
<a name="l00856"></a>00856         {
<a name="l00857"></a>00857         <span class="keywordflow">case</span> 0:
<a name="l00858"></a>00858           <span class="keywordflow">return</span> -.9999999999999994+(-64.43730158730155+(-1275.779345238094+(-12338.01201499117+(-68930.87539958109+(-240206.4480902776+(-539167.6189293978+(-779744.6068121688+(-701770.1461309519+(-357382.9447889107-78624.24785356036*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00859"></a>00859 
<a name="l00860"></a>00860         <span class="keywordflow">case</span> 1:
<a name="l00861"></a>00861           <span class="keywordflow">return</span> 33.2186507936508+(914.9568650793652+(10529.28835648148+(67482.7123346561+(269102.9154748127+(702350.1214583334+(1221444.149890046+(1403540.292261905+(1023414.796440972+(428859.5337466932+78624.24785356042*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00862"></a>00862 
<a name="l00863"></a>00863         <span class="keywordflow">case</span> 2:
<a name="l00864"></a>00864           <span class="keywordflow">return</span> 12.1+(777.2713492063492+(15323.969375+(147397.3637345679+(818004.6489266424+(2827608.196111111+(6286078.696244213+(8988328.740343915+(7982635.412239583+(4002688.981635802+864866.7263891644*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00865"></a>00865 
<a name="l00866"></a>00866         <span class="keywordflow">case</span> 3:
<a name="l00867"></a>00867           <span class="keywordflow">return</span> -67.22222222222232+(-4301.74206349207+(-84371.62344576732+(-806241.7181878318+(-4438664.17533345+(-15197594.39114585+(-33411814.74551509+(-47167460.12480165+(-41287476.93070442+(-20370827.85296795-4324333.631945828*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00868"></a>00868 
<a name="l00869"></a>00869         <span class="keywordflow">case</span> 4:
<a name="l00870"></a>00870           <span class="keywordflow">return</span> 226.8750000000001+(14449.05654761906+(281570.0790178573+(2668897.916302912+(14550507.15751076+(49254931.92812503+(106890177.8054688+(148732739.4557541+(128160772.9371653+(62184632.39327054+12973000.89583747*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00871"></a>00871 
<a name="l00872"></a>00872         <span class="keywordflow">case</span> 5:
<a name="l00873"></a>00873           <span class="keywordflow">return</span> -518.5714285714285+(-32822.69047619047+(-634337.9624999999+(-5951161.742195766+(-32053476.18047288+(-107015202.0322916+(-228727286.4230902+(-313117079.7464285+(-265269115.2375+(-126513562.4552744-25946001.79167493*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00874"></a>00874 
<a name="l00875"></a>00875         <span class="keywordflow">case</span> 6:
<a name="l00876"></a>00876           <span class="keywordflow">return</span> 847.0000000000005+(53166.72777777781+(1016244.195694445+(9406923.838888894+(49889787.88686346+(163758669.9375001+(343777378.7658683+(462062476.8222225+(384394597.5432294+(180121004.1736112+36324402.50834493*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00877"></a>00877 
<a name="l00878"></a>00878         <span class="keywordflow">case</span> 7:
<a name="l00879"></a>00879           <span class="keywordflow">return</span> -1016.400000000001+(-63054.71333333338+(-1186862.682500001+(-10787827.71203705+(-56070259.81307875+(-180193958.0397918+(-370348948.3898267+(-487666454.2750004+(-397903672.8562503+(-183123020.9098381-36324402.50834493*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00880"></a>00880 
<a name="l00881"></a>00881         <span class="keywordflow">case</span> 8:
<a name="l00882"></a>00882           <span class="keywordflow">return</span> 907.4999999999995+(55300.60119047616+(1017370.052678571+(9010082.051521159+(45578544.75252147+(142643877.2687499+(285964084.8567707+(368067808.7646823+(294217133.7654016+(132946455.4614748+25946001.79167492*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00883"></a>00883 
<a name="l00884"></a>00884         <span class="keywordflow">case</span> 9:
<a name="l00885"></a>00885           <span class="keywordflow">return</span> -604.9999999999997+(-35757.90079365078+(-633654.9006944442+(-5395757.537499998+(-26303245.82287532+(-79634435.01406247+(-155083710.9469617+(-194666785.3843253+(-152284121.7104166+(-67545376.56510414-12973000.89583746*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00886"></a>00886 
<a name="l00887"></a>00887         <span class="keywordflow">case</span> 10:
<a name="l00888"></a>00888           <span class="keywordflow">return</span> 302.4999999999999+(16769.78373015873+(276810.9617559523+(2216865.917570546+(10275947.41824432+(29863105.35694444+(56249470.99094327+(68702588.44748676+(52545039.69155505+(22872508.46649029+4324333.631945821*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00889"></a>00889 
<a name="l00890"></a>00890         <span class="keywordflow">case</span> 11:
<a name="l00891"></a>00891           <span class="keywordflow">return</span> -121.0000000000002+(-5376.9134920635+(-77345.59839285725+(-564323.0784171084+(-2447317.912381507+(-6769146.883506954+(-12277707.14086229+(-14559958.38538362+(-10877437.26502978+(-4645978.282255849-864866.7263891657*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00892"></a>00892 
<a name="l00893"></a>00893         <span class="keywordflow">default</span>:
<a name="l00894"></a>00894           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00895"></a>00895           libmesh_error();
<a name="l00896"></a>00896         }
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 
<a name="l00899"></a>00899     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa72ff7b576c902d58a9fc3ad53b247a85">TWELFTH</a>:
<a name="l00900"></a>00900       <span class="keywordflow">switch</span> (i)
<a name="l00901"></a>00901         {
<a name="l00902"></a>00902         <span class="keywordflow">case</span> 0:
<a name="l00903"></a>00903           <span class="keywordflow">return</span> .9999999999999998+(72.47705627705626+(1633.311428571428+(18226.50666666666+(119469.4285714285+(498933.257142857+(1381121.28+(2566761.325714285+(3167275.885714285+(2488319.999999999+(1126142.537142857+223367.1148051948*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00904"></a>00904 
<a name="l00905"></a>00905         <span class="keywordflow">case</span> 1:
<a name="l00906"></a>00906           <span class="keywordflow">return</span> 37.23852813852813+(1161.351341991342+(15303.19142857143+(113802.0495238095+(535247.1428571427+(1682751.497142857+(3627037.439999999+(5382117.668571427+(5406763.885714285+(3512085.942857142+(1330895.725714285+223367.1148051948*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00907"></a>00907 
<a name="l00908"></a>00908         <span class="keywordflow">case</span> 2:
<a name="l00909"></a>00909           <span class="keywordflow">return</span> -13.09090909090911+(-946.410389610391+(-21256.04571428574+(-236192.3657142861+(-1540134.857142859+(-6392069.485714295+(-17564843.52000003+(-32365222.76571433+(-39542959.5428572+(-30712978.28571433+(-13718463.63428573-2680405.377662341*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00910"></a>00910 
<a name="l00911"></a>00911         <span class="keywordflow">case</span> 3:
<a name="l00912"></a>00912           <span class="keywordflow">return</span> 79.19999999999997+(5708.502857142855+(127693.2342857142+(1411707.84+(9148841.14285714+(37695557.21142856+(102712458.24+(187435903.2685714+(226508214.8571428+(173784268.7999999+(76577692.52571426+14742229.57714285*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00913"></a>00913 
<a name="l00914"></a>00914         <span class="keywordflow">case</span> 4:
<a name="l00915"></a>00915           <span class="keywordflow">return</span> -293.3333333333333+(-21064.38095238095+(-468865.8285714286+(-5151708.952380953+(-33141236.57142857+(-135381015.7714286+(-365282265.6+(-659300527.5428572+(-787148039.3142857+(-596059282.2857143+(-259012783.5428571-49140765.25714286*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00916"></a>00916 
<a name="l00917"></a>00917         <span class="keywordflow">case</span> 5:
<a name="l00918"></a>00918           <span class="keywordflow">return</span> 742.4999999999988+(53071.7142857142+(1174043.699999998+(12802072.11428569+(81618641.99999987+(329991648.6857138+(880198099.1999986+(1568889314.742855+(1848249446.399997+(1380164461.714284+(591224831.9999991+110566721.8285713*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00919"></a>00919 
<a name="l00920"></a>00920         <span class="keywordflow">case</span> 6:
<a name="l00921"></a>00921           <span class="keywordflow">return</span> -1357.714285714284+(-96463.54285714276+(-2117125.851428569+(-22864004.02285712+(-144144041.142857+(-575530346.0571423+(-1514417679.359998+(-2660955375.908569+(-3088957791.085711+(-2272760393.142855+(-959473441.6457133-176906754.9257141*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00922"></a>00922 
<a name="l00923"></a>00923         <span class="keywordflow">case</span> 7:
<a name="l00924"></a>00924           <span class="keywordflow">return</span> 1848.+(130241.6+(2828541.120000001+(30164287.36000001+(187472016.+(737031225.6000001+(1908272701.44+(3298536898.560001+(3767714611.200001+(2729189376.+(1135151677.44+206391214.08*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00925"></a>00925 
<a name="l00926"></a>00926         <span class="keywordflow">case</span> 8:
<a name="l00927"></a>00927           <span class="keywordflow">return</span> -1900.800000000001+(-132442.1485714286+(-2834453.211428572+(-29714158.08000001+(-181251195.4285715+(-698873880.1371431+(-1774822855.680001+(-3011083328.365715+(-3379195435.885715+(-2407897497.600001+(-986500862.5371432-176906754.9257143*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00928"></a>00928 
<a name="l00929"></a>00929         <span class="keywordflow">case</span> 9:
<a name="l00930"></a>00930           <span class="keywordflow">return</span> 1485.000000000001+(101688.4285714286+(2129312.185714287+(21783070.2857143+(129558540.8571429+(487399661.4857146+(1209468153.600001+(2008852728.685716+(2211622370.742859+(1549085842.285715+(625009108.1142861+110566721.8285715*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00931"></a>00931 
<a name="l00932"></a>00932         <span class="keywordflow">case</span> 10:
<a name="l00933"></a>00933           <span class="keywordflow">return</span> -879.9999999999996+(-58499.8095238095+(-1181984.914285714+(-11651825.06666666+(-66923129.14285712+(-243989962.9714285+(-589005043.1999998+(-955168885.028571+(-1030036509.257142+(-708673535.9999997+(-281535634.2857142-49140765.25714284*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00934"></a>00934 
<a name="l00935"></a>00935         <span class="keywordflow">case</span> 11:
<a name="l00936"></a>00936           <span class="keywordflow">return</span> 395.9999999999998+(24740.91428571427+(467174.4685714284+(4342689.325714284+(23761844.57142856+(83264161.37142853+(194582062.0799999+(307216518.582857+(324021920.9142856+(218829970.2857142+(85586832.8228571+14742229.57714285*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00937"></a>00937 
<a name="l00938"></a>00938         <span class="keywordflow">case</span> 12:
<a name="l00939"></a>00939           <span class="keywordflow">return</span> -144.0000000000002+(-7268.696103896113+(-120015.3600000001+(-1017966.994285716+(-5214864.000000006+(-17396664.68571431+(-39148945.92000005+(-60006903.22285722+(-61809868.80000008+(-40950637.71428576+(-15765995.52000002-2680405.377662341*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00940"></a>00940 
<a name="l00941"></a>00941         <span class="keywordflow">default</span>:
<a name="l00942"></a>00942           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00943"></a>00943           libmesh_error();
<a name="l00944"></a>00944         }
<a name="l00945"></a>00945 
<a name="l00946"></a>00946 
<a name="l00947"></a>00947     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faeb2a82bbe2a44c6917cedc029423ce75">THIRTEENTH</a>:
<a name="l00948"></a>00948       <span class="keywordflow">switch</span> (i)
<a name="l00949"></a>00949         {
<a name="l00950"></a>00950         <span class="keywordflow">case</span> 0:
<a name="l00951"></a>00951           <span class="keywordflow">return</span> -1.+(-80.68347763347765+(-2044.462258297259+(-25942.2157164903+(-195933.4211304931+(-958398.5214740412+(-3173506.650750547+(-7259032.308898811+(-11486892.61199839+(-12346784.01976549+(-8601592.867103291+(-3501996.921969848-632304.9998001114*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00952"></a>00952 
<a name="l00953"></a>00953         <span class="keywordflow">case</span> 1:
<a name="l00954"></a>00954           <span class="keywordflow">return</span> 41.34173881673884+(1443.658316498317+(21501.124045665+(182688.9526208849+(994598.8556921946+(3678547.079260226+(9525159.921037011+(17469603.51956405+(22598998.22978734+(20166413.89895031+(11811756.71224232+(4085663.075631491+632304.9998001117*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00955"></a>00955 
<a name="l00956"></a>00956         <span class="keywordflow">case</span> 2:
<a name="l00957"></a>00957           <span class="keywordflow">return</span> 14.0833333333333+(1133.945087782585+(28654.62116838017+(362353.3209476036+(2725399.981313606+(13265700.68549035+(43674200.44979463+(99236897.21980192+(155839062.2764586+(166048415.8555637+(114536999.7566909+(46109626.13926956+8219964.997401429*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00958"></a>00958 
<a name="l00959"></a>00959         <span class="keywordflow">case</span> 3:
<a name="l00960"></a>00960           <span class="keywordflow">return</span> -92.18181818181805+(-7404.029004328994+(-186493.2485281383+(-2348815.46078042+(-17580908.74629903+(-85087791.92399955+(-278293001.5682587+(-627605520.9915996+(-977247224.5855008+(-1031431341.958869+(-704013624.8070271+(-280159753.7575874-49319789.98440861*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00961"></a>00961 
<a name="l00962"></a>00962         <span class="keywordflow">case</span> 4:
<a name="l00963"></a>00963           <span class="keywordflow">return</span> 371.8000000000002+(29775.036984127+(747066.9209920639+(9363907.89718475+(69688340.39763103+(335036414.4353251+(1087492542.853534+(2431673317.636533+(3750776185.102226+(3918109445.780044+(2644763448.927234+(1040093085.825045+180839229.9428319*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00964"></a>00964 
<a name="l00965"></a>00965         <span class="keywordflow">case</span> 5:
<a name="l00966"></a>00966           <span class="keywordflow">return</span> -1032.777777777779+(-82410.07804232813+(-2057912.1728836+(-25644457.74177325+(-189543869.9955658+(-904096807.162213+(-2908738078.894543+(-6440986214.655237+(-9830892990.478734+(-10155071564.15431+(-6774886171.378993+(-2632334353.014005-452098074.8570801*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00967"></a>00967 
<a name="l00968"></a>00968         <span class="keywordflow">case</span> 6:
<a name="l00969"></a>00969           <span class="keywordflow">return</span> 2091.375+(166125.1892857143+(4123916.218616072+(51020732.59433532+(373953022.277135+(1766886624.747501+(5625702404.785355+(12318759910.9515+(18582195606.11107+(18963235625.43443+(12496303574.24485+(4795984784.637706+813776534.7427433*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00970"></a>00970 
<a name="l00971"></a>00971         <span class="keywordflow">case</span> 7:
<a name="l00972"></a>00972           <span class="keywordflow">return</span> -3186.857142857142+(-251663.5333333333+(-6200036.526666666+(-76008876.2598148+(-551305314.9444829+(-2574950087.743402+(-8097779517.245471+(-17504674905.19222+(-26060004891.47182+(-26247363320.78761+(-17074614556.61409+(-6471690311.800277-1085035379.656991*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00973"></a>00973 
<a name="l00974"></a>00974         <span class="keywordflow">case</span> 8:
<a name="l00975"></a>00975           <span class="keywordflow">return</span> 3717.999999999998+(291305.8365079364+(7104538.462460314+(86064016.71082448+(615956862.0470787+(2836014413.233886+(8787496836.24099+(18714249266.16391+(27455001535.18193+(27263598620.87599+(17498356184.17243+(6548734244.083612+1085035379.656991*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00976"></a>00976 
<a name="l00977"></a>00977         <span class="keywordflow">case</span> 9:
<a name="l00978"></a>00978           <span class="keywordflow">return</span> -3346.199999999998+(-259275.2128571427+(-6234980.857857139+(-74314814.73490075+(-522619068.6865779+(-2363180534.798538+(-7192365653.835081+(-15054787917.48891+(-21728631050.65575+(-21251474605.34373+(-13449722236.25113+(-4969333632.275211-813776534.7427428*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00979"></a>00979 
<a name="l00980"></a>00980         <span class="keywordflow">case</span> 10:
<a name="l00981"></a>00981           <span class="keywordflow">return</span> 2323.75+(177031.3561507936+(4169023.658209325+(48551880.14924492+(333412303.9596687+(1473130923.654975+(4387072985.810989+(9001260757.284597+(12758505432.0885+(12276977202.42297+(7657681228.792217+(2792842545.270953+452098074.8570795*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00982"></a>00982 
<a name="l00983"></a>00983         <span class="keywordflow">case</span> 11:
<a name="l00984"></a>00984           <span class="keywordflow">return</span> -1239.333333333332+(-91731.50105820099+(-2087506.053492062+(-23468266.89172691+(-155895856.7716664+(-668508962.9727646+(-1939086147.461385+(-3888161778.825734+(-5402206035.376699+(-5109035910.537828+(-3139128681.07864+(-1129977673.488937-180839229.9428317*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00985"></a>00985 
<a name="l00986"></a>00986         <span class="keywordflow">case</span> 12:
<a name="l00987"></a>00987           <span class="keywordflow">return</span> 507.0000000000001+(35329.52316017317+(753439.2988852815+(8004952.597863758+(50738883.86584271+(209350649.6495577+(588284837.5399432+(1149033869.66415+(1561914935.552244+(1450272246.013992+(877362472.4445357+(311677726.0553165+49319789.98440869*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00988"></a>00988 
<a name="l00989"></a>00989         <span class="keywordflow">case</span> 13:
<a name="l00990"></a>00990           <span class="keywordflow">return</span> -168.9999999999998+(-9579.507720057708+(-179166.9826911975+(-1739358.918309081+(-10328458.8186393+(-40580690.36360362+(-109813061.9461516+(-208208252.9774634+(-276362669.3617079+(-251684443.4798346+(-149848802.0532203+(-52529953.82954764-8219964.997401437*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l00991"></a>00991 
<a name="l00992"></a>00992         <span class="keywordflow">default</span>:
<a name="l00993"></a>00993           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00994"></a>00994           libmesh_error();
<a name="l00995"></a>00995         }
<a name="l00996"></a>00996 
<a name="l00997"></a>00997 
<a name="l00998"></a>00998     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faab1534905d9792db00394cf617c71749">FOURTEENTH</a>:
<a name="l00999"></a>00999       <span class="keywordflow">switch</span> (i)
<a name="l01000"></a>01000         {
<a name="l01001"></a>01001         <span class="keywordflow">case</span> 0:
<a name="l01002"></a>01002           <span class="keywordflow">return</span> 1.000000000000001+(89.0437451437452+(2511.452929292931+(35805.84699214368+(307157.435133745+(1728831.305617285+(6694701.358837453+(18287612.31917697+(35556011.50111113+(48922521.07901238+(46544481.35786011+(29116191.77122336+(10770623.78528994+1784482.047266973*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01003"></a>01003 
<a name="l01004"></a>01004         <span class="keywordflow">case</span> 1:
<a name="l01005"></a>01005           <span class="keywordflow">return</span> 45.52187257187257+(1763.345698005698+(29365.83817340067+(281531.7950991395+(1747850.189814815+(7467146.756049383+(22696362.13811728+(49892955.87572016+(79586280.47222222+(91235685.94979424+(73234323.81481481+(39058306.0345679+(12427642.8291807+1784482.047266972*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01006"></a>01006 
<a name="l01007"></a>01007         <span class="keywordflow">case</span> 2:
<a name="l01008"></a>01008           <span class="keywordflow">return</span> -15.07692307692307+(-1340.186169386169+(-37713.82505050504+(-536175.4596184062+(-4584016.86584362+(-25698683.17679012+(-99057107.66633743+(-269159338.175144+(-520164399.5644443+(-710821314.4148147+(-671058896.060576+(-416148497.0228506+(-152445752.0379498-24982748.6617376*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01009"></a>01009 
<a name="l01010"></a>01010         <span class="keywordflow">case</span> 3:
<a name="l01011"></a>01011           <span class="keywordflow">return</span> 106.1666666666664+(9418.0887205387+(264331.1471464641+(3745715.752540209+(31899113.16882709+(178017355.746049+(682587693.1574368+(1843708348.548309+(3539222709.936659+(4800352165.04608+(4494355579.027644+(2761777312.15335+(1001668012.031962+162387866.3012941*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01012"></a>01012 
<a name="l01013"></a>01013         <span class="keywordflow">case</span> 4:
<a name="l01014"></a>01014           <span class="keywordflow">return</span> -463.2727272727266+(-40998.84444444439+(-1147094.434747473+(-16192604.75699212+(-137271541.0485595+(-762026508.285431+(-2904385776.815469+(-7792130969.395215+(-14846386660.68442+(-19971946670.39009+(-18532980221.46894+(-11280038782.78319+(-4049754543.269010-649551465.2051768*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01015"></a>01015 
<a name="l01016"></a>01016         <span class="keywordflow">case</span> 5:
<a name="l01017"></a>01017           <span class="keywordflow">return</span> 1401.399999999998+(123664.7844444442+(3447032.944444439+(48436585.99197523+(408409296.5789602+(2253197088.95512+(8528314129.288823+(22705190993.54646+(42899311094.9277+(57192419912.08138+(52567132654.44024+(31676286194.03451+(11255301855.62796+1786266529.314236*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01018"></a>01018 
<a name="l01019"></a>01019         <span class="keywordflow">case</span> 6:
<a name="l01020"></a>01020           <span class="keywordflow">return</span> -3114.222222222221+(-273841.7629629629+(-7598211.423703702+(-106176407.7618107+(-889486589.4962961+(-4871457715.624196+(-18289286459.60543+(-48264587628.2762+(-90336942561.1022+(-119250255953.088+(-108490582744.8178+(-64696178115.65826+(-22747557434.53234-3572533058.628476*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01021"></a>01021 
<a name="l01022"></a>01022         <span class="keywordflow">case</span> 7:
<a name="l01023"></a>01023           <span class="keywordflow">return</span> 5255.250000000005+(460064.2666666671+(12692565.01916668+(176150443.0362965+(1464070863.601545+(7947918838.465933+(29555009192.81537+(77204332615.9018+(142978921074.0568+(186702987302.2742+(168009721889.5444+(99106545732.11268+(34476766736.71312+5358799587.942721*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01024"></a>01024 
<a name="l01025"></a>01025         <span class="keywordflow">case</span> 8:
<a name="l01026"></a>01026           <span class="keywordflow">return</span> -6864.000000000005+(-597468.2666666671+(-16363002.50666668+(-225121477.611852+(-1852739107.920989+(-9950118584.456304+(-36579967858.71213+(-94431878855.5576+(-172801677847.3068+(-222974303851.9113+(-198322454721.1221+(-115675079151.9764+(-39808225510.43164-6124342386.220252*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01027"></a>01027 
<a name="l01028"></a>01028         <span class="keywordflow">case</span> 9:
<a name="l01029"></a>01029           <span class="keywordflow">return</span> 7007.+(605244.1888888889+(16415290.29777778+(223285445.4038272+(1814617394.563426+(9615694831.261296+(34866622054.4775+(88774809190.10321+(160266060424.7967+(204118806975.1876+(179312358692.2474+(103371712751.0874+(35187627906.54222+5358799587.942716*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01030"></a>01030 
<a name="l01031"></a>01031         <span class="keywordflow">case</span> 10:
<a name="l01032"></a>01032           <span class="keywordflow">return</span> -5605.599999999996+(-478963.4577777775+(-12815269.44444444+(-171640517.3604937+(-1371951477.497941+(-7147541864.43802+(-25485507407.83126+(-63848350696.57444+(-113517642944.8444+(-142532726188.3604+(-123573040616.0328+(-70383067474.29131+(-23695372327.63784-3572533058.628475*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01033"></a>01033 
<a name="l01034"></a>01034         <span class="keywordflow">case</span> 11:
<a name="l01035"></a>01035           <span class="keywordflow">return</span> 3503.500000000003+(294447.2611111113+(7720974.358611117+(101146405.0471606+(790417783.0809677+(4028557079.079386+(14071398696.88138+(34590639213.49616+(60449325371.26783+(74730994261.10376+(63894320392.36532+(35941453213.00941+(11966163025.45713+1786266529.31424*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01036"></a>01036 
<a name="l01037"></a>01037         <span class="keywordflow">case</span> 12:
<a name="l01038"></a>01038           <span class="keywordflow">return</span> -1698.666666666669+(-138798.752861953+(-3521413.568484853+(-44599342.83238314+(-337623011.738272+(-1672128961.184199+(-5694412271.43013+(-13691005583.17104+(-23467659366.85336+(-28527575611.29551+(-24035365582.07213+(-13347998549.55889+(-4394414504.398299-649551465.2051785*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01039"></a>01039 
<a name="l01040"></a>01040         <span class="keywordflow">case</span> 13:
<a name="l01041"></a>01041           <span class="keywordflow">return</span> 637.0000000000005+(49076.86565656569+(1169569.725050506+(14025401.12147027+(101447432.0348252+(483898256.0019139+(1597498806.855073+(3742961181.708809+(6278720198.481116+(7494910301.597536+(6218035822.71984+(3408014739.270754+(1109374249.884864+162387866.3012945*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01042"></a>01042 
<a name="l01043"></a>01043         <span class="keywordflow">case</span> 14:
<a name="l01044"></a>01044           <span class="keywordflow">return</span> -195.9999999999997+(-12356.57404817403+(-258935.5802020198+(-2840808.212210995+(-19261146.08559668+(-87507110.40641962+(-278204754.9117691+(-632709040.3499579+(-1036229385.084443+(-1212999534.859257+(-990221053.9430438+(-535453868.1829846+(-172329980.5646387-24982748.66173757*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v)*v;
<a name="l01045"></a>01045 
<a name="l01046"></a>01046         <span class="keywordflow">default</span>:
<a name="l01047"></a>01047           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l01048"></a>01048           libmesh_error();
<a name="l01049"></a>01049         }
<a name="l01050"></a>01050 
<a name="l01051"></a>01051 
<a name="l01052"></a>01052     <span class="comment">// provided the constructor worked fine, we should never end up here.</span>
<a name="l01053"></a>01053     <span class="keywordflow">default</span>:
<a name="l01054"></a>01054       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Lagrange polynomials only defined up to 15. &quot;</span>
<a name="l01055"></a>01055                     &lt;&lt; std::endl;
<a name="l01056"></a>01056       libmesh_error();
<a name="l01057"></a>01057     }
<a name="l01058"></a>01058 
<a name="l01059"></a>01059   <span class="comment">// we never end up here.</span>
<a name="l01060"></a>01060   <span class="keywordflow">return</span> 0.;
<a name="l01061"></a>01061 }
<a name="l01062"></a>01062 
<a name="l01063"></a>01063 
<a name="l01064"></a>01064 
<a name="l01065"></a>01065 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l01066"></a>01066 <span class="comment">// Explicit instantiations</span>
<a name="l01067"></a>01067 <span class="comment">// template class InfFE&lt;1,LAGRANGE,CARTESIAN&gt;;</span>
<a name="l01068"></a>01068 <span class="comment">// template class InfFE&lt;2,LAGRANGE,CARTESIAN&gt;;</span>
<a name="l01069"></a>01069 <span class="comment">// template class InfFE&lt;3,LAGRANGE,CARTESIAN&gt;;</span>
<a name="l01070"></a>01070 
<a name="l01071"></a>01071 <span class="comment">// template class InfFE&lt;1,LAGRANGE,SPHERICAL&gt;;</span>
<a name="l01072"></a>01072 <span class="comment">// template class InfFE&lt;2,LAGRANGE,SPHERICAL&gt;;</span>
<a name="l01073"></a>01073 <span class="comment">// template class InfFE&lt;3,LAGRANGE,SPHERICAL&gt;;</span>
<a name="l01074"></a>01074 
<a name="l01075"></a>01075 <span class="comment">// template class InfFE&lt;1,LAGRANGE,ELLIPSOIDAL&gt;;</span>
<a name="l01076"></a>01076 <span class="comment">// template class InfFE&lt;2,LAGRANGE,ELLIPSOIDAL&gt;;</span>
<a name="l01077"></a>01077 <span class="comment">// template class InfFE&lt;3,LAGRANGE,ELLIPSOIDAL&gt;;</span>
<a name="l01078"></a>01078 
<a name="l01079"></a>01079 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;1,LAGRANGE,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l01080"></a>01080 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;1,LAGRANGE,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l01081"></a>01081 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;2,LAGRANGE,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l01082"></a>01082 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;2,LAGRANGE,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l01083"></a>01083 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;3,LAGRANGE,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l01084"></a>01084 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;3,LAGRANGE,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l01085"></a>01085 
<a name="l01086"></a>01086 } <span class="comment">// namespace libMesh</span>
<a name="l01087"></a>01087 
<a name="l01088"></a>01088 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l01089"></a>01089 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
