<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_fe_legendre_eval.C</div>  </div>
</div>
<div class="contents">
<a href="inf__fe__legendre__eval_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe_legendre_eval.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local Includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="inf__fe__macro_8h.php">inf_fe_macro.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00033"></a>00033 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00034"></a>00034                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>, <span class="comment">/* not used */</span>
<a name="l00035"></a>00035                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00038"></a>00038 
<a name="l00039"></a>00039   <span class="keywordflow">switch</span> (i)
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041     <span class="keywordflow">case</span> 0:
<a name="l00042"></a>00042       <span class="keywordflow">return</span> 1.;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044     <span class="keywordflow">case</span> 1:
<a name="l00045"></a>00045       <span class="keywordflow">return</span> v+1.;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047     <span class="keywordflow">case</span> 2:
<a name="l00048"></a>00048       <span class="keywordflow">return</span> 1.5*v*v-1.5;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050     <span class="keywordflow">case</span> 3:
<a name="l00051"></a>00051       <span class="keywordflow">return</span> 1.+(-1.5+2.5*v*v)*v;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053     <span class="keywordflow">case</span> 4:
<a name="l00054"></a>00054       <span class="keywordflow">return</span> -.625+(-3.75+4.375*v*v)*v*v;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keywordflow">case</span> 5:
<a name="l00057"></a>00057       <span class="keywordflow">return</span> 1.+(1.875+(-8.75+7.875*v*v)*v*v)*v;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059     <span class="keywordflow">case</span> 6:
<a name="l00060"></a>00060       <span class="keywordflow">return</span> -1.3125+(6.5625+(-19.6875+14.4375*v*v)*v*v)*v*v;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     <span class="keywordflow">case</span> 7:
<a name="l00063"></a>00063       <span class="keywordflow">return</span> 1.+(-2.1875+(19.6875+(-43.3125+26.8125*v*v)*v*v)*v*v)*v;
<a name="l00064"></a>00064 
<a name="l00065"></a>00065     <span class="keywordflow">case</span> 8:
<a name="l00066"></a>00066       <span class="keywordflow">return</span> -.7265625+(-9.84375+(54.140625+(-93.84375+50.2734375*v*v)*v*v)*v*v)*v*v;
<a name="l00067"></a>00067 
<a name="l00068"></a>00068     <span class="keywordflow">case</span> 9:
<a name="l00069"></a>00069       <span class="keywordflow">return</span> 1.+(2.4609375+(-36.09375+(140.765625+(-201.09375+94.9609375*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     <span class="keywordflow">case</span> 10:
<a name="l00072"></a>00072       <span class="keywordflow">return</span> -1.24609375+(13.53515625+(-117.3046875+(351.9140625+(-427.32421875+180.42578125*v*v)*v*v)*v*v)*v*v)*v*v;
<a name="l00073"></a>00073 
<a name="l00074"></a>00074     <span class="keywordflow">case</span> 11:
<a name="l00075"></a>00075       <span class="keywordflow">return</span> 1.+(-2.70703125+(58.65234375+(-351.9140625+(854.6484375+(-902.12890625+344.44921875*v*v)*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077     <span class="keywordflow">case</span> 12:
<a name="l00078"></a>00078       <span class="keywordflow">return</span> -.7744140625+(-17.595703125+(219.9462890625+(-997.08984375+(2029.7900390625+(-1894.470703125+660.1943359375*v*v)*v*v)*v*v)*v*v)*v*v)*v*v;
<a name="l00079"></a>00079 
<a name="l00080"></a>00080     <span class="keywordflow">case</span> 13:
<a name="l00081"></a>00081       <span class="keywordflow">return</span> 1.+(2.9326171875+(-87.978515625+(747.8173828125+(-2706.38671875+(4736.1767578125+(-3961.166015625+1269.6044921875*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00082"></a>00082 
<a name="l00083"></a>00083     <span class="keywordflow">case</span> 14:
<a name="l00084"></a>00084       <span class="keywordflow">return</span> -1.20947265625+(21.99462890625+(-373.90869140625+(2368.08837890625+(-7104.26513671875+(10893.20654296875+(-8252.42919921875+2448.52294921875*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v;
<a name="l00085"></a>00085 
<a name="l00086"></a>00086     <span class="keywordflow">case</span> 15:
<a name="l00087"></a>00087       <span class="keywordflow">return</span> 1.+(-3.14208984375+(124.63623046875+(-1420.85302734375+(7104.26513671875+(-18155.34423828125+(24757.28759765625+(-17139.66064453125+4733.81103515625*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00088"></a>00088 
<a name="l00089"></a>00089     <span class="keywordflow">case</span> 16:
<a name="l00090"></a>00090       <span class="keywordflow">return</span> -.803619384765625+(-26.707763671875+(592.0220947265625+(-4972.985595703125+(20424.76226806641+(-45388.36059570313+(55703.89709472656+(-35503.58276367188+9171.758880615234*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v;
<a name="l00091"></a>00091 
<a name="l00092"></a>00092     <span class="keywordflow">case</span> 17:
<a name="l00093"></a>00093       <span class="keywordflow">return</span> 1.+(3.338470458984375+(-169.149169921875+(2486.492797851563+(-16339.80981445313+(56735.45074462891+(-111407.7941894531+(124262.5396728516+(-73374.07104492188+17804.00253295898*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00094"></a>00094 
<a name="l00095"></a>00095     <span class="keywordflow">case</span> 18:
<a name="l00096"></a>00096       <span class="keywordflow">return</span> -1.185470581054688+(31.71546936035156+(-888.0331420898438+(9531.555725097656+(-51061.90567016602+(153185.717010498+(-269235.5026245117+(275152.766418457+(-151334.0215301514+34618.89381408691*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099     <span class="keywordflow">default</span>:
<a name="l00100"></a>00100       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00101"></a>00101       libmesh_error();
<a name="l00102"></a>00102 
<a name="l00103"></a>00103     }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">// we never end up here.</span>
<a name="l00106"></a>00106   <span class="keywordflow">return</span> 0.;
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00112"></a>00112 <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;Dim,T_radial,T_map&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> v,
<a name="l00113"></a>00113                                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>, <span class="comment">/* not used */</span>
<a name="l00114"></a>00114                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116   libmesh_assert (-1.-1.e-5 &lt;= v &amp;&amp; v &lt; 1.);
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="keywordflow">switch</span> (i)
<a name="l00119"></a>00119     {
<a name="l00120"></a>00120     <span class="keywordflow">case</span> 0:
<a name="l00121"></a>00121       <span class="keywordflow">return</span> 0.;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123     <span class="keywordflow">case</span> 1:
<a name="l00124"></a>00124       <span class="keywordflow">return</span> 1.;
<a name="l00125"></a>00125 
<a name="l00126"></a>00126     <span class="keywordflow">case</span> 2:
<a name="l00127"></a>00127       <span class="keywordflow">return</span> 3.*v;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129     <span class="keywordflow">case</span> 3:
<a name="l00130"></a>00130       <span class="keywordflow">return</span> 7.5*v*v-1.5;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132     <span class="keywordflow">case</span> 4:
<a name="l00133"></a>00133       <span class="keywordflow">return</span> (-7.5+17.5*v*v)*v;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135     <span class="keywordflow">case</span> 5:
<a name="l00136"></a>00136       <span class="keywordflow">return</span> 1.875+(-26.25+39.375*v*v)*v*v;
<a name="l00137"></a>00137 
<a name="l00138"></a>00138     <span class="keywordflow">case</span> 6:
<a name="l00139"></a>00139       <span class="keywordflow">return</span> (13.125+(-78.75+86.625*v*v)*v*v)*v;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <span class="keywordflow">case</span> 7:
<a name="l00142"></a>00142       <span class="keywordflow">return</span> -2.1875+(59.0625+(-216.5625+187.6875*v*v)*v*v)*v*v;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="keywordflow">case</span> 8:
<a name="l00145"></a>00145       <span class="keywordflow">return</span> (-19.6875+(216.5625+(-563.0625+402.1875*v*v)*v*v)*v*v)*v;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     <span class="keywordflow">case</span> 9:
<a name="l00148"></a>00148       <span class="keywordflow">return</span> 2.4609375+(-108.28125+(703.828125+(-1407.65625+854.6484375*v*v)*v*v)*v*v)*v*v;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150     <span class="keywordflow">case</span> 10:
<a name="l00151"></a>00151       <span class="keywordflow">return</span> (27.0703125+(-469.21875+(2111.484375+(-3418.59375+1804.2578125*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00152"></a>00152 
<a name="l00153"></a>00153     <span class="keywordflow">case</span> 11:
<a name="l00154"></a>00154       <span class="keywordflow">return</span> -2.70703125+(175.95703125+(-1759.5703125+(5982.5390625+(-8119.16015625+3788.94140625*v*v)*v*v)*v*v)*v*v)*v*v;
<a name="l00155"></a>00155 
<a name="l00156"></a>00156     <span class="keywordflow">case</span> 12:
<a name="l00157"></a>00157       <span class="keywordflow">return</span> (-35.19140625+(879.78515625+(-5982.5390625+(16238.3203125+(-18944.70703125+7922.33203125*v*v)*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00158"></a>00158 
<a name="l00159"></a>00159     <span class="keywordflow">case</span> 13:
<a name="l00160"></a>00160       <span class="keywordflow">return</span> 2.9326171875+(-263.935546875+(3739.0869140625+(-18944.70703125+(42625.5908203125+(-43572.826171875+16504.8583984375*v*v)*v*v)*v*v)*v*v)*v*v)*v*v;
<a name="l00161"></a>00161 
<a name="l00162"></a>00162     <span class="keywordflow">case</span> 14:
<a name="l00163"></a>00163       <span class="keywordflow">return</span> (43.9892578125+(-1495.634765625+(14208.5302734375+(-56834.12109375+(108932.0654296875+(-99029.150390625+34279.3212890625*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00164"></a>00164 
<a name="l00165"></a>00165     <span class="keywordflow">case</span> 15:
<a name="l00166"></a>00166       <span class="keywordflow">return</span> -3.14208984375+(373.90869140625+(-7104.26513671875+(49729.85595703125+(-163398.0981445313+(272330.1635742188+(-222815.5883789063+71007.16552734375*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v;
<a name="l00167"></a>00167 
<a name="l00168"></a>00168     <span class="keywordflow">case</span> 16:
<a name="l00169"></a>00169       <span class="keywordflow">return</span> (-53.41552734375+(2368.08837890625+(-29837.91357421875+(163398.0981445313+(-453883.6059570313+(668446.7651367188+(-497050.1586914063+146748.1420898438*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171     <span class="keywordflow">case</span> 17:
<a name="l00172"></a>00172       <span class="keywordflow">return</span> 3.338470458984375+(-507.447509765625+(12432.46398925781+(-114378.6687011719+(510619.0567016602+(-1225485.736083984+(1615413.01574707+(-1100611.065673828+302668.0430603027*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174     <span class="keywordflow">case</span> 18:
<a name="l00175"></a>00175       <span class="keywordflow">return</span> (63.43093872070313+(-3552.132568359375+(57189.33435058594+(-408495.2453613281+(1531857.17010498+(-3230826.031494141+(3852138.729858398+(-2421344.344482422+623140.0886535645*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v*v)*v;
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178     <span class="keywordflow">default</span>:
<a name="l00179"></a>00179       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;bad index i = &quot;</span> &lt;&lt; i &lt;&lt; std::endl;
<a name="l00180"></a>00180       libmesh_error();
<a name="l00181"></a>00181 
<a name="l00182"></a>00182     }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184   <span class="comment">// we never end up here.</span>
<a name="l00185"></a>00185   <span class="keywordflow">return</span> 0.;
<a name="l00186"></a>00186 }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00191"></a>00191 <span class="comment">// Explicit instantiations</span>
<a name="l00192"></a>00192 <span class="comment">// template class InfFE&lt;1,LEGENDRE,CARTESIAN&gt;;</span>
<a name="l00193"></a>00193 <span class="comment">// template class InfFE&lt;2,LEGENDRE,CARTESIAN&gt;;</span>
<a name="l00194"></a>00194 <span class="comment">// template class InfFE&lt;3,LEGENDRE,CARTESIAN&gt;;</span>
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="comment">// template class InfFE&lt;1,LEGENDRE,SPHERICAL&gt;;</span>
<a name="l00197"></a>00197 <span class="comment">// template class InfFE&lt;2,LEGENDRE,SPHERICAL&gt;;</span>
<a name="l00198"></a>00198 <span class="comment">// template class InfFE&lt;3,LEGENDRE,SPHERICAL&gt;;</span>
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 <span class="comment">// template class InfFE&lt;1,LEGENDRE,ELLIPSOIDAL&gt;;</span>
<a name="l00201"></a>00201 <span class="comment">// template class InfFE&lt;2,LEGENDRE,ELLIPSOIDAL&gt;;</span>
<a name="l00202"></a>00202 <span class="comment">// template class InfFE&lt;3,LEGENDRE,ELLIPSOIDAL&gt;;</span>
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;1,LEGENDRE,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00205"></a>00205 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;1,LEGENDRE,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00206"></a>00206 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;2,LEGENDRE,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00207"></a>00207 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;2,LEGENDRE,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00208"></a>00208 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;3,LEGENDRE,CARTESIAN&gt;::eval</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00209"></a>00209 <span class="keyword">template</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#acfa5cba83479816c580b3fe3be133033">InfFE&lt;3,LEGENDRE,CARTESIAN&gt;::eval_deriv</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 } <span class="comment">// namespace libMesh</span>
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00215"></a>00215 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
