<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_80cc4cce2395f56f668cf780c4b1eac8.php">fe</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">inf_fe_static.C</div>  </div>
</div>
<div class="contents">
<a href="inf__fe__static_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: inf_fe_static.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="inf__fe_8h.php">inf_fe.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="inf__fe__macro_8h.php">inf_fe_macro.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="fe_8h.php">fe.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="fe__compute__data_8h.php">fe_compute_data.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// InfFE class static member initialization</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00038"></a>00038 <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> InfFE&lt;Dim,T_radial,T_map&gt;::_compute_node_indices_fast_current_elem_type = <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span>
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00043"></a>00043 <span class="keywordtype">bool</span> InfFE&lt;Dim,T_radial,T_map&gt;::_warned_for_nodal_soln = <span class="keyword">false</span>;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00047"></a>00047 <span class="keywordtype">bool</span> InfFE&lt;Dim,T_radial,T_map&gt;::_warned_for_shape      = <span class="keyword">false</span>;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="preprocessor">#endif</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span>
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// InfFE static class members</span>
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1InfFE.php#a3f1303f14c587b80140058f4652ea5c6">00057</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#a3f1303f14c587b80140058f4652ea5c6">InfFE&lt;Dim,T_radial,T_map&gt;::n_dofs</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00058"></a>00058                                                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_et (Base::get_elem_type(inf_elem_type));
<a name="l00061"></a>00061     
<a name="l00062"></a>00062   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00063"></a>00063     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a8d6e670715080e79706ded0009742acc">FEInterface::n_dofs</a>(Dim-1, fet, base_et) * Radial::n_dofs(fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);
<a name="l00064"></a>00064   <span class="keywordflow">else</span>
<a name="l00065"></a>00065     <span class="keywordflow">return</span> Radial::n_dofs(fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00074"></a><a class="code" href="classlibMesh_1_1InfFE.php#a197bf5ebd7b734cb9de463f714ed2293">00074</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#a197bf5ebd7b734cb9de463f714ed2293">InfFE&lt;Dim,T_radial,T_map&gt;::n_dofs_at_node</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00075"></a>00075                                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00076"></a>00076                                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_et (Base::get_elem_type(inf_elem_type));
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base, n_radial;
<a name="l00081"></a>00081   compute_node_indices(inf_elem_type, n, n_base, n_radial);
<a name="l00082"></a>00082   
<a name="l00083"></a>00083 <span class="comment">//   libMesh::out &lt;&lt; &quot;elem_type=&quot; &lt;&lt; inf_elem_type </span>
<a name="l00084"></a>00084 <span class="comment">//          &lt;&lt; &quot;,  fet.radial_order=&quot; &lt;&lt; fet.radial_order</span>
<a name="l00085"></a>00085 <span class="comment">//          &lt;&lt; &quot;,  n=&quot; &lt;&lt; n </span>
<a name="l00086"></a>00086 <span class="comment">//          &lt;&lt; &quot;,  n_radial=&quot; &lt;&lt; n_radial </span>
<a name="l00087"></a>00087 <span class="comment">//          &lt;&lt; &quot;,  n_base=&quot; &lt;&lt; n_base</span>
<a name="l00088"></a>00088 <span class="comment">//          &lt;&lt; std::endl;</span>
<a name="l00089"></a>00089 
<a name="l00090"></a>00090   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00091"></a>00091     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a>(Dim-1, fet, base_et, n_base) 
<a name="l00092"></a>00092         * Radial::n_dofs_at_node(fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>, n_radial);
<a name="l00093"></a>00093   <span class="keywordflow">else</span>
<a name="l00094"></a>00094     <span class="keywordflow">return</span> Radial::n_dofs_at_node(fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>, n_radial);
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00103"></a><a class="code" href="classlibMesh_1_1InfFE.php#ad970acd91b1df49608f75375a594df94">00103</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1InfFE.php#ad970acd91b1df49608f75375a594df94">InfFE&lt;Dim,T_radial,T_map&gt;::n_dofs_per_elem</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00104"></a>00104                                                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_et (Base::get_elem_type(inf_elem_type));
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00109"></a>00109     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">FEInterface::n_dofs_per_elem</a>(Dim-1, fet, base_et) 
<a name="l00110"></a>00110         * Radial::n_dofs_per_elem(fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);
<a name="l00111"></a>00111   <span class="keywordflow">else</span>
<a name="l00112"></a>00112     <span class="keywordflow">return</span> Radial::n_dofs_per_elem(fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);
<a name="l00113"></a>00113 }
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00121"></a><a class="code" href="classlibMesh_1_1InfFE.php#af60a6f7d080591594db6e2736f55bcb7">00121</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#af60a6f7d080591594db6e2736f55bcb7">InfFE&lt;Dim,T_radial,T_map&gt;::nodal_soln</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; <span class="comment">/* fet */</span>,
<a name="l00122"></a>00122                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="comment">/* elem */</span>,
<a name="l00123"></a>00123                                            <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; <span class="comment">/* elem_soln */</span>,
<a name="l00124"></a>00124                                            std::vector&lt;Number&gt;&amp;       nodal_soln)
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (!_warned_for_nodal_soln)
<a name="l00128"></a>00128     {
<a name="l00129"></a>00129       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: nodal_soln(...) does _not_ work for infinite elements.&quot;</span> &lt;&lt; std::endl
<a name="l00130"></a>00130                     &lt;&lt; <span class="stringliteral">&quot; Will return an empty nodal solution.  Use &quot;</span> &lt;&lt; std::endl
<a name="l00131"></a>00131                     &lt;&lt; <span class="stringliteral">&quot; InfFE&lt;Dim,T_radial,T_map&gt;::compute_data(..) instead!&quot;</span> &lt;&lt; std::endl;
<a name="l00132"></a>00132       _warned_for_nodal_soln = <span class="keyword">true</span>;
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134 <span class="preprocessor">#endif</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>
<a name="l00136"></a>00136   <span class="comment">/*</span>
<a name="l00137"></a>00137 <span class="comment">   * In the base the infinite element couples to</span>
<a name="l00138"></a>00138 <span class="comment">   * conventional finite elements.  To not destroy</span>
<a name="l00139"></a>00139 <span class="comment">   * the values there, clear \p nodal_soln.  This</span>
<a name="l00140"></a>00140 <span class="comment">   * indicates to the user of \p nodal_soln to</span>
<a name="l00141"></a>00141 <span class="comment">   * not use this result.</span>
<a name="l00142"></a>00142 <span class="comment">   */</span>
<a name="l00143"></a>00143   nodal_soln.clear();
<a name="l00144"></a>00144   libmesh_assert (nodal_soln.begin() == nodal_soln.end());
<a name="l00145"></a>00145   <span class="keywordflow">return</span>;
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00156"></a><a class="code" href="classlibMesh_1_1InfFE.php#aa8d2683754d22d28af105ff858cbb273">00156</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#aa8d2683754d22d28af105ff858cbb273">InfFE&lt;Dim,T_radial,T_map&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00157"></a>00157                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00158"></a>00158                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00159"></a>00159                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161   libmesh_assert (Dim != 0);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>  <span class="comment">// this makes only sense when used for mapping</span>
<a name="l00165"></a>00165   <span class="keywordflow">if</span> ((T_radial != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>) &amp;&amp; !_warned_for_shape)
<a name="l00166"></a>00166     {
<a name="l00167"></a>00167       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: InfFE&lt;Dim,T_radial,T_map&gt;::shape(...) does _not_&quot;</span> &lt;&lt; std::endl
<a name="l00168"></a>00168                     &lt;&lt; <span class="stringliteral">&quot; return the correct trial function!  Use &quot;</span> &lt;&lt; std::endl
<a name="l00169"></a>00169                     &lt;&lt; <span class="stringliteral">&quot; InfFE&lt;Dim,T_radial,T_map&gt;::compute_data(..) instead!&quot;</span> 
<a name="l00170"></a>00170                     &lt;&lt; std::endl;
<a name="l00171"></a>00171       _warned_for_shape = <span class="keyword">true</span>;
<a name="l00172"></a>00172     }
<a name="l00173"></a>00173 <span class="preprocessor">#endif</span>
<a name="l00174"></a>00174 <span class="preprocessor"></span>
<a name="l00175"></a>00175   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>     base_et  (Base::get_elem_type(inf_elem_type));
<a name="l00176"></a>00176   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        o_radial (fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);
<a name="l00177"></a>00177   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>         v        (p(Dim-1));
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_base, i_radial;
<a name="l00180"></a>00180   compute_shape_indices(fet, inf_elem_type, i, i_base, i_radial);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="comment">//TODO:[SP/DD]  exp(ikr) is still missing here!</span>
<a name="l00183"></a>00183   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00184"></a>00184     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">FEInterface::shape</a>(Dim-1, fet, base_et, i_base, p)
<a name="l00185"></a>00185         * <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(v, o_radial, i_radial)
<a name="l00186"></a>00186         * <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#aa102427e01a09378006d335620b38959">InfFE&lt;Dim,T_radial,T_map&gt;::Radial::decay</a>(v);
<a name="l00187"></a>00187   <span class="keywordflow">else</span>
<a name="l00188"></a>00188     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(v, o_radial, i_radial)
<a name="l00189"></a>00189         * <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#aa102427e01a09378006d335620b38959">InfFE&lt;Dim,T_radial,T_map&gt;::Radial::decay</a>(v);
<a name="l00190"></a>00190 }
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00198"></a><a class="code" href="classlibMesh_1_1InfFE.php#a3256b59ec7004297621588236d24b6b7">00198</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1InfFE.php#aa8d2683754d22d28af105ff858cbb273">InfFE&lt;Dim,T_radial,T_map&gt;::shape</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00199"></a>00199                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem,
<a name="l00200"></a>00200                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00201"></a>00201                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00202"></a>00202 {
<a name="l00203"></a>00203   libmesh_assert (inf_elem != NULL);
<a name="l00204"></a>00204   libmesh_assert (Dim != 0);
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>  <span class="comment">// this makes only sense when used for mapping</span>
<a name="l00208"></a>00208   <span class="keywordflow">if</span> ((T_radial != <a class="code" href="namespacelibMeshEnums.php#a6438eaaa28d7dbe2aa2f19e9de2ef0d5a71025d1f59830aa9264a533822120185">INFINITE_MAP</a>) &amp;&amp; !_warned_for_shape)
<a name="l00209"></a>00209     {
<a name="l00210"></a>00210       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: InfFE&lt;Dim,T_radial,T_map&gt;::shape(...) does _not_&quot;</span> &lt;&lt; std::endl
<a name="l00211"></a>00211                     &lt;&lt; <span class="stringliteral">&quot; return the correct trial function!  Use &quot;</span> &lt;&lt; std::endl
<a name="l00212"></a>00212                     &lt;&lt; <span class="stringliteral">&quot; InfFE&lt;Dim,T_radial,T_map&gt;::compute_data(..) instead!&quot;</span> 
<a name="l00213"></a>00213                     &lt;&lt; std::endl;
<a name="l00214"></a>00214       _warned_for_shape = <span class="keyword">true</span>;
<a name="l00215"></a>00215     }
<a name="l00216"></a>00216 <span class="preprocessor">#endif</span>
<a name="l00217"></a>00217 <span class="preprocessor"></span>
<a name="l00218"></a>00218   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        o_radial (fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);
<a name="l00219"></a>00219   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>         v        (p(Dim-1));
<a name="l00220"></a>00220   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>      base_el  (inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(0));
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_base, i_radial;
<a name="l00223"></a>00223   compute_shape_indices(fet, inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), i, i_base, i_radial);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00226"></a>00226     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">FEInterface::shape</a>(Dim-1, fet, base_el.get(), i_base, p)
<a name="l00227"></a>00227         * <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(v, o_radial, i_radial)
<a name="l00228"></a>00228         * <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#aa102427e01a09378006d335620b38959">InfFE&lt;Dim,T_radial,T_map&gt;::Radial::decay</a>(v);
<a name="l00229"></a>00229   <span class="keywordflow">else</span>
<a name="l00230"></a>00230     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(v, o_radial, i_radial)
<a name="l00231"></a>00231         * <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#aa102427e01a09378006d335620b38959">InfFE&lt;Dim,T_radial,T_map&gt;::Radial::decay</a>(v);
<a name="l00232"></a>00232 }
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00241"></a><a class="code" href="classlibMesh_1_1InfFE.php#abeba42623f9312b6d884e974de4751e1">00241</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#abeba42623f9312b6d884e974de4751e1">InfFE&lt;Dim,T_radial,T_map&gt;::compute_data</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00242"></a>00242                                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* inf_elem,
<a name="l00243"></a>00243                                              <a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a>&amp; data)
<a name="l00244"></a>00244 {
<a name="l00245"></a>00245   libmesh_assert (inf_elem != NULL);
<a name="l00246"></a>00246   libmesh_assert (Dim != 0);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        o_radial             (fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);
<a name="l00249"></a>00249   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>        radial_mapping_order (Radial::mapping_order());    
<a name="l00250"></a>00250   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;       p                    (data.<a class="code" href="classlibMesh_1_1FEComputeData.php#a23e7e761ccb626914ba41de94cfa9465">p</a>);
<a name="l00251"></a>00251   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>         v                    (p(Dim-1));
<a name="l00252"></a>00252   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a>      base_el              (inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(0));
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="comment">/*</span>
<a name="l00255"></a>00255 <span class="comment">   * compute \p interpolated_dist containing the mapping-interpolated </span>
<a name="l00256"></a>00256 <span class="comment">   * distance of the base point to the origin.  This is the same</span>
<a name="l00257"></a>00257 <span class="comment">   * for all shape functions.  Set \p interpolated_dist to 0, it</span>
<a name="l00258"></a>00258 <span class="comment">   * is added to.</span>
<a name="l00259"></a>00259 <span class="comment">   */</span>
<a name="l00260"></a>00260   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> interpolated_dist = 0.;
<a name="l00261"></a>00261   <span class="keywordflow">switch</span> (Dim)
<a name="l00262"></a>00262     {  
<a name="l00263"></a>00263     <span class="keywordflow">case</span> 1:
<a name="l00264"></a>00264       { 
<a name="l00265"></a>00265         libmesh_assert (inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>);
<a name="l00266"></a>00266         interpolated_dist =  <a class="code" href="classlibMesh_1_1Point.php">Point</a>(inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(0) - inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(1)).size();
<a name="l00267"></a>00267         <span class="keywordflow">break</span>;
<a name="l00268"></a>00268       }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270     <span class="keywordflow">case</span> 2:
<a name="l00271"></a>00271       {
<a name="l00272"></a>00272         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_nodes = base_el-&gt;n_nodes();
<a name="l00273"></a>00273 
<a name="l00274"></a>00274         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>    origin                 = inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4da21e127a2f2f1b35168b3cfd458b74">origin</a>();
<a name="l00275"></a>00275         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    base_mapping_order     (base_el-&gt;default_order());
<a name="l00276"></a>00276         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_mapping_elem_type (base_el-&gt;type());
<a name="l00277"></a>00277 
<a name="l00278"></a>00278         <span class="comment">// interpolate the base nodes&#39; distances</span>
<a name="l00279"></a>00279         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_base_nodes; n++)
<a name="l00280"></a>00280             interpolated_dist += <a class="code" href="classlibMesh_1_1Point.php">Point</a>(base_el-&gt;point(n) - origin).size()
<a name="l00281"></a>00281                 * <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;1,LAGRANGE&gt;::shape</a> (base_mapping_elem_type, base_mapping_order, n, p);
<a name="l00282"></a>00282         <span class="keywordflow">break</span>;
<a name="l00283"></a>00283       }
<a name="l00284"></a>00284 
<a name="l00285"></a>00285     <span class="keywordflow">case</span> 3:
<a name="l00286"></a>00286       {
<a name="l00287"></a>00287         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_nodes = base_el-&gt;n_nodes();
<a name="l00288"></a>00288 
<a name="l00289"></a>00289         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>    origin                 = inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4da21e127a2f2f1b35168b3cfd458b74">origin</a>();
<a name="l00290"></a>00290         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a>    base_mapping_order     (base_el-&gt;default_order());
<a name="l00291"></a>00291         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_mapping_elem_type (base_el-&gt;type());
<a name="l00292"></a>00292 
<a name="l00293"></a>00293         <span class="comment">// interpolate the base nodes&#39; distances</span>
<a name="l00294"></a>00294         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_base_nodes; n++)
<a name="l00295"></a>00295             interpolated_dist += <a class="code" href="classlibMesh_1_1Point.php">Point</a>(base_el-&gt;point(n) - origin).size()
<a name="l00296"></a>00296                 * <a class="code" href="classlibMesh_1_1FE.php#a9177d9a9fde77a4ba51f0f5c5c0ca313">FE&lt;2,LAGRANGE&gt;::shape</a> (base_mapping_elem_type, base_mapping_order, n, p);
<a name="l00297"></a>00297         <span class="keywordflow">break</span>;
<a name="l00298"></a>00298       }
<a name="l00299"></a>00299 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00300"></a>00300 <span class="preprocessor"></span>    <span class="keywordflow">default</span>:
<a name="l00301"></a>00301         libmesh_error();
<a name="l00302"></a>00302 <span class="preprocessor">#endif</span>
<a name="l00303"></a>00303 <span class="preprocessor"></span>    }
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00308"></a>00308 <span class="preprocessor"></span>
<a name="l00309"></a>00309   <span class="comment">// assumption on time-harmonic behavior</span>
<a name="l00310"></a>00310   <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> sign (-1);
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   <span class="comment">// the wave number</span>
<a name="l00313"></a>00313   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wavenumber = 2. * <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a> * data.<a class="code" href="classlibMesh_1_1FEComputeData.php#a7311109aecee478a1ce9e4dd62b975db">frequency</a> / data.<a class="code" href="classlibMesh_1_1FEComputeData.php#ad9aef672ac8a346ce0d1c8ec0873ae0b">speed</a>;
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="comment">// the exponent for time-harmonic behavior</span>
<a name="l00316"></a>00316   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> exponent = sign                                                            <span class="comment">/* +1. or -1.                */</span>
<a name="l00317"></a>00317       * wavenumber                                                                      <span class="comment">/* k                         */</span>
<a name="l00318"></a>00318       * interpolated_dist                                                               <span class="comment">/* together with next line:  */</span>
<a name="l00319"></a>00319       * <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval</a>(v, radial_mapping_order, 1);                <span class="comment">/* phase(s,t,v)              */</span>
<a name="l00320"></a>00320 
<a name="l00321"></a>00321   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> time_harmonic = <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>(cos(exponent), sin(exponent));                    <span class="comment">/* e^(sign*i*k*phase(s,t,v)) */</span>
<a name="l00322"></a>00322 
<a name="l00323"></a>00323   <span class="comment">/*</span>
<a name="l00324"></a>00324 <span class="comment">   * compute \p shape for all dof in the element</span>
<a name="l00325"></a>00325 <span class="comment">   */</span>
<a name="l00326"></a>00326   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00327"></a>00327     {
<a name="l00328"></a>00328       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dof = n_dofs (fet, inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00329"></a>00329       data.<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>.resize(n_dof);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dof; i++)
<a name="l00332"></a>00332         {
<a name="l00333"></a>00333           <span class="comment">// compute base and radial shape indices</span>
<a name="l00334"></a>00334           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_base, i_radial;
<a name="l00335"></a>00335           compute_shape_indices(fet, inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), i, i_base, i_radial);
<a name="l00336"></a>00336  
<a name="l00337"></a>00337           data.<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>[i] = (<a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#aa102427e01a09378006d335620b38959">InfFE&lt;Dim,T_radial,T_map&gt;::Radial::decay</a>(v)                  <span class="comment">/* (1.-v)/2. in 3D          */</span>
<a name="l00338"></a>00338                            *  <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">FEInterface::shape</a>(Dim-1, fet, base_el.get(), i_base, p)  <span class="comment">/* S_n(s,t)                 */</span>
<a name="l00339"></a>00339                            * <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(v, o_radial, i_radial))    <span class="comment">/* L_n(v)                   */</span>
<a name="l00340"></a>00340               * time_harmonic;                                                          <span class="comment">/* e^(sign*i*k*phase(s,t,v) */</span>
<a name="l00341"></a>00341         }
<a name="l00342"></a>00342     }
<a name="l00343"></a>00343   <span class="keywordflow">else</span>
<a name="l00344"></a>00344     {   
<a name="l00345"></a>00345       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;compute_data() for 1-dimensional InfFE not implemented.&quot;</span> &lt;&lt; std::endl;
<a name="l00346"></a>00346       libmesh_error();
<a name="l00347"></a>00347     }
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 <span class="preprocessor">#else</span>
<a name="l00350"></a>00350 <span class="preprocessor"></span>
<a name="l00351"></a>00351   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> speed = data.<a class="code" href="classlibMesh_1_1FEComputeData.php#ad9aef672ac8a346ce0d1c8ec0873ae0b">speed</a>;
<a name="l00352"></a>00352 
<a name="l00353"></a>00353   <span class="comment">/*</span>
<a name="l00354"></a>00354 <span class="comment">   * This is quite weird: the phase is actually </span>
<a name="l00355"></a>00355 <span class="comment">   * a measure how @e advanced the pressure is that</span>
<a name="l00356"></a>00356 <span class="comment">   * we compute.  In other words: the further away </span>
<a name="l00357"></a>00357 <span class="comment">   * the node \p data.p is, the further we look into</span>
<a name="l00358"></a>00358 <span class="comment">   * the future... </span>
<a name="l00359"></a>00359 <span class="comment">   */</span>
<a name="l00360"></a>00360   data.<a class="code" href="classlibMesh_1_1FEComputeData.php#ad1bbba20949444c9a995733d2f599770">phase</a> = interpolated_dist                                                       <span class="comment">/* phase(s,t,v)/c  */</span>
<a name="l00361"></a>00361       * <a class="code" href="classlibMesh_1_1InfFE.php#ae5b28e102ccdd23493b221d4c7f6a25e">InfFE&lt;Dim,INFINITE_MAP,T_map&gt;::eval</a>(v, radial_mapping_order, 1) / speed;
<a name="l00362"></a>00362 
<a name="l00363"></a>00363   <span class="keywordflow">if</span> (Dim &gt; 1)
<a name="l00364"></a>00364     {
<a name="l00365"></a>00365       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dof = n_dofs (fet, inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l00366"></a>00366       data.<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>.resize(n_dof);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dof; i++)
<a name="l00369"></a>00369         {
<a name="l00370"></a>00370           <span class="comment">// compute base and radial shape indices</span>
<a name="l00371"></a>00371           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_base, i_radial;
<a name="l00372"></a>00372           compute_shape_indices(fet, inf_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), i, i_base, i_radial);
<a name="l00373"></a>00373  
<a name="l00374"></a>00374           data.<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>[i] = <a class="code" href="classlibMesh_1_1InfFE_1_1Radial.php#aa102427e01a09378006d335620b38959">InfFE&lt;Dim,T_radial,T_map&gt;::Radial::decay</a>(v)                  <span class="comment">/* (1.-v)/2. in 3D */</span>
<a name="l00375"></a>00375                           *  <a class="code" href="classlibMesh_1_1FEInterface.php#a17412c020fcf8e4cba13e2da4ec39ef8">FEInterface::shape</a>(Dim-1, fet, base_el.get(), i_base, p)  <span class="comment">/* S_n(s,t)        */</span>
<a name="l00376"></a>00376                           * <a class="code" href="classlibMesh_1_1InfFE.php">InfFE&lt;Dim,T_radial,T_map&gt;::eval</a>(v, o_radial, i_radial);    <span class="comment">/* L_n(v)          */</span>
<a name="l00377"></a>00377         }
<a name="l00378"></a>00378     }
<a name="l00379"></a>00379   <span class="keywordflow">else</span>
<a name="l00380"></a>00380     {   
<a name="l00381"></a>00381       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;compute_data() for 1-dimensional InfFE not implemented.&quot;</span> &lt;&lt; std::endl;
<a name="l00382"></a>00382       libmesh_error();
<a name="l00383"></a>00383     }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="preprocessor">#endif</span>
<a name="l00386"></a>00386 <span class="preprocessor"></span>}
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00394"></a><a class="code" href="classlibMesh_1_1InfFE.php#ac3df17ad887b002540cc538849448a2e">00394</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#ac3df17ad887b002540cc538849448a2e">InfFE&lt;Dim,T_radial,T_map&gt;::compute_node_indices</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00395"></a>00395                                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> outer_node_index,
<a name="l00396"></a>00396                                                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; base_node,
<a name="l00397"></a>00397                                                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; radial_node)
<a name="l00398"></a>00398 {
<a name="l00399"></a>00399   <span class="keywordflow">switch</span> (inf_elem_type)
<a name="l00400"></a>00400     {
<a name="l00401"></a>00401     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00402"></a>00402       {
<a name="l00403"></a>00403         libmesh_assert (outer_node_index &lt; 2);
<a name="l00404"></a>00404         base_node   = 0;
<a name="l00405"></a>00405         radial_node = outer_node_index;
<a name="l00406"></a>00406         <span class="keywordflow">return</span>;
<a name="l00407"></a>00407       }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410     <span class="comment">// linear base approximation, easy to determine</span>
<a name="l00411"></a>00411     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00412"></a>00412       {
<a name="l00413"></a>00413         libmesh_assert (outer_node_index &lt; 4);
<a name="l00414"></a>00414         base_node   = outer_node_index % 2;
<a name="l00415"></a>00415         radial_node = outer_node_index / 2;
<a name="l00416"></a>00416         <span class="keywordflow">return</span>;
<a name="l00417"></a>00417       }
<a name="l00418"></a>00418 
<a name="l00419"></a>00419     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00420"></a>00420       {
<a name="l00421"></a>00421         libmesh_assert (outer_node_index &lt; 6);
<a name="l00422"></a>00422         base_node   = outer_node_index % 3;
<a name="l00423"></a>00423         radial_node = outer_node_index / 3;
<a name="l00424"></a>00424         <span class="keywordflow">return</span>;
<a name="l00425"></a>00425       }
<a name="l00426"></a>00426 
<a name="l00427"></a>00427     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00428"></a>00428       {
<a name="l00429"></a>00429         libmesh_assert (outer_node_index &lt; 8);
<a name="l00430"></a>00430         base_node   = outer_node_index % 4;
<a name="l00431"></a>00431         radial_node = outer_node_index / 4;
<a name="l00432"></a>00432         <span class="keywordflow">return</span>;
<a name="l00433"></a>00433       }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436     <span class="comment">// higher order base approximation, more work necessary</span>
<a name="l00437"></a>00437     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00438"></a>00438       {
<a name="l00439"></a>00439         <span class="keywordflow">switch</span> (outer_node_index)
<a name="l00440"></a>00440           {
<a name="l00441"></a>00441           <span class="keywordflow">case</span> 0:
<a name="l00442"></a>00442           <span class="keywordflow">case</span> 1:
<a name="l00443"></a>00443             {
<a name="l00444"></a>00444               radial_node = 0;
<a name="l00445"></a>00445               base_node   = outer_node_index;
<a name="l00446"></a>00446               <span class="keywordflow">return</span>;
<a name="l00447"></a>00447             }
<a name="l00448"></a>00448 
<a name="l00449"></a>00449           <span class="keywordflow">case</span> 2:
<a name="l00450"></a>00450           <span class="keywordflow">case</span> 3:
<a name="l00451"></a>00451             {
<a name="l00452"></a>00452               radial_node = 1;
<a name="l00453"></a>00453               base_node   = outer_node_index-2;
<a name="l00454"></a>00454               <span class="keywordflow">return</span>;
<a name="l00455"></a>00455             }
<a name="l00456"></a>00456 
<a name="l00457"></a>00457           <span class="keywordflow">case</span> 4:
<a name="l00458"></a>00458             {
<a name="l00459"></a>00459               radial_node = 0;
<a name="l00460"></a>00460               base_node   = 2;
<a name="l00461"></a>00461               <span class="keywordflow">return</span>;
<a name="l00462"></a>00462             }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464           <span class="keywordflow">case</span> 5:
<a name="l00465"></a>00465             {
<a name="l00466"></a>00466               radial_node = 1;
<a name="l00467"></a>00467               base_node   = 2;
<a name="l00468"></a>00468               <span class="keywordflow">return</span>;
<a name="l00469"></a>00469             }
<a name="l00470"></a>00470 
<a name="l00471"></a>00471           <span class="keywordflow">default</span>:
<a name="l00472"></a>00472             {
<a name="l00473"></a>00473               libmesh_error();
<a name="l00474"></a>00474               <span class="keywordflow">return</span>;
<a name="l00475"></a>00475             }
<a name="l00476"></a>00476           }
<a name="l00477"></a>00477       }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 
<a name="l00480"></a>00480     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00481"></a>00481     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00482"></a>00482       {
<a name="l00483"></a>00483         <span class="keywordflow">switch</span> (outer_node_index)
<a name="l00484"></a>00484           {
<a name="l00485"></a>00485           <span class="keywordflow">case</span> 0:
<a name="l00486"></a>00486           <span class="keywordflow">case</span> 1:
<a name="l00487"></a>00487           <span class="keywordflow">case</span> 2:
<a name="l00488"></a>00488           <span class="keywordflow">case</span> 3:
<a name="l00489"></a>00489             {
<a name="l00490"></a>00490               radial_node = 0;
<a name="l00491"></a>00491               base_node   = outer_node_index;
<a name="l00492"></a>00492               <span class="keywordflow">return</span>;
<a name="l00493"></a>00493             }
<a name="l00494"></a>00494 
<a name="l00495"></a>00495           <span class="keywordflow">case</span> 4:
<a name="l00496"></a>00496           <span class="keywordflow">case</span> 5:
<a name="l00497"></a>00497           <span class="keywordflow">case</span> 6:
<a name="l00498"></a>00498           <span class="keywordflow">case</span> 7:
<a name="l00499"></a>00499             {
<a name="l00500"></a>00500               radial_node = 1;
<a name="l00501"></a>00501               base_node   = outer_node_index-4;
<a name="l00502"></a>00502               <span class="keywordflow">return</span>;
<a name="l00503"></a>00503             }
<a name="l00504"></a>00504 
<a name="l00505"></a>00505           <span class="keywordflow">case</span> 8:
<a name="l00506"></a>00506           <span class="keywordflow">case</span> 9:
<a name="l00507"></a>00507           <span class="keywordflow">case</span> 10:
<a name="l00508"></a>00508           <span class="keywordflow">case</span> 11:
<a name="l00509"></a>00509             {
<a name="l00510"></a>00510               radial_node = 0;
<a name="l00511"></a>00511               base_node   = outer_node_index-4;
<a name="l00512"></a>00512               <span class="keywordflow">return</span>;
<a name="l00513"></a>00513             }
<a name="l00514"></a>00514 
<a name="l00515"></a>00515           <span class="keywordflow">case</span> 12:
<a name="l00516"></a>00516           <span class="keywordflow">case</span> 13:
<a name="l00517"></a>00517           <span class="keywordflow">case</span> 14:
<a name="l00518"></a>00518           <span class="keywordflow">case</span> 15:
<a name="l00519"></a>00519             {
<a name="l00520"></a>00520               radial_node = 1;
<a name="l00521"></a>00521               base_node   = outer_node_index-8;
<a name="l00522"></a>00522               <span class="keywordflow">return</span>;
<a name="l00523"></a>00523             }
<a name="l00524"></a>00524 
<a name="l00525"></a>00525           <span class="keywordflow">case</span> 16:
<a name="l00526"></a>00526             {
<a name="l00527"></a>00527               libmesh_assert (inf_elem_type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>);
<a name="l00528"></a>00528               radial_node = 0;
<a name="l00529"></a>00529               base_node   = 8;
<a name="l00530"></a>00530               <span class="keywordflow">return</span>;
<a name="l00531"></a>00531             }
<a name="l00532"></a>00532 
<a name="l00533"></a>00533           <span class="keywordflow">case</span> 17:
<a name="l00534"></a>00534             {
<a name="l00535"></a>00535               libmesh_assert (inf_elem_type == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>);
<a name="l00536"></a>00536               radial_node = 1;
<a name="l00537"></a>00537               base_node   = 8;
<a name="l00538"></a>00538               <span class="keywordflow">return</span>;
<a name="l00539"></a>00539             }
<a name="l00540"></a>00540 
<a name="l00541"></a>00541           <span class="keywordflow">default</span>:
<a name="l00542"></a>00542             {
<a name="l00543"></a>00543               libmesh_error();
<a name="l00544"></a>00544               <span class="keywordflow">return</span>;
<a name="l00545"></a>00545             }
<a name="l00546"></a>00546           }
<a name="l00547"></a>00547       }
<a name="l00548"></a>00548 
<a name="l00549"></a>00549 
<a name="l00550"></a>00550     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00551"></a>00551       {
<a name="l00552"></a>00552         <span class="keywordflow">switch</span> (outer_node_index)
<a name="l00553"></a>00553           {
<a name="l00554"></a>00554           <span class="keywordflow">case</span> 0:
<a name="l00555"></a>00555           <span class="keywordflow">case</span> 1:
<a name="l00556"></a>00556           <span class="keywordflow">case</span> 2:
<a name="l00557"></a>00557             {
<a name="l00558"></a>00558               radial_node = 0;
<a name="l00559"></a>00559               base_node   = outer_node_index;
<a name="l00560"></a>00560               <span class="keywordflow">return</span>;
<a name="l00561"></a>00561             }
<a name="l00562"></a>00562 
<a name="l00563"></a>00563           <span class="keywordflow">case</span> 3:
<a name="l00564"></a>00564           <span class="keywordflow">case</span> 4:
<a name="l00565"></a>00565           <span class="keywordflow">case</span> 5:
<a name="l00566"></a>00566             {
<a name="l00567"></a>00567               radial_node = 1;
<a name="l00568"></a>00568               base_node   = outer_node_index-3;
<a name="l00569"></a>00569               <span class="keywordflow">return</span>;
<a name="l00570"></a>00570             }
<a name="l00571"></a>00571 
<a name="l00572"></a>00572           <span class="keywordflow">case</span> 6:
<a name="l00573"></a>00573           <span class="keywordflow">case</span> 7:
<a name="l00574"></a>00574           <span class="keywordflow">case</span> 8:
<a name="l00575"></a>00575             {
<a name="l00576"></a>00576               radial_node = 0;
<a name="l00577"></a>00577               base_node   = outer_node_index-3;
<a name="l00578"></a>00578               <span class="keywordflow">return</span>;
<a name="l00579"></a>00579             }
<a name="l00580"></a>00580 
<a name="l00581"></a>00581           <span class="keywordflow">case</span> 9:
<a name="l00582"></a>00582           <span class="keywordflow">case</span> 10:
<a name="l00583"></a>00583           <span class="keywordflow">case</span> 11:
<a name="l00584"></a>00584             {
<a name="l00585"></a>00585               radial_node = 1;
<a name="l00586"></a>00586               base_node   = outer_node_index-6;
<a name="l00587"></a>00587               <span class="keywordflow">return</span>;
<a name="l00588"></a>00588             }
<a name="l00589"></a>00589 
<a name="l00590"></a>00590           <span class="keywordflow">default</span>:
<a name="l00591"></a>00591             {
<a name="l00592"></a>00592               libmesh_error();
<a name="l00593"></a>00593               <span class="keywordflow">return</span>;
<a name="l00594"></a>00594             }
<a name="l00595"></a>00595           }
<a name="l00596"></a>00596       }
<a name="l00597"></a>00597 
<a name="l00598"></a>00598 
<a name="l00599"></a>00599     <span class="keywordflow">default</span>:
<a name="l00600"></a>00600       { 
<a name="l00601"></a>00601         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad infinite element type=&quot;</span> &lt;&lt; inf_elem_type 
<a name="l00602"></a>00602                       &lt;&lt; <span class="stringliteral">&quot;, node=&quot;</span> &lt;&lt; outer_node_index &lt;&lt; std::endl;
<a name="l00603"></a>00603         libmesh_error();
<a name="l00604"></a>00604         <span class="keywordflow">return</span>;
<a name="l00605"></a>00605       }
<a name="l00606"></a>00606     }
<a name="l00607"></a>00607 }
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 
<a name="l00610"></a>00610 
<a name="l00611"></a>00611 
<a name="l00612"></a>00612 
<a name="l00613"></a>00613 
<a name="l00614"></a>00614 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00615"></a><a class="code" href="classlibMesh_1_1InfFE.php#a42dbfc303667197d7cae9362646a031c">00615</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a42dbfc303667197d7cae9362646a031c">InfFE&lt;Dim,T_radial,T_map&gt;::compute_node_indices_fast</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00616"></a>00616                                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> outer_node_index,
<a name="l00617"></a>00617                                                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; base_node,
<a name="l00618"></a>00618                                                            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; radial_node)
<a name="l00619"></a>00619 {
<a name="l00620"></a>00620   libmesh_assert (inf_elem_type != <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>);
<a name="l00621"></a>00621 
<a name="l00622"></a>00622   <span class="keyword">static</span> std::vector&lt;unsigned int&gt; _static_base_node_index;
<a name="l00623"></a>00623   <span class="keyword">static</span> std::vector&lt;unsigned int&gt; _static_radial_node_index;
<a name="l00624"></a>00624 
<a name="l00625"></a>00625   <span class="comment">/* </span>
<a name="l00626"></a>00626 <span class="comment">   * fast counterpart to compute_node_indices(), uses local static buffers</span>
<a name="l00627"></a>00627 <span class="comment">   * to store the index maps.  The class member</span>
<a name="l00628"></a>00628 <span class="comment">   * \p _compute_node_indices_fast_current_elem_type remembers</span>
<a name="l00629"></a>00629 <span class="comment">   * the current element type.</span>
<a name="l00630"></a>00630 <span class="comment">   *</span>
<a name="l00631"></a>00631 <span class="comment">   * Note that there exist non-static members storing the</span>
<a name="l00632"></a>00632 <span class="comment">   * same data.  However, you never know what element type</span>
<a name="l00633"></a>00633 <span class="comment">   * is currently used by the \p InfFE object, and what</span>
<a name="l00634"></a>00634 <span class="comment">   * request is currently directed to the static \p InfFE</span>
<a name="l00635"></a>00635 <span class="comment">   * members (which use \p compute_node_indices_fast()).</span>
<a name="l00636"></a>00636 <span class="comment">   * So separate these.</span>
<a name="l00637"></a>00637 <span class="comment">   *</span>
<a name="l00638"></a>00638 <span class="comment">   * check whether the work for this elemtype has already </span>
<a name="l00639"></a>00639 <span class="comment">   * been done.  If so, use this index.  Otherwise, refresh</span>
<a name="l00640"></a>00640 <span class="comment">   * the buffer to this element type.</span>
<a name="l00641"></a>00641 <span class="comment">   */</span>
<a name="l00642"></a>00642   <span class="keywordflow">if</span> (inf_elem_type==_compute_node_indices_fast_current_elem_type)
<a name="l00643"></a>00643     {
<a name="l00644"></a>00644       base_node   = _static_base_node_index  [outer_node_index];
<a name="l00645"></a>00645       radial_node = _static_radial_node_index[outer_node_index];
<a name="l00646"></a>00646       <span class="keywordflow">return</span>;
<a name="l00647"></a>00647     }
<a name="l00648"></a>00648   <span class="keywordflow">else</span>
<a name="l00649"></a>00649     {      
<a name="l00650"></a>00650       <span class="comment">// store the map for _all_ nodes for this element type</span>
<a name="l00651"></a>00651       _compute_node_indices_fast_current_elem_type = inf_elem_type;
<a name="l00652"></a>00652 
<a name="l00653"></a>00653       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a> = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00654"></a>00654 
<a name="l00655"></a>00655       <span class="keywordflow">switch</span> (inf_elem_type)
<a name="l00656"></a>00656         {
<a name="l00657"></a>00657         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00658"></a>00658           {
<a name="l00659"></a>00659             n_nodes = 2;
<a name="l00660"></a>00660             <span class="keywordflow">break</span>;
<a name="l00661"></a>00661           }
<a name="l00662"></a>00662         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00663"></a>00663           {
<a name="l00664"></a>00664             n_nodes = 4;
<a name="l00665"></a>00665             <span class="keywordflow">break</span>;
<a name="l00666"></a>00666           }
<a name="l00667"></a>00667         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00668"></a>00668           {
<a name="l00669"></a>00669             n_nodes = 6;
<a name="l00670"></a>00670             <span class="keywordflow">break</span>;
<a name="l00671"></a>00671           }
<a name="l00672"></a>00672         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00673"></a>00673           {
<a name="l00674"></a>00674             n_nodes = 8;
<a name="l00675"></a>00675             <span class="keywordflow">break</span>;
<a name="l00676"></a>00676           }
<a name="l00677"></a>00677         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00678"></a>00678           {
<a name="l00679"></a>00679             n_nodes = 16;
<a name="l00680"></a>00680             <span class="keywordflow">break</span>;
<a name="l00681"></a>00681           }
<a name="l00682"></a>00682         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00683"></a>00683           {
<a name="l00684"></a>00684             n_nodes = 18;
<a name="l00685"></a>00685             <span class="keywordflow">break</span>;
<a name="l00686"></a>00686           }
<a name="l00687"></a>00687         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00688"></a>00688           {
<a name="l00689"></a>00689             n_nodes = 6;
<a name="l00690"></a>00690             <span class="keywordflow">break</span>;
<a name="l00691"></a>00691           }
<a name="l00692"></a>00692         <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00693"></a>00693           {
<a name="l00694"></a>00694             n_nodes = 12;
<a name="l00695"></a>00695             <span class="keywordflow">break</span>;
<a name="l00696"></a>00696           }
<a name="l00697"></a>00697         <span class="keywordflow">default</span>:
<a name="l00698"></a>00698           { 
<a name="l00699"></a>00699             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad infinite element type=&quot;</span> &lt;&lt; inf_elem_type 
<a name="l00700"></a>00700                           &lt;&lt; <span class="stringliteral">&quot;, node=&quot;</span> &lt;&lt; outer_node_index &lt;&lt; std::endl;
<a name="l00701"></a>00701             libmesh_error();
<a name="l00702"></a>00702             <span class="keywordflow">break</span>;
<a name="l00703"></a>00703           }
<a name="l00704"></a>00704         }
<a name="l00705"></a>00705 
<a name="l00706"></a>00706 
<a name="l00707"></a>00707       _static_base_node_index.resize  (n_nodes);
<a name="l00708"></a>00708       _static_radial_node_index.resize(n_nodes);
<a name="l00709"></a>00709 
<a name="l00710"></a>00710       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; n++)
<a name="l00711"></a>00711           compute_node_indices (inf_elem_type, 
<a name="l00712"></a>00712                                 n, 
<a name="l00713"></a>00713                                 _static_base_node_index  [outer_node_index], 
<a name="l00714"></a>00714                                 _static_radial_node_index[outer_node_index]);
<a name="l00715"></a>00715 
<a name="l00716"></a>00716       <span class="comment">// and return for the specified node</span>
<a name="l00717"></a>00717       base_node   = _static_base_node_index  [outer_node_index];
<a name="l00718"></a>00718       radial_node = _static_radial_node_index[outer_node_index];
<a name="l00719"></a>00719       <span class="keywordflow">return</span>;
<a name="l00720"></a>00720     }
<a name="l00721"></a>00721 }
<a name="l00722"></a>00722 
<a name="l00723"></a>00723 
<a name="l00724"></a>00724 
<a name="l00725"></a>00725 
<a name="l00726"></a>00726 
<a name="l00727"></a>00727 
<a name="l00728"></a>00728 <span class="keyword">template</span> &lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> Dim, FEFamily T_radial, InfMapType T_map&gt;
<a name="l00729"></a><a class="code" href="classlibMesh_1_1InfFE.php#a8c1c5ab74ec54818d745a7bac3722b18">00729</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1InfFE.php#a8c1c5ab74ec54818d745a7bac3722b18">InfFE&lt;Dim,T_radial,T_map&gt;::compute_shape_indices</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fet,
<a name="l00730"></a>00730                                                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> inf_elem_type,
<a name="l00731"></a>00731                                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00732"></a>00732                                                        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; base_shape,
<a name="l00733"></a>00733                                                        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; radial_shape)
<a name="l00734"></a>00734 {
<a name="l00735"></a>00735 
<a name="l00736"></a>00736   <span class="comment">/*</span>
<a name="l00737"></a>00737 <span class="comment">   * An example is provided:  the numbers in comments refer to</span>
<a name="l00738"></a>00738 <span class="comment">   * a fictitious InfHex18.  The numbers are chosen as exemplary</span>
<a name="l00739"></a>00739 <span class="comment">   * values.  There is currently no base approximation that</span>
<a name="l00740"></a>00740 <span class="comment">   * requires this many dof&#39;s at nodes, sides, faces and in the element.</span>
<a name="l00741"></a>00741 <span class="comment">   *</span>
<a name="l00742"></a>00742 <span class="comment">   * the order of the shape functions is heavily related with the</span>
<a name="l00743"></a>00743 <span class="comment">   * order the dofs are assigned in \p DofMap::distributed_dofs().</span>
<a name="l00744"></a>00744 <span class="comment">   * Due to the infinite elements with higher-order base approximation,</span>
<a name="l00745"></a>00745 <span class="comment">   * some more effort is necessary.</span>
<a name="l00746"></a>00746 <span class="comment">   *</span>
<a name="l00747"></a>00747 <span class="comment">   * numbering scheme:</span>
<a name="l00748"></a>00748 <span class="comment">   * 1. all vertices in the base, assign node-&gt;n_comp() dofs to each vertex</span>
<a name="l00749"></a>00749 <span class="comment">   * 2. all vertices further out: innermost loop: radial shapes,</span>
<a name="l00750"></a>00750 <span class="comment">   *    then the base approximation shapes</span>
<a name="l00751"></a>00751 <span class="comment">   * 3. all side nodes in the base, assign node-&gt;n_comp() dofs to each side node</span>
<a name="l00752"></a>00752 <span class="comment">   * 4. all side nodes further out: innermost loop: radial shapes,</span>
<a name="l00753"></a>00753 <span class="comment">   *    then the base approximation shapes</span>
<a name="l00754"></a>00754 <span class="comment">   * 5. (all) face nodes in the base, assign node-&gt;n_comp() dofs to each face node</span>
<a name="l00755"></a>00755 <span class="comment">   * 6. (all) face nodes further out: innermost loop: radial shapes,</span>
<a name="l00756"></a>00756 <span class="comment">   *    then the base approximation shapes</span>
<a name="l00757"></a>00757 <span class="comment">   * 7. element-associated dof in the base</span>
<a name="l00758"></a>00758 <span class="comment">   * 8. element-associated dof further out</span>
<a name="l00759"></a>00759 <span class="comment">   */</span>
<a name="l00760"></a>00760 
<a name="l00761"></a>00761   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> radial_order       = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(fet.<a class="code" href="classlibMesh_1_1FEType.php#a140e81f4ae94ca119586b2533e042223">radial_order</a>);             <span class="comment">// 4</span>
<a name="l00762"></a>00762   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> radial_order_p_one = radial_order+1;                                          <span class="comment">// 5</span>
<a name="l00763"></a>00763 
<a name="l00764"></a>00764   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> base_elem_type           (Base::get_elem_type(inf_elem_type));                    <span class="comment">// QUAD9</span>
<a name="l00765"></a>00765 
<a name="l00766"></a>00766   <span class="comment">// assume that the number of dof is the same for all vertices</span>
<a name="l00767"></a>00767   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_vertices         = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;                                    <span class="comment">// 4</span>
<a name="l00768"></a>00768   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_vertex_dof = <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a>  (Dim-1, fet, base_elem_type, 0);<span class="comment">// 2</span>
<a name="l00769"></a>00769 
<a name="l00770"></a>00770   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_side_nodes       = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;                                    <span class="comment">// 4</span>
<a name="l00771"></a>00771   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_side_dof         = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;                                    <span class="comment">// 3</span>
<a name="l00772"></a>00772 
<a name="l00773"></a>00773   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_face_nodes       = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;                                    <span class="comment">// 1</span>
<a name="l00774"></a>00774   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_face_dof         = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;                                    <span class="comment">// 5</span>
<a name="l00775"></a>00775 
<a name="l00776"></a>00776   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_base_elem_dof   = <a class="code" href="classlibMesh_1_1FEInterface.php#aaf96d4ec7921d2f2a1d4cdbdbc63656a">FEInterface::n_dofs_per_elem</a> (Dim-1, fet, base_elem_type);<span class="comment">// 9</span>
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779   <span class="keywordflow">switch</span> (inf_elem_type)
<a name="l00780"></a>00780     {
<a name="l00781"></a>00781     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a278476b80069e0630827235779c82c47">INFEDGE2</a>:
<a name="l00782"></a>00782       {
<a name="l00783"></a>00783         n_base_vertices   = 1;
<a name="l00784"></a>00784         n_base_side_nodes = 0;
<a name="l00785"></a>00785         n_base_face_nodes = 0;
<a name="l00786"></a>00786         n_base_side_dof   = 0;
<a name="l00787"></a>00787         n_base_face_dof   = 0;
<a name="l00788"></a>00788         <span class="keywordflow">break</span>;
<a name="l00789"></a>00789       }
<a name="l00790"></a>00790 
<a name="l00791"></a>00791     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a23d0ae825ee3f493b6504b71f28e2aef">INFQUAD4</a>:
<a name="l00792"></a>00792       {
<a name="l00793"></a>00793         n_base_vertices   = 2;
<a name="l00794"></a>00794         n_base_side_nodes = 0;
<a name="l00795"></a>00795         n_base_face_nodes = 0;
<a name="l00796"></a>00796         n_base_side_dof   = 0;
<a name="l00797"></a>00797         n_base_face_dof   = 0;
<a name="l00798"></a>00798         <span class="keywordflow">break</span>;
<a name="l00799"></a>00799       }
<a name="l00800"></a>00800 
<a name="l00801"></a>00801     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a669ef57bb0d4c72fd22fa0f4febe6ac1">INFQUAD6</a>:
<a name="l00802"></a>00802       {
<a name="l00803"></a>00803         n_base_vertices   = 2;
<a name="l00804"></a>00804         n_base_side_nodes = 1;
<a name="l00805"></a>00805         n_base_face_nodes = 0;
<a name="l00806"></a>00806         n_base_side_dof   = <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (Dim-1, fet,base_elem_type, n_base_vertices);
<a name="l00807"></a>00807         n_base_face_dof   = 0;
<a name="l00808"></a>00808         <span class="keywordflow">break</span>;
<a name="l00809"></a>00809       }
<a name="l00810"></a>00810         
<a name="l00811"></a>00811     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a54cedbd05931dd2cb7dcabf0109bddcb">INFHEX8</a>:
<a name="l00812"></a>00812       {
<a name="l00813"></a>00813         n_base_vertices   = 4;
<a name="l00814"></a>00814         n_base_side_nodes = 0;
<a name="l00815"></a>00815         n_base_face_nodes = 0;
<a name="l00816"></a>00816         n_base_side_dof   = 0;
<a name="l00817"></a>00817         n_base_face_dof   = 0;
<a name="l00818"></a>00818         <span class="keywordflow">break</span>;
<a name="l00819"></a>00819       }
<a name="l00820"></a>00820 
<a name="l00821"></a>00821     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a583e72df1b20e339d9f8fcea6a94c1d4">INFHEX16</a>:
<a name="l00822"></a>00822       {
<a name="l00823"></a>00823         n_base_vertices   = 4;
<a name="l00824"></a>00824         n_base_side_nodes = 4;
<a name="l00825"></a>00825         n_base_face_nodes = 0;
<a name="l00826"></a>00826         n_base_side_dof   = <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (Dim-1, fet,base_elem_type, n_base_vertices);
<a name="l00827"></a>00827         n_base_face_dof   = 0;
<a name="l00828"></a>00828         <span class="keywordflow">break</span>;
<a name="l00829"></a>00829       }
<a name="l00830"></a>00830 
<a name="l00831"></a>00831     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4e68f53177cc7d1366225dfc8f7bbbed">INFHEX18</a>:
<a name="l00832"></a>00832       {
<a name="l00833"></a>00833         n_base_vertices   = 4;
<a name="l00834"></a>00834         n_base_side_nodes = 4;
<a name="l00835"></a>00835         n_base_face_nodes = 1;
<a name="l00836"></a>00836         n_base_side_dof   = <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (Dim-1, fet,base_elem_type, n_base_vertices);
<a name="l00837"></a>00837         n_base_face_dof   = <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (Dim-1, fet,base_elem_type, 8);
<a name="l00838"></a>00838         <span class="keywordflow">break</span>;
<a name="l00839"></a>00839       }
<a name="l00840"></a>00840 
<a name="l00841"></a>00841                  
<a name="l00842"></a>00842     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac6743a9a04524105e37159e924c4a33b">INFPRISM6</a>:
<a name="l00843"></a>00843       {
<a name="l00844"></a>00844         n_base_vertices   = 3;
<a name="l00845"></a>00845         n_base_side_nodes = 0;
<a name="l00846"></a>00846         n_base_face_nodes = 0;
<a name="l00847"></a>00847         n_base_side_dof   = 0;
<a name="l00848"></a>00848         n_base_face_dof   = 0;
<a name="l00849"></a>00849         <span class="keywordflow">break</span>;
<a name="l00850"></a>00850       }
<a name="l00851"></a>00851 
<a name="l00852"></a>00852     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a89630f5af6a58aaa9ae731d924139c61">INFPRISM12</a>:
<a name="l00853"></a>00853       {
<a name="l00854"></a>00854         n_base_vertices   = 3;
<a name="l00855"></a>00855         n_base_side_nodes = 3;
<a name="l00856"></a>00856         n_base_face_nodes = 0;
<a name="l00857"></a>00857         n_base_side_dof   = <a class="code" href="classlibMesh_1_1FEInterface.php#a9d448e5766ac099a401541d191439d0b">FEInterface::n_dofs_at_node</a> (Dim-1, fet,base_elem_type, n_base_vertices);
<a name="l00858"></a>00858         n_base_face_dof   = 0;
<a name="l00859"></a>00859         <span class="keywordflow">break</span>;
<a name="l00860"></a>00860       }
<a name="l00861"></a>00861 
<a name="l00862"></a>00862     <span class="keywordflow">default</span>:
<a name="l00863"></a>00863         libmesh_error();
<a name="l00864"></a>00864     }
<a name="l00865"></a>00865 
<a name="l00866"></a>00866 
<a name="l00867"></a>00867   {
<a name="l00868"></a>00868     <span class="comment">// these are the limits describing the intervals where the shape function lies</span>
<a name="l00869"></a>00869     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dof_at_base_vertices = n_base_vertices*n_base_vertex_dof;                 <span class="comment">// 8</span>
<a name="l00870"></a>00870     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dof_at_all_vertices  = n_dof_at_base_vertices*radial_order_p_one;         <span class="comment">// 40</span>
<a name="l00871"></a>00871 
<a name="l00872"></a>00872     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dof_at_base_sides    = n_base_side_nodes*n_base_side_dof;                 <span class="comment">// 12</span>
<a name="l00873"></a>00873     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dof_at_all_sides     = n_dof_at_base_sides*radial_order_p_one;            <span class="comment">// 60</span>
<a name="l00874"></a>00874 
<a name="l00875"></a>00875     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dof_at_base_face     = n_base_face_nodes*n_base_face_dof;                 <span class="comment">// 5</span>
<a name="l00876"></a>00876     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dof_at_all_faces     = n_dof_at_base_face*radial_order_p_one;             <span class="comment">// 25</span>
<a name="l00877"></a>00877 
<a name="l00878"></a>00878 
<a name="l00879"></a>00879     <span class="comment">// start locating the shape function</span>
<a name="l00880"></a>00880     <span class="keywordflow">if</span> (i &lt; n_dof_at_base_vertices)                                              <span class="comment">// range of i: 0..7</span>
<a name="l00881"></a>00881       {
<a name="l00882"></a>00882         <span class="comment">// belongs to vertex in the base</span>
<a name="l00883"></a>00883         radial_shape = 0;
<a name="l00884"></a>00884         base_shape   = i;
<a name="l00885"></a>00885       }
<a name="l00886"></a>00886 
<a name="l00887"></a>00887     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; n_dof_at_all_vertices)                                          <span class="comment">// range of i: 8..39</span>
<a name="l00888"></a>00888       {
<a name="l00889"></a>00889         <span class="comment">/* belongs to vertex in the outer shell</span>
<a name="l00890"></a>00890 <span class="comment">         *</span>
<a name="l00891"></a>00891 <span class="comment">         * subtract the number of dof already counted,</span>
<a name="l00892"></a>00892 <span class="comment">         * so that i_offset contains only the offset for the base</span>
<a name="l00893"></a>00893 <span class="comment">         */</span>
<a name="l00894"></a>00894         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_offset = i - n_dof_at_base_vertices;                <span class="comment">// 0..31</span>
<a name="l00895"></a>00895         
<a name="l00896"></a>00896         <span class="comment">// first the radial dof are counted, then the base dof</span>
<a name="l00897"></a>00897         radial_shape = (i_offset % radial_order) + 1;
<a name="l00898"></a>00898         base_shape   = i_offset / radial_order;
<a name="l00899"></a>00899       }
<a name="l00900"></a>00900 
<a name="l00901"></a>00901     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; n_dof_at_all_vertices+n_dof_at_base_sides)                      <span class="comment">// range of i: 40..51</span>
<a name="l00902"></a>00902       {
<a name="l00903"></a>00903         <span class="comment">// belongs to base, is a side node</span>
<a name="l00904"></a>00904         radial_shape = 0;
<a name="l00905"></a>00905         base_shape = i - radial_order * n_dof_at_base_vertices;                  <span class="comment">//  8..19</span>
<a name="l00906"></a>00906       }
<a name="l00907"></a>00907 
<a name="l00908"></a>00908     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; n_dof_at_all_vertices+n_dof_at_all_sides)                       <span class="comment">// range of i: 52..99</span>
<a name="l00909"></a>00909       {
<a name="l00910"></a>00910         <span class="comment">// belongs to side node in the outer shell</span>
<a name="l00911"></a>00911         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_offset = i - (n_dof_at_all_vertices
<a name="l00912"></a>00912                                            + n_dof_at_base_sides);               <span class="comment">// 0..47</span>
<a name="l00913"></a>00913         radial_shape = (i_offset % radial_order) + 1;
<a name="l00914"></a>00914         base_shape   = (i_offset / radial_order) + n_dof_at_base_vertices;
<a name="l00915"></a>00915       }
<a name="l00916"></a>00916 
<a name="l00917"></a>00917     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; n_dof_at_all_vertices+n_dof_at_all_sides+n_dof_at_base_face)    <span class="comment">// range of i: 100..104</span>
<a name="l00918"></a>00918       {
<a name="l00919"></a>00919         <span class="comment">// belongs to the node in the base face</span>
<a name="l00920"></a>00920         radial_shape = 0;
<a name="l00921"></a>00921         base_shape = i - radial_order*(n_dof_at_base_vertices
<a name="l00922"></a>00922                                        + n_dof_at_base_sides);                   <span class="comment">//  20..24</span>
<a name="l00923"></a>00923       }
<a name="l00924"></a>00924 
<a name="l00925"></a>00925     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; n_dof_at_all_vertices+n_dof_at_all_sides+n_dof_at_all_faces)    <span class="comment">// range of i: 105..124</span>
<a name="l00926"></a>00926       {
<a name="l00927"></a>00927         <span class="comment">// belongs to the node in the outer face</span>
<a name="l00928"></a>00928         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_offset = i - (n_dof_at_all_vertices 
<a name="l00929"></a>00929                                            + n_dof_at_all_sides 
<a name="l00930"></a>00930                                            + n_dof_at_base_face);                <span class="comment">// 0..19</span>
<a name="l00931"></a>00931         radial_shape = (i_offset % radial_order) + 1;
<a name="l00932"></a>00932         base_shape   = (i_offset / radial_order) + n_dof_at_base_vertices + n_dof_at_base_sides;
<a name="l00933"></a>00933       }
<a name="l00934"></a>00934 
<a name="l00935"></a>00935     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (i &lt; n_dof_at_all_vertices+n_dof_at_all_sides+n_dof_at_all_faces+n_base_elem_dof)      <span class="comment">// range of i: 125..133</span>
<a name="l00936"></a>00936       {
<a name="l00937"></a>00937         <span class="comment">// belongs to the base and is an element associated shape</span>
<a name="l00938"></a>00938         radial_shape = 0;
<a name="l00939"></a>00939         base_shape = i - (n_dof_at_all_vertices 
<a name="l00940"></a>00940                           + n_dof_at_all_sides 
<a name="l00941"></a>00941                           + n_dof_at_all_faces);                                 <span class="comment">// 0..8 </span>
<a name="l00942"></a>00942       }
<a name="l00943"></a>00943 
<a name="l00944"></a>00944     <span class="keywordflow">else</span>                                                                         <span class="comment">// range of i: 134..169</span>
<a name="l00945"></a>00945       {
<a name="l00946"></a>00946         libmesh_assert (i &lt; n_dofs(fet, inf_elem_type));
<a name="l00947"></a>00947         <span class="comment">// belongs to the outer shell and is an element associated shape</span>
<a name="l00948"></a>00948         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i_offset = i - (n_dof_at_all_vertices 
<a name="l00949"></a>00949                                            + n_dof_at_all_sides 
<a name="l00950"></a>00950                                            + n_dof_at_all_faces 
<a name="l00951"></a>00951                                            + n_base_elem_dof);                   <span class="comment">// 0..19</span>
<a name="l00952"></a>00952         radial_shape = (i_offset % radial_order) + 1;
<a name="l00953"></a>00953         base_shape   = (i_offset / radial_order) + n_dof_at_base_vertices + n_dof_at_base_sides + n_dof_at_base_face;
<a name="l00954"></a>00954       }
<a name="l00955"></a>00955   }
<a name="l00956"></a>00956 
<a name="l00957"></a>00957   <span class="keywordflow">return</span>;
<a name="l00958"></a>00958 }
<a name="l00959"></a>00959 
<a name="l00960"></a>00960 
<a name="l00961"></a>00961 
<a name="l00962"></a>00962 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00963"></a>00963 <span class="comment">// Explicit instantiations</span>
<a name="l00964"></a>00964 <span class="comment">//#include &quot;inf_fe_instantiate_1D.h&quot;</span>
<a name="l00965"></a>00965 <span class="comment">//#include &quot;inf_fe_instantiate_2D.h&quot;</span>
<a name="l00966"></a>00966 <span class="comment">//#include &quot;inf_fe_instantiate_3D.h&quot;</span>
<a name="l00967"></a>00967 
<a name="l00968"></a>00968 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,n_dofs(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>));
<a name="l00969"></a>00969 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,n_dofs(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>));
<a name="l00970"></a>00970 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,n_dofs(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>));
<a name="l00971"></a>00971 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,n_dofs_per_elem(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>));
<a name="l00972"></a>00972 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,n_dofs_per_elem(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>));
<a name="l00973"></a>00973 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,n_dofs_per_elem(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>));
<a name="l00974"></a>00974 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,n_dofs_at_node(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>));
<a name="l00975"></a>00975 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,n_dofs_at_node(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>));
<a name="l00976"></a>00976 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,n_dofs_at_node(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>));
<a name="l00977"></a>00977 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,compute_shape_indices(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;));
<a name="l00978"></a>00978 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,compute_shape_indices(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;));
<a name="l00979"></a>00979 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,compute_shape_indices(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;));
<a name="l00980"></a>00980 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,compute_node_indices(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;));
<a name="l00981"></a>00981 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,compute_node_indices(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;));
<a name="l00982"></a>00982 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,compute_node_indices(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;,<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp;));
<a name="l00983"></a>00983 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,shape(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p));
<a name="l00984"></a>00984 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,shape(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p));
<a name="l00985"></a>00985 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,shape(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p));
<a name="l00986"></a>00986 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,shape(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;));
<a name="l00987"></a>00987 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,shape(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;));
<a name="l00988"></a>00988 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,shape(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;));
<a name="l00989"></a>00989 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,compute_data(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a>&amp;));
<a name="l00990"></a>00990 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,compute_data(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a>&amp;));
<a name="l00991"></a>00991 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,compute_data(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a>&amp;));
<a name="l00992"></a>00992 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(1,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,nodal_soln(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,std::vector&lt;Number&gt;&amp;));
<a name="l00993"></a>00993 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(2,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,nodal_soln(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,std::vector&lt;Number&gt;&amp;));
<a name="l00994"></a>00994 <a class="code" href="namespacelibMesh.php#a882961c1d37b4e15b0c2c94676f1f0cf">INSTANTIATE_INF_FE_MBRF</a>(3,<a class="code" href="namespacelibMeshEnums.php#ae6721d46075567f5eb13dec5c2c924d7a50e35cb38ab1ade9e5a97016b59136cd">CARTESIAN</a>,<span class="keywordtype">void</span>,nodal_soln(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp;,<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,<span class="keyword">const</span> std::vector&lt;Number&gt;&amp;,std::vector&lt;Number&gt;&amp;));
<a name="l00995"></a>00995 
<a name="l00996"></a>00996 } <span class="comment">// namespace libMesh</span>
<a name="l00997"></a>00997                                            
<a name="l00998"></a>00998 <span class="preprocessor">#endif //ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00999"></a>00999 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
