<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">jump_error_estimator.C</div>  </div>
</div>
<div class="contents">
<a href="jump__error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: jump_error_estimator.C 4015 2010-10-01 21:03:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span>    <span class="comment">// for sqrt</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="jump__error__estimator_8h.php">jump_error_estimator.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>libMesh
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// JumpErrorEstimator implementations</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#aec1e6d7642dbdfec7759fa31a7a18f4b">00047</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#aec1e6d7642dbdfec7759fa31a7a18f4b">JumpErrorEstimator::initialize</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp;,
<a name="l00048"></a>00048                                      <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp;,
<a name="l00049"></a>00049                                      <span class="keywordtype">bool</span>)
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#abafa2609660d4de159fb16d0a8d3c509">00055</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#abafa2609660d4de159fb16d0a8d3c509">JumpErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00056"></a>00056                                          <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00057"></a>00057                                          <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00058"></a>00058                                          <span class="keywordtype">bool</span> estimate_parent_error)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   START_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;JumpErrorEstimator&quot;</span>);
<a name="l00061"></a>00061   <span class="comment">/*</span>
<a name="l00062"></a>00062 <span class="comment"></span>
<a name="l00063"></a>00063 <span class="comment">  Conventions for assigning the direction of the normal:</span>
<a name="l00064"></a>00064 <span class="comment">  </span>
<a name="l00065"></a>00065 <span class="comment">  - e &amp; f are global element ids</span>
<a name="l00066"></a>00066 <span class="comment">  </span>
<a name="l00067"></a>00067 <span class="comment">  Case (1.) Elements are at the same level, e&lt;f</span>
<a name="l00068"></a>00068 <span class="comment">            Compute the flux jump on the face and</span>
<a name="l00069"></a>00069 <span class="comment">            add it as a contribution to error_per_cell[e]</span>
<a name="l00070"></a>00070 <span class="comment">            and error_per_cell[f]</span>
<a name="l00071"></a>00071 <span class="comment">  </span>
<a name="l00072"></a>00072 <span class="comment">                   ----------------------</span>
<a name="l00073"></a>00073 <span class="comment">                  |           |          |</span>
<a name="l00074"></a>00074 <span class="comment">                  |           |    f     |</span>
<a name="l00075"></a>00075 <span class="comment">                  |           |          |</span>
<a name="l00076"></a>00076 <span class="comment">                  |    e      |---&gt; n    | </span>
<a name="l00077"></a>00077 <span class="comment">                  |           |          |</span>
<a name="l00078"></a>00078 <span class="comment">                  |           |          |</span>
<a name="l00079"></a>00079 <span class="comment">                   ----------------------</span>
<a name="l00080"></a>00080 <span class="comment"></span>
<a name="l00081"></a>00081 <span class="comment"></span>
<a name="l00082"></a>00082 <span class="comment">   Case (2.) The neighbor is at a higher level.</span>
<a name="l00083"></a>00083 <span class="comment">             Compute the flux jump on e&#39;s face and</span>
<a name="l00084"></a>00084 <span class="comment">             add it as a contribution to error_per_cell[e]</span>
<a name="l00085"></a>00085 <span class="comment">             and error_per_cell[f]</span>
<a name="l00086"></a>00086 <span class="comment"></span>
<a name="l00087"></a>00087 <span class="comment">                   ----------------------</span>
<a name="l00088"></a>00088 <span class="comment">                  |     |     |          |</span>
<a name="l00089"></a>00089 <span class="comment">                  |     |  e  |---&gt; n    |</span>
<a name="l00090"></a>00090 <span class="comment">                  |     |     |          |</span>
<a name="l00091"></a>00091 <span class="comment">                  |-----------|    f     | </span>
<a name="l00092"></a>00092 <span class="comment">                  |     |     |          |</span>
<a name="l00093"></a>00093 <span class="comment">                  |     |     |          |</span>
<a name="l00094"></a>00094 <span class="comment">                  |     |     |          |</span>
<a name="l00095"></a>00095 <span class="comment">                   ----------------------</span>
<a name="l00096"></a>00096 <span class="comment">  */</span>
<a name="l00097"></a>00097    
<a name="l00098"></a>00098   <span class="comment">// The current mesh</span>
<a name="l00099"></a>00099   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="comment">// The dimensionality of the mesh</span>
<a name="l00102"></a>00102   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00103"></a>00103   
<a name="l00104"></a>00104   <span class="comment">// The number of variables in the system</span>
<a name="l00105"></a>00105   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = system.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   <span class="comment">// The DofMap for this system</span>
<a name="l00108"></a>00108   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = system.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">// Resize the error_per_cell vector to be</span>
<a name="l00111"></a>00111   <span class="comment">// the number of elements, initialize it to 0.</span>
<a name="l00112"></a>00112   error_per_cell.resize (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>());
<a name="l00113"></a>00113   std::fill (error_per_cell.begin(), error_per_cell.end(), 0.);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// Declare a vector of floats which is as long as</span>
<a name="l00116"></a>00116   <span class="comment">// error_per_cell above, and fill with zeros.  This vector will be</span>
<a name="l00117"></a>00117   <span class="comment">// used to keep track of the number of edges (faces) on each active</span>
<a name="l00118"></a>00118   <span class="comment">// element which are either:</span>
<a name="l00119"></a>00119   <span class="comment">// 1) an internal edge</span>
<a name="l00120"></a>00120   <span class="comment">// 2) an edge on a Neumann boundary for which a boundary condition</span>
<a name="l00121"></a>00121   <span class="comment">//    function has been specified.</span>
<a name="l00122"></a>00122   <span class="comment">// The error estimator can be scaled by the number of flux edges (faces)</span>
<a name="l00123"></a>00123   <span class="comment">// which the element actually has to obtain a more uniform measure</span>
<a name="l00124"></a>00124   <span class="comment">// of the error.  Use floats instead of ints since in case 2 (above)</span>
<a name="l00125"></a>00125   <span class="comment">// f gets 1/2 of a flux face contribution from each of his</span>
<a name="l00126"></a>00126   <span class="comment">// neighbors</span>
<a name="l00127"></a>00127   std::vector&lt;float&gt; n_flux_faces (error_per_cell.size());
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   <span class="comment">// Prepare current_local_solution to localize a non-standard</span>
<a name="l00130"></a>00130   <span class="comment">// solution vector if necessary</span>
<a name="l00131"></a>00131   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00132"></a>00132     {
<a name="l00133"></a>00133       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00134"></a>00134         <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00135"></a>00135       <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1System.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00136"></a>00136       newsol-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">swap</a>(*sys.solution);
<a name="l00137"></a>00137       sys.update();
<a name="l00138"></a>00138     }
<a name="l00139"></a>00139   
<a name="l00140"></a>00140   <span class="comment">// Loop over all the variables in the system</span>
<a name="l00141"></a>00141   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>=0; <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>++)
<a name="l00142"></a>00142     {
<a name="l00143"></a>00143       <span class="comment">// Possibly skip this variable</span>
<a name="l00144"></a>00144       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>) == 0.0) <span class="keywordflow">continue</span>;
<a name="l00145"></a>00145 
<a name="l00146"></a>00146       <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00147"></a>00147       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a> (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>);
<a name="l00148"></a>00148       
<a name="l00149"></a>00149       <span class="comment">// Finite element objects for the same face from</span>
<a name="l00150"></a>00150       <span class="comment">// different sides</span>
<a name="l00151"></a>00151       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a> = <a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a> (dim, fe_type);
<a name="l00152"></a>00152       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a67599bdd08ab287db8b455660542bc19">fe_coarse</a> = <a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a> (dim, fe_type);
<a name="l00153"></a>00153 
<a name="l00154"></a>00154       <span class="comment">// Build an appropriate Gaussian quadrature rule</span>
<a name="l00155"></a>00155       <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> qrule (dim-1, fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a54506eab6fd48e0cbd2ff403fca09ed9">default_quadrature_order</a>());
<a name="l00156"></a>00156 
<a name="l00157"></a>00157       <span class="comment">// Tell the finite element for the fine element about the quadrature</span>
<a name="l00158"></a>00158       <span class="comment">// rule.  The finite element for the coarse element need not know about it</span>
<a name="l00159"></a>00159       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;attach_quadrature_rule (&amp;qrule);
<a name="l00160"></a>00160       
<a name="l00161"></a>00161       <span class="comment">// By convention we will always do the integration</span>
<a name="l00162"></a>00162       <span class="comment">// on the face of element e.  We&#39;ll need its Jacobian values and</span>
<a name="l00163"></a>00163       <span class="comment">// physical point locations, at least</span>
<a name="l00164"></a>00164       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;get_JxW();
<a name="l00165"></a>00165       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;get_xyz();
<a name="l00166"></a>00166 
<a name="l00167"></a>00167       <span class="comment">// Our derived classes may want to do some initialization here</span>
<a name="l00168"></a>00168       this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#aec1e6d7642dbdfec7759fa31a7a18f4b">initialize</a>(system, error_per_cell, estimate_parent_error);
<a name="l00169"></a>00169       
<a name="l00170"></a>00170       <span class="comment">// The global DOF indices for elements e &amp; f</span>
<a name="l00171"></a>00171       std::vector&lt;unsigned int&gt; dof_indices_fine;
<a name="l00172"></a>00172       std::vector&lt;unsigned int&gt; dof_indices_coarse;
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175       
<a name="l00176"></a>00176       <span class="comment">// Iterate over all the active elements in the mesh</span>
<a name="l00177"></a>00177       <span class="comment">// that live on this processor.</span>
<a name="l00178"></a>00178       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00179"></a>00179       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181       <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00182"></a>00182         {
<a name="l00183"></a>00183           <span class="comment">// e is necessarily an active element on the local processor</span>
<a name="l00184"></a>00184           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e = *elem_it;
<a name="l00185"></a>00185           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e_id = e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00188"></a>00188 <span class="preprocessor"></span>          <span class="comment">// See if the parent of element e has been examined yet;</span>
<a name="l00189"></a>00189           <span class="comment">// if not, we may want to compute the estimator on it</span>
<a name="l00190"></a>00190           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent = e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00191"></a>00191 
<a name="l00192"></a>00192           <span class="comment">// We only can compute and only need to compute on</span>
<a name="l00193"></a>00193           <span class="comment">// parents with all active children</span>
<a name="l00194"></a>00194           <span class="keywordtype">bool</span> compute_on_parent = <span class="keyword">true</span>;
<a name="l00195"></a>00195           <span class="keywordflow">if</span> (!parent || !estimate_parent_error)
<a name="l00196"></a>00196             compute_on_parent = <span class="keyword">false</span>;
<a name="l00197"></a>00197           <span class="keywordflow">else</span>
<a name="l00198"></a>00198             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l00199"></a>00199               <span class="keywordflow">if</span> (!parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00200"></a>00200                 compute_on_parent = <span class="keyword">false</span>;
<a name="l00201"></a>00201              
<a name="l00202"></a>00202           <span class="keywordflow">if</span> (compute_on_parent &amp;&amp;
<a name="l00203"></a>00203               !error_per_cell[parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()])
<a name="l00204"></a>00204             {
<a name="l00205"></a>00205               <span class="comment">// Compute a projection onto the parent</span>
<a name="l00206"></a>00206               <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> Uparent;
<a name="l00207"></a>00207               <a class="code" href="classlibMesh_1_1FEBase.php#a9e8a34c7c7dada421bcf88d5c9bc9a9e">FEBase::coarsened_dof_values</a>(*(system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>),
<a name="l00208"></a>00208                                            dof_map, parent, Uparent,
<a name="l00209"></a>00209                                            <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>, <span class="keyword">false</span>);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211               <span class="comment">// Loop over the neighbors of the parent</span>
<a name="l00212"></a>00212               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_p=0; n_p&lt;parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n_p++)
<a name="l00213"></a>00213                 {
<a name="l00214"></a>00214                   <span class="keywordflow">if</span> (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n_p) != NULL) <span class="comment">// parent has a neighbor here</span>
<a name="l00215"></a>00215                     {
<a name="l00216"></a>00216                       <span class="comment">// Find the active neighbors in this direction</span>
<a name="l00217"></a>00217                       std::vector&lt;const Elem*&gt; active_neighbors;
<a name="l00218"></a>00218                       parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n_p)-&gt;
<a name="l00219"></a>00219                         active_family_tree_by_neighbor(active_neighbors,
<a name="l00220"></a>00220                                                        parent);
<a name="l00221"></a>00221                       <span class="comment">// Compute the flux to each active neighbor</span>
<a name="l00222"></a>00222                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> a=0; 
<a name="l00223"></a>00223                            a != active_neighbors.size(); ++a)
<a name="l00224"></a>00224                         {
<a name="l00225"></a>00225                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *f = active_neighbors[a];
<a name="l00226"></a>00226                       <span class="comment">// FIXME - what about when f-&gt;level &lt;</span>
<a name="l00227"></a>00227                       <span class="comment">// parent-&gt;level()??</span>
<a name="l00228"></a>00228                           <span class="keywordflow">if</span> (f-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &gt;= parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>())
<a name="l00229"></a>00229                             {
<a name="l00230"></a>00230                               <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a> = f;
<a name="l00231"></a>00231                               <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a> = parent;
<a name="l00232"></a>00232                               <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6cb5f9a7c33e98c66e60f60332efd772">Ucoarse</a> = Uparent;
<a name="l00233"></a>00233 
<a name="l00234"></a>00234                               dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>, dof_indices_fine, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>);
<a name="l00235"></a>00235                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_fine = dof_indices_fine.size();
<a name="l00236"></a>00236                               <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(n_dofs_fine);
<a name="l00237"></a>00237                         
<a name="l00238"></a>00238                               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_fine; i++)
<a name="l00239"></a>00239                                 <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>(i) = system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices_fine[i]);
<a name="l00240"></a>00240                               this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6ce39bedb72e4b8c5b5f3403c4ad162d">reinit_sides</a>();
<a name="l00241"></a>00241                               this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3518b201b4f8bb17a292be2701d76749">internal_side_integration</a>();
<a name="l00242"></a>00242 
<a name="l00243"></a>00243                               error_per_cell[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] += <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a28cc78a25a550e30504bfef7402398d3">fine_error</a>;
<a name="l00244"></a>00244                               error_per_cell[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] += <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a5999107dbf9dfc4166e59cdc6e1c24fe">coarse_error</a>;
<a name="l00245"></a>00245 
<a name="l00246"></a>00246                               <span class="comment">// Keep track of the number of internal flux</span>
<a name="l00247"></a>00247                               <span class="comment">// sides found on each element</span>
<a name="l00248"></a>00248                               n_flux_faces[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]++;
<a name="l00249"></a>00249                               n_flux_faces[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] += this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a00b086850721807623cae109806ce189">coarse_n_flux_faces_increment</a>();
<a name="l00250"></a>00250                             }
<a name="l00251"></a>00251                         }
<a name="l00252"></a>00252                     }
<a name="l00253"></a>00253                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a5407898d65d3aeeaeada1786234e5de4">integrate_boundary_sides</a>)
<a name="l00254"></a>00254                     {
<a name="l00255"></a>00255                       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a> = parent;
<a name="l00256"></a>00256                       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a> = Uparent;
<a name="l00257"></a>00257 
<a name="l00258"></a>00258                       <span class="comment">// Reinitialize shape functions on the fine element side</span>
<a name="l00259"></a>00259                       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;reinit (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a8b64ccb00f0f451f0fb867e2993f0e0a">fine_side</a>);
<a name="l00260"></a>00260 
<a name="l00261"></a>00261                       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a32d9097610a87627382c5ea81a70d0b1">boundary_side_integration</a>())
<a name="l00262"></a>00262                         {
<a name="l00263"></a>00263                           error_per_cell[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] += <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a28cc78a25a550e30504bfef7402398d3">fine_error</a>;
<a name="l00264"></a>00264                           n_flux_faces[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]++;
<a name="l00265"></a>00265                         }
<a name="l00266"></a>00266                     } 
<a name="l00267"></a>00267                 }
<a name="l00268"></a>00268             }
<a name="l00269"></a>00269 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00270"></a>00270 <span class="preprocessor"></span>
<a name="l00271"></a>00271           <span class="comment">// If we do any more flux integration, e will be the fine element</span>
<a name="l00272"></a>00272           <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a> = e;
<a name="l00273"></a>00273 
<a name="l00274"></a>00274           <span class="comment">// Loop over the neighbors of element e</span>
<a name="l00275"></a>00275           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_e=0; n_e&lt;e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n_e++)
<a name="l00276"></a>00276             {
<a name="l00277"></a>00277               <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a8b64ccb00f0f451f0fb867e2993f0e0a">fine_side</a> = n_e;
<a name="l00278"></a>00278 
<a name="l00279"></a>00279               <span class="keywordflow">if</span> (e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n_e) != NULL) <span class="comment">// e is not on the boundary</span>
<a name="l00280"></a>00280                 {
<a name="l00281"></a>00281                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* f           = e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n_e);
<a name="l00282"></a>00282                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_id = f-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00283"></a>00283 
<a name="l00284"></a>00284                   <span class="comment">// Compute flux jumps if we are in case 1 or case 2.</span>
<a name="l00285"></a>00285                   <span class="keywordflow">if</span> ((f-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>() &amp;&amp; (f-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() == e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()) &amp;&amp; (e_id &lt; f_id))
<a name="l00286"></a>00286                       || (f-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; e-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()))
<a name="l00287"></a>00287                     {               
<a name="l00288"></a>00288                       <span class="comment">// f is now the coarse element</span>
<a name="l00289"></a>00289                       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a> = f;
<a name="l00290"></a>00290 
<a name="l00291"></a>00291                       <span class="comment">// Get the DOF indices for the two elements</span>
<a name="l00292"></a>00292                       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>, dof_indices_fine, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>);
<a name="l00293"></a>00293                       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>, dof_indices_coarse, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>);
<a name="l00294"></a>00294 
<a name="l00295"></a>00295                       <span class="comment">// The number of DOFS on each element</span>
<a name="l00296"></a>00296                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_fine = dof_indices_fine.size();
<a name="l00297"></a>00297                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_coarse = dof_indices_coarse.size();
<a name="l00298"></a>00298                       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(n_dofs_fine);
<a name="l00299"></a>00299                       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6cb5f9a7c33e98c66e60f60332efd772">Ucoarse</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(n_dofs_coarse);
<a name="l00300"></a>00300 
<a name="l00301"></a>00301                       <span class="comment">// The local solutions on each element</span>
<a name="l00302"></a>00302                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_fine; i++)
<a name="l00303"></a>00303                         <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>(i) = system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices_fine[i]);
<a name="l00304"></a>00304                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_coarse; i++)
<a name="l00305"></a>00305                         <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6cb5f9a7c33e98c66e60f60332efd772">Ucoarse</a>(i) = system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices_coarse[i]);
<a name="l00306"></a>00306                         
<a name="l00307"></a>00307                       this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6ce39bedb72e4b8c5b5f3403c4ad162d">reinit_sides</a>();
<a name="l00308"></a>00308                       this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3518b201b4f8bb17a292be2701d76749">internal_side_integration</a>();
<a name="l00309"></a>00309 
<a name="l00310"></a>00310                       error_per_cell[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] += <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a28cc78a25a550e30504bfef7402398d3">fine_error</a>;
<a name="l00311"></a>00311                       error_per_cell[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] += <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a5999107dbf9dfc4166e59cdc6e1c24fe">coarse_error</a>;
<a name="l00312"></a>00312 
<a name="l00313"></a>00313                       <span class="comment">// Keep track of the number of internal flux</span>
<a name="l00314"></a>00314                       <span class="comment">// sides found on each element</span>
<a name="l00315"></a>00315                       n_flux_faces[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]++;
<a name="l00316"></a>00316                       n_flux_faces[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] += this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a00b086850721807623cae109806ce189">coarse_n_flux_faces_increment</a>();
<a name="l00317"></a>00317                     } <span class="comment">// end if (case1 || case2)</span>
<a name="l00318"></a>00318                 } <span class="comment">// if (e-&gt;neigbor(n_e) != NULL)</span>
<a name="l00319"></a>00319 
<a name="l00320"></a>00320               <span class="comment">// Otherwise, e is on the boundary.  If it happens to</span>
<a name="l00321"></a>00321               <span class="comment">// be on a Dirichlet boundary, we need not do anything.</span>
<a name="l00322"></a>00322               <span class="comment">// On the other hand, if e is on a Neumann (flux) boundary</span>
<a name="l00323"></a>00323               <span class="comment">// with grad(u).n = g, we need to compute the additional residual</span>
<a name="l00324"></a>00324               <span class="comment">// (h * \int |g - grad(u_h).n|^2 dS)^(1/2).</span>
<a name="l00325"></a>00325               <span class="comment">// We can only do this with some knowledge of the boundary</span>
<a name="l00326"></a>00326               <span class="comment">// conditions, i.e. the user must have attached an appropriate</span>
<a name="l00327"></a>00327               <span class="comment">// BC function.</span>
<a name="l00328"></a>00328               <span class="keywordflow">else</span>
<a name="l00329"></a>00329                 {
<a name="l00330"></a>00330                   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a5407898d65d3aeeaeada1786234e5de4">integrate_boundary_sides</a>)
<a name="l00331"></a>00331                     {
<a name="l00332"></a>00332                       <span class="comment">// Reinitialize shape functions on the fine element side</span>
<a name="l00333"></a>00333                       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;reinit (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a8b64ccb00f0f451f0fb867e2993f0e0a">fine_side</a>);
<a name="l00334"></a>00334 
<a name="l00335"></a>00335                       <span class="comment">// Get the DOF indices </span>
<a name="l00336"></a>00336                       dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>, dof_indices_fine, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>);
<a name="l00337"></a>00337 
<a name="l00338"></a>00338                       <span class="comment">// The number of DOFS on each element</span>
<a name="l00339"></a>00339                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs_fine = dof_indices_fine.size();
<a name="l00340"></a>00340                       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(n_dofs_fine);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs_fine; i++)
<a name="l00343"></a>00343                         <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>(i) = system.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices_fine[i]);
<a name="l00344"></a>00344 
<a name="l00345"></a>00345                       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a32d9097610a87627382c5ea81a70d0b1">boundary_side_integration</a>())
<a name="l00346"></a>00346                         {
<a name="l00347"></a>00347                           error_per_cell[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] += <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a28cc78a25a550e30504bfef7402398d3">fine_error</a>;
<a name="l00348"></a>00348                           n_flux_faces[<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]++;
<a name="l00349"></a>00349                         }
<a name="l00350"></a>00350                     } <span class="comment">// end if _bc_function != NULL</span>
<a name="l00351"></a>00351                 } <span class="comment">// end if (e-&gt;neighbor(n_e) == NULL)</span>
<a name="l00352"></a>00352             } <span class="comment">// end loop over neighbors</span>
<a name="l00353"></a>00353         } <span class="comment">// End loop over active local elements</span>
<a name="l00354"></a>00354     } <span class="comment">// End loop over variables</span>
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357   
<a name="l00358"></a>00358   <span class="comment">// Each processor has now computed the error contribuions</span>
<a name="l00359"></a>00359   <span class="comment">// for its local elements.  We need to sum the vector</span>
<a name="l00360"></a>00360   <span class="comment">// and then take the square-root of each component.  Note</span>
<a name="l00361"></a>00361   <span class="comment">// that we only need to sum if we are running on multiple</span>
<a name="l00362"></a>00362   <span class="comment">// processors, and we only need to take the square-root</span>
<a name="l00363"></a>00363   <span class="comment">// if the value is nonzero.  There will in general be many</span>
<a name="l00364"></a>00364   <span class="comment">// zeros for the inactive elements.</span>
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="comment">// First sum the vector of estimated error values</span>
<a name="l00367"></a>00367   this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9b57650afd8a3a0a88cb62bf74dd95e3">reduce_error</a>(error_per_cell);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="comment">// Compute the square-root of each component.</span>
<a name="l00370"></a>00370   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;error_per_cell.size(); i++)
<a name="l00371"></a>00371     <span class="keywordflow">if</span> (error_per_cell[i] != 0.)
<a name="l00372"></a>00372       error_per_cell[i] = std::sqrt(error_per_cell[i]);
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a4edf0ef12588e39bb85d8dea4e7d560d">scale_by_n_flux_faces</a>)
<a name="l00376"></a>00376     {
<a name="l00377"></a>00377       <span class="comment">// Sum the vector of flux face counts</span>
<a name="l00378"></a>00378       this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9b57650afd8a3a0a88cb62bf74dd95e3">reduce_error</a>(n_flux_faces);
<a name="l00379"></a>00379 
<a name="l00380"></a>00380       <span class="comment">// Sanity check: Make sure the number of flux faces is</span>
<a name="l00381"></a>00381       <span class="comment">// always an integer value</span>
<a name="l00382"></a>00382 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00383"></a>00383 <span class="preprocessor"></span>      <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_flux_faces.size(); ++i)
<a name="l00384"></a>00384         libmesh_assert (n_flux_faces[i] == static_cast&lt;float&gt;(static_cast&lt;unsigned int&gt;(n_flux_faces[i])) );
<a name="l00385"></a>00385 <span class="preprocessor">#endif</span>
<a name="l00386"></a>00386 <span class="preprocessor"></span>  
<a name="l00387"></a>00387       <span class="comment">// Scale the error by the number of flux faces for each element</span>
<a name="l00388"></a>00388       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_flux_faces.size(); ++i)
<a name="l00389"></a>00389         {
<a name="l00390"></a>00390           <span class="keywordflow">if</span> (n_flux_faces[i] == 0.0) <span class="comment">// inactive or non-local element</span>
<a name="l00391"></a>00391             <span class="keywordflow">continue</span>;
<a name="l00392"></a>00392       
<a name="l00393"></a>00393           <span class="comment">//libMesh::out &lt;&lt; &quot;Element &quot; &lt;&lt; i &lt;&lt; &quot; has &quot; &lt;&lt; n_flux_faces[i] &lt;&lt; &quot; flux faces.&quot; &lt;&lt; std::endl;</span>
<a name="l00394"></a>00394           error_per_cell[i] /= <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(n_flux_faces[i]); 
<a name="l00395"></a>00395         }
<a name="l00396"></a>00396     }
<a name="l00397"></a>00397   
<a name="l00398"></a>00398   <span class="comment">// If we used a non-standard solution before, now is the time to fix</span>
<a name="l00399"></a>00399   <span class="comment">// the current_local_solution</span>
<a name="l00400"></a>00400   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00401"></a>00401     {
<a name="l00402"></a>00402       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00403"></a>00403         <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00404"></a>00404       <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1System.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00405"></a>00405       newsol-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">swap</a>(*sys.solution);
<a name="l00406"></a>00406       sys.update();
<a name="l00407"></a>00407     }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409   STOP_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;JumpErrorEstimator&quot;</span>);
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 <span class="keywordtype">void</span>
<a name="l00415"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6ce39bedb72e4b8c5b5f3403c4ad162d">00415</a> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6ce39bedb72e4b8c5b5f3403c4ad162d">JumpErrorEstimator::reinit_sides</a> ()
<a name="l00416"></a>00416 {
<a name="l00417"></a>00417   <span class="comment">// The master quadrature point locations on the coarse element</span>
<a name="l00418"></a>00418   std::vector&lt;Point&gt; qp_coarse;
<a name="l00419"></a>00419 
<a name="l00420"></a>00420   <span class="comment">// Reinitialize shape functions on the fine element side</span>
<a name="l00421"></a>00421   <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;reinit (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a8b64ccb00f0f451f0fb867e2993f0e0a">fine_side</a>);
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="comment">// Get the physical locations of the fine element quadrature points</span>
<a name="l00424"></a>00424   std::vector&lt;Point&gt; qface_point = <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>-&gt;get_xyz();
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="comment">// Find their locations on the coarse element</span>
<a name="l00427"></a>00427   <a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>(), <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a67599bdd08ab287db8b455660542bc19">fe_coarse</a>-&gt;get_fe_type(),
<a name="l00428"></a>00428                             <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>, qface_point, qp_coarse);
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   <span class="comment">// Calculate the coarse element shape functions at those locations</span>
<a name="l00431"></a>00431   <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a67599bdd08ab287db8b455660542bc19">fe_coarse</a>-&gt;reinit (<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>, &amp;qp_coarse);
<a name="l00432"></a>00432 }
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a00b086850721807623cae109806ce189">00436</a> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a00b086850721807623cae109806ce189">JumpErrorEstimator::coarse_n_flux_faces_increment</a> ()
<a name="l00437"></a>00437 {
<a name="l00438"></a>00438   <span class="comment">// Keep track of the number of internal flux sides found on each</span>
<a name="l00439"></a>00439   <span class="comment">// element</span>
<a name="l00440"></a>00440   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>();
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> divisor =
<a name="l00443"></a>00443     1 &lt;&lt; (dim-1)*(<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() - <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>());
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="comment">// With a difference of n levels between fine and coarse elements,</span>
<a name="l00446"></a>00446   <span class="comment">// we compute a fractional flux face for the coarse element by adding:</span>
<a name="l00447"></a>00447   <span class="comment">// 1/2^n in 2D</span>
<a name="l00448"></a>00448   <span class="comment">// 1/4^n in 3D</span>
<a name="l00449"></a>00449   <span class="comment">// each time.  This code will get hit 2^n times in 2D and 4^n</span>
<a name="l00450"></a>00450   <span class="comment">// times in 3D so that the final flux face count for the coarse</span>
<a name="l00451"></a>00451   <span class="comment">// element will be an integer value.</span>
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <span class="keywordflow">return</span> 1.0 / <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(divisor);
<a name="l00454"></a>00454 }
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
