<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3734f8fafd73a2969ee8ed4a34620869.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">jump_error_estimator.h</div>  </div>
</div>
<div class="contents">
<a href="jump__error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: jump_error_estimator.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __jump_error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __jump_error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward Declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span>Point;
<a name="l00040"></a>00040 <span class="keyword">class </span>Elem;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php">JumpErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php">ErrorEstimator</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054 <span class="keyword">public</span>:
<a name="l00055"></a>00055 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a056856c8945a3fd4f050e72865b8cab6">00059</a>   <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a056856c8945a3fd4f050e72865b8cab6">JumpErrorEstimator</a>()
<a name="l00060"></a>00060     : <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a4edf0ef12588e39bb85d8dea4e7d560d">scale_by_n_flux_faces</a>(false),
<a name="l00061"></a>00061       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a5407898d65d3aeeaeada1786234e5de4">integrate_boundary_sides</a>(false),
<a name="l00062"></a>00062       <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>(NULL), <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a67599bdd08ab287db8b455660542bc19">fe_coarse</a>(NULL) {}
<a name="l00063"></a>00063   
<a name="l00067"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#aa1161837d9b112004f56fcbe5e20736f">00067</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#aa1161837d9b112004f56fcbe5e20736f">~JumpErrorEstimator</a>() {}
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#abafa2609660d4de159fb16d0a8d3c509">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00077"></a>00077                                <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00078"></a>00078                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00079"></a>00079                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00080"></a>00080 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a4edf0ef12588e39bb85d8dea4e7d560d">00089</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a4edf0ef12588e39bb85d8dea4e7d560d">scale_by_n_flux_faces</a>;
<a name="l00090"></a>00090   
<a name="l00091"></a>00091 <span class="keyword">protected</span>:
<a name="l00096"></a>00096   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6ce39bedb72e4b8c5b5f3403c4ad162d">reinit_sides</a>();
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a00b086850721807623cae109806ce189">coarse_n_flux_faces_increment</a>();
<a name="l00102"></a>00102 
<a name="l00107"></a>00107   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#aec1e6d7642dbdfec7759fa31a7a18f4b">initialize</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00108"></a>00108                           <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00109"></a>00109                           <span class="keywordtype">bool</span> estimate_parent_error);
<a name="l00110"></a>00110 
<a name="l00115"></a>00115   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3518b201b4f8bb17a292be2701d76749">internal_side_integration</a>() = 0;
<a name="l00116"></a>00116 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a32d9097610a87627382c5ea81a70d0b1">00122</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a32d9097610a87627382c5ea81a70d0b1">boundary_side_integration</a>() { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00123"></a>00123 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a5407898d65d3aeeaeada1786234e5de4">00128</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a5407898d65d3aeeaeada1786234e5de4">integrate_boundary_sides</a>;
<a name="l00129"></a>00129 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">00133</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#ab842afb135de12675e61f0e3ea417aea">fine_elem</a>, *<a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a3d656d187526017997f06b098ff2fc1f">coarse_elem</a>;
<a name="l00134"></a>00134 
<a name="l00138"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a28cc78a25a550e30504bfef7402398d3">00138</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a28cc78a25a550e30504bfef7402398d3">fine_error</a>, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a5999107dbf9dfc4166e59cdc6e1c24fe">coarse_error</a>;
<a name="l00139"></a>00139 
<a name="l00143"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a8b64ccb00f0f451f0fb867e2993f0e0a">00143</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a8b64ccb00f0f451f0fb867e2993f0e0a">fine_side</a>;
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">00148</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a05b93294744b2b7a95dc593d7ab122bf">var</a>;
<a name="l00149"></a>00149 
<a name="l00153"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">00153</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a952ad7f8168ee3322a0e5f07132d1fbd">Ufine</a>, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a6cb5f9a7c33e98c66e60f60332efd772">Ucoarse</a>;
<a name="l00154"></a>00154 
<a name="l00158"></a><a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">00158</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#af89df69dc28f166329853bebd990cfed">fe_fine</a>, <a class="code" href="classlibMesh_1_1JumpErrorEstimator.php#a67599bdd08ab287db8b455660542bc19">fe_coarse</a>;
<a name="l00159"></a>00159 };
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 } <span class="comment">// namespace libMesh</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="preprocessor">#endif</span>
<a name="l00165"></a>00165 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
