<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">laspack_linear_solver.C</div>  </div>
</div>
<div class="contents">
<a href="laspack__linear__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: laspack_linear_solver.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#if defined(LIBMESH_HAVE_LASPACK)</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="laspack__linear__solver_8h.php">laspack_linear_solver.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// #ifndef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00037"></a>00037 <span class="comment">// extern &quot;C&quot;</span>
<a name="l00038"></a>00038 <span class="comment">// {</span>
<a name="l00039"></a>00039 <span class="comment">// #endif</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">//   void print_iter_accuracy(int Iter,</span>
<a name="l00042"></a>00042 <span class="comment">//                         _LPReal rNorm,</span>
<a name="l00043"></a>00043 <span class="comment">//                         _LPReal bNorm,</span>
<a name="l00044"></a>00044 <span class="comment">//                         IterIdType IterId)</span>
<a name="l00045"></a>00045 <span class="comment">//     /* put out accuracy reached after each solver iteration */</span>
<a name="l00046"></a>00046 <span class="comment">//   {</span>
<a name="l00047"></a>00047     
<a name="l00048"></a>00048 <span class="comment">//     //FILE* out = fopen(&quot;residual.hist&quot;, &quot;a&quot;);</span>
<a name="l00049"></a>00049 <span class="comment">//     static int icall=0;</span>
<a name="l00050"></a>00050     
<a name="l00051"></a>00051 <span class="comment">//     if (!icall)</span>
<a name="l00052"></a>00052 <span class="comment">//       {</span>
<a name="l00053"></a>00053 <span class="comment">//      printf(&quot;Iter   ||r||/||f||\n&quot;);</span>
<a name="l00054"></a>00054 <span class="comment">//      printf(&quot;------------------\n&quot;);</span>
<a name="l00055"></a>00055 <span class="comment">//      icall=1;</span>
<a name="l00056"></a>00056 <span class="comment">//       }</span>
<a name="l00057"></a>00057     
<a name="l00058"></a>00058 <span class="comment">//     if ( Iter%1==0 &amp;&amp; (IterId == CGIterId ||</span>
<a name="l00059"></a>00059 <span class="comment">//                     IterId == CGNIterId ||</span>
<a name="l00060"></a>00060 <span class="comment">//                     IterId == GMRESIterId ||</span>
<a name="l00061"></a>00061 <span class="comment">//                     IterId == BiCGIterId ||</span>
<a name="l00062"></a>00062 <span class="comment">//                     IterId == QMRIterId ||</span>
<a name="l00063"></a>00063 <span class="comment">//                     IterId == CGSIterId ||</span>
<a name="l00064"></a>00064 <span class="comment">//                     IterId == BiCGSTABIterId)  )</span>
<a name="l00065"></a>00065 <span class="comment">//       {</span>
<a name="l00066"></a>00066 <span class="comment">//      if (!_LPIsZeroReal(bNorm))</span>
<a name="l00067"></a>00067 <span class="comment">//        printf(&quot;%d    \t %g\n&quot;, Iter, rNorm/bNorm);</span>
<a name="l00068"></a>00068 <span class="comment">//      else</span>
<a name="l00069"></a>00069 <span class="comment">//        printf(&quot;%d     (fnorm == 0)\n&quot;, Iter);</span>
<a name="l00070"></a>00070 <span class="comment">//       }</span>
<a name="l00071"></a>00071     
<a name="l00072"></a>00072 <span class="comment">//     //fclose(out);</span>
<a name="l00073"></a>00073 <span class="comment">//   }</span>
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 <span class="comment">// #ifndef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00076"></a>00076 <span class="comment">// }</span>
<a name="l00077"></a>00077 <span class="comment">// #endif  </span>
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00080"></a>00080 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00081"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a4a574576ab79b8e125e83fc9c14dcdf2">00081</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a4a574576ab79b8e125e83fc9c14dcdf2">LaspackLinearSolver&lt;T&gt;::clear</a> ()
<a name="l00082"></a>00082 {
<a name="l00083"></a>00083   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00084"></a>00084     {
<a name="l00085"></a>00085       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00086"></a>00086       
<a name="l00087"></a>00087       this-&gt;_solver_type         = <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>;
<a name="l00088"></a>00088       this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;
<a name="l00089"></a>00089     }
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00095"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#aa89b58ee61aacb1afae22506a3c94df2">00095</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#aa89b58ee61aacb1afae22506a3c94df2">LaspackLinearSolver&lt;T&gt;::init</a> ()
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   <span class="comment">// Initialize the data structures if not done so already.</span>
<a name="l00098"></a>00098   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00099"></a>00099     {
<a name="l00100"></a>00100       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00101"></a>00101     }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103  <span class="comment">// SetRTCAuxProc (print_iter_accuracy);</span>
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00109"></a>00109 std::pair&lt;unsigned int, Real&gt; 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af18d2a5842e75467cad920d7b73b11a0">00110</a> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af18d2a5842e75467cad920d7b73b11a0">LaspackLinearSolver&lt;T&gt;::solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;matrix_in,
<a name="l00111"></a>00111                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in,
<a name="l00112"></a>00112                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs_in,
<a name="l00113"></a>00113                                <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00114"></a>00114                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00115"></a>00115 {
<a name="l00116"></a>00116   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;LaspackLinearSolver&quot;</span>);
<a name="l00117"></a>00117   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">// Make sure the data passed in are really in Laspack types</span>
<a name="l00120"></a>00120   <a class="code" href="classlibMesh_1_1LaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>* matrix   = libmesh_cast_ptr&lt;LaspackMatrix&lt;T&gt;*&gt;(&amp;matrix_in);
<a name="l00121"></a>00121   <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>* solution = libmesh_cast_ptr&lt;LaspackVector&lt;T&gt;*&gt;(&amp;solution_in);
<a name="l00122"></a>00122   <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>* rhs      = libmesh_cast_ptr&lt;LaspackVector&lt;T&gt;*&gt;(&amp;rhs_in);
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// Zero-out the solution to prevent the solver from exiting in 0</span>
<a name="l00125"></a>00125   <span class="comment">// iterations (?)</span>
<a name="l00126"></a>00126   <span class="comment">//TODO:[BSK] Why does Laspack do this?  Comment out this and try ex13...</span>
<a name="l00127"></a>00127   solution-&gt;<a class="code" href="classlibMesh_1_1LaspackVector.php#a6f29fe9d544b1bbbc427ce69928eb2c7">zero</a>();
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   <span class="comment">// Close the matrix and vectors in case this wasn&#39;t already done.</span>
<a name="l00130"></a>00130   matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a90374d2b650da070a55671feb3d8dcc8">close</a> ();
<a name="l00131"></a>00131   solution-&gt;close ();
<a name="l00132"></a>00132   rhs-&gt;close ();
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">// Set the preconditioner type</span>
<a name="l00135"></a>00135   this-&gt;set_laspack_preconditioner_type ();
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// Set the solver tolerance</span>
<a name="l00138"></a>00138   SetRTCAccuracy (tol);
<a name="l00139"></a>00139 
<a name="l00140"></a>00140   <span class="comment">// Solve the linear system</span>
<a name="l00141"></a>00141   <span class="keywordflow">switch</span> (this-&gt;_solver_type)
<a name="l00142"></a>00142     {
<a name="l00143"></a>00143       <span class="comment">// Conjugate-Gradient</span>
<a name="l00144"></a>00144     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19af0969a6b5512fce0e1ef22d7487e23d7">CG</a>:
<a name="l00145"></a>00145       {
<a name="l00146"></a>00146         CGIter (&amp;matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>,
<a name="l00147"></a>00147                 &amp;solution-&gt;_vec,
<a name="l00148"></a>00148                 &amp;rhs-&gt;_vec,
<a name="l00149"></a>00149                 m_its,
<a name="l00150"></a>00150                 _precond_type,
<a name="l00151"></a>00151                 1.);
<a name="l00152"></a>00152         <span class="keywordflow">break</span>;
<a name="l00153"></a>00153       }
<a name="l00154"></a>00154 
<a name="l00155"></a>00155       <span class="comment">// Conjugate-Gradient Normalized</span>
<a name="l00156"></a>00156     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a694143da15a5eceb33b2f2fd9823e02a">CGN</a>:
<a name="l00157"></a>00157       {
<a name="l00158"></a>00158         CGNIter (&amp;matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>,
<a name="l00159"></a>00159                  &amp;solution-&gt;_vec,
<a name="l00160"></a>00160                  &amp;rhs-&gt;_vec,
<a name="l00161"></a>00161                  m_its,
<a name="l00162"></a>00162                  _precond_type,
<a name="l00163"></a>00163                  1.);
<a name="l00164"></a>00164         <span class="keywordflow">break</span>;
<a name="l00165"></a>00165       }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167       <span class="comment">// Conjugate-Gradient Squared</span>
<a name="l00168"></a>00168     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19afff9553e13457ad7f271af09bc52f438">CGS</a>:
<a name="l00169"></a>00169       {
<a name="l00170"></a>00170         CGSIter (&amp;matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>,
<a name="l00171"></a>00171                  &amp;solution-&gt;_vec,
<a name="l00172"></a>00172                  &amp;rhs-&gt;_vec,
<a name="l00173"></a>00173                  m_its,
<a name="l00174"></a>00174                  _precond_type,
<a name="l00175"></a>00175                  1.);
<a name="l00176"></a>00176         <span class="keywordflow">break</span>;
<a name="l00177"></a>00177       }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179       <span class="comment">// Bi-Conjugate Gradient</span>
<a name="l00180"></a>00180     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a0dcffd9411a6eaa02f83ce1be41bcde2">BICG</a>:
<a name="l00181"></a>00181       {
<a name="l00182"></a>00182         BiCGIter (&amp;matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>,
<a name="l00183"></a>00183                   &amp;solution-&gt;_vec,
<a name="l00184"></a>00184                   &amp;rhs-&gt;_vec,
<a name="l00185"></a>00185                   m_its,
<a name="l00186"></a>00186                   _precond_type,
<a name="l00187"></a>00187                   1.);
<a name="l00188"></a>00188         <span class="keywordflow">break</span>;
<a name="l00189"></a>00189       }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191       <span class="comment">// Bi-Conjugate Gradient Stabilized</span>
<a name="l00192"></a>00192     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19ae5a5e49337074324233c300b1daf83ec">BICGSTAB</a>:
<a name="l00193"></a>00193       {
<a name="l00194"></a>00194         BiCGSTABIter (&amp;matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>,
<a name="l00195"></a>00195                       &amp;solution-&gt;_vec,
<a name="l00196"></a>00196                       &amp;rhs-&gt;_vec,
<a name="l00197"></a>00197                       m_its,
<a name="l00198"></a>00198                       _precond_type,
<a name="l00199"></a>00199                       1.);
<a name="l00200"></a>00200         <span class="keywordflow">break</span>;
<a name="l00201"></a>00201       }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203       <span class="comment">// Quasi-Minimum Residual</span>
<a name="l00204"></a>00204     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a495f762f230916be82605faf577f2c93">QMR</a>:
<a name="l00205"></a>00205       {
<a name="l00206"></a>00206         QMRIter (&amp;matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>,
<a name="l00207"></a>00207                  &amp;solution-&gt;_vec,
<a name="l00208"></a>00208                  &amp;rhs-&gt;_vec,
<a name="l00209"></a>00209                  m_its,
<a name="l00210"></a>00210                  _precond_type,
<a name="l00211"></a>00211                  1.);
<a name="l00212"></a>00212         <span class="keywordflow">break</span>;
<a name="l00213"></a>00213       }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215       <span class="comment">// Symmetric over-relaxation</span>
<a name="l00216"></a>00216     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19af1fd79e3cd3b4a175980871c83af77e2">SSOR</a>:
<a name="l00217"></a>00217       {
<a name="l00218"></a>00218         SSORIter (&amp;matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>,
<a name="l00219"></a>00219                   &amp;solution-&gt;_vec,
<a name="l00220"></a>00220                   &amp;rhs-&gt;_vec,
<a name="l00221"></a>00221                   m_its,
<a name="l00222"></a>00222                   _precond_type,
<a name="l00223"></a>00223                   1.);
<a name="l00224"></a>00224         <span class="keywordflow">break</span>;
<a name="l00225"></a>00225       }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227       <span class="comment">// Jacobi Relaxation</span>
<a name="l00228"></a>00228     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a60255bd6c276522988052a96b9c117c4">JACOBI</a>:
<a name="l00229"></a>00229       {
<a name="l00230"></a>00230         JacobiIter (&amp;matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>,
<a name="l00231"></a>00231                     &amp;solution-&gt;_vec,
<a name="l00232"></a>00232                     &amp;rhs-&gt;_vec,
<a name="l00233"></a>00233                     m_its,
<a name="l00234"></a>00234                     _precond_type,
<a name="l00235"></a>00235                     1.);
<a name="l00236"></a>00236         <span class="keywordflow">break</span>;
<a name="l00237"></a>00237       }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239       <span class="comment">// Generalized Minimum Residual</span>
<a name="l00240"></a>00240     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>:
<a name="l00241"></a>00241       {
<a name="l00242"></a>00242         SetGMRESRestart (30);
<a name="l00243"></a>00243         GMRESIter (&amp;matrix-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>,
<a name="l00244"></a>00244                    &amp;solution-&gt;_vec,
<a name="l00245"></a>00245                    &amp;rhs-&gt;_vec,
<a name="l00246"></a>00246                    m_its,
<a name="l00247"></a>00247                    _precond_type,
<a name="l00248"></a>00248                    1.);
<a name="l00249"></a>00249         <span class="keywordflow">break</span>;
<a name="l00250"></a>00250       }
<a name="l00251"></a>00251 
<a name="l00252"></a>00252       <span class="comment">// Unknown solver, use GMRES</span>
<a name="l00253"></a>00253     <span class="keywordflow">default</span>:
<a name="l00254"></a>00254       {
<a name="l00255"></a>00255         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unsupported LASPACK Solver: &quot;</span>
<a name="l00256"></a>00256                       &lt;&lt; this-&gt;_solver_type      &lt;&lt; std::endl
<a name="l00257"></a>00257                       &lt;&lt; <span class="stringliteral">&quot;Continuing with GMRES&quot;</span> &lt;&lt; std::endl;
<a name="l00258"></a>00258         
<a name="l00259"></a>00259         this-&gt;_solver_type = <a class="code" href="namespacelibMeshEnums.php#a6ecf91f56b4ab5cda4d3d0a468733b19a28c6a4ecccca1d0e6956e5e94fa82d97">GMRES</a>;
<a name="l00260"></a>00260         
<a name="l00261"></a>00261         <span class="keywordflow">return</span> this-&gt;solve (*matrix,
<a name="l00262"></a>00262                             *solution,
<a name="l00263"></a>00263                             *rhs,
<a name="l00264"></a>00264                             tol,
<a name="l00265"></a>00265                             m_its);
<a name="l00266"></a>00266       }
<a name="l00267"></a>00267     }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="comment">// Check for an error</span>
<a name="l00270"></a>00270   <span class="keywordflow">if</span> (LASResult() != LASOK)
<a name="l00271"></a>00271     {
<a name="l00272"></a>00272       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  LASPACK Error: &quot;</span> &lt;&lt; std::endl;
<a name="l00273"></a>00273       WriteLASErrDescr(stdout);
<a name="l00274"></a>00274       libmesh_error();
<a name="l00275"></a>00275     }
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;LaspackLinearSolver&quot;</span>);
<a name="l00278"></a>00278   <span class="comment">// Get the convergence step # and residual </span>
<a name="l00279"></a>00279   <span class="keywordflow">return</span> std::make_pair(GetLastNoIter(), GetLastAccuracy());
<a name="l00280"></a>00280 }
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00285"></a>00285 std::pair&lt;unsigned int, Real&gt; 
<a name="l00286"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#ad268e34dd28d17c154fe5c2615477ad5">00286</a> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af18d2a5842e75467cad920d7b73b11a0">LaspackLinearSolver&lt;T&gt;::solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; <span class="comment">/*shell_matrix*/</span>,
<a name="l00287"></a>00287                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/*solution_in*/</span>,
<a name="l00288"></a>00288                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/*rhs_in*/</span>,
<a name="l00289"></a>00289                                <span class="keyword">const</span> <span class="keywordtype">double</span> <span class="comment">/*tol*/</span>,
<a name="l00290"></a>00290                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*m_its*/</span>)
<a name="l00291"></a>00291 {
<a name="l00292"></a>00292   libmesh_not_implemented();
<a name="l00293"></a>00293   <span class="keywordflow">return</span> std::make_pair(0,0.0);
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00299"></a>00299 std::pair&lt;unsigned int, Real&gt; 
<a name="l00300"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a45d7c71fb2c985763c82f7047cb58c51">00300</a> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af18d2a5842e75467cad920d7b73b11a0">LaspackLinearSolver&lt;T&gt;::solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; <span class="comment">/*shell_matrix*/</span>,
<a name="l00301"></a>00301                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; <span class="comment">/*precond_matrix*/</span>,
<a name="l00302"></a>00302                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/*solution_in*/</span>,
<a name="l00303"></a>00303                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/*rhs_in*/</span>,
<a name="l00304"></a>00304                                <span class="keyword">const</span> <span class="keywordtype">double</span> <span class="comment">/*tol*/</span>,
<a name="l00305"></a>00305                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*m_its*/</span>)
<a name="l00306"></a>00306 {
<a name="l00307"></a>00307   libmesh_not_implemented();
<a name="l00308"></a>00308   <span class="keywordflow">return</span> std::make_pair(0,0.0);
<a name="l00309"></a>00309 }
<a name="l00310"></a>00310 
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00314"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a23ebdad5adcddcca23d676d1203496c0">00314</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a23ebdad5adcddcca23d676d1203496c0">LaspackLinearSolver&lt;T&gt;::set_laspack_preconditioner_type</a> ()
<a name="l00315"></a>00315 {
<a name="l00316"></a>00316   <span class="keywordflow">switch</span> (this-&gt;_preconditioner_type)
<a name="l00317"></a>00317     {
<a name="l00318"></a>00318     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a44a26581f6d3dd94e7188bbb4af8294a">IDENTITY_PRECOND</a>:
<a name="l00319"></a>00319       _precond_type = NULL; <span class="keywordflow">return</span>;
<a name="l00320"></a>00320 
<a name="l00321"></a>00321     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>:
<a name="l00322"></a>00322       _precond_type = ILUPrecond; <span class="keywordflow">return</span>;
<a name="l00323"></a>00323 
<a name="l00324"></a>00324     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a9b2d6ff994aa4cfb181f5eceec23174f">JACOBI_PRECOND</a>:
<a name="l00325"></a>00325       _precond_type = JacobiPrecond; <span class="keywordflow">return</span>;
<a name="l00326"></a>00326 
<a name="l00327"></a>00327     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a9e50971811a02ac1f940c7d803cc2b4c">SSOR_PRECOND</a>:
<a name="l00328"></a>00328       _precond_type = SSORPrecond; <span class="keywordflow">return</span>;
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331     <span class="keywordflow">default</span>:
<a name="l00332"></a>00332       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unsupported LASPACK Preconditioner: &quot;</span>
<a name="l00333"></a>00333                     &lt;&lt; this-&gt;_preconditioner_type &lt;&lt; std::endl
<a name="l00334"></a>00334                     &lt;&lt; <span class="stringliteral">&quot;Continuing with ILU&quot;</span>      &lt;&lt; std::endl;
<a name="l00335"></a>00335       this-&gt;_preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;
<a name="l00336"></a>00336       this-&gt;set_laspack_preconditioner_type();      
<a name="l00337"></a>00337     }
<a name="l00338"></a>00338 }
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00343"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af4d71d656a6a2417a80071db1aae98e5">00343</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af4d71d656a6a2417a80071db1aae98e5">LaspackLinearSolver&lt;T&gt;::print_converged_reason</a>()
<a name="l00344"></a>00344 {
<a name="l00345"></a>00345   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;print_converged_reason() is currently only supported&quot;</span>
<a name="l00346"></a>00346                 &lt;&lt; <span class="stringliteral">&quot;with Petsc 2.3.1 and later.&quot;</span> &lt;&lt; std::endl;
<a name="l00347"></a>00347 }
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00352"></a>00352 <span class="comment">// Explicit instantiations</span>
<a name="l00353"></a>00353 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php">LaspackLinearSolver&lt;Number&gt;</a>;
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 } <span class="comment">// namespace libMesh</span>
<a name="l00356"></a>00356  
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
