<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">laspack_linear_solver.h</div>  </div>
</div>
<div class="contents">
<a href="laspack__linear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: laspack_linear_solver.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __laspack_linear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __laspack_linear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#if defined(LIBMESH_HAVE_LASPACK)</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="comment">//#if defined(LIBMESH_HAVE_LASPACK) &amp;&amp; !defined(LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// C++ includes</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Local includes</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="laspack__vector_8h.php">laspack_vector.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="laspack__matrix_8h.php">laspack_matrix.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="preprocessor">#include &lt;itersolv.h&gt;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &lt;rtc.h&gt;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &lt;errhandl.h&gt;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>libMesh
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00056"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php">LaspackLinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver</a>&lt;T&gt;
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058  <span class="keyword">public</span>:
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a7cc0f5666f4c6ea1c1360b63746d42ac">LaspackLinearSolver</a> ();
<a name="l00063"></a>00063     
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a6e3bac5a144118c3fa79acdf717d9055">~LaspackLinearSolver</a> ();
<a name="l00068"></a>00068   
<a name="l00072"></a>00072   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a4a574576ab79b8e125e83fc9c14dcdf2">clear</a> ();
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#aa89b58ee61aacb1afae22506a3c94df2">init</a> ();
<a name="l00078"></a>00078   
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   std::pair&lt;unsigned int, Real&gt; 
<a name="l00084"></a>00084     <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af18d2a5842e75467cad920d7b73b11a0">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix,
<a name="l00085"></a>00085            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution,
<a name="l00086"></a>00086            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs,
<a name="l00087"></a>00087            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00088"></a>00088            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00092"></a>00092   std::pair&lt;unsigned int, Real&gt; 
<a name="l00093"></a>00093     <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af18d2a5842e75467cad920d7b73b11a0">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix,
<a name="l00094"></a>00094            <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;pc,
<a name="l00095"></a>00095            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution,
<a name="l00096"></a>00096            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs,
<a name="l00097"></a>00097            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00098"></a>00098            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00099"></a>00099    
<a name="l00103"></a>00103   std::pair&lt;unsigned int, Real&gt;
<a name="l00104"></a>00104     <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af18d2a5842e75467cad920d7b73b11a0">solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00105"></a>00105            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00106"></a>00106            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00107"></a>00107            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00108"></a>00108            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00109"></a>00109   
<a name="l00115"></a>00115   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00116"></a>00116     <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af18d2a5842e75467cad920d7b73b11a0">solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00117"></a>00117            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00118"></a>00118            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00119"></a>00119            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00120"></a>00120            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00121"></a>00121            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00122"></a>00122   
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af4d71d656a6a2417a80071db1aae98e5">print_converged_reason</a>();
<a name="l00128"></a>00128   
<a name="l00129"></a>00129  <span class="keyword">private</span>:
<a name="l00130"></a>00130   
<a name="l00135"></a>00135   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a23ebdad5adcddcca23d676d1203496c0">set_laspack_preconditioner_type</a> ();
<a name="l00136"></a>00136 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#accfd5f4ecb3b9728158ac0d41eaea51f">00140</a>   PrecondProcType <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#accfd5f4ecb3b9728158ac0d41eaea51f">_precond_type</a>;
<a name="l00141"></a>00141 };
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00145"></a>00145 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00146"></a>00146 <span class="keyword">inline</span>
<a name="l00147"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a7cc0f5666f4c6ea1c1360b63746d42ac">00147</a> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a7cc0f5666f4c6ea1c1360b63746d42ac">LaspackLinearSolver&lt;T&gt;::LaspackLinearSolver</a> () :
<a name="l00148"></a>00148   _precond_type (ILUPrecond)
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00155"></a>00155 <span class="keyword">inline</span>
<a name="l00156"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a6e3bac5a144118c3fa79acdf717d9055">00156</a> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a6e3bac5a144118c3fa79acdf717d9055">LaspackLinearSolver&lt;T&gt;::~LaspackLinearSolver</a> ()
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158   this-&gt;clear ();
<a name="l00159"></a>00159 }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00164"></a>00164 <span class="keyword">inline</span>
<a name="l00165"></a>00165 std::pair&lt;unsigned int, Real&gt;
<a name="l00166"></a><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#a3e0247fbee1246d3c97c9a89923dfeae">00166</a> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php#af18d2a5842e75467cad920d7b73b11a0">LaspackLinearSolver&lt;T&gt;::solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,
<a name="l00167"></a>00167                                <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,
<a name="l00168"></a>00168                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00169"></a>00169                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00170"></a>00170                                <span class="keyword">const</span> <span class="keywordtype">double</span>,
<a name="l00171"></a>00171                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00172"></a>00172 {
<a name="l00173"></a>00173   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: LASPACK does not support a user-supplied preconditioner!&quot;</span>
<a name="l00174"></a>00174                 &lt;&lt; std::endl;
<a name="l00175"></a>00175   libmesh_error();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   std::pair&lt;unsigned int, Real&gt; p;
<a name="l00178"></a>00178   <span class="keywordflow">return</span> p;
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 } <span class="comment">// namespace libMesh</span>
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00184"></a>00184 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifndef __laspack_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
