<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">laspack_matrix.h</div>  </div>
</div>
<div class="contents">
<a href="laspack__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: laspack_matrix.h 4246 2011-03-11 22:24:59Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __laspack_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __laspack_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK </span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;qmatrix.h&gt;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>libMesh
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// Forward declarations</span>
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseMatrix;
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>LaspackVector;
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>LaspackLinearSolver;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00065"></a>00065 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00066"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php">00066</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LaspackMatrix.php">LaspackMatrix</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;T&gt;
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="keyword">public</span>:
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a5f5d16d53c2189d8fbde1b2f736db309">LaspackMatrix</a> ();
<a name="l00086"></a>00086 
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a943c2d5db5e6c137c491a7c630d1d71d">~LaspackMatrix</a> ();
<a name="l00093"></a>00093 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#ad24e5046a47cc539c3ef56de2bb7ee7b">00097</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ad24e5046a47cc539c3ef56de2bb7ee7b">need_full_sparsity_pattern</a>()<span class="keyword"> const </span>
<a name="l00098"></a>00098 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00099"></a>00099 
<a name="l00105"></a>00105   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a0fa7fabdf07cf8d8d16a8498f28055e1">update_sparsity_pattern</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparsityPattern_1_1Graph.php">SparsityPattern::Graph</a> &amp;);
<a name="l00106"></a>00106   
<a name="l00115"></a>00115   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a9e190ee54e4b742513e3169d2b704af6">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac0dfaf611a4a53e689bafcf05c0d3e56">m</a>,
<a name="l00116"></a>00116              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac1d9b17068578394433b5f55f8360830">n</a>,
<a name="l00117"></a>00117              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00118"></a>00118              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00119"></a>00119              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz=30,
<a name="l00120"></a>00120              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz=10);
<a name="l00121"></a>00121 
<a name="l00125"></a>00125   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a9e190ee54e4b742513e3169d2b704af6">init</a> ();
<a name="l00126"></a>00126   
<a name="l00133"></a>00133   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a9d52cb1eda8dd163c75a0185d4dadfd9">clear</a> ();
<a name="l00134"></a>00134 
<a name="l00138"></a>00138   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a8424c2ea5acfc17f4624c9e93805263a">zero</a> ();
<a name="l00139"></a>00139   
<a name="l00145"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a90374d2b650da070a55671feb3d8dcc8">00145</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a90374d2b650da070a55671feb3d8dcc8">close</a> ()<span class="keyword"> const </span>{ <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1LaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(<span class="keyword">this</span>)-&gt;<a class="code" href="classlibMesh_1_1LaspackMatrix.php#acb97bb8a409c0239856127155e3acb81">_closed</a> = <span class="keyword">true</span>; }
<a name="l00146"></a>00146   
<a name="l00151"></a>00151   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac0dfaf611a4a53e689bafcf05c0d3e56">m</a> () <span class="keyword">const</span>;
<a name="l00152"></a>00152 
<a name="l00157"></a>00157   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac1d9b17068578394433b5f55f8360830">n</a> () <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00163"></a>00163   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ae348ed59082287248036865693ea1d50">row_start</a> () <span class="keyword">const</span>;
<a name="l00164"></a>00164 
<a name="l00169"></a>00169   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a68f79f057caefe579908478d85b01e87">row_stop</a> () <span class="keyword">const</span>;
<a name="l00170"></a>00170 
<a name="l00177"></a>00177   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00178"></a>00178             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00179"></a>00179             <span class="keyword">const</span> T value);
<a name="l00180"></a>00180     
<a name="l00189"></a>00189   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac070a9120898c00abc1148f0a7e29a04">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00190"></a>00190             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00191"></a>00191             <span class="keyword">const</span> T value);
<a name="l00192"></a>00192 
<a name="l00200"></a>00200   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ab194bd4e017ec1627fe6ad9cf693105a">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00201"></a>00201                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00202"></a>00202                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols);
<a name="l00203"></a>00203   
<a name="l00208"></a>00208   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ab194bd4e017ec1627fe6ad9cf693105a">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00209"></a>00209                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;dof_indices);
<a name="l00210"></a>00210       
<a name="l00218"></a>00218   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac070a9120898c00abc1148f0a7e29a04">add</a> (<span class="keyword">const</span> T a, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X);
<a name="l00219"></a>00219       
<a name="l00238"></a>00238   T <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a59a1472de7277b82650467ff7ecedd84">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00239"></a>00239                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00240"></a>00240 
<a name="l00251"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac926931cd5aa7e88aca93696b3e09ce6">00251</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac926931cd5aa7e88aca93696b3e09ce6">l1_norm</a> ()<span class="keyword"> const </span>{ libmesh_error(); <span class="keywordflow">return</span> 0.; }
<a name="l00252"></a>00252 
<a name="l00264"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a4a108f6275c0fff59dcbccdc02405cb8">00264</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a4a108f6275c0fff59dcbccdc02405cb8">linfty_norm</a> ()<span class="keyword"> const </span>{ libmesh_error(); <span class="keywordflow">return</span> 0.; }
<a name="l00265"></a>00265 
<a name="l00270"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a4792ce6e8704ac7d874ae0821eda8399">00270</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a4792ce6e8704ac7d874ae0821eda8399">closed</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#acb97bb8a409c0239856127155e3acb81">_closed</a>; }
<a name="l00271"></a>00271   
<a name="l00276"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a95ba5083247cbc6f7892925ece6bc33f">00276</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a95ba5083247cbc6f7892925ece6bc33f">print_personal</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>)<span class="keyword"> const </span>{ this-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#afcdf5bc4246bc646599e5d1a031b3c96">print</a>(os); }
<a name="l00277"></a>00277 
<a name="l00281"></a>00281   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a2568d05485bf17824853bbc2d5d0dde8">get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00282"></a>00282 
<a name="l00287"></a>00287   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a00f67b5eb5e315b88a6e7284c3ef9bef">get_transpose</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 <span class="keyword">private</span>:
<a name="l00290"></a>00290 
<a name="l00295"></a>00295   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a12923461af03da51c15136d29b8443dd">pos</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00296"></a>00296                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00297"></a>00297   
<a name="l00301"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">00301</a>   QMatrix <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a29df7284b5cc9a1f699b86b0cf14aec4">_QMat</a>;
<a name="l00302"></a>00302 
<a name="l00306"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a13a663a23eb9f923ee6d5543d8e39e11">00306</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a13a663a23eb9f923ee6d5543d8e39e11">_csr</a>;
<a name="l00307"></a>00307 
<a name="l00312"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a16d4814509b77b25bfa5e40276bb96bf">00312</a>   std::vector&lt;std::vector&lt;unsigned int&gt;::const_iterator&gt; <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a16d4814509b77b25bfa5e40276bb96bf">_row_start</a>;
<a name="l00313"></a>00313 
<a name="l00317"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#acb97bb8a409c0239856127155e3acb81">00317</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#acb97bb8a409c0239856127155e3acb81">_closed</a>;
<a name="l00318"></a>00318 
<a name="l00322"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a349576c19432153b5f5a0c544a29dbaf">00322</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector</a>&lt;T&gt;;
<a name="l00323"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a0be0354b510b1eba31ee700b6a44408b">00323</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LaspackLinearSolver.php">LaspackLinearSolver</a>&lt;T&gt;;
<a name="l00324"></a>00324 };
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00329"></a>00329 <span class="comment">// LaspackMatrix class inline members</span>
<a name="l00330"></a>00330 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00331"></a>00331 <span class="keyword">inline</span>
<a name="l00332"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a5f5d16d53c2189d8fbde1b2f736db309">00332</a> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a5f5d16d53c2189d8fbde1b2f736db309">LaspackMatrix&lt;T&gt;::LaspackMatrix</a> () :
<a name="l00333"></a>00333   _closed (false)
<a name="l00334"></a>00334 {
<a name="l00335"></a>00335 }
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00340"></a>00340 <span class="keyword">inline</span>
<a name="l00341"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a943c2d5db5e6c137c491a7c630d1d71d">00341</a> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a943c2d5db5e6c137c491a7c630d1d71d">LaspackMatrix&lt;T&gt;::~LaspackMatrix</a> ()
<a name="l00342"></a>00342 {
<a name="l00343"></a>00343   this-&gt;clear ();
<a name="l00344"></a>00344 }
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00349"></a>00349 <span class="keyword">inline</span>
<a name="l00350"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a9d52cb1eda8dd163c75a0185d4dadfd9">00350</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a9d52cb1eda8dd163c75a0185d4dadfd9">LaspackMatrix&lt;T&gt;::clear</a> ()
<a name="l00351"></a>00351 {
<a name="l00352"></a>00352   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00353"></a>00353     {
<a name="l00354"></a>00354       Q_Destr(&amp;_QMat);
<a name="l00355"></a>00355     }
<a name="l00356"></a>00356   
<a name="l00357"></a>00357   _csr.clear();
<a name="l00358"></a>00358   _row_start.clear();
<a name="l00359"></a>00359   _closed = <span class="keyword">false</span>;
<a name="l00360"></a>00360   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00361"></a>00361 }
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00366"></a>00366 <span class="keyword">inline</span>
<a name="l00367"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a8424c2ea5acfc17f4624c9e93805263a">00367</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a8424c2ea5acfc17f4624c9e93805263a">LaspackMatrix&lt;T&gt;::zero</a> ()
<a name="l00368"></a>00368 {
<a name="l00369"></a>00369   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = this-&gt;m();
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row=0; row&lt;n_rows; row++)
<a name="l00372"></a>00372     {
<a name="l00373"></a>00373       <span class="keyword">const</span> std::vector&lt;unsigned int&gt;::const_iterator
<a name="l00374"></a>00374         r_start = _row_start[row];
<a name="l00375"></a>00375       
<a name="l00376"></a>00376       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len = (_row_start[row+1] - _row_start[row]);
<a name="l00377"></a>00377         
<a name="l00378"></a>00378       <span class="comment">// Make sure we agree on the row length</span>
<a name="l00379"></a>00379       libmesh_assert (len == Q_GetLen(&amp;_QMat, row+1));
<a name="l00380"></a>00380       
<a name="l00381"></a>00381       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;len; l++)
<a name="l00382"></a>00382         {
<a name="l00383"></a>00383           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = *(r_start + l);
<a name="l00384"></a>00384 
<a name="l00385"></a>00385           <span class="comment">// Make sure the data structures are working</span>
<a name="l00386"></a>00386           libmesh_assert ((j+1) == Q_GetPos (&amp;_QMat, row+1, l));
<a name="l00387"></a>00387           
<a name="l00388"></a>00388           Q_SetEntry (&amp;_QMat, row+1, l, j+1, 0.);
<a name="l00389"></a>00389         }
<a name="l00390"></a>00390     }    
<a name="l00391"></a>00391 }
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00396"></a>00396 <span class="keyword">inline</span>
<a name="l00397"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac0dfaf611a4a53e689bafcf05c0d3e56">00397</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac0dfaf611a4a53e689bafcf05c0d3e56">LaspackMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00398"></a>00398 <span class="keyword"></span>{
<a name="l00399"></a>00399   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00400"></a>00400 
<a name="l00401"></a>00401   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(Q_GetDim(const_cast&lt;QMatrix*&gt;(&amp;_QMat)));
<a name="l00402"></a>00402 }
<a name="l00403"></a>00403 
<a name="l00404"></a>00404 
<a name="l00405"></a>00405 
<a name="l00406"></a>00406 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00407"></a>00407 <span class="keyword">inline</span>
<a name="l00408"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac1d9b17068578394433b5f55f8360830">00408</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac1d9b17068578394433b5f55f8360830">LaspackMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00409"></a>00409 <span class="keyword"></span>{
<a name="l00410"></a>00410   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00411"></a>00411   
<a name="l00412"></a>00412   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(Q_GetDim(const_cast&lt;QMatrix*&gt;(&amp;_QMat)));
<a name="l00413"></a>00413 }
<a name="l00414"></a>00414 
<a name="l00415"></a>00415 
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00418"></a>00418 <span class="keyword">inline</span>
<a name="l00419"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#ae348ed59082287248036865693ea1d50">00419</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ae348ed59082287248036865693ea1d50">LaspackMatrix&lt;T&gt;::row_start</a> ()<span class="keyword"> const</span>
<a name="l00420"></a>00420 <span class="keyword"></span>{
<a name="l00421"></a>00421   <span class="keywordflow">return</span> 0;
<a name="l00422"></a>00422 }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00427"></a>00427 <span class="keyword">inline</span>
<a name="l00428"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a68f79f057caefe579908478d85b01e87">00428</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a68f79f057caefe579908478d85b01e87">LaspackMatrix&lt;T&gt;::row_stop</a> ()<span class="keyword"> const</span>
<a name="l00429"></a>00429 <span class="keyword"></span>{
<a name="l00430"></a>00430   <span class="keywordflow">return</span> this-&gt;m();
<a name="l00431"></a>00431 }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00436"></a>00436 <span class="keyword">inline</span>
<a name="l00437"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a172581471c559648d3dfa0442066daea">00437</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a172581471c559648d3dfa0442066daea">LaspackMatrix&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00438"></a>00438                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00439"></a>00439                             <span class="keyword">const</span> T value)
<a name="l00440"></a>00440 {
<a name="l00441"></a>00441   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00442"></a>00442   libmesh_assert (i &lt; this-&gt;m());
<a name="l00443"></a>00443   libmesh_assert (j &lt; this-&gt;n());
<a name="l00444"></a>00444   
<a name="l00445"></a>00445   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> position = this-&gt;pos(i,j);
<a name="l00446"></a>00446 
<a name="l00447"></a>00447   <span class="comment">// Sanity check</span>
<a name="l00448"></a>00448   libmesh_assert (*(_row_start[i]+position) == j);
<a name="l00449"></a>00449   libmesh_assert ((j+1) == Q_GetPos (&amp;_QMat, i+1, position));
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   Q_SetEntry (&amp;_QMat, i+1, position, j+1, value);
<a name="l00452"></a>00452 }
<a name="l00453"></a>00453 
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00457"></a>00457 <span class="keyword">inline</span>
<a name="l00458"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac070a9120898c00abc1148f0a7e29a04">00458</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac070a9120898c00abc1148f0a7e29a04">LaspackMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00459"></a>00459                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00460"></a>00460                             <span class="keyword">const</span> T value)
<a name="l00461"></a>00461 {
<a name="l00462"></a>00462   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00463"></a>00463   libmesh_assert (i &lt; this-&gt;m());
<a name="l00464"></a>00464   libmesh_assert (j &lt; this-&gt;n());
<a name="l00465"></a>00465   
<a name="l00466"></a>00466   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> position = this-&gt;pos(i,j);
<a name="l00467"></a>00467 
<a name="l00468"></a>00468   <span class="comment">// Sanity check</span>
<a name="l00469"></a>00469   libmesh_assert (*(_row_start[i]+position) == j);
<a name="l00470"></a>00470 
<a name="l00471"></a>00471   Q_AddVal (&amp;_QMat, i+1, position, value);
<a name="l00472"></a>00472 }
<a name="l00473"></a>00473 
<a name="l00474"></a>00474 
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00477"></a>00477 <span class="keyword">inline</span>
<a name="l00478"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#abcb50f218cb44feed73e3b16fb5df735">00478</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ab194bd4e017ec1627fe6ad9cf693105a">LaspackMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00479"></a>00479                                   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00480"></a>00480 {
<a name="l00481"></a>00481   this-&gt;add_matrix (dm, dof_indices, dof_indices);
<a name="l00482"></a>00482 }
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 
<a name="l00485"></a>00485 
<a name="l00486"></a>00486 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00487"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a9e2130857357badb79c4a0ab793270a2">00487</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#ac070a9120898c00abc1148f0a7e29a04">LaspackMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T a_in, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X_in)
<a name="l00488"></a>00488 {
<a name="l00489"></a>00489   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00490"></a>00490   libmesh_assert (this-&gt;m() == X_in.<a class="code" href="classlibMesh_1_1SparseMatrix.php#ad0f01d9919e7b33f2d614848e494bb44">m</a>());
<a name="l00491"></a>00491   libmesh_assert (this-&gt;n() == X_in.<a class="code" href="classlibMesh_1_1SparseMatrix.php#adf547081169c5a585ea1d7bf816f4edc">n</a>());
<a name="l00492"></a>00492 
<a name="l00493"></a>00493   <a class="code" href="classlibMesh_1_1LaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>* X = libmesh_cast_ptr&lt;LaspackMatrix&lt;T&gt;*&gt; (&amp;X_in);
<a name="l00494"></a>00494   _LPNumber         a = <span class="keyword">static_cast&lt;</span>_LPNumber<span class="keyword">&gt;</span>          (a_in);
<a name="l00495"></a>00495   
<a name="l00496"></a>00496   libmesh_assert(X != NULL);
<a name="l00497"></a>00497   
<a name="l00498"></a>00498   <span class="comment">// loops taken from LaspackMatrix&lt;T&gt;::zero ()</span>
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_rows = this-&gt;m();
<a name="l00501"></a>00501 
<a name="l00502"></a>00502   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> row=0; row&lt;n_rows; row++)
<a name="l00503"></a>00503     {
<a name="l00504"></a>00504       <span class="keyword">const</span> std::vector&lt;unsigned int&gt;::const_iterator
<a name="l00505"></a>00505         r_start = _row_start[row];
<a name="l00506"></a>00506       
<a name="l00507"></a>00507       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> len = (_row_start[row+1] - _row_start[row]);
<a name="l00508"></a>00508 
<a name="l00509"></a>00509       <span class="comment">// Make sure we agree on the row length</span>
<a name="l00510"></a>00510       libmesh_assert (len == Q_GetLen(&amp;_QMat, row+1));
<a name="l00511"></a>00511       <span class="comment">// compare matrix sparsity structures</span>
<a name="l00512"></a>00512       libmesh_assert (len == Q_GetLen(&amp;(X-&gt;_QMat), row+1));
<a name="l00513"></a>00513         
<a name="l00514"></a>00514       
<a name="l00515"></a>00515       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;len; l++)
<a name="l00516"></a>00516         {
<a name="l00517"></a>00517           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j = *(r_start + l);
<a name="l00518"></a>00518 
<a name="l00519"></a>00519           <span class="comment">// Make sure the data structures are working</span>
<a name="l00520"></a>00520           libmesh_assert ((j+1) == Q_GetPos (&amp;_QMat, row+1, l));
<a name="l00521"></a>00521 
<a name="l00522"></a>00522           <span class="keyword">const</span> _LPNumber value = a * Q_GetEl(const_cast&lt;QMatrix*&gt;(&amp;(X-&gt;_QMat)), row+1, j+1);
<a name="l00523"></a>00523           Q_AddVal   (&amp;_QMat, row+1, l, value);
<a name="l00524"></a>00524         }
<a name="l00525"></a>00525     }    
<a name="l00526"></a>00526 }
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00532"></a>00532 <span class="keyword">inline</span>
<a name="l00533"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a59a1472de7277b82650467ff7ecedd84">00533</a> T <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a59a1472de7277b82650467ff7ecedd84">LaspackMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00534"></a>00534                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00535"></a>00535 <span class="keyword"></span>{
<a name="l00536"></a>00536   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00537"></a>00537   libmesh_assert (i &lt; this-&gt;m());
<a name="l00538"></a>00538   libmesh_assert (j &lt; this-&gt;n());
<a name="l00539"></a>00539   
<a name="l00540"></a>00540   <span class="keywordflow">return</span> Q_GetEl (const_cast&lt;QMatrix*&gt;(&amp;_QMat), i+1, j+1);
<a name="l00541"></a>00541 }
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00546"></a>00546 <span class="keyword">inline</span>
<a name="l00547"></a><a class="code" href="classlibMesh_1_1LaspackMatrix.php#a12923461af03da51c15136d29b8443dd">00547</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php#a12923461af03da51c15136d29b8443dd">LaspackMatrix&lt;T&gt;::pos</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00548"></a>00548                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00549"></a>00549 <span class="keyword"></span>{
<a name="l00550"></a>00550   libmesh_assert (i &lt; this-&gt;m());
<a name="l00551"></a>00551   libmesh_assert (j &lt; this-&gt;n());
<a name="l00552"></a>00552   libmesh_assert (i+1 &lt; _row_start.size());
<a name="l00553"></a>00553   libmesh_assert (_row_start.back() == _csr.end());
<a name="l00554"></a>00554 
<a name="l00555"></a>00555   <span class="comment">// note this requires the _csr to be </span>
<a name="l00556"></a>00556   std::pair&lt;std::vector&lt;unsigned int&gt;::const_iterator,
<a name="l00557"></a>00557             std::vector&lt;unsigned int&gt;::const_iterator&gt; p =
<a name="l00558"></a>00558     std::equal_range (_row_start[i],
<a name="l00559"></a>00559                       _row_start[i+1],
<a name="l00560"></a>00560                       j);
<a name="l00561"></a>00561 
<a name="l00562"></a>00562   <span class="comment">// Make sure the row contains the element j</span>
<a name="l00563"></a>00563   libmesh_assert (p.first != p.second);
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="comment">// Make sure the values match</span>
<a name="l00566"></a>00566   libmesh_assert (*p.first == j);
<a name="l00567"></a>00567 
<a name="l00568"></a>00568   <span class="comment">// Return the position in the compressed row</span>
<a name="l00569"></a>00569   <span class="keywordflow">return</span> std::distance (_row_start[i], p.first);
<a name="l00570"></a>00570 }
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 } <span class="comment">// namespace libMesh</span>
<a name="l00574"></a>00574 
<a name="l00575"></a>00575 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00576"></a>00576 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __laspack_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
