<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">laspack_vector.C</div>  </div>
</div>
<div class="contents">
<a href="laspack__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: laspack_vector.C 4286 2011-03-24 03:55:50Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::min</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="dense__subvector_8h.php">dense_subvector.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="laspack__vector_8h.php">laspack_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="laspack__matrix_8h.php">laspack_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00039"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a2844ed35c0bdbcb7b186643f28642bb6">00039</a> T <a class="code" href="classlibMesh_1_1LaspackVector.php#a2844ed35c0bdbcb7b186643f28642bb6">LaspackVector&lt;T&gt;::sum</a> ()<span class="keyword"> const</span>
<a name="l00040"></a>00040 <span class="keyword"></span>{
<a name="l00041"></a>00041   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00042"></a>00042 
<a name="l00043"></a>00043   T _sum = 0;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00046"></a>00046   
<a name="l00047"></a>00047   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=n; ++i)
<a name="l00048"></a>00048     _sum += (*<span class="keyword">this</span>)(i);
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keywordflow">return</span> _sum;
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00056"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a3d9ababc006523e6281049f1012e3142">00056</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a3d9ababc006523e6281049f1012e3142">LaspackVector&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00057"></a>00057 <span class="keyword"></span>{
<a name="l00058"></a>00058   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00059"></a>00059   
<a name="l00060"></a>00060   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(l1Norm_V(const_cast&lt;QVector*&gt;(&amp;_vec)));
<a name="l00061"></a>00061 }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00066"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#afbe684bcc60e28d4d4877e67f52c8827">00066</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#afbe684bcc60e28d4d4877e67f52c8827">LaspackVector&lt;T&gt;::l2_norm</a> ()<span class="keyword"> const</span>
<a name="l00067"></a>00067 <span class="keyword"></span>{
<a name="l00068"></a>00068   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00069"></a>00069   
<a name="l00070"></a>00070   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(l2Norm_V(const_cast&lt;QVector*&gt;(&amp;_vec)));
<a name="l00071"></a>00071 }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00076"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a2d2a328f49e370990131ef76488384a9">00076</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a2d2a328f49e370990131ef76488384a9">LaspackVector&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00077"></a>00077 <span class="keyword"></span>{
<a name="l00078"></a>00078   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00079"></a>00079   
<a name="l00080"></a>00080   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(MaxNorm_V(const_cast&lt;QVector*&gt;(&amp;_vec)));
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00086"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a74a07f8ee5bde5d4e2de57c209f4e9c1">00086</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1LaspackVector.php#a74a07f8ee5bde5d4e2de57c209f4e9c1">LaspackVector&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00087"></a>00087 {
<a name="l00088"></a>00088   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00089"></a>00089   
<a name="l00090"></a>00090   this-&gt;add(1., v);
<a name="l00091"></a>00091   
<a name="l00092"></a>00092   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00099"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#aafa446669afcb48086bd1d66de2c1e02">00099</a> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <a class="code" href="classlibMesh_1_1LaspackVector.php#aafa446669afcb48086bd1d66de2c1e02">LaspackVector&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00100"></a>00100 {
<a name="l00101"></a>00101   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00102"></a>00102   
<a name="l00103"></a>00103   this-&gt;add(-1., v);
<a name="l00104"></a>00104   
<a name="l00105"></a>00105   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00106"></a>00106 }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00111"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a8fb86fd385a82948149fba0de206df25">00111</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af592bfcb95ac2c4d4ed838b53cd4d85b">LaspackVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T v)
<a name="l00112"></a>00112 {
<a name="l00113"></a>00113   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00114"></a>00114   
<a name="l00115"></a>00115   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00116"></a>00116     this-&gt;add (i, v);
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00123"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a2cb1bc09f311532d005bf949a953421d">00123</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af592bfcb95ac2c4d4ed838b53cd4d85b">LaspackVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00124"></a>00124 {
<a name="l00125"></a>00125   this-&gt;add (1., v);
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00131"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a125d3395114bbef3dff84ad2c60ea876">00131</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af592bfcb95ac2c4d4ed838b53cd4d85b">LaspackVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00132"></a>00132 {
<a name="l00133"></a>00133   <span class="comment">// Make sure the vector passed in is really a LaspackVector</span>
<a name="l00134"></a>00134   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector</a>* v = libmesh_cast_ptr&lt;const LaspackVector*&gt;(&amp;v_in);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   libmesh_assert (v != NULL);
<a name="l00137"></a>00137   libmesh_assert (this-&gt;size() == v-&gt;<a class="code" href="classlibMesh_1_1LaspackVector.php#a16818eaac051881a87730496cbb51d2d">size</a>());
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v-&gt;<a class="code" href="classlibMesh_1_1LaspackVector.php#a16818eaac051881a87730496cbb51d2d">size</a>(); i++)
<a name="l00140"></a>00140     this-&gt;add (i, a*(*v)(i));
<a name="l00141"></a>00141 }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a44c85caff4b677fd91f26875f4f24c5f">00146</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a44c85caff4b677fd91f26875f4f24c5f">LaspackVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00147"></a>00147                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00148"></a>00148 {
<a name="l00149"></a>00149   libmesh_assert (!v.empty());
<a name="l00150"></a>00150   libmesh_assert (v.size() == dof_indices.size());
<a name="l00151"></a>00151   
<a name="l00152"></a>00152   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00153"></a>00153     this-&gt;add (dof_indices[i], v[i]);
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00159"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a97a4962f7d4e7a5fcffdc949be1defe0">00159</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a44c85caff4b677fd91f26875f4f24c5f">LaspackVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00160"></a>00160                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00161"></a>00161 {
<a name="l00162"></a>00162   libmesh_assert (V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>() == dof_indices.size());
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(); i++)
<a name="l00165"></a>00165     this-&gt;add (dof_indices[i], V(i));
<a name="l00166"></a>00166 }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00171"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a80c98d5640172be041835171cf61570f">00171</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a44c85caff4b677fd91f26875f4f24c5f">LaspackVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00172"></a>00172                                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00173"></a>00173 {
<a name="l00174"></a>00174   libmesh_assert (V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == dof_indices.size());
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l00177"></a>00177     this-&gt;add (dof_indices[i], V(i));
<a name="l00178"></a>00178 }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00183"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a845600858cd7eaff4d57cf2dfdde6ee4">00183</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a845600858cd7eaff4d57cf2dfdde6ee4">LaspackVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00184"></a>00184                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00185"></a>00185 {
<a name="l00186"></a>00186   libmesh_assert (!v.empty());
<a name="l00187"></a>00187   libmesh_assert (v.size() == dof_indices.size());
<a name="l00188"></a>00188   
<a name="l00189"></a>00189   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00190"></a>00190     this-&gt;<span class="keyword">set</span> (dof_indices[i], v[i]);
<a name="l00191"></a>00191 }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00196"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a551fac2327288a37ca44f86d308d2a4a">00196</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a845600858cd7eaff4d57cf2dfdde6ee4">LaspackVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00197"></a>00197                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00198"></a>00198 {
<a name="l00199"></a>00199   libmesh_assert (V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>() == dof_indices.size());
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(); i++)
<a name="l00202"></a>00202    this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00203"></a>00203 }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00208"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a2ff5fed2c20115207edf04f8b3e31495">00208</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a845600858cd7eaff4d57cf2dfdde6ee4">LaspackVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00209"></a>00209                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00210"></a>00210 {
<a name="l00211"></a>00211   libmesh_assert (V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == dof_indices.size());
<a name="l00212"></a>00212 
<a name="l00213"></a>00213   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l00214"></a>00214     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00220"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#acd6cca00386be1fc2e578b65437fc167">00220</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a845600858cd7eaff4d57cf2dfdde6ee4">LaspackVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00221"></a>00221                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00222"></a>00222 {
<a name="l00223"></a>00223   libmesh_assert (V.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>() == dof_indices.size());
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>(); i++)
<a name="l00226"></a>00226     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00232"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#ae08f42171508b7134b41003ba6c12cb4">00232</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a44c85caff4b677fd91f26875f4f24c5f">LaspackVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;vec_in,
<a name="l00233"></a>00233                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;mat_in)
<a name="l00234"></a>00234 {
<a name="l00235"></a>00235   <span class="comment">// Make sure the data passed in are really in Laspack types</span>
<a name="l00236"></a>00236   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>* vec = libmesh_cast_ptr&lt;const LaspackVector&lt;T&gt;*&gt;(&amp;vec_in);
<a name="l00237"></a>00237   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LaspackMatrix.php">LaspackMatrix&lt;T&gt;</a>* mat = libmesh_cast_ptr&lt;const LaspackMatrix&lt;T&gt;*&gt;(&amp;mat_in);
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   libmesh_assert (vec != NULL);
<a name="l00240"></a>00240   libmesh_assert (mat != NULL);
<a name="l00241"></a>00241   
<a name="l00242"></a>00242   <span class="comment">// += mat*vec</span>
<a name="l00243"></a>00243   AddAsgn_VV (&amp;_vec, Mul_QV(const_cast&lt;QMatrix*&gt;(&amp;mat-&gt;_QMat),
<a name="l00244"></a>00244                             const_cast&lt;QVector*&gt;(&amp;vec-&gt;<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>)));
<a name="l00245"></a>00245 }
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00249"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a75824f0a8e65e209a959f1313b911940">00249</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a75824f0a8e65e209a959f1313b911940">LaspackVector&lt;T&gt;::add_vector_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;,
<a name="l00250"></a>00250                                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;)
<a name="l00251"></a>00251 {
<a name="l00252"></a>00252   libmesh_not_implemented();
<a name="l00253"></a>00253 }
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00258"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a941759ff0417c321a2b923cf8ce515c3">00258</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#a941759ff0417c321a2b923cf8ce515c3">LaspackVector&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor)
<a name="l00259"></a>00259 {
<a name="l00260"></a>00260   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00261"></a>00261   
<a name="l00262"></a>00262   Mul_SV (factor, &amp;_vec);
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00266"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#aa85a4f80f71a924874ca97035f0c1871">00266</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#aa85a4f80f71a924874ca97035f0c1871">LaspackVector&lt;T&gt;::abs</a>()
<a name="l00267"></a>00267 {
<a name="l00268"></a>00268   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00271"></a>00271   
<a name="l00272"></a>00272   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=n; ++i)
<a name="l00273"></a>00273     this-&gt;<span class="keyword">set</span>(i,std::abs((*<span class="keyword">this</span>)(i)));
<a name="l00274"></a>00274 }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00277"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a266c47943c73c1b8d7443bf4bbf15f84">00277</a> T <a class="code" href="classlibMesh_1_1LaspackVector.php#a266c47943c73c1b8d7443bf4bbf15f84">LaspackVector&lt;T&gt;::dot</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V)<span class="keyword"> const</span>
<a name="l00278"></a>00278 <span class="keyword"></span>{
<a name="l00279"></a>00279   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="comment">// Make sure the NumericVector passed in is really a LaspackVector</span>
<a name="l00282"></a>00282   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const LaspackVector&lt;T&gt;*&gt;(&amp;V);
<a name="l00283"></a>00283   libmesh_assert (v != NULL);
<a name="l00284"></a>00284   
<a name="l00285"></a>00285   <span class="keywordflow">return</span> Mul_VV (const_cast&lt;QVector*&gt;(&amp;(this-&gt;_vec)),
<a name="l00286"></a>00286                  const_cast&lt;QVector*&gt;(&amp;(v-&gt;<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>)));
<a name="l00287"></a>00287 }
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00292"></a>00292 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; 
<a name="l00293"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a5b4647ebc33d010ef6f10e38d30ca18f">00293</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a5b4647ebc33d010ef6f10e38d30ca18f">LaspackVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> T s)
<a name="l00294"></a>00294 {
<a name="l00295"></a>00295   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00296"></a>00296 
<a name="l00297"></a>00297   V_SetAllCmp (&amp;_vec, s);
<a name="l00298"></a>00298   
<a name="l00299"></a>00299   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00300"></a>00300 }
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00305"></a>00305 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00306"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#ada4957985cccd79d47dbcf48dc50c03c">00306</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a5b4647ebc33d010ef6f10e38d30ca18f">LaspackVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00307"></a>00307 {
<a name="l00308"></a>00308   <span class="comment">// Make sure the NumericVector passed in is really a LaspackVector</span>
<a name="l00309"></a>00309   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>* v =
<a name="l00310"></a>00310     libmesh_cast_ptr&lt;const LaspackVector&lt;T&gt;*&gt;(&amp;v_in);
<a name="l00311"></a>00311 
<a name="l00312"></a>00312   libmesh_assert (v != NULL);
<a name="l00313"></a>00313   
<a name="l00314"></a>00314   *<span class="keyword">this</span> = *v;
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00317"></a>00317 }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00322"></a>00322 <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>&amp;
<a name="l00323"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#af92ee8e62cfe32b9fa5f27ab15e34cf7">00323</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a5b4647ebc33d010ef6f10e38d30ca18f">LaspackVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>&amp; v)
<a name="l00324"></a>00324 {
<a name="l00325"></a>00325   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00326"></a>00326   libmesh_assert (this-&gt;size() == v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a16818eaac051881a87730496cbb51d2d">size</a>());
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   this-&gt;_is_closed = v.<a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a>;
<a name="l00329"></a>00329 
<a name="l00330"></a>00330   <span class="keywordflow">if</span> (v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a16818eaac051881a87730496cbb51d2d">size</a>() != 0)    
<a name="l00331"></a>00331     Asgn_VV (const_cast&lt;QVector*&gt;(&amp;_vec),
<a name="l00332"></a>00332              <span class="keyword">const_cast&lt;</span>QVector*<span class="keyword">&gt;</span>(&amp;v.<a class="code" href="classlibMesh_1_1LaspackVector.php#a14bd0f053f3c627cbf2eca452886ed6f">_vec</a>)
<a name="l00333"></a>00333              );
<a name="l00334"></a>00334   
<a name="l00335"></a>00335   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00336"></a>00336 }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00341"></a>00341 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00342"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a709151a01a837c0a8a0be8b32cef03af">00342</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a5b4647ebc33d010ef6f10e38d30ca18f">LaspackVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v)
<a name="l00343"></a>00343 {
<a name="l00348"></a>00348   <span class="keywordflow">if</span> (this-&gt;size() == v.size())      
<a name="l00349"></a>00349     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00350"></a>00350       this-&gt;<span class="keyword">set</span> (i, v[i]);
<a name="l00351"></a>00351   
<a name="l00352"></a>00352   <span class="keywordflow">else</span>
<a name="l00353"></a>00353     libmesh_error();
<a name="l00354"></a>00354 
<a name="l00355"></a>00355   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00356"></a>00356 }
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00360"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a73cb5462f802e8ecc093730aa2b05168">00360</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af62ffbe8e6d6db31fa435729d517f125">LaspackVector&lt;T&gt;::localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in)<span class="keyword"> const</span>
<a name="l00361"></a>00361 <span class="keyword"></span>{
<a name="l00362"></a>00362   <span class="comment">// Make sure the NumericVector passed in is really a LaspackVector</span>
<a name="l00363"></a>00363   <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>* v_local =
<a name="l00364"></a>00364     libmesh_cast_ptr&lt;LaspackVector&lt;T&gt;*&gt;(&amp;v_local_in);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   libmesh_assert (v_local != NULL);
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   *v_local = *<span class="keyword">this</span>;
<a name="l00369"></a>00369 }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00374"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a90d021f56c85cb54b2e5f00a88e67a24">00374</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af62ffbe8e6d6db31fa435729d517f125">LaspackVector&lt;T&gt;::localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in,
<a name="l00375"></a>00375                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list)<span class="keyword"> const</span>
<a name="l00376"></a>00376 <span class="keyword"></span>{
<a name="l00377"></a>00377   <span class="comment">// Make sure the NumericVector passed in is really a LaspackVector</span>
<a name="l00378"></a>00378   <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>* v_local =
<a name="l00379"></a>00379     libmesh_cast_ptr&lt;LaspackVector&lt;T&gt;*&gt;(&amp;v_local_in);
<a name="l00380"></a>00380 
<a name="l00381"></a>00381   libmesh_assert (v_local != NULL);
<a name="l00382"></a>00382   libmesh_assert (send_list.size() &lt;= v_local-&gt;<a class="code" href="classlibMesh_1_1LaspackVector.php#a16818eaac051881a87730496cbb51d2d">size</a>());
<a name="l00383"></a>00383 
<a name="l00384"></a>00384   *v_local = *<span class="keyword">this</span>;
<a name="l00385"></a>00385 }
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00390"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a3a5de58bf789ca7747dcca15417b45e0">00390</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af62ffbe8e6d6db31fa435729d517f125">LaspackVector&lt;T&gt;::localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00391"></a>00391                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00392"></a>00392                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list)
<a name="l00393"></a>00393 {
<a name="l00394"></a>00394   libmesh_assert (first_local_idx  == 0);
<a name="l00395"></a>00395   libmesh_assert (last_local_idx+1 == this-&gt;size());
<a name="l00396"></a>00396   
<a name="l00397"></a>00397   libmesh_assert (send_list.size() &lt;= this-&gt;size());
<a name="l00398"></a>00398 }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00403"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#af62ffbe8e6d6db31fa435729d517f125">00403</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#af62ffbe8e6d6db31fa435729d517f125">LaspackVector&lt;T&gt;::localize</a> (std::vector&lt;T&gt;&amp; v_local)<span class="keyword"> const</span>
<a name="l00404"></a>00404 <span class="keyword"></span>
<a name="l00405"></a>00405 <span class="keyword"></span>{
<a name="l00406"></a>00406   v_local.resize(this-&gt;size());
<a name="l00407"></a>00407 
<a name="l00408"></a>00408   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v_local.size(); i++)
<a name="l00409"></a>00409     v_local[i] = (*<span class="keyword">this</span>)(i);  
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00415"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#ae4616ceb29f0804ca1070f29338c2ebe">00415</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#ae4616ceb29f0804ca1070f29338c2ebe">LaspackVector&lt;T&gt;::localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00416"></a>00416                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)<span class="keyword"> const</span>
<a name="l00417"></a>00417 <span class="keyword"></span>{
<a name="l00418"></a>00418   libmesh_assert (pid == 0);
<a name="l00419"></a>00419 
<a name="l00420"></a>00420   this-&gt;localize (v_local);
<a name="l00421"></a>00421 }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00426"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#ac73f389f54ce899f77fc757b407a9825">00426</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaspackVector.php#ac73f389f54ce899f77fc757b407a9825">LaspackVector&lt;T&gt;::pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/*vec1*/</span>,
<a name="l00427"></a>00427                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; <span class="comment">/*vec2*/</span>)
<a name="l00428"></a>00428 {
<a name="l00429"></a>00429   libmesh_not_implemented();
<a name="l00430"></a>00430 }
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00435"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a916d953c9c086fab573f55c2e795ee3a">00435</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a916d953c9c086fab573f55c2e795ee3a">LaspackVector&lt;T&gt;::max</a>()<span class="keyword"> const</span>
<a name="l00436"></a>00436 <span class="keyword"></span>{
<a name="l00437"></a>00437   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00438"></a>00438   <span class="keywordflow">if</span> (!this-&gt;size())
<a name="l00439"></a>00439     <span class="keywordflow">return</span> -<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>();
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a> = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(0));
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00444"></a>00444   
<a name="l00445"></a>00445   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;n; i++)
<a name="l00446"></a>00446     max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (max, <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(i)));
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>;
<a name="l00449"></a>00449 }
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; 
<a name="l00454"></a><a class="code" href="classlibMesh_1_1LaspackVector.php#a9cb1ea8c887c62e9e74d150548cf2998">00454</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1LaspackVector.php#a9cb1ea8c887c62e9e74d150548cf2998">LaspackVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l00455"></a>00455 <span class="keyword"></span>{
<a name="l00456"></a>00456   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00457"></a>00457   <span class="keywordflow">if</span> (!this-&gt;size())
<a name="l00458"></a>00458     <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>();
<a name="l00459"></a>00459 
<a name="l00460"></a>00460   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a> = <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(0));
<a name="l00461"></a>00461 
<a name="l00462"></a>00462   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00463"></a>00463   
<a name="l00464"></a>00464   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;n; i++)
<a name="l00465"></a>00465     min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (min, <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>((*<span class="keyword">this</span>)(i)));
<a name="l00466"></a>00466 
<a name="l00467"></a>00467   <span class="keywordflow">return</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>;
<a name="l00468"></a>00468 }
<a name="l00469"></a>00469 
<a name="l00470"></a>00470 
<a name="l00471"></a>00471 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00472"></a>00472 <span class="comment">// Explicit instantiations</span>
<a name="l00473"></a>00473 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;Number&gt;</a>;
<a name="l00474"></a>00474 
<a name="l00475"></a>00475 } <span class="comment">// namespace libMesh</span>
<a name="l00476"></a>00476  
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LASPACK</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
