<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">legacy_xdr_io.h</div>  </div>
</div>
<div class="contents">
<a href="legacy__xdr__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: legacy_xdr_io.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __legacy_xdr_io_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __legacy_xdr_io_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span>MeshBase;
<a name="l00037"></a>00037 <span class="keyword">class </span>MeshData;
<a name="l00038"></a>00038 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// LegacyXdrIO class definition</span>
<a name="l00046"></a><a class="code" href="classlibMesh_1_1LegacyXdrIO.php">00046</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LegacyXdrIO.php">LegacyXdrIO</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;MeshBase&gt;,
<a name="l00047"></a>00047                     <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 
<a name="l00050"></a>00050  <span class="keyword">public</span>:
<a name="l00058"></a><a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cba58605e1d65accdfed3fe439ccf3ba2cc">00058</a>    <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">FileFormat</a> {<a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cba6d96e003c93b90ea62108271a7081c4a">DEAL</a>=0, <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cba58605e1d65accdfed3fe439ccf3ba2cc">MGF</a>=1, <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LIBM</a>=2};
<a name="l00059"></a>00059 
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#ad13b788647c0dd6793db18edf0c37c71">LegacyXdrIO</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;,       <span class="keyword">const</span> <span class="keywordtype">bool</span>=<span class="keyword">false</span>);
<a name="l00068"></a>00068 
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#ad13b788647c0dd6793db18edf0c37c71">LegacyXdrIO</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span>=<span class="keyword">false</span>);
<a name="l00077"></a>00077   
<a name="l00081"></a>00081   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#af1623ad5ce0ab8eedbd1b3eee3430374">~LegacyXdrIO</a> ();
<a name="l00082"></a>00082   
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a96f24341c29ad681e085602b4eef8d8c">read</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00087"></a>00087   
<a name="l00092"></a>00092   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a124ef647d54bd059210280d83f92454b">read_mgf</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00093"></a>00093   
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a98b2756756a27ab7a9239f890a6f9b3e">write</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00098"></a>00098   
<a name="l00103"></a>00103   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#ad9aa839693c3022d920a6518f767cc2c">write_mgf</a> (<span class="keyword">const</span> std::string&amp;);
<a name="l00104"></a>00104     
<a name="l00115"></a>00115   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#ab0046f918dc527ac330c74451c0eb8fd">read_mgf_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00116"></a>00116                       std::vector&lt;Number&gt;&amp; soln,
<a name="l00117"></a>00117                       std::vector&lt;std::string&gt;&amp; var_names) <span class="keyword">const</span>;
<a name="l00118"></a>00118     
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a50f006bb1da681cb01c86b105fc110d7">write_mgf_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00129"></a>00129                        std::vector&lt;Number&gt;&amp; soln,
<a name="l00130"></a>00130                        std::vector&lt;std::string&gt;&amp; var_names) <span class="keyword">const</span>;  
<a name="l00131"></a>00131 
<a name="l00135"></a>00135   <span class="keywordtype">bool</span> &amp; <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#abe8e6df71f4f56829327a8bbe9e308af">binary</a>();
<a name="l00136"></a>00136 
<a name="l00140"></a>00140   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#abe8e6df71f4f56829327a8bbe9e308af">binary</a>() <span class="keyword">const</span>;
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   
<a name="l00143"></a>00143  <span class="keyword">private</span>:
<a name="l00144"></a>00144 
<a name="l00151"></a>00151   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#aa96f9fa3ee7cc7b9a44a0e8265e930ee">read_ascii</a> (<span class="keyword">const</span> std::string&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> = <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LegacyXdrIO::LIBM</a>);
<a name="l00152"></a>00152 
<a name="l00159"></a>00159   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#afff255e4b826679a64f3809932f2a15e">read_binary</a> (<span class="keyword">const</span> std::string&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> = <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LegacyXdrIO::LIBM</a>);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   
<a name="l00162"></a>00162   
<a name="l00172"></a>00172   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a977e7813abcca06c1aef20918b1b5b76">write_ascii</a> (<span class="keyword">const</span> std::string&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> = <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LegacyXdrIO::LIBM</a>);
<a name="l00173"></a>00173 
<a name="l00180"></a>00180   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a6c0193a7ac9426da1320b69fb69306dd">write_binary</a> (<span class="keyword">const</span> std::string&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> = <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LegacyXdrIO::LIBM</a>);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00186"></a>00186   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a2156cf3e82d33ac27c10242e956dc289">read_mesh</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00187"></a>00187                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> = <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LegacyXdrIO::LIBM</a>,
<a name="l00188"></a>00188                   <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* = NULL);
<a name="l00189"></a>00189 
<a name="l00193"></a>00193   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#aee5c045197a9d643486855c2c0c92f89">write_mesh</a> (<span class="keyword">const</span> std::string&amp;,
<a name="l00194"></a>00194                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cb">LegacyXdrIO::FileFormat</a> = <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a861802c784c080cd34507835ff61d9cbafa77b52541ae8714f02d33797c0763ff">LegacyXdrIO::LIBM</a>);
<a name="l00195"></a>00195 
<a name="l00199"></a>00199   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a5b4715c0a91bd1f9357c103459048ec4">read_soln</a>  (<span class="keyword">const</span> std::string&amp;,
<a name="l00200"></a>00200                    std::vector&lt;Real&gt;&amp;,
<a name="l00201"></a>00201                    std::vector&lt;std::string&gt;&amp;) <span class="keyword">const</span>;
<a name="l00202"></a>00202   
<a name="l00206"></a>00206   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#a5f731657657ebeb2c9cbf286e24db714">write_soln</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00207"></a>00207                    std::vector&lt;Real&gt;&amp; soln,
<a name="l00208"></a>00208                    std::vector&lt;std::string&gt;&amp;) <span class="keyword">const</span>;
<a name="l00209"></a>00209 
<a name="l00210"></a>00210   <span class="comment">//-------------------------------------------------------------</span>
<a name="l00211"></a>00211   <span class="comment">// local data</span>
<a name="l00212"></a>00212 
<a name="l00216"></a><a class="code" href="classlibMesh_1_1LegacyXdrIO.php#addc7647de85fc54d65d610dc4e407f01">00216</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LegacyXdrIO.php#addc7647de85fc54d65d610dc4e407f01">_binary</a>;
<a name="l00217"></a>00217 };
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 } <span class="comment">// namespace libMesh</span>
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 <span class="preprocessor">#endif // #define __legacy_xdr_io.h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
