<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">libmesh.h</div>  </div>
</div>
<div class="contents">
<a href="libmesh_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: libmesh.h 4219 2011-03-02 20:38:14Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __libmesh_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __libmesh_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__base_8h.php">libmesh_base.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="enum__solver__package_8h.php">enum_solver_package.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>libMesh
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1LibMeshInit.php">00057</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LibMeshInit.php">LibMeshInit</a>
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1LibMeshInit.php#a6cc460ae7fbdbd431df558779cd101a1">LibMeshInit</a>(<span class="keywordtype">int</span> &amp; argc, <span class="keywordtype">char</span>** &amp; <a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">argv</a>,
<a name="l00069"></a>00069               MPI_Comm COMM_WORLD_IN=MPI_COMM_WORLD);
<a name="l00070"></a>00070 <span class="preprocessor">#else</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1LibMeshInit.php#a6cc460ae7fbdbd431df558779cd101a1">LibMeshInit</a>(<span class="keywordtype">int</span> &amp; argc, <span class="keywordtype">char</span>** &amp; argv);
<a name="l00072"></a>00072 <span class="preprocessor">#endif</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>        
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1LibMeshInit.php#ace3b4148c438bc97e156a65ed9fa793c">~LibMeshInit</a>();
<a name="l00075"></a>00075 };
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="preprocessor">#ifndef LIBMESH_HAVE_MPI</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>  
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> (<span class="keywordtype">int</span> &amp; argc, <span class="keywordtype">char</span>** &amp; <a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">argv</a>);
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="preprocessor">#else</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>  
<a name="l00101"></a>00101   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> (<span class="keywordtype">int</span> &amp; argc, <span class="keywordtype">char</span>** &amp; <a class="code" href="namespacelibMesh.php#a417881714cb540579a186977f22143a2">argv</a>,
<a name="l00102"></a>00102              MPI_Comm COMM_WORLD_IN=MPI_COMM_WORLD);
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="preprocessor">#endif</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span>
<a name="l00112"></a>00112   <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a> ();
<a name="l00113"></a>00113   
<a name="l00126"></a>00126   <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a> ();
<a name="l00127"></a>00127 
<a name="l00134"></a>00134   <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a> ();
<a name="l00135"></a>00135   
<a name="l00140"></a>00140   <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#ad19739ed0fdd45f048901a13954369b6">on_command_line</a> (<span class="keyword">const</span> std::string&amp; arg);  
<a name="l00141"></a>00141 
<a name="l00146"></a>00146   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00147"></a>00147   T <a class="code" href="namespacelibMesh.php#a7cbd0ce3d26eb45284882fed440b2a09">command_line_value</a> (<span class="keyword">const</span> std::string &amp;, T);  
<a name="l00148"></a>00148 
<a name="l00152"></a>00152 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>  <span class="keyword">extern</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="namespacelibMesh.php#aa2cea1b0dff98dcda202f98174e7135d">imaginary</a>;
<a name="l00154"></a>00154 <span class="preprocessor">#endif</span>
<a name="l00155"></a>00155 <span class="preprocessor"></span>
<a name="l00164"></a>00164   <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">default_solver_package</a> ();
<a name="l00165"></a>00165 
<a name="l00169"></a><a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">00169</a>   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a> = 3.1415926535897932384626433832795029L;
<a name="l00170"></a>00170 
<a name="l00174"></a><a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">00174</a>   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> = 0.;
<a name="l00175"></a>00175 
<a name="l00180"></a><a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">00180</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(-1);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 } <span class="comment">// namespace libMesh</span>
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 <span class="preprocessor">#endif // #define __libmesh_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
