<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">libmesh_common.h</div>  </div>
</div>
<div class="contents">
<a href="libmesh__common_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: libmesh_common.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __libmesh_common_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __libmesh_common_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// The library configuration options</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Include the MPI definition</span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor"># include &lt;mpi.h&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="comment">// C/C++ includes everyone should know about</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;fstream&gt;</span> <span class="comment">// needed for argument to print_trace()</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &lt;unistd.h&gt;</span>  <span class="comment">// needed for getpid()</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &lt;complex&gt;</span>
<a name="l00038"></a>00038 <span class="comment">// #include &lt;cassert&gt;  // Use libmesh_assert() now</span>
<a name="l00039"></a>00039 <span class="preprocessor">#ifdef LIBMESH_HAVE_CSIGNAL</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;csignal&gt;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#endif</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#ifdef LIBMESH_HAVE_STDLIB_H</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor"># include &lt;cstdlib&gt;</span>
<a name="l00044"></a>00044 <span class="preprocessor">#endif</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#include &lt;typeinfo&gt;</span> <span class="comment">// std::bad_cast</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">// _basic_ library functionality</span>
<a name="l00048"></a>00048 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__base_8h.php">libmesh_base.h</a>&quot;</span>
<a name="l00049"></a>00049 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__exceptions_8h.php">libmesh_exceptions.h</a>&quot;</span>
<a name="l00050"></a>00050 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00051"></a>00051 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__C__isnan_8h.php">libmesh_C_isnan.h</a>&quot;</span>
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// Proxy class for libMesh::out/err output</span>
<a name="l00055"></a>00055 <span class="preprocessor">#include &quot;<a class="code" href="ostream__proxy_8h.php">ostream_proxy.h</a>&quot;</span>
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="preprocessor">#ifdef LIBMESH_ENABLE_TRACEFILES</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;<a class="code" href="print__trace_8h.php">print_trace.h</a>&quot;</span>
<a name="l00059"></a>00059 <span class="preprocessor">#endif</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>
<a name="l00061"></a>00061 <span class="comment">// For some reason the real std::max, std::min</span>
<a name="l00062"></a>00062 <span class="comment">// don&#39;t handle mixed compatible types</span>
<a name="l00063"></a><a class="code" href="namespacestd.php">00063</a> <span class="keyword">namespace </span>std {
<a name="l00064"></a><a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">00064</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span> a, <span class="keywordtype">double</span> b)
<a name="l00065"></a>00065   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00066"></a><a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">00066</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span> a, <span class="keywordtype">double</span> b)
<a name="l00067"></a>00067   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00068"></a>00068 
<a name="l00069"></a><a class="code" href="namespacestd.php#a33d9bf3e5ca74fc83b90511e690984b8">00069</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">double</span> a, <span class="keywordtype">long</span> <span class="keywordtype">double</span> b)
<a name="l00070"></a>00070   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00071"></a><a class="code" href="namespacestd.php#ae3946667b8ebc6ec27bd5e0efa1d9737">00071</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">double</span> a, <span class="keywordtype">long</span> <span class="keywordtype">double</span> b)
<a name="l00072"></a>00072   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00073"></a>00073 
<a name="l00074"></a><a class="code" href="namespacestd.php#ac84527deb5aca9e85f8329d851955e79">00074</a>   <span class="keyword">inline</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">double</span> a, <span class="keywordtype">float</span> b)
<a name="l00075"></a>00075   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00076"></a><a class="code" href="namespacestd.php#a6607fe77c40dd42e1ebf2d57bf13b959">00076</a>   <span class="keyword">inline</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">double</span> a, <span class="keywordtype">float</span> b)
<a name="l00077"></a>00077   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="namespacestd.php#ac7d047890b66decdabc8b0dbd592601f">00079</a>   <span class="keyword">inline</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">float</span> a, <span class="keywordtype">double</span> b)
<a name="l00080"></a>00080   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00081"></a><a class="code" href="namespacestd.php#a0ae76aafe42e114852df0231e865e058">00081</a>   <span class="keyword">inline</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">float</span> a, <span class="keywordtype">double</span> b)
<a name="l00082"></a>00082   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="namespacestd.php#a79b5de6915f33bf1a3bfc7fbaed59522">00084</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span> a, <span class="keywordtype">float</span> b)
<a name="l00085"></a>00085   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00086"></a><a class="code" href="namespacestd.php#a004c7feab71987219d4a4c0674626533">00086</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span> a, <span class="keywordtype">float</span> b)
<a name="l00087"></a>00087   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="namespacestd.php#a534434eadd7a712522181b7901b1d797">00089</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(<span class="keywordtype">float</span> a, <span class="keywordtype">long</span> <span class="keywordtype">double</span> b)
<a name="l00090"></a>00090   { <span class="keywordflow">return</span> (a&gt;b?a:b); }
<a name="l00091"></a><a class="code" href="namespacestd.php#a3957c2be1f5ac7339eb933c8cbcf41e0">00091</a>   <span class="keyword">inline</span> <span class="keywordtype">long</span> <span class="keywordtype">double</span> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(<span class="keywordtype">float</span> a, <span class="keywordtype">long</span> <span class="keywordtype">double</span> b)
<a name="l00092"></a>00092   { <span class="keywordflow">return</span> (a&lt;b?a:b); }
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="keyword">namespace </span>libMesh
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 <span class="comment">// Undefine any existing macros</span>
<a name="l00103"></a>00103 <span class="preprocessor">#ifdef Real</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span><span class="preprocessor">#  undef Real</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>
<a name="l00107"></a>00107 <span class="comment">//#ifdef REAL</span>
<a name="l00108"></a>00108 <span class="comment">//#  undef REAL</span>
<a name="l00109"></a>00109 <span class="comment">//#endif</span>
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="preprocessor">#ifdef Complex</span>
<a name="l00112"></a>00112 <span class="preprocessor"></span><span class="preprocessor">#  undef Complex</span>
<a name="l00113"></a>00113 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00114"></a>00114 <span class="preprocessor"></span>
<a name="l00115"></a>00115 <span class="preprocessor">#ifdef COMPLEX</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span><span class="preprocessor">#  undef COMPLEX</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>
<a name="l00119"></a>00119 <span class="preprocessor">#ifdef MPI_REAL</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span><span class="preprocessor">#  undef MPI_REAL</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00122"></a>00122 <span class="preprocessor"></span>
<a name="l00123"></a>00123 <span class="comment">// Check to see if TOLERANCE has been defined by another</span>
<a name="l00124"></a>00124 <span class="comment">// package, if so we might want to change the name...</span>
<a name="l00125"></a>00125 <span class="preprocessor">#ifdef TOLERANCE</span>
<a name="l00126"></a>00126 <span class="preprocessor"></span>   DIE A HORRIBLE DEATH HERE...
<a name="l00127"></a>00127 #  undef TOLERANCE
<a name="l00128"></a>00128 <span class="preprocessor">#endif</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00130"></a>00130 
<a name="l00131"></a>00131    
<a name="l00132"></a>00132 <span class="comment">// Define the type to use for real numbers</span>
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">00134</a> <span class="keyword">typedef</span> LIBMESH_DEFAULT_SCALAR_TYPE <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="comment">// Define a corresponding tolerance.  This is what should be</span>
<a name="l00137"></a>00137 <span class="comment">// considered &quot;good enough&quot; when doing floating point comparisons.</span>
<a name="l00138"></a>00138 <span class="comment">// For example, v == 0 is changed to std::abs(v) &lt; TOLERANCE.</span>
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 <span class="preprocessor">#ifndef LIBMESH_DEFAULT_SINGLE_PRECISION</span>
<a name="l00141"></a>00141 <span class="preprocessor"></span><span class="preprocessor">  #ifdef LIBMESH_DEFAULT_TRIPLE_PRECISION</span>
<a name="l00142"></a>00142 <span class="preprocessor"></span><span class="preprocessor">  # define TOLERANCE 1.e-8</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span><span class="preprocessor">  # define MPI_REAL MPI_LONG_DOUBLE</span>
<a name="l00144"></a>00144 <span class="preprocessor"></span><span class="preprocessor">  #else</span>
<a name="l00145"></a>00145 <span class="preprocessor"></span><span class="preprocessor">  # define TOLERANCE 1.e-6</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span><span class="preprocessor">  # define MPI_REAL MPI_DOUBLE</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span><span class="preprocessor">  #endif</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00149"></a>00149 <span class="preprocessor"></span><span class="preprocessor">  # define TOLERANCE 2.5e-3</span>
<a name="l00150"></a>00150 <span class="preprocessor"></span><span class="preprocessor">  # define MPI_REAL MPI_FLOAT</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>
<a name="l00153"></a>00153 <span class="comment">// Define the type to use for complex numbers</span>
<a name="l00154"></a>00154 <span class="comment">// Always use std::complex&lt;double&gt;, as required by Petsc?</span>
<a name="l00155"></a>00155 <span class="comment">// If your version of Petsc doesn&#39;t support</span>
<a name="l00156"></a>00156 <span class="comment">// std::complex&lt;other_precision&gt;, then you&#39;d better just leave</span>
<a name="l00157"></a>00157 <span class="comment">// Real==double</span>
<a name="l00158"></a><a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">00158</a> <span class="keyword">typedef</span> std::complex&lt;Real&gt; <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a>;
<a name="l00159"></a><a class="code" href="namespacelibMesh.php#a02349a31b5760c3b6b2c587ae8fb3304">00159</a> <span class="keyword">typedef</span> std::complex&lt;Real&gt; <a class="code" href="namespacelibMesh.php#a02349a31b5760c3b6b2c587ae8fb3304">COMPLEX</a>;
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="comment">// Helper functions for complex/real numbers</span>
<a name="l00163"></a>00163 <span class="comment">// to clean up #ifdef LIBMESH_USE_COMPLEX_NUMBERS elsewhere</span>
<a name="l00164"></a><a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">00164</a> <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> T <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(T a) { <span class="keywordflow">return</span> a; }
<a name="l00165"></a><a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">00165</a> <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> T <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(T a) { <span class="keywordflow">return</span> a*a; }
<a name="l00166"></a><a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">00166</a> <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <span class="keyword">inline</span> T <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(T a) { <span class="keywordflow">return</span> a; }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00169"></a><a class="code" href="namespacelibMesh.php#a2537eb78c6e4fbcb96f0dd7fb914746b">00169</a> <span class="keyword">inline</span> T <a class="code" href="namespacelibMesh.php#aea33cac176f18504c5c4078407aadbb7">libmesh_real</a>(std::complex&lt;T&gt; a) { <span class="keywordflow">return</span> std::real(a); }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00172"></a><a class="code" href="namespacelibMesh.php#abd18a7f83618f8a322db4f7e86716e40">00172</a> <span class="keyword">inline</span> T <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(std::complex&lt;T&gt; a) { <span class="keywordflow">return</span> std::norm(a); }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt;
<a name="l00175"></a><a class="code" href="namespacelibMesh.php#a3baa1575777e7294c7f4993b9670ca21">00175</a> <span class="keyword">inline</span> std::complex&lt;T&gt; <a class="code" href="namespacelibMesh.php#adf2cda6212d46ff664adf9f688129825">libmesh_conj</a>(std::complex&lt;T&gt; a) { <span class="keywordflow">return</span> std::conj(a); }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 <span class="comment">// isnan isn&#39;t actually C++ standard yet; in contexts where it&#39;s not defined in</span>
<a name="l00178"></a>00178 <span class="comment">// cmath, libmesh_isnan will just end up returning false.</span>
<a name="l00179"></a><a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">00179</a> <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(<span class="keywordtype">float</span> a) { <span class="keywordflow">return</span> <a class="code" href="libmesh__C__isnan_8h.php#a7d706955c573fe6580995a0aa472162b">libmesh_C_isnan_float</a>(a); }
<a name="l00180"></a><a class="code" href="namespacelibMesh.php#a432860492398eb5ddf4e14f7924faead">00180</a> <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(<span class="keywordtype">double</span> a) { <span class="keywordflow">return</span> <a class="code" href="libmesh__C__isnan_8h.php#a1e2f38ad8d47ff142267b1af26de75a2">libmesh_C_isnan_double</a>(a); }
<a name="l00181"></a><a class="code" href="namespacelibMesh.php#a98394f504c871674f52fffb10bb5f514">00181</a> <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(<span class="keywordtype">long</span> <span class="keywordtype">double</span> a) { <span class="keywordflow">return</span> <a class="code" href="libmesh__C__isnan_8h.php#a1ff96b1c4d21cc21ebe7fdf0bfa1d6cc">libmesh_C_isnan_longdouble</a>(a); }
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00184"></a><a class="code" href="namespacelibMesh.php#aff33f40b846a68e310d653248d2c310f">00184</a> <span class="keyword">inline</span> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(std::complex&lt;T&gt; a) { <span class="keywordflow">return</span> (<a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(std::real(a)) || <a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(std::imag(a))); }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 <span class="comment">// Define the value type for unknowns in simulations.</span>
<a name="l00188"></a>00188 <span class="comment">// This is either Real or Complex, depending on how</span>
<a name="l00189"></a>00189 <span class="comment">// the library was configures</span>
<a name="l00190"></a>00190 <span class="preprocessor">#if   defined (LIBMESH_USE_REAL_NUMBERS)</span>
<a name="l00191"></a><a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">00191</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>;
<a name="l00192"></a>00192 <span class="preprocessor">#elif defined (LIBMESH_USE_COMPLEX_NUMBERS)</span>
<a name="l00193"></a>00193 <span class="preprocessor"></span>  <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>;
<a name="l00194"></a>00194 <span class="preprocessor">#else</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span>  DIE A HORRIBLE DEATH HERE...
<a name="l00196"></a>00196 #endif
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="comment">// Define the value type for error estimates.</span>
<a name="l00200"></a>00200 <span class="comment">// Since AMR/C decisions don&#39;t have to be precise,</span>
<a name="l00201"></a>00201 <span class="comment">// we default to float for memory efficiency.</span>
<a name="l00202"></a><a class="code" href="namespacelibMesh.php#a26acf05f075521cbfb223db57e63d6d0">00202</a> <span class="keyword">typedef</span> <span class="keywordtype">float</span> <a class="code" href="namespacelibMesh.php#a26acf05f075521cbfb223db57e63d6d0">ErrorVectorReal</a>;
<a name="l00203"></a>00203 <span class="preprocessor">#define MPI_ERRORVECTORREAL MPI_FLOAT</span>
<a name="l00204"></a>00204 <span class="preprocessor"></span>
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00207"></a>00207 <span class="preprocessor"></span>
<a name="l00210"></a>00210   <span class="keyword">extern</span> MPI_Comm <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">COMM_WORLD</a>;
<a name="l00211"></a>00211 <span class="preprocessor">#else</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>
<a name="l00216"></a>00216   <span class="keyword">extern</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">COMM_WORLD</a>;
<a name="l00217"></a>00217 <span class="preprocessor">#endif</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>
<a name="l00219"></a>00219 <span class="comment">// Let&#39;s define a couple output streams - these will default</span>
<a name="l00220"></a>00220 <span class="comment">// to cout/cerr, but LibMeshInit (or the user) can also set them to</span>
<a name="l00221"></a>00221 <span class="comment">// something more sophisticated.</span>
<a name="l00222"></a>00222 <span class="comment">//</span>
<a name="l00223"></a>00223 <span class="comment">// We use a proxy class rather than references so they can be</span>
<a name="l00224"></a>00224 <span class="comment">// reseated at runtime.</span>
<a name="l00225"></a>00225 
<a name="l00226"></a><a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">00226</a> <span class="keyword">extern</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php">OStreamProxy</a> <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l00227"></a><a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">00227</a> <span class="keyword">extern</span> <a class="code" href="classlibMesh_1_1BasicOStreamProxy.php">OStreamProxy</a> <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">err</a>;
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 <span class="comment">// These are useful macros that behave like functions in the code.</span>
<a name="l00230"></a>00230 <span class="comment">// If you want to make sure you are accessing a section of code just</span>
<a name="l00231"></a>00231 <span class="comment">// stick a libmesh_here(); in it, for example</span>
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="preprocessor">#define libmesh_here()     do { libMesh::err &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;] &quot; &lt;&lt; __FILE__ &lt;&lt; &quot;, line &quot; &lt;&lt; __LINE__ &lt;&lt; &quot;, compiled &quot; &lt;&lt; __DATE__ &lt;&lt; &quot; at &quot; &lt;&lt; __TIME__ &lt;&lt; std::endl; } while (0)</span>
<a name="l00234"></a>00234 <span class="preprocessor"></span>
<a name="l00235"></a>00235 <span class="comment">// the libmesh_stop() macro will stop the code until a SIGCONT signal</span>
<a name="l00236"></a>00236 <span class="comment">// is recieved.  This is useful, for example, when determining the</span>
<a name="l00237"></a>00237 <span class="comment">// memory used by a given operation.  A libmesh_stop() could be</span>
<a name="l00238"></a>00238 <span class="comment">// instered before and after a questionable operation and the delta</span>
<a name="l00239"></a>00239 <span class="comment">// memory can be obtained from a ps or top.  This macro only works for</span>
<a name="l00240"></a>00240 <span class="comment">// serial cases.</span>
<a name="l00241"></a>00241 <span class="preprocessor">#ifdef LIBMESH_HAVE_CSIGNAL</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span><span class="preprocessor">#  define libmesh_stop()     do { if (libMesh::n_processors() == 1) { libmesh_here(); libMesh::out &lt;&lt; &quot;Stopping process &quot; &lt;&lt; getpid() &lt;&lt; &quot;...&quot; &lt;&lt; std::endl; std::raise(SIGSTOP); libMesh::out &lt;&lt; &quot;Continuing process &quot; &lt;&lt; getpid() &lt;&lt; &quot;...&quot; &lt;&lt; std::endl; } } while(0)</span>
<a name="l00243"></a>00243 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00244"></a>00244 <span class="preprocessor"></span><span class="preprocessor">#  define libmesh_stop()     do { if (libMesh::n_processors() == 1) { libmesh_here(); libMesh::out &lt;&lt; &quot;WARNING:  libmesh_stop() does not work without the &lt;csignal&gt; header file!&quot; &lt;&lt; std::endl; } } while(0)</span>
<a name="l00245"></a>00245 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00246"></a>00246 <span class="preprocessor"></span>
<a name="l00247"></a>00247 <span class="comment">// The libmesh_assert() macro acts like C&#39;s assert(), but throws a </span>
<a name="l00248"></a>00248 <span class="comment">// libmesh_error() (including stack trace, etc) instead of just exiting</span>
<a name="l00249"></a>00249 <span class="preprocessor">#ifdef NDEBUG</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_assert(asserted) </span>
<a name="l00251"></a>00251 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_assert(asserted)  do { if (!(asserted)) { libMesh::err &lt;&lt; &quot;Assertion `&quot; #asserted &quot;&#39; failed.&quot; &lt;&lt; std::endl; libmesh_error(); } } while(0)</span>
<a name="l00253"></a>00253 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>
<a name="l00255"></a>00255 <span class="comment">// The libmesh_write_traceout() macro writes stack trace files, if</span>
<a name="l00256"></a>00256 <span class="comment">// that feature has been configured.</span>
<a name="l00257"></a>00257 <span class="preprocessor">#ifdef LIBMESH_ENABLE_TRACEFILES</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span><span class="preprocessor">  #define libmesh_write_traceout()   do { std::stringstream outname; outname &lt;&lt; &quot;traceout_&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &#39;_&#39; &lt;&lt; getpid() &lt;&lt; &quot;.txt&quot;; std::ofstream traceout(outname.str().c_str()); libMesh::print_trace(traceout); } while(0)</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00260"></a>00260 <span class="preprocessor"></span><span class="preprocessor">  #define libmesh_write_traceout()   do { } while (0)</span>
<a name="l00261"></a>00261 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00262"></a>00262 <span class="preprocessor"></span>
<a name="l00263"></a>00263 <span class="comment">// The libmesh_error() macro prints a message and throws a LogicError</span>
<a name="l00264"></a>00264 <span class="comment">// exception</span>
<a name="l00265"></a>00265 <span class="comment">//</span>
<a name="l00266"></a>00266 <span class="comment">// The libmesh_not_implemented() macro prints a message and throws a</span>
<a name="l00267"></a>00267 <span class="comment">// NotImplemented exception</span>
<a name="l00268"></a>00268 <span class="comment">//</span>
<a name="l00269"></a>00269 <span class="comment">// The libmesh_file_error(const std::string&amp; filename) macro prints a message</span>
<a name="l00270"></a>00270 <span class="comment">// and throws a FileError exception</span>
<a name="l00271"></a>00271 <span class="comment">//</span>
<a name="l00272"></a>00272 <span class="comment">// The libmesh_convergence_failure() macro prints a message</span>
<a name="l00273"></a>00273 <span class="comment">// and throws a ConvergenceFailure exception</span>
<a name="l00274"></a>00274 <span class="preprocessor">#define libmesh_error()    do { libmesh_write_traceout(); libmesh_here(); LIBMESH_THROW(libMesh::LogicError()); } while(0)</span>
<a name="l00275"></a>00275 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_not_implemented()    do { libmesh_write_traceout(); libmesh_here(); LIBMESH_THROW(libMesh::NotImplemented()); } while(0)</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_file_error(filename)    do { libmesh_write_traceout(); libmesh_here(); LIBMESH_THROW(libMesh::FileError(filename)); } while(0)</span>
<a name="l00277"></a>00277 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_convergence_failure()    do { libmesh_here(); LIBMESH_THROW(libMesh::ConvergenceFailure()); } while(0)</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>
<a name="l00279"></a>00279 <span class="comment">// The libmesh_example_assert() macro prints a message and calls</span>
<a name="l00280"></a>00280 <span class="comment">// &quot;return 0;&quot; if the assertion specified by the macro is not true.  This</span>
<a name="l00281"></a>00281 <span class="comment">// macro is used in the example executables, which should run when the</span>
<a name="l00282"></a>00282 <span class="comment">// configure-time libMesh options support them but which should exit</span>
<a name="l00283"></a>00283 <span class="comment">// without failure otherwise.</span>
<a name="l00284"></a>00284 <span class="comment">//</span>
<a name="l00285"></a>00285 <span class="comment">// This macro only works in main(), because we have no better way than</span>
<a name="l00286"></a>00286 <span class="comment">// &quot;return 0&quot; from main to immediately exit successfully - std::exit(0)</span>
<a name="l00287"></a>00287 <span class="comment">// gets seen by at least some MPI stacks as failure.</span>
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 <span class="preprocessor">#define libmesh_example_assert(asserted, requirement)   do { if (!(asserted)) { libMesh::out &lt;&lt; &quot;Assertion `&quot; #asserted &quot;&#39; failed.  Configuring libMesh with &quot; requirement &quot; may be required to run this code.&quot; &lt;&lt; std::endl; return 0; } } while(0)</span>
<a name="l00290"></a>00290 <span class="preprocessor"></span>
<a name="l00291"></a>00291 <span class="comment">// The libmesh_cast functions do a dynamic cast and assert the result,</span>
<a name="l00292"></a>00292 <span class="comment">// The libmesh_cast functions do a dynamic cast and assert the result,</span>
<a name="l00293"></a>00293 <span class="comment">// if we&#39;re in debug or development modes, but just do a faster static</span>
<a name="l00294"></a>00294 <span class="comment">// cast if we&#39;re in optimized mode.  Use these casts when you&#39;re</span>
<a name="l00295"></a>00295 <span class="comment">// certain that a cast will succeed in correct code but you want to be</span>
<a name="l00296"></a>00296 <span class="comment">// able to double-check.</span>
<a name="l00297"></a>00297 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Tnew, <span class="keyword">typename</span> Told&gt;
<a name="l00298"></a><a class="code" href="namespacelibMesh.php#ab50710c6677b3b837044435e356eb87e">00298</a> <span class="keyword">inline</span> Tnew <a class="code" href="namespacelibMesh.php#ab50710c6677b3b837044435e356eb87e">libmesh_cast_ref</a>(Told&amp; oldvar)
<a name="l00299"></a>00299 {
<a name="l00300"></a>00300 <span class="preprocessor">#if !defined(NDEBUG) &amp;&amp; defined(LIBMESH_HAVE_RTTI)</span>
<a name="l00301"></a>00301 <span class="preprocessor"></span>  <span class="keywordflow">try</span>
<a name="l00302"></a>00302     {
<a name="l00303"></a>00303       Tnew newvar = <span class="keyword">dynamic_cast&lt;</span>Tnew<span class="keyword">&gt;</span>(oldvar);
<a name="l00304"></a>00304       <span class="keywordflow">return</span> newvar;
<a name="l00305"></a>00305     }
<a name="l00306"></a>00306   <span class="keywordflow">catch</span> (std::bad_cast)
<a name="l00307"></a>00307     {
<a name="l00308"></a>00308       libmesh_assert (<span class="keyword">false</span>);
<a name="l00309"></a>00309     }
<a name="l00310"></a>00310 <span class="preprocessor">#else</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span>  <span class="keywordflow">return</span>(static_cast&lt;Tnew&gt;(oldvar));
<a name="l00312"></a>00312 <span class="preprocessor">#endif</span>
<a name="l00313"></a>00313 <span class="preprocessor"></span>}
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="comment">// We use two different function names to avoid an odd overloading</span>
<a name="l00316"></a>00316 <span class="comment">// ambiguity bug with icc 10.1.008</span>
<a name="l00317"></a>00317 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Tnew, <span class="keyword">typename</span> Told&gt;
<a name="l00318"></a><a class="code" href="namespacelibMesh.php#af0cba785debb96be6fb9e8cefb838b6d">00318</a> <span class="keyword">inline</span> Tnew <a class="code" href="namespacelibMesh.php#af0cba785debb96be6fb9e8cefb838b6d">libmesh_cast_ptr</a> (Told* oldvar)
<a name="l00319"></a>00319 {
<a name="l00320"></a>00320 <span class="preprocessor">#if !defined(NDEBUG) &amp;&amp; defined(LIBMESH_HAVE_RTTI)</span>
<a name="l00321"></a>00321 <span class="preprocessor"></span>  Tnew newvar = <span class="keyword">dynamic_cast&lt;</span>Tnew<span class="keyword">&gt;</span>(oldvar);
<a name="l00322"></a>00322   <span class="keywordflow">if</span> (!newvar)
<a name="l00323"></a>00323     {
<a name="l00324"></a>00324       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Failed to convert &quot;</span> &lt;&lt; <span class="keyword">typeid</span>(Told).<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>() &lt;&lt; 
<a name="l00325"></a>00325                       <span class="stringliteral">&quot; pointer to &quot;</span> &lt;&lt; <span class="keyword">typeid</span>(Tnew).<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>() &lt;&lt; std::endl;
<a name="l00326"></a>00326       libmesh_error();
<a name="l00327"></a>00327     }
<a name="l00328"></a>00328   <span class="keywordflow">return</span> newvar;
<a name="l00329"></a>00329 <span class="preprocessor">#else</span>
<a name="l00330"></a>00330 <span class="preprocessor"></span>  <span class="keywordflow">return</span>(static_cast&lt;Tnew&gt;(oldvar));
<a name="l00331"></a>00331 <span class="preprocessor">#endif</span>
<a name="l00332"></a>00332 <span class="preprocessor"></span>}
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 <span class="comment">// The libmesh_do_once macro helps us avoid redundant repeated</span>
<a name="l00336"></a>00336 <span class="comment">// repetitions of the same warning messages</span>
<a name="l00337"></a>00337 <span class="preprocessor">#undef libmesh_do_once</span>
<a name="l00338"></a>00338 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_do_once(do_this) do { static bool did_this_already = false; if (!did_this_already) { did_this_already = true; do_this; } } while (0)</span>
<a name="l00339"></a>00339 <span class="preprocessor"></span>
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 <span class="comment">// The libmesh_experimental macro warns that you are using</span>
<a name="l00342"></a>00342 <span class="comment">// bleeding-edge code</span>
<a name="l00343"></a>00343 <span class="preprocessor">#undef libmesh_experimental</span>
<a name="l00344"></a>00344 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_experimental() libmesh_do_once(libMesh::out &lt;&lt; &quot;*** Warning, This code is untested, experimental, or likely to see future API changes: &quot; &lt;&lt; __FILE__ &lt;&lt; &quot;, line &quot; &lt;&lt; __LINE__ &lt;&lt; &quot;, compiled &quot; &lt;&lt; __DATE__ &lt;&lt; &quot; at &quot; &lt;&lt; __TIME__ &lt;&lt; &quot; ***&quot; &lt;&lt; std::endl;)</span>
<a name="l00345"></a>00345 <span class="preprocessor"></span>
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 <span class="comment">// The libmesh_deprecated macro warns that you are using obsoleted code</span>
<a name="l00348"></a>00348 <span class="preprocessor">#undef libmesh_deprecated</span>
<a name="l00349"></a>00349 <span class="preprocessor"></span><span class="preprocessor">#define libmesh_deprecated() libmesh_do_once(libMesh::out &lt;&lt; &quot;*** Warning, This code is deprecated, and likely to be removed in future library versions! &quot; &lt;&lt; __FILE__ &lt;&lt; &quot;, line &quot; &lt;&lt; __LINE__ &lt;&lt; &quot;, compiled &quot; &lt;&lt; __DATE__ &lt;&lt; &quot; at &quot; &lt;&lt; __TIME__ &lt;&lt; &quot; ***&quot; &lt;&lt; std::endl;)</span>
<a name="l00350"></a>00350 <span class="preprocessor"></span>
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 <span class="comment">// 3D spatial dimension unless otherwise specified</span>
<a name="l00355"></a>00355 <span class="preprocessor">#ifndef LIBMESH_DIM</span>
<a name="l00356"></a>00356 <span class="preprocessor"></span><span class="preprocessor">#  define LIBMESH_DIM 3</span>
<a name="l00357"></a>00357 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00358"></a>00358 <span class="preprocessor"></span>
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 } <span class="comment">// namespace libMesh</span>
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 <span class="preprocessor">#endif // #define __libmesh_common_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
