<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">libmesh_exceptions.h</div>  </div>
</div>
<div class="contents">
<a href="libmesh__exceptions_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: libmesh_exceptions.h 3482 2009-10-06 01:22:40Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __libmesh_exceptions_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __libmesh_exceptions_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_ENABLE_EXCEPTIONS</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span><span class="preprocessor">#include &lt;stdexcept&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh {
<a name="l00032"></a>00032 
<a name="l00037"></a><a class="code" href="classlibMesh_1_1LogicError.php">00037</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LogicError.php">LogicError</a> : <span class="keyword">public</span> std::logic_error
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039     <span class="keyword">public</span>:
<a name="l00040"></a><a class="code" href="classlibMesh_1_1LogicError.php#af575df95dea84d5edc974e44cb2084fe">00040</a>       <a class="code" href="classlibMesh_1_1LogicError.php#af575df95dea84d5edc974e44cb2084fe">LogicError</a>() : std::logic_error( <span class="stringliteral">&quot;Error in libMesh internal logic&quot;</span> ) {}
<a name="l00041"></a>00041     };
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00049"></a><a class="code" href="classlibMesh_1_1NotImplemented.php">00049</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NotImplemented.php">NotImplemented</a> : <span class="keyword">public</span> std::logic_error
<a name="l00050"></a>00050     {
<a name="l00051"></a>00051     <span class="keyword">public</span>:
<a name="l00052"></a><a class="code" href="classlibMesh_1_1NotImplemented.php#a33bf5733f57b7d97282a989aa0a8e52b">00052</a>       <a class="code" href="classlibMesh_1_1NotImplemented.php#a33bf5733f57b7d97282a989aa0a8e52b">NotImplemented</a>() : std::logic_error( <span class="stringliteral">&quot;Error: not implemented!&quot;</span> ) {}
<a name="l00053"></a>00053     };
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1FileError.php">00063</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1FileError.php">FileError</a> : <span class="keyword">public</span> std::runtime_error
<a name="l00064"></a>00064     {
<a name="l00065"></a>00065     <span class="keyword">public</span>:
<a name="l00066"></a><a class="code" href="classlibMesh_1_1FileError.php#aff80210741b6d9fc7991ddf39cc3abc0">00066</a>       <a class="code" href="classlibMesh_1_1FileError.php#aff80210741b6d9fc7991ddf39cc3abc0">FileError</a>(<span class="keyword">const</span> std::string&amp; filename) : std::runtime_error( <span class="stringliteral">&quot;Error accessing file: &quot;</span> + filename ) {}
<a name="l00067"></a>00067     };
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1ConvergenceFailure.php">00077</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ConvergenceFailure.php">ConvergenceFailure</a> : <span class="keyword">public</span> std::runtime_error
<a name="l00078"></a>00078     {
<a name="l00079"></a>00079     <span class="keyword">public</span>:
<a name="l00080"></a><a class="code" href="classlibMesh_1_1ConvergenceFailure.php#a32a53e6f6bda381b41d6c7ca0f84478e">00080</a>       <a class="code" href="classlibMesh_1_1ConvergenceFailure.php#a32a53e6f6bda381b41d6c7ca0f84478e">ConvergenceFailure</a>() : std::runtime_error( <span class="stringliteral">&quot;Unrecoverable failure to converge&quot;</span> ) {}
<a name="l00081"></a>00081     };
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1DynamicCastFailure.php">00087</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1DynamicCastFailure.php">DynamicCastFailure</a>:  <span class="keyword">public</span> std::runtime_error
<a name="l00088"></a>00088     {
<a name="l00089"></a>00089     <span class="keyword">public</span>:
<a name="l00090"></a><a class="code" href="classlibMesh_1_1DynamicCastFailure.php#ad0ffb1975639b16dfb8bdc32df17159e">00090</a>       <a class="code" href="classlibMesh_1_1DynamicCastFailure.php#ad0ffb1975639b16dfb8bdc32df17159e">DynamicCastFailure</a>() : std::runtime_error( <span class="stringliteral">&quot;Failed dynamic cast!&quot;</span> ) {}
<a name="l00091"></a>00091     };
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="preprocessor">#define LIBMESH_THROW(e) do { throw e; } while (0)</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span>
<a name="l00096"></a>00096 <span class="preprocessor">#else</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>
<a name="l00098"></a>00098 <span class="preprocessor">#define LIBMESH_THROW(e) do { std::abort(); } while (0)</span>
<a name="l00099"></a>00099 <span class="preprocessor"></span>
<a name="l00100"></a>00100 <span class="preprocessor">#endif // LIBMESH_ENABLE_EXCEPTIONS</span>
<a name="l00101"></a>00101 <span class="preprocessor"></span>
<a name="l00102"></a>00102 <span class="preprocessor">#endif // #define __libmesh_exceptions_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
