<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">libmesh_logging.h</div>  </div>
</div>
<div class="contents">
<a href="libmesh__logging_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: libmesh_logging.h 4030 2010-10-05 18:45:13Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __libmesh_logging_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __libmesh_logging_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// The library configuration options</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="perf__log_8h.php">perf_log.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declaration, required when included</span>
<a name="l00036"></a>00036 <span class="comment">// in perf_log.{C,h} because the preceeding</span>
<a name="l00037"></a>00037 <span class="comment">// #include &quot;perf_log.h&quot; is ineffective.</span>
<a name="l00038"></a>00038 <span class="comment">// Multiple inclusion avoidance problem...</span>
<a name="l00039"></a>00039 <span class="comment">// __perf_log_h__ already #define&#39;d, but the</span>
<a name="l00040"></a>00040 <span class="comment">// class has not been declared yet!.</span>
<a name="l00041"></a><a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">00041</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PerfLog.php">PerfLog</a>;
<a name="l00042"></a>00042 
<a name="l00047"></a>00047   <span class="keyword">extern</span> <a class="code" href="classlibMesh_1_1PerfLog.php">PerfLog</a> <a class="code" href="namespacelibMesh.php#a898fabb4e2a583bf30bf4bd46f4c032d">perflog</a>;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 } <span class="comment">// namespace libMesh</span>
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// Macros for performance logging.  This allows us</span>
<a name="l00055"></a>00055 <span class="comment">// to add performance monitors to the code without</span>
<a name="l00056"></a>00056 <span class="comment">// impacting performance when performance logging</span>
<a name="l00057"></a>00057 <span class="comment">// is disabled.</span>
<a name="l00058"></a>00058 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERFORMANCE_LOGGING</span>
<a name="l00059"></a>00059 <span class="preprocessor"></span>
<a name="l00060"></a>00060 <span class="comment">// Note the log is in libMesh, so we need to include it.</span>
<a name="l00061"></a>00061 <span class="preprocessor">#  include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00062"></a>00062 <span class="preprocessor">#  define START_LOG(a,b)   { libMesh::perflog.push(a,b); }</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span><span class="preprocessor">#  define STOP_LOG(a,b)    { libMesh::perflog.pop(a,b); }</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="preprocessor">#  define PALIBMESH_USE_LOG(a,b)   { libmesh_deprecated(); }</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span><span class="preprocessor">#  define RESTART_LOG(a,b) { libmesh_deprecated(); }</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>
<a name="l00067"></a>00067 <span class="preprocessor">#else</span>
<a name="l00068"></a>00068 <span class="preprocessor"></span>
<a name="l00069"></a>00069 <span class="preprocessor">#  define START_LOG(a,b)   {}</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span><span class="preprocessor">#  define STOP_LOG(a,b)    {}</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span><span class="preprocessor">#  define PALIBMESH_USE_LOG(a,b)   {}</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span><span class="preprocessor">#  define RESTART_LOG(a,b) {}</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>
<a name="l00074"></a>00074 <span class="preprocessor">#endif</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#endif // #define __libmesh_logging_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
