<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">linear_implicit_system.C</div>  </div>
</div>
<div class="contents">
<a href="linear__implicit__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: linear_implicit_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span> <span class="comment">// for parameter sensitivity calcs</span>
<a name="l00029"></a>00029 <span class="comment">//#include &quot;parameter_vector.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span> <span class="comment">// for get_transpose</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="system__subset_8h.php">system_subset.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// LinearImplicitSystem implementation</span>
<a name="l00039"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a329460f19707462e20a6344c5f0d3d3b">00039</a> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a329460f19707462e20a6344c5f0d3d3b">LinearImplicitSystem::LinearImplicitSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00040"></a>00040                                             <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00041"></a>00041                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00042"></a>00042   
<a name="l00043"></a>00043   <a class="code" href="classlibMesh_1_1System.php">Parent</a>                 (es, name, number),
<a name="l00044"></a>00044   linear_solver          (<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build()),
<a name="l00045"></a>00045   _n_linear_iterations   (0),
<a name="l00046"></a>00046   _final_linear_residual (1.e20),
<a name="l00047"></a>00047   _shell_matrix(NULL),
<a name="l00048"></a>00048   _subset(NULL),
<a name="l00049"></a>00049   _subset_solve_mode(<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>)
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af483d705ccd4e6287d0292287481e480">00055</a> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af483d705ccd4e6287d0292287481e480">LinearImplicitSystem::~LinearImplicitSystem</a> ()
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057   <span class="comment">// Clear data</span>
<a name="l00058"></a>00058   this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a8af6a9f61922d067be46acdfcde204f1">clear</a>();
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a8af6a9f61922d067be46acdfcde204f1">00063</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a8af6a9f61922d067be46acdfcde204f1">LinearImplicitSystem::clear</a> ()
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065   <span class="comment">// clear the linear solver</span>
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;clear();
<a name="l00067"></a>00067 
<a name="l00068"></a>00068   this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a153b7ea8d6c76a119277c36ddbd03a46">restrict_solve_to</a>(NULL);
<a name="l00069"></a>00069   
<a name="l00070"></a>00070   <span class="comment">// clear the parent data</span>
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a8ec1dbe98f37b3fa50d87292e5b46827">Parent::clear</a>();
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#acaeb85ca820997afa82131120c45ebd8">00076</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#acaeb85ca820997afa82131120c45ebd8">LinearImplicitSystem::reinit</a> ()
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   <span class="comment">// re-initialize the linear solver interface</span>
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;clear();
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="comment">// initialize parent data</span>
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a766e6bac5c51ef16b7ddc4f62933b309">Parent::reinit</a>();  
<a name="l00083"></a>00083 }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a153b7ea8d6c76a119277c36ddbd03a46">00087</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a153b7ea8d6c76a119277c36ddbd03a46">LinearImplicitSystem::restrict_solve_to</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SystemSubset.php">SystemSubset</a>* subset,
<a name="l00088"></a>00088                                               <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137">SubsetSolveMode</a> subset_solve_mode)
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#aeb4974a6350ff72805dcd2200d2f7ef6">_subset</a> = subset;
<a name="l00091"></a>00091   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#ae6b5ea5aa8eae2a79a16ed6db365e689">_subset_solve_mode</a> = subset_solve_mode;
<a name="l00092"></a>00092   <span class="keywordflow">if</span>(subset!=NULL)
<a name="l00093"></a>00093     {
<a name="l00094"></a>00094       libmesh_assert(&amp;subset-&gt;<a class="code" href="classlibMesh_1_1SystemSubset.php#a2be4abdaac14494458dfb6d00a90e71a">get_system</a>()==<span class="keyword">this</span>);
<a name="l00095"></a>00095     }
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">00100</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#af1de21a76860785bb1992280eb72b0db">LinearImplicitSystem::solve</a> ()
<a name="l00101"></a>00101 {
<a name="l00102"></a>00102   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1System.php#a6b24ccb769399c64405e8f8a52491e70">assemble_before_solve</a>)
<a name="l00103"></a>00103     <span class="comment">// Assemble the linear system</span>
<a name="l00104"></a>00104     this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a6446a3daa539c257cc3d621ec0040c35">assemble</a> (); 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106   <span class="comment">// Log how long the linear solve takes.</span>
<a name="l00107"></a>00107   <span class="comment">// This gets done by the LinearSolver classes now [RHS]</span>
<a name="l00108"></a>00108   <span class="comment">// START_LOG(&quot;solve()&quot;, &quot;System&quot;);</span>
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">// Get a reference to the EquationSystems</span>
<a name="l00111"></a>00111   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00112"></a>00112     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00113"></a>00113   
<a name="l00114"></a>00114   <span class="comment">// Get the user-specifiied linear solver tolerance</span>
<a name="l00115"></a>00115   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol            =
<a name="l00116"></a>00116     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>);
<a name="l00117"></a>00117 
<a name="l00118"></a>00118   <span class="comment">// Get the user-specified maximum # of linear solver iterations</span>
<a name="l00119"></a>00119   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxits =
<a name="l00120"></a>00120     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#aeb4974a6350ff72805dcd2200d2f7ef6">_subset</a>!=NULL)
<a name="l00123"></a>00123     {
<a name="l00124"></a>00124       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;restrict_solve_to(&amp;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#aeb4974a6350ff72805dcd2200d2f7ef6">_subset</a>-&gt;<a class="code" href="classlibMesh_1_1SystemSubset.php#acc57d6d675d8b55d0c1e8e1f47e24510">dof_ids</a>(),<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#ae6b5ea5aa8eae2a79a16ed6db365e689">_subset_solve_mode</a>);
<a name="l00125"></a>00125     }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   <span class="comment">// Solve the linear system.  Several cases:</span>
<a name="l00128"></a>00128   std::pair&lt;unsigned int, Real&gt; rval = std::make_pair(0,0.0);
<a name="l00129"></a>00129   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a560d4b7b25823897fab6226b371082a0">_shell_matrix</a>)
<a name="l00130"></a>00130     <span class="comment">// 1.) Shell matrix with or without user-supplied preconditioner.</span>
<a name="l00131"></a>00131     rval = <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;solve(*<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a560d4b7b25823897fab6226b371082a0">_shell_matrix</a>, this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0f497ae21ddc216ca57b4cbdb7429f67">request_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>), *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>, *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, tol, maxits);
<a name="l00132"></a>00132   <span class="keywordflow">else</span>
<a name="l00133"></a>00133     <span class="comment">// 2.) No shell matrix, with or without user-supplied preconditioner</span>
<a name="l00134"></a>00134     rval = <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;solve (*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0f497ae21ddc216ca57b4cbdb7429f67">request_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>), *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>, *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, tol, maxits);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#aeb4974a6350ff72805dcd2200d2f7ef6">_subset</a>!=NULL)
<a name="l00137"></a>00137     {
<a name="l00138"></a>00138       <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>-&gt;restrict_solve_to(NULL);
<a name="l00139"></a>00139     }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">// Store the number of linear iterations required to</span>
<a name="l00142"></a>00142   <span class="comment">// solve and the final residual.</span>
<a name="l00143"></a>00143   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a57e48b332f51b09bb0a202c18daa46f6">_n_linear_iterations</a>   = rval.first;
<a name="l00144"></a>00144   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a9a2a816c2a19f12d8d2f34709940f8dc">_final_linear_residual</a> = rval.second;
<a name="l00145"></a>00145     
<a name="l00146"></a>00146   <span class="comment">// Stop logging the linear solve</span>
<a name="l00147"></a>00147   <span class="comment">// This gets done by the LinearSolver classes now [RHS]</span>
<a name="l00148"></a>00148   <span class="comment">// STOP_LOG(&quot;solve()&quot;, &quot;System&quot;);</span>
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">// Update the system after the solve</span>
<a name="l00151"></a>00151   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();  
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a03b925bc4b6210f3cff6c45868d84484">00156</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a03b925bc4b6210f3cff6c45868d84484">LinearImplicitSystem::attach_shell_matrix</a> (<a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;Number&gt;</a>* shell_matrix)
<a name="l00157"></a>00157 {
<a name="l00158"></a>00158   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a560d4b7b25823897fab6226b371082a0">_shell_matrix</a> = shell_matrix;
<a name="l00159"></a>00159 }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="comment">/*</span>
<a name="l00163"></a>00163 <span class="comment">void LinearImplicitSystem::sensitivity_solve (const ParameterVector&amp; parameters)</span>
<a name="l00164"></a>00164 <span class="comment">{</span>
<a name="l00165"></a>00165 <span class="comment">  if (this-&gt;assemble_before_solve)</span>
<a name="l00166"></a>00166 <span class="comment">    {</span>
<a name="l00167"></a>00167 <span class="comment">      // Assemble the linear system</span>
<a name="l00168"></a>00168 <span class="comment">      this-&gt;assemble (); </span>
<a name="l00169"></a>00169 <span class="comment"></span>
<a name="l00170"></a>00170 <span class="comment">      // But now assemble right hand sides with the residual&#39;s</span>
<a name="l00171"></a>00171 <span class="comment">      // parameter derivatives</span>
<a name="l00172"></a>00172 <span class="comment">      this-&gt;assemble_residual_derivatives(parameters);</span>
<a name="l00173"></a>00173 <span class="comment">    }</span>
<a name="l00174"></a>00174 <span class="comment"></span>
<a name="l00175"></a>00175 <span class="comment">  // Get a reference to the EquationSystems</span>
<a name="l00176"></a>00176 <span class="comment">  const EquationSystems&amp; es =</span>
<a name="l00177"></a>00177 <span class="comment">    this-&gt;get_equation_systems();</span>
<a name="l00178"></a>00178 <span class="comment">  </span>
<a name="l00179"></a>00179 <span class="comment">  // Get the user-specifiied linear solver tolerance</span>
<a name="l00180"></a>00180 <span class="comment">  const Real tol            =</span>
<a name="l00181"></a>00181 <span class="comment">    es.parameters.get&lt;Real&gt;(&quot;sensitivity solver tolerance&quot;);</span>
<a name="l00182"></a>00182 <span class="comment"></span>
<a name="l00183"></a>00183 <span class="comment">  // Get the user-specified maximum # of linear solver iterations</span>
<a name="l00184"></a>00184 <span class="comment">  const unsigned int maxits =</span>
<a name="l00185"></a>00185 <span class="comment">    es.parameters.get&lt;unsigned int&gt;(&quot;sensitivity solver maximum iterations&quot;);</span>
<a name="l00186"></a>00186 <span class="comment"></span>
<a name="l00187"></a>00187 <span class="comment">  // Our iteration counts and residuals will be sums of the individual</span>
<a name="l00188"></a>00188 <span class="comment">  // results</span>
<a name="l00189"></a>00189 <span class="comment">  _n_linear_iterations = 0;</span>
<a name="l00190"></a>00190 <span class="comment">  _final_linear_residual = 0.0;</span>
<a name="l00191"></a>00191 <span class="comment">  std::pair&lt;unsigned int, Real&gt; rval = std::make_pair(0,0.0);</span>
<a name="l00192"></a>00192 <span class="comment"></span>
<a name="l00193"></a>00193 <span class="comment">  // Solve the linear system.</span>
<a name="l00194"></a>00194 <span class="comment">  SparseMatrix&lt;Number&gt; *pc = this-&gt;request_matrix(&quot;Preconditioner&quot;);</span>
<a name="l00195"></a>00195 <span class="comment">  for (unsigned int p=0; p != parameters.size(); ++p)</span>
<a name="l00196"></a>00196 <span class="comment">    {</span>
<a name="l00197"></a>00197 <span class="comment">      rval = linear_solver-&gt;solve (*matrix, pc,</span>
<a name="l00198"></a>00198 <span class="comment">                                   this-&gt;get_sensitivity_solution(p),</span>
<a name="l00199"></a>00199 <span class="comment">                                   this-&gt;get_sensitivity_rhs(p), tol, maxits);</span>
<a name="l00200"></a>00200 <span class="comment">      _n_linear_iterations   += rval.first;</span>
<a name="l00201"></a>00201 <span class="comment">      _final_linear_residual += rval.second;</span>
<a name="l00202"></a>00202 <span class="comment">    }</span>
<a name="l00203"></a>00203 <span class="comment"></span>
<a name="l00204"></a>00204 <span class="comment">  // Our matrix is the *negative* of the Jacobian for b-A*u, so our</span>
<a name="l00205"></a>00205 <span class="comment">  // solutions are all inverted</span>
<a name="l00206"></a>00206 <span class="comment">  for (unsigned int p=0; p != parameters.size(); ++p)</span>
<a name="l00207"></a>00207 <span class="comment">    {</span>
<a name="l00208"></a>00208 <span class="comment">      this-&gt;get_sensitivity_solution(p) *= -1.0;</span>
<a name="l00209"></a>00209 <span class="comment">    }</span>
<a name="l00210"></a>00210 <span class="comment">}</span>
<a name="l00211"></a>00211 <span class="comment"></span>
<a name="l00212"></a>00212 <span class="comment"></span>
<a name="l00213"></a>00213 <span class="comment"></span>
<a name="l00214"></a>00214 <span class="comment">void LinearImplicitSystem::adjoint_solve (const QoISet &amp;qoi_indices)</span>
<a name="l00215"></a>00215 <span class="comment">{</span>
<a name="l00216"></a>00216 <span class="comment">  const unsigned int Nq = this-&gt;qoi.size();</span>
<a name="l00217"></a>00217 <span class="comment"></span>
<a name="l00218"></a>00218 <span class="comment">  // We currently don&#39;t support adjoint solves of shell matrices</span>
<a name="l00219"></a>00219 <span class="comment">  // FIXME - we should let shell matrices support</span>
<a name="l00220"></a>00220 <span class="comment">  // vector_transpose_mult so that we can use them here.</span>
<a name="l00221"></a>00221 <span class="comment">  if(_shell_matrix!=NULL)</span>
<a name="l00222"></a>00222 <span class="comment">    libmesh_not_implemented();</span>
<a name="l00223"></a>00223 <span class="comment"></span>
<a name="l00224"></a>00224 <span class="comment">  if (this-&gt;assemble_before_solve)</span>
<a name="l00225"></a>00225 <span class="comment">    {</span>
<a name="l00226"></a>00226 <span class="comment">      // Assemble the linear system</span>
<a name="l00227"></a>00227 <span class="comment">      this-&gt;assemble (); </span>
<a name="l00228"></a>00228 <span class="comment"></span>
<a name="l00229"></a>00229 <span class="comment">      // And take the adjoint</span>
<a name="l00230"></a>00230 <span class="comment">      matrix-&gt;get_transpose(*matrix);</span>
<a name="l00231"></a>00231 <span class="comment"></span>
<a name="l00232"></a>00232 <span class="comment">      // Including of any separate preconditioner</span>
<a name="l00233"></a>00233 <span class="comment">      SparseMatrix&lt;Number&gt; *pc = this-&gt;request_matrix(&quot;Preconditioner&quot;);</span>
<a name="l00234"></a>00234 <span class="comment">      if(pc)</span>
<a name="l00235"></a>00235 <span class="comment">        pc-&gt;get_transpose(*pc);</span>
<a name="l00236"></a>00236 <span class="comment"></span>
<a name="l00237"></a>00237 <span class="comment">      // But now replace the right hand sides with the quantity of</span>
<a name="l00238"></a>00238 <span class="comment">      // interest functional&#39;s derivative</span>
<a name="l00239"></a>00239 <span class="comment">      this-&gt;assemble_qoi_derivative(qoi_indices);</span>
<a name="l00240"></a>00240 <span class="comment">    }</span>
<a name="l00241"></a>00241 <span class="comment"></span>
<a name="l00242"></a>00242 <span class="comment">  // Get a reference to the EquationSystems</span>
<a name="l00243"></a>00243 <span class="comment">  const EquationSystems&amp; es =</span>
<a name="l00244"></a>00244 <span class="comment">    this-&gt;get_equation_systems();</span>
<a name="l00245"></a>00245 <span class="comment">  </span>
<a name="l00246"></a>00246 <span class="comment">  // Get the user-specifiied linear solver tolerance</span>
<a name="l00247"></a>00247 <span class="comment">  const Real tol            =</span>
<a name="l00248"></a>00248 <span class="comment">    es.parameters.get&lt;Real&gt;(&quot;adjoint solver tolerance&quot;);</span>
<a name="l00249"></a>00249 <span class="comment"></span>
<a name="l00250"></a>00250 <span class="comment">  // Get the user-specified maximum # of linear solver iterations</span>
<a name="l00251"></a>00251 <span class="comment">  const unsigned int maxits =</span>
<a name="l00252"></a>00252 <span class="comment">    es.parameters.get&lt;unsigned int&gt;(&quot;adjoint solver maximum iterations&quot;);</span>
<a name="l00253"></a>00253 <span class="comment"></span>
<a name="l00254"></a>00254 <span class="comment">  // Our iteration counts and residuals will be sums of the individual</span>
<a name="l00255"></a>00255 <span class="comment">  // results</span>
<a name="l00256"></a>00256 <span class="comment">  _n_linear_iterations = 0;</span>
<a name="l00257"></a>00257 <span class="comment">  _final_linear_residual = 0.0;</span>
<a name="l00258"></a>00258 <span class="comment">  std::pair&lt;unsigned int, Real&gt; rval = std::make_pair(0,0.0);</span>
<a name="l00259"></a>00259 <span class="comment"></span>
<a name="l00260"></a>00260 <span class="comment">  // Solve the linear system.</span>
<a name="l00261"></a>00261 <span class="comment">  SparseMatrix&lt;Number&gt; *pc = this-&gt;request_matrix(&quot;Preconditioner&quot;);</span>
<a name="l00262"></a>00262 <span class="comment">  for (unsigned int i=0; i != Nq; ++i)</span>
<a name="l00263"></a>00263 <span class="comment">    if (qoi_indices.has_index(i))</span>
<a name="l00264"></a>00264 <span class="comment">      {</span>
<a name="l00265"></a>00265 <span class="comment">        rval = linear_solver-&gt;solve (*matrix, pc,</span>
<a name="l00266"></a>00266 <span class="comment">                                     this-&gt;add_adjoint_solution(i),</span>
<a name="l00267"></a>00267 <span class="comment">                                     this-&gt;get_adjoint_rhs(i), tol, maxits);</span>
<a name="l00268"></a>00268 <span class="comment">        _n_linear_iterations   += rval.first;</span>
<a name="l00269"></a>00269 <span class="comment">        _final_linear_residual += rval.second;</span>
<a name="l00270"></a>00270 <span class="comment">      }</span>
<a name="l00271"></a>00271 <span class="comment">}</span>
<a name="l00272"></a>00272 <span class="comment"></span>
<a name="l00273"></a>00273 <span class="comment"></span>
<a name="l00274"></a>00274 <span class="comment"></span>
<a name="l00275"></a>00275 <span class="comment">void LinearImplicitSystem::forward_qoi_parameter_sensitivity</span>
<a name="l00276"></a>00276 <span class="comment">  (const QoISet&amp;          qoi_indices,</span>
<a name="l00277"></a>00277 <span class="comment">   const ParameterVector&amp; parameters,</span>
<a name="l00278"></a>00278 <span class="comment">   SensitivityData&amp;       sensitivities)</span>
<a name="l00279"></a>00279 <span class="comment">{</span>
<a name="l00280"></a>00280 <span class="comment">  const unsigned int Np = parameters.size();</span>
<a name="l00281"></a>00281 <span class="comment">  const unsigned int Nq = this-&gt;qoi.size();</span>
<a name="l00282"></a>00282 <span class="comment"></span>
<a name="l00283"></a>00283 <span class="comment">  // An introduction to the problem:</span>
<a name="l00284"></a>00284 <span class="comment">  //</span>
<a name="l00285"></a>00285 <span class="comment">  // A(p)*u(p) = b(p), where x is determined implicitly.</span>
<a name="l00286"></a>00286 <span class="comment">  // Residual R(u(p),p) := b(p) - A(p)*u(p)</span>
<a name="l00287"></a>00287 <span class="comment">  // partial R / partial u = -A</span>
<a name="l00288"></a>00288 <span class="comment">  //</span>
<a name="l00289"></a>00289 <span class="comment">  // This implies that:</span>
<a name="l00290"></a>00290 <span class="comment">  // d/dp(R) = 0</span>
<a name="l00291"></a>00291 <span class="comment">  // (partial b / partial p) - </span>
<a name="l00292"></a>00292 <span class="comment">  // (partial A / partial p) * u -</span>
<a name="l00293"></a>00293 <span class="comment">  // A * (partial u / partial p) = 0</span>
<a name="l00294"></a>00294 <span class="comment">  // A * (partial u / partial p) = (partial R / partial p)</span>
<a name="l00295"></a>00295 <span class="comment">  //   = (partial b / partial p) - (partial A / partial p) * u</span>
<a name="l00296"></a>00296 <span class="comment"></span>
<a name="l00297"></a>00297 <span class="comment">  // We first solve for (partial u / partial p) for each parameter:</span>
<a name="l00298"></a>00298 <span class="comment">  // -A * (partial u / partial p) = - (partial R / partial p)</span>
<a name="l00299"></a>00299 <span class="comment"></span>
<a name="l00300"></a>00300 <span class="comment">  this-&gt;sensitivity_solve(parameters);</span>
<a name="l00301"></a>00301 <span class="comment"></span>
<a name="l00302"></a>00302 <span class="comment">  // Get ready to fill in senstivities:</span>
<a name="l00303"></a>00303 <span class="comment">  sensitivities.allocate_data(qoi_indices, *this, parameters);</span>
<a name="l00304"></a>00304 <span class="comment"></span>
<a name="l00305"></a>00305 <span class="comment">  // We use the identity:</span>
<a name="l00306"></a>00306 <span class="comment">  // dq/dp = (partial q / partial p) + (partial q / partial u) *</span>
<a name="l00307"></a>00307 <span class="comment">  //         (partial u / partial p)</span>
<a name="l00308"></a>00308 <span class="comment"> </span>
<a name="l00309"></a>00309 <span class="comment">  // We get (partial q / partial u) from the user</span>
<a name="l00310"></a>00310 <span class="comment">  this-&gt;assemble_qoi_derivative(qoi_indices);</span>
<a name="l00311"></a>00311 <span class="comment"> </span>
<a name="l00312"></a>00312 <span class="comment">  for (unsigned int j=0; j != Np; ++j)</span>
<a name="l00313"></a>00313 <span class="comment">    {</span>
<a name="l00314"></a>00314 <span class="comment">      // We currently get partial derivatives via central differencing</span>
<a name="l00315"></a>00315 <span class="comment">      Number delta_p = 1e-6;</span>
<a name="l00316"></a>00316 <span class="comment"></span>
<a name="l00317"></a>00317 <span class="comment">      // (partial q / partial p) ~= (q(p+dp)-q(p-dp))/(2*dp)</span>
<a name="l00318"></a>00318 <span class="comment"></span>
<a name="l00319"></a>00319 <span class="comment">      Number old_parameter = *parameters[j];</span>
<a name="l00320"></a>00320 <span class="comment"></span>
<a name="l00321"></a>00321 <span class="comment">      *parameters[j] = old_parameter - delta_p;</span>
<a name="l00322"></a>00322 <span class="comment">      this-&gt;assemble_qoi(qoi_indices);</span>
<a name="l00323"></a>00323 <span class="comment">      std::vector&lt;Number&gt; qoi_minus = this-&gt;qoi;</span>
<a name="l00324"></a>00324 <span class="comment"></span>
<a name="l00325"></a>00325 <span class="comment">      *parameters[j] = old_parameter + delta_p;</span>
<a name="l00326"></a>00326 <span class="comment">      this-&gt;assemble_qoi(qoi_indices);</span>
<a name="l00327"></a>00327 <span class="comment">      std::vector&lt;Number&gt; &amp;qoi_plus = this-&gt;qoi;</span>
<a name="l00328"></a>00328 <span class="comment">      std::vector&lt;Number&gt; partialq_partialp(Nq, 0);</span>
<a name="l00329"></a>00329 <span class="comment">      for (unsigned int i=0; i != Nq; ++i)</span>
<a name="l00330"></a>00330 <span class="comment">        if (qoi_indices.has_index(i))</span>
<a name="l00331"></a>00331 <span class="comment">          partialq_partialp[i] = (qoi_plus[i] - qoi_minus[i]) / (2.*delta_p);</span>
<a name="l00332"></a>00332 <span class="comment"></span>
<a name="l00333"></a>00333 <span class="comment">      for (unsigned int i=0; i != Nq; ++i)</span>
<a name="l00334"></a>00334 <span class="comment">        if (qoi_indices.has_index(i))</span>
<a name="l00335"></a>00335 <span class="comment">          sensitivities[i][j] = partialq_partialp[i] +</span>
<a name="l00336"></a>00336 <span class="comment">            this-&gt;get_adjoint_rhs(i).dot(this-&gt;get_sensitivity_solution(i));</span>
<a name="l00337"></a>00337 <span class="comment">    }</span>
<a name="l00338"></a>00338 <span class="comment"></span>
<a name="l00339"></a>00339 <span class="comment">  // All parameters have been reset.</span>
<a name="l00340"></a>00340 <span class="comment">  // Don&#39;t leave the qoi or system changed - principle of least</span>
<a name="l00341"></a>00341 <span class="comment">  // surprise.</span>
<a name="l00342"></a>00342 <span class="comment">  this-&gt;assemble();</span>
<a name="l00343"></a>00343 <span class="comment">  this-&gt;rhs-&gt;close();</span>
<a name="l00344"></a>00344 <span class="comment">  this-&gt;matrix-&gt;close();</span>
<a name="l00345"></a>00345 <span class="comment">  this-&gt;assemble_qoi(qoi_indices);</span>
<a name="l00346"></a>00346 <span class="comment">}</span>
<a name="l00347"></a>00347 <span class="comment">*/</span>
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 
<a name="l00350"></a>00350 
<a name="l00351"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a71c8cb9e4c0153683cbdd3499eb8728d">00351</a> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a>* <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a71c8cb9e4c0153683cbdd3499eb8728d">LinearImplicitSystem::get_linear_solver</a>()<span class="keyword"> const</span>
<a name="l00352"></a>00352 <span class="keyword"></span>{
<a name="l00353"></a>00353   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a7cc68891fa9f44ded49b9b84c057cb32">linear_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>();
<a name="l00354"></a>00354 }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a474c50db652e175cfc55a3f6b5c6cee3">00358</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a474c50db652e175cfc55a3f6b5c6cee3">LinearImplicitSystem::release_linear_solver</a>(<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a>*)<span class="keyword"> const</span>
<a name="l00359"></a>00359 <span class="keyword"></span>{
<a name="l00360"></a>00360 }
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a><a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#aa64262ff0919aea327cd1d298e386353">00364</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#aa64262ff0919aea327cd1d298e386353">LinearImplicitSystem::assembly</a>(<span class="keywordtype">bool</span>, 
<a name="l00365"></a>00365                                     <span class="keywordtype">bool</span>)
<a name="l00366"></a>00366 {
<a name="l00367"></a>00367   <span class="comment">// Residual R(u(p),p) := A(p)*u(p) - b(p)</span>
<a name="l00368"></a>00368   <span class="comment">// partial R / partial u = A</span>
<a name="l00369"></a>00369 
<a name="l00370"></a>00370   this-&gt;<a class="code" href="classlibMesh_1_1LinearImplicitSystem.php#a6446a3daa539c257cc3d621ec0040c35">assemble</a>();
<a name="l00371"></a>00371   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00372"></a>00372   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   *(this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>) *= -1.0;
<a name="l00375"></a>00375   this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>(*this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>, *this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
