<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">linear_solver.C</div>  </div>
</div>
<div class="contents">
<a href="linear__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: linear_solver.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="laspack__linear__solver_8h.php">laspack_linear_solver.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="petsc__linear__solver_8h.php">petsc_linear_solver.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="trilinos__aztec__linear__solver_8h.php">trilinos_aztec_linear_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="preconditioner_8h.php">preconditioner.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// LinearSolver members</span>
<a name="l00037"></a>00037 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00038"></a>00038 AutoPtr&lt;LinearSolver&lt;T&gt; &gt;
<a name="l00039"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a726d0a8d474d3f18cdff5485afe7d63a">00039</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a726d0a8d474d3f18cdff5485afe7d63a">LinearSolver&lt;T&gt;::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <span class="comment">// Build the appropriate solver</span>
<a name="l00042"></a>00042   <span class="keywordflow">switch</span> (solver_package)
<a name="l00043"></a>00043     {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMesh.php#aeb2a777af969e03421c99c4afe9d68a0">LASPACK_SOLVERS</a>:
<a name="l00048"></a>00048       {
<a name="l00049"></a>00049         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1LaspackLinearSolver.php">LaspackLinearSolver&lt;T&gt;</a>);
<a name="l00050"></a>00050         <span class="keywordflow">return</span> ap;
<a name="l00051"></a>00051       }
<a name="l00052"></a>00052 <span class="preprocessor">#endif</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8a4bb6e669bd80e3d232092e60df464572">PETSC_SOLVERS</a>:
<a name="l00057"></a>00057       {
<a name="l00058"></a>00058         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php">PetscLinearSolver&lt;T&gt;</a>);
<a name="l00059"></a>00059         <span class="keywordflow">return</span> ap;
<a name="l00060"></a>00060       }
<a name="l00061"></a>00061 <span class="preprocessor">#endif</span>
<a name="l00062"></a>00062 <span class="preprocessor"></span>
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMesh.php#aa27e267f495ee0599f7cd8981c0cf7ad">TRILINOS_SOLVERS</a>:
<a name="l00066"></a>00066       {
<a name="l00067"></a>00067         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1AztecLinearSolver.php">AztecLinearSolver&lt;T&gt;</a>);
<a name="l00068"></a>00068         <span class="keywordflow">return</span> ap;
<a name="l00069"></a>00069       }
<a name="l00070"></a>00070 <span class="preprocessor">#endif</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>
<a name="l00072"></a>00072     <span class="keywordflow">default</span>:
<a name="l00073"></a>00073       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  Unrecognized solver package: &quot;</span>
<a name="l00074"></a>00074                     &lt;&lt; solver_package
<a name="l00075"></a>00075                     &lt;&lt; std::endl;
<a name="l00076"></a>00076       libmesh_error();
<a name="l00077"></a>00077     }
<a name="l00078"></a>00078     
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;T&gt;</a> &gt; ap(NULL);
<a name="l00080"></a>00080   <span class="keywordflow">return</span> ap;    
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00084"></a>00084 <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a>
<a name="l00085"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a32740239cc7991d77b4166331514f2ad">00085</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a32740239cc7991d77b4166331514f2ad">LinearSolver&lt;T&gt;::preconditioner_type</a> ()<span class="keyword"> const</span>
<a name="l00086"></a>00086 <span class="keyword"></span>{
<a name="l00087"></a>00087   <span class="keywordflow">if</span>(_preconditioner)
<a name="l00088"></a>00088     <span class="keywordflow">return</span> _preconditioner-&gt;type();
<a name="l00089"></a>00089     
<a name="l00090"></a>00090   <span class="keywordflow">return</span> _preconditioner_type;
<a name="l00091"></a>00091 }
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00094"></a>00094 <span class="keywordtype">void</span>
<a name="l00095"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a9bacfd14b9ad9cc5a996125dace2a021">00095</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a9bacfd14b9ad9cc5a996125dace2a021">LinearSolver&lt;T&gt;::set_preconditioner_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> pct)
<a name="l00096"></a>00096 {
<a name="l00097"></a>00097   <span class="keywordflow">if</span>(_preconditioner)
<a name="l00098"></a>00098     _preconditioner-&gt;set_type(pct);
<a name="l00099"></a>00099   <span class="keywordflow">else</span>
<a name="l00100"></a>00100     _preconditioner_type = pct;
<a name="l00101"></a>00101 }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00104"></a>00104 <span class="keywordtype">void</span>
<a name="l00105"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#ae800697a18767330e32c14cc1c06aa91">00105</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#ae800697a18767330e32c14cc1c06aa91">LinearSolver&lt;T&gt;::attach_preconditioner</a>(<a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner&lt;T&gt;</a> * preconditioner)
<a name="l00106"></a>00106 {
<a name="l00107"></a>00107   <span class="keywordflow">if</span>(this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>)
<a name="l00108"></a>00108   {
<a name="l00109"></a>00109     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a>&lt;&lt;<span class="stringliteral">&quot;Preconditioner must be attached before the solver is initialized!&quot;</span>&lt;&lt;std::endl;
<a name="l00110"></a>00110     libmesh_error();
<a name="l00111"></a>00111   }
<a name="l00112"></a>00112   
<a name="l00113"></a>00113   _preconditioner_type = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af09677d7fa99ef863f62c4f26266b27f">SHELL_PRECOND</a>;
<a name="l00114"></a>00114   _preconditioner = preconditioner;
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00118"></a>00118 <span class="keywordtype">void</span>
<a name="l00119"></a><a class="code" href="classlibMesh_1_1LinearSolver.php#a04858dd8634c68ff5d301495d750224e">00119</a> <a class="code" href="classlibMesh_1_1LinearSolver.php#a04858dd8634c68ff5d301495d750224e">LinearSolver&lt;T&gt;::restrict_solve_to</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;* <span class="keyword">const</span> dofs,
<a name="l00120"></a>00120                                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137">SubsetSolveMode</a> <span class="comment">/*subset_solve_mode*/</span>)
<a name="l00121"></a>00121 {
<a name="l00122"></a>00122   <span class="keywordflow">if</span>(dofs!=NULL)
<a name="l00123"></a>00123     {
<a name="l00124"></a>00124       libmesh_not_implemented();
<a name="l00125"></a>00125     }
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00131"></a>00131 <span class="comment">// Explicit instantiations</span>
<a name="l00132"></a>00132 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver&lt;Number&gt;</a>;
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 } <span class="comment">// namespace libMesh</span>
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
