<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">location_maps.C</div>  </div>
</div>
<div class="contents">
<a href="location__maps_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// $Id: location_maps.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00004"></a>00004 
<a name="l00005"></a>00005 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00006"></a>00006 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00007"></a>00007   
<a name="l00008"></a>00008 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00009"></a>00009 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00010"></a>00010 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00011"></a>00011 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00012"></a>00012   
<a name="l00013"></a>00013 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00014"></a>00014 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00015"></a>00015 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00016"></a>00016 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00017"></a>00017   
<a name="l00018"></a>00018 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00019"></a>00019 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00020"></a>00020 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// C++ Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;utility&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="location__maps_8h.php">location_maps.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="node_8h.php">node.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="keyword">namespace</span>
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040   <span class="keyword">using</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">libMesh::Real</a>;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">// 10 bits per coordinate, to work with 32+ bit machines</span>
<a name="l00043"></a>00043   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> chunkmax = 1024;
<a name="l00044"></a>00044   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> chunkfloat = 1024.0;
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">namespace </span>libMesh
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00054"></a><a class="code" href="classlibMesh_1_1LocationMap.php#abadcd2f57010852e4d343171bf225cd6">00054</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LocationMap.php#abadcd2f57010852e4d343171bf225cd6">LocationMap&lt;T&gt;::init</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00057"></a>00057   <span class="comment">// for non-serial meshes</span>
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (!mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00059"></a>00059     parallel_only();
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   START_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;LocationMap&quot;</span>);
<a name="l00062"></a>00062 
<a name="l00063"></a>00063   <span class="comment">// Clear the old map</span>
<a name="l00064"></a>00064   _map.clear();
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">// Cache a bounding box</span>
<a name="l00067"></a>00067   _lower_bound.clear();
<a name="l00068"></a>00068   _lower_bound.resize(LIBMESH_DIM, <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>());
<a name="l00069"></a>00069   _upper_bound.clear();
<a name="l00070"></a>00070   _upper_bound.resize(LIBMESH_DIM, -<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;Real&gt;::max</a>());
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00073"></a>00073   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00074"></a>00074 
<a name="l00075"></a>00075   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00076"></a>00076     {
<a name="l00077"></a>00077       <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = *it;
<a name="l00078"></a>00078 
<a name="l00079"></a>00079       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != LIBMESH_DIM; ++i)
<a name="l00080"></a>00080         {
<a name="l00081"></a>00081           <span class="comment">// Expand the bounding box if necessary</span>
<a name="l00082"></a>00082           _lower_bound[i] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(_lower_bound[i],
<a name="l00083"></a>00083                                      (*node)(i));
<a name="l00084"></a>00084           _upper_bound[i] = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(_upper_bound[i],
<a name="l00085"></a>00085                                      (*node)(i));
<a name="l00086"></a>00086         }
<a name="l00087"></a>00087     }
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// On a parallel mesh we might not yet have a full bounding box</span>
<a name="l00090"></a>00090   <span class="keywordflow">if</span> (!mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00091"></a>00091     {
<a name="l00092"></a>00092       <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(_lower_bound);
<a name="l00093"></a>00093       <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">Parallel::max</a>(_upper_bound);
<a name="l00094"></a>00094     }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096   this-&gt;fill(mesh);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   STOP_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;LocationMap&quot;</span>);
<a name="l00099"></a>00099 }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00104"></a><a class="code" href="classlibMesh_1_1LocationMap.php#a89b7c1be90770909877d32b8c2481ba4">00104</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LocationMap.php#a89b7c1be90770909877d32b8c2481ba4">LocationMap&lt;T&gt;::insert</a>(T &amp;t)
<a name="l00105"></a>00105 {
<a name="l00106"></a>00106   this-&gt;_map.insert(std::make_pair(this-&gt;key(this-&gt;point_of(t)), &amp;t));
<a name="l00107"></a>00107 }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a>00111 <span class="keyword">template</span> &lt;&gt;
<a name="l00112"></a><a class="code" href="classlibMesh_1_1LocationMap.php#a5081c3ab681dfb8af2ceb1ebd7e9f33d">00112</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1LocationMap.php#a7bbf664429b19a3744a74836121bcc11">LocationMap&lt;Node&gt;::point_of</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; node)<span class="keyword"> const</span>
<a name="l00113"></a>00113 <span class="keyword"></span>{
<a name="l00114"></a>00114   <span class="keywordflow">return</span> node;
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 <span class="keyword">template</span> &lt;&gt;
<a name="l00120"></a><a class="code" href="classlibMesh_1_1LocationMap.php#a2dd9aea9b965b044f9b47772ad50e23a">00120</a> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Elem&gt;::point_of</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>&amp; elem)<span class="keyword"> const</span>
<a name="l00121"></a>00121 <span class="keyword"></span>{
<a name="l00122"></a>00122   <span class="keywordflow">return</span> elem.<a class="code" href="classlibMesh_1_1Elem.php#a462388b471a3cd8d88e9452a00299f8e">centroid</a>();
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00128"></a><a class="code" href="classlibMesh_1_1LocationMap.php#aaf94e1934f882d48664d7496ea27cb7e">00128</a> T* <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;T&gt;::find</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00129"></a>00129                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol)
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   START_LOG(<span class="stringliteral">&quot;find()&quot;</span>,<span class="stringliteral">&quot;LocationMap&quot;</span>);
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   <span class="comment">// Look for a likely key in the multimap</span>
<a name="l00134"></a>00134   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pointkey = this-&gt;key(p);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="comment">// Look for the exact key first</span>
<a name="l00137"></a>00137   std::pair&lt;<span class="keyword">typename</span> map_type::iterator,
<a name="l00138"></a>00138             <span class="keyword">typename</span> map_type::iterator&gt;
<a name="l00139"></a>00139     pos = _map.equal_range(pointkey);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="keywordflow">while</span> (pos.first != pos.second)
<a name="l00142"></a>00142     <span class="keywordflow">if</span> (p.<a class="code" href="classlibMesh_1_1TypeVector.php#aebdea0b3d6d9b9e699a15c9a9f532d8a">absolute_fuzzy_equals</a>
<a name="l00143"></a>00143          (this-&gt;point_of(*(pos.first-&gt;second)), tol))
<a name="l00144"></a>00144       {
<a name="l00145"></a>00145         STOP_LOG(<span class="stringliteral">&quot;find()&quot;</span>,<span class="stringliteral">&quot;LocationMap&quot;</span>);
<a name="l00146"></a>00146         <span class="keywordflow">return</span> pos.first-&gt;second;
<a name="l00147"></a>00147       }
<a name="l00148"></a>00148     <span class="keywordflow">else</span>
<a name="l00149"></a>00149       ++pos.first;
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   <span class="comment">// Look for neighboring bins&#39; keys next</span>
<a name="l00152"></a>00152   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> xoffset = -1; xoffset != 2; ++xoffset)
<a name="l00153"></a>00153     {
<a name="l00154"></a>00154       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> yoffset = -1; yoffset != 2; ++yoffset)
<a name="l00155"></a>00155         {
<a name="l00156"></a>00156           <span class="keywordflow">for</span> (<span class="keywordtype">int</span> zoffset = -1; zoffset != 2; ++zoffset)
<a name="l00157"></a>00157             {
<a name="l00158"></a>00158               std::pair&lt;<span class="keyword">typename</span> map_type::iterator,
<a name="l00159"></a>00159                         <span class="keyword">typename</span> map_type::iterator&gt;
<a name="l00160"></a>00160                 pos = _map.equal_range(pointkey +
<a name="l00161"></a>00161                                        xoffset*chunkmax*chunkmax +
<a name="l00162"></a>00162                                        yoffset*chunkmax +
<a name="l00163"></a>00163                                        zoffset);
<a name="l00164"></a>00164               <span class="keywordflow">while</span> (pos.first != pos.second)
<a name="l00165"></a>00165                 <span class="keywordflow">if</span> (p.<a class="code" href="classlibMesh_1_1TypeVector.php#aebdea0b3d6d9b9e699a15c9a9f532d8a">absolute_fuzzy_equals</a>
<a name="l00166"></a>00166                      (this-&gt;point_of(*(pos.first-&gt;second)), tol))
<a name="l00167"></a>00167                   {
<a name="l00168"></a>00168                     STOP_LOG(<span class="stringliteral">&quot;find()&quot;</span>,<span class="stringliteral">&quot;LocationMap&quot;</span>);
<a name="l00169"></a>00169                     <span class="keywordflow">return</span> pos.first-&gt;second;
<a name="l00170"></a>00170                   }
<a name="l00171"></a>00171                 <span class="keywordflow">else</span>
<a name="l00172"></a>00172                   ++pos.first;
<a name="l00173"></a>00173             }
<a name="l00174"></a>00174         }
<a name="l00175"></a>00175     }
<a name="l00176"></a>00176   
<a name="l00177"></a>00177   STOP_LOG(<span class="stringliteral">&quot;find()&quot;</span>,<span class="stringliteral">&quot;LocationMap&quot;</span>);
<a name="l00178"></a>00178   <span class="keywordflow">return</span> NULL;
<a name="l00179"></a>00179 }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00184"></a><a class="code" href="classlibMesh_1_1LocationMap.php#acd5cf2b0831dff2432584917f800fe5e">00184</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;T&gt;::key</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00185"></a>00185 {
<a name="l00186"></a>00186   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xscaled = (p(0) - _lower_bound[0])/
<a name="l00187"></a>00187                  (_upper_bound[0] - _lower_bound[0]),
<a name="l00188"></a>00188 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>       yscaled = (p(1) - _lower_bound[1])/
<a name="l00190"></a>00190                  (_upper_bound[1] - _lower_bound[1]),
<a name="l00191"></a>00191 <span class="preprocessor">#else</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span>       yscaled = 0,
<a name="l00193"></a>00193 <span class="preprocessor">#endif</span>
<a name="l00194"></a>00194 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span>       zscaled = (p(2) - _lower_bound[2])/
<a name="l00196"></a>00196                  (_upper_bound[2] - _lower_bound[2]);
<a name="l00197"></a>00197 <span class="preprocessor">#else</span>
<a name="l00198"></a>00198 <span class="preprocessor"></span>       zscaled = 0;
<a name="l00199"></a>00199 <span class="preprocessor">#endif</span>
<a name="l00200"></a>00200 <span class="preprocessor"></span>
<a name="l00201"></a>00201   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n0 = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span> (chunkfloat * xscaled),
<a name="l00202"></a>00202                n1 = static_cast&lt;unsigned int&gt; (chunkfloat * yscaled),
<a name="l00203"></a>00203                n2 = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span> (chunkfloat * zscaled);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="keywordflow">return</span> chunkmax*chunkmax*n0 + chunkmax*n1 + n2;
<a name="l00206"></a>00206 }
<a name="l00207"></a>00207 
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 <span class="keyword">template</span> &lt;&gt;
<a name="l00211"></a><a class="code" href="classlibMesh_1_1LocationMap.php#a4d21a913b12444931760a7c864c8b3dd">00211</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;::fill</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00212"></a>00212 {
<a name="l00213"></a>00213   <span class="comment">// Populate the nodes map</span>
<a name="l00214"></a>00214   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>  it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>(),
<a name="l00215"></a>00215                           end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00216"></a>00216   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00217"></a>00217     this-&gt;insert(**it);
<a name="l00218"></a>00218 }
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 <span class="keyword">template</span> &lt;&gt;
<a name="l00223"></a><a class="code" href="classlibMesh_1_1LocationMap.php#a946cf3d3b411a8e77402c4164734ff5a">00223</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Elem&gt;::fill</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00224"></a>00224 {
<a name="l00225"></a>00225   <span class="comment">// Populate the elem map</span>
<a name="l00226"></a>00226   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(),
<a name="l00227"></a>00227                                    end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00228"></a>00228   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00229"></a>00229     this-&gt;insert(**it);
<a name="l00230"></a>00230 }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Elem&gt;</a>;
<a name="l00235"></a>00235 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a>;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
