<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">location_maps.h</div>  </div>
</div>
<div class="contents">
<a href="location__maps_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: location_maps.h 4059 2010-10-22 22:21:42Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __location_maps_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __location_maps_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include LIBMESH_INCLUDE_UNORDERED_MAP</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Forward Declarations -----------------------------</span>
<a name="l00040"></a>00040 <span class="keyword">class </span>Elem;
<a name="l00041"></a>00041 <span class="keyword">class </span>MeshBase;
<a name="l00042"></a>00042 <span class="keyword">class </span>Node;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00051"></a>00051 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00052"></a><a class="code" href="classlibMesh_1_1LocationMap.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap</a>
<a name="l00053"></a>00053 {
<a name="l00054"></a><a class="code" href="classlibMesh_1_1LocationMap.php#ac08e2a93d4c4655e04b6e7fca26b9546">00054</a>   <span class="keyword">typedef</span> LIBMESH_BEST_UNORDERED_MULTIMAP&lt;unsigned int, T*&gt; <a class="code" href="classlibMesh_1_1LocationMap.php#ac08e2a93d4c4655e04b6e7fca26b9546">map_type</a>;
<a name="l00055"></a>00055 <span class="keyword">public</span>: 
<a name="l00056"></a>00056   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LocationMap.php#abadcd2f57010852e4d343171bf225cd6">init</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;);
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1LocationMap.php#ad503d4fe9a00525f2d890d8175f448dd">00058</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LocationMap.php#ad503d4fe9a00525f2d890d8175f448dd">clear</a>() { <a class="code" href="classlibMesh_1_1LocationMap.php#a12a594f9208b0add2b695f7c8eda26e0">_map</a>.clear(); }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LocationMap.php#a89b7c1be90770909877d32b8c2481ba4">insert</a>(T&amp;);
<a name="l00061"></a>00061 
<a name="l00062"></a><a class="code" href="classlibMesh_1_1LocationMap.php#ae5e9f2ba3dd8d494e6308459e2bba569">00062</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LocationMap.php#ae5e9f2ba3dd8d494e6308459e2bba569">empty</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1LocationMap.php#a12a594f9208b0add2b695f7c8eda26e0">_map</a>.empty(); }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   T* <a class="code" href="classlibMesh_1_1LocationMap.php#aaf94e1934f882d48664d7496ea27cb7e">find</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;,
<a name="l00065"></a>00065           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol = TOLERANCE);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1LocationMap.php#a7bbf664429b19a3744a74836121bcc11">point_of</a>(<span class="keyword">const</span> T&amp;) <span class="keyword">const</span>;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="keyword">protected</span>:
<a name="l00070"></a>00070   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1LocationMap.php#acd5cf2b0831dff2432584917f800fe5e">key</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp;);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LocationMap.php#ad137ac856b582e6ddf9938fcaf932f45">fill</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="keyword">private</span>: 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1LocationMap.php#a12a594f9208b0add2b695f7c8eda26e0">00075</a>   <a class="code" href="classlibMesh_1_1LocationMap.php#ac08e2a93d4c4655e04b6e7fca26b9546">map_type</a>          <a class="code" href="classlibMesh_1_1LocationMap.php#a12a594f9208b0add2b695f7c8eda26e0">_map</a>;
<a name="l00076"></a><a class="code" href="classlibMesh_1_1LocationMap.php#ac268fa6a867caf9461d8aa319a7d4bac">00076</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1LocationMap.php#ac268fa6a867caf9461d8aa319a7d4bac">_lower_bound</a>;
<a name="l00077"></a><a class="code" href="classlibMesh_1_1LocationMap.php#a3250becb10db7621a4e0edb32585d9c2">00077</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1LocationMap.php#a3250becb10db7621a4e0edb32585d9c2">_upper_bound</a>;
<a name="l00078"></a>00078 };
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 } <span class="comment">// namespace libMesh</span>
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="preprocessor">#endif // #define __location_maps_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
