<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mapvector.h</div>  </div>
</div>
<div class="contents">
<a href="mapvector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mapvector.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mapvector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mapvector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">namespace </span>libMesh
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Val&gt;
<a name="l00042"></a><a class="code" href="classlibMesh_1_1mapvector.php">00042</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1mapvector.php">mapvector</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1map.php">map</a>&lt;unsigned int, Val&gt;
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a><a class="code" href="classlibMesh_1_1mapvector.php#a60b0943d54eec756f799452f2de8c2b4">00045</a>   <span class="keyword">typedef</span> std::map&lt;unsigned int, Val&gt; <a class="code" href="classlibMesh_1_1mapvector.php#a60b0943d54eec756f799452f2de8c2b4">maptype</a>;
<a name="l00046"></a>00046 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1mapvector.php#a90e69abe75fd78d02899b3f44a5b4546">00047</a>   Val&amp; <a class="code" href="classlibMesh_1_1mapvector.php#a90e69abe75fd78d02899b3f44a5b4546">operator[] </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;k)
<a name="l00048"></a>00048   {
<a name="l00049"></a>00049     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1mapvector.php#a90e69abe75fd78d02899b3f44a5b4546">maptype::operator[]</a>(k);
<a name="l00050"></a>00050   }
<a name="l00051"></a><a class="code" href="classlibMesh_1_1mapvector.php#a983ee5f7794fa0572d806d2a5f824d4d">00051</a>   Val <a class="code" href="classlibMesh_1_1mapvector.php#a90e69abe75fd78d02899b3f44a5b4546">operator[] </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp;k)<span class="keyword"> const </span>
<a name="l00052"></a>00052 <span class="keyword">  </span>{
<a name="l00053"></a>00053     <span class="keyword">typename</span> maptype::const_iterator it = this-&gt;find(k);
<a name="l00054"></a>00054       <span class="keywordflow">return</span> it == this-&gt;<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>().<a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a>? Val() : it-&gt;second;
<a name="l00055"></a>00055   }
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">00057</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">veclike_iterator</a>
<a name="l00058"></a>00058   {
<a name="l00059"></a>00059   <span class="keyword">public</span>:
<a name="l00060"></a><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#af50fdb7468cd066353c8f9210977e861">00060</a>     <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#af50fdb7468cd066353c8f9210977e861">veclike_iterator</a>(<span class="keyword">const</span> <span class="keyword">typename</span> maptype::iterator &amp;i)
<a name="l00061"></a>00061       : <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a>(i) {}
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a34f44c8eaf2db607f20de79783311eaa">00063</a>     <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#af50fdb7468cd066353c8f9210977e861">veclike_iterator</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">veclike_iterator</a> &amp;i)
<a name="l00064"></a>00064       : <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a>(i.<a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a>) {}
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a739be0b06491147ab4b42e097399e709">00066</a>     Val&amp; <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a739be0b06491147ab4b42e097399e709">operator*</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a>-&gt;second; }
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#aa81a057eaf103febed6090f29ad5148a">00068</a>     <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">veclike_iterator</a>&amp; <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#aa81a057eaf103febed6090f29ad5148a">operator++</a>() { ++<a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a>; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00069"></a>00069 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a9b731461d01690b88912114b328a7d87">00070</a>     <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">veclike_iterator</a> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a9b731461d01690b88912114b328a7d87">operator++</a>(<span class="keywordtype">int</span>) {
<a name="l00071"></a>00071       <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">veclike_iterator</a> i = *<span class="keyword">this</span>;
<a name="l00072"></a>00072       ++(*this);
<a name="l00073"></a>00073       <span class="keywordflow">return</span> i;
<a name="l00074"></a>00074     }
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a1c713807d666bde845d214a46f01d21f">00076</a>     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a1c713807d666bde845d214a46f01d21f">operator==</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">veclike_iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00077"></a>00077       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a> == other.<a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a>;
<a name="l00078"></a>00078     }
<a name="l00079"></a>00079 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a68b56febd5dd739b8f417b9221756730">00080</a>     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a68b56febd5dd739b8f417b9221756730">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">veclike_iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00081"></a>00081       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a> != other.<a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a>;
<a name="l00082"></a>00082     }
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">00084</a>     <span class="keyword">typename</span> maptype::iterator <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php#a3d227c6a50debe1dbe02176c8de4a482">it</a>;
<a name="l00085"></a>00085   };
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php">00087</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a>
<a name="l00088"></a>00088   {
<a name="l00089"></a>00089   <span class="keyword">public</span>:
<a name="l00090"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a428588fd73293dc44e7b846d7a9af3f8">00090</a>     <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a428588fd73293dc44e7b846d7a9af3f8">const_veclike_iterator</a>(<span class="keyword">const</span> <span class="keyword">typename</span> maptype::const_iterator &amp;i)
<a name="l00091"></a>00091       : <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>(i) {}
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a38379d286e682a5c64cbd928c82be13e">00093</a>     <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a428588fd73293dc44e7b846d7a9af3f8">const_veclike_iterator</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a> &amp;i)
<a name="l00094"></a>00094       : <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>(i.<a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>) {}
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5004d48bd09a610ce061d5e66e147491">00096</a>     <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a428588fd73293dc44e7b846d7a9af3f8">const_veclike_iterator</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">veclike_iterator</a> &amp;i)
<a name="l00097"></a>00097       : <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>(i.<a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>) {}
<a name="l00098"></a>00098 
<a name="l00099"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a9591a43b9fcbb9c366e602e3c57e3fe7">00099</a>     <span class="keyword">const</span> Val&amp; <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a9591a43b9fcbb9c366e602e3c57e3fe7">operator*</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>-&gt;second; }
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#aba4903271ef9232905957110cd0f3b0e">00101</a>     <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a>&amp; <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#aba4903271ef9232905957110cd0f3b0e">operator++</a>() { ++<a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>; <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00102"></a>00102 
<a name="l00103"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a41d8fa569b98663bb4cbb6dcf1ed51d4">00103</a>     <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a> <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a41d8fa569b98663bb4cbb6dcf1ed51d4">operator++</a>(<span class="keywordtype">int</span>) {
<a name="l00104"></a>00104       <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">veclike_iterator</a> i = *<span class="keyword">this</span>;
<a name="l00105"></a>00105       ++(*this);
<a name="l00106"></a>00106       <span class="keywordflow">return</span> i;
<a name="l00107"></a>00107     }
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a03b52a11f654f66ea8c23d30c7a45fd8">00109</a>     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a03b52a11f654f66ea8c23d30c7a45fd8">operator==</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00110"></a>00110       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a> == other.<a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>;
<a name="l00111"></a>00111     }
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a8ba3bfde2fcd4c1cec2f27cc716f52f2">00113</a>     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a8ba3bfde2fcd4c1cec2f27cc716f52f2">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php">const_veclike_iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00114"></a>00114       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a> != other.<a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>;
<a name="l00115"></a>00115     }
<a name="l00116"></a>00116 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">00117</a>     <span class="keyword">typename</span> maptype::const_iterator <a class="code" href="classlibMesh_1_1mapvector_1_1const__veclike__iterator.php#a5f076a0279a1b9deed63747824e5349c">it</a>;
<a name="l00118"></a>00118   };
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">00120</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) {
<a name="l00121"></a>00121       <a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">maptype::erase</a>(i);
<a name="l00122"></a>00122   }
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1mapvector.php#a20dddbacd59d863d47a65aeda6162ae9">00124</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1mapvector.php#a20dddbacd59d863d47a65aeda6162ae9">erase</a>(<span class="keyword">const</span> veclike_iterator &amp;pos) {
<a name="l00125"></a>00125       <a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">maptype::erase</a>(pos.it);
<a name="l00126"></a>00126   }
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">00128</a>   veclike_iterator <a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>() {
<a name="l00129"></a>00129     <span class="keywordflow">return</span> veclike_iterator(maptype::begin());
<a name="l00130"></a>00130   }
<a name="l00131"></a>00131 
<a name="l00132"></a><a class="code" href="classlibMesh_1_1mapvector.php#aa0b830a1ab28ea533d552f5734bd37d5">00132</a>   const_veclike_iterator <a class="code" href="classlibMesh_1_1mapvector.php#aa0b830a1ab28ea533d552f5734bd37d5">begin</a>()<span class="keyword"> const </span>{
<a name="l00133"></a>00133     <span class="keywordflow">return</span> const_veclike_iterator(maptype::begin());
<a name="l00134"></a>00134   }
<a name="l00135"></a>00135 
<a name="l00136"></a><a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">00136</a>   veclike_iterator <a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>() {
<a name="l00137"></a>00137     <span class="keywordflow">return</span> veclike_iterator(maptype::end());
<a name="l00138"></a>00138   }
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1mapvector.php#adaf494911c5af405ebe02285b1b75f69">00140</a>   const_veclike_iterator <a class="code" href="classlibMesh_1_1mapvector.php#adaf494911c5af405ebe02285b1b75f69">end</a>()<span class="keyword"> const </span>{
<a name="l00141"></a>00141     <span class="keywordflow">return</span> const_veclike_iterator(maptype::end());
<a name="l00142"></a>00142   }
<a name="l00143"></a>00143 };
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 } <span class="comment">// namespace libMesh</span>
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 <span class="preprocessor">#endif // __mapvector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
