<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_base.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__base_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_base.C 4402 2011-04-22 23:10:19Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// library configuration</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::min</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>       <span class="comment">// for std::multimap</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sstream&gt;</span>   <span class="comment">// for std::ostringstream</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="partitioner_8h.php">partitioner.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__base_8h.php">point_locator_base.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// MeshBase class member functions</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1MeshBase.php#af80914e03e3731328990787b58a7c440">00047</a> <a class="code" href="classlibMesh_1_1MeshBase.php#af80914e03e3731328990787b58a7c440">MeshBase::MeshBase</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d) :
<a name="l00048"></a>00048   boundary_info  (new <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>(*this)),
<a name="l00049"></a>00049   _n_parts       (1),
<a name="l00050"></a>00050   _dim           (d),
<a name="l00051"></a>00051   _is_prepared   (false),
<a name="l00052"></a>00052   _point_locator (NULL),
<a name="l00053"></a>00053   _partitioner   (NULL),
<a name="l00054"></a>00054   _skip_partitioning(false)
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   libmesh_assert (LIBMESH_DIM &lt;= 3);
<a name="l00057"></a>00057   libmesh_assert (LIBMESH_DIM &gt;= <a class="code" href="classlibMesh_1_1MeshBase.php#ad20b418f0628a701570475c141aec0d0">_dim</a>);
<a name="l00058"></a>00058   libmesh_assert (<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">libMesh::initialized</a>());
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1MeshBase.php#ac60a1d5f8f233b0d0349d5298c90976b">00063</a> <a class="code" href="classlibMesh_1_1MeshBase.php#af80914e03e3731328990787b58a7c440">MeshBase::MeshBase</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; other_mesh) :
<a name="l00064"></a>00064   boundary_info  (new <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>(*this)),
<a name="l00065"></a>00065   _n_parts       (other_mesh._n_parts),
<a name="l00066"></a>00066   _dim           (other_mesh._dim),
<a name="l00067"></a>00067   _is_prepared   (other_mesh._is_prepared),
<a name="l00068"></a>00068   _point_locator (NULL),
<a name="l00069"></a>00069   _partitioner   (other_mesh._partitioner-&gt;clone()),
<a name="l00070"></a>00070   _skip_partitioning(other_mesh._skip_partitioning)
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a455beac9da4aeffaa6558da3714cbeaf">00076</a> <a class="code" href="classlibMesh_1_1MeshBase.php#a455beac9da4aeffaa6558da3714cbeaf">MeshBase::~MeshBase</a>()
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">clear</a>();
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   libmesh_assert (!<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">libMesh::closed</a>());
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">00085</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">MeshBase::prepare_for_use</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements)
<a name="l00086"></a>00086 {  
<a name="l00087"></a>00087   parallel_only();
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// Renumber the nodes and elements so that they in contiguous</span>
<a name="l00090"></a>00090   <span class="comment">// blocks.  By default, skip_renumber_nodes_and_elements is false,</span>
<a name="l00091"></a>00091   <span class="comment">// however we may skip this step by passing</span>
<a name="l00092"></a>00092   <span class="comment">// skip_renumber_nodes_and_elements==true to this function.</span>
<a name="l00093"></a>00093   <span class="comment">//</span>
<a name="l00094"></a>00094   <span class="comment">// Instances where you if prepare_for_use() should not renumber the nodes</span>
<a name="l00095"></a>00095   <span class="comment">// and elements include reading in e.g. an xda/r or gmv file. In</span>
<a name="l00096"></a>00096   <span class="comment">// this case, the ordering of the nodes may depend on an accompanying</span>
<a name="l00097"></a>00097   <span class="comment">// solution, and the node ordering cannot be changed.</span>
<a name="l00098"></a>00098   <span class="keywordflow">if</span>(!skip_renumber_nodes_and_elements)
<a name="l00099"></a>00099     this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a29fb19d7d0a036669ea088eb3cbc7bb9">renumber_nodes_and_elements</a>();
<a name="l00100"></a>00100   
<a name="l00101"></a>00101   <span class="comment">// Let all the elements find their neighbors</span>
<a name="l00102"></a>00102   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a7edb2ad9b032287e750880883cdcf0f3">find_neighbors</a>();
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// Partition the mesh.</span>
<a name="l00105"></a>00105   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a8f8f153b5eba75c5514fb4707405551c">partition</a>();
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   <span class="comment">// If we&#39;re using ParallelMesh, we&#39;ll want it parallelized.</span>
<a name="l00108"></a>00108   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a8d57ce79036999648936424bfbab715e">delete_remote_elements</a>();
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="keywordflow">if</span>(!skip_renumber_nodes_and_elements)
<a name="l00111"></a>00111     this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a29fb19d7d0a036669ea088eb3cbc7bb9">renumber_nodes_and_elements</a>();
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="comment">// Reset our PointLocator.  This needs to happen any time the elements</span>
<a name="l00114"></a>00114   <span class="comment">// in the underlying elements in the mesh have changed, so we do it here.</span>
<a name="l00115"></a>00115   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#acc11230de16adce50cbd3edabe8b778a">clear_point_locator</a>();
<a name="l00116"></a>00116 
<a name="l00117"></a>00117   <span class="comment">// The mesh is now prepared for use.</span>
<a name="l00118"></a>00118   <a class="code" href="classlibMesh_1_1MeshBase.php#a013ceb917534084574aa2e00837331bb">_is_prepared</a> = <span class="keyword">true</span>;
<a name="l00119"></a>00119 }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">00123</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">MeshBase::clear</a> ()
<a name="l00124"></a>00124 {
<a name="l00125"></a>00125   <span class="comment">// Reset the number of partitions</span>
<a name="l00126"></a>00126   <a class="code" href="classlibMesh_1_1MeshBase.php#ac7f0635c81f5e24e17d47aa1d4b3ff3c">_n_parts</a> = 1;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="comment">// Reset the _is_prepared flag</span>
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1MeshBase.php#a013ceb917534084574aa2e00837331bb">_is_prepared</a> = <span class="keyword">false</span>;
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">// Clear boundary information</span>
<a name="l00132"></a>00132   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;clear();
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <span class="comment">// Clear our point locator.</span>
<a name="l00135"></a>00135   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#acc11230de16adce50cbd3edabe8b778a">clear_point_locator</a>();
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a4a9a53f02f28310e99f946294a7667d0">00140</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a4a9a53f02f28310e99f946294a7667d0">MeshBase::n_subdomains</a>()<span class="keyword"> const</span>
<a name="l00141"></a>00141 <span class="keyword"></span>{
<a name="l00142"></a>00142   <span class="comment">// This requires an inspection on every processor</span>
<a name="l00143"></a>00143   parallel_only();
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>       el  = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00146"></a>00146   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   std::set&lt;unsigned int&gt; subdomain_ids;
<a name="l00149"></a>00149   
<a name="l00150"></a>00150   <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00151"></a>00151     subdomain_ids.insert((*el)-&gt;subdomain_id());
<a name="l00152"></a>00152 
<a name="l00153"></a>00153   <span class="comment">// Some subdomains may only live on other processors</span>
<a name="l00154"></a>00154   <a class="code" href="namespacelibMesh_1_1Parallel.php#a1250cf393dfd260b929ce540d8ab29c8">Parallel::set_union</a>(subdomain_ids, 0);
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sbd_ids = subdomain_ids.size();
<a name="l00157"></a>00157   <a class="code" href="namespacelibMesh_1_1Parallel.php#a0856815f9d1ce56771e340b45ef80e6c">Parallel::broadcast</a>(n_sbd_ids);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="keywordflow">return</span> n_sbd_ids;
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a8896c14639e1bf4ab9b68209cacc6c6c">00163</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8896c14639e1bf4ab9b68209cacc6c6c">MeshBase::n_nodes_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00164"></a>00164 <span class="keyword"></span>{
<a name="l00165"></a>00165   <span class="comment">// We&#39;re either counting a processor&#39;s nodes or unpartitioned</span>
<a name="l00166"></a>00166   <span class="comment">// nodes</span>
<a name="l00167"></a>00167   libmesh_assert (proc_id &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() ||
<a name="l00168"></a>00168           proc_id == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00169"></a>00169   
<a name="l00170"></a>00170   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a7d6366e57e92fdfecd3150d192956d03">pid_nodes_begin</a>(proc_id),
<a name="l00171"></a>00171                                                   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a329026356ca6689c35b765bb0b58eb01">pid_nodes_end</a>  (proc_id)));
<a name="l00172"></a>00172 }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a3faea8450fee70302028b3b263365ad3">00176</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a3faea8450fee70302028b3b263365ad3">MeshBase::n_elem_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00177"></a>00177 <span class="keyword"></span>{
<a name="l00178"></a>00178   <span class="comment">// We&#39;re either counting a processor&#39;s elements or unpartitioned</span>
<a name="l00179"></a>00179   <span class="comment">// elements</span>
<a name="l00180"></a>00180   libmesh_assert (proc_id &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() ||
<a name="l00181"></a>00181           proc_id == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00182"></a>00182   
<a name="l00183"></a>00183   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae05a5517582637b8469bbae1939d9aaf">pid_elements_begin</a>(proc_id),
<a name="l00184"></a>00184                                                   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a36245c34046bf4b2b4b26bfdb603abd9">pid_elements_end</a>  (proc_id)));
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 
<a name="l00189"></a><a class="code" href="classlibMesh_1_1MeshBase.php#ae428a6b5a2ed0aa5180a906021eca73a">00189</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ae428a6b5a2ed0aa5180a906021eca73a">MeshBase::n_active_elem_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)<span class="keyword"> const</span>
<a name="l00190"></a>00190 <span class="keyword"></span>{
<a name="l00191"></a>00191   libmesh_assert (proc_id &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00192"></a>00192   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ad250f85e39b8bbdfcc6605c6006aa202">active_pid_elements_begin</a>(proc_id),
<a name="l00193"></a>00193                                                   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#adf7c40f7022d79c4b9a96f2284fce248">active_pid_elements_end</a>  (proc_id)));
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195   
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a980d5dccaf993eca14cfc89492c869e9">00198</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a980d5dccaf993eca14cfc89492c869e9">MeshBase::n_sub_elem</a> ()<span class="keyword"> const</span>
<a name="l00199"></a>00199 <span class="keyword"></span>{
<a name="l00200"></a>00200   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ne=0;
<a name="l00201"></a>00201 
<a name="l00202"></a>00202   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>       el  = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00203"></a>00203   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00206"></a>00206     ne += (*el)-&gt;n_sub_elem(); 
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="keywordflow">return</span> ne;
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a8591c0c31abfbde5633d53bf29053ea5">00213</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8591c0c31abfbde5633d53bf29053ea5">MeshBase::n_active_sub_elem</a> ()<span class="keyword"> const</span>
<a name="l00214"></a>00214 <span class="keyword"></span>{
<a name="l00215"></a>00215   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ne=0;
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>       el  = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00218"></a>00218   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00221"></a>00221     ne += (*el)-&gt;n_sub_elem(); 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="keywordflow">return</span> ne;
<a name="l00224"></a>00224 }
<a name="l00225"></a>00225 
<a name="l00226"></a>00226 
<a name="l00227"></a>00227 
<a name="l00228"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a1d2b97fca534b38b4c1e914deb467152">00228</a> std::string <a class="code" href="classlibMesh_1_1MeshBase.php#a1d2b97fca534b38b4c1e914deb467152">MeshBase::get_info</a>()<span class="keyword"> const</span>
<a name="l00229"></a>00229 <span class="keyword"></span>{
<a name="l00230"></a>00230   std::ostringstream <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l00231"></a>00231 
<a name="l00232"></a>00232   out &lt;&lt; <span class="stringliteral">&quot; Mesh Information:&quot;</span>                                  &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00233"></a>00233       &lt;&lt; <span class="stringliteral">&quot;  mesh_dimension()=&quot;</span>    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>()    &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00234"></a>00234       &lt;&lt; <span class="stringliteral">&quot;  spatial_dimension()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">spatial_dimension</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00235"></a>00235       &lt;&lt; <span class="stringliteral">&quot;  n_nodes()=&quot;</span>           &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>()           &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00236"></a>00236       &lt;&lt; <span class="stringliteral">&quot;    n_local_nodes()=&quot;</span>   &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ad25082a75258d635a515e96e6860aa72">n_local_nodes</a>()     &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00237"></a>00237       &lt;&lt; <span class="stringliteral">&quot;  n_elem()=&quot;</span>            &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>()            &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00238"></a>00238       &lt;&lt; <span class="stringliteral">&quot;    n_local_elem()=&quot;</span>    &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a32db8a83b3c6348e1bd9142fb8e92107">n_local_elem</a>()      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00239"></a>00239 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span>      &lt;&lt; <span class="stringliteral">&quot;    n_active_elem()=&quot;</span>   &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>()     &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00241"></a>00241 <span class="preprocessor">#endif</span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>      &lt;&lt; <span class="stringliteral">&quot;  n_subdomains()=&quot;</span>      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a4a9a53f02f28310e99f946294a7667d0">n_subdomains</a>()      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00243"></a>00243       &lt;&lt; <span class="stringliteral">&quot;  n_processors()=&quot;</span>      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">n_processors</a>()      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00244"></a>00244       &lt;&lt; <span class="stringliteral">&quot;  processor_id()=&quot;</span>      &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>()      &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <span class="keywordflow">return</span> out.str();
<a name="l00247"></a>00247 }
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a94180309af3081c9da2a0064e66040e6">00250</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a94180309af3081c9da2a0064e66040e6">MeshBase::print_info</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00251"></a>00251 <span class="keyword"></span>{
<a name="l00252"></a>00252   os &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a1d2b97fca534b38b4c1e914deb467152">get_info</a>()
<a name="l00253"></a>00253      &lt;&lt; std::endl;
<a name="l00254"></a>00254 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 
<a name="l00257"></a><a class="code" href="namespacelibMesh.php#af7144270bc8c5e6dfd0bd1f455ae5c6a">00257</a> std::ostream&amp; <a class="code" href="namespacelibMesh.php#a546a7b5eb3d073add8e1f19af6bcaf82">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m)
<a name="l00258"></a>00258 {
<a name="l00259"></a>00259   m.<a class="code" href="classlibMesh_1_1MeshBase.php#a94180309af3081c9da2a0064e66040e6">print_info</a>(os);
<a name="l00260"></a>00260   <span class="keywordflow">return</span> os;
<a name="l00261"></a>00261 }
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a8f8f153b5eba75c5514fb4707405551c">00264</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8f8f153b5eba75c5514fb4707405551c">MeshBase::partition</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parts)
<a name="l00265"></a>00265 {
<a name="l00266"></a>00266   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1MeshBase.php#a5745bd8ce965d537c6bc95faf78e9f49">skip_partitioning</a>())
<a name="l00267"></a>00267   {
<a name="l00268"></a>00268     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshBase.php#aa07a00e86d68f366d8fe7e4d01140ffc">partitioner</a>().<span class="keyword">get</span>()) <span class="comment">// &quot;NULL&quot; means don&#39;t partition</span>
<a name="l00269"></a>00269       <a class="code" href="classlibMesh_1_1MeshBase.php#aa07a00e86d68f366d8fe7e4d01140ffc">partitioner</a>()-&gt;partition (*<span class="keyword">this</span>, n_parts);
<a name="l00270"></a>00270   }
<a name="l00271"></a>00271 }
<a name="l00272"></a>00272 
<a name="l00273"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a2746231a600b0d6c5d15a6e3ee8e771d">00273</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a2746231a600b0d6c5d15a6e3ee8e771d">MeshBase::recalculate_n_partitions</a>()
<a name="l00274"></a>00274 {
<a name="l00275"></a>00275   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>       el  = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00276"></a>00276   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_proc_id=0;
<a name="l00279"></a>00279   
<a name="l00280"></a>00280   <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00281"></a>00281     max_proc_id = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(max_proc_id, static_cast&lt;unsigned int&gt;((*el)-&gt;processor_id()));
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   <span class="comment">// The number of partitions is one more than the max processor ID.</span>
<a name="l00284"></a>00284   <a class="code" href="classlibMesh_1_1MeshBase.php#ac7f0635c81f5e24e17d47aa1d4b3ff3c">_n_parts</a> = max_proc_id+1;
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ac7f0635c81f5e24e17d47aa1d4b3ff3c">_n_parts</a>;
<a name="l00287"></a>00287 }
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a122877d5316f9035967c6ed10d86a520">00291</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshBase.php#a122877d5316f9035967c6ed10d86a520">MeshBase::point_locator</a> ()<span class="keyword"> const</span>
<a name="l00292"></a>00292 <span class="keyword"></span>{
<a name="l00293"></a>00293   libmesh_deprecated();
<a name="l00294"></a>00294 
<a name="l00295"></a>00295   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshBase.php#a4e6958fbf4fe8dbd52b6b358135b1af7">_point_locator</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() == NULL)
<a name="l00296"></a>00296     {
<a name="l00297"></a>00297       <span class="comment">// PointLocator construction may not be safe within threads</span>
<a name="l00298"></a>00298       libmesh_assert(!<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">Threads::in_threads</a>);
<a name="l00299"></a>00299 
<a name="l00300"></a>00300       <a class="code" href="classlibMesh_1_1MeshBase.php#a4e6958fbf4fe8dbd52b6b358135b1af7">_point_locator</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a> (<a class="code" href="classlibMesh_1_1PointLocatorBase.php#ab09c0f5a4b5ebdbe26672289921e1ee3">PointLocatorBase::build</a>(<a class="code" href="namespacelibMeshEnums.php#aca71eafd6001bb6f34dcefc9b6154766a13deee5da15b875e7a132bbdf02b257c">TREE</a>, *<span class="keyword">this</span>).release());
<a name="l00301"></a>00301     }
<a name="l00302"></a>00302 
<a name="l00303"></a>00303   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1MeshBase.php#a4e6958fbf4fe8dbd52b6b358135b1af7">_point_locator</a>;
<a name="l00304"></a>00304 }
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 
<a name="l00307"></a><a class="code" href="classlibMesh_1_1MeshBase.php#acb09a541f9ff1c5a95d0392f7d7e50ae">00307</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> <a class="code" href="classlibMesh_1_1MeshBase.php#acb09a541f9ff1c5a95d0392f7d7e50ae">MeshBase::sub_point_locator</a> ()<span class="keyword"> const</span>
<a name="l00308"></a>00308 <span class="keyword"></span>{
<a name="l00309"></a>00309   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshBase.php#a4e6958fbf4fe8dbd52b6b358135b1af7">_point_locator</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>() == NULL)
<a name="l00310"></a>00310     {
<a name="l00311"></a>00311       <span class="comment">// PointLocator construction may not be safe within threads</span>
<a name="l00312"></a>00312       libmesh_assert(!<a class="code" href="namespacelibMesh_1_1Threads.php#a130855799a58bba44e6ab25bd2a2a866">Threads::in_threads</a>);
<a name="l00313"></a>00313 
<a name="l00314"></a>00314       <a class="code" href="classlibMesh_1_1MeshBase.php#a4e6958fbf4fe8dbd52b6b358135b1af7">_point_locator</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a> (<a class="code" href="classlibMesh_1_1PointLocatorBase.php#ab09c0f5a4b5ebdbe26672289921e1ee3">PointLocatorBase::build</a>(<a class="code" href="namespacelibMeshEnums.php#aca71eafd6001bb6f34dcefc9b6154766a13deee5da15b875e7a132bbdf02b257c">TREE</a>, *<span class="keyword">this</span>).release());
<a name="l00315"></a>00315     }
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#ab09c0f5a4b5ebdbe26672289921e1ee3">PointLocatorBase::build</a>(<a class="code" href="namespacelibMeshEnums.php#aca71eafd6001bb6f34dcefc9b6154766a13deee5da15b875e7a132bbdf02b257c">TREE</a>, *<span class="keyword">this</span>, <a class="code" href="classlibMesh_1_1MeshBase.php#a4e6958fbf4fe8dbd52b6b358135b1af7">_point_locator</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00318"></a>00318 }
<a name="l00319"></a>00319 
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a><a class="code" href="classlibMesh_1_1MeshBase.php#acc11230de16adce50cbd3edabe8b778a">00322</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#acc11230de16adce50cbd3edabe8b778a">MeshBase::clear_point_locator</a> ()
<a name="l00323"></a>00323 {
<a name="l00324"></a>00324   <a class="code" href="classlibMesh_1_1MeshBase.php#a4e6958fbf4fe8dbd52b6b358135b1af7">_point_locator</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#aca7dac34d00cd798c43629794345a09c" title="Forcibly deletes the managed object.">reset</a>(NULL);
<a name="l00325"></a>00325 }
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 } <span class="comment">// namespace libMesh</span>
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
