<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_base.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_base.h 4402 2011-04-22 23:10:19Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="dof__object_8h.php">dof_object.h</a>&quot;</span> <span class="comment">// for invalid_processor_id</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="multi__predicates_8h.php">multi_predicates.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="partitioner_8h.php">partitioner.h</a>&quot;</span> <span class="comment">// AutoPtr needs a real declaration</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__base_8h.php">point_locator_base.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="variant__filter__iterator_8h.php">variant_filter_iterator.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// forward declarations</span>
<a name="l00044"></a>00044 <span class="keyword">class </span>Elem;
<a name="l00045"></a>00045 <span class="keyword">class </span>Node;
<a name="l00046"></a>00046 <span class="keyword">class </span>Point;
<a name="l00047"></a>00047 <span class="keyword">class </span>BoundaryInfo;
<a name="l00048"></a>00048 <span class="keyword">class </span>MeshData;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00069"></a>00069 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00070"></a>00070 <span class="comment">// MeshBase class definition</span>
<a name="l00071"></a><a class="code" href="classlibMesh_1_1MeshBase.php">00071</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073 <span class="keyword">public</span>:
<a name="l00074"></a>00074 
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1MeshBase.php#af80914e03e3731328990787b58a7c440">MeshBase</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim=1);
<a name="l00081"></a>00081   
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1MeshBase.php#af80914e03e3731328990787b58a7c440">MeshBase</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; other_mesh);
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a> <a class="code" href="classlibMesh_1_1MeshBase.php#a98a7a45b2176811b60664acfe21acc7a">clone</a>() <span class="keyword">const</span> = 0;
<a name="l00091"></a>00091 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a455beac9da4aeffaa6558da3714cbeaf">~MeshBase</a> ();
<a name="l00096"></a>00096 
<a name="l00102"></a><a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">00102</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;BoundaryInfo&gt;</a> <a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>;
<a name="l00103"></a>00103 
<a name="l00107"></a><a class="code" href="classlibMesh_1_1MeshBase.php#aa07a00e86d68f366d8fe7e4d01140ffc">00107</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> &amp;<a class="code" href="classlibMesh_1_1MeshBase.php#aa07a00e86d68f366d8fe7e4d01140ffc">partitioner</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a23499d00522daa25ed85eeb071148512">_partitioner</a>; }
<a name="l00108"></a>00108   
<a name="l00112"></a>00112   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a96d8f46093558e6c54de2743570c778d">clear</a> ();
<a name="l00113"></a>00113   
<a name="l00118"></a><a class="code" href="classlibMesh_1_1MeshBase.php#aef78858f228f672f3587b19c2bbd5fce">00118</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshBase.php#aef78858f228f672f3587b19c2bbd5fce">is_prepared</a> ()<span class="keyword"> const</span>
<a name="l00119"></a>00119 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a013ceb917534084574aa2e00837331bb">_is_prepared</a>; }
<a name="l00120"></a>00120   
<a name="l00125"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">00125</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a> ()<span class="keyword"> const </span>
<a name="l00126"></a>00126 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00127"></a>00127   
<a name="l00132"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a880cd0ce25794e2b0b200b1d6f6086be">00132</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a880cd0ce25794e2b0b200b1d6f6086be">allgather</a> () {}
<a name="l00133"></a>00133   
<a name="l00139"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a8d57ce79036999648936424bfbab715e">00139</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8d57ce79036999648936424bfbab715e">delete_remote_elements</a> () {}
<a name="l00140"></a>00140   
<a name="l00147"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">00147</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a> ()<span class="keyword"> const</span>
<a name="l00148"></a>00148 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1MeshBase.php#ad20b418f0628a701570475c141aec0d0">_dim</a>); }
<a name="l00149"></a>00149   
<a name="l00153"></a><a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">00153</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d)
<a name="l00154"></a>00154   { <a class="code" href="classlibMesh_1_1MeshBase.php#ad20b418f0628a701570475c141aec0d0">_dim</a> = d; }
<a name="l00155"></a>00155   
<a name="l00160"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">00160</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">spatial_dimension</a> ()<span class="keyword"> const</span>
<a name="l00161"></a>00161 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(LIBMESH_DIM); }
<a name="l00162"></a>00162   
<a name="l00168"></a>00168   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a> () <span class="keyword">const</span> = 0; 
<a name="l00169"></a>00169 
<a name="l00173"></a>00173   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8896c14639e1bf4ab9b68209cacc6c6c">n_nodes_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc) <span class="keyword">const</span>;
<a name="l00174"></a>00174 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1MeshBase.php#ad25082a75258d635a515e96e6860aa72">00178</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ad25082a75258d635a515e96e6860aa72">n_local_nodes</a> ()<span class="keyword"> const</span>
<a name="l00179"></a>00179 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a8896c14639e1bf4ab9b68209cacc6c6c">n_nodes_on_proc</a> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); }
<a name="l00180"></a>00180 
<a name="l00184"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a7c108f0e48b093fe0fc313c3875d90b6">00184</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a7c108f0e48b093fe0fc313c3875d90b6">n_unpartitioned_nodes</a> ()<span class="keyword"> const</span>
<a name="l00185"></a>00185 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a8896c14639e1bf4ab9b68209cacc6c6c">n_nodes_on_proc</a> (<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>); }
<a name="l00186"></a>00186 
<a name="l00191"></a>00191   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a9778fcd4d5fc7687babdf9a5ea56d882">max_node_id</a> () <span class="keyword">const</span> = 0;
<a name="l00192"></a>00192 
<a name="l00200"></a>00200   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn) = 0; 
<a name="l00201"></a>00201   
<a name="l00205"></a>00205   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a> () <span class="keyword">const</span> = 0; 
<a name="l00206"></a>00206 
<a name="l00211"></a>00211   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a> () <span class="keyword">const</span> = 0;
<a name="l00212"></a>00212 
<a name="l00220"></a>00220   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#af5d5be0906f6129f3f3bd9b4878789c4">reserve_elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ne) = 0; 
<a name="l00221"></a>00221 
<a name="l00226"></a>00226   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ae10a5f947142866d4a1c1409973b1582">update_parallel_id_counts</a> () = 0;
<a name="l00227"></a>00227 
<a name="l00232"></a>00232   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a> () <span class="keyword">const</span> = 0;
<a name="l00233"></a>00233 
<a name="l00237"></a>00237   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a3faea8450fee70302028b3b263365ad3">n_elem_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc) <span class="keyword">const</span>;
<a name="l00238"></a>00238 
<a name="l00242"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a32db8a83b3c6348e1bd9142fb8e92107">00242</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a32db8a83b3c6348e1bd9142fb8e92107">n_local_elem</a> ()<span class="keyword"> const</span>
<a name="l00243"></a>00243 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a3faea8450fee70302028b3b263365ad3">n_elem_on_proc</a> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); }
<a name="l00244"></a>00244 
<a name="l00248"></a><a class="code" href="classlibMesh_1_1MeshBase.php#ae210732141d58a19337dde4c901fc18c">00248</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ae210732141d58a19337dde4c901fc18c">n_unpartitioned_elem</a> ()<span class="keyword"> const</span>
<a name="l00249"></a>00249 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a3faea8450fee70302028b3b263365ad3">n_elem_on_proc</a> (<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>); }
<a name="l00250"></a>00250 
<a name="l00254"></a>00254   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ae428a6b5a2ed0aa5180a906021eca73a">n_active_elem_on_proc</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc) <span class="keyword">const</span>;
<a name="l00255"></a>00255 
<a name="l00259"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a29e50bada0ed564a1365e13173598565">00259</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a29e50bada0ed564a1365e13173598565">n_active_local_elem</a> ()<span class="keyword"> const</span>
<a name="l00260"></a>00260 <span class="keyword">  </span>{ <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae428a6b5a2ed0aa5180a906021eca73a">n_active_elem_on_proc</a> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()); }
<a name="l00261"></a>00261   
<a name="l00269"></a>00269   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a980d5dccaf993eca14cfc89492c869e9">n_sub_elem</a> () <span class="keyword">const</span>;
<a name="l00270"></a>00270 
<a name="l00274"></a>00274   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8591c0c31abfbde5633d53bf29053ea5">n_active_sub_elem</a> () <span class="keyword">const</span>;
<a name="l00275"></a>00275   
<a name="l00280"></a>00280   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00281"></a>00281 
<a name="l00286"></a>00286   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; <a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00287"></a>00287   
<a name="l00291"></a>00291   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; <a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) = 0;
<a name="l00292"></a>00292   
<a name="l00296"></a>00296   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00297"></a>00297 
<a name="l00301"></a>00301   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* &amp; <a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) = 0;
<a name="l00302"></a>00302 
<a name="l00306"></a>00306   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00307"></a>00307 
<a name="l00318"></a>00318   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00319"></a>00319                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>,
<a name="l00320"></a>00320                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id =
<a name="l00321"></a>00321                              <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>) = 0;
<a name="l00322"></a>00322 
<a name="l00326"></a>00326   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#a9422651366024f496b38d0269f0b2a40">add_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n) = 0;
<a name="l00327"></a>00327 
<a name="l00331"></a>00331   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a32f377b1687ed195cf7d1683c4b880e0">delete_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n) = 0;
<a name="l00332"></a>00332   
<a name="l00338"></a>00338   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#afff6be1835b4203202689641bd006aeb">renumber_node</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id) = 0;
<a name="l00339"></a>00339                       
<a name="l00346"></a>00346   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) = 0;
<a name="l00347"></a>00347 
<a name="l00352"></a>00352   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshBase.php#a087c31798cb9d6302d8a579e9b458713">insert_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) = 0;
<a name="l00353"></a>00353 
<a name="l00360"></a>00360   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a5c7824047ed759b5a4891a6936b546cc">delete_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) = 0;
<a name="l00361"></a>00361 
<a name="l00367"></a>00367   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#aeb6601a6b9c0df36148b41f6a2987c61">renumber_elem</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id) = 0;
<a name="l00368"></a>00368 
<a name="l00381"></a>00381   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a7edb2ad9b032287e750880883cdcf0f3">find_neighbors</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> reset_remote_elements = <span class="keyword">false</span>,
<a name="l00382"></a>00382                                <span class="keyword">const</span> <span class="keywordtype">bool</span> reset_current_list    = <span class="keyword">true</span>) = 0;
<a name="l00383"></a>00383   
<a name="l00389"></a>00389   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a29fb19d7d0a036669ea088eb3cbc7bb9">renumber_nodes_and_elements</a> () = 0;    
<a name="l00390"></a>00390 
<a name="l00397"></a>00397   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#aaf0472656c8f7b39f99b0808fb02671f">fix_broken_node_and_element_numbering</a> () = 0;
<a name="l00398"></a>00398   
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00401"></a>00401 <span class="preprocessor"></span>
<a name="l00406"></a>00406   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a0a109c00dfc85ad16576fde8a0cb2215">contract</a> () = 0;
<a name="l00407"></a>00407 <span class="preprocessor">#endif</span>
<a name="l00408"></a>00408 <span class="preprocessor"></span>
<a name="l00423"></a>00423   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements=<span class="keyword">true</span>);
<a name="l00424"></a>00424   
<a name="l00428"></a>00428   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8f8f153b5eba75c5514fb4707405551c">partition</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parts=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00429"></a>00429 
<a name="l00442"></a><a class="code" href="classlibMesh_1_1MeshBase.php#aebcd76029c9338c55766d1056ec820a6">00442</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#aebcd76029c9338c55766d1056ec820a6">skip_partitioning</a>(<span class="keywordtype">bool</span> skip) { <a class="code" href="classlibMesh_1_1MeshBase.php#ab2a2b5adfd2c3b66a9cd97342673499f">_skip_partitioning</a> = skip; }
<a name="l00443"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a5745bd8ce965d537c6bc95faf78e9f49">00443</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a5745bd8ce965d537c6bc95faf78e9f49">skip_partitioning</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ab2a2b5adfd2c3b66a9cd97342673499f">_skip_partitioning</a>; }
<a name="l00444"></a>00444   
<a name="l00452"></a>00452   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a4a9a53f02f28310e99f946294a7667d0">n_subdomains</a> () <span class="keyword">const</span>;
<a name="l00453"></a>00453 
<a name="l00460"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a716b4df3429a6b2a1d5386691dabe2ae">00460</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a716b4df3429a6b2a1d5386691dabe2ae">n_partitions</a> ()<span class="keyword"> const</span>
<a name="l00461"></a>00461 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ac7f0635c81f5e24e17d47aa1d4b3ff3c">_n_parts</a>; }
<a name="l00462"></a>00462   
<a name="l00467"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">00467</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">n_processors</a> ()<span class="keyword"> const</span>
<a name="l00468"></a>00468 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); }
<a name="l00469"></a>00469 
<a name="l00473"></a><a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">00473</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a> ()<span class="keyword"> const</span>
<a name="l00474"></a>00474 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>(); }
<a name="l00475"></a>00475 
<a name="l00480"></a>00480   std::string <a class="code" href="classlibMesh_1_1MeshBase.php#a1d2b97fca534b38b4c1e914deb467152">get_info</a> () <span class="keyword">const</span>;
<a name="l00481"></a>00481 
<a name="l00485"></a>00485   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a94180309af3081c9da2a0064e66040e6">print_info</a> (std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00486"></a>00486 
<a name="l00492"></a>00492   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classlibMesh_1_1MeshBase.php#a40e1132eec66b29d79926db67fc584bc">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m);
<a name="l00493"></a>00493 
<a name="l00498"></a>00498   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a8798b692a1e7861093e23f8a2caf2f4a">read</a>  (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>, <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* mesh_data=NULL,
<a name="l00499"></a>00499                       <span class="keywordtype">bool</span> skip_renumber_nodes_and_elements=<span class="keyword">false</span>) = 0;
<a name="l00500"></a>00500   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a451f5f23ce0e7670dbeee63b85a98849">write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>, <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>* mesh_data=NULL) = 0;
<a name="l00501"></a>00501 
<a name="l00508"></a>00508   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a1a467cd415f8c2377734d97f5afe53af">all_first_order</a> () = 0;
<a name="l00509"></a>00509 
<a name="l00521"></a>00521   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a7e30e787dc405c28e76736910bf496f8">all_second_order</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> full_ordered=<span class="keyword">true</span>) = 0;
<a name="l00522"></a>00522 
<a name="l00527"></a><a class="code" href="classlibMesh_1_1MeshBase.php#ada7b0f8aa5240ff784d30be4eecaceaf">00527</a>   <span class="keyword">typedef</span> <a class="code" href="structlibMesh_1_1Predicates_1_1multi__predicate.php">Predicates::multi_predicate</a> <a class="code" href="classlibMesh_1_1MeshBase.php#ada7b0f8aa5240ff784d30be4eecaceaf">Predicate</a>;
<a name="l00528"></a>00528 
<a name="l00535"></a>00535   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>;
<a name="l00536"></a>00536   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a>;
<a name="l00537"></a>00537 
<a name="l00544"></a>00544   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a>;
<a name="l00545"></a>00545   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a>;
<a name="l00546"></a>00546 
<a name="l00556"></a>00556   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a2746231a600b0d6c5d15a6e3ee8e771d">recalculate_n_partitions</a>();
<a name="l00557"></a>00557 
<a name="l00564"></a>00564   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshBase.php#a122877d5316f9035967c6ed10d86a520">point_locator</a> () <span class="keyword">const</span>;
<a name="l00565"></a>00565 
<a name="l00573"></a>00573   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> <a class="code" href="classlibMesh_1_1MeshBase.php#acb09a541f9ff1c5a95d0392f7d7e50ae">sub_point_locator</a> () <span class="keyword">const</span>;
<a name="l00574"></a>00574 
<a name="l00578"></a>00578   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#acc11230de16adce50cbd3edabe8b778a">clear_point_locator</a> ();
<a name="l00579"></a>00579 
<a name="l00587"></a><a class="code" href="classlibMesh_1_1MeshBase.php#adda5cd6af09b7fcc88a890a71a07c1a8">00587</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshBase.php#adda5cd6af09b7fcc88a890a71a07c1a8">libmesh_assert_valid_parallel_ids</a>()<span class="keyword"> const </span>{}
<a name="l00588"></a>00588 
<a name="l00589"></a>00589 <span class="keyword">public</span>:
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 
<a name="l00592"></a>00592   
<a name="l00597"></a>00597   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>                   () = 0;
<a name="l00598"></a>00598   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>                     () = 0;
<a name="l00599"></a>00599   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>            () = 0;
<a name="l00600"></a>00600   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>              () = 0;
<a name="l00601"></a>00601   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a49e8bef33dabe0c21c7e81d61e055154">ancestor_elements_begin</a>          () = 0;
<a name="l00602"></a>00602   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a993d03afe0646ec1e9a192808ad2ebd9">ancestor_elements_end</a>            () = 0;
<a name="l00603"></a>00603   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a63a55a9825ce771cc23e4e9921ad7920">subactive_elements_begin</a>         () = 0;
<a name="l00604"></a>00604   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aa3a828a11df05d9969641f11483c551f">subactive_elements_end</a>           () = 0;
<a name="l00605"></a>00605   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae05c8be2e993dcd6365de35260acf0aa">not_active_elements_begin</a>        () = 0;
<a name="l00606"></a>00606   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a1f0d4f282a9a83b869c826600b80777d">not_active_elements_end</a>          () = 0;
<a name="l00607"></a>00607   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ac3b057bb0c52841f61fca0f5e83b3fc8">not_ancestor_elements_begin</a>      () = 0;
<a name="l00608"></a>00608   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a84ae1c6d1e5c50b3c193d382b2e3768d">not_ancestor_elements_end</a>        () = 0;
<a name="l00609"></a>00609   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a7f76a6aea2cf8334b71fbb52b45f3dc0">not_subactive_elements_begin</a>     () = 0;
<a name="l00610"></a>00610   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a18afc9a42c573e2f2599ce36a308d4ab">not_subactive_elements_end</a>       () = 0;
<a name="l00611"></a>00611   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a5b67c2aa94e76310a6db3470cce8ef11">local_elements_begin</a>             () = 0;
<a name="l00612"></a>00612   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ab8bd839216a1ef9c0912d523b68ae136">local_elements_end</a>               () = 0;
<a name="l00613"></a>00613   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a151e26d7ee601e24a57f4f18a1ddec2e">not_local_elements_begin</a>         () = 0;
<a name="l00614"></a>00614   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aa7ba43cbc4025fc5629dad18485e019d">not_local_elements_end</a>           () = 0;
<a name="l00615"></a>00615   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>      () = 0;
<a name="l00616"></a>00616   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>        () = 0;
<a name="l00617"></a>00617   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ac68163904060c11860cd46b0fd9e4003">active_not_local_elements_begin</a>  () = 0;
<a name="l00618"></a>00618   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a81252a490defae08c5fd39ffac034333">active_not_local_elements_end</a>    () = 0;
<a name="l00619"></a>00619   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a32031f5d29428cf17dad4cabaf60d298">level_elements_begin</a>             (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00620"></a>00620   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae94f3f5a30c83cdd0187ba02a5b8b17e">level_elements_end</a>               (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00621"></a>00621   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aefb3974a79f4bd842006a8dccd1ca6ba">not_level_elements_begin</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00622"></a>00622   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a29f6fa09f85eb26c1844bd32f8c06246">not_level_elements_end</a>           (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00623"></a>00623   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aba25a41984a2f97d42663f8611189165">local_level_elements_begin</a>       (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00624"></a>00624   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a98611d6c196c6513849c0023e71c282d">local_level_elements_end</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00625"></a>00625   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a14aa6c6733651c2d0e815aa31da3e10d">local_not_level_elements_begin</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00626"></a>00626   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a8ecdf5bbe7d7f1ee9b5d354b0523bb8e">local_not_level_elements_end</a>     (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level  ) = 0;
<a name="l00627"></a>00627   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae05a5517582637b8469bbae1939d9aaf">pid_elements_begin</a>               (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00628"></a>00628   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a36245c34046bf4b2b4b26bfdb603abd9">pid_elements_end</a>                 (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00629"></a>00629   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#af23e30f351c55603492a52f6151b213d">type_elements_begin</a>              (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type       ) = 0;
<a name="l00630"></a>00630   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a106c235cfaf1d2d26e5355d5663d9a91">type_elements_end</a>                (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type       ) = 0;
<a name="l00631"></a>00631   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a77c6acb7a27f7407b58826a849e5d441">active_type_elements_begin</a>       (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type       ) = 0;
<a name="l00632"></a>00632   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a73cfd57bf4512ac0b90734e81bcbcd0d">active_type_elements_end</a>         (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type       ) = 0;
<a name="l00633"></a>00633   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ad250f85e39b8bbdfcc6605c6006aa202">active_pid_elements_begin</a>        (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00634"></a>00634   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#adf7c40f7022d79c4b9a96f2284fce248">active_pid_elements_end</a>          (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00635"></a>00635   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a0e898a7c74ad9552269753ee54e52b45">unpartitioned_elements_begin</a>     () = 0;
<a name="l00636"></a>00636   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ace9f5d288950516202e18c42a0552b0f">unpartitioned_elements_end</a>       () = 0;
<a name="l00637"></a>00637   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ad28ed42126bffc959f1c1382a66cc6f8">active_local_subdomain_elements_begin</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) = 0;
<a name="l00638"></a>00638   <span class="keyword">virtual</span> element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a58f8b4296cac29877c0fe4e9e880ca47">active_local_subdomain_elements_end</a>           (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) = 0;
<a name="l00639"></a>00639   
<a name="l00640"></a>00640 
<a name="l00641"></a>00641   
<a name="l00642"></a>00642   
<a name="l00646"></a>00646   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>                   () <span class="keyword">const</span> = 0;
<a name="l00647"></a>00647   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>                     () <span class="keyword">const</span> = 0;
<a name="l00648"></a>00648   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>            () <span class="keyword">const</span> = 0;
<a name="l00649"></a>00649   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>              () <span class="keyword">const</span> = 0;
<a name="l00650"></a>00650   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a49e8bef33dabe0c21c7e81d61e055154">ancestor_elements_begin</a>          () <span class="keyword">const</span> = 0;
<a name="l00651"></a>00651   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a993d03afe0646ec1e9a192808ad2ebd9">ancestor_elements_end</a>            () <span class="keyword">const</span> = 0;
<a name="l00652"></a>00652   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a63a55a9825ce771cc23e4e9921ad7920">subactive_elements_begin</a>         () <span class="keyword">const</span> = 0;
<a name="l00653"></a>00653   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aa3a828a11df05d9969641f11483c551f">subactive_elements_end</a>           () <span class="keyword">const</span> = 0;
<a name="l00654"></a>00654   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae05c8be2e993dcd6365de35260acf0aa">not_active_elements_begin</a>        () <span class="keyword">const</span> = 0;
<a name="l00655"></a>00655   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a1f0d4f282a9a83b869c826600b80777d">not_active_elements_end</a>          () <span class="keyword">const</span> = 0;
<a name="l00656"></a>00656   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ac3b057bb0c52841f61fca0f5e83b3fc8">not_ancestor_elements_begin</a>      () <span class="keyword">const</span> = 0;
<a name="l00657"></a>00657   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a84ae1c6d1e5c50b3c193d382b2e3768d">not_ancestor_elements_end</a>        () <span class="keyword">const</span> = 0;
<a name="l00658"></a>00658   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a7f76a6aea2cf8334b71fbb52b45f3dc0">not_subactive_elements_begin</a>     () <span class="keyword">const</span> = 0;
<a name="l00659"></a>00659   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a18afc9a42c573e2f2599ce36a308d4ab">not_subactive_elements_end</a>       () <span class="keyword">const</span> = 0;
<a name="l00660"></a>00660   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a5b67c2aa94e76310a6db3470cce8ef11">local_elements_begin</a>             () <span class="keyword">const</span> = 0;
<a name="l00661"></a>00661   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ab8bd839216a1ef9c0912d523b68ae136">local_elements_end</a>               () <span class="keyword">const</span> = 0;
<a name="l00662"></a>00662   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a151e26d7ee601e24a57f4f18a1ddec2e">not_local_elements_begin</a>         () <span class="keyword">const</span> = 0;
<a name="l00663"></a>00663   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aa7ba43cbc4025fc5629dad18485e019d">not_local_elements_end</a>           () <span class="keyword">const</span> = 0;
<a name="l00664"></a>00664   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>      () <span class="keyword">const</span> = 0;
<a name="l00665"></a>00665   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>        () <span class="keyword">const</span> = 0;
<a name="l00666"></a>00666   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ac68163904060c11860cd46b0fd9e4003">active_not_local_elements_begin</a>  () <span class="keyword">const</span> = 0;
<a name="l00667"></a>00667   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a81252a490defae08c5fd39ffac034333">active_not_local_elements_end</a>    () <span class="keyword">const</span> = 0;
<a name="l00668"></a>00668   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a32031f5d29428cf17dad4cabaf60d298">level_elements_begin</a>             (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00669"></a>00669   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae94f3f5a30c83cdd0187ba02a5b8b17e">level_elements_end</a>               (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00670"></a>00670   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aefb3974a79f4bd842006a8dccd1ca6ba">not_level_elements_begin</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00671"></a>00671   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a29f6fa09f85eb26c1844bd32f8c06246">not_level_elements_end</a>           (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00672"></a>00672   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#aba25a41984a2f97d42663f8611189165">local_level_elements_begin</a>       (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00673"></a>00673   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a98611d6c196c6513849c0023e71c282d">local_level_elements_end</a>         (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00674"></a>00674   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a14aa6c6733651c2d0e815aa31da3e10d">local_not_level_elements_begin</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00675"></a>00675   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a8ecdf5bbe7d7f1ee9b5d354b0523bb8e">local_not_level_elements_end</a>     (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)   <span class="keyword">const</span> = 0;
<a name="l00676"></a>00676   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ae05a5517582637b8469bbae1939d9aaf">pid_elements_begin</a>               (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00677"></a>00677   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a36245c34046bf4b2b4b26bfdb603abd9">pid_elements_end</a>                 (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00678"></a>00678   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#af23e30f351c55603492a52f6151b213d">type_elements_begin</a>              (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)        <span class="keyword">const</span> = 0;
<a name="l00679"></a>00679   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a106c235cfaf1d2d26e5355d5663d9a91">type_elements_end</a>                (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)        <span class="keyword">const</span> = 0;
<a name="l00680"></a>00680   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a77c6acb7a27f7407b58826a849e5d441">active_type_elements_begin</a>       (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)        <span class="keyword">const</span> = 0;
<a name="l00681"></a>00681   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a73cfd57bf4512ac0b90734e81bcbcd0d">active_type_elements_end</a>         (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)        <span class="keyword">const</span> = 0;
<a name="l00682"></a>00682   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ad250f85e39b8bbdfcc6605c6006aa202">active_pid_elements_begin</a>        (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00683"></a>00683   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#adf7c40f7022d79c4b9a96f2284fce248">active_pid_elements_end</a>          (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00684"></a>00684   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a0e898a7c74ad9552269753ee54e52b45">unpartitioned_elements_begin</a>     () <span class="keyword">const</span> = 0;
<a name="l00685"></a>00685   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ace9f5d288950516202e18c42a0552b0f">unpartitioned_elements_end</a>       () <span class="keyword">const</span> = 0;
<a name="l00686"></a>00686   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ad28ed42126bffc959f1c1382a66cc6f8">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span> = 0;
<a name="l00687"></a>00687   <span class="keyword">virtual</span> const_element_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a58f8b4296cac29877c0fe4e9e880ca47">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span> = 0;
<a name="l00688"></a>00688 
<a name="l00689"></a>00689   
<a name="l00693"></a>00693   <span class="keyword">virtual</span> node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>        () = 0;
<a name="l00694"></a>00694   <span class="keyword">virtual</span> node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>          () = 0;
<a name="l00695"></a>00695   <span class="keyword">virtual</span> node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a626ad50bac152b404fc23791158e706a">active_nodes_begin</a> () = 0;
<a name="l00696"></a>00696   <span class="keyword">virtual</span> node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a63415b7ca944ea160568653392c12517">active_nodes_end</a>   () = 0;
<a name="l00697"></a>00697   <span class="keyword">virtual</span> node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a7a87dbe56aaa89961e03d60a25a36e8b">local_nodes_begin</a>  () = 0;
<a name="l00698"></a>00698   <span class="keyword">virtual</span> node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ad0daaecd9c183194a99609db6507198c">local_nodes_end</a>    () = 0;
<a name="l00699"></a>00699   <span class="keyword">virtual</span> node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a7d6366e57e92fdfecd3150d192956d03">pid_nodes_begin</a>    (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00700"></a>00700   <span class="keyword">virtual</span> node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a329026356ca6689c35b765bb0b58eb01">pid_nodes_end</a>      (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) = 0;
<a name="l00701"></a>00701 
<a name="l00702"></a>00702 
<a name="l00706"></a>00706   <span class="keyword">virtual</span> const_node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>        () <span class="keyword">const</span> = 0;
<a name="l00707"></a>00707   <span class="keyword">virtual</span> const_node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>          () <span class="keyword">const</span> = 0;
<a name="l00708"></a>00708   <span class="keyword">virtual</span> const_node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a626ad50bac152b404fc23791158e706a">active_nodes_begin</a> () <span class="keyword">const</span> = 0;
<a name="l00709"></a>00709   <span class="keyword">virtual</span> const_node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a63415b7ca944ea160568653392c12517">active_nodes_end</a>   () <span class="keyword">const</span> = 0;
<a name="l00710"></a>00710   <span class="keyword">virtual</span> const_node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a7a87dbe56aaa89961e03d60a25a36e8b">local_nodes_begin</a>  () <span class="keyword">const</span> = 0;
<a name="l00711"></a>00711   <span class="keyword">virtual</span> const_node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#ad0daaecd9c183194a99609db6507198c">local_nodes_end</a>    () <span class="keyword">const</span> = 0;
<a name="l00712"></a>00712   <span class="keyword">virtual</span> const_node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a7d6366e57e92fdfecd3150d192956d03">pid_nodes_begin</a>    (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00713"></a>00713   <span class="keyword">virtual</span> const_node_iterator <a class="code" href="classlibMesh_1_1MeshBase.php#a329026356ca6689c35b765bb0b58eb01">pid_nodes_end</a>      (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span> = 0;
<a name="l00714"></a>00714 
<a name="l00715"></a>00715 
<a name="l00716"></a>00716   
<a name="l00717"></a>00717 <span class="keyword">protected</span>:
<a name="l00718"></a>00718 
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 
<a name="l00721"></a>00721   
<a name="l00722"></a>00722   
<a name="l00723"></a>00723 
<a name="l00727"></a><a class="code" href="classlibMesh_1_1MeshBase.php#aa1d4be6015417d17b41780fbcf5472a2">00727</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classlibMesh_1_1MeshBase.php#aa1d4be6015417d17b41780fbcf5472a2">set_n_partitions</a> ()
<a name="l00728"></a>00728   { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ac7f0635c81f5e24e17d47aa1d4b3ff3c">_n_parts</a>; }
<a name="l00729"></a>00729   
<a name="l00739"></a><a class="code" href="classlibMesh_1_1MeshBase.php#ac7f0635c81f5e24e17d47aa1d4b3ff3c">00739</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ac7f0635c81f5e24e17d47aa1d4b3ff3c">_n_parts</a>;
<a name="l00740"></a>00740   
<a name="l00744"></a><a class="code" href="classlibMesh_1_1MeshBase.php#ad20b418f0628a701570475c141aec0d0">00744</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ad20b418f0628a701570475c141aec0d0">_dim</a>;
<a name="l00745"></a>00745 
<a name="l00749"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a013ceb917534084574aa2e00837331bb">00749</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshBase.php#a013ceb917534084574aa2e00837331bb">_is_prepared</a>;
<a name="l00750"></a>00750   
<a name="l00758"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a4e6958fbf4fe8dbd52b6b358135b1af7">00758</a>   <span class="keyword">mutable</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> <a class="code" href="classlibMesh_1_1MeshBase.php#a4e6958fbf4fe8dbd52b6b358135b1af7">_point_locator</a>;
<a name="l00759"></a>00759 
<a name="l00766"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a23499d00522daa25ed85eeb071148512">00766</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> <a class="code" href="classlibMesh_1_1MeshBase.php#a23499d00522daa25ed85eeb071148512">_partitioner</a>;
<a name="l00767"></a>00767 
<a name="l00771"></a><a class="code" href="classlibMesh_1_1MeshBase.php#ab2a2b5adfd2c3b66a9cd97342673499f">00771</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshBase.php#ab2a2b5adfd2c3b66a9cd97342673499f">_skip_partitioning</a>;
<a name="l00772"></a>00772   
<a name="l00777"></a><a class="code" href="classlibMesh_1_1MeshBase.php#aecb7b18be543e142af79de1f0d0ed931">00777</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Partitioner.php">Partitioner</a>;
<a name="l00778"></a>00778 
<a name="l00783"></a><a class="code" href="classlibMesh_1_1MeshBase.php#a2c8dc194240e1c00896436711ef64897">00783</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a>;
<a name="l00784"></a>00784 
<a name="l00785"></a>00785 };
<a name="l00786"></a>00786 
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 
<a name="l00789"></a>00789 
<a name="l00790"></a>00790 
<a name="l00791"></a>00791 
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 
<a name="l00794"></a>00794 
<a name="l00795"></a>00795 
<a name="l00796"></a>00796 
<a name="l00800"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">00800</a> <span class="keyword">struct</span>
<a name="l00801"></a>00801 <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> :
<a name="l00802"></a>00802 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php#ada7b0f8aa5240ff784d30be4eecaceaf">MeshBase::Predicate</a>,
<a name="l00803"></a>00803                         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*&gt;
<a name="l00804"></a>00804 {
<a name="l00805"></a>00805   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l00806"></a>00806   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00807"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php#ac1b02deba7d4bbc05181de29930f238e">00807</a>   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00808"></a>00808                     <span class="keyword">const</span> IterType&amp; e,
<a name="l00809"></a>00809                     <span class="keyword">const</span> PredType&amp; p ) :
<a name="l00810"></a>00810     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>::<a class="code" href="structlibMesh_1_1Predicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00811"></a>00811                             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*&gt;(d,e,p) {}
<a name="l00812"></a>00812 };
<a name="l00813"></a>00813 
<a name="l00814"></a>00814 
<a name="l00815"></a>00815 
<a name="l00816"></a>00816 
<a name="l00821"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">00821</a> <span class="keyword">struct</span>
<a name="l00822"></a>00822 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> :
<a name="l00823"></a>00823 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php#ada7b0f8aa5240ff784d30be4eecaceaf">MeshBase::Predicate</a>,
<a name="l00824"></a>00824                         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span>,
<a name="l00825"></a>00825                         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span>&amp;,
<a name="l00826"></a>00826                         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <span class="keyword">const</span>*&gt;
<a name="l00827"></a>00827 {
<a name="l00828"></a>00828   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l00829"></a>00829   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00830"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php#ae2b15f2af1d83af9dd9aaec5e2fb30ab">00830</a>   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00831"></a>00831                           <span class="keyword">const</span> IterType&amp; e,
<a name="l00832"></a>00832                           <span class="keyword">const</span> PredType&amp; p ) :
<a name="l00833"></a>00833     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>::<a class="code" href="structlibMesh_1_1Predicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00834"></a>00834                             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* const,
<a name="l00835"></a>00835                             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* const&amp;,
<a name="l00836"></a>00836                             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* const*&gt;(d,e,p)  {}
<a name="l00837"></a>00837 
<a name="l00838"></a>00838 
<a name="l00839"></a>00839   <span class="comment">// The conversion-to-const ctor.  Takes a regular iterator and calls the appropriate</span>
<a name="l00840"></a>00840   <span class="comment">// variant_filter_iterator copy constructor.  Note that this one is *not* templated!</span>
<a name="l00841"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php#aa21a68a4a53f5869596cb42ecd3e49fc">00841</a>   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>&amp; rhs) :
<a name="l00842"></a>00842     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="structlibMesh_1_1Predicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00843"></a>00843                             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* const,
<a name="l00844"></a>00844                             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* const&amp;,
<a name="l00845"></a>00845                             <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* const*&gt;(rhs)
<a name="l00846"></a>00846   {
<a name="l00847"></a>00847     <span class="comment">// libMesh::out &lt;&lt; &quot;Called element_iterator conversion-to-const ctor.&quot; &lt;&lt; std::endl;</span>
<a name="l00848"></a>00848   }
<a name="l00849"></a>00849 };
<a name="l00850"></a>00850 
<a name="l00851"></a>00851 
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 
<a name="l00854"></a>00854 
<a name="l00855"></a>00855 
<a name="l00856"></a>00856 
<a name="l00860"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">00860</a> <span class="keyword">struct</span>
<a name="l00861"></a>00861 <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> :
<a name="l00862"></a>00862 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php#ada7b0f8aa5240ff784d30be4eecaceaf">MeshBase::Predicate</a>,
<a name="l00863"></a>00863                         <a class="code" href="classlibMesh_1_1Node.php">Node</a>*&gt;
<a name="l00864"></a>00864 {
<a name="l00865"></a>00865   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l00866"></a>00866   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00867"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php#a36c1568e53c47e7b180945bdfd4820cf">00867</a>   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">node_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00868"></a>00868                  <span class="keyword">const</span> IterType&amp; e,
<a name="l00869"></a>00869                  <span class="keyword">const</span> PredType&amp; p ) :
<a name="l00870"></a>00870     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>::<a class="code" href="structlibMesh_1_1Predicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00871"></a>00871                             <a class="code" href="classlibMesh_1_1Node.php">Node</a>*&gt;(d,e,p) {}
<a name="l00872"></a>00872 };
<a name="l00873"></a>00873 
<a name="l00874"></a>00874 
<a name="l00875"></a>00875 
<a name="l00876"></a>00876 
<a name="l00881"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">00881</a> <span class="keyword">struct</span>
<a name="l00882"></a>00882 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> :
<a name="l00883"></a>00883 <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php#ada7b0f8aa5240ff784d30be4eecaceaf">MeshBase::Predicate</a>,
<a name="l00884"></a>00884                         <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <span class="keyword">const</span>,
<a name="l00885"></a>00885                         <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <span class="keyword">const</span> &amp;,
<a name="l00886"></a>00886                         <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <span class="keyword">const</span> *&gt;
<a name="l00887"></a>00887 {
<a name="l00888"></a>00888   <span class="comment">// Templated forwarding ctor -- forwards to appropriate variant_filter_iterator ctor</span>
<a name="l00889"></a>00889   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> PredType, <span class="keyword">typename</span> IterType&gt;
<a name="l00890"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php#ad045151dcfae8c911dd2b56902f6dd1c">00890</a>   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a> (<span class="keyword">const</span> IterType&amp; d,
<a name="l00891"></a>00891                        <span class="keyword">const</span> IterType&amp; e,
<a name="l00892"></a>00892                        <span class="keyword">const</span> PredType&amp; p ) :
<a name="l00893"></a>00893     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>::<a class="code" href="structlibMesh_1_1Predicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00894"></a>00894                             <a class="code" href="classlibMesh_1_1Node.php">Node</a>* const,
<a name="l00895"></a>00895                             <a class="code" href="classlibMesh_1_1Node.php">Node</a>* const &amp;,
<a name="l00896"></a>00896                             <a class="code" href="classlibMesh_1_1Node.php">Node</a>* const *&gt;(d,e,p)  {}
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 
<a name="l00899"></a>00899   <span class="comment">// The conversion-to-const ctor.  Takes a regular iterator and calls the appropriate</span>
<a name="l00900"></a>00900   <span class="comment">// variant_filter_iterator copy constructor.  Note that this one is *not* templated!</span>
<a name="l00901"></a><a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php#aea4e2bcd3a7eb8f3cc8946c9e3680bb3">00901</a>   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">const_node_iterator</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>&amp; rhs) :
<a name="l00902"></a>00902     <a class="code" href="classvariant__filter__iterator.php">variant_filter_iterator</a>&lt;<a class="code" href="structlibMesh_1_1Predicates_1_1multi__predicate.php">Predicate</a>,
<a name="l00903"></a>00903                             <a class="code" href="classlibMesh_1_1Node.php">Node</a>* const,
<a name="l00904"></a>00904                             <a class="code" href="classlibMesh_1_1Node.php">Node</a>* const &amp;,
<a name="l00905"></a>00905                             <a class="code" href="classlibMesh_1_1Node.php">Node</a>* const *&gt;(rhs)
<a name="l00906"></a>00906   {
<a name="l00907"></a>00907     <span class="comment">// libMesh::out &lt;&lt; &quot;Called node_iterator conversion-to-const ctor.&quot; &lt;&lt; std::endl;</span>
<a name="l00908"></a>00908   }
<a name="l00909"></a>00909 };
<a name="l00910"></a>00910 
<a name="l00911"></a>00911 
<a name="l00912"></a>00912 } <span class="comment">// namespace libMesh</span>
<a name="l00913"></a>00913 
<a name="l00914"></a>00914 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
