<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_communication.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__communication_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_communication.h 4363 2011-04-19 18:51:33Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_communication_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_communication_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span>MeshBase;
<a name="l00038"></a>00038 <span class="keyword">class </span>ParallelMesh;
<a name="l00039"></a>00039 <span class="keyword">class </span>BoundaryInfo;
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>LocationMap;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// MeshCommunication class definition</span>
<a name="l00055"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php">00055</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00062"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#af7a9fe6fa2f8d820a0772e6ce73f0990">00062</a>   <a class="code" href="classlibMesh_1_1MeshCommunication.php#af7a9fe6fa2f8d820a0772e6ce73f0990">MeshCommunication</a> () {}
<a name="l00063"></a>00063 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1MeshCommunication.php#a7e700d5cae2559747f64283dfc2ad81c">00067</a>   <a class="code" href="classlibMesh_1_1MeshCommunication.php#a7e700d5cae2559747f64283dfc2ad81c">~MeshCommunication</a> () {}
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a227f46dad6159d846d8e6c90a9cfe3cb">clear</a> ();
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="comment">//   /**</span>
<a name="l00075"></a>00075 <span class="comment">//    * Finds all the processors that may contain</span>
<a name="l00076"></a>00076 <span class="comment">//    * elements that neighbor my elements.  This list</span>
<a name="l00077"></a>00077 <span class="comment">//    * is guaranteed to include all processors that border</span>
<a name="l00078"></a>00078 <span class="comment">//    * any of my elements, but may include additional ones as</span>
<a name="l00079"></a>00079 <span class="comment">//    * well.  This method computes bounding boxes for the</span>
<a name="l00080"></a>00080 <span class="comment">//    * elements on each processor and checks for overlaps.</span>
<a name="l00081"></a>00081 <span class="comment">//    */</span>
<a name="l00082"></a>00082 <span class="comment">//   void find_neighboring_processors(const MeshBase &amp;);</span>
<a name="l00083"></a>00083 
<a name="l00090"></a>00090   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#ab9d0275f5567a8253e3b10fa0d39a623">broadcast</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;) <span class="keyword">const</span>;
<a name="l00091"></a>00091 
<a name="l00103"></a>00103   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a64195de35a3f834f9393aad8b6ca1be2">redistribute</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;) <span class="keyword">const</span>;
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a1b5bcfce3b9a9daccb4abb795a0638e0">gather_neighboring_elements</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;) <span class="keyword">const</span>;
<a name="l00109"></a>00109   
<a name="l00118"></a>00118   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">allgather</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;) <span class="keyword">const</span>;
<a name="l00119"></a>00119 
<a name="l00134"></a>00134   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a4a0107f13a8af6e904a6067b19d4f5be">delete_remote_elements</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;, <span class="keyword">const</span> std::set&lt;Elem *&gt; &amp;) <span class="keyword">const</span>;
<a name="l00135"></a>00135 
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#ac07c8ba8aee328c186d853666dca4aa0">assign_global_indices</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;) <span class="keyword">const</span>;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00153"></a>00153   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> ForwardIterator&gt;
<a name="l00154"></a>00154   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#aa796c4e551a56a3e15603a2ffa7c6aaf">find_global_indices</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> &amp;,
<a name="l00155"></a>00155                             <span class="keyword">const</span> ForwardIterator &amp;,
<a name="l00156"></a>00156                             <span class="keyword">const</span> ForwardIterator &amp;,
<a name="l00157"></a>00157                             std::vector&lt;unsigned int&gt; &amp;) <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00162"></a>00162   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a737da6ee13b781ac7aef37851a99af58">make_elems_parallel_consistent</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;);
<a name="l00163"></a>00163 
<a name="l00169"></a>00169   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a12f81a2283c5629a144fac25019d1241">make_node_ids_parallel_consistent</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;,
<a name="l00170"></a>00170                                           <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a> &amp;);
<a name="l00171"></a>00171 
<a name="l00177"></a>00177   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a6343f61646db756556414516a068aa4e">make_node_proc_ids_parallel_consistent</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;,
<a name="l00178"></a>00178                                                <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a> &amp;);
<a name="l00179"></a>00179 
<a name="l00186"></a>00186   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a4267fefd3ddfeead0f25be8fb9918af8">make_nodes_parallel_consistent</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;,
<a name="l00187"></a>00187                                        <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a> &amp;);
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 <span class="keyword">private</span>:
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a0c40f3d84bf0007f8e2c3ec4de0c8081">broadcast_mesh</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;) <span class="keyword">const</span>;
<a name="l00192"></a>00192   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#a80b2e2f53a4271810181ceb41bffcf15">broadcast_bcs</a>  (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;, <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a> &amp;) <span class="keyword">const</span>;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#ac5191d5151039c4eca0aa05cd51e2e5d">allgather_mesh</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;) <span class="keyword">const</span>;
<a name="l00195"></a>00195   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshCommunication.php#aaa030e4082c298eca5efae64dfec69f3">allgather_bcs</a>  (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;, <a class="code" href="classlibMesh_1_1BoundaryInfo.php">BoundaryInfo</a> &amp;) <span class="keyword">const</span>;
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 <span class="comment">//   /**</span>
<a name="l00198"></a>00198 <span class="comment">//    * Packs the element \p elem at the end of vector \p conn.</span>
<a name="l00199"></a>00199 <span class="comment">//    * This includes all the information needed to rebuild the element</span>
<a name="l00200"></a>00200 <span class="comment">//    * on a remote processor, including refinement state.</span>
<a name="l00201"></a>00201 <span class="comment">//    */</span>
<a name="l00202"></a>00202 <span class="comment">//   void pack_element (std::vector&lt;int&gt; &amp;conn, const Elem* elem) const;</span>
<a name="l00203"></a>00203 
<a name="l00204"></a>00204 <span class="comment">//   /**</span>
<a name="l00205"></a>00205 <span class="comment">//    * The processors who neighbor the current</span>
<a name="l00206"></a>00206 <span class="comment">//    * processor</span>
<a name="l00207"></a>00207 <span class="comment">//    */</span>
<a name="l00208"></a>00208 <span class="comment">//   std::vector&lt;unsigned short int&gt; _neighboring_processors;</span>
<a name="l00209"></a>00209 };
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00214"></a>00214 <span class="comment">// MeshCommunication inline members</span>
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 } <span class="comment">// namespace libMesh</span>
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="preprocessor">#endif // end #ifndef __mesh_communication_h__ </span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
