<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_data.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__data_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_data.C 4314 2011-03-31 21:35:45Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__data_8h.php">mesh_data.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// MeshData functions</span>
<a name="l00037"></a><a class="code" href="classlibMesh_1_1MeshData.php#a3fdd6de8096631493be8e6f56dc15a73">00037</a> <a class="code" href="classlibMesh_1_1MeshData.php#a3fdd6de8096631493be8e6f56dc15a73">MeshData::MeshData</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m) :
<a name="l00038"></a>00038   _mesh               (m),
<a name="l00039"></a>00039   _data_descriptor    (<span class="stringliteral">&quot;&quot;</span>),
<a name="l00040"></a>00040   _node_id_map_closed (false),
<a name="l00041"></a>00041   _node_data_closed   (false),
<a name="l00042"></a>00042   _elem_id_map_closed (false),
<a name="l00043"></a>00043   _elem_data_closed   (false),
<a name="l00044"></a>00044   _active             (false),
<a name="l00045"></a>00045   _compatibility_mode (false),
<a name="l00046"></a>00046   _unv_header         (NULL)
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048   <span class="comment">// This class isn&#39;t actively maintained, doesn&#39;t work in parallel,</span>
<a name="l00049"></a>00049   <span class="comment">// and usually isn&#39;t as good a solution as adding an additional</span>
<a name="l00050"></a>00050   <span class="comment">// ExplicitSystem with appropriate data field(s).</span>
<a name="l00051"></a>00051   libmesh_deprecated();
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1MeshData.php#afe93244c75183533ba93da5baa7ae974">00057</a> <a class="code" href="classlibMesh_1_1MeshData.php#afe93244c75183533ba93da5baa7ae974">MeshData::~MeshData</a>()
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1MeshData.php#a19e205366bfe0869017f32985e60ff8b">clear</a>();
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1MeshData.php#a9c8a8f08799ae1e9acf43abdb904c6bb">00066</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a9c8a8f08799ae1e9acf43abdb904c6bb">MeshData::activate</a> (<span class="keyword">const</span> std::string&amp; descriptor)
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00069"></a>00069 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>)
<a name="l00070"></a>00070       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: MeshData was in compatibility mode, now being activated.&quot;</span>
<a name="l00071"></a>00071                     &lt;&lt; std::endl;
<a name="l00072"></a>00072 <span class="preprocessor">#endif</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span>
<a name="l00074"></a>00074   <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a> = <span class="keyword">false</span>;
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> = <span class="keyword">true</span>;
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a> = descriptor;
<a name="l00077"></a>00077 }
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1MeshData.php#a3e1a2ffd0b28624afa10d5a7c436d9e0">00083</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a3e1a2ffd0b28624afa10d5a7c436d9e0">MeshData::enable_compatibility_mode</a> (<span class="keyword">const</span> std::string&amp; descriptor)
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>)
<a name="l00086"></a>00086     {
<a name="l00087"></a>00087       <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a> = <span class="keyword">true</span>;
<a name="l00088"></a>00088       <a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> = <span class="keyword">false</span>;
<a name="l00089"></a>00089       <span class="comment">// do as if the id maps are already closed</span>
<a name="l00090"></a>00090       <a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a> = <span class="keyword">true</span>;
<a name="l00091"></a>00091       <a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a> = <span class="keyword">true</span>;
<a name="l00092"></a>00092       <a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a> = descriptor;
<a name="l00093"></a>00093       <span class="comment">// we can safely clear the id maps</span>
<a name="l00094"></a>00094       <a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>.clear();
<a name="l00095"></a>00095       <a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>.clear();
<a name="l00096"></a>00096       <a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>.clear();
<a name="l00097"></a>00097       <a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">_id_elem</a>.clear();
<a name="l00098"></a>00098     }
<a name="l00099"></a>00099 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00100"></a>00100 <span class="preprocessor"></span>  <span class="keywordflow">else</span>
<a name="l00101"></a>00101       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: MeshData was in compatibility mode, now being activated.&quot;</span>
<a name="l00102"></a>00102                     &lt;&lt; std::endl;
<a name="l00103"></a>00103 <span class="preprocessor">#endif</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>}
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1MeshData.php#a19e205366bfe0869017f32985e60ff8b">00111</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a19e205366bfe0869017f32985e60ff8b">MeshData::clear</a>()
<a name="l00112"></a>00112 {
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a>    = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00114"></a>00114   <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.clear();
<a name="l00115"></a>00115   <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.clear();
<a name="l00116"></a>00116   <a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>   = <span class="keyword">false</span>;
<a name="l00117"></a>00117   <a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>   = <span class="keyword">false</span>;
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1MeshData.php#a4ceb18a184138fdb46c40273aaa02d06">00124</a> <span class="keywordtype">void</span>  <a class="code" href="classlibMesh_1_1MeshData.php#a4ceb18a184138fdb46c40273aaa02d06">MeshData::slim</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> node_id_map,
<a name="l00125"></a>00125                       <span class="keyword">const</span> <span class="keywordtype">bool</span> elem_id_map)
<a name="l00126"></a>00126 {
<a name="l00127"></a>00127   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a601f98bb1c90131ce7d71313a5df6ee4">active</a>())
<a name="l00128"></a>00128     {
<a name="l00129"></a>00129 
<a name="l00130"></a>00130       <span class="keywordflow">if</span> (node_id_map)
<a name="l00131"></a>00131         {
<a name="l00132"></a>00132           <span class="comment">// dumb check</span>
<a name="l00133"></a>00133           libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135           <a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a> = <span class="keyword">false</span>;
<a name="l00136"></a>00136           <a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>.clear();
<a name="l00137"></a>00137           <a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>.clear();
<a name="l00138"></a>00138         }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140       <span class="keywordflow">if</span> (elem_id_map)
<a name="l00141"></a>00141         {
<a name="l00142"></a>00142           <span class="comment">// dumb check</span>
<a name="l00143"></a>00143           libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145           <a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a> = <span class="keyword">false</span>;
<a name="l00146"></a>00146           <a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>.clear();
<a name="l00147"></a>00147           <a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">_id_elem</a>.clear();
<a name="l00148"></a>00148         }
<a name="l00149"></a>00149     }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00152"></a>00152 <span class="preprocessor"></span>  <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">compatibility_mode</a>())
<a name="l00153"></a>00153     {
<a name="l00154"></a>00154       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: No need for MeshData::slim() in compatibility mode.&quot;</span> &lt;&lt; std::endl;
<a name="l00155"></a>00155     }
<a name="l00156"></a>00156 <span class="preprocessor">#endif</span>
<a name="l00157"></a>00157 <span class="preprocessor"></span>}
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a><a class="code" href="classlibMesh_1_1MeshData.php#a329d75769bbfa110390df61d154b01ed">00162</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a329d75769bbfa110390df61d154b01ed">MeshData::translate</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; out_mesh,
<a name="l00163"></a>00163                           std::vector&lt;Number&gt;&amp; values,
<a name="l00164"></a>00164                           std::vector&lt;std::string&gt;&amp; names)<span class="keyword"> const</span>
<a name="l00165"></a>00165 <span class="keyword"></span>{
<a name="l00166"></a>00166   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   START_LOG(<span class="stringliteral">&quot;translate()&quot;</span>, <span class="stringliteral">&quot;MeshData&quot;</span>);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_comp = this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a3a2d5a1cc9751d36340ca063ad87c19c">n_val_per_node</a>();
<a name="l00171"></a>00171 
<a name="l00172"></a>00172   <span class="comment">// transfer our nodal data to a vector</span>
<a name="l00173"></a>00173   <span class="comment">// that may be written concurrently</span>
<a name="l00174"></a>00174   <span class="comment">// with the \p out_mesh.</span>
<a name="l00175"></a>00175   {
<a name="l00176"></a>00176     <span class="comment">// reserve memory for the nodal data</span>
<a name="l00177"></a>00177     values.reserve(n_comp*out_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00178"></a>00178     
<a name="l00179"></a>00179     <span class="comment">// iterate over the mesh&#39;s nodes</span>
<a name="l00180"></a>00180     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a>       nodes_it  = out_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00181"></a>00181     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> nodes_end = out_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00182"></a>00182 
<a name="l00183"></a>00183     <span class="comment">// Do not use the \p get_data() method, but the operator()</span>
<a name="l00184"></a>00184     <span class="comment">// method, since this returns by default a zero value,</span>
<a name="l00185"></a>00185     <span class="comment">// when there is no nodal data.</span>
<a name="l00186"></a>00186     <span class="keywordflow">for</span> (; nodes_it != nodes_end; ++nodes_it)
<a name="l00187"></a>00187       {
<a name="l00188"></a>00188         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = *nodes_it;
<a name="l00189"></a>00189         
<a name="l00190"></a>00190         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c= 0; c&lt;n_comp; c++)
<a name="l00191"></a>00191           values.push_back(this-&gt;operator()(node, c));
<a name="l00192"></a>00192       }
<a name="l00193"></a>00193   }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   
<a name="l00197"></a>00197   <span class="comment">// Now we have the data, nicely stored in \p values.</span>
<a name="l00198"></a>00198   <span class="comment">// It remains to give names to the data, then write to</span>
<a name="l00199"></a>00199   <span class="comment">// file.</span>
<a name="l00200"></a>00200   {
<a name="l00201"></a>00201     names.reserve(n_comp);
<a name="l00202"></a>00202     
<a name="l00203"></a>00203     <span class="comment">// this naming scheme only works up to n_comp=100</span>
<a name="l00204"></a>00204     <span class="comment">// (at least for gmv-accepted variable names)</span>
<a name="l00205"></a>00205     libmesh_assert(n_comp &lt; 100);
<a name="l00206"></a>00206 
<a name="l00207"></a>00207     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_comp; n++)
<a name="l00208"></a>00208       {
<a name="l00209"></a>00209         std::ostringstream name_buf;
<a name="l00210"></a>00210         name_buf &lt;&lt; <span class="stringliteral">&quot;bc_&quot;</span> &lt;&lt; n;
<a name="l00211"></a>00211         names.push_back(name_buf.str());
<a name="l00212"></a>00212       }
<a name="l00213"></a>00213   }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   STOP_LOG(<span class="stringliteral">&quot;translate()&quot;</span>, <span class="stringliteral">&quot;MeshData&quot;</span>);
<a name="l00216"></a>00216 }
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a><a class="code" href="classlibMesh_1_1MeshData.php#a9d18d3adfdf70d79d8c48aaec35f7145">00221</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a9d18d3adfdf70d79d8c48aaec35f7145">MeshData::close_foreign_id_maps</a> ()
<a name="l00222"></a>00222 {
<a name="l00223"></a>00223   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>)
<a name="l00224"></a>00224     {
<a name="l00225"></a>00225       libmesh_assert (!<a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>.empty());
<a name="l00226"></a>00226       libmesh_assert (!<a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">_id_elem</a>.empty());
<a name="l00227"></a>00227       libmesh_assert (!<a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>.empty());
<a name="l00228"></a>00228       libmesh_assert (!<a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>.empty());
<a name="l00229"></a>00229 
<a name="l00230"></a>00230       <a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a> = <span class="keyword">true</span>;
<a name="l00231"></a>00231       <a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a> = <span class="keyword">true</span>;
<a name="l00232"></a>00232     }
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a><a class="code" href="classlibMesh_1_1MeshData.php#afcea34e28ca571eca0c333d164136b64">00239</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#afcea34e28ca571eca0c333d164136b64">MeshData::read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00240"></a>00240 {
<a name="l00241"></a>00241   START_LOG(<span class="stringliteral">&quot;read()&quot;</span>, <span class="stringliteral">&quot;MeshData&quot;</span>);
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00244"></a>00244 
<a name="l00245"></a>00245   <span class="comment">// the id maps have to be closed before reading</span>
<a name="l00246"></a>00246   <span class="comment">// (note that in compatibility mode these are also true)</span>
<a name="l00247"></a>00247   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a> &amp;&amp; <a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>);
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">compatibility_mode</a>())
<a name="l00251"></a>00251       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: MeshData in compatibility mode, node and element ids&quot;</span> &lt;&lt; std::endl
<a name="l00252"></a>00252                     &lt;&lt; <span class="stringliteral">&quot;         stored in file may be totally different from libMesh ids!&quot;</span> &lt;&lt; std::endl;
<a name="l00253"></a>00253 <span class="preprocessor">#endif</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>
<a name="l00255"></a>00255   <span class="comment">// Read the file based on extension.  We let all processors read the</span>
<a name="l00256"></a>00256   <span class="comment">// data because it would be inaccurate to let only one processor</span>
<a name="l00257"></a>00257   <span class="comment">// have it and we&#39;re too lazy to code up a proper parallel read or</span>
<a name="l00258"></a>00258   <span class="comment">// read+broadcast right now.</span>
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="comment">//if (libMesh::processor_id() == 0)</span>
<a name="l00261"></a>00261   <span class="comment">//  {</span>
<a name="l00262"></a>00262       <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xta&quot;</span>) &lt; name.size())
<a name="l00263"></a>00263         this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a75bc0115c3f9ebf6c57ede071b42a9c8">read_xdr</a> (name, <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l00264"></a>00264       
<a name="l00265"></a>00265       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xtr&quot;</span>)  &lt; name.size())
<a name="l00266"></a>00266         this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a75bc0115c3f9ebf6c57ede071b42a9c8">read_xdr</a> (name, <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a2632308739033bf9f82ea90cdf92231e">DECODE</a>);
<a name="l00267"></a>00267       
<a name="l00268"></a>00268       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.unv&quot;</span>) &lt; name.size())
<a name="l00269"></a>00269         this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ab3a427b0ae38e74ebadd8f536195a4f6">read_unv</a> (name);
<a name="l00270"></a>00270       
<a name="l00271"></a>00271       <span class="keywordflow">else</span> <span class="keywordflow">if</span> ((name.rfind(<span class="stringliteral">&quot;.node&quot;</span>) &lt; name.size()) ||
<a name="l00272"></a>00272                (name.rfind(<span class="stringliteral">&quot;.ele&quot;</span>) &lt; name.size()))
<a name="l00273"></a>00273         this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a0897b97eb82f56a820a7be46a268e45e">read_tetgen</a> (name);
<a name="l00274"></a>00274       
<a name="l00275"></a>00275       <span class="keywordflow">else</span>
<a name="l00276"></a>00276         {
<a name="l00277"></a>00277           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot; ERROR: Unrecognized file extension: &quot;</span> &lt;&lt; name
<a name="l00278"></a>00278                         &lt;&lt; <span class="stringliteral">&quot;\n   I understand the following:\n\n&quot;</span>
<a name="l00279"></a>00279                         &lt;&lt; <span class="stringliteral">&quot;     *.xta  -- Internal ASCII data format\n&quot;</span>
<a name="l00280"></a>00280                         &lt;&lt; <span class="stringliteral">&quot;     *.xtr  -- Internal binary data format\n&quot;</span>
<a name="l00281"></a>00281                         &lt;&lt; <span class="stringliteral">&quot;     *.unv  -- I-deas format\n&quot;</span>
<a name="l00282"></a>00282                         &lt;&lt; std::endl;
<a name="l00283"></a>00283           libmesh_error();
<a name="l00284"></a>00284           
<a name="l00285"></a>00285         }    
<a name="l00286"></a>00286     <span class="comment">//}</span>
<a name="l00287"></a>00287   STOP_LOG(<span class="stringliteral">&quot;read()&quot;</span>, <span class="stringliteral">&quot;MeshData&quot;</span>);
<a name="l00288"></a>00288 }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a><a class="code" href="classlibMesh_1_1MeshData.php#a90b381287a97141afbb7f1e0bb49bc9a">00295</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a90b381287a97141afbb7f1e0bb49bc9a">MeshData::write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00296"></a>00296 {
<a name="l00297"></a>00297   START_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;MeshData&quot;</span>);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="comment">// the id maps have to be closed before writing</span>
<a name="l00302"></a>00302   <span class="comment">// (note that in compatibility mode these are also true)</span>
<a name="l00303"></a>00303   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a> &amp;&amp; <a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>);
<a name="l00304"></a>00304   
<a name="l00305"></a>00305 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00306"></a>00306 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">compatibility_mode</a>())
<a name="l00307"></a>00307       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: MeshData in compatibility mode.  Node and element ids&quot;</span> &lt;&lt; std::endl
<a name="l00308"></a>00308                     &lt;&lt; <span class="stringliteral">&quot;         written to file may differ from libMesh numbering&quot;</span> &lt;&lt; std::endl
<a name="l00309"></a>00309                     &lt;&lt; <span class="stringliteral">&quot;         next time this file is read!&quot;</span> &lt;&lt; std::endl;
<a name="l00310"></a>00310 <span class="preprocessor">#endif</span>
<a name="l00311"></a>00311 <span class="preprocessor"></span>
<a name="l00312"></a>00312   <span class="comment">// Read the file based on extension</span>
<a name="l00313"></a>00313   {
<a name="l00314"></a>00314     <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xta&quot;</span>) &lt; name.size())
<a name="l00315"></a>00315       <a class="code" href="classlibMesh_1_1MeshData.php#ad137da147eda9f50aee32b5c746dbc83">write_xdr</a> (name, <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l00316"></a>00316 
<a name="l00317"></a>00317     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.xtr&quot;</span>)  &lt; name.size())
<a name="l00318"></a>00318       <a class="code" href="classlibMesh_1_1MeshData.php#ad137da147eda9f50aee32b5c746dbc83">write_xdr</a> (name, <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8ae5559170d41d912b449375bb4e3468f6">ENCODE</a>);
<a name="l00319"></a>00319 
<a name="l00320"></a>00320     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.unv&quot;</span>) &lt; name.size())
<a name="l00321"></a>00321       <a class="code" href="classlibMesh_1_1MeshData.php#a75b7a811a26fe53b3d873369cf7307d7">write_unv</a> (name);
<a name="l00322"></a>00322 
<a name="l00323"></a>00323     <span class="keywordflow">else</span>
<a name="l00324"></a>00324       {
<a name="l00325"></a>00325         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot; ERROR: Unrecognized file extension: &quot;</span> &lt;&lt; name
<a name="l00326"></a>00326                       &lt;&lt; <span class="stringliteral">&quot;\n   I understand the following:\n\n&quot;</span>
<a name="l00327"></a>00327                       &lt;&lt; <span class="stringliteral">&quot;     *.xta  -- Internal ASCII data format\n&quot;</span>
<a name="l00328"></a>00328                       &lt;&lt; <span class="stringliteral">&quot;     *.xtr  -- Internal binary data format\n&quot;</span>
<a name="l00329"></a>00329                       &lt;&lt; <span class="stringliteral">&quot;     *.unv  -- I-deas format\n&quot;</span>
<a name="l00330"></a>00330                       &lt;&lt; std::endl;
<a name="l00331"></a>00331         libmesh_error();
<a name="l00332"></a>00332 
<a name="l00333"></a>00333       }    
<a name="l00334"></a>00334   }
<a name="l00335"></a>00335   STOP_LOG(<span class="stringliteral">&quot;write()&quot;</span>, <span class="stringliteral">&quot;MeshData&quot;</span>);
<a name="l00336"></a>00336 }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a><a class="code" href="classlibMesh_1_1MeshData.php#a3a935172deedf28ea51cbc6a77d7bd7c">00341</a> std::string <a class="code" href="classlibMesh_1_1MeshData.php#a3a935172deedf28ea51cbc6a77d7bd7c">MeshData::get_info</a>()<span class="keyword"> const</span>
<a name="l00342"></a>00342 <span class="keyword"></span>{
<a name="l00343"></a>00343   std::ostringstream <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a601f98bb1c90131ce7d71313a5df6ee4">active</a>() || this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">compatibility_mode</a>())
<a name="l00346"></a>00346     {
<a name="l00347"></a>00347       out &lt;&lt; <span class="stringliteral">&quot; MeshData Information:\n&quot;</span>;
<a name="l00348"></a>00348       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a601f98bb1c90131ce7d71313a5df6ee4">active</a>())
<a name="l00349"></a>00349           out &lt;&lt; <span class="stringliteral">&quot;  object activated.\n&quot;</span>;
<a name="l00350"></a>00350       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">compatibility_mode</a>())
<a name="l00351"></a>00351           out &lt;&lt; <span class="stringliteral">&quot;  object in compatibility mode.\n&quot;</span>;
<a name="l00352"></a>00352       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a> != <span class="stringliteral">&quot;&quot;</span>)
<a name="l00353"></a>00353           out &lt;&lt; <span class="stringliteral">&quot;  descriptor=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a> &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00354"></a>00354       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a5dae25604ba226bdffce2852fc24f2c9">elem_initialized</a>())
<a name="l00355"></a>00355           out &lt;&lt; <span class="stringliteral">&quot;  Element associated data initialized.\n&quot;</span>
<a name="l00356"></a>00356               &lt;&lt; <span class="stringliteral">&quot;   n_val_per_elem()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac876ff50ca56bba9e1b7e02b614a31f3">n_val_per_elem</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00357"></a>00357               &lt;&lt; <span class="stringliteral">&quot;   n_elem_data()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac072d973a4e2264b8bf97c67ea8763c6">n_elem_data</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00358"></a>00358       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a589d73467febe67216d4d06465bcab7e">node_initialized</a>())
<a name="l00359"></a>00359           out &lt;&lt; <span class="stringliteral">&quot;  Node associated data initialized.\n&quot;</span>
<a name="l00360"></a>00360               &lt;&lt; <span class="stringliteral">&quot;   n_val_per_node()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a3a2d5a1cc9751d36340ca063ad87c19c">n_val_per_node</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>
<a name="l00361"></a>00361               &lt;&lt; <span class="stringliteral">&quot;   n_node_data()=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aae69454ae53d10dc6251bda5517bbb87">n_node_data</a>() &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00362"></a>00362     }
<a name="l00363"></a>00363   <span class="keywordflow">else</span>
<a name="l00364"></a>00364       out &lt;&lt; <span class="stringliteral">&quot; MeshData neither active nor in compatibility mode.\n&quot;</span>;
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="keywordflow">return</span> out.str();
<a name="l00367"></a>00367 }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a><a class="code" href="classlibMesh_1_1MeshData.php#abeee0c166a8c912aa7f83d3ee1546976">00372</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#abeee0c166a8c912aa7f83d3ee1546976">MeshData::print_info</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00373"></a>00373 <span class="keyword"></span>{
<a name="l00374"></a>00374   os &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a3a935172deedf28ea51cbc6a77d7bd7c">get_info</a>()
<a name="l00375"></a>00375      &lt;&lt; std::endl;
<a name="l00376"></a>00376 }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a><a class="code" href="namespacelibMesh.php#af3375191938b40bd4242da0b50918e49">00379</a> std::ostream&amp; <a class="code" href="namespacelibMesh.php#a546a7b5eb3d073add8e1f19af6bcaf82">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>&amp; m)
<a name="l00380"></a>00380 {
<a name="l00381"></a>00381   m.<a class="code" href="classlibMesh_1_1MeshData.php#abeee0c166a8c912aa7f83d3ee1546976">print_info</a>(os);
<a name="l00382"></a>00382   <span class="keywordflow">return</span> os;
<a name="l00383"></a>00383 }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a><a class="code" href="classlibMesh_1_1MeshData.php#a8fd77b8c09e0b805fa2cfca34b518540">00388</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1MeshData.php#a8fd77b8c09e0b805fa2cfca34b518540">MeshData::foreign_id_to_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fid)<span class="keyword"> const</span>
<a name="l00389"></a>00389 <span class="keyword"></span>{
<a name="l00390"></a>00390   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>)
<a name="l00391"></a>00391     {
<a name="l00392"></a>00392       <span class="comment">// when active, use our _id_node map</span>
<a name="l00393"></a>00393       libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>);
<a name="l00394"></a>00394 
<a name="l00395"></a>00395       std::map&lt;<span class="keywordtype">unsigned</span> int,
<a name="l00396"></a>00396                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*&gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>.find(fid);
<a name="l00397"></a>00397 
<a name="l00398"></a>00398       <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>.end())
<a name="l00399"></a>00399         {
<a name="l00400"></a>00400           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Have no Node* associated with the foreign id = &quot;</span>
<a name="l00401"></a>00401                         &lt;&lt; fid
<a name="l00402"></a>00402                         &lt;&lt; std::endl;
<a name="l00403"></a>00403           libmesh_error();
<a name="l00404"></a>00404           <span class="keywordflow">return</span> NULL;
<a name="l00405"></a>00405         }
<a name="l00406"></a>00406       <span class="keywordflow">else</span>
<a name="l00407"></a>00407           <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00408"></a>00408     }
<a name="l00409"></a>00409   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>)
<a name="l00410"></a>00410       <span class="comment">// when only in compatibility mode, </span>
<a name="l00411"></a>00411       <span class="comment">// return the node stored in the MeshBase </span>
<a name="l00412"></a>00412       <span class="comment">// under its current id</span>
<a name="l00413"></a>00413       <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a7bd23d016ad747f77e5843ac25df7151">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(fid);
<a name="l00414"></a>00414 
<a name="l00415"></a>00415   <span class="comment">// should never get here</span>
<a name="l00416"></a>00416   libmesh_error();
<a name="l00417"></a>00417   <span class="keywordflow">return</span> NULL;
<a name="l00418"></a>00418 }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a><a class="code" href="classlibMesh_1_1MeshData.php#a61177caeb0fb845281a61e8f52a0bb5f">00424</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#a61177caeb0fb845281a61e8f52a0bb5f">MeshData::node_to_foreign_id</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* n)<span class="keyword"> const</span>
<a name="l00425"></a>00425 <span class="keyword"></span>{
<a name="l00426"></a>00426   libmesh_assert (n != NULL);
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>)
<a name="l00429"></a>00429     {
<a name="l00430"></a>00430       <span class="comment">// when active, use our _node_id map</span>
<a name="l00431"></a>00431       libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>);
<a name="l00432"></a>00432 
<a name="l00433"></a>00433       <span class="comment">// look it up in the map</span>
<a name="l00434"></a>00434       std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*,
<a name="l00435"></a>00435                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>.find(n);
<a name="l00436"></a>00436       
<a name="l00437"></a>00437       <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>.end())
<a name="l00438"></a>00438         {
<a name="l00439"></a>00439           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: No foreign id stored for the node &quot;</span>
<a name="l00440"></a>00440                         &lt;&lt; <span class="stringliteral">&quot;with the libMesh id = &quot;</span>
<a name="l00441"></a>00441                         &lt;&lt; n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()
<a name="l00442"></a>00442                         &lt;&lt; std::endl;
<a name="l00443"></a>00443           libmesh_error();
<a name="l00444"></a>00444           <span class="keywordflow">return</span> 0;
<a name="l00445"></a>00445         }
<a name="l00446"></a>00446       <span class="keywordflow">else</span>
<a name="l00447"></a>00447           <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00448"></a>00448     }
<a name="l00449"></a>00449   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>)
<a name="l00450"></a>00450     <span class="comment">// when only in compatibility mode, </span>
<a name="l00451"></a>00451     <span class="comment">// return libMesh&#39;s node id</span>
<a name="l00452"></a>00452     <span class="keywordflow">return</span> n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   <span class="comment">// should never get here</span>
<a name="l00455"></a>00455   libmesh_error();
<a name="l00456"></a>00456   <span class="keywordflow">return</span> 0;
<a name="l00457"></a>00457 }
<a name="l00458"></a>00458 
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a><a class="code" href="classlibMesh_1_1MeshData.php#ac6ba706235420b69e98dc345d69f3d07">00466</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshData.php#ac6ba706235420b69e98dc345d69f3d07">MeshData::foreign_id_to_elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fid)<span class="keyword"> const</span>
<a name="l00467"></a>00467 <span class="keyword"></span>{
<a name="l00468"></a>00468   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>)
<a name="l00469"></a>00469     {
<a name="l00470"></a>00470       <span class="comment">// when active, use our _id_elem map</span>
<a name="l00471"></a>00471       libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>);
<a name="l00472"></a>00472       
<a name="l00473"></a>00473       std::map&lt;<span class="keywordtype">unsigned</span> int,
<a name="l00474"></a>00474                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*&gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">_id_elem</a>.find(fid);
<a name="l00475"></a>00475       
<a name="l00476"></a>00476       <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">_id_elem</a>.end())
<a name="l00477"></a>00477         {
<a name="l00478"></a>00478           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Have no Elem* associated with the foreign id = &quot;</span>
<a name="l00479"></a>00479                         &lt;&lt; fid
<a name="l00480"></a>00480                         &lt;&lt; std::endl;
<a name="l00481"></a>00481           libmesh_error();
<a name="l00482"></a>00482           <span class="keywordflow">return</span> NULL;
<a name="l00483"></a>00483         }
<a name="l00484"></a>00484       <span class="keywordflow">else</span>
<a name="l00485"></a>00485           <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00486"></a>00486     }
<a name="l00487"></a>00487   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>)
<a name="l00488"></a>00488     <span class="comment">// when only in compatibility mode, </span>
<a name="l00489"></a>00489     <span class="comment">// return element using the libMesh id</span>
<a name="l00490"></a>00490     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a7bd23d016ad747f77e5843ac25df7151">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(fid);
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   <span class="comment">// should never get here</span>
<a name="l00493"></a>00493   libmesh_error();
<a name="l00494"></a>00494   <span class="keywordflow">return</span> NULL;
<a name="l00495"></a>00495 }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a><a class="code" href="classlibMesh_1_1MeshData.php#ad92a581667b41710c22c7b59aec3fe64">00501</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#ad92a581667b41710c22c7b59aec3fe64">MeshData::elem_to_foreign_id</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e)<span class="keyword"> const</span>
<a name="l00502"></a>00502 <span class="keyword"></span>{
<a name="l00503"></a>00503   libmesh_assert (e != NULL);
<a name="l00504"></a>00504 
<a name="l00505"></a>00505   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>)
<a name="l00506"></a>00506     {
<a name="l00507"></a>00507       <span class="comment">// when active, use our _id_elem map</span>
<a name="l00508"></a>00508       libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>);
<a name="l00509"></a>00509 
<a name="l00510"></a>00510              <span class="comment">// look it up in the map</span>
<a name="l00511"></a>00511              std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00512"></a>00512                <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>.find(e);
<a name="l00513"></a>00513 
<a name="l00514"></a>00514       <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>.end())
<a name="l00515"></a>00515         {
<a name="l00516"></a>00516           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: No foreign id stored for the element &quot;</span>
<a name="l00517"></a>00517                         &lt;&lt; <span class="stringliteral">&quot;with the libMesh id = &quot;</span>
<a name="l00518"></a>00518                         &lt;&lt; e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()
<a name="l00519"></a>00519                         &lt;&lt; std::endl;
<a name="l00520"></a>00520           libmesh_error();
<a name="l00521"></a>00521           <span class="keywordflow">return</span> 0;
<a name="l00522"></a>00522         }
<a name="l00523"></a>00523       <span class="keywordflow">else</span>
<a name="l00524"></a>00524           <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00525"></a>00525     }
<a name="l00526"></a>00526   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>)
<a name="l00527"></a>00527     <span class="comment">// when only in compatibility mode, </span>
<a name="l00528"></a>00528     <span class="comment">// return libMesh&#39;s element id</span>
<a name="l00529"></a>00529     <span class="keywordflow">return</span> e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   <span class="comment">// should never get here</span>
<a name="l00532"></a>00532   libmesh_error();
<a name="l00533"></a>00533   <span class="keywordflow">return</span> 0;
<a name="l00534"></a>00534 }
<a name="l00535"></a>00535 
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540 
<a name="l00541"></a>00541 
<a name="l00542"></a><a class="code" href="classlibMesh_1_1MeshData.php#a846426f685cd75441b10e5c552256f79">00542</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a846426f685cd75441b10e5c552256f79">MeshData::insert_node_data</a> (std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*,
<a name="l00543"></a>00543                                  std::vector&lt;Number&gt; &gt;&amp; nd,
<a name="l00544"></a>00544                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> close_elem_data)
<a name="l00545"></a>00545 {
<a name="l00546"></a>00546   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00547"></a>00547   <span class="comment">// these are also true in compatibility mode</span>
<a name="l00548"></a>00548   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>);
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>)
<a name="l00551"></a>00551     {
<a name="l00552"></a>00552       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Nodal data already closed!  Use clear() first!&quot;</span>
<a name="l00553"></a>00553                     &lt;&lt; std::endl;
<a name="l00554"></a>00554       libmesh_error();
<a name="l00555"></a>00555     }
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.empty());
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00560"></a>00560 <span class="preprocessor"></span>  std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*, 
<a name="l00561"></a>00561            std::vector&lt;Number&gt; &gt;::const_iterator nd_pos = nd.begin();
<a name="l00562"></a>00562   std::map&lt;<span class="keyword">const</span> Node*, 
<a name="l00563"></a>00563            std::vector&lt;Number&gt; &gt;::const_iterator nd_end = nd.end();
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="comment">// Compare entity-by-entity that the</span>
<a name="l00566"></a>00566   <span class="comment">// sizes of the std::vector&#39;s are identical.</span>
<a name="l00567"></a>00567   <span class="comment">// For this, simply take the length of the 0th</span>
<a name="l00568"></a>00568   <span class="comment">// entry as reference length, and compare this</span>
<a name="l00569"></a>00569   <span class="comment">// with the length of the 1st, 2nd...</span>
<a name="l00570"></a>00570   libmesh_assert (nd_pos != nd_end);
<a name="l00571"></a>00571   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> reference_length = (*nd_pos).second.size();
<a name="l00572"></a>00572 
<a name="l00573"></a>00573   <span class="comment">// advance, so that we compare with the 1st</span>
<a name="l00574"></a>00574   ++nd_pos;
<a name="l00575"></a>00575 
<a name="l00576"></a>00576   <span class="keywordflow">for</span> (; nd_pos != nd_end; ++nd_pos)
<a name="l00577"></a>00577     <span class="keywordflow">if</span> ( (*nd_pos).second.size() != reference_length) 
<a name="l00578"></a>00578       {
<a name="l00579"></a>00579         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Size mismatch.&quot;</span>
<a name="l00580"></a>00580                       &lt;&lt; std::endl;
<a name="l00581"></a>00581         libmesh_error();
<a name="l00582"></a>00582       }
<a name="l00583"></a>00583 <span class="preprocessor">#endif</span>
<a name="l00584"></a>00584 <span class="preprocessor"></span>
<a name="l00585"></a>00585   <span class="comment">// copy over</span>
<a name="l00586"></a>00586   <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a> = nd;
<a name="l00587"></a>00587 
<a name="l00588"></a>00588   <span class="comment">// we may freely trash the nd</span>
<a name="l00589"></a>00589   nd.clear();
<a name="l00590"></a>00590 
<a name="l00591"></a>00591   <span class="comment">// close node data</span>
<a name="l00592"></a>00592   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a> = <span class="keyword">true</span>;
<a name="l00593"></a>00593 
<a name="l00594"></a>00594   <span class="comment">// if user wants to, then close elem data, too</span>
<a name="l00595"></a>00595   <span class="keywordflow">if</span> (close_elem_data)
<a name="l00596"></a>00596     {
<a name="l00597"></a>00597       libmesh_assert((this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>));
<a name="l00598"></a>00598       this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a> = <span class="keyword">true</span>;
<a name="l00599"></a>00599     }
<a name="l00600"></a>00600 }
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a>00603 
<a name="l00604"></a>00604 
<a name="l00605"></a>00605 
<a name="l00606"></a><a class="code" href="classlibMesh_1_1MeshData.php#ac8b13a5f85386ca5c6b5c150b585418b">00606</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#ac8b13a5f85386ca5c6b5c150b585418b">MeshData::insert_elem_data</a> (std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00607"></a>00607                                  std::vector&lt;Number&gt; &gt;&amp; ed,
<a name="l00608"></a>00608                                  <span class="keyword">const</span> <span class="keywordtype">bool</span> close_node_data)
<a name="l00609"></a>00609 {
<a name="l00610"></a>00610   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00611"></a>00611   <span class="comment">// these are also true in compatibility mode</span>
<a name="l00612"></a>00612   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>);
<a name="l00613"></a>00613 
<a name="l00614"></a>00614   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>)
<a name="l00615"></a>00615     {
<a name="l00616"></a>00616       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Element data already closed!  Use clear() first!&quot;</span>
<a name="l00617"></a>00617                     &lt;&lt; std::endl;
<a name="l00618"></a>00618       libmesh_error();
<a name="l00619"></a>00619     }
<a name="l00620"></a>00620 
<a name="l00621"></a>00621   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.empty());
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00624"></a>00624 <span class="preprocessor"></span>  std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*, 
<a name="l00625"></a>00625            std::vector&lt;Number&gt; &gt;::const_iterator ed_pos = ed.begin();
<a name="l00626"></a>00626   std::map&lt;<span class="keyword">const</span> Elem*, 
<a name="l00627"></a>00627            std::vector&lt;Number&gt; &gt;::const_iterator ed_end = ed.end();
<a name="l00628"></a>00628 
<a name="l00629"></a>00629   <span class="comment">// Compare entity-by-entity that the</span>
<a name="l00630"></a>00630   <span class="comment">// sizes of the std::vector&#39;s are identical.</span>
<a name="l00631"></a>00631   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> reference_length = (*ed_pos).second.size();
<a name="l00632"></a>00632   ++ed_pos;
<a name="l00633"></a>00633 
<a name="l00634"></a>00634   <span class="keywordflow">for</span> (; ed_pos != ed_end; ++ed_pos)
<a name="l00635"></a>00635     <span class="keywordflow">if</span> ( (*ed_pos).second.size() != reference_length) 
<a name="l00636"></a>00636       {
<a name="l00637"></a>00637         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Size mismatch.&quot;</span>
<a name="l00638"></a>00638                       &lt;&lt; std::endl;
<a name="l00639"></a>00639         libmesh_error();
<a name="l00640"></a>00640       }
<a name="l00641"></a>00641 <span class="preprocessor">#endif</span>
<a name="l00642"></a>00642 <span class="preprocessor"></span>
<a name="l00643"></a>00643   <span class="comment">// copy over</span>
<a name="l00644"></a>00644   <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a> = ed;
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   <span class="comment">// we may freely trash the ed</span>
<a name="l00647"></a>00647   ed.clear();
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   <span class="comment">// close elem data</span>
<a name="l00650"></a>00650   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a> = <span class="keyword">true</span>;
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="comment">// if user wants to, then close node data, too</span>
<a name="l00653"></a>00653   <span class="keywordflow">if</span> (close_node_data)
<a name="l00654"></a>00654     {
<a name="l00655"></a>00655       libmesh_assert((this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>));
<a name="l00656"></a>00656       this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a> = <span class="keyword">true</span>;
<a name="l00657"></a>00657     }
<a name="l00658"></a>00658 }
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a>00661 
<a name="l00662"></a>00662 
<a name="l00663"></a>00663 
<a name="l00664"></a><a class="code" href="classlibMesh_1_1MeshData.php#a3a2d5a1cc9751d36340ca063ad87c19c">00664</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#a3a2d5a1cc9751d36340ca063ad87c19c">MeshData::n_val_per_node</a> ()<span class="keyword"> const</span>
<a name="l00665"></a>00665 <span class="keyword"></span>{
<a name="l00666"></a>00666   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00667"></a>00667   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>);
<a name="l00668"></a>00668 
<a name="l00669"></a>00669   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.empty())
<a name="l00670"></a>00670     {
<a name="l00671"></a>00671       std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*, 
<a name="l00672"></a>00672                std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.begin();
<a name="l00673"></a>00673       libmesh_assert (pos != <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.end());
<a name="l00674"></a>00674       <span class="keywordflow">return</span> (pos-&gt;second.size());
<a name="l00675"></a>00675     }
<a name="l00676"></a>00676   <span class="keywordflow">else</span>
<a name="l00677"></a>00677       <span class="keywordflow">return</span> 0;
<a name="l00678"></a>00678 }
<a name="l00679"></a>00679 
<a name="l00680"></a>00680 
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a><a class="code" href="classlibMesh_1_1MeshData.php#aae69454ae53d10dc6251bda5517bbb87">00683</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#aae69454ae53d10dc6251bda5517bbb87">MeshData::n_node_data</a> ()<span class="keyword"> const</span>
<a name="l00684"></a>00684 <span class="keyword"></span>{
<a name="l00685"></a>00685   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00686"></a>00686   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>);
<a name="l00687"></a>00687 
<a name="l00688"></a>00688   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.size();
<a name="l00689"></a>00689 }
<a name="l00690"></a>00690 
<a name="l00691"></a>00691 
<a name="l00692"></a>00692 
<a name="l00693"></a>00693 
<a name="l00694"></a><a class="code" href="classlibMesh_1_1MeshData.php#ac876ff50ca56bba9e1b7e02b614a31f3">00694</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#ac876ff50ca56bba9e1b7e02b614a31f3">MeshData::n_val_per_elem</a> ()<span class="keyword"> const</span>
<a name="l00695"></a>00695 <span class="keyword"></span>{
<a name="l00696"></a>00696   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00697"></a>00697   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>);
<a name="l00698"></a>00698 
<a name="l00699"></a>00699   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.empty())
<a name="l00700"></a>00700     {
<a name="l00701"></a>00701       std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*, 
<a name="l00702"></a>00702                std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.begin();
<a name="l00703"></a>00703       libmesh_assert (pos != <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.end());
<a name="l00704"></a>00704       <span class="keywordflow">return</span> (pos-&gt;second.size());
<a name="l00705"></a>00705     }
<a name="l00706"></a>00706   <span class="keywordflow">else</span>
<a name="l00707"></a>00707       <span class="keywordflow">return</span> 0;
<a name="l00708"></a>00708 }
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 
<a name="l00711"></a>00711 
<a name="l00712"></a>00712 
<a name="l00713"></a><a class="code" href="classlibMesh_1_1MeshData.php#ac072d973a4e2264b8bf97c67ea8763c6">00713</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#ac072d973a4e2264b8bf97c67ea8763c6">MeshData::n_elem_data</a> ()<span class="keyword"> const</span>
<a name="l00714"></a>00714 <span class="keyword"></span>{
<a name="l00715"></a>00715   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00716"></a>00716   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>);
<a name="l00717"></a>00717 
<a name="l00718"></a>00718   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.size();
<a name="l00719"></a>00719 }
<a name="l00720"></a>00720 
<a name="l00721"></a>00721 
<a name="l00722"></a>00722 
<a name="l00723"></a>00723 
<a name="l00724"></a><a class="code" href="classlibMesh_1_1MeshData.php#a3cfeb42a2a552b7ccca99766bdc95f91">00724</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a3cfeb42a2a552b7ccca99766bdc95f91">MeshData::assign</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>&amp; omd)
<a name="l00725"></a>00725 {
<a name="l00726"></a>00726   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a>    = omd.<a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a>;
<a name="l00727"></a>00727   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a> = omd.<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>;
<a name="l00728"></a>00728   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>   = omd.<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>;
<a name="l00729"></a>00729 
<a name="l00730"></a>00730   <span class="comment">// we have to be able to modify our elem id maps</span>
<a name="l00731"></a>00731   libmesh_assert (!this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>);
<a name="l00732"></a>00732 
<a name="l00733"></a>00733   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>   = omd.<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>;
<a name="l00734"></a>00734   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>             = omd.<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>;
<a name="l00735"></a>00735   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a> = omd.<a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>;
<a name="l00736"></a>00736 
<a name="l00737"></a>00737   <span class="comment">// this is ok because we do not manage the UnvHeader</span>
<a name="l00738"></a>00738   <span class="comment">// in terms of memory, but only hold a pointer to it...</span>
<a name="l00739"></a>00739   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a2c427e9a33c42e3ea08fa2030be0ae68">_unv_header</a>         = omd.<a class="code" href="classlibMesh_1_1MeshData.php#a2c427e9a33c42e3ea08fa2030be0ae68">_unv_header</a>;
<a name="l00740"></a>00740 
<a name="l00741"></a>00741   <span class="comment">// Now copy the foreign id maps -- but only for the </span>
<a name="l00742"></a>00742   <span class="comment">// nodes.  The nodes of the boundary mesh are actually</span>
<a name="l00743"></a>00743   <span class="comment">// nodes of the volume mesh.</span>
<a name="l00744"></a>00744   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a> = omd.<a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>;
<a name="l00745"></a>00745   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a> = omd.<a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>;
<a name="l00746"></a>00746 
<a name="l00747"></a>00747   <span class="comment">// The element vector of the boundary mesh contains elements</span>
<a name="l00748"></a>00748   <span class="comment">// that are new, and there _cannot_ be any associated</span>
<a name="l00749"></a>00749   <span class="comment">// foreign id in the maps.  Therefore, fill the maps with</span>
<a name="l00750"></a>00750   <span class="comment">// the libMesh id&#39;s.  But only when the other MeshData</span>
<a name="l00751"></a>00751   <span class="comment">// has element ids.</span>
<a name="l00752"></a>00752   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>) &amp;&amp; (omd.<a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>.size() != 0))
<a name="l00753"></a>00753     {
<a name="l00754"></a>00754 
<a name="l00755"></a>00755       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshData.php#a7bd23d016ad747f77e5843ac25df7151">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00756"></a>00756       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshData.php#a7bd23d016ad747f77e5843ac25df7151">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00757"></a>00757 
<a name="l00758"></a>00758       <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00759"></a>00759         {
<a name="l00760"></a>00760           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;  
<a name="l00761"></a>00761           this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aca3722b2bab0198b3e3efc7d47eed1c8">add_foreign_elem_id</a>(elem, elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00762"></a>00762         }
<a name="l00763"></a>00763     }
<a name="l00764"></a>00764 
<a name="l00765"></a>00765   <span class="comment">// now we can safely assign omd&#39;s value</span>
<a name="l00766"></a>00766   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>   = omd.<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>;
<a name="l00767"></a>00767   
<a name="l00768"></a>00768 
<a name="l00769"></a>00769   <span class="comment">// and finally the node- and element-associated data</span>
<a name="l00770"></a>00770   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a> = omd.<a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>;
<a name="l00771"></a>00771   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a> = omd.<a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>;
<a name="l00772"></a>00772 }
<a name="l00773"></a>00773 
<a name="l00774"></a>00774 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
