<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_data.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__data_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_data.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_data_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_data_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="enum__xdr__mode_8h.php">enum_xdr_mode.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>Node;
<a name="l00039"></a>00039 <span class="keyword">class </span>Elem;
<a name="l00040"></a>00040 <span class="keyword">class </span>MeshBase;
<a name="l00041"></a>00041 <span class="keyword">class </span>MeshDataUnvHeader;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00057"></a>00057 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00058"></a>00058 <span class="comment">// MeshData class definition</span>
<a name="l00059"></a><a class="code" href="classlibMesh_1_1MeshData.php">00059</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a> 
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="comment">//----------------------------------------------------------</span>
<a name="l00065"></a>00065   <span class="comment">// convenient typedefs</span>
<a name="l00074"></a><a class="code" href="classlibMesh_1_1MeshData.php#a83a00f44aa1725ddc4056fbcbdc5f570">00074</a> <span class="comment"></span>  <span class="keyword">typedef</span> std::map&lt;const Node*, std::vector&lt;Number&gt; &gt;::const_iterator <a class="code" href="classlibMesh_1_1MeshData.php#a83a00f44aa1725ddc4056fbcbdc5f570">const_node_data_iterator</a>;
<a name="l00075"></a>00075 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1MeshData.php#a2d3b1aa41632f172b9f22205881b7045">00084</a>   <span class="keyword">typedef</span> std::map&lt;const Elem*, std::vector&lt;Number&gt; &gt;::const_iterator <a class="code" href="classlibMesh_1_1MeshData.php#a2d3b1aa41632f172b9f22205881b7045">const_elem_data_iterator</a>;
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="comment">//----------------------------------------------------------</span>
<a name="l00092"></a>00092 <span class="comment"></span>  <a class="code" href="classlibMesh_1_1MeshData.php#a3fdd6de8096631493be8e6f56dc15a73">MeshData</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; m);
<a name="l00093"></a>00093 
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1MeshData.php#afe93244c75183533ba93da5baa7ae974">~MeshData</a> ();
<a name="l00098"></a>00098 
<a name="l00108"></a>00108   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a9c8a8f08799ae1e9acf43abdb904c6bb">activate</a> (<span class="keyword">const</span> std::string&amp; descriptor=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00109"></a>00109 
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a3e1a2ffd0b28624afa10d5a7c436d9e0">enable_compatibility_mode</a> (<span class="keyword">const</span> std::string&amp; descriptor=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00123"></a>00123 
<a name="l00129"></a>00129   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a19e205366bfe0869017f32985e60ff8b">clear</a> ();
<a name="l00130"></a>00130 
<a name="l00139"></a>00139   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a4ceb18a184138fdb46c40273aaa02d06">slim</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> node_id_map = <span class="keyword">true</span>,
<a name="l00140"></a>00140              <span class="keyword">const</span> <span class="keywordtype">bool</span> elem_id_map = <span class="keyword">true</span>);
<a name="l00141"></a>00141 
<a name="l00156"></a>00156   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a329d75769bbfa110390df61d154b01ed">translate</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; out_mesh,
<a name="l00157"></a>00157                   std::vector&lt;Number&gt;&amp; data_values,
<a name="l00158"></a>00158                   std::vector&lt;std::string&gt;&amp; data_names) <span class="keyword">const</span>;
<a name="l00159"></a>00159 
<a name="l00166"></a>00166   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#afcea34e28ca571eca0c333d164136b64">read</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00167"></a>00167 
<a name="l00172"></a>00172   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a90b381287a97141afbb7f1e0bb49bc9a">write</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00173"></a>00173 
<a name="l00178"></a>00178   std::string <a class="code" href="classlibMesh_1_1MeshData.php#a3a935172deedf28ea51cbc6a77d7bd7c">get_info</a> () <span class="keyword">const</span>;
<a name="l00179"></a>00179 
<a name="l00183"></a>00183   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#abeee0c166a8c912aa7f83d3ee1546976">print_info</a> (std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00184"></a>00184 
<a name="l00188"></a>00188   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classlibMesh_1_1MeshData.php#a0e15bc21697bf830de2d316545795c93">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>&amp; m);
<a name="l00189"></a>00189   
<a name="l00190"></a>00190   
<a name="l00191"></a>00191   <span class="comment">//----------------------------------------------------------</span>
<a name="l00192"></a>00192   <span class="comment">// Node-associated data</span>
<a name="l00198"></a>00198 <span class="comment"></span>  <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1MeshData.php#a00caf832d0eab35af7c9617f8dbce2e1">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node, 
<a name="l00199"></a>00199                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00200"></a>00200 
<a name="l00205"></a>00205   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#abc23718035cd723bf105c0161b767a79">has_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node) <span class="keyword">const</span>;
<a name="l00206"></a>00206 
<a name="l00213"></a>00213   <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; <a class="code" href="classlibMesh_1_1MeshData.php#ae1506d2f8392e527efdda28256e7ebab">get_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node) <span class="keyword">const</span>;
<a name="l00214"></a>00214 
<a name="l00219"></a>00219   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a5912ac9d33a7d80f877bae173bcec531">set_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node, <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; val);
<a name="l00220"></a>00220 
<a name="l00228"></a>00228   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#a3a2d5a1cc9751d36340ca063ad87c19c">n_val_per_node</a> () <span class="keyword">const</span>;
<a name="l00229"></a>00229 
<a name="l00234"></a>00234   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#aae69454ae53d10dc6251bda5517bbb87">n_node_data</a> () <span class="keyword">const</span>;
<a name="l00235"></a>00235 
<a name="l00241"></a>00241   <a class="code" href="classlibMesh_1_1MeshData.php#a83a00f44aa1725ddc4056fbcbdc5f570">const_node_data_iterator</a> <a class="code" href="classlibMesh_1_1MeshData.php#abca36322b1804f54cd4008ec810ff577">node_data_begin</a> () <span class="keyword">const</span>;
<a name="l00242"></a>00242 
<a name="l00247"></a>00247   <a class="code" href="classlibMesh_1_1MeshData.php#a83a00f44aa1725ddc4056fbcbdc5f570">const_node_data_iterator</a> <a class="code" href="classlibMesh_1_1MeshData.php#abbffb2b92d785897388028f023944a76">node_data_end</a> () <span class="keyword">const</span>;
<a name="l00248"></a>00248 
<a name="l00264"></a>00264   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a846426f685cd75441b10e5c552256f79">insert_node_data</a> (std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*,
<a name="l00265"></a>00265                                   std::vector&lt;Number&gt; &gt;&amp; nd,
<a name="l00266"></a>00266                          <span class="keyword">const</span> <span class="keywordtype">bool</span> close_elem_data = <span class="keyword">true</span>);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269   <span class="comment">//----------------------------------------------------------</span>
<a name="l00270"></a>00270   <span class="comment">// Element-associated data</span>
<a name="l00276"></a>00276 <span class="comment"></span>  <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1MeshData.php#a00caf832d0eab35af7c9617f8dbce2e1">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, 
<a name="l00277"></a>00277                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0) <span class="keyword">const</span>;
<a name="l00278"></a>00278 
<a name="l00283"></a>00283   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#abc23718035cd723bf105c0161b767a79">has_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00284"></a>00284 
<a name="l00291"></a>00291   <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; <a class="code" href="classlibMesh_1_1MeshData.php#ae1506d2f8392e527efdda28256e7ebab">get_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem) <span class="keyword">const</span>;
<a name="l00292"></a>00292 
<a name="l00297"></a>00297   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a5912ac9d33a7d80f877bae173bcec531">set_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, <span class="keyword">const</span> std::vector&lt;Number&gt; &amp;val);
<a name="l00298"></a>00298 
<a name="l00306"></a>00306   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#ac876ff50ca56bba9e1b7e02b614a31f3">n_val_per_elem</a> () <span class="keyword">const</span>;
<a name="l00307"></a>00307 
<a name="l00312"></a>00312   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#ac072d973a4e2264b8bf97c67ea8763c6">n_elem_data</a> () <span class="keyword">const</span>;
<a name="l00313"></a>00313 
<a name="l00319"></a>00319   <a class="code" href="classlibMesh_1_1MeshData.php#a2d3b1aa41632f172b9f22205881b7045">const_elem_data_iterator</a> <a class="code" href="classlibMesh_1_1MeshData.php#ac52751a6f9af1738b2f878e4d12e41ce">elem_data_begin</a> () <span class="keyword">const</span>;
<a name="l00320"></a>00320 
<a name="l00325"></a>00325   <a class="code" href="classlibMesh_1_1MeshData.php#a2d3b1aa41632f172b9f22205881b7045">const_elem_data_iterator</a> <a class="code" href="classlibMesh_1_1MeshData.php#a256eb9b934c24731124520783d11ca9c">elem_data_end</a> () <span class="keyword">const</span>;
<a name="l00326"></a>00326 
<a name="l00343"></a>00343   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#ac8b13a5f85386ca5c6b5c150b585418b">insert_elem_data</a> (std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00344"></a>00344                                   std::vector&lt;Number&gt; &gt;&amp; ed,
<a name="l00345"></a>00345                          <span class="keyword">const</span> <span class="keywordtype">bool</span> close_node_data = <span class="keyword">true</span>);
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="comment">//----------------------------------------------------------</span>
<a name="l00353"></a>00353 <span class="comment"></span>  <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#a601f98bb1c90131ce7d71313a5df6ee4">active</a> () <span class="keyword">const</span>;
<a name="l00358"></a>00358   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">compatibility_mode</a> () <span class="keyword">const</span>;
<a name="l00359"></a>00359 
<a name="l00365"></a>00365   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#a5dae25604ba226bdffce2852fc24f2c9">elem_initialized</a> () <span class="keyword">const</span>;
<a name="l00366"></a>00366 
<a name="l00371"></a>00371   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#a589d73467febe67216d4d06465bcab7e">node_initialized</a> () <span class="keyword">const</span>;
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   <span class="comment">//----------------------------------------------------------</span>
<a name="l00375"></a>00375   <span class="comment">// Methods for accessing the node and element maps.</span>
<a name="l00376"></a>00376   <span class="comment">// Heavily used by the \p read() and \p write() methods.</span>
<a name="l00380"></a>00380 <span class="comment"></span>  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1MeshData.php#a8fd77b8c09e0b805fa2cfca34b518540">foreign_id_to_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fid) <span class="keyword">const</span>;
<a name="l00381"></a>00381 
<a name="l00385"></a>00385   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshData.php#ac6ba706235420b69e98dc345d69f3d07">foreign_id_to_elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> fid) <span class="keyword">const</span>;
<a name="l00386"></a>00386 
<a name="l00390"></a>00390   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#a61177caeb0fb845281a61e8f52a0bb5f">node_to_foreign_id</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* n) <span class="keyword">const</span>;
<a name="l00391"></a>00391 
<a name="l00395"></a>00395   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshData.php#ad92a581667b41710c22c7b59aec3fe64">elem_to_foreign_id</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* n) <span class="keyword">const</span>;
<a name="l00396"></a>00396 
<a name="l00397"></a>00397   <span class="comment">//----------------------------------------------------------</span>
<a name="l00398"></a>00398   <span class="comment">// Methods for the header information in universal formated</span>
<a name="l00399"></a>00399   <span class="comment">// datasets.</span>
<a name="l00400"></a>00400 
<a name="l00404"></a>00404   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">MeshDataUnvHeader</a> &amp; <a class="code" href="classlibMesh_1_1MeshData.php#a2827e4815c2922200d99f1d5fa71001d">get_unv_header</a>() <span class="keyword">const</span>;
<a name="l00405"></a>00405 
<a name="l00410"></a>00410   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#ae4290f8283e7aa9176b8d9c1418ea3dd">set_unv_header</a>(<a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">MeshDataUnvHeader</a>* unv_header);
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00419"></a>00419   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a3cfeb42a2a552b7ccca99766bdc95f91">assign</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>&amp; omd);
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422   <span class="comment">//----------------------------------------------------------</span>
<a name="l00423"></a>00423   <span class="comment">// Methods used by mesh importes to communicate node/element</span>
<a name="l00424"></a>00424   <span class="comment">// labels to this \p MeshData</span>
<a name="l00425"></a>00425   
<a name="l00433"></a>00433   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a42a382455dea188b00e990477439456d">add_foreign_node_id</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node, 
<a name="l00434"></a>00434                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> foreign_node_id);
<a name="l00435"></a>00435 
<a name="l00443"></a>00443   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#aca3722b2bab0198b3e3efc7d47eed1c8">add_foreign_elem_id</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, 
<a name="l00444"></a>00444                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> foreign_elem_id);
<a name="l00445"></a>00445 
<a name="l00450"></a>00450   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a9d18d3adfdf70d79d8c48aaec35f7145">close_foreign_id_maps</a> ();
<a name="l00451"></a>00451 
<a name="l00452"></a>00452 
<a name="l00453"></a>00453 <span class="keyword">protected</span>:
<a name="l00454"></a>00454 
<a name="l00455"></a>00455 
<a name="l00456"></a>00456   <span class="comment">//----------------------------------------------------------</span>
<a name="l00457"></a>00457   <span class="comment">// read/write Methods</span>
<a name="l00461"></a>00461 <span class="comment"></span>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a0897b97eb82f56a820a7be46a268e45e">read_tetgen</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>);
<a name="l00462"></a>00462 
<a name="l00468"></a>00468   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#ab3a427b0ae38e74ebadd8f536195a4f6">read_unv</a> (<span class="keyword">const</span> std::string&amp; file_name);
<a name="l00469"></a>00469 
<a name="l00476"></a>00476   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a75256c753074ddeb348072d197b4f2a2">read_unv_implementation</a> (std::istream&amp; in_file);
<a name="l00477"></a>00477 
<a name="l00483"></a>00483   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a75b7a811a26fe53b3d873369cf7307d7">write_unv</a> (<span class="keyword">const</span> std::string&amp; file_name);
<a name="l00484"></a>00484 
<a name="l00491"></a>00491   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a11068ac2064fe7b75dd7ccd6e5c4af00">write_unv_implementation</a> (std::ostream&amp; out_file);
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 
<a name="l00501"></a>00501   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a75bc0115c3f9ebf6c57ede071b42a9c8">read_xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00502"></a>00502                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> mode = <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8acd5c7906bd7fea7650acc4c8cde09d48">READ</a>);
<a name="l00503"></a>00503 
<a name="l00510"></a>00510   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#ad137da147eda9f50aee32b5c746dbc83">write_xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00511"></a>00511                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> mode = <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8a47f4bcd4fcf418da5ec74d3d8e2c3bc4">WRITE</a>);
<a name="l00512"></a>00512 
<a name="l00513"></a>00513 
<a name="l00517"></a><a class="code" href="classlibMesh_1_1MeshData.php#a7bd23d016ad747f77e5843ac25df7151">00517</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshData.php#a7bd23d016ad747f77e5843ac25df7151">_mesh</a>;
<a name="l00518"></a>00518 
<a name="l00523"></a><a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">00523</a>   std::string <a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a>;
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a>00526   <span class="comment">//--------------------------------------------------</span>
<a name="l00527"></a>00527   <span class="comment">// node associated data &amp; maps</span>
<a name="l00532"></a>00532 <span class="comment"></span>  std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*,
<a name="l00533"></a><a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">00533</a>            std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>;
<a name="l00534"></a>00534 
<a name="l00539"></a>00539   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*,
<a name="l00540"></a><a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">00540</a>            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; <a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>;
<a name="l00541"></a>00541 
<a name="l00546"></a>00546   std::map&lt;<span class="keywordtype">unsigned</span> int,
<a name="l00547"></a><a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">00547</a>            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*&gt; <a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>;
<a name="l00548"></a>00548 
<a name="l00549"></a>00549 
<a name="l00550"></a>00550 
<a name="l00551"></a>00551   <span class="comment">//--------------------------------------------------</span>
<a name="l00552"></a>00552   <span class="comment">// element associated data &amp; maps</span>
<a name="l00556"></a>00556 <span class="comment"></span>  std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00557"></a><a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">00557</a>            std::vector&lt;Number&gt; &gt; <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>;
<a name="l00558"></a>00558 
<a name="l00563"></a>00563   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*,
<a name="l00564"></a><a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">00564</a>            <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt; <a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>;
<a name="l00569"></a>00569   std::map&lt;<span class="keywordtype">unsigned</span> int,
<a name="l00570"></a><a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">00570</a>            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*&gt; <a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">_id_elem</a>;
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 
<a name="l00574"></a>00574   <span class="comment">//--------------------------------------------------------</span>
<a name="l00583"></a><a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">00583</a> <span class="comment"></span>  <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>;
<a name="l00584"></a>00584 
<a name="l00589"></a><a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">00589</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>;
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 
<a name="l00592"></a>00592   <span class="comment">//--------------------------------------------------------</span>
<a name="l00601"></a><a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">00601</a> <span class="comment"></span>  <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>;
<a name="l00602"></a>00602 
<a name="l00607"></a><a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">00607</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>;
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 
<a name="l00610"></a>00610   <span class="comment">//--------------------------------------------------------</span>
<a name="l00615"></a><a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">00615</a> <span class="comment"></span>  <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>;
<a name="l00616"></a>00616 
<a name="l00622"></a><a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">00622</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>;
<a name="l00623"></a>00623 
<a name="l00627"></a><a class="code" href="classlibMesh_1_1MeshData.php#a2c427e9a33c42e3ea08fa2030be0ae68">00627</a>   <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">MeshDataUnvHeader</a>* <a class="code" href="classlibMesh_1_1MeshData.php#a2c427e9a33c42e3ea08fa2030be0ae68">_unv_header</a>;
<a name="l00628"></a>00628   
<a name="l00632"></a><a class="code" href="classlibMesh_1_1MeshData.php#a6fc440741aa85819ff6935439e835106">00632</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">MeshDataUnvHeader</a>;
<a name="l00633"></a>00633   
<a name="l00634"></a>00634 };
<a name="l00635"></a>00635 
<a name="l00636"></a>00636 
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 <span class="comment">//-----------------------------------------------------------</span>
<a name="l00639"></a>00639 <span class="comment">// MeshDataUnvHeader class definition</span>
<a name="l00640"></a>00640 
<a name="l00684"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">00684</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">MeshDataUnvHeader</a>
<a name="l00685"></a>00685 {
<a name="l00686"></a>00686 <span class="keyword">public</span>:
<a name="l00687"></a>00687 
<a name="l00692"></a>00692   <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a942b1c1ce2274dff1bd8199bb91227c7">MeshDataUnvHeader</a> ();
<a name="l00693"></a>00693 
<a name="l00697"></a>00697   <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a86757a885f14159b965ab8b325074742">~MeshDataUnvHeader</a> ();
<a name="l00698"></a>00698 
<a name="l00713"></a>00713   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#adcb0147caa5616b6fdd3193353ac099b">which_dataset</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ds_label);
<a name="l00714"></a>00714 
<a name="l00719"></a>00719   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a5c00c33dfca2a0da6be0a63e1605100c">operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">MeshDataUnvHeader</a>&amp; omduh);
<a name="l00720"></a>00720 
<a name="l00725"></a>00725   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#aa817ce36dac8df27d02724770a4c5e9d">operator == </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">MeshDataUnvHeader</a>&amp; omduh) <span class="keyword">const</span>;
<a name="l00726"></a>00726 
<a name="l00730"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#adea580bc85a4ee842a411c0af2045d09">00730</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#adea580bc85a4ee842a411c0af2045d09">dataset_label</a>;
<a name="l00731"></a>00731 
<a name="l00735"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a02150c3f38139e8c725a2145b14f5a90">00735</a>   std::string <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a02150c3f38139e8c725a2145b14f5a90">dataset_name</a>;
<a name="l00736"></a>00736 
<a name="l00741"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#af0b4565297a7b6cf3f2f007dfc991853">00741</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#af0b4565297a7b6cf3f2f007dfc991853">dataset_location</a>;
<a name="l00742"></a>00742 
<a name="l00746"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a32bacfab36088bd614f7da1c35995af5">00746</a>   std::vector&lt;std::string&gt; <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a32bacfab36088bd614f7da1c35995af5">id_lines_1_to_5</a>;
<a name="l00747"></a>00747 
<a name="l00757"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#ad4713ceeb6c597e74b93636bf55d0ec1">00757</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a862f84e30606461c68a7168c7030fe02">model_type</a>,
<a name="l00758"></a>00758                <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a74d6046b0086774907806e7eee1f90fd">analysis_type</a>,
<a name="l00759"></a>00759                <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a920aa004e12ea696d975e126eca7ee65">data_characteristic</a>,
<a name="l00760"></a>00760                <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#ad4713ceeb6c597e74b93636bf55d0ec1">result_type</a>;
<a name="l00761"></a>00761 
<a name="l00767"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a2cb471ac8d19d7d8ebe7c3e84edecc1d">00767</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a2cb471ac8d19d7d8ebe7c3e84edecc1d">data_type</a>;
<a name="l00768"></a>00768 
<a name="l00773"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a0eb1ff0f56c66e0f951169537fe07ec6">00773</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a0eb1ff0f56c66e0f951169537fe07ec6">nvaldc</a>;
<a name="l00774"></a>00774 
<a name="l00779"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a717f6e3c8fd65904dcf8a5e739296422">00779</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#ab5135bb139399563b25396fe70249932">record_10</a>,
<a name="l00780"></a>00780                    <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a717f6e3c8fd65904dcf8a5e739296422">record_11</a>;
<a name="l00781"></a>00781 
<a name="l00786"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a5a7a7019758aab32d11077f0018185f8">00786</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a6eb1d2db1ca50944ec60bc35896ca5d2">record_12</a>,
<a name="l00787"></a>00787                     <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a5a7a7019758aab32d11077f0018185f8">record_13</a>;
<a name="l00788"></a>00788 
<a name="l00789"></a>00789 
<a name="l00790"></a>00790 <span class="keyword">protected</span>:
<a name="l00791"></a>00791 
<a name="l00800"></a>00800   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#ab41d34f02e386c10dcd0669c382b0d26">read</a> (std::istream&amp; in_file);
<a name="l00801"></a>00801 
<a name="l00805"></a>00805   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a0745b08b28fbc9ed969f247f32618d8d">write</a> (std::ostream&amp; out_file);
<a name="l00806"></a>00806 
<a name="l00807"></a>00807 
<a name="l00808"></a>00808 <span class="keyword">private</span>:
<a name="l00809"></a>00809 
<a name="l00814"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a027221f4538774a7c8adca8656bd6a18">00814</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a027221f4538774a7c8adca8656bd6a18">_desired_dataset_label</a>;
<a name="l00815"></a>00815 
<a name="l00822"></a>00822   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#a10b9494526e27c59cee870e3c36715e6">need_D_to_e</a> (std::string&amp; number);
<a name="l00823"></a>00823 
<a name="l00827"></a><a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php#adb370c823252769d6a7f254661e1ff6a">00827</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshData.php">MeshData</a>;
<a name="l00828"></a>00828 
<a name="l00829"></a>00829 };
<a name="l00830"></a>00830 
<a name="l00831"></a>00831 
<a name="l00832"></a>00832 
<a name="l00833"></a>00833 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00834"></a>00834 <span class="comment">// MeshData inline methods</span>
<a name="l00835"></a>00835 
<a name="l00836"></a>00836 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00837"></a>00837 <span class="comment">// element data inline methods</span>
<a name="l00838"></a>00838 <span class="keyword">inline</span>
<a name="l00839"></a><a class="code" href="classlibMesh_1_1MeshData.php#a00caf832d0eab35af7c9617f8dbce2e1">00839</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1MeshData.php#a00caf832d0eab35af7c9617f8dbce2e1">MeshData::operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node, 
<a name="l00840"></a>00840                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00841"></a>00841 <span class="keyword"></span>{
<a name="l00842"></a>00842   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00843"></a>00843   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>);
<a name="l00844"></a>00844 
<a name="l00845"></a>00845   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*, 
<a name="l00846"></a>00846            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.find(node);
<a name="l00847"></a>00847 
<a name="l00848"></a>00848   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.end())
<a name="l00849"></a>00849       <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00850"></a>00850 
<a name="l00851"></a>00851   <span class="comment">// we only get here when pos != _node_data.end()</span>
<a name="l00852"></a>00852   libmesh_assert (i &lt; pos-&gt;second.size());
<a name="l00853"></a>00853   <span class="keywordflow">return</span> pos-&gt;second[i];
<a name="l00854"></a>00854 }
<a name="l00855"></a>00855 
<a name="l00856"></a>00856 
<a name="l00857"></a>00857 
<a name="l00858"></a>00858 <span class="keyword">inline</span>
<a name="l00859"></a><a class="code" href="classlibMesh_1_1MeshData.php#abc23718035cd723bf105c0161b767a79">00859</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#abc23718035cd723bf105c0161b767a79">MeshData::has_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node)<span class="keyword"> const</span>
<a name="l00860"></a>00860 <span class="keyword"></span>{
<a name="l00861"></a>00861   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00862"></a>00862   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>);
<a name="l00863"></a>00863 
<a name="l00864"></a>00864   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*, 
<a name="l00865"></a>00865            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.find(node);
<a name="l00866"></a>00866 
<a name="l00867"></a>00867   <span class="keywordflow">return</span> (pos != <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.end());
<a name="l00868"></a>00868 }
<a name="l00869"></a>00869 
<a name="l00870"></a>00870 
<a name="l00871"></a>00871 
<a name="l00872"></a>00872 <span class="keyword">inline</span>
<a name="l00873"></a><a class="code" href="classlibMesh_1_1MeshData.php#ae1506d2f8392e527efdda28256e7ebab">00873</a> <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; <a class="code" href="classlibMesh_1_1MeshData.php#ae1506d2f8392e527efdda28256e7ebab">MeshData::get_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node)<span class="keyword"> const</span>
<a name="l00874"></a>00874 <span class="keyword"></span>{
<a name="l00875"></a>00875   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00876"></a>00876   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>);
<a name="l00877"></a>00877 
<a name="l00878"></a>00878   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*, 
<a name="l00879"></a>00879            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.find(node);
<a name="l00880"></a>00880 
<a name="l00881"></a>00881 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00882"></a>00882 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.end())
<a name="l00883"></a>00883     {
<a name="l00884"></a>00884       std::cerr &lt;&lt; <span class="stringliteral">&quot;ERROR: No data for this node.  Use has_data() first!&quot;</span> &lt;&lt; std::endl;
<a name="l00885"></a>00885       libmesh_error();
<a name="l00886"></a>00886     }
<a name="l00887"></a>00887 <span class="preprocessor">#endif</span>
<a name="l00888"></a>00888 <span class="preprocessor"></span>
<a name="l00889"></a>00889   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00890"></a>00890 }
<a name="l00891"></a>00891 
<a name="l00892"></a>00892 
<a name="l00893"></a>00893 
<a name="l00894"></a>00894 <span class="keyword">inline</span>
<a name="l00895"></a><a class="code" href="classlibMesh_1_1MeshData.php#a5912ac9d33a7d80f877bae173bcec531">00895</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a5912ac9d33a7d80f877bae173bcec531">MeshData::set_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node,
<a name="l00896"></a>00896                          <span class="keyword">const</span> std::vector&lt;Number&gt; &amp;val)
<a name="l00897"></a>00897 {
<a name="l00898"></a>00898   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>[node] = val;
<a name="l00899"></a>00899 }
<a name="l00900"></a>00900 
<a name="l00901"></a>00901 
<a name="l00902"></a>00902 
<a name="l00903"></a>00903 <span class="keyword">inline</span>
<a name="l00904"></a><a class="code" href="classlibMesh_1_1MeshData.php#abca36322b1804f54cd4008ec810ff577">00904</a> <a class="code" href="classlibMesh_1_1MeshData.php#a83a00f44aa1725ddc4056fbcbdc5f570">MeshData::const_node_data_iterator</a> <a class="code" href="classlibMesh_1_1MeshData.php#abca36322b1804f54cd4008ec810ff577">MeshData::node_data_begin</a> ()<span class="keyword"> const</span>
<a name="l00905"></a>00905 <span class="keyword"></span>{
<a name="l00906"></a>00906   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.begin();
<a name="l00907"></a>00907 }
<a name="l00908"></a>00908 
<a name="l00909"></a>00909 
<a name="l00910"></a>00910 
<a name="l00911"></a>00911 <span class="keyword">inline</span>
<a name="l00912"></a><a class="code" href="classlibMesh_1_1MeshData.php#abbffb2b92d785897388028f023944a76">00912</a> <a class="code" href="classlibMesh_1_1MeshData.php#a83a00f44aa1725ddc4056fbcbdc5f570">MeshData::const_node_data_iterator</a> <a class="code" href="classlibMesh_1_1MeshData.php#abbffb2b92d785897388028f023944a76">MeshData::node_data_end</a> ()<span class="keyword"> const</span>
<a name="l00913"></a>00913 <span class="keyword"></span>{
<a name="l00914"></a>00914   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.end();
<a name="l00915"></a>00915 }
<a name="l00916"></a>00916 
<a name="l00917"></a>00917 
<a name="l00918"></a>00918 
<a name="l00919"></a>00919 <span class="comment">//-------------------------------------------------------------</span>
<a name="l00920"></a>00920 <span class="comment">// element data inline methods</span>
<a name="l00921"></a>00921 <span class="keyword">inline</span>
<a name="l00922"></a><a class="code" href="classlibMesh_1_1MeshData.php#a7e2954d6fced264c3dc373ba14cb083b">00922</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1MeshData.php#a00caf832d0eab35af7c9617f8dbce2e1">MeshData::operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, 
<a name="l00923"></a>00923                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00924"></a>00924 <span class="keyword"></span>{
<a name="l00925"></a>00925   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00926"></a>00926   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>);
<a name="l00927"></a>00927 
<a name="l00928"></a>00928   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*, 
<a name="l00929"></a>00929            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.find(elem);
<a name="l00930"></a>00930 
<a name="l00931"></a>00931   <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.end())
<a name="l00932"></a>00932     <span class="keywordflow">return</span> <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00933"></a>00933   
<a name="l00934"></a>00934   <span class="comment">// we only get here when pos != _elem_data.end()  </span>
<a name="l00935"></a>00935   libmesh_assert (i &lt; pos-&gt;second.size());
<a name="l00936"></a>00936   <span class="keywordflow">return</span> pos-&gt;second[i];
<a name="l00937"></a>00937 }
<a name="l00938"></a>00938 
<a name="l00939"></a>00939 
<a name="l00940"></a>00940 
<a name="l00941"></a>00941 <span class="keyword">inline</span>
<a name="l00942"></a><a class="code" href="classlibMesh_1_1MeshData.php#afa48b766579fc8384b19305b9c92ea73">00942</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#abc23718035cd723bf105c0161b767a79">MeshData::has_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l00943"></a>00943 <span class="keyword"></span>{
<a name="l00944"></a>00944   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00945"></a>00945   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>);
<a name="l00946"></a>00946 
<a name="l00947"></a>00947   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*, 
<a name="l00948"></a>00948            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.find(elem);
<a name="l00949"></a>00949 
<a name="l00950"></a>00950   <span class="keywordflow">return</span> (pos != <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.end());
<a name="l00951"></a>00951 }
<a name="l00952"></a>00952 
<a name="l00953"></a>00953 
<a name="l00954"></a>00954 
<a name="l00955"></a>00955 <span class="keyword">inline</span>
<a name="l00956"></a><a class="code" href="classlibMesh_1_1MeshData.php#a4e51f38d44561b8c50ece14a8e4d9f42">00956</a> <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; <a class="code" href="classlibMesh_1_1MeshData.php#ae1506d2f8392e527efdda28256e7ebab">MeshData::get_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem)<span class="keyword"> const</span>
<a name="l00957"></a>00957 <span class="keyword"></span>{
<a name="l00958"></a>00958   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00959"></a>00959   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>);
<a name="l00960"></a>00960 
<a name="l00961"></a>00961   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*, 
<a name="l00962"></a>00962            std::vector&lt;Number&gt; &gt;::const_iterator pos = <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.find(elem);
<a name="l00963"></a>00963 
<a name="l00964"></a>00964 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00965"></a>00965 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (pos == <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.end())
<a name="l00966"></a>00966     {
<a name="l00967"></a>00967       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: No data for this element.  Use has_data() first!&quot;</span> &lt;&lt; std::endl;
<a name="l00968"></a>00968       libmesh_error();
<a name="l00969"></a>00969     }
<a name="l00970"></a>00970 <span class="preprocessor">#endif</span>
<a name="l00971"></a>00971 <span class="preprocessor"></span>
<a name="l00972"></a>00972   <span class="keywordflow">return</span> pos-&gt;second;
<a name="l00973"></a>00973 }
<a name="l00974"></a>00974 
<a name="l00975"></a>00975 
<a name="l00976"></a>00976 
<a name="l00977"></a>00977 <span class="keyword">inline</span>
<a name="l00978"></a><a class="code" href="classlibMesh_1_1MeshData.php#a82009082dfe3d083b6c55b6b527fd7a5">00978</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a5912ac9d33a7d80f877bae173bcec531">MeshData::set_data</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00979"></a>00979                          <span class="keyword">const</span> std::vector&lt;Number&gt; &amp;val)
<a name="l00980"></a>00980 {
<a name="l00981"></a>00981   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>[elem] = val;
<a name="l00982"></a>00982 }
<a name="l00983"></a>00983 
<a name="l00984"></a>00984 
<a name="l00985"></a>00985 
<a name="l00986"></a>00986 <span class="keyword">inline</span>
<a name="l00987"></a><a class="code" href="classlibMesh_1_1MeshData.php#ac52751a6f9af1738b2f878e4d12e41ce">00987</a> <a class="code" href="classlibMesh_1_1MeshData.php#a2d3b1aa41632f172b9f22205881b7045">MeshData::const_elem_data_iterator</a> <a class="code" href="classlibMesh_1_1MeshData.php#ac52751a6f9af1738b2f878e4d12e41ce">MeshData::elem_data_begin</a> ()<span class="keyword"> const</span>
<a name="l00988"></a>00988 <span class="keyword"></span>{
<a name="l00989"></a>00989   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.begin();
<a name="l00990"></a>00990 }
<a name="l00991"></a>00991 
<a name="l00992"></a>00992 
<a name="l00993"></a>00993 
<a name="l00994"></a>00994 <span class="keyword">inline</span>
<a name="l00995"></a><a class="code" href="classlibMesh_1_1MeshData.php#a256eb9b934c24731124520783d11ca9c">00995</a> <a class="code" href="classlibMesh_1_1MeshData.php#a2d3b1aa41632f172b9f22205881b7045">MeshData::const_elem_data_iterator</a> <a class="code" href="classlibMesh_1_1MeshData.php#a256eb9b934c24731124520783d11ca9c">MeshData::elem_data_end</a> ()<span class="keyword"> const</span>
<a name="l00996"></a>00996 <span class="keyword"></span>{
<a name="l00997"></a>00997   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.end();
<a name="l00998"></a>00998 }
<a name="l00999"></a>00999 
<a name="l01000"></a>01000 
<a name="l01001"></a>01001 
<a name="l01002"></a>01002 <span class="comment">//-------------------------------------------------------------</span>
<a name="l01003"></a>01003 <span class="comment">// other inline methods</span>
<a name="l01004"></a>01004 <span class="keyword">inline</span>
<a name="l01005"></a><a class="code" href="classlibMesh_1_1MeshData.php#a601f98bb1c90131ce7d71313a5df6ee4">01005</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#a601f98bb1c90131ce7d71313a5df6ee4">MeshData::active</a>()<span class="keyword"> const</span>
<a name="l01006"></a>01006 <span class="keyword"></span>{
<a name="l01007"></a>01007   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>;
<a name="l01008"></a>01008 }
<a name="l01009"></a>01009 
<a name="l01010"></a>01010 
<a name="l01011"></a>01011 
<a name="l01012"></a>01012 <span class="keyword">inline</span>
<a name="l01013"></a><a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">01013</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#ac7bb5132049a914dc49ab1881b564e4d">MeshData::compatibility_mode</a>()<span class="keyword"> const</span>
<a name="l01014"></a>01014 <span class="keyword"></span>{
<a name="l01015"></a>01015   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>;
<a name="l01016"></a>01016 }
<a name="l01017"></a>01017 
<a name="l01018"></a>01018 
<a name="l01019"></a>01019 
<a name="l01020"></a>01020 <span class="keyword">inline</span>
<a name="l01021"></a><a class="code" href="classlibMesh_1_1MeshData.php#a5dae25604ba226bdffce2852fc24f2c9">01021</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#a5dae25604ba226bdffce2852fc24f2c9">MeshData::elem_initialized</a>()<span class="keyword"> const</span>
<a name="l01022"></a>01022 <span class="keyword"></span>{
<a name="l01023"></a>01023   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> &amp;&amp; <a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>);
<a name="l01024"></a>01024 }
<a name="l01025"></a>01025 
<a name="l01026"></a>01026 
<a name="l01027"></a>01027 
<a name="l01028"></a>01028 <span class="keyword">inline</span>
<a name="l01029"></a><a class="code" href="classlibMesh_1_1MeshData.php#a589d73467febe67216d4d06465bcab7e">01029</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshData.php#a589d73467febe67216d4d06465bcab7e">MeshData::node_initialized</a>()<span class="keyword"> const</span>
<a name="l01030"></a>01030 <span class="keyword"></span>{
<a name="l01031"></a>01031   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> &amp;&amp; <a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>);
<a name="l01032"></a>01032 }
<a name="l01033"></a>01033 
<a name="l01034"></a>01034 
<a name="l01035"></a>01035 
<a name="l01036"></a>01036 <span class="keyword">inline</span>  
<a name="l01037"></a><a class="code" href="classlibMesh_1_1MeshData.php#a42a382455dea188b00e990477439456d">01037</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a42a382455dea188b00e990477439456d">MeshData::add_foreign_node_id</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node, 
<a name="l01038"></a>01038                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> foreign_node_id)
<a name="l01039"></a>01039 {
<a name="l01040"></a>01040   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>)
<a name="l01041"></a>01041     {
<a name="l01042"></a>01042       libmesh_assert (!<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>);
<a name="l01043"></a>01043       libmesh_assert (node                             != NULL);
<a name="l01044"></a>01044       libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>.find(node)              == <a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>.end());
<a name="l01045"></a>01045       libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>.find(foreign_node_id)   == <a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>.end());
<a name="l01046"></a>01046 
<a name="l01047"></a>01047       <span class="comment">/*</span>
<a name="l01048"></a>01048 <span class="comment">       * _always_ insert in _id_node and _node_id.  If we would </span>
<a name="l01049"></a>01049 <span class="comment">       * use the mesh.node(unsigned int) method or the node.id()</span>
<a name="l01050"></a>01050 <span class="comment">       * to get Node* and unsigned int, respectively, we would not</span>
<a name="l01051"></a>01051 <span class="comment">       * be safe any more when the mesh gets refined or re-numbered</span>
<a name="l01052"></a>01052 <span class="comment">       * within libMesh. And we could get in big trouble that would</span>
<a name="l01053"></a>01053 <span class="comment">       * be hard to find when importing data _after_ having refined...</span>
<a name="l01054"></a>01054 <span class="comment">       */</span>
<a name="l01055"></a>01055       <a class="code" href="classlibMesh_1_1MeshData.php#a970d1375818a6e2f9c4792ba8fa87801">_node_id</a>.insert(std::make_pair(node, foreign_node_id));
<a name="l01056"></a>01056       <a class="code" href="classlibMesh_1_1MeshData.php#a5f1bfe889d628a5e9a9020f8aea745f5">_id_node</a>.insert(std::make_pair(foreign_node_id, node));
<a name="l01057"></a>01057     }
<a name="l01058"></a>01058 }
<a name="l01059"></a>01059 
<a name="l01060"></a>01060 
<a name="l01061"></a>01061 
<a name="l01062"></a>01062 <span class="keyword">inline</span>  
<a name="l01063"></a><a class="code" href="classlibMesh_1_1MeshData.php#aca3722b2bab0198b3e3efc7d47eed1c8">01063</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#aca3722b2bab0198b3e3efc7d47eed1c8">MeshData::add_foreign_elem_id</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem, 
<a name="l01064"></a>01064                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> foreign_elem_id)
<a name="l01065"></a>01065 {
<a name="l01066"></a>01066   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a>)
<a name="l01067"></a>01067     {
<a name="l01068"></a>01068       libmesh_assert (!<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>);
<a name="l01069"></a>01069       libmesh_assert (elem                             != NULL);
<a name="l01070"></a>01070       libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>.find(elem)              == <a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>.end());
<a name="l01071"></a>01071       libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">_id_elem</a>.find(foreign_elem_id)   == <a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">_id_elem</a>.end());
<a name="l01072"></a>01072 
<a name="l01073"></a>01073       <a class="code" href="classlibMesh_1_1MeshData.php#ac41d36e5af02a214e9f727c8f47d7ef6">_elem_id</a>.insert(std::make_pair(elem, foreign_elem_id));
<a name="l01074"></a>01074       <a class="code" href="classlibMesh_1_1MeshData.php#a8ec8ec4bbd8a6ed9811e37148348ccdc">_id_elem</a>.insert(std::make_pair(foreign_elem_id, elem));
<a name="l01075"></a>01075     }
<a name="l01076"></a>01076 }
<a name="l01077"></a>01077 
<a name="l01078"></a>01078 
<a name="l01079"></a>01079 <span class="keyword">inline</span>
<a name="l01080"></a><a class="code" href="classlibMesh_1_1MeshData.php#a2827e4815c2922200d99f1d5fa71001d">01080</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">MeshDataUnvHeader</a> &amp; <a class="code" href="classlibMesh_1_1MeshData.php#a2827e4815c2922200d99f1d5fa71001d">MeshData::get_unv_header</a> ()<span class="keyword"> const</span>
<a name="l01081"></a>01081 <span class="keyword"></span>{
<a name="l01082"></a>01082   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a2c427e9a33c42e3ea08fa2030be0ae68">_unv_header</a> != NULL);
<a name="l01083"></a>01083   <span class="keywordflow">return</span> *this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a2c427e9a33c42e3ea08fa2030be0ae68">_unv_header</a>;
<a name="l01084"></a>01084 }
<a name="l01085"></a>01085 
<a name="l01086"></a>01086 
<a name="l01087"></a>01087 <span class="keyword">inline</span>
<a name="l01088"></a><a class="code" href="classlibMesh_1_1MeshData.php#ae4290f8283e7aa9176b8d9c1418ea3dd">01088</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#ae4290f8283e7aa9176b8d9c1418ea3dd">MeshData::set_unv_header</a> (<a class="code" href="classlibMesh_1_1MeshDataUnvHeader.php">MeshDataUnvHeader</a>* unv_header)
<a name="l01089"></a>01089 {
<a name="l01090"></a>01090   libmesh_assert (unv_header != NULL);
<a name="l01091"></a>01091   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a2c427e9a33c42e3ea08fa2030be0ae68">_unv_header</a> = unv_header;
<a name="l01092"></a>01092 }
<a name="l01093"></a>01093 
<a name="l01094"></a>01094 
<a name="l01095"></a>01095 <span class="comment">//-----------------------------------------------------------</span>
<a name="l01096"></a>01096 <span class="comment">// MeshDataUnvHeader inline methods</span>
<a name="l01097"></a>01097 
<a name="l01098"></a>01098 
<a name="l01099"></a>01099 } <span class="comment">// namespace libMesh</span>
<a name="l01100"></a>01100 
<a name="l01101"></a>01101 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
