<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_data_tetgen_support.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__data__tetgen__support_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_data_tetgen_support.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__data_8h.php">mesh_data.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">namespace </span>libMesh
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// MeshDate TetGen support function</span>
<a name="l00036"></a><a class="code" href="classlibMesh_1_1MeshData.php#a0897b97eb82f56a820a7be46a268e45e">00036</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a0897b97eb82f56a820a7be46a268e45e">MeshData::read_tetgen</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   std::string name_node, name_ele, dummy;
<a name="l00039"></a>00039   std::string desc = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00040"></a>00040   
<a name="l00041"></a>00041   
<a name="l00042"></a>00042   <span class="comment">// Check name for *.node or *.ele extension.</span>
<a name="l00043"></a>00043   <span class="comment">// Set std::istream for node_stream and ele_stream.</span>
<a name="l00044"></a>00044   <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.node&quot;</span>) &lt; name.size()) 
<a name="l00045"></a>00045     {
<a name="l00046"></a>00046       name_node = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00047"></a>00047       dummy     = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00048"></a>00048       <span class="keywordtype">int</span> position = dummy.rfind(<span class="stringliteral">&quot;.node&quot;</span>);
<a name="l00049"></a>00049       name_ele     = dummy.replace(position, 5, <span class="stringliteral">&quot;.ele&quot;</span>);
<a name="l00050"></a>00050       desc.erase(position);
<a name="l00051"></a>00051     }
<a name="l00052"></a>00052   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (name.rfind(<span class="stringliteral">&quot;.ele&quot;</span>) &lt; name.size()) 
<a name="l00053"></a>00053     {
<a name="l00054"></a>00054       name_ele = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00055"></a>00055       dummy    = <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>;
<a name="l00056"></a>00056       <span class="keywordtype">int</span> position = dummy.rfind(<span class="stringliteral">&quot;.ele&quot;</span>);
<a name="l00057"></a>00057       name_node    = dummy.replace(position, 4, <span class="stringliteral">&quot;.node&quot;</span>);
<a name="l00058"></a>00058       desc.erase(position);
<a name="l00059"></a>00059     }
<a name="l00060"></a>00060   <span class="keywordflow">else</span>
<a name="l00061"></a>00061     {
<a name="l00062"></a>00062       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unrecognized file name: &quot;</span>
<a name="l00063"></a>00063                     &lt;&lt; name &lt;&lt; std::endl;
<a name="l00064"></a>00064       libmesh_error();
<a name="l00065"></a>00065     }
<a name="l00066"></a>00066   
<a name="l00067"></a>00067   <span class="comment">// Set the streams from which to read in.</span>
<a name="l00068"></a>00068   std::ifstream node_stream (name_node.c_str());
<a name="l00069"></a>00069   std::ifstream ele_stream  (name_ele.c_str());
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="keywordflow">if</span> ( !node_stream.good() || !ele_stream.good() )
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: One or both Input file(s) not good.&quot;</span> &lt;&lt; std::endl
<a name="l00074"></a>00074                     &lt;&lt; <span class="stringliteral">&quot;Error checking files &quot;</span>
<a name="l00075"></a>00075                     &lt;&lt; name_node &lt;&lt; <span class="stringliteral">&quot; and &quot;</span>
<a name="l00076"></a>00076                     &lt;&lt; name_ele  &lt;&lt; std::endl;
<a name="l00077"></a>00077       libmesh_error();
<a name="l00078"></a>00078     }
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="comment">// Set the descriptive name.</span>
<a name="l00082"></a>00082   <span class="comment">// TetGen won&#39;t give a name, so we use the filename.</span>
<a name="l00083"></a>00083   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a> = desc;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   
<a name="l00086"></a>00086   <span class="comment">//--------------------------------------------------</span>
<a name="l00087"></a>00087   <span class="comment">// Read in the data associated with the nodes.</span>
<a name="l00088"></a>00088   {
<a name="l00089"></a>00089     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_node=0, f_n_id=0, nAttri=0, BoundMark=0;
<a name="l00090"></a>00090     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dummy=0.0;
<a name="l00091"></a>00091     std::vector&lt;Number&gt; AttriValue;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093     <span class="comment">// Read the parameters from the node_stream.</span>
<a name="l00094"></a>00094     node_stream &gt;&gt; n_node     <span class="comment">// Read the number of nodes</span>
<a name="l00095"></a>00095                 &gt;&gt; dummy      <span class="comment">// Read the dimension</span>
<a name="l00096"></a>00096                 &gt;&gt; nAttri     <span class="comment">// Read the number of attributes</span>
<a name="l00097"></a>00097                 &gt;&gt; BoundMark; <span class="comment">// (0 or 1) boundary markers are in the stream or not.</span>
<a name="l00098"></a>00098 
<a name="l00099"></a>00099     <span class="comment">// Resize the values vector.</span>
<a name="l00100"></a>00100     AttriValue.resize(nAttri);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_node; i++)
<a name="l00103"></a>00103       {
<a name="l00104"></a>00104         node_stream &gt;&gt; f_n_id;
<a name="l00105"></a>00105 
<a name="l00106"></a>00106         
<a name="l00107"></a>00107         <span class="comment">// Read the nodal coordinates for this node into dummy,</span>
<a name="l00108"></a>00108         <span class="comment">// since we don&#39;t need them.</span>
<a name="l00109"></a>00109         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;3; j++)
<a name="l00110"></a>00110           node_stream &gt;&gt; dummy;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112         <span class="comment">// Read the attributes from the stream.</span>
<a name="l00113"></a>00113         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;nAttri; j++)
<a name="l00114"></a>00114           node_stream &gt;&gt; AttriValue[j];
<a name="l00115"></a>00115 
<a name="l00116"></a>00116         <span class="comment">// Read boundary marker if BoundaryMarker=1.</span>
<a name="l00117"></a>00117         <span class="keywordflow">if</span> (BoundMark == 1)
<a name="l00118"></a>00118           node_stream &gt;&gt; dummy;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120         <span class="comment">// For the foreign node id locate the Node*.</span>
<a name="l00121"></a>00121         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = <a class="code" href="classlibMesh_1_1MeshData.php#a8fd77b8c09e0b805fa2cfca34b518540">foreign_id_to_node</a>(f_n_id);
<a name="l00122"></a>00122                                 
<a name="l00123"></a>00123         <span class="comment">// Insert this node and the values in our _node_data.</span>
<a name="l00124"></a>00124         <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.insert (std::make_pair(node, AttriValue));
<a name="l00125"></a>00125       }
<a name="l00126"></a>00126   }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   <span class="comment">//--------------------------------------------------</span>
<a name="l00130"></a>00130   <span class="comment">// Read in the data associated with the elements.</span>
<a name="l00131"></a>00131   {
<a name="l00132"></a>00132     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>, f_e_id, <a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>, nAttri=0;
<a name="l00133"></a>00133     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> dummy=0.0;
<a name="l00134"></a>00134     std::vector&lt;Number&gt; AttriValue;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136     <span class="comment">// Read the parameters from the ele_stream.</span>
<a name="l00137"></a>00137     ele_stream &gt;&gt; n_elem   <span class="comment">// Read the number of tetrahedrons</span>
<a name="l00138"></a>00138                &gt;&gt; n_nodes  <span class="comment">// Read the points per tetrahedron</span>
<a name="l00139"></a>00139                &gt;&gt; nAttri;  <span class="comment">// Read the number of attributes</span>
<a name="l00140"></a>00140 
<a name="l00141"></a>00141     <span class="comment">// Resize the values vector.</span>
<a name="l00142"></a>00142     AttriValue.resize(nAttri);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>; i++)
<a name="l00145"></a>00145       {
<a name="l00146"></a>00146         ele_stream &gt;&gt; f_e_id;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149         <span class="comment">// For the number of nodes for this element read them into dummy,</span>
<a name="l00150"></a>00150         <span class="comment">// since we don&#39;t need them.</span>
<a name="l00151"></a>00151         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="tecplot__io_8C.php#ad00604777dd9213f9627d8f12e3b2790">n_nodes</a>; n++)
<a name="l00152"></a>00152           {
<a name="l00153"></a>00153             ele_stream &gt;&gt; dummy;
<a name="l00154"></a>00154           }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156         <span class="comment">// Read the attributes from the stream.</span>
<a name="l00157"></a>00157         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;nAttri; j++)
<a name="l00158"></a>00158           {
<a name="l00159"></a>00159             ele_stream &gt;&gt; AttriValue[j];
<a name="l00160"></a>00160           }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162         <span class="comment">// For the foreign elem id locate the Elem*.</span>
<a name="l00163"></a>00163         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = <a class="code" href="classlibMesh_1_1MeshData.php#ac6ba706235420b69e98dc345d69f3d07">foreign_id_to_elem</a>(f_e_id);
<a name="l00164"></a>00164                                 
<a name="l00165"></a>00165         <span class="comment">// Insert this elem and the values in our _elem_data.</span>
<a name="l00166"></a>00166         <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.insert (std::make_pair(elem, AttriValue));
<a name="l00167"></a>00167       }
<a name="l00168"></a>00168   }
<a name="l00169"></a>00169   
<a name="l00170"></a>00170   <span class="comment">//--------------------------------------------------</span>
<a name="l00171"></a>00171   <span class="comment">// Finished reading.  Now ready for use.</span>
<a name="l00172"></a>00172   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a> = <span class="keyword">true</span>;
<a name="l00173"></a>00173   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a> = <span class="keyword">true</span>;
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   node_stream.close();
<a name="l00176"></a>00176   ele_stream.close();
<a name="l00177"></a>00177 }
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
