<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_data_xdr_support.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__data__xdr__support_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_data_xdr_support.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__data_8h.php">mesh_data.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="xdr__cxx_8h.php">xdr_cxx.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">//------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// MeshData functions</span>
<a name="l00037"></a><a class="code" href="classlibMesh_1_1MeshData.php#a75bc0115c3f9ebf6c57ede071b42a9c8">00037</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#a75bc0115c3f9ebf6c57ede071b42a9c8">MeshData::read_xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00038"></a>00038                          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> mode)
<a name="l00039"></a>00039 {
<a name="l00079"></a>00079   <span class="comment">// we should better be active or in compatibility mode</span>
<a name="l00080"></a>00080   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a92867365292ff4235cff1e6e6d0d7375">_active</a> || <a class="code" href="classlibMesh_1_1MeshData.php#a1c1bfa1a4740f0dab87c0ae2b1c28135">_compatibility_mode</a>);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">// make sure the id maps are ready</span>
<a name="l00084"></a>00084   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>);
<a name="l00085"></a>00085   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>);
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00091"></a>00091   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a19e205366bfe0869017f32985e60ff8b">clear</a>();
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> io(name, mode);
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="comment">/*</span>
<a name="l00098"></a>00098 <span class="comment">   * all processors read the data in the same format,</span>
<a name="l00099"></a>00099 <span class="comment">   * but only the processor that owns the element stores</span>
<a name="l00100"></a>00100 <span class="comment">   * element-associated data.  For nodes, i haven&#39;t come</span>
<a name="l00101"></a>00101 <span class="comment">   * up with such asmart idea, yet... :-P</span>
<a name="l00102"></a>00102 <span class="comment">   */</span>
<a name="l00103"></a>00103   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = <a class="code" href="classlibMesh_1_1MeshData.php#a7bd23d016ad747f77e5843ac25df7151">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>();
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00112"></a>00112   {
<a name="l00113"></a>00113     std::string desc = <span class="stringliteral">&quot;&quot;</span>;
<a name="l00114"></a>00114     io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (desc);
<a name="l00115"></a>00115     this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a> = desc;
<a name="l00116"></a>00116   }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00125"></a>00125   {
<a name="l00126"></a>00126     std::string vtype=<span class="stringliteral">&quot;&quot;</span>;
<a name="l00127"></a>00127     io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (vtype);
<a name="l00128"></a>00128 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (vtype != <span class="stringliteral">&quot;COMPLEX&quot;</span>)
<a name="l00130"></a>00130       {
<a name="l00131"></a>00131         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: File does not contain complex-valued data!&quot;</span>
<a name="l00132"></a>00132                       &lt;&lt; std::endl;
<a name="l00133"></a>00133         libmesh_error();
<a name="l00134"></a>00134       }
<a name="l00135"></a>00135 <span class="preprocessor">#elif LIBMESH_USE_REAL_NUMBERS</span>
<a name="l00136"></a>00136 <span class="preprocessor"></span>    <span class="keywordflow">if</span> (vtype != <span class="stringliteral">&quot;REAL&quot;</span>)
<a name="l00137"></a>00137       {
<a name="l00138"></a>00138         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: File does not contain real-valued data!&quot;</span>
<a name="l00139"></a>00139                       &lt;&lt; std::endl;
<a name="l00140"></a>00140         libmesh_error();
<a name="l00141"></a>00141       }
<a name="l00142"></a>00142 <span class="preprocessor">#else</span>
<a name="l00143"></a>00143 <span class="preprocessor"></span>    <span class="comment">/*</span>
<a name="l00144"></a>00144 <span class="comment">     * What number type is this?</span>
<a name="l00145"></a>00145 <span class="comment">     */</span>
<a name="l00146"></a>00146     libmesh_error();
<a name="l00147"></a>00147 <span class="preprocessor">#endif</span>
<a name="l00148"></a>00148 <span class="preprocessor"></span>  }
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00157"></a>00157   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_node = 0;
<a name="l00158"></a>00158   io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_node);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00166"></a>00166   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a> = 0;
<a name="l00167"></a>00167   io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_elem);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> previous_values_size = 0;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cnt=0; n_cnt &lt; n_node; n_cnt++)
<a name="l00172"></a>00172     {
<a name="l00179"></a>00179       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_id = 0;
<a name="l00180"></a>00180       io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (f_id);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = <a class="code" href="classlibMesh_1_1MeshData.php#a8fd77b8c09e0b805fa2cfca34b518540">foreign_id_to_node</a>(f_id);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00191"></a>00191       {
<a name="l00192"></a>00192         std::vector&lt;Number&gt; values;
<a name="l00193"></a>00193         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (values);
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>        <span class="comment">/*</span>
<a name="l00198"></a>00198 <span class="comment">         * make sure the size of the values vectors</span>
<a name="l00199"></a>00199 <span class="comment">         * are identical for all nodes</span>
<a name="l00200"></a>00200 <span class="comment">         */</span>
<a name="l00201"></a>00201         <span class="keywordflow">if</span> (n_cnt == 0)
<a name="l00202"></a>00202             previous_values_size = values.size();
<a name="l00203"></a>00203         <span class="keywordflow">else</span>
<a name="l00204"></a>00204           {
<a name="l00205"></a>00205             <span class="keywordflow">if</span> (previous_values_size != values.size())
<a name="l00206"></a>00206               {
<a name="l00207"></a>00207                 <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Size mismatch for n_cnt = &quot;</span> &lt;&lt; n_cnt &lt;&lt; std::endl;
<a name="l00208"></a>00208                 libmesh_error();
<a name="l00209"></a>00209               }
<a name="l00210"></a>00210           }
<a name="l00211"></a>00211 <span class="preprocessor">#endif</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>
<a name="l00213"></a>00213 
<a name="l00217"></a>00217         <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.insert (std::make_pair(node, values));
<a name="l00218"></a>00218       }
<a name="l00219"></a>00219     }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   previous_values_size = 0;
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_cnt=0; n_cnt &lt; <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a>; n_cnt++)
<a name="l00226"></a>00226     {
<a name="l00232"></a>00232       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_id = 0;
<a name="l00233"></a>00233       io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (f_id);
<a name="l00234"></a>00234 
<a name="l00235"></a>00235       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = <a class="code" href="classlibMesh_1_1MeshData.php#ac6ba706235420b69e98dc345d69f3d07">foreign_id_to_elem</a>(f_id);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00244"></a>00244       {
<a name="l00245"></a>00245         std::vector&lt;Number&gt; values;
<a name="l00246"></a>00246         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (values);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span>        <span class="comment">/*</span>
<a name="l00251"></a>00251 <span class="comment">         * make sure the size of the values vectors</span>
<a name="l00252"></a>00252 <span class="comment">         * are identical for all elements</span>
<a name="l00253"></a>00253 <span class="comment">         */</span>
<a name="l00254"></a>00254         <span class="keywordflow">if</span> (n_cnt == 0)
<a name="l00255"></a>00255             previous_values_size = values.size();
<a name="l00256"></a>00256         <span class="keywordflow">else</span>
<a name="l00257"></a>00257           {
<a name="l00258"></a>00258             <span class="keywordflow">if</span> (previous_values_size != values.size())
<a name="l00259"></a>00259               {
<a name="l00260"></a>00260                 <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Size mismatch for n_cnt = &quot;</span> &lt;&lt; n_cnt &lt;&lt; std::endl;
<a name="l00261"></a>00261                 libmesh_error();
<a name="l00262"></a>00262               }
<a name="l00263"></a>00263           }
<a name="l00264"></a>00264 <span class="preprocessor">#endif</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span>
<a name="l00266"></a>00266 
<a name="l00271"></a>00271         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == proc_id)
<a name="l00272"></a>00272           <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.insert (std::make_pair(elem, values));
<a name="l00273"></a>00273       }
<a name="l00274"></a>00274     }
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   <span class="comment">/*</span>
<a name="l00278"></a>00278 <span class="comment">   * finished reading.  Now ready for use, provided</span>
<a name="l00279"></a>00279 <span class="comment">   * there was any data contained in the file.</span>
<a name="l00280"></a>00280 <span class="comment">   */</span>
<a name="l00281"></a>00281   libmesh_assert ((this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.size() != 0) || (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.size() != 0));
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a> = <span class="keyword">true</span>;
<a name="l00284"></a>00284   this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a> = <span class="keyword">true</span>;
<a name="l00285"></a>00285 }
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a><a class="code" href="classlibMesh_1_1MeshData.php#ad137da147eda9f50aee32b5c746dbc83">00292</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshData.php#ad137da147eda9f50aee32b5c746dbc83">MeshData::write_xdr</a> (<span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00293"></a>00293                           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a3259cc4a42b40ff4f17d1550782ae2b8">XdrMODE</a> mode)
<a name="l00294"></a>00294 {
<a name="l00333"></a>00333   <span class="comment">/*</span>
<a name="l00334"></a>00334 <span class="comment">   * make sure the id maps are ready</span>
<a name="l00335"></a>00335 <span class="comment">   * and that we have data to write</span>
<a name="l00336"></a>00336 <span class="comment">   */</span>
<a name="l00337"></a>00337   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#a6796485bbb49480821ee7fc88129584c">_node_id_map_closed</a>);
<a name="l00338"></a>00338   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aafa368da459295ef681d3591cfd23efd">_elem_id_map_closed</a>);
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#ac8411f0e6d588a48fbb75756f0888e8b">_node_data_closed</a>);
<a name="l00341"></a>00341   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshData.php#aa184c2f724d75f263adfb4b73d6e0a10">_elem_data_closed</a>);
<a name="l00342"></a>00342   
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <a class="code" href="classlibMesh_1_1Xdr.php">Xdr</a> io(name, mode);
<a name="l00345"></a>00345 
<a name="l00346"></a>00346 
<a name="l00347"></a>00347   <span class="comment">// all processors write the data in the same format</span>
<a name="l00348"></a>00348   <span class="comment">//const unsigned int proc_id = _mesh.processor_id();</span>
<a name="l00349"></a>00349 
<a name="l00355"></a>00355   {
<a name="l00356"></a>00356     std::string desc = this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a4d4d511fa2fbe4d75576862ad4a440db">_data_descriptor</a>;
<a name="l00357"></a>00357     io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (desc, <span class="stringliteral">&quot;# Data description&quot;</span>);
<a name="l00358"></a>00358   }
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00367"></a>00367   {
<a name="l00368"></a>00368 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l00369"></a>00369 <span class="preprocessor"></span>    std::string desc = <span class="stringliteral">&quot;COMPLEX&quot;</span>;
<a name="l00370"></a>00370 <span class="preprocessor">#elif LIBMESH_USE_REAL_NUMBERS</span>
<a name="l00371"></a>00371 <span class="preprocessor"></span>    std::string desc = <span class="stringliteral">&quot;REAL&quot;</span>;
<a name="l00372"></a>00372 <span class="preprocessor">#else</span>
<a name="l00373"></a>00373 <span class="preprocessor"></span>better_you_choke_this...
<a name="l00374"></a>00374 #endif
<a name="l00375"></a>00375     io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (desc, <span class="stringliteral">&quot;# type of values&quot;</span>);
<a name="l00376"></a>00376   }
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00385"></a>00385   {
<a name="l00386"></a>00386     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_node = this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.size();
<a name="l00387"></a>00387     io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_node, <span class="stringliteral">&quot;# No. of nodes for which data is stored&quot;</span>);
<a name="l00388"></a>00388   }
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00396"></a>00396   {
<a name="l00397"></a>00397     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a> = this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.size();
<a name="l00398"></a>00398     io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (n_elem, <span class="stringliteral">&quot;# No. of elements for which data is stored&quot;</span>);
<a name="l00399"></a>00399   }
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>*, 
<a name="l00405"></a>00405            std::vector&lt;Number&gt; &gt;::const_iterator nit = <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.begin ();
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <span class="keywordflow">for</span> (; nit != <a class="code" href="classlibMesh_1_1MeshData.php#a71051cbe9de8cd511e3d7d285096c1e7">_node_data</a>.end(); ++nit)
<a name="l00408"></a>00408     {
<a name="l00409"></a>00409       <span class="keyword">const</span> Node* node = (*nit).first;
<a name="l00410"></a>00410 
<a name="l00416"></a>00416       {
<a name="l00417"></a>00417         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_id = <a class="code" href="classlibMesh_1_1MeshData.php#a61177caeb0fb845281a61e8f52a0bb5f">node_to_foreign_id</a> (node);
<a name="l00418"></a>00418         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (f_id, <span class="stringliteral">&quot;# Foreign node id&quot;</span>);
<a name="l00419"></a>00419       }
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00427"></a>00427       {
<a name="l00428"></a>00428         <span class="comment">/* </span>
<a name="l00429"></a>00429 <span class="comment">         * since we are iterating over our @e own </span>
<a name="l00430"></a>00430 <span class="comment">         * map, this libmesh_assert should never break...</span>
<a name="l00431"></a>00431 <span class="comment">         */</span>
<a name="l00432"></a>00432         libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#abc23718035cd723bf105c0161b767a79">has_data</a>(node));
<a name="l00433"></a>00433 
<a name="l00434"></a>00434         <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; values = this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ae1506d2f8392e527efdda28256e7ebab">get_data</a>(node);
<a name="l00435"></a>00435         
<a name="l00436"></a>00436         <span class="comment">/*</span>
<a name="l00437"></a>00437 <span class="comment">         * copy the data to a local buf, since</span>
<a name="l00438"></a>00438 <span class="comment">         * the Xdr class needs write access, even</span>
<a name="l00439"></a>00439 <span class="comment">         * when only reading data</span>
<a name="l00440"></a>00440 <span class="comment">         */</span>
<a name="l00441"></a>00441         std::vector&lt;Number&gt; buf = values;
<a name="l00442"></a>00442         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (buf, <span class="stringliteral">&quot;# Values&quot;</span>);
<a name="l00443"></a>00443       }
<a name="l00444"></a>00444     }
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 
<a name="l00451"></a>00451 
<a name="l00452"></a>00452   std::map&lt;<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>*, 
<a name="l00453"></a>00453            std::vector&lt;Number&gt; &gt;::const_iterator eit = <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.begin ();
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   <span class="keywordflow">for</span> (; eit != <a class="code" href="classlibMesh_1_1MeshData.php#a56c596c2e7d201c1f5e91c08ab25ffb9">_elem_data</a>.end(); ++eit)
<a name="l00456"></a>00456     {
<a name="l00457"></a>00457       <span class="keyword">const</span> Elem* elem = (*eit).first;
<a name="l00458"></a>00458 
<a name="l00464"></a>00464       {
<a name="l00465"></a>00465         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f_id = <a class="code" href="classlibMesh_1_1MeshData.php#ad92a581667b41710c22c7b59aec3fe64">elem_to_foreign_id</a> (elem);
<a name="l00466"></a>00466         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (f_id, <span class="stringliteral">&quot;# Foreign element id&quot;</span>);
<a name="l00467"></a>00467       }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469 
<a name="l00475"></a>00475       {
<a name="l00476"></a>00476         <span class="comment">/* </span>
<a name="l00477"></a>00477 <span class="comment">         * since we are iterating over our @e own </span>
<a name="l00478"></a>00478 <span class="comment">         * map, this libmesh_assert should never break...</span>
<a name="l00479"></a>00479 <span class="comment">         */</span>
<a name="l00480"></a>00480         libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#abc23718035cd723bf105c0161b767a79">has_data</a>(elem));
<a name="l00481"></a>00481 
<a name="l00482"></a>00482         <span class="keyword">const</span> std::vector&lt;Number&gt;&amp; values = this-&gt;<a class="code" href="classlibMesh_1_1MeshData.php#ae1506d2f8392e527efdda28256e7ebab">get_data</a>(elem);
<a name="l00483"></a>00483         
<a name="l00484"></a>00484         <span class="comment">/*</span>
<a name="l00485"></a>00485 <span class="comment">         * copy the data to a local buf, since</span>
<a name="l00486"></a>00486 <span class="comment">         * the Xdr class needs write access, even</span>
<a name="l00487"></a>00487 <span class="comment">         * when only reading data</span>
<a name="l00488"></a>00488 <span class="comment">         */</span>
<a name="l00489"></a>00489         std::vector&lt;Number&gt; buf = values;
<a name="l00490"></a>00490         io.<a class="code" href="classlibMesh_1_1Xdr.php#a8d41e3ea5b2559f8a73d83ad06a14cad">data</a> (buf, <span class="stringliteral">&quot;# Values&quot;</span>);
<a name="l00491"></a>00491       }
<a name="l00492"></a>00492     }
<a name="l00493"></a>00493 }
<a name="l00494"></a>00494 
<a name="l00495"></a>00495 } <span class="comment">// namespace libMesh</span>
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
