<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_function.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__function_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_function.C 3927 2010-08-24 22:37:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__function_8h.php">mesh_function.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__tree_8h.php">point_locator_tree.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="fe__interface_8h.php">fe_interface.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="fe__compute__data_8h.php">fe_compute_data.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>libMesh
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// MeshFunction methods</span>
<a name="l00044"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#ab8cf2b3fd285fd51fb1b36c2e6641e22">00044</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#ab8cf2b3fd285fd51fb1b36c2e6641e22">MeshFunction::MeshFunction</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; eqn_systems,
<a name="l00045"></a>00045                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec,
<a name="l00046"></a>00046                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map,
<a name="l00047"></a>00047                             <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; vars,
<a name="l00048"></a>00048                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>* master) :
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>   (master),
<a name="l00050"></a>00050   _eqn_systems   (eqn_systems),
<a name="l00051"></a>00051   _vector        (vec),
<a name="l00052"></a>00052   _dof_map       (dof_map),
<a name="l00053"></a>00053   _system_vars   (vars),
<a name="l00054"></a>00054   _point_locator (NULL),
<a name="l00055"></a>00055   _out_of_mesh_mode(false),
<a name="l00056"></a>00056   _out_of_mesh_value()
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 }
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a7a806f56ddd8d456c5e0344e3856d073">00062</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#ab8cf2b3fd285fd51fb1b36c2e6641e22">MeshFunction::MeshFunction</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; eqn_systems,
<a name="l00063"></a>00063                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec,
<a name="l00064"></a>00064                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map,
<a name="l00065"></a>00065                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00066"></a>00066                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>* master) :
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>   (master),
<a name="l00068"></a>00068   _eqn_systems   (eqn_systems),
<a name="l00069"></a>00069   _vector        (vec),
<a name="l00070"></a>00070   _dof_map       (dof_map),
<a name="l00071"></a>00071   _system_vars   (1,var),
<a name="l00072"></a>00072   _point_locator (NULL),
<a name="l00073"></a>00073   _out_of_mesh_mode(false),
<a name="l00074"></a>00074   _out_of_mesh_value()
<a name="l00075"></a>00075 {
<a name="l00076"></a>00076 <span class="comment">//   std::vector&lt;unsigned int&gt; buf (1);</span>
<a name="l00077"></a>00077 <span class="comment">//   buf[0] = var;</span>
<a name="l00078"></a>00078 <span class="comment">//   _system_vars (buf);</span>
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a680d29e406f77379fcd07eb6d227cd6a">00087</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#a680d29e406f77379fcd07eb6d227cd6a">MeshFunction::~MeshFunction</a> ()
<a name="l00088"></a>00088 {
<a name="l00089"></a>00089   <span class="comment">// only delete the point locator when we are the master</span>
<a name="l00090"></a>00090   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a> != NULL) &amp;&amp; (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a> == NULL))
<a name="l00091"></a>00091     <span class="keyword">delete</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>;
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a99e80d4afd3d5bd3dcabb9b9b79b34b0">00097</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a97deb97604e1f5870c053e8f861efa33">MeshFunction::init</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">Trees::BuildType</a> point_locator_build_type)
<a name="l00098"></a>00098 {
<a name="l00099"></a>00099   <span class="comment">// are indices of the desired variable(s) provided?</span>
<a name="l00100"></a>00100   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>.size() &gt; 0);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   <span class="comment">// Don&#39;t do twice...</span>
<a name="l00103"></a>00103   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">_initialized</a>)
<a name="l00104"></a>00104     {
<a name="l00105"></a>00105       libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a> != NULL);
<a name="l00106"></a>00106       <span class="keywordflow">return</span>;
<a name="l00107"></a>00107     }
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <span class="comment">/*</span>
<a name="l00110"></a>00110 <span class="comment">   * set up the PointLocator: either someone else</span>
<a name="l00111"></a>00111 <span class="comment">   * is the master (go and get the address of his</span>
<a name="l00112"></a>00112 <span class="comment">   * point locator) or this object is the master </span>
<a name="l00113"></a>00113 <span class="comment">   * (build the point locator  on our own).</span>
<a name="l00114"></a>00114 <span class="comment">   */</span>
<a name="l00115"></a>00115   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a> != NULL)
<a name="l00116"></a>00116     {
<a name="l00117"></a>00117       <span class="comment">// we aren&#39;t the master</span>
<a name="l00118"></a>00118       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>* master =
<a name="l00119"></a>00119         libmesh_cast_ptr&lt;const MeshFunction*&gt;(this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a>);
<a name="l00120"></a>00120       
<a name="l00121"></a>00121       <span class="keywordflow">if</span> (master-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a> == NULL)
<a name="l00122"></a>00122         {
<a name="l00123"></a>00123           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: When the master-servant concept is used,&quot;</span>
<a name="l00124"></a>00124                         &lt;&lt; std::endl
<a name="l00125"></a>00125                         &lt;&lt; <span class="stringliteral">&quot; the master has to be initialized first!&quot;</span>
<a name="l00126"></a>00126                         &lt;&lt; std::endl;
<a name="l00127"></a>00127           libmesh_error();
<a name="l00128"></a>00128         }
<a name="l00129"></a>00129       <span class="keywordflow">else</span>
<a name="l00130"></a>00130         {
<a name="l00131"></a>00131           this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a> = master-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>;
<a name="l00132"></a>00132         }
<a name="l00133"></a>00133     }
<a name="l00134"></a>00134   <span class="keywordflow">else</span>
<a name="l00135"></a>00135     {
<a name="l00136"></a>00136       <span class="comment">// we are the master: build the point locator</span>
<a name="l00137"></a>00137 
<a name="l00138"></a>00138       <span class="comment">// constant reference to the other mesh</span>
<a name="l00139"></a>00139       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a1a6163d6ba3be206635cd33ea9f9ce97">_eqn_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>();
<a name="l00140"></a>00140 
<a name="l00141"></a>00141       <span class="comment">// build the point locator.  Only \p TREE version available</span>
<a name="l00142"></a>00142       <span class="comment">//AutoPtr&lt;PointLocatorBase&gt; ap (PointLocatorBase::build (TREE, mesh));</span>
<a name="l00143"></a>00143       <span class="comment">//this-&gt;_point_locator = ap.release();</span>
<a name="l00144"></a>00144       this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php">PointLocatorTree</a> (mesh, point_locator_build_type);
<a name="l00145"></a>00145       
<a name="l00146"></a>00146 
<a name="l00147"></a>00147       <span class="comment">// Point locator no longer needs to be initialized.</span>
<a name="l00148"></a>00148       <span class="comment">//      this-&gt;_point_locator-&gt;init();</span>
<a name="l00149"></a>00149     }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">// ready for use</span>
<a name="l00153"></a>00153   this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">_initialized</a> = <span class="keyword">true</span>;
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 <span class="keywordtype">void</span>
<a name="l00158"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a59663e0ce81e4ce3266e3db78b8b9a99">00158</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#a59663e0ce81e4ce3266e3db78b8b9a99">MeshFunction::clear</a> ()
<a name="l00159"></a>00159 {
<a name="l00160"></a>00160   <span class="comment">// only delete the point locator when we are the master</span>
<a name="l00161"></a>00161   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a> != NULL) &amp;&amp; (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a> == NULL))
<a name="l00162"></a>00162     {
<a name="l00163"></a>00163       <span class="keyword">delete</span> this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>;
<a name="l00164"></a>00164       this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a> = NULL;
<a name="l00165"></a>00165     }
<a name="l00166"></a>00166   this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a1c121367b015c8e9214e1a894d30afe0">_initialized</a> = <span class="keyword">false</span>;
<a name="l00167"></a>00167 }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a6d2ce3ec12ed6be03e756d7fcbe51ced">00173</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#a6d2ce3ec12ed6be03e756d7fcbe51ced">MeshFunction::operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, 
<a name="l00174"></a>00174                                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time)
<a name="l00175"></a>00175 {
<a name="l00176"></a>00176   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00177"></a>00177   <span class="comment">// At the moment the function we call ignores the time</span>
<a name="l00178"></a>00178   libmesh_assert (time == 0.);
<a name="l00179"></a>00179   
<a name="l00180"></a>00180   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> buf (1);
<a name="l00181"></a>00181   this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a6d2ce3ec12ed6be03e756d7fcbe51ced">operator() </a>(p, time, buf);
<a name="l00182"></a>00182   <span class="keywordflow">return</span> buf(0);
<a name="l00183"></a>00183 }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a9b23c856cd235dbc24b6d0ce9315fc67">00187</a> <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#a9b23c856cd235dbc24b6d0ce9315fc67">MeshFunction::gradient</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, 
<a name="l00188"></a>00188                                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time)
<a name="l00189"></a>00189 {
<a name="l00190"></a>00190   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00191"></a>00191   <span class="comment">// At the moment the function we call ignores the time</span>
<a name="l00192"></a>00192   libmesh_assert (time == 0.);
<a name="l00193"></a>00193   
<a name="l00194"></a>00194   std::vector&lt;Gradient&gt; buf (1);
<a name="l00195"></a>00195   this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a9b23c856cd235dbc24b6d0ce9315fc67">gradient</a>(p, time, buf);
<a name="l00196"></a>00196   <span class="keywordflow">return</span> buf[0];
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00202"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a127a20e79669e4cbedece9532bf6dc20">00202</a> <span class="preprocessor"></span><a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#a127a20e79669e4cbedece9532bf6dc20">MeshFunction::hessian</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, 
<a name="l00203"></a>00203                               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time)
<a name="l00204"></a>00204 {
<a name="l00205"></a>00205   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00206"></a>00206   <span class="comment">// At the moment the function we call ignores the time</span>
<a name="l00207"></a>00207   libmesh_assert (time == 0.);
<a name="l00208"></a>00208   
<a name="l00209"></a>00209   std::vector&lt;Tensor&gt; buf (1);
<a name="l00210"></a>00210   this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a127a20e79669e4cbedece9532bf6dc20">hessian</a>(p, time, buf);
<a name="l00211"></a>00211   <span class="keywordflow">return</span> buf[0];
<a name="l00212"></a>00212 }
<a name="l00213"></a>00213 <span class="preprocessor">#endif</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span>
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a18dc4d4c722e1961fac15b2a337da62a">00217</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a6d2ce3ec12ed6be03e756d7fcbe51ced">MeshFunction::operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00218"></a>00218                                <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,
<a name="l00219"></a>00219                                <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output)
<a name="l00220"></a>00220 {
<a name="l00221"></a>00221   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="comment">/* Ensure that in the case of a master mesh function, the</span>
<a name="l00224"></a>00224 <span class="comment">     out-of-mesh mode is enabled either for both or for none.  This is</span>
<a name="l00225"></a>00225 <span class="comment">     important because the out-of-mesh mode is also communicated to</span>
<a name="l00226"></a>00226 <span class="comment">     the point locator.  Since this is time consuming, enable it only</span>
<a name="l00227"></a>00227 <span class="comment">     in debug mode.  */</span>
<a name="l00228"></a>00228 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00229"></a>00229 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a> != NULL)
<a name="l00230"></a>00230     {
<a name="l00231"></a>00231       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>* master =
<a name="l00232"></a>00232         libmesh_cast_ptr&lt;const MeshFunction*&gt;(this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a>);
<a name="l00233"></a>00233       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">_out_of_mesh_mode</a>!=master-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">_out_of_mesh_mode</a>)
<a name="l00234"></a>00234         {
<a name="l00235"></a>00235           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: If you use out-of-mesh-mode in connection with master mesh functions, you must enable out-of-mesh mode for both the master and the slave mesh function.&quot;</span> &lt;&lt; std::endl;
<a name="l00236"></a>00236           libmesh_error();
<a name="l00237"></a>00237         }
<a name="l00238"></a>00238     }
<a name="l00239"></a>00239 <span class="preprocessor">#endif</span>
<a name="l00240"></a>00240 <span class="preprocessor"></span>  
<a name="l00241"></a>00241   <span class="comment">// locate the point in the other mesh</span>
<a name="l00242"></a>00242   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* element = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>-&gt;operator()(p);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="keywordflow">if</span>(element==NULL)
<a name="l00245"></a>00245     {
<a name="l00246"></a>00246       output = <a class="code" href="classlibMesh_1_1MeshFunction.php#a923fd6da0edebc026c8d6cfe5574d078">_out_of_mesh_value</a>;      
<a name="l00247"></a>00247     }
<a name="l00248"></a>00248   <span class="keywordflow">else</span>
<a name="l00249"></a>00249     {
<a name="l00250"></a>00250       <span class="comment">// resize the output vector to the number of output values</span>
<a name="l00251"></a>00251       <span class="comment">// that the user told us</span>
<a name="l00252"></a>00252       output.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a> (this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>.size());
<a name="l00253"></a>00253       
<a name="l00254"></a>00254       
<a name="l00255"></a>00255       {
<a name="l00256"></a>00256         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a1a6163d6ba3be206635cd33ea9f9ce97">_eqn_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00257"></a>00257         
<a name="l00258"></a>00258         
<a name="l00259"></a>00259         <span class="comment">/*</span>
<a name="l00260"></a>00260 <span class="comment">         * Get local coordinates to feed these into compute_data().  </span>
<a name="l00261"></a>00261 <span class="comment">         * Note that the fe_type can safely be used from the 0-variable,</span>
<a name="l00262"></a>00262 <span class="comment">         * since the inverse mapping is the same for all FEFamilies</span>
<a name="l00263"></a>00263 <span class="comment">         */</span>
<a name="l00264"></a>00264         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> mapped_point (<a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (dim, 
<a name="l00265"></a>00265                                                             this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(0),
<a name="l00266"></a>00266                                                             element, 
<a name="l00267"></a>00267                                                             p));
<a name="l00268"></a>00268         
<a name="l00269"></a>00269         
<a name="l00270"></a>00270         <span class="comment">// loop over all vars</span>
<a name="l00271"></a>00271         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index &lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>.size(); index++)
<a name="l00272"></a>00272           {
<a name="l00273"></a>00273             <span class="comment">/*</span>
<a name="l00274"></a>00274 <span class="comment">             * the data for this variable</span>
<a name="l00275"></a>00275 <span class="comment">             */</span>
<a name="l00276"></a>00276             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>[index];
<a name="l00277"></a>00277             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(var);
<a name="l00278"></a>00278             
<a name="l00283"></a>00283             {
<a name="l00284"></a>00284               <a class="code" href="classlibMesh_1_1FEComputeData.php">FEComputeData</a> data (this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a1a6163d6ba3be206635cd33ea9f9ce97">_eqn_systems</a>, mapped_point);
<a name="l00285"></a>00285               
<a name="l00286"></a>00286               <a class="code" href="classlibMesh_1_1FEInterface.php#a73ff41d651b8412ccca780cf0b8c356d">FEInterface::compute_data</a> (dim, fe_type, element, data);
<a name="l00287"></a>00287               
<a name="l00288"></a>00288               <span class="comment">// where the solution values for the var-th variable are stored</span>
<a name="l00289"></a>00289               std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00290"></a>00290               this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (element, dof_indices, var);
<a name="l00291"></a>00291               
<a name="l00292"></a>00292               <span class="comment">// interpolate the solution</span>
<a name="l00293"></a>00293               {
<a name="l00294"></a>00294                 <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> value = 0.;
<a name="l00295"></a>00295                 
<a name="l00296"></a>00296                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00297"></a>00297                   value += this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a9d2f58b07ae25814534afd702e51cd9d">_vector</a>(dof_indices[i]) * data.<a class="code" href="classlibMesh_1_1FEComputeData.php#abcadcf6c89c2ca5258e5c1f53c321bfe">shape</a>[i];
<a name="l00298"></a>00298                 
<a name="l00299"></a>00299                 output(index) = value;
<a name="l00300"></a>00300               }
<a name="l00301"></a>00301               
<a name="l00302"></a>00302             }
<a name="l00303"></a>00303             
<a name="l00304"></a>00304             <span class="comment">// next variable</span>
<a name="l00305"></a>00305           }
<a name="l00306"></a>00306       }
<a name="l00307"></a>00307     }
<a name="l00308"></a>00308       
<a name="l00309"></a>00309   <span class="comment">// all done</span>
<a name="l00310"></a>00310   <span class="keywordflow">return</span>;
<a name="l00311"></a>00311 }
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#ae4f1d77d00067b5e89bf6ccfd4b067e2">00315</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a9b23c856cd235dbc24b6d0ce9315fc67">MeshFunction::gradient</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00316"></a>00316                              <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,
<a name="l00317"></a>00317                              std::vector&lt;Gradient&gt;&amp; output)
<a name="l00318"></a>00318 {
<a name="l00319"></a>00319   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00320"></a>00320 
<a name="l00321"></a>00321   <span class="comment">/* Ensure that in the case of a master mesh function, the</span>
<a name="l00322"></a>00322 <span class="comment">     out-of-mesh mode is enabled either for both or for none.  This is</span>
<a name="l00323"></a>00323 <span class="comment">     important because the out-of-mesh mode is also communicated to</span>
<a name="l00324"></a>00324 <span class="comment">     the point locator.  Since this is time consuming, enable it only</span>
<a name="l00325"></a>00325 <span class="comment">     in debug mode.  */</span>
<a name="l00326"></a>00326 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a> != NULL)
<a name="l00328"></a>00328     {
<a name="l00329"></a>00329       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>* master =
<a name="l00330"></a>00330         libmesh_cast_ptr&lt;const MeshFunction*&gt;(this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a>);
<a name="l00331"></a>00331       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">_out_of_mesh_mode</a>!=master-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">_out_of_mesh_mode</a>)
<a name="l00332"></a>00332         {
<a name="l00333"></a>00333           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: If you use out-of-mesh-mode in connection with master mesh functions, you must enable out-of-mesh mode for both the master and the slave mesh function.&quot;</span> &lt;&lt; std::endl;
<a name="l00334"></a>00334           libmesh_error();
<a name="l00335"></a>00335         }
<a name="l00336"></a>00336     }
<a name="l00337"></a>00337 <span class="preprocessor">#endif</span>
<a name="l00338"></a>00338 <span class="preprocessor"></span>  
<a name="l00339"></a>00339   <span class="comment">// locate the point in the other mesh</span>
<a name="l00340"></a>00340   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* element = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>-&gt;operator()(p);
<a name="l00341"></a>00341 
<a name="l00342"></a>00342   <span class="keywordflow">if</span>(element==NULL)
<a name="l00343"></a>00343     {
<a name="l00344"></a>00344       output.resize(0);
<a name="l00345"></a>00345     }
<a name="l00346"></a>00346   <span class="keywordflow">else</span>
<a name="l00347"></a>00347     {
<a name="l00348"></a>00348       <span class="comment">// resize the output vector to the number of output values</span>
<a name="l00349"></a>00349       <span class="comment">// that the user told us</span>
<a name="l00350"></a>00350       output.resize (this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>.size());
<a name="l00351"></a>00351       
<a name="l00352"></a>00352       
<a name="l00353"></a>00353       {
<a name="l00354"></a>00354         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a1a6163d6ba3be206635cd33ea9f9ce97">_eqn_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00355"></a>00355         
<a name="l00356"></a>00356         
<a name="l00357"></a>00357         <span class="comment">/*</span>
<a name="l00358"></a>00358 <span class="comment">         * Get local coordinates to feed these into compute_data().  </span>
<a name="l00359"></a>00359 <span class="comment">         * Note that the fe_type can safely be used from the 0-variable,</span>
<a name="l00360"></a>00360 <span class="comment">         * since the inverse mapping is the same for all FEFamilies</span>
<a name="l00361"></a>00361 <span class="comment">         */</span>
<a name="l00362"></a>00362         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> mapped_point (<a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (dim, 
<a name="l00363"></a>00363                                                             this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(0),
<a name="l00364"></a>00364                                                             element, 
<a name="l00365"></a>00365                                                             p));
<a name="l00366"></a>00366         
<a name="l00367"></a>00367         std::vector&lt;Point&gt; point_list (1, mapped_point);
<a name="l00368"></a>00368         
<a name="l00369"></a>00369         <span class="comment">// loop over all vars</span>
<a name="l00370"></a>00370         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index &lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>.size(); index++)
<a name="l00371"></a>00371           {
<a name="l00372"></a>00372             <span class="comment">/*</span>
<a name="l00373"></a>00373 <span class="comment">             * the data for this variable</span>
<a name="l00374"></a>00374 <span class="comment">             */</span>
<a name="l00375"></a>00375             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>[index];
<a name="l00376"></a>00376             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(var);
<a name="l00377"></a>00377 
<a name="l00378"></a>00378             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> point_fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, fe_type));
<a name="l00379"></a>00379             <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt;&amp; dphi = point_fe-&gt;get_dphi();
<a name="l00380"></a>00380             point_fe-&gt;reinit(element, &amp;point_list);
<a name="l00381"></a>00381             
<a name="l00382"></a>00382             <span class="comment">// where the solution values for the var-th variable are stored</span>
<a name="l00383"></a>00383             std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00384"></a>00384             this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (element, dof_indices, var);
<a name="l00385"></a>00385               
<a name="l00386"></a>00386             <span class="comment">// interpolate the solution</span>
<a name="l00387"></a>00387             <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad(0.);
<a name="l00388"></a>00388                 
<a name="l00389"></a>00389             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00390"></a>00390               grad.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a>(dphi[i][0], this-&gt;_vector(dof_indices[i]));
<a name="l00391"></a>00391                 
<a name="l00392"></a>00392             output[index] = grad;
<a name="l00393"></a>00393           }
<a name="l00394"></a>00394       }
<a name="l00395"></a>00395     }
<a name="l00396"></a>00396       
<a name="l00397"></a>00397   <span class="comment">// all done</span>
<a name="l00398"></a>00398   <span class="keywordflow">return</span>;
<a name="l00399"></a>00399 }
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 
<a name="l00403"></a>00403 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00404"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a6347dc0586c1c1067831c81286c66f9a">00404</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a127a20e79669e4cbedece9532bf6dc20">MeshFunction::hessian</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00405"></a>00405                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>,
<a name="l00406"></a>00406                             std::vector&lt;Tensor&gt;&amp; output)
<a name="l00407"></a>00407 {
<a name="l00408"></a>00408   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="comment">/* Ensure that in the case of a master mesh function, the</span>
<a name="l00411"></a>00411 <span class="comment">     out-of-mesh mode is enabled either for both or for none.  This is</span>
<a name="l00412"></a>00412 <span class="comment">     important because the out-of-mesh mode is also communicated to</span>
<a name="l00413"></a>00413 <span class="comment">     the point locator.  Since this is time consuming, enable it only</span>
<a name="l00414"></a>00414 <span class="comment">     in debug mode.  */</span>
<a name="l00415"></a>00415 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00416"></a>00416 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a> != NULL)
<a name="l00417"></a>00417     {
<a name="l00418"></a>00418       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a>* master =
<a name="l00419"></a>00419         libmesh_cast_ptr&lt;const MeshFunction*&gt;(this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#a0182eaaee9f34c17194646958f718415">_master</a>);
<a name="l00420"></a>00420       <span class="keywordflow">if</span>(<a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">_out_of_mesh_mode</a>!=master-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">_out_of_mesh_mode</a>)
<a name="l00421"></a>00421         {
<a name="l00422"></a>00422           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: If you use out-of-mesh-mode in connection with master mesh functions, you must enable out-of-mesh mode for both the master and the slave mesh function.&quot;</span> &lt;&lt; std::endl;
<a name="l00423"></a>00423           libmesh_error();
<a name="l00424"></a>00424         }
<a name="l00425"></a>00425     }
<a name="l00426"></a>00426 <span class="preprocessor">#endif</span>
<a name="l00427"></a>00427 <span class="preprocessor"></span>  
<a name="l00428"></a>00428   <span class="comment">// locate the point in the other mesh</span>
<a name="l00429"></a>00429   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* element = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>-&gt;operator()(p);
<a name="l00430"></a>00430 
<a name="l00431"></a>00431   <span class="keywordflow">if</span>(element==NULL)
<a name="l00432"></a>00432     {
<a name="l00433"></a>00433       output.resize(0);
<a name="l00434"></a>00434     }
<a name="l00435"></a>00435   <span class="keywordflow">else</span>
<a name="l00436"></a>00436     {
<a name="l00437"></a>00437       <span class="comment">// resize the output vector to the number of output values</span>
<a name="l00438"></a>00438       <span class="comment">// that the user told us</span>
<a name="l00439"></a>00439       output.resize (this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>.size());
<a name="l00440"></a>00440       
<a name="l00441"></a>00441       
<a name="l00442"></a>00442       {
<a name="l00443"></a>00443         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a1a6163d6ba3be206635cd33ea9f9ce97">_eqn_systems</a>.<a class="code" href="classlibMesh_1_1EquationSystems.php#aba1132bd8b38e9ce851abf57c3bc1e4b">get_mesh</a>().<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00444"></a>00444         
<a name="l00445"></a>00445         
<a name="l00446"></a>00446         <span class="comment">/*</span>
<a name="l00447"></a>00447 <span class="comment">         * Get local coordinates to feed these into compute_data().  </span>
<a name="l00448"></a>00448 <span class="comment">         * Note that the fe_type can safely be used from the 0-variable,</span>
<a name="l00449"></a>00449 <span class="comment">         * since the inverse mapping is the same for all FEFamilies</span>
<a name="l00450"></a>00450 <span class="comment">         */</span>
<a name="l00451"></a>00451         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> mapped_point (<a class="code" href="classlibMesh_1_1FEInterface.php#aa4cd7cde33c7f4b7f873d2fdad6fb635">FEInterface::inverse_map</a> (dim, 
<a name="l00452"></a>00452                                                             this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(0),
<a name="l00453"></a>00453                                                             element, 
<a name="l00454"></a>00454                                                             p));
<a name="l00455"></a>00455         
<a name="l00456"></a>00456         std::vector&lt;Point&gt; point_list (1, mapped_point);
<a name="l00457"></a>00457         
<a name="l00458"></a>00458         <span class="comment">// loop over all vars</span>
<a name="l00459"></a>00459         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> index=0; index &lt; this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>.size(); index++)
<a name="l00460"></a>00460           {
<a name="l00461"></a>00461             <span class="comment">/*</span>
<a name="l00462"></a>00462 <span class="comment">             * the data for this variable</span>
<a name="l00463"></a>00463 <span class="comment">             */</span>
<a name="l00464"></a>00464             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var = <a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>[index];
<a name="l00465"></a>00465             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a>(var);
<a name="l00466"></a>00466 
<a name="l00467"></a>00467             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> point_fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a>(dim, fe_type));
<a name="l00468"></a>00468             <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;&amp; d2phi =
<a name="l00469"></a>00469                             point_fe-&gt;get_d2phi();
<a name="l00470"></a>00470             point_fe-&gt;reinit(element, &amp;point_list);
<a name="l00471"></a>00471             
<a name="l00472"></a>00472             <span class="comment">// where the solution values for the var-th variable are stored</span>
<a name="l00473"></a>00473             std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00474"></a>00474             this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (element, dof_indices, var);
<a name="l00475"></a>00475               
<a name="l00476"></a>00476             <span class="comment">// interpolate the solution</span>
<a name="l00477"></a>00477             <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> hess;
<a name="l00478"></a>00478                 
<a name="l00479"></a>00479             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;dof_indices.size(); i++)
<a name="l00480"></a>00480               hess.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a>(d2phi[i][0], this-&gt;_vector(dof_indices[i]));
<a name="l00481"></a>00481                 
<a name="l00482"></a>00482             output[index] = hess;
<a name="l00483"></a>00483           }
<a name="l00484"></a>00484       }
<a name="l00485"></a>00485     }
<a name="l00486"></a>00486       
<a name="l00487"></a>00487   <span class="comment">// all done</span>
<a name="l00488"></a>00488   <span class="keywordflow">return</span>;
<a name="l00489"></a>00489 }
<a name="l00490"></a>00490 <span class="preprocessor">#endif</span>
<a name="l00491"></a>00491 <span class="preprocessor"></span>
<a name="l00492"></a>00492 
<a name="l00493"></a>00493 
<a name="l00494"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#abb046b8bfbe1cdfdbd0f35d24773d6a9">00494</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshFunction.php#abb046b8bfbe1cdfdbd0f35d24773d6a9">MeshFunction::get_point_locator</a> (<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l00495"></a>00495 <span class="keyword"></span>{
<a name="l00496"></a>00496   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00497"></a>00497   <span class="keywordflow">return</span> *<a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>;
<a name="l00498"></a>00498 }
<a name="l00499"></a>00499 
<a name="l00500"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#accd46b5c0eeed3f90b0ab6e5de9cfe86">00500</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#accd46b5c0eeed3f90b0ab6e5de9cfe86">MeshFunction::enable_out_of_mesh_mode</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; value)
<a name="l00501"></a>00501 {
<a name="l00502"></a>00502   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00503"></a>00503   <a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#ae1c2be8d30bc642174107694e6b376bf">enable_out_of_mesh_mode</a>();
<a name="l00504"></a>00504   <a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">_out_of_mesh_mode</a> = <span class="keyword">true</span>;
<a name="l00505"></a>00505   <a class="code" href="classlibMesh_1_1MeshFunction.php#a923fd6da0edebc026c8d6cfe5574d078">_out_of_mesh_value</a> = value;
<a name="l00506"></a>00506 }
<a name="l00507"></a>00507 
<a name="l00508"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#abe9ffe56743400090b53febeebcbb1f1">00508</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#accd46b5c0eeed3f90b0ab6e5de9cfe86">MeshFunction::enable_out_of_mesh_mode</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; value)
<a name="l00509"></a>00509 {
<a name="l00510"></a>00510   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> v(1);
<a name="l00511"></a>00511   v(0) = value;
<a name="l00512"></a>00512   this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#accd46b5c0eeed3f90b0ab6e5de9cfe86">enable_out_of_mesh_mode</a>(v);
<a name="l00513"></a>00513 }
<a name="l00514"></a>00514 
<a name="l00515"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a869353ffc5300d4bac446c3617ee9188">00515</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a869353ffc5300d4bac446c3617ee9188">MeshFunction::disable_out_of_mesh_mode</a>(<span class="keywordtype">void</span>)
<a name="l00516"></a>00516 {
<a name="l00517"></a>00517   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1FunctionBase.php#ad96541afb11184d8fdfdefe0cee334c1">initialized</a>());
<a name="l00518"></a>00518   <a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#a0a84c4b30b57365b2c1e58ddb29433ad">disable_out_of_mesh_mode</a>();
<a name="l00519"></a>00519   <a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">_out_of_mesh_mode</a> = <span class="keyword">false</span>;
<a name="l00520"></a>00520 }
<a name="l00521"></a>00521 
<a name="l00522"></a>00522 } <span class="comment">// namespace libMesh</span>
<a name="l00523"></a>00523 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
