<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_function.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__function_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_function.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_function_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_function_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="function__base_8h.php">function_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="vector__value_8h.php">vector_value.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="tree__base_8h.php">tree_base.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// Forward Declarations</span>
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseVector;
<a name="l00042"></a>00042 <span class="keyword">class </span>EquationSystems;
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00044"></a>00044 <span class="keyword">class </span>DofMap;
<a name="l00045"></a>00045 <span class="keyword">class </span>PointLocatorBase;
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00056"></a>00056 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00057"></a>00057 <span class="comment">// MeshFunction class definition</span>
<a name="l00058"></a><a class="code" href="classlibMesh_1_1MeshFunction.php">00058</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshFunction.php">MeshFunction</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00070"></a>00070   <a class="code" href="classlibMesh_1_1MeshFunction.php#ab8cf2b3fd285fd51fb1b36c2e6641e22">MeshFunction</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; eqn_systems,
<a name="l00071"></a>00071                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec,
<a name="l00072"></a>00072                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map,
<a name="l00073"></a>00073                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; vars,
<a name="l00074"></a>00074                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>* master=NULL);
<a name="l00075"></a>00075 
<a name="l00084"></a>00084   <a class="code" href="classlibMesh_1_1MeshFunction.php#ab8cf2b3fd285fd51fb1b36c2e6641e22">MeshFunction</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; eqn_systems,
<a name="l00085"></a>00085                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; vec,
<a name="l00086"></a>00086                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map,
<a name="l00087"></a>00087                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var,
<a name="l00088"></a>00088                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FunctionBase.php">FunctionBase</a>* master=NULL);
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <a class="code" href="classlibMesh_1_1MeshFunction.php#a680d29e406f77379fcd07eb6d227cd6a">~MeshFunction</a> ();
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a97deb97604e1f5870c053e8f861efa33">00101</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a97deb97604e1f5870c053e8f861efa33">init</a> () { this-&gt;<a class="code" href="classlibMesh_1_1MeshFunction.php#a97deb97604e1f5870c053e8f861efa33">init</a>(<a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9a99710d266ed849862503d6da40f75565">Trees::NODES</a>); };
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00108"></a>00108   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a97deb97604e1f5870c053e8f861efa33">init</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">Trees::BuildType</a> point_locator_build_type);
<a name="l00109"></a>00109 
<a name="l00113"></a>00113   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a59663e0ce81e4ce3266e3db78b8b9a99">clear</a> ();
<a name="l00114"></a>00114 
<a name="l00119"></a>00119   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#a6d2ce3ec12ed6be03e756d7fcbe51ced">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, 
<a name="l00120"></a>00120                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time=0.);
<a name="l00121"></a>00121 
<a name="l00126"></a>00126   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#a9b23c856cd235dbc24b6d0ce9315fc67">gradient</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, 
<a name="l00127"></a>00127                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time=0.);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00130"></a>00130 <span class="preprocessor"></span>
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#a127a20e79669e4cbedece9532bf6dc20">hessian</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, 
<a name="l00135"></a>00135                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time=0.);
<a name="l00136"></a>00136 <span class="preprocessor">#endif</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
<a name="l00142"></a>00142   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a6d2ce3ec12ed6be03e756d7fcbe51ced">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00143"></a>00143                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time,
<a name="l00144"></a>00144                    <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; output);
<a name="l00145"></a>00145 
<a name="l00150"></a>00150   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a9b23c856cd235dbc24b6d0ce9315fc67">gradient</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00151"></a>00151                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time,
<a name="l00152"></a>00152                  std::vector&lt;Gradient&gt;&amp; output);
<a name="l00153"></a>00153 
<a name="l00158"></a>00158   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a127a20e79669e4cbedece9532bf6dc20">hessian</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00159"></a>00159                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> time,
<a name="l00160"></a>00160                 std::vector&lt;Tensor&gt;&amp; output);
<a name="l00161"></a>00161 
<a name="l00167"></a>00167   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshFunction.php#abb046b8bfbe1cdfdbd0f35d24773d6a9">get_point_locator</a> (<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00168"></a>00168 
<a name="l00179"></a>00179   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#accd46b5c0eeed3f90b0ab6e5de9cfe86">enable_out_of_mesh_mode</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a>&amp; value);
<a name="l00180"></a>00180 
<a name="l00191"></a>00191   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#accd46b5c0eeed3f90b0ab6e5de9cfe86">enable_out_of_mesh_mode</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&amp; value);
<a name="l00192"></a>00192 
<a name="l00196"></a>00196   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a869353ffc5300d4bac446c3617ee9188">disable_out_of_mesh_mode</a>(<span class="keywordtype">void</span>);
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="keyword">protected</span>:
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00205"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a1a6163d6ba3be206635cd33ea9f9ce97">00205</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; <a class="code" href="classlibMesh_1_1MeshFunction.php#a1a6163d6ba3be206635cd33ea9f9ce97">_eqn_systems</a>;
<a name="l00206"></a>00206 
<a name="l00211"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a9d2f58b07ae25814534afd702e51cd9d">00211</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; <a class="code" href="classlibMesh_1_1MeshFunction.php#a9d2f58b07ae25814534afd702e51cd9d">_vector</a>;
<a name="l00212"></a>00212 
<a name="l00216"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">00216</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; <a class="code" href="classlibMesh_1_1MeshFunction.php#addaea8f4ceb57c14a77e79800707017c">_dof_map</a>;
<a name="l00217"></a>00217 
<a name="l00222"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">00222</a>   <span class="keyword">const</span> std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1MeshFunction.php#a2473008e94001a3c93e8f5b15fc05c3b">_system_vars</a>;
<a name="l00223"></a>00223 
<a name="l00228"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">00228</a>   <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* <a class="code" href="classlibMesh_1_1MeshFunction.php#ac5845fb720939ce94fac7d38eb4fbcdb">_point_locator</a>;
<a name="l00229"></a>00229 
<a name="l00234"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">00234</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshFunction.php#a77165b5f43d1b4b8e75a711f2cbc1079">_out_of_mesh_mode</a>;
<a name="l00235"></a>00235 
<a name="l00240"></a><a class="code" href="classlibMesh_1_1MeshFunction.php#a923fd6da0edebc026c8d6cfe5574d078">00240</a>   <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> <a class="code" href="classlibMesh_1_1MeshFunction.php#a923fd6da0edebc026c8d6cfe5574d078">_out_of_mesh_value</a>;
<a name="l00241"></a>00241 };
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00247"></a>00247 <span class="comment">// MeshFunction inline methods</span>
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 } <span class="comment">// namespace libMesh</span>
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 <span class="preprocessor">#endif</span>
<a name="l00254"></a>00254 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
