<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_generation.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__generation_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_generation.h 4066 2010-10-27 16:45:23Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_generation_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_generation_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00031"></a>00031 <span class="comment">// #include &quot;libmesh_common.h&quot; // needed for Real</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="comment">//#include &quot;point.h&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// forward declarations</span>
<a name="l00040"></a>00040 <span class="keyword">class </span>UnstructuredMesh;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// MeshTools::Generation namespace</span>
<a name="l00046"></a>00046 <span class="keyword">namespace </span>MeshTools
<a name="l00047"></a>00047 {
<a name="l00055"></a>00055   <span class="keyword">namespace </span>Generation
<a name="l00056"></a>00056   {
<a name="l00066"></a>00066     <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#adc26f45af62fb628158c7585d4171d01">build_cube</a> (UnstructuredMesh&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00067"></a>00067                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx=0,
<a name="l00068"></a>00068                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny=0,
<a name="l00069"></a>00069                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nz=0,
<a name="l00070"></a>00070                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin=0., <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax=1.,
<a name="l00071"></a>00071                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymin=0., <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymax=1.,
<a name="l00072"></a>00072                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zmin=0., <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zmax=1.,
<a name="l00073"></a>00073                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00074"></a>00074                      <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid=<span class="keyword">false</span>);
<a name="l00075"></a>00075 
<a name="l00080"></a>00080     <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#a0292e2a29274c5a479807524457eb1a7">build_point</a> (UnstructuredMesh&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00081"></a>00081                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00082"></a>00082                       <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid=<span class="keyword">false</span>);
<a name="l00083"></a>00083 
<a name="l00090"></a>00090     <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#ad590f9cbf833bddb69fc812bf4434379">build_line</a> (UnstructuredMesh&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00091"></a>00091                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l00092"></a>00092                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin=0., <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax=1.,
<a name="l00093"></a>00093                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00094"></a>00094                      <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid=<span class="keyword">false</span>);
<a name="l00095"></a>00095 
<a name="l00102"></a>00102     <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#a09ed2ca5dda1c38a23f7f44cf99cf617">build_square</a> (UnstructuredMesh&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00103"></a>00103                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx,
<a name="l00104"></a>00104                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny,
<a name="l00105"></a>00105                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin=0., <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax=1.,
<a name="l00106"></a>00106                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymin=0., <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymax=1.,
<a name="l00107"></a>00107                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00108"></a>00108                        <span class="keyword">const</span> <span class="keywordtype">bool</span> gauss_lobatto_grid=<span class="keyword">false</span>);
<a name="l00109"></a>00109 
<a name="l00113"></a>00113     <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#af94a54e1acc8f32e4fde70b0f3b73fed">build_sphere</a> (UnstructuredMesh&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00114"></a>00114                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rad=1,
<a name="l00115"></a>00115                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nr=2,
<a name="l00116"></a>00116                        <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>);
<a name="l00117"></a>00117 
<a name="l00118"></a>00118     
<a name="l00119"></a>00119   } <span class="comment">// end namespace Meshtools::Generation</span>
<a name="l00120"></a>00120 } <span class="comment">// end namespace MeshTools</span>
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 } <span class="comment">// namespace libMesh</span>
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="preprocessor">#endif // #define __mesh_generation_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
