<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_input.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__input_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_input.h 4170 2011-01-13 23:55:44Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_input_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_input_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;istream&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00050"></a>00050 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00051"></a>00051 <span class="comment">// MeshInput class definition</span>
<a name="l00052"></a>00052 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00053"></a><a class="code" href="classlibMesh_1_1MeshInput.php">00053</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055  <span class="keyword">protected</span>:
<a name="l00056"></a>00056 
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1MeshInput.php#a1cfc50938fdb298daa2b833a97bbde3d">MeshInput</a> (<span class="keywordtype">bool</span> is_parallel_format = <span class="keyword">false</span>);
<a name="l00062"></a>00062   
<a name="l00067"></a>00067   <a class="code" href="classlibMesh_1_1MeshInput.php#a1cfc50938fdb298daa2b833a97bbde3d">MeshInput</a> (MT&amp;, <span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format = <span class="keyword">false</span>);
<a name="l00068"></a>00068   
<a name="l00069"></a>00069  <span class="keyword">public</span>:
<a name="l00070"></a>00070 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1MeshInput.php#a90ba536f0f1e620539a9c29ed7f30bed">~MeshInput</a> ();
<a name="l00075"></a>00075   
<a name="l00079"></a>00079   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshInput.php#acd8a6f8530d308a2a3632b67ce28e340">read</a> (<span class="keyword">const</span> std::string&amp;) = 0;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   
<a name="l00082"></a>00082  <span class="keyword">protected</span>:
<a name="l00083"></a>00083   
<a name="l00087"></a>00087   MT&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> ();
<a name="l00088"></a>00088   
<a name="l00093"></a><a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">00093</a>   std::vector&lt;bool&gt; <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>;
<a name="l00094"></a>00094   
<a name="l00099"></a>00099   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshInput.php#a96cc4aa98c2495e488522155a3fa07f2">skip_comment_lines</a> (std::istream&amp; in,
<a name="l00100"></a>00100                            <span class="keyword">const</span> <span class="keywordtype">char</span> comment_start);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102   
<a name="l00103"></a>00103  <span class="keyword">private</span>:
<a name="l00104"></a>00104   
<a name="l00105"></a>00105 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1MeshInput.php#af996150af019204e88b6f4d81d6ff0e0">00110</a>   MT* <a class="code" href="classlibMesh_1_1MeshInput.php#af996150af019204e88b6f4d81d6ff0e0">_obj</a>;
<a name="l00111"></a>00111 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1MeshInput.php#ab85e0eb1d4a22c7b635bacbc22f5caf7">00117</a>   <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshInput.php#ab85e0eb1d4a22c7b635bacbc22f5caf7">_is_parallel_format</a>;
<a name="l00118"></a>00118 };
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00123"></a>00123 <span class="comment">// MeshInput inline members</span>
<a name="l00124"></a>00124 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00125"></a>00125 <span class="keyword">inline</span>
<a name="l00126"></a><a class="code" href="classlibMesh_1_1MeshInput.php#a1cfc50938fdb298daa2b833a97bbde3d">00126</a> <a class="code" href="classlibMesh_1_1MeshInput.php#a1cfc50938fdb298daa2b833a97bbde3d">MeshInput&lt;MT&gt;::MeshInput</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format) :
<a name="l00127"></a>00127   elems_of_dimension(),
<a name="l00128"></a>00128   _obj (NULL),
<a name="l00129"></a>00129   _is_parallel_format(is_parallel_format)
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131 }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00136"></a>00136 <span class="keyword">inline</span>
<a name="l00137"></a><a class="code" href="classlibMesh_1_1MeshInput.php#a385bf33c311d13f589b310653c9a428b">00137</a> <a class="code" href="classlibMesh_1_1MeshInput.php#a1cfc50938fdb298daa2b833a97bbde3d">MeshInput&lt;MT&gt;::MeshInput</a> (MT&amp; obj, <span class="keyword">const</span> <span class="keywordtype">bool</span> is_parallel_format) :
<a name="l00138"></a>00138   elems_of_dimension(),
<a name="l00139"></a>00139   _obj (&amp;obj),
<a name="l00140"></a>00140   _is_parallel_format(is_parallel_format)
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshInput.php#ab85e0eb1d4a22c7b635bacbc22f5caf7">_is_parallel_format</a> &amp;&amp; !this-&gt;<a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a>().is_serial())
<a name="l00143"></a>00143     {
<a name="l00144"></a>00144       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00145"></a>00145         {
<a name="l00146"></a>00146           libmesh_do_once(<a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; 
<a name="l00147"></a>00147             <span class="stringliteral">&quot;Warning:  This MeshInput subclass only support meshes which have been serialized!&quot;</span>
<a name="l00148"></a>00148             &lt;&lt; std::endl; libmesh_here(););
<a name="l00149"></a>00149         }
<a name="l00150"></a>00150     }
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00156"></a>00156 <span class="keyword">inline</span>
<a name="l00157"></a><a class="code" href="classlibMesh_1_1MeshInput.php#a90ba536f0f1e620539a9c29ed7f30bed">00157</a> <a class="code" href="classlibMesh_1_1MeshInput.php#a90ba536f0f1e620539a9c29ed7f30bed">MeshInput&lt;MT&gt;::~MeshInput</a> ()
<a name="l00158"></a>00158 {
<a name="l00159"></a>00159 }
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00164"></a>00164 <span class="keyword">inline</span>
<a name="l00165"></a><a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">00165</a> MT&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">MeshInput&lt;MT&gt;::mesh</a> ()
<a name="l00166"></a>00166 {
<a name="l00167"></a>00167   <span class="keywordflow">if</span> (_obj == NULL) libmesh_error();
<a name="l00168"></a>00168   <span class="keywordflow">return</span> *_obj;
<a name="l00169"></a>00169 }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00174"></a><a class="code" href="classlibMesh_1_1MeshInput.php#a96cc4aa98c2495e488522155a3fa07f2">00174</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshInput.php#a96cc4aa98c2495e488522155a3fa07f2">MeshInput&lt;MT&gt;::skip_comment_lines</a> (std::istream &amp;in,
<a name="l00175"></a>00175                                         <span class="keyword">const</span> <span class="keywordtype">char</span> comment_start)
<a name="l00176"></a>00176 {    
<a name="l00177"></a>00177   <span class="keywordtype">char</span> c, line[256];
<a name="l00178"></a>00178   
<a name="l00179"></a>00179   <span class="keywordflow">while</span> (in.get(c), c==comment_start) 
<a name="l00180"></a>00180     in.getline (line, 255);
<a name="l00181"></a>00181   
<a name="l00182"></a>00182   <span class="comment">// put back first character of</span>
<a name="l00183"></a>00183   <span class="comment">// first non-comment line</span>
<a name="l00184"></a>00184   in.putback (c);
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 } <span class="comment">// namespace libMesh</span>
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 <span class="preprocessor">#endif // #define __mesh_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
