<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_modification.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__modification_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_modification.C 4387 2011-04-21 01:17:20Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::acos()</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="face__tri3_8h.php">face_tri3.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="face__tri6_8h.php">face_tri6.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="location__maps_8h.php">location_maps.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="mesh__modification_8h.php">mesh_modification.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="remote__elem_8h.php">remote_elem.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="string__to__enum_8h.php">string_to_enum.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// MeshTools::Modification functions for mesh modification</span>
<a name="l00047"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#ab3c34bd675ddf6c6675daa7fcc96d7cf">00047</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#ab3c34bd675ddf6c6675daa7fcc96d7cf">MeshTools::Modification::distort</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00048"></a>00048                                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> factor,
<a name="l00049"></a>00049                                        <span class="keyword">const</span> <span class="keywordtype">bool</span> perturb_boundary)
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00052"></a>00052   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>());
<a name="l00053"></a>00053   libmesh_assert ((factor &gt;= 0.) &amp;&amp; (factor &lt;= 1.));
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   START_LOG(<span class="stringliteral">&quot;distort()&quot;</span>, <span class="stringliteral">&quot;MeshTools::Modification&quot;</span>);
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">// First find nodes on the boundary and flag them</span>
<a name="l00060"></a>00060   <span class="comment">// so that we don&#39;t move them</span>
<a name="l00061"></a>00061   <span class="comment">// on_boundary holds false (not on boundary) and true (on boundary)</span>
<a name="l00062"></a>00062   std::vector&lt;bool&gt; on_boundary (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(), <span class="keyword">false</span>);
<a name="l00063"></a>00063   
<a name="l00064"></a>00064   <span class="keywordflow">if</span> (!perturb_boundary) <a class="code" href="namespacelibMesh_1_1MeshTools.php#a0fd39d630f54c93571ee6449e8b15550">MeshTools::find_boundary_nodes</a> (mesh, on_boundary);
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">// Now calculate the minimum distance to</span>
<a name="l00067"></a>00067   <span class="comment">// neighboring nodes for each node.</span>
<a name="l00068"></a>00068   <span class="comment">// hmin holds these distances.</span>
<a name="l00069"></a>00069   std::vector&lt;float&gt; hmin (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(), 1.e20);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00072"></a>00072   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00075"></a>00075     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*el)-&gt;n_nodes(); n++)
<a name="l00076"></a>00076       hmin[(*el)-&gt;node(n)] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(hmin[(*el)-&gt;node(n)],
<a name="l00077"></a>00077                                       <span class="keyword">static_cast&lt;</span><span class="keywordtype">float</span><span class="keyword">&gt;</span>((*el)-&gt;hmin()));
<a name="l00078"></a>00078   
<a name="l00079"></a>00079   
<a name="l00080"></a>00080   <span class="comment">// Now actually move the nodes</span>
<a name="l00081"></a>00081   {
<a name="l00082"></a>00082     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> seed = 123456;
<a name="l00083"></a>00083     
<a name="l00084"></a>00084     <span class="comment">// seed the random number generator</span>
<a name="l00085"></a>00085     std::srand(seed);
<a name="l00086"></a>00086     
<a name="l00087"></a>00087     <span class="comment">// If the node is on the boundary or</span>
<a name="l00088"></a>00088     <span class="comment">// the node is not used by any element (hmin[n]&lt;1.e20)</span>
<a name="l00089"></a>00089     <span class="comment">// then we should not move it.</span>
<a name="l00090"></a>00090     <span class="comment">// [Note: Testing for (in)equality might be wrong</span>
<a name="l00091"></a>00091     <span class="comment">// (different types, namely float and double)]</span>
<a name="l00092"></a>00092     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); n++)
<a name="l00093"></a>00093       <span class="keywordflow">if</span> (!on_boundary[n] &amp;&amp; (hmin[n] &lt; 1.e20) )
<a name="l00094"></a>00094         {
<a name="l00095"></a>00095           <span class="comment">// the direction, random but unit normalized</span>
<a name="l00096"></a>00096           
<a name="l00097"></a>00097           <a class="code" href="classlibMesh_1_1Point.php">Point</a> dir( static_cast&lt;Real&gt;(std::rand())/static_cast&lt;Real&gt;(RAND_MAX),
<a name="l00098"></a>00098                      (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() &gt; 1) ?
<a name="l00099"></a>00099                      static_cast&lt;Real&gt;(std::rand())/static_cast&lt;Real&gt;(RAND_MAX)
<a name="l00100"></a>00100                      : 0.,
<a name="l00101"></a>00101                      ((mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() == 3) ?
<a name="l00102"></a>00102                       static_cast&lt;Real&gt;(std::rand())/static_cast&lt;Real&gt;(RAND_MAX)
<a name="l00103"></a>00103                       : 0.)
<a name="l00104"></a>00104                      );
<a name="l00105"></a>00105           
<a name="l00106"></a>00106           dir(0) = (dir(0)-.5)*2.;
<a name="l00107"></a>00107           <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() &gt; 1)
<a name="l00108"></a>00108             dir(1) = (dir(1)-.5)*2.;
<a name="l00109"></a>00109           <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() == 3)
<a name="l00110"></a>00110             dir(2) = (dir(2)-.5)*2.;
<a name="l00111"></a>00111           
<a name="l00112"></a>00112           dir = dir.<a class="code" href="classlibMesh_1_1TypeVector.php#af309ac3227a31641f8e8ecbe9bb972a5">unit</a>();
<a name="l00113"></a>00113 
<a name="l00114"></a>00114           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(n)(0) += dir(0)*factor*hmin[n];
<a name="l00115"></a>00115           <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() &gt; 1)
<a name="l00116"></a>00116             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(n)(1) += dir(1)*factor*hmin[n];
<a name="l00117"></a>00117           <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() == 3)
<a name="l00118"></a>00118             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(n)(2) += dir(2)*factor*hmin[n];
<a name="l00119"></a>00119         }
<a name="l00120"></a>00120   }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123   <span class="comment">// All done  </span>
<a name="l00124"></a>00124   STOP_LOG(<span class="stringliteral">&quot;distort()&quot;</span>, <span class="stringliteral">&quot;MeshTools::Modification&quot;</span>);
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#add16d717dcc51dfd7d2bf671fe8e811b">00129</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#add16d717dcc51dfd7d2bf671fe8e811b">MeshTools::Modification::translate</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00130"></a>00130                                          <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xt,
<a name="l00131"></a>00131                                          <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yt,
<a name="l00132"></a>00132                                          <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zt)
<a name="l00133"></a>00133 {
<a name="l00134"></a>00134   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> p(xt, yt, zt);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); n++)
<a name="l00137"></a>00137     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(n) += p;
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="comment">// void MeshTools::Modification::rotate2D (MeshBase&amp; mesh,</span>
<a name="l00142"></a>00142 <span class="comment">//                                         const Real alpha)</span>
<a name="l00143"></a>00143 <span class="comment">// {</span>
<a name="l00144"></a>00144 <span class="comment">//   libmesh_assert (mesh.mesh_dimension() != 1);</span>
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="comment">//   const Real pi = std::acos(-1);</span>
<a name="l00147"></a>00147 <span class="comment">//   const Real  a = alpha/180.*pi;</span>
<a name="l00148"></a>00148 <span class="comment">//   for (unsigned int n=0; n&lt;mesh.n_nodes(); n++)</span>
<a name="l00149"></a>00149 <span class="comment">//     {</span>
<a name="l00150"></a>00150 <span class="comment">//       const Point p = mesh.node(n);</span>
<a name="l00151"></a>00151 <span class="comment">//       const Real  x = p(0);</span>
<a name="l00152"></a>00152 <span class="comment">//       const Real  y = p(1);</span>
<a name="l00153"></a>00153 <span class="comment">//       const Real  z = p(2);</span>
<a name="l00154"></a>00154 <span class="comment">//       mesh.node(n) = Point(std::cos(a)*x - std::sin(a)*y,</span>
<a name="l00155"></a>00155 <span class="comment">//                            std::sin(a)*x + std::cos(a)*y,</span>
<a name="l00156"></a>00156 <span class="comment">//                            z);</span>
<a name="l00157"></a>00157 <span class="comment">//     }</span>
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 <span class="comment">// }</span>
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#ad1b9487f3155857fbc4c4201a748bc09">00163</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#ad1b9487f3155857fbc4c4201a748bc09">MeshTools::Modification::rotate</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00164"></a>00164                                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> phi,
<a name="l00165"></a>00165                                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta,
<a name="l00166"></a>00166                                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> psi)
<a name="l00167"></a>00167 {
<a name="l00168"></a>00168   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() != 1);
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a> = std::acos(-1.);
<a name="l00171"></a>00171   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  p = -phi/180.*<a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a>;
<a name="l00172"></a>00172   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  t = -theta/180.*<a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a>;
<a name="l00173"></a>00173   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  s = -psi/180.*<a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">pi</a>;
<a name="l00174"></a>00174   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sp = std::sin(p), cp = std::cos(p);
<a name="l00175"></a>00175   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> st = std::sin(t), ct = std::cos(t);
<a name="l00176"></a>00176   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ss = std::sin(s), cs = std::cos(s);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="comment">// We follow the convention described at http://mathworld.wolfram.com/EulerAngles.html</span>
<a name="l00179"></a>00179   <span class="comment">// (equations 6-14 give the entries of the composite transformation matrix).</span>
<a name="l00180"></a>00180   <span class="comment">// The rotations are performed sequentially about the z, x, and z axes, in that order.</span>
<a name="l00181"></a>00181   <span class="comment">// A positive angle yields a counter-clockwise rotation about the axis in question.</span>
<a name="l00182"></a>00182   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); n++)
<a name="l00183"></a>00183     {
<a name="l00184"></a>00184       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> p = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(n);
<a name="l00185"></a>00185       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  x = p(0);
<a name="l00186"></a>00186       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  y = p(1);
<a name="l00187"></a>00187       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  z = p(2);
<a name="l00188"></a>00188       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(n) = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(( cp*cs-sp*ct*ss)*x + ( sp*cs+cp*ct*ss)*y + (st*ss)*z,
<a name="l00189"></a>00189                            (-cp*ss-sp*ct*cs)*x + (-sp*ss+cp*ct*cs)*y + (st*cs)*z,
<a name="l00190"></a>00190                            ( sp*st)*x          + (-cp*st)*y          + (ct)*z   );
<a name="l00191"></a>00191     }
<a name="l00192"></a>00192 }
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a48c03ebd8ce97c6c8aef8e2a05a94a16">00195</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a48c03ebd8ce97c6c8aef8e2a05a94a16">MeshTools::Modification::scale</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00196"></a>00196                                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xs,
<a name="l00197"></a>00197                                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ys,
<a name="l00198"></a>00198                                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zs)
<a name="l00199"></a>00199 {
<a name="l00200"></a>00200   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x_scale = xs;
<a name="l00201"></a>00201   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y_scale       = ys;
<a name="l00202"></a>00202   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> z_scale       = zs;
<a name="l00203"></a>00203   
<a name="l00204"></a>00204   <span class="keywordflow">if</span> (ys == 0.)
<a name="l00205"></a>00205     {
<a name="l00206"></a>00206       libmesh_assert (zs == 0.);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208       y_scale = z_scale = x_scale;
<a name="l00209"></a>00209     }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="comment">// Scale the x coordinate in all dimensions</span>
<a name="l00212"></a>00212   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); n++)
<a name="l00213"></a>00213     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(n)(0) *= x_scale;
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216   <span class="comment">// Only scale the y coordinate in 2 and 3D</span>
<a name="l00217"></a>00217   <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">spatial_dimension</a>() &gt; 1)
<a name="l00218"></a>00218     {
<a name="l00219"></a>00219 
<a name="l00220"></a>00220       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); n++)
<a name="l00221"></a>00221         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(n)(1) *= y_scale;
<a name="l00222"></a>00222 
<a name="l00223"></a>00223       <span class="comment">// Only scale the z coordinate in 3D</span>
<a name="l00224"></a>00224       <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">spatial_dimension</a>() == 3)
<a name="l00225"></a>00225         {
<a name="l00226"></a>00226           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); n++)
<a name="l00227"></a>00227             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(n)(2) *= z_scale;
<a name="l00228"></a>00228         }
<a name="l00229"></a>00229     }
<a name="l00230"></a>00230 }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00236"></a>00236 <span class="comment">// UnstructuredMesh class member functions for mesh modification</span>
<a name="l00237"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#ab6de572c3a2499e34361e819c405dedc">00237</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#ab6de572c3a2499e34361e819c405dedc">UnstructuredMesh::all_first_order</a> ()
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239   <span class="comment">/*</span>
<a name="l00240"></a>00240 <span class="comment">   * when the mesh is not prepared,</span>
<a name="l00241"></a>00241 <span class="comment">   * at least renumber the nodes and </span>
<a name="l00242"></a>00242 <span class="comment">   * elements, so that the node ids</span>
<a name="l00243"></a>00243 <span class="comment">   * are correct</span>
<a name="l00244"></a>00244 <span class="comment">   */</span>
<a name="l00245"></a>00245   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a013ceb917534084574aa2e00837331bb">_is_prepared</a>)
<a name="l00246"></a>00246     this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a29fb19d7d0a036669ea088eb3cbc7bb9">renumber_nodes_and_elements</a> ();
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   START_LOG(<span class="stringliteral">&quot;all_first_order()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00249"></a>00249 
<a name="l00253"></a>00253   std::vector&lt;bool&gt; node_touched_by_me(this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a9778fcd4d5fc7687babdf9a5ea56d882">max_node_id</a>(), <span class="keyword">false</span>);
<a name="l00254"></a>00254 
<a name="l00260"></a>00260   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> endit = <a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00261"></a>00261   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> it = <a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00262"></a>00262        it != endit; ++it)
<a name="l00263"></a>00263     {
<a name="l00264"></a>00264       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* so_elem = *it;
<a name="l00265"></a>00265 
<a name="l00266"></a>00266       libmesh_assert (so_elem != NULL);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268       <span class="comment">/*</span>
<a name="l00269"></a>00269 <span class="comment">       * build the first-order equivalent, add to</span>
<a name="l00270"></a>00270 <span class="comment">       * the new_elements list.</span>
<a name="l00271"></a>00271 <span class="comment">       */</span>
<a name="l00272"></a>00272       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* lo_elem = <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a>
<a name="l00273"></a>00273         (<a class="code" href="classlibMesh_1_1Elem.php#a6c2704fb0b2d715cb19bb2a4f517b0f3">Elem::first_order_equivalent_type</a>
<a name="l00274"></a>00274           (so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>()), so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()).release();
<a name="l00275"></a>00275 
<a name="l00276"></a>00276       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s != so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); ++s)
<a name="l00277"></a>00277         <span class="keywordflow">if</span> (so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00278"></a>00278           lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a40980d9226643eb7dfd86b1c150c888e">set_neighbor</a>(s, const_cast&lt;RemoteElem*&gt;(<a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>));
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00281"></a>00281 <span class="preprocessor"></span>      <span class="comment">/*</span>
<a name="l00282"></a>00282 <span class="comment">       * Reset the parent links of any child elements</span>
<a name="l00283"></a>00283 <span class="comment">       */</span>
<a name="l00284"></a>00284       <span class="keywordflow">if</span> (so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>())
<a name="l00285"></a>00285         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l00286"></a>00286           {
<a name="l00287"></a>00287             so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa4496b9addd808d8c1fa2074e1a8cc4f">set_parent</a>(lo_elem);
<a name="l00288"></a>00288             lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab112c6162e29ef805534c3746b3f3657">add_child</a>(so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c), c);
<a name="l00289"></a>00289           }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291       <span class="comment">/*</span>
<a name="l00292"></a>00292 <span class="comment">       * Reset the child link of any parent element</span>
<a name="l00293"></a>00293 <span class="comment">       */</span>
<a name="l00294"></a>00294       <span class="keywordflow">if</span> (so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>())
<a name="l00295"></a>00295         {
<a name="l00296"></a>00296           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c =
<a name="l00297"></a>00297             so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(so_elem);
<a name="l00298"></a>00298           lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>()-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab1678542219d439b71a02beb477e94ce">replace_child</a>(lo_elem, c);
<a name="l00299"></a>00299         }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301       <span class="comment">/*</span>
<a name="l00302"></a>00302 <span class="comment">       * Copy as much data to the new element as makes sense</span>
<a name="l00303"></a>00303 <span class="comment">       */</span>
<a name="l00304"></a>00304       lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#af1f504a628c96ad2d9e49cff16d69bca">set_p_level</a>(so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00305"></a>00305       lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>());
<a name="l00306"></a>00306       lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>());
<a name="l00307"></a>00307 <span class="preprocessor">#endif</span>
<a name="l00308"></a>00308 <span class="preprocessor"></span>
<a name="l00309"></a>00309       libmesh_assert (lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>() == so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>());
<a name="l00310"></a>00310 
<a name="l00311"></a>00311       <span class="comment">/*</span>
<a name="l00312"></a>00312 <span class="comment">       * By definition the vertices of the linear and</span>
<a name="l00313"></a>00313 <span class="comment">       * second order element are identically numbered.</span>
<a name="l00314"></a>00314 <span class="comment">       * transfer these.</span>
<a name="l00315"></a>00315 <span class="comment">       */</span>
<a name="l00316"></a>00316       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v &lt; so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); v++)
<a name="l00317"></a>00317         {
<a name="l00318"></a>00318           lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(v) = so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(v);
<a name="l00319"></a>00319           node_touched_by_me[lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(v)] = <span class="keyword">true</span>;
<a name="l00320"></a>00320         }
<a name="l00321"></a>00321 
<a name="l00328"></a>00328       libmesh_assert (lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>() == so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>());
<a name="l00329"></a>00329         
<a name="l00330"></a>00330       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00331"></a>00331         {
<a name="l00332"></a>00332           <span class="keyword">const</span> std::vector&lt;short int&gt; boundary_ids =
<a name="l00333"></a>00333             this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;raw_boundary_ids (so_elem, s);
<a name="l00334"></a>00334             
<a name="l00335"></a>00335           this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side (lo_elem, s, boundary_ids);
<a name="l00336"></a>00336         }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338       <span class="comment">/*</span>
<a name="l00339"></a>00339 <span class="comment">       * The new first-order element is ready.</span>
<a name="l00340"></a>00340 <span class="comment">       * Inserting it into the mesh will replace and delete</span>
<a name="l00341"></a>00341 <span class="comment">       * the second-order element.</span>
<a name="l00342"></a>00342 <span class="comment">       */</span>
<a name="l00343"></a>00343       lo_elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>(so_elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00344"></a>00344       lo_elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = so_elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00345"></a>00345       lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = so_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l00346"></a>00346       this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a087c31798cb9d6302d8a579e9b458713">insert_elem</a>(lo_elem);
<a name="l00347"></a>00347     }
<a name="l00348"></a>00348 
<a name="l00349"></a>00349   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> nd_end = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00350"></a>00350   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> nd = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00351"></a>00351     <span class="keywordflow">while</span> (nd != nd_end)
<a name="l00352"></a>00352     {
<a name="l00353"></a>00353       <a class="code" href="classlibMesh_1_1Node.php">Node</a> *<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a> = *nd;
<a name="l00354"></a>00354       ++nd;
<a name="l00355"></a>00355       <span class="keywordflow">if</span> (!node_touched_by_me[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()])
<a name="l00356"></a>00356         this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a32f377b1687ed195cf7d1683c4b880e0">delete_node</a>(node);
<a name="l00357"></a>00357     }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   STOP_LOG(<span class="stringliteral">&quot;all_first_order()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 <span class="comment">// On hanging nodes that used to also be second order nodes, we might</span>
<a name="l00362"></a>00362 <span class="comment">// now have an invalid nodal processor_id()</span>
<a name="l00363"></a>00363   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a0e898a7c74ad9552269753ee54e52b45">unpartitioned_elements_begin</a>() != this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ace9f5d288950516202e18c42a0552b0f">unpartitioned_elements_end</a>())
<a name="l00364"></a>00364     <a class="code" href="classlibMesh_1_1Partitioner.php#accc819bc421fd8e50323b46f9762c714">Partitioner::set_node_processor_ids</a>(*<span class="keyword">this</span>);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366   <span class="comment">// delete or renumber nodes, etc</span>
<a name="l00367"></a>00367   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a>(<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);
<a name="l00368"></a>00368 }
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a><a class="code" href="classlibMesh_1_1UnstructuredMesh.php#adf74c2d3201889fe61af362800538680">00372</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php#adf74c2d3201889fe61af362800538680">UnstructuredMesh::all_second_order</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> full_ordered)
<a name="l00373"></a>00373 {
<a name="l00374"></a>00374   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00375"></a>00375   parallel_only();
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   <span class="comment">/*</span>
<a name="l00378"></a>00378 <span class="comment">   * when the mesh is not prepared,</span>
<a name="l00379"></a>00379 <span class="comment">   * at least renumber the nodes and </span>
<a name="l00380"></a>00380 <span class="comment">   * elements, so that the node ids</span>
<a name="l00381"></a>00381 <span class="comment">   * are correct</span>
<a name="l00382"></a>00382 <span class="comment">   */</span>
<a name="l00383"></a>00383   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a013ceb917534084574aa2e00837331bb">_is_prepared</a>)
<a name="l00384"></a>00384     this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a29fb19d7d0a036669ea088eb3cbc7bb9">renumber_nodes_and_elements</a> ();
<a name="l00385"></a>00385 
<a name="l00386"></a>00386   <span class="comment">/*</span>
<a name="l00387"></a>00387 <span class="comment">   * If the mesh is empty</span>
<a name="l00388"></a>00388 <span class="comment">   * then we have nothing to do</span>
<a name="l00389"></a>00389 <span class="comment">   */</span>
<a name="l00390"></a>00390   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>())
<a name="l00391"></a>00391     <span class="keywordflow">return</span>;
<a name="l00392"></a>00392  
<a name="l00393"></a>00393   <span class="comment">/*</span>
<a name="l00394"></a>00394 <span class="comment">   * If the mesh is already second order</span>
<a name="l00395"></a>00395 <span class="comment">   * then we have nothing to do.</span>
<a name="l00396"></a>00396 <span class="comment">   * We have to test for this in a round-about way to avoid</span>
<a name="l00397"></a>00397 <span class="comment">   * a bug on distributed parallel meshes with more processors</span>
<a name="l00398"></a>00398 <span class="comment">   * than elements.</span>
<a name="l00399"></a>00399 <span class="comment">   */</span>
<a name="l00400"></a>00400   <span class="keywordtype">bool</span> already_second_order = <span class="keyword">false</span>;
<a name="l00401"></a>00401   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>() != this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>() &amp;&amp;
<a name="l00402"></a>00402       (*(this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>()))-&gt;default_order() != <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>)
<a name="l00403"></a>00403     already_second_order = <span class="keyword">true</span>;
<a name="l00404"></a>00404   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(already_second_order);
<a name="l00405"></a>00405   <span class="keywordflow">if</span> (already_second_order)
<a name="l00406"></a>00406     <span class="keywordflow">return</span>;
<a name="l00407"></a>00407 
<a name="l00408"></a>00408   START_LOG(<span class="stringliteral">&quot;all_second_order()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="comment">/*</span>
<a name="l00411"></a>00411 <span class="comment">   * this map helps in identifying second order</span>
<a name="l00412"></a>00412 <span class="comment">   * nodes.  Namely, a second-order node:</span>
<a name="l00413"></a>00413 <span class="comment">   * - edge node</span>
<a name="l00414"></a>00414 <span class="comment">   * - face node</span>
<a name="l00415"></a>00415 <span class="comment">   * - bubble node</span>
<a name="l00416"></a>00416 <span class="comment">   * is uniquely defined through a set of adjacent</span>
<a name="l00417"></a>00417 <span class="comment">   * vertices.  This set of adjacent vertices is</span>
<a name="l00418"></a>00418 <span class="comment">   * used to identify already added higher-order</span>
<a name="l00419"></a>00419 <span class="comment">   * nodes.  We are safe to use node id&#39;s since we</span>
<a name="l00420"></a>00420 <span class="comment">   * make sure that these are correctly numbered.</span>
<a name="l00421"></a>00421 <span class="comment">   */</span>
<a name="l00422"></a>00422   std::map&lt;std::vector&lt;unsigned int&gt;, <a class="code" href="classlibMesh_1_1Node.php">Node</a>*&gt; adj_vertices_to_so_nodes;
<a name="l00423"></a>00423 
<a name="l00424"></a>00424   <span class="comment">/*</span>
<a name="l00425"></a>00425 <span class="comment">   * for speed-up of the \p add_point() method, we</span>
<a name="l00426"></a>00426 <span class="comment">   * can reserve memory.  Guess the number of additional</span>
<a name="l00427"></a>00427 <span class="comment">   * nodes for different dimensions</span>
<a name="l00428"></a>00428 <span class="comment">   */</span>
<a name="l00429"></a>00429   <span class="keywordflow">switch</span> (this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>())
<a name="l00430"></a>00430   {
<a name="l00431"></a>00431     <span class="keywordflow">case</span> 1:
<a name="l00432"></a>00432       <span class="comment">/*</span>
<a name="l00433"></a>00433 <span class="comment">       * in 1D, there can only be order-increase from Edge2</span>
<a name="l00434"></a>00434 <span class="comment">       * to Edge3.  Something like 1/2 of n_nodes() have</span>
<a name="l00435"></a>00435 <span class="comment">       * to be added</span>
<a name="l00436"></a>00436 <span class="comment">       */</span>
<a name="l00437"></a>00437       this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>(static_cast&lt;unsigned int&gt;(1.5*this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>()));
<a name="l00438"></a>00438       <span class="keywordflow">break</span>;
<a name="l00439"></a>00439 
<a name="l00440"></a>00440     <span class="keywordflow">case</span> 2:
<a name="l00441"></a>00441       <span class="comment">/*</span>
<a name="l00442"></a>00442 <span class="comment">       * in 2D, either refine from Tri3 to Tri6 (double the nodes)</span>
<a name="l00443"></a>00443 <span class="comment">       * or from Quad4 to Quad8 (again, double) or Quad9 (2.25 that much)</span>
<a name="l00444"></a>00444 <span class="comment">       */</span>
<a name="l00445"></a>00445       this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>(static_cast&lt;unsigned int&gt;(2*this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>()));
<a name="l00446"></a>00446       <span class="keywordflow">break</span>;
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449     <span class="keywordflow">case</span> 3:
<a name="l00450"></a>00450       <span class="comment">/*</span>
<a name="l00451"></a>00451 <span class="comment">       * in 3D, either refine from Tet4 to Tet10 (factor = 2.5) up to</span>
<a name="l00452"></a>00452 <span class="comment">       * Hex8 to Hex27 (something  &gt; 3).  Since in 3D there _are_ already</span>
<a name="l00453"></a>00453 <span class="comment">       * quite some nodes, and since we do not want to overburden the memory by</span>
<a name="l00454"></a>00454 <span class="comment">       * a too conservative guess, use the lower bound</span>
<a name="l00455"></a>00455 <span class="comment">       */</span>
<a name="l00456"></a>00456       this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a722dd88d208fbb89fa685118a46d6773">reserve_nodes</a>(static_cast&lt;unsigned int&gt;(2.5*this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>()));
<a name="l00457"></a>00457       <span class="keywordflow">break</span>;
<a name="l00458"></a>00458         
<a name="l00459"></a>00459     <span class="keywordflow">default</span>:
<a name="l00460"></a>00460       <span class="comment">// Hm?</span>
<a name="l00461"></a>00461       libmesh_error();
<a name="l00462"></a>00462   }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a>00466   <span class="comment">/*</span>
<a name="l00467"></a>00467 <span class="comment">   * form a vector that will hold the node id&#39;s of</span>
<a name="l00468"></a>00468 <span class="comment">   * the vertices that are adjacent to the son-th</span>
<a name="l00469"></a>00469 <span class="comment">   * second-order node.  Pull this outside of the</span>
<a name="l00470"></a>00470 <span class="comment">   * loop so that silly compilers don&#39;t repeatedly</span>
<a name="l00471"></a>00471 <span class="comment">   * create and destroy the vector.</span>
<a name="l00472"></a>00472 <span class="comment">   */</span>
<a name="l00473"></a>00473   std::vector&lt;unsigned int&gt; adjacent_vertices_ids;
<a name="l00474"></a>00474 
<a name="l00481"></a>00481   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> endit = <a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00482"></a>00482   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">const_element_iterator</a> it = <a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00483"></a>00483        it != endit; ++it)
<a name="l00484"></a>00484     {
<a name="l00485"></a>00485       <span class="comment">// the linear-order element</span>
<a name="l00486"></a>00486       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* lo_elem = *it;
<a name="l00487"></a>00487 
<a name="l00488"></a>00488       libmesh_assert (lo_elem != NULL);
<a name="l00489"></a>00489 
<a name="l00490"></a>00490       <span class="comment">// make sure it is linear order</span>
<a name="l00491"></a>00491       <span class="keywordflow">if</span> (lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a68d37810df08b5e3357d1f0f229a0759">default_order</a>() != <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>)
<a name="l00492"></a>00492         {         
<a name="l00493"></a>00493           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: This is not a linear element: type=&quot;</span> 
<a name="l00494"></a>00494                         &lt;&lt; lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() &lt;&lt; std::endl;
<a name="l00495"></a>00495           libmesh_error();
<a name="l00496"></a>00496         }
<a name="l00497"></a>00497 
<a name="l00498"></a>00498       <span class="comment">// this does _not_ work for refined elements</span>
<a name="l00499"></a>00499       libmesh_assert (lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a> () == 0);
<a name="l00500"></a>00500 
<a name="l00501"></a>00501       <span class="comment">/*</span>
<a name="l00502"></a>00502 <span class="comment">       * build the second-order equivalent, add to</span>
<a name="l00503"></a>00503 <span class="comment">       * the new_elements list.  Note that this here</span>
<a name="l00504"></a>00504 <span class="comment">       * is the only point where \p full_ordered</span>
<a name="l00505"></a>00505 <span class="comment">       * is necessary.  The remaining code works well</span>
<a name="l00506"></a>00506 <span class="comment">       * for either type of seconrd-order equivalent, e.g.</span>
<a name="l00507"></a>00507 <span class="comment">       * Hex20 or Hex27, as equivalents for Hex8</span>
<a name="l00508"></a>00508 <span class="comment">       */</span>
<a name="l00509"></a>00509       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* so_elem = 
<a name="l00510"></a>00510         <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a> (<a class="code" href="classlibMesh_1_1Elem.php#a877984e054cff62d2205a2a6c57cde0a">Elem::second_order_equivalent_type</a>(lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>(), 
<a name="l00511"></a>00511                                                         full_ordered) ).<a class="code" href="classlibMesh_1_1AutoPtr.php#a9aac56a85f0e34e52bd3ebf05f244526" title="Bypassing the smart pointer.">release</a>();
<a name="l00512"></a>00512 
<a name="l00513"></a>00513       libmesh_assert (lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>() == so_elem-&gt;n_vertices());
<a name="l00514"></a>00514 
<a name="l00515"></a>00515 
<a name="l00516"></a>00516       <span class="comment">/*</span>
<a name="l00517"></a>00517 <span class="comment">       * By definition the vertices of the linear and</span>
<a name="l00518"></a>00518 <span class="comment">       * second order element are identically numbered.</span>
<a name="l00519"></a>00519 <span class="comment">       * transfer these.</span>
<a name="l00520"></a>00520 <span class="comment">       */</span>
<a name="l00521"></a>00521       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v &lt; lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>(); v++)
<a name="l00522"></a>00522         so_elem-&gt;set_node(v) = lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(v);
<a name="l00523"></a>00523 
<a name="l00524"></a>00524       <span class="comment">/*</span>
<a name="l00525"></a>00525 <span class="comment">       * Now handle the additional mid-side nodes.  This</span>
<a name="l00526"></a>00526 <span class="comment">       * is simply handled through a map that remembers</span>
<a name="l00527"></a>00527 <span class="comment">       * the already-added nodes.  This map maps the global</span>
<a name="l00528"></a>00528 <span class="comment">       * ids of the vertices (that uniquely define this </span>
<a name="l00529"></a>00529 <span class="comment">       * higher-order node) to the new node. </span>
<a name="l00530"></a>00530 <span class="comment">       * Notation: son = second-order node</span>
<a name="l00531"></a>00531 <span class="comment">       */</span>
<a name="l00532"></a>00532       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_begin = so_elem-&gt;n_vertices();
<a name="l00533"></a>00533       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_end   = so_elem-&gt;n_nodes();
<a name="l00534"></a>00534       
<a name="l00535"></a>00535 
<a name="l00536"></a>00536       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son=son_begin; son&lt;son_end; son++)
<a name="l00537"></a>00537         {
<a name="l00538"></a>00538           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_adjacent_vertices =
<a name="l00539"></a>00539             so_elem-&gt;n_second_order_adjacent_vertices(son);
<a name="l00540"></a>00540 
<a name="l00541"></a>00541           adjacent_vertices_ids.resize(n_adjacent_vertices);
<a name="l00542"></a>00542           
<a name="l00543"></a>00543           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_adjacent_vertices; v++)
<a name="l00544"></a>00544             adjacent_vertices_ids[v] =
<a name="l00545"></a>00545               so_elem-&gt;node( so_elem-&gt;second_order_adjacent_vertex(son,v) );
<a name="l00546"></a>00546 
<a name="l00547"></a>00547           <span class="comment">/*</span>
<a name="l00548"></a>00548 <span class="comment">           * \p adjacent_vertices_ids is now in order of the current</span>
<a name="l00549"></a>00549 <span class="comment">           * side.  sort it, so that comparisons  with the </span>
<a name="l00550"></a>00550 <span class="comment">           * \p adjacent_vertices_ids created through other elements&#39; </span>
<a name="l00551"></a>00551 <span class="comment">           * sides can match</span>
<a name="l00552"></a>00552 <span class="comment">           */</span>
<a name="l00553"></a>00553           std::sort(adjacent_vertices_ids.begin(),
<a name="l00554"></a>00554                     adjacent_vertices_ids.end());
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 
<a name="l00557"></a>00557           <span class="comment">// does this set of vertices already has a mid-node added?</span>
<a name="l00558"></a>00558           std::pair&lt;std::map&lt;std::vector&lt;unsigned int&gt;, <a class="code" href="classlibMesh_1_1Node.php">Node</a>*&gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>,
<a name="l00559"></a>00559                     std::map&lt;std::vector&lt;unsigned int&gt;, <a class="code" href="classlibMesh_1_1Node.php">Node</a>*&gt;::iterator&gt;           
<a name="l00560"></a>00560             pos = adj_vertices_to_so_nodes.equal_range (adjacent_vertices_ids);
<a name="l00561"></a>00561 
<a name="l00562"></a>00562           <span class="comment">// no, not added yet</span>
<a name="l00563"></a>00563           <span class="keywordflow">if</span> (pos.first == pos.second)
<a name="l00564"></a>00564             {
<a name="l00565"></a>00565               <span class="comment">/*</span>
<a name="l00566"></a>00566 <span class="comment">               * for this set of vertices, there is no </span>
<a name="l00567"></a>00567 <span class="comment">               * second_order node yet.  Add it.</span>
<a name="l00568"></a>00568 <span class="comment">               *</span>
<a name="l00569"></a>00569 <span class="comment">               * compute the location of the new node as</span>
<a name="l00570"></a>00570 <span class="comment">               * the average over the adjacent vertices.</span>
<a name="l00571"></a>00571 <span class="comment">               */</span>
<a name="l00572"></a>00572               <a class="code" href="classlibMesh_1_1Point.php">Point</a> new_location = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(adjacent_vertices_ids[0]);
<a name="l00573"></a>00573               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=1; v&lt;n_adjacent_vertices; v++)
<a name="l00574"></a>00574                 new_location += this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(adjacent_vertices_ids[v]);
<a name="l00575"></a>00575 
<a name="l00576"></a>00576               new_location /= <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(n_adjacent_vertices);
<a name="l00577"></a>00577               
<a name="l00578"></a>00578               <span class="comment">/* Add the new point to the mesh, giving it a globally</span>
<a name="l00579"></a>00579 <span class="comment">               * well-defined processor id.</span>
<a name="l00580"></a>00580 <span class="comment">               */</span>
<a name="l00581"></a>00581               <a class="code" href="classlibMesh_1_1Node.php">Node</a>* so_node = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a>
<a name="l00582"></a>00582                 (new_location, <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>,
<a name="l00583"></a>00583                 this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(adjacent_vertices_ids[0]).<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">processor_id</a>());
<a name="l00584"></a>00584 
<a name="l00585"></a>00585               <span class="comment">/* </span>
<a name="l00586"></a>00586 <span class="comment">               * insert the new node with its defining vertex</span>
<a name="l00587"></a>00587 <span class="comment">               * set into the map, and relocate pos to this</span>
<a name="l00588"></a>00588 <span class="comment">               * new entry, so that the so_elem can use</span>
<a name="l00589"></a>00589 <span class="comment">               * \p pos for inserting the node</span>
<a name="l00590"></a>00590 <span class="comment">               */</span>
<a name="l00591"></a>00591               adj_vertices_to_so_nodes.insert(pos.first,
<a name="l00592"></a>00592                                               std::make_pair(adjacent_vertices_ids,
<a name="l00593"></a>00593                                                              so_node));
<a name="l00594"></a>00594 
<a name="l00595"></a>00595               so_elem-&gt;set_node(son) = so_node;
<a name="l00596"></a>00596             }
<a name="l00597"></a>00597           <span class="comment">// yes, already added.</span>
<a name="l00598"></a>00598           <span class="keywordflow">else</span>
<a name="l00599"></a>00599             {
<a name="l00600"></a>00600               libmesh_assert (pos.first-&gt;second != NULL);
<a name="l00601"></a>00601               
<a name="l00602"></a>00602               so_elem-&gt;set_node(son) = pos.first-&gt;second;
<a name="l00603"></a>00603             }
<a name="l00604"></a>00604         }
<a name="l00605"></a>00605 
<a name="l00606"></a>00606 
<a name="l00613"></a>00613       libmesh_assert (lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>() == so_elem-&gt;n_sides());
<a name="l00614"></a>00614         
<a name="l00615"></a>00615       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00616"></a>00616         {
<a name="l00617"></a>00617           <span class="keyword">const</span> std::vector&lt;short int&gt; boundary_ids =
<a name="l00618"></a>00618             this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;raw_boundary_ids (lo_elem, s);
<a name="l00619"></a>00619             
<a name="l00620"></a>00620           this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side (so_elem, s, boundary_ids);
<a name="l00621"></a>00621         }
<a name="l00622"></a>00622 
<a name="l00623"></a>00623       <span class="comment">/*</span>
<a name="l00624"></a>00624 <span class="comment">       * The new second-order element is ready.</span>
<a name="l00625"></a>00625 <span class="comment">       * Inserting it into the mesh will replace and delete</span>
<a name="l00626"></a>00626 <span class="comment">       * the first-order element.</span>
<a name="l00627"></a>00627 <span class="comment">       */</span>
<a name="l00628"></a>00628       so_elem-&gt;set_id(lo_elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00629"></a>00629       so_elem-&gt;processor_id() = lo_elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00630"></a>00630       so_elem-&gt;subdomain_id() = lo_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l00631"></a>00631       this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a087c31798cb9d6302d8a579e9b458713">insert_elem</a>(so_elem);
<a name="l00632"></a>00632     }
<a name="l00633"></a>00633 
<a name="l00634"></a>00634   <span class="comment">// we can clear the map</span>
<a name="l00635"></a>00635   adj_vertices_to_so_nodes.clear();
<a name="l00636"></a>00636 
<a name="l00637"></a>00637 
<a name="l00638"></a>00638   STOP_LOG(<span class="stringliteral">&quot;all_second_order()&quot;</span>, <span class="stringliteral">&quot;Mesh&quot;</span>);
<a name="l00639"></a>00639 
<a name="l00640"></a>00640   <span class="comment">// In a ParallelMesh our ghost node processor ids may be bad and</span>
<a name="l00641"></a>00641   <span class="comment">// the ids of nodes touching remote elements may be inconsistent.</span>
<a name="l00642"></a>00642   <span class="comment">// Fix them.</span>
<a name="l00643"></a>00643   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00644"></a>00644     {
<a name="l00645"></a>00645       <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a> loc_map;
<a name="l00646"></a>00646       <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#a4267fefd3ddfeead0f25be8fb9918af8">make_nodes_parallel_consistent</a>
<a name="l00647"></a>00647         (*<span class="keyword">this</span>, loc_map);
<a name="l00648"></a>00648     }
<a name="l00649"></a>00649 
<a name="l00650"></a>00650   <span class="comment">// renumber nodes, elements etc</span>
<a name="l00651"></a>00651   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a>(<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);
<a name="l00652"></a>00652 }
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 
<a name="l00655"></a>00655 
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 
<a name="l00658"></a>00658 
<a name="l00659"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a249f04550c345984831d08e013155668">00659</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a249f04550c345984831d08e013155668">MeshTools::Modification::all_tri</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00660"></a>00660 {
<a name="l00661"></a>00661   <span class="comment">// We store pointers to the newly created elements in a vector</span>
<a name="l00662"></a>00662   <span class="comment">// until they are ready to be added to the mesh.  This is because</span>
<a name="l00663"></a>00663   <span class="comment">// adding new elements on the fly can cause reallocation and invalidation</span>
<a name="l00664"></a>00664   <span class="comment">// of existing iterators.</span>
<a name="l00665"></a>00665   std::vector&lt;Elem*&gt; new_elements;
<a name="l00666"></a>00666   new_elements.reserve (2*mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>());
<a name="l00667"></a>00667 
<a name="l00668"></a>00668   <span class="comment">// If the original mesh has boundary data, we carry that over</span>
<a name="l00669"></a>00669   <span class="comment">// to the new mesh with triangular elements.</span>
<a name="l00670"></a>00670   <span class="keyword">const</span> <span class="keywordtype">bool</span> mesh_has_boundary_data = (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;n_boundary_ids() &gt; 0);
<a name="l00671"></a>00671 
<a name="l00672"></a>00672   <span class="comment">// Temporary vectors to store the new boundary element pointers, side numbers, and boundary ids</span>
<a name="l00673"></a>00673   std::vector&lt;Elem*&gt; new_bndry_elements;
<a name="l00674"></a>00674   std::vector&lt;unsigned short int&gt; new_bndry_sides;
<a name="l00675"></a>00675   std::vector&lt;short int&gt; new_bndry_ids;
<a name="l00676"></a>00676   
<a name="l00677"></a>00677   <span class="comment">// Iterate over the elements, splitting QUADS into</span>
<a name="l00678"></a>00678   <span class="comment">// pairs of conforming triangles.</span>
<a name="l00679"></a>00679   {
<a name="l00680"></a>00680     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00681"></a>00681     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683     <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00684"></a>00684       {
<a name="l00685"></a>00685         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> etype = (*el)-&gt;type();
<a name="l00686"></a>00686 
<a name="l00687"></a>00687         <span class="comment">// all_tri currently only works on coarse meshes</span>
<a name="l00688"></a>00688         libmesh_assert ((*el)-&gt;parent() == NULL);
<a name="l00689"></a>00689 
<a name="l00690"></a>00690         <span class="comment">// We split the quads using the shorter of the two diagonals</span>
<a name="l00691"></a>00691         <span class="comment">// to maintain the best angle properties.</span>
<a name="l00692"></a>00692         <span class="keywordtype">bool</span> edge_swap = <span class="keyword">false</span>;
<a name="l00693"></a>00693 
<a name="l00694"></a>00694         <span class="comment">// True if we actually split the current element.</span>
<a name="l00695"></a>00695         <span class="keywordtype">bool</span> split_elem = <span class="keyword">false</span>;
<a name="l00696"></a>00696 
<a name="l00697"></a>00697         <span class="comment">// The two new triangular elements we will split the quad into.</span>
<a name="l00698"></a>00698         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* tri0 = NULL;
<a name="l00699"></a>00699         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* tri1 = NULL;
<a name="l00700"></a>00700 
<a name="l00701"></a>00701         
<a name="l00702"></a>00702         <span class="keywordflow">switch</span> (etype)
<a name="l00703"></a>00703           {
<a name="l00704"></a>00704           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00705"></a>00705             {
<a name="l00706"></a>00706               split_elem = <span class="keyword">true</span>;
<a name="l00707"></a>00707               
<a name="l00708"></a>00708               tri0 = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>;
<a name="l00709"></a>00709               tri1 = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>;
<a name="l00710"></a>00710               
<a name="l00711"></a>00711               <span class="comment">// Check for possible edge swap</span>
<a name="l00712"></a>00712               <span class="keywordflow">if</span> (((*el)-&gt;point(0) - (*el)-&gt;point(2)).size() &lt;
<a name="l00713"></a>00713                   ((*el)-&gt;point(1) - (*el)-&gt;point(3)).size())
<a name="l00714"></a>00714                 {             
<a name="l00715"></a>00715                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(0);
<a name="l00716"></a>00716                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(1);
<a name="l00717"></a>00717                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(2);
<a name="l00718"></a>00718                 
<a name="l00719"></a>00719                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(0);
<a name="l00720"></a>00720                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(2);
<a name="l00721"></a>00721                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(3);
<a name="l00722"></a>00722                 }
<a name="l00723"></a>00723             
<a name="l00724"></a>00724               <span class="keywordflow">else</span>
<a name="l00725"></a>00725                 {
<a name="l00726"></a>00726                   edge_swap=<span class="keyword">true</span>;
<a name="l00727"></a>00727                   
<a name="l00728"></a>00728                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(0);
<a name="l00729"></a>00729                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(1);
<a name="l00730"></a>00730                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(3);
<a name="l00731"></a>00731                 
<a name="l00732"></a>00732                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(1);
<a name="l00733"></a>00733                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(2);
<a name="l00734"></a>00734                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(3);
<a name="l00735"></a>00735                 }
<a name="l00736"></a>00736 
<a name="l00737"></a>00737               
<a name="l00738"></a>00738               <span class="keywordflow">break</span>;
<a name="l00739"></a>00739             }
<a name="l00740"></a>00740       
<a name="l00741"></a>00741           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00742"></a>00742             {
<a name="l00743"></a>00743               split_elem =  <span class="keyword">true</span>;
<a name="l00744"></a>00744               
<a name="l00745"></a>00745               tri0 = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>;
<a name="l00746"></a>00746               tri1 = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>;
<a name="l00747"></a>00747           
<a name="l00748"></a>00748               <a class="code" href="classlibMesh_1_1Node.php">Node</a>* new_node = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a>((mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>((*el)-&gt;node(0)) +
<a name="l00749"></a>00749                                                mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>((*el)-&gt;node(1)) +
<a name="l00750"></a>00750                                                mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>((*el)-&gt;node(2)) +
<a name="l00751"></a>00751                                                mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>((*el)-&gt;node(3)))/4
<a name="l00752"></a>00752                                                );
<a name="l00753"></a>00753           
<a name="l00754"></a>00754               <span class="comment">// Check for possible edge swap</span>
<a name="l00755"></a>00755               <span class="keywordflow">if</span> (((*el)-&gt;point(0) - (*el)-&gt;point(2)).size() &lt;
<a name="l00756"></a>00756                   ((*el)-&gt;point(1) - (*el)-&gt;point(3)).size())
<a name="l00757"></a>00757                 {             
<a name="l00758"></a>00758                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(0);
<a name="l00759"></a>00759                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(1);
<a name="l00760"></a>00760                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(2);
<a name="l00761"></a>00761                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = (*el)-&gt;get_node(4);
<a name="l00762"></a>00762                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = (*el)-&gt;get_node(5);
<a name="l00763"></a>00763                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = new_node;
<a name="l00764"></a>00764               
<a name="l00765"></a>00765                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(0);
<a name="l00766"></a>00766                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(2);
<a name="l00767"></a>00767                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(3);
<a name="l00768"></a>00768                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = new_node;
<a name="l00769"></a>00769                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = (*el)-&gt;get_node(6);
<a name="l00770"></a>00770                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = (*el)-&gt;get_node(7);
<a name="l00771"></a>00771 
<a name="l00772"></a>00772                 }
<a name="l00773"></a>00773           
<a name="l00774"></a>00774               <span class="keywordflow">else</span>
<a name="l00775"></a>00775                 {
<a name="l00776"></a>00776                   edge_swap=<span class="keyword">true</span>;
<a name="l00777"></a>00777                   
<a name="l00778"></a>00778                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(3);
<a name="l00779"></a>00779                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(0);
<a name="l00780"></a>00780                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(1);
<a name="l00781"></a>00781                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = (*el)-&gt;get_node(7);
<a name="l00782"></a>00782                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = (*el)-&gt;get_node(4);
<a name="l00783"></a>00783                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = new_node;
<a name="l00784"></a>00784               
<a name="l00785"></a>00785                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(1);
<a name="l00786"></a>00786                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(2);
<a name="l00787"></a>00787                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(3);
<a name="l00788"></a>00788                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = (*el)-&gt;get_node(5);
<a name="l00789"></a>00789                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = (*el)-&gt;get_node(6);
<a name="l00790"></a>00790                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = new_node;
<a name="l00791"></a>00791                 }
<a name="l00792"></a>00792           
<a name="l00793"></a>00793               <span class="keywordflow">break</span>;
<a name="l00794"></a>00794             }
<a name="l00795"></a>00795       
<a name="l00796"></a>00796           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00797"></a>00797             {
<a name="l00798"></a>00798               split_elem =  <span class="keyword">true</span>;
<a name="l00799"></a>00799               
<a name="l00800"></a>00800               tri0 = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>;
<a name="l00801"></a>00801               tri1 = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri6.php">Tri6</a>;
<a name="l00802"></a>00802 
<a name="l00803"></a>00803               <span class="comment">// Check for possible edge swap</span>
<a name="l00804"></a>00804               <span class="keywordflow">if</span> (((*el)-&gt;point(0) - (*el)-&gt;point(2)).size() &lt;
<a name="l00805"></a>00805                   ((*el)-&gt;point(1) - (*el)-&gt;point(3)).size())
<a name="l00806"></a>00806                 {             
<a name="l00807"></a>00807                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(0);
<a name="l00808"></a>00808                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(1);
<a name="l00809"></a>00809                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(2);
<a name="l00810"></a>00810                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = (*el)-&gt;get_node(4);
<a name="l00811"></a>00811                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = (*el)-&gt;get_node(5);
<a name="l00812"></a>00812                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = (*el)-&gt;get_node(8);
<a name="l00813"></a>00813               
<a name="l00814"></a>00814                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(0);
<a name="l00815"></a>00815                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(2);
<a name="l00816"></a>00816                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(3);
<a name="l00817"></a>00817                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = (*el)-&gt;get_node(8);
<a name="l00818"></a>00818                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = (*el)-&gt;get_node(6);
<a name="l00819"></a>00819                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = (*el)-&gt;get_node(7);
<a name="l00820"></a>00820                 }
<a name="l00821"></a>00821 
<a name="l00822"></a>00822               <span class="keywordflow">else</span>
<a name="l00823"></a>00823                 {
<a name="l00824"></a>00824                   edge_swap=<span class="keyword">true</span>;
<a name="l00825"></a>00825                   
<a name="l00826"></a>00826                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(0);
<a name="l00827"></a>00827                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(1);
<a name="l00828"></a>00828                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(3);
<a name="l00829"></a>00829                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = (*el)-&gt;get_node(4);
<a name="l00830"></a>00830                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = (*el)-&gt;get_node(8);
<a name="l00831"></a>00831                   tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = (*el)-&gt;get_node(7);
<a name="l00832"></a>00832               
<a name="l00833"></a>00833                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(0) = (*el)-&gt;get_node(1);
<a name="l00834"></a>00834                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(1) = (*el)-&gt;get_node(2);
<a name="l00835"></a>00835                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(2) = (*el)-&gt;get_node(3);
<a name="l00836"></a>00836                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(3) = (*el)-&gt;get_node(5);
<a name="l00837"></a>00837                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(4) = (*el)-&gt;get_node(6);
<a name="l00838"></a>00838                   tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(5) = (*el)-&gt;get_node(8);
<a name="l00839"></a>00839                 }
<a name="l00840"></a>00840             
<a name="l00841"></a>00841               <span class="keywordflow">break</span>;
<a name="l00842"></a>00842             }
<a name="l00843"></a>00843           <span class="comment">// No need to split elements that are already triangles</span>
<a name="l00844"></a>00844           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00845"></a>00845           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00846"></a>00846             <span class="keywordflow">continue</span>;
<a name="l00847"></a>00847           <span class="comment">// Try to ignore non-2D elements for now</span>
<a name="l00848"></a>00848           <span class="keywordflow">default</span>:
<a name="l00849"></a>00849             {
<a name="l00850"></a>00850               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Warning, encountered non-2D element &quot;</span>
<a name="l00851"></a>00851                             &lt;&lt; <a class="code" href="namespacelibMesh_1_1Utility.php#aabd3e802dc167d1ae684b4fc272ffebc">Utility::enum_to_string&lt;ElemType&gt;</a>(etype)
<a name="l00852"></a>00852                             &lt;&lt; <span class="stringliteral">&quot; in MeshTools::Modification::all_tri(), hope that&#39;s OK...&quot;</span>
<a name="l00853"></a>00853                             &lt;&lt; std::endl;
<a name="l00854"></a>00854             }
<a name="l00855"></a>00855           } <span class="comment">// end switch (etype)</span>
<a name="l00856"></a>00856 
<a name="l00857"></a>00857         
<a name="l00858"></a>00858 
<a name="l00859"></a>00859         <span class="keywordflow">if</span> (split_elem)
<a name="l00860"></a>00860           {
<a name="l00861"></a>00861             <span class="comment">// Be sure the correct ID&#39;s are also set for tri0 and</span>
<a name="l00862"></a>00862             <span class="comment">// tri1.</span>
<a name="l00863"></a>00863             tri0-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = (*el)-&gt;processor_id();
<a name="l00864"></a>00864             tri0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = (*el)-&gt;subdomain_id();
<a name="l00865"></a>00865             tri1-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = (*el)-&gt;processor_id();
<a name="l00866"></a>00866             tri1-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = (*el)-&gt;subdomain_id();
<a name="l00867"></a>00867            
<a name="l00868"></a>00868             <span class="keywordflow">if</span> (mesh_has_boundary_data)
<a name="l00869"></a>00869               {
<a name="l00870"></a>00870                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sn=0; sn&lt;(*el)-&gt;n_sides(); ++sn)
<a name="l00871"></a>00871                   {
<a name="l00872"></a>00872                     <span class="keyword">const</span> std::vector&lt;short int&gt;&amp; bc_ids = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_ids(*el, sn);
<a name="l00873"></a>00873                     <span class="keywordflow">for</span> (std::vector&lt;short int&gt;::const_iterator id_it=bc_ids.begin(); id_it!=bc_ids.end(); ++id_it)
<a name="l00874"></a>00874                       {
<a name="l00875"></a>00875                         <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> b_id = *id_it;
<a name="l00876"></a>00876 
<a name="l00877"></a>00877                         <span class="keywordflow">if</span> (b_id != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">BoundaryInfo::invalid_id</a>)
<a name="l00878"></a>00878                           {
<a name="l00879"></a>00879                             <span class="comment">// Add the boundary ID to the list of new boundary ids</span>
<a name="l00880"></a>00880                             new_bndry_ids.push_back(b_id);
<a name="l00881"></a>00881                           
<a name="l00882"></a>00882                             <span class="comment">// Convert the boundary side information of the old element to</span>
<a name="l00883"></a>00883                             <span class="comment">// boundary side information for the new element.</span>
<a name="l00884"></a>00884                             <span class="keywordflow">if</span> (!edge_swap)
<a name="l00885"></a>00885                               {
<a name="l00886"></a>00886                                 <span class="keywordflow">switch</span> (sn)
<a name="l00887"></a>00887                                   {
<a name="l00888"></a>00888                                   <span class="keywordflow">case</span> 0:
<a name="l00889"></a>00889                                     {
<a name="l00890"></a>00890                                       <span class="comment">// New boundary side is Tri 0, side 0</span>
<a name="l00891"></a>00891                                       new_bndry_elements.push_back(tri0);
<a name="l00892"></a>00892                                       new_bndry_sides.push_back(0);
<a name="l00893"></a>00893                                       <span class="keywordflow">break</span>;
<a name="l00894"></a>00894                                     }
<a name="l00895"></a>00895                                   <span class="keywordflow">case</span> 1:
<a name="l00896"></a>00896                                     {
<a name="l00897"></a>00897                                       <span class="comment">// New boundary side is Tri 0, side 1</span>
<a name="l00898"></a>00898                                       new_bndry_elements.push_back(tri0);
<a name="l00899"></a>00899                                       new_bndry_sides.push_back(1);
<a name="l00900"></a>00900                                       <span class="keywordflow">break</span>;
<a name="l00901"></a>00901                                     }
<a name="l00902"></a>00902                                   <span class="keywordflow">case</span> 2:
<a name="l00903"></a>00903                                     {
<a name="l00904"></a>00904                                       <span class="comment">// New boundary side is Tri 1, side 1</span>
<a name="l00905"></a>00905                                       new_bndry_elements.push_back(tri1);
<a name="l00906"></a>00906                                       new_bndry_sides.push_back(1);
<a name="l00907"></a>00907                                       <span class="keywordflow">break</span>;
<a name="l00908"></a>00908                                     }
<a name="l00909"></a>00909                                   <span class="keywordflow">case</span> 3:
<a name="l00910"></a>00910                                     {
<a name="l00911"></a>00911                                       <span class="comment">// New boundary side is Tri 1, side 2</span>
<a name="l00912"></a>00912                                       new_bndry_elements.push_back(tri1);
<a name="l00913"></a>00913                                       new_bndry_sides.push_back(2);
<a name="l00914"></a>00914                                       <span class="keywordflow">break</span>;
<a name="l00915"></a>00915                                     }
<a name="l00916"></a>00916 
<a name="l00917"></a>00917                                   <span class="keywordflow">default</span>:
<a name="l00918"></a>00918                                     {
<a name="l00919"></a>00919                                       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Quad4/8/9 cannot have more than 4 sides.&quot;</span> &lt;&lt; std::endl;
<a name="l00920"></a>00920                                       libmesh_error();
<a name="l00921"></a>00921                                     }
<a name="l00922"></a>00922                                   }
<a name="l00923"></a>00923                               }
<a name="l00924"></a>00924 
<a name="l00925"></a>00925                             <span class="keywordflow">else</span> <span class="comment">// edge_swap==true</span>
<a name="l00926"></a>00926                               {
<a name="l00927"></a>00927                                 <span class="keywordflow">switch</span> (sn)
<a name="l00928"></a>00928                                   {
<a name="l00929"></a>00929                                   <span class="keywordflow">case</span> 0:
<a name="l00930"></a>00930                                     {
<a name="l00931"></a>00931                                       <span class="comment">// New boundary side is Tri 0, side 0</span>
<a name="l00932"></a>00932                                       new_bndry_elements.push_back(tri0);
<a name="l00933"></a>00933                                       new_bndry_sides.push_back(0);
<a name="l00934"></a>00934                                       <span class="keywordflow">break</span>;
<a name="l00935"></a>00935                                     }
<a name="l00936"></a>00936                                   <span class="keywordflow">case</span> 1:
<a name="l00937"></a>00937                                     {
<a name="l00938"></a>00938                                       <span class="comment">// New boundary side is Tri 1, side 0</span>
<a name="l00939"></a>00939                                       new_bndry_elements.push_back(tri1);
<a name="l00940"></a>00940                                       new_bndry_sides.push_back(0);
<a name="l00941"></a>00941                                       <span class="keywordflow">break</span>;
<a name="l00942"></a>00942                                     }
<a name="l00943"></a>00943                                   <span class="keywordflow">case</span> 2:
<a name="l00944"></a>00944                                     {
<a name="l00945"></a>00945                                       <span class="comment">// New boundary side is Tri 1, side 1</span>
<a name="l00946"></a>00946                                       new_bndry_elements.push_back(tri1);
<a name="l00947"></a>00947                                       new_bndry_sides.push_back(1);
<a name="l00948"></a>00948                                       <span class="keywordflow">break</span>;
<a name="l00949"></a>00949                                     }
<a name="l00950"></a>00950                                   <span class="keywordflow">case</span> 3:
<a name="l00951"></a>00951                                     {
<a name="l00952"></a>00952                                       <span class="comment">// New boundary side is Tri 0, side 2</span>
<a name="l00953"></a>00953                                       new_bndry_elements.push_back(tri0);
<a name="l00954"></a>00954                                       new_bndry_sides.push_back(2);
<a name="l00955"></a>00955                                       <span class="keywordflow">break</span>;
<a name="l00956"></a>00956                                     }
<a name="l00957"></a>00957 
<a name="l00958"></a>00958                                   <span class="keywordflow">default</span>:
<a name="l00959"></a>00959                                     {
<a name="l00960"></a>00960                                       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Quad4/8/9 cannot have more than 4 sides.&quot;</span> &lt;&lt; std::endl;
<a name="l00961"></a>00961                                       libmesh_error();
<a name="l00962"></a>00962                                     }
<a name="l00963"></a>00963                                   }
<a name="l00964"></a>00964                               } <span class="comment">// end edge_swap==true</span>
<a name="l00965"></a>00965                           } <span class="comment">// end if (b_id != BoundaryInfo::invalid_id)</span>
<a name="l00966"></a>00966                       } <span class="comment">// end for loop over boundary IDs</span>
<a name="l00967"></a>00967                   } <span class="comment">// end for loop over sides</span>
<a name="l00968"></a>00968 
<a name="l00969"></a>00969                 <span class="comment">// Remove the original element from the BoundaryInfo structure.</span>
<a name="l00970"></a>00970                 mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove(*el);
<a name="l00971"></a>00971 
<a name="l00972"></a>00972               } <span class="comment">// end if (mesh_has_boundary_data)</span>
<a name="l00973"></a>00973             
<a name="l00974"></a>00974             <span class="comment">// Add the newly-created triangles to the temporary vector of new elements.</span>
<a name="l00975"></a>00975             new_elements.push_back(tri0);
<a name="l00976"></a>00976             new_elements.push_back(tri1);
<a name="l00977"></a>00977 
<a name="l00978"></a>00978             <span class="comment">// Delete the original element</span>
<a name="l00979"></a>00979             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5c7824047ed759b5a4891a6936b546cc">delete_elem</a>(*el);
<a name="l00980"></a>00980           } <span class="comment">// end if (split_elem)</span>
<a name="l00981"></a>00981       } <span class="comment">// End for loop over elements</span>
<a name="l00982"></a>00982   } 
<a name="l00983"></a>00983 
<a name="l00984"></a>00984   
<a name="l00985"></a>00985     <span class="comment">// Now, iterate over the new elements vector, and add them each to</span>
<a name="l00986"></a>00986     <span class="comment">// the Mesh.</span>
<a name="l00987"></a>00987   {
<a name="l00988"></a>00988     std::vector&lt;Elem*&gt;::iterator el        = new_elements.begin();
<a name="l00989"></a>00989     <span class="keyword">const</span> std::vector&lt;Elem*&gt;::iterator end = new_elements.end();
<a name="l00990"></a>00990     <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00991"></a>00991       {
<a name="l00992"></a>00992         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(*el);
<a name="l00993"></a>00993       }
<a name="l00994"></a>00994   }
<a name="l00995"></a>00995 
<a name="l00996"></a>00996   
<a name="l00997"></a>00997   <span class="keywordflow">if</span> (mesh_has_boundary_data)
<a name="l00998"></a>00998     {
<a name="l00999"></a>00999       <span class="comment">// By this time, we should have removed all of the original boundary sides</span>
<a name="l01000"></a>01000       <span class="comment">// - except on a hybrid mesh, where we can&#39;t &quot;start from a blank slate&quot;! - RHS</span>
<a name="l01001"></a>01001       <span class="comment">// libmesh_assert (mesh.boundary_info-&gt;n_boundary_conds()==0);</span>
<a name="l01002"></a>01002 
<a name="l01003"></a>01003       <span class="comment">// Clear the boundary info, to be sure and start from a blank slate.</span>
<a name="l01004"></a>01004       <span class="comment">// mesh.boundary_info-&gt;clear();</span>
<a name="l01005"></a>01005 
<a name="l01006"></a>01006       <span class="comment">// If the old mesh had boundary data, the new mesh better have some.</span>
<a name="l01007"></a>01007       libmesh_assert (new_bndry_elements.size() &gt; 0);
<a name="l01008"></a>01008 
<a name="l01009"></a>01009       <span class="comment">// We should also be sure that the lengths of the new boundary data vectors</span>
<a name="l01010"></a>01010       <span class="comment">// are all the same.</span>
<a name="l01011"></a>01011       libmesh_assert (new_bndry_elements.size() == new_bndry_sides.size());
<a name="l01012"></a>01012       libmesh_assert (new_bndry_sides.size()    == new_bndry_ids.size());
<a name="l01013"></a>01013 
<a name="l01014"></a>01014       <span class="comment">// Add the new boundary info to the mesh</span>
<a name="l01015"></a>01015       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;new_bndry_elements.size(); ++s)
<a name="l01016"></a>01016         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(new_bndry_elements[s],
<a name="l01017"></a>01017                                      new_bndry_sides[s],
<a name="l01018"></a>01018                                      new_bndry_ids[s]);
<a name="l01019"></a>01019     }
<a name="l01020"></a>01020   
<a name="l01021"></a>01021 
<a name="l01022"></a>01022   <span class="comment">// Prepare the newly created mesh for use.</span>
<a name="l01023"></a>01023   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a>(<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);
<a name="l01024"></a>01024 
<a name="l01025"></a>01025   <span class="comment">// Let the new_elements and new_bndry_elements vectors go out of scope.</span>
<a name="l01026"></a>01026 }
<a name="l01027"></a>01027 
<a name="l01028"></a>01028 
<a name="l01029"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a2e817d4980341bde2cc3fba486d0d8e6">01029</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a2e817d4980341bde2cc3fba486d0d8e6">MeshTools::Modification::smooth</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l01030"></a>01030                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_iterations,
<a name="l01031"></a>01031                                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> power)
<a name="l01032"></a>01032 {
<a name="l01036"></a>01036   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() == 2);
<a name="l01037"></a>01037   
<a name="l01038"></a>01038   <span class="comment">/*</span>
<a name="l01039"></a>01039 <span class="comment">   * find the boundary nodes</span>
<a name="l01040"></a>01040 <span class="comment">   */</span>
<a name="l01041"></a>01041   std::vector&lt;bool&gt;  on_boundary;
<a name="l01042"></a>01042   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a0fd39d630f54c93571ee6449e8b15550">MeshTools::find_boundary_nodes</a>(mesh, on_boundary);
<a name="l01043"></a>01043 
<a name="l01044"></a>01044   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> iter=0; iter&lt;n_iterations; iter++)
<a name="l01045"></a>01045 
<a name="l01046"></a>01046     {
<a name="l01047"></a>01047       <span class="comment">/*</span>
<a name="l01048"></a>01048 <span class="comment">       * loop over the mesh refinement level</span>
<a name="l01049"></a>01049 <span class="comment">       */</span>
<a name="l01050"></a>01050       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">n_levels</a> = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">MeshTools::n_levels</a>(mesh);
<a name="l01051"></a>01051       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> refinement_level=0; refinement_level != <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">n_levels</a>;
<a name="l01052"></a>01052            refinement_level++)
<a name="l01053"></a>01053         {
<a name="l01054"></a>01054           <span class="comment">// initialize the storage (have to do it on every level to get empty vectors</span>
<a name="l01055"></a>01055           std::vector&lt;Point&gt; new_positions;
<a name="l01056"></a>01056           std::vector&lt;Real&gt;   <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">weight</a>;
<a name="l01057"></a>01057           new_positions.resize(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l01058"></a>01058           weight.resize(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l01059"></a>01059 
<a name="l01060"></a>01060           {
<a name="l01061"></a>01061             <span class="comment">/*</span>
<a name="l01062"></a>01062 <span class="comment">             * Loop over the elements to calculate new node positions</span>
<a name="l01063"></a>01063 <span class="comment">             */</span>
<a name="l01064"></a>01064             <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a32031f5d29428cf17dad4cabaf60d298">level_elements_begin</a>(refinement_level);
<a name="l01065"></a>01065             <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f3f5a30c83cdd0187ba02a5b8b17e">level_elements_end</a>(refinement_level); 
<a name="l01066"></a>01066         
<a name="l01067"></a>01067             <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l01068"></a>01068               {
<a name="l01069"></a>01069                 <span class="comment">/*</span>
<a name="l01070"></a>01070 <span class="comment">                 * Constant handle for the element</span>
<a name="l01071"></a>01071 <span class="comment">                 */</span>
<a name="l01072"></a>01072                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l01073"></a>01073           
<a name="l01074"></a>01074                 <span class="comment">/*</span>
<a name="l01075"></a>01075 <span class="comment">                 * We relax all nodes on level 0 first </span>
<a name="l01076"></a>01076 <span class="comment">                 * If the element is refined (level &gt; 0), we interpolate the</span>
<a name="l01077"></a>01077 <span class="comment">                 * parents nodes with help of the embedding matrix</span>
<a name="l01078"></a>01078 <span class="comment">                 */</span>
<a name="l01079"></a>01079                 <span class="keywordflow">if</span> (refinement_level == 0)
<a name="l01080"></a>01080                   {
<a name="l01081"></a>01081                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); s++)
<a name="l01082"></a>01082                       {
<a name="l01083"></a>01083                         <span class="comment">/*</span>
<a name="l01084"></a>01084 <span class="comment">                         * Only operate on sides which are on the</span>
<a name="l01085"></a>01085 <span class="comment">                         * boundary or for which the current element&#39;s</span>
<a name="l01086"></a>01086 <span class="comment">                         * id is greater than its neighbor&#39;s.</span>
<a name="l01087"></a>01087 <span class="comment">                         * Sides get only built once.</span>
<a name="l01088"></a>01088 <span class="comment">                         */</span>
<a name="l01089"></a>01089                         <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) != NULL) &amp;&amp;
<a name="l01090"></a>01090                             (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &gt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()) ) 
<a name="l01091"></a>01091                           {
<a name="l01092"></a>01092                             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l01093"></a>01093 
<a name="l01094"></a>01094                             <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node0 = <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;get_node(0);
<a name="l01095"></a>01095                             <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node1 = <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;get_node(1);
<a name="l01096"></a>01096 
<a name="l01097"></a>01097                             <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> node_weight = 1.;
<a name="l01098"></a>01098                             <span class="comment">// calculate the weight of the nodes</span>
<a name="l01099"></a>01099                             <span class="keywordflow">if</span> (power &gt; 0)
<a name="l01100"></a>01100                               {
<a name="l01101"></a>01101                                 <a class="code" href="classlibMesh_1_1Point.php">Point</a> diff = (*node0)-(*node1);
<a name="l01102"></a>01102                                 node_weight = <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>( diff.<a class="code" href="classlibMesh_1_1TypeVector.php#a8dcd4a3bff824a7cb1aeee67bdfb598d">size</a>(), power );
<a name="l01103"></a>01103                               }
<a name="l01104"></a>01104 
<a name="l01105"></a>01105                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> id0 = node0-&gt;id(), id1 = node1-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l01106"></a>01106                             new_positions[id0].add_scaled( *node1, node_weight );
<a name="l01107"></a>01107                             new_positions[id1].add_scaled( *node0, node_weight );
<a name="l01108"></a>01108                             weight[id0] += node_weight;
<a name="l01109"></a>01109                             weight[id1] += node_weight;
<a name="l01110"></a>01110                           }
<a name="l01111"></a>01111                       } <span class="comment">// element neighbor loop</span>
<a name="l01112"></a>01112                   } 
<a name="l01113"></a>01113 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01114"></a>01114 <span class="preprocessor"></span>                <span class="keywordflow">else</span>   <span class="comment">// refinement_level &gt; 0</span>
<a name="l01115"></a>01115                   {
<a name="l01116"></a>01116                     <span class="comment">/*</span>
<a name="l01117"></a>01117 <span class="comment">                     * Find the positions of the hanging nodes of refined elements.</span>
<a name="l01118"></a>01118 <span class="comment">                     * We do this by calculating their position based on the parent</span>
<a name="l01119"></a>01119 <span class="comment">                     * (one level less refined) element, and the embedding matrix</span>
<a name="l01120"></a>01120 <span class="comment">                     */</span>
<a name="l01121"></a>01121 
<a name="l01122"></a>01122                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l01123"></a>01123 
<a name="l01124"></a>01124                     <span class="comment">/*</span>
<a name="l01125"></a>01125 <span class="comment">                     * find out which child I am</span>
<a name="l01126"></a>01126 <span class="comment">                     */</span>
<a name="l01127"></a>01127                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c &lt; parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l01128"></a>01128                       {
<a name="l01129"></a>01129                         <span class="keywordflow">if</span> (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c) == elem)
<a name="l01130"></a>01130                           {
<a name="l01131"></a>01131                             <span class="comment">/*</span>
<a name="l01132"></a>01132 <span class="comment">                             *loop over the childs (that is, the current elements) nodes</span>
<a name="l01133"></a>01133 <span class="comment">                             */</span>
<a name="l01134"></a>01134                             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); nc++)
<a name="l01135"></a>01135                               {
<a name="l01136"></a>01136                                 <span class="comment">/*</span>
<a name="l01137"></a>01137 <span class="comment">                                 * the new position of the node</span>
<a name="l01138"></a>01138 <span class="comment">                                 */</span>
<a name="l01139"></a>01139                                 <a class="code" href="classlibMesh_1_1Point.php">Point</a> point;
<a name="l01140"></a>01140                                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l01141"></a>01141                                   {
<a name="l01142"></a>01142                                     <span class="comment">/*</span>
<a name="l01143"></a>01143 <span class="comment">                                     * The value from the embedding matrix</span>
<a name="l01144"></a>01144 <span class="comment">                                     */</span>
<a name="l01145"></a>01145                                     <span class="keyword">const</span> <span class="keywordtype">float</span> em_val = parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a20e8a3350fb24fd249209e0089b2ca33">embedding_matrix</a>(c,nc,n);
<a name="l01146"></a>01146               
<a name="l01147"></a>01147                                     <span class="keywordflow">if</span> (em_val != 0.)
<a name="l01148"></a>01148                                       point.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n), em_val);
<a name="l01149"></a>01149                                   }
<a name="l01150"></a>01150 
<a name="l01151"></a>01151                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(nc)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l01152"></a>01152                                 new_positions[id] = point;
<a name="l01153"></a>01153                                 weight[id] = 1.;
<a name="l01154"></a>01154                               }
<a name="l01155"></a>01155                     
<a name="l01156"></a>01156                           } <span class="comment">// if parent-&gt;child == elem</span>
<a name="l01157"></a>01157                       } <span class="comment">// for parent-&gt;n_children</span>
<a name="l01158"></a>01158                   } <span class="comment">// if element refinement_level</span>
<a name="l01159"></a>01159 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01160"></a>01160 <span class="preprocessor"></span>
<a name="l01161"></a>01161               } <span class="comment">// element loop</span>
<a name="l01162"></a>01162           
<a name="l01163"></a>01163             <span class="comment">/*</span>
<a name="l01164"></a>01164 <span class="comment">             * finally reposition the vertex nodes</span>
<a name="l01165"></a>01165 <span class="comment">             */</span>
<a name="l01166"></a>01166             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nid=0; nid&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); ++nid)
<a name="l01167"></a>01167               <span class="keywordflow">if</span> (!on_boundary[nid] &amp;&amp; weight[nid] &gt; 0.)
<a name="l01168"></a>01168                 mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(nid) = new_positions[nid]/weight[nid];
<a name="l01169"></a>01169           }
<a name="l01170"></a>01170 
<a name="l01171"></a>01171           {
<a name="l01172"></a>01172             <span class="comment">/*</span>
<a name="l01173"></a>01173 <span class="comment">             * Now handle the additional second_order nodes by calculating</span>
<a name="l01174"></a>01174 <span class="comment">             * their position based on the vertex postitions</span>
<a name="l01175"></a>01175 <span class="comment">             * we do a second loop over the level elements</span>
<a name="l01176"></a>01176 <span class="comment">             */</span>
<a name="l01177"></a>01177             <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a32031f5d29428cf17dad4cabaf60d298">level_elements_begin</a>(refinement_level);
<a name="l01178"></a>01178             <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f3f5a30c83cdd0187ba02a5b8b17e">level_elements_end</a>(refinement_level); 
<a name="l01179"></a>01179 
<a name="l01180"></a>01180             <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l01181"></a>01181               {
<a name="l01182"></a>01182                 <span class="comment">/*</span>
<a name="l01183"></a>01183 <span class="comment">                 * Constant handle for the element</span>
<a name="l01184"></a>01184 <span class="comment">                 */</span>
<a name="l01185"></a>01185                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l01186"></a>01186                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_begin = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>();
<a name="l01187"></a>01187                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_end   = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l01188"></a>01188                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=son_begin; n&lt;son_end; n++)
<a name="l01189"></a>01189                   {
<a name="l01190"></a>01190                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_adjacent_vertices =
<a name="l01191"></a>01191                       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a5175062272874a37befab4a16ce68eaf">n_second_order_adjacent_vertices</a>(n);
<a name="l01192"></a>01192 
<a name="l01193"></a>01193                     <a class="code" href="classlibMesh_1_1Point.php">Point</a> point; 
<a name="l01194"></a>01194                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_adjacent_vertices; v++)
<a name="l01195"></a>01195                       point.<a class="code" href="classlibMesh_1_1TypeVector.php#a670ef717fd81b3b529503ecec7a949da">add</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>( elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a430e1bdb48a91b50f7d22c203de8129f">second_order_adjacent_vertex</a>(n,v) ));
<a name="l01196"></a>01196 
<a name="l01197"></a>01197                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l01198"></a>01198                     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(<span class="keywordtype">id</span>) = point/n_adjacent_vertices;
<a name="l01199"></a>01199                   }
<a name="l01200"></a>01200               }
<a name="l01201"></a>01201           }
<a name="l01202"></a>01202       
<a name="l01203"></a>01203         } <span class="comment">// refinement_level loop</span>
<a name="l01204"></a>01204 
<a name="l01205"></a>01205     } <span class="comment">// end iteration</span>
<a name="l01206"></a>01206 }
<a name="l01207"></a>01207 
<a name="l01208"></a>01208 
<a name="l01209"></a>01209 
<a name="l01210"></a>01210 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01211"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a31ce3f7f69838b3326f9bcabae3f2cd6">01211</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a31ce3f7f69838b3326f9bcabae3f2cd6">MeshTools::Modification::flatten</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l01212"></a>01212 {
<a name="l01213"></a>01213   <span class="comment">// Algorithm:</span>
<a name="l01214"></a>01214   <span class="comment">// .) For each active element in the mesh: construct a </span>
<a name="l01215"></a>01215   <span class="comment">//    copy which is the same in every way *except* it is</span>
<a name="l01216"></a>01216   <span class="comment">//    a level 0 element.  Store the pointers to these in</span>
<a name="l01217"></a>01217   <span class="comment">//    a separate vector. Save any boundary information as well.</span>
<a name="l01218"></a>01218   <span class="comment">//    Delete the active element from the mesh.</span>
<a name="l01219"></a>01219   <span class="comment">// .) Loop over all (remaining) elements in the mesh, delete them.</span>
<a name="l01220"></a>01220   <span class="comment">// .) Add the level-0 copies back to the mesh</span>
<a name="l01221"></a>01221   
<a name="l01222"></a>01222   <span class="comment">// Temporary storage for new element pointers</span>
<a name="l01223"></a>01223   std::vector&lt;Elem*&gt; new_elements;
<a name="l01224"></a>01224 
<a name="l01225"></a>01225   <span class="comment">// BoundaryInfo Storage for element ids, sides, and BC ids</span>
<a name="l01226"></a>01226   std::vector&lt;Elem*&gt;              saved_boundary_elements;
<a name="l01227"></a>01227   std::vector&lt;short int&gt;          saved_bc_ids;
<a name="l01228"></a>01228   std::vector&lt;unsigned short int&gt; saved_bc_sides;
<a name="l01229"></a>01229 
<a name="l01230"></a>01230   <span class="comment">// Reserve a reasonable amt. of space for each</span>
<a name="l01231"></a>01231   new_elements.reserve(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>());
<a name="l01232"></a>01232   saved_boundary_elements.reserve(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;n_boundary_conds());
<a name="l01233"></a>01233   saved_bc_ids.reserve(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;n_boundary_conds());
<a name="l01234"></a>01234   saved_bc_sides.reserve(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;n_boundary_conds());
<a name="l01235"></a>01235   {
<a name="l01236"></a>01236     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l01237"></a>01237     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l01238"></a>01238 
<a name="l01239"></a>01239     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01240"></a>01240       {
<a name="l01241"></a>01241         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l01242"></a>01242 
<a name="l01243"></a>01243         <span class="comment">// Make a new element of the same type</span>
<a name="l01244"></a>01244         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* copy = <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>()).release();
<a name="l01245"></a>01245 
<a name="l01246"></a>01246         <span class="comment">// Set node pointers (they point to nodes in the original mesh)</span>
<a name="l01247"></a>01247         <span class="comment">// The copy&#39;s element ID will be set upon adding it to the mesh</span>
<a name="l01248"></a>01248         <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l01249"></a>01249           copy-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(n) = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l01250"></a>01250 
<a name="l01251"></a>01251         <span class="comment">// Copy over ids</span>
<a name="l01252"></a>01252         copy-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l01253"></a>01253         copy-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>();
<a name="l01254"></a>01254 
<a name="l01255"></a>01255         <span class="comment">// This element could have boundary info as well.  We need</span>
<a name="l01256"></a>01256         <span class="comment">// to save the (elem, side, bc_id) triples</span>
<a name="l01257"></a>01257         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l01258"></a>01258             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL)
<a name="l01259"></a>01259               {
<a name="l01260"></a>01260                 <span class="keyword">const</span> std::vector&lt;short int&gt;&amp; bc_ids = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_ids(elem,s);
<a name="l01261"></a>01261                 <span class="keywordflow">for</span> (std::vector&lt;short int&gt;::const_iterator id_it=bc_ids.begin(); id_it!=bc_ids.end(); ++id_it)
<a name="l01262"></a>01262                   {
<a name="l01263"></a>01263                     <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a5ecbd368c0b0ad8b7ec4d85877e05af3">bc_id</a> = *id_it;
<a name="l01264"></a>01264 
<a name="l01265"></a>01265                     <span class="keywordflow">if</span> (bc_id != <a class="code" href="classlibMesh_1_1BoundaryInfo.php#a3d20128706f2a7772f805dbd1a28f03d">BoundaryInfo::invalid_id</a>)
<a name="l01266"></a>01266                       {
<a name="l01267"></a>01267                         saved_boundary_elements.push_back(copy);
<a name="l01268"></a>01268                         saved_bc_ids.push_back(bc_id);
<a name="l01269"></a>01269                         saved_bc_sides.push_back(s);
<a name="l01270"></a>01270                       }
<a name="l01271"></a>01271                   }
<a name="l01272"></a>01272               }
<a name="l01273"></a>01273 
<a name="l01274"></a>01274         
<a name="l01275"></a>01275         <span class="comment">// We&#39;re done with this element</span>
<a name="l01276"></a>01276         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5c7824047ed759b5a4891a6936b546cc">delete_elem</a>(elem);
<a name="l01277"></a>01277 
<a name="l01278"></a>01278         <span class="comment">// But save the copy</span>
<a name="l01279"></a>01279         new_elements.push_back(copy);
<a name="l01280"></a>01280       }
<a name="l01281"></a>01281     
<a name="l01282"></a>01282     <span class="comment">// Make sure we saved the same number of boundary conditions</span>
<a name="l01283"></a>01283     <span class="comment">// in each vector.</span>
<a name="l01284"></a>01284     libmesh_assert (saved_boundary_elements.size() == saved_bc_ids.size());
<a name="l01285"></a>01285     libmesh_assert (saved_bc_ids.size()            == saved_bc_sides.size());
<a name="l01286"></a>01286   }
<a name="l01287"></a>01287 
<a name="l01288"></a>01288   
<a name="l01289"></a>01289   <span class="comment">// Loop again, delete any remaining elements</span>
<a name="l01290"></a>01290   {
<a name="l01291"></a>01291     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l01292"></a>01292     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l01293"></a>01293 
<a name="l01294"></a>01294     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l01295"></a>01295       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5c7824047ed759b5a4891a6936b546cc">delete_elem</a>( *it );
<a name="l01296"></a>01296   }
<a name="l01297"></a>01297 
<a name="l01298"></a>01298   
<a name="l01299"></a>01299   <span class="comment">// Add the copied (now level-0) elements back to the mesh</span>
<a name="l01300"></a>01300   {
<a name="l01301"></a>01301     <span class="keywordflow">for</span> (std::vector&lt;Elem*&gt;::iterator it = new_elements.begin();
<a name="l01302"></a>01302          it != new_elements.end();
<a name="l01303"></a>01303          ++it)
<a name="l01304"></a>01304       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(*it);
<a name="l01305"></a>01305   }
<a name="l01306"></a>01306 
<a name="l01307"></a>01307   <span class="comment">// Finally, also add back the saved boundary information</span>
<a name="l01308"></a>01308   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;saved_boundary_elements.size(); ++e)
<a name="l01309"></a>01309     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(saved_boundary_elements[e],
<a name="l01310"></a>01310                                  saved_bc_sides[e],
<a name="l01311"></a>01311                                  saved_bc_ids[e]);
<a name="l01312"></a>01312 
<a name="l01313"></a>01313   <span class="comment">// Trim unused and renumber nodes and elements</span>
<a name="l01314"></a>01314   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9805f1c4efa5d61188c582e58ed66a79">prepare_for_use</a>(<span class="comment">/*skip_renumber =*/</span> <span class="keyword">false</span>);
<a name="l01315"></a>01315 }
<a name="l01316"></a>01316 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01317"></a>01317 <span class="preprocessor"></span>
<a name="l01318"></a>01318 
<a name="l01319"></a>01319 
<a name="l01320"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a5347b08d93e1bd060e2d2550eac93b8d">01320</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Modification.php#a5347b08d93e1bd060e2d2550eac93b8d">MeshTools::Modification::change_boundary_id</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l01321"></a>01321                                                   <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> old_id,
<a name="l01322"></a>01322                                                   <span class="keyword">const</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> new_id)
<a name="l01323"></a>01323 {
<a name="l01324"></a>01324   <span class="comment">// Only level-0 elements store BCs.  Loop over them.</span>
<a name="l01325"></a>01325   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>           el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a32031f5d29428cf17dad4cabaf60d298">level_elements_begin</a>(0);
<a name="l01326"></a>01326   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f3f5a30c83cdd0187ba02a5b8b17e">level_elements_end</a>(0);
<a name="l01327"></a>01327   <span class="keywordflow">for</span> (; el != end_el; ++el)
<a name="l01328"></a>01328     {
<a name="l01329"></a>01329       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *el;
<a name="l01330"></a>01330       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sides = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>();
<a name="l01331"></a>01331       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s != n_sides; ++s)
<a name="l01332"></a>01332         {
<a name="l01333"></a>01333           <span class="keyword">const</span> std::vector&lt;short int&gt;&amp; old_ids = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;boundary_ids(elem, s);
<a name="l01334"></a>01334           <span class="keywordflow">if</span> (std::find(old_ids.begin(), old_ids.end(), old_id) != old_ids.end())
<a name="l01335"></a>01335             {
<a name="l01336"></a>01336               std::vector&lt;short int&gt; new_ids(old_ids);
<a name="l01337"></a>01337               std::replace(new_ids.begin(), new_ids.end(), old_id, new_id);
<a name="l01338"></a>01338               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove_side(elem, s);
<a name="l01339"></a>01339               mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side(elem, s, new_ids);
<a name="l01340"></a>01340             }
<a name="l01341"></a>01341         }
<a name="l01342"></a>01342     }
<a name="l01343"></a>01343 }
<a name="l01344"></a>01344 
<a name="l01345"></a>01345 } <span class="comment">// namespace libMesh</span>
<a name="l01346"></a>01346 
<a name="l01347"></a>01347 
<a name="l01348"></a>01348 
<a name="l01349"></a>01349 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
