<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_output.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__output_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_output.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// Local includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">template</span> &lt;<span class="keyword">class</span> MT&gt;
<a name="l00030"></a>00030 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshOutput.php#a857527791ede849b66d75c43272cdbe3">MeshOutput&lt;MT&gt;::</a>
<a name="l00031"></a><a class="code" href="classlibMesh_1_1MeshOutput.php#a857527791ede849b66d75c43272cdbe3">00031</a> <a class="code" href="classlibMesh_1_1MeshOutput.php#a857527791ede849b66d75c43272cdbe3">_build_variable_names_and_solution_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00032"></a>00032                                            std::vector&lt;Number&gt;&amp; soln,
<a name="l00033"></a>00033                                            std::vector&lt;std::string&gt;&amp; names)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <span class="comment">// We need a serial mesh for MeshOutput for now</span>
<a name="l00036"></a>00036   <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp;<span class="keyword">&gt;</span>(es).<a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">allgather</a>();
<a name="l00037"></a>00037 
<a name="l00038"></a>00038   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#aa050d0013c82f8a646d0ec583e142341">build_variable_names</a>  (names);
<a name="l00039"></a>00039   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a2c7a089f06d24e9f42330d849ab18503">build_solution_vector</a> (soln);
<a name="l00040"></a>00040 }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// Instantiate for our Mesh types.  If this becomes too cumbersome later,</span>
<a name="l00045"></a>00045 <span class="comment">// move any functions in this file to the header file instead.</span>
<a name="l00046"></a>00046 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput&lt;MeshBase&gt;</a>;
<a name="l00047"></a>00047 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput&lt;UnstructuredMesh&gt;</a>;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
