<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_refinement.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__refinement_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_refinement.h 4399 2011-04-22 18:32:39Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_refinement_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_refinement_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span>
<a name="l00031"></a>00031 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span> <span class="comment">// libMesh::invalid_uint</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="location__maps_8h.php">location_maps.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// Forward Declarations -----------------------------</span>
<a name="l00044"></a>00044 <span class="keyword">class </span>MeshBase;
<a name="l00045"></a>00045 <span class="keyword">class </span>Point;
<a name="l00046"></a>00046 <span class="keyword">class </span>Node;
<a name="l00047"></a>00047 <span class="keyword">class </span>ErrorVector;
<a name="l00048"></a>00048 <span class="keyword">class </span>PeriodicBoundaries;
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00060"></a>00060 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00061"></a>00061 <span class="comment">// MeshRefinement class definition</span>
<a name="l00062"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php">00062</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a>
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064 <span class="keyword">public</span>:
<a name="l00065"></a>00065 
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1MeshRefinement.php#aa08885aefc8dbd6572f9b2478b17e92f">MeshRefinement</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="keyword">private</span>:
<a name="l00072"></a>00072   <span class="comment">// Both the copy ctor and the assignment operator are </span>
<a name="l00073"></a>00073   <span class="comment">// declared private but not implemented.  This is the </span>
<a name="l00074"></a>00074   <span class="comment">// standard practice to prevent them from being used.</span>
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1MeshRefinement.php#aa08885aefc8dbd6572f9b2478b17e92f">MeshRefinement</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a>&amp;);
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#ad627b508017c8838cf513933dd6bdd00">operator=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a>&amp;);
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="keyword">public</span>:
<a name="l00079"></a>00079 
<a name="l00080"></a>00080   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a9bec9c92d8089a8b3098643defa4a83a">set_periodic_boundaries_ptr</a>(<a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> * pb_ptr);
<a name="l00081"></a>00081   
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac2b4fc8fbeef7897987b69fdba7d2ccc">~MeshRefinement</a> ();
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac64e4f1afa4af23fe11997dfbeae071b">clear</a> ();  
<a name="l00091"></a>00091 
<a name="l00103"></a>00103   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6ef885bd531649c9d0738f2e9c65b53b">flag_elements_by_error_fraction</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00104"></a>00104                                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac65900f46067a75f67814fc91ef05d4b">refine_fraction</a>  = 0.3,
<a name="l00105"></a>00105                                         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#afc484f7cbbb97079dee552daaaa06613">coarsen_fraction</a> = 0.0,
<a name="l00106"></a>00106                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a57a0ae7fb3cba63f06621d6c701327c8">max_level</a> = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00107"></a>00107 
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a31da3a2dbca4c3e0a893090f4e467ddc">flag_elements_by_error_tolerance</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell);
<a name="l00123"></a>00123 
<a name="l00137"></a>00137   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a700c8faeb937a543ced5e3979ab06033">flag_elements_by_nelem_target</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell);
<a name="l00138"></a>00138 
<a name="l00152"></a>00152   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a50e328f89c951deca3895d130750ac07">flag_elements_by_elem_fraction</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00153"></a>00153                                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac65900f46067a75f67814fc91ef05d4b">refine_fraction</a>  = 0.3,
<a name="l00154"></a>00154                                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#afc484f7cbbb97079dee552daaaa06613">coarsen_fraction</a> = 0.0,
<a name="l00155"></a>00155                                        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a57a0ae7fb3cba63f06621d6c701327c8">max_level</a> = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00156"></a>00156 
<a name="l00170"></a>00170   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ae0377024040f50645b4eec3d8ebc3268">flag_elements_by_mean_stddev</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00171"></a>00171                                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac65900f46067a75f67814fc91ef05d4b">refine_fraction</a>  = 1.0,
<a name="l00172"></a>00172                                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#afc484f7cbbb97079dee552daaaa06613">coarsen_fraction</a> = 0.0,
<a name="l00173"></a>00173                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a57a0ae7fb3cba63f06621d6c701327c8">max_level</a> = <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>);
<a name="l00174"></a>00174 
<a name="l00179"></a>00179   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f565f6b741867544c70a2c96ef728f0">switch_h_to_p_refinement</a>();
<a name="l00180"></a>00180 
<a name="l00185"></a>00185   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ab3f2ecc36e231ddc26798014ee133045">add_p_to_h_refinement</a>();
<a name="l00186"></a>00186 
<a name="l00198"></a>00198   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0fbfad1ea615122c73e2202c7dc1cc9e">refine_and_coarsen_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one=<span class="keyword">true</span>);
<a name="l00199"></a>00199 
<a name="l00211"></a>00211   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#aca713a738c5308507a7fe9ed02147100">coarsen_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one=<span class="keyword">true</span>);
<a name="l00212"></a>00212 
<a name="l00223"></a>00223   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a68f01ed0485284d19a9c153572a35da9">refine_elements</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span> maintain_level_one=<span class="keyword">true</span>);
<a name="l00224"></a>00224   
<a name="l00228"></a>00228   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a406e53c22bd8c9e2cefa862ef02f226f">uniformly_refine</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1);
<a name="l00229"></a>00229   
<a name="l00233"></a>00233   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0c090a5a22834d33fa0d436fbccab795">uniformly_coarsen</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1);
<a name="l00234"></a>00234   
<a name="l00238"></a>00238   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac8b117eccc68c96f20c0c0b4045303e8">uniformly_p_refine</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1);
<a name="l00239"></a>00239   
<a name="l00243"></a>00243   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a19810e55f1ba17b88aa665e8c31cb5a2">uniformly_p_coarsen</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1);
<a name="l00244"></a>00244 
<a name="l00249"></a>00249   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6930cd279030a81ff6d36a40809b1fd8">clean_refinement_flags</a> ();
<a name="l00250"></a>00250 
<a name="l00257"></a>00257   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f90c35be7bbebea889c925b6f20713a">test_level_one</a> (<span class="keywordtype">bool</span> libmesh_assert_yes = <span class="keyword">false</span>);
<a name="l00258"></a>00258   
<a name="l00266"></a>00266   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a2a95dae49cbfe9cb0ab381f14ccc337c">test_unflagged</a> (<span class="keywordtype">bool</span> libmesh_assert_yes = <span class="keyword">false</span>);
<a name="l00267"></a>00267   
<a name="l00275"></a>00275   <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1MeshRefinement.php#a1dae39fb0b5070dc1f343f0c99ca2971">add_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00276"></a>00276                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>,
<a name="l00277"></a>00277                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol);
<a name="l00278"></a>00278 
<a name="l00282"></a>00282   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshRefinement.php#a052c0307f8d231199f9a5d20b9d698ca">add_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00283"></a>00283 
<a name="l00288"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ad9eac946986b1e3eff41343ab9bfcc56">00288</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#ad9eac946986b1e3eff41343ab9bfcc56">get_mesh</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>; }
<a name="l00289"></a>00289 
<a name="l00294"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ae5fca6c48816c0221eea5c120571649f">00294</a>   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;       <a class="code" href="classlibMesh_1_1MeshRefinement.php#ae5fca6c48816c0221eea5c120571649f">get_mesh</a> ()       { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>; }
<a name="l00295"></a>00295 
<a name="l00303"></a>00303   <span class="keywordtype">bool</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a5db36c33bd581e101f38bcc1f3d2ce5d">coarsen_by_parents</a>();
<a name="l00304"></a>00304 
<a name="l00312"></a>00312   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac65900f46067a75f67814fc91ef05d4b">refine_fraction</a>();
<a name="l00313"></a>00313 
<a name="l00321"></a>00321   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#afc484f7cbbb97079dee552daaaa06613">coarsen_fraction</a>();
<a name="l00322"></a>00322 
<a name="l00329"></a>00329   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#aa761b1dfd3fd39c9b823a772d9f4f0ea">max_h_level</a>();
<a name="l00330"></a>00330 
<a name="l00339"></a>00339   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a811a18927f38ec427530bd7cb126c3a0">coarsen_threshold</a>();
<a name="l00340"></a>00340 
<a name="l00348"></a>00348   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a4ca0b06f597a07a1641c372cb9d42d66">nelem_target</a>();
<a name="l00349"></a>00349 
<a name="l00359"></a>00359   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a3cd3b275dc8d45ac914f638cc7179c9a">absolute_global_tolerance</a>();
<a name="l00360"></a>00360 
<a name="l00371"></a>00371   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a81fa55fe9538fded1391a56952aa1376">face_level_mismatch_limit</a>();
<a name="l00372"></a>00372 
<a name="l00382"></a>00382   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#adeb3800bb748de340a82caef581ed43d">edge_level_mismatch_limit</a>();
<a name="l00383"></a>00383 
<a name="l00393"></a>00393   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a7c7508c29a7083069c0c4d325c3bb27a">node_level_mismatch_limit</a>();
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 <span class="keyword">private</span>:
<a name="l00396"></a>00396 
<a name="l00411"></a>00411   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a46ef7ebd80c846f24998ef0f222c55e1">_coarsen_elements</a> ();
<a name="l00412"></a>00412   
<a name="l00421"></a>00421   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ad794507aa1e1908fea6fb373dd31c548">_refine_elements</a> ();
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425   <span class="comment">//------------------------------------------------------</span>
<a name="l00426"></a>00426   <span class="comment">// &quot;Smoothing&quot; algorthms for refined meshes</span>
<a name="l00427"></a>00427   
<a name="l00492"></a>00492   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#acbc5744304854c3ce239abced653624e">limit_level_mismatch_at_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_mismatch);
<a name="l00493"></a>00493 
<a name="l00494"></a>00494   <span class="comment">/*</span>
<a name="l00495"></a>00495 <span class="comment">   * This algorithm restricts the maximum level mismatch</span>
<a name="l00496"></a>00496 <span class="comment">   * at any edge in the mesh.  See the ASCII art in the comment of</span>
<a name="l00497"></a>00497 <span class="comment">   * limit_level_mismatch_at_node, and pretend they&#39;re hexes.</span>
<a name="l00498"></a>00498 <span class="comment">   */</span>
<a name="l00499"></a>00499   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6726f2900feee33e74f571aa31a9d545">limit_level_mismatch_at_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_mismatch);
<a name="l00500"></a>00500 
<a name="l00553"></a>00553   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a2f57c999ade430e94e7cf25bfc97eb07">eliminate_unrefined_patches</a> ();
<a name="l00554"></a>00554 
<a name="l00555"></a>00555 
<a name="l00556"></a>00556   <span class="comment">//---------------------------------------------</span>
<a name="l00557"></a>00557   <span class="comment">// Utility algorithms</span>
<a name="l00558"></a>00558 
<a name="l00564"></a>00564   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac25b931ac102cee61e84fac044bdbf0a">create_parent_error_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00565"></a>00565                                    <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_parent,
<a name="l00566"></a>00566                                    <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp;parent_error_min,
<a name="l00567"></a>00567                                    <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp;parent_error_max);
<a name="l00568"></a>00568 
<a name="l00572"></a>00572   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a2fbd7b73883ab6ad3f587a7e6e756ab0">update_nodes_map</a> ();
<a name="l00573"></a>00573   
<a name="l00578"></a>00578   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a2c2b086d711b1598b82105044e73a570">make_coarsening_compatible</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span>);
<a name="l00579"></a>00579 
<a name="l00584"></a>00584   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a98aad95c8d6f16674c878c8ef01dba6e">make_refinement_compatible</a> (<span class="keyword">const</span> <span class="keywordtype">bool</span>);
<a name="l00585"></a>00585 
<a name="l00590"></a>00590   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0e925a80a9435e0d2d2a5f6113050043">make_flags_parallel_consistent</a> ();
<a name="l00591"></a>00591 
<a name="l00596"></a>00596   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6afb4f67a92e0d3cebf6cbcd27fc22e3">topological_neighbor</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00597"></a>00597                               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* point_locator,
<a name="l00598"></a>00598                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>);
<a name="l00599"></a>00599 
<a name="l00604"></a>00604   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a7f021d919ece7366d8782410b7ed2d12">has_topological_neighbor</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00605"></a>00605                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* point_locator,
<a name="l00606"></a>00606                                  <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor);
<a name="l00607"></a>00607   
<a name="l00611"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a0b34a1599da3a45c2d0eed3e19c38574">00611</a>   <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a0b34a1599da3a45c2d0eed3e19c38574">_new_nodes_map</a>;
<a name="l00612"></a>00612 
<a name="l00616"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">00616</a>   <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>;
<a name="l00617"></a>00617 
<a name="l00623"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">00623</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a>;
<a name="l00624"></a>00624 
<a name="l00629"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">00629</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a>;
<a name="l00630"></a>00630 
<a name="l00631"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">00631</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>;
<a name="l00632"></a>00632 
<a name="l00633"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">00633</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a>;
<a name="l00634"></a>00634 
<a name="l00635"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">00635</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a>;
<a name="l00636"></a>00636 
<a name="l00637"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#aef4c09ce1e49edffc4b7f196d4b91b8a">00637</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#aef4c09ce1e49edffc4b7f196d4b91b8a">_coarsen_threshold</a>;
<a name="l00638"></a>00638 
<a name="l00639"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a9b6e56cf037d2cecb548715dddcd70d2">00639</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a9b6e56cf037d2cecb548715dddcd70d2">_nelem_target</a>;
<a name="l00640"></a>00640 
<a name="l00641"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#aea1a97aa9a8e4a8ec1967050c96f5b13">00641</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1MeshRefinement.php#aea1a97aa9a8e4a8ec1967050c96f5b13">_absolute_global_tolerance</a>;
<a name="l00642"></a>00642 
<a name="l00643"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ae794162fe8b50db70bb236ef9cbe68ab">00643</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a56f1015a59736175b39e4a1ca4d084bc">_face_level_mismatch_limit</a>, <a class="code" href="classlibMesh_1_1MeshRefinement.php#ae705082e7bc067be443b6792c1be54d6">_edge_level_mismatch_limit</a>,
<a name="l00644"></a>00644                 <a class="code" href="classlibMesh_1_1MeshRefinement.php#ae794162fe8b50db70bb236ef9cbe68ab">_node_level_mismatch_limit</a>;
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00647"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a47a409d8f3852a859271fafc5b466bb8">00647</a> <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> * <a class="code" href="classlibMesh_1_1MeshRefinement.php#a47a409d8f3852a859271fafc5b466bb8">_periodic_boundaries</a>;
<a name="l00648"></a>00648 <span class="preprocessor">#endif</span>
<a name="l00649"></a>00649 <span class="preprocessor"></span>};
<a name="l00650"></a>00650 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00654"></a>00654 <span class="comment">// MeshRefinement class inline members</span>
<a name="l00655"></a>00655 
<a name="l00656"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a5db36c33bd581e101f38bcc1f3d2ce5d">00656</a> <span class="keyword">inline</span> <span class="keywordtype">bool</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a5db36c33bd581e101f38bcc1f3d2ce5d">MeshRefinement::coarsen_by_parents</a>()
<a name="l00657"></a>00657 {
<a name="l00658"></a>00658   <a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00659"></a>00659   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a>;
<a name="l00660"></a>00660 }
<a name="l00661"></a>00661 
<a name="l00662"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ac65900f46067a75f67814fc91ef05d4b">00662</a> <span class="keyword">inline</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac65900f46067a75f67814fc91ef05d4b">MeshRefinement::refine_fraction</a>()
<a name="l00663"></a>00663 {
<a name="l00664"></a>00664   <a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00665"></a>00665   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>;
<a name="l00666"></a>00666 }
<a name="l00667"></a>00667 
<a name="l00668"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#afc484f7cbbb97079dee552daaaa06613">00668</a> <span class="keyword">inline</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#afc484f7cbbb97079dee552daaaa06613">MeshRefinement::coarsen_fraction</a>()
<a name="l00669"></a>00669 {
<a name="l00670"></a>00670   <a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00671"></a>00671   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a>;
<a name="l00672"></a>00672 }
<a name="l00673"></a>00673 
<a name="l00674"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#aa761b1dfd3fd39c9b823a772d9f4f0ea">00674</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#aa761b1dfd3fd39c9b823a772d9f4f0ea">MeshRefinement::max_h_level</a>()
<a name="l00675"></a>00675 {
<a name="l00676"></a>00676   <a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00677"></a>00677   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a>;
<a name="l00678"></a>00678 }
<a name="l00679"></a>00679 
<a name="l00680"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a811a18927f38ec427530bd7cb126c3a0">00680</a> <span class="keyword">inline</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a811a18927f38ec427530bd7cb126c3a0">MeshRefinement::coarsen_threshold</a>()
<a name="l00681"></a>00681 {
<a name="l00682"></a>00682   <a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00683"></a>00683   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#aef4c09ce1e49edffc4b7f196d4b91b8a">_coarsen_threshold</a>;
<a name="l00684"></a>00684 }
<a name="l00685"></a>00685 
<a name="l00686"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a4ca0b06f597a07a1641c372cb9d42d66">00686</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a4ca0b06f597a07a1641c372cb9d42d66">MeshRefinement::nelem_target</a>()
<a name="l00687"></a>00687 {
<a name="l00688"></a>00688   <a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00689"></a>00689   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a9b6e56cf037d2cecb548715dddcd70d2">_nelem_target</a>;
<a name="l00690"></a>00690 }
<a name="l00691"></a>00691 
<a name="l00692"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a3cd3b275dc8d45ac914f638cc7179c9a">00692</a> <span class="keyword">inline</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a3cd3b275dc8d45ac914f638cc7179c9a">MeshRefinement::absolute_global_tolerance</a>()
<a name="l00693"></a>00693 {
<a name="l00694"></a>00694   <a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a> = <span class="keyword">true</span>;
<a name="l00695"></a>00695   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#aea1a97aa9a8e4a8ec1967050c96f5b13">_absolute_global_tolerance</a>;
<a name="l00696"></a>00696 }
<a name="l00697"></a>00697 
<a name="l00698"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a81fa55fe9538fded1391a56952aa1376">00698</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a81fa55fe9538fded1391a56952aa1376">MeshRefinement::face_level_mismatch_limit</a>()
<a name="l00699"></a>00699 {
<a name="l00700"></a>00700   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a56f1015a59736175b39e4a1ca4d084bc">_face_level_mismatch_limit</a>;
<a name="l00701"></a>00701 }
<a name="l00702"></a>00702 
<a name="l00703"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#adeb3800bb748de340a82caef581ed43d">00703</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#adeb3800bb748de340a82caef581ed43d">MeshRefinement::edge_level_mismatch_limit</a>()
<a name="l00704"></a>00704 {
<a name="l00705"></a>00705   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ae705082e7bc067be443b6792c1be54d6">_edge_level_mismatch_limit</a>;
<a name="l00706"></a>00706 }
<a name="l00707"></a>00707 
<a name="l00708"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a7c7508c29a7083069c0c4d325c3bb27a">00708</a> <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a7c7508c29a7083069c0c4d325c3bb27a">MeshRefinement::node_level_mismatch_limit</a>()
<a name="l00709"></a>00709 {
<a name="l00710"></a>00710   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ae794162fe8b50db70bb236ef9cbe68ab">_node_level_mismatch_limit</a>;
<a name="l00711"></a>00711 }
<a name="l00712"></a>00712 
<a name="l00713"></a>00713 
<a name="l00714"></a>00714 } <span class="comment">// namespace libMesh</span>
<a name="l00715"></a>00715 
<a name="l00716"></a>00716 <span class="preprocessor">#endif // end #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00717"></a>00717 <span class="preprocessor"></span><span class="preprocessor">#endif // end #ifndef __mesh_refinement_h__ </span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
