<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_refinement_flagging.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__refinement__flagging_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: mesh_refinement_flagging.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// only compile these functions if the user requests AMR support</span>
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::sort</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__refinement_8h.php">mesh_refinement.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>libMesh
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// Mesh refinement methods</span>
<a name="l00046"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a6ef885bd531649c9d0738f2e9c65b53b">00046</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6ef885bd531649c9d0738f2e9c65b53b">MeshRefinement::flag_elements_by_error_fraction</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00047"></a>00047                                                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> refine_frac,
<a name="l00048"></a>00048                                                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> coarsen_frac,
<a name="l00049"></a>00049                                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_l)
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051   <span class="comment">// The function arguments are currently just there for</span>
<a name="l00052"></a>00052   <span class="comment">// backwards_compatibility</span>
<a name="l00053"></a>00053   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a>)
<a name="l00054"></a>00054   {
<a name="l00055"></a>00055     <span class="comment">// If the user used non-default parameters, lets warn</span>
<a name="l00056"></a>00056     <span class="comment">// that they&#39;re deprecated</span>
<a name="l00057"></a>00057     <span class="keywordflow">if</span> (refine_frac != 0.3 ||
<a name="l00058"></a>00058         coarsen_frac != 0.0 ||
<a name="l00059"></a>00059         max_l != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00060"></a>00060       libmesh_deprecated();
<a name="l00061"></a>00061 
<a name="l00062"></a>00062     <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a> = refine_frac;
<a name="l00063"></a>00063     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> = coarsen_frac;
<a name="l00064"></a>00064     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a> = max_l;
<a name="l00065"></a>00065   }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="comment">// Check for valid fractions..</span>
<a name="l00068"></a>00068   <span class="comment">// The fraction values must be in [0,1]</span>
<a name="l00069"></a>00069   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &lt;= 1.);
<a name="l00070"></a>00070   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &lt;= 1.);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072   <span class="comment">// Clean up the refinement flags.  These could be left</span>
<a name="l00073"></a>00073   <span class="comment">// over from previous refinement steps.</span>
<a name="l00074"></a>00074   this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6930cd279030a81ff6d36a40809b1fd8">clean_refinement_flags</a>();
<a name="l00075"></a>00075   
<a name="l00076"></a>00076   <span class="comment">// We&#39;re getting the minimum and maximum error values</span>
<a name="l00077"></a>00077   <span class="comment">// for the ACTIVE elements</span>
<a name="l00078"></a>00078   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_min = 1.e30;
<a name="l00079"></a>00079   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_max = 0.;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// And, if necessary, for their parents</span>
<a name="l00082"></a>00082   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> parent_error_min = 1.e30;
<a name="l00083"></a>00083   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> parent_error_max = 0.;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// Prepare another error vector if we need to sum parent errors</span>
<a name="l00086"></a>00086   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> error_per_parent;
<a name="l00087"></a>00087   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a>) 
<a name="l00088"></a>00088   {
<a name="l00089"></a>00089     <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac25b931ac102cee61e84fac044bdbf0a">create_parent_error_vector</a>(error_per_cell,
<a name="l00090"></a>00090                                error_per_parent,
<a name="l00091"></a>00091                                parent_error_min,
<a name="l00092"></a>00092                                parent_error_max);
<a name="l00093"></a>00093   }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="comment">// We need to loop over all active elements to find the minimum </span>
<a name="l00096"></a>00096   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el_it  =
<a name="l00097"></a>00097     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00098"></a>00098   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> el_end =
<a name="l00099"></a>00099     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="keywordflow">for</span> (; el_it != el_end; ++el_it)
<a name="l00102"></a>00102   {
<a name="l00103"></a>00103     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>  = (*el_it)-&gt;id();
<a name="l00104"></a>00104     libmesh_assert (<span class="keywordtype">id</span> &lt; error_per_cell.size());
<a name="l00105"></a>00105 
<a name="l00106"></a>00106     error_max = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (error_max, error_per_cell[<span class="keywordtype">id</span>]);
<a name="l00107"></a>00107     error_min = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (error_min, error_per_cell[<span class="keywordtype">id</span>]);
<a name="l00108"></a>00108   }
<a name="l00109"></a>00109   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(error_max);
<a name="l00110"></a>00110   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(error_min);
<a name="l00111"></a>00111   
<a name="l00112"></a>00112   <span class="comment">// Compute the cutoff values for coarsening and refinement</span>
<a name="l00113"></a>00113   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> error_delta = (error_max - error_min);
<a name="l00114"></a>00114   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> parent_error_delta = parent_error_max - parent_error_min;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> refine_cutoff  = (1.- <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>)*error_max;
<a name="l00117"></a>00117   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> coarsen_cutoff = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a>*error_delta + error_min;
<a name="l00118"></a>00118   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> parent_cutoff = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a>*parent_error_delta + error_min;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="comment">//   // Print information about the error</span>
<a name="l00121"></a>00121 <span class="comment">//   libMesh::out &lt;&lt; &quot; Error Information:&quot;                     &lt;&lt; std::endl</span>
<a name="l00122"></a>00122 <span class="comment">//          &lt;&lt; &quot; ------------------&quot;                     &lt;&lt; std::endl</span>
<a name="l00123"></a>00123 <span class="comment">//          &lt;&lt; &quot;   min:              &quot; &lt;&lt; error_min      &lt;&lt; std::endl</span>
<a name="l00124"></a>00124 <span class="comment">//          &lt;&lt; &quot;   max:              &quot; &lt;&lt; error_max      &lt;&lt; std::endl</span>
<a name="l00125"></a>00125 <span class="comment">//          &lt;&lt; &quot;   delta:            &quot; &lt;&lt; error_delta    &lt;&lt; std::endl</span>
<a name="l00126"></a>00126 <span class="comment">//          &lt;&lt; &quot;     refine_cutoff:  &quot; &lt;&lt; refine_cutoff  &lt;&lt; std::endl</span>
<a name="l00127"></a>00127 <span class="comment">//          &lt;&lt; &quot;     coarsen_cutoff: &quot; &lt;&lt; coarsen_cutoff &lt;&lt; std::endl;</span>
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="comment">// Loop over the elements and flag them for coarsening or</span>
<a name="l00132"></a>00132   <span class="comment">// refinement based on the element error</span>
<a name="l00133"></a>00133 
<a name="l00134"></a>00134   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       e_it  =
<a name="l00135"></a>00135     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00136"></a>00136   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> e_end =
<a name="l00137"></a>00137     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00138"></a>00138   <span class="keywordflow">for</span> (; e_it != e_end; ++e_it)
<a name="l00139"></a>00139   {
<a name="l00140"></a>00140     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem             = *e_it;
<a name="l00141"></a>00141     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>  = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00142"></a>00142 
<a name="l00143"></a>00143     libmesh_assert (<span class="keywordtype">id</span> &lt; error_per_cell.size());
<a name="l00144"></a>00144       
<a name="l00145"></a>00145     <span class="keyword">const</span> <span class="keywordtype">float</span> elem_error = error_per_cell[id];
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a>)
<a name="l00148"></a>00148     {
<a name="l00149"></a>00149       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent           = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00150"></a>00150       <span class="keywordflow">if</span> (parent)
<a name="l00151"></a>00151       {
<a name="l00152"></a>00152         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parentid  = parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00153"></a>00153         <span class="keywordflow">if</span> (error_per_parent[parentid] &gt;= 0. &amp;&amp;
<a name="l00154"></a>00154             error_per_parent[parentid] &lt;= parent_cutoff)
<a name="l00155"></a>00155           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00156"></a>00156       }
<a name="l00157"></a>00157     }
<a name="l00158"></a>00158     <span class="comment">// Flag the element for coarsening if its error</span>
<a name="l00159"></a>00159     <span class="comment">// is &lt;= coarsen_fraction*delta + error_min</span>
<a name="l00160"></a>00160     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem_error &lt;= coarsen_cutoff)
<a name="l00161"></a>00161     {
<a name="l00162"></a>00162       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00163"></a>00163     }
<a name="l00164"></a>00164       
<a name="l00165"></a>00165     <span class="comment">// Flag the element for refinement if its error</span>
<a name="l00166"></a>00166     <span class="comment">// is &gt;= refinement_cutoff.</span>
<a name="l00167"></a>00167     <span class="keywordflow">if</span> (elem_error &gt;= refine_cutoff)
<a name="l00168"></a>00168       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a>)
<a name="l00169"></a>00169         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00170"></a>00170   }
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a31da3a2dbca4c3e0a893090f4e467ddc">00175</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a31da3a2dbca4c3e0a893090f4e467ddc">MeshRefinement::flag_elements_by_error_tolerance</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell_in)
<a name="l00176"></a>00176 {
<a name="l00177"></a>00177   <span class="comment">// Check for valid fractions..</span>
<a name="l00178"></a>00178   <span class="comment">// The fraction values must be in [0,1]</span>
<a name="l00179"></a>00179   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#aef4c09ce1e49edffc4b7f196d4b91b8a">_coarsen_threshold</a>  &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &lt;= 1.);
<a name="l00180"></a>00180   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &lt;= 1.);
<a name="l00181"></a>00181   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &lt;= 1.);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">// How much error per cell will we tolerate?</span>
<a name="l00184"></a>00184   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> local_refinement_tolerance =
<a name="l00185"></a>00185     <a class="code" href="classlibMesh_1_1MeshRefinement.php#aea1a97aa9a8e4a8ec1967050c96f5b13">_absolute_global_tolerance</a> / std::sqrt(static_cast&lt;Real&gt;(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>()));
<a name="l00186"></a>00186   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> local_coarsening_tolerance =
<a name="l00187"></a>00187     local_refinement_tolerance * <a class="code" href="classlibMesh_1_1MeshRefinement.php#aef4c09ce1e49edffc4b7f196d4b91b8a">_coarsen_threshold</a>;
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="comment">// Prepare another error vector if we need to sum parent errors</span>
<a name="l00190"></a>00190   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> error_per_parent;
<a name="l00191"></a>00191   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a>) 
<a name="l00192"></a>00192   {
<a name="l00193"></a>00193     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> parent_error_min, parent_error_max;
<a name="l00194"></a>00194 
<a name="l00195"></a>00195     <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac25b931ac102cee61e84fac044bdbf0a">create_parent_error_vector</a>(error_per_cell_in,
<a name="l00196"></a>00196                                error_per_parent,
<a name="l00197"></a>00197                                parent_error_min,
<a name="l00198"></a>00198                                parent_error_max);
<a name="l00199"></a>00199   }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00202"></a>00202   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00203"></a>00203 
<a name="l00204"></a>00204   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00205"></a>00205   {
<a name="l00206"></a>00206     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00207"></a>00207     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00208"></a>00208     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_number = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00209"></a>00209     <span class="keyword">const</span> <span class="keywordtype">float</span>        elem_error  = error_per_cell_in[elem_number];
<a name="l00210"></a>00210 
<a name="l00211"></a>00211     <span class="keywordflow">if</span> (elem_error &gt; local_refinement_tolerance &amp;&amp;
<a name="l00212"></a>00212         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a>)
<a name="l00213"></a>00213       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00214"></a>00214 
<a name="l00215"></a>00215     <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a> &amp;&amp; elem_error &lt;
<a name="l00216"></a>00216         local_coarsening_tolerance)
<a name="l00217"></a>00217       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a> &amp;&amp; parent)
<a name="l00220"></a>00220     {
<a name="l00221"></a>00221       <span class="keywordtype">float</span> parent_error = error_per_parent[parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()];
<a name="l00222"></a>00222       <span class="keywordflow">if</span> (parent_error &gt;= 0.)
<a name="l00223"></a>00223       {
<a name="l00224"></a>00224         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> parent_coarsening_tolerance =
<a name="l00225"></a>00225           std::sqrt(parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>() *
<a name="l00226"></a>00226                     local_coarsening_tolerance *
<a name="l00227"></a>00227                     local_coarsening_tolerance);
<a name="l00228"></a>00228         <span class="keywordflow">if</span> (parent_error &lt; parent_coarsening_tolerance)
<a name="l00229"></a>00229           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00230"></a>00230       }
<a name="l00231"></a>00231     }
<a name="l00232"></a>00232   }
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a700c8faeb937a543ced5e3979ab06033">00237</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a700c8faeb937a543ced5e3979ab06033">MeshRefinement::flag_elements_by_nelem_target</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell)
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239   <span class="comment">// Check for valid fractions..</span>
<a name="l00240"></a>00240   <span class="comment">// The fraction values must be in [0,1]</span>
<a name="l00241"></a>00241   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &lt;= 1.);
<a name="l00242"></a>00242   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &lt;= 1.);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="comment">// This function is currently only coded to work when coarsening by</span>
<a name="l00245"></a>00245   <span class="comment">// parents - it&#39;s too hard to guess how many coarsenings will be</span>
<a name="l00246"></a>00246   <span class="comment">// performed otherwise.</span>
<a name="l00247"></a>00247   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a>);
<a name="l00248"></a>00248   
<a name="l00249"></a>00249   <span class="comment">// The number of active elements in the mesh - hopefully less than</span>
<a name="l00250"></a>00250   <span class="comment">// 2 billion on 32 bit machines</span>
<a name="l00251"></a>00251   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>();
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">// The maximum number of active elements to flag for coarsening</span>
<a name="l00254"></a>00254   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_elem_coarsen =
<a name="l00255"></a>00255     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> * n_active_elem) + 1;
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="comment">// The maximum number of elements to flag for refinement</span>
<a name="l00258"></a>00258   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_elem_refine  =
<a name="l00259"></a>00259     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  * n_active_elem) + 1;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   <span class="comment">// Clean up the refinement flags.  These could be left</span>
<a name="l00262"></a>00262   <span class="comment">// over from previous refinement steps.</span>
<a name="l00263"></a>00263   this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6930cd279030a81ff6d36a40809b1fd8">clean_refinement_flags</a>();
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <span class="comment">// The target number of elements to add or remove</span>
<a name="l00266"></a>00266   <span class="keyword">const</span> <span class="keywordtype">int</span> n_elem_new = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a9b6e56cf037d2cecb548715dddcd70d2">_nelem_target</a> - n_active_elem;
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <span class="comment">// Create an vector with active element errors and ids,</span>
<a name="l00269"></a>00269   <span class="comment">// sorted by highest errors first</span>
<a name="l00270"></a>00270   std::vector&lt;std::pair&lt;float, unsigned int&gt; &gt; sorted_error;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   sorted_error.reserve (n_active_elem);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274   <span class="comment">// FIXME - this won&#39;t work on a non-serialized mesh yet</span>
<a name="l00275"></a>00275   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00276"></a>00276     {
<a name="l00277"></a>00277       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00278"></a>00278         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;flag_elements_by_nelem_target does not yet &quot;</span>
<a name="l00279"></a>00279                       &lt;&lt; <span class="stringliteral">&quot;work on a parallel mesh.&quot;</span> &lt;&lt; std::endl;
<a name="l00280"></a>00280       libmesh_error();
<a name="l00281"></a>00281     }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00284"></a>00284   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00287"></a>00287     {
<a name="l00288"></a>00288       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> eid = (*elem_it)-&gt;id();
<a name="l00289"></a>00289       libmesh_assert(eid &lt; error_per_cell.size());
<a name="l00290"></a>00290       sorted_error.push_back
<a name="l00291"></a>00291         (std::make_pair(error_per_cell[eid], eid));
<a name="l00292"></a>00292     }
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="comment">// Default sort works since pairs are sorted lexicographically</span>
<a name="l00295"></a>00295   std::sort (sorted_error.begin(), sorted_error.end());
<a name="l00296"></a>00296   std::reverse (sorted_error.begin(), sorted_error.end());
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   <span class="comment">// Create a sorted error vector with coarsenable parent elements</span>
<a name="l00299"></a>00299   <span class="comment">// only, sorted by lowest errors first</span>
<a name="l00300"></a>00300   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> error_per_parent;
<a name="l00301"></a>00301   std::vector&lt;std::pair&lt;float, unsigned int&gt; &gt; sorted_parent_error;
<a name="l00302"></a>00302   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> parent_error_min, parent_error_max;
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac25b931ac102cee61e84fac044bdbf0a">create_parent_error_vector</a>(error_per_cell,
<a name="l00305"></a>00305                              error_per_parent,
<a name="l00306"></a>00306                              parent_error_min,
<a name="l00307"></a>00307                              parent_error_max);
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <span class="comment">// create_parent_error_vector sets values for non-parents and</span>
<a name="l00310"></a>00310   <span class="comment">// non-coarsenable parents to -1.  Get rid of them.</span>
<a name="l00311"></a>00311   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != error_per_parent.size(); ++i)
<a name="l00312"></a>00312     <span class="keywordflow">if</span> (error_per_parent[i] != -1)
<a name="l00313"></a>00313       sorted_parent_error.push_back(std::make_pair(error_per_parent[i], i));
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   std::sort (sorted_parent_error.begin(), sorted_parent_error.end());
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <span class="comment">// Keep track of how many elements we plan to coarsen &amp; refine</span>
<a name="l00318"></a>00318   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> coarsen_count = 0;
<a name="l00319"></a>00319   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> refine_count = 0;
<a name="l00320"></a>00320 
<a name="l00321"></a>00321   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00322"></a>00322   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> twotodim = 1;
<a name="l00323"></a>00323   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=dim; ++i)
<a name="l00324"></a>00324     twotodim *= 2;
<a name="l00325"></a>00325 
<a name="l00326"></a>00326   <span class="comment">// First, let&#39;s try to get our element count to target_nelem</span>
<a name="l00327"></a>00327   <span class="keywordflow">if</span> (n_elem_new &gt;= 0)
<a name="l00328"></a>00328   {
<a name="l00329"></a>00329     <span class="comment">// Every element refinement creates at least </span>
<a name="l00330"></a>00330     <span class="comment">// 2^dim-1 new elements</span>
<a name="l00331"></a>00331     refine_count =
<a name="l00332"></a>00332       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(static_cast&lt;unsigned int&gt;(n_elem_new / (twotodim-1)),
<a name="l00333"></a>00333                max_elem_refine);
<a name="l00334"></a>00334   }
<a name="l00335"></a>00335   <span class="keywordflow">else</span>
<a name="l00336"></a>00336   {
<a name="l00337"></a>00337     <span class="comment">// Every successful element coarsening is likely to destroy</span>
<a name="l00338"></a>00338     <span class="comment">// 2^dim-1 net elements.</span>
<a name="l00339"></a>00339     coarsen_count =
<a name="l00340"></a>00340       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(static_cast&lt;unsigned int&gt;(-n_elem_new / (twotodim-1)),
<a name="l00341"></a>00341                max_elem_coarsen);
<a name="l00342"></a>00342   }
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="comment">// Next, let&#39;s see if we can trade any refinement for coarsening</span>
<a name="l00345"></a>00345   <span class="keywordflow">while</span> (coarsen_count &lt; max_elem_coarsen &amp;&amp;
<a name="l00346"></a>00346          refine_count &lt; max_elem_refine &amp;&amp;
<a name="l00347"></a>00347          coarsen_count &lt; sorted_parent_error.size() &amp;&amp;
<a name="l00348"></a>00348          refine_count &lt; sorted_error.size() &amp;&amp;
<a name="l00349"></a>00349          sorted_error[refine_count].first &gt; 
<a name="l00350"></a>00350          sorted_parent_error[coarsen_count].first * <a class="code" href="classlibMesh_1_1MeshRefinement.php#aef4c09ce1e49edffc4b7f196d4b91b8a">_coarsen_threshold</a>)
<a name="l00351"></a>00351   {
<a name="l00352"></a>00352     coarsen_count++;
<a name="l00353"></a>00353     refine_count++;
<a name="l00354"></a>00354   }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <span class="keywordflow">if</span> (refine_count &gt; max_elem_refine)
<a name="l00357"></a>00357     refine_count = max_elem_refine;
<a name="l00358"></a>00358   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> successful_refine_count = 0;
<a name="l00359"></a>00359   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != sorted_error.size(); ++i)
<a name="l00360"></a>00360     {
<a name="l00361"></a>00361       <span class="keywordflow">if</span> (successful_refine_count &gt;= refine_count)
<a name="l00362"></a>00362         <span class="keywordflow">break</span>;
<a name="l00363"></a>00363 
<a name="l00364"></a>00364       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> eid = sorted_error[i].second;
<a name="l00365"></a>00365       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(eid);
<a name="l00366"></a>00366       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a>)
<a name="l00367"></a>00367         {
<a name="l00368"></a>00368           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00369"></a>00369           successful_refine_count++;
<a name="l00370"></a>00370         }
<a name="l00371"></a>00371     }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373   <span class="comment">// If we couldn&#39;t refine enough elements, don&#39;t coarsen too many</span>
<a name="l00374"></a>00374   <span class="comment">// either</span>
<a name="l00375"></a>00375   <span class="keywordflow">if</span> (coarsen_count &lt; (refine_count - successful_refine_count))
<a name="l00376"></a>00376     coarsen_count = 0;
<a name="l00377"></a>00377   <span class="keywordflow">else</span>
<a name="l00378"></a>00378     coarsen_count -= (refine_count - successful_refine_count);
<a name="l00379"></a>00379 
<a name="l00380"></a>00380   <span class="keywordflow">if</span> (coarsen_count &gt; max_elem_coarsen)
<a name="l00381"></a>00381     coarsen_count = max_elem_coarsen;
<a name="l00382"></a>00382   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> successful_coarsen_count = 0;
<a name="l00383"></a>00383   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != sorted_parent_error.size(); ++i)
<a name="l00384"></a>00384     {
<a name="l00385"></a>00385       <span class="keywordflow">if</span> (successful_coarsen_count &gt;= coarsen_count * twotodim)
<a name="l00386"></a>00386         <span class="keywordflow">break</span>;
<a name="l00387"></a>00387 
<a name="l00388"></a>00388       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_id = sorted_parent_error[i].second;
<a name="l00389"></a>00389       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *parent = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(parent_id);
<a name="l00390"></a>00390       libmesh_assert(parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>());
<a name="l00391"></a>00391       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l00392"></a>00392         {
<a name="l00393"></a>00393           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l00394"></a>00394           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00395"></a>00395             {
<a name="l00396"></a>00396               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00397"></a>00397               successful_coarsen_count++;
<a name="l00398"></a>00398             }
<a name="l00399"></a>00399         }
<a name="l00400"></a>00400     }
<a name="l00401"></a>00401 
<a name="l00402"></a>00402   <span class="comment">// Return true if we&#39;ve done all the AMR/C we can</span>
<a name="l00403"></a>00403   <span class="keywordflow">if</span> (!successful_coarsen_count &amp;&amp; 
<a name="l00404"></a>00404       !successful_refine_count)
<a name="l00405"></a>00405     <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00406"></a>00406   <span class="comment">// And false if there may still be more to do.</span>
<a name="l00407"></a>00407   <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00408"></a>00408 }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 
<a name="l00412"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a50e328f89c951deca3895d130750ac07">00412</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a50e328f89c951deca3895d130750ac07">MeshRefinement::flag_elements_by_elem_fraction</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00413"></a>00413                                                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> refine_frac,
<a name="l00414"></a>00414                                                      <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> coarsen_frac,
<a name="l00415"></a>00415                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_l)
<a name="l00416"></a>00416 {
<a name="l00417"></a>00417   <span class="comment">// FIXME - this won&#39;t work on a non-serialized mesh yet</span>
<a name="l00418"></a>00418   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00419"></a>00419     {
<a name="l00420"></a>00420       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00421"></a>00421         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;flag_elements_by_elem_fraction does not yet &quot;</span>
<a name="l00422"></a>00422                       &lt;&lt; <span class="stringliteral">&quot;work on a parallel mesh.&quot;</span> &lt;&lt; std::endl;
<a name="l00423"></a>00423       libmesh_error();
<a name="l00424"></a>00424     }
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="comment">// The function arguments are currently just there for</span>
<a name="l00427"></a>00427   <span class="comment">// backwards_compatibility</span>
<a name="l00428"></a>00428   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a>)
<a name="l00429"></a>00429   {
<a name="l00430"></a>00430     <span class="comment">// If the user used non-default parameters, lets warn</span>
<a name="l00431"></a>00431     <span class="comment">// that they&#39;re deprecated</span>
<a name="l00432"></a>00432     <span class="keywordflow">if</span> (refine_frac != 0.3 ||
<a name="l00433"></a>00433         coarsen_frac != 0.0 ||
<a name="l00434"></a>00434         max_l != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00435"></a>00435       libmesh_deprecated();
<a name="l00436"></a>00436 
<a name="l00437"></a>00437     <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a> = refine_frac;
<a name="l00438"></a>00438     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> = coarsen_frac;
<a name="l00439"></a>00439     <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a> = max_l;
<a name="l00440"></a>00440   }
<a name="l00441"></a>00441 
<a name="l00442"></a>00442   <span class="comment">// Check for valid fractions..</span>
<a name="l00443"></a>00443   <span class="comment">// The fraction values must be in [0,1]</span>
<a name="l00444"></a>00444   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &lt;= 1.);
<a name="l00445"></a>00445   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &lt;= 1.);
<a name="l00446"></a>00446 
<a name="l00447"></a>00447   <span class="comment">// The number of active elements in the mesh</span>
<a name="l00448"></a>00448   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <span class="comment">// The number of elements to flag for coarsening</span>
<a name="l00451"></a>00451   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_coarsen =
<a name="l00452"></a>00452     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> * n_active_elem);
<a name="l00453"></a>00453 
<a name="l00454"></a>00454   <span class="comment">// The number of elements to flag for refinement</span>
<a name="l00455"></a>00455   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_elem_refine =
<a name="l00456"></a>00456     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  * n_active_elem);
<a name="l00457"></a>00457 
<a name="l00458"></a>00458 
<a name="l00459"></a>00459   
<a name="l00460"></a>00460   <span class="comment">// Clean up the refinement flags.  These could be left</span>
<a name="l00461"></a>00461   <span class="comment">// over from previous refinement steps.</span>
<a name="l00462"></a>00462   this-&gt;<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6930cd279030a81ff6d36a40809b1fd8">clean_refinement_flags</a>();
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465   <span class="comment">// This vector stores the error and element number for all the</span>
<a name="l00466"></a>00466   <span class="comment">// active elements.  It will be sorted and the top &amp; bottom</span>
<a name="l00467"></a>00467   <span class="comment">// elements will then be flagged for coarsening &amp; refinement</span>
<a name="l00468"></a>00468   std::vector&lt;float&gt; sorted_error;
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   sorted_error.reserve (n_active_elem);
<a name="l00471"></a>00471 
<a name="l00472"></a>00472   <span class="comment">// Loop over the active elements and create the entry</span>
<a name="l00473"></a>00473   <span class="comment">// in the sorted_error vector</span>
<a name="l00474"></a>00474   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00475"></a>00475   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00476"></a>00476 
<a name="l00477"></a>00477   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00478"></a>00478     sorted_error.push_back (error_per_cell[(*elem_it)-&gt;id()]);
<a name="l00479"></a>00479 
<a name="l00480"></a>00480   <span class="comment">// Now sort the sorted_error vector</span>
<a name="l00481"></a>00481   std::sort (sorted_error.begin(), sorted_error.end());
<a name="l00482"></a>00482   
<a name="l00483"></a>00483   <span class="comment">// If we&#39;re coarsening by parents:</span>
<a name="l00484"></a>00484   <span class="comment">// Create a sorted error vector with coarsenable parent elements</span>
<a name="l00485"></a>00485   <span class="comment">// only, sorted by lowest errors first</span>
<a name="l00486"></a>00486   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> error_per_parent, sorted_parent_error;
<a name="l00487"></a>00487   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a>)
<a name="l00488"></a>00488   {
<a name="l00489"></a>00489     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> parent_error_min, parent_error_max;
<a name="l00490"></a>00490 
<a name="l00491"></a>00491     <a class="code" href="classlibMesh_1_1MeshRefinement.php#ac25b931ac102cee61e84fac044bdbf0a">create_parent_error_vector</a>(error_per_cell,
<a name="l00492"></a>00492                                error_per_parent,
<a name="l00493"></a>00493                                parent_error_min,
<a name="l00494"></a>00494                                parent_error_max);
<a name="l00495"></a>00495 
<a name="l00496"></a>00496     sorted_parent_error = error_per_parent;
<a name="l00497"></a>00497     std::sort (sorted_parent_error.begin(), sorted_parent_error.end());
<a name="l00498"></a>00498 
<a name="l00499"></a>00499     <span class="comment">// All the other error values will be 0., so get rid of them.</span>
<a name="l00500"></a>00500     sorted_parent_error.erase (std::remove(sorted_parent_error.begin(),
<a name="l00501"></a>00501                                            sorted_parent_error.end(), 0.),
<a name="l00502"></a>00502                                sorted_parent_error.end());
<a name="l00503"></a>00503   }
<a name="l00504"></a>00504   
<a name="l00505"></a>00505 
<a name="l00506"></a>00506   <span class="keywordtype">float</span> top_error= 0., bottom_error = 0.;
<a name="l00507"></a>00507 
<a name="l00508"></a>00508   <span class="comment">// Get the maximum error value corresponding to the</span>
<a name="l00509"></a>00509   <span class="comment">// bottom n_elem_coarsen elements</span>
<a name="l00510"></a>00510   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a> &amp;&amp; n_elem_coarsen)
<a name="l00511"></a>00511     {
<a name="l00512"></a>00512       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00513"></a>00513       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> twotodim = 1;
<a name="l00514"></a>00514       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=dim; ++i)
<a name="l00515"></a>00515         twotodim *= 2;
<a name="l00516"></a>00516 
<a name="l00517"></a>00517       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parent_coarsen = n_elem_coarsen / (twotodim - 1);
<a name="l00518"></a>00518 
<a name="l00519"></a>00519       <span class="keywordflow">if</span> (n_parent_coarsen)
<a name="l00520"></a>00520         bottom_error = sorted_parent_error[n_parent_coarsen - 1];
<a name="l00521"></a>00521     }
<a name="l00522"></a>00522   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (n_elem_coarsen)
<a name="l00523"></a>00523     {
<a name="l00524"></a>00524       bottom_error = sorted_error[n_elem_coarsen - 1];
<a name="l00525"></a>00525     }
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="keywordflow">if</span> (n_elem_refine)
<a name="l00528"></a>00528     top_error = sorted_error[sorted_error.size() - n_elem_refine + 1];
<a name="l00529"></a>00529 
<a name="l00530"></a>00530   <span class="comment">// Finally, let&#39;s do the element flagging</span>
<a name="l00531"></a>00531   elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00532"></a>00532   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00533"></a>00533     {
<a name="l00534"></a>00534       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00535"></a>00535       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00536"></a>00536 
<a name="l00537"></a>00537       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a> &amp;&amp; parent &amp;&amp; n_elem_coarsen &amp;&amp;
<a name="l00538"></a>00538           error_per_parent[parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] &lt;= bottom_error)
<a name="l00539"></a>00539         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00540"></a>00540 
<a name="l00541"></a>00541       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#ab6fda707e1285340135e56469b055746">_coarsen_by_parents</a> &amp;&amp; n_elem_coarsen &amp;&amp;
<a name="l00542"></a>00542           error_per_cell[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] &lt;= bottom_error)
<a name="l00543"></a>00543         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00544"></a>00544 
<a name="l00545"></a>00545       <span class="keywordflow">if</span> (n_elem_refine &amp;&amp;
<a name="l00546"></a>00546           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a> &amp;&amp;
<a name="l00547"></a>00547           error_per_cell[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] &gt;= top_error)
<a name="l00548"></a>00548         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00549"></a>00549     }
<a name="l00550"></a>00550 }
<a name="l00551"></a>00551 
<a name="l00552"></a>00552 
<a name="l00553"></a>00553 
<a name="l00554"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ae0377024040f50645b4eec3d8ebc3268">00554</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ae0377024040f50645b4eec3d8ebc3268">MeshRefinement::flag_elements_by_mean_stddev</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00555"></a>00555                                                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> refine_frac,
<a name="l00556"></a>00556                                                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> coarsen_frac,
<a name="l00557"></a>00557                                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_l)
<a name="l00558"></a>00558 {
<a name="l00559"></a>00559   <span class="comment">// FIXME - this won&#39;t work on a non-serialized mesh yet</span>
<a name="l00560"></a>00560   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00561"></a>00561     {
<a name="l00562"></a>00562       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() == 0)
<a name="l00563"></a>00563         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;flag_elements_by_mean_stddev does not yet &quot;</span>
<a name="l00564"></a>00564                       &lt;&lt; <span class="stringliteral">&quot;work on a parallel mesh.&quot;</span> &lt;&lt; std::endl;
<a name="l00565"></a>00565       libmesh_error();
<a name="l00566"></a>00566     }
<a name="l00567"></a>00567 
<a name="l00568"></a>00568   <span class="comment">// The function arguments are currently just there for</span>
<a name="l00569"></a>00569   <span class="comment">// backwards_compatibility</span>
<a name="l00570"></a>00570   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1MeshRefinement.php#acdeef5e2ff1463f80d57bd343f5ce0f6">_use_member_parameters</a>)
<a name="l00571"></a>00571     {
<a name="l00572"></a>00572       <span class="comment">// If the user used non-default parameters, lets warn</span>
<a name="l00573"></a>00573       <span class="comment">// that they&#39;re deprecated</span>
<a name="l00574"></a>00574       <span class="keywordflow">if</span> (refine_frac != 0.3 ||
<a name="l00575"></a>00575           coarsen_frac != 0.0 ||
<a name="l00576"></a>00576           max_l != <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>)
<a name="l00577"></a>00577         libmesh_deprecated();
<a name="l00578"></a>00578 
<a name="l00579"></a>00579       <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a> = refine_frac;
<a name="l00580"></a>00580       <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> = coarsen_frac;
<a name="l00581"></a>00581       <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a> = max_l;
<a name="l00582"></a>00582     }
<a name="l00583"></a>00583 
<a name="l00584"></a>00584   <span class="comment">// Get the mean value from the error vector</span>
<a name="l00585"></a>00585   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> mean = error_per_cell.<a class="code" href="classlibMesh_1_1ErrorVector.php#ada7e2f1c0df0e837d6e6f18cf5f56077">mean</a>();
<a name="l00586"></a>00586   
<a name="l00587"></a>00587   <span class="comment">// Get the standard deviation.  This equals the</span>
<a name="l00588"></a>00588   <span class="comment">// square-root of the variance</span>
<a name="l00589"></a>00589   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> stddev = std::sqrt (error_per_cell.<a class="code" href="classlibMesh_1_1ErrorVector.php#a961787a0534b54e9debd9a110d315f50">variance</a>());
<a name="l00590"></a>00590   
<a name="l00591"></a>00591   <span class="comment">// Check for valid fractions</span>
<a name="l00592"></a>00592   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  &lt;= 1.);
<a name="l00593"></a>00593   libmesh_assert (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &gt;= 0. &amp;&amp; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> &lt;= 1.);
<a name="l00594"></a>00594 
<a name="l00595"></a>00595   <span class="comment">// The refine and coarsen cutoff</span>
<a name="l00596"></a>00596   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> refine_cutoff  =  mean + <a class="code" href="classlibMesh_1_1MeshRefinement.php#af56d90ecbcb73303903c0e298eea13ec">_refine_fraction</a>  * stddev;
<a name="l00597"></a>00597   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> coarsen_cutoff =  <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(mean - <a class="code" href="classlibMesh_1_1MeshRefinement.php#a04e98b91b8eb9b6ddcf0dff673a1a281">_coarsen_fraction</a> * stddev, 0.);
<a name="l00598"></a>00598       
<a name="l00599"></a>00599   <span class="comment">// Loop over the elements and flag them for coarsening or</span>
<a name="l00600"></a>00600   <span class="comment">// refinement based on the element error</span>
<a name="l00601"></a>00601   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00602"></a>00602   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00603"></a>00603 
<a name="l00604"></a>00604   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00605"></a>00605     {
<a name="l00606"></a>00606       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem             = *elem_it;
<a name="l00607"></a>00607       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>  = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00608"></a>00608 
<a name="l00609"></a>00609       libmesh_assert (<span class="keywordtype">id</span> &lt; error_per_cell.size());
<a name="l00610"></a>00610       
<a name="l00611"></a>00611       <span class="keyword">const</span> <span class="keywordtype">float</span> elem_error = error_per_cell[id];
<a name="l00612"></a>00612 
<a name="l00613"></a>00613       <span class="comment">// Possibly flag the element for coarsening ...</span>
<a name="l00614"></a>00614       <span class="keywordflow">if</span> (elem_error &lt;= coarsen_cutoff)
<a name="l00615"></a>00615         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00616"></a>00616       
<a name="l00617"></a>00617       <span class="comment">// ... or refinement</span>
<a name="l00618"></a>00618       <span class="keywordflow">if</span> ((elem_error &gt;= refine_cutoff) &amp;&amp; (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; <a class="code" href="classlibMesh_1_1MeshRefinement.php#a80ebcf25e84315a95e59128b57c5834f">_max_h_level</a>))
<a name="l00619"></a>00619         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00620"></a>00620     }
<a name="l00621"></a>00621 }
<a name="l00622"></a>00622 
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f565f6b741867544c70a2c96ef728f0">00625</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a4f565f6b741867544c70a2c96ef728f0">MeshRefinement::switch_h_to_p_refinement</a> ()
<a name="l00626"></a>00626 {
<a name="l00627"></a>00627   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00628"></a>00628   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l00629"></a>00629 
<a name="l00630"></a>00630   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00631"></a>00631     {
<a name="l00632"></a>00632       <span class="keywordflow">if</span> ((*elem_it)-&gt;active())
<a name="l00633"></a>00633         {
<a name="l00634"></a>00634           (*elem_it)-&gt;set_p_refinement_flag((*elem_it)-&gt;refinement_flag());
<a name="l00635"></a>00635           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00636"></a>00636         } 
<a name="l00637"></a>00637       <span class="keywordflow">else</span>
<a name="l00638"></a>00638         {
<a name="l00639"></a>00639           (*elem_it)-&gt;set_p_refinement_flag((*elem_it)-&gt;refinement_flag());
<a name="l00640"></a>00640           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00641"></a>00641         } 
<a name="l00642"></a>00642     }
<a name="l00643"></a>00643 }
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 
<a name="l00646"></a>00646 
<a name="l00647"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#ab3f2ecc36e231ddc26798014ee133045">00647</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#ab3f2ecc36e231ddc26798014ee133045">MeshRefinement::add_p_to_h_refinement</a> ()
<a name="l00648"></a>00648 {
<a name="l00649"></a>00649   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00650"></a>00650   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00653"></a>00653     (*elem_it)-&gt;set_p_refinement_flag((*elem_it)-&gt;refinement_flag());
<a name="l00654"></a>00654 }
<a name="l00655"></a>00655 
<a name="l00656"></a>00656 
<a name="l00657"></a>00657 
<a name="l00658"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a6930cd279030a81ff6d36a40809b1fd8">00658</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6930cd279030a81ff6d36a40809b1fd8">MeshRefinement::clean_refinement_flags</a> ()
<a name="l00659"></a>00659 {
<a name="l00660"></a>00660   <span class="comment">// Possibly clean up the refinement flags from</span>
<a name="l00661"></a>00661   <span class="comment">// a previous step</span>
<a name="l00662"></a>00662 <span class="comment">//   elem_iterator       elem_it (_mesh.elements_begin());</span>
<a name="l00663"></a>00663 <span class="comment">//   const elem_iterator elem_end(_mesh.elements_end());</span>
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00666"></a>00666   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00669"></a>00669     {
<a name="l00670"></a>00670       <span class="keywordflow">if</span> ((*elem_it)-&gt;active())
<a name="l00671"></a>00671         {
<a name="l00672"></a>00672           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00673"></a>00673           (*elem_it)-&gt;set_p_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00674"></a>00674         } 
<a name="l00675"></a>00675       <span class="keywordflow">else</span>
<a name="l00676"></a>00676         {
<a name="l00677"></a>00677           (*elem_it)-&gt;set_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00678"></a>00678           (*elem_it)-&gt;set_p_refinement_flag(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00679"></a>00679         } 
<a name="l00680"></a>00680     }
<a name="l00681"></a>00681 }
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 } <span class="comment">// namespace libMesh</span>
<a name="l00684"></a>00684 
<a name="l00685"></a>00685 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
