<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_refinement_smoothing.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__refinement__smoothing_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_refinement_smoothing.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// only compile these functions if the user requests AMR support</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__refinement_8h.php">mesh_refinement.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="remote__elem_8h.php">remote_elem.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="comment">// Mesh refinement methods</span>
<a name="l00041"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#acbc5744304854c3ce239abced653624e">00041</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#acbc5744304854c3ce239abced653624e">MeshRefinement::limit_level_mismatch_at_node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_mismatch)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00044"></a>00044   parallel_only();
<a name="l00045"></a>00045 
<a name="l00046"></a>00046   <span class="keywordtype">bool</span> flags_changed = <span class="keyword">false</span>;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049   <span class="comment">// Vector holding the maximum element level that touches a node.</span>
<a name="l00050"></a>00050   std::vector&lt;unsigned char&gt; max_level_at_node (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(), 0);
<a name="l00051"></a>00051   std::vector&lt;unsigned char&gt; max_p_level_at_node (<a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(), 0);
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054   <span class="comment">// Loop over all the active elements &amp; fill the vector</span>
<a name="l00055"></a>00055   {
<a name="l00056"></a>00056     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00057"></a>00057     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00058"></a>00058     
<a name="l00059"></a>00059     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00060"></a>00060       {
<a name="l00061"></a>00061         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;    
<a name="l00062"></a>00062         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> elem_level =
<a name="l00063"></a>00063           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() + ((elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>) ? 1 : 0);
<a name="l00064"></a>00064         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> elem_p_level =
<a name="l00065"></a>00065           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() + ((elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>) ? 1 : 0);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067         <span class="comment">// Set the max_level at each node</span>
<a name="l00068"></a>00068         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00069"></a>00069           {
<a name="l00070"></a>00070             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_number = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072             libmesh_assert (node_number &lt; max_level_at_node.size());
<a name="l00073"></a>00073             
<a name="l00074"></a>00074             max_level_at_node[node_number] =
<a name="l00075"></a>00075               <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (max_level_at_node[node_number], elem_level);
<a name="l00076"></a>00076             max_p_level_at_node[node_number] =
<a name="l00077"></a>00077               <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (max_p_level_at_node[node_number], elem_p_level);
<a name="l00078"></a>00078           }
<a name="l00079"></a>00079       }     
<a name="l00080"></a>00080   }
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="comment">// Now loop over the active elements and flag the elements</span>
<a name="l00084"></a>00084   <span class="comment">// who violate the requested level mismatch</span>
<a name="l00085"></a>00085   {
<a name="l00086"></a>00086     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00087"></a>00087     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00088"></a>00088     
<a name="l00089"></a>00089     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00090"></a>00090       {
<a name="l00091"></a>00091         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;  
<a name="l00092"></a>00092         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>();
<a name="l00093"></a>00093         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_p_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00094"></a>00094         
<a name="l00095"></a>00095         <span class="comment">// Skip the element if it is already fully flagged</span>
<a name="l00096"></a>00096         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a> &amp;&amp;
<a name="l00097"></a>00097             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00098"></a>00098           <span class="keywordflow">continue</span>;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100         <span class="comment">// Loop over the nodes, check for possible mismatch</span>
<a name="l00101"></a>00101         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00102"></a>00102           {
<a name="l00103"></a>00103             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_number = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105             <span class="comment">// Flag the element for refinement if it violates</span>
<a name="l00106"></a>00106             <span class="comment">// the requested level mismatch</span>
<a name="l00107"></a>00107             <span class="keywordflow">if</span> ( (elem_level + max_mismatch) &lt; max_level_at_node[node_number]
<a name="l00108"></a>00108                  &amp;&amp; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00109"></a>00109               {
<a name="l00110"></a>00110                 elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a> (<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00111"></a>00111                 flags_changed = <span class="keyword">true</span>;
<a name="l00112"></a>00112               }
<a name="l00113"></a>00113             <span class="keywordflow">if</span> ( (elem_p_level + max_mismatch) &lt; max_p_level_at_node[node_number]
<a name="l00114"></a>00114                  &amp;&amp; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00115"></a>00115               {
<a name="l00116"></a>00116                 elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a> (<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00117"></a>00117                 flags_changed = <span class="keyword">true</span>;
<a name="l00118"></a>00118               }
<a name="l00119"></a>00119           }
<a name="l00120"></a>00120       }     
<a name="l00121"></a>00121   }
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <span class="comment">// If flags changed on any processor then they changed globally</span>
<a name="l00124"></a>00124   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(flags_changed);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="keywordflow">return</span> flags_changed;
<a name="l00127"></a>00127 }
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00132"></a>00132 <span class="comment">// Mesh refinement methods</span>
<a name="l00133"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a6726f2900feee33e74f571aa31a9d545">00133</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6726f2900feee33e74f571aa31a9d545">MeshRefinement::limit_level_mismatch_at_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_mismatch)
<a name="l00134"></a>00134 {
<a name="l00135"></a>00135   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00136"></a>00136   parallel_only();
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="keywordtype">bool</span> flags_changed = <span class="keyword">false</span>;
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141   <span class="comment">// Maps holding the maximum element level that touches an edge</span>
<a name="l00142"></a>00142   std::map&lt;std::pair&lt;unsigned int, unsigned int&gt;, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&gt;
<a name="l00143"></a>00143     max_level_at_edge;
<a name="l00144"></a>00144   std::map&lt;std::pair&lt;unsigned int, unsigned int&gt;, <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span>&gt;
<a name="l00145"></a>00145     max_p_level_at_edge;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="comment">// Loop over all the active elements &amp; fill the maps</span>
<a name="l00148"></a>00148   {
<a name="l00149"></a>00149     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00150"></a>00150     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00151"></a>00151     
<a name="l00152"></a>00152     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00153"></a>00153       {
<a name="l00154"></a>00154         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;    
<a name="l00155"></a>00155         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> elem_level =
<a name="l00156"></a>00156           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() + ((elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>) ? 1 : 0);
<a name="l00157"></a>00157         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> elem_p_level =
<a name="l00158"></a>00158           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() + ((elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>) ? 1 : 0);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160         <span class="comment">// Set the max_level at each edge</span>
<a name="l00161"></a>00161         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adde1fccc9a1fc4b43485629cb6c4062b">n_edges</a>(); n++)
<a name="l00162"></a>00162           {
<a name="l00163"></a>00163             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> edge = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2b0590037d655ea1b3f325137fe142e7">build_edge</a>(n);
<a name="l00164"></a>00164             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> childnode0 = edge-&gt;node(0);
<a name="l00165"></a>00165             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> childnode1 = edge-&gt;node(1);
<a name="l00166"></a>00166             <span class="keywordflow">if</span> (childnode1 &lt; childnode0)
<a name="l00167"></a>00167               std::swap(childnode0, childnode1);
<a name="l00168"></a>00168 
<a name="l00169"></a>00169             <span class="keywordflow">for</span> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *p = elem; p != NULL; p = p-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>())
<a name="l00170"></a>00170               {
<a name="l00171"></a>00171                 <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> pedge = p-&gt;build_edge(n);
<a name="l00172"></a>00172                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node0 = pedge-&gt;node(0);
<a name="l00173"></a>00173                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node1 = pedge-&gt;node(1);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175                 <span class="keywordflow">if</span> (node1 &lt; node0)
<a name="l00176"></a>00176                   std::swap(node0, node1);
<a name="l00177"></a>00177                 
<a name="l00178"></a>00178                 <span class="comment">// If elem does not share this edge with its ancestor</span>
<a name="l00179"></a>00179                 <span class="comment">// p, refinement levels of elements sharing p&#39;s edge</span>
<a name="l00180"></a>00180                 <span class="comment">// are not restricted by refinement levels of elem.</span>
<a name="l00181"></a>00181                 <span class="comment">// Furthermore, elem will not share this edge with any</span>
<a name="l00182"></a>00182                 <span class="comment">// of p&#39;s ancestors, so we can safely break out of the</span>
<a name="l00183"></a>00183                 <span class="comment">// for loop early.</span>
<a name="l00184"></a>00184                 <span class="keywordflow">if</span> (node0 != childnode0 &amp;&amp; node1 != childnode1)
<a name="l00185"></a>00185                   <span class="keywordflow">break</span>;
<a name="l00186"></a>00186 
<a name="l00187"></a>00187                 childnode0 = node0;
<a name="l00188"></a>00188                 childnode1 = node1;
<a name="l00189"></a>00189 
<a name="l00190"></a>00190                 std::pair&lt;unsigned int, unsigned int&gt; edge_key =
<a name="l00191"></a>00191                   std::make_pair(node0, node1);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193                 <span class="keywordflow">if</span> (max_level_at_edge.find(edge_key) ==
<a name="l00194"></a>00194                     max_level_at_edge.end())
<a name="l00195"></a>00195                   {
<a name="l00196"></a>00196                     max_level_at_edge[edge_key] = elem_level;
<a name="l00197"></a>00197                     max_p_level_at_edge[edge_key] = elem_p_level;
<a name="l00198"></a>00198                   }
<a name="l00199"></a>00199                 <span class="keywordflow">else</span>
<a name="l00200"></a>00200                   {
<a name="l00201"></a>00201                     max_level_at_edge[edge_key] =
<a name="l00202"></a>00202                       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (max_level_at_edge[edge_key], elem_level);
<a name="l00203"></a>00203                     max_p_level_at_edge[edge_key] =
<a name="l00204"></a>00204                       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (max_p_level_at_edge[edge_key], elem_p_level);
<a name="l00205"></a>00205                   }
<a name="l00206"></a>00206               }
<a name="l00207"></a>00207           }
<a name="l00208"></a>00208       }     
<a name="l00209"></a>00209   }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212   <span class="comment">// Now loop over the active elements and flag the elements</span>
<a name="l00213"></a>00213   <span class="comment">// who violate the requested level mismatch</span>
<a name="l00214"></a>00214   {
<a name="l00215"></a>00215     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00216"></a>00216     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00217"></a>00217     
<a name="l00218"></a>00218     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00219"></a>00219       {
<a name="l00220"></a>00220         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;  
<a name="l00221"></a>00221         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>();
<a name="l00222"></a>00222         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_p_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>();
<a name="l00223"></a>00223         
<a name="l00224"></a>00224         <span class="comment">// Skip the element if it is already fully flagged</span>
<a name="l00225"></a>00225         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a> &amp;&amp;
<a name="l00226"></a>00226             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00227"></a>00227           <span class="keywordflow">continue</span>;
<a name="l00228"></a>00228 
<a name="l00229"></a>00229         <span class="comment">// Loop over the nodes, check for possible mismatch</span>
<a name="l00230"></a>00230         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adde1fccc9a1fc4b43485629cb6c4062b">n_edges</a>(); n++)
<a name="l00231"></a>00231           {
<a name="l00232"></a>00232             <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> edge = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2b0590037d655ea1b3f325137fe142e7">build_edge</a>(n);
<a name="l00233"></a>00233             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node0 = edge-&gt;node(0);
<a name="l00234"></a>00234             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node1 = edge-&gt;node(1);
<a name="l00235"></a>00235             <span class="keywordflow">if</span> (node1 &lt; node0)
<a name="l00236"></a>00236               std::swap(node0, node1);
<a name="l00237"></a>00237 
<a name="l00238"></a>00238             std::pair&lt;unsigned int, unsigned int&gt; edge_key =
<a name="l00239"></a>00239               std::make_pair(node0, node1);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241             <span class="comment">// Flag the element for refinement if it violates</span>
<a name="l00242"></a>00242             <span class="comment">// the requested level mismatch</span>
<a name="l00243"></a>00243             <span class="keywordflow">if</span> ( (elem_level + max_mismatch) &lt; max_level_at_edge[edge_key]
<a name="l00244"></a>00244                  &amp;&amp; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00245"></a>00245               {
<a name="l00246"></a>00246                 elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a> (<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00247"></a>00247                 flags_changed = <span class="keyword">true</span>;
<a name="l00248"></a>00248               }
<a name="l00249"></a>00249             <span class="keywordflow">if</span> ( (elem_p_level + max_mismatch) &lt; max_p_level_at_edge[edge_key]
<a name="l00250"></a>00250                  &amp;&amp; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00251"></a>00251               {
<a name="l00252"></a>00252                 elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a> (<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00253"></a>00253                 flags_changed = <span class="keyword">true</span>;
<a name="l00254"></a>00254               }
<a name="l00255"></a>00255           }
<a name="l00256"></a>00256       }     
<a name="l00257"></a>00257   }
<a name="l00258"></a>00258   
<a name="l00259"></a>00259   <span class="comment">// If flags changed on any processor then they changed globally</span>
<a name="l00260"></a>00260   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(flags_changed);
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   <span class="keywordflow">return</span> flags_changed;
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a><a class="code" href="classlibMesh_1_1MeshRefinement.php#a2f57c999ade430e94e7cf25bfc97eb07">00268</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshRefinement.php#a2f57c999ade430e94e7cf25bfc97eb07">MeshRefinement::eliminate_unrefined_patches</a> ()
<a name="l00269"></a>00269 {
<a name="l00270"></a>00270   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00271"></a>00271   parallel_only();
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   <span class="keywordtype">bool</span> flags_changed = <span class="keyword">false</span>;
<a name="l00274"></a>00274 
<a name="l00275"></a>00275   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00276"></a>00276   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = <a class="code" href="classlibMesh_1_1MeshRefinement.php#a6df23471791e621cfeb7a7828c8c73a2">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00279"></a>00279     {
<a name="l00280"></a>00280       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00281"></a>00281       <span class="comment">// First assume that we&#39;ll have to flag this element for both h</span>
<a name="l00282"></a>00282       <span class="comment">// and p refinement, then change our minds if we see any</span>
<a name="l00283"></a>00283       <span class="comment">// neighbors that are as coarse or coarser than us.</span>
<a name="l00284"></a>00284       <span class="keywordtype">bool</span> h_flag_me = <span class="keyword">true</span>,
<a name="l00285"></a>00285            p_flag_me = <span class="keyword">true</span>;
<a name="l00286"></a>00286 
<a name="l00287"></a>00287 
<a name="l00288"></a>00288       <span class="comment">// Skip the element if it is already fully flagged for refinement</span>
<a name="l00289"></a>00289       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00290"></a>00290         p_flag_me = <span class="keyword">false</span>;
<a name="l00291"></a>00291       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00292"></a>00292         {
<a name="l00293"></a>00293           h_flag_me = <span class="keyword">false</span>;
<a name="l00294"></a>00294           <span class="keywordflow">if</span> (!p_flag_me)
<a name="l00295"></a>00295             <span class="keywordflow">continue</span>;
<a name="l00296"></a>00296         }
<a name="l00297"></a>00297       <span class="comment">// Test the parent if that is already flagged for coarsening</span>
<a name="l00298"></a>00298       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l00299"></a>00299         {
<a name="l00300"></a>00300           libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>());
<a name="l00301"></a>00301           elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00302"></a>00302           <span class="comment">// FIXME - this doesn&#39;t seem right - RHS</span>
<a name="l00303"></a>00303           <span class="keywordflow">if</span> (elem-&gt;refinement_flag() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">Elem::COARSEN_INACTIVE</a>)
<a name="l00304"></a>00304             <span class="keywordflow">continue</span>;
<a name="l00305"></a>00305           p_flag_me = <span class="keyword">false</span>;
<a name="l00306"></a>00306         }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>();
<a name="l00309"></a>00309       <span class="keywordtype">int</span> my_p_adjustment = 0;
<a name="l00310"></a>00310       <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00311"></a>00311         my_p_adjustment = 1;
<a name="l00312"></a>00312       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l00313"></a>00313         {
<a name="l00314"></a>00314           libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; 0);
<a name="l00315"></a>00315           my_p_adjustment = -1;
<a name="l00316"></a>00316         }
<a name="l00317"></a>00317       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_new_p_level = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() +
<a name="l00318"></a>00318                                           my_p_adjustment;
<a name="l00319"></a>00319 
<a name="l00320"></a>00320       <span class="comment">// Check all the element neighbors</span>
<a name="l00321"></a>00321       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); n++)
<a name="l00322"></a>00322         {
<a name="l00323"></a>00323           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n);
<a name="l00324"></a>00324           <span class="comment">// Quit if the element is on a local boundary</span>
<a name="l00325"></a>00325           <span class="keywordflow">if</span> (neighbor == NULL || neighbor == <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00326"></a>00326             {
<a name="l00327"></a>00327               h_flag_me = <span class="keyword">false</span>;
<a name="l00328"></a>00328               p_flag_me = <span class="keyword">false</span>;
<a name="l00329"></a>00329               <span class="keywordflow">break</span>;
<a name="l00330"></a>00330             }
<a name="l00331"></a>00331           <span class="comment">// if the neighbor will be equally or less refined than</span>
<a name="l00332"></a>00332           <span class="comment">// we are, then we will not become an unrefined island.</span>
<a name="l00333"></a>00333           <span class="comment">// So if we are still considering h refinement:</span>
<a name="l00334"></a>00334           <span class="keywordflow">if</span> (h_flag_me &amp;&amp;
<a name="l00335"></a>00335             <span class="comment">// If our neighbor is already at a lower level,</span>
<a name="l00336"></a>00336             <span class="comment">// it can&#39;t end up at a higher level even if it</span>
<a name="l00337"></a>00337             <span class="comment">// is flagged for refinement once</span>
<a name="l00338"></a>00338              ((neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; my_level) ||
<a name="l00339"></a>00339             <span class="comment">// If our neighbor is at the same level but isn&#39;t</span>
<a name="l00340"></a>00340             <span class="comment">// flagged for refinement, it won&#39;t end up at a</span>
<a name="l00341"></a>00341             <span class="comment">// higher level</span>
<a name="l00342"></a>00342              ((neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>()) &amp;&amp;
<a name="l00343"></a>00343               (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() != <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)) ||
<a name="l00344"></a>00344             <span class="comment">// If our neighbor is currently more refined but is</span>
<a name="l00345"></a>00345             <span class="comment">// a parent flagged for coarsening, it will end up</span>
<a name="l00346"></a>00346             <span class="comment">// at the same level.</span>
<a name="l00347"></a>00347              (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">Elem::COARSEN_INACTIVE</a>)))
<a name="l00348"></a>00348             {
<a name="l00349"></a>00349               <span class="comment">// We&#39;ve proven we won&#39;t become an unrefined island,</span>
<a name="l00350"></a>00350               <span class="comment">// so don&#39;t h refine to avoid that.</span>
<a name="l00351"></a>00351               h_flag_me = <span class="keyword">false</span>;
<a name="l00352"></a>00352 
<a name="l00353"></a>00353               <span class="comment">// If we&#39;ve also proven we don&#39;t need to p refine,</span>
<a name="l00354"></a>00354               <span class="comment">// we don&#39;t need to check more neighbors</span>
<a name="l00355"></a>00355               <span class="keywordflow">if</span> (!p_flag_me)
<a name="l00356"></a>00356                 <span class="keywordflow">break</span>;
<a name="l00357"></a>00357             }
<a name="l00358"></a>00358           <span class="keywordflow">if</span> (p_flag_me)
<a name="l00359"></a>00359             {
<a name="l00360"></a>00360               <span class="comment">// if active neighbors will have a p level</span>
<a name="l00361"></a>00361               <span class="comment">// equal to or lower than ours, then we do not need to p</span>
<a name="l00362"></a>00362               <span class="comment">// refine ourselves.</span>
<a name="l00363"></a>00363               <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00364"></a>00364                 {
<a name="l00365"></a>00365                   <span class="keywordtype">int</span> p_adjustment = 0;
<a name="l00366"></a>00366                   <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>)
<a name="l00367"></a>00367                     p_adjustment = 1;
<a name="l00368"></a>00368                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l00369"></a>00369                     {
<a name="l00370"></a>00370                       libmesh_assert(neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() &gt; 0);
<a name="l00371"></a>00371                       p_adjustment = -1;
<a name="l00372"></a>00372                     }
<a name="l00373"></a>00373                   <span class="keywordflow">if</span> (my_new_p_level &gt;= neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>() + p_adjustment)
<a name="l00374"></a>00374                     {
<a name="l00375"></a>00375                       p_flag_me = <span class="keyword">false</span>;
<a name="l00376"></a>00376                       <span class="keywordflow">if</span> (!h_flag_me)
<a name="l00377"></a>00377                         <span class="keywordflow">break</span>;
<a name="l00378"></a>00378                     }
<a name="l00379"></a>00379                 }
<a name="l00380"></a>00380               <span class="comment">// If we have inactive neighbors, we need to</span>
<a name="l00381"></a>00381               <span class="comment">// test all their active descendants which neighbor us</span>
<a name="l00382"></a>00382               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d132de7da15df7db92f8995cc234b87">ancestor</a>())
<a name="l00383"></a>00383                 {
<a name="l00384"></a>00384                   <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae4ccfe379ed5d23c4ae165e095867c22">min_new_p_level_by_neighbor</a>(elem,
<a name="l00385"></a>00385                       my_new_p_level + 2) &lt;= my_new_p_level)
<a name="l00386"></a>00386                     {
<a name="l00387"></a>00387                       p_flag_me = <span class="keyword">false</span>;
<a name="l00388"></a>00388                       <span class="keywordflow">if</span> (!h_flag_me)
<a name="l00389"></a>00389                         <span class="keywordflow">break</span>;
<a name="l00390"></a>00390                     }
<a name="l00391"></a>00391                 }
<a name="l00392"></a>00392             }
<a name="l00393"></a>00393         }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395       <span class="keywordflow">if</span> (h_flag_me)
<a name="l00396"></a>00396         {
<a name="l00397"></a>00397           <span class="comment">// Parents that would create islands should no longer</span>
<a name="l00398"></a>00398           <span class="comment">// coarsen</span>
<a name="l00399"></a>00399           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a560ee64b3c009f94569a135dce55c8b6">Elem::COARSEN_INACTIVE</a>)
<a name="l00400"></a>00400             {
<a name="l00401"></a>00401               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00402"></a>00402                 {
<a name="l00403"></a>00403                   libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>() ==
<a name="l00404"></a>00404                          <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>);
<a name="l00405"></a>00405                   elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00406"></a>00406                 }
<a name="l00407"></a>00407               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54af7c2ef5bee86b20e0a4e1cebd140caef">Elem::INACTIVE</a>);
<a name="l00408"></a>00408             }
<a name="l00409"></a>00409           <span class="keywordflow">else</span>
<a name="l00410"></a>00410             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adb60ffafaf6ebf931978c9335d278b46">set_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00411"></a>00411           flags_changed = <span class="keyword">true</span>;
<a name="l00412"></a>00412         }      
<a name="l00413"></a>00413       <span class="keywordflow">if</span> (p_flag_me)
<a name="l00414"></a>00414         {
<a name="l00415"></a>00415           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>() == <a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a7d9c31942b061618643ecf815f74dd2c">Elem::COARSEN</a>)
<a name="l00416"></a>00416             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a5a64eb29d0df43150a3b87184fb56be4">Elem::DO_NOTHING</a>);
<a name="l00417"></a>00417           <span class="keywordflow">else</span> 
<a name="l00418"></a>00418             elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a13716b8bb2b92fa2244f6f4f375a0004">set_p_refinement_flag</a>(<a class="code" href="classlibMesh_1_1Elem.php#a674d499e6c104bc63a68ca7e9c7ccb54a1511a7045e9a76eaa3b5b0f9511dd01b">Elem::REFINE</a>);
<a name="l00419"></a>00419           flags_changed = <span class="keyword">true</span>;
<a name="l00420"></a>00420         }      
<a name="l00421"></a>00421     }
<a name="l00422"></a>00422 
<a name="l00423"></a>00423   <span class="comment">// If flags changed on any processor then they changed globally</span>
<a name="l00424"></a>00424   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(flags_changed);
<a name="l00425"></a>00425 
<a name="l00426"></a>00426   <span class="keywordflow">return</span> flags_changed;
<a name="l00427"></a>00427 }
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 } <span class="comment">// namespace libMesh</span>
<a name="l00430"></a>00430 
<a name="l00431"></a>00431 
<a name="l00432"></a>00432 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
