<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_smoother_laplace.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__smoother__laplace_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_smoother_laplace.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::copy, std::sort</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__smoother__laplace_8h.php">mesh_smoother_laplace.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Member functions for the Laplace smoother</span>
<a name="l00036"></a><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a1d5f1e8b782c38b3524b3b1f0e268e0a">00036</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a615d5ae879810c1d228f33d38bd0cb13">LaplaceMeshSmoother::smooth</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_iterations)
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a607905beabcc58f01ff253b7873b2697">_initialized</a>)
<a name="l00039"></a>00039     this-&gt;<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a623528543d038460e488e77bab010d33">init</a>();
<a name="l00040"></a>00040   
<a name="l00041"></a>00041   <span class="comment">// Don&#39;t smooth the nodes on the boundary...</span>
<a name="l00042"></a>00042   <span class="comment">// this would change the mesh geometry which</span>
<a name="l00043"></a>00043   <span class="comment">// is probably not something we want!</span>
<a name="l00044"></a>00044   std::vector&lt;bool&gt; on_boundary;
<a name="l00045"></a>00045   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a0fd39d630f54c93571ee6449e8b15550">MeshTools::find_boundary_nodes</a>(<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>, on_boundary);
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="comment">// We can only update the nodes after all new positions were</span>
<a name="l00048"></a>00048   <span class="comment">// determined. We store the new positions here</span>
<a name="l00049"></a>00049   std::vector&lt;Point&gt; new_positions;
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;n_iterations; n++)
<a name="l00052"></a>00052     {
<a name="l00053"></a>00053       new_positions.resize(<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00054"></a>00054       
<a name="l00055"></a>00055       <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00056"></a>00056            it != <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00057"></a>00057            ++it) 
<a name="l00058"></a>00058         {
<a name="l00059"></a>00059           <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = *it;
<a name="l00060"></a>00060           <span class="comment">// leave the boundary intact</span>
<a name="l00061"></a>00061           <span class="comment">// Only relocate the nodes which are vertices of an element</span>
<a name="l00062"></a>00062           <span class="comment">// All other entries of _graph (the secondary nodes) are empty</span>
<a name="l00063"></a>00063           <span class="keywordflow">if</span> (!on_boundary[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] &amp;&amp; (<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()].size() &gt; 0) )
<a name="l00064"></a>00064             {
<a name="l00065"></a>00065               <a class="code" href="classlibMesh_1_1Point.php">Point</a> avg_position(0.,0.,0.);
<a name="l00066"></a>00066               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()].size(); ++j)
<a name="l00067"></a>00067                 avg_position.<a class="code" href="classlibMesh_1_1TypeVector.php#a670ef717fd81b3b529503ecec7a949da">add</a>(<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()][j]));
<a name="l00068"></a>00068               new_positions[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = avg_position /
<a name="l00069"></a>00069                 <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()].size());
<a name="l00070"></a>00070             }
<a name="l00071"></a>00071         }
<a name="l00072"></a>00072       
<a name="l00073"></a>00073       <span class="comment">// now update the node positions</span>
<a name="l00074"></a>00074       <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00075"></a>00075            it != <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00076"></a>00076            ++it)
<a name="l00077"></a>00077         {
<a name="l00078"></a>00078           <a class="code" href="classlibMesh_1_1Node.php">Node</a>* node = *it;
<a name="l00079"></a>00079           
<a name="l00080"></a>00080           <span class="keywordflow">if</span> (!on_boundary[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] &amp;&amp; (<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()].size() &gt; 0) )
<a name="l00081"></a>00081             {
<a name="l00082"></a>00082               <span class="comment">// Should call Point::op=</span>
<a name="l00083"></a>00083               <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()) = new_positions[node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()];
<a name="l00084"></a>00084             }
<a name="l00085"></a>00085         }
<a name="l00086"></a>00086     }
<a name="l00087"></a>00087   
<a name="l00088"></a>00088   <span class="comment">// finally adjust the second order nodes (those located between vertices)</span>
<a name="l00089"></a>00089   <span class="comment">// these nodes will be located between their adjacent nodes</span>
<a name="l00090"></a>00090   <span class="comment">// do this element-wise</span>
<a name="l00091"></a>00091   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00092"></a>00092   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00093"></a>00093         
<a name="l00094"></a>00094   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00095"></a>00095     {
<a name="l00096"></a>00096       <span class="comment">// Constant handle for the element</span>
<a name="l00097"></a>00097       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00098"></a>00098 
<a name="l00099"></a>00099       <span class="comment">// get the second order nodes (son)</span>
<a name="l00100"></a>00100       <span class="comment">// their element indices start at n_vertices and go to n_nodes</span>
<a name="l00101"></a>00101       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_begin = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a27233687bfcc3f1988777fb8e2e514d1">n_vertices</a>();
<a name="l00102"></a>00102       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son_end   = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00103"></a>00103       
<a name="l00104"></a>00104       <span class="comment">// loop over all second order nodes (son)</span>
<a name="l00105"></a>00105       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> son=son_begin; son&lt;son_end; son++)
<a name="l00106"></a>00106         {
<a name="l00107"></a>00107           <span class="comment">// Don&#39;t smooth second-order nodes which are on the boundary</span>
<a name="l00108"></a>00108           <span class="keywordflow">if</span> (!on_boundary[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(son)])
<a name="l00109"></a>00109             {
<a name="l00110"></a>00110               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_adjacent_vertices =
<a name="l00111"></a>00111                 elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a5175062272874a37befab4a16ce68eaf">n_second_order_adjacent_vertices</a>(son);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113               <span class="comment">// calculate the new position which is the average of the</span>
<a name="l00114"></a>00114               <span class="comment">// position of the adjacent vertices</span>
<a name="l00115"></a>00115               <a class="code" href="classlibMesh_1_1Point.php">Point</a> avg_position(0,0,0);
<a name="l00116"></a>00116               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=0; v&lt;n_adjacent_vertices; v++)
<a name="l00117"></a>00117                 avg_position +=
<a name="l00118"></a>00118                   <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>( elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>( elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a430e1bdb48a91b50f7d22c203de8129f">second_order_adjacent_vertex</a>(son,v) ) );
<a name="l00119"></a>00119 
<a name="l00120"></a>00120               <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(son)) = avg_position / n_adjacent_vertices;
<a name="l00121"></a>00121             }
<a name="l00122"></a>00122         }
<a name="l00123"></a>00123     }
<a name="l00124"></a>00124 }
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a623528543d038460e488e77bab010d33">00127</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a623528543d038460e488e77bab010d33">LaplaceMeshSmoother::init</a>()
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131   <span class="keywordflow">switch</span> (<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>())
<a name="l00132"></a>00132     {
<a name="l00133"></a>00133       
<a name="l00134"></a>00134       <span class="comment">// TODO:[BSK] Fix this to work for refined meshes...  I think</span>
<a name="l00135"></a>00135       <span class="comment">// the implementation was done quickly for Damien, who did not have</span>
<a name="l00136"></a>00136       <span class="comment">// refined grids.  Fix it here and in the original Mesh member.</span>
<a name="l00137"></a>00137       
<a name="l00138"></a>00138     <span class="keywordflow">case</span> 2: <span class="comment">// Stolen directly from build_L_graph in mesh_base.C</span>
<a name="l00139"></a>00139       {
<a name="l00140"></a>00140         <span class="comment">// Initialize space in the graph.  It is n_nodes</span>
<a name="l00141"></a>00141         <span class="comment">// long and each node is assumed to be connected to</span>
<a name="l00142"></a>00142         <span class="comment">// approximately 4 neighbors.</span>
<a name="l00143"></a>00143         <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>.resize(<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00144"></a>00144 <span class="comment">//      for (unsigned int i=0; i&lt;_mesh.n_nodes(); ++i)</span>
<a name="l00145"></a>00145 <span class="comment">//        _graph[i].reserve(4);</span>
<a name="l00146"></a>00146         
<a name="l00147"></a>00147         <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00148"></a>00148         <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00149"></a>00149         
<a name="l00150"></a>00150         <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00151"></a>00151           {
<a name="l00152"></a>00152             <span class="comment">// Constant handle for the element</span>
<a name="l00153"></a>00153             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00154"></a>00154             
<a name="l00155"></a>00155             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); s++)
<a name="l00156"></a>00156               {
<a name="l00157"></a>00157                 <span class="comment">// Only operate on sides which are on the</span>
<a name="l00158"></a>00158                 <span class="comment">// boundary or for which the current element&#39;s</span>
<a name="l00159"></a>00159                 <span class="comment">// id is greater than its neighbor&#39;s.</span>
<a name="l00160"></a>00160                 <span class="comment">// Sides get only built once.</span>
<a name="l00161"></a>00161                 <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) == NULL) ||
<a name="l00162"></a>00162                     (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &gt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()))
<a name="l00163"></a>00163                   {
<a name="l00164"></a>00164                     <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(s));
<a name="l00165"></a>00165                     <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(0)].push_back(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(1));
<a name="l00166"></a>00166                     <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(1)].push_back(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(0));
<a name="l00167"></a>00167                 }
<a name="l00168"></a>00168               }
<a name="l00169"></a>00169           }
<a name="l00170"></a>00170         <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a607905beabcc58f01ff253b7873b2697">_initialized</a> = <span class="keyword">true</span>;
<a name="l00171"></a>00171         <span class="keywordflow">break</span>;
<a name="l00172"></a>00172       }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174     <span class="keywordflow">case</span> 3: <span class="comment">// Stolen blatantly from build_L_graph in mesh_base.C</span>
<a name="l00175"></a>00175       {
<a name="l00176"></a>00176         <span class="comment">// Initialize space in the graph.  In 3D, I&#39;ve assumed</span>
<a name="l00177"></a>00177         <span class="comment">// that each node was connected to approximately 3 neighbors.</span>
<a name="l00178"></a>00178         <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>.resize(<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00179"></a>00179 <span class="comment">//      for (unsigned int i=0; i&lt;_mesh.n_nodes(); ++i)</span>
<a name="l00180"></a>00180 <span class="comment">//        _graph[i].reserve(8);</span>
<a name="l00181"></a>00181         
<a name="l00182"></a>00182         <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       el  = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00183"></a>00183         <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185         <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00186"></a>00186           {
<a name="l00187"></a>00187             <span class="comment">// Shortcut notation for simplicity</span>
<a name="l00188"></a>00188             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00189"></a>00189             
<a name="l00190"></a>00190             <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> f=0; f&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); f++) <span class="comment">// Loop over faces</span>
<a name="l00191"></a>00191               <span class="keywordflow">if</span> ((elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(f) == NULL) ||
<a name="l00192"></a>00192                   (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &gt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(f)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()))
<a name="l00193"></a>00193                 {
<a name="l00194"></a>00194                   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> face(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf633f222ddcbe450345c98c68050fda">build_side</a>(f));
<a name="l00195"></a>00195                 
<a name="l00196"></a>00196                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;face-&gt;n_neighbors(); s++) <span class="comment">// Loop over face&#39;s edges</span>
<a name="l00197"></a>00197                     {
<a name="l00198"></a>00198                       <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>(face-&gt;build_side(s));
<a name="l00199"></a>00199                     
<a name="l00200"></a>00200                       <span class="comment">// At this point, we just insert the node numbers</span>
<a name="l00201"></a>00201                       <span class="comment">// again.  At the end we&#39;ll call sort and unique</span>
<a name="l00202"></a>00202                       <span class="comment">// to make sure there are no duplicates</span>
<a name="l00203"></a>00203                       <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(0)].push_back(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(1));
<a name="l00204"></a>00204                       <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(1)].push_back(<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(0));
<a name="l00205"></a>00205                     }
<a name="l00206"></a>00206                 }
<a name="l00207"></a>00207           }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209         <span class="comment">// Now call sort and unique to remove duplicate entries.</span>
<a name="l00210"></a>00210         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); ++i)
<a name="l00211"></a>00211           {
<a name="l00212"></a>00212             std::sort  (<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[i].begin(), <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[i].end());
<a name="l00213"></a>00213             <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[i].erase(std::unique(<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[i].begin(), <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[i].end()), <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[i].end());
<a name="l00214"></a>00214           }
<a name="l00215"></a>00215         
<a name="l00216"></a>00216         <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a607905beabcc58f01ff253b7873b2697">_initialized</a> = <span class="keyword">true</span>;
<a name="l00217"></a>00217         <span class="keywordflow">break</span>;
<a name="l00218"></a>00218       }
<a name="l00219"></a>00219 
<a name="l00220"></a>00220     <span class="keywordflow">default</span>:
<a name="l00221"></a>00221       {
<a name="l00222"></a>00222         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;At this time it is not possible &quot;</span>
<a name="l00223"></a>00223                       &lt;&lt; <span class="stringliteral">&quot;to smooth a dimension &quot;</span>
<a name="l00224"></a>00224                       &lt;&lt; <a class="code" href="classlibMesh_1_1MeshSmoother.php#a23c08282a0f3088def89cd9c1c17fc4a">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>()
<a name="l00225"></a>00225                       &lt;&lt; <span class="stringliteral">&quot;mesh.  Aborting...&quot;</span>
<a name="l00226"></a>00226                       &lt;&lt; std::endl;
<a name="l00227"></a>00227         libmesh_error();
<a name="l00228"></a>00228       }
<a name="l00229"></a>00229       
<a name="l00230"></a>00230     }
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a4cdacde23a81af5b3df46eb50e8efa2d">00236</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a4cdacde23a81af5b3df46eb50e8efa2d">LaplaceMeshSmoother::print_graph</a>()<span class="keyword"> const</span>
<a name="l00237"></a>00237 <span class="keyword"></span>{
<a name="l00238"></a>00238   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>.size(); ++i)
<a name="l00239"></a>00239     {
<a name="l00240"></a>00240       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;: &quot;</span>;
<a name="l00241"></a>00241       std::copy(<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[i].begin(),
<a name="l00242"></a>00242                 <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>[i].end(),
<a name="l00243"></a>00243                 std::ostream_iterator&lt;unsigned int&gt;(<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>, <span class="stringliteral">&quot; &quot;</span>));
<a name="l00244"></a>00244       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00245"></a>00245     }
<a name="l00246"></a>00246 }
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
