<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_smoother_laplace.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__smoother__laplace_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_smoother_laplace.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_smoother_laplace_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_smoother_laplace_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// forward declarations</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="mesh__smoother_8h.php">mesh_smoother.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00054"></a>00054 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00055"></a>00055 <span class="comment">// LaplaceMeshSmoother class definition</span>
<a name="l00056"></a><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php">LaplaceMeshSmoother</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshSmoother.php">MeshSmoother</a>
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00063"></a><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a97ab924d65f154ce8b7fb79c4b48d3d2">00063</a>   <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a97ab924d65f154ce8b7fb79c4b48d3d2">LaplaceMeshSmoother</a>(<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00064"></a>00064     : <a class="code" href="classlibMesh_1_1MeshSmoother.php">MeshSmoother</a>(mesh),
<a name="l00065"></a>00065       <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a607905beabcc58f01ff253b7873b2697">_initialized</a>(false) {}
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a6fbb134b4194d614a08071e08d6e7ee1">00070</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a6fbb134b4194d614a08071e08d6e7ee1">~LaplaceMeshSmoother</a>() {}
<a name="l00071"></a>00071 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a615d5ae879810c1d228f33d38bd0cb13">00078</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a615d5ae879810c1d228f33d38bd0cb13">smooth</a>() { this-&gt;<a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a615d5ae879810c1d228f33d38bd0cb13">smooth</a>(1); }
<a name="l00079"></a>00079 
<a name="l00085"></a>00085   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a615d5ae879810c1d228f33d38bd0cb13">smooth</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_iterations);
<a name="l00086"></a>00086   
<a name="l00094"></a>00094   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a623528543d038460e488e77bab010d33">init</a>();
<a name="l00095"></a>00095 
<a name="l00100"></a>00100   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a4cdacde23a81af5b3df46eb50e8efa2d">print_graph</a>() <span class="keyword">const</span>;
<a name="l00101"></a>00101   
<a name="l00102"></a>00102 <span class="keyword">private</span>:
<a name="l00103"></a>00103 
<a name="l00107"></a><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a607905beabcc58f01ff253b7873b2697">00107</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#a607905beabcc58f01ff253b7873b2697">_initialized</a>;
<a name="l00108"></a>00108 
<a name="l00112"></a><a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">00112</a>   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; <a class="code" href="classlibMesh_1_1LaplaceMeshSmoother.php#ad4685f0820d13a83dca6b9a5a318f549">_graph</a>;
<a name="l00113"></a>00113 };
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 } <span class="comment">// namespace libMesh</span>
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
