<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_smoother_vsmoother.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__smoother__vsmoother_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_smoother_vsmoother.h 3925 2010-08-24 22:16:52Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_smoother_vsmoother_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_smoother_vsmoother_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_ENABLE_VSMOOTHER</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="mesh__smoother_8h.php">mesh_smoother.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//jj</span>
<a name="l00040"></a><a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">00040</a> <span class="keyword">typedef</span> <span class="keywordtype">double</span>     * <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a>;
<a name="l00041"></a><a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">00041</a> <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a>   * <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a>;
<a name="l00042"></a><a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">00042</a> <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a>   * <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a>;
<a name="l00043"></a><a class="code" href="namespacelibMesh.php#ac5dabc69ddee87f762ef0ed55a4382cb">00043</a> <span class="keyword">typedef</span> <span class="keywordtype">void</span>     * <a class="code" href="namespacelibMesh.php#ac5dabc69ddee87f762ef0ed55a4382cb">LPVOID</a>;
<a name="l00044"></a><a class="code" href="namespacelibMesh.php#a3604e9319cc6c03b6e94d63aa25f0d56">00044</a> <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#ac5dabc69ddee87f762ef0ed55a4382cb">LPVOID</a>   * <a class="code" href="namespacelibMesh.php#a3604e9319cc6c03b6e94d63aa25f0d56">LPLPVOID</a>;
<a name="l00045"></a><a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">00045</a> <span class="keyword">typedef</span> <span class="keywordtype">int</span>  * <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a>;
<a name="l00046"></a><a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">00046</a> <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a>  * <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a>;
<a name="l00047"></a><a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">00047</a> <span class="keyword">typedef</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>;
<a name="l00048"></a>00048 
<a name="l00071"></a>00071 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00072"></a>00072 <span class="comment">// VariationalMeshSmoother class definition</span>
<a name="l00073"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php">00073</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php">VariationalMeshSmoother</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshSmoother.php">MeshSmoother</a>
<a name="l00074"></a>00074 {
<a name="l00075"></a>00075 <span class="keyword">public</span>:
<a name="l00076"></a>00076 
<a name="l00080"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a654f5479ac83591c1f0ecae367cde137">00080</a>   <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a654f5479ac83591c1f0ecae367cde137">VariationalMeshSmoother</a>(<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; theta=0.5, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; miniter=2,
<a name="l00081"></a>00081                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; maxiter=5, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; miniterBC=5)
<a name="l00082"></a>00082     :<a class="code" href="classlibMesh_1_1MeshSmoother.php">MeshSmoother</a>(mesh),
<a name="l00083"></a>00083      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3833cbb0ab5132da618a9fbc2e502c7c">_percent_to_move</a>(1),
<a name="l00084"></a>00084      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ae719e07e9403b8ac628ecef3485e7124">_adapt_data</a>(NULL),
<a name="l00085"></a>00085      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a>(mesh.mesh_dimension()),
<a name="l00086"></a>00086      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa0ed679cb6ea0e07b52cc95bfe05013e">_miniter</a>(miniter),
<a name="l00087"></a>00087      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aba9e0c523e0efe0cbf08e574de8eb48c">_maxiter</a>(maxiter),
<a name="l00088"></a>00088      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a02f2826b12a74bfe7bdf36baf467383d">_miniterBC</a>(miniterBC),
<a name="l00089"></a>00089      
<a name="l00090"></a>00090      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1afd2243593f9bfb12f663be2da5ec04">_metric</a>(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1a8893efc449318a8559eac412bbebf015">uniform</a>),
<a name="l00091"></a>00091      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac860cbe58bfa793085677352ec1a8f70">_adaptive_func</a>(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07a4424b8516475b961de7e1b8e95d21761">none</a>),
<a name="l00092"></a>00092      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a21ace46583ecafb4ba33032fd21c12bd">_theta</a>(theta),
<a name="l00093"></a>00093      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a37194033786670d51c4395d33e100cb0">_generate_data</a>(false),
<a name="l00094"></a>00094 
<a name="l00095"></a>00095      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2f110b9dcffbb3159e2da30290baa990">_area_of_interest</a>(NULL)
<a name="l00096"></a>00096   {}
<a name="l00097"></a>00097 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a6d7a6963524201272971aeff543cdc57">00101</a>   <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a654f5479ac83591c1f0ecae367cde137">VariationalMeshSmoother</a>(<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, std::vector&lt;float&gt;* adapt_data, <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; theta=0.5,
<a name="l00102"></a>00102                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; miniter=2, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; maxiter=5, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; miniterBC=5,
<a name="l00103"></a>00103                           <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; percent_to_move=1)
<a name="l00104"></a>00104     :<a class="code" href="classlibMesh_1_1MeshSmoother.php">MeshSmoother</a>(mesh),
<a name="l00105"></a>00105      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3833cbb0ab5132da618a9fbc2e502c7c">_percent_to_move</a>(percent_to_move),
<a name="l00106"></a>00106      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ae719e07e9403b8ac628ecef3485e7124">_adapt_data</a>(adapt_data),
<a name="l00107"></a>00107      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a>(mesh.mesh_dimension()),
<a name="l00108"></a>00108      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa0ed679cb6ea0e07b52cc95bfe05013e">_miniter</a>(miniter),
<a name="l00109"></a>00109      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aba9e0c523e0efe0cbf08e574de8eb48c">_maxiter</a>(maxiter),
<a name="l00110"></a>00110      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a02f2826b12a74bfe7bdf36baf467383d">_miniterBC</a>(miniterBC),
<a name="l00111"></a>00111      
<a name="l00112"></a>00112      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1afd2243593f9bfb12f663be2da5ec04">_metric</a>(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1a8893efc449318a8559eac412bbebf015">uniform</a>),
<a name="l00113"></a>00113      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac860cbe58bfa793085677352ec1a8f70">_adaptive_func</a>(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07ab4196f55be3f8c387985909f1fc98c67">cell</a>),
<a name="l00114"></a>00114      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a21ace46583ecafb4ba33032fd21c12bd">_theta</a>(theta),
<a name="l00115"></a>00115      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a37194033786670d51c4395d33e100cb0">_generate_data</a>(false),
<a name="l00116"></a>00116 
<a name="l00117"></a>00117      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2f110b9dcffbb3159e2da30290baa990">_area_of_interest</a>(NULL)
<a name="l00118"></a>00118   {}
<a name="l00119"></a>00119   
<a name="l00124"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2be79213c9bb762a63357ac1028bf252">00124</a>   <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a654f5479ac83591c1f0ecae367cde137">VariationalMeshSmoother</a>(<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>* area_of_interest, std::vector&lt;float&gt;* adapt_data,
<a name="l00125"></a>00125                           <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; theta=0.5, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; miniter=2, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; maxiter=5,
<a name="l00126"></a>00126                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; miniterBC=5, <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; percent_to_move=1)
<a name="l00127"></a>00127     :<a class="code" href="classlibMesh_1_1MeshSmoother.php">MeshSmoother</a>(mesh),
<a name="l00128"></a>00128      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3833cbb0ab5132da618a9fbc2e502c7c">_percent_to_move</a>(percent_to_move),
<a name="l00129"></a>00129      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ae719e07e9403b8ac628ecef3485e7124">_adapt_data</a>(adapt_data),
<a name="l00130"></a>00130      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a>(mesh.mesh_dimension()),
<a name="l00131"></a>00131      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa0ed679cb6ea0e07b52cc95bfe05013e">_miniter</a>(miniter),
<a name="l00132"></a>00132      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aba9e0c523e0efe0cbf08e574de8eb48c">_maxiter</a>(maxiter),
<a name="l00133"></a>00133      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a02f2826b12a74bfe7bdf36baf467383d">_miniterBC</a>(miniterBC),
<a name="l00134"></a>00134 
<a name="l00135"></a>00135      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1afd2243593f9bfb12f663be2da5ec04">_metric</a>(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1a8893efc449318a8559eac412bbebf015">uniform</a>),
<a name="l00136"></a>00136      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac860cbe58bfa793085677352ec1a8f70">_adaptive_func</a>(<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07ab4196f55be3f8c387985909f1fc98c67">cell</a>),
<a name="l00137"></a>00137      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a21ace46583ecafb4ba33032fd21c12bd">_theta</a>(theta),
<a name="l00138"></a>00138      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a37194033786670d51c4395d33e100cb0">_generate_data</a>(false),
<a name="l00139"></a>00139 
<a name="l00140"></a>00140      <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2f110b9dcffbb3159e2da30290baa990">_area_of_interest</a>(area_of_interest)
<a name="l00141"></a>00141   {}
<a name="l00142"></a>00142 
<a name="l00143"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1">00143</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1">metric_type</a>
<a name="l00144"></a>00144   {
<a name="l00145"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1a8893efc449318a8559eac412bbebf015">00145</a>     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1a8893efc449318a8559eac412bbebf015">uniform</a>=1,
<a name="l00146"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1a3221120425ffe2093abd39ca2af72c70">00146</a>     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1a3221120425ffe2093abd39ca2af72c70">volumetric</a>=2,
<a name="l00147"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1a501e7077c92dec4de5d0d14ea7ecbf03">00147</a>     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1a501e7077c92dec4de5d0d14ea7ecbf03">directional</a>=3
<a name="l00148"></a>00148   };
<a name="l00149"></a>00149 
<a name="l00150"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07">00150</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07">adapt_type</a>
<a name="l00151"></a>00151   {
<a name="l00152"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07ab4196f55be3f8c387985909f1fc98c67">00152</a>     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07ab4196f55be3f8c387985909f1fc98c67">cell</a>=-1,
<a name="l00153"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07a4424b8516475b961de7e1b8e95d21761">00153</a>     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07a4424b8516475b961de7e1b8e95d21761">none</a>=0,
<a name="l00154"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07a74e48268f7aa822c16bbda054385ef48">00154</a>     <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07a74e48268f7aa822c16bbda054385ef48">node</a>=1
<a name="l00155"></a>00155   };
<a name="l00156"></a>00156 
<a name="l00160"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a849d21bce5ed478c79c41a3003f6a61d">00160</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a849d21bce5ed478c79c41a3003f6a61d">~VariationalMeshSmoother</a>() {}
<a name="l00161"></a>00161 
<a name="l00168"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af079f6eb1f4ea95a3599a662baa556ee">00168</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af079f6eb1f4ea95a3599a662baa556ee">smooth</a>() { <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad7adc7c2d7edfe11e7de764d8af369bb">_distance</a> = this-&gt;<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af079f6eb1f4ea95a3599a662baa556ee">smooth</a>(1); }
<a name="l00169"></a>00169 
<a name="l00175"></a>00175   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af079f6eb1f4ea95a3599a662baa556ee">smooth</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_iterations);
<a name="l00176"></a>00176 
<a name="l00182"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a5a87d53001f20c8c021f94e627ccd9e9">00182</a>   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a5a87d53001f20c8c021f94e627ccd9e9" title="Member function distanceMoved">distanceMoved</a>()<span class="keyword"> const </span>{<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad7adc7c2d7edfe11e7de764d8af369bb">_distance</a>;}
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 <span class="keyword">private</span>:
<a name="l00185"></a>00185 
<a name="l00189"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad7adc7c2d7edfe11e7de764d8af369bb">00189</a>   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad7adc7c2d7edfe11e7de764d8af369bb">_distance</a>;
<a name="l00190"></a>00190   
<a name="l00194"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3833cbb0ab5132da618a9fbc2e502c7c">00194</a>   <span class="keyword">const</span> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3833cbb0ab5132da618a9fbc2e502c7c">_percent_to_move</a>;
<a name="l00195"></a>00195   
<a name="l00199"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">00199</a>   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa07b8ddc81d1458d73d4b7261e9b9a29">_dist_norm</a>;
<a name="l00200"></a>00200   
<a name="l00204"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a4af429062348bf93b94cf4b9e8987b52">00204</a>   std::map&lt;unsigned int, std::vector&lt;unsigned int&gt; &gt; <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a4af429062348bf93b94cf4b9e8987b52">_hanging_nodes</a>;
<a name="l00205"></a>00205   
<a name="l00209"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ae719e07e9403b8ac628ecef3485e7124">00209</a>   std::vector&lt;float&gt; * <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ae719e07e9403b8ac628ecef3485e7124">_adapt_data</a>;
<a name="l00210"></a>00210 
<a name="l00214"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a02f2826b12a74bfe7bdf36baf467383d">00214</a>   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#ae39d2d03f80cd465c23c395408ed12e9">uint</a>&amp; <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a985d5315536222f1d46797ad555ec035">_dim</a>,<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa0ed679cb6ea0e07b52cc95bfe05013e">_miniter</a>,<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aba9e0c523e0efe0cbf08e574de8eb48c">_maxiter</a>,<a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a02f2826b12a74bfe7bdf36baf467383d">_miniterBC</a>;
<a name="l00215"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1afd2243593f9bfb12f663be2da5ec04">00215</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a7fb8b0009625dc2c5861a8d59d65bce1">metric_type</a>&amp; <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1afd2243593f9bfb12f663be2da5ec04">_metric</a>;
<a name="l00216"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac860cbe58bfa793085677352ec1a8f70">00216</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07">adapt_type</a>&amp; <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac860cbe58bfa793085677352ec1a8f70">_adaptive_func</a>;
<a name="l00217"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a21ace46583ecafb4ba33032fd21c12bd">00217</a>   <span class="keyword">const</span> <span class="keywordtype">double</span>&amp; <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a21ace46583ecafb4ba33032fd21c12bd">_theta</a>;
<a name="l00218"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a37194033786670d51c4395d33e100cb0">00218</a>   <span class="keyword">const</span> <span class="keywordtype">bool</span>&amp; <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a37194033786670d51c4395d33e100cb0">_generate_data</a>;
<a name="l00219"></a>00219 
<a name="l00223"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2f110b9dcffbb3159e2da30290baa990">00223</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> * <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2f110b9dcffbb3159e2da30290baa990">_area_of_interest</a>;
<a name="l00224"></a>00224   
<a name="l00225"></a>00225   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ab1d2ee2a407aab6c95f3b6cefa34f879">adjust_adapt_data</a>();
<a name="l00226"></a>00226   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aa37db98faf9ff10394900d029da0a05c">adapt_minimum</a>() <span class="keyword">const</span>;
<a name="l00227"></a>00227   
<a name="l00232"></a>00232   <span class="comment">/*-- allocate memory --*/</span>
<a name="l00233"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">00233</a>   <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a8d8eaf682296eb67829ac116d308af38">alloc_d_n1</a>(<span class="keywordtype">int</span> m1)              { <span class="keywordflow">return</span>((<a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a>)malloc(m1*<span class="keyword">sizeof</span>(<span class="keywordtype">double</span>))); }
<a name="l00234"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">00234</a>   <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a142e229dbae2cc6de2e3f5e9455d33fe">alloc_i_n1</a>(<span class="keywordtype">int</span> m1)                 { <span class="keywordflow">return</span>((<a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a>)malloc(m1*<span class="keyword">sizeof</span>(<span class="keywordtype">int</span>))); }
<a name="l00235"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aea218377addb1242650692248f082794">00235</a>   <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#aea218377addb1242650692248f082794">alloc_i_n1_n2</a>(<span class="keywordtype">int</span> m1, <span class="keywordtype">int</span>)    { <span class="keywordflow">return</span>((<a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a>)malloc(m1*<span class="keyword">sizeof</span>(<a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a>))); }
<a name="l00236"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">00236</a>   <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad638ece55af24c93187a48c1656b4665">alloc_d_n1_n2</a>(<span class="keywordtype">int</span> m1, <span class="keywordtype">int</span>) { <span class="keywordflow">return</span>((<a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a>)malloc(m1*<span class="keyword">sizeof</span>(<a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a>))); }
<a name="l00237"></a><a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac16362f740558ef8c369afd133bcceed">00237</a>   <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ac16362f740558ef8c369afd133bcceed">alloc_d_n1_n2_n3</a>(<span class="keywordtype">int</span> m1, <span class="keywordtype">int</span>, <span class="keywordtype">int</span>) { <span class="keywordflow">return</span>((<a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a>)malloc(m1*<span class="keyword">sizeof</span>(<a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a>))); }
<a name="l00238"></a>00238 
<a name="l00239"></a>00239   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3df91a4b440e5a71471316258deff34a">writegr</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells,
<a name="l00240"></a>00240               <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells, <span class="keywordtype">int</span> nedges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> edges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> hnodes, <span class="keyword">const</span> <span class="keywordtype">char</span> grid[],
<a name="l00241"></a>00241               <span class="keywordtype">int</span> me, <span class="keyword">const</span> <span class="keywordtype">char</span> grid_old[], FILE *sout);
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3e4f20c7407b7c07bbaf7ad0bdbc77b4">readgr</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells,
<a name="l00244"></a>00244              <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells, <span class="keywordtype">int</span> nedges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> edges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> hnodes, FILE *sout);
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a1695f359003a8e2cf7c9a083b7ae6911">readmetr</a>(<span class="keywordtype">char</span> *<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">int</span> ncells, <span class="keywordtype">int</span> n, FILE *sout);
<a name="l00247"></a>00247 
<a name="l00248"></a>00248   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abcd0c8f82d12085857cf14d1d2e09bb7">read_adp</a>(<a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <span class="keywordtype">char</span> *adap, FILE *sout);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abf9bc5a3a9a35ec48c45bf347d552eac">jac3</a>(<span class="keywordtype">double</span> x1,<span class="keywordtype">double</span> y1,<span class="keywordtype">double</span> z1,<span class="keywordtype">double</span> x2,<span class="keywordtype">double</span> y2,
<a name="l00251"></a>00251               <span class="keywordtype">double</span> z2,<span class="keywordtype">double</span> x3,<span class="keywordtype">double</span> y3,<span class="keywordtype">double</span> z3);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad601d6265a971048d8b635a1e00b43e7">jac2</a>(<span class="keywordtype">double</span> x1,<span class="keywordtype">double</span> y1,<span class="keywordtype">double</span> x2,<span class="keywordtype">double</span> y2);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a63e3c9a67d8f811d2cbe52b606168f30">basisA</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> Q, <span class="keywordtype">int</span> nvert, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> K, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> H, <span class="keywordtype">int</span> me);
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#af8f5b5f11a05b03da6e2352a5aeba5a7">adp_renew</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells,
<a name="l00258"></a>00258                  <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <span class="keywordtype">int</span> adp, FILE *sout);
<a name="l00259"></a>00259 
<a name="l00260"></a>00260   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a73c40468cbbbcc85f6cc763c56ad4005">full_smooth</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells, 
<a name="l00261"></a>00261                    <span class="keywordtype">int</span> nedges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> edges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> hnodes, <span class="keywordtype">double</span> w, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> iter, <span class="keywordtype">int</span> me, 
<a name="l00262"></a>00262                    <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">int</span> adp, <span class="keywordtype">char</span> *adap, <span class="keywordtype">int</span> gr, FILE *sout);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2ef72a340e51765a2b6aa843edbf88ad">maxE</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells, 
<a name="l00265"></a>00265               <span class="keywordtype">int</span> me, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> v, <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> Gamma, 
<a name="l00266"></a>00266               <span class="keywordtype">double</span> *qmin, FILE *sout);
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a2849eb387db1a62d80463624dd4a2885">minq</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells, 
<a name="l00269"></a>00269               <span class="keywordtype">int</span> me, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> *vol, <span class="keywordtype">double</span> *Vmin, FILE *sout);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a9d0928fd44bcffeed376f882c1f11aeb">minJ</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells,
<a name="l00272"></a>00272               <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> me, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> nedges, 
<a name="l00273"></a>00273               <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> edges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> hnodes, <span class="keywordtype">int</span> msglev, <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">double</span> *emax, <span class="keywordtype">double</span> *qmin, 
<a name="l00274"></a>00274               <span class="keywordtype">int</span> adp, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, FILE *sout);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a23a2e24c743ad61769e2b263fb2ca3fb">minJ_BC</a>(<span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells,
<a name="l00277"></a>00277                 <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> me, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> msglev, 
<a name="l00278"></a>00278                 <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">double</span> *emax, <span class="keywordtype">double</span> *qmin, <span class="keywordtype">int</span> adp, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <span class="keywordtype">int</span> NCN, FILE *sout);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#ad89bb2f5f5040eb7b22f86e0237b37b7">localP</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> W, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> F, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07ab4196f55be3f8c387985909f1fc98c67">cell</a>, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">double</span> epsilon, 
<a name="l00281"></a>00281                 <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> nvert, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> H, <span class="keywordtype">int</span> me, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> f, <span class="keywordtype">double</span> *Vmin, 
<a name="l00282"></a>00282                 <span class="keywordtype">double</span> *qmin, <span class="keywordtype">int</span> adp, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> Gloc, FILE *sout);
<a name="l00283"></a>00283 
<a name="l00284"></a>00284   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a69d9610a0107c0dcf21e2eb7b5f01af8">avertex</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> G, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07ab4196f55be3f8c387985909f1fc98c67">cell</a>, <span class="keywordtype">int</span> nvert, <span class="keywordtype">int</span> adp, FILE *sout);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a85daea29433878c820b7c1fbcba83046">vertex</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> W, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> F, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0b4e897e34bef3546ab91f12bde58d07ab4196f55be3f8c387985909f1fc98c67">cell</a>, 
<a name="l00287"></a>00287                 <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> nvert, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> K, 
<a name="l00288"></a>00288                 <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> H, <span class="keywordtype">int</span> me, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> f, <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">int</span> adp, 
<a name="l00289"></a>00289                 <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> G, <span class="keywordtype">double</span> sigma, FILE *sout);
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a52a126c779d4646296ad65a0c0a92d23">metr_data_gen</a>(<span class="keywordtype">char</span> grid[], <span class="keywordtype">char</span> metr[], <span class="keywordtype">int</span> n, <span class="keywordtype">int</span> me, FILE *sout);
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a86eb9c4d0df6ffdc1a0892daf7086131">solver</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ia, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ja, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> a, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> x, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> b, <span class="keywordtype">double</span> eps,
<a name="l00294"></a>00294              <span class="keywordtype">int</span> maxite, <span class="keywordtype">int</span> msglev, FILE *sout);
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a83878b9bb8e4e0e49330c037069ee44c">pcg_ic0</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ia, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ja, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> a, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> u, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> x, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> b, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> r, 
<a name="l00297"></a>00297               <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> p, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> z, <span class="keywordtype">double</span> eps, <span class="keywordtype">int</span> maxite, <span class="keywordtype">int</span> msglev, FILE *sout);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#abc0e1acadc8fd16c6f278c3d4056cc96">pcg_par_check</a>(<span class="keywordtype">int</span> n, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ia, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> ja, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> a, <span class="keywordtype">double</span> eps, <span class="keywordtype">int</span> maxite, <span class="keywordtype">int</span> msglev, FILE *sout);
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a0db3322b3810b54d2bfb7297157409bf">gener</a>(<span class="keywordtype">char</span> grid[], <span class="keywordtype">int</span> n, FILE *sout);
<a name="l00302"></a>00302   
<a name="l00303"></a>00303   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a3293222021e13ff1e965689e1ff18e28">local_sweep</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells, 
<a name="l00304"></a>00304                   <span class="keywordtype">int</span> nedges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> edges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> hnodes, <span class="keywordtype">double</span> w, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> iter, <span class="keywordtype">int</span> me, 
<a name="l00305"></a>00305                       <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">int</span> adp, <span class="keywordtype">int</span> OPT, FILE *sout);
<a name="l00306"></a>00306   
<a name="l00307"></a>00307   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1VariationalMeshSmoother.php#a5de1e0090d3dfda1617b775e8e148a02">minJ_l</a>(<span class="keywordtype">int</span> n, <span class="keywordtype">int</span> N, <a class="code" href="namespacelibMesh.php#a1bea0edefff65b8d46b1ff47830c3849">LPLPDOUBLE</a> R, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mask, <span class="keywordtype">int</span> ncells, <a class="code" href="namespacelibMesh.php#a16968b573aac273695c5517bdb378bb3">LPLPINT</a> cells, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> mcells,
<a name="l00308"></a>00308               <span class="keywordtype">double</span> epsilon, <span class="keywordtype">double</span> w, <span class="keywordtype">int</span> me, <a class="code" href="namespacelibMesh.php#aa6ce5300a2556a484fb79ac35d5fba26">LPLPLPDOUBLE</a> H, <span class="keywordtype">double</span> vol, <span class="keywordtype">int</span> nedges, 
<a name="l00309"></a>00309               <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> edges, <a class="code" href="namespacelibMesh.php#a0e9d42444ab0645b0417ba54f7a6f422">LPINT</a> hnodes, <span class="keywordtype">int</span> msglev, <span class="keywordtype">double</span> *Vmin, <span class="keywordtype">double</span> *emax, <span class="keywordtype">double</span> *qmin, 
<a name="l00310"></a>00310               <span class="keywordtype">int</span> adp, <a class="code" href="namespacelibMesh.php#a288071d66d6c0bba0a598a9967ac60bf">LPDOUBLE</a> afun, FILE *sout);
<a name="l00311"></a>00311 };
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 } <span class="comment">// namespace libMesh</span>
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="preprocessor">#endif // LIBMESH_ENABLE_VSMOOTHER</span>
<a name="l00316"></a>00316 <span class="preprocessor"></span>
<a name="l00317"></a>00317 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
