<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_tetgen_support.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__tetgen__support_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_tetgen_support.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002  
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005 
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010 
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015 
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00021"></a>00021 <span class="preprocessor">#ifdef LIBMESH_HAVE_TETGEN</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="cell__tet4_8h.php">cell_tet4.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="face__tri3_8h.php">face_tri3.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tetgen__support_8h.php">mesh_tetgen_support.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// TetGenMeshInterface functions</span>
<a name="l00040"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a115204d61274e1dcedbf9d77da86a066">00040</a> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a115204d61274e1dcedbf9d77da86a066">TetGenWrapper::TetGenWrapper</a>()
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a> = <span class="keyword">new</span> tetgenio;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.mesh_dim                = 3;
<a name="l00045"></a>00045   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.numberofpointattributes = 0;
<a name="l00046"></a>00046   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.firstnumber             = 0;
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a31da8a4d9c868179147fa939e3b72be4">00051</a> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a31da8a4d9c868179147fa939e3b72be4">TetGenWrapper::~TetGenWrapper</a>()
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>;
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3c3a1d223613bc1891dd600698b632ea">00058</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3c3a1d223613bc1891dd600698b632ea">TetGenWrapper::set_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> x, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> y, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> z)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   <span class="keywordtype">int</span> index = i*3;
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.pointlist[index++] = x;
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.pointlist[index++] = y;
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.pointlist[index++] = z;
<a name="l00064"></a>00064 }
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a0473a1625fe0298c21617cba7344e9a7">00068</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a0473a1625fe0298c21617cba7344e9a7">TetGenWrapper::set_hole</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> x, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> y, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> z)
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   <span class="keywordtype">int</span> index = i*3;
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.holelist[index++] = x;
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.holelist[index++] = y;
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.holelist[index++] = z;
<a name="l00074"></a>00074 }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#acf4dd49a84388662930ddd2dd08b563a">00078</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#acf4dd49a84388662930ddd2dd08b563a">TetGenWrapper::set_numberofpoints</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.numberofpoints = i;
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#ac23554446a737933a47caba6febe9459">00085</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#ac23554446a737933a47caba6febe9459">TetGenWrapper::get_output_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>&amp; x, <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>&amp; y, <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>&amp; z)
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087   x = <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;pointlist[3*i];
<a name="l00088"></a>00088   y = <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;pointlist[3*i+1];
<a name="l00089"></a>00089   z = <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;pointlist[3*i+2];
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a38312ab0aebc02be7563a8d667d202ab">00094</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a38312ab0aebc02be7563a8d667d202ab">TetGenWrapper::get_numberoftetrahedra</a>()
<a name="l00095"></a>00095 {
<a name="l00096"></a>00096   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;numberoftetrahedra;
<a name="l00097"></a>00097 }
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a888d5310f2dd981172b5117cbec28be2">00101</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a888d5310f2dd981172b5117cbec28be2">TetGenWrapper::get_numberoftrifaces</a>()
<a name="l00102"></a>00102 {
<a name="l00103"></a>00103   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;numberoftrifaces;
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#ac8d61f645946216032b8b106375c180a">00108</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#ac8d61f645946216032b8b106375c180a">TetGenWrapper::get_numberofpoints</a>()
<a name="l00109"></a>00109 {
<a name="l00110"></a>00110   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;numberofpoints;
<a name="l00111"></a>00111 }
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a92b1c327251652d78291a75e9e3e574f">00115</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a92b1c327251652d78291a75e9e3e574f">TetGenWrapper::get_element_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;tetrahedronlist[i*4+j];
<a name="l00118"></a>00118 }
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8b8e215e3078383282812863c1b3faf0">00122</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8b8e215e3078383282812863c1b3faf0">TetGenWrapper::get_triface_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j)
<a name="l00123"></a>00123 {
<a name="l00124"></a>00124   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;trifacelist[i*3+j];
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a40cfd04da7555e800084b21fdb3ae7bf">00129</a> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a40cfd04da7555e800084b21fdb3ae7bf">TetGenWrapper::get_element_attribute</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   libmesh_assert(<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;numberoftetrahedronattributes&gt;0);
<a name="l00132"></a>00132   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;tetrahedronattributelist[<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>-&gt;numberoftetrahedronattributes*i];
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9112ba074b28b6f337698995d6190dea">00137</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9112ba074b28b6f337698995d6190dea">TetGenWrapper::set_pointlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numofpoints)
<a name="l00138"></a>00138 {
<a name="l00139"></a>00139   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#acf4dd49a84388662930ddd2dd08b563a">set_numberofpoints</a>(numofpoints);
<a name="l00140"></a>00140   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.pointlist = <span class="keyword">new</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>[<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.numberofpoints * 3];
<a name="l00141"></a>00141 }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa8419c6f2d036e19a6f40dd61d790158">00145</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa8419c6f2d036e19a6f40dd61d790158">TetGenWrapper::set_switches</a>(<span class="keyword">const</span> std::string&amp; s)
<a name="l00146"></a>00146 {
<a name="l00147"></a>00147   <span class="comment">// Copy the string to a temporary buffer for passing to the C API</span>
<a name="l00148"></a>00148   <span class="keywordtype">char</span> buffer[256];
<a name="l00149"></a>00149   libmesh_assert (s.size() &lt; <span class="keyword">sizeof</span>(buffer)-1);
<a name="l00150"></a>00150   buffer[ s.copy( buffer , <span class="keyword">sizeof</span>( buffer ) - 1 ) ] = <span class="charliteral">&#39;\0&#39;</span> ;
<a name="l00151"></a>00151   
<a name="l00152"></a>00152   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a945509dbfddbed16d2ab9b0d55416c53">tetgen_be</a>.parse_commandline(buffer)) 
<a name="l00153"></a>00153     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;TetGen replies: Wrong switches!&quot;</span> &lt;&lt; std::endl;
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a248559d273c5cee6c07eb4d183565e7e">00158</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a248559d273c5cee6c07eb4d183565e7e">TetGenWrapper::run_tetgen</a>()
<a name="l00159"></a>00159 {
<a name="l00160"></a>00160   <span class="comment">// Call tetrahedralize from the TetGen library.</span>
<a name="l00161"></a>00161   tetrahedralize(&amp;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a945509dbfddbed16d2ab9b0d55416c53">tetgen_be</a>, &amp;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>, <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>);
<a name="l00162"></a>00162 }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 
<a name="l00166"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4aebcfaa10e85e13029ff2c05ba384ed">00166</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4aebcfaa10e85e13029ff2c05ba384ed">TetGenWrapper::set_numberoffacets</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00167"></a>00167 { 
<a name="l00168"></a>00168   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.numberoffacets = i;
<a name="l00169"></a>00169 }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a92f53a7bec19f7849cdc6ab8dfb6b403">00173</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a92f53a7bec19f7849cdc6ab8dfb6b403">TetGenWrapper::set_numberofholes</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00174"></a>00174 { 
<a name="l00175"></a>00175   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.numberofholes = i;
<a name="l00176"></a>00176 }
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa57623338e0e5fceb963fdb5795024b5">00180</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa57623338e0e5fceb963fdb5795024b5">TetGenWrapper::set_numberofregions</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i)
<a name="l00181"></a>00181 {
<a name="l00182"></a>00182   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.numberofregions = i;
<a name="l00183"></a>00183 }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9e093a7bbf339e23150e523c9e40cdfc">00187</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9e093a7bbf339e23150e523c9e40cdfc">TetGenWrapper::set_facetlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numoffacets, <span class="keyword">const</span> <span class="keywordtype">int</span> numofholes)
<a name="l00188"></a>00188 {
<a name="l00189"></a>00189   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4aebcfaa10e85e13029ff2c05ba384ed">set_numberoffacets</a>(numoffacets);
<a name="l00190"></a>00190   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a92f53a7bec19f7849cdc6ab8dfb6b403">set_numberofholes</a>(numofholes);
<a name="l00191"></a>00191   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.facetlist = <span class="keyword">new</span> tetgenio::facet[this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.numberoffacets];
<a name="l00192"></a>00192   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;numoffacets; i++)
<a name="l00193"></a>00193     this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.init(&amp;(this-&gt;tetgen_data.facetlist[i]));
<a name="l00194"></a>00194   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.holelist = <span class="keyword">new</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>[this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.numberofholes * 3];
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4e13f1eaf10bc8e0232df3777a12c9b7">00199</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4e13f1eaf10bc8e0232df3777a12c9b7">TetGenWrapper::set_regionlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numofregions)
<a name="l00200"></a>00200 {
<a name="l00201"></a>00201   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa57623338e0e5fceb963fdb5795024b5">set_numberofregions</a>(numofregions);
<a name="l00202"></a>00202   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.regionlist = <span class="keyword">new</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>[this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.numberofregions * 5];
<a name="l00203"></a>00203 }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3ef1609bbbcf13fdc94fe4ee7600a4a1">00207</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3ef1609bbbcf13fdc94fe4ee7600a4a1">TetGenWrapper::set_facet_numberofpolygons</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> num)
<a name="l00208"></a>00208 {
<a name="l00209"></a>00209   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.facetlist[i].numberofpolygons = num;
<a name="l00210"></a>00210 }
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#adfe99309c41f3bef0d60e78161231829">00214</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#adfe99309c41f3bef0d60e78161231829">TetGenWrapper::set_facet_numberofholes</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> num)
<a name="l00215"></a>00215 {
<a name="l00216"></a>00216   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.facetlist[i].numberofholes = num;
<a name="l00217"></a>00217 }
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4bb664b2a6951c85dd0c343de39ec78b">00222</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4bb664b2a6951c85dd0c343de39ec78b">TetGenWrapper::set_facet_polygonlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> numofpolygons)
<a name="l00223"></a>00223 {
<a name="l00224"></a>00224   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3ef1609bbbcf13fdc94fe4ee7600a4a1">set_facet_numberofpolygons</a>(i, numofpolygons);
<a name="l00225"></a>00225   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#adfe99309c41f3bef0d60e78161231829">set_facet_numberofholes</a>(i, 0);
<a name="l00226"></a>00226   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.facetlist[i].polygonlist = <span class="keyword">new</span> tetgenio::polygon[numofpolygons];
<a name="l00227"></a>00227   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> j=0; j&lt;this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.facetlist[i].numberofpolygons; j++)
<a name="l00228"></a>00228     this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.init(&amp;(this-&gt;tetgen_data.facetlist[i].polygonlist[j]));
<a name="l00229"></a>00229 }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a124ec042cf813d9f3496e37ad55269bf">00233</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a124ec042cf813d9f3496e37ad55269bf">TetGenWrapper::set_polygon_numberofvertices</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> num)
<a name="l00234"></a>00234 {
<a name="l00235"></a>00235   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.facetlist[i].polygonlist[j].numberofvertices = num;
<a name="l00236"></a>00236 }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 
<a name="l00239"></a>00239 
<a name="l00240"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#aef241deb3592ba8a085a56be32e81abc">00240</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#aef241deb3592ba8a085a56be32e81abc">TetGenWrapper::set_polygon_vertexlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> numofvertices)
<a name="l00241"></a>00241 {
<a name="l00242"></a>00242   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a124ec042cf813d9f3496e37ad55269bf">set_polygon_numberofvertices</a>(i, j, numofvertices);
<a name="l00243"></a>00243   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.facetlist[i].polygonlist[j].vertexlist = <span class="keyword">new</span> <span class="keywordtype">int</span>[numofvertices];
<a name="l00244"></a>00244 }
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a>00247 
<a name="l00248"></a>00248 
<a name="l00249"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a956f3fbf2d6f22b61c715123f367ffac">00249</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a956f3fbf2d6f22b61c715123f367ffac">TetGenWrapper::set_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> k, <span class="keyword">const</span> <span class="keywordtype">int</span> nodeindex)
<a name="l00250"></a>00250 {
<a name="l00251"></a>00251   this-&gt;<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.facetlist[i].polygonlist[j].vertexlist[k] = nodeindex;
<a name="l00252"></a>00252 }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#aed70a5adcee4441abbf62a369263f828">00256</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#aed70a5adcee4441abbf62a369263f828">TetGenWrapper::set_region</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> x, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> y, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> z,
<a name="l00257"></a>00257                                <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> attribute, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> vol_constraint)
<a name="l00258"></a>00258 {
<a name="l00259"></a>00259   <span class="keywordtype">int</span> index = i*5;
<a name="l00260"></a>00260   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.regionlist[index++] = x;
<a name="l00261"></a>00261   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.regionlist[index++] = y;
<a name="l00262"></a>00262   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.regionlist[index++] = z;
<a name="l00263"></a>00263   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.regionlist[index++] = attribute;
<a name="l00264"></a>00264   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>.regionlist[index++] = vol_constraint;
<a name="l00265"></a>00265 }
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 <span class="comment">// class type TetGen_access is cast to TetGenWrapper.</span>
<a name="l00269"></a><a class="code" href="namespacelibMesh.php#a7c1ce2478cf1d6027357c530de970801">00269</a> <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php">TetGenWrapper</a> <a class="code" href="namespacelibMesh.php#a7c1ce2478cf1d6027357c530de970801">TetGen_access</a>;
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00277"></a>00277 <span class="comment">// TetGenMeshInterface class members</span>
<a name="l00278"></a><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#aa12f916741d05c1c9641cf045dd50094">00278</a> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#aa12f916741d05c1c9641cf045dd50094">TetGenMeshInterface::TetGenMeshInterface</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) :
<a name="l00279"></a>00279   _mesh         (mesh)
<a name="l00280"></a>00280 {
<a name="l00281"></a>00281 }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a4d72158648256e5b047b89962489b9b7">00285</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a4d72158648256e5b047b89962489b9b7">TetGenMeshInterface::triangulate_pointset</a> ()   
<a name="l00286"></a>00286 {
<a name="l00287"></a>00287   <span class="comment">// class tetgen_wrapper allows library access on a basic level:</span>
<a name="l00288"></a>00288   <a class="code" href="classlibMesh_1_1TetGenWrapper.php">TetGen_access</a> tetgen_wrapper; 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="comment">// fill input structure with point set data:</span>
<a name="l00291"></a>00291   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9112ba074b28b6f337698995d6190dea">set_pointlist</a>( this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>() );
<a name="l00292"></a>00292 
<a name="l00293"></a>00293   {
<a name="l00294"></a>00294     <span class="keywordtype">int</span> index = 0;
<a name="l00295"></a>00295     <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it  = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00296"></a>00296     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00297"></a>00297     <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00298"></a>00298       tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3c3a1d223613bc1891dd600698b632ea">set_node</a>(index++, (**it)(0), (**it)(1), (**it)(2));
<a name="l00299"></a>00299   }
<a name="l00300"></a>00300   
<a name="l00301"></a>00301   <span class="comment">// run TetGen triangulation method:</span>
<a name="l00302"></a>00302   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa8419c6f2d036e19a6f40dd61d790158">set_switches</a>(<span class="stringliteral">&quot;Q&quot;</span>); <span class="comment">// TetGen switches: triangulation, Quiet mode</span>
<a name="l00303"></a>00303   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a248559d273c5cee6c07eb4d183565e7e">run_tetgen</a>();
<a name="l00304"></a>00304 
<a name="l00305"></a>00305   <span class="comment">// save elements to mesh structure, nodes will not be changed:</span>
<a name="l00306"></a>00306   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_elements   = tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a38312ab0aebc02be7563a8d667d202ab">get_numberoftetrahedra</a>();
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   <span class="comment">// Vector that temporarily holds the node labels defining element.</span>
<a name="l00309"></a>00309   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> node_labels[4];      
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num_elements; ++i)
<a name="l00312"></a>00312     {
<a name="l00313"></a>00313       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet4.php">Tet4</a>;
<a name="l00314"></a>00314 
<a name="l00315"></a>00315       <span class="comment">// Get the nodes associated with this element</span>
<a name="l00316"></a>00316       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++j)
<a name="l00317"></a>00317         node_labels[j] = tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a92b1c327251652d78291a75e9e3e574f">get_element_node</a>(i,j);
<a name="l00318"></a>00318 
<a name="l00319"></a>00319       <span class="comment">// Associate the nodes with this element</span>
<a name="l00320"></a>00320       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++j)
<a name="l00321"></a>00321         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(j) = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>( node_labels[j] );
<a name="l00322"></a>00322 
<a name="l00323"></a>00323       <span class="comment">// Finally, add this element to the mesh.</span>
<a name="l00324"></a>00324       this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(elem);
<a name="l00325"></a>00325     }
<a name="l00326"></a>00326 } 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 
<a name="l00329"></a>00329 
<a name="l00330"></a><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#ac0886c8ed88787b05064c67f50e70289">00330</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#ac0886c8ed88787b05064c67f50e70289">TetGenMeshInterface::pointset_convexhull</a> ()   
<a name="l00331"></a>00331 {
<a name="l00332"></a>00332   <span class="comment">// class tetgen_wrapper allows library access on a basic level:</span>
<a name="l00333"></a>00333   <a class="code" href="classlibMesh_1_1TetGenWrapper.php">TetGen_access</a> tetgen_wrapper; 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335   <span class="comment">// fill input structure with point set data:</span>
<a name="l00336"></a>00336   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9112ba074b28b6f337698995d6190dea">set_pointlist</a>(this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00337"></a>00337   <span class="keywordtype">int</span> index = 0;
<a name="l00338"></a>00338 
<a name="l00339"></a>00339   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it        = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00340"></a>00340   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00341"></a>00341   <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00342"></a>00342     tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3c3a1d223613bc1891dd600698b632ea">set_node</a>(index++, (**it)(0), (**it)(1), (**it)(2));
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   
<a name="l00345"></a>00345   <span class="comment">// run TetGen triangulation method:</span>
<a name="l00346"></a>00346   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa8419c6f2d036e19a6f40dd61d790158">set_switches</a>(<span class="stringliteral">&quot;Q&quot;</span>); <span class="comment">// TetGen switches: triangulation, Convex hull, Quiet mode</span>
<a name="l00347"></a>00347   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a248559d273c5cee6c07eb4d183565e7e">run_tetgen</a>();
<a name="l00348"></a>00348   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_elements   = tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a888d5310f2dd981172b5117cbec28be2">get_numberoftrifaces</a>();
<a name="l00349"></a>00349 
<a name="l00350"></a>00350   <span class="comment">// Delete *all* old elements</span>
<a name="l00351"></a>00351   {
<a name="l00352"></a>00352     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00353"></a>00353     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00354"></a>00354     <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00355"></a>00355       this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a5c7824047ed759b5a4891a6936b546cc">delete_elem</a> (*it);
<a name="l00356"></a>00356   }
<a name="l00357"></a>00357   
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   <span class="comment">// Add the 2D elements which comprise the convex hull back to the mesh.</span>
<a name="l00360"></a>00360   <span class="comment">// Vector that temporarily holds the node labels defining element.</span>
<a name="l00361"></a>00361   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> node_labels[3];
<a name="l00362"></a>00362   
<a name="l00363"></a>00363   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num_elements; ++i)
<a name="l00364"></a>00364     {
<a name="l00365"></a>00365       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tri3.php">Tri3</a>;
<a name="l00366"></a>00366 
<a name="l00367"></a>00367       <span class="comment">// Get node labels associated with this element</span>
<a name="l00368"></a>00368       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++j)
<a name="l00369"></a>00369         node_labels[j] = tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8b8e215e3078383282812863c1b3faf0">get_triface_node</a>(i,j);
<a name="l00370"></a>00370 
<a name="l00371"></a>00371       <span class="comment">// Associate nodes with this element</span>
<a name="l00372"></a>00372       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); j++)
<a name="l00373"></a>00373         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(j) = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>( node_labels[j] );
<a name="l00374"></a>00374 
<a name="l00375"></a>00375       <span class="comment">// Finally, add this element to the mesh.</span>
<a name="l00376"></a>00376       this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(elem);
<a name="l00377"></a>00377     }
<a name="l00378"></a>00378 } 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 
<a name="l00382"></a><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975a8bb687bca7286ece6a6acb9c1bbd">00382</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975a8bb687bca7286ece6a6acb9c1bbd">TetGenMeshInterface::get_node_index</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* inode)
<a name="l00383"></a>00383 {
<a name="l00384"></a>00384   <span class="comment">// This is NO elegant solution! (A linear search of the nodes.)</span>
<a name="l00385"></a>00385   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id;
<a name="l00386"></a>00386   node_id = inode-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>(); ++i)
<a name="l00389"></a>00389     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a04539794a1d24768fbfbd40de74fd118">node</a>(i).<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == node_id)
<a name="l00390"></a>00390       <span class="keywordflow">return</span> i;
<a name="l00391"></a>00391 
<a name="l00392"></a>00392   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error! Node not found in the mesh!&quot;</span> &lt;&lt; std::endl;
<a name="l00393"></a>00393   libmesh_error();
<a name="l00394"></a>00394   
<a name="l00395"></a>00395   <span class="keywordflow">return</span> 0;
<a name="l00396"></a>00396 }
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 
<a name="l00399"></a>00399 
<a name="l00400"></a><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#ac771bad4e0049ae27914a82387ef0032">00400</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#ac771bad4e0049ae27914a82387ef0032">TetGenMeshInterface::triangulate_conformingDelaunayMesh</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> quality_constraint,
<a name="l00401"></a>00401                                                               <span class="keyword">const</span> <span class="keywordtype">double</span> volume_constraint)   
<a name="l00402"></a>00402 {
<a name="l00403"></a>00403   <span class="comment">// &gt;&gt;&gt; libmesh_assert usage of TRI3 hull elements (no other elements! =&gt; mesh.all_tri() )</span>
<a name="l00404"></a>00404 
<a name="l00405"></a>00405   <span class="comment">// thorough check of hull integrity:</span>
<a name="l00406"></a>00406   <span class="comment">// loop over hull with breadth-first search:</span>
<a name="l00407"></a>00407   std::set&lt; Elem *&gt;    visited;
<a name="l00408"></a>00408   std::vector&lt; Elem *&gt; current;
<a name="l00409"></a>00409 
<a name="l00410"></a>00410   <span class="comment">// Initialize the current vector with element 0</span>
<a name="l00411"></a>00411   current.push_back(this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(0));
<a name="l00412"></a>00412 
<a name="l00413"></a>00413   <span class="keywordflow">while</span> (!current.empty())
<a name="l00414"></a>00414     {
<a name="l00415"></a>00415       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = current.back();
<a name="l00416"></a>00416 
<a name="l00417"></a>00417       libmesh_assert (elem != NULL);
<a name="l00418"></a>00418   
<a name="l00419"></a>00419       <span class="comment">// Attempt to insert this element into the visited set.</span>
<a name="l00420"></a>00420       visited.insert(elem);
<a name="l00421"></a>00421 
<a name="l00422"></a>00422       <span class="comment">// Remove the last element from the vector.</span>
<a name="l00423"></a>00423       current.pop_back();
<a name="l00424"></a>00424 
<a name="l00425"></a>00425       <span class="comment">// Loop over the element&#39;s neighbors</span>
<a name="l00426"></a>00426       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); ++i)
<a name="l00427"></a>00427         {
<a name="l00428"></a>00428           <span class="comment">// Attempt to find this element&#39;s neighbor in the visited set.</span>
<a name="l00429"></a>00429           <span class="comment">// If not found, insert this neighbor into the current vector.</span>
<a name="l00430"></a>00430           <span class="keywordflow">if</span> (visited.find(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(i)) == visited.end())
<a name="l00431"></a>00431             current.push_back(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(i));
<a name="l00432"></a>00432         } 
<a name="l00433"></a>00433     }
<a name="l00434"></a>00434   
<a name="l00435"></a>00435   <span class="keywordflow">if</span> (visited.size() != this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>())
<a name="l00436"></a>00436     {
<a name="l00437"></a>00437       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;triangulate: hull not connected: element(s) not reached by others.\n&quot;</span>;
<a name="l00438"></a>00438       libmesh_error();
<a name="l00439"></a>00439     } 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441   <span class="comment">// start triangulation method with empty holes list:</span>
<a name="l00442"></a>00442   std::vector&lt; Node *&gt; noholes;
<a name="l00443"></a>00443   <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a85b82980edc2381f126bd26e33992c48">triangulate_conformingDelaunayMesh_carvehole</a>(noholes, quality_constraint, volume_constraint);
<a name="l00444"></a>00444 }
<a name="l00445"></a>00445 
<a name="l00446"></a>00446 
<a name="l00447"></a>00447 
<a name="l00448"></a><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a85b82980edc2381f126bd26e33992c48">00448</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a85b82980edc2381f126bd26e33992c48">TetGenMeshInterface::triangulate_conformingDelaunayMesh_carvehole</a>  (<span class="keyword">const</span> std::vector&lt; Node *&gt;&amp; holes,
<a name="l00449"></a>00449                                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> quality_constraint,
<a name="l00450"></a>00450                                                                          <span class="keyword">const</span> <span class="keywordtype">double</span> volume_constraint)
<a name="l00451"></a>00451 {
<a name="l00452"></a>00452   <span class="comment">// Check mesh for validity: Must be composed of all TRI3 elements,</span>
<a name="l00453"></a>00453   <span class="comment">// also it must be convex so each element must have non-NULL neighbors.</span>
<a name="l00454"></a>00454   {
<a name="l00455"></a>00455     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> it        = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00456"></a>00456     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00457"></a>00457 
<a name="l00458"></a>00458     <span class="keywordflow">for</span> (; it != end ; ++it)
<a name="l00459"></a>00459       {
<a name="l00460"></a>00460         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00461"></a>00461 
<a name="l00462"></a>00462         <span class="comment">// Check for proper element type</span>
<a name="l00463"></a>00463         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() != <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>)
<a name="l00464"></a>00464           {
<a name="l00465"></a>00465             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Some of the elements in the original mesh were not TRI3!&quot;</span> &lt;&lt; std::endl;
<a name="l00466"></a>00466             libmesh_error();
<a name="l00467"></a>00467           }
<a name="l00468"></a>00468 
<a name="l00469"></a>00469         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); ++i)
<a name="l00470"></a>00470           {
<a name="l00471"></a>00471             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(i) == NULL)
<a name="l00472"></a>00472               {
<a name="l00473"></a>00473                 <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Non-convex hull, cannot be tetrahedralized.&quot;</span> &lt;&lt; std::endl;
<a name="l00474"></a>00474                 libmesh_error();
<a name="l00475"></a>00475               }
<a name="l00476"></a>00476           }
<a name="l00477"></a>00477       }
<a name="l00478"></a>00478   }
<a name="l00479"></a>00479   
<a name="l00480"></a>00480   <span class="comment">// &gt;&gt;&gt; fill input structure with point set data:</span>
<a name="l00481"></a>00481   <span class="comment">// class tetgen_wrapper allows library access on a basic level:</span>
<a name="l00482"></a>00482   <a class="code" href="classlibMesh_1_1TetGenWrapper.php">TetGen_access</a> tetgen_wrapper; 
<a name="l00483"></a>00483 
<a name="l00484"></a>00484   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9112ba074b28b6f337698995d6190dea">set_pointlist</a>(this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00485"></a>00485   {
<a name="l00486"></a>00486     <span class="keywordtype">int</span> index = 0;
<a name="l00487"></a>00487     <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> it        = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00488"></a>00488     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00489"></a>00489     <span class="keywordflow">for</span> ( ; it != end; ++it) 
<a name="l00490"></a>00490       tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3c3a1d223613bc1891dd600698b632ea">set_node</a>(index++, (**it)(0), (**it)(1), (**it)(2));
<a name="l00491"></a>00491   }
<a name="l00492"></a>00492 
<a name="l00493"></a>00493   <span class="comment">// &gt;&gt;&gt; fill input structure &quot;tetgenio&quot; with facet data:</span>
<a name="l00494"></a>00494   <span class="keywordtype">int</span> facet_num = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00495"></a>00495 
<a name="l00496"></a>00496   <span class="comment">// allocate memory in &quot;tetgenio&quot; structure:</span>
<a name="l00497"></a>00497   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9e093a7bbf339e23150e523c9e40cdfc">set_facetlist</a>(facet_num, holes.size());
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500   {
<a name="l00501"></a>00501     <span class="keywordtype">int</span> insertnum = 0;
<a name="l00502"></a>00502     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> it        = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00503"></a>00503     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00504"></a>00504     <span class="keywordflow">for</span> (; it != end ; ++it)
<a name="l00505"></a>00505       {
<a name="l00506"></a>00506         tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4bb664b2a6951c85dd0c343de39ec78b">set_facet_polygonlist</a>(insertnum, 1);
<a name="l00507"></a>00507         tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#aef241deb3592ba8a085a56be32e81abc">set_polygon_vertexlist</a>(insertnum, 0, 3);
<a name="l00508"></a>00508 
<a name="l00509"></a>00509         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00510"></a>00510 
<a name="l00511"></a>00511         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++j)
<a name="l00512"></a>00512           tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a956f3fbf2d6f22b61c715123f367ffac">set_vertex</a>(insertnum, <span class="comment">// facet number</span>
<a name="l00513"></a>00513                                     0,         <span class="comment">// polygon (always 0)</span>
<a name="l00514"></a>00514                                     j,         <span class="comment">// vertex in tetgen input</span>
<a name="l00515"></a>00515                                     this-&gt;get_node_index(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(j)));
<a name="l00516"></a>00516         insertnum++;
<a name="l00517"></a>00517       }
<a name="l00518"></a>00518   }
<a name="l00519"></a>00519 
<a name="l00520"></a>00520 
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   <span class="comment">// fill hole list (if there are holes):</span>
<a name="l00523"></a>00523   <span class="keywordflow">if</span> (holes.size() &gt; 0)
<a name="l00524"></a>00524     {
<a name="l00525"></a>00525       std::vector&lt; Node *&gt;::const_iterator ihole;
<a name="l00526"></a>00526       <span class="keywordtype">int</span> hole_index = 0;
<a name="l00527"></a>00527       <span class="keywordflow">for</span> (ihole=holes.begin(); ihole!=holes.end(); ++ihole)
<a name="l00528"></a>00528         tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a0473a1625fe0298c21617cba7344e9a7">set_hole</a>(hole_index++, (**ihole)(0), (**ihole)(1), (**ihole)(2));
<a name="l00529"></a>00529     }
<a name="l00530"></a>00530 
<a name="l00531"></a>00531   
<a name="l00532"></a>00532   <span class="comment">// &gt;&gt;&gt; run TetGen triangulation method:</span>
<a name="l00533"></a>00533   <span class="comment">// assemble switches:</span>
<a name="l00534"></a>00534   std::ostringstream oss; <span class="comment">// string holding switches</span>
<a name="l00535"></a>00535   oss &lt;&lt; <span class="stringliteral">&quot;pQ&quot;</span>;
<a name="l00536"></a>00536 
<a name="l00537"></a>00537   <span class="keywordflow">if</span> (quality_constraint != 0)
<a name="l00538"></a>00538     oss &lt;&lt; <span class="stringliteral">&quot;q&quot;</span> &lt;&lt; std::fixed &lt;&lt; quality_constraint;
<a name="l00539"></a>00539   
<a name="l00540"></a>00540   <span class="keywordflow">if</span> (volume_constraint != 0)
<a name="l00541"></a>00541     oss &lt;&lt; <span class="stringliteral">&quot;a&quot;</span> &lt;&lt; std::fixed &lt;&lt; volume_constraint;
<a name="l00542"></a>00542   
<a name="l00543"></a>00543   std::string params = oss.str();
<a name="l00544"></a>00544 
<a name="l00545"></a>00545   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa8419c6f2d036e19a6f40dd61d790158">set_switches</a>(params); <span class="comment">// TetGen switches: Piecewise linear complex, Quiet mode</span>
<a name="l00546"></a>00546   tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a248559d273c5cee6c07eb4d183565e7e">run_tetgen</a>();
<a name="l00547"></a>00547 
<a name="l00548"></a>00548   <span class="comment">// =&gt; nodes:</span>
<a name="l00549"></a>00549   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_nodesnum = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>();
<a name="l00550"></a>00550   <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> x=0., y=0., z=0.;
<a name="l00551"></a>00551   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_nodes = tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#ac8d61f645946216032b8b106375c180a">get_numberofpoints</a>();
<a name="l00552"></a>00552 
<a name="l00553"></a>00553   <span class="comment">// Add additional nodes to the nodes vector.</span>
<a name="l00554"></a>00554   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=old_nodesnum; i&lt;=num_nodes; i++)
<a name="l00555"></a>00555     {
<a name="l00556"></a>00556       tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#ac23554446a737933a47caba6febe9459">get_output_node</a>(i, x,y,z);
<a name="l00557"></a>00557       this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ab07787f7933b2fbe29bc2bef32401fdc">add_point</a> ( <a class="code" href="classlibMesh_1_1Point.php">Point</a>(x,y,z) );
<a name="l00558"></a>00558     }
<a name="l00559"></a>00559   
<a name="l00560"></a>00560   <span class="comment">// =&gt; tetrahedra:</span>
<a name="l00561"></a>00561   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_elements   = tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a38312ab0aebc02be7563a8d667d202ab">get_numberoftetrahedra</a>();
<a name="l00562"></a>00562 
<a name="l00563"></a>00563   <span class="comment">// Vector that temporarily holds the node labels defining element.</span>
<a name="l00564"></a>00564   <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> node_labels[4];      
<a name="l00565"></a>00565 
<a name="l00566"></a>00566   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num_elements; i++)
<a name="l00567"></a>00567     {
<a name="l00568"></a>00568       <span class="comment">//_elements[firstnumber+i] = new Tet4;     // TetGen only supports Tet4 elements.</span>
<a name="l00569"></a>00569       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tet4.php">Tet4</a>;
<a name="l00570"></a>00570 
<a name="l00571"></a>00571       <span class="comment">// Fill up the the node_labels vector</span>
<a name="l00572"></a>00572       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); j++) 
<a name="l00573"></a>00573         node_labels[j] = tetgen_wrapper.<a class="code" href="classlibMesh_1_1TetGenWrapper.php#a92b1c327251652d78291a75e9e3e574f">get_element_node</a>(i,j);
<a name="l00574"></a>00574       
<a name="l00575"></a>00575       <span class="comment">// Associate nodes with this element</span>
<a name="l00576"></a>00576       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); j++) 
<a name="l00577"></a>00577         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(j) = this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>( node_labels[j] );
<a name="l00578"></a>00578 
<a name="l00579"></a>00579       <span class="comment">// Finally, add this element to the mesh</span>
<a name="l00580"></a>00580       this-&gt;<a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a5ab834283fa6bc335ad623d2b737ec5e">add_elem</a>(elem);
<a name="l00581"></a>00581     }
<a name="l00582"></a>00582 }
<a name="l00583"></a>00583 
<a name="l00584"></a>00584 } <span class="comment">// namespace libMesh</span>
<a name="l00585"></a>00585 
<a name="l00586"></a>00586 
<a name="l00587"></a>00587 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_TETGEN</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
