<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_tetgen_support.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__tetgen__support_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_tetgen_support.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002  
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __mesh_tetgen_support_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_tetgen_support_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#ifdef LIBMESH_HAVE_TETGEN</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// C++ includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Local includes</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// TetGen include file</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;tetgen.h&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>libMesh
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// Forward Declarations</span>
<a name="l00043"></a>00043 <span class="keyword">class </span>UnstructuredMesh;
<a name="l00044"></a>00044 <span class="keyword">class </span>Node;
<a name="l00045"></a>00045 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TetGenWrapper.php">TetGenWrapper</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052  <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a115204d61274e1dcedbf9d77da86a066">TetGenWrapper</a> ();
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a31da8a4d9c868179147fa939e3b72be4">~TetGenWrapper</a> ();
<a name="l00063"></a>00063   
<a name="l00067"></a>00067   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa8419c6f2d036e19a6f40dd61d790158">set_switches</a>(<span class="keyword">const</span> std::string&amp; s);
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a248559d273c5cee6c07eb4d183565e7e">run_tetgen</a>();
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a38312ab0aebc02be7563a8d667d202ab">get_numberoftetrahedra</a>();
<a name="l00078"></a>00078 
<a name="l00082"></a>00082   <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a888d5310f2dd981172b5117cbec28be2">get_numberoftrifaces</a>();
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#acf4dd49a84388662930ddd2dd08b563a">set_numberofpoints</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00088"></a>00088 
<a name="l00092"></a>00092   <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1TetGenWrapper.php#ac8d61f645946216032b8b106375c180a">get_numberofpoints</a>();
<a name="l00093"></a>00093 
<a name="l00097"></a>00097   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4aebcfaa10e85e13029ff2c05ba384ed">set_numberoffacets</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00098"></a>00098 
<a name="l00102"></a>00102   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a92f53a7bec19f7849cdc6ab8dfb6b403">set_numberofholes</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00103"></a>00103 
<a name="l00107"></a>00107   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#aa57623338e0e5fceb963fdb5795024b5">set_numberofregions</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00108"></a>00108 
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9112ba074b28b6f337698995d6190dea">set_pointlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numofpoints);
<a name="l00113"></a>00113 
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a9e093a7bbf339e23150e523c9e40cdfc">set_facetlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numoffacets, <span class="keyword">const</span> <span class="keywordtype">int</span> numofholes);
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4e13f1eaf10bc8e0232df3777a12c9b7">set_regionlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> numofregions);
<a name="l00123"></a>00123 
<a name="l00127"></a>00127   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3c3a1d223613bc1891dd600698b632ea">set_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> x, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> y, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> z);
<a name="l00128"></a>00128 
<a name="l00132"></a>00132   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#ac23554446a737933a47caba6febe9459">get_output_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>&amp; x, <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>&amp; y, <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>&amp; z);
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a92b1c327251652d78291a75e9e3e574f">get_element_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j);
<a name="l00138"></a>00138 
<a name="l00142"></a>00142   <span class="keywordtype">int</span>  <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8b8e215e3078383282812863c1b3faf0">get_triface_node</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j);
<a name="l00143"></a>00143 
<a name="l00147"></a>00147   <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a40cfd04da7555e800084b21fdb3ae7bf">get_element_attribute</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i);
<a name="l00148"></a>00148        
<a name="l00152"></a>00152   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a0473a1625fe0298c21617cba7344e9a7">set_hole</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> x, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> y, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> z);
<a name="l00153"></a>00153 
<a name="l00157"></a>00157   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a3ef1609bbbcf13fdc94fe4ee7600a4a1">set_facet_numberofpolygons</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> num);
<a name="l00158"></a>00158 
<a name="l00162"></a>00162   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#adfe99309c41f3bef0d60e78161231829">set_facet_numberofholes</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> num);
<a name="l00163"></a>00163 
<a name="l00168"></a>00168   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a4bb664b2a6951c85dd0c343de39ec78b">set_facet_polygonlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> numofpolygons);
<a name="l00169"></a>00169 
<a name="l00173"></a>00173   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a124ec042cf813d9f3496e37ad55269bf">set_polygon_numberofvertices</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> num);
<a name="l00174"></a>00174 
<a name="l00179"></a>00179   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#aef241deb3592ba8a085a56be32e81abc">set_polygon_vertexlist</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> numofvertices);
<a name="l00180"></a>00180 
<a name="l00185"></a>00185   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a956f3fbf2d6f22b61c715123f367ffac">set_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <span class="keywordtype">int</span> j, <span class="keyword">const</span> <span class="keywordtype">int</span> k, <span class="keyword">const</span> <span class="keywordtype">int</span> nodeindex);
<a name="l00186"></a>00186 
<a name="l00193"></a>00193   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenWrapper.php#aed70a5adcee4441abbf62a369263f828">set_region</a>(<span class="keyword">const</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> x, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> y, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> z,
<a name="l00194"></a>00194                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> attribute, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a> vol_constraint);
<a name="l00195"></a>00195 
<a name="l00199"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">00199</a>   tetgenio   <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a43b66745bdfedaa2800e31b92d370398">tetgen_data</a>;
<a name="l00200"></a>00200   
<a name="l00204"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">00204</a>   tetgenio*  <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a8fc408001057b9afa6a7117459d7a52e">tetgen_output</a>;
<a name="l00205"></a>00205 
<a name="l00209"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#af27cda74a04ec53e49b344aaae60ee4c">00209</a>   tetgenmesh      <a class="code" href="classlibMesh_1_1TetGenWrapper.php#af27cda74a04ec53e49b344aaae60ee4c">tetgen_mesh</a>;
<a name="l00210"></a>00210   
<a name="l00214"></a><a class="code" href="classlibMesh_1_1TetGenWrapper.php#a945509dbfddbed16d2ab9b0d55416c53">00214</a>   tetgenbehavior  <a class="code" href="classlibMesh_1_1TetGenWrapper.php#a945509dbfddbed16d2ab9b0d55416c53">tetgen_be</a>; 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 };
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 
<a name="l00226"></a><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php">00226</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php">TetGenMeshInterface</a>
<a name="l00227"></a>00227 {
<a name="l00228"></a>00228 <span class="keyword">public</span>:
<a name="l00229"></a>00229 
<a name="l00233"></a>00233   <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#aa12f916741d05c1c9641cf045dd50094">TetGenMeshInterface</a> (<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00234"></a>00234 
<a name="l00238"></a><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a0ce84cbce6fc733bc897779e7f7f5462">00238</a>   <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a0ce84cbce6fc733bc897779e7f7f5462">~TetGenMeshInterface</a>() {};
<a name="l00239"></a>00239 
<a name="l00244"></a>00244   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a4d72158648256e5b047b89962489b9b7">triangulate_pointset</a> ();
<a name="l00245"></a>00245 
<a name="l00250"></a>00250   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#ac0886c8ed88787b05064c67f50e70289">pointset_convexhull</a> ();
<a name="l00251"></a>00251 
<a name="l00257"></a>00257   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#ac771bad4e0049ae27914a82387ef0032">triangulate_conformingDelaunayMesh</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> quality_constraint,
<a name="l00258"></a>00258                                            <span class="keyword">const</span> <span class="keywordtype">double</span> volume_constraint);
<a name="l00259"></a>00259 
<a name="l00265"></a>00265   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a85b82980edc2381f126bd26e33992c48">triangulate_conformingDelaunayMesh_carvehole</a> (<span class="keyword">const</span> std::vector&lt; Node *&gt;&amp; holes,
<a name="l00266"></a>00266                                                      <span class="keyword">const</span> <span class="keywordtype">double</span> quality_constraint,
<a name="l00267"></a>00267                                                      <span class="keyword">const</span> <span class="keywordtype">double</span> volume_constraint);
<a name="l00268"></a>00268 
<a name="l00272"></a>00272   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975a8bb687bca7286ece6a6acb9c1bbd">get_node_index</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* inode);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 <span class="keyword">protected</span>:
<a name="l00276"></a>00276 
<a name="l00280"></a><a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">00280</a>   <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="classlibMesh_1_1TetGenMeshInterface.php#a975b92754c9eb493185e49486a538bdc">_mesh</a>;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 };
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 } <span class="comment">// namespace libMesh</span>
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="preprocessor">#endif // LIBMESH_HAVE_TETGEN</span>
<a name="l00287"></a>00287 <span class="preprocessor"></span>
<a name="l00288"></a>00288 <span class="preprocessor">#endif </span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
