<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_tools.C</div>  </div>
</div>
<div class="contents">
<a href="mesh__tools_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_tools.C 4394 2011-04-22 04:12:18Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;limits&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem__range_8h.php">elem_range.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="location__maps_8h.php">location_maps.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="node__range_8h.php">node_range.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="serial__mesh_8h.php">serial_mesh.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="sphere_8h.php">sphere.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="threads_8h.php">threads.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00041"></a>00041 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;<a class="code" href="remote__elem_8h.php">remote_elem.h</a>&quot;</span>
<a name="l00042"></a>00042 <span class="preprocessor">#endif</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// anonymous namespace for helper classes</span>
<a name="l00048"></a>00048 <span class="keyword">namespace </span>{
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="keyword">using namespace </span>libMesh;
<a name="l00051"></a>00051 
<a name="l00059"></a>00059   <span class="keyword">class </span>SumElemWeight
<a name="l00060"></a>00060   {
<a name="l00061"></a>00061   <span class="keyword">public</span>:
<a name="l00062"></a>00062     SumElemWeight () : 
<a name="l00063"></a>00063       _weight(0) 
<a name="l00064"></a>00064     {}
<a name="l00065"></a>00065 
<a name="l00066"></a>00066     SumElemWeight (SumElemWeight &amp;, <a class="code" href="classlibMesh_1_1Threads_1_1split.php">Threads::split</a>) : 
<a name="l00067"></a>00067       _weight(0)
<a name="l00068"></a>00068     {}
<a name="l00069"></a>00069     
<a name="l00070"></a>00070     <span class="keywordtype">void</span> operator()(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range)
<a name="l00071"></a>00071     { 
<a name="l00072"></a>00072       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> it = range.<a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a>(); it !=range.<a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a>(); ++it)
<a name="l00073"></a>00073         _weight += (*it)-&gt;n_nodes();
<a name="l00074"></a>00074     }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">weight</a>()<span class="keyword"> const </span>
<a name="l00077"></a>00077 <span class="keyword">    </span>{ <span class="keywordflow">return</span> _weight; }
<a name="l00078"></a>00078     
<a name="l00079"></a>00079 <span class="comment">// If we don&#39;t have threads we never need a join, and icpc yells a</span>
<a name="l00080"></a>00080 <span class="comment">// warning if it sees an anonymous function that&#39;s never used</span>
<a name="l00081"></a>00081 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>    <span class="keywordtype">void</span> join (<span class="keyword">const</span> SumElemWeight &amp;other)
<a name="l00083"></a>00083     { _weight += other.weight(); }
<a name="l00084"></a>00084 <span class="preprocessor">#endif</span>
<a name="l00085"></a>00085 <span class="preprocessor"></span>
<a name="l00086"></a>00086   <span class="keyword">private</span>:
<a name="l00087"></a>00087     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _weight;
<a name="l00088"></a>00088   };
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00097"></a>00097   <span class="keyword">class </span>FindBBox
<a name="l00098"></a>00098   {
<a name="l00099"></a>00099   <span class="keyword">public</span>:
<a name="l00100"></a>00100     FindBBox () :
<a name="l00101"></a>00101       _vmin(LIBMESH_DIM,  std::numeric_limits&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;::<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>()),
<a name="l00102"></a>00102       _vmax(LIBMESH_DIM, -std::numeric_limits&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;::<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>())
<a name="l00103"></a>00103     {}
<a name="l00104"></a>00104 
<a name="l00105"></a>00105     FindBBox (FindBBox &amp;other, <a class="code" href="classlibMesh_1_1Threads_1_1split.php">Threads::split</a>) :
<a name="l00106"></a>00106       _vmin(other._vmin),
<a name="l00107"></a>00107       _vmax(other._vmax)
<a name="l00108"></a>00108     {}
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     std::vector&lt;Real&gt; &amp; <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>() { <span class="keywordflow">return</span> _vmin; }
<a name="l00111"></a>00111     std::vector&lt;Real&gt; &amp; <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>() { <span class="keywordflow">return</span> _vmax; }
<a name="l00112"></a>00112     
<a name="l00113"></a>00113     <span class="keywordtype">void</span> operator()(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstNodeRange</a> &amp;range)
<a name="l00114"></a>00114     {
<a name="l00115"></a>00115       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstNodeRange::const_iterator</a> it = range.<a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a>(); it != range.<a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a>(); ++it)
<a name="l00116"></a>00116         {
<a name="l00117"></a>00117           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = *it;
<a name="l00118"></a>00118           libmesh_assert (node != NULL);
<a name="l00119"></a>00119           
<a name="l00120"></a>00120           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00121"></a>00121             {
<a name="l00122"></a>00122               _vmin[i] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(_vmin[i], (*node)(i));
<a name="l00123"></a>00123               _vmax[i] = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(_vmax[i], (*node)(i));
<a name="l00124"></a>00124             }      
<a name="l00125"></a>00125         }
<a name="l00126"></a>00126     }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     <span class="keywordtype">void</span> operator()(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range)
<a name="l00129"></a>00129     {
<a name="l00130"></a>00130       <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> it = range.<a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a>(); it != range.<a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a>(); ++it)
<a name="l00131"></a>00131         {
<a name="l00132"></a>00132           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *it;
<a name="l00133"></a>00133           libmesh_assert (elem != NULL);
<a name="l00134"></a>00134 
<a name="l00135"></a>00135           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00136"></a>00136             {
<a name="l00137"></a>00137               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;point = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a2cb5212bd36caff163c65e3ccff273f0">point</a>(n);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00140"></a>00140                 {
<a name="l00141"></a>00141                   _vmin[i] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(_vmin[i], point(i));
<a name="l00142"></a>00142                   _vmax[i] = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(_vmax[i], point(i));
<a name="l00143"></a>00143                 }     
<a name="l00144"></a>00144             } 
<a name="l00145"></a>00145         }
<a name="l00146"></a>00146     }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 <span class="comment">// If we don&#39;t have threads we never need a join, and icpc yells a</span>
<a name="l00149"></a>00149 <span class="comment">// warning if it sees an anonymous function that&#39;s never used</span>
<a name="l00150"></a>00150 <span class="preprocessor">#ifdef LIBMESH_HAVE_TBB_API</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>    <span class="keywordtype">void</span> join (<span class="keyword">const</span> FindBBox &amp;other)
<a name="l00152"></a>00152     {
<a name="l00153"></a>00153       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;LIBMESH_DIM; i++)
<a name="l00154"></a>00154         {
<a name="l00155"></a>00155           _vmin[i] = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(_vmin[i], other._vmin[i]);
<a name="l00156"></a>00156           _vmax[i] = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(_vmax[i], other._vmax[i]);
<a name="l00157"></a>00157         }      
<a name="l00158"></a>00158     }
<a name="l00159"></a>00159 <span class="preprocessor">#endif</span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>
<a name="l00161"></a>00161     <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> bbox ()<span class="keyword"> const</span>
<a name="l00162"></a>00162 <span class="keyword">    </span>{
<a name="l00163"></a>00163       <a class="code" href="classlibMesh_1_1Point.php">Point</a> pmin(_vmin[0]
<a name="l00164"></a>00164 #<span class="keywordflow">if</span> LIBMESH_DIM &gt; 1
<a name="l00165"></a>00165                  , _vmin[1]
<a name="l00166"></a>00166 #endif
<a name="l00167"></a>00167 #<span class="keywordflow">if</span> LIBMESH_DIM &gt; 2
<a name="l00168"></a>00168                  , _vmin[2]
<a name="l00169"></a>00169 #endif
<a name="l00170"></a>00170                 );
<a name="l00171"></a>00171       <a class="code" href="classlibMesh_1_1Point.php">Point</a> pmax(_vmax[0]
<a name="l00172"></a>00172 #<span class="keywordflow">if</span> LIBMESH_DIM &gt; 1
<a name="l00173"></a>00173                  , _vmax[1]
<a name="l00174"></a>00174 #endif
<a name="l00175"></a>00175 #<span class="keywordflow">if</span> LIBMESH_DIM &gt; 2
<a name="l00176"></a>00176                  , _vmax[2]
<a name="l00177"></a>00177 #endif
<a name="l00178"></a>00178                 );
<a name="l00179"></a>00179 
<a name="l00180"></a>00180       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> ret_val(pmin, pmax);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182       <span class="keywordflow">return</span> ret_val;        
<a name="l00183"></a>00183     }
<a name="l00184"></a>00184     
<a name="l00185"></a>00185   <span class="keyword">private</span>:
<a name="l00186"></a>00186     std::vector&lt;Real&gt; _vmin;
<a name="l00187"></a>00187     std::vector&lt;Real&gt; _vmax;
<a name="l00188"></a>00188   };
<a name="l00189"></a>00189 }
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 <span class="keyword">namespace </span>libMesh
<a name="l00193"></a>00193 {
<a name="l00194"></a>00194 <span class="comment">// Small helper function to make intersect more readable.</span>
<a name="l00195"></a><a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">00195</a> <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> check, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>)
<a name="l00196"></a>00196 {
<a name="l00197"></a>00197   <span class="keywordflow">return</span> min &lt;= check &amp;&amp; check &lt;= <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>;
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
<a name="l00200"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a2ee857488624778d1282d2efa57ce743">00200</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a2ee857488624778d1282d2efa57ce743">MeshTools::BoundingBox::intersect</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">BoundingBox</a> &amp; other_box)<span class="keyword"> const</span>
<a name="l00201"></a>00201 <span class="keyword"></span>{
<a name="l00202"></a>00202   <span class="comment">// Make local variables first to make thiings more clear in a moment</span>
<a name="l00203"></a>00203   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; my_min_x = this-&gt;first(0);
<a name="l00204"></a>00204   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; my_max_x = this-&gt;second(0);
<a name="l00205"></a>00205   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; other_min_x = other_box.first(0);
<a name="l00206"></a>00206   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; other_max_x = other_box.second(0);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208   <span class="keyword">const</span> <span class="keywordtype">bool</span> x_int = <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(my_min_x, other_min_x, my_max_x) || <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(my_min_x, other_max_x, my_max_x) ||
<a name="l00209"></a>00209                      <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(other_min_x, my_min_x, other_max_x) || <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(other_min_x, my_max_x, other_max_x);
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="keywordtype">bool</span> intersection_true = x_int;
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00214"></a>00214 <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; my_min_y = this-&gt;first(1);
<a name="l00215"></a>00215   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; my_max_y = this-&gt;second(1);
<a name="l00216"></a>00216   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; other_min_y = other_box.first(1);
<a name="l00217"></a>00217   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; other_max_y = other_box.second(1);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="keyword">const</span> <span class="keywordtype">bool</span> y_int = <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(my_min_y, other_min_y, my_max_y) || <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(my_min_y, other_max_y, my_max_y) ||
<a name="l00220"></a>00220                      <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(other_min_y, my_min_y, other_max_y) || <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(other_min_y, my_max_y, other_max_y);
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   intersection_true = intersection_true &amp;&amp; y_int;
<a name="l00223"></a>00223 <span class="preprocessor">#endif</span>
<a name="l00224"></a>00224 <span class="preprocessor"></span>
<a name="l00225"></a>00225 <span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00226"></a>00226 <span class="preprocessor"></span>  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; my_min_z = this-&gt;first(2);
<a name="l00227"></a>00227   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; my_max_z = this-&gt;second(2);
<a name="l00228"></a>00228   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; other_min_z = other_box.first(2);
<a name="l00229"></a>00229   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; other_max_z = other_box.second(2);
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   <span class="keyword">const</span> <span class="keywordtype">bool</span> z_int = <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(my_min_z, other_min_z, my_max_z) || <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(my_min_z, other_max_z, my_max_z) ||
<a name="l00232"></a>00232                      <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(other_min_z, my_min_z, other_max_z) || <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(other_min_z, my_max_z, other_max_z);
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   intersection_true = intersection_true &amp;&amp; z_int;
<a name="l00235"></a>00235 <span class="preprocessor">#endif</span>
<a name="l00236"></a>00236 <span class="preprocessor"></span>
<a name="l00237"></a>00237   <span class="keywordflow">return</span> intersection_true;
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#ab80b8987921cdeafa69a873774d3bf24">00240</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#ab80b8987921cdeafa69a873774d3bf24">MeshTools::BoundingBox::contains_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; p)<span class="keyword"> const</span>
<a name="l00241"></a>00241 <span class="keyword"></span>{
<a name="l00242"></a>00242   <span class="comment">// Make local variables first to make thiings more clear in a moment</span>
<a name="l00243"></a>00243   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_min_x = this-&gt;first(0);
<a name="l00244"></a>00244   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max_x = this-&gt;second(0);
<a name="l00245"></a>00245   <span class="keywordtype">bool</span> x_int = <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(my_min_x, p(0), my_max_x);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <span class="keywordtype">bool</span> intersection_true = x_int;
<a name="l00248"></a>00248 
<a name="l00249"></a>00249 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span>  <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_min_y = this-&gt;first(1);
<a name="l00251"></a>00251   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max_y = this-&gt;second(1);
<a name="l00252"></a>00252   <span class="keywordtype">bool</span> y_int = <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(my_min_y, p(1), my_max_y);
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   intersection_true = intersection_true &amp;&amp; y_int;
<a name="l00255"></a>00255 <span class="preprocessor">#endif</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 <span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00259"></a>00259 <span class="preprocessor"></span>  <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_min_z = this-&gt;first(2);
<a name="l00260"></a>00260   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_max_z = this-&gt;second(2);
<a name="l00261"></a>00261   <span class="keywordtype">bool</span> z_int = <a class="code" href="namespacelibMesh.php#a19dce19dd9e0eece93901e8193b0cd39">is_between</a>(my_min_z, p(2), my_max_z);
<a name="l00262"></a>00262 
<a name="l00263"></a>00263   intersection_true = intersection_true &amp;&amp; z_int;
<a name="l00264"></a>00264 <span class="preprocessor">#endif</span>
<a name="l00265"></a>00265 <span class="preprocessor"></span>
<a name="l00266"></a>00266   <span class="keywordflow">return</span> intersection_true;
<a name="l00267"></a>00267 }
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00270"></a>00270 <span class="comment">// MeshTools functions</span>
<a name="l00271"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a090bd8f1b67e129c3aa31e8bd40bc365">00271</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a090bd8f1b67e129c3aa31e8bd40bc365">MeshTools::total_weight</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00272"></a>00272 {
<a name="l00273"></a>00273   <span class="keywordflow">if</span> (!mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00274"></a>00274     {
<a name="l00275"></a>00275       parallel_only();
<a name="l00276"></a>00276       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">weight</a> = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">MeshTools::weight</a> (mesh, <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00277"></a>00277       <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(weight);
<a name="l00278"></a>00278       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> unpartitioned_weight =
<a name="l00279"></a>00279         <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">MeshTools::weight</a> (mesh, <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00280"></a>00280       <span class="keywordflow">return</span> weight + unpartitioned_weight;
<a name="l00281"></a>00281     }
<a name="l00282"></a>00282   
<a name="l00283"></a>00283   SumElemWeight sew;
<a name="l00284"></a>00284   
<a name="l00285"></a>00285   <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">Threads::parallel_reduce</a> (<a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(),
<a name="l00286"></a>00286                                             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>()),
<a name="l00287"></a>00287                             sew);
<a name="l00288"></a>00288   <span class="keywordflow">return</span> sew.weight();
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 }
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 
<a name="l00294"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">00294</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">MeshTools::weight</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)
<a name="l00295"></a>00295 {
<a name="l00296"></a>00296   SumElemWeight sew;
<a name="l00297"></a>00297   
<a name="l00298"></a>00298   <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">Threads::parallel_reduce</a> (<a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae05a5517582637b8469bbae1939d9aaf">pid_elements_begin</a>(pid),
<a name="l00299"></a>00299                                             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a36245c34046bf4b2b4b26bfdb603abd9">pid_elements_end</a>(pid)),
<a name="l00300"></a>00300                             sew);
<a name="l00301"></a>00301   <span class="keywordflow">return</span> sew.weight();
<a name="l00302"></a>00302 }
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a1faee34ae17dbda4133b31ffbae712ca">00306</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1faee34ae17dbda4133b31ffbae712ca">MeshTools::build_nodes_to_elem_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00307"></a>00307                                          std::vector&lt;std::vector&lt;unsigned int&gt; &gt;&amp; nodes_to_elem_map)
<a name="l00308"></a>00308 {
<a name="l00309"></a>00309   nodes_to_elem_map.resize (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00312"></a>00312   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00313"></a>00313 
<a name="l00314"></a>00314   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00315"></a>00315     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*el)-&gt;n_nodes(); n++)
<a name="l00316"></a>00316       {
<a name="l00317"></a>00317         libmesh_assert ((*el)-&gt;node(n) &lt; nodes_to_elem_map.size());
<a name="l00318"></a>00318         libmesh_assert ((*el)-&gt;id()    &lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>());
<a name="l00319"></a>00319         
<a name="l00320"></a>00320         nodes_to_elem_map[(*el)-&gt;node(n)].push_back((*el)-&gt;id());
<a name="l00321"></a>00321       }
<a name="l00322"></a>00322 }
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 
<a name="l00326"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#abad32fd5e40ef1d5de0f5fa222a0eb8f">00326</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1faee34ae17dbda4133b31ffbae712ca">MeshTools::build_nodes_to_elem_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00327"></a>00327                                          std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; nodes_to_elem_map)
<a name="l00328"></a>00328 {
<a name="l00329"></a>00329   nodes_to_elem_map.resize (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00332"></a>00332   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00335"></a>00335     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;(*el)-&gt;n_nodes(); n++)
<a name="l00336"></a>00336       {
<a name="l00337"></a>00337         libmesh_assert ((*el)-&gt;node(n) &lt; nodes_to_elem_map.size());
<a name="l00338"></a>00338         
<a name="l00339"></a>00339         nodes_to_elem_map[(*el)-&gt;node(n)].push_back(*el);
<a name="l00340"></a>00340       }
<a name="l00341"></a>00341 }
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a0fd39d630f54c93571ee6449e8b15550">00345</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a0fd39d630f54c93571ee6449e8b15550">MeshTools::find_boundary_nodes</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00346"></a>00346                                      std::vector&lt;bool&gt;&amp; on_boundary)
<a name="l00347"></a>00347 {
<a name="l00348"></a>00348   <span class="comment">// Resize the vector which holds boundary nodes and fill with false.</span>
<a name="l00349"></a>00349   on_boundary.resize(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>());
<a name="l00350"></a>00350   std::fill(on_boundary.begin(),
<a name="l00351"></a>00351             on_boundary.end(),
<a name="l00352"></a>00352             <span class="keyword">false</span>);
<a name="l00353"></a>00353 
<a name="l00354"></a>00354   <span class="comment">// Loop over elements, find those on boundary, and</span>
<a name="l00355"></a>00355   <span class="comment">// mark them as true in on_boundary.</span>
<a name="l00356"></a>00356   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00357"></a>00357   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00360"></a>00360     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;(*el)-&gt;n_neighbors(); s++)
<a name="l00361"></a>00361       <span class="keywordflow">if</span> ((*el)-&gt;neighbor(s) == NULL) <span class="comment">// on the boundary</span>
<a name="l00362"></a>00362         {
<a name="l00363"></a>00363           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>((*el)-&gt;build_side(s));
<a name="l00364"></a>00364           
<a name="l00365"></a>00365           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;n_nodes(); n++)
<a name="l00366"></a>00366             on_boundary[<a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>-&gt;node(n)] = <span class="keyword">true</span>;
<a name="l00367"></a>00367         }
<a name="l00368"></a>00368 }
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 
<a name="l00372"></a>00372 <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a>
<a name="l00373"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">00373</a> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">MeshTools::bounding_box</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00374"></a>00374 {
<a name="l00375"></a>00375   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00376"></a>00376   parallel_only();
<a name="l00377"></a>00377 
<a name="l00378"></a>00378   FindBBox find_bbox;
<a name="l00379"></a>00379   
<a name="l00380"></a>00380   <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">Threads::parallel_reduce</a> (<a class="code" href="classlibMesh_1_1StoredRange.php">ConstNodeRange</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a7a87dbe56aaa89961e03d60a25a36e8b">local_nodes_begin</a>(),
<a name="l00381"></a>00381                                             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ad0daaecd9c183194a99609db6507198c">local_nodes_end</a>()),
<a name="l00382"></a>00382                             find_bbox);
<a name="l00383"></a>00383 
<a name="l00384"></a>00384   <span class="comment">// and the unpartitioned nodes</span>
<a name="l00385"></a>00385   <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">Threads::parallel_reduce</a> (<a class="code" href="classlibMesh_1_1StoredRange.php">ConstNodeRange</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a7d6366e57e92fdfecd3150d192956d03">pid_nodes_begin</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>),
<a name="l00386"></a>00386                                             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a329026356ca6689c35b765bb0b58eb01">pid_nodes_end</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)),
<a name="l00387"></a>00387                             find_bbox);
<a name="l00388"></a>00388 
<a name="l00389"></a>00389   <span class="comment">// Compare the bounding boxes across processors</span>
<a name="l00390"></a>00390   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(find_bbox.min());
<a name="l00391"></a>00391   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(find_bbox.max());
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   <span class="keywordflow">return</span> find_bbox.bbox();
<a name="l00394"></a>00394 }
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 
<a name="l00398"></a>00398 <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a>
<a name="l00399"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a15cfa4aa6733bffa5fff0c64c7608a71">00399</a> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a15cfa4aa6733bffa5fff0c64c7608a71">MeshTools::bounding_sphere</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00400"></a>00400 {
<a name="l00401"></a>00401   <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">BoundingBox</a> bbox = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a>(mesh);
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  diag = (bbox.second - bbox.first).size();
<a name="l00404"></a>00404   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> cent = (bbox.second + bbox.first)/2;
<a name="l00405"></a>00405 
<a name="l00406"></a>00406   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a> (cent, .5*diag);
<a name="l00407"></a>00407 }
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a>
<a name="l00412"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a4bb037002f33c07017927691f7bf90d7">00412</a> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4bb037002f33c07017927691f7bf90d7">MeshTools::processor_bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00413"></a>00413                                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)
<a name="l00414"></a>00414 {
<a name="l00415"></a>00415   libmesh_assert (pid &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00416"></a>00416 
<a name="l00417"></a>00417   FindBBox find_bbox;
<a name="l00418"></a>00418   
<a name="l00419"></a>00419   <a class="code" href="namespacelibMesh_1_1Threads.php#ab89ecaf19ab9f9d88629316cb341a4de">Threads::parallel_reduce</a> (<a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae05a5517582637b8469bbae1939d9aaf">pid_elements_begin</a>(pid),
<a name="l00420"></a>00420                                             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a36245c34046bf4b2b4b26bfdb603abd9">pid_elements_end</a>(pid)),
<a name="l00421"></a>00421                             find_bbox);
<a name="l00422"></a>00422   
<a name="l00423"></a>00423   <span class="keywordflow">return</span> find_bbox.bbox();
<a name="l00424"></a>00424 }
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a>
<a name="l00429"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#af9f209a04863401d00d8e422759dd1f2">00429</a> <a class="code" href="namespacelibMesh_1_1MeshTools.php#af9f209a04863401d00d8e422759dd1f2">MeshTools::processor_bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00430"></a>00430                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)
<a name="l00431"></a>00431 {
<a name="l00432"></a>00432   <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">BoundingBox</a> bbox = <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4bb037002f33c07017927691f7bf90d7">processor_bounding_box</a>(mesh,pid);
<a name="l00433"></a>00433 
<a name="l00434"></a>00434   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  diag = (bbox.second - bbox.first).size();
<a name="l00435"></a>00435   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> cent = (bbox.second + bbox.first)/2;
<a name="l00436"></a>00436 
<a name="l00437"></a>00437   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a> (cent, .5*diag);
<a name="l00438"></a>00438 }
<a name="l00439"></a>00439 
<a name="l00440"></a>00440 
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a>
<a name="l00443"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a84219b567ed5847433bf707a40b37883">00443</a> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a84219b567ed5847433bf707a40b37883">MeshTools::subdomain_bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00444"></a>00444                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> sid)
<a name="l00445"></a>00445 {
<a name="l00446"></a>00446   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>() != 0);
<a name="l00447"></a>00447 
<a name="l00448"></a>00448   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>( 1.e30,  1.e30,  1.e30);
<a name="l00449"></a>00449   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(-1.e30, -1.e30, -1.e30);
<a name="l00450"></a>00450 
<a name="l00451"></a>00451   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>(); e++)
<a name="l00452"></a>00452     <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() == sid)
<a name="l00453"></a>00453       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); n++)
<a name="l00454"></a>00454         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47dc43b4a8f54a6b2c9ab8712a9d9acd">spatial_dimension</a>(); i++)
<a name="l00455"></a>00455           {
<a name="l00456"></a>00456             <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(i) = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>(i), mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n))(i));
<a name="l00457"></a>00457             <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(i) = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>(i), mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0555c2f73ac109b05be3e27311f9cb67">point</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(e)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n))(i));
<a name="l00458"></a>00458           }      
<a name="l00459"></a>00459   
<a name="l00460"></a>00460   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">BoundingBox</a> (min, max);
<a name="l00461"></a>00461 }
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a>
<a name="l00466"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a8b4ec2068592eca4d6377e5b91de01fd">00466</a> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a8b4ec2068592eca4d6377e5b91de01fd">MeshTools::subdomain_bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00467"></a>00467                                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> sid)
<a name="l00468"></a>00468 {
<a name="l00469"></a>00469   <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">BoundingBox</a> bbox = <a class="code" href="namespacelibMesh_1_1MeshTools.php#a84219b567ed5847433bf707a40b37883">subdomain_bounding_box</a>(mesh,sid);
<a name="l00470"></a>00470 
<a name="l00471"></a>00471   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>  diag = (bbox.second - bbox.first).size();
<a name="l00472"></a>00472   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> cent = (bbox.second + bbox.first)/2;
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a> (cent, .5*diag);
<a name="l00475"></a>00475 }
<a name="l00476"></a>00476 
<a name="l00477"></a>00477 
<a name="l00478"></a>00478 
<a name="l00479"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a105332f64aa69991539faccda22f6710">00479</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a105332f64aa69991539faccda22f6710">MeshTools::elem_types</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00480"></a>00480                             std::vector&lt;ElemType&gt;&amp; et)
<a name="l00481"></a>00481 {
<a name="l00482"></a>00482   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00483"></a>00483   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l00484"></a>00484 
<a name="l00485"></a>00485   <span class="comment">// Automatically get the first type</span>
<a name="l00486"></a>00486   et.push_back((*el)-&gt;type());  ++el;
<a name="l00487"></a>00487 
<a name="l00488"></a>00488   <span class="comment">// Loop over the rest of the elements.</span>
<a name="l00489"></a>00489   <span class="comment">// If the current element type isn&#39;t in the</span>
<a name="l00490"></a>00490   <span class="comment">// vector, insert it.</span>
<a name="l00491"></a>00491   <span class="keywordflow">for</span> (; el != end; ++el)
<a name="l00492"></a>00492     <span class="keywordflow">if</span> (!std::count(et.begin(), et.end(), (*el)-&gt;type()))
<a name="l00493"></a>00493       et.push_back((*el)-&gt;type());
<a name="l00494"></a>00494 }
<a name="l00495"></a>00495 
<a name="l00496"></a>00496 
<a name="l00497"></a>00497 
<a name="l00498"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a111d5a366fdd494f84b67573794f3875">00498</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a111d5a366fdd494f84b67573794f3875">MeshTools::n_elem_of_type</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00499"></a>00499                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00500"></a>00500 {
<a name="l00501"></a>00501   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af23e30f351c55603492a52f6151b213d">type_elements_begin</a>(type),
<a name="l00502"></a>00502                                                  mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a106c235cfaf1d2d26e5355d5663d9a91">type_elements_end</a>  (type)));
<a name="l00503"></a>00503 }
<a name="l00504"></a>00504 
<a name="l00505"></a>00505 
<a name="l00506"></a>00506 
<a name="l00507"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">00507</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">MeshTools::n_active_elem_of_type</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00508"></a>00508                                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type)
<a name="l00509"></a>00509 {
<a name="l00510"></a>00510   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a77c6acb7a27f7407b58826a849e5d441">active_type_elements_begin</a>(type),
<a name="l00511"></a>00511                                                  mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a73cfd57bf4512ac0b90734e81bcbcd0d">active_type_elements_end</a>  (type)));
<a name="l00512"></a>00512 }
<a name="l00513"></a>00513 
<a name="l00514"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#af20b5f9a49193f82120721747b4a371a">00514</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#af20b5f9a49193f82120721747b4a371a">MeshTools::n_non_subactive_elem_of_type_at_level</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00515"></a>00515                                                 <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00516"></a>00516                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level)
<a name="l00517"></a>00517 {
<a name="l00518"></a>00518   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt = 0;
<a name="l00519"></a>00519   <span class="comment">// iterate over the elements of the specified type</span>
<a name="l00520"></a>00520   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af23e30f351c55603492a52f6151b213d">type_elements_begin</a>(type);
<a name="l00521"></a>00521   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a106c235cfaf1d2d26e5355d5663d9a91">type_elements_end</a>(type);
<a name="l00522"></a>00522 
<a name="l00523"></a>00523   <span class="keywordflow">for</span>(; el!=end; ++el)
<a name="l00524"></a>00524     <span class="keywordflow">if</span>( ((*el)-&gt;level() == level) &amp;&amp; !(*el)-&gt;subactive())
<a name="l00525"></a>00525       cnt++;
<a name="l00526"></a>00526 
<a name="l00527"></a>00527   <span class="keywordflow">return</span> cnt;
<a name="l00528"></a>00528 }
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a4ad92062f806ef59be2bbd73e9705775">00531</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4ad92062f806ef59be2bbd73e9705775">MeshTools::n_active_local_levels</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00532"></a>00532 {
<a name="l00533"></a>00533   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a57a0ae7fb3cba63f06621d6c701327c8">max_level</a> = 0;
<a name="l00534"></a>00534 
<a name="l00535"></a>00535   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00536"></a>00536   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00537"></a>00537 
<a name="l00538"></a>00538   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00539"></a>00539     max_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;level(), <a class="code" href="namespacelibMesh_1_1MeshTools.php#a57a0ae7fb3cba63f06621d6c701327c8">max_level</a>);
<a name="l00540"></a>00540 
<a name="l00541"></a>00541   <span class="keywordflow">return</span> max_level + 1;
<a name="l00542"></a>00542 }
<a name="l00543"></a>00543 
<a name="l00544"></a>00544 
<a name="l00545"></a>00545 
<a name="l00546"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a83a95efd16596e9d337f66983328ee8e">00546</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a83a95efd16596e9d337f66983328ee8e">MeshTools::n_active_levels</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00547"></a>00547 {
<a name="l00548"></a>00548   parallel_only();
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl = <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4ad92062f806ef59be2bbd73e9705775">MeshTools::n_active_local_levels</a>(mesh);
<a name="l00551"></a>00551 
<a name="l00552"></a>00552   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00553"></a>00553     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0e898a7c74ad9552269753ee54e52b45">unpartitioned_elements_begin</a>();
<a name="l00554"></a>00554   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00555"></a>00555     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ace9f5d288950516202e18c42a0552b0f">unpartitioned_elements_end</a>();
<a name="l00556"></a>00556 
<a name="l00557"></a>00557   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00558"></a>00558     <span class="keywordflow">if</span> ((*el)-&gt;active())
<a name="l00559"></a>00559       nl = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;level() + 1, nl);
<a name="l00560"></a>00560 
<a name="l00561"></a>00561   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(nl);
<a name="l00562"></a>00562   <span class="keywordflow">return</span> nl;
<a name="l00563"></a>00563 }
<a name="l00564"></a>00564 
<a name="l00565"></a>00565 
<a name="l00566"></a>00566 
<a name="l00567"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a86b5b94d1a51d606668a85e6f31af4b6">00567</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a86b5b94d1a51d606668a85e6f31af4b6">MeshTools::n_local_levels</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00568"></a>00568 {
<a name="l00569"></a>00569   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a57a0ae7fb3cba63f06621d6c701327c8">max_level</a> = 0;
<a name="l00570"></a>00570 
<a name="l00571"></a>00571   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5b67c2aa94e76310a6db3470cce8ef11">local_elements_begin</a>();
<a name="l00572"></a>00572   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab8bd839216a1ef9c0912d523b68ae136">local_elements_end</a>();
<a name="l00573"></a>00573 
<a name="l00574"></a>00574   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00575"></a>00575     max_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;level(), <a class="code" href="namespacelibMesh_1_1MeshTools.php#a57a0ae7fb3cba63f06621d6c701327c8">max_level</a>);
<a name="l00576"></a>00576 
<a name="l00577"></a>00577   <span class="keywordflow">return</span> max_level + 1;
<a name="l00578"></a>00578 }
<a name="l00579"></a>00579    
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 
<a name="l00582"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">00582</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">MeshTools::n_levels</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00583"></a>00583 {
<a name="l00584"></a>00584   parallel_only();
<a name="l00585"></a>00585 
<a name="l00586"></a>00586   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl = <a class="code" href="namespacelibMesh_1_1MeshTools.php#a86b5b94d1a51d606668a85e6f31af4b6">MeshTools::n_local_levels</a>(mesh);
<a name="l00587"></a>00587 
<a name="l00588"></a>00588   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el =
<a name="l00589"></a>00589     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0e898a7c74ad9552269753ee54e52b45">unpartitioned_elements_begin</a>();
<a name="l00590"></a>00590   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el =
<a name="l00591"></a>00591     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ace9f5d288950516202e18c42a0552b0f">unpartitioned_elements_end</a>();
<a name="l00592"></a>00592 
<a name="l00593"></a>00593   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00594"></a>00594     nl = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;level() + 1, nl);
<a name="l00595"></a>00595 
<a name="l00596"></a>00596   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(nl);
<a name="l00597"></a>00597   <span class="keywordflow">return</span> nl;
<a name="l00598"></a>00598 }
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 
<a name="l00602"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a3a83769db0dd1cc0ced4f981506a5492">00602</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a3a83769db0dd1cc0ced4f981506a5492">MeshTools::get_not_subactive_node_ids</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00603"></a>00603     std::set&lt;unsigned int&gt;&amp; not_subactive_node_ids)
<a name="l00604"></a>00604 {
<a name="l00605"></a>00605   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el           = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00606"></a>00606   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00607"></a>00607   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00608"></a>00608   {
<a name="l00609"></a>00609     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = (*el);
<a name="l00610"></a>00610     <span class="keywordflow">if</span>(!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad1486ba6e3005fe331e4911907fadfbb">subactive</a>())
<a name="l00611"></a>00611       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00612"></a>00612         not_subactive_node_ids.insert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n));
<a name="l00613"></a>00613   }
<a name="l00614"></a>00614 }
<a name="l00615"></a>00615 
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 
<a name="l00618"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">00618</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">MeshTools::n_elem</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> &amp;begin,
<a name="l00619"></a>00619                                 <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> &amp;end)
<a name="l00620"></a>00620 {
<a name="l00621"></a>00621   <span class="keywordflow">return</span> std::distance(begin, end);
<a name="l00622"></a>00622 }
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a85a60584ebd3d256c8114b06ff9560c2">00626</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a85a60584ebd3d256c8114b06ff9560c2">MeshTools::n_nodes</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> &amp;begin,
<a name="l00627"></a>00627                                  <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> &amp;end)
<a name="l00628"></a>00628 {
<a name="l00629"></a>00629   <span class="keywordflow">return</span> std::distance(begin, end);
<a name="l00630"></a>00630 }
<a name="l00631"></a>00631    
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a389d0bd8b56b85fce05a743e8f3bd454">00634</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a389d0bd8b56b85fce05a743e8f3bd454">MeshTools::n_p_levels</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00635"></a>00635 {
<a name="l00636"></a>00636   parallel_only();
<a name="l00637"></a>00637   
<a name="l00638"></a>00638   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_p_level = 0;
<a name="l00639"></a>00639 
<a name="l00640"></a>00640   <span class="comment">// first my local elements</span>
<a name="l00641"></a>00641   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>
<a name="l00642"></a>00642     el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5b67c2aa94e76310a6db3470cce8ef11">local_elements_begin</a>(),
<a name="l00643"></a>00643     end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab8bd839216a1ef9c0912d523b68ae136">local_elements_end</a>();
<a name="l00644"></a>00644 
<a name="l00645"></a>00645   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00646"></a>00646     max_p_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;p_level(), max_p_level);
<a name="l00647"></a>00647 
<a name="l00648"></a>00648   <span class="comment">// then any unpartitioned objects</span>
<a name="l00649"></a>00649   el     = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0e898a7c74ad9552269753ee54e52b45">unpartitioned_elements_begin</a>();
<a name="l00650"></a>00650   end_el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ace9f5d288950516202e18c42a0552b0f">unpartitioned_elements_end</a>();
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="keywordflow">for</span>( ; el != end_el; ++el)
<a name="l00653"></a>00653     max_p_level = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>((*el)-&gt;p_level(), max_p_level);
<a name="l00654"></a>00654 
<a name="l00655"></a>00655   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_p_level);
<a name="l00656"></a>00656   <span class="keywordflow">return</span> max_p_level + 1;
<a name="l00657"></a>00657 }
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 
<a name="l00661"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a56f90a762fb8feb128abb693690c223f">00661</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a56f90a762fb8feb128abb693690c223f">MeshTools::find_nodal_neighbors</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; n, 
<a name="l00662"></a>00662                                      std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; nodes_to_elem_map, 
<a name="l00663"></a>00663                                      std::vector&lt;const Node*&gt;&amp; neighbors)
<a name="l00664"></a>00664 {
<a name="l00665"></a>00665   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_id = n.<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00666"></a>00666   
<a name="l00667"></a>00667   <span class="comment">//Iterators to iterate through the elements that include this node</span>
<a name="l00668"></a>00668   std::vector&lt;const Elem*&gt;::const_iterator el     = nodes_to_elem_map[global_id].begin();
<a name="l00669"></a>00669   std::vector&lt;const Elem*&gt;::const_iterator end_el = nodes_to_elem_map[global_id].end();
<a name="l00670"></a>00670   
<a name="l00671"></a>00671   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_ed=0; <span class="comment">// Number of edges on the element</span>
<a name="l00672"></a>00672   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ed=0;   <span class="comment">// Current edge</span>
<a name="l00673"></a>00673   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l_n=0;  <span class="comment">// Local node number</span>
<a name="l00674"></a>00674   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> o_n=0;  <span class="comment">// Other node on this edge</span>
<a name="l00675"></a>00675   
<a name="l00676"></a>00676   <span class="comment">//Assume we find a edge... then prove ourselves wrong...</span>
<a name="l00677"></a>00677   <span class="keywordtype">bool</span> found_edge=<span class="keyword">true</span>;
<a name="l00678"></a>00678   
<a name="l00679"></a>00679   <a class="code" href="classlibMesh_1_1Node.php">Node</a> * node_to_save = NULL;
<a name="l00680"></a>00680   
<a name="l00681"></a>00681   <span class="comment">//Look through the elements that contain this node</span>
<a name="l00682"></a>00682   <span class="comment">//find the local node id... then find the side that</span>
<a name="l00683"></a>00683   <span class="comment">//node lives on in the element</span>
<a name="l00684"></a>00684   <span class="comment">//next, look for the _other_ node on that side</span>
<a name="l00685"></a>00685   <span class="comment">//That other node is a &quot;nodal_neighbor&quot;... save it</span>
<a name="l00686"></a>00686   <span class="keywordflow">for</span>(;el != end_el;el++)
<a name="l00687"></a>00687   {
<a name="l00688"></a>00688     <span class="comment">//We only care about active elements...</span>
<a name="l00689"></a>00689     <span class="keywordflow">if</span>((*el)-&gt;active())
<a name="l00690"></a>00690     {
<a name="l00691"></a>00691       n_ed=(*el)-&gt;n_edges();
<a name="l00692"></a>00692       
<a name="l00693"></a>00693       <span class="comment">//Find the local node id</span>
<a name="l00694"></a>00694       <span class="keywordflow">while</span>(global_id != (*el)-&gt;node(l_n++)) { }
<a name="l00695"></a>00695       l_n--; <span class="comment">//Hmmm... take the last one back off</span>
<a name="l00696"></a>00696       
<a name="l00697"></a>00697       <span class="keywordflow">while</span>(ed&lt;n_ed)
<a name="l00698"></a>00698       {
<a name="l00699"></a>00699         
<a name="l00700"></a>00700         <span class="comment">//Find the edge the node is on</span>
<a name="l00701"></a>00701         <span class="keywordflow">while</span>(found_edge &amp;&amp; !(*el)-&gt;is_node_on_edge(l_n,ed++))
<a name="l00702"></a>00702         {
<a name="l00703"></a>00703           <span class="comment">//This only happens if all the edges have already been found</span>
<a name="l00704"></a>00704           <span class="keywordflow">if</span>(ed&gt;=n_ed)
<a name="l00705"></a>00705             found_edge=<span class="keyword">false</span>;
<a name="l00706"></a>00706         }
<a name="l00707"></a>00707         
<a name="l00708"></a>00708         <span class="comment">//Did we find one?</span>
<a name="l00709"></a>00709         <span class="keywordflow">if</span>(found_edge)
<a name="l00710"></a>00710         {
<a name="l00711"></a>00711           ed--; <span class="comment">//Take the last one back off again</span>
<a name="l00712"></a>00712           
<a name="l00713"></a>00713           <span class="comment">//Now find the other node on that edge</span>
<a name="l00714"></a>00714           <span class="keywordflow">while</span>(!(*el)-&gt;is_node_on_edge(o_n++,ed) || global_id==(*el)-&gt;node(o_n-1)) { }
<a name="l00715"></a>00715           o_n--;
<a name="l00716"></a>00716           
<a name="l00717"></a>00717           <span class="comment">//We&#39;ve found one!  Save it..</span>
<a name="l00718"></a>00718           node_to_save=(*el)-&gt;get_node(o_n);
<a name="l00719"></a>00719           
<a name="l00720"></a>00720           <span class="comment">//Search to see if we&#39;ve already found this one</span>
<a name="l00721"></a>00721           std::vector&lt;const Node*&gt;::const_iterator result = std::find(neighbors.begin(),neighbors.end(),node_to_save);
<a name="l00722"></a>00722           
<a name="l00723"></a>00723           <span class="comment">//If we didn&#39;t find it and add it to the vector</span>
<a name="l00724"></a>00724           <span class="keywordflow">if</span>(result == neighbors.end())
<a name="l00725"></a>00725             neighbors.push_back(node_to_save);
<a name="l00726"></a>00726         }
<a name="l00727"></a>00727         
<a name="l00728"></a>00728         <span class="comment">//Reset to look for another</span>
<a name="l00729"></a>00729         o_n=0;
<a name="l00730"></a>00730         
<a name="l00731"></a>00731         <span class="comment">//Keep looking for edges, node may be on more than one edge</span>
<a name="l00732"></a>00732         ed++;
<a name="l00733"></a>00733       }
<a name="l00734"></a>00734       
<a name="l00735"></a>00735       <span class="comment">//Reset to get ready for the next element</span>
<a name="l00736"></a>00736       l_n=ed=0;
<a name="l00737"></a>00737       found_edge=<span class="keyword">true</span>;
<a name="l00738"></a>00738     }
<a name="l00739"></a>00739   }
<a name="l00740"></a>00740 }
<a name="l00741"></a>00741 
<a name="l00742"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a693646efaadc6206730b7bd1bf4d5978">00742</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a693646efaadc6206730b7bd1bf4d5978">MeshTools::find_hanging_nodes_and_parents</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, std::map&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, std::vector&lt;unsigned int&gt; &gt;&amp; hanging_nodes)
<a name="l00743"></a>00743 {
<a name="l00744"></a>00744   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00745"></a>00745   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00746"></a>00746   
<a name="l00747"></a>00747   <span class="comment">//Loop through all the elements</span>
<a name="l00748"></a>00748   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00749"></a>00749   {
<a name="l00750"></a>00750     <span class="comment">//Save it off for easier access</span>
<a name="l00751"></a>00751     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = (*it);
<a name="l00752"></a>00752     
<a name="l00753"></a>00753     <span class="comment">//Right now this only works for quad4&#39;s</span>
<a name="l00754"></a>00754     <span class="comment">//libmesh_assert(elem-&gt;type() == libMeshEnums::QUAD4);</span>
<a name="l00755"></a>00755     <span class="keywordflow">if</span>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>() == <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">libMeshEnums::QUAD4</a>)
<a name="l00756"></a>00756     {
<a name="l00757"></a>00757       <span class="comment">//Loop over the sides looking for sides that have hanging nodes</span>
<a name="l00758"></a>00758       <span class="comment">//This code is inspired by compute_proj_constraints()</span>
<a name="l00759"></a>00759       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00760"></a>00760       {
<a name="l00761"></a>00761         <span class="comment">//If not a boundary node</span>
<a name="l00762"></a>00762         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) != NULL)
<a name="l00763"></a>00763         {
<a name="l00764"></a>00764           <span class="comment">// Get pointers to the element&#39;s neighbor.</span>
<a name="l00765"></a>00765           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neigh = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l00766"></a>00766           
<a name="l00767"></a>00767           <span class="comment">//Is there a coarser element next to this one?</span>
<a name="l00768"></a>00768           <span class="keywordflow">if</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>()) 
<a name="l00769"></a>00769           {
<a name="l00770"></a>00770             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *ancestor = elem;
<a name="l00771"></a>00771             <span class="keywordflow">while</span> (neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>() &lt; ancestor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a1fa3e8bb1baa330a5037487dbe9304ab">level</a>())
<a name="l00772"></a>00772               ancestor = ancestor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00773"></a>00773             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s_neigh = neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a>(ancestor);
<a name="l00774"></a>00774             libmesh_assert (s_neigh &lt; neigh-&gt;n_neighbors());
<a name="l00775"></a>00775             
<a name="l00776"></a>00776             <span class="comment">//Couple of helper uints...</span>
<a name="l00777"></a>00777             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node1=0;
<a name="l00778"></a>00778             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node2=0;
<a name="l00779"></a>00779             <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> hanging_node=0;
<a name="l00780"></a>00780                 
<a name="l00781"></a>00781             <span class="keywordtype">bool</span> found_in_neighbor = <span class="keyword">false</span>;
<a name="l00782"></a>00782                 
<a name="l00783"></a>00783             <span class="comment">//Find the two vertices that make up this side</span>
<a name="l00784"></a>00784             <span class="keywordflow">while</span>(!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a095386c4644b0478229289f281f2f8e4">is_node_on_side</a>(node1++,s)) { }
<a name="l00785"></a>00785             node1--;
<a name="l00786"></a>00786                 
<a name="l00787"></a>00787                 <span class="comment">//Start looking for the second one with the next node</span>
<a name="l00788"></a>00788             node2=node1+1;
<a name="l00789"></a>00789             
<a name="l00790"></a>00790             <span class="comment">//Find the other one</span>
<a name="l00791"></a>00791             <span class="keywordflow">while</span>(!elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a095386c4644b0478229289f281f2f8e4">is_node_on_side</a>(node2++,s)) { }
<a name="l00792"></a>00792             node2--;
<a name="l00793"></a>00793   
<a name="l00794"></a>00794                 <span class="comment">//Pull out their global ids:</span>
<a name="l00795"></a>00795             node1 = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(node1);
<a name="l00796"></a>00796             node2 = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(node2);
<a name="l00797"></a>00797             
<a name="l00798"></a>00798             <span class="comment">//Now find which node is present in the neighbor</span>
<a name="l00799"></a>00799             <span class="comment">//FIXME This assumes a level one rule!</span>
<a name="l00800"></a>00800             <span class="comment">//The _other_ one is the hanging node</span>
<a name="l00801"></a>00801             
<a name="l00802"></a>00802             <span class="comment">//First look for the first one</span>
<a name="l00803"></a>00803             <span class="comment">//FIXME could be streamlined a bit</span>
<a name="l00804"></a>00804             <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0;n&lt;neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>();n++)
<a name="l00805"></a>00805             {
<a name="l00806"></a>00806               <span class="keywordflow">if</span>(neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n) == node1)
<a name="l00807"></a>00807                 found_in_neighbor=<span class="keyword">true</span>;
<a name="l00808"></a>00808             }
<a name="l00809"></a>00809                 
<a name="l00810"></a>00810                 
<a name="l00811"></a>00811             <span class="keywordflow">if</span>(!found_in_neighbor)
<a name="l00812"></a>00812               hanging_node=node1;
<a name="l00813"></a>00813             <span class="keywordflow">else</span> <span class="comment">//If it wasn&#39;t node1 then it must be node2!</span>
<a name="l00814"></a>00814               hanging_node=node2;
<a name="l00815"></a>00815             
<a name="l00816"></a>00816             <span class="comment">//Reset these for reuse</span>
<a name="l00817"></a>00817             node1=0;
<a name="l00818"></a>00818             node2=0;
<a name="l00819"></a>00819             
<a name="l00820"></a>00820             <span class="comment">//Find the first node that makes up the side in the neighbor (these should be the parent nodes)</span>
<a name="l00821"></a>00821             <span class="keywordflow">while</span>(!neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a095386c4644b0478229289f281f2f8e4">is_node_on_side</a>(node1++,s_neigh)) { }
<a name="l00822"></a>00822             node1--;
<a name="l00823"></a>00823                 
<a name="l00824"></a>00824             node2=node1+1;
<a name="l00825"></a>00825             
<a name="l00826"></a>00826             <span class="comment">//Find the second node...</span>
<a name="l00827"></a>00827             <span class="keywordflow">while</span>(!neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a095386c4644b0478229289f281f2f8e4">is_node_on_side</a>(node2++,s_neigh)) { }
<a name="l00828"></a>00828             node2--;
<a name="l00829"></a>00829             
<a name="l00830"></a>00830             <span class="comment">//Save them if we haven&#39;t already found the parents for this one</span>
<a name="l00831"></a>00831             <span class="keywordflow">if</span>(hanging_nodes[hanging_node].size()&lt;2)
<a name="l00832"></a>00832             {
<a name="l00833"></a>00833               hanging_nodes[hanging_node].push_back(neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(node1));
<a name="l00834"></a>00834               hanging_nodes[hanging_node].push_back(neigh-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(node2));
<a name="l00835"></a>00835             }
<a name="l00836"></a>00836           }
<a name="l00837"></a>00837         }
<a name="l00838"></a>00838       }
<a name="l00839"></a>00839     }
<a name="l00840"></a>00840   }
<a name="l00841"></a>00841 }
<a name="l00842"></a>00842 
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae41cec551d5e6a5502564b01056512d3">MeshTools::correct_node_proc_ids</a>
<a name="l00846"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#ae41cec551d5e6a5502564b01056512d3">00846</a>   (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00847"></a>00847    <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a> &amp;loc_map)
<a name="l00848"></a>00848 {
<a name="l00849"></a>00849   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00850"></a>00850   parallel_only();
<a name="l00851"></a>00851 
<a name="l00852"></a>00852   <span class="comment">// We&#39;ll need the new_nodes_map to answer other processors&#39;</span>
<a name="l00853"></a>00853   <span class="comment">// requests.  It should never be empty unless we don&#39;t have any</span>
<a name="l00854"></a>00854   <span class="comment">// nodes.</span>
<a name="l00855"></a>00855   libmesh_assert(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>() == mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>() ||
<a name="l00856"></a>00856                  !loc_map.<a class="code" href="classlibMesh_1_1LocationMap.php#ae5e9f2ba3dd8d494e6308459e2bba569">empty</a>());
<a name="l00857"></a>00857 
<a name="l00858"></a>00858   <span class="comment">// Fix all nodes&#39; processor ids.  Coarsening may have left us with</span>
<a name="l00859"></a>00859   <span class="comment">// nodes which are no longer touched by any elements of the same</span>
<a name="l00860"></a>00860   <span class="comment">// processor id, and for DofMap to work we need to fix that.</span>
<a name="l00861"></a>00861 
<a name="l00862"></a>00862   <span class="comment">// In the first pass, invalidate processor ids for nodes on active</span>
<a name="l00863"></a>00863   <span class="comment">// elements.  We avoid touching subactive-only nodes.</span>
<a name="l00864"></a>00864   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       e_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00865"></a>00865   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> e_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00866"></a>00866   <span class="keywordflow">for</span> (; e_it != e_end; ++e_it)
<a name="l00867"></a>00867     {
<a name="l00868"></a>00868       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *e_it;
<a name="l00869"></a>00869       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00870"></a>00870         {
<a name="l00871"></a>00871           <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l00872"></a>00872           node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a080a5295fc4a41c1ab776a1a38c4be8d">invalidate_processor_id</a>();
<a name="l00873"></a>00873         }
<a name="l00874"></a>00874     }
<a name="l00875"></a>00875 
<a name="l00876"></a>00876   <span class="comment">// In the second pass, find the lowest processor ids on active</span>
<a name="l00877"></a>00877   <span class="comment">// elements touching each node, and set the node processor id.</span>
<a name="l00878"></a>00878   <span class="keywordflow">for</span> (e_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(); e_it != e_end; ++e_it)
<a name="l00879"></a>00879     {
<a name="l00880"></a>00880       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *e_it;
<a name="l00881"></a>00881       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00882"></a>00882       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00883"></a>00883         {
<a name="l00884"></a>00884           <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n);
<a name="l00885"></a>00885           <span class="keywordflow">if</span> (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a> ||
<a name="l00886"></a>00886               node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() &gt; proc_id)
<a name="l00887"></a>00887             node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = proc_id;
<a name="l00888"></a>00888         }
<a name="l00889"></a>00889     }
<a name="l00890"></a>00890 
<a name="l00891"></a>00891   <span class="comment">// Those two passes will correct every node that touches a local</span>
<a name="l00892"></a>00892   <span class="comment">// element, but we can&#39;t be sure about nodes touching remote</span>
<a name="l00893"></a>00893   <span class="comment">// elements.  Fix those now.</span>
<a name="l00894"></a>00894   <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#a6343f61646db756556414516a068aa4e">make_node_proc_ids_parallel_consistent</a>
<a name="l00895"></a>00895     (mesh, loc_map);
<a name="l00896"></a>00896 }
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 
<a name="l00899"></a>00899 
<a name="l00900"></a>00900 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00901"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a059c8ba488323734da1dce1c85cbf8e6">00901</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a059c8ba488323734da1dce1c85cbf8e6">MeshTools::libmesh_assert_valid_node_pointers</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00902"></a>00902 {
<a name="l00903"></a>00903   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00904"></a>00904     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00905"></a>00905   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00906"></a>00906        mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(); el != el_end; ++el)
<a name="l00907"></a>00907     {
<a name="l00908"></a>00908       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00909"></a>00909       libmesh_assert (elem);
<a name="l00910"></a>00910       <span class="keywordflow">while</span> (elem)
<a name="l00911"></a>00911         {
<a name="l00912"></a>00912           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a6a2e745d84e1846b7456137051fe94b3">libmesh_assert_valid_node_pointers</a>();
<a name="l00913"></a>00913           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); ++n)
<a name="l00914"></a>00914             <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) &amp;&amp;
<a name="l00915"></a>00915                 elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>)
<a name="l00916"></a>00916               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n)-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a6a2e745d84e1846b7456137051fe94b3">libmesh_assert_valid_node_pointers</a>();
<a name="l00917"></a>00917             
<a name="l00918"></a>00918           libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l00919"></a>00919           elem = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00920"></a>00920         }
<a name="l00921"></a>00921     }
<a name="l00922"></a>00922 }
<a name="l00923"></a>00923 
<a name="l00924"></a>00924 
<a name="l00925"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a553f4980413b774f6ea4c39b18f331af">00925</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a553f4980413b774f6ea4c39b18f331af">MeshTools::libmesh_assert_valid_remote_elems</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00926"></a>00926 {
<a name="l00927"></a>00927   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00928"></a>00928     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ab8bd839216a1ef9c0912d523b68ae136">local_elements_end</a>();
<a name="l00929"></a>00929   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00930"></a>00930        mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a5b67c2aa94e76310a6db3470cce8ef11">local_elements_begin</a>(); el != el_end; ++el)
<a name="l00931"></a>00931     {
<a name="l00932"></a>00932       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00933"></a>00933       libmesh_assert (elem);
<a name="l00934"></a>00934       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); ++n)
<a name="l00935"></a>00935         libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l00936"></a>00936 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00937"></a>00937 <span class="preprocessor"></span>      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00938"></a>00938       <span class="keywordflow">if</span> (parent)
<a name="l00939"></a>00939         {
<a name="l00940"></a>00940           libmesh_assert (parent != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l00941"></a>00941           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l00942"></a>00942             libmesh_assert (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c) != <a class="code" href="namespacelibMesh.php#a903992f631b52b5ba05ad96a51e7b383">remote_elem</a>);
<a name="l00943"></a>00943         }
<a name="l00944"></a>00944 <span class="preprocessor">#endif</span>
<a name="l00945"></a>00945 <span class="preprocessor"></span>    }
<a name="l00946"></a>00946 }
<a name="l00947"></a>00947 
<a name="l00948"></a>00948 
<a name="l00949"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a8caf167bf36aeb0045b7736345f26da2">00949</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a8caf167bf36aeb0045b7736345f26da2">MeshTools::libmesh_assert_no_links_to_elem</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00950"></a>00950                                                 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *bad_elem)
<a name="l00951"></a>00951 {
<a name="l00952"></a>00952   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00953"></a>00953     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l00954"></a>00954   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00955"></a>00955        mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(); el != el_end; ++el)
<a name="l00956"></a>00956     {
<a name="l00957"></a>00957       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00958"></a>00958       libmesh_assert (elem);
<a name="l00959"></a>00959       libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>() != bad_elem);
<a name="l00960"></a>00960       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); ++n)
<a name="l00961"></a>00961         libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(n) != bad_elem);
<a name="l00962"></a>00962 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00963"></a>00963 <span class="preprocessor"></span>      <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>())
<a name="l00964"></a>00964         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); ++c)
<a name="l00965"></a>00965           libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c) != bad_elem);
<a name="l00966"></a>00966 <span class="preprocessor">#endif</span>
<a name="l00967"></a>00967 <span class="preprocessor"></span>    }
<a name="l00968"></a>00968 }
<a name="l00969"></a>00969 
<a name="l00970"></a>00970 
<a name="l00971"></a>00971 
<a name="l00972"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a1968ff1c8ed3fdc7f1c23e6b8ec322f8">00972</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1968ff1c8ed3fdc7f1c23e6b8ec322f8">MeshTools::libmesh_assert_valid_elem_ids</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00973"></a>00973 {
<a name="l00974"></a>00974   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lastprocid = 0;
<a name="l00975"></a>00975   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> lastelemid = 0;
<a name="l00976"></a>00976 
<a name="l00977"></a>00977   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l00978"></a>00978     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00979"></a>00979   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l00980"></a>00980        mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>(); el != el_end; ++el)
<a name="l00981"></a>00981     {
<a name="l00982"></a>00982       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l00983"></a>00983       libmesh_assert (elem);
<a name="l00984"></a>00984       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elemprocid = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00985"></a>00985       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elemid = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00986"></a>00986 
<a name="l00987"></a>00987       libmesh_assert(elemid &gt;= lastelemid);
<a name="l00988"></a>00988       libmesh_assert(elemprocid &gt;= lastprocid);
<a name="l00989"></a>00989 
<a name="l00990"></a>00990       lastelemid = elemid;
<a name="l00991"></a>00991       lastprocid = elemprocid;
<a name="l00992"></a>00992     }
<a name="l00993"></a>00993 }
<a name="l00994"></a>00994 
<a name="l00995"></a>00995 
<a name="l00996"></a>00996 
<a name="l00997"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a4413b39e0439b2e5535c9a9f962ea3fd">00997</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4413b39e0439b2e5535c9a9f962ea3fd">MeshTools::libmesh_assert_valid_node_procids</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh)
<a name="l00998"></a>00998 {
<a name="l00999"></a>00999   parallel_only();
<a name="l01000"></a>01000   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01001"></a>01001     <span class="keywordflow">return</span>;
<a name="l01002"></a>01002 
<a name="l01003"></a>01003   libmesh_assert(<a class="code" href="namespacelibMesh_1_1Parallel.php#afec10b0fbd4febe7fb866f26f6c3ee41">Parallel::verify</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9778fcd4d5fc7687babdf9a5ea56d882">max_node_id</a>()));
<a name="l01004"></a>01004   std::vector&lt;bool&gt; node_touched_by_me(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9778fcd4d5fc7687babdf9a5ea56d882">max_node_id</a>(), <span class="keyword">false</span>);
<a name="l01005"></a>01005 
<a name="l01006"></a>01006   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l01007"></a>01007     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l01008"></a>01008   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l01009"></a>01009        mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>(); el != el_end; ++el)
<a name="l01010"></a>01010     {
<a name="l01011"></a>01011       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l01012"></a>01012       libmesh_assert (elem);
<a name="l01013"></a>01013 
<a name="l01014"></a>01014       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++i)
<a name="l01015"></a>01015         {
<a name="l01016"></a>01016           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(i);
<a name="l01017"></a>01017           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodeid = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l01018"></a>01018           node_touched_by_me[nodeid] = <span class="keyword">true</span>;
<a name="l01019"></a>01019         }
<a name="l01020"></a>01020     }
<a name="l01021"></a>01021   std::vector&lt;bool&gt; node_touched_by_anyone(node_touched_by_me);
<a name="l01022"></a>01022   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(node_touched_by_anyone);
<a name="l01023"></a>01023 
<a name="l01024"></a>01024   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> nd_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ad0daaecd9c183194a99609db6507198c">local_nodes_end</a>();
<a name="l01025"></a>01025   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> nd = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a7a87dbe56aaa89961e03d60a25a36e8b">local_nodes_begin</a>();
<a name="l01026"></a>01026        nd != nd_end; ++nd)
<a name="l01027"></a>01027     {
<a name="l01028"></a>01028       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = *nd;
<a name="l01029"></a>01029       libmesh_assert(node);
<a name="l01030"></a>01030 
<a name="l01031"></a>01031       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nodeid = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l01032"></a>01032       libmesh_assert(!node_touched_by_anyone[nodeid] ||
<a name="l01033"></a>01033                      node_touched_by_me[nodeid]);
<a name="l01034"></a>01034     }
<a name="l01035"></a>01035 }
<a name="l01036"></a>01036 
<a name="l01037"></a>01037 
<a name="l01038"></a>01038 
<a name="l01039"></a>01039 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l01040"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a443c40ad462ac08f08aa00a23b552eb9">01040</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a443c40ad462ac08f08aa00a23b552eb9">MeshTools::libmesh_assert_valid_refinement_flags</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh)
<a name="l01041"></a>01041 {
<a name="l01042"></a>01042   parallel_only();
<a name="l01043"></a>01043   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l01044"></a>01044     <span class="keywordflow">return</span>;
<a name="l01045"></a>01045 
<a name="l01046"></a>01046   std::vector&lt;unsigned char&gt; my_elem_h_state(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>(), 255);
<a name="l01047"></a>01047   std::vector&lt;unsigned char&gt; my_elem_p_state(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>(), 255);
<a name="l01048"></a>01048 
<a name="l01049"></a>01049   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end =
<a name="l01050"></a>01050     mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l01051"></a>01051   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = 
<a name="l01052"></a>01052        mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>(); el != el_end; ++el)
<a name="l01053"></a>01053     {
<a name="l01054"></a>01054       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l01055"></a>01055       libmesh_assert (elem);
<a name="l01056"></a>01056       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elemid = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l01057"></a>01057 
<a name="l01058"></a>01058       my_elem_h_state[elemid] =
<a name="l01059"></a>01059         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">char</span><span class="keyword">&gt;</span>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>());
<a name="l01060"></a>01060 
<a name="l01061"></a>01061       my_elem_p_state[elemid] =
<a name="l01062"></a>01062         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">char</span><span class="keyword">&gt;</span>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>());
<a name="l01063"></a>01063     }
<a name="l01064"></a>01064   std::vector&lt;unsigned char&gt; min_elem_h_state(my_elem_h_state);
<a name="l01065"></a>01065   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_elem_h_state);
<a name="l01066"></a>01066 
<a name="l01067"></a>01067   std::vector&lt;unsigned char&gt; min_elem_p_state(my_elem_p_state);
<a name="l01068"></a>01068   <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_elem_p_state);
<a name="l01069"></a>01069 
<a name="l01070"></a>01070   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!= mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>(); ++i)
<a name="l01071"></a>01071     {
<a name="l01072"></a>01072       libmesh_assert(my_elem_h_state[i] == 255 ||
<a name="l01073"></a>01073                      my_elem_h_state[i] == min_elem_h_state[i]);
<a name="l01074"></a>01074       libmesh_assert(my_elem_p_state[i] == 255 ||
<a name="l01075"></a>01075                      my_elem_p_state[i] == min_elem_p_state[i]);
<a name="l01076"></a>01076     }
<a name="l01077"></a>01077 }
<a name="l01078"></a>01078 <span class="preprocessor">#else</span>
<a name="l01079"></a>01079 <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a443c40ad462ac08f08aa00a23b552eb9">MeshTools::libmesh_assert_valid_refinement_flags</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;)
<a name="l01080"></a>01080 {
<a name="l01081"></a>01081 }
<a name="l01082"></a>01082 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l01083"></a>01083 <span class="preprocessor"></span>
<a name="l01084"></a>01084 
<a name="l01085"></a>01085 
<a name="l01086"></a><a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">01086</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">MeshTools::libmesh_assert_valid_neighbors</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh)
<a name="l01087"></a>01087 {
<a name="l01088"></a>01088   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>();
<a name="l01089"></a>01089   <span class="keywordflow">for</span> (<a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> el = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l01090"></a>01090        el != el_end; ++el)
<a name="l01091"></a>01091     {
<a name="l01092"></a>01092       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *el;
<a name="l01093"></a>01093       libmesh_assert (elem);
<a name="l01094"></a>01094       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae15bea57cf5f41dbb2bdc680c6921200">libmesh_assert_valid_neighbors</a>();
<a name="l01095"></a>01095     }
<a name="l01096"></a>01096 }
<a name="l01097"></a>01097 <span class="preprocessor">#endif</span>
<a name="l01098"></a>01098 <span class="preprocessor"></span>
<a name="l01099"></a>01099 
<a name="l01100"></a>01100 
<a name="l01101"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a6250f59b9180229182c52939a4511363">01101</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a6250f59b9180229182c52939a4511363">MeshTools::Private::globally_renumber_nodes_and_elements</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh)
<a name="l01102"></a>01102 {
<a name="l01103"></a>01103   <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#ac07c8ba8aee328c186d853666dca4aa0">assign_global_indices</a>(mesh);
<a name="l01104"></a>01104 }
<a name="l01105"></a>01105 
<a name="l01106"></a>01106 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
