<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_tools.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__tools_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_tools.h 4394 2011-04-22 04:12:18Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __mesh_tools_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_tools_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="id__types_8h.php">id_types.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span> <span class="comment">// some compilers want the full definition - I think so they can do </span>
<a name="l00037"></a>00037                    <span class="comment">// return-value-optimization for BoundingBox&#39;es - BSK</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>libMesh
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// forward declarations</span>
<a name="l00043"></a>00043 <span class="keyword">class </span>SerialMesh;
<a name="l00044"></a>00044 <span class="keyword">class </span>ParallelMesh;
<a name="l00045"></a>00045 <span class="keyword">class </span>Sphere;
<a name="l00046"></a>00046 <span class="keyword">class </span>Elem;
<a name="l00047"></a>00047 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>LocationMap;
<a name="l00048"></a>00048 
<a name="l00061"></a>00061 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00062"></a>00062 <span class="comment">// MeshTools namespace</span>
<a name="l00063"></a>00063 <span class="keyword">namespace </span>MeshTools
<a name="l00064"></a>00064 {
<a name="l00069"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">00069</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">BoundingBox</a> : <span class="keyword">public</span> std::pair&lt;Point, Point&gt;
<a name="l00070"></a>00070   {
<a name="l00071"></a>00071   <span class="keyword">public</span>:
<a name="l00072"></a>00072     
<a name="l00073"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a412c23c4cc82cd81a82c45c77694335d">00073</a>     <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a412c23c4cc82cd81a82c45c77694335d">BoundingBox</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;<a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a441073168be127b8ed8bb01e0ed73846">min</a>, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;<a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a605cc4d95a780925a7fa305b95b74b6f">max</a>) :
<a name="l00074"></a>00074       std::pair&lt;<a class="code" href="classlibMesh_1_1Point.php">Point</a>, <a class="code" href="classlibMesh_1_1Point.php">Point</a>&gt;(min, max)
<a name="l00075"></a>00075     {}
<a name="l00076"></a>00076 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a78a000ef5ee889ff115a4bf3c193e22a">00077</a>     <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a412c23c4cc82cd81a82c45c77694335d">BoundingBox</a> (<span class="keyword">const</span> std::pair&lt;Point, Point&gt; &amp;bbox) :
<a name="l00078"></a>00078       std::pair&lt;<a class="code" href="classlibMesh_1_1Point.php">Point</a>, <a class="code" href="classlibMesh_1_1Point.php">Point</a>&gt; (bbox)
<a name="l00079"></a>00079     {}
<a name="l00080"></a>00080 
<a name="l00081"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a441073168be127b8ed8bb01e0ed73846">00081</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a441073168be127b8ed8bb01e0ed73846">min</a>()<span class="keyword"> const</span>
<a name="l00082"></a>00082 <span class="keyword">    </span>{ <span class="keywordflow">return</span> this-&gt;first; }
<a name="l00083"></a>00083 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a826ff91d586bbe9eee40cb2c424aa4bb">00084</a>     <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a441073168be127b8ed8bb01e0ed73846">min</a>()
<a name="l00085"></a>00085     { <span class="keywordflow">return</span> this-&gt;first; }
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a605cc4d95a780925a7fa305b95b74b6f">00087</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a605cc4d95a780925a7fa305b95b74b6f">max</a>()<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword">    </span>{ <span class="keywordflow">return</span> this-&gt;second; }
<a name="l00089"></a>00089 
<a name="l00090"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a40e31e785e7eeddad8e39f9e1e199746">00090</a>     <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a605cc4d95a780925a7fa305b95b74b6f">max</a>()
<a name="l00091"></a>00091     { <span class="keywordflow">return</span> this-&gt;second; }
<a name="l00092"></a>00092 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#ac6488f9ce66170a3ea96ad785c0247f8">00093</a>     <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">BoundingBox</a> &amp; <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#ac6488f9ce66170a3ea96ad785c0247f8">expand</a>()
<a name="l00094"></a>00094     { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#a2ee857488624778d1282d2efa57ce743">intersect</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">BoundingBox</a> &amp;) <span class="keyword">const</span>;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php#ab80b8987921cdeafa69a873774d3bf24">contains_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp;) <span class="keyword">const</span>;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="keyword">private</span>:
<a name="l00101"></a>00101   };
<a name="l00102"></a>00102   
<a name="l00109"></a>00109   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a090bd8f1b67e129c3aa31e8bd40bc365">total_weight</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00110"></a>00110   
<a name="l00117"></a>00117   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ace0de159896fa109bda6729e65c7d591">weight</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00118"></a>00118   
<a name="l00125"></a>00125   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1faee34ae17dbda4133b31ffbae712ca">build_nodes_to_elem_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00126"></a>00126                                 std::vector&lt;std::vector&lt;unsigned int&gt; &gt; &amp;nodes_to_elem_map);
<a name="l00127"></a>00127   
<a name="l00131"></a>00131   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1faee34ae17dbda4133b31ffbae712ca">build_nodes_to_elem_map</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00132"></a>00132                                 std::vector&lt;std::vector&lt;const Elem*&gt; &gt;&amp; nodes_to_elem_map);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="comment">//   /**</span>
<a name="l00136"></a>00136 <span class="comment">//    * Calling this function on a 2D mesh will convert all the elements</span>
<a name="l00137"></a>00137 <span class="comment">//    * to triangles.  \p QUAD4s will be converted to \p TRI3s, \p QUAD8s</span>
<a name="l00138"></a>00138 <span class="comment">//    * and \p QUAD9s will be converted to \p TRI6s. </span>
<a name="l00139"></a>00139 <span class="comment">//    */</span>
<a name="l00140"></a>00140 <span class="comment">//   void all_tri (MeshBase &amp;mesh);</span>
<a name="l00141"></a>00141 
<a name="l00146"></a>00146   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a0fd39d630f54c93571ee6449e8b15550">find_boundary_nodes</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00147"></a>00147                             std::vector&lt;bool&gt; &amp;on_boundary);
<a name="l00148"></a>00148 
<a name="l00154"></a>00154   BoundingBox
<a name="l00155"></a>00155   <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00156"></a>00156 
<a name="l00160"></a>00160   <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a>
<a name="l00161"></a>00161   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a15cfa4aa6733bffa5fff0c64c7608a71">bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00162"></a>00162   
<a name="l00167"></a>00167   BoundingBox
<a name="l00168"></a>00168   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4bb037002f33c07017927691f7bf90d7">processor_bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00169"></a>00169                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid);
<a name="l00170"></a>00170 
<a name="l00174"></a>00174   <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a> 
<a name="l00175"></a>00175   <a class="code" href="namespacelibMesh_1_1MeshTools.php#af9f209a04863401d00d8e422759dd1f2">processor_bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00176"></a>00176                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid);
<a name="l00177"></a>00177 
<a name="l00182"></a>00182   BoundingBox
<a name="l00183"></a>00183   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a84219b567ed5847433bf707a40b37883">subdomain_bounding_box</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00184"></a>00184                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> sid);
<a name="l00185"></a>00185 
<a name="l00189"></a>00189   <a class="code" href="classlibMesh_1_1Sphere.php">Sphere</a> 
<a name="l00190"></a>00190   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a8b4ec2068592eca4d6377e5b91de01fd">subdomain_bounding_sphere</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00191"></a>00191                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1TestClass.php">subdomain_id_type</a> sid);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193 
<a name="l00198"></a>00198   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a105332f64aa69991539faccda22f6710">elem_types</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00199"></a>00199                    std::vector&lt;ElemType&gt; &amp;et);
<a name="l00200"></a>00200   
<a name="l00205"></a>00205   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a111d5a366fdd494f84b67573794f3875">n_elem_of_type</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00206"></a>00206                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00207"></a>00207 
<a name="l00212"></a>00212   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a82584b7e94e5642d9b41ae0a726c3734">n_active_elem_of_type</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00213"></a>00213                                       <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00214"></a>00214 
<a name="l00223"></a>00223   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#af20b5f9a49193f82120721747b4a371a">n_non_subactive_elem_of_type_at_level</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00224"></a>00224                                                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00225"></a>00225                                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00226"></a>00226 
<a name="l00232"></a>00232   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae15ece869d4ef3d283edb677942e8439">n_levels</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00233"></a>00233 
<a name="l00239"></a>00239   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a86b5b94d1a51d606668a85e6f31af4b6">n_local_levels</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00240"></a>00240  
<a name="l00246"></a>00246   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a83a95efd16596e9d337f66983328ee8e">n_active_levels</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00247"></a>00247 
<a name="l00253"></a>00253   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4ad92062f806ef59be2bbd73e9705775">n_active_local_levels</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00254"></a>00254 
<a name="l00260"></a>00260   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a389d0bd8b56b85fce05a743e8f3bd454">n_p_levels</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00261"></a>00261  
<a name="l00268"></a>00268   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a3a83769db0dd1cc0ced4f981506a5492">get_not_subactive_node_ids</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh, 
<a name="l00269"></a>00269                                   std::set&lt;unsigned int&gt; &amp;not_subactive_node_ids);
<a name="l00270"></a>00270 
<a name="l00275"></a>00275    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">n_elem</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> &amp;begin,
<a name="l00276"></a>00276                         <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> &amp;end);
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00283"></a>00283    <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a85a60584ebd3d256c8114b06ff9560c2">n_nodes</a> (<span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> &amp;begin,
<a name="l00284"></a>00284                          <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__node__iterator.php">MeshBase::const_node_iterator</a> &amp;end);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 
<a name="l00290"></a>00290   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a57a0ae7fb3cba63f06621d6c701327c8">max_level</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00291"></a>00291     
<a name="l00292"></a>00292   
<a name="l00297"></a>00297    <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a56f90a762fb8feb128abb693690c223f">find_nodal_neighbors</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a> &amp;n, 
<a name="l00298"></a>00298                              std::vector&lt;std::vector&lt;const Elem*&gt; &gt; &amp;nodes_to_elem_map, 
<a name="l00299"></a>00299                              std::vector&lt;const Node*&gt; &amp;neighbors);
<a name="l00300"></a>00300    
<a name="l00307"></a>00307    <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a693646efaadc6206730b7bd1bf4d5978">find_hanging_nodes_and_parents</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh, std::map&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, std::vector&lt;unsigned int&gt; &gt; &amp;hanging_nodes);
<a name="l00308"></a>00308 
<a name="l00319"></a>00319   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#ae41cec551d5e6a5502564b01056512d3">correct_node_proc_ids</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;, <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;Node&gt;</a> &amp;);
<a name="l00320"></a>00320 
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00323"></a>00323 <span class="preprocessor"></span>
<a name="l00327"></a>00327   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a8caf167bf36aeb0045b7736345f26da2">libmesh_assert_no_links_to_elem</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh,
<a name="l00328"></a>00328                                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *bad_elem);
<a name="l00329"></a>00329 
<a name="l00334"></a>00334   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a059c8ba488323734da1dce1c85cbf8e6">libmesh_assert_valid_node_pointers</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00335"></a>00335 
<a name="l00340"></a>00340   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a553f4980413b774f6ea4c39b18f331af">libmesh_assert_valid_remote_elems</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00341"></a>00341 
<a name="l00346"></a>00346   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1968ff1c8ed3fdc7f1c23e6b8ec322f8">libmesh_assert_valid_elem_ids</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00347"></a>00347 
<a name="l00352"></a>00352   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4413b39e0439b2e5535c9a9f962ea3fd">libmesh_assert_valid_node_procids</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00353"></a>00353 
<a name="l00358"></a>00358   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a443c40ad462ac08f08aa00a23b552eb9">libmesh_assert_valid_refinement_flags</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00359"></a>00359 
<a name="l00364"></a>00364   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">libmesh_assert_valid_neighbors</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh);
<a name="l00365"></a>00365 <span class="preprocessor">#endif</span>
<a name="l00366"></a>00366 <span class="preprocessor"></span>
<a name="l00367"></a>00367   <span class="comment">// There is no reason for users to call functions in the MeshTools::Private namespace.</span>
<a name="l00368"></a><a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php">00368</a>   <span class="keyword">namespace </span>Private {
<a name="l00380"></a>00380     <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Private.php#a6250f59b9180229182c52939a4511363">globally_renumber_nodes_and_elements</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;);
<a name="l00381"></a>00381   } <span class="comment">// end namespace Private</span>
<a name="l00382"></a>00382   
<a name="l00383"></a>00383 } <span class="comment">// end namespace MeshTools</span>
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 } <span class="comment">// namespace libMesh</span>
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="preprocessor">#endif // #define __mesh_tools_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
