<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">mesh_triangle_support.h</div>  </div>
</div>
<div class="contents">
<a href="mesh__triangle__support_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: mesh_triangle_support.h 3924 2010-08-24 22:10:57Z roystgnr $</span>
<a name="l00002"></a>00002  
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __mesh_triangle_support_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __mesh_triangle_support_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// C++ includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span> <span class="comment">// For ElemType declaration below</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRIANGLE</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward Declarations</span>
<a name="l00039"></a><a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">00039</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Note: libmesh_common.h defines REAL, which is required by triangle.</span>
<a name="l00042"></a>00042 <span class="comment">// Therefore, we need to include it first.</span>
<a name="l00043"></a>00043 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="keyword">typedef</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="namespacelibMesh.php#a1e82fa346933f46b0f2e09213e9ef039">REAL</a>;
<a name="l00046"></a>00046 
<a name="l00052"></a><a class="code" href="namespacelibMesh_1_1Triangle.php">00052</a> <span class="keyword">namespace </span>Triangle {
<a name="l00053"></a>00053 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00054"></a>00054 <span class="preprocessor">#include &quot;triangle.h&quot;</span>
<a name="l00055"></a>00055 }
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="namespacelibMesh_1_1Triangle.php#a6906d44fce92bbb24b656a5ea851bee4">00057</a>   <span class="keyword">enum</span> <a class="code" href="namespacelibMesh_1_1Triangle.php#a6906d44fce92bbb24b656a5ea851bee4">IO_Type</a> {
<a name="l00058"></a><a class="code" href="namespacelibMesh_1_1Triangle.php#a6906d44fce92bbb24b656a5ea851bee4ac1abc84b970aa9cb9997d6d82a009a8c">00058</a>     <a class="code" href="namespacelibMesh_1_1Triangle.php#a6906d44fce92bbb24b656a5ea851bee4ac1abc84b970aa9cb9997d6d82a009a8c">INPUT</a>  = 0,
<a name="l00059"></a><a class="code" href="namespacelibMesh_1_1Triangle.php#a6906d44fce92bbb24b656a5ea851bee4a1beda65d8be7bf4b73e619832c3b5073">00059</a>     <a class="code" href="namespacelibMesh_1_1Triangle.php#a6906d44fce92bbb24b656a5ea851bee4a1beda65d8be7bf4b73e619832c3b5073">OUTPUT</a> = 1,
<a name="l00060"></a><a class="code" href="namespacelibMesh_1_1Triangle.php#a6906d44fce92bbb24b656a5ea851bee4af393015d393391d30e38546b5c5e2806">00060</a>     <a class="code" href="namespacelibMesh_1_1Triangle.php#a6906d44fce92bbb24b656a5ea851bee4af393015d393391d30e38546b5c5e2806">BOTH</a>   = 2};
<a name="l00061"></a>00061   
<a name="l00068"></a>00068   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Triangle.php#aa0bea36f7d82bb87a409db3d9e9152eb">init</a>(triangulateio&amp; t);
<a name="l00069"></a>00069     
<a name="l00081"></a>00081   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Triangle.php#aebe0e0cbad0b5ff62d3f289369261646">destroy</a>(triangulateio&amp; t, <a class="code" href="namespacelibMesh_1_1Triangle.php#a6906d44fce92bbb24b656a5ea851bee4">IO_Type</a>);
<a name="l00082"></a>00082 
<a name="l00089"></a>00089   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Triangle.php#a729389cdc4a58ff0169d110670ee504e">copy_tri_to_mesh</a>(<span class="keyword">const</span> triangulateio&amp; triangle_data_input,
<a name="l00090"></a>00090                         <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; mesh_output,
<a name="l00091"></a>00091                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00092"></a>00092     
<a name="l00093"></a>00093   
<a name="l00094"></a>00094 }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php">00111</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TriangleInterface.php">TriangleInterface</a>
<a name="l00112"></a>00112 {
<a name="l00113"></a>00113 <span class="keyword">public</span>:
<a name="l00120"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a9790eb35df113b88af9625393550170b">00120</a>   <a class="code" href="classlibMesh_1_1TriangleInterface.php#a9790eb35df113b88af9625393550170b">TriangleInterface</a>(<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00121"></a>00121     : <a class="code" href="classlibMesh_1_1TriangleInterface.php#ab9cc69a714106357635e1196f47bfc81">_mesh</a>(mesh),
<a name="l00122"></a>00122       <a class="code" href="classlibMesh_1_1TriangleInterface.php#a132a117de0bd11149de3bdf1b08a9147">_holes</a>(NULL),
<a name="l00123"></a>00123       <a class="code" href="classlibMesh_1_1TriangleInterface.php#a970a3c29fdea540c42b6acab6496978b">_elem_type</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>),
<a name="l00124"></a>00124       <a class="code" href="classlibMesh_1_1TriangleInterface.php#a80c545ad0ec3529b15e5fd9a6ba596e4">_desired_area</a>(0.1),
<a name="l00125"></a>00125       <a class="code" href="classlibMesh_1_1TriangleInterface.php#ace2d9fec8c52b013af364dc0b7713c64">_triangulation_type</a>(<a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698aca1d226bba47bf25b04ad0cd4c75e5f5d5">GENERATE_CONVEX_HULL</a>),
<a name="l00126"></a>00126       <a class="code" href="classlibMesh_1_1TriangleInterface.php#a435a3ea4d740804b5c714553da64eac6">_insert_extra_points</a>(false),
<a name="l00127"></a>00127       <a class="code" href="classlibMesh_1_1TriangleInterface.php#a6142acf9c9e08b9d9a8a1a25a5e617a0">_smooth_after_generating</a>(true)
<a name="l00128"></a>00128   {}
<a name="l00129"></a>00129 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#ab1d60af115712b94239e6e06942e246e">00133</a>   <a class="code" href="classlibMesh_1_1TriangleInterface.php#ab1d60af115712b94239e6e06942e246e">~TriangleInterface</a>() {}
<a name="l00134"></a>00134       
<a name="l00139"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698ac">00139</a>   <span class="keyword">enum</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698ac">TriangulationType</a>
<a name="l00140"></a>00140     {
<a name="l00141"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698aca1d226bba47bf25b04ad0cd4c75e5f5d5">00141</a>       <a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698aca1d226bba47bf25b04ad0cd4c75e5f5d5">GENERATE_CONVEX_HULL</a> = 0,
<a name="l00149"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698acaea0a3aba1c2f66629621021722a686f5">00149</a>       <a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698acaea0a3aba1c2f66629621021722a686f5">PSLG</a> = 1,
<a name="l00161"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698aca771f30982873b1dbb3cb85cb694a980f">00161</a>       <a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698aca771f30982873b1dbb3cb85cb694a980f">INVALID_TRIANGULATION_TYPE</a>
<a name="l00165"></a>00165     };
<a name="l00166"></a>00166 
<a name="l00172"></a>00172   <span class="keyword">class </span>Hole;
<a name="l00173"></a>00173   <span class="keyword">class </span>PolygonHole;
<a name="l00174"></a>00174   <span class="keyword">class </span>ArbitraryHole;
<a name="l00175"></a>00175       
<a name="l00180"></a>00180   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a640643807aa9f6bee6a34f4473f7351f">triangulate</a>();
<a name="l00181"></a>00181 
<a name="l00185"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a394fb441acbd4734ed1c1f267a1d1268">00185</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>&amp; <a class="code" href="classlibMesh_1_1TriangleInterface.php#a394fb441acbd4734ed1c1f267a1d1268">elem_type</a>() {<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a970a3c29fdea540c42b6acab6496978b">_elem_type</a>;}
<a name="l00186"></a>00186 
<a name="l00190"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a164241296ffdbbc61591f3a5846164b0">00190</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; <a class="code" href="classlibMesh_1_1TriangleInterface.php#a164241296ffdbbc61591f3a5846164b0">desired_area</a>() {<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a80c545ad0ec3529b15e5fd9a6ba596e4">_desired_area</a>;}
<a name="l00191"></a>00191 
<a name="l00195"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#ae0237c10299245de357f496d58a8d6e7">00195</a>   <a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698ac">TriangulationType</a>&amp; <a class="code" href="classlibMesh_1_1TriangleInterface.php#ae0237c10299245de357f496d58a8d6e7">triangulation_type</a>() {<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#ace2d9fec8c52b013af364dc0b7713c64">_triangulation_type</a>;}
<a name="l00196"></a>00196 
<a name="l00200"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a5432206530a49b968348ef24465f5bb2">00200</a>   <span class="keywordtype">bool</span>&amp; <a class="code" href="classlibMesh_1_1TriangleInterface.php#a5432206530a49b968348ef24465f5bb2">insert_extra_points</a>() {<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a435a3ea4d740804b5c714553da64eac6">_insert_extra_points</a>;}
<a name="l00201"></a>00201 
<a name="l00206"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#abc62141eda729c8b388a2230396768ad">00206</a>   <span class="keywordtype">bool</span>&amp; <a class="code" href="classlibMesh_1_1TriangleInterface.php#abc62141eda729c8b388a2230396768ad">smooth_after_generating</a>() {<span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a6142acf9c9e08b9d9a8a1a25a5e617a0">_smooth_after_generating</a>;}
<a name="l00207"></a>00207   
<a name="l00212"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a9a2ae8572521804999b20b967cc27e81">00212</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a9a2ae8572521804999b20b967cc27e81">attach_hole_list</a>(<span class="keyword">const</span> std::vector&lt;Hole*&gt;* holes) {<a class="code" href="classlibMesh_1_1TriangleInterface.php#a132a117de0bd11149de3bdf1b08a9147">_holes</a> = holes;}
<a name="l00213"></a>00213 
<a name="l00225"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a45ff6eaf6be9da300cbe99804212b6a9">00225</a>   std::vector&lt;std::pair&lt;unsigned int, unsigned int&gt; &gt; <a class="code" href="classlibMesh_1_1TriangleInterface.php#a45ff6eaf6be9da300cbe99804212b6a9">segments</a>;
<a name="l00226"></a>00226   
<a name="l00227"></a>00227 <span class="keyword">private</span>:
<a name="l00231"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#ab9cc69a714106357635e1196f47bfc81">00231</a>   <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="classlibMesh_1_1TriangleInterface.php#ab9cc69a714106357635e1196f47bfc81">_mesh</a>;
<a name="l00232"></a>00232 
<a name="l00237"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a132a117de0bd11149de3bdf1b08a9147">00237</a>   <span class="keyword">const</span> std::vector&lt;Hole*&gt;* <a class="code" href="classlibMesh_1_1TriangleInterface.php#a132a117de0bd11149de3bdf1b08a9147">_holes</a>;
<a name="l00238"></a>00238 
<a name="l00243"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a970a3c29fdea540c42b6acab6496978b">00243</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a970a3c29fdea540c42b6acab6496978b">_elem_type</a>;
<a name="l00244"></a>00244 
<a name="l00248"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a80c545ad0ec3529b15e5fd9a6ba596e4">00248</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a80c545ad0ec3529b15e5fd9a6ba596e4">_desired_area</a>;
<a name="l00249"></a>00249 
<a name="l00255"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#ace2d9fec8c52b013af364dc0b7713c64">00255</a>   <a class="code" href="classlibMesh_1_1TriangleInterface.php#a186e44b9aa66a96c7c7c2d85dcf698ac">TriangulationType</a> <a class="code" href="classlibMesh_1_1TriangleInterface.php#ace2d9fec8c52b013af364dc0b7713c64">_triangulation_type</a>;
<a name="l00256"></a>00256 
<a name="l00262"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a435a3ea4d740804b5c714553da64eac6">00262</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a435a3ea4d740804b5c714553da64eac6">_insert_extra_points</a>;
<a name="l00263"></a>00263 
<a name="l00268"></a><a class="code" href="classlibMesh_1_1TriangleInterface.php#a6142acf9c9e08b9d9a8a1a25a5e617a0">00268</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php#a6142acf9c9e08b9d9a8a1a25a5e617a0">_smooth_after_generating</a>;
<a name="l00269"></a>00269 };
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 
<a name="l00275"></a>00275 
<a name="l00276"></a>00276 
<a name="l00283"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php">00283</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php">TriangleInterface::Hole</a>
<a name="l00284"></a>00284 {
<a name="l00285"></a>00285 <span class="keyword">public</span>:
<a name="l00289"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php#aa19c6f6a3a8443165c3951159d98f1d2">00289</a>   <a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php#aa19c6f6a3a8443165c3951159d98f1d2">Hole</a>() {}
<a name="l00290"></a>00290 
<a name="l00294"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php#a758f5ff71086cf7c1761a453aee1bc5c">00294</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php#a758f5ff71086cf7c1761a453aee1bc5c">~Hole</a>() {}
<a name="l00295"></a>00295 
<a name="l00299"></a>00299   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php#a413ec0a4932c1ebcb7332d97cae3cfea">n_points</a>() <span class="keyword">const</span> = 0;
<a name="l00300"></a>00300 
<a name="l00304"></a>00304   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php#aaf7740dcd9caad0957bdf02d83b11b3d">point</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) <span class="keyword">const</span> = 0;
<a name="l00305"></a>00305 
<a name="l00309"></a>00309   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php#aaf05e5bb5d517afe797164e9d41058bb">inside</a>() <span class="keyword">const</span> = 0;
<a name="l00310"></a>00310 };
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316     
<a name="l00321"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php">00321</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php">TriangleInterface::PolygonHole</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php">TriangleInterface</a>::<a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php">Hole</a>
<a name="l00322"></a>00322 {
<a name="l00323"></a>00323 <span class="keyword">public</span>:
<a name="l00329"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a05b3c566754c614420ecc8c52d7758b6">00329</a>   <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a05b3c566754c614420ecc8c52d7758b6">PolygonHole</a>(<a class="code" href="classlibMesh_1_1Point.php">Point</a> center, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> radius, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#ac7a1a8b0bf7a156c39c0b2db418cd2da">n_points</a>) :
<a name="l00330"></a>00330     <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a70429a32752ba4544f39b0dae377d51c">_center</a>(center),
<a name="l00331"></a>00331     <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#ab6be306aec837b99726434c7e03432eb">_radius</a>(radius),
<a name="l00332"></a>00332     <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#acf1debe844a3d82cbb1a3b11c3d84e70">_n_points</a>(n_points) {}
<a name="l00333"></a>00333 
<a name="l00337"></a>00337   <span class="comment">// PolygonHole() {}</span>
<a name="l00338"></a>00338 
<a name="l00339"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#ac7a1a8b0bf7a156c39c0b2db418cd2da">00339</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#ac7a1a8b0bf7a156c39c0b2db418cd2da">n_points</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#acf1debe844a3d82cbb1a3b11c3d84e70">_n_points</a>; }
<a name="l00340"></a>00340 
<a name="l00341"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#acf641c0a490683fdb017975a048a80f4">00341</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#acf641c0a490683fdb017975a048a80f4">point</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00342"></a>00342 <span class="keyword">  </span>{
<a name="l00343"></a>00343     <span class="comment">// The nth point lies at the angle theta = 2 * pi * n / _n_points</span>
<a name="l00344"></a>00344     <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> theta = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(n) * 2.0 * <a class="code" href="namespacelibMesh.php#a668b057121e7cf9d0c35207b7ab6bf38">libMesh::pi</a> / static_cast&lt;Real&gt;(<a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#acf1debe844a3d82cbb1a3b11c3d84e70">_n_points</a>);
<a name="l00345"></a>00345         
<a name="l00346"></a>00346     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>(<a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a70429a32752ba4544f39b0dae377d51c">_center</a>(0) + <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#ab6be306aec837b99726434c7e03432eb">_radius</a>*std::cos(theta), <span class="comment">// x=r*cos(theta)</span>
<a name="l00347"></a>00347                  <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a70429a32752ba4544f39b0dae377d51c">_center</a>(1) + <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#ab6be306aec837b99726434c7e03432eb">_radius</a>*std::sin(theta), <span class="comment">// y=r*sin(theta)</span>
<a name="l00348"></a>00348                  0.);
<a name="l00349"></a>00349   }
<a name="l00350"></a>00350 
<a name="l00354"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a7abb070e7af9a0b271331aaf0880606b">00354</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a7abb070e7af9a0b271331aaf0880606b">inside</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a70429a32752ba4544f39b0dae377d51c">_center</a>;  }
<a name="l00355"></a>00355       
<a name="l00356"></a>00356 <span class="keyword">private</span>:
<a name="l00360"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a70429a32752ba4544f39b0dae377d51c">00360</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#a70429a32752ba4544f39b0dae377d51c">_center</a>;
<a name="l00361"></a>00361 
<a name="l00365"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#ab6be306aec837b99726434c7e03432eb">00365</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#ab6be306aec837b99726434c7e03432eb">_radius</a>;
<a name="l00366"></a>00366 
<a name="l00372"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#acf1debe844a3d82cbb1a3b11c3d84e70">00372</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1PolygonHole.php#acf1debe844a3d82cbb1a3b11c3d84e70">_n_points</a>;
<a name="l00373"></a>00373 };
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 
<a name="l00378"></a>00378 
<a name="l00379"></a>00379     
<a name="l00380"></a>00380 
<a name="l00388"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php">00388</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php">TriangleInterface::ArbitraryHole</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1TriangleInterface.php">TriangleInterface</a>::<a class="code" href="classlibMesh_1_1TriangleInterface_1_1Hole.php">Hole</a>
<a name="l00389"></a>00389 {
<a name="l00390"></a>00390 <span class="keyword">public</span>:
<a name="l00391"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a3e69614d7b1ed1068f53bf37d75d49f2">00391</a>   <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a3e69614d7b1ed1068f53bf37d75d49f2">ArbitraryHole</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> center,
<a name="l00392"></a>00392                 <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; points)
<a name="l00393"></a>00393     :   <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#acc787c5634cd066e26af097784cbb87b">_center</a>(center),
<a name="l00394"></a>00394         <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a147ce6e69a198b0e1d36293fb308b35b">_points</a>(points)
<a name="l00395"></a>00395   {}
<a name="l00396"></a>00396 
<a name="l00404"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a03044cbfbe4d963e4304bfa39eda8a1c">00404</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a03044cbfbe4d963e4304bfa39eda8a1c">n_points</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a147ce6e69a198b0e1d36293fb308b35b">_points</a>.size(); }
<a name="l00405"></a>00405 
<a name="l00409"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a34076507353a81261c83e6167c0142f8">00409</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a34076507353a81261c83e6167c0142f8">point</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)<span class="keyword"> const</span>
<a name="l00410"></a>00410 <span class="keyword">  </span>{
<a name="l00411"></a>00411     libmesh_assert (n &lt; <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a147ce6e69a198b0e1d36293fb308b35b">_points</a>.size());
<a name="l00412"></a>00412     <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a147ce6e69a198b0e1d36293fb308b35b">_points</a>[n];
<a name="l00413"></a>00413   }
<a name="l00414"></a>00414 
<a name="l00418"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a527d065fe8effc7626afeb72ab2cc210">00418</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a527d065fe8effc7626afeb72ab2cc210">inside</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#acc787c5634cd066e26af097784cbb87b">_center</a>;  }
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="keyword">private</span>:
<a name="l00424"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#acc787c5634cd066e26af097784cbb87b">00424</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#acc787c5634cd066e26af097784cbb87b">_center</a>;
<a name="l00425"></a>00425 
<a name="l00430"></a><a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a147ce6e69a198b0e1d36293fb308b35b">00430</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classlibMesh_1_1TriangleInterface_1_1ArbitraryHole.php#a147ce6e69a198b0e1d36293fb308b35b">_points</a>;
<a name="l00431"></a>00431 };
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00440"></a>00440 <span class="keyword">namespace </span>MeshTools
<a name="l00441"></a>00441 {
<a name="l00442"></a>00442   <span class="keyword">namespace </span>Generation
<a name="l00443"></a>00443   {
<a name="l00444"></a>00444 
<a name="l00450"></a>00450     <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation.php#a6ccc739fc2bd68d433883c2a8eb76b13">build_delaunay_square</a>(<a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00451"></a>00451                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nx, <span class="comment">// num. of elements in x-dir</span>
<a name="l00452"></a>00452                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ny, <span class="comment">// num. of elements in y-dir</span>
<a name="l00453"></a>00453                                <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmin, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xmax,
<a name="l00454"></a>00454                                <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymin, <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ymax,
<a name="l00455"></a>00455                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type,
<a name="l00456"></a>00456                                <span class="keyword">const</span> std::vector&lt;TriangleInterface::Hole*&gt;* holes=NULL);
<a name="l00457"></a>00457   }
<a name="l00458"></a>00458 }
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 } <span class="comment">// namespace libMesh</span>
<a name="l00462"></a>00462 
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 <span class="preprocessor">#endif // LIBMESH_HAVE_TRIANGLE</span>
<a name="l00466"></a>00466 <span class="preprocessor"></span>
<a name="l00467"></a>00467 <span class="preprocessor">#endif // ifndef __mesh_triangle_support_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
