<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_4d3110f67e028a3227e23bfd240351cc.php">partitioning</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">metis_partitioner.C</div>  </div>
</div>
<div class="contents">
<a href="metis__partitioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: metis_partitioner.C 4348 2011-04-14 14:17:46Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="metis__partitioner_8h.php">metis_partitioner.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef LIBMESH_HAVE_METIS</span>
<a name="l00035"></a>00035 <span class="preprocessor"></span><span class="comment">// MIPSPro 7.4.2 gets confused about these nested namespaces</span>
<a name="l00036"></a>00036 <span class="preprocessor"># ifdef __sgi</span>
<a name="l00037"></a>00037 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;cstdarg&gt;</span>
<a name="l00038"></a>00038 <span class="preprocessor"># endif</span>
<a name="l00039"></a><a class="code" href="namespaceMetis.php">00039</a> <span class="preprocessor"></span>  <span class="keyword">namespace </span>Metis {
<a name="l00040"></a>00040     <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00041"></a>00041 <span class="preprocessor">#     include &quot;metis.h&quot;</span>
<a name="l00042"></a>00042     }
<a name="l00043"></a>00043   }
<a name="l00044"></a>00044 <span class="preprocessor">#else</span>
<a name="l00045"></a>00045 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;<a class="code" href="sfc__partitioner_8h.php">sfc_partitioner.h</a>&quot;</span>
<a name="l00046"></a>00046 <span class="preprocessor">#endif</span>
<a name="l00047"></a>00047 <span class="preprocessor"></span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="keyword">namespace </span>libMesh
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// MetisPartitioner implementation</span>
<a name="l00055"></a><a class="code" href="classlibMesh_1_1MetisPartitioner.php#a57d911f4771afc7f55275fba1dffffa4">00055</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MetisPartitioner.php#a57d911f4771afc7f55275fba1dffffa4">MetisPartitioner::_do_partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00056"></a>00056                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pieces)
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   libmesh_assert (n_pieces &gt; 0);
<a name="l00059"></a>00059   libmesh_assert (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>());
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">// Check for an easy return</span>
<a name="l00062"></a>00062   <span class="keywordflow">if</span> (n_pieces == 1)
<a name="l00063"></a>00063     {
<a name="l00064"></a>00064       this-&gt;<a class="code" href="classlibMesh_1_1Partitioner.php#abd4be60a7010f0a483e7632867aed9ef">single_partition</a> (mesh);
<a name="l00065"></a>00065       <span class="keywordflow">return</span>;
<a name="l00066"></a>00066     }
<a name="l00067"></a>00067   
<a name="l00068"></a>00068 <span class="comment">// What to do if the Metis library IS NOT present</span>
<a name="l00069"></a>00069 <span class="preprocessor">#ifndef LIBMESH_HAVE_METIS</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>
<a name="l00071"></a>00071   libmesh_here();
<a name="l00072"></a>00072   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: The library has been built without&quot;</span>    &lt;&lt; std::endl
<a name="l00073"></a>00073                 &lt;&lt; <span class="stringliteral">&quot;Metis support.  Using a space-filling curve&quot;</span>  &lt;&lt; std::endl
<a name="l00074"></a>00074                 &lt;&lt; <span class="stringliteral">&quot;partitioner instead!&quot;</span>                         &lt;&lt; std::endl;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1SFCPartitioner.php">SFCPartitioner</a> sfcp;
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   sfcp.<a class="code" href="classlibMesh_1_1Partitioner.php#ac5ab060463865dc0b6fe4a614aad626f">partition</a> (mesh, n_pieces);
<a name="l00079"></a>00079   
<a name="l00080"></a>00080 <span class="comment">// What to do if the Metis library IS present</span>
<a name="l00081"></a>00081 <span class="preprocessor">#else</span>
<a name="l00082"></a>00082 <span class="preprocessor"></span>  
<a name="l00083"></a>00083   START_LOG(<span class="stringliteral">&quot;partition()&quot;</span>, <span class="stringliteral">&quot;MetisPartitioner&quot;</span>);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>();
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   <span class="comment">// build the graph  </span>
<a name="l00088"></a>00088   std::vector&lt;int&gt; options(5);
<a name="l00089"></a>00089   std::vector&lt;int&gt; vwgt(n_active_elem);
<a name="l00090"></a>00090   std::vector&lt;int&gt; part(n_active_elem);
<a name="l00091"></a>00091   
<a name="l00092"></a>00092   <span class="keywordtype">int</span>
<a name="l00093"></a>00093     n = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_active_elem),  <span class="comment">// number of &quot;nodes&quot; (elements)</span>
<a name="l00094"></a>00094                                           <span class="comment">//   in the graph</span>
<a name="l00095"></a>00095     wgtflag = 2,                          <span class="comment">// weights on vertices only,</span>
<a name="l00096"></a>00096                                           <span class="comment">//   none on edges</span>
<a name="l00097"></a>00097     numflag = 0,                          <span class="comment">// C-style 0-based numbering</span>
<a name="l00098"></a>00098     nparts  = static_cast&lt;int&gt;(n_pieces), <span class="comment">// number of subdomains to create</span>
<a name="l00099"></a>00099     edgecut = 0;                          <span class="comment">// the numbers of edges cut by the</span>
<a name="l00100"></a>00100                                           <span class="comment">//   resulting partition</span>
<a name="l00101"></a>00101   
<a name="l00102"></a>00102   <span class="comment">// Set the options</span>
<a name="l00103"></a>00103   options[0] = 0; <span class="comment">// use default options</span>
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <span class="comment">// Metis will only consider the active elements.</span>
<a name="l00106"></a>00106   <span class="comment">// We need to map the active element ids into a</span>
<a name="l00107"></a>00107   <span class="comment">// contiguous range.  Further, we want the unique range indexing to be</span>
<a name="l00108"></a>00108   <span class="comment">// independednt of the element ordering, otherwise a circular dependency</span>
<a name="l00109"></a>00109   <span class="comment">// can result in which the partitioning depends on the ordering which </span>
<a name="l00110"></a>00110   <span class="comment">// depends on the partitioning...</span>
<a name="l00111"></a>00111   std::map&lt;const Elem*, unsigned int&gt; global_index_map;
<a name="l00112"></a>00112   {
<a name="l00113"></a>00113     std::vector&lt;unsigned int&gt; global_index;
<a name="l00114"></a>00114     
<a name="l00115"></a>00115     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00116"></a>00116     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00117"></a>00117     
<a name="l00118"></a>00118     <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#aa796c4e551a56a3e15603a2ffa7c6aaf">find_global_indices</a> (<a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">MeshTools::bounding_box</a>(mesh),
<a name="l00119"></a>00119                                              it, end, global_index);
<a name="l00120"></a>00120     
<a name="l00121"></a>00121     libmesh_assert (global_index.size() == n_active_elem);    
<a name="l00122"></a>00122     
<a name="l00123"></a>00123     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0; it != end; ++it)
<a name="l00124"></a>00124       {
<a name="l00125"></a>00125         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *it;
<a name="l00126"></a>00126         libmesh_assert (!global_index_map.count(elem));
<a name="l00127"></a>00127         
<a name="l00128"></a>00128         global_index_map[elem]  = global_index[cnt++];
<a name="l00129"></a>00129       }
<a name="l00130"></a>00130     libmesh_assert (global_index_map.size() == n_active_elem);    
<a name="l00131"></a>00131   }
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   
<a name="l00134"></a>00134   <span class="comment">// build the graph in CSR format.  Note that</span>
<a name="l00135"></a>00135   <span class="comment">// the edges in the graph will correspond to</span>
<a name="l00136"></a>00136   <span class="comment">// face neighbors</span>
<a name="l00137"></a>00137   std::vector&lt;int&gt; xadj, adjncy;
<a name="l00138"></a>00138   {
<a name="l00139"></a>00139     std::vector&lt;const Elem*&gt; neighbors_offspring;    
<a name="l00140"></a>00140     
<a name="l00141"></a>00141     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00142"></a>00142     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00143"></a>00143     
<a name="l00144"></a>00144     <span class="comment">// This will be exact when there is no refinement and all the</span>
<a name="l00145"></a>00145     <span class="comment">// elements are of the same type.</span>
<a name="l00146"></a>00146     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> graph_size=0;
<a name="l00147"></a>00147     std::vector&lt;std::vector&lt;unsigned int&gt; &gt; graph(n_active_elem);
<a name="l00148"></a>00148     
<a name="l00149"></a>00149     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00150"></a>00150       {
<a name="l00151"></a>00151         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00152"></a>00152         
<a name="l00153"></a>00153         libmesh_assert (global_index_map.count(elem));
<a name="l00154"></a>00154         
<a name="l00155"></a>00155         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_global_index = 
<a name="l00156"></a>00156           global_index_map[elem];
<a name="l00157"></a>00157         
<a name="l00158"></a>00158         libmesh_assert (elem_global_index &lt; vwgt.size());
<a name="l00159"></a>00159         libmesh_assert (elem_global_index &lt; graph.size());
<a name="l00160"></a>00160 
<a name="l00161"></a>00161         <span class="comment">// maybe there is a better weight?</span>
<a name="l00162"></a>00162         <span class="comment">// The weight is used to define what a balanced graph is</span>
<a name="l00163"></a>00163         <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1Partitioner.php#a1701ba592caafda75ba383d04bf1a47e">_weights</a>)
<a name="l00164"></a>00164           vwgt[elem_global_index] = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00165"></a>00165         <span class="keywordflow">else</span>
<a name="l00166"></a>00166           vwgt[elem_global_index] = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>((*_weights)[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]);
<a name="l00167"></a>00167 
<a name="l00168"></a>00168         <span class="comment">// Loop over the element&#39;s neighbors.  An element</span>
<a name="l00169"></a>00169         <span class="comment">// adjacency corresponds to a face neighbor</span>
<a name="l00170"></a>00170         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ms=0; ms&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); ms++)
<a name="l00171"></a>00171           {
<a name="l00172"></a>00172             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(ms);
<a name="l00173"></a>00173             
<a name="l00174"></a>00174             <span class="keywordflow">if</span> (neighbor != NULL)
<a name="l00175"></a>00175               {  
<a name="l00176"></a>00176                 <span class="comment">// If the neighbor is active treat it</span>
<a name="l00177"></a>00177                 <span class="comment">// as a connection</span>
<a name="l00178"></a>00178                 <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00179"></a>00179                   {
<a name="l00180"></a>00180                     libmesh_assert (global_index_map.count(neighbor));
<a name="l00181"></a>00181                     
<a name="l00182"></a>00182                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> neighbor_global_index = 
<a name="l00183"></a>00183                       global_index_map[neighbor];
<a name="l00184"></a>00184                     
<a name="l00185"></a>00185                     graph[elem_global_index].push_back(neighbor_global_index);
<a name="l00186"></a>00186                     graph_size++;
<a name="l00187"></a>00187                   }
<a name="l00188"></a>00188   
<a name="l00189"></a>00189 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00190"></a>00190 <span class="preprocessor"></span>                
<a name="l00191"></a>00191                 <span class="comment">// Otherwise we need to find all of the</span>
<a name="l00192"></a>00192                 <span class="comment">// neighbor&#39;s children that are connected to</span>
<a name="l00193"></a>00193                 <span class="comment">// us and add them</span>
<a name="l00194"></a>00194                 <span class="keywordflow">else</span>
<a name="l00195"></a>00195                   {
<a name="l00196"></a>00196                     <span class="comment">// The side of the neighbor to which</span>
<a name="l00197"></a>00197                     <span class="comment">// we are connected</span>
<a name="l00198"></a>00198                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns =
<a name="l00199"></a>00199                       neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a> (elem);
<a name="l00200"></a>00200                     libmesh_assert (ns &lt; neighbor-&gt;n_neighbors());
<a name="l00201"></a>00201                     
<a name="l00202"></a>00202                     <span class="comment">// Get all the active children (&amp; grandchildren, etc...)</span>
<a name="l00203"></a>00203                     <span class="comment">// of the neighbor.</span>
<a name="l00204"></a>00204                     neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a115d93be0231e3c0bacf45a6a4f1804d">active_family_tree</a> (neighbors_offspring);
<a name="l00205"></a>00205                     
<a name="l00206"></a>00206                     <span class="comment">// Get all the neighbor&#39;s children that</span>
<a name="l00207"></a>00207                     <span class="comment">// live on that side and are thus connected</span>
<a name="l00208"></a>00208                     <span class="comment">// to us</span>
<a name="l00209"></a>00209                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;neighbors_offspring.size(); nc++)
<a name="l00210"></a>00210                       {
<a name="l00211"></a>00211                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* child =
<a name="l00212"></a>00212                           neighbors_offspring[nc];
<a name="l00213"></a>00213                         
<a name="l00214"></a>00214                         <span class="comment">// This does not assume a level-1 mesh.</span>
<a name="l00215"></a>00215                         <span class="comment">// Note that since children have sides numbered</span>
<a name="l00216"></a>00216                         <span class="comment">// coincident with the parent then this is a sufficient test.</span>
<a name="l00217"></a>00217                         <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(ns) == elem)
<a name="l00218"></a>00218                           {
<a name="l00219"></a>00219                             libmesh_assert (child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00220"></a>00220                             libmesh_assert (global_index_map.count(child));
<a name="l00221"></a>00221 
<a name="l00222"></a>00222                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child_global_index =
<a name="l00223"></a>00223                               global_index_map[child];
<a name="l00224"></a>00224                             
<a name="l00225"></a>00225                             graph[elem_global_index].push_back(child_global_index);
<a name="l00226"></a>00226                             graph_size++;
<a name="l00227"></a>00227                           }
<a name="l00228"></a>00228                       }
<a name="l00229"></a>00229                   }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 <span class="preprocessor">#endif </span><span class="comment">/* ifdef LIBMESH_ENABLE_AMR */</span>
<a name="l00232"></a>00232 
<a name="l00233"></a>00233               }
<a name="l00234"></a>00234           }
<a name="l00235"></a>00235       }
<a name="l00236"></a>00236     
<a name="l00237"></a>00237     <span class="comment">// Convert the graph into the format Metis wants</span>
<a name="l00238"></a>00238     xadj.reserve(n_active_elem+1);
<a name="l00239"></a>00239     adjncy.reserve(graph_size);
<a name="l00240"></a>00240     
<a name="l00241"></a>00241     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r=0; r&lt;graph.size(); r++)
<a name="l00242"></a>00242       {
<a name="l00243"></a>00243         xadj.push_back(adjncy.size());
<a name="l00244"></a>00244         std::vector&lt;unsigned int&gt; graph_row; <span class="comment">// build this emtpy</span>
<a name="l00245"></a>00245         graph_row.swap(graph[r]); <span class="comment">// this will deallocate at the end of scope</span>
<a name="l00246"></a>00246         adjncy.insert(adjncy.end(),
<a name="l00247"></a>00247                       graph_row.begin(),
<a name="l00248"></a>00248                       graph_row.end());
<a name="l00249"></a>00249       }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251     <span class="comment">// The end of the adjacency array for the last elem</span>
<a name="l00252"></a>00252     xadj.push_back(adjncy.size());
<a name="l00253"></a>00253     
<a name="l00254"></a>00254     libmesh_assert (adjncy.size() == graph_size);
<a name="l00255"></a>00255     libmesh_assert (xadj.size() == n_active_elem+1);    
<a name="l00256"></a>00256   } <span class="comment">// done building the graph</span>
<a name="l00257"></a>00257   
<a name="l00258"></a>00258   
<a name="l00259"></a>00259   <span class="keywordflow">if</span> (adjncy.empty())
<a name="l00260"></a>00260     adjncy.push_back(0);
<a name="l00261"></a>00261   
<a name="l00262"></a>00262   <span class="comment">// Select which type of partitioning to create</span>
<a name="l00263"></a>00263   
<a name="l00264"></a>00264   <span class="comment">// Use recursive if the number of partitions is less than or equal to 8</span>
<a name="l00265"></a>00265   <span class="keywordflow">if</span> (n_pieces &lt;= 8)
<a name="l00266"></a>00266     Metis::METIS_PartGraphRecursive(&amp;n, &amp;xadj[0], &amp;adjncy[0], &amp;vwgt[0], NULL,
<a name="l00267"></a>00267                                     &amp;wgtflag, &amp;numflag, &amp;nparts, &amp;options[0],
<a name="l00268"></a>00268                                     &amp;edgecut, &amp;part[0]);
<a name="l00269"></a>00269   
<a name="l00270"></a>00270   <span class="comment">// Otherwise  use kway</span>
<a name="l00271"></a>00271   <span class="keywordflow">else</span>
<a name="l00272"></a>00272     Metis::METIS_PartGraphKway(&amp;n, &amp;xadj[0], &amp;adjncy[0], &amp;vwgt[0], NULL,
<a name="l00273"></a>00273                                &amp;wgtflag, &amp;numflag, &amp;nparts, &amp;options[0],
<a name="l00274"></a>00274                                &amp;edgecut, &amp;part[0]);
<a name="l00275"></a>00275   
<a name="l00276"></a>00276   
<a name="l00277"></a>00277   <span class="comment">// Assign the returned processor ids.  The part array contains</span>
<a name="l00278"></a>00278   <span class="comment">// the processor id for each active element, but in terms of</span>
<a name="l00279"></a>00279   <span class="comment">// the contiguous indexing we defined above</span>
<a name="l00280"></a>00280   {
<a name="l00281"></a>00281     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00282"></a>00282     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00283"></a>00283     
<a name="l00284"></a>00284     <span class="keywordflow">for</span> (; it!=end; ++it)
<a name="l00285"></a>00285       {
<a name="l00286"></a>00286         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00287"></a>00287         
<a name="l00288"></a>00288         libmesh_assert (global_index_map.count(elem));
<a name="l00289"></a>00289         
<a name="l00290"></a>00290         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_global_index = 
<a name="l00291"></a>00291           global_index_map[elem];
<a name="l00292"></a>00292         
<a name="l00293"></a>00293         libmesh_assert (elem_global_index &lt; part.size());
<a name="l00294"></a>00294         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_procid =  <span class="keyword">static_cast&lt;</span><span class="keywordtype">short</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(part[elem_global_index]);
<a name="l00295"></a>00295     
<a name="l00296"></a>00296         elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = elem_procid;
<a name="l00297"></a>00297       }
<a name="l00298"></a>00298   }
<a name="l00299"></a>00299 
<a name="l00300"></a>00300   STOP_LOG(<span class="stringliteral">&quot;partition()&quot;</span>, <span class="stringliteral">&quot;MetisPartitioner&quot;</span>);
<a name="l00301"></a>00301 <span class="preprocessor">#endif</span>
<a name="l00302"></a>00302 <span class="preprocessor"></span>}
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 } <span class="comment">// namespace libMesh</span>
<a name="l00305"></a>00305   
<a name="l00306"></a>00306 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
