<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_80224e50d3aebdc14135f96bcab47e92.php">partitioning</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">metis_partitioner.h</div>  </div>
</div>
<div class="contents">
<a href="metis__partitioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: metis_partitioner.h 4173 2011-01-19 22:50:51Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __metis_partitioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __metis_partitioner_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="partitioner_8h.php">partitioner.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00038"></a>00038 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// MetisPartitioner class definition</span>
<a name="l00040"></a><a class="code" href="classlibMesh_1_1MetisPartitioner.php">00040</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MetisPartitioner.php">MetisPartitioner</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Partitioner.php">Partitioner</a>
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042  <span class="keyword">public</span>:
<a name="l00043"></a>00043 
<a name="l00047"></a><a class="code" href="classlibMesh_1_1MetisPartitioner.php#af004a70070b7ec02967184024843a162">00047</a>   <a class="code" href="classlibMesh_1_1MetisPartitioner.php#af004a70070b7ec02967184024843a162">MetisPartitioner</a> () {}
<a name="l00048"></a>00048 
<a name="l00053"></a><a class="code" href="classlibMesh_1_1MetisPartitioner.php#af0315b42bbdb89f30d6f07adf0a61546">00053</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> <a class="code" href="classlibMesh_1_1MetisPartitioner.php#af0315b42bbdb89f30d6f07adf0a61546">clone</a> ()<span class="keyword"> const </span>{
<a name="l00054"></a>00054     <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> cloned_partitioner
<a name="l00055"></a>00055       (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1MetisPartitioner.php#af004a70070b7ec02967184024843a162">MetisPartitioner</a>());
<a name="l00056"></a>00056     <span class="keywordflow">return</span> cloned_partitioner;
<a name="l00057"></a>00057   }
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1MetisPartitioner.php#ac7dae566668fb6f595ac497684304db1">00059</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MetisPartitioner.php#ac7dae566668fb6f595ac497684304db1">attach_weights</a>(<a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> * weights) { <a class="code" href="classlibMesh_1_1Partitioner.php#a1701ba592caafda75ba383d04bf1a47e">_weights</a> = weights; }
<a name="l00060"></a>00060   
<a name="l00061"></a>00061 <span class="keyword">protected</span>:
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1MetisPartitioner.php#a57d911f4771afc7f55275fba1dffffa4">_do_partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00066"></a>00066                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00067"></a>00067 };
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 } <span class="comment">// namespace libMesh</span>
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="preprocessor">#endif // #define __sfc_partitioner_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
