<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="namespaces.php"><span>Namespace&#160;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespacelibMesh.php">libMesh</a>      </li>
      <li class="navelem"><a class="el" href="namespacelibMesh_1_1Parallel.php">Parallel</a>      </li>
      <li class="navelem"><a class="el" href="namespacelibMesh_1_1Parallel_1_1Utils.php">Utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a>  </div>
  <div class="headertitle">
<div class="title">libMesh::Parallel::Utils Namespace Reference</div>  </div>
</div>
<div class="contents">
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename KeyType &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">bool&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1Parallel_1_1Utils.php#ac14800536403260c2b92f49bb859e694">is_sorted</a> (const std::vector&lt; KeyType &gt; &amp;v)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename KeyType &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a2490ebac6962550ed7426f3fa879284d">to_double</a> (const KeyType &amp;k)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;typename KeyType &gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">KeyType&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1Parallel_1_1Utils.php#ac32fea0d432a27d36a1948c730bc8346">to_key_type</a> (const double f)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;&gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">double&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a1a55cf59f898b20621ad8e411f534f33">to_double</a> (const Hilbert::HilbertIndices &amp;bvt)</td></tr>
<tr><td class="memTemplParams" colspan="2">template&lt;&gt; </td></tr>
<tr><td class="memTemplItemLeft" align="right" valign="top">Hilbert::HilbertIndices&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a2d61fa9e4e775569e9a3a902175305a9">to_key_type</a> (const double f)</td></tr>
</table>
<hr/><h2>Function Documentation</h2>
<a class="anchor" id="ac14800536403260c2b92f49bb859e694"></a><!-- doxytag: member="libMesh::Parallel::Utils::is_sorted" ref="ac14800536403260c2b92f49bb859e694" args="(const std::vector&lt; KeyType &gt; &amp;v)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename KeyType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool libMesh::Parallel::Utils::is_sorted </td>
          <td>(</td>
          <td class="paramtype">const std::vector&lt; KeyType &gt; &amp;&#160;</td>
          <td class="paramname"><em>v</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p><a class="el" href="namespacelibMesh_1_1Utility.php">Utility</a> function that returns true if the vector v is sorted, false otherwise. O(N), the length of the vector. This is implemented solely because the std::is_sorted appears to be an STL extension. </p>

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00050">50</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>

<p>Referenced by <a class="el" href="parallel__bin__sorter_8C_source.php#l00042">libMesh::Parallel::BinSorter&lt; KeyType &gt;::BinSorter()</a>, and <a class="el" href="parallel__histogram_8C_source.php#l00039">libMesh::Parallel::Histogram&lt; KeyType &gt;::Histogram()</a>.</p>
<div class="fragment"><pre class="fragment">      {
        <span class="keywordflow">if</span> (v.empty())
          <span class="keywordflow">return</span> <span class="keyword">true</span>;

        <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;v.size(); i++)
          <span class="keywordflow">if</span> (v[i] &lt; v[i-1])
            <span class="keywordflow">return</span> <span class="keyword">false</span>;

        <span class="keywordflow">return</span> <span class="keyword">true</span>;    
      }
</pre></div>
</div>
</div>
<a class="anchor" id="a2490ebac6962550ed7426f3fa879284d"></a><!-- doxytag: member="libMesh::Parallel::Utils::to_double" ref="a2490ebac6962550ed7426f3fa879284d" args="(const KeyType &amp;k)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename KeyType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">double libMesh::Parallel::Utils::to_double </td>
          <td>(</td>
          <td class="paramtype">const KeyType &amp;&#160;</td>
          <td class="paramname"><em>k</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>A utility function which converts whatever <code>KeyType</code> is to a <code>double</code> for the histogram bounds </p>

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00068">68</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>

<p>Referenced by <a class="el" href="parallel__bin__sorter_8C_source.php#l00057">libMesh::Parallel::BinSorter&lt; KeyType &gt;::binsort()</a>, and <a class="el" href="parallel__histogram_8C_source.php#l00048">libMesh::Parallel::Histogram&lt; KeyType &gt;::make_histogram()</a>.</p>
<div class="fragment"><pre class="fragment">      {
        <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(k);
      }
</pre></div>
</div>
</div>
<a class="anchor" id="a1a55cf59f898b20621ad8e411f534f33"></a><!-- doxytag: member="libMesh::Parallel::Utils::to_double" ref="a1a55cf59f898b20621ad8e411f534f33" args="(const Hilbert::HilbertIndices &amp;bvt)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">double libMesh::Parallel::Utils::to_double </td>
          <td>(</td>
          <td class="paramtype">const Hilbert::HilbertIndices &amp;&#160;</td>
          <td class="paramname"><em>bvt</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00090">90</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>
<div class="fragment"><pre class="fragment">      {
        <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(bvt.rack2);
      }
</pre></div>
</div>
</div>
<a class="anchor" id="ac32fea0d432a27d36a1948c730bc8346"></a><!-- doxytag: member="libMesh::Parallel::Utils::to_key_type" ref="ac32fea0d432a27d36a1948c730bc8346" args="(const double f)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename KeyType &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">KeyType libMesh::Parallel::Utils::to_key_type </td>
          <td>(</td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>f</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>A utility to convert a <code>double</code> to some sort of <code>KeyType</code>, for interpreting how histogram bounds relate to <code>KeyType</code> positions. </p>

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00081">81</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>
<div class="fragment"><pre class="fragment">      {
        <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>KeyType<span class="keyword">&gt;</span>(f);
      }
</pre></div>
</div>
</div>
<a class="anchor" id="a2d61fa9e4e775569e9a3a902175305a9"></a><!-- doxytag: member="libMesh::Parallel::Utils::to_key_type" ref="a2d61fa9e4e775569e9a3a902175305a9" args="(const double f)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;&gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">Hilbert::HilbertIndices libMesh::Parallel::Utils::to_key_type </td>
          <td>(</td>
          <td class="paramtype">const double&#160;</td>
          <td class="paramname"><em>f</em></td><td>)</td>
          <td><code> [inline]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="parallel__conversion__utils_8h_source.php#l00098">98</a> of file <a class="el" href="parallel__conversion__utils_8h_source.php">parallel_conversion_utils.h</a>.</p>
<div class="fragment"><pre class="fragment">      {
        Hilbert::HilbertIndices bvt;

        bvt.rack0 = 0;
        bvt.rack1 = 0;
        bvt.rack2 = <span class="keyword">static_cast&lt;</span>Hilbert::inttype<span class="keyword">&gt;</span>(f);

        <span class="keywordflow">return</span> bvt;
      }
</pre></div>
</div>
</div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
