<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li class="current"><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="namespaces.php"><span>Namespace&#160;List</span></a></li>
      <li><a href="namespacemembers.php"><span>Namespace&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespacelibMesh.php">libMesh</a>      </li>
      <li class="navelem"><a class="el" href="namespacelibMesh_1_1QuadratureRules.php">QuadratureRules</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#func-members">Functions</a> &#124;
<a href="#var-members">Variables</a>  </div>
  <div class="headertitle">
<div class="title">libMesh::QuadratureRules Namespace Reference</div>  </div>
</div>
<div class="contents">
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="func-members"></a>
Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">std::string&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1QuadratureRules.php#a312145f81bfe86d687e7f545e315ef66">name</a> (const QuadratureType t)</td></tr>
<tr><td colspan="2"><h2><a name="var-members"></a>
Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1QuadratureRules.php#a98f56a764f2fac18a45fed7500b1bf5f">num_rules</a> = 5</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const QuadratureType&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1QuadratureRules.php#a396274f98e0b365ae4a5a8a0e4dc08c0">valid_elem_rules</a> []</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">const unsigned int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="namespacelibMesh_1_1QuadratureRules.php#ac88b2c1b5a9dccfb55e7581fd551024b">num_valid_elem_rules</a> = 3</td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>A namespace for utility functions for quadrature rules. </p>
</div><hr/><h2>Function Documentation</h2>
<a class="anchor" id="a312145f81bfe86d687e7f545e315ef66"></a><!-- doxytag: member="libMesh::QuadratureRules::name" ref="a312145f81bfe86d687e7f545e315ef66" args="(const QuadratureType t)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">std::string libMesh::QuadratureRules::name </td>
          <td>(</td>
          <td class="paramtype">const QuadratureType&#160;</td>
          <td class="paramname"><em>t</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Returns a standard string representation for the specific quadrature rule. </p>

<p>Definition at line <a class="el" href="quadrature__rules_8C_source.php#l00033">33</a> of file <a class="el" href="quadrature__rules_8C_source.php">quadrature_rules.C</a>.</p>

<p>References <a class="el" href="libmesh__common_8h_source.php#l00227">libMesh::err</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00032">libMeshEnums::QGAUSS</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00034">libMeshEnums::QJACOBI_1_0</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00035">libMeshEnums::QJACOBI_2_0</a>, <a class="el" href="enum__quadrature__type_8h_source.php#l00037">libMeshEnums::QSIMPSON</a>, and <a class="el" href="enum__quadrature__type_8h_source.php#l00038">libMeshEnums::QTRAP</a>.</p>
<div class="fragment"><pre class="fragment">{
  std::string its_name;
  
  <span class="keywordflow">switch</span> (q)
    {
      
    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada11bd5a126c073e475e588e38016b3785">QGAUSS</a>:
      its_name = <span class="stringliteral">&quot;Gauss-Legendre Quadrature&quot;</span>;
      <span class="keywordflow">break</span>;

    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adad3a339e15685559999115b81f6d38370">QJACOBI_1_0</a>:
      its_name = <span class="stringliteral">&quot;Jacobi(1,0)-Gauss Quadrature&quot;</span>;
      <span class="keywordflow">break</span>;

    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada52629eed7dec8b36fbd387b3dd51d48d">QJACOBI_2_0</a>:
      its_name = <span class="stringliteral">&quot;Jacobi(2,0)-Gauss Quadrature&quot;</span>;
      <span class="keywordflow">break</span>;

    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adaeb07c05dac20ab7f134838e34f9db0c1">QSIMPSON</a>:
      its_name = <span class="stringliteral">&quot;Simpson Rule&quot;</span>;
      <span class="keywordflow">break</span>;

    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada26431abeff146407680a87ae0dd3a39a">QTRAP</a>:
      its_name = <span class="stringliteral">&quot;Trapezoidal Rule&quot;</span>;
      <span class="keywordflow">break</span>;


    <span class="keywordflow">default</span>:
      { 
        <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad qt=&quot;</span> &lt;&lt; q &lt;&lt; std::endl;
        libmesh_error();
      }
    }
  
  <span class="keywordflow">return</span> its_name;
}
</pre></div>
</div>
</div>
<hr/><h2>Variable Documentation</h2>
<a class="anchor" id="a98f56a764f2fac18a45fed7500b1bf5f"></a><!-- doxytag: member="libMesh::QuadratureRules::num_rules" ref="a98f56a764f2fac18a45fed7500b1bf5f" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const unsigned int <a class="el" href="namespacelibMesh_1_1QuadratureRules.php#a98f56a764f2fac18a45fed7500b1bf5f">libMesh::QuadratureRules::num_rules</a> = 5</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The number of quadrature rules that are defined (INVALD_Q_RULE excluded). You might have to update this if you add a new one! </p>

<p>Definition at line <a class="el" href="quadrature__rules_8h_source.php#l00048">48</a> of file <a class="el" href="quadrature__rules_8h_source.php">quadrature_rules.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac88b2c1b5a9dccfb55e7581fd551024b"></a><!-- doxytag: member="libMesh::QuadratureRules::num_valid_elem_rules" ref="ac88b2c1b5a9dccfb55e7581fd551024b" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const unsigned int <a class="el" href="namespacelibMesh_1_1QuadratureRules.php#ac88b2c1b5a9dccfb55e7581fd551024b">libMesh::QuadratureRules::num_valid_elem_rules</a> = 3</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>The number of valid quadrature rules for numerical integration over geometric entities. </p>

<p>Definition at line <a class="el" href="quadrature__rules_8h_source.php#l00063">63</a> of file <a class="el" href="quadrature__rules_8h_source.php">quadrature_rules.h</a>.</p>

</div>
</div>
<a class="anchor" id="a396274f98e0b365ae4a5a8a0e4dc08c0"></a><!-- doxytag: member="libMesh::QuadratureRules::valid_elem_rules" ref="a396274f98e0b365ae4a5a8a0e4dc08c0" args="[]" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">const QuadratureType <a class="el" href="namespacelibMesh_1_1QuadratureRules.php#a396274f98e0b365ae4a5a8a0e4dc08c0">libMesh::QuadratureRules::valid_elem_rules</a>[]</td>
        </tr>
      </table>
</div>
<div class="memdoc">
<b>Initial value:</b><div class="fragment"><pre class="fragment"> {<a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada11bd5a126c073e475e588e38016b3785">QGAUSS</a>,
                                             <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adaeb07c05dac20ab7f134838e34f9db0c1">QSIMPSON</a>,
                                             <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada26431abeff146407680a87ae0dd3a39a">QTRAP</a>}
</pre></div><p>The types of quadrature rules that may be used for numerical integration over geometric entities. </p>

<p>Definition at line <a class="el" href="quadrature__rules_8h_source.php#l00055">55</a> of file <a class="el" href="quadrature__rules_8h_source.php">quadrature_rules.h</a>.</p>

</div>
</div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
