<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">nemesis_io.C</div>  </div>
</div>
<div class="contents">
<a href="nemesis__io_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nemesis_io.C 4361 2011-04-19 13:35:57Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;numeric&gt;</span> <span class="comment">// std::accumulate</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// LibMesh includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="exodusII__io_8h.php">exodusII_io.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="nemesis__io_8h.php">nemesis_io.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="nemesis__io__helper_8h.php">nemesis_io_helper.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="node_8h.php">node.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span> <span class="comment">// is_sorted, deallocate</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00035"></a>00035  
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">//-----------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// anonymous namespace for implementation details</span>
<a name="l00042"></a>00042 <span class="keyword">namespace </span>{
<a name="l00043"></a>00043   <span class="keyword">struct </span>CompareGlobalIdxMappings
<a name="l00044"></a>00044   {
<a name="l00045"></a>00045     <span class="comment">// strict weak ordering for a.first -&gt; a.second mapping.  since we can only map to one</span>
<a name="l00046"></a>00046     <span class="comment">// value only order the first entry</span>
<a name="l00047"></a>00047     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;a,
<a name="l00048"></a>00048                     <span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;b)<span class="keyword"> const </span>
<a name="l00049"></a>00049 <span class="keyword">    </span>{ <span class="keywordflow">return</span> a.first &lt; b.first; }
<a name="l00050"></a>00050     
<a name="l00051"></a>00051     <span class="comment">// strict weak ordering for a.first -&gt; a.second mapping.  lookups will</span>
<a name="l00052"></a>00052     <span class="comment">// be in terms of a single integer, which is why we need this method.</span>
<a name="l00053"></a>00053     <span class="keywordtype">bool</span> operator()(<span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;a,
<a name="l00054"></a>00054                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b)<span class="keyword"> const </span>
<a name="l00055"></a>00055 <span class="keyword">    </span>{ <span class="keywordflow">return</span> a.first &lt; b; }
<a name="l00056"></a>00056   };
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="comment">// Nemesis &amp; ExodusII use int for all integer values, even the ones which </span>
<a name="l00059"></a>00059   <span class="comment">// should never be negative.  we like to use unsigned as a force of habit,</span>
<a name="l00060"></a>00060   <span class="comment">// this trivial little method saves some typing &amp; also makes sure something</span>
<a name="l00061"></a>00061   <span class="comment">// is not horribly wrong.</span>
<a name="l00062"></a>00062   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00063"></a>00063   <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> to_uint ( <span class="keyword">const</span> T &amp;t ) 
<a name="l00064"></a>00064   {
<a name="l00065"></a>00065     libmesh_assert (t == static_cast&lt;T&gt;(static_cast&lt;unsigned int&gt;(t)));
<a name="l00066"></a>00066 
<a name="l00067"></a>00067     <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(t); 
<a name="l00068"></a>00068   }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// test equality for a.first -&gt; a.second mapping.  since we can only map to one</span>
<a name="l00071"></a>00071   <span class="comment">// value only test the first entry</span>
<a name="l00072"></a>00072   <span class="keyword">inline</span> <span class="keywordtype">bool</span> global_idx_mapping_equality (<span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;a,
<a name="l00073"></a>00073                                            <span class="keyword">const</span> std::pair&lt;unsigned int, unsigned int&gt; &amp;b)
<a name="l00074"></a>00074   { <span class="keywordflow">return</span> a.first == b.first; }
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 
<a name="l00079"></a>00079 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00080"></a>00080 <span class="comment">// Nemesis_IO class members</span>
<a name="l00081"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#af3b8bd661b51a9ae2ab5dc32a3751da2">00081</a> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#af3b8bd661b51a9ae2ab5dc32a3751da2">Nemesis_IO::Nemesis_IO</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>) :
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&gt; (mesh, <span class="comment">/*is_parallel_format=*/</span>true),
<a name="l00083"></a>00083   <span class="comment">//MeshOutput&lt;ParallelMesh&gt; (mesh, /*is_parallel_format=*/true)</span>
<a name="l00084"></a>00084 #if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)
<a name="l00085"></a>00085   nemhelper(new <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php">Nemesis_IO_Helper</a>),
<a name="l00086"></a>00086 #endif
<a name="l00087"></a>00087   _verbose (false)
<a name="l00088"></a>00088 {
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#a30ad9757ce1d0b41e213c0366fc11a8c">00092</a> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a30ad9757ce1d0b41e213c0366fc11a8c">Nemesis_IO::~Nemesis_IO</a> ()
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094 <span class="preprocessor">#if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)</span>
<a name="l00095"></a>00095 <span class="preprocessor"></span>  <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>;
<a name="l00096"></a>00096 <span class="preprocessor">#endif</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span>}
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#a530d8f40acc55b2cb98b0e440e8dc40a">00101</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a530d8f40acc55b2cb98b0e440e8dc40a">Nemesis_IO::verbose</a> (<span class="keywordtype">bool</span> set_verbosity)
<a name="l00102"></a>00102 {
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a> = set_verbosity;
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 <span class="preprocessor">#if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span>  <span class="comment">// Set the verbose flag in the helper object</span>
<a name="l00107"></a>00107   <span class="comment">// as well.</span>
<a name="l00108"></a>00108   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0a486e1d944ba2dcea784255c5652499">verbose</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>);
<a name="l00109"></a>00109 <span class="preprocessor">#endif</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>}
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 <span class="preprocessor">#if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)</span>
<a name="l00115"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#a976d74c57a65812c355af28c55b6e8f5">00115</a> <span class="preprocessor"></span><span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a976d74c57a65812c355af28c55b6e8f5">Nemesis_IO::read</a> (<span class="keyword">const</span> std::string&amp; base_filename)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   <span class="comment">// On one processor, Nemesis and ExodusII should be equivalent, so</span>
<a name="l00118"></a>00118   <span class="comment">// let&#39;s cowardly defer to that implementation...</span>
<a name="l00119"></a>00119   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00120"></a>00120     {                   
<a name="l00121"></a>00121       <span class="comment">// We can do this in one line but if the verbose flag was set in this</span>
<a name="l00122"></a>00122       <span class="comment">// object, it will no longer be set... thus no extra print-outs for serial runs.</span>
<a name="l00123"></a>00123       <a class="code" href="classlibMesh_1_1ExodusII__IO.php">ExodusII_IO</a>(this-&gt;<a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a>()).<a class="code" href="classlibMesh_1_1ExodusII__IO.php#a5c8740e7197ba48ac0cd7d91d753f0f1">read</a> (base_filename);
<a name="l00124"></a>00124       <span class="keywordflow">return</span>;
<a name="l00125"></a>00125     }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127   START_LOG (<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;Nemesis_IO&quot;</span>);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00130"></a>00130   parallel_only();
<a name="l00131"></a>00131   
<a name="l00132"></a>00132   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00133"></a>00133     {
<a name="l00134"></a>00134       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00135"></a>00135       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading Nemesis file on processor: &quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; std::endl;
<a name="l00136"></a>00136     }
<a name="l00137"></a>00137   
<a name="l00138"></a>00138   <span class="comment">// Construct a filename string for this processor.</span>
<a name="l00139"></a>00139   <span class="comment">//</span>
<a name="l00140"></a>00140   <span class="comment">// TODO: This assumes you are reading in a mesh on exactly the</span>
<a name="l00141"></a>00141   <span class="comment">// same number of processors it was written out on!!</span>
<a name="l00142"></a>00142   <span class="comment">// This should be generalized at some point...</span>
<a name="l00143"></a>00143   std::ostringstream file_oss;
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   <span class="comment">// We have to be a little careful here: Nemesis left pads its file</span>
<a name="l00146"></a>00146   <span class="comment">// numbers based on the largest processor ID, so for example on 128</span>
<a name="l00147"></a>00147   <span class="comment">// processors, we&#39;d have:</span>
<a name="l00148"></a>00148   <span class="comment">// mesh.e.128.001</span>
<a name="l00149"></a>00149   <span class="comment">// mesh.e.128.002</span>
<a name="l00150"></a>00150   <span class="comment">// ...</span>
<a name="l00151"></a>00151   <span class="comment">// mesh.e.128.099</span>
<a name="l00152"></a>00152   <span class="comment">// mesh.e.128.100</span>
<a name="l00153"></a>00153   <span class="comment">// ...</span>
<a name="l00154"></a>00154   <span class="comment">// mesh.e.128.127</span>
<a name="l00155"></a>00155 
<a name="l00156"></a>00156   <span class="comment">// Find the length of the highest processor ID </span>
<a name="l00157"></a>00157   file_oss &lt;&lt; (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()-1);
<a name="l00158"></a>00158   <span class="keywordtype">unsigned</span> field_width = file_oss.str().size();
<a name="l00159"></a>00159   
<a name="l00160"></a>00160   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00161"></a>00161     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;field_width=&quot;</span> &lt;&lt; field_width &lt;&lt; std::endl;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   file_oss.str(<span class="stringliteral">&quot;&quot;</span>); <span class="comment">// reset the string stream</span>
<a name="l00164"></a>00164   file_oss &lt;&lt; base_filename  
<a name="l00165"></a>00165            &lt;&lt; <span class="charliteral">&#39;.&#39;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() 
<a name="l00166"></a>00166            &lt;&lt; <span class="charliteral">&#39;.&#39;</span> &lt;&lt; std::setfill(<span class="charliteral">&#39;0&#39;</span>) &lt;&lt; std::setw(field_width) &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00169"></a>00169     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Opening file: &quot;</span> &lt;&lt; file_oss.str() &lt;&lt; std::endl;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <span class="comment">// Open the Exodus file</span>
<a name="l00172"></a>00172   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9bf6deacca92641b0d30d7749a06b887">open</a>(file_oss.str().c_str());
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="comment">// Get a reference to the ParallelMesh.  </span>
<a name="l00175"></a>00175   <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a> = this-&gt;<a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a>();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// Local information: Read the following information from the standard Exodus header</span>
<a name="l00178"></a>00178   <span class="comment">//  title[0]</span>
<a name="l00179"></a>00179   <span class="comment">//  num_dim</span>
<a name="l00180"></a>00180   <span class="comment">//  num_nodes</span>
<a name="l00181"></a>00181   <span class="comment">//  num_elem</span>
<a name="l00182"></a>00182   <span class="comment">//  num_elem_blk</span>
<a name="l00183"></a>00183   <span class="comment">//  num_node_sets</span>
<a name="l00184"></a>00184   <span class="comment">//  num_side_sets</span>
<a name="l00185"></a>00185   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad33f14d5154d71c0bf8339e44b801997">read_header</a>();
<a name="l00186"></a>00186   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aa57b23eb3af94898729cb25919b3123c">print_header</a>();
<a name="l00187"></a>00187   
<a name="l00188"></a>00188   <span class="comment">// Get global information: number of nodes, elems, blocks, nodesets and sidesets</span>
<a name="l00189"></a>00189   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a58f32d4bd0357125c5a22778fb59650f">get_init_global</a>();
<a name="l00190"></a>00190   
<a name="l00191"></a>00191   <span class="comment">// Get &quot;load balance&quot; information.  This includes the number of internal &amp; border</span>
<a name="l00192"></a>00192   <span class="comment">// nodes and elements as well as the number of communication maps.</span>
<a name="l00193"></a>00193   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae9d2c643dac85d53e610e5d2e8224a6f">get_loadbal_param</a>();
<a name="l00194"></a>00194   
<a name="l00195"></a>00195   <span class="comment">// Do some error checking</span>
<a name="l00196"></a>00196   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">num_external_nodes</a>)
<a name="l00197"></a>00197     {
<a name="l00198"></a>00198       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: there should be no external nodes in an element-based partitioning!&quot;</span>
<a name="l00199"></a>00199                     &lt;&lt; std::endl;
<a name="l00200"></a>00200       libmesh_error();
<a name="l00201"></a>00201     }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   libmesh_assert (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a> ==
<a name="l00204"></a>00204                   (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a> + 
<a name="l00205"></a>00205                    <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>));
<a name="l00206"></a>00206   
<a name="l00207"></a>00207   libmesh_assert (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a> ==
<a name="l00208"></a>00208                   (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">num_internal_elems</a> +
<a name="l00209"></a>00209                    <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">num_border_elems</a>));
<a name="l00210"></a>00210   
<a name="l00211"></a>00211   libmesh_assert (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a> &lt;= <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">num_nodes_global</a>);
<a name="l00212"></a>00212   libmesh_assert (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>  &lt;= <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a428c62b9b28577fb377d085b6cf3fbf3">num_elems_global</a>);
<a name="l00213"></a>00213       
<a name="l00214"></a>00214   <span class="comment">// Read nodes from the exodus file: this fills the nemhelper-&gt;x,y,z arrays.</span>
<a name="l00215"></a>00215   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6442ae2187f05185649d88efef41c000">read_nodes</a>();
<a name="l00216"></a>00216 
<a name="l00217"></a>00217   <span class="comment">// Reads the nemhelper-&gt;node_num_map array, node_num_map[i] is the global node number for</span>
<a name="l00218"></a>00218   <span class="comment">// local node number i.</span>
<a name="l00219"></a>00219   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a18cb4af65d380ec6197cceca28f755ab">read_node_num_map</a>();
<a name="l00220"></a>00220   
<a name="l00221"></a>00221   <span class="comment">// The get_cmap_params() function reads in the:</span>
<a name="l00222"></a>00222   <span class="comment">//  node_cmap_ids[],</span>
<a name="l00223"></a>00223   <span class="comment">//  node_cmap_node_cnts[],</span>
<a name="l00224"></a>00224   <span class="comment">//  elem_cmap_ids[],</span>
<a name="l00225"></a>00225   <span class="comment">//  elem_cmap_elem_cnts[],</span>
<a name="l00226"></a>00226   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a653b6229679c6fa0f56952523b3b8302">get_cmap_params</a>();
<a name="l00227"></a>00227   
<a name="l00228"></a>00228   <span class="comment">// Read the IDs of the interior, boundary, and external nodes.  This function</span>
<a name="l00229"></a>00229   <span class="comment">// fills the vectors:</span>
<a name="l00230"></a>00230   <span class="comment">//  node_mapi[],</span>
<a name="l00231"></a>00231   <span class="comment">//  node_mapb[],</span>
<a name="l00232"></a>00232   <span class="comment">//  node_mape[]</span>
<a name="l00233"></a>00233   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1d46473b4a62c8d11fc6beda0e3215f5">get_node_map</a>();
<a name="l00234"></a>00234   
<a name="l00235"></a>00235   <span class="comment">// Read each node communication map for this processor.  This function</span>
<a name="l00236"></a>00236   <span class="comment">// fills the vectors of vectors named:</span>
<a name="l00237"></a>00237   <span class="comment">//  node_cmap_node_ids[][]</span>
<a name="l00238"></a>00238   <span class="comment">//  node_cmap_proc_ids[][]</span>
<a name="l00239"></a>00239   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a40274c2f13482adf02eeb441dfc298ab">get_node_cmap</a>();
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>) == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>.size());
<a name="l00242"></a>00242   libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>) == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>.size());
<a name="l00243"></a>00243   libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>) == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>.size());
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00246"></a>00246 <span class="preprocessor"></span>  <span class="comment">// We expect the communication maps to be symmetric - e.g. if processor i thinks it</span>
<a name="l00247"></a>00247   <span class="comment">// communicates with processor j, then processor j should also be expecting to</span>
<a name="l00248"></a>00248   <span class="comment">// communicate with i.  We can assert that here easily enough with an alltoall,</span>
<a name="l00249"></a>00249   <span class="comment">// but let&#39;s only do it when not in optimized mode to limit unnecessary communication.</span>
<a name="l00250"></a>00250   {
<a name="l00251"></a>00251     std::vector&lt;unsigned char&gt; pid_send_partener (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253     <span class="comment">// strictly speaking, we should expect to communicate with ourself...</span>
<a name="l00254"></a>00254     pid_send_partener[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] = 1;
<a name="l00255"></a>00255     
<a name="l00256"></a>00256     <span class="comment">// mark each processor id we reference with a node cmap </span>
<a name="l00257"></a>00257     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap=0; cmap&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); cmap++)
<a name="l00258"></a>00258       {
<a name="l00259"></a>00259         libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap]) &lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00260"></a>00260 
<a name="l00261"></a>00261         pid_send_partener[<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap]] = 1;
<a name="l00262"></a>00262       }
<a name="l00263"></a>00263 
<a name="l00264"></a>00264     <span class="comment">// Copy the send pairing so we can catch the receive paring and</span>
<a name="l00265"></a>00265     <span class="comment">// test for equality</span>
<a name="l00266"></a>00266     <span class="keyword">const</span> std::vector&lt;unsigned char&gt; pid_recv_partener (pid_send_partener);
<a name="l00267"></a>00267     
<a name="l00268"></a>00268     <a class="code" href="namespacelibMesh_1_1Parallel.php#ac132fe4daa7fdd6fb4cd5a18fbae3771">Parallel::alltoall</a> (pid_send_partener);
<a name="l00269"></a>00269 
<a name="l00270"></a>00270     libmesh_assert (pid_send_partener == pid_recv_partener);
<a name="l00271"></a>00271   }
<a name="l00272"></a>00272 <span class="preprocessor">#endif</span>
<a name="l00273"></a>00273 <span class="preprocessor"></span>  
<a name="l00274"></a>00274   <span class="comment">// We now have enough information to infer node ownership.  We start by assuming</span>
<a name="l00275"></a>00275   <span class="comment">// we own all the nodes on this processor.  We will then interrogate the </span>
<a name="l00276"></a>00276   <span class="comment">// node cmaps and see if a lower-rank processor is associated with any of</span>
<a name="l00277"></a>00277   <span class="comment">// our nodes.  If so, then that processor owns the node, not us...</span>
<a name="l00278"></a>00278   std::vector&lt;unsigned short int&gt; node_ownership (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a> +
<a name="l00279"></a>00279                                                   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>,
<a name="l00280"></a>00280                                                   libMesh::processor_id());
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   <span class="comment">// a map from processor id to cmap number, to be used later</span>
<a name="l00283"></a>00283   std::map&lt;unsigned int, unsigned int&gt; pid_to_cmap_map;
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="comment">// For each node_cmap...</span>
<a name="l00286"></a>00286   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap=0; cmap&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); cmap++)
<a name="l00287"></a>00287     {
<a name="l00288"></a>00288       <span class="comment">// Good time for error checking...</span>
<a name="l00289"></a>00289       libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]) ==
<a name="l00290"></a>00290                       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap].size());
<a name="l00291"></a>00291       
<a name="l00292"></a>00292       libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]) ==
<a name="l00293"></a>00293                       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>[cmap].size());
<a name="l00294"></a>00294       
<a name="l00295"></a>00295       <span class="comment">// In all the samples I have seen, node_cmap_ids[cmap] is the processor</span>
<a name="l00296"></a>00296       <span class="comment">// rank of the remote processor...</span>
<a name="l00297"></a>00297       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> adjcnt_pid_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap];
<a name="l00298"></a>00298 
<a name="l00299"></a>00299       libmesh_assert (adjcnt_pid_idx &lt;  <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00300"></a>00300       libmesh_assert (adjcnt_pid_idx != libMesh::processor_id());
<a name="l00301"></a>00301       
<a name="l00302"></a>00302       <span class="comment">// We only expect one cmap per adjacent processor</span>
<a name="l00303"></a>00303       libmesh_assert (!pid_to_cmap_map.count(adjcnt_pid_idx));
<a name="l00304"></a>00304                                                 
<a name="l00305"></a>00305       pid_to_cmap_map[adjcnt_pid_idx] = cmap;
<a name="l00306"></a>00306 
<a name="l00307"></a>00307       <span class="comment">// ...and each node in that cmap...</span>
<a name="l00308"></a>00308       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>++)
<a name="l00309"></a>00309         {
<a name="l00310"></a>00310           <span class="comment">//  Are the node_cmap_ids and node_cmap_proc_ids really redundant?</span>
<a name="l00311"></a>00311           libmesh_assert (adjcnt_pid_idx == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>[cmap][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>]);
<a name="l00312"></a>00312           
<a name="l00313"></a>00313           <span class="comment">// we are expecting the exodus node numbering to be 1-based...</span>
<a name="l00314"></a>00314           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>]-1;
<a name="l00315"></a>00315 
<a name="l00316"></a>00316           libmesh_assert (local_node_idx &lt; node_ownership.size());
<a name="l00317"></a>00317           
<a name="l00318"></a>00318           <span class="comment">// if the adjacent processor is lower rank than the current</span>
<a name="l00319"></a>00319           <span class="comment">// owner for this node, then it will get the node...</span>
<a name="l00320"></a>00320           node_ownership[local_node_idx] = 
<a name="l00321"></a>00321             <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(node_ownership[local_node_idx], adjcnt_pid_idx);
<a name="l00322"></a>00322         }
<a name="l00323"></a>00323     } <span class="comment">// We now should have established proper node ownership.</span>
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   <span class="comment">// now that ownership is established, we can figure out how many nodes we </span>
<a name="l00326"></a>00326   <span class="comment">// will be responsible for numbering.</span>
<a name="l00327"></a>00327   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num_nodes_i_must_number = 0;
<a name="l00328"></a>00328 
<a name="l00329"></a>00329   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;node_ownership.size(); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>++)
<a name="l00330"></a>00330     <span class="keywordflow">if</span> (node_ownership[<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>] == libMesh::processor_id())
<a name="l00331"></a>00331       num_nodes_i_must_number++;
<a name="l00332"></a>00332 
<a name="l00333"></a>00333   <span class="comment">// more error checking...</span>
<a name="l00334"></a>00334   libmesh_assert (num_nodes_i_must_number &gt;= to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a>));
<a name="l00335"></a>00335   libmesh_assert (num_nodes_i_must_number &lt;= to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a> +
<a name="l00336"></a>00336                                                   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>));
<a name="l00337"></a>00337   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00338"></a>00338     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00339"></a>00339                   &lt;&lt; <span class="stringliteral">&quot;num_nodes_i_must_number=&quot;</span>
<a name="l00340"></a>00340                   &lt;&lt; num_nodes_i_must_number
<a name="l00341"></a>00341                   &lt;&lt; std::endl;
<a name="l00342"></a>00342   
<a name="l00343"></a>00343   <span class="comment">// The call to get_loadbal_param() gets 7 pieces of information.  We allgather</span>
<a name="l00344"></a>00344   <span class="comment">// these now across all processors to determine some global numberings. We should</span>
<a name="l00345"></a>00345   <span class="comment">// also gather the number of nodes each processor thinks it will number so that</span>
<a name="l00346"></a>00346   <span class="comment">// we can (i) determine our offset, and (ii) do some error checking.</span>
<a name="l00347"></a>00347   std::vector&lt;int&gt; all_loadbal_data ( 8 );
<a name="l00348"></a>00348   all_loadbal_data[0] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a>;
<a name="l00349"></a>00349   all_loadbal_data[1] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>;
<a name="l00350"></a>00350   all_loadbal_data[2] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">num_external_nodes</a>;
<a name="l00351"></a>00351   all_loadbal_data[3] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">num_internal_elems</a>;
<a name="l00352"></a>00352   all_loadbal_data[4] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">num_border_elems</a>;
<a name="l00353"></a>00353   all_loadbal_data[5] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>;
<a name="l00354"></a>00354   all_loadbal_data[6] = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a>;
<a name="l00355"></a>00355   all_loadbal_data[7] = num_nodes_i_must_number;
<a name="l00356"></a>00356   
<a name="l00357"></a>00357   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a> (all_loadbal_data, <span class="comment">/* identical_buffer_sizes = */</span> <span class="keyword">true</span>);
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   <span class="comment">// OK, we are now in a position to request new global indices for all the nodes</span>
<a name="l00360"></a>00360   <span class="comment">// we do not own</span>
<a name="l00361"></a>00361 
<a name="l00362"></a>00362   <span class="comment">// Let&#39;s get a unique message tag to use for send()/receive()</span>
<a name="l00363"></a>00363   <a class="code" href="classlibMesh_1_1Parallel_1_1MessageTag.php">Parallel::MessageTag</a> nodes_tag = <a class="code" href="namespacelibMesh_1_1Parallel.php#a0177ff6d177a879cc6d29e2f95694c91">Parallel::Communicator_World</a>.get_unique_tag(12345);
<a name="l00364"></a>00364 
<a name="l00365"></a>00365   std::vector&lt;std::vector&lt;int&gt; &gt; 
<a name="l00366"></a>00366     needed_node_idxs (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); <span class="comment">// the indices we will ask for</span>
<a name="l00367"></a>00367     
<a name="l00368"></a>00368   std::vector&lt;Parallel::Request&gt; 
<a name="l00369"></a>00369     needed_nodes_requests (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>);
<a name="l00370"></a>00370   
<a name="l00371"></a>00371   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap=0; cmap&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); cmap++)
<a name="l00372"></a>00372     {
<a name="l00373"></a>00373       <span class="comment">// We know we will need no more indices than there are nodes</span>
<a name="l00374"></a>00374       <span class="comment">// in this cmap, but that number is an upper bound in general</span>
<a name="l00375"></a>00375       <span class="comment">// since the neighboring processor associated with the cmap</span>
<a name="l00376"></a>00376       <span class="comment">//  may not actually own it</span>
<a name="l00377"></a>00377       needed_node_idxs[cmap].reserve   (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]);
<a name="l00378"></a>00378             
<a name="l00379"></a>00379       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> adjcnt_pid_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap];
<a name="l00380"></a>00380 
<a name="l00381"></a>00381       <span class="comment">// ...and each node in that cmap...</span>
<a name="l00382"></a>00382       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>=0; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[cmap]); <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>++)
<a name="l00383"></a>00383         {
<a name="l00384"></a>00384           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00385"></a>00385             local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap][<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>]-1,
<a name="l00386"></a>00386             owning_pid_idx  = node_ownership[local_node_idx];
<a name="l00387"></a>00387 
<a name="l00388"></a>00388           <span class="comment">// add it to the request list for its owning processor.</span>
<a name="l00389"></a>00389           <span class="keywordflow">if</span> (owning_pid_idx == adjcnt_pid_idx)
<a name="l00390"></a>00390             {
<a name="l00391"></a>00391               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00392"></a>00392                 global_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx]-1;
<a name="l00393"></a>00393               needed_node_idxs[cmap].push_back(global_node_idx);
<a name="l00394"></a>00394             }
<a name="l00395"></a>00395         }
<a name="l00396"></a>00396       <span class="comment">// now post the send for this cmap</span>
<a name="l00397"></a>00397       <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (adjcnt_pid_idx,              <span class="comment">// destination</span>
<a name="l00398"></a>00398                       needed_node_idxs[cmap],      <span class="comment">// send buffer</span>
<a name="l00399"></a>00399                       needed_nodes_requests[cmap], <span class="comment">// request</span>
<a name="l00400"></a>00400                       nodes_tag);      
<a name="l00401"></a>00401     } <span class="comment">// all communication requests for getting updated global indices for border</span>
<a name="l00402"></a>00402       <span class="comment">// nodes have been initiated</span>
<a name="l00403"></a>00403 
<a name="l00404"></a>00404   <span class="comment">// Figure out how many nodes each processor thinks it will number and make sure</span>
<a name="l00405"></a>00405   <span class="comment">// that it adds up to the global number of nodes. Also, set up global node</span>
<a name="l00406"></a>00406   <span class="comment">// index offsets for each processor.</span>
<a name="l00407"></a>00407   std::vector&lt;unsigned int&gt;
<a name="l00408"></a>00408     all_num_nodes_i_must_number (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00409"></a>00409    
<a name="l00410"></a>00410   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00411"></a>00411     all_num_nodes_i_must_number[pid] = all_loadbal_data[8*pid + 7];
<a name="l00412"></a>00412   
<a name="l00413"></a>00413   <span class="comment">// The sum of all the entries in this vector should sum to the number of global nodes</span>
<a name="l00414"></a>00414   libmesh_assert (std::accumulate(all_num_nodes_i_must_number.begin(),
<a name="l00415"></a>00415                                   all_num_nodes_i_must_number.end(),
<a name="l00416"></a>00416                                   0) == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">num_nodes_global</a>);
<a name="l00417"></a>00417   
<a name="l00418"></a>00418   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_next_node = 0;
<a name="l00419"></a>00419   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); pid++)
<a name="l00420"></a>00420     my_next_node += all_num_nodes_i_must_number[pid];
<a name="l00421"></a>00421   
<a name="l00422"></a>00422   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_node_offset = my_next_node;
<a name="l00423"></a>00423 
<a name="l00424"></a>00424   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00425"></a>00425     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00426"></a>00426                   &lt;&lt; <span class="stringliteral">&quot;my_node_offset=&quot;</span>
<a name="l00427"></a>00427                   &lt;&lt; my_node_offset
<a name="l00428"></a>00428                   &lt;&lt; std::endl;
<a name="l00429"></a>00429   
<a name="l00430"></a>00430   <span class="comment">// Add internal nodes to the ParallelMesh, using the node ID offset we</span>
<a name="l00431"></a>00431   <span class="comment">// computed and the current processor&#39;s ID.</span>
<a name="l00432"></a>00432   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a>); ++i)
<a name="l00433"></a>00433     {
<a name="l00434"></a>00434       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00435"></a>00435         local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>[i]-1,
<a name="l00436"></a>00436         global_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx]-1,
<a name="l00437"></a>00437         owning_pid_idx  = node_ownership[local_node_idx];
<a name="l00438"></a>00438 
<a name="l00439"></a>00439       <span class="comment">// an internal node we do not own? huh??</span>
<a name="l00440"></a>00440       libmesh_assert (owning_pid_idx == libMesh::processor_id());
<a name="l00441"></a>00441       libmesh_assert (global_node_idx &lt; to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">num_nodes_global</a>));
<a name="l00442"></a>00442 
<a name="l00443"></a>00443       <span class="comment">// &quot;Catch&quot; the node pointer after addition, make sure the</span>
<a name="l00444"></a>00444       <span class="comment">// ID matches the requested value.</span>
<a name="l00445"></a>00445       <a class="code" href="classlibMesh_1_1Node.php">Node</a>* added_node = 
<a name="l00446"></a>00446         mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[local_node_idx],
<a name="l00447"></a>00447                               <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[local_node_idx],
<a name="l00448"></a>00448                               <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[local_node_idx]), 
<a name="l00449"></a>00449                         my_next_node, 
<a name="l00450"></a>00450                         libMesh::processor_id());
<a name="l00451"></a>00451 
<a name="l00452"></a>00452       <span class="comment">// Make sure the node we added has the ID we thought it would</span>
<a name="l00453"></a>00453       <span class="keywordflow">if</span> (added_node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() != my_next_node)
<a name="l00454"></a>00454         {
<a name="l00455"></a>00455           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error, node added with ID &quot;</span> &lt;&lt; added_node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() 
<a name="l00456"></a>00456                        &lt;&lt; <span class="stringliteral">&quot;, but we wanted ID &quot;</span> &lt;&lt; my_next_node &lt;&lt; std::endl;
<a name="l00457"></a>00457         }
<a name="l00458"></a>00458 
<a name="l00459"></a>00459       <span class="comment">// update the local-&gt;global index map, when we are done</span>
<a name="l00460"></a>00460       <span class="comment">// it will be 0-based.</span>
<a name="l00461"></a>00461       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx] = my_next_node++;
<a name="l00462"></a>00462     }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464   <span class="comment">// Now, for the boundary nodes...  We may very well own some of them,</span>
<a name="l00465"></a>00465   <span class="comment">// but there may be others for which we have requested the new global</span>
<a name="l00466"></a>00466   <span class="comment">// id.  We expect to be asked for the ids of the ones we own, so </span>
<a name="l00467"></a>00467   <span class="comment">// we need to create a map from the old global id to the new one</span>
<a name="l00468"></a>00468   <span class="comment">// we are about to create.</span>
<a name="l00469"></a>00469   <span class="keyword">typedef</span> std::vector&lt;std::pair&lt;unsigned int, unsigned int&gt; &gt; global_idx_mapping_type;
<a name="l00470"></a>00470   global_idx_mapping_type old_global_to_new_global_map;
<a name="l00471"></a>00471   old_global_to_new_global_map.reserve (num_nodes_i_must_number <span class="comment">// total # i will have         </span>
<a name="l00472"></a>00472                                         - (my_next_node         <span class="comment">// amount i have thus far</span>
<a name="l00473"></a>00473                                            - my_node_offset));  <span class="comment">// this should be exact! </span>
<a name="l00474"></a>00474   CompareGlobalIdxMappings global_idx_mapping_comp;
<a name="l00475"></a>00475 
<a name="l00476"></a>00476   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>); ++i)
<a name="l00477"></a>00477     {
<a name="l00478"></a>00478       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00479"></a>00479         local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>[i]-1,
<a name="l00480"></a>00480         owning_pid_idx  = node_ownership[local_node_idx];       
<a name="l00481"></a>00481       
<a name="l00482"></a>00482       <span class="comment">// if we own it...</span>
<a name="l00483"></a>00483       <span class="keywordflow">if</span> (owning_pid_idx == libMesh::processor_id())
<a name="l00484"></a>00484         {
<a name="l00485"></a>00485           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00486"></a>00486             global_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx]-1;
<a name="l00487"></a>00487 
<a name="l00488"></a>00488           <span class="comment">// we will number it, and create a mapping from its old global index to</span>
<a name="l00489"></a>00489           <span class="comment">// the new global index, for lookup purposes when neighbors come calling</span>
<a name="l00490"></a>00490           old_global_to_new_global_map.push_back(std::make_pair(global_node_idx, 
<a name="l00491"></a>00491                                                                 my_next_node));
<a name="l00492"></a>00492 
<a name="l00493"></a>00493           <span class="comment">// &quot;Catch&quot; the node pointer after addition, make sure the</span>
<a name="l00494"></a>00494           <span class="comment">// ID matches the requested value.</span>
<a name="l00495"></a>00495           <a class="code" href="classlibMesh_1_1Node.php">Node</a>* added_node = 
<a name="l00496"></a>00496             mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[local_node_idx],
<a name="l00497"></a>00497                                   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[local_node_idx],
<a name="l00498"></a>00498                                   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[local_node_idx]), 
<a name="l00499"></a>00499                             my_next_node, 
<a name="l00500"></a>00500                             libMesh::processor_id());
<a name="l00501"></a>00501 
<a name="l00502"></a>00502           <span class="comment">// Make sure the node we added has the ID we thought it would</span>
<a name="l00503"></a>00503           <span class="keywordflow">if</span> (added_node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() != my_next_node)
<a name="l00504"></a>00504             {
<a name="l00505"></a>00505               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error, node added with ID &quot;</span> &lt;&lt; added_node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() 
<a name="l00506"></a>00506                            &lt;&lt; <span class="stringliteral">&quot;, but we wanted ID &quot;</span> &lt;&lt; my_next_node &lt;&lt; std::endl;
<a name="l00507"></a>00507             }
<a name="l00508"></a>00508 
<a name="l00509"></a>00509           <span class="comment">// update the local-&gt;global index map, when we are done</span>
<a name="l00510"></a>00510           <span class="comment">// it will be 0-based.</span>
<a name="l00511"></a>00511           <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx] = my_next_node++;
<a name="l00512"></a>00512         }
<a name="l00513"></a>00513     }
<a name="l00514"></a>00514   <span class="comment">// That should cover numbering all the nodes which belong to us...</span>
<a name="l00515"></a>00515   libmesh_assert (num_nodes_i_must_number == (my_next_node - my_node_offset));
<a name="l00516"></a>00516 
<a name="l00517"></a>00517   <span class="comment">// Let&#39;s sort the mapping so we can efficiently answer requests</span>
<a name="l00518"></a>00518   std::sort (old_global_to_new_global_map.begin(),
<a name="l00519"></a>00519              old_global_to_new_global_map.end(),
<a name="l00520"></a>00520              global_idx_mapping_comp);
<a name="l00521"></a>00521 
<a name="l00522"></a>00522   <span class="comment">// and it had better be unique...</span>
<a name="l00523"></a>00523   libmesh_assert (std::unique (old_global_to_new_global_map.begin(),
<a name="l00524"></a>00524                                old_global_to_new_global_map.end(),
<a name="l00525"></a>00525                                global_idx_mapping_equality) ==
<a name="l00526"></a>00526                   old_global_to_new_global_map.end());
<a name="l00527"></a>00527 
<a name="l00528"></a>00528   <span class="comment">// We can now catch incoming requests and process them. for efficiency</span>
<a name="l00529"></a>00529   <span class="comment">// let&#39;s do whatever is available next</span>
<a name="l00530"></a>00530   std::map&lt;unsigned int, std::vector&lt;int&gt; &gt; requested_node_idxs; <span class="comment">// the indices asked of us   </span>
<a name="l00531"></a>00531 
<a name="l00532"></a>00532   std::vector&lt;Parallel::Request&gt; requested_nodes_requests(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>);
<a name="l00533"></a>00533   
<a name="l00534"></a>00534   <span class="comment">// We know we will receive the request from a given processor before</span>
<a name="l00535"></a>00535   <span class="comment">// we receive its reply to our request. However, we may receive</span>
<a name="l00536"></a>00536   <span class="comment">// a request and a response from one processor before getting</span>
<a name="l00537"></a>00537   <span class="comment">// a request from another processor.  So what we are doing here</span>
<a name="l00538"></a>00538   <span class="comment">// is processing whatever message comes next, while recognizing </span>
<a name="l00539"></a>00539   <span class="comment">// we will receive a request from a processor before receiving</span>
<a name="l00540"></a>00540   <span class="comment">// its reply</span>
<a name="l00541"></a>00541   std::vector&lt;bool&gt; processed_cmap (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>, <span class="keyword">false</span>);
<a name="l00542"></a>00542 
<a name="l00543"></a>00543   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> comm_step=0; comm_step&lt;2*to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>); comm_step++)
<a name="l00544"></a>00544     {
<a name="l00545"></a>00545       <span class="comment">// query the first message which is available</span>
<a name="l00546"></a>00546       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Status.php">Parallel::Status</a> 
<a name="l00547"></a>00547         <a class="code" href="namespacelibMesh_1_1Parallel.php#a08ff351bea1937bbde5a1af3160b4616">status</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#a11a1391d63c3bd391913f4a71321af21">Parallel::probe</a> (<a class="code" href="namespacelibMesh_1_1Parallel.php#af036e0e449c3b43e908bb8fa22f2191b">Parallel::any_source</a>, 
<a name="l00548"></a>00548                                  nodes_tag));      
<a name="l00549"></a>00549       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00550"></a>00550         requesting_pid_idx = status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aee8318932e11f49d49ad6f65768a629c">source</a>(),
<a name="l00551"></a>00551         source_pid_idx     = status.<a class="code" href="classlibMesh_1_1Parallel_1_1Status.php#aee8318932e11f49d49ad6f65768a629c">source</a>();
<a name="l00552"></a>00552 
<a name="l00553"></a>00553       <span class="comment">// this had better be from a processor we are expecting...</span>
<a name="l00554"></a>00554       libmesh_assert (pid_to_cmap_map.count(requesting_pid_idx));
<a name="l00555"></a>00555       
<a name="l00556"></a>00556       <span class="comment">// the local cmap which corresponds to the source processor</span>
<a name="l00557"></a>00557       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cmap = pid_to_cmap_map[source_pid_idx];
<a name="l00558"></a>00558 
<a name="l00559"></a>00559       <span class="keywordflow">if</span> (!processed_cmap[cmap])
<a name="l00560"></a>00560         {
<a name="l00561"></a>00561           processed_cmap[cmap] = <span class="keyword">true</span>;
<a name="l00562"></a>00562           
<a name="l00563"></a>00563           <span class="comment">// we should only get one request per paired processor</span>
<a name="l00564"></a>00564           libmesh_assert (!requested_node_idxs.count(requesting_pid_idx));
<a name="l00565"></a>00565       
<a name="l00566"></a>00566           <span class="comment">// get a reference to the request buffer for this processor to</span>
<a name="l00567"></a>00567           <span class="comment">// avoid repeated map lookups</span>
<a name="l00568"></a>00568           std::vector&lt;int&gt; &amp;xfer_buf (requested_node_idxs[requesting_pid_idx]);
<a name="l00569"></a>00569             
<a name="l00570"></a>00570           <span class="comment">// actually receive the message.  </span>
<a name="l00571"></a>00571           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (requesting_pid_idx, xfer_buf, nodes_tag);
<a name="l00572"></a>00572           
<a name="l00573"></a>00573           <span class="comment">// Fill the request</span>
<a name="l00574"></a>00574           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;xfer_buf.size(); i++)
<a name="l00575"></a>00575             {
<a name="l00576"></a>00576               <span class="comment">// the requested old global node index, *now 0-based*</span>
<a name="l00577"></a>00577               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_global_node_idx = xfer_buf[i];
<a name="l00578"></a>00578               
<a name="l00579"></a>00579               <span class="comment">// find the new global node index for the requested node -</span>
<a name="l00580"></a>00580               <span class="comment">// note that requesting_pid_idx thinks we own this node,</span>
<a name="l00581"></a>00581               <span class="comment">// so we better!</span>
<a name="l00582"></a>00582               <span class="keyword">const</span> global_idx_mapping_type::const_iterator it =
<a name="l00583"></a>00583                 std::lower_bound (old_global_to_new_global_map.begin(),
<a name="l00584"></a>00584                                   old_global_to_new_global_map.end(),
<a name="l00585"></a>00585                                   old_global_node_idx,
<a name="l00586"></a>00586                                   global_idx_mapping_comp);
<a name="l00587"></a>00587                 
<a name="l00588"></a>00588               libmesh_assert (it != old_global_to_new_global_map.end());
<a name="l00589"></a>00589               libmesh_assert (it-&gt;first == old_global_node_idx);
<a name="l00590"></a>00590               libmesh_assert (it-&gt;second &gt;= my_node_offset);
<a name="l00591"></a>00591               libmesh_assert (it-&gt;second &lt;  my_next_node);
<a name="l00592"></a>00592               
<a name="l00593"></a>00593               <span class="comment">// overwrite the requested old global node index with the new global index</span>
<a name="l00594"></a>00594               xfer_buf[i] = it-&gt;second;
<a name="l00595"></a>00595             }
<a name="l00596"></a>00596             
<a name="l00597"></a>00597           <span class="comment">// and send the new global indices back to the processor which asked for them</span>
<a name="l00598"></a>00598           <a class="code" href="namespacelibMesh_1_1Parallel.php#aa5a90fd8d590aaaa059158cb7d604b68">Parallel::send</a> (requesting_pid_idx,
<a name="l00599"></a>00599                           xfer_buf,
<a name="l00600"></a>00600                           requested_nodes_requests[cmap],
<a name="l00601"></a>00601                           nodes_tag);
<a name="l00602"></a>00602         } <span class="comment">// done processing the request</span>
<a name="l00603"></a>00603       
<a name="l00604"></a>00604       <span class="comment">// this is the second time we have heard from this processor, </span>
<a name="l00605"></a>00605       <span class="comment">// so it must be its reply to our request</span>
<a name="l00606"></a>00606       <span class="keywordflow">else</span>
<a name="l00607"></a>00607         {
<a name="l00608"></a>00608           <span class="comment">// a long time ago, we sent off our own requests.  now it is time to catch the </span>
<a name="l00609"></a>00609           <span class="comment">// replies and get the new global node numbering.  note that for any reply</span>
<a name="l00610"></a>00610           <span class="comment">// we receive, the corresponding nonblocking send from above *must* have been </span>
<a name="l00611"></a>00611           <span class="comment">// completed, since the reply is in response to that request!!</span>
<a name="l00612"></a>00612           
<a name="l00613"></a>00613           <span class="comment">// if we have received a reply, our send *must* have completed</span>
<a name="l00614"></a>00614           <span class="comment">// (note we never actually need to wait on the request)</span>
<a name="l00615"></a>00615           libmesh_assert (needed_nodes_requests[cmap].test());
<a name="l00616"></a>00616           libmesh_assert (to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[cmap]) == source_pid_idx);
<a name="l00617"></a>00617             
<a name="l00618"></a>00618           <span class="comment">// now post the receive for this cmap</span>
<a name="l00619"></a>00619           <a class="code" href="namespacelibMesh_1_1Parallel.php#aff69db520530bae51afc2e02eb385724">Parallel::receive</a> (source_pid_idx,
<a name="l00620"></a>00620                              needed_node_idxs[cmap],
<a name="l00621"></a>00621                              nodes_tag);
<a name="l00622"></a>00622           
<a name="l00623"></a>00623           libmesh_assert (needed_node_idxs[cmap].size() &lt;= 
<a name="l00624"></a>00624                           <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap].size());
<a name="l00625"></a>00625           
<a name="l00626"></a>00626           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0,j=0; i&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap].size(); i++)
<a name="l00627"></a>00627             {
<a name="l00628"></a>00628               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00629"></a>00629                 local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[cmap][i]-1,
<a name="l00630"></a>00630                 owning_pid_idx  = node_ownership[local_node_idx];       
<a name="l00631"></a>00631               
<a name="l00632"></a>00632               <span class="comment">// if this node is owned by source_pid_idx, its new global id </span>
<a name="l00633"></a>00633               <span class="comment">// is in the buffer we just received</span>
<a name="l00634"></a>00634               <span class="keywordflow">if</span> (owning_pid_idx == source_pid_idx)
<a name="l00635"></a>00635                 {
<a name="l00636"></a>00636                   libmesh_assert (j &lt; needed_node_idxs[cmap].size());
<a name="l00637"></a>00637                     
<a name="l00638"></a>00638                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">// now 0-based!</span>
<a name="l00639"></a>00639                     global_node_idx = needed_node_idxs[cmap][j++];
<a name="l00640"></a>00640                   
<a name="l00641"></a>00641                   <span class="comment">// &quot;Catch&quot; the node pointer after addition, make sure the</span>
<a name="l00642"></a>00642                   <span class="comment">// ID matches the requested value.</span>
<a name="l00643"></a>00643                   <a class="code" href="classlibMesh_1_1Node.php">Node</a>* added_node = 
<a name="l00644"></a>00644                     mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">add_point</a> (<a class="code" href="classlibMesh_1_1Point.php">Point</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>[local_node_idx],
<a name="l00645"></a>00645                                           <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>[local_node_idx],
<a name="l00646"></a>00646                                           <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>[local_node_idx]),
<a name="l00647"></a>00647                                     global_node_idx,
<a name="l00648"></a>00648                                     source_pid_idx);
<a name="l00649"></a>00649                   
<a name="l00650"></a>00650                   <span class="comment">// Make sure the node we added has the ID we thought it would</span>
<a name="l00651"></a>00651                   <span class="keywordflow">if</span> (added_node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() != global_node_idx)
<a name="l00652"></a>00652                     {
<a name="l00653"></a>00653                       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error, node added with ID &quot;</span> &lt;&lt; added_node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() 
<a name="l00654"></a>00654                                    &lt;&lt; <span class="stringliteral">&quot;, but we wanted ID &quot;</span> &lt;&lt; global_node_idx &lt;&lt; std::endl;
<a name="l00655"></a>00655                     }
<a name="l00656"></a>00656 
<a name="l00657"></a>00657                   <span class="comment">// update the local-&gt;global index map, when we are done</span>
<a name="l00658"></a>00658                   <span class="comment">// it will be 0-based.</span>
<a name="l00659"></a>00659                   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx] = global_node_idx;
<a name="l00660"></a>00660                   
<a name="l00661"></a>00661                   <span class="comment">// we are not really going to use my_next_node again, but we can</span>
<a name="l00662"></a>00662                   <span class="comment">// keep incrimenting it to track how many nodes we have added </span>
<a name="l00663"></a>00663                   <span class="comment">// to the mesh</span>
<a name="l00664"></a>00664                   my_next_node++;
<a name="l00665"></a>00665                 }
<a name="l00666"></a>00666             }
<a name="l00667"></a>00667         }
<a name="l00668"></a>00668     } <span class="comment">// end of node index communication loop</span>
<a name="l00669"></a>00669   
<a name="l00670"></a>00670   <span class="comment">// we had better have added all the nodes we need to!</span>
<a name="l00671"></a>00671   libmesh_assert ((my_next_node - my_node_offset) == to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a847ee7e0854676701e1b5205bb6ed743">num_nodes</a>));
<a name="l00672"></a>00672 
<a name="l00673"></a>00673   <span class="comment">// After all that, we should be done with all node-related arrays *except* the</span>
<a name="l00674"></a>00674   <span class="comment">// node_num_map, which we have transformed to use our new numbering...</span>
<a name="l00675"></a>00675   <span class="comment">// So let&#39;s clean up the arrays we are done with.</span>
<a name="l00676"></a>00676   {
<a name="l00677"></a>00677     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>);
<a name="l00678"></a>00678     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>);
<a name="l00679"></a>00679     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8adf1fe9838d266d02a589b715504e84">node_mape</a>);
<a name="l00680"></a>00680     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>);
<a name="l00681"></a>00681     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>);
<a name="l00682"></a>00682     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>);
<a name="l00683"></a>00683     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>);
<a name="l00684"></a>00684     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a34773dcda6a41b34e67fce165454c530">x</a>);
<a name="l00685"></a>00685     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9c91b82c014b865a677fd4dea029f1d9">y</a>);
<a name="l00686"></a>00686     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6537a7456410505c56fd3549eb98fc07">z</a>);
<a name="l00687"></a>00687     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (needed_node_idxs);
<a name="l00688"></a>00688     <a class="code" href="namespacelibMesh_1_1Utility.php#a92241eb8401cf9d333223e9c95e12475">Utility::deallocate</a> (node_ownership);
<a name="l00689"></a>00689   }
<a name="l00690"></a>00690   
<a name="l00691"></a>00691   <a class="code" href="namespacelibMesh_1_1Parallel.php#a134212c5276050e13f31cb2d22bbed8c">Parallel::wait</a> (requested_nodes_requests);
<a name="l00692"></a>00692   requested_node_idxs.clear();
<a name="l00693"></a>00693 
<a name="l00694"></a>00694   <span class="comment">// See what the node count is up to now.</span>
<a name="l00695"></a>00695   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00696"></a>00696     {
<a name="l00697"></a>00697       <span class="comment">// Report the number of nodes which have been added locally</span>
<a name="l00698"></a>00698       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00699"></a>00699       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mesh.n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() &lt;&lt; std::endl;
<a name="l00700"></a>00700       
<a name="l00701"></a>00701       <span class="comment">// Reports the number of nodes that have been added in total.</span>
<a name="l00702"></a>00702       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00703"></a>00703       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mesh.parallel_n_nodes()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">parallel_n_nodes</a>() &lt;&lt; std::endl;
<a name="l00704"></a>00704     }
<a name="l00705"></a>00705   
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 
<a name="l00708"></a>00708   <span class="comment">// --------------------------------------------------------------------------------</span>
<a name="l00709"></a>00709   <span class="comment">// --------------------------------------------------------------------------------</span>
<a name="l00710"></a>00710   <span class="comment">// --------------------------------------------------------------------------------</span>
<a name="l00711"></a>00711 
<a name="l00712"></a>00712       
<a name="l00713"></a>00713   <span class="comment">// We can now read in the elements...Exodus stores them in blocks in which all</span>
<a name="l00714"></a>00714   <span class="comment">// elements have the same geometric type.  This code is adapted directly from exodusII_io.C</span>
<a name="l00715"></a>00715 
<a name="l00716"></a>00716   <span class="comment">// Assertion: The sum of the border and internal elements on all processors</span>
<a name="l00717"></a>00717   <span class="comment">// should equal nemhelper-&gt;num_elems_global</span>
<a name="l00718"></a>00718 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00719"></a>00719 <span class="preprocessor"></span>  {
<a name="l00720"></a>00720     <span class="keywordtype">int</span> sum_internal_elems=0, sum_border_elems=0;
<a name="l00721"></a>00721     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=3,c=0; c&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); j+=8,++c)
<a name="l00722"></a>00722       sum_internal_elems += all_loadbal_data[j];
<a name="l00723"></a>00723     
<a name="l00724"></a>00724     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=4,c=0; c&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); j+=8,++c)
<a name="l00725"></a>00725       sum_border_elems += all_loadbal_data[j];
<a name="l00726"></a>00726     
<a name="l00727"></a>00727     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00728"></a>00728       {
<a name="l00729"></a>00729         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00730"></a>00730         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;sum_internal_elems=&quot;</span> &lt;&lt; sum_internal_elems &lt;&lt; std::endl;
<a name="l00731"></a>00731         
<a name="l00732"></a>00732         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00733"></a>00733         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;sum_border_elems=&quot;</span> &lt;&lt; sum_border_elems &lt;&lt; std::endl;
<a name="l00734"></a>00734       }
<a name="l00735"></a>00735     
<a name="l00736"></a>00736     libmesh_assert(sum_internal_elems+sum_border_elems == <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a428c62b9b28577fb377d085b6cf3fbf3">num_elems_global</a>);
<a name="l00737"></a>00737   }
<a name="l00738"></a>00738 <span class="preprocessor">#endif</span>
<a name="l00739"></a>00739 <span class="preprocessor"></span>
<a name="l00740"></a>00740   <span class="comment">// We need to set the mesh dimension, but the following...</span>
<a name="l00741"></a>00741   <span class="comment">// mesh.set_mesh_dimension(static_cast&lt;unsigned int&gt;(nemhelper-&gt;num_dim));</span>
<a name="l00742"></a>00742 
<a name="l00743"></a>00743   <span class="comment">// ... is not sufficient since some codes report num_dim==3 for two dimensional</span>
<a name="l00744"></a>00744   <span class="comment">// meshes living in 3D, even though all the elements are of 2D type.  Therefore,</span>
<a name="l00745"></a>00745   <span class="comment">// we instead use the dimension of the highest element found for the Mesh dimension, </span>
<a name="l00746"></a>00746   <span class="comment">// similar to what is done by the Exodus reader, except here it requires a</span>
<a name="l00747"></a>00747   <span class="comment">// parallel communication.  </span>
<a name="l00748"></a>00748   <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>.resize(4, <span class="keyword">false</span>); <span class="comment">// will use 1-based</span>
<a name="l00749"></a>00749 
<a name="l00750"></a>00750   <span class="comment">// Compute my_elem_offset, the amount by which to offset the local elem numbering</span>
<a name="l00751"></a>00751   <span class="comment">// on my processor.</span>
<a name="l00752"></a>00752   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_next_elem = 0;
<a name="l00753"></a>00753   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); ++pid)
<a name="l00754"></a>00754     my_next_elem += (all_loadbal_data[8*pid + 3]+  <span class="comment">// num_internal_elems, proc pid</span>
<a name="l00755"></a>00755                      all_loadbal_data[8*pid + 4]); <span class="comment">// num_border_elems, proc pid</span>
<a name="l00756"></a>00756   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> my_elem_offset = my_next_elem;
<a name="l00757"></a>00757 
<a name="l00758"></a>00758   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00759"></a>00759     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00760"></a>00760               &lt;&lt; <span class="stringliteral">&quot;my_elem_offset=&quot;</span> &lt;&lt; my_elem_offset &lt;&lt; std::endl;
<a name="l00761"></a>00761 
<a name="l00762"></a>00762 
<a name="l00763"></a>00763   <span class="comment">// Fills in the: </span>
<a name="l00764"></a>00764   <span class="comment">// global_elem_blk_ids[] and</span>
<a name="l00765"></a>00765   <span class="comment">// global_elem_blk_cnts[] arrays.</span>
<a name="l00766"></a>00766   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac1ff2be6140d2002737acdbc30bcd885">get_eb_info_global</a>();
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 <span class="comment">//   // Fills in the vectors</span>
<a name="l00769"></a>00769 <span class="comment">//   // elem_mapi[num_internal_elems]</span>
<a name="l00770"></a>00770 <span class="comment">//   // elem_mapb[num_border_elems  ]</span>
<a name="l00771"></a>00771 <span class="comment">//   // These tell which of the (locally-numbered) elements are internal and which are border elements.</span>
<a name="l00772"></a>00772 <span class="comment">//   // In our test example these arrays are sorted (but non-contiguous), which makes it possible to</span>
<a name="l00773"></a>00773 <span class="comment">//   // binary search for each element ID... however I don&#39;t think we need to distinguish between the</span>
<a name="l00774"></a>00774 <span class="comment">//   // two types, since either can have nodes the boundary!</span>
<a name="l00775"></a>00775 <span class="comment">//   nemhelper-&gt;get_elem_map();</span>
<a name="l00776"></a>00776       
<a name="l00777"></a>00777   <span class="comment">// Fills in the vectors of vectors:</span>
<a name="l00778"></a>00778   <span class="comment">// elem_cmap_elem_ids[][]</span>
<a name="l00779"></a>00779   <span class="comment">// elem_cmap_side_ids[][]</span>
<a name="l00780"></a>00780   <span class="comment">// elem_cmap_proc_ids[][]</span>
<a name="l00781"></a>00781   <span class="comment">// These arrays are of size num_elem_cmaps * elem_cmap_elem_cnts[i], i = 0..num_elem_cmaps</span>
<a name="l00782"></a>00782   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a902f187c60c1b72216f3197894ce99d1">get_elem_cmap</a>();
<a name="l00783"></a>00783       
<a name="l00784"></a>00784   <span class="comment">// Get information about the element blocks:</span>
<a name="l00785"></a>00785   <span class="comment">// (read in the array nemhelper-&gt;block_ids[])</span>
<a name="l00786"></a>00786   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a025711d210123880b8cdac91184ab45b">read_block_info</a>();
<a name="l00787"></a>00787 
<a name="l00788"></a>00788   <span class="comment">// Reads the nemhelper-&gt;elem_num_map array, elem_num_map[i] is the global element number for</span>
<a name="l00789"></a>00789   <span class="comment">// local element number i.</span>
<a name="l00790"></a>00790   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ade4a8af03ed43f731bd6d3974bceee65">read_elem_num_map</a>();
<a name="l00791"></a>00791       
<a name="l00792"></a>00792   <span class="comment">// Instantiate the ElementMaps interface.  This is what translates LibMesh&#39;s</span>
<a name="l00793"></a>00793   <span class="comment">// element numbering scheme to Exodus&#39;s.</span>
<a name="l00794"></a>00794   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php">ExodusII_IO_Helper::ElementMaps</a> em;
<a name="l00795"></a>00795       
<a name="l00796"></a>00796   <span class="comment">// Read in the element connectivity for each block by</span>
<a name="l00797"></a>00797   <span class="comment">// looping over all the blocks.</span>
<a name="l00798"></a>00798   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a752ec22fd9eca2dfd0b20461a6544fbc">num_elem_blk</a>); i++)
<a name="l00799"></a>00799     {
<a name="l00800"></a>00800       <span class="comment">// Read the information for block i:  For nemhelper-&gt;block_ids[i], reads</span>
<a name="l00801"></a>00801       <span class="comment">// elem_type</span>
<a name="l00802"></a>00802       <span class="comment">// num_elem_this_blk</span>
<a name="l00803"></a>00803       <span class="comment">// num_nodes_per_elem</span>
<a name="l00804"></a>00804       <span class="comment">// num_attr</span>
<a name="l00805"></a>00805       <span class="comment">// connect &lt;-- the nodal connectivity array for each element in the block.</span>
<a name="l00806"></a>00806       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afc3acc1e28f081a9f8a3c3a160715387">read_elem_in_block</a>(i);
<a name="l00807"></a>00807 
<a name="l00808"></a>00808       <span class="comment">// Note that with parallel files it is possible we have no elements in</span>
<a name="l00809"></a>00809       <span class="comment">// this block!</span>
<a name="l00810"></a>00810       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>) <span class="keywordflow">continue</span>;
<a name="l00811"></a>00811       
<a name="l00812"></a>00812       <span class="comment">// Set subdomain ID based on the block ID.</span>
<a name="l00813"></a>00813       <span class="keywordtype">int</span> subdomain_id = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#aba97767bd5bd1dfa25037f41d751e8d1">block_ids</a>[i];
<a name="l00814"></a>00814 
<a name="l00815"></a>00815       <span class="comment">// Create a type string (this uses the null-terminated string ctor).</span>
<a name="l00816"></a>00816       <span class="keyword">const</span> std::string type_str ( &amp;(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#afdf31751c214c456c1bb9a36516976ea">elem_type</a>[0]) ); 
<a name="l00817"></a>00817 
<a name="l00818"></a>00818       <span class="comment">// Set any relevant node/edge maps for this element</span>
<a name="l00819"></a>00819       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv = em.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(type_str); 
<a name="l00820"></a>00820 
<a name="l00821"></a>00821       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00822"></a>00822         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Reading a block of &quot;</span> &lt;&lt; type_str &lt;&lt; <span class="stringliteral">&quot; elements.&quot;</span> &lt;&lt; std::endl;
<a name="l00823"></a>00823       
<a name="l00824"></a>00824       <span class="comment">// Loop over all the elements in this block</span>
<a name="l00825"></a>00825       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60798106904a2036379dd4988e6ceaeb">num_elem_this_blk</a>); j++)
<a name="l00826"></a>00826         {
<a name="l00827"></a>00827           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = <a class="code" href="classlibMesh_1_1Elem.php#a68cfa73358f50660055bf07a2919b2db">Elem::build</a> (conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a5ca4c8800befbbd785efaf269e668e94">get_canonical_type</a>()).release();
<a name="l00828"></a>00828           libmesh_assert (elem);
<a name="l00829"></a>00829 
<a name="l00830"></a>00830           <span class="comment">// Assign subdomain and processor ID to the newly-created Elem.</span>
<a name="l00831"></a>00831           <span class="comment">// Assigning the processor ID beforehand ensures that the Elem is</span>
<a name="l00832"></a>00832           <span class="comment">// not added as an &quot;unpartitioned&quot; element.  Note that the element</span>
<a name="l00833"></a>00833           <span class="comment">// numbering in Exodus is also 1-based.</span>
<a name="l00834"></a>00834           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a96faae17e7ede5aa89c687d54cefb4b3">subdomain_id</a>() = subdomain_id;
<a name="l00835"></a>00835           elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>();
<a name="l00836"></a>00836           elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>()       = my_next_elem++;
<a name="l00837"></a>00837           
<a name="l00838"></a>00838           <span class="comment">// Mark that we have seen an element of the current element&#39;s</span>
<a name="l00839"></a>00839           <span class="comment">// dimension.</span>
<a name="l00840"></a>00840           <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>[elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#aa50d97d65dc379f64667da53c427b36f">dim</a>()] = <span class="keyword">true</span>;
<a name="l00841"></a>00841 
<a name="l00842"></a>00842           <span class="comment">// Add the created Elem to the Mesh, catch the Elem</span>
<a name="l00843"></a>00843           <span class="comment">// pointer that the Mesh throws back.</span>
<a name="l00844"></a>00844           elem = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ad230cc153170488ad92ab4f6ee2146c7">add_elem</a> (elem); 
<a name="l00845"></a>00845 
<a name="l00846"></a>00846           <span class="comment">// We are expecting the element &quot;thrown back&quot; by libmesh to have the ID we specified for it...</span>
<a name="l00847"></a>00847           <span class="comment">// Check to see that really is the case.  Note that my_next_elem was post-incremented, so</span>
<a name="l00848"></a>00848           <span class="comment">// subtract 1 when performing the check.</span>
<a name="l00849"></a>00849           <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() != my_next_elem-1)
<a name="l00850"></a>00850             {
<a name="l00851"></a>00851               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Unexpected ID &quot;</span> 
<a name="l00852"></a>00852                         &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() 
<a name="l00853"></a>00853                         &lt;&lt; <span class="stringliteral">&quot; set by parallel mesh. (expecting &quot;</span> 
<a name="l00854"></a>00854                         &lt;&lt; my_next_elem-1 
<a name="l00855"></a>00855                         &lt;&lt; <span class="stringliteral">&quot;).&quot;</span> &lt;&lt; std::endl;
<a name="l00856"></a>00856               libmesh_error();
<a name="l00857"></a>00857             }
<a name="l00858"></a>00858 
<a name="l00859"></a>00859           <span class="comment">// Set all the nodes for this element</span>
<a name="l00860"></a>00860           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)     
<a name="l00861"></a>00861             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00862"></a>00862                           &lt;&lt; <span class="stringliteral">&quot;Setting nodes for Elem &quot;</span> &lt;&lt; elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() &lt;&lt; std::endl;
<a name="l00863"></a>00863               
<a name="l00864"></a>00864           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a>); k++)
<a name="l00865"></a>00865             {
<a name="l00866"></a>00866               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>
<a name="l00867"></a>00867                 gi              = (j*<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a850769b9bbd31c3825aeb967e076ba05">num_nodes_per_elem</a> +       <span class="comment">// index into connectivity array</span>
<a name="l00868"></a>00868                                    conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a84ae7256b57510e53b3d087cfc3fe0ca">get_node_map</a>(k)), 
<a name="l00869"></a>00869                 local_node_idx  = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ac0708202a0c25af8a4d04253f6bae84e">connect</a>[gi]-1,                <span class="comment">// local node index </span>
<a name="l00870"></a>00870                 global_node_idx = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[local_node_idx]; <span class="comment">// new global node index</span>
<a name="l00871"></a>00871                   
<a name="l00872"></a>00872               <span class="comment">// Set node number</span>
<a name="l00873"></a>00873               elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a0d25454251fb8f3518211ccd9f467b91">set_node</a>(k) = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a>(global_node_idx);
<a name="l00874"></a>00874             }
<a name="l00875"></a>00875         } <span class="comment">// for (unsigned int j=0; j&lt;nemhelper-&gt;num_elem_this_blk; j++)     </span>
<a name="l00876"></a>00876     } <span class="comment">// end for (unsigned int i=0; i&lt;nemhelper-&gt;num_elem_blk; i++)</span>
<a name="l00877"></a>00877 
<a name="l00878"></a>00878   libmesh_assert ((my_next_elem - my_elem_offset) == to_uint(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af4bc089ec99edd6e62d67ed75a7d1a2a">num_elem</a>));
<a name="l00879"></a>00879 
<a name="l00880"></a>00880   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00881"></a>00881     {
<a name="l00882"></a>00882       <span class="comment">// Print local elems_of_dimension information</span>
<a name="l00883"></a>00883       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;<a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>.size(); ++i)
<a name="l00884"></a>00884         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; libMesh::processor_id() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00885"></a>00885                      &lt;&lt; <span class="stringliteral">&quot;elems_of_dimension[&quot;</span> &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>[i] &lt;&lt; std::endl;
<a name="l00886"></a>00886     }
<a name="l00887"></a>00887 
<a name="l00888"></a>00888   <span class="comment">// Get the max dimension seen on the current processor</span>
<a name="l00889"></a>00889   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_dim_seen = 0;
<a name="l00890"></a>00890   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;<a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>.size(); ++i)
<a name="l00891"></a>00891     <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1MeshInput.php#aa674e5327727692fac891ae85f2c211a">elems_of_dimension</a>[i])
<a name="l00892"></a>00892       max_dim_seen = i;
<a name="l00893"></a>00893 
<a name="l00894"></a>00894   <span class="comment">// Do a global max to determine the max dimension seen by all processors.</span>
<a name="l00895"></a>00895   <span class="comment">// It should match -- I don&#39;t think we even support calculations on meshes</span>
<a name="l00896"></a>00896   <span class="comment">// with elements of different dimension...</span>
<a name="l00897"></a>00897   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_dim_seen);
<a name="l00898"></a>00898 
<a name="l00899"></a>00899   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00900"></a>00900     {
<a name="l00901"></a>00901       <span class="comment">// Print the max element dimension from all processors</span>
<a name="l00902"></a>00902       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00903"></a>00903                    &lt;&lt; <span class="stringliteral">&quot;max_dim_seen=&quot;</span> &lt;&lt; max_dim_seen &lt;&lt; std::endl;
<a name="l00904"></a>00904     }
<a name="l00905"></a>00905 
<a name="l00906"></a>00906   <span class="comment">// Set the mesh dimension to the largest encountered for an element</span>
<a name="l00907"></a>00907   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#af7db7d54bc846c376d9c57a833263204">set_mesh_dimension</a>(max_dim_seen);
<a name="l00908"></a>00908 
<a name="l00909"></a>00909 <span class="preprocessor">#if LIBMESH_DIM &lt; 3</span>
<a name="l00910"></a>00910 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() &gt; LIBMESH_DIM)
<a name="l00911"></a>00911     {
<a name="l00912"></a>00912       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Cannot open dimension &quot;</span> &lt;&lt;
<a name="l00913"></a>00913                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() &lt;&lt;
<a name="l00914"></a>00914                       <span class="stringliteral">&quot; mesh file when configured without &quot;</span> &lt;&lt;
<a name="l00915"></a>00915                       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() &lt;&lt; <span class="stringliteral">&quot;D support.&quot;</span> &lt;&lt;
<a name="l00916"></a>00916                       std::endl;
<a name="l00917"></a>00917       libmesh_error();
<a name="l00918"></a>00918     }
<a name="l00919"></a>00919 <span class="preprocessor">#endif</span>
<a name="l00920"></a>00920 <span class="preprocessor"></span>  
<a name="l00921"></a>00921 
<a name="l00922"></a>00922   <span class="comment">// Global sideset information, they are distributed as well, not sure if they will require communication...?</span>
<a name="l00923"></a>00923   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a38c95a1f14084ff7d654f85b63a62d2b">get_ss_param_global</a>();
<a name="l00924"></a>00924 
<a name="l00925"></a>00925   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00926"></a>00926     {
<a name="l00927"></a>00927       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00928"></a>00928                    &lt;&lt; <span class="stringliteral">&quot;Read global sideset parameter information.&quot;</span> &lt;&lt; std::endl;
<a name="l00929"></a>00929       
<a name="l00930"></a>00930       <span class="comment">// These global values should be the same on all processors...</span>
<a name="l00931"></a>00931       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00932"></a>00932                    &lt;&lt; <span class="stringliteral">&quot;Number of global sideset IDs: &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af788a42ffedcc5a5552ecce5864e82cb">global_sideset_ids</a>.size() &lt;&lt; std::endl;
<a name="l00933"></a>00933     }
<a name="l00934"></a>00934 
<a name="l00935"></a>00935   <span class="comment">// Read *local* sideset info the same way it is done in</span>
<a name="l00936"></a>00936   <span class="comment">// exodusII_io_helper.  May be called any time after</span>
<a name="l00937"></a>00937   <span class="comment">// nem_helper-&gt;read_header(); This sets num_side_sets and resizes</span>
<a name="l00938"></a>00938   <span class="comment">// elem_list, side_list, and id_list to num_elem_all_sidesets.  Note</span>
<a name="l00939"></a>00939   <span class="comment">// that there appears to be the same number of sidesets in each file</span>
<a name="l00940"></a>00940   <span class="comment">// but they all have different numbers of entries (some are empty).</span>
<a name="l00941"></a>00941   <span class="comment">// Note that the sum of &quot;nemhelper-&gt;num_elem_all_sidesets&quot; over all</span>
<a name="l00942"></a>00942   <span class="comment">// processors should equal the sum of the entries in the &quot;num_global_side_counts&quot; array</span>
<a name="l00943"></a>00943   <span class="comment">// filled up by nemhelper-&gt;get_ss_param_global()</span>
<a name="l00944"></a>00944   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a9374fbb748e06b3fcdd5ca6a25bc1cd7">read_sideset_info</a>();
<a name="l00945"></a>00945   
<a name="l00946"></a>00946   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l00947"></a>00947     {
<a name="l00948"></a>00948       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00949"></a>00949                    &lt;&lt; <span class="stringliteral">&quot;nemhelper-&gt;num_side_sets = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#abf7689bb0e540d2ed83d85e6f321c3c8">num_side_sets</a> &lt;&lt; std::endl;
<a name="l00950"></a>00950       
<a name="l00951"></a>00951       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00952"></a>00952                    &lt;&lt; <span class="stringliteral">&quot;nemhelper-&gt;num_elem_all_sidesets = &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">num_elem_all_sidesets</a> &lt;&lt; std::endl;
<a name="l00953"></a>00953     }
<a name="l00954"></a>00954 
<a name="l00955"></a>00955 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00956"></a>00956 <span class="preprocessor"></span>  {
<a name="l00957"></a>00957     <span class="comment">// In DEBUG mode, check that the global number of sidesets reported</span>
<a name="l00958"></a>00958     <span class="comment">// in each nemesis file matches the sum of all local sideset counts</span>
<a name="l00959"></a>00959     <span class="comment">// from each processor.  This requires a small communication, so only</span>
<a name="l00960"></a>00960     <span class="comment">// do it in DEBUG mode.</span>
<a name="l00961"></a>00961     <span class="keywordtype">int</span> sum_num_global_side_counts = std::accumulate(<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a7f5a5ba3ea3dc237cd0cb9a05dc1aef3">num_global_side_counts</a>.begin(),
<a name="l00962"></a>00962                                                      <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a7f5a5ba3ea3dc237cd0cb9a05dc1aef3">num_global_side_counts</a>.end(),
<a name="l00963"></a>00963                                                      0);
<a name="l00964"></a>00964       
<a name="l00965"></a>00965     <span class="comment">// MPI sum up the local files contributions</span>
<a name="l00966"></a>00966     <span class="keywordtype">int</span> sum_num_elem_all_sidesets = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad7a95eb47d7c603f7f1f8d9232ccbb6a">num_elem_all_sidesets</a>;
<a name="l00967"></a>00967     <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(sum_num_elem_all_sidesets);
<a name="l00968"></a>00968 
<a name="l00969"></a>00969     <span class="keywordflow">if</span> (sum_num_global_side_counts != sum_num_elem_all_sidesets)
<a name="l00970"></a>00970       {
<a name="l00971"></a>00971         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error! global side count reported by Nemesis does not &quot;</span>
<a name="l00972"></a>00972                      &lt;&lt; <span class="stringliteral">&quot;match the side count reported by the individual files!&quot;</span> &lt;&lt; std::endl;
<a name="l00973"></a>00973         libmesh_error();
<a name="l00974"></a>00974       }
<a name="l00975"></a>00975   }
<a name="l00976"></a>00976 <span class="preprocessor">#endif</span>
<a name="l00977"></a>00977 <span class="preprocessor"></span>
<a name="l00978"></a>00978   <span class="comment">// Note that exodus stores sidesets in separate vectors but we want to pack</span>
<a name="l00979"></a>00979   <span class="comment">// them all into a single vector.  So when we call read_sideset(), we pass an offset</span>
<a name="l00980"></a>00980   <span class="comment">// into the single vector of all IDs</span>
<a name="l00981"></a>00981   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> offset=0, i=0; i&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a19f54aefc1d97e84171e9abcb7b5c85d">get_num_side_sets</a>(); i++)
<a name="l00982"></a>00982     {
<a name="l00983"></a>00983       offset += (i &gt; 0 ? <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a4edc84431dc0c83e9991eb66453685f2">get_num_sides_per_set</a>(i-1) : 0); <span class="comment">// Compute new offset</span>
<a name="l00984"></a>00984       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7e8af82fdd1f4fed93190bfa0c0fb2cb">read_sideset</a> (i, offset);
<a name="l00985"></a>00985     }
<a name="l00986"></a>00986 
<a name="l00987"></a>00987   <span class="comment">// Now that we have the lists of elements, sides, and IDs, we are ready to set them</span>
<a name="l00988"></a>00988   <span class="comment">// in the BoundaryInfo object of our Mesh object.  This is slightly different in parallel... </span>
<a name="l00989"></a>00989   <span class="comment">// For example, I think the IDs in each of the split Exodus files are numbered locally, </span>
<a name="l00990"></a>00990   <span class="comment">// and we have to know the appropriate ID for this processor to be able to set the</span>
<a name="l00991"></a>00991   <span class="comment">// entry in BoundaryInfo.  This offset should be given by my_elem_offset determined in </span>
<a name="l00992"></a>00992   <span class="comment">// this function...</span>
<a name="l00993"></a>00993 
<a name="l00994"></a>00994   <span class="comment">// Get references to the elem, side, and ID lists for this processor.  We should be</span>
<a name="l00995"></a>00995   <span class="comment">// able to get pointers to these elements on the local processor, and add them to the</span>
<a name="l00996"></a>00996   <span class="comment">// BoundaryInfo object</span>
<a name="l00997"></a>00997   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; elem_list = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a2791be975940e6c397e468611d6e8798">get_elem_list</a>();
<a name="l00998"></a>00998   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; side_list = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a60e82239f40a0e79335a925f6dd5f682">get_side_list</a>();
<a name="l00999"></a>00999   <span class="keyword">const</span> std::vector&lt;int&gt;&amp; id_list   = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a32ab0ea73058f9a343c14ce6e1eb65a4">get_id_list</a>();
<a name="l01000"></a>01000 
<a name="l01001"></a>01001 
<a name="l01002"></a>01002   <span class="comment">// Debugging:</span>
<a name="l01003"></a>01003   <span class="comment">// Print entries of elem_list</span>
<a name="l01004"></a>01004   <span class="comment">// libMesh::out &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;] &quot;</span>
<a name="l01005"></a>01005   <span class="comment">//           &lt;&lt; &quot;elem_list = &quot;;</span>
<a name="l01006"></a>01006   <span class="comment">// for (unsigned int e=0; e&lt;elem_list.size(); e++)</span>
<a name="l01007"></a>01007   <span class="comment">//   {</span>
<a name="l01008"></a>01008   <span class="comment">//     libMesh::out &lt;&lt; elem_list[e] &lt;&lt; &quot;, &quot;;</span>
<a name="l01009"></a>01009   <span class="comment">//   }</span>
<a name="l01010"></a>01010   <span class="comment">// libMesh::out &lt;&lt; std::endl;</span>
<a name="l01011"></a>01011 
<a name="l01012"></a>01012   <span class="comment">// Print entries of side_list</span>
<a name="l01013"></a>01013   <span class="comment">// libMesh::out &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;] &quot;</span>
<a name="l01014"></a>01014   <span class="comment">//           &lt;&lt; &quot;side_list = &quot;;</span>
<a name="l01015"></a>01015   <span class="comment">// for (unsigned int e=0; e&lt;side_list.size(); e++)</span>
<a name="l01016"></a>01016   <span class="comment">//   {</span>
<a name="l01017"></a>01017   <span class="comment">//     libMesh::out &lt;&lt; side_list[e] &lt;&lt; &quot;, &quot;;</span>
<a name="l01018"></a>01018   <span class="comment">//   }</span>
<a name="l01019"></a>01019   <span class="comment">// libMesh::out &lt;&lt; std::endl;</span>
<a name="l01020"></a>01020 
<a name="l01021"></a>01021 
<a name="l01022"></a>01022   <span class="comment">// Loop over the entries of the elem_list, get their pointers from the</span>
<a name="l01023"></a>01023   <span class="comment">// Mesh data structure, and assign the appropriate side to the BoundaryInfo object.</span>
<a name="l01024"></a>01024   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> e=0; e&lt;elem_list.size(); e++)
<a name="l01025"></a>01025     {
<a name="l01026"></a>01026       <span class="comment">// Calling mesh.elem() feels wrong, for example, in</span>
<a name="l01027"></a>01027       <span class="comment">// ParallelMesh, Mesh::elem() can return NULL so we have to check for this...</span>
<a name="l01028"></a>01028       <span class="comment">//</span>
<a name="l01029"></a>01029       <span class="comment">// Perhaps we should iterate over elements and look them up in</span>
<a name="l01030"></a>01030       <span class="comment">// the elem list instead?  Note that the IDs in elem_list are</span>
<a name="l01031"></a>01031       <span class="comment">// not necessarily in order, so if we did instead loop over the</span>
<a name="l01032"></a>01032       <span class="comment">// mesh, we would have to search the (unsorted) elem_list vector</span>
<a name="l01033"></a>01033       <span class="comment">// for each entry!  We&#39;ll settle for doing some error checking instead.</span>
<a name="l01034"></a>01034       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>(my_elem_offset + (elem_list[e]-1)<span class="comment">/*Exodus numbering is 1-based!*/</span>);
<a name="l01035"></a>01035 
<a name="l01036"></a>01036       <span class="keywordflow">if</span> (elem == NULL)
<a name="l01037"></a>01037         {
<a name="l01038"></a>01038           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ParallelMesh returned a NULL pointer when asked for element &quot;</span> 
<a name="l01039"></a>01039                        &lt;&lt; my_elem_offset &lt;&lt; <span class="stringliteral">&quot; + &quot;</span> &lt;&lt; elem_list[e] &lt;&lt; <span class="stringliteral">&quot; = &quot;</span> &lt;&lt; my_elem_offset+elem_list[e] &lt;&lt; std::endl;
<a name="l01040"></a>01040           libmesh_error();
<a name="l01041"></a>01041         }
<a name="l01042"></a>01042       
<a name="l01043"></a>01043       <span class="comment">// The side numberings in libmesh and exodus are not 1:1, so we need to map</span>
<a name="l01044"></a>01044       <span class="comment">// whatever side number is stored in Exodus into a libmesh side number using </span>
<a name="l01045"></a>01045       <span class="comment">// a conv object...</span>
<a name="l01046"></a>01046       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php">ExodusII_IO_Helper::Conversion</a> conv =
<a name="l01047"></a>01047         em.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1ElementMaps.php#ad7bd06525087dfbddb663f5330f1882f">assign_conversion</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad06f8ac22978144723179eed42d10bae">type</a>());
<a name="l01048"></a>01048 
<a name="l01049"></a>01049       <span class="comment">// Finally, we are ready to add the element and its side to the BoundaryInfo object.</span>
<a name="l01050"></a>01050       <span class="comment">// Call the version of add_side which takes a pointer, since we have already gone to</span>
<a name="l01051"></a>01051       <span class="comment">// the trouble of getting said pointer...</span>
<a name="l01052"></a>01052       mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_side (elem,
<a name="l01053"></a>01053                                     conv.<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper_1_1Conversion.php#a476e2be06fd2a76407446400e112ec10">get_side_map</a>(side_list[e]-1<span class="comment">/*Exodus numbering is 1-based*/</span>),
<a name="l01054"></a>01054                                     id_list[e]);
<a name="l01055"></a>01055     }
<a name="l01056"></a>01056 
<a name="l01057"></a>01057   <span class="comment">// Debugging: make sure there are as many boundary conditions in the</span>
<a name="l01058"></a>01058   <span class="comment">// boundary ID object as expected.  Note that, at this point, the</span>
<a name="l01059"></a>01059   <span class="comment">// mesh still thinks it&#39;s serial, so n_boundary_conds() returns the</span>
<a name="l01060"></a>01060   <span class="comment">// local number of boundary conditions (and is therefore cheap)</span>
<a name="l01061"></a>01061   <span class="comment">// which should match elem_list.size().</span>
<a name="l01062"></a>01062   {
<a name="l01063"></a>01063     <span class="keywordtype">unsigned</span> nbcs = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;n_boundary_conds();
<a name="l01064"></a>01064     <span class="keywordflow">if</span> (nbcs != elem_list.size())
<a name="l01065"></a>01065       {
<a name="l01066"></a>01066         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l01067"></a>01067         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;BoundaryInfo contains &quot;</span> 
<a name="l01068"></a>01068                      &lt;&lt; nbcs
<a name="l01069"></a>01069                      &lt;&lt; <span class="stringliteral">&quot; boundary conditions, while the Exodus file had &quot;</span> 
<a name="l01070"></a>01070                      &lt;&lt; elem_list.size()
<a name="l01071"></a>01071                      &lt;&lt; std::endl;
<a name="l01072"></a>01072         libmesh_error();
<a name="l01073"></a>01073       }
<a name="l01074"></a>01074   }
<a name="l01075"></a>01075 
<a name="l01076"></a>01076   <span class="comment">// Read global nodeset parameters?  We might be able to use this to verify</span>
<a name="l01077"></a>01077   <span class="comment">// something about the local files, but I haven&#39;t figured out what yet...</span>
<a name="l01078"></a>01078   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aa5b0ba0cf8ad0a3dd7270465895532c9">get_ns_param_global</a>();
<a name="l01079"></a>01079 
<a name="l01080"></a>01080   <span class="comment">// Read local nodeset info</span>
<a name="l01081"></a>01081   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a08200f195605daac61ad8d56a29ec435">read_nodeset_info</a>();
<a name="l01082"></a>01082   
<a name="l01083"></a>01083   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l01084"></a>01084     {
<a name="l01085"></a>01085       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l01086"></a>01086       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;nemhelper-&gt;num_node_sets=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a729156bcdd57603a31fb4b62ffbd37a5">num_node_sets</a> &lt;&lt; std::endl;
<a name="l01087"></a>01087     }  
<a name="l01088"></a>01088 
<a name="l01089"></a>01089 <span class="comment">//  // Debugging, what is currently in nemhelper-&gt;node_num_map anyway?</span>
<a name="l01090"></a>01090 <span class="comment">//  libMesh::out &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;] &quot;</span>
<a name="l01091"></a>01091 <span class="comment">//             &lt;&lt; &quot;nemhelper-&gt;node_num_map = &quot;;</span>
<a name="l01092"></a>01092 <span class="comment">//</span>
<a name="l01093"></a>01093 <span class="comment">//  for (unsigned int i=0; i&lt;nemhelper-&gt;node_num_map.size(); ++i)</span>
<a name="l01094"></a>01094 <span class="comment">//    libMesh::out &lt;&lt; nemhelper-&gt;node_num_map[i] &lt;&lt; &quot;, &quot;;</span>
<a name="l01095"></a>01095 <span class="comment">//  libMesh::out &lt;&lt; std::endl;</span>
<a name="l01096"></a>01096 
<a name="l01097"></a>01097   <span class="comment">// For each nodeset, </span>
<a name="l01098"></a>01098   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> nodeset=0; nodeset&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a452f165e7cfe0627066e68cdc132527f">get_num_node_sets</a>(); nodeset++)
<a name="l01099"></a>01099     {
<a name="l01100"></a>01100       <span class="comment">// Get the user-defined ID associcated with the nodeset</span>
<a name="l01101"></a>01101       <span class="keywordtype">int</span> nodeset_id = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#ad294983ff602b7e2d4668a58b3b7704c">get_nodeset_id</a>(nodeset);
<a name="l01102"></a>01102 
<a name="l01103"></a>01103       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l01104"></a>01104         {
<a name="l01105"></a>01105           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l01106"></a>01106           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;nemhelper-&gt;get_nodeset_id(&quot;</span> &lt;&lt; nodeset &lt;&lt; <span class="stringliteral">&quot;)=&quot;</span> &lt;&lt; nodeset_id &lt;&lt; std::endl;
<a name="l01107"></a>01107         }
<a name="l01108"></a>01108         
<a name="l01109"></a>01109       <span class="comment">// Read the nodeset from file, store them in a vector</span>
<a name="l01110"></a>01110       <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#af6f691a32892f4eb9377dba60fe26b31">read_nodeset</a>(nodeset);
<a name="l01111"></a>01111 
<a name="l01112"></a>01112       <span class="comment">// Get access to that vector</span>
<a name="l01113"></a>01113       <span class="keyword">const</span> std::vector&lt;int&gt;&amp; node_list = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a3cbb6a733154af7d6e5a79f44f1ee506">get_node_list</a>();
<a name="l01114"></a>01114       
<a name="l01115"></a>01115       <span class="comment">// Add nodes from the node_list to the BoundaryInfo object</span>
<a name="l01116"></a>01116       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node=0; node&lt;node_list.size(); node++)
<a name="l01117"></a>01117         {
<a name="l01118"></a>01118           <span class="comment">// Don&#39;t run past the end of our node map!</span>
<a name="l01119"></a>01119           <span class="keywordflow">if</span> (to_uint(node_list[node]-1) &gt;= <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>.size())
<a name="l01120"></a>01120             {
<a name="l01121"></a>01121               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Error, index is past the end of node_num_map array!&quot;</span> &lt;&lt; std::endl;
<a name="l01122"></a>01122               libmesh_error();
<a name="l01123"></a>01123             }
<a name="l01124"></a>01124           
<a name="l01125"></a>01125           <span class="comment">// We should be able to use the node_num_map data structure set up previously to determine</span>
<a name="l01126"></a>01126           <span class="comment">// the proper global node index.</span>
<a name="l01127"></a>01127           <span class="keywordtype">unsigned</span> global_node_id = <a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a6e11f33dc102e99b12ed8ea9ac677231">node_num_map</a>[ node_list[node]-1 <span class="comment">/*Exodus is 1-based!*/</span> ];
<a name="l01128"></a>01128 
<a name="l01129"></a>01129           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l01130"></a>01130             {
<a name="l01131"></a>01131               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l01132"></a>01132                            &lt;&lt; <span class="stringliteral">&quot;nodeset &quot;</span> &lt;&lt; nodeset
<a name="l01133"></a>01133                            &lt;&lt; <span class="stringliteral">&quot;, local node number: &quot;</span> &lt;&lt; node_list[node]-1
<a name="l01134"></a>01134                            &lt;&lt; <span class="stringliteral">&quot;, global node id: &quot;</span> &lt;&lt; global_node_id
<a name="l01135"></a>01135                            &lt;&lt; std::endl;
<a name="l01136"></a>01136             }
<a name="l01137"></a>01137 
<a name="l01138"></a>01138           <span class="comment">// Add the node to the BoundaryInfo object with the proper nodeset_id</span>
<a name="l01139"></a>01139           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;add_node(global_node_id, nodeset_id);
<a name="l01140"></a>01140         }
<a name="l01141"></a>01141     }
<a name="l01142"></a>01142   
<a name="l01143"></a>01143   <span class="comment">// See what the elem count is up to now.</span>
<a name="l01144"></a>01144   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>)
<a name="l01145"></a>01145     {
<a name="l01146"></a>01146       <span class="comment">// Report the number of elements which have been added locally</span>
<a name="l01147"></a>01147       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l01148"></a>01148       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mesh.n_elem()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() &lt;&lt; std::endl;
<a name="l01149"></a>01149 
<a name="l01150"></a>01150       <span class="comment">// Reports the number of elements that have been added in total.</span>
<a name="l01151"></a>01151       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l01152"></a>01152       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;mesh.parallel_n_elem()=&quot;</span> &lt;&lt; mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">parallel_n_elem</a>() &lt;&lt; std::endl;
<a name="l01153"></a>01153     }
<a name="l01154"></a>01154 
<a name="l01155"></a>01155   STOP_LOG (<span class="stringliteral">&quot;read()&quot;</span>,<span class="stringliteral">&quot;Nemesis_IO&quot;</span>);
<a name="l01156"></a>01156 
<a name="l01157"></a>01157   <span class="comment">// For ParallelMesh, it seems that _is_serial is true by default.  A hack to</span>
<a name="l01158"></a>01158   <span class="comment">// make the Mesh think it&#39;s parallel might be to call:</span>
<a name="l01159"></a>01159   mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a01627aec710b8452f66d3610bc461a8b">delete_remote_elements</a>();
<a name="l01160"></a>01160 
<a name="l01161"></a>01161   <span class="comment">// Gather neighboring elements so that the mesh has the proper &quot;ghost&quot; neighbor information.</span>
<a name="l01162"></a>01162   <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#a1b5bcfce3b9a9daccb4abb795a0638e0">gather_neighboring_elements</a>(mesh);
<a name="l01163"></a>01163 }
<a name="l01164"></a>01164 
<a name="l01165"></a>01165 <span class="preprocessor">#else</span>
<a name="l01166"></a>01166 <span class="preprocessor"></span>
<a name="l01167"></a>01167 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a976d74c57a65812c355af28c55b6e8f5">Nemesis_IO::read</a> (<span class="keyword">const</span> std::string&amp; )
<a name="l01168"></a>01168 {
<a name="l01169"></a>01169   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt;  <span class="stringliteral">&quot;ERROR, Nemesis API is not defined!&quot;</span> &lt;&lt; std::endl;
<a name="l01170"></a>01170   libmesh_error();
<a name="l01171"></a>01171 }
<a name="l01172"></a>01172 
<a name="l01173"></a>01173 <span class="preprocessor">#endif</span>
<a name="l01174"></a>01174 <span class="preprocessor"></span>
<a name="l01175"></a>01175 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
