<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">nemesis_io.h</div>  </div>
</div>
<div class="contents">
<a href="nemesis__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nemesis_io.h 3944 2010-08-26 19:00:39Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __nemesis_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __nemesis_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ inludes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__input_8h.php">mesh_input.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="comment">//#include &quot;mesh_output.h&quot; // eventually...</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// Forward declarations</span>
<a name="l00036"></a>00036 <span class="keyword">class </span>ParallelMesh;
<a name="l00037"></a>00037 <span class="keyword">class </span>Nemesis_IO_Helper;
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00052"></a>00052 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00053"></a>00053 <span class="comment">// Nemesis_IO class definition</span>
<a name="l00054"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php">00054</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Nemesis__IO.php">Nemesis_IO</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshInput.php">MeshInput</a>&lt;ParallelMesh&gt;
<a name="l00055"></a>00055 <span class="comment">//,public MeshOutput&lt;MeshBase&gt;</span>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 
<a name="l00058"></a>00058  <span class="keyword">public</span>:
<a name="l00059"></a>00059 
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1Nemesis__IO.php#af3b8bd661b51a9ae2ab5dc32a3751da2">Nemesis_IO</a> (<a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp; <a class="code" href="classlibMesh_1_1MeshInput.php#ac18df20ac8c6a96bc404d08bae1e481b">mesh</a>);
<a name="l00065"></a>00065   
<a name="l00069"></a>00069   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a30ad9757ce1d0b41e213c0366fc11a8c">~Nemesis_IO</a> ();
<a name="l00070"></a>00070 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a976d74c57a65812c355af28c55b6e8f5">read</a> (<span class="keyword">const</span> std::string&amp; base_filename);
<a name="l00077"></a>00077 
<a name="l00081"></a>00081   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#a530d8f40acc55b2cb98b0e440e8dc40a">verbose</a> (<span class="keywordtype">bool</span> set_verbosity);
<a name="l00082"></a>00082   
<a name="l00083"></a>00083 <span class="keyword">private</span>:
<a name="l00084"></a>00084 <span class="preprocessor">#if defined(LIBMESH_HAVE_EXODUS_API) &amp;&amp; defined(LIBMESH_HAVE_NEMESIS_API)</span>
<a name="l00085"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">00085</a> <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php">Nemesis_IO_Helper</a> *<a class="code" href="classlibMesh_1_1Nemesis__IO.php#add64fa9ad9b64491c78a654d403c0ddc">nemhelper</a>;
<a name="l00086"></a>00086 <span class="preprocessor">#endif</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>
<a name="l00088"></a><a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">00088</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Nemesis__IO.php#afdb38616a68787357c4f74f83ad3c3aa">_verbose</a>;
<a name="l00089"></a>00089 };
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 } <span class="comment">// namespace libMesh</span>
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 <span class="preprocessor">#endif // #ifndef __nemesis_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
