<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">nemesis_io_helper.C</div>  </div>
</div>
<div class="contents">
<a href="nemesis__io__helper_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nemesis_io_helper.C 4335 2011-04-11 19:52:03Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="nemesis__io__helper_8h.php">nemesis_io_helper.h</a>&quot;</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#if defined(LIBMESH_HAVE_NEMESIS_API) &amp;&amp; defined(LIBMESH_HAVE_EXODUS_API)</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Initialize the various integer members to zero.  We can check</span>
<a name="l00030"></a>00030 <span class="comment">// these later to see if they&#39;ve been properly initialized...</span>
<a name="l00031"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a79ad26a7e185237b62cb2f43299be735">00031</a> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a79ad26a7e185237b62cb2f43299be735">Nemesis_IO_Helper::Nemesis_IO_Helper</a>(<span class="keywordtype">bool</span> verbose) :
<a name="l00032"></a>00032   <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php">ExodusII_IO_Helper</a>(verbose),
<a name="l00033"></a>00033   nemesis_err_flag(0),
<a name="l00034"></a>00034   num_nodes_global(0),
<a name="l00035"></a>00035   num_elems_global(0),
<a name="l00036"></a>00036   num_elem_blks_global(0),
<a name="l00037"></a>00037   num_node_sets_global(0),
<a name="l00038"></a>00038   num_side_sets_global(0),
<a name="l00039"></a>00039   num_proc(0),
<a name="l00040"></a>00040   num_proc_in_file(0),
<a name="l00041"></a>00041   ftype(<span class="stringliteral">&#39;\0&#39;</span>),
<a name="l00042"></a>00042   num_internal_nodes(0),
<a name="l00043"></a>00043   num_border_nodes(0),
<a name="l00044"></a>00044   num_external_nodes(0),
<a name="l00045"></a>00045   num_internal_elems(0),
<a name="l00046"></a>00046   num_border_elems(0),
<a name="l00047"></a>00047   num_node_cmaps(0),
<a name="l00048"></a>00048   num_elem_cmaps(0)
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   <span class="comment">// Warn about using untested code!</span>
<a name="l00051"></a>00051   libmesh_experimental();
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec9403b95b5d8df5fc1ff4af7ef0a4cc">00055</a> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec9403b95b5d8df5fc1ff4af7ef0a4cc">Nemesis_IO_Helper::~Nemesis_IO_Helper</a>()
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="comment">// void Nemesis_IO_Helper::verbose (bool set_verbosity)</span>
<a name="l00062"></a>00062 <span class="comment">// {</span>
<a name="l00063"></a>00063 <span class="comment">//   _verbose = set_verbosity;</span>
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">//   // Also set verbosity in the exodus helper object</span>
<a name="l00066"></a>00066 <span class="comment">//   ex2helper.verbose(_verbose);</span>
<a name="l00067"></a>00067 <span class="comment">// }</span>
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a58f32d4bd0357125c5a22778fb59650f">00071</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a58f32d4bd0357125c5a22778fb59650f">Nemesis_IO_Helper::get_init_global</a>()
<a name="l00072"></a>00072 {
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00074"></a>00074     Nemesis::ne_get_init_global(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00075"></a>00075                                 &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">num_nodes_global</a>,
<a name="l00076"></a>00076                                 &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a428c62b9b28577fb377d085b6cf3fbf3">num_elems_global</a>,
<a name="l00077"></a>00077                                 &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a805da8a5dc52de083338209cd399b704">num_elem_blks_global</a>,
<a name="l00078"></a>00078                                 &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afc538b97549c6327366f45cb90b95fb3">num_node_sets_global</a>,
<a name="l00079"></a>00079                                 &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad1cff73aa4746d8ca6b7cd578edddbd6">num_side_sets_global</a>);
<a name="l00080"></a>00080   this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading initial global data!&quot;</span>);
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00083"></a>00083     {
<a name="l00084"></a>00084       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_nodes_global=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">num_nodes_global</a> &lt;&lt; std::endl;
<a name="l00085"></a>00085       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_elems_global=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a428c62b9b28577fb377d085b6cf3fbf3">num_elems_global</a> &lt;&lt; std::endl;
<a name="l00086"></a>00086       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_elem_blks_global=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a805da8a5dc52de083338209cd399b704">num_elem_blks_global</a> &lt;&lt; std::endl;
<a name="l00087"></a>00087       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_node_sets_global=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afc538b97549c6327366f45cb90b95fb3">num_node_sets_global</a> &lt;&lt; std::endl;
<a name="l00088"></a>00088       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_side_sets_global=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad1cff73aa4746d8ca6b7cd578edddbd6">num_side_sets_global</a> &lt;&lt; std::endl;
<a name="l00089"></a>00089     }
<a name="l00090"></a>00090 }
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a38c95a1f14084ff7d654f85b63a62d2b">00094</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a38c95a1f14084ff7d654f85b63a62d2b">Nemesis_IO_Helper::get_ss_param_global</a>()
<a name="l00095"></a>00095 {
<a name="l00096"></a>00096   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad1cff73aa4746d8ca6b7cd578edddbd6">num_side_sets_global</a> &gt; 0)
<a name="l00097"></a>00097     {
<a name="l00098"></a>00098       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af788a42ffedcc5a5552ecce5864e82cb">global_sideset_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad1cff73aa4746d8ca6b7cd578edddbd6">num_side_sets_global</a>);
<a name="l00099"></a>00099       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a7f5a5ba3ea3dc237cd0cb9a05dc1aef3">num_global_side_counts</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad1cff73aa4746d8ca6b7cd578edddbd6">num_side_sets_global</a>);
<a name="l00100"></a>00100 
<a name="l00101"></a>00101       <span class="comment">// df = &quot;distribution factor&quot;, not really sure what that is.  I don&#39;t yet have a file</span>
<a name="l00102"></a>00102       <span class="comment">// which has distribution factors so I guess we&#39;ll worry about it later...</span>
<a name="l00103"></a>00103       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a76719fca83e9a986ee145599e3f5004b">num_global_side_df_counts</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad1cff73aa4746d8ca6b7cd578edddbd6">num_side_sets_global</a>);
<a name="l00104"></a>00104       
<a name="l00105"></a>00105       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00106"></a>00106         Nemesis::ne_get_ss_param_global(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00107"></a>00107                                         <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af788a42ffedcc5a5552ecce5864e82cb">global_sideset_ids</a>.empty()        ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af788a42ffedcc5a5552ecce5864e82cb">global_sideset_ids</a>[0],
<a name="l00108"></a>00108                                         <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a7f5a5ba3ea3dc237cd0cb9a05dc1aef3">num_global_side_counts</a>.empty()    ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a7f5a5ba3ea3dc237cd0cb9a05dc1aef3">num_global_side_counts</a>[0],
<a name="l00109"></a>00109                                         <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a76719fca83e9a986ee145599e3f5004b">num_global_side_df_counts</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a76719fca83e9a986ee145599e3f5004b">num_global_side_df_counts</a>[0]);
<a name="l00110"></a>00110       this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading global sideset parameters!&quot;</span>);
<a name="l00111"></a>00111 
<a name="l00112"></a>00112       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00113"></a>00113         {
<a name="l00114"></a>00114           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;Global Sideset IDs, Side Counts, and DF counts:&quot;</span> &lt;&lt; std::endl;
<a name="l00115"></a>00115           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bn=0; bn&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af788a42ffedcc5a5552ecce5864e82cb">global_sideset_ids</a>.size(); ++bn)
<a name="l00116"></a>00116             {
<a name="l00117"></a>00117               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  [&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00118"></a>00118                         &lt;&lt; <span class="stringliteral">&quot;global_sideset_ids[&quot;</span>&lt;&lt;bn&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af788a42ffedcc5a5552ecce5864e82cb">global_sideset_ids</a>[bn]
<a name="l00119"></a>00119                         &lt;&lt; <span class="stringliteral">&quot;, num_global_side_counts[&quot;</span>&lt;&lt;bn&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a7f5a5ba3ea3dc237cd0cb9a05dc1aef3">num_global_side_counts</a>[bn]
<a name="l00120"></a>00120                         &lt;&lt; <span class="stringliteral">&quot;, num_global_side_df_counts[&quot;</span>&lt;&lt;bn&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a76719fca83e9a986ee145599e3f5004b">num_global_side_df_counts</a>[bn]
<a name="l00121"></a>00121                         &lt;&lt; std::endl;
<a name="l00122"></a>00122             }
<a name="l00123"></a>00123         }
<a name="l00124"></a>00124     }
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aa5b0ba0cf8ad0a3dd7270465895532c9">00130</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aa5b0ba0cf8ad0a3dd7270465895532c9">Nemesis_IO_Helper::get_ns_param_global</a>()
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afc538b97549c6327366f45cb90b95fb3">num_node_sets_global</a> &gt; 0)
<a name="l00133"></a>00133     {
<a name="l00134"></a>00134       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ab550709daf851529cb0600340f6910dd">global_nodeset_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afc538b97549c6327366f45cb90b95fb3">num_node_sets_global</a>);
<a name="l00135"></a>00135       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac3c8e99b92a3306e23b3c3ca4a433093">num_global_node_counts</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afc538b97549c6327366f45cb90b95fb3">num_node_sets_global</a>);
<a name="l00136"></a>00136       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aaaff44c34077b5c5e9fba35b5bcd6d5f">num_global_node_df_counts</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afc538b97549c6327366f45cb90b95fb3">num_node_sets_global</a>);
<a name="l00137"></a>00137       
<a name="l00138"></a>00138       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00139"></a>00139         Nemesis::ne_get_ns_param_global(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00140"></a>00140                                         <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ab550709daf851529cb0600340f6910dd">global_nodeset_ids</a>.empty()        ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ab550709daf851529cb0600340f6910dd">global_nodeset_ids</a>[0],
<a name="l00141"></a>00141                                         <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac3c8e99b92a3306e23b3c3ca4a433093">num_global_node_counts</a>.empty()    ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac3c8e99b92a3306e23b3c3ca4a433093">num_global_node_counts</a>[0],
<a name="l00142"></a>00142                                         <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aaaff44c34077b5c5e9fba35b5bcd6d5f">num_global_node_df_counts</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aaaff44c34077b5c5e9fba35b5bcd6d5f">num_global_node_df_counts</a>[0]);
<a name="l00143"></a>00143       this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading global nodeset parameters!&quot;</span>);
<a name="l00144"></a>00144 
<a name="l00145"></a>00145       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00146"></a>00146         {
<a name="l00147"></a>00147           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;Global Nodeset IDs, Node Counts, and DF counts:&quot;</span> &lt;&lt; std::endl;
<a name="l00148"></a>00148           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bn=0; bn&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ab550709daf851529cb0600340f6910dd">global_nodeset_ids</a>.size(); ++bn)
<a name="l00149"></a>00149             {
<a name="l00150"></a>00150               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  [&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00151"></a>00151                             &lt;&lt; <span class="stringliteral">&quot;global_nodeset_ids[&quot;</span>&lt;&lt;bn&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ab550709daf851529cb0600340f6910dd">global_nodeset_ids</a>[bn]
<a name="l00152"></a>00152                             &lt;&lt; <span class="stringliteral">&quot;, num_global_node_counts[&quot;</span>&lt;&lt;bn&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac3c8e99b92a3306e23b3c3ca4a433093">num_global_node_counts</a>[bn]
<a name="l00153"></a>00153                             &lt;&lt; <span class="stringliteral">&quot;, num_global_node_df_counts[&quot;</span>&lt;&lt;bn&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aaaff44c34077b5c5e9fba35b5bcd6d5f">num_global_node_df_counts</a>[bn]
<a name="l00154"></a>00154                             &lt;&lt; std::endl;
<a name="l00155"></a>00155             }
<a name="l00156"></a>00156         }
<a name="l00157"></a>00157     }
<a name="l00158"></a>00158 }
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac1ff2be6140d2002737acdbc30bcd885">00162</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac1ff2be6140d2002737acdbc30bcd885">Nemesis_IO_Helper::get_eb_info_global</a>()
<a name="l00163"></a>00163 {
<a name="l00164"></a>00164   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a9d61e1426726ab2c3b207716a0db1ff3">global_elem_blk_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a805da8a5dc52de083338209cd399b704">num_elem_blks_global</a>);
<a name="l00165"></a>00165   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a4757994f9aaf16c05377e8472c80ffeb">global_elem_blk_cnts</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a805da8a5dc52de083338209cd399b704">num_elem_blks_global</a>);
<a name="l00166"></a>00166   
<a name="l00167"></a>00167   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00168"></a>00168     Nemesis::ne_get_eb_info_global(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00169"></a>00169                                    <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a9d61e1426726ab2c3b207716a0db1ff3">global_elem_blk_ids</a>.empty()  ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a9d61e1426726ab2c3b207716a0db1ff3">global_elem_blk_ids</a>[0],
<a name="l00170"></a>00170                                    <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a4757994f9aaf16c05377e8472c80ffeb">global_elem_blk_cnts</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a4757994f9aaf16c05377e8472c80ffeb">global_elem_blk_cnts</a>[0]);                       
<a name="l00171"></a>00171   this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading global element block info!&quot;</span>);
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00174"></a>00174     {
<a name="l00175"></a>00175       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;Global Element Block IDs and Counts:&quot;</span> &lt;&lt; std::endl;
<a name="l00176"></a>00176       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bn=0; bn&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a9d61e1426726ab2c3b207716a0db1ff3">global_elem_blk_ids</a>.size(); ++bn)
<a name="l00177"></a>00177         {
<a name="l00178"></a>00178           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  [&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>
<a name="l00179"></a>00179                         &lt;&lt; <span class="stringliteral">&quot;global_elem_blk_ids[&quot;</span>&lt;&lt;bn&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a9d61e1426726ab2c3b207716a0db1ff3">global_elem_blk_ids</a>[bn]
<a name="l00180"></a>00180                         &lt;&lt; <span class="stringliteral">&quot;, global_elem_blk_cnts[&quot;</span>&lt;&lt;bn&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a4757994f9aaf16c05377e8472c80ffeb">global_elem_blk_cnts</a>[bn]
<a name="l00181"></a>00181                         &lt;&lt; std::endl;
<a name="l00182"></a>00182         }
<a name="l00183"></a>00183     }
<a name="l00184"></a>00184 }
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af327d4523f60cbee6dba2d49e3046d7c">00188</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af327d4523f60cbee6dba2d49e3046d7c">Nemesis_IO_Helper::get_init_info</a>()
<a name="l00189"></a>00189 {
<a name="l00190"></a>00190   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00191"></a>00191     Nemesis::ne_get_init_info(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00192"></a>00192                               &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aedbf0f2fd37e3268ab66ba1b446d0388">num_proc</a>,
<a name="l00193"></a>00193                               &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a49acded6135ff46cf2d0ba9a41350ae5">num_proc_in_file</a>,
<a name="l00194"></a>00194                               &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a3aacd3c247b7de59a604e55ec190d9c1">ftype</a>);
<a name="l00195"></a>00195   this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading initial info!&quot;</span>);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00198"></a>00198     {
<a name="l00199"></a>00199       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_proc=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aedbf0f2fd37e3268ab66ba1b446d0388">num_proc</a> &lt;&lt; std::endl;
<a name="l00200"></a>00200       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_proc_in_file=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a49acded6135ff46cf2d0ba9a41350ae5">num_proc_in_file</a> &lt;&lt; std::endl;
<a name="l00201"></a>00201       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;ftype=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a3aacd3c247b7de59a604e55ec190d9c1">ftype</a> &lt;&lt; std::endl;
<a name="l00202"></a>00202     }
<a name="l00203"></a>00203 }
<a name="l00204"></a>00204 
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae9d2c643dac85d53e610e5d2e8224a6f">00207</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae9d2c643dac85d53e610e5d2e8224a6f">Nemesis_IO_Helper::get_loadbal_param</a>()
<a name="l00208"></a>00208 {
<a name="l00209"></a>00209   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00210"></a>00210     Nemesis::ne_get_loadbal_param(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00211"></a>00211                                   &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a>,
<a name="l00212"></a>00212                                   &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>,
<a name="l00213"></a>00213                                   &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">num_external_nodes</a>,
<a name="l00214"></a>00214                                   &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">num_internal_elems</a>,
<a name="l00215"></a>00215                                   &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">num_border_elems</a>,
<a name="l00216"></a>00216                                   &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>,
<a name="l00217"></a>00217                                   &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a>,
<a name="l00218"></a>00218                                   <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() <span class="comment">// The ID of the processor for which info is to be read</span>
<a name="l00219"></a>00219                                   );
<a name="l00220"></a>00220   this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading load balance parameters!&quot;</span>);
<a name="l00221"></a>00221         
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00224"></a>00224     {
<a name="l00225"></a>00225       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_internal_nodes=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a> &lt;&lt; std::endl;
<a name="l00226"></a>00226       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_border_nodes=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a> &lt;&lt; std::endl;
<a name="l00227"></a>00227       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_external_nodes=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">num_external_nodes</a> &lt;&lt; std::endl;
<a name="l00228"></a>00228       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_internal_elems=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">num_internal_elems</a> &lt;&lt; std::endl;
<a name="l00229"></a>00229       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_border_elems=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">num_border_elems</a> &lt;&lt; std::endl;
<a name="l00230"></a>00230       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_node_cmaps=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a> &lt;&lt; std::endl;
<a name="l00231"></a>00231       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;num_elem_cmaps=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a> &lt;&lt; std::endl;
<a name="l00232"></a>00232     }
<a name="l00233"></a>00233 }
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afb6e8a2ae7638eef7346204803425189">00237</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afb6e8a2ae7638eef7346204803425189">Nemesis_IO_Helper::get_elem_map</a>()
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a77cabe86cb1296ed052849e4259ac704">elem_mapi</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">num_internal_elems</a>);
<a name="l00240"></a>00240   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a46a2ba3da3e77bc5517846854a7a9fb2">elem_mapb</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">num_border_elems</a>);
<a name="l00241"></a>00241   
<a name="l00242"></a>00242   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00243"></a>00243     Nemesis::ne_get_elem_map(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00244"></a>00244                              <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a77cabe86cb1296ed052849e4259ac704">elem_mapi</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a77cabe86cb1296ed052849e4259ac704">elem_mapi</a>[0],
<a name="l00245"></a>00245                              <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a46a2ba3da3e77bc5517846854a7a9fb2">elem_mapb</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a46a2ba3da3e77bc5517846854a7a9fb2">elem_mapb</a>[0],
<a name="l00246"></a>00246                              <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()
<a name="l00247"></a>00247                              );
<a name="l00248"></a>00248   this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading element maps!&quot;</span>);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00252"></a>00252     {
<a name="l00253"></a>00253       <span class="comment">// These are not contiguous ranges....</span>
<a name="l00254"></a>00254       <span class="comment">//libMesh::out &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;] &quot; &lt;&lt; &quot;first interior elem id=&quot; &lt;&lt; elem_mapi[0] &lt;&lt; std::endl;</span>
<a name="l00255"></a>00255       <span class="comment">//libMesh::out &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;] &quot; &lt;&lt; &quot;last interior elem id=&quot; &lt;&lt; elem_mapi.back() &lt;&lt; std::endl;</span>
<a name="l00256"></a>00256       <span class="comment">//libMesh::out &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;] &quot; &lt;&lt; &quot;first boundary elem id=&quot; &lt;&lt; elem_mapb[0] &lt;&lt; std::endl;</span>
<a name="l00257"></a>00257       <span class="comment">//libMesh::out &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;] &quot; &lt;&lt; &quot;last boundary elem id=&quot; &lt;&lt; elem_mapb.back() &lt;&lt; std::endl;</span>
<a name="l00258"></a>00258       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] elem_mapi[i] = &quot;</span>;
<a name="l00259"></a>00259       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">num_internal_elems</a>-1); ++i)
<a name="l00260"></a>00260         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a77cabe86cb1296ed052849e4259ac704">elem_mapi</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00261"></a>00261       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;... &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a77cabe86cb1296ed052849e4259ac704">elem_mapi</a>.back() &lt;&lt; std::endl;
<a name="l00262"></a>00262 
<a name="l00263"></a>00263       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] elem_mapb[i] = &quot;</span>;
<a name="l00264"></a>00264       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt; static_cast&lt;unsigned int&gt;(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(10, <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">num_border_elems</a>-1)); ++i)
<a name="l00265"></a>00265         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a46a2ba3da3e77bc5517846854a7a9fb2">elem_mapb</a>[i] &lt;&lt; <span class="stringliteral">&quot;, &quot;</span>;
<a name="l00266"></a>00266       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;... &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a46a2ba3da3e77bc5517846854a7a9fb2">elem_mapb</a>.back() &lt;&lt; std::endl;
<a name="l00267"></a>00267     }
<a name="l00268"></a>00268 }
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00273"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1d46473b4a62c8d11fc6beda0e3215f5">00273</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1d46473b4a62c8d11fc6beda0e3215f5">Nemesis_IO_Helper::get_node_map</a>()
<a name="l00274"></a>00274 {
<a name="l00275"></a>00275   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a>);
<a name="l00276"></a>00276   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>);
<a name="l00277"></a>00277   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8adf1fe9838d266d02a589b715504e84">node_mape</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">num_external_nodes</a>);
<a name="l00278"></a>00278   
<a name="l00279"></a>00279   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00280"></a>00280     Nemesis::ne_get_node_map(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00281"></a>00281                              <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>[0],
<a name="l00282"></a>00282                              <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>[0],
<a name="l00283"></a>00283                              <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8adf1fe9838d266d02a589b715504e84">node_mape</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8adf1fe9838d266d02a589b715504e84">node_mape</a>[0], 
<a name="l00284"></a>00284                              <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()
<a name="l00285"></a>00285                              );
<a name="l00286"></a>00286   this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading node maps!&quot;</span>);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00289"></a>00289     {
<a name="l00290"></a>00290       <span class="comment">// Remark: The Exodus/Nemesis node numbring is always (?) 1-based!  This means the first interior node id will</span>
<a name="l00291"></a>00291       <span class="comment">// always be == 1.</span>
<a name="l00292"></a>00292       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;first interior node id=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>[0] &lt;&lt; std::endl;
<a name="l00293"></a>00293       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;last interior node id=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>.back() &lt;&lt; std::endl;
<a name="l00294"></a>00294 
<a name="l00295"></a>00295       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;first boundary node id=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>[0] &lt;&lt; std::endl;
<a name="l00296"></a>00296       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;last boundary node id=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>.back() &lt;&lt; std::endl;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298       <span class="comment">// The number of external nodes is sometimes zero, don&#39;t try to access</span>
<a name="l00299"></a>00299       <span class="comment">// node_mape.back() in this case!</span>
<a name="l00300"></a>00300       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">num_external_nodes</a> &gt; 0)
<a name="l00301"></a>00301         {
<a name="l00302"></a>00302           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;first external node id=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8adf1fe9838d266d02a589b715504e84">node_mape</a>[0] &lt;&lt; std::endl;
<a name="l00303"></a>00303           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span> &lt;&lt; <span class="stringliteral">&quot;last external node id=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8adf1fe9838d266d02a589b715504e84">node_mape</a>.back() &lt;&lt; std::endl;
<a name="l00304"></a>00304         }
<a name="l00305"></a>00305     }
<a name="l00306"></a>00306 }
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 
<a name="l00309"></a>00309 
<a name="l00310"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a653b6229679c6fa0f56952523b3b8302">00310</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a653b6229679c6fa0f56952523b3b8302">Nemesis_IO_Helper::get_cmap_params</a>()
<a name="l00311"></a>00311 {
<a name="l00312"></a>00312   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>);
<a name="l00313"></a>00313   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>);
<a name="l00314"></a>00314   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae2e2e7cb416a2b88d6f58a1970a24237">elem_cmap_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a>);
<a name="l00315"></a>00315   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">elem_cmap_elem_cnts</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a>);
<a name="l00316"></a>00316   
<a name="l00317"></a>00317   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00318"></a>00318     Nemesis::ne_get_cmap_params(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00319"></a>00319                                 <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>.empty()       ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[0],
<a name="l00320"></a>00320                                 <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[0],
<a name="l00321"></a>00321                                 <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae2e2e7cb416a2b88d6f58a1970a24237">elem_cmap_ids</a>.empty()       ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae2e2e7cb416a2b88d6f58a1970a24237">elem_cmap_ids</a>[0],
<a name="l00322"></a>00322                                 <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">elem_cmap_elem_cnts</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">elem_cmap_elem_cnts</a>[0],
<a name="l00323"></a>00323                                 <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00324"></a>00324   this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading cmap parameters!&quot;</span>);
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00328"></a>00328     {
<a name="l00329"></a>00329       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00330"></a>00330       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>.size(); ++i)
<a name="l00331"></a>00331         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;node_cmap_ids[&quot;</span>&lt;&lt;i&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00332"></a>00332       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00333"></a>00333         
<a name="l00334"></a>00334       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00335"></a>00335       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>.size(); ++i)
<a name="l00336"></a>00336         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;node_cmap_node_cnts[&quot;</span>&lt;&lt;i&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00337"></a>00337       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00338"></a>00338 
<a name="l00339"></a>00339       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00340"></a>00340       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae2e2e7cb416a2b88d6f58a1970a24237">elem_cmap_ids</a>.size(); ++i)
<a name="l00341"></a>00341         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;elem_cmap_ids[&quot;</span>&lt;&lt;i&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae2e2e7cb416a2b88d6f58a1970a24237">elem_cmap_ids</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00342"></a>00342       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00343"></a>00343 
<a name="l00344"></a>00344       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] &quot;</span>;
<a name="l00345"></a>00345       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">elem_cmap_elem_cnts</a>.size(); ++i)
<a name="l00346"></a>00346         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;elem_cmap_elem_cnts[&quot;</span>&lt;&lt;i&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">elem_cmap_elem_cnts</a>[i] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00347"></a>00347       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00348"></a>00348     }
<a name="l00349"></a>00349 }
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a40274c2f13482adf02eeb441dfc298ab">00353</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a40274c2f13482adf02eeb441dfc298ab">Nemesis_IO_Helper::get_node_cmap</a>()
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>);
<a name="l00356"></a>00356   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>);
<a name="l00357"></a>00357   
<a name="l00358"></a>00358   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>.size(); ++i)
<a name="l00359"></a>00359     {
<a name="l00360"></a>00360       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[i].resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[i]);
<a name="l00361"></a>00361       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>[i].resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>[i]);
<a name="l00362"></a>00362 
<a name="l00363"></a>00363       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00364"></a>00364         Nemesis::ne_get_node_cmap(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00365"></a>00365                                   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>.empty()         ? 0    : <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>[i],
<a name="l00366"></a>00366                                   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[i].empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[i][0],
<a name="l00367"></a>00367                                   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>[i].empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>[i][0],
<a name="l00368"></a>00368                                   <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00369"></a>00369       this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading node cmap node and processor ids!&quot;</span>);
<a name="l00370"></a>00370 
<a name="l00371"></a>00371       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00372"></a>00372         {
<a name="l00373"></a>00373           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] node_cmap_node_ids[&quot;</span>&lt;&lt;i&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span>;
<a name="l00374"></a>00374           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[i].size(); ++j)
<a name="l00375"></a>00375             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>[i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00376"></a>00376           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00377"></a>00377 
<a name="l00378"></a>00378           <span class="comment">// This is basically a vector, all entries of which are = node_cmap_ids[i]</span>
<a name="l00379"></a>00379           <span class="comment">// Not sure if it&#39;s always guaranteed to be that or what...</span>
<a name="l00380"></a>00380           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] node_cmap_proc_ids[&quot;</span>&lt;&lt;i&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span>;
<a name="l00381"></a>00381           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>[i].size(); ++j)
<a name="l00382"></a>00382             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>[i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00383"></a>00383           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00384"></a>00384         }
<a name="l00385"></a>00385     }
<a name="l00386"></a>00386 }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a902f187c60c1b72216f3197894ce99d1">00390</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a902f187c60c1b72216f3197894ce99d1">Nemesis_IO_Helper::get_elem_cmap</a>()
<a name="l00391"></a>00391 {
<a name="l00392"></a>00392   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aba301d337e1e9663e8e71012f1d198ed">elem_cmap_elem_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a>);
<a name="l00393"></a>00393   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae3dffc3b4383d97f72b070b29b381116">elem_cmap_side_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a>);
<a name="l00394"></a>00394   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a0b241d81a51babbfa6d2d2e42f6a2609">elem_cmap_proc_ids</a>.resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a>);
<a name="l00395"></a>00395           
<a name="l00396"></a>00396   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aba301d337e1e9663e8e71012f1d198ed">elem_cmap_elem_ids</a>.size(); ++i)
<a name="l00397"></a>00397     {
<a name="l00398"></a>00398       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aba301d337e1e9663e8e71012f1d198ed">elem_cmap_elem_ids</a>[i].resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">elem_cmap_elem_cnts</a>[i]);
<a name="l00399"></a>00399       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae3dffc3b4383d97f72b070b29b381116">elem_cmap_side_ids</a>[i].resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">elem_cmap_elem_cnts</a>[i]);
<a name="l00400"></a>00400       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a0b241d81a51babbfa6d2d2e42f6a2609">elem_cmap_proc_ids</a>[i].resize(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">elem_cmap_elem_cnts</a>[i]);
<a name="l00401"></a>00401 
<a name="l00402"></a>00402       <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a> =
<a name="l00403"></a>00403         Nemesis::ne_get_elem_cmap(<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a091286ea84407aa8a4a6d8830b8e69d1">ex_id</a>,
<a name="l00404"></a>00404                                   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae2e2e7cb416a2b88d6f58a1970a24237">elem_cmap_ids</a>.empty()         ? 0    : <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae2e2e7cb416a2b88d6f58a1970a24237">elem_cmap_ids</a>[i],
<a name="l00405"></a>00405                                   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aba301d337e1e9663e8e71012f1d198ed">elem_cmap_elem_ids</a>[i].empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aba301d337e1e9663e8e71012f1d198ed">elem_cmap_elem_ids</a>[i][0],
<a name="l00406"></a>00406                                   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae3dffc3b4383d97f72b070b29b381116">elem_cmap_side_ids</a>[i].empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae3dffc3b4383d97f72b070b29b381116">elem_cmap_side_ids</a>[i][0],
<a name="l00407"></a>00407                                   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a0b241d81a51babbfa6d2d2e42f6a2609">elem_cmap_proc_ids</a>[i].empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a0b241d81a51babbfa6d2d2e42f6a2609">elem_cmap_proc_ids</a>[i][0],
<a name="l00408"></a>00408                                   <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00409"></a>00409       this-&gt;<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a5b784662aee4bd1604ef57edf4cf3f70">check_err</a>(<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>, <span class="stringliteral">&quot;Error reading elem cmap elem, side, and processor ids!&quot;</span>);
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 
<a name="l00412"></a>00412       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a7d6450269a6f617afb432dbeaac8a2ec">_verbose</a>)
<a name="l00413"></a>00413         {
<a name="l00414"></a>00414           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] elem_cmap_elem_ids[&quot;</span>&lt;&lt;i&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span>;
<a name="l00415"></a>00415           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aba301d337e1e9663e8e71012f1d198ed">elem_cmap_elem_ids</a>[i].size(); ++j)
<a name="l00416"></a>00416             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aba301d337e1e9663e8e71012f1d198ed">elem_cmap_elem_ids</a>[i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00417"></a>00417           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00418"></a>00418 
<a name="l00419"></a>00419           <span class="comment">// These must be the (local) side IDs (in the ExodusII face numbering scheme)</span>
<a name="l00420"></a>00420           <span class="comment">// of the sides shared across processors.</span>
<a name="l00421"></a>00421           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] elem_cmap_side_ids[&quot;</span>&lt;&lt;i&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span>;
<a name="l00422"></a>00422           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae3dffc3b4383d97f72b070b29b381116">elem_cmap_side_ids</a>[i].size(); ++j)
<a name="l00423"></a>00423             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae3dffc3b4383d97f72b070b29b381116">elem_cmap_side_ids</a>[i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00424"></a>00424           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00425"></a>00425 
<a name="l00426"></a>00426           <span class="comment">// This is basically a vector, all entries of which are = elem_cmap_ids[i]</span>
<a name="l00427"></a>00427           <span class="comment">// Not sure if it&#39;s always guaranteed to be that or what...</span>
<a name="l00428"></a>00428           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;[&quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &lt;&lt; <span class="stringliteral">&quot;] elem_cmap_proc_ids[&quot;</span>&lt;&lt;i&lt;&lt;<span class="stringliteral">&quot;]=&quot;</span>;
<a name="l00429"></a>00429           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a0b241d81a51babbfa6d2d2e42f6a2609">elem_cmap_proc_ids</a>[i].size(); ++j)
<a name="l00430"></a>00430             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a0b241d81a51babbfa6d2d2e42f6a2609">elem_cmap_proc_ids</a>[i][j] &lt;&lt; <span class="stringliteral">&quot; &quot;</span>;
<a name="l00431"></a>00431           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; std::endl;
<a name="l00432"></a>00432         }
<a name="l00433"></a>00433     }
<a name="l00434"></a>00434 }
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 } <span class="comment">// namespace libMesh</span>
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 <span class="preprocessor">#endif // #if defined(LIBMESH_HAVE_NEMESIS_API) &amp;&amp; defined(LIBMESH_HAVE_EXODUS_API)</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
