<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">nemesis_io_helper.h</div>  </div>
</div>
<div class="contents">
<a href="nemesis__io__helper_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nemesis_io_helper.h 4335 2011-04-11 19:52:03Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __nemesis_io_helper_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __nemesis_io_helper_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="preprocessor">#if defined(LIBMESH_HAVE_NEMESIS_API) &amp;&amp; defined(LIBMESH_HAVE_EXODUS_API)</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="exodusII__io__helper_8h.php">exodusII_io_helper.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// The Nemesis API header file.  Should already be</span>
<a name="l00034"></a>00034 <span class="comment">// correctly extern C&#39;d but it doesn&#39;t hurt :)</span>
<a name="l00035"></a><a class="code" href="namespacelibMesh_1_1Nemesis.php">00035</a> <span class="keyword">namespace </span>Nemesis {
<a name="l00036"></a>00036   <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;ne_nemesisI.h&quot;</span>
<a name="l00038"></a>00038   }
<a name="l00039"></a>00039 }
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php">00051</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php">Nemesis_IO_Helper</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php">ExodusII_IO_Helper</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053 <span class="keyword">public</span>:
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a79ad26a7e185237b62cb2f43299be735">Nemesis_IO_Helper</a>(<span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ExodusII__IO__Helper.php#a0a486e1d944ba2dcea784255c5652499">verbose</a>=<span class="keyword">false</span>);
<a name="l00058"></a>00058 
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec9403b95b5d8df5fc1ff4af7ef0a4cc">~Nemesis_IO_Helper</a>();
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="comment">//   /**</span>
<a name="l00065"></a>00065 <span class="comment">//    * Set the flag indicationg if we should be verbose.</span>
<a name="l00066"></a>00066 <span class="comment">//    */</span>
<a name="l00067"></a>00067 <span class="comment">//   void verbose (bool set_verbosity);</span>
<a name="l00068"></a>00068   
<a name="l00069"></a>00069   <span class="comment">// Member functions.  These just allocate memory for you and call the Nemesis</span>
<a name="l00070"></a>00070   <span class="comment">// routines of the same name.  They also handle error checking for the Nemesis</span>
<a name="l00071"></a>00071   <span class="comment">// return value.  Be careful calling these at random, some depend on others</span>
<a name="l00072"></a>00072   <span class="comment">// being called first...</span>
<a name="l00073"></a>00073   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a58f32d4bd0357125c5a22778fb59650f">get_init_global</a>();
<a name="l00074"></a>00074 
<a name="l00080"></a>00080   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a38c95a1f14084ff7d654f85b63a62d2b">get_ss_param_global</a>();
<a name="l00081"></a>00081   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aa5b0ba0cf8ad0a3dd7270465895532c9">get_ns_param_global</a>();
<a name="l00082"></a>00082   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac1ff2be6140d2002737acdbc30bcd885">get_eb_info_global</a>();
<a name="l00083"></a>00083   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af327d4523f60cbee6dba2d49e3046d7c">get_init_info</a>();
<a name="l00084"></a>00084   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae9d2c643dac85d53e610e5d2e8224a6f">get_loadbal_param</a>();
<a name="l00085"></a>00085   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afb6e8a2ae7638eef7346204803425189">get_elem_map</a>();
<a name="l00086"></a>00086   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1d46473b4a62c8d11fc6beda0e3215f5">get_node_map</a>();
<a name="l00087"></a>00087   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a653b6229679c6fa0f56952523b3b8302">get_cmap_params</a>();
<a name="l00088"></a>00088   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a40274c2f13482adf02eeb441dfc298ab">get_node_cmap</a>();
<a name="l00089"></a>00089   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a902f187c60c1b72216f3197894ce99d1">get_elem_cmap</a>();
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   <span class="comment">// Member data</span>
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="comment">//   /**</span>
<a name="l00094"></a>00094 <span class="comment">//    * Instance of the Exodus IO Helper.  We call the Exodus API through</span>
<a name="l00095"></a>00095 <span class="comment">//    * this object.  Instead of creating forwarding functions for</span>
<a name="l00096"></a>00096 <span class="comment">//    * everything in the ExodusII_IO_Helper class, just call them</span>
<a name="l00097"></a>00097 <span class="comment">//    * directly through this object!</span>
<a name="l00098"></a>00098 <span class="comment">//    */</span>
<a name="l00099"></a>00099 <span class="comment">//   ExodusII_IO_Helper ex2helper;</span>
<a name="l00100"></a>00100 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">00105</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8078de0cd66c3b280237f44d600bb3eb">nemesis_err_flag</a>;
<a name="l00106"></a>00106     
<a name="l00111"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">00111</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a98e66232b1d1a7af9aeb35a68e0ce7ef">num_nodes_global</a>;
<a name="l00112"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a428c62b9b28577fb377d085b6cf3fbf3">00112</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a428c62b9b28577fb377d085b6cf3fbf3">num_elems_global</a>;
<a name="l00113"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a805da8a5dc52de083338209cd399b704">00113</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a805da8a5dc52de083338209cd399b704">num_elem_blks_global</a>;
<a name="l00114"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afc538b97549c6327366f45cb90b95fb3">00114</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#afc538b97549c6327366f45cb90b95fb3">num_node_sets_global</a>;
<a name="l00115"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad1cff73aa4746d8ca6b7cd578edddbd6">00115</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad1cff73aa4746d8ca6b7cd578edddbd6">num_side_sets_global</a>;
<a name="l00116"></a>00116 
<a name="l00121"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aedbf0f2fd37e3268ab66ba1b446d0388">00121</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aedbf0f2fd37e3268ab66ba1b446d0388">num_proc</a>;
<a name="l00122"></a>00122 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a49acded6135ff46cf2d0ba9a41350ae5">00128</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a49acded6135ff46cf2d0ba9a41350ae5">num_proc_in_file</a>;
<a name="l00129"></a>00129 
<a name="l00135"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a3aacd3c247b7de59a604e55ec190d9c1">00135</a>   <span class="keywordtype">char</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a3aacd3c247b7de59a604e55ec190d9c1">ftype</a>;
<a name="l00136"></a>00136   
<a name="l00144"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af788a42ffedcc5a5552ecce5864e82cb">00144</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#af788a42ffedcc5a5552ecce5864e82cb">global_sideset_ids</a>;
<a name="l00145"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a7f5a5ba3ea3dc237cd0cb9a05dc1aef3">00145</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a7f5a5ba3ea3dc237cd0cb9a05dc1aef3">num_global_side_counts</a>;
<a name="l00146"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a76719fca83e9a986ee145599e3f5004b">00146</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a76719fca83e9a986ee145599e3f5004b">num_global_side_df_counts</a>;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00156"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ab550709daf851529cb0600340f6910dd">00156</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ab550709daf851529cb0600340f6910dd">global_nodeset_ids</a>;
<a name="l00157"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac3c8e99b92a3306e23b3c3ca4a433093">00157</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ac3c8e99b92a3306e23b3c3ca4a433093">num_global_node_counts</a>;
<a name="l00158"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aaaff44c34077b5c5e9fba35b5bcd6d5f">00158</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aaaff44c34077b5c5e9fba35b5bcd6d5f">num_global_node_df_counts</a>;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00166"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a9d61e1426726ab2c3b207716a0db1ff3">00166</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a9d61e1426726ab2c3b207716a0db1ff3">global_elem_blk_ids</a>;
<a name="l00167"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a4757994f9aaf16c05377e8472c80ffeb">00167</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a4757994f9aaf16c05377e8472c80ffeb">global_elem_blk_cnts</a>;
<a name="l00168"></a>00168   
<a name="l00169"></a>00169 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">00178</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a2c0c2908a3ed6a6f2efc3142db699d2b">num_internal_nodes</a>;
<a name="l00179"></a>00179 
<a name="l00185"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">00185</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a438b6bc4e1c65aa7c46d880d2e9be65d">num_border_nodes</a>;
<a name="l00186"></a>00186   
<a name="l00192"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">00192</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a1c1bb85f02b8c95ef66cb7dc40330247">num_external_nodes</a>;
<a name="l00193"></a>00193   
<a name="l00198"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">00198</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a319f0d1cac4b358ee634b888e6226927">num_internal_elems</a>;
<a name="l00199"></a>00199 
<a name="l00205"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">00205</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a06c94a0e522731c5c7d9aca265a1039d">num_border_elems</a>;
<a name="l00206"></a>00206   
<a name="l00212"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">00212</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a599b22b7b3f80c3135f207a970b73ef6">num_node_cmaps</a>;
<a name="l00213"></a>00213   
<a name="l00219"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">00219</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad47d0d6538010bd2c2aa358f7e518332">num_elem_cmaps</a>;
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   
<a name="l00228"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a77cabe86cb1296ed052849e4259ac704">00228</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a77cabe86cb1296ed052849e4259ac704">elem_mapi</a>;
<a name="l00229"></a>00229   
<a name="l00235"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a46a2ba3da3e77bc5517846854a7a9fb2">00235</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a46a2ba3da3e77bc5517846854a7a9fb2">elem_mapb</a>;
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   
<a name="l00244"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">00244</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ad3c20099029b60abb4ba76b8b2e4b2ec">node_mapi</a>;
<a name="l00245"></a>00245   
<a name="l00251"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">00251</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8bf17e199cbffdcd89250476aec05084">node_mapb</a>;
<a name="l00252"></a>00252 
<a name="l00258"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8adf1fe9838d266d02a589b715504e84">00258</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a8adf1fe9838d266d02a589b715504e84">node_mape</a>;
<a name="l00259"></a>00259   
<a name="l00260"></a>00260   
<a name="l00267"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">00267</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a921bd9e930cf7690d1f23590c893fb8b">node_cmap_ids</a>;
<a name="l00268"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">00268</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a901623ac3547b56de3fa23d50bff9109">node_cmap_node_cnts</a>;
<a name="l00269"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae2e2e7cb416a2b88d6f58a1970a24237">00269</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae2e2e7cb416a2b88d6f58a1970a24237">elem_cmap_ids</a>;
<a name="l00270"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">00270</a>   std::vector&lt;int&gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a409e114a0fd258236d00e0dbce7f46d5">elem_cmap_elem_cnts</a>;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272 
<a name="l00281"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">00281</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aec19670af4e2f47b1cc87a8dd4a4237c">node_cmap_node_ids</a>;
<a name="l00282"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">00282</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aac75518dad6476eb415b0c445a457f8b">node_cmap_proc_ids</a>;
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00290"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aba301d337e1e9663e8e71012f1d198ed">00290</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#aba301d337e1e9663e8e71012f1d198ed">elem_cmap_elem_ids</a>;
<a name="l00291"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae3dffc3b4383d97f72b070b29b381116">00291</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#ae3dffc3b4383d97f72b070b29b381116">elem_cmap_side_ids</a>;
<a name="l00292"></a><a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a0b241d81a51babbfa6d2d2e42f6a2609">00292</a>   std::vector&lt;std::vector&lt;int&gt; &gt; <a class="code" href="classlibMesh_1_1Nemesis__IO__Helper.php#a0b241d81a51babbfa6d2d2e42f6a2609">elem_cmap_proc_ids</a>;
<a name="l00293"></a>00293 
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 <span class="keyword">private</span>:
<a name="l00296"></a>00296   <span class="comment">//  bool _verbose;</span>
<a name="l00297"></a>00297   
<a name="l00298"></a>00298 };
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 } <span class="comment">// namespace libMesh</span>
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 <span class="preprocessor">#endif // #if defined(LIBMESH_HAVE_NEMESIS_API) &amp;&amp; defined(LIBMESH_HAVE_EXODUS_API)</span>
<a name="l00303"></a>00303 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifndef __nemesis_io_helper_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
