<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">newmark_system.C</div>  </div>
</div>
<div class="contents">
<a href="newmark__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: newmark_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="newmark__system_8h.php">newmark_system.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// NewmarkSystem static members</span>
<a name="l00039"></a>00039 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#ae7f788db2567c4e61d84db09b1a37922">NewmarkSystem::_default_alpha</a>    = .25;
<a name="l00040"></a>00040 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a4b166c01f8adb1abdd9a8c8213b44c0d">NewmarkSystem::_default_delta</a>    = .5;
<a name="l00041"></a>00041 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#acb2dea5f08030aa5eb41509b4e074ce5">NewmarkSystem::_default_timestep</a> = 1.;
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00046"></a>00046 <span class="comment">// NewmarkSystem implementation</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#ac15ddb513359617cbe5118b8f5d93cc9">00047</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#ac15ddb513359617cbe5118b8f5d93cc9">NewmarkSystem::NewmarkSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00048"></a>00048                               <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00049"></a>00049                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :  
<a name="l00050"></a>00050   <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php">LinearImplicitSystem</a> (es, name, number),
<a name="l00051"></a>00051   _a_0                 (1./(_default_alpha*_default_timestep*_default_timestep)),
<a name="l00052"></a>00052   _a_1                 (_default_delta/(_default_alpha*_default_timestep)),
<a name="l00053"></a>00053   _a_2                 (1./(_default_alpha*_default_timestep)),
<a name="l00054"></a>00054   _a_3                 (1./(2.*_default_alpha)-1.),
<a name="l00055"></a>00055   _a_4                 (_default_delta/_default_alpha -1.),
<a name="l00056"></a>00056   _a_5                 (_default_timestep/2.*(_default_delta/_default_alpha-2.)),
<a name="l00057"></a>00057   _a_6                 (_default_timestep*(1.-_default_delta)),
<a name="l00058"></a>00058   _a_7                 (_default_delta*_default_timestep),
<a name="l00059"></a>00059   _finished_assemble   (false)
<a name="l00060"></a>00060   
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062   <span class="comment">// default values of the newmark parameters</span>
<a name="l00063"></a>00063   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;Newmark alpha&quot;</span>) = <a class="code" href="classlibMesh_1_1NewmarkSystem.php#ae7f788db2567c4e61d84db09b1a37922">_default_alpha</a>;
<a name="l00064"></a>00064   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;Newmark delta&quot;</span>) = <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a4b166c01f8adb1abdd9a8c8213b44c0d">_default_delta</a>;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066   <span class="comment">// time step size.</span>
<a name="l00067"></a>00067   <span class="comment">// should be handled at a later stage through EquationSystems?</span>
<a name="l00068"></a>00068   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;Newmark time step&quot;</span>) = <a class="code" href="classlibMesh_1_1NewmarkSystem.php#acb2dea5f08030aa5eb41509b4e074ce5">_default_timestep</a>;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070   <span class="comment">// add additional matrices and vectors that will be used in the</span>
<a name="l00071"></a>00071   <span class="comment">// newmark algorithm to the data structure</span>
<a name="l00072"></a>00072   <span class="comment">// functions LinearImplicitSystem::add_matrix and LinearImplicitSystem::add_vector</span>
<a name="l00073"></a>00073   <span class="comment">// are used so we do not have to bother about initialization and</span>
<a name="l00074"></a>00074   <span class="comment">// dof mapping</span>
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// system matrices</span>
<a name="l00077"></a>00077   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a03484ff4590b6971c650b4cfb2196f85">add_matrix</a> (<span class="stringliteral">&quot;stiffness&quot;</span>);
<a name="l00078"></a>00078   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a03484ff4590b6971c650b4cfb2196f85">add_matrix</a> (<span class="stringliteral">&quot;damping&quot;</span>);
<a name="l00079"></a>00079   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a03484ff4590b6971c650b4cfb2196f85">add_matrix</a> (<span class="stringliteral">&quot;mass&quot;</span>);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// load vector  </span>
<a name="l00082"></a>00082   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="stringliteral">&quot;force&quot;</span>);
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   <span class="comment">// the displacement and the time derivatives  </span>
<a name="l00085"></a>00085   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="stringliteral">&quot;displacement&quot;</span>);
<a name="l00086"></a>00086   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="stringliteral">&quot;velocity&quot;</span>);
<a name="l00087"></a>00087   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="stringliteral">&quot;acceleration&quot;</span>);
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="comment">// contributions to the rhs</span>
<a name="l00090"></a>00090   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="stringliteral">&quot;rhs_m&quot;</span>);
<a name="l00091"></a>00091   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="stringliteral">&quot;rhs_c&quot;</span>);
<a name="l00092"></a>00092   
<a name="l00093"></a>00093   <span class="comment">// results from the previous time step</span>
<a name="l00094"></a>00094   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="stringliteral">&quot;old_solution&quot;</span>);
<a name="l00095"></a>00095   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a59ce4b808a4b8226da70e1cfa36dad7c">add_vector</a> (<span class="stringliteral">&quot;old_acceleration&quot;</span>);
<a name="l00096"></a>00096 }
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a6fa9494460d827b0f624f375de0e3162">00100</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a6fa9494460d827b0f624f375de0e3162">NewmarkSystem::~NewmarkSystem</a> ()
<a name="l00101"></a>00101 {
<a name="l00102"></a>00102   this-&gt;<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a061e063c6570270071b82854d48e23f0">clear</a>();
<a name="l00103"></a>00103 }
<a name="l00104"></a>00104 
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a061e063c6570270071b82854d48e23f0">00107</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a061e063c6570270071b82854d48e23f0">NewmarkSystem::clear</a> ()
<a name="l00108"></a>00108 {
<a name="l00109"></a>00109   <span class="comment">// use parent clear this will also clear the</span>
<a name="l00110"></a>00110   <span class="comment">// matrices and vectors added in the constructor</span>
<a name="l00111"></a>00111   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a061e063c6570270071b82854d48e23f0">LinearImplicitSystem::clear</a>();
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="comment">// Get a reference to the EquationSystems</span>
<a name="l00114"></a>00114   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00115"></a>00115     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00116"></a>00116   
<a name="l00117"></a>00117   <span class="comment">// default values of the newmark parameters</span>
<a name="l00118"></a>00118   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;Newmark alpha&quot;</span>) = <a class="code" href="classlibMesh_1_1NewmarkSystem.php#ae7f788db2567c4e61d84db09b1a37922">_default_alpha</a>;
<a name="l00119"></a>00119   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;Newmark delta&quot;</span>) = <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a4b166c01f8adb1abdd9a8c8213b44c0d">_default_delta</a>;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// time step size.  should be handled at a later stage through EquationSystems?</span>
<a name="l00122"></a>00122   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;Newmark time step&quot;</span>) = <a class="code" href="classlibMesh_1_1NewmarkSystem.php#acb2dea5f08030aa5eb41509b4e074ce5">_default_timestep</a>;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// set bool to false</span>
<a name="l00125"></a>00125   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a161e764a3c467a81b2db2e87a7b21092">_finished_assemble</a> = <span class="keyword">false</span>;
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a3afc277a7c39e61db01944eeb19160a5">00130</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a3afc277a7c39e61db01944eeb19160a5">NewmarkSystem::reinit</a> ()
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132   libmesh_error();
<a name="l00133"></a>00133   
<a name="l00134"></a>00134   <span class="comment">// initialize parent data</span>
<a name="l00135"></a>00135   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a3afc277a7c39e61db01944eeb19160a5">LinearImplicitSystem::reinit</a>();
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#abbdd2a80c752aecdfafbf5bf11cfd456">00140</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#abbdd2a80c752aecdfafbf5bf11cfd456">NewmarkSystem::assemble</a> ()
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a161e764a3c467a81b2db2e87a7b21092">_finished_assemble</a>)
<a name="l00143"></a>00143     {
<a name="l00144"></a>00144       <span class="comment">// prepare matrix with the help of the _dof_map, </span>
<a name="l00145"></a>00145       <span class="comment">// fill with sparsity pattern</span>
<a name="l00146"></a>00146       <a class="code" href="classlibMesh_1_1NewmarkSystem.php#abbdd2a80c752aecdfafbf5bf11cfd456">LinearImplicitSystem::assemble</a>();
<a name="l00147"></a>00147 
<a name="l00148"></a>00148       <span class="comment">// compute the effective system matrix</span>
<a name="l00149"></a>00149       this-&gt;<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a39aa5ea6b129cdb410c6f2768ad1409f">compute_matrix</a>();
<a name="l00150"></a>00150 
<a name="l00151"></a>00151       <span class="comment">// apply initial conditions</span>
<a name="l00152"></a>00152       this-&gt;<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a1f45e5193c3a5771ce454ea2627525b0">initial_conditions</a>();
<a name="l00153"></a>00153       
<a name="l00154"></a>00154       <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a161e764a3c467a81b2db2e87a7b21092">_finished_assemble</a> = <span class="keyword">true</span>;
<a name="l00155"></a>00155     }
<a name="l00156"></a>00156 }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a1f45e5193c3a5771ce454ea2627525b0">00159</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a1f45e5193c3a5771ce454ea2627525b0">NewmarkSystem::initial_conditions</a> ()
<a name="l00160"></a>00160 {
<a name="l00161"></a>00161   <span class="comment">// libmesh_assert (init_cond_fptr != NULL);</span>
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="comment">// Log how long the user&#39;s matrix assembly code takes</span>
<a name="l00164"></a>00164   START_LOG(<span class="stringliteral">&quot;initial_conditions ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00165"></a>00165   
<a name="l00166"></a>00166   <span class="comment">// Set all values to 0, then</span>
<a name="l00167"></a>00167   <span class="comment">// call the user-specified function for initial conditions.</span>
<a name="l00168"></a>00168   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;displacement&quot;</span>).<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00169"></a>00169   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;velocity&quot;</span>).<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00170"></a>00170   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;acceleration&quot;</span>).<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00171"></a>00171   this-&gt;<a class="code" href="classlibMesh_1_1System.php#a5f7a3a1e154fe61af97e966f3ab34ae2">user_initialization</a>();
<a name="l00172"></a>00172 
<a name="l00173"></a>00173   <span class="comment">// Stop logging the user code</span>
<a name="l00174"></a>00174   STOP_LOG(<span class="stringliteral">&quot;initial_conditions ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a39aa5ea6b129cdb410c6f2768ad1409f">00179</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a39aa5ea6b129cdb410c6f2768ad1409f">NewmarkSystem::compute_matrix</a> ()
<a name="l00180"></a>00180 {
<a name="l00181"></a>00181   <span class="comment">// close the component matrices</span>
<a name="l00182"></a>00182   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a> (<span class="stringliteral">&quot;stiffness&quot;</span>).<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00183"></a>00183   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a> (<span class="stringliteral">&quot;mass&quot;</span>     ).<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00184"></a>00184   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a> (<span class="stringliteral">&quot;damping&quot;</span>  ).<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a>();
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// close &amp; zero the system matrix</span>
<a name="l00187"></a>00187   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9a0781a7136e2f0f45b15cebef780522">close</a> (); this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a966e0a6479f33c2518937e7d0f54602f">zero</a>();
<a name="l00188"></a>00188 
<a name="l00189"></a>00189   <span class="comment">// add up the matrices</span>
<a name="l00190"></a>00190   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a> (1.,   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a> (<span class="stringliteral">&quot;stiffness&quot;</span>));
<a name="l00191"></a>00191   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a> (<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a64811db05d65fa7bf17c1426f599d422">_a_0</a>, this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a> (<span class="stringliteral">&quot;mass&quot;</span>));
<a name="l00192"></a>00192   this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a401beeed965b80425730050a61de5c21">add</a> (<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a9ad762db66069cf2172642302a9f8777">_a_1</a>, this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a> (<span class="stringliteral">&quot;damping&quot;</span>));
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a340db806bf8fedbdbea71674c3863511">00198</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a340db806bf8fedbdbea71674c3863511">NewmarkSystem::update_rhs</a> ()
<a name="l00199"></a>00199 {
<a name="l00200"></a>00200   START_LOG(<span class="stringliteral">&quot;update_rhs ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00201"></a>00201   
<a name="l00202"></a>00202   <span class="comment">// zero the rhs-vector</span>
<a name="l00203"></a>00203   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a> = *this-&gt;<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>;
<a name="l00204"></a>00204   rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   <span class="comment">// get writable references to some vectors</span>
<a name="l00207"></a>00207   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; rhs_m = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;rhs_m&quot;</span>);
<a name="l00208"></a>00208   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; rhs_c = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;rhs_c&quot;</span>);
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211   <span class="comment">// zero the vectors for matrix-vector product</span>
<a name="l00212"></a>00212   rhs_m.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00213"></a>00213   rhs_c.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00214"></a>00214 
<a name="l00215"></a>00215   <span class="comment">// compute auxiliary vectors rhs_m and rhs_c</span>
<a name="l00216"></a>00216   rhs_m.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a64811db05d65fa7bf17c1426f599d422">_a_0</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;displacement&quot;</span>));
<a name="l00217"></a>00217   rhs_m.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1NewmarkSystem.php#ab83b09e3f1fe6b4369a01c1cc3f07b1f">_a_2</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;velocity&quot;</span>));
<a name="l00218"></a>00218   rhs_m.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a237f10ffe77af61142f6bae7bac70b77">_a_3</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;acceleration&quot;</span>));
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   rhs_c.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a9ad762db66069cf2172642302a9f8777">_a_1</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;displacement&quot;</span>));
<a name="l00221"></a>00221   rhs_c.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a10664f4f1ad5fe10a5423d0f8971bf97">_a_4</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;velocity&quot;</span>));
<a name="l00222"></a>00222   rhs_c.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a331f9f52c813e2414b8dc48415ffdca7">_a_5</a>, this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;acceleration&quot;</span>));
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <span class="comment">// compute rhs</span>
<a name="l00225"></a>00225   rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;force&quot;</span>));
<a name="l00226"></a>00226   rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>(rhs_m, this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a>(<span class="stringliteral">&quot;mass&quot;</span>));
<a name="l00227"></a>00227   rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a>(rhs_c, this-&gt;<a class="code" href="classlibMesh_1_1ImplicitSystem.php#aa35857db25efad426a0442acf41dac02">get_matrix</a>(<span class="stringliteral">&quot;damping&quot;</span>));
<a name="l00228"></a>00228   
<a name="l00229"></a>00229   STOP_LOG(<span class="stringliteral">&quot;update_rhs ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00230"></a>00230 }
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#aa0330c5c5420f1ed83026e6ffd699ff8">00234</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#aa0330c5c5420f1ed83026e6ffd699ff8">NewmarkSystem::update_u_v_a</a> ()
<a name="l00235"></a>00235 {
<a name="l00236"></a>00236   START_LOG(<span class="stringliteral">&quot;update_u_v_a ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00237"></a>00237   
<a name="l00238"></a>00238   <span class="comment">// get some references for convenience</span>
<a name="l00239"></a>00239   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  solu = *this-&gt;<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>;
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  disp_vec   = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;displacement&quot;</span>);
<a name="l00242"></a>00242   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  vel_vec    = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;velocity&quot;</span>);
<a name="l00243"></a>00243   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  acc_vec    = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;acceleration&quot;</span>);
<a name="l00244"></a>00244   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  old_acc    = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;old_acceleration&quot;</span>);
<a name="l00245"></a>00245   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp;  old_solu   = this-&gt;<a class="code" href="classlibMesh_1_1System.php#a2ac8d1d590ae4b663bb7163c709c9e7a">get_vector</a>(<span class="stringliteral">&quot;old_solution&quot;</span>);
<a name="l00246"></a>00246 
<a name="l00247"></a>00247   <span class="comment">// copy data</span>
<a name="l00248"></a>00248   old_solu = disp_vec;
<a name="l00249"></a>00249   disp_vec = solu;
<a name="l00250"></a>00250   old_acc  = acc_vec;
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   <span class="comment">// compute the new acceleration vector</span>
<a name="l00253"></a>00253   acc_vec.<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(-<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a237f10ffe77af61142f6bae7bac70b77">_a_3</a>);
<a name="l00254"></a>00254   acc_vec.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a64811db05d65fa7bf17c1426f599d422">_a_0</a>, disp_vec);
<a name="l00255"></a>00255   acc_vec.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(-<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a64811db05d65fa7bf17c1426f599d422">_a_0</a>, old_solu);
<a name="l00256"></a>00256   acc_vec.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(-<a class="code" href="classlibMesh_1_1NewmarkSystem.php#ab83b09e3f1fe6b4369a01c1cc3f07b1f">_a_2</a>,vel_vec);
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="comment">// compute the new velocity vector</span>
<a name="l00259"></a>00259   vel_vec.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a3d1b288a60f981e154c89b89118b825a">_a_6</a>,old_acc);
<a name="l00260"></a>00260   vel_vec.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a>(<a class="code" href="classlibMesh_1_1NewmarkSystem.php#a14341f7d2397b2de2495c1ba0ac98eb1">_a_7</a>,acc_vec);
<a name="l00261"></a>00261   
<a name="l00262"></a>00262   STOP_LOG(<span class="stringliteral">&quot;update_u_v_a ()&quot;</span>, <span class="stringliteral">&quot;NewmarkSystem&quot;</span>);
<a name="l00263"></a>00263 }
<a name="l00264"></a>00264 
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a67e7866c73da0cee1c52ddb427fb7e4f">00267</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a67e7866c73da0cee1c52ddb427fb7e4f">NewmarkSystem::set_newmark_parameters</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta_T, 
<a name="l00268"></a>00268                                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha,
<a name="l00269"></a>00269                                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta)
<a name="l00270"></a>00270 {
<a name="l00271"></a>00271   libmesh_assert(delta_T != 0.);
<a name="l00272"></a>00272 
<a name="l00273"></a>00273     <span class="comment">// Get a reference to the EquationSystems</span>
<a name="l00274"></a>00274   <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00275"></a>00275     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();
<a name="l00276"></a>00276 
<a name="l00277"></a>00277   <span class="comment">// the newmark parameters</span>
<a name="l00278"></a>00278   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;Newmark alpha&quot;</span>) = alpha;
<a name="l00279"></a>00279   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;Newmark delta&quot;</span>) = delta;
<a name="l00280"></a>00280 
<a name="l00281"></a>00281   <span class="comment">// time step size.</span>
<a name="l00282"></a>00282   <span class="comment">// should be handled at a later stage through EquationSystems?</span>
<a name="l00283"></a>00283   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;Newmark time step&quot;</span>) = delta_T;
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="comment">// the constants for time integration</span>
<a name="l00286"></a>00286   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a64811db05d65fa7bf17c1426f599d422">_a_0</a> = 1./(alpha*delta_T*delta_T);
<a name="l00287"></a>00287   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a9ad762db66069cf2172642302a9f8777">_a_1</a> = delta/(alpha*delta_T);
<a name="l00288"></a>00288   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#ab83b09e3f1fe6b4369a01c1cc3f07b1f">_a_2</a> = 1./(alpha*delta_T);
<a name="l00289"></a>00289   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a237f10ffe77af61142f6bae7bac70b77">_a_3</a> = 1./(2.*alpha)-1.;
<a name="l00290"></a>00290   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a10664f4f1ad5fe10a5423d0f8971bf97">_a_4</a> = delta/alpha -1.;
<a name="l00291"></a>00291   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a331f9f52c813e2414b8dc48415ffdca7">_a_5</a> = delta_T/2.*(delta/alpha-2.);
<a name="l00292"></a>00292   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a3d1b288a60f981e154c89b89118b825a">_a_6</a> = delta_T*(1.-delta);
<a name="l00293"></a>00293   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a14341f7d2397b2de2495c1ba0ac98eb1">_a_7</a> = delta*delta_T;
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
