<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">newmark_system.h</div>  </div>
</div>
<div class="contents">
<a href="newmark__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: newmark_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __newmark_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __newmark_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="linear__implicit__system_8h.php">linear_implicit_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// Forward Declarations</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// NewmarkSystem class definition</span>
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NewmarkSystem.php">NewmarkSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1LinearImplicitSystem.php">LinearImplicitSystem</a>
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">public</span>:
<a name="l00059"></a>00059 
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#ac15ddb513359617cbe5118b8f5d93cc9">NewmarkSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00065"></a>00065                  <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00066"></a>00066                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a6fa9494460d827b0f624f375de0e3162">~NewmarkSystem</a> ();
<a name="l00072"></a>00072   
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a1caeefc419ccd0854d1564228f76bbfb">00077</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php">NewmarkSystem</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a1caeefc419ccd0854d1564228f76bbfb">sys_type</a>;
<a name="l00078"></a>00078   
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a061e063c6570270071b82854d48e23f0">clear</a> ();
<a name="l00084"></a>00084 
<a name="l00089"></a>00089   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a3afc277a7c39e61db01944eeb19160a5">reinit</a> ();
<a name="l00090"></a>00090 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#abbdd2a80c752aecdfafbf5bf11cfd456">assemble</a> ();
<a name="l00096"></a>00096   
<a name="l00101"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a75ed55977569de9f5e8a11e2ffd25f1e">00101</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a75ed55977569de9f5e8a11e2ffd25f1e">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;Newmark&quot;</span>; }
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">//---------------------------------------------------------</span>
<a name="l00105"></a>00105   <span class="comment">// These members are specific to the Newmark system</span>
<a name="l00106"></a>00106   <span class="comment">//</span>
<a name="l00107"></a>00107   
<a name="l00111"></a>00111   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a1f45e5193c3a5771ce454ea2627525b0">initial_conditions</a> ();
<a name="l00112"></a>00112 
<a name="l00117"></a>00117   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a39aa5ea6b129cdb410c6f2768ad1409f">compute_matrix</a> ();
<a name="l00118"></a>00118 
<a name="l00122"></a>00122   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a340db806bf8fedbdbea71674c3863511">update_rhs</a> ();
<a name="l00123"></a>00123 
<a name="l00127"></a>00127   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#aa0330c5c5420f1ed83026e6ffd699ff8">update_u_v_a</a> ();
<a name="l00128"></a>00128 
<a name="l00134"></a>00134   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a67e7866c73da0cee1c52ddb427fb7e4f">set_newmark_parameters</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta_T = <a class="code" href="classlibMesh_1_1NewmarkSystem.php#acb2dea5f08030aa5eb41509b4e074ce5">_default_timestep</a>,
<a name="l00135"></a>00135                                <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> alpha   = <a class="code" href="classlibMesh_1_1NewmarkSystem.php#ae7f788db2567c4e61d84db09b1a37922">_default_alpha</a>,
<a name="l00136"></a>00136                                <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> delta   = <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a4b166c01f8adb1abdd9a8c8213b44c0d">_default_delta</a>);
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 <span class="keyword">protected</span>:
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="keyword">private</span>:
<a name="l00142"></a>00142 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a64811db05d65fa7bf17c1426f599d422">00146</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a64811db05d65fa7bf17c1426f599d422">_a_0</a>;
<a name="l00147"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a9ad762db66069cf2172642302a9f8777">00147</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a9ad762db66069cf2172642302a9f8777">_a_1</a>;
<a name="l00148"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#ab83b09e3f1fe6b4369a01c1cc3f07b1f">00148</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#ab83b09e3f1fe6b4369a01c1cc3f07b1f">_a_2</a>;
<a name="l00149"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a237f10ffe77af61142f6bae7bac70b77">00149</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a237f10ffe77af61142f6bae7bac70b77">_a_3</a>;
<a name="l00150"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a10664f4f1ad5fe10a5423d0f8971bf97">00150</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a10664f4f1ad5fe10a5423d0f8971bf97">_a_4</a>;
<a name="l00151"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a331f9f52c813e2414b8dc48415ffdca7">00151</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a331f9f52c813e2414b8dc48415ffdca7">_a_5</a>;
<a name="l00152"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a3d1b288a60f981e154c89b89118b825a">00152</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a3d1b288a60f981e154c89b89118b825a">_a_6</a>;
<a name="l00153"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a14341f7d2397b2de2495c1ba0ac98eb1">00153</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a14341f7d2397b2de2495c1ba0ac98eb1">_a_7</a>;
<a name="l00154"></a>00154 
<a name="l00158"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a161e764a3c467a81b2db2e87a7b21092">00158</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a161e764a3c467a81b2db2e87a7b21092">_finished_assemble</a>;  
<a name="l00159"></a>00159   
<a name="l00163"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#ae7f788db2567c4e61d84db09b1a37922">00163</a>   <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#ae7f788db2567c4e61d84db09b1a37922">_default_alpha</a>;
<a name="l00164"></a>00164 
<a name="l00168"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#a4b166c01f8adb1abdd9a8c8213b44c0d">00168</a>   <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#a4b166c01f8adb1abdd9a8c8213b44c0d">_default_delta</a>;
<a name="l00169"></a>00169 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1NewmarkSystem.php#acb2dea5f08030aa5eb41509b4e074ce5">00173</a>   <span class="keyword">static</span> <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewmarkSystem.php#acb2dea5f08030aa5eb41509b4e074ce5">_default_timestep</a>;
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 };
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 } <span class="comment">// namespace libMesh</span>
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00182"></a>00182 <span class="comment">// NewmarkSystem inline methods</span>
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
