<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">newton_solver.C</div>  </div>
</div>
<div class="contents">
<a href="newton__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: newton_solver.C 4369 2011-04-19 22:30:47Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="newton__solver_8h.php">newton_solver.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// SIGN from Numerical Recipes</span>
<a name="l00033"></a>00033 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00034"></a>00034 <span class="keyword">inline</span>
<a name="l00035"></a><a class="code" href="namespacelibMesh.php#a51567a8c9dd51b8346a7cbb43ae25ec1">00035</a> T <a class="code" href="namespacelibMesh.php#a51567a8c9dd51b8346a7cbb43ae25ec1">SIGN</a>(T a, T b)
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037   <span class="keywordflow">return</span> b &gt;= 0 ? std::abs(a) : -std::abs(a);
<a name="l00038"></a>00038 }
<a name="l00039"></a>00039 
<a name="l00040"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a694e4e4672cd45d4cc71e2d965baf204">00040</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a694e4e4672cd45d4cc71e2d965baf204">NewtonSolver::line_search</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol,
<a name="l00041"></a>00041                                <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> last_residual,
<a name="l00042"></a>00042                                <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp;current_residual,
<a name="l00043"></a>00043                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;newton_iterate,
<a name="l00044"></a>00044                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;linear_solution)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="comment">// Take a full step if we got a residual reduction or if we</span>
<a name="l00047"></a>00047   <span class="comment">// aren&#39;t substepping</span>
<a name="l00048"></a>00048   <span class="keywordflow">if</span> ((current_residual &lt; last_residual) ||
<a name="l00049"></a>00049       (!<a class="code" href="classlibMesh_1_1NewtonSolver.php#a1dea627cbb3fb00fcba5a937043120c4">require_residual_reduction</a> &amp;&amp;
<a name="l00050"></a>00050        (!<a class="code" href="classlibMesh_1_1NewtonSolver.php#a38ba1b1d0f44a76e4bd30c7339154ea3">require_finite_residual</a> || !<a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(current_residual))))
<a name="l00051"></a>00051     <span class="keywordflow">return</span> 1.;
<a name="l00052"></a>00052 
<a name="l00053"></a>00053   <span class="comment">// The residual vector</span>
<a name="l00054"></a>00054   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;rhs = *(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>);
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ax = 0.;  <span class="comment">// First abscissa, don&#39;t take negative steps</span>
<a name="l00057"></a>00057   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> cx = 1.;  <span class="comment">// Second abscissa, don&#39;t extrapolate steps</span>
<a name="l00058"></a>00058 
<a name="l00059"></a>00059   <span class="comment">// Find bx, a step length that gives lower residual than ax or cx</span>
<a name="l00060"></a>00060   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> bx = 1.;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordflow">while</span> (<a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(current_residual) || 
<a name="l00063"></a>00063          (current_residual &gt; last_residual &amp;&amp;
<a name="l00064"></a>00064           <a class="code" href="classlibMesh_1_1NewtonSolver.php#a1dea627cbb3fb00fcba5a937043120c4">require_residual_reduction</a>))
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066       <span class="comment">// Reduce step size to 1/2, 1/4, etc.</span>
<a name="l00067"></a>00067       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> substepdivision;
<a name="l00068"></a>00068       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NewtonSolver.php#abe1872e40e47a6100c7d68f740a3f973">brent_line_search</a> &amp;&amp; !<a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(current_residual))
<a name="l00069"></a>00069         {
<a name="l00070"></a>00070           substepdivision = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(0.5, last_residual/current_residual);
<a name="l00071"></a>00071           substepdivision = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(substepdivision, tol*2.);
<a name="l00072"></a>00072         }
<a name="l00073"></a>00073       <span class="keywordflow">else</span>
<a name="l00074"></a>00074         substepdivision = 0.5;
<a name="l00075"></a>00075 
<a name="l00076"></a>00076       newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a> (bx * (1.-substepdivision),
<a name="l00077"></a>00077                           linear_solution);
<a name="l00078"></a>00078       newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00079"></a>00079       bx *= substepdivision;
<a name="l00080"></a>00080       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00081"></a>00081         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Shrinking Newton step to &quot;</span>
<a name="l00082"></a>00082                   &lt;&lt; bx &lt;&lt; std::endl;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084       <span class="comment">// Check residual with fractional Newton step</span>
<a name="l00085"></a>00085       <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a> (<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00086"></a>00086 
<a name="l00087"></a>00087       rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00088"></a>00088       current_residual = rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00089"></a>00089       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00090"></a>00090         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Current Residual: &quot;</span>
<a name="l00091"></a>00091                   &lt;&lt; current_residual &lt;&lt; std::endl;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093       <span class="keywordflow">if</span> (bx/2. &lt; <a class="code" href="classlibMesh_1_1NewtonSolver.php#a48596fd39541fd680830b7b7730f0bc5">minsteplength</a> &amp;&amp; 
<a name="l00094"></a>00094           (<a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(current_residual) || 
<a name="l00095"></a>00095            (current_residual &gt; last_residual)))
<a name="l00096"></a>00096         {
<a name="l00097"></a>00097           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Inexact Newton step FAILED at step &quot;</span>
<a name="l00098"></a>00098                     &lt;&lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a> &lt;&lt; std::endl;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DiffSolver.php#a438b337eddd22eb22750d047cbb09db5">continue_after_backtrack_failure</a>)
<a name="l00101"></a>00101             {
<a name="l00102"></a>00102               libmesh_convergence_failure();
<a name="l00103"></a>00103             }
<a name="l00104"></a>00104           <span class="keywordflow">else</span>
<a name="l00105"></a>00105             {
<a name="l00106"></a>00106               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Continuing anyway ...&quot;</span> &lt;&lt; std::endl;
<a name="l00107"></a>00107               <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a> = <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a5a9f6f2aa16e982c8ab85b4394140755">DiffSolver::DIVERGED_BACKTRACKING_FAILURE</a>;
<a name="l00108"></a>00108               <span class="keywordflow">return</span> bx;
<a name="l00109"></a>00109             }
<a name="l00110"></a>00110         }
<a name="l00111"></a>00111     } <span class="comment">// end while (current_residual &gt; last_residual)</span>
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="comment">// Now return that reduced-residual step, or  use Brent&#39;s method to</span>
<a name="l00114"></a>00114   <span class="comment">// find a more optimal step.</span>
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1NewtonSolver.php#abe1872e40e47a6100c7d68f740a3f973">brent_line_search</a>)
<a name="l00117"></a>00117     <span class="keywordflow">return</span> bx;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">// Brent&#39;s method adapted from Numerical Recipes in C, ch. 10.2</span>
<a name="l00120"></a>00120   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> e = 0.;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x = bx, w = bx, v = bx;
<a name="l00123"></a>00123 
<a name="l00124"></a>00124   <span class="comment">// Residuals at bx</span>
<a name="l00125"></a>00125   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> fx = current_residual,
<a name="l00126"></a>00126        fw = current_residual,
<a name="l00127"></a>00127        fv = current_residual;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="comment">// Max iterations for Brent&#39;s method loop</span>
<a name="l00130"></a>00130   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_i = 20;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// for golden ratio steps</span>
<a name="l00133"></a>00133   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> golden_ratio = 1.-(std::sqrt(5.)-1.)/2.;
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i &lt;= max_i; i++)
<a name="l00136"></a>00136     {
<a name="l00137"></a>00137       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xm = (ax+cx)*0.5;
<a name="l00138"></a>00138       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol1 = tol * std::abs(x) + tol*tol;
<a name="l00139"></a>00139       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol2 = 2.0 * tol1;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141       <span class="comment">// Test if we&#39;re done</span>
<a name="l00142"></a>00142       <span class="keywordflow">if</span> (std::abs(x-xm) &lt;= (tol2 - 0.5 * (cx - ax)))
<a name="l00143"></a>00143         <span class="keywordflow">return</span> x;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> d;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147       <span class="comment">// Construct a parabolic fit</span>
<a name="l00148"></a>00148       <span class="keywordflow">if</span> (std::abs(e) &gt; tol1)
<a name="l00149"></a>00149         {
<a name="l00150"></a>00150           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r = (x-w)*(fx-fv);
<a name="l00151"></a>00151           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> q = (x-v)*(fx-fw);
<a name="l00152"></a>00152           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p = (x-v)*q-(x-w)*r;
<a name="l00153"></a>00153           q = 2. * (q-r);
<a name="l00154"></a>00154           <span class="keywordflow">if</span> (q &gt; 0.)
<a name="l00155"></a>00155             p = -p;
<a name="l00156"></a>00156           <span class="keywordflow">else</span>
<a name="l00157"></a>00157             q = std::abs(q);
<a name="l00158"></a>00158           <span class="keywordflow">if</span> (std::abs(p) &gt;= std::abs(0.5*q*e) ||
<a name="l00159"></a>00159               p &lt;= q * (ax-x) ||
<a name="l00160"></a>00160               p &gt;= q * (cx-x))
<a name="l00161"></a>00161             {
<a name="l00162"></a>00162               <span class="comment">// Take a golden section step</span>
<a name="l00163"></a>00163               e = x &gt;= xm ? ax-x : cx-x;
<a name="l00164"></a>00164               d = golden_ratio * e;
<a name="l00165"></a>00165             }
<a name="l00166"></a>00166           <span class="keywordflow">else</span>
<a name="l00167"></a>00167             {
<a name="l00168"></a>00168               <span class="comment">// Take a parabolic fit step</span>
<a name="l00169"></a>00169               d = p/q;
<a name="l00170"></a>00170               <span class="keywordflow">if</span> (x+d-ax &lt; tol2 || cx-(x+d) &lt; tol2)
<a name="l00171"></a>00171                 d = <a class="code" href="namespacelibMesh.php#a51567a8c9dd51b8346a7cbb43ae25ec1">SIGN</a>(tol1, xm - x);
<a name="l00172"></a>00172             }
<a name="l00173"></a>00173         }
<a name="l00174"></a>00174       <span class="keywordflow">else</span>
<a name="l00175"></a>00175         {
<a name="l00176"></a>00176           <span class="comment">// Take a golden section step</span>
<a name="l00177"></a>00177           e = x &gt;= xm ? ax-x : cx-x;
<a name="l00178"></a>00178           d = golden_ratio * e;
<a name="l00179"></a>00179         }
<a name="l00180"></a>00180 
<a name="l00181"></a>00181       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> u = std::abs(d) &gt;= tol1 ? x+d : x + <a class="code" href="namespacelibMesh.php#a51567a8c9dd51b8346a7cbb43ae25ec1">SIGN</a>(tol1,d);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183       <span class="comment">// Assemble the residual at the new steplength u</span>
<a name="l00184"></a>00184       newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a> (bx - u, linear_solution);
<a name="l00185"></a>00185       newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00186"></a>00186       bx = u;
<a name="l00187"></a>00187       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00188"></a>00188         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Shrinking Newton step to &quot;</span>
<a name="l00189"></a>00189                       &lt;&lt; bx &lt;&lt; std::endl;
<a name="l00190"></a>00190 
<a name="l00191"></a>00191       <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a> (<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00192"></a>00192 
<a name="l00193"></a>00193       rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00194"></a>00194       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> fu = current_residual = rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00195"></a>00195       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00196"></a>00196         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Current Residual: &quot;</span>
<a name="l00197"></a>00197                       &lt;&lt; fu &lt;&lt; std::endl;
<a name="l00198"></a>00198 
<a name="l00199"></a>00199       <span class="keywordflow">if</span> (fu &lt;= fx)
<a name="l00200"></a>00200         {
<a name="l00201"></a>00201           <span class="keywordflow">if</span> (u &gt;= x)
<a name="l00202"></a>00202             ax = x;
<a name="l00203"></a>00203           <span class="keywordflow">else</span>
<a name="l00204"></a>00204             cx = x;
<a name="l00205"></a>00205           v = w;   w = x;   x = u;
<a name="l00206"></a>00206           fv = fw; fw = fx; fx = fu;
<a name="l00207"></a>00207         }
<a name="l00208"></a>00208       <span class="keywordflow">else</span>
<a name="l00209"></a>00209         {
<a name="l00210"></a>00210           <span class="keywordflow">if</span> (u &lt; x)
<a name="l00211"></a>00211             ax = u;
<a name="l00212"></a>00212           <span class="keywordflow">else</span>
<a name="l00213"></a>00213             cx = u;
<a name="l00214"></a>00214           <span class="keywordflow">if</span> (fu &lt;= fw || w == x)
<a name="l00215"></a>00215             {
<a name="l00216"></a>00216               v = w;   w = u;
<a name="l00217"></a>00217               fv = fw; fw = fu;
<a name="l00218"></a>00218             }
<a name="l00219"></a>00219           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (fu &lt;= fv || v == x || v == w)
<a name="l00220"></a>00220             {
<a name="l00221"></a>00221               v = u;
<a name="l00222"></a>00222               fv = fu;
<a name="l00223"></a>00223             }
<a name="l00224"></a>00224         }
<a name="l00225"></a>00225     }
<a name="l00226"></a>00226 
<a name="l00227"></a>00227   <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DiffSolver.php#ae8809909d1442365d6f7385b28625793">quiet</a>)
<a name="l00228"></a>00228     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning!  Too many iterations used in Brent line search!&quot;</span>
<a name="l00229"></a>00229                  &lt;&lt; std::endl;
<a name="l00230"></a>00230   <span class="keywordflow">return</span> bx;
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a4f1730e0b4552d44d8df01dcf87c6610">00234</a> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a4f1730e0b4552d44d8df01dcf87c6610">NewtonSolver::NewtonSolver</a> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a>&amp; s)
<a name="l00235"></a>00235   : <a class="code" href="classlibMesh_1_1DiffSolver.php">Parent</a>(s),
<a name="l00236"></a>00236     require_residual_reduction(true),
<a name="l00237"></a>00237     require_finite_residual(true),
<a name="l00238"></a>00238     brent_line_search(true),
<a name="l00239"></a>00239     minsteplength(1e-5),
<a name="l00240"></a>00240     linear_tolerance_multiplier(1e-3),
<a name="l00241"></a>00241     linear_solver(<a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build())
<a name="l00242"></a>00242 {
<a name="l00243"></a>00243 }
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 
<a name="l00246"></a>00246 
<a name="l00247"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#ab5fd14065433f30a6331f962268bb667">00247</a> <a class="code" href="classlibMesh_1_1NewtonSolver.php#ab5fd14065433f30a6331f962268bb667">NewtonSolver::~NewtonSolver</a> ()
<a name="l00248"></a>00248 {
<a name="l00249"></a>00249 }
<a name="l00250"></a>00250 
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00253"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#aece8f204133d71d9fc304e4220463c36">00253</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#aece8f204133d71d9fc304e4220463c36">NewtonSolver::reinit</a>()
<a name="l00254"></a>00254 {
<a name="l00255"></a>00255   <a class="code" href="classlibMesh_1_1DiffSolver.php#ac7f6532da1a45d35dee39e82ae383d17">Parent::reinit</a>();
<a name="l00256"></a>00256 
<a name="l00257"></a>00257   <a class="code" href="classlibMesh_1_1NewtonSolver.php#a01f9ade420e57962b4f2299054b94148">linear_solver</a>-&gt;clear();
<a name="l00258"></a>00258 }
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 
<a name="l00262"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a1ecdb0c580dd308d27d06617b1145736">00262</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a1ecdb0c580dd308d27d06617b1145736">NewtonSolver::solve</a>()
<a name="l00263"></a>00263 {
<a name="l00264"></a>00264   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;NewtonSolver&quot;</span>);
<a name="l00265"></a>00265 
<a name="l00266"></a>00266   <span class="comment">// Reset any prior solve result</span>
<a name="l00267"></a>00267   <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a> = <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450ae632866d841ee9a65aa1c9225aeb909c">INVALID_SOLVE_RESULT</a>;
<a name="l00268"></a>00268   
<a name="l00269"></a>00269   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;newton_iterate = *(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt; linear_solution_ptr = newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#a6f0bb3315b7252ca3bcc2b3c2e828a31">zero_clone</a>();
<a name="l00272"></a>00272   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;linear_solution = *linear_solution_ptr;
<a name="l00273"></a>00273   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;rhs = *(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>);
<a name="l00274"></a>00274 
<a name="l00275"></a>00275   newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00276"></a>00276   linear_solution.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00277"></a>00277   rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00280"></a>00280 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>);
<a name="l00281"></a>00281 <span class="preprocessor">#endif</span>
<a name="l00282"></a>00282 <span class="preprocessor"></span>
<a name="l00283"></a>00283   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp;matrix = *(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="comment">// Prepare to take incomplete steps</span>
<a name="l00286"></a>00286   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> last_residual=0.;
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   <span class="comment">// Set starting linear tolerance</span>
<a name="l00289"></a>00289   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_linear_tolerance = <a class="code" href="classlibMesh_1_1DiffSolver.php#afed86ff95698a52eecb3824ab5b6028d">initial_linear_tolerance</a>;
<a name="l00290"></a>00290 
<a name="l00291"></a>00291   <span class="comment">// Start counting our linear solver steps</span>
<a name="l00292"></a>00292   <a class="code" href="classlibMesh_1_1DiffSolver.php#a1427e8cbf65b72d18ba567c8cd35d3c0">_inner_iterations</a> = 0;
<a name="l00293"></a>00293 
<a name="l00294"></a>00294   <span class="comment">// Now we begin the nonlinear loop</span>
<a name="l00295"></a>00295   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>=0; <a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>&lt;<a class="code" href="classlibMesh_1_1DiffSolver.php#ae2d85fde243f9037ca23cc5f58483d21">max_nonlinear_iterations</a>;
<a name="l00296"></a>00296        ++<a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>)
<a name="l00297"></a>00297     {
<a name="l00298"></a>00298       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00299"></a>00299         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Assembling the System&quot;</span> &lt;&lt; std::endl;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301       <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">true</span>, <span class="keyword">true</span>);
<a name="l00302"></a>00302       rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00303"></a>00303       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_residual = rhs.<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00304"></a>00304       last_residual = current_residual;
<a name="l00305"></a>00305 
<a name="l00306"></a>00306       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a5e09b0d6841d128904914c0d40b02700">libmesh_isnan</a>(current_residual))
<a name="l00307"></a>00307         {
<a name="l00308"></a>00308           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver DIVERGED at step &quot;</span> 
<a name="l00309"></a>00309                        &lt;&lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>
<a name="l00310"></a>00310                        &lt;&lt; <span class="stringliteral">&quot; with residual Not-a-Number&quot;</span>
<a name="l00311"></a>00311                        &lt;&lt; std::endl;
<a name="l00312"></a>00312           libmesh_convergence_failure();
<a name="l00313"></a>00313           <span class="keywordflow">continue</span>;
<a name="l00314"></a>00314         }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316       <a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">max_residual_norm</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a> (current_residual,
<a name="l00317"></a>00317                                     <a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">max_residual_norm</a>);
<a name="l00318"></a>00318  
<a name="l00319"></a>00319       <span class="comment">// Compute the l2 norm of the whole solution</span>
<a name="l00320"></a>00320       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_total = newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00321"></a>00321 
<a name="l00322"></a>00322       <a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a>, norm_total);
<a name="l00323"></a>00323 
<a name="l00324"></a>00324       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00325"></a>00325         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Nonlinear Residual: &quot;</span>
<a name="l00326"></a>00326                       &lt;&lt; current_residual &lt;&lt; std::endl;
<a name="l00327"></a>00327 
<a name="l00328"></a>00328       <span class="comment">// Make sure our linear tolerance is low enough</span>
<a name="l00329"></a>00329       current_linear_tolerance = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (current_linear_tolerance,
<a name="l00330"></a>00330         current_residual * <a class="code" href="classlibMesh_1_1NewtonSolver.php#ace69fd08aa2ddfe9157db911ee2cdfb2">linear_tolerance_multiplier</a>);
<a name="l00331"></a>00331 
<a name="l00332"></a>00332       <span class="comment">// But don&#39;t let it be too small</span>
<a name="l00333"></a>00333       <span class="keywordflow">if</span> (current_linear_tolerance &lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#a3456056572858cb5a215d45db1514c38">minimum_linear_tolerance</a>)
<a name="l00334"></a>00334         {
<a name="l00335"></a>00335           current_linear_tolerance = <a class="code" href="classlibMesh_1_1DiffSolver.php#a3456056572858cb5a215d45db1514c38">minimum_linear_tolerance</a>;
<a name="l00336"></a>00336         }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338       <span class="comment">// At this point newton_iterate is the current guess, and</span>
<a name="l00339"></a>00339       <span class="comment">// linear_solution is now about to become the NEGATIVE of the next</span>
<a name="l00340"></a>00340       <span class="comment">// Newton step.</span>
<a name="l00341"></a>00341 
<a name="l00342"></a>00342       <span class="comment">// Our best initial guess for the linear_solution is zero!</span>
<a name="l00343"></a>00343       linear_solution.<a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a>();
<a name="l00344"></a>00344 
<a name="l00345"></a>00345       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00346"></a>00346         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solve starting, tolerance &quot;</span> 
<a name="l00347"></a>00347                       &lt;&lt; current_linear_tolerance &lt;&lt; std::endl;
<a name="l00348"></a>00348 
<a name="l00349"></a>00349       <span class="comment">// Solve the linear system.</span>
<a name="l00350"></a>00350       <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00351"></a>00351         <a class="code" href="classlibMesh_1_1NewtonSolver.php#a01f9ade420e57962b4f2299054b94148">linear_solver</a>-&gt;solve (matrix, <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a0f497ae21ddc216ca57b4cbdb7429f67">request_matrix</a>(<span class="stringliteral">&quot;Preconditioner&quot;</span>),
<a name="l00352"></a>00352                               linear_solution, rhs, current_linear_tolerance,
<a name="l00353"></a>00353                               <a class="code" href="classlibMesh_1_1DiffSolver.php#a2e1f21d4bbb429bbc643930238166327">max_linear_iterations</a>);
<a name="l00354"></a>00354 
<a name="l00355"></a>00355       <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00356"></a>00356       <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a> ();
<a name="l00357"></a>00357       <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00358"></a>00358 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00359"></a>00359 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>, &amp;linear_solution);
<a name="l00360"></a>00360 <span class="preprocessor">#endif</span>
<a name="l00361"></a>00361 <span class="preprocessor"></span>
<a name="l00362"></a>00362       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> linear_steps = rval.first;
<a name="l00363"></a>00363       libmesh_assert(linear_steps &lt;= <a class="code" href="classlibMesh_1_1DiffSolver.php#a2e1f21d4bbb429bbc643930238166327">max_linear_iterations</a>);
<a name="l00364"></a>00364       <a class="code" href="classlibMesh_1_1DiffSolver.php#a1427e8cbf65b72d18ba567c8cd35d3c0">_inner_iterations</a> += linear_steps;
<a name="l00365"></a>00365 
<a name="l00366"></a>00366       <span class="keyword">const</span> <span class="keywordtype">bool</span> linear_solve_finished = 
<a name="l00367"></a>00367         !(linear_steps == <a class="code" href="classlibMesh_1_1DiffSolver.php#a2e1f21d4bbb429bbc643930238166327">max_linear_iterations</a>);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00370"></a>00370         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Linear solve finished, step &quot;</span> &lt;&lt; linear_steps
<a name="l00371"></a>00371                       &lt;&lt; <span class="stringliteral">&quot;, residual &quot;</span> &lt;&lt; rval.second
<a name="l00372"></a>00372                       &lt;&lt; std::endl;
<a name="l00373"></a>00373 
<a name="l00374"></a>00374       <span class="comment">// Compute the l2 norm of the nonlinear update</span>
<a name="l00375"></a>00375       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_delta = linear_solution.<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00376"></a>00376 
<a name="l00377"></a>00377       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00378"></a>00378         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Trying full Newton step&quot;</span> &lt;&lt; std::endl;
<a name="l00379"></a>00379       <span class="comment">// Take a full Newton step</span>
<a name="l00380"></a>00380       newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a> (-1., linear_solution);
<a name="l00381"></a>00381       newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a>();
<a name="l00382"></a>00382 
<a name="l00383"></a>00383       <span class="comment">// Check residual with full Newton step, if that&#39;s useful for determining</span>
<a name="l00384"></a>00384       <span class="comment">// whether to line search, whether to quit early, or whether to die after</span>
<a name="l00385"></a>00385       <span class="comment">// hitting our max iteration count</span>
<a name="l00386"></a>00386       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1NewtonSolver.php#a1dea627cbb3fb00fcba5a937043120c4">require_residual_reduction</a> ||
<a name="l00387"></a>00387           this-&gt;<a class="code" href="classlibMesh_1_1NewtonSolver.php#a38ba1b1d0f44a76e4bd30c7339154ea3">require_finite_residual</a> ||
<a name="l00388"></a>00388           <a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>+1 &lt; max_nonlinear_iterations ||
<a name="l00389"></a>00389           !<a class="code" href="classlibMesh_1_1DiffSolver.php#a9b10e04643a5998e6bca41e54d53c0ce">continue_after_max_iterations</a>)
<a name="l00390"></a>00390         {
<a name="l00391"></a>00391           <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00392"></a>00392 
<a name="l00393"></a>00393           rhs.close();
<a name="l00394"></a>00394           current_residual = rhs.l2_norm();
<a name="l00395"></a>00395           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00396"></a>00396             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Current Residual: &quot;</span>
<a name="l00397"></a>00397                           &lt;&lt; current_residual &lt;&lt; std::endl;
<a name="l00398"></a>00398 
<a name="l00399"></a>00399           <span class="comment">// don&#39;t fiddle around if we&#39;ve already converged</span>
<a name="l00400"></a>00400           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NewtonSolver.php#a22fc638554236ea64accce2d4b16e83d">test_convergence</a>(current_residual, norm_delta,
<a name="l00401"></a>00401                                linear_solve_finished))
<a name="l00402"></a>00402             {
<a name="l00403"></a>00403               <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DiffSolver.php#ae8809909d1442365d6f7385b28625793">quiet</a>)
<a name="l00404"></a>00404                 <a class="code" href="classlibMesh_1_1NewtonSolver.php#a453d7e4e8c5e82e1fbed53b45fb53fa8">print_convergence</a>(<a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>, current_residual,
<a name="l00405"></a>00405                                   norm_delta, linear_solve_finished);
<a name="l00406"></a>00406               <a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>++;
<a name="l00407"></a>00407               <span class="keywordflow">break</span>; <span class="comment">// out of _outer_iterations for loop</span>
<a name="l00408"></a>00408             }
<a name="l00409"></a>00409         }
<a name="l00410"></a>00410 
<a name="l00411"></a>00411       <span class="comment">// since we&#39;re not converged, backtrack if necessary</span>
<a name="l00412"></a>00412       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> steplength = 1;
<a name="l00413"></a>00413       this-&gt;<a class="code" href="classlibMesh_1_1NewtonSolver.php#a694e4e4672cd45d4cc71e2d965baf204">line_search</a>(std::sqrt(TOLERANCE),
<a name="l00414"></a>00414                         last_residual, current_residual,
<a name="l00415"></a>00415                         newton_iterate, linear_solution);
<a name="l00416"></a>00416       norm_delta *= steplength;
<a name="l00417"></a>00417 
<a name="l00418"></a>00418       <span class="comment">// Check to see if backtracking failed,</span>
<a name="l00419"></a>00419       <span class="comment">// and break out of the nonlinear loop if so...</span>
<a name="l00420"></a>00420       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a> == <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a5a9f6f2aa16e982c8ab85b4394140755">DiffSolver::DIVERGED_BACKTRACKING_FAILURE</a>)
<a name="l00421"></a>00421         {
<a name="l00422"></a>00422           <a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>++;
<a name="l00423"></a>00423           <span class="keywordflow">break</span>; <span class="comment">// out of _outer_iterations for loop</span>
<a name="l00424"></a>00424         }
<a name="l00425"></a>00425 
<a name="l00426"></a>00426       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a> + 1 &gt;= max_nonlinear_iterations)
<a name="l00427"></a>00427         {
<a name="l00428"></a>00428           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver reached maximum step, &quot;</span>
<a name="l00429"></a>00429                         &lt;&lt; max_nonlinear_iterations &lt;&lt; <span class="stringliteral">&quot; latest evaluated residual &quot;</span>
<a name="l00430"></a>00430                         &lt;&lt; current_residual &lt;&lt; std::endl;
<a name="l00431"></a>00431           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#a9b10e04643a5998e6bca41e54d53c0ce">continue_after_max_iterations</a>)
<a name="l00432"></a>00432             {
<a name="l00433"></a>00433               <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a> = <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a7161b703163120b21894f1dec0ab6799">DiffSolver::DIVERGED_MAX_NONLINEAR_ITERATIONS</a>;
<a name="l00434"></a>00434               <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Continuing...&quot;</span> &lt;&lt; std::endl;
<a name="l00435"></a>00435             }
<a name="l00436"></a>00436           <span class="keywordflow">else</span>
<a name="l00437"></a>00437             {
<a name="l00438"></a>00438               libmesh_convergence_failure();
<a name="l00439"></a>00439             }
<a name="l00440"></a>00440           <span class="keywordflow">continue</span>;
<a name="l00441"></a>00441         }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443       <span class="comment">// Compute the l2 norm of the whole solution</span>
<a name="l00444"></a>00444       norm_total = newton_iterate.<a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a>();
<a name="l00445"></a>00445 
<a name="l00446"></a>00446       <a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a>, norm_total);
<a name="l00447"></a>00447 
<a name="l00448"></a>00448       <span class="comment">// Print out information for the </span>
<a name="l00449"></a>00449       <span class="comment">// nonlinear iterations.</span>
<a name="l00450"></a>00450       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00451"></a>00451         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear step: |du|/|u| = &quot;</span>
<a name="l00452"></a>00452                       &lt;&lt; norm_delta / norm_total
<a name="l00453"></a>00453                       &lt;&lt; <span class="stringliteral">&quot;, |du| = &quot;</span> &lt;&lt; norm_delta
<a name="l00454"></a>00454                       &lt;&lt; std::endl;
<a name="l00455"></a>00455 
<a name="l00456"></a>00456       <span class="comment">// Terminate the solution iteration if the difference between</span>
<a name="l00457"></a>00457       <span class="comment">// this iteration and the last is sufficiently small.</span>
<a name="l00458"></a>00458       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NewtonSolver.php#a22fc638554236ea64accce2d4b16e83d">test_convergence</a>(current_residual, norm_delta / steplength,
<a name="l00459"></a>00459                            linear_solve_finished))
<a name="l00460"></a>00460         {
<a name="l00461"></a>00461           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1DiffSolver.php#ae8809909d1442365d6f7385b28625793">quiet</a>)
<a name="l00462"></a>00462             <a class="code" href="classlibMesh_1_1NewtonSolver.php#a453d7e4e8c5e82e1fbed53b45fb53fa8">print_convergence</a>(<a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>, current_residual,
<a name="l00463"></a>00463                               norm_delta / steplength,
<a name="l00464"></a>00464                               linear_solve_finished);
<a name="l00465"></a>00465           <a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>++;
<a name="l00466"></a>00466           <span class="keywordflow">break</span>; <span class="comment">// out of _outer_iterations for loop</span>
<a name="l00467"></a>00467         }
<a name="l00468"></a>00468     } <span class="comment">// end nonlinear loop</span>
<a name="l00469"></a>00469 
<a name="l00470"></a>00470   <span class="comment">// The linear solver may not have fit our constraints exactly</span>
<a name="l00471"></a>00471 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00472"></a>00472 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>);
<a name="l00473"></a>00473 <span class="preprocessor">#endif</span>
<a name="l00474"></a>00474 <span class="preprocessor"></span>
<a name="l00475"></a>00475   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00476"></a>00476   <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a> ();
<a name="l00477"></a>00477 
<a name="l00478"></a>00478   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;NewtonSolver&quot;</span>);
<a name="l00479"></a>00479 
<a name="l00480"></a>00480   <span class="comment">// Make sure we are returning something sensible as the</span>
<a name="l00481"></a>00481   <span class="comment">// _solve_result.</span>
<a name="l00482"></a>00482   libmesh_assert (<a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a> != <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450ae632866d841ee9a65aa1c9225aeb909c">DiffSolver::INVALID_SOLVE_RESULT</a>);
<a name="l00483"></a>00483   
<a name="l00484"></a>00484   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a>;
<a name="l00485"></a>00485 }
<a name="l00486"></a>00486 
<a name="l00487"></a>00487 
<a name="l00488"></a>00488 
<a name="l00489"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a22fc638554236ea64accce2d4b16e83d">00489</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a22fc638554236ea64accce2d4b16e83d">NewtonSolver::test_convergence</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_residual,
<a name="l00490"></a>00490                                     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> step_norm,
<a name="l00491"></a>00491                                     <span class="keywordtype">bool</span> linear_solve_finished)
<a name="l00492"></a>00492 {
<a name="l00493"></a>00493   <span class="comment">// We haven&#39;t converged unless we pass a convergence test</span>
<a name="l00494"></a>00494   <span class="keywordtype">bool</span> has_converged = <span class="keyword">false</span>;
<a name="l00495"></a>00495 
<a name="l00496"></a>00496   <span class="comment">// Is our absolute residual low enough?</span>
<a name="l00497"></a>00497   <span class="keywordflow">if</span> (current_residual &lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#a1926cd67dedca636fc38ab09075b0c49">absolute_residual_tolerance</a>)
<a name="l00498"></a>00498     {
<a name="l00499"></a>00499       <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a> |= <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450aada72a67598570cfbe5bc23381893a0e">CONVERGED_ABSOLUTE_RESIDUAL</a>;
<a name="l00500"></a>00500       has_converged = <span class="keyword">true</span>;
<a name="l00501"></a>00501     }
<a name="l00502"></a>00502   
<a name="l00503"></a>00503   <span class="comment">// Is our relative residual low enough?</span>
<a name="l00504"></a>00504   <span class="keywordflow">if</span> ((current_residual / <a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">max_residual_norm</a>) &lt;
<a name="l00505"></a>00505       <a class="code" href="classlibMesh_1_1DiffSolver.php#ac277e840781dace340939660d459f266">relative_residual_tolerance</a>)
<a name="l00506"></a>00506     {
<a name="l00507"></a>00507       <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a> |= <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450af59076b835010125f7a7aba2501f38f7">CONVERGED_RELATIVE_RESIDUAL</a>;
<a name="l00508"></a>00508       has_converged = <span class="keyword">true</span>;
<a name="l00509"></a>00509     }
<a name="l00510"></a>00510   
<a name="l00511"></a>00511   <span class="comment">// For incomplete linear solves, it&#39;s not safe to test step sizes</span>
<a name="l00512"></a>00512   <span class="keywordflow">if</span> (!linear_solve_finished)
<a name="l00513"></a>00513     {
<a name="l00514"></a>00514       <span class="keywordflow">return</span> has_converged;
<a name="l00515"></a>00515     }
<a name="l00516"></a>00516   
<a name="l00517"></a>00517   <span class="comment">// Is our absolute Newton step size small enough?</span>
<a name="l00518"></a>00518   <span class="keywordflow">if</span> (step_norm &lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#a197637747531db57ef98538814252999">absolute_step_tolerance</a>)
<a name="l00519"></a>00519     {
<a name="l00520"></a>00520       <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a> |= <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450af6c19e0bb6182623a463bb7d0f24927d">CONVERGED_ABSOLUTE_STEP</a>;
<a name="l00521"></a>00521       has_converged = <span class="keyword">true</span>;
<a name="l00522"></a>00522     }
<a name="l00523"></a>00523   
<a name="l00524"></a>00524   <span class="comment">// Is our relative Newton step size small enough?</span>
<a name="l00525"></a>00525   <span class="keywordflow">if</span> (step_norm / <a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a> &lt;
<a name="l00526"></a>00526       <a class="code" href="classlibMesh_1_1DiffSolver.php#ac546f5e08f900ca8d1e90bd460da5b4f">relative_step_tolerance</a>)
<a name="l00527"></a>00527     {
<a name="l00528"></a>00528       <a class="code" href="classlibMesh_1_1DiffSolver.php#acee7627f282872e7e0e0f7bd1a95982d">_solve_result</a> |= <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450a95ac9d89a4ed442ba9a643ba6c181afa">CONVERGED_RELATIVE_STEP</a>;
<a name="l00529"></a>00529       has_converged = <span class="keyword">true</span>;
<a name="l00530"></a>00530     }
<a name="l00531"></a>00531   
<a name="l00532"></a>00532   <span class="keywordflow">return</span> has_converged;
<a name="l00533"></a>00533 }
<a name="l00534"></a>00534 
<a name="l00535"></a>00535 
<a name="l00536"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a453d7e4e8c5e82e1fbed53b45fb53fa8">00536</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a453d7e4e8c5e82e1fbed53b45fb53fa8">NewtonSolver::print_convergence</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> step_num,
<a name="l00537"></a>00537                                      <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_residual,
<a name="l00538"></a>00538                                      <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> step_norm,
<a name="l00539"></a>00539                                      <span class="keywordtype">bool</span> linear_solve_finished)
<a name="l00540"></a>00540 {
<a name="l00541"></a>00541   <span class="comment">// Is our absolute residual low enough?</span>
<a name="l00542"></a>00542   <span class="keywordflow">if</span> (current_residual &lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#a1926cd67dedca636fc38ab09075b0c49">absolute_residual_tolerance</a>)
<a name="l00543"></a>00543     {
<a name="l00544"></a>00544       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver converged, step &quot;</span> &lt;&lt; step_num
<a name="l00545"></a>00545                     &lt;&lt; <span class="stringliteral">&quot;, residual &quot;</span> &lt;&lt; current_residual
<a name="l00546"></a>00546                     &lt;&lt; std::endl;
<a name="l00547"></a>00547     }
<a name="l00548"></a>00548   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#a1926cd67dedca636fc38ab09075b0c49">absolute_residual_tolerance</a>)
<a name="l00549"></a>00549     {
<a name="l00550"></a>00550       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00551"></a>00551         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver current_residual &quot;</span>
<a name="l00552"></a>00552                      &lt;&lt; current_residual &lt;&lt; <span class="stringliteral">&quot; &gt; &quot;</span>
<a name="l00553"></a>00553                      &lt;&lt; (<a class="code" href="classlibMesh_1_1DiffSolver.php#a1926cd67dedca636fc38ab09075b0c49">absolute_residual_tolerance</a>) &lt;&lt; std::endl;
<a name="l00554"></a>00554     }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556   <span class="comment">// Is our relative residual low enough?</span>
<a name="l00557"></a>00557   <span class="keywordflow">if</span> ((current_residual / <a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">max_residual_norm</a>) &lt;
<a name="l00558"></a>00558       <a class="code" href="classlibMesh_1_1DiffSolver.php#ac277e840781dace340939660d459f266">relative_residual_tolerance</a>)
<a name="l00559"></a>00559     {
<a name="l00560"></a>00560       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver converged, step &quot;</span> &lt;&lt; step_num
<a name="l00561"></a>00561                     &lt;&lt; <span class="stringliteral">&quot;, residual reduction &quot;</span>
<a name="l00562"></a>00562                     &lt;&lt; current_residual / <a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">max_residual_norm</a>
<a name="l00563"></a>00563                     &lt;&lt; <span class="stringliteral">&quot; &lt; &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#ac277e840781dace340939660d459f266">relative_residual_tolerance</a>
<a name="l00564"></a>00564                     &lt;&lt; std::endl;
<a name="l00565"></a>00565     }
<a name="l00566"></a>00566   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#ac277e840781dace340939660d459f266">relative_residual_tolerance</a>)
<a name="l00567"></a>00567     {
<a name="l00568"></a>00568       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00569"></a>00569         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver relative residual &quot;</span>
<a name="l00570"></a>00570                      &lt;&lt; (current_residual / <a class="code" href="classlibMesh_1_1DiffSolver.php#a53af11ee109f81e72956803fea901183">max_residual_norm</a>)
<a name="l00571"></a>00571                      &lt;&lt; <span class="stringliteral">&quot; &gt; &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#ac277e840781dace340939660d459f266">relative_residual_tolerance</a>
<a name="l00572"></a>00572                      &lt;&lt; std::endl;
<a name="l00573"></a>00573     }
<a name="l00574"></a>00574 
<a name="l00575"></a>00575   <span class="comment">// For incomplete linear solves, it&#39;s not safe to test step sizes</span>
<a name="l00576"></a>00576   <span class="keywordflow">if</span> (!linear_solve_finished)
<a name="l00577"></a>00577     <span class="keywordflow">return</span>;
<a name="l00578"></a>00578 
<a name="l00579"></a>00579   <span class="comment">// Is our absolute Newton step size small enough?</span>
<a name="l00580"></a>00580   <span class="keywordflow">if</span> (step_norm &lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#a197637747531db57ef98538814252999">absolute_step_tolerance</a>)
<a name="l00581"></a>00581     {
<a name="l00582"></a>00582       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver converged, step &quot;</span> &lt;&lt; step_num
<a name="l00583"></a>00583                     &lt;&lt; <span class="stringliteral">&quot;, absolute step size &quot;</span>
<a name="l00584"></a>00584                     &lt;&lt; step_norm
<a name="l00585"></a>00585                     &lt;&lt; <span class="stringliteral">&quot; &lt; &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#a197637747531db57ef98538814252999">absolute_step_tolerance</a>
<a name="l00586"></a>00586                     &lt;&lt; std::endl;
<a name="l00587"></a>00587     }
<a name="l00588"></a>00588   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#a197637747531db57ef98538814252999">absolute_step_tolerance</a>)
<a name="l00589"></a>00589     {
<a name="l00590"></a>00590       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00591"></a>00591         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver absolute step size &quot;</span>
<a name="l00592"></a>00592                      &lt;&lt; step_norm
<a name="l00593"></a>00593                      &lt;&lt; <span class="stringliteral">&quot; &gt; &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#a197637747531db57ef98538814252999">absolute_step_tolerance</a>
<a name="l00594"></a>00594                      &lt;&lt; std::endl;
<a name="l00595"></a>00595     }
<a name="l00596"></a>00596 
<a name="l00597"></a>00597   <span class="comment">// Is our relative Newton step size small enough?</span>
<a name="l00598"></a>00598   <span class="keywordflow">if</span> (step_norm / <a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a> &lt;
<a name="l00599"></a>00599       <a class="code" href="classlibMesh_1_1DiffSolver.php#ac546f5e08f900ca8d1e90bd460da5b4f">relative_step_tolerance</a>)
<a name="l00600"></a>00600     {
<a name="l00601"></a>00601       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver converged, step &quot;</span> &lt;&lt; step_num
<a name="l00602"></a>00602                     &lt;&lt; <span class="stringliteral">&quot;, relative step size &quot;</span>
<a name="l00603"></a>00603                     &lt;&lt; (step_norm / <a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a>)
<a name="l00604"></a>00604                     &lt;&lt; <span class="stringliteral">&quot; &lt; &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#ac546f5e08f900ca8d1e90bd460da5b4f">relative_step_tolerance</a>
<a name="l00605"></a>00605                     &lt;&lt; std::endl;
<a name="l00606"></a>00606     }
<a name="l00607"></a>00607   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#ac546f5e08f900ca8d1e90bd460da5b4f">relative_step_tolerance</a>)
<a name="l00608"></a>00608     {
<a name="l00609"></a>00609       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00610"></a>00610         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  Nonlinear solver relative step size &quot;</span>
<a name="l00611"></a>00611                      &lt;&lt; (step_norm / <a class="code" href="classlibMesh_1_1DiffSolver.php#a5641b116c2015388f1e81be60f698bcf">max_solution_norm</a>)
<a name="l00612"></a>00612                      &lt;&lt; <span class="stringliteral">&quot; &gt; &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1DiffSolver.php#ac546f5e08f900ca8d1e90bd460da5b4f">relative_step_tolerance</a>
<a name="l00613"></a>00613                      &lt;&lt; std::endl;
<a name="l00614"></a>00614     }
<a name="l00615"></a>00615 }
<a name="l00616"></a>00616 
<a name="l00617"></a>00617 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
