<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">newton_solver.h</div>  </div>
</div>
<div class="contents">
<a href="newton__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: newton_solver.h 4009 2010-09-30 20:03:16Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __newton_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __newton_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="diff__solver_8h.php">diff_solver.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00048"></a>00048 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// Solver class definition</span>
<a name="l00050"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NewtonSolver.php">NewtonSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1DiffSolver.php">DiffSolver</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00057"></a>00057   <a class="code" href="classlibMesh_1_1NewtonSolver.php#a4f1730e0b4552d44d8df01dcf87c6610">NewtonSolver</a> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a>&amp; <a class="code" href="classlibMesh_1_1DiffSolver.php#a5409063e9676de368c09c023df7a92f8">system</a>);
<a name="l00058"></a>00058   
<a name="l00062"></a>00062   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#ab5fd14065433f30a6331f962268bb667">~NewtonSolver</a> ();
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a790f80775a3c4b9a417c0b929e83174c">00064</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1DiffSolver.php">DiffSolver</a> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a790f80775a3c4b9a417c0b929e83174c">Parent</a>;
<a name="l00065"></a>00065 
<a name="l00070"></a>00070   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#aece8f204133d71d9fc304e4220463c36">reinit</a> ();
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a1ecdb0c580dd308d27d06617b1145736">solve</a> ();
<a name="l00077"></a>00077 
<a name="l00085"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a1dea627cbb3fb00fcba5a937043120c4">00085</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a1dea627cbb3fb00fcba5a937043120c4">require_residual_reduction</a>;
<a name="l00086"></a>00086 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a38ba1b1d0f44a76e4bd30c7339154ea3">00094</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a38ba1b1d0f44a76e4bd30c7339154ea3">require_finite_residual</a>;
<a name="l00095"></a>00095 
<a name="l00107"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#abe1872e40e47a6100c7d68f740a3f973">00107</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#abe1872e40e47a6100c7d68f740a3f973">brent_line_search</a>;
<a name="l00108"></a>00108 
<a name="l00115"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a48596fd39541fd680830b7b7730f0bc5">00115</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a48596fd39541fd680830b7b7730f0bc5">minsteplength</a>;
<a name="l00116"></a>00116 
<a name="l00121"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#ace69fd08aa2ddfe9157db911ee2cdfb2">00121</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewtonSolver.php#ace69fd08aa2ddfe9157db911ee2cdfb2">linear_tolerance_multiplier</a>;
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="keyword">protected</span>:
<a name="l00124"></a>00124 
<a name="l00131"></a><a class="code" href="classlibMesh_1_1NewtonSolver.php#a01f9ade420e57962b4f2299054b94148">00131</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;LinearSolver&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1NewtonSolver.php#a01f9ade420e57962b4f2299054b94148">linear_solver</a>;
<a name="l00132"></a>00132 
<a name="l00139"></a>00139   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a694e4e4672cd45d4cc71e2d965baf204">line_search</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tol, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> last_residual, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&amp; current_residual,
<a name="l00140"></a>00140                    <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;newton_iterate,
<a name="l00141"></a>00141                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a> &amp;linear_solution);
<a name="l00142"></a>00142 
<a name="l00147"></a>00147   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a453d7e4e8c5e82e1fbed53b45fb53fa8">print_convergence</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> step_num,
<a name="l00148"></a>00148                          <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_residual,
<a name="l00149"></a>00149                          <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> step_norm,
<a name="l00150"></a>00150                          <span class="keywordtype">bool</span> linear_solve_finished);
<a name="l00151"></a>00151 
<a name="l00156"></a>00156   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NewtonSolver.php#a22fc638554236ea64accce2d4b16e83d">test_convergence</a>(<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_residual,
<a name="l00157"></a>00157                         <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> step_norm,
<a name="l00158"></a>00158                         <span class="keywordtype">bool</span> linear_solve_finished);
<a name="l00159"></a>00159 };
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 } <span class="comment">// namespace libMesh</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 <span class="preprocessor">#endif // #define __newton_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
