<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">node.h</div>  </div>
</div>
<div class="contents">
<a href="node_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: node.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __node_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __node_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dof__object_8h.php">dof_object.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// forward declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>Node;
<a name="l00039"></a>00039 <span class="keyword">class </span>MeshRefinement;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00054"></a><a class="code" href="classlibMesh_1_1Node.php">00054</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Node.php">Node</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>,
<a name="l00055"></a>00055              <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>,      
<a name="l00056"></a>00056              <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Node&gt;
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00060"></a>00060   
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node</a>  (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x,
<a name="l00066"></a>00066          <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y,
<a name="l00067"></a>00067          <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> z,
<a name="l00068"></a>00068          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">invalid_id</a>);
<a name="l00069"></a>00069 
<a name="l00073"></a>00073   <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; n);
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keyword">explicit</span> <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00079"></a>00079                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> = <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">invalid_id</a>);
<a name="l00080"></a>00080 
<a name="l00084"></a>00084   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php#a4dc30922f479715ca31573df37cf1a76">~Node</a> ();
<a name="l00085"></a>00085 
<a name="l00089"></a>00089   <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; <a class="code" href="classlibMesh_1_1Node.php#a628d47b6eba957ad303cb87871ff8c16">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p);
<a name="l00090"></a>00090   
<a name="l00095"></a>00095   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">build</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; n);
<a name="l00096"></a>00096 
<a name="l00101"></a>00101   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">build</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00102"></a>00102                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00103"></a>00103   
<a name="l00108"></a>00108   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">build</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x,
<a name="l00109"></a>00109                               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y,
<a name="l00110"></a>00110                               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> z,
<a name="l00111"></a>00111                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00112"></a>00112 
<a name="l00119"></a>00119   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Node.php#a8d3dad2047efb39b9cae275f7028b7d5">active</a> () <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00125"></a>00125   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Node.php#af1c04526cc6dce9d3bc5e6cc9c726e9d">operator ==</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; rhs) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00137"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php">00137</a>   <span class="keyword">struct </span><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php">PackedNode</a>
<a name="l00138"></a>00138   {
<a name="l00139"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a24ad894c88ce5bcab25efd2e2a9ae2f3">00139</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a24ad894c88ce5bcab25efd2e2a9ae2f3">id</a>;
<a name="l00140"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a941e3c3b0d955ad7402c2cb7aac5b70e">00140</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a941e3c3b0d955ad7402c2cb7aac5b70e">pid</a>;
<a name="l00141"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a467a1fd3bf1403c8da90d48fb669265a">00141</a>     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a467a1fd3bf1403c8da90d48fb669265a">x</a>;
<a name="l00142"></a>00142 <span class="comment">// FIXME: We should drop z (and y) if libMesh is built 2D (or 1D) only</span>
<a name="l00143"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a08291bbe1e60fa2b94f79809a03a2956">00143</a>     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a08291bbe1e60fa2b94f79809a03a2956">y</a>;
<a name="l00144"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#ac74af614f10fcab5b03ace735acab3d8">00144</a>     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#ac74af614f10fcab5b03ace735acab3d8">z</a>;
<a name="l00145"></a>00145 
<a name="l00146"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#ab988d4a96fbec9bbfd6797de4d2f32b6">00146</a>     <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#ab988d4a96fbec9bbfd6797de4d2f32b6">PackedNode</a> () :
<a name="l00147"></a>00147       id(0),
<a name="l00148"></a>00148       <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a941e3c3b0d955ad7402c2cb7aac5b70e">pid</a>(<a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>::<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">invalid_processor_id</a>),
<a name="l00149"></a>00149       x(0.),
<a name="l00150"></a>00150       y(0.),
<a name="l00151"></a>00151       z(0.)
<a name="l00152"></a>00152     {}
<a name="l00153"></a>00153 
<a name="l00154"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#af953b9e02e7289bfa35e4f5d379fc21e">00154</a>     <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#ab988d4a96fbec9bbfd6797de4d2f32b6">PackedNode</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a> &amp;node) :
<a name="l00155"></a>00155       id(node.id()),
<a name="l00156"></a>00156       <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a941e3c3b0d955ad7402c2cb7aac5b70e">pid</a>(node.<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>()),
<a name="l00157"></a>00157       x(node(0)),
<a name="l00158"></a>00158 #if LIBMESH_DIM &gt; 1
<a name="l00159"></a>00159       y(node(1)),
<a name="l00160"></a>00160 #else
<a name="l00161"></a>00161       y(0.),
<a name="l00162"></a>00162 #endif
<a name="l00163"></a>00163 #if LIBMESH_DIM &gt; 2
<a name="l00164"></a>00164       z(node(2))
<a name="l00165"></a>00165 #else
<a name="l00166"></a>00166       z(0.)
<a name="l00167"></a>00167 #endif
<a name="l00168"></a>00168     {}
<a name="l00169"></a>00169 
<a name="l00170"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#acc4e393b923ac770857065da323f1580">00170</a>     <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#acc4e393b923ac770857065da323f1580">build_node</a> ()<span class="keyword"> const</span>
<a name="l00171"></a>00171 <span class="keyword">    </span>{
<a name="l00172"></a>00172       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> node(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node</a>(x,y,z,<span class="keywordtype">id</span>));
<a name="l00173"></a>00173       node-&gt;processor_id() = <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a941e3c3b0d955ad7402c2cb7aac5b70e">pid</a>;
<a name="l00174"></a>00174       <span class="keywordflow">return</span> node;
<a name="l00175"></a>00175     }
<a name="l00176"></a>00176 
<a name="l00177"></a><a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#aab6b8856ee0cdec6c41107b1bbb6aad3">00177</a>     <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#aab6b8856ee0cdec6c41107b1bbb6aad3">build_point</a> ()<span class="keyword"> const</span>
<a name="l00178"></a>00178 <span class="keyword">    </span>{
<a name="l00179"></a>00179       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Point.php#a1d422159eca00677230dcb247daf4c21">Point</a>(x,y,z);
<a name="l00180"></a>00180     }
<a name="l00181"></a>00181     
<a name="l00182"></a>00182     <span class="keyword">static</span> MPI_Datatype <a class="code" href="structlibMesh_1_1Node_1_1PackedNode.php#a55550d69ace1f2e06fa03a9f21d850c0">create_mpi_datatype</a> ();
<a name="l00183"></a>00183     
<a name="l00184"></a>00184   };
<a name="l00185"></a>00185 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_MPI</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>  
<a name="l00187"></a>00187 <span class="keyword">private</span>:
<a name="l00188"></a>00188 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1Node.php#a7eb42a58c387442456965deba0fd97fd">00193</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1MeshRefinement.php">MeshRefinement</a>;
<a name="l00194"></a><a class="code" href="classlibMesh_1_1Node.php#ad1b9b5ac435c80adb1c05c0f811aa841">00194</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Elem.php">Elem</a>;
<a name="l00195"></a>00195 };
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="comment">//------------------------------------------------------</span>
<a name="l00200"></a>00200 <span class="comment">// Inline functions</span>
<a name="l00201"></a>00201 <span class="keyword">inline</span>
<a name="l00202"></a><a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">00202</a> <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node::Node</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x,
<a name="l00203"></a>00203             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y,
<a name="l00204"></a>00204             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> z,
<a name="l00205"></a>00205             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>) :
<a name="l00206"></a>00206   <a class="code" href="classlibMesh_1_1Point.php">Point</a>(x,y,z)
<a name="l00207"></a>00207 {
<a name="l00208"></a>00208   this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>() = <a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>;
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 <span class="keyword">inline</span>
<a name="l00214"></a><a class="code" href="classlibMesh_1_1Node.php#a5e26a1d5679536ea0c5a92e98b7ff035">00214</a> <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node::Node</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; n) :
<a name="l00215"></a>00215   <a class="code" href="classlibMesh_1_1Point.php">Point</a>(n),
<a name="l00216"></a>00216   <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a>(n),
<a name="l00217"></a>00217   <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;<a class="code" href="classlibMesh_1_1Node.php">Node</a>&gt;()
<a name="l00218"></a>00218 {
<a name="l00219"></a>00219 }
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="keyword">inline</span>
<a name="l00224"></a><a class="code" href="classlibMesh_1_1Node.php#a63660249d12c5214d06502fa6d4c7493">00224</a> <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node::Node</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00225"></a>00225             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>) :
<a name="l00226"></a>00226   <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p)
<a name="l00227"></a>00227 {
<a name="l00228"></a>00228   <span class="comment">// optionally assign the id.  We have</span>
<a name="l00229"></a>00229   <span class="comment">// to do it like this otherwise</span>
<a name="l00230"></a>00230   <span class="comment">// Node n = Point p would erase</span>
<a name="l00231"></a>00231   <span class="comment">// the id!</span>
<a name="l00232"></a>00232   <span class="keywordflow">if</span> (<span class="keywordtype">id</span> != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">invalid_id</a>)
<a name="l00233"></a>00233     this-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>() = <a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>;
<a name="l00234"></a>00234 }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 <span class="keyword">inline</span>
<a name="l00239"></a><a class="code" href="classlibMesh_1_1Node.php#a4dc30922f479715ca31573df37cf1a76">00239</a> <a class="code" href="classlibMesh_1_1Node.php#a4dc30922f479715ca31573df37cf1a76">Node::~Node</a> ()
<a name="l00240"></a>00240 {
<a name="l00241"></a>00241 }
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 
<a name="l00244"></a>00244 
<a name="l00245"></a>00245 <span class="keyword">inline</span>
<a name="l00246"></a><a class="code" href="classlibMesh_1_1Node.php#a628d47b6eba957ad303cb87871ff8c16">00246</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a> &amp; <a class="code" href="classlibMesh_1_1Node.php#a628d47b6eba957ad303cb87871ff8c16">Node::operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)
<a name="l00247"></a>00247 {
<a name="l00248"></a>00248   (*this)(0) = p(0);
<a name="l00249"></a>00249 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span>  (*this)(1) = p(1);
<a name="l00251"></a>00251 <span class="preprocessor">#endif</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00253"></a>00253 <span class="preprocessor"></span>  (*this)(2) = p(2);
<a name="l00254"></a>00254 <span class="preprocessor">#endif</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span>
<a name="l00256"></a>00256   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00257"></a>00257 }
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="keyword">inline</span>
<a name="l00262"></a><a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">00262</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">Node::build</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; n)
<a name="l00263"></a>00263 {
<a name="l00264"></a>00264   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node</a>(n));
<a name="l00265"></a>00265   <span class="keywordflow">return</span> ap;
<a name="l00266"></a>00266 }
<a name="l00267"></a>00267 
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 <span class="keyword">inline</span>
<a name="l00271"></a><a class="code" href="classlibMesh_1_1Node.php#a027417ab4d3bd8590d4e9e24d5602077">00271</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">Node::build</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00272"></a>00272                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00273"></a>00273 {
<a name="l00274"></a>00274   
<a name="l00275"></a>00275   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node</a>(p,<span class="keywordtype">id</span>));
<a name="l00276"></a>00276   <span class="keywordflow">return</span> ap;
<a name="l00277"></a>00277 }
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281 <span class="keyword">inline</span>
<a name="l00282"></a><a class="code" href="classlibMesh_1_1Node.php#a366a5166cb2c4e13b0d91e8af34e2ca2">00282</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> <a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">Node::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x,
<a name="l00283"></a>00283                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> y,
<a name="l00284"></a>00284                           <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> z,
<a name="l00285"></a>00285                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00286"></a>00286 {
<a name="l00287"></a>00287   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;Node&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Node.php#a287f13696634037a2a2d36064cc3dbe7">Node</a>(x,y,z,<span class="keywordtype">id</span>));
<a name="l00288"></a>00288   <span class="keywordflow">return</span> ap;
<a name="l00289"></a>00289 }
<a name="l00290"></a>00290 
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 
<a name="l00293"></a>00293 <span class="keyword">inline</span>
<a name="l00294"></a><a class="code" href="classlibMesh_1_1Node.php#a8d3dad2047efb39b9cae275f7028b7d5">00294</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Node.php#a8d3dad2047efb39b9cae275f7028b7d5">Node::active</a> ()<span class="keyword"> const</span>
<a name="l00295"></a>00295 <span class="keyword"></span>{
<a name="l00296"></a>00296   <span class="keywordflow">return</span> (this-&gt;<span class="keywordtype">id</span>() != <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">Node::invalid_id</a>);
<a name="l00297"></a>00297 }
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 
<a name="l00300"></a>00300 } <span class="comment">// namespace libMesh</span>
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a>00303 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
