<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">node_elem.h</div>  </div>
</div>
<div class="contents">
<a href="node__elem_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: node_elem.h 4279 2011-03-21 17:01:31Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __node_elem_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __node_elem_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// NodeElem class definition</span>
<a name="l00044"></a><a class="code" href="classlibMesh_1_1NodeElem.php">00044</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NodeElem.php">NodeElem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046  <span class="keyword">public</span>:
<a name="l00047"></a>00047 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1NodeElem.php#ac980dcd9257a371aed13091176909302">00051</a>   <a class="code" href="classlibMesh_1_1NodeElem.php#ac980dcd9257a371aed13091176909302">NodeElem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p=NULL) :
<a name="l00052"></a>00052     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>(<a class="code" href="classlibMesh_1_1NodeElem.php">NodeElem</a>::<a class="code" href="classlibMesh_1_1NodeElem.php#af564f13e0939b286d389035179c72837">n_nodes</a>(), <a class="code" href="classlibMesh_1_1NodeElem.php">NodeElem</a>::<a class="code" href="classlibMesh_1_1NodeElem.php#a4336dba4f6c3794aaf142c5bb22d8c5d">n_sides</a>(), p) {}
<a name="l00053"></a>00053 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a504d8df7b67525d0f7a6271d65ee8529">00058</a>   <a class="code" href="classlibMesh_1_1NodeElem.php#ac980dcd9257a371aed13091176909302">NodeElem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00059"></a>00059          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns,
<a name="l00060"></a>00060          <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00061"></a>00061     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>(nn, ns, p) { libmesh_assert(nn == 1); libmesh_assert (ns == 0); }
<a name="l00062"></a>00062 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a1218983184617b60bb4e205da209dff1">00067</a>   <a class="code" href="classlibMesh_1_1NodeElem.php#ac980dcd9257a371aed13091176909302">NodeElem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nn,
<a name="l00068"></a>00068         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* p) :
<a name="l00069"></a>00069     <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>(nn, <a class="code" href="classlibMesh_1_1NodeElem.php">NodeElem</a>::<a class="code" href="classlibMesh_1_1NodeElem.php#a4336dba4f6c3794aaf142c5bb22d8c5d">n_sides</a>(), p) {}
<a name="l00070"></a>00070    
<a name="l00074"></a><a class="code" href="classlibMesh_1_1NodeElem.php#ad3d2a47a39b229a99180823a79028b7a">00074</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#ad3d2a47a39b229a99180823a79028b7a">dim</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00075"></a>00075   
<a name="l00079"></a><a class="code" href="classlibMesh_1_1NodeElem.php#af564f13e0939b286d389035179c72837">00079</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#af564f13e0939b286d389035179c72837">n_nodes</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00080"></a>00080 
<a name="l00084"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a4336dba4f6c3794aaf142c5bb22d8c5d">00084</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a4336dba4f6c3794aaf142c5bb22d8c5d">n_sides</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00085"></a>00085 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1NodeElem.php#af8739c6a77af88d1bed2ba6d7ff09a50">00089</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#af8739c6a77af88d1bed2ba6d7ff09a50">n_vertices</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00090"></a>00090   
<a name="l00094"></a><a class="code" href="classlibMesh_1_1NodeElem.php#aebc498868c54d5ba53452c390d9a79d3">00094</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#aebc498868c54d5ba53452c390d9a79d3">n_edges</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00095"></a>00095   
<a name="l00099"></a><a class="code" href="classlibMesh_1_1NodeElem.php#aa650400d70cb19bf4d0c0de068c4a607">00099</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#aa650400d70cb19bf4d0c0de068c4a607">n_faces</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00100"></a>00100   
<a name="l00104"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a4fdcc99207fa676a80c43c8e2f191311">00104</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a4fdcc99207fa676a80c43c8e2f191311">n_children</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00105"></a>00105 
<a name="l00110"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a3ce73af39dc68ef17d5c27cb27a8475f">00110</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a3ce73af39dc68ef17d5c27cb27a8475f">key</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00111"></a>00111 <span class="keyword">  </span>{ <span class="keywordflow">return</span> 0; }
<a name="l00112"></a>00112   
<a name="l00116"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a740668097d33beca1a87d6a330e3ba82">00116</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1NodeElem.php#a740668097d33beca1a87d6a330e3ba82">side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00117"></a>00117 <span class="keyword">  </span>{ libmesh_error(); <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL); <span class="keywordflow">return</span> ap; }
<a name="l00118"></a>00118 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a849dfaca5c7e9b5081031068aca2db30">00122</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1NodeElem.php#a849dfaca5c7e9b5081031068aca2db30">build_side</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <span class="keywordtype">bool</span>)<span class="keyword"> const</span>
<a name="l00123"></a>00123 <span class="keyword">  </span>{ libmesh_error(); <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL); <span class="keywordflow">return</span> ap; }
<a name="l00124"></a>00124 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1NodeElem.php#acd3d4f7d84fa1b25f5d51bf8859e0545">00128</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> <a class="code" href="classlibMesh_1_1NodeElem.php#acd3d4f7d84fa1b25f5d51bf8859e0545">build_edge</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00129"></a>00129 <span class="keyword">  </span>{ libmesh_error(); <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Elem&gt;</a> ap(NULL); <span class="keywordflow">return</span> ap; }
<a name="l00130"></a>00130 
<a name="l00134"></a><a class="code" href="classlibMesh_1_1NodeElem.php#aacd1da026e15c1c1b09c1dc7bb9fc47c">00134</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#aacd1da026e15c1c1b09c1dc7bb9fc47c">n_sub_elem</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> 1; }
<a name="l00135"></a>00135   
<a name="l00139"></a><a class="code" href="classlibMesh_1_1NodeElem.php#af394be56f811919b4d46457b66012a5f">00139</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NodeElem.php#af394be56f811919b4d46457b66012a5f">is_vertex</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00140"></a>00140 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a3a8b4b6774caa7655956bf1c1e68361f">00144</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a3a8b4b6774caa7655956bf1c1e68361f">is_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00145"></a>00145 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a5c6a3f96bfce1c3238901a9cbbab135f">00146</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a5c6a3f96bfce1c3238901a9cbbab135f">is_face</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00147"></a>00147   
<a name="l00148"></a><a class="code" href="classlibMesh_1_1NodeElem.php#ae1e82234afed407cad39f7fa8d357848">00148</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NodeElem.php#ae1e82234afed407cad39f7fa8d357848">is_child_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00149"></a>00149                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00150"></a>00150 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00151"></a>00151   
<a name="l00152"></a><a class="code" href="classlibMesh_1_1NodeElem.php#aee310191c5379856b25652fced9e373c">00152</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NodeElem.php#aee310191c5379856b25652fced9e373c">is_node_on_side</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00153"></a>00153                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00154"></a>00154 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00155"></a>00155   
<a name="l00156"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a307bb4f601a6336f005090aae7d0c8bc">00156</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a307bb4f601a6336f005090aae7d0c8bc">is_node_on_edge</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00157"></a>00157                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const </span>
<a name="l00158"></a>00158 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00159"></a>00159   
<a name="l00160"></a>00160   <span class="comment">/*</span>
<a name="l00161"></a>00161 <span class="comment">   * @returns true iff the element map is definitely affine within</span>
<a name="l00162"></a>00162 <span class="comment">   * numerical tolerances</span>
<a name="l00163"></a>00163 <span class="comment">   */</span>
<a name="l00164"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a0b7b6042d9a3c79765e6de971d46d3c4">00164</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a0b7b6042d9a3c79765e6de971d46d3c4">has_affine_map</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">true</span>; }
<a name="l00165"></a>00165 
<a name="l00169"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a4c12f93e5922b9bec8b79f05f835d5fb">00169</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1NodeElem.php#a4c12f93e5922b9bec8b79f05f835d5fb">type</a>()<span class="keyword">  const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a49a1a401f0da579d7493973d61d7126f">NODEELEM</a>; }
<a name="l00170"></a>00170   
<a name="l00174"></a><a class="code" href="classlibMesh_1_1NodeElem.php#af6986648de53cca8005d39f34e104146">00174</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1NodeElem.php#af6986648de53cca8005d39f34e104146">default_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>; }
<a name="l00175"></a>00175 
<a name="l00176"></a>00176   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a90dcfd17ccd4d8c6f596378040351d1c">connectivity</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sc,
<a name="l00177"></a>00177                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ad24574b4526500f7ddc33a9bf75f953a">IOPackage</a> iop,
<a name="l00178"></a>00178                             std::vector&lt;unsigned int&gt;&amp; conn) <span class="keyword">const</span>;
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 <span class="preprocessor">#ifdef LIBMESH_ENABLE_INFINITE_ELEMENTS</span>
<a name="l00182"></a>00182 <span class="preprocessor"></span>
<a name="l00186"></a><a class="code" href="classlibMesh_1_1NodeElem.php#ad8029e2f737e55d3cedc443f317ff175">00186</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NodeElem.php#ad8029e2f737e55d3cedc443f317ff175">infinite</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="preprocessor">#endif</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>
<a name="l00190"></a>00190   
<a name="l00191"></a>00191 <span class="keyword">protected</span>:
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   
<a name="l00194"></a>00194 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00195"></a>00195 <span class="preprocessor"></span>
<a name="l00199"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a8834284a176e46a43942a7d41fa2acdc">00199</a>   <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a8834284a176e46a43942a7d41fa2acdc">embedding_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00200"></a>00200                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00201"></a>00201                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k)<span class="keyword"> const</span>
<a name="l00202"></a>00202 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a10572d625e4a6192bf1b62c219f7c158">_embedding_matrix</a>[i][j][k]; }
<a name="l00203"></a>00203   
<a name="l00208"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a10572d625e4a6192bf1b62c219f7c158">00208</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a10572d625e4a6192bf1b62c219f7c158">_embedding_matrix</a>[1][1][1];
<a name="l00209"></a>00209   
<a name="l00213"></a><a class="code" href="classlibMesh_1_1NodeElem.php#a89baa053e7b3be37c5dad0ada8bc126b">00213</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NodeElem.php#a89baa053e7b3be37c5dad0ada8bc126b">side_children_matrix</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, 
<a name="l00214"></a>00214                                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)<span class="keyword"> const</span>
<a name="l00215"></a>00215 <span class="keyword">  </span>{ libmesh_error(); <span class="keywordflow">return</span> 0; }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 <span class="preprocessor">#endif</span>
<a name="l00218"></a>00218 <span class="preprocessor"></span>  
<a name="l00219"></a>00219 };
<a name="l00220"></a>00220 
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00226"></a>00226 <span class="comment">// NodeElem class member functions</span>
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 } <span class="comment">// namespace libMesh</span>
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
