<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">nonlinear.h</div>  </div>
</div>
<div class="contents">
<a href="nonlinear_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nonlinear.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __nonlinear_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __nonlinear_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="linear_8h.php">linear.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00043"></a>00043 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00044"></a>00044 <span class="comment">// Nonlinear class definition</span>
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T = Linear&lt;&gt; &gt;
<a name="l00047"></a><a class="code" href="classlibMesh_1_1Nonlinear.php">00047</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Nonlinear.php">Nonlinear</a> : <span class="keyword">public</span> T
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050   
<a name="l00054"></a>00054   <a class="code" href="classlibMesh_1_1Nonlinear.php#aa2a79812ad20975a32d3fdd32bbe7078">Nonlinear</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es);
<a name="l00055"></a>00055 
<a name="l00059"></a>00059   <a class="code" href="classlibMesh_1_1Nonlinear.php#aa2a79812ad20975a32d3fdd32bbe7078">Nonlinear</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00060"></a>00060              <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00061"></a>00061              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number);
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1Nonlinear.php#ada9a984c48d6c2bdcc19dc3ea2c86cb4">~Nonlinear</a> ();
<a name="l00067"></a>00067 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nonlinear.php#afa7b2af8523df4e576938b795320d541">solve</a> ();
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#ac023f27f3c08d4213d57e7b608d443ce">00077</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nonlinear.php#ac023f27f3c08d4213d57e7b608d443ce">max_nonlinear_steps</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Nonlinear.php#a254275c7b3afbe14387b2f69fc99f4c1">_max_nl_steps</a>; }
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#aef5b1d8e31925af721d6d77e64cb7a83">00082</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> &amp; <a class="code" href="classlibMesh_1_1Nonlinear.php#aef5b1d8e31925af721d6d77e64cb7a83">max_nonlinear_steps</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Nonlinear.php#a254275c7b3afbe14387b2f69fc99f4c1">_max_nl_steps</a>; }
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#af8cf4615b9d3c1bd247d0a40b0ee9a02">00087</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Nonlinear.php#af8cf4615b9d3c1bd247d0a40b0ee9a02">nonlinear_tolerance</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Nonlinear.php#a2e8566ff9b3ddc6d6d646deb33bbc1c1">_nl_tol</a>; }
<a name="l00088"></a>00088 
<a name="l00092"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#a596cc9ca9ff1fb99ba9e73f1c2747f7b">00092</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> &amp; <a class="code" href="classlibMesh_1_1Nonlinear.php#a596cc9ca9ff1fb99ba9e73f1c2747f7b">nonlinear_tolerance</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Nonlinear.php#a2e8566ff9b3ddc6d6d646deb33bbc1c1">_nl_tol</a>; }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   
<a name="l00095"></a>00095 <span class="keyword">private</span>:
<a name="l00096"></a>00096 
<a name="l00100"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#a254275c7b3afbe14387b2f69fc99f4c1">00100</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Nonlinear.php#a254275c7b3afbe14387b2f69fc99f4c1">_max_nl_steps</a>;
<a name="l00101"></a>00101 
<a name="l00105"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#a2e8566ff9b3ddc6d6d646deb33bbc1c1">00105</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1Nonlinear.php#a2e8566ff9b3ddc6d6d646deb33bbc1c1">_nl_tol</a>;
<a name="l00106"></a>00106 };
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00111"></a>00111 <span class="comment">// Nonlinear inline members</span>
<a name="l00112"></a>00112 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00113"></a>00113 <span class="keyword">inline</span>
<a name="l00114"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#aa2a79812ad20975a32d3fdd32bbe7078">00114</a> <a class="code" href="classlibMesh_1_1Nonlinear.php#aa2a79812ad20975a32d3fdd32bbe7078">Nonlinear&lt;T&gt;::Nonlinear</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es) :
<a name="l00115"></a>00115   T             (es),  <span class="comment">// Call the base class constructor</span>
<a name="l00116"></a>00116   _max_nl_steps (5),   <span class="comment">// Default solver attributes</span>
<a name="l00117"></a>00117   _nl_tol       (1.e-6)
<a name="l00118"></a>00118 {
<a name="l00119"></a>00119 libmesh_deprecated();
<a name="l00120"></a>00120 }
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00125"></a>00125 <span class="keyword">inline</span>
<a name="l00126"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#aa4cf552a388790e265089ae9e3a494be">00126</a> <a class="code" href="classlibMesh_1_1Nonlinear.php#aa2a79812ad20975a32d3fdd32bbe7078">Nonlinear&lt;T&gt;::Nonlinear</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00127"></a>00127                          <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00128"></a>00128                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1Nonlinear.php">Nonlinear</a> (es),
<a name="l00130"></a>00130   T         (es, name, number)  <span class="comment">// Call the base class constructor</span>
<a name="l00131"></a>00131 {
<a name="l00132"></a>00132 libmesh_deprecated();
<a name="l00133"></a>00133 }
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00138"></a>00138 <span class="keyword">inline</span>
<a name="l00139"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#ada9a984c48d6c2bdcc19dc3ea2c86cb4">00139</a> <a class="code" href="classlibMesh_1_1Nonlinear.php#ada9a984c48d6c2bdcc19dc3ea2c86cb4">Nonlinear&lt;T&gt;::~Nonlinear</a> ()
<a name="l00140"></a>00140 {
<a name="l00141"></a>00141 libmesh_deprecated();
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00147"></a>00147 <span class="keyword">inline</span>
<a name="l00148"></a><a class="code" href="classlibMesh_1_1Nonlinear.php#afa7b2af8523df4e576938b795320d541">00148</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Nonlinear.php#afa7b2af8523df4e576938b795320d541">Nonlinear&lt;T&gt;::solve</a> ()
<a name="l00149"></a>00149 {
<a name="l00150"></a>00150   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> l=0; l&lt;this-&gt;max_nonlinear_steps(); l++)
<a name="l00151"></a>00151     {
<a name="l00152"></a>00152       <span class="comment">// Get a copy of the solution at the current nonlinear</span>
<a name="l00153"></a>00153       <span class="comment">// iteration</span>
<a name="l00154"></a>00154       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;Number&gt;</a> &gt;
<a name="l00155"></a>00155         last_nonlinear_soln (this-&gt;system().solution-&gt;clone());
<a name="l00156"></a>00156       
<a name="l00157"></a>00157       <span class="comment">// Call the base class solver</span>
<a name="l00158"></a>00158       T::solve ();
<a name="l00159"></a>00159 
<a name="l00160"></a>00160       <span class="comment">// Compute the difference between this solution</span>
<a name="l00161"></a>00161       <span class="comment">// and the last iterate</span>
<a name="l00162"></a>00162       last_nonlinear_soln-&gt;add (-1., *(this-&gt;system().solution));
<a name="l00163"></a>00163 
<a name="l00164"></a>00164       <span class="comment">// We must close the vector before we ask it for its norm</span>
<a name="l00165"></a>00165       last_nonlinear_soln-&gt;close();
<a name="l00166"></a>00166       
<a name="l00167"></a>00167       <span class="comment">// Compute the l2 norm of the difference</span>
<a name="l00168"></a>00168       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm_delta = last_nonlinear_soln-&gt;l2_norm();
<a name="l00169"></a>00169 
<a name="l00170"></a>00170       <span class="comment">// Print out convergence information</span>
<a name="l00171"></a>00171       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Nonlinear convergence: ||u - u_old|| = &quot;</span>
<a name="l00172"></a>00172                    &lt;&lt; norm_delta
<a name="l00173"></a>00173                    &lt;&lt; std::endl;
<a name="l00174"></a>00174 
<a name="l00175"></a>00175       <span class="comment">// Terminate the solution iteration if the difference between</span>
<a name="l00176"></a>00176       <span class="comment">// this iteration and the last is sufficiently small.</span>
<a name="l00177"></a>00177       <span class="keywordflow">if</span> (norm_delta &lt; this-&gt;nonlinear_tolerance())
<a name="l00178"></a>00178         {
<a name="l00179"></a>00179           <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot; Nonlinear solver converged at step &quot;</span>
<a name="l00180"></a>00180                        &lt;&lt; l
<a name="l00181"></a>00181                        &lt;&lt; std::endl;
<a name="l00182"></a>00182           <span class="keywordflow">break</span>;
<a name="l00183"></a>00183         }
<a name="l00184"></a>00184     }
<a name="l00185"></a>00185 }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 } <span class="comment">// namespace libMesh</span>
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 <span class="preprocessor">#endif // #define __nonlinear_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
