<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">nonlinear_implicit_system.C</div>  </div>
</div>
<div class="contents">
<a href="nonlinear__implicit__system_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nonlinear_implicit_system.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="nonlinear__implicit__system_8h.php">nonlinear_implicit_system.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="diff__solver_8h.php">diff_solver.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="equation__systems_8h.php">equation_systems.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="nonlinear__solver_8h.php">nonlinear_solver.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00036"></a>00036 <span class="comment">// NonlinearImplicitSystem implementation</span>
<a name="l00037"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a2b65a42059093a775cbc03bda6538a9f">00037</a> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a2b65a42059093a775cbc03bda6538a9f">NonlinearImplicitSystem::NonlinearImplicitSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00038"></a>00038                                                   <span class="keyword">const</span> std::string&amp; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00039"></a>00039                                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> number) :
<a name="l00040"></a>00040   
<a name="l00041"></a>00041   <a class="code" href="classlibMesh_1_1System.php">Parent</a>                    (es, name, number),
<a name="l00042"></a>00042   nonlinear_solver          (<a class="code" href="classlibMesh_1_1NonlinearSolver.php">NonlinearSolver</a>&lt;<a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>&gt;::build(*this)),
<a name="l00043"></a>00043   diff_solver               (NULL),
<a name="l00044"></a>00044   _n_nonlinear_iterations   (0),
<a name="l00045"></a>00045   _final_nonlinear_residual (1.e20)
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047   <span class="comment">// Set default parameters</span>
<a name="l00048"></a>00048   <span class="comment">// These were chosen to match the Petsc defaults</span>
<a name="l00049"></a>00049   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;        (<span class="stringliteral">&quot;linear solver tolerance&quot;</span>) = 1e-5;
<a name="l00050"></a>00050   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;        (<span class="stringliteral">&quot;linear solver minimum tolerance&quot;</span>) = 1e-5;
<a name="l00051"></a>00051   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>) = 10000;
<a name="l00052"></a>00052   
<a name="l00053"></a>00053   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;nonlinear solver maximum iterations&quot;</span>) = 50;
<a name="l00054"></a>00054   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;nonlinear solver maximum function evaluations&quot;</span>) = 10000;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver absolute residual tolerance&quot;</span>) = 1e-50;
<a name="l00057"></a>00057   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver relative residual tolerance&quot;</span>) = 1e-8;
<a name="l00058"></a>00058   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver absolute step tolerance&quot;</span>) = 1e-8;
<a name="l00059"></a>00059   es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#a7036d0ddbe4965e0a638e1b9814fa549">set</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver relative step tolerance&quot;</span>) = 1e-8;
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a6c7773a109cdc535751046c6ec42b2cf">00064</a> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a6c7773a109cdc535751046c6ec42b2cf">NonlinearImplicitSystem::~NonlinearImplicitSystem</a> ()
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   <span class="comment">// Clear data</span>
<a name="l00067"></a>00067   this-&gt;<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a8bcf68edde0094081171c633ef959bd1">clear</a>();
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a8bcf68edde0094081171c633ef959bd1">00072</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a8bcf68edde0094081171c633ef959bd1">NonlinearImplicitSystem::clear</a> ()
<a name="l00073"></a>00073 {
<a name="l00074"></a>00074   <span class="comment">// clear the nonlinear solver</span>
<a name="l00075"></a>00075   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;clear();
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <span class="comment">// clear the parent data</span>
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a8ec1dbe98f37b3fa50d87292e5b46827">Parent::clear</a>();
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a357e2def2e45779aa185d69032fa8a79">00083</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a357e2def2e45779aa185d69032fa8a79">NonlinearImplicitSystem::reinit</a> ()
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085   <span class="comment">// re-initialize the nonlinear solver interface</span>
<a name="l00086"></a>00086   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;clear();
<a name="l00087"></a>00087 
<a name="l00088"></a>00088   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00089"></a>00089     <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;reinit();
<a name="l00090"></a>00090   
<a name="l00091"></a>00091   <span class="comment">// initialize parent data</span>
<a name="l00092"></a>00092   <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a766e6bac5c51ef16b7ddc4f62933b309">Parent::reinit</a>();  
<a name="l00093"></a>00093 }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a0df3fa92601482658868919cd80de095">00097</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a0df3fa92601482658868919cd80de095">NonlinearImplicitSystem::set_solver_parameters</a> ()
<a name="l00098"></a>00098 {
<a name="l00099"></a>00099   <span class="comment">// Get a reference to the EquationSystems</span>
<a name="l00100"></a>00100   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es =
<a name="l00101"></a>00101     this-&gt;<a class="code" href="classlibMesh_1_1System.php#ac5ca6b1f3adcfac56982982e90dc905b">get_equation_systems</a>();  
<a name="l00102"></a>00102   
<a name="l00103"></a>00103   <span class="comment">// Get the user-specifiied nonlinear solver tolerances</span>
<a name="l00104"></a>00104   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxits =
<a name="l00105"></a>00105     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;nonlinear solver maximum iterations&quot;</span>);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxfuncs =
<a name="l00108"></a>00108     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;nonlinear solver maximum function evaluations&quot;</span>);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> abs_resid_tol =
<a name="l00111"></a>00111     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver absolute residual tolerance&quot;</span>);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rel_resid_tol =
<a name="l00114"></a>00114     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver relative residual tolerance&quot;</span>);
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> abs_step_tol =
<a name="l00117"></a>00117     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver absolute step tolerance&quot;</span>);
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rel_step_tol =
<a name="l00120"></a>00120     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;nonlinear solver relative step tolerance&quot;</span>);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="comment">// Get the user-specified linear solver toleranaces</span>
<a name="l00123"></a>00123   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> maxlinearits =
<a name="l00124"></a>00124     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>&gt;(<span class="stringliteral">&quot;linear solver maximum iterations&quot;</span>);
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> linear_tol =
<a name="l00127"></a>00127     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver tolerance&quot;</span>);
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> linear_min_tol =
<a name="l00130"></a>00130     es.<a class="code" href="classlibMesh_1_1EquationSystems.php#a7c02be232f564967ca0804a7824adb53">parameters</a>.<a class="code" href="classlibMesh_1_1Parameters.php#ac7fa2054ee32db2c3979d48bd2103f20">get</a>&lt;<a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>&gt;(<span class="stringliteral">&quot;linear solver minimum tolerance&quot;</span>);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// Set all the parameters on the NonlinearSolver</span>
<a name="l00133"></a>00133   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;max_nonlinear_iterations = maxits;
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;max_function_evaluations = maxfuncs;
<a name="l00135"></a>00135   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;absolute_residual_tolerance = abs_resid_tol;
<a name="l00136"></a>00136   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;relative_residual_tolerance = rel_resid_tol;
<a name="l00137"></a>00137   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;absolute_step_tolerance = abs_step_tol;
<a name="l00138"></a>00138   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;relative_step_tolerance = rel_step_tol;
<a name="l00139"></a>00139   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;max_linear_iterations = maxlinearits;
<a name="l00140"></a>00140   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;initial_linear_tolerance = linear_tol;
<a name="l00141"></a>00141   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;minimum_linear_tolerance = linear_min_tol;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00144"></a>00144     {
<a name="l00145"></a>00145       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;max_nonlinear_iterations = maxits;
<a name="l00146"></a>00146       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;absolute_residual_tolerance = abs_resid_tol;
<a name="l00147"></a>00147       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;relative_residual_tolerance = rel_resid_tol;
<a name="l00148"></a>00148       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;absolute_step_tolerance = abs_step_tol;
<a name="l00149"></a>00149       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;relative_step_tolerance = rel_step_tol;
<a name="l00150"></a>00150       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;max_linear_iterations = maxlinearits;
<a name="l00151"></a>00151       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;initial_linear_tolerance = linear_tol;
<a name="l00152"></a>00152       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;minimum_linear_tolerance = linear_min_tol;
<a name="l00153"></a>00153     }
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a4accb9254519ff611e4cb881f81aa78d">00158</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a4accb9254519ff611e4cb881f81aa78d">NonlinearImplicitSystem::solve</a> ()
<a name="l00159"></a>00159 {
<a name="l00160"></a>00160   <span class="comment">// Log how long the nonlinear solve takes.</span>
<a name="l00161"></a>00161   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00162"></a>00162   
<a name="l00163"></a>00163   this-&gt;<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a0df3fa92601482658868919cd80de095">set_solver_parameters</a>();
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00166"></a>00166     {
<a name="l00167"></a>00167       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;solve();
<a name="l00168"></a>00168 
<a name="l00169"></a>00169       <span class="comment">// Store the number of nonlinear iterations required to</span>
<a name="l00170"></a>00170       <span class="comment">// solve and the final residual.</span>
<a name="l00171"></a>00171       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a4b8e61e1e51e13b2ae4096be96999bc3">_n_nonlinear_iterations</a>   = <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;total_outer_iterations();
<a name="l00172"></a>00172       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ace2500649e2496ccbfa728d66cb4de59">_final_nonlinear_residual</a> = 0.; <span class="comment">// FIXME - support this!</span>
<a name="l00173"></a>00173     }
<a name="l00174"></a>00174   <span class="keywordflow">else</span>
<a name="l00175"></a>00175     {
<a name="l00176"></a>00176       <span class="comment">// Solve the nonlinear system.</span>
<a name="l00177"></a>00177       <span class="keyword">const</span> std::pair&lt;unsigned int, Real&gt; rval =
<a name="l00178"></a>00178         <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;solve (*<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, *<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>, *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, 
<a name="l00179"></a>00179                                  <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;relative_residual_tolerance,
<a name="l00180"></a>00180                                  <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;max_linear_iterations);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182       <span class="comment">// Store the number of nonlinear iterations required to</span>
<a name="l00183"></a>00183       <span class="comment">// solve and the final residual.</span>
<a name="l00184"></a>00184       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a4b8e61e1e51e13b2ae4096be96999bc3">_n_nonlinear_iterations</a>   = rval.first;
<a name="l00185"></a>00185       <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ace2500649e2496ccbfa728d66cb4de59">_final_nonlinear_residual</a> = rval.second;
<a name="l00186"></a>00186     }
<a name="l00187"></a>00187     
<a name="l00188"></a>00188   <span class="comment">// Stop logging the nonlinear solve</span>
<a name="l00189"></a>00189   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;System&quot;</span>);
<a name="l00190"></a>00190 
<a name="l00191"></a>00191   <span class="comment">// Update the system after the solve</span>
<a name="l00192"></a>00192   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();  
<a name="l00193"></a>00193 }
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a1c0a2e0e71faaf9e9bc02e824a7db874">00197</a> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a1c0a2e0e71faaf9e9bc02e824a7db874">NonlinearImplicitSystem::get_linear_solve_parameters</a>()<span class="keyword"> const</span>
<a name="l00198"></a>00198 <span class="keyword"></span>{
<a name="l00199"></a>00199   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00200"></a>00200     <span class="keywordflow">return</span> std::make_pair(this-&gt;<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>-&gt;max_linear_iterations,
<a name="l00201"></a>00201                         this-&gt;diff_solver-&gt;relative_residual_tolerance);
<a name="l00202"></a>00202   <span class="keywordflow">return</span> std::make_pair(this-&gt;<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;max_linear_iterations,
<a name="l00203"></a>00203                         this-&gt;nonlinear_solver-&gt;relative_residual_tolerance);
<a name="l00204"></a>00204 }
<a name="l00205"></a>00205 
<a name="l00206"></a>00206 
<a name="l00207"></a>00207 
<a name="l00208"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a48f6c945b6461ed6be973e4a43b6b439">00208</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a48f6c945b6461ed6be973e4a43b6b439">NonlinearImplicitSystem::assembly</a>(<span class="keywordtype">bool</span> get_residual, 
<a name="l00209"></a>00209                                        <span class="keywordtype">bool</span> get_jacobian)
<a name="l00210"></a>00210 {
<a name="l00211"></a>00211   <span class="comment">// Get current_local_solution in sync</span>
<a name="l00212"></a>00212   this-&gt;<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00213"></a>00213 
<a name="l00214"></a>00214   <span class="keywordflow">if</span> (get_jacobian)
<a name="l00215"></a>00215     {
<a name="l00216"></a>00216       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;jacobian != NULL)
<a name="l00217"></a>00217         <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;jacobian (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>(), *<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, *<span class="keyword">this</span>);
<a name="l00218"></a>00218       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;matvec != NULL)
<a name="l00219"></a>00219         <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;matvec (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>(), get_residual?<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>:NULL, <a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>, *<span class="keyword">this</span>);
<a name="l00220"></a>00220       <span class="keywordflow">else</span> libmesh_error();
<a name="l00221"></a>00221     }
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   <span class="keywordflow">if</span> (get_residual)
<a name="l00224"></a>00224     {
<a name="l00225"></a>00225       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;residual != NULL)
<a name="l00226"></a>00226         <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;residual (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>(), *<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, *<span class="keyword">this</span>);
<a name="l00227"></a>00227       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;matvec != NULL)
<a name="l00228"></a>00228         {
<a name="l00229"></a>00229           <span class="comment">// we might have already grabbed the residual and jacobian together</span>
<a name="l00230"></a>00230           <span class="keywordflow">if</span> (!get_jacobian)
<a name="l00231"></a>00231             <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>-&gt;matvec (*<a class="code" href="classlibMesh_1_1System.php#a1e1bec53fb8d8a5a2163dbee844e8417">current_local_solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>(), <a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>, NULL, *<span class="keyword">this</span>);
<a name="l00232"></a>00232         }
<a name="l00233"></a>00233       <span class="keywordflow">else</span>
<a name="l00234"></a>00234         libmesh_error();
<a name="l00235"></a>00235     }
<a name="l00236"></a>00236   <span class="keywordflow">else</span>
<a name="l00237"></a>00237     libmesh_assert(get_jacobian);  <span class="comment">// I can&#39;t believe you really wanted to assemble *nothing*</span>
<a name="l00238"></a>00238 }
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
