<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">nonlinear_implicit_system.h</div>  </div>
</div>
<div class="contents">
<a href="nonlinear__implicit__system_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nonlinear_implicit_system.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __nonlinear_implicit_system_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __nonlinear_implicit_system_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="implicit__system_8h.php">implicit_system.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>DiffSolver;
<a name="l00036"></a>00036 <span class="keyword">template</span>&lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NonlinearSolver;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00047"></a>00047 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// NonlinearImplicitSystem class definition</span>
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">NonlinearImplicitSystem</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a2b65a42059093a775cbc03bda6538a9f">NonlinearImplicitSystem</a> (<a class="code" href="classlibMesh_1_1EquationSystems.php">EquationSystems</a>&amp; es,
<a name="l00059"></a>00059                            <span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1System.php#af80f6b2e508821ebd9c8fcb78d443f18">name</a>,
<a name="l00060"></a>00060                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1System.php#aee5caacb487b070842733f1c84b9a2fd">number</a>);
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a6c7773a109cdc535751046c6ec42b2cf">~NonlinearImplicitSystem</a> ();
<a name="l00066"></a>00066 
<a name="l00070"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a055c93ebf293c4fe70b645940db73504">00070</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">NonlinearImplicitSystem</a> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a055c93ebf293c4fe70b645940db73504">sys_type</a>;
<a name="l00071"></a>00071 
<a name="l00075"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae086f8e710a7ddafd46a9d96474d7ae9">00075</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae086f8e710a7ddafd46a9d96474d7ae9">Parent</a>;
<a name="l00076"></a>00076   
<a name="l00080"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ab925958fe5eb90f242010334ed1167c3">00080</a>   <a class="code" href="classlibMesh_1_1ExplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ab925958fe5eb90f242010334ed1167c3">system</a> () { <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00081"></a>00081   
<a name="l00086"></a>00086   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a8bcf68edde0094081171c633ef959bd1">clear</a> ();
<a name="l00087"></a>00087 
<a name="l00092"></a>00092   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a357e2def2e45779aa185d69032fa8a79">reinit</a> ();
<a name="l00093"></a>00093    
<a name="l00097"></a>00097   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a4accb9254519ff611e4cb881f81aa78d">solve</a> ();
<a name="l00098"></a>00098  
<a name="l00104"></a>00104   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00105"></a>00105     <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a1c0a2e0e71faaf9e9bc02e824a7db874">get_linear_solve_parameters</a>() <span class="keyword">const</span>;
<a name="l00106"></a>00106 
<a name="l00111"></a>00111   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a48f6c945b6461ed6be973e4a43b6b439">assembly</a>(<span class="keywordtype">bool</span> get_residual, <span class="keywordtype">bool</span> get_jacobian);
<a name="l00112"></a>00112 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ab384c9a78731916c5b7aeb7cc28119bd">00117</a>   <span class="keyword">virtual</span> std::string <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ab384c9a78731916c5b7aeb7cc28119bd">system_type</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="stringliteral">&quot;NonlinearImplicit&quot;</span>; }
<a name="l00118"></a>00118 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">00125</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NonlinearSolver&lt;Number&gt;</a> &gt; <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ae4bc5fe6d34c30c15e3813c86a7753bf">nonlinear_solver</a>;
<a name="l00126"></a>00126 
<a name="l00131"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">00131</a>   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;DiffSolver&gt;</a> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a944c3aac30f9ed725c0c008bcc033566">diff_solver</a>;
<a name="l00132"></a>00132   
<a name="l00137"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a0e4bc2770f4a0a572639fd479a0d0884">00137</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a0e4bc2770f4a0a572639fd479a0d0884">n_nonlinear_iterations</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a4b8e61e1e51e13b2ae4096be96999bc3">_n_nonlinear_iterations</a>; }
<a name="l00138"></a>00138 
<a name="l00142"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a1b6aba82c3fd2865116ac3f239ff6905">00142</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a1b6aba82c3fd2865116ac3f239ff6905">final_nonlinear_residual</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ace2500649e2496ccbfa728d66cb4de59">_final_nonlinear_residual</a>; }
<a name="l00143"></a>00143   
<a name="l00144"></a>00144 <span class="keyword">protected</span>:
<a name="l00145"></a>00145 
<a name="l00149"></a>00149   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a0df3fa92601482658868919cd80de095">set_solver_parameters</a>();
<a name="l00150"></a>00150   
<a name="l00155"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a4b8e61e1e51e13b2ae4096be96999bc3">00155</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#a4b8e61e1e51e13b2ae4096be96999bc3">_n_nonlinear_iterations</a>;
<a name="l00156"></a>00156 
<a name="l00160"></a><a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ace2500649e2496ccbfa728d66cb4de59">00160</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php#ace2500649e2496ccbfa728d66cb4de59">_final_nonlinear_residual</a>;
<a name="l00161"></a>00161 };
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 } <span class="comment">// namespace libMesh</span>
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00168"></a>00168 <span class="comment">// NonlinearImplicitSystem inline methods</span>
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
