<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">nonlinear_solver.h</div>  </div>
</div>
<div class="contents">
<a href="nonlinear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: nonlinear_solver.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __nonlinear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __nonlinear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="enum__solver__package_8h.php">enum_solver_package.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// forward declarations</span>
<a name="l00038"></a>00038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>AutoPtr;
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>Preconditioner;
<a name="l00042"></a>00042 <span class="keyword">class </span>NonlinearImplicitSystem;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php">00057</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NonlinearSolver.php">NonlinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;NonlinearSolver&lt;T&gt; &gt;
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059 <span class="keyword">public</span>:
<a name="l00063"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a2e41b742221e0c4077ec92cdea1c973c">00063</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">NonlinearImplicitSystem</a> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a2e41b742221e0c4077ec92cdea1c973c">sys_type</a>;
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1NonlinearSolver.php#ad5ef5ea6d94dcca5231841607c623d8a">NonlinearSolver</a> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a>&amp; s);
<a name="l00069"></a>00069     
<a name="l00073"></a>00073   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a35674d19b4111783e6d4afe22313f36d">~NonlinearSolver</a> ();
<a name="l00074"></a>00074   
<a name="l00079"></a>00079   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NonlinearSolver&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1NonlinearSolver.php#ada6d168b920d56e2bbc4a1411e439d51">build</a>(<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a>&amp; s, <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package =
<a name="l00080"></a>00080                                             <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00081"></a>00081   
<a name="l00086"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#ac95ad819dc85c652cc0bb3ba2c6c0550">00086</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#ac95ad819dc85c652cc0bb3ba2c6c0550">initialized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a24dd4c132272aae21cb98a88b97bdcdd">_is_initialized</a>; }
<a name="l00087"></a>00087   
<a name="l00091"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a72e8ee0aa9520a523d43e45ac796ba15">00091</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a72e8ee0aa9520a523d43e45ac796ba15">clear</a> () {}
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#af86c78233f9f47dc85fb57b4a8587eb8">init</a> () = 0;
<a name="l00097"></a>00097 
<a name="l00101"></a>00101   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt; <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a7cb09fccf88e0ab7f9cf78fcb4957045">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;,  <span class="comment">// System Jacobian Matrix</span>
<a name="l00102"></a>00102                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Solution vector</span>
<a name="l00103"></a>00103                                                <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;, <span class="comment">// Residual vector</span>
<a name="l00104"></a>00104                                                <span class="keyword">const</span> <span class="keywordtype">double</span>,      <span class="comment">// Stopping tolerance</span>
<a name="l00105"></a>00105                                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) = 0; <span class="comment">// N. Iterations</span>
<a name="l00106"></a>00106 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a3dec939418a10f483ff91f2928c051d4">00111</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a3dec939418a10f483ff91f2928c051d4">print_converged_reason</a>() { libmesh_not_implemented(); }
<a name="l00112"></a>00112 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a9a7a991c403fba622accbf7ffc955537">00117</a>   void (* <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a9a7a991c403fba622accbf7ffc955537">residual</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; X,
<a name="l00118"></a>00118                      <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; R,
<a name="l00119"></a>00119                      <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a>&amp; S);
<a name="l00120"></a>00120 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a3b004cfd9859f6fdb7e6d3bf79f65683">00125</a>   void (* <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a3b004cfd9859f6fdb7e6d3bf79f65683">jacobian</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; X,
<a name="l00126"></a>00126                      <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>&amp; J,
<a name="l00127"></a>00127                      <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a>&amp; S);
<a name="l00128"></a>00128 
<a name="l00135"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a5aa221a09a2c2ca3ec78285c2b043498">00135</a>   void (* <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a5aa221a09a2c2ca3ec78285c2b043498">matvec</a>) (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>&amp; X,
<a name="l00136"></a>00136                    <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* R,
<a name="l00137"></a>00137                    <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a>*  J,
<a name="l00138"></a>00138                    <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a>&amp; S);
<a name="l00139"></a>00139 
<a name="l00143"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#afd4b2819b5c5cc4384a879df8b34ceb3">00143</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1NonlinearSolver.php#afd4b2819b5c5cc4384a879df8b34ceb3">system</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#ac7f406043820471f6959d8c6504b39b6">_system</a>; }
<a name="l00144"></a>00144 
<a name="l00148"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#abbd40055ee8c0647df7d8507f6248529">00148</a>   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a> &amp; <a class="code" href="classlibMesh_1_1NonlinearSolver.php#abbd40055ee8c0647df7d8507f6248529">system</a> () { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#ac7f406043820471f6959d8c6504b39b6">_system</a>; }
<a name="l00149"></a>00149 
<a name="l00153"></a>00153   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a262c843e5e7a2accd5bb4977efb90e0f">attach_preconditioner</a>(<a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner&lt;T&gt;</a> * preconditioner);
<a name="l00154"></a>00154 
<a name="l00158"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a4431922dde52240c67d0e2b43459c601">00158</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a4431922dde52240c67d0e2b43459c601">max_nonlinear_iterations</a>;
<a name="l00159"></a>00159 
<a name="l00163"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a8b135f6dc15fd3bb57fdcd55ff17e290">00163</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a8b135f6dc15fd3bb57fdcd55ff17e290">max_function_evaluations</a>;
<a name="l00164"></a>00164   
<a name="l00175"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a49f8b60b74aa30e44d0c1b9fcecfac3e">00175</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a49f8b60b74aa30e44d0c1b9fcecfac3e">absolute_residual_tolerance</a>;
<a name="l00176"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a67d67fa897be5b13ce8625cca56959ed">00176</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a67d67fa897be5b13ce8625cca56959ed">relative_residual_tolerance</a>;
<a name="l00177"></a>00177 
<a name="l00189"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a840439a7e907b1e0d83c345f82b83e45">00189</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a840439a7e907b1e0d83c345f82b83e45">absolute_step_tolerance</a>;
<a name="l00190"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a67bdcbd923a70e69260ecd6083513a55">00190</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a67bdcbd923a70e69260ecd6083513a55">relative_step_tolerance</a>;
<a name="l00191"></a>00191 
<a name="l00196"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a6f53f05d586e75354c8d6eae61d14136">00196</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a6f53f05d586e75354c8d6eae61d14136">max_linear_iterations</a>;
<a name="l00197"></a>00197 
<a name="l00202"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a483f310290eb3339a4f5556d0d07aec6">00202</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a483f310290eb3339a4f5556d0d07aec6">initial_linear_tolerance</a>;
<a name="l00203"></a>00203 
<a name="l00207"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a2530dc3e52a1435bf85efb0df60b7072">00207</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a2530dc3e52a1435bf85efb0df60b7072">minimum_linear_tolerance</a>;
<a name="l00208"></a>00208 
<a name="l00213"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#ae9f39aeafd4c5213f90b9bece1c626d2">00213</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#ae9f39aeafd4c5213f90b9bece1c626d2">converged</a>;
<a name="l00214"></a>00214   
<a name="l00215"></a>00215 <span class="keyword">protected</span>:
<a name="l00219"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#ac7f406043820471f6959d8c6504b39b6">00219</a>   <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a>&amp; <a class="code" href="classlibMesh_1_1NonlinearSolver.php#ac7f406043820471f6959d8c6504b39b6">_system</a>;
<a name="l00220"></a>00220   
<a name="l00224"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a24dd4c132272aae21cb98a88b97bdcdd">00224</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a24dd4c132272aae21cb98a88b97bdcdd">_is_initialized</a>;
<a name="l00225"></a>00225 
<a name="l00229"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#ad4a2968ec475be52a4264928ff0d1af4">00229</a>   <a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner&lt;T&gt;</a> * <a class="code" href="classlibMesh_1_1NonlinearSolver.php#ad4a2968ec475be52a4264928ff0d1af4">_preconditioner</a>;
<a name="l00230"></a>00230 };
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00236"></a>00236 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00237"></a>00237 <span class="keyword">inline</span>
<a name="l00238"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#ad5ef5ea6d94dcca5231841607c623d8a">00238</a> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#ad5ef5ea6d94dcca5231841607c623d8a">NonlinearSolver&lt;T&gt;::NonlinearSolver</a> (<a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">sys_type</a>&amp; s) :
<a name="l00239"></a>00239   residual        (NULL),
<a name="l00240"></a>00240   jacobian        (NULL),
<a name="l00241"></a>00241   matvec          (NULL),
<a name="l00242"></a>00242   max_nonlinear_iterations(0),
<a name="l00243"></a>00243   max_function_evaluations(0),
<a name="l00244"></a>00244   absolute_residual_tolerance(0),
<a name="l00245"></a>00245   relative_residual_tolerance(0),
<a name="l00246"></a>00246   absolute_step_tolerance(0),
<a name="l00247"></a>00247   relative_step_tolerance(0),
<a name="l00248"></a>00248   max_linear_iterations(0),
<a name="l00249"></a>00249   initial_linear_tolerance(0),
<a name="l00250"></a>00250   minimum_linear_tolerance(0),
<a name="l00251"></a>00251   _system(s),
<a name="l00252"></a>00252   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> (false),
<a name="l00253"></a>00253   _preconditioner (NULL)
<a name="l00254"></a>00254 {
<a name="l00255"></a>00255 }
<a name="l00256"></a>00256 
<a name="l00257"></a>00257 
<a name="l00258"></a>00258 
<a name="l00259"></a>00259 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00260"></a>00260 <span class="keyword">inline</span>
<a name="l00261"></a><a class="code" href="classlibMesh_1_1NonlinearSolver.php#a35674d19b4111783e6d4afe22313f36d">00261</a> <a class="code" href="classlibMesh_1_1NonlinearSolver.php#a35674d19b4111783e6d4afe22313f36d">NonlinearSolver&lt;T&gt;::~NonlinearSolver</a> ()
<a name="l00262"></a>00262 {
<a name="l00263"></a>00263   this-&gt;clear ();
<a name="l00264"></a>00264 }
<a name="l00265"></a>00265 
<a name="l00266"></a>00266 
<a name="l00267"></a>00267 } <span class="comment">// namespace libMesh</span>
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 <span class="preprocessor">#endif // #ifdef __solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
