<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">number_lookups.C</div>  </div>
</div>
<div class="contents">
<a href="number__lookups_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: number_lookups.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006 
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011 
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016 
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="number__lookups_8h.php">number_lookups.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// These numbers need to go up to at least maximum_totalorder - 2</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// triangular_number_*: indices for triangle interiors</span>
<a name="l00031"></a><a class="code" href="namespacelibMesh.php#a680d9107cd6589de21526ac7482d87e6">00031</a> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespacelibMesh.php#a680d9107cd6589de21526ac7482d87e6">triangular_number_row</a>[] = {
<a name="l00032"></a>00032  0,
<a name="l00033"></a>00033  1, 1,
<a name="l00034"></a>00034  2, 2, 2,
<a name="l00035"></a>00035  3, 3, 3, 3,
<a name="l00036"></a>00036  4, 4, 4, 4, 4,
<a name="l00037"></a>00037  5, 5, 5, 5, 5, 5,
<a name="l00038"></a>00038  6, 6, 6, 6, 6, 6, 6,
<a name="l00039"></a>00039  7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00040"></a>00040  8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00041"></a>00041  9, 9, 9, 9, 9, 9, 9, 9, 9, 9
<a name="l00042"></a>00042 };
<a name="l00043"></a>00043 
<a name="l00044"></a><a class="code" href="namespacelibMesh.php#abc3a8817fc91ad743eb3df854d59cc5e">00044</a> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespacelibMesh.php#abc3a8817fc91ad743eb3df854d59cc5e">triangular_number_column</a>[] = {
<a name="l00045"></a>00045  0,
<a name="l00046"></a>00046  0, 1,
<a name="l00047"></a>00047  0, 1, 2,
<a name="l00048"></a>00048  0, 1, 2, 3,
<a name="l00049"></a>00049  0, 1, 2, 3, 4,
<a name="l00050"></a>00050  0, 1, 2, 3, 4, 5,
<a name="l00051"></a>00051  0, 1, 2, 3, 4, 5, 6,
<a name="l00052"></a>00052  0, 1, 2, 3, 4, 5, 6, 7,
<a name="l00053"></a>00053  0, 1, 2, 3, 4, 5, 6, 7, 8,
<a name="l00054"></a>00054  0, 1, 2, 3, 4, 5, 6, 7, 8, 9
<a name="l00055"></a>00055 };
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058 <span class="comment">// square_number_*: indices for square interiors, cube faces</span>
<a name="l00059"></a><a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">00059</a> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespacelibMesh.php#aa440e1e8b909592056f7f2c923aa43f1">square_number_column</a>[] = {
<a name="l00060"></a>00060 0,
<a name="l00061"></a>00061 0, 1, 1,
<a name="l00062"></a>00062 0, 1, 2, 2, 2,
<a name="l00063"></a>00063 0, 1, 2, 3, 3, 3, 3,
<a name="l00064"></a>00064 0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00065"></a>00065 0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00066"></a>00066 0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00067"></a>00067 0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00068"></a>00068 0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00069"></a>00069 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9
<a name="l00070"></a>00070 };
<a name="l00071"></a>00071 
<a name="l00072"></a><a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">00072</a> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespacelibMesh.php#a965e7ab9d110cb4710b0813363a43566">square_number_row</a>[] = {
<a name="l00073"></a>00073  0,
<a name="l00074"></a>00074  1, 1, 0,
<a name="l00075"></a>00075  2, 2, 2, 1, 0,
<a name="l00076"></a>00076  3, 3, 3, 3, 2, 1, 0,
<a name="l00077"></a>00077  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00078"></a>00078  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00079"></a>00079  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00080"></a>00080  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00081"></a>00081  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00082"></a>00082  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00083"></a>00083 };
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="comment">// square_number_*: indices for cube interiors</span>
<a name="l00087"></a><a class="code" href="namespacelibMesh.php#a89b107ed0e100e4616f74b44b57d791d">00087</a> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespacelibMesh.php#a89b107ed0e100e4616f74b44b57d791d">cube_number_column</a>[] = {
<a name="l00088"></a>00088  0,
<a name="l00089"></a>00089 
<a name="l00090"></a>00090  0, 1, 1,
<a name="l00091"></a>00091  0, 1, 1,
<a name="l00092"></a>00092  0,
<a name="l00093"></a>00093 
<a name="l00094"></a>00094  0, 1, 2, 2, 2,
<a name="l00095"></a>00095  0, 1, 2, 2, 2,
<a name="l00096"></a>00096  0, 1, 2, 2, 2,
<a name="l00097"></a>00097  0, 1, 1,
<a name="l00098"></a>00098  0,
<a name="l00099"></a>00099 
<a name="l00100"></a>00100  0, 1, 2, 3, 3, 3, 3,
<a name="l00101"></a>00101  0, 1, 2, 3, 3, 3, 3,
<a name="l00102"></a>00102  0, 1, 2, 3, 3, 3, 3,
<a name="l00103"></a>00103  0, 1, 2, 3, 3, 3, 3,
<a name="l00104"></a>00104  0, 1, 2, 2, 2,
<a name="l00105"></a>00105  0, 1, 1,
<a name="l00106"></a>00106  0,
<a name="l00107"></a>00107 
<a name="l00108"></a>00108  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00109"></a>00109  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00110"></a>00110  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00111"></a>00111  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00112"></a>00112  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00113"></a>00113  0, 1, 2, 3, 3, 3, 3,
<a name="l00114"></a>00114  0, 1, 2, 2, 2,
<a name="l00115"></a>00115  0, 1, 1,
<a name="l00116"></a>00116  0,
<a name="l00117"></a>00117 
<a name="l00118"></a>00118  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00119"></a>00119  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00120"></a>00120  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00121"></a>00121  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00122"></a>00122  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00123"></a>00123  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00124"></a>00124  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00125"></a>00125  0, 1, 2, 3, 3, 3, 3,
<a name="l00126"></a>00126  0, 1, 2, 2, 2,
<a name="l00127"></a>00127  0, 1, 1,
<a name="l00128"></a>00128  0,
<a name="l00129"></a>00129 
<a name="l00130"></a>00130  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00131"></a>00131  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00132"></a>00132  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00133"></a>00133  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00134"></a>00134  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00135"></a>00135  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00136"></a>00136  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00137"></a>00137  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00138"></a>00138  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00139"></a>00139  0, 1, 2, 3, 3, 3, 3,
<a name="l00140"></a>00140  0, 1, 2, 2, 2,
<a name="l00141"></a>00141  0, 1, 1,
<a name="l00142"></a>00142  0,
<a name="l00143"></a>00143 
<a name="l00144"></a>00144  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00145"></a>00145  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00146"></a>00146  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00147"></a>00147  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00148"></a>00148  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00149"></a>00149  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00150"></a>00150  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00151"></a>00151  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00152"></a>00152  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00153"></a>00153  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00154"></a>00154  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00155"></a>00155  0, 1, 2, 3, 3, 3, 3,
<a name="l00156"></a>00156  0, 1, 2, 2, 2,
<a name="l00157"></a>00157  0, 1, 1,
<a name="l00158"></a>00158  0,
<a name="l00159"></a>00159 
<a name="l00160"></a>00160  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00161"></a>00161  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00162"></a>00162  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00163"></a>00163  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00164"></a>00164  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00165"></a>00165  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00166"></a>00166  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00167"></a>00167  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00168"></a>00168  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00169"></a>00169  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00170"></a>00170  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00171"></a>00171  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00172"></a>00172  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00173"></a>00173  0, 1, 2, 3, 3, 3, 3,
<a name="l00174"></a>00174  0, 1, 2, 2, 2,
<a name="l00175"></a>00175  0, 1, 1,
<a name="l00176"></a>00176  0,
<a name="l00177"></a>00177 
<a name="l00178"></a>00178  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00179"></a>00179  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00180"></a>00180  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00181"></a>00181  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00182"></a>00182  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00183"></a>00183  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00184"></a>00184  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00185"></a>00185  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00186"></a>00186  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00187"></a>00187  0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00188"></a>00188  0, 1, 2, 3, 4, 5, 6, 7, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00189"></a>00189  0, 1, 2, 3, 4, 5, 6, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00190"></a>00190  0, 1, 2, 3, 4, 5, 6, 6, 6, 6, 6, 6, 6,
<a name="l00191"></a>00191  0, 1, 2, 3, 4, 5, 5, 5, 5, 5, 5,
<a name="l00192"></a>00192  0, 1, 2, 3, 4, 4, 4, 4, 4,
<a name="l00193"></a>00193  0, 1, 2, 3, 3, 3, 3,
<a name="l00194"></a>00194  0, 1, 2, 2, 2,
<a name="l00195"></a>00195  0, 1, 1,
<a name="l00196"></a>00196  0
<a name="l00197"></a>00197 };
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="namespacelibMesh.php#a6a98ddb5341c1a8eb7c5517d89db62d8">00199</a> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespacelibMesh.php#a6a98ddb5341c1a8eb7c5517d89db62d8">cube_number_row</a>[] = {
<a name="l00200"></a>00200  0,
<a name="l00201"></a>00201 
<a name="l00202"></a>00202  1, 1, 0,
<a name="l00203"></a>00203  1, 1, 0,
<a name="l00204"></a>00204  0,
<a name="l00205"></a>00205 
<a name="l00206"></a>00206  2, 2, 2, 1, 0,
<a name="l00207"></a>00207  2, 2, 2, 1, 0,
<a name="l00208"></a>00208  2, 2, 2, 1, 0,
<a name="l00209"></a>00209  1, 1, 0,
<a name="l00210"></a>00210  0,
<a name="l00211"></a>00211 
<a name="l00212"></a>00212  3, 3, 3, 3, 2, 1, 0,
<a name="l00213"></a>00213  3, 3, 3, 3, 2, 1, 0,
<a name="l00214"></a>00214  3, 3, 3, 3, 2, 1, 0,
<a name="l00215"></a>00215  3, 3, 3, 3, 2, 1, 0,
<a name="l00216"></a>00216  2, 2, 2, 1, 0,
<a name="l00217"></a>00217  1, 1, 0,
<a name="l00218"></a>00218  0,
<a name="l00219"></a>00219 
<a name="l00220"></a>00220  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00221"></a>00221  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00222"></a>00222  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00223"></a>00223  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00224"></a>00224  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00225"></a>00225  3, 3, 3, 3, 2, 1, 0,
<a name="l00226"></a>00226  2, 2, 2, 1, 0,
<a name="l00227"></a>00227  1, 1, 0,
<a name="l00228"></a>00228  0,
<a name="l00229"></a>00229 
<a name="l00230"></a>00230  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00231"></a>00231  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00232"></a>00232  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00233"></a>00233  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00234"></a>00234  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00235"></a>00235  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00236"></a>00236  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00237"></a>00237  3, 3, 3, 3, 2, 1, 0,
<a name="l00238"></a>00238  2, 2, 2, 1, 0,
<a name="l00239"></a>00239  1, 1, 0,
<a name="l00240"></a>00240  0,
<a name="l00241"></a>00241 
<a name="l00242"></a>00242  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00243"></a>00243  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00244"></a>00244  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00245"></a>00245  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00246"></a>00246  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00247"></a>00247  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00248"></a>00248  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00249"></a>00249  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00250"></a>00250  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00251"></a>00251  3, 3, 3, 3, 2, 1, 0,
<a name="l00252"></a>00252  2, 2, 2, 1, 0,
<a name="l00253"></a>00253  1, 1, 0,
<a name="l00254"></a>00254  0,
<a name="l00255"></a>00255 
<a name="l00256"></a>00256  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00257"></a>00257  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00258"></a>00258  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00259"></a>00259  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00260"></a>00260  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00261"></a>00261  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00262"></a>00262  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00263"></a>00263  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00264"></a>00264  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00265"></a>00265  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00266"></a>00266  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00267"></a>00267  3, 3, 3, 3, 2, 1, 0,
<a name="l00268"></a>00268  2, 2, 2, 1, 0,
<a name="l00269"></a>00269  1, 1, 0,
<a name="l00270"></a>00270  0,
<a name="l00271"></a>00271 
<a name="l00272"></a>00272  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00273"></a>00273  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00274"></a>00274  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00275"></a>00275  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00276"></a>00276  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00277"></a>00277  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00278"></a>00278  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00279"></a>00279  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00280"></a>00280  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00281"></a>00281  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00282"></a>00282  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00283"></a>00283  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00284"></a>00284  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00285"></a>00285  3, 3, 3, 3, 2, 1, 0,
<a name="l00286"></a>00286  2, 2, 2, 1, 0,
<a name="l00287"></a>00287  1, 1, 0,
<a name="l00288"></a>00288  0,
<a name="l00289"></a>00289 
<a name="l00290"></a>00290  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00291"></a>00291  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00292"></a>00292  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00293"></a>00293  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00294"></a>00294  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00295"></a>00295  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00296"></a>00296  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00297"></a>00297  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00298"></a>00298  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00299"></a>00299  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00300"></a>00300  8, 8, 8, 8, 8, 8, 8, 8, 8, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00301"></a>00301  7, 7, 7, 7, 7, 7, 7, 7, 6, 5, 4, 3, 2, 1, 0,
<a name="l00302"></a>00302  6, 6, 6, 6, 6, 6, 6, 5, 4, 3, 2, 1, 0,
<a name="l00303"></a>00303  5, 5, 5, 5, 5, 5, 4, 3, 2, 1, 0,
<a name="l00304"></a>00304  4, 4, 4, 4, 4, 3, 2, 1, 0,
<a name="l00305"></a>00305  3, 3, 3, 3, 2, 1, 0,
<a name="l00306"></a>00306  2, 2, 2, 1, 0,
<a name="l00307"></a>00307  1, 1, 0,
<a name="l00308"></a>00308  0
<a name="l00309"></a>00309 };
<a name="l00310"></a>00310 
<a name="l00311"></a><a class="code" href="namespacelibMesh.php#a6c2acecfb9abd9fd0cff680913ba1447">00311</a> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> <a class="code" href="namespacelibMesh.php#a6c2acecfb9abd9fd0cff680913ba1447">cube_number_page</a>[] = {
<a name="l00312"></a>00312  0,
<a name="l00313"></a>00313 
<a name="l00314"></a>00314  0, 0, 0,
<a name="l00315"></a>00315  1, 1, 1,
<a name="l00316"></a>00316  1,
<a name="l00317"></a>00317 
<a name="l00318"></a>00318  0, 0, 0, 0, 0,
<a name="l00319"></a>00319  1, 1, 1, 1, 1,
<a name="l00320"></a>00320  2, 2, 2, 2, 2,
<a name="l00321"></a>00321  2, 2, 2,
<a name="l00322"></a>00322  2,
<a name="l00323"></a>00323 
<a name="l00324"></a>00324  0, 0, 0, 0, 0, 0, 0,
<a name="l00325"></a>00325  1, 1, 1, 1, 1, 1, 1,
<a name="l00326"></a>00326  2, 2, 2, 2, 2, 2, 2,
<a name="l00327"></a>00327  3, 3, 3, 3, 3, 3, 3,
<a name="l00328"></a>00328  3, 3, 3, 3, 3,
<a name="l00329"></a>00329  3, 3, 3,
<a name="l00330"></a>00330  3,
<a name="l00331"></a>00331 
<a name="l00332"></a>00332  0, 0, 0, 0, 0, 0, 0, 0, 0,
<a name="l00333"></a>00333  1, 1, 1, 1, 1, 1, 1, 1, 1,
<a name="l00334"></a>00334  2, 2, 2, 2, 2, 2, 2, 2, 2,
<a name="l00335"></a>00335  3, 3, 3, 3, 3, 3, 3, 3, 3,
<a name="l00336"></a>00336  4, 4, 4, 4, 4, 4, 4, 4, 4,
<a name="l00337"></a>00337  4, 4, 4, 4, 4, 4, 4,
<a name="l00338"></a>00338  4, 4, 4, 4, 4,
<a name="l00339"></a>00339  4, 4, 4,
<a name="l00340"></a>00340  4,
<a name="l00341"></a>00341 
<a name="l00342"></a>00342  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
<a name="l00343"></a>00343  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
<a name="l00344"></a>00344  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
<a name="l00345"></a>00345  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
<a name="l00346"></a>00346  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
<a name="l00347"></a>00347  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
<a name="l00348"></a>00348  5, 5, 5, 5, 5, 5, 5, 5, 5,
<a name="l00349"></a>00349  5, 5, 5, 5, 5, 5, 5,
<a name="l00350"></a>00350  5, 5, 5, 5, 5,
<a name="l00351"></a>00351  5, 5, 5,
<a name="l00352"></a>00352  5,
<a name="l00353"></a>00353 
<a name="l00354"></a>00354  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
<a name="l00355"></a>00355  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
<a name="l00356"></a>00356  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
<a name="l00357"></a>00357  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
<a name="l00358"></a>00358  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
<a name="l00359"></a>00359  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
<a name="l00360"></a>00360  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
<a name="l00361"></a>00361  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
<a name="l00362"></a>00362  6, 6, 6, 6, 6, 6, 6, 6, 6,
<a name="l00363"></a>00363  6, 6, 6, 6, 6, 6, 6,
<a name="l00364"></a>00364  6, 6, 6, 6, 6,
<a name="l00365"></a>00365  6, 6, 6,
<a name="l00366"></a>00366  6,
<a name="l00367"></a>00367 
<a name="l00368"></a>00368  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
<a name="l00369"></a>00369  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
<a name="l00370"></a>00370  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
<a name="l00371"></a>00371  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
<a name="l00372"></a>00372  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
<a name="l00373"></a>00373  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
<a name="l00374"></a>00374  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
<a name="l00375"></a>00375  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00376"></a>00376  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00377"></a>00377  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00378"></a>00378  7, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00379"></a>00379  7, 7, 7, 7, 7, 7, 7,
<a name="l00380"></a>00380  7, 7, 7, 7, 7,
<a name="l00381"></a>00381  7, 7, 7,
<a name="l00382"></a>00382  7,
<a name="l00383"></a>00383 
<a name="l00384"></a>00384  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
<a name="l00385"></a>00385  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
<a name="l00386"></a>00386  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
<a name="l00387"></a>00387  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
<a name="l00388"></a>00388  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
<a name="l00389"></a>00389  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
<a name="l00390"></a>00390  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
<a name="l00391"></a>00391  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00392"></a>00392  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00393"></a>00393  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00394"></a>00394  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00395"></a>00395  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00396"></a>00396  8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00397"></a>00397  8, 8, 8, 8, 8, 8, 8,
<a name="l00398"></a>00398  8, 8, 8, 8, 8,
<a name="l00399"></a>00399  8, 8, 8,
<a name="l00400"></a>00400  8,
<a name="l00401"></a>00401 
<a name="l00402"></a>00402  0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,
<a name="l00403"></a>00403  1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1,
<a name="l00404"></a>00404  2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2, 2,
<a name="l00405"></a>00405  3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3, 3,
<a name="l00406"></a>00406  4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4, 4,
<a name="l00407"></a>00407  5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5, 5,
<a name="l00408"></a>00408  6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6, 6,
<a name="l00409"></a>00409  7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7, 7,
<a name="l00410"></a>00410  8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8, 8,
<a name="l00411"></a>00411  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00412"></a>00412  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00413"></a>00413  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00414"></a>00414  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00415"></a>00415  9, 9, 9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00416"></a>00416  9, 9, 9, 9, 9, 9, 9, 9, 9,
<a name="l00417"></a>00417  9, 9, 9, 9, 9, 9, 9,
<a name="l00418"></a>00418  9, 9, 9, 9, 9,
<a name="l00419"></a>00419  9, 9, 9,
<a name="l00420"></a>00420  9
<a name="l00421"></a>00421 };
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
