<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">numeric_vector.C</div>  </div>
</div>
<div class="contents">
<a href="numeric__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: numeric_vector.C 4100 2010-11-15 17:46:53Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span> <span class="comment">// for std::abs</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="distributed__vector_8h.php">distributed_vector.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="laspack__vector_8h.php">laspack_vector.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="trilinos__epetra__vector_8h.php">trilinos_epetra_vector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="shell__matrix_8h.php">shell_matrix.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// NumericVector methods</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Full specialization for Real datatypes</span>
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00043"></a>00043 AutoPtr&lt;NumericVector&lt;T&gt; &gt;
<a name="l00044"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">00044</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">NumericVector&lt;T&gt;::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package)
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="comment">// Build the appropriate vector</span>
<a name="l00047"></a>00047   <span class="keywordflow">switch</span> (solver_package)
<a name="l00048"></a>00048     {
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="preprocessor">#ifdef LIBMESH_HAVE_LASPACK</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMesh.php#aeb2a777af969e03421c99c4afe9d68a0">LASPACK_SOLVERS</a>:
<a name="l00053"></a>00053       {
<a name="l00054"></a>00054         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1LaspackVector.php">LaspackVector&lt;T&gt;</a>);
<a name="l00055"></a>00055         <span class="keywordflow">return</span> ap;
<a name="l00056"></a>00056       }
<a name="l00057"></a>00057 <span class="preprocessor">#endif</span>
<a name="l00058"></a>00058 <span class="preprocessor"></span>
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00061"></a>00061 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8a4bb6e669bd80e3d232092e60df464572">PETSC_SOLVERS</a>:
<a name="l00062"></a>00062       {
<a name="l00063"></a>00063         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>);
<a name="l00064"></a>00064         <span class="keywordflow">return</span> ap;
<a name="l00065"></a>00065       }
<a name="l00066"></a>00066 <span class="preprocessor">#endif</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="preprocessor">#ifdef LIBMESH_HAVE_TRILINOS</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>    <span class="keywordflow">case</span> <a class="code" href="namespacelibMesh.php#aa27e267f495ee0599f7cd8981c0cf7ad">TRILINOS_SOLVERS</a>:
<a name="l00071"></a>00071       {
<a name="l00072"></a>00072         <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1EpetraVector.php">EpetraVector&lt;T&gt;</a>);
<a name="l00073"></a>00073         <span class="keywordflow">return</span> ap;
<a name="l00074"></a>00074       }
<a name="l00075"></a>00075 <span class="preprocessor">#endif</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span>
<a name="l00077"></a>00077 
<a name="l00078"></a>00078     <span class="keywordflow">default</span>:
<a name="l00079"></a>00079       <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1DistributedVector.php">DistributedVector&lt;T&gt;</a>);
<a name="l00080"></a>00080       <span class="keywordflow">return</span> ap;
<a name="l00081"></a>00081     }
<a name="l00082"></a>00082     
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; ap(NULL);
<a name="l00084"></a>00084   <span class="keywordflow">return</span> ap;    
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00089"></a><a class="code" href="classlibMesh_1_1NumericVector.php#ae3efc92e2f7a711df841c7eb8807b0f2">00089</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#ae3efc92e2f7a711df841c7eb8807b0f2">NumericVector&lt;T&gt;::compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other_vector,
<a name="l00090"></a>00090                                <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold)<span class="keyword"> const</span>
<a name="l00091"></a>00091 <span class="keyword"></span>{
<a name="l00092"></a>00092   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00093"></a>00093   libmesh_assert (other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#a02791337b6c509228fdf3e72320b56d3">initialized</a>());
<a name="l00094"></a>00094   libmesh_assert (this-&gt;first_local_index() == other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>());
<a name="l00095"></a>00095   libmesh_assert (this-&gt;last_local_index()  == other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>());
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="keywordtype">int</span> first_different_i = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;int&gt;::max</a>();
<a name="l00098"></a>00098   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = first_local_index();
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="keywordflow">do</span>
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       <span class="keywordflow">if</span> ( std::abs( (*<span class="keyword">this</span>)(i) - other_vector(i) ) &gt; threshold )
<a name="l00103"></a>00103         first_different_i = i;
<a name="l00104"></a>00104       <span class="keywordflow">else</span>
<a name="l00105"></a>00105         i++;
<a name="l00106"></a>00106     }
<a name="l00107"></a>00107   <span class="keywordflow">while</span> (first_different_i==<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;int&gt;::max</a>()
<a name="l00108"></a>00108          &amp;&amp; i&lt;last_local_index());
<a name="l00109"></a>00109 
<a name="l00110"></a>00110   <span class="comment">// Find the correct first differing index in parallel</span>
<a name="l00111"></a>00111   <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(first_different_i);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="keywordflow">if</span> (first_different_i == <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;int&gt;::max</a>())
<a name="l00114"></a>00114     <span class="keywordflow">return</span> -1;
<a name="l00115"></a>00115 
<a name="l00116"></a>00116   <span class="keywordflow">return</span> first_different_i;
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00121"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a10c766ef62ccd97a2b19917963a34425">00121</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a10c766ef62ccd97a2b19917963a34425">NumericVector&lt;T&gt;::local_relative_compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other_vector,
<a name="l00122"></a>00122                                               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold)<span class="keyword"> const</span>
<a name="l00123"></a>00123 <span class="keyword"></span>{
<a name="l00124"></a>00124   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00125"></a>00125   libmesh_assert (other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#a02791337b6c509228fdf3e72320b56d3">initialized</a>());
<a name="l00126"></a>00126   libmesh_assert (this-&gt;first_local_index() == other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>());
<a name="l00127"></a>00127   libmesh_assert (this-&gt;last_local_index()  == other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>());
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="keywordtype">int</span> first_different_i = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;int&gt;::max</a>();
<a name="l00130"></a>00130   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = first_local_index();
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="keywordflow">do</span>
<a name="l00133"></a>00133     {
<a name="l00134"></a>00134       <span class="keywordflow">if</span> ( std::abs( (*<span class="keyword">this</span>)(i) - other_vector(i) ) &gt; threshold *
<a name="l00135"></a>00135            <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(std::abs((*<span class="keyword">this</span>)(i)), std::abs(other_vector(i))))
<a name="l00136"></a>00136         first_different_i = i;
<a name="l00137"></a>00137       <span class="keywordflow">else</span>
<a name="l00138"></a>00138         i++;
<a name="l00139"></a>00139     }
<a name="l00140"></a>00140   <span class="keywordflow">while</span> (first_different_i==<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;int&gt;::max</a>()
<a name="l00141"></a>00141          &amp;&amp; i&lt;last_local_index());
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <span class="comment">// Find the correct first differing index in parallel</span>
<a name="l00144"></a>00144   <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(first_different_i);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   <span class="keywordflow">if</span> (first_different_i == <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;int&gt;::max</a>())
<a name="l00147"></a>00147     <span class="keywordflow">return</span> -1;
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keywordflow">return</span> first_different_i;
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00154"></a><a class="code" href="classlibMesh_1_1NumericVector.php#afc1b5914eb995c0cf405c33e0156eab0">00154</a> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#afc1b5914eb995c0cf405c33e0156eab0">NumericVector&lt;T&gt;::global_relative_compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other_vector,
<a name="l00155"></a>00155                                                <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold)<span class="keyword"> const</span>
<a name="l00156"></a>00156 <span class="keyword"></span>{
<a name="l00157"></a>00157   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00158"></a>00158   libmesh_assert (other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#a02791337b6c509228fdf3e72320b56d3">initialized</a>());
<a name="l00159"></a>00159   libmesh_assert (this-&gt;first_local_index() == other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>());
<a name="l00160"></a>00160   libmesh_assert (this-&gt;last_local_index()  == other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>());
<a name="l00161"></a>00161 
<a name="l00162"></a>00162   <span class="keywordtype">int</span> first_different_i = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;int&gt;::max</a>();
<a name="l00163"></a>00163   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = first_local_index();
<a name="l00164"></a>00164 
<a name="l00165"></a>00165   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> my_norm = this-&gt;linfty_norm();
<a name="l00166"></a>00166   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> other_norm = other_vector.<a class="code" href="classlibMesh_1_1NumericVector.php#a9dce53bc73ed63fa006bc5083a6922eb">linfty_norm</a>();
<a name="l00167"></a>00167   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> abs_threshold = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(my_norm, other_norm) * threshold;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169   <span class="keywordflow">do</span>
<a name="l00170"></a>00170     {
<a name="l00171"></a>00171       <span class="keywordflow">if</span> ( std::abs( (*<span class="keyword">this</span>)(i) - other_vector(i) ) &gt; abs_threshold )
<a name="l00172"></a>00172         first_different_i = i;
<a name="l00173"></a>00173       <span class="keywordflow">else</span>
<a name="l00174"></a>00174         i++;
<a name="l00175"></a>00175     }
<a name="l00176"></a>00176   <span class="keywordflow">while</span> (first_different_i==<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;int&gt;::max</a>()
<a name="l00177"></a>00177          &amp;&amp; i&lt;last_local_index());
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">// Find the correct first differing index in parallel</span>
<a name="l00180"></a>00180   <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(first_different_i);
<a name="l00181"></a>00181 
<a name="l00182"></a>00182   <span class="keywordflow">if</span> (first_different_i == <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::numeric_limits&lt;int&gt;::max</a>())
<a name="l00183"></a>00183     <span class="keywordflow">return</span> -1;
<a name="l00184"></a>00184 
<a name="l00185"></a>00185   <span class="keywordflow">return</span> first_different_i;
<a name="l00186"></a>00186 }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="comment">/*</span>
<a name="l00189"></a>00189 <span class="comment">// Full specialization for float datatypes (DistributedVector wants this)</span>
<a name="l00190"></a>00190 <span class="comment"></span>
<a name="l00191"></a>00191 <span class="comment">template &lt;&gt;</span>
<a name="l00192"></a>00192 <span class="comment">int NumericVector&lt;float&gt;::compare (const NumericVector&lt;float&gt; &amp;other_vector,</span>
<a name="l00193"></a>00193 <span class="comment">                                   const Real threshold) const</span>
<a name="l00194"></a>00194 <span class="comment">{</span>
<a name="l00195"></a>00195 <span class="comment">  libmesh_assert (this-&gt;initialized());</span>
<a name="l00196"></a>00196 <span class="comment">  libmesh_assert (other_vector.initialized());</span>
<a name="l00197"></a>00197 <span class="comment">  libmesh_assert (this-&gt;first_local_index() == other_vector.first_local_index());</span>
<a name="l00198"></a>00198 <span class="comment">  libmesh_assert (this-&gt;last_local_index()  == other_vector.last_local_index());</span>
<a name="l00199"></a>00199 <span class="comment"></span>
<a name="l00200"></a>00200 <span class="comment">  int rvalue     = -1;</span>
<a name="l00201"></a>00201 <span class="comment">  unsigned int i = first_local_index();</span>
<a name="l00202"></a>00202 <span class="comment"></span>
<a name="l00203"></a>00203 <span class="comment">  do</span>
<a name="l00204"></a>00204 <span class="comment">    {</span>
<a name="l00205"></a>00205 <span class="comment">      if ( std::abs( (*this)(i) - other_vector(i) ) &gt; threshold )</span>
<a name="l00206"></a>00206 <span class="comment">        rvalue = i;</span>
<a name="l00207"></a>00207 <span class="comment">      else</span>
<a name="l00208"></a>00208 <span class="comment">        i++;</span>
<a name="l00209"></a>00209 <span class="comment">    }</span>
<a name="l00210"></a>00210 <span class="comment">  while (rvalue==-1 &amp;&amp; i&lt;last_local_index());</span>
<a name="l00211"></a>00211 <span class="comment"></span>
<a name="l00212"></a>00212 <span class="comment">  return rvalue;</span>
<a name="l00213"></a>00213 <span class="comment">}</span>
<a name="l00214"></a>00214 <span class="comment"></span>
<a name="l00215"></a>00215 <span class="comment">// Full specialization for double datatypes</span>
<a name="l00216"></a>00216 <span class="comment">template &lt;&gt;</span>
<a name="l00217"></a>00217 <span class="comment">int NumericVector&lt;double&gt;::compare (const NumericVector&lt;double&gt; &amp;other_vector,</span>
<a name="l00218"></a>00218 <span class="comment">                                    const Real threshold) const</span>
<a name="l00219"></a>00219 <span class="comment">{</span>
<a name="l00220"></a>00220 <span class="comment">  libmesh_assert (this-&gt;initialized());</span>
<a name="l00221"></a>00221 <span class="comment">  libmesh_assert (other_vector.initialized());</span>
<a name="l00222"></a>00222 <span class="comment">  libmesh_assert (this-&gt;first_local_index() == other_vector.first_local_index());</span>
<a name="l00223"></a>00223 <span class="comment">  libmesh_assert (this-&gt;last_local_index()  == other_vector.last_local_index());</span>
<a name="l00224"></a>00224 <span class="comment"></span>
<a name="l00225"></a>00225 <span class="comment">  int rvalue     = -1;</span>
<a name="l00226"></a>00226 <span class="comment">  unsigned int i = first_local_index();</span>
<a name="l00227"></a>00227 <span class="comment"></span>
<a name="l00228"></a>00228 <span class="comment">  do</span>
<a name="l00229"></a>00229 <span class="comment">    {</span>
<a name="l00230"></a>00230 <span class="comment">      if ( std::abs( (*this)(i) - other_vector(i) ) &gt; threshold )</span>
<a name="l00231"></a>00231 <span class="comment">        rvalue = i;</span>
<a name="l00232"></a>00232 <span class="comment">      else</span>
<a name="l00233"></a>00233 <span class="comment">        i++;</span>
<a name="l00234"></a>00234 <span class="comment">    }</span>
<a name="l00235"></a>00235 <span class="comment">  while (rvalue==-1 &amp;&amp; i&lt;last_local_index());</span>
<a name="l00236"></a>00236 <span class="comment"></span>
<a name="l00237"></a>00237 <span class="comment">  return rvalue;</span>
<a name="l00238"></a>00238 <span class="comment">}</span>
<a name="l00239"></a>00239 <span class="comment"></span>
<a name="l00240"></a>00240 <span class="comment">#ifdef LIBMESH_DEFAULT_TRIPLE_PRECISION</span>
<a name="l00241"></a>00241 <span class="comment">// Full specialization for long double datatypes</span>
<a name="l00242"></a>00242 <span class="comment">template &lt;&gt;</span>
<a name="l00243"></a>00243 <span class="comment">int NumericVector&lt;long double&gt;::compare (const NumericVector&lt;long double&gt; &amp;other_vector,</span>
<a name="l00244"></a>00244 <span class="comment">                                         const Real threshold) const</span>
<a name="l00245"></a>00245 <span class="comment">{</span>
<a name="l00246"></a>00246 <span class="comment">  libmesh_assert (this-&gt;initialized());</span>
<a name="l00247"></a>00247 <span class="comment">  libmesh_assert (other_vector.initialized());</span>
<a name="l00248"></a>00248 <span class="comment">  libmesh_assert (this-&gt;first_local_index() == other_vector.first_local_index());</span>
<a name="l00249"></a>00249 <span class="comment">  libmesh_assert (this-&gt;last_local_index()  == other_vector.last_local_index());</span>
<a name="l00250"></a>00250 <span class="comment"></span>
<a name="l00251"></a>00251 <span class="comment">  int rvalue     = -1;</span>
<a name="l00252"></a>00252 <span class="comment">  unsigned int i = first_local_index();</span>
<a name="l00253"></a>00253 <span class="comment"></span>
<a name="l00254"></a>00254 <span class="comment">  do</span>
<a name="l00255"></a>00255 <span class="comment">    {</span>
<a name="l00256"></a>00256 <span class="comment">      if ( std::abs( (*this)(i) - other_vector(i) ) &gt; threshold )</span>
<a name="l00257"></a>00257 <span class="comment">        rvalue = i;</span>
<a name="l00258"></a>00258 <span class="comment">      else</span>
<a name="l00259"></a>00259 <span class="comment">        i++;</span>
<a name="l00260"></a>00260 <span class="comment">    }</span>
<a name="l00261"></a>00261 <span class="comment">  while (rvalue==-1 &amp;&amp; i&lt;last_local_index());</span>
<a name="l00262"></a>00262 <span class="comment"></span>
<a name="l00263"></a>00263 <span class="comment">  return rvalue;</span>
<a name="l00264"></a>00264 <span class="comment">}</span>
<a name="l00265"></a>00265 <span class="comment">#endif</span>
<a name="l00266"></a>00266 <span class="comment"></span>
<a name="l00267"></a>00267 <span class="comment"></span>
<a name="l00268"></a>00268 <span class="comment">// Full specialization for Complex datatypes</span>
<a name="l00269"></a>00269 <span class="comment">template &lt;&gt;</span>
<a name="l00270"></a>00270 <span class="comment">int NumericVector&lt;Complex&gt;::compare (const NumericVector&lt;Complex&gt; &amp;other_vector,</span>
<a name="l00271"></a>00271 <span class="comment">                                     const Real threshold) const</span>
<a name="l00272"></a>00272 <span class="comment">{</span>
<a name="l00273"></a>00273 <span class="comment">  libmesh_assert (this-&gt;initialized());</span>
<a name="l00274"></a>00274 <span class="comment">  libmesh_assert (other_vector.initialized());</span>
<a name="l00275"></a>00275 <span class="comment">  libmesh_assert (this-&gt;first_local_index() == other_vector.first_local_index());</span>
<a name="l00276"></a>00276 <span class="comment">  libmesh_assert (this-&gt;last_local_index()  == other_vector.last_local_index());</span>
<a name="l00277"></a>00277 <span class="comment"></span>
<a name="l00278"></a>00278 <span class="comment">  int rvalue     = -1;</span>
<a name="l00279"></a>00279 <span class="comment">  unsigned int i = first_local_index();</span>
<a name="l00280"></a>00280 <span class="comment"></span>
<a name="l00281"></a>00281 <span class="comment">  do</span>
<a name="l00282"></a>00282 <span class="comment">    {</span>
<a name="l00283"></a>00283 <span class="comment">      if (( std::abs( (*this)(i).real() - other_vector(i).real() ) &gt; threshold ) ||</span>
<a name="l00284"></a>00284 <span class="comment">          ( std::abs( (*this)(i).imag() - other_vector(i).imag() ) &gt; threshold ))</span>
<a name="l00285"></a>00285 <span class="comment">        rvalue = i;</span>
<a name="l00286"></a>00286 <span class="comment">      else</span>
<a name="l00287"></a>00287 <span class="comment">        i++;</span>
<a name="l00288"></a>00288 <span class="comment">    }</span>
<a name="l00289"></a>00289 <span class="comment">  while (rvalue==-1 &amp;&amp; i&lt;this-&gt;last_local_index());</span>
<a name="l00290"></a>00290 <span class="comment"></span>
<a name="l00291"></a>00291 <span class="comment">  return rvalue;</span>
<a name="l00292"></a>00292 <span class="comment">}</span>
<a name="l00293"></a>00293 <span class="comment">*/</span>
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00297"></a><a class="code" href="classlibMesh_1_1NumericVector.php#af561f729821ed58c47edb831c04d1910">00297</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#af561f729821ed58c47edb831c04d1910">NumericVector&lt;T&gt;::subset_l1_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices)<span class="keyword"> const</span>
<a name="l00298"></a>00298 <span class="keyword"></span>{
<a name="l00299"></a>00299   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; v = *<span class="keyword">this</span>;
<a name="l00300"></a>00300   
<a name="l00301"></a>00301   std::set&lt;unsigned int&gt;::const_iterator it = indices.begin();
<a name="l00302"></a>00302   <span class="keyword">const</span> std::set&lt;unsigned int&gt;::const_iterator it_end = indices.end();
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm = 0;
<a name="l00305"></a>00305   
<a name="l00306"></a>00306   <span class="keywordflow">for</span>(; it!=it_end; ++it)
<a name="l00307"></a>00307     norm += std::abs(v(*it));
<a name="l00308"></a>00308 
<a name="l00309"></a>00309   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(norm);
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <span class="keywordflow">return</span> norm;
<a name="l00312"></a>00312 }
<a name="l00313"></a>00313 
<a name="l00314"></a>00314 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00315"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a7c28e73b0d19b29b425446466f0a3c78">00315</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a7c28e73b0d19b29b425446466f0a3c78">NumericVector&lt;T&gt;::subset_l2_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices)<span class="keyword"> const</span>
<a name="l00316"></a>00316 <span class="keyword"></span>{
<a name="l00317"></a>00317   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; v = *<span class="keyword">this</span>;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   std::set&lt;unsigned int&gt;::const_iterator it = indices.begin();
<a name="l00320"></a>00320   <span class="keyword">const</span> std::set&lt;unsigned int&gt;::const_iterator it_end = indices.end();
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm = 0;
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   <span class="keywordflow">for</span>(; it!=it_end; ++it)
<a name="l00325"></a>00325     norm += <a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(v(*it));
<a name="l00326"></a>00326 
<a name="l00327"></a>00327   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(norm);
<a name="l00328"></a>00328 
<a name="l00329"></a>00329   <span class="keywordflow">return</span> std::sqrt(norm);
<a name="l00330"></a>00330 }
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="keyword">template</span> &lt;<span class="keyword">class</span> T&gt;
<a name="l00333"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a72e4e7c12301bb3b990b12491fabcfdd">00333</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a72e4e7c12301bb3b990b12491fabcfdd">NumericVector&lt;T&gt;::subset_linfty_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices)<span class="keyword"> const</span>
<a name="l00334"></a>00334 <span class="keyword"></span>{
<a name="l00335"></a>00335   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; v = *<span class="keyword">this</span>;
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   std::set&lt;unsigned int&gt;::const_iterator it = indices.begin();
<a name="l00338"></a>00338   <span class="keyword">const</span> std::set&lt;unsigned int&gt;::const_iterator it_end = indices.end();
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> norm = 0;
<a name="l00341"></a>00341   
<a name="l00342"></a>00342   <span class="keywordflow">for</span>(; it!=it_end; ++it)
<a name="l00343"></a>00343     {
<a name="l00344"></a>00344       <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> value = std::abs(v(*it));
<a name="l00345"></a>00345       <span class="keywordflow">if</span>(value &gt; norm)
<a name="l00346"></a>00346         norm = value;
<a name="l00347"></a>00347     }
<a name="l00348"></a>00348 
<a name="l00349"></a>00349   <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">Parallel::max</a>(norm);
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   <span class="keywordflow">return</span> norm;
<a name="l00352"></a>00352 }
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00357"></a><a class="code" href="classlibMesh_1_1NumericVector.php#af8cc6481483d5c8954a0a041a924d6d3">00357</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">NumericVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v,
<a name="l00358"></a>00358                                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; a)
<a name="l00359"></a>00359 {
<a name="l00360"></a>00360   a.<a class="code" href="classlibMesh_1_1ShellMatrix.php#a754071de77d848c5481a42fd41fc5157">vector_mult_add</a>(*<span class="keyword">this</span>,v);
<a name="l00361"></a>00361 }
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00366"></a>00366 <span class="comment">// Explicit instantiations</span>
<a name="l00367"></a>00367 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>;
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
