<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">numeric_vector.h</div>  </div>
</div>
<div class="contents">
<a href="numeric__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: numeric_vector.h 4286 2011-03-24 03:55:50Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __numeric_vector_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __numeric_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="enum__parallel__type_8h.php">enum_parallel_type.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="enum__solver__package_8h.php">enum_solver_package.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>libMesh
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="comment">// forward declarations</span>
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseVector;
<a name="l00045"></a>00045 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseSubVector;
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00047"></a>00047 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>ShellMatrix;
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00057"></a>00057 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00058"></a><a class="code" href="classlibMesh_1_1NumericVector.php">00058</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;NumericVector&lt;T&gt; &gt;
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060 <span class="keyword">public</span>:
<a name="l00061"></a>00061 
<a name="l00065"></a>00065   <span class="keyword">explicit</span>
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1NumericVector.php#ab5f28ead4fac7873eacc9ccea13adec9">NumericVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00067"></a>00067     
<a name="l00071"></a>00071   <span class="keyword">explicit</span>
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1NumericVector.php#ab5f28ead4fac7873eacc9ccea13adec9">NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00073"></a>00073                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00074"></a>00074     
<a name="l00079"></a>00079   <a class="code" href="classlibMesh_1_1NumericVector.php#ab5f28ead4fac7873eacc9ccea13adec9">NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> n,
<a name="l00080"></a>00080                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00081"></a>00081                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00082"></a>00082 
<a name="l00088"></a>00088   <a class="code" href="classlibMesh_1_1NumericVector.php#ab5f28ead4fac7873eacc9ccea13adec9">NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00089"></a>00089                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00090"></a>00090                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00091"></a>00091                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00092"></a>00092     
<a name="l00093"></a>00093 <span class="keyword">public</span>:
<a name="l00094"></a>00094 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a99c88c963aa6d26f3964876e4da98ba8">~NumericVector</a> ();
<a name="l00100"></a>00100 
<a name="l00105"></a>00105   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt;
<a name="l00106"></a>00106   <a class="code" href="classlibMesh_1_1NumericVector.php#a0d27c70b975f088614f068f3f30c8747">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package = <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00107"></a>00107   
<a name="l00112"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a02791337b6c509228fdf3e72320b56d3">00112</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a02791337b6c509228fdf3e72320b56d3">initialized</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a>; }
<a name="l00113"></a>00113 
<a name="l00117"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">00117</a>   <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a>; }
<a name="l00118"></a>00118 
<a name="l00122"></a><a class="code" href="classlibMesh_1_1NumericVector.php#ab26a86bcc0a2b9f994ee1b21404cb401">00122</a>   <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> &amp; <a class="code" href="classlibMesh_1_1NumericVector.php#ab26a86bcc0a2b9f994ee1b21404cb401">type</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a>; }
<a name="l00123"></a>00123 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1NumericVector.php#afa69111a678b5552c7fe586c91a6585f">00128</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NumericVector.php#afa69111a678b5552c7fe586c91a6585f">closed</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a>; }
<a name="l00129"></a>00129   
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a42ea91bba70b3e7b27dad2a636ad31ae">close</a> () = 0; 
<a name="l00134"></a>00134 
<a name="l00138"></a>00138   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a1d68d128b5e80a75fea7c24b7f3bcb5b">clear</a> ();
<a name="l00139"></a>00139 
<a name="l00144"></a>00144   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a85b3d4a53413e3745e6ecf1c8b96ca65">zero</a> () = 0;    
<a name="l00145"></a>00145 
<a name="l00152"></a>00152   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1NumericVector.php#a6f0bb3315b7252ca3bcc2b3c2e828a31">zero_clone</a> () <span class="keyword">const</span> = 0;
<a name="l00153"></a>00153   
<a name="l00158"></a>00158   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1NumericVector.php#a5c4b5cbb3877d0ad466895286fc8bb55">clone</a> () <span class="keyword">const</span> = 0;
<a name="l00159"></a>00159   
<a name="l00173"></a>00173   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00174"></a>00174                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00175"></a>00175                      <span class="keyword">const</span> <span class="keywordtype">bool</span> = <span class="keyword">false</span>,
<a name="l00176"></a>00176                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>) = 0;
<a name="l00177"></a>00177   
<a name="l00181"></a>00181   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>,
<a name="l00182"></a>00182                      <span class="keyword">const</span> <span class="keywordtype">bool</span> = <span class="keyword">false</span>,
<a name="l00183"></a>00183                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>) = 0;
<a name="l00184"></a>00184     
<a name="l00189"></a>00189   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00190"></a>00190                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00191"></a>00191                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00192"></a>00192                      <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00193"></a>00193                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>) = 0;
<a name="l00194"></a>00194 
<a name="l00199"></a>00199   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#aba2b1e60a94162764c07732626a8231b">init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00200"></a>00200                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>) = 0;
<a name="l00201"></a>00201     
<a name="l00205"></a>00205   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1NumericVector.php#aa280ed0139db9a1a4204a2b886ef60ba">operator= </a>(<span class="keyword">const</span> T s) = 0;
<a name="l00206"></a>00206   
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1NumericVector.php#aa280ed0139db9a1a4204a2b886ef60ba">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V) = 0;
<a name="l00211"></a>00211 
<a name="l00215"></a>00215   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1NumericVector.php#aa280ed0139db9a1a4204a2b886ef60ba">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v) = 0;
<a name="l00216"></a>00216 
<a name="l00222"></a>00222   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#abe1207a69225c25b6b009f98f37c43db">min</a> () <span class="keyword">const</span> = 0;
<a name="l00223"></a>00223   
<a name="l00229"></a>00229   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a2e297e0c71f81757d950c4c76f2e0116">max</a> () <span class="keyword">const</span> = 0;
<a name="l00230"></a>00230  
<a name="l00234"></a>00234   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1NumericVector.php#ad09f0eab77d58ce125dfc4f400c8ed5d">sum</a>() <span class="keyword">const</span> = 0;
<a name="l00235"></a>00235 
<a name="l00240"></a>00240   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a110a36d7800daa4bb8b91e35419d335d">l1_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00241"></a>00241 
<a name="l00247"></a>00247   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a7bbf5b5a75e7aafcbfc1ea19fbc51d73">l2_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00248"></a>00248 
<a name="l00254"></a>00254   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a9dce53bc73ed63fa006bc5083a6922eb">linfty_norm</a> () <span class="keyword">const</span> = 0;
<a name="l00255"></a>00255 
<a name="l00264"></a>00264   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#af561f729821ed58c47edb831c04d1910">subset_l1_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices) <span class="keyword">const</span>;
<a name="l00265"></a>00265 
<a name="l00275"></a>00275   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a7c28e73b0d19b29b425446466f0a3c78">subset_l2_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices) <span class="keyword">const</span>;
<a name="l00276"></a>00276 
<a name="l00285"></a>00285   <span class="keyword">virtual</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a72e4e7c12301bb3b990b12491fabcfdd">subset_linfty_norm</a> (<span class="keyword">const</span> std::set&lt;unsigned int&gt; &amp; indices) <span class="keyword">const</span>;
<a name="l00286"></a>00286 
<a name="l00294"></a>00294   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a> () <span class="keyword">const</span> = 0;
<a name="l00295"></a>00295 
<a name="l00301"></a>00301   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a6cc4358896c079e301a815a4ff4459eb">local_size</a>() <span class="keyword">const</span> = 0;
<a name="l00302"></a>00302 
<a name="l00308"></a>00308   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a313c2e8c69d74b3abd156b6b6fe415d1">first_local_index</a>() <span class="keyword">const</span> = 0;
<a name="l00309"></a>00309 
<a name="l00315"></a>00315   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#aaacb6f0a99a041108211ce79ea934fe2">last_local_index</a>() <span class="keyword">const</span> = 0;
<a name="l00316"></a>00316     
<a name="l00320"></a>00320   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1NumericVector.php#ad5c10e134a98202d39255f217a7cc0ef">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> = 0;
<a name="l00321"></a>00321     
<a name="l00325"></a><a class="code" href="classlibMesh_1_1NumericVector.php#abb55bab589e1e19fabdab2dc00221f4c">00325</a>   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1NumericVector.php#abb55bab589e1e19fabdab2dc00221f4c">el</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const </span>{ <span class="keywordflow">return</span> (*<span class="keyword">this</span>)(i); }
<a name="l00326"></a>00326 
<a name="l00333"></a>00333   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">get</span>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values) <span class="keyword">const</span>;
<a name="l00334"></a>00334 
<a name="l00339"></a>00339   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1NumericVector.php#a06154f6f2c3b75706341a4c00e3c3928">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V) = 0;
<a name="l00340"></a>00340 
<a name="l00345"></a>00345   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1NumericVector.php#a0691b13952669a1e2525c00e8b4878ee">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V) = 0;
<a name="l00346"></a>00346     
<a name="l00351"></a><a class="code" href="classlibMesh_1_1NumericVector.php#ad81ed76e0103038084a3035cf8dab795">00351</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1NumericVector.php#ad81ed76e0103038084a3035cf8dab795">operator *= </a>(<span class="keyword">const</span> T a) { this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00352"></a>00352 
<a name="l00357"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a116b383a8959e317a07d9e154a169840">00357</a>   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1NumericVector.php#a116b383a8959e317a07d9e154a169840">operator /= </a>(<span class="keyword">const</span> T a) { this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a>(1./a); <span class="keywordflow">return</span> *<span class="keyword">this</span>; }
<a name="l00358"></a>00358 
<a name="l00362"></a>00362   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value) = 0;
<a name="l00363"></a>00363     
<a name="l00367"></a>00367   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value) = 0;
<a name="l00368"></a>00368     
<a name="l00374"></a>00374   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a> (<span class="keyword">const</span> T s) = 0;
<a name="l00375"></a>00375     
<a name="l00381"></a>00381   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) = 0;
<a name="l00382"></a>00382 
<a name="l00388"></a>00388   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#aaf343defd46de8557801dc56a2884506">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v) = 0;
<a name="l00389"></a>00389 
<a name="l00395"></a>00395   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00396"></a>00396                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00397"></a>00397 
<a name="l00404"></a>00404   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00405"></a>00405                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00406"></a>00406 
<a name="l00411"></a>00411   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00412"></a>00412                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;) = 0;
<a name="l00413"></a>00413       
<a name="l00418"></a>00418   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v,
<a name="l00419"></a>00419                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; a);
<a name="l00420"></a>00420       
<a name="l00427"></a>00427   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#adbbff7081d24abefefad1497882b03ab">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00428"></a>00428                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00429"></a>00429 
<a name="l00434"></a>00434   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a5e4d04237963359cc7434190be17e9f1">add_vector_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;,
<a name="l00435"></a>00435                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;) = 0;
<a name="l00436"></a>00436 
<a name="l00441"></a>00441   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#af991ccf3003181f7449d790603df3075">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00442"></a>00442                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00443"></a>00443 
<a name="l00450"></a>00450   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#af991ccf3003181f7449d790603df3075">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00451"></a>00451                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00452"></a>00452       
<a name="l00459"></a>00459   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#af991ccf3003181f7449d790603df3075">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00460"></a>00460                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00461"></a>00461 
<a name="l00467"></a>00467   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#af991ccf3003181f7449d790603df3075">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00468"></a>00468                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices) = 0;
<a name="l00469"></a>00469     
<a name="l00474"></a>00474   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a7efb30d08bd1bb55a91f66782238d648">scale</a> (<span class="keyword">const</span> T factor) = 0;
<a name="l00475"></a>00475 
<a name="l00480"></a>00480   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a5ecda9cf4b18d9b39228ebe37c8381b0">abs</a>() = 0;
<a name="l00481"></a>00481 
<a name="l00485"></a>00485   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1NumericVector.php#a1f522c421b32b75ea4dc3de6d1a95000">dot</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;) <span class="keyword">const</span> = 0;
<a name="l00486"></a>00486   
<a name="l00491"></a>00491   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span> = 0;
<a name="l00492"></a>00492 
<a name="l00497"></a>00497   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span> = 0;
<a name="l00498"></a>00498 
<a name="l00504"></a>00504   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00505"></a>00505                          <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span> = 0;
<a name="l00506"></a>00506   
<a name="l00511"></a>00511   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a7348b5b027adf716016354847e0df0b6">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00512"></a>00512                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00513"></a>00513                          <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) = 0;
<a name="l00514"></a>00514 
<a name="l00521"></a>00521   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#ab1a4f4c4558bc17d655809276a49ba9e">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00522"></a>00522                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span> = 0;
<a name="l00523"></a>00523     
<a name="l00532"></a>00532   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#ae3efc92e2f7a711df841c7eb8807b0f2">compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other_vector,
<a name="l00533"></a>00533                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold = TOLERANCE) <span class="keyword">const</span>;
<a name="l00534"></a>00534 
<a name="l00543"></a>00543   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a10c766ef62ccd97a2b19917963a34425">local_relative_compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other_vector,
<a name="l00544"></a>00544                                       <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold = TOLERANCE) <span class="keyword">const</span>;
<a name="l00545"></a>00545 
<a name="l00554"></a>00554   <span class="keyword">virtual</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1NumericVector.php#afc1b5914eb995c0cf405c33e0156eab0">global_relative_compare</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other_vector,
<a name="l00555"></a>00555                                        <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> threshold = TOLERANCE) <span class="keyword">const</span>;
<a name="l00556"></a>00556 
<a name="l00561"></a>00561   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a01ffe7580b8f038caade2a22d0bb505e">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00562"></a>00562                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2) = 0;
<a name="l00563"></a>00563 
<a name="l00568"></a>00568   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a9932a4618eae8d40f938922b4bc04e65">print</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00569"></a>00569 
<a name="l00574"></a>00574   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#ad3f48ff5522a98fec4a70d022a340f34">print_global</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00575"></a>00575 
<a name="l00579"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a79351f9d343287d91dd2e782dfbd508d">00579</a>   <span class="keyword">friend</span> std::ostream&amp; operator &lt;&lt; (std::ostream&amp; os, const NumericVector&lt;T&gt;&amp; v)
<a name="l00580"></a>00580   {
<a name="l00581"></a>00581     v.print_global(os);
<a name="l00582"></a>00582     <span class="keywordflow">return</span> os;
<a name="l00583"></a>00583   }
<a name="l00584"></a>00584   
<a name="l00591"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a6fc091a2dcb5ea7764c3d8fdd220e71e">00591</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a6fc091a2dcb5ea7764c3d8fdd220e71e">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>)<span class="keyword"> const</span>
<a name="l00592"></a>00592 <span class="keyword">  </span>{
<a name="l00593"></a>00593     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Not Implemented in base class yet!&quot;</span> &lt;&lt; std::endl;
<a name="l00594"></a>00594     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR writing MATLAB file &quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a> &lt;&lt; std::endl;
<a name="l00595"></a>00595     libmesh_error();
<a name="l00596"></a>00596   }
<a name="l00597"></a>00597 
<a name="l00604"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a6b29195534340cfb0f247b5c7a2e6e6a">00604</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a6b29195534340cfb0f247b5c7a2e6e6a">create_subvector</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; ,
<a name="l00605"></a>00605                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; )<span class="keyword"> const</span>
<a name="l00606"></a>00606 <span class="keyword">  </span>{
<a name="l00607"></a>00607     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Not Implemented in base class yet!&quot;</span> &lt;&lt; std::endl;
<a name="l00608"></a>00608     libmesh_error();
<a name="l00609"></a>00609   }
<a name="l00610"></a>00610     
<a name="l00616"></a>00616   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00617"></a>00617 
<a name="l00618"></a>00618 <span class="keyword">protected</span>:
<a name="l00619"></a>00619   
<a name="l00624"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">00624</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a>;
<a name="l00625"></a>00625   
<a name="l00630"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">00630</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a>;
<a name="l00631"></a>00631 
<a name="l00635"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">00635</a>   <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a>;
<a name="l00636"></a>00636 };
<a name="l00637"></a>00637 
<a name="l00638"></a>00638 
<a name="l00639"></a>00639 <span class="comment">/*----------------------- Inline functions ----------------------------------*/</span>
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00644"></a>00644 <span class="keyword">inline</span>
<a name="l00645"></a><a class="code" href="classlibMesh_1_1NumericVector.php#ab5f28ead4fac7873eacc9ccea13adec9">00645</a> <a class="code" href="classlibMesh_1_1NumericVector.php#ab5f28ead4fac7873eacc9ccea13adec9">NumericVector&lt;T&gt;::NumericVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00646"></a>00646   _is_closed(false),
<a name="l00647"></a>00647   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false),
<a name="l00648"></a>00648   _type(type)
<a name="l00649"></a>00649 {
<a name="l00650"></a>00650 }
<a name="l00651"></a>00651 
<a name="l00652"></a>00652 
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00655"></a>00655 <span class="keyword">inline</span>
<a name="l00656"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a434d81a4547916ce870d39edf30c1e5b">00656</a> <a class="code" href="classlibMesh_1_1NumericVector.php#ab5f28ead4fac7873eacc9ccea13adec9">NumericVector&lt;T&gt;::NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n*/</span>,
<a name="l00657"></a>00657                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00658"></a>00658   _is_closed(false),
<a name="l00659"></a>00659   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false),
<a name="l00660"></a>00660   _type(type)
<a name="l00661"></a>00661 {
<a name="l00662"></a>00662   libmesh_error(); <span class="comment">// Abstract base class!</span>
<a name="l00663"></a>00663   <span class="comment">// init(n, n, false, type);</span>
<a name="l00664"></a>00664 }
<a name="l00665"></a>00665 
<a name="l00666"></a>00666 
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00669"></a>00669 <span class="keyword">inline</span>
<a name="l00670"></a><a class="code" href="classlibMesh_1_1NumericVector.php#ac7d3881a31767870397e902e9605a9a8">00670</a> <a class="code" href="classlibMesh_1_1NumericVector.php#ab5f28ead4fac7873eacc9ccea13adec9">NumericVector&lt;T&gt;::NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n*/</span>,
<a name="l00671"></a>00671                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00672"></a>00672                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00673"></a>00673   _is_closed(false),
<a name="l00674"></a>00674   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false),
<a name="l00675"></a>00675   _type(type)
<a name="l00676"></a>00676 {
<a name="l00677"></a>00677   libmesh_error(); <span class="comment">// Abstract base class!</span>
<a name="l00678"></a>00678   <span class="comment">// init(n, n_local, false, type);</span>
<a name="l00679"></a>00679 }
<a name="l00680"></a>00680 
<a name="l00681"></a>00681 
<a name="l00682"></a>00682 
<a name="l00683"></a>00683 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00684"></a>00684 <span class="keyword">inline</span>
<a name="l00685"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a471b89e7ab92e80fc4d399f44197e035">00685</a> <a class="code" href="classlibMesh_1_1NumericVector.php#ab5f28ead4fac7873eacc9ccea13adec9">NumericVector&lt;T&gt;::NumericVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n*/</span>,
<a name="l00686"></a>00686                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00687"></a>00687                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00688"></a>00688                                  <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type) :
<a name="l00689"></a>00689   _is_closed(false),
<a name="l00690"></a>00690   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>(false),
<a name="l00691"></a>00691   _type(type)
<a name="l00692"></a>00692 {
<a name="l00693"></a>00693   libmesh_error(); <span class="comment">// Abstract base class!</span>
<a name="l00694"></a>00694   <span class="comment">// init(n, n_local, ghost, false, type);</span>
<a name="l00695"></a>00695 }
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 
<a name="l00698"></a>00698 
<a name="l00699"></a>00699 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00700"></a>00700 <span class="keyword">inline</span>
<a name="l00701"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a99c88c963aa6d26f3964876e4da98ba8">00701</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a99c88c963aa6d26f3964876e4da98ba8">NumericVector&lt;T&gt;::~NumericVector</a> ()
<a name="l00702"></a>00702 {
<a name="l00703"></a>00703   clear ();
<a name="l00704"></a>00704 }
<a name="l00705"></a>00705 
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 <span class="comment">// These should be pure virtual, not bugs waiting to happen - RHS</span>
<a name="l00709"></a>00709 <span class="comment">/*</span>
<a name="l00710"></a>00710 <span class="comment">template &lt;typename T&gt;</span>
<a name="l00711"></a>00711 <span class="comment">inline</span>
<a name="l00712"></a>00712 <span class="comment">NumericVector&lt;T&gt; &amp; NumericVector&lt;T&gt;::operator= (const T) </span>
<a name="l00713"></a>00713 <span class="comment">{</span>
<a name="l00714"></a>00714 <span class="comment">  //  libmesh_error();</span>
<a name="l00715"></a>00715 <span class="comment"></span>
<a name="l00716"></a>00716 <span class="comment">  return *this;</span>
<a name="l00717"></a>00717 <span class="comment">}</span>
<a name="l00718"></a>00718 <span class="comment"></span>
<a name="l00719"></a>00719 <span class="comment"></span>
<a name="l00720"></a>00720 <span class="comment"></span>
<a name="l00721"></a>00721 <span class="comment">template &lt;typename T&gt;</span>
<a name="l00722"></a>00722 <span class="comment">inline</span>
<a name="l00723"></a>00723 <span class="comment">NumericVector&lt;T&gt; &amp; NumericVector&lt;T&gt;::operator= (const NumericVector&lt;T&gt;&amp;) </span>
<a name="l00724"></a>00724 <span class="comment">{</span>
<a name="l00725"></a>00725 <span class="comment">  //  libmesh_error();</span>
<a name="l00726"></a>00726 <span class="comment"></span>
<a name="l00727"></a>00727 <span class="comment">  return *this;</span>
<a name="l00728"></a>00728 <span class="comment">}</span>
<a name="l00729"></a>00729 <span class="comment"></span>
<a name="l00730"></a>00730 <span class="comment"></span>
<a name="l00731"></a>00731 <span class="comment"></span>
<a name="l00732"></a>00732 <span class="comment">template &lt;typename T&gt;</span>
<a name="l00733"></a>00733 <span class="comment">inline</span>
<a name="l00734"></a>00734 <span class="comment">NumericVector&lt;T&gt; &amp; NumericVector&lt;T&gt;::operator= (const std::vector&lt;T&gt;&amp;) </span>
<a name="l00735"></a>00735 <span class="comment">{</span>
<a name="l00736"></a>00736 <span class="comment">  //  libmesh_error();</span>
<a name="l00737"></a>00737 <span class="comment"></span>
<a name="l00738"></a>00738 <span class="comment">  return *this;</span>
<a name="l00739"></a>00739 <span class="comment">}</span>
<a name="l00740"></a>00740 <span class="comment">*/</span>
<a name="l00741"></a>00741 
<a name="l00742"></a>00742 
<a name="l00743"></a>00743 
<a name="l00744"></a>00744 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00745"></a>00745 <span class="keyword">inline</span>
<a name="l00746"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a1d68d128b5e80a75fea7c24b7f3bcb5b">00746</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a1d68d128b5e80a75fea7c24b7f3bcb5b">NumericVector&lt;T&gt;::clear</a> ()
<a name="l00747"></a>00747 {
<a name="l00748"></a>00748   _is_closed      = <span class="keyword">false</span>;
<a name="l00749"></a>00749   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00750"></a>00750 }
<a name="l00751"></a>00751   
<a name="l00752"></a>00752   
<a name="l00753"></a>00753   
<a name="l00754"></a>00754 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00755"></a>00755 <span class="keyword">inline</span>
<a name="l00756"></a><a class="code" href="classlibMesh_1_1NumericVector.php#acb2bc1f41545a29239706bf2ca3e7fa0">00756</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#acb2bc1f41545a29239706bf2ca3e7fa0">NumericVector&lt;T&gt;::get</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values)<span class="keyword"> const</span>
<a name="l00757"></a>00757 <span class="keyword"></span>{
<a name="l00758"></a>00758   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = index.size();
<a name="l00759"></a>00759   values.resize(num);
<a name="l00760"></a>00760   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num; i++)
<a name="l00761"></a>00761     {
<a name="l00762"></a>00762       values[i] = (*this)(index[i]);
<a name="l00763"></a>00763     }
<a name="l00764"></a>00764 }
<a name="l00765"></a>00765 
<a name="l00766"></a>00766 
<a name="l00767"></a>00767 
<a name="l00768"></a>00768 <span class="comment">// Full specialization of the print() member for complex</span>
<a name="l00769"></a>00769 <span class="comment">// variables.  This must precede the non-specialized</span>
<a name="l00770"></a>00770 <span class="comment">// version, at least according to icc v7.1</span>
<a name="l00771"></a>00771 <span class="keyword">template</span> &lt;&gt;
<a name="l00772"></a>00772 <span class="keyword">inline</span>
<a name="l00773"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a7521d24df14c323d74c735b8db047971">00773</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a9932a4618eae8d40f938922b4bc04e65">NumericVector&lt;Complex&gt;::print</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00774"></a>00774 <span class="keyword"></span>{
<a name="l00775"></a>00775   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00776"></a>00776   os &lt;&lt; <span class="stringliteral">&quot;Size\tglobal =  &quot;</span> &lt;&lt; this-&gt;size()
<a name="l00777"></a>00777      &lt;&lt; <span class="stringliteral">&quot;\t\tlocal =  &quot;</span> &lt;&lt; this-&gt;local_size() &lt;&lt; std::endl;
<a name="l00778"></a>00778   
<a name="l00779"></a>00779   <span class="comment">// std::complex&lt;&gt;::operator&lt;&lt;() is defined, but use this form</span>
<a name="l00780"></a>00780   os &lt;&lt; <span class="stringliteral">&quot;#\tReal part\t\tImaginary part&quot;</span> &lt;&lt; std::endl;
<a name="l00781"></a>00781   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;first_local_index(); i&lt;this-&gt;last_local_index(); i++)
<a name="l00782"></a>00782     os &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span> 
<a name="l00783"></a>00783        &lt;&lt; (*<span class="keyword">this</span>)(i).real() &lt;&lt; <span class="stringliteral">&quot;\t\t&quot;</span> 
<a name="l00784"></a>00784        &lt;&lt; (*this)(i).imag() &lt;&lt; std::endl;
<a name="l00785"></a>00785 }
<a name="l00786"></a>00786 
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 
<a name="l00789"></a>00789 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00790"></a>00790 <span class="keyword">inline</span>
<a name="l00791"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a9932a4618eae8d40f938922b4bc04e65">00791</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#a9932a4618eae8d40f938922b4bc04e65">NumericVector&lt;T&gt;::print</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00792"></a>00792 <span class="keyword"></span>{
<a name="l00793"></a>00793   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00794"></a>00794   os &lt;&lt; <span class="stringliteral">&quot;Size\tglobal =  &quot;</span> &lt;&lt; this-&gt;size()
<a name="l00795"></a>00795      &lt;&lt; <span class="stringliteral">&quot;\t\tlocal =  &quot;</span> &lt;&lt; this-&gt;local_size() &lt;&lt; std::endl;
<a name="l00796"></a>00796 
<a name="l00797"></a>00797   os &lt;&lt; <span class="stringliteral">&quot;#\tValue&quot;</span> &lt;&lt; std::endl;
<a name="l00798"></a>00798   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=this-&gt;first_local_index(); i&lt;this-&gt;last_local_index(); i++)
<a name="l00799"></a>00799     os &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span> &lt;&lt; (*<span class="keyword">this</span>)(i) &lt;&lt; std::endl;
<a name="l00800"></a>00800 }
<a name="l00801"></a>00801 
<a name="l00802"></a>00802 
<a name="l00803"></a>00803 
<a name="l00804"></a>00804 <span class="keyword">template</span> &lt;&gt;
<a name="l00805"></a>00805 <span class="keyword">inline</span>
<a name="l00806"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a3145a79c2fcc12968a023839c7d36dcc">00806</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#ad3f48ff5522a98fec4a70d022a340f34">NumericVector&lt;Complex&gt;::print_global</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00807"></a>00807 <span class="keyword"></span>{
<a name="l00808"></a>00808   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00809"></a>00809 
<a name="l00810"></a>00810   std::vector&lt;Complex&gt; v(this-&gt;size());
<a name="l00811"></a>00811   this-&gt;localize(v);
<a name="l00812"></a>00812 
<a name="l00813"></a>00813   <span class="comment">// Right now we only want one copy of the output</span>
<a name="l00814"></a>00814   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00815"></a>00815     <span class="keywordflow">return</span>;
<a name="l00816"></a>00816   
<a name="l00817"></a>00817   os &lt;&lt; <span class="stringliteral">&quot;Size\tglobal =  &quot;</span> &lt;&lt; this-&gt;size() &lt;&lt; std::endl;
<a name="l00818"></a>00818   os &lt;&lt; <span class="stringliteral">&quot;#\tReal part\t\tImaginary part&quot;</span> &lt;&lt; std::endl;
<a name="l00819"></a>00819   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=v.size(); i++)
<a name="l00820"></a>00820     os &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span> 
<a name="l00821"></a>00821        &lt;&lt; v[i].real() &lt;&lt; <span class="stringliteral">&quot;\t\t&quot;</span> 
<a name="l00822"></a>00822        &lt;&lt; v[i].imag() &lt;&lt; std::endl;
<a name="l00823"></a>00823 }
<a name="l00824"></a>00824 
<a name="l00825"></a>00825 
<a name="l00826"></a>00826 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00827"></a>00827 <span class="keyword">inline</span>
<a name="l00828"></a><a class="code" href="classlibMesh_1_1NumericVector.php#ad3f48ff5522a98fec4a70d022a340f34">00828</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1NumericVector.php#ad3f48ff5522a98fec4a70d022a340f34">NumericVector&lt;T&gt;::print_global</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00829"></a>00829 <span class="keyword"></span>{
<a name="l00830"></a>00830   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00831"></a>00831 
<a name="l00832"></a>00832   std::vector&lt;T&gt; v(this-&gt;size());
<a name="l00833"></a>00833   this-&gt;localize(v);
<a name="l00834"></a>00834 
<a name="l00835"></a>00835   <span class="comment">// Right now we only want one copy of the output</span>
<a name="l00836"></a>00836   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00837"></a>00837     <span class="keywordflow">return</span>;
<a name="l00838"></a>00838 
<a name="l00839"></a>00839   os &lt;&lt; <span class="stringliteral">&quot;Size\tglobal =  &quot;</span> &lt;&lt; this-&gt;size() &lt;&lt; std::endl;
<a name="l00840"></a>00840   os &lt;&lt; <span class="stringliteral">&quot;#\tValue&quot;</span> &lt;&lt; std::endl;
<a name="l00841"></a>00841   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i!=v.size(); i++)
<a name="l00842"></a>00842     os &lt;&lt; i &lt;&lt; <span class="stringliteral">&quot;\t&quot;</span> &lt;&lt; v[i] &lt;&lt; std::endl;
<a name="l00843"></a>00843 }
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 
<a name="l00846"></a>00846 
<a name="l00847"></a>00847 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00848"></a>00848 <span class="keyword">inline</span>
<a name="l00849"></a><a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">00849</a> <span class="keywordtype">void</span>  <a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">NumericVector&lt;T&gt;::swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;v)
<a name="l00850"></a>00850 {
<a name="l00851"></a>00851   std::swap(_is_closed, v.<a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a>);
<a name="l00852"></a>00852   std::swap(<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>, v.<a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a>);
<a name="l00853"></a>00853   std::swap(_type, v.<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a>);
<a name="l00854"></a>00854 }
<a name="l00855"></a>00855 
<a name="l00856"></a>00856 
<a name="l00857"></a>00857 } <span class="comment">// namespace libMesh</span>
<a name="l00858"></a>00858 
<a name="l00859"></a>00859 
<a name="l00860"></a>00860 <span class="preprocessor">#endif  // #ifdef __numeric_vector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
