<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">o_f_stream.C</div>  </div>
</div>
<div class="contents">
<a href="o__f__stream_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: o_f_stream.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="o__f__stream_8h.php">o_f_stream.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">/*</span>
<a name="l00029"></a>00029 <span class="comment"> * This class is only alive when iostream is broken</span>
<a name="l00030"></a>00030 <span class="comment"> */</span>
<a name="l00031"></a>00031 <span class="preprocessor">#ifdef LIBMESH_BROKEN_IOSTREAM</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// the template for reals</span>
<a name="l00039"></a>00039 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00040"></a><a class="code" href="classlibMesh_1_1OFStream.php#a1e706d37ac0596526753bd1d7c4faef7">00040</a> <a class="code" href="classlibMesh_1_1OFStream.php">OFStream</a>&amp; <a class="code" href="classlibMesh_1_1OFStream.php#a1e706d37ac0596526753bd1d7c4faef7">OFStream::scientific</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OFStream.php#a35a29a32ff98c9f721b36072243f2585">sizetype</a> w,
<a name="l00041"></a>00041                                 <span class="keyword">const</span> T r)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   libmesh_assert (w &lt; 30);
<a name="l00044"></a>00044   <span class="keywordtype">char</span> buf[30];  
<a name="l00045"></a>00045   <span class="keywordtype">char</span> format[8];
<a name="l00046"></a>00046   <span class="comment">// form the format for r</span>
<a name="l00047"></a>00047   sprintf (format, <span class="stringliteral">&quot;%%%de&quot;</span>, w);
<a name="l00048"></a>00048   <span class="comment">// form string as desired</span>
<a name="l00049"></a>00049   sprintf (buf, format, r);
<a name="l00050"></a>00050   *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00051"></a>00051   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="comment">// full specialization in case of complex numbers</span>
<a name="l00057"></a>00057 <span class="preprocessor">#if defined(LIBMESH_USE_COMPLEX_NUMBERS) </span>
<a name="l00058"></a>00058 <span class="preprocessor"></span>
<a name="l00059"></a>00059 <span class="keyword">template</span> &lt;&gt;
<a name="l00060"></a><a class="code" href="classlibMesh_1_1OFStream.php#ae3a576b3894b4d4c2951b674d2573b5b">00060</a> <a class="code" href="classlibMesh_1_1OFStream.php">OFStream</a>&amp; <a class="code" href="classlibMesh_1_1OFStream.php#a1e706d37ac0596526753bd1d7c4faef7">OFStream::scientific</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OFStream.php#a35a29a32ff98c9f721b36072243f2585">sizetype</a> w,
<a name="l00061"></a>00061                                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a> r)
<a name="l00062"></a>00062 {
<a name="l00063"></a>00063   libmesh_assert (w &lt; 30);
<a name="l00064"></a>00064   <span class="keywordtype">char</span> buf[60];  
<a name="l00065"></a>00065   <span class="keywordtype">char</span> format[16];
<a name="l00066"></a>00066   <span class="comment">// form the format for r</span>
<a name="l00067"></a>00067   sprintf (format, <span class="stringliteral">&quot;%%%de %%%de&quot;</span>, w, w);
<a name="l00068"></a>00068   <span class="comment">// form string as desired</span>
<a name="l00069"></a>00069   sprintf (buf, format, r.real(), r.imag());
<a name="l00070"></a>00070   *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00071"></a>00071   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="preprocessor">#endif // if defined(LIBMESH_USE_COMPLEX_NUMBERS) </span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a>00078 <span class="comment">//--------------------------------------------------------------</span>
<a name="l00079"></a>00079 <span class="comment">// Explicit instantiations for reals</span>
<a name="l00080"></a>00080 <span class="keyword">template</span> <a class="code" href="classlibMesh_1_1OFStream.php">OFStream</a>&amp; <a class="code" href="classlibMesh_1_1OFStream.php#a1e706d37ac0596526753bd1d7c4faef7">OFStream::scientific</a> (<span class="keyword">const</span> sizetype w,
<a name="l00081"></a>00081                                          <span class="keyword">const</span> <span class="keywordtype">double</span> r);
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="keyword">template</span> <a class="code" href="classlibMesh_1_1OFStream.php">OFStream</a>&amp; <a class="code" href="classlibMesh_1_1OFStream.php#a1e706d37ac0596526753bd1d7c4faef7">OFStream::scientific</a> (<span class="keyword">const</span> sizetype w,
<a name="l00084"></a>00084                                          <span class="keyword">const</span> <span class="keywordtype">float</span> r);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 } <span class="comment">// namespace libMesh</span>
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 <span class="preprocessor">#endif // ifdef LIBMESH_BROKEN_IOSTREAM</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
