<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">o_f_stream.h</div>  </div>
</div>
<div class="contents">
<a href="o__f__stream_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: o_f_stream.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __o_f_stream_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __o_f_stream_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;fstream&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local Includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">/*</span>
<a name="l00037"></a>00037 <span class="comment"> * Some compilers, at least HP \p aCC do not even</span>
<a name="l00038"></a>00038 <span class="comment"> * accept empty classes derived from \p std::ostringstream.</span>
<a name="l00039"></a>00039 <span class="comment"> * Therefore, resort to preprocessor definitions. </span>
<a name="l00040"></a>00040 <span class="comment"> */</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="preprocessor">#ifndef LIBMESH_BROKEN_IOSTREAM</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span> <span class="comment">/*</span>
<a name="l00044"></a>00044 <span class="comment">  * ---------------------------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">  * Everything for a clean iostream</span>
<a name="l00046"></a>00046 <span class="comment">  */</span>
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="preprocessor"># include &lt;iomanip&gt;</span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050  <span class="comment">/*</span>
<a name="l00051"></a>00051 <span class="comment">  * Outputs \p Real \p d  with width</span>
<a name="l00052"></a>00052 <span class="comment">  * \p v in scientific format to stream \p o.</span>
<a name="l00053"></a>00053 <span class="comment">  */</span>
<a name="l00054"></a>00054 <span class="preprocessor"># define OFSRealscientific(o,v,d)       (o) &lt;&lt; std::setprecision(v) &lt;&lt; std::scientific &lt;&lt; (d)</span>
<a name="l00055"></a>00055 <span class="preprocessor"></span>
<a name="l00056"></a>00056  <span class="comment">/*</span>
<a name="l00057"></a>00057 <span class="comment">  * Outputs \p Number \p d, (note that \p Number</span>
<a name="l00058"></a>00058 <span class="comment">  * may be either real or complex) with width</span>
<a name="l00059"></a>00059 <span class="comment">  * \p v in scientific format to stream \p o.</span>
<a name="l00060"></a>00060 <span class="comment">  */</span>
<a name="l00061"></a>00061 <span class="preprocessor"># if defined(LIBMESH_USE_COMPLEX_NUMBERS) </span>
<a name="l00062"></a>00062 <span class="preprocessor"></span><span class="preprocessor">#  define OFSNumberscientific(o,v,d)    (o) &lt;&lt; std::setprecision(v) &lt;&lt; std::scientific &lt;&lt; (d).real() &lt;&lt; &quot; &quot; \</span>
<a name="l00063"></a>00063 <span class="preprocessor">                                            &lt;&lt; std::setprecision(v) &lt;&lt; std::scientific &lt;&lt; (d).imag()</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span><span class="preprocessor"># else</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span><span class="preprocessor">#  define OFSNumberscientific(o,v,d)    (o) &lt;&lt; std::setprecision(v) &lt;&lt; std::scientific &lt;&lt; (d)</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span><span class="preprocessor"># endif</span>
<a name="l00067"></a>00067 <span class="preprocessor"></span>
<a name="l00068"></a>00068  <span class="comment">/*</span>
<a name="l00069"></a>00069 <span class="comment">  * class alias</span>
<a name="l00070"></a>00070 <span class="comment">  */</span>
<a name="l00071"></a>00071 <span class="preprocessor"># define OFStream                    std::ofstream</span>
<a name="l00072"></a>00072 <span class="preprocessor"></span>
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="preprocessor">#else</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span> <span class="comment">/*</span>
<a name="l00076"></a>00076 <span class="comment">  * ---------------------------------------------------------------------------------</span>
<a name="l00077"></a>00077 <span class="comment">  * Everything for broken iostream</span>
<a name="l00078"></a>00078 <span class="comment">  */</span>
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor"># include &lt;cstdio&gt;</span>
<a name="l00081"></a>00081 
<a name="l00082"></a>00082  <span class="comment">/*</span>
<a name="l00083"></a>00083 <span class="comment">  * Outputs \p Real \p d with width </span>
<a name="l00084"></a>00084 <span class="comment">  * \p v in scientific format to stream \p o.</span>
<a name="l00085"></a>00085 <span class="comment">  */</span>
<a name="l00086"></a>00086 <span class="preprocessor"># define OFSRealscientific(o,v,d)       (o).scientific( (v), (d) )</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>
<a name="l00088"></a>00088  <span class="comment">/*</span>
<a name="l00089"></a>00089 <span class="comment">  * Outputs \p Number \p d, (note that \p Number</span>
<a name="l00090"></a>00090 <span class="comment">  * may be either real or complex) with width</span>
<a name="l00091"></a>00091 <span class="comment">  * \p v in scientific format to stream \p o.</span>
<a name="l00092"></a>00092 <span class="comment">  */</span>
<a name="l00093"></a>00093 <span class="preprocessor"># define OFSNumberscientific(o,v,d)     (o).scientific( (v), (d) )</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span>
<a name="l00095"></a>00095 <span class="comment">//  /*</span>
<a name="l00096"></a>00096 <span class="comment">//   * class alias</span>
<a name="l00097"></a>00097 <span class="comment">//   */</span>
<a name="l00098"></a>00098 <span class="comment">// # define OFSOFStream                    OFStream</span>
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 <span class="keyword">namespace </span>libMesh
<a name="l00102"></a>00102 {
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 
<a name="l00111"></a>00111  <span class="comment">// ------------------------------------------------------------</span>
<a name="l00112"></a>00112  <span class="comment">// OFStream class definition</span>
<a name="l00113"></a><a class="code" href="classlibMesh_1_1OFStream.php">00113</a>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1OFStream.php">OFStream</a> : <span class="keyword">public</span> std::ofstream
<a name="l00114"></a>00114  {
<a name="l00115"></a>00115  <span class="keyword">public</span>:
<a name="l00116"></a>00116 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1OFStream.php#ab6e90c23eedd26c7b5d409498bce0486">00120</a>   <a class="code" href="classlibMesh_1_1OFStream.php#ab6e90c23eedd26c7b5d409498bce0486">OFStream</a> () {};
<a name="l00121"></a>00121 
<a name="l00125"></a><a class="code" href="classlibMesh_1_1OFStream.php#a3d6287d74d28a4a01325a3901e4c94c9">00125</a>   <a class="code" href="classlibMesh_1_1OFStream.php#a3d6287d74d28a4a01325a3901e4c94c9">~OFStream</a> () {};
<a name="l00126"></a>00126 
<a name="l00130"></a>00130   <span class="keyword">typedef</span> std::string::size_type <a class="code" href="classlibMesh_1_1OFStream.php#a35a29a32ff98c9f721b36072243f2585">sizetype</a>;
<a name="l00131"></a>00131 
<a name="l00137"></a>00137   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00138"></a>00138   <a class="code" href="classlibMesh_1_1OFStream.php">OFStream</a>&amp; <a class="code" href="classlibMesh_1_1OFStream.php#a1e706d37ac0596526753bd1d7c4faef7">scientific</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OFStream.php#a35a29a32ff98c9f721b36072243f2585">sizetype</a> w,
<a name="l00139"></a>00139                         <span class="keyword">const</span> T r);
<a name="l00140"></a>00140 
<a name="l00141"></a>00141  };
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 } <span class="comment">// namespace libMesh</span>
<a name="l00145"></a>00145 
<a name="l00146"></a>00146  <span class="comment">// ------------------------------------------------------------</span>
<a name="l00147"></a>00147  <span class="comment">// OFStream inline methods</span>
<a name="l00148"></a>00148  
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="preprocessor">#endif // ifndef ... else ... LIBMESH_BROKEN_IOSTREAM</span>
<a name="l00151"></a>00151 <span class="preprocessor"></span>
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="preprocessor">#endif // ifndef __o_f_stream_h__</span>
<a name="l00155"></a>00155 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
