<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">o_string_stream.h</div>  </div>
</div>
<div class="contents">
<a href="o__string__stream_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: o_string_stream.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __o_string_stream_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __o_string_stream_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Mesh configuration options</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#ifdef LIBMESH_HAVE_SSTREAM</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="comment">// C++ includes</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &lt;sstream&gt;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Local Includes</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Forward Declarations</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">/*</span>
<a name="l00046"></a>00046 <span class="comment"> * Some compilers, at least HP \p aCC do not even</span>
<a name="l00047"></a>00047 <span class="comment"> * accept empty classes derived from \p std::ostringstream.</span>
<a name="l00048"></a>00048 <span class="comment"> * Therefore, resort to preprocessor definitions. </span>
<a name="l00049"></a>00049 <span class="comment"> */</span>
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="preprocessor">#ifndef LIBMESH_BROKEN_IOSTREAM</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span> <span class="comment">/*</span>
<a name="l00053"></a>00053 <span class="comment">  * ---------------------------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">  * Everything for a clean iostream</span>
<a name="l00055"></a>00055 <span class="comment">  */</span>
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 <span class="preprocessor"># include &lt;iomanip&gt;</span>
<a name="l00058"></a>00058 
<a name="l00059"></a>00059  <span class="comment">/*</span>
<a name="l00060"></a>00060 <span class="comment">  * Outputs \p std::string \p d with width </span>
<a name="l00061"></a>00061 <span class="comment">  * \p v left-formatted to stream \p o.</span>
<a name="l00062"></a>00062 <span class="comment">  */</span>
<a name="l00063"></a>00063 <span class="preprocessor"># define OSSStringleft(o,v,d)       (o).width(v);  (o) &lt;&lt; std::left &lt;&lt; (d)</span>
<a name="l00064"></a>00064 <span class="preprocessor"></span>
<a name="l00065"></a>00065  <span class="comment">/*</span>
<a name="l00066"></a>00066 <span class="comment">  * Outputs \p std::string \p d with width </span>
<a name="l00067"></a>00067 <span class="comment">  * \p v right-formatted to stream \p o.</span>
<a name="l00068"></a>00068 <span class="comment">  */</span>
<a name="l00069"></a>00069 <span class="preprocessor"># define OSSStringright(o,v,d)      (o).width(v);  (o) &lt;&lt; std::right &lt;&lt; (d)</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>
<a name="l00071"></a>00071  <span class="comment">/*</span>
<a name="l00072"></a>00072 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00073"></a>00073 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00074"></a>00074 <span class="comment">  * whitespaces).</span>
<a name="l00075"></a>00075 <span class="comment">  */</span>
<a name="l00076"></a>00076 <span class="preprocessor"># define OSSRealleft(o,v,p,d)       (o).width(v);  (o).precision(p); (o).fill(&#39; &#39;); (o) &lt;&lt; (d)</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>
<a name="l00078"></a>00078  <span class="comment">/*</span>
<a name="l00079"></a>00079 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00080"></a>00080 <span class="comment">  * precision \p p to stream \p o (padded with </span>
<a name="l00081"></a>00081 <span class="comment">  * zeros).</span>
<a name="l00082"></a>00082 <span class="comment">  */</span>
<a name="l00083"></a>00083 <span class="preprocessor"># define OSSRealzeroleft(o,v,p,d)   (o).width(v); (o).precision(p); (o).fill(&#39;0&#39;); (o) &lt;&lt; std::showpoint &lt;&lt; std::left &lt;&lt; (d)</span>
<a name="l00084"></a>00084 <span class="preprocessor"></span>
<a name="l00085"></a>00085  <span class="comment">/*</span>
<a name="l00086"></a>00086 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00087"></a>00087 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00088"></a>00088 <span class="comment">  * whitespaces).</span>
<a name="l00089"></a>00089 <span class="comment">  */</span>
<a name="l00090"></a>00090 <span class="preprocessor"># define OSSRealright(o,v,p,d)       (o).width(v);  (o).precision(p); (o).fill(&#39; &#39;); (o) &lt;&lt; std::right &lt;&lt; (d)</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span>
<a name="l00092"></a>00092  <span class="comment">/*</span>
<a name="l00093"></a>00093 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00094"></a>00094 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00095"></a>00095 <span class="comment">  * zeros).</span>
<a name="l00096"></a>00096 <span class="comment">  */</span>
<a name="l00097"></a>00097 <span class="preprocessor"># define OSSRealzeroright(o,v,p,d)   (o).width(v);  (o).precision(p); (o).fill(&#39;0&#39;); (o) &lt;&lt; std::right &lt;&lt; (d) </span>
<a name="l00098"></a>00098 <span class="preprocessor"></span>
<a name="l00099"></a>00099  <span class="comment">/*</span>
<a name="l00100"></a>00100 <span class="comment">  * Outputs \p Real \p d with width \p v</span>
<a name="l00101"></a>00101 <span class="comment">  * in scientific format to stream \p o.</span>
<a name="l00102"></a>00102 <span class="comment">  */</span>
<a name="l00103"></a>00103 <span class="preprocessor"># define OSSRealscientific(o,v,d)   (o) &lt;&lt; std::setw(v) &lt;&lt; std::scientific &lt;&lt; (d)</span>
<a name="l00104"></a>00104 <span class="preprocessor"></span>
<a name="l00105"></a>00105  <span class="comment">/*</span>
<a name="l00106"></a>00106 <span class="comment">  * Outputs \p int \p d with width </span>
<a name="l00107"></a>00107 <span class="comment">  * \p v to stream \p o.</span>
<a name="l00108"></a>00108 <span class="comment">  */</span>
<a name="l00109"></a>00109 <span class="preprocessor"># define OSSInt(o,v,d)              (o).width(v);  (o) &lt;&lt; (d)</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>
<a name="l00111"></a>00111  <span class="comment">/*</span>
<a name="l00112"></a>00112 <span class="comment">  * class alias</span>
<a name="l00113"></a>00113 <span class="comment">  */</span>
<a name="l00114"></a>00114 <span class="comment">//# define OStringStream           std::ostringstream</span>
<a name="l00115"></a><a class="code" href="o__string__stream_8h.php#a404e79e210a38d985b3bfdab1e496280">00115</a> <span class="keyword">typedef</span> std::ostringstream <a class="code" href="o__string__stream_8h.php#a404e79e210a38d985b3bfdab1e496280">OStringStream</a>;
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="preprocessor">#else</span>
<a name="l00121"></a>00121 <span class="preprocessor"></span> <span class="comment">/*</span>
<a name="l00122"></a>00122 <span class="comment">  * ---------------------------------------------------------------------------------</span>
<a name="l00123"></a>00123 <span class="comment">  * Everything for broken iostream</span>
<a name="l00124"></a>00124 <span class="comment">  */</span>
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 <span class="preprocessor"># include &lt;cstdio&gt;</span>
<a name="l00127"></a>00127 
<a name="l00128"></a>00128  <span class="comment">/*</span>
<a name="l00129"></a>00129 <span class="comment">  * Outputs \p std::string \p d with width </span>
<a name="l00130"></a>00130 <span class="comment">  * \p v left-formatted to stream \p o.</span>
<a name="l00131"></a>00131 <span class="comment">  */</span>
<a name="l00132"></a>00132 <span class="preprocessor"># define OSSStringleft(o,v,d)       (o).left( (v), (d) )</span>
<a name="l00133"></a>00133 <span class="preprocessor"></span>
<a name="l00134"></a>00134  <span class="comment">/*</span>
<a name="l00135"></a>00135 <span class="comment">  * Outputs \p std::string \p d with width </span>
<a name="l00136"></a>00136 <span class="comment">  * \p v right-formatted to stream \p o.</span>
<a name="l00137"></a>00137 <span class="comment">  */</span>
<a name="l00138"></a>00138 <span class="preprocessor"># define OSSStringright(o,v,d)      (o).right( (v), (d) )</span>
<a name="l00139"></a>00139 <span class="preprocessor"></span>
<a name="l00140"></a>00140  <span class="comment">/*</span>
<a name="l00141"></a>00141 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00142"></a>00142 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00143"></a>00143 <span class="comment">  * whitespaces).</span>
<a name="l00144"></a>00144 <span class="comment">  */</span>
<a name="l00145"></a>00145 <span class="preprocessor"># define OSSRealleft(o,v,p,d)       (o).left( (v), (p), (d) , &#39; &#39;)</span>
<a name="l00146"></a>00146 <span class="preprocessor"></span>
<a name="l00147"></a>00147  <span class="comment">/*</span>
<a name="l00148"></a>00148 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00149"></a>00149 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00150"></a>00150 <span class="comment">  * zeros).</span>
<a name="l00151"></a>00151 <span class="comment">  */</span>
<a name="l00152"></a>00152 <span class="preprocessor"># define OSSRealzeroleft(o,v,p,d)       (o).left( (v), (p), (d) , &#39;0&#39;)</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>
<a name="l00154"></a>00154  <span class="comment">/*</span>
<a name="l00155"></a>00155 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00156"></a>00156 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00157"></a>00157 <span class="comment">  * whitespaces).</span>
<a name="l00158"></a>00158 <span class="comment">  */</span>
<a name="l00159"></a>00159 <span class="preprocessor"># define OSSRealright(o,v,p,d)      (o).right( (v), (p), (d) ,&#39; &#39;) </span>
<a name="l00160"></a>00160 <span class="preprocessor"></span>
<a name="l00161"></a>00161  <span class="comment">/*</span>
<a name="l00162"></a>00162 <span class="comment">  * Outputs \p Real \p d with width \p v and</span>
<a name="l00163"></a>00163 <span class="comment">  * precision \p p to stream \p o (padded with</span>
<a name="l00164"></a>00164 <span class="comment">  * zeros).</span>
<a name="l00165"></a>00165 <span class="comment">  */</span>
<a name="l00166"></a>00166 <span class="preprocessor"># define OSSRealzeroright(o,v,p,d)      (o).right( (v), (p), (d) ,&#39;0&#39;) </span>
<a name="l00167"></a>00167 <span class="preprocessor"></span>
<a name="l00168"></a>00168  <span class="comment">/*</span>
<a name="l00169"></a>00169 <span class="comment">  * Outputs \p Real \p d with width \p v</span>
<a name="l00170"></a>00170 <span class="comment">  * in scientific format to stream \p o.</span>
<a name="l00171"></a>00171 <span class="comment">  */</span>
<a name="l00172"></a>00172 <span class="preprocessor"># define OSSRealscientific(o,v,d)   (o).scientific( (v), (d) )</span>
<a name="l00173"></a>00173 <span class="preprocessor"></span>
<a name="l00174"></a>00174  <span class="comment">/*</span>
<a name="l00175"></a>00175 <span class="comment">  * Outputs \p int \p d with width </span>
<a name="l00176"></a>00176 <span class="comment">  * \p v to stream \p o.</span>
<a name="l00177"></a>00177 <span class="comment">  */</span>
<a name="l00178"></a>00178 <span class="preprocessor"># define OSSInt(o,v,d)              (o).left( (v), (d) )</span>
<a name="l00179"></a>00179 <span class="preprocessor"></span>
<a name="l00180"></a>00180 <span class="comment">//  /*</span>
<a name="l00181"></a>00181 <span class="comment">//   * class alias</span>
<a name="l00182"></a>00182 <span class="comment">//   */</span>
<a name="l00183"></a>00183 <span class="comment">// # define OSSOStringStream           OStringStream</span>
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="keyword">namespace </span>libMesh
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00196"></a>00196  <span class="comment">// ------------------------------------------------------------</span>
<a name="l00197"></a>00197  <span class="comment">// OStringStream class definition</span>
<a name="l00198"></a><a class="code" href="classlibMesh_1_1OStringStream.php">00198</a>  <span class="keyword">class </span><a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> : <span class="keyword">public</span> std::ostringstream
<a name="l00199"></a>00199  {
<a name="l00200"></a>00200  <span class="keyword">public</span>:
<a name="l00201"></a>00201 
<a name="l00205"></a><a class="code" href="classlibMesh_1_1OStringStream.php#a916209a0781692b31998bc5830945ca3">00205</a>   <a class="code" href="classlibMesh_1_1OStringStream.php#a916209a0781692b31998bc5830945ca3">OStringStream</a> () : std::ostringstream() {};
<a name="l00206"></a>00206 
<a name="l00210"></a><a class="code" href="classlibMesh_1_1OStringStream.php#adf3d01f11244f3e1211a4db949ca282d">00210</a>   <a class="code" href="classlibMesh_1_1OStringStream.php#adf3d01f11244f3e1211a4db949ca282d">~OStringStream</a> () {};
<a name="l00211"></a>00211 
<a name="l00215"></a>00215   <span class="keyword">typedef</span> std::string::size_type <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a>;
<a name="l00216"></a>00216 
<a name="l00222"></a>00222   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a112ef70a0c0a741d6ffc5620771d4139">left</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00223"></a>00223              <span class="keyword">const</span> std::string&amp; s);
<a name="l00224"></a>00224 
<a name="l00230"></a>00230   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a112ef70a0c0a741d6ffc5620771d4139">left</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00231"></a>00231              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> prec,
<a name="l00232"></a>00232              <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r,
<a name="l00233"></a>00233              <span class="keyword">const</span> <span class="keywordtype">char</span> c = <span class="charliteral">&#39; &#39;</span>);
<a name="l00234"></a>00234 
<a name="l00241"></a>00241   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a112ef70a0c0a741d6ffc5620771d4139">left</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00242"></a>00242              <span class="keyword">const</span> <span class="keywordtype">int</span> n);
<a name="l00243"></a>00243 
<a name="l00249"></a>00249   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a2b98f49cae2aa61552e696d712d61d22">right</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00250"></a>00250               <span class="keyword">const</span> std::string&amp; s);
<a name="l00251"></a>00251 
<a name="l00252"></a>00252 
<a name="l00259"></a>00259   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a2b98f49cae2aa61552e696d712d61d22">right</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00260"></a>00260               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> prec,
<a name="l00261"></a>00261               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r,
<a name="l00262"></a>00262               <span class="keyword">const</span> <span class="keywordtype">char</span> c = <span class="charliteral">&#39; &#39;</span>);
<a name="l00263"></a>00263 
<a name="l00269"></a>00269   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a5509b8c85848b43e2ad704defe31ce84">scientific</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00270"></a>00270                    <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r);
<a name="l00271"></a>00271 
<a name="l00272"></a>00272  <span class="keyword">protected</span>:
<a name="l00277"></a>00277   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a324cde7c0f49a042f5b58c2baf18228e">print_ws</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> n,
<a name="l00278"></a>00278                  <span class="keyword">const</span> <span class="keywordtype">char</span> c = <span class="charliteral">&#39; &#39;</span>);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280  };
<a name="l00281"></a>00281 
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284  <span class="comment">// ------------------------------------------------------------</span>
<a name="l00285"></a>00285  <span class="comment">// OStringStream inline methods</span>
<a name="l00286"></a>00286  <span class="keyword">inline</span>
<a name="l00287"></a><a class="code" href="classlibMesh_1_1OStringStream.php#a112ef70a0c0a741d6ffc5620771d4139">00287</a>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a112ef70a0c0a741d6ffc5620771d4139">OStringStream::left</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00288"></a>00288                            <span class="keyword">const</span> std::string&amp; s)
<a name="l00289"></a>00289  {
<a name="l00290"></a>00290    *<span class="keyword">this</span> &lt;&lt; s;
<a name="l00291"></a>00291    <span class="comment">// pad with whitespaces afterwards</span>
<a name="l00292"></a>00292    <a class="code" href="classlibMesh_1_1OStringStream.php#a324cde7c0f49a042f5b58c2baf18228e">print_ws</a> ((w-s.size()));
<a name="l00293"></a>00293  }
<a name="l00294"></a>00294 
<a name="l00295"></a>00295 
<a name="l00296"></a>00296  <span class="keyword">inline</span>
<a name="l00297"></a><a class="code" href="classlibMesh_1_1OStringStream.php#a257a9f7ebd3b1bf12fd0f3bb9c72ae91">00297</a>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a112ef70a0c0a741d6ffc5620771d4139">OStringStream::left</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00298"></a>00298                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> prec,
<a name="l00299"></a>00299                            <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r,
<a name="l00300"></a>00300                            <span class="keyword">const</span> <span class="keywordtype">char</span> c)
<a name="l00301"></a>00301  {
<a name="l00302"></a>00302    libmesh_assert (w &lt; 30);
<a name="l00303"></a>00303    <span class="keywordtype">char</span> buf[30];  
<a name="l00304"></a>00304    <span class="keywordtype">char</span> format[8];
<a name="l00305"></a>00305    <span class="comment">// form the format for r</span>
<a name="l00306"></a>00306    <span class="comment">// ALTERNATIVE: sprintf (format, &quot;%%%d.%df&quot;, int((w-prec)/2), prec);</span>
<a name="l00307"></a>00307    sprintf (format, <span class="stringliteral">&quot;%%.%df&quot;</span>, prec);
<a name="l00308"></a>00308    <span class="comment">// form string as desired</span>
<a name="l00309"></a>00309    sprintf (buf, format, r);
<a name="l00310"></a>00310    *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00311"></a>00311    <span class="comment">// pad with whitespaces afterwards</span>
<a name="l00312"></a>00312    <a class="code" href="classlibMesh_1_1OStringStream.php#a324cde7c0f49a042f5b58c2baf18228e">print_ws</a> (w-std::string(buf).size(), c);
<a name="l00313"></a>00313    <span class="comment">// ALTERNATIVE: print_ws (w-int((w-prec)/2));</span>
<a name="l00314"></a>00314  }
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317  <span class="keyword">inline</span>
<a name="l00318"></a><a class="code" href="classlibMesh_1_1OStringStream.php#aafebdaa12e33ca29e64042ce6b5c9f62">00318</a>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a112ef70a0c0a741d6ffc5620771d4139">OStringStream::left</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00319"></a>00319                            <span class="keyword">const</span> <span class="keywordtype">int</span> n)
<a name="l00320"></a>00320  {
<a name="l00321"></a>00321    libmesh_assert (w &lt; 30);
<a name="l00322"></a>00322    <span class="keywordtype">char</span> buf[30];  
<a name="l00323"></a>00323    <span class="comment">// form string as desired</span>
<a name="l00324"></a>00324    sprintf (buf, <span class="stringliteral">&quot;%d&quot;</span>, n);
<a name="l00325"></a>00325    *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00326"></a>00326    <span class="comment">// pad with whitespaces afterwards</span>
<a name="l00327"></a>00327    <a class="code" href="classlibMesh_1_1OStringStream.php#a324cde7c0f49a042f5b58c2baf18228e">print_ws</a> (w-std::string(buf).size());
<a name="l00328"></a>00328  }
<a name="l00329"></a>00329 
<a name="l00330"></a>00330 
<a name="l00331"></a>00331  <span class="keyword">inline</span>
<a name="l00332"></a><a class="code" href="classlibMesh_1_1OStringStream.php#a2b98f49cae2aa61552e696d712d61d22">00332</a>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a2b98f49cae2aa61552e696d712d61d22">OStringStream::right</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00333"></a>00333                             <span class="keyword">const</span> std::string&amp; s)
<a name="l00334"></a>00334  {
<a name="l00335"></a>00335    <span class="comment">// first pad with whitespaces</span>
<a name="l00336"></a>00336    <a class="code" href="classlibMesh_1_1OStringStream.php#a324cde7c0f49a042f5b58c2baf18228e">print_ws</a> ((w-s.size()));
<a name="l00337"></a>00337    *<span class="keyword">this</span> &lt;&lt; s;
<a name="l00338"></a>00338  }
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341  <span class="keyword">inline</span>
<a name="l00342"></a><a class="code" href="classlibMesh_1_1OStringStream.php#ac84af150c6e453f747ebf56789690513">00342</a>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a2b98f49cae2aa61552e696d712d61d22">OStringStream::right</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00343"></a>00343                             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> prec,
<a name="l00344"></a>00344                             <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r,
<a name="l00345"></a>00345                             <span class="keyword">const</span> <span class="keywordtype">char</span> c)
<a name="l00346"></a>00346  {
<a name="l00347"></a>00347    libmesh_assert (w &lt; 30);
<a name="l00348"></a>00348    <span class="keywordtype">char</span> buf[30];  
<a name="l00349"></a>00349    <span class="keywordtype">char</span> format[8];
<a name="l00350"></a>00350    <span class="comment">// form the format for r</span>
<a name="l00351"></a>00351    sprintf (format, <span class="stringliteral">&quot;%%.%df&quot;</span>, prec);
<a name="l00352"></a>00352    <span class="comment">// form string as desired</span>
<a name="l00353"></a>00353    sprintf (buf, format, r);
<a name="l00354"></a>00354    <span class="comment">// first pad with the user-defined char</span>
<a name="l00355"></a>00355    <a class="code" href="classlibMesh_1_1OStringStream.php#a324cde7c0f49a042f5b58c2baf18228e">print_ws</a> (w-std::string(buf).size(), c);
<a name="l00356"></a>00356    <span class="comment">// then print the float</span>
<a name="l00357"></a>00357    *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00358"></a>00358  }
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361  <span class="keyword">inline</span>
<a name="l00362"></a><a class="code" href="classlibMesh_1_1OStringStream.php#a5509b8c85848b43e2ad704defe31ce84">00362</a>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a5509b8c85848b43e2ad704defe31ce84">OStringStream::scientific</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> w,
<a name="l00363"></a>00363                                  <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> r)
<a name="l00364"></a>00364  {
<a name="l00365"></a>00365    libmesh_assert (w &lt; 30);
<a name="l00366"></a>00366    <span class="keywordtype">char</span> buf[30];  
<a name="l00367"></a>00367    <span class="keywordtype">char</span> format[8];
<a name="l00368"></a>00368    <span class="comment">// form the format for r</span>
<a name="l00369"></a>00369    sprintf (format, <span class="stringliteral">&quot;%%%de&quot;</span>, w);
<a name="l00370"></a>00370    <span class="comment">// form string as desired</span>
<a name="l00371"></a>00371    sprintf (buf, format, r);
<a name="l00372"></a>00372    *<span class="keyword">this</span> &lt;&lt; buf;
<a name="l00373"></a>00373  }
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376  <span class="keyword">inline</span>
<a name="l00377"></a><a class="code" href="classlibMesh_1_1OStringStream.php#a324cde7c0f49a042f5b58c2baf18228e">00377</a>  <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1OStringStream.php#a324cde7c0f49a042f5b58c2baf18228e">OStringStream::print_ws</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> n,
<a name="l00378"></a>00378                                <span class="keyword">const</span> <span class="keywordtype">char</span> c)
<a name="l00379"></a>00379  {
<a name="l00380"></a>00380    <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1OStringStream.php#ac2fb3119fe1a16d16f52003060932c6e">sizetype</a> i = 0; i &lt; n; i++)
<a name="l00381"></a>00381      *<span class="keyword">this</span> &lt;&lt; c;
<a name="l00382"></a>00382  }
<a name="l00383"></a>00383 
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 } <span class="comment">// namespace libMesh</span>
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 <span class="preprocessor">#endif // ifndef ... else ... LIBMESH_BROKEN_IOSTREAM</span>
<a name="l00388"></a>00388 <span class="preprocessor"></span>
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 <span class="preprocessor">#endif // ifdef LIBMESH_HAVE_SSTREAM</span>
<a name="l00393"></a>00393 <span class="preprocessor"></span>
<a name="l00394"></a>00394 <span class="preprocessor">#endif // ifndef __o_string_stream_h__</span>
<a name="l00395"></a>00395 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
