<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d4d34bb88452e16aa385991b3dad6a49.php">parallel</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel_bin_sorter.C</div>  </div>
</div>
<div class="contents">
<a href="parallel__bin__sorter_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_bin_sorter.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span>  <span class="comment">// std::lower_bound</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="parallel__bin__sorter_8h.php">parallel_bin_sorter.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="parallel__histogram_8h.php">parallel_histogram.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;hilbert.h&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#endif</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="parallel__conversion__utils_8h.php">parallel_conversion_utils.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a><a class="code" href="namespacelibMesh_1_1Parallel.php">00039</a> <span class="keyword">namespace </span>Parallel {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00042"></a><a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php#a61f70a1a7db0ae11a3003bda6bb0bca1">00042</a> <a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php#a61f70a1a7db0ae11a3003bda6bb0bca1">BinSorter&lt;KeyType&gt;::BinSorter</a> (<span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; d) :
<a name="l00043"></a>00043   data(d)
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   <span class="comment">// Assume (&amp; libmesh_assert) we are working with a sorted range</span>
<a name="l00046"></a>00046 
<a name="l00047"></a>00047   <span class="comment">// Ah...  is_sorted is an STL extension!</span>
<a name="l00048"></a>00048   <span class="comment">//libmesh_assert (std::is_sorted (data.begin(), data.end()));</span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   <span class="comment">// Home-grown is_sorted</span>
<a name="l00051"></a>00051   libmesh_assert (<a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#ac14800536403260c2b92f49bb859e694">Parallel::Utils::is_sorted</a> (<a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php#a4cb3a8657a3f5b78c7ab2436947e7484">data</a>));
<a name="l00052"></a>00052 }
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00057"></a><a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php#adcec209a8332a15c23c8ad9d34821238">00057</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php#adcec209a8332a15c23c8ad9d34821238">BinSorter&lt;KeyType&gt;::binsort</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nbins,
<a name="l00058"></a>00058                                   KeyType <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>,
<a name="l00059"></a>00059                                   KeyType <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>)
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061   libmesh_assert (min &lt; max);
<a name="l00062"></a>00062   
<a name="l00063"></a>00063   <span class="comment">// Build a histogram in parallel from our data.</span>
<a name="l00064"></a>00064   <span class="comment">// Use this to create quasi-uniform bins.</span>
<a name="l00065"></a>00065   <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php">Parallel::Histogram&lt;KeyType&gt;</a> phist (data);
<a name="l00066"></a>00066   phist.<a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a994c36f333866b4097d575a117c2ccea">make_histogram</a> (nbins*50, max, min);
<a name="l00067"></a>00067   phist.<a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#aa6686f5122770540c59681f949f55738">build_histogram</a> ();
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; histogram =
<a name="l00070"></a>00070     phist.<a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a213cb5442baefa77d3e05f8b46905650">get_histogram</a>();
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073   <span class="comment">// Now we will locate the bin boundaries so</span>
<a name="l00074"></a>00074   <span class="comment">// that each bin is roughly equal size</span>
<a name="l00075"></a>00075   {
<a name="l00076"></a>00076     <span class="comment">// Find the total size of the data set</span>
<a name="l00077"></a>00077     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_data_size = data.size();
<a name="l00078"></a>00078     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_data_size = local_data_size;
<a name="l00079"></a>00079 
<a name="l00080"></a>00080     <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(global_data_size);
<a name="l00081"></a>00081     
<a name="l00082"></a>00082     std::vector&lt;unsigned int&gt; target_bin_size (nbins, global_data_size / nbins);
<a name="l00083"></a>00083     
<a name="l00084"></a>00084     <span class="comment">// Equally distribute the remainder</span>
<a name="l00085"></a>00085     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;(global_data_size % nbins); i++)
<a name="l00086"></a>00086       ++target_bin_size[i];
<a name="l00087"></a>00087     
<a name="l00088"></a>00088     <span class="comment">// Set the iterators corresponding to the bin boundaries</span>
<a name="l00089"></a>00089     {
<a name="l00090"></a>00090       std::vector&lt;double&gt; bin_bounds (nbins+1);
<a name="l00091"></a>00091       bin_iters.resize  (nbins+1, data.begin());
<a name="l00092"></a>00092       
<a name="l00093"></a>00093       <span class="comment">// Set the minimum bin boundary iterator</span>
<a name="l00094"></a>00094       bin_iters[0]  = data.begin();
<a name="l00095"></a>00095       bin_bounds[0] = <a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a2490ebac6962550ed7426f3fa879284d">Parallel::Utils::to_double</a>(min);
<a name="l00096"></a>00096       
<a name="l00097"></a>00097       <span class="comment">// The current location in the histogram</span>
<a name="l00098"></a>00098       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_histogram_bin = 0;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100       <span class="comment">// How much above (+) or below (-) we are from the</span>
<a name="l00101"></a>00101       <span class="comment">// target size for the last bin.</span>
<a name="l00102"></a>00102       <span class="comment">// Note that when delta is (-) we will</span>
<a name="l00103"></a>00103       <span class="comment">// accept a slightly larger size for the next bin,</span>
<a name="l00104"></a>00104       <span class="comment">// the goal being to keep the whole mess average</span>
<a name="l00105"></a>00105       <span class="keywordtype">int</span> delta = 0;
<a name="l00106"></a>00106       
<a name="l00107"></a>00107       <span class="comment">// Set the internal bin boundary iterators</span>
<a name="l00108"></a>00108       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> b=0; b&lt;nbins; ++b)
<a name="l00109"></a>00109         {
<a name="l00110"></a>00110           <span class="comment">// The size of bin b.  We want this to</span>
<a name="l00111"></a>00111           <span class="comment">// be ~= target_bin_size[b]</span>
<a name="l00112"></a>00112           <span class="keywordtype">int</span> current_bin_size = 0;
<a name="l00113"></a>00113           
<a name="l00114"></a>00114           <span class="comment">// Step through the histogram until we have the</span>
<a name="l00115"></a>00115           <span class="comment">// desired bin size     </span>
<a name="l00116"></a>00116           <span class="keywordflow">while</span> ((current_bin_size + histogram[current_histogram_bin] + delta) &lt;= target_bin_size[b])
<a name="l00117"></a>00117             {
<a name="l00118"></a>00118               <span class="comment">// Don&#39;t index out of the histogram!</span>
<a name="l00119"></a>00119               <span class="keywordflow">if</span> ((current_histogram_bin+1) == phist.<a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a2fe71ddbfdbcba67c67f13523f85acdc">n_bins</a>())
<a name="l00120"></a>00120                 <span class="keywordflow">break</span>;
<a name="l00121"></a>00121               
<a name="l00122"></a>00122               current_bin_size += histogram[current_histogram_bin++];
<a name="l00123"></a>00123             }
<a name="l00124"></a>00124           
<a name="l00125"></a>00125           delta += current_bin_size - target_bin_size[b];
<a name="l00126"></a>00126           
<a name="l00127"></a>00127           <span class="comment">// Set the upper bound of the bin</span>
<a name="l00128"></a>00128           bin_bounds[b+1] = phist.<a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#aa6550f0126cd8314c734db10f83ee7fc">upper_bound</a> (current_histogram_bin);    
<a name="l00129"></a>00129           bin_iters[b+1]  = std::lower_bound(bin_iters[b], data.end(), 
<a name="l00130"></a>00130                                              Parallel::Utils::to_key_type&lt;KeyType&gt;(bin_bounds[b+1]));
<a name="l00131"></a>00131         }
<a name="l00132"></a>00132 
<a name="l00133"></a>00133       <span class="comment">// Just be sure the last boundaries point to the right place</span>
<a name="l00134"></a>00134       bin_iters[nbins]  = data.end();
<a name="l00135"></a>00135       bin_bounds[nbins] = <a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a2490ebac6962550ed7426f3fa879284d">Parallel::Utils::to_double</a>(max);
<a name="l00136"></a>00136     }
<a name="l00137"></a>00137   }
<a name="l00138"></a>00138 }
<a name="l00139"></a>00139   
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="comment">// Explicitly instantiate for int, double</span>
<a name="l00144"></a>00144 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php">Parallel::BinSorter&lt;int&gt;</a>;
<a name="l00145"></a>00145 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php">Parallel::BinSorter&lt;double&gt;</a>;
<a name="l00146"></a>00146 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php">Parallel::BinSorter&lt;Hilbert::HilbertIndices&gt;</a>;
<a name="l00148"></a>00148 <span class="preprocessor">#endif</span>
<a name="l00149"></a>00149 <span class="preprocessor"></span>
<a name="l00150"></a>00150 } <span class="comment">// namespace libMesh</span>
<a name="l00151"></a>00151 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
