<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bdae1604989e5516f706b95b493c360.php">parallel</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel_conversion_utils.h</div>  </div>
</div>
<div class="contents">
<a href="parallel__conversion__utils_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_conversion_utils.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __parallel_conversion_utils_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_conversion_utils_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00030"></a>00030 <span class="preprocessor"></span><span class="preprocessor">#include &quot;hilbert.h&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#endif</span>
<a name="l00032"></a>00032 <span class="preprocessor"></span>
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="keyword">namespace </span>Parallel {
<a name="l00040"></a><a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php">00040</a>   <span class="keyword">namespace </span>Utils {
<a name="l00041"></a>00041 
<a name="l00048"></a>00048     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00049"></a>00049       <span class="keyword">inline</span>
<a name="l00050"></a><a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#ac14800536403260c2b92f49bb859e694">00050</a>       <span class="keywordtype">bool</span> <a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#ac14800536403260c2b92f49bb859e694">is_sorted</a> (<span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; v)
<a name="l00051"></a>00051       {
<a name="l00052"></a>00052         <span class="keywordflow">if</span> (v.empty())
<a name="l00053"></a>00053           <span class="keywordflow">return</span> <span class="keyword">true</span>;
<a name="l00054"></a>00054 
<a name="l00055"></a>00055         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i&lt;v.size(); i++)
<a name="l00056"></a>00056           <span class="keywordflow">if</span> (v[i] &lt; v[i-1])
<a name="l00057"></a>00057             <span class="keywordflow">return</span> <span class="keyword">false</span>;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059         <span class="keywordflow">return</span> <span class="keyword">true</span>;    
<a name="l00060"></a>00060       }
<a name="l00061"></a>00061 
<a name="l00066"></a>00066     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00067"></a>00067       <span class="keyword">inline</span>
<a name="l00068"></a><a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a2490ebac6962550ed7426f3fa879284d">00068</a>       <span class="keywordtype">double</span> <a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a2490ebac6962550ed7426f3fa879284d">to_double</a> (<span class="keyword">const</span> KeyType &amp;k)
<a name="l00069"></a>00069       {
<a name="l00070"></a>00070         <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(k);
<a name="l00071"></a>00071       }
<a name="l00072"></a>00072 
<a name="l00079"></a>00079     <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00080"></a>00080       <span class="keyword">inline</span>
<a name="l00081"></a><a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#ac32fea0d432a27d36a1948c730bc8346">00081</a>       KeyType <a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#ac32fea0d432a27d36a1948c730bc8346">to_key_type</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> f)
<a name="l00082"></a>00082       {
<a name="l00083"></a>00083         <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>KeyType<span class="keyword">&gt;</span>(f);
<a name="l00084"></a>00084       }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00087"></a>00087 <span class="preprocessor"></span>
<a name="l00088"></a>00088     <span class="keyword">template</span> &lt;&gt;
<a name="l00089"></a>00089       <span class="keyword">inline</span>
<a name="l00090"></a><a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a1a55cf59f898b20621ad8e411f534f33">00090</a>       <span class="keywordtype">double</span> <a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a2490ebac6962550ed7426f3fa879284d">to_double</a> (<span class="keyword">const</span> Hilbert::HilbertIndices &amp;bvt)
<a name="l00091"></a>00091       {
<a name="l00092"></a>00092         <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(bvt.rack2);
<a name="l00093"></a>00093       }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095     <span class="keyword">template</span> &lt;&gt;
<a name="l00096"></a>00096       <span class="keyword">inline</span>
<a name="l00097"></a>00097       Hilbert::HilbertIndices 
<a name="l00098"></a><a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#a2d61fa9e4e775569e9a3a902175305a9">00098</a>       <a class="code" href="namespacelibMesh_1_1Parallel_1_1Utils.php#ac32fea0d432a27d36a1948c730bc8346">to_key_type</a> (<span class="keyword">const</span> <span class="keywordtype">double</span> f)
<a name="l00099"></a>00099       {
<a name="l00100"></a>00100         Hilbert::HilbertIndices bvt;
<a name="l00101"></a>00101 
<a name="l00102"></a>00102         bvt.rack0 = 0;
<a name="l00103"></a>00103         bvt.rack1 = 0;
<a name="l00104"></a>00104         bvt.rack2 = <span class="keyword">static_cast&lt;</span>Hilbert::inttype<span class="keyword">&gt;</span>(f);
<a name="l00105"></a>00105 
<a name="l00106"></a>00106         <span class="keywordflow">return</span> bvt;
<a name="l00107"></a>00107       }
<a name="l00108"></a>00108 <span class="preprocessor">#endif // LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00109"></a>00109 <span class="preprocessor"></span>  }
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 } <span class="comment">// namespace libMesh</span>
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 <span class="preprocessor">#endif // #define __parallel_conversion_utils_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
