<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bdae1604989e5516f706b95b493c360.php">parallel</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel_ghost_sync.h</div>  </div>
</div>
<div class="contents">
<a href="parallel__ghost__sync_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: parallel_ghost_sync.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __parallel_ghost_sync_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_ghost_sync_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="location__maps_8h.php">location_maps.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00040"></a>00040 <span class="keyword">namespace </span>Parallel {
<a name="l00041"></a>00041 
<a name="l00042"></a>00042   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00059"></a>00059 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00060"></a>00060             <span class="keyword">typename</span> DofObjType,
<a name="l00061"></a>00061             <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00062"></a>00062   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a4cc88801cb0c7534c3c9954da9e5d26f">sync_dofobject_data_by_xyz</a>(<span class="keyword">const</span> Iterator&amp;          range_begin,
<a name="l00063"></a>00063                                   <span class="keyword">const</span> Iterator&amp;          range_end,
<a name="l00064"></a>00064                                   LocationMap&lt;DofObjType&gt;* location_map,
<a name="l00065"></a>00065                                   SyncFunctor&amp;             sync);
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00080"></a>00080 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00081"></a>00081             <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00082"></a>00082   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8086357cefdf6ff1b849bd308af6cc6e">sync_dofobject_data_by_id</a>(<span class="keyword">const</span> Iterator&amp; range_begin,
<a name="l00083"></a>00083                                  <span class="keyword">const</span> Iterator&amp; range_end,
<a name="l00084"></a>00084                                  SyncFunctor&amp;    sync);
<a name="l00085"></a>00085 
<a name="l00086"></a>00086   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00100"></a>00100 <span class="comment"></span>  <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00101"></a>00101             <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00102"></a>00102   <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a9673356792a1d29be5012c1b0bbe6520">sync_element_data_by_parent_id</a>(MeshBase&amp;       <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00103"></a>00103                                       <span class="keyword">const</span> Iterator&amp; range_begin,
<a name="l00104"></a>00104                                       <span class="keyword">const</span> Iterator&amp; range_end,
<a name="l00105"></a>00105                                       SyncFunctor&amp;    sync);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107   <span class="comment">//------------------------------------------------------------------------</span>
<a name="l00108"></a>00108   <span class="comment">// Parallel members</span>
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00111"></a>00111           <span class="keyword">typename</span> DofObjType,
<a name="l00112"></a>00112           <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00113"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#ab91c63cd960b1dc03dd4b2d90c526bdc">00113</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a4cc88801cb0c7534c3c9954da9e5d26f">sync_dofobject_data_by_xyz</a>(<span class="keyword">const</span> Iterator&amp;          range_begin,
<a name="l00114"></a>00114                                 <span class="keyword">const</span> Iterator&amp;          range_end,
<a name="l00115"></a>00115                                 <a class="code" href="classlibMesh_1_1LocationMap.php">LocationMap&lt;DofObjType&gt;</a>&amp; location_map,
<a name="l00116"></a>00116                                 SyncFunctor&amp;             sync)
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00119"></a>00119   parallel_only();
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// We need a valid location_map</span>
<a name="l00122"></a>00122 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00123"></a>00123 <span class="preprocessor"></span>  <span class="keywordtype">bool</span> need_map_update = (range_begin != range_end &amp;&amp; location_map.<a class="code" href="classlibMesh_1_1LocationMap.php#ae5e9f2ba3dd8d494e6308459e2bba569">empty</a>());
<a name="l00124"></a>00124   <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">Parallel::max</a>(need_map_update);
<a name="l00125"></a>00125   libmesh_assert(!need_map_update);
<a name="l00126"></a>00126 <span class="preprocessor">#endif</span>
<a name="l00127"></a>00127 <span class="preprocessor"></span>
<a name="l00128"></a>00128   <span class="comment">// Count the objectss to ask each processor about</span>
<a name="l00129"></a>00129   std::vector&lt;unsigned int&gt;
<a name="l00130"></a>00130     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00133"></a>00133     {
<a name="l00134"></a>00134       DofObjType *obj = *it;
<a name="l00135"></a>00135       libmesh_assert (obj);
<a name="l00136"></a>00136       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;processor_id();
<a name="l00137"></a>00137       libmesh_assert (obj_procid != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139       ghost_objects_from_proc[obj_procid]++;
<a name="l00140"></a>00140     }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142   <span class="comment">// Request sets to send to each processor</span>
<a name="l00143"></a>00143   std::vector&lt;std::vector&lt;Real&gt; &gt;
<a name="l00144"></a>00144     requested_objs_x(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00145"></a>00145     requested_objs_y(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00146"></a>00146     requested_objs_z(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00147"></a>00147   <span class="comment">// Corresponding ids to keep track of</span>
<a name="l00148"></a>00148   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00149"></a>00149     requested_objs_id(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   <span class="comment">// We know how many objects live on each processor, so reserve()</span>
<a name="l00152"></a>00152   <span class="comment">// space for each.</span>
<a name="l00153"></a>00153   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00154"></a>00154     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00155"></a>00155       {
<a name="l00156"></a>00156         requested_objs_x[p].reserve(ghost_objects_from_proc[p]);
<a name="l00157"></a>00157         requested_objs_y[p].reserve(ghost_objects_from_proc[p]);
<a name="l00158"></a>00158         requested_objs_z[p].reserve(ghost_objects_from_proc[p]);
<a name="l00159"></a>00159         requested_objs_id[p].reserve(ghost_objects_from_proc[p]);
<a name="l00160"></a>00160       }
<a name="l00161"></a>00161   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00162"></a>00162     {
<a name="l00163"></a>00163       DofObjType *obj = *it;
<a name="l00164"></a>00164       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;processor_id();
<a name="l00165"></a>00165       <span class="keywordflow">if</span> (obj_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00166"></a>00166         <span class="keywordflow">continue</span>;
<a name="l00167"></a>00167 
<a name="l00168"></a>00168       <a class="code" href="classlibMesh_1_1Point.php">Point</a> p = location_map.<a class="code" href="classlibMesh_1_1LocationMap.php#a7bbf664429b19a3744a74836121bcc11">point_of</a>(*obj);
<a name="l00169"></a>00169       requested_objs_x[obj_procid].push_back(p(0));
<a name="l00170"></a>00170       requested_objs_y[obj_procid].push_back(p(1));
<a name="l00171"></a>00171       requested_objs_z[obj_procid].push_back(p(2));
<a name="l00172"></a>00172       requested_objs_id[obj_procid].push_back(obj-&gt;id());
<a name="l00173"></a>00173     }
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="comment">// Trade requests with other processors</span>
<a name="l00176"></a>00176   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00177"></a>00177     {
<a name="l00178"></a>00178       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00179"></a>00179       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00180"></a>00180                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00181"></a>00181       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00182"></a>00182                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00183"></a>00183                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00184"></a>00184       std::vector&lt;Real&gt; request_to_fill_x,
<a name="l00185"></a>00185                         request_to_fill_y,
<a name="l00186"></a>00186                         request_to_fill_z;
<a name="l00187"></a>00187       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_objs_x[procup],
<a name="l00188"></a>00188                              procdown, request_to_fill_x);
<a name="l00189"></a>00189       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_objs_y[procup],
<a name="l00190"></a>00190                              procdown, request_to_fill_y);
<a name="l00191"></a>00191       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_objs_z[procup],
<a name="l00192"></a>00192                              procdown, request_to_fill_z);
<a name="l00193"></a>00193 
<a name="l00194"></a>00194       <span class="comment">// Find the local id of each requested object</span>
<a name="l00195"></a>00195       std::vector&lt;unsigned int&gt; request_to_fill_id(request_to_fill_x.size());
<a name="l00196"></a>00196       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill_x.size(); ++i)
<a name="l00197"></a>00197         {
<a name="l00198"></a>00198           <a class="code" href="classlibMesh_1_1Point.php">Point</a> p(request_to_fill_x[i],
<a name="l00199"></a>00199                   request_to_fill_y[i],
<a name="l00200"></a>00200                   request_to_fill_z[i]);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202           <span class="comment">// Look for this object in the multimap</span>
<a name="l00203"></a>00203           DofObjType *obj = location_map.<a class="code" href="classlibMesh_1_1LocationMap.php#aaf94e1934f882d48664d7496ea27cb7e">find</a>(p);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205           <span class="comment">// We&#39;d better find every object we&#39;re asked for</span>
<a name="l00206"></a>00206           libmesh_assert (obj);
<a name="l00207"></a>00207 
<a name="l00208"></a>00208           <span class="comment">// Return the object&#39;s correct processor id,</span>
<a name="l00209"></a>00209           <span class="comment">// and our (correct if it&#39;s local) id for it.</span>
<a name="l00210"></a>00210           request_to_fill_id[i] = obj-&gt;id();
<a name="l00211"></a>00211         }
<a name="l00212"></a>00212 
<a name="l00213"></a>00213       <span class="comment">// Gather whatever data the user wants</span>
<a name="l00214"></a>00214       std::vector&lt;typename SyncFunctor::datum&gt; data;
<a name="l00215"></a>00215       sync.gather_data(request_to_fill_id, data);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217       <span class="comment">// Trade back the results</span>
<a name="l00218"></a>00218       std::vector&lt;typename SyncFunctor::datum&gt; received_data;
<a name="l00219"></a>00219       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, data,
<a name="l00220"></a>00220                              procup, received_data);
<a name="l00221"></a>00221       libmesh_assert(requested_objs_x[procup].size() ==
<a name="l00222"></a>00222                      received_data.size());
<a name="l00223"></a>00223 
<a name="l00224"></a>00224       <span class="comment">// Let the user process the results</span>
<a name="l00225"></a>00225       sync.act_on_data(requested_objs_id[procup], received_data);
<a name="l00226"></a>00226     }
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00232"></a>00232           <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00233"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a8086357cefdf6ff1b849bd308af6cc6e">00233</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a8086357cefdf6ff1b849bd308af6cc6e">sync_dofobject_data_by_id</a>(<span class="keyword">const</span> Iterator&amp; range_begin,
<a name="l00234"></a>00234                                <span class="keyword">const</span> Iterator&amp; range_end,
<a name="l00235"></a>00235                                SyncFunctor&amp;    sync)
<a name="l00236"></a>00236 {
<a name="l00237"></a>00237   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00238"></a>00238   parallel_only();
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   <span class="comment">// Count the objects to ask each processor about</span>
<a name="l00241"></a>00241   std::vector&lt;unsigned int&gt;
<a name="l00242"></a>00242     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00245"></a>00245     {
<a name="l00246"></a>00246       <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a> *obj = *it;
<a name="l00247"></a>00247       libmesh_assert (obj);
<a name="l00248"></a>00248       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00249"></a>00249       libmesh_assert (obj_procid != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00250"></a>00250 
<a name="l00251"></a>00251       ghost_objects_from_proc[obj_procid]++;
<a name="l00252"></a>00252     }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   <span class="comment">// Request sets to send to each processor</span>
<a name="l00255"></a>00255   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00256"></a>00256     requested_objs_id(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   <span class="comment">// We know how many objects live on each processor, so reserve()</span>
<a name="l00259"></a>00259   <span class="comment">// space for each.</span>
<a name="l00260"></a>00260   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00261"></a>00261     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00262"></a>00262       {
<a name="l00263"></a>00263         requested_objs_id[p].reserve(ghost_objects_from_proc[p]);
<a name="l00264"></a>00264       }
<a name="l00265"></a>00265   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00266"></a>00266     {
<a name="l00267"></a>00267       <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a> *obj = *it;
<a name="l00268"></a>00268       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00269"></a>00269       <span class="keywordflow">if</span> (obj_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00270"></a>00270         <span class="keywordflow">continue</span>;
<a name="l00271"></a>00271 
<a name="l00272"></a>00272       requested_objs_id[obj_procid].push_back(obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00273"></a>00273     }
<a name="l00274"></a>00274 
<a name="l00275"></a>00275   <span class="comment">// Trade requests with other processors</span>
<a name="l00276"></a>00276   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00277"></a>00277     {
<a name="l00278"></a>00278       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00279"></a>00279       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00280"></a>00280                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00281"></a>00281       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00282"></a>00282                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00283"></a>00283                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00284"></a>00284       std::vector&lt;unsigned int&gt; request_to_fill_id;
<a name="l00285"></a>00285       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_objs_id[procup],
<a name="l00286"></a>00286                              procdown, request_to_fill_id);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288       <span class="comment">// Gather whatever data the user wants</span>
<a name="l00289"></a>00289       std::vector&lt;typename SyncFunctor::datum&gt; data;
<a name="l00290"></a>00290       sync.gather_data(request_to_fill_id, data);
<a name="l00291"></a>00291 
<a name="l00292"></a>00292       <span class="comment">// Trade back the results</span>
<a name="l00293"></a>00293       std::vector&lt;typename SyncFunctor::datum&gt; received_data;
<a name="l00294"></a>00294       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, data,
<a name="l00295"></a>00295                              procup, received_data);
<a name="l00296"></a>00296       libmesh_assert(requested_objs_id[procup].size() ==
<a name="l00297"></a>00297                      received_data.size());
<a name="l00298"></a>00298 
<a name="l00299"></a>00299       <span class="comment">// Let the user process the results</span>
<a name="l00300"></a>00300       sync.act_on_data(requested_objs_id[procup], received_data);
<a name="l00301"></a>00301     }
<a name="l00302"></a>00302 }
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   <span class="comment">// If there&#39;s no refined elements, there&#39;s nothing to sync</span>
<a name="l00307"></a>00307 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00308"></a>00308 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00309"></a>00309           <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00310"></a><a class="code" href="namespacelibMesh_1_1Parallel.php#a9673356792a1d29be5012c1b0bbe6520">00310</a> <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a9673356792a1d29be5012c1b0bbe6520">sync_element_data_by_parent_id</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;       <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00311"></a>00311                                     <span class="keyword">const</span> Iterator&amp; range_begin,
<a name="l00312"></a>00312                                     <span class="keyword">const</span> Iterator&amp; range_end,
<a name="l00313"></a>00313                                     SyncFunctor&amp;    sync)
<a name="l00314"></a>00314 {
<a name="l00315"></a>00315   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00316"></a>00316   parallel_only();
<a name="l00317"></a>00317 
<a name="l00318"></a>00318   <span class="comment">// Count the objects to ask each processor about</span>
<a name="l00319"></a>00319   std::vector&lt;unsigned int&gt;
<a name="l00320"></a>00320     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00323"></a>00323     {
<a name="l00324"></a>00324       <a class="code" href="classlibMesh_1_1DofObject.php">DofObject</a> *obj = *it;
<a name="l00325"></a>00325       libmesh_assert (obj);
<a name="l00326"></a>00326       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00327"></a>00327       libmesh_assert (obj_procid != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00328"></a>00328 
<a name="l00329"></a>00329       ghost_objects_from_proc[obj_procid]++;
<a name="l00330"></a>00330     }
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   <span class="comment">// Request sets to send to each processor</span>
<a name="l00333"></a>00333   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00334"></a>00334     requested_objs_id(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00335"></a>00335     requested_objs_parent_id(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00336"></a>00336     requested_objs_child_num(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00337"></a>00337 
<a name="l00338"></a>00338   <span class="comment">// We know how many objects live on each processor, so reserve()</span>
<a name="l00339"></a>00339   <span class="comment">// space for each.</span>
<a name="l00340"></a>00340   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00341"></a>00341     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00342"></a>00342       {
<a name="l00343"></a>00343         requested_objs_id[p].reserve(ghost_objects_from_proc[p]);
<a name="l00344"></a>00344         requested_objs_parent_id[p].reserve(ghost_objects_from_proc[p]);
<a name="l00345"></a>00345         requested_objs_child_num[p].reserve(ghost_objects_from_proc[p]);
<a name="l00346"></a>00346       }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="keywordflow">for</span> (Iterator it = range_begin; it != range_end; ++it)
<a name="l00349"></a>00349     {
<a name="l00350"></a>00350       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *it;
<a name="l00351"></a>00351       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00352"></a>00352       <span class="keywordflow">if</span> (obj_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00353"></a>00353         <span class="keywordflow">continue</span>;
<a name="l00354"></a>00354       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *parent = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00355"></a>00355       <span class="keywordflow">if</span> (!parent || !elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00356"></a>00356         <span class="keywordflow">continue</span>;
<a name="l00357"></a>00357 
<a name="l00358"></a>00358       requested_objs_id[obj_procid].push_back(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00359"></a>00359       requested_objs_parent_id[obj_procid].push_back(parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00360"></a>00360       requested_objs_child_num[obj_procid].push_back
<a name="l00361"></a>00361         (parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad3ec91e1b0444b1d699302681b713fe1">which_child_am_i</a>(elem));
<a name="l00362"></a>00362     }
<a name="l00363"></a>00363 
<a name="l00364"></a>00364   <span class="comment">// Trade requests with other processors</span>
<a name="l00365"></a>00365   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00366"></a>00366     {
<a name="l00367"></a>00367       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00368"></a>00368       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00369"></a>00369                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00370"></a>00370       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00371"></a>00371                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00372"></a>00372                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00373"></a>00373       std::vector&lt;unsigned int&gt; request_to_fill_parent_id,
<a name="l00374"></a>00374                                 request_to_fill_child_num;
<a name="l00375"></a>00375       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_objs_parent_id[procup],
<a name="l00376"></a>00376                              procdown, request_to_fill_parent_id);
<a name="l00377"></a>00377       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_objs_child_num[procup],
<a name="l00378"></a>00378                              procdown, request_to_fill_child_num);
<a name="l00379"></a>00379 
<a name="l00380"></a>00380       <span class="comment">// Find the id of each requested element</span>
<a name="l00381"></a>00381       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> request_size = request_to_fill_parent_id.size();
<a name="l00382"></a>00382       std::vector&lt;unsigned int&gt; request_to_fill_id(request_size);
<a name="l00383"></a>00383       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_size; ++i)
<a name="l00384"></a>00384         {
<a name="l00385"></a>00385           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *parent = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1e828981aea77f70730719e4e09e26f2">elem</a>(request_to_fill_parent_id[i]);
<a name="l00386"></a>00386           libmesh_assert(parent);
<a name="l00387"></a>00387           libmesh_assert(parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac6316ca5f7b962a8a806ac385d6c0236">has_children</a>());
<a name="l00388"></a>00388           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *child = parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(request_to_fill_child_num[i]);
<a name="l00389"></a>00389           libmesh_assert(child);
<a name="l00390"></a>00390           libmesh_assert(child-&gt;active());
<a name="l00391"></a>00391           request_to_fill_id[i] = child-&gt;id();
<a name="l00392"></a>00392         }
<a name="l00393"></a>00393 
<a name="l00394"></a>00394       <span class="comment">// Gather whatever data the user wants</span>
<a name="l00395"></a>00395       std::vector&lt;typename SyncFunctor::datum&gt; data;
<a name="l00396"></a>00396       sync.gather_data(request_to_fill_id, data);
<a name="l00397"></a>00397 
<a name="l00398"></a>00398       <span class="comment">// Trade back the results</span>
<a name="l00399"></a>00399       std::vector&lt;typename SyncFunctor::datum&gt; received_data;
<a name="l00400"></a>00400       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, data,
<a name="l00401"></a>00401                              procup, received_data);
<a name="l00402"></a>00402       libmesh_assert(requested_objs_id[procup].size() ==
<a name="l00403"></a>00403                      received_data.size());
<a name="l00404"></a>00404 
<a name="l00405"></a>00405       <span class="comment">// Let the user process the results</span>
<a name="l00406"></a>00406       sync.act_on_data(requested_objs_id[procup], received_data);
<a name="l00407"></a>00407     }
<a name="l00408"></a>00408 }
<a name="l00409"></a>00409 <span class="preprocessor">#else</span>
<a name="l00410"></a>00410 <span class="preprocessor"></span><span class="keyword">template</span> &lt;<span class="keyword">typename</span> Iterator,
<a name="l00411"></a>00411           <span class="keyword">typename</span> SyncFunctor&gt;
<a name="l00412"></a>00412 <span class="keywordtype">void</span> <a class="code" href="namespacelibMesh_1_1Parallel.php#a9673356792a1d29be5012c1b0bbe6520">sync_element_data_by_parent_id</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp;,
<a name="l00413"></a>00413                                     <span class="keyword">const</span> Iterator&amp;,
<a name="l00414"></a>00414                                     <span class="keyword">const</span> Iterator&amp;,
<a name="l00415"></a>00415                                     SyncFunctor&amp;)
<a name="l00416"></a>00416 {
<a name="l00417"></a>00417 }
<a name="l00418"></a>00418 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00419"></a>00419 <span class="preprocessor"></span>
<a name="l00420"></a>00420 
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423 }
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 } <span class="comment">// namespace libMesh</span>
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 <span class="preprocessor">#endif // #define __parallel_ghost_sync_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
