<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bdae1604989e5516f706b95b493c360.php">parallel</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel_histogram.h</div>  </div>
</div>
<div class="contents">
<a href="parallel__histogram_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_histogram.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __parallel_histogram_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_histogram_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// This class contains all the functionality for bin sorting</span>
<a name="l00025"></a>00025 <span class="comment">// Templated on the type of keys you will be sorting and the</span>
<a name="l00026"></a>00026 <span class="comment">// type of iterator you will be using.</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;iterator&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span> <span class="comment">// for libmesh_assert()</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="keyword">namespace </span>Parallel {
<a name="l00038"></a>00038 
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00044"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php">00044</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php">Histogram</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046   <span class="comment">// The type of iterator we will be using is inferred from KeyType</span>
<a name="l00047"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a4997f2581ddf733144325508c1268afd">00047</a>   <span class="keyword">typedef</span> <span class="keyword">typename</span> std::vector&lt;KeyType&gt;::const_iterator <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a4997f2581ddf733144325508c1268afd">IterType</a>;
<a name="l00048"></a>00048   
<a name="l00049"></a>00049 <span class="keyword">public</span>:
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">// Constructor</span>
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a59dac1c48c4f19dda31672e88f81dc29">Histogram</a> (<span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; d);
<a name="l00053"></a>00053   
<a name="l00054"></a>00054   <span class="comment">// The actual function which sorts the data into</span>
<a name="l00055"></a>00055   <span class="comment">// nbins.  Currently based on the global min and</span>
<a name="l00056"></a>00056   <span class="comment">// max which you must provide e.g. by using MPI.</span>
<a name="l00057"></a>00057   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a994c36f333866b4097d575a117c2ccea">make_histogram</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nbins,
<a name="l00058"></a>00058                        KeyType <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">max</a>,
<a name="l00059"></a>00059                        KeyType <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">min</a>);
<a name="l00060"></a>00060 
<a name="l00061"></a>00061   <span class="comment">// Build the histogram across all processors and store the</span>
<a name="l00062"></a>00062   <span class="comment">// result in the input vector \p hist</span>
<a name="l00063"></a>00063   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#aa6686f5122770540c59681f949f55738">build_histogram</a> ();
<a name="l00064"></a>00064 
<a name="l00065"></a>00065   <span class="comment">// Return the raw histogram data to the user</span>
<a name="l00066"></a>00066   <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a213cb5442baefa77d3e05f8b46905650">get_histogram</a>() <span class="keyword">const</span>;
<a name="l00067"></a>00067   
<a name="l00068"></a>00068   <span class="comment">// The number of bins in the histogram</span>
<a name="l00069"></a>00069   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a2fe71ddbfdbcba67c67f13523f85acdc">n_bins</a> () <span class="keyword">const</span>;
<a name="l00070"></a>00070   
<a name="l00071"></a>00071   <span class="comment">// Returns the size of local bin b as an unsigned int.</span>
<a name="l00072"></a>00072   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a2aa2bd07ab3d8dfbfeb0fc4e47617a75">local_bin_size</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin) <span class="keyword">const</span>;  
<a name="l00073"></a>00073   
<a name="l00074"></a>00074   <span class="comment">// Returns the size of global bin b as an unsigned int.</span>
<a name="l00075"></a>00075   <span class="comment">// Requires that the user first call \p build_histogram()</span>
<a name="l00076"></a>00076   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a3c8190cb4119a9feb6d7efbe2e610cfa">global_bin_size</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin) <span class="keyword">const</span>;  
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="comment">// Returns the lower boundary of bin \p bin</span>
<a name="l00079"></a>00079   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a0c58f22f963deaa81e0f91ff6e06e127">lower_bound</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin) <span class="keyword">const</span>;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// Returns the upper boundary of bin \p bin</span>
<a name="l00082"></a>00082   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#aa6550f0126cd8314c734db10f83ee7fc">upper_bound</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin) <span class="keyword">const</span>;
<a name="l00083"></a>00083 
<a name="l00084"></a>00084   
<a name="l00085"></a>00085 <span class="keyword">private</span>:
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   
<a name="l00088"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#ac0ec370faf3386d0a8f48a1d6af59cd1">00088</a>   <span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#ac0ec370faf3386d0a8f48a1d6af59cd1">data</a>;
<a name="l00089"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#ad7e11e41d78f56a0066ce3362804c013">00089</a>   std::vector&lt;unsigned int&gt;   <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#ad7e11e41d78f56a0066ce3362804c013">hist</a>;        <span class="comment">// The actual histogram</span>
<a name="l00090"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a3e06b3a34062e83c3d050e898bee6e07">00090</a>   std::vector&lt;double&gt;         <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a3e06b3a34062e83c3d050e898bee6e07">bin_bounds</a>;  <span class="comment">// The boundary values of each bin</span>
<a name="l00091"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a95a9813878cbeb89e3e909151749d2f4">00091</a>   std::vector&lt;IterType&gt;       <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a95a9813878cbeb89e3e909151749d2f4">bin_iters</a>;   <span class="comment">// Iterators to the bin boundaries</span>
<a name="l00092"></a>00092                                            <span class="comment">//  in data</span>
<a name="l00093"></a>00093 };
<a name="l00094"></a>00094 
<a name="l00095"></a>00095 
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="comment">//--------------------------------------------------------------------------</span>
<a name="l00099"></a>00099 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00100"></a>00100 <span class="keyword">inline</span>
<a name="l00101"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a213cb5442baefa77d3e05f8b46905650">00101</a> <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a213cb5442baefa77d3e05f8b46905650">Histogram&lt;KeyType&gt;::get_histogram</a> ()<span class="keyword"> const</span>
<a name="l00102"></a>00102 <span class="keyword"></span>{
<a name="l00103"></a>00103   <span class="keywordflow">return</span> hist;
<a name="l00104"></a>00104 }
<a name="l00105"></a>00105 
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00109"></a>00109 <span class="keyword">inline</span>
<a name="l00110"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a2fe71ddbfdbcba67c67f13523f85acdc">00110</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a2fe71ddbfdbcba67c67f13523f85acdc">Histogram&lt;KeyType&gt;::n_bins</a> ()<span class="keyword"> const</span>
<a name="l00111"></a>00111 <span class="keyword"></span>{
<a name="l00112"></a>00112   <span class="keywordflow">if</span> (bin_iters.empty())
<a name="l00113"></a>00113     <span class="keywordflow">return</span> 0;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordflow">return</span> (bin_iters.size()-1);
<a name="l00116"></a>00116 }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00121"></a>00121 <span class="keyword">inline</span>
<a name="l00122"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a2aa2bd07ab3d8dfbfeb0fc4e47617a75">00122</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a2aa2bd07ab3d8dfbfeb0fc4e47617a75">Histogram&lt;KeyType&gt;::local_bin_size</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin)<span class="keyword"> const</span>
<a name="l00123"></a>00123 <span class="keyword"></span>{
<a name="l00124"></a>00124   libmesh_assert ((bin+1) &lt; bin_iters.size());
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="comment">// The number of entries in the bin (locally)</span>
<a name="l00127"></a>00127   <span class="keywordflow">return</span> std::distance (bin_iters[bin], bin_iters[bin+1]);
<a name="l00128"></a>00128 }
<a name="l00129"></a>00129 
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00133"></a>00133 <span class="keyword">inline</span>
<a name="l00134"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a3c8190cb4119a9feb6d7efbe2e610cfa">00134</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a3c8190cb4119a9feb6d7efbe2e610cfa">Histogram&lt;KeyType&gt;::global_bin_size</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin)<span class="keyword"> const</span>
<a name="l00135"></a>00135 <span class="keyword"></span>{
<a name="l00136"></a>00136   libmesh_assert (bin &lt; hist.size());
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// The number of entries in the bin (globally)</span>
<a name="l00139"></a>00139   <span class="keywordflow">return</span> hist[bin];
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00145"></a>00145 <span class="keyword">inline</span>
<a name="l00146"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a0c58f22f963deaa81e0f91ff6e06e127">00146</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#a0c58f22f963deaa81e0f91ff6e06e127">Histogram&lt;KeyType&gt;::lower_bound</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin)<span class="keyword"> const</span>
<a name="l00147"></a>00147 <span class="keyword"></span>{
<a name="l00148"></a>00148   libmesh_assert ((bin+1) &lt; bin_bounds.size());
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="keywordflow">return</span> bin_bounds[bin];
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00156"></a>00156 <span class="keyword">inline</span>
<a name="l00157"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#aa6550f0126cd8314c734db10f83ee7fc">00157</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Histogram.php#aa6550f0126cd8314c734db10f83ee7fc">Histogram&lt;KeyType&gt;::upper_bound</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> bin)<span class="keyword"> const</span>
<a name="l00158"></a>00158 <span class="keyword"></span>{
<a name="l00159"></a>00159   libmesh_assert ((bin+1) &lt; bin_bounds.size());
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="keywordflow">return</span> bin_bounds[bin+1];
<a name="l00162"></a>00162 }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 } <span class="comment">// namespace libMesh</span>
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="preprocessor">#endif</span>
<a name="l00169"></a>00169 <span class="preprocessor"></span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
