<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel_mesh.C</div>  </div>
</div>
<div class="contents">
<a href="parallel__mesh_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_mesh.C 4384 2011-04-21 00:46:56Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="boundary__info_8h.php">boundary_info.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="parallel__mesh_8h.php">parallel_mesh.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="parmetis__partitioner_8h.php">parmetis_partitioner.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// ParallelMesh class member functions</span>
<a name="l00036"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">00036</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh::ParallelMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d) :
<a name="l00037"></a>00037   <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> (d), _is_serial(true),
<a name="l00038"></a>00038   _n_nodes(0), _n_elem(0), _max_node_id(0), _max_elem_id(0),
<a name="l00039"></a>00039   _next_free_local_node_id(libMesh::<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>()),
<a name="l00040"></a>00040   _next_free_local_elem_id(libMesh::<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">processor_id</a>()),
<a name="l00041"></a>00041   _next_free_unpartitioned_node_id(libMesh::<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">n_processors</a>()),
<a name="l00042"></a>00042   _next_free_unpartitioned_elem_id(libMesh::<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">n_processors</a>())
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <a class="code" href="classlibMesh_1_1MeshBase.php#a23499d00522daa25ed85eeb071148512">_partitioner</a> = <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php">ParmetisPartitioner</a>());
<a name="l00045"></a>00045 }
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ab629e768ba9b128360c7323ec1133db3">00048</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab629e768ba9b128360c7323ec1133db3">ParallelMesh::~ParallelMesh</a> ()
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">clear</a>();  <span class="comment">// Free nodes and elements</span>
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">// This might be specialized later, but right now it&#39;s just here to</span>
<a name="l00055"></a>00055 <span class="comment">// make sure the compiler doesn&#39;t give us a default (non-deep) copy</span>
<a name="l00056"></a>00056 <span class="comment">// constructor instead.</span>
<a name="l00057"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a7ae17d20299e5623c3a79532d5e56d92">00057</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh::ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> &amp;other_mesh) :
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> (other_mesh), _is_serial(other_mesh._is_serial)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   this-&gt;<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a5fab9455dc9b3af779d83b1125ac1ed6">copy_nodes_and_elements</a>(other_mesh);
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>();
<a name="l00062"></a>00062   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>  = other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>();
<a name="l00063"></a>00063   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>();
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>();
<a name="l00065"></a>00065   *this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a> = *other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>;
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   <span class="comment">// Need to copy extra_ghost_elems</span>
<a name="l00068"></a>00068   <span class="keywordflow">for</span>(std::set&lt;Elem *&gt;::iterator it = other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a68988aa2a6bcb8c9a4d3ca8bcec0dd79">_extra_ghost_elems</a>.begin();
<a name="l00069"></a>00069       it != other_mesh.<a class="code" href="classlibMesh_1_1ParallelMesh.php#a68988aa2a6bcb8c9a4d3ca8bcec0dd79">_extra_ghost_elems</a>.end();
<a name="l00070"></a>00070       ++it)
<a name="l00071"></a>00071     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a68988aa2a6bcb8c9a4d3ca8bcec0dd79">_extra_ghost_elems</a>.insert(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>((*it)-&gt;id()));
<a name="l00072"></a>00072 }
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a1e13890b4fe099387e3edde7e133a011">00076</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh::ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> &amp;other_mesh) :
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a> (other_mesh)
<a name="l00078"></a>00078 {
<a name="l00079"></a>00079   this-&gt;<a class="code" href="classlibMesh_1_1UnstructuredMesh.php#a5fab9455dc9b3af779d83b1125ac1ed6">copy_nodes_and_elements</a>(other_mesh);
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aff7b82001829828de180cf961df93ea1">n_nodes</a>();
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>  = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a89566c09cd05aba8bd7f606eba96bf6f">n_elem</a>();
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9778fcd4d5fc7687babdf9a5ea56d882">max_node_id</a>();
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>();
<a name="l00084"></a>00084   *this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a> = *other_mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>;
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 <span class="comment">// We use cached values for these so they can be called</span>
<a name="l00089"></a>00089 <span class="comment">// from one processor without bothering the rest, but</span>
<a name="l00090"></a>00090 <span class="comment">// we may need to update those caches before doing a full</span>
<a name="l00091"></a>00091 <span class="comment">// renumbering</span>
<a name="l00092"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a2539e4472fc43042afc8cc0d84e10ad5">00092</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2539e4472fc43042afc8cc0d84e10ad5">ParallelMesh::update_parallel_id_counts</a>()
<a name="l00093"></a>00093 {
<a name="l00094"></a>00094   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00095"></a>00095   parallel_only();
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a> = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a32db8a83b3c6348e1bd9142fb8e92107">n_local_elem</a>();
<a name="l00098"></a>00098   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>);
<a name="l00099"></a>00099   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a> += this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae210732141d58a19337dde4c901fc18c">n_unpartitioned_elem</a>();
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.empty() ?
<a name="l00102"></a>00102     0 : <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.rbegin()-&gt;first + 1;
<a name="l00103"></a>00103   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a>);
<a name="l00104"></a>00104 
<a name="l00105"></a>00105   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ad25082a75258d635a515e96e6860aa72">n_local_nodes</a>();
<a name="l00106"></a>00106   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>);
<a name="l00107"></a>00107   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> += this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a7c108f0e48b093fe0fc313c3875d90b6">n_unpartitioned_nodes</a>();
<a name="l00108"></a>00108 
<a name="l00109"></a>00109   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.empty() ?
<a name="l00110"></a>00110     0 : <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.rbegin()-&gt;first + 1;
<a name="l00111"></a>00111   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a>);
<a name="l00112"></a>00112 }
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 <span class="comment">// Or in debug mode we may want to test the uncached values without</span>
<a name="l00116"></a>00116 <span class="comment">// changing the cache</span>
<a name="l00117"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">00117</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">ParallelMesh::parallel_n_elem</a>()<span class="keyword"> const</span>
<a name="l00118"></a>00118 <span class="keyword"></span>{
<a name="l00119"></a>00119   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00120"></a>00120   parallel_only();
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a32db8a83b3c6348e1bd9142fb8e92107">n_local_elem</a>();
<a name="l00123"></a>00123   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(n_local);
<a name="l00124"></a>00124   n_local += this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ae210732141d58a19337dde4c901fc18c">n_unpartitioned_elem</a>();
<a name="l00125"></a>00125   <span class="keywordflow">return</span> n_local;
<a name="l00126"></a>00126 }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129 
<a name="l00130"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">00130</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">ParallelMesh::parallel_max_elem_id</a>()<span class="keyword"> const</span>
<a name="l00131"></a>00131 <span class="keyword"></span>{
<a name="l00132"></a>00132   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00133"></a>00133   parallel_only();
<a name="l00134"></a>00134 
<a name="l00135"></a>00135   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_local = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.empty() ?
<a name="l00136"></a>00136     0 : <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.rbegin()-&gt;first + 1;
<a name="l00137"></a>00137   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_local);
<a name="l00138"></a>00138   <span class="keywordflow">return</span> max_local;
<a name="l00139"></a>00139 }
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">00143</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">ParallelMesh::parallel_n_nodes</a>()<span class="keyword"> const</span>
<a name="l00144"></a>00144 <span class="keyword"></span>{
<a name="l00145"></a>00145   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00146"></a>00146   parallel_only();
<a name="l00147"></a>00147 
<a name="l00148"></a>00148   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local = this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#ad25082a75258d635a515e96e6860aa72">n_local_nodes</a>();
<a name="l00149"></a>00149   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(n_local);
<a name="l00150"></a>00150   n_local += this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#a7c108f0e48b093fe0fc313c3875d90b6">n_unpartitioned_nodes</a>();
<a name="l00151"></a>00151   <span class="keywordflow">return</span> n_local;
<a name="l00152"></a>00152 }
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 
<a name="l00156"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">00156</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">ParallelMesh::parallel_max_node_id</a>()<span class="keyword"> const</span>
<a name="l00157"></a>00157 <span class="keyword"></span>{
<a name="l00158"></a>00158   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00159"></a>00159   parallel_only();
<a name="l00160"></a>00160 
<a name="l00161"></a>00161   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_local = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.empty() ?
<a name="l00162"></a>00162     0 : <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.rbegin()-&gt;first + 1;
<a name="l00163"></a>00163   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(max_local);
<a name="l00164"></a>00164   <span class="keywordflow">return</span> max_local;
<a name="l00165"></a>00165 }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 
<a name="l00169"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#aeec56d7bbe312b24d1a7fc78ee657a14">00169</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#aeec56d7bbe312b24d1a7fc78ee657a14">ParallelMesh::point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00170"></a>00170 <span class="keyword"></span>{
<a name="l00171"></a>00171   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] != NULL);
<a name="l00172"></a>00172   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00173"></a>00173 
<a name="l00174"></a>00174   <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]);
<a name="l00175"></a>00175 }
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 
<a name="l00181"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">00181</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">ParallelMesh::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00182"></a>00182 <span class="keyword"></span>{
<a name="l00183"></a>00183   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] != NULL);
<a name="l00184"></a>00184   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00185"></a>00185   
<a name="l00186"></a>00186   <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]);
<a name="l00187"></a>00187 }
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 
<a name="l00193"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a572cdfe2bdfc8f52f9395b1a2e35c3ad">00193</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">ParallelMesh::node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00194"></a>00194 {
<a name="l00195"></a>00195   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] != NULL);
<a name="l00196"></a>00196   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00197"></a>00197 
<a name="l00198"></a>00198   <span class="keywordflow">return</span> (*<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]);
<a name="l00199"></a>00199 }
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 
<a name="l00203"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">00203</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">ParallelMesh::node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00204"></a>00204 <span class="keyword"></span>{
<a name="l00205"></a>00205 <span class="comment">//  libmesh_assert (_nodes[i] != NULL);</span>
<a name="l00206"></a>00206   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] == NULL || <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);  
<a name="l00207"></a>00207   
<a name="l00208"></a>00208   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i];
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 
<a name="l00212"></a>00212 
<a name="l00213"></a>00213 
<a name="l00214"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a1ab714c74f4e9f19fb963e9d2c885dd9">00214</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* &amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">ParallelMesh::node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00215"></a>00215 {
<a name="l00216"></a>00216 <span class="comment">//  libmesh_assert (_nodes[i] != NULL);</span>
<a name="l00217"></a>00217   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i] == NULL || <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i]-&gt;<span class="keywordtype">id</span>() == i);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[i];
<a name="l00220"></a>00220 }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">00225</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">ParallelMesh::elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00226"></a>00226 <span class="keyword"></span>{
<a name="l00227"></a>00227 <span class="comment">//  libmesh_assert (_elements[i] != NULL);</span>
<a name="l00228"></a>00228   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[i] == NULL || <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[i]-&gt;<span class="keywordtype">id</span>() == i);
<a name="l00229"></a>00229   
<a name="l00230"></a>00230   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[i];
<a name="l00231"></a>00231 }
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 
<a name="l00234"></a>00234 
<a name="l00235"></a>00235 
<a name="l00236"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ad230cc153170488ad92ab4f6ee2146c7">00236</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#ad230cc153170488ad92ab4f6ee2146c7">ParallelMesh::add_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e)
<a name="l00237"></a>00237 {
<a name="l00238"></a>00238   <span class="comment">// Don&#39;t try to add NULLs!</span>
<a name="l00239"></a>00239   libmesh_assert(e);
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_procid = e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   <span class="keywordflow">if</span> (!e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">valid_id</a>())
<a name="l00244"></a>00244     {
<a name="l00245"></a>00245       <span class="comment">// Use the unpartitioned ids for unpartitioned elems,</span>
<a name="l00246"></a>00246       <span class="comment">// in serial, and temporarily for ghost elems</span>
<a name="l00247"></a>00247       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *next_id = &amp;<a class="code" href="classlibMesh_1_1ParallelMesh.php#af2cf69eaed1ebdd13c4ede5429158649">_next_free_unpartitioned_elem_id</a>;
<a name="l00248"></a>00248       <span class="keywordflow">if</span> (elem_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l00249"></a>00249           !this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a>())
<a name="l00250"></a>00250         next_id = &amp;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a>;
<a name="l00251"></a>00251       e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a> (*next_id);
<a name="l00252"></a>00252       *next_id += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00253"></a>00253     }
<a name="l00254"></a>00254   <span class="keywordflow">else</span>
<a name="l00255"></a>00255     {
<a name="l00256"></a>00256       <span class="keywordflow">if</span> (_next_free_unpartitioned_elem_id &lt;= e-&gt;<span class="keywordtype">id</span>())
<a name="l00257"></a>00257         <a class="code" href="classlibMesh_1_1ParallelMesh.php#af2cf69eaed1ebdd13c4ede5429158649">_next_free_unpartitioned_elem_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00258"></a>00258       <span class="keywordflow">if</span> (_next_free_local_elem_id &lt;= e-&gt;<span class="keywordtype">id</span>())
<a name="l00259"></a>00259         <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00260"></a>00260     }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   <span class="comment">// Don&#39;t try to overwrite existing elems</span>
<a name="l00263"></a>00263   libmesh_assert (!<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = e;
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   <span class="comment">// Make the cached elem data more accurate</span>
<a name="l00268"></a>00268   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>++;
<a name="l00269"></a>00269   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a>, e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()+1);
<a name="l00270"></a>00270   
<a name="l00271"></a>00271 <span class="comment">// Unpartitioned elems should be added on every processor</span>
<a name="l00272"></a>00272 <span class="comment">// And shouldn&#39;t be added in the same batch as ghost elems</span>
<a name="l00273"></a>00273 <span class="comment">// But we might be just adding on processor 0 to</span>
<a name="l00274"></a>00274 <span class="comment">// broadcast later</span>
<a name="l00275"></a>00275 <span class="preprocessor">#if 0</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00277"></a>00277 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (elem_procid == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00278"></a>00278     {
<a name="l00279"></a>00279       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#ab69c0b5b064ef16daf3f46102d138efa">elem_id</a> = e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00280"></a>00280       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(elem_id);
<a name="l00281"></a>00281       libmesh_assert(elem_id == e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00282"></a>00282     }
<a name="l00283"></a>00283 <span class="preprocessor">#endif</span>
<a name="l00284"></a>00284 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00285"></a>00285 <span class="preprocessor"></span>
<a name="l00286"></a>00286   <span class="keywordflow">return</span> e;
<a name="l00287"></a>00287 }
<a name="l00288"></a>00288 
<a name="l00289"></a>00289 
<a name="l00290"></a>00290 
<a name="l00291"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a467afea44aacb57e0e57eb5de3f8aa86">00291</a> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a467afea44aacb57e0e57eb5de3f8aa86">ParallelMesh::insert_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e)
<a name="l00292"></a>00292 {
<a name="l00293"></a>00293   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()])
<a name="l00294"></a>00294     this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a18ec9841a284a6c31fb69ff6e445c35c">delete_elem</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]);
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = e;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   <span class="keywordflow">return</span> e;
<a name="l00299"></a>00299 }
<a name="l00300"></a>00300 
<a name="l00301"></a>00301 
<a name="l00302"></a>00302 
<a name="l00303"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a18ec9841a284a6c31fb69ff6e445c35c">00303</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a18ec9841a284a6c31fb69ff6e445c35c">ParallelMesh::delete_elem</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e)
<a name="l00304"></a>00304 {
<a name="l00305"></a>00305   libmesh_assert (e);
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="comment">// Delete the element from the BoundaryInfo object</span>
<a name="l00308"></a>00308   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove(e);
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   <span class="comment">// But not yet from the container; we might invalidate</span>
<a name="l00311"></a>00311   <span class="comment">// an iterator that way!</span>
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   <span class="comment">//_elements.erase(e-&gt;id());</span>
<a name="l00314"></a>00314 
<a name="l00315"></a>00315   <span class="comment">// Instead, we set it to NULL for now</span>
<a name="l00316"></a>00316 
<a name="l00317"></a>00317   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[e-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = NULL;
<a name="l00318"></a>00318   
<a name="l00319"></a>00319   <span class="comment">// delete the element</span>
<a name="l00320"></a>00320   <span class="keyword">delete</span> e;
<a name="l00321"></a>00321 }
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 
<a name="l00325"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a05e15401a367a0773ff8ca1eb9293f44">00325</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a05e15401a367a0773ff8ca1eb9293f44">ParallelMesh::renumber_elem</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id,
<a name="l00326"></a>00326                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id)
<a name="l00327"></a>00327 {
<a name="l00328"></a>00328   <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[old_id];
<a name="l00329"></a>00329   libmesh_assert (elem);
<a name="l00330"></a>00330   libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == old_id);
<a name="l00331"></a>00331 
<a name="l00332"></a>00332   elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>(new_id);
<a name="l00333"></a>00333   libmesh_assert (!<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[new_id]);
<a name="l00334"></a>00334   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[new_id] = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>;
<a name="l00335"></a>00335   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(old_id);
<a name="l00336"></a>00336 }
<a name="l00337"></a>00337 
<a name="l00338"></a>00338 
<a name="l00339"></a>00339 
<a name="l00340"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">00340</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">ParallelMesh::add_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00341"></a>00341                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>,
<a name="l00342"></a>00342                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id)
<a name="l00343"></a>00343 {  
<a name="l00344"></a>00344   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.count(<span class="keywordtype">id</span>))
<a name="l00345"></a>00345     {
<a name="l00346"></a>00346       <a class="code" href="classlibMesh_1_1Node.php">Node</a> *n = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[id];
<a name="l00347"></a>00347       libmesh_assert (n);
<a name="l00348"></a>00348       libmesh_assert (n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == id);
<a name="l00349"></a>00349       
<a name="l00350"></a>00350       *n = p;
<a name="l00351"></a>00351       n-&gt;processor_id() = proc_id;
<a name="l00352"></a>00352 
<a name="l00353"></a>00353       <span class="keywordflow">return</span> n;
<a name="l00354"></a>00354     }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356   <a class="code" href="classlibMesh_1_1Node.php">Node</a>* n = <a class="code" href="classlibMesh_1_1Node.php#a25a962918684ad079dfb52eac7f07132">Node::build</a>(p, <span class="keywordtype">id</span>).release();
<a name="l00357"></a>00357   n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = proc_id;
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0361fbb9f7c55066ec20b45c02db63fb">ParallelMesh::add_node</a>(n);
<a name="l00360"></a>00360 }
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a0361fbb9f7c55066ec20b45c02db63fb">00364</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0361fbb9f7c55066ec20b45c02db63fb">ParallelMesh::add_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a> *n)
<a name="l00365"></a>00365 {
<a name="l00366"></a>00366   <span class="comment">// Don&#39;t try to add NULLs!</span>
<a name="l00367"></a>00367   libmesh_assert(n);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_procid = n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   <span class="keywordflow">if</span> (!n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#af2f7ac012e2ba614a49883ddb1bb6366">valid_id</a>())
<a name="l00372"></a>00372     {
<a name="l00373"></a>00373       <span class="comment">// Use the unpartitioned ids for unpartitioned nodes,</span>
<a name="l00374"></a>00374       <span class="comment">// in serial, and temporarily for ghost nodes</span>
<a name="l00375"></a>00375       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> *next_id = &amp;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">_next_free_unpartitioned_node_id</a>;
<a name="l00376"></a>00376       <span class="keywordflow">if</span> (node_procid == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l00377"></a>00377           !this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a>())
<a name="l00378"></a>00378         next_id = &amp;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a>;
<a name="l00379"></a>00379       n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a> (*next_id);
<a name="l00380"></a>00380       *next_id += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00381"></a>00381     }
<a name="l00382"></a>00382   <span class="keywordflow">else</span>
<a name="l00383"></a>00383     {
<a name="l00384"></a>00384       <span class="keywordflow">if</span> (_next_free_unpartitioned_node_id &lt;= n-&gt;<span class="keywordtype">id</span>())
<a name="l00385"></a>00385         <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">_next_free_unpartitioned_node_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00386"></a>00386       <span class="keywordflow">if</span> (_next_free_local_node_id &lt;= n-&gt;<span class="keywordtype">id</span>())
<a name="l00387"></a>00387         <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() + 1;
<a name="l00388"></a>00388     }
<a name="l00389"></a>00389 
<a name="l00390"></a>00390   <span class="comment">// Don&#39;t try to overwrite existing nodes</span>
<a name="l00391"></a>00391   libmesh_assert (!<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]);
<a name="l00392"></a>00392 
<a name="l00393"></a>00393   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = n;
<a name="l00394"></a>00394   
<a name="l00395"></a>00395   <span class="comment">// Make the cached elem data more accurate</span>
<a name="l00396"></a>00396   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>++;
<a name="l00397"></a>00397   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(<a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a>, n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()+1);
<a name="l00398"></a>00398   
<a name="l00399"></a>00399 <span class="comment">// Unpartitioned nodes should be added on every processor</span>
<a name="l00400"></a>00400 <span class="comment">// And shouldn&#39;t be added in the same batch as ghost nodes</span>
<a name="l00401"></a>00401 <span class="comment">// But we might be just adding on processor 0 to</span>
<a name="l00402"></a>00402 <span class="comment">// broadcast later</span>
<a name="l00403"></a>00403 <span class="preprocessor">#if 0</span>
<a name="l00404"></a>00404 <span class="preprocessor"></span><span class="preprocessor">#ifdef DEBUG</span>
<a name="l00405"></a>00405 <span class="preprocessor"></span>  <span class="keywordflow">if</span> (node_procid == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00406"></a>00406     {
<a name="l00407"></a>00407       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> node_id = n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00408"></a>00408       <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(node_id);
<a name="l00409"></a>00409       libmesh_assert(node_id == n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00410"></a>00410     }
<a name="l00411"></a>00411 <span class="preprocessor">#endif</span>
<a name="l00412"></a>00412 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00413"></a>00413 <span class="preprocessor"></span>
<a name="l00414"></a>00414   <span class="keywordflow">return</span> n;
<a name="l00415"></a>00415 }
<a name="l00416"></a>00416 
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a85ef9faafacd3006a31317a7f8d8ef4c">00419</a> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a85ef9faafacd3006a31317a7f8d8ef4c">ParallelMesh::insert_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n)
<a name="l00420"></a>00420 {
<a name="l00421"></a>00421   <span class="comment">// If we already have this node we cannot</span>
<a name="l00422"></a>00422   <span class="comment">// simply delete it, because we may have elements</span>
<a name="l00423"></a>00423   <span class="comment">// which are attached to its address.</span>
<a name="l00424"></a>00424   <span class="comment">//</span>
<a name="l00425"></a>00425   <span class="comment">// Instead, call the Node = Point assignment operator</span>
<a name="l00426"></a>00426   <span class="comment">// to overwrite the spatial coordinates (but keep its</span>
<a name="l00427"></a>00427   <span class="comment">// address), delete the provided node, and return the</span>
<a name="l00428"></a>00428   <span class="comment">// address of the one we already had.</span>
<a name="l00429"></a>00429   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.count(n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()))
<a name="l00430"></a>00430     {
<a name="l00431"></a>00431       <a class="code" href="classlibMesh_1_1Node.php">Node</a> *my_n = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()];
<a name="l00432"></a>00432 
<a name="l00433"></a>00433       *my_n = <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1Point.php">Point</a><span class="keyword">&gt;</span>(*n);
<a name="l00434"></a>00434       <span class="keyword">delete</span> n;
<a name="l00435"></a>00435       n = my_n;
<a name="l00436"></a>00436     }
<a name="l00437"></a>00437   <span class="keywordflow">else</span>
<a name="l00438"></a>00438     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] = n;
<a name="l00439"></a>00439 
<a name="l00440"></a>00440   <span class="keywordflow">return</span> n;
<a name="l00441"></a>00441 }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ab5499379a814832a4d8ebd8b721b2a91">00445</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab5499379a814832a4d8ebd8b721b2a91">ParallelMesh::delete_node</a>(<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n)
<a name="l00446"></a>00446 {
<a name="l00447"></a>00447   libmesh_assert (n != NULL);
<a name="l00448"></a>00448   libmesh_assert (<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()] != NULL);
<a name="l00449"></a>00449 
<a name="l00450"></a>00450   <span class="comment">// Delete the node from the BoundaryInfo object</span>
<a name="l00451"></a>00451   this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove(n);
<a name="l00452"></a>00452 
<a name="l00453"></a>00453   <span class="comment">// And from the container</span>
<a name="l00454"></a>00454   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(n-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00455"></a>00455   
<a name="l00456"></a>00456   <span class="comment">// delete the node</span>
<a name="l00457"></a>00457   <span class="keyword">delete</span> n;
<a name="l00458"></a>00458 }
<a name="l00459"></a>00459 
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a332329d86145018a84e41e3223565a56">00462</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a332329d86145018a84e41e3223565a56">ParallelMesh::renumber_node</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id,
<a name="l00463"></a>00463                                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id)
<a name="l00464"></a>00464 {
<a name="l00465"></a>00465   <a class="code" href="classlibMesh_1_1Node.php">Node</a> *<a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[old_id];
<a name="l00466"></a>00466   libmesh_assert (node);
<a name="l00467"></a>00467   libmesh_assert (node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>() == old_id);
<a name="l00468"></a>00468 
<a name="l00469"></a>00469   node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a7fe214a46de8b1773a2fa56568f826d4">set_id</a>(new_id);
<a name="l00470"></a>00470   libmesh_assert (!<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[new_id]);
<a name="l00471"></a>00471   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>[new_id] = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a>;
<a name="l00472"></a>00472   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(old_id);
<a name="l00473"></a>00473 }
<a name="l00474"></a>00474 
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 
<a name="l00477"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">00477</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">ParallelMesh::clear</a> ()
<a name="l00478"></a>00478 {
<a name="l00479"></a>00479   <span class="comment">// Call parent clear function</span>
<a name="l00480"></a>00480   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">MeshBase::clear</a>();
<a name="l00481"></a>00481 
<a name="l00482"></a>00482   
<a name="l00483"></a>00483   <span class="comment">// Clear our elements and nodes</span>
<a name="l00484"></a>00484   {
<a name="l00485"></a>00485     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2dab276070364298e00df807046df55c">elem_iterator_imp</a>        it = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>();
<a name="l00486"></a>00486     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2dab276070364298e00df807046df55c">elem_iterator_imp</a> end = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00487"></a>00487 
<a name="l00488"></a>00488     <span class="comment">// There is no need to remove the elements from</span>
<a name="l00489"></a>00489     <span class="comment">// the BoundaryInfo data structure since we</span>
<a name="l00490"></a>00490     <span class="comment">// already cleared it.</span>
<a name="l00491"></a>00491     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00492"></a>00492       <span class="keyword">delete</span> *it;
<a name="l00493"></a>00493 
<a name="l00494"></a>00494     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>.clear();
<a name="l00495"></a>00495   }
<a name="l00496"></a>00496 
<a name="l00497"></a>00497   <span class="comment">// clear the nodes data structure</span>
<a name="l00498"></a>00498   {
<a name="l00499"></a>00499     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">node_iterator_imp</a> it  = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>();
<a name="l00500"></a>00500     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">node_iterator_imp</a> end = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00501"></a>00501 
<a name="l00502"></a>00502     <span class="comment">// There is no need to remove the nodes from</span>
<a name="l00503"></a>00503     <span class="comment">// the BoundaryInfo data structure since we</span>
<a name="l00504"></a>00504     <span class="comment">// already cleared it.</span>
<a name="l00505"></a>00505     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00506"></a>00506       <span class="keyword">delete</span> *it;
<a name="l00507"></a>00507     
<a name="l00508"></a>00508     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.clear();
<a name="l00509"></a>00509   }
<a name="l00510"></a>00510 
<a name="l00511"></a>00511   <span class="comment">// We&#39;re no longer distributed if we were before</span>
<a name="l00512"></a>00512   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a> = <span class="keyword">true</span>;
<a name="l00513"></a>00513 
<a name="l00514"></a>00514   <span class="comment">// Correct our caches</span>
<a name="l00515"></a>00515   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = 0;
<a name="l00516"></a>00516   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a> = 0;
<a name="l00517"></a>00517   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = 0;
<a name="l00518"></a>00518   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = 0;
<a name="l00519"></a>00519   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> = <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>();
<a name="l00520"></a>00520   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> = <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>();
<a name="l00521"></a>00521   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">_next_free_unpartitioned_node_id</a> = <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>();
<a name="l00522"></a>00522   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af2cf69eaed1ebdd13c4ede5429158649">_next_free_unpartitioned_elem_id</a> = <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>();
<a name="l00523"></a>00523 }
<a name="l00524"></a>00524 
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a251d6a0c667fdc43367f7524e15ebc98">00527</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a251d6a0c667fdc43367f7524e15ebc98">ParallelMesh::partition</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parts)
<a name="l00528"></a>00528 {
<a name="l00529"></a>00529   <span class="comment">// FIXME: We still need to MeshCommunication::redistribute to handle</span>
<a name="l00530"></a>00530   <span class="comment">// dof indices before repartitioning won&#39;t break AMR</span>
<a name="l00531"></a>00531   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a>())
<a name="l00532"></a>00532     <span class="keywordflow">return</span>;
<a name="l00533"></a>00533 
<a name="l00534"></a>00534   <span class="keywordflow">if</span>(!<a class="code" href="classlibMesh_1_1MeshBase.php#a5745bd8ce965d537c6bc95faf78e9f49">skip_partitioning</a>())
<a name="l00535"></a>00535   { 
<a name="l00536"></a>00536     <span class="comment">// Call base class&#39; partition() function.</span>
<a name="l00537"></a>00537     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a251d6a0c667fdc43367f7524e15ebc98">MeshBase::partition</a>(n_parts);
<a name="l00538"></a>00538 
<a name="l00539"></a>00539     <span class="comment">// If this is a truly parallel mesh, go through the redistribution/gather/delete remote steps</span>
<a name="l00540"></a>00540     <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a>())
<a name="l00541"></a>00541       {
<a name="l00542"></a>00542         <span class="comment">// Construct a MeshCommunication object to actually redistribute the nodes</span>
<a name="l00543"></a>00543         <span class="comment">// and elements according to the partitioner, and then to re-gather the neighbors.</span>
<a name="l00544"></a>00544         <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a> mc;
<a name="l00545"></a>00545         mc.<a class="code" href="classlibMesh_1_1MeshCommunication.php#a64195de35a3f834f9393aad8b6ca1be2">redistribute</a>(*<span class="keyword">this</span>);
<a name="l00546"></a>00546         mc.<a class="code" href="classlibMesh_1_1MeshCommunication.php#a1b5bcfce3b9a9daccb4abb795a0638e0">gather_neighboring_elements</a>(*<span class="keyword">this</span>);
<a name="l00547"></a>00547 
<a name="l00548"></a>00548         <span class="comment">// Is this necessary?  If we are called from prepare_for_use(), this will be called</span>
<a name="l00549"></a>00549         <span class="comment">// anyway... but users can always call partition directly, in which case we do need</span>
<a name="l00550"></a>00550         <span class="comment">// to call delete_remote_elements()...</span>
<a name="l00551"></a>00551         this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a01627aec710b8452f66d3610bc461a8b">delete_remote_elements</a>();
<a name="l00552"></a>00552       }
<a name="l00553"></a>00553   }
<a name="l00554"></a>00554 }
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00559"></a>00559 <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab203ea7e93074e74f2eb920d285bc88c">ParallelMesh::libmesh_assert_valid_parallel_object_ids</a> 
<a name="l00560"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ab203ea7e93074e74f2eb920d285bc88c">00560</a>   (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;T*&gt;</a> &amp;objects) <span class="keyword">const</span>
<a name="l00561"></a>00561 {
<a name="l00562"></a>00562   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00563"></a>00563   parallel_only();
<a name="l00564"></a>00564 
<a name="l00565"></a>00565   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pmax_elem_id = this-&gt;parallel_max_elem_id();
<a name="l00566"></a>00566 
<a name="l00567"></a>00567   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != pmax_elem_id; ++i)
<a name="l00568"></a>00568     {
<a name="l00569"></a>00569       T* obj = objects[i]; <span class="comment">// Returns NULL if there&#39;s no map entry</span>
<a name="l00570"></a>00570 
<a name="l00571"></a>00571       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dofid = obj &amp;&amp; obj-&gt;valid_id() ?
<a name="l00572"></a>00572         obj-&gt;id() : <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>;
<a name="l00573"></a>00573       <span class="comment">// Local lookups by id should return the requested object</span>
<a name="l00574"></a>00574       libmesh_assert(!obj || obj-&gt;id() == i);
<a name="l00575"></a>00575 
<a name="l00576"></a>00576       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_dofid = dofid;
<a name="l00577"></a>00577       <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(min_dofid);
<a name="l00578"></a>00578       <span class="comment">// All processors with an object should agree on id</span>
<a name="l00579"></a>00579       libmesh_assert (!obj || dofid == min_dofid);
<a name="l00580"></a>00580 
<a name="l00581"></a>00581       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procid = obj &amp;&amp; obj-&gt;valid_processor_id() ?
<a name="l00582"></a>00582         obj-&gt;processor_id() : <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>;
<a name="l00583"></a>00583 
<a name="l00584"></a>00584       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_procid = procid;
<a name="l00585"></a>00585       <a class="code" href="namespacelibMesh_1_1Parallel.php#ad612bc0ffd617ebe5f47ffeecd7aae96">Parallel::min</a>(min_procid);
<a name="l00586"></a>00586       <span class="comment">// All processors with an object should agree on processor id</span>
<a name="l00587"></a>00587       libmesh_assert (!obj || procid == min_procid);
<a name="l00588"></a>00588       <span class="comment">// I should own any object another processor thinks I do</span>
<a name="l00589"></a>00589       libmesh_assert (min_procid != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() || obj);
<a name="l00590"></a>00590     }
<a name="l00591"></a>00591 }
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 
<a name="l00595"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">00595</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">ParallelMesh::libmesh_assert_valid_parallel_ids</a> ()<span class="keyword"> const</span>
<a name="l00596"></a>00596 <span class="keyword"></span>{
<a name="l00597"></a>00597   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab203ea7e93074e74f2eb920d285bc88c">libmesh_assert_valid_parallel_object_ids</a> (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>);
<a name="l00598"></a>00598   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab203ea7e93074e74f2eb920d285bc88c">libmesh_assert_valid_parallel_object_ids</a> (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>);
<a name="l00599"></a>00599 }
<a name="l00600"></a>00600 
<a name="l00601"></a>00601 
<a name="l00602"></a>00602 
<a name="l00603"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">00603</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">ParallelMesh::libmesh_assert_valid_parallel_flags</a> ()<span class="keyword"> const</span>
<a name="l00604"></a>00604 <span class="keyword"></span>{
<a name="l00605"></a>00605 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00606"></a>00606 <span class="preprocessor"></span>  <span class="comment">// This function must be run on all processors at once</span>
<a name="l00607"></a>00607   parallel_only();
<a name="l00608"></a>00608 
<a name="l00609"></a>00609   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pmax_elem_id = this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">parallel_max_elem_id</a>();
<a name="l00610"></a>00610 
<a name="l00611"></a>00611   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != pmax_elem_id; ++i)
<a name="l00612"></a>00612     {
<a name="l00613"></a>00613       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>[i]; <span class="comment">// Returns NULL if there&#39;s no map entry</span>
<a name="l00614"></a>00614 
<a name="l00615"></a>00615       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> refinement_flag   = elem ?
<a name="l00616"></a>00616         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a174bfe5b3d22e2b79000bfc816f633e6">refinement_flag</a>()) : <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00617"></a>00617       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_refinement_flag = elem ?
<a name="l00618"></a>00618         <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a53a98cf29aef9af6292c812d7b905c18">p_refinement_flag</a>()) : <a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">libMesh::invalid_uint</a>;
<a name="l00619"></a>00619 
<a name="l00620"></a>00620       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_rflag = refinement_flag;
<a name="l00621"></a>00621       <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a>(min_rflag);
<a name="l00622"></a>00622       <span class="comment">// All processors with this element should agree on flag</span>
<a name="l00623"></a>00623       libmesh_assert (!elem || min_rflag == refinement_flag);
<a name="l00624"></a>00624 
<a name="l00625"></a>00625       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> min_pflag = p_refinement_flag;
<a name="l00626"></a>00626       <span class="comment">// All processors with this element should agree on flag</span>
<a name="l00627"></a>00627       libmesh_assert (!elem || min_pflag == p_refinement_flag);
<a name="l00628"></a>00628     }
<a name="l00629"></a>00629 <span class="preprocessor">#endif // LIBMESH_ENABLE_AMR</span>
<a name="l00630"></a>00630 <span class="preprocessor"></span>}
<a name="l00631"></a>00631 
<a name="l00632"></a>00632 
<a name="l00633"></a>00633 
<a name="l00634"></a>00634 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00635"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a17d4240194816767b705e606062c720f">00635</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a17d4240194816767b705e606062c720f">ParallelMesh::renumber_dof_objects</a> (<a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;T*&gt;</a> &amp;objects)
<a name="l00636"></a>00636 {
<a name="l00637"></a>00637   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00638"></a>00638   parallel_only();
<a name="l00639"></a>00639 
<a name="l00640"></a>00640   <span class="keyword">typedef</span> <span class="keyword">typename</span> <a class="code" href="classlibMesh_1_1mapvector_1_1veclike__iterator.php">mapvector&lt;T*&gt;::veclike_iterator</a> object_iterator;
<a name="l00641"></a>00641 
<a name="l00642"></a>00642   <span class="comment">// In parallel we may not know what objects other processors have.</span>
<a name="l00643"></a>00643   <span class="comment">// Start by figuring out how many</span>
<a name="l00644"></a>00644   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> unpartitioned_objects = 0;
<a name="l00645"></a>00645 
<a name="l00646"></a>00646   std::vector&lt;unsigned int&gt;
<a name="l00647"></a>00647     ghost_objects_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   object_iterator it  = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>();
<a name="l00650"></a>00650   object_iterator end = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00651"></a>00651 
<a name="l00652"></a>00652   <span class="keywordflow">for</span> (; it != end;)
<a name="l00653"></a>00653     {
<a name="l00654"></a>00654       T *obj = *it;
<a name="l00655"></a>00655 
<a name="l00656"></a>00656       <span class="comment">// Remove any NULL container entries while we&#39;re here,</span>
<a name="l00657"></a>00657       <span class="comment">// being careful not to invalidate our iterator</span>
<a name="l00658"></a>00658       <span class="keywordflow">if</span> (!*it)
<a name="l00659"></a>00659         objects.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(it++);
<a name="l00660"></a>00660       <span class="keywordflow">else</span>
<a name="l00661"></a>00661         {
<a name="l00662"></a>00662           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> obj_procid = obj-&gt;processor_id();
<a name="l00663"></a>00663           <span class="keywordflow">if</span> (obj_procid == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00664"></a>00664             unpartitioned_objects++;
<a name="l00665"></a>00665           <span class="keywordflow">else</span>
<a name="l00666"></a>00666             ghost_objects_from_proc[obj_procid]++;
<a name="l00667"></a>00667           ++it;
<a name="l00668"></a>00668         }
<a name="l00669"></a>00669     }
<a name="l00670"></a>00670 
<a name="l00671"></a>00671   std::vector&lt;unsigned int&gt; objects_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00672"></a>00672   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac88199c0b21d0e97e7f74c005fb24c46">Parallel::allgather</a>(ghost_objects_from_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()],
<a name="l00673"></a>00673                       objects_on_proc);
<a name="l00674"></a>00674 
<a name="l00675"></a>00675 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00676"></a>00676 <span class="preprocessor"></span>  <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_unpartitioned_objects = unpartitioned_objects;
<a name="l00677"></a>00677   <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">Parallel::max</a>(global_unpartitioned_objects);
<a name="l00678"></a>00678   libmesh_assert(global_unpartitioned_objects == unpartitioned_objects);
<a name="l00679"></a>00679   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++p)
<a name="l00680"></a>00680     libmesh_assert(ghost_objects_from_proc[p] &lt;= objects_on_proc[p]);
<a name="l00681"></a>00681 <span class="preprocessor">#endif</span>
<a name="l00682"></a>00682 <span class="preprocessor"></span>
<a name="l00683"></a>00683   <span class="comment">// We&#39;ll renumber objects in blocks by processor id</span>
<a name="l00684"></a>00684   std::vector&lt;unsigned int&gt; first_object_on_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00685"></a>00685   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=1; i != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++i)
<a name="l00686"></a>00686     first_object_on_proc[i] = first_object_on_proc[i-1] +
<a name="l00687"></a>00687                               objects_on_proc[i-1];
<a name="l00688"></a>00688   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> next_id = first_object_on_proc[<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>()];
<a name="l00689"></a>00689   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_free_id =
<a name="l00690"></a>00690     first_object_on_proc[<a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>()-1] +
<a name="l00691"></a>00691     objects_on_proc[<a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>()-1] + 
<a name="l00692"></a>00692     unpartitioned_objects;
<a name="l00693"></a>00693 
<a name="l00694"></a>00694   <span class="comment">// First set new local object ids and build request sets </span>
<a name="l00695"></a>00695   <span class="comment">// for non-local object ids</span>
<a name="l00696"></a>00696   
<a name="l00697"></a>00697   <span class="comment">// Request sets to send to each processor</span>
<a name="l00698"></a>00698   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00699"></a>00699     requested_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   <span class="comment">// We know how many objects live on each processor, so reseve() space for</span>
<a name="l00702"></a>00702   <span class="comment">// each.</span>
<a name="l00703"></a>00703   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=0; p != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++p)
<a name="l00704"></a>00704     <span class="keywordflow">if</span> (p != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>())
<a name="l00705"></a>00705       requested_ids[p].reserve(ghost_objects_from_proc[p]);
<a name="l00706"></a>00706 
<a name="l00707"></a>00707   end = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00708"></a>00708   <span class="keywordflow">for</span> (it = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(); it != end; ++it)
<a name="l00709"></a>00709     {
<a name="l00710"></a>00710       T *obj = *it;
<a name="l00711"></a>00711       <span class="keywordflow">if</span> (obj-&gt;processor_id() == <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>())
<a name="l00712"></a>00712         obj-&gt;set_id(next_id++);
<a name="l00713"></a>00713       <span class="keywordflow">else</span> <span class="keywordflow">if</span> (obj-&gt;processor_id() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00714"></a>00714         requested_ids[obj-&gt;processor_id()].push_back(obj-&gt;id());
<a name="l00715"></a>00715     }
<a name="l00716"></a>00716 
<a name="l00717"></a>00717   <span class="comment">// Next set ghost object ids from other processors</span>
<a name="l00718"></a>00718   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00719"></a>00719     {
<a name="l00720"></a>00720       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++p)
<a name="l00721"></a>00721         {
<a name="l00722"></a>00722           <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00723"></a>00723           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>() + p) %
<a name="l00724"></a>00724                                  <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00725"></a>00725           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>() +
<a name="l00726"></a>00726                                    <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>() - p) %
<a name="l00727"></a>00727                                    <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00728"></a>00728           std::vector&lt;unsigned int&gt; request_to_fill;
<a name="l00729"></a>00729           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_ids[procup],
<a name="l00730"></a>00730                                  procdown, request_to_fill);
<a name="l00731"></a>00731 
<a name="l00732"></a>00732           <span class="comment">// Fill those requests</span>
<a name="l00733"></a>00733           std::vector&lt;unsigned int&gt; new_ids(request_to_fill.size());
<a name="l00734"></a>00734           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill.size(); ++i)
<a name="l00735"></a>00735             {
<a name="l00736"></a>00736               T *obj = objects[request_to_fill[i]];
<a name="l00737"></a>00737               libmesh_assert(obj);
<a name="l00738"></a>00738               libmesh_assert(obj-&gt;processor_id() == <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>());
<a name="l00739"></a>00739               new_ids[i] = obj-&gt;id();
<a name="l00740"></a>00740               libmesh_assert(new_ids[i] &gt;=
<a name="l00741"></a>00741                      first_object_on_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l00742"></a>00742               libmesh_assert(new_ids[i] &lt;
<a name="l00743"></a>00743                      first_object_on_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()] +
<a name="l00744"></a>00744                      objects_on_proc[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()]);
<a name="l00745"></a>00745             }
<a name="l00746"></a>00746 
<a name="l00747"></a>00747           <span class="comment">// Trade back the results</span>
<a name="l00748"></a>00748           std::vector&lt;unsigned int&gt; filled_request;
<a name="l00749"></a>00749           <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, new_ids,
<a name="l00750"></a>00750                                  procup, filled_request);
<a name="l00751"></a>00751 
<a name="l00752"></a>00752           <span class="comment">// And copy the id changes we&#39;ve now been informed of</span>
<a name="l00753"></a>00753           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != filled_request.size(); ++i)
<a name="l00754"></a>00754             {
<a name="l00755"></a>00755               T *obj = objects[requested_ids[procup][i]];
<a name="l00756"></a>00756               libmesh_assert (obj);
<a name="l00757"></a>00757               libmesh_assert (obj-&gt;processor_id() == procup);
<a name="l00758"></a>00758               libmesh_assert(filled_request[i] &gt;=
<a name="l00759"></a>00759                      first_object_on_proc[procup]);
<a name="l00760"></a>00760               libmesh_assert(filled_request[i] &lt;
<a name="l00761"></a>00761                      first_object_on_proc[procup] +
<a name="l00762"></a>00762                      objects_on_proc[procup]);
<a name="l00763"></a>00763               obj-&gt;set_id(filled_request[i]);
<a name="l00764"></a>00764             }
<a name="l00765"></a>00765         }
<a name="l00766"></a>00766     }
<a name="l00767"></a>00767 
<a name="l00768"></a>00768   <span class="comment">// Next set unpartitioned object ids</span>
<a name="l00769"></a>00769   next_id = 0;
<a name="l00770"></a>00770   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>(); ++i)
<a name="l00771"></a>00771     next_id += objects_on_proc[i];
<a name="l00772"></a>00772   <span class="keywordflow">for</span> (it = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(); it != end; ++it)
<a name="l00773"></a>00773     {
<a name="l00774"></a>00774       T *obj = *it;
<a name="l00775"></a>00775       <span class="keywordflow">if</span> (obj-&gt;processor_id() == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00776"></a>00776         obj-&gt;set_id(next_id++);
<a name="l00777"></a>00777     }
<a name="l00778"></a>00778 
<a name="l00779"></a>00779   <span class="comment">// Finally shuffle around objects so that container indices</span>
<a name="l00780"></a>00780   <span class="comment">// match ids</span>
<a name="l00781"></a>00781   end = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00782"></a>00782   <span class="keywordflow">for</span> (it = objects.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(); it != end;)
<a name="l00783"></a>00783     {
<a name="l00784"></a>00784       T *obj = *it;
<a name="l00785"></a>00785       <span class="keywordflow">if</span> (obj) <span class="comment">// don&#39;t try shuffling already-NULL entries</span>
<a name="l00786"></a>00786         {
<a name="l00787"></a>00787           T *next = objects[obj-&gt;id()];
<a name="l00788"></a>00788           <span class="comment">// If we have to move this object</span>
<a name="l00789"></a>00789           <span class="keywordflow">if</span> (next != obj)
<a name="l00790"></a>00790             {
<a name="l00791"></a>00791               <span class="comment">// NULL out its original position for now</span>
<a name="l00792"></a>00792               <span class="comment">// (our shuffling may put another object there shortly)</span>
<a name="l00793"></a>00793               *it = NULL;
<a name="l00794"></a>00794 
<a name="l00795"></a>00795               <span class="comment">// There may already be another object with this id that</span>
<a name="l00796"></a>00796               <span class="comment">// needs to be moved itself</span>
<a name="l00797"></a>00797               <span class="keywordflow">while</span> (next)
<a name="l00798"></a>00798                 {
<a name="l00799"></a>00799                   <span class="comment">// We shouldn&#39;t be trying to give two objects the</span>
<a name="l00800"></a>00800                   <span class="comment">// same id</span>
<a name="l00801"></a>00801                   libmesh_assert (next-&gt;id() != obj-&gt;id());
<a name="l00802"></a>00802                   objects[obj-&gt;id()] = obj;
<a name="l00803"></a>00803                   obj = next;
<a name="l00804"></a>00804                   next = objects[obj-&gt;id()];
<a name="l00805"></a>00805                 }
<a name="l00806"></a>00806               objects[obj-&gt;id()] = obj;
<a name="l00807"></a>00807             }
<a name="l00808"></a>00808         }
<a name="l00809"></a>00809       <span class="comment">// Remove any container entries that were left as NULL,</span>
<a name="l00810"></a>00810       <span class="comment">// being careful not to invalidate our iterator</span>
<a name="l00811"></a>00811       <span class="keywordflow">if</span> (!*it)
<a name="l00812"></a>00812         objects.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(it++);
<a name="l00813"></a>00813       <span class="keywordflow">else</span>
<a name="l00814"></a>00814         ++it;
<a name="l00815"></a>00815     }
<a name="l00816"></a>00816 
<a name="l00817"></a>00817   <span class="keywordflow">return</span> first_free_id;
<a name="l00818"></a>00818 }
<a name="l00819"></a>00819 
<a name="l00820"></a>00820 
<a name="l00821"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a453795c7436d377ed4fc99b6905c363a">00821</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a453795c7436d377ed4fc99b6905c363a">ParallelMesh::renumber_nodes_and_elements</a> ()
<a name="l00822"></a>00822 {
<a name="l00823"></a>00823   START_LOG(<span class="stringliteral">&quot;renumber_nodes_and_elements()&quot;</span>, <span class="stringliteral">&quot;ParallelMesh&quot;</span>);
<a name="l00824"></a>00824 
<a name="l00825"></a>00825 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00826"></a>00826 <span class="preprocessor"></span><span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00827"></a>00827   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00828"></a>00828   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">libmesh_assert_valid_parallel_flags</a>();
<a name="l00829"></a>00829 <span class="preprocessor">#endif</span>
<a name="l00830"></a>00830 <span class="preprocessor"></span>
<a name="l00831"></a>00831   std::set&lt;unsigned int&gt; used_nodes;
<a name="l00832"></a>00832 
<a name="l00833"></a>00833   <span class="comment">// flag the nodes we need</span>
<a name="l00834"></a>00834   {      
<a name="l00835"></a>00835     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a>  it = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a9efee9d54424295764266297f7315c88">elements_begin</a>();
<a name="l00836"></a>00836     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">element_iterator</a> end = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae15fa4b5b62f914b11e6abcaff8f568d">elements_end</a>();
<a name="l00837"></a>00837 
<a name="l00838"></a>00838     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00839"></a>00839       {
<a name="l00840"></a>00840         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a> = *it;
<a name="l00841"></a>00841 
<a name="l00842"></a>00842         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n != elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00843"></a>00843           used_nodes.insert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a4f70a5e5c686b9078085f650c99e1cef">node</a>(n));
<a name="l00844"></a>00844       }
<a name="l00845"></a>00845   }
<a name="l00846"></a>00846 
<a name="l00847"></a>00847   <span class="comment">// Nodes not connected to any local elements are deleted</span>
<a name="l00848"></a>00848   {
<a name="l00849"></a>00849     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">node_iterator_imp</a>  it = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>();
<a name="l00850"></a>00850     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">node_iterator_imp</a> end = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00851"></a>00851 
<a name="l00852"></a>00852     <span class="keywordflow">for</span> (; it != end;)
<a name="l00853"></a>00853       {
<a name="l00854"></a>00854         <a class="code" href="classlibMesh_1_1Node.php">Node</a> *<a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a> = *it;
<a name="l00855"></a>00855         <span class="keywordflow">if</span> (!used_nodes.count(node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()))
<a name="l00856"></a>00856           {
<a name="l00857"></a>00857             <span class="comment">// remove any boundary information associated with</span>
<a name="l00858"></a>00858             <span class="comment">// this node</span>
<a name="l00859"></a>00859             this-&gt;<a class="code" href="classlibMesh_1_1MeshBase.php#aa681e21ace583604487dbd6b544a025a">boundary_info</a>-&gt;remove (node);
<a name="l00860"></a>00860 
<a name="l00861"></a>00861             <span class="comment">// delete the node</span>
<a name="l00862"></a>00862             <span class="keyword">delete</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a>;
<a name="l00863"></a>00863 
<a name="l00864"></a>00864             <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>.<a class="code" href="classlibMesh_1_1mapvector.php#a80a02556416b62e3bb87f64a0e5c21cf">erase</a>(it++);
<a name="l00865"></a>00865           }
<a name="l00866"></a>00866         <span class="keywordflow">else</span>
<a name="l00867"></a>00867           ++it;
<a name="l00868"></a>00868       }
<a name="l00869"></a>00869   }
<a name="l00870"></a>00870 
<a name="l00871"></a>00871   <span class="comment">// Finally renumber all the elements</span>
<a name="l00872"></a>00872   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a> = this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a17d4240194816767b705e606062c720f">renumber_dof_objects</a> (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>);
<a name="l00873"></a>00873   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>;
<a name="l00874"></a>00874   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>;
<a name="l00875"></a>00875 
<a name="l00876"></a>00876   <span class="comment">// and all the remaining nodes</span>
<a name="l00877"></a>00877   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a> = this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a17d4240194816767b705e606062c720f">renumber_dof_objects</a> (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>);
<a name="l00878"></a>00878   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>;
<a name="l00879"></a>00879   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>;
<a name="l00880"></a>00880 
<a name="l00881"></a>00881   <span class="comment">// And figure out what IDs we should use when adding new nodes and</span>
<a name="l00882"></a>00882   <span class="comment">// new elements</span>
<a name="l00883"></a>00883   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cycle = <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>()+1;
<a name="l00884"></a>00884   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> % cycle;
<a name="l00885"></a>00885   <span class="keywordflow">if</span> (offset)
<a name="l00886"></a>00886     <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> += cycle - offset;
<a name="l00887"></a>00887   <a class="code" href="classlibMesh_1_1ParallelMesh.php#af2cf69eaed1ebdd13c4ede5429158649">_next_free_unpartitioned_elem_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> +
<a name="l00888"></a>00888                                      <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>();
<a name="l00889"></a>00889   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>();
<a name="l00890"></a>00890 
<a name="l00891"></a>00891   offset = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> % cycle;
<a name="l00892"></a>00892   <span class="keywordflow">if</span> (offset)
<a name="l00893"></a>00893     <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> += cycle - offset;
<a name="l00894"></a>00894   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">_next_free_unpartitioned_node_id</a> = <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> +
<a name="l00895"></a>00895                                      <a class="code" href="classlibMesh_1_1MeshBase.php#a8b4ca46b2f69b29d670c737ba2b38600">libMesh::n_processors</a>();
<a name="l00896"></a>00896   <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a> += <a class="code" href="classlibMesh_1_1MeshBase.php#aa557872c33163622cc66645fc393c925">libMesh::processor_id</a>();
<a name="l00897"></a>00897 
<a name="l00898"></a>00898 <span class="comment">// Make sure our caches are up to date and our</span>
<a name="l00899"></a>00899 <span class="comment">// DofObjects are well packed</span>
<a name="l00900"></a>00900 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00901"></a>00901 <span class="preprocessor"></span>  libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">parallel_n_nodes</a>());
<a name="l00902"></a>00902   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">parallel_n_elem</a>());
<a name="l00903"></a>00903   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">parallel_max_node_id</a>());
<a name="l00904"></a>00904   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">parallel_max_elem_id</a>());
<a name="l00905"></a>00905   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>());
<a name="l00906"></a>00906   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>());
<a name="l00907"></a>00907 
<a name="l00908"></a>00908   <span class="comment">// Make sure we didn&#39;t miss any nodes</span>
<a name="l00909"></a>00909   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a4413b39e0439b2e5535c9a9f962ea3fd">MeshTools::libmesh_assert_valid_node_procids</a>(*<span class="keyword">this</span>);
<a name="l00910"></a>00910     
<a name="l00911"></a>00911   <span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l00912"></a>00912   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l00913"></a>00913   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">libmesh_assert_valid_parallel_flags</a>();
<a name="l00914"></a>00914 
<a name="l00915"></a>00915 <span class="comment">// And make sure we&#39;ve made our numbering monotonic</span>
<a name="l00916"></a>00916   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1968ff1c8ed3fdc7f1c23e6b8ec322f8">MeshTools::libmesh_assert_valid_elem_ids</a>(*<span class="keyword">this</span>);
<a name="l00917"></a>00917 <span class="preprocessor">#endif</span>
<a name="l00918"></a>00918 <span class="preprocessor"></span>
<a name="l00919"></a>00919   STOP_LOG(<span class="stringliteral">&quot;renumber_nodes_and_elements()&quot;</span>, <span class="stringliteral">&quot;ParallelMesh&quot;</span>);
<a name="l00920"></a>00920 }
<a name="l00921"></a>00921 
<a name="l00922"></a>00922 
<a name="l00923"></a>00923 
<a name="l00924"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a362b615a09ac9d4c6884d14858bfffda">00924</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a362b615a09ac9d4c6884d14858bfffda">ParallelMesh::fix_broken_node_and_element_numbering</a> ()
<a name="l00925"></a>00925 {
<a name="l00926"></a>00926   <span class="comment">// We need access to iterators for the underlying containers,</span>
<a name="l00927"></a>00927   <span class="comment">// not the mapvector&lt;&gt; reimplementations.</span>
<a name="l00928"></a>00928   <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Node*&gt;::maptype</a> &amp;nodes = this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>;
<a name="l00929"></a>00929   <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Elem*&gt;::maptype</a> &amp;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a>  = this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>;
<a name="l00930"></a>00930   
<a name="l00931"></a>00931   <span class="comment">// Nodes first</span>
<a name="l00932"></a>00932   {
<a name="l00933"></a>00933     <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Node*&gt;::maptype::iterator</a>
<a name="l00934"></a>00934       it  = nodes.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(),
<a name="l00935"></a>00935       end = nodes.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00936"></a>00936 
<a name="l00937"></a>00937     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00938"></a>00938       <span class="keywordflow">if</span> (it-&gt;second != NULL)
<a name="l00939"></a>00939         it-&gt;second-&gt;set_id() = it-&gt;first;
<a name="l00940"></a>00940   }
<a name="l00941"></a>00941 
<a name="l00942"></a>00942   <span class="comment">// Elements next</span>
<a name="l00943"></a>00943   {
<a name="l00944"></a>00944     <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Elem*&gt;::maptype::iterator</a>
<a name="l00945"></a>00945       it  = elem.<a class="code" href="classlibMesh_1_1mapvector.php#a707b45f1d69a9ef9a214343b85d402da">begin</a>(),
<a name="l00946"></a>00946       end = elem.<a class="code" href="classlibMesh_1_1mapvector.php#a89fd9cbe464dc374f033283ecbb9d200">end</a>();
<a name="l00947"></a>00947 
<a name="l00948"></a>00948     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00949"></a>00949       <span class="keywordflow">if</span> (it-&gt;second != NULL)
<a name="l00950"></a>00950         it-&gt;second-&gt;set_id() = it-&gt;first;
<a name="l00951"></a>00951   }
<a name="l00952"></a>00952 }
<a name="l00953"></a>00953 
<a name="l00954"></a>00954 
<a name="l00955"></a>00955 
<a name="l00956"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a0eda57eedc9bda3d305281fc7640aa09">00956</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0eda57eedc9bda3d305281fc7640aa09">ParallelMesh::n_active_elem</a> ()<span class="keyword"> const</span>
<a name="l00957"></a>00957 <span class="keyword"></span>{
<a name="l00958"></a>00958   parallel_only();
<a name="l00959"></a>00959 
<a name="l00960"></a>00960   <span class="comment">// Get local active elements first</span>
<a name="l00961"></a>00961   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> active_elements =
<a name="l00962"></a>00962     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a8523aa7490f182df9ed52422b62ce1b8">active_local_elements_begin</a>(),
<a name="l00963"></a>00963                                              this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ad64cb66d3478d53dff68cb1801e7f675">active_local_elements_end</a>()));
<a name="l00964"></a>00964   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(active_elements);
<a name="l00965"></a>00965 
<a name="l00966"></a>00966   <span class="comment">// Then add unpartitioned active elements, which should exist on</span>
<a name="l00967"></a>00967   <span class="comment">// every processor</span>
<a name="l00968"></a>00968   active_elements +=
<a name="l00969"></a>00969     <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(std::distance
<a name="l00970"></a>00970       (this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84dd911088eb2db83dece207ae50878">active_pid_elements_begin</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>),
<a name="l00971"></a>00971        this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a76bebba197955acced2e10deba2052f6">active_pid_elements_end</a>(<a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)));
<a name="l00972"></a>00972   <span class="keywordflow">return</span> active_elements;
<a name="l00973"></a>00973 }
<a name="l00974"></a>00974 
<a name="l00975"></a>00975 
<a name="l00976"></a>00976 
<a name="l00977"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a01627aec710b8452f66d3610bc461a8b">00977</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a01627aec710b8452f66d3610bc461a8b">ParallelMesh::delete_remote_elements</a>()
<a name="l00978"></a>00978 {
<a name="l00979"></a>00979 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00980"></a>00980 <span class="preprocessor"></span><span class="comment">// Make sure our neighbor links are all fine</span>
<a name="l00981"></a>00981   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00982"></a>00982 <span class="preprocessor">#endif</span>
<a name="l00983"></a>00983 <span class="preprocessor"></span>
<a name="l00984"></a>00984   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a> = <span class="keyword">false</span>;
<a name="l00985"></a>00985   <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#a4a0107f13a8af6e904a6067b19d4f5be">delete_remote_elements</a>(*<span class="keyword">this</span>, <a class="code" href="classlibMesh_1_1ParallelMesh.php#a68988aa2a6bcb8c9a4d3ca8bcec0dd79">_extra_ghost_elems</a>);
<a name="l00986"></a>00986 
<a name="l00987"></a>00987 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00988"></a>00988 <span class="preprocessor"></span><span class="comment">// Make sure our caches are up to date and our</span>
<a name="l00989"></a>00989 <span class="comment">// DofObjects are well packed</span>
<a name="l00990"></a>00990   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">parallel_n_nodes</a>());
<a name="l00991"></a>00991   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">parallel_n_elem</a>());
<a name="l00992"></a>00992   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">parallel_max_node_id</a>());
<a name="l00993"></a>00993   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">parallel_max_elem_id</a>());
<a name="l00994"></a>00994   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>());
<a name="l00995"></a>00995   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>());
<a name="l00996"></a>00996 
<a name="l00997"></a>00997 <span class="comment">// Make sure our neighbor links are all fine</span>
<a name="l00998"></a>00998   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l00999"></a>00999 
<a name="l01000"></a>01000 <span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l01001"></a>01001   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l01002"></a>01002   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">libmesh_assert_valid_parallel_flags</a>();
<a name="l01003"></a>01003 
<a name="l01004"></a>01004 <span class="comment">// And make sure our numbering is still monotonic</span>
<a name="l01005"></a>01005   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a1968ff1c8ed3fdc7f1c23e6b8ec322f8">MeshTools::libmesh_assert_valid_elem_ids</a>(*<span class="keyword">this</span>);
<a name="l01006"></a>01006 <span class="preprocessor">#endif</span>
<a name="l01007"></a>01007 <span class="preprocessor"></span>}
<a name="l01008"></a>01008 
<a name="l01009"></a>01009 
<a name="l01010"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a90ac68a290148e33610a5f5cd5a68cb9">01010</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a90ac68a290148e33610a5f5cd5a68cb9">ParallelMesh::insert_extra_ghost_elem</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e)
<a name="l01011"></a>01011 {
<a name="l01012"></a>01012   <span class="comment">// First insert the elem like normal</span>
<a name="l01013"></a>01013   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a467afea44aacb57e0e57eb5de3f8aa86">insert_elem</a>(e);
<a name="l01014"></a>01014 
<a name="l01015"></a>01015   <span class="comment">// Now add it to the set that won&#39;t be deleted when we call</span>
<a name="l01016"></a>01016   <span class="comment">// delete_remote_elements()</span>
<a name="l01017"></a>01017   <a class="code" href="classlibMesh_1_1ParallelMesh.php#a68988aa2a6bcb8c9a4d3ca8bcec0dd79">_extra_ghost_elems</a>.insert(e);
<a name="l01018"></a>01018 }
<a name="l01019"></a>01019 
<a name="l01020"></a>01020 
<a name="l01021"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ac88199c0b21d0e97e7f74c005fb24c46">01021</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac88199c0b21d0e97e7f74c005fb24c46">ParallelMesh::allgather</a>()
<a name="l01022"></a>01022 {
<a name="l01023"></a>01023   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a>)
<a name="l01024"></a>01024     <span class="keywordflow">return</span>;
<a name="l01025"></a>01025   <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a> = <span class="keyword">true</span>;
<a name="l01026"></a>01026   <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#a69151d8425723f28381fea5fdd627bdb">allgather</a>(*<span class="keyword">this</span>);
<a name="l01027"></a>01027 
<a name="l01028"></a>01028 <span class="comment">// Make sure our caches are up to date and our</span>
<a name="l01029"></a>01029 <span class="comment">// DofObjects are well packed</span>
<a name="l01030"></a>01030 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l01031"></a>01031 <span class="preprocessor"></span>  libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">parallel_n_nodes</a>());
<a name="l01032"></a>01032   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">parallel_n_elem</a>());
<a name="l01033"></a>01033   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">parallel_max_node_id</a>());
<a name="l01034"></a>01034   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">parallel_max_elem_id</a>());
<a name="l01035"></a>01035   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a>());
<a name="l01036"></a>01036   libmesh_assert(this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a>() == this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a>());
<a name="l01037"></a>01037 
<a name="l01038"></a>01038 <span class="comment">// Make sure our neighbor links are all fine</span>
<a name="l01039"></a>01039   <a class="code" href="namespacelibMesh_1_1MeshTools.php#a943be6a54f82a23518dc6fc11d9bb527">MeshTools::libmesh_assert_valid_neighbors</a>(*<span class="keyword">this</span>);
<a name="l01040"></a>01040 
<a name="l01041"></a>01041 <span class="comment">// Make sure our ids and flags are consistent</span>
<a name="l01042"></a>01042   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>();
<a name="l01043"></a>01043   this-&gt;<a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">libmesh_assert_valid_parallel_flags</a>();
<a name="l01044"></a>01044 <span class="preprocessor">#endif</span>
<a name="l01045"></a>01045 <span class="preprocessor"></span>}
<a name="l01046"></a>01046 
<a name="l01047"></a>01047 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
