<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel_mesh.h</div>  </div>
</div>
<div class="contents">
<a href="parallel__mesh_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_mesh.h 4363 2011-04-19 18:51:33Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __parallel_mesh_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_mesh_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mapvector_8h.php">mapvector.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="unstructured__mesh_8h.php">unstructured_mesh.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Forward declarations</span>
<a name="l00037"></a>00037 <span class="keyword">class </span>Elem;
<a name="l00038"></a>00038 <span class="keyword">class </span>Node;
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00049"></a>00049 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00050"></a>00050 <span class="comment">// UnstructuredMesh class definition</span>
<a name="l00051"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php">00051</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053  <span class="keyword">public</span>:
<a name="l00054"></a>00054 
<a name="l00060"></a>00060   <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim=1);
<a name="l00061"></a>00061 
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1UnstructuredMesh.php">UnstructuredMesh</a>&amp; other_mesh);
<a name="l00067"></a>00067 
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php">ParallelMesh</a>&amp; other_mesh);
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#aa0e0961c8495ea9519dda9e2568186d6">00077</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa0e0961c8495ea9519dda9e2568186d6">clone</a> ()<span class="keyword"> const</span>
<a name="l00078"></a>00078 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;MeshBase&gt;</a>(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#adf412844e21c8480d126017d38bc88ee">ParallelMesh</a>(*<span class="keyword">this</span>)); }
<a name="l00079"></a>00079 
<a name="l00083"></a>00083   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab629e768ba9b128360c7323ec1133db3">~ParallelMesh</a>();
<a name="l00084"></a>00084 
<a name="l00088"></a>00088   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a7649541e7576d5246ae5192293a10153">clear</a>();
<a name="l00089"></a>00089 
<a name="l00095"></a>00095   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a251d6a0c667fdc43367f7524e15ebc98">partition</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parts=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00096"></a>00096 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">00101</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a6149774fe1885d2ee423f1398f50f847">is_serial</a> ()<span class="keyword"> const</span>
<a name="l00102"></a>00102 <span class="keyword">    </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a>; }
<a name="l00103"></a>00103 
<a name="l00109"></a>00109   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00110"></a>00110   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab203ea7e93074e74f2eb920d285bc88c">libmesh_assert_valid_parallel_object_ids</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;T*&gt;</a>&amp;) <span class="keyword">const</span>;
<a name="l00111"></a>00111 
<a name="l00117"></a>00117   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a71de7cc0384ce24b982c49b2276478b3">libmesh_assert_valid_parallel_ids</a>() <span class="keyword">const</span>;
<a name="l00118"></a>00118 
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a20683143bfb9f9a2d842f2aeb93835dd">libmesh_assert_valid_parallel_flags</a>() <span class="keyword">const</span>;
<a name="l00125"></a>00125 
<a name="l00131"></a>00131   <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00132"></a>00132   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a17d4240194816767b705e606062c720f">renumber_dof_objects</a> (<a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;T*&gt;</a>&amp;);
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a453795c7436d377ed4fc99b6905c363a">renumber_nodes_and_elements</a> ();
<a name="l00138"></a>00138 
<a name="l00143"></a>00143   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac88199c0b21d0e97e7f74c005fb24c46">allgather</a>();
<a name="l00144"></a>00144 
<a name="l00150"></a>00150   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a01627aec710b8452f66d3610bc461a8b">delete_remote_elements</a>();
<a name="l00151"></a>00151 
<a name="l00157"></a>00157   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a90ac68a290148e33610a5f5cd5a68cb9">insert_extra_ghost_elem</a>(<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">// Cached methods that can be called in serial</span>
<a name="l00160"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">00160</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#afa159384231957ca748e1c3c0ea599a4">n_nodes</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>; }
<a name="l00161"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">00161</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae9bacbf51c7089a8aada184b3ac01f2a">max_node_id</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a>; }
<a name="l00162"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a3bc142900cfe869d278d58ca69def123">00162</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a3bc142900cfe869d278d58ca69def123">reserve_nodes</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) { }
<a name="l00163"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">00163</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a54f3c1d99f06946b368fea0f40111780">n_elem</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>; }
<a name="l00164"></a>00164   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0eda57eedc9bda3d305281fc7640aa09">n_active_elem</a> () <span class="keyword">const</span>;
<a name="l00165"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">00165</a>   <span class="keyword">virtual</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac278075751b4e7501c9293dd24613ff5">max_elem_id</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a>; }
<a name="l00166"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ad5d9354473a2da35b763f8625a108917">00166</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ad5d9354473a2da35b763f8625a108917">reserve_elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) { }
<a name="l00167"></a>00167 
<a name="l00168"></a>00168   <span class="comment">// Parallel only method to update the caches</span>
<a name="l00169"></a>00169   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2539e4472fc43042afc8cc0d84e10ad5">update_parallel_id_counts</a> ();
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   <span class="comment">// And more parallel only methods to test non-cached values</span>
<a name="l00172"></a>00172   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a9639396ca8d96b4d4bff36f22fe05370">parallel_n_nodes</a> () <span class="keyword">const</span>;
<a name="l00173"></a>00173   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab412740205d3fa7bc4580f105103255f">parallel_max_node_id</a> () <span class="keyword">const</span>;
<a name="l00174"></a>00174   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a81c366a6f0f566d9966f2bf4f4bd4207">parallel_n_elem</a> () <span class="keyword">const</span>;
<a name="l00175"></a>00175   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#aed4cdeb0ddd80a2621d35fa3e61a4d0c">parallel_max_elem_id</a> () <span class="keyword">const</span>;
<a name="l00176"></a>00176 
<a name="l00180"></a>00180   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#aeec56d7bbe312b24d1a7fc78ee657a14">point</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00181"></a>00181   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp;  <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a>  (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00182"></a>00182   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>&amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#a454136f0ecbe817adbec8ec370a1540a">node</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) ;
<a name="l00183"></a>00183   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00184"></a>00184   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* &amp; <a class="code" href="classlibMesh_1_1ParallelMesh.php#af929cf6df7403ecc4d3a7e459f646bc8">node_ptr</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) ;
<a name="l00185"></a>00185   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a5b15e05a7d948285783576569d00d3e3">elem</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span> ;
<a name="l00186"></a>00186 
<a name="l00190"></a>00190   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf046537db0139a6c515dec62dedaf5d">add_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p,
<a name="l00191"></a>00191                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span> =
<a name="l00192"></a>00192                              <a class="code" href="classlibMesh_1_1DofObject.php#a1801e332bf034abe252086db668fee2d">DofObject::invalid_id</a>,
<a name="l00193"></a>00193                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id =
<a name="l00194"></a>00194                              <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00195"></a>00195   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0361fbb9f7c55066ec20b45c02db63fb">add_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n) ;
<a name="l00196"></a>00196   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Node.php">Node</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a85ef9faafacd3006a31317a7f8d8ef4c">insert_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n);
<a name="l00197"></a>00197   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab5499379a814832a4d8ebd8b721b2a91">delete_node</a> (<a class="code" href="classlibMesh_1_1Node.php">Node</a>* n) ;
<a name="l00198"></a>00198   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a332329d86145018a84e41e3223565a56">renumber_node</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id);
<a name="l00199"></a>00199   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#ad230cc153170488ad92ab4f6ee2146c7">add_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) ;
<a name="l00200"></a>00200   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1ParallelMesh.php#a467afea44aacb57e0e57eb5de3f8aa86">insert_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) ;
<a name="l00201"></a>00201   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a18ec9841a284a6c31fb69ff6e445c35c">delete_elem</a> (<a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e) ;
<a name="l00202"></a>00202   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a05e15401a367a0773ff8ca1eb9293f44">renumber_elem</a> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_id, <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_id);
<a name="l00203"></a>00203 
<a name="l00210"></a>00210   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a362b615a09ac9d4c6884d14858bfffda">fix_broken_node_and_element_numbering</a> ();
<a name="l00211"></a>00211   
<a name="l00212"></a>00212 <span class="keyword">public</span>:
<a name="l00216"></a>00216   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a9efee9d54424295764266297f7315c88">elements_begin</a> ();
<a name="l00217"></a>00217   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae15fa4b5b62f914b11e6abcaff8f568d">elements_end</a>   ();
<a name="l00218"></a>00218 
<a name="l00219"></a>00219   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a512d22e825d8049f23bc8e102affc3b7">active_elements_begin</a> ();
<a name="l00220"></a>00220   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ad287ca1c3006ce10b684c6c0f3d2da37">active_elements_end</a>   ();
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#af540a33b1fe31950f89832320cb8a61c">ancestor_elements_begin</a> ();
<a name="l00223"></a>00223   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab40d93b444171d354aa08720025d1665">ancestor_elements_end</a>   ();
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aae4d1b71c11e56cbca6b0ad8ab79d312">subactive_elements_begin</a> ();
<a name="l00226"></a>00226   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a6f5a12fcf7302dab4fcc684495aa0e80">subactive_elements_end</a>   ();
<a name="l00227"></a>00227 
<a name="l00228"></a>00228   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a50f33da779ba80ffcdc8a7dc25ec8d96">not_active_elements_begin</a> ();
<a name="l00229"></a>00229   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf71354eb1f2d398b28a4cad0cff9e0a">not_active_elements_end</a>   ();
<a name="l00230"></a>00230 
<a name="l00231"></a>00231   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2aa887ea63e54a13ccaa2bf60820dbb8">not_ancestor_elements_begin</a> ();
<a name="l00232"></a>00232   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a8a88bcdcee96961904f46156c2e4c81e">not_ancestor_elements_end</a>   ();
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0a6a2483172202f093145a9337e71cdd">not_subactive_elements_begin</a> ();
<a name="l00235"></a>00235   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a934963c6ccc072bf04465dda8f466496">not_subactive_elements_end</a>   ();
<a name="l00236"></a>00236 
<a name="l00237"></a>00237   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a7939ec2e4cd98e1895f9194a1c7d63f7">local_elements_begin</a> ();
<a name="l00238"></a>00238   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a66975b20577e03ae982e7a500c60bce3">local_elements_end</a>   ();
<a name="l00239"></a>00239 
<a name="l00240"></a>00240   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#abb1e3a037f026da07015778658d34149">not_local_elements_begin</a> ();
<a name="l00241"></a>00241   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a470683e7ff9f8e2d80648e119d92a4b3">not_local_elements_end</a>   ();
<a name="l00242"></a>00242 
<a name="l00243"></a>00243   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a8523aa7490f182df9ed52422b62ce1b8">active_local_elements_begin</a> ();
<a name="l00244"></a>00244   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ad64cb66d3478d53dff68cb1801e7f675">active_local_elements_end</a>   ();
<a name="l00245"></a>00245 
<a name="l00246"></a>00246   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a14fccab431b55fe685365c15211694e3">active_not_local_elements_begin</a> ();
<a name="l00247"></a>00247   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a392dfb5bf4db0606d1ca528082cf4218">active_not_local_elements_end</a>   ();
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab520fdc54337d02d6c15e5e56cc40bec">level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00250"></a>00250   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab035ffb9897f365a2d907f93f7ebb7d2">level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4e4527ebfb050e9ae455db7f412b6c0d">not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00253"></a>00253   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aba2e8d3253ec80636238cdd80deb8778">not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a8ae6ffb939cec26f67bf491a6b6eb9c7">local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00256"></a>00256   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab1c7a59e47bf42fe024b6c13a1989256">local_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00257"></a>00257 
<a name="l00258"></a>00258   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a973a14389cff6cb5cbb5f15861ccc64a">local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00259"></a>00259   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa4e36c82fb855de6e01472e08dcba650">local_not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level);
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a08667ae5bdf566f899b4ac8e04c22ac4">pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00262"></a>00262   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a3c5209ea2aff54710de489eadf4d97f2">pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00263"></a>00263 
<a name="l00264"></a>00264   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a09e8228e43ab2b3bf69a6291eb13cc08">type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00265"></a>00265   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a1502f39804edbe2ecc1d34211877a2b0">type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00266"></a>00266 
<a name="l00267"></a>00267   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a32c38a00c5c39d1ab524091d54a62a81">active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00268"></a>00268   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a842c71e487b1ea483deaea1da58641c9">active_type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type);
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84dd911088eb2db83dece207ae50878">active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00271"></a>00271   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a76bebba197955acced2e10deba2052f6">active_pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00272"></a>00272 
<a name="l00273"></a>00273   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a118989a5196f5c3a3ba79bea01966c6d">unpartitioned_elements_begin</a> ();
<a name="l00274"></a>00274   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac34a0c2b38beb146284f0462a13508d4">unpartitioned_elements_end</a> ();
<a name="l00275"></a>00275 
<a name="l00276"></a>00276   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac12d3b04f82cc9eb62b916906490ddf5">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id);
<a name="l00277"></a>00277   element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a1f0b15953241205be133ffbcb41fb9ca">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id);
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00283"></a>00283   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a9efee9d54424295764266297f7315c88">elements_begin</a>() <span class="keyword">const</span>;
<a name="l00284"></a>00284   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae15fa4b5b62f914b11e6abcaff8f568d">elements_end</a>()   <span class="keyword">const</span>;
<a name="l00285"></a>00285   
<a name="l00286"></a>00286   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a512d22e825d8049f23bc8e102affc3b7">active_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00287"></a>00287   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ad287ca1c3006ce10b684c6c0f3d2da37">active_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00288"></a>00288   
<a name="l00289"></a>00289   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#af540a33b1fe31950f89832320cb8a61c">ancestor_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00290"></a>00290   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab40d93b444171d354aa08720025d1665">ancestor_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00291"></a>00291   
<a name="l00292"></a>00292   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aae4d1b71c11e56cbca6b0ad8ab79d312">subactive_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00293"></a>00293   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a6f5a12fcf7302dab4fcc684495aa0e80">subactive_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00294"></a>00294   
<a name="l00295"></a>00295   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a50f33da779ba80ffcdc8a7dc25ec8d96">not_active_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00296"></a>00296   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aaf71354eb1f2d398b28a4cad0cff9e0a">not_active_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00297"></a>00297 
<a name="l00298"></a>00298   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2aa887ea63e54a13ccaa2bf60820dbb8">not_ancestor_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00299"></a>00299   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a8a88bcdcee96961904f46156c2e4c81e">not_ancestor_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0a6a2483172202f093145a9337e71cdd">not_subactive_elements_begin</a>() <span class="keyword">const</span>;
<a name="l00302"></a>00302   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a934963c6ccc072bf04465dda8f466496">not_subactive_elements_end</a>()   <span class="keyword">const</span>;
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a7939ec2e4cd98e1895f9194a1c7d63f7">local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00305"></a>00305   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a66975b20577e03ae982e7a500c60bce3">local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#abb1e3a037f026da07015778658d34149">not_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00308"></a>00308   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a470683e7ff9f8e2d80648e119d92a4b3">not_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a8523aa7490f182df9ed52422b62ce1b8">active_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00311"></a>00311   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ad64cb66d3478d53dff68cb1801e7f675">active_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00312"></a>00312 
<a name="l00313"></a>00313   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a14fccab431b55fe685365c15211694e3">active_not_local_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00314"></a>00314   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a392dfb5bf4db0606d1ca528082cf4218">active_not_local_elements_end</a>   () <span class="keyword">const</span>;
<a name="l00315"></a>00315 
<a name="l00316"></a>00316   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab520fdc54337d02d6c15e5e56cc40bec">level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00317"></a>00317   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab035ffb9897f365a2d907f93f7ebb7d2">level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00318"></a>00318 
<a name="l00319"></a>00319   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4e4527ebfb050e9ae455db7f412b6c0d">not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00320"></a>00320   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aba2e8d3253ec80636238cdd80deb8778">not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00321"></a>00321 
<a name="l00322"></a>00322   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a8ae6ffb939cec26f67bf491a6b6eb9c7">local_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00323"></a>00323   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ab1c7a59e47bf42fe024b6c13a1989256">local_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00324"></a>00324 
<a name="l00325"></a>00325   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a973a14389cff6cb5cbb5f15861ccc64a">local_not_level_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00326"></a>00326   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa4e36c82fb855de6e01472e08dcba650">local_not_level_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> level) <span class="keyword">const</span>;
<a name="l00327"></a>00327 
<a name="l00328"></a>00328   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a08667ae5bdf566f899b4ac8e04c22ac4">pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00329"></a>00329   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a3c5209ea2aff54710de489eadf4d97f2">pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00330"></a>00330 
<a name="l00331"></a>00331   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a09e8228e43ab2b3bf69a6291eb13cc08">type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00332"></a>00332   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a1502f39804edbe2ecc1d34211877a2b0">type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00333"></a>00333 
<a name="l00334"></a>00334   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a32c38a00c5c39d1ab524091d54a62a81">active_type_elements_begin</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00335"></a>00335   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a842c71e487b1ea483deaea1da58641c9">active_type_elements_end</a>   (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> type) <span class="keyword">const</span>;
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84dd911088eb2db83dece207ae50878">active_pid_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00338"></a>00338   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a76bebba197955acced2e10deba2052f6">active_pid_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a118989a5196f5c3a3ba79bea01966c6d">unpartitioned_elements_begin</a> () <span class="keyword">const</span>;
<a name="l00341"></a>00341   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac34a0c2b38beb146284f0462a13508d4">unpartitioned_elements_end</a> () <span class="keyword">const</span>;
<a name="l00342"></a>00342   
<a name="l00343"></a>00343   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac12d3b04f82cc9eb62b916906490ddf5">active_local_subdomain_elements_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span>;
<a name="l00344"></a>00344   const_element_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a1f0b15953241205be133ffbcb41fb9ca">active_local_subdomain_elements_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id) <span class="keyword">const</span>;
<a name="l00345"></a>00345   
<a name="l00346"></a>00346   
<a name="l00347"></a>00347   
<a name="l00348"></a>00348   
<a name="l00349"></a>00349   
<a name="l00353"></a>00353   node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a9c5d7c7087409fa5c2a12f6af2858512">nodes_begin</a>();
<a name="l00354"></a>00354   node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2e2c2f4e91ae31456050bc5da3a52fa2">nodes_end</a>();
<a name="l00355"></a>00355   
<a name="l00356"></a>00356   node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac4181b2d52e7138db1741fc3786e3700">active_nodes_begin</a>();
<a name="l00357"></a>00357   node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2d54fd0a078c33b5a531c6c206979313">active_nodes_end</a>();
<a name="l00358"></a>00358 
<a name="l00359"></a>00359   node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#abb46f88fbb47fef5636af8eae4ce36b4">local_nodes_begin</a>  ();
<a name="l00360"></a>00360   node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a06d628805eb6ca230022d0a1127b8fa4">local_nodes_end</a>    ();
<a name="l00361"></a>00361   
<a name="l00362"></a>00362   node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a564c7558d288b4cdffd0726aeb9c12dd">pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00363"></a>00363   node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2a70fe69d9d9da050dddd3148f4ea3be">pid_nodes_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id);
<a name="l00364"></a>00364 
<a name="l00368"></a>00368   const_node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a9c5d7c7087409fa5c2a12f6af2858512">nodes_begin</a>() <span class="keyword">const</span>;
<a name="l00369"></a>00369   const_node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2e2c2f4e91ae31456050bc5da3a52fa2">nodes_end</a>()   <span class="keyword">const</span>;
<a name="l00370"></a>00370 
<a name="l00371"></a>00371   const_node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac4181b2d52e7138db1741fc3786e3700">active_nodes_begin</a>() <span class="keyword">const</span>;
<a name="l00372"></a>00372   const_node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2d54fd0a078c33b5a531c6c206979313">active_nodes_end</a>()   <span class="keyword">const</span>;
<a name="l00373"></a>00373 
<a name="l00374"></a>00374   const_node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#abb46f88fbb47fef5636af8eae4ce36b4">local_nodes_begin</a>  () <span class="keyword">const</span>;
<a name="l00375"></a>00375   const_node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a06d628805eb6ca230022d0a1127b8fa4">local_nodes_end</a>    () <span class="keyword">const</span>;
<a name="l00376"></a>00376 
<a name="l00377"></a>00377   const_node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a564c7558d288b4cdffd0726aeb9c12dd">pid_nodes_begin</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00378"></a>00378   const_node_iterator <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2a70fe69d9d9da050dddd3148f4ea3be">pid_nodes_end</a>   (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) <span class="keyword">const</span>;
<a name="l00379"></a>00379  
<a name="l00380"></a>00380 <span class="keyword">protected</span>:
<a name="l00381"></a>00381 
<a name="l00385"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">00385</a>   <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Node*&gt;</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a93dcd617abf4505ab8628472eb1cce90">_nodes</a>;
<a name="l00386"></a>00386   
<a name="l00390"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">00390</a>   <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Elem*&gt;</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#a0ccc1060937df3ec67ded54440e6590e">_elements</a>;
<a name="l00391"></a>00391 
<a name="l00395"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">00395</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa5ec1fff0c588a69e81a84a16120efd1">_is_serial</a>;
<a name="l00396"></a>00396 
<a name="l00400"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">00400</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#af70058d54e5d727f87c524dbc0013f46">_n_nodes</a>, <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae3bbc433435383bcde09bd28aa13818e">_n_elem</a>, <a class="code" href="classlibMesh_1_1ParallelMesh.php#a4ade8de51594885d94713fe1de9efa01">_max_node_id</a>, <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2ff7a43f89e1ceb7bc3fc205483151be">_max_elem_id</a>;
<a name="l00401"></a>00401 
<a name="l00406"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">00406</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ac1c91b6ea0a74ee9f5a7aa21a0f77332">_next_free_local_node_id</a>,
<a name="l00407"></a>00407                <a class="code" href="classlibMesh_1_1ParallelMesh.php#a576a8dc7ced081673c7ab8663752d591">_next_free_local_elem_id</a>;
<a name="l00408"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">00408</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParallelMesh.php#aa84f67d0ac65d3e1cdd7afdc6f292672">_next_free_unpartitioned_node_id</a>,
<a name="l00409"></a>00409                <a class="code" href="classlibMesh_1_1ParallelMesh.php#af2cf69eaed1ebdd13c4ede5429158649">_next_free_unpartitioned_elem_id</a>;
<a name="l00410"></a>00410 
<a name="l00415"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a68988aa2a6bcb8c9a4d3ca8bcec0dd79">00415</a>   std::set&lt;Elem *&gt; <a class="code" href="classlibMesh_1_1ParallelMesh.php#a68988aa2a6bcb8c9a4d3ca8bcec0dd79">_extra_ghost_elems</a>;
<a name="l00416"></a>00416   
<a name="l00417"></a>00417 <span class="keyword">private</span>:
<a name="l00418"></a>00418   
<a name="l00423"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a2dab276070364298e00df807046df55c">00423</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Elem*&gt;::veclike_iterator</a>             <a class="code" href="classlibMesh_1_1ParallelMesh.php#a2dab276070364298e00df807046df55c">elem_iterator_imp</a>;
<a name="l00424"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#ae7bded7ae55bca1203f3f63a5468fa8f">00424</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Elem*&gt;::const_veclike_iterator</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#ae7bded7ae55bca1203f3f63a5468fa8f">const_elem_iterator_imp</a>;
<a name="l00425"></a>00425 
<a name="l00430"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">00430</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Node*&gt;::veclike_iterator</a>             <a class="code" href="classlibMesh_1_1ParallelMesh.php#a97fd0ae8092ccb5070d2baadfdb24b91">node_iterator_imp</a>;
<a name="l00431"></a><a class="code" href="classlibMesh_1_1ParallelMesh.php#acb28058431b2f8b95e47b6a55b5e7217">00431</a>   <span class="keyword">typedef</span> <a class="code" href="classlibMesh_1_1mapvector.php">mapvector&lt;Node*&gt;::const_veclike_iterator</a> <a class="code" href="classlibMesh_1_1ParallelMesh.php#acb28058431b2f8b95e47b6a55b5e7217">const_node_iterator_imp</a>;
<a name="l00432"></a>00432 };
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 } <span class="comment">// namespace libMesh</span>
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
