<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_d4d34bb88452e16aa385991b3dad6a49.php">parallel</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel_sort.C</div>  </div>
</div>
<div class="contents">
<a href="parallel__sort_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_sort.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// System Includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local Includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="parallel__sort_8h.php">parallel_sort.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="parallel__bin__sorter_8h.php">parallel_bin_sorter.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span><span class="preprocessor">#  include &quot;hilbert.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#endif</span>
<a name="l00033"></a>00033 <span class="preprocessor"></span>
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>Parallel {
<a name="l00039"></a>00039   
<a name="l00040"></a>00040 <span class="comment">// The Constructor sorts the local data using</span>
<a name="l00041"></a>00041 <span class="comment">// std::sort().  Therefore, the construction of</span>
<a name="l00042"></a>00042 <span class="comment">// a Parallel::Sort object takes O(nlogn) time,</span>
<a name="l00043"></a>00043 <span class="comment">// where n is the length of _data.</span>
<a name="l00044"></a>00044 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00045"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a353198262fcceb237f9e510c1c0cc222">00045</a> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a353198262fcceb237f9e510c1c0cc222">Sort&lt;KeyType&gt;::Sort</a>(std::vector&lt;KeyType&gt;&amp; d,
<a name="l00046"></a>00046                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_procs,
<a name="l00047"></a>00047                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id) :           
<a name="l00048"></a>00048   _n_procs(n_procs),
<a name="l00049"></a>00049   _proc_id(proc_id),
<a name="l00050"></a>00050   _bin_is_sorted(false),
<a name="l00051"></a>00051   _data(d)
<a name="l00052"></a>00052 {
<a name="l00053"></a>00053   <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a25ef345977c350dfed97c25893acce88">std::sort</a>(<a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#aef533f57b12926ee8f23da768a770f7f">_data</a>.begin(), <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#aef533f57b12926ee8f23da768a770f7f">_data</a>.end());
<a name="l00054"></a>00054 
<a name="l00055"></a>00055   <span class="comment">// Allocate storage</span>
<a name="l00056"></a>00056   <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a4b842204c7eb0c5794d066a6e33a62f4">_local_bin_sizes</a>.resize(<a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a5ef6b280ee00daaa9d000dce31442d6b">_n_procs</a>);
<a name="l00057"></a>00057 }
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00062"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a25ef345977c350dfed97c25893acce88">00062</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a25ef345977c350dfed97c25893acce88">Sort&lt;KeyType&gt;::sort</a>()
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064   <span class="comment">// Find the global data size.  The sorting</span>
<a name="l00065"></a>00065   <span class="comment">// algorithms assume they have a range to</span>
<a name="l00066"></a>00066   <span class="comment">// work with, so catch the degenerate cases here</span>
<a name="l00067"></a>00067   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_data_size = _data.size();
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a> (global_data_size);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="keywordflow">if</span> (global_data_size &lt; 2)
<a name="l00072"></a>00072     {
<a name="l00073"></a>00073       <span class="comment">// the entire global range is either empty</span>
<a name="l00074"></a>00074       <span class="comment">// or contains only one element</span>
<a name="l00075"></a>00075       _my_bin = _data;
<a name="l00076"></a>00076 
<a name="l00077"></a>00077       <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a> (static_cast&lt;unsigned int&gt;(_my_bin.size()),
<a name="l00078"></a>00078                            _local_bin_sizes);
<a name="l00079"></a>00079     }
<a name="l00080"></a>00080   <span class="keywordflow">else</span>
<a name="l00081"></a>00081     {
<a name="l00082"></a>00082       this-&gt;binsort();
<a name="l00083"></a>00083       this-&gt;communicate_bins();
<a name="l00084"></a>00084       this-&gt;sort_local_bin();
<a name="l00085"></a>00085     }
<a name="l00086"></a>00086   
<a name="l00087"></a>00087   <span class="comment">// Set sorted flag to true</span>
<a name="l00088"></a>00088   _bin_is_sorted = <span class="keyword">true</span>;
<a name="l00089"></a>00089 }
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00094"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ab6edbfbf055e4f99284ff213f71ed278">00094</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ab6edbfbf055e4f99284ff213f71ed278">Sort&lt;KeyType&gt;::binsort</a>()
<a name="l00095"></a>00095 {  
<a name="l00096"></a>00096   <span class="comment">// Find the global min and max from all the</span>
<a name="l00097"></a>00097   <span class="comment">// processors.</span>
<a name="l00098"></a>00098   std::vector&lt;KeyType&gt; global_min_max(2);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="comment">// Insert the local min and max for this processor</span>
<a name="l00101"></a>00101   global_min_max[0] = -_data.front();
<a name="l00102"></a>00102   global_min_max[1] =  _data.back();
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// Communicate to determine the global</span>
<a name="l00105"></a>00105   <span class="comment">// min and max for all processors.</span>
<a name="l00106"></a>00106   <a class="code" href="namespacelibMesh_1_1Parallel.php#aab5d5b064cff00655e8f2bb640ffc04f">Parallel::max</a>(global_min_max);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">// Multiply the min by -1 to obtain the true min</span>
<a name="l00109"></a>00109   global_min_max[0] *= -1;
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="comment">// Bin-Sort based on the global min and max</span>
<a name="l00112"></a>00112   <a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php">Parallel::BinSorter&lt;KeyType&gt;</a> bs(_data);
<a name="l00113"></a>00113   bs.<a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php#adcec209a8332a15c23c8ad9d34821238">binsort</a>(_n_procs, global_min_max[1], global_min_max[0]);
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// Now save the local bin sizes in a vector so</span>
<a name="l00116"></a>00116   <span class="comment">// we don&#39;t have to keep around the BinSorter.</span>
<a name="l00117"></a>00117   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_n_procs; ++i)
<a name="l00118"></a>00118     _local_bin_sizes[i] = bs.<a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php#ad75323bc19bda9771ef3f441222b58be">sizeof_bin</a>(i);
<a name="l00119"></a>00119 }
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 
<a name="l00123"></a>00123 <span class="preprocessor">#if defined(LIBMESH_HAVE_LIBHILBERT) &amp;&amp; defined(LIBMESH_HAVE_MPI)</span>
<a name="l00124"></a>00124 <span class="preprocessor"></span><span class="comment">// Full specialization for HilbertIndices, there is a fair amount of</span>
<a name="l00125"></a>00125 <span class="comment">// code duplication here that could potentially be consolidated with the </span>
<a name="l00126"></a>00126 <span class="comment">// above method</span>
<a name="l00127"></a>00127 <span class="keyword">template</span> &lt;&gt;
<a name="l00128"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ae085fedea1614a0fa3545fb0109356a5">00128</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ab6edbfbf055e4f99284ff213f71ed278">Sort&lt;Hilbert::HilbertIndices&gt;::binsort</a>()
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130   <span class="comment">// Find the global min and max from all the</span>
<a name="l00131"></a>00131   <span class="comment">// processors.  Do this using MPI_Allreduce.</span>
<a name="l00132"></a>00132   Hilbert::HilbertIndices 
<a name="l00133"></a>00133     local_min,  local_max,
<a name="l00134"></a>00134     global_min, global_max;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <span class="keywordflow">if</span> (_data.empty())
<a name="l00137"></a>00137     {
<a name="l00138"></a>00138       local_min.rack0 = local_min.rack1 = local_min.rack2 = <span class="keyword">static_cast&lt;</span>Hilbert::inttype<span class="keyword">&gt;</span>(-1);
<a name="l00139"></a>00139       local_max.rack0 = local_max.rack1 = local_max.rack2 = 0;
<a name="l00140"></a>00140     }
<a name="l00141"></a>00141   <span class="keywordflow">else</span>
<a name="l00142"></a>00142     {
<a name="l00143"></a>00143       local_min = _data.front();
<a name="l00144"></a>00144       local_max = _data.back();
<a name="l00145"></a>00145     }
<a name="l00146"></a>00146   
<a name="l00147"></a>00147   MPI_Op hilbert_max, hilbert_min;
<a name="l00148"></a>00148   MPI_Datatype hilbert_type;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   MPI_Type_contiguous (3, MPI_UNSIGNED, &amp;hilbert_type);
<a name="l00151"></a>00151   MPI_Type_commit     (&amp;hilbert_type);
<a name="l00152"></a>00152   MPI_Op_create       ((MPI_User_function*)__hilbert_max_op, <span class="keyword">true</span>, &amp;hilbert_max);
<a name="l00153"></a>00153   MPI_Op_create       ((MPI_User_function*)__hilbert_min_op, <span class="keyword">true</span>, &amp;hilbert_min);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155   <span class="comment">// Communicate to determine the global</span>
<a name="l00156"></a>00156   <span class="comment">// min and max for all processors.</span>
<a name="l00157"></a>00157   MPI_Allreduce(&amp;local_min,
<a name="l00158"></a>00158                 &amp;global_min,
<a name="l00159"></a>00159                 1,
<a name="l00160"></a>00160                 hilbert_type,
<a name="l00161"></a>00161                 hilbert_min,
<a name="l00162"></a>00162                 <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);
<a name="l00163"></a>00163 
<a name="l00164"></a>00164   MPI_Allreduce(&amp;local_max,
<a name="l00165"></a>00165                 &amp;global_max,
<a name="l00166"></a>00166                 1,
<a name="l00167"></a>00167                 hilbert_type,
<a name="l00168"></a>00168                 hilbert_max,
<a name="l00169"></a>00169                 <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);
<a name="l00170"></a>00170 
<a name="l00171"></a>00171   MPI_Type_free (&amp;hilbert_type);
<a name="l00172"></a>00172   MPI_Op_free   (&amp;hilbert_max);
<a name="l00173"></a>00173   MPI_Op_free   (&amp;hilbert_min);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175   <span class="comment">// Bin-Sort based on the global min and max</span>
<a name="l00176"></a>00176   <a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php">Parallel::BinSorter&lt;Hilbert::HilbertIndices&gt;</a> bs(_data);
<a name="l00177"></a>00177   bs.<a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php#adcec209a8332a15c23c8ad9d34821238">binsort</a>(_n_procs, global_max, global_min);
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="comment">// Now save the local bin sizes in a vector so</span>
<a name="l00180"></a>00180   <span class="comment">// we don&#39;t have to keep around the BinSorter.</span>
<a name="l00181"></a>00181   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_n_procs; ++i)
<a name="l00182"></a>00182     _local_bin_sizes[i] = bs.<a class="code" href="classlibMesh_1_1Parallel_1_1BinSorter.php#ad75323bc19bda9771ef3f441222b58be">sizeof_bin</a>(i);
<a name="l00183"></a>00183 }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_LIBHILBERT</span>
<a name="l00186"></a>00186 <span class="preprocessor"></span>
<a name="l00187"></a>00187 
<a name="l00188"></a>00188 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00189"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#adf1e28eb2d80da017c0863054180bcda">00189</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#adf1e28eb2d80da017c0863054180bcda">Sort&lt;KeyType&gt;::communicate_bins</a>()
<a name="l00190"></a>00190 {
<a name="l00191"></a>00191 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span>  <span class="comment">// Create storage for the global bin sizes.  This</span>
<a name="l00193"></a>00193   <span class="comment">// is the number of keys which will be held in</span>
<a name="l00194"></a>00194   <span class="comment">// each bin over all processors.</span>
<a name="l00195"></a>00195   std::vector&lt;unsigned int&gt; global_bin_sizes = _local_bin_sizes;
<a name="l00196"></a>00196   
<a name="l00197"></a>00197   <span class="comment">// Sum to find the total number of entries in each bin.</span>
<a name="l00198"></a>00198   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(global_bin_sizes);
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="comment">// Create a vector to temporarily hold the results of MPI_Gatherv</span>
<a name="l00201"></a>00201   <span class="comment">// calls.  The vector dest  may be saved away to _my_bin depending on which</span>
<a name="l00202"></a>00202   <span class="comment">// processor is being MPI_Gatherv&#39;d.</span>
<a name="l00203"></a>00203   std::vector&lt;KeyType&gt; dest;
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_offset = 0;
<a name="l00206"></a>00206   
<a name="l00207"></a>00207   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_n_procs; ++i)
<a name="l00208"></a>00208     {
<a name="l00209"></a>00209       <span class="comment">// Vector to receive the total bin size for each</span>
<a name="l00210"></a>00210       <span class="comment">// processor.  Processor i&#39;s bin size will be</span>
<a name="l00211"></a>00211       <span class="comment">// held in proc_bin_size[i]</span>
<a name="l00212"></a>00212       std::vector&lt;unsigned int&gt; proc_bin_size;
<a name="l00213"></a>00213 
<a name="l00214"></a>00214       <span class="comment">// Find the number of contributions coming from each</span>
<a name="l00215"></a>00215       <span class="comment">// processor for this bin.  Note: allgather combines</span>
<a name="l00216"></a>00216       <span class="comment">// the MPI_Gather and MPI_Bcast operations into one.</span>
<a name="l00217"></a>00217       <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(_local_bin_sizes[i], proc_bin_size);
<a name="l00218"></a>00218 
<a name="l00219"></a>00219       <span class="comment">// Compute the offsets into my_bin for each processor&#39;s</span>
<a name="l00220"></a>00220       <span class="comment">// portion of the bin.  These are basically partial sums</span>
<a name="l00221"></a>00221       <span class="comment">// of the proc_bin_size vector.</span>
<a name="l00222"></a>00222       std::vector&lt;unsigned int&gt; displacements(_n_procs);
<a name="l00223"></a>00223       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j&lt;_n_procs; ++j)
<a name="l00224"></a>00224         displacements[j] = proc_bin_size[j-1] + displacements[j-1];
<a name="l00225"></a>00225 
<a name="l00226"></a>00226       <span class="comment">// Resize the destination buffer</span>
<a name="l00227"></a>00227       dest.resize (global_bin_sizes[i]);
<a name="l00228"></a>00228           
<a name="l00229"></a>00229       MPI_Gatherv((_data.size() &gt; local_offset) ?
<a name="l00230"></a>00230                     &amp;_data[local_offset] :
<a name="l00231"></a>00231                     NULL,                        <span class="comment">// Points to the beginning of the bin to be sent</span>
<a name="l00232"></a>00232                   _local_bin_sizes[i],           <span class="comment">// How much data is in the bin being sent.</span>
<a name="l00233"></a>00233                   Parallel::datatype&lt;KeyType&gt;(), <span class="comment">// The data type we are sorting</span>
<a name="l00234"></a>00234                   (dest.empty()) ?
<a name="l00235"></a>00235                     NULL :
<a name="l00236"></a>00236                     &amp;dest[0],                    <span class="comment">// Enough storage to hold all bin contributions</span>
<a name="l00237"></a>00237                   (<span class="keywordtype">int</span>*) &amp;proc_bin_size[0],      <span class="comment">// How much is to be received from each processor</span>
<a name="l00238"></a>00238                   (<span class="keywordtype">int</span>*) &amp;displacements[0],      <span class="comment">// Offsets into the receive buffer</span>
<a name="l00239"></a>00239                   Parallel::datatype&lt;KeyType&gt;(), <span class="comment">// The data type we are sorting</span>
<a name="l00240"></a>00240                   i,                             <span class="comment">// The root process (we do this once for each proc)</span>
<a name="l00241"></a>00241                   <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);
<a name="l00242"></a>00242 
<a name="l00243"></a>00243       <span class="comment">// Copy the destination buffer if it</span>
<a name="l00244"></a>00244       <span class="comment">// corresponds to the bin for this processor</span>
<a name="l00245"></a>00245       <span class="keywordflow">if</span> (i == _proc_id)
<a name="l00246"></a>00246         _my_bin = dest;
<a name="l00247"></a>00247           
<a name="l00248"></a>00248       <span class="comment">// Increment the local offset counter</span>
<a name="l00249"></a>00249       local_offset += _local_bin_sizes[i];
<a name="l00250"></a>00250     } 
<a name="l00251"></a>00251 <span class="preprocessor">#endif // LIBMESH_HAVE_MPI</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>}
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 <span class="preprocessor">#if defined(LIBMESH_HAVE_LIBHILBERT) &amp;&amp; defined(LIBMESH_HAVE_MPI)</span>
<a name="l00257"></a>00257 <span class="preprocessor"></span><span class="comment">// Full specialization for HilbertIndices, there is a fair amount of</span>
<a name="l00258"></a>00258 <span class="comment">// code duplication here that could potentially be consolidated with the </span>
<a name="l00259"></a>00259 <span class="comment">// above method</span>
<a name="l00260"></a>00260 <span class="keyword">template</span> &lt;&gt;
<a name="l00261"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a8a43358e50aad53765a338db7688ab9f">00261</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#adf1e28eb2d80da017c0863054180bcda">Sort&lt;Hilbert::HilbertIndices&gt;::communicate_bins</a>()
<a name="l00262"></a>00262 {
<a name="l00263"></a>00263   <span class="comment">// Create storage for the global bin sizes.  This</span>
<a name="l00264"></a>00264   <span class="comment">// is the number of keys which will be held in</span>
<a name="l00265"></a>00265   <span class="comment">// each bin over all processors.</span>
<a name="l00266"></a>00266   std::vector&lt;unsigned int&gt; global_bin_sizes(_n_procs);
<a name="l00267"></a>00267   
<a name="l00268"></a>00268   libmesh_assert (_local_bin_sizes.size() == global_bin_sizes.size());
<a name="l00269"></a>00269 
<a name="l00270"></a>00270   <span class="comment">// Sum to find the total number of entries in each bin.</span>
<a name="l00271"></a>00271   <span class="comment">// This is stored in global_bin_sizes.  Note, we</span>
<a name="l00272"></a>00272   <span class="comment">// explicitly know that we are communicating MPI_UNSIGNED&#39;s here.</span>
<a name="l00273"></a>00273   MPI_Allreduce(&amp;_local_bin_sizes[0],
<a name="l00274"></a>00274                 &amp;global_bin_sizes[0],
<a name="l00275"></a>00275                 _n_procs,
<a name="l00276"></a>00276                 MPI_UNSIGNED,
<a name="l00277"></a>00277                 MPI_SUM,
<a name="l00278"></a>00278                 <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   MPI_Datatype hilbert_type;
<a name="l00281"></a>00281 
<a name="l00282"></a>00282   MPI_Type_contiguous (3, MPI_UNSIGNED, &amp;hilbert_type);
<a name="l00283"></a>00283   MPI_Type_commit     (&amp;hilbert_type);
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   <span class="comment">// Create a vector to temporarily hold the results of MPI_Gatherv</span>
<a name="l00286"></a>00286   <span class="comment">// calls.  The vector dest  may be saved away to _my_bin depending on which</span>
<a name="l00287"></a>00287   <span class="comment">// processor is being MPI_Gatherv&#39;d.</span>
<a name="l00288"></a>00288   std::vector&lt;Hilbert::HilbertIndices&gt; sendbuf, dest;
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_offset = 0;
<a name="l00291"></a>00291   
<a name="l00292"></a>00292   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;_n_procs; ++i)
<a name="l00293"></a>00293     {
<a name="l00294"></a>00294       <span class="comment">// Vector to receive the total bin size for each</span>
<a name="l00295"></a>00295       <span class="comment">// processor.  Processor i&#39;s bin size will be</span>
<a name="l00296"></a>00296       <span class="comment">// held in proc_bin_size[i]</span>
<a name="l00297"></a>00297       std::vector&lt;unsigned int&gt; proc_bin_size(_n_procs);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299       <span class="comment">// Find the number of contributions coming from each</span>
<a name="l00300"></a>00300       <span class="comment">// processor for this bin.  Note: Allgather combines</span>
<a name="l00301"></a>00301       <span class="comment">// the MPI_Gather and MPI_Bcast operations into one.</span>
<a name="l00302"></a>00302       <span class="comment">// Note: Here again we know that we are communicating</span>
<a name="l00303"></a>00303       <span class="comment">// MPI_UNSIGNED&#39;s so there is no need to check the MPI_traits.</span>
<a name="l00304"></a>00304       MPI_Allgather(&amp;_local_bin_sizes[i], <span class="comment">// Source: # of entries on this proc in bin i</span>
<a name="l00305"></a>00305                     1,                    <span class="comment">// Number of items to gather                 </span>
<a name="l00306"></a>00306                     MPI_UNSIGNED,           
<a name="l00307"></a>00307                     &amp;proc_bin_size[0],    <span class="comment">// Destination: Total # of entries in bin i</span>
<a name="l00308"></a>00308                     1,
<a name="l00309"></a>00309                     MPI_UNSIGNED,
<a name="l00310"></a>00310                     <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);
<a name="l00311"></a>00311       
<a name="l00312"></a>00312       <span class="comment">// Compute the offsets into my_bin for each processor&#39;s</span>
<a name="l00313"></a>00313       <span class="comment">// portion of the bin.  These are basically partial sums</span>
<a name="l00314"></a>00314       <span class="comment">// of the proc_bin_size vector.</span>
<a name="l00315"></a>00315       std::vector&lt;unsigned int&gt; displacements(_n_procs);
<a name="l00316"></a>00316       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=1; j&lt;_n_procs; ++j)
<a name="l00317"></a>00317         displacements[j] = proc_bin_size[j-1] + displacements[j-1];
<a name="l00318"></a>00318 
<a name="l00319"></a>00319       <span class="comment">// Resize the destination buffer</span>
<a name="l00320"></a>00320       dest.resize (global_bin_sizes[i]);
<a name="l00321"></a>00321       
<a name="l00322"></a>00322       MPI_Gatherv((_data.size() &gt; local_offset) ?
<a name="l00323"></a>00323                     &amp;_data[local_offset] :
<a name="l00324"></a>00324                     NULL,                   <span class="comment">// Points to the beginning of the bin to be sent</span>
<a name="l00325"></a>00325                   _local_bin_sizes[i],      <span class="comment">// How much data is in the bin being sent.</span>
<a name="l00326"></a>00326                   hilbert_type,             <span class="comment">// The data type we are sorting</span>
<a name="l00327"></a>00327                   (dest.empty()) ?
<a name="l00328"></a>00328                     NULL :
<a name="l00329"></a>00329                     &amp;dest[0],               <span class="comment">// Enough storage to hold all bin contributions</span>
<a name="l00330"></a>00330                   (<span class="keywordtype">int</span>*) &amp;proc_bin_size[0], <span class="comment">// How much is to be received from each processor</span>
<a name="l00331"></a>00331                   (<span class="keywordtype">int</span>*) &amp;displacements[0], <span class="comment">// Offsets into the receive buffer</span>
<a name="l00332"></a>00332                   hilbert_type,             <span class="comment">// The data type we are sorting</span>
<a name="l00333"></a>00333                   i,                        <span class="comment">// The root process (we do this once for each proc)</span>
<a name="l00334"></a>00334                   <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);
<a name="l00335"></a>00335 
<a name="l00336"></a>00336       <span class="comment">// Copy the destination buffer if it</span>
<a name="l00337"></a>00337       <span class="comment">// corresponds to the bin for this processor</span>
<a name="l00338"></a>00338       <span class="keywordflow">if</span> (i == _proc_id)
<a name="l00339"></a>00339         _my_bin = dest;
<a name="l00340"></a>00340 
<a name="l00341"></a>00341       <span class="comment">// Increment the local offset counter</span>
<a name="l00342"></a>00342       local_offset += _local_bin_sizes[i];
<a name="l00343"></a>00343     }
<a name="l00344"></a>00344 
<a name="l00345"></a>00345   MPI_Type_free (&amp;hilbert_type);  
<a name="l00346"></a>00346 }
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 <span class="preprocessor">#endif // #if defined(LIBMESH_HAVE_LIBHILBERT) &amp;&amp; defined(LIBMESH_HAVE_MPI)</span>
<a name="l00349"></a>00349 <span class="preprocessor"></span>
<a name="l00350"></a>00350 
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00353"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a99092cd06a629fed8d524fac1de69e6e">00353</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a99092cd06a629fed8d524fac1de69e6e">Sort&lt;KeyType&gt;::sort_local_bin</a>()
<a name="l00354"></a>00354 {
<a name="l00355"></a>00355   std::sort(_my_bin.begin(), _my_bin.end());
<a name="l00356"></a>00356 }
<a name="l00357"></a>00357 
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00361"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ad7d4586c6ef2ea97360896922534143b">00361</a> <span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ad7d4586c6ef2ea97360896922534143b">Sort&lt;KeyType&gt;::bin</a>()
<a name="l00362"></a>00362 {
<a name="l00363"></a>00363   <span class="keywordflow">if</span> (!_bin_is_sorted)
<a name="l00364"></a>00364     {
<a name="l00365"></a>00365       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Warning! Bin is not yet sorted!&quot;</span> &lt;&lt; std::endl; 
<a name="l00366"></a>00366     }
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   <span class="keywordflow">return</span> _my_bin;
<a name="l00369"></a>00369 }
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 }
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 <span class="comment">// Explicitly instantiate for int, double</span>
<a name="l00376"></a>00376 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php">Parallel::Sort&lt;int&gt;</a>;
<a name="l00377"></a>00377 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php">Parallel::Sort&lt;double&gt;</a>;
<a name="l00378"></a>00378 <span class="preprocessor">#if defined(LIBMESH_HAVE_LIBHILBERT) &amp;&amp; defined(LIBMESH_HAVE_MPI)</span>
<a name="l00379"></a>00379 <span class="preprocessor"></span><span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php">Parallel::Sort&lt;Hilbert::HilbertIndices&gt;</a>;
<a name="l00380"></a>00380 <span class="preprocessor">#endif</span>
<a name="l00381"></a>00381 <span class="preprocessor"></span>
<a name="l00382"></a>00382 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
