<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_7bdae1604989e5516f706b95b493c360.php">parallel</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parallel_sort.h</div>  </div>
</div>
<div class="contents">
<a href="parallel__sort_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parallel_sort.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __parallel_sort_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __parallel_sort_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// System Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>Parallel
<a name="l00036"></a>00036 {
<a name="l00048"></a>00048 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> KeyType&gt;
<a name="l00049"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php">00049</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php">Sort</a>
<a name="l00050"></a>00050 {
<a name="l00051"></a>00051 <span class="keyword">public</span>:
<a name="l00060"></a>00060   <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a353198262fcceb237f9e510c1c0cc222">Sort</a> (std::vector&lt;KeyType&gt;&amp; d,
<a name="l00061"></a>00061         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_procs = <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(),
<a name="l00062"></a>00062         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id = <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00063"></a>00063                 
<a name="l00064"></a>00064 
<a name="l00071"></a>00071   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a25ef345977c350dfed97c25893acce88">sort</a>();
<a name="l00072"></a>00072   
<a name="l00078"></a>00078   <span class="keyword">const</span> std::vector&lt;KeyType&gt;&amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ad7d4586c6ef2ea97360896922534143b">bin</a>();
<a name="l00079"></a>00079   
<a name="l00080"></a>00080 <span class="keyword">private</span>:
<a name="l00081"></a>00081 
<a name="l00085"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a5ef6b280ee00daaa9d000dce31442d6b">00085</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a5ef6b280ee00daaa9d000dce31442d6b">_n_procs</a>;
<a name="l00086"></a>00086 
<a name="l00090"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a27857ebc319ab2b7a1fa8b850278e6e3">00090</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a27857ebc319ab2b7a1fa8b850278e6e3">_proc_id</a>;
<a name="l00091"></a>00091 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ada364c2d1dcb20694238d9769efaa6ea">00095</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ada364c2d1dcb20694238d9769efaa6ea">_bin_is_sorted</a>;
<a name="l00096"></a>00096   
<a name="l00102"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#aef533f57b12926ee8f23da768a770f7f">00102</a>   std::vector&lt;KeyType&gt;&amp; <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#aef533f57b12926ee8f23da768a770f7f">_data</a>;
<a name="l00103"></a>00103 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a4b842204c7eb0c5794d066a6e33a62f4">00109</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a4b842204c7eb0c5794d066a6e33a62f4">_local_bin_sizes</a>;
<a name="l00110"></a>00110   
<a name="l00117"></a><a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a91478aef277097c199f98755cb86dbf3">00117</a>   std::vector&lt;KeyType&gt; <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a91478aef277097c199f98755cb86dbf3">_my_bin</a>;
<a name="l00118"></a>00118 
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#ab6edbfbf055e4f99284ff213f71ed278">binsort</a> ();
<a name="l00125"></a>00125 
<a name="l00132"></a>00132   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#adf1e28eb2d80da017c0863054180bcda">communicate_bins</a>();
<a name="l00133"></a>00133 
<a name="l00139"></a>00139   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Parallel_1_1Sort.php#a99092cd06a629fed8d524fac1de69e6e">sort_local_bin</a>();
<a name="l00140"></a>00140   
<a name="l00141"></a>00141 };
<a name="l00142"></a>00142 }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 } <span class="comment">// namespace libMesh</span>
<a name="l00145"></a>00145 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
