<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parameter_vector.h</div>  </div>
</div>
<div class="contents">
<a href="parameter__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// $Id: parameter_vector.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00004"></a>00004 
<a name="l00005"></a>00005 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00006"></a>00006 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00007"></a>00007   
<a name="l00008"></a>00008 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00009"></a>00009 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00010"></a>00010 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00011"></a>00011 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00012"></a>00012   
<a name="l00013"></a>00013 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00014"></a>00014 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00015"></a>00015 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00016"></a>00016 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00017"></a>00017   
<a name="l00018"></a>00018 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00019"></a>00019 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00020"></a>00020 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifndef __parameter_vector_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="preprocessor">#define __parameter_vector_h__</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00042"></a><a class="code" href="classlibMesh_1_1ParameterVector.php">00042</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>: 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1ParameterVector.php#a0aa54e89a6c2ffa6ee237fea4a276136">00048</a>   <a class="code" href="classlibMesh_1_1ParameterVector.php#a0aa54e89a6c2ffa6ee237fea4a276136">ParameterVector</a>() {}
<a name="l00049"></a>00049 
<a name="l00053"></a><a class="code" href="classlibMesh_1_1ParameterVector.php#a22cbc75bd737da9211aaab9c1a277f48">00053</a>   <a class="code" href="classlibMesh_1_1ParameterVector.php#a22cbc75bd737da9211aaab9c1a277f48">ParameterVector</a>(<span class="keyword">const</span> std::vector&lt;Number *&gt; &amp;params) : <a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">_params</a>(params) {}
<a name="l00054"></a>00054 
<a name="l00059"></a>00059   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#aacf06a1971b30b2328c9d3013df2af5c">deep_copy</a>(<a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a> &amp;target) <span class="keyword">const</span>;
<a name="l00060"></a>00060 
<a name="l00065"></a>00065   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#a160b5540404fe6b64547dc2a278a0efe">shallow_copy</a>(<a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a> &amp;target) <span class="keyword">const</span>;
<a name="l00066"></a>00066 
<a name="l00072"></a>00072   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#ab1728a53e4e47d3d9b9dc2bf470f0dbe">value_copy</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a> &amp;target) <span class="keyword">const</span>;
<a name="l00073"></a>00073 
<a name="l00077"></a><a class="code" href="classlibMesh_1_1ParameterVector.php#a54d52a3b3b8a4ccef48afcc6acae3708">00077</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#a54d52a3b3b8a4ccef48afcc6acae3708">clear</a>() { <a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">_params</a>.clear(); }
<a name="l00078"></a>00078 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">00082</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#a820adeed54c94a2459b154b71bd304cf">size</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">_params</a>.size(); }
<a name="l00083"></a>00083 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1ParameterVector.php#a487ebd3295a388cd4474094076ca4cf8">00089</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#a487ebd3295a388cd4474094076ca4cf8">resize</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s) { <a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">_params</a>.resize(s); }
<a name="l00090"></a>00090 
<a name="l00095"></a>00095   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#ae3128b078e8453184b0dcaf68f0d6ef4">deep_resize</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s);
<a name="l00096"></a>00096 
<a name="l00100"></a>00100   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> * <a class="code" href="classlibMesh_1_1ParameterVector.php#aa001d082c1c387b542bcab0e7ba472aa">operator[]</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00101"></a>00101 
<a name="l00106"></a>00106   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> *&amp; <a class="code" href="classlibMesh_1_1ParameterVector.php#aa001d082c1c387b542bcab0e7ba472aa">operator[]</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i);
<a name="l00107"></a>00107 
<a name="l00111"></a>00111   <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; <a class="code" href="classlibMesh_1_1ParameterVector.php#a891baa14f4b1bd65dde18f86131dbf36">operator *= </a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> a);
<a name="l00112"></a>00112 
<a name="l00117"></a>00117   <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; <a class="code" href="classlibMesh_1_1ParameterVector.php#a7e0ef7facadc1f227e9c642955e825c8">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; a);
<a name="l00118"></a>00118 
<a name="l00123"></a>00123   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; <a class="code" href="classlibMesh_1_1ParameterVector.php#a7e0ef7facadc1f227e9c642955e825c8">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ParameterVector.php">ParameterVector</a>&amp; a) <span class="keyword">const</span>;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 <span class="keyword">private</span>: 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">00129</a>   std::vector&lt;Number *&gt; <a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">_params</a>;
<a name="l00130"></a>00130 
<a name="l00134"></a><a class="code" href="classlibMesh_1_1ParameterVector.php#a959328b942701f9f754a816a889b59a4">00134</a>   std::vector&lt;Number&gt; <a class="code" href="classlibMesh_1_1ParameterVector.php#a959328b942701f9f754a816a889b59a4">_my_data</a>;
<a name="l00135"></a>00135 };
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00140"></a>00140 <span class="comment">// ParameterVector inline methods</span>
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a>00144 <span class="keyword">inline</span>
<a name="l00145"></a><a class="code" href="classlibMesh_1_1ParameterVector.php#aa001d082c1c387b542bcab0e7ba472aa">00145</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>* <a class="code" href="classlibMesh_1_1ParameterVector.php#aa001d082c1c387b542bcab0e7ba472aa">ParameterVector::operator[] </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00146"></a>00146 <span class="keyword"></span>{
<a name="l00147"></a>00147   libmesh_assert(<a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">_params</a>.size() &gt; i);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">_params</a>[i];
<a name="l00150"></a>00150 }
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 <span class="keyword">inline</span>
<a name="l00155"></a><a class="code" href="classlibMesh_1_1ParameterVector.php#aa28144ceeaa3b447fae126aa5d3c36c5">00155</a> <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a>*&amp; <a class="code" href="classlibMesh_1_1ParameterVector.php#aa001d082c1c387b542bcab0e7ba472aa">ParameterVector::operator[] </a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00156"></a>00156 {
<a name="l00157"></a>00157   libmesh_assert(<a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">_params</a>.size() &gt; i);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1ParameterVector.php#a276940eb77dc8708c81d987bdee44f2a">_params</a>[i];
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 } <span class="comment">// namespace libMesh</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="preprocessor">#endif // #define __parameter_vector_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
