<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_4d3110f67e028a3227e23bfd240351cc.php">partitioning</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parmetis_partitioner.C</div>  </div>
</div>
<div class="contents">
<a href="parmetis__partitioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parmetis_partitioner.C 4376 2011-04-20 19:41:19Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="parmetis__partitioner_8h.php">parmetis_partitioner.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="metis__partitioner_8h.php">metis_partitioner.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="preprocessor">#ifdef LIBMESH_HAVE_PARMETIS</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>
<a name="l00037"></a>00037 <span class="comment">// Include the MPI header files, which must be accessible for</span>
<a name="l00038"></a>00038 <span class="comment">// ParMETIS to work properly.</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;mpi.h&quot;</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Include the ParMETIS header files</span>
<a name="l00042"></a><a class="code" href="namespaceParmetis.php">00042</a> <span class="keyword">namespace </span>Parmetis {
<a name="l00043"></a>00043   <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span> {
<a name="l00044"></a>00044 <span class="preprocessor">#     include &quot;parmetis.h&quot;</span>
<a name="l00045"></a>00045   }
<a name="l00046"></a>00046 }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PARMETIS ... else ...</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span>
<a name="l00050"></a>00050 <span class="keyword">namespace </span>libMesh
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00056"></a>00056 <span class="comment">// ParmetisPartitioner implementation</span>
<a name="l00057"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a74987eb17d4887d994d537522afc9376">00057</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a74987eb17d4887d994d537522afc9376">ParmetisPartitioner::_do_partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00058"></a>00058                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sbdmns)
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   this-&gt;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9da16940130531a597077f36b40c1980">_do_repartition</a> (mesh, n_sbdmns);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 <span class="comment">//   libmesh_assert (n_sbdmns &gt; 0);</span>
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="comment">//   // Check for an easy return</span>
<a name="l00065"></a>00065 <span class="comment">//   if (n_sbdmns == 1)</span>
<a name="l00066"></a>00066 <span class="comment">//     {</span>
<a name="l00067"></a>00067 <span class="comment">//       this-&gt;single_partition (mesh);</span>
<a name="l00068"></a>00068 <span class="comment">//       return;</span>
<a name="l00069"></a>00069 <span class="comment">//     }</span>
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="comment">//   // This function must be run on all processors at once</span>
<a name="l00072"></a>00072 <span class="comment">//   parallel_only();</span>
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="comment">// // What to do if the Parmetis library IS NOT present</span>
<a name="l00075"></a>00075 <span class="comment">// #ifndef LIBMESH_HAVE_PARMETIS</span>
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 <span class="comment">//   libmesh_here();</span>
<a name="l00078"></a>00078 <span class="comment">//   libMesh::err &lt;&lt; &quot;ERROR: The library has been built without&quot;  &lt;&lt; std::endl</span>
<a name="l00079"></a>00079 <span class="comment">//          &lt;&lt; &quot;Parmetis support.  Using a Metis&quot;           &lt;&lt; std::endl</span>
<a name="l00080"></a>00080 <span class="comment">//          &lt;&lt; &quot;partitioner instead!&quot;                       &lt;&lt; std::endl;</span>
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 <span class="comment">//   MetisPartitioner mp;</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 <span class="comment">//   mp.partition (mesh, n_sbdmns);</span>
<a name="l00085"></a>00085   
<a name="l00086"></a>00086 <span class="comment">// // What to do if the Parmetis library IS present</span>
<a name="l00087"></a>00087 <span class="comment">// #else</span>
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="comment">//   START_LOG(&quot;partition()&quot;, &quot;ParmetisPartitioner&quot;);</span>
<a name="l00090"></a>00090 
<a name="l00091"></a>00091 <span class="comment">//   // Initialize the data structures required by ParMETIS</span>
<a name="l00092"></a>00092 <span class="comment">//   this-&gt;initialize (mesh, n_sbdmns);</span>
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 <span class="comment">//   // build the graph corresponding to the mesh</span>
<a name="l00095"></a>00095 <span class="comment">//   this-&gt;build_graph (mesh);</span>
<a name="l00096"></a>00096   
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 <span class="comment">//   // Partition the graph</span>
<a name="l00099"></a>00099 <span class="comment">//   MPI_Comm mpi_comm = libMesh::COMM_WORLD;</span>
<a name="l00100"></a>00100   
<a name="l00101"></a>00101 <span class="comment">//   // Call the ParMETIS k-way partitioning algorithm.</span>
<a name="l00102"></a>00102 <span class="comment">//   Parmetis::ParMETIS_V3_PartKway(&amp;_vtxdist[0], &amp;_xadj[0], &amp;_adjncy[0], &amp;_vwgt[0], NULL,</span>
<a name="l00103"></a>00103 <span class="comment">//                               &amp;_wgtflag, &amp;_numflag, &amp;_ncon, &amp;_nparts, &amp;_tpwgts[0],</span>
<a name="l00104"></a>00104 <span class="comment">//                               &amp;_ubvec[0], &amp;_options[0], &amp;_edgecut,</span>
<a name="l00105"></a>00105 <span class="comment">//                               &amp;_part[0],</span>
<a name="l00106"></a>00106 <span class="comment">//                               &amp;mpi_comm);</span>
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 <span class="comment">//   // Assign the returned processor ids</span>
<a name="l00109"></a>00109 <span class="comment">//   this-&gt;assign_partitioning (mesh);</span>
<a name="l00110"></a>00110   
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 <span class="comment">//   STOP_LOG (&quot;partition()&quot;, &quot;ParmetisPartitioner&quot;);</span>
<a name="l00113"></a>00113   
<a name="l00114"></a>00114 <span class="comment">// #endif // #ifndef LIBMESH_HAVE_PARMETIS ... else ...</span>
<a name="l00115"></a>00115   
<a name="l00116"></a>00116 }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9da16940130531a597077f36b40c1980">00120</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9da16940130531a597077f36b40c1980">ParmetisPartitioner::_do_repartition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00121"></a>00121                                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sbdmns)
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   libmesh_assert (n_sbdmns &gt; 0);
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   <span class="comment">// Check for an easy return</span>
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (n_sbdmns == 1)
<a name="l00127"></a>00127     {
<a name="l00128"></a>00128       this-&gt;<a class="code" href="classlibMesh_1_1Partitioner.php#abd4be60a7010f0a483e7632867aed9ef">single_partition</a>(mesh);
<a name="l00129"></a>00129       <span class="keywordflow">return</span>;
<a name="l00130"></a>00130     }
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00133"></a>00133   parallel_only();
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="comment">// What to do if the Parmetis library IS NOT present</span>
<a name="l00136"></a>00136 <span class="preprocessor">#ifndef LIBMESH_HAVE_PARMETIS</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span>
<a name="l00138"></a>00138   libmesh_here();
<a name="l00139"></a>00139   <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: The library has been built without&quot;</span>  &lt;&lt; std::endl
<a name="l00140"></a>00140                 &lt;&lt; <span class="stringliteral">&quot;Parmetis support.  Using a Metis&quot;</span>           &lt;&lt; std::endl
<a name="l00141"></a>00141                 &lt;&lt; <span class="stringliteral">&quot;partitioner instead!&quot;</span>                       &lt;&lt; std::endl;
<a name="l00142"></a>00142 
<a name="l00143"></a>00143   <a class="code" href="classlibMesh_1_1MetisPartitioner.php">MetisPartitioner</a> mp;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145   mp.<a class="code" href="classlibMesh_1_1Partitioner.php#ac5ab060463865dc0b6fe4a614aad626f">partition</a> (mesh, n_sbdmns);
<a name="l00146"></a>00146   
<a name="l00147"></a>00147 <span class="comment">// What to do if the Parmetis library IS present</span>
<a name="l00148"></a>00148 <span class="preprocessor">#else</span>
<a name="l00149"></a>00149 <span class="preprocessor"></span>
<a name="l00150"></a>00150   <span class="comment">// Revert to METIS on one processor.</span>
<a name="l00151"></a>00151   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00152"></a>00152     {
<a name="l00153"></a>00153       <a class="code" href="classlibMesh_1_1MetisPartitioner.php">MetisPartitioner</a> mp;
<a name="l00154"></a>00154       mp.<a class="code" href="classlibMesh_1_1Partitioner.php#ac5ab060463865dc0b6fe4a614aad626f">partition</a> (mesh, n_sbdmns);
<a name="l00155"></a>00155       <span class="keywordflow">return</span>;   
<a name="l00156"></a>00156     }
<a name="l00157"></a>00157   
<a name="l00158"></a>00158   START_LOG(<span class="stringliteral">&quot;repartition()&quot;</span>, <span class="stringliteral">&quot;ParmetisPartitioner&quot;</span>);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">// Initialize the data structures required by ParMETIS</span>
<a name="l00161"></a>00161   this-&gt;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad30c9f4513a46e0f56f9263284b79131">initialize</a> (mesh, n_sbdmns);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   <span class="comment">// Make sure all processors have some active local elements.</span>
<a name="l00164"></a>00164   {
<a name="l00165"></a>00165     <span class="keywordtype">bool</span> all_have_active_elements = <span class="keyword">true</span>;
<a name="l00166"></a>00166     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0ac5148ba078b5a589a20bb1d908a799">_n_active_elem_on_proc</a>.size(); pid++)
<a name="l00167"></a>00167       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0ac5148ba078b5a589a20bb1d908a799">_n_active_elem_on_proc</a>[pid]) all_have_active_elements = <span class="keyword">false</span>;
<a name="l00168"></a>00168 
<a name="l00169"></a>00169     <span class="comment">// Parmetis will not work unless each processor has some</span>
<a name="l00170"></a>00170     <span class="comment">// elements. Specifically, it will abort when passed a NULL</span>
<a name="l00171"></a>00171     <span class="comment">// partition array on *any* of the processors.</span>
<a name="l00172"></a>00172     <span class="keywordflow">if</span> (!all_have_active_elements)
<a name="l00173"></a>00173       {
<a name="l00174"></a>00174         <span class="comment">// Cowardly revert to METIS, although this requires a serial mesh</span>
<a name="l00175"></a>00175         <span class="keywordtype">bool</span> mesh_was_serial = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>();
<a name="l00176"></a>00176         <span class="keywordflow">if</span> (!mesh_was_serial)
<a name="l00177"></a>00177           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a880cd0ce25794e2b0b200b1d6f6086be">allgather</a>();
<a name="l00178"></a>00178 
<a name="l00179"></a>00179         STOP_LOG (<span class="stringliteral">&quot;repartition()&quot;</span>, <span class="stringliteral">&quot;ParmetisPartitioner&quot;</span>);
<a name="l00180"></a>00180   
<a name="l00181"></a>00181         <a class="code" href="classlibMesh_1_1MetisPartitioner.php">MetisPartitioner</a> mp;
<a name="l00182"></a>00182         mp.<a class="code" href="classlibMesh_1_1Partitioner.php#ac5ab060463865dc0b6fe4a614aad626f">partition</a> (mesh, n_sbdmns);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184         <span class="keywordflow">if</span> (mesh_was_serial)
<a name="l00185"></a>00185           mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a8d57ce79036999648936424bfbab715e">delete_remote_elements</a>();
<a name="l00186"></a>00186 
<a name="l00187"></a>00187         <span class="keywordflow">return</span>; 
<a name="l00188"></a>00188       }
<a name="l00189"></a>00189   }
<a name="l00190"></a>00190   
<a name="l00191"></a>00191   <span class="comment">// build the graph corresponding to the mesh</span>
<a name="l00192"></a>00192   this-&gt;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#acea02552c610550f08685883063122bc">build_graph</a> (mesh);
<a name="l00193"></a>00193   
<a name="l00194"></a>00194 
<a name="l00195"></a>00195   <span class="comment">// Partition the graph</span>
<a name="l00196"></a>00196   std::vector&lt;int&gt; vsize(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a77bf3f973b518c4e484bd19d445d0c51">_vwgt</a>.size(), 1);
<a name="l00197"></a>00197   <span class="keywordtype">float</span> itr = 1000000.0;
<a name="l00198"></a>00198   MPI_Comm mpi_comm = <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>;
<a name="l00199"></a>00199 
<a name="l00200"></a>00200   <span class="comment">// Call the ParMETIS adaptive repartitioning method.  This respects the</span>
<a name="l00201"></a>00201   <span class="comment">// original partitioning when computing the new partitioning so as to</span>
<a name="l00202"></a>00202   <span class="comment">// minimize the required data redistribution.</span>
<a name="l00203"></a>00203   Parmetis::ParMETIS_V3_AdaptiveRepart(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>.empty() ? NULL : &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>[0],
<a name="l00204"></a>00204                                        <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af8bcfd8ed5708fa6357bc1dcc97526be">_xadj</a>.empty()    ? NULL : &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af8bcfd8ed5708fa6357bc1dcc97526be">_xadj</a>[0],
<a name="l00205"></a>00205                                        <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>.empty()  ? NULL : &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>[0],
<a name="l00206"></a>00206                                        <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a77bf3f973b518c4e484bd19d445d0c51">_vwgt</a>.empty()    ? NULL : &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a77bf3f973b518c4e484bd19d445d0c51">_vwgt</a>[0],
<a name="l00207"></a>00207                                        vsize.empty()    ? NULL : &amp;vsize[0],
<a name="l00208"></a>00208                                        NULL,
<a name="l00209"></a>00209                                        &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a23cc5083f2530fa7984523f25dd814c5">_wgtflag</a>,
<a name="l00210"></a>00210                                        &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa76a3c2eebfe6ec5be88617712773ba2">_numflag</a>,
<a name="l00211"></a>00211                                        &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a10b034fbe1ad212d6217cfd484b8d13b">_ncon</a>,
<a name="l00212"></a>00212                                        &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>,
<a name="l00213"></a>00213                                        <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af974f6c3c39b04f2f2e15991d2fd6fd1">_tpwgts</a>.empty()  ? NULL : &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af974f6c3c39b04f2f2e15991d2fd6fd1">_tpwgts</a>[0],
<a name="l00214"></a>00214                                        <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa5e0cdda686b95f1fa34adb39fe73f4d">_ubvec</a>.empty()   ? NULL : &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa5e0cdda686b95f1fa34adb39fe73f4d">_ubvec</a>[0],
<a name="l00215"></a>00215                                        &amp;itr,
<a name="l00216"></a>00216                                        &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae746c3e4230e553bfcdcaf43366e5604">_options</a>[0],
<a name="l00217"></a>00217                                        &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0d7753360568225f28d5f60f2e5b4d59">_edgecut</a>,
<a name="l00218"></a>00218                                        <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>.empty()    ? NULL : &amp;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>[0],
<a name="l00219"></a>00219                                        &amp;mpi_comm);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   <span class="comment">// Assign the returned processor ids</span>
<a name="l00222"></a>00222   this-&gt;<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a2d687743269cc2687047b6eaaab5c864">assign_partitioning</a> (mesh);
<a name="l00223"></a>00223   
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   STOP_LOG (<span class="stringliteral">&quot;repartition()&quot;</span>, <span class="stringliteral">&quot;ParmetisPartitioner&quot;</span>);
<a name="l00226"></a>00226   
<a name="l00227"></a>00227 <span class="preprocessor">#endif // #ifndef LIBMESH_HAVE_PARMETIS ... else ...</span>
<a name="l00228"></a>00228 <span class="preprocessor"></span>  
<a name="l00229"></a>00229 }
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 
<a name="l00233"></a>00233 <span class="comment">// Only need to compile these methods if ParMETIS is present</span>
<a name="l00234"></a>00234 <span class="preprocessor">#ifdef LIBMESH_HAVE_PARMETIS</span>
<a name="l00235"></a>00235 <span class="preprocessor"></span>
<a name="l00236"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad30c9f4513a46e0f56f9263284b79131">00236</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad30c9f4513a46e0f56f9263284b79131">ParmetisPartitioner::initialize</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00237"></a>00237                                       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sbdmns)
<a name="l00238"></a>00238 {
<a name="l00239"></a>00239   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_local_elem = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a29e50bada0ed564a1365e13173598565">n_active_local_elem</a>();
<a name="l00240"></a>00240 
<a name="l00241"></a>00241   <span class="comment">// Set parameters.</span>
<a name="l00242"></a>00242   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a23cc5083f2530fa7984523f25dd814c5">_wgtflag</a> = 2;                          <span class="comment">// weights on vertices only</span>
<a name="l00243"></a>00243   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a10b034fbe1ad212d6217cfd484b8d13b">_ncon</a>    = 1;                          <span class="comment">// one weight per vertex</span>
<a name="l00244"></a>00244   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa76a3c2eebfe6ec5be88617712773ba2">_numflag</a> = 0;                          <span class="comment">// C-style 0-based numbering</span>
<a name="l00245"></a>00245   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>  = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_sbdmns); <span class="comment">// number of subdomains to create</span>
<a name="l00246"></a>00246   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0d7753360568225f28d5f60f2e5b4d59">_edgecut</a> = 0;                          <span class="comment">// the numbers of edges cut by the</span>
<a name="l00247"></a>00247                                          <span class="comment">//   partition</span>
<a name="l00248"></a>00248 
<a name="l00249"></a>00249   <span class="comment">// Initialize data structures for ParMETIS</span>
<a name="l00250"></a>00250   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>.resize (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()+1); std::fill (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>.begin(), <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>.end(), 0);
<a name="l00251"></a>00251   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af974f6c3c39b04f2f2e15991d2fd6fd1">_tpwgts</a>.resize  (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>);                   std::fill (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af974f6c3c39b04f2f2e15991d2fd6fd1">_tpwgts</a>.begin(),  <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af974f6c3c39b04f2f2e15991d2fd6fd1">_tpwgts</a>.end(),  1./<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>);
<a name="l00252"></a>00252   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa5e0cdda686b95f1fa34adb39fe73f4d">_ubvec</a>.resize   (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a10b034fbe1ad212d6217cfd484b8d13b">_ncon</a>);                     std::fill (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa5e0cdda686b95f1fa34adb39fe73f4d">_ubvec</a>.begin(),   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa5e0cdda686b95f1fa34adb39fe73f4d">_ubvec</a>.end(),   1.);
<a name="l00253"></a>00253   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>.resize    (n_active_local_elem);       std::fill (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>.begin(),    <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>.end(), 0);
<a name="l00254"></a>00254   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae746c3e4230e553bfcdcaf43366e5604">_options</a>.resize (5);
<a name="l00255"></a>00255   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a77bf3f973b518c4e484bd19d445d0c51">_vwgt</a>.resize    (n_active_local_elem);
<a name="l00256"></a>00256   
<a name="l00257"></a>00257   <span class="comment">// Set the options</span>
<a name="l00258"></a>00258   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae746c3e4230e553bfcdcaf43366e5604">_options</a>[0] = 1;  <span class="comment">// don&#39;t use default options</span>
<a name="l00259"></a>00259   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae746c3e4230e553bfcdcaf43366e5604">_options</a>[1] = 0;  <span class="comment">// default (level of timing)</span>
<a name="l00260"></a>00260   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae746c3e4230e553bfcdcaf43366e5604">_options</a>[2] = 15; <span class="comment">// random seed (default)</span>
<a name="l00261"></a>00261   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae746c3e4230e553bfcdcaf43366e5604">_options</a>[3] = 2;  <span class="comment">// processor distribution and subdomain distribution are decoupled</span>
<a name="l00262"></a>00262   
<a name="l00263"></a>00263   <span class="comment">// Find the number of active elements on each processor.  We cannot use</span>
<a name="l00264"></a>00264   <span class="comment">// mesh.n_active_elem_on_proc(pid) since that only returns the number of</span>
<a name="l00265"></a>00265   <span class="comment">// elements assigned to pid which are currently stored on the calling </span>
<a name="l00266"></a>00266   <span class="comment">// processor. This will not in general be correct for parallel meshes</span>
<a name="l00267"></a>00267   <span class="comment">// when (pid!=libMesh::processor_id()).</span>
<a name="l00268"></a>00268   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0ac5148ba078b5a589a20bb1d908a799">_n_active_elem_on_proc</a>.resize(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00269"></a>00269   <a class="code" href="namespacelibMesh_1_1Parallel.php#a5d83bd3061eee7fc9ec2c58427c67aef">Parallel::allgather</a>(n_active_local_elem, <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0ac5148ba078b5a589a20bb1d908a799">_n_active_elem_on_proc</a>);
<a name="l00270"></a>00270 
<a name="l00271"></a>00271   <span class="comment">// count the total number of active elements in the mesh.  Note we cannot</span>
<a name="l00272"></a>00272   <span class="comment">// use mesh.n_active_elem() in general since this only returns the number</span>
<a name="l00273"></a>00273   <span class="comment">// of active elements which are stored on the calling processor.</span>
<a name="l00274"></a>00274   <span class="comment">// We should not use n_active_elem for any allocation because that will</span>
<a name="l00275"></a>00275   <span class="comment">// be inheritly unscalable, but it can be useful for libmesh_assertions.</span>
<a name="l00276"></a>00276   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_elem=0;
<a name="l00277"></a>00277 
<a name="l00278"></a>00278   <span class="comment">// Set up the vtxdist array.  This will be the same on each processor.</span>
<a name="l00279"></a>00279   <span class="comment">// ***** Consult the Parmetis documentation. *****</span>
<a name="l00280"></a>00280   libmesh_assert (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>.size() == <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()+1);
<a name="l00281"></a>00281   libmesh_assert (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>[0] == 0);
<a name="l00282"></a>00282   
<a name="l00283"></a>00283   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00284"></a>00284     {
<a name="l00285"></a>00285       <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>[pid+1] = <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>[pid] + <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0ac5148ba078b5a589a20bb1d908a799">_n_active_elem_on_proc</a>[pid];
<a name="l00286"></a>00286       n_active_elem += _n_active_elem_on_proc[pid];
<a name="l00287"></a>00287     }
<a name="l00288"></a>00288   libmesh_assert (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>.back() == <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_active_elem));
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   <span class="comment">// ParMetis expects the elements to be numbered in contiguous blocks</span>
<a name="l00291"></a>00291   <span class="comment">// by processor, i.e. [0, ne0), [ne0, ne0+ne1), ...</span>
<a name="l00292"></a>00292   <span class="comment">// Since we only partition active elements we should have no expectation</span>
<a name="l00293"></a>00293   <span class="comment">// that we currently have such a distribution.  So we need to create it.</span>
<a name="l00294"></a>00294   <span class="comment">// Also, at the same time we are going to map all the active elements into a globally</span>
<a name="l00295"></a>00295   <span class="comment">// unique range [0,n_active_elem) which is *independent* of the current partitioning.</span>
<a name="l00296"></a>00296   <span class="comment">// This can be fed to ParMetis as the initial partitioning of the subdomains (decoupled</span>
<a name="l00297"></a>00297   <span class="comment">// from the partitioning of the objects themselves).  This allows us to get the same</span>
<a name="l00298"></a>00298   <span class="comment">// resultant partitioning independed of the input partitioning.</span>
<a name="l00299"></a>00299   <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> bbox =
<a name="l00300"></a>00300     <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">MeshTools::bounding_box</a>(mesh);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>.clear();
<a name="l00303"></a>00303 
<a name="l00304"></a>00304   <span class="comment">// Maps active element ids into a contiguous range independent of partitioning.</span>
<a name="l00305"></a>00305   <span class="comment">// (only needs local scope)</span>
<a name="l00306"></a>00306   std::map&lt;unsigned int, unsigned int&gt; global_index_map;
<a name="l00307"></a>00307 
<a name="l00308"></a>00308   {
<a name="l00309"></a>00309     std::vector&lt;unsigned int&gt; global_index;
<a name="l00310"></a>00310 
<a name="l00311"></a>00311     <span class="comment">// create the mapping which is contiguous by processor </span>
<a name="l00312"></a>00312     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0, pid_offset=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00313"></a>00313       {
<a name="l00314"></a>00314         <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ad250f85e39b8bbdfcc6605c6006aa202">active_pid_elements_begin</a>(pid);
<a name="l00315"></a>00315         <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#adf7c40f7022d79c4b9a96f2284fce248">active_pid_elements_end</a>(pid); 
<a name="l00316"></a>00316         
<a name="l00317"></a>00317         <span class="comment">// note that we may not have all (or any!) the active elements which belong on this processor,</span>
<a name="l00318"></a>00318         <span class="comment">// but by calling this on all processors a unique range in [0,_n_active_elem_on_proc[pid])</span>
<a name="l00319"></a>00319         <span class="comment">// is constructed.  Only the indices for the elements we pass in are returned in the array.</span>
<a name="l00320"></a>00320         <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#aa796c4e551a56a3e15603a2ffa7c6aaf">find_global_indices</a> (bbox, it, end, 
<a name="l00321"></a>00321                                                  global_index);
<a name="l00322"></a>00322         
<a name="l00323"></a>00323         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0; it != end; ++it)
<a name="l00324"></a>00324           {
<a name="l00325"></a>00325             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *it;
<a name="l00326"></a>00326             libmesh_assert (!<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>.count(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()));
<a name="l00327"></a>00327             libmesh_assert (cnt &lt; global_index.size());
<a name="l00328"></a>00328             libmesh_assert (global_index[cnt] &lt; <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0ac5148ba078b5a589a20bb1d908a799">_n_active_elem_on_proc</a>[pid]);
<a name="l00329"></a>00329 
<a name="l00330"></a>00330             <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]  = global_index[cnt++] + pid_offset;
<a name="l00331"></a>00331           }
<a name="l00332"></a>00332 
<a name="l00333"></a>00333         pid_offset += <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0ac5148ba078b5a589a20bb1d908a799">_n_active_elem_on_proc</a>[pid];
<a name="l00334"></a>00334       }
<a name="l00335"></a>00335 
<a name="l00336"></a>00336     <span class="comment">// create the unique mapping for all active elements independent of partitioning</span>
<a name="l00337"></a>00337     {
<a name="l00338"></a>00338       <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00339"></a>00339       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00340"></a>00340         
<a name="l00341"></a>00341       <span class="comment">// Calling this on all processors a unique range in [0,n_active_elem) is constructed.  </span>
<a name="l00342"></a>00342       <span class="comment">// Only the indices for the elements we pass in are returned in the array.</span>
<a name="l00343"></a>00343       <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#aa796c4e551a56a3e15603a2ffa7c6aaf">find_global_indices</a> (bbox, it, end, 
<a name="l00344"></a>00344                                                global_index);
<a name="l00345"></a>00345       
<a name="l00346"></a>00346       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0; it != end; ++it)
<a name="l00347"></a>00347         {
<a name="l00348"></a>00348           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *it;
<a name="l00349"></a>00349           libmesh_assert (!global_index_map.count(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()));
<a name="l00350"></a>00350           libmesh_assert (cnt &lt; global_index.size());
<a name="l00351"></a>00351           libmesh_assert (global_index[cnt] &lt; n_active_elem);
<a name="l00352"></a>00352 
<a name="l00353"></a>00353           global_index_map[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]  = global_index[cnt++];
<a name="l00354"></a>00354         }
<a name="l00355"></a>00355       }
<a name="l00356"></a>00356     <span class="comment">// really, shouldn&#39;t be close!</span>
<a name="l00357"></a>00357     libmesh_assert (global_index_map.size() &lt;= n_active_elem);
<a name="l00358"></a>00358     libmesh_assert (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>.size() &lt;= n_active_elem);
<a name="l00359"></a>00359 
<a name="l00360"></a>00360     <span class="comment">// At this point the two maps should be the same size.  If they are not</span>
<a name="l00361"></a>00361     <span class="comment">// then the number of active elements is not the same as the sum over all </span>
<a name="l00362"></a>00362     <span class="comment">// processors of the number of active elements per processor, which means</span>
<a name="l00363"></a>00363     <span class="comment">// there must be some unpartitioned objects out there.</span>
<a name="l00364"></a>00364     <span class="keywordflow">if</span> (global_index_map.size() != <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>.size())
<a name="l00365"></a>00365       {
<a name="l00366"></a>00366         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  ParmetisPartitioner cannot handle unpartitioned objects!&quot;</span>
<a name="l00367"></a>00367                       &lt;&lt; std::endl;
<a name="l00368"></a>00368         libmesh_error();
<a name="l00369"></a>00369       }    
<a name="l00370"></a>00370   }
<a name="l00371"></a>00371 
<a name="l00372"></a>00372   <span class="comment">// Finally, we need to initialize the vertex (partition) weights and the initial subdomain</span>
<a name="l00373"></a>00373   <span class="comment">// mapping.  The subdomain mapping will be independent of the processor mapping, and is </span>
<a name="l00374"></a>00374   <span class="comment">// defined by a simple mapping of the global indices we just found.</span>
<a name="l00375"></a>00375   {
<a name="l00376"></a>00376     std::vector&lt;unsigned int&gt; subdomain_bounds(libMesh::n_processors());
<a name="l00377"></a>00377 
<a name="l00378"></a>00378     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_elem = <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()];
<a name="l00379"></a>00379 
<a name="l00380"></a>00380     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00381"></a>00381       {
<a name="l00382"></a>00382         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tgt_subdomain_size = 0;
<a name="l00383"></a>00383         
<a name="l00384"></a>00384         <span class="comment">// watch out for the case that n_subdomains &lt; n_processors</span>
<a name="l00385"></a>00385         <span class="keywordflow">if</span> (pid &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>))
<a name="l00386"></a>00386           {     
<a name="l00387"></a>00387             tgt_subdomain_size =
<a name="l00388"></a>00388               n_active_elem/<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(libMesh::n_processors(),
<a name="l00389"></a>00389                                      static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>));
<a name="l00390"></a>00390             
<a name="l00391"></a>00391             <span class="keywordflow">if</span> (pid &lt; n_active_elem%<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>)
<a name="l00392"></a>00392               tgt_subdomain_size++;
<a name="l00393"></a>00393           }
<a name="l00394"></a>00394         <span class="keywordflow">if</span> (pid == 0)
<a name="l00395"></a>00395           subdomain_bounds[0] = tgt_subdomain_size;
<a name="l00396"></a>00396         <span class="keywordflow">else</span>
<a name="l00397"></a>00397           subdomain_bounds[pid] = subdomain_bounds[pid-1] + tgt_subdomain_size;
<a name="l00398"></a>00398       }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400     libmesh_assert (subdomain_bounds.back() == n_active_elem);
<a name="l00401"></a>00401 
<a name="l00402"></a>00402     <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00403"></a>00403     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>();
<a name="l00404"></a>00404     
<a name="l00405"></a>00405     <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00406"></a>00406       {
<a name="l00407"></a>00407         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *elem_it;
<a name="l00408"></a>00408         
<a name="l00409"></a>00409         libmesh_assert (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>.count(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()));
<a name="l00410"></a>00410         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index_by_pid = 
<a name="l00411"></a>00411           <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()]; 
<a name="l00412"></a>00412         libmesh_assert (global_index_by_pid &lt; n_active_elem);
<a name="l00413"></a>00413         
<a name="l00414"></a>00414         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index =
<a name="l00415"></a>00415           global_index_by_pid - first_local_elem;
<a name="l00416"></a>00416         
<a name="l00417"></a>00417         libmesh_assert (local_index &lt; n_active_local_elem);
<a name="l00418"></a>00418         libmesh_assert (local_index &lt; <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a77bf3f973b518c4e484bd19d445d0c51">_vwgt</a>.size());
<a name="l00419"></a>00419         
<a name="l00420"></a>00420         <span class="comment">// TODO:[BSK] maybe there is a better weight?</span>
<a name="l00421"></a>00421         <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a77bf3f973b518c4e484bd19d445d0c51">_vwgt</a>[local_index] = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>();
<a name="l00422"></a>00422         
<a name="l00423"></a>00423         <span class="comment">// find the subdomain this element belongs in</span>
<a name="l00424"></a>00424         libmesh_assert (global_index_map.count(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()));
<a name="l00425"></a>00425         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index =
<a name="l00426"></a>00426           global_index_map[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()];
<a name="l00427"></a>00427         
<a name="l00428"></a>00428         libmesh_assert (global_index &lt; subdomain_bounds.back());
<a name="l00429"></a>00429         
<a name="l00430"></a>00430         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id =
<a name="l00431"></a>00431           std::distance(subdomain_bounds.begin(),
<a name="l00432"></a>00432                         std::lower_bound(subdomain_bounds.begin(),
<a name="l00433"></a>00433                                          subdomain_bounds.end(),
<a name="l00434"></a>00434                                          global_index));
<a name="l00435"></a>00435         libmesh_assert (subdomain_id &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>));
<a name="l00436"></a>00436         libmesh_assert (local_index &lt; <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>.size());
<a name="l00437"></a>00437           
<a name="l00438"></a>00438         <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>[local_index] = subdomain_id;
<a name="l00439"></a>00439       }    
<a name="l00440"></a>00440   }
<a name="l00441"></a>00441 }
<a name="l00442"></a>00442 
<a name="l00443"></a>00443 
<a name="l00444"></a>00444 
<a name="l00445"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#acea02552c610550f08685883063122bc">00445</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#acea02552c610550f08685883063122bc">ParmetisPartitioner::build_graph</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00446"></a>00446 {
<a name="l00447"></a>00447   <span class="comment">// build the graph in distributed CSR format.  Note that</span>
<a name="l00448"></a>00448   <span class="comment">// the edges in the graph will correspond to</span>
<a name="l00449"></a>00449   <span class="comment">// face neighbors</span>
<a name="l00450"></a>00450   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_active_local_elem  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a29e50bada0ed564a1365e13173598565">n_active_local_elem</a>();
<a name="l00451"></a>00451     
<a name="l00452"></a>00452   std::vector&lt;const Elem*&gt; neighbors_offspring;
<a name="l00453"></a>00453   
<a name="l00454"></a>00454   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; graph(n_active_local_elem);
<a name="l00455"></a>00455   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> graph_size=0;
<a name="l00456"></a>00456 
<a name="l00457"></a>00457   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_elem = <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()];
<a name="l00458"></a>00458   
<a name="l00459"></a>00459   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>();
<a name="l00460"></a>00460   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(); 
<a name="l00461"></a>00461   
<a name="l00462"></a>00462   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00463"></a>00463     {
<a name="l00464"></a>00464       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00465"></a>00465         
<a name="l00466"></a>00466       libmesh_assert (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>.count(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()));
<a name="l00467"></a>00467       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index_by_pid = 
<a name="l00468"></a>00468         <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()];   
<a name="l00469"></a>00469         
<a name="l00470"></a>00470       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index =
<a name="l00471"></a>00471         global_index_by_pid - first_local_elem;
<a name="l00472"></a>00472       libmesh_assert (local_index &lt; n_active_local_elem);
<a name="l00473"></a>00473 
<a name="l00474"></a>00474       std::vector&lt;unsigned int&gt; &amp;graph_row = graph[local_index];
<a name="l00475"></a>00475 
<a name="l00476"></a>00476       <span class="comment">// Loop over the element&#39;s neighbors.  An element</span>
<a name="l00477"></a>00477       <span class="comment">// adjacency corresponds to a face neighbor</span>
<a name="l00478"></a>00478       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ms=0; ms&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#adf36086a897fdef3a88deec071ca5dfd">n_neighbors</a>(); ms++)
<a name="l00479"></a>00479         {
<a name="l00480"></a>00480           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(ms);
<a name="l00481"></a>00481           
<a name="l00482"></a>00482           <span class="keywordflow">if</span> (neighbor != NULL)
<a name="l00483"></a>00483             {  
<a name="l00484"></a>00484               <span class="comment">// If the neighbor is active treat it</span>
<a name="l00485"></a>00485               <span class="comment">// as a connection</span>
<a name="l00486"></a>00486               <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())
<a name="l00487"></a>00487                 {
<a name="l00488"></a>00488                   libmesh_assert(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>.count(neighbor-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()));
<a name="l00489"></a>00489                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> neighbor_global_index_by_pid =
<a name="l00490"></a>00490                     <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>[neighbor-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()];
<a name="l00491"></a>00491                   
<a name="l00492"></a>00492                   graph_row.push_back(neighbor_global_index_by_pid);
<a name="l00493"></a>00493                   graph_size++;
<a name="l00494"></a>00494                 }
<a name="l00495"></a>00495   
<a name="l00496"></a>00496 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00497"></a>00497 <span class="preprocessor"></span>              
<a name="l00498"></a>00498               <span class="comment">// Otherwise we need to find all of the</span>
<a name="l00499"></a>00499               <span class="comment">// neighbor&#39;s children that are connected to</span>
<a name="l00500"></a>00500               <span class="comment">// us and add them</span>
<a name="l00501"></a>00501               <span class="keywordflow">else</span>
<a name="l00502"></a>00502                 {
<a name="l00503"></a>00503                   <span class="comment">// The side of the neighbor to which</span>
<a name="l00504"></a>00504                   <span class="comment">// we are connected</span>
<a name="l00505"></a>00505                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ns =
<a name="l00506"></a>00506                     neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ad5c780d4c81ecf044e4b864573562d81">which_neighbor_am_i</a> (elem);
<a name="l00507"></a>00507                   libmesh_assert (ns &lt; neighbor-&gt;n_neighbors());
<a name="l00508"></a>00508                   
<a name="l00509"></a>00509                   <span class="comment">// Get all the active children (&amp; grandchildren, etc...)</span>
<a name="l00510"></a>00510                   <span class="comment">// of the neighbor.</span>
<a name="l00511"></a>00511                   neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a115d93be0231e3c0bacf45a6a4f1804d">active_family_tree</a> (neighbors_offspring);
<a name="l00512"></a>00512                   
<a name="l00513"></a>00513                   <span class="comment">// Get all the neighbor&#39;s children that</span>
<a name="l00514"></a>00514                   <span class="comment">// live on that side and are thus connected</span>
<a name="l00515"></a>00515                   <span class="comment">// to us</span>
<a name="l00516"></a>00516                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nc=0; nc&lt;neighbors_offspring.size(); nc++)
<a name="l00517"></a>00517                     {
<a name="l00518"></a>00518                       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* child =
<a name="l00519"></a>00519                         neighbors_offspring[nc];
<a name="l00520"></a>00520                       
<a name="l00521"></a>00521                       <span class="comment">// This does not assume a level-1 mesh.</span>
<a name="l00522"></a>00522                       <span class="comment">// Note that since children have sides numbered</span>
<a name="l00523"></a>00523                       <span class="comment">// coincident with the parent then this is a sufficient test.</span>
<a name="l00524"></a>00524                       <span class="keywordflow">if</span> (child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(ns) == elem)
<a name="l00525"></a>00525                         {
<a name="l00526"></a>00526                           libmesh_assert (child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00527"></a>00527                           libmesh_assert (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>.count(child-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()));
<a name="l00528"></a>00528                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> child_global_index_by_pid =
<a name="l00529"></a>00529                             <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>[child-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>()];
<a name="l00530"></a>00530 
<a name="l00531"></a>00531                           graph_row.push_back(child_global_index_by_pid);
<a name="l00532"></a>00532                           graph_size++;
<a name="l00533"></a>00533                         }
<a name="l00534"></a>00534                     }
<a name="l00535"></a>00535                 }
<a name="l00536"></a>00536 
<a name="l00537"></a>00537 <span class="preprocessor">#endif </span><span class="comment">/* ifdef LIBMESH_ENABLE_AMR */</span>
<a name="l00538"></a>00538 
<a name="l00539"></a>00539 
<a name="l00540"></a>00540             }
<a name="l00541"></a>00541         }
<a name="l00542"></a>00542     }
<a name="l00543"></a>00543 
<a name="l00544"></a>00544   <span class="comment">// Reserve space in the adjacency array</span>
<a name="l00545"></a>00545   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af8bcfd8ed5708fa6357bc1dcc97526be">_xadj</a>.clear();
<a name="l00546"></a>00546   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af8bcfd8ed5708fa6357bc1dcc97526be">_xadj</a>.reserve (n_active_local_elem + 1);
<a name="l00547"></a>00547   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>.clear();
<a name="l00548"></a>00548   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>.reserve (graph_size);
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> r=0; r&lt;graph.size(); r++)
<a name="l00551"></a>00551     {
<a name="l00552"></a>00552       <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af8bcfd8ed5708fa6357bc1dcc97526be">_xadj</a>.push_back(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>.size());
<a name="l00553"></a>00553       std::vector&lt;unsigned int&gt; graph_row; <span class="comment">// build this emtpy</span>
<a name="l00554"></a>00554       graph_row.swap(graph[r]); <span class="comment">// this will deallocate at the end of scope</span>
<a name="l00555"></a>00555       <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>.insert(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>.end(),
<a name="l00556"></a>00556                      graph_row.begin(),
<a name="l00557"></a>00557                      graph_row.end());
<a name="l00558"></a>00558     }
<a name="l00559"></a>00559   
<a name="l00560"></a>00560   <span class="comment">// The end of the adjacency array for the last elem</span>
<a name="l00561"></a>00561   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af8bcfd8ed5708fa6357bc1dcc97526be">_xadj</a>.push_back(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>.size());
<a name="l00562"></a>00562   
<a name="l00563"></a>00563   libmesh_assert (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af8bcfd8ed5708fa6357bc1dcc97526be">_xadj</a>.size() == n_active_local_elem+1);
<a name="l00564"></a>00564   libmesh_assert (<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>.size() == graph_size);
<a name="l00565"></a>00565 }
<a name="l00566"></a>00566 
<a name="l00567"></a>00567 
<a name="l00568"></a>00568 
<a name="l00569"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a2d687743269cc2687047b6eaaab5c864">00569</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a2d687743269cc2687047b6eaaab5c864">ParmetisPartitioner::assign_partitioning</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00570"></a>00570 {
<a name="l00571"></a>00571   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> 
<a name="l00572"></a>00572     first_local_elem = <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>[<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()];
<a name="l00573"></a>00573     
<a name="l00574"></a>00574   std::vector&lt;std::vector&lt;unsigned int&gt; &gt; 
<a name="l00575"></a>00575     requested_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>()),
<a name="l00576"></a>00576     requests_to_fill(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00577"></a>00577   
<a name="l00578"></a>00578   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00579"></a>00579   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00580"></a>00580     
<a name="l00581"></a>00581   <span class="keywordflow">for</span> (; elem_it != elem_end; ++elem_it)
<a name="l00582"></a>00582     {   
<a name="l00583"></a>00583       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *elem_it;
<a name="l00584"></a>00584 
<a name="l00585"></a>00585       <span class="comment">// we need to get the index from the owning processor</span>
<a name="l00586"></a>00586       <span class="comment">// (note we cannot assign it now -- we are iterating</span>
<a name="l00587"></a>00587       <span class="comment">// over elements again and this will be bad!)</span>
<a name="l00588"></a>00588       libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() &lt; requested_ids.size());
<a name="l00589"></a>00589       requested_ids[elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>()].push_back(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00590"></a>00590     }
<a name="l00591"></a>00591   
<a name="l00592"></a>00592   <span class="comment">// Trade with all processors (including self) to get their indices</span>
<a name="l00593"></a>00593   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00594"></a>00594     {
<a name="l00595"></a>00595       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00596"></a>00596       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + pid) %
<a name="l00597"></a>00597                                    libMesh::n_processors();
<a name="l00598"></a>00598       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00599"></a>00599                                      <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - pid) %
<a name="l00600"></a>00600                                      libMesh::n_processors();
<a name="l00601"></a>00601 
<a name="l00602"></a>00602       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a> (procup,   requested_ids[procup],
<a name="l00603"></a>00603                               procdown, requests_to_fill[procdown]); 
<a name="l00604"></a>00604 
<a name="l00605"></a>00605       <span class="comment">// we can overwrite these requested ids in-place.</span>
<a name="l00606"></a>00606       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;requests_to_fill[procdown].size(); i++)
<a name="l00607"></a>00607         {
<a name="l00608"></a>00608           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> requested_elem_index = 
<a name="l00609"></a>00609             requests_to_fill[procdown][i];
<a name="l00610"></a>00610 
<a name="l00611"></a>00611           libmesh_assert(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>.count(requested_elem_index));
<a name="l00612"></a>00612 
<a name="l00613"></a>00613           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index_by_pid = 
<a name="l00614"></a>00614             <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>[requested_elem_index];
<a name="l00615"></a>00615 
<a name="l00616"></a>00616           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index =
<a name="l00617"></a>00617             global_index_by_pid - first_local_elem;
<a name="l00618"></a>00618             
<a name="l00619"></a>00619           libmesh_assert (local_index &lt; <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>.size());
<a name="l00620"></a>00620           libmesh_assert (local_index &lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a29e50bada0ed564a1365e13173598565">n_active_local_elem</a>());
<a name="l00621"></a>00621           
<a name="l00622"></a>00622           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_procid =
<a name="l00623"></a>00623             <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>[local_index]);
<a name="l00624"></a>00624 
<a name="l00625"></a>00625           libmesh_assert (elem_procid &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>));
<a name="l00626"></a>00626 
<a name="l00627"></a>00627           requests_to_fill[procdown][i] = elem_procid;
<a name="l00628"></a>00628         }
<a name="l00629"></a>00629 
<a name="l00630"></a>00630       <span class="comment">// Trade back</span>
<a name="l00631"></a>00631       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a> (procdown, requests_to_fill[procdown],
<a name="l00632"></a>00632                               procup,   requested_ids[procup]);
<a name="l00633"></a>00633     }
<a name="l00634"></a>00634 
<a name="l00635"></a>00635    <span class="comment">// and finally assign the partitioning.</span>
<a name="l00636"></a>00636    <span class="comment">// note we are iterating in exactly the same order</span>
<a name="l00637"></a>00637    <span class="comment">// used to build up the request, so we can expect the</span>
<a name="l00638"></a>00638    <span class="comment">// required entries to be in the proper sequence.</span>
<a name="l00639"></a>00639    elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00640"></a>00640    elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();      
<a name="l00641"></a>00641    
<a name="l00642"></a>00642    <span class="keywordflow">for</span> (std::vector&lt;unsigned int&gt; counters(libMesh::n_processors(), 0);  
<a name="l00643"></a>00643         elem_it != elem_end; ++elem_it)
<a name="l00644"></a>00644      {  
<a name="l00645"></a>00645        <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *elem_it;
<a name="l00646"></a>00646        
<a name="l00647"></a>00647        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_pid = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00648"></a>00648        
<a name="l00649"></a>00649        libmesh_assert (counters[current_pid] &lt; requested_ids[current_pid].size());
<a name="l00650"></a>00650        
<a name="l00651"></a>00651        <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> elem_procid = 
<a name="l00652"></a>00652          requested_ids[current_pid][counters[current_pid]++];
<a name="l00653"></a>00653        
<a name="l00654"></a>00654        libmesh_assert (elem_procid &lt; static_cast&lt;unsigned int&gt;(<a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>));
<a name="l00655"></a>00655        elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = elem_procid;
<a name="l00656"></a>00656      }
<a name="l00657"></a>00657 }
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PARMETIS</span>
<a name="l00660"></a>00660 <span class="preprocessor"></span>
<a name="l00661"></a>00661 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
