<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_80224e50d3aebdc14135f96bcab47e92.php">partitioning</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">parmetis_partitioner.h</div>  </div>
</div>
<div class="contents">
<a href="parmetis__partitioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: parmetis_partitioner.h 3930 2010-08-24 23:04:08Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __parmetis_partitioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __parmetis_partitioner_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="partitioner_8h.php">partitioner.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00042"></a>00042 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00043"></a>00043 <span class="comment">// ParmetisPartitioner class definition</span>
<a name="l00044"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php">00044</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php">ParmetisPartitioner</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Partitioner.php">Partitioner</a>
<a name="l00045"></a>00045 {
<a name="l00046"></a>00046  <span class="keyword">public</span>:
<a name="l00047"></a>00047 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0d4a0dab938a01efc42935cd89eb2160">00051</a>   <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0d4a0dab938a01efc42935cd89eb2160">ParmetisPartitioner</a> () {}
<a name="l00052"></a>00052 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a478009b7b2f656fb8202ac7986943485">00057</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a478009b7b2f656fb8202ac7986943485">clone</a> ()<span class="keyword"> const </span>{
<a name="l00058"></a>00058     <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> cloned_partitioner
<a name="l00059"></a>00059       (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0d4a0dab938a01efc42935cd89eb2160">ParmetisPartitioner</a>());
<a name="l00060"></a>00060     <span class="keywordflow">return</span> cloned_partitioner;
<a name="l00061"></a>00061   }
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 <span class="keyword">protected</span>:
<a name="l00065"></a>00065 
<a name="l00072"></a>00072   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9da16940130531a597077f36b40c1980">_do_repartition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00073"></a>00073                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a74987eb17d4887d994d537522afc9376">_do_partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00079"></a>00079                               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="keyword">private</span>:
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="comment">// These methods &amp; data only need to be available if the</span>
<a name="l00084"></a>00084 <span class="comment">// ParMETIS library is available.</span>
<a name="l00085"></a>00085 <span class="preprocessor">#ifdef LIBMESH_HAVE_PARMETIS</span>
<a name="l00086"></a>00086 <span class="preprocessor"></span>
<a name="l00090"></a>00090   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad30c9f4513a46e0f56f9263284b79131">initialize</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>, <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sbdmns);
<a name="l00091"></a>00091   
<a name="l00095"></a>00095   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#acea02552c610550f08685883063122bc">build_graph</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00096"></a>00096 
<a name="l00100"></a>00100   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a2d687743269cc2687047b6eaaab5c864">assign_partitioning</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>);
<a name="l00101"></a>00101 
<a name="l00107"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0ac5148ba078b5a589a20bb1d908a799">00107</a>   std::vector&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0ac5148ba078b5a589a20bb1d908a799">_n_active_elem_on_proc</a>;
<a name="l00108"></a>00108   
<a name="l00112"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">00112</a>   std::map&lt;unsigned int, unsigned int&gt; <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ad255c0921d6a5bce493d34374548777d">_global_index_by_pid_map</a>;
<a name="l00113"></a>00113   
<a name="l00118"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">00118</a>   std::vector&lt;int&gt;    <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a62036524708aa17107468bfe8d35cc4a">_vtxdist</a>;
<a name="l00119"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af8bcfd8ed5708fa6357bc1dcc97526be">00119</a>   std::vector&lt;int&gt;    <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af8bcfd8ed5708fa6357bc1dcc97526be">_xadj</a>;
<a name="l00120"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">00120</a>   std::vector&lt;int&gt;    <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae65bcbc973370996e4e5d4d8d2a06743">_adjncy</a>;
<a name="l00121"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">00121</a>   std::vector&lt;int&gt;    <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a9ff71578508cbea5d8e89075eac7ede6">_part</a>;
<a name="l00122"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af974f6c3c39b04f2f2e15991d2fd6fd1">00122</a>   std::vector&lt;float&gt;  <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#af974f6c3c39b04f2f2e15991d2fd6fd1">_tpwgts</a>;
<a name="l00123"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa5e0cdda686b95f1fa34adb39fe73f4d">00123</a>   std::vector&lt;float&gt;  <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa5e0cdda686b95f1fa34adb39fe73f4d">_ubvec</a>;
<a name="l00124"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae746c3e4230e553bfcdcaf43366e5604">00124</a>   std::vector&lt;int&gt;    <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#ae746c3e4230e553bfcdcaf43366e5604">_options</a>;
<a name="l00125"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a77bf3f973b518c4e484bd19d445d0c51">00125</a>   std::vector&lt;int&gt;    <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a77bf3f973b518c4e484bd19d445d0c51">_vwgt</a>;
<a name="l00126"></a>00126 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a23cc5083f2530fa7984523f25dd814c5">00127</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a23cc5083f2530fa7984523f25dd814c5">_wgtflag</a>;
<a name="l00128"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a10b034fbe1ad212d6217cfd484b8d13b">00128</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a10b034fbe1ad212d6217cfd484b8d13b">_ncon</a>;
<a name="l00129"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa76a3c2eebfe6ec5be88617712773ba2">00129</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#aa76a3c2eebfe6ec5be88617712773ba2">_numflag</a>;
<a name="l00130"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">00130</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a8b3950cbc66d664afbabf16e0d420c49">_nparts</a>;
<a name="l00131"></a><a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0d7753360568225f28d5f60f2e5b4d59">00131</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1ParmetisPartitioner.php#a0d7753360568225f28d5f60f2e5b4d59">_edgecut</a>;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133 <span class="preprocessor">#endif</span>
<a name="l00134"></a>00134 <span class="preprocessor"></span>};
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 } <span class="comment">// namespace libMesh</span>
<a name="l00138"></a>00138 
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 <span class="preprocessor">#endif // #define __parmetis_partitioner_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
