<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_4d3110f67e028a3227e23bfd240351cc.php">partitioning</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">partitioner.C</div>  </div>
</div>
<div class="contents">
<a href="partitioner_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: partitioner.C 4382 2011-04-21 00:45:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="partitioner_8h.php">partitioner.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__communication_8h.php">mesh_communication.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00039"></a>00039 <span class="comment">// Partitioner static data</span>
<a name="l00040"></a>00040 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Partitioner.php#a96621569ac545c9ee2f87eece614a242">Partitioner::communication_blocksize</a> = 1000000;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00045"></a>00045 <span class="comment">// Partitioner implementation</span>
<a name="l00046"></a><a class="code" href="classlibMesh_1_1Partitioner.php#ac5ab060463865dc0b6fe4a614aad626f">00046</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#ac5ab060463865dc0b6fe4a614aad626f">Partitioner::partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00047"></a>00047                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   parallel_only();
<a name="l00050"></a>00050 
<a name="l00051"></a>00051   <span class="comment">// BSK - temporary fix while redistribution is integrated 6/26/2008</span>
<a name="l00052"></a>00052   <span class="comment">// Uncomment this to not repartition in parallel</span>
<a name="l00053"></a>00053 <span class="comment">//   if (!mesh.is_serial())</span>
<a name="l00054"></a>00054 <span class="comment">//     return;</span>
<a name="l00055"></a>00055 
<a name="l00056"></a>00056   <span class="comment">// we cannot partition into more pieces than we have</span>
<a name="l00057"></a>00057   <span class="comment">// active elements!</span>
<a name="l00058"></a>00058   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parts =
<a name="l00059"></a>00059     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>(), n);
<a name="l00060"></a>00060   
<a name="l00061"></a>00061   <span class="comment">// Set the number of partitions in the mesh</span>
<a name="l00062"></a>00062   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa1d4be6015417d17b41780fbcf5472a2">set_n_partitions</a>()=n_parts;
<a name="l00063"></a>00063 
<a name="l00064"></a>00064   <span class="keywordflow">if</span> (n_parts == 1)
<a name="l00065"></a>00065     {
<a name="l00066"></a>00066       this-&gt;<a class="code" href="classlibMesh_1_1Partitioner.php#abd4be60a7010f0a483e7632867aed9ef">single_partition</a> (mesh);
<a name="l00067"></a>00067       <span class="keywordflow">return</span>;
<a name="l00068"></a>00068     }
<a name="l00069"></a>00069   
<a name="l00070"></a>00070   <span class="comment">// First assign a temporary partitioning to any unpartitioned elements</span>
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1Partitioner.php#ac7aa39d5eb5cc225e5262080aac8f2c1">Partitioner::partition_unpartitioned_elements</a>(mesh, n_parts);
<a name="l00072"></a>00072   
<a name="l00073"></a>00073   <span class="comment">// Call the partitioning function</span>
<a name="l00074"></a>00074   this-&gt;<a class="code" href="classlibMesh_1_1Partitioner.php#a95ae8657d4679a5f309069bc1aacb12b">_do_partition</a>(mesh,n_parts);
<a name="l00075"></a>00075 
<a name="l00076"></a>00076   <span class="comment">// Set the parent&#39;s processor ids</span>
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1Partitioner.php#a335c032a3e387485a7210ec806681c1a">Partitioner::set_parent_processor_ids</a>(mesh);
<a name="l00078"></a>00078 
<a name="l00079"></a>00079   <span class="comment">// Set the node&#39;s processor ids</span>
<a name="l00080"></a>00080   <a class="code" href="classlibMesh_1_1Partitioner.php#accc819bc421fd8e50323b46f9762c714">Partitioner::set_node_processor_ids</a>(mesh);
<a name="l00081"></a>00081 }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1Partitioner.php#ad1bbd7766cd4b24023be7232c20e0372">00087</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#ad1bbd7766cd4b24023be7232c20e0372">Partitioner::repartition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00088"></a>00088                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n)
<a name="l00089"></a>00089 {
<a name="l00090"></a>00090   <span class="comment">// we cannot partition into more pieces than we have</span>
<a name="l00091"></a>00091   <span class="comment">// active elements!</span>
<a name="l00092"></a>00092   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_parts =
<a name="l00093"></a>00093     <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>(), n);
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   <span class="comment">// Set the number of partitions in the mesh</span>
<a name="l00096"></a>00096   mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa1d4be6015417d17b41780fbcf5472a2">set_n_partitions</a>()=n_parts;
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">if</span> (n_parts == 1)
<a name="l00099"></a>00099     {
<a name="l00100"></a>00100       this-&gt;<a class="code" href="classlibMesh_1_1Partitioner.php#abd4be60a7010f0a483e7632867aed9ef">single_partition</a> (mesh);
<a name="l00101"></a>00101       <span class="keywordflow">return</span>;
<a name="l00102"></a>00102     }
<a name="l00103"></a>00103   
<a name="l00104"></a>00104   <span class="comment">// First assign a temporary partitioning to any unpartitioned elements</span>
<a name="l00105"></a>00105   <a class="code" href="classlibMesh_1_1Partitioner.php#ac7aa39d5eb5cc225e5262080aac8f2c1">Partitioner::partition_unpartitioned_elements</a>(mesh, n_parts);
<a name="l00106"></a>00106   
<a name="l00107"></a>00107   <span class="comment">// Call the partitioning function</span>
<a name="l00108"></a>00108   this-&gt;<a class="code" href="classlibMesh_1_1Partitioner.php#a91df287a38324e9531b8aba0344ad184">_do_repartition</a>(mesh,n_parts);
<a name="l00109"></a>00109   
<a name="l00110"></a>00110   <span class="comment">// Set the parent&#39;s processor ids</span>
<a name="l00111"></a>00111   <a class="code" href="classlibMesh_1_1Partitioner.php#a335c032a3e387485a7210ec806681c1a">Partitioner::set_parent_processor_ids</a>(mesh);
<a name="l00112"></a>00112   
<a name="l00113"></a>00113   <span class="comment">// Set the node&#39;s processor ids</span>
<a name="l00114"></a>00114   <a class="code" href="classlibMesh_1_1Partitioner.php#accc819bc421fd8e50323b46f9762c714">Partitioner::set_node_processor_ids</a>(mesh);
<a name="l00115"></a>00115 }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a><a class="code" href="classlibMesh_1_1Partitioner.php#abd4be60a7010f0a483e7632867aed9ef">00121</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#abd4be60a7010f0a483e7632867aed9ef">Partitioner::single_partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123   START_LOG(<span class="stringliteral">&quot;single_partition()&quot;</span>,<span class="stringliteral">&quot;Partitioner&quot;</span>);
<a name="l00124"></a>00124   
<a name="l00125"></a>00125   <span class="comment">// Loop over all the elements and assign them to processor 0.</span>
<a name="l00126"></a>00126   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00127"></a>00127   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00130"></a>00130     (*elem_it)-&gt;processor_id() = 0;
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="comment">// For a single partition, all the nodes are on processor 0</span>
<a name="l00133"></a>00133   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00134"></a>00134   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00135"></a>00135   
<a name="l00136"></a>00136   <span class="keywordflow">for</span> ( ; node_it != node_end; ++node_it)
<a name="l00137"></a>00137     (*node_it)-&gt;processor_id() = 0;
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   STOP_LOG(<span class="stringliteral">&quot;single_partition()&quot;</span>,<span class="stringliteral">&quot;Partitioner&quot;</span>);
<a name="l00140"></a>00140 }
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 
<a name="l00144"></a><a class="code" href="classlibMesh_1_1Partitioner.php#ac7aa39d5eb5cc225e5262080aac8f2c1">00144</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#ac7aa39d5eb5cc225e5262080aac8f2c1">Partitioner::partition_unpartitioned_elements</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;<a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00145"></a>00145                                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_subdomains)
<a name="l00146"></a>00146 {
<a name="l00147"></a>00147   <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0e898a7c74ad9552269753ee54e52b45">unpartitioned_elements_begin</a>();
<a name="l00148"></a>00148   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ace9f5d288950516202e18c42a0552b0f">unpartitioned_elements_end</a>();
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_unpartitioned_elements = <a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">MeshTools::n_elem</a> (it, end);
<a name="l00151"></a>00151 
<a name="l00152"></a>00152   <span class="comment">// the unpartitioned elements must exist on all processors. If the range is empty on one</span>
<a name="l00153"></a>00153   <span class="comment">// it is empty on all, and we can quit right here.</span>
<a name="l00154"></a>00154   <span class="keywordflow">if</span> (!n_unpartitioned_elements) <span class="keywordflow">return</span>;
<a name="l00155"></a>00155          
<a name="l00156"></a>00156   <span class="comment">// find the target subdomain sizes</span>
<a name="l00157"></a>00157   std::vector&lt;unsigned int&gt; subdomain_bounds(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid&lt;<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); pid++)
<a name="l00160"></a>00160     {
<a name="l00161"></a>00161       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tgt_subdomain_size = 0;
<a name="l00162"></a>00162 
<a name="l00163"></a>00163       <span class="comment">// watch out for the case that n_subdomains &lt; n_processors</span>
<a name="l00164"></a>00164       <span class="keywordflow">if</span> (pid &lt; n_subdomains)
<a name="l00165"></a>00165         {
<a name="l00166"></a>00166           tgt_subdomain_size = n_unpartitioned_elements/n_subdomains;
<a name="l00167"></a>00167       
<a name="l00168"></a>00168           <span class="keywordflow">if</span> (pid &lt; n_unpartitioned_elements%n_subdomains)
<a name="l00169"></a>00169             tgt_subdomain_size++;
<a name="l00170"></a>00170 
<a name="l00171"></a>00171         }
<a name="l00172"></a>00172       
<a name="l00173"></a>00173       <span class="comment">//libMesh::out &lt;&lt; &quot;pid, #= &quot; &lt;&lt; pid &lt;&lt; &quot;, &quot; &lt;&lt; tgt_subdomain_size &lt;&lt; std::endl;</span>
<a name="l00174"></a>00174       <span class="keywordflow">if</span> (pid == 0)
<a name="l00175"></a>00175         subdomain_bounds[0] = tgt_subdomain_size;
<a name="l00176"></a>00176       <span class="keywordflow">else</span>
<a name="l00177"></a>00177         subdomain_bounds[pid] = subdomain_bounds[pid-1] + tgt_subdomain_size;
<a name="l00178"></a>00178     }
<a name="l00179"></a>00179   
<a name="l00180"></a>00180   libmesh_assert (subdomain_bounds.back() == n_unpartitioned_elements);  
<a name="l00181"></a>00181   
<a name="l00182"></a>00182   <span class="comment">// create the unique mapping for all unpartitioned elements independent of partitioning</span>
<a name="l00183"></a>00183   <span class="comment">// determine the global indexing for all the unpartitoned elements</span>
<a name="l00184"></a>00184   std::vector&lt;unsigned int&gt; global_indices;
<a name="l00185"></a>00185     
<a name="l00186"></a>00186   <span class="comment">// Calling this on all processors a unique range in [0,n_unpartitioned_elements) is constructed.  </span>
<a name="l00187"></a>00187   <span class="comment">// Only the indices for the elements we pass in are returned in the array.</span>
<a name="l00188"></a>00188   <a class="code" href="classlibMesh_1_1MeshCommunication.php">MeshCommunication</a>().<a class="code" href="classlibMesh_1_1MeshCommunication.php#aa796c4e551a56a3e15603a2ffa7c6aaf">find_global_indices</a> (<a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">MeshTools::bounding_box</a>(mesh), it, end, 
<a name="l00189"></a>00189                                            global_indices);
<a name="l00190"></a>00190   
<a name="l00191"></a>00191   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> cnt=0; it != end; ++it)
<a name="l00192"></a>00192     {
<a name="l00193"></a>00193       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *elem = *it;
<a name="l00194"></a>00194       
<a name="l00195"></a>00195       libmesh_assert (cnt &lt; global_indices.size());
<a name="l00196"></a>00196       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> global_index =
<a name="l00197"></a>00197         global_indices[cnt++];
<a name="l00198"></a>00198       
<a name="l00199"></a>00199       libmesh_assert (global_index &lt; subdomain_bounds.back());
<a name="l00200"></a>00200       libmesh_assert (global_index &lt; n_unpartitioned_elements);
<a name="l00201"></a>00201 
<a name="l00202"></a>00202       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> subdomain_id =
<a name="l00203"></a>00203         std::distance(subdomain_bounds.begin(),
<a name="l00204"></a>00204                       std::upper_bound(subdomain_bounds.begin(),
<a name="l00205"></a>00205                                        subdomain_bounds.end(),
<a name="l00206"></a>00206                                        global_index));
<a name="l00207"></a>00207       libmesh_assert (subdomain_id &lt; n_subdomains);
<a name="l00208"></a>00208      
<a name="l00209"></a>00209       elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = subdomain_id;              
<a name="l00210"></a>00210       <span class="comment">//libMesh::out &lt;&lt; &quot;assigning &quot; &lt;&lt; global_index &lt;&lt; &quot; to &quot; &lt;&lt; subdomain_id &lt;&lt; std::endl;          </span>
<a name="l00211"></a>00211     }
<a name="l00212"></a>00212 }
<a name="l00213"></a>00213 
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a><a class="code" href="classlibMesh_1_1Partitioner.php#a335c032a3e387485a7210ec806681c1a">00216</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#a335c032a3e387485a7210ec806681c1a">Partitioner::set_parent_processor_ids</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00217"></a>00217 {
<a name="l00218"></a>00218   START_LOG(<span class="stringliteral">&quot;set_parent_processor_ids()&quot;</span>,<span class="stringliteral">&quot;Partitioner&quot;</span>);
<a name="l00219"></a>00219   
<a name="l00220"></a>00220   <span class="comment">// If the mesh is serial we have access to all the elements,</span>
<a name="l00221"></a>00221   <span class="comment">// in particular all the active ones.  We can therefore set</span>
<a name="l00222"></a>00222   <span class="comment">// the parent processor ids indirecly through their children.</span>
<a name="l00223"></a>00223   <span class="comment">// By convention a parent is assigned to the minimum processor</span>
<a name="l00224"></a>00224   <span class="comment">// of all its children.</span>
<a name="l00225"></a>00225   <span class="keywordflow">if</span> (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3c7d22fed3feea4c9ebd1fb41e7dbb4f">is_serial</a>())
<a name="l00226"></a>00226     {
<a name="l00227"></a>00227       <span class="comment">// Loop over all the active elements in the mesh  </span>
<a name="l00228"></a>00228       <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00229"></a>00229       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>();
<a name="l00230"></a>00230       
<a name="l00231"></a>00231       <span class="keywordflow">for</span> ( ; it!=end; ++it)
<a name="l00232"></a>00232         {
<a name="l00233"></a>00233 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00234"></a>00234 <span class="preprocessor"></span>          <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *child  = *it;
<a name="l00235"></a>00235           <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *parent = child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00236"></a>00236 
<a name="l00237"></a>00237           <span class="keywordflow">while</span> (parent)
<a name="l00238"></a>00238             {
<a name="l00239"></a>00239               <span class="comment">// invalidate the parent id, otherwise the min below</span>
<a name="l00240"></a>00240               <span class="comment">// will not work if the current parent id is less</span>
<a name="l00241"></a>00241               <span class="comment">// than all the children!</span>
<a name="l00242"></a>00242               parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a080a5295fc4a41c1ab776a1a38c4be8d">invalidate_processor_id</a>();
<a name="l00243"></a>00243               
<a name="l00244"></a>00244               <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00245"></a>00245                 {
<a name="l00246"></a>00246                   child = parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c);
<a name="l00247"></a>00247                   libmesh_assert(child);
<a name="l00248"></a>00248                   libmesh_assert(!child-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a72a89396d5712c7541be0788d159403c">is_remote</a>());
<a name="l00249"></a>00249                   libmesh_assert(child-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00250"></a>00250                   parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>(),
<a name="l00251"></a>00251                                                     child-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>());
<a name="l00252"></a>00252                 }             
<a name="l00253"></a>00253               parent = parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a7cdd994bb4245128f8617b62d7968e35">parent</a>();
<a name="l00254"></a>00254             }
<a name="l00255"></a>00255 <span class="preprocessor">#else</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>          libmesh_assert ((*it)-&gt;level() == 0);
<a name="l00257"></a>00257 <span class="preprocessor">#endif</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span>          
<a name="l00259"></a>00259         }
<a name="l00260"></a>00260     }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262   <span class="comment">// When the mesh is parallel we cannot guarantee that parents have access to</span>
<a name="l00263"></a>00263   <span class="comment">// all their children.</span>
<a name="l00264"></a>00264   <span class="keywordflow">else</span>
<a name="l00265"></a>00265     {
<a name="l00266"></a>00266       <span class="comment">// We will use a brute-force approach here.  Each processor finds its parent</span>
<a name="l00267"></a>00267       <span class="comment">// elements and sets the parent pid to the minimum of its local children.</span>
<a name="l00268"></a>00268       <span class="comment">// A global reduction is then performed to make sure the true minimum is found.</span>
<a name="l00269"></a>00269       <span class="comment">// As noted, this is required because we cannot guarantee that a parent has</span>
<a name="l00270"></a>00270       <span class="comment">// access to all its children on any single processor.</span>
<a name="l00271"></a>00271       parallel_only();
<a name="l00272"></a>00272       libmesh_assert(<a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">MeshTools::n_elem</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0e898a7c74ad9552269753ee54e52b45">unpartitioned_elements_begin</a>(),
<a name="l00273"></a>00273                                mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ace9f5d288950516202e18c42a0552b0f">unpartitioned_elements_end</a>()) == 0);
<a name="l00274"></a>00274 
<a name="l00275"></a>00275       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_elem_id = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>();
<a name="l00276"></a>00276 
<a name="l00277"></a>00277       std::vector&lt;unsigned short int&gt;
<a name="l00278"></a>00278         parent_processor_ids (<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(<a class="code" href="classlibMesh_1_1Partitioner.php#a96621569ac545c9ee2f87eece614a242">communication_blocksize</a>,
<a name="l00279"></a>00279                                        max_elem_id));
<a name="l00280"></a>00280       
<a name="l00281"></a>00281       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> blk=0, last_elem_id=0; last_elem_id&lt;max_elem_id; blk++)
<a name="l00282"></a>00282         {
<a name="l00283"></a>00283                               last_elem_id = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>((blk+1)*<a class="code" href="classlibMesh_1_1Partitioner.php#a96621569ac545c9ee2f87eece614a242">communication_blocksize</a>, max_elem_id);
<a name="l00284"></a>00284           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_elem_id = blk*<a class="code" href="classlibMesh_1_1Partitioner.php#a96621569ac545c9ee2f87eece614a242">communication_blocksize</a>;
<a name="l00285"></a>00285 
<a name="l00286"></a>00286           std::fill (parent_processor_ids.begin(),
<a name="l00287"></a>00287                      parent_processor_ids.end(),
<a name="l00288"></a>00288                      <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00289"></a>00289 
<a name="l00290"></a>00290           <span class="comment">// first build up local contributions to parent_processor_ids</span>
<a name="l00291"></a>00291           <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       not_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a49e8bef33dabe0c21c7e81d61e055154">ancestor_elements_begin</a>();
<a name="l00292"></a>00292           <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> not_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a993d03afe0646ec1e9a192808ad2ebd9">ancestor_elements_end</a>(); 
<a name="l00293"></a>00293 
<a name="l00294"></a>00294           <span class="keywordtype">bool</span> have_parent_in_block = <span class="keyword">false</span>;
<a name="l00295"></a>00295           
<a name="l00296"></a>00296           <span class="keywordflow">for</span> ( ; not_it != not_end; ++not_it)
<a name="l00297"></a>00297             {
<a name="l00298"></a>00298 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00299"></a>00299 <span class="preprocessor"></span>              <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *parent = *not_it;
<a name="l00300"></a>00300 
<a name="l00301"></a>00301               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_idx = parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00302"></a>00302               libmesh_assert (parent_idx &lt; max_elem_id);
<a name="l00303"></a>00303 
<a name="l00304"></a>00304               <span class="keywordflow">if</span> ((parent_idx &gt;= first_elem_id) &amp;&amp;
<a name="l00305"></a>00305                   (parent_idx &lt;  last_elem_id))
<a name="l00306"></a>00306                 {
<a name="l00307"></a>00307                   have_parent_in_block = <span class="keyword">true</span>;
<a name="l00308"></a>00308                   <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> parent_pid = <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>;
<a name="l00309"></a>00309 
<a name="l00310"></a>00310                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0; c&lt;parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac9df9e0213d3ea1d2d8279892f6f1094">n_children</a>(); c++)
<a name="l00311"></a>00311                     parent_pid = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a> (parent_pid, parent-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3966a92c6f8b6748755a94f9f3103c5a">child</a>(c)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>());
<a name="l00312"></a>00312                   
<a name="l00313"></a>00313                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> packed_idx = parent_idx - first_elem_id;
<a name="l00314"></a>00314                   libmesh_assert (packed_idx &lt; parent_processor_ids.size());
<a name="l00315"></a>00315 
<a name="l00316"></a>00316                   parent_processor_ids[packed_idx] = parent_pid;
<a name="l00317"></a>00317                 }
<a name="l00318"></a>00318 <span class="preprocessor">#else</span>
<a name="l00319"></a>00319 <span class="preprocessor"></span>              <span class="comment">// without AMR there should be no inactive elements</span>
<a name="l00320"></a>00320               libmesh_error();
<a name="l00321"></a>00321 <span class="preprocessor">#endif</span>
<a name="l00322"></a>00322 <span class="preprocessor"></span>            }
<a name="l00323"></a>00323 
<a name="l00324"></a>00324           <span class="comment">// then find the global minimum</span>
<a name="l00325"></a>00325           <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">Parallel::min</a> (parent_processor_ids);
<a name="l00326"></a>00326 
<a name="l00327"></a>00327           <span class="comment">// and assign the ids, if we have a parent in this block.</span>
<a name="l00328"></a>00328           <span class="keywordflow">if</span> (have_parent_in_block)
<a name="l00329"></a>00329             <span class="keywordflow">for</span> (not_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a49e8bef33dabe0c21c7e81d61e055154">ancestor_elements_begin</a>();
<a name="l00330"></a>00330                  not_it != not_end; ++not_it)
<a name="l00331"></a>00331               {
<a name="l00332"></a>00332                 <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *parent = *not_it;
<a name="l00333"></a>00333                 
<a name="l00334"></a>00334                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> parent_idx = parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00335"></a>00335                 
<a name="l00336"></a>00336                 <span class="keywordflow">if</span> ((parent_idx &gt;= first_elem_id) &amp;&amp;
<a name="l00337"></a>00337                     (parent_idx &lt;  last_elem_id))
<a name="l00338"></a>00338                   {
<a name="l00339"></a>00339                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> packed_idx = parent_idx - first_elem_id;
<a name="l00340"></a>00340                     libmesh_assert (packed_idx &lt; parent_processor_ids.size());
<a name="l00341"></a>00341                     
<a name="l00342"></a>00342                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">short</span> <span class="keywordtype">int</span> parent_pid =
<a name="l00343"></a>00343                       parent_processor_ids[packed_idx];
<a name="l00344"></a>00344                     
<a name="l00345"></a>00345                     libmesh_assert (parent_pid != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00346"></a>00346                     
<a name="l00347"></a>00347                     parent-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = parent_pid;
<a name="l00348"></a>00348                   }
<a name="l00349"></a>00349               }
<a name="l00350"></a>00350         }
<a name="l00351"></a>00351     }
<a name="l00352"></a>00352   
<a name="l00353"></a>00353   STOP_LOG(<span class="stringliteral">&quot;set_parent_processor_ids()&quot;</span>,<span class="stringliteral">&quot;Partitioner&quot;</span>);
<a name="l00354"></a>00354 }
<a name="l00355"></a>00355 
<a name="l00356"></a>00356 
<a name="l00357"></a>00357 
<a name="l00358"></a><a class="code" href="classlibMesh_1_1Partitioner.php#accc819bc421fd8e50323b46f9762c714">00358</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#accc819bc421fd8e50323b46f9762c714">Partitioner::set_node_processor_ids</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>)
<a name="l00359"></a>00359 {
<a name="l00360"></a>00360   START_LOG(<span class="stringliteral">&quot;set_node_processor_ids()&quot;</span>,<span class="stringliteral">&quot;Partitioner&quot;</span>);
<a name="l00361"></a>00361 
<a name="l00362"></a>00362   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00363"></a>00363   parallel_only();
<a name="l00364"></a>00364 
<a name="l00365"></a>00365   <span class="comment">// If we have any unpartitioned elements at this </span>
<a name="l00366"></a>00366   <span class="comment">// stage there is a problem</span>
<a name="l00367"></a>00367   libmesh_assert (<a class="code" href="namespacelibMesh_1_1MeshTools.php#a684d42e38fa56e4dda1c7c331ec75126">MeshTools::n_elem</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a0e898a7c74ad9552269753ee54e52b45">unpartitioned_elements_begin</a>(),
<a name="l00368"></a>00368                             mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ace9f5d288950516202e18c42a0552b0f">unpartitioned_elements_end</a>()) == 0);
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="comment">//   const unsigned int orig_n_local_nodes = mesh.n_local_nodes();</span>
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 <span class="comment">//   libMesh::err &lt;&lt; &quot;[&quot; &lt;&lt; libMesh::processor_id() &lt;&lt; &quot;]: orig_n_local_nodes=&quot;</span>
<a name="l00374"></a>00374 <span class="comment">//          &lt;&lt; orig_n_local_nodes &lt;&lt; std::endl;</span>
<a name="l00375"></a>00375 
<a name="l00376"></a>00376   <span class="comment">// Build up request sets.  Each node is currently owned by a processor because</span>
<a name="l00377"></a>00377   <span class="comment">// it is connected to an element owned by that processor.  However, during the</span>
<a name="l00378"></a>00378   <span class="comment">// repartitioning phase that element may have been assigned a new processor id, but</span>
<a name="l00379"></a>00379   <span class="comment">// it is still resident on the original processor.  We need to know where to look</span>
<a name="l00380"></a>00380   <span class="comment">// for new ids before assigning new ids, otherwise we may be asking the wrong processors</span>
<a name="l00381"></a>00381   <span class="comment">// for the wrong information.</span>
<a name="l00382"></a>00382   <span class="comment">//</span>
<a name="l00383"></a>00383   <span class="comment">// The only remaining issue is what to do with unpartitioned nodes.  Since they are required</span>
<a name="l00384"></a>00384   <span class="comment">// to live on all processors we can simply rely on ourselves to number them properly.</span>
<a name="l00385"></a>00385   std::vector&lt;std::vector&lt;unsigned int&gt; &gt;
<a name="l00386"></a>00386     requested_node_ids(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00387"></a>00387 
<a name="l00388"></a>00388   <span class="comment">// Loop over all the nodes, count the ones on each processor.  We can skip ourself</span>
<a name="l00389"></a>00389   std::vector&lt;unsigned int&gt; ghost_nodes_from_proc(<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(), 0);
<a name="l00390"></a>00390 
<a name="l00391"></a>00391   <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a>       node_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>();
<a name="l00392"></a>00392   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1node__iterator.php">MeshBase::node_iterator</a> node_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a47575077b6ad40d4f05292634f7615f8">nodes_end</a>();
<a name="l00393"></a>00393   
<a name="l00394"></a>00394   <span class="keywordflow">for</span> (; node_it != node_end; ++node_it)
<a name="l00395"></a>00395     {
<a name="l00396"></a>00396       <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = *node_it;
<a name="l00397"></a>00397       libmesh_assert(node);
<a name="l00398"></a>00398       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_pid = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00399"></a>00399       <span class="keywordflow">if</span> (current_pid != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l00400"></a>00400           current_pid != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00401"></a>00401         {
<a name="l00402"></a>00402           libmesh_assert(current_pid &lt; ghost_nodes_from_proc.size());
<a name="l00403"></a>00403           ghost_nodes_from_proc[current_pid]++;
<a name="l00404"></a>00404         }
<a name="l00405"></a>00405     }
<a name="l00406"></a>00406 
<a name="l00407"></a>00407   <span class="comment">// We know how many objects live on each processor, so reserve()</span>
<a name="l00408"></a>00408   <span class="comment">// space for each.</span>
<a name="l00409"></a>00409   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0; pid != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++pid)
<a name="l00410"></a>00410     requested_node_ids[pid].reserve(ghost_nodes_from_proc[pid]);
<a name="l00411"></a>00411 
<a name="l00412"></a>00412   <span class="comment">// We need to get the new pid for each node from the processor</span>
<a name="l00413"></a>00413   <span class="comment">// which *currently* owns the node.  We can safely skip ourself</span>
<a name="l00414"></a>00414   <span class="keywordflow">for</span> (node_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>(); node_it != node_end; ++node_it)
<a name="l00415"></a>00415     {
<a name="l00416"></a>00416       <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = *node_it;
<a name="l00417"></a>00417       libmesh_assert(node);
<a name="l00418"></a>00418       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> current_pid = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();      
<a name="l00419"></a>00419       <span class="keywordflow">if</span> (current_pid != <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() &amp;&amp;
<a name="l00420"></a>00420           current_pid != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00421"></a>00421         {
<a name="l00422"></a>00422           libmesh_assert(current_pid &lt; requested_node_ids.size());
<a name="l00423"></a>00423           libmesh_assert(requested_node_ids[current_pid].size() &lt;
<a name="l00424"></a>00424                  ghost_nodes_from_proc[current_pid]);
<a name="l00425"></a>00425           requested_node_ids[current_pid].push_back(node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>());
<a name="l00426"></a>00426         }
<a name="l00427"></a>00427       
<a name="l00428"></a>00428       <span class="comment">// Unset any previously-set node processor ids</span>
<a name="l00429"></a>00429       node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a080a5295fc4a41c1ab776a1a38c4be8d">invalidate_processor_id</a>();
<a name="l00430"></a>00430     }
<a name="l00431"></a>00431   
<a name="l00432"></a>00432   <span class="comment">// Loop over all the active elements</span>
<a name="l00433"></a>00433   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       elem_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00434"></a>00434   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> elem_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00435"></a>00435   
<a name="l00436"></a>00436   <span class="keywordflow">for</span> ( ; elem_it != elem_end; ++elem_it)
<a name="l00437"></a>00437     {
<a name="l00438"></a>00438       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00439"></a>00439       libmesh_assert(elem);
<a name="l00440"></a>00440 
<a name="l00441"></a>00441       libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00442"></a>00442       
<a name="l00443"></a>00443       <span class="comment">// For each node, set the processor ID to the min of</span>
<a name="l00444"></a>00444       <span class="comment">// its current value and this Element&#39;s processor id.</span>
<a name="l00445"></a>00445       <span class="comment">// </span>
<a name="l00446"></a>00446       <span class="comment">// TODO: we would probably get better parallel partitioning if</span>
<a name="l00447"></a>00447       <span class="comment">// we did something like &quot;min for even numbered nodes, max for</span>
<a name="l00448"></a>00448       <span class="comment">// odd numbered&quot;.  We&#39;d need to be careful about how that would</span>
<a name="l00449"></a>00449       <span class="comment">// affect solution ordering for I/O, though.</span>
<a name="l00450"></a>00450       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00451"></a>00451         elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">std::min</a>(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>(),
<a name="l00452"></a>00452                                                      elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>());
<a name="l00453"></a>00453     }
<a name="l00454"></a>00454 
<a name="l00455"></a>00455   <span class="comment">// And loop over the subactive elements, but don&#39;t reassign</span>
<a name="l00456"></a>00456   <span class="comment">// nodes that are already active on another processor.</span>
<a name="l00457"></a>00457   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       sub_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a63a55a9825ce771cc23e4e9921ad7920">subactive_elements_begin</a>();
<a name="l00458"></a>00458   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> sub_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#aa3a828a11df05d9969641f11483c551f">subactive_elements_end</a>(); 
<a name="l00459"></a>00459   
<a name="l00460"></a>00460   <span class="keywordflow">for</span> ( ; sub_it != sub_end; ++sub_it)
<a name="l00461"></a>00461     {
<a name="l00462"></a>00462       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *sub_it;
<a name="l00463"></a>00463       libmesh_assert(elem);
<a name="l00464"></a>00464 
<a name="l00465"></a>00465       libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00466"></a>00466       
<a name="l00467"></a>00467       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00468"></a>00468         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00469"></a>00469           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00470"></a>00470     }
<a name="l00471"></a>00471 
<a name="l00472"></a>00472   <span class="comment">// Same for the inactive elements -- we will have already gotten most of these</span>
<a name="l00473"></a>00473   <span class="comment">// nodes, *except* for the case of a parent with a subset of children which are</span>
<a name="l00474"></a>00474   <span class="comment">// ghost elements.  In that case some of the parent nodes will not have been</span>
<a name="l00475"></a>00475   <span class="comment">// properly handled yet</span>
<a name="l00476"></a>00476   <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       not_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae05c8be2e993dcd6365de35260acf0aa">not_active_elements_begin</a>();
<a name="l00477"></a>00477   <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> not_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1f0d4f282a9a83b869c826600b80777d">not_active_elements_end</a>(); 
<a name="l00478"></a>00478   
<a name="l00479"></a>00479   <span class="keywordflow">for</span> ( ; not_it != not_end; ++not_it)
<a name="l00480"></a>00480     {
<a name="l00481"></a>00481       <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *not_it;
<a name="l00482"></a>00482       libmesh_assert(elem);
<a name="l00483"></a>00483 
<a name="l00484"></a>00484       libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00485"></a>00485       
<a name="l00486"></a>00486       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00487"></a>00487         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>)
<a name="l00488"></a>00488           elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n)-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() = elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00489"></a>00489     }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00492"></a>00492 <span class="preprocessor"></span>  {
<a name="l00493"></a>00493     <span class="comment">// make sure all the nodes connected to any element have received a</span>
<a name="l00494"></a>00494     <span class="comment">// valid processor id</span>
<a name="l00495"></a>00495     std::set&lt;const Node*&gt; used_nodes;
<a name="l00496"></a>00496     <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a>       all_it  = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac266e1f5eb6ac9566ccbd7e6add6c239">elements_begin</a>();
<a name="l00497"></a>00497     <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1element__iterator.php">MeshBase::element_iterator</a> all_end = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ae94f1bce0dc50c489c6bae9ba64d06e8">elements_end</a>(); 
<a name="l00498"></a>00498   
<a name="l00499"></a>00499     <span class="keywordflow">for</span> ( ; all_it != all_end; ++all_it)
<a name="l00500"></a>00500       {
<a name="l00501"></a>00501         <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *all_it;
<a name="l00502"></a>00502         libmesh_assert(elem);
<a name="l00503"></a>00503         libmesh_assert(elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00504"></a>00504         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=0; n&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a3a1e00b1906b0f6cf0cc1760c9a7da1f">n_nodes</a>(); ++n)
<a name="l00505"></a>00505           used_nodes.insert(elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ac190df363bef9fc5eed46b8d86b756d6">get_node</a>(n));
<a name="l00506"></a>00506       }
<a name="l00507"></a>00507 
<a name="l00508"></a>00508     <span class="keywordflow">for</span> (node_it = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a3ab1d28a6ea1e8028ce0c06e11cfb68d">nodes_begin</a>(); node_it != node_end; ++node_it)
<a name="l00509"></a>00509       {
<a name="l00510"></a>00510         <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = *node_it;
<a name="l00511"></a>00511         libmesh_assert(node);
<a name="l00512"></a>00512         libmesh_assert(used_nodes.count(node));
<a name="l00513"></a>00513         libmesh_assert(node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00514"></a>00514       }
<a name="l00515"></a>00515   }
<a name="l00516"></a>00516 <span class="preprocessor">#endif</span>
<a name="l00517"></a>00517 <span class="preprocessor"></span>
<a name="l00518"></a>00518   <span class="comment">// Next set node ids from other processors, excluding self</span>
<a name="l00519"></a>00519   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p=1; p != <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>(); ++p)
<a name="l00520"></a>00520     {
<a name="l00521"></a>00521       <span class="comment">// Trade my requests with processor procup and procdown</span>
<a name="l00522"></a>00522       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procup = (<a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() + p) %
<a name="l00523"></a>00523                              <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00524"></a>00524       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> procdown = (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() +
<a name="l00525"></a>00525                                <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>() - p) %
<a name="l00526"></a>00526                                <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00527"></a>00527       std::vector&lt;unsigned int&gt; request_to_fill;
<a name="l00528"></a>00528       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procup, requested_node_ids[procup],
<a name="l00529"></a>00529                              procdown, request_to_fill);
<a name="l00530"></a>00530 
<a name="l00531"></a>00531       <span class="comment">// Fill those requests in-place</span>
<a name="l00532"></a>00532       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != request_to_fill.size(); ++i)
<a name="l00533"></a>00533         {
<a name="l00534"></a>00534           <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(request_to_fill[i]);
<a name="l00535"></a>00535           libmesh_assert(node);
<a name="l00536"></a>00536           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> new_pid = node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>();
<a name="l00537"></a>00537           libmesh_assert (new_pid != <a class="code" href="classlibMesh_1_1DofObject.php#a46e3889aa741da5ebf483fe91fd1d431">DofObject::invalid_processor_id</a>);
<a name="l00538"></a>00538           libmesh_assert (new_pid &lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a716b4df3429a6b2a1d5386691dabe2ae">n_partitions</a>()); <span class="comment">// this is the correct test --</span>
<a name="l00539"></a>00539           request_to_fill[i] = new_pid;           <span class="comment">//  the number of partitions may</span>
<a name="l00540"></a>00540         }                                         <span class="comment">//  not equal the number of processors</span>
<a name="l00541"></a>00541 
<a name="l00542"></a>00542       <span class="comment">// Trade back the results</span>
<a name="l00543"></a>00543       std::vector&lt;unsigned int&gt; filled_request;
<a name="l00544"></a>00544       <a class="code" href="namespacelibMesh_1_1Parallel.php#acfbfff4a15f9dc0b0abdfb081086dd3b">Parallel::send_receive</a>(procdown, request_to_fill,
<a name="l00545"></a>00545                              procup,   filled_request);
<a name="l00546"></a>00546       libmesh_assert(filled_request.size() == requested_node_ids[procup].size());
<a name="l00547"></a>00547       
<a name="l00548"></a>00548       <span class="comment">// And copy the id changes we&#39;ve now been informed of</span>
<a name="l00549"></a>00549       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != filled_request.size(); ++i)
<a name="l00550"></a>00550         {
<a name="l00551"></a>00551           <a class="code" href="classlibMesh_1_1Node.php">Node</a> *node = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#ac0520df5e7a87ed1bd98919f911b1f95">node_ptr</a>(requested_node_ids[procup][i]);
<a name="l00552"></a>00552           libmesh_assert(node);
<a name="l00553"></a>00553           libmesh_assert(filled_request[i] &lt; mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a716b4df3429a6b2a1d5386691dabe2ae">n_partitions</a>()); <span class="comment">// this is the correct test --</span>
<a name="l00554"></a>00554           node-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>(filled_request[i]);           <span class="comment">//  the number of partitions may</span>
<a name="l00555"></a>00555         }                                                  <span class="comment">//  not equal the number of processors</span>
<a name="l00556"></a>00556     }
<a name="l00557"></a>00557   
<a name="l00558"></a>00558   STOP_LOG(<span class="stringliteral">&quot;set_node_processor_ids()&quot;</span>,<span class="stringliteral">&quot;Partitioner&quot;</span>);
<a name="l00559"></a>00559 }
<a name="l00560"></a>00560 
<a name="l00561"></a>00561 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
