<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_80224e50d3aebdc14135f96bcab47e92.php">partitioning</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">partitioner.h</div>  </div>
</div>
<div class="contents">
<a href="partitioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: partitioner.h 4175 2011-01-20 15:17:57Z permcody $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __partitioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __partitioner_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>MeshBase;
<a name="l00036"></a>00036 <span class="keyword">class </span>ErrorVector;
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00046"></a>00046 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00047"></a>00047 <span class="comment">// Partitioner class definition</span>
<a name="l00048"></a><a class="code" href="classlibMesh_1_1Partitioner.php">00048</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Partitioner.php">Partitioner</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050  <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00055"></a><a class="code" href="classlibMesh_1_1Partitioner.php#a9dc0ce0193c0702fa7e4226a94404acd">00055</a>   <a class="code" href="classlibMesh_1_1Partitioner.php#a9dc0ce0193c0702fa7e4226a94404acd">Partitioner</a> ():<a class="code" href="classlibMesh_1_1Partitioner.php#a1701ba592caafda75ba383d04bf1a47e">_weights</a>(NULL) {}
<a name="l00056"></a>00056   
<a name="l00060"></a><a class="code" href="classlibMesh_1_1Partitioner.php#a5b31fd933573cc12d97aef522cf675e7">00060</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Partitioner.php#a5b31fd933573cc12d97aef522cf675e7">~Partitioner</a>() {}
<a name="l00061"></a>00061 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;Partitioner&gt;</a> <a class="code" href="classlibMesh_1_1Partitioner.php#a898e3c3cae72c2e8c5282338406a540c">clone</a> () <span class="keyword">const</span> = 0;
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00081"></a>00081   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#ac5ab060463865dc0b6fe4a614aad626f">partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00082"></a>00082                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00083"></a>00083 
<a name="l00090"></a>00090   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#ad1bbd7766cd4b24023be7232c20e0372">repartition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00091"></a>00091                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#ac7aa39d5eb5cc225e5262080aac8f2c1">partition_unpartitioned_elements</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a> &amp;mesh, 
<a name="l00097"></a>00097                                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>());
<a name="l00098"></a>00098 
<a name="l00104"></a>00104   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#a335c032a3e387485a7210ec806681c1a">set_parent_processor_ids</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00105"></a>00105 
<a name="l00111"></a>00111   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#accc819bc421fd8e50323b46f9762c714">set_node_processor_ids</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00112"></a>00112 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1Partitioner.php#adbbd55dc00016fd45c2575595ce23285">00118</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#adbbd55dc00016fd45c2575595ce23285">attach_weights</a>(<a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> * <span class="comment">/*weights*/</span>) { libmesh_not_implemented(); }
<a name="l00119"></a>00119   
<a name="l00120"></a>00120 <span class="keyword">protected</span>:
<a name="l00121"></a>00121 
<a name="l00128"></a>00128   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#abd4be60a7010f0a483e7632867aed9ef">single_partition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh);
<a name="l00129"></a>00129 
<a name="l00135"></a>00135   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#a95ae8657d4679a5f309069bc1aacb12b">_do_partition</a>(<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00136"></a>00136                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) = 0;
<a name="l00137"></a>00137 
<a name="l00143"></a><a class="code" href="classlibMesh_1_1Partitioner.php#a91df287a38324e9531b8aba0344ad184">00143</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Partitioner.php#a91df287a38324e9531b8aba0344ad184">_do_repartition</a> (<a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00144"></a>00144                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n) { this-&gt;<a class="code" href="classlibMesh_1_1Partitioner.php#a95ae8657d4679a5f309069bc1aacb12b">_do_partition</a> (mesh, n); }
<a name="l00145"></a>00145 
<a name="l00150"></a><a class="code" href="classlibMesh_1_1Partitioner.php#a96621569ac545c9ee2f87eece614a242">00150</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1Partitioner.php#a96621569ac545c9ee2f87eece614a242">communication_blocksize</a>;
<a name="l00151"></a>00151 
<a name="l00155"></a><a class="code" href="classlibMesh_1_1Partitioner.php#a1701ba592caafda75ba383d04bf1a47e">00155</a>   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> * <a class="code" href="classlibMesh_1_1Partitioner.php#a1701ba592caafda75ba383d04bf1a47e">_weights</a>;
<a name="l00156"></a>00156 };
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 } <span class="comment">// namespace libMesh</span>
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
