<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5052f12e05b451ef48f4724bcfd75ea2.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">patch.C</div>  </div>
</div>
<div class="contents">
<a href="patch_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: patch.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;cmath&gt;</span>     <span class="comment">// for std::sqrt std::pow std::abs</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="patch_8h.php">patch.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="keyword">namespace </span>libMesh
<a name="l00033"></a>00033 {
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// Patch implementations</span>
<a name="l00039"></a><a class="code" href="classlibMesh_1_1Patch.php#a45fb72b1f70f52bb361e3c0f1a3cee06">00039</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a45fb72b1f70f52bb361e3c0f1a3cee06">Patch::find_face_neighbors</a>(std::set&lt;const Elem *&gt; &amp;new_neighbors)
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <span class="comment">// Loop over all the elements in the patch</span>
<a name="l00042"></a>00042   std::set&lt;const Elem*&gt;::const_iterator       it  = this-&gt;begin();
<a name="l00043"></a>00043   <span class="keyword">const</span> std::set&lt;const Elem*&gt;::const_iterator end = this-&gt;end();
<a name="l00044"></a>00044 
<a name="l00045"></a>00045   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00046"></a>00046     {
<a name="l00047"></a>00047       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00048"></a>00048       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> s=0; s&lt;elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ae376bfa6ac14723330e07a97992b56c9">n_sides</a>(); s++)
<a name="l00049"></a>00049         <span class="keywordflow">if</span> (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s) != NULL)        <span class="comment">// we have a neighbor on this side</span>
<a name="l00050"></a>00050           {
<a name="l00051"></a>00051             <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a06576c749e62f4a5962e112e5441c31b">neighbor</a>(s);
<a name="l00052"></a>00052         
<a name="l00053"></a>00053 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00054"></a>00054 <span class="preprocessor"></span>            <span class="keywordflow">if</span> (!neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>())          <span class="comment">// the neighbor is *not* active,</span>
<a name="l00055"></a>00055               {                               <span class="comment">// so add *all* neighboring</span>
<a name="l00056"></a>00056                                               <span class="comment">// active children to the patch</span>
<a name="l00057"></a>00057                 std::vector&lt;const Elem*&gt; active_neighbor_children;
<a name="l00058"></a>00058 
<a name="l00059"></a>00059                 neighbor-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a93229ab6804e5876a99368817120d9c3">active_family_tree_by_neighbor</a>
<a name="l00060"></a>00060                   (active_neighbor_children, elem);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062                 std::vector&lt;const Elem*&gt;::const_iterator
<a name="l00063"></a>00063                   child_it  = active_neighbor_children.begin();
<a name="l00064"></a>00064                 <span class="keyword">const</span> std::vector&lt;const Elem*&gt;::const_iterator
<a name="l00065"></a>00065                   child_end = active_neighbor_children.end();
<a name="l00066"></a>00066                 <span class="keywordflow">for</span> (; child_it != child_end; ++child_it)
<a name="l00067"></a>00067                   new_neighbors.insert(*child_it);
<a name="l00068"></a>00068               }
<a name="l00069"></a>00069             <span class="keywordflow">else</span>
<a name="l00070"></a>00070 <span class="preprocessor">#endif // #ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00071"></a>00071 <span class="preprocessor"></span>              new_neighbors.insert (neighbor); <span class="comment">// add active neighbors</span>
<a name="l00072"></a>00072           }
<a name="l00073"></a>00073     }
<a name="l00074"></a>00074 }
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1Patch.php#aa571745668280fdba35de80031aacf9c">00078</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#aa571745668280fdba35de80031aacf9c">Patch::add_face_neighbors</a>()
<a name="l00079"></a>00079 {
<a name="l00080"></a>00080   std::set&lt;const Elem *&gt; new_neighbors;
<a name="l00081"></a>00081 
<a name="l00082"></a>00082   this-&gt;<a class="code" href="classlibMesh_1_1Patch.php#a45fb72b1f70f52bb361e3c0f1a3cee06">find_face_neighbors</a>(new_neighbors);
<a name="l00083"></a>00083     
<a name="l00084"></a>00084   this-&gt;insert(new_neighbors.begin(), new_neighbors.end());
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a><a class="code" href="classlibMesh_1_1Patch.php#a5a0fcd13cfe4dff3036af054cb548500">00089</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a5a0fcd13cfe4dff3036af054cb548500">Patch::add_local_face_neighbors</a>()
<a name="l00090"></a>00090 {
<a name="l00091"></a>00091   std::set&lt;const Elem *&gt; new_neighbors;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093   this-&gt;<a class="code" href="classlibMesh_1_1Patch.php#a45fb72b1f70f52bb361e3c0f1a3cee06">find_face_neighbors</a>(new_neighbors);
<a name="l00094"></a>00094     
<a name="l00095"></a>00095   std::set&lt;const Elem*&gt;::const_iterator       it  = new_neighbors.begin();
<a name="l00096"></a>00096   <span class="keyword">const</span> std::set&lt;const Elem*&gt;::const_iterator end = new_neighbors.end();
<a name="l00097"></a>00097 
<a name="l00098"></a>00098   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00099"></a>00099     {
<a name="l00100"></a>00100       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = *it;
<a name="l00101"></a>00101       <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() ==
<a name="l00102"></a>00102           <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) <span class="comment">// ... if the neighbor belongs to this processor</span>
<a name="l00103"></a>00103         this-&gt;insert (neighbor);   <span class="comment">// ... then add it to the patch</span>
<a name="l00104"></a>00104     }
<a name="l00105"></a>00105 }
<a name="l00106"></a>00106     
<a name="l00107"></a>00107 
<a name="l00108"></a>00108 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1Patch.php#a39122bba3dc1ac5591ae81f2febaf957">00109</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a39122bba3dc1ac5591ae81f2febaf957">Patch::find_point_neighbors</a>(std::set&lt;const Elem *&gt; &amp;new_neighbors)
<a name="l00110"></a>00110 {
<a name="l00111"></a>00111   <span class="comment">// Loop over all the elements in the patch</span>
<a name="l00112"></a>00112   std::set&lt;const Elem*&gt;::const_iterator       it  = this-&gt;begin();
<a name="l00113"></a>00113   <span class="keyword">const</span> std::set&lt;const Elem*&gt;::const_iterator end = this-&gt;end();
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00116"></a>00116     {
<a name="l00117"></a>00117       std::set&lt;const Elem*&gt; elem_point_neighbors;
<a name="l00118"></a>00118 
<a name="l00119"></a>00119       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00120"></a>00120       elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a479ca39359c81c4c75f19457a23ad32f">find_point_neighbors</a>(elem_point_neighbors);
<a name="l00121"></a>00121  
<a name="l00122"></a>00122       new_neighbors.insert(elem_point_neighbors.begin(),
<a name="l00123"></a>00123                            elem_point_neighbors.end());
<a name="l00124"></a>00124     }
<a name="l00125"></a>00125 }
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 
<a name="l00129"></a><a class="code" href="classlibMesh_1_1Patch.php#a11b615f30ef27475e5507d1ec93750d6">00129</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a11b615f30ef27475e5507d1ec93750d6">Patch::add_point_neighbors</a>()
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   std::set&lt;const Elem *&gt; new_neighbors;
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   this-&gt;<a class="code" href="classlibMesh_1_1Patch.php#a39122bba3dc1ac5591ae81f2febaf957">find_point_neighbors</a>(new_neighbors);
<a name="l00134"></a>00134     
<a name="l00135"></a>00135   this-&gt;insert(new_neighbors.begin(), new_neighbors.end());
<a name="l00136"></a>00136 }
<a name="l00137"></a>00137 
<a name="l00138"></a>00138 
<a name="l00139"></a>00139   
<a name="l00140"></a><a class="code" href="classlibMesh_1_1Patch.php#a86a6c3aebdd08ce17ac5a17c5a8a4c15">00140</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a86a6c3aebdd08ce17ac5a17c5a8a4c15">Patch::add_local_point_neighbors</a>()
<a name="l00141"></a>00141 {
<a name="l00142"></a>00142   std::set&lt;const Elem *&gt; new_neighbors;
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   this-&gt;<a class="code" href="classlibMesh_1_1Patch.php#a39122bba3dc1ac5591ae81f2febaf957">find_point_neighbors</a>(new_neighbors);
<a name="l00145"></a>00145 
<a name="l00146"></a>00146   std::set&lt;const Elem*&gt;::const_iterator       it  = new_neighbors.begin();
<a name="l00147"></a>00147   <span class="keyword">const</span> std::set&lt;const Elem*&gt;::const_iterator end = new_neighbors.end();
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00150"></a>00150     {
<a name="l00151"></a>00151       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* neighbor = *it;
<a name="l00152"></a>00152       <span class="keywordflow">if</span> (neighbor-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() ==
<a name="l00153"></a>00153           <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>()) <span class="comment">// ... if the neighbor belongs to this processor</span>
<a name="l00154"></a>00154         this-&gt;insert (neighbor);   <span class="comment">// ... then add it to the patch</span>
<a name="l00155"></a>00155     }
<a name="l00156"></a>00156 }
<a name="l00157"></a>00157   
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a><a class="code" href="classlibMesh_1_1Patch.php#ac4c8cdb3d027e4c895cd66cf39ab0247">00160</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#ac4c8cdb3d027e4c895cd66cf39ab0247">Patch::build_around_element</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e0,
<a name="l00161"></a>00161                                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> target_patch_size,
<a name="l00162"></a>00162                                   PMF patchtype)
<a name="l00163"></a>00163 {
<a name="l00164"></a>00164   
<a name="l00165"></a>00165   <span class="comment">// Make sure we are building a patch for an active element.</span>
<a name="l00166"></a>00166   libmesh_assert (e0 != NULL);
<a name="l00167"></a>00167   libmesh_assert (e0-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00168"></a>00168   <span class="comment">// Make sure we are either starting with a local element or</span>
<a name="l00169"></a>00169   <span class="comment">// requesting a nonlocal patch</span>
<a name="l00170"></a>00170   libmesh_assert ((patchtype != &amp;<a class="code" href="classlibMesh_1_1Patch.php#a5a0fcd13cfe4dff3036af054cb548500">Patch::add_local_face_neighbors</a> &amp;&amp;
<a name="l00171"></a>00171            patchtype != &amp;<a class="code" href="classlibMesh_1_1Patch.php#a86a6c3aebdd08ce17ac5a17c5a8a4c15">Patch::add_local_point_neighbors</a>) ||
<a name="l00172"></a>00172            e0-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00173"></a>00173   
<a name="l00174"></a>00174   <span class="comment">// First clear the current set, then add the element of interest.</span>
<a name="l00175"></a>00175   this-&gt;clear();
<a name="l00176"></a>00176   this-&gt;insert (e0);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   <span class="comment">// Repeatedly add the neighbors of the elements in the patch until</span>
<a name="l00179"></a>00179   <span class="comment">// the target patch size is met</span>
<a name="l00180"></a>00180   <span class="keywordflow">while</span> (this-&gt;size() &lt; target_patch_size)
<a name="l00181"></a>00181     {
<a name="l00182"></a>00182       <span class="comment">// It is possible that the target patch size is larger than the number</span>
<a name="l00183"></a>00183       <span class="comment">// of elements that can be added to the patch.  Since we don&#39;t</span>
<a name="l00184"></a>00184       <span class="comment">// have access to the Mesh object here, the only way we can</span>
<a name="l00185"></a>00185       <span class="comment">// detect this case is by detecting a &quot;stagnant patch,&quot; i.e. a</span>
<a name="l00186"></a>00186       <span class="comment">// patch whose size does not increase after adding face neighbors</span>
<a name="l00187"></a>00187       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> old_patch_size = this-&gt;size();
<a name="l00188"></a>00188       
<a name="l00189"></a>00189       <span class="comment">// We profile the patch-extending functions separately</span>
<a name="l00190"></a>00190       (this-&gt;*patchtype)();
<a name="l00191"></a>00191       
<a name="l00192"></a>00192       <span class="comment">// Check for a &quot;stagnant&quot; patch</span>
<a name="l00193"></a>00193       <span class="keywordflow">if</span> (this-&gt;size() == old_patch_size)
<a name="l00194"></a>00194         {
<a name="l00195"></a>00195           <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: stagnant patch of &quot;</span>
<a name="l00196"></a>00196                         &lt;&lt; this-&gt;size() &lt;&lt; <span class="stringliteral">&quot; elements.&quot;</span>
<a name="l00197"></a>00197                         &lt;&lt; std::endl
<a name="l00198"></a>00198                         &lt;&lt; <span class="stringliteral">&quot;Does your target patch size exceed the number of elements in the mesh?&quot;</span>
<a name="l00199"></a>00199                         &lt;&lt; std::endl;
<a name="l00200"></a>00200           libmesh_here();
<a name="l00201"></a>00201           <span class="keywordflow">break</span>;
<a name="l00202"></a>00202         }
<a name="l00203"></a>00203     } <span class="comment">// end while loop</span>
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   
<a name="l00206"></a>00206   <span class="comment">// make sure all the elements in the patch are active and local</span>
<a name="l00207"></a>00207   <span class="comment">// if we are in debug mode</span>
<a name="l00208"></a>00208 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00209"></a>00209 <span class="preprocessor"></span>  {
<a name="l00210"></a>00210     std::set&lt;const Elem*&gt;::const_iterator       it  = this-&gt;begin();
<a name="l00211"></a>00211     <span class="keyword">const</span> std::set&lt;const Elem*&gt;::const_iterator end = this-&gt;end();
<a name="l00212"></a>00212     
<a name="l00213"></a>00213     <span class="keywordflow">for</span> (; it != end; ++it)
<a name="l00214"></a>00214       {
<a name="l00215"></a>00215         <span class="comment">// Convenience.  Keep the syntax simple.</span>
<a name="l00216"></a>00216         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *it;
<a name="l00217"></a>00217 
<a name="l00218"></a>00218         libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00219"></a>00219         <span class="keywordflow">if</span> ((patchtype == &amp;<a class="code" href="classlibMesh_1_1Patch.php#a5a0fcd13cfe4dff3036af054cb548500">Patch::add_local_face_neighbors</a> ||
<a name="l00220"></a>00220              patchtype == &amp;<a class="code" href="classlibMesh_1_1Patch.php#a86a6c3aebdd08ce17ac5a17c5a8a4c15">Patch::add_local_point_neighbors</a>))
<a name="l00221"></a>00221           libmesh_assert (elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#aae1d28de6302fd8289052fd39a6ee610">processor_id</a>() == <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>());
<a name="l00222"></a>00222       }
<a name="l00223"></a>00223   }
<a name="l00224"></a>00224 <span class="preprocessor">#endif</span>
<a name="l00225"></a>00225 <span class="preprocessor"></span>
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
