<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">patch.h</div>  </div>
</div>
<div class="contents">
<a href="patch_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: patch.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __patch_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __patch_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// Forward Declarations</span>
<a name="l00035"></a>00035 <span class="keyword">class </span>Elem;
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 
<a name="l00046"></a><a class="code" href="classlibMesh_1_1Patch.php">00046</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Patch.php">Patch</a> : <span class="keyword">public</span> std::set&lt;const Elem *&gt;
<a name="l00047"></a>00047 {
<a name="l00048"></a>00048 <span class="keyword">public</span>:
<a name="l00049"></a>00049 
<a name="l00053"></a><a class="code" href="classlibMesh_1_1Patch.php#ac4b5dc67319958ab319cfff6da210953">00053</a>   <a class="code" href="classlibMesh_1_1Patch.php#ac4b5dc67319958ab319cfff6da210953">Patch</a>() {}
<a name="l00054"></a>00054   
<a name="l00058"></a><a class="code" href="classlibMesh_1_1Patch.php#a2e37f5de47b63e626b5cf9ed888443c4">00058</a>   <a class="code" href="classlibMesh_1_1Patch.php#a2e37f5de47b63e626b5cf9ed888443c4">~Patch</a>() {}
<a name="l00059"></a>00059 
<a name="l00064"></a>00064   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#aa571745668280fdba35de80031aacf9c">add_face_neighbors</a>();
<a name="l00065"></a>00065 
<a name="l00070"></a>00070   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a5a0fcd13cfe4dff3036af054cb548500">add_local_face_neighbors</a>();
<a name="l00071"></a>00071 
<a name="l00076"></a>00076   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a11b615f30ef27475e5507d1ec93750d6">add_point_neighbors</a>();
<a name="l00077"></a>00077 
<a name="l00082"></a>00082   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a86a6c3aebdd08ce17ac5a17c5a8a4c15">add_local_point_neighbors</a>();
<a name="l00083"></a>00083 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1Patch.php#a2223898c123f750a1e66a8d75d72a89c">00087</a>   <span class="keyword">typedef</span> void (<a class="code" href="classlibMesh_1_1Patch.php">Patch</a>::*<a class="code" href="classlibMesh_1_1Patch.php#a2223898c123f750a1e66a8d75d72a89c">PMF</a>)();
<a name="l00088"></a>00088 
<a name="l00096"></a>00096   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#ac4c8cdb3d027e4c895cd66cf39ab0247">build_around_element</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem,
<a name="l00097"></a>00097                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> target_patch_size = 10,
<a name="l00098"></a>00098                             <a class="code" href="classlibMesh_1_1Patch.php#a2223898c123f750a1e66a8d75d72a89c">PMF</a> patchtype = &amp;<a class="code" href="classlibMesh_1_1Patch.php#a5a0fcd13cfe4dff3036af054cb548500">Patch::add_local_face_neighbors</a>);
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="keyword">protected</span>:
<a name="l00101"></a>00101 
<a name="l00106"></a>00106   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a45fb72b1f70f52bb361e3c0f1a3cee06">find_face_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set);
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Patch.php#a39122bba3dc1ac5591ae81f2febaf957">find_point_neighbors</a>(std::set&lt;const Elem *&gt; &amp;neighbor_set);
<a name="l00113"></a>00113 };
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 } <span class="comment">// namespace libMesh</span>
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 <span class="preprocessor">#endif // #define __patch_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
