<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_ab56aa07afc90dc9b38495678b8db7f4.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">patch_recovery_error_estimator.C</div>  </div>
</div>
<div class="contents">
<a href="patch__recovery__error__estimator_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: patch_recovery_error_estimator.C 4390 2011-04-21 17:02:25Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;algorithm&gt;</span> <span class="comment">// for std::fill</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;cmath&gt;</span>     <span class="comment">// for std::sqrt std::pow std::abs</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local Includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="patch__recovery__error__estimator_8h.php">patch_recovery_error_estimator.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="fe__base_8h.php">fe_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__matrix_8h.php">dense_matrix.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="error__vector_8h.php">error_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="patch_8h.php">patch.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__grid_8h.php">quadrature_grid.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00041"></a>00041 <span class="preprocessor">#include &quot;<a class="code" href="tensor__value_8h.php">tensor_value.h</a>&quot;</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keyword">namespace </span>libMesh
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="comment">//-----------------------------------------------------------------</span>
<a name="l00048"></a>00048 <span class="comment">// PatchRecoveryErrorEstimator implementations</span>
<a name="l00049"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">00049</a> std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">PatchRecoveryErrorEstimator::specpoly</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00050"></a>00050                                                         <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00051"></a>00051                                                         <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> p,
<a name="l00052"></a>00052                                                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matsize)
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   std::vector&lt;Real&gt; psi;
<a name="l00055"></a>00055   psi.reserve(matsize);
<a name="l00056"></a>00056   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> x = p(0), y=0., z=0.;
<a name="l00057"></a>00057   <span class="keywordflow">if</span> (dim &gt; 1)
<a name="l00058"></a>00058     y = p(1);
<a name="l00059"></a>00059   <span class="keywordflow">if</span> (dim &gt; 2)
<a name="l00060"></a>00060     z = p(2);
<a name="l00061"></a>00061     
<a name="l00062"></a>00062   <span class="comment">// builds psi vector of form 1 x y z x^2 xy xz y^2 yz z^2 etc..</span>
<a name="l00063"></a>00063   <span class="comment">// I haven&#39;t added 1D support here</span>
<a name="l00064"></a>00064   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> poly_deg=0; poly_deg &lt;= static_cast&lt;unsigned int&gt;(order) ; poly_deg++)
<a name="l00065"></a>00065     { <span class="comment">// loop over all polynomials of total degreee = poly_deg</span>
<a name="l00066"></a>00066 
<a name="l00067"></a>00067       <span class="keywordflow">switch</span> (dim)
<a name="l00068"></a>00068         {
<a name="l00069"></a>00069           <span class="comment">// 3D spectral polynomial basis functions</span>
<a name="l00070"></a>00070         <span class="keywordflow">case</span> 3:
<a name="l00071"></a>00071           {     
<a name="l00072"></a>00072             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> xexp=poly_deg; xexp &gt;= 0; xexp--) <span class="comment">// use an int for xexp since we -- it</span>
<a name="l00073"></a>00073               <span class="keywordflow">for</span> (<span class="keywordtype">int</span> yexp=poly_deg-xexp; yexp &gt;= 0; yexp--)
<a name="l00074"></a>00074                 {
<a name="l00075"></a>00075                   <span class="keywordtype">int</span> zexp = poly_deg - xexp - yexp;
<a name="l00076"></a>00076                   psi.push_back(<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(x,static_cast&lt;Real&gt;(xexp))*
<a name="l00077"></a>00077                                 <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(y,static_cast&lt;Real&gt;(yexp))*
<a name="l00078"></a>00078                                 <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(z,static_cast&lt;Real&gt;(zexp)));
<a name="l00079"></a>00079                 }
<a name="l00080"></a>00080             <span class="keywordflow">break</span>;
<a name="l00081"></a>00081           }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083           <span class="comment">// 2D spectral polynomial basis functions</span>
<a name="l00084"></a>00084         <span class="keywordflow">case</span> 2:
<a name="l00085"></a>00085           {
<a name="l00086"></a>00086             <span class="keywordflow">for</span> (<span class="keywordtype">int</span> xexp=poly_deg; xexp &gt;= 0; xexp--) <span class="comment">// use an int for xexp since we -- it</span>
<a name="l00087"></a>00087               {
<a name="l00088"></a>00088                 <span class="keywordtype">int</span> yexp = poly_deg - xexp;
<a name="l00089"></a>00089                 psi.push_back(<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(x,static_cast&lt;Real&gt;(xexp))*
<a name="l00090"></a>00090                               <a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(y,static_cast&lt;Real&gt;(yexp)));
<a name="l00091"></a>00091               }
<a name="l00092"></a>00092             <span class="keywordflow">break</span>;
<a name="l00093"></a>00093           }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095           <span class="comment">// 1D spectral polynomial basis functions</span>
<a name="l00096"></a>00096         <span class="keywordflow">case</span> 1:
<a name="l00097"></a>00097           {
<a name="l00098"></a>00098             <span class="keywordtype">int</span> xexp = poly_deg;
<a name="l00099"></a>00099             psi.push_back(<a class="code" href="namespacelibMesh_1_1Utility.php#aa4be0076e10127d723fde831e41758eb">std::pow</a>(x,static_cast&lt;Real&gt;(xexp)));
<a name="l00100"></a>00100             <span class="keywordflow">break</span>;
<a name="l00101"></a>00101           }
<a name="l00102"></a>00102           
<a name="l00103"></a>00103         <span class="keywordflow">default</span>:
<a name="l00104"></a>00104           libmesh_error();
<a name="l00105"></a>00105         }
<a name="l00106"></a>00106     }
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="keywordflow">return</span> psi;
<a name="l00109"></a>00109 }
<a name="l00110"></a>00110     
<a name="l00111"></a>00111   
<a name="l00112"></a>00112 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a49b17c22f18578866ebb751b1d28852c">00113</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a49b17c22f18578866ebb751b1d28852c">PatchRecoveryErrorEstimator::estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00114"></a>00114                                                   <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00115"></a>00115                                                   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector,
<a name="l00116"></a>00116                                                   <span class="keywordtype">bool</span>)
<a name="l00117"></a>00117 {
<a name="l00118"></a>00118   START_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;PatchRecoveryErrorEstimator&quot;</span>);
<a name="l00119"></a>00119 
<a name="l00120"></a>00120   <span class="comment">// The current mesh</span>
<a name="l00121"></a>00121   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = system.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00122"></a>00122   
<a name="l00123"></a>00123   <span class="comment">// Resize the error_per_cell vector to be</span>
<a name="l00124"></a>00124   <span class="comment">// the number of elements, initialize it to 0.</span>
<a name="l00125"></a>00125   error_per_cell.resize (mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a4553709ee4a6a6088c7b656bec34839e">max_elem_id</a>());
<a name="l00126"></a>00126   std::fill (error_per_cell.begin(), error_per_cell.end(), 0.);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128   <span class="comment">// Prepare current_local_solution to localize a non-standard</span>
<a name="l00129"></a>00129   <span class="comment">// solution vector if necessary</span>
<a name="l00130"></a>00130   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00131"></a>00131     {
<a name="l00132"></a>00132       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00133"></a>00133         <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00134"></a>00134       <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1System.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00135"></a>00135       newsol-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">swap</a>(*sys.solution);
<a name="l00136"></a>00136       sys.update();
<a name="l00137"></a>00137     }
<a name="l00138"></a>00138   
<a name="l00139"></a>00139   <span class="comment">//------------------------------------------------------------</span>
<a name="l00140"></a>00140   <span class="comment">// Iterate over all the active elements in the mesh</span>
<a name="l00141"></a>00141   <span class="comment">// that live on this processor.</span>
<a name="l00142"></a>00142   <a class="code" href="namespacelibMesh_1_1Threads.php#a0a6259585412504a211d6d022b196221">Threads::parallel_for</a> (<a class="code" href="namespacelibMesh.php#acabd15c3bba2b26daa7032e0b5e60e7f">ConstElemRange</a>(mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a99742bad0b034a29ccae8c5a90c6f4aa">active_local_elements_begin</a>(),
<a name="l00143"></a>00143                                         mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a2e27f54d33f7539c0c06b36adae36cda">active_local_elements_end</a>(),
<a name="l00144"></a>00144                                         200),
<a name="l00145"></a>00145                          <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#aa6f9e02d634611633027410694b95781">EstimateError</a>(system,
<a name="l00146"></a>00146                                        *<span class="keyword">this</span>,
<a name="l00147"></a>00147                                        error_per_cell)
<a name="l00148"></a>00148                          );
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">// Each processor has now computed the error contribuions</span>
<a name="l00151"></a>00151   <span class="comment">// for its local elements, and error_per_cell contains 0 for all the</span>
<a name="l00152"></a>00152   <span class="comment">// non-local elements.  Summing the vector will provide the L_oo value</span>
<a name="l00153"></a>00153   <span class="comment">// for each element, local or remote</span>
<a name="l00154"></a>00154   this-&gt;<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9b57650afd8a3a0a88cb62bf74dd95e3">reduce_error</a>(error_per_cell);
<a name="l00155"></a>00155   
<a name="l00156"></a>00156   <span class="comment">// If we used a non-standard solution before, now is the time to fix</span>
<a name="l00157"></a>00157   <span class="comment">// the current_local_solution</span>
<a name="l00158"></a>00158   <span class="keywordflow">if</span> (solution_vector &amp;&amp; solution_vector != system.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>())
<a name="l00159"></a>00159     {
<a name="l00160"></a>00160       <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* newsol =
<a name="l00161"></a>00161         <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>*<span class="keyword">&gt;</span>(solution_vector);
<a name="l00162"></a>00162       <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys = <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1System.php">System</a>&amp;<span class="keyword">&gt;</span>(system);
<a name="l00163"></a>00163       newsol-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">swap</a>(*sys.solution);
<a name="l00164"></a>00164       sys.update();
<a name="l00165"></a>00165     }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   STOP_LOG(<span class="stringliteral">&quot;estimate_error()&quot;</span>, <span class="stringliteral">&quot;PatchRecoveryErrorEstimator&quot;</span>);
<a name="l00168"></a>00168 }
<a name="l00169"></a>00169 
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 
<a name="l00172"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#af0759b6a9c3d10483c71ac6d5cd6440f">00172</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#af0759b6a9c3d10483c71ac6d5cd6440f">PatchRecoveryErrorEstimator::EstimateError::operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range)<span class="keyword"> const</span>
<a name="l00173"></a>00173 <span class="keyword"></span>{
<a name="l00174"></a>00174   <span class="comment">// The current mesh</span>
<a name="l00175"></a>00175   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a> = <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#a39141a08afe4e0334c21035de6f0b7a3">get_mesh</a>();
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <span class="comment">// The dimensionality of the mesh</span>
<a name="l00178"></a>00178   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim = mesh.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>();
<a name="l00179"></a>00179   
<a name="l00180"></a>00180   <span class="comment">// The number of variables in the system</span>
<a name="l00181"></a>00181   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a> = <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#a4cf032eda109fe32a7fcde672ef5726e">n_vars</a>();
<a name="l00182"></a>00182   
<a name="l00183"></a>00183   <span class="comment">// The DofMap for this system</span>
<a name="l00184"></a>00184   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DofMap.php">DofMap</a>&amp; dof_map = <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>();
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 
<a name="l00187"></a>00187   <span class="comment">//------------------------------------------------------------</span>
<a name="l00188"></a>00188   <span class="comment">// Iterate over all the elements in the range.</span>
<a name="l00189"></a>00189   <span class="keywordflow">for</span> (<a class="code" href="classlibMesh_1_1StoredRange.php#a07c6e88eede585628af3437d8cad903f">ConstElemRange::const_iterator</a> elem_it=range.<a class="code" href="classlibMesh_1_1StoredRange.php#a9687da8abb136c142c4df14f4444737b">begin</a>(); elem_it!=range.<a class="code" href="classlibMesh_1_1StoredRange.php#aff337b550b3349015980e791dd982b21">end</a>(); ++elem_it)
<a name="l00190"></a>00190     {
<a name="l00191"></a>00191       <span class="comment">// elem is necessarily an active element on the local processor</span>
<a name="l00192"></a>00192       <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem = *elem_it;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194       <span class="comment">// We&#39;ll need an index into the error vector</span>
<a name="l00195"></a>00195       <span class="keyword">const</span> <span class="keywordtype">int</span> e_id=elem-&gt;<a class="code" href="classlibMesh_1_1DofObject.php#a65bf7c6c844834d78e04bcec37b1f059">id</a>();
<a name="l00196"></a>00196 
<a name="l00197"></a>00197       <span class="comment">// Build a patch containing the current element</span>
<a name="l00198"></a>00198       <span class="comment">// and its neighbors on the local processor</span>
<a name="l00199"></a>00199       <a class="code" href="classlibMesh_1_1Patch.php">Patch</a> patch;
<a name="l00200"></a>00200 
<a name="l00201"></a>00201       <span class="comment">// Use user specified patch size and growth strategy</span>
<a name="l00202"></a>00202       patch.<a class="code" href="classlibMesh_1_1Patch.php#ac4c8cdb3d027e4c895cd66cf39ab0247">build_around_element</a> (elem, <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a180843e3c0d3993cb1dcce3e86509d73">target_patch_size</a>,
<a name="l00203"></a>00203                                   <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a3f28c0ae0ded6264c53bcaa2c5483c89">patch_growth_strategy</a>);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205       <span class="comment">//------------------------------------------------------------</span>
<a name="l00206"></a>00206       <span class="comment">// Process each variable in the system using the current patch</span>
<a name="l00207"></a>00207       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var=0; var&lt;<a class="code" href="tecplot__io_8C.php#ac001e4247887b98c2aa5b8ec5107ca0d">n_vars</a>; var++)
<a name="l00208"></a>00208         {
<a name="l00209"></a>00209 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00210"></a>00210 <span class="preprocessor"></span><span class="preprocessor">  #ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00211"></a>00211 <span class="preprocessor"></span>          libmesh_assert (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00212"></a>00212                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00213"></a>00213                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00214"></a>00214                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a> ||
<a name="l00215"></a>00215                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a> ||
<a name="l00216"></a>00216                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a> ||
<a name="l00217"></a>00217                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a> ||
<a name="l00218"></a>00218                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00219"></a>00219                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>);
<a name="l00220"></a>00220 <span class="preprocessor">  #else</span>
<a name="l00221"></a>00221 <span class="preprocessor"></span>          libmesh_assert (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00222"></a>00222                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a> ||
<a name="l00223"></a>00223                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00224"></a>00224                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a> ||
<a name="l00225"></a>00225                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a> ||
<a name="l00226"></a>00226                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a> ||
<a name="l00227"></a>00227                           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>);
<a name="l00228"></a>00228 <span class="preprocessor">  #endif</span>
<a name="l00229"></a>00229 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (var &gt; 0)
<a name="l00230"></a>00230             <span class="comment">// We can&#39;t mix L_inf and L_2 norms</span>
<a name="l00231"></a>00231             libmesh_assert (((<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00232"></a>00232                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00233"></a>00233                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>) &amp;&amp;
<a name="l00234"></a>00234                              (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00235"></a>00235                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00236"></a>00236                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a> ||
<a name="l00237"></a>00237                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a> ||
<a name="l00238"></a>00238                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a> ||
<a name="l00239"></a>00239                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)) ||
<a name="l00240"></a>00240                             ((<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a> ||
<a name="l00241"></a>00241                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00242"></a>00242                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>) &amp;&amp;
<a name="l00243"></a>00243                              (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a> ||
<a name="l00244"></a>00244                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00245"></a>00245                               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var-1) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)));
<a name="l00246"></a>00246 <span class="preprocessor">#endif</span>
<a name="l00247"></a>00247 <span class="preprocessor"></span>
<a name="l00248"></a>00248           <span class="comment">// Possibly skip this variable</span>
<a name="l00249"></a>00249           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(var) == 0.0) <span class="keywordflow">continue</span>;
<a name="l00250"></a>00250           
<a name="l00251"></a>00251           <span class="comment">// The type of finite element to use for this variable</span>
<a name="l00252"></a>00252           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1FEType.php">FEType</a>&amp; fe_type = dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a0c010bb250d4cd8d65794452f46d141a">variable_type</a> (var);
<a name="l00253"></a>00253 
<a name="l00254"></a>00254           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> element_order  = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>
<a name="l00255"></a>00255             (fe_type.<a class="code" href="classlibMesh_1_1FEType.php#aa2484e0f6721f3e34dedebccacc48ac1">order</a> + elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#a362aba1afba25a8417aa6d242e2f8d52">p_level</a>());
<a name="l00256"></a>00256       
<a name="l00257"></a>00257           <span class="comment">// Finite element object for use in this patch</span>
<a name="l00258"></a>00258           <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;FEBase&gt;</a> fe (<a class="code" href="classlibMesh_1_1FEBase.php#aa6065b49a9dd684109a87770e514ff5d">FEBase::build</a> (dim, fe_type));
<a name="l00259"></a>00259           
<a name="l00260"></a>00260           <span class="comment">// Build an appropriate Gaussian quadrature rule</span>
<a name="l00261"></a>00261           <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> qrule (fe_type.<a class="code" href="classlibMesh_1_1FEType.php#a3f1da6f01808bcef1ee575b908f57dc4">default_quadrature_rule</a>(dim));
<a name="l00262"></a>00262 
<a name="l00263"></a>00263           <span class="comment">// Tell the finite element about the quadrature rule.</span>
<a name="l00264"></a>00264           fe-&gt;attach_quadrature_rule (qrule.get());
<a name="l00265"></a>00265       
<a name="l00266"></a>00266           <span class="comment">// Get Jacobian values, etc..</span>
<a name="l00267"></a>00267           <span class="keyword">const</span> std::vector&lt;Real&gt;&amp;                       JxW     = fe-&gt;get_JxW();
<a name="l00268"></a>00268           <span class="keyword">const</span> std::vector&lt;Point&gt;&amp;                      q_point = fe-&gt;get_xyz();
<a name="l00269"></a>00269 
<a name="l00270"></a>00270           <span class="comment">// Get whatever phi/dphi/d2phi values we need.  Avoid</span>
<a name="l00271"></a>00271           <span class="comment">// getting them unless the requested norm is actually going</span>
<a name="l00272"></a>00272           <span class="comment">// to use them.</span>
<a name="l00273"></a>00273 
<a name="l00274"></a>00274           <span class="keyword">const</span> std::vector&lt;std::vector&lt;Real&gt; &gt;         *phi = NULL;
<a name="l00275"></a>00275           <span class="comment">// If we&#39;re using phi to assert the correct dof_indices</span>
<a name="l00276"></a>00276           <span class="comment">// vector size later, then we&#39;ll need to get_phi whether we</span>
<a name="l00277"></a>00277           <span class="comment">// plan to use it or not.</span>
<a name="l00278"></a>00278 <span class="preprocessor">#ifdef NDEBUG</span>
<a name="l00279"></a>00279 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00280"></a>00280               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>)
<a name="l00281"></a>00281 #endif
<a name="l00282"></a>00282             phi = &amp;(fe-&gt;get_phi());
<a name="l00283"></a>00283 
<a name="l00284"></a>00284           <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealGradient&gt; &gt; *dphi = NULL;
<a name="l00285"></a>00285           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00286"></a>00286               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a> ||
<a name="l00287"></a>00287               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a> ||
<a name="l00288"></a>00288               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a> ||
<a name="l00289"></a>00289               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>)
<a name="l00290"></a>00290             dphi = &amp;(fe-&gt;get_dphi());
<a name="l00291"></a>00291 
<a name="l00292"></a>00292 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00293"></a>00293 <span class="preprocessor"></span>          <span class="keyword">const</span> std::vector&lt;std::vector&lt;RealTensor&gt; &gt;  *d2phi = NULL;
<a name="l00294"></a>00294           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00295"></a>00295               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00296"></a>00296             d2phi = &amp;(fe-&gt;get_d2phi());
<a name="l00297"></a>00297 <span class="preprocessor">#endif</span>
<a name="l00298"></a>00298 <span class="preprocessor"></span>      
<a name="l00299"></a>00299           <span class="comment">// global DOF indices</span>
<a name="l00300"></a>00300           std::vector&lt;unsigned int&gt; dof_indices;
<a name="l00301"></a>00301 
<a name="l00302"></a>00302           <span class="comment">// Compute the approprite size for the patch projection matrices</span>
<a name="l00303"></a>00303           <span class="comment">// and vectors; </span>
<a name="l00304"></a>00304           <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matsize = element_order + 1;
<a name="l00305"></a>00305           <span class="keywordflow">if</span> (dim &gt; 1)
<a name="l00306"></a>00306             {
<a name="l00307"></a>00307               matsize *= (element_order + 2);
<a name="l00308"></a>00308               matsize /= 2;
<a name="l00309"></a>00309             }
<a name="l00310"></a>00310           <span class="keywordflow">if</span> (dim &gt; 2)
<a name="l00311"></a>00311             {
<a name="l00312"></a>00312               matsize *= (element_order + 3);
<a name="l00313"></a>00313               matsize /= 3;
<a name="l00314"></a>00314             }
<a name="l00315"></a>00315                   
<a name="l00316"></a>00316           <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;Number&gt;</a> Kp(matsize,matsize);
<a name="l00317"></a>00317           <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> F,    Fx,     Fy,     Fz,     Fxy,     Fxz,     Fyz;
<a name="l00318"></a>00318           <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;Number&gt;</a> Pu_h, Pu_x_h, Pu_y_h, Pu_z_h, Pu_xy_h, Pu_xz_h, Pu_yz_h;
<a name="l00319"></a>00319           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00320"></a>00320               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>)
<a name="l00321"></a>00321             {
<a name="l00322"></a>00322               F.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize);
<a name="l00323"></a>00323             }
<a name="l00324"></a>00324           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00325"></a>00325               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00326"></a>00326               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00327"></a>00327               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00328"></a>00328             {
<a name="l00329"></a>00329               Fx.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_x_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); <span class="comment">// stores xx in W2 cases</span>
<a name="l00330"></a>00330 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00331"></a>00331 <span class="preprocessor"></span>              Fy.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_y_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); <span class="comment">// stores yy in W2 cases</span>
<a name="l00332"></a>00332 <span class="preprocessor">#endif</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00334"></a>00334 <span class="preprocessor"></span>              Fz.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_z_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); <span class="comment">// stores zz in W2 cases</span>
<a name="l00335"></a>00335 <span class="preprocessor">#endif</span>
<a name="l00336"></a>00336 <span class="preprocessor"></span>            }
<a name="l00337"></a>00337           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a>)
<a name="l00338"></a>00338             {
<a name="l00339"></a>00339               Fx.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_x_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); <span class="comment">// Only need to compute the x gradient for the x component seminorm</span>
<a name="l00340"></a>00340             }
<a name="l00341"></a>00341           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a>)
<a name="l00342"></a>00342             {
<a name="l00343"></a>00343               libmesh_assert(LIBMESH_DIM &gt; 1);
<a name="l00344"></a>00344               Fy.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_y_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); <span class="comment">// Only need to compute the y gradient for the y component seminorm</span>
<a name="l00345"></a>00345             }
<a name="l00346"></a>00346           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a>)
<a name="l00347"></a>00347             {
<a name="l00348"></a>00348               libmesh_assert(LIBMESH_DIM &gt; 2);
<a name="l00349"></a>00349               Fz.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_z_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); <span class="comment">// Only need to compute the z gradient for the z component seminorm</span>
<a name="l00350"></a>00350             }          
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00353"></a>00353 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00354"></a>00354               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00355"></a>00355             {
<a name="l00356"></a>00356               Fxy.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_xy_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize);
<a name="l00357"></a>00357 <span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00358"></a>00358 <span class="preprocessor"></span>              Fxz.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_xz_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize);
<a name="l00359"></a>00359               Fyz.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize); Pu_yz_h.<a class="code" href="classlibMesh_1_1DenseVector.php#a08430ae781094632e8272cbb825d4f44">resize</a>(matsize);
<a name="l00360"></a>00360 <span class="preprocessor">#endif</span>
<a name="l00361"></a>00361 <span class="preprocessor"></span>            }
<a name="l00362"></a>00362 <span class="preprocessor">#endif</span>
<a name="l00363"></a>00363 <span class="preprocessor"></span>
<a name="l00364"></a>00364           <span class="comment">//------------------------------------------------------</span>
<a name="l00365"></a>00365           <span class="comment">// Loop over each element in the patch and compute their</span>
<a name="l00366"></a>00366           <span class="comment">// contribution to the patch gradient projection.</span>
<a name="l00367"></a>00367           Patch::const_iterator        patch_it  = patch.begin();
<a name="l00368"></a>00368           <span class="keyword">const</span> Patch::const_iterator  patch_end = patch.end();
<a name="l00369"></a>00369 
<a name="l00370"></a>00370           <span class="keywordflow">for</span> (; patch_it != patch_end; ++patch_it)
<a name="l00371"></a>00371             {
<a name="l00372"></a>00372               <span class="comment">// The pth element in the patch</span>
<a name="l00373"></a>00373               <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* e_p = *patch_it;
<a name="l00374"></a>00374 
<a name="l00375"></a>00375               <span class="comment">// Reinitialize the finite element data for this element</span>
<a name="l00376"></a>00376               fe-&gt;reinit (e_p);
<a name="l00377"></a>00377 
<a name="l00378"></a>00378               <span class="comment">// Get the global DOF indices for the current variable</span>
<a name="l00379"></a>00379               <span class="comment">// in the current element</span>
<a name="l00380"></a>00380               dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (e_p, dof_indices, var);
<a name="l00381"></a>00381               libmesh_assert (dof_indices.size() == phi-&gt;size());
<a name="l00382"></a>00382 
<a name="l00383"></a>00383               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = dof_indices.size();
<a name="l00384"></a>00384               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_qp   = qrule-&gt;n_points();
<a name="l00385"></a>00385 
<a name="l00386"></a>00386               <span class="comment">// Compute the projection components from this cell.</span>
<a name="l00387"></a>00387               <span class="comment">// \int_{Omega_e} \psi_i \psi_j = \int_{Omega_e} du_h/dx_k \psi_i</span>
<a name="l00388"></a>00388               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qp=0; qp&lt;n_qp; qp++)
<a name="l00389"></a>00389                 {
<a name="l00390"></a>00390                   <span class="comment">// Construct the shape function values for the patch projection</span>
<a name="l00391"></a>00391                   std::vector&lt;Real&gt; psi(<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">specpoly</a>(dim, element_order, q_point[qp], matsize));
<a name="l00392"></a>00392                   
<a name="l00393"></a>00393                   <span class="comment">// Patch matrix contribution</span>
<a name="l00394"></a>00394                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;Kp.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a68bd665fb9252382cc9a28df4099d76a">m</a>(); i++)
<a name="l00395"></a>00395                     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;Kp.<a class="code" href="classlibMesh_1_1DenseMatrixBase.php#a4fb8c524109fd5dff8c98855437544ee">n</a>(); j++)
<a name="l00396"></a>00396                       Kp(i,j) += JxW[qp]*psi[i]*psi[j];
<a name="l00397"></a>00397 
<a name="l00398"></a>00398                   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00399"></a>00399                       <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>)
<a name="l00400"></a>00400                     {
<a name="l00401"></a>00401                       <span class="comment">// Compute the solution on the current patch element</span>
<a name="l00402"></a>00402                       <span class="comment">// the quadrature point</span>
<a name="l00403"></a>00403                       <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_h = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00404"></a>00404                       
<a name="l00405"></a>00405                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00406"></a>00406                         u_h += (*phi)[i][qp]*<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[i]);
<a name="l00407"></a>00407 
<a name="l00408"></a>00408                       <span class="comment">// Patch RHS contributions</span>
<a name="l00409"></a>00409                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;psi.size(); i++)                 
<a name="l00410"></a>00410                           F(i) = JxW[qp]*u_h*psi[i];                    
<a name="l00411"></a>00411 
<a name="l00412"></a>00412                     }            
<a name="l00413"></a>00413                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00414"></a>00414                       <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>)
<a name="l00415"></a>00415                     {
<a name="l00416"></a>00416                       <span class="comment">// Compute the gradient on the current patch element</span>
<a name="l00417"></a>00417                       <span class="comment">// at the quadrature point</span>
<a name="l00418"></a>00418                       <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00419"></a>00419 
<a name="l00420"></a>00420                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00421"></a>00421                         grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> ((*dphi)[i][qp],
<a name="l00422"></a>00422                                              <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00423"></a>00423                   
<a name="l00424"></a>00424                       <span class="comment">// Patch RHS contributions</span>
<a name="l00425"></a>00425                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;psi.size(); i++)
<a name="l00426"></a>00426                         {
<a name="l00427"></a>00427                           Fx(i) += JxW[qp]*grad_u_h(0)*psi[i];
<a name="l00428"></a>00428 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00429"></a>00429 <span class="preprocessor"></span>                          Fy(i) += JxW[qp]*grad_u_h(1)*psi[i];
<a name="l00430"></a>00430 <span class="preprocessor">#endif</span>
<a name="l00431"></a>00431 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00432"></a>00432 <span class="preprocessor"></span>                          Fz(i) += JxW[qp]*grad_u_h(2)*psi[i];
<a name="l00433"></a>00433 <span class="preprocessor">#endif</span>
<a name="l00434"></a>00434 <span class="preprocessor"></span>                        }
<a name="l00435"></a>00435                     }
<a name="l00436"></a>00436                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a>)
<a name="l00437"></a>00437                     {
<a name="l00438"></a>00438                       <span class="comment">// Compute the gradient on the current patch element</span>
<a name="l00439"></a>00439                       <span class="comment">// at the quadrature point</span>
<a name="l00440"></a>00440                       <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00441"></a>00441 
<a name="l00442"></a>00442                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00443"></a>00443                         grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> ((*dphi)[i][qp],
<a name="l00444"></a>00444                                              <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00445"></a>00445                   
<a name="l00446"></a>00446                       <span class="comment">// Patch RHS contributions</span>
<a name="l00447"></a>00447                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;psi.size(); i++)
<a name="l00448"></a>00448                         {
<a name="l00449"></a>00449                           Fx(i) += JxW[qp]*grad_u_h(0)*psi[i];                    
<a name="l00450"></a>00450                         }
<a name="l00451"></a>00451                     }
<a name="l00452"></a>00452                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a>)
<a name="l00453"></a>00453                     {
<a name="l00454"></a>00454                       <span class="comment">// Compute the gradient on the current patch element</span>
<a name="l00455"></a>00455                       <span class="comment">// at the quadrature point</span>
<a name="l00456"></a>00456                       <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00457"></a>00457 
<a name="l00458"></a>00458                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00459"></a>00459                         grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> ((*dphi)[i][qp],
<a name="l00460"></a>00460                                              <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00461"></a>00461                   
<a name="l00462"></a>00462                       <span class="comment">// Patch RHS contributions</span>
<a name="l00463"></a>00463                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;psi.size(); i++)
<a name="l00464"></a>00464                         {                         
<a name="l00465"></a>00465                           Fy(i) += JxW[qp]*grad_u_h(1)*psi[i];                   
<a name="l00466"></a>00466                         }
<a name="l00467"></a>00467                     }
<a name="l00468"></a>00468                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a>)
<a name="l00469"></a>00469                     {
<a name="l00470"></a>00470                       <span class="comment">// Compute the gradient on the current patch element</span>
<a name="l00471"></a>00471                       <span class="comment">// at the quadrature point</span>
<a name="l00472"></a>00472                       <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00473"></a>00473 
<a name="l00474"></a>00474                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00475"></a>00475                         grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> ((*dphi)[i][qp],
<a name="l00476"></a>00476                                              <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00477"></a>00477                   
<a name="l00478"></a>00478                       <span class="comment">// Patch RHS contributions</span>
<a name="l00479"></a>00479                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;psi.size(); i++)
<a name="l00480"></a>00480                         {
<a name="l00481"></a>00481                           Fz(i) += JxW[qp]*grad_u_h(2)*psi[i];
<a name="l00482"></a>00482                         }
<a name="l00483"></a>00483                     }                  
<a name="l00484"></a>00484                   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00485"></a>00485                            <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00486"></a>00486                     {
<a name="l00487"></a>00487 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00488"></a>00488 <span class="preprocessor"></span>                      <span class="comment">// Compute the hessian on the current patch element</span>
<a name="l00489"></a>00489                       <span class="comment">// at the quadrature point</span>
<a name="l00490"></a>00490                       <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> hess_u_h;
<a name="l00491"></a>00491 
<a name="l00492"></a>00492                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00493"></a>00493                         hess_u_h.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a> ((*d2phi)[i][qp],
<a name="l00494"></a>00494                                              <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00495"></a>00495 
<a name="l00496"></a>00496                       <span class="comment">// Patch RHS contributions</span>
<a name="l00497"></a>00497                       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;psi.size(); i++)
<a name="l00498"></a>00498                         {
<a name="l00499"></a>00499                           Fx(i)  += JxW[qp]*hess_u_h(0,0)*psi[i];
<a name="l00500"></a>00500 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00501"></a>00501 <span class="preprocessor"></span>                          Fy(i)  += JxW[qp]*hess_u_h(1,1)*psi[i];
<a name="l00502"></a>00502                           Fxy(i) += JxW[qp]*hess_u_h(0,1)*psi[i];
<a name="l00503"></a>00503 <span class="preprocessor">#endif</span>
<a name="l00504"></a>00504 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00505"></a>00505 <span class="preprocessor"></span>                          Fz(i)  += JxW[qp]*hess_u_h(2,2)*psi[i];
<a name="l00506"></a>00506                           Fxz(i) += JxW[qp]*hess_u_h(0,2)*psi[i];
<a name="l00507"></a>00507                           Fyz(i) += JxW[qp]*hess_u_h(1,2)*psi[i];
<a name="l00508"></a>00508 <span class="preprocessor">#endif</span>
<a name="l00509"></a>00509 <span class="preprocessor"></span>                        }
<a name="l00510"></a>00510 <span class="preprocessor">#else</span>
<a name="l00511"></a>00511 <span class="preprocessor"></span>                      <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  --enable-second-derivatives is required\n&quot;</span>
<a name="l00512"></a>00512                                     &lt;&lt; <span class="stringliteral">&quot;        for _sobolev_order == 2!\n&quot;</span>;
<a name="l00513"></a>00513                       libmesh_error();
<a name="l00514"></a>00514 <span class="preprocessor">#endif</span>
<a name="l00515"></a>00515 <span class="preprocessor"></span>                    }
<a name="l00516"></a>00516                   <span class="keywordflow">else</span>
<a name="l00517"></a>00517                     libmesh_error();
<a name="l00518"></a>00518                 } <span class="comment">// end quadrature loop</span>
<a name="l00519"></a>00519             } <span class="comment">// end patch loop</span>
<a name="l00520"></a>00520           
<a name="l00521"></a>00521 
<a name="l00522"></a>00522           
<a name="l00523"></a>00523           <span class="comment">//--------------------------------------------------</span>
<a name="l00524"></a>00524           <span class="comment">// Now we have fully assembled the projection system</span>
<a name="l00525"></a>00525           <span class="comment">// for this patch.  Project the gradient components.</span>
<a name="l00526"></a>00526           <span class="comment">// MAY NEED TO USE PARTIAL PIVOTING!</span>
<a name="l00527"></a>00527           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00528"></a>00528               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>)
<a name="l00529"></a>00529             {
<a name="l00530"></a>00530               Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(F, Pu_h);
<a name="l00531"></a>00531             }
<a name="l00532"></a>00532           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00533"></a>00533                    <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00534"></a>00534                    <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00535"></a>00535                    <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00536"></a>00536             {
<a name="l00537"></a>00537               Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a> (Fx, Pu_x_h);
<a name="l00538"></a>00538 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00539"></a>00539 <span class="preprocessor"></span>              Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a> (Fy, Pu_y_h);
<a name="l00540"></a>00540 <span class="preprocessor">#endif</span>
<a name="l00541"></a>00541 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00542"></a>00542 <span class="preprocessor"></span>              Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a> (Fz, Pu_z_h);
<a name="l00543"></a>00543 <span class="preprocessor">#endif</span>
<a name="l00544"></a>00544 <span class="preprocessor"></span>            }
<a name="l00545"></a>00545           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a>)
<a name="l00546"></a>00546             {
<a name="l00547"></a>00547               Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a> (Fx, Pu_x_h); 
<a name="l00548"></a>00548             }
<a name="l00549"></a>00549           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a>)
<a name="l00550"></a>00550             {
<a name="l00551"></a>00551               Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a> (Fy, Pu_y_h); 
<a name="l00552"></a>00552             }     
<a name="l00553"></a>00553           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a>)
<a name="l00554"></a>00554             {
<a name="l00555"></a>00555               Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a> (Fz, Pu_z_h); 
<a name="l00556"></a>00556             }             
<a name="l00557"></a>00557 
<a name="l00558"></a>00558 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00559"></a>00559 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00560"></a>00560               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00561"></a>00561             {
<a name="l00562"></a>00562               Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(Fxy, Pu_xy_h);
<a name="l00563"></a>00563 <span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00564"></a>00564 <span class="preprocessor"></span>              Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(Fxz, Pu_xz_h);
<a name="l00565"></a>00565               Kp.<a class="code" href="classlibMesh_1_1DenseMatrix.php#a878b9bf0a49000c70acecd55fdcf8d74">lu_solve</a>(Fyz, Pu_yz_h);
<a name="l00566"></a>00566 <span class="preprocessor">#endif</span>
<a name="l00567"></a>00567 <span class="preprocessor"></span>            }
<a name="l00568"></a>00568 <span class="preprocessor">#endif</span>
<a name="l00569"></a>00569 <span class="preprocessor"></span>          
<a name="l00570"></a>00570           <span class="comment">//--------------------------------------------------</span>
<a name="l00571"></a>00571           <span class="comment">// Finally, estimate the error in the current variable</span>
<a name="l00572"></a>00572           <span class="comment">// for the current element by computing ||P u_h - u_h|| or ||P grad_u_h - grad_u_h||</span>
<a name="l00573"></a>00573           <span class="comment">// or ||P hess_u_h - hess_u_h|| according to the requested</span>
<a name="l00574"></a>00574           <span class="comment">// seminorm</span>
<a name="l00575"></a>00575 
<a name="l00576"></a>00576           dof_map.<a class="code" href="classlibMesh_1_1DofMap.php#a5dac22ba99a9da3563c00b7dfd2f07af">dof_indices</a> (elem, dof_indices, var);
<a name="l00577"></a>00577           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_dofs = dof_indices.size();
<a name="l00578"></a>00578           
<a name="l00579"></a>00579           <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> element_error = 0;
<a name="l00580"></a>00580 
<a name="l00581"></a>00581           <span class="comment">// we approximate the max norm by sampling over a set of points</span>
<a name="l00582"></a>00582           <span class="comment">// in future we may add specialized routines for specific cases</span>
<a name="l00583"></a>00583           <span class="comment">// or use some optimization package</span>
<a name="l00584"></a>00584           <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> qorder = element_order;
<a name="l00585"></a>00585 
<a name="l00586"></a>00586           <span class="comment">// build a &quot;fake&quot; quadrature rule for the element</span>
<a name="l00587"></a>00587           <span class="comment">//</span>
<a name="l00588"></a>00588           <span class="comment">// For linear elements, grad is a constant, so we need</span>
<a name="l00589"></a>00589           <span class="comment">// to compute grad u_h once on the element.  Also as G_H</span>
<a name="l00590"></a>00590           <span class="comment">// u_h - gradu_h is linear on an element, it assumes its</span>
<a name="l00591"></a>00591           <span class="comment">// maximum at a vertex of the element</span>
<a name="l00592"></a>00592 
<a name="l00593"></a>00593           <a class="code" href="classlibMesh_1_1QGrid.php">QGrid</a> samprule (dim, qorder);
<a name="l00594"></a>00594 
<a name="l00595"></a>00595           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00596"></a>00596               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00597"></a>00597             fe-&gt;attach_quadrature_rule (&amp;samprule);
<a name="l00598"></a>00598 
<a name="l00599"></a>00599           <span class="comment">// reinitialize element for integration or sampling</span>
<a name="l00600"></a>00600           fe-&gt;reinit(elem);
<a name="l00601"></a>00601               
<a name="l00602"></a>00602           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sp = JxW.size();
<a name="l00603"></a>00603           <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> sp=0; sp&lt; n_sp; sp++)
<a name="l00604"></a>00604             {
<a name="l00605"></a>00605               std::vector&lt;Number&gt; temperr(6,0.0); <span class="comment">// x,y,z or xx,yy,zz,xy,xz,yz</span>
<a name="l00606"></a>00606           
<a name="l00607"></a>00607               <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00608"></a>00608                   <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>)
<a name="l00609"></a>00609                 {
<a name="l00610"></a>00610                   <span class="comment">// Compute the value at the current sample point</span>
<a name="l00611"></a>00611                   <a class="code" href="namespacelibMesh.php#a8b17bf24a15bc292850c3a3894e2e8f9">Number</a> u_h = <a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">libMesh::zero</a>;
<a name="l00612"></a>00612           
<a name="l00613"></a>00613                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00614"></a>00614                     u_h += (*phi)[i][sp]*<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a> (dof_indices[i]);
<a name="l00615"></a>00615 
<a name="l00616"></a>00616                   <span class="comment">// Compute the phi values at the current sample point</span>
<a name="l00617"></a>00617                   std::vector&lt;Real&gt; psi(<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">specpoly</a>(dim, element_order, q_point[sp], matsize));
<a name="l00618"></a>00618                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;matsize; i++)
<a name="l00619"></a>00619                     {
<a name="l00620"></a>00620                       temperr[0] += psi[i]*Pu_h(i);
<a name="l00621"></a>00621                     }
<a name="l00622"></a>00622                   temperr[0] -= u_h;
<a name="l00623"></a>00623                 }             
<a name="l00624"></a>00624               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00625"></a>00625                        <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>)
<a name="l00626"></a>00626                 {
<a name="l00627"></a>00627                   <span class="comment">// Compute the gradient at the current sample point</span>
<a name="l00628"></a>00628                   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00629"></a>00629           
<a name="l00630"></a>00630                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00631"></a>00631                     grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> ((*dphi)[i][sp],
<a name="l00632"></a>00632                                          <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00633"></a>00633                   <span class="comment">// Compute the phi values at the current sample point</span>
<a name="l00634"></a>00634                   std::vector&lt;Real&gt; psi(<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">specpoly</a>(dim, element_order, q_point[sp], matsize));
<a name="l00635"></a>00635                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;matsize; i++)
<a name="l00636"></a>00636                     {
<a name="l00637"></a>00637                       temperr[0] += psi[i]*Pu_x_h(i);
<a name="l00638"></a>00638 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00639"></a>00639 <span class="preprocessor"></span>                      temperr[1] += psi[i]*Pu_y_h(i);
<a name="l00640"></a>00640 <span class="preprocessor">#endif</span>
<a name="l00641"></a>00641 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00642"></a>00642 <span class="preprocessor"></span>                      temperr[2] += psi[i]*Pu_z_h(i);
<a name="l00643"></a>00643 <span class="preprocessor">#endif</span>
<a name="l00644"></a>00644 <span class="preprocessor"></span>                    }
<a name="l00645"></a>00645                   temperr[0] -= grad_u_h(0);
<a name="l00646"></a>00646 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00647"></a>00647 <span class="preprocessor"></span>                  temperr[1] -= grad_u_h(1);
<a name="l00648"></a>00648 <span class="preprocessor">#endif</span>
<a name="l00649"></a>00649 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00650"></a>00650 <span class="preprocessor"></span>                  temperr[2] -= grad_u_h(2);
<a name="l00651"></a>00651 <span class="preprocessor">#endif</span>
<a name="l00652"></a>00652 <span class="preprocessor"></span>                }
<a name="l00653"></a>00653               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a>)
<a name="l00654"></a>00654                 {
<a name="l00655"></a>00655                   <span class="comment">// Compute the gradient at the current sample point</span>
<a name="l00656"></a>00656                   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00657"></a>00657           
<a name="l00658"></a>00658                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00659"></a>00659                     grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> ((*dphi)[i][sp],
<a name="l00660"></a>00660                                          <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00661"></a>00661                   <span class="comment">// Compute the phi values at the current sample point</span>
<a name="l00662"></a>00662                   std::vector&lt;Real&gt; psi(<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">specpoly</a>(dim, element_order, q_point[sp], matsize));
<a name="l00663"></a>00663                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;matsize; i++)
<a name="l00664"></a>00664                     {
<a name="l00665"></a>00665                       temperr[0] += psi[i]*Pu_x_h(i);                 
<a name="l00666"></a>00666                     }
<a name="l00667"></a>00667                   temperr[0] -= grad_u_h(0);
<a name="l00668"></a>00668                 }
<a name="l00669"></a>00669               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a>)
<a name="l00670"></a>00670                 {
<a name="l00671"></a>00671                   <span class="comment">// Compute the gradient at the current sample point</span>
<a name="l00672"></a>00672                   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00673"></a>00673           
<a name="l00674"></a>00674                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00675"></a>00675                     grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> ((*dphi)[i][sp],
<a name="l00676"></a>00676                                          <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00677"></a>00677                   <span class="comment">// Compute the phi values at the current sample point</span>
<a name="l00678"></a>00678                   std::vector&lt;Real&gt; psi(<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">specpoly</a>(dim, element_order, q_point[sp], matsize));
<a name="l00679"></a>00679                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;matsize; i++)
<a name="l00680"></a>00680                     {
<a name="l00681"></a>00681                       temperr[1] += psi[i]*Pu_y_h(i);          
<a name="l00682"></a>00682                     }       
<a name="l00683"></a>00683                   temperr[1] -= grad_u_h(1);              
<a name="l00684"></a>00684                 }
<a name="l00685"></a>00685               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a>)
<a name="l00686"></a>00686                 {
<a name="l00687"></a>00687                   <span class="comment">// Compute the gradient at the current sample point</span>
<a name="l00688"></a>00688                   <a class="code" href="classlibMesh_1_1VectorValue.php">Gradient</a> grad_u_h;
<a name="l00689"></a>00689           
<a name="l00690"></a>00690                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00691"></a>00691                     grad_u_h.<a class="code" href="classlibMesh_1_1TypeVector.php#aaf2f65f39d9cdb06500baa2d571dc27f">add_scaled</a> ((*dphi)[i][sp],
<a name="l00692"></a>00692                                          <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00693"></a>00693                   <span class="comment">// Compute the phi values at the current sample point</span>
<a name="l00694"></a>00694                   std::vector&lt;Real&gt; psi(<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">specpoly</a>(dim, element_order, q_point[sp], matsize));
<a name="l00695"></a>00695                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;matsize; i++)
<a name="l00696"></a>00696                     {
<a name="l00697"></a>00697                       temperr[2] += psi[i]*Pu_z_h(i);
<a name="l00698"></a>00698                     }             
<a name="l00699"></a>00699                   temperr[2] -= grad_u_h(2);
<a name="l00700"></a>00700                 }              
<a name="l00701"></a>00701               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a> ||
<a name="l00702"></a>00702                        <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00703"></a>00703                 {
<a name="l00704"></a>00704 <span class="preprocessor">#ifdef LIBMESH_ENABLE_SECOND_DERIVATIVES</span>
<a name="l00705"></a>00705 <span class="preprocessor"></span>                  <span class="comment">// Compute the Hessian at the current sample point</span>
<a name="l00706"></a>00706                   <a class="code" href="classlibMesh_1_1TensorValue.php">Tensor</a> hess_u_h;
<a name="l00707"></a>00707           
<a name="l00708"></a>00708                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_dofs; i++)
<a name="l00709"></a>00709                     hess_u_h.<a class="code" href="classlibMesh_1_1TypeTensor.php#adae55fa841255b47d85a5baf7a352ff6">add_scaled</a> ((*d2phi)[i][sp],
<a name="l00710"></a>00710                                          <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>.<a class="code" href="classlibMesh_1_1System.php#adad8bac609ebbd85b0c6aaafb8d3371e">current_solution</a>(dof_indices[i]));
<a name="l00711"></a>00711                   <span class="comment">// Compute the phi values at the current sample point</span>
<a name="l00712"></a>00712                   std::vector&lt;Real&gt; psi(<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">specpoly</a>(dim, element_order, q_point[sp], matsize));
<a name="l00713"></a>00713                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;matsize; i++)
<a name="l00714"></a>00714                     {
<a name="l00715"></a>00715                       temperr[0] += psi[i]*Pu_x_h(i);
<a name="l00716"></a>00716 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00717"></a>00717 <span class="preprocessor"></span>                      temperr[1] += psi[i]*Pu_y_h(i);
<a name="l00718"></a>00718                       temperr[3] += psi[i]*Pu_xy_h(i);
<a name="l00719"></a>00719 <span class="preprocessor">#endif</span>
<a name="l00720"></a>00720 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00721"></a>00721 <span class="preprocessor"></span>                      temperr[2] += psi[i]*Pu_z_h(i);
<a name="l00722"></a>00722                       temperr[4] += psi[i]*Pu_xz_h(i);
<a name="l00723"></a>00723                       temperr[5] += psi[i]*Pu_yz_h(i);
<a name="l00724"></a>00724 <span class="preprocessor">#endif</span>
<a name="l00725"></a>00725 <span class="preprocessor"></span>                    }
<a name="l00726"></a>00726                   temperr[0] -= hess_u_h(0,0);
<a name="l00727"></a>00727 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00728"></a>00728 <span class="preprocessor"></span>                  temperr[1] -= hess_u_h(1,1);
<a name="l00729"></a>00729                   temperr[3] -= hess_u_h(0,1);
<a name="l00730"></a>00730 <span class="preprocessor">#endif</span>
<a name="l00731"></a>00731 <span class="preprocessor"></span><span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00732"></a>00732 <span class="preprocessor"></span>                  temperr[2] -= hess_u_h(2,2);
<a name="l00733"></a>00733                   temperr[4] -= hess_u_h(0,2);
<a name="l00734"></a>00734                   temperr[5] -= hess_u_h(1,2);
<a name="l00735"></a>00735 <span class="preprocessor">#endif</span>
<a name="l00736"></a>00736 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00737"></a>00737 <span class="preprocessor"></span>                      <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR:  --enable-second-derivatives is required\n&quot;</span>
<a name="l00738"></a>00738                                     &lt;&lt; <span class="stringliteral">&quot;        for _sobolev_order == 2!\n&quot;</span>;
<a name="l00739"></a>00739                       libmesh_error();
<a name="l00740"></a>00740 <span class="preprocessor">#endif</span>
<a name="l00741"></a>00741 <span class="preprocessor"></span>                }
<a name="l00742"></a>00742 
<a name="l00743"></a>00743               <span class="comment">// Add up relevant terms.  We can easily optimize the</span>
<a name="l00744"></a>00744               <span class="comment">// LIBMESH_DIM &lt; 3 cases a little bit with the exception</span>
<a name="l00745"></a>00745               <span class="comment">// of the W2 cases</span>
<a name="l00746"></a>00746 
<a name="l00747"></a>00747               <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a>)
<a name="l00748"></a>00748                 element_error = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(element_error, std::abs(temperr[0]));
<a name="l00749"></a>00749               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a>)
<a name="l00750"></a>00750                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != LIBMESH_DIM; ++i)
<a name="l00751"></a>00751                   element_error = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(element_error, std::abs(temperr[i]));
<a name="l00752"></a>00752               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00753"></a>00753                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != 6; ++i)
<a name="l00754"></a>00754                   element_error = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(element_error, std::abs(temperr[i]));
<a name="l00755"></a>00755               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a>)
<a name="l00756"></a>00756                 element_error += JxW[sp]*<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(temperr[0]);
<a name="l00757"></a>00757               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>)
<a name="l00758"></a>00758                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != LIBMESH_DIM; ++i)
<a name="l00759"></a>00759                   element_error += JxW[sp]*<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(temperr[i]);
<a name="l00760"></a>00760               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a>)
<a name="l00761"></a>00761                 element_error += JxW[sp]*<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(temperr[0]);
<a name="l00762"></a>00762               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a>)
<a name="l00763"></a>00763                 element_error += JxW[sp]*<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(temperr[1]);
<a name="l00764"></a>00764               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a>)
<a name="l00765"></a>00765                 element_error += JxW[sp]*<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(temperr[2]);
<a name="l00766"></a>00766               <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00767"></a>00767                 {
<a name="l00768"></a>00768                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != LIBMESH_DIM; ++i)
<a name="l00769"></a>00769                     element_error += JxW[sp]*<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(temperr[i]);
<a name="l00770"></a>00770                 <span class="comment">// Off diagonal terms enter into the Hessian norm twice</span>
<a name="l00771"></a>00771                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=3; i != 6; ++i)
<a name="l00772"></a>00772                     element_error += JxW[sp]*2*<a class="code" href="namespacelibMesh.php#a1ccf1226fe7f6e1611259752ff1ee29e">libmesh_norm</a>(temperr[i]);
<a name="l00773"></a>00773                 }
<a name="l00774"></a>00774 
<a name="l00775"></a>00775             } <span class="comment">// end sample_point_loop</span>
<a name="l00776"></a>00776 
<a name="l00777"></a>00777           <span class="comment">// The patch error estimator works element-by-element --</span>
<a name="l00778"></a>00778           <span class="comment">// there is no need to get a mutex on error_per_cell!</span>
<a name="l00779"></a>00779           <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aca29cedfeb6d15e888ac0c1c31d5ce21">L_INF</a> ||
<a name="l00780"></a>00780               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a4b61e006ed8d92ee72c5b9f15b812357">W1_INF_SEMINORM</a> ||
<a name="l00781"></a>00781               <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ad02dfe2efa80354e38555ad2e5a206d6">W2_INF_SEMINORM</a>)
<a name="l00782"></a>00782             <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a54307aeb42ae0a688db9b13bbb456256">error_per_cell</a>[e_id] += <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#ac8a59940264314511d0e4f253433e76b">weight</a>(var) * element_error;       
<a name="l00783"></a>00783           <span class="keywordflow">else</span> <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00784"></a>00784                    <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00785"></a>00785                    <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a> ||
<a name="l00786"></a>00786                    <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a> ||
<a name="l00787"></a>00787                    <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a> ||
<a name="l00788"></a>00788                    <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(var) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00789"></a>00789             <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a54307aeb42ae0a688db9b13bbb456256">error_per_cell</a>[e_id] += <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a6c84f8dbb0f519c5abef6a47ee0a4f23">weight_sq</a>(var) * element_error;    
<a name="l00790"></a>00790           <span class="keywordflow">else</span>
<a name="l00791"></a>00791             libmesh_error();
<a name="l00792"></a>00792         } <span class="comment">// end variable loop  </span>
<a name="l00793"></a>00793 
<a name="l00794"></a>00794       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(0) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a81428a949c80fd4e4178fe53fa94ce92">L2</a> ||
<a name="l00795"></a>00795           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(0) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a> ||
<a name="l00796"></a>00796           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(0) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a119d78d3ba8a644c87902e6e110849c7">H1_X_SEMINORM</a> ||
<a name="l00797"></a>00797           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(0) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098ab757e9d16bfdbf6f0a17f1a411d2f09a">H1_Y_SEMINORM</a> ||
<a name="l00798"></a>00798           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(0) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a1618470bdd0c77fb352e18567dcbd72c">H1_Z_SEMINORM</a> ||
<a name="l00799"></a>00799           <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>.<a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a>.<a class="code" href="classlibMesh_1_1SystemNorm.php#a3cb7cd59d6684a3d7da0fa75f50be005">type</a>(0) == <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098a517739ce55228741cc19623e06670f23">H2_SEMINORM</a>)
<a name="l00800"></a>00800         <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a54307aeb42ae0a688db9b13bbb456256">error_per_cell</a>[e_id] = std::sqrt(<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a54307aeb42ae0a688db9b13bbb456256">error_per_cell</a>[e_id]);
<a name="l00801"></a>00801 
<a name="l00802"></a>00802     } <span class="comment">// end element loop</span>
<a name="l00803"></a>00803 }
<a name="l00804"></a>00804 
<a name="l00805"></a>00805 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
