<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3734f8fafd73a2969ee8ed4a34620869.php">error_estimation</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">patch_recovery_error_estimator.h</div>  </div>
</div>
<div class="contents">
<a href="patch__recovery__error__estimator_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: patch_recovery_error_estimator.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __patch_recovery_error_estimator_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __patch_recovery_error_estimator_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local Includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="error__estimator_8h.php">error_estimator.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="enum__order_8h.php">enum_order.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="patch_8h.php">patch.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="elem__range_8h.php">elem_range.h</a>&quot;</span>
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 <span class="keyword">namespace </span>libMesh
<a name="l00036"></a>00036 {
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">// Forward Declarations</span>
<a name="l00039"></a>00039 <span class="keyword">class </span>Elem;
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php">00048</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ErrorEstimator.php">ErrorEstimator</a>
<a name="l00049"></a>00049 {
<a name="l00050"></a>00050 <span class="keyword">public</span>:
<a name="l00051"></a>00051 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a65f65c6159aac8112488bed815779091">00057</a>   <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a65f65c6159aac8112488bed815779091">PatchRecoveryErrorEstimator</a>() :
<a name="l00058"></a>00058     <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a180843e3c0d3993cb1dcce3e86509d73">target_patch_size</a>(20),
<a name="l00059"></a>00059     <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a3f28c0ae0ded6264c53bcaa2c5483c89">patch_growth_strategy</a>(&amp;<a class="code" href="classlibMesh_1_1Patch.php">Patch</a>::add_local_face_neighbors) 
<a name="l00060"></a>00060   { <a class="code" href="classlibMesh_1_1ErrorEstimator.php#a9d626496b0b6f99f679c4ef4f0a5e46e">error_norm</a> = <a class="code" href="namespacelibMeshEnums.php#a4448492d578e5ad9c23eddd1518a0098aa9c1ddb21411ca64e2d3a671c7d1eedd">H1_SEMINORM</a>; }
<a name="l00061"></a>00061   
<a name="l00065"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#aaaa1c08ed987d71c9c2880e8358cf3ce">00065</a>   <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#aaaa1c08ed987d71c9c2880e8358cf3ce">~PatchRecoveryErrorEstimator</a>() {}
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a49b17c22f18578866ebb751b1d28852c">estimate_error</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; system,
<a name="l00075"></a>00075                                <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; error_per_cell,
<a name="l00076"></a>00076                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;Number&gt;</a>* solution_vector = NULL,
<a name="l00077"></a>00077                                <span class="keywordtype">bool</span> estimate_parent_error = <span class="keyword">false</span>);
<a name="l00078"></a>00078 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a180843e3c0d3993cb1dcce3e86509d73">00083</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a180843e3c0d3993cb1dcce3e86509d73">target_patch_size</a>;
<a name="l00084"></a>00084 
<a name="l00091"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a3f28c0ae0ded6264c53bcaa2c5483c89">00091</a>   <a class="code" href="classlibMesh_1_1Patch.php#a2223898c123f750a1e66a8d75d72a89c">Patch::PMF</a> <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a3f28c0ae0ded6264c53bcaa2c5483c89">patch_growth_strategy</a>;
<a name="l00092"></a>00092 
<a name="l00093"></a>00093 <span class="keyword">private</span>:
<a name="l00094"></a>00094 
<a name="l00099"></a>00099   <span class="keyword">static</span> std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#a1f3f6cd248e2043a44ed52f42f6e9bce">specpoly</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> dim,
<a name="l00100"></a>00100                                     <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> order,
<a name="l00101"></a>00101                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> p,
<a name="l00102"></a>00102                                     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> matsize);
<a name="l00103"></a>00103 
<a name="l00108"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php">00108</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php">EstimateError</a>
<a name="l00109"></a>00109   {
<a name="l00110"></a>00110   <span class="keyword">public</span>:
<a name="l00111"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a9921cd23e5dfe9bd3fd1d94c7895cd18">00111</a>     <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a9921cd23e5dfe9bd3fd1d94c7895cd18">EstimateError</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys,
<a name="l00112"></a>00112                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a> &amp;ee,
<a name="l00113"></a>00113                    <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a>&amp; epc) :
<a name="l00114"></a>00114       <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>(sys),
<a name="l00115"></a>00115       <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>(ee),
<a name="l00116"></a>00116       <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a54307aeb42ae0a688db9b13bbb456256">error_per_cell</a>(epc)
<a name="l00117"></a>00117     {}
<a name="l00118"></a>00118 
<a name="l00119"></a>00119     <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#af0759b6a9c3d10483c71ac6d5cd6440f">operator()</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1StoredRange.php">ConstElemRange</a> &amp;range) <span class="keyword">const</span>;
<a name="l00120"></a>00120     
<a name="l00121"></a>00121   <span class="keyword">private</span>:
<a name="l00122"></a>00122 
<a name="l00123"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">00123</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2210084fb804006ce66bdcdb9a5f7cb0">system</a>;
<a name="l00124"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">00124</a>     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php">PatchRecoveryErrorEstimator</a> &amp;<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a2fff2eaa3cb7736565b7da3fa8863a8e">error_estimator</a>;
<a name="l00125"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a54307aeb42ae0a688db9b13bbb456256">00125</a>     <a class="code" href="classlibMesh_1_1ErrorVector.php">ErrorVector</a> &amp;<a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php#a54307aeb42ae0a688db9b13bbb456256">error_per_cell</a>;    
<a name="l00126"></a>00126   };
<a name="l00127"></a>00127 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator.php#aa6f9e02d634611633027410694b95781">00128</a>   <span class="keyword">friend</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PatchRecoveryErrorEstimator_1_1EstimateError.php">EstimateError</a>;
<a name="l00129"></a>00129 };
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 
<a name="l00132"></a>00132 } <span class="comment">// namespace libMesh</span>
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 <span class="preprocessor">#endif // #define __patch_recovery_error_estimator_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
