<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">perf_log.C</div>  </div>
</div>
<div class="contents">
<a href="perf__log_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: perf_log.C 3884 2010-07-27 21:25:16Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &lt;iomanip&gt;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;ctime&gt;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;unistd.h&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;sys/utsname.h&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sys/types.h&gt;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;pwd.h&gt;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="perf__log_8h.php">perf_log.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="timestamp_8h.php">timestamp.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// PerfLog class member funcions</span>
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PerfLog.php#aee181cf8480820db002d91e1ad3a83f0">PerfLog::called</a> = <span class="keyword">false</span>;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a263d9ec19829bf1361e6f9e07049ce5b">00046</a> <a class="code" href="classlibMesh_1_1PerfLog.php#a263d9ec19829bf1361e6f9e07049ce5b">PerfLog::PerfLog</a>(<span class="keyword">const</span> std::string&amp; ln,
<a name="l00047"></a>00047                  <span class="keyword">const</span> <span class="keywordtype">bool</span> le) :
<a name="l00048"></a>00048   label_name(ln),
<a name="l00049"></a>00049   log_events(le),
<a name="l00050"></a>00050   total_time(0.)
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>)
<a name="l00053"></a>00053     this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#a3d3d2147ad6667552663be7befdd35e1">clear</a>();
<a name="l00054"></a>00054 }
<a name="l00055"></a>00055 
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a8d75ec0e1a217f90be39d0132c0938dd">00058</a> <a class="code" href="classlibMesh_1_1PerfLog.php#a8d75ec0e1a217f90be39d0132c0938dd">PerfLog::~PerfLog</a>()
<a name="l00059"></a>00059 {
<a name="l00060"></a>00060   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>)
<a name="l00061"></a>00061     this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#a77310cc500de193b6172d92a5ddbf95d">print_log</a>();
<a name="l00062"></a>00062 }
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a3d3d2147ad6667552663be7befdd35e1">00066</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a3d3d2147ad6667552663be7befdd35e1">PerfLog::clear</a>()
<a name="l00067"></a>00067 {
<a name="l00068"></a>00068   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>)
<a name="l00069"></a>00069     {
<a name="l00070"></a>00070       <span class="comment">//  check that all events are closed</span>
<a name="l00071"></a>00071       <span class="keywordflow">for</span> (std::map&lt;std::pair&lt;std::string,std::string&gt;, <a class="code" href="classlibMesh_1_1PerfData.php">PerfData</a>&gt;::<a class="code" href="classstd_1_1iterator.php">iterator</a>
<a name="l00072"></a>00072              pos = <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.begin(); pos != <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.end(); ++pos)
<a name="l00073"></a>00073         <span class="keywordflow">if</span> (pos-&gt;second.open)
<a name="l00074"></a>00074           {
<a name="l00075"></a>00075             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>
<a name="l00076"></a>00076               &lt;&lt; <span class="stringliteral">&quot;ERROR clearning performance log for class &quot;</span>
<a name="l00077"></a>00077               &lt;&lt; <a class="code" href="classlibMesh_1_1PerfLog.php#abf62278a809f704951c95151158300a0">label_name</a> &lt;&lt; std::endl
<a name="l00078"></a>00078               &lt;&lt; <span class="stringliteral">&quot;event &quot;</span> &lt;&lt; pos-&gt;first.second &lt;&lt; <span class="stringliteral">&quot; is still being monitored!&quot;</span>
<a name="l00079"></a>00079               &lt;&lt; std::endl;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081             libmesh_error();
<a name="l00082"></a>00082           }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084       
<a name="l00085"></a>00085       gettimeofday (&amp;<a class="code" href="classlibMesh_1_1PerfLog.php#a809ef5f49c9c2df645b44ec61a92d471">tstart</a>, NULL);
<a name="l00086"></a>00086   
<a name="l00087"></a>00087       <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.clear();
<a name="l00088"></a>00088 
<a name="l00089"></a>00089       <span class="keywordflow">while</span> (!<a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.empty())
<a name="l00090"></a>00090         <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.pop();
<a name="l00091"></a>00091     }
<a name="l00092"></a>00092 }
<a name="l00093"></a>00093 
<a name="l00094"></a>00094 
<a name="l00095"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a8f7e636b403bf8ae3a059b47e4e714c8">00095</a> std::string <a class="code" href="classlibMesh_1_1PerfLog.php#a8f7e636b403bf8ae3a059b47e4e714c8">PerfLog::get_info_header</a>()<span class="keyword"> const</span>
<a name="l00096"></a>00096 <span class="keyword"></span>{
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l00098"></a>00098   
<a name="l00099"></a>00099   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>)
<a name="l00100"></a>00100     {
<a name="l00101"></a>00101       std::string date = <a class="code" href="namespacelibMesh_1_1Utility.php#a0e4485920eb5de9a47b6f8760a11361d">Utility::get_timestamp</a>();
<a name="l00102"></a>00102       
<a name="l00103"></a>00103       <span class="comment">// Get system information</span>
<a name="l00104"></a>00104       <span class="keyword">struct </span>utsname sysInfo;
<a name="l00105"></a>00105       uname(&amp;sysInfo);
<a name="l00106"></a>00106       
<a name="l00107"></a>00107       <span class="comment">// Get user information</span>
<a name="l00108"></a>00108       <span class="comment">//</span>
<a name="l00109"></a>00109       <span class="comment">// Some systems, for example Crays, actually have getpwuid on the head-node</span>
<a name="l00110"></a>00110       <span class="comment">// but (if I understand correctly) a dynamically-linked glibc is not available</span>
<a name="l00111"></a>00111       <span class="comment">// on the backend, which is running a reduced operating system like Compute</span>
<a name="l00112"></a>00112       <span class="comment">// Node Linux.  Thus functions like getpwuid cannot be called.  This makes</span>
<a name="l00113"></a>00113       <span class="comment">// automatically testing for the existence of getpwuid on the login node</span>
<a name="l00114"></a>00114       <span class="comment">// difficult.  The configure test would work on the login node but will fail</span>
<a name="l00115"></a>00115       <span class="comment">// on the backend.  Hence we have added a configure flag, --disable-getpwuid,</span>
<a name="l00116"></a>00116       <span class="comment">// to manually turn this off.</span>
<a name="l00117"></a>00117 <span class="preprocessor">#ifdef LIBMESH_HAVE_GETPWUID</span>
<a name="l00118"></a>00118 <span class="preprocessor"></span>      <span class="keyword">struct </span>passwd* p = getpwuid(getuid());
<a name="l00119"></a>00119 <span class="preprocessor">#endif</span>
<a name="l00120"></a>00120 <span class="preprocessor"></span>      out &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span>;
<a name="l00121"></a>00121 
<a name="l00122"></a>00122       <span class="comment">// Construct string stream objects for each of the outputs</span>
<a name="l00123"></a>00123       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> pid_stream;
<a name="l00124"></a>00124       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> nprocs_stream;
<a name="l00125"></a>00125       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> time_stream;
<a name="l00126"></a>00126       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> os_stream;
<a name="l00127"></a>00127       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> host_stream;
<a name="l00128"></a>00128       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> osrel_stream;
<a name="l00129"></a>00129       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> osver_stream;
<a name="l00130"></a>00130       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> machine_stream;
<a name="l00131"></a>00131       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> user_stream;
<a name="l00132"></a>00132       <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> config_stream;
<a name="l00133"></a>00133       
<a name="l00134"></a>00134 
<a name="l00135"></a>00135       <span class="comment">// Put pointers to these streams in a vector</span>
<a name="l00136"></a>00136       std::vector&lt;OStringStream*&gt; v(10);
<a name="l00137"></a>00137       v[0] = &amp;pid_stream;
<a name="l00138"></a>00138       v[1] = &amp;nprocs_stream;
<a name="l00139"></a>00139       v[2] = &amp;time_stream;
<a name="l00140"></a>00140       v[3] = &amp;os_stream;
<a name="l00141"></a>00141       v[4] = &amp;host_stream;
<a name="l00142"></a>00142       v[5] = &amp;osrel_stream;
<a name="l00143"></a>00143       v[6] = &amp;osver_stream;
<a name="l00144"></a>00144       v[7] = &amp;machine_stream;
<a name="l00145"></a>00145       v[8] = &amp;user_stream;
<a name="l00146"></a>00146       v[9] = &amp;config_stream;
<a name="l00147"></a>00147 
<a name="l00148"></a>00148       <span class="comment">// Fill string stream objects</span>
<a name="l00149"></a>00149       <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() &gt; 1)
<a name="l00150"></a>00150         {
<a name="l00151"></a>00151           pid_stream     &lt;&lt; <span class="stringliteral">&quot;| Processor id:   &quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#a4fe65174e7d095f43acae6801a6f6c7d">libMesh::processor_id</a>(); 
<a name="l00152"></a>00152           nprocs_stream  &lt;&lt; <span class="stringliteral">&quot;| Num Processors: &quot;</span> &lt;&lt; <a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>();
<a name="l00153"></a>00153         }
<a name="l00154"></a>00154       
<a name="l00155"></a>00155       time_stream    &lt;&lt; <span class="stringliteral">&quot;| Time:           &quot;</span> &lt;&lt; date                   ; 
<a name="l00156"></a>00156       os_stream      &lt;&lt; <span class="stringliteral">&quot;| OS:             &quot;</span> &lt;&lt; sysInfo.sysname        ; 
<a name="l00157"></a>00157       host_stream    &lt;&lt; <span class="stringliteral">&quot;| HostName:       &quot;</span> &lt;&lt; sysInfo.nodename       ; 
<a name="l00158"></a>00158       osrel_stream   &lt;&lt; <span class="stringliteral">&quot;| OS Release:     &quot;</span> &lt;&lt; sysInfo.release        ; 
<a name="l00159"></a>00159       osver_stream   &lt;&lt; <span class="stringliteral">&quot;| OS Version:     &quot;</span> &lt;&lt; sysInfo.version        ; 
<a name="l00160"></a>00160       machine_stream &lt;&lt; <span class="stringliteral">&quot;| Machine:        &quot;</span> &lt;&lt; sysInfo.machine        ; 
<a name="l00161"></a>00161 <span class="preprocessor">#ifdef LIBMESH_HAVE_GETPWUID</span>
<a name="l00162"></a>00162 <span class="preprocessor"></span>      user_stream    &lt;&lt; <span class="stringliteral">&quot;| Username:       &quot;</span> &lt;&lt; p-&gt;pw_name             ;
<a name="l00163"></a>00163 <span class="preprocessor">#else</span>
<a name="l00164"></a>00164 <span class="preprocessor"></span>      user_stream    &lt;&lt; <span class="stringliteral">&quot;| Username:       &quot;</span> &lt;&lt; <span class="stringliteral">&quot;Unknown&quot;</span>              ;
<a name="l00165"></a>00165 <span class="preprocessor">#endif</span>
<a name="l00166"></a>00166 <span class="preprocessor"></span>      config_stream  &lt;&lt; <span class="stringliteral">&quot;| Configuration:  &quot;</span> &lt;&lt; LIBMESH_CONFIGURE_INFO;
<a name="l00167"></a>00167       
<a name="l00168"></a>00168       <span class="comment">// Find the longest string, use that to set the line length for formatting.</span>
<a name="l00169"></a>00169       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_length = 0;
<a name="l00170"></a>00170       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); ++i)
<a name="l00171"></a>00171         <span class="keywordflow">if</span> (v[i]-&gt;str().size() &gt; max_length)
<a name="l00172"></a>00172           max_length = v[i]-&gt;str().size();
<a name="l00173"></a>00173       
<a name="l00174"></a>00174       <span class="comment">// Print dashed line</span>
<a name="l00175"></a>00175       this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(max_length+2, <span class="charliteral">&#39;-&#39;</span>, out);
<a name="l00176"></a>00176       out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00177"></a>00177 
<a name="l00178"></a>00178       <span class="comment">// Loop over all the strings and print them out with end-formatting</span>
<a name="l00179"></a>00179       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); ++i)
<a name="l00180"></a>00180         {
<a name="l00181"></a>00181           <span class="keywordflow">if</span> (v[i]-&gt;str().size() &gt; 0)
<a name="l00182"></a>00182             {
<a name="l00183"></a>00183               out &lt;&lt; v[i]-&gt;str();
<a name="l00184"></a>00184               OSSStringright(out, max_length+4 - v[i]-&gt;str().size(), <span class="stringliteral">&quot;|\n&quot;</span>);
<a name="l00185"></a>00185             }
<a name="l00186"></a>00186         }
<a name="l00187"></a>00187 
<a name="l00188"></a>00188       <span class="comment">// Print dashed line</span>
<a name="l00189"></a>00189       this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(max_length+2, <span class="charliteral">&#39;-&#39;</span>, out);
<a name="l00190"></a>00190       out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00191"></a>00191     }
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="keywordflow">return</span> out.str();
<a name="l00194"></a>00194 }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197  
<a name="l00198"></a>00198 
<a name="l00199"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a35b6d94c01b7c0a219df37cf51b41d6d">00199</a> std::string <a class="code" href="classlibMesh_1_1PerfLog.php#a35b6d94c01b7c0a219df37cf51b41d6d">PerfLog::get_perf_info</a>()<span class="keyword"> const</span>
<a name="l00200"></a>00200 <span class="keyword"></span>{
<a name="l00201"></a>00201   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l00202"></a>00202   
<a name="l00203"></a>00203   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a> &amp;&amp; !<a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.empty())
<a name="l00204"></a>00204     {
<a name="l00205"></a>00205       <span class="comment">// Stop timing for this event.</span>
<a name="l00206"></a>00206       <span class="keyword">struct </span>timeval tstop;
<a name="l00207"></a>00207       
<a name="l00208"></a>00208       gettimeofday (&amp;tstop, NULL);
<a name="l00209"></a>00209           
<a name="l00210"></a>00210       <span class="keyword">const</span> <span class="keywordtype">double</span> elapsed_time = (<span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(tstop.tv_sec  - <a class="code" href="classlibMesh_1_1PerfLog.php#a809ef5f49c9c2df645b44ec61a92d471">tstart</a>.tv_sec) +
<a name="l00211"></a>00211                                    static_cast&lt;double&gt;(tstop.tv_usec - <a class="code" href="classlibMesh_1_1PerfLog.php#a809ef5f49c9c2df645b44ec61a92d471">tstart</a>.tv_usec)*1.e-6);
<a name="l00212"></a>00212 
<a name="l00213"></a>00213       <span class="comment">// Figure out the formatting required based on the event names</span>
<a name="l00214"></a>00214       <span class="comment">// Unsigned ints for each of the column widths</span>
<a name="l00215"></a>00215       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> event_col_width            = 30;
<a name="l00216"></a>00216       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ncalls_col_width     = 10;
<a name="l00217"></a>00217       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot_time_col_width   = 12;
<a name="l00218"></a>00218       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> avg_time_col_width   = 12;
<a name="l00219"></a>00219       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> tot_time_incl_sub_col_width   = 12;
<a name="l00220"></a>00220       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> avg_time_incl_sub_col_width   = 12;
<a name="l00221"></a>00221       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pct_active_col_width = 9;
<a name="l00222"></a>00222       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pct_active_incl_sub_col_width = 9;
<a name="l00223"></a>00223       
<a name="l00224"></a>00224       <span class="comment">// Iterator to be used to loop over the map of timed events</span>
<a name="l00225"></a>00225       std::map&lt;std::pair&lt;std::string,std::string&gt;, <a class="code" href="classlibMesh_1_1PerfData.php">PerfData</a>&gt;::const_iterator pos;
<a name="l00226"></a>00226       
<a name="l00227"></a>00227       <span class="comment">// Reset the event column width based on the longest event name plus</span>
<a name="l00228"></a>00228       <span class="comment">// a possible 2-character indentation, plus a space.</span>
<a name="l00229"></a>00229       <span class="keywordflow">for</span> (pos = <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.begin(); pos != <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.end(); ++pos)
<a name="l00230"></a>00230         <span class="keywordflow">if</span> (pos-&gt;first.second.size()+3 &gt; event_col_width)
<a name="l00231"></a>00231           event_col_width = pos-&gt;first.second.size()+3;
<a name="l00232"></a>00232 
<a name="l00233"></a>00233       <span class="comment">// Set the total width of the column</span>
<a name="l00234"></a>00234       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> total_col_width =
<a name="l00235"></a>00235         event_col_width     +
<a name="l00236"></a>00236         ncalls_col_width    +
<a name="l00237"></a>00237         tot_time_col_width  +
<a name="l00238"></a>00238         avg_time_col_width  +
<a name="l00239"></a>00239         tot_time_incl_sub_col_width  +
<a name="l00240"></a>00240         avg_time_incl_sub_col_width  +
<a name="l00241"></a>00241         pct_active_col_width+
<a name="l00242"></a>00242         pct_active_incl_sub_col_width+1;
<a name="l00243"></a>00243 
<a name="l00244"></a>00244       <span class="comment">// Print dashed line</span>
<a name="l00245"></a>00245       out &lt;&lt; <span class="charliteral">&#39; &#39;</span>;
<a name="l00246"></a>00246       this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(total_col_width, <span class="charliteral">&#39;-&#39;</span>, out);
<a name="l00247"></a>00247       out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00248"></a>00248             
<a name="l00249"></a>00249       {
<a name="l00250"></a>00250         <span class="comment">// Construct temporary message string</span>
<a name="l00251"></a>00251         <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> temp;
<a name="l00252"></a>00252         temp &lt;&lt; <span class="stringliteral">&quot;| &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1PerfLog.php#abf62278a809f704951c95151158300a0">label_name</a> &lt;&lt; <span class="stringliteral">&quot; Performance: Alive time=&quot;</span> &lt;&lt; elapsed_time
<a name="l00253"></a>00253              &lt;&lt; <span class="stringliteral">&quot;, Active time=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1PerfLog.php#a2b198f5c72c73b5f21b394f16928f686">total_time</a>;
<a name="l00254"></a>00254 
<a name="l00255"></a>00255         <span class="comment">// Get the size of the temporary string</span>
<a name="l00256"></a>00256         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> temp_size = temp.str().size();
<a name="l00257"></a>00257 
<a name="l00258"></a>00258         <span class="comment">// Send the temporary message to the output</span>
<a name="l00259"></a>00259         out &lt;&lt; temp.str();
<a name="l00260"></a>00260 
<a name="l00261"></a>00261         <span class="comment">// If this string is longer than the previously computed total</span>
<a name="l00262"></a>00262         <span class="comment">// column width, skip the additional formatting... this shouldn&#39;t</span>
<a name="l00263"></a>00263         <span class="comment">// happen often, hopefully.  Add two additional characters for a</span>
<a name="l00264"></a>00264         <span class="comment">// space and a &quot;|&quot; character at the end.</span>
<a name="l00265"></a>00265         <span class="keywordflow">if</span> (temp_size &lt; total_col_width+2)
<a name="l00266"></a>00266           {
<a name="l00267"></a>00267             OSSStringright(out, total_col_width-temp_size+2, <span class="stringliteral">&quot;|&quot;</span>);
<a name="l00268"></a>00268           }
<a name="l00269"></a>00269         
<a name="l00270"></a>00270         out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00271"></a>00271       }
<a name="l00272"></a>00272       
<a name="l00273"></a>00273       <span class="comment">// Print dashed line</span>
<a name="l00274"></a>00274       out &lt;&lt; <span class="charliteral">&#39; &#39;</span>;
<a name="l00275"></a>00275       this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(total_col_width, <span class="charliteral">&#39;-&#39;</span>, out);
<a name="l00276"></a>00276       out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00277"></a>00277 
<a name="l00278"></a>00278       
<a name="l00279"></a>00279       <span class="comment">// Write out the header for the events listing</span>
<a name="l00280"></a>00280       out &lt;&lt; <span class="stringliteral">&quot;| &quot;</span>;
<a name="l00281"></a>00281       OSSStringleft(out,event_col_width,<span class="stringliteral">&quot;Event&quot;</span>);      
<a name="l00282"></a>00282       OSSStringleft(out,ncalls_col_width,<span class="stringliteral">&quot;nCalls&quot;</span>);      
<a name="l00283"></a>00283       OSSStringleft(out,tot_time_col_width,<span class="stringliteral">&quot;Total Time&quot;</span>);
<a name="l00284"></a>00284       OSSStringleft(out,avg_time_col_width,<span class="stringliteral">&quot;Avg Time&quot;</span>);
<a name="l00285"></a>00285       OSSStringleft(out,tot_time_incl_sub_col_width,<span class="stringliteral">&quot;Total Time&quot;</span>);
<a name="l00286"></a>00286       OSSStringleft(out,avg_time_incl_sub_col_width,<span class="stringliteral">&quot;Avg Time&quot;</span>);
<a name="l00287"></a>00287       OSSStringleft(out,pct_active_col_width+pct_active_incl_sub_col_width,<span class="stringliteral">&quot;% of Active Time&quot;</span>);      
<a name="l00288"></a>00288       out &lt;&lt; <span class="stringliteral">&quot;|\n&quot;</span>;      
<a name="l00289"></a>00289       out &lt;&lt; <span class="stringliteral">&quot;| &quot;</span>;
<a name="l00290"></a>00290       OSSStringleft(out,event_col_width,<span class="stringliteral">&quot;&quot;</span>);
<a name="l00291"></a>00291       OSSStringleft(out,ncalls_col_width,<span class="stringliteral">&quot;&quot;</span>);
<a name="l00292"></a>00292       OSSStringleft(out,tot_time_col_width,<span class="stringliteral">&quot;w/o Sub&quot;</span>);
<a name="l00293"></a>00293       OSSStringleft(out,avg_time_col_width,<span class="stringliteral">&quot;w/o Sub&quot;</span>);
<a name="l00294"></a>00294       OSSStringleft(out,tot_time_incl_sub_col_width,<span class="stringliteral">&quot;With Sub&quot;</span>);
<a name="l00295"></a>00295       OSSStringleft(out,avg_time_incl_sub_col_width,<span class="stringliteral">&quot;With Sub&quot;</span>);
<a name="l00296"></a>00296       OSSStringleft(out,pct_active_col_width,<span class="stringliteral">&quot;w/o S&quot;</span>);
<a name="l00297"></a>00297       OSSStringleft(out,pct_active_incl_sub_col_width,<span class="stringliteral">&quot;With S&quot;</span>);
<a name="l00298"></a>00298       
<a name="l00299"></a>00299       out &lt;&lt; <span class="stringliteral">&quot;|\n|&quot;</span>;
<a name="l00300"></a>00300       this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(total_col_width, <span class="charliteral">&#39;-&#39;</span>, out);
<a name="l00301"></a>00301       out &lt;&lt; <span class="stringliteral">&quot;|\n|&quot;</span>;
<a name="l00302"></a>00302       this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(total_col_width, <span class="charliteral">&#39; &#39;</span>, out);
<a name="l00303"></a>00303       out &lt;&lt; <span class="stringliteral">&quot;|\n&quot;</span>;
<a name="l00304"></a>00304       
<a name="l00305"></a>00305       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> summed_function_calls = 0;
<a name="l00306"></a>00306       <span class="keywordtype">double</span>       summed_total_time     = 0;
<a name="l00307"></a>00307       <span class="keywordtype">double</span>       summed_percentage     = 0;
<a name="l00308"></a>00308       
<a name="l00309"></a>00309       std::string last_header(<span class="stringliteral">&quot;&quot;</span>);
<a name="l00310"></a>00310           
<a name="l00311"></a>00311       <span class="keywordflow">for</span> (pos = <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.begin(); pos != <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.end(); ++pos)
<a name="l00312"></a>00312         {
<a name="l00313"></a>00313           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PerfData.php">PerfData</a>&amp; perf_data = pos-&gt;second;
<a name="l00314"></a>00314 
<a name="l00315"></a>00315           <span class="comment">// Only print the event if the count is non-zero.</span>
<a name="l00316"></a>00316           <span class="keywordflow">if</span> (perf_data.<a class="code" href="classlibMesh_1_1PerfData.php#ab8cc3cba8f3b3144895102bfd1420892">count</a> != 0)
<a name="l00317"></a>00317             {
<a name="l00318"></a>00318               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> perf_count    = perf_data.<a class="code" href="classlibMesh_1_1PerfData.php#ab8cc3cba8f3b3144895102bfd1420892">count</a>;
<a name="l00319"></a>00319               <span class="keyword">const</span> <span class="keywordtype">double</span>       perf_time     = perf_data.<a class="code" href="classlibMesh_1_1PerfData.php#ab6742a77b0e3847d1439c26cd2703192">tot_time</a>;
<a name="l00320"></a>00320               <span class="keyword">const</span> <span class="keywordtype">double</span>       perf_avg_time = perf_time / <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(perf_count);
<a name="l00321"></a>00321               <span class="keyword">const</span> <span class="keywordtype">double</span>       perf_time_incl_sub     = perf_data.<a class="code" href="classlibMesh_1_1PerfData.php#a15209bc644699df8252321ab92448fee">tot_time_incl_sub</a>;
<a name="l00322"></a>00322               <span class="keyword">const</span> <span class="keywordtype">double</span>       perf_avg_time_incl_sub = perf_time_incl_sub / <span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(perf_count);
<a name="l00323"></a>00323               <span class="keyword">const</span> <span class="keywordtype">double</span>       perf_percent  = (<a class="code" href="classlibMesh_1_1PerfLog.php#a2b198f5c72c73b5f21b394f16928f686">total_time</a> != 0.) ? perf_time / <a class="code" href="classlibMesh_1_1PerfLog.php#a2b198f5c72c73b5f21b394f16928f686">total_time</a> * 100. : 0.;
<a name="l00324"></a>00324               <span class="keyword">const</span> <span class="keywordtype">double</span>       perf_percent_incl_sub  = (<a class="code" href="classlibMesh_1_1PerfLog.php#a2b198f5c72c73b5f21b394f16928f686">total_time</a> != 0.) ? perf_time_incl_sub / <a class="code" href="classlibMesh_1_1PerfLog.php#a2b198f5c72c73b5f21b394f16928f686">total_time</a> * 100. : 0.;
<a name="l00325"></a>00325 
<a name="l00326"></a>00326               summed_function_calls += perf_count;
<a name="l00327"></a>00327               summed_total_time     += perf_time;
<a name="l00328"></a>00328               summed_percentage     += perf_percent;
<a name="l00329"></a>00329 
<a name="l00330"></a>00330               <span class="comment">// Print the event name</span>
<a name="l00331"></a>00331               <span class="keywordflow">if</span> (pos-&gt;first.first == <span class="stringliteral">&quot;&quot;</span>)
<a name="l00332"></a>00332                 {
<a name="l00333"></a>00333                   out &lt;&lt; <span class="stringliteral">&quot;| &quot;</span>;
<a name="l00334"></a>00334                   OSSStringleft(out,event_col_width,pos-&gt;first.second);
<a name="l00335"></a>00335                 }
<a name="l00336"></a>00336               <span class="keywordflow">else</span>
<a name="l00337"></a>00337                 {
<a name="l00338"></a>00338                   <span class="keywordflow">if</span> (last_header != pos-&gt;first.first)
<a name="l00339"></a>00339                     {
<a name="l00340"></a>00340                       last_header = pos-&gt;first.first;
<a name="l00341"></a>00341 
<a name="l00342"></a>00342                       <span class="comment">// print blank line</span>
<a name="l00343"></a>00343                       out &lt;&lt; <span class="stringliteral">&quot;|&quot;</span>;
<a name="l00344"></a>00344                       this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(total_col_width, <span class="charliteral">&#39; &#39;</span>, out);
<a name="l00345"></a>00345                       out &lt;&lt; <span class="stringliteral">&quot;|\n&quot;</span>;
<a name="l00346"></a>00346 
<a name="l00347"></a>00347                       <span class="comment">// print header name (account for additional space before</span>
<a name="l00348"></a>00348                       <span class="comment">// the header)</span>
<a name="l00349"></a>00349                       out &lt;&lt; <span class="stringliteral">&quot;| &quot;</span>;
<a name="l00350"></a>00350                       OSSStringleft(out, total_col_width-1, pos-&gt;first.first);
<a name="l00351"></a>00351                       out &lt;&lt; <span class="stringliteral">&quot;|\n&quot;</span>;
<a name="l00352"></a>00352                     }
<a name="l00353"></a>00353 
<a name="l00354"></a>00354                   out &lt;&lt; <span class="stringliteral">&quot;|   &quot;</span>;
<a name="l00355"></a>00355                   OSSStringleft(out, event_col_width-2, pos-&gt;first.second);
<a name="l00356"></a>00356                 }
<a name="l00357"></a>00357               
<a name="l00358"></a>00358 
<a name="l00359"></a>00359               <span class="comment">// Print the number of calls to the event.  </span>
<a name="l00360"></a>00360               OSSInt(out,ncalls_col_width,perf_count);
<a name="l00361"></a>00361 
<a name="l00362"></a>00362               <span class="comment">// Print the total time spent in the event</span>
<a name="l00363"></a>00363               out.setf(std::ios::fixed);
<a name="l00364"></a>00364               OSSRealleft(out,tot_time_col_width,4,perf_time);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366               <span class="comment">// Print the average time per function call</span>
<a name="l00367"></a>00367               OSSRealleft(out,avg_time_col_width,6,perf_avg_time);
<a name="l00368"></a>00368 
<a name="l00369"></a>00369               <span class="comment">// Print the total time spent in the event incl. sub-events</span>
<a name="l00370"></a>00370               OSSRealleft(out,tot_time_incl_sub_col_width,4,perf_time_incl_sub);
<a name="l00371"></a>00371 
<a name="l00372"></a>00372               <span class="comment">// Print the average time per function call incl. sub-events</span>
<a name="l00373"></a>00373               OSSRealleft(out,avg_time_incl_sub_col_width,6,perf_avg_time_incl_sub);
<a name="l00374"></a>00374 
<a name="l00375"></a>00375               <span class="comment">// Print the percentage of the time spent in the event</span>
<a name="l00376"></a>00376               OSSRealleft(out,pct_active_col_width,2,perf_percent);
<a name="l00377"></a>00377               
<a name="l00378"></a>00378               <span class="comment">// Print the percentage of the time spent in the event incl. sub-events</span>
<a name="l00379"></a>00379               OSSRealleft(out,pct_active_incl_sub_col_width,2,perf_percent_incl_sub);
<a name="l00380"></a>00380               
<a name="l00381"></a>00381               out &lt;&lt; <span class="stringliteral">&quot;|&quot;</span>;
<a name="l00382"></a>00382               out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00383"></a>00383             }
<a name="l00384"></a>00384         }
<a name="l00385"></a>00385 
<a name="l00386"></a>00386       out &lt;&lt; <span class="charliteral">&#39; &#39;</span>;
<a name="l00387"></a>00387       this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(total_col_width, <span class="charliteral">&#39;-&#39;</span>, out);
<a name="l00388"></a>00388       out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00389"></a>00389       out &lt;&lt; <span class="stringliteral">&quot;| &quot;</span>;
<a name="l00390"></a>00390       OSSStringleft(out,event_col_width,<span class="stringliteral">&quot;Totals:&quot;</span>);
<a name="l00391"></a>00391 
<a name="l00392"></a>00392       <span class="comment">// Print the total number of logged function calls</span>
<a name="l00393"></a>00393       <span class="comment">// For routines which are called many times, summed_function_calls may</span>
<a name="l00394"></a>00394       <span class="comment">// exceed 7 digits.  If this happens use, scientific notation.</span>
<a name="l00395"></a>00395       <span class="keywordflow">if</span> (summed_function_calls &lt; 9999999)
<a name="l00396"></a>00396         {
<a name="l00397"></a>00397           OSSInt(out,ncalls_col_width,summed_function_calls);
<a name="l00398"></a>00398         }
<a name="l00399"></a>00399       
<a name="l00400"></a>00400       <span class="keywordflow">else</span>
<a name="l00401"></a>00401         {
<a name="l00402"></a>00402           out.setf(std::ios::scientific);
<a name="l00403"></a>00403           OSSRealleft(out, ncalls_col_width, 3, static_cast&lt;Real&gt;(summed_function_calls));
<a name="l00404"></a>00404           out.unsetf(std::ios::scientific);
<a name="l00405"></a>00405         }
<a name="l00406"></a>00406         
<a name="l00407"></a>00407       <span class="comment">// Print the total time spent in logged function calls</span>
<a name="l00408"></a>00408       out.setf(std::ios::fixed);
<a name="l00409"></a>00409       OSSRealleft(out,tot_time_col_width,4,summed_total_time);
<a name="l00410"></a>00410 
<a name="l00411"></a>00411       <span class="comment">// Null, the average time doesn&#39;t make sense as a total</span>
<a name="l00412"></a>00412       out.width(avg_time_col_width);
<a name="l00413"></a>00413       out &lt;&lt; <span class="stringliteral">&quot;&quot;</span>;
<a name="l00414"></a>00414 
<a name="l00415"></a>00415       <span class="comment">// Same for times that include sub-events</span>
<a name="l00416"></a>00416       out.width(tot_time_incl_sub_col_width);
<a name="l00417"></a>00417       out &lt;&lt; <span class="stringliteral">&quot;&quot;</span>;
<a name="l00418"></a>00418       out.width(avg_time_incl_sub_col_width);
<a name="l00419"></a>00419       out &lt;&lt; <span class="stringliteral">&quot;&quot;</span>;
<a name="l00420"></a>00420 
<a name="l00421"></a>00421       <span class="comment">// Print the total percentage</span>
<a name="l00422"></a>00422       OSSRealleft(out,pct_active_col_width,2,summed_percentage);
<a name="l00423"></a>00423       
<a name="l00424"></a>00424       out.width(pct_active_incl_sub_col_width);
<a name="l00425"></a>00425       out &lt;&lt; <span class="stringliteral">&quot;&quot;</span>;
<a name="l00426"></a>00426 
<a name="l00427"></a>00427       out &lt;&lt; <span class="stringliteral">&quot;|\n &quot;</span>;
<a name="l00428"></a>00428       this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(total_col_width, <span class="charliteral">&#39;-&#39;</span>, out);
<a name="l00429"></a>00429       out &lt;&lt; <span class="charliteral">&#39;\n&#39;</span>;
<a name="l00430"></a>00430     }
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   <span class="keywordflow">return</span> out.str();
<a name="l00433"></a>00433 }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a10a7a08834a985c382487b02a543d86d">00437</a> std::string <a class="code" href="classlibMesh_1_1PerfLog.php#a10a7a08834a985c382487b02a543d86d">PerfLog::get_log</a>()<span class="keyword"> const</span>
<a name="l00438"></a>00438 <span class="keyword"></span>{
<a name="l00439"></a>00439   <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a> <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>;
<a name="l00440"></a>00440   
<a name="l00441"></a>00441   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>)
<a name="l00442"></a>00442     {
<a name="l00443"></a>00443       <span class="comment">// Only print the log</span>
<a name="l00444"></a>00444       <span class="comment">// if it isn&#39;t empty</span>
<a name="l00445"></a>00445       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.empty())
<a name="l00446"></a>00446         {
<a name="l00447"></a>00447           <span class="comment">// Possibly print machine info,</span>
<a name="l00448"></a>00448           <span class="comment">// but only do this once</span>
<a name="l00449"></a>00449           <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1PerfLog.php#aee181cf8480820db002d91e1ad3a83f0">called</a>)
<a name="l00450"></a>00450             {
<a name="l00451"></a>00451               <a class="code" href="classlibMesh_1_1PerfLog.php#aee181cf8480820db002d91e1ad3a83f0">called</a> = <span class="keyword">true</span>;
<a name="l00452"></a>00452               out &lt;&lt; <a class="code" href="classlibMesh_1_1PerfLog.php#a8f7e636b403bf8ae3a059b47e4e714c8">get_info_header</a>();
<a name="l00453"></a>00453             }     
<a name="l00454"></a>00454           out &lt;&lt; <a class="code" href="classlibMesh_1_1PerfLog.php#a35b6d94c01b7c0a219df37cf51b41d6d">get_perf_info</a>();
<a name="l00455"></a>00455         }
<a name="l00456"></a>00456     }
<a name="l00457"></a>00457   
<a name="l00458"></a>00458   <span class="keywordflow">return</span> out.str();
<a name="l00459"></a>00459 }
<a name="l00460"></a>00460 
<a name="l00461"></a>00461 
<a name="l00462"></a>00462 
<a name="l00463"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a77310cc500de193b6172d92a5ddbf95d">00463</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a77310cc500de193b6172d92a5ddbf95d">PerfLog::print_log</a>()<span class="keyword"> const</span>
<a name="l00464"></a>00464 <span class="keyword"></span>{
<a name="l00465"></a>00465   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>)
<a name="l00466"></a>00466     {
<a name="l00467"></a>00467       <span class="comment">// Check to see if the log_string is empty, and if so,</span>
<a name="l00468"></a>00468       <span class="comment">// avoid printing an unnecessary newline.</span>
<a name="l00469"></a>00469       std::string log_string = this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#a10a7a08834a985c382487b02a543d86d">get_log</a>();
<a name="l00470"></a>00470       <span class="keywordflow">if</span> (log_string.size() &gt; 0)
<a name="l00471"></a>00471         <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; log_string &lt;&lt; std::endl;
<a name="l00472"></a>00472     }
<a name="l00473"></a>00473 }
<a name="l00474"></a>00474 
<a name="l00475"></a>00475 
<a name="l00476"></a>00476 
<a name="l00477"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a123d150c7529ef7000435b9fc344cce6">00477</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a123d150c7529ef7000435b9fc344cce6">PerfLog::start_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00478"></a>00478                           <span class="keyword">const</span> std::string &amp;header)
<a name="l00479"></a>00479 {
<a name="l00480"></a>00480   this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#a81ee696975e5c1f43e501b716fe25b0c">push</a>(label,header);
<a name="l00481"></a>00481 }
<a name="l00482"></a>00482 
<a name="l00483"></a>00483 
<a name="l00484"></a>00484 
<a name="l00485"></a><a class="code" href="classlibMesh_1_1PerfLog.php#ae7441ae7daaa389bf9be41cdc10d89db">00485</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#ae7441ae7daaa389bf9be41cdc10d89db">PerfLog::stop_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00486"></a>00486                          <span class="keyword">const</span> std::string &amp;header)
<a name="l00487"></a>00487 {
<a name="l00488"></a>00488   this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#a8baba3eec226ca4f268564f50d3ca798">pop</a>(label,header);
<a name="l00489"></a>00489 }
<a name="l00490"></a>00490 
<a name="l00491"></a>00491 
<a name="l00492"></a>00492 
<a name="l00493"></a><a class="code" href="classlibMesh_1_1PerfLog.php#ab01fd2638276f8c3c2120b417f4c4ce8">00493</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#ab01fd2638276f8c3c2120b417f4c4ce8">PerfLog::pause_event</a>(<span class="keyword">const</span> std::string &amp;,
<a name="l00494"></a>00494                           <span class="keyword">const</span> std::string &amp;)
<a name="l00495"></a>00495 {  
<a name="l00496"></a>00496   <span class="comment">// nothing to do.  pushing the next object on the stack will handle it</span>
<a name="l00497"></a>00497 }
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 
<a name="l00501"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a5d54a63bbb5b5dd241575ee85511292e">00501</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a5d54a63bbb5b5dd241575ee85511292e">PerfLog::restart_event</a>(<span class="keyword">const</span> std::string &amp;,
<a name="l00502"></a>00502                             <span class="keyword">const</span> std::string &amp;)
<a name="l00503"></a>00503 {
<a name="l00504"></a>00504   <span class="comment">// nothing to do.  popping the top off the stack will handle it.</span>
<a name="l00505"></a>00505 }
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 
<a name="l00508"></a>00508 
<a name="l00509"></a>00509 
<a name="l00510"></a><a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">00510</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">PerfLog::_character_line</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00511"></a>00511                               <span class="keyword">const</span> <span class="keywordtype">char</span> c,
<a name="l00512"></a>00512                               <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a>&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)<span class="keyword"> const</span>
<a name="l00513"></a>00513 <span class="keyword"></span>{
<a name="l00514"></a>00514   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n; ++i)
<a name="l00515"></a>00515     out &lt;&lt; c;
<a name="l00516"></a>00516 }
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
