<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">perf_log.h</div>  </div>
</div>
<div class="contents">
<a href="perf__log_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: perf_log.h 4153 2011-01-11 16:36:50Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __perflog_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __perflog_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// Local includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="o__string__stream_8h.php">o_string_stream.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// C++ includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &lt;stack&gt;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;sys/time.h&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Forward Declarations</span>
<a name="l00040"></a>00040 <span class="comment">// class OStringStream;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00048"></a>00048 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// PerfData class definition</span>
<a name="l00050"></a><a class="code" href="classlibMesh_1_1PerfData.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PerfData.php">PerfData</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052  <span class="keyword">public</span>:
<a name="l00053"></a>00053 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1PerfData.php#ab04b45435d30a4808af1d7578e4891f0">00057</a>   <a class="code" href="classlibMesh_1_1PerfData.php#ab04b45435d30a4808af1d7578e4891f0">PerfData</a> () :
<a name="l00058"></a>00058     <a class="code" href="classlibMesh_1_1PerfData.php#ab6742a77b0e3847d1439c26cd2703192">tot_time</a>(0.),
<a name="l00059"></a>00059     <a class="code" href="classlibMesh_1_1PerfData.php#a15209bc644699df8252321ab92448fee">tot_time_incl_sub</a>(0.),
<a name="l00060"></a>00060     <a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>(),
<a name="l00061"></a>00061     <a class="code" href="classlibMesh_1_1PerfData.php#aaa7b0c10df6c78e6f68702998b147545">tstart_incl_sub</a>(),
<a name="l00062"></a>00062     <a class="code" href="classlibMesh_1_1PerfData.php#ab8cc3cba8f3b3144895102bfd1420892">count</a>(0),
<a name="l00063"></a>00063     <a class="code" href="classlibMesh_1_1PerfData.php#afe045624fad41d012f698dd275c2ed2b">open</a>(false),
<a name="l00064"></a>00064     <a class="code" href="classlibMesh_1_1PerfData.php#a3671b9fa464c61dbbbb96d564a33cfd0">called_recursively</a>(0)
<a name="l00065"></a>00065     {}
<a name="l00066"></a>00066 
<a name="l00067"></a>00067   
<a name="l00071"></a><a class="code" href="classlibMesh_1_1PerfData.php#ab6742a77b0e3847d1439c26cd2703192">00071</a>   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfData.php#ab6742a77b0e3847d1439c26cd2703192">tot_time</a>;
<a name="l00072"></a>00072 
<a name="l00076"></a><a class="code" href="classlibMesh_1_1PerfData.php#a15209bc644699df8252321ab92448fee">00076</a>   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfData.php#a15209bc644699df8252321ab92448fee">tot_time_incl_sub</a>;
<a name="l00077"></a>00077 
<a name="l00082"></a><a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">00082</a>   <span class="keyword">struct </span>timeval <a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>;
<a name="l00083"></a>00083 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1PerfData.php#aaa7b0c10df6c78e6f68702998b147545">00088</a>   <span class="keyword">struct </span>timeval <a class="code" href="classlibMesh_1_1PerfData.php#aaa7b0c10df6c78e6f68702998b147545">tstart_incl_sub</a>;
<a name="l00089"></a>00089 
<a name="l00094"></a><a class="code" href="classlibMesh_1_1PerfData.php#ab8cc3cba8f3b3144895102bfd1420892">00094</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PerfData.php#ab8cc3cba8f3b3144895102bfd1420892">count</a>;
<a name="l00095"></a>00095 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1PerfData.php#afe045624fad41d012f698dd275c2ed2b">00101</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PerfData.php#afe045624fad41d012f698dd275c2ed2b">open</a>;
<a name="l00102"></a>00102 
<a name="l00103"></a>00103   <span class="keywordtype">void</span>   <a class="code" href="classlibMesh_1_1PerfData.php#adbbfbc66604b9a9ca35f0e5956c20db7">start</a> ();
<a name="l00104"></a>00104   <span class="keywordtype">void</span>   <a class="code" href="classlibMesh_1_1PerfData.php#a31e69d4b21fbf34848d04066461f5fa2">restart</a> ();
<a name="l00105"></a>00105   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfData.php#aa81429c7a1457981d30e92e738baef63">pause</a> ();
<a name="l00106"></a>00106   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfData.php#a334c196b4f3ecb0deb7fcf2f1cb0ecc2">stopit</a> ();
<a name="l00107"></a>00107     
<a name="l00108"></a><a class="code" href="classlibMesh_1_1PerfData.php#a3671b9fa464c61dbbbb96d564a33cfd0">00108</a>   <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PerfData.php#a3671b9fa464c61dbbbb96d564a33cfd0">called_recursively</a>;
<a name="l00109"></a>00109 
<a name="l00110"></a>00110  <span class="keyword">protected</span>:
<a name="l00111"></a>00111   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfData.php#a834a668b1cd19b9120574726383a3c57">stop_or_pause</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> do_stop);
<a name="l00112"></a>00112 };
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00126"></a>00126 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00127"></a>00127 <span class="comment">// PerfLog class definition</span>
<a name="l00128"></a><a class="code" href="classlibMesh_1_1PerfLog.php">00128</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PerfLog.php">PerfLog</a>
<a name="l00129"></a>00129 {
<a name="l00130"></a>00130 
<a name="l00131"></a>00131  <span class="keyword">public</span>:
<a name="l00132"></a>00132 
<a name="l00140"></a>00140   <a class="code" href="classlibMesh_1_1PerfLog.php#a263d9ec19829bf1361e6f9e07049ce5b">PerfLog</a>(<span class="keyword">const</span> std::string&amp; <a class="code" href="classlibMesh_1_1PerfLog.php#abf62278a809f704951c95151158300a0">label_name</a>=<span class="stringliteral">&quot;&quot;</span>,
<a name="l00141"></a>00141           <span class="keyword">const</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>=<span class="keyword">true</span>);
<a name="l00142"></a>00142 
<a name="l00146"></a>00146   <a class="code" href="classlibMesh_1_1PerfLog.php#a8d75ec0e1a217f90be39d0132c0938dd">~PerfLog</a>();
<a name="l00147"></a>00147   
<a name="l00155"></a>00155   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a3d3d2147ad6667552663be7befdd35e1">clear</a>();
<a name="l00156"></a>00156 
<a name="l00160"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a306ad61e6df5f6380cf60541b2cd343d">00160</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a306ad61e6df5f6380cf60541b2cd343d">disable_logging</a>() { <a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a> = <span class="keyword">false</span>; }
<a name="l00161"></a>00161 
<a name="l00165"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a8e929e91e0fd9c6915bbbbdfca03e346">00165</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a8e929e91e0fd9c6915bbbbdfca03e346">enable_logging</a>() { <a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a> = <span class="keyword">true</span>; }
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00171"></a>00171   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a81ee696975e5c1f43e501b716fe25b0c">push</a> (<span class="keyword">const</span> std::string &amp;label,
<a name="l00172"></a>00172              <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00173"></a>00173   
<a name="l00177"></a>00177   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a8baba3eec226ca4f268564f50d3ca798">pop</a> (<span class="keyword">const</span> std::string &amp;label,
<a name="l00178"></a>00178             <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00179"></a>00179   
<a name="l00183"></a>00183   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a123d150c7529ef7000435b9fc344cce6">start_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00184"></a>00184                    <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00185"></a>00185 
<a name="l00189"></a>00189   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#ae7441ae7daaa389bf9be41cdc10d89db">stop_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00190"></a>00190                   <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00191"></a>00191 
<a name="l00195"></a>00195   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#ab01fd2638276f8c3c2120b417f4c4ce8">pause_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00196"></a>00196                    <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00197"></a>00197 
<a name="l00201"></a>00201   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a5d54a63bbb5b5dd241575ee85511292e">restart_event</a>(<span class="keyword">const</span> std::string &amp;label,
<a name="l00202"></a>00202                      <span class="keyword">const</span> std::string &amp;header=<span class="stringliteral">&quot;&quot;</span>);
<a name="l00203"></a>00203   
<a name="l00209"></a>00209   std::string <a class="code" href="classlibMesh_1_1PerfLog.php#a10a7a08834a985c382487b02a543d86d">get_log</a>() <span class="keyword">const</span>;
<a name="l00210"></a>00210   
<a name="l00214"></a>00214   std::string <a class="code" href="classlibMesh_1_1PerfLog.php#a8f7e636b403bf8ae3a059b47e4e714c8">get_info_header</a>() <span class="keyword">const</span>;
<a name="l00215"></a>00215 
<a name="l00219"></a>00219   std::string <a class="code" href="classlibMesh_1_1PerfLog.php#a35b6d94c01b7c0a219df37cf51b41d6d">get_perf_info</a>() <span class="keyword">const</span>;
<a name="l00220"></a>00220   
<a name="l00224"></a>00224   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a77310cc500de193b6172d92a5ddbf95d">print_log</a>() <span class="keyword">const</span>;
<a name="l00225"></a>00225 
<a name="l00229"></a>00229   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfLog.php#af6f21f167474b21739404fee6ae06acf">get_elapsed_time</a>() <span class="keyword">const</span>;
<a name="l00230"></a>00230  
<a name="l00231"></a>00231    
<a name="l00232"></a>00232  <span class="keyword">private</span>:
<a name="l00233"></a>00233 
<a name="l00234"></a>00234   
<a name="l00238"></a><a class="code" href="classlibMesh_1_1PerfLog.php#abf62278a809f704951c95151158300a0">00238</a>   <span class="keyword">const</span> std::string <a class="code" href="classlibMesh_1_1PerfLog.php#abf62278a809f704951c95151158300a0">label_name</a>;
<a name="l00239"></a>00239 
<a name="l00243"></a><a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">00243</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>;
<a name="l00244"></a>00244 
<a name="l00248"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a2b198f5c72c73b5f21b394f16928f686">00248</a>   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a2b198f5c72c73b5f21b394f16928f686">total_time</a>;
<a name="l00249"></a>00249   
<a name="l00253"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a809ef5f49c9c2df645b44ec61a92d471">00253</a>   <span class="keyword">struct </span>timeval <a class="code" href="classlibMesh_1_1PerfLog.php#a809ef5f49c9c2df645b44ec61a92d471">tstart</a>;
<a name="l00254"></a>00254   
<a name="l00258"></a>00258   std::map&lt;std::pair&lt;std::string,
<a name="l00259"></a>00259                      std::string&gt;,
<a name="l00260"></a><a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">00260</a>            <a class="code" href="classlibMesh_1_1PerfData.php">PerfData</a>&gt; <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>;
<a name="l00261"></a>00261 
<a name="l00265"></a><a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">00265</a>   std::stack&lt;PerfData*&gt; <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>;
<a name="l00266"></a>00266   
<a name="l00272"></a><a class="code" href="classlibMesh_1_1PerfLog.php#aee181cf8480820db002d91e1ad3a83f0">00272</a>   <span class="keyword">static</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PerfLog.php#aee181cf8480820db002d91e1ad3a83f0">called</a>;
<a name="l00273"></a>00273   
<a name="l00278"></a>00278   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#ab121f5baa6f3a6e33186291188c98c01">_character_line</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00279"></a>00279                        <span class="keyword">const</span> <span class="keywordtype">char</span> c,
<a name="l00280"></a>00280                        <a class="code" href="classlibMesh_1_1OStringStream.php">OStringStream</a>&amp; <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>) <span class="keyword">const</span>;
<a name="l00281"></a>00281 };
<a name="l00282"></a>00282 
<a name="l00283"></a>00283 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00286"></a>00286 <span class="comment">// PerfData class member funcions</span>
<a name="l00287"></a>00287 <span class="keyword">inline</span>
<a name="l00288"></a><a class="code" href="classlibMesh_1_1PerfData.php#adbbfbc66604b9a9ca35f0e5956c20db7">00288</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfData.php#adbbfbc66604b9a9ca35f0e5956c20db7">PerfData::start</a> ()
<a name="l00289"></a>00289 {
<a name="l00290"></a>00290   this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ab8cc3cba8f3b3144895102bfd1420892">count</a>++;
<a name="l00291"></a>00291   this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#a3671b9fa464c61dbbbb96d564a33cfd0">called_recursively</a>++;
<a name="l00292"></a>00292   gettimeofday (&amp;(this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>), NULL);
<a name="l00293"></a>00293   this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#aaa7b0c10df6c78e6f68702998b147545">tstart_incl_sub</a> = this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>;
<a name="l00294"></a>00294 }
<a name="l00295"></a>00295 
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 
<a name="l00298"></a>00298 <span class="keyword">inline</span>
<a name="l00299"></a><a class="code" href="classlibMesh_1_1PerfData.php#a31e69d4b21fbf34848d04066461f5fa2">00299</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfData.php#a31e69d4b21fbf34848d04066461f5fa2">PerfData::restart</a> ()
<a name="l00300"></a>00300 {
<a name="l00301"></a>00301   gettimeofday (&amp;(this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>), NULL);
<a name="l00302"></a>00302 }
<a name="l00303"></a>00303 
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306 <span class="keyword">inline</span>
<a name="l00307"></a><a class="code" href="classlibMesh_1_1PerfData.php#aa81429c7a1457981d30e92e738baef63">00307</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfData.php#aa81429c7a1457981d30e92e738baef63">PerfData::pause</a> ()
<a name="l00308"></a>00308 {
<a name="l00309"></a>00309   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#a834a668b1cd19b9120574726383a3c57">stop_or_pause</a>(<span class="keyword">false</span>);
<a name="l00310"></a>00310 }
<a name="l00311"></a>00311 
<a name="l00312"></a>00312 
<a name="l00313"></a>00313 <span class="keyword">inline</span>
<a name="l00314"></a><a class="code" href="classlibMesh_1_1PerfData.php#a834a668b1cd19b9120574726383a3c57">00314</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfData.php#a834a668b1cd19b9120574726383a3c57">PerfData::stop_or_pause</a>(<span class="keyword">const</span> <span class="keywordtype">bool</span> do_stop)
<a name="l00315"></a>00315 {
<a name="l00316"></a>00316   <span class="comment">// save the start times, reuse the structure we have rather than create</span>
<a name="l00317"></a>00317   <span class="comment">// a new one.</span>
<a name="l00318"></a>00318   <span class="keyword">const</span> time_t
<a name="l00319"></a>00319     tstart_tv_sec  = this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>.tv_sec,
<a name="l00320"></a>00320     tstart_tv_usec = this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>.tv_usec;
<a name="l00321"></a>00321   
<a name="l00322"></a>00322   gettimeofday (&amp;(this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>), NULL);
<a name="l00323"></a>00323   
<a name="l00324"></a>00324   <span class="keyword">const</span> <span class="keywordtype">double</span> elapsed_time = (<span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>.tv_sec  - tstart_tv_sec) +
<a name="l00325"></a>00325                                static_cast&lt;double&gt;(this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>.tv_usec - tstart_tv_usec)*1.e-6);      
<a name="l00326"></a>00326   
<a name="l00327"></a>00327   this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ab6742a77b0e3847d1439c26cd2703192">tot_time</a> += elapsed_time;
<a name="l00328"></a>00328 
<a name="l00329"></a>00329   <span class="keywordflow">if</span>(do_stop)
<a name="l00330"></a>00330     {
<a name="l00331"></a>00331       <span class="keyword">const</span> <span class="keywordtype">double</span> elapsed_time_incl_sub = (<span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>.tv_sec  - this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#aaa7b0c10df6c78e6f68702998b147545">tstart_incl_sub</a>.tv_sec) +
<a name="l00332"></a>00332                                             static_cast&lt;double&gt;(this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#ac99da9dde014ca5750aaaeb763bea115">tstart</a>.tv_usec - this-&gt;tstart_incl_sub.tv_usec)*1.e-6);      
<a name="l00333"></a>00333 
<a name="l00334"></a>00334       this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#a15209bc644699df8252321ab92448fee">tot_time_incl_sub</a> += elapsed_time_incl_sub;
<a name="l00335"></a>00335     }
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   <span class="keywordflow">return</span> elapsed_time;
<a name="l00338"></a>00338 }
<a name="l00339"></a>00339 
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 <span class="keyword">inline</span>
<a name="l00343"></a><a class="code" href="classlibMesh_1_1PerfData.php#a334c196b4f3ecb0deb7fcf2f1cb0ecc2">00343</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfData.php#a334c196b4f3ecb0deb7fcf2f1cb0ecc2">PerfData::stopit</a> ()
<a name="l00344"></a>00344 {
<a name="l00345"></a>00345   <span class="comment">// stopit is just similar to pause except that it decrements the </span>
<a name="l00346"></a>00346   <span class="comment">// recursive call counter</span>
<a name="l00347"></a>00347   
<a name="l00348"></a>00348   this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#a3671b9fa464c61dbbbb96d564a33cfd0">called_recursively</a>--;
<a name="l00349"></a>00349   <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#a834a668b1cd19b9120574726383a3c57">stop_or_pause</a>(<span class="keyword">true</span>);
<a name="l00350"></a>00350 }
<a name="l00351"></a>00351 
<a name="l00352"></a>00352 
<a name="l00353"></a>00353 
<a name="l00354"></a>00354 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00355"></a>00355 <span class="comment">// PerfLog class inline member funcions</span>
<a name="l00356"></a>00356 <span class="keyword">inline</span>
<a name="l00357"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a81ee696975e5c1f43e501b716fe25b0c">00357</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a81ee696975e5c1f43e501b716fe25b0c">PerfLog::push</a> (<span class="keyword">const</span> std::string &amp;label,
<a name="l00358"></a>00358                     <span class="keyword">const</span> std::string &amp;header)
<a name="l00359"></a>00359 {
<a name="l00360"></a>00360   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>)
<a name="l00361"></a>00361     {
<a name="l00362"></a>00362       <span class="comment">// Get a reference to the event data to avoid</span>
<a name="l00363"></a>00363       <span class="comment">// repeated map lookups</span>
<a name="l00364"></a>00364       <a class="code" href="classlibMesh_1_1PerfData.php">PerfData</a> *perf_data = &amp;(<a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>[std::make_pair(header,label)]);
<a name="l00365"></a>00365 
<a name="l00366"></a>00366       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.empty())
<a name="l00367"></a>00367         <a class="code" href="classlibMesh_1_1PerfLog.php#a2b198f5c72c73b5f21b394f16928f686">total_time</a> += 
<a name="l00368"></a>00368           <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.top()-&gt;pause();
<a name="l00369"></a>00369       
<a name="l00370"></a>00370       perf_data-&gt;<a class="code" href="classlibMesh_1_1PerfData.php#adbbfbc66604b9a9ca35f0e5956c20db7">start</a>();
<a name="l00371"></a>00371       <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.push(perf_data);
<a name="l00372"></a>00372     }
<a name="l00373"></a>00373 }
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 <span class="keyword">inline</span>
<a name="l00378"></a><a class="code" href="classlibMesh_1_1PerfLog.php#a8baba3eec226ca4f268564f50d3ca798">00378</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfLog.php#a8baba3eec226ca4f268564f50d3ca798">PerfLog::pop</a> (<span class="keyword">const</span> std::string &amp;label,
<a name="l00379"></a>00379                    <span class="keyword">const</span> std::string &amp;header)
<a name="l00380"></a>00380 {
<a name="l00381"></a>00381   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PerfLog.php#aef3639eb47499b9f419d0d38aad3572d">log_events</a>)
<a name="l00382"></a>00382     {
<a name="l00383"></a>00383       libmesh_assert (!<a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.empty());
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00386"></a>00386 <span class="preprocessor"></span>      <a class="code" href="classlibMesh_1_1PerfData.php">PerfData</a> *perf_data = &amp;(<a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>[std::make_pair(header,label)]);
<a name="l00387"></a>00387       <span class="keywordflow">if</span> (perf_data != <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.top())
<a name="l00388"></a>00388         {
<a name="l00389"></a>00389           std::cerr &lt;&lt; <span class="stringliteral">&quot;PerfLog can&#39;t pop (&quot;</span> &lt;&lt; header &lt;&lt; <span class="charliteral">&#39;,&#39;</span> &lt;&lt; label &lt;&lt; <span class="charliteral">&#39;)&#39;</span> &lt;&lt; std::endl;
<a name="l00390"></a>00390           std::cerr &lt;&lt; <span class="stringliteral">&quot;From top of stack of running logs:&quot;</span> &lt;&lt; std::endl;
<a name="l00391"></a>00391           std::map&lt;std::pair&lt;std::string, std::string&gt;, <a class="code" href="classlibMesh_1_1PerfData.php">PerfData</a>&gt;<a class="code" href="classstd_1_1iterator.php">::iterator</a>
<a name="l00392"></a>00392             i = <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.begin(), endi = <a class="code" href="classlibMesh_1_1PerfLog.php#af71948f5244492ec99c1634f05bda2db">log</a>.end();
<a name="l00393"></a>00393           <span class="keywordflow">for</span> (; i != endi; ++i)
<a name="l00394"></a>00394             <span class="keywordflow">if</span> (&amp;(i-&gt;second) == <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.top())
<a name="l00395"></a>00395               std::cerr &lt;&lt; <span class="charliteral">&#39;(&#39;</span> &lt;&lt; i-&gt;first.first &lt;&lt; <span class="charliteral">&#39;,&#39;</span> &lt;&lt; i-&gt;first.second &lt;&lt; <span class="charliteral">&#39;)&#39;</span> &lt;&lt; std::endl;
<a name="l00396"></a>00396             
<a name="l00397"></a>00397           libmesh_assert(perf_data == <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.top());
<a name="l00398"></a>00398         }
<a name="l00399"></a>00399 <span class="preprocessor">#endif</span>
<a name="l00400"></a>00400 <span class="preprocessor"></span>
<a name="l00401"></a>00401       <a class="code" href="classlibMesh_1_1PerfLog.php#a2b198f5c72c73b5f21b394f16928f686">total_time</a> += <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.top()-&gt;stopit();
<a name="l00402"></a>00402 
<a name="l00403"></a>00403       <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.pop();
<a name="l00404"></a>00404 
<a name="l00405"></a>00405       <span class="keywordflow">if</span> (!<a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.empty())
<a name="l00406"></a>00406         <a class="code" href="classlibMesh_1_1PerfLog.php#afe9bd2cd566bb3728a4bc17047dfed01">log_stack</a>.top()-&gt;restart();
<a name="l00407"></a>00407     }
<a name="l00408"></a>00408 }
<a name="l00409"></a>00409 
<a name="l00410"></a>00410 
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 <span class="keyword">inline</span>
<a name="l00413"></a><a class="code" href="classlibMesh_1_1PerfLog.php#af6f21f167474b21739404fee6ae06acf">00413</a> <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfLog.php#af6f21f167474b21739404fee6ae06acf">PerfLog::get_elapsed_time</a> ()<span class="keyword"> const</span>
<a name="l00414"></a>00414 <span class="keyword"></span>{
<a name="l00415"></a>00415   <span class="keyword">struct </span>timeval tnow;
<a name="l00416"></a>00416   
<a name="l00417"></a>00417   gettimeofday (&amp;tnow, NULL);
<a name="l00418"></a>00418           
<a name="l00419"></a>00419   <span class="keyword">const</span> <span class="keywordtype">double</span> elapsed_time = (<span class="keyword">static_cast&lt;</span><span class="keywordtype">double</span><span class="keyword">&gt;</span>(tnow.tv_sec  - <a class="code" href="classlibMesh_1_1PerfLog.php#a809ef5f49c9c2df645b44ec61a92d471">tstart</a>.tv_sec) +
<a name="l00420"></a>00420                                static_cast&lt;double&gt;(tnow.tv_usec - <a class="code" href="classlibMesh_1_1PerfLog.php#a809ef5f49c9c2df645b44ec61a92d471">tstart</a>.tv_usec)*1.e-6);
<a name="l00421"></a>00421   <span class="keywordflow">return</span> elapsed_time;
<a name="l00422"></a>00422 }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 } <span class="comment">// namespace libMesh</span>
<a name="l00426"></a>00426 
<a name="l00427"></a>00427 
<a name="l00428"></a>00428 
<a name="l00429"></a>00429 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
