<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">perfmon.h</div>  </div>
</div>
<div class="contents">
<a href="perfmon_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: perfmon.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __perfmon_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __perfmon_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;sys/time.h&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00035"></a><a class="code" href="namespacePapi.php">00035</a> <span class="preprocessor"></span><span class="keyword">namespace </span>Papi {
<a name="l00036"></a>00036 <span class="preprocessor">#  include &lt;papi.h&gt;</span>
<a name="l00037"></a>00037 }
<a name="l00038"></a>00038 <span class="preprocessor">#endif</span>
<a name="l00039"></a>00039 <span class="preprocessor"></span>
<a name="l00040"></a>00040 <span class="keyword">namespace </span>libMesh
<a name="l00041"></a>00041 {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 
<a name="l00045"></a><a class="code" href="classlibMesh_1_1PerfMon.php">00045</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PerfMon.php">PerfMon</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047  <span class="keyword">public</span>:
<a name="l00048"></a>00048   <a class="code" href="classlibMesh_1_1PerfMon.php#aa97c677d1c39959f10a22d81b6cf096d">PerfMon</a>  (std::string <span class="keywordtype">id</span>,
<a name="l00049"></a>00049             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v=1,
<a name="l00050"></a>00050             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid=0);
<a name="l00051"></a>00051             
<a name="l00052"></a>00052   <a class="code" href="classlibMesh_1_1PerfMon.php#abf957c3043edf00d6a9d111f815d0ff7">~PerfMon</a> ();
<a name="l00053"></a>00053   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PerfMon.php#ac6266f04b82d7d50472d54cd891e210e">reset</a> ();
<a name="l00054"></a>00054   <span class="keywordtype">double</span> <a class="code" href="classlibMesh_1_1PerfMon.php#abcdfee74597ad34d0119d106bae9b259">print</a> (std::string msg=<span class="stringliteral">&quot;NULL&quot;</span>, std::ostream &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a> = <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>);
<a name="l00055"></a>00055   
<a name="l00056"></a>00056  <span class="keyword">private</span>:
<a name="l00057"></a>00057 
<a name="l00058"></a><a class="code" href="classlibMesh_1_1PerfMon.php#a98445e29db2851e9def74f66292167c4">00058</a>   <span class="keyword">const</span> std::string <a class="code" href="classlibMesh_1_1PerfMon.php#a98445e29db2851e9def74f66292167c4">id_string</a>;
<a name="l00059"></a>00059   
<a name="l00060"></a><a class="code" href="classlibMesh_1_1PerfMon.php#a95d911708f7e3533803a364105b6ff45">00060</a>   <span class="keyword">struct </span>timeval <a class="code" href="classlibMesh_1_1PerfMon.php#a95d911708f7e3533803a364105b6ff45">the_time_start</a>;
<a name="l00061"></a><a class="code" href="classlibMesh_1_1PerfMon.php#afbd161862e0c9cf3c4f3f2d783de0dd1">00061</a>   <span class="keyword">struct </span>timeval <a class="code" href="classlibMesh_1_1PerfMon.php#afbd161862e0c9cf3c4f3f2d783de0dd1">the_time_stop</a>;
<a name="l00062"></a>00062 
<a name="l00063"></a><a class="code" href="classlibMesh_1_1PerfMon.php#a312bf2e31bee7fee44d6b93edff22571">00063</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PerfMon.php#a312bf2e31bee7fee44d6b93edff22571">verbose</a>;
<a name="l00064"></a><a class="code" href="classlibMesh_1_1PerfMon.php#a95373bd932d3daa396e5324fe4350430">00064</a>   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PerfMon.php#a95373bd932d3daa396e5324fe4350430">proc_id</a>;
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00067"></a><a class="code" href="classlibMesh_1_1PerfMon.php#a0addb4f151eea44eec11ab8fbdbcd4c0">00067</a> <span class="preprocessor"></span>  <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1PerfMon.php#a0addb4f151eea44eec11ab8fbdbcd4c0">rtime</a>, <a class="code" href="classlibMesh_1_1PerfMon.php#afe33ee655fa9ce5d32db550c58e48d65">ptime</a>, <a class="code" href="classlibMesh_1_1PerfMon.php#a0a3d7d80f23deb5d85a8805706f34345">mflops</a>;
<a name="l00068"></a><a class="code" href="classlibMesh_1_1PerfMon.php#a35c5c178f19bcccb948e61702fb09a23">00068</a>   <span class="keywordtype">long</span> <span class="keywordtype">long</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PerfMon.php#a35c5c178f19bcccb948e61702fb09a23">flpins</a>;
<a name="l00069"></a>00069 <span class="preprocessor">#endif</span>
<a name="l00070"></a>00070 <span class="preprocessor"></span>};
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="keyword">inline</span>
<a name="l00075"></a>00075 <span class="keywordtype">void</span>
<a name="l00076"></a><a class="code" href="classlibMesh_1_1PerfMon.php#ac6266f04b82d7d50472d54cd891e210e">00076</a> <a class="code" href="classlibMesh_1_1PerfMon.php#ac6266f04b82d7d50472d54cd891e210e">PerfMon::reset</a> ()
<a name="l00077"></a>00077 {
<a name="l00078"></a>00078   gettimeofday (&amp;<a class="code" href="classlibMesh_1_1PerfMon.php#a95d911708f7e3533803a364105b6ff45">the_time_start</a>, NULL);
<a name="l00079"></a>00079 
<a name="l00080"></a>00080 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>  Papi::PAPI_flops (&amp;<a class="code" href="classlibMesh_1_1PerfMon.php#a0addb4f151eea44eec11ab8fbdbcd4c0">rtime</a>, &amp;<a class="code" href="classlibMesh_1_1PerfMon.php#afe33ee655fa9ce5d32db550c58e48d65">ptime</a>, &amp;<a class="code" href="classlibMesh_1_1PerfMon.php#a35c5c178f19bcccb948e61702fb09a23">flpins</a>, &amp;<a class="code" href="classlibMesh_1_1PerfMon.php#a0a3d7d80f23deb5d85a8805706f34345">mflops</a>);
<a name="l00082"></a>00082 <span class="preprocessor">#endif  </span>
<a name="l00083"></a>00083 <span class="preprocessor"></span>}
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="keyword">inline</span>
<a name="l00088"></a>00088 <span class="keywordtype">double</span>
<a name="l00089"></a><a class="code" href="classlibMesh_1_1PerfMon.php#abcdfee74597ad34d0119d106bae9b259">00089</a> <a class="code" href="classlibMesh_1_1PerfMon.php#abcdfee74597ad34d0119d106bae9b259">PerfMon::print</a> (std::string msg, std::ostream &amp;<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">out</a>)
<a name="l00090"></a>00090 {  
<a name="l00091"></a>00091   gettimeofday (&amp;<a class="code" href="classlibMesh_1_1PerfMon.php#afbd161862e0c9cf3c4f3f2d783de0dd1">the_time_stop</a>, NULL);
<a name="l00092"></a>00092   
<a name="l00093"></a>00093 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00094"></a>00094 <span class="preprocessor"></span>  Papi::PAPI_flops (&amp;<a class="code" href="classlibMesh_1_1PerfMon.php#a0addb4f151eea44eec11ab8fbdbcd4c0">rtime</a>, &amp;<a class="code" href="classlibMesh_1_1PerfMon.php#afe33ee655fa9ce5d32db550c58e48d65">ptime</a>, &amp;<a class="code" href="classlibMesh_1_1PerfMon.php#a35c5c178f19bcccb948e61702fb09a23">flpins</a>, &amp;<a class="code" href="classlibMesh_1_1PerfMon.php#a0a3d7d80f23deb5d85a8805706f34345">mflops</a>);
<a name="l00095"></a>00095 <span class="preprocessor">#endif</span>
<a name="l00096"></a>00096 <span class="preprocessor"></span>
<a name="l00097"></a>00097   <span class="keyword">const</span> <span class="keywordtype">double</span> elapsed_time = ((double) (<a class="code" href="classlibMesh_1_1PerfMon.php#afbd161862e0c9cf3c4f3f2d783de0dd1">the_time_stop</a>.tv_sec - <a class="code" href="classlibMesh_1_1PerfMon.php#a95d911708f7e3533803a364105b6ff45">the_time_start</a>.tv_sec)) +
<a name="l00098"></a>00098                               ((<span class="keywordtype">double</span>) (<a class="code" href="classlibMesh_1_1PerfMon.php#afbd161862e0c9cf3c4f3f2d783de0dd1">the_time_stop</a>.tv_usec - <a class="code" href="classlibMesh_1_1PerfMon.php#a95d911708f7e3533803a364105b6ff45">the_time_start</a>.tv_usec))/1000000.;
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PerfMon.php#a312bf2e31bee7fee44d6b93edff22571">verbose</a>)
<a name="l00101"></a>00101     {
<a name="l00102"></a>00102       
<a name="l00103"></a>00103       <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1PerfMon.php#a95373bd932d3daa396e5324fe4350430">proc_id</a> == 0)
<a name="l00104"></a>00104         {
<a name="l00105"></a>00105           <span class="keywordflow">if</span> (msg == <span class="stringliteral">&quot;NULL&quot;</span>)
<a name="l00106"></a>00106             out &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1PerfMon.php#a98445e29db2851e9def74f66292167c4">id_string</a>
<a name="l00107"></a>00107                 &lt;&lt; <span class="stringliteral">&quot;: elapsed time: &quot;</span>
<a name="l00108"></a>00108                 &lt;&lt; elapsed_time &lt;&lt; <span class="stringliteral">&quot; (sec)&quot;</span>
<a name="l00109"></a>00109                 &lt;&lt; std::endl;
<a name="l00110"></a>00110           <span class="keywordflow">else</span>
<a name="l00111"></a>00111             out &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; msg
<a name="l00112"></a>00112                 &lt;&lt; <span class="stringliteral">&quot;: elapsed time: &quot;</span>
<a name="l00113"></a>00113                 &lt;&lt; elapsed_time &lt;&lt; <span class="stringliteral">&quot; (sec)&quot;</span>
<a name="l00114"></a>00114                 &lt;&lt; std::endl;
<a name="l00115"></a>00115           
<a name="l00116"></a>00116 <span class="preprocessor">#ifdef HAVE_PAPI_H</span>
<a name="l00117"></a>00117 <span class="preprocessor"></span>          <span class="keywordflow">if</span> (msg == <span class="stringliteral">&quot;NULL&quot;</span>)
<a name="l00118"></a>00118             out &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1PerfMon.php#a98445e29db2851e9def74f66292167c4">id_string</a>
<a name="l00119"></a>00119                 &lt;&lt; <span class="stringliteral">&quot;: mflops: &quot;</span>
<a name="l00120"></a>00120                 &lt;&lt; <a class="code" href="classlibMesh_1_1PerfMon.php#a0a3d7d80f23deb5d85a8805706f34345">mflops</a>
<a name="l00121"></a>00121                 &lt;&lt; std::endl;
<a name="l00122"></a>00122           <span class="keywordflow">else</span>
<a name="l00123"></a>00123             out &lt;&lt; <span class="stringliteral">&quot; &quot;</span> &lt;&lt; msg
<a name="l00124"></a>00124                 &lt;&lt; <span class="stringliteral">&quot;: mflops: &quot;</span>
<a name="l00125"></a>00125                 &lt;&lt; <a class="code" href="classlibMesh_1_1PerfMon.php#a0a3d7d80f23deb5d85a8805706f34345">mflops</a>
<a name="l00126"></a>00126                 &lt;&lt; std::endl;
<a name="l00127"></a>00127       
<a name="l00128"></a>00128 <span class="preprocessor">#endif</span>
<a name="l00129"></a>00129 <span class="preprocessor"></span>
<a name="l00130"></a>00130         }
<a name="l00131"></a>00131     }
<a name="l00132"></a>00132   
<a name="l00133"></a>00133   <span class="keywordflow">return</span> elapsed_time;
<a name="l00134"></a>00134 }
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 
<a name="l00137"></a>00137 <span class="keyword">inline</span>
<a name="l00138"></a><a class="code" href="classlibMesh_1_1PerfMon.php#aa97c677d1c39959f10a22d81b6cf096d">00138</a> <a class="code" href="classlibMesh_1_1PerfMon.php#aa97c677d1c39959f10a22d81b6cf096d">PerfMon::PerfMon</a> (std::string <span class="keywordtype">id</span>,
<a name="l00139"></a>00139                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> v,
<a name="l00140"></a>00140                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid) :
<a name="l00141"></a>00141   id_string(id),
<a name="l00142"></a>00142   verbose(v),
<a name="l00143"></a>00143   proc_id(pid)
<a name="l00144"></a>00144 {
<a name="l00145"></a>00145   <a class="code" href="classlibMesh_1_1PerfMon.php#ac6266f04b82d7d50472d54cd891e210e">reset</a> ();
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="keyword">inline</span>
<a name="l00151"></a><a class="code" href="classlibMesh_1_1PerfMon.php#abf957c3043edf00d6a9d111f815d0ff7">00151</a> <a class="code" href="classlibMesh_1_1PerfMon.php#abf957c3043edf00d6a9d111f815d0ff7">PerfMon::~PerfMon</a> ()
<a name="l00152"></a>00152 {
<a name="l00153"></a>00153   <a class="code" href="classlibMesh_1_1PerfMon.php#abcdfee74597ad34d0119d106bae9b259">print</a> ();
<a name="l00154"></a>00154 }
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 } <span class="comment">// namespace libMesh</span>
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
