<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c5eb276bc08a4c4672971937d71467c1.php">base</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">periodic_boundaries.h</div>  </div>
</div>
<div class="contents">
<a href="periodic__boundaries_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 <span class="comment">// $Id: periodic_boundaries.h 4399 2011-04-22 18:32:39Z roystgnr $</span>
<a name="l00003"></a>00003 
<a name="l00004"></a>00004 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00005"></a>00005 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00006"></a>00006   
<a name="l00007"></a>00007 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00008"></a>00008 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00009"></a>00009 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00010"></a>00010 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00011"></a>00011   
<a name="l00012"></a>00012 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00013"></a>00013 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00014"></a>00014 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00015"></a>00015 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00016"></a>00016   
<a name="l00017"></a>00017 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00018"></a>00018 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00019"></a>00019 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#ifndef __periodic_boundaries_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span><span class="preprocessor">#define __periodic_boundaries_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span>
<a name="l00024"></a>00024 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00025"></a>00025 <span class="comment">// Periodic boundary conditions information</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_ENABLE_PERIODIC</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;map&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &lt;set&gt;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="vector__value_8h.php">vector_value.h</a>&quot;</span> <span class="comment">// RealVectorValue</span>
<a name="l00039"></a>00039 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span> <span class="comment">// libMesh::invalid_uint</span>
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="keyword">namespace </span>libMesh {
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// Forward Declarations</span>
<a name="l00044"></a>00044 <span class="keyword">class </span>Elem;
<a name="l00045"></a>00045 <span class="keyword">class </span>MeshBase;
<a name="l00046"></a>00046 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php">00050</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a>
<a name="l00051"></a>00051 {
<a name="l00052"></a>00052 <span class="keyword">public</span>:
<a name="l00053"></a>00053   <span class="comment">// The boundary ID of this boundary and it&#39;s counterpart</span>
<a name="l00054"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">00054</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>,
<a name="l00055"></a>00055                <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>;
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#abb4c7dc300b21f32bbf32423dea10ae5">00057</a>   <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#abb4c7dc300b21f32bbf32423dea10ae5">PeriodicBoundary</a>() :
<a name="l00058"></a>00058     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00059"></a>00059     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00060"></a>00060     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#ab5fa28e752971cda926b8d77537f402e">translation_vector</a>()
<a name="l00061"></a>00061   {
<a name="l00062"></a>00062   }
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#aff9f7fff8c10db69ec64d2f6c3330e8a">00064</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#aff9f7fff8c10db69ec64d2f6c3330e8a">~PeriodicBoundary</a>() {}
<a name="l00065"></a>00065 
<a name="l00066"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a1c5c7ee49779f23e8d5da32f5f4cc984">00066</a>   <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#abb4c7dc300b21f32bbf32423dea10ae5">PeriodicBoundary</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> &amp; o, <span class="keywordtype">bool</span> inverse = <span class="keyword">false</span>) :
<a name="l00067"></a>00067     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>(o.<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>),
<a name="l00068"></a>00068     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>(o.<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>),
<a name="l00069"></a>00069     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#ab5fa28e752971cda926b8d77537f402e">translation_vector</a>(o.<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#ab5fa28e752971cda926b8d77537f402e">translation_vector</a>),
<a name="l00070"></a>00070     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>(o.<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>)
<a name="l00071"></a>00071   {
<a name="l00072"></a>00072     <span class="keywordflow">if</span> (inverse)
<a name="l00073"></a>00073     {
<a name="l00074"></a>00074       std::swap(<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>, <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>);
<a name="l00075"></a>00075       <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#ab5fa28e752971cda926b8d77537f402e">translation_vector</a> *= -1.0;
<a name="l00076"></a>00076     }
<a name="l00077"></a>00077   }
<a name="l00078"></a>00078 
<a name="l00079"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a801af039f50ce41df3a703f0510085d3">00079</a>   <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#abb4c7dc300b21f32bbf32423dea10ae5">PeriodicBoundary</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1VectorValue.php">RealVectorValue</a> &amp; <a class="code" href="classstd_1_1vector.php">vector</a>) :
<a name="l00080"></a>00080     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a9b672ef0d74f6179e33c13bd8632e78b">myboundary</a>(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00081"></a>00081     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a8f33f69366325248b3b337975061ba3e">pairedboundary</a>(libMesh::<a class="code" href="namespacelibMesh.php#a5588f6411946120c9d917450ab73e2e2">invalid_uint</a>),
<a name="l00082"></a>00082     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#ab5fa28e752971cda926b8d77537f402e">translation_vector</a> (vector)
<a name="l00083"></a>00083   {
<a name="l00084"></a>00084   }
<a name="l00085"></a>00085 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a27be85e1730579d906bad0d1703acfe2">00086</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a27be85e1730579d906bad0d1703acfe2">get_corresponding_pos</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; pt)<span class="keyword"> const</span>
<a name="l00087"></a>00087 <span class="keyword">  </span>{
<a name="l00088"></a>00088     <span class="keywordflow">return</span> pt + <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#ab5fa28e752971cda926b8d77537f402e">translation_vector</a>;
<a name="l00089"></a>00089   }
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#af46f81c3b2a01912d3777d59c6470108">00091</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#af46f81c3b2a01912d3777d59c6470108">set_variable</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var)
<a name="l00092"></a>00092   {
<a name="l00093"></a>00093     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>.insert(var);
<a name="l00094"></a>00094   }
<a name="l00095"></a>00095 
<a name="l00096"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a94ca1680f846a5cc8537d39a7420eb8c">00096</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a94ca1680f846a5cc8537d39a7420eb8c">merge</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> &amp; pb)
<a name="l00097"></a>00097   {
<a name="l00098"></a>00098     <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>.insert(pb.<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>.begin(), pb.<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>.end());
<a name="l00099"></a>00099   }
<a name="l00100"></a>00100 
<a name="l00101"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#afdb1f2ade1a6985da7e6c0c6143af2bf">00101</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#afdb1f2ade1a6985da7e6c0c6143af2bf">is_my_variable</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> var_num)<span class="keyword"> const</span>
<a name="l00102"></a>00102 <span class="keyword">  </span>{
<a name="l00103"></a>00103     <span class="keywordtype">bool</span> a = <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>.empty() || (!<a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>.empty() &amp;&amp; <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>.find(var_num) != <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>.end());
<a name="l00104"></a>00104     <span class="keywordflow">return</span> a;
<a name="l00105"></a>00105   }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107 <span class="keyword">protected</span>:
<a name="l00108"></a>00108   <span class="comment">// One of these days we&#39;ll support rotated boundaries</span>
<a name="l00109"></a>00109   <span class="comment">// RealTensor rotation_matrix;</span>
<a name="l00110"></a>00110 
<a name="l00111"></a>00111   <span class="comment">// The vector which is added to points in myboundary</span>
<a name="l00112"></a>00112   <span class="comment">// to produce corresponding points in pairedboundary</span>
<a name="l00113"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#ab5fa28e752971cda926b8d77537f402e">00113</a>   <a class="code" href="classlibMesh_1_1VectorValue.php">RealVectorValue</a> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#ab5fa28e752971cda926b8d77537f402e">translation_vector</a>;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115   <span class="comment">// Set of variables for this periodiv boundary, empty means all varaibles possible</span>
<a name="l00116"></a><a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">00116</a>   std::set&lt;unsigned int&gt; <a class="code" href="classlibMesh_1_1PeriodicBoundary.php#a06bf4f5c17ad5a62742bb7db6a007bcc">variables</a>;
<a name="l00117"></a>00117 };
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">00127</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PeriodicBoundaries.php">PeriodicBoundaries</a> : <span class="keyword">public</span> std::<a class="code" href="classstd_1_1map.php">map</a>&lt;unsigned int, PeriodicBoundary *&gt;
<a name="l00128"></a>00128 {
<a name="l00129"></a>00129 <span class="keyword">public</span>:
<a name="l00130"></a>00130   <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *<a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a5ab69d80e060239a949a58c03bdf57f6">boundary</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>);
<a name="l00131"></a>00131 
<a name="l00132"></a>00132   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *<a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a5ab69d80e060239a949a58c03bdf57f6">boundary</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>) <span class="keyword">const</span>;
<a name="l00133"></a>00133 
<a name="l00134"></a><a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a66f61c204ec236cf8ad9edfd3e27a937">00134</a>   <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a66f61c204ec236cf8ad9edfd3e27a937">PeriodicBoundaries</a>() {}
<a name="l00135"></a>00135 
<a name="l00136"></a>00136   <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#aa7921d23950abb00801648c34f389786">~PeriodicBoundaries</a>();
<a name="l00137"></a>00137 
<a name="l00138"></a>00138   <span class="comment">// The periodic neighbor of \p e in direction \p side, if it</span>
<a name="l00139"></a>00139   <span class="comment">// exists.  NULL otherwise</span>
<a name="l00140"></a>00140   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *<a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a06b6e333d6a0ffaee9252b703dfefede">neighbor</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> boundary_id,
<a name="l00141"></a>00141                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> &amp;point_locator,
<a name="l00142"></a>00142                        <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *e,
<a name="l00143"></a>00143                        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="xdr__io_8C.php#a538c9c249908c84b07be8ce1400b82c9">side</a>) <span class="keyword">const</span>;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145 <span class="keyword">private</span>:
<a name="l00146"></a>00146 };
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00151"></a>00151 <span class="comment">// PeriodicBoundary inline member functions</span>
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 <span class="keyword">inline</span>
<a name="l00154"></a>00154 PeriodicBoundary *
<a name="l00155"></a><a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a5ab69d80e060239a949a58c03bdf57f6">00155</a> <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a5ab69d80e060239a949a58c03bdf57f6">PeriodicBoundaries::boundary</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)
<a name="l00156"></a>00156 {
<a name="l00157"></a>00157   <a class="code" href="classstd_1_1iterator.php">iterator</a> i = this-&gt;find(<span class="keywordtype">id</span>);
<a name="l00158"></a>00158   <span class="keywordflow">if</span> (i == this-&gt;end())
<a name="l00159"></a>00159     <span class="keywordflow">return</span> NULL;
<a name="l00160"></a>00160   <span class="keywordflow">return</span> i-&gt;second;
<a name="l00161"></a>00161 }
<a name="l00162"></a>00162 
<a name="l00163"></a>00163 <span class="keyword">inline</span>
<a name="l00164"></a>00164 <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PeriodicBoundary.php">PeriodicBoundary</a> *
<a name="l00165"></a><a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a08ffd39279126eac611809c20e79daa8">00165</a> <a class="code" href="classlibMesh_1_1PeriodicBoundaries.php#a5ab69d80e060239a949a58c03bdf57f6">PeriodicBoundaries::boundary</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="keywordtype">id</span>)<span class="keyword"> const</span>
<a name="l00166"></a>00166 <span class="keyword"></span>{
<a name="l00167"></a>00167   const_iterator i = this-&gt;find(<span class="keywordtype">id</span>);
<a name="l00168"></a>00168   <span class="keywordflow">if</span> (i == this-&gt;end())
<a name="l00169"></a>00169     <span class="keywordflow">return</span> NULL;
<a name="l00170"></a>00170   <span class="keywordflow">return</span> i-&gt;second;
<a name="l00171"></a>00171 }
<a name="l00172"></a>00172 
<a name="l00173"></a>00173 } <span class="comment">// namespace libMesh</span>
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 <span class="preprocessor">#endif // LIBMESH_ENABLE_PERIODIC</span>
<a name="l00176"></a>00176 <span class="preprocessor"></span>
<a name="l00177"></a>00177 <span class="preprocessor">#endif // __periodic_boundaries_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
