<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_diff_solver.C</div>  </div>
</div>
<div class="contents">
<a href="petsc__diff__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_diff_solver.C 4369 2011-04-19 22:30:47Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="diff__system_8h.php">diff_system.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__logging_8h.php">libmesh_logging.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="petsc__diff__solver_8h.php">petsc_diff_solver.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00034"></a>00034 <span class="comment">// Functions with C linkage to pass to PETSc.  PETSc will call these</span>
<a name="l00035"></a>00035 <span class="comment">// methods as needed.</span>
<a name="l00036"></a>00036 <span class="comment">//</span>
<a name="l00037"></a>00037 <span class="comment">// Since they must have C linkage they have no knowledge of a namespace.</span>
<a name="l00038"></a>00038 <span class="comment">// Give them an obscure name to avoid namespace pollution.</span>
<a name="l00039"></a>00039 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span>
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041   <span class="comment">// Older versions of PETSc do not have the different int typedefs.</span>
<a name="l00042"></a>00042   <span class="comment">// On 64-bit machines, PetscInt may actually be a long long int.</span>
<a name="l00043"></a>00043   <span class="comment">// This change occurred in Petsc-2.2.1.</span>
<a name="l00044"></a>00044 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00045"></a><a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">00045</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a>;
<a name="l00046"></a><a class="code" href="namespacelibMesh.php#a7ad10af8599548704f3938639a33b5ca">00046</a>   <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a7ad10af8599548704f3938639a33b5ca">PetscInt</a>;
<a name="l00047"></a>00047 <span class="preprocessor">#endif</span>
<a name="l00048"></a>00048 <span class="preprocessor"></span>
<a name="l00049"></a>00049 <span class="comment">// Function to hand to PETSc&#39;s SNES,</span>
<a name="l00050"></a>00050 <span class="comment">// which monitors convergence at X</span>
<a name="l00051"></a>00051 PetscErrorCode
<a name="l00052"></a><a class="code" href="namespacelibMesh.php#a613b6eab35f6e37ecc06c3f571fd0be9">00052</a> <a class="code" href="namespacelibMesh.php#a613b6eab35f6e37ecc06c3f571fd0be9">__libmesh_petsc_diff_solver_monitor</a> (SNES, PetscInt its,
<a name="l00053"></a>00053                                      PetscReal fnorm, <span class="keywordtype">void</span> *ctx)
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <a class="code" href="classlibMesh_1_1PetscDiffSolver.php">PetscDiffSolver</a>&amp; solver =
<a name="l00056"></a>00056     *(<span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscDiffSolver.php">PetscDiffSolver</a>*<span class="keyword">&gt;</span> (ctx));
<a name="l00057"></a>00057 
<a name="l00058"></a>00058   <span class="keywordflow">if</span> (solver.<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00059"></a>00059     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  PetscDiffSolver step &quot;</span> &lt;&lt; its
<a name="l00060"></a>00060                  &lt;&lt; <span class="stringliteral">&quot;, |residual|_2 = &quot;</span> &lt;&lt; fnorm &lt;&lt; std::endl;
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordflow">return</span> 0;
<a name="l00063"></a>00063 }
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">// Functions to hand to PETSc&#39;s SNES,</span>
<a name="l00066"></a>00066 <span class="comment">// which compute the residual or jacobian at X</span>
<a name="l00067"></a>00067 PetscErrorCode
<a name="l00068"></a><a class="code" href="namespacelibMesh.php#affa5ca83fdf2688afa4d87301c23a2af">00068</a> <a class="code" href="namespacelibMesh.php#affa5ca83fdf2688afa4d87301c23a2af">__libmesh_petsc_diff_solver_residual</a> (SNES, Vec x, Vec r, <span class="keywordtype">void</span> *ctx)
<a name="l00069"></a>00069 {
<a name="l00070"></a>00070   libmesh_assert (x   != NULL);
<a name="l00071"></a>00071   libmesh_assert (r   != NULL);
<a name="l00072"></a>00072   libmesh_assert (ctx != NULL);
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <a class="code" href="classlibMesh_1_1PetscDiffSolver.php">PetscDiffSolver</a>&amp; solver =
<a name="l00075"></a>00075     *(<span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscDiffSolver.php">PetscDiffSolver</a>*<span class="keyword">&gt;</span> (ctx));
<a name="l00076"></a>00076   <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a> &amp;sys = solver.<a class="code" href="classlibMesh_1_1DiffSolver.php#a5409063e9676de368c09c023df7a92f8">system</a>();
<a name="l00077"></a>00077 
<a name="l00078"></a>00078   <span class="keywordflow">if</span> (solver.<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00079"></a>00079     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Assembling the residual&quot;</span> &lt;&lt; std::endl;
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a>&amp; X_system =
<a name="l00082"></a>00082     *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a>&amp; R_system =
<a name="l00084"></a>00084     *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>);
<a name="l00085"></a>00085   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a> X_input(x), R_input(r);
<a name="l00086"></a>00086 
<a name="l00087"></a>00087   <span class="comment">// DiffSystem assembles from the solution and into the rhs, so swap</span>
<a name="l00088"></a>00088   <span class="comment">// those with our input vectors before assembling.  They&#39;ll probably</span>
<a name="l00089"></a>00089   <span class="comment">// already be references to the same vectors, but PETSc might do</span>
<a name="l00090"></a>00090   <span class="comment">// something tricky.</span>
<a name="l00091"></a>00091   X_input.swap(X_system);
<a name="l00092"></a>00092   R_input.swap(R_system);
<a name="l00093"></a>00093 
<a name="l00094"></a>00094   <span class="comment">// We may need to correct a non-conforming solution</span>
<a name="l00095"></a>00095   sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>(sys);
<a name="l00096"></a>00096 
<a name="l00097"></a>00097   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00098"></a>00098   sys.<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00099"></a>00099 
<a name="l00100"></a>00100   <span class="comment">// Do DiffSystem assembly</span>
<a name="l00101"></a>00101   sys.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">true</span>, <span class="keyword">false</span>);
<a name="l00102"></a>00102   R_system.close();
<a name="l00103"></a>00103 
<a name="l00104"></a>00104   <span class="comment">// Swap back</span>
<a name="l00105"></a>00105   X_input.swap(X_system);
<a name="l00106"></a>00106   R_input.swap(R_system);
<a name="l00107"></a>00107 
<a name="l00108"></a>00108   <span class="comment">// No errors, we hope</span>
<a name="l00109"></a>00109   <span class="keywordflow">return</span> 0;
<a name="l00110"></a>00110 }
<a name="l00111"></a>00111 
<a name="l00112"></a>00112 
<a name="l00113"></a>00113 PetscErrorCode
<a name="l00114"></a><a class="code" href="namespacelibMesh.php#ae611e921fcdf335e9af2cb04227257d0">00114</a> <a class="code" href="namespacelibMesh.php#ae611e921fcdf335e9af2cb04227257d0">__libmesh_petsc_diff_solver_jacobian</a> (SNES, Vec x, Mat *j, Mat *pc,
<a name="l00115"></a>00115                                       MatStructure *msflag, <span class="keywordtype">void</span> *ctx)
<a name="l00116"></a>00116 {
<a name="l00117"></a>00117   libmesh_assert (x   != NULL);
<a name="l00118"></a>00118   libmesh_assert (j   != NULL);
<a name="l00119"></a>00119 <span class="comment">//  libmesh_assert (pc  == j);  // We don&#39;t use separate preconditioners yet</span>
<a name="l00120"></a>00120   libmesh_assert (ctx != NULL);
<a name="l00121"></a>00121 
<a name="l00122"></a>00122   <a class="code" href="classlibMesh_1_1PetscDiffSolver.php">PetscDiffSolver</a>&amp; solver =
<a name="l00123"></a>00123     *(<span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscDiffSolver.php">PetscDiffSolver</a>*<span class="keyword">&gt;</span> (ctx));
<a name="l00124"></a>00124   <a class="code" href="classlibMesh_1_1ImplicitSystem.php">ImplicitSystem</a> &amp;sys = solver.<a class="code" href="classlibMesh_1_1DiffSolver.php#a5409063e9676de368c09c023df7a92f8">system</a>();
<a name="l00125"></a>00125 
<a name="l00126"></a>00126   <span class="keywordflow">if</span> (solver.<a class="code" href="classlibMesh_1_1DiffSolver.php#adc3f130493a6c985cb08116b9ba848ec">verbose</a>)
<a name="l00127"></a>00127     <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Assembling the Jacobian&quot;</span> &lt;&lt; std::endl;
<a name="l00128"></a>00128 
<a name="l00129"></a>00129   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a>&amp; X_system =
<a name="l00130"></a>00130     *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>());
<a name="l00131"></a>00131   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a> X_input(x);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a> J_input(*pc);
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a>&amp; J_system =
<a name="l00135"></a>00135     *libmesh_cast_ptr&lt;PetscMatrix&lt;Number&gt;*&gt;(sys.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>);
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// DiffSystem assembles from the solution and into the jacobian, so</span>
<a name="l00138"></a>00138   <span class="comment">// swap those with our input vectors before assembling.  They&#39;ll</span>
<a name="l00139"></a>00139   <span class="comment">// probably already be references to the same vectors, but PETSc</span>
<a name="l00140"></a>00140   <span class="comment">// might do something tricky.</span>
<a name="l00141"></a>00141   X_input.<a class="code" href="classlibMesh_1_1PetscMatrix.php#a89482535aa806cb4e39136443ccbb20d">swap</a>(X_system);
<a name="l00142"></a>00142   J_input.<a class="code" href="classlibMesh_1_1PetscMatrix.php#a89482535aa806cb4e39136443ccbb20d">swap</a>(J_system);
<a name="l00143"></a>00143 
<a name="l00144"></a>00144   <span class="comment">// We may need to correct a non-conforming solution</span>
<a name="l00145"></a>00145   sys.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>(sys);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="comment">// We may need to localize a parallel solution</span>
<a name="l00148"></a>00148   sys.<a class="code" href="classlibMesh_1_1System.php#ab9d81ac9c1787c43fb87cf13d37741ee">update</a>();
<a name="l00149"></a>00149 
<a name="l00150"></a>00150   <span class="comment">// Do DiffSystem assembly</span>
<a name="l00151"></a>00151   sys.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a280e85a81fb1e54bb5c012a176f367c7">assembly</a>(<span class="keyword">false</span>, <span class="keyword">true</span>);
<a name="l00152"></a>00152   J_system.<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a>();
<a name="l00153"></a>00153 
<a name="l00154"></a>00154   <span class="comment">// Swap back</span>
<a name="l00155"></a>00155   X_input.swap(X_system);
<a name="l00156"></a>00156   J_input.<a class="code" href="classlibMesh_1_1PetscMatrix.php#a89482535aa806cb4e39136443ccbb20d">swap</a>(J_system);
<a name="l00157"></a>00157 
<a name="l00158"></a>00158   *msflag = SAME_NONZERO_PATTERN;
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   <span class="comment">// No errors, we hope</span>
<a name="l00161"></a>00161   <span class="keywordflow">return</span> 0;
<a name="l00162"></a>00162 }
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 } <span class="comment">// extern &quot;C&quot;</span>
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a><a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a6b9a0a462ff5ba5ea61791b0a80e56a9">00167</a> <a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a6b9a0a462ff5ba5ea61791b0a80e56a9">PetscDiffSolver::PetscDiffSolver</a> (<a class="code" href="classlibMesh_1_1ImplicitSystem.php">sys_type</a>&amp; s)
<a name="l00168"></a>00168   : <a class="code" href="classlibMesh_1_1DiffSolver.php">Parent</a>(s)
<a name="l00169"></a>00169 {
<a name="l00170"></a>00170 }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a3842d47d3c254ec07cf7ebf3ec7f22f8">00173</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a3842d47d3c254ec07cf7ebf3ec7f22f8">PetscDiffSolver::init</a> ()
<a name="l00174"></a>00174 {
<a name="l00175"></a>00175   START_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00176"></a>00176 
<a name="l00177"></a>00177   <a class="code" href="classlibMesh_1_1DiffSolver.php#a7bd8581a3550252487bc90a76733747c">Parent::init</a>();
<a name="l00178"></a>00178 
<a name="l00179"></a>00179   <span class="keywordtype">int</span> ierr=0;
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,1,2)</span>
<a name="l00182"></a>00182 <span class="preprocessor"></span>  <span class="comment">// At least until Petsc 2.1.1, the SNESCreate had a different</span>
<a name="l00183"></a>00183   <span class="comment">// calling syntax.  The second argument was of type SNESProblemType,</span>
<a name="l00184"></a>00184   <span class="comment">// and could have a value of either SNES_NONLINEAR_EQUATIONS or</span>
<a name="l00185"></a>00185   <span class="comment">// SNES_UNCONSTRAINED_MINIMIZATION.</span>
<a name="l00186"></a>00186   ierr = SNESCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, SNES_NONLINEAR_EQUATIONS, &amp;<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>);
<a name="l00187"></a>00187   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00188"></a>00188 <span class="preprocessor">#else</span>
<a name="l00189"></a>00189 <span class="preprocessor"></span>  ierr = SNESCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>);
<a name="l00190"></a>00190   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00191"></a>00191 <span class="preprocessor">#endif</span>
<a name="l00192"></a>00192 <span class="preprocessor"></span>
<a name="l00193"></a>00193 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00194"></a>00194 <span class="preprocessor"></span>  ierr = SNESSetMonitor (<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>, <a class="code" href="namespacelibMesh.php#a613b6eab35f6e37ecc06c3f571fd0be9">__libmesh_petsc_diff_solver_monitor</a>,
<a name="l00195"></a>00195                          <span class="keyword">this</span>, PETSC_NULL);
<a name="l00196"></a>00196 <span class="preprocessor">#else</span>
<a name="l00197"></a>00197 <span class="preprocessor"></span>  <span class="comment">// API name change in PETSc 2.3.3</span>
<a name="l00198"></a>00198   ierr = SNESMonitorSet (<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>, <a class="code" href="namespacelibMesh.php#a613b6eab35f6e37ecc06c3f571fd0be9">__libmesh_petsc_diff_solver_monitor</a>,
<a name="l00199"></a>00199                          <span class="keyword">this</span>, PETSC_NULL);
<a name="l00200"></a>00200 <span class="preprocessor">#endif</span>
<a name="l00201"></a>00201 <span class="preprocessor"></span>  CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00202"></a>00202 
<a name="l00203"></a>00203   ierr = SNESSetFromOptions(<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>);
<a name="l00204"></a>00204   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00205"></a>00205 
<a name="l00206"></a>00206   STOP_LOG(<span class="stringliteral">&quot;init()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00207"></a>00207 }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a><a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a9ec651efc44e423e8c3706f68144de5d">00211</a> <a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a9ec651efc44e423e8c3706f68144de5d">PetscDiffSolver::~PetscDiffSolver</a> ()
<a name="l00212"></a>00212 {
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 
<a name="l00216"></a>00216 
<a name="l00217"></a><a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a27066a9f8ec515125131a1420e03b9d1">00217</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a27066a9f8ec515125131a1420e03b9d1">PetscDiffSolver::clear</a>()
<a name="l00218"></a>00218 {
<a name="l00219"></a>00219   START_LOG(<span class="stringliteral">&quot;clear()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00220"></a>00220 
<a name="l00221"></a>00221   <span class="keywordtype">int</span> ierr=0;
<a name="l00222"></a>00222 
<a name="l00223"></a>00223   ierr = SNESDestroy(<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>);
<a name="l00224"></a>00224   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00225"></a>00225 
<a name="l00226"></a>00226   STOP_LOG(<span class="stringliteral">&quot;clear()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00227"></a>00227 }
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a><a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a714db7078df67d306eb49d74efdb1c38">00231</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a714db7078df67d306eb49d74efdb1c38">PetscDiffSolver::reinit</a>()
<a name="l00232"></a>00232 {
<a name="l00233"></a>00233   <a class="code" href="classlibMesh_1_1DiffSolver.php#ac7f6532da1a45d35dee39e82ae383d17">Parent::reinit</a>();
<a name="l00234"></a>00234 }
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 
<a name="l00237"></a>00237 
<a name="l00238"></a><a class="code" href="classlibMesh_1_1PetscDiffSolver.php#ad6a4758f07942760d95ba3c1fbcd1137">00238</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscDiffSolver.php#ad6a4758f07942760d95ba3c1fbcd1137">PetscDiffSolver::solve</a>()
<a name="l00239"></a>00239 {
<a name="l00240"></a>00240   this-&gt;<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a3842d47d3c254ec07cf7ebf3ec7f22f8">init</a>();
<a name="l00241"></a>00241 
<a name="l00242"></a>00242   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00243"></a>00243 
<a name="l00244"></a>00244   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a> &amp;x =
<a name="l00245"></a>00245     *(libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1System.php#ae1846816118b13d942071124f8a74808">solution</a>.<a class="code" href="classlibMesh_1_1AutoPtr.php#a47c8f66bc54219761cefe575c26a81dd" title="Bypassing the smart pointer.">get</a>()));
<a name="l00246"></a>00246   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a> &amp;jac =
<a name="l00247"></a>00247     *(libmesh_cast_ptr&lt;PetscMatrix&lt;Number&gt;*&gt;(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ImplicitSystem.php#a549bd875b4fc99cbd5d1f7ba169feca7">matrix</a>));
<a name="l00248"></a>00248   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a> &amp;r =
<a name="l00249"></a>00249     *(libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1ExplicitSystem.php#a98fde3a02d1256dbc31891c88986bddc">rhs</a>));
<a name="l00250"></a>00250 
<a name="l00251"></a>00251   x.<a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a>();
<a name="l00252"></a>00252   r.<a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a>();
<a name="l00253"></a>00253   jac.<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a>();
<a name="l00254"></a>00254 
<a name="l00255"></a>00255 <span class="preprocessor">#ifdef LIBMESH_ENABLE_AMR</span>
<a name="l00256"></a>00256 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>.<a class="code" href="classlibMesh_1_1System.php#a3b392c8791f781092d6326e51856f553">get_dof_map</a>().<a class="code" href="classlibMesh_1_1DofMap.php#a938f3e6db23b740002490ac88d1bb60a">enforce_constraints_exactly</a>(<a class="code" href="classlibMesh_1_1DiffSolver.php#a8dd9723b1eccf691e4e0591ac6d0eaef">_system</a>);
<a name="l00257"></a>00257 <span class="preprocessor">#endif</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span>
<a name="l00259"></a>00259   <span class="keywordtype">int</span> ierr = 0;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261   ierr = SNESSetFunction (<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>, r.<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>(),
<a name="l00262"></a>00262                           <a class="code" href="namespacelibMesh.php#affa5ca83fdf2688afa4d87301c23a2af">__libmesh_petsc_diff_solver_residual</a>, <span class="keyword">this</span>);
<a name="l00263"></a>00263     CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00264"></a>00264 
<a name="l00265"></a>00265   ierr = SNESSetJacobian (<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>, jac.<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), jac.<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(),
<a name="l00266"></a>00266                           <a class="code" href="namespacelibMesh.php#ae611e921fcdf335e9af2cb04227257d0">__libmesh_petsc_diff_solver_jacobian</a>, <span class="keyword">this</span>);
<a name="l00267"></a>00267     CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00268"></a>00268 
<a name="l00269"></a>00269 <span class="preprocessor"># if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00270"></a>00270 <span class="preprocessor"></span>
<a name="l00271"></a>00271   ierr = SNESSolve (<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>, x.<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>(), &amp;<a class="code" href="classlibMesh_1_1DiffSolver.php#ac091cec59ab726fa5ecd7475fe83d8df">_outer_iterations</a>);
<a name="l00272"></a>00272          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00273"></a>00273 
<a name="l00274"></a>00274 <span class="comment">// 2.2.x style</span>
<a name="l00275"></a>00275 <span class="preprocessor">#elif PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00276"></a>00276 <span class="preprocessor"></span>
<a name="l00277"></a>00277   ierr = SNESSolve (<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>, x.<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>());
<a name="l00278"></a>00278          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 <span class="comment">// 2.3.x &amp; newer style</span>
<a name="l00281"></a>00281 <span class="preprocessor">#else</span>
<a name="l00282"></a>00282 <span class="preprocessor"></span>
<a name="l00283"></a>00283   ierr = SNESSolve (<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a76688574da713d6b0177bfbb20a83a49">_snes</a>, PETSC_NULL, x.<a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a>());
<a name="l00284"></a>00284          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00285"></a>00285 
<a name="l00286"></a>00286 <span class="preprocessor">#endif</span>
<a name="l00287"></a>00287 <span class="preprocessor"></span>
<a name="l00288"></a>00288   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscDiffSolver&quot;</span>);
<a name="l00289"></a>00289 
<a name="l00290"></a>00290   this-&gt;<a class="code" href="classlibMesh_1_1PetscDiffSolver.php#a27066a9f8ec515125131a1420e03b9d1">clear</a>();
<a name="l00291"></a>00291 
<a name="l00292"></a>00292   <span class="comment">// FIXME - We&#39;ll worry about getting the solve result right later...</span>
<a name="l00293"></a>00293   
<a name="l00294"></a>00294   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1DiffSolver.php#aa4773581b155951a6e3d7397dd174450af59076b835010125f7a7aba2501f38f7">DiffSolver::CONVERGED_RELATIVE_RESIDUAL</a>;
<a name="l00295"></a>00295 }
<a name="l00296"></a>00296 
<a name="l00297"></a>00297 } <span class="comment">// namespace libMesh</span>
<a name="l00298"></a>00298 
<a name="l00299"></a>00299 <span class="preprocessor">#endif // LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
