<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d6d810ec48df3afe8aec0deeb10d5fcf.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_linear_solver.h</div>  </div>
</div>
<div class="contents">
<a href="petsc__linear__solver_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_linear_solver.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __petsc_linear_solver_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_linear_solver_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="linear__solver_8h.php">linear_solver.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00040"></a>00040 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00041"></a>00041 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;petscsles.h&gt;</span>
<a name="l00043"></a>00043 <span class="preprocessor">#else</span>
<a name="l00044"></a>00044 <span class="preprocessor"></span><span class="preprocessor">#  include &lt;petscksp.h&gt;</span>
<a name="l00045"></a>00045 <span class="preprocessor">#endif</span>
<a name="l00046"></a>00046 <span class="preprocessor"></span>EXTERN_C_FOR_PETSC_END
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00049"></a>00049 <span class="comment">// Functions with C linkage to pass to PETSc.  PETSc will call these</span>
<a name="l00050"></a>00050 <span class="comment">// methods as needed for preconditioning</span>
<a name="l00051"></a>00051 <span class="comment">// </span>
<a name="l00052"></a>00052 <span class="comment">// Since they must have C linkage they have no knowledge of a namespace.</span>
<a name="l00053"></a>00053 <span class="comment">// Give them an obscure name to avoid namespace pollution.</span>
<a name="l00054"></a>00054 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span>
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   <span class="comment">// Older versions of PETSc do not have the different int typedefs.</span>
<a name="l00057"></a>00057   <span class="comment">// On 64-bit machines, PetscInt may actually be a long long int.</span>
<a name="l00058"></a>00058   <span class="comment">// This change occurred in Petsc-2.2.1.</span>
<a name="l00059"></a>00059 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00060"></a><a class="code" href="petsc__linear__solver_8h.php#a91cad2aac2280ad0d8a5796908f49a74">00060</a> <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8h.php#a91cad2aac2280ad0d8a5796908f49a74">PetscErrorCode</a>;
<a name="l00061"></a><a class="code" href="petsc__linear__solver_8h.php#a515706180f960b30595b607f2d734d14">00061</a>   <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="petsc__linear__solver_8h.php#a515706180f960b30595b607f2d734d14">PetscInt</a>;
<a name="l00062"></a>00062 <span class="preprocessor">#endif</span>
<a name="l00063"></a>00063 <span class="preprocessor"></span>
<a name="l00064"></a>00064 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,1) &amp;&amp; PETSC_VERSION_RELEASE</span>
<a name="l00065"></a>00065 <span class="preprocessor"></span>
<a name="l00069"></a>00069   PetscErrorCode <a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a> (<span class="keywordtype">void</span> * ctx);
<a name="l00070"></a>00070 
<a name="l00075"></a>00075   PetscErrorCode <a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>(<span class="keywordtype">void</span> *ctx, Vec x, Vec y);
<a name="l00076"></a>00076 <span class="preprocessor">#else</span>
<a name="l00077"></a>00077 <span class="preprocessor"></span>  PetscErrorCode <a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a> (PC);
<a name="l00078"></a>00078   PetscErrorCode <a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>(PC, Vec x, Vec y);
<a name="l00079"></a>00079 <span class="preprocessor">#endif</span>
<a name="l00080"></a>00080 <span class="preprocessor"></span>} <span class="comment">// end extern &quot;C&quot;</span>
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 <span class="keyword">namespace </span>libMesh
<a name="l00084"></a>00084 {
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="comment">// forward declarations</span>
<a name="l00087"></a>00087 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>PetscMatrix;
<a name="l00088"></a>00088 
<a name="l00097"></a>00097 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00098"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php">00098</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscLinearSolver.php">PetscLinearSolver</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1LinearSolver.php">LinearSolver</a>&lt;T&gt;
<a name="l00099"></a>00099 {
<a name="l00100"></a>00100 <span class="keyword">public</span>:
<a name="l00104"></a>00104   <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ab09320c55165f1c994f2f9e34043b3fe">PetscLinearSolver</a> ();
<a name="l00105"></a>00105     
<a name="l00109"></a>00109   <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1e98c6de5eb553ba0262291ac49a8743">~PetscLinearSolver</a> ();
<a name="l00110"></a>00110   
<a name="l00114"></a>00114   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adafec932e0a6a770391d756a9b21fa14">clear</a> ();
<a name="l00115"></a>00115 
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">init</a> ();
<a name="l00120"></a>00120   
<a name="l00124"></a>00124   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">init</a> (<a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* matrix);
<a name="l00125"></a>00125 
<a name="l00133"></a>00133   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a7252a37818ad8bab9bda8b95b2ec7162">restrict_solve_to</a> (<span class="keyword">const</span> std::vector&lt;unsigned int&gt;* <span class="keyword">const</span> dofs,
<a name="l00134"></a>00134                                   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137">SubsetSolveMode</a> subset_solve_mode=<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>);
<a name="l00135"></a>00135 
<a name="l00140"></a>00140   std::pair&lt;unsigned int, Real&gt; 
<a name="l00141"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">00141</a>   <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix_in,
<a name="l00142"></a>00142          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution_in,
<a name="l00143"></a>00143          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs_in,
<a name="l00144"></a>00144          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00145"></a>00145          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its)
<a name="l00146"></a>00146   {
<a name="l00147"></a>00147     <span class="keywordflow">return</span> this-&gt;<a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">solve</a>(matrix_in, matrix_in, solution_in, rhs_in, tol, m_its);
<a name="l00148"></a>00148   }
<a name="l00149"></a>00149 
<a name="l00165"></a>00165   std::pair&lt;unsigned int, Real&gt; 
<a name="l00166"></a>00166   <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;matrix,
<a name="l00167"></a>00167          <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>  &amp;preconditioner,
<a name="l00168"></a>00168          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;solution,
<a name="l00169"></a>00169          <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;rhs,
<a name="l00170"></a>00170          <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00171"></a>00171          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00172"></a>00172 
<a name="l00176"></a>00176   std::pair&lt;unsigned int, Real&gt;
<a name="l00177"></a>00177     <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00178"></a>00178            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00179"></a>00179            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00180"></a>00180            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00181"></a>00181            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00182"></a>00182   
<a name="l00188"></a>00188   <span class="keyword">virtual</span> std::pair&lt;unsigned int, Real&gt;
<a name="l00189"></a>00189     <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#adcb5c8a344e2fd9ab1c9a39ff560d087">solve</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1ShellMatrix.php">ShellMatrix&lt;T&gt;</a>&amp; shell_matrix,
<a name="l00190"></a>00190            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; precond_matrix,
<a name="l00191"></a>00191            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; solution_in,
<a name="l00192"></a>00192            <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; rhs_in,
<a name="l00193"></a>00193            <span class="keyword">const</span> <span class="keywordtype">double</span> tol,
<a name="l00194"></a>00194            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_its);
<a name="l00195"></a>00195   
<a name="l00201"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1aae14fe9e4e8e350918d1f954fd0444">00201</a>   PC <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1aae14fe9e4e8e350918d1f954fd0444">pc</a>() { this-&gt;<a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">init</a>(); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#aec0962b22c0c4b93c85a0eb73f356d08">_pc</a>; }
<a name="l00202"></a>00202 
<a name="l00208"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8f722acb8c35301ed1581726d4024d60">00208</a>   KSP <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8f722acb8c35301ed1581726d4024d60">ksp</a>() { this-&gt;<a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a634b1f121de9d575606291469cd325b1">init</a>(); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8ab7a17b361ee3fc29048f828a3c2735">_ksp</a>; }
<a name="l00209"></a>00209   
<a name="l00214"></a>00214   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1d8c73be13b0e349132fbd2f1a7e0efc">get_residual_history</a>(std::vector&lt;double&gt;&amp; hist);
<a name="l00215"></a>00215 
<a name="l00222"></a>00222   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a37641e5e49a89c36098322f1e5b1f0d8">get_initial_residual</a>();
<a name="l00223"></a>00223 
<a name="l00228"></a>00228   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ae6d4b32b1157d3ac64bc48a1f0e63720">print_converged_reason</a>();
<a name="l00229"></a>00229   
<a name="l00230"></a>00230 <span class="keyword">private</span>:
<a name="l00231"></a>00231 
<a name="l00236"></a>00236   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a7ba2130af69add0da3a7526c79095090">set_petsc_solver_type</a> ();
<a name="l00237"></a>00237 
<a name="l00241"></a>00241   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a74fc6258796b7724355d07fac71e335b">_petsc_shell_matrix_mult</a>(Mat mat, Vec arg, Vec dest);
<a name="l00242"></a>00242 
<a name="l00246"></a>00246   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#aca0fc5357cfc5608df9c2ed47ae2c471">_petsc_shell_matrix_mult_add</a>(Mat mat, Vec arg, Vec add, Vec dest);
<a name="l00247"></a>00247 
<a name="l00251"></a>00251   <span class="keyword">static</span> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8568708754d996fda7f23f507577b4e9">_petsc_shell_matrix_get_diagonal</a>(Mat mat, Vec dest);
<a name="l00252"></a>00252 
<a name="l00253"></a>00253   <span class="comment">// SLES removed from &gt;= PETSc 2.2.0</span>
<a name="l00254"></a>00254 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00255"></a>00255 <span class="preprocessor"></span>  
<a name="l00259"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a5e0e279c8b33fdebb77bb1866667c69e">00259</a>   SLES <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a5e0e279c8b33fdebb77bb1866667c69e">_sles</a>;
<a name="l00260"></a>00260 
<a name="l00261"></a>00261 <span class="preprocessor">#endif</span>
<a name="l00262"></a>00262 <span class="preprocessor"></span>  
<a name="l00266"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#aec0962b22c0c4b93c85a0eb73f356d08">00266</a>   PC <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#aec0962b22c0c4b93c85a0eb73f356d08">_pc</a>; 
<a name="l00267"></a>00267 
<a name="l00271"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8ab7a17b361ee3fc29048f828a3c2735">00271</a>   KSP <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a8ab7a17b361ee3fc29048f828a3c2735">_ksp</a>;
<a name="l00272"></a>00272 
<a name="l00277"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a9dce039d2a51416c1f7c6c3c281abe28">00277</a>   IS <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a9dce039d2a51416c1f7c6c3c281abe28">_restrict_solve_to_is</a>;
<a name="l00278"></a>00278 
<a name="l00284"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ac6c04c198cbb2b5ad74b6e0565ec5cfb">00284</a>   IS <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ac6c04c198cbb2b5ad74b6e0565ec5cfb">_restrict_solve_to_is_complement</a>;
<a name="l00285"></a>00285 
<a name="l00290"></a>00290   <span class="keywordtype">size_t</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a10a544af293a00d66a7d84696b38172a">_restrict_solve_to_is_local_size</a>(<span class="keywordtype">void</span>)<span class="keyword">const</span>;
<a name="l00291"></a>00291 
<a name="l00297"></a>00297   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a53c040d15138a248ff0f1006aa42a23c">_create_complement_is</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;vec_in);
<a name="l00298"></a>00298 
<a name="l00303"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#aaf9b5a6769afcb1bb671446a30acd467">00303</a>   <a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137">SubsetSolveMode</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#aaf9b5a6769afcb1bb671446a30acd467">_subset_solve_mode</a>;
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 };
<a name="l00306"></a>00306 
<a name="l00307"></a>00307 
<a name="l00308"></a>00308 <span class="comment">/*----------------------- functions ----------------------------------*/</span>
<a name="l00309"></a>00309 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00310"></a>00310 <span class="keyword">inline</span>
<a name="l00311"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ab09320c55165f1c994f2f9e34043b3fe">00311</a>   <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#ab09320c55165f1c994f2f9e34043b3fe">PetscLinearSolver&lt;T&gt;::PetscLinearSolver</a> ():
<a name="l00312"></a>00312     _restrict_solve_to_is(NULL),
<a name="l00313"></a>00313     _restrict_solve_to_is_complement(NULL),
<a name="l00314"></a>00314     _subset_solve_mode(<a class="code" href="namespacelibMeshEnums.php#ae51ba7fafff861eb208c2a74e4649137a3558d936d07644b52ed8f9fed901fb5a" title="Set dofs outside the subset to zero.">SUBSET_ZERO</a>)
<a name="l00315"></a>00315 {
<a name="l00316"></a>00316   <span class="keywordflow">if</span> (<a class="code" href="namespacelibMesh.php#ad3500784bea5fae5979f7c1d783716c0">libMesh::n_processors</a>() == 1)
<a name="l00317"></a>00317     this-&gt;<a class="code" href="classlibMesh_1_1LinearSolver.php#a866f963e86c384dc28fb3dbec70c5b39">_preconditioner_type</a> = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>;
<a name="l00318"></a>00318   <span class="keywordflow">else</span>
<a name="l00319"></a>00319     this-&gt;<a class="code" href="classlibMesh_1_1LinearSolver.php#a866f963e86c384dc28fb3dbec70c5b39">_preconditioner_type</a> = <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4a8f036d61e96c69b14d585f04235613d2">BLOCK_JACOBI_PRECOND</a>;
<a name="l00320"></a>00320 }
<a name="l00321"></a>00321 
<a name="l00322"></a>00322 
<a name="l00323"></a>00323 
<a name="l00324"></a>00324 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00325"></a>00325 <span class="keyword">inline</span>
<a name="l00326"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1e98c6de5eb553ba0262291ac49a8743">00326</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a1e98c6de5eb553ba0262291ac49a8743">PetscLinearSolver&lt;T&gt;::~PetscLinearSolver</a> ()
<a name="l00327"></a>00327 {
<a name="l00328"></a>00328   this-&gt;clear ();
<a name="l00329"></a>00329 }
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 
<a name="l00333"></a>00333 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00334"></a>00334 <span class="keyword">inline</span> <span class="keywordtype">size_t</span>
<a name="l00335"></a>00335 <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a10a544af293a00d66a7d84696b38172a">PetscLinearSolver&lt;T&gt;::</a>
<a name="l00336"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a10a544af293a00d66a7d84696b38172a">00336</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a10a544af293a00d66a7d84696b38172a">_restrict_solve_to_is_local_size</a>(<span class="keywordtype">void</span>)<span class="keyword">const</span>
<a name="l00337"></a>00337 <span class="keyword"></span>{
<a name="l00338"></a>00338   libmesh_assert(_restrict_solve_to_is!=NULL);
<a name="l00339"></a>00339 
<a name="l00340"></a>00340   <a class="code" href="namespacelibMesh.php#a7ad10af8599548704f3938639a33b5ca">PetscInt</a> s;
<a name="l00341"></a>00341   <span class="keywordtype">int</span> ierr = ISGetLocalSize(_restrict_solve_to_is,&amp;s);
<a name="l00342"></a>00342   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">size_t</span><span class="keyword">&gt;</span>(s);
<a name="l00345"></a>00345 }
<a name="l00346"></a>00346 
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 
<a name="l00349"></a>00349 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00350"></a>00350 <span class="keywordtype">void</span>
<a name="l00351"></a><a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a53c040d15138a248ff0f1006aa42a23c">00351</a> <a class="code" href="classlibMesh_1_1PetscLinearSolver.php#a53c040d15138a248ff0f1006aa42a23c">PetscLinearSolver&lt;T&gt;::_create_complement_is</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;
<a name="l00352"></a>00352 #<span class="keywordflow">if</span> PETSC_VERSION_LESS_THAN(3,0,0)
<a name="l00353"></a>00353                                              <span class="comment">// unnamed to avoid compiler &quot;unused parameter&quot; warning</span>
<a name="l00354"></a>00354 #<span class="keywordflow">else</span>
<a name="l00355"></a>00355                                              vec_in
<a name="l00356"></a>00356 #endif
<a name="l00357"></a>00357   )
<a name="l00358"></a>00358 {
<a name="l00359"></a>00359   libmesh_assert(_restrict_solve_to_is!=NULL);
<a name="l00360"></a>00360 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00361"></a>00361 <span class="preprocessor"></span>  <span class="comment">// No ISComplement in PETSc 2.3.3</span>
<a name="l00362"></a>00362   libmesh_not_implemented();
<a name="l00363"></a>00363 <span class="preprocessor">#else</span>
<a name="l00364"></a>00364 <span class="preprocessor"></span>  <span class="keywordflow">if</span>(_restrict_solve_to_is_complement==NULL)
<a name="l00365"></a>00365     {
<a name="l00366"></a>00366       <span class="keywordtype">int</span> ierr = ISComplement(_restrict_solve_to_is,
<a name="l00367"></a>00367                               vec_in.first_local_index(),
<a name="l00368"></a>00368                               vec_in.last_local_index(),
<a name="l00369"></a>00369                               &amp;_restrict_solve_to_is_complement);
<a name="l00370"></a>00370       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00371"></a>00371     }
<a name="l00372"></a>00372 <span class="preprocessor">#endif</span>
<a name="l00373"></a>00373 <span class="preprocessor"></span>}
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 
<a name="l00377"></a>00377 } <span class="comment">// namespace libMesh</span>
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 
<a name="l00380"></a>00380 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00381"></a>00381 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
