<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_macro.h</div>  </div>
</div>
<div class="contents">
<a href="petsc__macro_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_macro.h 4289 2011-03-24 16:24:13Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 <span class="preprocessor">#ifndef __petsc_macro_h__</span>
<a name="l00021"></a>00021 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_macro_h__</span>
<a name="l00022"></a>00022 <span class="preprocessor"></span>
<a name="l00023"></a>00023 <span class="comment">// Local includes</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00027"></a>00027 <span class="preprocessor"></span>
<a name="l00028"></a>00028 <span class="comment">// A convenient macro for comparing PETSc versions.  Returns 1 if the</span>
<a name="l00029"></a>00029 <span class="comment">// current PETSc version is &lt; major.minor.subminor and zero otherwise.</span>
<a name="l00030"></a>00030 <span class="comment">//</span>
<a name="l00031"></a>00031 <span class="comment">// This macro does not require petscversion.h to be included for it to work correctly.</span>
<a name="l00032"></a>00032 <span class="comment">// It instead relies on the PETSc version numbers detected during configure.  Note that if</span>
<a name="l00033"></a>00033 <span class="comment">// LIBMESH_HAVE_PETSC is not defined, none of the LIBMESH_DETECTED_PETSC_VERSION_* variables will</span>
<a name="l00034"></a>00034 <span class="comment">// be defined either.</span>
<a name="l00035"></a>00035 <span class="preprocessor">#define PETSC_VERSION_LESS_THAN(major,minor,subminor)                                                               \</span>
<a name="l00036"></a>00036 <span class="preprocessor">  ((LIBMESH_DETECTED_PETSC_VERSION_MAJOR &lt; (major) ||                                                               \</span>
<a name="l00037"></a>00037 <span class="preprocessor">    (LIBMESH_DETECTED_PETSC_VERSION_MAJOR == (major) &amp;&amp; (LIBMESH_DETECTED_PETSC_VERSION_MINOR &lt; (minor) ||          \</span>
<a name="l00038"></a>00038 <span class="preprocessor">                                  (LIBMESH_DETECTED_PETSC_VERSION_MINOR == (minor) &amp;&amp;                               \</span>
<a name="l00039"></a>00039 <span class="preprocessor">                                   LIBMESH_DETECTED_PETSC_VERSION_SUBMINOR &lt; (subminor))))) ? 1 : 0)</span>
<a name="l00040"></a>00040 <span class="preprocessor"></span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 <span class="comment">// In case the configure test some day fails, we can fall back on including petscversion.h.</span>
<a name="l00044"></a>00044 <span class="comment">// In order to support PETSc 2.3.1, however, we need to use a few hacks that allow us to</span>
<a name="l00045"></a>00045 <span class="comment">// include petscversion.h without including petsc.h first.  These are explained below...</span>
<a name="l00046"></a>00046 <span class="comment">//</span>
<a name="l00047"></a>00047 <span class="comment">// // We have to jump through some hoops here: in Petsc 2.3.1 you cannot</span>
<a name="l00048"></a>00048 <span class="comment">// // include petscversion.h without including petsc.h beforehand.  This</span>
<a name="l00049"></a>00049 <span class="comment">// // was because petscversion.h relied on the existence of</span>
<a name="l00050"></a>00050 <span class="comment">// // PETSC_EXTERN_CXX_BEGIN/END in 2.3.1.  The problem is, we don&#39;t know</span>
<a name="l00051"></a>00051 <span class="comment">// // how to include petsc.h (wrapped or not wrapped in extern &quot;C&quot;) until</span>
<a name="l00052"></a>00052 <span class="comment">// // we know the version!</span>
<a name="l00053"></a>00053 <span class="comment">// </span>
<a name="l00054"></a>00054 <span class="comment">// // First figure out if we need to define PETSC_EXTERN_CXX_BEGIN/END to</span>
<a name="l00055"></a>00055 <span class="comment">// // make petscversion.h happy</span>
<a name="l00056"></a>00056 <span class="comment">// #ifndef PETSC_EXTERN_CXX_BEGIN</span>
<a name="l00057"></a>00057 <span class="comment">// #  define PETSC_EXTERN_CXX_BEGIN</span>
<a name="l00058"></a>00058 <span class="comment">// #  define PETSC_EXTERN_CXX_END</span>
<a name="l00059"></a>00059 <span class="comment">// #  define LIBMESH_PETSC_EXTERN_C_WORKAROUND</span>
<a name="l00060"></a>00060 <span class="comment">// #endif</span>
<a name="l00061"></a>00061 <span class="comment">// </span>
<a name="l00062"></a>00062 <span class="comment">// // Now actually include it</span>
<a name="l00063"></a>00063 <span class="comment">// #include &lt;petscversion.h&gt;</span>
<a name="l00064"></a>00064 <span class="comment">// </span>
<a name="l00065"></a>00065 <span class="comment">// // And finally, get rid of our bogus-definitions.  &lt;petsc.h&gt; will set these itself.</span>
<a name="l00066"></a>00066 <span class="comment">// #ifdef LIBMESH_PETSC_EXTERN_C_WORKAROUND</span>
<a name="l00067"></a>00067 <span class="comment">// #  undef PETSC_EXTERN_CXX_BEGIN</span>
<a name="l00068"></a>00068 <span class="comment">// #  undef PETSC_EXTERN_CXX_END</span>
<a name="l00069"></a>00069 <span class="comment">// #endif</span>
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 <span class="comment">// Make up for missing extern &quot;C&quot; in old PETSc versions</span>
<a name="l00072"></a>00072 <span class="preprocessor">#if !defined(LIBMESH_USE_COMPLEX_NUMBERS) &amp;&amp; PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00073"></a>00073 <span class="preprocessor"></span><span class="preprocessor">#  define EXTERN_C_FOR_PETSC_BEGIN extern &quot;C&quot; {</span>
<a name="l00074"></a>00074 <span class="preprocessor"></span><span class="preprocessor">#  define EXTERN_C_FOR_PETSC_END }</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00076"></a>00076 <span class="preprocessor"></span><span class="preprocessor">#  define EXTERN_C_FOR_PETSC_BEGIN </span>
<a name="l00077"></a>00077 <span class="preprocessor"></span><span class="preprocessor">#  define EXTERN_C_FOR_PETSC_END</span>
<a name="l00078"></a>00078 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00079"></a>00079 <span class="preprocessor"></span>
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 <span class="comment">// Petsc include files</span>
<a name="l00082"></a>00082 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00083"></a>00083 <span class="preprocessor">#include &lt;petsc.h&gt;</span>
<a name="l00084"></a>00084 EXTERN_C_FOR_PETSC_END
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="preprocessor">#if PETSC_VERSION_RELEASE &amp;&amp; PETSC_VERSION_LESS_THAN(3,1,1)</span>
<a name="l00087"></a><a class="code" href="petsc__macro_8h.php#a118393cd7c42d4cc73950defd0e32873">00087</a> <span class="preprocessor"></span><span class="keyword">typedef</span> PetscTruth <a class="code" href="petsc__macro_8h.php#a118393cd7c42d4cc73950defd0e32873">PetscBool</a>;
<a name="l00088"></a>00088 <span class="preprocessor">#endif</span>
<a name="l00089"></a>00089 <span class="preprocessor"></span>
<a name="l00090"></a>00090 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00091"></a>00091 <span class="preprocessor"></span><span class="comment">// This version of PETSc always makes a copy. Current occurrences of PETSC_USE_POINTER are safe with the definition below.</span>
<a name="l00092"></a><a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bc">00092</a> <span class="keyword">typedef</span> <span class="keyword">enum</span> { <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca91bd13386594be61c97445cbac9bbcc9">PETSC_COPY_VALUES</a>, <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca7c3700533291999bc8618cc62bcc8486">PETSC_OWN_POINTER</a>, <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca1e5674c0acb009634823faf5b9c9915d">PETSC_USE_POINTER</a>} <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bc">PetscCopyMode</a>;
<a name="l00093"></a>00093 <span class="preprocessor">#  define ISCreateLibMesh(comm,n,idx,mode,is)                           \</span>
<a name="l00094"></a>00094 <span class="preprocessor">  ((mode) == PETSC_OWN_POINTER                                          \</span>
<a name="l00095"></a>00095 <span class="preprocessor">   ? (ISCreateGeneral((comm),(n),(idx),(is)) || PetscFree(idx) || (*(idx) = PETSC_NULL)) \</span>
<a name="l00096"></a>00096 <span class="preprocessor">   : (ISCreateGeneral((comm),(n),(idx),(is))))</span>
<a name="l00097"></a>00097 <span class="preprocessor"></span><span class="preprocessor">#elif PETSC_VERSION_RELEASE &amp;&amp; PETSC_VERSION_LESS_THAN(3,1,1)</span>
<a name="l00098"></a><a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bc">00098</a> <span class="preprocessor"></span><span class="keyword">typedef</span> <span class="keyword">enum</span> { <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca91bd13386594be61c97445cbac9bbcc9">PETSC_COPY_VALUES</a>, <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca7c3700533291999bc8618cc62bcc8486">PETSC_OWN_POINTER</a>, <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca1e5674c0acb009634823faf5b9c9915d">PETSC_USE_POINTER</a>} <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bc">PetscCopyMode</a>;
<a name="l00099"></a>00099 <span class="preprocessor">#  define ISCreateLibMesh(comm,n,idx,mode,is)           \</span>
<a name="l00100"></a>00100 <span class="preprocessor">  ((mode) == PETSC_USE_POINTER                          \</span>
<a name="l00101"></a>00101 <span class="preprocessor">   ? ISCreateGeneralWithArray((comm),(n),(idx),(is))    \</span>
<a name="l00102"></a>00102 <span class="preprocessor">   : ((mode) == PETSC_OWN_POINTER                       \</span>
<a name="l00103"></a>00103 <span class="preprocessor">      ? ISCreateGeneralNC((comm),(n),(idx),(is))        \</span>
<a name="l00104"></a>00104 <span class="preprocessor">      : ISCreateGeneral((comm),(n),(idx),(is))))</span>
<a name="l00105"></a>00105 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00106"></a>00106 <span class="preprocessor"></span><span class="preprocessor">#  define ISCreateLibMesh(comm,n,idx,mode,is) ISCreateGeneral((comm),(n),(idx),(mode),(is))</span>
<a name="l00107"></a>00107 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00108"></a>00108 <span class="preprocessor"></span>
<a name="l00109"></a>00109 <span class="preprocessor">#endif // LIBMESH_HAVE_PETSC</span>
<a name="l00110"></a>00110 <span class="preprocessor"></span>
<a name="l00111"></a>00111 <span class="preprocessor">#endif // __petsc_macro_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
