<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_matrix.h</div>  </div>
</div>
<div class="contents">
<a href="petsc__matrix_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_matrix.h 4246 2011-03-11 22:24:59Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __petsc_matrix_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_matrix_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &lt;algorithm&gt;</span>
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 <span class="comment">// Local includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="sparse__matrix_8h.php">sparse_matrix.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Macro to identify and debug functions which should be called in</span>
<a name="l00038"></a>00038 <span class="comment">// parallel on parallel matrices but which may be called in serial on</span>
<a name="l00039"></a>00039 <span class="comment">// serial matrices.  This macro will only be valid inside non-static</span>
<a name="l00040"></a>00040 <span class="comment">// PetscMatrix methods</span>
<a name="l00041"></a>00041 <span class="preprocessor">#undef semiparallel_only</span>
<a name="l00042"></a>00042 <span class="preprocessor"></span><span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00043"></a>00043 <span class="preprocessor"></span><span class="preprocessor">  #include &lt;cstring&gt;</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="preprocessor">  #define semiparallel_only() do { if (this-&gt;initialized()) { const char *mytype; \</span>
<a name="l00046"></a>00046 <span class="preprocessor">    MatGetType(_mat,&amp;mytype); \</span>
<a name="l00047"></a>00047 <span class="preprocessor">    if (!strcmp(mytype, MATSEQAIJ)) \</span>
<a name="l00048"></a>00048 <span class="preprocessor">      parallel_only(); } } while (0)</span>
<a name="l00049"></a>00049 <span class="preprocessor"></span><span class="preprocessor">#else</span>
<a name="l00050"></a>00050 <span class="preprocessor"></span><span class="preprocessor">  #define semiparallel_only()</span>
<a name="l00051"></a>00051 <span class="preprocessor"></span><span class="preprocessor">#endif</span>
<a name="l00052"></a>00052 <span class="preprocessor"></span>
<a name="l00053"></a>00053 
<a name="l00057"></a>00057 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00058"></a>00058 <span class="preprocessor"># include &lt;petscmat.h&gt;</span>
<a name="l00059"></a>00059 EXTERN_C_FOR_PETSC_END
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 <span class="keyword">namespace </span>libMesh
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065 
<a name="l00066"></a>00066 <span class="comment">// Forward Declarations</span>
<a name="l00067"></a>00067 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>DenseMatrix;
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 
<a name="l00078"></a>00078 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00079"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php">00079</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix</a>&lt;T&gt;
<a name="l00080"></a>00080 {
<a name="l00081"></a>00081 <span class="keyword">public</span>:
<a name="l00097"></a>00097   <a class="code" href="classlibMesh_1_1PetscMatrix.php#af9267d6f2becfbdaaa0a366d1b35f161">PetscMatrix</a> ();
<a name="l00098"></a>00098 
<a name="l00106"></a>00106   <a class="code" href="classlibMesh_1_1PetscMatrix.php#af9267d6f2becfbdaaa0a366d1b35f161">PetscMatrix</a> (Mat <a class="code" href="classlibMesh_1_1PetscMatrix.php#a98a5ece696171d13e48b822a42bf46c6">m</a>);
<a name="l00107"></a>00107   
<a name="l00113"></a>00113   <a class="code" href="classlibMesh_1_1PetscMatrix.php#a660ec7b00924eb9b14decb9becc79963">~PetscMatrix</a> ();
<a name="l00114"></a>00114 
<a name="l00123"></a>00123   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a700a10746d757d98f55174d774832a9d">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m,
<a name="l00124"></a>00124              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a21ae90af4d712c0f33ca2b2f16c1a8fc">n</a>,
<a name="l00125"></a>00125              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> m_l,
<a name="l00126"></a>00126              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_l,
<a name="l00127"></a>00127              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nnz=30,
<a name="l00128"></a>00128              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> noz=10);
<a name="l00129"></a>00129 
<a name="l00133"></a>00133   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a700a10746d757d98f55174d774832a9d">init</a> ();
<a name="l00134"></a>00134   
<a name="l00141"></a>00141   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a2126e5e36eb3f249acce205ea96995f8">clear</a> ();
<a name="l00142"></a>00142 
<a name="l00147"></a>00147   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#ae8ce5cac1fe09c916c52e2dcd0bea7ea">zero</a> ();
<a name="l00148"></a>00148 
<a name="l00152"></a>00152   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#ae1a8212ad0651377974d3d097f23b2fd">zero_rows</a> (std::vector&lt;int&gt; &amp; rows, T diag_value = 0.0);
<a name="l00153"></a>00153   
<a name="l00159"></a>00159   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a> () <span class="keyword">const</span>;
<a name="l00160"></a>00160   
<a name="l00165"></a>00165   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a98a5ece696171d13e48b822a42bf46c6">m</a> () <span class="keyword">const</span>;
<a name="l00166"></a>00166 
<a name="l00171"></a>00171   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a21ae90af4d712c0f33ca2b2f16c1a8fc">n</a> () <span class="keyword">const</span>;
<a name="l00172"></a>00172 
<a name="l00177"></a>00177   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a195ca4efb603145409af0bc5893a317a">row_start</a> () <span class="keyword">const</span>;
<a name="l00178"></a>00178 
<a name="l00183"></a>00183   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a39fb0f58f5f77b1034ce16b36523d029">row_stop</a> () <span class="keyword">const</span>;
<a name="l00184"></a>00184 
<a name="l00191"></a>00191   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00192"></a>00192             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00193"></a>00193             <span class="keyword">const</span> T value);
<a name="l00194"></a>00194     
<a name="l00203"></a>00203   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a46c640423895a20af74579ecd5d6f0e6">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00204"></a>00204             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00205"></a>00205             <span class="keyword">const</span> T value);
<a name="l00206"></a>00206 
<a name="l00214"></a>00214   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a5b01d18992c31d067686dc76049df29d">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00215"></a>00215                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;rows,
<a name="l00216"></a>00216                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;cols);           
<a name="l00217"></a>00217 
<a name="l00222"></a>00222   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a5b01d18992c31d067686dc76049df29d">add_matrix</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a> &amp;dm,
<a name="l00223"></a>00223                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;dof_indices);            
<a name="l00224"></a>00224       
<a name="l00236"></a>00236   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a46c640423895a20af74579ecd5d6f0e6">add</a> (<span class="keyword">const</span> T a, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X);
<a name="l00237"></a>00237     
<a name="l00256"></a>00256   T <a class="code" href="classlibMesh_1_1PetscMatrix.php#afa05a7d76556d67a36389b3b90975e45">operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00257"></a>00257                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j) <span class="keyword">const</span>;
<a name="l00258"></a>00258 
<a name="l00270"></a>00270   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscMatrix.php#ab528219ea3d2d9d697da233c77730cc1">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00271"></a>00271 
<a name="l00284"></a>00284   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscMatrix.php#aaa985313896c14962e9259095c56085f">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00285"></a>00285 
<a name="l00290"></a>00290   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a478e7ee9d3ec050ca9417512bea516b6">closed</a>() <span class="keyword">const</span>;
<a name="l00291"></a>00291   
<a name="l00299"></a>00299   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#ab24430542992d7c586f2cdf178b329ab">print_personal</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00300"></a>00300 
<a name="l00307"></a>00307   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a999f6d560842d59fe3911cd3fdd76a29">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>) <span class="keyword">const</span>;
<a name="l00308"></a>00308 
<a name="l00312"></a>00312   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a9708988038977263227f90dee91482f9">get_diagonal</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00313"></a>00313 
<a name="l00318"></a>00318   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a31d11117c505d898a56d70e8a5878e1c">get_transpose</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; dest) <span class="keyword">const</span>;
<a name="l00319"></a>00319 
<a name="l00323"></a>00323   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a89482535aa806cb4e39136443ccbb20d">swap</a> (<a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a> &amp;);
<a name="l00324"></a>00324 
<a name="l00330"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">00330</a>   Mat <a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a> () { libmesh_assert (<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>; }
<a name="l00331"></a>00331 
<a name="l00332"></a>00332 <span class="keyword">protected</span>:
<a name="l00333"></a>00333 
<a name="l00343"></a>00343   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#acab00e1ff3c5ad2392f4fb4326444da4">_get_submatrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; submatrix,
<a name="l00344"></a>00344                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows,
<a name="l00345"></a>00345                               <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; cols,
<a name="l00346"></a>00346                               <span class="keyword">const</span> <span class="keywordtype">bool</span> reuse_submatrix) <span class="keyword">const</span>;
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 <span class="keyword">private</span>:
<a name="l00349"></a>00349   
<a name="l00353"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">00353</a>   Mat <a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>;
<a name="l00354"></a>00354 
<a name="l00359"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#aa9dc3865c6533af85bff507f60ccf94d">00359</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#aa9dc3865c6533af85bff507f60ccf94d">_destroy_mat_on_exit</a>;
<a name="l00360"></a>00360 };
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364 
<a name="l00365"></a>00365 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00366"></a>00366 <span class="comment">// PetscMatrix inline members</span>
<a name="l00367"></a>00367 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00368"></a>00368 <span class="keyword">inline</span>
<a name="l00369"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#af9267d6f2becfbdaaa0a366d1b35f161">00369</a> <a class="code" href="classlibMesh_1_1PetscMatrix.php#af9267d6f2becfbdaaa0a366d1b35f161">PetscMatrix&lt;T&gt;::PetscMatrix</a>()
<a name="l00370"></a>00370   : _destroy_mat_on_exit(true)
<a name="l00371"></a>00371 {}
<a name="l00372"></a>00372 
<a name="l00373"></a>00373 
<a name="l00374"></a>00374 
<a name="l00375"></a>00375 
<a name="l00376"></a>00376 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00377"></a>00377 <span class="keyword">inline</span>
<a name="l00378"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a8b68ff10a5725ecf856f18a300a811de">00378</a> <a class="code" href="classlibMesh_1_1PetscMatrix.php#af9267d6f2becfbdaaa0a366d1b35f161">PetscMatrix&lt;T&gt;::PetscMatrix</a>(Mat m)
<a name="l00379"></a>00379   : _destroy_mat_on_exit(false)
<a name="l00380"></a>00380 {
<a name="l00381"></a>00381   this-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a> = <a class="code" href="classlibMesh_1_1PetscMatrix.php#a98a5ece696171d13e48b822a42bf46c6">m</a>;
<a name="l00382"></a>00382   this-&gt;<a class="code" href="classlibMesh_1_1SparseMatrix.php#a9af4f8901ed954b3980801faf2250a55">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00383"></a>00383 }
<a name="l00384"></a>00384 
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00389"></a>00389 <span class="keyword">inline</span>
<a name="l00390"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a660ec7b00924eb9b14decb9becc79963">00390</a> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a660ec7b00924eb9b14decb9becc79963">PetscMatrix&lt;T&gt;::~PetscMatrix</a>()
<a name="l00391"></a>00391 {
<a name="l00392"></a>00392   this-&gt;clear();
<a name="l00393"></a>00393 }
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 
<a name="l00397"></a>00397 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00398"></a>00398 <span class="keyword">inline</span>
<a name="l00399"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">00399</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">PetscMatrix&lt;T&gt;::close</a> ()<span class="keyword"> const</span>
<a name="l00400"></a>00400 <span class="keyword"></span>{
<a name="l00401"></a>00401   semiparallel_only();
<a name="l00402"></a>00402 
<a name="l00403"></a>00403   <span class="comment">// BSK - 1/19/2004</span>
<a name="l00404"></a>00404   <span class="comment">// strictly this check should be OK, but it seems to</span>
<a name="l00405"></a>00405   <span class="comment">// fail on matrix-free matrices.  Do they falsely</span>
<a name="l00406"></a>00406   <span class="comment">// state they are assembled?  Check with the developers...</span>
<a name="l00407"></a>00407 <span class="comment">//   if (this-&gt;closed())</span>
<a name="l00408"></a>00408 <span class="comment">//     return;</span>
<a name="l00409"></a>00409   
<a name="l00410"></a>00410   <span class="keywordtype">int</span> ierr=0;
<a name="l00411"></a>00411  
<a name="l00412"></a>00412   ierr = MatAssemblyBegin (_mat, MAT_FINAL_ASSEMBLY);
<a name="l00413"></a>00413          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00414"></a>00414   ierr = MatAssemblyEnd   (_mat, MAT_FINAL_ASSEMBLY);
<a name="l00415"></a>00415          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00416"></a>00416 }
<a name="l00417"></a>00417 
<a name="l00418"></a>00418 
<a name="l00419"></a>00419 
<a name="l00420"></a>00420 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00421"></a>00421 <span class="keyword">inline</span>
<a name="l00422"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a98a5ece696171d13e48b822a42bf46c6">00422</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a98a5ece696171d13e48b822a42bf46c6">PetscMatrix&lt;T&gt;::m</a> ()<span class="keyword"> const</span>
<a name="l00423"></a>00423 <span class="keyword"></span>{
<a name="l00424"></a>00424   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00425"></a>00425   
<a name="l00426"></a>00426   <span class="keywordtype">int</span> petsc_m=0, petsc_n=0, ierr=0;
<a name="l00427"></a>00427 
<a name="l00428"></a>00428   ierr = MatGetSize (_mat, &amp;petsc_m, &amp;petsc_n);
<a name="l00429"></a>00429 
<a name="l00430"></a>00430   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_m);
<a name="l00431"></a>00431 }
<a name="l00432"></a>00432 
<a name="l00433"></a>00433 
<a name="l00434"></a>00434 
<a name="l00435"></a>00435 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00436"></a>00436 <span class="keyword">inline</span>
<a name="l00437"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a21ae90af4d712c0f33ca2b2f16c1a8fc">00437</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a21ae90af4d712c0f33ca2b2f16c1a8fc">PetscMatrix&lt;T&gt;::n</a> ()<span class="keyword"> const</span>
<a name="l00438"></a>00438 <span class="keyword"></span>{
<a name="l00439"></a>00439   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00440"></a>00440   
<a name="l00441"></a>00441   <span class="keywordtype">int</span> petsc_m=0, petsc_n=0, ierr=0;
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   ierr = MatGetSize (_mat, &amp;petsc_m, &amp;petsc_n);
<a name="l00444"></a>00444 
<a name="l00445"></a>00445   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_n);
<a name="l00446"></a>00446 }
<a name="l00447"></a>00447 
<a name="l00448"></a>00448 
<a name="l00449"></a>00449 
<a name="l00450"></a>00450 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00451"></a>00451 <span class="keyword">inline</span>
<a name="l00452"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a195ca4efb603145409af0bc5893a317a">00452</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a195ca4efb603145409af0bc5893a317a">PetscMatrix&lt;T&gt;::row_start</a> ()<span class="keyword"> const</span>
<a name="l00453"></a>00453 <span class="keyword"></span>{
<a name="l00454"></a>00454   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00455"></a>00455   
<a name="l00456"></a>00456   <span class="keywordtype">int</span> start=0, stop=0, ierr=0;
<a name="l00457"></a>00457 
<a name="l00458"></a>00458   ierr = MatGetOwnershipRange(_mat, &amp;start, &amp;stop);
<a name="l00459"></a>00459          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00460"></a>00460 
<a name="l00461"></a>00461   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(start);
<a name="l00462"></a>00462 }
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 
<a name="l00465"></a>00465 
<a name="l00466"></a>00466 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00467"></a>00467 <span class="keyword">inline</span>
<a name="l00468"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a39fb0f58f5f77b1034ce16b36523d029">00468</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a39fb0f58f5f77b1034ce16b36523d029">PetscMatrix&lt;T&gt;::row_stop</a> ()<span class="keyword"> const</span>
<a name="l00469"></a>00469 <span class="keyword"></span>{
<a name="l00470"></a>00470   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00471"></a>00471   
<a name="l00472"></a>00472   <span class="keywordtype">int</span> start=0, stop=0, ierr=0;
<a name="l00473"></a>00473 
<a name="l00474"></a>00474   ierr = MatGetOwnershipRange(_mat, &amp;start, &amp;stop);
<a name="l00475"></a>00475          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00476"></a>00476 
<a name="l00477"></a>00477   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(stop);
<a name="l00478"></a>00478 }
<a name="l00479"></a>00479 
<a name="l00480"></a>00480 
<a name="l00481"></a>00481 
<a name="l00482"></a>00482 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00483"></a>00483 <span class="keyword">inline</span>
<a name="l00484"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a6bc1216d51322c5e50881b349257614c">00484</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a6bc1216d51322c5e50881b349257614c">PetscMatrix&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00485"></a>00485                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00486"></a>00486                           <span class="keyword">const</span> T value)
<a name="l00487"></a>00487 {  
<a name="l00488"></a>00488   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00489"></a>00489   
<a name="l00490"></a>00490   <span class="keywordtype">int</span> ierr=0, i_val=i, j_val=j;
<a name="l00491"></a>00491 
<a name="l00492"></a>00492   PetscScalar petsc_value = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(value);
<a name="l00493"></a>00493   ierr = MatSetValues(_mat, 1, &amp;i_val, 1, &amp;j_val,
<a name="l00494"></a>00494                       &amp;petsc_value, INSERT_VALUES);
<a name="l00495"></a>00495          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00496"></a>00496 }
<a name="l00497"></a>00497 
<a name="l00498"></a>00498 
<a name="l00499"></a>00499 
<a name="l00500"></a>00500 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00501"></a>00501 <span class="keyword">inline</span>
<a name="l00502"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a46c640423895a20af74579ecd5d6f0e6">00502</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a46c640423895a20af74579ecd5d6f0e6">PetscMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00503"></a>00503                           <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j,
<a name="l00504"></a>00504                           <span class="keyword">const</span> T value)
<a name="l00505"></a>00505 {
<a name="l00506"></a>00506   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00507"></a>00507   
<a name="l00508"></a>00508   <span class="keywordtype">int</span> ierr=0, i_val=i, j_val=j;
<a name="l00509"></a>00509 
<a name="l00510"></a>00510   PetscScalar petsc_value = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(value);
<a name="l00511"></a>00511   ierr = MatSetValues(_mat, 1, &amp;i_val, 1, &amp;j_val,
<a name="l00512"></a>00512                       &amp;petsc_value, ADD_VALUES);
<a name="l00513"></a>00513          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00514"></a>00514 }
<a name="l00515"></a>00515 
<a name="l00516"></a>00516 
<a name="l00517"></a>00517 
<a name="l00518"></a>00518 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00519"></a>00519 <span class="keyword">inline</span>
<a name="l00520"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a48ada2b6f86b0ad4acb5fe030ef00730">00520</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a5b01d18992c31d067686dc76049df29d">PetscMatrix&lt;T&gt;::add_matrix</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseMatrix.php">DenseMatrix&lt;T&gt;</a>&amp; dm,
<a name="l00521"></a>00521                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00522"></a>00522 {
<a name="l00523"></a>00523   this-&gt;add_matrix (dm, dof_indices, dof_indices);
<a name="l00524"></a>00524 }
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 
<a name="l00532"></a>00532 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00533"></a>00533 <span class="keyword">inline</span>
<a name="l00534"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a585e38717c1cb5611595f58c815dc39b">00534</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a46c640423895a20af74579ecd5d6f0e6">PetscMatrix&lt;T&gt;::add</a> (<span class="keyword">const</span> T a_in, <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;X_in)
<a name="l00535"></a>00535 {
<a name="l00536"></a>00536   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00537"></a>00537 
<a name="l00538"></a>00538   <span class="comment">// sanity check. but this cannot avoid </span>
<a name="l00539"></a>00539   <span class="comment">// crash due to incompatible sparsity structure...</span>
<a name="l00540"></a>00540   libmesh_assert (this-&gt;m() == X_in.<a class="code" href="classlibMesh_1_1SparseMatrix.php#ad0f01d9919e7b33f2d614848e494bb44">m</a>());
<a name="l00541"></a>00541   libmesh_assert (this-&gt;n() == X_in.<a class="code" href="classlibMesh_1_1SparseMatrix.php#adf547081169c5a585ea1d7bf816f4edc">n</a>());
<a name="l00542"></a>00542 
<a name="l00543"></a>00543   PetscScalar     a = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>      (a_in);
<a name="l00544"></a>00544   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* X = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt; (&amp;X_in);
<a name="l00545"></a>00545 
<a name="l00546"></a>00546   libmesh_assert (X != NULL);
<a name="l00547"></a>00547   
<a name="l00548"></a>00548   <span class="keywordtype">int</span> ierr=0;
<a name="l00549"></a>00549 
<a name="l00550"></a>00550   <span class="comment">// the matrix from which we copy the values has to be assembled/closed</span>
<a name="l00551"></a>00551   <span class="comment">// X-&gt;close ();</span>
<a name="l00552"></a>00552   libmesh_assert(X-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#a478e7ee9d3ec050ca9417512bea516b6">closed</a>());
<a name="l00553"></a>00553 
<a name="l00554"></a>00554   semiparallel_only();
<a name="l00555"></a>00555 
<a name="l00556"></a>00556 <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00557"></a>00557 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00558"></a>00558 <span class="preprocessor"></span>  
<a name="l00559"></a>00559   ierr = MatAXPY(&amp;a,  X-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>, _mat, SAME_NONZERO_PATTERN);
<a name="l00560"></a>00560          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00561"></a>00561          
<a name="l00562"></a>00562 <span class="comment">// 2.3.x &amp; newer</span>
<a name="l00563"></a>00563 <span class="preprocessor">#else</span>
<a name="l00564"></a>00564 <span class="preprocessor"></span>  
<a name="l00565"></a>00565   ierr = MatAXPY(_mat, a, X-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>, DIFFERENT_NONZERO_PATTERN);
<a name="l00566"></a>00566          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00567"></a>00567          
<a name="l00568"></a>00568 <span class="preprocessor">#endif</span>
<a name="l00569"></a>00569 <span class="preprocessor"></span>}
<a name="l00570"></a>00570 
<a name="l00571"></a>00571 
<a name="l00572"></a>00572 
<a name="l00573"></a>00573 
<a name="l00574"></a>00574 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00575"></a>00575 <span class="keyword">inline</span>
<a name="l00576"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#afa05a7d76556d67a36389b3b90975e45">00576</a> T <a class="code" href="classlibMesh_1_1PetscMatrix.php#afa05a7d76556d67a36389b3b90975e45">PetscMatrix&lt;T&gt;::operator () </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i,
<a name="l00577"></a>00577                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j)<span class="keyword"> const</span>
<a name="l00578"></a>00578 <span class="keyword"></span>{
<a name="l00579"></a>00579   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00582"></a>00582 <span class="preprocessor"></span>
<a name="l00583"></a>00583   <span class="comment">// PETSc 2.2.0 &amp; older</span>
<a name="l00584"></a>00584   PetscScalar *petsc_row;
<a name="l00585"></a>00585   <span class="keywordtype">int</span>* petsc_cols;
<a name="l00586"></a>00586   
<a name="l00587"></a>00587 <span class="preprocessor">#else</span>
<a name="l00588"></a>00588 <span class="preprocessor"></span>  
<a name="l00589"></a>00589   <span class="comment">// PETSc 2.2.1 &amp; newer</span>
<a name="l00590"></a>00590   <span class="keyword">const</span> PetscScalar *petsc_row;
<a name="l00591"></a>00591   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#a7ad10af8599548704f3938639a33b5ca">PetscInt</a>    *petsc_cols;
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 <span class="preprocessor">#endif</span>
<a name="l00594"></a>00594 <span class="preprocessor"></span>  
<a name="l00595"></a>00595   
<a name="l00596"></a>00596   <span class="comment">// If the entry is not in the sparse matrix, it is 0.  </span>
<a name="l00597"></a>00597   T value=0.;  
<a name="l00598"></a>00598   
<a name="l00599"></a>00599   <span class="keywordtype">int</span>
<a name="l00600"></a>00600     ierr=0,
<a name="l00601"></a>00601     ncols=0,
<a name="l00602"></a>00602     i_val=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(i),
<a name="l00603"></a>00603     j_val=static_cast&lt;int&gt;(j);
<a name="l00604"></a>00604   
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   <span class="comment">// the matrix needs to be closed for this to work</span>
<a name="l00607"></a>00607   <span class="comment">// this-&gt;close();</span>
<a name="l00608"></a>00608   <span class="comment">// but closing it is a semiparallel operation; we want operator()</span>
<a name="l00609"></a>00609   <span class="comment">// to run on one processor.</span>
<a name="l00610"></a>00610   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00611"></a>00611 
<a name="l00612"></a>00612   ierr = MatGetRow(_mat, i_val, &amp;ncols, &amp;petsc_cols, &amp;petsc_row);
<a name="l00613"></a>00613          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00614"></a>00614          
<a name="l00615"></a>00615   <span class="comment">// Perform a binary search to find the contiguous index in</span>
<a name="l00616"></a>00616   <span class="comment">// petsc_cols (resp. petsc_row) corresponding to global index j_val</span>
<a name="l00617"></a>00617   std::pair&lt;const int*, const int*&gt; p =
<a name="l00618"></a>00618     std::equal_range (&amp;petsc_cols[0], &amp;petsc_cols[0] + ncols, j_val);
<a name="l00619"></a>00619 
<a name="l00620"></a>00620   <span class="comment">// Found an entry for j_val</span>
<a name="l00621"></a>00621   <span class="keywordflow">if</span> (p.first != p.second)
<a name="l00622"></a>00622     {
<a name="l00623"></a>00623       <span class="comment">// The entry in the contiguous row corresponding</span>
<a name="l00624"></a>00624       <span class="comment">// to the j_val column of interest</span>
<a name="l00625"></a>00625       <span class="keyword">const</span> <span class="keywordtype">int</span> j = std::distance (const_cast&lt;int*&gt;(&amp;petsc_cols[0]),
<a name="l00626"></a>00626                                    const_cast&lt;int*&gt;(p.first));
<a name="l00627"></a>00627       
<a name="l00628"></a>00628       libmesh_assert (j &lt; ncols);
<a name="l00629"></a>00629       libmesh_assert (petsc_cols[j] == j_val);
<a name="l00630"></a>00630       
<a name="l00631"></a>00631       value = <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span> (petsc_row[j]);
<a name="l00632"></a>00632     }
<a name="l00633"></a>00633       
<a name="l00634"></a>00634   ierr  = MatRestoreRow(_mat, i_val,
<a name="l00635"></a>00635                         &amp;ncols, &amp;petsc_cols, &amp;petsc_row);
<a name="l00636"></a>00636           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00637"></a>00637           
<a name="l00638"></a>00638   <span class="keywordflow">return</span> value;
<a name="l00639"></a>00639 }
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00645"></a>00645 <span class="keyword">inline</span>
<a name="l00646"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a478e7ee9d3ec050ca9417512bea516b6">00646</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a478e7ee9d3ec050ca9417512bea516b6">PetscMatrix&lt;T&gt;::closed</a>()<span class="keyword"> const</span>
<a name="l00647"></a>00647 <span class="keyword"></span>{
<a name="l00648"></a>00648   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l00649"></a>00649   
<a name="l00650"></a>00650   <span class="keywordtype">int</span> ierr=0;
<a name="l00651"></a>00651   <a class="code" href="petsc__macro_8h.php#a118393cd7c42d4cc73950defd0e32873">PetscBool</a> assembled;
<a name="l00652"></a>00652 
<a name="l00653"></a>00653   ierr = MatAssembled(_mat, &amp;assembled);
<a name="l00654"></a>00654          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00655"></a>00655 
<a name="l00656"></a>00656   <span class="keywordflow">return</span> (assembled == PETSC_TRUE);
<a name="l00657"></a>00657 }
<a name="l00658"></a>00658 
<a name="l00659"></a>00659 
<a name="l00660"></a>00660 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00661"></a>00661 <span class="keyword">inline</span>
<a name="l00662"></a><a class="code" href="classlibMesh_1_1PetscMatrix.php#a89482535aa806cb4e39136443ccbb20d">00662</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php#a89482535aa806cb4e39136443ccbb20d">PetscMatrix&lt;T&gt;::swap</a>(<a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a> &amp;m) 
<a name="l00663"></a>00663 {
<a name="l00664"></a>00664   std::swap(_mat, m.<a class="code" href="classlibMesh_1_1PetscMatrix.php#a0deeafca10aa9a80b4adeca9fe5327d2">_mat</a>);
<a name="l00665"></a>00665   std::swap(_destroy_mat_on_exit, m.<a class="code" href="classlibMesh_1_1PetscMatrix.php#aa9dc3865c6533af85bff507f60ccf94d">_destroy_mat_on_exit</a>);
<a name="l00666"></a>00666 }
<a name="l00667"></a>00667 
<a name="l00668"></a>00668 
<a name="l00669"></a>00669 } <span class="comment">// namespace libMesh</span>
<a name="l00670"></a>00670 
<a name="l00671"></a>00671 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00672"></a>00672 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_matrix_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
