<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_5631ec19e80ce2f75296cc4b0d550802.php">solvers</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_nonlinear_solver.C</div>  </div>
</div>
<div class="contents">
<a href="petsc__nonlinear__solver_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_nonlinear_solver.C 4280 2011-03-21 20:01:50Z jwpeterson $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// C++ includes</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="nonlinear__implicit__system_8h.php">nonlinear_implicit_system.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="petsc__nonlinear__solver_8h.php">petsc_nonlinear_solver.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="petsc__linear__solver_8h.php">petsc_linear_solver.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="dof__map_8h.php">dof_map.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="preconditioner_8h.php">preconditioner.h</a>&quot;</span>
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="keyword">namespace </span>libMesh
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">//--------------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// Functions with C linkage to pass to PETSc.  PETSc will call these</span>
<a name="l00043"></a>00043 <span class="comment">// methods as needed.</span>
<a name="l00044"></a>00044 <span class="comment">// </span>
<a name="l00045"></a>00045 <span class="comment">// Since they must have C linkage they have no knowledge of a namespace.</span>
<a name="l00046"></a>00046 <span class="comment">// Give them an obscure name to avoid namespace pollution.</span>
<a name="l00047"></a>00047 <span class="keyword">extern</span> <span class="stringliteral">&quot;C&quot;</span>
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049   <span class="comment">// Older versions of PETSc do not have the different int typedefs.</span>
<a name="l00050"></a>00050   <span class="comment">// On 64-bit machines, PetscInt may actually be a long long int.</span>
<a name="l00051"></a>00051   <span class="comment">// This change occurred in Petsc-2.2.1.</span>
<a name="l00052"></a>00052 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,2,1)</span>
<a name="l00053"></a>00053 <span class="preprocessor"></span>  <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#ae498bcd21156b9579c241812fe40c3c2">PetscErrorCode</a>;
<a name="l00054"></a>00054   <span class="keyword">typedef</span> <span class="keywordtype">int</span> <a class="code" href="namespacelibMesh.php#a7ad10af8599548704f3938639a33b5ca">PetscInt</a>;
<a name="l00055"></a>00055 <span class="preprocessor">#endif</span>
<a name="l00056"></a>00056 <span class="preprocessor"></span>  
<a name="l00057"></a>00057   <span class="comment">//-------------------------------------------------------------------</span>
<a name="l00058"></a>00058   <span class="comment">// this function is called by PETSc at the end of each nonlinear step  </span>
<a name="l00059"></a>00059   PetscErrorCode
<a name="l00060"></a><a class="code" href="namespacelibMesh.php#a6991149c9bcc49b90fcc1575bcbc4564">00060</a>   <a class="code" href="namespacelibMesh.php#a6991149c9bcc49b90fcc1575bcbc4564">__libmesh_petsc_snes_monitor</a> (SNES, PetscInt its, PetscReal fnorm, <span class="keywordtype">void</span> *)
<a name="l00061"></a>00061   {
<a name="l00062"></a>00062     <span class="comment">//int ierr=0;</span>
<a name="l00063"></a>00063 
<a name="l00064"></a>00064     <span class="comment">//if (its &gt; 0)</span>
<a name="l00065"></a>00065       <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;  NL step &quot;</span>
<a name="l00066"></a>00066                     &lt;&lt; std::setw(2) &lt;&lt; its
<a name="l00067"></a>00067                     &lt;&lt; std::scientific
<a name="l00068"></a>00068                     &lt;&lt; <span class="stringliteral">&quot;, |residual|_2 = &quot;</span> &lt;&lt; fnorm
<a name="l00069"></a>00069                     &lt;&lt; std::endl;
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     <span class="comment">//return ierr;</span>
<a name="l00072"></a>00072     <span class="keywordflow">return</span> 0;
<a name="l00073"></a>00073   }
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
<a name="l00077"></a>00077   <span class="comment">//---------------------------------------------------------------</span>
<a name="l00078"></a>00078   <span class="comment">// this function is called by PETSc to evaluate the residual at X</span>
<a name="l00079"></a>00079   PetscErrorCode
<a name="l00080"></a><a class="code" href="namespacelibMesh.php#a1fddb7d65a946c15b6895abefe18f826">00080</a>   <a class="code" href="namespacelibMesh.php#a1fddb7d65a946c15b6895abefe18f826">__libmesh_petsc_snes_residual</a> (SNES, Vec x, Vec r, <span class="keywordtype">void</span> *ctx)
<a name="l00081"></a>00081   {
<a name="l00082"></a>00082     START_LOG(<span class="stringliteral">&quot;residual()&quot;</span>, <span class="stringliteral">&quot;PetscNonlinearSolver&quot;</span>);
<a name="l00083"></a>00083     <span class="keywordtype">int</span> ierr=0;
<a name="l00084"></a>00084 
<a name="l00085"></a>00085     libmesh_assert (x   != NULL);
<a name="l00086"></a>00086     libmesh_assert (r   != NULL);
<a name="l00087"></a>00087     libmesh_assert (ctx != NULL);
<a name="l00088"></a>00088     
<a name="l00089"></a>00089     <a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php">PetscNonlinearSolver&lt;Number&gt;</a>* solver =
<a name="l00090"></a>00090       <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php">PetscNonlinearSolver&lt;Number&gt;</a>*<span class="keyword">&gt;</span> (ctx);
<a name="l00091"></a>00091     
<a name="l00092"></a>00092     <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">NonlinearImplicitSystem</a> &amp;sys = solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#afd4b2819b5c5cc4384a879df8b34ceb3">system</a>();
<a name="l00093"></a>00093 
<a name="l00094"></a>00094     <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a>&amp; X_sys = *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.solution.get());
<a name="l00095"></a>00095     <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a>&amp; R_sys = *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.rhs);
<a name="l00096"></a>00096     <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a> X_global(x), R(r);
<a name="l00097"></a>00097 
<a name="l00098"></a>00098     <span class="comment">// Use the systems update() to get a good local version of the parallel solution</span>
<a name="l00099"></a>00099     X_global.swap(X_sys);
<a name="l00100"></a>00100     R.swap(R_sys);
<a name="l00101"></a>00101 
<a name="l00102"></a>00102     sys.get_dof_map().enforce_constraints_exactly(sys);
<a name="l00103"></a>00103     
<a name="l00104"></a>00104     sys.update();
<a name="l00105"></a>00105 
<a name="l00106"></a>00106     <span class="comment">//Swap back</span>
<a name="l00107"></a>00107     X_global.swap(X_sys);
<a name="l00108"></a>00108     R.swap(R_sys);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110     R.zero();
<a name="l00111"></a>00111 
<a name="l00112"></a>00112     <span class="keywordflow">if</span>      (solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a9a7a991c403fba622accbf7ffc955537">residual</a> != NULL) solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a9a7a991c403fba622accbf7ffc955537">residual</a> (*sys.current_local_solution.get(), R, sys);
<a name="l00113"></a>00113     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a5aa221a09a2c2ca3ec78285c2b043498">matvec</a>   != NULL) solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a5aa221a09a2c2ca3ec78285c2b043498">matvec</a>   (*sys.current_local_solution.get(), &amp;R, NULL, sys);
<a name="l00114"></a>00114     <span class="keywordflow">else</span> libmesh_error();
<a name="l00115"></a>00115     
<a name="l00116"></a>00116     R.close();
<a name="l00117"></a>00117     X_global.close();
<a name="l00118"></a>00118 
<a name="l00119"></a>00119     STOP_LOG(<span class="stringliteral">&quot;residual()&quot;</span>, <span class="stringliteral">&quot;PetscNonlinearSolver&quot;</span>);
<a name="l00120"></a>00120     
<a name="l00121"></a>00121     <span class="keywordflow">return</span> ierr;
<a name="l00122"></a>00122   }
<a name="l00123"></a>00123 
<a name="l00124"></a>00124 
<a name="l00125"></a>00125   
<a name="l00126"></a>00126   <span class="comment">//---------------------------------------------------------------</span>
<a name="l00127"></a>00127   <span class="comment">// this function is called by PETSc to evaluate the Jacobian at X</span>
<a name="l00128"></a>00128   PetscErrorCode
<a name="l00129"></a><a class="code" href="namespacelibMesh.php#af5fa5b9b3a3177c17c15f518bbe431a4">00129</a>   <a class="code" href="namespacelibMesh.php#af5fa5b9b3a3177c17c15f518bbe431a4">__libmesh_petsc_snes_jacobian</a> (SNES, Vec x, Mat *jac, Mat *pc, MatStructure *msflag, <span class="keywordtype">void</span> *ctx)
<a name="l00130"></a>00130   {
<a name="l00131"></a>00131     START_LOG(<span class="stringliteral">&quot;jacobian()&quot;</span>, <span class="stringliteral">&quot;PetscNonlinearSolver&quot;</span>);
<a name="l00132"></a>00132     <span class="keywordtype">int</span> ierr=0;
<a name="l00133"></a>00133     
<a name="l00134"></a>00134     libmesh_assert (ctx != NULL);
<a name="l00135"></a>00135     
<a name="l00136"></a>00136     <a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php">PetscNonlinearSolver&lt;Number&gt;</a>* solver =
<a name="l00137"></a>00137       <span class="keyword">static_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php">PetscNonlinearSolver&lt;Number&gt;</a>*<span class="keyword">&gt;</span> (ctx);
<a name="l00138"></a>00138 
<a name="l00139"></a>00139     <a class="code" href="classlibMesh_1_1NonlinearImplicitSystem.php">NonlinearImplicitSystem</a> &amp;sys = solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#afd4b2819b5c5cc4384a879df8b34ceb3">system</a>();
<a name="l00140"></a>00140     
<a name="l00141"></a>00141     <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a> PC(*pc);
<a name="l00142"></a>00142     <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a> Jac(*jac);
<a name="l00143"></a>00143     <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a>&amp; X_sys = *libmesh_cast_ptr&lt;PetscVector&lt;Number&gt;*&gt;(sys.solution.get());
<a name="l00144"></a>00144     <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;Number&gt;</a>&amp; Jac_sys = *libmesh_cast_ptr&lt;PetscMatrix&lt;Number&gt;*&gt;(sys.matrix);
<a name="l00145"></a>00145     <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a> X_global(x);
<a name="l00146"></a>00146 
<a name="l00147"></a>00147     <span class="comment">// Set the dof maps</span>
<a name="l00148"></a>00148     PC.<a class="code" href="classlibMesh_1_1SparseMatrix.php#a327789280fc9e054844455b212d143b4">attach_dof_map</a>(sys.get_dof_map());
<a name="l00149"></a>00149     Jac.<a class="code" href="classlibMesh_1_1SparseMatrix.php#a327789280fc9e054844455b212d143b4">attach_dof_map</a>(sys.get_dof_map());
<a name="l00150"></a>00150 
<a name="l00151"></a>00151     <span class="comment">// Use the systems update() to get a good local version of the parallel solution</span>
<a name="l00152"></a>00152     X_global.swap(X_sys);
<a name="l00153"></a>00153     Jac.<a class="code" href="classlibMesh_1_1PetscMatrix.php#a89482535aa806cb4e39136443ccbb20d">swap</a>(Jac_sys);
<a name="l00154"></a>00154 
<a name="l00155"></a>00155     sys.get_dof_map().enforce_constraints_exactly(sys);
<a name="l00156"></a>00156     sys.update();
<a name="l00157"></a>00157 
<a name="l00158"></a>00158     X_global.swap(X_sys);
<a name="l00159"></a>00159     Jac.<a class="code" href="classlibMesh_1_1PetscMatrix.php#a89482535aa806cb4e39136443ccbb20d">swap</a>(Jac_sys);
<a name="l00160"></a>00160 
<a name="l00161"></a>00161     PC.<a class="code" href="classlibMesh_1_1PetscMatrix.php#ae8ce5cac1fe09c916c52e2dcd0bea7ea">zero</a>();
<a name="l00162"></a>00162 
<a name="l00163"></a>00163     <span class="keywordflow">if</span>      (solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a3b004cfd9859f6fdb7e6d3bf79f65683">jacobian</a> != NULL) solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a3b004cfd9859f6fdb7e6d3bf79f65683">jacobian</a> (*sys.current_local_solution.get(), PC, sys);
<a name="l00164"></a>00164     <span class="keywordflow">else</span> <span class="keywordflow">if</span> (solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a5aa221a09a2c2ca3ec78285c2b043498">matvec</a>   != NULL) solver-&gt;<a class="code" href="classlibMesh_1_1NonlinearSolver.php#a5aa221a09a2c2ca3ec78285c2b043498">matvec</a>   (*sys.current_local_solution.get(), NULL, &amp;PC, sys);
<a name="l00165"></a>00165     <span class="keywordflow">else</span> libmesh_error();
<a name="l00166"></a>00166     
<a name="l00167"></a>00167     PC.close();
<a name="l00168"></a>00168     Jac.<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a>();
<a name="l00169"></a>00169     X_global.close();
<a name="l00170"></a>00170     
<a name="l00171"></a>00171     *msflag = SAME_NONZERO_PATTERN;
<a name="l00172"></a>00172     
<a name="l00173"></a>00173     STOP_LOG(<span class="stringliteral">&quot;jacobian()&quot;</span>, <span class="stringliteral">&quot;PetscNonlinearSolver&quot;</span>);
<a name="l00174"></a>00174 
<a name="l00175"></a>00175     <span class="keywordflow">return</span> ierr;
<a name="l00176"></a>00176   }
<a name="l00177"></a>00177     
<a name="l00178"></a>00178 } <span class="comment">// end extern &quot;C&quot;</span>
<a name="l00179"></a>00179 <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="comment">//---------------------------------------------------------------------</span>
<a name="l00184"></a>00184 <span class="comment">// PetscNonlinearSolver&lt;&gt; methods</span>
<a name="l00185"></a>00185 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00186"></a><a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#a1eb28ba51d7d9a5b00ee7b9aad9a7ce2">00186</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#a1eb28ba51d7d9a5b00ee7b9aad9a7ce2">PetscNonlinearSolver&lt;T&gt;::clear</a> ()
<a name="l00187"></a>00187 {
<a name="l00188"></a>00188   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00189"></a>00189     {
<a name="l00190"></a>00190       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00191"></a>00191 
<a name="l00192"></a>00192       <span class="keywordtype">int</span> ierr=0;
<a name="l00193"></a>00193 
<a name="l00194"></a>00194       ierr = SNESDestroy(_snes);
<a name="l00195"></a>00195              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00196"></a>00196     }
<a name="l00197"></a>00197 }
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00202"></a><a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#a9d1d0a2552efc07fb8f03bbadde71ad4">00202</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#a9d1d0a2552efc07fb8f03bbadde71ad4">PetscNonlinearSolver&lt;T&gt;::init</a> ()
<a name="l00203"></a>00203 {  
<a name="l00204"></a>00204   <span class="comment">// Initialize the data structures if not done so already.</span>
<a name="l00205"></a>00205   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00206"></a>00206     {
<a name="l00207"></a>00207       this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00208"></a>00208       
<a name="l00209"></a>00209       <span class="keywordtype">int</span> ierr=0;
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,1,2)</span>
<a name="l00212"></a>00212 <span class="preprocessor"></span>      <span class="comment">// At least until Petsc 2.1.1, the SNESCreate had a different calling syntax.</span>
<a name="l00213"></a>00213       <span class="comment">// The second argument was of type SNESProblemType, and could have a value of</span>
<a name="l00214"></a>00214       <span class="comment">// either SNES_NONLINEAR_EQUATIONS or SNES_UNCONSTRAINED_MINIMIZATION.</span>
<a name="l00215"></a>00215       ierr = SNESCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, SNES_NONLINEAR_EQUATIONS, &amp;_snes);
<a name="l00216"></a>00216              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 <span class="preprocessor">#else</span>
<a name="l00219"></a>00219 <span class="preprocessor"></span>
<a name="l00220"></a>00220       ierr = SNESCreate(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,&amp;_snes);
<a name="l00221"></a>00221              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 <span class="preprocessor">#endif</span>
<a name="l00224"></a>00224 <span class="preprocessor"></span>
<a name="l00225"></a>00225              
<a name="l00226"></a>00226 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00227"></a>00227 <span class="preprocessor"></span>      ierr = SNESSetMonitor (_snes, <a class="code" href="namespacelibMesh.php#a6991149c9bcc49b90fcc1575bcbc4564">__libmesh_petsc_snes_monitor</a>,
<a name="l00228"></a>00228                              <span class="keyword">this</span>, PETSC_NULL);
<a name="l00229"></a>00229 <span class="preprocessor">#else</span>
<a name="l00230"></a>00230 <span class="preprocessor"></span>      <span class="comment">// API name change in PETSc 2.3.3</span>
<a name="l00231"></a>00231       ierr = SNESMonitorSet (_snes, <a class="code" href="namespacelibMesh.php#a6991149c9bcc49b90fcc1575bcbc4564">__libmesh_petsc_snes_monitor</a>,
<a name="l00232"></a>00232                              <span class="keyword">this</span>, PETSC_NULL);
<a name="l00233"></a>00233 <span class="preprocessor">#endif</span>
<a name="l00234"></a>00234 <span class="preprocessor"></span>      CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00235"></a>00235 
<a name="l00236"></a>00236 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,1,0)</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>      <span class="comment">// Cannot call SNESSetOptions before SNESSetFunction when using</span>
<a name="l00238"></a>00238       <span class="comment">// any matrix free options with PETSc 3.1.0+</span>
<a name="l00239"></a>00239       ierr = SNESSetFromOptions(_snes);
<a name="l00240"></a>00240              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00241"></a>00241 <span class="preprocessor">#endif </span>
<a name="l00242"></a>00242 <span class="preprocessor"></span>             
<a name="l00243"></a>00243       <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00244"></a>00244       {
<a name="l00245"></a>00245         KSP ksp;         
<a name="l00246"></a>00246         ierr = SNESGetKSP (_snes, &amp;ksp);
<a name="l00247"></a>00247                CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00248"></a>00248         PC pc;
<a name="l00249"></a>00249         ierr = KSPGetPC(ksp,&amp;pc);
<a name="l00250"></a>00250                CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00251"></a>00251                
<a name="l00252"></a>00252         PCSetType(pc, PCSHELL);
<a name="l00253"></a>00253         PCShellSetContext(pc,(<span class="keywordtype">void</span>*)this-&gt;_preconditioner);
<a name="l00254"></a>00254 
<a name="l00255"></a>00255         <span class="comment">//Re-Use the shell functions from petsc_linear_solver</span>
<a name="l00256"></a>00256         PCShellSetSetUp(pc,<a class="code" href="namespacelibMesh.php#a0ad4171647357ca5a2ffacb1c8ca5c6a">__libmesh_petsc_preconditioner_setup</a>);
<a name="l00257"></a>00257         PCShellSetApply(pc,<a class="code" href="namespacelibMesh.php#ae6c236ad49e5a5d8ad7f42d3f16b553e">__libmesh_petsc_preconditioner_apply</a>);
<a name="l00258"></a>00258       }
<a name="l00259"></a>00259     }
<a name="l00260"></a>00260 }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 
<a name="l00264"></a>00264 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00265"></a>00265 std::pair&lt;unsigned int, Real&gt; 
<a name="l00266"></a><a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#a1d5ed777465c1f08785bc321c84c7c71">00266</a> <a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#a1d5ed777465c1f08785bc321c84c7c71">PetscNonlinearSolver&lt;T&gt;::solve</a> (<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp;  jac_in,  <span class="comment">// System Jacobian Matrix</span>
<a name="l00267"></a>00267                                 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; x_in,    <span class="comment">// Solution vector</span>
<a name="l00268"></a>00268                                 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; r_in,    <span class="comment">// Residual vector</span>
<a name="l00269"></a>00269                                 <span class="keyword">const</span> <span class="keywordtype">double</span>,              <span class="comment">// Stopping tolerance</span>
<a name="l00270"></a>00270                                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) 
<a name="l00271"></a>00271 {
<a name="l00272"></a>00272   START_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscNonlinearSolver&quot;</span>);
<a name="l00273"></a>00273   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a> ();
<a name="l00274"></a>00274   
<a name="l00275"></a>00275   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00276"></a>00276   <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* jac = libmesh_cast_ptr&lt;PetscMatrix&lt;T&gt;*&gt;(&amp;jac_in);
<a name="l00277"></a>00277   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* x   = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;x_in);
<a name="l00278"></a>00278   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* r   = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;r_in);
<a name="l00279"></a>00279 
<a name="l00280"></a>00280   <span class="keywordtype">int</span> ierr=0;
<a name="l00281"></a>00281   <span class="keywordtype">int</span> n_iterations =0;
<a name="l00282"></a>00282   <span class="comment">// Should actually be a PetscReal, but I don&#39;t know which version of PETSc first introduced PetscReal</span>
<a name="l00283"></a>00283   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> final_residual_norm=0.; 
<a name="l00284"></a>00284 
<a name="l00285"></a>00285   ierr = SNESSetFunction (_snes, r-&gt;vec(), <a class="code" href="namespacelibMesh.php#a1fddb7d65a946c15b6895abefe18f826">__libmesh_petsc_snes_residual</a>, <span class="keyword">this</span>);
<a name="l00286"></a>00286          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00287"></a>00287 
<a name="l00288"></a>00288   ierr = SNESSetJacobian (_snes, jac-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), jac-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#aaca7a5afeb063716ee67fa11302c2aea">mat</a>(), <a class="code" href="namespacelibMesh.php#af5fa5b9b3a3177c17c15f518bbe431a4">__libmesh_petsc_snes_jacobian</a>, <span class="keyword">this</span>);
<a name="l00289"></a>00289          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00290"></a>00290 
<a name="l00291"></a>00291    <span class="comment">// Have the Krylov subspace method use our good initial guess rather than 0</span>
<a name="l00292"></a>00292    KSP ksp;      
<a name="l00293"></a>00293    ierr = SNESGetKSP (_snes, &amp;ksp);
<a name="l00294"></a>00294           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00295"></a>00295 
<a name="l00296"></a>00296   <span class="comment">// Set the tolerances for the iterative solver.  Use the user-supplied</span>
<a name="l00297"></a>00297   <span class="comment">// tolerance for the relative residual &amp; leave the others at default values</span>
<a name="l00298"></a>00298   ierr = KSPSetTolerances (ksp, this-&gt;initial_linear_tolerance, PETSC_DEFAULT,
<a name="l00299"></a>00299                            PETSC_DEFAULT, this-&gt;max_linear_iterations);
<a name="l00300"></a>00300          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00301"></a>00301 
<a name="l00302"></a>00302   <span class="comment">// Set the tolerances for the non-linear solver.</span>
<a name="l00303"></a>00303   ierr = SNESSetTolerances(_snes, this-&gt;absolute_residual_tolerance, this-&gt;relative_residual_tolerance,
<a name="l00304"></a>00304                            this-&gt;absolute_step_tolerance, this-&gt;max_nonlinear_iterations, this-&gt;max_function_evaluations);
<a name="l00305"></a>00305          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00306"></a>00306 
<a name="l00307"></a>00307   <span class="comment">//Pull in command-line options       </span>
<a name="l00308"></a>00308   KSPSetFromOptions(ksp);
<a name="l00309"></a>00309   SNESSetFromOptions(_snes);
<a name="l00310"></a>00310 
<a name="l00311"></a>00311   <span class="comment">//Set the preconditioning matrix</span>
<a name="l00312"></a>00312   <span class="keywordflow">if</span>(this-&gt;_preconditioner)
<a name="l00313"></a>00313     this-&gt;_preconditioner-&gt;set_matrix(jac_in);
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 <span class="comment">//    ierr = KSPSetInitialGuessNonzero (ksp, PETSC_TRUE);</span>
<a name="l00316"></a>00316 <span class="comment">//           CHKERRABORT(libMesh::COMM_WORLD,ierr);</span>
<a name="l00317"></a>00317          
<a name="l00318"></a>00318 <span class="comment">// Older versions (at least up to 2.1.5) of SNESSolve took 3 arguments,</span>
<a name="l00319"></a>00319 <span class="comment">// the last one being a pointer to an int to hold the number of iterations required.</span>
<a name="l00320"></a>00320 <span class="preprocessor"># if PETSC_VERSION_LESS_THAN(2,2,0)</span>
<a name="l00321"></a>00321 <span class="preprocessor"></span>
<a name="l00322"></a>00322  ierr = SNESSolve (_snes, x-&gt;vec(), &amp;n_iterations);
<a name="l00323"></a>00323         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00324"></a>00324 
<a name="l00325"></a>00325 <span class="comment">// 2.2.x style  </span>
<a name="l00326"></a>00326 <span class="preprocessor">#elif PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00327"></a>00327 <span class="preprocessor"></span>        
<a name="l00328"></a>00328  ierr = SNESSolve (_snes, x-&gt;vec());
<a name="l00329"></a>00329         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00330"></a>00330 
<a name="l00331"></a>00331 <span class="comment">// 2.3.x &amp; newer style  </span>
<a name="l00332"></a>00332 <span class="preprocessor">#else</span>
<a name="l00333"></a>00333 <span class="preprocessor"></span>        
<a name="l00334"></a>00334   ierr = SNESSolve (_snes, PETSC_NULL, x-&gt;vec());
<a name="l00335"></a>00335          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00336"></a>00336 
<a name="l00337"></a>00337   ierr = SNESGetIterationNumber(_snes,&amp;n_iterations);
<a name="l00338"></a>00338          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00339"></a>00339          
<a name="l00340"></a>00340   ierr = SNESGetFunctionNorm(_snes,&amp;final_residual_norm);
<a name="l00341"></a>00341          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00342"></a>00342          
<a name="l00343"></a>00343 <span class="preprocessor">#endif</span>
<a name="l00344"></a>00344 <span class="preprocessor"></span>
<a name="l00345"></a>00345   <span class="comment">// Get and store the reason for convergence</span>
<a name="l00346"></a>00346   SNESGetConvergedReason(_snes, &amp;_reason);
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   <span class="comment">//Based on Petsc 2.3.3 documentation all diverged reasons are negative</span>
<a name="l00349"></a>00349   this-&gt;converged = (_reason &gt;= 0);
<a name="l00350"></a>00350 
<a name="l00351"></a>00351   this-&gt;clear();
<a name="l00352"></a>00352   
<a name="l00353"></a>00353   STOP_LOG(<span class="stringliteral">&quot;solve()&quot;</span>, <span class="stringliteral">&quot;PetscNonlinearSolver&quot;</span>);
<a name="l00354"></a>00354                  
<a name="l00355"></a>00355   <span class="comment">// return the # of its. and the final residual norm.</span>
<a name="l00356"></a>00356   <span class="keywordflow">return</span> std::make_pair(n_iterations, final_residual_norm);
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00362"></a><a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#a1a9d8964018e0fc4782b1dfb554a63e3">00362</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#a1a9d8964018e0fc4782b1dfb554a63e3">PetscNonlinearSolver&lt;T&gt;::print_converged_reason</a>()
<a name="l00363"></a>00363 {
<a name="l00364"></a>00364   
<a name="l00365"></a>00365   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;Nonlinear solver convergence/divergence reason: &quot;</span>
<a name="l00366"></a>00366                &lt;&lt; SNESConvergedReasons[this-&gt;get_converged_reason()] &lt;&lt; std::endl;
<a name="l00367"></a>00367 }
<a name="l00368"></a>00368 
<a name="l00369"></a>00369 
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00372"></a><a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#acab9d2303d58c508111413943ff7b1f1">00372</a> SNESConvergedReason <a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php#acab9d2303d58c508111413943ff7b1f1">PetscNonlinearSolver&lt;T&gt;::get_converged_reason</a>()
<a name="l00373"></a>00373 {
<a name="l00374"></a>00374   <span class="keywordtype">int</span> ierr=0;
<a name="l00375"></a>00375   
<a name="l00376"></a>00376   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00377"></a>00377     {
<a name="l00378"></a>00378       ierr = SNESGetConvergedReason(_snes, &amp;_reason);
<a name="l00379"></a>00379       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00380"></a>00380     }
<a name="l00381"></a>00381 
<a name="l00382"></a>00382   <span class="keywordflow">return</span> _reason;
<a name="l00383"></a>00383 }
<a name="l00384"></a>00384   
<a name="l00385"></a>00385 
<a name="l00386"></a>00386 
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00389"></a>00389 <span class="comment">// Explicit instantiations</span>
<a name="l00390"></a>00390 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscNonlinearSolver.php">PetscNonlinearSolver&lt;Number&gt;</a>;
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 } <span class="comment">// namespace libMesh</span>
<a name="l00393"></a>00393  
<a name="l00394"></a>00394 
<a name="l00395"></a>00395 
<a name="l00396"></a>00396 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
