<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_preconditioner.h</div>  </div>
</div>
<div class="contents">
<a href="petsc__preconditioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_preconditioner.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __petsc_preconditioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_preconditioner_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00028"></a>00028 <span class="preprocessor"></span>
<a name="l00029"></a>00029 <span class="comment">// C++ includes</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local includes</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="preconditioner_8h.php">preconditioner.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="enum__solver__package_8h.php">enum_solver_package.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="enum__preconditioner__type_8h.php">enum_preconditioner_type.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// Petsc includes</span>
<a name="l00040"></a>00040 <span class="preprocessor">#include &quot;petscpc.h&quot;</span>
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 <span class="keyword">namespace </span>libMesh
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">// forward declarations</span>
<a name="l00046"></a>00046 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>AutoPtr;
<a name="l00047"></a>00047 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00048"></a>00048 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00049"></a>00049 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>ShellMatrix;
<a name="l00050"></a>00050 
<a name="l00058"></a>00058 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00059"></a><a class="code" href="classlibMesh_1_1PetscPreconditioner.php">00059</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscPreconditioner.php">PetscPreconditioner</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner</a>&lt;T&gt;
<a name="l00060"></a>00060 {
<a name="l00061"></a>00061 <span class="keyword">public</span>:
<a name="l00062"></a>00062   
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a29ccde42aef1558bf8d7437c6dcdd694">PetscPreconditioner</a> ();
<a name="l00067"></a>00067     
<a name="l00071"></a>00071   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a9fe3afd0a43eefe04be0c4951c25aa34">~PetscPreconditioner</a> ();  
<a name="l00072"></a>00072 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a1f2d0c05c03ee68509351474ab24ecef">apply</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; x, <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; y);
<a name="l00078"></a>00078   
<a name="l00082"></a><a class="code" href="classlibMesh_1_1PetscPreconditioner.php#ac8a46b9d1139bf9bd6c0cb0d9b9648e2">00082</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#ac8a46b9d1139bf9bd6c0cb0d9b9648e2">clear</a> () {}
<a name="l00083"></a>00083 
<a name="l00087"></a>00087   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a62e0cd323cf8dc6cc6df65e95a94be26">init</a> ();
<a name="l00088"></a>00088 
<a name="l00093"></a><a class="code" href="classlibMesh_1_1PetscPreconditioner.php#ae1d93ba595670bf95075d48ba44c3667">00093</a>   PC <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#ae1d93ba595670bf95075d48ba44c3667">pc</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a9baf15a2c31ef7f3d956387306f94bef">_pc</a>; }
<a name="l00094"></a>00094   
<a name="l00098"></a>00098   <span class="keyword">static</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#aab69801de7b38fc74cf110baa0bcde9b">set_petsc_preconditioner_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> &amp; preconditioner_type, PC &amp; <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#ae1d93ba595670bf95075d48ba44c3667">pc</a>);
<a name="l00099"></a>00099   
<a name="l00100"></a>00100 <span class="keyword">protected</span>:
<a name="l00101"></a>00101   
<a name="l00105"></a><a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a9baf15a2c31ef7f3d956387306f94bef">00105</a>   PC <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a9baf15a2c31ef7f3d956387306f94bef">_pc</a>;
<a name="l00106"></a>00106 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1PetscPreconditioner.php#aafd44aca3b3edfbe7bb92a0b81157cf3">00111</a>   Mat <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#aafd44aca3b3edfbe7bb92a0b81157cf3">_mat</a>;
<a name="l00112"></a>00112 };
<a name="l00113"></a>00113 
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00118"></a>00118 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00119"></a>00119 <span class="keyword">inline</span>
<a name="l00120"></a><a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a29ccde42aef1558bf8d7437c6dcdd694">00120</a> <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a29ccde42aef1558bf8d7437c6dcdd694">PetscPreconditioner&lt;T&gt;::PetscPreconditioner</a> () :
<a name="l00121"></a>00121   <a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner</a>&lt;T&gt;()
<a name="l00122"></a>00122 {
<a name="l00123"></a>00123 }
<a name="l00124"></a>00124 
<a name="l00125"></a>00125 
<a name="l00126"></a>00126 
<a name="l00127"></a>00127 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00128"></a>00128 <span class="keyword">inline</span>
<a name="l00129"></a><a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a9fe3afd0a43eefe04be0c4951c25aa34">00129</a> <a class="code" href="classlibMesh_1_1PetscPreconditioner.php#a9fe3afd0a43eefe04be0c4951c25aa34">PetscPreconditioner&lt;T&gt;::~PetscPreconditioner</a> ()
<a name="l00130"></a>00130 {
<a name="l00131"></a>00131   this-&gt;clear ();
<a name="l00132"></a>00132 }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 } <span class="comment">// namespace libMesh</span>
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00137"></a>00137 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_linear_solver_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
