<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_b6e7ec15aeb88c85f9b82bb9ef83e3e4.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_vector.C</div>  </div>
</div>
<div class="contents">
<a href="petsc__vector_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_vector.C 4286 2011-03-24 03:55:50Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="petsc__vector_8h.php">petsc_vector.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="petsc__matrix_8h.php">petsc_matrix.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00029"></a>00029 <span class="preprocessor"></span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="dense__subvector_8h.php">dense_subvector.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="dense__vector_8h.php">dense_vector.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="parallel_8h.php">parallel.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="utility_8h.php">utility.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00042"></a>00042 <span class="comment">// PetscVector members</span>
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// void PetscVector&lt;T&gt;::init (const NumericVector&lt;T&gt;&amp; v, const bool fast)</span>
<a name="l00045"></a>00045 <span class="comment">// {</span>
<a name="l00046"></a>00046 <span class="comment">//   libmesh_error();</span>
<a name="l00047"></a>00047   
<a name="l00048"></a>00048 <span class="comment">//   init (v.local_size(), v.size(), fast);</span>
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 <span class="comment">//   vec = libmesh_cast_ref&lt;const PetscVector&lt;T&gt;&amp;&gt;(v).vec;</span>
<a name="l00051"></a>00051 <span class="comment">// }</span>
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00054"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a8e29eb124d4d870a5c4654e1d24ba71b">00054</a> T <a class="code" href="classlibMesh_1_1PetscVector.php#a8e29eb124d4d870a5c4654e1d24ba71b">PetscVector&lt;T&gt;::sum</a> ()<span class="keyword"> const</span>
<a name="l00055"></a>00055 <span class="keyword"></span>{
<a name="l00056"></a>00056   this-&gt;_restore_array();
<a name="l00057"></a>00057   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00058"></a>00058   
<a name="l00059"></a>00059   <span class="keywordtype">int</span> ierr=0;
<a name="l00060"></a>00060   PetscScalar value=0.;
<a name="l00061"></a>00061   
<a name="l00062"></a>00062   ierr = VecSum (_vec, &amp;value);
<a name="l00063"></a>00063          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00064"></a>00064   
<a name="l00065"></a>00065   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(value);
<a name="l00066"></a>00066 }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00070"></a><a class="code" href="classlibMesh_1_1PetscVector.php#abdc8865d1b68a5cce20476aadc2741b7">00070</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#abdc8865d1b68a5cce20476aadc2741b7">PetscVector&lt;T&gt;::l1_norm</a> ()<span class="keyword"> const</span>
<a name="l00071"></a>00071 <span class="keyword"></span>{
<a name="l00072"></a>00072   this-&gt;_restore_array();
<a name="l00073"></a>00073   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00074"></a>00074   
<a name="l00075"></a>00075   <span class="keywordtype">int</span> ierr=0;
<a name="l00076"></a>00076   PetscReal value=0.;
<a name="l00077"></a>00077   
<a name="l00078"></a>00078   ierr = VecNorm (_vec, NORM_1, &amp;value);
<a name="l00079"></a>00079          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00080"></a>00080   
<a name="l00081"></a>00081   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(value);
<a name="l00082"></a>00082 }
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 
<a name="l00086"></a>00086 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00087"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aedba6fc62aa53a8767b115abf8de5c17">00087</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#aedba6fc62aa53a8767b115abf8de5c17">PetscVector&lt;T&gt;::l2_norm</a> ()<span class="keyword"> const</span>
<a name="l00088"></a>00088 <span class="keyword"></span>{
<a name="l00089"></a>00089   this-&gt;_restore_array();
<a name="l00090"></a>00090   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00091"></a>00091   
<a name="l00092"></a>00092   <span class="keywordtype">int</span> ierr=0;
<a name="l00093"></a>00093   PetscReal value=0.;
<a name="l00094"></a>00094   
<a name="l00095"></a>00095   ierr = VecNorm (_vec, NORM_2, &amp;value);
<a name="l00096"></a>00096          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00097"></a>00097   
<a name="l00098"></a>00098   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(value);
<a name="l00099"></a>00099 }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101 
<a name="l00102"></a>00102 
<a name="l00103"></a>00103 
<a name="l00104"></a>00104 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00105"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a2cb0b9e70d671b5a713ab2e817ea2c4e">00105</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a2cb0b9e70d671b5a713ab2e817ea2c4e">PetscVector&lt;T&gt;::linfty_norm</a> ()<span class="keyword"> const</span>
<a name="l00106"></a>00106 <span class="keyword"></span>{
<a name="l00107"></a>00107   this-&gt;_restore_array();
<a name="l00108"></a>00108   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00109"></a>00109   
<a name="l00110"></a>00110   <span class="keywordtype">int</span> ierr=0;
<a name="l00111"></a>00111   PetscReal value=0.;
<a name="l00112"></a>00112   
<a name="l00113"></a>00113   ierr = VecNorm (_vec, NORM_INFINITY, &amp;value);
<a name="l00114"></a>00114          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00115"></a>00115   
<a name="l00116"></a>00116   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(value);
<a name="l00117"></a>00117 }
<a name="l00118"></a>00118 
<a name="l00119"></a>00119 
<a name="l00120"></a>00120 
<a name="l00121"></a>00121 
<a name="l00122"></a>00122 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00123"></a>00123 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00124"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a427752e9e998847c55fe092669c61d10">00124</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a427752e9e998847c55fe092669c61d10">PetscVector&lt;T&gt;::operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00125"></a>00125 {
<a name="l00126"></a>00126   this-&gt;_restore_array();
<a name="l00127"></a>00127   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00128"></a>00128   
<a name="l00129"></a>00129   this-&gt;add(1., v);
<a name="l00130"></a>00130   
<a name="l00131"></a>00131   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00132"></a>00132 }
<a name="l00133"></a>00133 
<a name="l00134"></a>00134 
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00137"></a>00137 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00138"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a172b730a7ae74d8d811ae47fa253f846">00138</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a172b730a7ae74d8d811ae47fa253f846">PetscVector&lt;T&gt;::operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00139"></a>00139 {
<a name="l00140"></a>00140   this-&gt;_restore_array();
<a name="l00141"></a>00141   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00142"></a>00142   
<a name="l00143"></a>00143   this-&gt;add(-1., v);
<a name="l00144"></a>00144   
<a name="l00145"></a>00145   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00146"></a>00146 }
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00151"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a1e3b7ff2cb7035deacff96570b928298">00151</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a1e3b7ff2cb7035deacff96570b928298">PetscVector&lt;T&gt;::set</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00152"></a>00152 {
<a name="l00153"></a>00153   this-&gt;_restore_array();
<a name="l00154"></a>00154   libmesh_assert(i&lt;size());
<a name="l00155"></a>00155   
<a name="l00156"></a>00156   <span class="keywordtype">int</span> ierr=0;
<a name="l00157"></a>00157   <span class="keywordtype">int</span> i_val = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(i);
<a name="l00158"></a>00158   PetscScalar petsc_value = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(value);
<a name="l00159"></a>00159 
<a name="l00160"></a>00160   ierr = VecSetValues (_vec, 1, &amp;i_val, &amp;petsc_value, INSERT_VALUES);
<a name="l00161"></a>00161          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00162"></a>00162 
<a name="l00163"></a>00163   this-&gt;_is_closed = <span class="keyword">false</span>;
<a name="l00164"></a>00164 }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 
<a name="l00168"></a>00168 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00169"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">00169</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">PetscVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value)
<a name="l00170"></a>00170 {
<a name="l00171"></a>00171   this-&gt;_restore_array();
<a name="l00172"></a>00172   libmesh_assert(i&lt;size());
<a name="l00173"></a>00173   
<a name="l00174"></a>00174   <span class="keywordtype">int</span> ierr=0;
<a name="l00175"></a>00175   <span class="keywordtype">int</span> i_val = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(i);
<a name="l00176"></a>00176   PetscScalar petsc_value = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(value);
<a name="l00177"></a>00177 
<a name="l00178"></a>00178   ierr = VecSetValues (_vec, 1, &amp;i_val, &amp;petsc_value, ADD_VALUES);
<a name="l00179"></a>00179          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00180"></a>00180 
<a name="l00181"></a>00181   this-&gt;_is_closed = <span class="keyword">false</span>;
<a name="l00182"></a>00182 }
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185 
<a name="l00186"></a>00186 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00187"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">00187</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">PetscVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00188"></a>00188                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00189"></a>00189 {
<a name="l00190"></a>00190   this-&gt;_restore_array();
<a name="l00191"></a>00191   libmesh_assert (v.size() == dof_indices.size());
<a name="l00192"></a>00192 
<a name="l00193"></a>00193   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00194"></a>00194     this-&gt;add (dof_indices[i], v[i]);
<a name="l00195"></a>00195 }
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 
<a name="l00199"></a>00199 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00200"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a4de470025cfa5fa94e662ae2b17954fb">00200</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">PetscVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00201"></a>00201                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00202"></a>00202 {
<a name="l00203"></a>00203   libmesh_assert (V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>() == dof_indices.size());
<a name="l00204"></a>00204 
<a name="l00205"></a>00205   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(); i++)
<a name="l00206"></a>00206     this-&gt;add (dof_indices[i], V(i));
<a name="l00207"></a>00207 }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00212"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aac72e37ac9eed1e87145e8e3e969dbba">00212</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">PetscVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V_in,
<a name="l00213"></a>00213                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; A_in)
<a name="l00214"></a>00214 {
<a name="l00215"></a>00215   this-&gt;_restore_array();
<a name="l00216"></a>00216   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00217"></a>00217   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* V = libmesh_cast_ptr&lt;const PetscVector&lt;T&gt;*&gt;(&amp;V_in);
<a name="l00218"></a>00218   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* A = libmesh_cast_ptr&lt;const PetscMatrix&lt;T&gt;*&gt;(&amp;A_in);
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   <span class="keywordtype">int</span> ierr=0;
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   A-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a>();
<a name="l00223"></a>00223 
<a name="l00224"></a>00224   <span class="comment">// The const_cast&lt;&gt; is not elegant, but it is required since PETSc</span>
<a name="l00225"></a>00225   <span class="comment">// is not const-correct.  </span>
<a name="l00226"></a>00226   ierr = MatMultAdd(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(A)-&gt;mat(), V-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, _vec, _vec);
<a name="l00227"></a>00227          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); 
<a name="l00228"></a>00228 }
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00233"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a092ef58e6a964cf52029736ee49f2776">00233</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">PetscVector&lt;T&gt;::add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00234"></a>00234                                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00235"></a>00235 {
<a name="l00236"></a>00236   libmesh_assert (V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == dof_indices.size());
<a name="l00237"></a>00237 
<a name="l00238"></a>00238   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l00239"></a>00239     this-&gt;add (dof_indices[i], V(i));
<a name="l00240"></a>00240 }
<a name="l00241"></a>00241 
<a name="l00242"></a>00242 
<a name="l00243"></a>00243 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00244"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a2aa269edc0159eca5cc0e25c25ddb03d">00244</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a2aa269edc0159eca5cc0e25c25ddb03d">PetscVector&lt;T&gt;::add_vector_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V_in,
<a name="l00245"></a>00245                                            <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a>&amp; A_in)
<a name="l00246"></a>00246 {
<a name="l00247"></a>00247   this-&gt;_restore_array();
<a name="l00248"></a>00248   <span class="comment">// Make sure the data passed in are really of Petsc types</span>
<a name="l00249"></a>00249   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* V = libmesh_cast_ptr&lt;const PetscVector&lt;T&gt;*&gt;(&amp;V_in);
<a name="l00250"></a>00250   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>* A = libmesh_cast_ptr&lt;const PetscMatrix&lt;T&gt;*&gt;(&amp;A_in);
<a name="l00251"></a>00251 
<a name="l00252"></a>00252   <span class="keywordtype">int</span> ierr=0;
<a name="l00253"></a>00253 
<a name="l00254"></a>00254   A-&gt;<a class="code" href="classlibMesh_1_1PetscMatrix.php#ab8835ee5e4160b1345fab9dbca26b52b">close</a>();
<a name="l00255"></a>00255 
<a name="l00256"></a>00256   <span class="comment">// The const_cast&lt;&gt; is not elegant, but it is required since PETSc</span>
<a name="l00257"></a>00257   <span class="comment">// is not const-correct.  </span>
<a name="l00258"></a>00258   ierr = MatMultTransposeAdd(<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscMatrix.php">PetscMatrix&lt;T&gt;</a>*<span class="keyword">&gt;</span>(A)-&gt;mat(), V-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, _vec, _vec);
<a name="l00259"></a>00259          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); 
<a name="l00260"></a>00260 }
<a name="l00261"></a>00261 
<a name="l00262"></a>00262 
<a name="l00263"></a>00263 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00264"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ac968241117247afb84d4269d6ecdab41">00264</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">PetscVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T v_in)
<a name="l00265"></a>00265 {
<a name="l00266"></a>00266   this-&gt;_restore_array();
<a name="l00267"></a>00267 
<a name="l00268"></a>00268   <span class="keywordtype">int</span> ierr=0;
<a name="l00269"></a>00269   PetscScalar* values;
<a name="l00270"></a>00270   <span class="keyword">const</span> PetscScalar v = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(v_in);  
<a name="l00271"></a>00271 
<a name="l00272"></a>00272   <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00273"></a>00273     {
<a name="l00274"></a>00274       <span class="keyword">const</span> <span class="keywordtype">int</span> n   = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;local_size());
<a name="l00275"></a>00275       <span class="keyword">const</span> <span class="keywordtype">int</span> fli = <span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(this-&gt;first_local_index());
<a name="l00276"></a>00276       
<a name="l00277"></a>00277       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00278"></a>00278         {
<a name="l00279"></a>00279           ierr = VecGetArray (_vec, &amp;values);
<a name="l00280"></a>00280           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00281"></a>00281           
<a name="l00282"></a>00282           <span class="keywordtype">int</span> ig = fli + i;      
<a name="l00283"></a>00283           
<a name="l00284"></a>00284           PetscScalar value = (values[i] + v);
<a name="l00285"></a>00285           
<a name="l00286"></a>00286           ierr = VecRestoreArray (_vec, &amp;values);
<a name="l00287"></a>00287           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00288"></a>00288           
<a name="l00289"></a>00289           ierr = VecSetValues (_vec, 1, &amp;ig, &amp;value, INSERT_VALUES);
<a name="l00290"></a>00290           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); 
<a name="l00291"></a>00291         }
<a name="l00292"></a>00292     }
<a name="l00293"></a>00293   <span class="keywordflow">else</span>
<a name="l00294"></a>00294     {
<a name="l00295"></a>00295       <span class="comment">/* Vectors that include ghost values require a special</span>
<a name="l00296"></a>00296 <span class="comment">         handling.  */</span>
<a name="l00297"></a>00297       Vec loc_vec;
<a name="l00298"></a>00298       ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l00299"></a>00299       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00300"></a>00300 
<a name="l00301"></a>00301       <span class="keywordtype">int</span> n=0;
<a name="l00302"></a>00302       ierr = VecGetSize(loc_vec, &amp;n);
<a name="l00303"></a>00303       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00304"></a>00304       
<a name="l00305"></a>00305       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00306"></a>00306         {
<a name="l00307"></a>00307           ierr = VecGetArray (loc_vec, &amp;values);
<a name="l00308"></a>00308           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00309"></a>00309           
<a name="l00310"></a>00310           PetscScalar value = (values[i] + v);
<a name="l00311"></a>00311           
<a name="l00312"></a>00312           ierr = VecRestoreArray (loc_vec, &amp;values);
<a name="l00313"></a>00313           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00314"></a>00314           
<a name="l00315"></a>00315           ierr = VecSetValues (loc_vec, 1, &amp;i, &amp;value, INSERT_VALUES);
<a name="l00316"></a>00316           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); 
<a name="l00317"></a>00317         }
<a name="l00318"></a>00318 
<a name="l00319"></a>00319       ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l00320"></a>00320       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00321"></a>00321     }
<a name="l00322"></a>00322 
<a name="l00323"></a>00323   this-&gt;_is_closed = <span class="keyword">false</span>;
<a name="l00324"></a>00324 }
<a name="l00325"></a>00325 
<a name="l00326"></a>00326 
<a name="l00327"></a>00327 
<a name="l00328"></a>00328 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00329"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a5e2bd109998ae1191bcc6b7cf36ea154">00329</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">PetscVector&lt;T&gt;::add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v)
<a name="l00330"></a>00330 {
<a name="l00331"></a>00331   this-&gt;add (1., v);
<a name="l00332"></a>00332 }
<a name="l00333"></a>00333 
<a name="l00334"></a>00334 
<a name="l00335"></a>00335 
<a name="l00336"></a>00336 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00337"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ab8bb722cc6756862572a61993dd55b01">00337</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">PetscVector&lt;T&gt;::add</a> (<span class="keyword">const</span> T a_in, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00338"></a>00338 {
<a name="l00339"></a>00339   this-&gt;_restore_array();
<a name="l00340"></a>00340 
<a name="l00341"></a>00341   <span class="keywordtype">int</span> ierr = 0;
<a name="l00342"></a>00342   PetscScalar a = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(a_in);
<a name="l00343"></a>00343 
<a name="l00344"></a>00344   <span class="comment">// Make sure the NumericVector passed in is really a PetscVector</span>
<a name="l00345"></a>00345   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const PetscVector&lt;T&gt;*&gt;(&amp;v_in);
<a name="l00346"></a>00346   v-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">_restore_array</a>();
<a name="l00347"></a>00347 
<a name="l00348"></a>00348   libmesh_assert(this-&gt;size() == v-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a>());
<a name="l00349"></a>00349   
<a name="l00350"></a>00350   <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00351"></a>00351     {
<a name="l00352"></a>00352 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00353"></a>00353 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00354"></a>00354       ierr = VecAXPY(&amp;a, v-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, _vec);
<a name="l00355"></a>00355       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00356"></a>00356 <span class="preprocessor">#else</span>
<a name="l00357"></a>00357 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; later style</span>
<a name="l00358"></a>00358       ierr = VecAXPY(_vec, a, v-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>);
<a name="l00359"></a>00359       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00360"></a>00360 <span class="preprocessor">#endif</span>
<a name="l00361"></a>00361 <span class="preprocessor"></span>    }
<a name="l00362"></a>00362   <span class="keywordflow">else</span>
<a name="l00363"></a>00363     {
<a name="l00364"></a>00364       Vec loc_vec;
<a name="l00365"></a>00365       Vec v_loc_vec;
<a name="l00366"></a>00366       ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l00367"></a>00367       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00368"></a>00368       ierr = VecGhostGetLocalForm (v-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,&amp;v_loc_vec);
<a name="l00369"></a>00369       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00370"></a>00370 
<a name="l00371"></a>00371 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00372"></a>00372 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00373"></a>00373       ierr = VecAXPY(&amp;a, v_loc_vec, loc_vec);
<a name="l00374"></a>00374       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00375"></a>00375 <span class="preprocessor">#else</span>
<a name="l00376"></a>00376 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; later style</span>
<a name="l00377"></a>00377       ierr = VecAXPY(loc_vec, a, v_loc_vec);
<a name="l00378"></a>00378       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00379"></a>00379 <span class="preprocessor">#endif</span>
<a name="l00380"></a>00380 <span class="preprocessor"></span>
<a name="l00381"></a>00381       ierr = VecGhostRestoreLocalForm (v-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,&amp;v_loc_vec);
<a name="l00382"></a>00382       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00383"></a>00383       ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l00384"></a>00384       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00385"></a>00385     }
<a name="l00386"></a>00386 }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00391"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">00391</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">PetscVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00392"></a>00392                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00393"></a>00393 {
<a name="l00394"></a>00394   libmesh_assert (v.size() == dof_indices.size());
<a name="l00395"></a>00395 
<a name="l00396"></a>00396   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;v.size(); i++)
<a name="l00397"></a>00397     this-&gt;<span class="keyword">set</span> (dof_indices[i], v[i]);
<a name="l00398"></a>00398 }
<a name="l00399"></a>00399 
<a name="l00400"></a>00400 
<a name="l00401"></a>00401 
<a name="l00402"></a>00402 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00403"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a2b77c0ea994d9ad6caf497df5b52e8d3">00403</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">PetscVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00404"></a>00404                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00405"></a>00405 {
<a name="l00406"></a>00406   libmesh_assert (V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>() == dof_indices.size());
<a name="l00407"></a>00407 
<a name="l00408"></a>00408   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1NumericVector.php#a86082d6030cb32700e7eeac6e7f26455">size</a>(); i++)
<a name="l00409"></a>00409     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00410"></a>00410 }
<a name="l00411"></a>00411 
<a name="l00412"></a>00412 
<a name="l00413"></a>00413 
<a name="l00414"></a>00414 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00415"></a><a class="code" href="classlibMesh_1_1PetscVector.php#acb26787789b2bc36db7800e45e0b20e9">00415</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">PetscVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00416"></a>00416                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00417"></a>00417 {
<a name="l00418"></a>00418   libmesh_assert (V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>() == dof_indices.size());
<a name="l00419"></a>00419 
<a name="l00420"></a>00420   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1DenseVector.php#ab124ecf2f46ee43b167f093b05d81fdb">size</a>(); i++)
<a name="l00421"></a>00421     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00422"></a>00422 }
<a name="l00423"></a>00423 
<a name="l00424"></a>00424 
<a name="l00425"></a>00425 
<a name="l00426"></a>00426 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00427"></a><a class="code" href="classlibMesh_1_1PetscVector.php#adc1729b3484337c8b29b1c5c636b975a">00427</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">PetscVector&lt;T&gt;::insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00428"></a>00428                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices)
<a name="l00429"></a>00429 {
<a name="l00430"></a>00430   libmesh_assert (V.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>() == dof_indices.size());
<a name="l00431"></a>00431 
<a name="l00432"></a>00432   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;V.<a class="code" href="classlibMesh_1_1DenseVectorBase.php#a4ec1ad50c02f01beea21df4c29ed9736">size</a>(); i++)
<a name="l00433"></a>00433     this-&gt;<span class="keyword">set</span> (dof_indices[i], V(i));
<a name="l00434"></a>00434 }
<a name="l00435"></a>00435 
<a name="l00436"></a>00436 
<a name="l00437"></a>00437 
<a name="l00438"></a>00438 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00439"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a594b8417a43df556940509786642f8ce">00439</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a594b8417a43df556940509786642f8ce">PetscVector&lt;T&gt;::scale</a> (<span class="keyword">const</span> T factor_in)
<a name="l00440"></a>00440 {
<a name="l00441"></a>00441   this-&gt;_restore_array();
<a name="l00442"></a>00442 
<a name="l00443"></a>00443   <span class="keywordtype">int</span> ierr = 0;
<a name="l00444"></a>00444   PetscScalar factor = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(factor_in);
<a name="l00445"></a>00445   
<a name="l00446"></a>00446   <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00447"></a>00447     {
<a name="l00448"></a>00448 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00449"></a>00449 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00450"></a>00450       ierr = VecScale(&amp;factor, _vec);
<a name="l00451"></a>00451       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00452"></a>00452 <span class="preprocessor">#else</span>
<a name="l00453"></a>00453 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; later style     </span>
<a name="l00454"></a>00454       ierr = VecScale(_vec, factor);
<a name="l00455"></a>00455       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00456"></a>00456 <span class="preprocessor">#endif</span>
<a name="l00457"></a>00457 <span class="preprocessor"></span>    }
<a name="l00458"></a>00458   <span class="keywordflow">else</span>
<a name="l00459"></a>00459     {
<a name="l00460"></a>00460       Vec loc_vec;
<a name="l00461"></a>00461       ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l00462"></a>00462       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00463"></a>00463 
<a name="l00464"></a>00464 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00465"></a>00465 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00466"></a>00466       ierr = VecScale(&amp;factor, loc_vec);
<a name="l00467"></a>00467       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00468"></a>00468 <span class="preprocessor">#else</span>
<a name="l00469"></a>00469 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; later style     </span>
<a name="l00470"></a>00470       ierr = VecScale(loc_vec, factor);
<a name="l00471"></a>00471       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00472"></a>00472 <span class="preprocessor">#endif</span>
<a name="l00473"></a>00473 <span class="preprocessor"></span>
<a name="l00474"></a>00474       ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l00475"></a>00475       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00476"></a>00476     }
<a name="l00477"></a>00477 }
<a name="l00478"></a>00478 
<a name="l00479"></a>00479 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00480"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a470a96bc67762d23d0abdb8e963ca614">00480</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a470a96bc67762d23d0abdb8e963ca614">PetscVector&lt;T&gt;::abs</a>()
<a name="l00481"></a>00481 {
<a name="l00482"></a>00482   this-&gt;_restore_array();
<a name="l00483"></a>00483 
<a name="l00484"></a>00484   <span class="keywordtype">int</span> ierr = 0;
<a name="l00485"></a>00485 
<a name="l00486"></a>00486   <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00487"></a>00487     {
<a name="l00488"></a>00488       ierr = VecAbs(_vec);
<a name="l00489"></a>00489       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);  
<a name="l00490"></a>00490     }
<a name="l00491"></a>00491   <span class="keywordflow">else</span>
<a name="l00492"></a>00492     {
<a name="l00493"></a>00493       Vec loc_vec;
<a name="l00494"></a>00494       ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l00495"></a>00495       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00496"></a>00496 
<a name="l00497"></a>00497       ierr = VecAbs(loc_vec);
<a name="l00498"></a>00498       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);  
<a name="l00499"></a>00499 
<a name="l00500"></a>00500       ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l00501"></a>00501       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00502"></a>00502     }
<a name="l00503"></a>00503 }
<a name="l00504"></a>00504 
<a name="l00505"></a>00505 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00506"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a8bec8d600fe295651a58c3c59c4c0ad8">00506</a> T <a class="code" href="classlibMesh_1_1PetscVector.php#a8bec8d600fe295651a58c3c59c4c0ad8">PetscVector&lt;T&gt;::dot</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V)<span class="keyword"> const</span>
<a name="l00507"></a>00507 <span class="keyword"></span>{
<a name="l00508"></a>00508   this-&gt;_restore_array();
<a name="l00509"></a>00509 
<a name="l00510"></a>00510   <span class="comment">// Error flag</span>
<a name="l00511"></a>00511   <span class="keywordtype">int</span> ierr = 0;
<a name="l00512"></a>00512   
<a name="l00513"></a>00513   <span class="comment">// Return value</span>
<a name="l00514"></a>00514   PetscScalar value=0.;
<a name="l00515"></a>00515   
<a name="l00516"></a>00516   <span class="comment">// Make sure the NumericVector passed in is really a PetscVector</span>
<a name="l00517"></a>00517   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const PetscVector&lt;T&gt;*&gt;(&amp;V);
<a name="l00518"></a>00518 
<a name="l00519"></a>00519   <span class="comment">// 2.3.x (at least) style.  Untested for previous versions.</span>
<a name="l00520"></a>00520   ierr = VecDot(this-&gt;_vec, v-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, &amp;value);
<a name="l00521"></a>00521          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00522"></a>00522 
<a name="l00523"></a>00523   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(value);
<a name="l00524"></a>00524 }
<a name="l00525"></a>00525 
<a name="l00526"></a>00526 
<a name="l00527"></a>00527 
<a name="l00528"></a>00528 
<a name="l00529"></a>00529 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00530"></a>00530 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; 
<a name="l00531"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">00531</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">PetscVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> T s_in)
<a name="l00532"></a>00532 {
<a name="l00533"></a>00533   this-&gt;_restore_array();
<a name="l00534"></a>00534   libmesh_assert(this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l00535"></a>00535 
<a name="l00536"></a>00536   <span class="keywordtype">int</span> ierr = 0;
<a name="l00537"></a>00537   PetscScalar s = <span class="keyword">static_cast&lt;</span>PetscScalar<span class="keyword">&gt;</span>(s_in);
<a name="l00538"></a>00538 
<a name="l00539"></a>00539   <span class="keywordflow">if</span> (this-&gt;size() != 0)
<a name="l00540"></a>00540     {
<a name="l00541"></a>00541       <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00542"></a>00542         {
<a name="l00543"></a>00543 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00544"></a>00544 <span class="preprocessor"></span>          <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00545"></a>00545           ierr = VecSet(&amp;s, _vec);
<a name="l00546"></a>00546           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00547"></a>00547 <span class="preprocessor">#else</span>
<a name="l00548"></a>00548 <span class="preprocessor"></span>          <span class="comment">// 2.3.x &amp; later style         </span>
<a name="l00549"></a>00549           ierr = VecSet(_vec, s);
<a name="l00550"></a>00550           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00551"></a>00551 <span class="preprocessor">#endif</span>
<a name="l00552"></a>00552 <span class="preprocessor"></span>        }
<a name="l00553"></a>00553       <span class="keywordflow">else</span>
<a name="l00554"></a>00554         {
<a name="l00555"></a>00555           Vec loc_vec;
<a name="l00556"></a>00556           ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l00557"></a>00557           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00558"></a>00558 
<a name="l00559"></a>00559 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)</span>
<a name="l00560"></a>00560 <span class="preprocessor"></span>          <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00561"></a>00561           ierr = VecSet(&amp;s, loc_vec);
<a name="l00562"></a>00562           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00563"></a>00563 <span class="preprocessor">#else</span>
<a name="l00564"></a>00564 <span class="preprocessor"></span>          <span class="comment">// 2.3.x &amp; later style         </span>
<a name="l00565"></a>00565           ierr = VecSet(loc_vec, s);
<a name="l00566"></a>00566           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00567"></a>00567 <span class="preprocessor">#endif</span>
<a name="l00568"></a>00568 <span class="preprocessor"></span>
<a name="l00569"></a>00569           ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l00570"></a>00570           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00571"></a>00571         }
<a name="l00572"></a>00572     }
<a name="l00573"></a>00573   
<a name="l00574"></a>00574   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00575"></a>00575 }
<a name="l00576"></a>00576 
<a name="l00577"></a>00577 
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00580"></a>00580 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00581"></a><a class="code" href="classlibMesh_1_1PetscVector.php#af2dca3101920308daa9b5c22ba393ccc">00581</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">PetscVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_in)
<a name="l00582"></a>00582 {
<a name="l00583"></a>00583   <span class="comment">// Make sure the NumericVector passed in is really a PetscVector</span>
<a name="l00584"></a>00584   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* v = libmesh_cast_ptr&lt;const PetscVector&lt;T&gt;*&gt;(&amp;v_in);
<a name="l00585"></a>00585 
<a name="l00586"></a>00586   *<span class="keyword">this</span> = *v;
<a name="l00587"></a>00587   
<a name="l00588"></a>00588   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00589"></a>00589 }
<a name="l00590"></a>00590 
<a name="l00591"></a>00591 
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00594"></a>00594 <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>&amp;
<a name="l00595"></a><a class="code" href="classlibMesh_1_1PetscVector.php#abfb5916eeeebccc75d7d6c9e35af4d36">00595</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">PetscVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>&amp; v)
<a name="l00596"></a>00596 {
<a name="l00597"></a>00597   this-&gt;_restore_array();
<a name="l00598"></a>00598   v.<a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">_restore_array</a>();
<a name="l00599"></a>00599 
<a name="l00600"></a>00600   libmesh_assert (this-&gt;size() == v.<a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a>());
<a name="l00601"></a>00601   libmesh_assert (this-&gt;local_size() == v.<a class="code" href="classlibMesh_1_1PetscVector.php#a9586f2b97a6c61a35b36f8fbe4c3c944">local_size</a>());
<a name="l00602"></a>00602   libmesh_assert (v.<a class="code" href="classlibMesh_1_1NumericVector.php#afa69111a678b5552c7fe586c91a6585f">closed</a>());
<a name="l00603"></a>00603 
<a name="l00604"></a>00604   <span class="keywordtype">int</span> ierr = 0;
<a name="l00605"></a>00605 
<a name="l00606"></a>00606   <span class="keywordflow">if</span> (((this-&gt;type()==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>) &amp;&amp; (v.<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>()==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)) || 
<a name="l00607"></a>00607       ((this-&gt;type()==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>) &amp;&amp; (v.<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>()==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>)))
<a name="l00608"></a>00608   {
<a name="l00609"></a>00609     <span class="comment">/* Allow assignment of a ghosted to a parallel vector since this</span>
<a name="l00610"></a>00610 <span class="comment">       causes no difficulty.  See discussion in libmesh-devel of</span>
<a name="l00611"></a>00611 <span class="comment">       June 24, 2010.  */</span>
<a name="l00612"></a>00612     ierr = VecCopy (v.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, this-&gt;_vec);
<a name="l00613"></a>00613     CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00614"></a>00614   }
<a name="l00615"></a>00615   <span class="keywordflow">else</span>
<a name="l00616"></a>00616   {
<a name="l00617"></a>00617     <span class="comment">/* In all other cases, we assert that both vectors are of equal</span>
<a name="l00618"></a>00618 <span class="comment">       type.  */</span>
<a name="l00619"></a>00619     libmesh_assert (this-&gt;_type == v.<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a>);
<a name="l00620"></a>00620     libmesh_assert (this-&gt;_global_to_local_map == v.<a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">_global_to_local_map</a>);
<a name="l00621"></a>00621       
<a name="l00622"></a>00622     <span class="keywordflow">if</span> (v.<a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a>() != 0)
<a name="l00623"></a>00623     {
<a name="l00624"></a>00624       <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00625"></a>00625       {
<a name="l00626"></a>00626         ierr = VecCopy (v.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, this-&gt;_vec);
<a name="l00627"></a>00627         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00628"></a>00628             }
<a name="l00629"></a>00629       <span class="keywordflow">else</span>
<a name="l00630"></a>00630       {
<a name="l00631"></a>00631         Vec loc_vec;
<a name="l00632"></a>00632         Vec v_loc_vec;
<a name="l00633"></a>00633         ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l00634"></a>00634         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00635"></a>00635         ierr = VecGhostGetLocalForm (v.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,&amp;v_loc_vec);
<a name="l00636"></a>00636         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00637"></a>00637               
<a name="l00638"></a>00638         ierr = VecCopy (v_loc_vec, loc_vec);
<a name="l00639"></a>00639         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00640"></a>00640               
<a name="l00641"></a>00641         ierr = VecGhostRestoreLocalForm (v.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,&amp;v_loc_vec);
<a name="l00642"></a>00642         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00643"></a>00643         ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l00644"></a>00644         CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00645"></a>00645       }
<a name="l00646"></a>00646     }
<a name="l00647"></a>00647   }
<a name="l00648"></a>00648 
<a name="l00649"></a>00649   <a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a>();
<a name="l00650"></a>00650 
<a name="l00651"></a>00651   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00652"></a>00652 }
<a name="l00653"></a>00653 
<a name="l00654"></a>00654 
<a name="l00655"></a>00655 
<a name="l00656"></a>00656 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00657"></a>00657 <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp;
<a name="l00658"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a818dea8920203ae9abf2b3921103abba">00658</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">PetscVector&lt;T&gt;::operator = </a>(<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v)
<a name="l00659"></a>00659 {
<a name="l00660"></a>00660   this-&gt;_restore_array();
<a name="l00661"></a>00661 
<a name="l00662"></a>00662   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nl   = this-&gt;local_size();
<a name="l00663"></a>00663   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff = this-&gt;first_local_index();
<a name="l00664"></a>00664   <span class="keywordtype">int</span> ierr=0;
<a name="l00665"></a>00665   PetscScalar* values;
<a name="l00666"></a>00666       
<a name="l00671"></a>00671   <span class="keywordflow">if</span> (this-&gt;size() == v.size())
<a name="l00672"></a>00672     {
<a name="l00673"></a>00673       ierr = VecGetArray (_vec, &amp;values);
<a name="l00674"></a>00674              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00675"></a>00675 
<a name="l00676"></a>00676       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nl; i++)
<a name="l00677"></a>00677         values[i] =  static_cast&lt;PetscScalar&gt;(v[i+ioff]);
<a name="l00678"></a>00678       
<a name="l00679"></a>00679       ierr = VecRestoreArray (_vec, &amp;values);
<a name="l00680"></a>00680              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00681"></a>00681     }
<a name="l00682"></a>00682 
<a name="l00687"></a>00687   <span class="keywordflow">else</span>
<a name="l00688"></a>00688     {
<a name="l00689"></a>00689       libmesh_assert (this-&gt;local_size() == v.size());
<a name="l00690"></a>00690 
<a name="l00691"></a>00691       ierr = VecGetArray (_vec, &amp;values);
<a name="l00692"></a>00692              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00693"></a>00693 
<a name="l00694"></a>00694       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;nl; i++)
<a name="l00695"></a>00695         values[i] = static_cast&lt;PetscScalar&gt;(v[i]);
<a name="l00696"></a>00696       
<a name="l00697"></a>00697       ierr = VecRestoreArray (_vec, &amp;values);
<a name="l00698"></a>00698              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00699"></a>00699     }
<a name="l00700"></a>00700 
<a name="l00701"></a>00701   <span class="comment">// Make sure ghost dofs are up to date</span>
<a name="l00702"></a>00702   <span class="keywordflow">if</span> (this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00703"></a>00703     this-&gt;<a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a>();
<a name="l00704"></a>00704 
<a name="l00705"></a>00705   <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00706"></a>00706 }
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 
<a name="l00710"></a>00710 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00711"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aa608bc0dad18db41e2441111129bf57d">00711</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">PetscVector&lt;T&gt;::localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in)<span class="keyword"> const</span>
<a name="l00712"></a>00712 <span class="keyword"></span>{
<a name="l00713"></a>00713   this-&gt;_restore_array();
<a name="l00714"></a>00714 
<a name="l00715"></a>00715   <span class="comment">// Make sure the NumericVector passed in is really a PetscVector</span>
<a name="l00716"></a>00716   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* v_local = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;v_local_in);
<a name="l00717"></a>00717 
<a name="l00718"></a>00718   libmesh_assert (v_local != NULL);
<a name="l00719"></a>00719   libmesh_assert (v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a>() == this-&gt;size());
<a name="l00720"></a>00720 
<a name="l00721"></a>00721   <span class="keywordtype">int</span> ierr = 0;
<a name="l00722"></a>00722   <span class="keyword">const</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00723"></a>00723 
<a name="l00724"></a>00724   IS is;
<a name="l00725"></a>00725   VecScatter scatter;
<a name="l00726"></a>00726 
<a name="l00727"></a>00727   <span class="comment">// Create idx, idx[i] = i;</span>
<a name="l00728"></a>00728   std::vector&lt;int&gt; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(n); <a class="code" href="namespacelibMesh_1_1Utility.php#a40269b7cf3ba8157ed6b3c2399e62809">Utility::iota</a> (idx.begin(), idx.end(), 0);
<a name="l00729"></a>00729 
<a name="l00730"></a>00730   <span class="comment">// Create the index set &amp; scatter object</span>
<a name="l00731"></a>00731   ierr = ISCreateLibMesh(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, n, &amp;idx[0], <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca1e5674c0acb009634823faf5b9c9915d">PETSC_USE_POINTER</a>, &amp;is);
<a name="l00732"></a>00732          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00733"></a>00733 
<a name="l00734"></a>00734   ierr = VecScatterCreate(_vec,          is,
<a name="l00735"></a>00735                           v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, is,
<a name="l00736"></a>00736                           &amp;scatter);
<a name="l00737"></a>00737          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00738"></a>00738 
<a name="l00739"></a>00739   <span class="comment">// Perform the scatter</span>
<a name="l00740"></a>00740 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00741"></a>00741 <span class="preprocessor"></span>         
<a name="l00742"></a>00742   ierr = VecScatterBegin(_vec, v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, INSERT_VALUES,
<a name="l00743"></a>00743                          SCATTER_FORWARD, scatter);
<a name="l00744"></a>00744          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00745"></a>00745   
<a name="l00746"></a>00746   ierr = VecScatterEnd  (_vec, v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, INSERT_VALUES,
<a name="l00747"></a>00747                          SCATTER_FORWARD, scatter);
<a name="l00748"></a>00748          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00749"></a>00749 <span class="preprocessor">#else</span>
<a name="l00750"></a>00750 <span class="preprocessor"></span>  <span class="comment">// API argument order change in PETSc 2.3.3</span>
<a name="l00751"></a>00751   ierr = VecScatterBegin(scatter, _vec, v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l00752"></a>00752                          INSERT_VALUES, SCATTER_FORWARD);
<a name="l00753"></a>00753          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00754"></a>00754   
<a name="l00755"></a>00755   ierr = VecScatterEnd  (scatter, _vec, v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l00756"></a>00756                          INSERT_VALUES, SCATTER_FORWARD);
<a name="l00757"></a>00757          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00758"></a>00758 <span class="preprocessor">#endif</span>
<a name="l00759"></a>00759 <span class="preprocessor"></span>
<a name="l00760"></a>00760   <span class="comment">// Clean up</span>
<a name="l00761"></a>00761   ierr = ISDestroy (is);
<a name="l00762"></a>00762          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00763"></a>00763   
<a name="l00764"></a>00764   ierr = VecScatterDestroy(scatter);
<a name="l00765"></a>00765          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00766"></a>00766 
<a name="l00767"></a>00767   <span class="comment">// Make sure ghost dofs are up to date</span>
<a name="l00768"></a>00768   <span class="keywordflow">if</span> (v_local-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00769"></a>00769     v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a>();
<a name="l00770"></a>00770 }
<a name="l00771"></a>00771 
<a name="l00772"></a>00772 
<a name="l00773"></a>00773 
<a name="l00774"></a>00774 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00775"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ae10dfabc761296ebf1cd14158ab276d2">00775</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">PetscVector&lt;T&gt;::localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local_in,
<a name="l00776"></a>00776                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list)<span class="keyword"> const</span>
<a name="l00777"></a>00777 <span class="keyword"></span>{
<a name="l00778"></a>00778   this-&gt;_restore_array();
<a name="l00779"></a>00779 
<a name="l00780"></a>00780   <span class="comment">// Make sure the NumericVector passed in is really a PetscVector</span>
<a name="l00781"></a>00781   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* v_local = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;v_local_in);
<a name="l00782"></a>00782 
<a name="l00783"></a>00783   libmesh_assert (v_local != NULL);
<a name="l00784"></a>00784   libmesh_assert (v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a>() == this-&gt;size());
<a name="l00785"></a>00785   libmesh_assert (send_list.size()     &lt;= v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a>());
<a name="l00786"></a>00786   
<a name="l00787"></a>00787   <span class="keywordtype">int</span> ierr=0;
<a name="l00788"></a>00788   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_sl = send_list.size();
<a name="l00789"></a>00789 
<a name="l00790"></a>00790   IS is;
<a name="l00791"></a>00791   VecScatter scatter;
<a name="l00792"></a>00792 
<a name="l00793"></a>00793   std::vector&lt;int&gt; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(n_sl + this-&gt;local_size());
<a name="l00794"></a>00794   
<a name="l00795"></a>00795   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;n_sl; i++)
<a name="l00796"></a>00796     idx[i] = static_cast&lt;int&gt;(send_list[i]);
<a name="l00797"></a>00797   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != this-&gt;local_size(); ++i)
<a name="l00798"></a>00798     idx[n_sl+i] = i + this-&gt;first_local_index();
<a name="l00799"></a>00799   
<a name="l00800"></a>00800   <span class="comment">// Create the index set &amp; scatter object</span>
<a name="l00801"></a>00801   <span class="keywordflow">if</span> (idx.empty())
<a name="l00802"></a>00802     ierr = ISCreateLibMesh(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00803"></a>00803                            n_sl+this-&gt;local_size(), PETSC_NULL, <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca1e5674c0acb009634823faf5b9c9915d">PETSC_USE_POINTER</a>, &amp;is);
<a name="l00804"></a>00804   <span class="keywordflow">else</span>
<a name="l00805"></a>00805     ierr = ISCreateLibMesh(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l00806"></a>00806                            n_sl+this-&gt;local_size(), &amp;idx[0], PETSC_USE_POINTER, &amp;is);
<a name="l00807"></a>00807            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00808"></a>00808 
<a name="l00809"></a>00809   ierr = VecScatterCreate(_vec,          is,
<a name="l00810"></a>00810                           v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, is,
<a name="l00811"></a>00811                           &amp;scatter);
<a name="l00812"></a>00812          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00813"></a>00813 
<a name="l00814"></a>00814   
<a name="l00815"></a>00815   <span class="comment">// Perform the scatter</span>
<a name="l00816"></a>00816 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00817"></a>00817 <span class="preprocessor"></span>         
<a name="l00818"></a>00818   ierr = VecScatterBegin(_vec, v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, INSERT_VALUES,
<a name="l00819"></a>00819                          SCATTER_FORWARD, scatter);
<a name="l00820"></a>00820          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00821"></a>00821   
<a name="l00822"></a>00822   ierr = VecScatterEnd  (_vec, v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, INSERT_VALUES,
<a name="l00823"></a>00823                          SCATTER_FORWARD, scatter);
<a name="l00824"></a>00824          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00825"></a>00825 
<a name="l00826"></a>00826 <span class="preprocessor">#else</span>
<a name="l00827"></a>00827 <span class="preprocessor"></span>         
<a name="l00828"></a>00828   <span class="comment">// API argument order change in PETSc 2.3.3</span>
<a name="l00829"></a>00829   ierr = VecScatterBegin(scatter, _vec, v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l00830"></a>00830                          INSERT_VALUES, SCATTER_FORWARD);
<a name="l00831"></a>00831          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00832"></a>00832   
<a name="l00833"></a>00833   ierr = VecScatterEnd  (scatter, _vec, v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l00834"></a>00834                          INSERT_VALUES, SCATTER_FORWARD);
<a name="l00835"></a>00835          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00836"></a>00836 
<a name="l00837"></a>00837 <span class="preprocessor">#endif</span>
<a name="l00838"></a>00838 <span class="preprocessor"></span>         
<a name="l00839"></a>00839 
<a name="l00840"></a>00840   <span class="comment">// Clean up</span>
<a name="l00841"></a>00841   ierr = ISDestroy (is);
<a name="l00842"></a>00842          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00843"></a>00843   
<a name="l00844"></a>00844   ierr = VecScatterDestroy(scatter);
<a name="l00845"></a>00845          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00846"></a>00846 
<a name="l00847"></a>00847   <span class="comment">// Make sure ghost dofs are up to date</span>
<a name="l00848"></a>00848   <span class="keywordflow">if</span> (v_local-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00849"></a>00849     v_local-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a>();
<a name="l00850"></a>00850 }
<a name="l00851"></a>00851 
<a name="l00852"></a>00852 
<a name="l00853"></a>00853 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00854"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aaebb220c83261bd0574c3c06af613a8a">00854</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">PetscVector&lt;T&gt;::localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00855"></a>00855                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00856"></a>00856                                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list)
<a name="l00857"></a>00857 {
<a name="l00858"></a>00858   this-&gt;_restore_array();
<a name="l00859"></a>00859 
<a name="l00860"></a>00860   <span class="comment">// Only good for serial vectors.</span>
<a name="l00861"></a>00861   <span class="comment">// libmesh_assert (this-&gt;size() == this-&gt;local_size());</span>
<a name="l00862"></a>00862   libmesh_assert (last_local_idx &gt;= first_local_idx);
<a name="l00863"></a>00863   libmesh_assert (send_list.size() &lt;= this-&gt;size());
<a name="l00864"></a>00864   libmesh_assert (last_local_idx &lt; this-&gt;size());
<a name="l00865"></a>00865   
<a name="l00866"></a>00866   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> size       = this-&gt;size();
<a name="l00867"></a>00867   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_size = (last_local_idx - first_local_idx + 1);
<a name="l00868"></a>00868   <span class="keywordtype">int</span> ierr=0;  
<a name="l00869"></a>00869   
<a name="l00870"></a>00870   <span class="comment">// Don&#39;t bother for serial cases</span>
<a name="l00871"></a>00871   <span class="keywordflow">if</span> ((first_local_idx == 0) &amp;&amp;
<a name="l00872"></a>00872       (local_size == size))
<a name="l00873"></a>00873     <span class="keywordflow">return</span>;
<a name="l00874"></a>00874   
<a name="l00875"></a>00875   
<a name="l00876"></a>00876   <span class="comment">// Build a parallel vector, initialize it with the local</span>
<a name="l00877"></a>00877   <span class="comment">// parts of (*this)</span>
<a name="l00878"></a>00878   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> parallel_vec;
<a name="l00879"></a>00879 
<a name="l00880"></a>00880   parallel_vec.<a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a> (size, local_size, <span class="keyword">true</span>, <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00881"></a>00881 
<a name="l00882"></a>00882 
<a name="l00883"></a>00883   <span class="comment">// Copy part of *this into the parallel_vec</span>
<a name="l00884"></a>00884   {
<a name="l00885"></a>00885     IS is;
<a name="l00886"></a>00886     VecScatter scatter;
<a name="l00887"></a>00887 
<a name="l00888"></a>00888     <span class="comment">// Create idx, idx[i] = i+first_local_idx;</span>
<a name="l00889"></a>00889     std::vector&lt;int&gt; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(local_size);
<a name="l00890"></a>00890     <a class="code" href="namespacelibMesh_1_1Utility.php#a40269b7cf3ba8157ed6b3c2399e62809">Utility::iota</a> (idx.begin(), idx.end(), first_local_idx);
<a name="l00891"></a>00891 
<a name="l00892"></a>00892     <span class="comment">// Create the index set &amp; scatter object</span>
<a name="l00893"></a>00893     ierr = ISCreateLibMesh(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, local_size, &amp;idx[0], <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca1e5674c0acb009634823faf5b9c9915d">PETSC_USE_POINTER</a>, &amp;is);
<a name="l00894"></a>00894            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00895"></a>00895 
<a name="l00896"></a>00896     ierr = VecScatterCreate(_vec,              is,
<a name="l00897"></a>00897                             parallel_vec.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, is,
<a name="l00898"></a>00898                             &amp;scatter);
<a name="l00899"></a>00899            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00900"></a>00900 
<a name="l00901"></a>00901     <span class="comment">// Perform the scatter</span>
<a name="l00902"></a>00902 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,3)</span>
<a name="l00903"></a>00903 <span class="preprocessor"></span>
<a name="l00904"></a>00904     ierr = VecScatterBegin(_vec, parallel_vec.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, INSERT_VALUES,
<a name="l00905"></a>00905                            SCATTER_FORWARD, scatter);
<a name="l00906"></a>00906            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00907"></a>00907   
<a name="l00908"></a>00908     ierr = VecScatterEnd  (_vec, parallel_vec.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, INSERT_VALUES,
<a name="l00909"></a>00909                            SCATTER_FORWARD, scatter);
<a name="l00910"></a>00910            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00911"></a>00911 
<a name="l00912"></a>00912 <span class="preprocessor">#else</span>
<a name="l00913"></a>00913 <span class="preprocessor"></span>           
<a name="l00914"></a>00914       <span class="comment">// API argument order change in PETSc 2.3.3</span>
<a name="l00915"></a>00915     ierr = VecScatterBegin(scatter, _vec, parallel_vec.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l00916"></a>00916                            INSERT_VALUES, SCATTER_FORWARD);
<a name="l00917"></a>00917            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00918"></a>00918   
<a name="l00919"></a>00919     ierr = VecScatterEnd  (scatter, _vec, parallel_vec.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l00920"></a>00920                            INSERT_VALUES, SCATTER_FORWARD);
<a name="l00921"></a>00921            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00922"></a>00922            
<a name="l00923"></a>00923 <span class="preprocessor">#endif</span>
<a name="l00924"></a>00924 <span class="preprocessor"></span>
<a name="l00925"></a>00925     <span class="comment">// Clean up</span>
<a name="l00926"></a>00926     ierr = ISDestroy (is);
<a name="l00927"></a>00927            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00928"></a>00928   
<a name="l00929"></a>00929     ierr = VecScatterDestroy(scatter);
<a name="l00930"></a>00930            CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00931"></a>00931   }
<a name="l00932"></a>00932 
<a name="l00933"></a>00933   <span class="comment">// localize like normal</span>
<a name="l00934"></a>00934   parallel_vec.<a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a>();
<a name="l00935"></a>00935   parallel_vec.<a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">localize</a> (*<span class="keyword">this</span>, send_list);
<a name="l00936"></a>00936   this-&gt;<a class="code" href="namespacelibMesh.php#a6e41d4c43a417f7b9e20302af9736247">close</a>();
<a name="l00937"></a>00937 }
<a name="l00938"></a>00938 
<a name="l00939"></a>00939 
<a name="l00940"></a>00940 
<a name="l00941"></a>00941 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00942"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">00942</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">PetscVector&lt;T&gt;::localize</a> (std::vector&lt;T&gt;&amp; v_local)<span class="keyword"> const</span>
<a name="l00943"></a>00943 <span class="keyword"></span>{
<a name="l00944"></a>00944   this-&gt;_restore_array();
<a name="l00945"></a>00945 
<a name="l00946"></a>00946   <span class="comment">// This function must be run on all processors at once</span>
<a name="l00947"></a>00947   parallel_only();
<a name="l00948"></a>00948 
<a name="l00949"></a>00949   <span class="keywordtype">int</span> ierr=0;
<a name="l00950"></a>00950   <span class="keyword">const</span> <span class="keywordtype">int</span> n = this-&gt;size();
<a name="l00951"></a>00951   <span class="keyword">const</span> <span class="keywordtype">int</span> nl = this-&gt;local_size();
<a name="l00952"></a>00952   PetscScalar *values;
<a name="l00953"></a>00953 
<a name="l00954"></a>00954   v_local.clear();
<a name="l00955"></a>00955   v_local.resize(n, 0.);
<a name="l00956"></a>00956 
<a name="l00957"></a>00957   ierr = VecGetArray (_vec, &amp;values);
<a name="l00958"></a>00958          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00959"></a>00959 
<a name="l00960"></a>00960   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff = first_local_index();
<a name="l00961"></a>00961 
<a name="l00962"></a>00962   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;nl; i++)
<a name="l00963"></a>00963     v_local[i+ioff] = static_cast&lt;T&gt;(values[i]);
<a name="l00964"></a>00964 
<a name="l00965"></a>00965   ierr = VecRestoreArray (_vec, &amp;values);
<a name="l00966"></a>00966          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00967"></a>00967 
<a name="l00968"></a>00968   <a class="code" href="namespacelibMesh_1_1Parallel.php#a32ab26117222089e6540e66b05c06b1b">Parallel::sum</a>(v_local);
<a name="l00969"></a>00969 }
<a name="l00970"></a>00970 
<a name="l00971"></a>00971 
<a name="l00972"></a>00972 
<a name="l00973"></a>00973 <span class="comment">// Full specialization for Real datatypes</span>
<a name="l00974"></a>00974 <span class="preprocessor">#ifdef LIBMESH_USE_REAL_NUMBERS</span>
<a name="l00975"></a>00975 <span class="preprocessor"></span>
<a name="l00976"></a>00976 <span class="keyword">template</span> &lt;&gt;
<a name="l00977"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a29690d92463a8edbae460950936bdbf7">00977</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a3b7b8300db75a12c23576c546207b99d">PetscVector&lt;Real&gt;::localize_to_one</a> (std::vector&lt;Real&gt;&amp; v_local,
<a name="l00978"></a>00978                                          <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)<span class="keyword"> const</span>
<a name="l00979"></a>00979 <span class="keyword"></span>{
<a name="l00980"></a>00980   this-&gt;_restore_array();
<a name="l00981"></a>00981 
<a name="l00982"></a>00982   <span class="keywordtype">int</span> ierr=0;
<a name="l00983"></a>00983   <span class="keyword">const</span> <span class="keywordtype">int</span> n  = size();
<a name="l00984"></a>00984   <span class="keyword">const</span> <span class="keywordtype">int</span> nl = local_size();
<a name="l00985"></a>00985   PetscScalar *values;
<a name="l00986"></a>00986 
<a name="l00987"></a>00987   
<a name="l00988"></a>00988   v_local.resize(n);
<a name="l00989"></a>00989 
<a name="l00990"></a>00990   
<a name="l00991"></a>00991   <span class="comment">// only one processor</span>
<a name="l00992"></a>00992   <span class="keywordflow">if</span> (n == nl)
<a name="l00993"></a>00993     {      
<a name="l00994"></a>00994       ierr = VecGetArray (_vec, &amp;values);
<a name="l00995"></a>00995              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00996"></a>00996 
<a name="l00997"></a>00997       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l00998"></a>00998         v_local[i] = static_cast&lt;Real&gt;(values[i]);
<a name="l00999"></a>00999 
<a name="l01000"></a>01000       ierr = VecRestoreArray (_vec, &amp;values);
<a name="l01001"></a>01001              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01002"></a>01002     }
<a name="l01003"></a>01003 
<a name="l01004"></a>01004   <span class="comment">// otherwise multiple processors</span>
<a name="l01005"></a>01005   <span class="keywordflow">else</span>
<a name="l01006"></a>01006     {
<a name="l01007"></a>01007       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff = this-&gt;first_local_index();
<a name="l01008"></a>01008       std::vector&lt;Real&gt; local_values (n, 0.);
<a name="l01009"></a>01009       
<a name="l01010"></a>01010       {
<a name="l01011"></a>01011         ierr = VecGetArray (_vec, &amp;values);
<a name="l01012"></a>01012                CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01013"></a>01013         
<a name="l01014"></a>01014         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;nl; i++)
<a name="l01015"></a>01015           local_values[i+ioff] = static_cast&lt;Real&gt;(values[i]);
<a name="l01016"></a>01016         
<a name="l01017"></a>01017         ierr = VecRestoreArray (_vec, &amp;values);
<a name="l01018"></a>01018                CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01019"></a>01019       }
<a name="l01020"></a>01020       
<a name="l01021"></a>01021 
<a name="l01022"></a>01022       MPI_Reduce (&amp;local_values[0], &amp;v_local[0], n, MPI_REAL, MPI_SUM,
<a name="l01023"></a>01023                   pid, <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);
<a name="l01024"></a>01024     }
<a name="l01025"></a>01025 }
<a name="l01026"></a>01026 
<a name="l01027"></a>01027 <span class="preprocessor">#endif</span>
<a name="l01028"></a>01028 <span class="preprocessor"></span>
<a name="l01029"></a>01029 
<a name="l01030"></a>01030 <span class="comment">// Full specialization for Complex datatypes</span>
<a name="l01031"></a>01031 <span class="preprocessor">#ifdef LIBMESH_USE_COMPLEX_NUMBERS</span>
<a name="l01032"></a>01032 <span class="preprocessor"></span>
<a name="l01033"></a>01033 <span class="keyword">template</span> &lt;&gt;
<a name="l01034"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a5470632610fc1dc963d3ec65ee75b7cc">01034</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a3b7b8300db75a12c23576c546207b99d">PetscVector&lt;Complex&gt;::localize_to_one</a> (std::vector&lt;Complex&gt;&amp; v_local,
<a name="l01035"></a>01035                                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> pid)<span class="keyword"> const</span>
<a name="l01036"></a>01036 <span class="keyword"></span>{
<a name="l01037"></a>01037   this-&gt;_restore_array();
<a name="l01038"></a>01038 
<a name="l01039"></a>01039   <span class="keywordtype">int</span> ierr=0;
<a name="l01040"></a>01040   <span class="keyword">const</span> <span class="keywordtype">int</span> n  = size();
<a name="l01041"></a>01041   <span class="keyword">const</span> <span class="keywordtype">int</span> nl = local_size();
<a name="l01042"></a>01042   PetscScalar *values;
<a name="l01043"></a>01043 
<a name="l01044"></a>01044   
<a name="l01045"></a>01045   v_local.resize(n);
<a name="l01046"></a>01046 
<a name="l01047"></a>01047   
<a name="l01048"></a>01048   <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l01049"></a>01049     v_local[i] = 0.;
<a name="l01050"></a>01050   
<a name="l01051"></a>01051   <span class="comment">// only one processor</span>
<a name="l01052"></a>01052   <span class="keywordflow">if</span> (n == nl)
<a name="l01053"></a>01053     {      
<a name="l01054"></a>01054       ierr = VecGetArray (_vec, &amp;values);
<a name="l01055"></a>01055              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01056"></a>01056 
<a name="l01057"></a>01057       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l01058"></a>01058         v_local[i] = static_cast&lt;Complex&gt;(values[i]);
<a name="l01059"></a>01059 
<a name="l01060"></a>01060       ierr = VecRestoreArray (_vec, &amp;values);
<a name="l01061"></a>01061              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01062"></a>01062     }
<a name="l01063"></a>01063 
<a name="l01064"></a>01064   <span class="comment">// otherwise multiple processors</span>
<a name="l01065"></a>01065   <span class="keywordflow">else</span>
<a name="l01066"></a>01066     {
<a name="l01067"></a>01067       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ioff = this-&gt;first_local_index();
<a name="l01068"></a>01068 
<a name="l01069"></a>01069       <span class="comment">/* in here the local values are stored, acting as send buffer for MPI</span>
<a name="l01070"></a>01070 <span class="comment">       * initialize to zero, since we collect using MPI_SUM</span>
<a name="l01071"></a>01071 <span class="comment">       */</span>
<a name="l01072"></a>01072       std::vector&lt;Real&gt; real_local_values(n, 0.);
<a name="l01073"></a>01073       std::vector&lt;Real&gt; imag_local_values(n, 0.);
<a name="l01074"></a>01074 
<a name="l01075"></a>01075       {
<a name="l01076"></a>01076         ierr = VecGetArray (_vec, &amp;values);
<a name="l01077"></a>01077                CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01078"></a>01078         
<a name="l01079"></a>01079         <span class="comment">// provide my local share to the real and imag buffers</span>
<a name="l01080"></a>01080         <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;nl; i++)
<a name="l01081"></a>01081           {
<a name="l01082"></a>01082             real_local_values[i+ioff] = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a><span class="keyword">&gt;</span>(values[i]).real();
<a name="l01083"></a>01083             imag_local_values[i+ioff] = <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a><span class="keyword">&gt;</span>(values[i]).imag();
<a name="l01084"></a>01084           }
<a name="l01085"></a>01085 
<a name="l01086"></a>01086         ierr = VecRestoreArray (_vec, &amp;values);
<a name="l01087"></a>01087                CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01088"></a>01088       }
<a name="l01089"></a>01089    
<a name="l01090"></a>01090       <span class="comment">/* have buffers of the real and imaginary part of v_local.</span>
<a name="l01091"></a>01091 <span class="comment">       * Once MPI_Reduce() collected all the real and imaginary</span>
<a name="l01092"></a>01092 <span class="comment">       * parts in these std::vector&lt;Real&gt;, the values can be </span>
<a name="l01093"></a>01093 <span class="comment">       * copied to v_local</span>
<a name="l01094"></a>01094 <span class="comment">       */</span>
<a name="l01095"></a>01095       std::vector&lt;Real&gt; real_v_local(n);
<a name="l01096"></a>01096       std::vector&lt;Real&gt; imag_v_local(n);
<a name="l01097"></a>01097 
<a name="l01098"></a>01098       <span class="comment">// collect entries from other proc&#39;s in real_v_local, imag_v_local</span>
<a name="l01099"></a>01099       MPI_Reduce (&amp;real_local_values[0], &amp;real_v_local[0], n, 
<a name="l01100"></a>01100                   MPI_REAL, MPI_SUM,
<a name="l01101"></a>01101                   pid, <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);    
<a name="l01102"></a>01102 
<a name="l01103"></a>01103       MPI_Reduce (&amp;imag_local_values[0], &amp;imag_v_local[0], n, 
<a name="l01104"></a>01104                   MPI_REAL, MPI_SUM,
<a name="l01105"></a>01105                   pid, <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>);    
<a name="l01106"></a>01106 
<a name="l01107"></a>01107       <span class="comment">// copy real_v_local and imag_v_local to v_local</span>
<a name="l01108"></a>01108       <span class="keywordflow">for</span> (<span class="keywordtype">int</span> i=0; i&lt;n; i++)
<a name="l01109"></a>01109         v_local[i] = <a class="code" href="namespacelibMesh.php#a43dea8acd5b918a056f650911d139db0">Complex</a>(real_v_local[i], imag_v_local[i]);
<a name="l01110"></a>01110     }  
<a name="l01111"></a>01111 }
<a name="l01112"></a>01112 
<a name="l01113"></a>01113 <span class="preprocessor">#endif</span>
<a name="l01114"></a>01114 <span class="preprocessor"></span>
<a name="l01115"></a>01115 
<a name="l01116"></a>01116 
<a name="l01117"></a>01117 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01118"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a1a7a9d46b37a104a5ddab4629d96ffb0">01118</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a1a7a9d46b37a104a5ddab4629d96ffb0">PetscVector&lt;T&gt;::pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l01119"></a>01119                                      <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2)
<a name="l01120"></a>01120 {
<a name="l01121"></a>01121   this-&gt;_restore_array();
<a name="l01122"></a>01122 
<a name="l01123"></a>01123   <span class="keywordtype">int</span> ierr = 0;
<a name="l01124"></a>01124 
<a name="l01125"></a>01125   <span class="comment">// Convert arguments to PetscVector*.</span>
<a name="l01126"></a>01126   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* vec1_petsc = libmesh_cast_ptr&lt;const PetscVector&lt;T&gt;*&gt;(&amp;vec1);
<a name="l01127"></a>01127   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* vec2_petsc = libmesh_cast_ptr&lt;const PetscVector&lt;T&gt;*&gt;(&amp;vec2);
<a name="l01128"></a>01128 
<a name="l01129"></a>01129   <span class="comment">// Call PETSc function.</span>
<a name="l01130"></a>01130 
<a name="l01131"></a>01131 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,1)</span>
<a name="l01132"></a>01132 <span class="preprocessor"></span>
<a name="l01133"></a>01133   <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;This method has been developed with PETSc 2.3.1.  &quot;</span>
<a name="l01134"></a>01134                 &lt;&lt; <span class="stringliteral">&quot;No one has made it backwards compatible with older &quot;</span>
<a name="l01135"></a>01135                 &lt;&lt; <span class="stringliteral">&quot;versions of PETSc so far; however, it might work &quot;</span>
<a name="l01136"></a>01136                 &lt;&lt; <span class="stringliteral">&quot;without any change with some older version.&quot;</span> &lt;&lt; std::endl;
<a name="l01137"></a>01137   libmesh_error();
<a name="l01138"></a>01138 
<a name="l01139"></a>01139 <span class="preprocessor">#else</span>
<a name="l01140"></a>01140 <span class="preprocessor"></span>  
<a name="l01141"></a>01141   <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01142"></a>01142     {
<a name="l01143"></a>01143       ierr = VecPointwiseMult(this-&gt;vec(),
<a name="l01144"></a>01144                               <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>*<span class="keyword">&gt;</span>(vec1_petsc)-&gt;vec(),
<a name="l01145"></a>01145                               <span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>*<span class="keyword">&gt;</span>(vec2_petsc)-&gt;vec());
<a name="l01146"></a>01146       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01147"></a>01147     }
<a name="l01148"></a>01148   <span class="keywordflow">else</span>
<a name="l01149"></a>01149     {
<a name="l01150"></a>01150           Vec loc_vec;
<a name="l01151"></a>01151           Vec v1_loc_vec;
<a name="l01152"></a>01152           Vec v2_loc_vec;
<a name="l01153"></a>01153           ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l01154"></a>01154           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01155"></a>01155           ierr = VecGhostGetLocalForm (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>*<span class="keyword">&gt;</span>(vec1_petsc)-&gt;vec(),&amp;v1_loc_vec);
<a name="l01156"></a>01156           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01157"></a>01157           ierr = VecGhostGetLocalForm (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>*<span class="keyword">&gt;</span>(vec2_petsc)-&gt;vec(),&amp;v2_loc_vec);
<a name="l01158"></a>01158           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01159"></a>01159 
<a name="l01160"></a>01160           ierr = VecPointwiseMult(loc_vec,v1_loc_vec,v2_loc_vec);
<a name="l01161"></a>01161           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01162"></a>01162 
<a name="l01163"></a>01163           ierr = VecGhostRestoreLocalForm (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>*<span class="keyword">&gt;</span>(vec1_petsc)-&gt;vec(),&amp;v1_loc_vec);
<a name="l01164"></a>01164           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01165"></a>01165           ierr = VecGhostRestoreLocalForm (<span class="keyword">const_cast&lt;</span><a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>*<span class="keyword">&gt;</span>(vec2_petsc)-&gt;vec(),&amp;v2_loc_vec);
<a name="l01166"></a>01166           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01167"></a>01167           ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l01168"></a>01168           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01169"></a>01169     }
<a name="l01170"></a>01170       
<a name="l01171"></a>01171 <span class="preprocessor">#endif</span>
<a name="l01172"></a>01172 <span class="preprocessor"></span>
<a name="l01173"></a>01173 }
<a name="l01174"></a>01174 
<a name="l01175"></a>01175 
<a name="l01176"></a>01176 
<a name="l01177"></a>01177 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01178"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a41c9c9d46ed87b403c37b869dee65843">01178</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a41c9c9d46ed87b403c37b869dee65843">PetscVector&lt;T&gt;::print_matlab</a> (<span class="keyword">const</span> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>)<span class="keyword"> const</span>
<a name="l01179"></a>01179 <span class="keyword"></span>{
<a name="l01180"></a>01180   this-&gt;_restore_array();
<a name="l01181"></a>01181   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#a3dc0a134260371bd023e0d0f632399e1">closed</a>());
<a name="l01182"></a>01182   
<a name="l01183"></a>01183   <span class="keywordtype">int</span> ierr=0; 
<a name="l01184"></a>01184   PetscViewer petsc_viewer;
<a name="l01185"></a>01185 
<a name="l01186"></a>01186 
<a name="l01187"></a>01187   ierr = PetscViewerCreate (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l01188"></a>01188                             &amp;petsc_viewer);
<a name="l01189"></a>01189          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01190"></a>01190 
<a name="l01195"></a>01195   <span class="keywordflow">if</span> (name != <span class="stringliteral">&quot;NULL&quot;</span>)
<a name="l01196"></a>01196     {
<a name="l01197"></a>01197       ierr = PetscViewerASCIIOpen( <a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l01198"></a>01198                                    name.c_str(),
<a name="l01199"></a>01199                                    &amp;petsc_viewer);
<a name="l01200"></a>01200              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01201"></a>01201       
<a name="l01202"></a>01202       ierr = PetscViewerSetFormat (petsc_viewer,
<a name="l01203"></a>01203                                    PETSC_VIEWER_ASCII_MATLAB);
<a name="l01204"></a>01204              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01205"></a>01205   
<a name="l01206"></a>01206       ierr = VecView (_vec, petsc_viewer);
<a name="l01207"></a>01207              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01208"></a>01208     }
<a name="l01209"></a>01209 
<a name="l01213"></a>01213   <span class="keywordflow">else</span>
<a name="l01214"></a>01214     {
<a name="l01215"></a>01215       ierr = PetscViewerSetFormat (PETSC_VIEWER_STDOUT_WORLD,
<a name="l01216"></a>01216                                    PETSC_VIEWER_ASCII_MATLAB);
<a name="l01217"></a>01217              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01218"></a>01218   
<a name="l01219"></a>01219       ierr = VecView (_vec, PETSC_VIEWER_STDOUT_WORLD);
<a name="l01220"></a>01220              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01221"></a>01221     }
<a name="l01222"></a>01222 
<a name="l01223"></a>01223 
<a name="l01227"></a>01227   ierr = PetscViewerDestroy (petsc_viewer);
<a name="l01228"></a>01228          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01229"></a>01229 }
<a name="l01230"></a>01230 
<a name="l01231"></a>01231 
<a name="l01232"></a>01232 
<a name="l01233"></a>01233 
<a name="l01234"></a>01234 
<a name="l01235"></a>01235 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01236"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a77e562fea6fa014f5cce1df3b68d55b4">01236</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a77e562fea6fa014f5cce1df3b68d55b4">PetscVector&lt;T&gt;::create_subvector</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; subvector,
<a name="l01237"></a>01237                                       <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows)<span class="keyword"> const</span>
<a name="l01238"></a>01238 <span class="keyword"></span>{
<a name="l01239"></a>01239   this-&gt;_restore_array();
<a name="l01240"></a>01240 
<a name="l01241"></a>01241   <span class="comment">// PETSc data structures</span>
<a name="l01242"></a>01242   IS parent_is, subvector_is;
<a name="l01243"></a>01243   VecScatter scatter;
<a name="l01244"></a>01244   <span class="keywordtype">int</span> ierr = 0;
<a name="l01245"></a>01245   
<a name="l01246"></a>01246   <span class="comment">// Make sure the passed in subvector is really a PetscVector</span>
<a name="l01247"></a>01247   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>* petsc_subvector = libmesh_cast_ptr&lt;PetscVector&lt;T&gt;*&gt;(&amp;subvector);
<a name="l01248"></a>01248   
<a name="l01249"></a>01249   <span class="comment">// If the petsc_subvector is already initialized, we assume that the</span>
<a name="l01250"></a>01250   <span class="comment">// user has already allocated the *correct* amount of space for it.</span>
<a name="l01251"></a>01251   <span class="comment">// If not, we use the appropriate PETSc routines to initialize it.</span>
<a name="l01252"></a>01252   <span class="keywordflow">if</span> (!petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a02791337b6c509228fdf3e72320b56d3">initialized</a>())
<a name="l01253"></a>01253     {
<a name="l01254"></a>01254       <span class="comment">// Initialize the petsc_subvector to have enough space to hold</span>
<a name="l01255"></a>01255       <span class="comment">// the entries which will be scattered into it.  Note: such an</span>
<a name="l01256"></a>01256       <span class="comment">// init() function (where we let PETSc decide the number of local</span>
<a name="l01257"></a>01257       <span class="comment">// entries) is not currently offered by the PetscVector</span>
<a name="l01258"></a>01258       <span class="comment">// class.  Should we differentiate here between sequential and</span>
<a name="l01259"></a>01259       <span class="comment">// parallel vector creation based on libMesh::n_processors() ?</span>
<a name="l01260"></a>01260       ierr = VecCreateMPI(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l01261"></a>01261                           PETSC_DECIDE,          <span class="comment">// n_local</span>
<a name="l01262"></a>01262                           rows.size(),           <span class="comment">// n_global</span>
<a name="l01263"></a>01263                           &amp;(petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>)); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01264"></a>01264 
<a name="l01265"></a>01265       ierr = VecSetFromOptions (petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01266"></a>01266 
<a name="l01267"></a>01267       <span class="comment">// Mark the subvector as initialized</span>
<a name="l01268"></a>01268       petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l01269"></a>01269     }
<a name="l01270"></a>01270   <span class="keywordflow">else</span>
<a name="l01271"></a>01271     {
<a name="l01272"></a>01272       petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">_restore_array</a>();
<a name="l01273"></a>01273     }
<a name="l01274"></a>01274   
<a name="l01275"></a>01275   <span class="comment">// Use iota to fill an array with entries [0,1,2,3,4,...rows.size()]</span>
<a name="l01276"></a>01276   std::vector&lt;int&gt; <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>(rows.size());
<a name="l01277"></a>01277   <a class="code" href="namespacelibMesh_1_1Utility.php#a40269b7cf3ba8157ed6b3c2399e62809">Utility::iota</a> (<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>.begin(), <a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>.end(), 0);
<a name="l01278"></a>01278 
<a name="l01279"></a>01279   <span class="comment">// Construct index sets</span>
<a name="l01280"></a>01280   ierr = ISCreateLibMesh(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l01281"></a>01281                          rows.size(),
<a name="l01282"></a>01282                          (<span class="keywordtype">int</span>*) &amp;rows[0],
<a name="l01283"></a>01283                          <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca1e5674c0acb009634823faf5b9c9915d">PETSC_USE_POINTER</a>,
<a name="l01284"></a>01284                          &amp;parent_is); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01285"></a>01285 
<a name="l01286"></a>01286   ierr = ISCreateLibMesh(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,
<a name="l01287"></a>01287                          rows.size(),
<a name="l01288"></a>01288                          (<span class="keywordtype">int</span>*) &amp;<a class="code" href="namespacelibMesh_1_1MeshTools_1_1Generation_1_1Private.php#acd3e3226af58784e414a3c242a3ef740">idx</a>[0],
<a name="l01289"></a>01289                          <a class="code" href="petsc__macro_8h.php#ae087df21a67db9c4b0334f765d1af3bca1e5674c0acb009634823faf5b9c9915d">PETSC_USE_POINTER</a>,
<a name="l01290"></a>01290                          &amp;subvector_is); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01291"></a>01291 
<a name="l01292"></a>01292   <span class="comment">// Construct the scatter object</span>
<a name="l01293"></a>01293   ierr = VecScatterCreate(this-&gt;_vec,
<a name="l01294"></a>01294                           parent_is,
<a name="l01295"></a>01295                           petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l01296"></a>01296                           subvector_is,
<a name="l01297"></a>01297                           &amp;scatter); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01298"></a>01298 
<a name="l01299"></a>01299   <span class="comment">// Actually perform the scatter</span>
<a name="l01300"></a>01300 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,3)</span>
<a name="l01301"></a>01301 <span class="preprocessor"></span>  ierr = VecScatterBegin(this-&gt;_vec,
<a name="l01302"></a>01302                          petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l01303"></a>01303                          INSERT_VALUES,
<a name="l01304"></a>01304                          SCATTER_FORWARD,
<a name="l01305"></a>01305                          scatter); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01306"></a>01306 
<a name="l01307"></a>01307   ierr = VecScatterEnd(this-&gt;_vec,
<a name="l01308"></a>01308                        petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l01309"></a>01309                        INSERT_VALUES,
<a name="l01310"></a>01310                        SCATTER_FORWARD,
<a name="l01311"></a>01311                        scatter); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01312"></a>01312 <span class="preprocessor">#else</span>
<a name="l01313"></a>01313 <span class="preprocessor"></span>  <span class="comment">// API argument order change in PETSc 2.3.3</span>
<a name="l01314"></a>01314   ierr = VecScatterBegin(scatter,
<a name="l01315"></a>01315                          this-&gt;_vec,
<a name="l01316"></a>01316                          petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l01317"></a>01317                          INSERT_VALUES,
<a name="l01318"></a>01318                          SCATTER_FORWARD); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01319"></a>01319 
<a name="l01320"></a>01320   ierr = VecScatterEnd(scatter,
<a name="l01321"></a>01321                        this-&gt;_vec,
<a name="l01322"></a>01322                        petsc_subvector-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>,
<a name="l01323"></a>01323                        INSERT_VALUES,
<a name="l01324"></a>01324                        SCATTER_FORWARD); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01325"></a>01325 <span class="preprocessor">#endif</span>
<a name="l01326"></a>01326 <span class="preprocessor"></span>  
<a name="l01327"></a>01327   <span class="comment">// Clean up </span>
<a name="l01328"></a>01328   ierr = ISDestroy(parent_is);       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01329"></a>01329   ierr = ISDestroy(subvector_is);    CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01330"></a>01330   ierr = VecScatterDestroy(scatter); CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr); 
<a name="l01331"></a>01331 
<a name="l01332"></a>01332 }
<a name="l01333"></a>01333 
<a name="l01334"></a>01334 
<a name="l01335"></a>01335 
<a name="l01336"></a>01336 
<a name="l01337"></a>01337 <span class="comment">//------------------------------------------------------------------</span>
<a name="l01338"></a>01338 <span class="comment">// Explicit instantiations</span>
<a name="l01339"></a>01339 <span class="keyword">template</span> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;Number&gt;</a>;
<a name="l01340"></a>01340 
<a name="l01341"></a>01341 } <span class="comment">// namespace libMesh</span>
<a name="l01342"></a>01342 
<a name="l01343"></a>01343 
<a name="l01344"></a>01344 
<a name="l01345"></a>01345 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
