<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">petsc_vector.h</div>  </div>
</div>
<div class="contents">
<a href="petsc__vector_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: petsc_vector.h 4286 2011-03-24 03:55:50Z knezed01 $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="preprocessor">#ifndef __petsc_vector_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span><span class="preprocessor">#define __petsc_vector_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__config_8h.php">libmesh_config.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="preprocessor">#ifdef LIBMESH_HAVE_PETSC</span>
<a name="l00031"></a>00031 <span class="preprocessor"></span>
<a name="l00032"></a>00032 <span class="comment">// C++ includes</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;string.h&quot;</span> <span class="comment">// Needed for strcmp with gcc-4.4.3</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Local includes</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="numeric__vector_8h.php">numeric_vector.h</a>&quot;</span>
<a name="l00038"></a>00038 <span class="preprocessor">#include &quot;<a class="code" href="petsc__macro_8h.php">petsc_macro.h</a>&quot;</span>
<a name="l00039"></a>00039 
<a name="l00043"></a>00043 EXTERN_C_FOR_PETSC_BEGIN
<a name="l00044"></a>00044 <span class="preprocessor"># include &lt;petscvec.h&gt;</span>
<a name="l00045"></a>00045 EXTERN_C_FOR_PETSC_END
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 <span class="keyword">namespace </span>libMesh
<a name="l00048"></a>00048 {
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 <span class="comment">// forward declarations</span>
<a name="l00053"></a>00053 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00054"></a>00054 
<a name="l00062"></a>00062 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00063"></a><a class="code" href="classlibMesh_1_1PetscVector.php">00063</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector</a>&lt;T&gt;
<a name="l00064"></a>00064 {
<a name="l00065"></a>00065 <span class="keyword">public</span>:
<a name="l00066"></a>00066 
<a name="l00070"></a>00070   <span class="keyword">explicit</span>
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00072"></a>00072   
<a name="l00076"></a>00076   <span class="keyword">explicit</span>
<a name="l00077"></a>00077   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00078"></a>00078                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00079"></a>00079     
<a name="l00084"></a>00084   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00085"></a>00085                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00086"></a>00086                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00087"></a>00087 
<a name="l00093"></a>00093   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00094"></a>00094                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00095"></a>00095                <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00096"></a>00096                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00097"></a>00097   
<a name="l00105"></a>00105   <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector</a>(Vec v);
<a name="l00106"></a>00106   
<a name="l00111"></a>00111   <a class="code" href="classlibMesh_1_1PetscVector.php#a47190fb6c0e223214da7a8fcec32aff3">~PetscVector</a> ();
<a name="l00112"></a>00112 
<a name="l00116"></a>00116   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">close</a> (); 
<a name="l00117"></a>00117 
<a name="l00121"></a>00121   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a007ddfc6829440932987ebb6570ecbc3">clear</a> ();
<a name="l00122"></a>00122   
<a name="l00127"></a>00127   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9c4a5fa4f97980d8d41d5e684b754ad2">zero</a> ();    
<a name="l00128"></a>00128 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a16ae7e736c696598f9ac6ef8fb4722f9">zero_clone</a> () <span class="keyword">const</span>;
<a name="l00135"></a>00135   
<a name="l00139"></a>00139   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a2589fe9ed56966da256d17ae0ed2aaa5">clone</a> () <span class="keyword">const</span>;
<a name="l00140"></a>00140   
<a name="l00154"></a>00154   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00155"></a>00155              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00156"></a>00156              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00157"></a>00157              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00158"></a>00158     
<a name="l00162"></a>00162   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> N,
<a name="l00163"></a>00163              <span class="keyword">const</span> <span class="keywordtype">bool</span>         fast=<span class="keyword">false</span>,
<a name="l00164"></a>00164              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>=<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00165"></a>00165     
<a name="l00170"></a>00170   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*N*/</span>,
<a name="l00171"></a>00171                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <span class="comment">/*n_local*/</span>,
<a name="l00172"></a>00172                      <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; <span class="comment">/*ghost*/</span>,
<a name="l00173"></a>00173                      <span class="keyword">const</span> <span class="keywordtype">bool</span> <span class="comment">/*fast*/</span> = <span class="keyword">false</span>,
<a name="l00174"></a>00174                      <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>);
<a name="l00175"></a>00175 
<a name="l00180"></a>00180   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00181"></a>00181                      <span class="keyword">const</span> <span class="keywordtype">bool</span> fast = <span class="keyword">false</span>);
<a name="l00182"></a>00182 
<a name="l00183"></a>00183   <span class="comment">//   /**</span>
<a name="l00184"></a>00184   <span class="comment">//    * Change the dimension to that of the</span>
<a name="l00185"></a>00185   <span class="comment">//    * vector \p V. The same applies as for</span>
<a name="l00186"></a>00186   <span class="comment">//    * the other \p init function.</span>
<a name="l00187"></a>00187   <span class="comment">//    *</span>
<a name="l00188"></a>00188   <span class="comment">//    * The elements of \p V are not copied, i.e.</span>
<a name="l00189"></a>00189   <span class="comment">//    * this function is the same as calling</span>
<a name="l00190"></a>00190   <span class="comment">//    * \p init(V.size(),fast).</span>
<a name="l00191"></a>00191   <span class="comment">//    */</span>
<a name="l00192"></a>00192   <span class="comment">//   void init (const NumericVector&lt;T&gt;&amp; V,</span>
<a name="l00193"></a>00193   <span class="comment">//         const bool fast=false);</span>
<a name="l00194"></a>00194 
<a name="l00198"></a>00198   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">operator= </a>(<span class="keyword">const</span> T s);
<a name="l00199"></a>00199     
<a name="l00203"></a>00203   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00204"></a>00204 
<a name="l00208"></a>00208   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">operator= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a> &amp;V);
<a name="l00209"></a>00209 
<a name="l00213"></a>00213   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#ae539d02f0976d2a14d78bb26fe387c05">operator= </a>(<span class="keyword">const</span> std::vector&lt;T&gt; &amp;v);
<a name="l00214"></a>00214 
<a name="l00220"></a>00220   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ad6b3453051282426cf2d24a5f818694b">min</a> () <span class="keyword">const</span>;
<a name="l00221"></a>00221   
<a name="l00227"></a>00227   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a451166e5c22db1400d10ad95663570d9">max</a> () <span class="keyword">const</span>;
<a name="l00228"></a>00228 
<a name="l00232"></a>00232   T <a class="code" href="classlibMesh_1_1PetscVector.php#a8e29eb124d4d870a5c4654e1d24ba71b">sum</a> () <span class="keyword">const</span>;
<a name="l00233"></a>00233 
<a name="l00238"></a>00238   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#abdc8865d1b68a5cce20476aadc2741b7">l1_norm</a> () <span class="keyword">const</span>;
<a name="l00239"></a>00239 
<a name="l00245"></a>00245   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#aedba6fc62aa53a8767b115abf8de5c17">l2_norm</a> () <span class="keyword">const</span>;
<a name="l00246"></a>00246 
<a name="l00252"></a>00252   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a2cb0b9e70d671b5a713ab2e817ea2c4e">linfty_norm</a> () <span class="keyword">const</span>;
<a name="l00253"></a>00253 
<a name="l00261"></a>00261   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a> () <span class="keyword">const</span>;
<a name="l00262"></a>00262 
<a name="l00267"></a>00267   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9586f2b97a6c61a35b36f8fbe4c3c944">local_size</a>() <span class="keyword">const</span>;
<a name="l00268"></a>00268 
<a name="l00273"></a>00273   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a24ba974e25d6f45320e44c6b09172445">first_local_index</a>() <span class="keyword">const</span>;
<a name="l00274"></a>00274 
<a name="l00279"></a>00279   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a2e46f596e497108daaf43a994a789a25">last_local_index</a>() <span class="keyword">const</span>;
<a name="l00280"></a>00280 
<a name="l00287"></a>00287   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a03165d6ee0a36f6db8e5a7af1c794b44">map_global_to_local_index</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00288"></a>00288     
<a name="l00292"></a>00292   T <a class="code" href="classlibMesh_1_1PetscVector.php#aed023fcdc606a1397a42db67462acf74">operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i) <span class="keyword">const</span>;
<a name="l00293"></a>00293     
<a name="l00299"></a>00299   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <span class="keyword">get</span>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values) <span class="keyword">const</span>;
<a name="l00300"></a>00300 
<a name="l00305"></a>00305   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#a427752e9e998847c55fe092669c61d10">operator += </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00306"></a>00306 
<a name="l00311"></a>00311   <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; <a class="code" href="classlibMesh_1_1PetscVector.php#a172b730a7ae74d8d811ae47fa253f846">operator -= </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V);
<a name="l00312"></a>00312     
<a name="l00316"></a>00316   <span class="keywordtype">void</span> <span class="keyword">set</span> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00317"></a>00317     
<a name="l00321"></a>00321   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">add</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <span class="keyword">const</span> T value);
<a name="l00322"></a>00322     
<a name="l00328"></a>00328   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">add</a> (<span class="keyword">const</span> T s);
<a name="l00329"></a>00329     
<a name="l00335"></a>00335   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">add</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V);
<a name="l00336"></a>00336 
<a name="l00342"></a>00342   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a56e21f9b50e79ee84da389d2fa1d6ae2">add</a> (<span class="keyword">const</span> T a, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v);
<a name="l00343"></a>00343   
<a name="l00349"></a>00349   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">add_vector</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00350"></a>00350                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00351"></a>00351 
<a name="l00358"></a>00358   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00359"></a>00359                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00366"></a>00366   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V,
<a name="l00367"></a>00367                    <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;A);
<a name="l00368"></a>00368      
<a name="l00375"></a>00375   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a25816c41be95fad452146d515d831d3d">add_vector</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00376"></a>00376                    <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00377"></a>00377 
<a name="l00383"></a>00383   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a2aa269edc0159eca5cc0e25c25ddb03d">add_vector_transpose</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;V,
<a name="l00384"></a>00384                              <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> &amp;A_trans);
<a name="l00385"></a>00385   
<a name="l00390"></a>00390   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">insert</a> (<span class="keyword">const</span> std::vector&lt;T&gt;&amp; v,
<a name="l00391"></a>00391                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00392"></a>00392 
<a name="l00399"></a>00399   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V,
<a name="l00400"></a>00400                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00401"></a>00401       
<a name="l00407"></a>00407   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseVector.php">DenseVector&lt;T&gt;</a>&amp; V,
<a name="l00408"></a>00408                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00409"></a>00409     
<a name="l00415"></a>00415   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0a9cde83712f9cd2ccc1d683be85cf6f">insert</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1DenseSubVector.php">DenseSubVector&lt;T&gt;</a>&amp; V,
<a name="l00416"></a>00416                        <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; dof_indices);
<a name="l00417"></a>00417     
<a name="l00418"></a>00418   
<a name="l00423"></a>00423   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a594b8417a43df556940509786642f8ce">scale</a> (<span class="keyword">const</span> T factor);
<a name="l00424"></a>00424 
<a name="l00429"></a>00429   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a470a96bc67762d23d0abdb8e963ca614">abs</a>();
<a name="l00430"></a>00430 
<a name="l00434"></a>00434   <span class="keyword">virtual</span> T <a class="code" href="classlibMesh_1_1PetscVector.php#a8bec8d600fe295651a58c3c59c4c0ad8">dot</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; V) <span class="keyword">const</span>;
<a name="l00435"></a>00435   
<a name="l00440"></a>00440   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">localize</a> (std::vector&lt;T&gt;&amp; v_local) <span class="keyword">const</span>;
<a name="l00441"></a>00441 
<a name="l00446"></a>00446   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local) <span class="keyword">const</span>;
<a name="l00447"></a>00447 
<a name="l00453"></a>00453   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">localize</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; v_local,
<a name="l00454"></a>00454                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list) <span class="keyword">const</span>;
<a name="l00455"></a>00455   
<a name="l00460"></a>00460   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a888af92342fafe21c75c6a32ce086797">localize</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first_local_idx,
<a name="l00461"></a>00461                  <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last_local_idx,
<a name="l00462"></a>00462                  <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; send_list);
<a name="l00463"></a>00463   
<a name="l00470"></a>00470   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a3b7b8300db75a12c23576c546207b99d">localize_to_one</a> (std::vector&lt;T&gt;&amp; v_local,
<a name="l00471"></a>00471                         <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> proc_id=0) <span class="keyword">const</span>;
<a name="l00472"></a>00472   
<a name="l00477"></a>00477   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a1a7a9d46b37a104a5ddab4629d96ffb0">pointwise_mult</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec1,
<a name="l00478"></a>00478                                <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; vec2);
<a name="l00479"></a>00479 
<a name="l00486"></a>00486   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a41c9c9d46ed87b403c37b869dee65843">print_matlab</a>(<span class="keyword">const</span> std::string <a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>=<span class="stringliteral">&quot;NULL&quot;</span>) <span class="keyword">const</span>;
<a name="l00487"></a>00487 
<a name="l00492"></a>00492   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a77e562fea6fa014f5cce1df3b68d55b4">create_subvector</a>(<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; subvector,
<a name="l00493"></a>00493                                 <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; rows) <span class="keyword">const</span>;
<a name="l00494"></a>00494 
<a name="l00498"></a>00498   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a7ddbc3123946cc4f3d1bdf9831b10ea1">swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;v);
<a name="l00499"></a>00499 
<a name="l00505"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">00505</a>   Vec <a class="code" href="classlibMesh_1_1PetscVector.php#ada434b1090f88c405ad6d0294646a400">vec</a> () { libmesh_assert (<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a> != NULL); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>; }
<a name="l00506"></a>00506 
<a name="l00507"></a>00507 
<a name="l00508"></a>00508   
<a name="l00509"></a>00509 <span class="keyword">private</span>:
<a name="l00510"></a>00510 
<a name="l00515"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">00515</a>   Vec <a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>;
<a name="l00516"></a>00516 
<a name="l00522"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ae10345bff1d65f2b84f7d16c6c7b538c">00522</a>   <span class="keyword">mutable</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ae10345bff1d65f2b84f7d16c6c7b538c">_array_is_present</a>;
<a name="l00523"></a>00523 
<a name="l00524"></a>00524 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l00525"></a>00525 <span class="preprocessor"></span>
<a name="l00530"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ac25a64f1b9af2d6a1daa8cde5b71da95">00530</a>   <span class="keyword">mutable</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ac25a64f1b9af2d6a1daa8cde5b71da95">_local_size</a>;
<a name="l00531"></a>00531 <span class="preprocessor">#endif</span>
<a name="l00532"></a>00532 <span class="preprocessor"></span>
<a name="l00538"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a04af5355d6a0463f3466750d77143f02">00538</a>   <span class="keyword">mutable</span> Vec <a class="code" href="classlibMesh_1_1PetscVector.php#a04af5355d6a0463f3466750d77143f02">_local_form</a>;
<a name="l00539"></a>00539 
<a name="l00544"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a6a4fcd82f63d93f1f4b8d94c154ce2ac">00544</a>   <span class="keyword">mutable</span> PetscScalar* <a class="code" href="classlibMesh_1_1PetscVector.php#a6a4fcd82f63d93f1f4b8d94c154ce2ac">_values</a>;
<a name="l00545"></a>00545 
<a name="l00550"></a>00550   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#aa2b346d42c670f3de26d2f96a0a22dcb">_get_array</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00551"></a>00551 
<a name="l00556"></a>00556   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">_restore_array</a>(<span class="keywordtype">void</span>) <span class="keyword">const</span>;
<a name="l00557"></a>00557 
<a name="l00561"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a9d1e427746f7c4e1c1aacc9d433827ab">00561</a>   <span class="keyword">typedef</span> std::map&lt;unsigned int,unsigned int&gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a9d1e427746f7c4e1c1aacc9d433827ab">GlobalToLocalMap</a>;
<a name="l00562"></a>00562 
<a name="l00567"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">00567</a>   <a class="code" href="classlibMesh_1_1PetscVector.php#a9d1e427746f7c4e1c1aacc9d433827ab">GlobalToLocalMap</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">_global_to_local_map</a>;
<a name="l00568"></a>00568 
<a name="l00573"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ae7bb1316f1184ca49794ba697f81be92">00573</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ae7bb1316f1184ca49794ba697f81be92">_destroy_vec_on_exit</a>;
<a name="l00574"></a>00574 };
<a name="l00575"></a>00575 
<a name="l00576"></a>00576 
<a name="l00577"></a>00577 <span class="comment">/*----------------------- Inline functions ----------------------------------*/</span>
<a name="l00578"></a>00578 
<a name="l00579"></a>00579 
<a name="l00580"></a>00580 
<a name="l00581"></a>00581 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00582"></a>00582 <span class="keyword">inline</span>
<a name="l00583"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">00583</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00584"></a>00584   : _array_is_present(false),
<a name="l00585"></a>00585     _local_form(NULL),
<a name="l00586"></a>00586     _values(NULL),
<a name="l00587"></a>00587     _global_to_local_map(),
<a name="l00588"></a>00588     _destroy_vec_on_exit(true)
<a name="l00589"></a>00589 {
<a name="l00590"></a>00590   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a> = <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>;
<a name="l00591"></a>00591 }
<a name="l00592"></a>00592 
<a name="l00593"></a>00593 
<a name="l00594"></a>00594 
<a name="l00595"></a>00595 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00596"></a>00596 <span class="keyword">inline</span>
<a name="l00597"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a124150b16ec4e194f72d41e1c23a1f4f">00597</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00598"></a>00598                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00599"></a>00599   : _array_is_present(false),
<a name="l00600"></a>00600     _local_form(NULL),
<a name="l00601"></a>00601     _values(NULL),
<a name="l00602"></a>00602     _global_to_local_map(),
<a name="l00603"></a>00603     _destroy_vec_on_exit(true)
<a name="l00604"></a>00604 {
<a name="l00605"></a>00605   this-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a>(n, n, <span class="keyword">false</span>, type);
<a name="l00606"></a>00606 }
<a name="l00607"></a>00607 
<a name="l00608"></a>00608 
<a name="l00609"></a>00609 
<a name="l00610"></a>00610 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00611"></a>00611 <span class="keyword">inline</span>
<a name="l00612"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aefc9053ace1c0a25acf76351856ed517">00612</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00613"></a>00613                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00614"></a>00614                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00615"></a>00615   : _array_is_present(false),
<a name="l00616"></a>00616     _local_form(NULL),
<a name="l00617"></a>00617     _values(NULL),
<a name="l00618"></a>00618     _global_to_local_map(),
<a name="l00619"></a>00619     _destroy_vec_on_exit(true)
<a name="l00620"></a>00620 {
<a name="l00621"></a>00621   this-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a>(n, n_local, <span class="keyword">false</span>, type);
<a name="l00622"></a>00622 }
<a name="l00623"></a>00623 
<a name="l00624"></a>00624 
<a name="l00625"></a>00625 
<a name="l00626"></a>00626 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00627"></a>00627 <span class="keyword">inline</span>
<a name="l00628"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a66d3712ca545a2430bdd0926818ab906">00628</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00629"></a>00629                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00630"></a>00630                              <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00631"></a>00631                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00632"></a>00632   : _array_is_present(false),
<a name="l00633"></a>00633     _local_form(NULL),
<a name="l00634"></a>00634     _values(NULL),
<a name="l00635"></a>00635     _global_to_local_map(),
<a name="l00636"></a>00636     _destroy_vec_on_exit(true)
<a name="l00637"></a>00637 {
<a name="l00638"></a>00638   this-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">init</a>(n, n_local, ghost, <span class="keyword">false</span>, type);
<a name="l00639"></a>00639 }
<a name="l00640"></a>00640 
<a name="l00641"></a>00641 
<a name="l00642"></a>00642 
<a name="l00643"></a>00643 
<a name="l00644"></a>00644 
<a name="l00645"></a>00645 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00646"></a>00646 <span class="keyword">inline</span>
<a name="l00647"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a8e985b9752090d0edf22ce08c7d12793">00647</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a18384c047ea8f12c1c67d0a83a39d482">PetscVector&lt;T&gt;::PetscVector</a> (Vec v)
<a name="l00648"></a>00648   : _array_is_present(false),
<a name="l00649"></a>00649     _local_form(NULL),
<a name="l00650"></a>00650     _values(NULL),
<a name="l00651"></a>00651     _global_to_local_map(),
<a name="l00652"></a>00652     _destroy_vec_on_exit(false)
<a name="l00653"></a>00653 {
<a name="l00654"></a>00654   this-&gt;<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a> = v;
<a name="l00655"></a>00655   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a> = <span class="keyword">true</span>;
<a name="l00656"></a>00656   this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00657"></a>00657 
<a name="l00658"></a>00658   <span class="comment">/* We need to ask PETSc about the (local to global) ghost value</span>
<a name="l00659"></a>00659 <span class="comment">     mapping and create the inverse mapping out of it.  */</span>
<a name="l00660"></a>00660   <span class="keywordtype">int</span> ierr=0;
<a name="l00661"></a>00661   <span class="keywordtype">int</span> petsc_local_size=0;
<a name="l00662"></a>00662   ierr = VecGetLocalSize(<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, &amp;petsc_local_size);
<a name="l00663"></a>00663   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00664"></a>00664 
<a name="l00665"></a>00665   <span class="comment">// Get the vector type from PETSc.</span>
<a name="l00666"></a>00666   <span class="comment">// As of Petsc 3.0.0, the VecType #define lost its const-ness, so we</span>
<a name="l00667"></a>00667   <span class="comment">// need to have it in the code</span>
<a name="l00668"></a>00668 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(3,0,0)</span>
<a name="l00669"></a>00669 <span class="preprocessor"></span>  VecType <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>;
<a name="l00670"></a>00670 <span class="preprocessor">#else</span>
<a name="l00671"></a>00671 <span class="preprocessor"></span>  <span class="keyword">const</span> VecType <a class="code" href="classlibMesh_1_1NumericVector.php#a3b6bc13960a5d0022beea138c4e86dc4">type</a>;
<a name="l00672"></a>00672 <span class="preprocessor">#endif</span>
<a name="l00673"></a>00673 <span class="preprocessor"></span>  ierr = VecGetType(<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, &amp;type);
<a name="l00674"></a>00674   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00675"></a>00675 
<a name="l00676"></a>00676   <span class="keywordflow">if</span>((strcmp(type,VECSHARED) == 0) || (strcmp(type,VECMPI) == 0))
<a name="l00677"></a>00677   {
<a name="l00678"></a>00678     ISLocalToGlobalMapping mapping = <a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>-&gt;mapping;
<a name="l00679"></a>00679 
<a name="l00680"></a>00680     <span class="comment">// If is a sparsely stored vector, set up our new mapping</span>
<a name="l00681"></a>00681     <span class="keywordflow">if</span> (mapping)
<a name="l00682"></a>00682     {
<a name="l00683"></a>00683       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9586f2b97a6c61a35b36f8fbe4c3c944">local_size</a> = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_local_size);
<a name="l00684"></a>00684       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ghost_begin = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_local_size);
<a name="l00685"></a>00685       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> ghost_end = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(mapping-&gt;n);
<a name="l00686"></a>00686       <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=ghost_begin; i&lt;ghost_end; i++)
<a name="l00687"></a>00687         <a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">_global_to_local_map</a>[mapping-&gt;indices[i]] = i-local_size;
<a name="l00688"></a>00688       this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>;
<a name="l00689"></a>00689     }
<a name="l00690"></a>00690     <span class="keywordflow">else</span>
<a name="l00691"></a>00691       this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00692"></a>00692   }
<a name="l00693"></a>00693   <span class="keywordflow">else</span>
<a name="l00694"></a>00694     this-&gt;<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a> = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00695"></a>00695 }
<a name="l00696"></a>00696 
<a name="l00697"></a>00697 
<a name="l00698"></a>00698 
<a name="l00699"></a>00699 
<a name="l00700"></a>00700 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00701"></a>00701 <span class="keyword">inline</span>
<a name="l00702"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a47190fb6c0e223214da7a8fcec32aff3">00702</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a47190fb6c0e223214da7a8fcec32aff3">PetscVector&lt;T&gt;::~PetscVector</a> ()
<a name="l00703"></a>00703 {
<a name="l00704"></a>00704   this-&gt;clear ();
<a name="l00705"></a>00705 }
<a name="l00706"></a>00706 
<a name="l00707"></a>00707 
<a name="l00708"></a>00708 
<a name="l00709"></a>00709 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00710"></a>00710 <span class="keyword">inline</span>
<a name="l00711"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">00711</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00712"></a>00712                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00713"></a>00713                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00714"></a>00714                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00715"></a>00715 {
<a name="l00716"></a>00716   <span class="keywordtype">int</span> ierr=0;
<a name="l00717"></a>00717   <span class="keywordtype">int</span> petsc_n=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00718"></a>00718   <span class="keywordtype">int</span> petsc_n_local=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_local);
<a name="l00719"></a>00719 
<a name="l00720"></a>00720 
<a name="l00721"></a>00721   <span class="comment">// Clear initialized vectors </span>
<a name="l00722"></a>00722   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00723"></a>00723     this-&gt;clear();
<a name="l00724"></a>00724 
<a name="l00725"></a>00725   <span class="keywordflow">if</span> (type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a>)
<a name="l00726"></a>00726     {
<a name="l00727"></a>00727       <span class="keywordflow">if</span> (n == n_local)
<a name="l00728"></a>00728         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>;
<a name="l00729"></a>00729       <span class="keywordflow">else</span>
<a name="l00730"></a>00730         this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>;
<a name="l00731"></a>00731     }
<a name="l00732"></a>00732   <span class="keywordflow">else</span>
<a name="l00733"></a>00733     this-&gt;_type = type;
<a name="l00734"></a>00734 
<a name="l00735"></a>00735   libmesh_assert ((this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a> &amp;&amp; n==n_local) ||
<a name="l00736"></a>00736                   this-&gt;_type==<a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>);
<a name="l00737"></a>00737   
<a name="l00738"></a>00738   <span class="comment">// create a sequential vector if on only 1 processor </span>
<a name="l00739"></a>00739   <span class="keywordflow">if</span> (this-&gt;_type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa333690ccec0379e5dd4ccb60db5ea0c9">SERIAL</a>)
<a name="l00740"></a>00740     {
<a name="l00741"></a>00741       ierr = VecCreateSeq (PETSC_COMM_SELF, petsc_n, &amp;_vec);
<a name="l00742"></a>00742              CHKERRABORT(PETSC_COMM_SELF,ierr);
<a name="l00743"></a>00743       
<a name="l00744"></a>00744       ierr = VecSetFromOptions (_vec);
<a name="l00745"></a>00745              CHKERRABORT(PETSC_COMM_SELF,ierr);
<a name="l00746"></a>00746     }
<a name="l00747"></a>00747   <span class="comment">// otherwise create an MPI-enabled vector</span>
<a name="l00748"></a>00748   <span class="keywordflow">else</span> <span class="keywordflow">if</span> (this-&gt;_type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa54e037459e78638cccaec74deafd631c">PARALLEL</a>)
<a name="l00749"></a>00749     {
<a name="l00750"></a>00750 <span class="preprocessor">#ifdef LIBMESH_HAVE_MPI</span>
<a name="l00751"></a>00751 <span class="preprocessor"></span>      libmesh_assert (n_local &lt;= n);
<a name="l00752"></a>00752       ierr = VecCreateMPI (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, petsc_n_local, petsc_n,
<a name="l00753"></a>00753                            &amp;_vec);
<a name="l00754"></a>00754              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00755"></a>00755 <span class="preprocessor">#else</span>
<a name="l00756"></a>00756 <span class="preprocessor"></span>      libmesh_assert (n_local == n);
<a name="l00757"></a>00757       ierr = VecCreateSeq (PETSC_COMM_SELF, petsc_n, &amp;_vec);
<a name="l00758"></a>00758              CHKERRABORT(PETSC_COMM_SELF,ierr);
<a name="l00759"></a>00759 <span class="preprocessor">#endif</span>
<a name="l00760"></a>00760 <span class="preprocessor"></span>      
<a name="l00761"></a>00761       ierr = VecSetFromOptions (_vec);
<a name="l00762"></a>00762              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00763"></a>00763     }  
<a name="l00764"></a>00764   <span class="keywordflow">else</span>
<a name="l00765"></a>00765     libmesh_error();
<a name="l00766"></a>00766   
<a name="l00767"></a>00767   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00768"></a>00768   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00769"></a>00769   
<a name="l00770"></a>00770   
<a name="l00771"></a>00771   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00772"></a>00772     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00773"></a>00773 }
<a name="l00774"></a>00774 
<a name="l00775"></a>00775 
<a name="l00776"></a>00776 
<a name="l00777"></a>00777 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00778"></a>00778 <span class="keyword">inline</span>
<a name="l00779"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ab4278753fca60ca176d8d7595629f03a">00779</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00780"></a>00780                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00781"></a>00781                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00782"></a>00782 {
<a name="l00783"></a>00783   this-&gt;<a class="code" href="namespacelibMesh.php#a74975b21077cce916d7b3e22ad49290c">init</a>(n,n,fast,type);
<a name="l00784"></a>00784 }
<a name="l00785"></a>00785 
<a name="l00786"></a>00786 
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00789"></a>00789 <span class="keyword">inline</span>
<a name="l00790"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aed5439f90abce9a6027dcb521740320b">00790</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n,
<a name="l00791"></a>00791                            <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_local,
<a name="l00792"></a>00792                            <span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; ghost,
<a name="l00793"></a>00793                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast,
<a name="l00794"></a>00794                            <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76f">ParallelType</a> type)
<a name="l00795"></a>00795 {
<a name="l00796"></a>00796   <span class="keywordtype">int</span> ierr=0;
<a name="l00797"></a>00797   <span class="keywordtype">int</span> petsc_n=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n);
<a name="l00798"></a>00798   <span class="keywordtype">int</span> petsc_n_local=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(n_local);
<a name="l00799"></a>00799   <span class="keywordtype">int</span> petsc_n_ghost=<span class="keyword">static_cast&lt;</span><span class="keywordtype">int</span><span class="keyword">&gt;</span>(ghost.size());
<a name="l00800"></a>00800 
<a name="l00801"></a>00801   <span class="comment">// If the mesh is not disjoint, every processor will either have</span>
<a name="l00802"></a>00802   <span class="comment">// all the dofs, none of the dofs, or some non-zero dofs at the</span>
<a name="l00803"></a>00803   <span class="comment">// boundary between processors.</span>
<a name="l00804"></a>00804   <span class="comment">//</span>
<a name="l00805"></a>00805   <span class="comment">// However we can&#39;t assert this, because someone might want to</span>
<a name="l00806"></a>00806   <span class="comment">// construct a GHOSTED vector which doesn&#39;t include neighbor element</span>
<a name="l00807"></a>00807   <span class="comment">// dofs.  Boyce tried to do so in user code, and we&#39;re going to want</span>
<a name="l00808"></a>00808   <span class="comment">// to do so in System::project_vector().</span>
<a name="l00809"></a>00809   <span class="comment">//</span>
<a name="l00810"></a>00810   <span class="comment">// libmesh_assert(n_local == 0 || n_local == n || !ghost.empty());</span>
<a name="l00811"></a>00811 
<a name="l00812"></a>00812   <span class="keywordtype">int</span>* petsc_ghost = ghost.empty() ? PETSC_NULL :
<a name="l00813"></a>00813     <span class="keyword">const_cast&lt;</span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(<span class="keyword">reinterpret_cast&lt;</span><span class="keyword">const </span><span class="keywordtype">int</span>*<span class="keyword">&gt;</span>(&amp;ghost[0]));
<a name="l00814"></a>00814 
<a name="l00815"></a>00815   <span class="comment">// Clear initialized vectors </span>
<a name="l00816"></a>00816   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00817"></a>00817     this-&gt;clear();
<a name="l00818"></a>00818 
<a name="l00819"></a>00819   libmesh_assert(type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa13dc964f55aa3fba644670673652bc2e">AUTOMATIC</a> || type == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>);
<a name="l00820"></a>00820   this-&gt;_type = <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>;
<a name="l00821"></a>00821 
<a name="l00822"></a>00822   <span class="comment">/* Make the global-to-local ghost cell map.  */</span>
<a name="l00823"></a>00823   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;ghost.size(); i++)
<a name="l00824"></a>00824     {
<a name="l00825"></a>00825       _global_to_local_map[ghost[i]] = i;
<a name="l00826"></a>00826     }
<a name="l00827"></a>00827 
<a name="l00828"></a>00828   <span class="comment">/* Create vector.  */</span>
<a name="l00829"></a>00829   ierr = VecCreateGhost (<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>, petsc_n_local, petsc_n,
<a name="l00830"></a>00830                          petsc_n_ghost, petsc_ghost,
<a name="l00831"></a>00831                          &amp;_vec);
<a name="l00832"></a>00832   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00833"></a>00833   
<a name="l00834"></a>00834   ierr = VecSetFromOptions (_vec);
<a name="l00835"></a>00835   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00836"></a>00836   
<a name="l00837"></a>00837   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">true</span>;
<a name="l00838"></a>00838   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00839"></a>00839   
<a name="l00840"></a>00840   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00841"></a>00841     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00842"></a>00842 }
<a name="l00843"></a>00843 
<a name="l00844"></a>00844 
<a name="l00845"></a>00845 
<a name="l00846"></a>00846 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00847"></a>00847 <span class="keyword">inline</span>
<a name="l00848"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a1a9ed9f54cab101da906d976e0b7bea1">00848</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a83f3b4d4b254651312243dfa478c4128">PetscVector&lt;T&gt;::init</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a>&amp; other,
<a name="l00849"></a>00849                            <span class="keyword">const</span> <span class="keywordtype">bool</span> fast)
<a name="l00850"></a>00850 {
<a name="l00851"></a>00851   <span class="comment">// Clear initialized vectors </span>
<a name="l00852"></a>00852   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00853"></a>00853     this-&gt;clear();
<a name="l00854"></a>00854 
<a name="l00855"></a>00855   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;const PetscVector&lt;T&gt;&amp;&gt;(other);
<a name="l00856"></a>00856 
<a name="l00857"></a>00857   <span class="comment">// Other vector should restore array.</span>
<a name="l00858"></a>00858   <span class="keywordflow">if</span>(v.<a class="code" href="classlibMesh_1_1NumericVector.php#a02791337b6c509228fdf3e72320b56d3">initialized</a>())
<a name="l00859"></a>00859     {
<a name="l00860"></a>00860       v.<a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">_restore_array</a>();
<a name="l00861"></a>00861     }
<a name="l00862"></a>00862 
<a name="l00863"></a>00863   this-&gt;_global_to_local_map = v.<a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">_global_to_local_map</a>;
<a name="l00864"></a>00864   this-&gt;_is_closed      = v.<a class="code" href="classlibMesh_1_1NumericVector.php#a9f798c4a61662ab8486b3ddca31520a3">_is_closed</a>;
<a name="l00865"></a>00865   this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = v.<a class="code" href="classlibMesh_1_1NumericVector.php#a7ec1792df4c8c636e5dd387534067819">_is_initialized</a>;
<a name="l00866"></a>00866   this-&gt;_type = v.<a class="code" href="classlibMesh_1_1NumericVector.php#a5703f5d080a4ac9c725db7660a768fb8">_type</a>;
<a name="l00867"></a>00867 
<a name="l00868"></a>00868   <span class="keywordflow">if</span> (v.<a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">size</a>() != 0)
<a name="l00869"></a>00869     {
<a name="l00870"></a>00870       <span class="keywordtype">int</span> ierr = 0;
<a name="l00871"></a>00871 
<a name="l00872"></a>00872       ierr = VecDuplicate (v.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>, &amp;this-&gt;_vec);
<a name="l00873"></a>00873       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00874"></a>00874     }
<a name="l00875"></a>00875   
<a name="l00876"></a>00876   <span class="keywordflow">if</span> (fast == <span class="keyword">false</span>)
<a name="l00877"></a>00877     this-&gt;<a class="code" href="namespacelibMesh.php#a7384a2e49f01ab6e656cae298da85146">zero</a> ();
<a name="l00878"></a>00878 }
<a name="l00879"></a>00879 
<a name="l00880"></a>00880 
<a name="l00881"></a>00881 
<a name="l00882"></a>00882 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00883"></a>00883 <span class="keyword">inline</span>
<a name="l00884"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">00884</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a0285829baf6ad79ddc9d4e071f5654d6">PetscVector&lt;T&gt;::close</a> ()
<a name="l00885"></a>00885 {
<a name="l00886"></a>00886   this-&gt;_restore_array();
<a name="l00887"></a>00887   
<a name="l00888"></a>00888   <span class="keywordtype">int</span> ierr=0;
<a name="l00889"></a>00889   
<a name="l00890"></a>00890   ierr = VecAssemblyBegin(_vec);
<a name="l00891"></a>00891   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00892"></a>00892   ierr = VecAssemblyEnd(_vec);
<a name="l00893"></a>00893   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00894"></a>00894 
<a name="l00895"></a>00895   <span class="keywordflow">if</span>(this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00896"></a>00896     {
<a name="l00897"></a>00897       ierr = VecGhostUpdateBegin(_vec,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00898"></a>00898       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00899"></a>00899       ierr = VecGhostUpdateEnd(_vec,INSERT_VALUES,SCATTER_FORWARD);
<a name="l00900"></a>00900       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00901"></a>00901     }
<a name="l00902"></a>00902 
<a name="l00903"></a>00903   this-&gt;_is_closed = <span class="keyword">true</span>;
<a name="l00904"></a>00904 }
<a name="l00905"></a>00905 
<a name="l00906"></a>00906 
<a name="l00907"></a>00907 
<a name="l00908"></a>00908 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00909"></a>00909 <span class="keyword">inline</span>
<a name="l00910"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a007ddfc6829440932987ebb6570ecbc3">00910</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a007ddfc6829440932987ebb6570ecbc3">PetscVector&lt;T&gt;::clear</a> ()
<a name="l00911"></a>00911 {
<a name="l00912"></a>00912   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l00913"></a>00913     this-&gt;_restore_array();
<a name="l00914"></a>00914 
<a name="l00915"></a>00915   <span class="keywordflow">if</span> ((this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>()) &amp;&amp; (this-&gt;_destroy_vec_on_exit))
<a name="l00916"></a>00916     {
<a name="l00917"></a>00917       <span class="keywordtype">int</span> ierr=0;
<a name="l00918"></a>00918 
<a name="l00919"></a>00919       ierr = VecDestroy(_vec);
<a name="l00920"></a>00920              CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00921"></a>00921     }
<a name="l00922"></a>00922 
<a name="l00923"></a>00923   this-&gt;_is_closed = this-&gt;<a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00924"></a>00924 
<a name="l00925"></a>00925   _global_to_local_map.clear();
<a name="l00926"></a>00926 }
<a name="l00927"></a>00927 
<a name="l00928"></a>00928 
<a name="l00929"></a>00929 
<a name="l00930"></a>00930 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00931"></a>00931 <span class="keyword">inline</span>
<a name="l00932"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a9c4a5fa4f97980d8d41d5e684b754ad2">00932</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9c4a5fa4f97980d8d41d5e684b754ad2">PetscVector&lt;T&gt;::zero</a> ()
<a name="l00933"></a>00933 {
<a name="l00934"></a>00934   this-&gt;_restore_array();
<a name="l00935"></a>00935   
<a name="l00936"></a>00936   <span class="keywordtype">int</span> ierr=0;
<a name="l00937"></a>00937 
<a name="l00938"></a>00938   PetscScalar z=0.;
<a name="l00939"></a>00939 
<a name="l00940"></a>00940   <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l00941"></a>00941     {
<a name="l00942"></a>00942 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00943"></a>00943 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00944"></a>00944       ierr = VecSet (&amp;z, _vec);
<a name="l00945"></a>00945       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00946"></a>00946 <span class="preprocessor">#else</span>
<a name="l00947"></a>00947 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; newer</span>
<a name="l00948"></a>00948       ierr = VecSet (_vec, z);
<a name="l00949"></a>00949       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00950"></a>00950 <span class="preprocessor">#endif</span>
<a name="l00951"></a>00951 <span class="preprocessor"></span>    }
<a name="l00952"></a>00952   <span class="keywordflow">else</span>
<a name="l00953"></a>00953     {
<a name="l00954"></a>00954       <span class="comment">/* Vectors that include ghost values require a special</span>
<a name="l00955"></a>00955 <span class="comment">         handling.  */</span>
<a name="l00956"></a>00956       Vec loc_vec;
<a name="l00957"></a>00957       ierr = VecGhostGetLocalForm (_vec,&amp;loc_vec);
<a name="l00958"></a>00958       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00959"></a>00959 <span class="preprocessor">#if PETSC_VERSION_LESS_THAN(2,3,0)  </span>
<a name="l00960"></a>00960 <span class="preprocessor"></span>      <span class="comment">// 2.2.x &amp; earlier style</span>
<a name="l00961"></a>00961       ierr = VecSet (&amp;z, loc_vec);
<a name="l00962"></a>00962       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00963"></a>00963 <span class="preprocessor">#else</span>
<a name="l00964"></a>00964 <span class="preprocessor"></span>      <span class="comment">// 2.3.x &amp; newer</span>
<a name="l00965"></a>00965       ierr = VecSet (loc_vec, z);
<a name="l00966"></a>00966       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00967"></a>00967 <span class="preprocessor">#endif</span>
<a name="l00968"></a>00968 <span class="preprocessor"></span>      ierr = VecGhostRestoreLocalForm (_vec,&amp;loc_vec);
<a name="l00969"></a>00969       CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l00970"></a>00970     }
<a name="l00971"></a>00971 }
<a name="l00972"></a>00972 
<a name="l00973"></a>00973 
<a name="l00974"></a>00974 
<a name="l00975"></a>00975 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00976"></a>00976 <span class="keyword">inline</span>
<a name="l00977"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a16ae7e736c696598f9ac6ef8fb4722f9">00977</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a16ae7e736c696598f9ac6ef8fb4722f9">PetscVector&lt;T&gt;::zero_clone</a> ()<span class="keyword"> const</span>
<a name="l00978"></a>00978 <span class="keyword"></span>{
<a name="l00979"></a>00979   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>);
<a name="l00980"></a>00980 
<a name="l00981"></a>00981   cloned_vector-&gt;init(*<span class="keyword">this</span>);
<a name="l00982"></a>00982 
<a name="l00983"></a>00983   <span class="keywordflow">return</span> cloned_vector;
<a name="l00984"></a>00984 }
<a name="l00985"></a>00985 
<a name="l00986"></a>00986 
<a name="l00987"></a>00987 
<a name="l00988"></a>00988 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00989"></a>00989 <span class="keyword">inline</span>
<a name="l00990"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a2589fe9ed56966da256d17ae0ed2aaa5">00990</a> <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; <a class="code" href="classlibMesh_1_1PetscVector.php#a2589fe9ed56966da256d17ae0ed2aaa5">PetscVector&lt;T&gt;::clone</a> ()<span class="keyword"> const</span>
<a name="l00991"></a>00991 <span class="keyword"></span>{
<a name="l00992"></a>00992   <a class="code" href="classlibMesh_1_1AutoPtr.php" title="A simple smart pointer providing strict ownership semantics.">AutoPtr&lt;NumericVector&lt;T&gt;</a> &gt; cloned_vector (<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>);
<a name="l00993"></a>00993 
<a name="l00994"></a>00994   cloned_vector-&gt;init(*<span class="keyword">this</span>, <span class="keyword">true</span>);
<a name="l00995"></a>00995 
<a name="l00996"></a>00996   *cloned_vector = *<span class="keyword">this</span>;
<a name="l00997"></a>00997 
<a name="l00998"></a>00998   <span class="keywordflow">return</span> cloned_vector;
<a name="l00999"></a>00999 }
<a name="l01000"></a>01000 
<a name="l01001"></a>01001 
<a name="l01002"></a>01002 
<a name="l01003"></a>01003 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01004"></a>01004 <span class="keyword">inline</span>
<a name="l01005"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">01005</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#ac4223fe11da95ce84aaf3187bc774544">PetscVector&lt;T&gt;::size</a> ()<span class="keyword"> const</span>
<a name="l01006"></a>01006 <span class="keyword"></span>{
<a name="l01007"></a>01007   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01008"></a>01008   
<a name="l01009"></a>01009   <span class="keywordtype">int</span> ierr=0, petsc_size=0;
<a name="l01010"></a>01010   
<a name="l01011"></a>01011   <span class="keywordflow">if</span> (!this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>())
<a name="l01012"></a>01012     <span class="keywordflow">return</span> 0;
<a name="l01013"></a>01013   
<a name="l01014"></a>01014   ierr = VecGetSize(_vec, &amp;petsc_size);
<a name="l01015"></a>01015          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01016"></a>01016 
<a name="l01017"></a>01017   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_size);
<a name="l01018"></a>01018 }
<a name="l01019"></a>01019 
<a name="l01020"></a>01020 
<a name="l01021"></a>01021 
<a name="l01022"></a>01022 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01023"></a>01023 <span class="keyword">inline</span>
<a name="l01024"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a9586f2b97a6c61a35b36f8fbe4c3c944">01024</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a9586f2b97a6c61a35b36f8fbe4c3c944">PetscVector&lt;T&gt;::local_size</a> ()<span class="keyword"> const</span>
<a name="l01025"></a>01025 <span class="keyword"></span>{
<a name="l01026"></a>01026   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01027"></a>01027   
<a name="l01028"></a>01028   <span class="keywordtype">int</span> ierr=0, petsc_size=0;
<a name="l01029"></a>01029   
<a name="l01030"></a>01030   ierr = VecGetLocalSize(_vec, &amp;petsc_size);
<a name="l01031"></a>01031          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01032"></a>01032   
<a name="l01033"></a>01033   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_size);
<a name="l01034"></a>01034 }
<a name="l01035"></a>01035 
<a name="l01036"></a>01036 
<a name="l01037"></a>01037 
<a name="l01038"></a>01038 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01039"></a>01039 <span class="keyword">inline</span>
<a name="l01040"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a24ba974e25d6f45320e44c6b09172445">01040</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a24ba974e25d6f45320e44c6b09172445">PetscVector&lt;T&gt;::first_local_index</a> ()<span class="keyword"> const</span>
<a name="l01041"></a>01041 <span class="keyword"></span>{
<a name="l01042"></a>01042   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01043"></a>01043   
<a name="l01044"></a>01044   <span class="keywordtype">int</span> ierr=0, petsc_first=0, petsc_last=0;
<a name="l01045"></a>01045   
<a name="l01046"></a>01046   ierr = VecGetOwnershipRange (_vec, &amp;petsc_first, &amp;petsc_last);
<a name="l01047"></a>01047          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01048"></a>01048   
<a name="l01049"></a>01049   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_first);
<a name="l01050"></a>01050 }
<a name="l01051"></a>01051 
<a name="l01052"></a>01052 
<a name="l01053"></a>01053 
<a name="l01054"></a>01054 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01055"></a>01055 <span class="keyword">inline</span>
<a name="l01056"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a2e46f596e497108daaf43a994a789a25">01056</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a2e46f596e497108daaf43a994a789a25">PetscVector&lt;T&gt;::last_local_index</a> ()<span class="keyword"> const</span>
<a name="l01057"></a>01057 <span class="keyword"></span>{
<a name="l01058"></a>01058   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01059"></a>01059   
<a name="l01060"></a>01060   <span class="keywordtype">int</span> ierr=0, petsc_first=0, petsc_last=0;
<a name="l01061"></a>01061   
<a name="l01062"></a>01062   ierr = VecGetOwnershipRange (_vec, &amp;petsc_first, &amp;petsc_last);
<a name="l01063"></a>01063          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01064"></a>01064   
<a name="l01065"></a>01065   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_last);
<a name="l01066"></a>01066 }
<a name="l01067"></a>01067 
<a name="l01068"></a>01068 
<a name="l01069"></a>01069 
<a name="l01070"></a>01070 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01071"></a>01071 <span class="keyword">inline</span>
<a name="l01072"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a03165d6ee0a36f6db8e5a7af1c794b44">01072</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a03165d6ee0a36f6db8e5a7af1c794b44">PetscVector&lt;T&gt;::map_global_to_local_index</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01073"></a>01073 <span class="keyword"></span>{
<a name="l01074"></a>01074   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01075"></a>01075 
<a name="l01076"></a>01076   <span class="keywordtype">int</span> ierr=0, petsc_first=0, petsc_last=0;
<a name="l01077"></a>01077   ierr = VecGetOwnershipRange (_vec, &amp;petsc_first, &amp;petsc_last);
<a name="l01078"></a>01078   CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01079"></a>01079   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> first = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_first);
<a name="l01080"></a>01080   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> last = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(petsc_last);
<a name="l01081"></a>01081 
<a name="l01082"></a>01082   <span class="keywordflow">if</span>((i&gt;=first) &amp;&amp; (i&lt;last))
<a name="l01083"></a>01083     {
<a name="l01084"></a>01084       <span class="keywordflow">return</span> i-first;
<a name="l01085"></a>01085     }
<a name="l01086"></a>01086 
<a name="l01087"></a>01087   GlobalToLocalMap::const_iterator it = _global_to_local_map.find(i);
<a name="l01088"></a>01088   libmesh_assert (it!=_global_to_local_map.end());
<a name="l01089"></a>01089   <span class="keywordflow">return</span> it-&gt;second+last-first;
<a name="l01090"></a>01090 }
<a name="l01091"></a>01091 
<a name="l01092"></a>01092 
<a name="l01093"></a>01093 
<a name="l01094"></a>01094 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01095"></a>01095 <span class="keyword">inline</span>
<a name="l01096"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aed023fcdc606a1397a42db67462acf74">01096</a> T <a class="code" href="classlibMesh_1_1PetscVector.php#aed023fcdc606a1397a42db67462acf74">PetscVector&lt;T&gt;::operator() </a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l01097"></a>01097 <span class="keyword"></span>{
<a name="l01098"></a>01098   this-&gt;_get_array();
<a name="l01099"></a>01099 
<a name="l01100"></a>01100   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index = this-&gt;map_global_to_local_index(i);
<a name="l01101"></a>01101 
<a name="l01102"></a>01102 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01103"></a>01103 <span class="preprocessor"></span>  <span class="keywordflow">if</span>(this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01104"></a>01104     {
<a name="l01105"></a>01105       libmesh_assert(local_index&lt;_local_size);
<a name="l01106"></a>01106     }
<a name="l01107"></a>01107 <span class="preprocessor">#endif</span>
<a name="l01108"></a>01108 <span class="preprocessor"></span>  
<a name="l01109"></a>01109   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(_values[local_index]);
<a name="l01110"></a>01110 }
<a name="l01111"></a>01111 
<a name="l01112"></a>01112 
<a name="l01113"></a>01113 
<a name="l01114"></a>01114 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01115"></a>01115 <span class="keyword">inline</span>
<a name="l01116"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a68dacce6f7d72004375933057460ee8c">01116</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a68dacce6f7d72004375933057460ee8c">PetscVector&lt;T&gt;::get</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt;&amp; index, std::vector&lt;T&gt;&amp; values)<span class="keyword"> const</span>
<a name="l01117"></a>01117 <span class="keyword"></span>{
<a name="l01118"></a>01118   this-&gt;_get_array();
<a name="l01119"></a>01119 
<a name="l01120"></a>01120   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> num = index.size();
<a name="l01121"></a>01121   values.resize(num);
<a name="l01122"></a>01122 
<a name="l01123"></a>01123   <span class="keywordflow">for</span>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;num; i++)
<a name="l01124"></a>01124     {
<a name="l01125"></a>01125       <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> local_index = this-&gt;map_global_to_local_index(index[i]);
<a name="l01126"></a>01126 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01127"></a>01127 <span class="preprocessor"></span>      <span class="keywordflow">if</span>(this-&gt;type() == <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01128"></a>01128         {
<a name="l01129"></a>01129           libmesh_assert(local_index&lt;_local_size);
<a name="l01130"></a>01130         }
<a name="l01131"></a>01131 <span class="preprocessor">#endif</span>
<a name="l01132"></a>01132 <span class="preprocessor"></span>      values[i] = <span class="keyword">static_cast&lt;</span>T<span class="keyword">&gt;</span>(_values[local_index]);
<a name="l01133"></a>01133     }
<a name="l01134"></a>01134 }
<a name="l01135"></a>01135 
<a name="l01136"></a>01136 
<a name="l01137"></a>01137 
<a name="l01138"></a>01138 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01139"></a>01139 <span class="keyword">inline</span>
<a name="l01140"></a><a class="code" href="classlibMesh_1_1PetscVector.php#ad6b3453051282426cf2d24a5f818694b">01140</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#ad6b3453051282426cf2d24a5f818694b">PetscVector&lt;T&gt;::min</a> ()<span class="keyword"> const</span>
<a name="l01141"></a>01141 <span class="keyword"></span>{
<a name="l01142"></a>01142   this-&gt;_restore_array();
<a name="l01143"></a>01143 
<a name="l01144"></a>01144   <span class="keywordtype">int</span> index=0, ierr=0;
<a name="l01145"></a>01145   PetscReal <a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>=0.;
<a name="l01146"></a>01146 
<a name="l01147"></a>01147   ierr = VecMin (_vec, &amp;index, &amp;min);
<a name="l01148"></a>01148          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01149"></a>01149 
<a name="l01150"></a>01150   <span class="comment">// this return value is correct: VecMin returns a PetscReal</span>
<a name="l01151"></a>01151   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(<a class="code" href="namespacestd.php#a4444b32c7044d9b34125eaebd070a0e3">min</a>);
<a name="l01152"></a>01152 }
<a name="l01153"></a>01153 
<a name="l01154"></a>01154 
<a name="l01155"></a>01155 
<a name="l01156"></a>01156 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01157"></a>01157 <span class="keyword">inline</span>
<a name="l01158"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a451166e5c22db1400d10ad95663570d9">01158</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PetscVector.php#a451166e5c22db1400d10ad95663570d9">PetscVector&lt;T&gt;::max</a>()<span class="keyword"> const</span>
<a name="l01159"></a>01159 <span class="keyword"></span>{
<a name="l01160"></a>01160   this-&gt;_restore_array();
<a name="l01161"></a>01161 
<a name="l01162"></a>01162   <span class="keywordtype">int</span> index=0, ierr=0;
<a name="l01163"></a>01163   PetscReal <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>=0.;
<a name="l01164"></a>01164 
<a name="l01165"></a>01165   ierr = VecMax (_vec, &amp;index, &amp;max);
<a name="l01166"></a>01166          CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01167"></a>01167 
<a name="l01168"></a>01168   <span class="comment">// this return value is correct: VecMax returns a PetscReal</span>
<a name="l01169"></a>01169   <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a><span class="keyword">&gt;</span>(<a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">max</a>);
<a name="l01170"></a>01170 }
<a name="l01171"></a>01171 
<a name="l01172"></a>01172 
<a name="l01173"></a>01173 
<a name="l01174"></a>01174 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01175"></a>01175 <span class="keyword">inline</span>
<a name="l01176"></a><a class="code" href="classlibMesh_1_1PetscVector.php#a7ddbc3123946cc4f3d1bdf9831b10ea1">01176</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#a7ddbc3123946cc4f3d1bdf9831b10ea1">PetscVector&lt;T&gt;::swap</a> (<a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp;other)
<a name="l01177"></a>01177 {
<a name="l01178"></a>01178   <a class="code" href="classlibMesh_1_1NumericVector.php#a4a3bb09ff24810391b15da006ba39cb4">NumericVector&lt;T&gt;::swap</a>(other);
<a name="l01179"></a>01179 
<a name="l01180"></a>01180   <a class="code" href="classlibMesh_1_1PetscVector.php">PetscVector&lt;T&gt;</a>&amp; v = libmesh_cast_ref&lt;PetscVector&lt;T&gt;&amp;&gt;(other);
<a name="l01181"></a>01181 
<a name="l01182"></a>01182   std::swap(_vec, v.<a class="code" href="classlibMesh_1_1PetscVector.php#ad5a8a89fa15de5f7bb6fb2d5ab62dea0">_vec</a>);
<a name="l01183"></a>01183   std::swap(_destroy_vec_on_exit, v.<a class="code" href="classlibMesh_1_1PetscVector.php#ae7bb1316f1184ca49794ba697f81be92">_destroy_vec_on_exit</a>);
<a name="l01184"></a>01184   std::swap(_global_to_local_map, v.<a class="code" href="classlibMesh_1_1PetscVector.php#ac28fe132e16a1de3b1521b2aedef05ce">_global_to_local_map</a>);
<a name="l01185"></a>01185   std::swap(_array_is_present, v.<a class="code" href="classlibMesh_1_1PetscVector.php#ae10345bff1d65f2b84f7d16c6c7b538c">_array_is_present</a>);
<a name="l01186"></a>01186   std::swap(_local_form, v.<a class="code" href="classlibMesh_1_1PetscVector.php#a04af5355d6a0463f3466750d77143f02">_local_form</a>);
<a name="l01187"></a>01187   std::swap(_values, v.<a class="code" href="classlibMesh_1_1PetscVector.php#a6a4fcd82f63d93f1f4b8d94c154ce2ac">_values</a>);
<a name="l01188"></a>01188 }
<a name="l01189"></a>01189 
<a name="l01190"></a>01190 
<a name="l01191"></a>01191 
<a name="l01192"></a>01192 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01193"></a>01193 <span class="keyword">inline</span>
<a name="l01194"></a><a class="code" href="classlibMesh_1_1PetscVector.php#aa2b346d42c670f3de26d2f96a0a22dcb">01194</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#aa2b346d42c670f3de26d2f96a0a22dcb">PetscVector&lt;T&gt;::_get_array</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l01195"></a>01195 <span class="keyword"></span>{
<a name="l01196"></a>01196   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01197"></a>01197   <span class="keywordflow">if</span>(!_array_is_present)
<a name="l01198"></a>01198     {
<a name="l01199"></a>01199       <span class="keywordtype">int</span> ierr=0;
<a name="l01200"></a>01200       <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01201"></a>01201         {
<a name="l01202"></a>01202           ierr = VecGetArray(_vec, &amp;_values);
<a name="l01203"></a>01203           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01204"></a>01204         }
<a name="l01205"></a>01205       <span class="keywordflow">else</span>
<a name="l01206"></a>01206         {
<a name="l01207"></a>01207           ierr = VecGhostGetLocalForm (_vec,&amp;_local_form);
<a name="l01208"></a>01208           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01209"></a>01209           ierr = VecGetArray(_local_form, &amp;_values);
<a name="l01210"></a>01210           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01211"></a>01211 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01212"></a>01212 <span class="preprocessor"></span>          <span class="keywordtype">int</span> local_size = 0;
<a name="l01213"></a>01213           ierr = VecGetLocalSize(_local_form, &amp;local_size);
<a name="l01214"></a>01214           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01215"></a>01215           _local_size = <span class="keyword">static_cast&lt;</span><span class="keywordtype">unsigned</span> <span class="keywordtype">int</span><span class="keyword">&gt;</span>(local_size);
<a name="l01216"></a>01216 <span class="preprocessor">#endif</span>
<a name="l01217"></a>01217 <span class="preprocessor"></span>        }
<a name="l01218"></a>01218       _array_is_present = <span class="keyword">true</span>;
<a name="l01219"></a>01219     }
<a name="l01220"></a>01220 }
<a name="l01221"></a>01221 
<a name="l01222"></a>01222 
<a name="l01223"></a>01223 
<a name="l01224"></a>01224 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l01225"></a>01225 <span class="keyword">inline</span>
<a name="l01226"></a><a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">01226</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PetscVector.php#adf26b52e8c4b03874a572389f00d4f9b">PetscVector&lt;T&gt;::_restore_array</a>(<span class="keywordtype">void</span>)<span class="keyword"> const</span>
<a name="l01227"></a>01227 <span class="keyword"></span>{
<a name="l01228"></a>01228   libmesh_assert (this-&gt;<a class="code" href="namespacelibMesh.php#aad2e4639e47d92a7d34c80bf2e936cba">initialized</a>());
<a name="l01229"></a>01229   <span class="keywordflow">if</span>(_array_is_present)
<a name="l01230"></a>01230     {
<a name="l01231"></a>01231       <span class="keywordtype">int</span> ierr=0;
<a name="l01232"></a>01232       <span class="keywordflow">if</span>(this-&gt;type() != <a class="code" href="namespacelibMeshEnums.php#ab7aa22bf764e474e9be7366739d0f76fa9f12475bbe90a64ad167ec0b856ca6c1">GHOSTED</a>)
<a name="l01233"></a>01233         {
<a name="l01234"></a>01234           ierr = VecRestoreArray (_vec, &amp;_values);
<a name="l01235"></a>01235           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01236"></a>01236           _values = NULL;
<a name="l01237"></a>01237         }
<a name="l01238"></a>01238       <span class="keywordflow">else</span>
<a name="l01239"></a>01239         {
<a name="l01240"></a>01240           ierr = VecRestoreArray (_local_form, &amp;_values);
<a name="l01241"></a>01241           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01242"></a>01242           _values = NULL;
<a name="l01243"></a>01243           ierr = VecGhostRestoreLocalForm (_vec,&amp;_local_form);
<a name="l01244"></a>01244           CHKERRABORT(<a class="code" href="namespacelibMesh.php#ad20e070f68f2ad06eda5608a05c35e4f">libMesh::COMM_WORLD</a>,ierr);
<a name="l01245"></a>01245           _local_form = NULL;
<a name="l01246"></a>01246 <span class="preprocessor">#ifndef NDEBUG</span>
<a name="l01247"></a>01247 <span class="preprocessor"></span>          _local_size = 0;
<a name="l01248"></a>01248 <span class="preprocessor">#endif</span>
<a name="l01249"></a>01249 <span class="preprocessor"></span>        }
<a name="l01250"></a>01250       _array_is_present = <span class="keyword">false</span>;
<a name="l01251"></a>01251     }
<a name="l01252"></a>01252 }
<a name="l01253"></a>01253 
<a name="l01254"></a>01254 
<a name="l01255"></a>01255 } <span class="comment">// namespace libMesh</span>
<a name="l01256"></a>01256 
<a name="l01257"></a>01257 
<a name="l01258"></a>01258 <span class="preprocessor">#endif // #ifdef LIBMESH_HAVE_PETSC</span>
<a name="l01259"></a>01259 <span class="preprocessor"></span><span class="preprocessor">#endif // #ifdef __petsc_vector_h__</span>
<a name="l01260"></a>01260 <span class="preprocessor"></span>
<a name="l01261"></a>01261 
<a name="l01262"></a>01262 
<a name="l01263"></a>01263 
<a name="l01264"></a>01264 
<a name="l01265"></a>01265 
<a name="l01266"></a>01266 
<a name="l01267"></a>01267 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
