<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_c9ed10037cd343a70b96b574fb47210b.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">plane.h</div>  </div>
</div>
<div class="contents">
<a href="plane_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: plane.h 4150 2010-12-15 21:07:49Z permcody $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __plane_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __plane_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local includes</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="surface_8h.php">surface.h</a>&quot;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="keyword">namespace </span>libMesh
<a name="l00031"></a>00031 {
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00040"></a>00040 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00041"></a>00041 <span class="comment">// Plane class definition</span>
<a name="l00042"></a><a class="code" href="classlibMesh_1_1Plane.php">00042</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Plane.php">Plane</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1Surface.php">Surface</a>
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044 <span class="keyword">public</span>:
<a name="l00045"></a>00045   
<a name="l00049"></a>00049   <a class="code" href="classlibMesh_1_1Plane.php#a83b93591cfc29e9d4e885bd9efa2d0d8">Plane</a> ();
<a name="l00050"></a>00050 
<a name="l00054"></a>00054   <a class="code" href="classlibMesh_1_1Plane.php#a83b93591cfc29e9d4e885bd9efa2d0d8">Plane</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; n);
<a name="l00055"></a>00055 
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1Plane.php#a83b93591cfc29e9d4e885bd9efa2d0d8">Plane</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p0, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p1, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p2);
<a name="l00062"></a>00062 
<a name="l00066"></a>00066   <a class="code" href="classlibMesh_1_1Plane.php#a83b93591cfc29e9d4e885bd9efa2d0d8">Plane</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Plane.php">Plane</a>&amp; other_plane);
<a name="l00067"></a>00067 
<a name="l00071"></a>00071   <a class="code" href="classlibMesh_1_1Plane.php#a5c3ac0c2dd4ced3f5bd37d91b0051b3a">~Plane</a> ();
<a name="l00072"></a>00072 
<a name="l00076"></a>00076   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Plane.php#a7667ec704c47133068cd271d6aa8d383">create_from_point_normal</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; n);
<a name="l00077"></a>00077 
<a name="l00083"></a>00083   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Plane.php#ac02899304b899ed4d87b2998c4b6ec6c">create_from_three_points</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p0,
<a name="l00084"></a>00084                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p1,
<a name="l00085"></a>00085                                  <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p2 );
<a name="l00086"></a>00086 
<a name="l00090"></a>00090   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Plane.php#ab175c760d1611f0e0a03e4d24ba06318">xy_plane</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zpos=0.);
<a name="l00091"></a>00091 
<a name="l00095"></a>00095   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Plane.php#a21969fed6f6a4c453bd078b444ad6093">xz_plane</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> ypos=0.);
<a name="l00096"></a>00096 
<a name="l00100"></a>00100   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Plane.php#a6cd8ee639f8ee3dddcb6c5d8f0d601ca">yz_plane</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xpos=0.);
<a name="l00101"></a>00101 
<a name="l00106"></a>00106   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Plane.php#a8112263887a77490afa714e561b48c2a">above_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00107"></a>00107 
<a name="l00112"></a>00112   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Plane.php#aeac61b0cbb0820592ef207b9d7fdb231">below_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00113"></a>00113 
<a name="l00120"></a>00120   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Plane.php#aed041b0f7730420fd19b6ba29baf0bf1">on_surface</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00121"></a>00121 
<a name="l00125"></a>00125   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Plane.php#a6ed875da39ea4c2d27ee18f1acf7e7e5">closest_point</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00126"></a>00126 
<a name="l00131"></a>00131   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Plane.php#a960f351664c0fd8189c3c36f63bf84d6">unit_normal</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00132"></a>00132 
<a name="l00137"></a>00137   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1Plane.php#a430c56e779d4605485c88087aa95b19f">get_planar_point</a>() <span class="keyword">const</span>;
<a name="l00138"></a>00138   
<a name="l00139"></a>00139   
<a name="l00140"></a>00140 <span class="keyword">private</span>:
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00146"></a>00146   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; <a class="code" href="classlibMesh_1_1Plane.php#a1cfb3311ab9ba908d1390ed23cf88fd7">normal</a> () <span class="keyword">const</span>;
<a name="l00147"></a>00147   
<a name="l00151"></a><a class="code" href="classlibMesh_1_1Plane.php#a36906fdf173293c8c7a9a6c378931f58">00151</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Plane.php#a36906fdf173293c8c7a9a6c378931f58">_point</a>;
<a name="l00152"></a><a class="code" href="classlibMesh_1_1Plane.php#a183bfe4b7a079185eb1171e68ec62675">00152</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1Plane.php#a183bfe4b7a079185eb1171e68ec62675">_normal</a>;
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 };
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00159"></a>00159 <span class="comment">// Plane class inline members</span>
<a name="l00160"></a><a class="code" href="classlibMesh_1_1Plane.php#a1cfb3311ab9ba908d1390ed23cf88fd7">00160</a> <span class="keyword">inline</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a> &amp; <a class="code" href="classlibMesh_1_1Plane.php#a1cfb3311ab9ba908d1390ed23cf88fd7">Plane::normal</a> ()<span class="keyword"> const</span>
<a name="l00161"></a>00161 <span class="keyword"></span>{
<a name="l00162"></a>00162   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Plane.php#a183bfe4b7a079185eb1171e68ec62675">_normal</a>;
<a name="l00163"></a>00163 }
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 } <span class="comment">// namespace libMesh</span>
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
