<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_0a1fab037dcbf4a6d47af8196906575e.php">geom</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">point.C</div>  </div>
</div>
<div class="contents">
<a href="point_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point.C 3391 2009-05-26 03:50:35Z benkirk $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 <span class="comment">// C++ includes</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="comment">// #include &quot;point.h&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00032"></a>00032 <span class="comment">// Point class member funcions</span>
<a name="l00033"></a>00033 <span class="comment">// unsigned int Point::key() const</span>
<a name="l00034"></a>00034 <span class="comment">// {</span>
<a name="l00035"></a>00035 <span class="comment">//   unsigned int tempx,tempy,tempz;</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">//   int i,j=2,cnt=0;</span>
<a name="l00038"></a>00038 <span class="comment">//   unsigned int index[3];</span>
<a name="l00039"></a>00039 <span class="comment">//   const Real deg = 1.e12;</span>
<a name="l00040"></a>00040   
<a name="l00041"></a>00041 <span class="comment">//   tempx = static_cast&lt;unsigned int&gt;(((*this)(0)*deg));</span>
<a name="l00042"></a>00042 <span class="comment">//   tempy = static_cast&lt;unsigned int&gt;(((*this)(1)*deg));</span>
<a name="l00043"></a>00043 <span class="comment">//   tempz = static_cast&lt;unsigned int&gt;(((*this)(2)*deg));</span>
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 <span class="comment">//   index[0]=0;</span>
<a name="l00046"></a>00046 <span class="comment">//   index[1]=0;</span>
<a name="l00047"></a>00047 <span class="comment">//   index[2]=0;</span>
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 <span class="comment">//   for(i=sizeof(unsigned int)*8-1;i&gt;=0;i--)</span>
<a name="l00050"></a>00050 <span class="comment">//     {</span>
<a name="l00051"></a>00051 <span class="comment">//       index[j] += (tempx &gt;&gt; i) &amp; 01;</span>
<a name="l00052"></a>00052 <span class="comment">//       index[j]  = index[j] &lt;&lt; 01;</span>
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 <span class="comment">//       if (( cnt % (sizeof(unsigned int)*8) == 0) &amp;&amp; (cnt !=0 ) )</span>
<a name="l00055"></a>00055 <span class="comment">//      {</span>
<a name="l00056"></a>00056 <span class="comment">//        cnt = 0;</span>
<a name="l00057"></a>00057 <span class="comment">//        j--;</span>
<a name="l00058"></a>00058 <span class="comment">//      }</span>
<a name="l00059"></a>00059 <span class="comment">//       else</span>
<a name="l00060"></a>00060 <span class="comment">//      cnt++;</span>
<a name="l00061"></a>00061     
<a name="l00062"></a>00062 <span class="comment">//       index[j] += (tempy &gt;&gt; i) &amp; 01;</span>
<a name="l00063"></a>00063 <span class="comment">//       index[j]  = index[j] &lt;&lt; 01;</span>
<a name="l00064"></a>00064 
<a name="l00065"></a>00065 <span class="comment">//       if (( cnt % (sizeof(unsigned int)*8) == 0) &amp;&amp; (cnt !=0 ) )</span>
<a name="l00066"></a>00066 <span class="comment">//      {</span>
<a name="l00067"></a>00067 <span class="comment">//        cnt = 0;</span>
<a name="l00068"></a>00068 <span class="comment">//        j--;</span>
<a name="l00069"></a>00069 <span class="comment">//      }</span>
<a name="l00070"></a>00070 <span class="comment">//       else</span>
<a name="l00071"></a>00071 <span class="comment">//      cnt++;</span>
<a name="l00072"></a>00072     
<a name="l00073"></a>00073 <span class="comment">//       index[j] += (tempz &gt;&gt; i) &amp; 01;</span>
<a name="l00074"></a>00074 <span class="comment">//       index[j]  = index[j] &lt;&lt; 01;</span>
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 <span class="comment">//       if (( cnt % (sizeof(unsigned int)*8) == 0) &amp;&amp; (cnt !=0 ) )</span>
<a name="l00077"></a>00077 <span class="comment">//      {</span>
<a name="l00078"></a>00078 <span class="comment">//        cnt = 0;</span>
<a name="l00079"></a>00079 <span class="comment">//        j--;</span>
<a name="l00080"></a>00080 <span class="comment">//      }</span>
<a name="l00081"></a>00081 <span class="comment">//       else</span>
<a name="l00082"></a>00082 <span class="comment">//      cnt++;</span>
<a name="l00083"></a>00083 <span class="comment">//     }</span>
<a name="l00084"></a>00084 
<a name="l00085"></a>00085 <span class="comment">//   return index[2];</span>
<a name="l00086"></a>00086 <span class="comment">// }</span>
<a name="l00087"></a>00087 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
