<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">point_locator_base.h</div>  </div>
</div>
<div class="contents">
<a href="point__locator__base_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point_locator_base.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __point_locator_base_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __point_locator_base_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local Includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="enum__point__locator__type_8h.php">enum_point_locator_type.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 <span class="comment">// Forward Declarations</span>
<a name="l00042"></a>00042 <span class="keyword">class </span>PointLocatorBase;
<a name="l00043"></a>00043 <span class="keyword">class </span>MeshBase;
<a name="l00044"></a>00044 <span class="keyword">class </span>Point;
<a name="l00045"></a>00045 <span class="keyword">class </span>TreeBase;
<a name="l00046"></a>00046 <span class="keyword">class </span>Elem;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00058"></a>00058 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00059"></a>00059 <span class="comment">// PointLocatorBase class definition</span>
<a name="l00060"></a><a class="code" href="classlibMesh_1_1PointLocatorBase.php">00060</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;PointLocatorBase&gt;
<a name="l00061"></a>00061 {
<a name="l00062"></a>00062 <span class="keyword">protected</span>:
<a name="l00063"></a>00063 
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1PointLocatorBase.php#a9730077d0ab30f183110e853e86a2dcb">PointLocatorBase</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00070"></a>00070                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* master);
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 <span class="keyword">public</span>:
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#a3f92eacbab91e897e41c8173d4eb08c9">~PointLocatorBase</a> ();
<a name="l00079"></a>00079 
<a name="l00086"></a>00086   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;PointLocatorBase&gt;</a> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#ab09c0f5a4b5ebdbe26672289921e1ee3">build</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aca71eafd6001bb6f34dcefc9b6154766">PointLocatorType</a> t,
<a name="l00087"></a>00087                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00088"></a>00088                                           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* master = NULL);
<a name="l00089"></a>00089 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#a91868c29e2c88b4779d3e1a0e86fae1d">clear</a>() = 0;
<a name="l00094"></a>00094 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#a74373cd03dee74d47e62690c45f6eb4f">init</a>() = 0;
<a name="l00100"></a>00100 
<a name="l00105"></a>00105   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1PointLocatorBase.php#ab4d6a657e7f207f5e1d0109aa682ef92">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span> = 0;
<a name="l00106"></a>00106 
<a name="l00111"></a>00111   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#a7cf6fe451ab3467605911798f7b0e39d">initialized</a> () <span class="keyword">const</span>;
<a name="l00112"></a>00112 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#ae1c2be8d30bc642174107694e6b376bf">enable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>) = 0;
<a name="l00120"></a>00120 
<a name="l00126"></a>00126   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#a0a84c4b30b57365b2c1e58ddb29433ad">disable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>) = 0;
<a name="l00127"></a>00127 
<a name="l00128"></a>00128 <span class="keyword">protected</span>:
<a name="l00129"></a>00129 
<a name="l00135"></a><a class="code" href="classlibMesh_1_1PointLocatorBase.php#afa51ddd6562a250bf23df16ade843f17">00135</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* <a class="code" href="classlibMesh_1_1PointLocatorBase.php#afa51ddd6562a250bf23df16ade843f17">_master</a>;
<a name="l00136"></a>00136   
<a name="l00140"></a><a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">00140</a>   <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">_mesh</a>;
<a name="l00141"></a>00141 
<a name="l00145"></a><a class="code" href="classlibMesh_1_1PointLocatorBase.php#a84e5ced6bd58643678b0faed4a7ba799">00145</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#a84e5ced6bd58643678b0faed4a7ba799">_initialized</a>;
<a name="l00146"></a>00146 
<a name="l00147"></a>00147 };
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00151"></a>00151 <span class="comment">// PointLocatorBase inline methods</span>
<a name="l00152"></a>00152 <span class="keyword">inline</span>
<a name="l00153"></a><a class="code" href="classlibMesh_1_1PointLocatorBase.php#a7cf6fe451ab3467605911798f7b0e39d">00153</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php#a7cf6fe451ab3467605911798f7b0e39d">PointLocatorBase::initialized</a> ()<span class="keyword"> const</span>
<a name="l00154"></a>00154 <span class="keyword"></span>{
<a name="l00155"></a>00155   <span class="keywordflow">return</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#a84e5ced6bd58643678b0faed4a7ba799">_initialized</a>);
<a name="l00156"></a>00156 }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 } <span class="comment">// namespace libMesh</span>
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 <span class="preprocessor">#endif</span>
<a name="l00161"></a>00161 <span class="preprocessor"></span>
<a name="l00162"></a>00162 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
