<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">point_locator_list.C</div>  </div>
</div>
<div class="contents">
<a href="point__locator__list_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point_locator_list.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__list_8h.php">point_locator_list.h</a>&quot;</span>
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="keyword">namespace </span>libMesh
<a name="l00030"></a>00030 {
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="comment">// typedefs</span>
<a name="l00034"></a><a class="code" href="namespacelibMesh.php#a249f83b1b81108c806c67f49fefba17f">00034</a> <span class="keyword">typedef</span> std::vector&lt;Point&gt;::const_iterator   <a class="code" href="namespacelibMesh.php#a249f83b1b81108c806c67f49fefba17f">const_list_iterator</a>;
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00038"></a>00038 <span class="comment">// PointLocator methods</span>
<a name="l00039"></a><a class="code" href="classlibMesh_1_1PointLocatorList.php#a4e07ab503a4abf744a55afc20485a7e2">00039</a> <a class="code" href="classlibMesh_1_1PointLocatorList.php#a4e07ab503a4abf744a55afc20485a7e2">PointLocatorList::PointLocatorList</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00040"></a>00040                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* master) :
<a name="l00041"></a>00041   <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> (mesh,master),
<a name="l00042"></a>00042   _list            (NULL)
<a name="l00043"></a>00043 {
<a name="l00044"></a>00044   <span class="comment">// This code will only work if your mesh is the Voroni mesh of it&#39;s</span>
<a name="l00045"></a>00045   <span class="comment">// own elements&#39; centroids.  If your mesh is that regular you might</span>
<a name="l00046"></a>00046   <span class="comment">// as well hand-code an O(1) algorithm for locating points within</span>
<a name="l00047"></a>00047   <span class="comment">// it. - RHS</span>
<a name="l00048"></a>00048   libmesh_experimental();
<a name="l00049"></a>00049 
<a name="l00050"></a>00050   this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a48f6e9f96a192abb7beff704fa53e540">init</a>();
<a name="l00051"></a>00051 }
<a name="l00052"></a>00052 
<a name="l00053"></a>00053 
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classlibMesh_1_1PointLocatorList.php#afb6925c210f7eff7b2798f77b49984ae">00056</a> <a class="code" href="classlibMesh_1_1PointLocatorList.php#afb6925c210f7eff7b2798f77b49984ae">PointLocatorList::~PointLocatorList</a> ()
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058   this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a93a60d63a01a7572a0183c48a4498d8b">clear</a> ();
<a name="l00059"></a>00059 }
<a name="l00060"></a>00060 
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a><a class="code" href="classlibMesh_1_1PointLocatorList.php#a93a60d63a01a7572a0183c48a4498d8b">00064</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorList.php#a93a60d63a01a7572a0183c48a4498d8b">PointLocatorList::clear</a> ()
<a name="l00065"></a>00065 {
<a name="l00066"></a>00066   <span class="comment">// only delete the list when we are the master</span>
<a name="l00067"></a>00067   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a2595686f2f7b05427d2973fbe0bd2a60">_list</a> != NULL)
<a name="l00068"></a>00068     {
<a name="l00069"></a>00069       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#afa51ddd6562a250bf23df16ade843f17">_master</a> == NULL)
<a name="l00070"></a>00070         {
<a name="l00071"></a>00071           <span class="comment">// we own the list</span>
<a name="l00072"></a>00072           this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a2595686f2f7b05427d2973fbe0bd2a60">_list</a>-&gt;clear();
<a name="l00073"></a>00073           <span class="keyword">delete</span> this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a2595686f2f7b05427d2973fbe0bd2a60">_list</a>;
<a name="l00074"></a>00074         }
<a name="l00075"></a>00075       <span class="keywordflow">else</span>
<a name="l00076"></a>00076           <span class="comment">// someone else owns and therefore deletes the list</span>
<a name="l00077"></a>00077           this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a2595686f2f7b05427d2973fbe0bd2a60">_list</a> = NULL;
<a name="l00078"></a>00078     }
<a name="l00079"></a>00079 }
<a name="l00080"></a>00080 
<a name="l00081"></a>00081 
<a name="l00082"></a>00082 
<a name="l00083"></a>00083 
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classlibMesh_1_1PointLocatorList.php#a48f6e9f96a192abb7beff704fa53e540">00085</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorList.php#a48f6e9f96a192abb7beff704fa53e540">PointLocatorList::init</a> ()
<a name="l00086"></a>00086 {
<a name="l00087"></a>00087   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a2595686f2f7b05427d2973fbe0bd2a60">_list</a> == NULL); 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#a84e5ced6bd58643678b0faed4a7ba799">_initialized</a>)
<a name="l00090"></a>00090     {
<a name="l00091"></a>00091       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Already initialized!  Will ignore this call...&quot;</span>
<a name="l00092"></a>00092                     &lt;&lt; std::endl;
<a name="l00093"></a>00093     }
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="keywordflow">else</span>
<a name="l00096"></a>00096 
<a name="l00097"></a>00097     {
<a name="l00098"></a>00098 
<a name="l00099"></a>00099       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#afa51ddd6562a250bf23df16ade843f17">_master</a> == NULL)
<a name="l00100"></a>00100         {
<a name="l00101"></a>00101           <span class="comment">// We are the master, so we have to build the list.</span>
<a name="l00102"></a>00102           <span class="comment">// First create it, then get a handy reference, and</span>
<a name="l00103"></a>00103           <span class="comment">// then try to speed up by reserving space...</span>
<a name="l00104"></a>00104           this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a2595686f2f7b05427d2973fbe0bd2a60">_list</a> = <span class="keyword">new</span> std::vector&lt;std::pair&lt;Point, const Elem *&gt; &gt;;
<a name="l00105"></a>00105           std::vector&lt;std::pair&lt;Point, const Elem *&gt; &gt;&amp; my_list = *(this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a2595686f2f7b05427d2973fbe0bd2a60">_list</a>);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107           my_list.clear();
<a name="l00108"></a>00108           my_list.reserve(this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a9067012d79ffd869a3ece283ac3c3bd3">n_active_elem</a>());
<a name="l00109"></a>00109 
<a name="l00110"></a>00110           <span class="comment">// fill our list with the centroids and element</span>
<a name="l00111"></a>00111           <span class="comment">// pointers of the mesh.  For this use the handy</span>
<a name="l00112"></a>00112           <span class="comment">// element iterators.</span>
<a name="l00113"></a>00113 <span class="comment">//        const_active_elem_iterator       el (this-&gt;_mesh.elements_begin());</span>
<a name="l00114"></a>00114 <span class="comment">//        const const_active_elem_iterator end(this-&gt;_mesh.elements_end()); </span>
<a name="l00115"></a>00115 
<a name="l00116"></a>00116           <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       el  = <a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#aefa4ded9eaf654a45ab593a0963ecbf3">active_elements_begin</a>();
<a name="l00117"></a>00117           <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end = <a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#ae3f09f1b7556aef88919249861728e23">active_elements_end</a>(); 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119           <span class="keywordflow">for</span> (; el!=end; ++el)
<a name="l00120"></a>00120             my_list.push_back(std::make_pair((*el)-&gt;centroid(), *el));
<a name="l00121"></a>00121         }
<a name="l00122"></a>00122 
<a name="l00123"></a>00123       <span class="keywordflow">else</span>
<a name="l00124"></a>00124           
<a name="l00125"></a>00125         {
<a name="l00126"></a>00126           <span class="comment">// We are _not_ the master.  Let our _list point to</span>
<a name="l00127"></a>00127           <span class="comment">// the master&#39;s list.  But for this we first transform</span>
<a name="l00128"></a>00128           <span class="comment">// the master in a state for which we are friends</span>
<a name="l00129"></a>00129           <span class="comment">// (this should also beware of a bad master pointer?).</span>
<a name="l00130"></a>00130           <span class="comment">// And make sure the master @e has a list!</span>
<a name="l00131"></a>00131           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorList.php">PointLocatorList</a>* my_master =
<a name="l00132"></a>00132             libmesh_cast_ptr&lt;const PointLocatorList*&gt;(this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#afa51ddd6562a250bf23df16ade843f17">_master</a>);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134           <span class="keywordflow">if</span> (my_master-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#a7cf6fe451ab3467605911798f7b0e39d">initialized</a>())
<a name="l00135"></a>00135             this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a2595686f2f7b05427d2973fbe0bd2a60">_list</a> = my_master-&gt;<a class="code" href="classlibMesh_1_1PointLocatorList.php#a2595686f2f7b05427d2973fbe0bd2a60">_list</a>;
<a name="l00136"></a>00136           <span class="keywordflow">else</span>
<a name="l00137"></a>00137             {
<a name="l00138"></a>00138               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Initialize master first, then servants!&quot;</span>
<a name="l00139"></a>00139                             &lt;&lt; std::endl;
<a name="l00140"></a>00140               libmesh_error();
<a name="l00141"></a>00141             }
<a name="l00142"></a>00142         }
<a name="l00143"></a>00143 
<a name="l00144"></a>00144     }
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 
<a name="l00147"></a>00147   <span class="comment">// ready for take-off</span>
<a name="l00148"></a>00148   this-&gt;_initialized = <span class="keyword">true</span>;
<a name="l00149"></a>00149 }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a><a class="code" href="classlibMesh_1_1PointLocatorList.php#a74482fa901fa0b7abcece1f2d5e4edc1">00155</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* PointLocatorList::operator() (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00156"></a>00156 <span class="keyword"></span>{
<a name="l00157"></a>00157   libmesh_assert (this-&gt;_initialized);
<a name="l00158"></a>00158 
<a name="l00159"></a>00159   <span class="comment">// Ask the list.  This is quite expensive, since</span>
<a name="l00160"></a>00160   <span class="comment">// we loop through the whole list to try to find</span>
<a name="l00161"></a>00161   <span class="comment">// the @e nearest element.</span>
<a name="l00162"></a>00162   <span class="comment">// However, there is not much else to do: when</span>
<a name="l00163"></a>00163   <span class="comment">// we would use bounding boxes like in a tree,</span>
<a name="l00164"></a>00164   <span class="comment">// it may happen that a surface element is just</span>
<a name="l00165"></a>00165   <span class="comment">// in plane with a bounding box face, and quite</span>
<a name="l00166"></a>00166   <span class="comment">// close to it.  But when a point comes, this</span>
<a name="l00167"></a>00167   <span class="comment">// point may belong to the bounding box (where the</span>
<a name="l00168"></a>00168   <span class="comment">// coplanar element does @e not belong to).  Then</span>
<a name="l00169"></a>00169   <span class="comment">// we would search through the elements in this </span>
<a name="l00170"></a>00170   <span class="comment">// bounding box, while the other bounding box&#39;es</span>
<a name="l00171"></a>00171   <span class="comment">// element is closer, but we simply don&#39;t consider</span>
<a name="l00172"></a>00172   <span class="comment">// it!</span>
<a name="l00173"></a>00173   <span class="comment">//</span>
<a name="l00174"></a>00174   <span class="comment">// We _can_, however, use size_sq() instead of size()</span>
<a name="l00175"></a>00175   <span class="comment">// here to avoid repeated calls to std::sqrt(), which is</span>
<a name="l00176"></a>00176   <span class="comment">// pretty expensive.</span>
<a name="l00177"></a>00177   {
<a name="l00178"></a>00178     std::vector&lt;std::pair&lt;Point, const Elem *&gt; &gt;&amp; my_list = *(this-&gt;_list);
<a name="l00179"></a>00179 
<a name="l00180"></a>00180     <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>               last_distance_sq = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(my_list[0].first -p).<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>();
<a name="l00181"></a>00181     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a> *       last_elem        = NULL;
<a name="l00182"></a>00182     <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> max_index        = my_list.size();
<a name="l00183"></a>00183 
<a name="l00184"></a>00184 
<a name="l00185"></a>00185     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n=1; n&lt;max_index; n++)
<a name="l00186"></a>00186       {
<a name="l00187"></a>00187         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> current_distance_sq = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(my_list[n].first -p).<a class="code" href="classlibMesh_1_1TypeVector.php#a6388a8db55ae02bdf8a72d0c4df45301">size_sq</a>();
<a name="l00188"></a>00188 
<a name="l00189"></a>00189         <span class="keywordflow">if</span> (current_distance_sq &lt; last_distance_sq)
<a name="l00190"></a>00190           {
<a name="l00191"></a>00191             last_distance_sq = current_distance_sq;
<a name="l00192"></a>00192             last_elem        = my_list[n].second;
<a name="l00193"></a>00193           }
<a name="l00194"></a>00194       }
<a name="l00195"></a>00195 
<a name="l00196"></a>00196     <span class="comment">// the element should be active</span>
<a name="l00197"></a>00197     libmesh_assert (last_elem-&gt;<a class="code" href="classlibMesh_1_1Elem.php#ab426ef9274eb93de879fef28b027d602">active</a>());
<a name="l00198"></a>00198 
<a name="l00199"></a>00199     <span class="comment">// return the element</span>
<a name="l00200"></a>00200     <span class="keywordflow">return</span> (last_elem);
<a name="l00201"></a>00201   }
<a name="l00202"></a>00202 
<a name="l00203"></a>00203 }
<a name="l00204"></a>00204 
<a name="l00205"></a><a class="code" href="classlibMesh_1_1PointLocatorList.php#aaffe689e4f161da6e0304387e3fc92ac">00205</a> <span class="keywordtype">void</span> PointLocatorList::enable_out_of_mesh_mode (<span class="keywordtype">void</span>)
<a name="l00206"></a>00206 {
<a name="l00207"></a>00207   <span class="comment">/* This functionality is not yet implemented for PointLocatorList.  */</span>
<a name="l00208"></a>00208   libmesh_not_implemented();
<a name="l00209"></a>00209 }
<a name="l00210"></a>00210 
<a name="l00211"></a><a class="code" href="classlibMesh_1_1PointLocatorList.php#aa79a7a5b1eef5fed2ef99c1bb8d8e6d3">00211</a> <span class="keywordtype">void</span> PointLocatorList::disable_out_of_mesh_mode (<span class="keywordtype">void</span>)
<a name="l00212"></a>00212 {
<a name="l00213"></a>00213   <span class="comment">/* This functionality is not yet implemented for PointLocatorList.  */</span>
<a name="l00214"></a>00214   libmesh_not_implemented();
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 } <span class="comment">// namespace libMesh</span>
<a name="l00218"></a>00218 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
