<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_1c51a0dd851c719e6b4bbeb78ad36bc0.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">point_locator_tree.C</div>  </div>
</div>
<div class="contents">
<a href="point__locator__tree_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point_locator_tree.C 4372 2011-04-20 18:50:40Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local Includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="mesh__base_8h.php">mesh_base.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="elem_8h.php">elem.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="tree_8h.php">tree.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__tree_8h.php">point_locator_tree.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="mesh__tools_8h.php">mesh_tools.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">//------------------------------------------------------------------</span>
<a name="l00037"></a>00037 <span class="comment">// PointLocator methods</span>
<a name="l00038"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#ad3bc957dbf0423fca76639d76a0a21d8">00038</a> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#ad3bc957dbf0423fca76639d76a0a21d8">PointLocatorTree::PointLocatorTree</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00039"></a>00039                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* master) :
<a name="l00040"></a>00040   <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> (mesh,master),
<a name="l00041"></a>00041   _tree            (NULL),
<a name="l00042"></a>00042   _element         (NULL),
<a name="l00043"></a>00043   _out_of_mesh_mode(false)
<a name="l00044"></a>00044 {
<a name="l00045"></a>00045   this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a3d25bf04da42208484b5fb5985b52cdf">init</a>(<a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9a99710d266ed849862503d6da40f75565">Trees::NODES</a>);
<a name="l00046"></a>00046 }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#a8e52da8f8385f90172d116ed634a658c">00051</a> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#ad3bc957dbf0423fca76639d76a0a21d8">PointLocatorTree::PointLocatorTree</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00052"></a>00052                                     <span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">Trees::BuildType</a> build_type,
<a name="l00053"></a>00053                                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* master) :
<a name="l00054"></a>00054   <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a> (mesh,master),
<a name="l00055"></a>00055   _tree            (NULL),
<a name="l00056"></a>00056   _element         (NULL),
<a name="l00057"></a>00057   _out_of_mesh_mode(false)
<a name="l00058"></a>00058 {
<a name="l00059"></a>00059   this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a3d25bf04da42208484b5fb5985b52cdf">init</a>(build_type);
<a name="l00060"></a>00060 }
<a name="l00061"></a>00061 
<a name="l00062"></a>00062 
<a name="l00063"></a>00063 
<a name="l00064"></a>00064 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#a2965a21b0b32ac32a038f66921491cfb">00065</a> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a2965a21b0b32ac32a038f66921491cfb">PointLocatorTree::~PointLocatorTree</a> ()
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067   this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a2804594d256a9126664fe026fd32d2b9">clear</a> ();
<a name="l00068"></a>00068 }
<a name="l00069"></a>00069 
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#a2804594d256a9126664fe026fd32d2b9">00073</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a2804594d256a9126664fe026fd32d2b9">PointLocatorTree::clear</a> ()
<a name="l00074"></a>00074 {
<a name="l00075"></a>00075   <span class="comment">// only delete the tree when we are the master</span>
<a name="l00076"></a>00076   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a> != NULL)
<a name="l00077"></a>00077     {
<a name="l00078"></a>00078       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#afa51ddd6562a250bf23df16ade843f17">_master</a> == NULL)
<a name="l00079"></a>00079           <span class="comment">// we own the tree</span>
<a name="l00080"></a>00080           <span class="keyword">delete</span> this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a>;
<a name="l00081"></a>00081       <span class="keywordflow">else</span>
<a name="l00082"></a>00082           <span class="comment">// someone else owns and therefore deletes the tree</span>
<a name="l00083"></a>00083           this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a> = NULL;
<a name="l00084"></a>00084     }
<a name="l00085"></a>00085 }
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 
<a name="l00091"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#ad1d526e686d860fdfd44ec90de6a3cc5">00091</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a3d25bf04da42208484b5fb5985b52cdf">PointLocatorTree::init</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">Trees::BuildType</a> build_type)
<a name="l00092"></a>00092 {
<a name="l00093"></a>00093   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a> == NULL); 
<a name="l00094"></a>00094 
<a name="l00095"></a>00095   <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#a84e5ced6bd58643678b0faed4a7ba799">_initialized</a>)
<a name="l00096"></a>00096     {
<a name="l00097"></a>00097       <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Already initialized!  Will ignore this call...&quot;</span>
<a name="l00098"></a>00098                     &lt;&lt; std::endl;
<a name="l00099"></a>00099     }
<a name="l00100"></a>00100 
<a name="l00101"></a>00101   <span class="keywordflow">else</span>
<a name="l00102"></a>00102 
<a name="l00103"></a>00103     {
<a name="l00104"></a>00104 
<a name="l00105"></a>00105       <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#afa51ddd6562a250bf23df16ade843f17">_master</a> == NULL)
<a name="l00106"></a>00106         {
<a name="l00107"></a>00107           <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">_mesh</a>.<a class="code" href="classlibMesh_1_1MeshBase.php#a1bc787d29f4c496f107aed988be4b9bf">mesh_dimension</a>() == 3)
<a name="l00108"></a>00108             <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a> = <span class="keyword">new</span> <a class="code" href="classlibMesh_1_1Tree.php">Trees::OctTree</a> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">_mesh</a>, 200, build_type);          
<a name="l00109"></a>00109           <span class="keywordflow">else</span>
<a name="l00110"></a>00110             {
<a name="l00111"></a>00111               <span class="comment">// A 1D/2D mesh in 3D space needs special consideration.</span>
<a name="l00112"></a>00112               <span class="comment">// If the mesh is planar XY, we want to build a QuadTree</span>
<a name="l00113"></a>00113               <span class="comment">// to search efficiently.  If the mesh is truly a manifold,</span>
<a name="l00114"></a>00114               <span class="comment">// then we need an octree</span>
<a name="l00115"></a>00115 <span class="preprocessor">#if LIBMESH_DIM &gt; 2</span>
<a name="l00116"></a>00116 <span class="preprocessor"></span>              <span class="keywordtype">bool</span> is_planar_xy = <span class="keyword">false</span>;
<a name="l00117"></a>00117               
<a name="l00118"></a>00118               <span class="comment">// Build the bounding box for the mesh.  If the delta-z bound is</span>
<a name="l00119"></a>00119               <span class="comment">// negligibly small then we can use a quadtree.</span>
<a name="l00120"></a>00120               {
<a name="l00121"></a>00121                 <a class="code" href="classlibMesh_1_1MeshTools_1_1BoundingBox.php">MeshTools::BoundingBox</a> bbox = <a class="code" href="namespacelibMesh_1_1MeshTools.php#ab099ca10b8e0521017c6d28644b88135">MeshTools::bounding_box</a>(this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">_mesh</a>);
<a name="l00122"></a>00122                 
<a name="l00123"></a>00123                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l00124"></a>00124                   Dx = bbox.second(0) - bbox.first(0),
<a name="l00125"></a>00125                   Dz = bbox.second(2) - bbox.first(2);
<a name="l00126"></a>00126                 
<a name="l00127"></a>00127                 <span class="keywordflow">if</span> (std::abs(Dz/(Dx + 1.e-20)) &lt; 1e-10)
<a name="l00128"></a>00128                   is_planar_xy = <span class="keyword">true</span>;
<a name="l00129"></a>00129               }
<a name="l00130"></a>00130                             
<a name="l00131"></a>00131               <span class="keywordflow">if</span> (!is_planar_xy)
<a name="l00132"></a>00132                 <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a> = <span class="keyword">new</span> <a class="code" href="namespacelibMesh_1_1Trees.php#afb2b70bbc4692560ad1dac3727feb769">Trees::OctTree</a> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">_mesh</a>, 200, build_type);
<a name="l00133"></a>00133               <span class="keywordflow">else</span>
<a name="l00134"></a>00134 <span class="preprocessor">#endif</span>
<a name="l00135"></a>00135 <span class="preprocessor"></span>                <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a> = <span class="keyword">new</span> <a class="code" href="namespacelibMesh_1_1Trees.php#a29a21088dbdfa3cf27d5a38780a19760">Trees::QuadTree</a> (this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#ad9b6557329fc2c75f97a489e749dfdd8">_mesh</a>, 200, build_type);
<a name="l00136"></a>00136             }
<a name="l00137"></a>00137         }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139       <span class="keywordflow">else</span>
<a name="l00140"></a>00140           
<a name="l00141"></a>00141         {
<a name="l00142"></a>00142           <span class="comment">// We are _not_ the master.  Let our Tree point to</span>
<a name="l00143"></a>00143           <span class="comment">// the master&#39;s tree.  But for this we first transform</span>
<a name="l00144"></a>00144           <span class="comment">// the master in a state for which we are friends.</span>
<a name="l00145"></a>00145           <span class="comment">// And make sure the master @e has a tree!</span>
<a name="l00146"></a>00146           <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php">PointLocatorTree</a>* my_master =
<a name="l00147"></a>00147             libmesh_cast_ptr&lt;const PointLocatorTree*&gt;(this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#afa51ddd6562a250bf23df16ade843f17">_master</a>);
<a name="l00148"></a>00148 
<a name="l00149"></a>00149           <span class="keywordflow">if</span> (my_master-&gt;<a class="code" href="classlibMesh_1_1PointLocatorBase.php#a7cf6fe451ab3467605911798f7b0e39d">initialized</a>())
<a name="l00150"></a>00150             this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a> = my_master-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a>;
<a name="l00151"></a>00151           <span class="keywordflow">else</span>
<a name="l00152"></a>00152             {
<a name="l00153"></a>00153               <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Initialize master first, then servants!&quot;</span>
<a name="l00154"></a>00154                             &lt;&lt; std::endl;
<a name="l00155"></a>00155               libmesh_error();
<a name="l00156"></a>00156             }
<a name="l00157"></a>00157         }
<a name="l00158"></a>00158 
<a name="l00159"></a>00159 
<a name="l00160"></a>00160       <span class="comment">// Not all PointLocators may own a tree, but all of them</span>
<a name="l00161"></a>00161       <span class="comment">// use their own element pointer.  Let the element pointer</span>
<a name="l00162"></a>00162       <span class="comment">// be unique for every interpolator.</span>
<a name="l00163"></a>00163       <span class="comment">// Suppose the interpolators are used concurrently</span>
<a name="l00164"></a>00164       <span class="comment">// at different locations in the mesh, then it makes quite</span>
<a name="l00165"></a>00165       <span class="comment">// sense to have unique start elements.</span>
<a name="l00166"></a>00166       this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a4d6a0fd94a8482aebb5024faea8f9407">_element</a> = NULL;
<a name="l00167"></a>00167     }
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 
<a name="l00170"></a>00170   <span class="comment">// ready for take-off</span>
<a name="l00171"></a>00171   this-&gt;_initialized = <span class="keyword">true</span>;
<a name="l00172"></a>00172 }
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#add8eb7e47fd0d1ac89ea91bc08cb5ce8">00178</a> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* PointLocatorTree::operator() (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p)<span class="keyword"> const</span>
<a name="l00179"></a>00179 <span class="keyword"></span>{
<a name="l00180"></a>00180   libmesh_assert (this-&gt;_initialized);
<a name="l00181"></a>00181   
<a name="l00182"></a>00182   <span class="comment">// First check the element from last time before asking the tree</span>
<a name="l00183"></a>00183   <span class="keywordflow">if</span> (this-&gt;_element==NULL || !(this-&gt;_element-&gt;contains_point(p)))
<a name="l00184"></a>00184     {
<a name="l00185"></a>00185         <span class="comment">// ask the tree</span>
<a name="l00186"></a>00186         this-&gt;_element = this-&gt;_tree-&gt;find_element (p);
<a name="l00187"></a>00187 
<a name="l00188"></a>00188         <span class="keywordflow">if</span> (this-&gt;_element == NULL)
<a name="l00189"></a>00189           {
<a name="l00190"></a>00190             <span class="comment">/* No element seems to contain this point.  If out-of-mesh</span>
<a name="l00191"></a>00191 <span class="comment">               mode is enabled, just return NULL.  If not, however, we</span>
<a name="l00192"></a>00192 <span class="comment">               have to perform a linear search before we call \p</span>
<a name="l00193"></a>00193 <span class="comment">               libmesh_error() since in the case of curved elements, the</span>
<a name="l00194"></a>00194 <span class="comment">               bounding box computed in \p TreeNode::insert(const</span>
<a name="l00195"></a>00195 <span class="comment">               Elem*) might be slightly inaccurate.  */</span>
<a name="l00196"></a>00196             <span class="keywordflow">if</span>(!_out_of_mesh_mode)
<a name="l00197"></a>00197               {
<a name="l00198"></a>00198                 <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       pos     = this-&gt;_mesh.active_elements_begin();
<a name="l00199"></a>00199                 <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_pos = this-&gt;_mesh.active_elements_end();
<a name="l00200"></a>00200                 
<a name="l00201"></a>00201                 <span class="keywordflow">for</span> ( ; pos != end_pos; ++pos)
<a name="l00202"></a>00202                   <span class="keywordflow">if</span> ((*pos)-&gt;contains_point(p))
<a name="l00203"></a>00203                     <span class="keywordflow">return</span> this-&gt;_element = (*pos);
<a name="l00204"></a>00204 
<a name="l00205"></a>00205                 <span class="keywordflow">if</span> (this-&gt;_element == NULL)
<a name="l00206"></a>00206                   {
<a name="l00207"></a>00207                     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; std::endl
<a name="l00208"></a>00208                                   &lt;&lt; <span class="stringliteral">&quot; ******** Serious Problem.  Could not find an Element &quot;</span>
<a name="l00209"></a>00209                                   &lt;&lt; <span class="stringliteral">&quot;in the Mesh&quot;</span> 
<a name="l00210"></a>00210                                   &lt;&lt; std:: endl
<a name="l00211"></a>00211                                   &lt;&lt; <span class="stringliteral">&quot; ******** that contains the Point &quot;</span>
<a name="l00212"></a>00212                                   &lt;&lt; p;
<a name="l00213"></a>00213                     libmesh_error();
<a name="l00214"></a>00214                   }
<a name="l00215"></a>00215               }
<a name="l00216"></a>00216           }
<a name="l00217"></a>00217     }
<a name="l00218"></a>00218   
<a name="l00219"></a>00219   <span class="comment">// If we found an element, it should be active</span>
<a name="l00220"></a>00220   libmesh_assert (!this-&gt;_element || this-&gt;_element-&gt;active());
<a name="l00221"></a>00221 
<a name="l00222"></a>00222   <span class="comment">// return the element</span>
<a name="l00223"></a>00223   <span class="keywordflow">return</span> this-&gt;_element;
<a name="l00224"></a>00224 }
<a name="l00225"></a>00225 
<a name="l00226"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#a46904e327c23918926e786c525c35aab">00226</a> <span class="keywordtype">void</span> PointLocatorTree::enable_out_of_mesh_mode (<span class="keywordtype">void</span>)
<a name="l00227"></a>00227 {
<a name="l00228"></a>00228   <span class="comment">/* Out-of-mesh mode is currently only supported if all of the</span>
<a name="l00229"></a>00229 <span class="comment">     elements have affine mappings.  The reason is that for quadratic</span>
<a name="l00230"></a>00230 <span class="comment">     mappings, it is not easy to construct a relyable bounding box of</span>
<a name="l00231"></a>00231 <span class="comment">     the element, and thus, the fallback linear search in \p</span>
<a name="l00232"></a>00232 <span class="comment">     operator() is required.  Hence, out-of-mesh mode would be</span>
<a name="l00233"></a>00233 <span class="comment">     extremely slow.  */</span>
<a name="l00234"></a>00234   <span class="keywordflow">if</span>(!_out_of_mesh_mode)
<a name="l00235"></a>00235     {
<a name="l00236"></a>00236 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00237"></a>00237 <span class="preprocessor"></span>      <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a>       pos     = this-&gt;_mesh.active_elements_begin();
<a name="l00238"></a>00238       <span class="keyword">const</span> <a class="code" href="structlibMesh_1_1MeshBase_1_1const__element__iterator.php">MeshBase::const_element_iterator</a> end_pos = this-&gt;_mesh.active_elements_end();
<a name="l00239"></a>00239       <span class="keywordflow">for</span> ( ; pos != end_pos; ++pos)
<a name="l00240"></a>00240         <span class="keywordflow">if</span> (!(*pos)-&gt;has_affine_map())
<a name="l00241"></a>00241           {
<a name="l00242"></a>00242             <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Out-of-mesh mode is currently only supported if all elements have affine mappings.&quot;</span> &lt;&lt; std::endl;
<a name="l00243"></a>00243             libmesh_error();
<a name="l00244"></a>00244           }
<a name="l00245"></a>00245 <span class="preprocessor">#endif</span>
<a name="l00246"></a>00246 <span class="preprocessor"></span>      
<a name="l00247"></a>00247       _out_of_mesh_mode = <span class="keyword">true</span>;
<a name="l00248"></a>00248     }
<a name="l00249"></a>00249 }
<a name="l00250"></a>00250 
<a name="l00251"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#a73cf141f7ffabc8a5e4385e5ee67f3c2">00251</a> <span class="keywordtype">void</span> PointLocatorTree::disable_out_of_mesh_mode (<span class="keywordtype">void</span>)
<a name="l00252"></a>00252 {
<a name="l00253"></a>00253   _out_of_mesh_mode = <span class="keyword">false</span>;
<a name="l00254"></a>00254 }
<a name="l00255"></a>00255 
<a name="l00256"></a>00256 } <span class="comment">// namespace libMesh</span>
<a name="l00257"></a>00257 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
