<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_1814684ce9288779ac5c7da2680527db.php">utils</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">point_locator_tree.h</div>  </div>
</div>
<div class="contents">
<a href="point__locator__tree_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: point_locator_tree.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __point_locator_tree_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __point_locator_tree_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 <span class="comment">// Local Includes</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="point__locator__base_8h.php">point_locator_base.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="tree__base_8h.php">tree_base.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>MeshBase;
<a name="l00039"></a>00039 <span class="keyword">class </span>Point;
<a name="l00040"></a>00040 <span class="keyword">class </span>Elem;
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// PointLocatorTree class definition</span>
<a name="l00055"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php">00055</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PointLocatorTree.php">PointLocatorTree</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>
<a name="l00056"></a>00056 {
<a name="l00057"></a>00057 <span class="keyword">public</span>:
<a name="l00058"></a>00058 
<a name="l00059"></a>00059 
<a name="l00068"></a>00068   <a class="code" href="classlibMesh_1_1PointLocatorTree.php#ad3bc957dbf0423fca76639d76a0a21d8">PointLocatorTree</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="mesh__communication_8C.php#afaa03b874c297f4693d9cdef7f50f3c6">mesh</a>,
<a name="l00069"></a>00069                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* master = NULL);
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1PointLocatorTree.php#ad3bc957dbf0423fca76639d76a0a21d8">PointLocatorTree</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; mesh,
<a name="l00084"></a>00084                     <span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">Trees::BuildType</a> build_type,
<a name="l00085"></a>00085                     <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1PointLocatorBase.php">PointLocatorBase</a>* master = NULL);
<a name="l00086"></a>00086 
<a name="l00087"></a>00087     
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="keyword">public</span>:
<a name="l00090"></a>00090 
<a name="l00094"></a>00094   <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a2965a21b0b32ac32a038f66921491cfb">~PointLocatorTree</a> ();
<a name="l00095"></a>00095 
<a name="l00099"></a>00099   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a2804594d256a9126664fe026fd32d2b9">clear</a>();
<a name="l00100"></a>00100 
<a name="l00105"></a>00105   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a3d25bf04da42208484b5fb5985b52cdf">init</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9">Trees::BuildType</a> build_type);
<a name="l00106"></a>00106 
<a name="l00111"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#a3d25bf04da42208484b5fb5985b52cdf">00111</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a3d25bf04da42208484b5fb5985b52cdf">init</a>() { this-&gt;<a class="code" href="classlibMesh_1_1PointLocatorTree.php#a3d25bf04da42208484b5fb5985b52cdf">init</a>(<a class="code" href="namespacelibMesh_1_1Trees.php#aa445f2ee1b3f644fcc6ef02e5192dff9a99710d266ed849862503d6da40f75565">Trees::NODES</a>); };
<a name="l00112"></a>00112 
<a name="l00119"></a>00119   <span class="keyword">virtual</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1PointLocatorTree.php#add8eb7e47fd0d1ac89ea91bc08cb5ce8">operator() </a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Point.php">Point</a>&amp; p) <span class="keyword">const</span>;
<a name="l00120"></a>00120 
<a name="l00127"></a>00127   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a46904e327c23918926e786c525c35aab">enable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>);
<a name="l00128"></a>00128 
<a name="l00134"></a>00134   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a73cf141f7ffabc8a5e4385e5ee67f3c2">disable_out_of_mesh_mode</a> (<span class="keywordtype">void</span>);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136 <span class="keyword">protected</span>:
<a name="l00137"></a>00137 
<a name="l00143"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">00143</a>   <a class="code" href="classlibMesh_1_1TreeBase.php">TreeBase</a>* <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a1771a0b2ee6bcfd95344a00c4e3a8b4a">_tree</a>;
<a name="l00144"></a>00144 
<a name="l00150"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#a4d6a0fd94a8482aebb5024faea8f9407">00150</a>   <span class="keyword">mutable</span> <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* <a class="code" href="classlibMesh_1_1PointLocatorTree.php#a4d6a0fd94a8482aebb5024faea8f9407">_element</a>;
<a name="l00151"></a>00151 
<a name="l00156"></a><a class="code" href="classlibMesh_1_1PointLocatorTree.php#aee3699bfb41bc30d34e8f7880a990340">00156</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1PointLocatorTree.php#aee3699bfb41bc30d34e8f7880a990340">_out_of_mesh_mode</a>;
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 };
<a name="l00159"></a>00159 
<a name="l00160"></a>00160 
<a name="l00161"></a>00161 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00162"></a>00162 <span class="comment">// PointLocatorTree inline methods</span>
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 
<a name="l00165"></a>00165 } <span class="comment">// namespace libMesh</span>
<a name="l00166"></a>00166 
<a name="l00167"></a>00167 <span class="preprocessor">#endif</span>
<a name="l00168"></a>00168 <span class="preprocessor"></span>
<a name="l00169"></a>00169 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
