<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_3e5624a3cbc2fe49c445f4c1e628332f.php">mesh</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">postscript_io.h</div>  </div>
</div>
<div class="contents">
<a href="postscript__io_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: postscript_io.h 3928 2010-08-24 22:39:45Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __postscript_io_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __postscript_io_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="mesh__output_8h.php">mesh_output.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="comment">//#include &quot;dense_matrix.h&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward declarations</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>MeshBase;
<a name="l00039"></a>00039 <span class="keyword">class </span>Elem;
<a name="l00040"></a>00040 
<a name="l00052"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php">00052</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1PostscriptIO.php">PostscriptIO</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1MeshOutput.php">MeshOutput</a>&lt;MeshBase&gt;
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054  <span class="keyword">public</span>:
<a name="l00058"></a>00058   <a class="code" href="classlibMesh_1_1PostscriptIO.php#ab08c4a2b522d5abe22129386ce1feb15">PostscriptIO</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1MeshBase.php">MeshBase</a>&amp; <a class="code" href="classlibMesh_1_1MeshOutput.php#ab5720c977b43a80f3e9d29bd3eedb173">mesh</a>);
<a name="l00059"></a>00059 
<a name="l00063"></a>00063   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1PostscriptIO.php#a415fcffa09479ec8f6474e125fe1fb34">~PostscriptIO</a> ();
<a name="l00064"></a>00064 
<a name="l00068"></a>00068   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PostscriptIO.php#addb4f799a23efd1110cdb56c6f1b64c9">write</a> (<span class="keyword">const</span> std::string&amp; );
<a name="l00069"></a>00069   
<a name="l00078"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php#abf0e518dedf7914dbfaf5f76bcc6012e">00078</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PostscriptIO.php#abf0e518dedf7914dbfaf5f76bcc6012e">shade_value</a>;
<a name="l00079"></a>00079 
<a name="l00086"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php#ac8e32c9449680541434871081dae1988">00086</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PostscriptIO.php#ac8e32c9449680541434871081dae1988">line_width</a>;
<a name="l00087"></a>00087   
<a name="l00091"></a>00091   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PostscriptIO.php#a0402b685c7cc2f26beb58be5858f8151">plot_quadratic_elem</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00092"></a>00092 
<a name="l00096"></a>00096   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PostscriptIO.php#adaa47b61eb23843fe184c3af22549e85">plot_linear_elem</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00097"></a>00097   
<a name="l00098"></a>00098 <span class="keyword">private</span>:
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1PostscriptIO.php#ae7212f49c3dc6f09934bca7b9f554696">_compute_edge_bezier_coeffs</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1Elem.php">Elem</a>* elem);
<a name="l00105"></a>00105 
<a name="l00111"></a>00111   <span class="comment">//DenseMatrix&lt;float&gt; _M;</span>
<a name="l00112"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php#a565dbb4cf8fa5db92b798e2128365138">00112</a>   <span class="keyword">static</span> <span class="keyword">const</span> <span class="keywordtype">float</span> <a class="code" href="classlibMesh_1_1PostscriptIO.php#a565dbb4cf8fa5db92b798e2128365138">_bezier_transform</a>[3][3];
<a name="l00113"></a>00113   
<a name="l00118"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php#a6f119505cc8d0d10abf8ad45536bc471">00118</a>   std::vector&lt;Point&gt; <a class="code" href="classlibMesh_1_1PostscriptIO.php#a6f119505cc8d0d10abf8ad45536bc471">_bezier_coeffs</a>;
<a name="l00119"></a>00119 
<a name="l00123"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php#a8762d74481afc10ad4653b0d23fa2596">00123</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1PostscriptIO.php#a8762d74481afc10ad4653b0d23fa2596">_offset</a>;
<a name="l00124"></a>00124 
<a name="l00128"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php#a2528f89e82265e5eca7d52271d51952f">00128</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1PostscriptIO.php#a2528f89e82265e5eca7d52271d51952f">_scale</a>;
<a name="l00129"></a>00129 
<a name="l00133"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php#a82072a4fcdaa0dc25764521c5cf8b3c5">00133</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1PostscriptIO.php#a82072a4fcdaa0dc25764521c5cf8b3c5">_current_point</a>;
<a name="l00134"></a>00134 
<a name="l00140"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php#a211cb3d8d4ae26ff9d8e11be614c9559">00140</a>   std::ostringstream <a class="code" href="classlibMesh_1_1PostscriptIO.php#a211cb3d8d4ae26ff9d8e11be614c9559">_cell_string</a>;
<a name="l00141"></a>00141 
<a name="l00145"></a><a class="code" href="classlibMesh_1_1PostscriptIO.php#a3c05baddacf9a1dabe8a3ac9c8945071">00145</a>   std::ofstream <a class="code" href="classlibMesh_1_1PostscriptIO.php#a3c05baddacf9a1dabe8a3ac9c8945071">_out</a>;
<a name="l00146"></a>00146 };
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 } <span class="comment">// namespace libMesh</span>
<a name="l00149"></a>00149 
<a name="l00150"></a>00150 <span class="preprocessor">#endif // #ifndef __postscript_io_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
