<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_d45fd345e047ce3d35e6605c886a1156.php">numerics</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">preconditioner.h</div>  </div>
</div>
<div class="contents">
<a href="preconditioner_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: preconditioner.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __preconditioner_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __preconditioner_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="comment">// C++ includes</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// Local includes</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="enum__solver__package_8h.php">enum_solver_package.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="enum__solver__type_8h.php">enum_solver_type.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="enum__preconditioner__type_8h.php">enum_preconditioner_type.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="libmesh_8h.php">libmesh.h</a>&quot;</span>
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="keyword">namespace </span>libMesh
<a name="l00037"></a>00037 {
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="comment">// forward declarations</span>
<a name="l00040"></a>00040 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>AutoPtr;
<a name="l00041"></a>00041 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>SparseMatrix;
<a name="l00042"></a>00042 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>NumericVector;
<a name="l00043"></a>00043 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt; <span class="keyword">class </span>ShellMatrix;
<a name="l00044"></a>00044 
<a name="l00045"></a>00045 
<a name="l00046"></a>00046 
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00061"></a>00061 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00062"></a><a class="code" href="classlibMesh_1_1Preconditioner.php">00062</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;Preconditioner&lt;T&gt; &gt;
<a name="l00063"></a>00063 {
<a name="l00064"></a>00064 <span class="keyword">public</span>:
<a name="l00065"></a>00065   
<a name="l00069"></a>00069   <a class="code" href="classlibMesh_1_1Preconditioner.php#a1d746e0ec6a3f7e3bfd0d4d455edf7e0">Preconditioner</a> ();
<a name="l00070"></a>00070 
<a name="l00074"></a>00074   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#a95ba5c6ca9ecbb65884109d5939df84a">~Preconditioner</a> ();
<a name="l00075"></a>00075   
<a name="l00080"></a>00080   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1Preconditioner.php">Preconditioner&lt;T&gt;</a> * <a class="code" href="classlibMesh_1_1Preconditioner.php#a9c5e177cbdccc8151e1a5f0a3564b46a">build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a2785fa3c3529ebe4c62dc593b12b65d8">SolverPackage</a> solver_package =
<a name="l00081"></a>00081                                    <a class="code" href="namespacelibMesh.php#a496c62248223cd940c7715932dd0dc2d">libMesh::default_solver_package</a>());
<a name="l00082"></a>00082   
<a name="l00087"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#a5b1320f541ba96ccae509a587bb38479">00087</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#a5b1320f541ba96ccae509a587bb38479">initialized</a> ()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#a11827c073f85328efda1660f69ad9723">_is_initialized</a>; }
<a name="l00088"></a>00088 
<a name="l00093"></a>00093   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#a3e8b22c773204301fa19f81e2cc4a7bc">apply</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; x, <a class="code" href="classlibMesh_1_1NumericVector.php">NumericVector&lt;T&gt;</a> &amp; y) = 0;
<a name="l00094"></a>00094   
<a name="l00098"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#af33dd26aa04cb595f1340a1ab7133b89">00098</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#af33dd26aa04cb595f1340a1ab7133b89">clear</a> () {}
<a name="l00099"></a>00099 
<a name="l00103"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#a58fb92aee3dd8a80c629e6807f120e7b">00103</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#a58fb92aee3dd8a80c629e6807f120e7b">init</a> () {};
<a name="l00104"></a>00104 
<a name="l00108"></a>00108   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#a3423a34952bd03cf627e1fba8985a114">set_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; mat);
<a name="l00109"></a>00109 
<a name="l00113"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#a1bd0bbba24c80eadafb2ee74395e155e">00113</a>   <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> <a class="code" href="classlibMesh_1_1Preconditioner.php#a1bd0bbba24c80eadafb2ee74395e155e">type</a> ()<span class="keyword"> const</span>
<a name="l00114"></a>00114 <span class="keyword">  </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#a34bb86dd30ce791b57edceec5c2e727b">_preconditioner_type</a>; }
<a name="l00115"></a>00115 
<a name="l00119"></a>00119   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#a007bbd2b1c0cd6192299243405e43b86">set_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> pct);
<a name="l00120"></a>00120   
<a name="l00121"></a>00121 <span class="keyword">protected</span>:
<a name="l00122"></a>00122 
<a name="l00127"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#aeaab9e65a71dd4e30caa3b6ee67e6118">00127</a>   <a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;T&gt;</a> * <a class="code" href="classlibMesh_1_1Preconditioner.php#aeaab9e65a71dd4e30caa3b6ee67e6118">_matrix</a>;
<a name="l00128"></a>00128   
<a name="l00132"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#a34bb86dd30ce791b57edceec5c2e727b">00132</a>   <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> <a class="code" href="classlibMesh_1_1Preconditioner.php#a34bb86dd30ce791b57edceec5c2e727b">_preconditioner_type</a>;
<a name="l00133"></a>00133   
<a name="l00137"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#a11827c073f85328efda1660f69ad9723">00137</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1Preconditioner.php#a11827c073f85328efda1660f69ad9723">_is_initialized</a>;
<a name="l00138"></a>00138 };
<a name="l00139"></a>00139 
<a name="l00140"></a>00140 
<a name="l00141"></a>00141 
<a name="l00142"></a>00142 
<a name="l00143"></a>00143 <span class="comment">/*----------------------- inline functions ----------------------------------*/</span>
<a name="l00144"></a>00144 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00145"></a>00145 <span class="keyword">inline</span>
<a name="l00146"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#a1d746e0ec6a3f7e3bfd0d4d455edf7e0">00146</a> <a class="code" href="classlibMesh_1_1Preconditioner.php#a1d746e0ec6a3f7e3bfd0d4d455edf7e0">Preconditioner&lt;T&gt;::Preconditioner</a> () :
<a name="l00147"></a>00147   _matrix(NULL),
<a name="l00148"></a>00148   _preconditioner_type (<a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4af54549e0e69fbdd4ddd199ee316527f3">ILU_PRECOND</a>),
<a name="l00149"></a>00149   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a>      (false)
<a name="l00150"></a>00150 {
<a name="l00151"></a>00151 }
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00156"></a>00156 <span class="keyword">inline</span>
<a name="l00157"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#a95ba5c6ca9ecbb65884109d5939df84a">00157</a> <a class="code" href="classlibMesh_1_1Preconditioner.php#a95ba5c6ca9ecbb65884109d5939df84a">Preconditioner&lt;T&gt;::~Preconditioner</a> ()
<a name="l00158"></a>00158 {
<a name="l00159"></a>00159   this-&gt;clear ();
<a name="l00160"></a>00160 }
<a name="l00161"></a>00161 
<a name="l00162"></a>00162 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00163"></a>00163 <span class="keywordtype">void</span>
<a name="l00164"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#a3423a34952bd03cf627e1fba8985a114">00164</a> <a class="code" href="classlibMesh_1_1Preconditioner.php#a3423a34952bd03cf627e1fba8985a114">Preconditioner&lt;T&gt;::set_matrix</a>(<a class="code" href="classlibMesh_1_1SparseMatrix.php">SparseMatrix&lt;Number&gt;</a> &amp; mat)
<a name="l00165"></a>00165 {
<a name="l00166"></a>00166   <span class="comment">//If the matrix is changing then we (probably) need to reinitialize.</span>
<a name="l00167"></a>00167   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00168"></a>00168   _matrix = &amp;mat;
<a name="l00169"></a>00169 }
<a name="l00170"></a>00170 
<a name="l00171"></a>00171 <span class="keyword">template</span> &lt;<span class="keyword">typename</span> T&gt;
<a name="l00172"></a>00172 <span class="keywordtype">void</span>
<a name="l00173"></a><a class="code" href="classlibMesh_1_1Preconditioner.php#a007bbd2b1c0cd6192299243405e43b86">00173</a> <a class="code" href="classlibMesh_1_1Preconditioner.php#a007bbd2b1c0cd6192299243405e43b86">Preconditioner&lt;T&gt;::set_type</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a45b101a23b532f020f46f412485db0d4">PreconditionerType</a> pct)
<a name="l00174"></a>00174 {
<a name="l00175"></a>00175   <span class="comment">//If the preconditioner type changes we (probably) need to reinitialize.</span>
<a name="l00176"></a>00176   <a class="code" href="namespacelibMesh_1_1libMeshPrivateData.php#ab8b7115ea57ced35ec86d1fdfa0ab853">_is_initialized</a> = <span class="keyword">false</span>;
<a name="l00177"></a>00177   _preconditioner_type = pct;
<a name="l00178"></a>00178 }
<a name="l00179"></a>00179 
<a name="l00180"></a>00180 } <span class="comment">// namespace libMesh</span>
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="preprocessor">#endif // #ifdef __preconditioner_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
