<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_64cd1a73d4bfb4904ee1d5f3c3dae3ca.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qoi_set.C</div>  </div>
</div>
<div class="contents">
<a href="qoi__set_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// $Id: qoi_set.C 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00004"></a>00004 
<a name="l00005"></a>00005 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00006"></a>00006 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00007"></a>00007   
<a name="l00008"></a>00008 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00009"></a>00009 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00010"></a>00010 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00011"></a>00011 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00012"></a>00012   
<a name="l00013"></a>00013 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00014"></a>00014 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00015"></a>00015 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00016"></a>00016 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00017"></a>00017   
<a name="l00018"></a>00018 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00019"></a>00019 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00020"></a>00020 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// C++ Includes -------------------------------------</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="qoi__set_8h.php">qoi_set.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="system_8h.php">system.h</a>&quot;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="keyword">namespace </span>libMesh
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00035"></a>00035 <span class="comment">// QoISet implementation</span>
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a><a class="code" href="classlibMesh_1_1QoISet.php#ac9a2b290a39c07ba02dead37fd8665b3">00038</a> <a class="code" href="classlibMesh_1_1QoISet.php#a7b1dca62ff6f50fb576df6a4846f9f1e">QoISet::QoISet</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys) : _indices(sys.qoi.size(), true) {}
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041 
<a name="l00042"></a><a class="code" href="classlibMesh_1_1QoISet.php#a89f3599e625d010d25012ddc308c06c8">00042</a> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QoISet.php#a89f3599e625d010d25012ddc308c06c8">QoISet::size</a> (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys)<span class="keyword"> const</span>
<a name="l00043"></a>00043 <span class="keyword"></span>{
<a name="l00044"></a>00044   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> qoi_count = 0;
<a name="l00045"></a>00045   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i != sys.<a class="code" href="classlibMesh_1_1System.php#a33fc90917ecd01516d3b284ad67968c6">qoi</a>.size(); ++i)
<a name="l00046"></a>00046     <span class="keywordflow">if</span> (this-&gt;<a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(i))
<a name="l00047"></a>00047       qoi_count++;
<a name="l00048"></a>00048   <span class="keywordflow">return</span> qoi_count;
<a name="l00049"></a>00049 }
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 
<a name="l00052"></a>00052 
<a name="l00053"></a><a class="code" href="classlibMesh_1_1QoISet.php#a057ffd2df235259d2cb408af8083c134">00053</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#a057ffd2df235259d2cb408af8083c134">QoISet::add_indices</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;indices) 
<a name="l00054"></a>00054 {
<a name="l00055"></a>00055   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QoISet.php#a89f3599e625d010d25012ddc308c06c8">size</a> = 0;
<a name="l00056"></a>00056   <span class="keywordflow">for</span> (std::vector&lt;unsigned int&gt;::const_iterator i = indices.begin();
<a name="l00057"></a>00057        i != indices.end(); ++i)
<a name="l00058"></a>00058     size = <a class="code" href="namespacestd.php#a6987c84b7beab8b2ebdee7e2549d698f">std::max</a>(size, *i + 1);
<a name="l00059"></a>00059 
<a name="l00060"></a>00060   <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>.resize(size);
<a name="l00061"></a>00061 
<a name="l00062"></a>00062   <span class="keywordflow">for</span> (std::vector&lt;unsigned int&gt;::const_iterator i = indices.begin();
<a name="l00063"></a>00063        i != indices.end(); ++i)
<a name="l00064"></a>00064     <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>[*i] = <span class="keyword">true</span>;
<a name="l00065"></a>00065 }
<a name="l00066"></a>00066 
<a name="l00067"></a>00067 
<a name="l00068"></a>00068 
<a name="l00069"></a>00069 <span class="keyword">inline</span>
<a name="l00070"></a><a class="code" href="classlibMesh_1_1QoISet.php#ac4f01238a5f59aabab540543b7ff04b4">00070</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#ac4f01238a5f59aabab540543b7ff04b4">QoISet::remove_indices</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;indices) 
<a name="l00071"></a>00071 {
<a name="l00072"></a>00072   <span class="keywordflow">for</span> (std::vector&lt;unsigned int&gt;::const_iterator i = indices.begin();
<a name="l00073"></a>00073        i != indices.end(); ++i)
<a name="l00074"></a>00074     <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>[*i] = <span class="keyword">false</span>;
<a name="l00075"></a>00075 }
<a name="l00076"></a>00076 
<a name="l00077"></a>00077 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
