<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_f7ba8f08e2dbc3d45d9f7fd01cec9f20.php">systems</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">qoi_set.h</div>  </div>
</div>
<div class="contents">
<a href="qoi__set_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// $Id: qoi_set.h 4278 2011-03-21 15:23:30Z roystgnr $</span>
<a name="l00004"></a>00004 
<a name="l00005"></a>00005 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00006"></a>00006 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00007"></a>00007   
<a name="l00008"></a>00008 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00009"></a>00009 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00010"></a>00010 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00011"></a>00011 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00012"></a>00012   
<a name="l00013"></a>00013 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00014"></a>00014 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00015"></a>00015 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00016"></a>00016 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00017"></a>00017   
<a name="l00018"></a>00018 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00019"></a>00019 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00020"></a>00020 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="preprocessor">#ifndef __qoi_set_h__</span>
<a name="l00025"></a>00025 <span class="preprocessor"></span><span class="preprocessor">#define __qoi_set_h__</span>
<a name="l00026"></a>00026 <span class="preprocessor"></span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// C++ Includes   -----------------------------------</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 <span class="comment">// Local Includes -----------------------------------</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 <span class="keyword">namespace </span>libMesh
<a name="l00035"></a>00035 {
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 <span class="comment">// Forward Declarations -----------------------------</span>
<a name="l00038"></a>00038 <span class="keyword">class </span>System;
<a name="l00039"></a>00039 
<a name="l00045"></a><a class="code" href="classlibMesh_1_1QoISet.php">00045</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1QoISet.php">QoISet</a>
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 <span class="keyword">public</span>: 
<a name="l00048"></a><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php">00048</a>   <span class="keyword">class </span><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php">iterator</a>
<a name="l00049"></a>00049   {
<a name="l00050"></a>00050   <span class="keyword">public</span>:
<a name="l00051"></a><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a886df9d156fcdce2846db25c798af533">00051</a>     <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a886df9d156fcdce2846db25c798af533">iterator</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, std::vector&lt;bool&gt;&amp; v) : <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a>(i), <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a>(v)
<a name="l00052"></a>00052       {
<a name="l00053"></a>00053         <span class="keywordflow">while</span> (<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a> &lt; <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a>.size() &amp;&amp; !<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a>[<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a>])
<a name="l00054"></a>00054           <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a>++;
<a name="l00055"></a>00055       }
<a name="l00056"></a>00056 
<a name="l00057"></a><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#ac10db5bac9f234fabb2f960b399cec3c">00057</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#ac10db5bac9f234fabb2f960b399cec3c">operator*</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a>; }
<a name="l00058"></a>00058 
<a name="l00059"></a><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a8685eee32e396e931b6217aa5499532a">00059</a>     <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php">iterator</a>&amp; <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a8685eee32e396e931b6217aa5499532a">operator++</a>()
<a name="l00060"></a>00060       {
<a name="l00061"></a>00061         <span class="keywordflow">do</span> {
<a name="l00062"></a>00062           <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a>++;
<a name="l00063"></a>00063         } <span class="keywordflow">while</span> (<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a> &lt; <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a>.size() &amp;&amp; !<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a>[<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a>]);
<a name="l00064"></a>00064         <span class="keywordflow">return</span> *<span class="keyword">this</span>;
<a name="l00065"></a>00065       }
<a name="l00066"></a>00066 
<a name="l00067"></a><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a394fa75faeb4801af39d7c48385df591">00067</a>     <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php">iterator</a> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a394fa75faeb4801af39d7c48385df591">operator++</a>(<span class="keywordtype">int</span>) {
<a name="l00068"></a>00068       <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php">iterator</a> it = *<span class="keyword">this</span>;
<a name="l00069"></a>00069       ++(*this);
<a name="l00070"></a>00070       <span class="keywordflow">return</span> it;
<a name="l00071"></a>00071     }
<a name="l00072"></a>00072 
<a name="l00073"></a><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a984c1526597af527353edd9ed9150746">00073</a>     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a984c1526597af527353edd9ed9150746">operator==</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php">iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00074"></a>00074       libmesh_assert(&amp;<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a> == &amp;other.<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a>);
<a name="l00075"></a>00075       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a> == other.<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a>;
<a name="l00076"></a>00076     }
<a name="l00077"></a>00077 
<a name="l00078"></a><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#ae0fe3879339945150523181f9a3764b5">00078</a>     <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#ae0fe3879339945150523181f9a3764b5">operator!=</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php">iterator</a> &amp;other)<span class="keyword"> const </span>{
<a name="l00079"></a>00079       libmesh_assert(&amp;<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a> == &amp;other.<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a>);
<a name="l00080"></a>00080       <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a> != other.<a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a>;
<a name="l00081"></a>00081     }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   <span class="keyword">private</span>:
<a name="l00084"></a>00084 
<a name="l00085"></a><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">00085</a>     <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a229f5b437c6ff4496d3794ebc062d747">_i</a>;
<a name="l00086"></a>00086 
<a name="l00087"></a><a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">00087</a>     std::vector&lt;bool&gt;&amp; <a class="code" href="classlibMesh_1_1QoISet_1_1iterator.php#a12ca7a3062d12ccea05e9e61fe3bd401">_vecbool</a>;
<a name="l00088"></a>00088   };
<a name="l00089"></a>00089 
<a name="l00097"></a><a class="code" href="classlibMesh_1_1QoISet.php#a7b1dca62ff6f50fb576df6a4846f9f1e">00097</a>   <a class="code" href="classlibMesh_1_1QoISet.php#a7b1dca62ff6f50fb576df6a4846f9f1e">QoISet</a>() : <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>(), <a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">_weights</a>() {}
<a name="l00098"></a>00098 
<a name="l00103"></a>00103   <a class="code" href="classlibMesh_1_1QoISet.php#a7b1dca62ff6f50fb576df6a4846f9f1e">QoISet</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a> &amp;sys);
<a name="l00104"></a>00104 
<a name="l00109"></a><a class="code" href="classlibMesh_1_1QoISet.php#a1fd938c4a90948aad1b75fe1a1750317">00109</a>   <a class="code" href="classlibMesh_1_1QoISet.php#a7b1dca62ff6f50fb576df6a4846f9f1e">QoISet</a>(<span class="keyword">const</span> std::vector&lt;bool&gt; &amp;indices) :
<a name="l00110"></a>00110     <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>(indices), <a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">_weights</a>() {}
<a name="l00111"></a>00111 
<a name="l00116"></a>00116   <a class="code" href="classlibMesh_1_1QoISet.php#a7b1dca62ff6f50fb576df6a4846f9f1e">QoISet</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;indices);
<a name="l00117"></a>00117 
<a name="l00121"></a><a class="code" href="classlibMesh_1_1QoISet.php#a58ed695d00dab7021bb58a3b3fc45d49">00121</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#a58ed695d00dab7021bb58a3b3fc45d49">clear</a>() { <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>.clear(); <a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">_weights</a>.clear(); }
<a name="l00122"></a>00122 
<a name="l00127"></a>00127   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QoISet.php#a89f3599e625d010d25012ddc308c06c8">size</a>(<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1System.php">System</a>&amp; sys) <span class="keyword">const</span>;
<a name="l00128"></a>00128 
<a name="l00132"></a>00132   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#a057ffd2df235259d2cb408af8083c134">add_indices</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;indices);
<a name="l00133"></a>00133 
<a name="l00137"></a>00137   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#a934206efd80c8acc2d5bf9f5fb1b572f">add_index</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00138"></a>00138 
<a name="l00142"></a>00142   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#ac4f01238a5f59aabab540543b7ff04b4">remove_indices</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;indices);
<a name="l00143"></a>00143 
<a name="l00147"></a>00147   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#a1b177ec886b820e340f354653ba92d8f">remove_index</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>);
<a name="l00148"></a>00148 
<a name="l00152"></a>00152   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#a5d99d2ac8d9093513569495c11469b38">set_weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>);
<a name="l00153"></a>00153 
<a name="l00157"></a>00157   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QoISet.php#abfcf1c89b78ec1ff01f3b6064b910401">weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) <span class="keyword">const</span>;
<a name="l00158"></a>00158 
<a name="l00162"></a>00162   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">has_index</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>) <span class="keyword">const</span>;
<a name="l00163"></a>00163 
<a name="l00164"></a>00164 <span class="keyword">private</span>: 
<a name="l00168"></a><a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">00168</a>   std::vector&lt;bool&gt; <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>;
<a name="l00169"></a>00169 
<a name="l00173"></a><a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">00173</a>   std::vector&lt;bool&gt; <a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">_weights</a>;
<a name="l00174"></a>00174 };
<a name="l00175"></a>00175 
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 
<a name="l00178"></a>00178 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00179"></a>00179 <span class="comment">// QoISet inline methods</span>
<a name="l00180"></a>00180 
<a name="l00181"></a>00181 
<a name="l00182"></a>00182 
<a name="l00183"></a>00183 <span class="keyword">inline</span>
<a name="l00184"></a><a class="code" href="classlibMesh_1_1QoISet.php#a2a52543e26d21f7db4b06c251ee576cd">00184</a> <a class="code" href="classlibMesh_1_1QoISet.php#a7b1dca62ff6f50fb576df6a4846f9f1e">QoISet::QoISet</a>(<span class="keyword">const</span> std::vector&lt;unsigned int&gt; &amp;indices) :
<a name="l00185"></a>00185   _indices(), _weights()
<a name="l00186"></a>00186 {
<a name="l00187"></a>00187   this-&gt;<a class="code" href="classlibMesh_1_1QoISet.php#a057ffd2df235259d2cb408af8083c134">add_indices</a>(indices);
<a name="l00188"></a>00188 }
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 <span class="keyword">inline</span>
<a name="l00193"></a><a class="code" href="classlibMesh_1_1QoISet.php#a934206efd80c8acc2d5bf9f5fb1b572f">00193</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#a934206efd80c8acc2d5bf9f5fb1b572f">QoISet::add_index</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00194"></a>00194 {
<a name="l00195"></a>00195   <span class="keywordflow">if</span> (i &gt;= <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>.size())
<a name="l00196"></a>00196     <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>.resize(i+1);
<a name="l00197"></a>00197   <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>[i] = <span class="keyword">true</span>;
<a name="l00198"></a>00198 }
<a name="l00199"></a>00199 
<a name="l00200"></a>00200 
<a name="l00201"></a>00201 
<a name="l00202"></a>00202 <span class="keyword">inline</span>
<a name="l00203"></a><a class="code" href="classlibMesh_1_1QoISet.php#a1b177ec886b820e340f354653ba92d8f">00203</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#a1b177ec886b820e340f354653ba92d8f">QoISet::remove_index</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)
<a name="l00204"></a>00204 {
<a name="l00205"></a>00205   libmesh_assert(i &lt; <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>.size());
<a name="l00206"></a>00206   <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>[i] = <span class="keyword">false</span>;
<a name="l00207"></a>00207 }
<a name="l00208"></a>00208 
<a name="l00209"></a>00209 
<a name="l00210"></a>00210 
<a name="l00211"></a>00211 <span class="keyword">inline</span>
<a name="l00212"></a><a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">00212</a> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1QoISet.php#adcfff89b353ad16cb93a89d7af779fc0">QoISet::has_index</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00213"></a>00213 <span class="keyword"></span>{
<a name="l00214"></a>00214   <span class="keywordflow">return</span> (<a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>.size() &lt;= i || <a class="code" href="classlibMesh_1_1QoISet.php#a35e60c59c33646526030487de732560c">_indices</a>[i]);
<a name="l00215"></a>00215 }
<a name="l00216"></a>00216 
<a name="l00217"></a>00217 
<a name="l00218"></a>00218 
<a name="l00219"></a>00219 <span class="keyword">inline</span>
<a name="l00220"></a><a class="code" href="classlibMesh_1_1QoISet.php#a5d99d2ac8d9093513569495c11469b38">00220</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QoISet.php#a5d99d2ac8d9093513569495c11469b38">QoISet::set_weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i, <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> w)
<a name="l00221"></a>00221 {
<a name="l00222"></a>00222   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">_weights</a>.size() &lt;= i)
<a name="l00223"></a>00223     <a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">_weights</a>.resize(i+1, 1.0);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225   <a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">_weights</a>[i] = w;
<a name="l00226"></a>00226 }
<a name="l00227"></a>00227 
<a name="l00228"></a>00228 
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 <span class="keyword">inline</span>
<a name="l00231"></a><a class="code" href="classlibMesh_1_1QoISet.php#abfcf1c89b78ec1ff01f3b6064b910401">00231</a> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QoISet.php#abfcf1c89b78ec1ff01f3b6064b910401">QoISet::weight</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00232"></a>00232 <span class="keyword"></span>{
<a name="l00233"></a>00233   <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">_weights</a>.size() &lt;= i)
<a name="l00234"></a>00234     <span class="keywordflow">return</span> 1.0;
<a name="l00235"></a>00235   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QoISet.php#ab9c824c9ee07985c05da6784c50e9435">_weights</a>[i];
<a name="l00236"></a>00236 }
<a name="l00237"></a>00237 
<a name="l00238"></a>00238 } <span class="comment">// namespace libMesh</span>
<a name="l00239"></a>00239 
<a name="l00240"></a>00240 <span class="preprocessor">#endif // #define __qoi_set_h__</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
