<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_7130bdbee22170d77bc57b73a8cc6b8c.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature.h</div>  </div>
</div>
<div class="contents">
<a href="quadrature_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature.h 4106 2010-11-16 16:35:07Z friedmud $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quadrature_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quadrature_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// C++ includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &lt;vector&gt;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &lt;string&gt;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &lt;utility&gt;</span>
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 <span class="comment">// Local includes</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00032"></a>00032 <span class="preprocessor">#include &quot;<a class="code" href="reference__counted__object_8h.php">reference_counted_object.h</a>&quot;</span>
<a name="l00033"></a>00033 <span class="preprocessor">#include &quot;<a class="code" href="point_8h.php">point.h</a>&quot;</span>
<a name="l00034"></a>00034 <span class="preprocessor">#include &quot;<a class="code" href="enum__elem__type_8h.php">enum_elem_type.h</a>&quot;</span>
<a name="l00035"></a>00035 <span class="preprocessor">#include &quot;<a class="code" href="enum__order_8h.php">enum_order.h</a>&quot;</span>
<a name="l00036"></a>00036 <span class="preprocessor">#include &quot;<a class="code" href="enum__quadrature__type_8h.php">enum_quadrature_type.h</a>&quot;</span>
<a name="l00037"></a>00037 <span class="preprocessor">#include &quot;<a class="code" href="auto__ptr_8h.php">auto_ptr.h</a>&quot;</span>
<a name="l00038"></a>00038 
<a name="l00039"></a>00039 <span class="keyword">namespace </span>libMesh
<a name="l00040"></a>00040 {
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00053"></a>00053 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00054"></a>00054 <span class="comment">// QBase class definition</span>
<a name="l00055"></a>00055 
<a name="l00056"></a><a class="code" href="classlibMesh_1_1QBase.php">00056</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1QBase.php">QBase</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1ReferenceCountedObject.php">ReferenceCountedObject</a>&lt;QBase&gt;
<a name="l00057"></a>00057 {
<a name="l00058"></a>00058 <span class="keyword">protected</span>:
<a name="l00059"></a>00059 
<a name="l00064"></a>00064   <a class="code" href="classlibMesh_1_1QBase.php#a7850e68c8375789e8992e11d2f874e16">QBase</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00065"></a>00065          <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>);
<a name="l00066"></a>00066   
<a name="l00067"></a>00067 <span class="keyword">public</span>:
<a name="l00068"></a>00068   
<a name="l00072"></a><a class="code" href="classlibMesh_1_1QBase.php#aacee8c0c80e3a2f959e93d725282d5ff">00072</a>   <span class="keyword">virtual</span> <a class="code" href="classlibMesh_1_1QBase.php#aacee8c0c80e3a2f959e93d725282d5ff">~QBase</a>() {}
<a name="l00073"></a>00073 
<a name="l00077"></a>00077   <span class="keyword">virtual</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> <a class="code" href="classlibMesh_1_1QBase.php#a580d1c4a57b7c9f6f1c8904f3c804373">type</a>() <span class="keyword">const</span> = 0;
<a name="l00078"></a>00078 
<a name="l00088"></a>00088   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classlibMesh_1_1QBase.php#a036daa63de83f2df0333c5e2e6740552">build</a> (<span class="keyword">const</span> std::string &amp;<a class="code" href="namespacelibMesh_1_1Quality.php#a1d3617b89c15ade245910fc9a4ddfa34">name</a>,
<a name="l00089"></a>00089                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00090"></a>00090                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>);
<a name="l00091"></a>00091 
<a name="l00099"></a>00099   <span class="keyword">static</span> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classlibMesh_1_1QBase.php#a036daa63de83f2df0333c5e2e6740552">build</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> _qt,
<a name="l00100"></a>00100                                <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00101"></a>00101                                <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>);
<a name="l00102"></a>00102 
<a name="l00106"></a><a class="code" href="classlibMesh_1_1QBase.php#a4bce9ca918606d1c36848c95dbaeffb7">00106</a>   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> <a class="code" href="classlibMesh_1_1QBase.php#a4bce9ca918606d1c36848c95dbaeffb7">get_elem_type</a>()<span class="keyword"> const</span>
<a name="l00107"></a>00107 <span class="keyword">    </span>{ <span class="keywordflow">return</span> _type; }
<a name="l00108"></a>00108 
<a name="l00112"></a><a class="code" href="classlibMesh_1_1QBase.php#ad5c83248dfca64ee7a49a4519368f337">00112</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QBase.php#ad5c83248dfca64ee7a49a4519368f337">get_p_level</a>()<span class="keyword"> const</span>
<a name="l00113"></a>00113 <span class="keyword">    </span>{ <span class="keywordflow">return</span> _p_level; }
<a name="l00114"></a>00114 
<a name="l00118"></a><a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">00118</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>()<span class="keyword"> const</span>
<a name="l00119"></a>00119 <span class="keyword">    </span>{ libmesh_assert (!<a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.empty()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.size(); }
<a name="l00120"></a>00120 
<a name="l00124"></a><a class="code" href="classlibMesh_1_1QBase.php#a334ad6c046a65963406402fbdf13e748">00124</a>   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QBase.php#a334ad6c046a65963406402fbdf13e748">get_dim</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> _dim;  }
<a name="l00125"></a>00125 
<a name="l00130"></a><a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">00130</a>   <span class="keyword">const</span> std::vector&lt;Point&gt;&amp; <a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">get_points</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>;  }
<a name="l00131"></a>00131 
<a name="l00136"></a><a class="code" href="classlibMesh_1_1QBase.php#a3fb58de732312387ab37f6ae7d666243">00136</a>   std::vector&lt;Point&gt;&amp; <a class="code" href="classlibMesh_1_1QBase.php#a3fb58de732312387ab37f6ae7d666243">get_points</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>;  }
<a name="l00137"></a>00137 
<a name="l00141"></a><a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">00141</a>   <span class="keyword">const</span> std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">get_weights</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>; }
<a name="l00142"></a>00142 
<a name="l00146"></a><a class="code" href="classlibMesh_1_1QBase.php#a5f0b462d41e3f16f4fc7df2eb3ac2edd">00146</a>   std::vector&lt;Real&gt;&amp; <a class="code" href="classlibMesh_1_1QBase.php#a5f0b462d41e3f16f4fc7df2eb3ac2edd">get_weights</a>() { <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>; }
<a name="l00147"></a>00147 
<a name="l00151"></a><a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">00151</a>   <a class="code" href="classlibMesh_1_1Point.php">Point</a> <a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00152"></a>00152 <span class="keyword">    </span>{ libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[i]; }
<a name="l00153"></a>00153 
<a name="l00157"></a><a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">00157</a>   <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i)<span class="keyword"> const</span>
<a name="l00158"></a>00158 <span class="keyword">    </span>{ libmesh_assert (i &lt; <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.size()); <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[i]; }
<a name="l00159"></a>00159   
<a name="l00164"></a>00164   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00165"></a>00165              <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00166"></a>00166 
<a name="l00170"></a><a class="code" href="classlibMesh_1_1QBase.php#a35cb2015566e5ab627e3af64519d4f03">00170</a>   <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> <a class="code" href="classlibMesh_1_1QBase.php#a35cb2015566e5ab627e3af64519d4f03">get_order</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <span class="keyword">static_cast&lt;</span><a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a><span class="keyword">&gt;</span>(_order + _p_level); }
<a name="l00171"></a>00171   
<a name="l00176"></a>00176   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QBase.php#a3a9755739cf9fdad1efa8e5b8ade6234">print_info</a>(std::ostream&amp; os=<a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a>) <span class="keyword">const</span>;
<a name="l00177"></a>00177 
<a name="l00184"></a>00184   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QBase.php#afeadfcbe5456e574f72b095d9416fe15">scale</a>(std::pair&lt;Real, Real&gt; old_range,
<a name="l00185"></a>00185              std::pair&lt;Real, Real&gt; new_range);
<a name="l00186"></a>00186 
<a name="l00190"></a>00190   <span class="keyword">friend</span> std::ostream&amp; <a class="code" href="classlibMesh_1_1QBase.php#a98886adbc1976761ab84721b2a28237e">operator &lt;&lt; </a>(std::ostream&amp; os, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QBase.php">QBase</a>&amp; q);
<a name="l00191"></a>00191 
<a name="l00199"></a><a class="code" href="classlibMesh_1_1QBase.php#a44006faa114189db0ed74e0dc4925593">00199</a>   <span class="keyword">virtual</span> <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1QBase.php#a44006faa114189db0ed74e0dc4925593">shapes_need_reinit</a>() { <span class="keywordflow">return</span> <span class="keyword">false</span>; }
<a name="l00200"></a>00200 
<a name="l00216"></a><a class="code" href="classlibMesh_1_1QBase.php#a6f1f4bb99c359f881b0b5b2695bb2cde">00216</a>   <span class="keywordtype">bool</span> <a class="code" href="classlibMesh_1_1QBase.php#a6f1f4bb99c359f881b0b5b2695bb2cde">allow_rules_with_negative_weights</a>;
<a name="l00217"></a>00217   
<a name="l00218"></a>00218 <span class="keyword">protected</span>:
<a name="l00219"></a>00219 
<a name="l00220"></a>00220   
<a name="l00226"></a>00226   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QBase.php#a0959ac4965bb0d5b21f420718116826f">init_0D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00227"></a>00227                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00228"></a>00228 
<a name="l00236"></a>00236   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QBase.php#a8f33234a0c580a393f9d29c5c2d9b6b4">init_1D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00237"></a>00237                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0) = 0;
<a name="l00238"></a>00238 
<a name="l00247"></a><a class="code" href="classlibMesh_1_1QBase.php#a1073096a5c578e6aed7efbf277c9f1ca">00247</a>   <span class="keyword">virtual</span> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QBase.php#a1073096a5c578e6aed7efbf277c9f1ca">init_2D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00248"></a>00248                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> =0)
<a name="l00249"></a>00249 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00250"></a>00250 <span class="preprocessor"></span>  {}
<a name="l00251"></a>00251 <span class="preprocessor">#else</span>
<a name="l00252"></a>00252 <span class="preprocessor"></span>  {  
<a name="l00253"></a>00253     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Seems as if this quadrature rule&quot;</span> &lt;&lt; std::endl
<a name="l00254"></a>00254                   &lt;&lt; <span class="stringliteral">&quot; is not implemented for 2D.&quot;</span> &lt;&lt; std::endl;
<a name="l00255"></a>00255     libmesh_error();
<a name="l00256"></a>00256   }
<a name="l00257"></a>00257 <span class="preprocessor">#endif</span>
<a name="l00258"></a>00258 <span class="preprocessor"></span>
<a name="l00267"></a>00267   <span class="keyword">virtual</span> <span class="keywordtype">void</span> init_3D (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00268"></a>00268                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> =0)
<a name="l00269"></a>00269 <span class="preprocessor">#ifndef DEBUG</span>
<a name="l00270"></a>00270 <span class="preprocessor"></span>  {}
<a name="l00271"></a>00271 <span class="preprocessor">#else</span>
<a name="l00272"></a>00272 <span class="preprocessor"></span>  {  
<a name="l00273"></a>00273     <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Seems as if this quadrature rule&quot;</span> &lt;&lt; std::endl
<a name="l00274"></a>00274                   &lt;&lt; <span class="stringliteral">&quot; is not implemented for 3D.&quot;</span> &lt;&lt; std::endl;
<a name="l00275"></a>00275     libmesh_error();
<a name="l00276"></a>00276   }
<a name="l00277"></a>00277 <span class="preprocessor">#endif</span>
<a name="l00278"></a>00278 <span class="preprocessor"></span>  
<a name="l00279"></a>00279   
<a name="l00286"></a>00286   <span class="keywordtype">void</span> tensor_product_quad (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QBase.php#a7850e68c8375789e8992e11d2f874e16">QBase</a>&amp; q1D);
<a name="l00287"></a>00287 
<a name="l00294"></a>00294   <span class="keywordtype">void</span> tensor_product_hex (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QBase.php#a7850e68c8375789e8992e11d2f874e16">QBase</a>&amp; q1D);
<a name="l00295"></a>00295   
<a name="l00303"></a>00303   <span class="keywordtype">void</span> tensor_product_prism (<span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QBase.php#a7850e68c8375789e8992e11d2f874e16">QBase</a>&amp; q1D, <span class="keyword">const</span> <a class="code" href="classlibMesh_1_1QBase.php#a7850e68c8375789e8992e11d2f874e16">QBase</a>&amp; q2D);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305 
<a name="l00306"></a>00306   
<a name="l00310"></a>00310   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim;
<a name="l00311"></a>00311   
<a name="l00315"></a>00315   <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order;
<a name="l00316"></a>00316 
<a name="l00321"></a>00321   <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type;
<a name="l00322"></a>00322 
<a name="l00327"></a>00327   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _p_level;
<a name="l00328"></a>00328 
<a name="l00333"></a><a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">00333</a>   std::vector&lt;Point&gt; <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>;
<a name="l00334"></a>00334 
<a name="l00338"></a><a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">00338</a>   std::vector&lt;Real&gt; <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>;
<a name="l00339"></a>00339 };
<a name="l00340"></a>00340 
<a name="l00341"></a>00341 
<a name="l00342"></a>00342 
<a name="l00343"></a>00343 
<a name="l00344"></a>00344 
<a name="l00345"></a>00345 <span class="comment">// ------------------------------------------------------------</span>
<a name="l00346"></a>00346 <span class="comment">// QBase class members</span>
<a name="l00347"></a>00347 
<a name="l00348"></a>00348 <span class="keyword">inline</span>
<a name="l00349"></a><a class="code" href="classlibMesh_1_1QBase.php#a7850e68c8375789e8992e11d2f874e16">00349</a> <a class="code" href="classlibMesh_1_1QBase.php#a7850e68c8375789e8992e11d2f874e16">QBase::QBase</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d,
<a name="l00350"></a>00350              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o) :
<a name="l00351"></a>00351   allow_rules_with_negative_weights(true),
<a name="l00352"></a>00352   _dim(d),
<a name="l00353"></a>00353   _order(o),
<a name="l00354"></a>00354   _type(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>),
<a name="l00355"></a>00355   _p_level(0)
<a name="l00356"></a>00356 {
<a name="l00357"></a>00357 }
<a name="l00358"></a>00358 
<a name="l00359"></a>00359 
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 <span class="keyword">inline</span>
<a name="l00363"></a><a class="code" href="classlibMesh_1_1QBase.php#a3a9755739cf9fdad1efa8e5b8ade6234">00363</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QBase.php#a3a9755739cf9fdad1efa8e5b8ade6234">QBase::print_info</a>(std::ostream&amp; os)<span class="keyword"> const</span>
<a name="l00364"></a>00364 <span class="keyword"></span>{
<a name="l00365"></a>00365   libmesh_assert(!<a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.empty());
<a name="l00366"></a>00366   libmesh_assert(!<a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.empty());
<a name="l00367"></a>00367 
<a name="l00368"></a>00368   os &lt;&lt; <span class="stringliteral">&quot;N_Q_Points=&quot;</span> &lt;&lt; this-&gt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>() &lt;&lt; std::endl &lt;&lt; std::endl;
<a name="l00369"></a>00369   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>=0; <a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>&lt;this-&gt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>(); <a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>++)
<a name="l00370"></a>00370     {
<a name="l00371"></a>00371       os &lt;&lt; <span class="stringliteral">&quot; Point &quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a> &lt;&lt; <span class="stringliteral">&quot;:\n&quot;</span>
<a name="l00372"></a>00372          &lt;&lt; <span class="stringliteral">&quot;  &quot;</span>
<a name="l00373"></a>00373          &lt;&lt; <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>]
<a name="l00374"></a>00374          &lt;&lt; <span class="stringliteral">&quot; Weight:\n &quot;</span>
<a name="l00375"></a>00375          &lt;&lt; <span class="stringliteral">&quot;  w=&quot;</span> &lt;&lt; <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>] &lt;&lt; <span class="stringliteral">&quot;\n&quot;</span> &lt;&lt; std::endl;
<a name="l00376"></a>00376     }
<a name="l00377"></a>00377 }
<a name="l00378"></a>00378 
<a name="l00379"></a>00379 } <span class="comment">// namespace libMesh</span>
<a name="l00380"></a>00380 
<a name="l00381"></a>00381 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
