<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_build.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__build_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_build.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__clough_8h.php">quadrature_clough.h</a>&quot;</span>
<a name="l00027"></a>00027 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00028"></a>00028 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__jacobi_8h.php">quadrature_jacobi.h</a>&quot;</span>
<a name="l00029"></a>00029 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__simpson_8h.php">quadrature_simpson.h</a>&quot;</span>
<a name="l00030"></a>00030 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__trap_8h.php">quadrature_trap.h</a>&quot;</span>
<a name="l00031"></a>00031 <span class="preprocessor">#include &quot;<a class="code" href="string__to__enum_8h.php">string_to_enum.h</a>&quot;</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 <span class="keyword">namespace </span>libMesh
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 
<a name="l00037"></a>00037 
<a name="l00038"></a>00038 <span class="comment">//---------------------------------------------------------------</span>
<a name="l00039"></a><a class="code" href="classlibMesh_1_1QBase.php#a036daa63de83f2df0333c5e2e6740552">00039</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classlibMesh_1_1QBase.php#a036daa63de83f2df0333c5e2e6740552">QBase::build</a> (<span class="keyword">const</span> std::string &amp;type,
<a name="l00040"></a>00040                              <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00041"></a>00041                              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order)
<a name="l00042"></a>00042 {
<a name="l00043"></a>00043   <span class="keywordflow">return</span> <a class="code" href="classlibMesh_1_1QBase.php#a036daa63de83f2df0333c5e2e6740552">QBase::build</a> (<a class="code" href="namespacelibMesh_1_1Utility.php#a0263092dbfdbe464571c4a8c63bbd7b2">Utility::string_to_enum&lt;QuadratureType&gt;</a> (type),
<a name="l00044"></a>00044                        _dim,
<a name="l00045"></a>00045                        _order);
<a name="l00046"></a>00046 }
<a name="l00047"></a>00047 
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a><a class="code" href="classlibMesh_1_1QBase.php#a8a808dd0b4f127a2d10ee0166c94a2de">00050</a> <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> <a class="code" href="classlibMesh_1_1QBase.php#a036daa63de83f2df0333c5e2e6740552">QBase::build</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> _qt,
<a name="l00051"></a>00051                             <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00052"></a>00052                             <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order)
<a name="l00053"></a>00053 {
<a name="l00054"></a>00054   <span class="keywordflow">switch</span> (_qt)
<a name="l00055"></a>00055     {
<a name="l00056"></a>00056       
<a name="l00057"></a>00057     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada6a44b32cfeb467cf770cd8ff2d462c77">QCLOUGH</a>:
<a name="l00058"></a>00058       {
<a name="l00059"></a>00059 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00060"></a>00060 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (_order &gt; <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1dda25317008178eb86eef7e967e9ecf">TWENTYTHIRD</a>)
<a name="l00061"></a>00061           {
<a name="l00062"></a>00062             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Clough quadrature implemented&quot;</span> &lt;&lt; std::endl
<a name="l00063"></a>00063                           &lt;&lt; <span class="stringliteral">&quot; up to TWENTYTHIRD order.&quot;</span> &lt;&lt; std::endl;
<a name="l00064"></a>00064           }
<a name="l00065"></a>00065 <span class="preprocessor">#endif</span>
<a name="l00066"></a>00066 <span class="preprocessor"></span>
<a name="l00067"></a>00067         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QClough.php">QClough</a>(_dim, _order));
<a name="l00068"></a>00068         <span class="keywordflow">return</span> ap;
<a name="l00069"></a>00069       }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada11bd5a126c073e475e588e38016b3785">QGAUSS</a>:
<a name="l00072"></a>00072       {
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00075"></a>00075 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (_order &gt; <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5536e362ffba6fc36737d12d56016794">FORTYTHIRD</a>)
<a name="l00076"></a>00076           {
<a name="l00077"></a>00077             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Gauss quadrature implemented&quot;</span> &lt;&lt; std::endl
<a name="l00078"></a>00078                           &lt;&lt; <span class="stringliteral">&quot; up to FORTYTHIRD order.&quot;</span> &lt;&lt; std::endl;
<a name="l00079"></a>00079           }
<a name="l00080"></a>00080 <span class="preprocessor">#endif</span>
<a name="l00081"></a>00081 <span class="preprocessor"></span>
<a name="l00082"></a>00082         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a>(_dim, _order));
<a name="l00083"></a>00083         <span class="keywordflow">return</span> ap;
<a name="l00084"></a>00084       }
<a name="l00085"></a>00085 
<a name="l00086"></a>00086     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adad3a339e15685559999115b81f6d38370">QJACOBI_1_0</a>:
<a name="l00087"></a>00087       {
<a name="l00088"></a>00088 
<a name="l00089"></a>00089 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00090"></a>00090 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (_order &gt; <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1dda25317008178eb86eef7e967e9ecf">TWENTYTHIRD</a>)
<a name="l00091"></a>00091           {
<a name="l00092"></a>00092             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Jacobi(1,0) quadrature implemented&quot;</span> &lt;&lt; std::endl
<a name="l00093"></a>00093                           &lt;&lt; <span class="stringliteral">&quot; up to TWENTYTHIRD order.&quot;</span> &lt;&lt; std::endl;
<a name="l00094"></a>00094           }
<a name="l00095"></a>00095 
<a name="l00096"></a>00096         <span class="keywordflow">if</span> (_dim &gt; 1)
<a name="l00097"></a>00097           {
<a name="l00098"></a>00098             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Jacobi(1,0) quadrature implemented&quot;</span> &lt;&lt; std::endl
<a name="l00099"></a>00099                           &lt;&lt; <span class="stringliteral">&quot; in 1D only.&quot;</span> &lt;&lt; std::endl;
<a name="l00100"></a>00100           }
<a name="l00101"></a>00101 <span class="preprocessor">#endif</span>
<a name="l00102"></a>00102 <span class="preprocessor"></span>
<a name="l00103"></a>00103         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QJacobi.php">QJacobi</a>(_dim, _order, 1, 0));
<a name="l00104"></a>00104         <span class="keywordflow">return</span> ap;
<a name="l00105"></a>00105       }
<a name="l00106"></a>00106 
<a name="l00107"></a>00107     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada52629eed7dec8b36fbd387b3dd51d48d">QJACOBI_2_0</a>:
<a name="l00108"></a>00108       {
<a name="l00109"></a>00109 
<a name="l00110"></a>00110 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00111"></a>00111 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (_order &gt; <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1dda25317008178eb86eef7e967e9ecf">TWENTYTHIRD</a>)
<a name="l00112"></a>00112           {
<a name="l00113"></a>00113             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Jacobi(2,0) quadrature implemented&quot;</span> &lt;&lt; std::endl
<a name="l00114"></a>00114                           &lt;&lt; <span class="stringliteral">&quot; up to TWENTYTHIRD order.&quot;</span> &lt;&lt; std::endl;
<a name="l00115"></a>00115           }
<a name="l00116"></a>00116 
<a name="l00117"></a>00117         <span class="keywordflow">if</span> (_dim &gt; 1)
<a name="l00118"></a>00118           {
<a name="l00119"></a>00119             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Jacobi(2,0) quadrature implemented&quot;</span> &lt;&lt; std::endl
<a name="l00120"></a>00120                           &lt;&lt; <span class="stringliteral">&quot; in 1D only.&quot;</span> &lt;&lt; std::endl;
<a name="l00121"></a>00121           }
<a name="l00122"></a>00122 <span class="preprocessor">#endif</span>
<a name="l00123"></a>00123 <span class="preprocessor"></span>
<a name="l00124"></a>00124         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QJacobi.php">QJacobi</a>(_dim, _order, 2, 0));
<a name="l00125"></a>00125         <span class="keywordflow">return</span> ap;
<a name="l00126"></a>00126       }
<a name="l00127"></a>00127 
<a name="l00128"></a>00128     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adaeb07c05dac20ab7f134838e34f9db0c1">QSIMPSON</a>:
<a name="l00129"></a>00129       {
<a name="l00130"></a>00130 
<a name="l00131"></a>00131 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00132"></a>00132 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (_order &gt; <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>)
<a name="l00133"></a>00133           {
<a name="l00134"></a>00134             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Simpson rule provides only&quot;</span> &lt;&lt; std::endl
<a name="l00135"></a>00135                           &lt;&lt; <span class="stringliteral">&quot; THIRD order!&quot;</span> &lt;&lt; std::endl;
<a name="l00136"></a>00136           }
<a name="l00137"></a>00137 <span class="preprocessor">#endif</span>
<a name="l00138"></a>00138 <span class="preprocessor"></span>
<a name="l00139"></a>00139         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QSimpson.php">QSimpson</a>(_dim));
<a name="l00140"></a>00140         <span class="keywordflow">return</span> ap;
<a name="l00141"></a>00141       }
<a name="l00142"></a>00142 
<a name="l00143"></a>00143     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada26431abeff146407680a87ae0dd3a39a">QTRAP</a>:
<a name="l00144"></a>00144       {
<a name="l00145"></a>00145 
<a name="l00146"></a>00146 <span class="preprocessor">#ifdef DEBUG</span>
<a name="l00147"></a>00147 <span class="preprocessor"></span>        <span class="keywordflow">if</span> (_order &gt; <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>)
<a name="l00148"></a>00148           {
<a name="l00149"></a>00149             <a class="code" href="namespacelibMesh.php#a63e3c3158308e2184c12b55ab9ea9a35">libMesh::out</a> &lt;&lt; <span class="stringliteral">&quot;WARNING: Trapezoidal rule provides only&quot;</span> &lt;&lt; std::endl
<a name="l00150"></a>00150                           &lt;&lt; <span class="stringliteral">&quot; FIRST order!&quot;</span> &lt;&lt; std::endl;
<a name="l00151"></a>00151           }
<a name="l00152"></a>00152 <span class="preprocessor">#endif</span>
<a name="l00153"></a>00153 <span class="preprocessor"></span>
<a name="l00154"></a>00154         <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> ap(<span class="keyword">new</span> <a class="code" href="classlibMesh_1_1QTrap.php">QTrap</a>(_dim));
<a name="l00155"></a>00155         <span class="keywordflow">return</span> ap;
<a name="l00156"></a>00156       }
<a name="l00157"></a>00157 
<a name="l00158"></a>00158 
<a name="l00159"></a>00159     <span class="keywordflow">default</span>:
<a name="l00160"></a>00160       { 
<a name="l00161"></a>00161         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad qt=&quot;</span> &lt;&lt; _qt &lt;&lt; std::endl;
<a name="l00162"></a>00162         libmesh_error();
<a name="l00163"></a>00163       }
<a name="l00164"></a>00164     }
<a name="l00165"></a>00165 
<a name="l00166"></a>00166 
<a name="l00167"></a>00167   libmesh_error();
<a name="l00168"></a>00168   <a class="code" href="classlibMesh_1_1AutoPtr.php">AutoPtr&lt;QBase&gt;</a> ap(NULL);
<a name="l00169"></a>00169   <span class="keywordflow">return</span> ap;
<a name="l00170"></a>00170 }
<a name="l00171"></a>00171 
<a name="l00172"></a>00172 } <span class="comment">// namespace libMesh</span>
<a name="l00173"></a>00173 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
