<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_clough_2D.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__clough__2D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_clough_2D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__clough_8h.php">quadrature_clough.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="classlibMesh_1_1QClough.php#a4d9b9a0ac9e6c11bbb6ef1f6f486f5bd">00030</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QClough.php#a4d9b9a0ac9e6c11bbb6ef1f6f486f5bd">QClough::init_2D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type,
<a name="l00031"></a>00031                       <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>  <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> gauss_rule(2, _order);
<a name="l00035"></a>00035   gauss_rule.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>, p);
<a name="l00036"></a>00036   
<a name="l00037"></a>00037   <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00038"></a>00038   <span class="comment">// 2D quadrature rules</span>
<a name="l00039"></a>00039   <span class="keywordflow">switch</span> (_type)
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041 
<a name="l00042"></a>00042       <span class="comment">//---------------------------------------------</span>
<a name="l00043"></a>00043       <span class="comment">// Triangle quadrature rules</span>
<a name="l00044"></a>00044     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00045"></a>00045     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00046"></a>00046       {
<a name="l00047"></a>00047         std::vector&lt;Point&gt; &amp;gausspoints = gauss_rule.<a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">get_points</a>();
<a name="l00048"></a>00048         std::vector&lt;Real&gt; &amp;gaussweights = gauss_rule.<a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">get_weights</a>();
<a name="l00049"></a>00049         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> numgausspts = gausspoints.size();
<a name="l00050"></a>00050         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(numgausspts*3);
<a name="l00051"></a>00051         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(numgausspts*3);
<a name="l00052"></a>00052         <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i = 0; i != numgausspts; ++i)
<a name="l00053"></a>00053           {
<a name="l00054"></a>00054             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3*i](0) = gausspoints[i](0) +
<a name="l00055"></a>00055                             gausspoints[i](1) / 3.;
<a name="l00056"></a>00056             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3*i](1) = gausspoints[i](1) / 3.;
<a name="l00057"></a>00057             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3*i+1](0) = gausspoints[i](1) / 3.;
<a name="l00058"></a>00058             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3*i+1](1) = gausspoints[i](0) +
<a name="l00059"></a>00059                             gausspoints[i](1) / 3.;
<a name="l00060"></a>00060             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3*i+2](0) = 1./3. +
<a name="l00061"></a>00061                             gausspoints[i](0) * 2./3. -
<a name="l00062"></a>00062                             gausspoints[i](1) / 3.;
<a name="l00063"></a>00063             <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3*i+2](1) = 1./3. - 
<a name="l00064"></a>00064                             gausspoints[i](0) / 3. +
<a name="l00065"></a>00065                             gausspoints[i](1) * 2./3.;
<a name="l00066"></a>00066             <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3*i] = gaussweights[i] / 3.;
<a name="l00067"></a>00067             _weights[3*i+1] = _weights[3*i];
<a name="l00068"></a>00068             _weights[3*i+2] = _weights[3*i];
<a name="l00069"></a>00069           }
<a name="l00070"></a>00070         <span class="keywordflow">return</span>;
<a name="l00071"></a>00071       }
<a name="l00072"></a>00072 
<a name="l00073"></a>00073             
<a name="l00074"></a>00074       <span class="comment">//---------------------------------------------</span>
<a name="l00075"></a>00075       <span class="comment">// Unsupported type</span>
<a name="l00076"></a>00076     <span class="keywordflow">default</span>:
<a name="l00077"></a>00077       {
<a name="l00078"></a>00078         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Element type not supported!:&quot;</span> &lt;&lt; _type &lt;&lt; std::endl;
<a name="l00079"></a>00079         libmesh_error();
<a name="l00080"></a>00080       }
<a name="l00081"></a>00081     }
<a name="l00082"></a>00082 
<a name="l00083"></a>00083   libmesh_error();
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="keywordflow">return</span>;
<a name="l00086"></a>00086 
<a name="l00087"></a>00087 <span class="preprocessor">#endif</span>
<a name="l00088"></a>00088 <span class="preprocessor"></span>}
<a name="l00089"></a>00089 
<a name="l00090"></a>00090 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
