<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_conical.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__conical_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_conical.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__conical_8h.php">quadrature_conical.h</a>&quot;</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__jacobi_8h.php">quadrature_jacobi.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="comment">// See also the files:</span>
<a name="l00029"></a>00029 <span class="comment">// quadrature_conical_2D.C</span>
<a name="l00030"></a>00030 <span class="comment">// quadrature_conical_3D.C</span>
<a name="l00031"></a>00031 <span class="comment">// for additional implementation.</span>
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00034"></a>00034 
<a name="l00035"></a>00035 
<a name="l00036"></a>00036 <span class="comment">// Constructor</span>
<a name="l00037"></a><a class="code" href="classlibMesh_1_1QConical.php#a01f9d4949fb5d72a7cb641a758e9421f">00037</a> <a class="code" href="classlibMesh_1_1QConical.php#a01f9d4949fb5d72a7cb641a758e9421f">QConical::QConical</a>(<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> d,
<a name="l00038"></a>00038                    <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> o) : <a class="code" href="classlibMesh_1_1QBase.php">QBase</a>(d,o)
<a name="l00039"></a>00039 {
<a name="l00040"></a>00040 }
<a name="l00041"></a>00041 
<a name="l00042"></a>00042 
<a name="l00043"></a>00043 
<a name="l00044"></a>00044 <span class="comment">// Destructor</span>
<a name="l00045"></a><a class="code" href="classlibMesh_1_1QConical.php#ab6ffbc299fa3a7c452438c8c67c3a365">00045</a> <a class="code" href="classlibMesh_1_1QConical.php#ab6ffbc299fa3a7c452438c8c67c3a365">QConical::~QConical</a>()
<a name="l00046"></a>00046 {
<a name="l00047"></a>00047 }
<a name="l00048"></a>00048 
<a name="l00049"></a>00049 
<a name="l00050"></a>00050 
<a name="l00051"></a>00051 <span class="comment">// Builds and scales a Gauss rule and a Jacobi rule.</span>
<a name="l00052"></a>00052 <span class="comment">// Then combines them to compute points and weights</span>
<a name="l00053"></a>00053 <span class="comment">// of a 2D conical product rule.</span>
<a name="l00054"></a><a class="code" href="classlibMesh_1_1QConical.php#ac35c3d1dc1d15748d19e4b0e6f66159f">00054</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QConical.php#ac35c3d1dc1d15748d19e4b0e6f66159f">QConical::conical_product_tri</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00055"></a>00055 {
<a name="l00056"></a>00056   <span class="comment">// Be sure the underlying rule object was built with the same dimension as the</span>
<a name="l00057"></a>00057   <span class="comment">// rule we are about to construct.</span>
<a name="l00058"></a>00058   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1QBase.php#a334ad6c046a65963406402fbdf13e748">get_dim</a>() == 2);
<a name="l00059"></a>00059   
<a name="l00060"></a>00060   <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a>  gauss1D(1,static_cast&lt;Order&gt;(_order+2*p));
<a name="l00061"></a>00061   <a class="code" href="classlibMesh_1_1QJacobi.php">QJacobi</a> jac1D(1,static_cast&lt;Order&gt;(_order+2*p),1,0);
<a name="l00062"></a>00062               
<a name="l00063"></a>00063   <span class="comment">// The Gauss rule needs to be scaled to [0,1]</span>
<a name="l00064"></a>00064   std::pair&lt;Real, Real&gt; old_range(-1.0L, 1.0L);
<a name="l00065"></a>00065   std::pair&lt;Real, Real&gt; new_range( 0.0L, 1.0L);
<a name="l00066"></a>00066   gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#afeadfcbe5456e574f72b095d9416fe15">scale</a>(old_range,
<a name="l00067"></a>00067                 new_range);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069   <span class="comment">// Now construct the points and weights for the conical product rule.</span>
<a name="l00070"></a>00070 
<a name="l00071"></a>00071   <span class="comment">// Both rules should have the same number of points.</span>
<a name="l00072"></a>00072   libmesh_assert(gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>() == jac1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>());
<a name="l00073"></a>00073 
<a name="l00074"></a>00074   <span class="comment">// Save the number of points as a convenient variable</span>
<a name="l00075"></a>00075   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a> = gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l00076"></a>00076   
<a name="l00077"></a>00077   <span class="comment">// Both rules should be between x=0 and x=1</span>
<a name="l00078"></a>00078   libmesh_assert(gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(0)(0) &gt;= 0.0); libmesh_assert(gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(n_points-1)(0) &lt;= 1.0);
<a name="l00079"></a>00079   libmesh_assert(jac1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(0)(0)   &gt;= 0.0); libmesh_assert(jac1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(n_points-1)(0) &lt;= 1.0);
<a name="l00080"></a>00080 
<a name="l00081"></a>00081   <span class="comment">// Resize the points and weights vectors</span>
<a name="l00082"></a>00082   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(n_points * n_points);
<a name="l00083"></a>00083   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(n_points * n_points);
<a name="l00084"></a>00084 
<a name="l00085"></a>00085   <span class="comment">// Compute the conical product</span>
<a name="l00086"></a>00086   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> gp = 0;
<a name="l00087"></a>00087   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>; i++)
<a name="l00088"></a>00088     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>; j++)
<a name="l00089"></a>00089       {
<a name="l00090"></a>00090         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[gp](0) = jac1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(j)(0);                          <span class="comment">//s[j];</span>
<a name="l00091"></a>00091         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[gp](1) = gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(i)(0) * (1.-jac1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(j)(0)); <span class="comment">//r[i]*(1.-s[j]);</span>
<a name="l00092"></a>00092         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[gp]   = gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>(i) * jac1D.<a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>(j);              <span class="comment">//A[i]*B[j];</span>
<a name="l00093"></a>00093         gp++;
<a name="l00094"></a>00094       }
<a name="l00095"></a>00095 }
<a name="l00096"></a>00096 
<a name="l00097"></a>00097 
<a name="l00098"></a>00098 
<a name="l00099"></a>00099 
<a name="l00100"></a>00100 <span class="comment">// Builds and scales a Gauss rule and a Jacobi rule.</span>
<a name="l00101"></a>00101 <span class="comment">// Then combines them to compute points and weights</span>
<a name="l00102"></a>00102 <span class="comment">// of a 3D conical product rule for the Tet.</span>
<a name="l00103"></a><a class="code" href="classlibMesh_1_1QConical.php#aea70ba0d904dc981e9d130755211060d">00103</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QConical.php#aea70ba0d904dc981e9d130755211060d">QConical::conical_product_tet</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00104"></a>00104 {
<a name="l00105"></a>00105   <span class="comment">// Be sure the underlying rule object was built with the same dimension as the</span>
<a name="l00106"></a>00106   <span class="comment">// rule we are about to construct.</span>
<a name="l00107"></a>00107   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1QBase.php#a334ad6c046a65963406402fbdf13e748">get_dim</a>() == 3);
<a name="l00108"></a>00108   
<a name="l00109"></a>00109   <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a>  gauss1D(1,static_cast&lt;Order&gt;(_order+2*p));
<a name="l00110"></a>00110   <a class="code" href="classlibMesh_1_1QJacobi.php">QJacobi</a> jacA1D(1,static_cast&lt;Order&gt;(_order+2*p),1,0);
<a name="l00111"></a>00111   <a class="code" href="classlibMesh_1_1QJacobi.php">QJacobi</a> jacB1D(1,static_cast&lt;Order&gt;(_order+2*p),2,0);
<a name="l00112"></a>00112 
<a name="l00113"></a>00113   <span class="comment">// The Gauss rule needs to be scaled to [0,1]</span>
<a name="l00114"></a>00114   std::pair&lt;Real, Real&gt; old_range(-1.0L, 1.0L);
<a name="l00115"></a>00115   std::pair&lt;Real, Real&gt; new_range( 0.0L, 1.0L);
<a name="l00116"></a>00116   gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#afeadfcbe5456e574f72b095d9416fe15">scale</a>(old_range,
<a name="l00117"></a>00117                 new_range);
<a name="l00118"></a>00118 
<a name="l00119"></a>00119   <span class="comment">// Now construct the points and weights for the conical product rule.</span>
<a name="l00120"></a>00120 
<a name="l00121"></a>00121   <span class="comment">// All rules should have the same number of points</span>
<a name="l00122"></a>00122   libmesh_assert(gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>() == jacA1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>());
<a name="l00123"></a>00123   libmesh_assert(jacA1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>()  == jacB1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>());
<a name="l00124"></a>00124   
<a name="l00125"></a>00125   <span class="comment">// Save the number of points as a convenient variable</span>
<a name="l00126"></a>00126   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a> = gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l00127"></a>00127   
<a name="l00128"></a>00128   <span class="comment">// All rules should be between x=0 and x=1</span>
<a name="l00129"></a>00129   libmesh_assert(gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(0)(0) &gt;= 0.0); libmesh_assert(gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(n_points-1)(0) &lt;= 1.0);
<a name="l00130"></a>00130   libmesh_assert(jacA1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(0)(0)  &gt;= 0.0); libmesh_assert(jacA1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(n_points-1)(0)  &lt;= 1.0);
<a name="l00131"></a>00131   libmesh_assert(jacB1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(0)(0)  &gt;= 0.0); libmesh_assert(jacB1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(n_points-1)(0)  &lt;= 1.0);
<a name="l00132"></a>00132 
<a name="l00133"></a>00133   <span class="comment">// Resize the points and weights vectors</span>
<a name="l00134"></a>00134   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(n_points * n_points * n_points);
<a name="l00135"></a>00135   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(n_points * n_points * n_points);
<a name="l00136"></a>00136 
<a name="l00137"></a>00137   <span class="comment">// Compute the conical product</span>
<a name="l00138"></a>00138   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> gp = 0;
<a name="l00139"></a>00139   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>; i++)
<a name="l00140"></a>00140     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>; j++)
<a name="l00141"></a>00141       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>; k++)
<a name="l00142"></a>00142       {
<a name="l00143"></a>00143         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[gp](0) = jacB1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(k)(0);                                                  <span class="comment">//t[k];</span>
<a name="l00144"></a>00144         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[gp](1) = jacA1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(j)(0)  * (1.-jacB1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(k)(0));                         <span class="comment">//s[j]*(1.-t[k]);</span>
<a name="l00145"></a>00145         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[gp](2) = gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(i)(0) * (1.-jacA1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(j)(0)) * (1.-jacB1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(k)(0)); <span class="comment">//r[i]*(1.-s[j])*(1.-t[k]);</span>
<a name="l00146"></a>00146         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[gp]   = gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>(i)     * jacA1D.<a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>(j)          * jacB1D.<a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>(k);          <span class="comment">//A[i]*B[j]*C[k];</span>
<a name="l00147"></a>00147         gp++;
<a name="l00148"></a>00148       }
<a name="l00149"></a>00149 }
<a name="l00150"></a>00150 
<a name="l00151"></a>00151 
<a name="l00152"></a>00152 
<a name="l00153"></a>00153 
<a name="l00154"></a>00154 
<a name="l00155"></a>00155 <span class="comment">// Builds and scales a Gauss rule and a Jacobi rule.</span>
<a name="l00156"></a>00156 <span class="comment">// Then combines them to compute points and weights</span>
<a name="l00157"></a>00157 <span class="comment">// of a 3D conical product rule for the Pyramid.  The integral</span>
<a name="l00158"></a>00158 <span class="comment">// over the reference Tet can be written (in LaTeX notation) as:</span>
<a name="l00159"></a>00159 <span class="comment">//</span>
<a name="l00160"></a>00160 <span class="comment">// If := \int_0^1 dz \int_{-(1-z)}^{(1-z)} dy \int_{-(1-z)}^{(1-z)} f(x,y,z) dx (1)</span>
<a name="l00161"></a>00161 <span class="comment">//</span>
<a name="l00162"></a>00162 <span class="comment">// (Imagine a stack of infinitely thin squares which decrease in size as</span>
<a name="l00163"></a>00163 <span class="comment">//  you approach the apex.)  Under the transformation of variables:</span>
<a name="l00164"></a>00164 <span class="comment">// </span>
<a name="l00165"></a>00165 <span class="comment">// z=w</span>
<a name="l00166"></a>00166 <span class="comment">// y=(1-z)v</span>
<a name="l00167"></a>00167 <span class="comment">// x=(1-z)u,</span>
<a name="l00168"></a>00168 <span class="comment">//</span>
<a name="l00169"></a>00169 <span class="comment">// The Jacobian determinant of this transformation is |J|=(1-w)^2, and</span>
<a name="l00170"></a>00170 <span class="comment">// the integral itself is transformed to:</span>
<a name="l00171"></a>00171 <span class="comment">//</span>
<a name="l00172"></a>00172 <span class="comment">// If = \int_0^1 (1-w)^2 dw \int_{-1}^{1} dv \int_{-1}^{1} f((1-w)u, (1-w)v, w) du (2)</span>
<a name="l00173"></a>00173 <span class="comment">//</span>
<a name="l00174"></a>00174 <span class="comment">// The integral can now be approximated by the product of three 1D quadrature rules:</span>
<a name="l00175"></a>00175 <span class="comment">// A Jacobi rule with alpha==2, beta==0 in w, and Gauss rules in v and u.  In this way</span>
<a name="l00176"></a>00176 <span class="comment">// we can obtain 3D rules to any order for which the 1D rules exist.</span>
<a name="l00177"></a><a class="code" href="classlibMesh_1_1QConical.php#a3444eeaaf3fdfdcb188738e6f2c50382">00177</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QConical.php#a3444eeaaf3fdfdcb188738e6f2c50382">QConical::conical_product_pyramid</a>(<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00178"></a>00178 {
<a name="l00179"></a>00179   <span class="comment">// Be sure the underlying rule object was built with the same dimension as the</span>
<a name="l00180"></a>00180   <span class="comment">// rule we are about to construct.</span>
<a name="l00181"></a>00181   libmesh_assert (this-&gt;<a class="code" href="classlibMesh_1_1QBase.php#a334ad6c046a65963406402fbdf13e748">get_dim</a>() == 3);
<a name="l00182"></a>00182   
<a name="l00183"></a>00183   <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a>  gauss1D(1,static_cast&lt;Order&gt;(_order+2*p));
<a name="l00184"></a>00184   <a class="code" href="classlibMesh_1_1QJacobi.php">QJacobi</a> jac1D(1,static_cast&lt;Order&gt;(_order+2*p),2,0);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186   <span class="comment">// These rules should have the same number of points</span>
<a name="l00187"></a>00187   libmesh_assert(gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>() == jac1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>());
<a name="l00188"></a>00188   
<a name="l00189"></a>00189   <span class="comment">// Save the number of points as a convenient variable</span>
<a name="l00190"></a>00190   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a> = gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>();
<a name="l00191"></a>00191 
<a name="l00192"></a>00192   <span class="comment">// Resize the points and weights vectors</span>
<a name="l00193"></a>00193   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(n_points * n_points * n_points);
<a name="l00194"></a>00194   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(n_points * n_points * n_points);
<a name="l00195"></a>00195 
<a name="l00196"></a>00196   <span class="comment">// Compute the conical product</span>
<a name="l00197"></a>00197   <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> <a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a> = 0;
<a name="l00198"></a>00198   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>; ++i)
<a name="l00199"></a>00199     <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>; ++j)
<a name="l00200"></a>00200       <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> k=0; k&lt;<a class="code" href="classlibMesh_1_1QBase.php#ac0395144dc0b41dd27689f303c1eba2b">n_points</a>; ++k, ++<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>)
<a name="l00201"></a>00201       {
<a name="l00202"></a>00202         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi=gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(i)(0);
<a name="l00203"></a>00203         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> yj=gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(j)(0);
<a name="l00204"></a>00204         <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> zk=jac1D.<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>(k)(0);
<a name="l00205"></a>00205         
<a name="l00206"></a>00206         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>](0) = (1.-zk) * xi;
<a name="l00207"></a>00207         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>](1) = (1.-zk) * yj;
<a name="l00208"></a>00208         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>](2) = zk;
<a name="l00209"></a>00209         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[<a class="code" href="classlibMesh_1_1QBase.php#ab214d58a178cf9f2c12a4c6d36722edf">qp</a>]   = gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>(i) * gauss1D.<a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>(j) * jac1D.<a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>(k);
<a name="l00210"></a>00210       }
<a name="l00211"></a>00211   
<a name="l00212"></a>00212   
<a name="l00213"></a>00213 }
<a name="l00214"></a>00214 
<a name="l00215"></a>00215 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
