<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_gauss_1D.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__gauss__1D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_gauss_1D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// C++ includes</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029  
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a><a class="code" href="classlibMesh_1_1QGauss.php#ac5875bbe0cbcb83cb50570e75e83db0a">00032</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QGauss.php#ac5875bbe0cbcb83cb50570e75e83db0a">QGauss::init_1D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00033"></a>00033                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   <span class="comment">//----------------------------------------------------------------------</span>
<a name="l00036"></a>00036   <span class="comment">// 1D quadrature rules</span>
<a name="l00037"></a>00037   <span class="keywordflow">switch</span>(_order + 2*p)
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>:
<a name="l00040"></a>00040     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00041"></a>00041       {
<a name="l00042"></a>00042         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (1);
<a name="l00043"></a>00043         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(1);
<a name="l00044"></a>00044         
<a name="l00045"></a>00045         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0)  = 0.;
<a name="l00046"></a>00046         
<a name="l00047"></a>00047         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0]    = 2.;
<a name="l00048"></a>00048         
<a name="l00049"></a>00049         <span class="keywordflow">return</span>;
<a name="l00050"></a>00050       }
<a name="l00051"></a>00051     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00052"></a>00052     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00053"></a>00053       {
<a name="l00054"></a>00054         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (2);
<a name="l00055"></a>00055         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(2);
<a name="l00056"></a>00056               
<a name="l00057"></a>00057         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0) = -5.7735026918962576450914878050196e-01L; <span class="comment">// -sqrt(3)/3</span>
<a name="l00058"></a>00058         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1]    = -_points[0];
<a name="l00059"></a>00059 
<a name="l00060"></a>00060         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0]   = 1.;
<a name="l00061"></a>00061         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00062"></a>00062 
<a name="l00063"></a>00063         <span class="keywordflow">return</span>;
<a name="l00064"></a>00064       }
<a name="l00065"></a>00065     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00066"></a>00066     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00067"></a>00067       {
<a name="l00068"></a>00068         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (3);
<a name="l00069"></a>00069         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(3);
<a name="l00070"></a>00070               
<a name="l00071"></a>00071         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -7.7459666924148337703585307995648e-01L;
<a name="l00072"></a>00072         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = 0.;
<a name="l00073"></a>00073         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2]    = -_points[0];
<a name="l00074"></a>00074 
<a name="l00075"></a>00075         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 5.5555555555555555555555555555556e-01L;
<a name="l00076"></a>00076         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 8.8888888888888888888888888888889e-01L;
<a name="l00077"></a>00077         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00078"></a>00078 
<a name="l00079"></a>00079         <span class="keywordflow">return</span>;
<a name="l00080"></a>00080       }
<a name="l00081"></a>00081     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00082"></a>00082     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00083"></a>00083       {
<a name="l00084"></a>00084         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (4);
<a name="l00085"></a>00085         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(4);
<a name="l00086"></a>00086               
<a name="l00087"></a>00087         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -8.6113631159405257522394648889281e-01L;
<a name="l00088"></a>00088         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -3.3998104358485626480266575910324e-01L;
<a name="l00089"></a>00089         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2]    = -_points[1];
<a name="l00090"></a>00090         _points[ 3]    = -_points[0];
<a name="l00091"></a>00091 
<a name="l00092"></a>00092         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 3.4785484513745385737306394922200e-01L;
<a name="l00093"></a>00093         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 6.5214515486254614262693605077800e-01L;
<a name="l00094"></a>00094         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00095"></a>00095         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00096"></a>00096 
<a name="l00097"></a>00097         <span class="keywordflow">return</span>;
<a name="l00098"></a>00098       }
<a name="l00099"></a>00099     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>:
<a name="l00100"></a>00100     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa96e4b793b046031faa991f15f1a80bc6">NINTH</a>:
<a name="l00101"></a>00101       {
<a name="l00102"></a>00102         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (5);
<a name="l00103"></a>00103         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(5);
<a name="l00104"></a>00104               
<a name="l00105"></a>00105         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.0617984593866399279762687829939e-01L;
<a name="l00106"></a>00106         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -5.3846931010568309103631442070021e-01L;
<a name="l00107"></a>00107         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = 0.;
<a name="l00108"></a>00108         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3]    = -_points[1];
<a name="l00109"></a>00109         _points[ 4]    = -_points[0];
<a name="l00110"></a>00110 
<a name="l00111"></a>00111         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 2.3692688505618908751426404071992e-01L;
<a name="l00112"></a>00112         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 4.7862867049936646804129151483564e-01L;
<a name="l00113"></a>00113         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 5.6888888888888888888888888888889e-01L;
<a name="l00114"></a>00114         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00115"></a>00115         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00116"></a>00116 
<a name="l00117"></a>00117         <span class="keywordflow">return</span>;
<a name="l00118"></a>00118       }
<a name="l00119"></a>00119     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6115f555ee86d242617207bec760f208">TENTH</a>:
<a name="l00120"></a>00120     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa9d8cd1c6f2feb41a556c16d8cb4744cd">ELEVENTH</a>:
<a name="l00121"></a>00121       {
<a name="l00122"></a>00122         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (6);
<a name="l00123"></a>00123         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(6);
<a name="l00124"></a>00124               
<a name="l00125"></a>00125         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.3246951420315202781230155449399e-01L;
<a name="l00126"></a>00126         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -6.6120938646626451366139959501991e-01L;
<a name="l00127"></a>00127         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -2.3861918608319690863050172168071e-01L;
<a name="l00128"></a>00128         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3]    = -_points[2];
<a name="l00129"></a>00129         _points[ 4]    = -_points[1];
<a name="l00130"></a>00130         _points[ 5]    = -_points[0];
<a name="l00131"></a>00131 
<a name="l00132"></a>00132         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 1.7132449237917034504029614217273e-01L;
<a name="l00133"></a>00133         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 3.6076157304813860756983351383772e-01L;
<a name="l00134"></a>00134         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 4.6791393457269104738987034398955e-01L;
<a name="l00135"></a>00135         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00136"></a>00136         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00137"></a>00137         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00138"></a>00138 
<a name="l00139"></a>00139         <span class="keywordflow">return</span>;
<a name="l00140"></a>00140       }
<a name="l00141"></a>00141     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa72ff7b576c902d58a9fc3ad53b247a85">TWELFTH</a>:
<a name="l00142"></a>00142     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faeb2a82bbe2a44c6917cedc029423ce75">THIRTEENTH</a>:
<a name="l00143"></a>00143       {
<a name="l00144"></a>00144         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (7);
<a name="l00145"></a>00145         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(7);
<a name="l00146"></a>00146               
<a name="l00147"></a>00147         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.4910791234275852452618968404785e-01L;
<a name="l00148"></a>00148         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -7.4153118559939443986386477328079e-01L;
<a name="l00149"></a>00149         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -4.0584515137739716690660641207696e-01L;
<a name="l00150"></a>00150         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = 0.;
<a name="l00151"></a>00151         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4]    = -_points[2];
<a name="l00152"></a>00152         _points[ 5]    = -_points[1];
<a name="l00153"></a>00153         _points[ 6]    = -_points[0];
<a name="l00154"></a>00154 
<a name="l00155"></a>00155         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 1.2948496616886969327061143267908e-01L;
<a name="l00156"></a>00156         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 2.7970539148927666790146777142378e-01L;
<a name="l00157"></a>00157         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 3.8183005050511894495036977548898e-01L;
<a name="l00158"></a>00158         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 4.1795918367346938775510204081633e-01L;
<a name="l00159"></a>00159         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00160"></a>00160         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00161"></a>00161         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00162"></a>00162 
<a name="l00163"></a>00163         <span class="keywordflow">return</span>;
<a name="l00164"></a>00164       }
<a name="l00165"></a>00165     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faab1534905d9792db00394cf617c71749">FOURTEENTH</a>:
<a name="l00166"></a>00166     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7120ce4c6dcb4b9465b15e7531631fe6">FIFTEENTH</a>:
<a name="l00167"></a>00167       {
<a name="l00168"></a>00168         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (8);
<a name="l00169"></a>00169         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(8);
<a name="l00170"></a>00170               
<a name="l00171"></a>00171         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.6028985649753623168356086856947e-01L;
<a name="l00172"></a>00172         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -7.9666647741362673959155393647583e-01L;
<a name="l00173"></a>00173         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -5.2553240991632898581773904918925e-01L;
<a name="l00174"></a>00174         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -1.8343464249564980493947614236018e-01L;
<a name="l00175"></a>00175         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4]    = -_points[3];
<a name="l00176"></a>00176         _points[ 5]    = -_points[2];
<a name="l00177"></a>00177         _points[ 6]    = -_points[1];
<a name="l00178"></a>00178         _points[ 7]    = -_points[0];
<a name="l00179"></a>00179 
<a name="l00180"></a>00180         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 1.0122853629037625915253135430996e-01L;
<a name="l00181"></a>00181         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 2.2238103445337447054435599442624e-01L;
<a name="l00182"></a>00182         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 3.1370664587788728733796220198660e-01L;
<a name="l00183"></a>00183         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 3.6268378337836198296515044927720e-01L;
<a name="l00184"></a>00184         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00185"></a>00185         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00186"></a>00186         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00187"></a>00187         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00188"></a>00188 
<a name="l00189"></a>00189         <span class="keywordflow">return</span>;
<a name="l00190"></a>00190       }
<a name="l00191"></a>00191     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad3a83c160ba19d280cf82ab0fee65f2d">SIXTEENTH</a>:
<a name="l00192"></a>00192     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fae4eeb80a784baaf763cdccf0a47a4557">SEVENTEENTH</a>:
<a name="l00193"></a>00193       {
<a name="l00194"></a>00194         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (9);
<a name="l00195"></a>00195         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(9);
<a name="l00196"></a>00196 
<a name="l00197"></a>00197         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.6816023950762608983557620290367e-01L;
<a name="l00198"></a>00198         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -8.3603110732663579429942978806973e-01L;
<a name="l00199"></a>00199         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -6.1337143270059039730870203934147e-01L;
<a name="l00200"></a>00200         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -3.2425342340380892903853801464334e-01L;
<a name="l00201"></a>00201         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = 0.;
<a name="l00202"></a>00202         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5]    = -_points[3];
<a name="l00203"></a>00203         _points[ 6]    = -_points[2];
<a name="l00204"></a>00204         _points[ 7]    = -_points[1];
<a name="l00205"></a>00205         _points[ 8]    = -_points[0];
<a name="l00206"></a>00206 
<a name="l00207"></a>00207         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 8.1274388361574411971892158110524e-02L;
<a name="l00208"></a>00208         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 1.8064816069485740405847203124291e-01L;
<a name="l00209"></a>00209         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 2.6061069640293546231874286941863e-01L;
<a name="l00210"></a>00210         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 3.1234707704000284006863040658444e-01L;
<a name="l00211"></a>00211         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 3.3023935500125976316452506928697e-01L;
<a name="l00212"></a>00212         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00213"></a>00213         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00214"></a>00214         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00215"></a>00215         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00216"></a>00216 
<a name="l00217"></a>00217         <span class="keywordflow">return</span>;
<a name="l00218"></a>00218       }
<a name="l00219"></a>00219     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa04abe26889214024e6b01556757afebc">EIGHTTEENTH</a>:
<a name="l00220"></a>00220     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa460d128a5ae3f0cab006386047945a63">NINTEENTH</a>:
<a name="l00221"></a>00221       {
<a name="l00222"></a>00222         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (10);
<a name="l00223"></a>00223         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(10);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.7390652851717172007796401208445e-01L;
<a name="l00226"></a>00226         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -8.6506336668898451073209668842349e-01L;
<a name="l00227"></a>00227         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -6.7940956829902440623432736511487e-01L;
<a name="l00228"></a>00228         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -4.3339539412924719079926594316578e-01L;
<a name="l00229"></a>00229         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -1.4887433898163121088482600112972e-01L;
<a name="l00230"></a>00230         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5]    = -_points[4];
<a name="l00231"></a>00231         _points[ 6]    = -_points[3];
<a name="l00232"></a>00232         _points[ 7]    = -_points[2];
<a name="l00233"></a>00233         _points[ 8]    = -_points[1];
<a name="l00234"></a>00234         _points[ 9]    = -_points[0];
<a name="l00235"></a>00235 
<a name="l00236"></a>00236         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 6.6671344308688137593568809893332e-02L;
<a name="l00237"></a>00237         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 1.4945134915058059314577633965770e-01L;
<a name="l00238"></a>00238         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 2.1908636251598204399553493422816e-01L;
<a name="l00239"></a>00239         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 2.6926671930999635509122692156947e-01L;
<a name="l00240"></a>00240         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 2.9552422471475287017389299465134e-01L;
<a name="l00241"></a>00241         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00242"></a>00242         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00243"></a>00243         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00244"></a>00244         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00245"></a>00245         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00246"></a>00246 
<a name="l00247"></a>00247         <span class="keywordflow">return</span>;
<a name="l00248"></a>00248       }      
<a name="l00249"></a>00249 
<a name="l00250"></a>00250     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1fd67e9ea1cf7030e0e5b9c6e82698a2">TWENTIETH</a>:
<a name="l00251"></a>00251     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6e1551e839c8196b348cd883be5a4bd8">TWENTYFIRST</a>:
<a name="l00252"></a>00252       {
<a name="l00253"></a>00253         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (11);
<a name="l00254"></a>00254         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(11);
<a name="l00255"></a>00255 
<a name="l00256"></a>00256         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.7822865814605699280393800112286e-01L;
<a name="l00257"></a>00257         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -8.8706259976809529907515776930393e-01L;
<a name="l00258"></a>00258         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -7.3015200557404932409341625203115e-01L;
<a name="l00259"></a>00259         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -5.1909612920681181592572566945861e-01L;
<a name="l00260"></a>00260         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -2.6954315595234497233153198540086e-01L;
<a name="l00261"></a>00261         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = 0.;
<a name="l00262"></a>00262         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6]    = -_points[4];
<a name="l00263"></a>00263         _points[ 7]    = -_points[3];
<a name="l00264"></a>00264         _points[ 8]    = -_points[2];
<a name="l00265"></a>00265         _points[ 9]    = -_points[1];
<a name="l00266"></a>00266         _points[10]    = -_points[0];
<a name="l00267"></a>00267 
<a name="l00268"></a>00268         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 5.5668567116173666482753720442549e-02L;
<a name="l00269"></a>00269         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 1.2558036946490462463469429922394e-01L;
<a name="l00270"></a>00270         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 1.8629021092773425142609764143166e-01L;
<a name="l00271"></a>00271         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 2.3319376459199047991852370484318e-01L;
<a name="l00272"></a>00272         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 2.6280454451024666218068886989051e-01L;
<a name="l00273"></a>00273         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 2.7292508677790063071448352833634e-01L;
<a name="l00274"></a>00274         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00275"></a>00275         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00276"></a>00276         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00277"></a>00277         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00278"></a>00278         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00279"></a>00279 
<a name="l00280"></a>00280         <span class="keywordflow">return</span>;
<a name="l00281"></a>00281       }
<a name="l00282"></a>00282 
<a name="l00283"></a>00283     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac53c44bf97483f77b3b8f12689d1025f">TWENTYSECOND</a>:
<a name="l00284"></a>00284     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1dda25317008178eb86eef7e967e9ecf">TWENTYTHIRD</a>:
<a name="l00285"></a>00285       {
<a name="l00286"></a>00286         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (12);
<a name="l00287"></a>00287         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(12);
<a name="l00288"></a>00288 
<a name="l00289"></a>00289         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.8156063424671925069054909014928e-01L;
<a name="l00290"></a>00290         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.0411725637047485667846586611910e-01L;
<a name="l00291"></a>00291         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -7.6990267419430468703689383321282e-01L;
<a name="l00292"></a>00292         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -5.8731795428661744729670241894053e-01L;
<a name="l00293"></a>00293         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -3.6783149899818019375269153664372e-01L;
<a name="l00294"></a>00294         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -1.2523340851146891547244136946385e-01L;
<a name="l00295"></a>00295         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6]    = -_points[5];
<a name="l00296"></a>00296         _points[ 7]    = -_points[4];
<a name="l00297"></a>00297         _points[ 8]    = -_points[3];
<a name="l00298"></a>00298         _points[ 9]    = -_points[2];
<a name="l00299"></a>00299         _points[10]    = -_points[1];
<a name="l00300"></a>00300         _points[11]    = -_points[0];
<a name="l00301"></a>00301 
<a name="l00302"></a>00302         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 4.7175336386511827194615961485017e-02L;
<a name="l00303"></a>00303         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 1.0693932599531843096025471819400e-01L;
<a name="l00304"></a>00304         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 1.6007832854334622633465252954336e-01L;
<a name="l00305"></a>00305         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 2.0316742672306592174906445580980e-01L;
<a name="l00306"></a>00306         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 2.3349253653835480876084989892483e-01L;
<a name="l00307"></a>00307         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 2.4914704581340278500056243604295e-01L;
<a name="l00308"></a>00308         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00309"></a>00309         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00310"></a>00310         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00311"></a>00311         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00312"></a>00312         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00313"></a>00313         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00314"></a>00314 
<a name="l00315"></a>00315         <span class="keywordflow">return</span>;
<a name="l00316"></a>00316       }      
<a name="l00317"></a>00317 
<a name="l00318"></a>00318     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa8093001568608e51bbe10f03c871fc41">TWENTYFOURTH</a>:
<a name="l00319"></a>00319     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad2f79bea88fd463e33a7800d828bded9">TWENTYFIFTH</a>:
<a name="l00320"></a>00320       {
<a name="l00321"></a>00321         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (13);
<a name="l00322"></a>00322         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(13);
<a name="l00323"></a>00323 
<a name="l00324"></a>00324         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.8418305471858814947282944880711e-01L;
<a name="l00325"></a>00325         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.1759839922297796520654783650072e-01L;
<a name="l00326"></a>00326         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -8.0157809073330991279420648958286e-01L;
<a name="l00327"></a>00327         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -6.4234933944034022064398460699552e-01L;
<a name="l00328"></a>00328         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -4.4849275103644685287791285212764e-01L;
<a name="l00329"></a>00329         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -2.3045831595513479406552812109799e-01L;
<a name="l00330"></a>00330         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = 0.;
<a name="l00331"></a>00331         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7]    = -_points[5];
<a name="l00332"></a>00332         _points[ 8]    = -_points[4];
<a name="l00333"></a>00333         _points[ 9]    = -_points[3];
<a name="l00334"></a>00334         _points[10]    = -_points[2];
<a name="l00335"></a>00335         _points[11]    = -_points[1];
<a name="l00336"></a>00336         _points[12]    = -_points[0];
<a name="l00337"></a>00337 
<a name="l00338"></a>00338         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 4.0484004765315879520021592200986e-02L;
<a name="l00339"></a>00339         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 9.2121499837728447914421775953797e-02L;
<a name="l00340"></a>00340         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 1.3887351021978723846360177686887e-01L;
<a name="l00341"></a>00341         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 1.7814598076194573828004669199610e-01L;
<a name="l00342"></a>00342         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 2.0781604753688850231252321930605e-01L;
<a name="l00343"></a>00343         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 2.2628318026289723841209018603978e-01L;
<a name="l00344"></a>00344         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 2.3255155323087391019458951526884e-01L;
<a name="l00345"></a>00345         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00346"></a>00346         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00347"></a>00347         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00348"></a>00348         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00349"></a>00349         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00350"></a>00350         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00351"></a>00351 
<a name="l00352"></a>00352         <span class="keywordflow">return</span>;
<a name="l00353"></a>00353       }
<a name="l00354"></a>00354 
<a name="l00355"></a>00355     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5f33eeba0f7239d41b54654ce8d99aa3">TWENTYSIXTH</a>:
<a name="l00356"></a>00356     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0facb1defec8f9bfcd21f5ef0f62fcacd2f">TWENTYSEVENTH</a>:
<a name="l00357"></a>00357       {
<a name="l00358"></a>00358         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (14);
<a name="l00359"></a>00359         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(14);
<a name="l00360"></a>00360 
<a name="l00361"></a>00361         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.8628380869681233884159726670405e-01L;
<a name="l00362"></a>00362         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.2843488366357351733639113937787e-01L;
<a name="l00363"></a>00363         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -8.2720131506976499318979474265039e-01L;
<a name="l00364"></a>00364         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -6.8729290481168547014801980301933e-01L;
<a name="l00365"></a>00365         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -5.1524863635815409196529071855119e-01L;
<a name="l00366"></a>00366         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -3.1911236892788976043567182416848e-01L;
<a name="l00367"></a>00367         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = -1.0805494870734366206624465021983e-01L;
<a name="l00368"></a>00368         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7]    = -_points[6];
<a name="l00369"></a>00369         _points[ 8]    = -_points[5];
<a name="l00370"></a>00370         _points[ 9]    = -_points[4];
<a name="l00371"></a>00371         _points[10]    = -_points[3];
<a name="l00372"></a>00372         _points[11]    = -_points[2];
<a name="l00373"></a>00373         _points[12]    = -_points[1];
<a name="l00374"></a>00374         _points[13]    = -_points[0];
<a name="l00375"></a>00375 
<a name="l00376"></a>00376         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 3.5119460331751863031832876138192e-02L;
<a name="l00377"></a>00377         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 8.0158087159760209805633277062854e-02L;
<a name="l00378"></a>00378         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 1.2151857068790318468941480907248e-01L;
<a name="l00379"></a>00379         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 1.5720316715819353456960193862384e-01L;
<a name="l00380"></a>00380         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 1.8553839747793781374171659012516e-01L;
<a name="l00381"></a>00381         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 2.0519846372129560396592406566122e-01L;
<a name="l00382"></a>00382         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 2.1526385346315779019587644331626e-01L;
<a name="l00383"></a>00383         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[6];
<a name="l00384"></a>00384         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00385"></a>00385         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00386"></a>00386         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00387"></a>00387         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00388"></a>00388         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00389"></a>00389         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[13]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00390"></a>00390 
<a name="l00391"></a>00391         <span class="keywordflow">return</span>;
<a name="l00392"></a>00392       }
<a name="l00393"></a>00393 
<a name="l00394"></a>00394     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa0e295eb2dfc5e7e8c49b433ae27b1369">TWENTYEIGHTH</a>:
<a name="l00395"></a>00395     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2e33cfffe6c21901c488cc5c58d5bae9">TWENTYNINTH</a>:
<a name="l00396"></a>00396       {
<a name="l00397"></a>00397         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (15);
<a name="l00398"></a>00398         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(15);
<a name="l00399"></a>00399 
<a name="l00400"></a>00400         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.8799251802048542848956571858661e-01L;
<a name="l00401"></a>00401         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.3727339240070590430775894771021e-01L;
<a name="l00402"></a>00402         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -8.4820658341042721620064832077422e-01L;
<a name="l00403"></a>00403         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -7.2441773136017004741618605461394e-01L;
<a name="l00404"></a>00404         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -5.7097217260853884753722673725391e-01L;
<a name="l00405"></a>00405         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -3.9415134707756336989720737098105e-01L;
<a name="l00406"></a>00406         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = -2.0119409399743452230062830339460e-01L;
<a name="l00407"></a>00407         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0) = 0.;
<a name="l00408"></a>00408         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8]    = -_points[6];
<a name="l00409"></a>00409         _points[ 9]    = -_points[5];
<a name="l00410"></a>00410         _points[10]    = -_points[4];
<a name="l00411"></a>00411         _points[11]    = -_points[3];
<a name="l00412"></a>00412         _points[12]    = -_points[2];
<a name="l00413"></a>00413         _points[13]    = -_points[1];
<a name="l00414"></a>00414         _points[14]    = -_points[0];
<a name="l00415"></a>00415 
<a name="l00416"></a>00416         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 3.0753241996117268354628393577204e-02L;
<a name="l00417"></a>00417         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 7.0366047488108124709267416450667e-02L;
<a name="l00418"></a>00418         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 1.0715922046717193501186954668587e-01L;
<a name="l00419"></a>00419         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 1.3957067792615431444780479451103e-01L;
<a name="l00420"></a>00420         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 1.6626920581699393355320086048121e-01L;
<a name="l00421"></a>00421         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 1.8616100001556221102680056186642e-01L;
<a name="l00422"></a>00422         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 1.9843148532711157645611832644384e-01L;
<a name="l00423"></a>00423         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = 2.0257824192556127288062019996752e-01L;
<a name="l00424"></a>00424         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[6];
<a name="l00425"></a>00425         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00426"></a>00426         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00427"></a>00427         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00428"></a>00428         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00429"></a>00429         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[13]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00430"></a>00430         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[14]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00431"></a>00431 
<a name="l00432"></a>00432         <span class="keywordflow">return</span>;
<a name="l00433"></a>00433       }
<a name="l00434"></a>00434 
<a name="l00435"></a>00435     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac64b552bcc7fd10e6a8723de2e2a1250">THIRTIETH</a>:
<a name="l00436"></a>00436     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6812a2218979fea1f20f3cdf06d855a9">THIRTYFIRST</a>:
<a name="l00437"></a>00437       {
<a name="l00438"></a>00438         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (16);
<a name="l00439"></a>00439         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(16);
<a name="l00440"></a>00440 
<a name="l00441"></a>00441         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.8940093499164993259615417345033e-01L;
<a name="l00442"></a>00442         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.4457502307323257607798841553461e-01L;
<a name="l00443"></a>00443         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -8.6563120238783174388046789771239e-01L;
<a name="l00444"></a>00444         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -7.5540440835500303389510119484744e-01L;
<a name="l00445"></a>00445         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -6.1787624440264374844667176404879e-01L;
<a name="l00446"></a>00446         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -4.5801677765722738634241944298358e-01L;
<a name="l00447"></a>00447         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = -2.8160355077925891323046050146050e-01L;
<a name="l00448"></a>00448         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0) = -9.5012509837637440185319335424958e-02L;
<a name="l00449"></a>00449         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8]    = -_points[7];
<a name="l00450"></a>00450         _points[ 9]    = -_points[6];
<a name="l00451"></a>00451         _points[10]    = -_points[5];
<a name="l00452"></a>00452         _points[11]    = -_points[4];
<a name="l00453"></a>00453         _points[12]    = -_points[3];
<a name="l00454"></a>00454         _points[13]    = -_points[2];
<a name="l00455"></a>00455         _points[14]    = -_points[1];
<a name="l00456"></a>00456         _points[15]    = -_points[0];
<a name="l00457"></a>00457 
<a name="l00458"></a>00458         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 2.7152459411754094851780572456018e-02L;
<a name="l00459"></a>00459         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 6.2253523938647892862843836994378e-02L;
<a name="l00460"></a>00460         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 9.5158511682492784809925107602246e-02L;
<a name="l00461"></a>00461         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 1.2462897125553387205247628219202e-01L;
<a name="l00462"></a>00462         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 1.4959598881657673208150173054748e-01L;
<a name="l00463"></a>00463         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 1.6915651939500253818931207903033e-01L;
<a name="l00464"></a>00464         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 1.8260341504492358886676366796922e-01L;
<a name="l00465"></a>00465         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = 1.8945061045506849628539672320828e-01L;
<a name="l00466"></a>00466         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[7];
<a name="l00467"></a>00467         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[6];
<a name="l00468"></a>00468         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00469"></a>00469         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00470"></a>00470         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00471"></a>00471         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[13]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00472"></a>00472         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[14]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00473"></a>00473         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[15]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00474"></a>00474 
<a name="l00475"></a>00475         <span class="keywordflow">return</span>;
<a name="l00476"></a>00476       }
<a name="l00477"></a>00477 
<a name="l00478"></a>00478     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa88a052a9254947f209a5736a2cf49b19">THIRTYSECOND</a>:
<a name="l00479"></a>00479     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa15d72f9acb6abf33bfbd64b4afdb59b4">THIRTYTHIRD</a>:
<a name="l00480"></a>00480       {
<a name="l00481"></a>00481         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (17);
<a name="l00482"></a>00482         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(17);
<a name="l00483"></a>00483 
<a name="l00484"></a>00484         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.9057547531441733567543401994067e-01L;
<a name="l00485"></a>00485         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.5067552176876776122271695789580e-01L;
<a name="l00486"></a>00486         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -8.8023915372698590212295569448816e-01L;
<a name="l00487"></a>00487         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -7.8151400389680140692523005552048e-01L;
<a name="l00488"></a>00488         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -6.5767115921669076585030221664300e-01L;
<a name="l00489"></a>00489         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -5.1269053708647696788624656862955e-01L;
<a name="l00490"></a>00490         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = -3.5123176345387631529718551709535e-01L;
<a name="l00491"></a>00491         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0) = -1.7848418149584785585067749365407e-01L;
<a name="l00492"></a>00492         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0) = 0.;
<a name="l00493"></a>00493         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9]    = -_points[7];
<a name="l00494"></a>00494         _points[10]    = -_points[6];
<a name="l00495"></a>00495         _points[11]    = -_points[5];
<a name="l00496"></a>00496         _points[12]    = -_points[4];
<a name="l00497"></a>00497         _points[13]    = -_points[3];
<a name="l00498"></a>00498         _points[14]    = -_points[2];
<a name="l00499"></a>00499         _points[15]    = -_points[1];
<a name="l00500"></a>00500         _points[16]    = -_points[0];
<a name="l00501"></a>00501 
<a name="l00502"></a>00502         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 2.4148302868547931960110026287565e-02L;
<a name="l00503"></a>00503         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 5.5459529373987201129440165358245e-02L;
<a name="l00504"></a>00504         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 8.5036148317179180883535370191062e-02L;
<a name="l00505"></a>00505         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 1.1188384719340397109478838562636e-01L;
<a name="l00506"></a>00506         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 1.3513636846852547328631998170235e-01L;
<a name="l00507"></a>00507         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 1.5404576107681028808143159480196e-01L;
<a name="l00508"></a>00508         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 1.6800410215645004450997066378832e-01L;
<a name="l00509"></a>00509         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = 1.7656270536699264632527099011320e-01L;
<a name="l00510"></a>00510         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = 1.7944647035620652545826564426189e-01L;
<a name="l00511"></a>00511         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[7];
<a name="l00512"></a>00512         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[6];
<a name="l00513"></a>00513         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00514"></a>00514         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00515"></a>00515         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[13]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00516"></a>00516         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[14]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00517"></a>00517         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[15]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00518"></a>00518         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[16]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00519"></a>00519 
<a name="l00520"></a>00520         <span class="keywordflow">return</span>;
<a name="l00521"></a>00521       }
<a name="l00522"></a>00522 
<a name="l00523"></a>00523     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa621d865989d4fc3580a8d55ddc63a03a">THIRTYFOURTH</a>:
<a name="l00524"></a>00524     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faa8088f586a6b0baa0a05d6a18361510e">THIRTYFIFTH</a>:
<a name="l00525"></a>00525       {
<a name="l00526"></a>00526         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (18);
<a name="l00527"></a>00527         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(18);
<a name="l00528"></a>00528 
<a name="l00529"></a>00529         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.9156516842093094673001600470615e-01L;
<a name="l00530"></a>00530         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.5582394957139775518119589292978e-01L;
<a name="l00531"></a>00531         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -8.9260246649755573920606059112715e-01L;
<a name="l00532"></a>00532         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -8.0370495897252311568241745501459e-01L;
<a name="l00533"></a>00533         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -6.9168704306035320787489108128885e-01L;
<a name="l00534"></a>00534         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -5.5977083107394753460787154852533e-01L;
<a name="l00535"></a>00535         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = -4.1175116146284264603593179383305e-01L;
<a name="l00536"></a>00536         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0) = -2.5188622569150550958897285487791e-01L;
<a name="l00537"></a>00537         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0) = -8.4775013041735301242261852935784e-02L;
<a name="l00538"></a>00538         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9]    = -_points[8];
<a name="l00539"></a>00539         _points[10]    = -_points[7];
<a name="l00540"></a>00540         _points[11]    = -_points[6];
<a name="l00541"></a>00541         _points[12]    = -_points[5];
<a name="l00542"></a>00542         _points[13]    = -_points[4];
<a name="l00543"></a>00543         _points[14]    = -_points[3];
<a name="l00544"></a>00544         _points[15]    = -_points[2];
<a name="l00545"></a>00545         _points[16]    = -_points[1];
<a name="l00546"></a>00546         _points[17]    = -_points[0];
<a name="l00547"></a>00547 
<a name="l00548"></a>00548         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 2.1616013526483310313342710266452e-02L;
<a name="l00549"></a>00549         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 4.9714548894969796453334946202639e-02L;
<a name="l00550"></a>00550         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 7.6425730254889056529129677616637e-02L;
<a name="l00551"></a>00551         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 1.0094204410628716556281398492483e-01L;
<a name="l00552"></a>00552         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 1.2255520671147846018451912680020e-01L;
<a name="l00553"></a>00553         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 1.4064291467065065120473130375195e-01L;
<a name="l00554"></a>00554         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 1.5468467512626524492541800383637e-01L;
<a name="l00555"></a>00555         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = 1.6427648374583272298605377646593e-01L;
<a name="l00556"></a>00556         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = 1.6914238296314359184065647013499e-01L;
<a name="l00557"></a>00557         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[8];
<a name="l00558"></a>00558         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[7];
<a name="l00559"></a>00559         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[6];
<a name="l00560"></a>00560         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00561"></a>00561         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[13]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00562"></a>00562         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[14]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00563"></a>00563         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[15]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00564"></a>00564         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[16]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00565"></a>00565         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[17]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00566"></a>00566 
<a name="l00567"></a>00567         <span class="keywordflow">return</span>;
<a name="l00568"></a>00568       }
<a name="l00569"></a>00569 
<a name="l00570"></a>00570     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1c81e8502e0dabbaa5ea9e87b53459bd">THIRTYSIXTH</a>:
<a name="l00571"></a>00571     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa24cbc0dd8da68e1efcf1873487f9904c">THIRTYSEVENTH</a>:
<a name="l00572"></a>00572       {
<a name="l00573"></a>00573         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (19);
<a name="l00574"></a>00574         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(19);
<a name="l00575"></a>00575 
<a name="l00576"></a>00576         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.9240684384358440318901767025326e-01L;
<a name="l00577"></a>00577         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.6020815213483003085277884068765e-01L;
<a name="l00578"></a>00578         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -9.0315590361481790164266092853231e-01L;
<a name="l00579"></a>00579         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -8.2271465653714282497892248671271e-01L;
<a name="l00580"></a>00580         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -7.2096617733522937861709586082378e-01L;
<a name="l00581"></a>00581         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -6.0054530466168102346963816494624e-01L;
<a name="l00582"></a>00582         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = -4.6457074137596094571726714810410e-01L;
<a name="l00583"></a>00583         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0) = -3.1656409996362983199011732884984e-01L;
<a name="l00584"></a>00584         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0) = -1.6035864564022537586809611574074e-01L;
<a name="l00585"></a>00585         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0) = 0.;
<a name="l00586"></a>00586         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10]    = -_points[8];
<a name="l00587"></a>00587         _points[11]    = -_points[7];
<a name="l00588"></a>00588         _points[12]    = -_points[6];
<a name="l00589"></a>00589         _points[13]    = -_points[5];
<a name="l00590"></a>00590         _points[14]    = -_points[4];
<a name="l00591"></a>00591         _points[15]    = -_points[3];
<a name="l00592"></a>00592         _points[16]    = -_points[2];
<a name="l00593"></a>00593         _points[17]    = -_points[1];
<a name="l00594"></a>00594         _points[18]    = -_points[0];
<a name="l00595"></a>00595 
<a name="l00596"></a>00596         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 1.9461788229726477036312041464438e-02L;
<a name="l00597"></a>00597         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 4.4814226765699600332838157401994e-02L;
<a name="l00598"></a>00598         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 6.9044542737641226580708258006013e-02L;
<a name="l00599"></a>00599         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 9.1490021622449999464462094123840e-02L;
<a name="l00600"></a>00600         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 1.1156664554733399471602390168177e-01L;
<a name="l00601"></a>00601         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 1.2875396253933622767551578485688e-01L;
<a name="l00602"></a>00602         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 1.4260670217360661177574610944190e-01L;
<a name="l00603"></a>00603         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = 1.5276604206585966677885540089766e-01L;
<a name="l00604"></a>00604         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = 1.5896884339395434764995643946505e-01L;
<a name="l00605"></a>00605         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = 1.6105444984878369597916362532092e-01L;
<a name="l00606"></a>00606         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[8];
<a name="l00607"></a>00607         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[7];
<a name="l00608"></a>00608         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[6];
<a name="l00609"></a>00609         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[13]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00610"></a>00610         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[14]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00611"></a>00611         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[15]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00612"></a>00612         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[16]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00613"></a>00613         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[17]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00614"></a>00614         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[18]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00615"></a>00615 
<a name="l00616"></a>00616         <span class="keywordflow">return</span>;
<a name="l00617"></a>00617       }
<a name="l00618"></a>00618 
<a name="l00619"></a>00619     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad7b5f8e152598d25c7c161f15221f5be">THIRTYEIGHTH</a>:
<a name="l00620"></a>00620     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7686c65f85c6e3ec25fb1ce492b41e2c">THIRTYNINTH</a>:
<a name="l00621"></a>00621       {
<a name="l00622"></a>00622         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (20);
<a name="l00623"></a>00623         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(20);
<a name="l00624"></a>00624 
<a name="l00625"></a>00625         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.9312859918509492478612238847132e-01L;
<a name="l00626"></a>00626         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.6397192727791379126766613119728e-01L;
<a name="l00627"></a>00627         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -9.1223442825132590586775244120330e-01L;
<a name="l00628"></a>00628         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -8.3911697182221882339452906170152e-01L;
<a name="l00629"></a>00629         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -7.4633190646015079261430507035564e-01L;
<a name="l00630"></a>00630         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -6.3605368072651502545283669622629e-01L;
<a name="l00631"></a>00631         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = -5.1086700195082709800436405095525e-01L;
<a name="l00632"></a>00632         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0) = -3.7370608871541956067254817702493e-01L;
<a name="l00633"></a>00633         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0) = -2.2778585114164507808049619536857e-01L;
<a name="l00634"></a>00634         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0) = -7.6526521133497333754640409398838e-02L;
<a name="l00635"></a>00635         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10]    = -_points[9];
<a name="l00636"></a>00636         _points[11]    = -_points[8];
<a name="l00637"></a>00637         _points[12]    = -_points[7];
<a name="l00638"></a>00638         _points[13]    = -_points[6];
<a name="l00639"></a>00639         _points[14]    = -_points[5];
<a name="l00640"></a>00640         _points[15]    = -_points[4];
<a name="l00641"></a>00641         _points[16]    = -_points[3];
<a name="l00642"></a>00642         _points[17]    = -_points[2];
<a name="l00643"></a>00643         _points[18]    = -_points[1];
<a name="l00644"></a>00644         _points[19]    = -_points[0];
<a name="l00645"></a>00645 
<a name="l00646"></a>00646         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 1.7614007139152118311861962351853e-02L;
<a name="l00647"></a>00647         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 4.0601429800386941331039952274932e-02L;
<a name="l00648"></a>00648         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 6.2672048334109063569506535187042e-02L;
<a name="l00649"></a>00649         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 8.3276741576704748724758143222046e-02L;
<a name="l00650"></a>00650         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 1.0193011981724043503675013548035e-01L;
<a name="l00651"></a>00651         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 1.1819453196151841731237737771138e-01L;
<a name="l00652"></a>00652         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 1.3168863844917662689849449974816e-01L;
<a name="l00653"></a>00653         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = 1.4209610931838205132929832506716e-01L;
<a name="l00654"></a>00654         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = 1.4917298647260374678782873700197e-01L;
<a name="l00655"></a>00655         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = 1.5275338713072585069808433195510e-01L;
<a name="l00656"></a>00656         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[9];
<a name="l00657"></a>00657         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[8];
<a name="l00658"></a>00658         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[7];
<a name="l00659"></a>00659         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[13]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[6];
<a name="l00660"></a>00660         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[14]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00661"></a>00661         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[15]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00662"></a>00662         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[16]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00663"></a>00663         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[17]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00664"></a>00664         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[18]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00665"></a>00665         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[19]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00666"></a>00666 
<a name="l00667"></a>00667         <span class="keywordflow">return</span>;
<a name="l00668"></a>00668       }
<a name="l00669"></a>00669 
<a name="l00670"></a>00670     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa0b2b50be416b002ce458061fe2d7506a">FORTIETH</a>:
<a name="l00671"></a>00671     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faae7b8a6cf8f301aa024087e7f371a81c">FORTYFIRST</a>:
<a name="l00672"></a>00672       {
<a name="l00673"></a>00673         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (21);
<a name="l00674"></a>00674         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(21);
<a name="l00675"></a>00675 
<a name="l00676"></a>00676         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.9375217062038950026024203593794e-01L;
<a name="l00677"></a>00677         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.6722683856630629431662221490770e-01L;
<a name="l00678"></a>00678         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -9.2009933415040082879018713371497e-01L;
<a name="l00679"></a>00679         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -8.5336336458331728364725063858757e-01L;
<a name="l00680"></a>00680         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -7.6843996347567790861587785130623e-01L;
<a name="l00681"></a>00681         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -6.6713880419741231930596666999034e-01L;
<a name="l00682"></a>00682         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = -5.5161883588721980705901879672431e-01L;
<a name="l00683"></a>00683         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0) = -4.2434212020743878357366888854379e-01L;
<a name="l00684"></a>00684         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0) = -2.8802131680240109660079251606460e-01L;
<a name="l00685"></a>00685         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0) = -1.4556185416089509093703098233869e-01L;
<a name="l00686"></a>00686         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0) = 0.;
<a name="l00687"></a>00687         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11]    = -_points[9];
<a name="l00688"></a>00688         _points[12]    = -_points[8];
<a name="l00689"></a>00689         _points[13]    = -_points[7];
<a name="l00690"></a>00690         _points[14]    = -_points[6];
<a name="l00691"></a>00691         _points[15]    = -_points[5];
<a name="l00692"></a>00692         _points[16]    = -_points[4];
<a name="l00693"></a>00693         _points[17]    = -_points[3];
<a name="l00694"></a>00694         _points[18]    = -_points[2];
<a name="l00695"></a>00695         _points[19]    = -_points[1];
<a name="l00696"></a>00696         _points[20]    = -_points[0];
<a name="l00697"></a>00697 
<a name="l00698"></a>00698         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 1.6017228257774333324224616858471e-02L;
<a name="l00699"></a>00699         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 3.6953789770852493799950668299330e-02L;
<a name="l00700"></a>00700         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 5.7134425426857208283635826472448e-02L;
<a name="l00701"></a>00701         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 7.6100113628379302017051653300183e-02L;
<a name="l00702"></a>00702         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 9.3444423456033861553289741113932e-02L;
<a name="l00703"></a>00703         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 1.0879729916714837766347457807011e-01L;
<a name="l00704"></a>00704         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 1.2183141605372853419536717712572e-01L;
<a name="l00705"></a>00705         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = 1.3226893863333746178105257449678e-01L;
<a name="l00706"></a>00706         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = 1.3988739479107315472213342386758e-01L;
<a name="l00707"></a>00707         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = 1.4452440398997005906382716655375e-01L;
<a name="l00708"></a>00708         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = 1.4608113364969042719198514768337e-01L;
<a name="l00709"></a>00709         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[9];
<a name="l00710"></a>00710         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[8];
<a name="l00711"></a>00711         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[13]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[7];
<a name="l00712"></a>00712         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[14]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[6];
<a name="l00713"></a>00713         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[15]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00714"></a>00714         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[16]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00715"></a>00715         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[17]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00716"></a>00716         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[18]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00717"></a>00717         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[19]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00718"></a>00718         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[20]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00719"></a>00719 
<a name="l00720"></a>00720         <span class="keywordflow">return</span>;
<a name="l00721"></a>00721       }
<a name="l00722"></a>00722 
<a name="l00723"></a>00723     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faf1ea9fc7d47660c23ff7ff4c0ffae985">FORTYSECOND</a>:
<a name="l00724"></a>00724     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5536e362ffba6fc36737d12d56016794">FORTYTHIRD</a>:
<a name="l00725"></a>00725       {
<a name="l00726"></a>00726         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (22);
<a name="l00727"></a>00727         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(22);
<a name="l00728"></a>00728 
<a name="l00729"></a>00729         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 0](0) = -9.9429458548239929207303142116130e-01L;
<a name="l00730"></a>00730         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 1](0) = -9.7006049783542872712395098676527e-01L;
<a name="l00731"></a>00731         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 2](0) = -9.2695677218717400052069293925905e-01L;
<a name="l00732"></a>00732         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 3](0) = -8.6581257772030013653642563701938e-01L;
<a name="l00733"></a>00733         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 4](0) = -7.8781680597920816200427795540835e-01L;
<a name="l00734"></a>00734         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 5](0) = -6.9448726318668278005068983576226e-01L;
<a name="l00735"></a>00735         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 6](0) = -5.8764040350691159295887692763865e-01L;
<a name="l00736"></a>00736         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 7](0) = -4.6935583798675702640633071096641e-01L;
<a name="l00737"></a>00737         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 8](0) = -3.4193582089208422515814742042738e-01L;
<a name="l00738"></a>00738         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[ 9](0) = -2.0786042668822128547884653391955e-01L;
<a name="l00739"></a>00739         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[10](0) = -6.9739273319722221213841796118628e-02L;
<a name="l00740"></a>00740         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[11]    = -_points[10];
<a name="l00741"></a>00741         _points[12]    = -_points[9];
<a name="l00742"></a>00742         _points[13]    = -_points[8];
<a name="l00743"></a>00743         _points[14]    = -_points[7];
<a name="l00744"></a>00744         _points[15]    = -_points[6];
<a name="l00745"></a>00745         _points[16]    = -_points[5];
<a name="l00746"></a>00746         _points[17]    = -_points[4];
<a name="l00747"></a>00747         _points[18]    = -_points[3];
<a name="l00748"></a>00748         _points[19]    = -_points[2];
<a name="l00749"></a>00749         _points[20]    = -_points[1];
<a name="l00750"></a>00750         _points[21]    = -_points[0];
<a name="l00751"></a>00751 
<a name="l00752"></a>00752         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 0]   = 1.4627995298272200684991098047185e-02L;
<a name="l00753"></a>00753         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 1]   = 3.3774901584814154793302246865913e-02L;
<a name="l00754"></a>00754         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 2]   = 5.2293335152683285940312051273211e-02L;
<a name="l00755"></a>00755         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 3]   = 6.9796468424520488094961418930218e-02L;
<a name="l00756"></a>00756         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 4]   = 8.5941606217067727414443681372703e-02L;
<a name="l00757"></a>00757         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 5]   = 1.0041414444288096493207883783054e-01L;
<a name="l00758"></a>00758         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 6]   = 1.1293229608053921839340060742175e-01L;
<a name="l00759"></a>00759         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 7]   = 1.2325237681051242428556098615481e-01L;
<a name="l00760"></a>00760         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 8]   = 1.3117350478706237073296499253031e-01L;
<a name="l00761"></a>00761         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[ 9]   = 1.3654149834601517135257383123152e-01L;
<a name="l00762"></a>00762         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10]   = 1.3925187285563199337541024834181e-01L;
<a name="l00763"></a>00763         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[11]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[10];
<a name="l00764"></a>00764         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[12]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[9];
<a name="l00765"></a>00765         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[13]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[8];
<a name="l00766"></a>00766         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[14]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[7];
<a name="l00767"></a>00767         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[15]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[6];
<a name="l00768"></a>00768         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[16]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[5];
<a name="l00769"></a>00769         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[17]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[4];
<a name="l00770"></a>00770         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[18]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[3];
<a name="l00771"></a>00771         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[19]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[2];
<a name="l00772"></a>00772         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[20]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[1];
<a name="l00773"></a>00773         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[21]   = <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0];
<a name="l00774"></a>00774 
<a name="l00775"></a>00775         <span class="keywordflow">return</span>;
<a name="l00776"></a>00776       }
<a name="l00777"></a>00777 
<a name="l00778"></a>00778 
<a name="l00779"></a>00779     <span class="keywordflow">default</span>:
<a name="l00780"></a>00780       {
<a name="l00781"></a>00781         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Quadrature rule &quot;</span> &lt;&lt; _order
<a name="l00782"></a>00782                       &lt;&lt; <span class="stringliteral">&quot; not supported!&quot;</span> &lt;&lt; std::endl;
<a name="l00783"></a>00783               
<a name="l00784"></a>00784         libmesh_error();
<a name="l00785"></a>00785       }
<a name="l00786"></a>00786     }
<a name="l00787"></a>00787 
<a name="l00788"></a>00788 
<a name="l00789"></a>00789 
<a name="l00790"></a>00790   <span class="keywordflow">return</span>;
<a name="l00791"></a>00791 }
<a name="l00792"></a>00792 
<a name="l00793"></a>00793 } <span class="comment">// namespace libMesh</span>
<a name="l00794"></a>00794  
<a name="l00795"></a>00795 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
