<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_gauss_2D.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__gauss__2D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_gauss_2D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__conical_8h.php">quadrature_conical.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="classlibMesh_1_1QGauss.php#a7cb63d8c954fe08ddd209d44a92b5dac">00030</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QGauss.php#a7cb63d8c954fe08ddd209d44a92b5dac">QGauss::init_2D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type,
<a name="l00031"></a>00031                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 <span class="preprocessor">#if LIBMESH_DIM &gt; 1</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>  
<a name="l00035"></a>00035   <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00036"></a>00036   <span class="comment">// 2D quadrature rules</span>
<a name="l00037"></a>00037   <span class="keywordflow">switch</span> (_type)
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039 
<a name="l00040"></a>00040 
<a name="l00041"></a>00041       <span class="comment">//---------------------------------------------</span>
<a name="l00042"></a>00042       <span class="comment">// Quadrilateral quadrature rules</span>
<a name="l00043"></a>00043     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00044"></a>00044     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00045"></a>00045     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00046"></a>00046       {
<a name="l00047"></a>00047         <span class="comment">// We compute the 2D quadrature rule as a tensor</span>
<a name="l00048"></a>00048         <span class="comment">// product of the 1D quadrature rule.</span>
<a name="l00049"></a>00049         <span class="comment">//</span>
<a name="l00050"></a>00050         <span class="comment">// For QUADs, a quadrature rule of order &#39;p&#39; must be able to integrate</span>
<a name="l00051"></a>00051         <span class="comment">// bilinear (p=1), biquadratic (p=2), bicubic (p=3), etc. polynomials of the form</span>
<a name="l00052"></a>00052         <span class="comment">//</span>
<a name="l00053"></a>00053         <span class="comment">// (x^p + x^{p-1} + ... + 1) * (y^p + y^{p-1} + ... + 1)</span>
<a name="l00054"></a>00054         <span class="comment">//</span>
<a name="l00055"></a>00055         <span class="comment">// These polynomials have terms *up to* degree 2p but they are *not* complete</span>
<a name="l00056"></a>00056         <span class="comment">// polynomials of degree 2p. For example, when p=2 we have</span>
<a name="l00057"></a>00057         <span class="comment">//        1</span>
<a name="l00058"></a>00058         <span class="comment">//     x      y</span>
<a name="l00059"></a>00059         <span class="comment">// x^2    xy     y^2</span>
<a name="l00060"></a>00060         <span class="comment">//    yx^2   xy^2</span>
<a name="l00061"></a>00061         <span class="comment">//       x^2y^2</span>
<a name="l00062"></a>00062         <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> q1D(1,_order);
<a name="l00063"></a>00063         q1D.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>,p);
<a name="l00064"></a>00064         tensor_product_quad( q1D );
<a name="l00065"></a>00065         <span class="keywordflow">return</span>;
<a name="l00066"></a>00066       }
<a name="l00067"></a>00067 
<a name="l00068"></a>00068             
<a name="l00069"></a>00069       <span class="comment">//---------------------------------------------</span>
<a name="l00070"></a>00070       <span class="comment">// Triangle quadrature rules</span>
<a name="l00071"></a>00071     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>:
<a name="l00072"></a>00072     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adf1c74e0d29cadce230d1d485e5c5aba">TRI6</a>:
<a name="l00073"></a>00073       {
<a name="l00074"></a>00074         <span class="keywordflow">switch</span>(_order + 2*p)
<a name="l00075"></a>00075           {
<a name="l00076"></a>00076           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>:
<a name="l00077"></a>00077           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00078"></a>00078             {
<a name="l00079"></a>00079               <span class="comment">// Exact for linears</span>
<a name="l00080"></a>00080               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(1);
<a name="l00081"></a>00081               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(1);
<a name="l00082"></a>00082                   
<a name="l00083"></a>00083               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0) = 1.0L/3.0L;
<a name="l00084"></a>00084               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](1) = 1.0L/3.0L;
<a name="l00085"></a>00085 
<a name="l00086"></a>00086               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0] = 0.5;
<a name="l00087"></a>00087 
<a name="l00088"></a>00088               <span class="keywordflow">return</span>;
<a name="l00089"></a>00089             }
<a name="l00090"></a>00090           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00091"></a>00091             {
<a name="l00092"></a>00092               <span class="comment">// Exact for quadratics</span>
<a name="l00093"></a>00093               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(3);
<a name="l00094"></a>00094               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(3);
<a name="l00095"></a>00095 
<a name="l00096"></a>00096               <span class="comment">// Alternate rule with points on ref. elt. boundaries.</span>
<a name="l00097"></a>00097               <span class="comment">// Not ideal for problems with material coefficient discontinuities</span>
<a name="l00098"></a>00098               <span class="comment">// aligned along element boundaries.</span>
<a name="l00099"></a>00099               <span class="comment">// _points[0](0) = .5;</span>
<a name="l00100"></a>00100               <span class="comment">// _points[0](1) = .5;</span>
<a name="l00101"></a>00101               <span class="comment">// _points[1](0) = 0.;</span>
<a name="l00102"></a>00102               <span class="comment">// _points[1](1) = .5;</span>
<a name="l00103"></a>00103               <span class="comment">// _points[2](0) = .5;</span>
<a name="l00104"></a>00104               <span class="comment">// _points[2](1) = .0;</span>
<a name="l00105"></a>00105               
<a name="l00106"></a>00106               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0) = 2.0L/3.0L;
<a name="l00107"></a>00107               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](1) = 1.0L/6.0L;
<a name="l00108"></a>00108 
<a name="l00109"></a>00109               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](0) = 1.0L/6.0L;
<a name="l00110"></a>00110               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](1) = 2.0L/3.0L;
<a name="l00111"></a>00111 
<a name="l00112"></a>00112               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](0) = 1.0L/6.0L;
<a name="l00113"></a>00113               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](1) = 1.0L/6.0L;
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0] = 1.0L/6.0L;
<a name="l00117"></a>00117               _weights[1] = 1.0L/6.0L;
<a name="l00118"></a>00118               _weights[2] = 1.0L/6.0L;
<a name="l00119"></a>00119 
<a name="l00120"></a>00120               <span class="keywordflow">return</span>;
<a name="l00121"></a>00121             }
<a name="l00122"></a>00122           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00123"></a>00123             {
<a name="l00124"></a>00124               <span class="comment">// Exact for cubics</span>
<a name="l00125"></a>00125               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(4);
<a name="l00126"></a>00126               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(4);
<a name="l00127"></a>00127 
<a name="l00128"></a>00128               <span class="comment">// This rule is formed from a tensor product of</span>
<a name="l00129"></a>00129               <span class="comment">// appropriately-scaled Gauss and Jacobi rules.  (See</span>
<a name="l00130"></a>00130               <span class="comment">// also the QConical quadrature class, this is a</span>
<a name="l00131"></a>00131               <span class="comment">// hard-coded version of one of those rules.)  For high</span>
<a name="l00132"></a>00132               <span class="comment">// orders these rules generally have too many points,</span>
<a name="l00133"></a>00133               <span class="comment">// but at extremely low order they are competitive and</span>
<a name="l00134"></a>00134               <span class="comment">// have the additional benefit of having all positive</span>
<a name="l00135"></a>00135               <span class="comment">// weights.</span>
<a name="l00136"></a>00136               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0) = 1.5505102572168219018027159252941e-01L;
<a name="l00137"></a>00137               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](1) = 1.7855872826361642311703513337422e-01L;
<a name="l00138"></a>00138               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](0) = 6.4494897427831780981972840747059e-01L;
<a name="l00139"></a>00139               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](1) = 7.5031110222608118177475598324603e-02L;
<a name="l00140"></a>00140               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](0) = 1.5505102572168219018027159252941e-01L;
<a name="l00141"></a>00141               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](1) = 6.6639024601470138670269327409637e-01L;
<a name="l00142"></a>00142               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](0) = 6.4494897427831780981972840747059e-01L;
<a name="l00143"></a>00143               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](1) = 2.8001991549907407200279599420481e-01L;
<a name="l00144"></a>00144 
<a name="l00145"></a>00145               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0] = 1.5902069087198858469718450103758e-01L;
<a name="l00146"></a>00146               _weights[1] = 9.0979309128011415302815498962418e-02L;
<a name="l00147"></a>00147               _weights[2] = 1.5902069087198858469718450103758e-01L;
<a name="l00148"></a>00148               _weights[3] = 9.0979309128011415302815498962418e-02L;
<a name="l00149"></a>00149 
<a name="l00150"></a>00150               <span class="keywordflow">return</span>;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152               
<a name="l00153"></a>00153               <span class="comment">// The following third-order rule is quite commonly cited</span>
<a name="l00154"></a>00154               <span class="comment">// in the literature and most likely works fine.  However,</span>
<a name="l00155"></a>00155               <span class="comment">// we generally prefer a rule with all positive weights</span>
<a name="l00156"></a>00156               <span class="comment">// and an equal number of points, when available.</span>
<a name="l00157"></a>00157               <span class="comment">//</span>
<a name="l00158"></a>00158               <span class="comment">//  (allow_rules_with_negative_weights)</span>
<a name="l00159"></a>00159               <span class="comment">// {</span>
<a name="l00160"></a>00160               <span class="comment">//   // Exact for cubics</span>
<a name="l00161"></a>00161               <span class="comment">//   _points.resize(4);</span>
<a name="l00162"></a>00162               <span class="comment">//   _weights.resize(4);</span>
<a name="l00163"></a>00163               <span class="comment">//   </span>
<a name="l00164"></a>00164               <span class="comment">//   _points[0](0) = .33333333333333333333333333333333;</span>
<a name="l00165"></a>00165               <span class="comment">//   _points[0](1) = .33333333333333333333333333333333;</span>
<a name="l00166"></a>00166               <span class="comment">// </span>
<a name="l00167"></a>00167               <span class="comment">//   _points[1](0) = .2;</span>
<a name="l00168"></a>00168               <span class="comment">//   _points[1](1) = .6;</span>
<a name="l00169"></a>00169               <span class="comment">// </span>
<a name="l00170"></a>00170               <span class="comment">//   _points[2](0) = .2;</span>
<a name="l00171"></a>00171               <span class="comment">//   _points[2](1) = .2;</span>
<a name="l00172"></a>00172               <span class="comment">// </span>
<a name="l00173"></a>00173               <span class="comment">//   _points[3](0) = .6;</span>
<a name="l00174"></a>00174               <span class="comment">//   _points[3](1) = .2;</span>
<a name="l00175"></a>00175               <span class="comment">// </span>
<a name="l00176"></a>00176               <span class="comment">// </span>
<a name="l00177"></a>00177               <span class="comment">//   _weights[0] = -27./96.;</span>
<a name="l00178"></a>00178               <span class="comment">//   _weights[1] =  25./96.;</span>
<a name="l00179"></a>00179               <span class="comment">//   _weights[2] =  25./96.;</span>
<a name="l00180"></a>00180               <span class="comment">//   _weights[3] =  25./96.;</span>
<a name="l00181"></a>00181               <span class="comment">// </span>
<a name="l00182"></a>00182               <span class="comment">//   return;</span>
<a name="l00183"></a>00183               <span class="comment">// } // end if (allow_rules_with_negative_weights)</span>
<a name="l00184"></a>00184               <span class="comment">// Note: if !allow_rules_with_negative_weights, fall through to next case.</span>
<a name="l00185"></a>00185             }
<a name="l00186"></a>00186 
<a name="l00187"></a>00187 
<a name="l00188"></a>00188             
<a name="l00189"></a>00189             <span class="comment">// A degree 4 rule with six points.  This rule can be found in many places</span>
<a name="l00190"></a>00190             <span class="comment">// including:</span>
<a name="l00191"></a>00191             <span class="comment">//</span>
<a name="l00192"></a>00192             <span class="comment">// J.N. Lyness and D. Jespersen, Moderate degree symmetric</span>
<a name="l00193"></a>00193             <span class="comment">// quadrature rules for the triangle, J. Inst. Math. Appl.  15 (1975),</span>
<a name="l00194"></a>00194             <span class="comment">// 19--32.</span>
<a name="l00195"></a>00195             <span class="comment">//</span>
<a name="l00196"></a>00196             <span class="comment">// We used the code in: </span>
<a name="l00197"></a>00197             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00198"></a>00198             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00199"></a>00199             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00200"></a>00200             <span class="comment">// to generate additional precision.</span>
<a name="l00201"></a>00201           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00202"></a>00202             {
<a name="l00203"></a>00203               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 2;
<a name="l00204"></a>00204               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00205"></a>00205                 {
<a name="l00206"></a>00206                   1.1169079483900573284750350421656140e-01L,
<a name="l00207"></a>00207                   5.4975871827660933819163162450105264e-02L
<a name="l00208"></a>00208                 };
<a name="l00209"></a>00209 
<a name="l00210"></a>00210               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00211"></a>00211                 {
<a name="l00212"></a>00212                   4.4594849091596488631832925388305199e-01L,
<a name="l00213"></a>00213                   9.1576213509770743459571463402201508e-02L
<a name="l00214"></a>00214                 };
<a name="l00215"></a>00215 
<a name="l00216"></a>00216               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] = {0., 0.}; <span class="comment">// not used</span>
<a name="l00217"></a>00217               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts] = {3, 3};
<a name="l00218"></a>00218 
<a name="l00219"></a>00219               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts); <span class="comment">// 6 total points</span>
<a name="l00220"></a>00220               
<a name="l00221"></a>00221               <span class="keywordflow">return</span>;
<a name="l00222"></a>00222             }
<a name="l00223"></a>00223 
<a name="l00224"></a>00224 
<a name="l00225"></a>00225             
<a name="l00226"></a>00226             <span class="comment">// Exact for quintics</span>
<a name="l00227"></a>00227             <span class="comment">// Can be found in &quot;Quadrature on Simplices of Arbitrary</span>
<a name="l00228"></a>00228             <span class="comment">// Dimension&quot; by Walkington.</span>
<a name="l00229"></a>00229           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00230"></a>00230             {
<a name="l00231"></a>00231               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 3;
<a name="l00232"></a>00232               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00233"></a>00233                 {
<a name="l00234"></a>00234                   9.0L/80.0L,
<a name="l00235"></a>00235                   31.0L/480.0L + std::sqrt(15.0L)/2400.0L,
<a name="l00236"></a>00236                   31.0L/480.0L - std::sqrt(15.0L)/2400.0L
<a name="l00237"></a>00237                 };
<a name="l00238"></a>00238 
<a name="l00239"></a>00239               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00240"></a>00240                 {
<a name="l00241"></a>00241                   0., <span class="comment">// &#39;a&#39; parameter not used for origin permutation</span>
<a name="l00242"></a>00242                   2.0L/7.0L + std::sqrt(15.0L)/21.0L,
<a name="l00243"></a>00243                   2.0L/7.0L - std::sqrt(15.0L)/21.0L
<a name="l00244"></a>00244                 };
<a name="l00245"></a>00245 
<a name="l00246"></a>00246               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] = {0., 0., 0.}; <span class="comment">// not used</span>
<a name="l00247"></a>00247               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts] = {1, 3, 3};
<a name="l00248"></a>00248 
<a name="l00249"></a>00249               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts); <span class="comment">// 6 total points</span>
<a name="l00250"></a>00250 
<a name="l00251"></a>00251               <span class="keywordflow">return</span>;
<a name="l00252"></a>00252             }
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 
<a name="l00255"></a>00255             
<a name="l00256"></a>00256             <span class="comment">// A degree 6 rule with 12 points.  This rule can be found in many places</span>
<a name="l00257"></a>00257             <span class="comment">// including:</span>
<a name="l00258"></a>00258             <span class="comment">//</span>
<a name="l00259"></a>00259             <span class="comment">// J.N. Lyness and D. Jespersen, Moderate degree symmetric</span>
<a name="l00260"></a>00260             <span class="comment">// quadrature rules for the triangle, J. Inst. Math. Appl.  15 (1975),</span>
<a name="l00261"></a>00261             <span class="comment">// 19--32.</span>
<a name="l00262"></a>00262             <span class="comment">//</span>
<a name="l00263"></a>00263             <span class="comment">// We used the code in: </span>
<a name="l00264"></a>00264             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00265"></a>00265             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00266"></a>00266             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00267"></a>00267             <span class="comment">// to generate additional precision.</span>
<a name="l00268"></a>00268             <span class="comment">//</span>
<a name="l00269"></a>00269             <span class="comment">// Note that the following 7th-order Ro3-invariant rule also has only 12 points,</span>
<a name="l00270"></a>00270             <span class="comment">// which technically makes it the superior rule.  This one is here for completeness.</span>
<a name="l00271"></a>00271           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00272"></a>00272             {
<a name="l00273"></a>00273               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 3;
<a name="l00274"></a>00274               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00275"></a>00275                 {
<a name="l00276"></a>00276                   5.8393137863189683012644805692789721e-02L,
<a name="l00277"></a>00277                   2.5422453185103408460468404553434492e-02L,
<a name="l00278"></a>00278                   4.1425537809186787596776728210221227e-02L
<a name="l00279"></a>00279                 };
<a name="l00280"></a>00280 
<a name="l00281"></a>00281               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00282"></a>00282                 {
<a name="l00283"></a>00283                   2.4928674517091042129163855310701908e-01L,
<a name="l00284"></a>00284                   6.3089014491502228340331602870819157e-02L,
<a name="l00285"></a>00285                   3.1035245103378440541660773395655215e-01L
<a name="l00286"></a>00286                 };
<a name="l00287"></a>00287 
<a name="l00288"></a>00288               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00289"></a>00289                 {
<a name="l00290"></a>00290                   0.,
<a name="l00291"></a>00291                   0.,
<a name="l00292"></a>00292                   6.3650249912139864723014259441204970e-01L               
<a name="l00293"></a>00293                 };
<a name="l00294"></a>00294               
<a name="l00295"></a>00295               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts] = {3, 3, 6}; <span class="comment">// 12 total points</span>
<a name="l00296"></a>00296 
<a name="l00297"></a>00297               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00298"></a>00298 
<a name="l00299"></a>00299               <span class="keywordflow">return</span>;
<a name="l00300"></a>00300             }
<a name="l00301"></a>00301             
<a name="l00302"></a>00302             
<a name="l00303"></a>00303             <span class="comment">// A degree 7 rule with 12 points.  This rule can be found in:</span>
<a name="l00304"></a>00304             <span class="comment">//</span>
<a name="l00305"></a>00305             <span class="comment">// K. Gatermann, The construction of symmetric cubature</span>
<a name="l00306"></a>00306             <span class="comment">// formulas for the square and the triangle, Computing 40</span>
<a name="l00307"></a>00307             <span class="comment">// (1988), 229--240.</span>
<a name="l00308"></a>00308             <span class="comment">//</span>
<a name="l00309"></a>00309             <span class="comment">// This rule, which is provably minimal in the number of</span>
<a name="l00310"></a>00310             <span class="comment">// integration points, is said to be &#39;Ro3 invariant&#39; which</span>
<a name="l00311"></a>00311             <span class="comment">// means that a given set of barycentric coordinates</span>
<a name="l00312"></a>00312             <span class="comment">// (z1,z2,z3) implies the quadrature points (z1,z2),</span>
<a name="l00313"></a>00313             <span class="comment">// (z3,z1), (z2,z3) which are formed by taking the first</span>
<a name="l00314"></a>00314             <span class="comment">// two entries in cyclic permutations of the barycentric</span>
<a name="l00315"></a>00315             <span class="comment">// point.  Barycentric coordinates are related in the</span>
<a name="l00316"></a>00316             <span class="comment">// sense that: z3 = 1 - z1 - z2.</span>
<a name="l00317"></a>00317             <span class="comment">//</span>
<a name="l00318"></a>00318             <span class="comment">// The 12-point sixth-order rule for triangles given in</span>
<a name="l00319"></a>00319             <span class="comment">// Flaherty&#39;s (http://www.cs.rpi.edu/~flaherje/FEM/fem6.ps)</span>
<a name="l00320"></a>00320             <span class="comment">// lecture notes has been removed in favor of this rule</span>
<a name="l00321"></a>00321             <span class="comment">// which is higher-order (for the same number of</span>
<a name="l00322"></a>00322             <span class="comment">// quadrature points) and has a few more digits of</span>
<a name="l00323"></a>00323             <span class="comment">// precision in the points and weights.  Some 10-point</span>
<a name="l00324"></a>00324             <span class="comment">// degree 6 rules exist for the triangle but they have</span>
<a name="l00325"></a>00325             <span class="comment">// quadrature points outside the region of integration.</span>
<a name="l00326"></a>00326           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00327"></a>00327             {
<a name="l00328"></a>00328               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (12);
<a name="l00329"></a>00329               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(12);
<a name="l00330"></a>00330               
<a name="l00331"></a>00331               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> nrows=4;
<a name="l00332"></a>00332               
<a name="l00333"></a>00333               <span class="comment">// In each of the rows below, the first two entries are (z1, z2) which imply</span>
<a name="l00334"></a>00334               <span class="comment">// z3.  The third entry is the weight for each of the points in the cyclic permutation.</span>
<a name="l00335"></a>00335               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p[nrows][3] = {
<a name="l00336"></a>00336                 {6.2382265094402118e-02, 6.7517867073916085e-02, 2.6517028157436251e-02}, <span class="comment">// group A</span>
<a name="l00337"></a>00337                 {5.5225456656926611e-02, 3.2150249385198182e-01, 4.3881408714446055e-02}, <span class="comment">// group B</span>
<a name="l00338"></a>00338                 {3.4324302945097146e-02, 6.6094919618673565e-01, 2.8775042784981585e-02}, <span class="comment">// group C</span>
<a name="l00339"></a>00339                 {5.1584233435359177e-01, 2.7771616697639178e-01, 6.7493187009802774e-02}  <span class="comment">// group D</span>
<a name="l00340"></a>00340               };
<a name="l00341"></a>00341 
<a name="l00342"></a>00342               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0, offset=0; i&lt;nrows; ++i)
<a name="l00343"></a>00343                 {
<a name="l00344"></a>00344                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 0] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p[i][0],            p[i][1]); <span class="comment">// (z1,z2)</span>
<a name="l00345"></a>00345                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 1] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(1.-p[i][0]-p[i][1], p[i][0]); <span class="comment">// (z3,z1)</span>
<a name="l00346"></a>00346                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 2] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(p[i][1], 1.-p[i][0]-p[i][1]); <span class="comment">// (z2,z3)</span>
<a name="l00347"></a>00347 
<a name="l00348"></a>00348                   <span class="comment">// All these points get the same weight</span>
<a name="l00349"></a>00349                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[offset + 0] = p[i][2];
<a name="l00350"></a>00350                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[offset + 1] = p[i][2];
<a name="l00351"></a>00351                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[offset + 2] = p[i][2];
<a name="l00352"></a>00352 
<a name="l00353"></a>00353                   <span class="comment">// Increment offset</span>
<a name="l00354"></a>00354                   offset += 3;
<a name="l00355"></a>00355                 }
<a name="l00356"></a>00356 
<a name="l00357"></a>00357               <span class="keywordflow">return</span>;
<a name="l00358"></a>00358 
<a name="l00359"></a>00359               
<a name="l00360"></a>00360 <span class="comment">//            // The following is an inferior 7th-order Lyness-style rule with 15 points.</span>
<a name="l00361"></a>00361 <span class="comment">//            // It&#39;s here only for completeness and the Ro3-invariant rule above should</span>
<a name="l00362"></a>00362 <span class="comment">//            // be used instead!</span>
<a name="l00363"></a>00363 <span class="comment">//            const unsigned int n_wts = 3;</span>
<a name="l00364"></a>00364 <span class="comment">//            const Real wts[n_wts] =</span>
<a name="l00365"></a>00365 <span class="comment">//              {</span>
<a name="l00366"></a>00366 <span class="comment">//                2.6538900895116205835977487499847719e-02L,</span>
<a name="l00367"></a>00367 <span class="comment">//                3.5426541846066783659206291623201826e-02L,</span>
<a name="l00368"></a>00368 <span class="comment">//                3.4637341039708446756138297960207647e-02L</span>
<a name="l00369"></a>00369 <span class="comment">//              };</span>
<a name="l00370"></a>00370 <span class="comment">// </span>
<a name="l00371"></a>00371 <span class="comment">//            const Real a[n_wts] =</span>
<a name="l00372"></a>00372 <span class="comment">//              {</span>
<a name="l00373"></a>00373 <span class="comment">//                6.4930513159164863078379776030396538e-02L,</span>
<a name="l00374"></a>00374 <span class="comment">//                2.8457558424917033519741605734978046e-01L,</span>
<a name="l00375"></a>00375 <span class="comment">//                3.1355918438493150795585190219862865e-01L</span>
<a name="l00376"></a>00376 <span class="comment">//              };</span>
<a name="l00377"></a>00377 <span class="comment">// </span>
<a name="l00378"></a>00378 <span class="comment">//            const Real b[n_wts] =</span>
<a name="l00379"></a>00379 <span class="comment">//              {</span>
<a name="l00380"></a>00380 <span class="comment">//                0.,</span>
<a name="l00381"></a>00381 <span class="comment">//                1.9838447668150671917987659863332941e-01L,</span>
<a name="l00382"></a>00382 <span class="comment">//                4.3863471792372471511798695971295936e-02L               </span>
<a name="l00383"></a>00383 <span class="comment">//              };</span>
<a name="l00384"></a>00384 <span class="comment">//            </span>
<a name="l00385"></a>00385 <span class="comment">//            const unsigned int permutation_ids[n_wts] = {3, 6, 6}; // 15 total points</span>
<a name="l00386"></a>00386 <span class="comment">// </span>
<a name="l00387"></a>00387 <span class="comment">//            dunavant_rule2(wts, a, b, permutation_ids, n_wts);</span>
<a name="l00388"></a>00388 <span class="comment">// </span>
<a name="l00389"></a>00389 <span class="comment">//            return;</span>
<a name="l00390"></a>00390             }
<a name="l00391"></a>00391 
<a name="l00392"></a>00392 
<a name="l00393"></a>00393 
<a name="l00394"></a>00394             
<a name="l00395"></a>00395             <span class="comment">// Another Dunavant rule.  This one has all positive weights.  This rule has</span>
<a name="l00396"></a>00396             <span class="comment">// 16 points while a comparable conical product rule would have 5*5=25.</span>
<a name="l00397"></a>00397             <span class="comment">//</span>
<a name="l00398"></a>00398             <span class="comment">// It was copied 23rd June 2008 from:</span>
<a name="l00399"></a>00399             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/dunavant/dunavant.f90</span>
<a name="l00400"></a>00400             <span class="comment">//</span>
<a name="l00401"></a>00401             <span class="comment">// Additional precision obtained from the code in:</span>
<a name="l00402"></a>00402             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00403"></a>00403             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00404"></a>00404             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00405"></a>00405           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>:
<a name="l00406"></a>00406             {
<a name="l00407"></a>00407               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 5;
<a name="l00408"></a>00408               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00409"></a>00409                 {
<a name="l00410"></a>00410                   7.2157803838893584125545555244532310e-02L,
<a name="l00411"></a>00411                   4.7545817133642312396948052194292159e-02L,
<a name="l00412"></a>00412                   5.1608685267359125140895775146064515e-02L,
<a name="l00413"></a>00413                   1.6229248811599040155462964170890299e-02L,
<a name="l00414"></a>00414                   1.3615157087217497132422345036954462e-02L
<a name="l00415"></a>00415                 };
<a name="l00416"></a>00416 
<a name="l00417"></a>00417               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00418"></a>00418                 {
<a name="l00419"></a>00419                   0.0, <span class="comment">// &#39;a&#39; parameter not used for origin permutation</span>
<a name="l00420"></a>00420                   4.5929258829272315602881551449416932e-01L,
<a name="l00421"></a>00421                   1.7056930775176020662229350149146450e-01L,
<a name="l00422"></a>00422                   5.0547228317030975458423550596598947e-02L,
<a name="l00423"></a>00423                   2.6311282963463811342178578628464359e-01L,
<a name="l00424"></a>00424                 };
<a name="l00425"></a>00425 
<a name="l00426"></a>00426               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00427"></a>00427                 {
<a name="l00428"></a>00428                   0.,
<a name="l00429"></a>00429                   0.,
<a name="l00430"></a>00430                   0.,
<a name="l00431"></a>00431                   0.,
<a name="l00432"></a>00432                   7.2849239295540428124100037917606196e-01L
<a name="l00433"></a>00433                 };
<a name="l00434"></a>00434               
<a name="l00435"></a>00435               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts] = {1, 3, 3, 3, 6}; <span class="comment">// 16 total points</span>
<a name="l00436"></a>00436 
<a name="l00437"></a>00437               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00438"></a>00438 
<a name="l00439"></a>00439               <span class="keywordflow">return</span>;
<a name="l00440"></a>00440             }
<a name="l00441"></a>00441 
<a name="l00442"></a>00442 
<a name="l00443"></a>00443             
<a name="l00444"></a>00444             <span class="comment">// Another Dunavant rule.  This one has all positive weights.  This rule has 19</span>
<a name="l00445"></a>00445             <span class="comment">// points. The comparable conical product rule would have 25.</span>
<a name="l00446"></a>00446             <span class="comment">// It was copied 23rd June 2008 from:</span>
<a name="l00447"></a>00447             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/dunavant/dunavant.f90</span>
<a name="l00448"></a>00448             <span class="comment">//</span>
<a name="l00449"></a>00449             <span class="comment">// Additional precision obtained from the code in:</span>
<a name="l00450"></a>00450             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00451"></a>00451             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00452"></a>00452             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00453"></a>00453           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa96e4b793b046031faa991f15f1a80bc6">NINTH</a>:
<a name="l00454"></a>00454             {
<a name="l00455"></a>00455               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 6;
<a name="l00456"></a>00456               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00457"></a>00457                 {
<a name="l00458"></a>00458                   4.8567898141399416909620991253644315e-02L,
<a name="l00459"></a>00459                   1.5667350113569535268427415643604658e-02L, 
<a name="l00460"></a>00460                   1.2788837829349015630839399279499912e-02L, 
<a name="l00461"></a>00461                   3.8913770502387139658369678149701978e-02L, 
<a name="l00462"></a>00462                   3.9823869463605126516445887132022637e-02L, 
<a name="l00463"></a>00463                   2.1641769688644688644688644688644689e-02L
<a name="l00464"></a>00464                 };
<a name="l00465"></a>00465 
<a name="l00466"></a>00466               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00467"></a>00467                 {
<a name="l00468"></a>00468                   0.0, <span class="comment">// &#39;a&#39; parameter not used for origin permutation</span>
<a name="l00469"></a>00469                   4.8968251919873762778370692483619280e-01L,
<a name="l00470"></a>00470                   4.4729513394452709865106589966276365e-02L,
<a name="l00471"></a>00471                   4.3708959149293663726993036443535497e-01L,
<a name="l00472"></a>00472                   1.8820353561903273024096128046733557e-01L,
<a name="l00473"></a>00473                   2.2196298916076569567510252769319107e-01L
<a name="l00474"></a>00474                 };
<a name="l00475"></a>00475 
<a name="l00476"></a>00476               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00477"></a>00477                 {
<a name="l00478"></a>00478                   0.,
<a name="l00479"></a>00479                   0.,
<a name="l00480"></a>00480                   0.,
<a name="l00481"></a>00481                   0.,
<a name="l00482"></a>00482                   0.,
<a name="l00483"></a>00483                   7.4119859878449802069007987352342383e-01L
<a name="l00484"></a>00484                 };
<a name="l00485"></a>00485               
<a name="l00486"></a>00486               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts] = {1, 3, 3, 3, 3, 6}; <span class="comment">// 19 total points</span>
<a name="l00487"></a>00487 
<a name="l00488"></a>00488               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00489"></a>00489 
<a name="l00490"></a>00490               <span class="keywordflow">return</span>;
<a name="l00491"></a>00491             }
<a name="l00492"></a>00492 
<a name="l00493"></a>00493             
<a name="l00494"></a>00494             <span class="comment">// Another Dunavant rule with all positive weights.  This rule has 25</span>
<a name="l00495"></a>00495             <span class="comment">// points. The comparable conical product rule would have 36.</span>
<a name="l00496"></a>00496             <span class="comment">// It was copied 23rd June 2008 from:</span>
<a name="l00497"></a>00497             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/dunavant/dunavant.f90</span>
<a name="l00498"></a>00498             <span class="comment">//</span>
<a name="l00499"></a>00499             <span class="comment">// Additional precision obtained from the code in:</span>
<a name="l00500"></a>00500             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00501"></a>00501             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00502"></a>00502             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00503"></a>00503           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6115f555ee86d242617207bec760f208">TENTH</a>:
<a name="l00504"></a>00504             {
<a name="l00505"></a>00505               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 6;
<a name="l00506"></a>00506               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00507"></a>00507                 {
<a name="l00508"></a>00508                   4.5408995191376790047643297550014267e-02L,
<a name="l00509"></a>00509                   1.8362978878233352358503035945683300e-02L,
<a name="l00510"></a>00510                   2.2660529717763967391302822369298659e-02L,
<a name="l00511"></a>00511                   3.6378958422710054302157588309680344e-02L,
<a name="l00512"></a>00512                   1.4163621265528742418368530791049552e-02L,
<a name="l00513"></a>00513                   4.7108334818664117299637354834434138e-03L
<a name="l00514"></a>00514                 };
<a name="l00515"></a>00515 
<a name="l00516"></a>00516               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00517"></a>00517                 {
<a name="l00518"></a>00518                   0.0, <span class="comment">// &#39;a&#39; parameter not used for origin permutation</span>
<a name="l00519"></a>00519                   4.8557763338365737736750753220812615e-01L,
<a name="l00520"></a>00520                   1.0948157548503705479545863134052284e-01L,
<a name="l00521"></a>00521                   3.0793983876412095016515502293063162e-01L,
<a name="l00522"></a>00522                   2.4667256063990269391727646541117681e-01L,
<a name="l00523"></a>00523                   6.6803251012200265773540212762024737e-02L
<a name="l00524"></a>00524                 };
<a name="l00525"></a>00525 
<a name="l00526"></a>00526               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00527"></a>00527                 {
<a name="l00528"></a>00528                   0.,
<a name="l00529"></a>00529                   0.,
<a name="l00530"></a>00530                   0.,
<a name="l00531"></a>00531                   5.5035294182099909507816172659300821e-01L,
<a name="l00532"></a>00532                   7.2832390459741092000873505358107866e-01L,
<a name="l00533"></a>00533                   9.2365593358750027664630697761508843e-01L
<a name="l00534"></a>00534                 };
<a name="l00535"></a>00535               
<a name="l00536"></a>00536               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts] = {1, 3, 3, 6, 6, 6}; <span class="comment">// 25 total points</span>
<a name="l00537"></a>00537 
<a name="l00538"></a>00538               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00539"></a>00539               
<a name="l00540"></a>00540               <span class="keywordflow">return</span>;
<a name="l00541"></a>00541             }
<a name="l00542"></a>00542 
<a name="l00543"></a>00543 
<a name="l00544"></a>00544             <span class="comment">// Dunavant&#39;s 11th-order rule contains points outside the region of</span>
<a name="l00545"></a>00545             <span class="comment">// integration, and is thus unacceptable for our FEM calculations.</span>
<a name="l00546"></a>00546             <span class="comment">//</span>
<a name="l00547"></a>00547             <span class="comment">// This 30-point, 11th-order rule was obtained by me [JWP] using the code in</span>
<a name="l00548"></a>00548             <span class="comment">//</span>
<a name="l00549"></a>00549             <span class="comment">// Additional precision obtained from the code in:</span>
<a name="l00550"></a>00550             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00551"></a>00551             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00552"></a>00552             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00553"></a>00553             <span class="comment">//</span>
<a name="l00554"></a>00554             <span class="comment">// Note: the 28-point 11th-order rule obtained by Zhang in the paper above</span>
<a name="l00555"></a>00555             <span class="comment">// does not appear to be unique.  It is a solution in the sense that it</span>
<a name="l00556"></a>00556             <span class="comment">// minimizes the error in the least-squares minimization problem, but</span>
<a name="l00557"></a>00557             <span class="comment">// it involves too many unknowns and the Jacobian is therefore singular</span>
<a name="l00558"></a>00558             <span class="comment">// when attempting to improve the solution via Newton&#39;s method. </span>
<a name="l00559"></a>00559           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa9d8cd1c6f2feb41a556c16d8cb4744cd">ELEVENTH</a>:
<a name="l00560"></a>00560             {
<a name="l00561"></a>00561               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 6;
<a name="l00562"></a>00562               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00563"></a>00563                 {
<a name="l00564"></a>00564                   3.6089021198604635216985338480426484e-02L,
<a name="l00565"></a>00565                   2.1607717807680420303346736867931050e-02L,
<a name="l00566"></a>00566                   3.1144524293927978774861144478241807e-03L,
<a name="l00567"></a>00567                   2.9086855161081509446654185084988077e-02L,
<a name="l00568"></a>00568                   8.4879241614917017182977532679947624e-03L,
<a name="l00569"></a>00569                   1.3795732078224796530729242858347546e-02L
<a name="l00570"></a>00570                 };
<a name="l00571"></a>00571 
<a name="l00572"></a>00572               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00573"></a>00573                 {
<a name="l00574"></a>00574                   3.9355079629947969884346551941969960e-01L,
<a name="l00575"></a>00575                   4.7979065808897448654107733982929214e-01L,
<a name="l00576"></a>00576                   5.1003445645828061436081405648347852e-03L,
<a name="l00577"></a>00577                   2.6597620190330158952732822450744488e-01L,
<a name="l00578"></a>00578                   2.8536418538696461608233522814483715e-01L,
<a name="l00579"></a>00579                   1.3723536747817085036455583801851025e-01L
<a name="l00580"></a>00580                 };
<a name="l00581"></a>00581 
<a name="l00582"></a>00582               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00583"></a>00583                 {
<a name="l00584"></a>00584                   0.,
<a name="l00585"></a>00585                   0.,
<a name="l00586"></a>00586                   5.6817155788572446538150614865768991e-02L,
<a name="l00587"></a>00587                   1.2539956353662088473247489775203396e-01L,
<a name="l00588"></a>00588                   1.2409970153698532116262152247041742e-02L,
<a name="l00589"></a>00589                   5.2792057988217708934207928630851643e-02L               
<a name="l00590"></a>00590                 };
<a name="l00591"></a>00591               
<a name="l00592"></a>00592               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts] = {3, 3, 6, 6, 6, 6}; <span class="comment">// 30 total points</span>
<a name="l00593"></a>00593 
<a name="l00594"></a>00594               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00595"></a>00595               
<a name="l00596"></a>00596               <span class="keywordflow">return</span>;
<a name="l00597"></a>00597             }
<a name="l00598"></a>00598 
<a name="l00599"></a>00599 
<a name="l00600"></a>00600 
<a name="l00601"></a>00601             
<a name="l00602"></a>00602             <span class="comment">// Another Dunavant rule with all positive weights.  This rule has 33</span>
<a name="l00603"></a>00603             <span class="comment">// points. The comparable conical product rule would have 36 (ELEVENTH) or 49 (TWELFTH).</span>
<a name="l00604"></a>00604             <span class="comment">//</span>
<a name="l00605"></a>00605             <span class="comment">// It was copied 23rd June 2008 from:</span>
<a name="l00606"></a>00606             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/dunavant/dunavant.f90</span>
<a name="l00607"></a>00607             <span class="comment">//</span>
<a name="l00608"></a>00608             <span class="comment">// Additional precision obtained from the code in:</span>
<a name="l00609"></a>00609             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00610"></a>00610             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00611"></a>00611             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00612"></a>00612           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa72ff7b576c902d58a9fc3ad53b247a85">TWELFTH</a>:
<a name="l00613"></a>00613             {
<a name="l00614"></a>00614               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 8;
<a name="l00615"></a>00615               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00616"></a>00616                 {
<a name="l00617"></a>00617                   3.0831305257795086169332418926151771e-03L,
<a name="l00618"></a>00618                   3.1429112108942550177135256546441273e-02L,
<a name="l00619"></a>00619                   1.7398056465354471494664198647499687e-02L,
<a name="l00620"></a>00620                   2.1846272269019201067728631278737487e-02L,
<a name="l00621"></a>00621                   1.2865533220227667708895461535782215e-02L,
<a name="l00622"></a>00622                   1.1178386601151722855919538351159995e-02L,
<a name="l00623"></a>00623                   8.6581155543294461858210504055170332e-03L,
<a name="l00624"></a>00624                   2.0185778883190464758914349626118386e-02L
<a name="l00625"></a>00625                 };
<a name="l00626"></a>00626 
<a name="l00627"></a>00627               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00628"></a>00628                 {
<a name="l00629"></a>00629                   2.1317350453210370246856975515728246e-02L,
<a name="l00630"></a>00630                   2.7121038501211592234595134039689474e-01L,
<a name="l00631"></a>00631                   1.2757614554158592467389632515428357e-01L,
<a name="l00632"></a>00632                   4.3972439229446027297973662348436108e-01L,
<a name="l00633"></a>00633                   4.8821738977380488256466206525881104e-01L,
<a name="l00634"></a>00634                   2.8132558098993954824813069297455275e-01L,
<a name="l00635"></a>00635                   1.1625191590759714124135414784260182e-01L,
<a name="l00636"></a>00636                   2.7571326968551419397479634607976398e-01L
<a name="l00637"></a>00637                 };
<a name="l00638"></a>00638 
<a name="l00639"></a>00639               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00640"></a>00640                 {
<a name="l00641"></a>00641                   0.,
<a name="l00642"></a>00642                   0.,
<a name="l00643"></a>00643                   0.,
<a name="l00644"></a>00644                   0.,
<a name="l00645"></a>00645                   0.,
<a name="l00646"></a>00646                   6.9583608678780342214163552323607254e-01L,
<a name="l00647"></a>00647                   8.5801403354407263059053661662617818e-01L,
<a name="l00648"></a>00648                   6.0894323577978780685619243776371007e-01L
<a name="l00649"></a>00649                 };
<a name="l00650"></a>00650               
<a name="l00651"></a>00651               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts] = {3, 3, 3, 3, 3, 6, 6, 6}; <span class="comment">// 33 total points</span>
<a name="l00652"></a>00652 
<a name="l00653"></a>00653               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00654"></a>00654               
<a name="l00655"></a>00655               <span class="keywordflow">return</span>;
<a name="l00656"></a>00656             }
<a name="l00657"></a>00657 
<a name="l00658"></a>00658             
<a name="l00659"></a>00659             <span class="comment">// Another Dunavant rule with all positive weights.  This rule has 37</span>
<a name="l00660"></a>00660             <span class="comment">// points. The comparable conical product rule would have 49 points.</span>
<a name="l00661"></a>00661             <span class="comment">//</span>
<a name="l00662"></a>00662             <span class="comment">// It was copied 23rd June 2008 from:</span>
<a name="l00663"></a>00663             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/dunavant/dunavant.f90</span>
<a name="l00664"></a>00664             <span class="comment">//</span>
<a name="l00665"></a>00665             <span class="comment">// A second rule with additional precision obtained from the code in:</span>
<a name="l00666"></a>00666             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00667"></a>00667             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00668"></a>00668             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00669"></a>00669           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faeb2a82bbe2a44c6917cedc029423ce75">THIRTEENTH</a>:
<a name="l00670"></a>00670             {
<a name="l00671"></a>00671               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 9;
<a name="l00672"></a>00672               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00673"></a>00673                 {
<a name="l00674"></a>00674                   3.3980018293415822140887212340442440e-02L,
<a name="l00675"></a>00675                   2.7800983765226664353628733005230734e-02L,
<a name="l00676"></a>00676                   2.9139242559599990702383541756669905e-02L,
<a name="l00677"></a>00677                   3.0261685517695859208964000161454122e-03L,
<a name="l00678"></a>00678                   1.1997200964447365386855399725479827e-02L,
<a name="l00679"></a>00679                   1.7320638070424185232993414255459110e-02L,
<a name="l00680"></a>00680                   7.4827005525828336316229285664517190e-03L,
<a name="l00681"></a>00681                   1.2089519905796909568722872786530380e-02L,
<a name="l00682"></a>00682                   4.7953405017716313612975450830554457e-03L
<a name="l00683"></a>00683                 };
<a name="l00684"></a>00684 
<a name="l00685"></a>00685               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00686"></a>00686                 {
<a name="l00687"></a>00687                   0., <span class="comment">// &#39;a&#39; parameter not used for origin permutation</span>
<a name="l00688"></a>00688                   4.2694141425980040602081253503137421e-01L,
<a name="l00689"></a>00689                   2.2137228629183290065481255470507908e-01L,
<a name="l00690"></a>00690                   2.1509681108843183869291313534052083e-02L,
<a name="l00691"></a>00691                   4.8907694645253934990068971909020439e-01L,
<a name="l00692"></a>00692                   3.0844176089211777465847185254124531e-01L,
<a name="l00693"></a>00693                   1.1092204280346339541286954522167452e-01L,
<a name="l00694"></a>00694                   1.6359740106785048023388790171095725e-01L,
<a name="l00695"></a>00695                   2.7251581777342966618005046435408685e-01L
<a name="l00696"></a>00696                 };
<a name="l00697"></a>00697 
<a name="l00698"></a>00698               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00699"></a>00699                 {
<a name="l00700"></a>00700                   0.,
<a name="l00701"></a>00701                   0.,
<a name="l00702"></a>00702                   0.,
<a name="l00703"></a>00703                   0.,
<a name="l00704"></a>00704                   0.,
<a name="l00705"></a>00705                   6.2354599555367557081585435318623659e-01L,
<a name="l00706"></a>00706                   8.6470777029544277530254595089569318e-01L,
<a name="l00707"></a>00707                   7.4850711589995219517301859578870965e-01L,
<a name="l00708"></a>00708                   7.2235779312418796526062013230478405e-01L 
<a name="l00709"></a>00709                 };
<a name="l00710"></a>00710               
<a name="l00711"></a>00711               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts] = {1, 3, 3, 3, 3, 6, 6, 6, 6}; <span class="comment">// 37 total points</span>
<a name="l00712"></a>00712 
<a name="l00713"></a>00713               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00714"></a>00714               
<a name="l00715"></a>00715               <span class="keywordflow">return</span>;
<a name="l00716"></a>00716             }
<a name="l00717"></a>00717 
<a name="l00718"></a>00718             
<a name="l00719"></a>00719             <span class="comment">// Another Dunavant rule.  This rule has 42 points, while</span>
<a name="l00720"></a>00720             <span class="comment">// a comparable conical product rule would have 64.</span>
<a name="l00721"></a>00721             <span class="comment">//</span>
<a name="l00722"></a>00722             <span class="comment">// It was copied 23rd June 2008 from:</span>
<a name="l00723"></a>00723             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/dunavant/dunavant.f90</span>
<a name="l00724"></a>00724             <span class="comment">//</span>
<a name="l00725"></a>00725             <span class="comment">// Additional precision obtained from the code in:</span>
<a name="l00726"></a>00726             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00727"></a>00727             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00728"></a>00728             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00729"></a>00729           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faab1534905d9792db00394cf617c71749">FOURTEENTH</a>:
<a name="l00730"></a>00730             {
<a name="l00731"></a>00731               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 10;
<a name="l00732"></a>00732               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00733"></a>00733                 {
<a name="l00734"></a>00734                   1.0941790684714445320422472981662986e-02L,
<a name="l00735"></a>00735                   1.6394176772062675320655489369312672e-02L,
<a name="l00736"></a>00736                   2.5887052253645793157392455083198201e-02L,
<a name="l00737"></a>00737                   2.1081294368496508769115218662093065e-02L,
<a name="l00738"></a>00738                   7.2168498348883338008549607403266583e-03L,
<a name="l00739"></a>00739                   2.4617018012000408409130117545210774e-03L,
<a name="l00740"></a>00740                   1.2332876606281836981437622591818114e-02L,
<a name="l00741"></a>00741                   1.9285755393530341614244513905205430e-02L,
<a name="l00742"></a>00742                   7.2181540567669202480443459995079017e-03L,
<a name="l00743"></a>00743                   2.5051144192503358849300465412445582e-03L
<a name="l00744"></a>00744                 };
<a name="l00745"></a>00745 
<a name="l00746"></a>00746               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00747"></a>00747                 {
<a name="l00748"></a>00748                   4.8896391036217863867737602045239024e-01L,
<a name="l00749"></a>00749                   4.1764471934045392250944082218564344e-01L,
<a name="l00750"></a>00750                   2.7347752830883865975494428326269856e-01L,
<a name="l00751"></a>00751                   1.7720553241254343695661069046505908e-01L,
<a name="l00752"></a>00752                   6.1799883090872601267478828436935788e-02L,
<a name="l00753"></a>00753                   1.9390961248701048178250095054529511e-02L,
<a name="l00754"></a>00754                   1.7226668782135557837528960161365733e-01L,
<a name="l00755"></a>00755                   3.3686145979634500174405519708892539e-01L,
<a name="l00756"></a>00756                   2.9837288213625775297083151805961273e-01L,
<a name="l00757"></a>00757                   1.1897449769695684539818196192990548e-01L
<a name="l00758"></a>00758                 };
<a name="l00759"></a>00759 
<a name="l00760"></a>00760               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00761"></a>00761                 {
<a name="l00762"></a>00762                   0.,
<a name="l00763"></a>00763                   0.,
<a name="l00764"></a>00764                   0.,
<a name="l00765"></a>00765                   0.,
<a name="l00766"></a>00766                   0.,
<a name="l00767"></a>00767                   0.,             
<a name="l00768"></a>00768                   7.7060855477499648258903327416742796e-01L,
<a name="l00769"></a>00769                   5.7022229084668317349769621336235426e-01L,
<a name="l00770"></a>00770                   6.8698016780808783735862715402031306e-01L,
<a name="l00771"></a>00771                   8.7975717137017112951457163697460183e-01L 
<a name="l00772"></a>00772                 };
<a name="l00773"></a>00773               
<a name="l00774"></a>00774               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts]
<a name="l00775"></a>00775                 = {3, 3, 3, 3, 3, 3, 6, 6, 6, 6}; <span class="comment">// 42 total points</span>
<a name="l00776"></a>00776 
<a name="l00777"></a>00777               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00778"></a>00778               
<a name="l00779"></a>00779               <span class="keywordflow">return</span>;
<a name="l00780"></a>00780             }
<a name="l00781"></a>00781 
<a name="l00782"></a>00782             
<a name="l00783"></a>00783             <span class="comment">// This 49-point rule was found by me [JWP] using the code in:</span>
<a name="l00784"></a>00784             <span class="comment">//</span>
<a name="l00785"></a>00785             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00786"></a>00786             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00787"></a>00787             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00788"></a>00788             <span class="comment">//</span>
<a name="l00789"></a>00789             <span class="comment">// A 54-point, 15th-order rule is reported by</span>
<a name="l00790"></a>00790             <span class="comment">//</span>
<a name="l00791"></a>00791             <span class="comment">// Stephen Wandzura, Hong Xiao,</span>
<a name="l00792"></a>00792             <span class="comment">// Symmetric Quadrature Rules on a Triangle,</span>
<a name="l00793"></a>00793             <span class="comment">// Computers and Mathematics with Applications,</span>
<a name="l00794"></a>00794             <span class="comment">// Volume 45, Number 12, June 2003, pages 1829-1840.</span>
<a name="l00795"></a>00795             <span class="comment">//</span>
<a name="l00796"></a>00796             <span class="comment">// can be found here:</span>
<a name="l00797"></a>00797             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/wandzura/wandzura.f90</span>
<a name="l00798"></a>00798             <span class="comment">//</span>
<a name="l00799"></a>00799             <span class="comment">// but this 49-point rule is superior.</span>
<a name="l00800"></a>00800           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7120ce4c6dcb4b9465b15e7531631fe6">FIFTEENTH</a>:
<a name="l00801"></a>00801             {
<a name="l00802"></a>00802               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 11;
<a name="l00803"></a>00803               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00804"></a>00804                 {
<a name="l00805"></a>00805                   2.4777380743035579804788826970198951e-02L,
<a name="l00806"></a>00806                   9.2433943023307730591540642828347660e-03L,
<a name="l00807"></a>00807                   2.2485768962175402793245929133296627e-03L,
<a name="l00808"></a>00808                   6.7052581900064143760518398833360903e-03L,
<a name="l00809"></a>00809                   1.9011381726930579256700190357527956e-02L,
<a name="l00810"></a>00810                   1.4605445387471889398286155981802858e-02L,
<a name="l00811"></a>00811                   1.5087322572773133722829435011138258e-02L,
<a name="l00812"></a>00812                   1.5630213780078803020711746273129099e-02L,
<a name="l00813"></a>00813                   6.1808086085778203192616856133701233e-03L,
<a name="l00814"></a>00814                   3.2209366452594664857296985751120513e-03L,
<a name="l00815"></a>00815                   5.8747373242569702667677969985668817e-03L
<a name="l00816"></a>00816                 };
<a name="l00817"></a>00817 
<a name="l00818"></a>00818               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00819"></a>00819                 {
<a name="l00820"></a>00820                   0.0, <span class="comment">// &#39;a&#39; parameter not used for origin</span>
<a name="l00821"></a>00821                   7.9031013655541635005816956762252155e-02L,
<a name="l00822"></a>00822                   1.8789501810770077611247984432284226e-02L,
<a name="l00823"></a>00823                   4.9250168823249670532514526605352905e-01L,
<a name="l00824"></a>00824                   4.0886316907744105975059040108092775e-01L,
<a name="l00825"></a>00825                   5.3877851064220142445952549348423733e-01L,
<a name="l00826"></a>00826                   2.0250549804829997692885033941362673e-01L,
<a name="l00827"></a>00827                   5.5349674918711643207148086558288110e-01L,
<a name="l00828"></a>00828                   7.8345022567320812359258882143250181e-01L,
<a name="l00829"></a>00829                   8.9514624528794883409864566727625002e-01L,
<a name="l00830"></a>00830                   3.2515745241110782862789881780746490e-01L
<a name="l00831"></a>00831                 };
<a name="l00832"></a>00832 
<a name="l00833"></a>00833               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00834"></a>00834                 {
<a name="l00835"></a>00835                   0.,
<a name="l00836"></a>00836                   0.,
<a name="l00837"></a>00837                   0.,
<a name="l00838"></a>00838                   0.,
<a name="l00839"></a>00839                   0.,
<a name="l00840"></a>00840                   1.9412620368774630292701241080996842e-01L,
<a name="l00841"></a>00841                   9.8765911355712115933807754318089099e-02L,
<a name="l00842"></a>00842                   7.7663767064308164090246588765178087e-02L,
<a name="l00843"></a>00843                   2.1594628433980258573654682690950798e-02L,
<a name="l00844"></a>00844                   1.2563596287784997705599005477153617e-02L,
<a name="l00845"></a>00845                   1.5082654870922784345283124845552190e-02L               
<a name="l00846"></a>00846                 };
<a name="l00847"></a>00847               
<a name="l00848"></a>00848               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts]
<a name="l00849"></a>00849                 = {1, 3, 3, 3, 3, 6, 6, 6, 6, 6, 6}; <span class="comment">// 49 total points</span>
<a name="l00850"></a>00850 
<a name="l00851"></a>00851               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00852"></a>00852               
<a name="l00853"></a>00853               <span class="keywordflow">return</span>;
<a name="l00854"></a>00854             }
<a name="l00855"></a>00855 
<a name="l00856"></a>00856 
<a name="l00857"></a>00857 
<a name="l00858"></a>00858             
<a name="l00859"></a>00859             <span class="comment">// Dunavant&#39;s 16th-order rule contains points outside the region of</span>
<a name="l00860"></a>00860             <span class="comment">// integration, and is thus unacceptable for our FEM calculations.</span>
<a name="l00861"></a>00861             <span class="comment">//</span>
<a name="l00862"></a>00862             <span class="comment">// This 55-point, 16th-order rule was obtained by me [JWP] using the code in</span>
<a name="l00863"></a>00863             <span class="comment">//</span>
<a name="l00864"></a>00864             <span class="comment">// Additional precision obtained from the code in:</span>
<a name="l00865"></a>00865             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00866"></a>00866             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00867"></a>00867             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00868"></a>00868             <span class="comment">//</span>
<a name="l00869"></a>00869             <span class="comment">// Note: the 55-point 16th-order rule obtained by Zhang in the paper above</span>
<a name="l00870"></a>00870             <span class="comment">// does not appear to be unique.  It is a solution in the sense that it</span>
<a name="l00871"></a>00871             <span class="comment">// minimizes the error in the least-squares minimization problem, but</span>
<a name="l00872"></a>00872             <span class="comment">// it involves too many unknowns and the Jacobian is therefore singular</span>
<a name="l00873"></a>00873             <span class="comment">// when attempting to improve the solution via Newton&#39;s method. </span>
<a name="l00874"></a>00874           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad3a83c160ba19d280cf82ab0fee65f2d">SIXTEENTH</a>:    
<a name="l00875"></a>00875             {
<a name="l00876"></a>00876               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 12;
<a name="l00877"></a>00877               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00878"></a>00878                 {
<a name="l00879"></a>00879                   2.2668082505910087151996321171534230e-02L,
<a name="l00880"></a>00880                   8.4043060714818596159798961899306135e-03L,
<a name="l00881"></a>00881                   1.0850949634049747713966288634484161e-03L,
<a name="l00882"></a>00882                   7.2252773375423638869298219383808751e-03L,
<a name="l00883"></a>00883                   1.2997715227338366024036316182572871e-02L,
<a name="l00884"></a>00884                   2.0054466616677715883228810959112227e-02L,
<a name="l00885"></a>00885                   9.7299841600417010281624372720122710e-03L,
<a name="l00886"></a>00886                   1.1651974438298104227427176444311766e-02L,
<a name="l00887"></a>00887                   9.1291185550484450744725847363097389e-03L,
<a name="l00888"></a>00888                   3.5568614040947150231712567900113671e-03L,
<a name="l00889"></a>00889                   5.8355861686234326181790822005304303e-03L,
<a name="l00890"></a>00890                   4.7411314396804228041879331486234396e-03L
<a name="l00891"></a>00891                 };
<a name="l00892"></a>00892 
<a name="l00893"></a>00893               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00894"></a>00894                 {
<a name="l00895"></a>00895                   0.0, <span class="comment">// &#39;a&#39; parameter not used for centroid weight</span>
<a name="l00896"></a>00896                   8.5402539407933203673769900926355911e-02L,
<a name="l00897"></a>00897                   1.2425572001444092841183633409631260e-02L,
<a name="l00898"></a>00898                   4.9174838341891594024701017768490960e-01L,
<a name="l00899"></a>00899                   4.5669426695387464162068900231444462e-01L,
<a name="l00900"></a>00900                   4.8506759880447437974189793537259677e-01L,
<a name="l00901"></a>00901                   2.0622099278664205707909858461264083e-01L,
<a name="l00902"></a>00902                   3.2374950270039093446805340265853956e-01L,
<a name="l00903"></a>00903                   7.3834330556606586255186213302750029e-01L,
<a name="l00904"></a>00904                   9.1210673061680792565673823935174611e-01L,
<a name="l00905"></a>00905                   6.6129919222598721544966837350891531e-01L,
<a name="l00906"></a>00906                   1.7807138906021476039088828811346122e-01L
<a name="l00907"></a>00907                 };
<a name="l00908"></a>00908 
<a name="l00909"></a>00909               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00910"></a>00910                 {
<a name="l00911"></a>00911                   0.0,
<a name="l00912"></a>00912                   0.0,
<a name="l00913"></a>00913                   0.0,
<a name="l00914"></a>00914                   0.0,
<a name="l00915"></a>00915                   0.0,
<a name="l00916"></a>00916                   3.2315912848634384647700266402091638e-01L,
<a name="l00917"></a>00917                   1.5341553679414688425981898952416987e-01L,
<a name="l00918"></a>00918                   7.4295478991330687632977899141707872e-02L,
<a name="l00919"></a>00919                   7.1278762832147862035977841733532020e-02L,
<a name="l00920"></a>00920                   1.6623223223705792825395256602140459e-02L,
<a name="l00921"></a>00921                   1.4160772533794791868984026749196156e-02L,
<a name="l00922"></a>00922                   1.4539694958941854654807449467759690e-02L               
<a name="l00923"></a>00923                 };
<a name="l00924"></a>00924               
<a name="l00925"></a>00925               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts]
<a name="l00926"></a>00926                 = {1, 3, 3, 3, 3, 6, 6, 6, 6, 6, 6, 6}; <span class="comment">// 55 total points</span>
<a name="l00927"></a>00927 
<a name="l00928"></a>00928               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l00929"></a>00929               
<a name="l00930"></a>00930               <span class="keywordflow">return</span>;
<a name="l00931"></a>00931             }
<a name="l00932"></a>00932             
<a name="l00933"></a>00933             
<a name="l00934"></a>00934             <span class="comment">// Dunavant&#39;s 17th-order rule has 61 points, while a</span>
<a name="l00935"></a>00935             <span class="comment">// comparable conical product rule would have 81 (16th and 17th orders).</span>
<a name="l00936"></a>00936             <span class="comment">//</span>
<a name="l00937"></a>00937             <span class="comment">// It can be found here:</span>
<a name="l00938"></a>00938             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/dunavant/dunavant.f90</span>
<a name="l00939"></a>00939             <span class="comment">//</span>
<a name="l00940"></a>00940             <span class="comment">// Zhang reports an identical rule in:</span>
<a name="l00941"></a>00941             <span class="comment">// L. Zhang, T. Cui, and H. Liu. &quot;A set of symmetric quadrature rules</span>
<a name="l00942"></a>00942             <span class="comment">// on triangles and tetrahedra&quot;  Journal of Computational Mathematics,</span>
<a name="l00943"></a>00943             <span class="comment">// v. 27, no. 1, 2009, pp. 89-96.</span>
<a name="l00944"></a>00944             <span class="comment">//</span>
<a name="l00945"></a>00945             <span class="comment">// Note: the 61-point 17th-order rule obtained by Dunavant and Zhang</span>
<a name="l00946"></a>00946             <span class="comment">// does not appear to be unique.  It is a solution in the sense that it</span>
<a name="l00947"></a>00947             <span class="comment">// minimizes the error in the least-squares minimization problem, but</span>
<a name="l00948"></a>00948             <span class="comment">// it involves too many unknowns and the Jacobian is therefore singular</span>
<a name="l00949"></a>00949             <span class="comment">// when attempting to improve the solution via Newton&#39;s method.</span>
<a name="l00950"></a>00950             <span class="comment">//</span>
<a name="l00951"></a>00951             <span class="comment">// Therefore, we prefer the following 63-point rule which</span>
<a name="l00952"></a>00952             <span class="comment">// I [JWP] found.  It appears to be more accurate than the</span>
<a name="l00953"></a>00953             <span class="comment">// rule reported by Dunavant and Zhang, even though it has</span>
<a name="l00954"></a>00954             <span class="comment">// a few more points.</span>
<a name="l00955"></a>00955           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fae4eeb80a784baaf763cdccf0a47a4557">SEVENTEENTH</a>:
<a name="l00956"></a>00956             {
<a name="l00957"></a>00957               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_wts = 12;
<a name="l00958"></a>00958               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> wts[n_wts] =
<a name="l00959"></a>00959                 {
<a name="l00960"></a>00960                   1.7464603792572004485690588092246146e-02L,
<a name="l00961"></a>00961                   5.9429003555801725246549713984660076e-03L,
<a name="l00962"></a>00962                   1.2490753345169579649319736639588729e-02L,
<a name="l00963"></a>00963                   1.5386987188875607593083456905596468e-02L,
<a name="l00964"></a>00964                   1.1185807311917706362674684312990270e-02L,
<a name="l00965"></a>00965                   1.0301845740670206831327304917180007e-02L,
<a name="l00966"></a>00966                   1.1767783072977049696840016810370464e-02L,
<a name="l00967"></a>00967                   3.8045312849431209558329128678945240e-03L,
<a name="l00968"></a>00968                   4.5139302178876351271037137230354382e-03L,
<a name="l00969"></a>00969                   2.2178812517580586419412547665472893e-03L,
<a name="l00970"></a>00970                   5.2216271537483672304731416553063103e-03L,
<a name="l00971"></a>00971                   9.8381136389470256422419930926212114e-04L
<a name="l00972"></a>00972                 };
<a name="l00973"></a>00973 
<a name="l00974"></a>00974               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[n_wts] =
<a name="l00975"></a>00975                 {
<a name="l00976"></a>00976                   2.8796825754667362165337965123570514e-01L,
<a name="l00977"></a>00977                   4.9216175986208465345536805750663939e-01L,
<a name="l00978"></a>00978                   4.6252866763171173685916780827044612e-01L,
<a name="l00979"></a>00979                   1.6730292951631792248498303276090273e-01L,
<a name="l00980"></a>00980                   1.5816335500814652972296428532213019e-01L,
<a name="l00981"></a>00981                   1.6352252138387564873002458959679529e-01L,
<a name="l00982"></a>00982                   6.2447680488959768233910286168417367e-01L,
<a name="l00983"></a>00983                   8.7317249935244454285263604347964179e-01L,
<a name="l00984"></a>00984                   3.4428164322282694677972239461699271e-01L,
<a name="l00985"></a>00985                   9.1584484467813674010523309855340209e-02L,
<a name="l00986"></a>00986                   2.0172088013378989086826623852040632e-01L,
<a name="l00987"></a>00987                   9.6538762758254643474731509845084691e-01L
<a name="l00988"></a>00988                 };
<a name="l00989"></a>00989 
<a name="l00990"></a>00990               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b[n_wts] =
<a name="l00991"></a>00991                 {
<a name="l00992"></a>00992                   0.0,
<a name="l00993"></a>00993                   0.0,
<a name="l00994"></a>00994                   0.0,
<a name="l00995"></a>00995                   3.4429160695501713926320695771253348e-01L,
<a name="l00996"></a>00996                   2.2541623431550639817203145525444726e-01L,
<a name="l00997"></a>00997                   8.0670083153531811694942222940484991e-02L,
<a name="l00998"></a>00998                   6.5967451375050925655738829747288190e-02L,
<a name="l00999"></a>00999                   4.5677879890996762665044366994439565e-02L,
<a name="l01000"></a>01000                   1.1528411723154215812386518751976084e-02L,
<a name="l01001"></a>01001                   9.3057714323900610398389176844165892e-03L,
<a name="l01002"></a>01002                   1.5916814107619812717966560404970160e-02L,
<a name="l01003"></a>01003                   1.0734733163764032541125434215228937e-02L
<a name="l01004"></a>01004                 };
<a name="l01005"></a>01005               
<a name="l01006"></a>01006               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> permutation_ids[n_wts]
<a name="l01007"></a>01007                 = {3, 3, 3, 6, 6, 6, 6, 6, 6, 6, 6, 6}; <span class="comment">// 63 total points</span>
<a name="l01008"></a>01008 
<a name="l01009"></a>01009               <a class="code" href="classlibMesh_1_1QGauss.php#a7d869c3ac9e372473d0acc76c82b10ca">dunavant_rule2</a>(wts, a, b, permutation_ids, n_wts);
<a name="l01010"></a>01010               
<a name="l01011"></a>01011               <span class="keywordflow">return</span>;
<a name="l01012"></a>01012    
<a name="l01013"></a>01013 <span class="comment">//            _points.resize (61);</span>
<a name="l01014"></a>01014 <span class="comment">//            _weights.resize(61);</span>
<a name="l01015"></a>01015 
<a name="l01016"></a>01016 <span class="comment">//            // The raw data for the quadrature rule.</span>
<a name="l01017"></a>01017 <span class="comment">//            const Real p[15][4] = {</span>
<a name="l01018"></a>01018 <span class="comment">//              {                1./3.,                    0.,                    0., 0.033437199290803e+00 / 2.0}, // 1-perm</span>
<a name="l01019"></a>01019 <span class="comment">//              {0.005658918886452e+00, 0.497170540556774e+00,                    0., 0.005093415440507e+00 / 2.0}, // 3-perm</span>
<a name="l01020"></a>01020 <span class="comment">//              {0.035647354750751e+00, 0.482176322624625e+00,                    0., 0.014670864527638e+00 / 2.0}, // 3-perm</span>
<a name="l01021"></a>01021 <span class="comment">//              {0.099520061958437e+00, 0.450239969020782e+00,                    0., 0.024350878353672e+00 / 2.0}, // 3-perm</span>
<a name="l01022"></a>01022 <span class="comment">//              {0.199467521245206e+00, 0.400266239377397e+00,                    0., 0.031107550868969e+00 / 2.0}, // 3-perm</span>
<a name="l01023"></a>01023 <span class="comment">//              {0.495717464058095e+00, 0.252141267970953e+00,                    0., 0.031257111218620e+00 / 2.0}, // 3-perm</span>
<a name="l01024"></a>01024 <span class="comment">//              {0.675905990683077e+00, 0.162047004658461e+00,                    0., 0.024815654339665e+00 / 2.0}, // 3-perm</span>
<a name="l01025"></a>01025 <span class="comment">//              {0.848248235478508e+00, 0.075875882260746e+00,                    0., 0.014056073070557e+00 / 2.0}, // 3-perm</span>
<a name="l01026"></a>01026 <span class="comment">//              {0.968690546064356e+00, 0.015654726967822e+00,                    0., 0.003194676173779e+00 / 2.0}, // 3-perm</span>
<a name="l01027"></a>01027 <span class="comment">//              {0.010186928826919e+00, 0.334319867363658e+00, 0.655493203809423e+00, 0.008119655318993e+00 / 2.0}, // 6-perm</span>
<a name="l01028"></a>01028 <span class="comment">//              {0.135440871671036e+00, 0.292221537796944e+00, 0.572337590532020e+00, 0.026805742283163e+00 / 2.0}, // 6-perm</span>
<a name="l01029"></a>01029 <span class="comment">//              {0.054423924290583e+00, 0.319574885423190e+00, 0.626001190286228e+00, 0.018459993210822e+00 / 2.0}, // 6-perm </span>
<a name="l01030"></a>01030 <span class="comment">//              {0.012868560833637e+00, 0.190704224192292e+00, 0.796427214974071e+00, 0.008476868534328e+00 / 2.0}, // 6-perm</span>
<a name="l01031"></a>01031 <span class="comment">//              {0.067165782413524e+00, 0.180483211648746e+00, 0.752351005937729e+00, 0.018292796770025e+00 / 2.0}, // 6-perm </span>
<a name="l01032"></a>01032 <span class="comment">//              {0.014663182224828e+00, 0.080711313679564e+00, 0.904625504095608e+00, 0.006665632004165e+00 / 2.0}  // 6-perm</span>
<a name="l01033"></a>01033 <span class="comment">//            };</span>
<a name="l01034"></a>01034 
<a name="l01035"></a>01035               
<a name="l01036"></a>01036 <span class="comment">//            // Now call the dunavant routine to generate _points and _weights</span>
<a name="l01037"></a>01037 <span class="comment">//            dunavant_rule(p, 15);</span>
<a name="l01038"></a>01038 
<a name="l01039"></a>01039 <span class="comment">//            return;</span>
<a name="l01040"></a>01040             }
<a name="l01041"></a>01041 
<a name="l01042"></a>01042 
<a name="l01043"></a>01043             
<a name="l01044"></a>01044             <span class="comment">// Dunavant&#39;s 18th-order rule contains points outside the region and is therefore unsuitable</span>
<a name="l01045"></a>01045             <span class="comment">// for our FEM calculations.  His 19th-order rule has 73 points, compared with 100 points for</span>
<a name="l01046"></a>01046             <span class="comment">// a comparable-order conical product rule.</span>
<a name="l01047"></a>01047             <span class="comment">//</span>
<a name="l01048"></a>01048             <span class="comment">// It was copied 23rd June 2008 from:</span>
<a name="l01049"></a>01049             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/dunavant/dunavant.f90</span>
<a name="l01050"></a>01050           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa04abe26889214024e6b01556757afebc">EIGHTTEENTH</a>:  
<a name="l01051"></a>01051           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa460d128a5ae3f0cab006386047945a63">NINTEENTH</a>:
<a name="l01052"></a>01052             {
<a name="l01053"></a>01053               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (73);
<a name="l01054"></a>01054               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(73);
<a name="l01055"></a>01055 
<a name="l01056"></a>01056               <span class="comment">// The raw data for the quadrature rule.</span>
<a name="l01057"></a>01057               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p[17][4] = {
<a name="l01058"></a>01058                 {                1./3.,                    0.,                    0., 0.032906331388919e+00 / 2.0}, <span class="comment">// 1-perm</span>
<a name="l01059"></a>01059                 {0.020780025853987e+00, 0.489609987073006e+00,                    0., 0.010330731891272e+00 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01060"></a>01060                 {0.090926214604215e+00, 0.454536892697893e+00,                    0., 0.022387247263016e+00 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01061"></a>01061                 {0.197166638701138e+00, 0.401416680649431e+00,                    0., 0.030266125869468e+00 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01062"></a>01062                 {0.488896691193805e+00, 0.255551654403098e+00,                    0., 0.030490967802198e+00 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01063"></a>01063                 {0.645844115695741e+00, 0.177077942152130e+00,                    0., 0.024159212741641e+00 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01064"></a>01064                 {0.779877893544096e+00, 0.110061053227952e+00,                    0., 0.016050803586801e+00 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01065"></a>01065                 {0.888942751496321e+00, 0.055528624251840e+00,                    0., 0.008084580261784e+00 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01066"></a>01066                 {0.974756272445543e+00, 0.012621863777229e+00,                    0., 0.002079362027485e+00 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01067"></a>01067                 {0.003611417848412e+00, 0.395754787356943e+00, 0.600633794794645e+00, 0.003884876904981e+00 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01068"></a>01068                 {0.134466754530780e+00, 0.307929983880436e+00, 0.557603261588784e+00, 0.025574160612022e+00 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01069"></a>01069                 {0.014446025776115e+00, 0.264566948406520e+00, 0.720987025817365e+00, 0.008880903573338e+00 / 2.0}, <span class="comment">// 6-perm </span>
<a name="l01070"></a>01070                 {0.046933578838178e+00, 0.358539352205951e+00, 0.594527068955871e+00, 0.016124546761731e+00 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01071"></a>01071                 {0.002861120350567e+00, 0.157807405968595e+00, 0.839331473680839e+00, 0.002491941817491e+00 / 2.0}, <span class="comment">// 6-perm </span>
<a name="l01072"></a>01072                 {0.223861424097916e+00, 0.075050596975911e+00, 0.701087978926173e+00, 0.018242840118951e+00 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01073"></a>01073                 {0.034647074816760e+00, 0.142421601113383e+00, 0.822931324069857e+00, 0.010258563736199e+00 / 2.0}, <span class="comment">// 6-perm </span>
<a name="l01074"></a>01074                 {0.010161119296278e+00, 0.065494628082938e+00, 0.924344252620784e+00, 0.003799928855302e+00 / 2.0}  <span class="comment">// 6-perm</span>
<a name="l01075"></a>01075               };
<a name="l01076"></a>01076 
<a name="l01077"></a>01077               
<a name="l01078"></a>01078               <span class="comment">// Now call the dunavant routine to generate _points and _weights</span>
<a name="l01079"></a>01079               <a class="code" href="classlibMesh_1_1QGauss.php#a0ded5d1a09592c2643f71ed00d74ca66">dunavant_rule</a>(p, 17);
<a name="l01080"></a>01080 
<a name="l01081"></a>01081               <span class="keywordflow">return</span>;
<a name="l01082"></a>01082             }
<a name="l01083"></a>01083 
<a name="l01084"></a>01084             
<a name="l01085"></a>01085             <span class="comment">// 20th-order rule by Wandzura.  </span>
<a name="l01086"></a>01086             <span class="comment">//</span>
<a name="l01087"></a>01087             <span class="comment">// Stephen Wandzura, Hong Xiao,</span>
<a name="l01088"></a>01088             <span class="comment">// Symmetric Quadrature Rules on a Triangle,</span>
<a name="l01089"></a>01089             <span class="comment">// Computers and Mathematics with Applications,</span>
<a name="l01090"></a>01090             <span class="comment">// Volume 45, Number 12, June 2003, pages 1829-1840.</span>
<a name="l01091"></a>01091             <span class="comment">//</span>
<a name="l01092"></a>01092             <span class="comment">// Wandzura&#39;s work extends the work of Dunavant by providing degree</span>
<a name="l01093"></a>01093             <span class="comment">// 5,10,15,20,25, and 30 rules with positive weights for the triangle.</span>
<a name="l01094"></a>01094             <span class="comment">//</span>
<a name="l01095"></a>01095             <span class="comment">// Copied on 3rd July 2008 from:</span>
<a name="l01096"></a>01096             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/wandzura/wandzura.f90</span>
<a name="l01097"></a>01097           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1fd67e9ea1cf7030e0e5b9c6e82698a2">TWENTIETH</a>:
<a name="l01098"></a>01098             {
<a name="l01099"></a>01099               <span class="comment">// The equivalent concial product rule would have 121 points</span>
<a name="l01100"></a>01100               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (85);
<a name="l01101"></a>01101               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(85);
<a name="l01102"></a>01102 
<a name="l01103"></a>01103               <span class="comment">// The raw data for the quadrature rule.</span>
<a name="l01104"></a>01104               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p[19][4] = {
<a name="l01105"></a>01105                 {0.33333333333333e+00,                  0.0,                  0.0, 0.2761042699769952e-01 / 2.0}, <span class="comment">// 1-perm</span>
<a name="l01106"></a>01106                 {0.00150064932443e+00, 0.49924967533779e+00,                  0.0, 0.1779029547326740e-02 / 2.0}, <span class="comment">// 3-perm </span>
<a name="l01107"></a>01107                 {0.09413975193895e+00, 0.45293012403052e+00,                  0.0, 0.2011239811396117e-01 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01108"></a>01108                 {0.20447212408953e+00, 0.39776393795524e+00,                  0.0, 0.2681784725933157e-01 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01109"></a>01109                 {0.47099959493443e+00, 0.26450020253279e+00,                  0.0, 0.2452313380150201e-01 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01110"></a>01110                 {0.57796207181585e+00, 0.21101896409208e+00,                  0.0, 0.1639457841069539e-01 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01111"></a>01111                 {0.78452878565746e+00, 0.10773560717127e+00,                  0.0, 0.1479590739864960e-01 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01112"></a>01112                 {0.92186182432439e+00, 0.03906908783780e+00,                  0.0, 0.4579282277704251e-02 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01113"></a>01113                 {0.97765124054134e+00, 0.01117437972933e+00,                  0.0, 0.1651826515576217e-02 / 2.0}, <span class="comment">// 3-perm</span>
<a name="l01114"></a>01114                 {0.00534961818734e+00, 0.06354966590835e+00, 0.93110071590431e+00, 0.2349170908575584e-02 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01115"></a>01115                 {0.00795481706620e+00, 0.15710691894071e+00, 0.83493826399309e+00, 0.4465925754181793e-02 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01116"></a>01116                 {0.01042239828126e+00, 0.39564211436437e+00, 0.59393548735436e+00, 0.6099566807907972e-02 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01117"></a>01117                 {0.01096441479612e+00, 0.27316757071291e+00, 0.71586801449097e+00, 0.6891081327188203e-02 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01118"></a>01118                 {0.03856671208546e+00, 0.10178538248502e+00, 0.85964790542952e+00, 0.7997475072478163e-02 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01119"></a>01119                 {0.03558050781722e+00, 0.44665854917641e+00, 0.51776094300637e+00, 0.7386134285336024e-02 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01120"></a>01120                 {0.04967081636276e+00, 0.19901079414950e+00, 0.75131838948773e+00, 0.1279933187864826e-01 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01121"></a>01121                 {0.05851972508433e+00, 0.32426118369228e+00, 0.61721909122339e+00, 0.1725807117569655e-01 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01122"></a>01122                 {0.12149778700439e+00, 0.20853136321013e+00, 0.66997084978547e+00, 0.1867294590293547e-01 / 2.0}, <span class="comment">// 6-perm</span>
<a name="l01123"></a>01123                 {0.14071084494394e+00, 0.32317056653626e+00, 0.53611858851980e+00, 0.2281822405839526e-01 / 2.0}  <span class="comment">// 6-perm</span>
<a name="l01124"></a>01124               };
<a name="l01125"></a>01125 
<a name="l01126"></a>01126               
<a name="l01127"></a>01127               <span class="comment">// Now call the dunavant routine to generate _points and _weights</span>
<a name="l01128"></a>01128               <a class="code" href="classlibMesh_1_1QGauss.php#a0ded5d1a09592c2643f71ed00d74ca66">dunavant_rule</a>(p, 19);
<a name="l01129"></a>01129 
<a name="l01130"></a>01130               <span class="keywordflow">return</span>;
<a name="l01131"></a>01131             }
<a name="l01132"></a>01132 
<a name="l01133"></a>01133 
<a name="l01134"></a>01134 
<a name="l01135"></a>01135             <span class="comment">// 25th-order rule by Wandzura.  </span>
<a name="l01136"></a>01136             <span class="comment">//</span>
<a name="l01137"></a>01137             <span class="comment">// Stephen Wandzura, Hong Xiao,</span>
<a name="l01138"></a>01138             <span class="comment">// Symmetric Quadrature Rules on a Triangle,</span>
<a name="l01139"></a>01139             <span class="comment">// Computers and Mathematics with Applications,</span>
<a name="l01140"></a>01140             <span class="comment">// Volume 45, Number 12, June 2003, pages 1829-1840.</span>
<a name="l01141"></a>01141             <span class="comment">//</span>
<a name="l01142"></a>01142             <span class="comment">// Wandzura&#39;s work extends the work of Dunavant by providing degree</span>
<a name="l01143"></a>01143             <span class="comment">// 5,10,15,20,25, and 30 rules with positive weights for the triangle.</span>
<a name="l01144"></a>01144             <span class="comment">//</span>
<a name="l01145"></a>01145             <span class="comment">// Copied on 3rd July 2008 from:</span>
<a name="l01146"></a>01146             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/wandzura/wandzura.f90</span>
<a name="l01147"></a>01147             <span class="comment">// case TWENTYFIRST: // fall through to 121 point conical product rule below</span>
<a name="l01148"></a>01148           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac53c44bf97483f77b3b8f12689d1025f">TWENTYSECOND</a>:  
<a name="l01149"></a>01149           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1dda25317008178eb86eef7e967e9ecf">TWENTYTHIRD</a>:   
<a name="l01150"></a>01150           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa8093001568608e51bbe10f03c871fc41">TWENTYFOURTH</a>:        
<a name="l01151"></a>01151           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad2f79bea88fd463e33a7800d828bded9">TWENTYFIFTH</a>:
<a name="l01152"></a>01152             {
<a name="l01153"></a>01153               <span class="comment">// The equivalent concial product rule would have 169 points</span>
<a name="l01154"></a>01154               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (126);
<a name="l01155"></a>01155               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(126);
<a name="l01156"></a>01156 
<a name="l01157"></a>01157               <span class="comment">// The raw data for the quadrature rule.</span>
<a name="l01158"></a>01158               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p[26][4] = {
<a name="l01159"></a>01159                 {0.02794648307317e+00, 0.48602675846341e+00,                  0.0, 0.8005581880020417e-02 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01160"></a>01160                 {0.13117860132765e+00, 0.43441069933617e+00,                  0.0, 0.1594707683239050e-01 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01161"></a>01161                 {0.22022172951207e+00, 0.38988913524396e+00,                  0.0, 0.1310914123079553e-01 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01162"></a>01162                 {0.40311353196039e+00, 0.29844323401980e+00,                  0.0, 0.1958300096563562e-01 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01163"></a>01163                 {0.53191165532526e+00, 0.23404417233737e+00,                  0.0, 0.1647088544153727e-01 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01164"></a>01164                 {0.69706333078196e+00, 0.15146833460902e+00,                  0.0, 0.8547279074092100e-02 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01165"></a>01165                 {0.77453221290801e+00, 0.11273389354599e+00,                  0.0, 0.8161885857226492e-02 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01166"></a>01166                 {0.84456861581695e+00, 0.07771569209153e+00,                  0.0, 0.6121146539983779e-02 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01167"></a>01167                 {0.93021381277141e+00, 0.03489309361430e+00,                  0.0, 0.2908498264936665e-02 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01168"></a>01168                 {0.98548363075813e+00, 0.00725818462093e+00,                  0.0, 0.6922752456619963e-03 / 2.0},  <span class="comment">// 3-perm</span>
<a name="l01169"></a>01169                 {0.00129235270444e+00, 0.22721445215336e+00, 0.77149319514219e+00, 0.1248289199277397e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01170"></a>01170                 {0.00539970127212e+00, 0.43501055485357e+00, 0.55958974387431e+00, 0.3404752908803022e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01171"></a>01171                 {0.00638400303398e+00, 0.32030959927220e+00, 0.67330639769382e+00, 0.3359654326064051e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01172"></a>01172                 {0.00502821150199e+00, 0.09175032228001e+00, 0.90322146621800e+00, 0.1716156539496754e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01173"></a>01173                 {0.00682675862178e+00, 0.03801083585872e+00, 0.95516240551949e+00, 0.1480856316715606e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01174"></a>01174                 {0.01001619963993e+00, 0.15742521848531e+00, 0.83255858187476e+00, 0.3511312610728685e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01175"></a>01175                 {0.02575781317339e+00, 0.23988965977853e+00, 0.73435252704808e+00, 0.7393550149706484e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01176"></a>01176                 {0.03022789811992e+00, 0.36194311812606e+00, 0.60782898375402e+00, 0.7983087477376558e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01177"></a>01177                 {0.03050499010716e+00, 0.08355196095483e+00, 0.88594304893801e+00, 0.4355962613158041e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01178"></a>01178                 {0.04595654736257e+00, 0.14844322073242e+00, 0.80560023190501e+00, 0.7365056701417832e-02 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01179"></a>01179                 {0.06744280054028e+00, 0.28373970872753e+00, 0.64881749073219e+00, 0.1096357284641955e-01 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01180"></a>01180                 {0.07004509141591e+00, 0.40689937511879e+00, 0.52305553346530e+00, 0.1174996174354112e-01 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01181"></a>01181                 {0.08391152464012e+00, 0.19411398702489e+00, 0.72197448833499e+00, 0.1001560071379857e-01 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01182"></a>01182                 {0.12037553567715e+00, 0.32413434700070e+00, 0.55549011732214e+00, 0.1330964078762868e-01 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01183"></a>01183                 {0.14806689915737e+00, 0.22927748355598e+00, 0.62265561728665e+00, 0.1415444650522614e-01 / 2.0},  <span class="comment">// 6-perm</span>
<a name="l01184"></a>01184                 {0.19177186586733e+00, 0.32561812259598e+00, 0.48261001153669e+00, 0.1488137956116801e-01 / 2.0}   <span class="comment">// 6-perm</span>
<a name="l01185"></a>01185               };
<a name="l01186"></a>01186 
<a name="l01187"></a>01187               
<a name="l01188"></a>01188               <span class="comment">// Now call the dunavant routine to generate _points and _weights</span>
<a name="l01189"></a>01189               <a class="code" href="classlibMesh_1_1QGauss.php#a0ded5d1a09592c2643f71ed00d74ca66">dunavant_rule</a>(p, 26);
<a name="l01190"></a>01190 
<a name="l01191"></a>01191               <span class="keywordflow">return</span>;
<a name="l01192"></a>01192             }
<a name="l01193"></a>01193 
<a name="l01194"></a>01194 
<a name="l01195"></a>01195 
<a name="l01196"></a>01196             <span class="comment">// 30th-order rule by Wandzura.  </span>
<a name="l01197"></a>01197             <span class="comment">//</span>
<a name="l01198"></a>01198             <span class="comment">// Stephen Wandzura, Hong Xiao,</span>
<a name="l01199"></a>01199             <span class="comment">// Symmetric Quadrature Rules on a Triangle,</span>
<a name="l01200"></a>01200             <span class="comment">// Computers and Mathematics with Applications,</span>
<a name="l01201"></a>01201             <span class="comment">// Volume 45, Number 12, June 2003, pages 1829-1840.</span>
<a name="l01202"></a>01202             <span class="comment">//</span>
<a name="l01203"></a>01203             <span class="comment">// Wandzura&#39;s work extends the work of Dunavant by providing degree</span>
<a name="l01204"></a>01204             <span class="comment">// 5,10,15,20,25, and 30 rules with positive weights for the triangle.</span>
<a name="l01205"></a>01205             <span class="comment">//</span>
<a name="l01206"></a>01206             <span class="comment">// Copied on 3rd July 2008 from:</span>
<a name="l01207"></a>01207             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/wandzura/wandzura.f90</span>
<a name="l01208"></a>01208           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa5f33eeba0f7239d41b54654ce8d99aa3">TWENTYSIXTH</a>:   
<a name="l01209"></a>01209           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0facb1defec8f9bfcd21f5ef0f62fcacd2f">TWENTYSEVENTH</a>: 
<a name="l01210"></a>01210           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa0e295eb2dfc5e7e8c49b433ae27b1369">TWENTYEIGHTH</a>:  
<a name="l01211"></a>01211           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2e33cfffe6c21901c488cc5c58d5bae9">TWENTYNINTH</a>:         
<a name="l01212"></a>01212           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fac64b552bcc7fd10e6a8723de2e2a1250">THIRTIETH</a>:
<a name="l01213"></a>01213             {
<a name="l01214"></a>01214               <span class="comment">// The equivalent concial product rule would have 256 points</span>
<a name="l01215"></a>01215               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (175);
<a name="l01216"></a>01216               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(175);
<a name="l01217"></a>01217 
<a name="l01218"></a>01218               <span class="comment">// The raw data for the quadrature rule.</span>
<a name="l01219"></a>01219               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p[36][4] = {
<a name="l01220"></a>01220                 {0.33333333333333e+00,                  0.0,                  0.0, 0.1557996020289920e-01 / 2.0}, <span class="comment">// 1-perm </span>
<a name="l01221"></a>01221                 {0.00733011643277e+00, 0.49633494178362e+00,                  0.0, 0.3177233700534134e-02 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01222"></a>01222                 {0.08299567580296e+00, 0.45850216209852e+00,                  0.0, 0.1048342663573077e-01 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01223"></a>01223                 {0.15098095612541e+00, 0.42450952193729e+00,                  0.0, 0.1320945957774363e-01 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01224"></a>01224                 {0.23590585989217e+00, 0.38204707005392e+00,                  0.0, 0.1497500696627150e-01 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01225"></a>01225                 {0.43802430840785e+00, 0.28098784579608e+00,                  0.0, 0.1498790444338419e-01 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01226"></a>01226                 {0.54530204829193e+00, 0.22734897585403e+00,                  0.0, 0.1333886474102166e-01 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01227"></a>01227                 {0.65088177698254e+00, 0.17455911150873e+00,                  0.0, 0.1088917111390201e-01 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01228"></a>01228                 {0.75348314559713e+00, 0.12325842720144e+00,                  0.0, 0.8189440660893461e-02 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01229"></a>01229                 {0.83983154221561e+00, 0.08008422889220e+00,                  0.0, 0.5575387588607785e-02 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01230"></a>01230                 {0.90445106518420e+00, 0.04777446740790e+00,                  0.0, 0.3191216473411976e-02 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01231"></a>01231                 {0.95655897063972e+00, 0.02172051468014e+00,                  0.0, 0.1296715144327045e-02 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01232"></a>01232                 {0.99047064476913e+00, 0.00476467761544e+00,                  0.0, 0.2982628261349172e-03 / 2.0}, <span class="comment">// 3-perm  </span>
<a name="l01233"></a>01233                 {0.00092537119335e+00, 0.41529527091331e+00, 0.58377935789334e+00, 0.9989056850788964e-03 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01234"></a>01234                 {0.00138592585556e+00, 0.06118990978535e+00, 0.93742416435909e+00, 0.4628508491732533e-03 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01235"></a>01235                 {0.00368241545591e+00, 0.16490869013691e+00, 0.83140889440718e+00, 0.1234451336382413e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01236"></a>01236                 {0.00390322342416e+00, 0.02503506223200e+00, 0.97106171434384e+00, 0.5707198522432062e-03 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01237"></a>01237                 {0.00323324815501e+00, 0.30606446515110e+00, 0.69070228669389e+00, 0.1126946125877624e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01238"></a>01238                 {0.00646743211224e+00, 0.10707328373022e+00, 0.88645928415754e+00, 0.1747866949407337e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01239"></a>01239                 {0.00324747549133e+00, 0.22995754934558e+00, 0.76679497516308e+00, 0.1182818815031657e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01240"></a>01240                 {0.00867509080675e+00, 0.33703663330578e+00, 0.65428827588746e+00, 0.1990839294675034e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01241"></a>01241                 {0.01559702646731e+00, 0.05625657618206e+00, 0.92814639735063e+00, 0.1900412795035980e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01242"></a>01242                 {0.01797672125369e+00, 0.40245137521240e+00, 0.57957190353391e+00, 0.4498365808817451e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01243"></a>01243                 {0.01712424535389e+00, 0.24365470201083e+00, 0.73922105263528e+00, 0.3478719460274719e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01244"></a>01244                 {0.02288340534658e+00, 0.16538958561453e+00, 0.81172700903888e+00, 0.4102399036723953e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01245"></a>01245                 {0.03273759728777e+00, 0.09930187449585e+00, 0.86796052821639e+00, 0.4021761549744162e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01246"></a>01246                 {0.03382101234234e+00, 0.30847833306905e+00, 0.65770065458860e+00, 0.6033164660795066e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01247"></a>01247                 {0.03554761446002e+00, 0.46066831859211e+00, 0.50378406694787e+00, 0.3946290302129598e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01248"></a>01248                 {0.05053979030687e+00, 0.21881529945393e+00, 0.73064491023920e+00, 0.6644044537680268e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01249"></a>01249                 {0.05701471491573e+00, 0.37920955156027e+00, 0.56377573352399e+00, 0.8254305856078458e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01250"></a>01250                 {0.06415280642120e+00, 0.14296081941819e+00, 0.79288637416061e+00, 0.6496056633406411e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01251"></a>01251                 {0.08050114828763e+00, 0.28373128210592e+00, 0.63576756960645e+00, 0.9252778144146602e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01252"></a>01252                 {0.10436706813453e+00, 0.19673744100444e+00, 0.69889549086103e+00, 0.9164920726294280e-02 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01253"></a>01253                 {0.11384489442875e+00, 0.35588914121166e+00, 0.53026596435959e+00, 0.1156952462809767e-01 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01254"></a>01254                 {0.14536348771552e+00, 0.25981868535191e+00, 0.59481782693256e+00, 0.1176111646760917e-01 / 2.0}, <span class="comment">// 6-perm  </span>
<a name="l01255"></a>01255                 {0.18994565282198e+00, 0.32192318123130e+00, 0.48813116594672e+00, 0.1382470218216540e-01 / 2.0}  <span class="comment">// 6-perm   </span>
<a name="l01256"></a>01256               };
<a name="l01257"></a>01257 
<a name="l01258"></a>01258               
<a name="l01259"></a>01259               <span class="comment">// Now call the dunavant routine to generate _points and _weights</span>
<a name="l01260"></a>01260               <a class="code" href="classlibMesh_1_1QGauss.php#a0ded5d1a09592c2643f71ed00d74ca66">dunavant_rule</a>(p, 36);
<a name="l01261"></a>01261 
<a name="l01262"></a>01262               <span class="keywordflow">return</span>;
<a name="l01263"></a>01263             }
<a name="l01264"></a>01264             
<a name="l01265"></a>01265             
<a name="l01266"></a>01266             <span class="comment">// By default, we fall back on the conical product rules.  If the user</span>
<a name="l01267"></a>01267             <span class="comment">// requests an order higher than what is currently available in the 1D</span>
<a name="l01268"></a>01268             <span class="comment">// rules, an error will be thrown from the respective 1D code.</span>
<a name="l01269"></a>01269           <span class="keywordflow">default</span>:
<a name="l01270"></a>01270             {
<a name="l01271"></a>01271               <span class="comment">// The following quadrature rules are generated as</span>
<a name="l01272"></a>01272               <span class="comment">// conical products.  These tend to be non-optimal</span>
<a name="l01273"></a>01273               <span class="comment">// (use too many points, cluster points in certain</span>
<a name="l01274"></a>01274               <span class="comment">// regions of the domain) but they are quite easy to</span>
<a name="l01275"></a>01275               <span class="comment">// automatically generate using a 1D Gauss rule on</span>
<a name="l01276"></a>01276               <span class="comment">// [0,1] and two 1D Jacobi-Gauss rules on [0,1].</span>
<a name="l01277"></a>01277               <a class="code" href="classlibMesh_1_1QConical.php">QConical</a> conical_rule(2, _order);
<a name="l01278"></a>01278               conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(_type, p);
<a name="l01279"></a>01279 
<a name="l01280"></a>01280               <span class="comment">// Swap points and weights with the about-to-be destroyed rule.</span>
<a name="l01281"></a>01281               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.swap (conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">get_points</a>() );
<a name="l01282"></a>01282               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.swap(conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">get_weights</a>());
<a name="l01283"></a>01283                   
<a name="l01284"></a>01284               <span class="keywordflow">return</span>;
<a name="l01285"></a>01285             }
<a name="l01286"></a>01286           }
<a name="l01287"></a>01287       }
<a name="l01288"></a>01288 
<a name="l01289"></a>01289             
<a name="l01290"></a>01290       <span class="comment">//---------------------------------------------</span>
<a name="l01291"></a>01291       <span class="comment">// Unsupported type</span>
<a name="l01292"></a>01292     <span class="keywordflow">default</span>:
<a name="l01293"></a>01293       {
<a name="l01294"></a>01294         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;Element type not supported!:&quot;</span> &lt;&lt; _type &lt;&lt; std::endl;
<a name="l01295"></a>01295         libmesh_error();
<a name="l01296"></a>01296       }
<a name="l01297"></a>01297     }
<a name="l01298"></a>01298 
<a name="l01299"></a>01299   libmesh_error();
<a name="l01300"></a>01300 
<a name="l01301"></a>01301   <span class="keywordflow">return</span>;
<a name="l01302"></a>01302 
<a name="l01303"></a>01303 <span class="preprocessor">#endif</span>
<a name="l01304"></a>01304 <span class="preprocessor"></span>}
<a name="l01305"></a>01305 
<a name="l01306"></a>01306 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
