<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_gauss_3D.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__gauss__3D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_gauss_3D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__conical_8h.php">quadrature_conical.h</a>&quot;</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gm_8h.php">quadrature_gm.h</a>&quot;</span>
<a name="l00026"></a>00026 
<a name="l00027"></a>00027 <span class="keyword">namespace </span>libMesh
<a name="l00028"></a>00028 {
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="classlibMesh_1_1QGauss.php#aa50dd7f01f3a38222412071d7e58a542">00030</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QGauss.php#aa50dd7f01f3a38222412071d7e58a542">QGauss::init_3D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type,
<a name="l00031"></a>00031                      <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00034"></a>00034 <span class="preprocessor"></span>  
<a name="l00035"></a>00035   <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00036"></a>00036   <span class="comment">// 3D quadrature rules</span>
<a name="l00037"></a>00037   <span class="keywordflow">switch</span> (_type)
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039       <span class="comment">//---------------------------------------------</span>
<a name="l00040"></a>00040       <span class="comment">// Hex quadrature rules</span>
<a name="l00041"></a>00041     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00042"></a>00042     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00043"></a>00043     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00044"></a>00044       {
<a name="l00045"></a>00045         <span class="comment">// We compute the 3D quadrature rule as a tensor</span>
<a name="l00046"></a>00046         <span class="comment">// product of the 1D quadrature rule.</span>
<a name="l00047"></a>00047         <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> q1D(1,_order);
<a name="l00048"></a>00048         q1D.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>,p);
<a name="l00049"></a>00049 
<a name="l00050"></a>00050         tensor_product_hex( q1D );
<a name="l00051"></a>00051         
<a name="l00052"></a>00052         <span class="keywordflow">return</span>;
<a name="l00053"></a>00053       }
<a name="l00054"></a>00054 
<a name="l00055"></a>00055 
<a name="l00056"></a>00056       
<a name="l00057"></a>00057       <span class="comment">//---------------------------------------------</span>
<a name="l00058"></a>00058       <span class="comment">// Tetrahedral quadrature rules</span>
<a name="l00059"></a>00059     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00060"></a>00060     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00061"></a>00061       {
<a name="l00062"></a>00062         <span class="keywordflow">switch</span>(_order + 2*p)
<a name="l00063"></a>00063           {
<a name="l00064"></a>00064             <span class="comment">// Taken from pg. 222 of &quot;The finite element method,&quot; vol. 1</span>
<a name="l00065"></a>00065             <span class="comment">// ed. 5 by Zienkiewicz &amp; Taylor</span>
<a name="l00066"></a>00066           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fab999dd3da94a1ab81b0359e1fd11c6fa">CONSTANT</a>:
<a name="l00067"></a>00067           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa4b49c3582d6a0be3b89e3af4493edda7">FIRST</a>:
<a name="l00068"></a>00068             {
<a name="l00069"></a>00069               <span class="comment">// Exact for linears</span>
<a name="l00070"></a>00070               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(1);
<a name="l00071"></a>00071               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(1);
<a name="l00072"></a>00072                     
<a name="l00073"></a>00073                     
<a name="l00074"></a>00074               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0) = .25;
<a name="l00075"></a>00075               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](1) = .25;
<a name="l00076"></a>00076               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](2) = .25;
<a name="l00077"></a>00077                     
<a name="l00078"></a>00078               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0] = .1666666666666666666666666666666666666666666667L;
<a name="l00079"></a>00079                     
<a name="l00080"></a>00080               <span class="keywordflow">return</span>;
<a name="l00081"></a>00081             }
<a name="l00082"></a>00082           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00083"></a>00083             {
<a name="l00084"></a>00084               <span class="comment">// Exact for quadratics</span>
<a name="l00085"></a>00085               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(4);
<a name="l00086"></a>00086               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(4);
<a name="l00087"></a>00087                     
<a name="l00088"></a>00088                     
<a name="l00089"></a>00089               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a = .585410196624969;
<a name="l00090"></a>00090               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b = .138196601125011;
<a name="l00091"></a>00091                     
<a name="l00092"></a>00092               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0) = a;
<a name="l00093"></a>00093               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](1) = b;
<a name="l00094"></a>00094               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](2) = b;
<a name="l00095"></a>00095                     
<a name="l00096"></a>00096               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](0) = b;
<a name="l00097"></a>00097               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](1) = a;
<a name="l00098"></a>00098               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](2) = b;
<a name="l00099"></a>00099                     
<a name="l00100"></a>00100               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](0) = b;
<a name="l00101"></a>00101               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](1) = b;
<a name="l00102"></a>00102               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](2) = a;
<a name="l00103"></a>00103                     
<a name="l00104"></a>00104               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](0) = b;
<a name="l00105"></a>00105               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](1) = b;
<a name="l00106"></a>00106               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](2) = b;
<a name="l00107"></a>00107                     
<a name="l00108"></a>00108                     
<a name="l00109"></a>00109                     
<a name="l00110"></a>00110               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0] = .0416666666666666666666666666666666666666666667;
<a name="l00111"></a>00111               _weights[1] = _weights[0];
<a name="l00112"></a>00112               _weights[2] = _weights[0];
<a name="l00113"></a>00113               _weights[3] = _weights[0];
<a name="l00114"></a>00114                     
<a name="l00115"></a>00115               <span class="keywordflow">return</span>;
<a name="l00116"></a>00116             }
<a name="l00117"></a>00117 
<a name="l00118"></a>00118 
<a name="l00119"></a>00119             
<a name="l00120"></a>00120             <span class="comment">// Can be found in the class notes</span>
<a name="l00121"></a>00121             <span class="comment">// http://www.cs.rpi.edu/~flaherje/FEM/fem6.ps</span>
<a name="l00122"></a>00122             <span class="comment">// by Flaherty.</span>
<a name="l00123"></a>00123             <span class="comment">//</span>
<a name="l00124"></a>00124             <span class="comment">// Caution: this rule has a negative weight and may be</span>
<a name="l00125"></a>00125             <span class="comment">// unsuitable for some problems.</span>
<a name="l00126"></a>00126             <span class="comment">// Exact for cubics.</span>
<a name="l00127"></a>00127             <span class="comment">//</span>
<a name="l00128"></a>00128             <span class="comment">// Note: Keast (see ref. elsewhere in this file) also gives</span>
<a name="l00129"></a>00129             <span class="comment">// a third-order rule with positive weights, but it contains points</span>
<a name="l00130"></a>00130             <span class="comment">// on the ref. elt. boundary, making it less suitable for FEM calculations.</span>
<a name="l00131"></a>00131           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00132"></a>00132             {
<a name="l00133"></a>00133               <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1QBase.php#a6f1f4bb99c359f881b0b5b2695bb2cde">allow_rules_with_negative_weights</a>)
<a name="l00134"></a>00134                 {
<a name="l00135"></a>00135                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(5);
<a name="l00136"></a>00136                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(5);
<a name="l00137"></a>00137                     
<a name="l00138"></a>00138                     
<a name="l00139"></a>00139                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0) = .25;
<a name="l00140"></a>00140                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](1) = .25;
<a name="l00141"></a>00141                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](2) = .25;
<a name="l00142"></a>00142                     
<a name="l00143"></a>00143                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](0) = .5;
<a name="l00144"></a>00144                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](1) = .16666666666666666666666666666666666666666667;
<a name="l00145"></a>00145                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](2) = .16666666666666666666666666666666666666666667;
<a name="l00146"></a>00146                     
<a name="l00147"></a>00147                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](0) = .16666666666666666666666666666666666666666667;
<a name="l00148"></a>00148                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](1) = .5;
<a name="l00149"></a>00149                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](2) = .16666666666666666666666666666666666666666667;
<a name="l00150"></a>00150                     
<a name="l00151"></a>00151                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](0) = .16666666666666666666666666666666666666666667;
<a name="l00152"></a>00152                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](1) = .16666666666666666666666666666666666666666667;
<a name="l00153"></a>00153                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](2) = .5;
<a name="l00154"></a>00154                     
<a name="l00155"></a>00155                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[4](0) = .16666666666666666666666666666666666666666667;
<a name="l00156"></a>00156                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[4](1) = .16666666666666666666666666666666666666666667;
<a name="l00157"></a>00157                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[4](2) = .16666666666666666666666666666666666666666667;
<a name="l00158"></a>00158                     
<a name="l00159"></a>00159                     
<a name="l00160"></a>00160                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0] = -.133333333333333333333333333333333333333333333;
<a name="l00161"></a>00161                   _weights[1] = .075;
<a name="l00162"></a>00162                   _weights[2] = _weights[1];
<a name="l00163"></a>00163                   _weights[3] = _weights[1];
<a name="l00164"></a>00164                   _weights[4] = _weights[1];
<a name="l00165"></a>00165                     
<a name="l00166"></a>00166                   <span class="keywordflow">return</span>;
<a name="l00167"></a>00167                 } <span class="comment">// end if (allow_rules_with_negative_weights)</span>
<a name="l00168"></a>00168               <span class="keywordflow">else</span>
<a name="l00169"></a>00169                 {
<a name="l00170"></a>00170                   <span class="comment">// If a rule with postive weights is required, the 2x2x2 conical</span>
<a name="l00171"></a>00171                   <span class="comment">// product rule is third-order accurate and has less points than</span>
<a name="l00172"></a>00172                   <span class="comment">// the next-available positive-weight rule at FIFTH order. </span>
<a name="l00173"></a>00173                   <a class="code" href="classlibMesh_1_1QConical.php">QConical</a> conical_rule(3, _order);
<a name="l00174"></a>00174                   conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(_type, p);
<a name="l00175"></a>00175 
<a name="l00176"></a>00176                   <span class="comment">// Swap points and weights with the about-to-be destroyed rule.</span>
<a name="l00177"></a>00177                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.swap (conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">get_points</a>() );
<a name="l00178"></a>00178                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.swap(conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">get_weights</a>());
<a name="l00179"></a>00179 
<a name="l00180"></a>00180                   <span class="keywordflow">return</span>;
<a name="l00181"></a>00181                 }
<a name="l00182"></a>00182               <span class="comment">// Note: if !allow_rules_with_negative_weights, fall through to next case.</span>
<a name="l00183"></a>00183             }
<a name="l00184"></a>00184 
<a name="l00185"></a>00185             
<a name="l00186"></a>00186 
<a name="l00187"></a>00187             <span class="comment">// Originally a Keast rule,</span>
<a name="l00188"></a>00188             <span class="comment">//    Patrick Keast,</span>
<a name="l00189"></a>00189             <span class="comment">//    Moderate Degree Tetrahedral Quadrature Formulas,</span>
<a name="l00190"></a>00190             <span class="comment">//    Computer Methods in Applied Mechanics and Engineering,</span>
<a name="l00191"></a>00191             <span class="comment">//    Volume 55, Number 3, May 1986, pages 339-348.</span>
<a name="l00192"></a>00192             <span class="comment">//</span>
<a name="l00193"></a>00193             <span class="comment">// Can also be found the class notes</span>
<a name="l00194"></a>00194             <span class="comment">// http://www.cs.rpi.edu/~flaherje/FEM/fem6.ps</span>
<a name="l00195"></a>00195             <span class="comment">// by Flaherty.</span>
<a name="l00196"></a>00196             <span class="comment">//</span>
<a name="l00197"></a>00197             <span class="comment">// Caution: this rule has a negative weight and may be</span>
<a name="l00198"></a>00198             <span class="comment">// unsuitable for some problems.</span>
<a name="l00199"></a>00199           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00200"></a>00200             {
<a name="l00201"></a>00201               <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1QBase.php#a6f1f4bb99c359f881b0b5b2695bb2cde">allow_rules_with_negative_weights</a>)
<a name="l00202"></a>00202                 {
<a name="l00203"></a>00203                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(11);
<a name="l00204"></a>00204                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(11);
<a name="l00205"></a>00205                     
<a name="l00206"></a>00206                   <span class="comment">// The raw data for the quadrature rule.</span>
<a name="l00207"></a>00207                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p[3][4] = {
<a name="l00208"></a>00208                     {0.250000000000000000e+00,                         0.,                            0.,  -0.131555555555555556e-01},  <span class="comment">// 1</span>
<a name="l00209"></a>00209                     {0.785714285714285714e+00,   0.714285714285714285e-01,                            0.,   0.762222222222222222e-02},  <span class="comment">// 4</span>
<a name="l00210"></a>00210                     {0.399403576166799219e+00,                         0.,      0.100596423833200785e+00,   0.248888888888888889e-01}   <span class="comment">// 6</span>
<a name="l00211"></a>00211                   };
<a name="l00212"></a>00212 
<a name="l00213"></a>00213               
<a name="l00214"></a>00214                   <span class="comment">// Now call the keast routine to generate _points and _weights</span>
<a name="l00215"></a>00215                   <a class="code" href="classlibMesh_1_1QGauss.php#aae03c6302651a828b86abe89ea85b32c">keast_rule</a>(p, 3);
<a name="l00216"></a>00216 
<a name="l00217"></a>00217                   <span class="keywordflow">return</span>;
<a name="l00218"></a>00218                 } <span class="comment">// end if (allow_rules_with_negative_weights)</span>
<a name="l00219"></a>00219               <span class="comment">// Note: if !allow_rules_with_negative_weights, fall through to next case.</span>
<a name="l00220"></a>00220             }
<a name="l00221"></a>00221 
<a name="l00222"></a>00222 
<a name="l00223"></a>00223 
<a name="l00224"></a>00224             
<a name="l00225"></a>00225             <span class="comment">// Walkington&#39;s fifth-order 14-point rule from</span>
<a name="l00226"></a>00226             <span class="comment">// &quot;Quadrature on Simplices of Arbitrary Dimension&quot;</span>
<a name="l00227"></a>00227             <span class="comment">//</span>
<a name="l00228"></a>00228             <span class="comment">// We originally had a Keast rule here, but this rule had</span>
<a name="l00229"></a>00229             <span class="comment">// more points than an equivalent rule by Walkington and</span>
<a name="l00230"></a>00230             <span class="comment">// also contained points on the boundary of the ref. elt,</span>
<a name="l00231"></a>00231             <span class="comment">// making it less suitable for FEM calculations.</span>
<a name="l00232"></a>00232           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00233"></a>00233             {
<a name="l00234"></a>00234               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(14);
<a name="l00235"></a>00235               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(14);
<a name="l00236"></a>00236 
<a name="l00237"></a>00237               <span class="comment">// permutations of these points and suitably-modified versions of</span>
<a name="l00238"></a>00238               <span class="comment">// these points are the quadrature point locations</span>
<a name="l00239"></a>00239               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> a[3] = {0.31088591926330060980,    <span class="comment">// a1 from the paper</span>
<a name="l00240"></a>00240                                  0.092735250310891226402,   <span class="comment">// a2 from the paper</span>
<a name="l00241"></a>00241                                  0.045503704125649649492};  <span class="comment">// a3 from the paper</span>
<a name="l00242"></a>00242 
<a name="l00243"></a>00243               <span class="comment">// weights.  a[] and w[] are the only floating-point inputs required</span>
<a name="l00244"></a>00244               <span class="comment">// for this rule.</span>
<a name="l00245"></a>00245               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> <a class="code" href="classlibMesh_1_1QBase.php#a330408929f8ec92d574ede28c7781b24">w</a>[3] = {0.018781320953002641800,    <span class="comment">// w1 from the paper</span>
<a name="l00246"></a>00246                                  0.012248840519393658257,    <span class="comment">// w2 from the paper</span>
<a name="l00247"></a>00247                                  0.0070910034628469110730};  <span class="comment">// w3 from the paper</span>
<a name="l00248"></a>00248 
<a name="l00249"></a>00249               <span class="comment">// The first two sets of 4 points are formed in a similar manner</span>
<a name="l00250"></a>00250               <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> i=0; i&lt;2; ++i)
<a name="l00251"></a>00251                 {
<a name="l00252"></a>00252                   <span class="comment">// Where we will insert values into _points and _weights</span>
<a name="l00253"></a>00253                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset=4*i;
<a name="l00254"></a>00254 
<a name="l00255"></a>00255                   <span class="comment">// Stuff points and weights values into their arrays</span>
<a name="l00256"></a>00256                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b = 1. - 3.*a[i];
<a name="l00257"></a>00257 
<a name="l00258"></a>00258                   <span class="comment">// Here are the permutations.  Order of these is not important,</span>
<a name="l00259"></a>00259                   <span class="comment">// all have the same weight</span>
<a name="l00260"></a>00260                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 0] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(a[i], a[i], a[i]);
<a name="l00261"></a>00261                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 1] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(a[i],    b, a[i]);
<a name="l00262"></a>00262                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 2] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(   b, a[i], a[i]);
<a name="l00263"></a>00263                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 3] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(a[i], a[i],    b);
<a name="l00264"></a>00264                                             
<a name="l00265"></a>00265                   <span class="comment">// These 4 points all have the same weights </span>
<a name="l00266"></a>00266                   <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;4; ++j)
<a name="l00267"></a>00267                     <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[offset + j] = w[i];
<a name="l00268"></a>00268                 } <span class="comment">// end for</span>
<a name="l00269"></a>00269 
<a name="l00270"></a>00270 
<a name="l00271"></a>00271               {
<a name="l00272"></a>00272                 <span class="comment">// The third set contains 6 points and is formed a little differently</span>
<a name="l00273"></a>00273                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> offset = 8;
<a name="l00274"></a>00274                 <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> b = 0.5*(1. - 2.*a[2]);
<a name="l00275"></a>00275 
<a name="l00276"></a>00276                 <span class="comment">// Here are the permutations.  Order of these is not important,</span>
<a name="l00277"></a>00277                 <span class="comment">// all have the same weight</span>
<a name="l00278"></a>00278                 <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 0] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(b   ,    b, a[2]);
<a name="l00279"></a>00279                 <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 1] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(b   , a[2], a[2]);
<a name="l00280"></a>00280                 <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 2] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(a[2], a[2],    b);
<a name="l00281"></a>00281                 <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 3] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(a[2],    b, a[2]);
<a name="l00282"></a>00282                 <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 4] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(   b, a[2],    b);
<a name="l00283"></a>00283                 <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[offset + 5] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(a[2],    b,    b);
<a name="l00284"></a>00284                   
<a name="l00285"></a>00285                 <span class="comment">// These 6 points all have the same weights </span>
<a name="l00286"></a>00286                 <span class="keywordflow">for</span> (<span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> j=0; j&lt;6; ++j)
<a name="l00287"></a>00287                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[offset + j] = w[2];
<a name="l00288"></a>00288               }
<a name="l00289"></a>00289 
<a name="l00290"></a>00290               
<a name="l00291"></a>00291               <span class="comment">// Original rule by Keast, unsuitable because it has points on the</span>
<a name="l00292"></a>00292               <span class="comment">// reference element boundary!</span>
<a name="l00293"></a>00293               <span class="comment">//              _points.resize(15);</span>
<a name="l00294"></a>00294               <span class="comment">//              _weights.resize(15);</span>
<a name="l00295"></a>00295                     
<a name="l00296"></a>00296               <span class="comment">//              _points[0](0) = 0.25;</span>
<a name="l00297"></a>00297               <span class="comment">//              _points[0](1) = 0.25;</span>
<a name="l00298"></a>00298               <span class="comment">//              _points[0](2) = 0.25;</span>
<a name="l00299"></a>00299 
<a name="l00300"></a>00300               <span class="comment">//              {</span>
<a name="l00301"></a>00301               <span class="comment">//                const Real a = 0.;</span>
<a name="l00302"></a>00302               <span class="comment">//                const Real b = 0.333333333333333333333333333333333333333;</span>
<a name="l00303"></a>00303                 
<a name="l00304"></a>00304               <span class="comment">//                _points[1](0) = a;</span>
<a name="l00305"></a>00305               <span class="comment">//                _points[1](1) = b;</span>
<a name="l00306"></a>00306               <span class="comment">//                _points[1](2) = b;</span>
<a name="l00307"></a>00307                 
<a name="l00308"></a>00308               <span class="comment">//                _points[2](0) = b;</span>
<a name="l00309"></a>00309               <span class="comment">//                _points[2](1) = a;</span>
<a name="l00310"></a>00310               <span class="comment">//                _points[2](2) = b;</span>
<a name="l00311"></a>00311                 
<a name="l00312"></a>00312               <span class="comment">//                _points[3](0) = b;</span>
<a name="l00313"></a>00313               <span class="comment">//                _points[3](1) = b;</span>
<a name="l00314"></a>00314               <span class="comment">//                _points[3](2) = a;</span>
<a name="l00315"></a>00315                 
<a name="l00316"></a>00316               <span class="comment">//                _points[4](0) = b;</span>
<a name="l00317"></a>00317               <span class="comment">//                _points[4](1) = b;</span>
<a name="l00318"></a>00318               <span class="comment">//                _points[4](2) = b;</span>
<a name="l00319"></a>00319               <span class="comment">//              }</span>
<a name="l00320"></a>00320               <span class="comment">//              {</span>
<a name="l00321"></a>00321               <span class="comment">//                const Real a = 0.7272727272727272727272727272727272727272727272727272727;</span>
<a name="l00322"></a>00322               <span class="comment">//                const Real b = 0.0909090909090909090909090909090909090909090909090909091;</span>
<a name="l00323"></a>00323                 
<a name="l00324"></a>00324               <span class="comment">//                _points[5](0) = a;</span>
<a name="l00325"></a>00325               <span class="comment">//                _points[5](1) = b;</span>
<a name="l00326"></a>00326               <span class="comment">//                _points[5](2) = b;</span>
<a name="l00327"></a>00327                 
<a name="l00328"></a>00328               <span class="comment">//                _points[6](0) = b;</span>
<a name="l00329"></a>00329               <span class="comment">//                _points[6](1) = a;</span>
<a name="l00330"></a>00330               <span class="comment">//                _points[6](2) = b;</span>
<a name="l00331"></a>00331                 
<a name="l00332"></a>00332               <span class="comment">//                _points[7](0) = b;</span>
<a name="l00333"></a>00333               <span class="comment">//                _points[7](1) = b;</span>
<a name="l00334"></a>00334               <span class="comment">//                _points[7](2) = a;</span>
<a name="l00335"></a>00335                 
<a name="l00336"></a>00336               <span class="comment">//                _points[8](0) = b;</span>
<a name="l00337"></a>00337               <span class="comment">//                _points[8](1) = b;</span>
<a name="l00338"></a>00338               <span class="comment">//                _points[8](2) = b;</span>
<a name="l00339"></a>00339               <span class="comment">//              }</span>
<a name="l00340"></a>00340               <span class="comment">//              {</span>
<a name="l00341"></a>00341               <span class="comment">//                const Real a = 0.066550153573664;</span>
<a name="l00342"></a>00342               <span class="comment">//                const Real b = 0.433449846426336;</span>
<a name="l00343"></a>00343                 
<a name="l00344"></a>00344               <span class="comment">//                _points[9](0) = b;</span>
<a name="l00345"></a>00345               <span class="comment">//                _points[9](1) = a;</span>
<a name="l00346"></a>00346               <span class="comment">//                _points[9](2) = a;</span>
<a name="l00347"></a>00347                 
<a name="l00348"></a>00348               <span class="comment">//                _points[10](0) = a;</span>
<a name="l00349"></a>00349               <span class="comment">//                _points[10](1) = a;</span>
<a name="l00350"></a>00350               <span class="comment">//                _points[10](2) = b;</span>
<a name="l00351"></a>00351                 
<a name="l00352"></a>00352               <span class="comment">//                _points[11](0) = a;</span>
<a name="l00353"></a>00353               <span class="comment">//                _points[11](1) = b;</span>
<a name="l00354"></a>00354               <span class="comment">//                _points[11](2) = b;</span>
<a name="l00355"></a>00355                 
<a name="l00356"></a>00356               <span class="comment">//                _points[12](0) = b;</span>
<a name="l00357"></a>00357               <span class="comment">//                _points[12](1) = a;</span>
<a name="l00358"></a>00358               <span class="comment">//                _points[12](2) = b;</span>
<a name="l00359"></a>00359                 
<a name="l00360"></a>00360               <span class="comment">//                _points[13](0) = b;</span>
<a name="l00361"></a>00361               <span class="comment">//                _points[13](1) = b;</span>
<a name="l00362"></a>00362               <span class="comment">//                _points[13](2) = a;</span>
<a name="l00363"></a>00363                 
<a name="l00364"></a>00364               <span class="comment">//                _points[14](0) = a;</span>
<a name="l00365"></a>00365               <span class="comment">//                _points[14](1) = b;</span>
<a name="l00366"></a>00366               <span class="comment">//                _points[14](2) = a;             </span>
<a name="l00367"></a>00367               <span class="comment">//              }</span>
<a name="l00368"></a>00368               
<a name="l00369"></a>00369               <span class="comment">//              _weights[0]  = 0.030283678097089;</span>
<a name="l00370"></a>00370               <span class="comment">//              _weights[1]  = 0.006026785714286;</span>
<a name="l00371"></a>00371               <span class="comment">//              _weights[2]  = _weights[1];</span>
<a name="l00372"></a>00372               <span class="comment">//              _weights[3]  = _weights[1];</span>
<a name="l00373"></a>00373               <span class="comment">//              _weights[4]  = _weights[1];</span>
<a name="l00374"></a>00374               <span class="comment">//              _weights[5]  = 0.011645249086029;</span>
<a name="l00375"></a>00375               <span class="comment">//              _weights[6]  = _weights[5];</span>
<a name="l00376"></a>00376               <span class="comment">//              _weights[7]  = _weights[5];</span>
<a name="l00377"></a>00377               <span class="comment">//              _weights[8]  = _weights[5];</span>
<a name="l00378"></a>00378               <span class="comment">//              _weights[9]  = 0.010949141561386;</span>
<a name="l00379"></a>00379               <span class="comment">//              _weights[10] = _weights[9];</span>
<a name="l00380"></a>00380               <span class="comment">//              _weights[11] = _weights[9];</span>
<a name="l00381"></a>00381               <span class="comment">//              _weights[12] = _weights[9];</span>
<a name="l00382"></a>00382               <span class="comment">//              _weights[13] = _weights[9];</span>
<a name="l00383"></a>00383               <span class="comment">//              _weights[14] = _weights[9];</span>
<a name="l00384"></a>00384               
<a name="l00385"></a>00385               <span class="keywordflow">return</span>;
<a name="l00386"></a>00386             }
<a name="l00387"></a>00387 
<a name="l00388"></a>00388 
<a name="l00389"></a>00389 
<a name="l00390"></a>00390             
<a name="l00391"></a>00391             <span class="comment">// This rule is originally from Keast:</span>
<a name="l00392"></a>00392             <span class="comment">//    Patrick Keast,</span>
<a name="l00393"></a>00393             <span class="comment">//    Moderate Degree Tetrahedral Quadrature Formulas,</span>
<a name="l00394"></a>00394             <span class="comment">//    Computer Methods in Applied Mechanics and Engineering,</span>
<a name="l00395"></a>00395             <span class="comment">//    Volume 55, Number 3, May 1986, pages 339-348.</span>
<a name="l00396"></a>00396             <span class="comment">//</span>
<a name="l00397"></a>00397             <span class="comment">// It is accurate on 6th-degree polynomials and has 24 points</span>
<a name="l00398"></a>00398             <span class="comment">// vs. 64 for the comparable conical product rule.</span>
<a name="l00399"></a>00399             <span class="comment">//</span>
<a name="l00400"></a>00400             <span class="comment">// Values copied 24th June 2008 from:</span>
<a name="l00401"></a>00401             <span class="comment">// http://people.scs.fsu.edu/~burkardt/f_src/keast/keast.f90</span>
<a name="l00402"></a>00402           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00403"></a>00403             {
<a name="l00404"></a>00404               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (24);
<a name="l00405"></a>00405               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(24);
<a name="l00406"></a>00406 
<a name="l00407"></a>00407               <span class="comment">// The raw data for the quadrature rule.</span>
<a name="l00408"></a>00408               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p[4][4] = {
<a name="l00409"></a>00409                 {0.356191386222544953e+00 , 0.214602871259151684e+00 ,                       0., 0.00665379170969464506e+00}, <span class="comment">// 4</span>
<a name="l00410"></a>00410                 {0.877978124396165982e+00 , 0.0406739585346113397e+00,                       0., 0.00167953517588677620e+00}, <span class="comment">// 4</span>
<a name="l00411"></a>00411                 {0.0329863295731730594e+00, 0.322337890142275646e+00 ,                       0., 0.00922619692394239843e+00}, <span class="comment">// 4</span>
<a name="l00412"></a>00412                 {0.0636610018750175299e+00, 0.269672331458315867e+00 , 0.603005664791649076e+00, 0.00803571428571428248e+00}  <span class="comment">// 12    </span>
<a name="l00413"></a>00413               };
<a name="l00414"></a>00414 
<a name="l00415"></a>00415               
<a name="l00416"></a>00416               <span class="comment">// Now call the keast routine to generate _points and _weights</span>
<a name="l00417"></a>00417               <a class="code" href="classlibMesh_1_1QGauss.php#aae03c6302651a828b86abe89ea85b32c">keast_rule</a>(p, 4);
<a name="l00418"></a>00418 
<a name="l00419"></a>00419               <span class="keywordflow">return</span>;
<a name="l00420"></a>00420             }
<a name="l00421"></a>00421 
<a name="l00422"></a>00422 
<a name="l00423"></a>00423             <span class="comment">// Keast&#39;s 31 point, 7th-order rule contains points on the reference</span>
<a name="l00424"></a>00424             <span class="comment">// element boundary, so we&#39;ve decided not to include it here.</span>
<a name="l00425"></a>00425             <span class="comment">//</span>
<a name="l00426"></a>00426             <span class="comment">// Keast&#39;s 8th-order rule has 45 points.  and a negative</span>
<a name="l00427"></a>00427             <span class="comment">// weight, so if you&#39;ve explicitly disallowed such rules</span>
<a name="l00428"></a>00428             <span class="comment">// you will fall through to the conical product rules</span>
<a name="l00429"></a>00429             <span class="comment">// below.</span>
<a name="l00430"></a>00430           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00431"></a>00431           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>:
<a name="l00432"></a>00432             {
<a name="l00433"></a>00433               <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1QBase.php#a6f1f4bb99c359f881b0b5b2695bb2cde">allow_rules_with_negative_weights</a>)
<a name="l00434"></a>00434                 {
<a name="l00435"></a>00435                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (45);
<a name="l00436"></a>00436                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(45);
<a name="l00437"></a>00437 
<a name="l00438"></a>00438                   <span class="comment">// The raw data for the quadrature rule.</span>
<a name="l00439"></a>00439                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> p[7][4] = {
<a name="l00440"></a>00440                     {0.250000000000000000e+00,                        0.,                        0.,   -0.393270066412926145e-01},  <span class="comment">// 1</span>
<a name="l00441"></a>00441                     {0.617587190300082967e+00,  0.127470936566639015e+00,                        0.,    0.408131605934270525e-02},  <span class="comment">// 4</span>
<a name="l00442"></a>00442                     {0.903763508822103123e+00,  0.320788303926322960e-01,                        0.,    0.658086773304341943e-03},  <span class="comment">// 4</span>
<a name="l00443"></a>00443                     {0.497770956432810185e-01,                        0.,  0.450222904356718978e+00,    0.438425882512284693e-02},  <span class="comment">// 6</span>
<a name="l00444"></a>00444                     {0.183730447398549945e+00,                        0.,  0.316269552601450060e+00,    0.138300638425098166e-01},  <span class="comment">// 6</span>
<a name="l00445"></a>00445                     {0.231901089397150906e+00,  0.229177878448171174e-01,  0.513280033360881072e+00,    0.424043742468372453e-02},  <span class="comment">// 12</span>
<a name="l00446"></a>00446                     {0.379700484718286102e-01,  0.730313427807538396e+00,  0.193746475248804382e+00,    0.223873973961420164e-02}   <span class="comment">// 12</span>
<a name="l00447"></a>00447                   };
<a name="l00448"></a>00448 
<a name="l00449"></a>00449               
<a name="l00450"></a>00450                   <span class="comment">// Now call the keast routine to generate _points and _weights</span>
<a name="l00451"></a>00451                   <a class="code" href="classlibMesh_1_1QGauss.php#aae03c6302651a828b86abe89ea85b32c">keast_rule</a>(p, 7);
<a name="l00452"></a>00452 
<a name="l00453"></a>00453                   <span class="keywordflow">return</span>;
<a name="l00454"></a>00454                 } <span class="comment">// end if (allow_rules_with_negative_weights)</span>
<a name="l00455"></a>00455               <span class="comment">// Note: if !allow_rules_with_negative_weights, fall through to next case.</span>
<a name="l00456"></a>00456             }
<a name="l00457"></a>00457 
<a name="l00458"></a>00458             <span class="comment">// Fall back on Grundmann-Moller or Conical Product rules at high orders.</span>
<a name="l00459"></a>00459           <span class="keywordflow">default</span>:
<a name="l00460"></a>00460             {
<a name="l00461"></a>00461               <span class="keywordflow">if</span> ((<a class="code" href="classlibMesh_1_1QBase.php#a6f1f4bb99c359f881b0b5b2695bb2cde">allow_rules_with_negative_weights</a>) &amp;&amp; (_order + 2*p &lt; 34))
<a name="l00462"></a>00462                 {
<a name="l00463"></a>00463                   <span class="comment">// The Grundmann-Moller rules are defined to arbitrary order and</span>
<a name="l00464"></a>00464                   <span class="comment">// can have significantly fewer evaluation points than concial product</span>
<a name="l00465"></a>00465                   <span class="comment">// rules.  If you allow rules with negative weights, the GM rules</span>
<a name="l00466"></a>00466                   <span class="comment">// will be more efficient for degree up to 33 (for degree 34 and</span>
<a name="l00467"></a>00467                   <span class="comment">// higher, CP is more efficient!) but may be more susceptible</span>
<a name="l00468"></a>00468                   <span class="comment">// to round-off error.  Safest is to disallow rules with negative</span>
<a name="l00469"></a>00469                   <span class="comment">// weights, but this decision should be made on a case-by-case basis.</span>
<a name="l00470"></a>00470                   <a class="code" href="classlibMesh_1_1QGrundmann__Moller.php">QGrundmann_Moller</a> gm_rule(3, _order);
<a name="l00471"></a>00471                   gm_rule.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(_type, p);
<a name="l00472"></a>00472 
<a name="l00473"></a>00473                   <span class="comment">// Swap points and weights with the about-to-be destroyed rule.</span>
<a name="l00474"></a>00474                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.swap (gm_rule.<a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">get_points</a>() );
<a name="l00475"></a>00475                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.swap(gm_rule.<a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">get_weights</a>());
<a name="l00476"></a>00476 
<a name="l00477"></a>00477                   <span class="keywordflow">return</span>;
<a name="l00478"></a>00478                 }
<a name="l00479"></a>00479 
<a name="l00480"></a>00480               <span class="keywordflow">else</span>
<a name="l00481"></a>00481                 {
<a name="l00482"></a>00482                   <span class="comment">// The following quadrature rules are generated as</span>
<a name="l00483"></a>00483                   <span class="comment">// conical products.  These tend to be non-optimal</span>
<a name="l00484"></a>00484                   <span class="comment">// (use too many points, cluster points in certain</span>
<a name="l00485"></a>00485                   <span class="comment">// regions of the domain) but they are quite easy to</span>
<a name="l00486"></a>00486                   <span class="comment">// automatically generate using a 1D Gauss rule on</span>
<a name="l00487"></a>00487                   <span class="comment">// [0,1] and two 1D Jacobi-Gauss rules on [0,1].</span>
<a name="l00488"></a>00488                   <a class="code" href="classlibMesh_1_1QConical.php">QConical</a> conical_rule(3, _order);
<a name="l00489"></a>00489                   conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(_type, p);
<a name="l00490"></a>00490 
<a name="l00491"></a>00491                   <span class="comment">// Swap points and weights with the about-to-be destroyed rule.</span>
<a name="l00492"></a>00492                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.swap (conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">get_points</a>() );
<a name="l00493"></a>00493                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.swap(conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">get_weights</a>());
<a name="l00494"></a>00494                   
<a name="l00495"></a>00495                   <span class="keywordflow">return</span>;
<a name="l00496"></a>00496                 }
<a name="l00497"></a>00497             }
<a name="l00498"></a>00498           }
<a name="l00499"></a>00499       } <span class="comment">// end case TET4,TET10</span>
<a name="l00500"></a>00500 
<a name="l00501"></a>00501       
<a name="l00502"></a>00502             
<a name="l00503"></a>00503       <span class="comment">//---------------------------------------------</span>
<a name="l00504"></a>00504       <span class="comment">// Prism quadrature rules</span>
<a name="l00505"></a>00505     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00506"></a>00506     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00507"></a>00507     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00508"></a>00508       {
<a name="l00509"></a>00509         <span class="comment">// We compute the 3D quadrature rule as a tensor</span>
<a name="l00510"></a>00510         <span class="comment">// product of the 1D quadrature rule and a 2D</span>
<a name="l00511"></a>00511         <span class="comment">// triangle quadrature rule</span>
<a name="l00512"></a>00512             
<a name="l00513"></a>00513         <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> q1D(1,_order);
<a name="l00514"></a>00514         <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> q2D(2,_order);
<a name="l00515"></a>00515 
<a name="l00516"></a>00516         <span class="comment">// Initialize </span>
<a name="l00517"></a>00517         q1D.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>,p);
<a name="l00518"></a>00518         q2D.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>,p);
<a name="l00519"></a>00519 
<a name="l00520"></a>00520         tensor_product_prism(q1D, q2D);
<a name="l00521"></a>00521         
<a name="l00522"></a>00522         <span class="keywordflow">return</span>;
<a name="l00523"></a>00523       }
<a name="l00524"></a>00524       
<a name="l00525"></a>00525 
<a name="l00526"></a>00526       
<a name="l00527"></a>00527       <span class="comment">//---------------------------------------------</span>
<a name="l00528"></a>00528       <span class="comment">// Pyramid</span>
<a name="l00529"></a>00529     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a8eb2346479e1d75ee0c85b9259dcf2d7">PYRAMID5</a>:
<a name="l00530"></a>00530       {
<a name="l00531"></a>00531         <span class="comment">// We compute the Pyramid rule as a conical product of a</span>
<a name="l00532"></a>00532         <span class="comment">// Jacobi rule with alpha==2 on the interval [0,1] two 1D</span>
<a name="l00533"></a>00533         <span class="comment">// Gauss rules with suitably modified points.  The idea comes</span>
<a name="l00534"></a>00534         <span class="comment">// from: Stroud, A.H. &quot;Approximate Calculation of Multiple</span>
<a name="l00535"></a>00535         <span class="comment">// Integrals.&quot;</span>
<a name="l00536"></a>00536         <a class="code" href="classlibMesh_1_1QConical.php">QConical</a> conical_rule(3, _order);
<a name="l00537"></a>00537         conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(_type, p);
<a name="l00538"></a>00538 
<a name="l00539"></a>00539         <span class="comment">// Swap points and weights with the about-to-be destroyed rule.</span>
<a name="l00540"></a>00540         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.swap (conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">get_points</a>() );
<a name="l00541"></a>00541         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.swap(conical_rule.<a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">get_weights</a>());
<a name="l00542"></a>00542         
<a name="l00543"></a>00543         <span class="keywordflow">return</span>;
<a name="l00544"></a>00544 
<a name="l00545"></a>00545       }
<a name="l00546"></a>00546 
<a name="l00547"></a>00547 
<a name="l00548"></a>00548       
<a name="l00549"></a>00549       <span class="comment">//---------------------------------------------</span>
<a name="l00550"></a>00550       <span class="comment">// Unsupported type</span>
<a name="l00551"></a>00551     <span class="keywordflow">default</span>:
<a name="l00552"></a>00552       {
<a name="l00553"></a>00553         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported type: &quot;</span> &lt;&lt; _type &lt;&lt; std::endl;
<a name="l00554"></a>00554         libmesh_error();
<a name="l00555"></a>00555       }
<a name="l00556"></a>00556     }
<a name="l00557"></a>00557 
<a name="l00558"></a>00558   libmesh_error();
<a name="l00559"></a>00559 
<a name="l00560"></a>00560   <span class="keywordflow">return</span>;
<a name="l00561"></a>00561   
<a name="l00562"></a>00562 <span class="preprocessor">#endif</span>
<a name="l00563"></a>00563 <span class="preprocessor"></span>}
<a name="l00564"></a>00564 
<a name="l00565"></a>00565 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
