<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b3cacb7eaaea4a453afa5ec010f6097e.php">include</a>      </li>
      <li class="navelem"><a class="el" href="dir_7130bdbee22170d77bc57b73a8cc6b8c.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_monomial.h</div>  </div>
</div>
<div class="contents">
<a href="quadrature__monomial_8h.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_monomial.h 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="preprocessor">#ifndef __quadrature_monomial_h__</span>
<a name="l00023"></a>00023 <span class="preprocessor"></span><span class="preprocessor">#define __quadrature_monomial_h__</span>
<a name="l00024"></a>00024 <span class="preprocessor"></span>
<a name="l00025"></a>00025 <span class="comment">// Local includes</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="quadrature_8h.php">quadrature.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">namespace </span>libMesh
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a>00033 
<a name="l00065"></a><a class="code" href="classlibMesh_1_1QMonomial.php">00065</a> <span class="keyword">class </span><a class="code" href="classlibMesh_1_1QMonomial.php">QMonomial</a> : <span class="keyword">public</span> <a class="code" href="classlibMesh_1_1QBase.php">QBase</a>
<a name="l00066"></a>00066 {
<a name="l00067"></a>00067  <span class="keyword">public</span>:
<a name="l00068"></a>00068 
<a name="l00072"></a>00072   <a class="code" href="classlibMesh_1_1QMonomial.php#ae7ab65841bd5c10dd1e587b58c3f245c">QMonomial</a> (<span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> _dim,
<a name="l00073"></a>00073              <span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0f">Order</a> _order=<a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa2c3571d1803f3f264b0b2c653f0a6a04">INVALID_ORDER</a>);
<a name="l00074"></a>00074 
<a name="l00078"></a>00078   <a class="code" href="classlibMesh_1_1QMonomial.php#ac9385a913b48b2dfd2db9642ea8b958e">~QMonomial</a>();
<a name="l00079"></a>00079 
<a name="l00083"></a><a class="code" href="classlibMesh_1_1QMonomial.php#ad4036fc76f852c9a4aa46af3d1a5d7e0">00083</a>   <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> <a class="code" href="classlibMesh_1_1QMonomial.php#ad4036fc76f852c9a4aa46af3d1a5d7e0">type</a>()<span class="keyword"> const </span>{ <span class="keywordflow">return</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adad253e92d04395f506aa249f2b42e1ff5">QMONOMIAL</a>; }
<a name="l00084"></a>00084 
<a name="l00085"></a>00085  
<a name="l00086"></a>00086  <span class="keyword">private</span>:
<a name="l00087"></a>00087 
<a name="l00088"></a><a class="code" href="classlibMesh_1_1QMonomial.php#a924c4ebcd9561199e41bd7288483d7d6">00088</a>   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QMonomial.php#a924c4ebcd9561199e41bd7288483d7d6">init_1D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a>,
<a name="l00089"></a>00089                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> =0)
<a name="l00090"></a>00090   {
<a name="l00091"></a>00091     <span class="comment">// See about making this non-pure virtual in the base class?</span>
<a name="l00092"></a>00092     libmesh_error();
<a name="l00093"></a>00093   }
<a name="l00094"></a>00094 
<a name="l00098"></a>00098   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QMonomial.php#a8116886c7835be17d9f0ab9c8935011b">init_2D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00099"></a>00099                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00100"></a>00100   
<a name="l00104"></a>00104   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QMonomial.php#a054916b2671ee9faba2c834b945236ca">init_3D</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type=<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4518904c8c2948ef3d2869c4cb4a2b8f">INVALID_ELEM</a>,
<a name="l00105"></a>00105                 <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p_level=0);
<a name="l00106"></a>00106 
<a name="l00107"></a>00107      
<a name="l00108"></a>00108   
<a name="l00121"></a>00121   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QMonomial.php#a807a6390595db9781a0621306d38f93a">wissmann_rule</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rule_data[][3],
<a name="l00122"></a>00122                      <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pts);
<a name="l00123"></a>00123 
<a name="l00144"></a>00144   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QMonomial.php#a68499e0efcbbfb1bc9f3c13ec51301d7">stroud_rule</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rule_data[][3],
<a name="l00145"></a>00145                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* rule_symmetry,
<a name="l00146"></a>00146                    <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pts);
<a name="l00147"></a>00147 
<a name="l00185"></a>00185   <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QMonomial.php#a05e6cf99b4befdcd61a7aa5f4ee180f7">kim_rule</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> rule_data[][4],
<a name="l00186"></a>00186                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>* rule_id,
<a name="l00187"></a>00187                 <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> n_pts);
<a name="l00188"></a>00188 };
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191 
<a name="l00192"></a>00192 } <span class="comment">// namespace libMesh</span>
<a name="l00193"></a>00193 
<a name="l00194"></a>00194 
<a name="l00195"></a>00195 
<a name="l00196"></a>00196 
<a name="l00197"></a>00197 
<a name="l00198"></a>00198 <span class="preprocessor">#endif</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
