<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_monomial_2D.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__monomial__2D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_monomial_2D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__monomial_8h.php">quadrature_monomial.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="classlibMesh_1_1QMonomial.php#a8116886c7835be17d9f0ab9c8935011b">00030</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QMonomial.php#a8116886c7835be17d9f0ab9c8935011b">QMonomial::init_2D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type,
<a name="l00031"></a>00031                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="keywordflow">switch</span> (_type)
<a name="l00035"></a>00035     {
<a name="l00036"></a>00036       <span class="comment">//---------------------------------------------</span>
<a name="l00037"></a>00037       <span class="comment">// Quadrilateral quadrature rules</span>
<a name="l00038"></a>00038     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa8030d65f56cdce395636f10639a2e59">QUAD4</a>:
<a name="l00039"></a>00039     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a90319786834bbeb401191874e8cf807a">QUAD8</a>:
<a name="l00040"></a>00040     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a536ade963d6c030fe342dc679c382deb">QUAD9</a>:
<a name="l00041"></a>00041       {
<a name="l00042"></a>00042         <span class="keywordflow">switch</span>(_order + 2*p)
<a name="l00043"></a>00043           {
<a name="l00044"></a>00044           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00045"></a>00045             {
<a name="l00046"></a>00046               <span class="comment">// A degree=2 rule for the QUAD with 3 points.</span>
<a name="l00047"></a>00047               <span class="comment">// A tensor product degree-2 Gauss would have 4 points.</span>
<a name="l00048"></a>00048               <span class="comment">// This rule (or a variation on it) is probably available in</span>
<a name="l00049"></a>00049               <span class="comment">//</span>
<a name="l00050"></a>00050               <span class="comment">// A.H. Stroud, Approximate calculation of multiple integrals,</span>
<a name="l00051"></a>00051               <span class="comment">// Prentice-Hall, Englewood Cliffs, N.J., 1971.</span>
<a name="l00052"></a>00052               <span class="comment">//</span>
<a name="l00053"></a>00053               <span class="comment">// though I have never actually seen a reference for it.</span>
<a name="l00054"></a>00054               <span class="comment">// Luckily it&#39;s fairly easy to derive, which is what I&#39;ve done</span>
<a name="l00055"></a>00055               <span class="comment">// here [JWP].</span>
<a name="l00056"></a>00056               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l00057"></a>00057                 s=std::sqrt(1./3.),
<a name="l00058"></a>00058                 t=std::sqrt(2./3.);
<a name="l00059"></a>00059               
<a name="l00060"></a>00060               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[2][3] =
<a name="l00061"></a>00061                 {
<a name="l00062"></a>00062                   {0.0,  s,  2.0},
<a name="l00063"></a>00063                   {  t, -s,  1.0}
<a name="l00064"></a>00064                 };
<a name="l00065"></a>00065 
<a name="l00066"></a>00066               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(3);
<a name="l00067"></a>00067               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(3);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069               <a class="code" href="classlibMesh_1_1QMonomial.php#a807a6390595db9781a0621306d38f93a">wissmann_rule</a>(data, 2);
<a name="l00070"></a>00070               
<a name="l00071"></a>00071               <span class="keywordflow">return</span>;
<a name="l00072"></a>00072             } <span class="comment">// end case SECOND</span>
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075             
<a name="l00076"></a>00076           <span class="comment">// For third-order, fall through to default case, use 2x2 Gauss product rule.</span>
<a name="l00077"></a>00077           <span class="comment">// case THIRD:</span>
<a name="l00078"></a>00078           <span class="comment">//   {</span>
<a name="l00079"></a>00079           <span class="comment">//   }  // end case THIRD</span>
<a name="l00080"></a>00080             
<a name="l00081"></a>00081           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00082"></a>00082             {
<a name="l00083"></a>00083               <span class="comment">// A pair of degree=4 rules for the QUAD &quot;C2&quot; due to</span>
<a name="l00084"></a>00084               <span class="comment">// Wissmann and Becker. These rules both have six points.</span>
<a name="l00085"></a>00085               <span class="comment">// A tensor product degree-4 Gauss would have 9 points.</span>
<a name="l00086"></a>00086               <span class="comment">//</span>
<a name="l00087"></a>00087               <span class="comment">// J. W. Wissmann and T. Becker, Partially symmetric cubature </span>
<a name="l00088"></a>00088               <span class="comment">// formulas for even degrees of exactness, SIAM J. Numer. Anal.  23</span>
<a name="l00089"></a>00089               <span class="comment">// (1986), 676--685.                                           </span>
<a name="l00090"></a>00090               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[4][3] =
<a name="l00091"></a>00091                 {
<a name="l00092"></a>00092                   <span class="comment">// First of 2 degree-4 rules given by Wissmann</span>
<a name="l00093"></a>00093                   {0.0000000000000000e+00,  0.0000000000000000e+00,  1.1428571428571428e+00},
<a name="l00094"></a>00094                   {0.0000000000000000e+00,  9.6609178307929590e-01,  4.3956043956043956e-01},
<a name="l00095"></a>00095                   {8.5191465330460049e-01,  4.5560372783619284e-01,  5.6607220700753210e-01},
<a name="l00096"></a>00096                   {6.3091278897675402e-01, -7.3162995157313452e-01,  6.4271900178367668e-01}
<a name="l00097"></a>00097                   <span class="comment">//</span>
<a name="l00098"></a>00098                   <span class="comment">// Second of 2 degree-4 rules given by Wissmann.  These both</span>
<a name="l00099"></a>00099                   <span class="comment">// yield 4th-order accurate rules, I just chose the one that</span>
<a name="l00100"></a>00100                   <span class="comment">// happened to contain the origin.</span>
<a name="l00101"></a>00101                   <span class="comment">// {0.000000000000000, -0.356822089773090,  1.286412084888852}, </span>
<a name="l00102"></a>00102                   <span class="comment">// {0.000000000000000,  0.934172358962716,  0.491365692888926},</span>
<a name="l00103"></a>00103                   <span class="comment">// {0.774596669241483,  0.390885162530071,  0.761883709085613},</span>
<a name="l00104"></a>00104                   <span class="comment">// {0.774596669241483, -0.852765377881771,  0.349227402025498} </span>
<a name="l00105"></a>00105                 };
<a name="l00106"></a>00106 
<a name="l00107"></a>00107               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(6);
<a name="l00108"></a>00108               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(6);
<a name="l00109"></a>00109 
<a name="l00110"></a>00110               <a class="code" href="classlibMesh_1_1QMonomial.php#a807a6390595db9781a0621306d38f93a">wissmann_rule</a>(data, 4);
<a name="l00111"></a>00111               
<a name="l00112"></a>00112               <span class="keywordflow">return</span>;
<a name="l00113"></a>00113             } <span class="comment">// end case FOURTH</span>
<a name="l00114"></a>00114 
<a name="l00115"></a>00115 
<a name="l00116"></a>00116 
<a name="l00117"></a>00117             
<a name="l00118"></a>00118           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00119"></a>00119             {
<a name="l00120"></a>00120               <span class="comment">// A degree 5, 7-point rule due to Stroud.  </span>
<a name="l00121"></a>00121               <span class="comment">//</span>
<a name="l00122"></a>00122               <span class="comment">// A.H. Stroud, Approximate calculation of multiple integrals,</span>
<a name="l00123"></a>00123               <span class="comment">// Prentice-Hall, Englewood Cliffs, N.J., 1971.</span>
<a name="l00124"></a>00124               <span class="comment">//</span>
<a name="l00125"></a>00125               <span class="comment">// This rule is provably minimal in the number of points.</span>
<a name="l00126"></a>00126               <span class="comment">// A tensor-product rule accurate for &quot;bi-quintic&quot; polynomials would have 9 points.</span>
<a name="l00127"></a>00127               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[3][3] =
<a name="l00128"></a>00128                 {
<a name="l00129"></a>00129                   {               0.L,                  0.L, 8.L  /  7.L}, <span class="comment">// 1</span>
<a name="l00130"></a>00130                   {               0.L, std::sqrt(14.L/15.L), 20.L / 63.L}, <span class="comment">// 2</span>
<a name="l00131"></a>00131                   {std::sqrt(3.L/5.L),   std::sqrt(1.L/3.L), 20.L / 36.L}  <span class="comment">// 4</span>
<a name="l00132"></a>00132                 };
<a name="l00133"></a>00133 
<a name="l00134"></a>00134               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> symmetry[3] = {
<a name="l00135"></a>00135                 0, <span class="comment">// Origin</span>
<a name="l00136"></a>00136                 7, <span class="comment">// Central Symmetry</span>
<a name="l00137"></a>00137                 6  <span class="comment">// Rectangular</span>
<a name="l00138"></a>00138               };
<a name="l00139"></a>00139               
<a name="l00140"></a>00140               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (7);
<a name="l00141"></a>00141               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(7);
<a name="l00142"></a>00142 
<a name="l00143"></a>00143               <a class="code" href="classlibMesh_1_1QMonomial.php#a68499e0efcbbfb1bc9f3c13ec51301d7">stroud_rule</a>(data, symmetry, 3);
<a name="l00144"></a>00144               
<a name="l00145"></a>00145               <span class="keywordflow">return</span>;
<a name="l00146"></a>00146             } <span class="comment">// end case FIFTH</span>
<a name="l00147"></a>00147 
<a name="l00148"></a>00148 
<a name="l00149"></a>00149 
<a name="l00150"></a>00150             
<a name="l00151"></a>00151           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00152"></a>00152             {
<a name="l00153"></a>00153               <span class="comment">// A pair of degree=6 rules for the QUAD &quot;C2&quot; due to</span>
<a name="l00154"></a>00154               <span class="comment">// Wissmann and Becker. These rules both have 10 points.</span>
<a name="l00155"></a>00155               <span class="comment">// A tensor product degree-6 Gauss would have 16 points.</span>
<a name="l00156"></a>00156               <span class="comment">//</span>
<a name="l00157"></a>00157               <span class="comment">// J. W. Wissmann and T. Becker, Partially symmetric cubature </span>
<a name="l00158"></a>00158               <span class="comment">// formulas for even degrees of exactness, SIAM J. Numer. Anal.  23</span>
<a name="l00159"></a>00159               <span class="comment">// (1986), 676--685.                                           </span>
<a name="l00160"></a>00160               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[6][3] =
<a name="l00161"></a>00161                 {
<a name="l00162"></a>00162                   <span class="comment">// First of 2 degree-6, 10 point rules given by Wissmann</span>
<a name="l00163"></a>00163                   <span class="comment">// {0.000000000000000,  0.836405633697626,  0.455343245714174},</span>
<a name="l00164"></a>00164                   <span class="comment">// {0.000000000000000, -0.357460165391307,  0.827395973202966},</span>
<a name="l00165"></a>00165                   <span class="comment">// {0.888764014654765,  0.872101531193131,  0.144000884599645},</span>
<a name="l00166"></a>00166                   <span class="comment">// {0.604857639464685,  0.305985162155427,  0.668259104262665},</span>
<a name="l00167"></a>00167                   <span class="comment">// {0.955447506641064, -0.410270899466658,  0.225474004890679},</span>
<a name="l00168"></a>00168                   <span class="comment">// {0.565459993438754, -0.872869311156879,  0.320896396788441} </span>
<a name="l00169"></a>00169                   <span class="comment">//</span>
<a name="l00170"></a>00170                   <span class="comment">// Second of 2 degree-6, 10 point rules given by Wissmann.</span>
<a name="l00171"></a>00171                   <span class="comment">// Either of these will work, I just chose the one with points</span>
<a name="l00172"></a>00172                   <span class="comment">// slightly further into the element interior.</span>
<a name="l00173"></a>00173                   {0.0000000000000000e+00,  8.6983337525005900e-01,  3.9275059096434794e-01},
<a name="l00174"></a>00174                   {0.0000000000000000e+00, -4.7940635161211124e-01,  7.5476288124261053e-01},
<a name="l00175"></a>00175                   {8.6374282634615388e-01,  8.0283751620765670e-01,  2.0616605058827902e-01},
<a name="l00176"></a>00176                   {5.1869052139258234e-01,  2.6214366550805818e-01,  6.8999213848986375e-01},
<a name="l00177"></a>00177                   {9.3397254497284950e-01, -3.6309658314806653e-01,  2.6051748873231697e-01},
<a name="l00178"></a>00178                   {6.0897753601635630e-01, -8.9660863276245265e-01,  2.6956758608606100e-01}
<a name="l00179"></a>00179                 };
<a name="l00180"></a>00180 
<a name="l00181"></a>00181               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(10);
<a name="l00182"></a>00182               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(10);
<a name="l00183"></a>00183 
<a name="l00184"></a>00184               <a class="code" href="classlibMesh_1_1QMonomial.php#a807a6390595db9781a0621306d38f93a">wissmann_rule</a>(data, 6);
<a name="l00185"></a>00185 
<a name="l00186"></a>00186               <span class="keywordflow">return</span>; 
<a name="l00187"></a>00187             } <span class="comment">// end case SIXTH</span>
<a name="l00188"></a>00188 
<a name="l00189"></a>00189 
<a name="l00190"></a>00190 
<a name="l00191"></a>00191             
<a name="l00192"></a>00192           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00193"></a>00193             {
<a name="l00194"></a>00194               <span class="comment">// A degree 7, 12-point rule due to Tyler, can be found in Stroud&#39;s book  </span>
<a name="l00195"></a>00195               <span class="comment">//</span>
<a name="l00196"></a>00196               <span class="comment">// A.H. Stroud, Approximate calculation of multiple integrals,</span>
<a name="l00197"></a>00197               <span class="comment">// Prentice-Hall, Englewood Cliffs, N.J., 1971.</span>
<a name="l00198"></a>00198               <span class="comment">//</span>
<a name="l00199"></a>00199               <span class="comment">// This rule is fully-symmetric and provably minimal in the number of points.</span>
<a name="l00200"></a>00200               <span class="comment">// A tensor-product rule accurate for &quot;bi-septic&quot; polynomials would have 16 points.</span>
<a name="l00201"></a>00201               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l00202"></a>00202                 r  = std::sqrt(6.L/7.L),
<a name="l00203"></a>00203                 s  = std::sqrt( (114.L - 3.L*std::sqrt(583.L)) / 287.L ),
<a name="l00204"></a>00204                 t  = std::sqrt( (114.L + 3.L*std::sqrt(583.L)) / 287.L ),
<a name="l00205"></a>00205                 B1 = 196.L / 810.L,
<a name="l00206"></a>00206                 B2 = 4.L * (178981.L + 2769.L*std::sqrt(583.L)) / 1888920.L,
<a name="l00207"></a>00207                 B3 = 4.L * (178981.L - 2769.L*std::sqrt(583.L)) / 1888920.L;
<a name="l00208"></a>00208               
<a name="l00209"></a>00209               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[3][3] =
<a name="l00210"></a>00210                 {
<a name="l00211"></a>00211                   {r, 0.0, B1}, <span class="comment">// 4</span>
<a name="l00212"></a>00212                   {s, 0.0, B2}, <span class="comment">// 4</span>
<a name="l00213"></a>00213                   {t, 0.0, B3}  <span class="comment">// 4</span>
<a name="l00214"></a>00214                 };
<a name="l00215"></a>00215 
<a name="l00216"></a>00216               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> symmetry[3] = {
<a name="l00217"></a>00217                 3, <span class="comment">// Full Symmetry, (x,0)</span>
<a name="l00218"></a>00218                 2, <span class="comment">// Full Symmetry, (x,x)</span>
<a name="l00219"></a>00219                 2  <span class="comment">// Full Symmetry, (x,x)</span>
<a name="l00220"></a>00220               };
<a name="l00221"></a>00221               
<a name="l00222"></a>00222               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (12);
<a name="l00223"></a>00223               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(12);
<a name="l00224"></a>00224 
<a name="l00225"></a>00225               <a class="code" href="classlibMesh_1_1QMonomial.php#a68499e0efcbbfb1bc9f3c13ec51301d7">stroud_rule</a>(data, symmetry, 3);
<a name="l00226"></a>00226 
<a name="l00227"></a>00227               <span class="keywordflow">return</span>;
<a name="l00228"></a>00228             } <span class="comment">// end case SEVENTH</span>
<a name="l00229"></a>00229 
<a name="l00230"></a>00230 
<a name="l00231"></a>00231 
<a name="l00232"></a>00232             
<a name="l00233"></a>00233           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>:
<a name="l00234"></a>00234             {
<a name="l00235"></a>00235               <span class="comment">// A pair of degree=8 rules for the QUAD &quot;C2&quot; due to</span>
<a name="l00236"></a>00236               <span class="comment">// Wissmann and Becker. These rules both have 16 points.</span>
<a name="l00237"></a>00237               <span class="comment">// A tensor product degree-6 Gauss would have 25 points.</span>
<a name="l00238"></a>00238               <span class="comment">//</span>
<a name="l00239"></a>00239               <span class="comment">// J. W. Wissmann and T. Becker, Partially symmetric cubature </span>
<a name="l00240"></a>00240               <span class="comment">// formulas for even degrees of exactness, SIAM J. Numer. Anal.  23</span>
<a name="l00241"></a>00241               <span class="comment">// (1986), 676--685.                                           </span>
<a name="l00242"></a>00242               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[10][3] =
<a name="l00243"></a>00243                 {
<a name="l00244"></a>00244                   <span class="comment">// First of 2 degree-8, 16 point rules given by Wissmann</span>
<a name="l00245"></a>00245                   <span class="comment">// {0.000000000000000,  0.000000000000000,  0.055364705621440},</span>
<a name="l00246"></a>00246                   <span class="comment">// {0.000000000000000,  0.757629177660505,  0.404389368726076},</span>
<a name="l00247"></a>00247                   <span class="comment">// {0.000000000000000, -0.236871842255702,  0.533546604952635},</span>
<a name="l00248"></a>00248                   <span class="comment">// {0.000000000000000, -0.989717929044527,  0.117054188786739},</span>
<a name="l00249"></a>00249                   <span class="comment">// {0.639091304900370,  0.950520955645667,  0.125614417613747},</span>
<a name="l00250"></a>00250                   <span class="comment">// {0.937069076924990,  0.663882736885633,  0.136544584733588},</span>
<a name="l00251"></a>00251                   <span class="comment">// {0.537083530541494,  0.304210681724104,  0.483408479211257},</span>
<a name="l00252"></a>00252                   <span class="comment">// {0.887188506449625, -0.236496718536120,  0.252528506429544},</span>
<a name="l00253"></a>00253                   <span class="comment">// {0.494698820670197, -0.698953476086564,  0.361262323882172},</span>
<a name="l00254"></a>00254                   <span class="comment">// {0.897495818279768, -0.900390774211580,  0.085464254086247}</span>
<a name="l00255"></a>00255                   <span class="comment">//</span>
<a name="l00256"></a>00256                   <span class="comment">// Second of 2 degree-8, 16 point rules given by Wissmann.</span>
<a name="l00257"></a>00257                   <span class="comment">// Either of these will work, I just chose the one with points</span>
<a name="l00258"></a>00258                   <span class="comment">// further into the element interior.</span>
<a name="l00259"></a>00259                   {0.0000000000000000e+00,  6.5956013196034176e-01,  4.5027677630559029e-01},
<a name="l00260"></a>00260                   {0.0000000000000000e+00, -9.4914292304312538e-01,  1.6657042677781274e-01},
<a name="l00261"></a>00261                   {9.5250946607156228e-01,  7.6505181955768362e-01,  9.8869459933431422e-02},
<a name="l00262"></a>00262                   {5.3232745407420624e-01,  9.3697598108841598e-01,  1.5369674714081197e-01},
<a name="l00263"></a>00263                   {6.8473629795173504e-01,  3.3365671773574759e-01,  3.9668697607290278e-01},
<a name="l00264"></a>00264                   {2.3314324080140552e-01, -7.9583272377396852e-02,  3.5201436794569501e-01},
<a name="l00265"></a>00265                   {9.2768331930611748e-01, -2.7224008061253425e-01,  1.8958905457779799e-01},
<a name="l00266"></a>00266                   {4.5312068740374942e-01, -6.1373535339802760e-01,  3.7510100114758727e-01},
<a name="l00267"></a>00267                   {8.3750364042281223e-01, -8.8847765053597136e-01,  1.2561879164007201e-01}
<a name="l00268"></a>00268                 };
<a name="l00269"></a>00269 
<a name="l00270"></a>00270               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(16);
<a name="l00271"></a>00271               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(16);
<a name="l00272"></a>00272 
<a name="l00273"></a>00273               <a class="code" href="classlibMesh_1_1QMonomial.php#a807a6390595db9781a0621306d38f93a">wissmann_rule</a>(data, <span class="comment">/*10*/</span> 9);
<a name="l00274"></a>00274 
<a name="l00275"></a>00275               <span class="keywordflow">return</span>; 
<a name="l00276"></a>00276             } <span class="comment">// end case EIGHTH</span>
<a name="l00277"></a>00277 
<a name="l00278"></a>00278 
<a name="l00279"></a>00279 
<a name="l00280"></a>00280 
<a name="l00281"></a>00281           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa96e4b793b046031faa991f15f1a80bc6">NINTH</a>:
<a name="l00282"></a>00282             {
<a name="l00283"></a>00283               <span class="comment">// A degree 9, 17-point rule due to Moller.  </span>
<a name="l00284"></a>00284               <span class="comment">//</span>
<a name="l00285"></a>00285               <span class="comment">// H.M. Moller,  Kubaturformeln mit minimaler Knotenzahl,</span>
<a name="l00286"></a>00286               <span class="comment">// Numer. Math.  25 (1976), 185--200.</span>
<a name="l00287"></a>00287               <span class="comment">//</span>
<a name="l00288"></a>00288               <span class="comment">// This rule is provably minimal in the number of points.</span>
<a name="l00289"></a>00289               <span class="comment">// A tensor-product rule accurate for &quot;bi-ninth&quot; degree polynomials would have 25 points.</span>
<a name="l00290"></a>00290               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[5][3] =
<a name="l00291"></a>00291                 {
<a name="l00292"></a>00292                   {0.0000000000000000e+00, 0.0000000000000000e+00, 5.2674897119341563e-01}, <span class="comment">// 1</span>
<a name="l00293"></a>00293                   {6.3068011973166885e-01, 9.6884996636197772e-01, 8.8879378170198706e-02}, <span class="comment">// 4</span>
<a name="l00294"></a>00294                   {9.2796164595956966e-01, 7.5027709997890053e-01, 1.1209960212959648e-01}, <span class="comment">// 4</span>
<a name="l00295"></a>00295                   {4.5333982113564719e-01, 5.2373582021442933e-01, 3.9828243926207009e-01}, <span class="comment">// 4</span>
<a name="l00296"></a>00296                   {8.5261572933366230e-01, 7.6208328192617173e-02, 2.6905133763978080e-01}  <span class="comment">// 4</span>
<a name="l00297"></a>00297                 };
<a name="l00298"></a>00298 
<a name="l00299"></a>00299               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> symmetry[5] = {
<a name="l00300"></a>00300                 0, <span class="comment">// Single point</span>
<a name="l00301"></a>00301                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00302"></a>00302                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00303"></a>00303                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00304"></a>00304                 4  <span class="comment">// Rotational Invariant</span>
<a name="l00305"></a>00305               };
<a name="l00306"></a>00306               
<a name="l00307"></a>00307               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (17);
<a name="l00308"></a>00308               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(17);
<a name="l00309"></a>00309 
<a name="l00310"></a>00310               <a class="code" href="classlibMesh_1_1QMonomial.php#a68499e0efcbbfb1bc9f3c13ec51301d7">stroud_rule</a>(data, symmetry, 5);
<a name="l00311"></a>00311 
<a name="l00312"></a>00312               <span class="keywordflow">return</span>;
<a name="l00313"></a>00313             } <span class="comment">// end case NINTH</span>
<a name="l00314"></a>00314 
<a name="l00315"></a>00315 
<a name="l00316"></a>00316 
<a name="l00317"></a>00317 
<a name="l00318"></a>00318           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa6115f555ee86d242617207bec760f208">TENTH</a>:
<a name="l00319"></a>00319           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa9d8cd1c6f2feb41a556c16d8cb4744cd">ELEVENTH</a>:
<a name="l00320"></a>00320             {
<a name="l00321"></a>00321               <span class="comment">// A degree 11, 24-point rule due to Cools and Haegemans.  </span>
<a name="l00322"></a>00322               <span class="comment">//</span>
<a name="l00323"></a>00323               <span class="comment">// R. Cools and A. Haegemans, Another step forward in searching for</span>
<a name="l00324"></a>00324               <span class="comment">// cubature formulae with a minimal number of knots for the square,</span>
<a name="l00325"></a>00325               <span class="comment">// Computing 40 (1988), 139--146.</span>
<a name="l00326"></a>00326               <span class="comment">// </span>
<a name="l00327"></a>00327               <span class="comment">// P. Verlinden and R. Cools, The algebraic construction of a minimal</span>
<a name="l00328"></a>00328               <span class="comment">// cubature formula of degree 11 for the square, Cubature Formulas</span>
<a name="l00329"></a>00329               <span class="comment">// and their Applications (Russian) (Krasnoyarsk) (M.V. Noskov, ed.),</span>
<a name="l00330"></a>00330               <span class="comment">// 1994, pp. 13--23.</span>
<a name="l00331"></a>00331               <span class="comment">//</span>
<a name="l00332"></a>00332               <span class="comment">// This rule is provably minimal in the number of points.</span>
<a name="l00333"></a>00333               <span class="comment">// A tensor-product rule accurate for &quot;bi-tenth&quot; or &quot;bi-eleventh&quot; degree polynomials would have 36 points.</span>
<a name="l00334"></a>00334               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[6][3] =
<a name="l00335"></a>00335                 {
<a name="l00336"></a>00336                   {6.9807610454956756e-01, 9.8263922354085547e-01, 4.8020763350723814e-02}, <span class="comment">// 4</span>
<a name="l00337"></a>00337                   {9.3948638281673690e-01, 8.2577583590296393e-01, 6.6071329164550595e-02}, <span class="comment">// 4</span>
<a name="l00338"></a>00338                   {9.5353952820153201e-01, 1.8858613871864195e-01, 9.7386777358668164e-02}, <span class="comment">// 4</span>
<a name="l00339"></a>00339                   {3.1562343291525419e-01, 8.1252054830481310e-01, 2.1173634999894860e-01}, <span class="comment">// 4</span>
<a name="l00340"></a>00340                   {7.1200191307533630e-01, 5.2532025036454776e-01, 2.2562606172886338e-01}, <span class="comment">// 4</span>
<a name="l00341"></a>00341                   {4.2484724884866925e-01, 4.1658071912022368e-02, 3.5115871839824543e-01}  <span class="comment">// 4</span>
<a name="l00342"></a>00342                 };
<a name="l00343"></a>00343 
<a name="l00344"></a>00344               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> symmetry[6] = {
<a name="l00345"></a>00345                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00346"></a>00346                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00347"></a>00347                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00348"></a>00348                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00349"></a>00349                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00350"></a>00350                 4  <span class="comment">// Rotational Invariant</span>
<a name="l00351"></a>00351               };
<a name="l00352"></a>00352               
<a name="l00353"></a>00353               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (24);
<a name="l00354"></a>00354               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(24);
<a name="l00355"></a>00355 
<a name="l00356"></a>00356               <a class="code" href="classlibMesh_1_1QMonomial.php#a68499e0efcbbfb1bc9f3c13ec51301d7">stroud_rule</a>(data, symmetry, 6);
<a name="l00357"></a>00357 
<a name="l00358"></a>00358               <span class="keywordflow">return</span>;
<a name="l00359"></a>00359             } <span class="comment">// end case TENTH,ELEVENTH</span>
<a name="l00360"></a>00360 
<a name="l00361"></a>00361 
<a name="l00362"></a>00362 
<a name="l00363"></a>00363 
<a name="l00364"></a>00364           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa72ff7b576c902d58a9fc3ad53b247a85">TWELFTH</a>:
<a name="l00365"></a>00365           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faeb2a82bbe2a44c6917cedc029423ce75">THIRTEENTH</a>:
<a name="l00366"></a>00366             {
<a name="l00367"></a>00367               <span class="comment">// A degree 13, 33-point rule due to Cools and Haegemans.  </span>
<a name="l00368"></a>00368               <span class="comment">//</span>
<a name="l00369"></a>00369               <span class="comment">// R. Cools and A. Haegemans, Another step forward in searching for</span>
<a name="l00370"></a>00370               <span class="comment">// cubature formulae with a minimal number of knots for the square,</span>
<a name="l00371"></a>00371               <span class="comment">// Computing 40 (1988), 139--146.</span>
<a name="l00372"></a>00372               <span class="comment">// </span>
<a name="l00373"></a>00373               <span class="comment">// A tensor-product rule accurate for &quot;bi-12&quot; or &quot;bi-13&quot; degree polynomials would have 49 points.</span>
<a name="l00374"></a>00374               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[9][3] =
<a name="l00375"></a>00375                 {
<a name="l00376"></a>00376                   {0.0000000000000000e+00, 0.0000000000000000e+00, 3.0038211543122536e-01}, <span class="comment">// 1</span>
<a name="l00377"></a>00377                   {9.8348668243987226e-01, 7.7880971155441942e-01, 2.9991838864499131e-02}, <span class="comment">// 4</span>
<a name="l00378"></a>00378                   {8.5955600564163892e-01, 9.5729769978630736e-01, 3.8174421317083669e-02}, <span class="comment">// 4</span>
<a name="l00379"></a>00379                   {9.5892517028753485e-01, 1.3818345986246535e-01, 6.0424923817749980e-02}, <span class="comment">// 4</span>
<a name="l00380"></a>00380                   {3.9073621612946100e-01, 9.4132722587292523e-01, 7.7492738533105339e-02}, <span class="comment">// 4</span>
<a name="l00381"></a>00381                   {8.5007667369974857e-01, 4.7580862521827590e-01, 1.1884466730059560e-01}, <span class="comment">// 4</span>
<a name="l00382"></a>00382                   {6.4782163718701073e-01, 7.5580535657208143e-01, 1.2976355037000271e-01}, <span class="comment">// 4</span>
<a name="l00383"></a>00383                   {7.0741508996444936e-02, 6.9625007849174941e-01, 2.1334158145718938e-01}, <span class="comment">// 4</span>
<a name="l00384"></a>00384                   {4.0930456169403884e-01, 3.4271655604040678e-01, 2.5687074948196783e-01}  <span class="comment">// 4</span>
<a name="l00385"></a>00385                 };
<a name="l00386"></a>00386 
<a name="l00387"></a>00387               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> symmetry[9] = {
<a name="l00388"></a>00388                 0, <span class="comment">// Single point</span>
<a name="l00389"></a>00389                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00390"></a>00390                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00391"></a>00391                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00392"></a>00392                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00393"></a>00393                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00394"></a>00394                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00395"></a>00395                 4, <span class="comment">// Rotational Invariant</span>
<a name="l00396"></a>00396                 4  <span class="comment">// Rotational Invariant</span>
<a name="l00397"></a>00397               };
<a name="l00398"></a>00398               
<a name="l00399"></a>00399               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (33);
<a name="l00400"></a>00400               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(33);
<a name="l00401"></a>00401 
<a name="l00402"></a>00402               <a class="code" href="classlibMesh_1_1QMonomial.php#a68499e0efcbbfb1bc9f3c13ec51301d7">stroud_rule</a>(data, symmetry, 9);
<a name="l00403"></a>00403 
<a name="l00404"></a>00404               <span class="keywordflow">return</span>;
<a name="l00405"></a>00405             } <span class="comment">// end case TWELFTH,THIRTEENTH</span>
<a name="l00406"></a>00406 
<a name="l00407"></a>00407 
<a name="l00408"></a>00408 
<a name="l00409"></a>00409 
<a name="l00410"></a>00410           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0faab1534905d9792db00394cf617c71749">FOURTEENTH</a>:
<a name="l00411"></a>00411           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa7120ce4c6dcb4b9465b15e7531631fe6">FIFTEENTH</a>:
<a name="l00412"></a>00412             {
<a name="l00413"></a>00413               <span class="comment">// A degree-15, 48 point rule originally due to Rabinowitz and Richter,</span>
<a name="l00414"></a>00414               <span class="comment">// can be found in Cools&#39; 1971 book.</span>
<a name="l00415"></a>00415               <span class="comment">//</span>
<a name="l00416"></a>00416               <span class="comment">// A.H. Stroud, Approximate calculation of multiple integrals,</span>
<a name="l00417"></a>00417               <span class="comment">// Prentice-Hall, Englewood Cliffs, N.J., 1971.</span>
<a name="l00418"></a>00418               <span class="comment">//</span>
<a name="l00419"></a>00419               <span class="comment">// The product Gauss rule for this order has 8^2=64 points.</span>
<a name="l00420"></a>00420               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[9][3] =
<a name="l00421"></a>00421                 {
<a name="l00422"></a>00422                   {9.915377816777667e-01L, 0.0000000000000000e+00,  3.01245207981210e-02L}, <span class="comment">// 4</span>
<a name="l00423"></a>00423                   {8.020163879230440e-01L, 0.0000000000000000e+00,  8.71146840209092e-02L}, <span class="comment">// 4</span>
<a name="l00424"></a>00424                   {5.648674875232742e-01L, 0.0000000000000000e+00, 1.250080294351494e-01L}, <span class="comment">// 4</span>
<a name="l00425"></a>00425                   {9.354392392539896e-01L, 0.0000000000000000e+00,  2.67651407861666e-02L}, <span class="comment">// 4</span>
<a name="l00426"></a>00426                   {7.624563338825799e-01L, 0.0000000000000000e+00,  9.59651863624437e-02L}, <span class="comment">// 4</span>
<a name="l00427"></a>00427                   {2.156164241427213e-01L, 0.0000000000000000e+00, 1.750832998343375e-01L}, <span class="comment">// 4</span>
<a name="l00428"></a>00428                   {9.769662659711761e-01L, 6.684480048977932e-01L,  2.83136372033274e-02L}, <span class="comment">// 4</span>
<a name="l00429"></a>00429                   {8.937128379503403e-01L, 3.735205277617582e-01L,  8.66414716025093e-02L}, <span class="comment">// 4</span>
<a name="l00430"></a>00430                   {6.122485619312083e-01L, 4.078983303613935e-01L, 1.150144605755996e-01L}  <span class="comment">// 4</span>
<a name="l00431"></a>00431                 };
<a name="l00432"></a>00432 
<a name="l00433"></a>00433               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> symmetry[9] = {
<a name="l00434"></a>00434                 3, <span class="comment">// Full Symmetry, (x,0)</span>
<a name="l00435"></a>00435                 3, <span class="comment">// Full Symmetry, (x,0)</span>
<a name="l00436"></a>00436                 3, <span class="comment">// Full Symmetry, (x,0)</span>
<a name="l00437"></a>00437                 2, <span class="comment">// Full Symmetry, (x,x)</span>
<a name="l00438"></a>00438                 2, <span class="comment">// Full Symmetry, (x,x)</span>
<a name="l00439"></a>00439                 2, <span class="comment">// Full Symmetry, (x,x)</span>
<a name="l00440"></a>00440                 1, <span class="comment">// Full Symmetry, (x,y)</span>
<a name="l00441"></a>00441                 1, <span class="comment">// Full Symmetry, (x,y)</span>
<a name="l00442"></a>00442                 1, <span class="comment">// Full Symmetry, (x,y)</span>
<a name="l00443"></a>00443               };
<a name="l00444"></a>00444               
<a name="l00445"></a>00445               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (48);
<a name="l00446"></a>00446               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(48);
<a name="l00447"></a>00447 
<a name="l00448"></a>00448               <a class="code" href="classlibMesh_1_1QMonomial.php#a68499e0efcbbfb1bc9f3c13ec51301d7">stroud_rule</a>(data, symmetry, 9);
<a name="l00449"></a>00449 
<a name="l00450"></a>00450               <span class="keywordflow">return</span>;
<a name="l00451"></a>00451             } <span class="comment">//          case FOURTEENTH, FIFTEENTH:</span>
<a name="l00452"></a>00452 
<a name="l00453"></a>00453 
<a name="l00454"></a>00454 
<a name="l00455"></a>00455             
<a name="l00456"></a>00456           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fad3a83c160ba19d280cf82ab0fee65f2d">SIXTEENTH</a>:
<a name="l00457"></a>00457           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fae4eeb80a784baaf763cdccf0a47a4557">SEVENTEENTH</a>:
<a name="l00458"></a>00458             {
<a name="l00459"></a>00459               <span class="comment">// A degree 17, 60-point rule due to Cools and Haegemans.  </span>
<a name="l00460"></a>00460               <span class="comment">//</span>
<a name="l00461"></a>00461               <span class="comment">// R. Cools and A. Haegemans, Another step forward in searching for</span>
<a name="l00462"></a>00462               <span class="comment">// cubature formulae with a minimal number of knots for the square,</span>
<a name="l00463"></a>00463               <span class="comment">// Computing 40 (1988), 139--146.</span>
<a name="l00464"></a>00464               <span class="comment">// </span>
<a name="l00465"></a>00465               <span class="comment">// A tensor-product rule accurate for &quot;bi-14&quot; or &quot;bi-15&quot; degree polynomials would have 64 points.</span>
<a name="l00466"></a>00466               <span class="comment">// A tensor-product rule accurate for &quot;bi-16&quot; or &quot;bi-17&quot; degree polynomials would have 81 points.</span>
<a name="l00467"></a>00467               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[10][3] =
<a name="l00468"></a>00468                 {
<a name="l00469"></a>00469                   {9.8935307451260049e-01, 0.0000000000000000e+00, 2.0614915919990959e-02}, <span class="comment">// 4</span>
<a name="l00470"></a>00470                   {3.7628520715797329e-01, 0.0000000000000000e+00, 1.2802571617990983e-01}, <span class="comment">// 4</span>
<a name="l00471"></a>00471                   {9.7884827926223311e-01, 0.0000000000000000e+00, 5.5117395340318905e-03}, <span class="comment">// 4</span>
<a name="l00472"></a>00472                   {8.8579472916411612e-01, 0.0000000000000000e+00, 3.9207712457141880e-02}, <span class="comment">// 4</span>
<a name="l00473"></a>00473                   {1.7175612383834817e-01, 0.0000000000000000e+00, 7.6396945079863302e-02}, <span class="comment">// 4</span>
<a name="l00474"></a>00474                   {5.9049927380600241e-01, 3.1950503663457394e-01, 1.4151372994997245e-01}, <span class="comment">// 8</span>
<a name="l00475"></a>00475                   {7.9907913191686325e-01, 5.9797245192945738e-01, 8.3903279363797602e-02}, <span class="comment">// 8</span>
<a name="l00476"></a>00476                   {8.0374396295874471e-01, 5.8344481776550529e-02, 6.0394163649684546e-02}, <span class="comment">// 8</span>
<a name="l00477"></a>00477                   {9.3650627612749478e-01, 3.4738631616620267e-01, 5.7387752969212695e-02}, <span class="comment">// 8</span>
<a name="l00478"></a>00478                   {9.8132117980545229e-01, 7.0600028779864611e-01, 2.1922559481863763e-02}, <span class="comment">// 8</span>
<a name="l00479"></a>00479                 };
<a name="l00480"></a>00480 
<a name="l00481"></a>00481               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> symmetry[10] = {
<a name="l00482"></a>00482                 3, <span class="comment">// Fully symmetric (x,0)</span>
<a name="l00483"></a>00483                 3, <span class="comment">// Fully symmetric (x,0)</span>
<a name="l00484"></a>00484                 2, <span class="comment">// Fully symmetric (x,x)</span>
<a name="l00485"></a>00485                 2, <span class="comment">// Fully symmetric (x,x)</span>
<a name="l00486"></a>00486                 2, <span class="comment">// Fully symmetric (x,x)</span>
<a name="l00487"></a>00487                 1, <span class="comment">// Fully symmetric (x,y) </span>
<a name="l00488"></a>00488                 1, <span class="comment">// Fully symmetric (x,y)</span>
<a name="l00489"></a>00489                 1, <span class="comment">// Fully symmetric (x,y)</span>
<a name="l00490"></a>00490                 1, <span class="comment">// Fully symmetric (x,y)</span>
<a name="l00491"></a>00491                 1  <span class="comment">// Fully symmetric (x,y)</span>
<a name="l00492"></a>00492               };
<a name="l00493"></a>00493               
<a name="l00494"></a>00494               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize (60);
<a name="l00495"></a>00495               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(60);
<a name="l00496"></a>00496 
<a name="l00497"></a>00497               <a class="code" href="classlibMesh_1_1QMonomial.php#a68499e0efcbbfb1bc9f3c13ec51301d7">stroud_rule</a>(data, symmetry, 10);
<a name="l00498"></a>00498 
<a name="l00499"></a>00499               <span class="keywordflow">return</span>;
<a name="l00500"></a>00500             } <span class="comment">// end case FOURTEENTH through SEVENTEENTH</span>
<a name="l00501"></a>00501             
<a name="l00502"></a>00502             
<a name="l00503"></a>00503             
<a name="l00504"></a>00504             <span class="comment">// By default: construct and use a Gauss quadrature rule</span>
<a name="l00505"></a>00505           <span class="keywordflow">default</span>:
<a name="l00506"></a>00506             {
<a name="l00507"></a>00507               <span class="comment">// Break out and fall down into the default: case for the</span>
<a name="l00508"></a>00508               <span class="comment">// outer switch statement.</span>
<a name="l00509"></a>00509               <span class="keywordflow">break</span>;
<a name="l00510"></a>00510             }
<a name="l00511"></a>00511             
<a name="l00512"></a>00512           } <span class="comment">// end switch(_order + 2*p)</span>
<a name="l00513"></a>00513       } <span class="comment">// end case QUAD4/8/9</span>
<a name="l00514"></a>00514 
<a name="l00515"></a>00515       
<a name="l00516"></a>00516       <span class="comment">// By default: construct and use a Gauss quadrature rule</span>
<a name="l00517"></a>00517     <span class="keywordflow">default</span>:
<a name="l00518"></a>00518       {
<a name="l00519"></a>00519         <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> gauss_rule(2, _order);
<a name="l00520"></a>00520         gauss_rule.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(_type, p);
<a name="l00521"></a>00521 
<a name="l00522"></a>00522         <span class="comment">// Swap points and weights with the about-to-be destroyed rule.</span>
<a name="l00523"></a>00523         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.swap (gauss_rule.<a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">get_points</a>() );
<a name="l00524"></a>00524         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.swap(gauss_rule.<a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">get_weights</a>());
<a name="l00525"></a>00525 
<a name="l00526"></a>00526         <span class="keywordflow">return</span>;
<a name="l00527"></a>00527       }
<a name="l00528"></a>00528     } <span class="comment">// end switch (_type)</span>
<a name="l00529"></a>00529 }
<a name="l00530"></a>00530 
<a name="l00531"></a>00531 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
