<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_monomial_3D.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__monomial__3D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_monomial_3D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__monomial_8h.php">quadrature_monomial.h</a>&quot;</span>
<a name="l00024"></a>00024 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__gauss_8h.php">quadrature_gauss.h</a>&quot;</span>
<a name="l00025"></a>00025 
<a name="l00026"></a>00026 <span class="keyword">namespace </span>libMesh
<a name="l00027"></a>00027 {
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a><a class="code" href="classlibMesh_1_1QMonomial.php#a054916b2671ee9faba2c834b945236ca">00030</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QMonomial.php#a054916b2671ee9faba2c834b945236ca">QMonomial::init_3D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type,
<a name="l00031"></a>00031                         <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> p)
<a name="l00032"></a>00032 {
<a name="l00033"></a>00033 
<a name="l00034"></a>00034   <span class="keywordflow">switch</span> (_type)
<a name="l00035"></a>00035     {
<a name="l00036"></a>00036       <span class="comment">//---------------------------------------------</span>
<a name="l00037"></a>00037       <span class="comment">// Hex quadrature rules</span>
<a name="l00038"></a>00038     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00039"></a>00039     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00040"></a>00040     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00041"></a>00041       {
<a name="l00042"></a>00042         <span class="keywordflow">switch</span>(_order + 2*p)
<a name="l00043"></a>00043           {
<a name="l00044"></a>00044 
<a name="l00045"></a>00045             <span class="comment">// The CONSTANT/FIRST rule is the 1-point Gauss &quot;product&quot; rule...we fall</span>
<a name="l00046"></a>00046             <span class="comment">// through to the default case for this rule.</span>
<a name="l00047"></a>00047             
<a name="l00048"></a>00048           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa996958e976cf6cba9461db488396e753">SECOND</a>:
<a name="l00049"></a>00049           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa1e9eb131bc526ffcaa49989faff73f6c">THIRD</a>:
<a name="l00050"></a>00050             {
<a name="l00051"></a>00051               <span class="comment">// A degree 3, 6-point, &quot;rotationally-symmetric&quot; rule by</span>
<a name="l00052"></a>00052               <span class="comment">// Kim and Song, Comm. Korean Math. Soc vol. 13, no. 4, 1998, pp. 913-931.</span>
<a name="l00053"></a>00053               <span class="comment">//</span>
<a name="l00054"></a>00054               <span class="comment">// Warning: this rule contains points on the boundary of the reference</span>
<a name="l00055"></a>00055               <span class="comment">// element, and therefore may be unsuitable for some problems.  The alternative</span>
<a name="l00056"></a>00056               <span class="comment">// would be a 2x2x2 Gauss product rule.</span>
<a name="l00057"></a>00057               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[1][4] =
<a name="l00058"></a>00058                 {
<a name="l00059"></a>00059                   {1.0L, 0.0L, 0.0L, 4.0L/3.0L}  
<a name="l00060"></a>00060                 };
<a name="l00061"></a>00061 
<a name="l00062"></a>00062               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rule_id[1] = {
<a name="l00063"></a>00063                 1 <span class="comment">// (x,0,0) -&gt; 6 permutations</span>
<a name="l00064"></a>00064               };
<a name="l00065"></a>00065 
<a name="l00066"></a>00066               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(6);
<a name="l00067"></a>00067               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(6);
<a name="l00068"></a>00068 
<a name="l00069"></a>00069               <a class="code" href="classlibMesh_1_1QMonomial.php#a05e6cf99b4befdcd61a7aa5f4ee180f7">kim_rule</a>(data, rule_id, 1);
<a name="l00070"></a>00070               <span class="keywordflow">return</span>;
<a name="l00071"></a>00071             } <span class="comment">// end case SECOND,THIRD</span>
<a name="l00072"></a>00072 
<a name="l00073"></a>00073           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa786b5502dc91e9f53b5cbc9c284852a0">FOURTH</a>:
<a name="l00074"></a>00074           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa357bed9167850d65b08770e2ab6587ac">FIFTH</a>:
<a name="l00075"></a>00075             {
<a name="l00076"></a>00076               <span class="comment">// A degree 5, 13-point rule by Stroud,</span>
<a name="l00077"></a>00077               <span class="comment">// AH Stroud, &quot;Some Fifth Degree Integration Formulas for Symmetric Regions II.&quot;,</span>
<a name="l00078"></a>00078               <span class="comment">// Numerische Mathematik 9, pp. 460-468 (1967).</span>
<a name="l00079"></a>00079               <span class="comment">//</span>
<a name="l00080"></a>00080               <span class="comment">// This rule is provably minimal in the number of points.  The equations given for</span>
<a name="l00081"></a>00081               <span class="comment">// the n-cube on pg. 466 of the paper for mu/gamma and gamma are wrong, at least for</span>
<a name="l00082"></a>00082               <span class="comment">// the n=3 case.  The analytical values given here were computed by me [JWP] in Maple.</span>
<a name="l00083"></a>00083 
<a name="l00084"></a>00084               <span class="comment">// Convenient intermediate values.</span>
<a name="l00085"></a>00085               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> sqrt19 = std::sqrt(19.L);
<a name="l00086"></a>00086               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> tp     = std::sqrt(71440.L + 6802.L*sqrt19);
<a name="l00087"></a>00087               
<a name="l00088"></a>00088               <span class="comment">// Point data for permutations.</span>
<a name="l00089"></a>00089               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> eta    =  0.00000000000000000000000000000000e+00L;
<a name="l00090"></a>00090               
<a name="l00091"></a>00091               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> lambda =  std::sqrt(1919.L/3285.L - 148.L*sqrt19/3285.L + 4.L*tp/3285.L);
<a name="l00092"></a>00092               <span class="comment">// 8.8030440669930978047737818209860e-01L; </span>
<a name="l00093"></a>00093               
<a name="l00094"></a>00094               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> xi     = -std::sqrt(1121.L/3285.L +  74.L*sqrt19/3285.L - 2.L*tp/3285.L);
<a name="l00095"></a>00095               <span class="comment">// -4.9584817142571115281421242364290e-01L; </span>
<a name="l00096"></a>00096               
<a name="l00097"></a>00097               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> mu     =  std::sqrt(1121.L/3285.L +  74.L*sqrt19/3285.L + 2.L*tp/3285.L);
<a name="l00098"></a>00098               <span class="comment">// 7.9562142216409541542982482567580e-01L;</span>
<a name="l00099"></a>00099               
<a name="l00100"></a>00100               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> gamma  =  std::sqrt(1919.L/3285.L - 148.L*sqrt19/3285.L - 4.L*tp/3285.L);
<a name="l00101"></a>00101               <span class="comment">// 2.5293711744842581347389255929324e-02L; </span>
<a name="l00102"></a>00102               
<a name="l00103"></a>00103               <span class="comment">// Weights: the centroid weight is given analytically.  Weight B (resp C) goes</span>
<a name="l00104"></a>00104               <span class="comment">// with the {lambda,xi} (resp {gamma,mu}) permutation.  The single-precision</span>
<a name="l00105"></a>00105               <span class="comment">// results reported by Stroud are given for reference.</span>
<a name="l00106"></a>00106 
<a name="l00107"></a>00107               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> A      = 32.0L / 19.0L;
<a name="l00108"></a>00108               <span class="comment">// Stroud: 0.21052632  * 8.0 = 1.684210560;</span>
<a name="l00109"></a>00109 
<a name="l00110"></a>00110               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> B      = 1.L / ( 260072.L/133225.L  - 1520*sqrt19/133225.L + (133.L - 37.L*sqrt19)*tp/133225.L );
<a name="l00111"></a>00111               <span class="comment">// 5.4498735127757671684690782180890e-01L; // Stroud: 0.068123420 * 8.0 = 0.544987360;</span>
<a name="l00112"></a>00112               
<a name="l00113"></a>00113               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> C      = 1.L / ( 260072.L/133225.L  - 1520*sqrt19/133225.L - (133.L - 37.L*sqrt19)*tp/133225.L );
<a name="l00114"></a>00114               <span class="comment">// 5.0764422766979170420572375713840e-01L; // Stroud: 0.063455527 * 8.0 = 0.507644216;</span>
<a name="l00115"></a>00115               
<a name="l00116"></a>00116               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(13);
<a name="l00117"></a>00117               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(13);
<a name="l00118"></a>00118 
<a name="l00119"></a>00119               <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> c=0;
<a name="l00120"></a>00120 
<a name="l00121"></a>00121               <span class="comment">// Point with weight A (origin)</span>
<a name="l00122"></a>00122               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(eta, eta, eta);
<a name="l00123"></a>00123               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = A;
<a name="l00124"></a>00124 
<a name="l00125"></a>00125               <span class="comment">// Points with weight B</span>
<a name="l00126"></a>00126               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(lambda, xi, xi);  
<a name="l00127"></a>00127               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = B;
<a name="l00128"></a>00128               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = -<a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c-1];             
<a name="l00129"></a>00129               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = B;
<a name="l00130"></a>00130               
<a name="l00131"></a>00131               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(xi, lambda, xi);  
<a name="l00132"></a>00132               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = B;
<a name="l00133"></a>00133               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = -<a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c-1];             
<a name="l00134"></a>00134               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = B;
<a name="l00135"></a>00135 
<a name="l00136"></a>00136               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(xi, xi, lambda);  
<a name="l00137"></a>00137               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = B;
<a name="l00138"></a>00138               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = -<a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c-1];             
<a name="l00139"></a>00139               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = B;
<a name="l00140"></a>00140 
<a name="l00141"></a>00141               <span class="comment">// Points with weight C</span>
<a name="l00142"></a>00142               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(mu, mu, gamma);  
<a name="l00143"></a>00143               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = C;
<a name="l00144"></a>00144               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = -<a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c-1];             
<a name="l00145"></a>00145               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = C;
<a name="l00146"></a>00146               
<a name="l00147"></a>00147               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(mu, gamma, mu);  
<a name="l00148"></a>00148               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = C;
<a name="l00149"></a>00149               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = -<a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c-1];             
<a name="l00150"></a>00150               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = C;
<a name="l00151"></a>00151 
<a name="l00152"></a>00152               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = <a class="code" href="classlibMesh_1_1Point.php">Point</a>(gamma, mu, mu);  
<a name="l00153"></a>00153               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = C;
<a name="l00154"></a>00154               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c] = -<a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[c-1];             
<a name="l00155"></a>00155               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[c++] = C;
<a name="l00156"></a>00156               
<a name="l00157"></a>00157               <span class="keywordflow">return</span>;
<a name="l00158"></a>00158 
<a name="l00159"></a>00159               
<a name="l00160"></a>00160 <span class="comment">//            // A degree 5, 14-point, &quot;rotationally-symmetric&quot; rule by</span>
<a name="l00161"></a>00161 <span class="comment">//            // Kim and Song, Comm. Korean Math. Soc vol. 13, no. 4, 1998, pp. 913-931.</span>
<a name="l00162"></a>00162 <span class="comment">//            // Was also reported in Stroud&#39;s 1971 book.</span>
<a name="l00163"></a>00163 <span class="comment">//            const Real data[2][4] =</span>
<a name="l00164"></a>00164 <span class="comment">//              {</span>
<a name="l00165"></a>00165 <span class="comment">//                {7.95822425754221463264548820476135e-01L, 0.00000000000000000000000000000000e+00L, 0.00000000000000000000000000000000e+00L, 8.86426592797783933518005540166204e-01L}, </span>
<a name="l00166"></a>00166 <span class="comment">//                {7.58786910639328146269034278112267e-01L, 7.58786910639328146269034278112267e-01L, 7.58786910639328146269034278112267e-01L, 3.35180055401662049861495844875346e-01L}  </span>
<a name="l00167"></a>00167 <span class="comment">//              };</span>
<a name="l00168"></a>00168 
<a name="l00169"></a>00169 <span class="comment">//            const unsigned int rule_id[2] = {</span>
<a name="l00170"></a>00170 <span class="comment">//              1, // (x,0,0) -&gt; 6 permutations</span>
<a name="l00171"></a>00171 <span class="comment">//              4  // (x,x,x) -&gt; 8 permutations</span>
<a name="l00172"></a>00172 <span class="comment">//            };</span>
<a name="l00173"></a>00173 
<a name="l00174"></a>00174 <span class="comment">//            _points.resize(14);</span>
<a name="l00175"></a>00175 <span class="comment">//            _weights.resize(14);</span>
<a name="l00176"></a>00176 
<a name="l00177"></a>00177 <span class="comment">//            kim_rule(data, rule_id, 2);</span>
<a name="l00178"></a>00178 <span class="comment">//            return;</span>
<a name="l00179"></a>00179             } <span class="comment">// end case FOURTH,FIFTH</span>
<a name="l00180"></a>00180 
<a name="l00181"></a>00181           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa12e4c6641c177b3d6a15fa73eb5bfa1a">SIXTH</a>:
<a name="l00182"></a>00182           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa084350fc91ff5f1f99dc2a99e9494e1f">SEVENTH</a>:
<a name="l00183"></a>00183             {
<a name="l00184"></a>00184               <span class="keywordflow">if</span> (<a class="code" href="classlibMesh_1_1QBase.php#a6f1f4bb99c359f881b0b5b2695bb2cde">allow_rules_with_negative_weights</a>)
<a name="l00185"></a>00185                 {
<a name="l00186"></a>00186                   <span class="comment">// A degree 7, 31-point, &quot;rotationally-symmetric&quot; rule by</span>
<a name="l00187"></a>00187                   <span class="comment">// Kim and Song, Comm. Korean Math. Soc vol. 13, no. 4, 1998, pp. 913-931.</span>
<a name="l00188"></a>00188                   <span class="comment">// This rule contains a negative weight, so only use it if such type of</span>
<a name="l00189"></a>00189                   <span class="comment">// rules are allowed.</span>
<a name="l00190"></a>00190                   <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[3][4] =
<a name="l00191"></a>00191                     {
<a name="l00192"></a>00192                       {0.00000000000000000000000000000000e+00L, 0.00000000000000000000000000000000e+00L, 0.00000000000000000000000000000000e+00L, -1.27536231884057971014492753623188e+00L}, 
<a name="l00193"></a>00193                       {5.85540043769119907612630781744060e-01L, 0.00000000000000000000000000000000e+00L, 0.00000000000000000000000000000000e+00L,  8.71111111111111111111111111111111e-01L}, 
<a name="l00194"></a>00194                       {6.94470135991704766602025803883310e-01L, 9.37161638568208038511047377665396e-01L, 4.15659267604065126239606672567031e-01L,  1.68695652173913043478260869565217e-01L}  
<a name="l00195"></a>00195                     };
<a name="l00196"></a>00196                   
<a name="l00197"></a>00197                   <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rule_id[3] = {
<a name="l00198"></a>00198                     0, <span class="comment">// (0,0,0) -&gt; 1 permutation</span>
<a name="l00199"></a>00199                     1, <span class="comment">// (x,0,0) -&gt; 6 permutations</span>
<a name="l00200"></a>00200                     6  <span class="comment">// (x,y,z) -&gt; 24 permutations</span>
<a name="l00201"></a>00201                   };
<a name="l00202"></a>00202 
<a name="l00203"></a>00203                   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(31);
<a name="l00204"></a>00204                   <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(31);
<a name="l00205"></a>00205 
<a name="l00206"></a>00206                   <a class="code" href="classlibMesh_1_1QMonomial.php#a05e6cf99b4befdcd61a7aa5f4ee180f7">kim_rule</a>(data, rule_id, 3);
<a name="l00207"></a>00207                   <span class="keywordflow">return</span>;
<a name="l00208"></a>00208                 } <span class="comment">// end if (allow_rules_with_negative_weights)</span>
<a name="l00209"></a>00209 
<a name="l00210"></a>00210               
<a name="l00211"></a>00211               <span class="comment">// A degree 7, 34-point, &quot;fully-symmetric&quot; rule, first published in</span>
<a name="l00212"></a>00212               <span class="comment">// P.C. Hammer and A.H. Stroud, &quot;Numerical Evaluation of Multiple Integrals II&quot;,</span>
<a name="l00213"></a>00213               <span class="comment">// Mathmatical Tables and Other Aids to Computation, vol 12., no 64, 1958, pp. 272-280</span>
<a name="l00214"></a>00214               <span class="comment">//</span>
<a name="l00215"></a>00215               <span class="comment">// This rule happens to fall under the same general</span>
<a name="l00216"></a>00216               <span class="comment">// construction as the Kim rules, so we&#39;ve re-used</span>
<a name="l00217"></a>00217               <span class="comment">// that code here.  Stroud gives 16 digits for his rule,</span>
<a name="l00218"></a>00218               <span class="comment">// and this is the most accurate version I&#39;ve found.</span>
<a name="l00219"></a>00219               <span class="comment">//</span>
<a name="l00220"></a>00220               <span class="comment">// For comparison, a SEVENTH-order Gauss product rule</span>
<a name="l00221"></a>00221               <span class="comment">// (which integrates tri-7th order polynomials) would</span>
<a name="l00222"></a>00222               <span class="comment">// have 4^3=64 points.</span>
<a name="l00223"></a>00223               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a>
<a name="l00224"></a>00224                 r  = std::sqrt(6.L/7.L),
<a name="l00225"></a>00225                 s  = std::sqrt((960.L - 3.L*std::sqrt(28798.L)) / 2726.L),
<a name="l00226"></a>00226                 t  = std::sqrt((960.L + 3.L*std::sqrt(28798.L)) / 2726.L),
<a name="l00227"></a>00227                 B1 = 8624.L / 29160.L,
<a name="l00228"></a>00228                 B2 = 2744.L / 29160.L,
<a name="l00229"></a>00229                 B3 = 8.L*(774.L*t*t - 230.L)/(9720.L*(t*t-s*s)),
<a name="l00230"></a>00230                 B4 = 8.L*(230.L - 774.L*s*s)/(9720.L*(t*t-s*s));
<a name="l00231"></a>00231                 
<a name="l00232"></a>00232               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[4][4] =
<a name="l00233"></a>00233                 {
<a name="l00234"></a>00234                   {r, 0.L, 0.L, B1}, 
<a name="l00235"></a>00235                   {r,   r, 0.L, B2}, 
<a name="l00236"></a>00236                   {s,   s,   s, B3}, 
<a name="l00237"></a>00237                   {t,   t,   t, B4}  
<a name="l00238"></a>00238                 };
<a name="l00239"></a>00239                   
<a name="l00240"></a>00240               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rule_id[4] = {
<a name="l00241"></a>00241                 1, <span class="comment">// (x,0,0) -&gt; 6 permutations</span>
<a name="l00242"></a>00242                 2, <span class="comment">// (x,x,0) -&gt; 12 permutations</span>
<a name="l00243"></a>00243                 4, <span class="comment">// (x,x,x) -&gt; 8 permutations</span>
<a name="l00244"></a>00244                 4  <span class="comment">// (x,x,x) -&gt; 8 permutations</span>
<a name="l00245"></a>00245                   };
<a name="l00246"></a>00246 
<a name="l00247"></a>00247               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(34);
<a name="l00248"></a>00248               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(34);
<a name="l00249"></a>00249 
<a name="l00250"></a>00250               <a class="code" href="classlibMesh_1_1QMonomial.php#a05e6cf99b4befdcd61a7aa5f4ee180f7">kim_rule</a>(data, rule_id, 4);
<a name="l00251"></a>00251               <span class="keywordflow">return</span>;
<a name="l00252"></a>00252 
<a name="l00253"></a>00253 
<a name="l00254"></a>00254 <span class="comment">//            // A degree 7, 38-point, &quot;rotationally-symmetric&quot; rule by</span>
<a name="l00255"></a>00255 <span class="comment">//            // Kim and Song, Comm. Korean Math. Soc vol. 13, no. 4, 1998, pp. 913-931.</span>
<a name="l00256"></a>00256 <span class="comment">//            //</span>
<a name="l00257"></a>00257 <span class="comment">//            // This rule is obviously inferior to the 34-point rule above...</span>
<a name="l00258"></a>00258 <span class="comment">//            const Real data[3][4] =</span>
<a name="l00259"></a>00259 <span class="comment">//              {</span>
<a name="l00260"></a>00260 <span class="comment">//                {9.01687807821291289082811566285950e-01L, 0.00000000000000000000000000000000e+00L, 0.00000000000000000000000000000000e+00L, 2.95189738262622903181631100062774e-01L}, </span>
<a name="l00261"></a>00261 <span class="comment">//                {4.08372221499474674069588900002128e-01L, 4.08372221499474674069588900002128e-01L, 4.08372221499474674069588900002128e-01L, 4.04055417266200582425904380777126e-01L}, </span>
<a name="l00262"></a>00262 <span class="comment">//                {8.59523090201054193116477875786220e-01L, 8.59523090201054193116477875786220e-01L, 4.14735913727987720499709244748633e-01L, 1.24850759678944080062624098058597e-01L}  </span>
<a name="l00263"></a>00263 <span class="comment">//              };</span>
<a name="l00264"></a>00264 <span class="comment">//</span>
<a name="l00265"></a>00265 <span class="comment">//            const unsigned int rule_id[3] = {</span>
<a name="l00266"></a>00266 <span class="comment">//              1, // (x,0,0) -&gt; 6 permutations</span>
<a name="l00267"></a>00267 <span class="comment">//              4, // (x,x,x) -&gt; 8 permutations</span>
<a name="l00268"></a>00268 <span class="comment">//              5  // (x,x,z) -&gt; 24 permutations</span>
<a name="l00269"></a>00269 <span class="comment">//            };</span>
<a name="l00270"></a>00270 <span class="comment">//</span>
<a name="l00271"></a>00271 <span class="comment">//            _points.resize(38);</span>
<a name="l00272"></a>00272 <span class="comment">//            _weights.resize(38);</span>
<a name="l00273"></a>00273 <span class="comment">//</span>
<a name="l00274"></a>00274 <span class="comment">//            kim_rule(data, rule_id, 3);</span>
<a name="l00275"></a>00275 <span class="comment">//            return;</span>
<a name="l00276"></a>00276             } <span class="comment">// end case SIXTH,SEVENTH</span>
<a name="l00277"></a>00277 
<a name="l00278"></a>00278           <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#aec0a9e70ed9a84a861c4df1460dc3a0fa10019183220ee3e691f593d9507eb620">EIGHTH</a>:
<a name="l00279"></a>00279             {
<a name="l00280"></a>00280               <span class="comment">// A degree 8, 47-point, &quot;rotationally-symmetric&quot; rule by</span>
<a name="l00281"></a>00281               <span class="comment">// Kim and Song, Comm. Korean Math. Soc vol. 13, no. 4, 1998, pp. 913-931.</span>
<a name="l00282"></a>00282               <span class="comment">//</span>
<a name="l00283"></a>00283               <span class="comment">// A EIGHTH-order Gauss product rule (which integrates tri-8th order polynomials)</span>
<a name="l00284"></a>00284               <span class="comment">// would have 5^3=125 points.</span>
<a name="l00285"></a>00285               <span class="keyword">const</span> <a class="code" href="namespacelibMesh.php#aef28359fb4851abec08fc99cfbac118d">Real</a> data[5][4] =
<a name="l00286"></a>00286                 {
<a name="l00287"></a>00287                   {0.00000000000000000000000000000000e+00L, 0.00000000000000000000000000000000e+00L, 0.00000000000000000000000000000000e+00L, 4.51903714875199690490763818699555e-01L}, 
<a name="l00288"></a>00288                   {7.82460796435951590652813975429717e-01L, 0.00000000000000000000000000000000e+00L, 0.00000000000000000000000000000000e+00L, 2.99379177352338919703385618576171e-01L}, 
<a name="l00289"></a>00289                   {4.88094669706366480526729301468686e-01L, 4.88094669706366480526729301468686e-01L, 4.88094669706366480526729301468686e-01L, 3.00876159371240019939698689791164e-01L}, 
<a name="l00290"></a>00290                   {8.62218927661481188856422891110042e-01L, 8.62218927661481188856422891110042e-01L, 8.62218927661481188856422891110042e-01L, 4.94843255877038125738173175714853e-02L},  
<a name="l00291"></a>00291                   {2.81113909408341856058098281846420e-01L, 9.44196578292008195318687494773744e-01L, 6.97574833707236996779391729948984e-01L, 1.22872389222467338799199767122592e-01L}  
<a name="l00292"></a>00292                 };
<a name="l00293"></a>00293 
<a name="l00294"></a>00294               <span class="keyword">const</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span> rule_id[5] = {
<a name="l00295"></a>00295                 0, <span class="comment">// (0,0,0) -&gt; 1 permutation</span>
<a name="l00296"></a>00296                 1, <span class="comment">// (x,0,0) -&gt; 6 permutations</span>
<a name="l00297"></a>00297                 4, <span class="comment">// (x,x,x) -&gt; 8 permutations</span>
<a name="l00298"></a>00298                 4, <span class="comment">// (x,x,x) -&gt; 8 permutations</span>
<a name="l00299"></a>00299                 6  <span class="comment">// (x,y,z) -&gt; 24 permutations</span>
<a name="l00300"></a>00300               };
<a name="l00301"></a>00301 
<a name="l00302"></a>00302               <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(47);
<a name="l00303"></a>00303               <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(47);
<a name="l00304"></a>00304 
<a name="l00305"></a>00305               <a class="code" href="classlibMesh_1_1QMonomial.php#a05e6cf99b4befdcd61a7aa5f4ee180f7">kim_rule</a>(data, rule_id, 5);
<a name="l00306"></a>00306               <span class="keywordflow">return</span>;
<a name="l00307"></a>00307             } <span class="comment">// end case EIGHTH</span>
<a name="l00308"></a>00308 
<a name="l00309"></a>00309             
<a name="l00310"></a>00310             <span class="comment">// By default: construct and use a Gauss quadrature rule</span>
<a name="l00311"></a>00311           <span class="keywordflow">default</span>:
<a name="l00312"></a>00312             {
<a name="l00313"></a>00313               <span class="comment">// Break out and fall down into the default: case for the</span>
<a name="l00314"></a>00314               <span class="comment">// outer switch statement.</span>
<a name="l00315"></a>00315               <span class="keywordflow">break</span>;
<a name="l00316"></a>00316             }
<a name="l00317"></a>00317             
<a name="l00318"></a>00318           } <span class="comment">// end switch(_order + 2*p)</span>
<a name="l00319"></a>00319       } <span class="comment">// end case HEX8/20/27</span>
<a name="l00320"></a>00320 
<a name="l00321"></a>00321       
<a name="l00322"></a>00322       <span class="comment">// By default: construct and use a Gauss quadrature rule</span>
<a name="l00323"></a>00323     <span class="keywordflow">default</span>:
<a name="l00324"></a>00324       {
<a name="l00325"></a>00325         <a class="code" href="classlibMesh_1_1QGauss.php">QGauss</a> gauss_rule(3, _order);
<a name="l00326"></a>00326         gauss_rule.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(_type, p);
<a name="l00327"></a>00327 
<a name="l00328"></a>00328         <span class="comment">// Swap points and weights with the about-to-be destroyed rule.</span>
<a name="l00329"></a>00329         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.swap (gauss_rule.<a class="code" href="classlibMesh_1_1QBase.php#ad8d49997a7441bc59f3a44f77fae4852">get_points</a>() );
<a name="l00330"></a>00330         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.swap(gauss_rule.<a class="code" href="classlibMesh_1_1QBase.php#a2edd6df821d4beabee5c354982b77ad7">get_weights</a>());
<a name="l00331"></a>00331 
<a name="l00332"></a>00332         <span class="keywordflow">return</span>;
<a name="l00333"></a>00333       }
<a name="l00334"></a>00334     } <span class="comment">// end switch (_type)</span>
<a name="l00335"></a>00335 }
<a name="l00336"></a>00336 
<a name="l00337"></a>00337 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
