<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_rules.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__rules_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_rules.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 <span class="comment">// C++ includes</span>
<a name="l00022"></a>00022 <span class="preprocessor">#include &lt;iostream&gt;</span>
<a name="l00023"></a>00023 
<a name="l00024"></a>00024 <span class="comment">// Local includes</span>
<a name="l00025"></a>00025 <span class="preprocessor">#include &quot;<a class="code" href="libmesh__common_8h.php">libmesh_common.h</a>&quot;</span>
<a name="l00026"></a>00026 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__rules_8h.php">quadrature_rules.h</a>&quot;</span>
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 <span class="keyword">namespace </span>libMesh
<a name="l00029"></a>00029 {
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a>00032 
<a name="l00033"></a><a class="code" href="namespacelibMesh_1_1QuadratureRules.php#a312145f81bfe86d687e7f545e315ef66">00033</a> std::string <a class="code" href="namespacelibMesh_1_1QuadratureRules.php#a312145f81bfe86d687e7f545e315ef66">QuadratureRules::name</a> (<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ad">QuadratureType</a> q) 
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035   std::string its_name;
<a name="l00036"></a>00036   
<a name="l00037"></a>00037   <span class="keywordflow">switch</span> (q)
<a name="l00038"></a>00038     {
<a name="l00039"></a>00039       
<a name="l00040"></a>00040     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada11bd5a126c073e475e588e38016b3785">QGAUSS</a>:
<a name="l00041"></a>00041       its_name = <span class="stringliteral">&quot;Gauss-Legendre Quadrature&quot;</span>;
<a name="l00042"></a>00042       <span class="keywordflow">break</span>;
<a name="l00043"></a>00043 
<a name="l00044"></a>00044     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adad3a339e15685559999115b81f6d38370">QJACOBI_1_0</a>:
<a name="l00045"></a>00045       its_name = <span class="stringliteral">&quot;Jacobi(1,0)-Gauss Quadrature&quot;</span>;
<a name="l00046"></a>00046       <span class="keywordflow">break</span>;
<a name="l00047"></a>00047 
<a name="l00048"></a>00048     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada52629eed7dec8b36fbd387b3dd51d48d">QJACOBI_2_0</a>:
<a name="l00049"></a>00049       its_name = <span class="stringliteral">&quot;Jacobi(2,0)-Gauss Quadrature&quot;</span>;
<a name="l00050"></a>00050       <span class="keywordflow">break</span>;
<a name="l00051"></a>00051 
<a name="l00052"></a>00052     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716adaeb07c05dac20ab7f134838e34f9db0c1">QSIMPSON</a>:
<a name="l00053"></a>00053       its_name = <span class="stringliteral">&quot;Simpson Rule&quot;</span>;
<a name="l00054"></a>00054       <span class="keywordflow">break</span>;
<a name="l00055"></a>00055 
<a name="l00056"></a>00056     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a4650fed21cdce6d06df0add57ee716ada26431abeff146407680a87ae0dd3a39a">QTRAP</a>:
<a name="l00057"></a>00057       its_name = <span class="stringliteral">&quot;Trapezoidal Rule&quot;</span>;
<a name="l00058"></a>00058       <span class="keywordflow">break</span>;
<a name="l00059"></a>00059 
<a name="l00060"></a>00060 
<a name="l00061"></a>00061     <span class="keywordflow">default</span>:
<a name="l00062"></a>00062       { 
<a name="l00063"></a>00063         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Bad qt=&quot;</span> &lt;&lt; q &lt;&lt; std::endl;
<a name="l00064"></a>00064         libmesh_error();
<a name="l00065"></a>00065       }
<a name="l00066"></a>00066     }
<a name="l00067"></a>00067   
<a name="l00068"></a>00068   <span class="keywordflow">return</span> its_name;
<a name="l00069"></a>00069 }
<a name="l00070"></a>00070 
<a name="l00071"></a>00071 } <span class="comment">// namespace libMesh</span>
<a name="l00072"></a>00072 
<a name="l00073"></a>00073 
<a name="l00074"></a>00074 
<a name="l00075"></a>00075 
<a name="l00076"></a>00076 
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
