<?php $root="../"; ?>
<?php require($root."navigation.php"); ?>

<html>
<head>
  <title>LibMesh Class Documentation</title>
  <?php load_style($root); ?>
</head>

<body>
<?php make_navigation("documentation",$root)?>

<div class="content">
<!-- Generated by Doxygen 1.7.4 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.php"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.php"><span>Namespaces</span></a></li>
      <li><a href="annotated.php"><span>Classes</span></a></li>
      <li class="current"><a href="files.php"><span>Files</span></a></li>
      <li><a href="dirs.php"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.php"><span>File&#160;List</span></a></li>
      <li><a href="globals.php"><span>File&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="dir_b878589ff746f8138e7f8f17cb4cbbc1.php">src</a>      </li>
      <li class="navelem"><a class="el" href="dir_2366301720c1c2378574208e3db04d8d.php">quadrature</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="headertitle">
<div class="title">quadrature_simpson_3D.C</div>  </div>
</div>
<div class="contents">
<a href="quadrature__simpson__3D_8C.php">Go to the documentation of this file.</a><div class="fragment"><pre class="fragment"><a name="l00001"></a>00001 <span class="comment">// $Id: quadrature_simpson_3D.C 3874 2010-07-02 21:57:26Z roystgnr $</span>
<a name="l00002"></a>00002 
<a name="l00003"></a>00003 <span class="comment">// The libMesh Finite Element Library.</span>
<a name="l00004"></a>00004 <span class="comment">// Copyright (C) 2002-2008 Benjamin S. Kirk, John W. Peterson, Roy H. Stogner</span>
<a name="l00005"></a>00005   
<a name="l00006"></a>00006 <span class="comment">// This library is free software; you can redistribute it and/or</span>
<a name="l00007"></a>00007 <span class="comment">// modify it under the terms of the GNU Lesser General Public</span>
<a name="l00008"></a>00008 <span class="comment">// License as published by the Free Software Foundation; either</span>
<a name="l00009"></a>00009 <span class="comment">// version 2.1 of the License, or (at your option) any later version.</span>
<a name="l00010"></a>00010   
<a name="l00011"></a>00011 <span class="comment">// This library is distributed in the hope that it will be useful,</span>
<a name="l00012"></a>00012 <span class="comment">// but WITHOUT ANY WARRANTY; without even the implied warranty of</span>
<a name="l00013"></a>00013 <span class="comment">// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU</span>
<a name="l00014"></a>00014 <span class="comment">// Lesser General Public License for more details.</span>
<a name="l00015"></a>00015   
<a name="l00016"></a>00016 <span class="comment">// You should have received a copy of the GNU Lesser General Public</span>
<a name="l00017"></a>00017 <span class="comment">// License along with this library; if not, write to the Free Software</span>
<a name="l00018"></a>00018 <span class="comment">// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA</span>
<a name="l00019"></a>00019 
<a name="l00020"></a>00020 
<a name="l00021"></a>00021 
<a name="l00022"></a>00022 <span class="comment">// Local includes</span>
<a name="l00023"></a>00023 <span class="preprocessor">#include &quot;<a class="code" href="quadrature__simpson_8h.php">quadrature_simpson.h</a>&quot;</span>
<a name="l00024"></a>00024 
<a name="l00025"></a>00025 <span class="keyword">namespace </span>libMesh
<a name="l00026"></a>00026 {
<a name="l00027"></a>00027 
<a name="l00028"></a>00028 
<a name="l00029"></a>00029 
<a name="l00030"></a>00030 
<a name="l00031"></a>00031 
<a name="l00032"></a><a class="code" href="classlibMesh_1_1QSimpson.php#ad7c06989927c616bebfe2b8e4cb6b91e">00032</a> <span class="keywordtype">void</span> <a class="code" href="classlibMesh_1_1QSimpson.php#ad7c06989927c616bebfe2b8e4cb6b91e">QSimpson::init_3D</a>(<span class="keyword">const</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457">ElemType</a> _type,
<a name="l00033"></a>00033                        <span class="keywordtype">unsigned</span> <span class="keywordtype">int</span>)
<a name="l00034"></a>00034 {
<a name="l00035"></a>00035 <span class="preprocessor">#if LIBMESH_DIM == 3</span>
<a name="l00036"></a>00036 <span class="preprocessor"></span>  
<a name="l00037"></a>00037   <span class="comment">//-----------------------------------------------------------------------</span>
<a name="l00038"></a>00038   <span class="comment">// 3D quadrature rules</span>
<a name="l00039"></a>00039   <span class="keywordflow">switch</span> (_type)
<a name="l00040"></a>00040     {
<a name="l00041"></a>00041       <span class="comment">//---------------------------------------------</span>
<a name="l00042"></a>00042       <span class="comment">// Hex quadrature rules</span>
<a name="l00043"></a>00043     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a923c4e4e6400963e9f76551efd62b4a0">HEX8</a>:
<a name="l00044"></a>00044     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aaa666e1610412fb3365aa5c6fca8c723">HEX20</a>:
<a name="l00045"></a>00045     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457aa37e2c264dca7c853841cc29e2651717">HEX27</a>:
<a name="l00046"></a>00046       {
<a name="l00047"></a>00047         <span class="comment">// We compute the 3D quadrature rule as a tensor</span>
<a name="l00048"></a>00048         <span class="comment">// product of the 1D quadrature rule.</span>
<a name="l00049"></a>00049         <a class="code" href="classlibMesh_1_1QSimpson.php">QSimpson</a> q1D(1);
<a name="l00050"></a>00050         q1D.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>);
<a name="l00051"></a>00051 
<a name="l00052"></a>00052         tensor_product_hex( q1D );
<a name="l00053"></a>00053         
<a name="l00054"></a>00054         <span class="keywordflow">return</span>;
<a name="l00055"></a>00055       }
<a name="l00056"></a>00056 
<a name="l00057"></a>00057 
<a name="l00058"></a>00058       
<a name="l00059"></a>00059       <span class="comment">//---------------------------------------------</span>
<a name="l00060"></a>00060       <span class="comment">// Tetrahedral quadrature rules</span>
<a name="l00061"></a>00061     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a4d9b820fdbef7fc7f5310a30e37e06b9">TET4</a>:
<a name="l00062"></a>00062     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a01f6850195138cf12206f3a46cc17da0">TET10</a>:
<a name="l00063"></a>00063       {
<a name="l00064"></a>00064         <span class="comment">// This rule is created by combining 8 subtets</span>
<a name="l00065"></a>00065         <span class="comment">// which use the trapezoidal rule.  The weights</span>
<a name="l00066"></a>00066         <span class="comment">// may seem a bit odd, but they are correct,</span>
<a name="l00067"></a>00067         <span class="comment">// and should add up to 1/6, the volume of the</span>
<a name="l00068"></a>00068         <span class="comment">// reference tet.  The points of this rule are</span>
<a name="l00069"></a>00069         <span class="comment">// at the nodal points of the TET10, allowing</span>
<a name="l00070"></a>00070         <span class="comment">// you to generate diagonal element stiffness</span>
<a name="l00071"></a>00071         <span class="comment">// matrices when using quadratic elements.</span>
<a name="l00072"></a>00072         <span class="comment">// It should be able to integrate something</span>
<a name="l00073"></a>00073         <span class="comment">// better than linears, but I&#39;m not sure how</span>
<a name="l00074"></a>00074         <span class="comment">// high.</span>
<a name="l00075"></a>00075         
<a name="l00076"></a>00076         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>.resize(10);
<a name="l00077"></a>00077         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>.resize(10);
<a name="l00078"></a>00078         
<a name="l00079"></a>00079         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](0) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[5](0) = .5;  
<a name="l00080"></a>00080         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](1) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[5](1) = .5;
<a name="l00081"></a>00081         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[0](2) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[5](2) = 0.;
<a name="l00082"></a>00082                                            
<a name="l00083"></a>00083         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](0) = 1.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[6](0) = 0.;
<a name="l00084"></a>00084         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](1) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[6](1) = .5;
<a name="l00085"></a>00085         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[1](2) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[6](2) = 0.;
<a name="l00086"></a>00086                                            
<a name="l00087"></a>00087         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](0) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[7](0) = 0.;
<a name="l00088"></a>00088         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](1) = 1.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[7](1) = 0.;
<a name="l00089"></a>00089         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[2](2) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[7](2) = .5;
<a name="l00090"></a>00090                                            
<a name="l00091"></a>00091         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](0) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[8](0) = .5;
<a name="l00092"></a>00092         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](1) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[8](1) = 0.;
<a name="l00093"></a>00093         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[3](2) = 1.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[8](2) = .5;
<a name="l00094"></a>00094                                            
<a name="l00095"></a>00095         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[4](0) = .5;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[9](0) = 0.;
<a name="l00096"></a>00096         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[4](1) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[9](1) = .5;
<a name="l00097"></a>00097         <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[4](2) = 0.;   <a class="code" href="classlibMesh_1_1QBase.php#acb43c08f37a8fea30728b95665e80d37">_points</a>[9](2) = .5;
<a name="l00098"></a>00098         
<a name="l00099"></a>00099         
<a name="l00100"></a>00100         <a class="code" href="classlibMesh_1_1QBase.php#aa77bcb5a61b21af01c0ebaca722631d1">_weights</a>[0] = .0052083333333333333333333333333333333333333333; <span class="comment">// 1./192.</span>
<a name="l00101"></a>00101         _weights[1] = _weights[0];
<a name="l00102"></a>00102         _weights[2] = _weights[0];
<a name="l00103"></a>00103         _weights[3] = _weights[0];
<a name="l00104"></a>00104 
<a name="l00105"></a>00105         _weights[4] = .0243055555555555555555555555555555555555555555; <span class="comment">// 14./576.</span>
<a name="l00106"></a>00106         _weights[5] = _weights[4];
<a name="l00107"></a>00107         _weights[6] = _weights[4];
<a name="l00108"></a>00108         _weights[7] = _weights[4];
<a name="l00109"></a>00109         _weights[8] = _weights[4];
<a name="l00110"></a>00110         _weights[9] = _weights[4];
<a name="l00111"></a>00111         
<a name="l00112"></a>00112         <span class="keywordflow">return</span>;
<a name="l00113"></a>00113       }
<a name="l00114"></a>00114       
<a name="l00115"></a>00115       
<a name="l00116"></a>00116       
<a name="l00117"></a>00117       <span class="comment">//---------------------------------------------</span>
<a name="l00118"></a>00118       <span class="comment">// Prism quadrature rules</span>
<a name="l00119"></a>00119     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457a7b2d78d7f8c67febc193df3e2be2bed0">PRISM6</a>:
<a name="l00120"></a>00120     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ad3646f147ae4ab65c5075ee5e69ea021">PRISM15</a>:
<a name="l00121"></a>00121     <span class="keywordflow">case</span> <a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457ac783e32ea168055de0ec429cb7a45755">PRISM18</a>:
<a name="l00122"></a>00122       {
<a name="l00123"></a>00123         <span class="comment">// We compute the 3D quadrature rule as a tensor</span>
<a name="l00124"></a>00124         <span class="comment">// product of the 1D quadrature rule and a 2D</span>
<a name="l00125"></a>00125         <span class="comment">// triangle quadrature rule</span>
<a name="l00126"></a>00126 
<a name="l00127"></a>00127         <a class="code" href="classlibMesh_1_1QSimpson.php">QSimpson</a> q1D(1);
<a name="l00128"></a>00128         <a class="code" href="classlibMesh_1_1QSimpson.php">QSimpson</a> q2D(2);
<a name="l00129"></a>00129 
<a name="l00130"></a>00130         <span class="comment">// Initialize </span>
<a name="l00131"></a>00131         q1D.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457adc872103dde65a2c35071420002cc756">EDGE2</a>);
<a name="l00132"></a>00132         q2D.<a class="code" href="classlibMesh_1_1QBase.php#a4aa6da5dd814db96a68b778997255051">init</a>(<a class="code" href="namespacelibMeshEnums.php#a54ee290fca7f0c26eb1e5986f5271457afaa297142f1c6f1019d90e5674708315">TRI3</a>);
<a name="l00133"></a>00133 
<a name="l00134"></a>00134         tensor_product_prism(q1D, q2D);
<a name="l00135"></a>00135 
<a name="l00136"></a>00136         <span class="keywordflow">return</span>;
<a name="l00137"></a>00137       }
<a name="l00138"></a>00138 
<a name="l00139"></a>00139       
<a name="l00140"></a>00140       <span class="comment">//---------------------------------------------</span>
<a name="l00141"></a>00141       <span class="comment">// Unsupported type</span>
<a name="l00142"></a>00142     <span class="keywordflow">default</span>:
<a name="l00143"></a>00143       {
<a name="l00144"></a>00144         <a class="code" href="namespacelibMesh.php#a74e5bc8a72d210b3d87b0221b1f69db1">libMesh::err</a> &lt;&lt; <span class="stringliteral">&quot;ERROR: Unsupported type: &quot;</span> &lt;&lt; _type &lt;&lt; std::endl;
<a name="l00145"></a>00145         libmesh_error();
<a name="l00146"></a>00146       }
<a name="l00147"></a>00147     }
<a name="l00148"></a>00148 
<a name="l00149"></a>00149   libmesh_error();
<a name="l00150"></a>00150 
<a name="l00151"></a>00151   <span class="keywordflow">return</span>;
<a name="l00152"></a>00152   
<a name="l00153"></a>00153 <span class="preprocessor">#endif</span>
<a name="l00154"></a>00154 <span class="preprocessor"></span>}
<a name="l00155"></a>00155 
<a name="l00156"></a>00156 } <span class="comment">// namespace libMesh</span>
</pre></div></div>
</div>
</div>


<?php make_footer() ?>

</body>
</html>
 
